-- MySQL dump 10.14  Distrib 5.5.62-MariaDB, for Linux ()
--
-- Host: localhost    Database: sisyphos_dist
-- ------------------------------------------------------
-- Server version	5.5.62-MariaDB

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `absence`
--

DROP TABLE IF EXISTS `absence`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `absence` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `absence_date` date NOT NULL,
  `posted_when` datetime NOT NULL,
  `post_teacher_id` int(11) NOT NULL,
  `student_id` int(11) NOT NULL,
  `card_id` int(11) NOT NULL,
  `absence_reason_id` int(11) NOT NULL,
  `comments` varchar(255) DEFAULT NULL,
  `justified` tinyint(1) NOT NULL DEFAULT '0',
  `justified_when` datetime DEFAULT NULL,
  `justified_comments` varchar(255) DEFAULT NULL,
  `counts` tinyint(1) NOT NULL DEFAULT '1',
  `justified_teacher_id` int(11) DEFAULT NULL,
  `justified_reason_id` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_absence_card1_idx` (`card_id`),
  KEY `fk_absence_student1_idx` (`student_id`),
  KEY `fk_absence_absence_reason1_idx` (`absence_reason_id`),
  KEY `fk_absence_teacher1_idx` (`justified_teacher_id`),
  KEY `fk_absence_justified_reason1_idx` (`justified_reason_id`),
  KEY `absence_date` (`absence_date`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `absence`
--

LOCK TABLES `absence` WRITE;
/*!40000 ALTER TABLE `absence` DISABLE KEYS */;
/*!40000 ALTER TABLE `absence` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `absence_reason`
--

DROP TABLE IF EXISTS `absence_reason`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `absence_reason` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL,
  `short_name` varchar(50) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `absence_reason`
--

LOCK TABLES `absence_reason` WRITE;
/*!40000 ALTER TABLE `absence_reason` DISABLE KEYS */;
INSERT INTO `absence_reason` VALUES (1,'Απουσία','Α'),(2,'Ωριαία Αποβολή','ΩΑ'),(3,'Αποβολή','ΑΠ');
/*!40000 ALTER TABLE `absence_reason` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `appointment_teacher_availability`
--

DROP TABLE IF EXISTS `appointment_teacher_availability`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `appointment_teacher_availability` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `teacher_id` int(11) NOT NULL,
  `day_id` int(11) NOT NULL,
  `start_time` time NOT NULL DEFAULT '00:00:00',
  `end_time` time NOT NULL DEFAULT '00:00:00',
  `location` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_teacher_idx` (`teacher_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `appointment_teacher_availability`
--

LOCK TABLES `appointment_teacher_availability` WRITE;
/*!40000 ALTER TABLE `appointment_teacher_availability` DISABLE KEYS */;
/*!40000 ALTER TABLE `appointment_teacher_availability` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ballot`
--

DROP TABLE IF EXISTS `ballot`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ballot` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `description` varchar(1000) DEFAULT NULL,
  `start_date` date NOT NULL,
  `start_time` time NOT NULL DEFAULT '00:00:00',
  `end_date` date NOT NULL,
  `end_time` time NOT NULL DEFAULT '00:00:00',
  `max_numb_of_choices` int(11) NOT NULL DEFAULT '1',
  `teacher_id` int(11) NOT NULL DEFAULT '26',
  `is_active` tinyint(1) NOT NULL DEFAULT '0',
  `is_anonymous` tinyint(1) NOT NULL DEFAULT '1',
  `is_shared` tinyint(1) NOT NULL DEFAULT '0',
  `display_results` tinyint(1) NOT NULL DEFAULT '0',
  `create_notification` tinyint(1) NOT NULL DEFAULT '0',
  `calendar_event_id` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_teacher_id_idx` (`teacher_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ballot`
--

LOCK TABLES `ballot` WRITE;
/*!40000 ALTER TABLE `ballot` DISABLE KEYS */;
/*!40000 ALTER TABLE `ballot` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ballot_choice`
--

DROP TABLE IF EXISTS `ballot_choice`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ballot_choice` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `ballot_id` int(11) NOT NULL,
  `name` varchar(512) NOT NULL,
  `description` text,
  `student_id` int(11) DEFAULT NULL,
  `hierarchy` int(11) DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `fk_ballot_id_idx` (`ballot_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ballot_choice`
--

LOCK TABLES `ballot_choice` WRITE;
/*!40000 ALTER TABLE `ballot_choice` DISABLE KEYS */;
/*!40000 ALTER TABLE `ballot_choice` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ballot_paper`
--

DROP TABLE IF EXISTS `ballot_paper`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ballot_paper` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `ballot_id` int(11) NOT NULL,
  `student_id` int(11) DEFAULT NULL,
  `is_parent` tinyint(1) NOT NULL DEFAULT '0',
  `added_at` datetime NOT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_ballot_id_idx` (`ballot_id`),
  KEY `fk_student_id_idx` (`student_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ballot_paper`
--

LOCK TABLES `ballot_paper` WRITE;
/*!40000 ALTER TABLE `ballot_paper` DISABLE KEYS */;
/*!40000 ALTER TABLE `ballot_paper` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ballot_vote`
--

DROP TABLE IF EXISTS `ballot_vote`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ballot_vote` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `ballot_paper_id` int(11) NOT NULL,
  `ballot_choice_id` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_ballot_paper_id_idx` (`ballot_paper_id`),
  KEY `fk_ballot_choice_id_idx` (`ballot_choice_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ballot_vote`
--

LOCK TABLES `ballot_vote` WRITE;
/*!40000 ALTER TABLE `ballot_vote` DISABLE KEYS */;
/*!40000 ALTER TABLE `ballot_vote` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ballot_voter`
--

DROP TABLE IF EXISTS `ballot_voter`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ballot_voter` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `ballot_id` int(11) NOT NULL,
  `student_id` int(11) NOT NULL,
  `voted` tinyint(1) NOT NULL DEFAULT '0',
  `voted_at` datetime DEFAULT NULL,
  `is_parent` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `fk_ballot_id_idx` (`ballot_id`),
  KEY `fk_student_id_idx` (`student_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ballot_voter`
--

LOCK TABLES `ballot_voter` WRITE;
/*!40000 ALTER TABLE `ballot_voter` DISABLE KEYS */;
/*!40000 ALTER TABLE `ballot_voter` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `calendar_event`
--

DROP TABLE IF EXISTS `calendar_event`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `calendar_event` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(100) NOT NULL,
  `description` varchar(1000) DEFAULT NULL,
  `allDay` tinyint(1) NOT NULL DEFAULT '0',
  `start_date` date NOT NULL,
  `end_date` date NOT NULL,
  `start_time` time NOT NULL DEFAULT '00:00:00',
  `end_time` time NOT NULL DEFAULT '00:00:00',
  `color` varchar(30) DEFAULT NULL,
  `backgroundColor` varchar(30) DEFAULT NULL,
  `borderColor` varchar(30) DEFAULT NULL,
  `textColor` varchar(30) DEFAULT NULL,
  `is_exam` tinyint(1) NOT NULL DEFAULT '0',
  `is_test` tinyint(1) NOT NULL DEFAULT '0',
  `is_ballot` tinyint(1) NOT NULL DEFAULT '0',
  `is_appointment` tinyint(1) NOT NULL DEFAULT '0',
  `teacher_id` int(11) NOT NULL,
  `location` varchar(255) DEFAULT NULL,
  `comments` text,
  `was_held` tinyint(1) DEFAULT NULL,
  `exam_class_id` int(11) DEFAULT NULL,
  `exam_subject_id` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_teacher_idx` (`teacher_id`),
  KEY `fk_exam_class_idx` (`exam_class_id`),
  KEY `fk_exam_subject_idx` (`exam_subject_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `calendar_event`
--

LOCK TABLES `calendar_event` WRITE;
/*!40000 ALTER TABLE `calendar_event` DISABLE KEYS */;
/*!40000 ALTER TABLE `calendar_event` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `calendar_event_access`
--

DROP TABLE IF EXISTS `calendar_event_access`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `calendar_event_access` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `calendar_event_id` int(11) NOT NULL,
  `teacher_id` int(11) DEFAULT NULL,
  `student_id` int(11) DEFAULT NULL,
  `grade_id` int(11) DEFAULT NULL,
  `class_id` int(11) DEFAULT NULL,
  `user_group_id` varchar(25) DEFAULT NULL,
  `publish_id` varchar(25) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_calendar_event_idx` (`calendar_event_id`),
  KEY `fk_teacher_idx` (`teacher_id`),
  KEY `fk_student_idx` (`student_id`),
  KEY `fk_grade_idx` (`grade_id`),
  KEY `fk_class_idx` (`class_id`),
  KEY `fk_user_group_idx` (`user_group_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `calendar_event_access`
--

LOCK TABLES `calendar_event_access` WRITE;
/*!40000 ALTER TABLE `calendar_event_access` DISABLE KEYS */;
/*!40000 ALTER TABLE `calendar_event_access` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `card`
--

DROP TABLE IF EXISTS `card`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `card` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `valid_from` date NOT NULL,
  `subject_id` int(11) NOT NULL,
  `teacher_id` int(11) NOT NULL,
  `class_id` int(11) DEFAULT NULL,
  `classroom_id` int(11) DEFAULT NULL,
  `day_id` int(11) NOT NULL,
  `period_id` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_card_subject1_idx` (`subject_id`),
  KEY `fk_card_teacher1_idx` (`teacher_id`),
  KEY `fk_card_class1_idx` (`class_id`),
  KEY `fk_card_classroom1_idx` (`classroom_id`),
  KEY `fk_card_day1_idx` (`day_id`),
  KEY `fk_card_period1_idx` (`period_id`),
  KEY `card_valid_from_idx` (`valid_from`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `card`
--

LOCK TABLES `card` WRITE;
/*!40000 ALTER TABLE `card` DISABLE KEYS */;
/*!40000 ALTER TABLE `card` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `card_in`
--

DROP TABLE IF EXISTS `card_in`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `card_in` (
  `new_id` int(11) NOT NULL AUTO_INCREMENT,
  `day` varchar(255) DEFAULT NULL,
  `period` varchar(255) DEFAULT NULL,
  `classids` varchar(255) DEFAULT NULL,
  `groupids` varchar(255) DEFAULT NULL,
  `subjectid` varchar(255) DEFAULT NULL,
  `teacherids` varchar(255) DEFAULT NULL,
  `classroomid` varchar(255) DEFAULT NULL,
  `group_new_id` int(11) DEFAULT NULL,
  `subject_new_id` int(11) DEFAULT NULL,
  `teacher_new_id` int(11) DEFAULT NULL,
  `classroom_new_id` int(11) DEFAULT NULL,
  PRIMARY KEY (`new_id`),
  KEY `fk_day` (`day`),
  KEY `fk_period` (`period`),
  KEY `fk_group` (`groupids`),
  KEY `fk_subject` (`subjectid`),
  KEY `fk_teacher` (`teacherids`),
  KEY `fk_class` (`classroomid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `card_in`
--

LOCK TABLES `card_in` WRITE;
/*!40000 ALTER TABLE `card_in` DISABLE KEYS */;
/*!40000 ALTER TABLE `card_in` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `class`
--

DROP TABLE IF EXISTS `class`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `class` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) DEFAULT NULL,
  `short_name` varchar(50) NOT NULL,
  `grade_id` int(11) DEFAULT NULL,
  `post_teacher_id` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_class_grade1_idx` (`grade_id`),
  KEY `fk_class_teacher1_idx` (`post_teacher_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `class`
--

LOCK TABLES `class` WRITE;
/*!40000 ALTER TABLE `class` DISABLE KEYS */;
/*!40000 ALTER TABLE `class` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `class_in`
--

DROP TABLE IF EXISTS `class_in`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `class_in` (
  `id` varchar(255) DEFAULT NULL,
  `name` varchar(255) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `class_in`
--

LOCK TABLES `class_in` WRITE;
/*!40000 ALTER TABLE `class_in` DISABLE KEYS */;
/*!40000 ALTER TABLE `class_in` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `classroom`
--

DROP TABLE IF EXISTS `classroom`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `classroom` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL,
  `short_name` varchar(50) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `classroom`
--

LOCK TABLES `classroom` WRITE;
/*!40000 ALTER TABLE `classroom` DISABLE KEYS */;
/*!40000 ALTER TABLE `classroom` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `classroom_in`
--

DROP TABLE IF EXISTS `classroom_in`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `classroom_in` (
  `id` varchar(255) DEFAULT NULL,
  `name` varchar(255) DEFAULT NULL,
  `short` varchar(255) DEFAULT NULL,
  `new_id` int(11) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `classroom_in`
--

LOCK TABLES `classroom_in` WRITE;
/*!40000 ALTER TABLE `classroom_in` DISABLE KEYS */;
/*!40000 ALTER TABLE `classroom_in` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `comment`
--

DROP TABLE IF EXISTS `comment`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `comment` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `student_id` int(11) NOT NULL,
  `subject_id` int(11) NOT NULL,
  `teacher_comments` text,
  `student_comments` text,
  `post_teacher_id` int(11) NOT NULL,
  `changed_at` datetime NOT NULL,
  `hide_to_student` tinyint(1) NOT NULL DEFAULT '0',
  `student_viewed_at` datetime NOT NULL,
  `parent_viewed_at` datetime NOT NULL,
  `student_comments_changed_at` datetime NOT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_mark_student1_idx` (`student_id`),
  KEY `fk_mark_subject1_idx` (`subject_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `comment`
--

LOCK TABLES `comment` WRITE;
/*!40000 ALTER TABLE `comment` DISABLE KEYS */;
/*!40000 ALTER TABLE `comment` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `critirion_general`
--

DROP TABLE IF EXISTS `critirion_general`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `critirion_general` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `description` varchar(255) NOT NULL,
  `grade_id` int(11) DEFAULT NULL,
  `speciality_id` int(11) DEFAULT NULL,
  `teacher_id` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `fk_critirion_general_speciality1_idx` (`speciality_id`),
  KEY `teacher_id` (`teacher_id`),
  KEY `grade_id` (`grade_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `critirion_general`
--

LOCK TABLES `critirion_general` WRITE;
/*!40000 ALTER TABLE `critirion_general` DISABLE KEYS */;
/*!40000 ALTER TABLE `critirion_general` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `critirion_special`
--

DROP TABLE IF EXISTS `critirion_special`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `critirion_special` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) DEFAULT NULL,
  `description` varchar(255) NOT NULL,
  `hierarchy` int(11) DEFAULT '0',
  `critirion_general_id` int(11) NOT NULL,
  `is_editable` tinyint(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`),
  KEY `fk_critirion_special_critirion_general1_idx` (`critirion_general_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `critirion_special`
--

LOCK TABLES `critirion_special` WRITE;
/*!40000 ALTER TABLE `critirion_special` DISABLE KEYS */;
/*!40000 ALTER TABLE `critirion_special` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `critirion_special_level`
--

DROP TABLE IF EXISTS `critirion_special_level`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `critirion_special_level` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) DEFAULT NULL,
  `description` text NOT NULL,
  `hierarchy` int(11) DEFAULT '0',
  `critirion_special_id` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_critirion_special_level_critirion_special1_idx` (`critirion_special_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `critirion_special_level`
--

LOCK TABLES `critirion_special_level` WRITE;
/*!40000 ALTER TABLE `critirion_special_level` DISABLE KEYS */;
/*!40000 ALTER TABLE `critirion_special_level` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `day`
--

DROP TABLE IF EXISTS `day`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `day` (
  `id` int(11) NOT NULL,
  `name` varchar(100) NOT NULL,
  `short_name` varchar(50) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `day`
--

LOCK TABLES `day` WRITE;
/*!40000 ALTER TABLE `day` DISABLE KEYS */;
INSERT INTO `day` VALUES (0,'Δευτέρα','Δευ'),(1,'Τρίτη','Τρι'),(2,'Τετάρτη','Τετ'),(3,'Πέμπτη','Πεμ'),(4,'Παρασκευή','Παρ');
/*!40000 ALTER TABLE `day` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `email`
--

DROP TABLE IF EXISTS `email`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `email` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `sender_id` int(11) NOT NULL,
  `sent_at` datetime NOT NULL,
  `email_address` varchar(255) NOT NULL,
  `email_subject` varchar(255) DEFAULT NULL,
  `email_text` text,
  `fail_code` tinyint(4) unsigned NOT NULL DEFAULT '0',
  `fail_comments` varchar(255) DEFAULT NULL,
  `student_id` int(11) DEFAULT NULL,
  `teacher_id` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_student_id1_idx` (`student_id`),
  KEY `fk_teacher_id1_idx` (`teacher_id`),
  KEY `fk_sender_id1_idx` (`sender_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `email`
--

LOCK TABLES `email` WRITE;
/*!40000 ALTER TABLE `email` DISABLE KEYS */;
/*!40000 ALTER TABLE `email` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `email_login_server`
--

DROP TABLE IF EXISTS `email_login_server`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `email_login_server` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `domain_name` varchar(100) NOT NULL,
  `server_name` varchar(100) NOT NULL,
  `port_number` int(11) NOT NULL DEFAULT '993',
  `use_ssl` tinyint(1) NOT NULL DEFAULT '1',
  `use_full_address_as_login_name` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=7 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `email_login_server`
--

LOCK TABLES `email_login_server` WRITE;
/*!40000 ALTER TABLE `email_login_server` DISABLE KEYS */;
INSERT INTO `email_login_server` VALUES (1,'gmail.com','imap.gmail.com',993,1,0),(2,'sch.gr','mail.sch.gr',993,1,0),(3,'yahoo.gr','imap.mail.yahoo.com',993,1,0),(4,'hotmail.com','imap-mail.outlook.com',993,1,1),(5,'outlook.com','imap-mail.outlook.com',993,1,1),(6,'icloud.com','imap.mail.me.com',993,1,0);
/*!40000 ALTER TABLE `email_login_server` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `foo`
--

DROP TABLE IF EXISTS `foo`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `foo` (
  `foo` int(11) NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `foo`
--

LOCK TABLES `foo` WRITE;
/*!40000 ALTER TABLE `foo` DISABLE KEYS */;
/*!40000 ALTER TABLE `foo` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `grade`
--

DROP TABLE IF EXISTS `grade`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `grade` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL,
  `short_name` varchar(50) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `grade`
--

LOCK TABLES `grade` WRITE;
/*!40000 ALTER TABLE `grade` DISABLE KEYS */;
INSERT INTO `grade` VALUES (1,'Α Τάξη','Α'),(2,'Β Τάξη','Β'),(3,'Γ Τάξη','Γ');
/*!40000 ALTER TABLE `grade` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `grading_period`
--

DROP TABLE IF EXISTS `grading_period`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `grading_period` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL,
  `short_name` varchar(50) NOT NULL,
  `start_date` date NOT NULL,
  `end_date` date NOT NULL,
  `num_of_decimals` int(11) NOT NULL DEFAULT '0',
  `marks_publication_date` date DEFAULT NULL,
  `mark_required` tinyint(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `grading_period`
--

LOCK TABLES `grading_period` WRITE;
/*!40000 ALTER TABLE `grading_period` DISABLE KEYS */;
INSERT INTO `grading_period` VALUES (1,'Α\' Τετράμηνο','Α Τετ','2021-01-11','2021-01-31',0,'2021-02-12',1),(2,'Β\' Τετράμηνο','Β Τετ','2021-05-01','2021-05-16',0,'2021-05-28',1),(3,'Γραπτά','Γραπ','2021-06-01','2021-06-30',1,'2021-07-01',1);
/*!40000 ALTER TABLE `grading_period` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `group_in`
--

DROP TABLE IF EXISTS `group_in`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `group_in` (
  `id` varchar(255) DEFAULT NULL,
  `name` varchar(255) DEFAULT NULL,
  `classid` varchar(255) DEFAULT NULL,
  `entireclass` varchar(255) DEFAULT NULL,
  `new_id` int(11) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `group_in`
--

LOCK TABLES `group_in` WRITE;
/*!40000 ALTER TABLE `group_in` DISABLE KEYS */;
/*!40000 ALTER TABLE `group_in` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `holiday`
--

DROP TABLE IF EXISTS `holiday`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `holiday` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `holiday` date NOT NULL,
  `description` varchar(255) DEFAULT NULL,
  `school_year_id` int(11) NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=64 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `holiday`
--

LOCK TABLES `holiday` WRITE;
/*!40000 ALTER TABLE `holiday` DISABLE KEYS */;
INSERT INTO `holiday` VALUES (56,'2021-04-28','Διακοπές Πάσχα',1),(55,'2021-04-29','Διακοπές Πάσχα',1),(54,'2021-04-30','Διακοπές Πάσχα',1),(53,'2021-03-15','Καθαρά Δευτέρα',1),(52,'2021-05-02','Διακοπές Πάσχα',1),(51,'2021-05-01','Πρωτομαγιά',1),(50,'2021-03-25','25 Μαρτίου (Εθνική Εορτή)',1),(48,'2021-01-07','Διακοπές Χριστουγέννων',1),(47,'2021-01-06','Διακοπές Χριστουγέννων',1),(46,'2021-01-05','Διακοπές Χριστουγέννων',1),(45,'2021-01-04','Διακοπές Χριστουγέννων',1),(33,'2020-10-28','28η Οκτωβρίου (Εθνική Εορτή)',1),(34,'2020-12-24','Διακοπές Χριστουγέννων',1),(44,'2021-01-03','Διακοπές Χριστουγέννων',1),(43,'2021-01-02','Διακοπές Χριστουγέννων',1),(35,'2020-12-25','Διακοπές Χριστουγέννων',1),(36,'2020-12-26','Διακοπές Χριστουγέννων',1),(37,'2020-12-27','Διακοπές Χριστουγέννων',1),(38,'2020-12-28','Διακοπές Χριστουγέννων',1),(39,'2020-12-29','Διακοπές Χριστουγέννων',1),(40,'2020-12-30','Διακοπές Χριστουγέννων',1),(41,'2020-12-31','Διακοπές Χριστουγέννων',1),(42,'2021-01-01','Διακοπές Χριστουγέννων',1),(57,'2021-04-27','Διακοπές Πάσχα',1),(58,'2021-04-26','Διακοπές Πάσχα',1),(59,'2021-05-03','Διακοπές Πάσχα',1),(60,'2021-05-04','Διακοπές Πάσχα',1),(61,'2021-05-05','Διακοπές Πάσχα',1),(62,'2021-05-06','Διακοπές Πάσχα',1),(63,'2021-05-07','Διακοπές Πάσχα',1);
/*!40000 ALTER TABLE `holiday` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `justification_request`
--

DROP TABLE IF EXISTS `justification_request`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `justification_request` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `absence_id` int(11) NOT NULL,
  `post_teacher_id` int(11) NOT NULL,
  `justification_request_reason_id` int(11) NOT NULL,
  `comments` varchar(255) DEFAULT NULL,
  `added_when` datetime NOT NULL,
  `proceeded` tinyint(1) NOT NULL DEFAULT '0',
  `proceeded_teacher_id` int(11) DEFAULT NULL,
  `proceeded_comments` varchar(255) DEFAULT NULL,
  `proceeded_when` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_justification_request_absence1_idx` (`absence_id`),
  KEY `fk_justification_request_teacher1_idx` (`post_teacher_id`),
  KEY `fk_justification_request_justification_request_reason1` (`justification_request_reason_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `justification_request`
--

LOCK TABLES `justification_request` WRITE;
/*!40000 ALTER TABLE `justification_request` DISABLE KEYS */;
/*!40000 ALTER TABLE `justification_request` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `justification_request_reason`
--

DROP TABLE IF EXISTS `justification_request_reason`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `justification_request_reason` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL,
  `short_name` varchar(50) NOT NULL,
  `num_of_days_limit` smallint(6) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=20 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `justification_request_reason`
--

LOCK TABLES `justification_request_reason` WRITE;
/*!40000 ALTER TABLE `justification_request_reason` DISABLE KEYS */;
INSERT INTO `justification_request_reason` VALUES (1,'Εκ Παραδρομής','Εκ Παραδρομής',NULL),(2,'Καθυστερημένη Είσοδος','Προσήλθε',NULL),(3,'Καθυστέρηση Λεωφορείου','Λεωφορείο',NULL),(4,'Πρόβες Παρέλασης','Παρέλαση',NULL),(5,'Πρόβες Γιορτής','Γιορτή',NULL),(6,'Εργασίες Συντήρησης Σχολείου','Συντήρηση',NULL),(7,'Διανομή Βιβλίων','Βιβλία',NULL),(8,'Άλλο','Άλλο',NULL),(9,'Απασχόληση στο Γραφείο Διευθυντή','Γραφείο',NULL),(10,'Πρόβα Θεατρικής Ομάδας','Θεατρική Ομάδα',NULL),(11,'Συνεδρίαση Δεκαπενταμελούς','Δεκαπενταμελές',NULL),(12,'Συμμετοχή σε επίσημες εκδηλώσεις φορέων','Επίσημη Εκδήλωση',NULL),(13,'Συμμετοχή σε Διαγώνισμα','Διαγώνισμα',NULL),(14,'Προπόνηση Σχολικής Αθλητικής Ομάδας','Προπόνηση',NULL),(15,'Συμμετοχή σε αγώνα Σχολικής Αθλητικής Ομάδας','Αθλητικός αγώνας',NULL),(16,'Έκδοση Ταυτότητας Αθλητή','Ταυτότητα Αθλητή',NULL);
/*!40000 ALTER TABLE `justification_request_reason` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `justified_reason`
--

DROP TABLE IF EXISTS `justified_reason`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `justified_reason` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL,
  `short_name` varchar(50) NOT NULL,
  `counts` tinyint(1) NOT NULL DEFAULT '1',
  `teacher_access` tinyint(1) NOT NULL DEFAULT '0',
  `myschool_code` varchar(50) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=21 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `justified_reason`
--

LOCK TABLES `justified_reason` WRITE;
/*!40000 ALTER TABLE `justified_reason` DISABLE KEYS */;
INSERT INTO `justified_reason` VALUES (3,'Διαγραφή από τον Διευθυντή','Διευθυντής ΠΔ',0,0,NULL),(7,'Κλήτευση σε Δίκη','Δικαστήριο',0,1,NULL),(17,'Συμμετοχή σε Επίσημο Αθλητικό Αγώνα','Αγώνες',0,1,NULL),(8,'Συμμετοχή σε Εκπαιδευτική Εκδρομή / Δράση του Σχολείου','Εκπ. Εκδρομή / Δράση',0,1,NULL),(9,'Συμμετοχή σε Αιμοδοσία','Αιμοδοσία',0,1,NULL),(18,'Συμμετοχή σε Επίσημο Διαγωνισμό','Επίσημος Διαγωνισμός',0,1,NULL),(10,'Συμμετοχή στη Διαδικασία Επιλογής Οπλιτών','Στρατολογία',0,1,NULL),(4,'Διαγραφή από το Σύλλογο Διδασκόντων','Σύλλογος',0,0,NULL),(5,'Σοβαρά και Επείγοντα Περιστατικά Υγείας','ΣΕΠΥ',0,1,NULL),(19,'Συμμετοχή σε Επίσημη Καλλιτεχνική Εκδήλωση','Καλλιτεχνική Εκδήλωση',0,1,NULL),(6,'Ιδιάζων Πρόβλημα Υγείας','Ιδιάζων Πρόβλημα Υγείας',0,1,NULL),(11,'Συμμετοχή σε Εξετάσεις για ΑΕΙ','Εξετάσεις ΑΕΙ',0,1,NULL),(12,'Θρησκευτική Εορτή','Θρησκευτική Εορτή',0,1,NULL),(13,'Απαλλαγή από τη Διδασκαλία του Μαθήματος','Απαλλαγή',0,1,NULL),(14,'Δυσμενείς Καιρικές Συνθήκες','Κακοκαιρία',0,1,NULL),(0,'Δεν προσμετράται','Δεν προσμετράται',0,0,NULL);
/*!40000 ALTER TABLE `justified_reason` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mark`
--

DROP TABLE IF EXISTS `mark`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `mark` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `value` decimal(4,1) DEFAULT '0.0',
  `added_when` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `grading_period_id` int(11) NOT NULL,
  `student_id` int(11) NOT NULL,
  `subject_id` int(11) NOT NULL,
  `post_teacher_id` int(11) NOT NULL,
  `class_id` int(11) NOT NULL DEFAULT '0',
  `published` tinyint(1) DEFAULT '0',
  `comments` text,
  PRIMARY KEY (`id`),
  KEY `fk_mark_grading_period1_idx` (`grading_period_id`),
  KEY `fk_mark_student1_idx` (`student_id`),
  KEY `fk_mark_subject1_idx` (`subject_id`),
  KEY `fk_mark_teacher1_idx` (`post_teacher_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mark`
--

LOCK TABLES `mark` WRITE;
/*!40000 ALTER TABLE `mark` DISABLE KEYS */;
/*!40000 ALTER TABLE `mark` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mark_critirion_special_level`
--

DROP TABLE IF EXISTS `mark_critirion_special_level`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `mark_critirion_special_level` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `mark_id` int(11) NOT NULL,
  `critirion_special_id` int(11) NOT NULL,
  `critirion_special_level_id` int(11) DEFAULT NULL,
  `custom_description` text,
  PRIMARY KEY (`id`),
  KEY `fk_mark_critirion_special_level_mark1_idx` (`mark_id`),
  KEY `fk_mark_critirion_special_level_critirion_special1_idx` (`critirion_special_id`),
  KEY `fk_mark_critirion_special_level_critirion_special_level1_idx` (`critirion_special_level_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mark_critirion_special_level`
--

LOCK TABLES `mark_critirion_special_level` WRITE;
/*!40000 ALTER TABLE `mark_critirion_special_level` DISABLE KEYS */;
/*!40000 ALTER TABLE `mark_critirion_special_level` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mark_type`
--

DROP TABLE IF EXISTS `mark_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `mark_type` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL,
  `is_number` tinyint(1) NOT NULL DEFAULT '1',
  `start_value` int(11) NOT NULL DEFAULT '0',
  `end_value` int(11) NOT NULL DEFAULT '100',
  `num_of_decimals` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=5 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mark_type`
--

LOCK TABLES `mark_type` WRITE;
/*!40000 ALTER TABLE `mark_type` DISABLE KEYS */;
INSERT INTO `mark_type` VALUES (1,'ΔΕ-Προφορικός',1,0,20,0),(2,'ΔΕ-Γραπτός',1,0,20,1),(3,'ΠΕ-Τάξεις Ε και ΣΤ',1,0,10,0),(4,'ΠΕ-Τάξεις Γ και Δ',0,0,20,0);
/*!40000 ALTER TABLE `mark_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mark_type_value`
--

DROP TABLE IF EXISTS `mark_type_value`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `mark_type_value` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `mark_type_id` int(11) NOT NULL,
  `name` varchar(50) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_mark_type_idx` (`mark_type_id`)
) ENGINE=MyISAM AUTO_INCREMENT=5 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mark_type_value`
--

LOCK TABLES `mark_type_value` WRITE;
/*!40000 ALTER TABLE `mark_type_value` DISABLE KEYS */;
INSERT INTO `mark_type_value` VALUES (1,4,'Α'),(2,4,'Β'),(3,4,'Γ'),(4,4,'Δ');
/*!40000 ALTER TABLE `mark_type_value` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `myschool_subject_name`
--

DROP TABLE IF EXISTS `myschool_subject_name`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `myschool_subject_name` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `grade_id` int(11) DEFAULT NULL,
  `name` varchar(255) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `myschool_subject_name`
--

LOCK TABLES `myschool_subject_name` WRITE;
/*!40000 ALTER TABLE `myschool_subject_name` DISABLE KEYS */;
/*!40000 ALTER TABLE `myschool_subject_name` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `notification`
--

DROP TABLE IF EXISTS `notification`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `notification` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `added_at` datetime NOT NULL,
  `type_id` int(11) DEFAULT NULL,
  `content` text,
  `student_id` int(11) DEFAULT NULL,
  `is_parent` tinyint(1) NOT NULL DEFAULT '0',
  `pending` tinyint(1) NOT NULL DEFAULT '1',
  `email_id` int(11) DEFAULT NULL,
  `associated_id` int(11) DEFAULT NULL,
  `occurred_at` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_type_id1_idx` (`type_id`),
  KEY `fk_student_id1_idx` (`student_id`),
  KEY `type_id` (`type_id`),
  KEY `student_id` (`student_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `notification`
--

LOCK TABLES `notification` WRITE;
/*!40000 ALTER TABLE `notification` DISABLE KEYS */;
/*!40000 ALTER TABLE `notification` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `notification_category`
--

DROP TABLE IF EXISTS `notification_category`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `notification_category` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL,
  `header` text NOT NULL,
  `hierarchy` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=6 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `notification_category`
--

LOCK TABLES `notification_category` WRITE;
/*!40000 ALTER TABLE `notification_category` DISABLE KEYS */;
INSERT INTO `notification_category` VALUES (1,'Απουσίες','<table style=\"width: 900px; background-color: #556677;\">\n<tbody>\n<tr style=\"height: 14.1701px;\">\n<td style=\"height: 50px; width: 100%; text-align: center;\"><span style=\"color: #ffffff;\"><strong><span style=\"font-family: verdana, geneva, sans-serif; font-size: 14pt;\">Ειδοποιήσεις Απουσιών</span></strong></span></td>\n</tr>\n</tbody>\n</table>',2),(2,'Ποινές','<table style=\"width: 900px; background-color: #994433;\">\n<tbody>\n<tr style=\"height: 14.1701px;\">\n<td style=\"height: 50px; width: 100%; text-align: center;\"><span style=\"color: #ffffff;\"><strong><span style=\"font-family: verdana, geneva, sans-serif; font-size: 14pt;\">Ειδοποιήσεις για Ποινές</span></strong></span></td>\n</tr>\n</tbody>\n</table>',1),(3,'Σχόλια Καθηγητών','<table style=\"width: 900px; background-color: #447755;\">\n<tbody>\n<tr style=\"height: 14.1701px;\">\n<td style=\"height: 50px; width: 100%; text-align: center;\"><span style=\"color: #ffffff;\"><strong><span style=\"font-family: verdana, geneva, sans-serif; font-size: 14pt;\">Ειδοποιήσεις για Σχόλια Καθηγητών</span></strong></span></td>\n</tr>\n</tbody>\n</table>',3),(4,'Ημερολόγιο Σχολείου','<table style=\"width: 900px; background-color: #e69500;\">\n<tbody>\n<tr style=\"height: 14.1701px;\">\n<td style=\"height: 50px; width: 100%; text-align: center;\"><span style=\"color: #ffffff;\"><strong><span style=\"font-family: verdana, geneva, sans-serif; font-size: 14pt;\">Ειδοποιήσεις από το Ημερολόγιο Σχολείου</span></strong></span></td>\n</tr>\n</tbody>\n</table>',4),(5,'Επιβραβεύσεις ','<table style=\"width: 900px; background-color: #449944;\">\r\n<tbody>\r\n<tr style=\"height: 14.1701px;\">\r\n<td style=\"height: 50px; width: 100%; text-align: center;\"><span style=\"color: #ffffff;\"><strong><span style=\"font-family: verdana, geneva, sans-serif; font-size: 14pt;\">Ειδοποιήσεις για Επιβραβεύσεις</span></strong></span></td>\r\n</tr>\r\n</tbody>\r\n</table>',5);
/*!40000 ALTER TABLE `notification_category` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `notification_key`
--

DROP TABLE IF EXISTS `notification_key`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `notification_key` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL,
  `description` varchar(255) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=35 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `notification_key`
--

LOCK TABLES `notification_key` WRITE;
/*!40000 ALTER TABLE `notification_key` DISABLE KEYS */;
INSERT INTO `notification_key` VALUES (1,'-date-','Ημερομηνία'),(2,'-period-','Διδακτική Ώρα'),(3,'-subject-','Μάθημα'),(4,'-reason-','Λόγος Απουσίας'),(5,'-teacher-','Διδάσκων Καθηγητής'),(6,'-jreason-','Λόγος Δικαιολόγησης Απουσίας'),(7,'-counts-','Μετράει'),(8,'-dreason-','Λόγος Διαγραφής Απουσίας'),(9,'-reqteacher-','Καθηγητής που Έκανε την Αίτηση'),(10,'-type-','Τύπος Ποινής'),(11,'-carrier-','Φορέας Επιβολής'),(12,'-cause-','Αιτία Ποινής'),(13,'-teacher-','Καθηγητής Επέβαλε την Ποινή'),(14,'-datetime-','Ημερομηνία και Ώρα'),(15,'-postteacher-','Καθηγητής που Έκανε την Ενημέρωση'),(16,'-comments-','Σχόλια'),(17,'-absences-','Συνολικός Αριθμός Απουσιών'),(18,'-title-','Τίτλος Συμβάντος'),(19,'-from-','Χρονική Στιγμή που Ξεκινά το Συμβάν Ημερολογίου'),(20,'-to-','Χρονική Στιγμή που Τελειώνει το Συμβάν Ημερολογίου'),(21,'-allday-','Εάν το Συμβάν Ημερολογίου Είναι Ολοήμερο (ΝΑΙ/ΌΧΙ)'),(22,'-location-','Τοποθεσία που θα Πραγματοποιηθεί το Συμβάν Ημερολογίου'),(23,'-description-','Περιγραφή του Συμβάντος Ημερολογίου'),(24,'-teacher-','Καθηγητής που Δημιούργησε το Συμβάν Ημερολογίου'),(25,'-postteacher-','Καθηγητής που Τροποποίησε ή Κοινοποίησε το Συμβάν Ημερολογίου'),(26,'-newtitle-','Ο Τίτλος Μετά την Αλλαγή Ενός Συμβάντος '),(28,'-newlocation-','Η Τοποθεσία Μετά την Αλλαγή Ενός Συμβάντος'),(29,'-newfrom-','Η Χρονική Στιγμή Έναρξης Μετά την Αλλαγή Ενός Συμβάντος'),(30,'-newto-','Η Λήξη Μετά την Αλλαγή Ενός Συμβάντος'),(31,'-newallday-','Εάν Είναι Ολοήμερο Ένα Συμβάν Μετά την Αλλαγή'),(32,'-teacher-','Καθηγητής που απένειμε την επιβράβευση'),(33,'-medals-','Αριθμός μεταλλίων'),(34,'-type-','Τύπος Επιβράβευσης');
/*!40000 ALTER TABLE `notification_key` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `notification_type`
--

DROP TABLE IF EXISTS `notification_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `notification_type` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL,
  `header` text,
  `content` text NOT NULL,
  `active` tinyint(1) NOT NULL DEFAULT '1',
  `selectable` tinyint(1) NOT NULL DEFAULT '1',
  `hierarchy` int(11) NOT NULL DEFAULT '0',
  `category_id` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=11 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `notification_type`
--

LOCK TABLES `notification_type` WRITE;
/*!40000 ALTER TABLE `notification_type` DISABLE KEYS */;
INSERT INTO `notification_type` VALUES (1,'Καταχώριση Απουσίας','<table style=\"background-color: #778899; width: 900px;\">\n<tbody>\n<tr style=\"height: 32px;\">\n<td style=\"width: 100%; height: 30px; text-align: center;\" colspan=\"5\"><span style=\"font-family: verdana, geneva, sans-serif; font-size: 12pt; color: #ffffff;\"><strong>Νέες Απουσίες</strong></span></td>\n</tr>\n<tr style=\"height: 26.8317px;\">\n<td style=\"width: 150px; height: 26.8317px; text-align: center;\"><span style=\"color: #ffffff;\"><strong><span style=\"font-family: verdana, geneva, sans-serif; font-size: 10pt;\">Ημερομηνία</span></strong></span></td>\n<td style=\"width: 100px; height: 26.8317px; text-align: center;\"><span style=\"color: #ffffff;\"><strong><span style=\"font-family: verdana, geneva, sans-serif; font-size: 10pt;\">Ώρα</span></strong></span></td>\n<td style=\"width: 275px; height: 26.8317px;\"><span style=\"color: #ffffff;\"><strong><span style=\"font-family: verdana, geneva, sans-serif; font-size: 10pt;\">Μάθημα</span></strong></span></td>\n<td style=\"width: 275px; height: 26.8317px;\"><span style=\"color: #ffffff;\"><strong><span style=\"font-family: verdana, geneva, sans-serif; font-size: 10pt;\">Καθηγητής</span></strong></span></td>\n<td style=\"width: 100px; height: 26.8317px; text-align: center;\"><span style=\"color: #ffffff;\"><strong><span style=\"font-family: verdana, geneva, sans-serif; font-size: 10pt;\">Λόγος Απουσίας</span></strong></span></td>\n</tr>\n</tbody>\n</table>','<table style=\"width: 900px; height: 30px; border: 1px; border-style: none none dotted none;\">\n<tbody>\n<tr style=\"height: 13px;\">\n<td style=\"width: 150px; height: 13px; text-align: center;\"><span style=\"font-family: verdana, geneva, sans-serif; font-size: 8pt;\">-date-</span></td>\n<td style=\"width: 100px; height: 13px; text-align: center;\"><span style=\"font-family: verdana, geneva, sans-serif; font-size: 8pt;\">-period-</span></td>\n<td style=\"width: 275px; height: 13px;\"><span style=\"font-family: verdana, geneva, sans-serif; font-size: 8pt;\">-subject-</span></td>\n<td style=\"width: 275px; height: 13px;\"><span style=\"font-family: verdana, geneva, sans-serif; font-size: 8pt;\">-teacher-</span></td>\n<td style=\"width: 100px; height: 13px; text-align: center;\"><span style=\"font-family: verdana, geneva, sans-serif; font-size: 8pt;\">-reason-</span></td>\n</tr>\n</tbody>\n</table>',1,1,1,1),(2,'Δικαιολόγηση Απουσίας','<table style=\"background-color: #778899; width: 898px;\">\n<tbody>\n<tr style=\"height: 30.0049px;\">\n<td style=\"width: 925px; height: 30.0049px; text-align: center;\" colspan=\"6\"><span style=\"font-family: verdana, geneva, sans-serif; font-size: 12pt; color: #ffffff;\"><strong>Δικαιολόγηση ή Διαγραφή Απουσιών</strong></span></td>\n</tr>\n<tr style=\"height: 26px;\">\n<td style=\"width: 120px; height: 26px; text-align: center;\"><span style=\"color: #ffffff;\"><strong><span style=\"font-family: verdana, geneva, sans-serif; font-size: 10pt;\">Ημερομηνία</span></strong></span></td>\n<td style=\"width: 80px; height: 26px; text-align: center;\"><span style=\"color: #ffffff;\"><strong><span style=\"font-family: verdana, geneva, sans-serif; font-size: 10pt;\">Ώρα</span></strong></span></td>\n<td style=\"width: 275px; height: 26px;\"><span style=\"color: #ffffff;\"><strong><span style=\"font-family: verdana, geneva, sans-serif; font-size: 10pt;\">Μάθημα</span></strong></span></td>\n<td style=\"width: 150px; height: 26px; text-align: center;\"><span style=\"color: #ffffff;\"><strong><span style=\"font-family: verdana, geneva, sans-serif; font-size: 10pt;\">Λόγος Απουσίας</span></strong></span></td>\n<td style=\"width: 150px; height: 26px; text-align: center;\"><span style=\"color: #ffffff;\"><strong><span style=\"font-family: verdana, geneva, sans-serif; font-size: 10pt;\">Λόγος Δικαιολόγησης</span></strong></span></td>\n<td style=\"width: 150px; height: 26px; text-align: center;\"><span style=\"color: #ffffff;\"><strong><span style=\"font-family: verdana, geneva, sans-serif; font-size: 10pt;\">Μετράει στις Δικαιολογημένες</span></strong></span></td>\n</tr>\n</tbody>\n</table>','<table style=\"width: 900px; border-width: 1px; border-image: initial; border-style: none none dotted; border-color: #b04b00;\">\n<tbody>\n<tr style=\"height: 26px;\">\n<td style=\"width: 120px; height: 26px; text-align: center;\"><span style=\"font-family: verdana, geneva, sans-serif; font-size: 8pt;\">-date-</span></td>\n<td style=\"width: 80px; height: 26px; text-align: center;\"><span style=\"font-family: verdana, geneva, sans-serif; font-size: 8pt;\">-period-</span></td>\n<td style=\"width: 250px; height: 26px;\"><span style=\"font-family: verdana, geneva, sans-serif;\"><span style=\"font-size: 10.6667px;\">-subject-</span></span></td>\n<td style=\"width: 150px; height: 26px; text-align: center;\"><span style=\"font-family: verdana, geneva, sans-serif;\"><span style=\"font-size: 10.6667px;\">-reason-</span></span></td>\n<td style=\"width: 150px; height: 26px; text-align: center;\"><span style=\"font-family: verdana, geneva, sans-serif;\"><span style=\"font-size: 10.6667px;\">-jreason-</span></span></td>\n<td style=\"width: 150px; height: 26px; text-align: center;\"><span style=\"font-family: verdana, geneva, sans-serif;\"><span style=\"font-size: 10.6667px;\">-counts-</span></span></td>\n</tr>\n</tbody>\n</table>',1,1,3,1),(3,'Διαγραφή Απουσίας','<table style=\"background-color: #778899; width: 900px;\">\n<tbody>\n<tr style=\"height: 30.0049px;\">\n<td style=\"width: 100%; height: 30.0049px; text-align: center;\" colspan=\"6\"><span style=\"font-family: verdana, geneva, sans-serif; font-size: 12pt; color: #ffffff;\"><strong>Διαγραφή Απουσιών από το Διευθυντή</strong></span></td>\n</tr>\n<tr style=\"height: 26px;\">\n<td style=\"width: 120px; height: 26px; text-align: center;\"><span style=\"color: #ffffff;\"><strong><span style=\"font-family: verdana, geneva, sans-serif; font-size: 10pt;\">Ημερομηνία</span></strong></span></td>\n<td style=\"width: 80px; height: 26px; text-align: center;\"><span style=\"color: #ffffff;\"><strong><span style=\"font-family: verdana, geneva, sans-serif; font-size: 10pt;\">Ώρα</span></strong></span></td>\n<td style=\"width: 275px; height: 26px;\"><span style=\"color: #ffffff;\"><strong><span style=\"font-family: verdana, geneva, sans-serif; font-size: 10pt;\">Μάθημα</span></strong></span></td>\n<td style=\"width: 150px; height: 26px; text-align: center;\"><span style=\"color: #ffffff;\"><strong><span style=\"font-family: verdana, geneva, sans-serif; font-size: 10pt;\">Λόγος Απουσίας</span></strong></span></td>\n<td style=\"width: 150px; height: 26px; text-align: center;\"><span style=\"color: #ffffff;\"><strong><span style=\"font-family: verdana, geneva, sans-serif; font-size: 10pt;\">Λόγος Διαγραφής</span></strong></span></td>\n<td style=\"width: 150px; height: 26px; text-align: center;\"><span style=\"color: #ffffff; font-family: verdana, geneva, sans-serif;\"><span style=\"font-size: 13.3333px;\"><strong>Καθηγητής που Αιτήθηκε</strong></span></span></td>\n</tr>\n</tbody>\n</table>','<table style=\"width: 900px; border-width: 1px; border-image: initial; border-style: none none dotted; border-color: #b04b00;\">\n<tbody>\n<tr style=\"height: 26px;\">\n<td style=\"width: 120px; height: 26px; text-align: center;\"><span style=\"font-family: verdana, geneva, sans-serif; font-size: 8pt;\">-date-</span></td>\n<td style=\"width: 80px; height: 26px; text-align: center;\"><span style=\"font-family: verdana, geneva, sans-serif; font-size: 8pt;\">-period-</span></td>\n<td style=\"width: 250px; height: 26px;\"><span style=\"font-size: 8pt; font-family: verdana, geneva, sans-serif;\">-subject-</span></td>\n<td style=\"width: 150px; height: 26px; text-align: center;\"><span style=\"font-size: 8pt; font-family: verdana, geneva, sans-serif;\">-reason-</span></td>\n<td style=\"width: 150px; height: 26px; text-align: center;\"><span style=\"font-size: 8pt; font-family: verdana, geneva, sans-serif;\">-dreason-</span></td>\n<td style=\"width: 150px; height: 26px; text-align: center;\"><span style=\"font-size: 8pt; font-family: verdana, geneva, sans-serif;\">-reqteacher-</span></td>\n</tr>\n</tbody>\n</table>',1,1,4,1),(4,'Καταχώριση Ποινής','<table style=\"background-color: #aa5544; width: 900px;\">\n<tbody>\n<tr style=\"height: 32px;\">\n<td style=\"width: 100%; height: 30px; text-align: center;\" colspan=\"5\"><span style=\"font-family: verdana, geneva, sans-serif; font-size: 12pt; color: #ffffff;\"><strong>Νέες Ποινές</strong></span></td>\n</tr>\n<tr style=\"height: 26.8317px;\">\n<td style=\"width: 120px; height: 26.8317px; text-align: center;\"><span style=\"color: #ffffff;\"><strong><span style=\"font-family: verdana, geneva, sans-serif; font-size: 10pt;\">Ημερομηνία</span></strong></span></td>\n<td style=\"width: 80px; height: 26.8317px; text-align: center;\"><span style=\"color: #ffffff;\"><strong><span style=\"font-family: verdana, geneva, sans-serif; font-size: 10pt;\">Ώρα</span></strong></span></td>\n<td style=\"width: 175px; height: 26.8317px; text-align: center;\"><span style=\"color: #ffffff; font-family: verdana, geneva, sans-serif;\"><span style=\"font-size: 13.3333px;\"><strong>Τύπος Ποινής</strong></span></span></td>\n<td style=\"width: 325px; height: 26.8317px;\"><span style=\"color: #ffffff; font-family: verdana, geneva, sans-serif;\"><span style=\"font-size: 13.3333px;\"><strong>Αιτία Ποινής</strong></span></span></td>\n<td style=\"width: 200px; height: 26.8317px; text-align: center;\"><span style=\"color: #ffffff;\"><strong><span style=\"font-family: verdana, geneva, sans-serif; font-size: 10pt;\">Φορέας Επιβολής</span></strong></span></td>\n</tr>\n</tbody>\n</table>','<table style=\"width: 900px; height: 30px; border: 1px; border-style: none none dotted none;\">\n<tbody>\n<tr style=\"height: 13px;\">\n<td style=\"width: 120px; height: 13px; text-align: center;\"><span style=\"font-family: verdana, geneva, sans-serif; font-size: 8pt;\">-date-</span></td>\n<td style=\"width: 80px; height: 13px; text-align: center;\"><span style=\"font-family: verdana, geneva, sans-serif; font-size: 8pt;\">-period-</span></td>\n<td style=\"width: 175px; height: 13px; text-align: center;\"><span style=\"font-family: verdana, geneva, sans-serif; font-size: 8pt;\">-type-</span></td>\n<td style=\"width: 325px; height: 13px;\"><span style=\"font-family: verdana, geneva, sans-serif; font-size: 8pt;\">-cause-</span></td>\n<td style=\"width: 200px; height: 13px; text-align: center;\"><span style=\"font-family: verdana, geneva, sans-serif; font-size: 8pt;\">-carrier-</span></td>\n</tr>\n</tbody>\n</table>',1,0,1,2),(5,'Ενημέρωση Σχόλιου Καθηγητή','<table style=\"background-color: #669955; width: 900px;\">\n<tbody>\n<tr style=\"height: 32px;\">\n<td style=\"width: 100%; height: 30px; text-align: center;\" colspan=\"4\"><span style=\"font-family: verdana, geneva, sans-serif; font-size: 12pt; color: #ffffff;\"><strong>Ενημερώσεις στα Σχόλια των Καθηγητών</strong></span></td>\n</tr>\n<tr style=\"height: 26.8317px;\">\n<td style=\"width: 250px; height: 26.8317px; text-align: center;\"><span style=\"color: #ffffff; font-family: verdana, geneva, sans-serif;\"><span style=\"font-size: 13.3333px;\"><strong>Μάθημα</strong></span></span></td>\n<td style=\"width: 250px; height: 26.8317px; text-align: center;\"><span style=\"color: #ffffff; font-family: verdana, geneva, sans-serif;\"><span style=\"font-size: 13.3333px;\"><strong>Καθηγητής</strong></span></span></td>\n<td style=\"width: 350px; height: 26.8317px;\"><span style=\"color: #ffffff; font-family: verdana, geneva, sans-serif;\"><span style=\"font-size: 13.3333px;\"><strong>Σχόλια</strong></span></span></td>\n<td style=\"width: 150px; height: 26.8317px; text-align: center;\"><span style=\"color: #ffffff;\"><strong><span style=\"font-family: verdana, geneva, sans-serif; font-size: 10pt;\">Τροποποιήθηκε στις</span></strong></span></td>\n</tr>\n</tbody>\n</table>','<table style=\"width: 900px; height: 30px; border: 1px; border-style: none none dotted none;\">\n<tbody>\n<tr style=\"height: 13px;\">\n<td style=\"width: 200px; height: 13px; text-align: left;\"><span style=\"font-family: verdana, geneva, sans-serif; font-size: 8pt;\">-subject-</span></td>\n<td style=\"width: 200px; height: 13px; text-align: left;\"><span style=\"font-family: verdana, geneva, sans-serif; font-size: 8pt;\">-postteacher-</span></td>\n<td style=\"width: 350px; height: 13px;\"><span style=\"font-family: verdana, geneva, sans-serif; font-size: 8pt;\">-comments-</span></td>\n<td style=\"width: 150px; height: 13px; text-align: center;\"><span style=\"font-family: verdana, geneva, sans-serif; font-size: 8pt;\">-datetime-</span></td>\n</tr>\n</tbody>\n</table>',1,1,1,3),(6,'Καταχώριση Συνόλου Απουσιών Ημέρας','<table style=\"background-color: #778899; width: 900px;\">\n<tbody>\n<tr style=\"height: 32px;\">\n<td style=\"width: 100%; height: 30px; text-align: center;\" colspan=\"5\"><span style=\"font-family: verdana, geneva, sans-serif; font-size: 12pt; color: #ffffff;\"><strong>Νέες Απουσίες για Όλη την Ημέρα</strong></span></td>\n</tr>\n<tr style=\"height: 26.8317px;\">\n<td style=\"width: 150px; height: 26.8317px; text-align: center;\"><span style=\"color: #ffffff;\"><strong><span style=\"font-family: verdana, geneva, sans-serif; font-size: 10pt;\">Ημερομηνία</span></strong></span></td>\n<td style=\"width: 250px; height: 26.8317px; text-align: center;\"><span style=\"color: #ffffff;\"><strong><span style=\"font-family: verdana, geneva, sans-serif; font-size: 10pt;\">Συνολικός Αριθμός Απουσιών</span></strong></span></td>\n<td style=\"width: 250px; height: 26.8317px; text-align: center;\"><span style=\"color: #ffffff; font-family: verdana, geneva, sans-serif;\"><span style=\"font-size: 13.3333px;\"><strong>Διδακτικές Ώρες</strong></span></span></td>\n<td style=\"width: 250px; height: 26.8317px; text-align: center;\" colspan=\"2\"><span style=\"color: #ffffff;\"><strong><span style=\"font-family: verdana, geneva, sans-serif; font-size: 10pt;\">Λόγος Απουσίας</span></strong></span></td>\n</tr>\n</tbody>\n</table>','<table style=\"width: 900px; height: 30px; border: 1px; border-style: none none dotted none;\">\n<tbody>\n<tr style=\"height: 13px;\">\n<td style=\"width: 150px; height: 13px; text-align: center;\"><span style=\"font-family: verdana, geneva, sans-serif; font-size: 8pt;\">-date-</span></td>\n<td style=\"width: 250px; height: 13px; text-align: center;\"><span style=\"font-family: verdana, geneva, sans-serif; font-size: 8pt;\">-absences-</span></td>\n<td style=\"width: 250px; height: 13px; text-align: center;\"><span style=\"font-family: verdana, geneva, sans-serif; font-size: 8pt;\">-period-</span></td>\n<td style=\"width: 250px; height: 13px; text-align: center;\" colspan=\"2\"><span style=\"font-family: verdana, geneva, sans-serif; font-size: 8pt;\">-reason-</span></td>\n</tr>\n</tbody>\n</table>',1,1,2,1),(7,'Νέο Συμβάν Ημερολογίου','<table style=\"background-color: #ffa600; width: 900px;\">\n<tbody>\n<tr style=\"height: 32px;\">\n<td style=\"width: 100%; height: 30px; text-align: center;\" colspan=\"5\"><span style=\"font-family: verdana, geneva, sans-serif; font-size: 12pt; color: #ffffff;\"><strong>Νέα Συμβάντα στο Ημερολόγιο Σχολείου</strong></span></td>\n</tr>\n<tr style=\"height: 26.8317px;\">\n<td style=\"width: 350px; height: 26.8317px; text-align: center;\"><span style=\"color: #ffffff; font-family: verdana, geneva, sans-serif;\"><span style=\"font-size: 13.3333px;\"><strong>Τίτλος</strong></span></span></td>\n<td style=\"width: 150px; height: 26.8317px; text-align: center;\"><span style=\"color: #ffffff; font-family: verdana, geneva, sans-serif;\"><span style=\"font-size: 13.3333px;\"><strong>Από</strong></span></span></td>\n<td style=\"width: 150px; height: 26.8317px;\"><span style=\"color: #ffffff; font-family: verdana, geneva, sans-serif;\"><span style=\"font-size: 13.3333px;\"><strong>Έως</strong></span></span></td>\n<td style=\"width: 100px; height: 26.8317px; text-align: center;\"><span style=\"color: #ffffff; font-family: verdana, geneva, sans-serif;\"><span style=\"font-size: 13.3333px;\"><strong>Ολοήμερο</strong></span></span></td>\n<td style=\"width: 250px; height: 26.8317px; text-align: center;\"><span style=\"color: #ffffff; font-family: verdana, geneva, sans-serif;\"><span style=\"font-size: 13.3333px;\"><strong>Τοποθεσία</strong></span></span></td>\n</tr>\n</tbody>\n</table>','<table style=\"width: 900px; height: 30px; border: 1px; border-style: none none dotted none;\">\n<tbody>\n<tr style=\"height: 13px;\">\n<td style=\"width: 350px; height: 13px; text-align: left;\"><span style=\"font-family: verdana, geneva, sans-serif; font-size: 8pt;\">-title-</span></td>\n<td style=\"width: 150px; height: 13px; text-align: left;\"><span style=\"font-family: verdana, geneva, sans-serif; font-size: 8pt;\">-from-</span></td>\n<td style=\"width: 150px; height: 13px;\"><span style=\"font-family: verdana, geneva, sans-serif; font-size: 8pt;\">-to-</span></td>\n<td style=\"width: 100px; height: 13px; text-align: center;\"><span style=\"font-family: verdana, geneva, sans-serif; font-size: 8pt;\">-allday-</span></td>\n<td style=\"width: 250px; height: 13px; text-align: center;\"><span style=\"font-family: verdana, geneva, sans-serif; font-size: 8pt;\">-location-</span></td>\n</tr>\n</tbody>\n</table>',1,1,1,4),(8,'Τροποποίηση Συμβάντος Ημερολογίου','<table style=\"background-color: #ffa600; width: 898px;\">\n<tbody>\n<tr style=\"height: 32px;\">\n<td style=\"width: 1000px; height: 30px; text-align: center;\" colspan=\"5\"><span style=\"font-family: verdana, geneva, sans-serif; font-size: 12pt; color: #ffffff;\"><strong>Συμβάντα που Τροποποιήθηκαν</strong></span></td>\n</tr>\n<tr style=\"height: 26.8317px;\">\n<td style=\"width: 350px; height: 26.8317px; text-align: center;\"><span style=\"color: #ffffff; font-family: verdana, geneva, sans-serif;\"><span style=\"font-size: 13.3333px;\"><strong>Τίτλος</strong></span></span></td>\n<td style=\"width: 150.8px; height: 26.8317px; text-align: center;\"><span style=\"color: #ffffff; font-family: verdana, geneva, sans-serif;\"><span style=\"font-size: 13.3333px;\"><strong>Από</strong></span></span></td>\n<td style=\"width: 149.2px; height: 26.8317px;\"><span style=\"color: #ffffff; font-family: verdana, geneva, sans-serif;\"><span style=\"font-size: 13.3333px;\"><strong>Έως</strong></span></span></td>\n<td style=\"width: 100px; height: 26.8317px; text-align: center;\"><span style=\"color: #ffffff; font-family: verdana, geneva, sans-serif;\"><span style=\"font-size: 13.3333px;\"><strong>Ολοήμερο</strong></span></span></td>\n<td style=\"width: 250px; height: 26.8317px; text-align: center;\"><span style=\"color: #ffffff; font-family: verdana, geneva, sans-serif;\"><span style=\"font-size: 13.3333px;\"><strong>Τοποθεσία</strong></span></span></td>\n</tr>\n</tbody>\n</table>','<table style=\"width: 900px; height: 30px; border: 1px; border-style: none none dotted none;\">\n<tbody>\n<tr style=\"height: 13px;\">\n<td style=\"width: 350px; height: 13px; text-align: left;\"><span style=\"font-family: verdana, geneva, sans-serif; font-size: 8pt; color: #999999;\">-title-</span></td>\n<td style=\"width: 150px; height: 13px; text-align: left;\"><span style=\"font-family: verdana, geneva, sans-serif; font-size: 8pt; color: #999999;\">-from-</span></td>\n<td style=\"width: 150px; height: 13px;\"><span style=\"font-family: verdana, geneva, sans-serif; font-size: 8pt; color: #999999;\">-to-</span></td>\n<td style=\"width: 100px; height: 13px; text-align: center;\"><span style=\"font-family: verdana, geneva, sans-serif; font-size: 8pt; color: #999999;\">-allday-</span></td>\n<td style=\"width: 250px; height: 13px; text-align: center;\"><span style=\"font-family: verdana, geneva, sans-serif; font-size: 8pt; color: #999999;\">-location-</span></td>\n</tr>\n<tr style=\"height: 13px;\">\n<td style=\"width: 350px; height: 13px; text-align: left;\"><span style=\"font-family: verdana, geneva, sans-serif; font-size: 8pt;\">-newtitle-</span></td>\n<td style=\"width: 150px; height: 13px; text-align: left;\"><span style=\"font-family: verdana, geneva, sans-serif; font-size: 8pt;\">-newfrom-</span></td>\n<td style=\"width: 150px; height: 13px;\"><span style=\"font-family: verdana, geneva, sans-serif; font-size: 8pt;\">-newto-</span></td>\n<td style=\"width: 100px; height: 13px; text-align: center;\"><span style=\"font-family: verdana, geneva, sans-serif; font-size: 8pt;\">-newallday-</span></td>\n<td style=\"width: 250px; height: 13px; text-align: center;\"><span style=\"font-family: verdana, geneva, sans-serif; font-size: 8pt;\">-newlocation-</span></td>\n</tr>\n</tbody>\n</table>',1,1,2,4),(9,'Διαγραφή Συμβάντος Ημερολογίου','<table style=\"background-color: #ffa600; width: 900px;\">\n<tbody>\n<tr style=\"height: 32px;\">\n<td style=\"width: 100%; height: 30px; text-align: center;\" colspan=\"5\"><span style=\"font-family: verdana, geneva, sans-serif; font-size: 12pt; color: #ffffff;\"><strong><span style=\"color: #ffffff; font-family: verdana, geneva, sans-serif;\"><span style=\"font-size: 12pt;\">Συμβάντα που </span><span style=\"font-size: 16px;\">Διεγράφησαν</span></span></strong></span></td>\n</tr>\n<tr style=\"height: 26.8317px;\">\n<td style=\"width: 350px; height: 26.8317px; text-align: center;\"><span style=\"color: #ffffff; font-family: verdana, geneva, sans-serif;\"><span style=\"font-size: 13.3333px;\"><strong>Τίτλος</strong></span></span></td>\n<td style=\"width: 150px; height: 26.8317px; text-align: center;\"><span style=\"color: #ffffff; font-family: verdana, geneva, sans-serif;\"><span style=\"font-size: 13.3333px;\"><strong>Από</strong></span></span></td>\n<td style=\"width: 150px; height: 26.8317px;\"><span style=\"color: #ffffff; font-family: verdana, geneva, sans-serif;\"><span style=\"font-size: 13.3333px;\"><strong>Έως</strong></span></span></td>\n<td style=\"width: 100px; height: 26.8317px; text-align: center;\"><span style=\"color: #ffffff; font-family: verdana, geneva, sans-serif;\"><span style=\"font-size: 13.3333px;\"><strong>Ολοήμερο</strong></span></span></td>\n<td style=\"width: 250px; height: 26.8317px; text-align: center;\"><span style=\"color: #ffffff; font-family: verdana, geneva, sans-serif;\"><span style=\"font-size: 13.3333px;\"><strong>Τοποθεσία</strong></span></span></td>\n</tr>\n</tbody>\n</table>','<table style=\"width: 900px; height: 30px; border: 1px; border-style: none none dotted none;\">\n<tbody>\n<tr style=\"height: 13px;\">\n<td style=\"width: 350px; height: 13px; text-align: left;\"><span style=\"font-family: verdana, geneva, sans-serif; font-size: 8pt;\">-title-</span></td>\n<td style=\"width: 150px; height: 13px; text-align: left;\"><span style=\"font-family: verdana, geneva, sans-serif; font-size: 8pt;\">-from-</span></td>\n<td style=\"width: 150px; height: 13px;\"><span style=\"font-family: verdana, geneva, sans-serif; font-size: 8pt;\">-to-</span></td>\n<td style=\"width: 100px; height: 13px; text-align: center;\"><span style=\"font-family: verdana, geneva, sans-serif; font-size: 8pt;\">-allday-</span></td>\n<td style=\"width: 250px; height: 13px; text-align: center;\"><span style=\"font-family: verdana, geneva, sans-serif; font-size: 8pt;\">-location-</span></td>\n</tr>\n</tbody>\n</table>',1,1,3,4),(10,'Απονομή Επιβράβευσης','<table style=\"background-color: #55aa55; width: 900px;\">\n<tbody>\n<tr style=\"height: 32px;\">\n<td style=\"width: 890px; height: 30px; text-align: center;\" colspan=\"5\"><span style=\"font-family: verdana, geneva, sans-serif; font-size: 12pt; color: #ffffff;\"><strong>Νέες Επιβραβεύσεις<br /></strong></span></td>\n</tr>\n<tr style=\"height: 26.8317px;\">\n<td style=\"width: 110px; height: 26.8317px; text-align: center;\"><span style=\"color: #ffffff;\"><strong><span style=\"font-family: verdana, geneva, sans-serif; font-size: 10pt;\">Ημερομηνία</span></strong></span></td>\n<td style=\"width: 80px; height: 26.8317px; text-align: center;\"><span style=\"color: #ffffff;\"><strong><span style=\"font-family: verdana, geneva, sans-serif; font-size: 10pt;\">Ώρα</span></strong></span></td>\n<td style=\"width: 420px; height: 26.8317px; text-align: left;\"><span style=\"color: #ffffff; font-family: verdana, geneva, sans-serif;\"><span style=\"font-size: 13.3333px;\"><strong>Τύπος <br /></strong></span></span></td>\n<td style=\"width: 80px; height: 26.8317px;\"><span style=\"color: #ffffff; font-family: verdana, geneva, sans-serif;\"><span style=\"font-size: 13.3333px;\"><strong>Μετάλλια<br /></strong></span></span></td>\n<td style=\"width: 200px; height: 26.8317px; text-align: center;\"><span style=\"color: #ffffff;\"><strong><span style=\"font-family: verdana, geneva, sans-serif; font-size: 10pt;\">Καθηγητής<br /></span></strong></span></td>\n</tr>\n</tbody>\n</table>\n<p> </p>','<table style=\"width: 900px; height: 30px; border: 1px; border-style: none none dotted none;\">\n<tbody>\n<tr style=\"height: 13px;\">\n<td style=\"width: 110px; height: 13px; text-align: center;\"><span style=\"font-family: verdana, geneva, sans-serif; font-size: 8pt;\">-date-</span></td>\n<td style=\"width: 80px; height: 13px; text-align: center;\"><span style=\"font-family: verdana, geneva, sans-serif; font-size: 8pt;\">-period-</span></td>\n<td style=\"width: 420px; height: 13px; text-align: left;\"><span style=\"font-family: verdana, geneva, sans-serif; font-size: 8pt;\">-type-</span></td>\n<td style=\"width: 80px; height: 13px; text-align: center;\"><span style=\"font-family: verdana, geneva, sans-serif; font-size: 8pt;\">-medals-</span></td>\n<td style=\"width: 200px; height: 13px; text-align: center;\"><span style=\"font-family: verdana, geneva, sans-serif; font-size: 8pt;\">-teacher-</span></td>\n</tr>\n</tbody>\n</table>\n<p> </p>',1,1,1,5);
/*!40000 ALTER TABLE `notification_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `notification_type_key`
--

DROP TABLE IF EXISTS `notification_type_key`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `notification_type_key` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `type_id` int(11) NOT NULL,
  `key_id` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=70 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `notification_type_key`
--

LOCK TABLES `notification_type_key` WRITE;
/*!40000 ALTER TABLE `notification_type_key` DISABLE KEYS */;
INSERT INTO `notification_type_key` VALUES (1,1,1),(2,1,2),(3,1,3),(4,1,4),(5,2,1),(6,1,5),(7,2,2),(8,2,4),(9,2,3),(10,2,5),(11,2,6),(12,2,7),(13,3,1),(14,3,2),(15,3,4),(16,3,3),(17,3,8),(18,3,9),(19,4,1),(20,4,2),(21,4,10),(22,4,11),(23,4,12),(24,4,13),(25,5,3),(27,5,14),(28,5,15),(29,5,16),(30,6,1),(31,6,17),(32,6,2),(33,6,4),(34,7,18),(35,7,19),(36,7,20),(37,7,21),(38,7,22),(39,7,23),(40,7,24),(41,7,25),(42,8,18),(43,9,18),(44,8,19),(45,9,19),(46,8,20),(47,9,20),(48,8,21),(49,9,21),(50,8,22),(51,9,22),(52,8,23),(53,9,23),(54,8,24),(55,9,24),(56,8,25),(57,9,25),(58,8,26),(59,8,28),(60,8,29),(61,8,30),(62,8,31),(63,10,1),(64,10,2),(68,10,33),(67,10,32),(69,10,34);
/*!40000 ALTER TABLE `notification_type_key` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `penalty`
--

DROP TABLE IF EXISTS `penalty`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `penalty` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `student_id` int(11) NOT NULL,
  `teacher_id` int(11) DEFAULT NULL,
  `date_enforced` date NOT NULL,
  `date_added` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `type` varchar(255) DEFAULT NULL,
  `reason` text,
  `carrier` varchar(255) DEFAULT NULL,
  `period_id` int(11) DEFAULT NULL,
  `post_teacher_id` int(11) DEFAULT NULL,
  `apology` text,
  `after_referral` tinyint(1) NOT NULL DEFAULT '0',
  `modifier_teacher_id` int(11) DEFAULT NULL,
  `modified_at` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `penalty`
--

LOCK TABLES `penalty` WRITE;
/*!40000 ALTER TABLE `penalty` DISABLE KEYS */;
/*!40000 ALTER TABLE `penalty` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `penalty_in`
--

DROP TABLE IF EXISTS `penalty_in`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `penalty_in` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `student_id` int(11) DEFAULT NULL,
  `teacher_id` int(11) DEFAULT NULL,
  `registration_number` varchar(100) NOT NULL,
  `name` varchar(255) DEFAULT NULL,
  `surname` varchar(255) DEFAULT NULL,
  `date_enforced` date NOT NULL,
  `type` varchar(255) DEFAULT NULL,
  `reason` text,
  `carrier` varchar(255) DEFAULT NULL,
  `allredy_exists` tinyint(1) DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `penalty_in`
--

LOCK TABLES `penalty_in` WRITE;
/*!40000 ALTER TABLE `penalty_in` DISABLE KEYS */;
/*!40000 ALTER TABLE `penalty_in` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `penalty_type`
--

DROP TABLE IF EXISTS `penalty_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `penalty_type` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `on_absence_table` tinyint(1) NOT NULL DEFAULT '0',
  `on_form` tinyint(1) NOT NULL DEFAULT '0',
  `teacher_access` tinyint(1) NOT NULL DEFAULT '0',
  `absence_reason_id` int(11) DEFAULT NULL,
  `all_day` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=9 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `penalty_type`
--

LOCK TABLES `penalty_type` WRITE;
/*!40000 ALTER TABLE `penalty_type` DISABLE KEYS */;
INSERT INTO `penalty_type` VALUES (1,'ΚΑΘΥΣΤΕΡΗΜΕΝΗ ΕΙΣΟΔΟΣ ΣΤΗΝ ΤΑΞΗ',1,0,1,NULL,0),(2,'ΠΑΡΑΤΗΡΗΣΗ',1,1,1,NULL,0),(3,'ΕΠΙΠΛΗΞΗ',1,1,1,NULL,0),(4,'ΩΡΙΑΙΑ ΑΠΟΒΟΛΗ',1,0,1,2,0),(5,'ΠΑΡΑΠΟΜΠΗ ΣΤΟ ΔΙΕΥΘΥΝΤΗ',1,1,1,NULL,0),(6,'ΑΠΟΒΟΛΗ',0,1,0,3,1),(7,'ΜΕΙΩΣΗ ΔΙΑΓΩΓΗΣ',0,1,0,NULL,0),(8,'ΑΛΛΑΓΗ ΣΧΟΛΙΚΟΥ ΠΕΡΙΒΑΛΛΟΝΤΟΣ',0,1,0,NULL,0);
/*!40000 ALTER TABLE `penalty_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `period`
--

DROP TABLE IF EXISTS `period`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `period` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL,
  `short_name` varchar(50) NOT NULL,
  `start_time` time NOT NULL,
  `end_time` time NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=8 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `period`
--

LOCK TABLES `period` WRITE;
/*!40000 ALTER TABLE `period` DISABLE KEYS */;
INSERT INTO `period` VALUES (1,'1η Ώρα','1η','08:10:00','08:55:00'),(2,'2η Ώρα','2η','09:05:00','09:50:00'),(3,'3η Ώρα','3η','10:00:00','10:45:00'),(4,'4η Ώρα','4η','10:55:00','11:35:00'),(5,'5η Ώρα','5η','11:45:00','12:25:00'),(6,'6η Ώρα','6η','12:30:00','13:10:00'),(7,'7η Ώρα','7η','13:15:00','13:50:00');
/*!40000 ALTER TABLE `period` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `registered_card`
--

DROP TABLE IF EXISTS `registered_card`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `registered_card` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `card_date` date NOT NULL,
  `posted_when` datetime NOT NULL,
  `card_id` int(11) NOT NULL,
  `comments` text,
  `teacher_id` int(11) NOT NULL,
  `no_lesson` tinyint(1) NOT NULL DEFAULT '0',
  `prime` tinyint(1) DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `fk_registered_card_card1_idx` (`card_id`),
  KEY `added_when` (`posted_when`),
  KEY `card_id` (`card_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `registered_card`
--

LOCK TABLES `registered_card` WRITE;
/*!40000 ALTER TABLE `registered_card` DISABLE KEYS */;
/*!40000 ALTER TABLE `registered_card` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `reward`
--

DROP TABLE IF EXISTS `reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `reward` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `student_id` int(11) NOT NULL,
  `teacher_id` int(11) NOT NULL,
  `reward_type_id` int(11) NOT NULL,
  `date_enforced` date NOT NULL,
  `date_added` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `period_id` int(11) DEFAULT NULL,
  `subject_id` int(11) DEFAULT NULL,
  `comments` text,
  `number_of_medals` smallint(6) NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`),
  KEY `fk_reward_teacher_idx` (`teacher_id`),
  KEY `fk_reward_student_idx` (`student_id`),
  KEY `fk_reward_reward_type_idx` (`reward_type_id`),
  KEY `fk_reward_subject_idx` (`subject_id`),
  KEY `fk_reward_period_idx` (`period_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `reward`
--

LOCK TABLES `reward` WRITE;
/*!40000 ALTER TABLE `reward` DISABLE KEYS */;
/*!40000 ALTER TABLE `reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `reward_type`
--

DROP TABLE IF EXISTS `reward_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `reward_type` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `description` varchar(255) DEFAULT NULL,
  `teacher_id` int(11) DEFAULT NULL,
  `is_public` tinyint(1) NOT NULL DEFAULT '0',
  `default_number_of_medals` int(11) NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`),
  KEY `fk_reward_type_teacher_idx` (`teacher_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `reward_type`
--

LOCK TABLES `reward_type` WRITE;
/*!40000 ALTER TABLE `reward_type` DISABLE KEYS */;
/*!40000 ALTER TABLE `reward_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `school`
--

DROP TABLE IF EXISTS `school`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `school` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL,
  `short_name` varchar(50) NOT NULL,
  `ministry` varchar(100) NOT NULL DEFAULT 'ΥΠΟΥΡΓΕΙΟ ΠΑΙΔΕΙΑΣ ΚΑΙ ΘΡΗΣΚΕΥΜΑΤΩΝ',
  `region` varchar(100) NOT NULL DEFAULT 'ΠΕΡΙΦΕΡΕΙΑΚΗ Δ/ΝΣΗ Α/ΘΜΙΑΣ & Β/ΘΜΙΑΣ ΕΚΠ/ΣΗΣ',
  `intendancy` varchar(100) NOT NULL DEFAULT 'Δ/ΝΣΗ Β/ΘΜΙΑΣ ΕΚΠ/ΣΗΣ',
  `phone1` varchar(30) NOT NULL,
  `phone2` varchar(30) DEFAULT NULL,
  `fax` varchar(30) DEFAULT NULL,
  `street` varchar(100) NOT NULL,
  `area` varchar(100) DEFAULT NULL,
  `city` varchar(100) NOT NULL,
  `zipcode` varchar(10) NOT NULL,
  `state` varchar(50) DEFAULT NULL,
  `country` varchar(50) DEFAULT NULL,
  `email` varchar(100) DEFAULT NULL,
  `web_page` varchar(200) DEFAULT NULL,
  `num_days_absence_justification` int(11) NOT NULL DEFAULT '10',
  `parent_days_limit_justification` int(11) NOT NULL DEFAULT '10',
  `school_type_id` int(11) NOT NULL,
  `school_year_id` int(11) NOT NULL,
  `grading_period_id` int(11) NOT NULL,
  `set_absence_time_limit` time DEFAULT '00:00:00',
  `open_absence_books` tinyint(1) NOT NULL DEFAULT '0',
  `absence_anjustified_limit` int(11) NOT NULL DEFAULT '50',
  `absence_total_limit` int(11) NOT NULL DEFAULT '114',
  `hide_teaching_calendar` tinyint(1) NOT NULL DEFAULT '0',
  `show_student_status` tinyint(1) NOT NULL DEFAULT '0',
  `hide_student_absence` tinyint(1) NOT NULL DEFAULT '0',
  `allow_parents_to_edit` tinyint(1) NOT NULL DEFAULT '0',
  `exam_day_limit` int(11) NOT NULL DEFAULT '1',
  `exam_week_limit` int(11) NOT NULL DEFAULT '3',
  `email_absence_text` text,
  `sms_absence_text` varchar(255) DEFAULT NULL,
  `system_url` varchar(255) DEFAULT NULL,
  `version` varchar(50) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_school_school_type_idx` (`school_type_id`),
  KEY `fk_school_school_year1_idx` (`school_year_id`),
  KEY `fk_school_grading_period1_idx` (`grading_period_id`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `school`
--

LOCK TABLES `school` WRITE;
/*!40000 ALTER TABLE `school` DISABLE KEYS */;
INSERT INTO `school` VALUES (1,'ΤΟ ΣΧΟΛΕΙΟ ΜΟΥ','ΣΧΟΛΕΙΟ','ΥΠΟΥΡΓΕΙΟ ΠΑΙΔΕΙΑΣ,  ΕΡΕΥΝΑΣ ΚΑΙ ΘΡΗΣΚΕΥΜΑΤΩΝ','ΠΕΡΙΦΕΡΕΙΑΚΗ Δ/ΝΣΗ Π/ΘΜΙΑΣ & Δ/ΘΜΙΑΣ ΕΚΠ/ΣΗΣ','Δ/ΝΣΗ Δ/ΘΜΙΑΣ ΕΚΠ/ΣΗΣ ','',NULL,NULL,'',NULL,'','',NULL,'GREECE',NULL,NULL,400,100,0,1,1,'00:00:00',1,114,114,0,1,0,0,1,3,'<p>Σας ενημερώνουμε ότι ο μαθητής <strong>-student-</strong><br />μέχρι τις <strong>-date-</strong> έχει πραγματοποιήσει συνολικά <strong>-total-</strong> απουσίες.</p>','Σας ενημερώνουμε ότι ο μαθητής -student- μέχρι -date- έχει συνολικά -total- απουσίες.',NULL,'2024.1.0');
/*!40000 ALTER TABLE `school` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `school_type`
--

DROP TABLE IF EXISTS `school_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `school_type` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL,
  `short_name` varchar(50) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=5 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `school_type`
--

LOCK TABLES `school_type` WRITE;
/*!40000 ALTER TABLE `school_type` DISABLE KEYS */;
INSERT INTO `school_type` VALUES (1,'Γυμνάσιο','Γυμνάσιο'),(2,'Γενικό Λύκειο','ΓΕΛ'),(3,'Επαγγελματικό Λύκειο','ΕΠΑΛ'),(4,'Δημοτικό','Δημοτικό');
/*!40000 ALTER TABLE `school_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `school_year`
--

DROP TABLE IF EXISTS `school_year`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `school_year` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL,
  `short_name` varchar(50) NOT NULL,
  `start_date` date NOT NULL,
  `end_date` date NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `school_year`
--

LOCK TABLES `school_year` WRITE;
/*!40000 ALTER TABLE `school_year` DISABLE KEYS */;
INSERT INTO `school_year` VALUES (1,'Σχολικό Έτος 2020-2021','Σχ. Έτος 2020-2021','2020-09-07','2021-05-31');
/*!40000 ALTER TABLE `school_year` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `section`
--

DROP TABLE IF EXISTS `section`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `section` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL,
  `short_name` varchar(50) NOT NULL,
  `abbreviation` char(1) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=9 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `section`
--

LOCK TABLES `section` WRITE;
/*!40000 ALTER TABLE `section` DISABLE KEYS */;
INSERT INTO `section` VALUES (6,'ΓΕΝΙΚΗΣ ΠΑΙΔΕΙΑΣ','ΓΕΝΙΚΗΣ ΠΑΙΔΕΙΑΣ',''),(7,'ΕΠΙΛΟΓΗΣ','ΕΠΙΛΟΓΗΣ','ε'),(8,'ΕΡΕΥΝΗΤΙΚΗΣ ΕΡΓΑΣΙΑΣ','PROJECT','p');
/*!40000 ALTER TABLE `section` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `session_variables`
--

DROP TABLE IF EXISTS `session_variables`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `session_variables` (
  `temp_id` int(11) NOT NULL AUTO_INCREMENT,
  `session_id` varchar(255) NOT NULL,
  `student_id` int(11) DEFAULT NULL,
  `teacher_id` int(11) DEFAULT NULL,
  `class_id` int(11) DEFAULT NULL,
  `subject_id` int(11) DEFAULT NULL,
  `card_id` int(11) DEFAULT NULL,
  `grading_period_id` int(11) DEFAULT NULL,
  `day_id` int(11) DEFAULT NULL,
  `period_id` int(11) DEFAULT NULL,
  `grade_id` int(11) DEFAULT NULL,
  `mark_id` int(11) DEFAULT NULL,
  `absence_id` int(11) DEFAULT NULL,
  `justification_request_id` int(11) DEFAULT NULL,
  `grading_period_decimals` int(11) DEFAULT '0',
  `mark_print_grading_period_id` int(11) DEFAULT '-1',
  `mark_print_class_id` int(11) DEFAULT '-1',
  `mark_print_subject_id` int(11) DEFAULT '-1',
  `email_subject` varchar(255) DEFAULT NULL,
  `email_recipients` text,
  `email_text` text,
  `sms_mobile_number` varchar(50) DEFAULT NULL,
  `sms_student_id` int(11) DEFAULT '-1',
  `sms_teacher_id` int(11) DEFAULT '-1',
  `critirion_general_id` int(11) DEFAULT '-1',
  `critirion_general_full_name` varchar(512) DEFAULT NULL,
  `critirion_special_id` int(11) DEFAULT '-1',
  `open_absence_books` tinyint(1) DEFAULT '0',
  `student_comments_edited` tinyint(1) DEFAULT '0',
  `ballot_id` int(11) DEFAULT NULL,
  `system_url` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`temp_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `session_variables`
--

LOCK TABLES `session_variables` WRITE;
/*!40000 ALTER TABLE `session_variables` DISABLE KEYS */;
/*!40000 ALTER TABLE `session_variables` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sms`
--

DROP TABLE IF EXISTS `sms`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `sms` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `sender_id` int(11) NOT NULL,
  `sent_at` datetime NOT NULL,
  `phone_number` varchar(20) NOT NULL,
  `sms_text` varchar(255) NOT NULL,
  `gateway_id` int(11) NOT NULL,
  `code` varchar(50) NOT NULL,
  `state` tinyint(4) unsigned NOT NULL,
  `state_changed_at` datetime NOT NULL,
  `remarks` varchar(255) DEFAULT NULL,
  `student_id` int(11) DEFAULT NULL,
  `teacher_id` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_gateway_id1_idx` (`gateway_id`),
  KEY `fk_student_id1_idx` (`student_id`),
  KEY `fk_teacher_id1_idx` (`teacher_id`),
  KEY `fk_sender_id1_idx` (`sender_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sms`
--

LOCK TABLES `sms` WRITE;
/*!40000 ALTER TABLE `sms` DISABLE KEYS */;
/*!40000 ALTER TABLE `sms` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sms_gateway`
--

DROP TABLE IF EXISTS `sms_gateway`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `sms_gateway` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL,
  `class_name` varchar(50) NOT NULL,
  `login_name` varchar(50) DEFAULT NULL,
  `login_password` varchar(50) DEFAULT NULL,
  `api_key` varchar(255) DEFAULT NULL,
  `originator` varchar(50) DEFAULT NULL,
  `active` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sms_gateway`
--

LOCK TABLES `sms_gateway` WRITE;
/*!40000 ALTER TABLE `sms_gateway` DISABLE KEYS */;
INSERT INTO `sms_gateway` VALUES (1,'easySMS API Ver.2','easysms','','',NULL,'',0),(2,'easySMS API Ver.2','easysms','','',NULL,'',0),(3,'easySMS API Ver.3','easysms3',NULL,NULL,'xxxxxxxxxxxxxx','school',0);
/*!40000 ALTER TABLE `sms_gateway` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `speciality`
--

DROP TABLE IF EXISTS `speciality`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `speciality` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL,
  `short_name` varchar(50) NOT NULL,
  `abbreviation` varchar(10) NOT NULL,
  `section_id` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_speciality_section1_idx` (`section_id`)
) ENGINE=MyISAM AUTO_INCREMENT=25 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `speciality`
--

LOCK TABLES `speciality` WRITE;
/*!40000 ALTER TABLE `speciality` DISABLE KEYS */;
INSERT INTO `speciality` VALUES (13,'ΓΕΝΙΚΗΣ ΠΑΙΔΕΙΑΣ','ΓΕΝΙΚΗΣ ΠΑΙΔΕΙΑΣ','',6),(16,'ΕΠΙΛΟΓΗΣ','ΕΠΙΛΟΓΗΣ','ε',7),(17,'ΕΡΕΥΝΗΤΙΚΗ ΕΡΓΑΣΙΑ','PROJECT','p',8);
/*!40000 ALTER TABLE `speciality` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `student`
--

DROP TABLE IF EXISTS `student`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `student` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL,
  `surname` varchar(100) NOT NULL,
  `fathers_name` varchar(100) DEFAULT NULL,
  `mothers_name` varchar(100) DEFAULT NULL,
  `mothers_surname` varchar(100) DEFAULT NULL,
  `registration_number` varchar(100) NOT NULL,
  `gender` varchar(10) DEFAULT NULL,
  `birth_date` date DEFAULT NULL,
  `phone1` varchar(30) DEFAULT NULL,
  `phone2` varchar(30) DEFAULT NULL,
  `mobile` varchar(30) DEFAULT NULL,
  `email` varchar(100) DEFAULT NULL,
  `street` varchar(100) DEFAULT NULL,
  `area` varchar(100) DEFAULT NULL,
  `zipcode` varchar(10) DEFAULT NULL,
  `city` varchar(100) DEFAULT NULL,
  `parent_name` varchar(100) DEFAULT NULL,
  `parent_surname` varchar(100) DEFAULT NULL,
  `parent_phone1` varchar(30) DEFAULT NULL,
  `parent_phone2` varchar(30) DEFAULT NULL,
  `parent_phone3` varchar(45) DEFAULT NULL,
  `parent_email` varchar(100) DEFAULT NULL,
  `parent_email2` varchar(100) DEFAULT NULL,
  `parent_street` varchar(100) DEFAULT NULL,
  `parent_area` varchar(100) DEFAULT NULL,
  `parent_zipcode` varchar(10) DEFAULT NULL,
  `speciality_id` int(11) DEFAULT NULL,
  `grade_id` int(11) DEFAULT NULL,
  `teacher_id` int(11) DEFAULT NULL,
  `user_id` varchar(25) DEFAULT NULL,
  `parent_user_id` varchar(25) DEFAULT NULL,
  `prev_an_justified_absences` int(11) DEFAULT '0',
  `prev_justified_absences` int(11) DEFAULT '0',
  `has_left_school` tinyint(1) NOT NULL DEFAULT '0',
  `advisor_id` int(11) DEFAULT NULL,
  `new_absence_notification` tinyint(1) NOT NULL DEFAULT '1',
  `justify_absence_notification` tinyint(1) NOT NULL DEFAULT '1',
  `delete_absence_notification` tinyint(1) NOT NULL DEFAULT '1',
  `new_penalty_notification` tinyint(1) NOT NULL DEFAULT '1',
  `update_comment_notification` tinyint(1) NOT NULL DEFAULT '1',
  `parent_new_absence_notification` tinyint(1) NOT NULL DEFAULT '1',
  `parent_justify_absence_notification` tinyint(1) NOT NULL DEFAULT '1',
  `parent_delete_absence_notification` tinyint(1) NOT NULL DEFAULT '1',
  `parent_new_penalty_notification` tinyint(1) NOT NULL DEFAULT '1',
  `parent_update_comment_notification` tinyint(1) NOT NULL DEFAULT '1',
  `group_absence_notification` tinyint(1) NOT NULL DEFAULT '0',
  `group_new_absence_notification` tinyint(1) NOT NULL DEFAULT '0',
  `parent_group_new_absence_notification` tinyint(1) NOT NULL DEFAULT '0',
  `new_calendar_event_notification` tinyint(1) NOT NULL DEFAULT '1',
  `parent_new_calendar_event_notification` tinyint(1) NOT NULL DEFAULT '1',
  `new_reward_notification` tinyint(1) NOT NULL DEFAULT '1',
  `parent_new_reward_notification` tinyint(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`),
  KEY `fk_student_speciality1_idx` (`speciality_id`),
  KEY `fk_student_grade1_idx` (`grade_id`),
  KEY `fk_student_teacher1_idx` (`teacher_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `student`
--

LOCK TABLES `student` WRITE;
/*!40000 ALTER TABLE `student` DISABLE KEYS */;
/*!40000 ALTER TABLE `student` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `student_class`
--

DROP TABLE IF EXISTS `student_class`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `student_class` (
  `new_id` int(11) NOT NULL AUTO_INCREMENT,
  `class_id` int(11) NOT NULL,
  `student_id` int(11) NOT NULL,
  PRIMARY KEY (`new_id`),
  KEY `fk_student_class_class1_idx` (`class_id`),
  KEY `fk_student_class_student1_idx` (`student_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `student_class`
--

LOCK TABLES `student_class` WRITE;
/*!40000 ALTER TABLE `student_class` DISABLE KEYS */;
/*!40000 ALTER TABLE `student_class` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `student_class_in`
--

DROP TABLE IF EXISTS `student_class_in`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `student_class_in` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `student_id` int(11) DEFAULT NULL,
  `class_id` int(11) DEFAULT NULL,
  `registration_number` varchar(100) NOT NULL,
  `class` varchar(100) NOT NULL,
  `surname` varchar(100) DEFAULT NULL,
  `name` varchar(100) DEFAULT NULL,
  `fathers_name` varchar(100) DEFAULT NULL,
  `allredy_exists` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `student_class_in`
--

LOCK TABLES `student_class_in` WRITE;
/*!40000 ALTER TABLE `student_class_in` DISABLE KEYS */;
/*!40000 ALTER TABLE `student_class_in` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `student_in`
--

DROP TABLE IF EXISTS `student_in`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `student_in` (
  `student_id` int(11) DEFAULT NULL,
  `name` varchar(100) NOT NULL,
  `surname` varchar(100) NOT NULL,
  `fathers_name` varchar(100) DEFAULT NULL,
  `mothers_name` varchar(100) DEFAULT NULL,
  `registration_number` varchar(100) NOT NULL,
  `gender` varchar(10) DEFAULT NULL,
  `birth_date` varchar(50) DEFAULT NULL,
  `phone1` varchar(30) DEFAULT NULL,
  `phone2` varchar(30) DEFAULT NULL,
  `mobile` varchar(30) DEFAULT NULL,
  `email` varchar(100) DEFAULT NULL,
  `street` varchar(100) DEFAULT NULL,
  `area` varchar(100) DEFAULT NULL,
  `zipcode` varchar(10) DEFAULT NULL,
  `city` varchar(100) DEFAULT NULL,
  `parent_name` varchar(100) DEFAULT NULL,
  `parent_surname` varchar(100) DEFAULT NULL,
  `parent_phone1` varchar(30) DEFAULT NULL,
  `parent_phone2` varchar(30) DEFAULT NULL,
  `parent_phone3` varchar(45) DEFAULT NULL,
  `parent_email` varchar(100) DEFAULT NULL,
  `parent_street` varchar(100) DEFAULT NULL,
  `parent_area` varchar(100) DEFAULT NULL,
  `parent_zipcode` varchar(10) DEFAULT NULL,
  `speciality` varchar(100) DEFAULT NULL,
  `grade` varchar(30) DEFAULT NULL,
  `mothers_surname` varchar(100) DEFAULT NULL,
  `parent_email2` varchar(100) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `student_in`
--

LOCK TABLES `student_in` WRITE;
/*!40000 ALTER TABLE `student_in` DISABLE KEYS */;
/*!40000 ALTER TABLE `student_in` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `subject`
--

DROP TABLE IF EXISTS `subject`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `subject` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `short_name` varchar(255) NOT NULL,
  `is_marked` tinyint(1) NOT NULL DEFAULT '1',
  `subject_type_id` int(11) DEFAULT NULL,
  `grade_id` int(11) DEFAULT NULL,
  `speciality_id` int(11) DEFAULT NULL,
  `myschool_name_id` int(11) DEFAULT NULL,
  `exam_curriculum` text,
  `exam_curriculum_modified_at` datetime DEFAULT NULL,
  `exam_curriculum_post_teacher_id` int(11) DEFAULT NULL,
  `absence_counts` tinyint(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`),
  KEY `fk_subject_subject_type1_idx` (`subject_type_id`),
  KEY `fk_subject_grade1_idx` (`grade_id`),
  KEY `fk_subject_speciality1_idx` (`speciality_id`)
) ENGINE=MyISAM AUTO_INCREMENT=10 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `subject`
--

LOCK TABLES `subject` WRITE;
/*!40000 ALTER TABLE `subject` DISABLE KEYS */;
INSERT INTO `subject` VALUES (2,'Εκδρομή','Εκδρομή',0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1),(3,'Γιορτή','Γιορτή',0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1),(4,'Εκδήλωση','Εκδήλωση',0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1),(5,'Εκλογές','Εκλογές',0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1),(6,'Αθλητικοί Αγώνες','Αθλητικοί Αγώνες',0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1),(7,'Αναπλήρωση Μαθήματος','Αναπλήρωση',0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1),(1,'Δε γίνεται μάθημα','Όχι Μάθημα',0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1);
/*!40000 ALTER TABLE `subject` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `subject_critirion_general`
--

DROP TABLE IF EXISTS `subject_critirion_general`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `subject_critirion_general` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `subject_id` int(11) NOT NULL,
  `critirion_general_id` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_subject_critirion_general_subject1_idx` (`subject_id`),
  KEY `fk_subject_critirion_general_critirion_general1_idx` (`critirion_general_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `subject_critirion_general`
--

LOCK TABLES `subject_critirion_general` WRITE;
/*!40000 ALTER TABLE `subject_critirion_general` DISABLE KEYS */;
/*!40000 ALTER TABLE `subject_critirion_general` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `subject_in`
--

DROP TABLE IF EXISTS `subject_in`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `subject_in` (
  `id` varchar(255) DEFAULT NULL,
  `name` varchar(255) DEFAULT NULL,
  `short` varchar(255) DEFAULT NULL,
  `new_id` int(11) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `subject_in`
--

LOCK TABLES `subject_in` WRITE;
/*!40000 ALTER TABLE `subject_in` DISABLE KEYS */;
/*!40000 ALTER TABLE `subject_in` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `subject_type`
--

DROP TABLE IF EXISTS `subject_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `subject_type` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(50) NOT NULL,
  `short_name` varchar(10) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `subject_type`
--

LOCK TABLES `subject_type` WRITE;
/*!40000 ALTER TABLE `subject_type` DISABLE KEYS */;
INSERT INTO `subject_type` VALUES (1,'Θεωρία','Θ'),(2,'Εργαστήριο','Ε');
/*!40000 ALTER TABLE `subject_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `teacher`
--

DROP TABLE IF EXISTS `teacher`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `teacher` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `short_name` varchar(50) NOT NULL,
  `name` varchar(100) NOT NULL,
  `surname` varchar(100) DEFAULT NULL,
  `gender` varchar(10) DEFAULT NULL,
  `fathers_name` varchar(100) DEFAULT NULL,
  `phone1` varchar(30) DEFAULT NULL,
  `phone2` varchar(30) DEFAULT NULL,
  `mobile` varchar(30) DEFAULT NULL,
  `email` varchar(100) DEFAULT NULL,
  `web_page` varchar(200) DEFAULT NULL,
  `teaching_field_id` int(11) DEFAULT NULL,
  `user_id` varchar(25) DEFAULT NULL,
  `comments_for_students` varchar(255) DEFAULT NULL,
  `sms_limit` int(11) DEFAULT '0',
  `accept_email_from_students` tinyint(1) NOT NULL DEFAULT '1',
  `accept_appointments` tinyint(1) NOT NULL DEFAULT '0',
  `appointment_duration` int(11) NOT NULL DEFAULT '10',
  `hide_teaching_calendar` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `fk_teacher_teaching_field1_idx` (`teaching_field_id`)
) ENGINE=MyISAM AUTO_INCREMENT=27 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `teacher`
--

LOCK TABLES `teacher` WRITE;
/*!40000 ALTER TABLE `teacher` DISABLE KEYS */;
INSERT INTO `teacher` VALUES (26,'ΔΙΕΥΘΥΝΤΗΣ','','ΔΙΕΥΘΥΝΤΗΣ',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'54737fc85981449',NULL,NULL,1,0,10,0);
/*!40000 ALTER TABLE `teacher` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `teacher_in`
--

DROP TABLE IF EXISTS `teacher_in`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `teacher_in` (
  `id` varchar(255) DEFAULT NULL,
  `name` varchar(255) DEFAULT NULL,
  `short` varchar(255) DEFAULT NULL,
  `new_id` int(11) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `teacher_in`
--

LOCK TABLES `teacher_in` WRITE;
/*!40000 ALTER TABLE `teacher_in` DISABLE KEYS */;
/*!40000 ALTER TABLE `teacher_in` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `teacher_student`
--

DROP TABLE IF EXISTS `teacher_student`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `teacher_student` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `teacher_id` int(11) DEFAULT NULL,
  `student_id` int(11) DEFAULT NULL,
  `hierarchy_teacher` int(11) DEFAULT NULL,
  `hierarchy_student` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_teacher1_idx` (`teacher_id`),
  KEY `fk_student1_idx` (`student_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `teacher_student`
--

LOCK TABLES `teacher_student` WRITE;
/*!40000 ALTER TABLE `teacher_student` DISABLE KEYS */;
/*!40000 ALTER TABLE `teacher_student` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `teaching_field`
--

DROP TABLE IF EXISTS `teaching_field`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `teaching_field` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL,
  `short_name` varchar(50) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=200 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `teaching_field`
--

LOCK TABLES `teaching_field` WRITE;
/*!40000 ALTER TABLE `teaching_field` DISABLE KEYS */;
INSERT INTO `teaching_field` VALUES (1,'ΘΕΟΛΟΓΟΙ','ΠΕ01'),(2,'ΦΙΛΟΛΟΓΟΙ','ΠΕ02'),(3,'ΜΑΘΗΜΑΤΙΚΟΙ','ΠΕ03'),(4,'ΦΥΣΙΚΟΙ','ΠΕ0401'),(5,'ΧΗΜΙΚΟΙ','ΠΕ0402'),(6,'ΦΥΣΙΟΓΝΩΣΤΕΣ','ΠΕ0403'),(7,'ΒΙΟΛΟΓΟΙ','ΠΕ0404'),(8,'ΓΕΩΛΟΓΟΙ','ΠΕ0405'),(9,'ΓΑΛΛΙΚΗΣ','ΠΕ05'),(10,'ΑΓΓΛΙΚΗΣ','ΠΕ06'),(11,'ΓΕΡΜΑΝΙΚΗΣ','ΠΕ07'),(12,'ΚΑΛΛΙΤΕΧΝΙΚΩΝ','ΠΕ08'),(15,'ΦΥΣΙΚΗΣ ΑΓΩΓΗΣ','ΠΕ11'),(196,'ΕΞΕΙΔΙΚΕΥΜΕΝΩΝ ΣΤΟΥΣ ΤΥΦΛΟΥΣ ΚΑΙ ΚΩΦΟΥΣ','ΠΕ31'),(197,'ΕΞΕΙΔΙΚΕΥΜΕΝΩΝ ΠΑΙΔΙΑΤΡΩΝ','ΠΕ35'),(198,'ΜΟΥΣΙΚΟΘΕΡΑΠΕΥΤΩΝ','ΠΕ36'),(199,'ΕΙΔΙΚΟ ΒΟΗΘΗΤΙΚΟ ΠΡΟΣΩΠΙΚΟ','ΔΕ01'),(93,'ΜΕΘΟΔΟΛΟΓΙΑΣ ΙΣΤΟΡΙΑΣ ΚΑΙ ΘΕΩΡΙΑΣ ΤΗΣ ΕΠΙΣΤΗΜΗΣ (ΜΙΘΕ)','ΠΕ33'),(94,'ΙΤΑΛΙΚΗΣ ΦΙΛΟΛΟΓΙΑΣ','ΠΕ34'),(187,'ΙΣΠΑΝΙΚΗΣ ΦΙΛΟΛΟΓΙΑΣ','ΠΕ40'),(195,'ΚΟΙΝΩΝΙΚΩΝ ΛΕΙΤΟΥΡΓΩΝ','ΠΕ30'),(99,'ΨΥΚΤΙΚΟΙ','ΤΕ0104'),(101,'ΗΛΕΚΤΡΟΛΟΓΟΙ','ΤΕ0106'),(102,'ΗΛΕΚΤΡΟΝΙΚΟΙ','ΤΕ0107'),(194,'ΕΡΓΑΣΙΟΘΕΡΑΠΕΥΤΩΝ – ΕΡΓΟΘΕΡΑΠΕΥΤΩΝ','ΠΕ29'),(108,'ΠΡΟΓΡΑΜΜΑΤΙΣΤΕΣ Η/Υ','ΤΕ0113'),(193,'ΦΥΣΙΟΘΕΡΑΠΕΥΤΩΝ','ΠΕ28'),(112,'ΚΟΜΜΩΤΙΚΗΣ','ΤΕ0119'),(113,'ΑΙΣΘΗΤΙΚΗΣ','ΤΕ0120'),(188,'ΜΟΥΣΙΚΗΣ ΜΗ ΑΝΩΤΑΤΩΝ ΙΔΡΥΜΑΤΩΝ','ΤΕ16'),(117,'ΑΡΓΥΡΟΧΡΥΣΟΧΟΪΑΣ','ΤΕ0125'),(118,'ΟΔΟΝΤΟΤΕΧΝΙΚΗΣ','ΤΕ0126'),(121,'ΒΟΗΘΩΝ ΙΑΤΡ. ΒΙΟΛΟΓ. ΕΡΓΑΣΤΗΡΙΩΝ','ΤΕ0129'),(122,'ΒΟΗΘΟΙ ΒΡΕΦΟΚΟΜΩΝ - ΠΑΙΔΟΚΟΜΩΝ','ΤΕ0130'),(123,'ΧΕΙΡΙΣΤΕΣ ΙΑΤΡΙΚΩΝ ΣΥΣΚΕΥΩΝ ΒΟΗΘΟΙ ΑΚΤΙΝΟΛΟΓΟΙ','ΤΕ0131'),(133,'ΟΙΚΟΔΟΜΟΙ','ΔΕ0105'),(190,'ΨΥΧΟΛΟΓΩΝ','ΠΕ23'),(191,'ΠΑΙΔΟΨΥΧΙΑΤΡΩΝ','ΠΕ24'),(192,'ΣΧΟΛΙΚΩΝ ΝΟΣΗΛΕΥΤΩΝ','ΠΕ25'),(141,'ΞΥΛΟΥΡΓΟΙ','ΔΕ0113'),(142,'ΚΟΠΤΙΚΗΣ - ΡΑΠΤΙΚΗΣ','ΔΕ0114'),(143,'ΑΡΓΥΡΟΧΡΥΣΟΧΟΟΙ','ΔΕ0115'),(145,'ΚΟΜΜΩΤΙΚΗΣ','ΔΕ0117'),(189,'ΕΠΑΓΓΕΛΜΑΤΙΚΩΝ ΣΥΜΒΟΥΛΩΝ','ΠΕ22'),(147,'ΚΟΙΝΩΝΙΚΩΝ ΕΠΙΣΤΗΜΩΝ ','ΠΕ78'),(148,'ΜΟΥΣΙΚΗΣ ΕΠΙΣΤΗΜΗΣ','ΠΕ7901'),(149,'ΤΕΧΝΟΛΟΓΟΙ ΜΟΥΣΙΚΗΣ ΤΕΧΝΟΛΟΓΙΑΣ, ΗΧΟΥ ΚΑΙ ΜΟΥΣΙΚΩΝ ΟΡΓΑΝΩΝ','ΠΕ7902'),(150,'ΟΙΚΟΝΟΜΙΑΣ','ΠΕ80'),(151,'ΠΟΛ.ΜΗΧΑΝΙΚΩΝ - ΑΡΧΙΤΕΚΤΟΝΩΝ','ΠΕ81'),(152,'ΜΗΧΑΝΟΛΟΓΩΝ','ΠΕ82'),(153,'ΗΛΕΚΤΡΟΛΟΓΩΝ','ΠΕ83'),(154,'ΗΛΕΚΤΡΟΝΙΚΩΝ','ΠΕ84'),(155,'ΧΗΜΙΚΩΝ ΜΗΧΑΝΙΚΩΝ','ΠΕ85'),(156,'ΠΛΗΡΟΦΟΡΙΚΗΣ','ΠΕ86'),(157,'ΙΑΤΡΙΚΗΣ','ΠΕ8701'),(158,'ΝΟΣΗΛΕΥΤΙΚΗΣ','ΠΕ8702'),(159,'ΑΙΣΘΗΤΙΚΗΣ','ΠΕ8703'),(160,'ΙΑΤΡΙΚΩΝ ΕΡΓΑΣΤΗΡΙΩΝ','ΠΕ8704'),(161,'ΟΔΟΝΤΟΤΕΧΝΙΚΗΣ','ΠΕ8705'),(162,'ΚΟΙΝΩΝΙΚΗΣ ΕΡΓΑΣΙΑΣ','ΠΕ8706'),(163,'ΡΑΔΙΟΛΟΓΙΑΣ- ΑΚΤΙΝΟΛΟΓΙΑΣ','ΠΕ8707'),(164,'ΦΥΣΙΟΘΕΡΑΠΕΙΑΣ','ΠΕ8708'),(165,'ΒΡΕΦΟΝΗΠΙΟΚΟΜΩΝ','ΠΕ8709 '),(166,'ΔΗΜΟΣΙΑΣ ΥΓΙΕΙΝΗΣ','ΠΕ8710'),(167,'ΓΕΩΠΟΝΟΙ','ΠΕ8801'),(168,'ΦΥΤΙΚΗΣ ΠΑΡΑΓΩΓΗΣ','ΠΕ8802 '),(169,'ΖΩΙΚΗΣ ΠΑΡΑΓΩΓΗΣ','ΠΕ8803'),(170,'ΔΙΑΤΡΟΦΗΣ','ΠΕ8804'),(171,'ΦΥΣΙΚΟΥ ΠΕΡΙΒΑΛΛΟΝΤΟΣ','ΠΕ8805'),(172,'ΚΑΛΛΙΤΕΧΝΙΚΩΝ ΣΠΟΥΔΩΝ','ΠΕ8901'),(173,'ΣΧΕΔΙΑΣΜΟΥ ΚΑΙ ΠΑΡΑΓΩΓΗΣ ΠΡΟΪΟΝΤΩΝ','ΠΕ8902'),(174,'ΝΑΥΤΙΚΩΝ','ΠΕ90'),(175,'ΘΕΑΤΡΙΚΩΝ ΣΠΟΥΔΩΝ','ΠΕ9101'),(176,'ΔΡΑΜΑΤΙΚΗΣ ΤΕΧΝΗΣ','ΠΕ9102 '),(177,'ΣΧΕΔΙΑΣΤΕΣ - ΔΟΜΙΚΟΙ','ΤΕ0201'),(178,'ΜΗΧΑΝΟΛΟΓΟΙ','ΤΕ0202'),(179,'ΧΗΜΙΚΟΙ ΕΡΓΑΣΤΗΡΙΩΝ','ΤΕ0203'),(180,'ΟΙΚΟΝΟΜΙΑΣ – ΔΙΟΙΚΗΣΗΣ','ΤΕ0204'),(181,'ΕΦΑΡΜΟΣΜΕΝΩΝ ΤΕΧΝΩΝ','ΤΕ0205'),(182,'ΣΧΕΔΙΑΣΜΟΥ ΚΑΙ ΠΑΡΑΓΩΓΗΣ ΠΡΟΪΟΝΤΩΝ','ΤΕ0206'),(183,'ΓΕΩΠΟΝΙΑΣ','ΤΕ0207'),(184,'ΗΛΕΚΤΡΟΛΟΓΟΙ – ΗΛΕΚΤΡΟΝΙΚΟΙ','ΔΕ0201'),(185,'ΜΗΧΑΝΟΛΟΓΟΙ','ΔΕ0202'),(186,'ΘΕΡΑΠΕΥΤΩΝ ΛΟΓΟΥ','ΠΕ21');
/*!40000 ALTER TABLE `teaching_field` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `timetable`
--

DROP TABLE IF EXISTS `timetable`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `timetable` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `start_date` date NOT NULL,
  `added_when` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`),
  UNIQUE KEY `start_date` (`start_date`),
  KEY `start_date_2` (`start_date`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `timetable`
--

LOCK TABLES `timetable` WRITE;
/*!40000 ALTER TABLE `timetable` DISABLE KEYS */;
/*!40000 ALTER TABLE `timetable` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `zzzsys_access_level`
--

DROP TABLE IF EXISTS `zzzsys_access_level`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `zzzsys_access_level` (
  `zzzsys_access_level_id` varchar(25) NOT NULL DEFAULT '',
  `sal_code` varchar(50) DEFAULT NULL,
  `sal_description` varchar(200) DEFAULT NULL,
  `sal_zzzsys_form_id` varchar(25) NOT NULL,
  `zzzsys_access_level_log_added_at` datetime NOT NULL,
  `zzzsys_access_level_log_added_by` varchar(25) NOT NULL,
  `zzzsys_access_level_log_changed_at` datetime NOT NULL,
  `zzzsys_access_level_log_changed_by` varchar(25) NOT NULL,
  `zzzsys_access_level_log_viewed_at` datetime NOT NULL,
  `zzzsys_access_level_log_viewed_by` varchar(25) NOT NULL,
  PRIMARY KEY (`zzzsys_access_level_id`),
  KEY `sal_name` (`sal_code`),
  KEY `sal_zzzsys_form_id` (`sal_zzzsys_form_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `zzzsys_access_level`
--

LOCK TABLES `zzzsys_access_level` WRITE;
/*!40000 ALTER TABLE `zzzsys_access_level` DISABLE KEYS */;
INSERT INTO `zzzsys_access_level` VALUES ('547de3bee410196','AssistManager','Υποδιευθυντής του Σχολείου','5618f5cc92f9c9e','2014-12-02 18:07:26','globeadmin','2015-10-10 23:28:55','globeadmin','2022-01-31 16:18:37','globeadmin'),('547de3e001028e8','Teacher','Καθηγητής','59d67ca712d3ffa','2014-12-02 18:08:00','globeadmin','2017-10-06 23:57:26','globeadmin','2019-11-06 15:15:01','globeadmin'),('547de3fe0d36089','Student','Μαθητής','59da63096606dc0','2014-12-02 18:08:30','globeadmin','2017-10-15 19:01:13','globeadmin','2019-07-01 11:06:55','globeadmin'),('5501dbedc785fe4','Manager','Διευθυντής του Σχολείου','5618f5cc92f9c9e','2015-03-12 20:33:18','globeadmin','2015-10-10 23:05:04','globeadmin','2018-01-09 18:50:57','globeadmin'),('5601afbc23dfb00','Administrator','Διαχειριστής του Σίσυφου','5618f5cc92f9c9e','2015-09-22 22:45:00','globeadmin','2015-10-10 14:26:44','globeadmin','2018-11-20 14:41:57','globeadmin'),('561928b27d0261b','temp','temporary','nuhome','2015-10-10 18:03:14','globeadmin','2015-10-10 18:03:14','globeadmin','2022-02-12 00:40:51','globeadmin'),('5689468794353da','Secretary','Γραμματέας','5618f5cc92f9c9e','2016-01-03 18:04:23','globeadmin','2016-02-04 21:27:42','globeadmin','2016-02-09 20:37:54','globeadmin'),('nufastformlevel','FF','Fast Forms','nuhome','0000-00-00 00:00:00','','0000-00-00 00:00:00','','2016-07-17 22:59:00','globeadmin'),('5717b9c74a31169','Parent','Γονέας','59da63096606dc0','2016-04-20 20:18:01','globeadmin','2017-10-15 19:02:04','globeadmin','2017-10-15 19:02:04','globeadmin'),('60475aa35186b93','Psychologist','Ψυχολόγος','59d67ca712d3ffa','2021-03-09 13:23:15','globeadmin','2021-03-09 13:25:38','globeadmin','2021-03-09 13:25:38','globeadmin');
/*!40000 ALTER TABLE `zzzsys_access_level` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `zzzsys_access_level_form`
--

DROP TABLE IF EXISTS `zzzsys_access_level_form`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `zzzsys_access_level_form` (
  `zzzsys_access_level_form_id` varchar(25) NOT NULL DEFAULT '',
  `slf_zzzsys_access_level_id` varchar(25) DEFAULT NULL,
  `slf_zzzsys_form_id` varchar(25) DEFAULT NULL,
  `slf_add_button` varchar(1) NOT NULL,
  `slf_save_button` varchar(1) NOT NULL,
  `slf_delete_button` varchar(1) NOT NULL,
  `slf_clone_button` varchar(1) NOT NULL,
  `slf_new_button` varchar(1) NOT NULL,
  `slf_print_button` varchar(1) NOT NULL,
  `zzzsys_access_level_form_log_added_at` datetime NOT NULL,
  `zzzsys_access_level_form_log_added_by` varchar(25) NOT NULL,
  `zzzsys_access_level_form_log_changed_at` datetime NOT NULL,
  `zzzsys_access_level_form_log_changed_by` varchar(25) NOT NULL,
  `zzzsys_access_level_form_log_viewed_at` datetime NOT NULL,
  `zzzsys_access_level_form_log_viewed_by` varchar(25) NOT NULL,
  PRIMARY KEY (`zzzsys_access_level_form_id`),
  KEY `saf_zzzsys_access_level_id` (`slf_zzzsys_access_level_id`),
  KEY `slf_zzzsys_form_id` (`slf_zzzsys_form_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `zzzsys_access_level_form`
--

LOCK TABLES `zzzsys_access_level_form` WRITE;
/*!40000 ALTER TABLE `zzzsys_access_level_form` DISABLE KEYS */;
INSERT INTO `zzzsys_access_level_form` VALUES ('547de55c12182aa','547de3e001028e8','547d6ec60ac6bdd','','','','','','','2014-12-02 18:14:20','globeadmin','2014-12-02 18:14:20','globeadmin','2019-11-06 15:15:06','globeadmin'),('54833bfc69f40ea','547de3e001028e8','548338073921bfe','','','','','','','2014-12-06 19:25:16','globeadmin','2014-12-06 19:25:16','globeadmin','2019-11-06 15:15:08','globeadmin'),('54835f847b0af5d','547de3e001028e8','54835ec50abe722','','','','','','','2014-12-06 21:56:52','globeadmin','2014-12-06 21:56:52','globeadmin','2019-11-06 15:15:04','globeadmin'),('548d7a16e5ed7b7','547de3529860755','nuuser','','','','','','','2014-12-14 13:52:54','globeadmin','2014-12-14 13:52:54','globeadmin','2015-03-12 20:30:48','globeadmin'),('5501de7da557c2c','5501dbedc785fe4','54a433830716b84','','','','','','','2015-03-12 20:44:13','globeadmin','2015-03-12 20:44:13','globeadmin','2015-10-10 23:29:14','globeadmin'),('5501de7d9b93c55','5501dbedc785fe4','54a4107cddefff1','','','','','','','2015-03-12 20:44:13','globeadmin','2015-03-12 20:44:13','globeadmin','2018-01-09 18:51:07','globeadmin'),('5501de7d7e47e4d','5501dbedc785fe4','54ce7f0188a78ec','','','','','','','2015-03-12 20:44:13','globeadmin','2015-03-12 20:44:13','globeadmin','2018-01-09 18:51:09','globeadmin'),('5501de7d880bc14','5501dbedc785fe4','54a26a8d05fa91d','','','','','','','2015-03-12 20:44:13','globeadmin','2015-03-12 20:44:13','globeadmin','2018-01-09 18:51:02','globeadmin'),('5501de7d91cfb4b','5501dbedc785fe4','54a312a5698c8f9','','','','','','','2015-03-12 20:44:13','globeadmin','2015-03-12 20:44:13','globeadmin','2018-01-09 18:51:10','globeadmin'),('5501dcf2a7c76ff','5501dbedc785fe4','5470b05b91e73a0','','','','','','','2015-03-12 20:37:38','globeadmin','2015-03-12 20:37:38','globeadmin','2018-01-09 18:51:07','globeadmin'),('5501dcf2b18ce9d','5501dbedc785fe4','5470b3806384141','','','','','','','2015-03-12 20:37:38','globeadmin','2015-03-12 20:37:38','globeadmin','2018-01-09 18:51:12','globeadmin'),('5501dcf2bb51fc9','5501dbedc785fe4','5470b6d7c79d3b9','','','','','','','2015-03-12 20:37:38','globeadmin','2015-03-12 20:37:38','globeadmin','2018-01-09 18:51:00','globeadmin'),('5501dcf2c514d6a','5501dbedc785fe4','5470c07906bfd70','','','','','','','2015-03-12 20:37:38','globeadmin','2015-03-12 20:37:38','globeadmin','2018-01-09 18:51:06','globeadmin'),('5501dcf2ced8d85','5501dbedc785fe4','54730f661a9b822','','','','','','','2015-03-12 20:37:38','globeadmin','2015-03-12 20:37:38','globeadmin','2018-01-09 18:50:58','globeadmin'),('5501dcf29e0c948','5501dbedc785fe4','547081ceb3d2146','','','','','','','2015-03-12 20:37:38','globeadmin','2015-03-12 20:37:38','globeadmin','2018-01-09 18:51:06','globeadmin'),('5501dcf29440ce2','5501dbedc785fe4','5470802845f7427','','','','','','','2015-03-12 20:37:38','globeadmin','2015-03-12 20:37:38','globeadmin','2018-01-09 18:51:06','globeadmin'),('5501dcf28a7ce10','5501dbedc785fe4','54707c8612b1b6b','','','','','','','2015-03-12 20:37:38','globeadmin','2015-03-12 20:37:38','globeadmin','2018-01-09 18:51:03','globeadmin'),('5501dcf280b8cc9','5501dbedc785fe4','5470788787e004a','','','','','','','2015-03-12 20:37:38','globeadmin','2015-03-12 20:37:38','globeadmin','2018-01-09 18:51:03','globeadmin'),('5501dcf2636cd54','5501dbedc785fe4','54706f6b39c1b38','','','','','','','2015-03-12 20:37:38','globeadmin','2015-03-12 20:37:38','globeadmin','2018-01-09 18:51:02','globeadmin'),('5501dcf26d30fbc','5501dbedc785fe4','547070c91793d3b','','','','','','','2015-03-12 20:37:38','globeadmin','2015-03-12 20:37:38','globeadmin','2018-01-09 18:51:02','globeadmin'),('5501dcf276f4ecd','5501dbedc785fe4','54707442a2bcae4','','','','','','','2015-03-12 20:37:38','globeadmin','2015-03-12 20:37:38','globeadmin','2018-01-09 18:51:06','globeadmin'),('5501dcf259a8e29','5501dbedc785fe4','54706cd4f34daae','','','','','','','2015-03-12 20:37:38','globeadmin','2015-03-12 20:37:38','globeadmin','2018-01-09 18:51:02','globeadmin'),('5501dcf2461f22f','5501dbedc785fe4','nuuser','','','','','','','2015-03-12 20:37:38','globeadmin','2015-03-12 20:37:38','globeadmin','2018-01-09 18:51:12','globeadmin'),('5501dcf24fe4cb2','5501dbedc785fe4','54705a95c4e91c2','','','','','','','2015-03-12 20:37:38','globeadmin','2015-03-12 20:37:38','globeadmin','2018-01-09 18:51:00','globeadmin'),('549842d8442c17c','547de3e001028e8','5495dad1762dc2c','','','','','','','2014-12-22 18:12:08','globeadmin','2014-12-22 18:12:08','globeadmin','2019-11-06 15:15:06','globeadmin'),('5501de7db8dfa94','5501dbedc785fe4','54a65ecc3f14737','','','','','','','2015-03-12 20:44:14','globeadmin','2015-03-12 20:44:14','globeadmin','2018-01-09 18:51:00','globeadmin'),('5501de7dc2a3bac','5501dbedc785fe4','54aa751b6567046','','','','','','','2015-03-12 20:44:14','globeadmin','2015-03-12 20:44:14','globeadmin','2018-01-09 18:51:10','globeadmin'),('5501de7daf1bc9b','5501dbedc785fe4','54a52c3dcf3610b','','','','','','','2015-03-12 20:44:14','globeadmin','2015-03-12 20:44:14','globeadmin','2018-01-09 18:51:02','globeadmin'),('5501dd990916bc7','5501dbedc785fe4','54736dab44212c7','','','','','','','2015-03-12 20:40:25','globeadmin','2015-03-12 20:40:25','globeadmin','2018-01-09 18:51:10','globeadmin'),('5501dd9912db2ab','5501dbedc785fe4','547372d029461f4','','','','','','','2015-03-12 20:40:25','globeadmin','2015-03-12 20:40:25','globeadmin','2018-01-09 18:51:10','globeadmin'),('5501dd991ca095b','5501dbedc785fe4','5474c1d7bef6b64','','','','','','','2015-03-12 20:40:25','globeadmin','2015-03-12 20:40:25','globeadmin','2018-01-09 18:50:57','globeadmin'),('5501dd992663cba','5501dbedc785fe4','547489b0d4efe7c','','','','','','','2015-03-12 20:40:25','globeadmin','2015-03-12 20:40:25','globeadmin','2018-01-09 18:51:00','globeadmin'),('5501dd993027d8b','5501dbedc785fe4','5476201e5a3d38f','','','','','','','2015-03-12 20:40:25','globeadmin','2015-03-12 20:40:25','globeadmin','2018-01-09 18:51:09','globeadmin'),('54a66525047acd7','547de3e001028e8','54a65ecc3f14737','','','','','','','2015-01-02 11:30:13','globeadmin','2015-01-02 11:30:13','globeadmin','2019-11-06 15:15:03','globeadmin'),('5501de7dcc67cdf','5501dbedc785fe4','54b2d9dd8417a3d','','','','','','','2015-03-12 20:44:14','globeadmin','2015-03-12 20:44:14','globeadmin','2018-01-09 18:51:07','globeadmin'),('54a7bbb9c8a46da','547de3fe0d36089','54835ec50abe722','','','','','','','2015-01-03 11:51:53','globeadmin','2015-01-03 11:51:53','globeadmin','2019-07-01 11:06:57','globeadmin'),('54a7bbb9d4d984f','547de3fe0d36089','54a6fde1ab6eb6d','','','','','','','2015-01-03 11:51:53','globeadmin','2015-01-03 11:51:53','globeadmin','2019-07-01 11:07:00','globeadmin'),('5501dd9939ebdf2','5501dbedc785fe4','5478c7e75911cd4','','','','','','','2015-03-12 20:40:25','globeadmin','2015-03-12 20:40:25','globeadmin','2018-01-09 18:51:12','globeadmin'),('5501dd9943b0376','5501dbedc785fe4','547d6ec60ac6bdd','','','','','','','2015-03-12 20:40:25','globeadmin','2015-03-12 20:40:25','globeadmin','2018-01-09 18:51:08','globeadmin'),('5501dd994d7451b','5501dbedc785fe4','54d65f0144e61a3','','','','','','','2015-03-12 20:40:25','globeadmin','2015-03-12 20:40:25','globeadmin','2018-01-09 18:51:05','globeadmin'),('5501dd995737e64','5501dbedc785fe4','5495dad1762dc2c','','','','','','','2015-03-12 20:40:25','globeadmin','2015-03-12 20:40:25','globeadmin','2018-01-09 18:51:06','globeadmin'),('54f0c6afcda8ef6','547de3e001028e8','5476201e5a3d38f','','','','','','','2015-02-27 21:34:07','globeadmin','2015-02-27 21:34:07','globeadmin','2019-11-06 15:15:07','globeadmin'),('55013634ccb8ba5','547de3e001028e8','54f735c7d56625f','','','','','','','2015-03-12 08:46:12','globeadmin','2015-03-12 08:46:12','globeadmin','2019-11-06 15:15:06','globeadmin'),('550138cf180f0ac','547de3bee410196','54f735c7d56625f','','','','','','','2015-03-12 08:57:19','globeadmin','2015-03-12 08:57:19','globeadmin','2022-01-31 16:18:40','globeadmin'),('5501de7dd62bdc7','5501dbedc785fe4','54df1259eb4def9','','','','','','','2015-03-12 20:44:14','globeadmin','2015-03-12 20:44:14','globeadmin','2018-01-09 18:51:09','globeadmin'),('5501de7ddff003d','5501dbedc785fe4','54df1dbf0f931e5','','','','','','','2015-03-12 20:44:14','globeadmin','2015-03-12 20:44:14','globeadmin','2018-01-09 18:51:09','globeadmin'),('5501de7dec24df4','5501dbedc785fe4','54df20f94548357','','','','','','','2015-03-12 20:44:14','globeadmin','2015-03-12 20:44:14','globeadmin','2018-01-09 18:51:12','globeadmin'),('5501deac684edc5','5501dbedc785fe4','5501db35db0c716','','','','','','','2015-03-12 20:45:00','globeadmin','2015-03-12 20:45:00','globeadmin','2018-01-09 18:51:08','globeadmin'),('5501deac7212b96','5501dbedc785fe4','54f735c7d56625f','','','','','','','2015-03-12 20:45:00','globeadmin','2015-03-12 20:45:00','globeadmin','2018-01-09 18:51:08','globeadmin'),('5501e09fb18b7f7','5501dbedc785fe4','548338073921bfe','','','','','','','2015-03-12 20:53:19','globeadmin','2015-03-12 20:53:19','globeadmin','2018-01-09 18:51:10','globeadmin'),('550680e00cd3a60','547de3e001028e8','5501db35db0c716','','','','','','','2015-03-16 09:06:08','globeadmin','2015-03-16 09:06:08','globeadmin','2019-11-06 15:15:07','globeadmin'),('550e78acd1c8746','5501dbedc785fe4','5509671b4e81a07','','','','','','','2015-03-22 10:09:16','globeadmin','2015-03-22 10:09:16','globeadmin','2018-01-09 18:50:57','globeadmin'),('550e7e3abe4286a','5501dbedc785fe4','550dbae55f33b5f','','','','','','','2015-03-22 00:00:00','globeadmin','2015-03-22 00:00:00','globeadmin','2018-01-09 18:51:02','globeadmin'),('550e7ffdc322a58','547de3e001028e8','5509671b4e81a07','','','','','','','2015-03-22 10:40:29','globeadmin','2015-03-22 10:40:29','globeadmin','2019-11-06 15:15:02','globeadmin'),('550e7ffdcce7fae','547de3e001028e8','54707c8612b1b6b','','','','','','','2015-03-22 10:40:29','globeadmin','2015-03-22 10:40:29','globeadmin','2019-11-06 15:15:04','globeadmin'),('550e853e0c095f3','547de3e001028e8','550dbae55f33b5f','','','','','','','2015-03-22 11:02:54','globeadmin','2015-03-22 11:02:54','globeadmin','2019-11-06 15:15:04','globeadmin'),('5512f6f647e2c37','547de3e001028e8','55127aebdf42446','','','','','','','2015-03-25 19:57:10','globeadmin','2015-03-25 19:57:10','globeadmin','2019-11-06 15:15:02','globeadmin'),('5512f7b57b28fed','5501dbedc785fe4','55127aebdf42446','','','','','','','2015-03-25 00:00:00','globeadmin','2015-03-25 00:00:00','globeadmin','2018-01-09 18:50:58','globeadmin'),('55182db5543432d','547de3fe0d36089','551821232f9553f','','','','','','','2015-03-29 19:52:05','globeadmin','2015-03-29 19:52:05','globeadmin','2019-07-01 11:06:56','globeadmin'),('55182e0c236061e','547de3fe0d36089','5509671b4e81a07','','','','','','','2015-03-29 19:53:32','globeadmin','2015-03-29 19:53:32','globeadmin','2019-07-01 11:06:55','globeadmin'),('55182e0c2d25a5b','547de3fe0d36089','550dbae55f33b5f','','','','','','','2015-03-29 19:53:32','globeadmin','2015-03-29 19:53:32','globeadmin','2019-07-01 11:06:58','globeadmin'),('551adadb6d9c799','5501dbedc785fe4','551a34a930825c0','','','','','','','2015-03-31 00:00:00','globeadmin','2015-03-31 00:00:00','globeadmin','2018-01-09 18:51:03','globeadmin'),('551d03615e18d26','5501dbedc785fe4','551ce09c2fb5d12','','','','','','','2015-04-02 00:00:00','globeadmin','2015-04-02 00:00:00','globeadmin','2015-04-02 00:00:00','globeadmin'),('5522c642afafdc0','5501dbedc785fe4','55222f79d342b66','','','','','','','2015-04-06 00:00:00','globeadmin','2015-04-06 00:00:00','globeadmin','2018-01-09 18:51:03','globeadmin'),('5522c7964927479','5501dbedc785fe4','551821232f9553f','','','','','','','2015-04-06 00:00:00','globeadmin','2015-04-06 00:00:00','globeadmin','2018-01-09 18:50:58','globeadmin'),('5522c853d44edb8','547de3e001028e8','551821232f9553f','','','','','','','2015-04-06 20:54:27','globeadmin','2015-04-06 20:54:27','globeadmin','2019-11-06 15:15:02','globeadmin'),('5522c853de148c4','547de3e001028e8','55222f79d342b66','','','','','','','2015-04-06 20:54:27','globeadmin','2015-04-06 20:54:27','globeadmin','2019-11-06 15:15:05','globeadmin'),('55254ffb4f3b762','5501dbedc785fe4','5525421c67a48bc','','','','','','','2015-04-08 00:00:00','globeadmin','2015-04-08 00:00:00','globeadmin','2018-01-09 18:50:57','globeadmin'),('552621b1f09a2f3','5501dbedc785fe4','55261f6b593bdba','','','','','','','2015-04-09 00:00:00','globeadmin','2015-04-09 00:00:00','globeadmin','2018-01-09 18:50:58','globeadmin'),('552622194a95cde','547de3e001028e8','55261f6b593bdba','','','','','','','2015-04-09 09:54:17','globeadmin','2015-04-09 09:54:17','globeadmin','2019-11-06 15:15:02','globeadmin'),('552c134cd31f9c7','547de3e001028e8','551a34a930825c0','','','','','','','2015-04-13 22:04:44','globeadmin','2015-04-13 22:04:44','globeadmin','2019-11-06 15:15:04','globeadmin'),('552d1a764f908b9','5501dbedc785fe4','552cf4b2df9bcce','','','','','','','2015-04-14 00:00:00','globeadmin','2015-04-14 00:00:00','globeadmin','2018-01-09 18:50:58','globeadmin'),('552fb40a45a1b8e','547de3e001028e8','552cf4b2df9bcce','','','','','','','2015-04-16 16:07:22','globeadmin','2015-04-16 16:07:22','globeadmin','2019-11-06 15:15:02','globeadmin'),('55393c2738ff83d','547de3e001028e8','5538ff58cb7b4b8','','','','','','','2015-04-23 21:38:31','globeadmin','2015-04-23 21:38:31','globeadmin','2019-11-06 15:15:06','globeadmin'),('55393c4b98490b2','5501dbedc785fe4','5538ff58cb7b4b8','','','','','','','2015-04-23 00:00:00','globeadmin','2015-04-23 00:00:00','globeadmin','2018-01-09 18:51:06','globeadmin'),('553e8fd643318bc','5501dbedc785fe4','553e8f779634e69','','','','','','','2015-04-27 00:00:00','globeadmin','2015-04-27 00:00:00','globeadmin','2018-01-09 18:50:58','globeadmin'),('554524025133722','5501dbedc785fe4','554517bdc18334d','','','','','','','2015-05-02 00:00:00','globeadmin','2015-05-02 00:00:00','globeadmin','2018-01-09 18:51:05','globeadmin'),('5547b1e7c31e7d3','547de3e001028e8','55479f1837f6df0','','','','','','','2015-05-04 20:52:39','globeadmin','2015-05-04 20:52:39','globeadmin','2019-11-06 15:15:07','globeadmin'),('5547b5314b7d42c','5501dbedc785fe4','55479f1837f6df0','','','','','','','2015-05-04 00:00:00','globeadmin','2015-05-04 00:00:00','globeadmin','2018-01-09 18:51:09','globeadmin'),('5564d8de0e68d44','5501dbedc785fe4','5564d8431a9da4b','','','','','','','2015-05-26 00:00:00','globeadmin','2015-05-26 00:00:00','globeadmin','2018-01-09 18:50:59','globeadmin'),('560a52f30474666','547de3bee410196','54a433830716b84','','','','','','','2015-09-29 11:59:31','globeadmin','2015-09-29 11:59:31','globeadmin','2015-10-22 20:42:40','globeadmin'),('560a52f30bc7319','547de3bee410196','54a4107cddefff1','','','','','','','2015-09-29 11:59:31','globeadmin','2015-09-29 11:59:31','globeadmin','2022-01-31 16:18:40','globeadmin'),('560a52f31320d65','547de3bee410196','54ce7f0188a78ec','','','','','','','2015-09-29 11:59:31','globeadmin','2015-09-29 11:59:31','globeadmin','2022-01-31 16:18:40','globeadmin'),('560a52f31a6d5d0','547de3bee410196','54a26a8d05fa91d','','','','','','','2015-09-29 11:59:31','globeadmin','2015-09-29 11:59:31','globeadmin','2022-01-31 16:18:38','globeadmin'),('560a52f321c033f','547de3bee410196','54a312a5698c8f9','','','','','','','2015-09-29 11:59:31','globeadmin','2015-09-29 11:59:31','globeadmin','2022-01-31 16:18:41','globeadmin'),('560a52f32913645','547de3bee410196','5470b05b91e73a0','','','','','','','2015-09-29 11:59:31','globeadmin','2015-09-29 11:59:31','globeadmin','2022-01-31 16:18:40','globeadmin'),('560a52f330663f7','547de3bee410196','5470b3806384141','','','','','','','2015-09-29 11:59:31','globeadmin','2015-09-29 11:59:31','globeadmin','2022-01-31 16:18:41','globeadmin'),('560a52f337b9492','547de3bee410196','5470b6d7c79d3b9','','','','','','','2015-09-29 11:59:31','globeadmin','2015-09-29 11:59:31','globeadmin','2022-01-31 16:18:38','globeadmin'),('560a52f33f0c387','547de3bee410196','5470c07906bfd70','','','','','','','2015-09-29 11:59:31','globeadmin','2015-09-29 11:59:31','globeadmin','2022-01-31 16:18:40','globeadmin'),('560a52f3465f74d','547de3bee410196','54730f661a9b822','','','','','','','2015-09-29 11:59:31','globeadmin','2015-09-29 11:59:31','globeadmin','2022-01-31 16:18:37','globeadmin'),('560a52f34db231a','547de3bee410196','547081ceb3d2146','','','','','','','2015-09-29 11:59:31','globeadmin','2015-09-29 11:59:31','globeadmin','2022-01-31 16:18:40','globeadmin'),('560a52f35776527','547de3bee410196','5470802845f7427','','','','','','','2015-09-29 11:59:31','globeadmin','2015-09-29 11:59:31','globeadmin','2022-01-31 16:18:40','globeadmin'),('560a52f35ec94ee','547de3bee410196','54707c8612b1b6b','','','','','','','2015-09-29 11:59:31','globeadmin','2015-09-29 11:59:31','globeadmin','2022-01-31 16:18:39','globeadmin'),('560a52f3661c3e1','547de3bee410196','5470788787e004a','','','','','','','2015-09-29 11:59:31','globeadmin','2015-09-29 11:59:31','globeadmin','2022-01-31 16:18:39','globeadmin'),('560a52f36d6f687','547de3bee410196','54706f6b39c1b38','','','','','','','2015-09-29 11:59:31','globeadmin','2015-09-29 11:59:31','globeadmin','2022-01-31 16:18:39','globeadmin'),('560a52f374c232b','547de3bee410196','547070c91793d3b','','','','','','','2015-09-29 11:59:31','globeadmin','2015-09-29 11:59:31','globeadmin','2022-01-31 16:18:39','globeadmin'),('560a52f37c15338','547de3bee410196','54707442a2bcae4','','','','','','','2015-09-29 11:59:31','globeadmin','2015-09-29 11:59:31','globeadmin','2022-01-31 16:18:39','globeadmin'),('560a52f38368390','547de3bee410196','54706cd4f34daae','','','','','','','2015-09-29 11:59:31','globeadmin','2015-09-29 11:59:31','globeadmin','2022-01-31 16:18:38','globeadmin'),('560a52f38abb383','547de3bee410196','nuuser','','','','','','','2015-09-29 11:59:31','globeadmin','2015-09-29 11:59:31','globeadmin','2022-01-31 16:18:42','globeadmin'),('560a52f3920e28d','547de3bee410196','54705a95c4e91c2','','','','','','','2015-09-29 11:59:31','globeadmin','2015-09-29 11:59:31','globeadmin','2022-01-31 16:18:38','globeadmin'),('560a52f399616fe','547de3bee410196','54a65ecc3f14737','','','','','','','2015-09-29 11:59:31','globeadmin','2015-09-29 11:59:31','globeadmin','2022-01-31 16:18:38','globeadmin'),('560a52f3a0b43eb','547de3bee410196','54aa751b6567046','','','','','','','2015-09-29 11:59:31','globeadmin','2015-09-29 11:59:31','globeadmin','2022-01-31 16:18:41','globeadmin'),('560a52f3a80738a','547de3bee410196','54a52c3dcf3610b','','','','','','','2015-09-29 11:59:31','globeadmin','2015-09-29 11:59:31','globeadmin','2022-01-31 16:18:38','globeadmin'),('560a52f3af5a3eb','547de3bee410196','54736dab44212c7','','','','','','','2015-09-29 11:59:31','globeadmin','2015-09-29 11:59:31','globeadmin','2022-01-31 16:18:41','globeadmin'),('560a52f3b6ad31d','547de3bee410196','547372d029461f4','','','','','','','2015-09-29 11:59:31','globeadmin','2015-09-29 11:59:31','globeadmin','2022-01-31 16:18:41','globeadmin'),('560a52f3be004b3','547de3bee410196','5474c1d7bef6b64','','','','','','','2015-09-29 11:59:31','globeadmin','2015-09-29 11:59:31','globeadmin','2022-01-31 16:18:37','globeadmin'),('560a52f3c553381','547de3bee410196','547489b0d4efe7c','','','','','','','2015-09-29 11:59:31','globeadmin','2015-09-29 11:59:31','globeadmin','2022-01-31 16:18:38','globeadmin'),('560a52f3cca63f1','547de3bee410196','5476201e5a3d38f','','','','','','','2015-09-29 11:59:31','globeadmin','2015-09-29 11:59:31','globeadmin','2022-01-31 16:18:40','globeadmin'),('560a52f3d3f94b9','547de3bee410196','54b2d9dd8417a3d','','','','','','','2015-09-29 11:59:31','globeadmin','2015-09-29 11:59:31','globeadmin','2022-01-31 16:18:40','globeadmin'),('560a52f3db4c3ff','547de3bee410196','5478c7e75911cd4','','','','','','','2015-09-29 11:59:31','globeadmin','2015-09-29 11:59:31','globeadmin','2022-01-31 16:18:42','globeadmin'),('560a52f3e29f27b','547de3bee410196','547d6ec60ac6bdd','','','','','','','2015-09-29 11:59:31','globeadmin','2015-09-29 11:59:31','globeadmin','2022-01-31 16:18:40','globeadmin'),('560a52f3e9f2319','547de3bee410196','54d65f0144e61a3','','','','','','','2015-09-29 11:59:31','globeadmin','2015-09-29 11:59:31','globeadmin','2022-01-31 16:18:39','globeadmin'),('560a52f3f1452a9','547de3bee410196','5495dad1762dc2c','','','','','','','2015-09-29 11:59:31','globeadmin','2015-09-29 11:59:31','globeadmin','2022-01-31 16:18:39','globeadmin'),('560a52f40474294','547de3bee410196','54df1259eb4def9','','','','','','','2015-09-29 11:59:32','globeadmin','2015-09-29 11:59:32','globeadmin','2022-01-31 16:18:41','globeadmin'),('560a52f40bc733f','547de3bee410196','54df1dbf0f931e5','','','','','','','2015-09-29 11:59:32','globeadmin','2015-09-29 11:59:32','globeadmin','2022-01-31 16:18:40','globeadmin'),('560a52f4131a4c2','547de3bee410196','54df20f94548357','','','','','','','2015-09-29 11:59:32','globeadmin','2015-09-29 11:59:32','globeadmin','2022-01-31 16:18:41','globeadmin'),('560a52f41a6e168','547de3bee410196','5501db35db0c716','','','','','','','2015-09-29 11:59:32','globeadmin','2015-09-29 11:59:32','globeadmin','2022-01-31 16:18:40','globeadmin'),('560a52f421c0361','547de3bee410196','548338073921bfe','','','','','','','2015-09-29 11:59:32','globeadmin','2015-09-29 11:59:32','globeadmin','2022-01-31 16:18:41','globeadmin'),('560a52f4291337f','547de3bee410196','5509671b4e81a07','','','','','','','2015-09-29 11:59:32','globeadmin','2015-09-29 11:59:32','globeadmin','2022-01-31 16:18:37','globeadmin'),('560a52f430663e6','547de3bee410196','550dbae55f33b5f','','','','','','','2015-09-29 11:59:32','globeadmin','2015-09-29 11:59:32','globeadmin','2022-01-31 16:18:39','globeadmin'),('560a52f437b955c','547de3bee410196','55127aebdf42446','','','','','','','2015-09-29 11:59:32','globeadmin','2015-09-29 11:59:32','globeadmin','2022-01-31 16:18:37','globeadmin'),('560a52f43f0c3ad','547de3bee410196','551a34a930825c0','','','','','','','2015-09-29 11:59:32','globeadmin','2015-09-29 11:59:32','globeadmin','2022-01-31 16:18:39','globeadmin'),('560a52f4465f306','547de3bee410196','551ce09c2fb5d12','','','','','','','2015-09-29 11:59:32','globeadmin','2015-09-29 11:59:32','globeadmin','2015-09-29 11:59:32','globeadmin'),('560a52f44db232b','547de3bee410196','55222f79d342b66','','','','','','','2015-09-29 11:59:32','globeadmin','2015-09-29 11:59:32','globeadmin','2022-01-31 16:18:39','globeadmin'),('560a52f455054a9','547de3bee410196','551821232f9553f','','','','','','','2015-09-29 11:59:32','globeadmin','2015-09-29 11:59:32','globeadmin','2022-01-31 16:18:37','globeadmin'),('560a52f45c58890','547de3bee410196','5525421c67a48bc','','','','','','','2015-09-29 11:59:32','globeadmin','2015-09-29 11:59:32','globeadmin','2022-01-31 16:18:37','globeadmin'),('560a52f463ab374','547de3bee410196','55261f6b593bdba','','','','','','','2015-09-29 11:59:32','globeadmin','2015-09-29 11:59:32','globeadmin','2022-01-31 16:18:37','globeadmin'),('560a52f46afe2f4','547de3bee410196','552cf4b2df9bcce','','','','','','','2015-09-29 11:59:32','globeadmin','2015-09-29 11:59:32','globeadmin','2022-01-31 16:18:37','globeadmin'),('560a52f47251376','547de3bee410196','5538ff58cb7b4b8','','','','','','','2015-09-29 11:59:32','globeadmin','2015-09-29 11:59:32','globeadmin','2022-01-31 16:18:39','globeadmin'),('560a52f479a44dd','547de3bee410196','553e8f779634e69','','','','','','','2015-09-29 11:59:32','globeadmin','2015-09-29 11:59:32','globeadmin','2022-01-31 16:18:37','globeadmin'),('560a52f480f74d1','547de3bee410196','554517bdc18334d','','','','','','','2015-09-29 11:59:32','globeadmin','2015-09-29 11:59:32','globeadmin','2022-01-31 16:18:39','globeadmin'),('560a52f4884a5d6','547de3bee410196','55479f1837f6df0','','','','','','','2015-09-29 11:59:32','globeadmin','2015-09-29 11:59:32','globeadmin','2022-01-31 16:18:40','globeadmin'),('560a52f48f9d365','547de3bee410196','5564d8431a9da4b','','','','','','','2015-09-29 11:59:32','globeadmin','2015-09-29 11:59:32','globeadmin','2022-01-31 16:18:38','globeadmin'),('56140ba45258357','5501dbedc785fe4','5613deecec28ad6','','','','','','','2015-10-06 00:00:00','globeadmin','2015-10-06 00:00:00','globeadmin','2018-01-09 18:51:02','globeadmin'),('561820c2362f7c2','547de3bee410196','5613deecec28ad6','','','','','','','2015-10-09 23:17:06','globeadmin','2015-10-09 23:17:06','globeadmin','2022-01-31 16:18:38','globeadmin'),('561820ca8ba2bb5','5601afbc23dfb00','54a433830716b84','','','','','','','2015-10-09 23:17:14','globeadmin','2015-10-09 23:17:14','globeadmin','2015-10-22 20:44:02','globeadmin'),('561820ca92f574d','5601afbc23dfb00','54a4107cddefff1','','','','','','','2015-10-09 23:17:14','globeadmin','2015-10-09 23:17:14','globeadmin','2018-11-20 14:42:07','globeadmin'),('561820ca9a48871','5601afbc23dfb00','54ce7f0188a78ec','','','','','','','2015-10-09 23:17:14','globeadmin','2015-10-09 23:17:14','globeadmin','2018-11-20 14:42:08','globeadmin'),('561820caa19b6b2','5601afbc23dfb00','54a26a8d05fa91d','','','','','','','2015-10-09 23:17:14','globeadmin','2015-10-09 23:17:14','globeadmin','2018-11-20 14:42:02','globeadmin'),('561820caa8ee9a3','5601afbc23dfb00','54a312a5698c8f9','','','','','','','2015-10-09 23:17:14','globeadmin','2015-10-09 23:17:14','globeadmin','2018-11-20 14:42:10','globeadmin'),('561820cab041634','5601afbc23dfb00','5470b05b91e73a0','','','','','','','2015-10-09 23:17:14','globeadmin','2015-10-09 23:17:14','globeadmin','2018-11-20 14:42:07','globeadmin'),('561820cab7949f2','5601afbc23dfb00','5470b3806384141','','','','','','','2015-10-09 23:17:14','globeadmin','2015-10-09 23:17:14','globeadmin','2018-11-20 14:42:12','globeadmin'),('561820cabee7748','5601afbc23dfb00','5470b6d7c79d3b9','','','','','','','2015-10-09 23:17:14','globeadmin','2015-10-09 23:17:14','globeadmin','2018-11-20 14:42:00','globeadmin'),('561820cac63a61c','5601afbc23dfb00','5470c07906bfd70','','','','','','','2015-10-09 23:17:14','globeadmin','2015-10-09 23:17:14','globeadmin','2018-11-20 14:42:06','globeadmin'),('561820cacd8d6d3','5601afbc23dfb00','54730f661a9b822','','','','','','','2015-10-09 23:17:14','globeadmin','2015-10-09 23:17:14','globeadmin','2018-11-20 14:41:58','globeadmin'),('561820cad4e06dd','5601afbc23dfb00','547081ceb3d2146','','','','','','','2015-10-09 23:17:14','globeadmin','2015-10-09 23:17:14','globeadmin','2018-11-20 14:42:06','globeadmin'),('561820cadc33688','5601afbc23dfb00','5470802845f7427','','','','','','','2015-10-09 23:17:14','globeadmin','2015-10-09 23:17:14','globeadmin','2018-11-20 14:42:06','globeadmin'),('561820cae386689','5601afbc23dfb00','54707c8612b1b6b','','','','','','','2015-10-09 23:17:14','globeadmin','2015-10-09 23:17:14','globeadmin','2018-11-20 14:42:02','globeadmin'),('561820caead97a9','5601afbc23dfb00','5470788787e004a','','','','','','','2015-10-09 23:17:14','globeadmin','2015-10-09 23:17:14','globeadmin','2018-11-20 14:42:02','globeadmin'),('561820caf22c664','5601afbc23dfb00','54706f6b39c1b38','','','','','','','2015-10-09 23:17:14','globeadmin','2015-10-09 23:17:14','globeadmin','2018-11-20 14:42:02','globeadmin'),('561820cb055b906','5601afbc23dfb00','547070c91793d3b','','','','','','','2015-10-09 23:17:15','globeadmin','2015-10-09 23:17:15','globeadmin','2018-11-20 14:42:02','globeadmin'),('561820cb0caf0df','5601afbc23dfb00','54707442a2bcae4','','','','','','','2015-10-09 23:17:15','globeadmin','2015-10-09 23:17:15','globeadmin','2018-11-20 14:42:05','globeadmin'),('561820cb1401696','5601afbc23dfb00','54706cd4f34daae','','','','','','','2015-10-09 23:17:15','globeadmin','2015-10-09 23:17:15','globeadmin','2018-11-20 14:42:01','globeadmin'),('561820cb1b5463f','5601afbc23dfb00','nuuser','','','','','','','2015-10-09 23:17:15','globeadmin','2015-10-09 23:17:15','globeadmin','2018-11-20 14:42:12','globeadmin'),('561820cb22a7696','5601afbc23dfb00','54705a95c4e91c2','','','','','','','2015-10-09 23:17:15','globeadmin','2015-10-09 23:17:15','globeadmin','2018-11-20 14:42:00','globeadmin'),('561820cb29fa688','5601afbc23dfb00','54a65ecc3f14737','','','','','','','2015-10-09 23:17:15','globeadmin','2015-10-09 23:17:15','globeadmin','2018-11-20 14:42:00','globeadmin'),('561820cb314d524','5601afbc23dfb00','54aa751b6567046','','','','','','','2015-10-09 23:17:15','globeadmin','2015-10-09 23:17:15','globeadmin','2018-11-20 14:42:09','globeadmin'),('561820cb38a070e','5601afbc23dfb00','54a52c3dcf3610b','','','','','','','2015-10-09 23:17:15','globeadmin','2015-10-09 23:17:15','globeadmin','2018-11-20 14:42:02','globeadmin'),('561820cb3ff3771','5601afbc23dfb00','54736dab44212c7','','','','','','','2015-10-09 23:17:15','globeadmin','2015-10-09 23:17:15','globeadmin','2018-11-20 14:42:10','globeadmin'),('561820cb4747842','5601afbc23dfb00','547372d029461f4','','','','','','','2015-10-09 23:17:15','globeadmin','2015-10-09 23:17:15','globeadmin','2018-11-20 14:42:10','globeadmin'),('561820cb4e996cd','5601afbc23dfb00','5474c1d7bef6b64','','','','','','','2015-10-09 23:17:15','globeadmin','2015-10-09 23:17:15','globeadmin','2018-11-20 14:41:57','globeadmin'),('561820cb55ec606','5601afbc23dfb00','547489b0d4efe7c','','','','','','','2015-10-09 23:17:15','globeadmin','2015-10-09 23:17:15','globeadmin','2018-11-20 14:41:59','globeadmin'),('561820cb5d3f5a3','5601afbc23dfb00','5476201e5a3d38f','','','','','','','2015-10-09 23:17:15','globeadmin','2015-10-09 23:17:15','globeadmin','2018-11-20 14:42:09','globeadmin'),('561820cb649260e','5601afbc23dfb00','54b2d9dd8417a3d','','','','','','','2015-10-09 23:17:15','globeadmin','2015-10-09 23:17:15','globeadmin','2018-11-20 14:42:07','globeadmin'),('561820cb6be5abd','5601afbc23dfb00','5478c7e75911cd4','','','','','','','2015-10-09 23:17:15','globeadmin','2015-10-09 23:17:15','globeadmin','2018-11-20 14:42:12','globeadmin'),('561820cb73386dd','5601afbc23dfb00','547d6ec60ac6bdd','','','','','','','2015-10-09 23:17:15','globeadmin','2015-10-09 23:17:15','globeadmin','2018-11-20 14:42:08','globeadmin'),('561820cb7a8b822','5601afbc23dfb00','54d65f0144e61a3','','','','','','','2015-10-09 23:17:15','globeadmin','2015-10-09 23:17:15','globeadmin','2018-11-20 14:42:05','globeadmin'),('561820cb81de644','5601afbc23dfb00','5495dad1762dc2c','','','','','','','2015-10-09 23:17:15','globeadmin','2015-10-09 23:17:15','globeadmin','2018-11-20 14:42:06','globeadmin'),('561820cb893152b','5601afbc23dfb00','54df1259eb4def9','','','','','','','2015-10-09 23:17:15','globeadmin','2015-10-09 23:17:15','globeadmin','2018-11-20 14:42:09','globeadmin'),('561820cb908469b','5601afbc23dfb00','54df1dbf0f931e5','','','','','','','2015-10-09 23:17:15','globeadmin','2015-10-09 23:17:15','globeadmin','2018-11-20 14:42:09','globeadmin'),('561820cb97d78de','5601afbc23dfb00','54df20f94548357','','','','','','','2015-10-09 23:17:15','globeadmin','2015-10-09 23:17:15','globeadmin','2018-11-20 14:42:12','globeadmin'),('561820cb9f2a6c6','5601afbc23dfb00','5501db35db0c716','','','','','','','2015-10-09 23:17:15','globeadmin','2015-10-09 23:17:15','globeadmin','2018-11-20 14:42:08','globeadmin'),('561820cba67d5a6','5601afbc23dfb00','54f735c7d56625f','','','','','','','2015-10-09 23:17:15','globeadmin','2015-10-09 23:17:15','globeadmin','2018-11-20 14:42:07','globeadmin'),('561820cbadd0624','5601afbc23dfb00','548338073921bfe','','','','','','','2015-10-09 23:17:15','globeadmin','2015-10-09 23:17:15','globeadmin','2018-11-20 14:42:11','globeadmin'),('561820cbb5236f0','5601afbc23dfb00','5509671b4e81a07','','','','','','','2015-10-09 23:17:15','globeadmin','2015-10-09 23:17:15','globeadmin','2018-11-20 14:41:57','globeadmin'),('561820cbbc76782','5601afbc23dfb00','550dbae55f33b5f','','','','','','','2015-10-09 23:17:15','globeadmin','2015-10-09 23:17:15','globeadmin','2018-11-20 14:42:02','globeadmin'),('561820cbc3c97ef','5601afbc23dfb00','55127aebdf42446','','','','','','','2015-10-09 23:17:15','globeadmin','2015-10-09 23:17:15','globeadmin','2018-11-20 14:41:58','globeadmin'),('561820cbcb1c6b8','5601afbc23dfb00','551a34a930825c0','','','','','','','2015-10-09 23:17:15','globeadmin','2015-10-09 23:17:15','globeadmin','2018-11-20 14:42:02','globeadmin'),('561820cbd26f681','5601afbc23dfb00','551ce09c2fb5d12','','','','','','','2015-10-09 23:17:15','globeadmin','2015-10-09 23:17:15','globeadmin','2015-10-09 23:17:15','globeadmin'),('561820cbd9c26fb','5601afbc23dfb00','55222f79d342b66','','','','','','','2015-10-09 23:17:15','globeadmin','2015-10-09 23:17:15','globeadmin','2018-11-20 14:42:02','globeadmin'),('561820cbe115607','5601afbc23dfb00','551821232f9553f','','','','','','','2015-10-09 23:17:15','globeadmin','2015-10-09 23:17:15','globeadmin','2018-11-20 14:41:58','globeadmin'),('561820cbe86851f','5601afbc23dfb00','5525421c67a48bc','','','','','','','2015-10-09 23:17:15','globeadmin','2015-10-09 23:17:15','globeadmin','2018-11-20 14:41:57','globeadmin'),('561820cbefbb7c4','5601afbc23dfb00','55261f6b593bdba','','','','','','','2015-10-09 23:17:15','globeadmin','2015-10-09 23:17:15','globeadmin','2018-11-20 14:41:57','globeadmin'),('561820cc02ea716','5601afbc23dfb00','552cf4b2df9bcce','','','','','','','2015-10-09 23:17:16','globeadmin','2015-10-09 23:17:16','globeadmin','2018-11-20 14:41:57','globeadmin'),('561820cc0a3d6fb','5601afbc23dfb00','5538ff58cb7b4b8','','','','','','','2015-10-09 23:17:16','globeadmin','2015-10-09 23:17:16','globeadmin','2018-11-20 14:42:05','globeadmin'),('561820cc1190626','5601afbc23dfb00','553e8f779634e69','','','','','','','2015-10-09 23:17:16','globeadmin','2015-10-09 23:17:16','globeadmin','2018-11-20 14:41:58','globeadmin'),('561820cc18e364e','5601afbc23dfb00','554517bdc18334d','','','','','','','2015-10-09 23:17:16','globeadmin','2015-10-09 23:17:16','globeadmin','2018-11-20 14:42:05','globeadmin'),('561820cc20366b7','5601afbc23dfb00','55479f1837f6df0','','','','','','','2015-10-09 23:17:16','globeadmin','2015-10-09 23:17:16','globeadmin','2018-11-20 14:42:09','globeadmin'),('561820cc27897f2','5601afbc23dfb00','5564d8431a9da4b','','','','','','','2015-10-09 23:17:16','globeadmin','2015-10-09 23:17:16','globeadmin','2018-11-20 14:41:58','globeadmin'),('561820cc2edc633','5601afbc23dfb00','5613deecec28ad6','','','','','','','2015-10-09 23:17:16','globeadmin','2015-10-09 23:17:16','globeadmin','2018-11-20 14:42:01','globeadmin'),('562011f390a2a5a','5501dbedc785fe4','562003aa49d836a','','','','','','','2015-10-15 23:52:03','globeadmin','2015-10-15 23:52:03','globeadmin','2018-01-09 18:51:01','globeadmin'),('562011efa42aa94','547de3bee410196','562003aa49d836a','','','','','','','2015-10-15 23:51:59','globeadmin','2015-10-15 23:51:59','globeadmin','2022-01-31 16:18:38','globeadmin'),('561928e0c8b108a','5501dbedc785fe4','5618f5cc92f9c9e','','','','','','','2015-10-10 18:04:00','globeadmin','2015-10-10 18:04:00','globeadmin','2018-01-09 18:51:03','globeadmin'),('561928e0d002610','5501dbedc785fe4','561922d0a8f28d2','','','','','','','2015-10-10 18:04:00','globeadmin','2015-10-10 18:04:00','globeadmin','2018-01-09 18:51:03','globeadmin'),('561928e4ed4ea45','547de3bee410196','5618f5cc92f9c9e','','','','','','','2015-10-10 18:04:04','globeadmin','2015-10-10 18:04:04','globeadmin','2022-01-31 16:18:39','globeadmin'),('561928e5007df50','547de3bee410196','561922d0a8f28d2','','','','','','','2015-10-10 18:04:05','globeadmin','2015-10-10 18:04:05','globeadmin','2022-01-31 16:18:39','globeadmin'),('561928e9ed506fa','5601afbc23dfb00','5618f5cc92f9c9e','','','','','','','2015-10-10 18:04:09','globeadmin','2015-10-10 18:04:09','globeadmin','2018-11-20 14:42:03','globeadmin'),('561928ea007d710','5601afbc23dfb00','561922d0a8f28d2','','','','','','','2015-10-10 18:04:10','globeadmin','2015-10-10 18:04:10','globeadmin','2018-11-20 14:42:03','globeadmin'),('56192cda6be9917','561928b27d0261b','56192a97203c280','','','','','','','2015-10-10 18:20:58','globeadmin','2015-10-10 18:20:58','globeadmin','2015-10-10 18:20:58','globeadmin'),('562002fa0099381','5501dbedc785fe4','561fe384a42ad55','','','','','','','2015-10-15 22:48:10','globeadmin','2015-10-15 22:48:10','globeadmin','2018-01-09 18:51:06','globeadmin'),('562011f64011dc0','5601afbc23dfb00','562003aa49d836a','','','','','','','2015-10-15 23:52:06','globeadmin','2015-10-15 23:52:06','globeadmin','2018-11-20 14:42:01','globeadmin'),('562002fccdac066','5601afbc23dfb00','561fe384a42ad55','','','','','','','2015-10-15 22:48:12','globeadmin','2015-10-15 22:48:12','globeadmin','2018-11-20 14:42:06','globeadmin'),('562002f5d76fc71','547de3bee410196','561fe384a42ad55','','','','','','','2015-10-15 22:48:05','globeadmin','2015-10-15 22:48:05','globeadmin','2022-01-31 16:18:39','globeadmin'),('56192d53eadf0fc','547de3bee410196','56192a12e86c93e','','','','','','','2015-10-10 18:22:59','globeadmin','2015-10-10 18:22:59','globeadmin','2022-01-31 16:18:39','globeadmin'),('56192d53f2307a9','547de3bee410196','56192a97203c280','','','','','','','2015-10-10 18:22:59','globeadmin','2015-10-10 18:22:59','globeadmin','2015-10-10 18:22:59','globeadmin'),('56192d54055f76b','547de3bee410196','56192b05ed5032f','','','','','','','2015-10-10 18:23:00','globeadmin','2015-10-10 18:23:00','globeadmin','2022-01-31 16:18:39','globeadmin'),('56192d540cb2a56','547de3bee410196','56192be786c61d7','','','','','','','2015-10-10 18:23:00','globeadmin','2015-10-10 18:23:00','globeadmin','2022-01-31 16:18:39','globeadmin'),('56192d541405934','547de3bee410196','56192c691b58858','','','','','','','2015-10-10 18:23:00','globeadmin','2015-10-10 18:23:00','globeadmin','2022-01-31 16:18:39','globeadmin'),('56192d59c3cd974','5501dbedc785fe4','56192a12e86c93e','','','','','','','2015-10-10 18:23:05','globeadmin','2015-10-10 18:23:05','globeadmin','2018-01-09 18:51:03','globeadmin'),('56192d59cb20ad9','5501dbedc785fe4','56192a97203c280','','','','','','','2015-10-10 18:23:05','globeadmin','2015-10-10 18:23:05','globeadmin','2015-10-10 18:23:05','globeadmin'),('56192d59d273848','5501dbedc785fe4','56192b05ed5032f','','','','','','','2015-10-10 18:23:05','globeadmin','2015-10-10 18:23:05','globeadmin','2018-01-09 18:51:03','globeadmin'),('56192d59d9c6740','5501dbedc785fe4','56192be786c61d7','','','','','','','2015-10-10 18:23:05','globeadmin','2015-10-10 18:23:05','globeadmin','2018-01-09 18:51:03','globeadmin'),('56192d59e11974f','5501dbedc785fe4','56192c691b58858','','','','','','','2015-10-10 18:23:05','globeadmin','2015-10-10 18:23:05','globeadmin','2018-01-09 18:51:03','globeadmin'),('56192d5dc8b10e2','5601afbc23dfb00','56192a12e86c93e','','','','','','','2015-10-10 18:23:09','globeadmin','2015-10-10 18:23:09','globeadmin','2018-11-20 14:42:03','globeadmin'),('56192d5dd0028c4','5601afbc23dfb00','56192a97203c280','','','','','','','2015-10-10 18:23:09','globeadmin','2015-10-10 18:23:09','globeadmin','2015-10-10 18:23:09','globeadmin'),('56192d5dd755772','5601afbc23dfb00','56192b05ed5032f','','','','','','','2015-10-10 18:23:09','globeadmin','2015-10-10 18:23:09','globeadmin','2018-11-20 14:42:03','globeadmin'),('56192d5ddea871c','5601afbc23dfb00','56192be786c61d7','','','','','','','2015-10-10 18:23:09','globeadmin','2015-10-10 18:23:09','globeadmin','2018-11-20 14:42:03','globeadmin'),('56192d5de5fbcd2','5601afbc23dfb00','56192c691b58858','','','','','','','2015-10-10 18:23:09','globeadmin','2015-10-10 18:23:09','globeadmin','2018-11-20 14:42:03','globeadmin'),('5623793057f135e','547de3e001028e8','56192a97203c280','','','','','','','2015-10-18 13:49:20','globeadmin','2015-10-18 13:49:20','globeadmin','2015-10-18 13:49:20','globeadmin'),('561f23f8ce52e09','5501dbedc785fe4','561a90ab2457a16','','','','','','','2015-10-15 06:56:40','globeadmin','2015-10-15 06:56:40','globeadmin','2018-01-09 18:51:07','globeadmin'),('561f23ff5b92c37','547de3bee410196','561a90ab2457a16','','','','','','','2015-10-15 06:56:47','globeadmin','2015-10-15 06:56:47','globeadmin','2022-01-31 16:18:40','globeadmin'),('561f2403914a116','5601afbc23dfb00','561a90ab2457a16','','','','','','','2015-10-15 06:56:51','globeadmin','2015-10-15 06:56:51','globeadmin','2018-11-20 14:42:06','globeadmin'),('56215cbd0e000ac','547de3bee410196','5621401c573dfb8','','','','','','','2015-10-16 23:23:25','globeadmin','2015-10-16 23:23:25','globeadmin','2022-01-31 16:18:38','globeadmin'),('561f2b91b10586e','547de3bee410196','5616c3a5f23ccc8','','','','','','','2015-10-15 07:29:05','globeadmin','2015-10-15 07:29:05','globeadmin','2022-01-31 16:18:38','globeadmin'),('561f2b984f5ee3f','5501dbedc785fe4','5616c3a5f23ccc8','','','','','','','2015-10-15 07:29:12','globeadmin','2015-10-15 07:29:12','globeadmin','2018-01-09 18:51:00','globeadmin'),('561f2b9d82a275f','5601afbc23dfb00','5616c3a5f23ccc8','','','','','','','2015-10-15 07:29:17','globeadmin','2015-10-15 07:29:17','globeadmin','2018-11-20 14:41:59','globeadmin'),('56215cc817c424d','5501dbedc785fe4','5621401c573dfb8','','','','','','','2015-10-16 23:23:36','globeadmin','2015-10-16 23:23:36','globeadmin','2018-01-09 18:51:00','globeadmin'),('56215ccb54cd1be','5601afbc23dfb00','5621401c573dfb8','','','','','','','2015-10-16 23:23:39','globeadmin','2015-10-16 23:23:39','globeadmin','2018-11-20 14:41:59','globeadmin'),('562245adab8ce78','5601afbc23dfb00','562229979f567be','','','','','','','2015-10-17 15:57:17','globeadmin','2015-10-17 15:57:17','globeadmin','2018-11-20 14:42:06','globeadmin'),('56292082cd5e698','5501dbedc785fe4','562229979f567be','','','','','','','2015-10-22 20:44:34','globeadmin','2015-10-22 20:44:34','globeadmin','2018-01-09 18:51:06','globeadmin'),('56e58c876045bdd','547de3bee410196','56e553b8d3afa56','','','','','','','2016-03-13 17:51:35','globeadmin','2016-03-13 17:51:35','globeadmin','2022-01-31 16:18:40','globeadmin'),('56ec73672c84636','547de3fe0d36089','56ea588f03c272b','','','','','','','2016-03-18 23:30:15','globeadmin','2016-03-18 23:30:15','globeadmin','2019-07-01 11:06:57','globeadmin'),('562951c4ef8b915','547de3bee410196','562362d2ef4f556','','','','','','','2015-10-23 00:14:44','globeadmin','2015-10-23 00:14:44','globeadmin','2022-01-31 16:18:40','globeadmin'),('562951cdeaa9922','5501dbedc785fe4','562362d2ef4f556','','','','','','','2015-10-23 00:14:53','globeadmin','2015-10-23 00:14:53','globeadmin','2018-01-09 18:51:08','globeadmin'),('562951d25a9ecb9','5601afbc23dfb00','562362d2ef4f556','','','','','','','2015-10-23 00:14:58','globeadmin','2015-10-23 00:14:58','globeadmin','2018-11-20 14:42:08','globeadmin'),('562951d902bacc1','547de3e001028e8','562362d2ef4f556','','','','','','','2015-10-23 00:15:05','globeadmin','2015-10-23 00:15:05','globeadmin','2019-11-06 15:15:06','globeadmin'),('5629b06e2cf6d20','547de3e001028e8','5627e58b8ed5f6d','','','','','','','2015-10-23 06:58:38','globeadmin','2015-10-23 06:58:38','globeadmin','2019-11-06 15:15:05','globeadmin'),('5629b075d7dc98f','5501dbedc785fe4','5627e58b8ed5f6d','','','','','','','2015-10-23 06:58:45','globeadmin','2015-10-23 06:58:45','globeadmin','2018-01-09 18:51:04','globeadmin'),('5629b07b93820e3','5601afbc23dfb00','5627e58b8ed5f6d','','','','','','','2015-10-23 06:58:51','globeadmin','2015-10-23 06:58:51','globeadmin','2018-11-20 14:42:03','globeadmin'),('5629b0820ac8ac2','547de3bee410196','5627e58b8ed5f6d','','','','','','','2015-10-23 06:58:58','globeadmin','2015-10-23 06:58:58','globeadmin','2022-01-31 16:18:39','globeadmin'),('562fc3015fdabe6','547de3bee410196','562e770b79c0722','','','','','','','2015-10-27 20:31:29','globeadmin','2015-10-27 20:31:29','globeadmin','2022-01-31 16:18:40','globeadmin'),('562fc3055887ae7','547de3e001028e8','562e770b79c0722','','','','','','','2015-10-27 20:31:33','globeadmin','2015-10-27 20:31:33','globeadmin','2019-11-06 15:15:07','globeadmin'),('562fc30c1b7eb00','5501dbedc785fe4','562e770b79c0722','','','','','','','2015-10-27 20:31:40','globeadmin','2015-10-27 20:31:40','globeadmin','2018-01-09 18:51:08','globeadmin'),('562fc30ebf11c65','5601afbc23dfb00','562e770b79c0722','','','','','','','2015-10-27 20:31:42','globeadmin','2015-10-27 20:31:42','globeadmin','2018-11-20 14:42:08','globeadmin'),('562fc8177f979e9','547de3bee410196','562d11f6d45ccf1','','','','','','','2015-10-27 20:53:11','globeadmin','2015-10-27 20:53:11','globeadmin','2022-01-31 16:18:39','globeadmin'),('562fc81e2a24bc9','547de3e001028e8','562d11f6d45ccf1','','','','','','','2015-10-27 20:53:18','globeadmin','2015-10-27 20:53:18','globeadmin','2019-11-06 15:15:05','globeadmin'),('562fc822bf11a4b','547de3fe0d36089','56192a97203c280','','','','','','','2015-10-27 20:53:22','globeadmin','2015-10-27 20:53:22','globeadmin','2015-10-27 20:53:22','globeadmin'),('562fc822c6652a7','547de3fe0d36089','562d11f6d45ccf1','','','','','','','2015-10-27 20:53:22','globeadmin','2015-10-27 20:53:22','globeadmin','2019-07-01 11:06:58','globeadmin'),('562fc8267d26a56','5501dbedc785fe4','562d11f6d45ccf1','','','','','','','2015-10-27 20:53:26','globeadmin','2015-10-27 20:53:26','globeadmin','2018-01-09 18:51:04','globeadmin'),('562fc8293659981','5601afbc23dfb00','562d11f6d45ccf1','','','','','','','2015-10-27 20:53:29','globeadmin','2015-10-27 20:53:29','globeadmin','2018-11-20 14:42:03','globeadmin'),('563137e247b206c','547de3bee410196','56312e4782e78b4','','','','','','','2015-10-28 23:02:26','globeadmin','2015-10-28 23:02:26','globeadmin','2022-01-31 16:18:40','globeadmin'),('563137e8342a7d1','5501dbedc785fe4','56312e4782e78b4','','','','','','','2015-10-28 23:02:32','globeadmin','2015-10-28 23:02:32','globeadmin','2018-01-09 18:51:08','globeadmin'),('563137eb405f18b','5601afbc23dfb00','56312e4782e78b4','','','','','','','2015-10-28 23:02:35','globeadmin','2015-10-28 23:02:35','globeadmin','2018-11-20 14:42:08','globeadmin'),('565b3409dcce076','547de3bee410196','565b05b5e424081','','','','','','','2015-11-29 19:21:13','globeadmin','2015-11-29 19:21:13','globeadmin','2022-01-31 16:18:39','globeadmin'),('565b3413bf8260a','5501dbedc785fe4','565b05b5e424081','','','','','','','2015-11-29 19:21:23','globeadmin','2015-11-29 19:21:23','globeadmin','2018-01-09 18:51:06','globeadmin'),('565b3416eb754f2','5601afbc23dfb00','565b05b5e424081','','','','','','','2015-11-29 19:21:26','globeadmin','2015-11-29 19:21:26','globeadmin','2018-11-20 14:42:06','globeadmin'),('56619d6213d43f7','547de3fe0d36089','566086607663544','','','','','','','2015-12-04 16:04:18','globeadmin','2015-12-04 16:04:18','globeadmin','2019-07-01 11:07:01','globeadmin'),('5688f6dee5c166f','5501dbedc785fe4','5684e68b302da76','','','','','','','2016-01-03 12:24:30','globeadmin','2016-01-03 12:24:30','globeadmin','2018-01-09 18:51:12','globeadmin'),('5688f6e673028ea','547de3bee410196','5684e68b302da76','','','','','','','2016-01-03 12:24:38','globeadmin','2016-01-03 12:24:38','globeadmin','2022-01-31 16:18:41','globeadmin'),('5688f6ec9ef5f60','5601afbc23dfb00','5684e68b302da76','','','','','','','2016-01-03 12:24:44','globeadmin','2016-01-03 12:24:44','globeadmin','2018-11-20 14:42:12','globeadmin'),('5688f75cab29a79','547de3bee410196','5688ee0218ad763','','','','','','','2016-01-03 12:26:36','globeadmin','2016-01-03 12:26:36','globeadmin','2022-01-31 16:18:38','globeadmin'),('5688f75cb27c788','547de3bee410196','568834bf97fe8a1','','','','','','','2016-01-03 12:26:36','globeadmin','2016-01-03 12:26:36','globeadmin','2022-01-31 16:18:38','globeadmin'),('5688f760cfc8991','5501dbedc785fe4','5688ee0218ad763','','','','','','','2016-01-03 12:26:40','globeadmin','2016-01-03 12:26:40','globeadmin','2018-01-09 18:51:00','globeadmin'),('5688f760d71b7bf','5501dbedc785fe4','568834bf97fe8a1','','','','','','','2016-01-03 12:26:40','globeadmin','2016-01-03 12:26:40','globeadmin','2018-01-09 18:51:01','globeadmin'),('5688f7659ef4d1f','5601afbc23dfb00','5688ee0218ad763','','','','','','','2016-01-03 12:26:45','globeadmin','2016-01-03 12:26:45','globeadmin','2018-11-20 14:42:00','globeadmin'),('5688f765a6477a3','5601afbc23dfb00','568834bf97fe8a1','','','','','','','2016-01-03 12:26:45','globeadmin','2016-01-03 12:26:45','globeadmin','2018-11-20 14:42:01','globeadmin'),('568949c99df929f','5689468794353da','54a433830716b84','','','','','','','2016-01-03 18:18:17','globeadmin','2016-01-03 18:18:17','globeadmin','2016-01-03 18:18:17','globeadmin'),('568949c9a54c613','5689468794353da','54a4107cddefff1','','','','','','','2016-01-03 18:18:17','globeadmin','2016-01-03 18:18:17','globeadmin','2016-02-09 20:37:57','globeadmin'),('568949c9ac9f29a','5689468794353da','54ce7f0188a78ec','','','','','','','2016-01-03 18:18:17','globeadmin','2016-01-03 18:18:17','globeadmin','2016-02-09 20:38:02','globeadmin'),('568949c9b3f22ff','5689468794353da','54a26a8d05fa91d','','','','','','','2016-01-03 18:18:17','globeadmin','2016-01-03 18:18:17','globeadmin','2016-02-09 20:37:57','globeadmin'),('568949c9bb45679','5689468794353da','54a312a5698c8f9','','','','','','','2016-01-03 18:18:17','globeadmin','2016-01-03 18:18:17','globeadmin','2016-02-09 20:38:03','globeadmin'),('568949c9c50927a','5689468794353da','5470b05b91e73a0','','','','','','','2016-01-03 18:18:17','globeadmin','2016-01-03 18:18:17','globeadmin','2016-02-09 20:38:01','globeadmin'),('568949c9cc5c4a2','5689468794353da','5470b3806384141','','','','','','','2016-01-03 18:18:17','globeadmin','2016-01-03 18:18:17','globeadmin','2016-02-09 20:38:03','globeadmin'),('568949c9d3af136','5689468794353da','5470b6d7c79d3b9','','','','','','','2016-01-03 18:18:17','globeadmin','2016-01-03 18:18:17','globeadmin','2016-02-09 20:37:56','globeadmin'),('568949c9db02dcf','5689468794353da','5470c07906bfd70','','','','','','','2016-01-03 18:18:17','globeadmin','2016-01-03 18:18:17','globeadmin','2016-02-09 20:38:00','globeadmin'),('568949c9e2552ba','5689468794353da','54730f661a9b822','','','','','','','2016-01-03 18:18:17','globeadmin','2016-01-03 18:18:17','globeadmin','2016-02-09 20:37:55','globeadmin'),('568949c9e9a8137','5689468794353da','547081ceb3d2146','','','','','','','2016-01-03 18:18:17','globeadmin','2016-01-03 18:18:17','globeadmin','2016-02-09 20:38:00','globeadmin'),('568949c9f0fb564','5689468794353da','5470802845f7427','','','','','','','2016-01-03 18:18:17','globeadmin','2016-01-03 18:18:17','globeadmin','2016-02-09 20:38:00','globeadmin'),('568949ca042a294','5689468794353da','54707c8612b1b6b','','','','','','','2016-01-03 18:18:18','globeadmin','2016-01-03 18:18:18','globeadmin','2016-02-09 20:37:58','globeadmin'),('568949ca0b7dccb','5689468794353da','5470788787e004a','','','','','','','2016-01-03 18:18:18','globeadmin','2016-01-03 18:18:18','globeadmin','2016-02-09 20:37:58','globeadmin'),('568949ca12d0209','5689468794353da','54706f6b39c1b38','','','','','','','2016-01-03 18:18:18','globeadmin','2016-01-03 18:18:18','globeadmin','2016-02-09 20:37:57','globeadmin'),('568949ca1a23393','5689468794353da','547070c91793d3b','','','','','','','2016-01-03 18:18:18','globeadmin','2016-01-03 18:18:18','globeadmin','2016-02-09 20:37:57','globeadmin'),('568949ca217618e','5689468794353da','54707442a2bcae4','','','','','','','2016-01-03 18:18:18','globeadmin','2016-01-03 18:18:18','globeadmin','2016-02-09 20:37:59','globeadmin'),('568949ca28c915a','5689468794353da','54706cd4f34daae','','','','','','','2016-01-03 18:18:18','globeadmin','2016-01-03 18:18:18','globeadmin','2016-02-09 20:37:57','globeadmin'),('568949ca301d424','5689468794353da','nuuser','','','','','','','2016-01-03 18:18:18','globeadmin','2016-01-03 18:18:18','globeadmin','2016-02-09 20:38:04','globeadmin'),('568949ca376f2c6','5689468794353da','54705a95c4e91c2','','','','','','','2016-01-03 18:18:18','globeadmin','2016-01-03 18:18:18','globeadmin','2016-02-09 20:37:56','globeadmin'),('568949ca3ec25d2','5689468794353da','54a65ecc3f14737','','','','','','','2016-01-03 18:18:18','globeadmin','2016-01-03 18:18:18','globeadmin','2016-02-09 20:37:56','globeadmin'),('568949ca46153cf','5689468794353da','54aa751b6567046','','','','','','','2016-01-03 18:18:18','globeadmin','2016-01-03 18:18:18','globeadmin','2016-02-09 20:38:02','globeadmin'),('568949ca4d685b8','5689468794353da','54a52c3dcf3610b','','','','','','','2016-01-03 18:18:18','globeadmin','2016-01-03 18:18:18','globeadmin','2016-02-09 20:37:57','globeadmin'),('568949ca54bb1d2','5689468794353da','54736dab44212c7','','','','','','','2016-01-03 18:18:18','globeadmin','2016-01-03 18:18:18','globeadmin','2016-02-09 20:38:03','globeadmin'),('568949ca5c0e2d5','5689468794353da','547372d029461f4','','','','','','','2016-01-03 18:18:18','globeadmin','2016-01-03 18:18:18','globeadmin','2016-02-09 20:38:03','globeadmin'),('568949ca63615a7','5689468794353da','5474c1d7bef6b64','','','','','','','2016-01-03 18:18:18','globeadmin','2016-01-03 18:18:18','globeadmin','2016-02-09 20:37:54','globeadmin'),('568949ca6ab45ae','5689468794353da','547489b0d4efe7c','','','','','','','2016-01-03 18:18:18','globeadmin','2016-01-03 18:18:18','globeadmin','2016-02-09 20:37:56','globeadmin'),('568949ca72072ff','5689468794353da','5476201e5a3d38f','','','','','','','2016-01-03 18:18:18','globeadmin','2016-01-03 18:18:18','globeadmin','2016-02-09 20:38:02','globeadmin'),('568949ca795a2bf','5689468794353da','54b2d9dd8417a3d','','','','','','','2016-01-03 18:18:18','globeadmin','2016-01-03 18:18:18','globeadmin','2016-02-09 20:38:01','globeadmin'),('568949ca80ad816','5689468794353da','5478c7e75911cd4','','','','','','','2016-01-03 18:18:18','globeadmin','2016-01-03 18:18:18','globeadmin','2016-02-09 20:38:03','globeadmin'),('568949ca880016f','5689468794353da','547d6ec60ac6bdd','','','','','','','2016-01-03 18:18:18','globeadmin','2016-01-03 18:18:18','globeadmin','2016-02-09 20:38:01','globeadmin'),('568949ca8f5326d','5689468794353da','54d65f0144e61a3','','','','','','','2016-01-03 18:18:18','globeadmin','2016-01-03 18:18:18','globeadmin','2016-02-09 20:37:59','globeadmin'),('568949ca96a657a','5689468794353da','5495dad1762dc2c','','','','','','','2016-01-03 18:18:18','globeadmin','2016-01-03 18:18:18','globeadmin','2016-02-09 20:38:00','globeadmin'),('568949ca9df91b9','5689468794353da','54df1259eb4def9','','','','','','','2016-01-03 18:18:18','globeadmin','2016-01-03 18:18:18','globeadmin','2016-02-09 20:38:02','globeadmin'),('568949caa54c242','5689468794353da','54df1dbf0f931e5','','','','','','','2016-01-03 18:18:18','globeadmin','2016-01-03 18:18:18','globeadmin','2016-02-09 20:38:02','globeadmin'),('568949caac9f183','5689468794353da','54df20f94548357','','','','','','','2016-01-03 18:18:18','globeadmin','2016-01-03 18:18:18','globeadmin','2016-02-09 20:38:03','globeadmin'),('568949cab3f21f0','5689468794353da','5501db35db0c716','','','','','','','2016-01-03 18:18:18','globeadmin','2016-01-03 18:18:18','globeadmin','2016-02-09 20:38:01','globeadmin'),('568949cabb4515c','5689468794353da','54f735c7d56625f','','','','','','','2016-01-03 18:18:18','globeadmin','2016-01-03 18:18:18','globeadmin','2016-02-09 20:38:01','globeadmin'),('568949cac29817a','5689468794353da','548338073921bfe','','','','','','','2016-01-03 18:18:18','globeadmin','2016-01-03 18:18:18','globeadmin','2016-02-09 20:38:03','globeadmin'),('568949cac9eb034','5689468794353da','5509671b4e81a07','','','','','','','2016-01-03 18:18:18','globeadmin','2016-01-03 18:18:18','globeadmin','2016-02-09 20:37:55','globeadmin'),('568949cad13e5a5','5689468794353da','550dbae55f33b5f','','','','','','','2016-01-03 18:18:18','globeadmin','2016-01-03 18:18:18','globeadmin','2016-02-09 20:37:58','globeadmin'),('568949cad8911dc','5689468794353da','55127aebdf42446','','','','','','','2016-01-03 18:18:18','globeadmin','2016-01-03 18:18:18','globeadmin','2016-02-09 20:37:55','globeadmin'),('568949cadfe41d2','5689468794353da','551a34a930825c0','','','','','','','2016-01-03 18:18:18','globeadmin','2016-01-03 18:18:18','globeadmin','2016-02-09 20:37:58','globeadmin'),('568949cae73715a','5689468794353da','551ce09c2fb5d12','','','','','','','2016-01-03 18:18:18','globeadmin','2016-01-03 18:18:18','globeadmin','2016-01-03 18:18:18','globeadmin'),('568949caee8a194','5689468794353da','55222f79d342b66','','','','','','','2016-01-03 18:18:18','globeadmin','2016-01-03 18:18:18','globeadmin','2016-02-09 20:37:58','globeadmin'),('568949cb01b93f1','5689468794353da','551821232f9553f','','','','','','','2016-01-03 18:18:19','globeadmin','2016-01-03 18:18:19','globeadmin','2016-02-09 20:37:55','globeadmin'),('568949cb090c18b','5689468794353da','5525421c67a48bc','','','','','','','2016-01-03 18:18:19','globeadmin','2016-01-03 18:18:19','globeadmin','2016-02-09 20:37:55','globeadmin'),('568949cb105f29e','5689468794353da','55261f6b593bdba','','','','','','','2016-01-03 18:18:19','globeadmin','2016-01-03 18:18:19','globeadmin','2016-02-09 20:37:55','globeadmin'),('568949cb17b216f','5689468794353da','552cf4b2df9bcce','','','','','','','2016-01-03 18:18:19','globeadmin','2016-01-03 18:18:19','globeadmin','2016-02-09 20:37:55','globeadmin'),('568949cb1f05292','5689468794353da','5538ff58cb7b4b8','','','','','','','2016-01-03 18:18:19','globeadmin','2016-01-03 18:18:19','globeadmin','2016-02-09 20:38:00','globeadmin'),('568949cb2658117','5689468794353da','553e8f779634e69','','','','','','','2016-01-03 18:18:19','globeadmin','2016-01-03 18:18:19','globeadmin','2016-02-09 20:37:55','globeadmin'),('568949cb2dabe9e','5689468794353da','554517bdc18334d','','','','','','','2016-01-03 18:18:19','globeadmin','2016-01-03 18:18:19','globeadmin','2016-02-09 20:37:59','globeadmin'),('568949cb34fe15f','5689468794353da','55479f1837f6df0','','','','','','','2016-01-03 18:18:19','globeadmin','2016-01-03 18:18:19','globeadmin','2016-02-09 20:38:02','globeadmin'),('568949cb3c52f84','5689468794353da','5564d8431a9da4b','','','','','','','2016-01-03 18:18:19','globeadmin','2016-01-03 18:18:19','globeadmin','2016-02-09 20:37:55','globeadmin'),('568949cb43a49fc','5689468794353da','5613deecec28ad6','','','','','','','2016-01-03 18:18:19','globeadmin','2016-01-03 18:18:19','globeadmin','2016-02-09 20:37:57','globeadmin'),('568949cb4af7270','5689468794353da','562003aa49d836a','','','','','','','2016-01-03 18:18:19','globeadmin','2016-01-03 18:18:19','globeadmin','2016-02-09 20:37:56','globeadmin'),('568949cb524a29b','5689468794353da','5618f5cc92f9c9e','','','','','','','2016-01-03 18:18:19','globeadmin','2016-01-03 18:18:19','globeadmin','2016-02-09 20:37:58','globeadmin'),('568949cb599d693','5689468794353da','561922d0a8f28d2','','','','','','','2016-01-03 18:18:19','globeadmin','2016-01-03 18:18:19','globeadmin','2016-02-09 20:37:58','globeadmin'),('568949cb60f0125','5689468794353da','561fe384a42ad55','','','','','','','2016-01-03 18:18:19','globeadmin','2016-01-03 18:18:19','globeadmin','2016-02-09 20:38:00','globeadmin'),('568949cb68431dd','5689468794353da','56192a12e86c93e','','','','','','','2016-01-03 18:18:19','globeadmin','2016-01-03 18:18:19','globeadmin','2016-02-09 20:37:59','globeadmin'),('568949cb6f9753c','5689468794353da','56192a97203c280','','','','','','','2016-01-03 18:18:19','globeadmin','2016-01-03 18:18:19','globeadmin','2016-01-03 18:18:19','globeadmin'),('568949cb76e93ed','5689468794353da','56192b05ed5032f','','','','','','','2016-01-03 18:18:19','globeadmin','2016-01-03 18:18:19','globeadmin','2016-02-09 20:37:58','globeadmin'),('568949cb7e3c249','5689468794353da','56192be786c61d7','','','','','','','2016-01-03 18:18:19','globeadmin','2016-01-03 18:18:19','globeadmin','2016-02-09 20:37:59','globeadmin'),('568949cb858f553','5689468794353da','56192c691b58858','','','','','','','2016-01-03 18:18:19','globeadmin','2016-01-03 18:18:19','globeadmin','2016-02-09 20:37:59','globeadmin'),('568949cb8ce20c8','5689468794353da','561a90ab2457a16','','','','','','','2016-01-03 18:18:19','globeadmin','2016-01-03 18:18:19','globeadmin','2016-02-09 20:38:01','globeadmin'),('568949cb9435253','5689468794353da','5616c3a5f23ccc8','','','','','','','2016-01-03 18:18:19','globeadmin','2016-01-03 18:18:19','globeadmin','2016-02-09 20:37:56','globeadmin'),('568949cb9b88136','5689468794353da','5621401c573dfb8','','','','','','','2016-01-03 18:18:19','globeadmin','2016-01-03 18:18:19','globeadmin','2016-02-09 20:37:56','globeadmin'),('568949cba2db8d4','5689468794353da','562229979f567be','','','','','','','2016-01-03 18:18:19','globeadmin','2016-01-03 18:18:19','globeadmin','2016-02-09 20:38:00','globeadmin'),('568949cbaa2e4df','5689468794353da','562362d2ef4f556','','','','','','','2016-01-03 18:18:19','globeadmin','2016-01-03 18:18:19','globeadmin','2016-02-09 20:38:01','globeadmin'),('568949cbb181287','5689468794353da','5627e58b8ed5f6d','','','','','','','2016-01-03 18:18:19','globeadmin','2016-01-03 18:18:19','globeadmin','2016-02-09 20:37:59','globeadmin'),('568949cbb8d4299','5689468794353da','562e770b79c0722','','','','','','','2016-01-03 18:18:19','globeadmin','2016-01-03 18:18:19','globeadmin','2016-02-09 20:38:02','globeadmin'),('568949cbc02711d','5689468794353da','562d11f6d45ccf1','','','','','','','2016-01-03 18:18:19','globeadmin','2016-01-03 18:18:19','globeadmin','2016-02-09 20:37:59','globeadmin'),('568949cbc77a28c','5689468794353da','56312e4782e78b4','','','','','','','2016-01-03 18:18:19','globeadmin','2016-01-03 18:18:19','globeadmin','2016-02-09 20:38:02','globeadmin'),('568949cbcecd2ce','5689468794353da','565b05b5e424081','','','','','','','2016-01-03 18:18:19','globeadmin','2016-01-03 18:18:19','globeadmin','2016-02-09 20:38:00','globeadmin'),('568949cbd620449','5689468794353da','5684e68b302da76','','','','','','','2016-01-03 18:18:19','globeadmin','2016-01-03 18:18:19','globeadmin','2016-02-09 20:38:03','globeadmin'),('568949cbdd737bb','5689468794353da','5688ee0218ad763','','','','','','','2016-01-03 18:18:19','globeadmin','2016-01-03 18:18:19','globeadmin','2016-02-09 20:37:56','globeadmin'),('568949cbe4c61ec','5689468794353da','568834bf97fe8a1','','','','','','','2016-01-03 18:18:19','globeadmin','2016-01-03 18:18:19','globeadmin','2016-02-09 20:37:57','globeadmin'),('56e199cd81c690e','547de3bee410196','56dd9f180d22b31','','','','','','','2016-03-10 17:59:09','globeadmin','2016-03-10 17:59:09','globeadmin','2022-01-31 16:18:39','globeadmin'),('56e199cd89197cd','547de3bee410196','56e052ae98309fe','','','','','','','2016-03-10 17:59:09','globeadmin','2016-03-10 17:59:09','globeadmin','2022-01-31 16:18:41','globeadmin'),('56e199d1a8d67ca','547de3e001028e8','56dd9f180d22b31','','','','','','','2016-03-10 17:59:13','globeadmin','2016-03-10 17:59:13','globeadmin','2019-11-06 15:15:06','globeadmin'),('56e199d1b0296ee','547de3e001028e8','56e052ae98309fe','','','','','','','2016-03-10 17:59:13','globeadmin','2016-03-10 17:59:13','globeadmin','2019-11-06 15:15:09','globeadmin'),('56e199d55d2798c','547de3fe0d36089','56dd9f180d22b31','','','','','','','2016-03-10 17:59:17','globeadmin','2016-03-10 17:59:17','globeadmin','2019-07-01 11:06:59','globeadmin'),('56e199d5647a7ae','547de3fe0d36089','56e052ae98309fe','','','','','','','2016-03-10 17:59:17','globeadmin','2016-03-10 17:59:17','globeadmin','2019-07-01 11:07:01','globeadmin'),('56e199d82500952','5501dbedc785fe4','56dd9f180d22b31','','','','','','','2016-03-10 17:59:20','globeadmin','2016-03-10 17:59:20','globeadmin','2018-01-09 18:51:06','globeadmin'),('56e199d82c53bef','5501dbedc785fe4','56e052ae98309fe','','','','','','','2016-03-10 17:59:20','globeadmin','2016-03-10 17:59:20','globeadmin','2018-01-09 18:51:11','globeadmin'),('56e199db49b94e4','5601afbc23dfb00','56dd9f180d22b31','','','','','','','2016-03-10 17:59:23','globeadmin','2016-03-10 17:59:23','globeadmin','2018-11-20 14:42:06','globeadmin'),('56e199db50f2a0b','5601afbc23dfb00','56e052ae98309fe','','','','','','','2016-03-10 17:59:23','globeadmin','2016-03-10 17:59:23','globeadmin','2018-11-20 14:42:12','globeadmin'),('56e199ddd73aeda','5689468794353da','56dd9f180d22b31','','','','','','','2016-03-10 17:59:25','globeadmin','2016-03-10 17:59:25','globeadmin','2016-03-10 17:59:25','globeadmin'),('56e199ddde8c744','5689468794353da','56e052ae98309fe','','','','','','','2016-03-10 17:59:25','globeadmin','2016-03-10 17:59:25','globeadmin','2016-03-10 17:59:25','globeadmin'),('56e58c8ece21454','5501dbedc785fe4','56e553b8d3afa56','','','','','','','2016-03-13 17:51:42','globeadmin','2016-03-13 17:51:42','globeadmin','2018-01-09 18:51:08','globeadmin'),('56e58c920d425da','5601afbc23dfb00','56e553b8d3afa56','','','','','','','2016-03-13 17:51:46','globeadmin','2016-03-13 17:51:46','globeadmin','2018-11-20 14:42:08','globeadmin'),('572b7acadfe52f3','547de3bee410196','572af54adfe5517','','','','','','','2016-05-05 19:54:34','globeadmin','2016-05-05 19:54:34','globeadmin','2022-01-31 16:18:41','globeadmin'),('56ec731686d970c','547de3bee410196','56e98e66abfe2c1','','','','','','','2016-03-18 23:28:54','globeadmin','2016-03-18 23:28:54','globeadmin','2022-01-31 16:18:38','globeadmin'),('56ec73168e2c787','547de3bee410196','56eae5254137ba7','','','','','','','2016-03-18 23:28:54','globeadmin','2016-03-18 23:28:54','globeadmin','2022-01-31 16:18:38','globeadmin'),('56ec731a7d15856','547de3e001028e8','56e98e66abfe2c1','','','','','','','2016-03-18 23:28:58','globeadmin','2016-03-18 23:28:58','globeadmin','2019-11-06 15:15:03','globeadmin'),('56ec731a84686c5','547de3e001028e8','56eae5254137ba7','','','','','','','2016-03-18 23:28:58','globeadmin','2016-03-18 23:28:58','globeadmin','2019-11-06 15:15:03','globeadmin'),('56ec731deaf29f6','5501dbedc785fe4','56e98e66abfe2c1','','','','','','','2016-03-18 23:29:01','globeadmin','2016-03-18 23:29:01','globeadmin','2018-01-09 18:51:01','globeadmin'),('56ec731df2455d5','5501dbedc785fe4','56eae5254137ba7','','','','','','','2016-03-18 23:29:01','globeadmin','2016-03-18 23:29:01','globeadmin','2018-01-09 18:51:01','globeadmin'),('56ec732149d06fa','5601afbc23dfb00','56e98e66abfe2c1','','','','','','','2016-03-18 23:29:05','globeadmin','2016-03-18 23:29:05','globeadmin','2018-11-20 14:42:00','globeadmin'),('56ec7321512369d','5601afbc23dfb00','56eae5254137ba7','','','','','','','2016-03-18 23:29:05','globeadmin','2016-03-18 23:29:05','globeadmin','2018-11-20 14:42:00','globeadmin'),('56ec732422c1d08','5689468794353da','56e98e66abfe2c1','','','','','','','2016-03-18 23:29:08','globeadmin','2016-03-18 23:29:08','globeadmin','2016-03-18 23:29:08','globeadmin'),('56ec73242a136b7','5689468794353da','56eae5254137ba7','','','','','','','2016-03-18 23:29:08','globeadmin','2016-03-18 23:29:08','globeadmin','2016-03-18 23:29:08','globeadmin'),('5712367041e6ebf','547de3bee410196','5711e1d915f5011','','','','','','','2016-04-16 15:56:16','globeadmin','2016-04-16 15:56:16','globeadmin','2022-01-31 16:18:40','globeadmin'),('57123676a38ecf3','547de3e001028e8','5711e1d915f5011','','','','','','','2016-04-16 15:56:22','globeadmin','2016-04-16 15:56:22','globeadmin','2019-11-06 15:15:06','globeadmin'),('5712367c68f6d16','5501dbedc785fe4','5711e1d915f5011','','','','','','','2016-04-16 15:56:28','globeadmin','2016-04-16 15:56:28','globeadmin','2018-01-09 18:51:07','globeadmin'),('5712368061a3d22','5601afbc23dfb00','5711e1d915f5011','','','','','','','2016-04-16 15:56:32','globeadmin','2016-04-16 15:56:32','globeadmin','2018-11-20 14:42:07','globeadmin'),('5712368472baccf','5689468794353da','5711e1d915f5011','','','','','','','2016-04-16 15:56:36','globeadmin','2016-04-16 15:56:36','globeadmin','2016-04-16 15:56:36','globeadmin'),('572b7ad043a545b','5501dbedc785fe4','572b615e795d4d1','','','','','','','2016-05-05 19:54:40','globeadmin','2016-05-05 19:54:40','globeadmin','2018-01-09 18:51:11','globeadmin'),('57137d425b9b551','547de3bee410196','571354ed43a4d47','','','','','','','2016-04-17 15:10:42','globeadmin','2016-04-17 15:10:42','globeadmin','2022-01-31 16:18:39','globeadmin'),('57137d49c97835d','5501dbedc785fe4','571354ed43a4d47','','','','','','','2016-04-17 15:10:49','globeadmin','2016-04-17 15:10:49','globeadmin','2018-01-09 18:51:04','globeadmin'),('57137d500b0a52f','5601afbc23dfb00','571354ed43a4d47','','','','','','','2016-04-17 15:10:56','globeadmin','2016-04-17 15:10:56','globeadmin','2018-11-20 14:42:04','globeadmin'),('57137d5608995cf','5689468794353da','571354ed43a4d47','','','','','','','2016-04-17 15:11:02','globeadmin','2016-04-17 15:11:02','globeadmin','2016-04-17 15:11:02','globeadmin'),('5717b9c97624c3d','5717b9c74a31169','5509671b4e81a07','','','','','','','2016-04-20 20:18:02','globeadmin','2016-04-20 20:18:02','globeadmin','2017-10-15 19:02:05','globeadmin'),('5717b9c982583a2','5717b9c74a31169','551821232f9553f','','','','','','','2016-04-20 20:18:02','globeadmin','2016-04-20 20:18:02','globeadmin','2017-10-15 19:02:05','globeadmin'),('5717b9c98c1d874','5717b9c74a31169','56ea588f03c272b','','','','','','','2016-04-20 20:18:02','globeadmin','2016-04-20 20:18:02','globeadmin','2017-10-15 19:02:05','globeadmin'),('5717b9c995e19eb','5717b9c74a31169','54835ec50abe722','','','','','','','2016-04-20 20:18:02','globeadmin','2016-04-20 20:18:02','globeadmin','2017-10-15 19:02:05','globeadmin'),('5717b9c99fa5a40','5717b9c74a31169','550dbae55f33b5f','','','','','','','2016-04-20 20:18:02','globeadmin','2016-04-20 20:18:02','globeadmin','2017-10-15 19:02:06','globeadmin'),('5717b9c9a9699e3','5717b9c74a31169','562d11f6d45ccf1','','','','','','','2016-04-20 20:18:02','globeadmin','2016-04-20 20:18:02','globeadmin','2017-10-15 19:02:06','globeadmin'),('5717b9c9b32d8ce','5717b9c74a31169','56dd9f180d22b31','','','','','','','2016-04-20 20:18:02','globeadmin','2016-04-20 20:18:02','globeadmin','2017-10-15 19:02:06','globeadmin'),('5717b9c9bf613dc','5717b9c74a31169','54a6fde1ab6eb6d','','','','','','','2016-04-20 20:18:02','globeadmin','2016-04-20 20:18:02','globeadmin','2017-10-15 19:02:08','globeadmin'),('5717b9c9c9268ec','5717b9c74a31169','566086607663544','','','','','','','2016-04-20 20:18:02','globeadmin','2016-04-20 20:18:02','globeadmin','2017-10-15 19:02:09','globeadmin'),('5717b9c9d2ea88e','5717b9c74a31169','56e052ae98309fe','','','','','','','2016-04-20 20:18:02','globeadmin','2016-04-20 20:18:02','globeadmin','2017-10-15 19:02:09','globeadmin'),('5717b9ebc443276','5717b9c74a31169','56192a97203c280','','','','','','','2016-04-20 20:18:35','globeadmin','2016-04-20 20:18:35','globeadmin','2016-04-20 20:18:35','globeadmin'),('572b7acad892771','547de3bee410196','572b615e795d4d1','','','','','','','2016-05-05 19:54:34','globeadmin','2016-05-05 19:54:34','globeadmin','2022-01-31 16:18:41','globeadmin'),('57418eb4e81dc56','547de3bee410196','57400922b87c65a','','','','','','','2016-05-22 13:49:24','globeadmin','2016-05-22 13:49:24','globeadmin','2022-01-31 16:18:38','globeadmin'),('5781496326e64e1','547de3e001028e8','577ebb808309312','','','','','','','2016-07-09 21:58:43','globeadmin','2016-07-09 21:58:43','globeadmin','2019-11-06 15:15:04','globeadmin'),('571bcc6012504e4','547de3bee410196','5713df2963f613a','','','','','','','2016-04-23 22:26:24','globeadmin','2016-04-23 22:26:24','globeadmin','2022-01-31 16:18:40','globeadmin'),('571bcc6019a3256','547de3bee410196','5719cb61e92d4e8','','','','','','','2016-04-23 22:26:24','globeadmin','2016-04-23 22:26:24','globeadmin','2022-01-31 16:18:41','globeadmin'),('571bcc6020f635a','547de3bee410196','571bae293e43d23','','','','','','','2016-04-23 22:26:24','globeadmin','2016-04-23 22:26:24','globeadmin','2022-01-31 16:18:41','globeadmin'),('571bcc6a5dff4c8','547de3e001028e8','571354ed43a4d47','','','','','','','2016-04-23 22:26:34','globeadmin','2016-04-23 22:26:34','globeadmin','2019-11-06 15:15:05','globeadmin'),('571bcc6a65522d1','547de3e001028e8','5713df2963f613a','','','','','','','2016-04-23 22:26:34','globeadmin','2016-04-23 22:26:34','globeadmin','2019-11-06 15:15:07','globeadmin'),('571bcc6a6ca5320','547de3e001028e8','5719cb61e92d4e8','','','','','','','2016-04-23 22:26:34','globeadmin','2016-04-23 22:26:34','globeadmin','2019-11-06 15:15:07','globeadmin'),('571bcc6a73f82ed','547de3e001028e8','571bae293e43d23','','','','','','','2016-04-23 22:26:34','globeadmin','2016-04-23 22:26:34','globeadmin','2019-11-06 15:15:09','globeadmin'),('571bcc70e1d52be','5501dbedc785fe4','5713df2963f613a','','','','','','','2016-04-23 22:26:40','globeadmin','2016-04-23 22:26:40','globeadmin','2018-01-09 18:51:08','globeadmin'),('571bcc70e928432','5501dbedc785fe4','5719cb61e92d4e8','','','','','','','2016-04-23 22:26:40','globeadmin','2016-04-23 22:26:40','globeadmin','2018-01-09 18:51:09','globeadmin'),('571bcc70f07cba1','5501dbedc785fe4','571bae293e43d23','','','','','','','2016-04-23 22:26:40','globeadmin','2016-04-23 22:26:40','globeadmin','2018-01-09 18:51:11','globeadmin'),('571bcc756f163df','5601afbc23dfb00','5713df2963f613a','','','','','','','2016-04-23 22:26:45','globeadmin','2016-04-23 22:26:45','globeadmin','2018-11-20 14:42:08','globeadmin'),('571bcc757669299','5601afbc23dfb00','5719cb61e92d4e8','','','','','','','2016-04-23 22:26:45','globeadmin','2016-04-23 22:26:45','globeadmin','2018-11-20 14:42:09','globeadmin'),('571bcc757dbc2e4','5601afbc23dfb00','571bae293e43d23','','','','','','','2016-04-23 22:26:45','globeadmin','2016-04-23 22:26:45','globeadmin','2018-11-20 14:42:11','globeadmin'),('571bcc7b7b4b3d7','5689468794353da','5713df2963f613a','','','','','','','2016-04-23 22:26:51','globeadmin','2016-04-23 22:26:51','globeadmin','2016-04-23 22:26:51','globeadmin'),('571bcc7b829e271','5689468794353da','5719cb61e92d4e8','','','','','','','2016-04-23 22:26:51','globeadmin','2016-04-23 22:26:51','globeadmin','2016-04-23 22:26:51','globeadmin'),('571bcc7b89f12ad','5689468794353da','571bae293e43d23','','','','','','','2016-04-23 22:26:51','globeadmin','2016-04-23 22:26:51','globeadmin','2016-04-23 22:26:51','globeadmin'),('571e6ed377e4037','5717b9c74a31169','54a65ecc3f14737','','','','','','','2016-04-25 22:24:03','globeadmin','2016-04-25 22:24:03','globeadmin','2017-10-15 19:02:05','globeadmin'),('572b7ad04af83d8','5501dbedc785fe4','572af54adfe5517','','','','','','','2016-05-05 19:54:40','globeadmin','2016-05-05 19:54:40','globeadmin','2018-01-09 18:51:09','globeadmin'),('572b7ad4831f422','5601afbc23dfb00','572b615e795d4d1','','','','','','','2016-05-05 19:54:44','globeadmin','2016-05-05 19:54:44','globeadmin','2018-11-20 14:42:11','globeadmin'),('572b7ad48a722f0','5601afbc23dfb00','572af54adfe5517','','','','','','','2016-05-05 19:54:44','globeadmin','2016-05-05 19:54:44','globeadmin','2018-11-20 14:42:09','globeadmin'),('572b7ad8dd743d2','5689468794353da','572b615e795d4d1','','','','','','','2016-05-05 19:54:48','globeadmin','2016-05-05 19:54:48','globeadmin','2016-05-05 19:54:48','globeadmin'),('572b7ad8e4c73d6','5689468794353da','572af54adfe5517','','','','','','','2016-05-05 19:54:48','globeadmin','2016-05-05 19:54:48','globeadmin','2016-05-05 19:54:48','globeadmin'),('57418eb9225cb35','547de3e001028e8','57400922b87c65a','','','','','','','2016-05-22 13:49:29','globeadmin','2016-05-22 13:49:29','globeadmin','2019-11-06 15:15:04','globeadmin'),('57418ebde0ca867','5501dbedc785fe4','57400922b87c65a','','','','','','','2016-05-22 13:49:33','globeadmin','2016-05-22 13:49:33','globeadmin','2018-01-09 18:51:01','globeadmin'),('57418ec1978ff6d','5601afbc23dfb00','57400922b87c65a','','','','','','','2016-05-22 13:49:37','globeadmin','2016-05-22 13:49:37','globeadmin','2018-11-20 14:42:01','globeadmin'),('57418ec6ecff6da','5689468794353da','57400922b87c65a','','','','','','','2016-05-22 13:49:42','globeadmin','2016-05-22 13:49:42','globeadmin','2016-05-22 13:49:42','globeadmin'),('5781495f3a6875d','547de3bee410196','577ebb808309312','','','','','','','2016-07-09 21:58:39','globeadmin','2016-07-09 21:58:39','globeadmin','2022-01-31 16:18:38','globeadmin'),('57840153c86077b','547de3e001028e8','54a4107cddefff1','','','','','','','2016-07-11 23:28:03','globeadmin','2016-07-11 23:28:03','globeadmin','2019-11-06 15:15:06','globeadmin'),('5742e4c05534a9a','547de3bee410196','5741fe1502bb6c2','','','','','','','2016-05-23 14:08:48','globeadmin','2016-05-23 14:08:48','globeadmin','2022-01-31 16:18:38','globeadmin'),('5742e4c05ef9efc','547de3bee410196','5742996ed6426f1','','','','','','','2016-05-23 14:08:48','globeadmin','2016-05-23 14:08:48','globeadmin','2022-01-31 16:18:38','globeadmin'),('5742e4c3c7f3cba','547de3e001028e8','5741fe1502bb6c2','','','','','','','2016-05-23 14:08:51','globeadmin','2016-05-23 14:08:51','globeadmin','2019-11-06 15:15:04','globeadmin'),('5742e4c3d428b51','547de3e001028e8','5742996ed6426f1','','','','','','','2016-05-23 14:08:51','globeadmin','2016-05-23 14:08:51','globeadmin','2019-11-06 15:15:04','globeadmin'),('5742e4c8a0e3a24','5501dbedc785fe4','5741fe1502bb6c2','','','','','','','2016-05-23 14:08:56','globeadmin','2016-05-23 14:08:56','globeadmin','2018-01-09 18:51:01','globeadmin'),('5742e4c8aaa7e42','5501dbedc785fe4','5742996ed6426f1','','','','','','','2016-05-23 14:08:56','globeadmin','2016-05-23 14:08:56','globeadmin','2018-01-09 18:51:01','globeadmin'),('5742e4cbd90ac57','5601afbc23dfb00','5741fe1502bb6c2','','','','','','','2016-05-23 14:08:59','globeadmin','2016-05-23 14:08:59','globeadmin','2018-11-20 14:42:01','globeadmin'),('5742e4cbe2d003d','5601afbc23dfb00','5742996ed6426f1','','','','','','','2016-05-23 14:08:59','globeadmin','2016-05-23 14:08:59','globeadmin','2018-11-20 14:42:01','globeadmin'),('5742e4cfbe2fa67','5689468794353da','5741fe1502bb6c2','','','','','','','2016-05-23 14:09:03','globeadmin','2016-05-23 14:09:03','globeadmin','2016-05-23 14:09:03','globeadmin'),('5742e4cfc7f4e90','5689468794353da','5742996ed6426f1','','','','','','','2016-05-23 14:09:03','globeadmin','2016-05-23 14:09:03','globeadmin','2016-05-23 14:09:03','globeadmin'),('57814965f3f4847','5501dbedc785fe4','577ebb808309312','','','','','','','2016-07-09 21:58:45','globeadmin','2016-07-09 21:58:45','globeadmin','2018-01-09 18:51:02','globeadmin'),('57460da710596d3','547de3bee410196','57457fe729a1d1c','','','','','','','2016-05-25 23:40:07','globeadmin','2016-05-25 23:40:07','globeadmin','2022-01-31 16:18:38','globeadmin'),('57460daa8f4d4da','547de3e001028e8','57457fe729a1d1c','','','','','','','2016-05-25 23:40:10','globeadmin','2016-05-25 23:40:10','globeadmin','2019-11-06 15:15:03','globeadmin'),('57460daecec75b8','5501dbedc785fe4','57457fe729a1d1c','','','','','','','2016-05-25 23:40:14','globeadmin','2016-05-25 23:40:14','globeadmin','2018-01-09 18:51:01','globeadmin'),('57460db3f366523','5601afbc23dfb00','57457fe729a1d1c','','','','','','','2016-05-25 23:40:19','globeadmin','2016-05-25 23:40:19','globeadmin','2018-11-20 14:42:00','globeadmin'),('57460db8831b785','5689468794353da','57457fe729a1d1c','','','','','','','2016-05-25 23:40:24','globeadmin','2016-05-25 23:40:24','globeadmin','2016-05-25 23:40:24','globeadmin'),('57814968f183782','5601afbc23dfb00','577ebb808309312','','','','','','','2016-07-09 21:58:48','globeadmin','2016-07-09 21:58:48','globeadmin','2018-11-20 14:42:01','globeadmin'),('5781496fddfb8fe','5689468794353da','577ebb808309312','','','','','','','2016-07-09 21:58:55','globeadmin','2016-07-09 21:58:55','globeadmin','2016-07-09 21:58:55','globeadmin'),('5782567a125a171','547de3bee410196','57822e81b5ed24f','','','','','','','2016-07-10 17:06:50','globeadmin','2016-07-10 17:06:50','globeadmin','2022-01-31 16:18:41','globeadmin'),('5782567ed0c7f93','5501dbedc785fe4','57822e81b5ed24f','','','','','','','2016-07-10 17:06:54','globeadmin','2016-07-10 17:06:54','globeadmin','2018-01-09 18:51:11','globeadmin'),('5782568182a7e55','5601afbc23dfb00','57822e81b5ed24f','','','','','','','2016-07-10 17:06:57','globeadmin','2016-07-10 17:06:57','globeadmin','2018-11-20 14:42:11','globeadmin'),('578256848789f73','5689468794353da','57822e81b5ed24f','','','','','','','2016-07-10 17:07:00','globeadmin','2016-07-10 17:07:00','globeadmin','2016-07-10 17:07:00','globeadmin'),('5794bb9ded51c10','5501dbedc785fe4','5762f95837d99ee','','','','','','','2016-07-24 15:59:09','globeadmin','2016-07-24 15:59:09','globeadmin','2018-01-09 18:51:09','globeadmin'),('5782b55635b723f','547de3bee410196','57829d0d8167dd0','','','','','','','2016-07-10 23:51:34','globeadmin','2016-07-10 23:51:34','globeadmin','2022-01-31 16:18:41','globeadmin'),('5782b55a3a99270','5501dbedc785fe4','57829d0d8167dd0','','','','','','','2016-07-10 23:51:38','globeadmin','2016-07-10 23:51:38','globeadmin','2018-01-09 18:51:11','globeadmin'),('5782b55cad582bc','5601afbc23dfb00','57829d0d8167dd0','','','','','','','2016-07-10 23:51:40','globeadmin','2016-07-10 23:51:40','globeadmin','2018-11-20 14:42:11','globeadmin'),('578be3d102c9497','547de3bee410196','5787f33aaa172a1','','','','','','','2016-07-17 23:00:17','globeadmin','2016-07-17 23:00:17','globeadmin','2022-01-31 16:18:40','globeadmin'),('578be3d6ed292e3','547de3e001028e8','5787f33aaa172a1','','','','','','','2016-07-17 23:00:22','globeadmin','2016-07-17 23:00:22','globeadmin','2019-11-06 15:15:07','globeadmin'),('578be3db2ebb2b6','5501dbedc785fe4','5787f33aaa172a1','','','','','','','2016-07-17 23:00:27','globeadmin','2016-07-17 23:00:27','globeadmin','2018-01-09 18:51:08','globeadmin'),('578be3deb29115a','5601afbc23dfb00','5787f33aaa172a1','','','','','','','2016-07-17 23:00:30','globeadmin','2016-07-17 23:00:30','globeadmin','2018-11-20 14:42:08','globeadmin'),('578be3e2c88a4be','5689468794353da','5787f33aaa172a1','','','','','','','2016-07-17 23:00:34','globeadmin','2016-07-17 23:00:34','globeadmin','2016-07-17 23:00:34','globeadmin'),('5794bb9de5ff265','5501dbedc785fe4','5794b884d007734','','','','','','','2016-07-24 15:59:09','globeadmin','2016-07-24 15:59:09','globeadmin','2018-01-09 18:50:59','globeadmin'),('5794bbe0733fdfb','547de3bee410196','5762f95837d99ee','','','','','','','2016-07-24 16:00:16','globeadmin','2016-07-24 16:00:16','globeadmin','2022-01-31 16:18:41','globeadmin'),('578f81108ab4a49','547de3bee410196','578e9b35d4d3cf8','','','','','','','2016-07-20 16:48:00','globeadmin','2016-07-20 16:48:00','globeadmin','2022-01-31 16:18:40','globeadmin'),('578f8118eecd8ba','547de3e001028e8','578e9b35d4d3cf8','','','','','','','2016-07-20 16:48:08','globeadmin','2016-07-20 16:48:08','globeadmin','2019-11-06 15:15:06','globeadmin'),('578f811901fc651','547de3e001028e8','572af54adfe5517','','','','','','','2016-07-20 16:48:09','globeadmin','2016-07-20 16:48:09','globeadmin','2019-11-06 15:15:07','globeadmin'),('578f81239e3c727','5501dbedc785fe4','578e9b35d4d3cf8','','','','','','','2016-07-20 16:48:19','globeadmin','2016-07-20 16:48:19','globeadmin','2018-01-09 18:51:07','globeadmin'),('578f812974bb61b','5601afbc23dfb00','578e9b35d4d3cf8','','','','','','','2016-07-20 16:48:25','globeadmin','2016-07-20 16:48:25','globeadmin','2018-11-20 14:42:07','globeadmin'),('578f812f724a995','5689468794353da','578e9b35d4d3cf8','','','','','','','2016-07-20 16:48:31','globeadmin','2016-07-20 16:48:31','globeadmin','2016-07-20 16:48:31','globeadmin'),('5794bb9e00810e2','5501dbedc785fe4','5794b8d73636f76','','','','','','','2016-07-24 15:59:10','globeadmin','2016-07-24 15:59:10','globeadmin','2018-01-09 18:51:10','globeadmin'),('5794bba63ffadbb','5601afbc23dfb00','5794b884d007734','','','','','','','2016-07-24 15:59:18','globeadmin','2016-07-24 15:59:18','globeadmin','2016-07-24 15:59:18','globeadmin'),('5794bba6474dc8b','5601afbc23dfb00','5762f95837d99ee','','','','','','','2016-07-24 15:59:18','globeadmin','2016-07-24 15:59:18','globeadmin','2018-11-20 14:42:09','globeadmin'),('5794bba64ea0c10','5601afbc23dfb00','5794b8d73636f76','','','','','','','2016-07-24 15:59:18','globeadmin','2016-07-24 15:59:18','globeadmin','2018-11-20 14:42:10','globeadmin'),('57ed74bd047fcca','547de3bee410196','57ece27c6e12afd','','','','','','','2016-09-29 23:08:29','globeadmin','2016-09-29 23:08:29','globeadmin','2022-01-31 16:18:40','globeadmin'),('57deae95622d865','547de3fe0d36089','57dae2cd92d16c0','','','','','','','2016-09-18 18:11:17','globeadmin','2016-09-18 18:11:17','globeadmin','2019-07-01 11:07:02','globeadmin'),('57deae9a7d158ab','5717b9c74a31169','57dae2cd92d16c0','','','','','','','2016-09-18 18:11:22','globeadmin','2016-09-18 18:11:22','globeadmin','2017-10-15 19:02:09','globeadmin'),('57deaeb10cab304','547de3bee410196','57dae2cd92d16c0','','','','','','','2016-09-18 18:11:45','globeadmin','2016-09-18 18:11:45','globeadmin','2022-01-31 16:18:41','globeadmin'),('57deaeb52a01bd0','547de3e001028e8','57dae2cd92d16c0','','','','','','','2016-09-18 18:11:49','globeadmin','2016-09-18 18:11:49','globeadmin','2019-11-06 15:15:09','globeadmin'),('57deaeba18dca3d','5501dbedc785fe4','57dae2cd92d16c0','','','','','','','2016-09-18 18:11:54','globeadmin','2016-09-18 18:11:54','globeadmin','2018-01-09 18:51:12','globeadmin'),('57deaebc89281e3','5601afbc23dfb00','57dae2cd92d16c0','','','','','','','2016-09-18 18:11:56','globeadmin','2016-09-18 18:11:56','globeadmin','2018-11-20 14:42:12','globeadmin'),('57deaebf7a806c2','5689468794353da','57dae2cd92d16c0','','','','','','','2016-09-18 18:11:59','globeadmin','2016-09-18 18:11:59','globeadmin','2016-09-18 18:11:59','globeadmin'),('57e16f3977dc65a','5501dbedc785fe4','57e15c6777df58a','','','','','','','2016-09-20 20:17:45','globeadmin','2016-09-20 20:17:45','globeadmin','2018-01-09 18:51:05','globeadmin'),('57e16f3e9ee6506','5601afbc23dfb00','57e15c6777df58a','','','','','','','2016-09-20 20:17:50','globeadmin','2016-09-20 20:17:50','globeadmin','2018-11-20 14:42:05','globeadmin'),('584176093a8a8fa','5689468794353da','5831a1813b1b74d','','','','','','','2016-12-02 15:24:25','globeadmin','2016-12-02 15:24:25','globeadmin','2016-12-02 15:24:25','globeadmin'),('57e6bf22346a69f','5501dbedc785fe4','57e6bdac4fee426','','','','','','','2016-09-24 21:00:02','globeadmin','2016-09-24 21:00:02','globeadmin','2018-01-09 18:51:07','globeadmin'),('57e6bf25825445c','5601afbc23dfb00','57e6bdac4fee426','','','','','','','2016-09-24 21:00:05','globeadmin','2016-09-24 21:00:05','globeadmin','2018-11-20 14:42:07','globeadmin'),('57ed74c421ce3f3','5501dbedc785fe4','57ece27c6e12afd','','','','','','','2016-09-29 23:08:36','globeadmin','2016-09-29 23:08:36','globeadmin','2018-01-09 18:51:07','globeadmin'),('57ed74c8b4474ea','5601afbc23dfb00','57ece27c6e12afd','','','','','','','2016-09-29 23:08:40','globeadmin','2016-09-29 23:08:40','globeadmin','2018-11-20 14:42:07','globeadmin'),('5807a93f4faaaa3','547de3e001028e8','5525421c67a48bc','','','','','','','2016-10-19 20:11:27','globeadmin','2016-10-19 20:11:27','globeadmin','2019-11-06 15:15:02','globeadmin'),('580c882637399a9','547de3bee410196','580ba2a48260384','','','','','','','2016-10-23 12:51:34','globeadmin','2016-10-23 12:51:34','globeadmin','2022-01-31 16:18:39','globeadmin'),('580c882aa2a2b80','547de3e001028e8','580ba2a48260384','','','','','','','2016-10-23 12:51:38','globeadmin','2016-10-23 12:51:38','globeadmin','2019-11-06 15:15:06','globeadmin'),('580c882d4ac418d','5501dbedc785fe4','580ba2a48260384','','','','','','','2016-10-23 12:51:41','globeadmin','2016-10-23 12:51:41','globeadmin','2018-01-09 18:51:05','globeadmin'),('580c882f966b31d','5601afbc23dfb00','580ba2a48260384','','','','','','','2016-10-23 12:51:43','globeadmin','2016-10-23 12:51:43','globeadmin','2018-11-20 14:42:05','globeadmin'),('580c88330182d97','5689468794353da','580ba2a48260384','','','','','','','2016-10-23 12:51:47','globeadmin','2016-10-23 12:51:47','globeadmin','2016-10-23 12:51:47','globeadmin'),('580cf597bba1133','547de3bee410196','580cdf151b06780','','','','','','','2016-10-23 20:38:31','globeadmin','2016-10-23 20:38:31','globeadmin','2022-01-31 16:18:39','globeadmin'),('580cf59c37df0c0','547de3e001028e8','580cdf151b06780','','','','','','','2016-10-23 20:38:36','globeadmin','2016-10-23 20:38:36','globeadmin','2019-11-06 15:15:05','globeadmin'),('580cf59fa0c1315','5501dbedc785fe4','580cdf151b06780','','','','','','','2016-10-23 20:38:39','globeadmin','2016-10-23 20:38:39','globeadmin','2018-01-09 18:51:05','globeadmin'),('580cf5a221d4836','5601afbc23dfb00','580cdf151b06780','','','','','','','2016-10-23 20:38:42','globeadmin','2016-10-23 20:38:42','globeadmin','2018-11-20 14:42:05','globeadmin'),('580cf5a50e4237e','5689468794353da','580cdf151b06780','','','','','','','2016-10-23 20:38:45','globeadmin','2016-10-23 20:38:45','globeadmin','2016-10-23 20:38:45','globeadmin'),('5810e122cfefe9c','547de3bee410196','580e312bc544f2e','','','','','','','2016-10-26 20:00:18','globeadmin','2016-10-26 20:00:18','globeadmin','2022-01-31 16:18:37','globeadmin'),('5810e1271b43089','5501dbedc785fe4','580e312bc544f2e','','','','','','','2016-10-26 20:00:23','globeadmin','2016-10-26 20:00:23','globeadmin','2018-01-09 18:50:58','globeadmin'),('5810e129b29f3b1','5601afbc23dfb00','580e312bc544f2e','','','','','','','2016-10-26 20:00:25','globeadmin','2016-10-26 20:00:25','globeadmin','2018-11-20 14:41:57','globeadmin'),('58133e097f3857b','547de3bee410196','5812516a1bf18a5','','','','','','','2016-10-28 15:01:13','globeadmin','2016-10-28 15:01:13','globeadmin','2022-01-31 16:18:37','globeadmin'),('58133e0f9ef55b4','547de3e001028e8','5812516a1bf18a5','','','','','','','2016-10-28 15:01:19','globeadmin','2016-10-28 15:01:19','globeadmin','2019-11-06 15:15:02','globeadmin'),('58133e149efdd41','5501dbedc785fe4','5812516a1bf18a5','','','','','','','2016-10-28 15:01:24','globeadmin','2016-10-28 15:01:24','globeadmin','2018-01-09 18:50:58','globeadmin'),('58133e1877e5d56','5601afbc23dfb00','5812516a1bf18a5','','','','','','','2016-10-28 15:01:28','globeadmin','2016-10-28 15:01:28','globeadmin','2018-11-20 14:41:58','globeadmin'),('58133e1cc876cdc','5689468794353da','5812516a1bf18a5','','','','','','','2016-10-28 15:01:32','globeadmin','2016-10-28 15:01:32','globeadmin','2016-10-28 15:01:32','globeadmin'),('5814a127ea9431e','547de3bee410196','581469f72e8002c','','','','','','','2016-10-29 16:16:23','globeadmin','2016-10-29 16:16:23','globeadmin','2022-01-31 16:18:40','globeadmin'),('5814a12fecfff10','5501dbedc785fe4','581469f72e8002c','','','','','','','2016-10-29 16:16:31','globeadmin','2016-10-29 16:16:31','globeadmin','2018-01-09 18:51:07','globeadmin'),('5814a13300334e7','5601afbc23dfb00','581469f72e8002c','','','','','','','2016-10-29 16:16:35','globeadmin','2016-10-29 16:16:35','globeadmin','2018-11-20 14:42:07','globeadmin'),('584175d7caba75a','547de3bee410196','583031e43183ea3','','','','','','','2016-12-02 15:23:35','globeadmin','2016-12-02 15:23:35','globeadmin','2022-01-31 16:18:39','globeadmin'),('584175d7d20ab62','547de3bee410196','5831a1813b1b74d','','','','','','','2016-12-02 15:23:35','globeadmin','2016-12-02 15:23:35','globeadmin','2022-01-31 16:18:39','globeadmin'),('5841765c293914f','5717b9c74a31169','584128b691c711a','','','','','','','2016-12-02 15:25:48','globeadmin','2016-12-02 15:25:48','globeadmin','2017-10-15 19:02:06','globeadmin'),('583f15462b636ff','5501dbedc785fe4','58275eceb901234','','','','','','','2016-11-30 20:07:02','globeadmin','2016-11-30 20:07:02','globeadmin','2018-01-09 18:51:04','globeadmin'),('583f154632b96dc','5501dbedc785fe4','582762fe10beed3','','','','','','','2016-11-30 20:07:02','globeadmin','2016-11-30 20:07:02','globeadmin','2018-01-09 18:51:05','globeadmin'),('583f15463a09fd9','5501dbedc785fe4','582b3fe8c3f39e6','','','','','','','2016-11-30 20:07:02','globeadmin','2016-11-30 20:07:02','globeadmin','2018-01-09 18:51:05','globeadmin'),('583f1546415c5c5','5501dbedc785fe4','582b40cc7c93c9c','','','','','','','2016-11-30 20:07:02','globeadmin','2016-11-30 20:07:02','globeadmin','2018-01-09 18:51:05','globeadmin'),('583f154648af540','5501dbedc785fe4','583031e43183ea3','','','','','','','2016-11-30 20:07:02','globeadmin','2016-11-30 20:07:02','globeadmin','2018-01-09 18:51:05','globeadmin'),('583f154650090f0','5501dbedc785fe4','5831a1813b1b74d','','','','','','','2016-11-30 20:07:02','globeadmin','2016-11-30 20:07:02','globeadmin','2018-01-09 18:51:04','globeadmin'),('583f154b9e7aa9d','5601afbc23dfb00','58275eceb901234','','','','','','','2016-11-30 20:07:07','globeadmin','2016-11-30 20:07:07','globeadmin','2018-11-20 14:42:04','globeadmin'),('583f154ba57a8e6','5601afbc23dfb00','582762fe10beed3','','','','','','','2016-11-30 20:07:07','globeadmin','2016-11-30 20:07:07','globeadmin','2018-11-20 14:42:04','globeadmin'),('583f154bacc4a79','5601afbc23dfb00','582b3fe8c3f39e6','','','','','','','2016-11-30 20:07:07','globeadmin','2016-11-30 20:07:07','globeadmin','2018-11-20 14:42:04','globeadmin'),('583f154bb419f62','5601afbc23dfb00','582b40cc7c93c9c','','','','','','','2016-11-30 20:07:07','globeadmin','2016-11-30 20:07:07','globeadmin','2018-11-20 14:42:04','globeadmin'),('583f154bbb6aa98','5601afbc23dfb00','583031e43183ea3','','','','','','','2016-11-30 20:07:07','globeadmin','2016-11-30 20:07:07','globeadmin','2018-11-20 14:42:05','globeadmin'),('583f154bc2bd923','5601afbc23dfb00','5831a1813b1b74d','','','','','','','2016-11-30 20:07:07','globeadmin','2016-11-30 20:07:07','globeadmin','2018-11-20 14:42:04','globeadmin'),('58417609333e403','5689468794353da','583031e43183ea3','','','','','','','2016-12-02 15:24:25','globeadmin','2016-12-02 15:24:25','globeadmin','2016-12-02 15:24:25','globeadmin'),('5841766d52ae294','547de3fe0d36089','584117d1d046e30','','','','','','','2016-12-02 15:26:05','globeadmin','2016-12-02 15:26:05','globeadmin','2019-07-01 11:07:00','globeadmin'),('584a62a1731933c','547de3fe0d36089','584a5c7c116e00c','','','','','','','2016-12-09 09:52:01','globeadmin','2016-12-09 09:52:01','globeadmin','2019-07-01 11:07:00','globeadmin'),('584bdd471f48c75','547de3bee410196','584bd01a9203a9a','','','','','','','2016-12-10 12:47:35','globeadmin','2016-12-10 12:47:35','globeadmin','2022-01-31 16:18:39','globeadmin'),('584bdd4948d0d01','547de3e001028e8','584bd01a9203a9a','','','','','','','2016-12-10 12:47:37','globeadmin','2016-12-10 12:47:37','globeadmin','2019-11-06 15:15:05','globeadmin'),('584bdd4c6887f5f','5501dbedc785fe4','584bd01a9203a9a','','','','','','','2016-12-10 12:47:40','globeadmin','2016-12-10 12:47:40','globeadmin','2018-01-09 18:51:04','globeadmin'),('584bdd4f10b627b','5601afbc23dfb00','584bd01a9203a9a','','','','','','','2016-12-10 12:47:43','globeadmin','2016-12-10 12:47:43','globeadmin','2018-11-20 14:42:03','globeadmin'),('584bdd534daf066','5689468794353da','584bd01a9203a9a','','','','','','','2016-12-10 12:47:47','globeadmin','2016-12-10 12:47:47','globeadmin','2016-12-10 12:47:47','globeadmin'),('585d52837afb88b','547de3bee410196','56ea588f03c272b','','','','','','','2016-12-23 18:36:19','globeadmin','2016-12-23 18:36:19','globeadmin','2022-01-31 16:18:38','globeadmin'),('585d528811f90eb','5501dbedc785fe4','56ea588f03c272b','','','','','','','2016-12-23 18:36:24','globeadmin','2016-12-23 18:36:24','globeadmin','2018-01-09 18:51:01','globeadmin'),('585d528b4a20f7a','5601afbc23dfb00','56ea588f03c272b','','','','','','','2016-12-23 18:36:27','globeadmin','2016-12-23 18:36:27','globeadmin','2018-11-20 14:42:00','globeadmin'),('58dbe8e9d5ea4c3','5501dbedc785fe4','58d616cfeb60afc','','','','','','','2017-03-29 20:03:37','globeadmin','2017-03-29 20:03:37','globeadmin','2018-01-09 18:50:58','globeadmin'),('58dbe8edebe362c','5601afbc23dfb00','58d616cfeb60afc','','','','','','','2017-03-29 20:03:41','globeadmin','2017-03-29 20:03:41','globeadmin','2018-11-20 14:41:58','globeadmin'),('59b03add73e6015','547de3fe0d36089','59ac07f003930c8','','','','','','','2017-09-06 21:13:49','globeadmin','2017-09-06 21:13:49','globeadmin','2019-07-01 11:06:59','globeadmin'),('59a6f4aa85fb4b2','547de3bee410196','599591df20eb2f7','','','','','','','2017-08-30 20:23:54','globeadmin','2017-08-30 20:23:54','globeadmin','2022-01-31 16:18:41','globeadmin'),('59a6f4aa94a0cf5','547de3bee410196','599954a01e175cd','','','','','','','2017-08-30 20:23:54','globeadmin','2017-08-30 20:23:54','globeadmin','2022-01-31 16:18:38','globeadmin'),('59a6f4af970f25f','547de3e001028e8','599591df20eb2f7','','','','','','','2017-08-30 20:23:59','globeadmin','2017-08-30 20:23:59','globeadmin','2019-11-06 15:15:08','globeadmin'),('59a6f4af9e627db','547de3e001028e8','599954a01e175cd','','','','','','','2017-08-30 20:23:59','globeadmin','2017-08-30 20:23:59','globeadmin','2019-11-06 15:15:03','globeadmin'),('59a6f4b38113ff2','5501dbedc785fe4','599591df20eb2f7','','','','','','','2017-08-30 20:24:03','globeadmin','2017-08-30 20:24:03','globeadmin','2018-01-09 18:51:10','globeadmin'),('59a6f4b3886d7d8','5501dbedc785fe4','599954a01e175cd','','','','','','','2017-08-30 20:24:03','globeadmin','2017-08-30 20:24:03','globeadmin','2018-01-09 18:51:00','globeadmin'),('59a6f4b69bed665','5601afbc23dfb00','599591df20eb2f7','','','','','','','2017-08-30 20:24:06','globeadmin','2017-08-30 20:24:06','globeadmin','2018-11-20 14:42:11','globeadmin'),('59a6f4b6a34024c','5601afbc23dfb00','599954a01e175cd','','','','','','','2017-08-30 20:24:06','globeadmin','2017-08-30 20:24:06','globeadmin','2018-11-20 14:41:59','globeadmin'),('59a6f4bc4677224','5689468794353da','599591df20eb2f7','','','','','','','2017-08-30 20:24:12','globeadmin','2017-08-30 20:24:12','globeadmin','2017-08-30 20:24:12','globeadmin'),('59a6f4bc4dca1b9','5689468794353da','599954a01e175cd','','','','','','','2017-08-30 20:24:12','globeadmin','2017-08-30 20:24:12','globeadmin','2017-08-30 20:24:12','globeadmin'),('59b03ae1bf91f2a','5717b9c74a31169','59ac07f003930c8','','','','','','','2017-09-06 21:13:53','globeadmin','2017-09-06 21:13:53','globeadmin','2017-10-15 19:02:07','globeadmin'),('59a9a9c205e022c','547de3bee410196','59a96e2c710af4a','','','','','','','2017-09-01 21:41:06','globeadmin','2017-09-01 21:41:06','globeadmin','2022-01-31 16:18:38','globeadmin'),('59a9a9c8e1992d0','547de3e001028e8','59a96e2c710af4a','','','','','','','2017-09-01 21:41:12','globeadmin','2017-09-01 21:41:12','globeadmin','2019-11-06 15:15:03','globeadmin'),('59a9a9cd7d7a7b9','5501dbedc785fe4','59a96e2c710af4a','','','','','','','2017-09-01 21:41:17','globeadmin','2017-09-01 21:41:17','globeadmin','2018-01-09 18:51:00','globeadmin'),('59a9a9d08e8fdde','5601afbc23dfb00','59a96e2c710af4a','','','','','','','2017-09-01 21:41:20','globeadmin','2017-09-01 21:41:20','globeadmin','2018-11-20 14:41:59','globeadmin'),('59a9a9d495e059c','5689468794353da','59a96e2c710af4a','','','','','','','2017-09-01 21:41:24','globeadmin','2017-09-01 21:41:24','globeadmin','2017-09-01 21:41:24','globeadmin'),('59b03ae48c4b535','547de3bee410196','59ac07f003930c8','','','','','','','2017-09-06 21:13:56','globeadmin','2017-09-06 21:13:56','globeadmin','2022-01-31 16:18:40','globeadmin'),('59b03ae931fc547','5501dbedc785fe4','59ac07f003930c8','','','','','','','2017-09-06 21:14:01','globeadmin','2017-09-06 21:14:01','globeadmin','2018-01-09 18:51:09','globeadmin'),('59b03aebd585669','5601afbc23dfb00','59ac07f003930c8','','','','','','','2017-09-06 21:14:03','globeadmin','2017-09-06 21:14:03','globeadmin','2018-11-20 14:42:09','globeadmin'),('59b03aeeda676ea','5689468794353da','59ac07f003930c8','','','','','','','2017-09-06 21:14:06','globeadmin','2017-09-06 21:14:06','globeadmin','2017-09-06 21:14:06','globeadmin'),('59c2b2d9b197af4','5501dbedc785fe4','59c292e97e52d3e','','','','','','','2017-09-20 21:26:33','globeadmin','2017-09-20 21:26:33','globeadmin','2018-01-09 18:51:02','globeadmin'),('59c2b2de54d0470','5601afbc23dfb00','59c292e97e52d3e','','','','','','','2017-09-20 21:26:38','globeadmin','2017-09-20 21:26:38','globeadmin','2018-11-20 14:42:01','globeadmin'),('59cff9118e9e779','547de3bee410196','59cfad675ee667a','','','','','','','2017-09-30 23:05:37','globeadmin','2017-09-30 23:05:37','globeadmin','2022-01-31 16:18:39','globeadmin'),('59cff91401005df','547de3e001028e8','59cfad675ee667a','','','','','','','2017-09-30 23:05:40','globeadmin','2017-09-30 23:05:40','globeadmin','2019-11-06 15:15:05','globeadmin'),('59cff9170d337c4','5501dbedc785fe4','59cfad675ee667a','','','','','','','2017-09-30 23:05:43','globeadmin','2017-09-30 23:05:43','globeadmin','2018-01-09 18:51:04','globeadmin'),('59cff919cba0569','5601afbc23dfb00','59cfad675ee667a','','','','','','','2017-09-30 23:05:45','globeadmin','2017-09-30 23:05:45','globeadmin','2018-11-20 14:42:04','globeadmin'),('59cff91db5a463d','5689468794353da','59cfad675ee667a','','','','','','','2017-09-30 23:05:49','globeadmin','2017-09-30 23:05:49','globeadmin','2017-09-30 23:05:49','globeadmin'),('59d296b4bd47681','547de3bee410196','59d294a40ecced8','','','','','','','2017-10-02 22:42:44','globeadmin','2017-10-02 22:42:44','globeadmin','2022-01-31 16:18:37','globeadmin'),('59d296b982ad7bf','5501dbedc785fe4','59d294a40ecced8','','','','','','','2017-10-02 22:42:49','globeadmin','2017-10-02 22:42:49','globeadmin','2018-01-09 18:50:59','globeadmin'),('59d296bc08990f6','5601afbc23dfb00','59d294a40ecced8','','','','','','','2017-10-02 22:42:52','globeadmin','2017-10-02 22:42:52','globeadmin','2018-11-20 14:41:58','globeadmin'),('59feec614763402','547de3bee410196','59fe027dd6fe9f8','','','','','','','2017-11-05 12:48:01','globeadmin','2017-11-05 12:48:01','globeadmin','2022-01-31 16:18:38','globeadmin'),('59feec649586a59','547de3e001028e8','59fe027dd6fe9f8','','','','','','','2017-11-05 12:48:04','globeadmin','2017-11-05 12:48:04','globeadmin','2019-11-06 15:15:03','globeadmin'),('59eb9e799f5ff42','547de3fe0d36089','59eaf663b08f216','','','','','','','2017-10-21 22:22:33','globeadmin','2017-10-21 22:22:33','globeadmin','2019-07-01 11:06:56','globeadmin'),('59eb9e79a6b3075','547de3fe0d36089','54a65ecc3f14737','','','','','','','2017-10-21 22:22:33','globeadmin','2017-10-21 22:22:33','globeadmin','2019-07-01 11:06:57','globeadmin'),('59eb9e79ae0d5ed','547de3fe0d36089','59ea67cf8d2d9b3','','','','','','','2017-10-21 22:22:33','globeadmin','2017-10-21 22:22:33','globeadmin','2019-07-01 11:06:56','globeadmin'),('59feec67475f482','5501dbedc785fe4','59fe027dd6fe9f8','','','','','','','2017-11-05 12:48:07','globeadmin','2017-11-05 12:48:07','globeadmin','2018-01-09 18:50:59','globeadmin'),('59ecc317516834e','5601afbc23dfb00','59eaf663b08f216','','','','','','','2017-10-22 19:11:03','globeadmin','2017-10-22 19:11:03','globeadmin','2018-11-20 14:41:59','globeadmin'),('59d7d87671b50f3','547de3bee410196','59d67ca712d3ffa','','','','','','','2017-10-06 22:24:38','globeadmin','2017-10-06 22:24:38','globeadmin','2022-01-31 16:18:41','globeadmin'),('59d7d876790144e','547de3bee410196','59d7d65650da67c','','','','','','','2017-10-06 22:24:38','globeadmin','2017-10-06 22:24:38','globeadmin','2022-01-31 16:18:41','globeadmin'),('59d7d876805433c','547de3bee410196','59d7d6e9ecc73da','','','','','','','2017-10-06 22:24:38','globeadmin','2017-10-06 22:24:38','globeadmin','2022-01-31 16:18:41','globeadmin'),('59d7d87687a7633','547de3bee410196','59d7d745b1eecbf','','','','','','','2017-10-06 22:24:38','globeadmin','2017-10-06 22:24:38','globeadmin','2022-01-31 16:18:41','globeadmin'),('59d7d8768efc533','547de3bee410196','59d7d7986aed52d','','','','','','','2017-10-06 22:24:38','globeadmin','2017-10-06 22:24:38','globeadmin','2022-01-31 16:18:41','globeadmin'),('59d7d876964f01e','547de3bee410196','59d7d7da6d30b22','','','','','','','2017-10-06 22:24:38','globeadmin','2017-10-06 22:24:38','globeadmin','2022-01-31 16:18:41','globeadmin'),('59d7d8769da1d11','547de3bee410196','59d7d837262870c','','','','','','','2017-10-06 22:24:38','globeadmin','2017-10-06 22:24:38','globeadmin','2022-01-31 16:18:41','globeadmin'),('59d7d87a6f3ac0b','547de3e001028e8','59d67ca712d3ffa','','','','','','','2017-10-06 22:24:42','globeadmin','2017-10-06 22:24:42','globeadmin','2019-11-06 15:15:08','globeadmin'),('59d7d87a768db26','547de3e001028e8','59d7d65650da67c','','','','','','','2017-10-06 22:24:42','globeadmin','2017-10-06 22:24:42','globeadmin','2019-11-06 15:15:08','globeadmin'),('59d7d87a7de0b77','547de3e001028e8','59d7d6e9ecc73da','','','','','','','2017-10-06 22:24:42','globeadmin','2017-10-06 22:24:42','globeadmin','2019-11-06 15:15:08','globeadmin'),('59d7d87a8534461','547de3e001028e8','59d7d745b1eecbf','','','','','','','2017-10-06 22:24:42','globeadmin','2017-10-06 22:24:42','globeadmin','2019-11-06 15:15:09','globeadmin'),('59d7d87a8c87c94','547de3e001028e8','59d7d7986aed52d','','','','','','','2017-10-06 22:24:42','globeadmin','2017-10-06 22:24:42','globeadmin','2019-11-06 15:15:08','globeadmin'),('59d7d87a93d9b28','547de3e001028e8','59d7d7da6d30b22','','','','','','','2017-10-06 22:24:42','globeadmin','2017-10-06 22:24:42','globeadmin','2019-11-06 15:15:08','globeadmin'),('59d7d87a9b2caf6','547de3e001028e8','59d7d837262870c','','','','','','','2017-10-06 22:24:42','globeadmin','2017-10-06 22:24:42','globeadmin','2019-11-06 15:15:09','globeadmin'),('59d7d87e78fc55d','5501dbedc785fe4','59d67ca712d3ffa','','','','','','','2017-10-06 22:24:46','globeadmin','2017-10-06 22:24:46','globeadmin','2018-01-09 18:51:10','globeadmin'),('59d7d87e804f30a','5501dbedc785fe4','59d7d65650da67c','','','','','','','2017-10-06 22:24:46','globeadmin','2017-10-06 22:24:46','globeadmin','2018-01-09 18:51:11','globeadmin'),('59d7d87e87a25ec','5501dbedc785fe4','59d7d6e9ecc73da','','','','','','','2017-10-06 22:24:46','globeadmin','2017-10-06 22:24:46','globeadmin','2018-01-09 18:51:10','globeadmin'),('59d7d87e8ef53fd','5501dbedc785fe4','59d7d745b1eecbf','','','','','','','2017-10-06 22:24:46','globeadmin','2017-10-06 22:24:46','globeadmin','2018-01-09 18:51:11','globeadmin'),('59d7d87e9649478','5501dbedc785fe4','59d7d7986aed52d','','','','','','','2017-10-06 22:24:46','globeadmin','2017-10-06 22:24:46','globeadmin','2018-01-09 18:51:10','globeadmin'),('59d7d87e9d9b37b','5501dbedc785fe4','59d7d7da6d30b22','','','','','','','2017-10-06 22:24:46','globeadmin','2017-10-06 22:24:46','globeadmin','2018-01-09 18:51:11','globeadmin'),('59d7d87ea4ee1d0','5501dbedc785fe4','59d7d837262870c','','','','','','','2017-10-06 22:24:46','globeadmin','2017-10-06 22:24:46','globeadmin','2018-01-09 18:51:11','globeadmin'),('59d7d881baecaaf','5601afbc23dfb00','59d67ca712d3ffa','','','','','','','2017-10-06 22:24:49','globeadmin','2017-10-06 22:24:49','globeadmin','2018-11-20 14:42:10','globeadmin'),('59d7d881c2386d1','5601afbc23dfb00','59d7d65650da67c','','','','','','','2017-10-06 22:24:49','globeadmin','2017-10-06 22:24:49','globeadmin','2018-11-20 14:42:11','globeadmin'),('59d7d881c98b551','5601afbc23dfb00','59d7d6e9ecc73da','','','','','','','2017-10-06 22:24:49','globeadmin','2017-10-06 22:24:49','globeadmin','2018-11-20 14:42:10','globeadmin'),('59d7d881d0de721','5601afbc23dfb00','59d7d745b1eecbf','','','','','','','2017-10-06 22:24:49','globeadmin','2017-10-06 22:24:49','globeadmin','2018-11-20 14:42:11','globeadmin'),('59d7d881d831383','5601afbc23dfb00','59d7d7986aed52d','','','','','','','2017-10-06 22:24:49','globeadmin','2017-10-06 22:24:49','globeadmin','2018-11-20 14:42:11','globeadmin'),('59d7d881df84114','5601afbc23dfb00','59d7d7da6d30b22','','','','','','','2017-10-06 22:24:49','globeadmin','2017-10-06 22:24:49','globeadmin','2018-11-20 14:42:11','globeadmin'),('59d7d881e6d73c6','5601afbc23dfb00','59d7d837262870c','','','','','','','2017-10-06 22:24:49','globeadmin','2017-10-06 22:24:49','globeadmin','2018-11-20 14:42:12','globeadmin'),('59d7d88608a9b71','5689468794353da','59d67ca712d3ffa','','','','','','','2017-10-06 22:24:54','globeadmin','2017-10-06 22:24:54','globeadmin','2017-10-06 22:24:54','globeadmin'),('59d7d8861005c22','5689468794353da','59d7d65650da67c','','','','','','','2017-10-06 22:24:54','globeadmin','2017-10-06 22:24:54','globeadmin','2017-10-06 22:24:54','globeadmin'),('59d7d88617512f9','5689468794353da','59d7d6e9ecc73da','','','','','','','2017-10-06 22:24:54','globeadmin','2017-10-06 22:24:54','globeadmin','2017-10-06 22:24:54','globeadmin'),('59d7d8861ea41c8','5689468794353da','59d7d745b1eecbf','','','','','','','2017-10-06 22:24:54','globeadmin','2017-10-06 22:24:54','globeadmin','2017-10-06 22:24:54','globeadmin'),('59d7d88625f688b','5689468794353da','59d7d7986aed52d','','','','','','','2017-10-06 22:24:54','globeadmin','2017-10-06 22:24:54','globeadmin','2017-10-06 22:24:54','globeadmin'),('59d7d8862d489ee','5689468794353da','59d7d7da6d30b22','','','','','','','2017-10-06 22:24:54','globeadmin','2017-10-06 22:24:54','globeadmin','2017-10-06 22:24:54','globeadmin'),('59d7d886349b6e7','5689468794353da','59d7d837262870c','','','','','','','2017-10-06 22:24:54','globeadmin','2017-10-06 22:24:54','globeadmin','2017-10-06 22:24:54','globeadmin'),('59e234004f8a77a','547de3fe0d36089','59e22e4fa1018fd','','','','','','','2017-10-14 18:57:52','globeadmin','2017-10-14 18:57:52','globeadmin','2019-07-01 11:07:00','globeadmin'),('59e2340056ce215','547de3fe0d36089','59da63096606dc0','','','','','','','2017-10-14 18:57:52','globeadmin','2017-10-14 18:57:52','globeadmin','2019-07-01 11:06:59','globeadmin'),('59e234005e279d2','547de3fe0d36089','59e22fca2af8d03','','','','','','','2017-10-14 18:57:52','globeadmin','2017-10-14 18:57:52','globeadmin','2019-07-01 11:07:00','globeadmin'),('59e2340065ca5db','547de3fe0d36089','59e22f9965b5362','','','','','','','2017-10-14 18:57:52','globeadmin','2017-10-14 18:57:52','globeadmin','2019-07-01 11:06:59','globeadmin'),('59e234006ccfa69','547de3fe0d36089','59e22f4f52546e3','','','','','','','2017-10-14 18:57:52','globeadmin','2017-10-14 18:57:52','globeadmin','2019-07-01 11:06:59','globeadmin'),('59e2340074196cc','547de3fe0d36089','59e22ed0a598932','','','','','','','2017-10-14 18:57:52','globeadmin','2017-10-14 18:57:52','globeadmin','2019-07-01 11:06:59','globeadmin'),('59e234007b72d32','547de3fe0d36089','59e23027879009a','','','','','','','2017-10-14 18:57:52','globeadmin','2017-10-14 18:57:52','globeadmin','2019-07-01 11:07:00','globeadmin'),('59e2340082c5aa8','547de3fe0d36089','59e22ff819cd774','','','','','','','2017-10-14 18:57:52','globeadmin','2017-10-14 18:57:52','globeadmin','2019-07-01 11:07:00','globeadmin'),('59e234054f74ee7','5717b9c74a31169','59e22e4fa1018fd','','','','','','','2017-10-14 18:57:57','globeadmin','2017-10-14 18:57:57','globeadmin','2017-10-15 19:02:08','globeadmin'),('59e2340556c4f84','5717b9c74a31169','59da63096606dc0','','','','','','','2017-10-14 18:57:57','globeadmin','2017-10-14 18:57:57','globeadmin','2017-10-15 19:02:07','globeadmin'),('59e234055e17c4f','5717b9c74a31169','59e22fca2af8d03','','','','','','','2017-10-14 18:57:57','globeadmin','2017-10-14 18:57:57','globeadmin','2017-10-15 19:02:08','globeadmin'),('59e23405656b838','5717b9c74a31169','59e22f9965b5362','','','','','','','2017-10-14 18:57:57','globeadmin','2017-10-14 18:57:57','globeadmin','2017-10-15 19:02:07','globeadmin'),('59e234056cbdb08','5717b9c74a31169','59e22f4f52546e3','','','','','','','2017-10-14 18:57:57','globeadmin','2017-10-14 18:57:57','globeadmin','2017-10-15 19:02:08','globeadmin'),('59e234057411083','5717b9c74a31169','59e22ed0a598932','','','','','','','2017-10-14 18:57:57','globeadmin','2017-10-14 18:57:57','globeadmin','2017-10-15 19:02:07','globeadmin'),('59e234057b6a24b','5717b9c74a31169','59e23027879009a','','','','','','','2017-10-14 18:57:57','globeadmin','2017-10-14 18:57:57','globeadmin','2017-10-15 19:02:08','globeadmin'),('59e2340582b6b9c','5717b9c74a31169','59e22ff819cd774','','','','','','','2017-10-14 18:57:57','globeadmin','2017-10-14 18:57:57','globeadmin','2017-10-15 19:02:09','globeadmin'),('59eb9e79b558ff3','547de3fe0d36089','59e90833df79d7d','','','','','','','2017-10-21 22:22:33','globeadmin','2017-10-21 22:22:33','globeadmin','2019-07-01 11:06:56','globeadmin'),('59eb9e805fe1bb9','5717b9c74a31169','59eaf663b08f216','','','','','','','2017-10-21 22:22:40','globeadmin','2017-10-21 22:22:40','globeadmin','2017-10-21 22:22:40','globeadmin'),('59eb9e80673486c','5717b9c74a31169','59ea67cf8d2d9b3','','','','','','','2017-10-21 22:22:40','globeadmin','2017-10-21 22:22:40','globeadmin','2017-10-21 22:22:40','globeadmin'),('59eb9e806e87fc0','5717b9c74a31169','59e90833df79d7d','','','','','','','2017-10-21 22:22:40','globeadmin','2017-10-21 22:22:40','globeadmin','2017-10-21 22:22:40','globeadmin'),('59ecc31758c15f1','5601afbc23dfb00','59e5cdf8d43772d','','','','','','','2017-10-22 19:11:03','globeadmin','2017-10-22 19:11:03','globeadmin','2018-11-20 14:41:58','globeadmin'),('59ecc317600e264','5601afbc23dfb00','59ea67cf8d2d9b3','','','','','','','2017-10-22 19:11:03','globeadmin','2017-10-22 19:11:03','globeadmin','2018-11-20 14:41:59','globeadmin'),('59ecc32100d1f2d','5501dbedc785fe4','59eaf663b08f216','','','','','','','2017-10-22 19:11:13','globeadmin','2017-10-22 19:11:13','globeadmin','2018-01-09 18:50:59','globeadmin'),('59ecc3210824339','5501dbedc785fe4','59e5cdf8d43772d','','','','','','','2017-10-22 19:11:13','globeadmin','2017-10-22 19:11:13','globeadmin','2018-01-09 18:50:59','globeadmin'),('59ecc3210f7d452','5501dbedc785fe4','59ea67cf8d2d9b3','','','','','','','2017-10-22 19:11:13','globeadmin','2017-10-22 19:11:13','globeadmin','2018-01-09 18:50:59','globeadmin'),('59f82449638733e','547de3bee410196','59eaf663b08f216','','','','','','','2017-10-31 09:20:41','globeadmin','2017-10-31 09:20:41','globeadmin','2022-01-31 16:18:38','globeadmin'),('59f824496ae0e80','547de3bee410196','59e5cdf8d43772d','','','','','','','2017-10-31 09:20:41','globeadmin','2017-10-31 09:20:41','globeadmin','2022-01-31 16:18:38','globeadmin'),('59f824497232e96','547de3bee410196','59ea67cf8d2d9b3','','','','','','','2017-10-31 09:20:41','globeadmin','2017-10-31 09:20:41','globeadmin','2022-01-31 16:18:38','globeadmin'),('59f82449798087f','547de3bee410196','59f607fc7a2c0b2','','','','','','','2017-10-31 09:20:41','globeadmin','2017-10-31 09:20:41','globeadmin','2022-01-31 16:18:38','globeadmin'),('59f8244d5c2c2ad','547de3e001028e8','59eaf663b08f216','','','','','','','2017-10-31 09:20:45','globeadmin','2017-10-31 09:20:45','globeadmin','2019-11-06 15:15:03','globeadmin'),('59f8244d637ef51','547de3e001028e8','59e5cdf8d43772d','','','','','','','2017-10-31 09:20:45','globeadmin','2017-10-31 09:20:45','globeadmin','2019-11-06 15:15:02','globeadmin'),('59f8244d6ad83c5','547de3e001028e8','59ea67cf8d2d9b3','','','','','','','2017-10-31 09:20:45','globeadmin','2017-10-31 09:20:45','globeadmin','2019-11-06 15:15:02','globeadmin'),('59f8244d72251a2','547de3e001028e8','59f607fc7a2c0b2','','','','','','','2017-10-31 09:20:45','globeadmin','2017-10-31 09:20:45','globeadmin','2019-11-06 15:15:03','globeadmin'),('59f82450aa4a19e','5501dbedc785fe4','59f607fc7a2c0b2','','','','','','','2017-10-31 09:20:48','globeadmin','2017-10-31 09:20:48','globeadmin','2018-01-09 18:50:59','globeadmin'),('59f824547976436','5601afbc23dfb00','59f607fc7a2c0b2','','','','','','','2017-10-31 09:20:52','globeadmin','2017-10-31 09:20:52','globeadmin','2018-11-20 14:41:59','globeadmin'),('59f82457c7935a3','5689468794353da','59eaf663b08f216','','','','','','','2017-10-31 09:20:55','globeadmin','2017-10-31 09:20:55','globeadmin','2017-10-31 09:20:55','globeadmin'),('59f82457cee64a6','5689468794353da','59e5cdf8d43772d','','','','','','','2017-10-31 09:20:55','globeadmin','2017-10-31 09:20:55','globeadmin','2017-10-31 09:20:55','globeadmin'),('59f82457d63852a','5689468794353da','59ea67cf8d2d9b3','','','','','','','2017-10-31 09:20:55','globeadmin','2017-10-31 09:20:55','globeadmin','2017-10-31 09:20:55','globeadmin'),('59f82457dd8a7de','5689468794353da','59f607fc7a2c0b2','','','','','','','2017-10-31 09:20:55','globeadmin','2017-10-31 09:20:55','globeadmin','2017-10-31 09:20:55','globeadmin'),('59feec69b7ab6fd','5601afbc23dfb00','59fe027dd6fe9f8','','','','','','','2017-11-05 12:48:09','globeadmin','2017-11-05 12:48:09','globeadmin','2018-11-20 14:41:59','globeadmin'),('59feec6e3161469','5689468794353da','59fe027dd6fe9f8','','','','','','','2017-11-05 12:48:14','globeadmin','2017-11-05 12:48:14','globeadmin','2017-11-05 12:48:14','globeadmin'),('5a109d6db893b19','5501dbedc785fe4','5a1011c80a896b3','','','','','','','2017-11-18 22:51:57','globeadmin','2017-11-18 22:51:57','globeadmin','2018-01-09 18:51:04','globeadmin'),('5a109d7856e2fc5','5601afbc23dfb00','5a1011c80a896b3','','','','','','','2017-11-18 22:52:08','globeadmin','2017-11-18 22:52:08','globeadmin','2018-11-20 14:42:04','globeadmin'),('5a60d461b2193f4','547de3bee410196','5a607704e048c15','','','','','','','2018-01-18 19:07:45','globeadmin','2018-01-18 19:07:45','globeadmin','2022-01-31 16:18:39','globeadmin'),('5a2c27395cc8810','547de3bee410196','5a28402a618a46f','','','','','','','2017-12-09 20:11:05','globeadmin','2017-12-09 20:11:05','globeadmin','2022-01-31 16:18:38','globeadmin'),('5a2c273cb98bfe2','547de3e001028e8','5a28402a618a46f','','','','','','','2017-12-09 20:11:08','globeadmin','2017-12-09 20:11:08','globeadmin','2019-11-06 15:15:03','globeadmin'),('5a2c2743556decb','5501dbedc785fe4','5a28402a618a46f','','','','','','','2017-12-09 20:11:15','globeadmin','2017-12-09 20:11:15','globeadmin','2018-01-09 18:51:00','globeadmin'),('5a2c2746c3483bb','5601afbc23dfb00','5a28402a618a46f','','','','','','','2017-12-09 20:11:18','globeadmin','2017-12-09 20:11:18','globeadmin','2018-11-20 14:42:00','globeadmin'),('5a2c274becc52f2','5689468794353da','5a28402a618a46f','','','','','','','2017-12-09 20:11:23','globeadmin','2017-12-09 20:11:23','globeadmin','2017-12-09 20:11:23','globeadmin'),('5a4a032689eaa4f','5501dbedc785fe4','5a36abffedf9461','','','','','','','2018-01-01 11:45:10','globeadmin','2018-01-01 11:45:10','globeadmin','2018-01-09 18:51:12','globeadmin'),('5a4a032cd0b5bae','5601afbc23dfb00','5a36abffedf9461','','','','','','','2018-01-01 11:45:16','globeadmin','2018-01-01 11:45:16','globeadmin','2018-11-20 14:42:12','globeadmin'),('5a4b776226597f4','547de3e001028e8','554517bdc18334d','','','','','','','2018-01-02 14:13:22','globeadmin','2018-01-02 14:13:22','globeadmin','2019-11-06 15:15:05','globeadmin'),('5a54f74d84f3db6','5501dbedc785fe4','5a4e32f55d7faf5','','','','','','','2018-01-09 19:09:33','globeadmin','2018-01-09 19:09:33','globeadmin','2018-01-09 19:09:33','globeadmin'),('5a54f74d912731d','5501dbedc785fe4','5a54c08c836c142','','','','','','','2018-01-09 19:09:33','globeadmin','2018-01-09 19:09:33','globeadmin','2018-01-09 19:09:33','globeadmin'),('5a54f751282965e','5601afbc23dfb00','5a4e32f55d7faf5','','','','','','','2018-01-09 19:09:37','globeadmin','2018-01-09 19:09:37','globeadmin','2018-11-20 14:42:05','globeadmin'),('5a54f7512f7c5bd','5601afbc23dfb00','5a54c08c836c142','','','','','','','2018-01-09 19:09:37','globeadmin','2018-01-09 19:09:37','globeadmin','2018-11-20 14:42:06','globeadmin'),('5a54f7543e20179','547de3bee410196','5a4e32f55d7faf5','','','','','','','2018-01-09 19:09:40','globeadmin','2018-01-09 19:09:40','globeadmin','2022-01-31 16:18:39','globeadmin'),('5a54f754457358d','547de3bee410196','5a54c08c836c142','','','','','','','2018-01-09 19:09:40','globeadmin','2018-01-09 19:09:40','globeadmin','2022-01-31 16:18:40','globeadmin'),('5a60d466506d59c','547de3e001028e8','5a607704e048c15','','','','','','','2018-01-18 19:07:50','globeadmin','2018-01-18 19:07:50','globeadmin','2019-11-06 15:15:05','globeadmin'),('5a60d46a99a80c3','5501dbedc785fe4','5a607704e048c15','','','','','','','2018-01-18 19:07:54','globeadmin','2018-01-18 19:07:54','globeadmin','2018-01-18 19:07:54','globeadmin'),('5a60d46da84bc67','5601afbc23dfb00','5a607704e048c15','','','','','','','2018-01-18 19:07:57','globeadmin','2018-01-18 19:07:57','globeadmin','2018-11-20 14:42:04','globeadmin'),('5a60d471f25fd6a','5689468794353da','5a607704e048c15','','','','','','','2018-01-18 19:08:01','globeadmin','2018-01-18 19:08:01','globeadmin','2018-01-18 19:08:01','globeadmin'),('5a773f1121c4e4a','5501dbedc785fe4','5a7738b60e35797','','','','','','','2018-02-04 19:12:49','globeadmin','2018-02-04 19:12:49','globeadmin','2018-02-04 19:12:49','globeadmin'),('5a773f14af5c1a2','5601afbc23dfb00','5a7738b60e35797','','','','','','','2018-02-04 19:12:52','globeadmin','2018-02-04 19:12:52','globeadmin','2018-11-20 14:42:00','globeadmin'),('5b0488d502b0d29','547de3bee410196','5b04854d1104747','','','','','','','2018-05-23 00:17:09','globeadmin','2018-05-23 00:17:09','globeadmin','2022-01-31 16:18:41','globeadmin'),('5b0488d8b290d86','547de3e001028e8','5b04854d1104747','','','','','','','2018-05-23 00:17:12','globeadmin','2018-05-23 00:17:12','globeadmin','2019-11-06 15:15:07','globeadmin'),('5b0488de7cbd61a','5501dbedc785fe4','5b04854d1104747','','','','','','','2018-05-23 00:17:18','globeadmin','2018-05-23 00:17:18','globeadmin','2018-05-23 00:17:18','globeadmin'),('5b0488e11d85610','5601afbc23dfb00','5b04854d1104747','','','','','','','2018-05-23 00:17:21','globeadmin','2018-05-23 00:17:21','globeadmin','2018-11-20 14:42:10','globeadmin'),('5b0488e74974bac','5689468794353da','5b04854d1104747','','','','','','','2018-05-23 00:17:27','globeadmin','2018-05-23 00:17:27','globeadmin','2018-05-23 00:17:27','globeadmin'),('5b0712dd381f5fc','547de3bee410196','5b070b1a5c6dfb0','','','','','','','2018-05-24 22:30:37','globeadmin','2018-05-24 22:30:37','globeadmin','2022-01-31 16:18:41','globeadmin'),('5b0712e052feba1','547de3e001028e8','5b070b1a5c6dfb0','','','','','','','2018-05-24 22:30:40','globeadmin','2018-05-24 22:30:40','globeadmin','2019-11-06 15:15:08','globeadmin'),('5b0712e2a5f920d','547de3fe0d36089','5b070b1a5c6dfb0','','','','','','','2018-05-24 22:30:42','globeadmin','2018-05-24 22:30:42','globeadmin','2019-07-01 11:07:01','globeadmin'),('5b0712e53cfc85d','5501dbedc785fe4','5b070b1a5c6dfb0','','','','','','','2018-05-24 22:30:45','globeadmin','2018-05-24 22:30:45','globeadmin','2018-05-24 22:30:45','globeadmin'),('5b0712e7b49c260','5601afbc23dfb00','5b070b1a5c6dfb0','','','','','','','2018-05-24 22:30:47','globeadmin','2018-05-24 22:30:47','globeadmin','2018-11-20 14:42:10','globeadmin'),('5b0712eb2971524','5689468794353da','5b070b1a5c6dfb0','','','','','','','2018-05-24 22:30:51','globeadmin','2018-05-24 22:30:51','globeadmin','2018-05-24 22:30:51','globeadmin'),('5b0712ee6dcb3b3','5717b9c74a31169','5b070b1a5c6dfb0','','','','','','','2018-05-24 22:30:54','globeadmin','2018-05-24 22:30:54','globeadmin','2018-05-24 22:30:54','globeadmin'),('5b2142a2b577d50','547de3bee410196','5b1f98c3701d658','','','','','','','2018-06-13 19:13:22','globeadmin','2018-06-13 19:13:22','globeadmin','2022-01-31 16:18:42','globeadmin'),('5b2142a4d0517c6','547de3e001028e8','5b1f98c3701d658','','','','','','','2018-06-13 19:13:24','globeadmin','2018-06-13 19:13:24','globeadmin','2019-11-06 15:15:09','globeadmin'),('5b2142a6d532525','547de3fe0d36089','5b1f98c3701d658','','','','','','','2018-06-13 19:13:26','globeadmin','2018-06-13 19:13:26','globeadmin','2019-07-01 11:07:02','globeadmin'),('5b2142a9c1a9353','5501dbedc785fe4','5b1f98c3701d658','','','','','','','2018-06-13 19:13:29','globeadmin','2018-06-13 19:13:29','globeadmin','2018-06-13 19:13:29','globeadmin'),('5b2142acc1a8985','5601afbc23dfb00','5b1f98c3701d658','','','','','','','2018-06-13 19:13:32','globeadmin','2018-06-13 19:13:32','globeadmin','2018-11-20 14:42:13','globeadmin'),('5b2142b058a9e27','5689468794353da','5b1f98c3701d658','','','','','','','2018-06-13 19:13:36','globeadmin','2018-06-13 19:13:36','globeadmin','2018-06-13 19:13:36','globeadmin'),('5b2142b2d0498a2','5717b9c74a31169','5b1f98c3701d658','','','','','','','2018-06-13 19:13:38','globeadmin','2018-06-13 19:13:38','globeadmin','2018-06-13 19:13:38','globeadmin'),('5b7132906d1b147','547de3e001028e8','5564d8431a9da4b','','','','','','','2018-08-13 10:26:08','globeadmin','2018-08-13 10:26:08','globeadmin','2019-11-06 15:15:02','globeadmin'),('5c086361ace0267','547de3bee410196','5c053bad46326aa','','','','','','','2018-12-06 01:46:41','globeadmin','2018-12-06 01:46:41','globeadmin','2022-01-31 16:18:40','globeadmin'),('5c086365ddb1c96','5501dbedc785fe4','5c053bad46326aa','','','','','','','2018-12-06 01:46:45','globeadmin','2018-12-06 01:46:45','globeadmin','2018-12-06 01:46:45','globeadmin'),('5c08636874b773d','5601afbc23dfb00','5c053bad46326aa','','','','','','','2018-12-06 01:46:48','globeadmin','2018-12-06 01:46:48','globeadmin','2018-12-06 01:46:48','globeadmin'),('5c840f653ae7dc1','547de3bee410196','5c838179bfcf3d0','','','','','','','2019-03-09 21:09:25','globeadmin','2019-03-09 21:09:25','globeadmin','2022-01-31 16:18:41','globeadmin'),('5c840f677a6077b','547de3e001028e8','5c838179bfcf3d0','','','','','','','2019-03-09 21:09:27','globeadmin','2019-03-09 21:09:27','globeadmin','2019-11-06 15:15:08','globeadmin'),('5c840f6ce83a4b3','5501dbedc785fe4','5c838179bfcf3d0','','','','','','','2019-03-09 21:09:32','globeadmin','2019-03-09 21:09:32','globeadmin','2019-03-09 21:09:32','globeadmin'),('5c840f705a9d588','5601afbc23dfb00','5c838179bfcf3d0','','','','','','','2019-03-09 21:09:36','globeadmin','2019-03-09 21:09:36','globeadmin','2019-03-09 21:09:36','globeadmin'),('5c840f73e5c3b30','5689468794353da','5c838179bfcf3d0','','','','','','','2019-03-09 21:09:39','globeadmin','2019-03-09 21:09:39','globeadmin','2019-03-09 21:09:39','globeadmin'),('5dc2c2acdd9de0a','547de3bee410196','5dc273803a8d0d6','','','','','','','2019-11-06 14:55:08','globeadmin','2019-11-06 14:55:08','globeadmin','2022-01-31 16:18:39','globeadmin'),('5dc2c2afce669fc','547de3e001028e8','5dc273803a8d0d6','','','','','','','2019-11-06 14:55:11','globeadmin','2019-11-06 14:55:11','globeadmin','2019-11-06 15:15:04','globeadmin'),('5dc2c2b3556632e','5501dbedc785fe4','5dc273803a8d0d6','','','','','','','2019-11-06 14:55:15','globeadmin','2019-11-06 14:55:15','globeadmin','2019-11-06 14:55:15','globeadmin'),('5dc2c2b61b21715','5601afbc23dfb00','5dc273803a8d0d6','','','','','','','2019-11-06 14:55:18','globeadmin','2019-11-06 14:55:18','globeadmin','2019-11-06 14:55:18','globeadmin'),('5dc2c2ba59b081c','5689468794353da','5dc273803a8d0d6','','','','','','','2019-11-06 14:55:22','globeadmin','2019-11-06 14:55:22','globeadmin','2019-11-06 14:55:22','globeadmin'),('5f43ec964d2f317','5501dbedc785fe4','5e85a2a072783b3','','','','','','','2020-08-24 19:36:38','globeadmin','2020-08-24 19:36:38','globeadmin','2020-08-24 19:36:38','globeadmin'),('5f43ec9adf22557','5601afbc23dfb00','5e85a2a072783b3','','','','','','','2020-08-24 19:36:42','globeadmin','2020-08-24 19:36:42','globeadmin','2020-08-24 19:36:42','globeadmin'),('5f7cea8b44af3f4','547de3bee410196','5f7cd744d8ace2f','','','','','','','2020-10-07 01:07:07','globeadmin','2020-10-07 01:07:07','globeadmin','2022-01-31 16:18:37','globeadmin'),('5f6af5bede4fbc8','5717b9c74a31169','5f609a0c726f729','','','','','','','2020-09-23 10:14:06','globeadmin','2020-09-23 10:14:06','globeadmin','2020-09-23 10:14:06','globeadmin'),('5f6af52c97e91a4','547de3bee410196','5f6a50545e4de79','','','','','','','2020-09-23 10:11:40','globeadmin','2020-09-23 10:11:40','globeadmin','2022-01-31 16:18:41','globeadmin'),('5f6af52c987cb07','547de3bee410196','5f5fc06e94c4759','','','','','','','2020-09-23 10:11:40','globeadmin','2020-09-23 10:11:40','globeadmin','2022-01-31 16:18:38','globeadmin'),('5f6af52c98f2b4c','547de3bee410196','5f68d148d9f3222','','','','','','','2020-09-23 10:11:40','globeadmin','2020-09-23 10:11:40','globeadmin','2022-01-31 16:18:37','globeadmin'),('5f6af5308058016','547de3e001028e8','5f6a50545e4de79','','','','','','','2020-09-23 10:11:44','globeadmin','2020-09-23 10:11:44','globeadmin','2020-09-23 10:11:44','globeadmin'),('5f6af53080cfcb1','547de3e001028e8','5f5fc06e94c4759','','','','','','','2020-09-23 10:11:44','globeadmin','2020-09-23 10:11:44','globeadmin','2020-09-23 10:11:44','globeadmin'),('5f6af5308139fe3','547de3e001028e8','5f68d148d9f3222','','','','','','','2020-09-23 10:11:44','globeadmin','2020-09-23 10:11:44','globeadmin','2020-09-23 10:11:44','globeadmin'),('5f6af534b64fa90','5501dbedc785fe4','5f6a50545e4de79','','','','','','','2020-09-23 10:11:48','globeadmin','2020-09-23 10:11:48','globeadmin','2020-09-23 10:11:48','globeadmin'),('5f6af534b6c4a1d','5501dbedc785fe4','5f5fc06e94c4759','','','','','','','2020-09-23 10:11:48','globeadmin','2020-09-23 10:11:48','globeadmin','2020-09-23 10:11:48','globeadmin'),('5f6af534b72c5e0','5501dbedc785fe4','5f68d148d9f3222','','','','','','','2020-09-23 10:11:48','globeadmin','2020-09-23 10:11:48','globeadmin','2020-09-23 10:11:48','globeadmin'),('5f6af538aa61183','5601afbc23dfb00','5f6a50545e4de79','','','','','','','2020-09-23 10:11:52','globeadmin','2020-09-23 10:11:52','globeadmin','2020-09-23 10:11:52','globeadmin'),('5f6af538aad4319','5601afbc23dfb00','5f5fc06e94c4759','','','','','','','2020-09-23 10:11:52','globeadmin','2020-09-23 10:11:52','globeadmin','2020-09-23 10:11:52','globeadmin'),('5f6af538ab39d48','5601afbc23dfb00','5f68d148d9f3222','','','','','','','2020-09-23 10:11:52','globeadmin','2020-09-23 10:11:52','globeadmin','2020-09-23 10:11:52','globeadmin'),('5f6af53cb622ee3','5689468794353da','5f6a50545e4de79','','','','','','','2020-09-23 10:11:56','globeadmin','2020-09-23 10:11:56','globeadmin','2020-09-23 10:11:56','globeadmin'),('5f6af53cb6a4c6a','5689468794353da','5f5fc06e94c4759','','','','','','','2020-09-23 10:11:56','globeadmin','2020-09-23 10:11:56','globeadmin','2020-09-23 10:11:56','globeadmin'),('5f6af53cb718713','5689468794353da','5f68d148d9f3222','','','','','','','2020-09-23 10:11:56','globeadmin','2020-09-23 10:11:56','globeadmin','2020-09-23 10:11:56','globeadmin'),('60395aa60522d19','547de3bee410196','60380fd5e427d6b','','','','','','','2021-02-26 22:31:34','globeadmin','2021-02-26 22:31:34','globeadmin','2022-01-31 16:18:37','globeadmin'),('5f6cf0510dbd7dc','5501dbedc785fe4','5f6cee92b5f274a','','','','','','','2020-09-24 22:15:29','globeadmin','2020-09-24 22:15:29','globeadmin','2020-09-24 22:15:29','globeadmin'),('5f6cf0510e49981','5501dbedc785fe4','5f6cbe6fd03a211','','','','','','','2020-09-24 22:15:29','globeadmin','2020-09-24 22:15:29','globeadmin','2020-09-24 22:15:29','globeadmin'),('5f6cf054b703a8f','5601afbc23dfb00','5f6cee92b5f274a','','','','','','','2020-09-24 22:15:32','globeadmin','2020-09-24 22:15:32','globeadmin','2020-09-24 22:15:32','globeadmin'),('5f6cf054b77be71','5601afbc23dfb00','5f6cbe6fd03a211','','','','','','','2020-09-24 22:15:32','globeadmin','2020-09-24 22:15:32','globeadmin','2020-09-24 22:15:32','globeadmin'),('5f7cea8e4c9f1ce','547de3e001028e8','5f7cd744d8ace2f','','','','','','','2020-10-07 01:07:10','globeadmin','2020-10-07 01:07:10','globeadmin','2020-10-07 01:07:10','globeadmin'),('5f7cea92c9cd01c','5501dbedc785fe4','5f7cd744d8ace2f','','','','','','','2020-10-07 01:07:14','globeadmin','2020-10-07 01:07:14','globeadmin','2020-10-07 01:07:14','globeadmin'),('5f7cea969e6684d','5601afbc23dfb00','5f7cd744d8ace2f','','','','','','','2020-10-07 01:07:18','globeadmin','2020-10-07 01:07:18','globeadmin','2020-10-07 01:07:18','globeadmin'),('5f7cea9c0d870f4','5689468794353da','5f7cd744d8ace2f','','','','','','','2020-10-07 01:07:24','globeadmin','2020-10-07 01:07:24','globeadmin','2020-10-07 01:07:24','globeadmin'),('5f8b75fd075dbe1','547de3bee410196','5f8b690f7120805','','','','','','','2020-10-18 01:53:49','globeadmin','2020-10-18 01:53:49','globeadmin','2022-01-31 16:18:41','globeadmin'),('5f8b75fd07e18d3','547de3bee410196','5f8b4f77ca6b53e','','','','','','','2020-10-18 01:53:49','globeadmin','2020-10-18 01:53:49','globeadmin','2022-01-31 16:18:41','globeadmin'),('5f8b76015245693','5501dbedc785fe4','5f8b690f7120805','','','','','','','2020-10-18 01:53:53','globeadmin','2020-10-18 01:53:53','globeadmin','2020-10-18 01:53:53','globeadmin'),('5f8b760152c06b5','5501dbedc785fe4','5f8b4f77ca6b53e','','','','','','','2020-10-18 01:53:53','globeadmin','2020-10-18 01:53:53','globeadmin','2020-10-18 01:53:53','globeadmin'),('5f8b7604cc1b470','5601afbc23dfb00','5f8b690f7120805','','','','','','','2020-10-18 01:53:56','globeadmin','2020-10-18 01:53:56','globeadmin','2020-10-18 01:53:56','globeadmin'),('5f8b7604ccf9b7f','5601afbc23dfb00','5f8b4f77ca6b53e','','','','','','','2020-10-18 01:53:56','globeadmin','2020-10-18 01:53:56','globeadmin','2020-10-18 01:53:56','globeadmin'),('60395aaab45cf6e','547de3e001028e8','60380fd5e427d6b','','','','','','','2021-02-26 22:31:38','globeadmin','2021-02-26 22:31:38','globeadmin','2021-02-26 22:31:38','globeadmin'),('60395ab084dba68','5501dbedc785fe4','60380fd5e427d6b','','','','','','','2021-02-26 22:31:44','globeadmin','2021-02-26 22:31:44','globeadmin','2021-02-26 22:31:44','globeadmin'),('60395ab5448c98e','5601afbc23dfb00','60380fd5e427d6b','','','','','','','2021-02-26 22:31:49','globeadmin','2021-02-26 22:31:49','globeadmin','2021-02-26 22:31:49','globeadmin'),('60395aba1355c50','5689468794353da','60380fd5e427d6b','','','','','','','2021-02-26 22:31:54','globeadmin','2021-02-26 22:31:54','globeadmin','2021-02-26 22:31:54','globeadmin'),('60475b5ac4d4ea1','60475aa35186b93','547d6ec60ac6bdd','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5ac5504ab','60475aa35186b93','548338073921bfe','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5ac5b684f','60475aa35186b93','54835ec50abe722','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5ac61b1fb','60475aa35186b93','5495dad1762dc2c','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5ac692f83','60475aa35186b93','54a65ecc3f14737','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5ac6f894b','60475aa35186b93','5476201e5a3d38f','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5ac7578de','60475aa35186b93','54f735c7d56625f','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5ac7be6b9','60475aa35186b93','5501db35db0c716','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5ac821d01','60475aa35186b93','5509671b4e81a07','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5ac87feb8','60475aa35186b93','54707c8612b1b6b','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5ac94f03a','60475aa35186b93','550dbae55f33b5f','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5ac9b3e6f','60475aa35186b93','55127aebdf42446','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5aca1502c','60475aa35186b93','551821232f9553f','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5aca75333','60475aa35186b93','55222f79d342b66','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5acad565c','60475aa35186b93','55261f6b593bdba','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5acb46f0b','60475aa35186b93','551a34a930825c0','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5acbaa0d2','60475aa35186b93','552cf4b2df9bcce','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5acc0c2f7','60475aa35186b93','5538ff58cb7b4b8','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5acc6ea24','60475aa35186b93','55479f1837f6df0','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5acccd032','60475aa35186b93','56192a97203c280','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5acd2da35','60475aa35186b93','562362d2ef4f556','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5acda414e','60475aa35186b93','5627e58b8ed5f6d','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5ace095db','60475aa35186b93','562e770b79c0722','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5ace6b51d','60475aa35186b93','562d11f6d45ccf1','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5aceccaeb','60475aa35186b93','56dd9f180d22b31','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5acf309eb','60475aa35186b93','56e052ae98309fe','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5acf94a97','60475aa35186b93','56e98e66abfe2c1','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5acff9202','60475aa35186b93','56eae5254137ba7','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5ad074601','60475aa35186b93','5711e1d915f5011','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5ad0dad67','60475aa35186b93','577ebb808309312','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5ad13f7cc','60475aa35186b93','571354ed43a4d47','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5ad1a1e4e','60475aa35186b93','5713df2963f613a','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5ad204468','60475aa35186b93','5719cb61e92d4e8','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5ad267423','60475aa35186b93','571bae293e43d23','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5ad2f50ae','60475aa35186b93','57400922b87c65a','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5ad35a395','60475aa35186b93','54a4107cddefff1','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5ad3be85e','60475aa35186b93','5741fe1502bb6c2','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5ad42336e','60475aa35186b93','5742996ed6426f1','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5ad487a29','60475aa35186b93','57457fe729a1d1c','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5ad4f814e','60475aa35186b93','5787f33aaa172a1','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5ad561d5c','60475aa35186b93','578e9b35d4d3cf8','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5ad5cbe3a','60475aa35186b93','572af54adfe5517','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5ad6307e0','60475aa35186b93','57dae2cd92d16c0','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5ad69a6c8','60475aa35186b93','5525421c67a48bc','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5ad701751','60475aa35186b93','580ba2a48260384','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5ad778983','60475aa35186b93','580cdf151b06780','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5ad7e0347','60475aa35186b93','5812516a1bf18a5','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5ad84711f','60475aa35186b93','584bd01a9203a9a','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5ad8ae398','60475aa35186b93','599591df20eb2f7','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5ad912bad','60475aa35186b93','599954a01e175cd','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5ad977cac','60475aa35186b93','59a96e2c710af4a','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5ad9eacad','60475aa35186b93','59cfad675ee667a','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5ada530ef','60475aa35186b93','59fe027dd6fe9f8','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5adabdcf6','60475aa35186b93','59d67ca712d3ffa','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5adb259fb','60475aa35186b93','59d7d65650da67c','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5adb8d327','60475aa35186b93','59d7d6e9ecc73da','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5adbf6062','60475aa35186b93','59d7d745b1eecbf','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5adc6ed02','60475aa35186b93','59d7d7986aed52d','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5adcdb01e','60475aa35186b93','59d7d7da6d30b22','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5add4675e','60475aa35186b93','59d7d837262870c','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5addb1ca0','60475aa35186b93','59eaf663b08f216','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5ade1aa65','60475aa35186b93','59e5cdf8d43772d','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5ade82792','60475aa35186b93','59ea67cf8d2d9b3','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5adf0bf75','60475aa35186b93','59f607fc7a2c0b2','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5adf79394','60475aa35186b93','5a28402a618a46f','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5adfe4ec1','60475aa35186b93','554517bdc18334d','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5ae04f6dc','60475aa35186b93','5a607704e048c15','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5ae0bacab','60475aa35186b93','5b04854d1104747','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5ae136c15','60475aa35186b93','5b070b1a5c6dfb0','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5ae1a5f19','60475aa35186b93','5b1f98c3701d658','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5ae2141d4','60475aa35186b93','5564d8431a9da4b','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5ae27e7ef','60475aa35186b93','5c838179bfcf3d0','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5ae2ec2f4','60475aa35186b93','5dc273803a8d0d6','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5ae35a17d','60475aa35186b93','5f6a50545e4de79','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5ae3d69a6','60475aa35186b93','5f5fc06e94c4759','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5ae447af0','60475aa35186b93','5f68d148d9f3222','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5ae4baaa7','60475aa35186b93','5f7cd744d8ace2f','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5ae52bf30','60475aa35186b93','60380fd5e427d6b','','','','','','','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('617a88119731366','5601afbc23dfb00','6175a7faca903a3','','','','','','','2021-10-28 14:22:57','globeadmin','2021-10-28 14:22:57','globeadmin','2021-10-28 14:22:57','globeadmin'),('617a881197aadd8','5601afbc23dfb00','616c8bafd921bae','','','','','','','2021-10-28 14:22:57','globeadmin','2021-10-28 14:22:57','globeadmin','2021-10-28 14:22:57','globeadmin'),('617a88119815880','5601afbc23dfb00','61744f1b13259e3','','','','','','','2021-10-28 14:22:57','globeadmin','2021-10-28 14:22:57','globeadmin','2021-10-28 14:22:57','globeadmin'),('61d89ad4636c719','547de3bee410196','6175a7faca903a3','','','','','','','2022-01-07 21:56:04','globeadmin','2022-01-07 21:56:04','globeadmin','2022-01-31 16:18:40','globeadmin'),('61d89ad463f5698','547de3bee410196','616c8bafd921bae','','','','','','','2022-01-07 21:56:04','globeadmin','2022-01-07 21:56:04','globeadmin','2022-01-31 16:18:40','globeadmin'),('61d89ad46467bdd','547de3bee410196','61744f1b13259e3','','','','','','','2022-01-07 21:56:04','globeadmin','2022-01-07 21:56:04','globeadmin','2022-01-31 16:18:40','globeadmin'),('61d89ad464d84b8','547de3bee410196','61d88d6b6d133c3','','','','','','','2022-01-07 21:56:04','globeadmin','2022-01-07 21:56:04','globeadmin','2022-01-31 16:18:40','globeadmin'),('61d89adc7012549','5501dbedc785fe4','6175a7faca903a3','','','','','','','2022-01-07 21:56:12','globeadmin','2022-01-07 21:56:12','globeadmin','2022-01-07 21:56:12','globeadmin'),('61d89adc70877da','5501dbedc785fe4','616c8bafd921bae','','','','','','','2022-01-07 21:56:12','globeadmin','2022-01-07 21:56:12','globeadmin','2022-01-07 21:56:12','globeadmin'),('61d89adc70f0085','5501dbedc785fe4','61744f1b13259e3','','','','','','','2022-01-07 21:56:12','globeadmin','2022-01-07 21:56:12','globeadmin','2022-01-07 21:56:12','globeadmin'),('61d89adc71570a5','5501dbedc785fe4','61d88d6b6d133c3','','','','','','','2022-01-07 21:56:12','globeadmin','2022-01-07 21:56:12','globeadmin','2022-01-07 21:56:12','globeadmin'),('61d89adf5571ff8','5601afbc23dfb00','61d88d6b6d133c3','','','','','','','2022-01-07 21:56:15','globeadmin','2022-01-07 21:56:15','globeadmin','2022-01-07 21:56:15','globeadmin'),('61d9995e9da4aab','547de3e001028e8','6175a7faca903a3','','','','','','','2022-01-08 16:02:06','globeadmin','2022-01-08 16:02:06','globeadmin','2022-01-08 16:02:06','globeadmin'),('61d9995e9e1bfa7','547de3e001028e8','616c8bafd921bae','','','','','','','2022-01-08 16:02:06','globeadmin','2022-01-08 16:02:06','globeadmin','2022-01-08 16:02:06','globeadmin'),('61d9995e9e83c01','547de3e001028e8','61744f1b13259e3','','','','','','','2022-01-08 16:02:06','globeadmin','2022-01-08 16:02:06','globeadmin','2022-01-08 16:02:06','globeadmin'),('61d9995e9eeacff','547de3e001028e8','61d88d6b6d133c3','','','','','','','2022-01-08 16:02:06','globeadmin','2022-01-08 16:02:06','globeadmin','2022-01-08 16:02:06','globeadmin'),('61d99968c84a2ea','5689468794353da','6175a7faca903a3','','','','','','','2022-01-08 16:02:16','globeadmin','2022-01-08 16:02:16','globeadmin','2022-01-08 16:02:16','globeadmin'),('61d99968c8bb153','5689468794353da','616c8bafd921bae','','','','','','','2022-01-08 16:02:16','globeadmin','2022-01-08 16:02:16','globeadmin','2022-01-08 16:02:16','globeadmin'),('61d99968c91cfa4','5689468794353da','61744f1b13259e3','','','','','','','2022-01-08 16:02:16','globeadmin','2022-01-08 16:02:16','globeadmin','2022-01-08 16:02:16','globeadmin'),('61d99968c98bfe3','5689468794353da','61d88d6b6d133c3','','','','','','','2022-01-08 16:02:16','globeadmin','2022-01-08 16:02:16','globeadmin','2022-01-08 16:02:16','globeadmin'),('61d9996c48d4273','60475aa35186b93','6175a7faca903a3','','','','','','','2022-01-08 16:02:20','globeadmin','2022-01-08 16:02:20','globeadmin','2022-01-08 16:02:20','globeadmin'),('61d9996c494dc1a','60475aa35186b93','616c8bafd921bae','','','','','','','2022-01-08 16:02:20','globeadmin','2022-01-08 16:02:20','globeadmin','2022-01-08 16:02:20','globeadmin'),('61d9996c49bdb47','60475aa35186b93','61744f1b13259e3','','','','','','','2022-01-08 16:02:20','globeadmin','2022-01-08 16:02:20','globeadmin','2022-01-08 16:02:20','globeadmin'),('61d9996c4a2cb1d','60475aa35186b93','61d88d6b6d133c3','','','','','','','2022-01-08 16:02:20','globeadmin','2022-01-08 16:02:20','globeadmin','2022-01-08 16:02:20','globeadmin'),('6206e5f360cfde8','561928b27d0261b','6206ad009f3ac5e','','','','','','','2022-02-12 00:40:51','globeadmin','2022-02-12 00:40:51','globeadmin','2022-02-12 00:40:51','globeadmin'),('6206e604cc24e73','547de3bee410196','6206ad009f3ac5e','','','','','','','2022-02-12 00:41:08','globeadmin','2022-02-12 00:41:08','globeadmin','2022-02-12 00:41:08','globeadmin'),('6206e60934d2d49','5501dbedc785fe4','6206ad009f3ac5e','','','','','','','2022-02-12 00:41:13','globeadmin','2022-02-12 00:41:13','globeadmin','2022-02-12 00:41:13','globeadmin'),('6206e60be9891fd','5601afbc23dfb00','6206ad009f3ac5e','','','','','','','2022-02-12 00:41:15','globeadmin','2022-02-12 00:41:15','globeadmin','2022-02-12 00:41:15','globeadmin'),('6206e619ec52e28','5689468794353da','6206ad009f3ac5e','','','','','','','2022-02-12 00:41:29','globeadmin','2022-02-12 00:41:29','globeadmin','2022-02-12 00:41:29','globeadmin'),('6207bb7dd84ef2d','547de3e001028e8','6206ad009f3ac5e','','','','','','','2022-02-12 15:51:57','globeadmin','2022-02-12 15:51:57','globeadmin','2022-02-12 15:51:57','globeadmin');
/*!40000 ALTER TABLE `zzzsys_access_level_form` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `zzzsys_access_level_menu_item`
--

DROP TABLE IF EXISTS `zzzsys_access_level_menu_item`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `zzzsys_access_level_menu_item` (
  `zzzsys_access_level_menu_item_id` varchar(25) NOT NULL,
  `slm_zzzsys_access_level_id` varchar(25) DEFAULT NULL,
  `slm_zzzsys_menu_item_id` varchar(25) DEFAULT NULL,
  `zzzsys_access_level_menu_item_log_added_at` datetime NOT NULL,
  `zzzsys_access_level_menu_item_log_added_by` varchar(25) NOT NULL,
  `zzzsys_access_level_menu_item_log_changed_at` datetime NOT NULL,
  `zzzsys_access_level_menu_item_log_changed_by` varchar(25) NOT NULL,
  `zzzsys_access_level_menu_item_log_viewed_at` datetime NOT NULL,
  `zzzsys_access_level_menu_item_log_viewed_by` varchar(25) NOT NULL,
  PRIMARY KEY (`zzzsys_access_level_menu_item_id`),
  KEY `slm_zzzsys_access_level_id` (`slm_zzzsys_access_level_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `zzzsys_access_level_menu_item`
--

LOCK TABLES `zzzsys_access_level_menu_item` WRITE;
/*!40000 ALTER TABLE `zzzsys_access_level_menu_item` DISABLE KEYS */;
INSERT INTO `zzzsys_access_level_menu_item` VALUES ('5b51f8077ce7a9e','5501dbedc785fe4','5b51eea7a4424e6','2018-07-20 17:56:07','globeadmin','2018-07-20 17:56:07','globeadmin','2018-07-24 18:17:01','globeadmin'),('5b51f80c361eb80','547de3bee410196','5b51eea7a4424e6','2018-07-20 17:56:12','globeadmin','2018-07-20 17:56:12','globeadmin','2018-07-24 18:17:01','globeadmin'),('5b51f83aeaaa0e0','5601afbc23dfb00','5b51eea7a4424e6','2018-07-20 17:56:59','globeadmin','2018-07-20 17:56:59','globeadmin','2018-07-24 18:17:01','globeadmin'),('5b51f83b02bb15a','5689468794353da','5b51eea7a4424e6','2018-07-20 17:56:59','globeadmin','2018-07-20 17:56:59','globeadmin','2018-07-24 18:17:01','globeadmin'),('5b52d17de27fbb5','547de3bee410196','5b52d17dd8bbcc2','2018-07-21 09:23:58','globeadmin','2018-07-21 09:23:58','globeadmin','2018-07-24 18:17:54','globeadmin'),('5b52d17dec43fd3','5501dbedc785fe4','5b52d17dd8bbcc2','2018-07-21 09:23:58','globeadmin','2018-07-21 09:23:58','globeadmin','2018-07-24 18:17:54','globeadmin'),('5b52d17e01e3e91','5601afbc23dfb00','5b52d17dd8bbcc2','2018-07-21 09:23:58','globeadmin','2018-07-21 09:23:58','globeadmin','2018-07-24 18:17:54','globeadmin'),('5b52d17e0bae1d7','5689468794353da','5b52d17dd8bbcc2','2018-07-21 09:23:58','globeadmin','2018-07-21 09:23:58','globeadmin','2018-07-24 18:17:54','globeadmin'),('5b52d21c82f5379','547de3bee410196','5b52d21c793154b','2018-07-21 09:26:36','globeadmin','2018-07-21 09:26:36','globeadmin','2018-07-24 18:17:21','globeadmin'),('5b52d21c8cb969e','5501dbedc785fe4','5b52d21c793154b','2018-07-21 09:26:36','globeadmin','2018-07-21 09:26:36','globeadmin','2018-07-24 18:17:21','globeadmin'),('5b52d21c967d423','5601afbc23dfb00','5b52d21c793154b','2018-07-21 09:26:36','globeadmin','2018-07-21 09:26:36','globeadmin','2018-07-24 18:17:21','globeadmin'),('5b52d21ca04159d','5689468794353da','5b52d21c793154b','2018-07-21 09:26:36','globeadmin','2018-07-21 09:26:36','globeadmin','2018-07-24 18:17:21','globeadmin'),('5b52d27b211b8b9','547de3bee410196','5b52d27b1758c37','2018-07-21 09:28:11','globeadmin','2018-07-21 09:28:11','globeadmin','2018-07-24 18:17:28','globeadmin'),('5b52d27b2adfeb4','5501dbedc785fe4','5b52d27b1758c37','2018-07-21 09:28:11','globeadmin','2018-07-21 09:28:11','globeadmin','2018-07-24 18:17:28','globeadmin'),('5b52d27b34a3c93','5601afbc23dfb00','5b52d27b1758c37','2018-07-21 09:28:11','globeadmin','2018-07-21 09:28:11','globeadmin','2018-07-24 18:17:28','globeadmin'),('5b562b31d264d56','5689468794353da','5b562b31ab550c0','2018-07-23 22:23:29','globeadmin','2018-07-23 22:23:29','globeadmin','2018-07-24 18:19:07','globeadmin'),('5b562b31c8a1a34','5601afbc23dfb00','5b562b31ab550c0','2018-07-23 22:23:29','globeadmin','2018-07-23 22:23:29','globeadmin','2018-07-24 18:19:07','globeadmin'),('5b52d420d007094','547de3bee410196','5b52d420c655c7e','2018-07-21 09:35:12','globeadmin','2018-07-21 09:35:12','globeadmin','2018-07-24 18:17:35','globeadmin'),('5b52d420d9ca334','5501dbedc785fe4','5b52d420c655c7e','2018-07-21 09:35:12','globeadmin','2018-07-21 09:35:12','globeadmin','2018-07-24 18:17:35','globeadmin'),('5b52d420e38e9b1','5601afbc23dfb00','5b52d420c655c7e','2018-07-21 09:35:12','globeadmin','2018-07-21 09:35:12','globeadmin','2018-07-24 18:17:35','globeadmin'),('5b52d48f7576bf8','547de3bee410196','5b52d48f6bbf379','2018-07-21 09:37:03','globeadmin','2018-07-21 09:37:03','globeadmin','2018-07-24 21:28:38','globeadmin'),('5b52d48f88ff533','5601afbc23dfb00','5b52d48f6bbf379','2018-07-21 09:37:03','globeadmin','2018-07-21 09:37:03','globeadmin','2018-07-24 21:28:38','globeadmin'),('5b57719cb7f8233','5689468794353da','5b56d0e3a2543ef','2018-07-24 21:36:12','globeadmin','2018-07-24 21:36:12','globeadmin','2022-02-12 20:00:29','globeadmin'),('5b576fd5dcefd61','5501dbedc785fe4','5b52d48f6bbf379','2018-07-24 21:28:37','globeadmin','2018-07-24 21:28:37','globeadmin','2018-07-24 21:28:38','globeadmin'),('5b52d498f1f4e16','5689468794353da','5b52d48f6bbf379','2018-07-21 09:37:13','globeadmin','2018-07-21 09:37:13','globeadmin','2018-07-24 21:28:38','globeadmin'),('5b52d5395a426c3','547de3bee410196','5b52d539507e6af','2018-07-21 09:39:53','globeadmin','2018-07-21 09:39:53','globeadmin','2018-07-24 18:17:41','globeadmin'),('5b52d5396407185','5501dbedc785fe4','5b52d539507e6af','2018-07-21 09:39:53','globeadmin','2018-07-21 09:39:53','globeadmin','2018-07-24 18:17:41','globeadmin'),('5b52d5396dca649','5601afbc23dfb00','5b52d539507e6af','2018-07-21 09:39:53','globeadmin','2018-07-21 09:39:53','globeadmin','2018-07-24 18:17:41','globeadmin'),('5b52d53977905b0','5689468794353da','5b52d539507e6af','2018-07-21 09:39:53','globeadmin','2018-07-21 09:39:53','globeadmin','2018-07-24 18:17:41','globeadmin'),('5b52d5889992c64','547de3bee410196','5b52d5888fcec23','2018-07-21 09:41:12','globeadmin','2018-07-21 09:41:12','globeadmin','2018-07-24 18:17:47','globeadmin'),('5b52d588a358902','5501dbedc785fe4','5b52d5888fcec23','2018-07-21 09:41:12','globeadmin','2018-07-21 09:41:12','globeadmin','2018-07-24 18:17:47','globeadmin'),('5b52d588af8d46f','5601afbc23dfb00','5b52d5888fcec23','2018-07-21 09:41:12','globeadmin','2018-07-21 09:41:12','globeadmin','2018-07-24 18:17:47','globeadmin'),('5b52d5f00bc25ab','5501dbedc785fe4','5b52d5efec5eeb5','2018-07-21 09:42:56','globeadmin','2018-07-21 09:42:56','globeadmin','2018-07-24 18:19:32','globeadmin'),('5b52d5f001ff5db','547de3bee410196','5b52d5efec5eeb5','2018-07-21 09:42:56','globeadmin','2018-07-21 09:42:56','globeadmin','2018-07-24 18:19:32','globeadmin'),('5b52d5f015863be','5601afbc23dfb00','5b52d5efec5eeb5','2018-07-21 09:42:56','globeadmin','2018-07-21 09:42:56','globeadmin','2018-07-24 18:19:32','globeadmin'),('5b55740709cf9cc','547de3bee410196','5b5574070016b0b','2018-07-23 09:21:59','globeadmin','2018-07-23 09:21:59','globeadmin','2018-07-24 18:18:37','globeadmin'),('5b5574071399b7f','5501dbedc785fe4','5b5574070016b0b','2018-07-23 09:21:59','globeadmin','2018-07-23 09:21:59','globeadmin','2018-07-24 18:18:37','globeadmin'),('5b5574071d57e33','5601afbc23dfb00','5b5574070016b0b','2018-07-23 09:21:59','globeadmin','2018-07-23 09:21:59','globeadmin','2018-07-24 18:18:37','globeadmin'),('5b557407271af45','5689468794353da','5b5574070016b0b','2018-07-23 09:21:59','globeadmin','2018-07-23 09:21:59','globeadmin','2018-07-24 18:18:38','globeadmin'),('5b557ff8762c944','547de3bee410196','5b557ff86c68add','2018-07-23 10:12:56','globeadmin','2018-07-23 10:12:56','globeadmin','2018-07-25 19:30:10','globeadmin'),('5b557ff87ff0ab7','5501dbedc785fe4','5b557ff86c68add','2018-07-23 10:12:56','globeadmin','2018-07-23 10:12:56','globeadmin','2018-07-25 19:30:10','globeadmin'),('5b557ff889b483a','5601afbc23dfb00','5b557ff86c68add','2018-07-23 10:12:56','globeadmin','2018-07-23 10:12:56','globeadmin','2018-07-25 19:30:10','globeadmin'),('5b557ff89378bf7','5689468794353da','5b557ff86c68add','2018-07-23 10:12:56','globeadmin','2018-07-23 10:12:56','globeadmin','2018-07-25 19:30:10','globeadmin'),('5b5584a990f3aa4','547de3bee410196','5b5584a9872fc66','2018-07-23 10:32:57','globeadmin','2018-07-23 10:32:57','globeadmin','2018-07-24 18:18:52','globeadmin'),('5b5584a99ab7b68','5501dbedc785fe4','5b5584a9872fc66','2018-07-23 10:32:57','globeadmin','2018-07-23 10:32:57','globeadmin','2018-07-24 18:18:52','globeadmin'),('5b5584a9a47bc1d','5601afbc23dfb00','5b5584a9872fc66','2018-07-23 10:32:57','globeadmin','2018-07-23 10:32:57','globeadmin','2018-07-24 18:18:52','globeadmin'),('5b5584a9ae3fab5','5689468794353da','5b5584a9872fc66','2018-07-23 10:32:57','globeadmin','2018-07-23 10:32:57','globeadmin','2018-07-24 18:18:52','globeadmin'),('5b558654e7f29e8','547de3bee410196','5b558654de2e9e3','2018-07-23 10:40:05','globeadmin','2018-07-23 10:40:05','globeadmin','2022-02-12 19:54:21','globeadmin'),('5b558654f1b7018','5501dbedc785fe4','5b558654de2e9e3','2018-07-23 10:40:05','globeadmin','2018-07-23 10:40:05','globeadmin','2022-02-12 19:54:21','globeadmin'),('5b55865509ce53f','5601afbc23dfb00','5b558654de2e9e3','2018-07-23 10:40:05','globeadmin','2018-07-23 10:40:05','globeadmin','2022-02-12 19:54:21','globeadmin'),('5b558655138c4c5','5689468794353da','5b558654de2e9e3','2018-07-23 10:40:05','globeadmin','2018-07-23 10:40:05','globeadmin','2022-02-12 19:54:21','globeadmin'),('5b55b4bca0dafd7','547de3bee410196','5b55b4bc972078a','2018-07-23 13:58:04','globeadmin','2018-07-23 13:58:04','globeadmin','2018-07-24 18:18:24','globeadmin'),('5b55b4bcaa9e312','5501dbedc785fe4','5b55b4bc972078a','2018-07-23 13:58:04','globeadmin','2018-07-23 13:58:04','globeadmin','2018-07-24 18:18:24','globeadmin'),('5b55b4bcb468dac','5601afbc23dfb00','5b55b4bc972078a','2018-07-23 13:58:04','globeadmin','2018-07-23 13:58:04','globeadmin','2018-07-24 18:18:24','globeadmin'),('5b55b4bcbe262c7','5689468794353da','5b55b4bc972078a','2018-07-23 13:58:04','globeadmin','2018-07-23 13:58:04','globeadmin','2018-07-24 18:18:24','globeadmin'),('5b55b5478d07fc2','547de3bee410196','5b55b5478365d60','2018-07-23 14:00:23','globeadmin','2018-07-23 14:00:23','globeadmin','2018-07-24 18:18:31','globeadmin'),('5b55b54796cf7b5','5501dbedc785fe4','5b55b5478365d60','2018-07-23 14:00:23','globeadmin','2018-07-23 14:00:23','globeadmin','2018-07-24 18:18:31','globeadmin'),('5b55b547a08ff47','5601afbc23dfb00','5b55b5478365d60','2018-07-23 14:00:23','globeadmin','2018-07-23 14:00:23','globeadmin','2018-07-24 18:18:31','globeadmin'),('5b562b31bee309b','5501dbedc785fe4','5b562b31ab550c0','2018-07-23 22:23:29','globeadmin','2018-07-23 22:23:29','globeadmin','2018-07-24 18:19:07','globeadmin'),('5b562b31b51ed67','547de3bee410196','5b562b31ab550c0','2018-07-23 22:23:29','globeadmin','2018-07-23 22:23:29','globeadmin','2018-07-24 18:19:07','globeadmin'),('5b55f444ab1c0fd','547de3bee410196','5b55f444a150d4a','2018-07-23 18:29:08','globeadmin','2018-07-23 18:29:08','globeadmin','2022-02-12 19:39:55','globeadmin'),('5b55f444b4d8e6e','5501dbedc785fe4','5b55f444a150d4a','2018-07-23 18:29:08','globeadmin','2018-07-23 18:29:08','globeadmin','2022-02-12 19:39:55','globeadmin'),('5b55f444be9d064','5601afbc23dfb00','5b55f444a150d4a','2018-07-23 18:29:08','globeadmin','2018-07-23 18:29:08','globeadmin','2022-02-12 19:39:55','globeadmin'),('5b55f444c860b96','5689468794353da','5b55f444a150d4a','2018-07-23 18:29:08','globeadmin','2018-07-23 18:29:08','globeadmin','2022-02-12 19:39:55','globeadmin'),('5b55f4c8afb0417','5501dbedc785fe4','5b55f4c89c27b65','2018-07-23 18:31:20','globeadmin','2018-07-23 18:31:20','globeadmin','2018-07-24 18:18:59','globeadmin'),('5b56c4d75a83db7','547de3e001028e8','5b56c4d75109104','2018-07-24 09:19:03','globeadmin','2018-07-24 09:19:03','globeadmin','2022-02-12 19:57:18','globeadmin'),('5b5740fac954c9b','547de3e001028e8','5b5740fabd1ab7c','2018-07-24 18:08:42','globeadmin','2018-07-24 18:08:42','globeadmin','2022-02-12 19:58:13','globeadmin'),('5b56c62d638dad8','547de3e001028e8','5b56c62d59c9a9f','2018-07-24 09:24:45','globeadmin','2018-07-24 09:24:45','globeadmin','2022-02-12 19:57:54','globeadmin'),('5b56c6b8b64e0b0','547de3e001028e8','5b56c6b8ac833a2','2018-07-24 09:27:04','globeadmin','2018-07-24 09:27:04','globeadmin','2022-02-12 19:57:45','globeadmin'),('5b56c74251e76c1','547de3e001028e8','5b56c74243416ad','2018-07-24 09:29:22','globeadmin','2018-07-24 09:29:22','globeadmin','2022-02-12 19:58:04','globeadmin'),('5b574145bcf3a0e','547de3e001028e8','5b574145b0bebb5','2018-07-24 18:09:57','globeadmin','2018-07-24 18:09:57','globeadmin','2022-02-12 19:59:14','globeadmin'),('5b57418f2f325e2','547de3e001028e8','5b57418f208d5aa','2018-07-24 18:11:11','globeadmin','2018-07-24 18:11:11','globeadmin','2022-02-12 19:59:02','globeadmin'),('5b5741d911c26cd','547de3e001028e8','5b5741d9058ac5b','2018-07-24 18:12:25','globeadmin','2018-07-24 18:12:25','globeadmin','2022-02-12 19:58:22','globeadmin'),('5b5741f9e886b29','547de3e001028e8','5b5741f9dc51c9a','2018-07-24 18:12:57','globeadmin','2018-07-24 18:12:58','globeadmin','2022-02-12 19:58:47','globeadmin'),('5b574235a1a0670','547de3e001028e8','5b5742359566eb0','2018-07-24 18:13:57','globeadmin','2018-07-24 18:13:57','globeadmin','2022-02-12 20:00:58','globeadmin'),('5b574278842baa7','547de3e001028e8','5b57427877fc946','2018-07-24 18:15:04','globeadmin','2018-07-24 18:15:04','globeadmin','2022-02-12 20:01:12','globeadmin'),('5b5771a977e1e94','5689468794353da','5b56d25297deb98','2018-07-24 21:36:25','globeadmin','2018-07-24 21:36:25','globeadmin','2022-02-12 20:00:40','globeadmin'),('5b56c9194e84870','547de3e001028e8','5b56c919424f115','2018-07-24 09:37:13','globeadmin','2018-07-24 09:37:13','globeadmin','2022-02-12 19:58:37','globeadmin'),('5b56c9f1926fdb4','547de3e001028e8','5b56c9f16b65506','2018-07-24 09:40:49','globeadmin','2018-07-24 09:40:58','globeadmin','2022-02-12 20:00:06','globeadmin'),('5b57409caec37a3','547de3e001028e8','5b57409ca27a001','2018-07-24 18:07:08','globeadmin','2018-07-24 18:07:08','globeadmin','2022-02-12 19:57:34','globeadmin'),('5b56d252a8e49ee','547de3e001028e8','5b56d25297deb98','2018-07-24 10:16:34','globeadmin','2018-07-24 10:16:34','globeadmin','2022-02-12 20:00:40','globeadmin'),('5b56d0e3ac1dfab','547de3e001028e8','5b56d0e3a2543ef','2018-07-24 10:10:27','globeadmin','2018-07-24 10:10:27','globeadmin','2022-02-12 20:00:29','globeadmin'),('5b578e56ca8907b','547de3fe0d36089','5b578e56c0c5093','2018-07-24 23:38:46','globeadmin','2018-07-24 23:38:46','globeadmin','2018-07-25 19:20:59','globeadmin'),('5b578e56d44d215','5717b9c74a31169','5b578e56c0c5093','2018-07-24 23:38:46','globeadmin','2018-07-24 23:38:46','globeadmin','2018-07-25 19:20:59','globeadmin'),('5b578fda8cb99db','547de3fe0d36089','5b578fda8084e57','2018-07-24 23:45:14','globeadmin','2018-07-24 23:45:14','globeadmin','2018-07-25 19:20:31','globeadmin'),('5b578fda98ee8bd','5717b9c74a31169','5b578fda8084e57','2018-07-24 23:45:14','globeadmin','2018-07-24 23:45:14','globeadmin','2018-07-25 19:20:31','globeadmin'),('5b5790d5ce20f2d','547de3fe0d36089','5b5790d5c45d34e','2018-07-24 23:49:25','globeadmin','2018-07-24 23:49:25','globeadmin','2018-07-24 23:56:20','globeadmin'),('5b5790d5d7e51d7','5717b9c74a31169','5b5790d5c45d34e','2018-07-24 23:49:25','globeadmin','2018-07-24 23:49:25','globeadmin','2018-07-24 23:56:20','globeadmin'),('5b5816e045e0a29','547de3fe0d36089','5b5816e03c1cbcc','2018-07-25 09:21:20','globeadmin','2018-07-25 09:21:20','globeadmin','2018-07-25 19:21:06','globeadmin'),('5b5816e04fab1e8','5717b9c74a31169','5b5816e03c1cbcc','2018-07-25 09:21:20','globeadmin','2018-07-25 09:21:20','globeadmin','2018-07-25 19:21:06','globeadmin'),('5b581748c70f363','547de3fe0d36089','5b581748bd55247','2018-07-25 09:23:04','globeadmin','2018-07-25 09:23:04','globeadmin','2018-07-25 19:26:33','globeadmin'),('5b581748d0d36b7','5717b9c74a31169','5b581748bd55247','2018-07-25 09:23:04','globeadmin','2018-07-25 09:23:04','globeadmin','2018-07-25 19:26:33','globeadmin'),('5b5817cbdf35528','547de3fe0d36089','5b5817cbd57abff','2018-07-25 09:25:15','globeadmin','2018-07-25 09:25:15','globeadmin','2018-07-25 09:25:56','globeadmin'),('5b5817cbe8f8957','5717b9c74a31169','5b5817cbd57abff','2018-07-25 09:25:16','globeadmin','2018-07-25 09:25:16','globeadmin','2018-07-25 09:25:56','globeadmin'),('5b581835479f8db','547de3fe0d36089','5b5818353ddb875','2018-07-25 09:27:01','globeadmin','2018-07-25 09:27:01','globeadmin','2022-02-12 20:07:06','globeadmin'),('5b58183551639f4','5717b9c74a31169','5b5818353ddb875','2018-07-25 09:27:01','globeadmin','2018-07-25 09:27:01','globeadmin','2022-02-12 20:07:06','globeadmin'),('5b5818e89a46083','547de3fe0d36089','5b5818e89080185','2018-07-25 09:30:00','globeadmin','2018-07-25 09:30:00','globeadmin','2018-07-25 19:22:06','globeadmin'),('5b5818e8a67a789','5717b9c74a31169','5b5818e89080185','2018-07-25 09:30:00','globeadmin','2018-07-25 09:30:00','globeadmin','2018-07-25 19:22:06','globeadmin'),('5b581981b73fa6e','547de3fe0d36089','5b581981ad87f4c','2018-07-25 09:32:33','globeadmin','2018-07-25 09:32:33','globeadmin','2018-07-25 19:26:40','globeadmin'),('5b581981c10409e','5717b9c74a31169','5b581981ad87f4c','2018-07-25 09:32:33','globeadmin','2018-07-25 09:32:33','globeadmin','2018-07-25 19:26:40','globeadmin'),('5b581a32e545f48','547de3fe0d36089','5b581a32db8d355','2018-07-25 09:35:31','globeadmin','2018-07-25 09:35:31','globeadmin','2018-07-25 11:10:41','globeadmin'),('5b581a32ef0a1e6','5717b9c74a31169','5b581a32db8d355','2018-07-25 09:35:31','globeadmin','2018-07-25 09:35:31','globeadmin','2018-07-25 11:10:41','globeadmin'),('5b583079eac6880','547de3fe0d36089','5b583079e10cc75','2018-07-25 11:10:33','globeadmin','2018-07-25 11:12:59','globeadmin','2018-07-25 19:28:08','globeadmin'),('5b58310b24ba7c4','5717b9c74a31169','5b583079e10cc75','2018-07-25 11:12:59','globeadmin','2018-07-25 11:12:59','globeadmin','2018-07-25 19:28:08','globeadmin'),('5b5857e99b427f4','547de3fe0d36089','5b5857e9917de04','2018-07-25 13:58:49','globeadmin','2018-07-25 13:58:49','globeadmin','2018-07-25 19:25:49','globeadmin'),('5b5857e9a505beb','5717b9c74a31169','5b5857e9917de04','2018-07-25 13:58:49','globeadmin','2018-07-25 13:58:49','globeadmin','2018-07-25 19:25:49','globeadmin'),('5b5858974092b09','547de3fe0d36089','5b58589736ceccc','2018-07-25 14:01:43','globeadmin','2018-07-25 14:01:43','globeadmin','2018-07-25 19:23:47','globeadmin'),('5b5858974a56d2f','5717b9c74a31169','5b58589736ceccc','2018-07-25 14:01:43','globeadmin','2018-07-25 14:01:43','globeadmin','2018-07-25 19:23:47','globeadmin'),('5b585addecc101f','547de3fe0d36089','5b585adde2fd1d9','2018-07-25 14:11:26','globeadmin','2018-07-25 14:11:26','globeadmin','2018-07-25 19:24:38','globeadmin'),('5b585ade0261bac','5717b9c74a31169','5b585adde2fd1d9','2018-07-25 14:11:26','globeadmin','2018-07-25 14:11:26','globeadmin','2018-07-25 19:24:38','globeadmin'),('6207f2434c096f4','547de3bee410196','6207f24347deb8a','2022-02-12 19:45:39','globeadmin','2022-02-12 19:45:39','globeadmin','2022-02-12 19:55:04','globeadmin'),('6207f2434ecc8b5','5501dbedc785fe4','6207f24347deb8a','2022-02-12 19:45:39','globeadmin','2022-02-12 19:45:39','globeadmin','2022-02-12 19:55:04','globeadmin'),('6207f24351e0992','5601afbc23dfb00','6207f24347deb8a','2022-02-12 19:45:39','globeadmin','2022-02-12 19:45:39','globeadmin','2022-02-12 19:55:04','globeadmin'),('6207f24354a8d25','5689468794353da','6207f24347deb8a','2022-02-12 19:45:39','globeadmin','2022-02-12 19:45:39','globeadmin','2022-02-12 19:55:04','globeadmin'),('6207f4d05a17e9e','547de3e001028e8','6207f4d0569a8c2','2022-02-12 19:56:32','globeadmin','2022-02-12 19:56:32','globeadmin','2022-02-12 19:59:23','globeadmin'),('6207f4fed7ef345','60475aa35186b93','5b56c4d75109104','2022-02-12 19:57:18','globeadmin','2022-02-12 19:57:18','globeadmin','2022-02-12 19:57:19','globeadmin'),('6207f50ec0a4626','60475aa35186b93','5b57409ca27a001','2022-02-12 19:57:34','globeadmin','2022-02-12 19:57:34','globeadmin','2022-02-12 19:57:34','globeadmin'),('6207f5192ed351f','60475aa35186b93','5b56c6b8ac833a2','2022-02-12 19:57:45','globeadmin','2022-02-12 19:57:45','globeadmin','2022-02-12 19:57:45','globeadmin'),('6207f521daa1b01','60475aa35186b93','5b56c62d59c9a9f','2022-02-12 19:57:53','globeadmin','2022-02-12 19:57:53','globeadmin','2022-02-12 19:57:54','globeadmin'),('6207f52c515d772','60475aa35186b93','5b56c74243416ad','2022-02-12 19:58:04','globeadmin','2022-02-12 19:58:04','globeadmin','2022-02-12 19:58:04','globeadmin'),('6207f535497d88c','60475aa35186b93','5b5740fabd1ab7c','2022-02-12 19:58:13','globeadmin','2022-02-12 19:58:13','globeadmin','2022-02-12 19:58:13','globeadmin'),('6207f53e654c3b2','60475aa35186b93','5b5741d9058ac5b','2022-02-12 19:58:22','globeadmin','2022-02-12 19:58:22','globeadmin','2022-02-12 19:58:22','globeadmin'),('6207f54dc4a41c2','60475aa35186b93','5b56c919424f115','2022-02-12 19:58:37','globeadmin','2022-02-12 19:58:37','globeadmin','2022-02-12 19:58:37','globeadmin'),('6207f55785f9b6f','60475aa35186b93','5b5741f9dc51c9a','2022-02-12 19:58:47','globeadmin','2022-02-12 19:58:47','globeadmin','2022-02-12 19:58:47','globeadmin'),('6207f5667c9a6f1','60475aa35186b93','5b57418f208d5aa','2022-02-12 19:59:02','globeadmin','2022-02-12 19:59:02','globeadmin','2022-02-12 19:59:02','globeadmin'),('6207f5721039858','60475aa35186b93','5b574145b0bebb5','2022-02-12 19:59:14','globeadmin','2022-02-12 19:59:14','globeadmin','2022-02-12 19:59:14','globeadmin'),('6207f57b9ecc896','60475aa35186b93','6207f4d0569a8c2','2022-02-12 19:59:23','globeadmin','2022-02-12 19:59:23','globeadmin','2022-02-12 19:59:23','globeadmin'),('6207f586c9aa6c4','60475aa35186b93','5b56c9f16b65506','2022-02-12 19:59:34','globeadmin','2022-02-12 19:59:34','globeadmin','2022-02-12 20:00:06','globeadmin'),('6207f5b1f3cec65','60475aa35186b93','5b56d0e3a2543ef','2022-02-12 20:00:18','globeadmin','2022-02-12 20:00:18','globeadmin','2022-02-12 20:00:29','globeadmin'),('6207f5c8817cc3b','60475aa35186b93','5b56d25297deb98','2022-02-12 20:00:40','globeadmin','2022-02-12 20:00:40','globeadmin','2022-02-12 20:00:40','globeadmin'),('6207f5daa1474b5','60475aa35186b93','5b5742359566eb0','2022-02-12 20:00:58','globeadmin','2022-02-12 20:00:58','globeadmin','2022-02-12 20:00:58','globeadmin'),('6207f5e8b4911d8','60475aa35186b93','5b57427877fc946','2022-02-12 20:01:12','globeadmin','2022-02-12 20:01:12','globeadmin','2022-02-12 20:01:12','globeadmin');
/*!40000 ALTER TABLE `zzzsys_access_level_menu_item` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `zzzsys_access_level_php`
--

DROP TABLE IF EXISTS `zzzsys_access_level_php`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `zzzsys_access_level_php` (
  `zzzsys_access_level_php_id` varchar(25) NOT NULL,
  `slp_zzzsys_access_level_id` varchar(25) DEFAULT NULL,
  `slp_zzzsys_php_id` varchar(25) DEFAULT NULL,
  `zzzsys_access_level_php_log_added_at` datetime NOT NULL,
  `zzzsys_access_level_php_log_added_by` varchar(25) NOT NULL,
  `zzzsys_access_level_php_log_changed_at` datetime NOT NULL,
  `zzzsys_access_level_php_log_changed_by` varchar(25) NOT NULL,
  `zzzsys_access_level_php_log_viewed_at` datetime NOT NULL,
  `zzzsys_access_level_php_log_viewed_by` varchar(25) NOT NULL,
  PRIMARY KEY (`zzzsys_access_level_php_id`),
  KEY `slp_zzzsys_access_level_id` (`slp_zzzsys_access_level_id`),
  KEY `slp_zzzsys_library_id` (`slp_zzzsys_php_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `zzzsys_access_level_php`
--

LOCK TABLES `zzzsys_access_level_php` WRITE;
/*!40000 ALTER TABLE `zzzsys_access_level_php` DISABLE KEYS */;
INSERT INTO `zzzsys_access_level_php` VALUES ('548945dc51c44ba','547de3e001028e8','5487369544262a7','2014-12-11 09:21:00','globeadmin','2014-12-11 09:21:00','globeadmin','2019-11-06 15:15:11','globeadmin'),('548b36fa6fde17f','547de3e001028e8','548b2b8d4b3f282','2014-12-12 20:42:02','globeadmin','2014-12-12 20:42:02','globeadmin','2019-11-06 15:15:16','globeadmin'),('5491c8b7b437af7','547de3e001028e8','548897f34ce2b64','2014-12-17 20:17:27','globeadmin','2014-12-17 20:17:27','globeadmin','2019-11-06 15:15:15','globeadmin'),('5491c8b7bb8950a','547de3e001028e8','54889d24766371b','2014-12-17 20:17:27','globeadmin','2014-12-17 20:17:27','globeadmin','2019-11-06 15:15:19','globeadmin'),('56894e2b6844e57','547de3bee410196','56883955e3ab0ac','2016-01-03 18:36:59','globeadmin','2016-01-03 18:36:59','globeadmin','2022-01-31 16:18:43','globeadmin'),('570ca579a4e8043','547de3bee410196','570c988f9d95164','2016-04-12 10:36:25','globeadmin','2016-04-12 10:36:25','globeadmin','2022-01-31 16:18:45','globeadmin'),('572b7ad06362f4e','5501dbedc785fe4','572b066732990f9','2016-05-05 19:54:40','globeadmin','2016-05-05 19:54:40','globeadmin','2018-01-09 18:51:18','globeadmin'),('572b7ad05c0f240','5501dbedc785fe4','5728fe5eefef00e','2016-05-05 19:54:40','globeadmin','2016-05-05 19:54:40','globeadmin','2018-01-09 18:51:25','globeadmin'),('568949cc76e9382','5689468794353da','562378beaaf323a','2016-01-03 18:18:20','globeadmin','2016-01-03 18:18:20','globeadmin','2016-02-09 20:38:05','globeadmin'),('568949cc6843263','5689468794353da','561feead7838ca8','2016-01-03 18:18:20','globeadmin','2016-01-03 18:18:20','globeadmin','2016-02-09 20:38:05','globeadmin'),('5652f3497dbcbe0','5501dbedc785fe4','56200a1fadf03a4','2015-11-23 13:06:49','globeadmin','2015-11-23 13:06:49','globeadmin','2018-01-09 18:51:17','globeadmin'),('562b77746213dc5','5601afbc23dfb00','562b7741ab50baf','2015-10-24 15:20:04','globeadmin','2015-10-24 15:20:04','globeadmin','2018-11-20 14:42:30','globeadmin'),('562b77712299de9','5501dbedc785fe4','562b7741ab50baf','2015-10-24 15:20:01','globeadmin','2015-10-24 15:20:01','globeadmin','2018-01-09 18:51:29','globeadmin'),('562b7769ab51c40','547de3e001028e8','562b7741ab50baf','2015-10-24 15:19:53','globeadmin','2015-10-24 15:19:53','globeadmin','2019-11-06 15:15:22','globeadmin'),('568949cc60f05a7','5689468794353da','562b7741ab50baf','2016-01-03 18:18:20','globeadmin','2016-01-03 18:18:20','globeadmin','2016-02-09 20:38:05','globeadmin'),('562b77655d307c0','547de3bee410196','562b7741ab50baf','2015-10-24 15:19:49','globeadmin','2015-10-24 15:19:49','globeadmin','2022-01-31 16:18:48','globeadmin'),('56292082d4b08a2','5501dbedc785fe4','561feead7838ca8','2015-10-22 20:44:34','globeadmin','2015-10-22 20:44:34','globeadmin','2018-01-09 18:51:24','globeadmin'),('5624f9f91688767','5601afbc23dfb00','561feead7838ca8','2015-10-19 17:11:05','globeadmin','2015-10-19 17:11:05','globeadmin','2018-11-20 14:42:25','globeadmin'),('568949cc599d379','5689468794353da','56200a1fadf03a4','2016-01-03 18:18:20','globeadmin','2016-01-03 18:18:20','globeadmin','2016-02-09 20:38:05','globeadmin'),('56223ef2820a757','5601afbc23dfb00','56223ed375d706d','2015-10-17 15:28:34','globeadmin','2015-10-17 15:28:34','globeadmin','2018-11-20 14:42:20','globeadmin'),('56223efb69a05e0','5501dbedc785fe4','56223ed375d706d','2015-10-17 15:28:43','globeadmin','2015-10-17 15:28:43','globeadmin','2018-01-09 18:51:19','globeadmin'),('5623792be590bf2','547de3bee410196','562378beaaf323a','2015-10-18 13:49:15','globeadmin','2015-10-18 13:49:15','globeadmin','2022-01-31 16:18:43','globeadmin'),('562379305f44783','547de3e001028e8','562378beaaf323a','2015-10-18 13:49:20','globeadmin','2015-10-18 13:49:20','globeadmin','2019-11-06 15:15:13','globeadmin'),('5623793ebc0a227','5501dbedc785fe4','562378beaaf323a','2015-10-18 13:49:34','globeadmin','2015-10-18 13:49:34','globeadmin','2018-01-09 18:51:17','globeadmin'),('56237943a3a0215','5601afbc23dfb00','562378beaaf323a','2015-10-18 13:49:39','globeadmin','2015-10-18 13:49:39','globeadmin','2018-11-20 14:42:18','globeadmin'),('570ca57e5ba9dbe','5501dbedc785fe4','570c988f9d95164','2016-04-12 10:36:30','globeadmin','2016-04-12 10:36:30','globeadmin','2018-01-09 18:51:20','globeadmin'),('56894e2b6f9621a','547de3bee410196','5687b0505b9ec15','2016-01-03 18:36:59','globeadmin','2016-01-03 18:36:59','globeadmin','2022-01-31 16:18:46','globeadmin'),('56894e31858f3fc','5501dbedc785fe4','56883955e3ab0ac','2016-01-03 18:37:05','globeadmin','2016-01-03 18:37:05','globeadmin','2018-01-09 18:51:17','globeadmin'),('56894e318ce2869','5501dbedc785fe4','5687b0505b9ec15','2016-01-03 18:37:05','globeadmin','2016-01-03 18:37:05','globeadmin','2018-01-09 18:51:25','globeadmin'),('56894e35c028bf8','5601afbc23dfb00','56883955e3ab0ac','2016-01-03 18:37:09','globeadmin','2016-01-03 18:37:09','globeadmin','2018-11-20 14:42:18','globeadmin'),('56894e35c77a408','5601afbc23dfb00','5687b0505b9ec15','2016-01-03 18:37:09','globeadmin','2016-01-03 18:37:09','globeadmin','2018-11-20 14:42:26','globeadmin'),('56894e39ee8bcbf','5689468794353da','56883955e3ab0ac','2016-01-03 18:37:13','globeadmin','2016-01-03 18:37:13','globeadmin','2016-02-09 20:38:05','globeadmin'),('56894e3a01b98a4','5689468794353da','5687b0505b9ec15','2016-01-03 18:37:14','globeadmin','2016-01-03 18:37:14','globeadmin','2016-02-09 20:38:05','globeadmin'),('572b7ad054bc4dd','5501dbedc785fe4','572b6f3ed13f95a','2016-05-05 19:54:40','globeadmin','2016-05-05 19:54:40','globeadmin','2018-01-09 18:51:18','globeadmin'),('572b7acb042b2a8','547de3bee410196','572b066732990f9','2016-05-05 19:54:35','globeadmin','2016-05-05 19:54:35','globeadmin','2022-01-31 16:18:44','globeadmin'),('572b7acaf0fc4c7','547de3bee410196','5728fe5eefef00e','2016-05-05 19:54:34','globeadmin','2016-05-05 19:54:34','globeadmin','2022-01-31 16:18:46','globeadmin'),('572b7acae9a93a1','547de3bee410196','572b6f3ed13f95a','2016-05-05 19:54:34','globeadmin','2016-05-05 19:54:34','globeadmin','2022-01-31 16:18:44','globeadmin'),('571cc305a2b7a09','5689468794353da','571c76ec5f95f4a','2016-04-24 15:58:45','globeadmin','2016-04-24 15:58:45','globeadmin','2016-04-24 15:58:45','globeadmin'),('571cc30128a3755','5601afbc23dfb00','571c76ec5f95f4a','2016-04-24 15:58:41','globeadmin','2016-04-24 15:58:41','globeadmin','2018-11-20 14:42:19','globeadmin'),('571cc2fdf3465fb','5501dbedc785fe4','571c76ec5f95f4a','2016-04-24 15:58:37','globeadmin','2016-04-24 15:58:37','globeadmin','2018-01-09 18:51:17','globeadmin'),('571cc2fa214f027','547de3e001028e8','571c76ec5f95f4a','2016-04-24 15:58:34','globeadmin','2016-04-24 15:58:34','globeadmin','2019-11-06 15:15:14','globeadmin'),('571cc2f28f2d7d3','547de3bee410196','571c76ec5f95f4a','2016-04-24 15:58:26','globeadmin','2016-04-24 15:58:26','globeadmin','2022-01-31 16:18:44','globeadmin'),('572dca9f6e1a798','547de3fe0d36089','5728fe5eefef00e','2016-05-07 13:59:43','globeadmin','2016-05-07 13:59:43','globeadmin','2019-07-01 11:07:07','globeadmin'),('571bcc7bb5e32be','5689468794353da','571867a3c69b329','2016-04-23 22:26:51','globeadmin','2016-04-23 22:26:51','globeadmin','2016-04-23 22:26:51','globeadmin'),('571bcc7bae90524','5689468794353da','571b3a668693434','2016-04-23 22:26:51','globeadmin','2016-04-23 22:26:51','globeadmin','2016-04-23 22:26:51','globeadmin'),('571bcc7ba73dc91','5689468794353da','5719cc13ce50b1c','2016-04-23 22:26:51','globeadmin','2016-04-23 22:26:51','globeadmin','2016-04-23 22:26:51','globeadmin'),('571bcc7b9fea248','5689468794353da','571bb4109fea243','2016-04-23 22:26:51','globeadmin','2016-04-23 22:26:51','globeadmin','2016-04-23 22:26:51','globeadmin'),('571bcc7b98989f3','5689468794353da','570f37d999d041a','2016-04-23 22:26:51','globeadmin','2016-04-23 22:26:51','globeadmin','2016-04-23 22:26:51','globeadmin'),('571bcc75a9ae3dd','5601afbc23dfb00','571867a3c69b329','2016-04-23 22:26:45','globeadmin','2016-04-23 22:26:45','globeadmin','2018-11-20 14:42:26','globeadmin'),('571bcc75a25b272','5601afbc23dfb00','571b3a668693434','2016-04-23 22:26:45','globeadmin','2016-04-23 22:26:45','globeadmin','2018-11-20 14:42:26','globeadmin'),('571bcc759b086e8','5601afbc23dfb00','5719cc13ce50b1c','2016-04-23 22:26:45','globeadmin','2016-04-23 22:26:45','globeadmin','2018-11-20 14:42:19','globeadmin'),('571bcc7593b57ad','5601afbc23dfb00','571bb4109fea243','2016-04-23 22:26:45','globeadmin','2016-04-23 22:26:45','globeadmin','2018-11-20 14:42:20','globeadmin'),('571bcc758c63fd5','5601afbc23dfb00','570f37d999d041a','2016-04-23 22:26:45','globeadmin','2016-04-23 22:26:45','globeadmin','2018-11-20 14:42:30','globeadmin'),('571bcc7128496d9','5501dbedc785fe4','571867a3c69b329','2016-04-23 22:26:41','globeadmin','2016-04-23 22:26:41','globeadmin','2018-01-09 18:51:24','globeadmin'),('571bcc7120f6491','5501dbedc785fe4','571b3a668693434','2016-04-23 22:26:41','globeadmin','2016-04-23 22:26:41','globeadmin','2018-01-09 18:51:25','globeadmin'),('571bcc7119a322e','5501dbedc785fe4','5719cc13ce50b1c','2016-04-23 22:26:41','globeadmin','2016-04-23 22:26:41','globeadmin','2018-01-09 18:51:18','globeadmin'),('571bcc711250222','5501dbedc785fe4','571bb4109fea243','2016-04-23 22:26:41','globeadmin','2016-04-23 22:26:41','globeadmin','2018-01-09 18:51:18','globeadmin'),('571bcc710afea2d','5501dbedc785fe4','570f37d999d041a','2016-04-23 22:26:41','globeadmin','2016-04-23 22:26:41','globeadmin','2018-01-09 18:51:29','globeadmin'),('571bcc6a9fea273','547de3e001028e8','571867a3c69b329','2016-04-23 22:26:34','globeadmin','2016-04-23 22:26:34','globeadmin','2019-11-06 15:15:19','globeadmin'),('571bcc6a989722e','547de3e001028e8','571b3a668693434','2016-04-23 22:26:34','globeadmin','2016-04-23 22:26:34','globeadmin','2019-11-06 15:15:19','globeadmin'),('571bcc6a9144296','547de3e001028e8','5719cc13ce50b1c','2016-04-23 22:26:34','globeadmin','2016-04-23 22:26:34','globeadmin','2019-11-06 15:15:14','globeadmin'),('571bcc6a89f13de','547de3e001028e8','571bb4109fea243','2016-04-23 22:26:34','globeadmin','2016-04-23 22:26:34','globeadmin','2019-11-06 15:15:14','globeadmin'),('571bcc6a82a0ac3','547de3e001028e8','570f37d999d041a','2016-04-23 22:26:34','globeadmin','2016-04-23 22:26:34','globeadmin','2019-11-06 15:15:22','globeadmin'),('571bcc60480627d','547de3bee410196','571867a3c69b329','2016-04-23 22:26:24','globeadmin','2016-04-23 22:26:24','globeadmin','2022-01-31 16:18:46','globeadmin'),('571bcc6040b32c1','547de3bee410196','571b3a668693434','2016-04-23 22:26:24','globeadmin','2016-04-23 22:26:24','globeadmin','2022-01-31 16:18:46','globeadmin'),('571bcc603960274','547de3bee410196','5719cc13ce50b1c','2016-04-23 22:26:24','globeadmin','2016-04-23 22:26:24','globeadmin','2022-01-31 16:18:44','globeadmin'),('571bcc60320d278','547de3bee410196','571bb4109fea243','2016-04-23 22:26:24','globeadmin','2016-04-23 22:26:24','globeadmin','2022-01-31 16:18:44','globeadmin'),('571bcc602abbf46','547de3bee410196','570f37d999d041a','2016-04-23 22:26:24','globeadmin','2016-04-23 22:26:24','globeadmin','2022-01-31 16:18:48','globeadmin'),('571f207f49ab626','5601afbc23dfb00','571e7a2a61eb15a','2016-04-26 11:02:07','globeadmin','2016-04-26 11:02:07','globeadmin','2018-11-20 14:42:18','globeadmin'),('5723172e3220563','5501dbedc785fe4','57208dbe24f2fad','2016-04-29 11:11:26','globeadmin','2016-04-29 11:11:26','globeadmin','2018-01-09 18:51:18','globeadmin'),('571fb76b7ba84eb','5501dbedc785fe4','571faf73f0d67fa','2016-04-26 21:46:03','globeadmin','2016-04-26 21:46:03','globeadmin','2018-01-09 18:51:18','globeadmin'),('571f207bd2635de','5501dbedc785fe4','571e7a2a61eb15a','2016-04-26 11:02:03','globeadmin','2016-04-26 11:02:03','globeadmin','2018-01-09 18:51:17','globeadmin'),('578004942d42d1d','547de3e001028e8','5757b8458c72cf3','2016-07-08 22:52:52','globeadmin','2016-07-08 22:52:52','globeadmin','2019-11-06 15:15:20','globeadmin'),('571f207355e0aa2','547de3bee410196','571e7a2a61eb15a','2016-04-26 11:01:55','globeadmin','2016-04-26 11:01:55','globeadmin','2022-01-31 16:18:44','globeadmin'),('5717b9c969ef726','5717b9c74a31169','55490413c23b81c','2016-04-20 20:18:02','globeadmin','2016-04-20 20:18:02','globeadmin','2017-10-15 19:02:16','globeadmin'),('5717b9c9602bcc9','5717b9c74a31169','56521e303a1e26c','2016-04-20 20:18:02','globeadmin','2016-04-20 20:18:02','globeadmin','2017-10-15 19:02:16','globeadmin'),('5717b9c94a314da','5717b9c74a31169','547cc4b073c1854','2016-04-20 20:18:02','globeadmin','2016-04-20 20:18:02','globeadmin','2017-10-15 19:02:16','globeadmin'),('5717b9c956663a7','5717b9c74a31169','56608bc656a4d24','2016-04-20 20:18:02','globeadmin','2016-04-20 20:18:02','globeadmin','2017-10-15 19:02:16','globeadmin'),('5717b9c93dfc21d','5717b9c74a31169','5477806364bbd3b','2016-04-20 20:18:02','globeadmin','2016-04-20 20:18:02','globeadmin','2017-10-15 19:02:15','globeadmin'),('5717b9c925923b7','5717b9c74a31169','5547a512d1c5bd2','2016-04-20 20:18:02','globeadmin','2016-04-20 20:18:02','globeadmin','2017-10-15 19:02:15','globeadmin'),('5717b9c931c73b9','5717b9c74a31169','547cce2020be0b5','2016-04-20 20:18:02','globeadmin','2016-04-20 20:18:02','globeadmin','2017-10-15 19:02:15','globeadmin'),('5717b9c9195d386','5717b9c74a31169','554797f3cce46e4','2016-04-20 20:18:02','globeadmin','2016-04-20 20:18:02','globeadmin','2017-10-15 19:02:15','globeadmin'),('5717b9c900f4c94','5717b9c74a31169','5507176562eedae','2016-04-20 20:18:02','globeadmin','2016-04-20 20:18:02','globeadmin','2017-10-15 19:02:15','globeadmin'),('5717b9c90d283e9','5717b9c74a31169','56a11975eff1dd2','2016-04-20 20:18:02','globeadmin','2016-04-20 20:18:02','globeadmin','2017-10-15 19:02:15','globeadmin'),('5717b9c8eb55962','5717b9c74a31169','562e80fdcf335fe','2016-04-20 20:18:02','globeadmin','2016-04-20 20:18:02','globeadmin','2017-10-15 19:02:15','globeadmin'),('5717b9c8d55a3a4','5717b9c74a31169','550d4eea3e00a18','2016-04-20 20:18:02','globeadmin','2016-04-20 20:18:02','globeadmin','2017-10-15 19:02:14','globeadmin'),('5717b9c8e18f77a','5717b9c74a31169','54a921725907fab','2016-04-20 20:18:02','globeadmin','2016-04-20 20:18:02','globeadmin','2017-10-15 19:02:15','globeadmin'),('5717b9c8c926869','5717b9c74a31169','54889d24766371b','2016-04-20 20:18:02','globeadmin','2016-04-20 20:18:02','globeadmin','2017-10-15 19:02:14','globeadmin'),('5717b9c8b59e7c5','5717b9c74a31169','5687b0505b9ec15','2016-04-20 20:18:02','globeadmin','2016-04-20 20:18:02','globeadmin','2017-10-15 19:02:14','globeadmin'),('5717b9c8bf628d9','5717b9c74a31169','54b1245d2bacdb6','2016-04-20 20:18:02','globeadmin','2016-04-20 20:18:02','globeadmin','2016-04-25 22:24:06','globeadmin'),('5717b9c8abda810','5717b9c74a31169','561d62acbdd0ab8','2016-04-20 20:18:02','globeadmin','2016-04-20 20:18:02','globeadmin','2017-10-15 19:02:14','globeadmin'),('5717b9c8985295b','5717b9c74a31169','553fe1e308e7e3a','2016-04-20 20:18:02','globeadmin','2016-04-20 20:18:02','globeadmin','2017-10-15 19:02:14','globeadmin'),('5717b9c8a216713','5717b9c74a31169','55128eb9652ead5','2016-04-20 20:18:02','globeadmin','2016-04-20 20:18:02','globeadmin','2017-10-15 19:02:14','globeadmin'),('5717b9c88e8e70c','5717b9c74a31169','551a39550972489','2016-04-20 20:18:02','globeadmin','2016-04-20 20:18:02','globeadmin','2017-10-15 19:02:14','globeadmin'),('5717b9c87b059ac','5717b9c74a31169','549ef456718c2ed','2016-04-20 20:18:01','globeadmin','2016-04-20 20:18:01','globeadmin','2017-10-15 19:02:13','globeadmin'),('5717b9c884ca8ff','5717b9c74a31169','5569e34f68bcbbb','2016-04-20 20:18:02','globeadmin','2016-04-20 20:18:02','globeadmin','2017-10-15 19:02:14','globeadmin'),('56ba2b9e0002d2e','547de3bee410196','52c0da99b95c264','2016-02-09 20:10:38','globeadmin','2016-02-09 20:10:38','globeadmin','2022-01-31 16:18:44','globeadmin'),('56ba2b9e0755da7','547de3bee410196','530a8f8e78111c4','2016-02-09 20:10:38','globeadmin','2016-02-09 20:10:38','globeadmin','2022-01-31 16:18:47','globeadmin'),('56ba2b9e0ea8b7e','547de3bee410196','5477806364bbd3b','2016-02-09 20:10:38','globeadmin','2016-02-09 20:10:38','globeadmin','2022-01-31 16:18:47','globeadmin'),('56ba2b9e15fbe97','547de3bee410196','547cc4b073c1854','2016-02-09 20:10:38','globeadmin','2016-02-09 20:10:38','globeadmin','2016-02-09 20:32:48','globeadmin'),('56ba2b9e1d4ec03','547de3bee410196','547cce2020be0b5','2016-02-09 20:10:38','globeadmin','2016-02-09 20:10:38','globeadmin','2022-01-31 16:18:47','globeadmin'),('56ba2b9e24a1e9f','547de3bee410196','5487369544262a7','2016-02-09 20:10:38','globeadmin','2016-02-09 20:10:38','globeadmin','2022-01-31 16:18:43','globeadmin'),('56ba2b9e2bf509d','547de3bee410196','548897f34ce2b64','2016-02-09 20:10:38','globeadmin','2016-02-09 20:10:38','globeadmin','2022-01-31 16:18:45','globeadmin'),('56ba2b9e3347cc3','547de3bee410196','54889d24766371b','2016-02-09 20:10:38','globeadmin','2016-02-09 20:10:38','globeadmin','2022-01-31 16:18:46','globeadmin'),('56ba2b9e3a9ab37','547de3bee410196','548b2b8d4b3f282','2016-02-09 20:10:38','globeadmin','2016-02-09 20:10:38','globeadmin','2022-01-31 16:18:45','globeadmin'),('56ba2b9e41ee17e','547de3bee410196','5494859e9bfaf58','2016-02-09 20:10:38','globeadmin','2016-02-09 20:10:38','globeadmin','2022-01-31 16:18:47','globeadmin'),('56ba2b9e4940d6d','547de3bee410196','5495d3357b0fb7c','2016-02-09 20:10:38','globeadmin','2016-02-09 20:10:38','globeadmin','2022-01-31 16:18:47','globeadmin'),('56ba2b9e5093c8e','547de3bee410196','5498454b86171f6','2016-02-09 20:10:38','globeadmin','2016-02-09 20:10:38','globeadmin','2022-01-31 16:18:45','globeadmin'),('56ba2b9e57e6b61','547de3bee410196','549ef456718c2ed','2016-02-09 20:10:38','globeadmin','2016-02-09 20:10:38','globeadmin','2022-01-31 16:18:45','globeadmin'),('56ba2b9e5f39f02','547de3bee410196','54a06aabf3085fe','2016-02-09 20:10:38','globeadmin','2016-02-09 20:10:38','globeadmin','2022-01-31 16:18:45','globeadmin'),('56ba2b9e668cc9a','547de3bee410196','54a11e8a5b34dee','2016-02-09 20:10:38','globeadmin','2016-02-09 20:10:38','globeadmin','2022-01-31 16:18:44','globeadmin'),('56ba2b9e6ddfdbf','547de3bee410196','54a2700ab351809','2016-02-09 20:10:38','globeadmin','2016-02-09 20:10:38','globeadmin','2022-01-31 16:18:45','globeadmin'),('56ba2b9e7532d0d','547de3bee410196','54a2baf998a4dbd','2016-02-09 20:10:38','globeadmin','2016-02-09 20:10:38','globeadmin','2022-01-31 16:18:44','globeadmin'),('56ba2b9e7c85ce9','547de3bee410196','54a30da411a6ba7','2016-02-09 20:10:38','globeadmin','2016-02-09 20:10:38','globeadmin','2022-01-31 16:18:47','globeadmin'),('56ba2b9e83d8bf4','547de3bee410196','54a3e7ba6b7fc63','2016-02-09 20:10:38','globeadmin','2016-02-09 20:10:38','globeadmin','2022-01-31 16:18:45','globeadmin'),('56ba2b9e8b2bf2b','547de3bee410196','54a57904c1b4546','2016-02-09 20:10:38','globeadmin','2016-02-09 20:10:38','globeadmin','2022-01-31 16:18:45','globeadmin'),('56ba2b9e927ea75','547de3bee410196','54a921725907fab','2016-02-09 20:10:38','globeadmin','2016-02-09 20:10:38','globeadmin','2022-01-31 16:18:47','globeadmin'),('56ba2b9e99d1f5e','547de3bee410196','54a9704fd26ded5','2016-02-09 20:10:38','globeadmin','2016-02-09 20:10:38','globeadmin','2022-01-31 16:18:47','globeadmin'),('56ba2b9ea124cbd','547de3bee410196','54aa72ec60858cc','2016-02-09 20:10:38','globeadmin','2016-02-09 20:10:38','globeadmin','2022-01-31 16:18:43','globeadmin'),('56ba2b9ea877be6','547de3bee410196','54b1245d2bacdb6','2016-02-09 20:10:38','globeadmin','2016-02-09 20:10:38','globeadmin','2016-02-09 20:32:49','globeadmin'),('56ba2b9eafcac93','547de3bee410196','54b3853f5280e06','2016-02-09 20:10:38','globeadmin','2016-02-09 20:10:38','globeadmin','2022-01-31 16:18:46','globeadmin'),('56ba2b9eb71dc28','547de3bee410196','54d1374c9e8d38a','2016-02-09 20:10:38','globeadmin','2016-02-09 20:10:38','globeadmin','2022-01-31 16:18:45','globeadmin'),('56ba2b9ebe70bea','547de3bee410196','54d65d126230684','2016-02-09 20:10:38','globeadmin','2016-02-09 20:10:38','globeadmin','2022-01-31 16:18:45','globeadmin'),('56ba2b9ec5c5ed6','547de3bee410196','54d6660b538bea2','2016-02-09 20:10:38','globeadmin','2016-02-09 20:10:38','globeadmin','2022-01-31 16:18:45','globeadmin'),('56ba2b9ecd16c12','547de3bee410196','54da24749d82eb7','2016-02-09 20:10:38','globeadmin','2016-02-09 20:10:38','globeadmin','2022-01-31 16:18:45','globeadmin'),('56ba2b9ed469ee9','547de3bee410196','54df2384b808c9b','2016-02-09 20:10:38','globeadmin','2016-02-09 20:10:38','globeadmin','2022-01-31 16:18:47','globeadmin'),('56ba2b9edbbca52','547de3bee410196','54df23b8e8dd0cf','2016-02-09 20:10:38','globeadmin','2016-02-09 20:10:38','globeadmin','2022-01-31 16:18:47','globeadmin'),('56ba2b9ee30fb01','547de3bee410196','54df242190f8a42','2016-02-09 20:10:38','globeadmin','2016-02-09 20:10:38','globeadmin','2022-01-31 16:18:47','globeadmin'),('56ba2b9eea62c93','547de3bee410196','54df249e87338f1','2016-02-09 20:10:38','globeadmin','2016-02-09 20:10:38','globeadmin','2022-01-31 16:18:47','globeadmin'),('56ba2b9ef1b641b','547de3bee410196','54df24c6566897c','2016-02-09 20:10:38','globeadmin','2016-02-09 20:10:38','globeadmin','2022-01-31 16:18:47','globeadmin'),('56ba2b9f04e4c8c','547de3bee410196','54df2503ce004f5','2016-02-09 20:10:39','globeadmin','2016-02-09 20:10:39','globeadmin','2022-01-31 16:18:47','globeadmin'),('56ba2b9f0c37ce8','547de3bee410196','54e61e02a705c6d','2016-02-09 20:10:39','globeadmin','2016-02-09 20:10:39','globeadmin','2022-01-31 16:18:47','globeadmin'),('56ba2b9f138ac93','547de3bee410196','54eb5821b763976','2016-02-09 20:10:39','globeadmin','2016-02-09 20:10:39','globeadmin','2022-01-31 16:18:47','globeadmin'),('56ba2b9f1addc03','547de3bee410196','54f4afe911e357f','2016-02-09 20:10:39','globeadmin','2016-02-09 20:10:39','globeadmin','2022-01-31 16:18:47','globeadmin'),('56ba2b9f2230c2a','547de3bee410196','54f729629379af4','2016-02-09 20:10:39','globeadmin','2016-02-09 20:10:39','globeadmin','2022-01-31 16:18:43','globeadmin'),('56ba2b9f2983b54','547de3bee410196','54f8ae257942c56','2016-02-09 20:10:39','globeadmin','2016-02-09 20:10:39','globeadmin','2022-01-31 16:18:45','globeadmin'),('56ba2b9f30d6c14','547de3bee410196','54fdfd017b6a60e','2016-02-09 20:10:39','globeadmin','2016-02-09 20:10:39','globeadmin','2022-01-31 16:18:46','globeadmin'),('56ba2b9f3829bec','547de3bee410196','54ff33e86cd65f8','2016-02-09 20:10:39','globeadmin','2016-02-09 20:10:39','globeadmin','2022-01-31 16:18:43','globeadmin'),('56ba2b9f3f7cab6','547de3bee410196','55004dd5e43f2f2','2016-02-09 20:10:39','globeadmin','2016-02-09 20:10:39','globeadmin','2022-01-31 16:18:43','globeadmin'),('56ba2b9f46cfc2e','547de3bee410196','5507176562eedae','2016-02-09 20:10:39','globeadmin','2016-02-09 20:10:39','globeadmin','2022-01-31 16:18:47','globeadmin'),('56ba2b9f4e230af','547de3bee410196','550737d00a4a57b','2016-02-09 20:10:39','globeadmin','2016-02-09 20:10:39','globeadmin','2022-01-31 16:18:43','globeadmin'),('56ba2b9f5575b5d','547de3bee410196','5507d4d7b50b99c','2016-02-09 20:10:39','globeadmin','2016-02-09 20:10:39','globeadmin','2022-01-31 16:18:46','globeadmin'),('56ba2b9f5cc8ba7','547de3bee410196','550c7f9aba73fb6','2016-02-09 20:10:39','globeadmin','2016-02-09 20:10:39','globeadmin','2022-01-31 16:18:43','globeadmin'),('56ba2b9f641bcd3','547de3bee410196','550d4eea3e00a18','2016-02-09 20:10:39','globeadmin','2016-02-09 20:10:39','globeadmin','2022-01-31 16:18:47','globeadmin'),('56ba2b9f6b6efa7','547de3bee410196','550d5651ba833e2','2016-02-09 20:10:39','globeadmin','2016-02-09 20:10:39','globeadmin','2022-01-31 16:18:43','globeadmin'),('56ba2b9f72c1ca6','547de3bee410196','550db8c2a38fc30','2016-02-09 20:10:39','globeadmin','2016-02-09 20:10:39','globeadmin','2022-01-31 16:18:44','globeadmin'),('56ba2b9f7a14c9f','547de3bee410196','550e7cdc443015a','2016-02-09 20:10:39','globeadmin','2016-02-09 20:10:39','globeadmin','2022-01-31 16:18:45','globeadmin'),('56ba2b9f8167b95','547de3bee410196','55128eb9652ead5','2016-02-09 20:10:39','globeadmin','2016-02-09 20:10:39','globeadmin','2022-01-31 16:18:46','globeadmin'),('570b8df229c7cb0','5689468794353da','570a9f835bf5454','2016-04-11 14:43:46','globeadmin','2016-04-11 14:43:46','globeadmin','2016-04-11 14:43:46','globeadmin'),('570b8dee4e66f7d','5601afbc23dfb00','570a9f835bf5454','2016-04-11 14:43:42','globeadmin','2016-04-11 14:43:42','globeadmin','2018-11-20 14:42:28','globeadmin'),('56ba2b9f9760fdb','547de3bee410196','55183736b84eee4','2016-02-09 20:10:39','globeadmin','2016-02-09 20:10:39','globeadmin','2022-01-31 16:18:43','globeadmin'),('56ba2b9f9eb3ecb','547de3bee410196','551a39550972489','2016-02-09 20:10:39','globeadmin','2016-02-09 20:10:39','globeadmin','2022-01-31 16:18:46','globeadmin'),('56ba2b9fa606cb8','547de3bee410196','552124aeebd01bf','2016-02-09 20:10:39','globeadmin','2016-02-09 20:10:39','globeadmin','2022-01-31 16:18:45','globeadmin'),('56ba2b9fad59c22','547de3bee410196','552233092acee07','2016-02-09 20:10:39','globeadmin','2016-02-09 20:10:39','globeadmin','2022-01-31 16:18:45','globeadmin'),('56ba2b9fb4acd60','547de3bee410196','5522ba5ae053074','2016-02-09 20:10:39','globeadmin','2016-02-09 20:10:39','globeadmin','2022-01-31 16:18:45','globeadmin'),('56ba2b9fbbffc8e','547de3bee410196','55255886b0e2e42','2016-02-09 20:10:39','globeadmin','2016-02-09 20:10:39','globeadmin','2022-01-31 16:18:43','globeadmin'),('56ba2b9fc352e47','547de3bee410196','55262fb4d34fbc0','2016-02-09 20:10:39','globeadmin','2016-02-09 20:10:39','globeadmin','2022-01-31 16:18:44','globeadmin'),('56ba2b9fcaa66a3','547de3bee410196','552ea7c73b78c04','2016-02-09 20:10:39','globeadmin','2016-02-09 20:10:39','globeadmin','2022-01-31 16:18:45','globeadmin'),('56ba2b9fd1f8ea7','547de3bee410196','5537d807e48c62b','2016-02-09 20:10:39','globeadmin','2016-02-09 20:10:39','globeadmin','2022-01-31 16:18:46','globeadmin'),('56ba2b9fd94be46','547de3bee410196','5539081d564cca6','2016-02-09 20:10:39','globeadmin','2016-02-09 20:10:39','globeadmin','2022-01-31 16:18:45','globeadmin'),('56ba2b9fe09ec3d','547de3bee410196','553fe1e308e7e3a','2016-02-09 20:10:39','globeadmin','2016-02-09 20:10:39','globeadmin','2022-01-31 16:18:46','globeadmin'),('56ba2b9fe7f3eed','547de3bee410196','5541240a041c4ee','2016-02-09 20:10:39','globeadmin','2016-02-09 20:10:39','globeadmin','2022-01-31 16:18:43','globeadmin'),('56ba2b9fef4593c','547de3bee410196','554797f3cce46e4','2016-02-09 20:10:39','globeadmin','2016-02-09 20:10:39','globeadmin','2022-01-31 16:18:47','globeadmin'),('56ba2ba00273d09','547de3bee410196','5547a512d1c5bd2','2016-02-09 20:10:40','globeadmin','2016-02-09 20:10:40','globeadmin','2022-01-31 16:18:47','globeadmin'),('56ba2ba009c6c19','547de3bee410196','55490413c23b81c','2016-02-09 20:10:40','globeadmin','2016-02-09 20:10:40','globeadmin','2022-01-31 16:18:48','globeadmin'),('56ba2ba01119c29','547de3bee410196','555d8a344f6f95a','2016-02-09 20:10:40','globeadmin','2016-02-09 20:10:40','globeadmin','2022-01-31 16:18:43','globeadmin'),('56ba2ba0186cd12','547de3bee410196','5569e34f68bcbbb','2016-02-09 20:10:40','globeadmin','2016-02-09 20:10:40','globeadmin','2022-01-31 16:18:46','globeadmin'),('56ba2ba01fbfc12','547de3bee410196','55fd4a4b286857e','2016-02-09 20:10:40','globeadmin','2016-02-09 20:10:40','globeadmin','2022-01-31 16:18:43','globeadmin'),('56ba2ba02712bd7','547de3bee410196','561191a369a4a78','2016-02-09 20:10:40','globeadmin','2016-02-09 20:10:40','globeadmin','2022-01-31 16:18:44','globeadmin'),('56ba2ba02e65ca4','547de3bee410196','561542b85b07cd4','2016-02-09 20:10:40','globeadmin','2016-02-09 20:10:40','globeadmin','2022-01-31 16:18:43','globeadmin'),('56ba2ba035b8b5b','547de3bee410196','561c0a55ec1ed91','2016-02-09 20:10:40','globeadmin','2016-02-09 20:10:40','globeadmin','2022-01-31 16:18:45','globeadmin'),('56ba2ba03d0bcb7','547de3bee410196','561d62acbdd0ab8','2016-02-09 20:10:40','globeadmin','2016-02-09 20:10:40','globeadmin','2022-01-31 16:18:46','globeadmin'),('56ba2ba0445ed9f','547de3bee410196','561feead7838ca8','2016-02-09 20:10:40','globeadmin','2016-02-09 20:10:40','globeadmin','2022-01-31 16:18:46','globeadmin'),('56ba2ba04bb1d71','547de3bee410196','56200a1fadf03a4','2016-02-09 20:10:40','globeadmin','2016-02-09 20:10:40','globeadmin','2022-01-31 16:18:43','globeadmin'),('570b8dea3d4e496','5501dbedc785fe4','570a9f835bf5454','2016-04-11 14:43:38','globeadmin','2016-04-11 14:43:38','globeadmin','2018-01-09 18:51:26','globeadmin'),('56ba2ba05a57b73','547de3bee410196','562e7c9f1816a51','2016-02-09 20:10:40','globeadmin','2016-02-09 20:10:40','globeadmin','2022-01-31 16:18:45','globeadmin'),('56ba2ba061aab1e','547de3bee410196','562e80fdcf335fe','2016-02-09 20:10:40','globeadmin','2016-02-09 20:10:40','globeadmin','2022-01-31 16:18:47','globeadmin'),('56ba2ba068fdcf1','547de3bee410196','563134ef69e16fd','2016-02-09 20:10:40','globeadmin','2016-02-09 20:10:40','globeadmin','2022-01-31 16:18:45','globeadmin'),('56ba2ba07050cba','547de3bee410196','563137091e32c73','2016-02-09 20:10:40','globeadmin','2016-02-09 20:10:40','globeadmin','2022-01-31 16:18:45','globeadmin'),('56ba2ba077a3f4e','547de3bee410196','5635f36fa9f36bf','2016-02-09 20:10:40','globeadmin','2016-02-09 20:10:40','globeadmin','2016-02-09 20:32:53','globeadmin'),('56ba2ba07ef6ca0','547de3bee410196','563634de56f2b28','2016-02-09 20:10:40','globeadmin','2016-02-09 20:10:40','globeadmin','2022-01-31 16:18:45','globeadmin'),('56ba2ba08649cad','547de3bee410196','5636594106c1894','2016-02-09 20:10:40','globeadmin','2016-02-09 20:10:40','globeadmin','2022-01-31 16:18:45','globeadmin'),('56ba2ba08d9ca93','547de3bee410196','56521e303a1e26c','2016-02-09 20:10:40','globeadmin','2016-02-09 20:10:40','globeadmin','2022-01-31 16:18:47','globeadmin'),('56ba2ba094efcec','547de3bee410196','56588495311fece','2016-02-09 20:10:40','globeadmin','2016-02-09 20:10:40','globeadmin','2022-01-31 16:18:43','globeadmin'),('56ba2ba09c42c9a','547de3bee410196','565ac873e409ddc','2016-02-09 20:10:40','globeadmin','2016-02-09 20:10:40','globeadmin','2022-01-31 16:18:45','globeadmin'),('56ba2ba0a395bf4','547de3bee410196','56608bc656a4d24','2016-02-09 20:10:40','globeadmin','2016-02-09 20:10:40','globeadmin','2022-01-31 16:18:47','globeadmin'),('56ba2ba0aae8d79','547de3bee410196','56a11975eff1dd2','2016-02-09 20:10:40','globeadmin','2016-02-09 20:10:40','globeadmin','2022-01-31 16:18:47','globeadmin'),('56ba2bb9d46b9e0','547de3e001028e8','52c0da99b95c264','2016-02-09 20:11:05','globeadmin','2016-02-09 20:11:05','globeadmin','2019-11-06 15:15:15','globeadmin'),('56ba2bb9dbbcd45','547de3e001028e8','530a8f8e78111c4','2016-02-09 20:11:05','globeadmin','2016-02-09 20:11:05','globeadmin','2019-11-06 15:15:22','globeadmin'),('56ba2bb9e30fc73','547de3e001028e8','5477806364bbd3b','2016-02-09 20:11:05','globeadmin','2016-02-09 20:11:05','globeadmin','2019-11-06 15:15:21','globeadmin'),('56ba2bb9ea62df3','547de3e001028e8','547cc4b073c1854','2016-02-09 20:11:05','globeadmin','2016-02-09 20:11:05','globeadmin','2017-10-06 23:57:52','globeadmin'),('56ba2bb9f1b5c27','547de3e001028e8','547cce2020be0b5','2016-02-09 20:11:05','globeadmin','2016-02-09 20:11:05','globeadmin','2019-11-06 15:15:21','globeadmin'),('56ba2bba04e4e7d','547de3e001028e8','5494859e9bfaf58','2016-02-09 20:11:06','globeadmin','2016-02-09 20:11:06','globeadmin','2019-11-06 15:15:21','globeadmin'),('56ba2bba0c37cdc','547de3e001028e8','5495d3357b0fb7c','2016-02-09 20:11:06','globeadmin','2016-02-09 20:11:06','globeadmin','2019-11-06 15:15:21','globeadmin'),('56ba2bba138d102','547de3e001028e8','5498454b86171f6','2016-02-09 20:11:06','globeadmin','2016-02-09 20:11:06','globeadmin','2019-11-06 15:15:17','globeadmin'),('56ba2bba1ae0af4','547de3e001028e8','549ef456718c2ed','2016-02-09 20:11:06','globeadmin','2016-02-09 20:11:06','globeadmin','2019-11-06 15:15:17','globeadmin'),('56ba2bba2230e76','547de3e001028e8','54a06aabf3085fe','2016-02-09 20:11:06','globeadmin','2016-02-09 20:11:06','globeadmin','2019-11-06 15:15:16','globeadmin'),('56ba2bba2983c7f','547de3e001028e8','54a11e8a5b34dee','2016-02-09 20:11:06','globeadmin','2016-02-09 20:11:06','globeadmin','2019-11-06 15:15:14','globeadmin'),('56ba2bba30d6d2d','547de3e001028e8','54a2700ab351809','2016-02-09 20:11:06','globeadmin','2016-02-09 20:11:06','globeadmin','2019-11-06 15:15:16','globeadmin'),('56ba2bba3829e8b','547de3e001028e8','54a2baf998a4dbd','2016-02-09 20:11:06','globeadmin','2016-02-09 20:11:06','globeadmin','2019-11-06 15:15:15','globeadmin'),('56ba2bba3f7cd7e','547de3e001028e8','54a30da411a6ba7','2016-02-09 20:11:06','globeadmin','2016-02-09 20:11:06','globeadmin','2019-11-06 15:15:21','globeadmin'),('56ba2bba46cfb6f','547de3e001028e8','54a3e7ba6b7fc63','2016-02-09 20:11:06','globeadmin','2016-02-09 20:11:06','globeadmin','2019-11-06 15:15:17','globeadmin'),('56ba2bba4e22c2b','547de3e001028e8','54a57904c1b4546','2016-02-09 20:11:06','globeadmin','2016-02-09 20:11:06','globeadmin','2019-11-06 15:15:16','globeadmin'),('56ba2bba5576009','547de3e001028e8','54a921725907fab','2016-02-09 20:11:06','globeadmin','2016-02-09 20:11:06','globeadmin','2019-11-06 15:15:20','globeadmin'),('56ba2bba5cc8b6f','547de3e001028e8','54a9704fd26ded5','2016-02-09 20:11:06','globeadmin','2016-02-09 20:11:06','globeadmin','2019-11-06 15:15:20','globeadmin'),('56ba2bba641bc6b','547de3e001028e8','54aa72ec60858cc','2016-02-09 20:11:06','globeadmin','2016-02-09 20:11:06','globeadmin','2019-11-06 15:15:12','globeadmin'),('56ba2bba6b6eb4d','547de3e001028e8','54b1245d2bacdb6','2016-02-09 20:11:06','globeadmin','2016-02-09 20:11:06','globeadmin','2016-04-26 11:28:40','globeadmin'),('56ba2bba72c1c3b','547de3e001028e8','54b3853f5280e06','2016-02-09 20:11:06','globeadmin','2016-02-09 20:11:06','globeadmin','2019-11-06 15:15:19','globeadmin'),('56ba2bba7a14b0f','547de3e001028e8','54d1374c9e8d38a','2016-02-09 20:11:06','globeadmin','2016-02-09 20:11:06','globeadmin','2019-11-06 15:15:17','globeadmin'),('56ba2bba8167cb2','547de3e001028e8','54d65d126230684','2016-02-09 20:11:06','globeadmin','2016-02-09 20:11:06','globeadmin','2019-11-06 15:15:16','globeadmin'),('56ba2bba88bb66e','547de3e001028e8','54d6660b538bea2','2016-02-09 20:11:06','globeadmin','2016-02-09 20:11:06','globeadmin','2019-11-06 15:15:17','globeadmin'),('56ba2bba900dd46','547de3e001028e8','54da24749d82eb7','2016-02-09 20:11:06','globeadmin','2016-02-09 20:11:06','globeadmin','2019-11-06 15:15:16','globeadmin'),('56ba2bba9760b85','547de3e001028e8','54df2384b808c9b','2016-02-09 20:11:06','globeadmin','2016-02-09 20:11:06','globeadmin','2019-11-06 15:15:21','globeadmin'),('56ba2bba9eb3cd6','547de3e001028e8','54df23b8e8dd0cf','2016-02-09 20:11:06','globeadmin','2016-02-09 20:11:06','globeadmin','2019-11-06 15:15:21','globeadmin'),('56ba2bbaa606cee','547de3e001028e8','54df242190f8a42','2016-02-09 20:11:06','globeadmin','2016-02-09 20:11:06','globeadmin','2019-11-06 15:15:22','globeadmin'),('56ba2bbaad59a3a','547de3e001028e8','54df249e87338f1','2016-02-09 20:11:06','globeadmin','2016-02-09 20:11:06','globeadmin','2019-11-06 15:15:21','globeadmin'),('56ba2bbab4acb6a','547de3e001028e8','54df24c6566897c','2016-02-09 20:11:06','globeadmin','2016-02-09 20:11:06','globeadmin','2019-11-06 15:15:21','globeadmin'),('56ba2bbabbfff53','547de3e001028e8','54df2503ce004f5','2016-02-09 20:11:06','globeadmin','2016-02-09 20:11:06','globeadmin','2019-11-06 15:15:22','globeadmin'),('56ba2bbac352cbf','547de3e001028e8','54e61e02a705c6d','2016-02-09 20:11:06','globeadmin','2016-02-09 20:11:06','globeadmin','2019-11-06 15:15:20','globeadmin'),('56ba2bbacaa5a77','547de3e001028e8','54eb5821b763976','2016-02-09 20:11:06','globeadmin','2016-02-09 20:11:06','globeadmin','2019-11-06 15:15:21','globeadmin'),('56ba2bbad1f8cba','547de3e001028e8','54f4afe911e357f','2016-02-09 20:11:06','globeadmin','2016-02-09 20:11:06','globeadmin','2019-11-06 15:15:21','globeadmin'),('56ba2bbad94bc91','547de3e001028e8','54f729629379af4','2016-02-09 20:11:06','globeadmin','2016-02-09 20:11:06','globeadmin','2019-11-06 15:15:13','globeadmin'),('56ba2bbae09ebd1','547de3e001028e8','54f8ae257942c56','2016-02-09 20:11:06','globeadmin','2016-02-09 20:11:06','globeadmin','2019-11-06 15:15:15','globeadmin'),('56ba2bbae7f3039','547de3e001028e8','54fdfd017b6a60e','2016-02-09 20:11:06','globeadmin','2016-02-09 20:11:06','globeadmin','2019-11-06 15:15:18','globeadmin'),('56ba2bbaef44b8b','547de3e001028e8','54ff33e86cd65f8','2016-02-09 20:11:06','globeadmin','2016-02-09 20:11:06','globeadmin','2019-11-06 15:15:11','globeadmin'),('56ba2bbb0273d15','547de3e001028e8','55004dd5e43f2f2','2016-02-09 20:11:07','globeadmin','2016-02-09 20:11:07','globeadmin','2019-11-06 15:15:13','globeadmin'),('56ba2bbb09c703b','547de3e001028e8','5507176562eedae','2016-02-09 20:11:07','globeadmin','2016-02-09 20:11:07','globeadmin','2019-11-06 15:15:20','globeadmin'),('56ba2bbb1119c78','547de3e001028e8','550737d00a4a57b','2016-02-09 20:11:07','globeadmin','2016-02-09 20:11:07','globeadmin','2019-11-06 15:15:12','globeadmin'),('56ba2bbb186cc2f','547de3e001028e8','5507d4d7b50b99c','2016-02-09 20:11:07','globeadmin','2016-02-09 20:11:07','globeadmin','2019-11-06 15:15:18','globeadmin'),('56ba2bbb1fc00ce','547de3e001028e8','550c7f9aba73fb6','2016-02-09 20:11:07','globeadmin','2016-02-09 20:11:07','globeadmin','2019-11-06 15:15:12','globeadmin'),('56ba2bbb2712c54','547de3e001028e8','550d4eea3e00a18','2016-02-09 20:11:07','globeadmin','2016-02-09 20:11:07','globeadmin','2019-11-06 15:15:19','globeadmin'),('56ba2bbb2e65cd2','547de3e001028e8','550d5651ba833e2','2016-02-09 20:11:07','globeadmin','2016-02-09 20:11:07','globeadmin','2019-11-06 15:15:11','globeadmin'),('56ba2bbb35b8c58','547de3e001028e8','550db8c2a38fc30','2016-02-09 20:11:07','globeadmin','2016-02-09 20:11:07','globeadmin','2019-11-06 15:15:14','globeadmin'),('570b8ddf70961d9','547de3e001028e8','570a9f835bf5454','2016-04-11 14:43:27','globeadmin','2016-04-11 14:43:27','globeadmin','2019-11-06 15:15:20','globeadmin'),('56ba2bbb445eb49','547de3e001028e8','55128eb9652ead5','2016-02-09 20:11:07','globeadmin','2016-02-09 20:11:07','globeadmin','2019-11-06 15:15:19','globeadmin'),('570b8dd31d929df','547de3bee410196','570a9f835bf5454','2016-04-11 14:43:15','globeadmin','2016-04-11 14:43:15','globeadmin','2022-01-31 16:18:47','globeadmin'),('57231732b3854c3','5601afbc23dfb00','57208dbe24f2fad','2016-04-29 11:11:30','globeadmin','2016-04-29 11:11:30','globeadmin','2018-11-20 14:42:19','globeadmin'),('56ba2bbb5a57c6b','547de3e001028e8','55183736b84eee4','2016-02-09 20:11:07','globeadmin','2016-02-09 20:11:07','globeadmin','2019-11-06 15:15:11','globeadmin'),('56ba2bbb61aab00','547de3e001028e8','551a39550972489','2016-02-09 20:11:07','globeadmin','2016-02-09 20:11:07','globeadmin','2019-11-06 15:15:18','globeadmin'),('56ba2bbb68fdb8d','547de3e001028e8','552124aeebd01bf','2016-02-09 20:11:07','globeadmin','2016-02-09 20:11:07','globeadmin','2019-11-06 15:15:17','globeadmin'),('56ba2bbb7050b56','547de3e001028e8','552233092acee07','2016-02-09 20:11:07','globeadmin','2016-02-09 20:11:07','globeadmin','2019-11-06 15:15:16','globeadmin'),('56ba2bbb77a3b6e','547de3e001028e8','5522ba5ae053074','2016-02-09 20:11:07','globeadmin','2016-02-09 20:11:07','globeadmin','2019-11-06 15:15:16','globeadmin'),('56ba2bbb7ef6ca4','547de3e001028e8','55255886b0e2e42','2016-02-09 20:11:07','globeadmin','2016-02-09 20:11:07','globeadmin','2019-11-06 15:15:11','globeadmin'),('56ba2bbb8649c5c','547de3e001028e8','55262fb4d34fbc0','2016-02-09 20:11:07','globeadmin','2016-02-09 20:11:07','globeadmin','2019-11-06 15:15:14','globeadmin'),('56ba2bbb8d9cd0f','547de3e001028e8','552ea7c73b78c04','2016-02-09 20:11:07','globeadmin','2016-02-09 20:11:07','globeadmin','2019-11-06 15:15:17','globeadmin'),('56ba2bbb94efc71','547de3e001028e8','5537d807e48c62b','2016-02-09 20:11:07','globeadmin','2016-02-09 20:11:07','globeadmin','2019-11-06 15:15:18','globeadmin'),('56ba2bbb9c42c99','547de3e001028e8','5539081d564cca6','2016-02-09 20:11:07','globeadmin','2016-02-09 20:11:07','globeadmin','2019-11-06 15:15:17','globeadmin'),('56ba2bbba395b3d','547de3e001028e8','553fe1e308e7e3a','2016-02-09 20:11:07','globeadmin','2016-02-09 20:11:07','globeadmin','2019-11-06 15:15:19','globeadmin'),('56ba2bbbaae8cef','547de3e001028e8','5541240a041c4ee','2016-02-09 20:11:07','globeadmin','2016-02-09 20:11:07','globeadmin','2019-11-06 15:15:12','globeadmin'),('56ba2bbbb23bce6','547de3e001028e8','554797f3cce46e4','2016-02-09 20:11:07','globeadmin','2016-02-09 20:11:07','globeadmin','2019-11-06 15:15:20','globeadmin'),('56ba2bbbb98ec40','547de3e001028e8','5547a512d1c5bd2','2016-02-09 20:11:07','globeadmin','2016-02-09 20:11:07','globeadmin','2019-11-06 15:15:21','globeadmin'),('56ba2bbbc0e1cc8','547de3e001028e8','55490413c23b81c','2016-02-09 20:11:07','globeadmin','2016-02-09 20:11:07','globeadmin','2019-11-06 15:15:22','globeadmin'),('56ba2bbbc834b1c','547de3e001028e8','555d8a344f6f95a','2016-02-09 20:11:07','globeadmin','2016-02-09 20:11:07','globeadmin','2019-11-06 15:15:13','globeadmin'),('56ba2bbbcf87c1d','547de3e001028e8','5569e34f68bcbbb','2016-02-09 20:11:07','globeadmin','2016-02-09 20:11:07','globeadmin','2019-11-06 15:15:18','globeadmin'),('56ba2bbbd6daa83','547de3e001028e8','55fd4a4b286857e','2016-02-09 20:11:07','globeadmin','2016-02-09 20:11:07','globeadmin','2019-11-06 15:15:13','globeadmin'),('56ba2bbbde2dfb7','547de3e001028e8','561191a369a4a78','2016-02-09 20:11:07','globeadmin','2016-02-09 20:11:07','globeadmin','2019-11-06 15:15:15','globeadmin'),('56ba2bbbe580d8c','547de3e001028e8','561542b85b07cd4','2016-02-09 20:11:07','globeadmin','2016-02-09 20:11:07','globeadmin','2019-11-06 15:15:12','globeadmin'),('56ba2bbbecd3cbd','547de3e001028e8','561c0a55ec1ed91','2016-02-09 20:11:07','globeadmin','2016-02-09 20:11:07','globeadmin','2019-11-06 15:15:17','globeadmin'),('56ba2bbc0002e06','547de3e001028e8','561d62acbdd0ab8','2016-02-09 20:11:08','globeadmin','2016-02-09 20:11:08','globeadmin','2019-11-06 15:15:19','globeadmin'),('56ba2bbc0755ea5','547de3e001028e8','561feead7838ca8','2016-02-09 20:11:08','globeadmin','2016-02-09 20:11:08','globeadmin','2019-11-06 15:15:18','globeadmin'),('56ba2bbc0ea8cda','547de3e001028e8','56200a1fadf03a4','2016-02-09 20:11:08','globeadmin','2016-02-09 20:11:08','globeadmin','2019-11-06 15:15:13','globeadmin'),('570a19cd879771f','5689468794353da','570a196b80430d3','2016-04-10 12:15:57','globeadmin','2016-04-10 12:15:57','globeadmin','2016-04-10 12:15:57','globeadmin'),('56ba2bbc1d4ecd4','547de3e001028e8','562e7c9f1816a51','2016-02-09 20:11:08','globeadmin','2016-02-09 20:11:08','globeadmin','2019-11-06 15:15:16','globeadmin'),('56ba2bbc27133ff','547de3e001028e8','562e80fdcf335fe','2016-02-09 20:11:08','globeadmin','2016-02-09 20:11:08','globeadmin','2019-11-06 15:15:20','globeadmin'),('56ba2bbc2e65c4b','547de3e001028e8','563134ef69e16fd','2016-02-09 20:11:08','globeadmin','2016-02-09 20:11:08','globeadmin','2019-11-06 15:15:16','globeadmin'),('56ba2bbc35b8d5d','547de3e001028e8','563137091e32c73','2016-02-09 20:11:08','globeadmin','2016-02-09 20:11:08','globeadmin','2019-11-06 15:15:16','globeadmin'),('56ba2bbc3d0bc80','547de3e001028e8','5635f36fa9f36bf','2016-02-09 20:11:08','globeadmin','2016-02-09 20:11:08','globeadmin','2017-10-06 23:57:45','globeadmin'),('56ba2bbc445ec86','547de3e001028e8','563634de56f2b28','2016-02-09 20:11:08','globeadmin','2016-02-09 20:11:08','globeadmin','2019-11-06 15:15:16','globeadmin'),('56ba2bbc4bb1daf','547de3e001028e8','5636594106c1894','2016-02-09 20:11:08','globeadmin','2016-02-09 20:11:08','globeadmin','2019-11-06 15:15:16','globeadmin'),('56ba2bbc53050cf','547de3e001028e8','56521e303a1e26c','2016-02-09 20:11:08','globeadmin','2016-02-09 20:11:08','globeadmin','2019-11-06 15:15:22','globeadmin'),('56ba2bbc5a57be8','547de3e001028e8','56588495311fece','2016-02-09 20:11:08','globeadmin','2016-02-09 20:11:08','globeadmin','2019-11-06 15:15:12','globeadmin'),('56ba2bbc61aab85','547de3e001028e8','565ac873e409ddc','2016-02-09 20:11:08','globeadmin','2016-02-09 20:11:08','globeadmin','2019-11-06 15:15:17','globeadmin'),('56ba2bbc68fdcd3','547de3e001028e8','56608bc656a4d24','2016-02-09 20:11:08','globeadmin','2016-02-09 20:11:08','globeadmin','2019-11-06 15:15:21','globeadmin'),('56ba2bbc7050b35','547de3e001028e8','5687b0505b9ec15','2016-02-09 20:11:08','globeadmin','2016-02-09 20:11:08','globeadmin','2019-11-06 15:15:19','globeadmin'),('56ba2bbc77a3c50','547de3e001028e8','56883955e3ab0ac','2016-02-09 20:11:08','globeadmin','2016-02-09 20:11:08','globeadmin','2019-11-06 15:15:13','globeadmin'),('56ba2bbc7ef6c0e','547de3e001028e8','56a11975eff1dd2','2016-02-09 20:11:08','globeadmin','2016-02-09 20:11:08','globeadmin','2019-11-06 15:15:20','globeadmin'),('570a19c87dd1a2d','5601afbc23dfb00','570a196b80430d3','2016-04-10 12:15:52','globeadmin','2016-04-10 12:15:52','globeadmin','2018-11-20 14:42:26','globeadmin'),('56ba2bc45093cf2','5501dbedc785fe4','52c0da99b95c264','2016-02-09 20:11:16','globeadmin','2016-02-09 20:11:16','globeadmin','2018-01-09 18:51:20','globeadmin'),('56ba2bc457e6ba9','5501dbedc785fe4','530a8f8e78111c4','2016-02-09 20:11:16','globeadmin','2016-02-09 20:11:16','globeadmin','2018-01-09 18:51:28','globeadmin'),('56ba2bc45f39bb8','5501dbedc785fe4','5477806364bbd3b','2016-02-09 20:11:16','globeadmin','2016-02-09 20:11:16','globeadmin','2018-01-09 18:51:27','globeadmin'),('56ba2bc4668ccc9','5501dbedc785fe4','547cc4b073c1854','2016-02-09 20:11:16','globeadmin','2016-02-09 20:11:16','globeadmin','2018-01-09 18:51:27','globeadmin'),('56ba2bc46ddfbf5','5501dbedc785fe4','547cce2020be0b5','2016-02-09 20:11:16','globeadmin','2016-02-09 20:11:16','globeadmin','2018-01-09 18:51:27','globeadmin'),('56ba2bc47532c82','5501dbedc785fe4','5487369544262a7','2016-02-09 20:11:16','globeadmin','2016-02-09 20:11:16','globeadmin','2018-01-09 18:51:14','globeadmin'),('56ba2bc47c85ce9','5501dbedc785fe4','548897f34ce2b64','2016-02-09 20:11:16','globeadmin','2016-02-09 20:11:16','globeadmin','2018-01-09 18:51:20','globeadmin'),('56ba2bc483d8c17','5501dbedc785fe4','54889d24766371b','2016-02-09 20:11:16','globeadmin','2016-02-09 20:11:16','globeadmin','2018-01-09 18:51:25','globeadmin'),('56ba2bc48b2bcb0','5501dbedc785fe4','548b2b8d4b3f282','2016-02-09 20:11:16','globeadmin','2016-02-09 20:11:16','globeadmin','2018-01-09 18:51:21','globeadmin'),('56ba2bc4927ec32','5501dbedc785fe4','5494859e9bfaf58','2016-02-09 20:11:16','globeadmin','2016-02-09 20:11:16','globeadmin','2018-01-09 18:51:28','globeadmin'),('56ba2bc499d1b8f','5501dbedc785fe4','5495d3357b0fb7c','2016-02-09 20:11:16','globeadmin','2016-02-09 20:11:16','globeadmin','2018-01-09 18:51:28','globeadmin'),('56ba2bc4a124dbe','5501dbedc785fe4','5498454b86171f6','2016-02-09 20:11:16','globeadmin','2016-02-09 20:11:16','globeadmin','2018-01-09 18:51:23','globeadmin'),('56ba2bc4a877d62','5501dbedc785fe4','549ef456718c2ed','2016-02-09 20:11:16','globeadmin','2016-02-09 20:11:16','globeadmin','2018-01-09 18:51:23','globeadmin'),('56ba2bc4afcacf8','5501dbedc785fe4','54a06aabf3085fe','2016-02-09 20:11:16','globeadmin','2016-02-09 20:11:16','globeadmin','2018-01-09 18:51:22','globeadmin'),('56ba2bc4b71e44e','5501dbedc785fe4','54a11e8a5b34dee','2016-02-09 20:11:16','globeadmin','2016-02-09 20:11:16','globeadmin','2018-01-09 18:51:20','globeadmin'),('56ba2bc4be70c1a','5501dbedc785fe4','54a2700ab351809','2016-02-09 20:11:16','globeadmin','2016-02-09 20:11:16','globeadmin','2018-01-09 18:51:21','globeadmin'),('56ba2bc4c5c3f41','5501dbedc785fe4','54a2baf998a4dbd','2016-02-09 20:11:16','globeadmin','2016-02-09 20:11:16','globeadmin','2018-01-09 18:51:20','globeadmin'),('56ba2bc4cd16bbe','5501dbedc785fe4','54a30da411a6ba7','2016-02-09 20:11:16','globeadmin','2016-02-09 20:11:16','globeadmin','2018-01-09 18:51:28','globeadmin'),('56ba2bc4d469cde','5501dbedc785fe4','54a3e7ba6b7fc63','2016-02-09 20:11:16','globeadmin','2016-02-09 20:11:16','globeadmin','2018-01-09 18:51:23','globeadmin'),('56ba2bc4dbbcce8','5501dbedc785fe4','54a57904c1b4546','2016-02-09 20:11:16','globeadmin','2016-02-09 20:11:16','globeadmin','2018-01-09 18:51:21','globeadmin'),('56ba2bc4e30fa01','5501dbedc785fe4','54a921725907fab','2016-02-09 20:11:16','globeadmin','2016-02-09 20:11:16','globeadmin','2018-01-09 18:51:26','globeadmin'),('56ba2bc4ea62d02','5501dbedc785fe4','54a9704fd26ded5','2016-02-09 20:11:16','globeadmin','2016-02-09 20:11:16','globeadmin','2018-01-09 18:51:27','globeadmin'),('56ba2bc4f1b5bf1','5501dbedc785fe4','54aa72ec60858cc','2016-02-09 20:11:16','globeadmin','2016-02-09 20:11:16','globeadmin','2018-01-09 18:51:16','globeadmin'),('56ba2bc504e4f35','5501dbedc785fe4','54b1245d2bacdb6','2016-02-09 20:11:17','globeadmin','2016-02-09 20:11:17','globeadmin','2016-02-09 20:13:31','globeadmin'),('56ba2bc50c37d6f','5501dbedc785fe4','54b3853f5280e06','2016-02-09 20:11:17','globeadmin','2016-02-09 20:11:17','globeadmin','2018-01-09 18:51:25','globeadmin'),('56ba2bc5138acaa','5501dbedc785fe4','54d1374c9e8d38a','2016-02-09 20:11:17','globeadmin','2016-02-09 20:11:17','globeadmin','2018-01-09 18:51:22','globeadmin'),('56ba2bc51addb09','5501dbedc785fe4','54d65d126230684','2016-02-09 20:11:17','globeadmin','2016-02-09 20:11:17','globeadmin','2018-01-09 18:51:22','globeadmin'),('56ba2bc52230df6','5501dbedc785fe4','54d6660b538bea2','2016-02-09 20:11:17','globeadmin','2016-02-09 20:11:17','globeadmin','2018-01-09 18:51:22','globeadmin'),('56ba2bc52983bb0','5501dbedc785fe4','54da24749d82eb7','2016-02-09 20:11:17','globeadmin','2016-02-09 20:11:17','globeadmin','2018-01-09 18:51:21','globeadmin'),('56ba2bc530d6f59','5501dbedc785fe4','54df2384b808c9b','2016-02-09 20:11:17','globeadmin','2016-02-09 20:11:17','globeadmin','2018-01-09 18:51:28','globeadmin'),('56ba2bc53829ff7','5501dbedc785fe4','54df23b8e8dd0cf','2016-02-09 20:11:17','globeadmin','2016-02-09 20:11:17','globeadmin','2018-01-09 18:51:27','globeadmin'),('56ba2bc53f7cc30','5501dbedc785fe4','54df242190f8a42','2016-02-09 20:11:17','globeadmin','2016-02-09 20:11:17','globeadmin','2018-01-09 18:51:28','globeadmin'),('56ba2bc546cfca0','5501dbedc785fe4','54df249e87338f1','2016-02-09 20:11:17','globeadmin','2016-02-09 20:11:17','globeadmin','2018-01-09 18:51:27','globeadmin'),('56ba2bc54e22cf5','5501dbedc785fe4','54df24c6566897c','2016-02-09 20:11:17','globeadmin','2016-02-09 20:11:17','globeadmin','2018-01-09 18:51:27','globeadmin'),('56ba2bc55575c66','5501dbedc785fe4','54df2503ce004f5','2016-02-09 20:11:17','globeadmin','2016-02-09 20:11:17','globeadmin','2018-01-09 18:51:28','globeadmin'),('56ba2bc55cc8caa','5501dbedc785fe4','54e61e02a705c6d','2016-02-09 20:11:17','globeadmin','2016-02-09 20:11:17','globeadmin','2018-01-09 18:51:26','globeadmin'),('56ba2bc5641c048','5501dbedc785fe4','54eb5821b763976','2016-02-09 20:11:17','globeadmin','2016-02-09 20:11:17','globeadmin','2018-01-09 18:51:27','globeadmin'),('56ba2bc56b6ec0a','5501dbedc785fe4','54f4afe911e357f','2016-02-09 20:11:17','globeadmin','2016-02-09 20:11:17','globeadmin','2018-01-09 18:51:28','globeadmin'),('56ba2bc572c1d09','5501dbedc785fe4','54f729629379af4','2016-02-09 20:11:17','globeadmin','2016-02-09 20:11:17','globeadmin','2018-01-09 18:51:17','globeadmin'),('56ba2bc57a14c8e','5501dbedc785fe4','54f8ae257942c56','2016-02-09 20:11:17','globeadmin','2016-02-09 20:11:17','globeadmin','2018-01-09 18:51:20','globeadmin'),('56ba2bc58167be0','5501dbedc785fe4','54fdfd017b6a60e','2016-02-09 20:11:17','globeadmin','2016-02-09 20:11:17','globeadmin','2018-01-09 18:51:23','globeadmin'),('56ba2bc588bab91','5501dbedc785fe4','54ff33e86cd65f8','2016-02-09 20:11:17','globeadmin','2016-02-09 20:11:17','globeadmin','2018-01-09 18:51:15','globeadmin'),('56ba2bc5900ddf4','5501dbedc785fe4','55004dd5e43f2f2','2016-02-09 20:11:17','globeadmin','2016-02-09 20:11:17','globeadmin','2018-01-09 18:51:17','globeadmin'),('56ba2bc59760ca3','5501dbedc785fe4','5507176562eedae','2016-02-09 20:11:17','globeadmin','2016-02-09 20:11:17','globeadmin','2018-01-09 18:51:26','globeadmin'),('56ba2bc59eb3ce2','5501dbedc785fe4','550737d00a4a57b','2016-02-09 20:11:17','globeadmin','2016-02-09 20:11:17','globeadmin','2018-01-09 18:51:15','globeadmin'),('56ba2bc5a606c50','5501dbedc785fe4','5507d4d7b50b99c','2016-02-09 20:11:17','globeadmin','2016-02-09 20:11:17','globeadmin','2018-01-09 18:51:23','globeadmin'),('56ba2bc5ad59c69','5501dbedc785fe4','550c7f9aba73fb6','2016-02-09 20:11:17','globeadmin','2016-02-09 20:11:17','globeadmin','2018-01-09 18:51:15','globeadmin'),('56ba2bc5b4acb49','5501dbedc785fe4','550d4eea3e00a18','2016-02-09 20:11:17','globeadmin','2016-02-09 20:11:17','globeadmin','2018-01-09 18:51:26','globeadmin'),('56ba2bc5bbffee7','5501dbedc785fe4','550d5651ba833e2','2016-02-09 20:11:17','globeadmin','2016-02-09 20:11:17','globeadmin','2018-01-09 18:51:15','globeadmin'),('56ba2bc5c352b7c','5501dbedc785fe4','550db8c2a38fc30','2016-02-09 20:11:17','globeadmin','2016-02-09 20:11:17','globeadmin','2018-01-09 18:51:19','globeadmin'),('56ba2bc5caa5cd1','5501dbedc785fe4','550e7cdc443015a','2016-02-09 20:11:17','globeadmin','2016-02-09 20:11:17','globeadmin','2018-01-09 18:51:21','globeadmin'),('56ba2bc5d1f8b71','5501dbedc785fe4','55128eb9652ead5','2016-02-09 20:11:17','globeadmin','2016-02-09 20:11:17','globeadmin','2018-01-09 18:51:24','globeadmin'),('56ba2bc5d94bc62','5501dbedc785fe4','5515ac288fe7f65','2016-02-09 20:11:17','globeadmin','2016-02-09 20:11:17','globeadmin','2018-01-09 18:51:19','globeadmin'),('56ba2bc5e09ec0a','5501dbedc785fe4','5516d2815e269ce','2016-02-09 20:11:17','globeadmin','2016-02-09 20:11:17','globeadmin','2018-01-09 18:51:15','globeadmin'),('56ba2bc5e7f1b08','5501dbedc785fe4','55183736b84eee4','2016-02-09 20:11:17','globeadmin','2016-02-09 20:11:17','globeadmin','2018-01-09 18:51:14','globeadmin'),('56ba2bc5ef45ef4','5501dbedc785fe4','551a39550972489','2016-02-09 20:11:17','globeadmin','2016-02-09 20:11:17','globeadmin','2018-01-09 18:51:24','globeadmin'),('56ba2bc6027448f','5501dbedc785fe4','552124aeebd01bf','2016-02-09 20:11:18','globeadmin','2016-02-09 20:11:18','globeadmin','2018-01-09 18:51:22','globeadmin'),('56ba2bc609c6d05','5501dbedc785fe4','552233092acee07','2016-02-09 20:11:18','globeadmin','2016-02-09 20:11:18','globeadmin','2018-01-09 18:51:21','globeadmin'),('56ba2bc61119c7f','5501dbedc785fe4','5522ba5ae053074','2016-02-09 20:11:18','globeadmin','2016-02-09 20:11:18','globeadmin','2018-01-09 18:51:21','globeadmin'),('56ba2bc6186cd58','5501dbedc785fe4','55255886b0e2e42','2016-02-09 20:11:18','globeadmin','2016-02-09 20:11:18','globeadmin','2018-01-09 18:51:14','globeadmin'),('56ba2bc61fbffd2','5501dbedc785fe4','55262fb4d34fbc0','2016-02-09 20:11:18','globeadmin','2016-02-09 20:11:18','globeadmin','2018-01-09 18:51:19','globeadmin'),('56ba2bc62712c01','5501dbedc785fe4','552ea7c73b78c04','2016-02-09 20:11:18','globeadmin','2016-02-09 20:11:18','globeadmin','2018-01-09 18:51:22','globeadmin'),('56ba2bc62e65d0b','5501dbedc785fe4','5537d807e48c62b','2016-02-09 20:11:18','globeadmin','2016-02-09 20:11:18','globeadmin','2018-01-09 18:51:23','globeadmin'),('56ba2bc635b8c2d','5501dbedc785fe4','5539081d564cca6','2016-02-09 20:11:18','globeadmin','2016-02-09 20:11:18','globeadmin','2018-01-09 18:51:22','globeadmin'),('56ba2bc63f7d0cf','5501dbedc785fe4','553fe1e308e7e3a','2016-02-09 20:11:18','globeadmin','2016-02-09 20:11:18','globeadmin','2018-01-09 18:51:24','globeadmin'),('56ba2bc646d1b48','5501dbedc785fe4','5541240a041c4ee','2016-02-09 20:11:18','globeadmin','2016-02-09 20:11:18','globeadmin','2018-01-09 18:51:15','globeadmin'),('56ba2bc64e22b65','5501dbedc785fe4','554797f3cce46e4','2016-02-09 20:11:18','globeadmin','2016-02-09 20:11:18','globeadmin','2018-01-09 18:51:27','globeadmin'),('56ba2bc65575cfc','5501dbedc785fe4','5547a512d1c5bd2','2016-02-09 20:11:18','globeadmin','2016-02-09 20:11:18','globeadmin','2018-01-09 18:51:27','globeadmin'),('56ba2bc65cc8cdd','5501dbedc785fe4','55490413c23b81c','2016-02-09 20:11:18','globeadmin','2016-02-09 20:11:18','globeadmin','2018-01-09 18:51:28','globeadmin'),('56ba2bc6641c085','5501dbedc785fe4','555d8a344f6f95a','2016-02-09 20:11:18','globeadmin','2016-02-09 20:11:18','globeadmin','2018-01-09 18:51:17','globeadmin'),('56ba2bc66b6ecdd','5501dbedc785fe4','5569e34f68bcbbb','2016-02-09 20:11:18','globeadmin','2016-02-09 20:11:18','globeadmin','2018-01-09 18:51:23','globeadmin'),('56ba2bc672c1c0f','5501dbedc785fe4','55fd4a4b286857e','2016-02-09 20:11:18','globeadmin','2016-02-09 20:11:18','globeadmin','2018-01-09 18:51:16','globeadmin'),('56ba2bc67a14b98','5501dbedc785fe4','561191a369a4a78','2016-02-09 20:11:18','globeadmin','2016-02-09 20:11:18','globeadmin','2018-01-09 18:51:20','globeadmin'),('56ba2bc68167c4f','5501dbedc785fe4','561542b85b07cd4','2016-02-09 20:11:18','globeadmin','2016-02-09 20:11:18','globeadmin','2018-01-09 18:51:16','globeadmin'),('56ba2bc688bac6d','5501dbedc785fe4','561c0a55ec1ed91','2016-02-09 20:11:18','globeadmin','2016-02-09 20:11:18','globeadmin','2018-01-09 18:51:22','globeadmin'),('56ba2bc6900df9d','5501dbedc785fe4','561d62acbdd0ab8','2016-02-09 20:11:18','globeadmin','2016-02-09 20:11:18','globeadmin','2018-01-09 18:51:25','globeadmin'),('56ba2bc69760afa','5501dbedc785fe4','562e7c9f1816a51','2016-02-09 20:11:18','globeadmin','2016-02-09 20:11:18','globeadmin','2018-01-09 18:51:22','globeadmin'),('56ba2bc69eb3c8f','5501dbedc785fe4','562e80fdcf335fe','2016-02-09 20:11:18','globeadmin','2016-02-09 20:11:18','globeadmin','2018-01-09 18:51:26','globeadmin'),('56ba2bc6a606d1c','5501dbedc785fe4','563134ef69e16fd','2016-02-09 20:11:18','globeadmin','2016-02-09 20:11:18','globeadmin','2018-01-09 18:51:22','globeadmin'),('56ba2bc6ad59f1a','5501dbedc785fe4','563137091e32c73','2016-02-09 20:11:18','globeadmin','2016-02-09 20:11:18','globeadmin','2018-01-09 18:51:22','globeadmin'),('56ba2bc6b4acc34','5501dbedc785fe4','5635f36fa9f36bf','2016-02-09 20:11:18','globeadmin','2016-02-09 20:11:18','globeadmin','2018-01-09 18:51:21','globeadmin'),('56ba2bc6bbffcd2','5501dbedc785fe4','563634de56f2b28','2016-02-09 20:11:18','globeadmin','2016-02-09 20:11:18','globeadmin','2018-01-09 18:51:21','globeadmin'),('56ba2bc6c352c6b','5501dbedc785fe4','5636594106c1894','2016-02-09 20:11:18','globeadmin','2016-02-09 20:11:18','globeadmin','2018-01-09 18:51:22','globeadmin'),('56ba2bc6caa5fac','5501dbedc785fe4','56521e303a1e26c','2016-02-09 20:11:18','globeadmin','2016-02-09 20:11:18','globeadmin','2018-01-09 18:51:28','globeadmin'),('56ba2bc6d1f8b6e','5501dbedc785fe4','56588495311fece','2016-02-09 20:11:18','globeadmin','2016-02-09 20:11:18','globeadmin','2018-01-09 18:51:16','globeadmin'),('56ba2bc6d94bc09','5501dbedc785fe4','565ac873e409ddc','2016-02-09 20:11:18','globeadmin','2016-02-09 20:11:18','globeadmin','2018-01-09 18:51:23','globeadmin'),('56ba2bc6e09ef61','5501dbedc785fe4','56608bc656a4d24','2016-02-09 20:11:18','globeadmin','2016-02-09 20:11:18','globeadmin','2018-01-09 18:51:28','globeadmin'),('56ba2bc6e7f1c94','5501dbedc785fe4','56a11975eff1dd2','2016-02-09 20:11:18','globeadmin','2016-02-09 20:11:18','globeadmin','2018-01-09 18:51:27','globeadmin'),('56ba2bc6ef4c917','5501dbedc785fe4','56ba2948946e4df','2016-02-09 20:11:18','globeadmin','2016-02-09 20:11:18','globeadmin','2018-01-09 18:51:25','globeadmin'),('56ba2bccb98f46a','5601afbc23dfb00','52c0da99b95c264','2016-02-09 20:11:24','globeadmin','2016-02-09 20:11:24','globeadmin','2018-11-20 14:42:21','globeadmin'),('56ba2bccc0e1bb1','5601afbc23dfb00','530a8f8e78111c4','2016-02-09 20:11:24','globeadmin','2016-02-09 20:11:24','globeadmin','2018-11-20 14:42:29','globeadmin'),('56ba2bccc834dd6','5601afbc23dfb00','5477806364bbd3b','2016-02-09 20:11:24','globeadmin','2016-02-09 20:11:24','globeadmin','2018-11-20 14:42:29','globeadmin'),('56ba2bcccf87b1c','5601afbc23dfb00','547cc4b073c1854','2016-02-09 20:11:24','globeadmin','2016-02-09 20:11:24','globeadmin','2016-02-09 20:35:30','globeadmin'),('56ba2bccd6dab4e','5601afbc23dfb00','547cce2020be0b5','2016-02-09 20:11:24','globeadmin','2016-02-09 20:11:24','globeadmin','2018-11-20 14:42:28','globeadmin'),('56ba2bccde2dc73','5601afbc23dfb00','5487369544262a7','2016-02-09 20:11:24','globeadmin','2016-02-09 20:11:24','globeadmin','2018-11-20 14:42:15','globeadmin'),('56ba2bcce580cb7','5601afbc23dfb00','548897f34ce2b64','2016-02-09 20:11:24','globeadmin','2016-02-09 20:11:24','globeadmin','2018-11-20 14:42:22','globeadmin'),('56ba2bccecd3c4f','5601afbc23dfb00','54889d24766371b','2016-02-09 20:11:24','globeadmin','2016-02-09 20:11:24','globeadmin','2018-11-20 14:42:26','globeadmin'),('56ba2bcd0002cdd','5601afbc23dfb00','548b2b8d4b3f282','2016-02-09 20:11:25','globeadmin','2016-02-09 20:11:25','globeadmin','2018-11-20 14:42:22','globeadmin'),('56ba2bcd0755d36','5601afbc23dfb00','5494859e9bfaf58','2016-02-09 20:11:25','globeadmin','2016-02-09 20:11:25','globeadmin','2018-11-20 14:42:29','globeadmin'),('56ba2bcd0ea8c61','5601afbc23dfb00','5495d3357b0fb7c','2016-02-09 20:11:25','globeadmin','2016-02-09 20:11:25','globeadmin','2018-11-20 14:42:29','globeadmin'),('56ba2bcd15fbc4d','5601afbc23dfb00','5498454b86171f6','2016-02-09 20:11:25','globeadmin','2016-02-09 20:11:25','globeadmin','2018-11-20 14:42:24','globeadmin'),('56ba2bcd1d4ed76','5601afbc23dfb00','549ef456718c2ed','2016-02-09 20:11:25','globeadmin','2016-02-09 20:11:25','globeadmin','2018-11-20 14:42:24','globeadmin'),('56ba2bcd24a2105','5601afbc23dfb00','54a06aabf3085fe','2016-02-09 20:11:25','globeadmin','2016-02-09 20:11:25','globeadmin','2018-11-20 14:42:23','globeadmin'),('56ba2bcd2bf4c18','5601afbc23dfb00','54a11e8a5b34dee','2016-02-09 20:11:25','globeadmin','2016-02-09 20:11:25','globeadmin','2018-11-20 14:42:21','globeadmin'),('56ba2bcd3347d23','5601afbc23dfb00','54a2700ab351809','2016-02-09 20:11:25','globeadmin','2016-02-09 20:11:25','globeadmin','2018-11-20 14:42:22','globeadmin'),('56ba2bcd3a9ac7d','5601afbc23dfb00','54a2baf998a4dbd','2016-02-09 20:11:25','globeadmin','2016-02-09 20:11:25','globeadmin','2018-11-20 14:42:21','globeadmin'),('56ba2bcd41edcda','5601afbc23dfb00','54a30da411a6ba7','2016-02-09 20:11:25','globeadmin','2016-02-09 20:11:25','globeadmin','2018-11-20 14:42:29','globeadmin'),('56ba2bcd4940ccf','5601afbc23dfb00','54a3e7ba6b7fc63','2016-02-09 20:11:25','globeadmin','2016-02-09 20:11:25','globeadmin','2018-11-20 14:42:24','globeadmin'),('56ba2bcd5093f3b','5601afbc23dfb00','54a57904c1b4546','2016-02-09 20:11:25','globeadmin','2016-02-09 20:11:25','globeadmin','2018-11-20 14:42:22','globeadmin'),('56ba2bcd57e6cdf','5601afbc23dfb00','54a921725907fab','2016-02-09 20:11:25','globeadmin','2016-02-09 20:11:25','globeadmin','2018-11-20 14:42:27','globeadmin'),('56ba2bcd5f39ce9','5601afbc23dfb00','54a9704fd26ded5','2016-02-09 20:11:25','globeadmin','2016-02-09 20:11:25','globeadmin','2018-11-20 14:42:28','globeadmin'),('56ba2bcd668cb1d','5601afbc23dfb00','54aa72ec60858cc','2016-02-09 20:11:25','globeadmin','2016-02-09 20:11:25','globeadmin','2018-11-20 14:42:17','globeadmin'),('56ba2bcd6ddfd63','5601afbc23dfb00','54b1245d2bacdb6','2016-02-09 20:11:25','globeadmin','2016-02-09 20:11:25','globeadmin','2016-02-09 20:35:31','globeadmin'),('56ba2bcd7532cfa','5601afbc23dfb00','54b3853f5280e06','2016-02-09 20:11:25','globeadmin','2016-02-09 20:11:25','globeadmin','2018-11-20 14:42:27','globeadmin'),('56ba2bcd7c85cf4','5601afbc23dfb00','54d1374c9e8d38a','2016-02-09 20:11:25','globeadmin','2016-02-09 20:11:25','globeadmin','2018-11-20 14:42:23','globeadmin'),('56ba2bcd83d8c44','5601afbc23dfb00','54d65d126230684','2016-02-09 20:11:25','globeadmin','2016-02-09 20:11:25','globeadmin','2018-11-20 14:42:23','globeadmin'),('56ba2bcd8b2bd58','5601afbc23dfb00','54d6660b538bea2','2016-02-09 20:11:25','globeadmin','2016-02-09 20:11:25','globeadmin','2018-11-20 14:42:23','globeadmin'),('56ba2bcd927eb33','5601afbc23dfb00','54da24749d82eb7','2016-02-09 20:11:25','globeadmin','2016-02-09 20:11:25','globeadmin','2018-11-20 14:42:22','globeadmin'),('56ba2bcd99d1cf3','5601afbc23dfb00','54df2384b808c9b','2016-02-09 20:11:25','globeadmin','2016-02-09 20:11:25','globeadmin','2018-11-20 14:42:29','globeadmin'),('56ba2bcda124d2e','5601afbc23dfb00','54df23b8e8dd0cf','2016-02-09 20:11:25','globeadmin','2016-02-09 20:11:25','globeadmin','2018-11-20 14:42:29','globeadmin'),('56ba2bcda877b35','5601afbc23dfb00','54df242190f8a42','2016-02-09 20:11:25','globeadmin','2016-02-09 20:11:25','globeadmin','2018-11-20 14:42:30','globeadmin'),('56ba2bcdafcac49','5601afbc23dfb00','54df249e87338f1','2016-02-09 20:11:25','globeadmin','2016-02-09 20:11:25','globeadmin','2018-11-20 14:42:29','globeadmin'),('56ba2bcdb71e523','5601afbc23dfb00','54df24c6566897c','2016-02-09 20:11:25','globeadmin','2016-02-09 20:11:25','globeadmin','2018-11-20 14:42:29','globeadmin'),('56ba2bcdbe70dd4','5601afbc23dfb00','54df2503ce004f5','2016-02-09 20:11:25','globeadmin','2016-02-09 20:11:25','globeadmin','2018-11-20 14:42:30','globeadmin'),('56ba2bcdc5c3ceb','5601afbc23dfb00','54e61e02a705c6d','2016-02-09 20:11:25','globeadmin','2016-02-09 20:11:25','globeadmin','2018-11-20 14:42:27','globeadmin'),('56ba2bcdcd16cd7','5601afbc23dfb00','54eb5821b763976','2016-02-09 20:11:25','globeadmin','2016-02-09 20:11:25','globeadmin','2018-11-20 14:42:28','globeadmin'),('56ba2bcdd469c8f','5601afbc23dfb00','54f4afe911e357f','2016-02-09 20:11:25','globeadmin','2016-02-09 20:11:25','globeadmin','2018-11-20 14:42:29','globeadmin'),('56ba2bcddbbcc3c','5601afbc23dfb00','54f729629379af4','2016-02-09 20:11:25','globeadmin','2016-02-09 20:11:25','globeadmin','2018-11-20 14:42:18','globeadmin'),('56ba2bcde30fc37','5601afbc23dfb00','54f8ae257942c56','2016-02-09 20:11:25','globeadmin','2016-02-09 20:11:25','globeadmin','2018-11-20 14:42:21','globeadmin'),('56ba2bcdea6371e','5601afbc23dfb00','54fdfd017b6a60e','2016-02-09 20:11:25','globeadmin','2016-02-09 20:11:25','globeadmin','2018-11-20 14:42:25','globeadmin'),('56ba2bcdf1b5c14','5601afbc23dfb00','54ff33e86cd65f8','2016-02-09 20:11:25','globeadmin','2016-02-09 20:11:25','globeadmin','2018-11-20 14:42:16','globeadmin'),('56ba2bce04e4cd5','5601afbc23dfb00','55004dd5e43f2f2','2016-02-09 20:11:26','globeadmin','2016-02-09 20:11:26','globeadmin','2018-11-20 14:42:18','globeadmin'),('56ba2bce0c37bf0','5601afbc23dfb00','5507176562eedae','2016-02-09 20:11:26','globeadmin','2016-02-09 20:11:26','globeadmin','2018-11-20 14:42:27','globeadmin'),('56ba2bce138ae86','5601afbc23dfb00','550737d00a4a57b','2016-02-09 20:11:26','globeadmin','2016-02-09 20:11:26','globeadmin','2018-11-20 14:42:16','globeadmin'),('56ba2bce1ade0a1','5601afbc23dfb00','5507d4d7b50b99c','2016-02-09 20:11:26','globeadmin','2016-02-09 20:11:26','globeadmin','2018-11-20 14:42:25','globeadmin'),('56ba2bce2230c44','5601afbc23dfb00','550c7f9aba73fb6','2016-02-09 20:11:26','globeadmin','2016-02-09 20:11:26','globeadmin','2018-11-20 14:42:16','globeadmin'),('56ba2bce2983ce4','5601afbc23dfb00','550d4eea3e00a18','2016-02-09 20:11:26','globeadmin','2016-02-09 20:11:26','globeadmin','2018-11-20 14:42:27','globeadmin'),('56ba2bce30d6daf','5601afbc23dfb00','550d5651ba833e2','2016-02-09 20:11:26','globeadmin','2016-02-09 20:11:26','globeadmin','2018-11-20 14:42:16','globeadmin'),('56ba2bce3829cc9','5601afbc23dfb00','550db8c2a38fc30','2016-02-09 20:11:26','globeadmin','2016-02-09 20:11:26','globeadmin','2018-11-20 14:42:20','globeadmin'),('56ba2bce3f7cd0b','5601afbc23dfb00','550e7cdc443015a','2016-02-09 20:11:26','globeadmin','2016-02-09 20:11:26','globeadmin','2018-11-20 14:42:22','globeadmin'),('56ba2bce46cfc93','5601afbc23dfb00','55128eb9652ead5','2016-02-09 20:11:26','globeadmin','2016-02-09 20:11:26','globeadmin','2018-11-20 14:42:26','globeadmin'),('570a19c35932cf6','5501dbedc785fe4','570a196b80430d3','2016-04-10 12:15:47','globeadmin','2016-04-10 12:15:47','globeadmin','2018-01-09 18:51:25','globeadmin'),('56ba2bce5cc8cbd','5601afbc23dfb00','55183736b84eee4','2016-02-09 20:11:26','globeadmin','2016-02-09 20:11:26','globeadmin','2018-11-20 14:42:15','globeadmin'),('56ba2bce668eb7c','5601afbc23dfb00','551a39550972489','2016-02-09 20:11:26','globeadmin','2016-02-09 20:11:26','globeadmin','2018-11-20 14:42:25','globeadmin'),('56ba2bce6ddfcda','5601afbc23dfb00','552124aeebd01bf','2016-02-09 20:11:26','globeadmin','2016-02-09 20:11:26','globeadmin','2018-11-20 14:42:24','globeadmin'),('56ba2bce7532ae0','5601afbc23dfb00','552233092acee07','2016-02-09 20:11:26','globeadmin','2016-02-09 20:11:26','globeadmin','2018-11-20 14:42:22','globeadmin'),('56ba2bce7c85c12','5601afbc23dfb00','5522ba5ae053074','2016-02-09 20:11:26','globeadmin','2016-02-09 20:11:26','globeadmin','2018-11-20 14:42:22','globeadmin'),('56ba2bce83d8cd2','5601afbc23dfb00','55255886b0e2e42','2016-02-09 20:11:26','globeadmin','2016-02-09 20:11:26','globeadmin','2018-11-20 14:42:15','globeadmin'),('56ba2bce8b2bb55','5601afbc23dfb00','55262fb4d34fbc0','2016-02-09 20:11:26','globeadmin','2016-02-09 20:11:26','globeadmin','2018-11-20 14:42:21','globeadmin'),('56ba2bce927ecc6','5601afbc23dfb00','552ea7c73b78c04','2016-02-09 20:11:26','globeadmin','2016-02-09 20:11:26','globeadmin','2018-11-20 14:42:24','globeadmin'),('56ba2bce99d1cca','5601afbc23dfb00','5537d807e48c62b','2016-02-09 20:11:26','globeadmin','2016-02-09 20:11:26','globeadmin','2018-11-20 14:42:25','globeadmin'),('56ba2bcea124c2d','5601afbc23dfb00','5539081d564cca6','2016-02-09 20:11:26','globeadmin','2016-02-09 20:11:26','globeadmin','2018-11-20 14:42:24','globeadmin'),('56ba2bcea877a63','5601afbc23dfb00','553fe1e308e7e3a','2016-02-09 20:11:26','globeadmin','2016-02-09 20:11:26','globeadmin','2018-11-20 14:42:26','globeadmin'),('56ba2bceafcac20','5601afbc23dfb00','5541240a041c4ee','2016-02-09 20:11:26','globeadmin','2016-02-09 20:11:26','globeadmin','2018-11-20 14:42:16','globeadmin'),('56ba2bceb71dc8b','5601afbc23dfb00','554797f3cce46e4','2016-02-09 20:11:26','globeadmin','2016-02-09 20:11:26','globeadmin','2018-11-20 14:42:28','globeadmin'),('56ba2bcebe70eb1','5601afbc23dfb00','5547a512d1c5bd2','2016-02-09 20:11:26','globeadmin','2016-02-09 20:11:26','globeadmin','2018-11-20 14:42:28','globeadmin'),('56ba2bcec5c3c5b','5601afbc23dfb00','55490413c23b81c','2016-02-09 20:11:26','globeadmin','2016-02-09 20:11:26','globeadmin','2018-11-20 14:42:30','globeadmin'),('56ba2bcecd16b4b','5601afbc23dfb00','555d8a344f6f95a','2016-02-09 20:11:26','globeadmin','2016-02-09 20:11:26','globeadmin','2018-11-20 14:42:18','globeadmin'),('56ba2bced469c18','5601afbc23dfb00','5569e34f68bcbbb','2016-02-09 20:11:26','globeadmin','2016-02-09 20:11:26','globeadmin','2018-11-20 14:42:24','globeadmin'),('56ba2bcedbbcb00','5601afbc23dfb00','55fd4a4b286857e','2016-02-09 20:11:26','globeadmin','2016-02-09 20:11:26','globeadmin','2018-11-20 14:42:17','globeadmin'),('56ba2bcee30fcfe','5601afbc23dfb00','561191a369a4a78','2016-02-09 20:11:26','globeadmin','2016-02-09 20:11:26','globeadmin','2018-11-20 14:42:21','globeadmin'),('56ba2bceea630ed','5601afbc23dfb00','561542b85b07cd4','2016-02-09 20:11:26','globeadmin','2016-02-09 20:11:26','globeadmin','2018-11-20 14:42:17','globeadmin'),('56ba2bcef1b5c90','5601afbc23dfb00','561c0a55ec1ed91','2016-02-09 20:11:26','globeadmin','2016-02-09 20:11:26','globeadmin','2018-11-20 14:42:24','globeadmin'),('56ba2bcf04e4cff','5601afbc23dfb00','561d62acbdd0ab8','2016-02-09 20:11:27','globeadmin','2016-02-09 20:11:27','globeadmin','2018-11-20 14:42:26','globeadmin'),('56ba2bcf0c37b60','5601afbc23dfb00','56200a1fadf03a4','2016-02-09 20:11:27','globeadmin','2016-02-09 20:11:27','globeadmin','2018-11-20 14:42:18','globeadmin'),('56ba2bcf138ac88','5601afbc23dfb00','562e7c9f1816a51','2016-02-09 20:11:27','globeadmin','2016-02-09 20:11:27','globeadmin','2018-11-20 14:42:23','globeadmin'),('56ba2bcf1addbfe','5601afbc23dfb00','562e80fdcf335fe','2016-02-09 20:11:27','globeadmin','2016-02-09 20:11:27','globeadmin','2018-11-20 14:42:27','globeadmin'),('56ba2bcf2230ec3','5601afbc23dfb00','563134ef69e16fd','2016-02-09 20:11:27','globeadmin','2016-02-09 20:11:27','globeadmin','2018-11-20 14:42:23','globeadmin'),('56ba2bcf2983c58','5601afbc23dfb00','563137091e32c73','2016-02-09 20:11:27','globeadmin','2016-02-09 20:11:27','globeadmin','2018-11-20 14:42:23','globeadmin'),('56ba2bcf30d6ca1','5601afbc23dfb00','5635f36fa9f36bf','2016-02-09 20:11:27','globeadmin','2016-02-09 20:11:27','globeadmin','2016-02-09 20:35:34','globeadmin'),('56ba2bcf3829e44','5601afbc23dfb00','563634de56f2b28','2016-02-09 20:11:27','globeadmin','2016-02-09 20:11:27','globeadmin','2018-11-20 14:42:23','globeadmin'),('56ba2bcf3f7cbf0','5601afbc23dfb00','5636594106c1894','2016-02-09 20:11:27','globeadmin','2016-02-09 20:11:27','globeadmin','2018-11-20 14:42:23','globeadmin'),('56ba2bcf46cfb7e','5601afbc23dfb00','56521e303a1e26c','2016-02-09 20:11:27','globeadmin','2016-02-09 20:11:27','globeadmin','2018-11-20 14:42:29','globeadmin'),('56ba2bcf4e22b1e','5601afbc23dfb00','56588495311fece','2016-02-09 20:11:27','globeadmin','2016-02-09 20:11:27','globeadmin','2018-11-20 14:42:17','globeadmin'),('56ba2bcf5575cec','5601afbc23dfb00','565ac873e409ddc','2016-02-09 20:11:27','globeadmin','2016-02-09 20:11:27','globeadmin','2018-11-20 14:42:24','globeadmin'),('56ba2bcf5cc8b42','5601afbc23dfb00','56608bc656a4d24','2016-02-09 20:11:27','globeadmin','2016-02-09 20:11:27','globeadmin','2018-11-20 14:42:29','globeadmin'),('56ba2bcf641bcd7','5601afbc23dfb00','56a11975eff1dd2','2016-02-09 20:11:27','globeadmin','2016-02-09 20:11:27','globeadmin','2018-11-20 14:42:28','globeadmin'),('570a19bd4a8e037','547de3e001028e8','570a196b80430d3','2016-04-10 12:15:41','globeadmin','2016-04-10 12:15:41','globeadmin','2019-11-06 15:15:19','globeadmin'),('56ba2bd49c42c67','5689468794353da','52c0da99b95c264','2016-02-09 20:11:32','globeadmin','2016-02-09 20:11:32','globeadmin','2016-02-09 20:38:05','globeadmin'),('56ba2bd4a395bec','5689468794353da','530a8f8e78111c4','2016-02-09 20:11:32','globeadmin','2016-02-09 20:11:32','globeadmin','2016-02-09 20:38:05','globeadmin'),('56ba2bd4aae9436','5689468794353da','5477806364bbd3b','2016-02-09 20:11:32','globeadmin','2016-02-09 20:11:32','globeadmin','2016-02-09 20:38:05','globeadmin'),('56ba2bd4b23bb27','5689468794353da','547cc4b073c1854','2016-02-09 20:11:32','globeadmin','2016-02-09 20:11:32','globeadmin','2016-02-09 20:38:05','globeadmin'),('56ba2bd4b98ee9f','5689468794353da','547cce2020be0b5','2016-02-09 20:11:32','globeadmin','2016-02-09 20:11:32','globeadmin','2016-02-09 20:38:05','globeadmin'),('56ba2bd4c0e1c49','5689468794353da','5487369544262a7','2016-02-09 20:11:32','globeadmin','2016-02-09 20:11:32','globeadmin','2016-02-09 20:38:06','globeadmin'),('56ba2bd4c834ce6','5689468794353da','548897f34ce2b64','2016-02-09 20:11:32','globeadmin','2016-02-09 20:11:32','globeadmin','2016-02-09 20:38:06','globeadmin'),('56ba2bd4cf87cca','5689468794353da','54889d24766371b','2016-02-09 20:11:32','globeadmin','2016-02-09 20:11:32','globeadmin','2016-02-09 20:38:06','globeadmin'),('56ba2bd4d6dac2f','5689468794353da','548b2b8d4b3f282','2016-02-09 20:11:32','globeadmin','2016-02-09 20:11:32','globeadmin','2016-02-09 20:38:06','globeadmin'),('56ba2bd4de2deb0','5689468794353da','5494859e9bfaf58','2016-02-09 20:11:32','globeadmin','2016-02-09 20:11:32','globeadmin','2016-02-09 20:38:06','globeadmin'),('56ba2bd4e580c7a','5689468794353da','5495d3357b0fb7c','2016-02-09 20:11:32','globeadmin','2016-02-09 20:11:32','globeadmin','2016-02-09 20:38:06','globeadmin'),('56ba2bd4ecd3cf8','5689468794353da','5498454b86171f6','2016-02-09 20:11:32','globeadmin','2016-02-09 20:11:32','globeadmin','2016-02-09 20:38:06','globeadmin'),('56ba2bd50002c6c','5689468794353da','549ef456718c2ed','2016-02-09 20:11:33','globeadmin','2016-02-09 20:11:33','globeadmin','2016-02-09 20:38:06','globeadmin'),('56ba2bd50755c6e','5689468794353da','54a06aabf3085fe','2016-02-09 20:11:33','globeadmin','2016-02-09 20:11:33','globeadmin','2016-02-09 20:38:06','globeadmin'),('56ba2bd50ea8b5e','5689468794353da','54a11e8a5b34dee','2016-02-09 20:11:33','globeadmin','2016-02-09 20:11:33','globeadmin','2016-02-09 20:38:06','globeadmin'),('56ba2bd515fbc98','5689468794353da','54a2700ab351809','2016-02-09 20:11:33','globeadmin','2016-02-09 20:11:33','globeadmin','2016-02-09 20:38:06','globeadmin'),('56ba2bd51d4ed1f','5689468794353da','54a2baf998a4dbd','2016-02-09 20:11:33','globeadmin','2016-02-09 20:11:33','globeadmin','2016-02-09 20:38:06','globeadmin'),('56ba2bd524a1f0f','5689468794353da','54a30da411a6ba7','2016-02-09 20:11:33','globeadmin','2016-02-09 20:11:33','globeadmin','2016-02-09 20:38:06','globeadmin'),('56ba2bd52bf4cb0','5689468794353da','54a3e7ba6b7fc63','2016-02-09 20:11:33','globeadmin','2016-02-09 20:11:33','globeadmin','2016-02-09 20:38:06','globeadmin'),('56ba2bd53347dc4','5689468794353da','54a57904c1b4546','2016-02-09 20:11:33','globeadmin','2016-02-09 20:11:33','globeadmin','2016-02-09 20:38:06','globeadmin'),('56ba2bd53a9ab3b','5689468794353da','54a921725907fab','2016-02-09 20:11:33','globeadmin','2016-02-09 20:11:33','globeadmin','2016-02-09 20:38:06','globeadmin'),('56ba2bd541eddad','5689468794353da','54a9704fd26ded5','2016-02-09 20:11:33','globeadmin','2016-02-09 20:11:33','globeadmin','2016-02-09 20:38:07','globeadmin'),('56ba2bd54940da6','5689468794353da','54aa72ec60858cc','2016-02-09 20:11:33','globeadmin','2016-02-09 20:11:33','globeadmin','2016-02-09 20:38:07','globeadmin'),('56ba2bd55094095','5689468794353da','54b1245d2bacdb6','2016-02-09 20:11:33','globeadmin','2016-02-09 20:11:33','globeadmin','2016-02-09 20:38:07','globeadmin'),('56ba2bd557e6bf6','5689468794353da','54b3853f5280e06','2016-02-09 20:11:33','globeadmin','2016-02-09 20:11:33','globeadmin','2016-02-09 20:38:07','globeadmin'),('56ba2bd55f39c77','5689468794353da','54d1374c9e8d38a','2016-02-09 20:11:33','globeadmin','2016-02-09 20:11:33','globeadmin','2016-02-09 20:38:07','globeadmin'),('56ba2bd5668d0c0','5689468794353da','54d65d126230684','2016-02-09 20:11:33','globeadmin','2016-02-09 20:11:33','globeadmin','2016-02-09 20:38:07','globeadmin'),('56ba2bd56ddff78','5689468794353da','54d6660b538bea2','2016-02-09 20:11:33','globeadmin','2016-02-09 20:11:33','globeadmin','2016-02-09 20:38:07','globeadmin'),('56ba2bd57532cd3','5689468794353da','54da24749d82eb7','2016-02-09 20:11:33','globeadmin','2016-02-09 20:11:33','globeadmin','2016-02-09 20:38:07','globeadmin'),('56ba2bd57c85f71','5689468794353da','54df2384b808c9b','2016-02-09 20:11:33','globeadmin','2016-02-09 20:11:33','globeadmin','2016-02-09 20:38:07','globeadmin'),('56ba2bd583d8ac1','5689468794353da','54df23b8e8dd0cf','2016-02-09 20:11:33','globeadmin','2016-02-09 20:11:33','globeadmin','2016-02-09 20:38:07','globeadmin'),('56ba2bd58b2bc20','5689468794353da','54df242190f8a42','2016-02-09 20:11:33','globeadmin','2016-02-09 20:11:33','globeadmin','2016-02-09 20:38:07','globeadmin'),('56ba2bd5927ecee','5689468794353da','54df249e87338f1','2016-02-09 20:11:33','globeadmin','2016-02-09 20:11:33','globeadmin','2016-02-09 20:38:07','globeadmin'),('56ba2bd599d1c58','5689468794353da','54df24c6566897c','2016-02-09 20:11:33','globeadmin','2016-02-09 20:11:33','globeadmin','2016-02-09 20:38:07','globeadmin'),('56ba2bd5a124b16','5689468794353da','54df2503ce004f5','2016-02-09 20:11:33','globeadmin','2016-02-09 20:11:33','globeadmin','2016-02-09 20:38:07','globeadmin'),('56ba2bd5a877ce0','5689468794353da','54e61e02a705c6d','2016-02-09 20:11:33','globeadmin','2016-02-09 20:11:33','globeadmin','2016-02-09 20:38:07','globeadmin'),('56ba2bd5afcacfc','5689468794353da','54eb5821b763976','2016-02-09 20:11:33','globeadmin','2016-02-09 20:11:33','globeadmin','2016-02-09 20:38:07','globeadmin'),('56ba2bd5b71da1c','5689468794353da','54f4afe911e357f','2016-02-09 20:11:33','globeadmin','2016-02-09 20:11:33','globeadmin','2016-02-09 20:38:08','globeadmin'),('56ba2bd5be70b32','5689468794353da','54f729629379af4','2016-02-09 20:11:33','globeadmin','2016-02-09 20:11:33','globeadmin','2016-02-09 20:38:08','globeadmin'),('56ba2bd5c5c3cb0','5689468794353da','54f8ae257942c56','2016-02-09 20:11:33','globeadmin','2016-02-09 20:11:33','globeadmin','2016-02-09 20:38:08','globeadmin'),('56ba2bd5cd16ce5','5689468794353da','54fdfd017b6a60e','2016-02-09 20:11:33','globeadmin','2016-02-09 20:11:33','globeadmin','2016-02-09 20:38:08','globeadmin'),('56ba2bd5d469ec4','5689468794353da','54ff33e86cd65f8','2016-02-09 20:11:33','globeadmin','2016-02-09 20:11:33','globeadmin','2016-02-09 20:38:08','globeadmin'),('56ba2bd5dbbccab','5689468794353da','55004dd5e43f2f2','2016-02-09 20:11:33','globeadmin','2016-02-09 20:11:33','globeadmin','2016-02-09 20:38:08','globeadmin'),('56ba2bd5e30fb71','5689468794353da','5507176562eedae','2016-02-09 20:11:33','globeadmin','2016-02-09 20:11:33','globeadmin','2016-02-09 20:38:08','globeadmin'),('56ba2bd5ea62cda','5689468794353da','550737d00a4a57b','2016-02-09 20:11:33','globeadmin','2016-02-09 20:11:33','globeadmin','2016-02-09 20:38:08','globeadmin'),('56ba2bd5f1b5c35','5689468794353da','5507d4d7b50b99c','2016-02-09 20:11:33','globeadmin','2016-02-09 20:11:33','globeadmin','2016-02-09 20:38:08','globeadmin'),('56ba2bd604e4cf7','5689468794353da','550c7f9aba73fb6','2016-02-09 20:11:34','globeadmin','2016-02-09 20:11:34','globeadmin','2016-02-09 20:38:08','globeadmin'),('56ba2bd60c37cfb','5689468794353da','550d4eea3e00a18','2016-02-09 20:11:34','globeadmin','2016-02-09 20:11:34','globeadmin','2016-02-09 20:38:08','globeadmin'),('56ba2bd6138acdf','5689468794353da','550d5651ba833e2','2016-02-09 20:11:34','globeadmin','2016-02-09 20:11:34','globeadmin','2016-02-09 20:38:08','globeadmin'),('56ba2bd61addfab','5689468794353da','550db8c2a38fc30','2016-02-09 20:11:34','globeadmin','2016-02-09 20:11:34','globeadmin','2016-02-09 20:38:08','globeadmin'),('570a19b98c77c7e','547de3bee410196','570a196b80430d3','2016-04-10 12:15:37','globeadmin','2016-04-10 12:15:37','globeadmin','2022-01-31 16:18:46','globeadmin'),('56ba2bd62983a13','5689468794353da','55128eb9652ead5','2016-02-09 20:11:34','globeadmin','2016-02-09 20:11:34','globeadmin','2016-02-09 20:38:08','globeadmin'),('56eae9c81f0b386','5689468794353da','56eae990f0fff5f','2016-03-17 19:30:48','globeadmin','2016-03-17 19:30:48','globeadmin','2016-03-17 19:30:48','globeadmin'),('56ba2bd63f7cc11','5689468794353da','55183736b84eee4','2016-02-09 20:11:34','globeadmin','2016-02-09 20:11:34','globeadmin','2016-02-09 20:38:08','globeadmin'),('56ba2bd646cfcbc','5689468794353da','551a39550972489','2016-02-09 20:11:34','globeadmin','2016-02-09 20:11:34','globeadmin','2016-02-09 20:38:08','globeadmin'),('56ba2bd64e22c89','5689468794353da','552124aeebd01bf','2016-02-09 20:11:34','globeadmin','2016-02-09 20:11:34','globeadmin','2016-02-09 20:38:09','globeadmin'),('56ba2bd65575c1f','5689468794353da','552233092acee07','2016-02-09 20:11:34','globeadmin','2016-02-09 20:11:34','globeadmin','2016-02-09 20:38:09','globeadmin'),('56ba2bd65cc8f11','5689468794353da','5522ba5ae053074','2016-02-09 20:11:34','globeadmin','2016-02-09 20:11:34','globeadmin','2016-02-09 20:38:09','globeadmin'),('56ba2bd6641bcf3','5689468794353da','55255886b0e2e42','2016-02-09 20:11:34','globeadmin','2016-02-09 20:11:34','globeadmin','2016-02-09 20:38:09','globeadmin'),('56ba2bd66b6ec67','5689468794353da','55262fb4d34fbc0','2016-02-09 20:11:34','globeadmin','2016-02-09 20:11:34','globeadmin','2016-02-09 20:38:09','globeadmin'),('56ba2bd672c1c6e','5689468794353da','552ea7c73b78c04','2016-02-09 20:11:34','globeadmin','2016-02-09 20:11:34','globeadmin','2016-02-09 20:38:09','globeadmin'),('56ba2bd67a14da0','5689468794353da','5537d807e48c62b','2016-02-09 20:11:34','globeadmin','2016-02-09 20:11:34','globeadmin','2016-02-09 20:38:09','globeadmin'),('56ba2bd68167b08','5689468794353da','5539081d564cca6','2016-02-09 20:11:34','globeadmin','2016-02-09 20:11:34','globeadmin','2016-02-09 20:38:09','globeadmin'),('56ba2bd688bac44','5689468794353da','553fe1e308e7e3a','2016-02-09 20:11:34','globeadmin','2016-02-09 20:11:34','globeadmin','2016-02-09 20:38:09','globeadmin'),('56ba2bd6900e041','5689468794353da','5541240a041c4ee','2016-02-09 20:11:34','globeadmin','2016-02-09 20:11:34','globeadmin','2016-02-09 20:38:09','globeadmin'),('56ba2bd69760cbb','5689468794353da','554797f3cce46e4','2016-02-09 20:11:34','globeadmin','2016-02-09 20:11:34','globeadmin','2016-02-09 20:38:09','globeadmin'),('56ba2bd69eb3b13','5689468794353da','5547a512d1c5bd2','2016-02-09 20:11:34','globeadmin','2016-02-09 20:11:34','globeadmin','2016-02-09 20:38:09','globeadmin'),('56ba2bd6a606cb3','5689468794353da','55490413c23b81c','2016-02-09 20:11:34','globeadmin','2016-02-09 20:11:34','globeadmin','2016-02-09 20:38:09','globeadmin'),('56ba2bd6ad59bd1','5689468794353da','555d8a344f6f95a','2016-02-09 20:11:34','globeadmin','2016-02-09 20:11:34','globeadmin','2016-02-09 20:38:09','globeadmin'),('56ba2bd6b4accaa','5689468794353da','5569e34f68bcbbb','2016-02-09 20:11:34','globeadmin','2016-02-09 20:11:34','globeadmin','2016-02-09 20:38:09','globeadmin'),('56eae9c4943b19a','5601afbc23dfb00','56eae990f0fff5f','2016-03-17 19:30:44','globeadmin','2016-03-17 19:30:44','globeadmin','2018-11-20 14:42:18','globeadmin'),('56ba2bd6c352bd2','5689468794353da','561191a369a4a78','2016-02-09 20:11:34','globeadmin','2016-02-09 20:11:34','globeadmin','2016-02-09 20:38:09','globeadmin'),('56ba2bd6caa5ba5','5689468794353da','561542b85b07cd4','2016-02-09 20:11:34','globeadmin','2016-02-09 20:11:34','globeadmin','2016-02-09 20:38:10','globeadmin'),('56ba2bd6d1f9000','5689468794353da','561c0a55ec1ed91','2016-02-09 20:11:34','globeadmin','2016-02-09 20:11:34','globeadmin','2016-02-09 20:38:10','globeadmin'),('56ba2bd6d94bcf8','5689468794353da','561d62acbdd0ab8','2016-02-09 20:11:34','globeadmin','2016-02-09 20:11:34','globeadmin','2016-02-09 20:38:10','globeadmin'),('56ba2bd6e09edc1','5689468794353da','562e7c9f1816a51','2016-02-09 20:11:34','globeadmin','2016-02-09 20:11:34','globeadmin','2016-02-09 20:38:10','globeadmin'),('56ba2bd6e7fd609','5689468794353da','562e80fdcf335fe','2016-02-09 20:11:34','globeadmin','2016-02-09 20:11:34','globeadmin','2016-02-09 20:38:10','globeadmin'),('56ba2bd6ef44b27','5689468794353da','563134ef69e16fd','2016-02-09 20:11:34','globeadmin','2016-02-09 20:11:34','globeadmin','2016-02-09 20:38:10','globeadmin'),('56ba2bd70273e5a','5689468794353da','563137091e32c73','2016-02-09 20:11:35','globeadmin','2016-02-09 20:11:35','globeadmin','2016-02-09 20:38:10','globeadmin'),('56ba2bd709c6cc4','5689468794353da','5635f36fa9f36bf','2016-02-09 20:11:35','globeadmin','2016-02-09 20:11:35','globeadmin','2016-02-09 20:38:10','globeadmin'),('56ba2bd71119cf9','5689468794353da','563634de56f2b28','2016-02-09 20:11:35','globeadmin','2016-02-09 20:11:35','globeadmin','2016-02-09 20:38:10','globeadmin'),('56ba2bd7186cc5e','5689468794353da','5636594106c1894','2016-02-09 20:11:35','globeadmin','2016-02-09 20:11:35','globeadmin','2016-02-09 20:38:10','globeadmin'),('56ba2bd71fbfcc5','5689468794353da','56521e303a1e26c','2016-02-09 20:11:35','globeadmin','2016-02-09 20:11:35','globeadmin','2016-02-09 20:38:10','globeadmin'),('56ba2bd72712bd8','5689468794353da','56588495311fece','2016-02-09 20:11:35','globeadmin','2016-02-09 20:11:35','globeadmin','2016-02-09 20:38:10','globeadmin'),('56ba2bd72e65cf1','5689468794353da','565ac873e409ddc','2016-02-09 20:11:35','globeadmin','2016-02-09 20:11:35','globeadmin','2016-02-09 20:38:10','globeadmin'),('56ba2bd735b8d15','5689468794353da','56608bc656a4d24','2016-02-09 20:11:35','globeadmin','2016-02-09 20:11:35','globeadmin','2016-02-09 20:38:10','globeadmin'),('56ba2bd73d0bc5e','5689468794353da','56a11975eff1dd2','2016-02-09 20:11:35','globeadmin','2016-02-09 20:11:35','globeadmin','2016-02-09 20:38:10','globeadmin'),('56eae9b5ec1db8c','547de3bee410196','56eae990f0fff5f','2016-03-17 19:30:29','globeadmin','2016-03-17 19:30:29','globeadmin','2022-01-31 16:18:43','globeadmin'),('56eae9be720d39d','547de3e001028e8','56eae990f0fff5f','2016-03-17 19:30:38','globeadmin','2016-03-17 19:30:38','globeadmin','2019-11-06 15:15:13','globeadmin'),('56eae9c18322a51','5501dbedc785fe4','56eae990f0fff5f','2016-03-17 19:30:41','globeadmin','2016-03-17 19:30:41','globeadmin','2018-01-09 18:51:17','globeadmin'),('56ba2bdab23bc1c','547de3fe0d36089','5477806364bbd3b','2016-02-09 20:11:38','globeadmin','2016-02-09 20:11:38','globeadmin','2019-07-01 11:07:10','globeadmin'),('56ba2bdab98efd3','547de3fe0d36089','547cc4b073c1854','2016-02-09 20:11:38','globeadmin','2016-02-09 20:11:38','globeadmin','2017-10-15 19:01:25','globeadmin'),('56ba2bdac0e1ce4','547de3fe0d36089','547cce2020be0b5','2016-02-09 20:11:38','globeadmin','2016-02-09 20:11:38','globeadmin','2019-07-01 11:07:10','globeadmin'),('56ba2bdac834dc5','547de3fe0d36089','5487369544262a7','2016-02-09 20:11:38','globeadmin','2016-02-09 20:11:38','globeadmin','2019-07-01 11:07:03','globeadmin'),('56ba2bdacf87ccd','547de3fe0d36089','548897f34ce2b64','2016-02-09 20:11:38','globeadmin','2016-02-09 20:11:38','globeadmin','2019-07-01 11:07:04','globeadmin'),('56ba2bdad6dac18','547de3fe0d36089','54889d24766371b','2016-02-09 20:11:38','globeadmin','2016-02-09 20:11:38','globeadmin','2019-07-01 11:07:07','globeadmin'),('56ba2bdade2e6df','547de3fe0d36089','548b2b8d4b3f282','2016-02-09 20:11:38','globeadmin','2016-02-09 20:11:38','globeadmin','2019-07-01 11:07:04','globeadmin'),('5717b9c86ed2de2','5717b9c74a31169','565ac873e409ddc','2016-04-20 20:18:01','globeadmin','2016-04-20 20:18:01','globeadmin','2017-10-15 19:02:13','globeadmin'),('5717b9c858d8c70','5717b9c74a31169','561c0a55ec1ed91','2016-04-20 20:18:01','globeadmin','2016-04-20 20:18:01','globeadmin','2017-10-15 19:02:13','globeadmin'),('5717b9c8650c397','5717b9c74a31169','5498454b86171f6','2016-04-20 20:18:01','globeadmin','2016-04-20 20:18:01','globeadmin','2017-10-15 19:02:13','globeadmin'),('56ba2bdb0002d8d','547de3fe0d36089','5498454b86171f6','2016-02-09 20:11:39','globeadmin','2016-02-09 20:11:39','globeadmin','2019-07-01 11:07:05','globeadmin'),('56ba2bdb0755ccb','547de3fe0d36089','549ef456718c2ed','2016-02-09 20:11:39','globeadmin','2016-02-09 20:11:39','globeadmin','2019-07-01 11:07:06','globeadmin'),('56ba2bdb0ea8ea0','547de3fe0d36089','54a06aabf3085fe','2016-02-09 20:11:39','globeadmin','2016-02-09 20:11:39','globeadmin','2019-07-01 11:07:05','globeadmin'),('5717b9c81bcf724','5717b9c74a31169','54a06aabf3085fe','2016-04-20 20:18:01','globeadmin','2016-04-20 20:18:01','globeadmin','2017-10-15 19:02:12','globeadmin'),('5717b9c8259382c','5717b9c74a31169','562e7c9f1816a51','2016-04-20 20:18:01','globeadmin','2016-04-20 20:18:01','globeadmin','2017-10-15 19:02:12','globeadmin'),('56ba2bdb1d4ec46','547de3fe0d36089','54a2700ab351809','2016-02-09 20:11:39','globeadmin','2016-02-09 20:11:39','globeadmin','2019-07-01 11:07:04','globeadmin'),('5717b9c8120a3e5','5717b9c74a31169','563137091e32c73','2016-04-20 20:18:01','globeadmin','2016-04-20 20:18:01','globeadmin','2017-10-15 19:02:12','globeadmin'),('5717b9c7f03688a','5717b9c74a31169','54a57904c1b4546','2016-04-20 20:18:01','globeadmin','2016-04-20 20:18:01','globeadmin','2017-10-15 19:02:12','globeadmin'),('5717b9c805d6a2e','5717b9c74a31169','563134ef69e16fd','2016-04-20 20:18:01','globeadmin','2016-04-20 20:18:01','globeadmin','2017-10-15 19:02:12','globeadmin'),('5717b9c7e67284a','5717b9c74a31169','54a2700ab351809','2016-04-20 20:18:01','globeadmin','2016-04-20 20:18:01','globeadmin','2017-10-15 19:02:12','globeadmin'),('56ba2bdb3a9aacf','547de3fe0d36089','54a57904c1b4546','2016-02-09 20:11:39','globeadmin','2016-02-09 20:11:39','globeadmin','2019-07-01 11:07:04','globeadmin'),('56ba2bdb41edcca','547de3fe0d36089','54a921725907fab','2016-02-09 20:11:39','globeadmin','2016-02-09 20:11:39','globeadmin','2019-07-01 11:07:09','globeadmin'),('5717b9c7d2ea8f5','5717b9c74a31169','548b2b8d4b3f282','2016-04-20 20:18:01','globeadmin','2016-04-20 20:18:01','globeadmin','2017-10-15 19:02:12','globeadmin'),('5717b9c7dcae894','5717b9c74a31169','54da24749d82eb7','2016-04-20 20:18:01','globeadmin','2016-04-20 20:18:01','globeadmin','2017-10-15 19:02:12','globeadmin'),('56ba2bdb5093cad','547de3fe0d36089','54aa72ec60858cc','2016-02-09 20:11:39','globeadmin','2016-02-09 20:11:39','globeadmin','2019-07-01 11:07:03','globeadmin'),('56ba2bdb57e6c11','547de3fe0d36089','54b1245d2bacdb6','2016-02-09 20:11:39','globeadmin','2016-02-09 20:11:39','globeadmin','2016-06-09 12:16:21','globeadmin'),('5717b9c7c925381','5717b9c74a31169','548897f34ce2b64','2016-04-20 20:18:01','globeadmin','2016-04-20 20:18:01','globeadmin','2017-10-15 19:02:11','globeadmin'),('5717b9c7b32d865','5717b9c74a31169','55262fb4d34fbc0','2016-04-20 20:18:01','globeadmin','2016-04-20 20:18:01','globeadmin','2017-10-15 19:02:11','globeadmin'),('5717b9c7bcf198d','5717b9c74a31169','561191a369a4a78','2016-04-20 20:18:01','globeadmin','2016-04-20 20:18:01','globeadmin','2017-10-15 19:02:11','globeadmin'),('5717b9c7a96971e','5717b9c74a31169','562378beaaf323a','2016-04-20 20:18:01','globeadmin','2016-04-20 20:18:01','globeadmin','2017-10-15 19:02:11','globeadmin'),('56ba2bdb75330bc','547de3fe0d36089','54d6660b538bea2','2016-02-09 20:11:39','globeadmin','2016-02-09 20:11:39','globeadmin','2019-07-01 11:07:05','globeadmin'),('56ba2bdb7c85fdc','547de3fe0d36089','54da24749d82eb7','2016-02-09 20:11:39','globeadmin','2016-02-09 20:11:39','globeadmin','2019-07-01 11:07:04','globeadmin'),('5717b9c79370b08','5717b9c74a31169','54f729629379af4','2016-04-20 20:18:01','globeadmin','2016-04-20 20:18:01','globeadmin','2017-10-15 19:02:11','globeadmin'),('5717b9c79fa44e4','5717b9c74a31169','555d8a344f6f95a','2016-04-20 20:18:01','globeadmin','2016-04-20 20:18:01','globeadmin','2017-10-15 19:02:11','globeadmin'),('5717b9c789ab353','5717b9c74a31169','54aa72ec60858cc','2016-04-20 20:18:01','globeadmin','2016-04-20 20:18:01','globeadmin','2017-10-15 19:02:11','globeadmin'),('5717b9c773b2362','5717b9c74a31169','5541240a041c4ee','2016-04-20 20:18:01','globeadmin','2016-04-20 20:18:01','globeadmin','2017-10-15 19:02:11','globeadmin'),('5717b9c77d776da','5717b9c74a31169','56588495311fece','2016-04-20 20:18:01','globeadmin','2016-04-20 20:18:01','globeadmin','2017-10-15 19:02:11','globeadmin'),('5717b9c7677e7ec','5717b9c74a31169','5487369544262a7','2016-04-20 20:18:01','globeadmin','2016-04-20 20:18:01','globeadmin','2017-10-15 19:02:11','globeadmin'),('5717b9c753f6e03','5717b9c74a31169','55255886b0e2e42','2016-04-20 20:18:01','globeadmin','2016-04-20 20:18:01','globeadmin','2017-10-15 19:02:10','globeadmin'),('5717b9c75dba704','5717b9c74a31169','55183736b84eee4','2016-04-20 20:18:01','globeadmin','2016-04-20 20:18:01','globeadmin','2017-10-15 19:02:10','globeadmin'),('57137cf236fc3d1','5689468794353da','5712874ac076347','2016-04-17 15:09:22','globeadmin','2016-04-17 15:09:22','globeadmin','2016-04-17 15:09:22','globeadmin'),('57137ceaeba640e','5601afbc23dfb00','5712874ac076347','2016-04-17 15:09:14','globeadmin','2016-04-17 15:09:14','globeadmin','2018-11-20 14:42:28','globeadmin'),('57137cda89fe470','5501dbedc785fe4','5712874ac076347','2016-04-17 15:08:58','globeadmin','2016-04-17 15:08:58','globeadmin','2018-01-09 18:51:26','globeadmin'),('56ba2bdbc5c3c46','547de3fe0d36089','54f729629379af4','2016-02-09 20:11:39','globeadmin','2016-02-09 20:11:39','globeadmin','2019-07-01 11:07:04','globeadmin'),('57137cd29ff76ec','547de3e001028e8','5712874ac076347','2016-04-17 15:08:50','globeadmin','2016-04-17 15:08:50','globeadmin','2019-11-06 15:15:20','globeadmin'),('57137cca5b9b396','547de3bee410196','5712874ac076347','2016-04-17 15:08:42','globeadmin','2016-04-17 15:08:42','globeadmin','2022-01-31 16:18:47','globeadmin'),('5712368483d1b52','5689468794353da','571147d19d7d69a','2016-04-16 15:56:36','globeadmin','2016-04-16 15:56:36','globeadmin','2016-04-16 15:56:36','globeadmin'),('56ba2bdbea62fde','547de3fe0d36089','5507176562eedae','2016-02-09 20:11:39','globeadmin','2016-02-09 20:11:39','globeadmin','2019-07-01 11:07:09','globeadmin'),('5712368072bb0e6','5601afbc23dfb00','571147d19d7d69a','2016-04-16 15:56:32','globeadmin','2016-04-16 15:56:32','globeadmin','2018-11-20 14:42:28','globeadmin'),('5712367c779cee2','5501dbedc785fe4','571147d19d7d69a','2016-04-16 15:56:28','globeadmin','2016-04-16 15:56:28','globeadmin','2018-01-09 18:51:26','globeadmin'),('571fb7662ff8e49','547de3bee410196','571faf73f0d67fa','2016-04-26 21:45:58','globeadmin','2016-04-26 21:45:58','globeadmin','2022-01-31 16:18:44','globeadmin'),('56ba2bdc138ac23','547de3fe0d36089','550d4eea3e00a18','2016-02-09 20:11:40','globeadmin','2016-02-09 20:11:40','globeadmin','2019-07-01 11:07:08','globeadmin'),('57123676b4a64ba','547de3e001028e8','571147d19d7d69a','2016-04-16 15:56:22','globeadmin','2016-04-16 15:56:22','globeadmin','2019-11-06 15:15:20','globeadmin'),('5712367052fdb82','547de3bee410196','571147d19d7d69a','2016-04-16 15:56:16','globeadmin','2016-04-16 15:56:16','globeadmin','2022-01-31 16:18:47','globeadmin'),('571fb76ea2b84b6','5601afbc23dfb00','571faf73f0d67fa','2016-04-26 21:46:06','globeadmin','2016-04-26 21:46:06','globeadmin','2018-11-20 14:42:19','globeadmin'),('56ba2bdc30d6cae','547de3fe0d36089','55128eb9652ead5','2016-02-09 20:11:40','globeadmin','2016-02-09 20:11:40','globeadmin','2019-07-01 11:07:06','globeadmin'),('570dfd88e455927','5689468794353da','570d43d53aebdc2','2016-04-13 11:04:24','globeadmin','2016-04-13 11:04:24','globeadmin','2016-04-13 11:04:24','globeadmin'),('570dfd88d821f8a','5689468794353da','570c988f9d95164','2016-04-13 11:04:24','globeadmin','2016-04-13 11:04:24','globeadmin','2016-04-13 11:04:24','globeadmin'),('56ba2bdc46d0185','547de3fe0d36089','55183736b84eee4','2016-02-09 20:11:40','globeadmin','2016-02-09 20:11:40','globeadmin','2019-07-01 11:07:03','globeadmin'),('56ba2bdc4e233c0','547de3fe0d36089','551a39550972489','2016-02-09 20:11:40','globeadmin','2016-02-09 20:11:40','globeadmin','2019-07-01 11:07:06','globeadmin'),('56ba2bdc55760de','547de3fe0d36089','552124aeebd01bf','2016-02-09 20:11:40','globeadmin','2016-02-09 20:11:40','globeadmin','2019-07-01 11:07:05','globeadmin'),('5717b9c8391c0e8','5717b9c74a31169','5539081d564cca6','2016-04-20 20:18:01','globeadmin','2016-04-20 20:18:01','globeadmin','2017-10-15 19:02:13','globeadmin'),('5717b9c8454f3a1','5717b9c74a31169','552124aeebd01bf','2016-04-20 20:18:01','globeadmin','2016-04-20 20:18:01','globeadmin','2017-10-15 19:02:13','globeadmin'),('5717b9c82f57d97','5717b9c74a31169','54d6660b538bea2','2016-04-20 20:18:01','globeadmin','2016-04-20 20:18:01','globeadmin','2017-10-15 19:02:12','globeadmin'),('56ba2bdc6b6ec60','547de3fe0d36089','55255886b0e2e42','2016-02-09 20:11:40','globeadmin','2016-02-09 20:11:40','globeadmin','2019-07-01 11:07:03','globeadmin'),('56ba2bdc72c1ca1','547de3fe0d36089','55262fb4d34fbc0','2016-02-09 20:11:40','globeadmin','2016-02-09 20:11:40','globeadmin','2019-07-01 11:07:04','globeadmin'),('56ba2bdc7a1663a','547de3fe0d36089','552ea7c73b78c04','2016-02-09 20:11:40','globeadmin','2016-02-09 20:11:40','globeadmin','2019-07-01 11:07:05','globeadmin'),('570dfd82c498b90','5601afbc23dfb00','570d43d53aebdc2','2016-04-13 11:04:18','globeadmin','2016-04-13 11:04:18','globeadmin','2018-11-20 14:42:26','globeadmin'),('56ba2bdc8b2f563','547de3fe0d36089','5539081d564cca6','2016-02-09 20:11:40','globeadmin','2016-02-09 20:11:40','globeadmin','2019-07-01 11:07:05','globeadmin'),('56ba2bdc927ef6a','547de3fe0d36089','553fe1e308e7e3a','2016-02-09 20:11:40','globeadmin','2016-02-09 20:11:40','globeadmin','2019-07-01 11:07:06','globeadmin'),('56ba2bdc99d1fd8','547de3fe0d36089','5541240a041c4ee','2016-02-09 20:11:40','globeadmin','2016-02-09 20:11:40','globeadmin','2019-07-01 11:07:03','globeadmin'),('56ba2bdca124cb4','547de3fe0d36089','554797f3cce46e4','2016-02-09 20:11:40','globeadmin','2016-02-09 20:11:40','globeadmin','2019-07-01 11:07:09','globeadmin'),('56ba2bdca877ff2','547de3fe0d36089','5547a512d1c5bd2','2016-02-09 20:11:40','globeadmin','2016-02-09 20:11:40','globeadmin','2019-07-01 11:07:09','globeadmin'),('56ba2bdcafcacb1','547de3fe0d36089','55490413c23b81c','2016-02-09 20:11:40','globeadmin','2016-02-09 20:11:40','globeadmin','2019-07-01 11:07:10','globeadmin'),('56ba2bdcb71e44e','547de3fe0d36089','555d8a344f6f95a','2016-02-09 20:11:40','globeadmin','2016-02-09 20:11:40','globeadmin','2019-07-01 11:07:04','globeadmin'),('56ba2bdcbe70cdb','547de3fe0d36089','5569e34f68bcbbb','2016-02-09 20:11:40','globeadmin','2016-02-09 20:11:40','globeadmin','2019-07-01 11:07:06','globeadmin'),('570dfd7ee6c85c8','5501dbedc785fe4','570d43d53aebdc2','2016-04-13 11:04:14','globeadmin','2016-04-13 11:04:14','globeadmin','2018-01-09 18:51:25','globeadmin'),('56ba2bdccd16b12','547de3fe0d36089','561191a369a4a78','2016-02-09 20:11:40','globeadmin','2016-02-09 20:11:40','globeadmin','2019-07-01 11:07:04','globeadmin'),('570dfd79321c89e','547de3e001028e8','570d43d53aebdc2','2016-04-13 11:04:09','globeadmin','2016-04-13 11:04:09','globeadmin','2019-11-06 15:15:19','globeadmin'),('56ba2bdcdbbcd74','547de3fe0d36089','561c0a55ec1ed91','2016-02-09 20:11:40','globeadmin','2016-02-09 20:11:40','globeadmin','2019-07-01 11:07:05','globeadmin'),('56ba2bdce30fd0f','547de3fe0d36089','561d62acbdd0ab8','2016-02-09 20:11:40','globeadmin','2016-02-09 20:11:40','globeadmin','2019-07-01 11:07:06','globeadmin'),('570dfd792ac986b','547de3e001028e8','570c988f9d95164','2016-04-13 11:04:09','globeadmin','2016-04-13 11:04:09','globeadmin','2019-11-06 15:15:15','globeadmin'),('570dfd741e960b4','547de3bee410196','570d43d53aebdc2','2016-04-13 11:04:04','globeadmin','2016-04-13 11:04:04','globeadmin','2022-01-31 16:18:46','globeadmin'),('56ba2bdd0c37c2b','547de3fe0d36089','562378beaaf323a','2016-02-09 20:11:41','globeadmin','2016-02-09 20:11:41','globeadmin','2019-07-01 11:07:04','globeadmin'),('5721056ed243b00','5501dbedc785fe4','5720bb3291b7333','2016-04-27 21:31:10','globeadmin','2016-04-27 21:31:10','globeadmin','2018-01-09 18:51:24','globeadmin'),('56ba2bdd1addcf0','547de3fe0d36089','562e7c9f1816a51','2016-02-09 20:11:41','globeadmin','2016-02-09 20:11:41','globeadmin','2019-07-01 11:07:05','globeadmin'),('56ba2bdd2230b2e','547de3fe0d36089','562e80fdcf335fe','2016-02-09 20:11:41','globeadmin','2016-02-09 20:11:41','globeadmin','2019-07-01 11:07:09','globeadmin'),('56ba2bdd2983c10','547de3fe0d36089','563134ef69e16fd','2016-02-09 20:11:41','globeadmin','2016-02-09 20:11:41','globeadmin','2019-07-01 11:07:05','globeadmin'),('56ba2bdd30d6c9a','547de3fe0d36089','563137091e32c73','2016-02-09 20:11:41','globeadmin','2016-02-09 20:11:41','globeadmin','2019-07-01 11:07:05','globeadmin'),('572105751d99a96','5601afbc23dfb00','5720bb3291b7333','2016-04-27 21:31:17','globeadmin','2016-04-27 21:31:17','globeadmin','2018-11-20 14:42:25','globeadmin'),('572dcaa28dd78be','5717b9c74a31169','5728fe5eefef00e','2016-05-07 13:59:46','globeadmin','2016-05-07 13:59:46','globeadmin','2017-10-15 19:02:14','globeadmin'),('5721056761f5a76','547de3bee410196','5720bb3291b7333','2016-04-27 21:31:03','globeadmin','2016-04-27 21:31:03','globeadmin','2022-01-31 16:18:46','globeadmin'),('56ba2bdd4e22d91','547de3fe0d36089','56521e303a1e26c','2016-02-09 20:11:41','globeadmin','2016-02-09 20:11:41','globeadmin','2019-07-01 11:07:10','globeadmin'),('56ba2bdd5575c4a','547de3fe0d36089','56588495311fece','2016-02-09 20:11:41','globeadmin','2016-02-09 20:11:41','globeadmin','2019-07-01 11:07:03','globeadmin'),('56ba2bdd5cc8df7','547de3fe0d36089','565ac873e409ddc','2016-02-09 20:11:41','globeadmin','2016-02-09 20:11:41','globeadmin','2019-07-01 11:07:05','globeadmin'),('56ba2bdd641bc90','547de3fe0d36089','56608bc656a4d24','2016-02-09 20:11:41','globeadmin','2016-02-09 20:11:41','globeadmin','2019-07-01 11:07:10','globeadmin'),('56ba2bdd6b6eb2b','547de3fe0d36089','5687b0505b9ec15','2016-02-09 20:11:41','globeadmin','2016-02-09 20:11:41','globeadmin','2019-07-01 11:07:07','globeadmin'),('570ca5833228ef8','5601afbc23dfb00','570c988f9d95164','2016-04-12 10:36:35','globeadmin','2016-04-12 10:36:35','globeadmin','2018-11-20 14:42:21','globeadmin'),('56ba2bdd7a14cf2','547de3fe0d36089','56a11975eff1dd2','2016-02-09 20:11:41','globeadmin','2016-02-09 20:11:41','globeadmin','2019-07-01 11:07:09','globeadmin'),('5717b9c84f147bd','5717b9c74a31169','552ea7c73b78c04','2016-04-20 20:18:01','globeadmin','2016-04-20 20:18:01','globeadmin','2017-10-15 19:02:13','globeadmin'),('572b7ad496a89a5','5601afbc23dfb00','572b6f3ed13f95a','2016-05-05 19:54:44','globeadmin','2016-05-05 19:54:44','globeadmin','2018-11-20 14:42:19','globeadmin'),('572b7ad49dfae06','5601afbc23dfb00','5728fe5eefef00e','2016-05-05 19:54:44','globeadmin','2016-05-05 19:54:44','globeadmin','2018-11-20 14:42:26','globeadmin'),('572b7ad4a54d2a4','5601afbc23dfb00','572b066732990f9','2016-05-05 19:54:44','globeadmin','2016-05-05 19:54:44','globeadmin','2018-11-20 14:42:19','globeadmin'),('572b7ad8ee8b3dd','5689468794353da','572b6f3ed13f95a','2016-05-05 19:54:48','globeadmin','2016-05-05 19:54:48','globeadmin','2016-05-05 19:54:48','globeadmin'),('572b7ad901ba405','5689468794353da','5728fe5eefef00e','2016-05-05 19:54:49','globeadmin','2016-05-05 19:54:49','globeadmin','2016-05-05 19:54:49','globeadmin'),('572b7ad9090d20f','5689468794353da','572b066732990f9','2016-05-05 19:54:49','globeadmin','2016-05-05 19:54:49','globeadmin','2016-05-05 19:54:49','globeadmin'),('572dca58ef7f72d','547de3bee410196','572dbad6497d1fa','2016-05-07 13:58:32','globeadmin','2016-05-07 13:58:32','globeadmin','2022-01-31 16:18:46','globeadmin'),('572dca5902ae60b','547de3bee410196','572d973a2c31092','2016-05-07 13:58:33','globeadmin','2016-05-07 13:58:33','globeadmin','2022-01-31 16:18:44','globeadmin'),('572dca5c13c6e56','547de3e001028e8','572dbad6497d1fa','2016-05-07 13:58:36','globeadmin','2016-05-07 13:58:36','globeadmin','2019-11-06 15:15:19','globeadmin'),('572dca5c1b186db','547de3e001028e8','572d973a2c31092','2016-05-07 13:58:36','globeadmin','2016-05-07 13:58:36','globeadmin','2019-11-06 15:15:14','globeadmin'),('572dca5c226b67e','547de3e001028e8','5728fe5eefef00e','2016-05-07 13:58:36','globeadmin','2016-05-07 13:58:36','globeadmin','2019-11-06 15:15:19','globeadmin'),('572dca62d235016','5501dbedc785fe4','572dbad6497d1fa','2016-05-07 13:58:42','globeadmin','2016-05-07 13:58:42','globeadmin','2018-01-09 18:51:25','globeadmin'),('572dca62d98e72f','5501dbedc785fe4','572d973a2c31092','2016-05-07 13:58:42','globeadmin','2016-05-07 13:58:42','globeadmin','2018-01-09 18:51:17','globeadmin'),('572dca66ad95d77','5601afbc23dfb00','572dbad6497d1fa','2016-05-07 13:58:46','globeadmin','2016-05-07 13:58:46','globeadmin','2018-11-20 14:42:26','globeadmin'),('572dca66b4e7755','5601afbc23dfb00','572d973a2c31092','2016-05-07 13:58:46','globeadmin','2016-05-07 13:58:46','globeadmin','2018-11-20 14:42:18','globeadmin'),('572dca6b051f7b9','5689468794353da','572dbad6497d1fa','2016-05-07 13:58:51','globeadmin','2016-05-07 13:58:51','globeadmin','2016-05-07 13:58:51','globeadmin'),('572dca6b0c727ad','5689468794353da','572d973a2c31092','2016-05-07 13:58:51','globeadmin','2016-05-07 13:58:51','globeadmin','2016-05-07 13:58:51','globeadmin'),('57418eb4ef7073c','547de3bee410196','57401ba6d83b3e9','2016-05-22 13:49:24','globeadmin','2016-05-22 13:49:24','globeadmin','2022-01-31 16:18:46','globeadmin'),('57418eb929afca2','547de3e001028e8','57401ba6d83b3e9','2016-05-22 13:49:29','globeadmin','2016-05-22 13:49:29','globeadmin','2019-11-06 15:15:18','globeadmin'),('57418ebde81d67c','5501dbedc785fe4','57401ba6d83b3e9','2016-05-22 13:49:33','globeadmin','2016-05-22 13:49:33','globeadmin','2018-01-09 18:51:24','globeadmin'),('57418ec19edfa4d','5601afbc23dfb00','57401ba6d83b3e9','2016-05-22 13:49:37','globeadmin','2016-05-22 13:49:37','globeadmin','2018-11-20 14:42:25','globeadmin'),('57418ec70036b7f','5689468794353da','57401ba6d83b3e9','2016-05-22 13:49:43','globeadmin','2016-05-22 13:49:43','globeadmin','2016-05-22 13:49:43','globeadmin'),('5780048f06316ff','547de3bee410196','577fd4f60b0df80','2016-07-08 22:52:47','globeadmin','2016-07-08 22:52:47','globeadmin','2016-07-08 22:52:47','globeadmin'),('5742e4c06b2efaf','547de3bee410196','57428fad993ae6b','2016-05-23 14:08:48','globeadmin','2016-05-23 14:08:48','globeadmin','2022-01-31 16:18:46','globeadmin'),('5742e4c074f19ff','547de3bee410196','5742d24537ea41b','2016-05-23 14:08:48','globeadmin','2016-05-23 14:08:48','globeadmin','2022-01-31 16:18:44','globeadmin'),('5742e4c3e05f0fe','547de3e001028e8','57428fad993ae6b','2016-05-23 14:08:51','globeadmin','2016-05-23 14:08:51','globeadmin','2019-11-06 15:15:18','globeadmin'),('5742e4c3ea21ef2','547de3e001028e8','5742d24537ea41b','2016-05-23 14:08:51','globeadmin','2016-05-23 14:08:51','globeadmin','2019-11-06 15:15:14','globeadmin'),('5742e4c8b6dc9f9','5501dbedc785fe4','57428fad993ae6b','2016-05-23 14:08:56','globeadmin','2016-05-23 14:08:56','globeadmin','2018-01-09 18:51:24','globeadmin'),('5742e4c8c0a0869','5501dbedc785fe4','5742d24537ea41b','2016-05-23 14:08:56','globeadmin','2016-05-23 14:08:56','globeadmin','2018-01-09 18:51:19','globeadmin'),('5742e4cbef05295','5601afbc23dfb00','57428fad993ae6b','2016-05-23 14:08:59','globeadmin','2016-05-23 14:08:59','globeadmin','2018-11-20 14:42:25','globeadmin'),('5742e4cc04a3cda','5601afbc23dfb00','5742d24537ea41b','2016-05-23 14:09:00','globeadmin','2016-05-23 14:09:00','globeadmin','2018-11-20 14:42:20','globeadmin'),('5742e4cfd429d22','5689468794353da','57428fad993ae6b','2016-05-23 14:09:03','globeadmin','2016-05-23 14:09:03','globeadmin','2016-05-23 14:09:03','globeadmin'),('5742e4cfddecad2','5689468794353da','5742d24537ea41b','2016-05-23 14:09:03','globeadmin','2016-05-23 14:09:03','globeadmin','2016-05-23 14:09:03','globeadmin'),('57800497126787a','547de3fe0d36089','5757b8458c72cf3','2016-07-08 22:52:55','globeadmin','2016-07-08 22:52:55','globeadmin','2019-07-01 11:07:09','globeadmin'),('5780049719b99c0','547de3fe0d36089','577fd4f60b0df80','2016-07-08 22:52:55','globeadmin','2016-07-08 22:52:55','globeadmin','2016-07-08 22:52:55','globeadmin'),('5780049434940d3','547de3e001028e8','577fd4f60b0df80','2016-07-08 22:52:52','globeadmin','2016-07-08 22:52:52','globeadmin','2016-07-08 22:52:52','globeadmin'),('57460da728c3711','547de3bee410196','57449ba8e93ac07','2016-05-25 23:40:07','globeadmin','2016-05-25 23:40:07','globeadmin','2022-01-31 16:18:43','globeadmin'),('57460da73016359','547de3bee410196','57453d968dbad4a','2016-05-25 23:40:07','globeadmin','2016-05-25 23:40:07','globeadmin','2022-01-31 16:18:43','globeadmin'),('57460da7376936c','547de3bee410196','57459161e5a0363','2016-05-25 23:40:07','globeadmin','2016-05-25 23:40:07','globeadmin','2022-01-31 16:18:43','globeadmin'),('57460daaa5479b1','547de3e001028e8','57449ba8e93ac07','2016-05-25 23:40:10','globeadmin','2016-05-25 23:40:10','globeadmin','2019-11-06 15:15:13','globeadmin'),('57460daaac99453','547de3e001028e8','57453d968dbad4a','2016-05-25 23:40:10','globeadmin','2016-05-25 23:40:10','globeadmin','2019-11-06 15:15:13','globeadmin'),('57460daab3ec3c8','547de3e001028e8','57459161e5a0363','2016-05-25 23:40:10','globeadmin','2016-05-25 23:40:10','globeadmin','2019-11-06 15:15:13','globeadmin'),('57460daee4c0494','5501dbedc785fe4','57449ba8e93ac07','2016-05-25 23:40:14','globeadmin','2016-05-25 23:40:14','globeadmin','2018-01-09 18:51:16','globeadmin'),('57460daeec1340e','5501dbedc785fe4','57453d968dbad4a','2016-05-25 23:40:14','globeadmin','2016-05-25 23:40:14','globeadmin','2018-01-09 18:51:16','globeadmin'),('57460daef3667f7','5501dbedc785fe4','57459161e5a0363','2016-05-25 23:40:14','globeadmin','2016-05-25 23:40:14','globeadmin','2018-01-09 18:51:16','globeadmin'),('57460db4153b8af','5601afbc23dfb00','57449ba8e93ac07','2016-05-25 23:40:20','globeadmin','2016-05-25 23:40:20','globeadmin','2018-11-20 14:42:17','globeadmin'),('57460db41c8e29f','5601afbc23dfb00','57453d968dbad4a','2016-05-25 23:40:20','globeadmin','2016-05-25 23:40:20','globeadmin','2018-11-20 14:42:17','globeadmin'),('57460db423e313c','5601afbc23dfb00','57459161e5a0363','2016-05-25 23:40:20','globeadmin','2016-05-25 23:40:20','globeadmin','2018-11-20 14:42:17','globeadmin'),('57460db8991287e','5689468794353da','57449ba8e93ac07','2016-05-25 23:40:24','globeadmin','2016-05-25 23:40:24','globeadmin','2016-05-25 23:40:24','globeadmin'),('57460db8a06729a','5689468794353da','57453d968dbad4a','2016-05-25 23:40:24','globeadmin','2016-05-25 23:40:24','globeadmin','2016-05-25 23:40:24','globeadmin'),('57460db8a7b7822','5689468794353da','57459161e5a0363','2016-05-25 23:40:24','globeadmin','2016-05-25 23:40:24','globeadmin','2016-05-25 23:40:24','globeadmin'),('5780048ef304230','547de3bee410196','5757b8458c72cf3','2016-07-08 22:52:46','globeadmin','2016-07-08 22:52:46','globeadmin','2022-01-31 16:18:47','globeadmin'),('579105d28f7d4ab','547de3fe0d36089','5790f5c50ba72b6','2016-07-21 20:26:42','globeadmin','2016-07-21 20:26:42','globeadmin','2019-07-01 11:07:07','globeadmin'),('574eb837dd77d03','547de3bee410196','574bd5bd5a5bede','2016-06-01 13:25:59','globeadmin','2016-06-01 13:25:59','globeadmin','2022-01-31 16:18:46','globeadmin'),('574eb837e73a321','547de3bee410196','574ea919042d569','2016-06-01 13:25:59','globeadmin','2016-06-01 13:25:59','globeadmin','2022-01-31 16:18:43','globeadmin'),('574eb83aa7c1d37','547de3e001028e8','574bd5bd5a5bede','2016-06-01 13:26:02','globeadmin','2016-06-01 13:26:02','globeadmin','2019-11-06 15:15:18','globeadmin'),('574eb83aaf135fd','547de3e001028e8','574ea919042d569','2016-06-01 13:26:02','globeadmin','2016-06-01 13:26:02','globeadmin','2019-11-06 15:15:13','globeadmin'),('574eb83e991bf99','5501dbedc785fe4','574bd5bd5a5bede','2016-06-01 13:26:06','globeadmin','2016-06-01 13:26:06','globeadmin','2018-01-09 18:51:24','globeadmin'),('574eb83ea06d831','5501dbedc785fe4','574ea919042d569','2016-06-01 13:26:06','globeadmin','2016-06-01 13:26:06','globeadmin','2018-01-09 18:51:17','globeadmin'),('574eb8419438ee3','5601afbc23dfb00','574bd5bd5a5bede','2016-06-01 13:26:09','globeadmin','2016-06-01 13:26:09','globeadmin','2018-11-20 14:42:25','globeadmin'),('574eb8419b8b5e6','5601afbc23dfb00','574ea919042d569','2016-06-01 13:26:09','globeadmin','2016-06-01 13:26:09','globeadmin','2018-11-20 14:42:18','globeadmin'),('574eb84aa2de77f','5689468794353da','574bd5bd5a5bede','2016-06-01 13:26:18','globeadmin','2016-06-01 13:26:18','globeadmin','2016-06-01 13:26:18','globeadmin'),('574eb84aaa315cf','5689468794353da','574ea919042d569','2016-06-01 13:26:18','globeadmin','2016-06-01 13:26:18','globeadmin','2016-06-01 13:26:18','globeadmin'),('5780047776807eb','561928b27d0261b','577fd4f60b0df80','2016-07-08 22:52:23','globeadmin','2016-07-08 22:52:23','globeadmin','2016-07-08 22:52:23','globeadmin'),('5754ea403e4ebc0','547de3bee410196','5753f0e67512c07','2016-06-06 06:13:04','globeadmin','2016-06-06 06:13:04','globeadmin','2022-01-31 16:18:48','globeadmin'),('5754ea440627454','547de3e001028e8','5753f0e67512c07','2016-06-06 06:13:08','globeadmin','2016-06-06 06:13:08','globeadmin','2019-11-06 15:15:22','globeadmin'),('5754ea47e932d52','5501dbedc785fe4','5753f0e67512c07','2016-06-06 06:13:11','globeadmin','2016-06-06 06:13:11','globeadmin','2018-01-09 18:51:29','globeadmin'),('5754ea4aa4d832c','5601afbc23dfb00','5753f0e67512c07','2016-06-06 06:13:14','globeadmin','2016-06-06 06:13:14','globeadmin','2018-11-20 14:42:30','globeadmin'),('5754ea4ed5aacbc','5689468794353da','5753f0e67512c07','2016-06-06 06:13:18','globeadmin','2016-06-06 06:13:18','globeadmin','2016-06-06 06:13:18','globeadmin'),('5780049aa7531f1','5501dbedc785fe4','5757b8458c72cf3','2016-07-08 22:52:58','globeadmin','2016-07-08 22:52:58','globeadmin','2018-01-09 18:51:26','globeadmin'),('5780049aaea600f','5501dbedc785fe4','577fd4f60b0df80','2016-07-08 22:52:58','globeadmin','2016-07-08 22:52:58','globeadmin','2016-07-08 22:52:58','globeadmin'),('5780049dc711744','5601afbc23dfb00','5757b8458c72cf3','2016-07-08 22:53:01','globeadmin','2016-07-08 22:53:01','globeadmin','2018-11-20 14:42:27','globeadmin'),('5780049dce630d3','5601afbc23dfb00','577fd4f60b0df80','2016-07-08 22:53:01','globeadmin','2016-07-08 22:53:01','globeadmin','2016-07-08 22:53:01','globeadmin'),('578004a1237f8db','5689468794353da','5757b8458c72cf3','2016-07-08 22:53:05','globeadmin','2016-07-08 22:53:05','globeadmin','2016-07-08 22:53:05','globeadmin'),('578004a12ad00ac','5689468794353da','577fd4f60b0df80','2016-07-08 22:53:05','globeadmin','2016-07-08 22:53:05','globeadmin','2016-07-08 22:53:05','globeadmin'),('578004a3ee2176a','5717b9c74a31169','5757b8458c72cf3','2016-07-08 22:53:07','globeadmin','2016-07-08 22:53:07','globeadmin','2017-10-15 19:02:15','globeadmin'),('578004a4014f4db','5717b9c74a31169','577fd4f60b0df80','2016-07-08 22:53:08','globeadmin','2016-07-08 22:53:08','globeadmin','2016-07-08 22:53:08','globeadmin'),('5781495f442c7a2','547de3bee410196','577ec3a08a5bebe','2016-07-09 21:58:39','globeadmin','2016-07-09 21:58:39','globeadmin','2022-01-31 16:18:46','globeadmin'),('5781496330a46bc','547de3e001028e8','577ec3a08a5bebe','2016-07-09 21:58:43','globeadmin','2016-07-09 21:58:43','globeadmin','2019-11-06 15:15:18','globeadmin'),('578149660995d1e','5501dbedc785fe4','577ec3a08a5bebe','2016-07-09 21:58:46','globeadmin','2016-07-09 21:58:46','globeadmin','2018-01-09 18:51:24','globeadmin'),('578149690995de6','5601afbc23dfb00','577ec3a08a5bebe','2016-07-09 21:58:49','globeadmin','2016-07-09 21:58:49','globeadmin','2018-11-20 14:42:25','globeadmin'),('5781496fe7c0ebe','5689468794353da','577ec3a08a5bebe','2016-07-09 21:58:55','globeadmin','2016-07-09 21:58:55','globeadmin','2016-07-09 21:58:55','globeadmin'),('578554c46a2bccf','547de3bee410196','573497529d89c8b','2016-07-12 23:36:20','globeadmin','2016-07-12 23:36:20','globeadmin','2022-01-31 16:18:48','globeadmin'),('579105dee4f0394','5717b9c74a31169','5790f5c50ba72b6','2016-07-21 20:26:54','globeadmin','2016-07-21 20:26:54','globeadmin','2017-10-15 19:02:14','globeadmin'),('57815deb3cdb732','547de3bee410196','57815cda5c980f5','2016-07-09 23:26:19','globeadmin','2016-07-09 23:26:19','globeadmin','2022-01-31 16:18:44','globeadmin'),('57815deb469d6b7','547de3bee410196','57811f7eb6d75f3','2016-07-09 23:26:19','globeadmin','2016-07-09 23:26:19','globeadmin','2022-01-31 16:18:44','globeadmin'),('57815df27c5387d','5501dbedc785fe4','57815cda5c980f5','2016-07-09 23:26:26','globeadmin','2016-07-09 23:26:26','globeadmin','2018-01-09 18:51:18','globeadmin'),('57815df2861765c','5501dbedc785fe4','57811f7eb6d75f3','2016-07-09 23:26:26','globeadmin','2016-07-09 23:26:26','globeadmin','2018-01-09 18:51:18','globeadmin'),('57815df5a0f3e5a','5601afbc23dfb00','57815cda5c980f5','2016-07-09 23:26:29','globeadmin','2016-07-09 23:26:29','globeadmin','2018-11-20 14:42:19','globeadmin'),('57815df5aab66fd','5601afbc23dfb00','57811f7eb6d75f3','2016-07-09 23:26:29','globeadmin','2016-07-09 23:26:29','globeadmin','2018-11-20 14:42:19','globeadmin'),('578554cb62d9747','5501dbedc785fe4','573497529d89c8b','2016-07-12 23:36:27','globeadmin','2016-07-12 23:36:27','globeadmin','2018-01-09 18:51:28','globeadmin'),('57868e2c31fba54','5501dbedc785fe4','577bdc658c7b9a8','2016-07-13 21:53:32','globeadmin','2016-07-13 21:53:32','globeadmin','2018-01-09 18:51:16','globeadmin'),('57868e33a24b4b2','5601afbc23dfb00','577bdc658c7b9a8','2016-07-13 21:53:39','globeadmin','2016-07-13 21:53:39','globeadmin','2018-11-20 14:42:17','globeadmin'),('579105d806c6ee7','5601afbc23dfb00','5790f5c50ba72b6','2016-07-21 20:26:48','globeadmin','2016-07-21 20:26:48','globeadmin','2018-11-20 14:42:26','globeadmin'),('578be3d10c8dbcb','547de3bee410196','5788d587dcb311f','2016-07-17 23:00:17','globeadmin','2016-07-17 23:00:17','globeadmin','2022-01-31 16:18:45','globeadmin'),('578be3d113e01f5','547de3bee410196','5788d1d89374f2b','2016-07-17 23:00:17','globeadmin','2016-07-17 23:00:17','globeadmin','2022-01-31 16:18:45','globeadmin'),('578be3d11b331f0','547de3bee410196','578a2334d076529','2016-07-17 23:00:17','globeadmin','2016-07-17 23:00:17','globeadmin','2022-01-31 16:18:43','globeadmin'),('578be3d702c919a','547de3e001028e8','5788d587dcb311f','2016-07-17 23:00:23','globeadmin','2016-07-17 23:00:23','globeadmin','2019-11-06 15:15:15','globeadmin'),('578be3d70a1c1df','547de3e001028e8','5788d1d89374f2b','2016-07-17 23:00:23','globeadmin','2016-07-17 23:00:23','globeadmin','2019-11-06 15:15:15','globeadmin'),('578be3d7116f13d','547de3e001028e8','578a2334d076529','2016-07-17 23:00:23','globeadmin','2016-07-17 23:00:23','globeadmin','2019-11-06 15:15:13','globeadmin'),('578be3db360e690','5501dbedc785fe4','5788d587dcb311f','2016-07-17 23:00:27','globeadmin','2016-07-17 23:00:27','globeadmin','2018-01-09 18:51:20','globeadmin'),('578be3db3d611b1','5501dbedc785fe4','5788d1d89374f2b','2016-07-17 23:00:27','globeadmin','2016-07-17 23:00:27','globeadmin','2018-01-09 18:51:20','globeadmin'),('578be3db44b4132','5501dbedc785fe4','578a2334d076529','2016-07-17 23:00:27','globeadmin','2016-07-17 23:00:27','globeadmin','2018-01-09 18:51:17','globeadmin'),('578be3debc551e1','5601afbc23dfb00','5788d587dcb311f','2016-07-17 23:00:30','globeadmin','2016-07-17 23:00:30','globeadmin','2018-11-20 14:42:21','globeadmin'),('578be3dec3a814d','5601afbc23dfb00','5788d1d89374f2b','2016-07-17 23:00:30','globeadmin','2016-07-17 23:00:30','globeadmin','2018-11-20 14:42:22','globeadmin'),('578be3decafb18c','5601afbc23dfb00','578a2334d076529','2016-07-17 23:00:30','globeadmin','2016-07-17 23:00:30','globeadmin','2018-11-20 14:42:18','globeadmin'),('578be3e2d24e73a','5689468794353da','5788d587dcb311f','2016-07-17 23:00:34','globeadmin','2016-07-17 23:00:34','globeadmin','2016-07-17 23:00:34','globeadmin'),('578be3e2d9a13e8','5689468794353da','5788d1d89374f2b','2016-07-17 23:00:34','globeadmin','2016-07-17 23:00:34','globeadmin','2016-07-17 23:00:34','globeadmin'),('578be3e2e0f4392','5689468794353da','578a2334d076529','2016-07-17 23:00:34','globeadmin','2016-07-17 23:00:34','globeadmin','2016-07-17 23:00:34','globeadmin'),('579105d5724aada','5501dbedc785fe4','5790f5c50ba72b6','2016-07-21 20:26:45','globeadmin','2016-07-21 20:26:45','globeadmin','2018-01-09 18:51:25','globeadmin'),('579105cfd64a33c','547de3e001028e8','5790f5c50ba72b6','2016-07-21 20:26:39','globeadmin','2016-07-21 20:26:39','globeadmin','2019-11-06 15:15:19','globeadmin'),('579105db6ae0478','5689468794353da','5790f5c50ba72b6','2016-07-21 20:26:51','globeadmin','2016-07-21 20:26:51','globeadmin','2016-07-21 20:26:51','globeadmin'),('579105caec44a0e','547de3bee410196','5790f5c50ba72b6','2016-07-21 20:26:34','globeadmin','2016-07-21 20:26:34','globeadmin','2022-01-31 16:18:46','globeadmin'),('578f81190e31630','547de3e001028e8','572b066732990f9','2016-07-20 16:48:09','globeadmin','2016-07-20 16:48:09','globeadmin','2019-11-06 15:15:14','globeadmin'),('5794bbe07d0418b','547de3bee410196','576309a50223f96','2016-07-24 16:00:16','globeadmin','2016-07-24 16:00:16','globeadmin','2022-01-31 16:18:44','globeadmin'),('5794bb9e07d3df9','5501dbedc785fe4','5794ba3aab6842f','2016-07-24 15:59:10','globeadmin','2016-07-24 15:59:10','globeadmin','2018-01-09 18:51:28','globeadmin'),('5794bb9e0f26eb5','5501dbedc785fe4','5794ba9e70d0672','2016-07-24 15:59:10','globeadmin','2016-07-24 15:59:10','globeadmin','2018-01-09 18:51:15','globeadmin'),('5794bb9e1679cce','5501dbedc785fe4','576309a50223f96','2016-07-24 15:59:10','globeadmin','2016-07-24 15:59:10','globeadmin','2018-01-09 18:51:18','globeadmin'),('5794bba65ad7302','5601afbc23dfb00','5794ba3aab6842f','2016-07-24 15:59:18','globeadmin','2016-07-24 15:59:18','globeadmin','2018-11-20 14:42:29','globeadmin'),('5794bba66228c04','5601afbc23dfb00','5794ba9e70d0672','2016-07-24 15:59:18','globeadmin','2016-07-24 15:59:18','globeadmin','2018-11-20 14:42:16','globeadmin'),('5794bba6697bc93','5601afbc23dfb00','576309a50223f96','2016-07-24 15:59:18','globeadmin','2016-07-24 15:59:18','globeadmin','2018-11-20 14:42:19','globeadmin'),('579893511561141','547de3bee410196','579785a44a87d70','2016-07-27 13:56:17','globeadmin','2016-07-27 13:56:17','globeadmin','2022-01-31 16:18:45','globeadmin'),('579893511cb41ad','547de3bee410196','57965e409e50885','2016-07-27 13:56:17','globeadmin','2016-07-27 13:56:17','globeadmin','2022-01-31 16:18:45','globeadmin'),('579893550e0fbf9','547de3e001028e8','579785a44a87d70','2016-07-27 13:56:21','globeadmin','2016-07-27 13:56:21','globeadmin','2019-11-06 15:15:17','globeadmin'),('5798935515610bf','547de3e001028e8','57965e409e50885','2016-07-27 13:56:21','globeadmin','2016-07-27 13:56:21','globeadmin','2019-11-06 15:15:17','globeadmin'),('5798935932ad1c3','547de3fe0d36089','579785a44a87d70','2016-07-27 13:56:25','globeadmin','2016-07-27 13:56:25','globeadmin','2019-07-01 11:07:06','globeadmin'),('579893593a000dc','547de3fe0d36089','57965e409e50885','2016-07-27 13:56:25','globeadmin','2016-07-27 13:56:25','globeadmin','2019-07-01 11:07:05','globeadmin'),('5798935cf11c485','5501dbedc785fe4','579785a44a87d70','2016-07-27 13:56:28','globeadmin','2016-07-27 13:56:28','globeadmin','2018-01-09 18:51:23','globeadmin'),('5798935d0449f61','5501dbedc785fe4','57965e409e50885','2016-07-27 13:56:29','globeadmin','2016-07-27 13:56:29','globeadmin','2018-01-09 18:51:23','globeadmin'),('57989362d64165c','5601afbc23dfb00','579785a44a87d70','2016-07-27 13:56:34','globeadmin','2016-07-27 13:56:34','globeadmin','2018-11-20 14:42:24','globeadmin'),('57989362dd935f1','5601afbc23dfb00','57965e409e50885','2016-07-27 13:56:34','globeadmin','2016-07-27 13:56:34','globeadmin','2018-11-20 14:42:24','globeadmin'),('579893666fb64f0','5689468794353da','579785a44a87d70','2016-07-27 13:56:38','globeadmin','2016-07-27 13:56:38','globeadmin','2016-07-27 13:56:38','globeadmin'),('579893667708f08','5689468794353da','57965e409e50885','2016-07-27 13:56:38','globeadmin','2016-07-27 13:56:38','globeadmin','2016-07-27 13:56:38','globeadmin'),('5798936a6fb7693','5717b9c74a31169','579785a44a87d70','2016-07-27 13:56:42','globeadmin','2016-07-27 13:56:42','globeadmin','2017-10-15 19:02:13','globeadmin'),('5798936a770914d','5717b9c74a31169','57965e409e50885','2016-07-27 13:56:42','globeadmin','2016-07-27 13:56:42','globeadmin','2017-10-15 19:02:13','globeadmin'),('5814a128003686d','547de3bee410196','58146d78c37daaa','2016-10-29 16:16:24','globeadmin','2016-10-29 16:16:24','globeadmin','2022-01-31 16:18:46','globeadmin'),('57e16f398199011','5501dbedc785fe4','57e16edf9a33988','2016-09-20 20:17:45','globeadmin','2016-09-20 20:17:45','globeadmin','2018-01-09 18:51:17','globeadmin'),('57e16f3ea8a654f','5601afbc23dfb00','57e16edf9a33988','2016-09-20 20:17:50','globeadmin','2016-09-20 20:17:50','globeadmin','2018-11-20 14:42:18','globeadmin'),('5804dc5c021a89e','547de3bee410196','58038a9f6de6bc9','2016-10-17 17:12:44','globeadmin','2016-10-17 17:12:44','globeadmin','2022-01-31 16:18:44','globeadmin'),('57e79bbe4d9abf0','547de3bee410196','579a4c58a490a53','2016-09-25 12:41:18','globeadmin','2016-09-25 12:41:18','globeadmin','2022-01-31 16:18:46','globeadmin'),('57e437584855fd7','5501dbedc785fe4','57e4314804e765c','2016-09-22 22:56:08','globeadmin','2016-09-22 22:56:08','globeadmin','2018-01-09 18:51:17','globeadmin'),('57e4375b7451352','5601afbc23dfb00','57e4314804e765c','2016-09-22 22:56:11','globeadmin','2016-09-22 22:56:11','globeadmin','2018-11-20 14:42:18','globeadmin'),('57e79bc1d176829','547de3e001028e8','579a4c58a490a53','2016-09-25 12:41:21','globeadmin','2016-09-25 12:41:21','globeadmin','2019-11-06 15:15:18','globeadmin'),('57e79bc50bb1b1a','5501dbedc785fe4','579a4c58a490a53','2016-09-25 12:41:25','globeadmin','2016-09-25 12:41:25','globeadmin','2018-01-09 18:51:24','globeadmin'),('57e79bc87714b2a','5601afbc23dfb00','579a4c58a490a53','2016-09-25 12:41:28','globeadmin','2016-09-25 12:41:28','globeadmin','2018-11-20 14:42:25','globeadmin'),('57e79bcbb1aabe6','5689468794353da','579a4c58a490a53','2016-09-25 12:41:31','globeadmin','2016-09-25 12:41:31','globeadmin','2016-09-25 12:41:31','globeadmin'),('57ed74bd10b0128','547de3bee410196','57ed715f3c48a80','2016-09-29 23:08:29','globeadmin','2016-09-29 23:08:29','globeadmin','2022-01-31 16:18:46','globeadmin'),('57ed74bd18030e5','547de3bee410196','57ed57dd13deb39','2016-09-29 23:08:29','globeadmin','2016-09-29 23:08:29','globeadmin','2022-01-31 16:18:44','globeadmin'),('57ed74c42b86ab0','5501dbedc785fe4','57ed715f3c48a80','2016-09-29 23:08:36','globeadmin','2016-09-29 23:08:36','globeadmin','2018-01-09 18:51:26','globeadmin'),('57ed74c432d997a','5501dbedc785fe4','57ed57dd13deb39','2016-09-29 23:08:36','globeadmin','2016-09-29 23:08:36','globeadmin','2018-01-09 18:51:18','globeadmin'),('57ed74c8bdffe23','5601afbc23dfb00','57ed715f3c48a80','2016-09-29 23:08:40','globeadmin','2016-09-29 23:08:40','globeadmin','2018-11-20 14:42:27','globeadmin'),('57ed74c8c552e9a','5601afbc23dfb00','57ed57dd13deb39','2016-09-29 23:08:40','globeadmin','2016-09-29 23:08:40','globeadmin','2018-11-20 14:42:19','globeadmin'),('5804dc5c096d43b','547de3bee410196','58038a698b9a3ec','2016-10-17 17:12:44','globeadmin','2016-10-17 17:12:44','globeadmin','2022-01-31 16:18:44','globeadmin'),('5804dc5f5c6cf3b','547de3e001028e8','58038a9f6de6bc9','2016-10-17 17:12:47','globeadmin','2016-10-17 17:12:47','globeadmin','2019-11-06 15:15:15','globeadmin'),('5804dc5f63c08e3','547de3e001028e8','58038a698b9a3ec','2016-10-17 17:12:47','globeadmin','2016-10-17 17:12:47','globeadmin','2019-11-06 15:15:15','globeadmin'),('5804dc690964359','5501dbedc785fe4','58038a9f6de6bc9','2016-10-17 17:12:57','globeadmin','2016-10-17 17:12:57','globeadmin','2018-01-09 18:51:20','globeadmin'),('5804dc6910b75eb','5501dbedc785fe4','58038a698b9a3ec','2016-10-17 17:12:57','globeadmin','2016-10-17 17:12:57','globeadmin','2018-01-09 18:51:20','globeadmin'),('5804dc6c6fec3c5','5601afbc23dfb00','58038a9f6de6bc9','2016-10-17 17:13:00','globeadmin','2016-10-17 17:13:00','globeadmin','2018-11-20 14:42:21','globeadmin'),('5804dc6c773eb57','5601afbc23dfb00','58038a698b9a3ec','2016-10-17 17:13:00','globeadmin','2016-10-17 17:13:00','globeadmin','2018-11-20 14:42:21','globeadmin'),('5804dc6f773d28a','5689468794353da','58038a9f6de6bc9','2016-10-17 17:13:03','globeadmin','2016-10-17 17:13:03','globeadmin','2016-10-17 17:13:03','globeadmin'),('5804dc6f7e8fb2f','5689468794353da','58038a698b9a3ec','2016-10-17 17:13:03','globeadmin','2016-10-17 17:13:03','globeadmin','2016-10-17 17:13:03','globeadmin'),('580cf597ccbca0f','547de3bee410196','580cf554357ba80','2016-10-23 20:38:31','globeadmin','2016-10-23 20:38:31','globeadmin','2022-01-31 16:18:46','globeadmin'),('580cf59c43fb694','547de3e001028e8','580cf554357ba80','2016-10-23 20:38:36','globeadmin','2016-10-23 20:38:36','globeadmin','2019-11-06 15:15:18','globeadmin'),('580cf59faa80ed0','5501dbedc785fe4','580cf554357ba80','2016-10-23 20:38:39','globeadmin','2016-10-23 20:38:39','globeadmin','2018-01-09 18:51:24','globeadmin'),('580cf5a22b8b87f','5601afbc23dfb00','580cf554357ba80','2016-10-23 20:38:42','globeadmin','2016-10-23 20:38:42','globeadmin','2018-11-20 14:42:25','globeadmin'),('580cf5a518023b9','5689468794353da','580cf554357ba80','2016-10-23 20:38:45','globeadmin','2016-10-23 20:38:45','globeadmin','2016-10-23 20:38:45','globeadmin'),('584176353cdcb63','547de3e001028e8','583a9ecc6d7c907','2016-12-02 15:25:09','globeadmin','2016-12-02 15:25:09','globeadmin','2019-11-06 15:15:16','globeadmin'),('5810e122d9afa5b','547de3bee410196','580e35e0d0e50a6','2016-10-26 20:00:18','globeadmin','2016-10-26 20:00:18','globeadmin','2022-01-31 16:18:45','globeadmin'),('5810e122e1029a4','547de3bee410196','580f89b9d0103ee','2016-10-26 20:00:18','globeadmin','2016-10-26 20:00:18','globeadmin','2022-01-31 16:18:48','globeadmin'),('5810e122e855d93','547de3bee410196','580f8ebfe3c4e82','2016-10-26 20:00:18','globeadmin','2016-10-26 20:00:18','globeadmin','2022-01-31 16:18:45','globeadmin'),('5810e1272502a97','5501dbedc785fe4','580e35e0d0e50a6','2016-10-26 20:00:23','globeadmin','2016-10-26 20:00:23','globeadmin','2018-01-09 18:51:22','globeadmin'),('5810e1272c55640','5501dbedc785fe4','580f89b9d0103ee','2016-10-26 20:00:23','globeadmin','2016-10-26 20:00:23','globeadmin','2018-01-09 18:51:29','globeadmin'),('5810e12733a8684','5501dbedc785fe4','580f8ebfe3c4e82','2016-10-26 20:00:23','globeadmin','2016-10-26 20:00:23','globeadmin','2018-01-09 18:51:22','globeadmin'),('5810e129bc5eb45','5601afbc23dfb00','580e35e0d0e50a6','2016-10-26 20:00:25','globeadmin','2016-10-26 20:00:25','globeadmin','2018-11-20 14:42:23','globeadmin'),('5810e129c3b1cef','5601afbc23dfb00','580f89b9d0103ee','2016-10-26 20:00:25','globeadmin','2016-10-26 20:00:25','globeadmin','2018-11-20 14:42:30','globeadmin'),('5810e129cb04a52','5601afbc23dfb00','580f8ebfe3c4e82','2016-10-26 20:00:25','globeadmin','2016-10-26 20:00:25','globeadmin','2018-11-20 14:42:23','globeadmin'),('5814a1280782c73','547de3bee410196','58146cff692dbf3','2016-10-29 16:16:24','globeadmin','2016-10-29 16:16:24','globeadmin','2022-01-31 16:18:44','globeadmin'),('5814a130029ba43','5501dbedc785fe4','58146d78c37daaa','2016-10-29 16:16:32','globeadmin','2016-10-29 16:16:32','globeadmin','2018-01-09 18:51:25','globeadmin'),('5814a13009ee838','5501dbedc785fe4','58146cff692dbf3','2016-10-29 16:16:32','globeadmin','2016-10-29 16:16:32','globeadmin','2018-01-09 18:51:18','globeadmin'),('5814a13309eca9b','5601afbc23dfb00','58146d78c37daaa','2016-10-29 16:16:35','globeadmin','2016-10-29 16:16:35','globeadmin','2018-11-20 14:42:27','globeadmin'),('5814a133113f8b4','5601afbc23dfb00','58146cff692dbf3','2016-10-29 16:16:35','globeadmin','2016-10-29 16:16:35','globeadmin','2018-11-20 14:42:19','globeadmin'),('58469c29f1d043e','5501dbedc785fe4','58458875d6799f3','2016-12-06 13:08:25','globeadmin','2016-12-06 13:08:25','globeadmin','2018-01-09 18:51:23','globeadmin'),('58469c2746ec44d','547de3fe0d36089','58458875d6799f3','2016-12-06 13:08:23','globeadmin','2016-12-06 13:08:23','globeadmin','2019-07-01 11:07:06','globeadmin'),('58469c2109e7fd6','547de3bee410196','58458875d6799f3','2016-12-06 13:08:17','globeadmin','2016-12-06 13:08:17','globeadmin','2022-01-31 16:18:46','globeadmin'),('58469c250502f18','547de3e001028e8','58458875d6799f3','2016-12-06 13:08:21','globeadmin','2016-12-06 13:08:21','globeadmin','2019-11-06 15:15:17','globeadmin'),('583f15465c32f72','5501dbedc785fe4','5831b9019b61979','2016-11-30 20:07:02','globeadmin','2016-11-30 20:07:02','globeadmin','2018-01-09 18:51:26','globeadmin'),('583f15467230701','5501dbedc785fe4','58304c1fb6f7121','2016-11-30 20:07:02','globeadmin','2016-11-30 20:07:02','globeadmin','2018-01-09 18:51:24','globeadmin'),('583f154685b3e59','5501dbedc785fe4','5831f3f9cb4503b','2016-11-30 20:07:02','globeadmin','2016-11-30 20:07:02','globeadmin','2018-01-09 18:51:19','globeadmin'),('583f15468d0822c','5501dbedc785fe4','5832d0065f53e2f','2016-11-30 20:07:02','globeadmin','2016-11-30 20:07:02','globeadmin','2018-01-09 18:51:25','globeadmin'),('583f15469941e13','5501dbedc785fe4','583a9ecc6d7c907','2016-11-30 20:07:02','globeadmin','2016-11-30 20:07:02','globeadmin','2018-01-09 18:51:21','globeadmin'),('583f1546a08e8b3','5501dbedc785fe4','58331f44ad5ba4e','2016-11-30 20:07:02','globeadmin','2016-11-30 20:07:02','globeadmin','2018-01-09 18:51:25','globeadmin'),('583f1546a7e182e','5501dbedc785fe4','582c94ea0c52b86','2016-11-30 20:07:02','globeadmin','2016-11-30 20:07:02','globeadmin','2018-01-09 18:51:21','globeadmin'),('583f154bcc7d5d7','5601afbc23dfb00','5831b9019b61979','2016-11-30 20:07:07','globeadmin','2016-11-30 20:07:07','globeadmin','2018-11-20 14:42:27','globeadmin'),('583f154bd3d0102','5601afbc23dfb00','58304c1fb6f7121','2016-11-30 20:07:07','globeadmin','2016-11-30 20:07:07','globeadmin','2018-11-20 14:42:25','globeadmin'),('583f154bdb23024','5601afbc23dfb00','5831f3f9cb4503b','2016-11-30 20:07:07','globeadmin','2016-11-30 20:07:07','globeadmin','2018-11-20 14:42:20','globeadmin'),('583f154be27ca6e','5601afbc23dfb00','5832d0065f53e2f','2016-11-30 20:07:07','globeadmin','2016-11-30 20:07:07','globeadmin','2018-11-20 14:42:27','globeadmin'),('583f154be9c915a','5601afbc23dfb00','583a9ecc6d7c907','2016-11-30 20:07:07','globeadmin','2016-11-30 20:07:07','globeadmin','2018-11-20 14:42:23','globeadmin'),('583f154bf11c2a6','5601afbc23dfb00','58331f44ad5ba4e','2016-11-30 20:07:07','globeadmin','2016-11-30 20:07:07','globeadmin','2018-11-20 14:42:26','globeadmin'),('583f154c044af9c','5601afbc23dfb00','582c94ea0c52b86','2016-11-30 20:07:08','globeadmin','2016-11-30 20:07:08','globeadmin','2018-11-20 14:42:23','globeadmin'),('584176094ba4e9b','5689468794353da','58304c1fb6f7121','2016-12-02 15:24:25','globeadmin','2016-12-02 15:24:25','globeadmin','2016-12-02 15:24:25','globeadmin'),('58417609444a5c1','5689468794353da','5831b9019b61979','2016-12-02 15:24:25','globeadmin','2016-12-02 15:24:25','globeadmin','2016-12-02 15:24:25','globeadmin'),('584175d7dbca612','547de3bee410196','5831b9019b61979','2016-12-02 15:23:35','globeadmin','2016-12-02 15:23:35','globeadmin','2022-01-31 16:18:47','globeadmin'),('584175d7e31d7eb','547de3bee410196','58304c1fb6f7121','2016-12-02 15:23:35','globeadmin','2016-12-02 15:23:35','globeadmin','2022-01-31 16:18:46','globeadmin'),('584175d7ea704f7','547de3bee410196','5831f3f9cb4503b','2016-12-02 15:23:35','globeadmin','2016-12-02 15:23:35','globeadmin','2022-01-31 16:18:44','globeadmin'),('584175d7f1c348a','547de3bee410196','5832d0065f53e2f','2016-12-02 15:23:35','globeadmin','2016-12-02 15:23:35','globeadmin','2022-01-31 16:18:46','globeadmin'),('584175d804f24f5','547de3bee410196','583a9ecc6d7c907','2016-12-02 15:23:36','globeadmin','2016-12-02 15:23:36','globeadmin','2022-01-31 16:18:45','globeadmin'),('584175d80c45794','547de3bee410196','58331f44ad5ba4e','2016-12-02 15:23:36','globeadmin','2016-12-02 15:23:36','globeadmin','2022-01-31 16:18:46','globeadmin'),('584175d81398649','547de3bee410196','582c94ea0c52b86','2016-12-02 15:23:36','globeadmin','2016-12-02 15:23:36','globeadmin','2022-01-31 16:18:45','globeadmin'),('5841760952f0347','5689468794353da','5831f3f9cb4503b','2016-12-02 15:24:25','globeadmin','2016-12-02 15:24:25','globeadmin','2016-12-02 15:24:25','globeadmin'),('584176095a43101','5689468794353da','5832d0065f53e2f','2016-12-02 15:24:25','globeadmin','2016-12-02 15:24:25','globeadmin','2016-12-02 15:24:25','globeadmin'),('584176096196364','5689468794353da','583a9ecc6d7c907','2016-12-02 15:24:25','globeadmin','2016-12-02 15:24:25','globeadmin','2016-12-02 15:24:25','globeadmin'),('5841760968e8ffb','5689468794353da','58331f44ad5ba4e','2016-12-02 15:24:25','globeadmin','2016-12-02 15:24:25','globeadmin','2016-12-02 15:24:25','globeadmin'),('58417609703bf2f','5689468794353da','582c94ea0c52b86','2016-12-02 15:24:25','globeadmin','2016-12-02 15:24:25','globeadmin','2016-12-02 15:24:25','globeadmin'),('58469c2cf1d0566','5601afbc23dfb00','58458875d6799f3','2016-12-06 13:08:28','globeadmin','2016-12-06 13:08:28','globeadmin','2018-11-20 14:42:24','globeadmin'),('58469c2fe59715c','5689468794353da','58458875d6799f3','2016-12-06 13:08:31','globeadmin','2016-12-06 13:08:31','globeadmin','2016-12-06 13:08:31','globeadmin'),('58469c33cfa651a','5717b9c74a31169','58458875d6799f3','2016-12-06 13:08:35','globeadmin','2016-12-06 13:08:35','globeadmin','2017-10-15 19:02:13','globeadmin'),('584bdd47290876d','547de3bee410196','584bdd251a7b996','2016-12-10 12:47:35','globeadmin','2016-12-10 12:47:35','globeadmin','2022-01-31 16:18:43','globeadmin'),('584bdd49528807e','547de3e001028e8','584bdd251a7b996','2016-12-10 12:47:37','globeadmin','2016-12-10 12:47:37','globeadmin','2019-11-06 15:15:11','globeadmin'),('584bdd4c72428af','5501dbedc785fe4','584bdd251a7b996','2016-12-10 12:47:40','globeadmin','2016-12-10 12:47:40','globeadmin','2018-01-09 18:51:15','globeadmin'),('584bdd4f1a5ca9b','5601afbc23dfb00','584bdd251a7b996','2016-12-10 12:47:43','globeadmin','2016-12-10 12:47:43','globeadmin','2018-11-20 14:42:16','globeadmin'),('584bdd535762cb5','5689468794353da','584bdd251a7b996','2016-12-10 12:47:47','globeadmin','2016-12-10 12:47:47','globeadmin','2016-12-10 12:47:47','globeadmin'),('59b03aeee429856','5689468794353da','59ac0890dc7beb0','2017-09-06 21:14:06','globeadmin','2017-09-06 21:14:06','globeadmin','2017-09-06 21:14:06','globeadmin'),('58e11e14f247e67','547de3bee410196','58e11da705d0093','2017-04-02 18:51:48','globeadmin','2017-04-02 18:51:48','globeadmin','2022-01-31 16:18:44','globeadmin'),('58e11e192ef97d8','5501dbedc785fe4','58e11da705d0093','2017-04-02 18:51:53','globeadmin','2017-04-02 18:51:53','globeadmin','2018-01-09 18:51:18','globeadmin'),('58e11e1c0a53c75','5601afbc23dfb00','58e11da705d0093','2017-04-02 18:51:56','globeadmin','2017-04-02 18:51:56','globeadmin','2018-11-20 14:42:19','globeadmin'),('58e16837e3a7b63','547de3bee410196','58e168017ad4042','2017-04-03 00:08:07','globeadmin','2017-04-03 00:08:07','globeadmin','2022-01-31 16:18:46','globeadmin'),('58e1683b1de44a7','5501dbedc785fe4','58e168017ad4042','2017-04-03 00:08:11','globeadmin','2017-04-03 00:08:11','globeadmin','2018-01-09 18:51:25','globeadmin'),('58e1683df249425','5601afbc23dfb00','58e168017ad4042','2017-04-03 00:08:13','globeadmin','2017-04-03 00:08:13','globeadmin','2018-11-20 14:42:27','globeadmin'),('59b03ae496102ca','547de3bee410196','59ac0890dc7beb0','2017-09-06 21:13:56','globeadmin','2017-09-06 21:13:56','globeadmin','2022-01-31 16:18:44','globeadmin'),('59b03ae1c955ff6','5717b9c74a31169','59ac0890dc7beb0','2017-09-06 21:13:53','globeadmin','2017-09-06 21:13:53','globeadmin','2017-10-15 19:02:11','globeadmin'),('59b03add7da983a','547de3fe0d36089','59ac0890dc7beb0','2017-09-06 21:13:49','globeadmin','2017-09-06 21:13:49','globeadmin','2019-07-01 11:07:04','globeadmin'),('59a6f4aaa0e5f48','547de3bee410196','5995b81c6de4f2e','2017-08-30 20:23:54','globeadmin','2017-08-30 20:23:54','globeadmin','2022-01-31 16:18:44','globeadmin'),('59a6f4aaa870673','547de3bee410196','599efd331c64642','2017-08-30 20:23:54','globeadmin','2017-08-30 20:23:54','globeadmin','2022-01-31 16:18:46','globeadmin'),('59a6f4aaaf8268b','547de3bee410196','59a17e291687ee8','2017-08-30 20:23:54','globeadmin','2017-08-30 20:23:54','globeadmin','2022-01-31 16:18:47','globeadmin'),('59a6f4aab6de998','547de3bee410196','59a29391abf2a01','2017-08-30 20:23:54','globeadmin','2017-08-30 20:23:54','globeadmin','2022-01-31 16:18:44','globeadmin'),('59a6f4afa826391','547de3e001028e8','5995b81c6de4f2e','2017-08-30 20:23:59','globeadmin','2017-08-30 20:23:59','globeadmin','2019-11-06 15:15:14','globeadmin'),('59a6f4afaf79180','547de3e001028e8','599efd331c64642','2017-08-30 20:23:59','globeadmin','2017-08-30 20:23:59','globeadmin','2019-11-06 15:15:18','globeadmin'),('59a6f4afb6cbfc4','547de3e001028e8','59a17e291687ee8','2017-08-30 20:23:59','globeadmin','2017-08-30 20:23:59','globeadmin','2019-11-06 15:15:20','globeadmin'),('59a6f4afbe1efe4','547de3e001028e8','59a29391abf2a01','2017-08-30 20:23:59','globeadmin','2017-08-30 20:23:59','globeadmin','2019-11-06 15:15:14','globeadmin'),('59a6f4b3922affa','5501dbedc785fe4','5995b81c6de4f2e','2017-08-30 20:24:03','globeadmin','2017-08-30 20:24:03','globeadmin','2018-01-09 18:51:18','globeadmin'),('59a6f4b3997ec1f','5501dbedc785fe4','599efd331c64642','2017-08-30 20:24:03','globeadmin','2017-08-30 20:24:03','globeadmin','2018-01-09 18:51:23','globeadmin'),('59a6f4b3a0d71b8','5501dbedc785fe4','59a17e291687ee8','2017-08-30 20:24:03','globeadmin','2017-08-30 20:24:03','globeadmin','2018-01-09 18:51:26','globeadmin'),('59a6f4b3a823eab','5501dbedc785fe4','59a29391abf2a01','2017-08-30 20:24:03','globeadmin','2017-08-30 20:24:03','globeadmin','2018-01-09 18:51:19','globeadmin'),('59a6f4b6ad04317','5601afbc23dfb00','5995b81c6de4f2e','2017-08-30 20:24:06','globeadmin','2017-08-30 20:24:06','globeadmin','2018-11-20 14:42:19','globeadmin'),('59a6f4b6b4575ff','5601afbc23dfb00','599efd331c64642','2017-08-30 20:24:06','globeadmin','2017-08-30 20:24:06','globeadmin','2018-11-20 14:42:24','globeadmin'),('59a6f4b6bbaa1c4','5601afbc23dfb00','59a17e291687ee8','2017-08-30 20:24:06','globeadmin','2017-08-30 20:24:06','globeadmin','2018-11-20 14:42:28','globeadmin'),('59a6f4b6c2fcfa9','5601afbc23dfb00','59a29391abf2a01','2017-08-30 20:24:06','globeadmin','2017-08-30 20:24:06','globeadmin','2018-11-20 14:42:20','globeadmin'),('59a6f4bc57944d0','5689468794353da','5995b81c6de4f2e','2017-08-30 20:24:12','globeadmin','2017-08-30 20:24:12','globeadmin','2017-08-30 20:24:12','globeadmin'),('59a6f4bc5ee0dd0','5689468794353da','599efd331c64642','2017-08-30 20:24:12','globeadmin','2017-08-30 20:24:12','globeadmin','2017-08-30 20:24:12','globeadmin'),('59a6f4bc6634344','5689468794353da','59a17e291687ee8','2017-08-30 20:24:12','globeadmin','2017-08-30 20:24:12','globeadmin','2017-08-30 20:24:12','globeadmin'),('59a6f4bc6d86d94','5689468794353da','59a29391abf2a01','2017-08-30 20:24:12','globeadmin','2017-08-30 20:24:12','globeadmin','2017-08-30 20:24:12','globeadmin'),('59b03aebdf49498','5601afbc23dfb00','59ac0890dc7beb0','2017-09-06 21:14:03','globeadmin','2017-09-06 21:14:03','globeadmin','2018-11-20 14:42:19','globeadmin'),('59a85fccd60e7a5','547de3bee410196','59a844651845ca6','2017-08-31 22:13:16','globeadmin','2017-08-31 22:13:16','globeadmin','2022-01-31 16:18:44','globeadmin'),('59a85fcf809c6ab','547de3e001028e8','59a844651845ca6','2017-08-31 22:13:19','globeadmin','2017-08-31 22:13:19','globeadmin','2019-11-06 15:15:14','globeadmin'),('59a85fd33759f7b','5501dbedc785fe4','59a844651845ca6','2017-08-31 22:13:23','globeadmin','2017-08-31 22:13:23','globeadmin','2018-01-09 18:51:19','globeadmin'),('59a85fd6438cf42','5601afbc23dfb00','59a844651845ca6','2017-08-31 22:13:26','globeadmin','2017-08-31 22:13:26','globeadmin','2018-11-20 14:42:20','globeadmin'),('59a85fda71ef690','5689468794353da','59a844651845ca6','2017-08-31 22:13:30','globeadmin','2017-08-31 22:13:30','globeadmin','2017-08-31 22:13:30','globeadmin'),('59b03ae93e2a6a5','5501dbedc785fe4','59ac0890dc7beb0','2017-09-06 21:14:01','globeadmin','2017-09-06 21:14:01','globeadmin','2018-01-09 18:51:18','globeadmin'),('59a9a9c21968a1a','547de3bee410196','59a97ae0711178e','2017-09-01 21:41:06','globeadmin','2017-09-01 21:41:06','globeadmin','2022-01-31 16:18:45','globeadmin'),('59a9a9c220bb415','547de3bee410196','59a9a9964302541','2017-09-01 21:41:06','globeadmin','2017-09-01 21:41:06','globeadmin','2022-01-31 16:18:46','globeadmin'),('59a9a9c8edcd5db','547de3e001028e8','59a97ae0711178e','2017-09-01 21:41:12','globeadmin','2017-09-01 21:41:12','globeadmin','2019-11-06 15:15:15','globeadmin'),('59a9a9c900fc554','547de3e001028e8','59a9a9964302541','2017-09-01 21:41:13','globeadmin','2017-09-01 21:41:13','globeadmin','2019-11-06 15:15:18','globeadmin'),('59a9a9cd873e9c0','5501dbedc785fe4','59a97ae0711178e','2017-09-01 21:41:17','globeadmin','2017-09-01 21:41:17','globeadmin','2018-01-09 18:51:20','globeadmin'),('59a9a9cd95e46e1','5501dbedc785fe4','59a9a9964302541','2017-09-01 21:41:17','globeadmin','2017-09-01 21:41:17','globeadmin','2018-01-09 18:51:23','globeadmin'),('59a9a9d09853c2b','5601afbc23dfb00','59a97ae0711178e','2017-09-01 21:41:20','globeadmin','2017-09-01 21:41:20','globeadmin','2018-11-20 14:42:21','globeadmin'),('59a9a9d09fa7fab','5601afbc23dfb00','59a9a9964302541','2017-09-01 21:41:20','globeadmin','2017-09-01 21:41:20','globeadmin','2018-11-20 14:42:24','globeadmin'),('59a9a9d49fa66d3','5689468794353da','59a97ae0711178e','2017-09-01 21:41:24','globeadmin','2017-09-01 21:41:24','globeadmin','2017-09-01 21:41:24','globeadmin'),('59a9a9d4a6f7b6b','5689468794353da','59a9a9964302541','2017-09-01 21:41:24','globeadmin','2017-09-01 21:41:24','globeadmin','2017-09-01 21:41:24','globeadmin'),('59b4ed030614249','547de3bee410196','59b447a587c9f81','2017-09-10 10:42:59','globeadmin','2017-09-10 10:42:59','globeadmin','2022-01-31 16:18:46','globeadmin'),('59b4ed067db1be9','547de3e001028e8','59b447a587c9f81','2017-09-10 10:43:02','globeadmin','2017-09-10 10:43:02','globeadmin','2019-11-06 15:15:19','globeadmin'),('59b4ed09717b09f','5501dbedc785fe4','59b447a587c9f81','2017-09-10 10:43:05','globeadmin','2017-09-10 10:43:05','globeadmin','2018-01-09 18:51:25','globeadmin'),('59b4ed0c2f8e982','5601afbc23dfb00','59b447a587c9f81','2017-09-10 10:43:08','globeadmin','2017-09-10 10:43:08','globeadmin','2018-11-20 14:42:26','globeadmin'),('59b4ed1247f5031','5689468794353da','59b447a587c9f81','2017-09-10 10:43:14','globeadmin','2017-09-10 10:43:14','globeadmin','2017-09-10 10:43:14','globeadmin'),('59c26dbe266d798','5501dbedc785fe4','59c268951ca99d5','2017-09-20 16:31:42','globeadmin','2017-09-20 16:31:42','globeadmin','2018-01-09 18:51:27','globeadmin'),('59c26dc24d7d2e9','5601afbc23dfb00','59c268951ca99d5','2017-09-20 16:31:46','globeadmin','2017-09-20 16:31:46','globeadmin','2018-11-20 14:42:28','globeadmin'),('59cf61bd09cc7df','547de3bee410196','59cf5a3a12fe151','2017-09-30 12:19:57','globeadmin','2017-09-30 12:19:57','globeadmin','2022-01-31 16:18:47','globeadmin'),('59cf61bfb4b0dab','547de3e001028e8','59cf5a3a12fe151','2017-09-30 12:19:59','globeadmin','2017-09-30 12:19:59','globeadmin','2019-11-06 15:15:21','globeadmin'),('59cf61c28d9ede6','547de3fe0d36089','59cf5a3a12fe151','2017-09-30 12:20:02','globeadmin','2017-09-30 12:20:02','globeadmin','2019-07-01 11:07:10','globeadmin'),('59cf61c524a2c31','5501dbedc785fe4','59cf5a3a12fe151','2017-09-30 12:20:05','globeadmin','2017-09-30 12:20:05','globeadmin','2018-01-09 18:51:27','globeadmin'),('59cf61c7e30fa86','5601afbc23dfb00','59cf5a3a12fe151','2017-09-30 12:20:07','globeadmin','2017-09-30 12:20:07','globeadmin','2018-11-20 14:42:29','globeadmin'),('59cf61cb3d08c83','5689468794353da','59cf5a3a12fe151','2017-09-30 12:20:11','globeadmin','2017-09-30 12:20:11','globeadmin','2017-09-30 12:20:11','globeadmin'),('59cf61ce09c22c1','5717b9c74a31169','59cf5a3a12fe151','2017-09-30 12:20:14','globeadmin','2017-09-30 12:20:14','globeadmin','2017-10-15 19:02:15','globeadmin'),('59d3626eca39d8e','5501dbedc785fe4','59d3619f0eb43b8','2017-10-03 13:11:58','globeadmin','2017-10-03 13:11:58','globeadmin','2018-01-09 18:51:19','globeadmin'),('59cff9119ad106d','547de3bee410196','59cfe983ac3c809','2017-09-30 23:05:37','globeadmin','2017-09-30 23:05:37','globeadmin','2022-01-31 16:18:47','globeadmin'),('59cff9140d36b1e','547de3e001028e8','59cfe983ac3c809','2017-09-30 23:05:40','globeadmin','2017-09-30 23:05:40','globeadmin','2019-11-06 15:15:20','globeadmin'),('59cff91716f741b','5501dbedc785fe4','59cfe983ac3c809','2017-09-30 23:05:43','globeadmin','2017-09-30 23:05:43','globeadmin','2018-01-09 18:51:26','globeadmin'),('59cff919d563d44','5601afbc23dfb00','59cfe983ac3c809','2017-09-30 23:05:45','globeadmin','2017-09-30 23:05:45','globeadmin','2018-11-20 14:42:27','globeadmin'),('59cff91dbf6885f','5689468794353da','59cfe983ac3c809','2017-09-30 23:05:49','globeadmin','2017-09-30 23:05:49','globeadmin','2017-09-30 23:05:49','globeadmin'),('59d2906c448b8d1','547de3bee410196','59d28f945fe6eab','2017-10-02 22:15:56','globeadmin','2017-10-02 22:15:56','globeadmin','2022-01-31 16:18:47','globeadmin'),('59d2906f8192230','5501dbedc785fe4','59d28f945fe6eab','2017-10-02 22:15:59','globeadmin','2017-10-02 22:15:59','globeadmin','2018-01-09 18:51:27','globeadmin'),('59d290730ed0d49','5601afbc23dfb00','59d28f945fe6eab','2017-10-02 22:16:03','globeadmin','2017-10-02 22:16:03','globeadmin','2018-11-20 14:42:28','globeadmin'),('59d296b4c70b361','547de3bee410196','59d29693d0e9c14','2017-10-02 22:42:44','globeadmin','2017-10-02 22:42:44','globeadmin','2022-01-31 16:18:47','globeadmin'),('59d296b98c70b3e','5501dbedc785fe4','59d29693d0e9c14','2017-10-02 22:42:49','globeadmin','2017-10-02 22:42:49','globeadmin','2018-01-09 18:51:27','globeadmin'),('59d296bc125d2c4','5601afbc23dfb00','59d29693d0e9c14','2017-10-02 22:42:52','globeadmin','2017-10-02 22:42:52','globeadmin','2018-11-20 14:42:28','globeadmin'),('59d3627221c35a1','5601afbc23dfb00','59d3619f0eb43b8','2017-10-03 13:12:02','globeadmin','2017-10-03 13:12:02','globeadmin','2018-11-20 14:42:20','globeadmin'),('59ecc31769d2056','5601afbc23dfb00','59ea53ae2bbc384','2017-10-22 19:11:03','globeadmin','2017-10-22 19:11:03','globeadmin','2018-11-20 14:42:28','globeadmin'),('59f88f55e69615b','547de3bee410196','59f84dae26c5aa0','2017-10-31 16:57:25','globeadmin','2017-10-31 16:57:25','globeadmin','2022-01-31 16:18:44','globeadmin'),('59feec649f44e21','547de3e001028e8','59fe057de3b97b4','2017-11-05 12:48:04','globeadmin','2017-11-05 12:48:04','globeadmin','2019-11-06 15:15:13','globeadmin'),('59f842403560f1c','547de3bee410196','59f840c19a6f621','2017-10-31 11:28:32','globeadmin','2017-10-31 11:28:32','globeadmin','2022-01-31 16:18:44','globeadmin'),('59eb9e79c18dd0d','547de3fe0d36089','59ea53ae2bbc384','2017-10-21 22:22:33','globeadmin','2017-10-21 22:22:33','globeadmin','2019-07-01 11:07:09','globeadmin'),('59eb9e79c8e0ac3','547de3fe0d36089','56d08b4c33c56c4','2017-10-21 22:22:33','globeadmin','2017-10-21 22:22:33','globeadmin','2019-07-01 11:07:08','globeadmin'),('59eb9e79d034b0b','547de3fe0d36089','59ea6f7db44655c','2017-10-21 22:22:33','globeadmin','2017-10-21 22:22:33','globeadmin','2019-07-01 11:07:09','globeadmin'),('59eb9e79d786ff5','547de3fe0d36089','59eb9e1160272cc','2017-10-21 22:22:33','globeadmin','2017-10-21 22:22:33','globeadmin','2019-07-01 11:07:03','globeadmin'),('59eb9e79dedfeb3','547de3fe0d36089','59eb2c8c6a0bf72','2017-10-21 22:22:33','globeadmin','2017-10-21 22:22:33','globeadmin','2019-07-01 11:07:09','globeadmin'),('59eb9e80784c38f','5717b9c74a31169','59ea53ae2bbc384','2017-10-21 22:22:40','globeadmin','2017-10-21 22:22:40','globeadmin','2017-10-21 22:22:40','globeadmin'),('59eb9e807f9e83c','5717b9c74a31169','56d08b4c33c56c4','2017-10-21 22:22:40','globeadmin','2017-10-21 22:22:40','globeadmin','2017-10-21 22:22:40','globeadmin'),('59eb9e8086f17e4','5717b9c74a31169','59ea6f7db44655c','2017-10-21 22:22:40','globeadmin','2017-10-21 22:22:40','globeadmin','2017-10-21 22:22:40','globeadmin'),('59eb9e808e44880','5717b9c74a31169','59eb9e1160272cc','2017-10-21 22:22:40','globeadmin','2017-10-21 22:22:40','globeadmin','2017-10-21 22:22:40','globeadmin'),('59eb9e80959e0ff','5717b9c74a31169','59eb2c8c6a0bf72','2017-10-21 22:22:40','globeadmin','2017-10-21 22:22:40','globeadmin','2017-10-21 22:22:40','globeadmin'),('59ecc317712bedb','5601afbc23dfb00','59eb9e1160272cc','2017-10-22 19:11:03','globeadmin','2017-10-22 19:11:03','globeadmin','2018-11-20 14:42:17','globeadmin'),('59ecb6c0ae89e1b','547de3fe0d36089','59ecb4b6b724284','2017-10-22 18:18:24','globeadmin','2017-10-22 18:18:24','globeadmin','2019-07-01 11:07:03','globeadmin'),('59ecb6c4961f311','5717b9c74a31169','59ecb4b6b724284','2017-10-22 18:18:28','globeadmin','2017-10-22 18:18:28','globeadmin','2017-10-22 18:18:28','globeadmin'),('59ecc3177877e88','5601afbc23dfb00','59eb9f11d245bfd','2017-10-22 19:11:03','globeadmin','2017-10-22 19:11:03','globeadmin','2018-11-20 14:42:16','globeadmin'),('59ecc3177fcb39c','5601afbc23dfb00','59e6312e9944cb9','2017-10-22 19:11:03','globeadmin','2017-10-22 19:11:03','globeadmin','2018-11-20 14:42:27','globeadmin'),('59ecc3211bac2f7','5501dbedc785fe4','59ea53ae2bbc384','2017-10-22 19:11:13','globeadmin','2017-10-22 19:11:13','globeadmin','2018-01-09 18:51:26','globeadmin'),('59ecc32122ff465','5501dbedc785fe4','59eb9e1160272cc','2017-10-22 19:11:13','globeadmin','2017-10-22 19:11:13','globeadmin','2018-01-09 18:51:16','globeadmin'),('59ecc3212a520a7','5501dbedc785fe4','59eb9f11d245bfd','2017-10-22 19:11:13','globeadmin','2017-10-22 19:11:13','globeadmin','2018-01-09 18:51:15','globeadmin'),('59ecc32131a5164','5501dbedc785fe4','59e6312e9944cb9','2017-10-22 19:11:13','globeadmin','2017-10-22 19:11:13','globeadmin','2018-01-09 18:51:26','globeadmin'),('59eed8b66626aac','5601afbc23dfb00','59ee65967ccd61f','2017-10-24 09:07:50','globeadmin','2017-10-24 09:07:50','globeadmin','2018-11-20 14:42:20','globeadmin'),('59eed8b66d798dd','5601afbc23dfb00','59ee6a061d547b1','2017-10-24 09:07:50','globeadmin','2017-10-24 09:07:50','globeadmin','2018-11-20 14:42:15','globeadmin'),('59eed8b959f0468','5501dbedc785fe4','59ee65967ccd61f','2017-10-24 09:07:53','globeadmin','2017-10-24 09:07:53','globeadmin','2018-01-09 18:51:19','globeadmin'),('59eed8b96149509','5501dbedc785fe4','59ee6a061d547b1','2017-10-24 09:07:53','globeadmin','2017-10-24 09:07:53','globeadmin','2018-01-09 18:51:15','globeadmin'),('59f88f55ede8bd4','547de3bee410196','59f878b4b35c111','2017-10-31 16:57:25','globeadmin','2017-10-31 16:57:25','globeadmin','2022-01-31 16:18:43','globeadmin'),('59f84244ccbbc48','5501dbedc785fe4','59f840c19a6f621','2017-10-31 11:28:36','globeadmin','2017-10-31 11:28:36','globeadmin','2018-01-09 18:51:19','globeadmin'),('59f84247e523d9b','5601afbc23dfb00','59f840c19a6f621','2017-10-31 11:28:39','globeadmin','2017-10-31 11:28:39','globeadmin','2018-11-20 14:42:20','globeadmin'),('59feec61512737a','547de3bee410196','59fe057de3b97b4','2017-11-05 12:48:01','globeadmin','2017-11-05 12:48:01','globeadmin','2022-01-31 16:18:43','globeadmin'),('59f8244985b139d','547de3bee410196','59ea53ae2bbc384','2017-10-31 09:20:41','globeadmin','2017-10-31 09:20:41','globeadmin','2022-01-31 16:18:47','globeadmin'),('59f824498d0449b','547de3bee410196','59eb9e1160272cc','2017-10-31 09:20:41','globeadmin','2017-10-31 09:20:41','globeadmin','2022-01-31 16:18:43','globeadmin'),('59f8244994571ae','547de3bee410196','59eb9f11d245bfd','2017-10-31 09:20:41','globeadmin','2017-10-31 09:20:41','globeadmin','2022-01-31 16:18:43','globeadmin'),('59f824499baf5d7','547de3bee410196','59e6312e9944cb9','2017-10-31 09:20:41','globeadmin','2017-10-31 09:20:41','globeadmin','2022-01-31 16:18:47','globeadmin'),('59f82449a2fb7b6','547de3bee410196','59ee65967ccd61f','2017-10-31 09:20:41','globeadmin','2017-10-31 09:20:41','globeadmin','2022-01-31 16:18:44','globeadmin'),('59f82449aa4e672','547de3bee410196','59ee6a061d547b1','2017-10-31 09:20:41','globeadmin','2017-10-31 09:20:41','globeadmin','2022-01-31 16:18:43','globeadmin'),('59f82449b1a145c','547de3bee410196','59f2469383bbd98','2017-10-31 09:20:41','globeadmin','2017-10-31 09:20:41','globeadmin','2022-01-31 16:18:43','globeadmin'),('59f82449b8f487a','547de3bee410196','59f4d865bbf74c4','2017-10-31 09:20:41','globeadmin','2017-10-31 09:20:41','globeadmin','2022-01-31 16:18:47','globeadmin'),('59f82449c047537','547de3bee410196','59f5e72d606d247','2017-10-31 09:20:41','globeadmin','2017-10-31 09:20:41','globeadmin','2022-01-31 16:18:44','globeadmin'),('59f82449c79a956','547de3bee410196','59f5e965a0dd38c','2017-10-31 09:20:41','globeadmin','2017-10-31 09:20:41','globeadmin','2022-01-31 16:18:46','globeadmin'),('59f8244d7e59fa0','547de3e001028e8','59ea53ae2bbc384','2017-10-31 09:20:45','globeadmin','2017-10-31 09:20:45','globeadmin','2019-11-06 15:15:20','globeadmin'),('59f8244d85acde6','547de3e001028e8','59eb9e1160272cc','2017-10-31 09:20:45','globeadmin','2017-10-31 09:20:45','globeadmin','2019-11-06 15:15:12','globeadmin'),('59f8244d8cfffcb','547de3e001028e8','59eb9f11d245bfd','2017-10-31 09:20:45','globeadmin','2017-10-31 09:20:45','globeadmin','2019-11-06 15:15:12','globeadmin'),('59f8244d9453af3','547de3e001028e8','59e6312e9944cb9','2017-10-31 09:20:45','globeadmin','2017-10-31 09:20:45','globeadmin','2019-11-06 15:15:20','globeadmin'),('59f8244d9bac122','547de3e001028e8','59ee65967ccd61f','2017-10-31 09:20:45','globeadmin','2017-10-31 09:20:45','globeadmin','2019-11-06 15:15:14','globeadmin'),('59f8244da2f8bcc','547de3e001028e8','59ee6a061d547b1','2017-10-31 09:20:45','globeadmin','2017-10-31 09:20:45','globeadmin','2019-11-06 15:15:11','globeadmin'),('59f8244daa4c044','547de3e001028e8','59f2469383bbd98','2017-10-31 09:20:45','globeadmin','2017-10-31 09:20:45','globeadmin','2019-11-06 15:15:12','globeadmin'),('59f8244db19ebdc','547de3e001028e8','59f4d865bbf74c4','2017-10-31 09:20:45','globeadmin','2017-10-31 09:20:45','globeadmin','2019-11-06 15:15:19','globeadmin'),('59f8244db8f1b33','547de3e001028e8','59f5e72d606d247','2017-10-31 09:20:45','globeadmin','2017-10-31 09:20:45','globeadmin','2019-11-06 15:15:14','globeadmin'),('59f8244dc044ef3','547de3e001028e8','59f5e965a0dd38c','2017-10-31 09:20:45','globeadmin','2017-10-31 09:20:45','globeadmin','2019-11-06 15:15:18','globeadmin'),('59f82450b67ecbc','5501dbedc785fe4','59f2469383bbd98','2017-10-31 09:20:48','globeadmin','2017-10-31 09:20:48','globeadmin','2018-01-09 18:51:16','globeadmin'),('59f82450bdd256d','5501dbedc785fe4','59f4d865bbf74c4','2017-10-31 09:20:48','globeadmin','2017-10-31 09:20:48','globeadmin','2018-01-09 18:51:26','globeadmin'),('59f82450c525058','5501dbedc785fe4','59f5e72d606d247','2017-10-31 09:20:48','globeadmin','2017-10-31 09:20:48','globeadmin','2018-01-09 18:51:19','globeadmin'),('59f82450cc7f21f','5501dbedc785fe4','59f5e965a0dd38c','2017-10-31 09:20:48','globeadmin','2017-10-31 09:20:48','globeadmin','2018-01-09 18:51:24','globeadmin'),('59f8245485aa05f','5601afbc23dfb00','59f2469383bbd98','2017-10-31 09:20:52','globeadmin','2017-10-31 09:20:52','globeadmin','2018-11-20 14:42:16','globeadmin'),('59f824548cfd68c','5601afbc23dfb00','59f4d865bbf74c4','2017-10-31 09:20:52','globeadmin','2017-10-31 09:20:52','globeadmin','2018-11-20 14:42:27','globeadmin'),('59f82454944eb6f','5601afbc23dfb00','59f5e72d606d247','2017-10-31 09:20:52','globeadmin','2017-10-31 09:20:52','globeadmin','2018-11-20 14:42:20','globeadmin'),('59f824549ba7b8c','5601afbc23dfb00','59f5e965a0dd38c','2017-10-31 09:20:52','globeadmin','2017-10-31 09:20:52','globeadmin','2018-11-20 14:42:25','globeadmin'),('59f82457e74e343','5689468794353da','59ea53ae2bbc384','2017-10-31 09:20:55','globeadmin','2017-10-31 09:20:55','globeadmin','2017-10-31 09:20:55','globeadmin'),('59f82457eea1da0','5689468794353da','59eb9e1160272cc','2017-10-31 09:20:55','globeadmin','2017-10-31 09:20:55','globeadmin','2017-10-31 09:20:55','globeadmin'),('59f8245801d019a','5689468794353da','59eb9f11d245bfd','2017-10-31 09:20:56','globeadmin','2017-10-31 09:20:56','globeadmin','2017-10-31 09:20:56','globeadmin'),('59f824580929bd8','5689468794353da','59e6312e9944cb9','2017-10-31 09:20:56','globeadmin','2017-10-31 09:20:56','globeadmin','2017-10-31 09:20:56','globeadmin'),('59f824581076000','5689468794353da','59ee65967ccd61f','2017-10-31 09:20:56','globeadmin','2017-10-31 09:20:56','globeadmin','2017-10-31 09:20:56','globeadmin'),('59f8245817c9162','5689468794353da','59ee6a061d547b1','2017-10-31 09:20:56','globeadmin','2017-10-31 09:20:56','globeadmin','2017-10-31 09:20:56','globeadmin'),('59f824581f1c3a7','5689468794353da','59f2469383bbd98','2017-10-31 09:20:56','globeadmin','2017-10-31 09:20:56','globeadmin','2017-10-31 09:20:56','globeadmin'),('59f82458266ef4d','5689468794353da','59f4d865bbf74c4','2017-10-31 09:20:56','globeadmin','2017-10-31 09:20:56','globeadmin','2017-10-31 09:20:56','globeadmin'),('59f824582dc276f','5689468794353da','59f5e72d606d247','2017-10-31 09:20:56','globeadmin','2017-10-31 09:20:56','globeadmin','2017-10-31 09:20:56','globeadmin'),('59f824583515f36','5689468794353da','59f5e965a0dd38c','2017-10-31 09:20:56','globeadmin','2017-10-31 09:20:56','globeadmin','2017-10-31 09:20:56','globeadmin'),('59f88f560116335','547de3bee410196','59f88affdd8e424','2017-10-31 16:57:26','globeadmin','2017-10-31 16:57:26','globeadmin','2022-01-31 16:18:46','globeadmin'),('59f88f5cd09dc84','5501dbedc785fe4','59f84dae26c5aa0','2017-10-31 16:57:32','globeadmin','2017-10-31 16:57:32','globeadmin','2018-01-09 18:51:18','globeadmin'),('59f88f5cd7e9f69','5501dbedc785fe4','59f878b4b35c111','2017-10-31 16:57:32','globeadmin','2017-10-31 16:57:32','globeadmin','2018-01-09 18:51:15','globeadmin'),('59f88f5cdf3ccf3','5501dbedc785fe4','59f88affdd8e424','2017-10-31 16:57:32','globeadmin','2017-10-31 16:57:32','globeadmin','2018-01-09 18:51:23','globeadmin'),('59f88f601e5c37f','5601afbc23dfb00','59f84dae26c5aa0','2017-10-31 16:57:36','globeadmin','2017-10-31 16:57:36','globeadmin','2018-11-20 14:42:19','globeadmin'),('59f88f6025b55f1','5601afbc23dfb00','59f878b4b35c111','2017-10-31 16:57:36','globeadmin','2017-10-31 16:57:36','globeadmin','2018-11-20 14:42:16','globeadmin'),('59f88f602d01c5b','5601afbc23dfb00','59f88affdd8e424','2017-10-31 16:57:36','globeadmin','2017-10-31 16:57:36','globeadmin','2018-11-20 14:42:25','globeadmin'),('59feec675122e1a','5501dbedc785fe4','59fe057de3b97b4','2017-11-05 12:48:07','globeadmin','2017-11-05 12:48:07','globeadmin','2018-01-09 18:51:17','globeadmin'),('59feec69c16f43a','5601afbc23dfb00','59fe057de3b97b4','2017-11-05 12:48:09','globeadmin','2017-11-05 12:48:09','globeadmin','2018-11-20 14:42:18','globeadmin'),('59feec6e3b25384','5689468794353da','59fe057de3b97b4','2017-11-05 12:48:14','globeadmin','2017-11-05 12:48:14','globeadmin','2017-11-05 12:48:14','globeadmin'),('5a084f8dca40578','547de3bee410196','5a084a0d4a2a6e6','2017-11-12 15:41:33','globeadmin','2017-11-12 15:41:33','globeadmin','2022-01-31 16:18:43','globeadmin'),('5a084f917e8ed43','547de3e001028e8','5a084a0d4a2a6e6','2017-11-12 15:41:37','globeadmin','2017-11-12 15:41:37','globeadmin','2019-11-06 15:15:12','globeadmin'),('5a084f9474c9084','547de3fe0d36089','5a084a0d4a2a6e6','2017-11-12 15:41:40','globeadmin','2017-11-12 15:41:40','globeadmin','2019-07-01 11:07:03','globeadmin'),('5a084fa09e41bbe','5501dbedc785fe4','5a084a0d4a2a6e6','2017-11-12 15:41:52','globeadmin','2017-11-12 15:41:52','globeadmin','2018-01-09 18:51:16','globeadmin'),('5a084fa3cca292e','5601afbc23dfb00','5a084a0d4a2a6e6','2017-11-12 15:41:55','globeadmin','2017-11-12 15:41:55','globeadmin','2018-11-20 14:42:17','globeadmin'),('5a084fa7ace2f9d','5689468794353da','5a084a0d4a2a6e6','2017-11-12 15:41:59','globeadmin','2017-11-12 15:41:59','globeadmin','2017-11-12 15:41:59','globeadmin'),('5a084fb0aa6c1ee','5717b9c74a31169','5a084a0d4a2a6e6','2017-11-12 15:42:08','globeadmin','2017-11-12 15:42:08','globeadmin','2017-11-12 15:42:08','globeadmin'),('5a12eadae222a10','547de3bee410196','5a12e752e9655e6','2017-11-20 16:46:50','globeadmin','2017-11-20 16:46:50','globeadmin','2022-01-31 16:18:44','globeadmin'),('5a12eadec2630a4','547de3e001028e8','5a12e752e9655e6','2017-11-20 16:46:54','globeadmin','2017-11-20 16:46:54','globeadmin','2019-11-06 15:15:15','globeadmin'),('5a109d6dc9a9c64','5501dbedc785fe4','5a109cd88f731e7','2017-11-18 22:51:57','globeadmin','2017-11-18 22:51:57','globeadmin','2018-01-09 18:51:21','globeadmin'),('5a109d6dd0fc237','5501dbedc785fe4','5a109cea54d2823','2017-11-18 22:51:57','globeadmin','2017-11-18 22:51:57','globeadmin','2018-01-09 18:51:21','globeadmin'),('5a109d6dd84f3d8','5501dbedc785fe4','5a109cfa4fed6f9','2017-11-18 22:51:57','globeadmin','2017-11-18 22:51:57','globeadmin','2018-01-09 18:51:21','globeadmin'),('5a109d7860a6d96','5601afbc23dfb00','5a109cd88f731e7','2017-11-18 22:52:08','globeadmin','2017-11-18 22:52:08','globeadmin','2018-11-20 14:42:22','globeadmin'),('5a109d7867f9b82','5601afbc23dfb00','5a109cea54d2823','2017-11-18 22:52:08','globeadmin','2017-11-18 22:52:08','globeadmin','2018-11-20 14:42:22','globeadmin'),('5a109d786f4cbbd','5601afbc23dfb00','5a109cfa4fed6f9','2017-11-18 22:52:08','globeadmin','2017-11-18 22:52:08','globeadmin','2018-11-20 14:42:22','globeadmin'),('5a12eae1c9b4d3f','5501dbedc785fe4','5a12e752e9655e6','2017-11-20 16:46:57','globeadmin','2017-11-20 16:46:57','globeadmin','2018-01-09 18:51:20','globeadmin'),('5a12eae54f9ffb0','5601afbc23dfb00','5a12e752e9655e6','2017-11-20 16:47:01','globeadmin','2017-11-20 16:47:01','globeadmin','2018-11-20 14:42:21','globeadmin'),('5a12eaea743b2d5','5689468794353da','5a12e752e9655e6','2017-11-20 16:47:06','globeadmin','2017-11-20 16:47:06','globeadmin','2017-11-20 16:47:06','globeadmin'),('5a58600b4234e52','547de3bee410196','5a585e7b93e7cfa','2018-01-12 09:13:15','globeadmin','2018-01-12 09:13:15','globeadmin','2022-01-31 16:18:43','globeadmin'),('5a2c2739668d117','547de3bee410196','5a2becd4c30f6d1','2017-12-09 20:11:05','globeadmin','2017-12-09 20:11:05','globeadmin','2022-01-31 16:18:44','globeadmin'),('5a2c273cc350416','547de3e001028e8','5a2becd4c30f6d1','2017-12-09 20:11:08','globeadmin','2017-12-09 20:11:08','globeadmin','2019-11-06 15:15:14','globeadmin'),('5a2c27435f39709','5501dbedc785fe4','5a2becd4c30f6d1','2017-12-09 20:11:15','globeadmin','2017-12-09 20:11:15','globeadmin','2018-01-09 18:51:19','globeadmin'),('5a2c2746cd0c1c2','5601afbc23dfb00','5a2becd4c30f6d1','2017-12-09 20:11:18','globeadmin','2017-12-09 20:11:18','globeadmin','2018-11-20 14:42:20','globeadmin'),('5a2c274c026522f','5689468794353da','5a2becd4c30f6d1','2017-12-09 20:11:24','globeadmin','2017-12-09 20:11:24','globeadmin','2017-12-09 20:11:24','globeadmin'),('5a2c278a30980b3','547de3bee410196','5a28162b9f2ddc4','2017-12-09 20:12:26','globeadmin','2017-12-09 20:12:26','globeadmin','2022-01-31 16:18:43','globeadmin'),('5a2c278d61696e7','547de3e001028e8','5a28162b9f2ddc4','2017-12-09 20:12:29','globeadmin','2017-12-09 20:12:29','globeadmin','2019-11-06 15:15:12','globeadmin'),('5a2c27911f7b905','5501dbedc785fe4','5a28162b9f2ddc4','2017-12-09 20:12:33','globeadmin','2017-12-09 20:12:33','globeadmin','2018-01-09 18:51:16','globeadmin'),('5a2c27958602405','5601afbc23dfb00','5a28162b9f2ddc4','2017-12-09 20:12:37','globeadmin','2017-12-09 20:12:37','globeadmin','2018-11-20 14:42:17','globeadmin'),('5a2c279a8fcbc15','5689468794353da','5a28162b9f2ddc4','2017-12-09 20:12:42','globeadmin','2017-12-09 20:12:42','globeadmin','2017-12-09 20:12:42','globeadmin'),('5a36912b348570b','547de3bee410196','5a3690cc1299b0a','2017-12-17 17:45:47','globeadmin','2017-12-17 17:45:47','globeadmin','2022-01-31 16:18:44','globeadmin'),('5a36912b3bde935','547de3bee410196','5a36908c39d6562','2017-12-17 17:45:47','globeadmin','2017-12-17 17:45:47','globeadmin','2022-01-31 16:18:44','globeadmin'),('5a36912ea9b26dd','547de3e001028e8','5a3690cc1299b0a','2017-12-17 17:45:50','globeadmin','2017-12-17 17:45:50','globeadmin','2019-11-06 15:15:15','globeadmin'),('5a36912eb10505e','547de3e001028e8','5a36908c39d6562','2017-12-17 17:45:50','globeadmin','2017-12-17 17:45:50','globeadmin','2019-11-06 15:15:15','globeadmin'),('5a3691327188b9c','5501dbedc785fe4','5a3690cc1299b0a','2017-12-17 17:45:54','globeadmin','2017-12-17 17:45:54','globeadmin','2018-01-09 18:51:20','globeadmin'),('5a36913278db715','5501dbedc785fe4','5a36908c39d6562','2017-12-17 17:45:54','globeadmin','2017-12-17 17:45:54','globeadmin','2018-01-09 18:51:20','globeadmin'),('5a3691353bd7913','5601afbc23dfb00','5a3690cc1299b0a','2017-12-17 17:45:57','globeadmin','2017-12-17 17:45:57','globeadmin','2018-11-20 14:42:21','globeadmin'),('5a369135432392f','5601afbc23dfb00','5a36908c39d6562','2017-12-17 17:45:57','globeadmin','2017-12-17 17:45:57','globeadmin','2018-11-20 14:42:21','globeadmin'),('5a369139c216186','5689468794353da','5a3690cc1299b0a','2017-12-17 17:46:01','globeadmin','2017-12-17 17:46:01','globeadmin','2017-12-17 17:46:01','globeadmin'),('5a369139c969045','5689468794353da','5a36908c39d6562','2017-12-17 17:46:01','globeadmin','2017-12-17 17:46:01','globeadmin','2017-12-17 17:46:01','globeadmin'),('5a527e84d3214df','5501dbedc785fe4','5a5273258ad81dd','2018-01-07 22:09:40','globeadmin','2018-01-07 22:09:40','globeadmin','2018-01-09 18:51:23','globeadmin'),('5a527e87395398a','5601afbc23dfb00','5a5273258ad81dd','2018-01-07 22:09:43','globeadmin','2018-01-07 22:09:43','globeadmin','2018-11-20 14:42:24','globeadmin'),('5a527e8c2d181f7','5689468794353da','5a5273258ad81dd','2018-01-07 22:09:48','globeadmin','2018-01-07 22:09:48','globeadmin','2018-01-07 22:09:48','globeadmin'),('5a4f5cbb625323a','547de3e001028e8','5a4f4833bacfc5c','2018-01-05 13:08:43','globeadmin','2018-01-05 13:08:43','globeadmin','2019-11-06 15:15:16','globeadmin'),('5a4f5cbe64c05d1','5501dbedc785fe4','5a4f4833bacfc5c','2018-01-05 13:08:46','globeadmin','2018-01-05 13:08:46','globeadmin','2018-01-09 18:51:22','globeadmin'),('5a4f5cc169a06d0','5601afbc23dfb00','5a4f4833bacfc5c','2018-01-05 13:08:49','globeadmin','2018-01-05 13:08:49','globeadmin','2018-11-20 14:42:23','globeadmin'),('5a4f5cc4b7bf4bb','5689468794353da','5a47ce353542e1e','2018-01-05 13:08:52','globeadmin','2018-01-05 13:08:52','globeadmin','2018-01-05 13:08:52','globeadmin'),('5a58600f7305e28','5501dbedc785fe4','5a585e7b93e7cfa','2018-01-12 09:13:19','globeadmin','2018-01-12 09:13:19','globeadmin','2018-01-12 09:13:19','globeadmin'),('5a4f5cc4bf13257','5689468794353da','5a4f4833bacfc5c','2018-01-05 13:08:52','globeadmin','2018-01-05 13:08:52','globeadmin','2018-01-05 13:08:52','globeadmin'),('5a527e7eb84b766','547de3bee410196','5a5273258ad81dd','2018-01-07 22:09:34','globeadmin','2018-01-07 22:09:34','globeadmin','2022-01-31 16:18:45','globeadmin'),('5a78d656edf1688','547de3bee410196','5a788f06d54e1a2','2018-02-06 00:10:30','globeadmin','2018-02-06 00:10:30','globeadmin','2022-01-31 16:18:43','globeadmin'),('5a4f5cb25fee338','547de3bee410196','5a47ce353542e1e','2018-01-05 13:08:34','globeadmin','2018-01-05 13:08:34','globeadmin','2022-01-31 16:18:43','globeadmin'),('5a4f5cb267396f1','547de3bee410196','5a4f4833bacfc5c','2018-01-05 13:08:34','globeadmin','2018-01-05 13:08:34','globeadmin','2022-01-31 16:18:45','globeadmin'),('5a4f5cbb5afe8e0','547de3e001028e8','5a47ce353542e1e','2018-01-05 13:08:43','globeadmin','2018-01-05 13:08:43','globeadmin','2019-11-06 15:15:12','globeadmin'),('5a527e8234773b0','547de3e001028e8','5a5273258ad81dd','2018-01-07 22:09:38','globeadmin','2018-01-07 22:09:38','globeadmin','2019-11-06 15:15:17','globeadmin'),('5a4a03269fe5f9e','5501dbedc785fe4','5a36b672b84479b','2018-01-01 11:45:10','globeadmin','2018-01-01 11:45:10','globeadmin','2018-01-09 18:51:19','globeadmin'),('5a4a0326a732ac2','5501dbedc785fe4','5a3c17afa650e8f','2018-01-01 11:45:10','globeadmin','2018-01-01 11:45:10','globeadmin','2018-01-09 18:51:21','globeadmin'),('5a4a0326ae8762a','5501dbedc785fe4','5a37c77e5107316','2018-01-01 11:45:10','globeadmin','2018-01-01 11:45:10','globeadmin','2018-01-09 18:51:19','globeadmin'),('5a4a0326b5d9d06','5501dbedc785fe4','5a48d4e8ce664c8','2018-01-01 11:45:10','globeadmin','2018-01-01 11:45:10','globeadmin','2018-01-09 18:51:28','globeadmin'),('5a4a0326bd2c0b5','5501dbedc785fe4','5a3d4ce3031112d','2018-01-01 11:45:10','globeadmin','2018-01-01 11:45:10','globeadmin','2018-01-09 18:51:28','globeadmin'),('5a4a0326c48058c','5501dbedc785fe4','5a41416ba57ab7e','2018-01-01 11:45:10','globeadmin','2018-01-01 11:45:10','globeadmin','2018-01-09 18:51:16','globeadmin'),('5a4a0326cbd25eb','5501dbedc785fe4','5a413f9ddeeef6a','2018-01-01 11:45:10','globeadmin','2018-01-01 11:45:10','globeadmin','2018-01-09 18:51:16','globeadmin'),('5a4a0326d325d35','5501dbedc785fe4','5a464a6044084ff','2018-01-01 11:45:10','globeadmin','2018-01-01 11:45:10','globeadmin','2018-01-09 18:51:15','globeadmin'),('5a4a0326da77621','5501dbedc785fe4','5a48f33613f2b2b','2018-01-01 11:45:10','globeadmin','2018-01-01 11:45:10','globeadmin','2018-01-09 18:51:29','globeadmin'),('5a4a0326e1cbb4e','5501dbedc785fe4','5a48f38d2e8d6bd','2018-01-01 11:45:10','globeadmin','2018-01-01 11:45:10','globeadmin','2018-01-09 18:51:29','globeadmin'),('5a4a0326e923e9f','5501dbedc785fe4','5a4a001d391cfa4','2018-01-01 11:45:10','globeadmin','2018-01-01 11:45:10','globeadmin','2018-01-09 18:51:16','globeadmin'),('5a4a0326f071eb0','5501dbedc785fe4','5a43e2feb23700e','2018-01-01 11:45:10','globeadmin','2018-01-01 11:45:10','globeadmin','2018-01-09 18:51:15','globeadmin'),('5a4a0327039f46f','5501dbedc785fe4','5a47ce353542e1e','2018-01-01 11:45:11','globeadmin','2018-01-01 11:45:11','globeadmin','2018-01-09 18:51:15','globeadmin'),('5a4a03270af6d35','5501dbedc785fe4','5a453233d2245ec','2018-01-01 11:45:11','globeadmin','2018-01-01 11:45:11','globeadmin','2018-01-09 18:51:15','globeadmin'),('5a4a032cda737d4','5601afbc23dfb00','5a36b672b84479b','2018-01-01 11:45:16','globeadmin','2018-01-01 11:45:16','globeadmin','2018-11-20 14:42:20','globeadmin'),('5a4a032ce1c7708','5601afbc23dfb00','5a3c17afa650e8f','2018-01-01 11:45:16','globeadmin','2018-01-01 11:45:16','globeadmin','2018-11-20 14:42:22','globeadmin'),('5a4a032ce91f58a','5601afbc23dfb00','5a37c77e5107316','2018-01-01 11:45:16','globeadmin','2018-01-01 11:45:16','globeadmin','2018-11-20 14:42:20','globeadmin'),('5a4a032cf06d738','5601afbc23dfb00','5a48d4e8ce664c8','2018-01-01 11:45:16','globeadmin','2018-01-01 11:45:16','globeadmin','2018-11-20 14:42:30','globeadmin'),('5a4a032d039aeff','5601afbc23dfb00','5a3d4ce3031112d','2018-01-01 11:45:17','globeadmin','2018-01-01 11:45:17','globeadmin','2018-11-20 14:42:30','globeadmin'),('5a4a032d0aefaaf','5601afbc23dfb00','5a41416ba57ab7e','2018-01-01 11:45:17','globeadmin','2018-01-01 11:45:17','globeadmin','2018-11-20 14:42:17','globeadmin'),('5a4a032d124155f','5601afbc23dfb00','5a413f9ddeeef6a','2018-01-01 11:45:17','globeadmin','2018-01-01 11:45:17','globeadmin','2018-11-20 14:42:17','globeadmin'),('5a4a032d199563f','5601afbc23dfb00','5a464a6044084ff','2018-01-01 11:45:17','globeadmin','2018-01-01 11:45:17','globeadmin','2018-11-20 14:42:16','globeadmin'),('5a4a032d20e74ae','5601afbc23dfb00','5a48f33613f2b2b','2018-01-01 11:45:17','globeadmin','2018-01-01 11:45:17','globeadmin','2018-11-20 14:42:30','globeadmin'),('5a4a032d283bdc2','5601afbc23dfb00','5a48f38d2e8d6bd','2018-01-01 11:45:17','globeadmin','2018-01-01 11:45:17','globeadmin','2018-11-20 14:42:30','globeadmin'),('5a4a032d2f8cb6a','5601afbc23dfb00','5a4a001d391cfa4','2018-01-01 11:45:17','globeadmin','2018-01-01 11:45:17','globeadmin','2018-11-20 14:42:17','globeadmin'),('5a4a032d36e16a9','5601afbc23dfb00','5a43e2feb23700e','2018-01-01 11:45:17','globeadmin','2018-01-01 11:45:17','globeadmin','2018-11-20 14:42:16','globeadmin'),('5a4a032d3e38f47','5601afbc23dfb00','5a47ce353542e1e','2018-01-01 11:45:17','globeadmin','2018-01-01 11:45:17','globeadmin','2018-11-20 14:42:16','globeadmin'),('5a4a032d4587f4e','5601afbc23dfb00','5a453233d2245ec','2018-01-01 11:45:17','globeadmin','2018-01-01 11:45:17','globeadmin','2018-11-20 14:42:16','globeadmin'),('5a58601700417bf','5601afbc23dfb00','5a585e7b93e7cfa','2018-01-12 09:13:27','globeadmin','2018-01-12 09:13:27','globeadmin','2018-11-20 14:42:17','globeadmin'),('5a58601be0d9e95','5689468794353da','5a585e7b93e7cfa','2018-01-12 09:13:31','globeadmin','2018-01-12 09:13:31','globeadmin','2018-01-12 09:13:31','globeadmin'),('5a60d461be4dc08','547de3bee410196','5a60ab1d143a8e7','2018-01-18 19:07:45','globeadmin','2018-01-18 19:07:45','globeadmin','2022-01-31 16:18:43','globeadmin'),('5a60d461c5a0c6e','547de3bee410196','5a60719e03a40ca','2018-01-18 19:07:45','globeadmin','2018-01-18 19:07:45','globeadmin','2022-01-31 16:18:44','globeadmin'),('5a60d4665a3135d','547de3e001028e8','5a60ab1d143a8e7','2018-01-18 19:07:50','globeadmin','2018-01-18 19:07:50','globeadmin','2019-11-06 15:15:12','globeadmin'),('5a60d4666184480','547de3e001028e8','5a60719e03a40ca','2018-01-18 19:07:50','globeadmin','2018-01-18 19:07:50','globeadmin','2019-11-06 15:15:13','globeadmin'),('5a60d46aa36c087','5501dbedc785fe4','5a60ab1d143a8e7','2018-01-18 19:07:54','globeadmin','2018-01-18 19:07:54','globeadmin','2018-01-18 19:07:54','globeadmin'),('5a60d46aaabf4eb','5501dbedc785fe4','5a60719e03a40ca','2018-01-18 19:07:54','globeadmin','2018-01-18 19:07:54','globeadmin','2018-01-18 19:07:54','globeadmin'),('5a60d46db20fe04','5601afbc23dfb00','5a60ab1d143a8e7','2018-01-18 19:07:57','globeadmin','2018-01-18 19:07:57','globeadmin','2018-11-20 14:42:16','globeadmin'),('5a60d46db96314a','5601afbc23dfb00','5a60719e03a40ca','2018-01-18 19:07:57','globeadmin','2018-01-18 19:07:57','globeadmin','2018-11-20 14:42:18','globeadmin'),('5a60d472073d45f','5689468794353da','5a60ab1d143a8e7','2018-01-18 19:08:02','globeadmin','2018-01-18 19:08:02','globeadmin','2018-01-18 19:08:02','globeadmin'),('5a60d4720e7fcd1','5689468794353da','5a60719e03a40ca','2018-01-18 19:08:02','globeadmin','2018-01-18 19:08:02','globeadmin','2018-01-18 19:08:02','globeadmin'),('5a78d65a4a4ca27','547de3e001028e8','5a788f06d54e1a2','2018-02-06 00:10:34','globeadmin','2018-02-06 00:10:34','globeadmin','2019-11-06 15:15:12','globeadmin'),('5a78d65d47d9787','5501dbedc785fe4','5a788f06d54e1a2','2018-02-06 00:10:37','globeadmin','2018-02-06 00:10:37','globeadmin','2018-02-06 00:10:37','globeadmin'),('5a78d65fb5b3db1','5601afbc23dfb00','5a788f06d54e1a2','2018-02-06 00:10:39','globeadmin','2018-02-06 00:10:39','globeadmin','2018-11-20 14:42:17','globeadmin'),('5a78d662d093b5d','5689468794353da','5a788f06d54e1a2','2018-02-06 00:10:42','globeadmin','2018-02-06 00:10:42','globeadmin','2018-02-06 00:10:42','globeadmin'),('5a9e803318d1ec7','547de3bee410196','5a9d96938c5959e','2018-03-06 13:49:07','globeadmin','2018-03-06 13:49:07','globeadmin','2022-01-31 16:18:47','globeadmin'),('5a9070e96869a23','547de3bee410196','5a8c6664a38d180','2018-02-23 21:52:09','globeadmin','2018-02-23 21:52:09','globeadmin','2022-01-31 16:18:43','globeadmin'),('5a9070ec65fd04d','547de3e001028e8','5a8c6664a38d180','2018-02-23 21:52:12','globeadmin','2018-02-23 21:52:12','globeadmin','2019-11-06 15:15:11','globeadmin'),('5a9070eff11ccbf','5501dbedc785fe4','5a8c6664a38d180','2018-02-23 21:52:15','globeadmin','2018-02-23 21:52:15','globeadmin','2018-02-23 21:52:15','globeadmin'),('5a9070f2ca0aed6','5601afbc23dfb00','5a8c6664a38d180','2018-02-23 21:52:18','globeadmin','2018-02-23 21:52:18','globeadmin','2018-11-20 14:42:15','globeadmin'),('5a9070fa0926751','5689468794353da','5a8c6664a38d180','2018-02-23 21:52:26','globeadmin','2018-02-23 21:52:26','globeadmin','2018-02-23 21:52:26','globeadmin'),('5a930645bfa808e','547de3bee410196','5a92dae6a2be54b','2018-02-25 20:53:57','globeadmin','2018-02-25 20:53:57','globeadmin','2022-01-31 16:18:47','globeadmin'),('5a930648a4cafd4','547de3e001028e8','5a92dae6a2be54b','2018-02-25 20:54:00','globeadmin','2018-02-25 20:54:00','globeadmin','2019-11-06 15:15:20','globeadmin'),('5a93064ba4c8b3b','5501dbedc785fe4','5a92dae6a2be54b','2018-02-25 20:54:03','globeadmin','2018-02-25 20:54:03','globeadmin','2018-02-25 20:54:03','globeadmin'),('5a93064de441403','5601afbc23dfb00','5a92dae6a2be54b','2018-02-25 20:54:05','globeadmin','2018-02-25 20:54:05','globeadmin','2018-11-20 14:42:28','globeadmin'),('5a930651e920345','5689468794353da','5a92dae6a2be54b','2018-02-25 20:54:09','globeadmin','2018-02-25 20:54:09','globeadmin','2018-02-25 20:54:09','globeadmin'),('5a9e80362021d1b','547de3e001028e8','5a9d96938c5959e','2018-03-06 13:49:10','globeadmin','2018-03-06 13:49:10','globeadmin','2019-11-06 15:15:21','globeadmin'),('5a9e80383d6c7b6','547de3fe0d36089','5a9d96938c5959e','2018-03-06 13:49:12','globeadmin','2018-03-06 13:49:12','globeadmin','2019-07-01 11:07:10','globeadmin'),('5a9e803af215ca9','5501dbedc785fe4','5a9d96938c5959e','2018-03-06 13:49:14','globeadmin','2018-03-06 13:49:14','globeadmin','2018-03-06 13:49:14','globeadmin'),('5a9e803d9c9ffb2','5601afbc23dfb00','5a9d96938c5959e','2018-03-06 13:49:17','globeadmin','2018-03-06 13:49:17','globeadmin','2018-11-20 14:42:29','globeadmin'),('5a9e80408b86938','5689468794353da','5a9d96938c5959e','2018-03-06 13:49:20','globeadmin','2018-03-06 13:49:20','globeadmin','2018-03-06 13:49:20','globeadmin'),('5a9e8045cd6e42a','5717b9c74a31169','5a9d96938c5959e','2018-03-06 13:49:25','globeadmin','2018-03-06 13:49:25','globeadmin','2018-03-06 13:49:25','globeadmin'),('5a9e807372fb9d1','547de3bee410196','5a9e7622e307049','2018-03-06 13:50:11','globeadmin','2018-03-06 13:50:11','globeadmin','2022-01-31 16:18:47','globeadmin'),('5a9e8075cadc8e5','547de3e001028e8','5a9e7622e307049','2018-03-06 13:50:13','globeadmin','2018-03-06 13:50:13','globeadmin','2019-11-06 15:15:21','globeadmin'),('5a9e807870856ee','5501dbedc785fe4','5a9e7622e307049','2018-03-06 13:50:16','globeadmin','2018-03-06 13:50:16','globeadmin','2018-03-06 13:50:16','globeadmin'),('5a9e807b4e55840','5601afbc23dfb00','5a9e7622e307049','2018-03-06 13:50:19','globeadmin','2018-03-06 13:50:19','globeadmin','2018-11-20 14:42:29','globeadmin'),('5a9e807e77d49bb','5689468794353da','5a9e7622e307049','2018-03-06 13:50:22','globeadmin','2018-03-06 13:50:22','globeadmin','2018-03-06 13:50:22','globeadmin'),('5aa1993bc628a4c','547de3bee410196','5aa18dc089a2268','2018-03-08 22:12:43','globeadmin','2018-03-08 22:12:43','globeadmin','2022-01-31 16:18:45','globeadmin'),('5aa1993dc8985a5','547de3e001028e8','5aa18dc089a2268','2018-03-08 22:12:45','globeadmin','2018-03-08 22:12:45','globeadmin','2019-11-06 15:15:16','globeadmin'),('5aa1993fc3b4725','547de3fe0d36089','5aa18dc089a2268','2018-03-08 22:12:47','globeadmin','2018-03-08 22:12:47','globeadmin','2019-07-01 11:07:04','globeadmin'),('5aa19942165c360','5501dbedc785fe4','5aa18dc089a2268','2018-03-08 22:12:50','globeadmin','2018-03-08 22:12:50','globeadmin','2018-03-08 22:12:50','globeadmin'),('5aa19944b028e33','5601afbc23dfb00','5aa18dc089a2268','2018-03-08 22:12:52','globeadmin','2018-03-08 22:12:52','globeadmin','2018-11-20 14:42:23','globeadmin'),('5aa199476478bd1','5689468794353da','5aa18dc089a2268','2018-03-08 22:12:55','globeadmin','2018-03-08 22:12:55','globeadmin','2018-03-08 22:12:55','globeadmin'),('5aa1994a3fd7704','5717b9c74a31169','5aa18dc089a2268','2018-03-08 22:12:58','globeadmin','2018-03-08 22:12:58','globeadmin','2018-03-08 22:12:58','globeadmin'),('5adc5129b10951c','547de3bee410196','5adc50f42d58755','2018-04-22 12:08:57','globeadmin','2018-04-22 12:08:57','globeadmin','2022-01-31 16:18:43','globeadmin'),('5adc512d0d73620','547de3e001028e8','5adc50f42d58755','2018-04-22 12:09:01','globeadmin','2018-04-22 12:09:01','globeadmin','2019-11-06 15:15:12','globeadmin'),('5adc51320d70405','5501dbedc785fe4','5adc50f42d58755','2018-04-22 12:09:06','globeadmin','2018-04-22 12:09:06','globeadmin','2018-04-22 12:09:06','globeadmin'),('5adc5135ae8f616','5601afbc23dfb00','5adc50f42d58755','2018-04-22 12:09:09','globeadmin','2018-04-22 12:09:09','globeadmin','2018-11-20 14:42:17','globeadmin'),('5adc5139c6f66f3','5689468794353da','5adc50f42d58755','2018-04-22 12:09:13','globeadmin','2018-04-22 12:09:13','globeadmin','2018-04-22 12:09:13','globeadmin'),('5b0f1ccebf27834','547de3bee410196','5b0f02fc45e374e','2018-05-31 00:51:10','globeadmin','2018-05-31 00:51:10','globeadmin','2022-01-31 16:18:44','globeadmin'),('5b0f1cd195a49aa','547de3e001028e8','5b0f02fc45e374e','2018-05-31 00:51:13','globeadmin','2018-05-31 00:51:13','globeadmin','2019-11-06 15:15:14','globeadmin'),('5b0f1cd6366c8c3','5501dbedc785fe4','5b0f02fc45e374e','2018-05-31 00:51:18','globeadmin','2018-05-31 00:51:18','globeadmin','2018-05-31 00:51:18','globeadmin'),('5b0f1cd8a44d2f2','5601afbc23dfb00','5b0f02fc45e374e','2018-05-31 00:51:20','globeadmin','2018-05-31 00:51:20','globeadmin','2018-11-20 14:42:21','globeadmin'),('5b0f1cdc3dba6ad','5689468794353da','5b0f02fc45e374e','2018-05-31 00:51:24','globeadmin','2018-05-31 00:51:24','globeadmin','2018-05-31 00:51:24','globeadmin'),('5b2142a2c1aca1d','547de3bee410196','5b1f96ff515d327','2018-06-13 19:13:22','globeadmin','2018-06-13 19:13:22','globeadmin','2022-01-31 16:18:48','globeadmin'),('5b2142a4da15730','547de3e001028e8','5b1f96ff515d327','2018-06-13 19:13:24','globeadmin','2018-06-13 19:13:24','globeadmin','2019-11-06 15:15:22','globeadmin'),('5b2142a6def646e','547de3fe0d36089','5b1f96ff515d327','2018-06-13 19:13:26','globeadmin','2018-06-13 19:13:26','globeadmin','2019-07-01 11:07:10','globeadmin'),('5b2142a9cb6ca29','5501dbedc785fe4','5b1f96ff515d327','2018-06-13 19:13:29','globeadmin','2018-06-13 19:13:29','globeadmin','2018-06-13 19:13:29','globeadmin'),('5b2142accde03ab','5601afbc23dfb00','5b1f96ff515d327','2018-06-13 19:13:32','globeadmin','2018-06-13 19:13:32','globeadmin','2018-11-20 14:42:30','globeadmin'),('5b2142b0626dd7f','5689468794353da','5b1f96ff515d327','2018-06-13 19:13:36','globeadmin','2018-06-13 19:13:36','globeadmin','2018-06-13 19:13:36','globeadmin'),('5b2142b2da0d8cf','5717b9c74a31169','5b1f96ff515d327','2018-06-13 19:13:38','globeadmin','2018-06-13 19:13:38','globeadmin','2018-06-13 19:13:38','globeadmin'),('5b5d6c1a45a71eb','547de3bee410196','5b5cb6ec96e8b56','2018-07-29 10:26:18','globeadmin','2018-07-29 10:26:18','globeadmin','2022-01-31 16:18:45','globeadmin'),('5b5d6c1a4cfc749','547de3bee410196','5b5cb9cc119131f','2018-07-29 10:26:18','globeadmin','2018-07-29 10:26:18','globeadmin','2022-01-31 16:18:45','globeadmin'),('5b5d6c30a260634','5501dbedc785fe4','5b5cb6ec96e8b56','2018-07-29 10:26:40','globeadmin','2018-07-29 10:26:40','globeadmin','2018-07-29 10:26:40','globeadmin'),('5b5d6c30a9b294c','5501dbedc785fe4','5b5cb9cc119131f','2018-07-29 10:26:40','globeadmin','2018-07-29 10:26:40','globeadmin','2018-07-29 10:26:40','globeadmin'),('5b5d6c33dcf5da4','5601afbc23dfb00','5b5cb6ec96e8b56','2018-07-29 10:26:43','globeadmin','2018-07-29 10:26:43','globeadmin','2018-11-20 14:42:23','globeadmin'),('5b5d6c33e448e31','5601afbc23dfb00','5b5cb9cc119131f','2018-07-29 10:26:43','globeadmin','2018-07-29 10:26:43','globeadmin','2018-11-20 14:42:23','globeadmin'),('5b5d6c37061dda2','5689468794353da','5b5cb6ec96e8b56','2018-07-29 10:26:47','globeadmin','2018-07-29 10:26:47','globeadmin','2018-07-29 10:26:47','globeadmin'),('5b5d6c370d70e2a','5689468794353da','5b5cb9cc119131f','2018-07-29 10:26:47','globeadmin','2018-07-29 10:26:47','globeadmin','2018-07-29 10:26:47','globeadmin'),('5b5dd3f7af4db2c','547de3bee410196','5b5dc66f6d3bbfa','2018-07-29 17:49:27','globeadmin','2018-07-29 17:49:27','globeadmin','2022-01-31 16:18:45','globeadmin'),('5b5dd3f7b6a73e5','547de3bee410196','5b5dc7d35686687','2018-07-29 17:49:27','globeadmin','2018-07-29 17:49:27','globeadmin','2022-01-31 16:18:45','globeadmin'),('5b5dd3fc99541d8','5501dbedc785fe4','5b5dc66f6d3bbfa','2018-07-29 17:49:32','globeadmin','2018-07-29 17:49:32','globeadmin','2018-07-29 17:49:32','globeadmin'),('5b5dd3fca0a521c','5501dbedc785fe4','5b5dc7d35686687','2018-07-29 17:49:32','globeadmin','2018-07-29 17:49:32','globeadmin','2018-07-29 17:49:32','globeadmin'),('5b5dd3ff29037f0','5601afbc23dfb00','5b5dc66f6d3bbfa','2018-07-29 17:49:35','globeadmin','2018-07-29 17:49:35','globeadmin','2018-11-20 14:42:22','globeadmin'),('5b5dd3ff3055ce6','5601afbc23dfb00','5b5dc7d35686687','2018-07-29 17:49:35','globeadmin','2018-07-29 17:49:35','globeadmin','2018-11-20 14:42:22','globeadmin'),('5b5dd40217ecfd9','5689468794353da','5b5dc66f6d3bbfa','2018-07-29 17:49:38','globeadmin','2018-07-29 17:49:38','globeadmin','2018-07-29 17:49:38','globeadmin'),('5b5dd4021f3f02a','5689468794353da','5b5dc7d35686687','2018-07-29 17:49:38','globeadmin','2018-07-29 17:49:38','globeadmin','2018-07-29 17:49:38','globeadmin'),('5b68980d687f471','547de3e001028e8','5b5dc66f6d3bbfa','2018-08-06 21:48:45','globeadmin','2018-08-06 21:48:45','globeadmin','2019-11-06 15:15:15','globeadmin'),('5b68980d6fd0abf','547de3e001028e8','5b5cb9cc119131f','2018-08-06 21:48:45','globeadmin','2018-08-06 21:48:45','globeadmin','2019-11-06 15:15:17','globeadmin'),('5b68980d772a242','547de3e001028e8','5b5cb6ec96e8b56','2018-08-06 21:48:45','globeadmin','2018-08-06 21:48:45','globeadmin','2019-11-06 15:15:16','globeadmin'),('5b68980d7e77d99','547de3e001028e8','5b5dc7d35686687','2018-08-06 21:48:45','globeadmin','2018-08-06 21:48:45','globeadmin','2019-11-06 15:15:16','globeadmin'),('5c1e7b3184801d9','547de3bee410196','5c1e7af53187bff','2018-12-22 19:58:09','globeadmin','2018-12-22 19:58:09','globeadmin','2022-01-31 16:18:47','globeadmin'),('5c1e7b34474bbd7','547de3e001028e8','5c1e7af53187bff','2018-12-22 19:58:12','globeadmin','2018-12-22 19:58:12','globeadmin','2019-11-06 15:15:20','globeadmin'),('5c1e7b369cc06d8','547de3fe0d36089','5c1e7af53187bff','2018-12-22 19:58:14','globeadmin','2018-12-22 19:58:14','globeadmin','2019-07-01 11:07:09','globeadmin'),('5c1e7b397cfe63f','5501dbedc785fe4','5c1e7af53187bff','2018-12-22 19:58:17','globeadmin','2018-12-22 19:58:17','globeadmin','2018-12-22 19:58:17','globeadmin'),('5c1e7b3c6491e9a','5601afbc23dfb00','5c1e7af53187bff','2018-12-22 19:58:20','globeadmin','2018-12-22 19:58:20','globeadmin','2018-12-22 19:58:20','globeadmin'),('5c1e7b3f5d3c7cf','5689468794353da','5c1e7af53187bff','2018-12-22 19:58:23','globeadmin','2018-12-22 19:58:23','globeadmin','2018-12-22 19:58:23','globeadmin'),('5c1e7b449a43b23','5717b9c74a31169','5c1e7af53187bff','2018-12-22 19:58:28','globeadmin','2018-12-22 19:58:28','globeadmin','2018-12-22 19:58:28','globeadmin'),('5c840f6550e0fd2','547de3bee410196','5c83c9358b77ad3','2019-03-09 21:09:25','globeadmin','2019-03-09 21:09:25','globeadmin','2022-01-31 16:18:43','globeadmin'),('5c840f6786967d3','547de3e001028e8','5c83c9358b77ad3','2019-03-09 21:09:27','globeadmin','2019-03-09 21:09:27','globeadmin','2019-11-06 15:15:12','globeadmin'),('5c840f6d004a9e6','5501dbedc785fe4','5c83c9358b77ad3','2019-03-09 21:09:33','globeadmin','2019-03-09 21:09:33','globeadmin','2019-03-09 21:09:33','globeadmin'),('5c840f7066d2630','5601afbc23dfb00','5c83c9358b77ad3','2019-03-09 21:09:36','globeadmin','2019-03-09 21:09:36','globeadmin','2019-03-09 21:09:36','globeadmin'),('5c840f73f1ff58e','5689468794353da','5c83c9358b77ad3','2019-03-09 21:09:39','globeadmin','2019-03-09 21:09:39','globeadmin','2019-03-09 21:09:39','globeadmin'),('5c84df40ce977a0','547de3bee410196','5c84df1571ef247','2019-03-10 11:56:16','globeadmin','2019-03-10 11:56:16','globeadmin','2022-01-31 16:18:46','globeadmin'),('5c84df43b1499c7','547de3e001028e8','5c84df1571ef247','2019-03-10 11:56:19','globeadmin','2019-03-10 11:56:19','globeadmin','2019-11-06 15:15:18','globeadmin'),('5c84df477e02902','5501dbedc785fe4','5c84df1571ef247','2019-03-10 11:56:23','globeadmin','2019-03-10 11:56:23','globeadmin','2019-03-10 11:56:23','globeadmin'),('5c84df4adfa77d0','5601afbc23dfb00','5c84df1571ef247','2019-03-10 11:56:26','globeadmin','2019-03-10 11:56:26','globeadmin','2019-03-10 11:56:26','globeadmin'),('5c84df4e2d6c945','5689468794353da','5c84df1571ef247','2019-03-10 11:56:30','globeadmin','2019-03-10 11:56:30','globeadmin','2019-03-10 11:56:30','globeadmin'),('5d107e44972b91e','547de3bee410196','5d0dda2ac6ea17d','2019-06-24 10:39:48','globeadmin','2019-06-24 10:39:48','globeadmin','2022-01-31 16:18:45','globeadmin'),('5d107e4774f555a','547de3e001028e8','5d0dda2ac6ea17d','2019-06-24 10:39:51','globeadmin','2019-06-24 10:39:51','globeadmin','2019-11-06 15:15:15','globeadmin'),('5d107e49ea23d59','547de3fe0d36089','5d0dda2ac6ea17d','2019-06-24 10:39:53','globeadmin','2019-06-24 10:39:53','globeadmin','2019-07-01 11:07:04','globeadmin'),('5d107e4d700f9f1','5501dbedc785fe4','5d0dda2ac6ea17d','2019-06-24 10:39:57','globeadmin','2019-06-24 10:39:57','globeadmin','2019-06-24 10:39:57','globeadmin'),('5d107e50b1f8c00','5601afbc23dfb00','5d0dda2ac6ea17d','2019-06-24 10:40:00','globeadmin','2019-06-24 10:40:00','globeadmin','2019-06-24 10:40:00','globeadmin'),('5d107e54ec8dd6b','5689468794353da','5d0dda2ac6ea17d','2019-06-24 10:40:04','globeadmin','2019-06-24 10:40:04','globeadmin','2019-06-24 10:40:04','globeadmin'),('5d107e57f16dda5','5717b9c74a31169','5d0dda2ac6ea17d','2019-06-24 10:40:07','globeadmin','2019-06-24 10:40:07','globeadmin','2019-06-24 10:40:07','globeadmin'),('5f6af5bee21e1f1','5717b9c74a31169','5f68734969ddcf1','2020-09-23 10:14:06','globeadmin','2020-09-23 10:14:06','globeadmin','2020-09-23 10:14:06','globeadmin'),('5f6af52c9de4b8c','547de3bee410196','5f5e56bb6d78a38','2020-09-23 10:11:40','globeadmin','2020-09-23 10:11:40','globeadmin','2022-01-31 16:18:47','globeadmin'),('5f6af5bee1ac33c','5717b9c74a31169','5f63e26289741cf','2020-09-23 10:14:06','globeadmin','2020-09-23 10:14:06','globeadmin','2020-09-23 10:14:06','globeadmin'),('61d999aceb2c049','547de3fe0d36089','61d954057af2530','2022-01-08 16:03:24','globeadmin','2022-01-08 16:03:24','globeadmin','2022-01-08 16:03:24','globeadmin'),('617a88119ba141f','5601afbc23dfb00','6176a844969aad4','2021-10-28 14:22:57','globeadmin','2021-10-28 14:22:57','globeadmin','2021-10-28 14:22:57','globeadmin'),('5f6cf0511718415','5501dbedc785fe4','5f6cc2b342ea2e8','2020-09-24 22:15:29','globeadmin','2020-09-24 22:15:29','globeadmin','2020-09-24 22:15:29','globeadmin'),('5f7cea8e4f58ba3','547de3e001028e8','5f7c42a7aa3146f','2020-10-07 01:07:10','globeadmin','2020-10-07 01:07:10','globeadmin','2020-10-07 01:07:10','globeadmin'),('5f7cea8b4d3b8fc','547de3bee410196','5f7c42a7aa3146f','2020-10-07 01:07:07','globeadmin','2020-10-07 01:07:07','globeadmin','2022-01-31 16:18:43','globeadmin'),('5f43ec9652e352c','5501dbedc785fe4','5f424a2f68b37ac','2020-08-24 19:36:38','globeadmin','2020-08-24 19:36:38','globeadmin','2020-08-24 19:36:38','globeadmin'),('5f43ec96536d2e8','5501dbedc785fe4','5e860fe9679ea49','2020-08-24 19:36:38','globeadmin','2020-08-24 19:36:38','globeadmin','2020-08-24 19:36:38','globeadmin'),('5f43ec9653ee91d','5501dbedc785fe4','5e8774909b74cee','2020-08-24 19:36:38','globeadmin','2020-08-24 19:36:38','globeadmin','2020-08-24 19:36:38','globeadmin'),('5f43ec965458d3f','5501dbedc785fe4','5e89aa30b163504','2020-08-24 19:36:38','globeadmin','2020-08-24 19:36:38','globeadmin','2020-08-24 19:36:38','globeadmin'),('5f43ec9654c14e7','5501dbedc785fe4','5f3a5eff6565e0c','2020-08-24 19:36:38','globeadmin','2020-08-24 19:36:38','globeadmin','2020-08-24 19:36:38','globeadmin'),('5f43ec9655292bc','5501dbedc785fe4','5f3f7a399f33641','2020-08-24 19:36:38','globeadmin','2020-08-24 19:36:38','globeadmin','2020-08-24 19:36:38','globeadmin'),('5f43ec9ae251e77','5601afbc23dfb00','5f424a2f68b37ac','2020-08-24 19:36:42','globeadmin','2020-08-24 19:36:42','globeadmin','2020-08-24 19:36:42','globeadmin'),('5f43ec9ae2b7d84','5601afbc23dfb00','5e860fe9679ea49','2020-08-24 19:36:42','globeadmin','2020-08-24 19:36:42','globeadmin','2020-08-24 19:36:42','globeadmin'),('5f43ec9ae3124ed','5601afbc23dfb00','5e8774909b74cee','2020-08-24 19:36:42','globeadmin','2020-08-24 19:36:42','globeadmin','2020-08-24 19:36:42','globeadmin'),('5f43ec9ae36a4cd','5601afbc23dfb00','5e89aa30b163504','2020-08-24 19:36:42','globeadmin','2020-08-24 19:36:42','globeadmin','2020-08-24 19:36:42','globeadmin'),('5f43ec9ae3d1bcf','5601afbc23dfb00','5f3a5eff6565e0c','2020-08-24 19:36:42','globeadmin','2020-08-24 19:36:42','globeadmin','2020-08-24 19:36:42','globeadmin'),('5f43ec9ae42c4c4','5601afbc23dfb00','5f3f7a399f33641','2020-08-24 19:36:42','globeadmin','2020-08-24 19:36:42','globeadmin','2020-08-24 19:36:42','globeadmin'),('5f6af52c9e4c5d3','547de3bee410196','5f6087c5486319a','2020-09-23 10:11:40','globeadmin','2020-09-23 10:11:40','globeadmin','2022-01-31 16:18:44','globeadmin'),('5f6af52c9ea6cb6','547de3bee410196','5f6888aa4c7548f','2020-09-23 10:11:40','globeadmin','2020-09-23 10:11:40','globeadmin','2022-01-31 16:18:46','globeadmin'),('5f6af52c9eff1a0','547de3bee410196','5f5e03747627db2','2020-09-23 10:11:40','globeadmin','2020-09-23 10:11:40','globeadmin','2022-01-31 16:18:47','globeadmin'),('5f6af52c9f5776c','547de3bee410196','5f68734969ddcf1','2020-09-23 10:11:40','globeadmin','2020-09-23 10:11:40','globeadmin','2022-01-31 16:18:44','globeadmin'),('5f6af530842fcba','547de3e001028e8','5f5e56bb6d78a38','2020-09-23 10:11:44','globeadmin','2020-09-23 10:11:44','globeadmin','2020-09-23 10:11:44','globeadmin'),('5f6af53084a8d51','547de3e001028e8','5f6087c5486319a','2020-09-23 10:11:44','globeadmin','2020-09-23 10:11:44','globeadmin','2020-09-23 10:11:44','globeadmin'),('5f6af5308506716','547de3e001028e8','5f6888aa4c7548f','2020-09-23 10:11:44','globeadmin','2020-09-23 10:11:44','globeadmin','2020-09-23 10:11:44','globeadmin'),('5f6af530855fa8f','547de3e001028e8','5f5e03747627db2','2020-09-23 10:11:44','globeadmin','2020-09-23 10:11:44','globeadmin','2020-09-23 10:11:44','globeadmin'),('5f6af53085b81c3','547de3e001028e8','5f68734969ddcf1','2020-09-23 10:11:44','globeadmin','2020-09-23 10:11:44','globeadmin','2020-09-23 10:11:44','globeadmin'),('5f6af534ba7f29d','5501dbedc785fe4','5f5e56bb6d78a38','2020-09-23 10:11:48','globeadmin','2020-09-23 10:11:48','globeadmin','2020-09-23 10:11:48','globeadmin'),('5f6af534baf86fa','5501dbedc785fe4','5f6087c5486319a','2020-09-23 10:11:48','globeadmin','2020-09-23 10:11:48','globeadmin','2020-09-23 10:11:48','globeadmin'),('5f6af534bb652a7','5501dbedc785fe4','5f6888aa4c7548f','2020-09-23 10:11:48','globeadmin','2020-09-23 10:11:48','globeadmin','2020-09-23 10:11:48','globeadmin'),('5f6af534bbd0884','5501dbedc785fe4','5f5e03747627db2','2020-09-23 10:11:48','globeadmin','2020-09-23 10:11:48','globeadmin','2020-09-23 10:11:48','globeadmin'),('5f6af534bc3af26','5501dbedc785fe4','5f68734969ddcf1','2020-09-23 10:11:48','globeadmin','2020-09-23 10:11:48','globeadmin','2020-09-23 10:11:48','globeadmin'),('5f6af538aed6c25','5601afbc23dfb00','5f5e56bb6d78a38','2020-09-23 10:11:52','globeadmin','2020-09-23 10:11:52','globeadmin','2020-09-23 10:11:52','globeadmin'),('5f6af538af40170','5601afbc23dfb00','5f6087c5486319a','2020-09-23 10:11:52','globeadmin','2020-09-23 10:11:52','globeadmin','2020-09-23 10:11:52','globeadmin'),('5f6af538af9e157','5601afbc23dfb00','5f6888aa4c7548f','2020-09-23 10:11:52','globeadmin','2020-09-23 10:11:52','globeadmin','2020-09-23 10:11:52','globeadmin'),('5f6af538affcf22','5601afbc23dfb00','5f5e03747627db2','2020-09-23 10:11:52','globeadmin','2020-09-23 10:11:52','globeadmin','2020-09-23 10:11:52','globeadmin'),('5f6af538b058aa7','5601afbc23dfb00','5f68734969ddcf1','2020-09-23 10:11:52','globeadmin','2020-09-23 10:11:52','globeadmin','2020-09-23 10:11:52','globeadmin'),('5f6af53cba53e1b','5689468794353da','5f5e56bb6d78a38','2020-09-23 10:11:56','globeadmin','2020-09-23 10:11:56','globeadmin','2020-09-23 10:11:56','globeadmin'),('5f6af53cbabffd4','5689468794353da','5f6087c5486319a','2020-09-23 10:11:56','globeadmin','2020-09-23 10:11:56','globeadmin','2020-09-23 10:11:56','globeadmin'),('5f6af53cbb201f8','5689468794353da','5f6888aa4c7548f','2020-09-23 10:11:56','globeadmin','2020-09-23 10:11:56','globeadmin','2020-09-23 10:11:56','globeadmin'),('5f6af53cbb7ebd8','5689468794353da','5f5e03747627db2','2020-09-23 10:11:56','globeadmin','2020-09-23 10:11:56','globeadmin','2020-09-23 10:11:56','globeadmin'),('5f6af53cbbdbe27','5689468794353da','5f68734969ddcf1','2020-09-23 10:11:56','globeadmin','2020-09-23 10:11:56','globeadmin','2020-09-23 10:11:56','globeadmin'),('5f6af5bee289090','5717b9c74a31169','5f611d27111dcc8','2020-09-23 10:14:06','globeadmin','2020-09-23 10:14:06','globeadmin','2020-09-23 10:14:06','globeadmin'),('5f6cf051179532f','5501dbedc785fe4','5f6cef854c9e4b1','2020-09-24 22:15:29','globeadmin','2020-09-24 22:15:29','globeadmin','2020-09-24 22:15:29','globeadmin'),('5f6cf054ba51023','5601afbc23dfb00','5f6cc2b342ea2e8','2020-09-24 22:15:32','globeadmin','2020-09-24 22:15:32','globeadmin','2020-09-24 22:15:32','globeadmin'),('5f6cf054babcd2e','5601afbc23dfb00','5f6cef854c9e4b1','2020-09-24 22:15:32','globeadmin','2020-09-24 22:15:32','globeadmin','2020-09-24 22:15:32','globeadmin'),('5f7cea92cca88a5','5501dbedc785fe4','5f7c42a7aa3146f','2020-10-07 01:07:14','globeadmin','2020-10-07 01:07:14','globeadmin','2020-10-07 01:07:14','globeadmin'),('5f7cea96a3b445b','5601afbc23dfb00','5f7c42a7aa3146f','2020-10-07 01:07:18','globeadmin','2020-10-07 01:07:18','globeadmin','2020-10-07 01:07:18','globeadmin'),('5f7cea9c1079829','5689468794353da','5f7c42a7aa3146f','2020-10-07 01:07:24','globeadmin','2020-10-07 01:07:24','globeadmin','2020-10-07 01:07:24','globeadmin'),('5f8b75fd10bde38','547de3bee410196','5f8b6c6f9011cfc','2020-10-18 01:53:49','globeadmin','2020-10-18 01:53:49','globeadmin','2022-01-31 16:18:44','globeadmin'),('5f8b75fd112ec86','547de3bee410196','5f8b61c073af846','2020-10-18 01:53:49','globeadmin','2020-10-18 01:53:49','globeadmin','2022-01-31 16:18:44','globeadmin'),('5f8b760155af2b2','5501dbedc785fe4','5f8b6c6f9011cfc','2020-10-18 01:53:53','globeadmin','2020-10-18 01:53:53','globeadmin','2020-10-18 01:53:53','globeadmin'),('5f8b76015618c70','5501dbedc785fe4','5f8b61c073af846','2020-10-18 01:53:53','globeadmin','2020-10-18 01:53:53','globeadmin','2020-10-18 01:53:53','globeadmin'),('5f8b7604d041582','5601afbc23dfb00','5f8b6c6f9011cfc','2020-10-18 01:53:56','globeadmin','2020-10-18 01:53:56','globeadmin','2020-10-18 01:53:56','globeadmin'),('5f8b7604d0ae676','5601afbc23dfb00','5f8b61c073af846','2020-10-18 01:53:56','globeadmin','2020-10-18 01:53:56','globeadmin','2020-10-18 01:53:56','globeadmin'),('60395aa61160064','547de3bee410196','603804125b80c1b','2021-02-26 22:31:34','globeadmin','2021-02-26 22:31:34','globeadmin','2022-01-31 16:18:43','globeadmin'),('60395aa611e488b','547de3bee410196','6039488575f57d2','2021-02-26 22:31:34','globeadmin','2021-02-26 22:31:34','globeadmin','2022-01-31 16:18:43','globeadmin'),('60395aaab763af6','547de3e001028e8','603804125b80c1b','2021-02-26 22:31:38','globeadmin','2021-02-26 22:31:38','globeadmin','2021-02-26 22:31:38','globeadmin'),('60395aaab7d9d02','547de3e001028e8','6039488575f57d2','2021-02-26 22:31:38','globeadmin','2021-02-26 22:31:38','globeadmin','2021-02-26 22:31:38','globeadmin'),('60395ab087d1fda','5501dbedc785fe4','603804125b80c1b','2021-02-26 22:31:44','globeadmin','2021-02-26 22:31:44','globeadmin','2021-02-26 22:31:44','globeadmin'),('60395ab0883dbf0','5501dbedc785fe4','6039488575f57d2','2021-02-26 22:31:44','globeadmin','2021-02-26 22:31:44','globeadmin','2021-02-26 22:31:44','globeadmin'),('60395ab54a274ff','5601afbc23dfb00','603804125b80c1b','2021-02-26 22:31:49','globeadmin','2021-02-26 22:31:49','globeadmin','2021-02-26 22:31:49','globeadmin'),('60395ab54a95af4','5601afbc23dfb00','6039488575f57d2','2021-02-26 22:31:49','globeadmin','2021-02-26 22:31:49','globeadmin','2021-02-26 22:31:49','globeadmin'),('60395aba163bfc5','5689468794353da','603804125b80c1b','2021-02-26 22:31:54','globeadmin','2021-02-26 22:31:54','globeadmin','2021-02-26 22:31:54','globeadmin'),('60395aba16c0174','5689468794353da','6039488575f57d2','2021-02-26 22:31:54','globeadmin','2021-02-26 22:31:54','globeadmin','2021-02-26 22:31:54','globeadmin'),('60475b5b0ad2778','60475aa35186b93','5487369544262a7','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b0bf1fe5','60475aa35186b93','548b2b8d4b3f282','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b0c4e45a','60475aa35186b93','548897f34ce2b64','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b0ca5f7e','60475aa35186b93','54889d24766371b','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b0d17dac','60475aa35186b93','562b7741ab50baf','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b0d78fde','60475aa35186b93','562378beaaf323a','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b13dcfe7','60475aa35186b93','571c76ec5f95f4a','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b15ea866','60475aa35186b93','571867a3c69b329','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b164f781','60475aa35186b93','571b3a668693434','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b16b69c2','60475aa35186b93','5719cc13ce50b1c','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b170f3eb','60475aa35186b93','571bb4109fea243','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b176701f','60475aa35186b93','570f37d999d041a','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b17c063a','60475aa35186b93','5757b8458c72cf3','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b181bca6','60475aa35186b93','52c0da99b95c264','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b18775db','60475aa35186b93','530a8f8e78111c4','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b18cded3','60475aa35186b93','5477806364bbd3b','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b1940c9a','60475aa35186b93','547cc4b073c1854','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b199bf31','60475aa35186b93','547cce2020be0b5','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b19f57b7','60475aa35186b93','5494859e9bfaf58','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b1a50145','60475aa35186b93','5495d3357b0fb7c','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b1aab2ed','60475aa35186b93','5498454b86171f6','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b1b06e67','60475aa35186b93','549ef456718c2ed','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b1b763ad','60475aa35186b93','54a06aabf3085fe','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b1bd1532','60475aa35186b93','54a11e8a5b34dee','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b1c2ac6f','60475aa35186b93','54a2700ab351809','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b1c84497','60475aa35186b93','54a2baf998a4dbd','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b1cde761','60475aa35186b93','54a30da411a6ba7','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b1d3900f','60475aa35186b93','54a3e7ba6b7fc63','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b1d93c91','60475aa35186b93','54a57904c1b4546','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b1e0083c','60475aa35186b93','54a921725907fab','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b1e5f4fb','60475aa35186b93','54a9704fd26ded5','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b1ebd8e4','60475aa35186b93','54aa72ec60858cc','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b1f1bb27','60475aa35186b93','54b1245d2bacdb6','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b1f79c5f','60475aa35186b93','54b3853f5280e06','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b1fd809f','60475aa35186b93','54d1374c9e8d38a','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b20466f8','60475aa35186b93','54d65d126230684','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b20aac93','60475aa35186b93','54d6660b538bea2','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b210d59e','60475aa35186b93','54da24749d82eb7','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b2172e6d','60475aa35186b93','54df2384b808c9b','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b21d0a56','60475aa35186b93','54df23b8e8dd0cf','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b222eb10','60475aa35186b93','54df242190f8a42','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b228de2f','60475aa35186b93','54df249e87338f1','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b230489b','60475aa35186b93','54df24c6566897c','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b2365304','60475aa35186b93','54df2503ce004f5','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b23c4f54','60475aa35186b93','54e61e02a705c6d','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b2423c6c','60475aa35186b93','54eb5821b763976','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b2482edf','60475aa35186b93','54f4afe911e357f','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b24e26a4','60475aa35186b93','54f729629379af4','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b2557d38','60475aa35186b93','54f8ae257942c56','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b25bb9ca','60475aa35186b93','54fdfd017b6a60e','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b261dd3c','60475aa35186b93','54ff33e86cd65f8','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b2680164','60475aa35186b93','55004dd5e43f2f2','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b26e274a','60475aa35186b93','5507176562eedae','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b2745f01','60475aa35186b93','550737d00a4a57b','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b27b5160','60475aa35186b93','5507d4d7b50b99c','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b2816789','60475aa35186b93','550c7f9aba73fb6','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b2876727','60475aa35186b93','550d4eea3e00a18','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b28d7a70','60475aa35186b93','550d5651ba833e2','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b293881b','60475aa35186b93','550db8c2a38fc30','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b2999847','60475aa35186b93','570a9f835bf5454','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b2a0aa11','60475aa35186b93','55128eb9652ead5','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b2a78dbd','60475aa35186b93','55183736b84eee4','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b2ad9336','60475aa35186b93','551a39550972489','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b2b38ced','60475aa35186b93','552124aeebd01bf','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b2b9864d','60475aa35186b93','552233092acee07','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b2bf8641','60475aa35186b93','5522ba5ae053074','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b2c59652','60475aa35186b93','55255886b0e2e42','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b2ccce3c','60475aa35186b93','55262fb4d34fbc0','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b2d29922','60475aa35186b93','552ea7c73b78c04','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b2d8614b','60475aa35186b93','5537d807e48c62b','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b2de2c9f','60475aa35186b93','5539081d564cca6','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b2e40c6d','60475aa35186b93','553fe1e308e7e3a','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b2e9ea6c','60475aa35186b93','5541240a041c4ee','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b2f22e5f','60475aa35186b93','554797f3cce46e4','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b2f85037','60475aa35186b93','5547a512d1c5bd2','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b2fe6c8c','60475aa35186b93','55490413c23b81c','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b3047a73','60475aa35186b93','555d8a344f6f95a','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b30a8b48','60475aa35186b93','5569e34f68bcbbb','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b310a684','60475aa35186b93','55fd4a4b286857e','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b31812e4','60475aa35186b93','561191a369a4a78','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b31e7143','60475aa35186b93','561542b85b07cd4','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b324ae5b','60475aa35186b93','561c0a55ec1ed91','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b32a9528','60475aa35186b93','561d62acbdd0ab8','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b33087e7','60475aa35186b93','561feead7838ca8','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b3368794','60475aa35186b93','56200a1fadf03a4','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b33df432','60475aa35186b93','562e7c9f1816a51','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b3489a64','60475aa35186b93','562e80fdcf335fe','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b34f0985','60475aa35186b93','563134ef69e16fd','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b355500a','60475aa35186b93','563137091e32c73','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b35b98b7','60475aa35186b93','5635f36fa9f36bf','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b361dbff','60475aa35186b93','563634de56f2b28','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b369b19a','60475aa35186b93','5636594106c1894','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b3702d02','60475aa35186b93','56521e303a1e26c','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b376a02c','60475aa35186b93','56588495311fece','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b37cb03e','60475aa35186b93','565ac873e409ddc','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b382c4d6','60475aa35186b93','56608bc656a4d24','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b388e3b4','60475aa35186b93','5687b0505b9ec15','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b3901ea6','60475aa35186b93','56883955e3ab0ac','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b39675f1','60475aa35186b93','56a11975eff1dd2','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b39cb986','60475aa35186b93','570a196b80430d3','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b3a30399','60475aa35186b93','56eae990f0fff5f','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b3a94cf0','60475aa35186b93','5712874ac076347','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b3afc0f9','60475aa35186b93','571147d19d7d69a','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b3c737eb','60475aa35186b93','570d43d53aebdc2','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b3cdf441','60475aa35186b93','570c988f9d95164','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b3d4728d','60475aa35186b93','572dbad6497d1fa','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b3dcfe17','60475aa35186b93','572d973a2c31092','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b3e3a9a5','60475aa35186b93','5728fe5eefef00e','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b3ea20f1','60475aa35186b93','57401ba6d83b3e9','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b3f0a5be','60475aa35186b93','57428fad993ae6b','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b3f73063','60475aa35186b93','5742d24537ea41b','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b3fdc76a','60475aa35186b93','577fd4f60b0df80','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b4057461','60475aa35186b93','57449ba8e93ac07','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b40be6ed','60475aa35186b93','57453d968dbad4a','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b41247c3','60475aa35186b93','57459161e5a0363','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b418da44','60475aa35186b93','574bd5bd5a5bede','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b41f4bd6','60475aa35186b93','574ea919042d569','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b425bf36','60475aa35186b93','5753f0e67512c07','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b42d3a63','60475aa35186b93','577ec3a08a5bebe','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b433f564','60475aa35186b93','5788d587dcb311f','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b43acd0f','60475aa35186b93','5788d1d89374f2b','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b441a23f','60475aa35186b93','578a2334d076529','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b4488077','60475aa35186b93','5790f5c50ba72b6','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b45020fd','60475aa35186b93','572b066732990f9','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b456e8c3','60475aa35186b93','579785a44a87d70','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b45d8076','60475aa35186b93','57965e409e50885','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b4640d5c','60475aa35186b93','579a4c58a490a53','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b46aa150','60475aa35186b93','58038a9f6de6bc9','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b47144f8','60475aa35186b93','58038a698b9a3ec','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b479ffb1','60475aa35186b93','580cf554357ba80','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b480e8e0','60475aa35186b93','583a9ecc6d7c907','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b487c3fb','60475aa35186b93','58458875d6799f3','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b48e7ce1','60475aa35186b93','584bdd251a7b996','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b495873f','60475aa35186b93','5995b81c6de4f2e','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b4ad6e86','60475aa35186b93','599efd331c64642','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b4b4dd73','60475aa35186b93','59a17e291687ee8','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b4bbe114','60475aa35186b93','59a29391abf2a01','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b4c3c155','60475aa35186b93','59a844651845ca6','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b4cb0b9e','60475aa35186b93','59a97ae0711178e','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b4d23409','60475aa35186b93','59a9a9964302541','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b4d95338','60475aa35186b93','59b447a587c9f81','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b4e02fea','60475aa35186b93','59cf5a3a12fe151','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b4e77fa8','60475aa35186b93','59cfe983ac3c809','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b4ef0791','60475aa35186b93','59fe057de3b97b4','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b4f603e0','60475aa35186b93','59ea53ae2bbc384','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b4fc8e9c','60475aa35186b93','59eb9e1160272cc','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b5031d6b','60475aa35186b93','59eb9f11d245bfd','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b509b527','60475aa35186b93','59e6312e9944cb9','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b510316a','60475aa35186b93','59ee65967ccd61f','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b517f5af','60475aa35186b93','59ee6a061d547b1','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b51ee02e','60475aa35186b93','59f2469383bbd98','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b525b3c7','60475aa35186b93','59f4d865bbf74c4','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b52c4b24','60475aa35186b93','59f5e72d606d247','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b532d4ed','60475aa35186b93','59f5e965a0dd38c','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b53a6154','60475aa35186b93','5a084a0d4a2a6e6','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b5411d89','60475aa35186b93','5a12e752e9655e6','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b547caa5','60475aa35186b93','5a2becd4c30f6d1','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b54e7578','60475aa35186b93','5a28162b9f2ddc4','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b5551a4c','60475aa35186b93','5a3690cc1299b0a','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b55bd4c8','60475aa35186b93','5a36908c39d6562','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b563d418','60475aa35186b93','5a4f4833bacfc5c','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b56a912f','60475aa35186b93','5a47ce353542e1e','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b57132ce','60475aa35186b93','5a5273258ad81dd','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b577e042','60475aa35186b93','5a60ab1d143a8e7','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b57ea2f8','60475aa35186b93','5a60719e03a40ca','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b58556e5','60475aa35186b93','5a788f06d54e1a2','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b58d5c9e','60475aa35186b93','5a8c6664a38d180','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b59460a7','60475aa35186b93','5a92dae6a2be54b','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b59b5914','60475aa35186b93','5a9d96938c5959e','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b5a2484a','60475aa35186b93','5a9e7622e307049','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b5a922b2','60475aa35186b93','5aa18dc089a2268','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b5b0d86a','60475aa35186b93','5adc50f42d58755','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b5b7b466','60475aa35186b93','5b0f02fc45e374e','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b5be8b4d','60475aa35186b93','5b1f96ff515d327','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b5c55e65','60475aa35186b93','5b5dc66f6d3bbfa','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b5cc4042','60475aa35186b93','5b5cb9cc119131f','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b5d31d06','60475aa35186b93','5b5cb6ec96e8b56','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b5db137a','60475aa35186b93','5b5dc7d35686687','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b5e22b41','60475aa35186b93','5c1e7af53187bff','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b5e932c0','60475aa35186b93','5c83c9358b77ad3','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b5f03765','60475aa35186b93','5c84df1571ef247','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b5f73f8c','60475aa35186b93','5d0dda2ac6ea17d','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b5ff8b02','60475aa35186b93','5f7c42a7aa3146f','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b606fb6b','60475aa35186b93','5f5e56bb6d78a38','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b60e39ff','60475aa35186b93','5f6087c5486319a','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b615730f','60475aa35186b93','5f6888aa4c7548f','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b61cbdb4','60475aa35186b93','5f5e03747627db2','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b624ff94','60475aa35186b93','5f68734969ddcf1','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b62c9689','60475aa35186b93','603804125b80c1b','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('60475b5b63449cf','60475aa35186b93','6039488575f57d2','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin','2021-03-09 13:26:19','globeadmin'),('61d89ad467a71d8','547de3bee410196','6176a844969aad4','2022-01-07 21:56:04','globeadmin','2022-01-07 21:56:04','globeadmin','2022-01-31 16:18:46','globeadmin'),('61d89adc7431a45','5501dbedc785fe4','6176a844969aad4','2022-01-07 21:56:12','globeadmin','2022-01-07 21:56:12','globeadmin','2022-01-07 21:56:12','globeadmin'),('6206e5f3594a980','561928b27d0261b','6206b6bc29d3be4','2022-02-12 00:40:51','globeadmin','2022-02-12 00:40:51','globeadmin','2022-02-12 00:40:51','globeadmin'),('61d9995b484ff18','547de3bee410196','61d954057af2530','2022-01-08 16:02:03','globeadmin','2022-01-08 16:02:03','globeadmin','2022-01-31 16:18:46','globeadmin'),('61d9995ea41ef78','547de3e001028e8','6176a844969aad4','2022-01-08 16:02:06','globeadmin','2022-01-08 16:02:06','globeadmin','2022-01-08 16:02:06','globeadmin'),('61d9995ea484b28','547de3e001028e8','61d954057af2530','2022-01-08 16:02:06','globeadmin','2022-01-08 16:02:06','globeadmin','2022-01-08 16:02:06','globeadmin'),('61d99961dc536fe','5501dbedc785fe4','61d954057af2530','2022-01-08 16:02:09','globeadmin','2022-01-08 16:02:09','globeadmin','2022-01-08 16:02:09','globeadmin'),('61d999653266ffb','5601afbc23dfb00','61d954057af2530','2022-01-08 16:02:13','globeadmin','2022-01-08 16:02:13','globeadmin','2022-01-08 16:02:13','globeadmin'),('61d99968cc653f3','5689468794353da','6176a844969aad4','2022-01-08 16:02:16','globeadmin','2022-01-08 16:02:16','globeadmin','2022-01-08 16:02:16','globeadmin'),('61d99968ccd36ef','5689468794353da','61d954057af2530','2022-01-08 16:02:16','globeadmin','2022-01-08 16:02:16','globeadmin','2022-01-08 16:02:16','globeadmin'),('61d9996c4d7820d','60475aa35186b93','6176a844969aad4','2022-01-08 16:02:20','globeadmin','2022-01-08 16:02:20','globeadmin','2022-01-08 16:02:20','globeadmin'),('61d9996c4dfa606','60475aa35186b93','61d954057af2530','2022-01-08 16:02:20','globeadmin','2022-01-08 16:02:20','globeadmin','2022-01-08 16:02:20','globeadmin'),('61d999b07516579','5717b9c74a31169','61d954057af2530','2022-01-08 16:03:28','globeadmin','2022-01-08 16:03:28','globeadmin','2022-01-08 16:03:28','globeadmin'),('6206e604d3f7548','547de3bee410196','6206b6bc29d3be4','2022-02-12 00:41:08','globeadmin','2022-02-12 00:41:08','globeadmin','2022-02-12 00:41:08','globeadmin'),('6206e60937f158e','5501dbedc785fe4','6206b6bc29d3be4','2022-02-12 00:41:13','globeadmin','2022-02-12 00:41:13','globeadmin','2022-02-12 00:41:13','globeadmin'),('6206e60bf1ef2f7','5601afbc23dfb00','6206b6bc29d3be4','2022-02-12 00:41:15','globeadmin','2022-02-12 00:41:15','globeadmin','2022-02-12 00:41:15','globeadmin'),('6206e619f241d45','5689468794353da','6206b6bc29d3be4','2022-02-12 00:41:29','globeadmin','2022-02-12 00:41:29','globeadmin','2022-02-12 00:41:29','globeadmin'),('6207bb7ddf995fb','547de3e001028e8','6206b6bc29d3be4','2022-02-12 15:51:57','globeadmin','2022-02-12 15:51:57','globeadmin','2022-02-12 15:51:57','globeadmin');
/*!40000 ALTER TABLE `zzzsys_access_level_php` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `zzzsys_access_level_report`
--

DROP TABLE IF EXISTS `zzzsys_access_level_report`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `zzzsys_access_level_report` (
  `zzzsys_access_level_report_id` varchar(25) NOT NULL,
  `slr_zzzsys_access_level_id` varchar(25) DEFAULT NULL,
  `slr_zzzsys_report_id` varchar(25) DEFAULT NULL,
  `zzzsys_access_level_report_log_added_at` datetime NOT NULL,
  `zzzsys_access_level_report_log_added_by` varchar(25) NOT NULL,
  `zzzsys_access_level_report_log_changed_at` datetime NOT NULL,
  `zzzsys_access_level_report_log_changed_by` varchar(25) NOT NULL,
  `zzzsys_access_level_report_log_viewed_at` datetime NOT NULL,
  `zzzsys_access_level_report_log_viewed_by` varchar(25) NOT NULL,
  PRIMARY KEY (`zzzsys_access_level_report_id`),
  KEY `slr_zzzsys_access_level_id` (`slr_zzzsys_access_level_id`),
  KEY `slr_zzzsys_report_id` (`slr_zzzsys_report_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `zzzsys_access_level_report`
--

LOCK TABLES `zzzsys_access_level_report` WRITE;
/*!40000 ALTER TABLE `zzzsys_access_level_report` DISABLE KEYS */;
INSERT INTO `zzzsys_access_level_report` VALUES ('549842d82e31880','547de3e001028e8','54984128358902b','2014-12-22 18:12:08','globeadmin','2014-12-22 18:12:08','globeadmin','2019-11-06 15:15:10','globeadmin'),('54a04d1d1c2f1ad','547de3e001028e8','549ef5f9e44b43a','2014-12-28 20:34:05','globeadmin','2014-12-28 20:34:05','globeadmin','2019-11-06 15:15:10','globeadmin'),('5501dbee0df87c7','5501dbedc785fe4','54f1bf4c1f13912','2015-03-12 20:33:18','globeadmin','2015-03-12 20:33:18','globeadmin','2018-01-09 18:51:14','globeadmin'),('5501dbee01c4d80','5501dbedc785fe4','54f1a5592b47fb0','2015-03-12 20:33:18','globeadmin','2015-03-12 20:33:18','globeadmin','2018-01-09 18:51:14','globeadmin'),('5501dbedec260a2','5501dbedc785fe4','549ef5f9e44b43a','2015-03-12 20:33:18','globeadmin','2015-03-12 20:33:18','globeadmin','2018-01-09 18:51:13','globeadmin'),('5501dbedd3bad23','5501dbedc785fe4','54984128358902b','2015-03-12 20:33:18','globeadmin','2015-03-12 20:33:18','globeadmin','2018-01-09 18:51:13','globeadmin'),('5501dbede25fa35','5501dbedc785fe4','54a3e993669f5ae','2015-03-12 20:33:18','globeadmin','2015-03-12 20:33:18','globeadmin','2018-01-09 18:51:13','globeadmin'),('54f7f9887ff3181','547de3e001028e8','54f1bf4c1f13912','2015-03-05 08:36:56','globeadmin','2015-03-05 08:36:56','globeadmin','2019-11-06 15:15:11','globeadmin'),('5522cebeef2ab44','5501dbedc785fe4','55216527cffb240','2015-04-06 21:21:51','globeadmin','2015-04-06 21:21:51','globeadmin','2018-01-09 18:51:13','globeadmin'),('5522cf2a3f61d85','547de3e001028e8','55216527cffb240','2015-04-06 21:23:38','globeadmin','2015-04-06 21:23:38','globeadmin','2019-11-06 15:15:10','globeadmin'),('553201832d29ab7','547de3e001028e8','552fc50a0145cb2','2015-04-18 10:02:27','globeadmin','2015-04-18 10:02:27','globeadmin','2019-11-06 15:15:10','globeadmin'),('553201aa5b8df25','5501dbedc785fe4','552fc50a0145cb2','2015-04-18 10:03:06','globeadmin','2015-04-18 10:03:06','globeadmin','2018-01-09 18:51:13','globeadmin'),('55393db72306474','547de3e001028e8','553917b8d7b07cc','2015-04-23 21:45:11','globeadmin','2015-04-23 21:45:11','globeadmin','2019-11-06 15:15:09','globeadmin'),('55393dd0c699457','5501dbedc785fe4','553917b8d7b07cc','2015-04-23 21:45:37','globeadmin','2015-04-23 21:45:37','globeadmin','2018-01-09 18:51:13','globeadmin'),('553d0b42845299a','547de3e001028e8','553cfc2bbc79d34','2015-04-26 18:58:58','globeadmin','2015-04-26 18:58:58','globeadmin','2019-11-06 15:15:10','globeadmin'),('553d2e70c8ae79e','5501dbedc785fe4','553cfc2bbc79d34','2015-04-26 00:00:00','globeadmin','2015-04-26 00:00:00','globeadmin','2018-01-09 18:51:13','globeadmin'),('5561850f7b904fc','547de3e001028e8','555e385e069287c','2015-05-24 11:00:15','globeadmin','2015-05-24 11:00:15','globeadmin','2019-11-06 15:15:10','globeadmin'),('556185986f5a0eb','5501dbedc785fe4','555e385e069287c','2015-05-24 00:00:00','globeadmin','2015-05-24 00:00:00','globeadmin','2018-01-09 18:51:13','globeadmin'),('556460b6bcfd206','547de3e001028e8','556460424caeb6a','2015-05-26 15:01:58','globeadmin','2015-05-26 15:01:58','globeadmin','2019-11-06 15:15:10','globeadmin'),('5564611d4079490','5501dbedc785fe4','556460424caeb6a','2015-05-26 00:00:00','globeadmin','2015-05-26 00:00:00','globeadmin','2018-01-09 18:51:13','globeadmin'),('556f52eda847e9f','5501dbedc785fe4','556dfec63aa0e9d','2015-06-03 00:00:00','globeadmin','2015-06-03 00:00:00','globeadmin','2018-01-09 18:51:14','globeadmin'),('560a52f496f04be','547de3bee410196','54f1bf4c1f13912','2015-09-29 11:59:32','globeadmin','2015-09-29 11:59:32','globeadmin','2022-01-31 16:18:42','globeadmin'),('560a52f49e43363','547de3bee410196','54f1a5592b47fb0','2015-09-29 11:59:32','globeadmin','2015-09-29 11:59:32','globeadmin','2022-01-31 16:18:42','globeadmin'),('560a52f4a596359','547de3bee410196','549ef5f9e44b43a','2015-09-29 11:59:32','globeadmin','2015-09-29 11:59:32','globeadmin','2022-01-31 16:18:42','globeadmin'),('560a52f4ace9441','547de3bee410196','54984128358902b','2015-09-29 11:59:32','globeadmin','2015-09-29 11:59:32','globeadmin','2022-01-31 16:18:42','globeadmin'),('560a52f4b43c3af','547de3bee410196','54a3e993669f5ae','2015-09-29 11:59:32','globeadmin','2015-09-29 11:59:32','globeadmin','2022-01-31 16:18:42','globeadmin'),('560a52f4bb8f82d','547de3bee410196','55216527cffb240','2015-09-29 11:59:32','globeadmin','2015-09-29 11:59:32','globeadmin','2022-01-31 16:18:42','globeadmin'),('560a52f4c2e24db','547de3bee410196','552fc50a0145cb2','2015-09-29 11:59:32','globeadmin','2015-09-29 11:59:32','globeadmin','2022-01-31 16:18:42','globeadmin'),('560a52f4ca353f2','547de3bee410196','553917b8d7b07cc','2015-09-29 11:59:32','globeadmin','2015-09-29 11:59:32','globeadmin','2022-01-31 16:18:42','globeadmin'),('560a52f4d1886d1','547de3bee410196','553cfc2bbc79d34','2015-09-29 11:59:32','globeadmin','2015-09-29 11:59:32','globeadmin','2022-01-31 16:18:42','globeadmin'),('560a52f4d8db3ec','547de3bee410196','555e385e069287c','2015-09-29 11:59:32','globeadmin','2015-09-29 11:59:32','globeadmin','2022-01-31 16:18:42','globeadmin'),('560a52f4e02e3f2','547de3bee410196','556460424caeb6a','2015-09-29 11:59:32','globeadmin','2015-09-29 11:59:32','globeadmin','2022-01-31 16:18:42','globeadmin'),('560a52f4e7814aa','547de3bee410196','556dfec63aa0e9d','2015-09-29 11:59:32','globeadmin','2015-09-29 11:59:32','globeadmin','2022-01-31 16:18:42','globeadmin'),('561820cc3630624','5601afbc23dfb00','54f1bf4c1f13912','2015-10-09 23:17:16','globeadmin','2015-10-09 23:17:16','globeadmin','2018-11-20 14:42:15','globeadmin'),('561820cc3d82668','5601afbc23dfb00','54f1a5592b47fb0','2015-10-09 23:17:16','globeadmin','2015-10-09 23:17:16','globeadmin','2018-11-20 14:42:15','globeadmin'),('561820cc44d566e','5601afbc23dfb00','549ef5f9e44b43a','2015-10-09 23:17:16','globeadmin','2015-10-09 23:17:16','globeadmin','2018-11-20 14:42:14','globeadmin'),('561820cc4c286c6','5601afbc23dfb00','54984128358902b','2015-10-09 23:17:16','globeadmin','2015-10-09 23:17:16','globeadmin','2018-11-20 14:42:14','globeadmin'),('561820cc537b691','5601afbc23dfb00','54a3e993669f5ae','2015-10-09 23:17:16','globeadmin','2015-10-09 23:17:16','globeadmin','2018-11-20 14:42:14','globeadmin'),('561820cc5ace6a2','5601afbc23dfb00','55216527cffb240','2015-10-09 23:17:16','globeadmin','2015-10-09 23:17:16','globeadmin','2018-11-20 14:42:13','globeadmin'),('561820cc62216f7','5601afbc23dfb00','552fc50a0145cb2','2015-10-09 23:17:16','globeadmin','2015-10-09 23:17:16','globeadmin','2018-11-20 14:42:13','globeadmin'),('561820cc69745dc','5601afbc23dfb00','553917b8d7b07cc','2015-10-09 23:17:16','globeadmin','2015-10-09 23:17:16','globeadmin','2018-11-20 14:42:13','globeadmin'),('561820cc70c76d1','5601afbc23dfb00','553cfc2bbc79d34','2015-10-09 23:17:16','globeadmin','2015-10-09 23:17:16','globeadmin','2018-11-20 14:42:13','globeadmin'),('561820cc781a5ce','5601afbc23dfb00','555e385e069287c','2015-10-09 23:17:16','globeadmin','2015-10-09 23:17:16','globeadmin','2018-11-20 14:42:14','globeadmin'),('561820cc7f6d6bb','5601afbc23dfb00','556460424caeb6a','2015-10-09 23:17:16','globeadmin','2015-10-09 23:17:16','globeadmin','2018-11-20 14:42:14','globeadmin'),('561820cc86c09d9','5601afbc23dfb00','556dfec63aa0e9d','2015-10-09 23:17:16','globeadmin','2015-10-09 23:17:16','globeadmin','2018-11-20 14:42:15','globeadmin'),('568949cbee8bfb3','5689468794353da','54f1bf4c1f13912','2016-01-03 18:18:19','globeadmin','2016-01-03 18:18:19','globeadmin','2016-02-09 20:38:04','globeadmin'),('565b34a45dd9f51','547de3bee410196','565b04ea7d96cc4','2015-11-29 19:23:48','globeadmin','2015-11-29 19:23:48','globeadmin','2022-01-31 16:18:42','globeadmin'),('565b34af9600d0b','5501dbedc785fe4','565b04ea7d96cc4','2015-11-29 19:23:59','globeadmin','2015-11-29 19:23:59','globeadmin','2018-01-09 18:51:13','globeadmin'),('565b34b28278cce','5601afbc23dfb00','565b04ea7d96cc4','2015-11-29 19:24:02','globeadmin','2015-11-29 19:24:02','globeadmin','2018-11-20 14:42:14','globeadmin'),('568949cc01b9473','5689468794353da','54f1a5592b47fb0','2016-01-03 18:18:20','globeadmin','2016-01-03 18:18:20','globeadmin','2016-02-09 20:38:04','globeadmin'),('568949cc090c22b','5689468794353da','549ef5f9e44b43a','2016-01-03 18:18:20','globeadmin','2016-01-03 18:18:20','globeadmin','2016-02-09 20:38:04','globeadmin'),('568949cc105f20f','5689468794353da','54984128358902b','2016-01-03 18:18:20','globeadmin','2016-01-03 18:18:20','globeadmin','2016-02-09 20:38:04','globeadmin'),('568949cc17b21f2','5689468794353da','54a3e993669f5ae','2016-01-03 18:18:20','globeadmin','2016-01-03 18:18:20','globeadmin','2016-02-09 20:38:04','globeadmin'),('568949cc1f05167','5689468794353da','55216527cffb240','2016-01-03 18:18:20','globeadmin','2016-01-03 18:18:20','globeadmin','2016-02-09 20:38:04','globeadmin'),('568949cc265820f','5689468794353da','552fc50a0145cb2','2016-01-03 18:18:20','globeadmin','2016-01-03 18:18:20','globeadmin','2016-02-09 20:38:04','globeadmin'),('568949cc2db2331','5689468794353da','553917b8d7b07cc','2016-01-03 18:18:20','globeadmin','2016-01-03 18:18:20','globeadmin','2016-02-09 20:38:04','globeadmin'),('568949cc34fe837','5689468794353da','553cfc2bbc79d34','2016-01-03 18:18:20','globeadmin','2016-01-03 18:18:20','globeadmin','2016-02-09 20:38:04','globeadmin'),('568949cc3c5114e','5689468794353da','555e385e069287c','2016-01-03 18:18:20','globeadmin','2016-01-03 18:18:20','globeadmin','2016-02-09 20:38:04','globeadmin'),('568949cc43a4675','5689468794353da','556460424caeb6a','2016-01-03 18:18:20','globeadmin','2016-01-03 18:18:20','globeadmin','2016-02-09 20:38:04','globeadmin'),('568949cc4af723b','5689468794353da','556dfec63aa0e9d','2016-01-03 18:18:20','globeadmin','2016-01-03 18:18:20','globeadmin','2016-02-09 20:38:05','globeadmin'),('568949cc524a15f','5689468794353da','565b04ea7d96cc4','2016-01-03 18:18:20','globeadmin','2016-01-03 18:18:20','globeadmin','2016-02-09 20:38:05','globeadmin'),('56efa60bafa6ae0','547de3bee410196','56eefe2e7a0f4b7','2016-03-21 09:43:07','globeadmin','2016-03-21 09:43:07','globeadmin','2022-01-31 16:18:42','globeadmin'),('56adbec69a2e83e','547de3bee410196','56a48e641bec142','2016-01-31 09:59:02','globeadmin','2016-01-31 09:59:02','globeadmin','2022-01-31 16:18:42','globeadmin'),('56adbec6a181701','547de3bee410196','56a4a92f31e4ef8','2016-01-31 09:59:02','globeadmin','2016-01-31 09:59:02','globeadmin','2022-01-31 16:18:42','globeadmin'),('56adbecacd740ad','547de3e001028e8','56a48e641bec142','2016-01-31 09:59:06','globeadmin','2016-01-31 09:59:06','globeadmin','2019-11-06 15:15:10','globeadmin'),('56adbecad4c6b9a','547de3e001028e8','56a4a92f31e4ef8','2016-01-31 09:59:06','globeadmin','2016-01-31 09:59:06','globeadmin','2019-11-06 15:15:10','globeadmin'),('56adbececd737b8','5501dbedc785fe4','56a48e641bec142','2016-01-31 09:59:10','globeadmin','2016-01-31 09:59:10','globeadmin','2018-01-09 18:51:13','globeadmin'),('56adbeced4c6789','5501dbedc785fe4','56a4a92f31e4ef8','2016-01-31 09:59:10','globeadmin','2016-01-31 09:59:10','globeadmin','2018-01-09 18:51:13','globeadmin'),('56adbed23615880','5601afbc23dfb00','56a48e641bec142','2016-01-31 09:59:14','globeadmin','2016-01-31 09:59:14','globeadmin','2018-11-20 14:42:13','globeadmin'),('56adbed23d687ec','5601afbc23dfb00','56a4a92f31e4ef8','2016-01-31 09:59:14','globeadmin','2016-01-31 09:59:14','globeadmin','2018-11-20 14:42:13','globeadmin'),('56adbed63d687d1','5689468794353da','56a48e641bec142','2016-01-31 09:59:18','globeadmin','2016-01-31 09:59:18','globeadmin','2016-02-09 20:38:05','globeadmin'),('56adbed644bb7a0','5689468794353da','56a4a92f31e4ef8','2016-01-31 09:59:18','globeadmin','2016-01-31 09:59:18','globeadmin','2016-02-09 20:38:05','globeadmin'),('56efa61099ae231','547de3e001028e8','56eefe2e7a0f4b7','2016-03-21 09:43:12','globeadmin','2016-03-21 09:43:12','globeadmin','2019-11-06 15:15:11','globeadmin'),('56efa6165f14126','5501dbedc785fe4','56eefe2e7a0f4b7','2016-03-21 09:43:18','globeadmin','2016-03-21 09:43:18','globeadmin','2018-01-09 18:51:14','globeadmin'),('56efa61a491cae8','5689468794353da','56eefe2e7a0f4b7','2016-03-21 09:43:22','globeadmin','2016-03-21 09:43:22','globeadmin','2016-03-21 09:43:22','globeadmin'),('56efa66383b4a3a','5601afbc23dfb00','56eefe2e7a0f4b7','2016-03-21 09:44:35','globeadmin','2016-03-21 09:44:35','globeadmin','2018-11-20 14:42:14','globeadmin'),('57460da71a1ecd5','547de3bee410196','5745eed0d13a1e0','2016-05-25 23:40:07','globeadmin','2016-05-25 23:40:07','globeadmin','2022-01-31 16:18:42','globeadmin'),('57460daa9912c29','547de3e001028e8','5745eed0d13a1e0','2016-05-25 23:40:10','globeadmin','2016-05-25 23:40:10','globeadmin','2019-11-06 15:15:10','globeadmin'),('57460daed88cba0','5501dbedc785fe4','5745eed0d13a1e0','2016-05-25 23:40:14','globeadmin','2016-05-25 23:40:14','globeadmin','2018-01-09 18:51:13','globeadmin'),('57460db40907a4b','5601afbc23dfb00','5745eed0d13a1e0','2016-05-25 23:40:20','globeadmin','2016-05-25 23:40:20','globeadmin','2018-11-20 14:42:14','globeadmin'),('57460db88cddd93','5689468794353da','5745eed0d13a1e0','2016-05-25 23:40:24','globeadmin','2016-05-25 23:40:24','globeadmin','2016-05-25 23:40:24','globeadmin'),('5798933d9937621','561928b27d0261b','57978ed5f08be11','2016-07-27 13:55:57','globeadmin','2016-07-27 13:55:57','globeadmin','2016-07-27 13:55:57','globeadmin'),('57989351044a1fc','547de3bee410196','57965aa71a7c002','2016-07-27 13:56:17','globeadmin','2016-07-27 13:56:17','globeadmin','2022-01-31 16:18:42','globeadmin'),('579893510b9d06f','547de3bee410196','57978ed5f08be11','2016-07-27 13:56:17','globeadmin','2016-07-27 13:56:17','globeadmin','2016-07-27 13:56:17','globeadmin'),('57989354eeaa13a','547de3e001028e8','57965aa71a7c002','2016-07-27 13:56:20','globeadmin','2016-07-27 13:56:20','globeadmin','2019-11-06 15:15:10','globeadmin'),('5798935501d9251','547de3e001028e8','57978ed5f08be11','2016-07-27 13:56:21','globeadmin','2016-07-27 13:56:21','globeadmin','2016-07-27 13:56:21','globeadmin'),('579893591cb3f32','547de3fe0d36089','57965aa71a7c002','2016-07-27 13:56:25','globeadmin','2016-07-27 13:56:25','globeadmin','2019-07-01 11:07:02','globeadmin'),('57989359267a03e','547de3fe0d36089','57978ed5f08be11','2016-07-27 13:56:25','globeadmin','2016-07-27 13:56:25','globeadmin','2016-07-27 13:56:25','globeadmin'),('5798935ce005c99','5501dbedc785fe4','57965aa71a7c002','2016-07-27 13:56:28','globeadmin','2016-07-27 13:56:28','globeadmin','2018-01-09 18:51:13','globeadmin'),('5798935ce757096','5501dbedc785fe4','57978ed5f08be11','2016-07-27 13:56:28','globeadmin','2016-07-27 13:56:28','globeadmin','2016-07-27 13:56:28','globeadmin'),('57989362c2b8059','5601afbc23dfb00','57965aa71a7c002','2016-07-27 13:56:34','globeadmin','2016-07-27 13:56:34','globeadmin','2018-11-20 14:42:14','globeadmin'),('57989362ca0b335','5601afbc23dfb00','57978ed5f08be11','2016-07-27 13:56:34','globeadmin','2016-07-27 13:56:34','globeadmin','2016-07-27 13:56:34','globeadmin'),('579893665ea08c1','5689468794353da','57965aa71a7c002','2016-07-27 13:56:38','globeadmin','2016-07-27 13:56:38','globeadmin','2016-07-27 13:56:38','globeadmin'),('5798936665f1fec','5689468794353da','57978ed5f08be11','2016-07-27 13:56:38','globeadmin','2016-07-27 13:56:38','globeadmin','2016-07-27 13:56:38','globeadmin'),('5798936a5e9f175','5717b9c74a31169','57965aa71a7c002','2016-07-27 13:56:42','globeadmin','2016-07-27 13:56:42','globeadmin','2017-10-15 19:02:10','globeadmin'),('5798936a65f2029','5717b9c74a31169','57978ed5f08be11','2016-07-27 13:56:42','globeadmin','2016-07-27 13:56:42','globeadmin','2016-07-27 13:56:42','globeadmin'),('57992440e408ac7','547de3bee410196','57991b2b036e45b','2016-07-28 00:14:40','globeadmin','2016-07-28 00:14:40','globeadmin','2022-01-31 16:18:42','globeadmin'),('57992444c1daa93','547de3e001028e8','57991b2b036e45b','2016-07-28 00:14:44','globeadmin','2016-07-28 00:14:44','globeadmin','2019-11-06 15:15:10','globeadmin'),('57992447df26879','547de3fe0d36089','57991b2b036e45b','2016-07-28 00:14:47','globeadmin','2016-07-28 00:14:47','globeadmin','2019-07-01 11:07:02','globeadmin'),('5799244bb5a5853','5501dbedc785fe4','57991b2b036e45b','2016-07-28 00:14:51','globeadmin','2016-07-28 00:14:51','globeadmin','2018-01-09 18:51:13','globeadmin'),('5799244f196583d','5601afbc23dfb00','57991b2b036e45b','2016-07-28 00:14:55','globeadmin','2016-07-28 00:14:55','globeadmin','2018-11-20 14:42:14','globeadmin'),('579924530d329f5','5689468794353da','57991b2b036e45b','2016-07-28 00:14:59','globeadmin','2016-07-28 00:14:59','globeadmin','2016-07-28 00:14:59','globeadmin'),('579924572a7c8ef','5717b9c74a31169','57991b2b036e45b','2016-07-28 00:15:03','globeadmin','2016-07-28 00:15:03','globeadmin','2017-10-15 19:02:10','globeadmin'),('58469c2102952b2','547de3bee410196','584596d4e28b331','2016-12-06 13:08:17','globeadmin','2016-12-06 13:08:17','globeadmin','2022-01-31 16:18:42','globeadmin'),('58469c24f1d409d','547de3e001028e8','584596d4e28b331','2016-12-06 13:08:20','globeadmin','2016-12-06 13:08:20','globeadmin','2019-11-06 15:15:11','globeadmin'),('58469c273f99631','547de3fe0d36089','584596d4e28b331','2016-12-06 13:08:23','globeadmin','2016-12-06 13:08:23','globeadmin','2019-07-01 11:07:02','globeadmin'),('58469c29ea7d63e','5501dbedc785fe4','584596d4e28b331','2016-12-06 13:08:25','globeadmin','2016-12-06 13:08:25','globeadmin','2018-01-09 18:51:14','globeadmin'),('58469c2ce810f06','5601afbc23dfb00','584596d4e28b331','2016-12-06 13:08:28','globeadmin','2016-12-06 13:08:28','globeadmin','2018-11-20 14:42:15','globeadmin'),('58469c2fde44d5f','5689468794353da','584596d4e28b331','2016-12-06 13:08:31','globeadmin','2016-12-06 13:08:31','globeadmin','2016-12-06 13:08:31','globeadmin'),('58469c33c84cd6b','5717b9c74a31169','584596d4e28b331','2016-12-06 13:08:35','globeadmin','2016-12-06 13:08:35','globeadmin','2017-10-15 19:02:10','globeadmin'),('5a1673d703cc817','547de3bee410196','5a15dd9989051f3','2017-11-23 09:08:07','globeadmin','2017-11-23 09:08:07','globeadmin','2022-01-31 16:18:42','globeadmin'),('5a1673da7417fb2','5501dbedc785fe4','5a15dd9989051f3','2017-11-23 09:08:10','globeadmin','2017-11-23 09:08:10','globeadmin','2018-01-09 18:51:13','globeadmin'),('5a1673dce4643b4','5601afbc23dfb00','5a15dd9989051f3','2017-11-23 09:08:12','globeadmin','2017-11-23 09:08:12','globeadmin','2018-11-20 14:42:14','globeadmin'),('5a1673e2c232386','5689468794353da','5a15dd9989051f3','2017-11-23 09:08:18','globeadmin','2017-11-23 09:08:18','globeadmin','2017-11-23 09:08:18','globeadmin'),('5a4e60ca08ef331','547de3bee410196','5a4b96939f5f56f','2018-01-04 19:13:46','globeadmin','2018-01-04 19:13:46','globeadmin','2022-01-31 16:18:42','globeadmin'),('5a4e60cd9684b68','547de3e001028e8','5a4b96939f5f56f','2018-01-04 19:13:49','globeadmin','2018-01-04 19:13:49','globeadmin','2019-11-06 15:15:11','globeadmin'),('5a4e60d9ac7618a','5501dbedc785fe4','5a4b96939f5f56f','2018-01-04 19:14:01','globeadmin','2018-01-04 19:14:01','globeadmin','2018-01-09 18:51:14','globeadmin'),('5a4e60dc8081d73','5601afbc23dfb00','5a4b96939f5f56f','2018-01-04 19:14:04','globeadmin','2018-01-04 19:14:04','globeadmin','2018-11-20 14:42:15','globeadmin'),('5a4e60dfbff80a3','5689468794353da','5a4b96939f5f56f','2018-01-04 19:14:07','globeadmin','2018-01-04 19:14:07','globeadmin','2018-01-04 19:14:07','globeadmin'),('5a527e7eac167b7','547de3bee410196','5a521da19c2dba4','2018-01-07 22:09:34','globeadmin','2018-01-07 22:09:34','globeadmin','2022-01-31 16:18:42','globeadmin'),('5a527e822d1f4e8','547de3e001028e8','5a521da19c2dba4','2018-01-07 22:09:38','globeadmin','2018-01-07 22:09:38','globeadmin','2019-11-06 15:15:11','globeadmin'),('5a527e84cbce489','5501dbedc785fe4','5a521da19c2dba4','2018-01-07 22:09:40','globeadmin','2018-01-07 22:09:40','globeadmin','2018-01-09 18:51:14','globeadmin'),('5a527e8731fe344','5601afbc23dfb00','5a521da19c2dba4','2018-01-07 22:09:43','globeadmin','2018-01-07 22:09:43','globeadmin','2018-11-20 14:42:14','globeadmin'),('5a527e8c25c6648','5689468794353da','5a521da19c2dba4','2018-01-07 22:09:48','globeadmin','2018-01-07 22:09:48','globeadmin','2018-01-07 22:09:48','globeadmin'),('5a8ae843763bb04','547de3bee410196','5a8adb1f1beccd3','2018-02-19 17:07:47','globeadmin','2018-02-19 17:07:47','globeadmin','2022-01-31 16:18:42','globeadmin'),('5a8ae8437d8e9da','547de3bee410196','5a8add5aeea826d','2018-02-19 17:07:47','globeadmin','2018-02-19 17:07:47','globeadmin','2022-01-31 16:18:42','globeadmin'),('5a8ae846ae69f20','547de3e001028e8','5a8adb1f1beccd3','2018-02-19 17:07:50','globeadmin','2018-02-19 17:07:50','globeadmin','2019-11-06 15:15:10','globeadmin'),('5a8ae846b5c0c8f','547de3e001028e8','5a8add5aeea826d','2018-02-19 17:07:50','globeadmin','2018-02-19 17:07:50','globeadmin','2019-11-06 15:15:10','globeadmin'),('5a8ae84c0105619','5501dbedc785fe4','5a8adb1f1beccd3','2018-02-19 17:07:56','globeadmin','2018-02-19 17:07:56','globeadmin','2018-02-19 17:07:56','globeadmin'),('5a8ae84c0858767','5501dbedc785fe4','5a8add5aeea826d','2018-02-19 17:07:56','globeadmin','2018-02-19 17:07:56','globeadmin','2018-02-19 17:07:56','globeadmin'),('5a8ae84ed0884e0','5601afbc23dfb00','5a8adb1f1beccd3','2018-02-19 17:07:58','globeadmin','2018-02-19 17:07:58','globeadmin','2018-11-20 14:42:13','globeadmin'),('5a8ae84ed7db226','5601afbc23dfb00','5a8add5aeea826d','2018-02-19 17:07:58','globeadmin','2018-02-19 17:07:58','globeadmin','2018-11-20 14:42:13','globeadmin'),('5a8ae8529ad9e7a','5689468794353da','5a8adb1f1beccd3','2018-02-19 17:08:02','globeadmin','2018-02-19 17:08:02','globeadmin','2018-02-19 17:08:02','globeadmin'),('5a8ae852a228499','5689468794353da','5a8add5aeea826d','2018-02-19 17:08:02','globeadmin','2018-02-19 17:08:02','globeadmin','2018-02-19 17:08:02','globeadmin'),('5b689502d5902f1','547de3bee410196','5b67ff45182fe35','2018-08-06 21:35:46','globeadmin','2018-08-06 21:35:46','globeadmin','2022-01-31 16:18:42','globeadmin'),('5b689502dce0617','547de3bee410196','5b67ff6dad11ea9','2018-08-06 21:35:46','globeadmin','2018-08-06 21:35:46','globeadmin','2022-01-31 16:18:42','globeadmin'),('5b689507ac039b2','547de3e001028e8','5b67ff45182fe35','2018-08-06 21:35:51','globeadmin','2018-08-06 21:35:51','globeadmin','2019-11-06 15:15:11','globeadmin'),('5b689507b35690f','547de3e001028e8','5b67ff6dad11ea9','2018-08-06 21:35:51','globeadmin','2018-08-06 21:35:51','globeadmin','2019-11-06 15:15:10','globeadmin'),('5b68950e98771f8','5501dbedc785fe4','5b67ff45182fe35','2018-08-06 21:35:58','globeadmin','2018-08-06 21:35:58','globeadmin','2018-08-06 21:35:58','globeadmin'),('5b68950e9fca3e9','5501dbedc785fe4','5b67ff6dad11ea9','2018-08-06 21:35:58','globeadmin','2018-08-06 21:35:58','globeadmin','2018-08-06 21:35:58','globeadmin'),('5b68951145747d3','5601afbc23dfb00','5b67ff45182fe35','2018-08-06 21:36:01','globeadmin','2018-08-06 21:36:01','globeadmin','2018-11-20 14:42:14','globeadmin'),('5b6895114cc6a2f','5601afbc23dfb00','5b67ff6dad11ea9','2018-08-06 21:36:01','globeadmin','2018-08-06 21:36:01','globeadmin','2018-11-20 14:42:14','globeadmin'),('5b689514e1b1b25','5689468794353da','5b67ff45182fe35','2018-08-06 21:36:04','globeadmin','2018-08-06 21:36:04','globeadmin','2018-08-06 21:36:04','globeadmin'),('5b689514e9049e7','5689468794353da','5b67ff6dad11ea9','2018-08-06 21:36:04','globeadmin','2018-08-06 21:36:04','globeadmin','2018-08-06 21:36:04','globeadmin'),('5bf4008adcf0015','547de3bee410196','5bf3263959be988','2018-11-20 14:39:38','globeadmin','2018-11-20 14:39:38','globeadmin','2022-01-31 16:18:42','globeadmin'),('5bf4008ae43ec00','547de3bee410196','5bf3268b46322c6','2018-11-20 14:39:38','globeadmin','2018-11-20 14:39:38','globeadmin','2022-01-31 16:18:42','globeadmin'),('5bf40090654cbfa','547de3e001028e8','5bf3263959be988','2018-11-20 14:39:44','globeadmin','2018-11-20 14:39:44','globeadmin','2019-11-06 15:15:10','globeadmin'),('5bf400906cd4cb2','547de3e001028e8','5bf3268b46322c6','2018-11-20 14:39:44','globeadmin','2018-11-20 14:39:44','globeadmin','2019-11-06 15:15:09','globeadmin'),('5bf400941c010f0','5501dbedc785fe4','5bf3263959be988','2018-11-20 14:39:48','globeadmin','2018-11-20 14:39:48','globeadmin','2018-11-20 14:39:48','globeadmin'),('5bf400942353c89','5501dbedc785fe4','5bf3268b46322c6','2018-11-20 14:39:48','globeadmin','2018-11-20 14:39:48','globeadmin','2018-11-20 14:39:48','globeadmin'),('5bf40096653d55f','5601afbc23dfb00','5bf3263959be988','2018-11-20 14:39:50','globeadmin','2018-11-20 14:39:50','globeadmin','2018-11-20 14:42:13','globeadmin'),('5bf400966c91315','5601afbc23dfb00','5bf3268b46322c6','2018-11-20 14:39:50','globeadmin','2018-11-20 14:39:50','globeadmin','2018-11-20 14:42:13','globeadmin'),('5bf4009c31f48bd','5689468794353da','5bf3263959be988','2018-11-20 14:39:56','globeadmin','2018-11-20 14:39:56','globeadmin','2018-11-20 14:39:56','globeadmin'),('5bf4009c394760b','5689468794353da','5bf3268b46322c6','2018-11-20 14:39:56','globeadmin','2018-11-20 14:39:56','globeadmin','2018-11-20 14:39:56','globeadmin'),('5c094ef24d878bf','547de3bee410196','5c08d35cb0aa3ac','2018-12-06 18:31:46','globeadmin','2018-12-06 18:31:46','globeadmin','2022-01-31 16:18:42','globeadmin'),('5c094ef665f0cb6','5501dbedc785fe4','5c08d35cb0aa3ac','2018-12-06 18:31:50','globeadmin','2018-12-06 18:31:50','globeadmin','2018-12-06 18:31:50','globeadmin'),('5c094ef9610ea06','5601afbc23dfb00','5c08d35cb0aa3ac','2018-12-06 18:31:53','globeadmin','2018-12-06 18:31:53','globeadmin','2018-12-06 18:31:53','globeadmin'),('60475b5aeabab97','60475aa35186b93','54984128358902b','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5aeb32149','60475aa35186b93','549ef5f9e44b43a','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5aeb8b720','60475aa35186b93','54f1bf4c1f13912','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5aebe3b05','60475aa35186b93','55216527cffb240','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5aec3a501','60475aa35186b93','552fc50a0145cb2','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5aec90c59','60475aa35186b93','553917b8d7b07cc','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5aece7f2f','60475aa35186b93','553cfc2bbc79d34','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5aed3f57e','60475aa35186b93','555e385e069287c','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5aedbf043','60475aa35186b93','556460424caeb6a','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5aee1aada','60475aa35186b93','56a48e641bec142','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5aee75249','60475aa35186b93','56a4a92f31e4ef8','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5aeecfe31','60475aa35186b93','56eefe2e7a0f4b7','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5aef2b80a','60475aa35186b93','5745eed0d13a1e0','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5aef871d1','60475aa35186b93','57965aa71a7c002','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5aeff42dc','60475aa35186b93','57978ed5f08be11','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5af0535a5','60475aa35186b93','57991b2b036e45b','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5af0b23ba','60475aa35186b93','584596d4e28b331','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5af11026b','60475aa35186b93','5a4b96939f5f56f','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5af16e026','60475aa35186b93','5a521da19c2dba4','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5af1cc8d2','60475aa35186b93','5a8adb1f1beccd3','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5af22bd45','60475aa35186b93','5a8add5aeea826d','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5af2a0513','60475aa35186b93','5b67ff45182fe35','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5af30362a','60475aa35186b93','5b67ff6dad11ea9','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5af36df47','60475aa35186b93','5bf3263959be988','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin'),('60475b5af3ce317','60475aa35186b93','5bf3268b46322c6','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin','2021-03-09 13:26:18','globeadmin');
/*!40000 ALTER TABLE `zzzsys_access_level_report` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `zzzsys_browse`
--

DROP TABLE IF EXISTS `zzzsys_browse`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `zzzsys_browse` (
  `zzzsys_browse_id` varchar(25) NOT NULL DEFAULT '',
  `sbr_zzzsys_form_id` varchar(25) DEFAULT NULL,
  `sbr_title` varchar(100) DEFAULT NULL,
  `sbr_display` varchar(512) DEFAULT NULL,
  `sbr_align` char(1) DEFAULT NULL,
  `sbr_format` varchar(10) DEFAULT NULL,
  `sbr_searchable` char(1) DEFAULT NULL,
  `sbr_sort` varchar(512) DEFAULT NULL,
  `sbr_sortable` char(1) DEFAULT NULL,
  `sbr_visible` char(1) DEFAULT NULL,
  `sbr_order` int(11) DEFAULT NULL,
  `sbr_width` int(11) DEFAULT NULL,
  `zzzsys_browse_log_added_at` datetime NOT NULL,
  `zzzsys_browse_log_added_by` varchar(25) NOT NULL,
  `zzzsys_browse_log_changed_at` datetime NOT NULL,
  `zzzsys_browse_log_changed_by` varchar(25) NOT NULL,
  `zzzsys_browse_log_viewed_at` datetime NOT NULL,
  `zzzsys_browse_log_viewed_by` varchar(25) NOT NULL,
  PRIMARY KEY (`zzzsys_browse_id`),
  KEY `sbr_zzzsys_form_id` (`sbr_zzzsys_form_id`),
  KEY `sbr_sort` (`sbr_sort`(255))
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `zzzsys_browse`
--

LOCK TABLES `zzzsys_browse` WRITE;
/*!40000 ALTER TABLE `zzzsys_browse` DISABLE KEYS */;
INSERT INTO `zzzsys_browse` VALUES ('51678957425d78f','nurunphp','Description','slp_description','','','1','slp_description',NULL,'1',20,500,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('51678e2f28e6c6b','nurunreport','Code','sre_code','','','1','sre_code',NULL,'1',10,150,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-09-24 12:40:23','globeadmin'),('14575f7c3aad70','nuobject','Tab','sob_all_tab_number','c','','1','sob_all_tab_number','1','1',70,90,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-02-05 10:30:58','globeadmin'),('1502303e4b43aa','nutranslate','Language','trl_language','l','','1','trl_language',NULL,'1',10,100,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('145935537761ee','nuuser','User Group','sug_code','l','','1','sug_code','1','1',20,300,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('1455245046b9fe','nuobject','Order','sob_all_order_number','c','','1','sob_all_order_number','1','1',90,90,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-02-05 10:30:58','globeadmin'),('1459200e0c810b','nulevel','Description','sal_description','l','','1','sal_description','1','1',20,300,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2015-04-14 11:40:59','globeadmin'),('14575d67f6e508','nuobject','Column','sob_all_column_number','c','','1','sob_all_column_number','1','1',80,90,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-02-05 10:30:58','globeadmin'),('51678e2f2e9396c','nurunreport','Group','sre_group','','','1','sre_group',NULL,'1',30,200,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-09-24 12:40:23','globeadmin'),('14624594549f6d','nugroup','Access Level','sal_description','l','','1','sal_description','1','1',30,300,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2013-10-22 14:59:13','globeadmin'),('1455393203f20c','nuobject','Title','sob_all_title','l','','1','sob_all_title','1','1',30,240,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-02-05 10:30:57','globeadmin'),('147312293cf2e2','nuimage','Group','sfi_group','l','','1','sfi_group','1','1',30,200,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-01-17 13:36:18','globeadmin'),('14624598331c6a','nuuser','Access Level','sal_description','l','','1','sal_description','1','1',30,300,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('5269ea1a33db4c6','nudebug','Time','SUBSTR(deb_added,11,9)','l','',NULL,'SUBSTR(deb_added,11,9)',NULL,NULL,20,100,'2013-10-25 14:18:42','globeadmin','2013-10-25 14:20:41','globeadmin','2014-01-10 13:05:23','globeadmin'),('1472e8ca611470','nuimage','Description','sfi_description','l','','1','sfi_description','1','1',20,300,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-01-17 13:36:18','globeadmin'),('521aa4a50c3e360','nudebug','Message','deb_message','l',NULL,NULL,'deb_message',NULL,NULL,30,500,'0000-00-00 00:00:00','','2013-10-25 14:20:41','globeadmin','2014-01-10 13:05:23','globeadmin'),('14589b1adedddc','nuform','Name','sfo_name','l','','1','sfo_name','1','1',10,300,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2015-04-14 11:42:50','globeadmin'),('1455393203f209','nuform','Table','sfo_table','l','','1','sfo_table','1','1',30,300,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2015-04-14 11:42:50','globeadmin'),('5164d44fa4daaad','nureport','Code','sre_code','','','1','sre_code',NULL,'1',10,200,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-09-24 12:40:47','globeadmin'),('5269ea1a1ca5a58','nudebug','Added','deb_added','l','6',NULL,'deb_added',NULL,NULL,10,100,'2013-10-25 14:18:42','globeadmin','2013-10-25 14:20:41','globeadmin','2014-01-10 13:05:23','globeadmin'),('1502303e4b57df','nutranslate','English','trl_english','l','','1','trl_english',NULL,'1',20,450,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('1459354088ccef','nuuser','Name','sus_name','l','','1','sus_name','1','1',10,300,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('5164af4c21a5c00','nuphp','Group','slp_group','','','1','slp_group',NULL,'1',30,200,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2013-11-08 11:19:18','globeadmin'),('52f440e9cd1e25c','nunoaccess','Code','sfo_name','l',NULL,NULL,'sfo_name',NULL,NULL,10,300,'2014-02-07 13:11:53','globeadmin','2014-02-07 13:11:53','globeadmin','2014-02-07 14:06:07','globeadmin'),('5269d98acc454c4','5269ae8512ebfd3','Group','sre_group','l','',NULL,'sre_group',NULL,NULL,30,250,'2013-10-25 13:08:03','globeadmin','2013-10-25 13:08:03','globeadmin','2014-10-21 09:36:20','globeadmin'),('52f440e9d0a6ebf','nunoaccess','Title','sfo_title','l',NULL,NULL,'sfo_title',NULL,NULL,20,300,'2014-02-07 13:11:53','globeadmin','2014-02-07 13:11:53','globeadmin','2014-02-07 14:06:07','globeadmin'),('5164df2fe66185c','nureport','Group','sre_group','','','1','sre_group',NULL,'1',20,200,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-09-24 12:40:47','globeadmin'),('51661887c9dae99','nuformsandsubforms','Description','thedesc','','','1','thedesc',NULL,'1',20,250,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2013-10-10 14:10:12','globeadmin'),('51661887c6fe74e','nuformsandsubforms','Name','thecode','','','1','thecode',NULL,'1',10,150,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2013-10-10 14:10:12','globeadmin'),('5164dfff1e25e91','nureport','PHP Description','slp_description','','','1','slp_description',NULL,'1',40,250,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-09-24 12:40:48','globeadmin'),('1459200e0c7e5b','nulevel','Code','sal_code','l','','1','sal_code','1','1',10,200,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2015-04-14 11:40:59','globeadmin'),('1455245046b9fd','nuobject','Field Name','sob_all_name','l','','1','sob_all_name','1','1',20,200,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-02-05 10:30:57','globeadmin'),('1487ae96ca1b0f','nuobject','fid','sob_zzzsys_form_id','l','','1','form_id',NULL,'0',111,1,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-02-05 10:30:58','globeadmin'),('5164d859900a861','nureport','Description','sre_description','','','1','sre_description',NULL,'1',30,750,'0000-00-00 00:00:00','','2014-09-24 12:40:47','globeadmin','2014-09-24 12:40:48','globeadmin'),('51678705c49ea7f','nurunphp','Code','slp_code','','','1','slp_code',NULL,'1',10,150,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('54ffbe3eeab22dd','nufastform','Description','sfo_title','l',NULL,NULL,'sfo_title',NULL,NULL,20,300,'2015-03-11 14:32:06','globeadmin','2015-03-16 14:49:14','globeadmin','2015-04-15 12:04:02','globeadmin'),('51678957453334b','nurunphp','Group','slp_group','','','1','slp_group',NULL,'1',30,200,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('1455245046b9fz','nuobject','Type','sob_all_type','l','','1','sob_all_type','1','1',40,90,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-02-05 10:30:57','globeadmin'),('5164af4c1c1ff69','nuphp','Code','slp_code','','','1','slp_code',NULL,'1',10,150,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2013-11-08 11:19:18','globeadmin'),('5269d98ab51acb5','5269ae8512ebfd3','Description','sre_description','l','',NULL,'sre_description',NULL,NULL,20,350,'2013-10-25 13:08:03','globeadmin','2014-06-23 10:15:25','globeadmin','2014-10-21 09:36:20','globeadmin'),('54705a95d38efda','54705a95c4e91c2','Όνομα','name','c','','1','name',NULL,'',10,500,'0000-00-00 00:00:00','','2014-11-23 14:52:53','globeadmin','2018-07-29 15:28:17','globeadmin'),('547489b0dc411fc','547489b0d4efe7c','Συντομογραφία','short_name','l','','1','short_name',NULL,'',30,150,'0000-00-00 00:00:00','','2016-07-14 20:05:56','globeadmin','2022-02-14 11:00:18','globeadmin'),('54706cd5067b02f','54706cd4f34daae','Ημέρα','name','c','','1','name',NULL,'',10,500,'0000-00-00 00:00:00','','2014-11-23 14:50:28','globeadmin','2018-07-29 15:29:23','globeadmin'),('54736dab4b73fbe','54736dab44212c7','Τύπος','name','l','','1','name',NULL,'',10,600,'0000-00-00 00:00:00','','2015-11-05 20:15:28','globeadmin','2018-07-29 15:36:05','globeadmin'),('54730f66245d2a0','54730f661a9b822','Λόγος','name','l','','1','name',NULL,'',10,500,'0000-00-00 00:00:00','','2014-11-24 19:31:54','globeadmin','2016-03-05 14:05:15','globeadmin'),('54706f6b4383fcb','54706f6b39c1b38','Τάξη','name','c','','1','name',NULL,'',10,600,'0000-00-00 00:00:00','','2015-11-21 23:01:08','globeadmin','2018-07-29 15:33:29','globeadmin'),('547372d03098f97','547372d029461f4','Συντομογραφία','short_name','l','','1','short_name',NULL,'',10,220,'0000-00-00 00:00:00','','2016-03-29 23:28:45','globeadmin','2021-01-26 20:15:02','globeadmin'),('547070c91ee4d25','547070c91793d3b','Περίοδος Αξιολόγησης','name','c','','1','name',NULL,'',10,500,'0000-00-00 00:00:00','','2017-04-02 21:42:17','globeadmin','2021-09-04 21:36:57','globeadmin'),('54707442aa0e2fd','54707442a2bcae4','Διδακτική Ώρα','name','c','','1','name',NULL,'',10,500,'0000-00-00 00:00:00','','2014-11-23 14:43:22','globeadmin','2019-11-03 18:24:57','globeadmin'),('547078878f37596','5470788787e004a','Λόγος Διαγραφής','name','l','','1','name',NULL,'',10,650,'0000-00-00 00:00:00','','2018-08-05 12:39:18','globeadmin','2018-08-09 18:08:31','globeadmin'),('54707c861a02d06','54707c8612b1b6b','Λόγος','name','l','','1','name',NULL,'',10,500,'0000-00-00 00:00:00','','2018-05-05 14:18:28','globeadmin','2019-11-03 18:57:13','globeadmin'),('547080284d47eea','5470802845f7427','Τύπος','name','l','','1','name',NULL,'',10,500,'0000-00-00 00:00:00','','2014-11-23 14:53:38','globeadmin','2020-04-02 11:28:35','globeadmin'),('547081cebb24fac','547081ceb3d2146','Σχ. Έτος','name','l','','1','name',NULL,'',10,500,'0000-00-00 00:00:00','','2014-11-22 14:32:27','globeadmin','2019-11-03 18:27:46','globeadmin'),('5470b3806ad720b','5470b3806384141','Ειδικότητα','name','l','','1','name',NULL,'',20,600,'0000-00-00 00:00:00','','2018-08-05 11:33:53','globeadmin','2018-08-05 11:34:35','globeadmin'),('5470b380722a19f','5470b3806384141','Συντομογραφία','short_name','l','','1','short_name',NULL,'',10,200,'0000-00-00 00:00:00','','2018-08-05 11:33:53','globeadmin','2018-08-05 11:34:35','globeadmin'),('5470b16654de3af','5470b05b91e73a0','Τομέας Μαθημάτων','name','l',NULL,NULL,'name',NULL,NULL,10,600,'2014-11-22 17:53:10','globeadmin','2015-11-21 23:04:07','globeadmin','2018-07-29 15:34:07','globeadmin'),('5470b6d7cef010b','5470b6d7c79d3b9','Τμήμα','short_name','c','','1','short_name',NULL,'',10,400,'0000-00-00 00:00:00','','2017-10-31 11:55:00','globeadmin','2022-01-08 15:26:10','globeadmin'),('5470c0790e111f8','5470c07906bfd70','Σχολείο','short_name','l','','1','short_name',NULL,'',10,500,'0000-00-00 00:00:00','','2014-11-22 19:32:39','globeadmin','2018-01-09 15:24:33','globeadmin'),('547489b0e39418e','547489b0d4efe7c','Όνομα','name','l','','1','name',NULL,'',40,350,'0000-00-00 00:00:00','','2016-07-14 20:05:56','globeadmin','2022-02-14 11:00:18','globeadmin'),('5474c1d7cb2b8b4','5474c1d7bef6b64','Συντομογραφία','short_name','l',NULL,NULL,'short_name',NULL,NULL,10,200,'2014-11-25 19:52:23','globeadmin','2014-11-25 19:52:23','globeadmin','2016-01-04 10:17:01','globeadmin'),('5474c1d7d4efa30','5474c1d7bef6b64','Όνομα','name','l',NULL,NULL,'name',NULL,NULL,20,450,'2014-11-25 19:52:23','globeadmin','2014-12-17 18:39:47','globeadmin','2016-01-04 10:17:02','globeadmin'),('5475af102a08121','547489b0d4efe7c','Βαθμολογείται','if(is_marked,\'Ναι\',\'Όχι\')','c',NULL,NULL,'is_marked',NULL,NULL,60,100,'2014-11-26 12:44:32','globeadmin','2016-07-14 19:58:12','globeadmin','2022-02-14 11:00:18','globeadmin'),('54ce83fd6dcdc4c','54ce7f0188a78ec','Τομέας','s_name','c',NULL,NULL,'section_id',NULL,NULL,20,300,'2015-02-01 21:52:29','globeadmin','2015-11-21 23:26:48','globeadmin','2018-07-29 15:35:19','globeadmin'),('5491b1d35770620','5474c1d7bef6b64','Βαθμολογείται','if(is_marked,\'Ναι\',\'Όχι\')','c',NULL,NULL,'is_marked',NULL,NULL,30,100,'2014-12-17 18:39:47','globeadmin','2014-12-17 18:39:47','globeadmin','2016-01-04 10:17:02','globeadmin'),('54ce7f01926b605','54ce7f0188a78ec','Ειδικότητα','name','l','','1','name',NULL,'',10,650,'0000-00-00 00:00:00','','2015-11-21 23:26:48','globeadmin','2018-07-29 15:35:19','globeadmin'),('5476201e68e31c7','5476201e5a3d38f','Επώνυμο','surname','l',NULL,NULL,'surname',NULL,NULL,10,200,'2014-11-26 20:46:54','globeadmin','2014-11-26 20:46:54','globeadmin','2022-01-08 11:22:25','globeadmin'),('5476201e72a8a2c','5476201e5a3d38f','Όνομα','name','l',NULL,NULL,'name',NULL,NULL,20,200,'2014-11-26 20:46:54','globeadmin','2014-11-26 20:46:54','globeadmin','2022-01-08 11:22:25','globeadmin'),('5476201e7c6cc7c','5476201e5a3d38f','Όνομα Πατρός','fathers_name','l',NULL,NULL,'fathers_name',NULL,NULL,30,200,'2014-11-26 20:46:54','globeadmin','2014-11-26 20:46:54','globeadmin','2022-01-08 11:22:25','globeadmin'),('5476201e8630767','5476201e5a3d38f','ΑΜ','registration_number','c',NULL,NULL,'registration_number',NULL,NULL,40,100,'2014-11-26 20:46:54','globeadmin','2014-11-26 20:50:21','globeadmin','2022-01-08 11:22:25','globeadmin'),('5476201e8ff48a5','5476201e5a3d38f','Τάξη','grade_short_name','c',NULL,NULL,'grade_short_name',NULL,NULL,50,80,'2014-11-26 20:46:54','globeadmin','2014-11-26 20:54:24','globeadmin','2022-01-08 11:22:25','globeadmin'),('554517bdd77a5e4','554517bdc18334d','Φορέας Επιβολής','carrier','l','','1','carrier',NULL,'',40,300,'0000-00-00 00:00:00','','2015-05-02 21:58:09','globeadmin','2022-01-07 21:47:52','globeadmin'),('554517bdd027a31','554517bdc18334d','Ημερομηνία','date_enforced','r','7','1','date_enforced',NULL,'',20,100,'0000-00-00 00:00:00','','2015-05-02 22:00:55','globeadmin','2022-01-07 21:47:52','globeadmin'),('55451e414c52f3b','554517bdc18334d','Τύπος','type','l',NULL,NULL,'type',NULL,NULL,30,200,'2015-05-02 21:58:09','globeadmin','2015-05-02 21:58:09','globeadmin','2022-01-07 21:47:52','globeadmin'),('554517bdc8d4bd8','554517bdc18334d','Μαθητής','student_name','l',NULL,'1','student_id',NULL,'',10,300,'0000-00-00 00:00:00','','2015-05-02 21:56:57','globeadmin','2022-01-07 21:47:52','globeadmin'),('5545ef921fb9972','547489b0d4efe7c','Διδάσκεται','if(subject_id is null,\'Όχι\',\'Διδάσκεται\')','l',NULL,NULL,'subject_id',NULL,NULL,70,100,'2015-05-03 12:51:14','globeadmin','2016-07-14 19:58:12','globeadmin','2022-02-14 11:00:18','globeadmin'),('5612baa6d0e1d3e','55222f79d342b66','Επώνυμο','surname','l',NULL,NULL,'surname',NULL,NULL,10,200,'2015-10-05 21:00:07','globeadmin','2015-10-05 21:00:07','globeadmin','2018-08-14 10:07:24','globeadmin'),('5612baa6dd15763','55222f79d342b66','Όνομα','name','l',NULL,NULL,'name',NULL,NULL,20,200,'2015-10-05 21:00:07','globeadmin','2015-10-05 21:00:07','globeadmin','2018-08-14 10:07:24','globeadmin'),('5612baa6e94a963','55222f79d342b66','Όνομα Πατρός','fathers_name','l',NULL,NULL,'fathers_name',NULL,NULL,30,200,'2015-10-05 21:00:07','globeadmin','2015-10-05 21:00:07','globeadmin','2018-08-14 10:07:24','globeadmin'),('5612baa7015b91e','55222f79d342b66','ΑΜ','registration_number','c',NULL,NULL,'registration_number',NULL,NULL,40,100,'2015-10-05 21:00:07','globeadmin','2015-10-05 21:00:07','globeadmin','2018-08-14 10:07:25','globeadmin'),('5612baa70d90f0d','55222f79d342b66','Τάξη','grade_short_name','c',NULL,NULL,'grade_short_name',NULL,NULL,50,80,'2015-10-05 21:00:07','globeadmin','2015-10-05 21:00:07','globeadmin','2018-08-14 10:07:25','globeadmin'),('52f440e9d60d3e9','nunoaccess','Table','sfo_table','l',NULL,NULL,'sfo_table',NULL,NULL,30,300,'2014-02-07 13:11:53','globeadmin','2014-02-07 13:11:53','globeadmin','2014-02-07 14:06:07','globeadmin'),('5684e68b3c61208','5684e68b302da76','Ενεργό από την Ημερομηνία','start_date','c','7',NULL,'start_date',NULL,NULL,10,400,'2015-12-31 10:25:47','globeadmin','2015-12-31 17:37:19','globeadmin','2021-03-24 11:14:34','globeadmin'),('568545440d677a7','5684e68b302da76','Κατάσταση','if(start_date>pdate,\'Θα Ενεργοποιηθεί\',if(start_date=pdate,\'**** Ενεργό ****\',\'Απενεργοποιημένο\'))','c',NULL,NULL,'pdate',NULL,NULL,20,300,'2015-12-31 17:09:56','globeadmin','2015-12-31 18:23:31','globeadmin','2021-03-24 11:14:34','globeadmin'),('56c9890255b07ad','56c989024e5f43c','Name','name','l','','1','name',NULL,'',10,500,'0000-00-00 00:00:00','','2016-02-21 11:56:19','globeadmin','2017-08-20 15:48:22','globeadmin'),('1472e8ca61083f','nuimage','Code','sfi_code','l','','1','sfi_code','1','1',10,100,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-01-17 13:36:18','globeadmin'),('1455245046b9ff','nuobject','Tab Title','sob_all_tab_title','l','','1','sob_all_tab_title','1','1',50,100,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-02-05 10:30:57','globeadmin'),('1502303e4b6c07','nutranslate','Translation','trl_translation','l','','1','trl_translation',NULL,'1',30,450,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('51678e2f2bc0e29','nurunreport','Description','sre_description','','','0','sre_description',NULL,'1',20,700,'0000-00-00 00:00:00','','2014-09-24 12:40:23','globeadmin','2014-09-24 12:40:23','globeadmin'),('145934f0f1a899','nugroup','Description','sug_description','l','','1','sug_description','1','1',20,400,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2013-10-22 14:59:13','globeadmin'),('5269d98a9d3e17b','5269ae8512ebfd3','Code','sre_code','l',NULL,NULL,'sre_code',NULL,NULL,10,150,'2013-10-25 13:08:02','globeadmin','2013-10-25 13:08:03','globeadmin','2014-10-21 09:36:20','globeadmin'),('1455393203f208','nuform','Title','sfo_title','l','','1','sfo_title','1','1',20,300,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2015-04-14 11:42:50','globeadmin'),('54ffbe3ee418f7a','nufastform','Code','sfo_name','l',NULL,NULL,'sfo_name',NULL,NULL,10,150,'2015-03-11 14:32:06','globeadmin','2015-03-11 14:32:06','globeadmin','2015-04-15 12:04:02','globeadmin'),('5164af4c1ee805b','nuphp','Description','slp_description','','','1','slp_description',NULL,'1',20,600,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2013-11-08 11:19:18','globeadmin'),('145934bea29f5d','nugroup','Name','sug_code','l','','1','sug_code','1','1',10,300,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2013-10-22 14:59:13','globeadmin'),('514b90e7ac33aef','nuobject','Form','form_name','l','','1','form_name',NULL,'1',10,250,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-02-05 10:30:57','globeadmin'),('56fae1f2bfba579','547372d029461f4','Επώνυμο','surname','l',NULL,NULL,'surname',NULL,NULL,20,280,'2016-03-29 23:13:38','globeadmin','2016-03-29 23:28:45','globeadmin','2021-01-26 20:15:03','globeadmin'),('56fae450dd061d4','547372d029461f4','Όνομα','name','l',NULL,NULL,'name',NULL,NULL,30,220,'2016-03-29 23:23:44','globeadmin','2016-03-29 23:28:45','globeadmin','2021-01-26 20:15:03','globeadmin'),('57400922bfcf411','57400922b87c65a','Όνομα','name','l','','1','name',NULL,'',30,200,'0000-00-00 00:00:00','','2016-05-28 21:40:41','globeadmin','2020-09-18 01:08:16','globeadmin'),('57400922c7223db','57400922b87c65a','Περιγραφή','description','l','','1','description',NULL,'',40,500,'0000-00-00 00:00:00','','2016-05-28 21:45:18','globeadmin','2020-09-18 01:08:16','globeadmin'),('57400922ce7549e','57400922b87c65a','Ειδικότητα','sp_short_name','l',NULL,'1','sp_short_name',NULL,'',10,200,'0000-00-00 00:00:00','','2016-05-21 10:34:14','globeadmin','2020-09-18 01:08:16','globeadmin'),('5749e4f68a73ac1','57400922b87c65a','Τάξη','g_short_name','c',NULL,NULL,'g_short_name',NULL,NULL,20,80,'2016-05-28 21:35:34','globeadmin','2016-05-28 21:44:01','globeadmin','2020-09-18 01:08:16','globeadmin'),('5787c2503eaab70','547489b0d4efe7c','Τάξη','g_name','c',NULL,NULL,'g_name',NULL,NULL,10,60,'2016-07-14 19:48:16','globeadmin','2016-07-14 19:58:12','globeadmin','2022-02-14 11:00:18','globeadmin'),('5787c34176d1b6d','547489b0d4efe7c','Ειδικότητα','s_name','l',NULL,NULL,'s_name',NULL,NULL,20,150,'2016-07-14 19:52:17','globeadmin','2016-07-14 19:58:12','globeadmin','2022-02-14 11:00:18','globeadmin'),('5787c470dd5a5c9','547489b0d4efe7c','Τύπος','t_name','c',NULL,NULL,'t_name',NULL,NULL,50,60,'2016-07-14 19:57:20','globeadmin','2016-07-14 19:58:12','globeadmin','2022-02-14 11:00:18','globeadmin'),('5830025d9a35e67','5830025d8a778f9','Περιγραφή','description','l','','1','description',NULL,'',20,450,'0000-00-00 00:00:00','','2016-11-19 09:44:11','globeadmin','2017-09-10 23:02:17','globeadmin'),('5830025d91ca145','5830025d8a778f9','Όνομα','name','l','','1','name',NULL,'',10,200,'0000-00-00 00:00:00','','2016-11-19 09:44:11','globeadmin','2017-09-10 23:02:17','globeadmin'),('582762fe26ab130','582762fe10beed3','Ιεραρχία','hierarchy','c','0','1','hierarchy',NULL,'',30,100,'0000-00-00 00:00:00','','2016-12-06 16:54:06','globeadmin','2016-12-06 16:54:31','globeadmin'),('582762fe18005ec','582762fe10beed3','Τύπος Ειδοποίησης','name','l','','1','name',NULL,'',10,500,'0000-00-00 00:00:00','','2016-11-12 21:06:28','globeadmin','2016-12-06 16:54:30','globeadmin'),('582762fe1f538f9','582762fe10beed3','Κατηγορία','cname','c',NULL,'1','cname',NULL,'',20,150,'0000-00-00 00:00:00','','2016-12-06 16:54:30','globeadmin','2016-12-06 16:54:30','globeadmin'),('5827601bddaf382','58275eceb901234','Ιεραρχία','hierarchy','c','0',NULL,'hierarchy',NULL,NULL,20,100,'2016-11-12 20:31:55','globeadmin','2016-11-12 20:34:42','globeadmin','2016-11-16 19:06:32','globeadmin'),('58275ecec053b07','58275eceb901234','Κατηγορία','name','l','','1','name',NULL,'',10,500,'0000-00-00 00:00:00','','2016-11-12 20:29:17','globeadmin','2016-11-16 19:06:32','globeadmin'),('5830097239d977e','5830097228cb500','Τύπος Ειδοποίησης','name','l',NULL,NULL,'name',NULL,NULL,10,500,'2016-11-19 10:12:34','globeadmin','2016-11-19 10:12:34','globeadmin','2016-11-19 10:12:34','globeadmin'),('5830097246170dc','5830097228cb500','Κατηγορία','cname','r',NULL,NULL,'cname',NULL,NULL,20,150,'2016-11-19 10:12:34','globeadmin','2016-11-19 10:12:34','globeadmin','2016-11-19 10:12:34','globeadmin'),('58300972572c08a','5830097228cb500','Ιεραρχία','hierarchy','r','0',NULL,'hierarchy',NULL,NULL,30,100,'2016-11-19 10:12:34','globeadmin','2016-11-19 10:12:34','globeadmin','2016-11-19 10:12:35','globeadmin'),('58d6183e5f2c78e','58d616cfeb60afc','Όνομα','sus_name','l',NULL,NULL,'sus_name',NULL,NULL,10,400,'2017-03-25 09:11:58','globeadmin','2017-03-25 09:21:37','globeadmin','2020-12-15 17:56:40','globeadmin'),('58d6183e6bccab6','58d616cfeb60afc','Ομάδα Χρηστών','sug_code','l',NULL,NULL,'sal_description',NULL,NULL,20,250,'2017-03-25 09:11:58','globeadmin','2017-03-25 09:32:33','globeadmin','2020-12-15 17:56:40','globeadmin'),('58d61c777bd4681','58d616cfeb60afc','Ρόλος','sal_description','l',NULL,NULL,'sug_code',NULL,NULL,30,250,'2017-03-25 09:29:59','globeadmin','2017-03-25 15:11:32','globeadmin','2020-12-15 17:56:40','globeadmin'),('58e146096ec63a2','547070c91793d3b','Κατάσταση','if(id=gid,\'Τρέχουσα\',\'Ανενεργή\')','c',NULL,NULL,'gid',NULL,NULL,20,200,'2017-04-02 21:42:17','globeadmin','2017-04-02 21:48:37','globeadmin','2021-09-04 21:36:57','globeadmin'),('59e5cdf8db83f32','59e5cdf8d43772d','Όνομα','name','l','','1','name',NULL,'',10,350,'0000-00-00 00:00:00','','2017-10-19 21:32:20','globeadmin','2021-10-23 22:10:40','globeadmin'),('59e5cdf8e2e5e86','59e5cdf8d43772d','Ημ/νία Έναρξης','start_date','c','7','1','start_date',NULL,'',20,150,'0000-00-00 00:00:00','','2017-10-17 13:31:08','globeadmin','2021-10-23 22:10:40','globeadmin'),('59e5cdf8ea2aa53','59e5cdf8d43772d','Ώρα Έναρξης','start_time','c','','1','start_time',NULL,'',30,100,'0000-00-00 00:00:00','','2017-10-17 13:31:08','globeadmin','2021-10-23 22:10:40','globeadmin'),('59e5cdf8f186c02','59e5cdf8d43772d','Κατάσταση','ballot_state','c','','1','ballot_state',NULL,'',60,150,'0000-00-00 00:00:00','','2017-10-19 21:32:20','globeadmin','2021-10-23 22:10:40','globeadmin'),('59e5d049515dbd2','59e5cdf8d43772d','Ημ/νία Λήξης','end_date','c','7',NULL,'end_date',NULL,NULL,40,150,'2017-10-17 12:41:29','globeadmin','2017-10-17 13:31:08','globeadmin','2021-10-23 22:10:40','globeadmin'),('59e5d0495b17cd4','59e5cdf8d43772d','Ώρα Λήξης','end_time','c',NULL,NULL,'end_time',NULL,NULL,50,100,'2017-10-17 12:41:29','globeadmin','2017-10-17 13:31:08','globeadmin','2021-10-23 22:10:40','globeadmin'),('59e90833f2fc119','59e90833df79d7d','Όνομα','name','l',NULL,NULL,'name',NULL,NULL,10,350,'2017-10-19 23:16:52','globeadmin','2017-10-19 23:16:52','globeadmin','2019-11-07 12:59:07','globeadmin'),('59e90834089bf4e','59e90833df79d7d','Ημ/νία Έναρξης','start_date','c','7',NULL,'start_date',NULL,NULL,20,150,'2017-10-19 23:16:52','globeadmin','2017-10-19 23:16:52','globeadmin','2019-11-07 12:59:07','globeadmin'),('59e90834125fe3e','59e90833df79d7d','Ώρα Έναρξης','start_time','c',NULL,NULL,'start_time',NULL,NULL,30,100,'2017-10-19 23:16:52','globeadmin','2017-10-19 23:16:52','globeadmin','2019-11-07 12:59:07','globeadmin'),('59e908341c27022','59e90833df79d7d','Ημ/νία Λήξης','end_date','c','7',NULL,'end_date',NULL,NULL,40,150,'2017-10-19 23:16:52','globeadmin','2017-10-19 23:16:52','globeadmin','2019-11-07 12:59:07','globeadmin'),('59e90834285a746','59e90833df79d7d','Ώρα Λήξης','end_time','c',NULL,NULL,'end_time',NULL,NULL,50,100,'2017-10-19 23:16:52','globeadmin','2017-10-19 23:16:52','globeadmin','2019-11-07 12:59:07','globeadmin'),('59e90834348f7ed','59e90833df79d7d','Κατάσταση','ballot_state','c',NULL,NULL,'ballot_state',NULL,NULL,60,150,'2017-10-19 23:16:52','globeadmin','2017-10-19 23:16:52','globeadmin','2019-11-07 12:59:07','globeadmin'),('59f84804b800c44','5470b6d7c79d3b9','Καταχωρητής Απουσιών','t_short','c',NULL,NULL,'t_short',NULL,NULL,20,250,'2017-10-31 11:53:08','globeadmin','2017-10-31 11:55:00','globeadmin','2022-01-08 15:26:10','globeadmin'),('5a4e425e9532f19','5a4e32f55d7faf5','Όνομα','name','l',NULL,NULL,'id',NULL,NULL,10,600,'2018-01-04 17:03:58','globeadmin','2018-01-04 17:04:55','globeadmin','2019-11-03 18:26:09','globeadmin'),('5a54c08c99656b5','5a54c08c836c142','Σχολείο','short_name','l',NULL,NULL,'short_name',NULL,NULL,10,500,'2018-01-09 15:15:56','globeadmin','2018-01-09 15:15:56','globeadmin','2022-09-24 23:21:52','globeadmin'),('5aed92f13e7d188','54707c8612b1b6b','Προσμετρείται','if(counts=1,\'ΝΑΙ\',\'ΟΧΙ\')','c',NULL,NULL,'counts',NULL,NULL,20,150,'2018-05-05 14:18:09','globeadmin','2018-05-05 14:24:40','globeadmin','2019-11-03 18:57:13','globeadmin'),('5aed92f14840f2e','54707c8612b1b6b','Δικαιολόγηση από Καθηγητές','if(teacher_access=1,\'ΝΑΙ\',\'ΟΧΙ\')','c',NULL,NULL,'teacher_access',NULL,NULL,30,250,'2018-05-05 14:18:09','globeadmin','2018-05-05 14:24:40','globeadmin','2019-11-03 18:57:13','globeadmin'),('5b51e6098e2ca0d','5b51e592c69b21a','Ομάδα','sme_name','c',NULL,NULL,'sme_name',NULL,NULL,10,150,'2018-07-20 16:39:21','globeadmin','2018-07-24 18:05:47','globeadmin','2018-07-24 18:05:47','globeadmin'),('5b51e6099a61759','5b51e592c69b21a','Περιγραφή','sme_description','l',NULL,NULL,'sme_description',NULL,NULL,40,450,'2018-07-20 16:39:21','globeadmin','2018-07-24 18:05:27','globeadmin','2018-07-24 18:05:47','globeadmin'),('5b52d323ac38a98','5b51e592c69b21a','Σειρά','sme_order_number','c','0',NULL,'sme_order_number',NULL,NULL,20,70,'2018-07-21 09:30:59','globeadmin','2018-07-24 18:05:27','globeadmin','2018-07-24 18:05:47','globeadmin'),('5b573ea8a10b5e3','5b51e592c69b21a','Τίτλος','sme_label','l',NULL,NULL,'sme_label',NULL,NULL,30,300,'2018-07-24 17:58:48','globeadmin','2018-07-24 18:05:27','globeadmin','2018-07-24 18:05:47','globeadmin'),('5b6c58ef007372d','5470788787e004a','Όριο Ημερών','num_of_days_limit','r',NULL,NULL,'num_of_days_limit',NULL,NULL,20,100,'2018-08-09 18:08:31','globeadmin','2018-08-09 18:08:31','globeadmin','2018-08-09 18:08:31','globeadmin'),('61744f1b1c853df','61744f1b13259e3','Όνομα','name','l','','1','name',NULL,'',10,700,'0000-00-00 00:00:00','','2021-10-28 12:44:38','globeadmin','2022-01-08 15:28:42','globeadmin'),('61744f1b1c957f7','61744f1b13259e3','Δημόσιο','if(is_public,\'Ναι\',\'Όχι\')','l','','1','is_public',NULL,'',20,100,'0000-00-00 00:00:00','','2021-10-23 22:06:38','globeadmin','2022-01-08 15:28:42','globeadmin');
/*!40000 ALTER TABLE `zzzsys_browse` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `zzzsys_debug`
--

DROP TABLE IF EXISTS `zzzsys_debug`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `zzzsys_debug` (
  `zzzsys_debug_id` varchar(25) NOT NULL,
  `deb_message` longtext,
  `deb_added` datetime NOT NULL,
  PRIMARY KEY (`zzzsys_debug_id`),
  KEY `deb_added` (`deb_added`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `zzzsys_debug`
--

LOCK TABLES `zzzsys_debug` WRITE;
/*!40000 ALTER TABLE `zzzsys_debug` DISABLE KEYS */;
/*!40000 ALTER TABLE `zzzsys_debug` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `zzzsys_event`
--

DROP TABLE IF EXISTS `zzzsys_event`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `zzzsys_event` (
  `zzzsys_event_id` varchar(25) NOT NULL,
  `sev_zzzsys_object_id` varchar(25) NOT NULL,
  `sev_name` varchar(50) NOT NULL,
  `sev_javascript` varchar(5000) NOT NULL,
  `zzzsys_event_log_added_at` datetime NOT NULL,
  `zzzsys_event_log_added_by` varchar(25) NOT NULL,
  `zzzsys_event_log_changed_at` datetime NOT NULL,
  `zzzsys_event_log_changed_by` varchar(25) NOT NULL,
  `zzzsys_event_log_viewed_at` datetime NOT NULL,
  `zzzsys_event_log_viewed_by` varchar(25) NOT NULL,
  PRIMARY KEY (`zzzsys_event_id`),
  KEY `sev_zzzsys_objecct_id` (`sev_zzzsys_object_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `zzzsys_event`
--

LOCK TABLES `zzzsys_event` WRITE;
/*!40000 ALTER TABLE `zzzsys_event` DISABLE KEYS */;
INSERT INTO `zzzsys_event` VALUES ('53aa19e9c2f0f97','53a2774db3d7432','onclick','moveField(0)','2014-06-25 10:38:01','globeadmin','2014-06-25 10:38:01','globeadmin','2014-06-25 10:38:02','globeadmin'),('53aa19da96ee6d7','53a2773b9894b78','onclick','moveField(1)','2014-06-25 10:37:46','globeadmin','2014-06-25 10:37:46','globeadmin','2014-06-25 10:37:47','globeadmin'),('53aa19c2c804da3','53a2744c77066f3','onclick','removeField()','2014-06-25 10:37:22','globeadmin','2014-06-25 10:37:23','globeadmin','2014-09-19 15:51:02','globeadmin'),('53aa19915446481','53a273b6a287e45','onclick','addField();','2014-06-25 10:36:33','globeadmin','2014-06-25 10:36:33','globeadmin','2014-06-25 10:36:33','globeadmin'),('52eb2b82419ba8d','52eb2b822843d25','onclick','$(\'#sfw_table_listbox option:selected\').each( function() {\n    if( $(\'#sfw_form_listbox option[nu_ed_title=\"\'+$(this).attr(\'nuTitle\')+\'\"]\').length === 0 ) {\n        $(\'#sfw_form_listbox\').append(\"<option nu_ed_title=\'\"+$(this).attr(\'nuTitle\')+\"\' nu_ed_width=\'\"+$(this).attr(\'nuWidth\')+\"\' nu_lookup=\'\' nu_lookup_code=\'\' nu_lookup_description=\'\' value=\'\"+this.value+\"\'>\"+$(this).text()+\"</option>\");\n    }\n});','2014-01-31 15:50:10','globeadmin','2014-02-06 15:31:21','globeadmin','2014-02-07 09:26:42','globeadmin'),('520427b0487ce90','520421ea5f5cfc9','onClick','captureImageClip();','0000-00-00 00:00:00','','0000-00-00 00:00:00','','2013-12-30 13:24:08','globeadmin'),('530aa199ebad5b2','15087459201b94','onclick','nuRunPHP(\'TESTEMAIL\');','2014-02-24 12:34:17','globeadmin','2014-02-24 12:51:35','globeadmin','2014-02-24 12:51:36','globeadmin'),('53aa180922c372c','53a261c9d8f8f50','onchange','updateListbox()','2014-06-25 10:30:01','globeadmin','2014-06-25 10:30:01','globeadmin','2014-09-19 15:08:10','globeadmin'),('52e992fc76f9a42','52e1d895e6fd1c0','onchange','$(\'#fw_browse_title\').val($(\'option:selected\', $(this)).attr(\'nu_bw_title\'));\n$(\'#fw_browse_width\').val($(\'option:selected\', $(this)).attr(\'nu_bw_width\'));\n','2014-01-30 10:47:08','globeadmin','2014-01-30 11:21:46','globeadmin','2014-02-06 09:49:19','globeadmin'),('542b88536b1e758','1455245046ba5e','ondblclick','nuOpenAce(\"SQL\", this.id, \"\");','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('52f310e337835f5','52f30df94b69637','onchange','$(\"#sfw_form_listbox option:selected\").attr(\'nu_lookup_code\', $(\'#sfw_code_field\').val());','2014-02-06 15:34:43','globeadmin','2014-02-06 15:38:22','globeadmin','2014-02-06 15:38:22','globeadmin'),('52eb2bb51da6241','52eb2bb50ee12a7','onchange','$(\'#sfw_form_title\').val($(\'option:selected\', $(this)).attr(\'nu_ed_title\'));\n$(\'#sfw_form_width\').val($(\'option:selected\', $(this)).attr(\'nu_ed_width\'));\n$(\'#sfw_form_lookup\').val($(\'option:selected\', $(this)).attr(\'nu_lookup\'));\n$(\'#sfw_form_lookup\').change();','2014-01-31 15:51:01','globeadmin','2014-02-06 15:29:05','globeadmin','2014-02-06 15:40:31','globeadmin'),('542b88536fb06c5','515223cfd1c36e2','ondblclick','nuOpenAce(\"Javascript\", this.id, \"Event Javascript\");','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('52e1fcf3b9704df','52e1d823b7e73e1','onclick','$(\'#fw_table_listbox option:selected\').each( function() {\n    if( $(\'#fw_form_listbox option[nu_ed_title=\"\'+$(this).attr(\'nuTitle\')+\'\"]\').length === 0 ) {\n        $(\'#fw_form_listbox\').append(\"<option nu_ed_title=\'\"+$(this).attr(\'nuTitle\')+\"\' nu_ed_width=\'\"+$(this).attr(\'nuWidth\')+\"\' nu_lookup=\'\' nu_lookup_code=\'\' nu_lookup_description=\'\' value=\'\"+this.value+\"\'>\"+$(this).text()+\"</option>\");\n    }\n});','2014-01-24 16:41:07','globeadmin','2014-02-06 14:15:20','globeadmin','2014-02-11 09:53:45','globeadmin'),('526d9c4829d58cf','1455245046ba36','onchange','nuHideTabs();','2013-10-28 09:35:44','globeadmin','2014-02-10 14:55:33','globeadmin','2014-02-10 14:55:33','globeadmin'),('542b88536d0b1e8','14b171429ee70d','ondblclick','nuOpenAce(\"PHP\", this.id, \"Before Save\");','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('542b88536f629a2','14580c19159999','ondblclick','nuOpenAce(\"Javascript\", this.id, \"Form Javascript\");','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('51c3cb0b084a86b','51678f239d70019','onclick','window.open(\'nureportbuilder.php\');','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('542b88536ffb790','525b1a7d7714972','ondblclick','nuOpenAce(\"Javascript\", this.id, \"Lookup Javascript\");','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('52e877fb99ec063','52e866facf32940','onchange','var width = $(\'#fw_browse_width\').val();\nwidth = (width > 300) ? 300 : width;\n$(\'#fw_browse_width\').val(width); \n\n$(\'#fw_browse_listbox option:selected\').each(function() {\n    $(this).attr(\'nu_bw_width\', width);\n});','2014-01-29 14:39:39','globeadmin','2014-02-11 09:49:54','globeadmin','2014-02-11 09:49:54','globeadmin'),('52818c8420c2c7d','52818c84074eb82','onblur','if(Number(this.value) < 1){alert(\'Must be Over 1 Minute\');this.focus();}','2013-11-12 13:03:48','globeadmin','2013-11-12 13:03:48','globeadmin','2013-11-12 14:44:48','globeadmin'),('52eb2afb7e3a3de','52eb2afb7363ada','onclick','selectAll(\'sfw_table_listbox\');','2014-01-31 15:47:55','globeadmin','2014-01-31 16:06:14','globeadmin','2014-02-07 09:25:49','globeadmin'),('52e999db414516c','52e1d895e6fd1c0','onkeyup','if(event.which === 46 ) {\n    $(\'option:selected\', $(this)).remove();\n    $(this).change();\n}','2014-01-30 11:16:27','globeadmin','2014-01-30 11:21:46','globeadmin','2014-02-06 09:49:19','globeadmin'),('54ffa1a24ebf8a4','54ffa1a22a1b5de','onclick','nuFastFormForm();','2015-03-11 12:30:02','globeadmin','2015-03-16 14:16:38','globeadmin','2015-03-30 10:53:13','globeadmin'),('542b88536e9a062','542b41a007a0d02','ondblclick','nuOpenAce(\"PHP\", this.id, \"Before Delete\");','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('52eb2bc0f0859b8','52eb2bc0e407dcc','onchange','$(\'#sfw_form_listbox option:selected\').each(function() {\n    $(this).attr(\'nu_ed_title\', $(\'#sfw_form_title\').val());\n});','2014-01-31 15:51:13','globeadmin','2014-02-11 10:08:41','globeadmin','2014-02-11 10:08:41','globeadmin'),('52eb2be115838cb','52eb2be10a06e51','onclick','$(\'#fw_form_listbox option:selected\').each(function() {\n    $(this).remove()\n});\n$(\'#fw_form_title\').val(\'\');\n$(\'#fw_form_width\').val(\'\');\n$(\'#fw_form_lookup\').val(\'\');\n$(\'#fw_form_lookup\').change();','2014-01-31 15:51:45','globeadmin','2014-02-11 13:06:35','globeadmin','2014-02-11 13:06:35','globeadmin'),('542b8853703a40a','145787f625367a','ondblclick','nuOpenAce(\"Javascript\", this.id, \"Button Javascript\");','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('53bce0521a5b0c9','53bce051e2777b4','onclick','loadUpdater();','2014-07-09 16:25:22','globeadmin','2014-07-09 16:25:22','globeadmin','2014-07-09 16:25:33','globeadmin'),('542b88536945c9e','14575e368d59f9','ondblclick','nuOpenAce(\"SQL\", this.id, \"Form SQL\");','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('542b88536da5268','14580c083db4cb','ondblclick','nuOpenAce(\"PHP\", this.id, \"Before Open\");','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('52eb2bcf9fd4193','52eb2bcf8e9043d','onchange','var width = $(\'#sfw_form_width\').val();\nwidth = (width > 300) ? 300 : width;\n$(\'#sfw_form_width\').val(width);\n$(\'#sfw_form_listbox option:selected\').each(function() {\n    $(this).attr(\'nu_ed_width\',width);\n});','2014-01-31 15:51:27','globeadmin','2014-02-11 10:08:24','globeadmin','2014-02-11 10:08:25','globeadmin'),('5164d542dc3c65a','1455245046c006','onblur','nuPopulateSort(this);','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('52eec5635165b18','52eec5634507ad5','onchange','fetch_columns();\nvar table = $(\'#sfw_table_name\').val();\n\n$(\"select[id$=\'listbox\']\").empty();\n$(\"input[id$=\'title\'], input[id$=\'width\']\").val(\'\');\nvar column_length = window.columns.length;\n\nfor(var idx = 0; idx < column_length; idx++) {\n    var width = (window.columns[idx][6] == \'\' ) ? window.columns[idx][5] : window.columns[idx][6];\n    width = Math.ceil(width*2.5);\n    if( width == 0 ) {\n        width = \'100\';\n    }\n    if( window.columns[idx][0] == table && window.columns[idx][2] != \"PRI\") {\n        $(\'#sfw_table_listbox\').append(\"<option nuTitle=\'\"+window.columns[idx][1]+\"\' nuWidth=\'\"+width+\"\' value=\'\"+window.columns[idx][1]+\"#nuSepr#\"+window.columns[idx][3]+\"#nuSepr#\"+window.columns[idx][4]+\"\'>\"+window.columns[idx][1]+\"</option>\");\n    }\n}','2014-02-03 09:23:31','globeadmin','2014-02-03 09:23:31','globeadmin','2014-02-03 14:00:44','globeadmin'),('52e1f5d8b7c0f19','52e1d6b61a8c8cd','onclick','selectAll(\'fw_browse_listbox\');\n$(\'#fw_browse_listbox\').focus();','2014-01-24 16:10:48','globeadmin','2014-01-30 11:22:59','globeadmin','2014-02-06 09:45:10','globeadmin'),('542b88536c55120','1455245046bfb5','ondblclick','nuOpenAce(\"SQL\", this.id, \"\");','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('52e8773f37e8b05','52e86699bf261e8','onchange','$(\'#fw_browse_listbox option:selected\').each(function() {\n    $(this).attr(\'nu_bw_title\', $(\'#fw_browse_title\').val());\n});','2014-01-29 14:36:31','globeadmin','2014-01-29 15:16:03','globeadmin','2014-02-06 09:49:45','globeadmin'),('52f3119171d02f5','52f30e3b96640a4','onchange','$(\"#sfw_form_listbox option:selected\").attr(\'nu_lookup_description\', $(\'#sfw_description_field\').val());','2014-02-06 15:37:37','globeadmin','2014-02-06 15:39:28','globeadmin','2014-02-06 15:39:28','globeadmin'),('52e1f6159c7ef91','52e1d6c72bec014','onclick','selectAll(\'fw_form_listbox\');\n$(\'#fw_form_listbox\').focus();','2014-01-24 16:11:49','globeadmin','2014-01-30 11:24:04','globeadmin','2014-02-06 09:52:56','globeadmin'),('52e6f5a7b18688b','52e6f46bb695a82','onclick','$(\'#fw_browse_listbox option:selected\').each(function() {\n    $(this).remove()\n});\n$(\'#fw_browse_title\').val(\'\');\n$(\'#fw_browse_width\').val(\'\');','2014-01-28 11:11:19','globeadmin','2014-02-11 13:07:23','globeadmin','2014-02-11 13:07:23','globeadmin'),('52e6f19d79b9777','52e6e3db34cf668','onclick','var selected = $(\'#fw_form_listbox option:selected\');\n\nif(selected.length === 1  && selected.is(\':not(:first-child)\') ) {\n    var before = selected[0].index - 1;\n    selected.insertBefore($(\'#fw_form_listbox option:eq(\'+before+\')\'));\n}','2014-01-28 10:54:05','globeadmin','2014-01-28 10:54:05','globeadmin','2014-02-11 10:21:02','globeadmin'),('52e6f145880fe3f','52e6e33fbb3f431','onclick','var selected = $(\'#fw_browse_listbox option:selected\');\n\nif(selected.length === 1  && selected.is(\':not(:last-child)\') ) {\n    var after = selected[0].index + 1;\n    selected.insertAfter($(\'#fw_browse_listbox option:eq(\'+after+\')\'));\n}','2014-01-28 10:52:37','globeadmin','2014-01-28 10:52:37','globeadmin','2014-02-11 10:21:49','globeadmin'),('542b885366ef498','145773ab7798d4','ondblclick','nuOpenAce(\"SQL\", this.id, \"Delete Button Display Condition\");','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('542b8853662339b','1457739571a2f3','ondblclick','nuOpenAce(\"SQL\", this.id, \"Add Button Display Condition\");','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('52e87d227886d41','52e87d2262e7976','onchange','$(\'#fw_form_listbox option:selected\').each(function() {\n    $(this).attr(\'nu_ed_title\', $(\'#fw_form_title\').val());\n});','2014-01-29 15:01:38','globeadmin','2014-01-29 15:16:30','globeadmin','2014-02-06 10:19:53','globeadmin'),('542b885367be798','145beab28ce1bb','ondblclick','nuOpenAce(\"SQL\", this.id, \"New Button Display Condition\");','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('542b88536a9b92e','1455245046ba4c','ondblclick','nuOpenAce(\"SQL\", this.id, \"\");','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('52eb2bb530b39a4','52eb2bb50ee12a7','onkeyup','if(event.which === 46 ) {\n    $(\'option:selected\', $(this)).remove();\n    $(this).change();\n}','2014-01-31 15:51:01','globeadmin','2014-01-31 15:51:01','globeadmin','2014-02-06 15:40:31','globeadmin'),('52e6ec785bee8d6','52e6e44874b1aa3','onclick','var selected = $(\'#fw_form_listbox option:selected\');\n\nif( selected.length === 1 && selected.is(\':not(:last-child)\') ) {\n    var after = selected[0].index + 1;\n    selected.insertAfter($(\'#fw_form_listbox option:eq(\'+after+\')\'));\n}','2014-01-28 10:32:08','globeadmin','2014-01-30 11:48:00','globeadmin','2014-02-11 10:21:57','globeadmin'),('52e6efc7091880b','52e6e0a571faf6a','onclick','var selected = $(\'#fw_browse_listbox option:selected\');\n\nif(selected.length === 1  && selected.is(\':not(:first-child)\') ) {\n    var before = selected[0].index - 1;\n    selected.insertBefore($(\'#fw_browse_listbox option:eq(\'+before+\')\'));\n}','2014-01-28 10:46:15','globeadmin','2014-01-28 10:51:22','globeadmin','2014-02-11 10:20:49','globeadmin'),('542b8853675862f','145773ba26e1b9','ondblclick','nuOpenAce(\"SQL\", this.id, \"Clone Button Display Condition\");','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('542b88536a215a5','516340b344b54b4','ondblclick','nuOpenAce(\"SQL\", this.id, \"Default Value\");','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('52eb2b9d48f101e','52eb2b9d3b96d77','onclick','selectAll(\'sfw_form_listbox\');\n$(\'#sfw_form_listbox\').focus();','2014-01-31 15:50:37','globeadmin','2014-01-31 16:08:09','globeadmin','2014-02-07 09:26:06','globeadmin'),('53aa218def406e6','53a7c432f396097','onchange','updateColumnData()','2014-06-25 11:10:38','globeadmin','2014-06-25 11:10:43','globeadmin','2014-06-25 14:30:44','globeadmin'),('53aa2168338bee2','53a2710dcff862d','onchange','showColumnData()','2014-06-25 11:10:00','globeadmin','2014-06-25 11:10:00','globeadmin','2014-09-19 14:57:47','globeadmin'),('551897918632c0d','5518979176fd7ad','onclick','nuFastFormFormView();','2015-03-30 10:53:45','globeadmin','2015-04-15 12:02:23','globeadmin','2015-04-15 12:04:13','globeadmin'),('52eb2aec7108cdf','52eb2aec64b5abd','onchange','fetch_columns();\r\n\r\nvar table = $(\'#sfw_table_name\').val();\r\n\r\n$(\"select[id$=\'listbox\']\").empty();\r\n$(\"#sfw_foreign_key\").empty();\r\n$(\"input[id$=\'title\'], input[id$=\'width\'], input[id$=\'lookup\']\").val(\'\');\r\nvar column_length = window.columns.length;\r\n\r\nvar titleList = new Array();\r\nfor(var i = 0; i < column_length; i++) {\r\n    if( window.columns[i][0] == table && window.columns[i][2] != \"PRI\" ) {\r\n        titleList.push(window.columns[i][1]);\r\n    }    \r\n}\r\n\r\n\r\n\r\n$(\'#sfw_foreign_key\').append(\"<option value=\'\'></option>\");\r\n\r\nfor(var idx = 0; idx < column_length; idx++) {\r\n    var width = (window.columns[idx][6] == \'\' ) ? window.columns[idx][5] : window.columns[idx][6];\r\n    width = Math.ceil(width*2.5);\r\n    \r\n    if( width <= 125 ) {\r\n        width = 100;\r\n    }\r\n    else if( width > 125 && width <= 175 ) {\r\n        width = 150;\r\n    }\r\n    else if( width > 175 && width <= 225 ) {\r\n        width = 200;\r\n    }\r\n    else if( width > 225 && width <= 275 ) {\r\n        width = 250;\r\n    }\r\n    else {\r\n        width = 300;\r\n    }\r\n    \r\n    \r\n    \r\n    if( window.columns[idx][0] == table && window.columns[idx][2] != \"PRI\") {\r\n        console.log(idx);\r\n        console.log(window.columns[idx][1]);\r\n        var title = nuFieldTitle(window.columns[idx][1], titleList);\r\n        $(\'#sfw_table_listbox\').append(\"<option nuTitle=\'\"+title+\"\' nuWidth=\'\"+width+\"\' value=\'\"+window.columns[idx][1]+\"#nuSepr#\"+window.columns[idx][3]+\"#nuSepr#\"+window.columns[idx][4]+\"\'>\"+window.columns[idx][1]+\"</option>\");\r\n        $(\'#sfw_foreign_key\').append(\"<option value=\'\"+window.columns[idx][1]+\"\'>\"+window.columns[idx][1]+\"</option>\");\r\n    }\r\n    else if (window.columns[idx][0] == table && window.columns[idx][2] == \"PRI\") {\r\n        $(\'#sfw_hidden_primary\').val(window.columns[idx][1]);\r\n    }\r\n}\r\n','2014-01-31 15:47:40','globeadmin','2014-02-11 13:58:37','globeadmin','2014-02-11 13:58:38','globeadmin'),('53aa1e6c808b684','53a7bc81843cd9f','onclick','moveOrder(0)','2014-06-25 10:57:16','globeadmin','2014-06-25 10:57:16','globeadmin','2014-06-25 10:57:17','globeadmin'),('53aa1e375dc6139','53a7bc5531e3033','onclick','removeOrder()','2014-06-25 10:56:23','globeadmin','2014-06-25 10:56:23','globeadmin','2014-06-25 10:56:23','globeadmin'),('52e1e232212e7fc','52e1d7bbc29ca2c','onchange','fetch_columns();\nvar table = $(\'#fw_table_name\').val();\n\n$(\"select[id$=\'listbox\']\").empty();\n$(\"input[id$=\'title\'], input[id$=\'width\'], input[id$=\'lookup\']\").val(\'\');\nvar column_length = window.columns.length;\n\nvar titleList = new Array();\nfor(var i = 0; i < column_length; i++) {\n    if( window.columns[i][0] == table && window.columns[i][2] != \"PRI\" ) {\n        titleList.push(window.columns[i][1]);\n    }    \n}\n\n\n\n\nfor(var idx = 0; idx < column_length; idx++) {\n    var width = (window.columns[idx][6] == \'\' ) ? window.columns[idx][5] : window.columns[idx][6];\n    width = Math.ceil(width*2.5);\n    \n    if( width <= 125 ) {\n        width = 100;\n    }\n    else if( width > 125 && width <= 175 ) {\n        width = 150;\n    }\n    else if( width > 175 && width <= 225 ) {\n        width = 200;\n    }\n    else if( width > 225 && width <= 275 ) {\n        width = 250;\n    }\n    else {\n        width = 300;\n    }\n    \n    \n    \n    if( window.columns[idx][0] == table && window.columns[idx][2] != \"PRI\") {\n        console.log(idx);\n        console.log(window.columns[idx][1]);\n        var title = nuFieldTitle(window.columns[idx][1], titleList);\n        $(\'#fw_table_listbox\').append(\"<option nuTitle=\'\"+title+\"\' nuWidth=\'\"+width+\"\' value=\'\"+window.columns[idx][1]+\"#nuSepr#\"+window.columns[idx][3]+\"#nuSepr#\"+window.columns[idx][4]+\"\'>\"+window.columns[idx][1]+\"</option>\");\n    }\n    else if (window.columns[idx][0] == table && window.columns[idx][2] == \"PRI\") {\n        $(\'#fw_hidden_primary\').val(window.columns[idx][1]);\n    }\n}\n','2014-01-24 14:46:58','globeadmin','2014-02-11 13:58:52','globeadmin','2014-02-20 10:41:39','globeadmin'),('53aa1e22a6dd5d1','53a7bc41a990aa4','onclick','addOrder()','2014-06-25 10:56:02','globeadmin','2014-06-25 10:56:02','globeadmin','2014-06-25 10:56:03','globeadmin'),('53aa1e51d440dd8','53a7bc6ad1e7c9a','onclick','moveOrder(1)','2014-06-25 10:56:49','globeadmin','2014-06-25 10:56:50','globeadmin','2014-06-25 10:56:50','globeadmin'),('53aa24cc69babcc','53aa24cc4c00e25','onchange','updateColumnData()','2014-06-25 11:24:28','globeadmin','2014-06-25 11:24:28','globeadmin','2014-06-26 16:48:22','globeadmin'),('54ffad929659858','54ffad928488d6e','onclick','nuFastFormObject(this);','2015-03-11 13:20:58','globeadmin','2015-03-16 14:08:01','globeadmin','2015-03-23 11:57:47','globeadmin'),('542b8853682057d','decafc0ffee003','ondblclick','nuOpenAce(\"SQL\", this.id, \"Print Button Display Condition\");','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('53aa24e8693a224','53aa24e8509d3fc','onchange','updateColumnData()','2014-06-25 11:24:56','globeadmin','2014-06-25 11:24:56','globeadmin','2014-06-25 14:30:35','globeadmin'),('53aba22067b98e8','53aba22054ddcda','onchange','updateColumnData()','2014-06-26 14:31:28','globeadmin','2014-06-26 14:31:28','globeadmin','2014-06-26 14:31:29','globeadmin'),('542b88536d58c7e','146bc0d39135da','ondblclick','nuOpenAce(\"PHP\", this.id, \"Before Browse\");','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('542b88536687889','145773a500ebd8','ondblclick','nuOpenAce(\"SQL\", this.id, \"Save Button Display Condition\");','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('52f309795235cd1','52f2f8ca88a7888','onchange','$(\"select option:selected\").attr(\'nu_lookup_description\', $(\'#fw_description_field\').val());','2014-02-06 15:03:05','globeadmin','2014-02-06 15:03:05','globeadmin','2014-02-06 15:03:05','globeadmin'),('52e1fe0088d891f','52e1d83f5e35df5','onclick','$(\'#fw_table_listbox option:selected\').each( function() {\n    if( $(\'#fw_browse_listbox option[nu_bw_title=\"\'+$(this).attr(\'nuTitle\')+\'\"]\').length === 0 ) {\n        $(\'#fw_browse_listbox\').append(\"<option nu_bw_title=\'\"+$(this).attr(\'nuTitle\')+\"\' nu_bw_width=\'\"+$(this).attr(\'nuWidth\')+\"\'value=\'\"+this.value+\"\'>\"+$(this).text()+\"</option>\");\n    }\n});','2014-01-24 16:45:36','globeadmin','2014-01-31 09:48:37','globeadmin','2014-02-20 09:41:46','globeadmin'),('542b88536e23ac5','14580c11db5271','ondblclick','nuOpenAce(\"PHP\", this.id, \"After Save\");','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('522025e89afabb3','522025e88174a00','onclick','nuOpenFormInFrame(\'nuphp\',$(\'#sre_zzzsys_php_id\').val(), \'PHP Code\')','0000-00-00 00:00:00','','2014-02-05 11:04:36','globeadmin','2014-02-05 11:04:36','globeadmin'),('51ad723caea1dbe','145d3d46168a33','onblur','if(Number(this.value) < 1){alert(\'Must be Over 1 Minute\');this.focus();}','0000-00-00 00:00:00','','0000-00-00 00:00:00','','2013-11-12 13:03:13','globeadmin'),('542b88536b92a57','1455245046ba87','ondblclick','nuOpenAce(\"SQL\", this.id, \"\");','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('542b88536884bff','1455245046ba15','ondblclick','nuOpenAce(\"SQL\", this.id, \"Display Object Condition\");','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('542b885369aa18a','5186d40c2a32069','ondblclick','nuOpenAce(\"SQL\", this.id, \"\");','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('52f300034c5c21e','52f2f869865117b','onchange','$(\"select option:selected\").attr(\'nu_lookup_code\', $(\'#fw_code_field\').val());','2014-02-06 14:22:43','globeadmin','2014-02-06 14:22:43','globeadmin','2014-02-06 15:36:30','globeadmin'),('542b88536de4558','146bc0d39115da','ondblclick','nuOpenAce(\"PHP\", this.id, \"After Browse\");','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('542b885368e1802','145787f999fb2e','ondblclick','nuOpenAce(\"SQL\", this.id, \"Button Display Condition\");','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('542b88537077b9a','1455245046ba67','ondblclick','nuOpenAce(\"HTML\", this.id, \"HTML Code\");','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('542b88536cb4132','537d4266d97ca33','ondblclick','nuOpenAce(\"SQL\", this.id, \"\");','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('545ad9ff30910d2','545ad8a397d734d','onclick','window.nuControlKey=true;nuOpenForm($(\'#sal_zzzsys_form_id\').val(), \'-1\', $(\'#sal_zzzsys_form_id\').val(), \'-1\', \'Home Form\');window.nuControlKey=false;','2014-11-06 12:46:31','globeadmin','2014-11-06 12:50:19','globeadmin','2014-11-06 12:51:42','globeadmin'),('52e993b3a5b7624','52e1cd8771f75fd','onchange','$(\'#fw_form_title\').val($(\'option:selected\', $(this)).attr(\'nu_ed_title\'));\n$(\'#fw_form_width\').val($(\'option:selected\', $(this)).attr(\'nu_ed_width\'));\n$(\'#fw_form_lookup\').val($(\'option:selected\', $(this)).attr(\'nu_lookup\'));\n\n$(\'#fw_form_lookup\').change();\n','2014-01-30 10:50:11','globeadmin','2014-02-06 15:02:04','globeadmin','2014-02-06 15:28:39','globeadmin'),('phpMyAdminevt','phpMyAdminbtn','onClick','window.open(\"nupmalogin.php?sessid=#session_id#\");','2014-06-27 10:37:31','globeadmin','2014-06-27 10:37:31','globeadmin','2014-07-15 13:32:12','globeadmin'),('542b88536f19d87','5164b0fcc6e8515','ondblclick','nuOpenAce(\"PHP\", this.id, \"PHP Code\");','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('5471cf3ae983a7d','5471ce5f326a27f','onclick','function deleteStudent(pThis){\n    var student_class_id = $(\'#\' + nuRowPrefix(pThis) + \'_nuPrimaryKey\').val();\n    alert(student_class_id);\n    //nuOpenForm(\'\',\'\', \'5476201e5a3d38f\', student_id,\'Μαθητής\');\n    //nuOpenFormInFrame(\'5476201e5a3d38f\',student_id); //--open form in floating window\n}\n\nif (confirm(\'Θέλετε να διαγραφεί ο μαθητής από το τμήμα;\')) {\n    deleteStudent(this);\n} \n\n','2014-11-23 14:12:42','globeadmin','2015-02-28 20:06:16','globeadmin','2015-02-28 20:06:16','globeadmin'),('548c2dcc92d4c0f','54809cf71d0a61e','onfocus','blur();','2014-12-13 14:15:08','globeadmin','2014-12-13 14:15:08','globeadmin','2014-12-13 14:26:45','globeadmin'),('547d7712651b66b','547d746016fa2bd','onchange','function removeOptions(selectbox)\n{\n    var i;\n    for(i=selectbox.options.length-1;i>=0;i--){\n        selectbox.remove(i);\n    }\n}\n\nfunction addOption(selectbox,val,txt)\n{\n    var option = document.createElement(\'option\');\n    option.text = txt;\n    option.value = val;\n    selectbox.add(option,selectbox[0]);\n}\n\nfunction populate_select(selectbox){\n    addOption(selectbox,1,\'Nektarios\');\n}\n\nvar x = document.getElementById(\'class_subject_selection\');\nvar class_subject_id = x.options[x.selectedIndex].value;\n\n//alert(class_subject_id);\n\nvar pos = class_subject_id.search(\',\');\nvar id1= class_subject_id.substr(0, pos);\nvar id2= class_subject_id.substring(pos+1, class_subject_id.length);\n\nset_session_variable(\'class_id\',id1);\nset_session_variable(\'subject_id\',id2);\n\n//nuSaveForm(true,0);\n//$(\'#class_subject_selection\').find($(\'option\')).attr(\'selected\',false);\n//x.selected = false;\nnuReloadForm();','2014-12-02 10:23:46','globeadmin','2015-01-12 21:57:52','globeadmin','2016-03-26 16:31:53','globeadmin'),('548c2a80b020ccb','5480b8e487f3c55','onfocus','//blur(); ','2014-12-13 14:01:04','globeadmin','2014-12-13 14:51:57','globeadmin','2014-12-13 14:57:34','globeadmin'),('548c2dea583cbd5','5480b7a30ddfc01','onfocus','blur();','2014-12-13 14:15:38','globeadmin','2014-12-13 14:15:38','globeadmin','2014-12-13 14:58:18','globeadmin'),('54972ec8b321758','54972ec8a2089fa','onchange','var x = document.getElementById(\'print_marks_grading_period_selection\');\nvar grading_period_id = x.options[x.selectedIndex].value;\n\nif (grading_period_id==\'\') {\n    set_session_variable(\'mark_print_grading_period_id\',-1);\n} else {\n    set_session_variable(\'mark_print_grading_period_id\',grading_period_id);\n}\n    \nnuAjax(\'pass_teachers_lessons\',\'refresh_lessons\');\n\n//nuReloadForm();','2014-12-21 22:34:16','globeadmin','2022-01-22 10:50:54','globeadmin','2022-01-22 10:50:55','globeadmin'),('548c2e0318c2be5','5480b8b61c85cf9','onfocus','blur();','2014-12-13 14:16:03','globeadmin','2014-12-13 14:16:03','globeadmin','2014-12-13 14:26:21','globeadmin'),('549ef738962a6ea','549ef7387b50521','onclick','var all_class_ids = [];\nvar all_subject_ids = [];\n\nvar x = document.getElementById(\'print_marks_grading_period_selection\');\nvar gp = x.options[x.selectedIndex].value;\n\nvar s = document.getElementById(\'print_marks_class_subject_selection\');\nvar all_class_subject_ids=\'\';\n\nif(gp==\'\'){\n    alert(\'Παρακαλώ επιλέξτε πρώτα τη βαθμολογική περίοδο..\');    \n} else {\n    \n    for (var i = 0; i < s.options.length; i++) {\n        if (s.options[i].selected == true) {\n\n            var class_subject_id=s.options[i].value;\n        \n            var tmp=\'(\'+class_subject_id+\')\';\n            if (all_class_subject_ids==\'\'){\n                all_class_subject_ids=tmp;\n            }\n            else{\n                all_class_subject_ids=all_class_subject_ids+\',\'+tmp;\n            }\n            \n            var pos = class_subject_id.search(\",\");\n            var id1= class_subject_id.substr(0, pos);\n            var id2= class_subject_id.substring(pos+1, class_subject_id.length);\n        \n            all_class_ids.push(id1);\n            all_subject_ids.push(id2);\n        }\n    }\n    \n    if(all_class_ids.length==0){\n        if(confirm(\'Δεν έχετε επιλέξει μάθημα!\\nΘέλετε να εκτυπωθούν όλα όσα υπάρχουν στη λίστα;\')){    \n\n            for (var i = 0; i < s.options.length; i++) {\n                var class_subject_id=s.options[i].value;\n        \n                var tmp=\'(\'+class_subject_id+\')\';\n                if (all_class_subject_ids==\'\'){\n                    all_class_subject_ids=tmp;\n                }\n                else{\n                    all_class_subject_ids=all_class_subject_ids+\',\'+tmp;\n                }\n        \n                var pos = class_subject_id.search(\",\");\n                var id1= class_subject_id.substr(0, pos);\n                var id2= class_subject_id.substring(pos+1, class_subject_id.length);\n        \n                all_class_ids.push(id1);\n                all_subject_ids.push(id2);\n            }\n        }   \n    }\n    \n    if(all_class_ids.length==1){\n        set_session_variable(\'mark_print_class_id\',all_class_ids[0]);\n        set_session_variable(\'mark_print_subject_id\',all_subject_ids[0]);\n        nuPrintPDF(\'marks_print\');\n    }\n    else if (all_class_ids.length>1){\n        nuSetHash(\'print_class_subject_ids\',all_class_subject_ids);\n        nuPrintPDF(\'marks_print_teacher_full\');\n    }\n}\n    ','2014-12-27 20:15:20','globeadmin','2015-05-10 20:54:35','globeadmin','2016-01-06 11:28:59','globeadmin'),('549b25c1250e638','549b25c11669f8c','onchange','//var x = document.getElementById(\"print_marks_class_subject_selection\");\n//var class_subject_id = x.options[x.selectedIndex].value;\n\n//var pos = class_subject_id.search(\",\");\n//var id1= class_subject_id.substr(0, pos);\n//var id2= class_subject_id.substring(pos+1, class_subject_id.length);\n\n//set_session_variable(\'mark_print_class_id\',id1);\n//set_session_variable(\'mark_print_subject_id\',id2);\n\n//nuReloadForm();','2014-12-24 22:44:49','globeadmin','2014-12-28 20:10:59','globeadmin','2016-01-04 11:23:37','globeadmin'),('54a3ea79e320caa','54a3ea79d47acb8','onclick','nuPrintPDF(\'marks_print_full\');','2014-12-31 14:22:17','globeadmin','2015-01-02 11:26:29','globeadmin','2015-10-10 20:13:28','globeadmin'),('54a26e2d5419197','54a26e2d4574a89','onclick','var x = document.getElementById(\"export_marks_type\");\nvar type = x.options[x.selectedIndex].value;\n\nvar x = document.getElementById(\"export_marks_grading_period_selection\");\nvar grading_period_id = x.options[x.selectedIndex].value;\n\nif (grading_period_id==\'\'){\n    alert(\'Παρακαλώ Επιλέξτε Βαθμολογική Περίοδο\');\n    }\nelse{\n    if(type==\'\'){\n        alert(\'Παρακαλώ Επιλέξτε Ομαδοποίηση\');\n        }\n    else if (type==0){\n        nuRunPHP(\'extract_marks_grade\',\'export_marks_iframe\');\n        }\n    else if (type==1){\n        nuRunPHP(\'extract_marks_class\',\'export_marks_iframe\');\n        }\n}','2014-12-30 11:19:41','globeadmin','2014-12-30 17:30:27','globeadmin','2018-01-29 10:19:55','globeadmin'),('54a26c39e1b3110','54a26c39d30d2c0','onchange','var x = document.getElementById(\'export_marks_grading_period_selection\');\nvar grading_period_id = x.options[x.selectedIndex].value;\n\nif(grading_period_id==\'\'){\n    nuSetHash(\'export_grading_period_id\', 0);\n    }\nelse{\n    nuSetHash(\'export_grading_period_id\', grading_period_id);\n    }\n    ','2014-12-30 11:11:21','globeadmin','2015-05-10 19:28:00','globeadmin','2016-07-24 16:18:18','globeadmin'),('57939f02899c08e','57939f0273a2f79','onclick','nuOpenForm(\'\',\'\', \'5794b8d73636f76\', \'#RECORD_ID#\',\'Έλεγχος Συστήματος και Δεδομένων\');\n\n\n','2016-07-23 19:44:50','globeadmin','2016-11-30 20:00:05','globeadmin','2017-11-18 12:49:29','globeadmin'),('5787bce43274658','5787bce41eec5ca','onblur','nuFORM.edited = 0;','2016-07-14 19:25:08','globeadmin','2016-07-14 19:25:08','globeadmin','2016-12-26 10:28:06','globeadmin'),('5783feb469290b7','5783feb45a84acd','onclick','open_email_frame($(\'#parent_email\').val());','2016-07-11 23:16:52','globeadmin','2016-07-11 23:16:52','globeadmin','2021-09-04 21:43:45','globeadmin'),('578f99b3592d020','578f99b34a70b01','onclick','nuOpenForm(\'\',\'\', \'5713df2963f613a\', \'#RECORD_ID#\',\'Καθηγητής\');\n \n   ','2016-07-20 18:33:07','globeadmin','2016-07-20 18:33:07','globeadmin','2017-10-06 23:43:51','globeadmin'),('572b65b812df5f5','572b65b7f36f3fc','onblur','nuFORM.edited = 0;','2016-05-05 18:24:40','globeadmin','2016-05-05 18:24:40','globeadmin','2020-09-23 10:31:30','globeadmin'),('54a561b2d7aefae','54a52e0e922dcaa','onclick','nuRunPHP(\'myTESTEMAIL\');','2015-01-01 17:03:14','globeadmin','2015-01-01 18:44:02','globeadmin','2016-04-10 12:30:52','globeadmin'),('56044c399c6eebf','547070c945f4fd9','onclick','nuOpenForm(\'\',\'\', \'547070c91793d3b\', \'\',\'Βαθμολογικές Περίοδοι\');','2015-09-24 22:17:13','globeadmin','2015-09-24 22:17:13','globeadmin','2015-10-10 20:11:58','globeadmin'),('56037fe59fa5d36','547081cedfc3d51','onclick','nuOpenForm(\'\',\'\', \'547081ceb3d2146\', \'1\',\'Σχολικό Έτος\');','2015-09-24 07:45:25','globeadmin','2015-09-24 07:45:25','globeadmin','2015-10-10 20:01:22','globeadmin'),('54df1e7fd7c4399','54df1e7fc91fd62','onclick',';\nnuRunPHP(\'student_class_insert\',\'insert_student_class_iframe\');','2015-02-14 12:07:59','globeadmin','2015-02-14 12:07:59','globeadmin','2015-02-14 12:08:00','globeadmin'),('54a91b839af2f04','54a91b838c4d4b1','onclick','var x = document.getElementById(\"student_mark_grade_period\");\nvar grading_period_id = x.options[x.selectedIndex].value;\n\nvar iframe = document.getElementById(\'student_mark_showiframe\');\nvar innerDoc = (iframe.contentDocument) ? iframe.contentDocument : iframe.contentWindow.document;\n\nvar values = innerDoc.getElementsByClassName(\'value\');\nvar evaluations = innerDoc.getElementsByClassName(\'evaluation\');\n\nif (grading_period_id==\'\'){\n    alert(\'Παρακαλώ επιλέξτε πρώτα την Περίοδο Αξιολόγησης\');\n} else {\n    \n    if (values.length==0 && evaluations.length==0){\n        alert(\'Δεν υπάρχεί αξιολόγηση προς εκτύπωση...\');    \n    } else {\n        if(values.length>0 && evaluations.length>0){\n            nuPrintPDF(\'marks_print_student\');\n            if(confirm(\'Να εκτυπωθεί και η περιγραφική αξιολόγηση;\')){\n                nuPrintPDF(\'marks_print_student_evaluation\');    \n            }\n        } else {\n            if (values.length>0){\n                nuPrintPDF(\'marks_print_student\');\n            }\n    \n            if (evaluations.length>0){\n                nuPrintPDF(\'marks_print_student_evaluation\');\n            }\n        }\n    }\n    \n}','2015-01-04 12:52:51','globeadmin','2016-07-28 15:54:10','globeadmin','2017-10-15 11:58:16','globeadmin'),('54a91e7b89dc13d','54a85bc4032bd41','onchange','var x = document.getElementById(\"student_mark_grade_period\");\nvar grading_period_id = x.options[x.selectedIndex].value;\n\nif (grading_period_id==\'\'){\n    nuSetHash(\'student_mark_grade_period_id\', 0);\n} else{\n    nuSetHash(\'student_mark_grade_period_id\', grading_period_id);\n}\n\nnuRunPHP(\'show_marks_student\',\'student_mark_showiframe\');','2015-01-04 13:05:31','globeadmin','2016-07-28 15:51:06','globeadmin','2018-07-05 13:10:57','globeadmin'),('54a92ce7edf519f','54a92ce7df50a6b','onchange','var x = document.getElementById(\"student_mark_grade_period\");\nvar grading_period_id = x.options[x.selectedIndex].value;\n\nif (grading_period_id==\'\'){\n    nuSetHash(\'student_mark_grade_period_id\', 0);\n} else{\n    nuSetHash(\'student_mark_grade_period_id\', grading_period_id);\n}\n\nnuRunPHP(\'show_marks_student\',\'student_mark_showiframe\');\n\n','2015-01-04 14:07:03','globeadmin','2016-07-26 09:57:46','globeadmin','2021-03-09 19:46:06','globeadmin'),('54aa76567dcf69d','54aa76566f2b29a','onclick','nuRunPHP(\'student_account_creation\',\'create_std_acc_homeiframe\');','2015-01-05 13:32:38','globeadmin','2015-01-05 13:32:38','globeadmin','2016-09-20 20:42:35','globeadmin'),('54aab29564cef70','54aab29556125a2','onclick','var iframe = document.getElementById(\'student_home_school_text_tinymce\');\nvar htmltext = iframe.contentWindow.getHTML();\n\nvar teachers_id_list = nuGetHash(\'student_home_school_teacher_email_sumo\');\n \nif (typeof teachers_id_list == \"undefined\"){\n    alert(\'Παρακαλώ επιλέξτε παραλήπτη..\');    \n}else if(teachers_id_list.trim()==\'\'){\n    alert(\'Παρακαλώ επιλέξτε παραλήπτη..\');   \n}else if(htmltext.trim()==\'\'){\n    alert(\'Παρακαλώ γράψτε πρώτα το μήνυμα σας..\');\n} else{\n    \n    var subject = \'Μήνυμα από \'+$(\'#surname\').val()+\' \'+$(\'#name\').val()+\' - ΑΜ:\'+$(\'#registration_number\').val();\n    if(\'#nu_user_group#\'==\'Parents\'){\n        subject = subject + \' (Γονέας)\';    \n    }\n    \n    nuSetHash(\'teacher_ids\', teachers_id_list);\n    nuSetHash(\'email_subject\', subject);\n    nuSetHash(\'email_content\', htmltext);\n    nuSetHash(\'is_student\', \'1\');\n    nuSetHash(\'sender_name\', (\'#nu_user_group#\'==\'Parents\' ? \'<b><u>γονέας</u></b> του μαθητή \': \'μαθητής \')+\'#surname#\'+\' \'+\'#name#\');\n\n    showLoader();\n    nuAjax(\'send_email_to_teachers\',\'display_sent_result\',{async:true});    \n}\n\n\n','2015-01-05 17:49:41','globeadmin','2019-07-25 12:24:55','globeadmin','2019-07-25 12:24:55','globeadmin'),('580256bc6408bdf','580256bc4baedd5','onclick','nuRunPHP(\'myFILE\',\'ifile\');\nnuSetHash(\'FILES\' , \'\');\n','2016-10-15 19:18:04','globeadmin','2016-10-15 19:18:04','globeadmin','2020-04-03 20:25:19','globeadmin'),('54ad68e4bf6c280','547d746016fa2bd','onblur','nuFORM.edited = 0;','2015-01-07 19:12:04','globeadmin','2015-01-07 19:12:04','globeadmin','2016-03-26 16:31:53','globeadmin'),('54ad69510d31bb4','54809cf7134817b','onblur','nuFORM.edited = 0;','2015-01-07 19:13:53','globeadmin','2015-01-07 19:13:53','globeadmin','2015-10-04 14:46:52','globeadmin'),('54ad69ce5dc2d9c','548c39cbd4bfd5e','onblur','nuFORM.edited = 0;','2015-01-07 19:15:58','globeadmin','2015-01-07 19:15:58','globeadmin','2015-06-01 10:58:57','globeadmin'),('54ad6a4ad563b8a','54972ec8a2089fa','onblur','nuFORM.edited = 0;','2015-01-07 19:18:02','globeadmin','2015-01-07 19:18:02','globeadmin','2022-01-22 10:50:55','globeadmin'),('54ad6a649107d51','549b25c11669f8c','onblur','nuFORM.edited = 0;','2015-01-07 19:18:28','globeadmin','2015-01-07 19:18:28','globeadmin','2016-01-04 11:23:37','globeadmin'),('54ad6af4a21eadb','54a41994a838651','onblur','nuFORM.edited = 0;','2015-01-07 19:20:52','globeadmin','2015-01-07 19:20:52','globeadmin','2016-09-24 20:54:16','globeadmin'),('54ad6b0c789def3','54a41108b1fc7b5','onblur','nuFORM.edited = 0;','2015-01-07 19:21:16','globeadmin','2015-01-07 19:21:16','globeadmin','2016-09-24 20:54:45','globeadmin'),('5783fd7f02ad173','5783fd7ee81d3fb','onclick','open_email_frame($(\'#email\').val());','2016-07-11 23:11:43','globeadmin','2016-07-11 23:11:43','globeadmin','2018-08-06 22:16:03','globeadmin'),('54ad6bf66033a6b','54a26c39d30d2c0','onblur','nuFORM.edited = 0;','2015-01-07 19:25:10','globeadmin','2015-01-07 19:25:10','globeadmin','2016-07-24 16:18:18','globeadmin'),('54ad6c07d56521f','54a2b91fcbea1b1','onblur','nuFORM.edited = 0;','2015-01-07 19:25:27','globeadmin','2015-01-07 19:25:27','globeadmin','2015-05-30 17:44:20','globeadmin'),('54ad6ceb1966c50','54a92ce7df50a6b','onblur','nuFORM.edited = 0;','2015-01-07 19:29:15','globeadmin','2015-01-07 19:29:15','globeadmin','2021-03-09 19:46:06','globeadmin'),('54ad6f0b4f1ccaf','54aaae2f00a154c','onblur','nuFORM.edited = 0;','2015-01-07 19:38:19','globeadmin','2015-01-07 19:38:19','globeadmin','2020-09-15 13:42:12','globeadmin'),('578674c951d17d8','578674c94314417','onclick','if(confirm(\'Όλα τα αρχεία στο φάκελο tmp του εξυπηρετητή θα διαγραφούν!\\nΕίστε σίγουρος;\')){\n    showLoader();\n    nuAjax(\'clear_tmp\',\'display_ajax_result\',{async:true});\n}\n','2016-07-13 20:05:13','globeadmin','2016-07-13 23:12:57','globeadmin','2016-07-23 19:42:20','globeadmin'),('578f9a7ba74cd8b','578f9a7b988e9cd','onclick','nuOpenForm(\'\',\'\', \'577ebb808309312\', \'#RECORD_ID#\',\'Καθηγητής\');\n \n   ','2016-07-20 18:36:27','globeadmin','2016-07-20 18:36:27','globeadmin','2017-10-06 23:44:28','globeadmin'),('578f9ae11c0b631','578f9ae10d67cae','onclick','nuOpenForm(\'\',\'\', \'572af54adfe5517\', \'#RECORD_ID#\',\'Καθηγητής\');\n\n \n   ','2016-07-20 18:38:09','globeadmin','2016-07-20 18:38:09','globeadmin','2018-03-10 19:12:51','globeadmin'),('578f9a05ce5d5ac','578f9a05bfa01da','onclick','nuOpenForm(\'\',\'\', \'5719cb61e92d4e8\', \'#RECORD_ID#\',\'Καθηγητής\');\n \n   ','2016-07-20 18:34:29','globeadmin','2016-07-20 18:34:29','globeadmin','2018-03-10 19:12:08','globeadmin'),('54b276b06884732','54aaac5d169a703','onclick','var url=$(\'#student_home_school_web_page\').val();\n\nif(!url.startsWith(\'http://\')){\n    url = \'http://\'+url;    \n}\nwindow.open(url, \'_blank\');','2015-01-11 15:12:16','globeadmin','2016-09-15 19:47:16','globeadmin','2017-10-15 13:05:18','globeadmin'),('57dae3131b01059','57dae313051002e','onchange','var x = document.getElementById(\'class_subject_selection\');\nvar class_subject_id = x.options[x.selectedIndex].value;\n\nvar pos = class_subject_id.search(\',\');\nvar class_id= class_subject_id.substr(0, pos);\nvar subject_id= class_subject_id.substring(pos+1, class_subject_id.length);\n\nset_session_variable(\'class_id\',class_id);\nset_session_variable(\'subject_id\',subject_id);\n\nnuRunPHP(\'create_teaching_book\' , \'registered_cards_iframe\');\n','2016-09-15 21:06:11','globeadmin','2016-09-15 21:06:11','globeadmin','2018-07-25 13:54:16','globeadmin'),('54b2dc997f351ba','54b2db273866aaa','onblur','nuFORM.edited = 0;','2015-01-11 22:27:05','globeadmin','2015-01-11 22:27:05','globeadmin','2016-09-29 12:49:02','globeadmin'),('54b2dbabb9cba06','54b2dbabab261b6','onclick','var x = document.getElementById(\'set_responsible_class\');\nvar class_id = x.options[x.selectedIndex].value;\n\nvar x = document.getElementById(\'set_responsible_teacher\');\nvar teacher_id = x.options[x.selectedIndex].value;\n\nif (class_id==\'\'){\n    alert(\'Παρακαλώ Επιλέξτε Τμήμα..\');\n} else if(teacher_id==\'\'){\n    alert(\'Παρακαλώ Επιλέξτε Καθηγητή..\');\n} else {\n    \n    nuSetHash(\'class_id\',class_id);\n    nuSetHash(\'teacher_id\',teacher_id);\n    \n    nuRunPHP(\'set_class_responsible\',\'set_responsible_info\');\n}','2015-01-11 22:23:07','globeadmin','2015-01-12 20:07:35','globeadmin','2015-01-12 20:07:35','globeadmin'),('54b2dc85d237026','54b2dac10794544','onblur','nuFORM.edited = 0;','2015-01-11 22:26:45','globeadmin','2015-01-11 22:26:45','globeadmin','2016-09-29 12:46:35','globeadmin'),('54b2ddae66c9e17','54b2ddae5823bd9','onblur','nuFORM.edited = 0;','2015-01-11 22:31:42','globeadmin','2015-01-11 22:31:42','globeadmin','2015-11-21 20:59:10','globeadmin'),('54d66050bef6833','54d66050a8ff183','onclick',';\nnuRunPHP(\'penalty_read\',\'insert_penalty_iframe\');','2015-02-07 20:58:24','globeadmin','2015-02-07 20:58:24','globeadmin','2016-10-24 19:09:47','globeadmin'),('54d660d655fb75f','54d660d64757149','onclick',';\nnuRunPHP(\'penalty_read\',\'insert_penalty_iframe\');','2015-02-07 21:00:38','globeadmin','2015-02-07 21:00:38','globeadmin','2018-07-02 09:23:26','globeadmin'),('54d6626bc64977a','54d6626bb7a3dde','onclick',';\nnuRunPHP(\'penalty_insert\',\'insert_penalty_iframe\');','2015-02-07 21:07:23','globeadmin','2015-02-07 21:07:23','globeadmin','2016-12-05 15:19:07','globeadmin'),('54df21aad554a9a','54df21aac43c3d0','onclick','var x = document.getElementById(\'card_date\');\nvar card_date = x.value;\n\nx = document.getElementById(\'current_date\');\nvar current_date = x.value;\n\nx = document.getElementById(\'timetable_count\');\nvar timetable_count = x.value;\n\nif (card_date!=\'\'){\n\n    var temp    = \'\';\n    var str     = card_date; \n    var dt      = str.substring(0,2);\n    var mon     = str.substring(3,5);\n    var yr      = str.substring(6,10); \n    \n    card_date_temp      = yr + \"-\" + mon + \"-\" + dt;\n    \n    var s = document.getElementById(\'active_timetables\');\n    var other_prog_exists=false;\n    var stop=false;\n    \n    if(current_date <= card_date_temp) {\n        \n        for (var i = 0; i < s.options.length; i++) {\n            \n            var prog_date=s.options[i].value;\n            \n            if(prog_date==card_date_temp){\n                if(!confirm(\'Προσοχή : Υπάρχει και άλλο καταχωρήμενο προγράμμα στις \'+card_date+\'!\\n\\nΘέλετε να αντικατασταθεί;\\n \')){\n                    stop=true;\n                } \n            }\n            \n            if(prog_date>card_date_temp){other_prog_exists=true;}\n        }\n        \n        if(other_prog_exists && !stop){\n            if(!confirm(\'Προσοχή : Υπάρχουν προγράμματα με μεταγενέστερη ημερομηνία έναρξης! Το πρόγραμμα αυτό θα έχει περιορισμένη διάρκεια!\\n\\nΘέλετε να συνεχίσετε;\\n \')){\n                    stop=true;\n                }  \n        }\n    } else {\n        if(timetable_count!=\'0\'){ // Στη περίπτωση που δεν είναι το πρώτο πρόγραμμα που εισάγεται\n            alert(\'Προσοχή : Η ημερομηνία έναρξης ισχύος του νέου προγράμματος πρέπει να μην έχει περάσει!\');    \n            stop=true;\n        }\n    }\n\n    if(!stop){\n        nuRunPHP(\'timetable_insert\',\'insert_timetable_iframe\');\n    }\n\n} else{\n    alert(\'Παρακαλώ επιλέξτε ημερομηνία έναρξης ισχύος του ωρολογίου...\');\n}\n','2015-02-14 12:21:30','globeadmin','2017-10-31 20:20:13','globeadmin','2020-04-02 16:12:13','globeadmin'),('54df1333c1cb39c','54df1333abd3c69','onclick','if(document.getElementById(\'account_creation\').checked){\n    nuSetHash(\'user_creation\',\'YES\');\n} else {\n    nuSetHash(\'user_creation\',\'NO\');\n}\n\nif(document.getElementById(\'student_update\').checked){\n    if(confirm(\'ΠΡΟΣΟΧΗ : Όλα τα στοιχεία των μαθητών όπου υπάρχει διαφορά (κίτρινο χρώμα), θα μεταβληθούν!\\nΕίστε σίγουρος;\')){\n        nuSetHash(\'update_students\',\'YES\');\n        nuRunPHP(\'student_insert\',\'insert_student_iframe\');\n        nuFORM.edited = 0;\n    }\n} else {\n    nuSetHash(\'update_students\',\'NO\');\n    nuRunPHP(\'student_insert\',\'insert_student_iframe\');\n    nuFORM.edited = 0;\n}','2015-02-14 11:19:47','globeadmin','2015-03-03 08:41:26','globeadmin','2016-10-22 13:50:14','globeadmin'),('54df1390a9612ec','54df13909abb4c9','onclick',';\nnuRunPHP(\'penalty_read\',\'insert_penalty_iframe\');','2015-02-14 11:21:20','globeadmin','2015-02-14 11:21:20','globeadmin','2018-07-03 13:00:21','globeadmin'),('54df13eace00732','54df13eabf5bc61','onclick',';\nnuRunPHP(\'student_read\',\'insert_student_iframe\');','2015-02-14 11:22:50','globeadmin','2015-02-14 11:22:50','globeadmin','2020-11-01 11:21:20','globeadmin'),('54df1eb614747de','54df1eb605cfd4c','onclick',';\nnuRunPHP(\'penalty_read\',\'insert_penalty_iframe\');','2015-02-14 12:08:54','globeadmin','2015-02-14 12:08:54','globeadmin','2018-07-12 23:43:10','globeadmin'),('54df1ef9a6f029a','54df1ef9984bd44','onclick',';\nnuRunPHP(\'student_class_read\',\'insert_student_class_iframe\');','2015-02-14 12:10:01','globeadmin','2015-02-14 12:10:01','globeadmin','2015-02-14 12:10:02','globeadmin'),('54df21e047b93b1','54df21e03914ceb','onclick',';\nnuRunPHP(\'penalty_read\',\'insert_penalty_iframe\');','2015-02-14 12:22:24','globeadmin','2015-02-14 12:22:24','globeadmin','2018-07-02 23:10:07','globeadmin'),('54df221c6ec932c','54df221c602520c','onclick',';\nnuRunPHP(\'timetable_read\',\'insert_timetable_iframe\');','2015-02-14 12:23:24','globeadmin','2015-02-14 12:23:24','globeadmin','2016-01-13 18:45:01','globeadmin'),('59d88b4a3012574','59d88b4a1c965b8','onclick','var open_absence_books = 0;\nopen_absence_books = get_session_variable(\'open_absence_books\');\n\nif(open_absence_books==0){\n    nuOpenForm(\'\',\'\', \'5501db35db0c716\', \'#RECORD_ID#\',\'Καταχώριση Aπουσιών στη Τάξη\');\n} else {\n    nuOpenForm(\'\',\'\', \'5787f33aaa172a1\', \'#RECORD_ID#\',\'Καταχώριση Aπουσιών στη Τάξη\');\n}','2017-10-07 11:07:38','globeadmin','2018-07-22 16:08:16','globeadmin','2021-02-26 22:35:41','globeadmin'),('54f0c2ee8bbe3b7','54f0ac403b2b132','onclick','openStudent(this);','2015-02-27 21:18:06','globeadmin','2015-02-27 21:18:06','globeadmin','2015-05-08 11:19:21','globeadmin'),('54f0c3220576bdb','54f0ac4033d8282','onclick','openStudent(this);','2015-02-27 21:18:58','globeadmin','2015-02-27 21:18:58','globeadmin','2015-11-22 22:33:28','globeadmin'),('54f0c33ec8c5336','54f0ac40427efc9','onclick','openStudent(this);','2015-02-27 21:19:26','globeadmin','2015-02-27 21:19:26','globeadmin','2015-05-08 11:20:09','globeadmin'),('54f0c359d9dd9d0','54f0ac4049d1a78','onclick','openStudent(this);','2015-02-27 21:19:53','globeadmin','2015-02-27 21:19:53','globeadmin','2015-10-04 14:38:06','globeadmin'),('54f55537f0ebae0','54f4b9e39a9c7c1','onblur','nuFORM.edited = 0;','2015-03-03 08:31:19','globeadmin','2015-03-03 08:31:19','globeadmin','2021-09-04 23:32:17','globeadmin'),('54f5554f4122f01','54ef61c0c3e3820','onblur','nuFORM.edited = 0;','2015-03-03 08:31:43','globeadmin','2015-03-03 08:31:43','globeadmin','2015-03-03 08:31:43','globeadmin'),('54f73b36dcb9594','54f73a31a9747ec','onchange','nuRunPHP(\'create_absence_class_table\',\'absence_iframe\');','2015-03-04 19:04:54','globeadmin','2017-09-22 22:49:16','globeadmin','2018-11-18 23:14:13','globeadmin'),('54f7516cdcb90f6','54f73993ba89b87','onchange','nuRunPHP(\'create_absence_class_table\',\'absence_iframe\');','2015-03-04 20:39:40','globeadmin','2017-09-22 22:49:06','globeadmin','2022-09-24 22:50:39','globeadmin'),('57967dfd04830c8','57967dfce78e8d1','onclick','var x = document.getElementById(\"student_mark_grade_period\");\nvar grading_period_id = x.options[x.selectedIndex].value;\n\nvar iframe = document.getElementById(\'student_mark_showiframe\');\nvar innerDoc = (iframe.contentDocument) ? iframe.contentDocument : iframe.contentWindow.document;\n\nvar values = innerDoc.getElementsByClassName(\'value\');\nvar evaluations = innerDoc.getElementsByClassName(\'evaluation\');\n\nif (grading_period_id==\'\'){\n    alert(\'Παρακαλώ επιλέξτε πρώτα την Περίοδο Αξιολόγησης\');\n} else {\n    \n    if (values.length==0 && evaluations.length==0){\n        alert(\'Δεν υπάρχεί αξιολόγηση προς εκτύπωση...\');    \n    } else {\n        if(values.length>0 && evaluations.length>0){\n            nuPrintPDF(\'marks_print_student\');\n            if(confirm(\'Να εκτυπωθεί και η περιγραφική αξιολόγηση;\')){\n                nuPrintPDF(\'marks_print_student_evaluation\');    \n            }\n        } else {\n            if (values.length>0){\n                nuPrintPDF(\'marks_print_student\');\n            }\n    \n            if (evaluations.length>0){\n                nuPrintPDF(\'marks_print_student_evaluation\');\n            }\n        }\n    }\n    \n}','2016-07-26 00:00:45','globeadmin','2016-07-28 15:44:55','globeadmin','2016-07-28 15:48:46','globeadmin'),('54f89f954fc02c2','54f89f95411a754','onclick','nuSaveForm();\nnuAjax(\'find_school_year_holidays\',\'foo\');\nnuReloadForm();\n','2015-03-05 20:25:25','globeadmin','2015-03-06 20:05:44','globeadmin','2016-02-07 20:59:29','globeadmin'),('54fdb0cda22b477','54fdb0cd8e94a69','onclick','var iframe = document.getElementById(\'absence_iframe\');\nvar innerDoc = (iframe.contentDocument) ? iframe.contentDocument : iframe.contentWindow.document;\n\nvar a = innerDoc.getElementsByClassName(\'absence\');\n\nif (a.length>0){\n    \n    var ids = \'\';\n    for(i=0;i<a.length;i++){\n    \n        res = a[i].id.split(\'_\');\n        \n        absence_reason_id=parseInt(res[2]);\n        \n        if(absence_reason_id!=0){\n            if (ids == \'\'){\n                ids =  a[i].id;\n            } else {\n                ids = ids+\';\'+a[i].id;\n            }\n        }\n    }\n    \n    if (ids != \'\'){\n        nuSetHash(\'absence_id_list\',ids);\n        nuAjax(\'add_class_absences\',\'foo\');     // Καταχώριση Απουσίών\n                                                // Η Δήλωση Καταχώρισης Απουσίών μετακινήθηκε στο add_class_absences\n        //nuAjax(\'register_class_cards\',\'foo\'); // Δήλωση Καταχώρισης Απουσίών\n    } else {\n        nuAjax(\'register_class_cards\',\'foo\'); // Δήλωση Καταχώρισης Απουσίών\n    }\n    \n    nuRunPHP(\'create_absence_class_table\',\'absence_iframe\'); // Επαναφόρτωση Απουσιολογίου\n    \n} else {\n    alert(\'Δεν υπάρχουν στοιχεία προς καταχώριση...\');\n}\n\n\n','2015-03-09 16:40:13','globeadmin','2016-07-18 00:15:02','globeadmin','2019-11-05 19:23:50','globeadmin'),('55044f4c6c8d3bc','55044f4c5b6748e','onclick','var iframe = document.getElementById(\'period_absence_iframe\');\nvar innerDoc = (iframe.contentDocument) ? iframe.contentDocument : iframe.contentWindow.document;\n\nvar a = innerDoc.getElementsByClassName(\'absence\');\n\nvar y = document.getElementById(\'period_absence_class\');\n\nvar class_id = y.options[y.selectedIndex].value;\n\nif (a.length>0){\n\n    if(document.getElementById(\'period_absence_timeleft_text\').value > \'00:00:00\'){\n    \n        nuSetHash(\'absence_class_id\',class_id);\n    \n        var ids = \'\';\n        var period_id;\n        for(i=0;i<a.length;i++){\n    \n            res = a[i].id.split(\'_\');\n        \n            absence_reason_id=parseInt(res[2]);\n            period_id=res[1];\n        \n            if(absence_reason_id!=0){\n                if (ids == \'\'){\n                    ids =  a[i].id;\n                } else {\n                    ids = ids+\';\'+a[i].id;\n                }\n            }\n        }\n    \n        if (ids != \'\'){\n            nuSetHash(\'absence_id_list\',ids);\n            nuSetHash(\'absence_period_id\',period_id);\n            nuAjax(\'add_period_absences\',\'foo\');        // Καταχώριση Απουσίών\n                                                        // Η δήλωση Δήλωση Καταχώρισης Απουσίών πραγματοποιείται από το add_period_absences\n            //nuAjax(\'register_period_cards\',\'foo\');    // Δήλωση Καταχώρισης Απουσίών\n        } else {\n            nuAjax(\'register_period_cards\',\'foo\');      // Δήλωση Καταχώρισης Απουσίών\n        }\n    \n        if(ajaxSucced){\n            nuRunPHP(\'create_absence_period_table\',\'period_absence_iframe\'); // Επαναφόρτωση Απουσιολογίου\n        \n            // Πρέπει να σταματήσει ο μετρητής!\n        \n            if(myInterval){\n                clearInterval(myInterval);\n            }\n    \n            if(myTimeOut){\n                clearTimeout(myTimeOut);\n            }\n    \n            if(y.length==2){\n                $(\'#period_absence_timeleft_text\').val(\'00:00:00\');\n                $(\'#period_absence_timeleft_text\').css(\'background-color\', \'Grey\');\n                $(\'#period_absence_timeleft_text\').css(\'color\', \'black\'); \n            }\n            \n            ajaxSucced = false;\n        } else {\n            alert(\'Παρουσιάστηκε πρόβλημα κατά τη καταχώριση των απουσιών!\\nΠαρακαλώ ξαναπροσπαθήστε αργότερα!\');    \n        }\n    } else {\n        alert(\'Έχει λήξει το χρονικό όριο καταχώρισης των απουσιών...\');\n    }\n}else {\n    alert(\'Δεν υπάρχουν στοιχεία προς καταχώριση...\');\n}\n','2015-03-14 17:10:04','globeadmin','2016-03-06 10:29:13','globeadmin','2016-12-06 13:32:29','globeadmin'),('55048b63c990b14','55040e47d578a0d','onchange','var y = document.getElementById(\'period_absence_class\');\nvar class_id = y.options[y.selectedIndex].value;\n\nnuSetHash(\'absence_class_id\',class_id);\n\nnuRunPHP(\'create_absence_period_table\',\'period_absence_iframe\');','2015-03-14 21:26:27','globeadmin','2015-03-14 21:37:17','globeadmin','2016-07-14 23:19:43','globeadmin'),('5b5f3f3d57d616a','5b5f3311c24cb74','ondblclick','nuOpenAce(\"SQL\", this.id, \"Form SQL\");','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('550d45939d37845','550d4593873edeb','onclick','/*\nnuSetHash(\'teacher_id\', get_session_variable(\'teacher_id\'));\nnuSetHash(\'absence_id\', \'\');\nnuAjax(\'add_justification_request\',\'open_new_justification_request\');// Καταχώριση Αιτήματος\nnuRunPHP(\'show_absence_justification_requests\',\'justification_requests_iframe\'); // Επαναφόρτωση Αιτημάτων\n*/\n\nnuOpenFormInFrame(\'584bd01a9203a9a\', get_session_variable(\'teacher_id\'));\n\n','2015-03-21 12:18:59','globeadmin','2018-08-07 15:17:42','globeadmin','2021-03-09 14:49:17','globeadmin'),('5b709e4c0cabd74','5b709e4bed47213','onblur','nuFORM.edited = 0;','2018-08-12 23:53:32','globeadmin','2018-08-12 23:53:32','globeadmin','2018-08-13 10:22:29','globeadmin'),('5b709e4c1674ea7','5b709e4bed47213','onchange','sumoSetHashSelectedIds(this);','2018-08-12 23:53:32','globeadmin','2018-08-12 23:53:32','globeadmin','2018-08-13 10:22:29','globeadmin'),('550dca97c5bded6','550dca97afc51ac','onclick','if(nuFORM.edited){\n    alert(\'Έχετε κάνει αλλαγές στο αίτημα δικαιολόγησης! Παρακαλώ αποθηκεύστε πρώτα...\');\n} else{\n    nuSetHash(\'justification_request_id\',\'#RECORD_ID#\');\n    nuAjax(\'decline_justification_request\',\'foo\');// Απόρριψη Αιτήματος\n    parent.nuRunPHP(\'show_absence_justification_requests\',\'justification_requests_iframe\'); // Επαναφόρτωση Αιτημάτων\n    nuReloadForm();\n}','2015-03-21 21:46:31','globeadmin','2015-03-28 19:40:10','globeadmin','2016-10-08 10:59:18','globeadmin'),('550dcb0768f7e52','550dcb07508dc56','onclick','if(nuFORM.edited){\n    alert(\'Έχετε κάνει αλλαγές στο αίτημα δικαιολόγησης! Παρακαλώ αποθηκεύστε πρώτα...\');\n} else{\n    nuSetHash(\'justification_request_id\',\'#RECORD_ID#\');\n    nuAjax(\'aprove_justification_request\',\'foo\');// Έγκριση Αιτήματος\n    parent.nuRunPHP(\'show_absence_justification_requests\',\'justification_requests_iframe\'); // Επαναφόρτωση Αιτημάτων\n    nuReloadForm();\n}','2015-03-21 21:48:23','globeadmin','2015-03-28 19:29:39','globeadmin','2015-10-15 21:39:31','globeadmin'),('550e7c5272931dc','550e7c52617a9bb','onclick','nuAjax(\'id_generator\', \'set_id\');','2015-03-22 10:24:50','globeadmin','2015-03-22 10:32:47','globeadmin','2016-09-25 13:58:34','globeadmin'),('550ec6d1d63fa14','55040e47d578a0d','onblur','nuFORM.edited = 0;','2015-03-22 15:42:41','globeadmin','2015-03-22 15:42:41','globeadmin','2016-07-14 23:19:43','globeadmin'),('550ec6f1dd92b78','55031a2868f6575','onblur','nuFORM.edited = 0;','2015-03-22 15:43:13','globeadmin','2015-03-22 15:43:13','globeadmin','2015-03-22 15:43:14','globeadmin'),('550ecbc6dd91473','54f73a31a9747ec','onblur','nuFORM.edited = 0;','2015-03-22 16:03:50','globeadmin','2015-03-22 16:03:50','globeadmin','2018-11-18 23:14:13','globeadmin'),('550ecbdc1cb24b6','54f73993ba89b87','onblur','nuFORM.edited = 0;','2015-03-22 16:04:12','globeadmin','2015-03-22 16:04:12','globeadmin','2022-09-24 22:50:39','globeadmin'),('5512837f8c3e9b8','5512837f7d9a410','onclick','nuRunPHP(\'search_teacher_absence\',\'search_iframe\');','2015-03-25 11:44:31','globeadmin','2015-03-25 15:50:26','globeadmin','2016-12-05 19:20:39','globeadmin'),('5512848520d2d14','55128485122ca74','onblur','nuFORM.edited = 0;','2015-03-25 11:48:53','globeadmin','2015-03-25 11:53:36','globeadmin','2021-04-01 10:49:09','globeadmin'),('5512850e827ad0f','55127ccbb0de71b','onblur','nuFORM.edited = 0;','2015-03-25 11:51:10','globeadmin','2015-03-25 11:51:10','globeadmin','2017-11-25 11:33:30','globeadmin'),('55128526393cc9b','55127cec20d42cc','onblur','nuFORM.edited = 0;','2015-03-25 11:51:34','globeadmin','2015-03-25 11:51:34','globeadmin','2016-10-23 19:04:08','globeadmin'),('551285420386842','55127b84875e51e','onblur','nuFORM.edited = 0;','2015-03-25 11:52:02','globeadmin','2015-03-25 11:52:02','globeadmin','2019-11-06 09:18:45','globeadmin'),('5512855b76458f0','55127dcf345abf4','onblur','nuFORM.edited = 0;','2015-03-25 11:52:27','globeadmin','2015-03-25 11:52:27','globeadmin','2019-11-06 09:18:17','globeadmin'),('551285779d576a4','551280cbbf8530f','onblur','nuFORM.edited = 0;','2015-03-25 11:52:55','globeadmin','2015-03-25 11:52:55','globeadmin','2018-08-05 00:20:26','globeadmin'),('55128b5d56888f7','55128b5d47e445a','onblur','nuFORM.edited = 0;','2015-03-25 12:18:05','globeadmin','2015-03-25 12:18:05','globeadmin','2016-10-23 19:07:24','globeadmin'),('551293038eaf8e4','55129303800b34e','onblur','nuFORM.edited = 0;','2015-03-25 12:50:43','globeadmin','2015-03-25 12:50:43','globeadmin','2019-03-10 11:10:46','globeadmin'),('5512948f25b4df8','5512948f171035b','onblur','nuFORM.edited = 0;','2015-03-25 12:57:19','globeadmin','2015-03-25 12:57:19','globeadmin','2018-08-05 00:26:39','globeadmin'),('551295056a1088f','551295055b6c4d7','onblur','nuFORM.edited = 0;','2015-03-25 12:59:17','globeadmin','2015-03-25 12:59:17','globeadmin','2016-12-24 16:57:30','globeadmin'),('5512aa9f17101e3','5512aa9f05f9517','onblur','nuFORM.edited = 0;','2015-03-25 14:31:27','globeadmin','2015-03-25 14:31:27','globeadmin','2021-10-28 17:20:58','globeadmin'),('5512f489baa19c4','5512f489abfd236','onblur','nuFORM.edited = 0;','2015-03-25 19:46:49','globeadmin','2015-03-25 19:46:49','globeadmin','2015-04-16 11:01:59','globeadmin'),('5516e6d5d355832','550dc0209007de1','onblur','nuFORM.edited = 0;','2015-03-28 19:37:25','globeadmin','2015-03-28 19:37:25','globeadmin','2018-08-04 11:55:22','globeadmin'),('55182239e1ce4e3','55182239d32859d','onblur','nuFORM.edited = 0;','2015-03-29 19:03:05','globeadmin','2015-03-29 19:03:05','globeadmin','2015-03-29 19:56:22','globeadmin'),('551822529b012f2','551822528c5b4f0','onblur','nuFORM.edited = 0;','2015-03-29 19:03:30','globeadmin','2015-03-29 19:03:30','globeadmin','2015-03-29 19:56:29','globeadmin'),('55182267d328868','55182267c48246a','onblur','nuFORM.edited = 0;','2015-03-29 19:03:51','globeadmin','2015-03-29 19:03:51','globeadmin','2016-12-26 10:28:14','globeadmin'),('5518228dce461f8','5518228dbfa0990','onblur','nuFORM.edited = 0;','2015-03-29 19:04:29','globeadmin','2015-03-29 19:04:29','globeadmin','2018-08-04 20:49:26','globeadmin'),('551822aa36e86d2','551822aa2842338','onblur','nuFORM.edited = 0;','2015-03-29 19:04:58','globeadmin','2015-03-29 19:04:58','globeadmin','2018-08-04 20:56:48','globeadmin'),('551822f17b442a5','551822f16c9fd72','onclick','nuRunPHP(\'search_teacher_absence\',\'search_iframe\');','2015-03-29 19:06:09','globeadmin','2015-03-29 19:06:09','globeadmin','2016-12-26 10:33:37','globeadmin'),('5518230a03a3196','55182309e9216e7','onblur','nuFORM.edited = 0;','2015-03-29 19:06:34','globeadmin','2015-03-29 19:06:34','globeadmin','2015-03-29 20:00:59','globeadmin'),('5518233025d12ff','55182330172b455','onblur','nuFORM.edited = 0;','2015-03-29 19:07:12','globeadmin','2015-03-29 19:07:12','globeadmin','2018-07-13 23:10:01','globeadmin'),('5518277378d4906','54a85bc4032bd41','onblur','nuFORM.edited = 0;','2015-03-29 19:25:23','globeadmin','2015-03-29 19:25:23','globeadmin','2018-07-05 13:10:57','globeadmin'),('5518302a1743a5d','5518302a088531b','onblur','nuFORM.edited = 0;','2015-03-29 20:02:34','globeadmin','2015-03-29 20:02:34','globeadmin','2015-03-29 20:02:34','globeadmin'),('551a35a23a483fc','551a35a2292f7cf','onblur','nuFORM.edited = 0;','2015-03-31 08:50:26','globeadmin','2015-03-31 08:50:26','globeadmin','2016-12-24 17:16:14','globeadmin'),('551a35d05a04423','551a35d0440a3b2','onblur','nuFORM.edited = 0;','2015-03-31 08:51:12','globeadmin','2015-03-31 08:51:12','globeadmin','2015-04-01 10:32:32','globeadmin'),('552231ae56c30e7','552231ae3e5575d','onblur','nuFORM.edited = 0;','2015-04-06 10:11:42','globeadmin','2015-04-06 10:11:42','globeadmin','2018-08-05 14:06:29','globeadmin'),('551a3666970dca9','551a366685f6b14','onblur','nuFORM.edited = 0;','2015-03-31 08:53:42','globeadmin','2015-03-31 08:53:42','globeadmin','2018-01-09 21:24:25','globeadmin'),('551a36a0be1c8d6','551a36a0aa969ab','onclick','nuRunPHP(\'search_absence_justification_requests\',\'justification_requests_iframe\');','2015-03-31 08:54:40','globeadmin','2015-03-31 20:41:13','globeadmin','2018-08-04 11:48:38','globeadmin'),('551a36af1336f16','551a36af021f796','onblur','nuFORM.edited = 0;','2015-03-31 08:54:55','globeadmin','2015-03-31 08:54:55','globeadmin','2015-03-31 08:54:55','globeadmin'),('551a36d19e60df7','551a36d18d48356','onblur','nuFORM.edited = 0;','2015-03-31 08:55:29','globeadmin','2015-03-31 08:55:29','globeadmin','2018-07-17 01:05:12','globeadmin'),('551a3ddb7ea3d9f','551a3ddb6d8b44f','onblur','nuFORM.edited = 0;','2015-03-31 09:25:31','globeadmin','2015-03-31 09:25:31','globeadmin','2018-01-09 21:16:42','globeadmin'),('551a602024525a7','551a60200e56dcb','onclick','\nvar t=get_session_variable(\'teacher_id\');\n\nif  (($.isNumeric(t)) && (t!=-1)) {\n    nuOpenForm(\'\',\'\', \'55127aebdf42446\', t,\'Καθηγητής\');\n    }\nelse{\n    if(nuIsGA()){\n        nuOpenForm(\'\',\'\', \'55127aebdf42446\', 26,\'Καθηγητής\');\n        }\n    else{\n        alert(\"Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με καθηγητή!\");\n        }\n    }\n   ','2015-03-31 11:51:44','globeadmin','2015-03-31 12:01:07','globeadmin','2015-10-10 17:38:43','globeadmin'),('551a6045b6cb2f2','551a6045a5b2446','onclick','\nvar t=get_session_variable(\'teacher_id\');\n\nif  (($.isNumeric(t)) && (t!=-1)) {\n    nuOpenForm(\'\',\'\', \'551a34a930825c0\', t,\'Καθηγητής\');\n    }\nelse{\n    if(nuIsGA()){\n        nuOpenForm(\'\',\'\', \'551a34a930825c0\', 26,\'Καθηγητής\');\n        }\n    else{\n        alert(\"Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με καθηγητή!\");\n        }\n    }\n   ','2015-03-31 11:52:21','globeadmin','2015-03-31 12:01:38','globeadmin','2015-10-10 17:39:15','globeadmin'),('552232346f41ba1','55223234608396b','onblur','nuFORM.edited = 0;','2015-04-06 10:13:56','globeadmin','2015-04-06 10:13:56','globeadmin','2016-01-19 11:21:06','globeadmin'),('5522344a56bf637','5522344a481b1a2','onblur','nuFORM.edited = 0;','2015-04-06 10:22:50','globeadmin','2015-04-06 10:22:50','globeadmin','2022-01-31 16:19:24','globeadmin'),('552168ae5860caa','552168ae4261715','onclick','if($(\'#period_count\').val()==\'8\'){\n    nuPrintPDF(\'absence_class_day_table8\');\n} else {\n    nuPrintPDF(\'absence_class_day_table\');    \n}\n    \n\n','2015-04-05 19:54:06','globeadmin','2018-11-19 23:29:37','globeadmin','2018-12-03 16:14:41','globeadmin'),('578e9c7e0f2ba4a','578e9c7e006f0ee','onblur','nuFORM.edited = 0;','2016-07-20 00:32:46','globeadmin','2016-07-20 00:32:46','globeadmin','2017-03-14 20:30:37','globeadmin'),('552231ae4d13c7c','552231ae3e5575d','onchange','//var x = document.getElementById(\'absence_date\');\n//nuSetHash(\'absence_date\',x.value);\n\nnuRunPHP(\'justify_student_day_absence\',\'absence_iframe\');\nnuRunPHP(\'student_cards_not_registered_msg\',\'not_registered_cards_msg_iframe\');\n//nuOpenFormInFrame(\'55479f1837f6df0\', \'#RECORD_ID#\');','2015-04-06 10:11:42','globeadmin','2015-05-04 20:19:33','globeadmin','2018-08-05 14:06:29','globeadmin'),('5522b35f63ce724','5522b35f4dd5a83','onclick','var iframe = document.getElementById(\'absence_iframe\');\nvar innerDoc = (iframe.contentDocument) ? iframe.contentDocument : iframe.contentWindow.document;\nvar a = innerDoc.getElementsByClassName(\'justify_chk\');\n\nvar y = document.getElementById(\'justify_reason\');\n\nvar justify_reason_id = y.options[y.selectedIndex].value;\n\nif (a.length>0){\n\n    if(justify_reason_id!=\'\'){\n        \n        nuSetHash(\'justify_reason_id\',justify_reason_id);\n    \n        var ids = \'\';\n\n        for(i=0;i<a.length;i++){\n    \n            if(a[i].checked){\n                absence_id = a[i].id;\n\n                if (ids == \'\'){\n                    ids =  absence_id;\n                } else {\n                    ids = ids + \',\' + absence_id;\n                }\n            }\n        }\n        \n        if (ids != \'\'){\n            if(confirm(\'Είστε σίγουρος;\')){\n        \n                nuSetHash(\'absence_id_list\',ids);\n                nuAjax(\'justify_absences\',\'foo\');                                   // Δικαιολόγηση Απουσίών\n                nuRunPHP(\'justify_student_day_absence\',\'absence_iframe\');    // Επαναφόρτωση Απουσιολογίου\n            }\n            \n        } else {\n            alert(\'Παρακαλώ επιλέξτε απουσίες για δικαιολόγηση…\');\n        }\n    } else {\n        alert(\'Παρακαλώ επιλέξτε λόγο δικαιολόγησης των απουσιών…\');\n    }\n}else {\n    alert(\'Δεν υπάρχουν στοιχεία προς καταχώριση...\');\n}\n','2015-04-06 19:25:03','globeadmin','2015-04-06 20:44:09','globeadmin','2020-06-09 21:00:07','globeadmin'),('5522dd40dba3593','5522dd40ca8ac28','onclick','\nvar t=get_session_variable(\'teacher_id\');\n\nif  (($.isNumeric(t)) && (t!=-1)) {\n    nuOpenForm(\'\',\'\', \'54f735c7d56625f\', t,\'Καθηγητής\');\n    }\nelse{\n    if(nuIsGA()){\n        nuOpenForm(\'\',\'\', \'54f735c7d56625f\', 26,\'Καθηγητής\');\n        }\n    else{\n        alert(\"Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με καθηγητή!\");\n        }\n    }\n   ','2015-04-06 22:23:44','globeadmin','2015-04-06 22:27:35','globeadmin','2015-12-26 20:46:49','globeadmin'),('552404248fbec1c','55240424811a361','onblur','nuFORM.edited = 0;','2015-04-07 19:21:56','globeadmin','2015-04-07 19:21:56','globeadmin','2018-08-05 12:48:39','globeadmin'),('5612bc193711422','5612bc192389785','onclick','nuOpenForm(\'\',\'\', \'55222f79d342b66\', \'\',\'Δικαιολόγηση Απουσιών\');','2015-10-05 21:06:17','globeadmin','2015-10-05 21:06:17','globeadmin','2017-10-07 11:36:43','globeadmin'),('5611a20ded7af10','5611a20dded7b81','onblur','nuFORM.edited = 0;','2015-10-05 01:02:53','globeadmin','2015-10-05 01:02:53','globeadmin','2018-08-05 12:48:58','globeadmin'),('552549d067a4970','552549d058ff209','onblur','nuFORM.edited = 0;','2015-04-08 18:31:28','globeadmin','2015-04-08 18:31:28','globeadmin','2022-02-11 20:38:14','globeadmin'),('552549e9c6da740','552549e9b837755','onblur','nuFORM.edited = 0;','2015-04-08 18:31:53','globeadmin','2015-04-08 18:31:53','globeadmin','2022-02-11 20:38:37','globeadmin'),('55254a979606a63','55254a978760860','onblur','nuFORM.edited = 0;','2015-04-08 18:34:47','globeadmin','2015-04-08 18:34:47','globeadmin','2022-09-17 21:43:38','globeadmin'),('55254a979fcbe47','55254a978760860','onclick','nuRunPHP(\'absence_card_not_registered\',\'search_iframe\');','2015-04-08 18:34:47','globeadmin','2015-04-08 21:12:35','globeadmin','2022-09-17 21:43:38','globeadmin'),('55254ae88eb5151','55254ae87d9c8ea','onblur','nuFORM.edited = 0;','2015-04-08 18:36:08','globeadmin','2015-04-08 18:36:08','globeadmin','2022-02-11 21:01:47','globeadmin'),('55254ee7876065f','55254ee778bc26d','onblur','nuFORM.edited = 0;','2015-04-08 18:53:11','globeadmin','2015-04-08 18:53:11','globeadmin','2020-10-06 23:47:11','globeadmin'),('55261fac45b3bdb','55261fac370f6c1','onblur','nuFORM.edited = 0;','2015-04-09 09:43:56','globeadmin','2015-04-09 09:43:56','globeadmin','2018-06-01 18:55:59','globeadmin'),('55261fc374170fe','55261fc36572632','onblur','nuFORM.edited = 0;','2015-04-09 09:44:19','globeadmin','2015-04-09 09:44:19','globeadmin','2018-06-01 18:56:27','globeadmin'),('55261fd72fbe47f','55261fd71750db6','onclick','var x = document.getElementById(\'export_type\');\nvar s = x.options[x.selectedIndex].value;\n\nif(s==\'\'){\n    alert(\'Παρακαλώ επιλεξτε «Μορφή Εξαγόμενων Αρχείων»\');    \n} else if(s==\'1\'){\n    var class_ids = nuGetHash(\'class_id_sumo\');\n    if(class_ids){\n        nuRunPHP(\'extract_absence_class\',\'search_iframe\'); \n    } else {\n        alert(\'Παρακαλώ επιλεξτε πρώτα τα Τμήματα\');    \n    }\n}  else if(s==\'2\'){\n    var student_ids = nuGetHash(\'student_id_sumo\');\n    if(student_ids){\n        showLoader();\n        nuAjax(\'extract_absence_student_excel\',\'get_excel_file\',{async:true});\n    } else {\n        alert(\'Παρακαλώ επιλεξτε πρώτα τους Μαθητές\');    \n    }\n        \n} else {\n    alert(\'Παρακαλώ επιλεξτε «Μορφή Εξαγόμενων Αρχείων»\');       \n}\n\n\n','2015-04-09 09:44:39','globeadmin','2018-05-31 00:44:22','globeadmin','2020-09-24 22:37:35','globeadmin'),('5a76c256dadda27','5a7619b517f7ec0','onkeyup','compute_numb_of_chars();','2018-02-04 10:20:38','globeadmin','2018-02-04 10:31:53','globeadmin','2018-02-04 10:31:54','globeadmin'),('5526201b879ecbf','5526201b78f8d2f','onblur','nuFORM.edited = 0;','2015-04-09 09:45:47','globeadmin','2015-04-09 09:45:47','globeadmin','2018-05-30 22:41:45','globeadmin'),('552620620158b9f','55262061e6d8545','onblur','nuFORM.edited = 0;','2015-04-09 09:46:58','globeadmin','2015-04-09 09:46:58','globeadmin','2015-04-14 14:09:12','globeadmin'),('55262148d5c0dae','55262148c4a9b3a','onclick','\nvar t=get_session_variable(\'teacher_id\');\n\nif  (($.isNumeric(t)) && (t!=-1)) {\n    nuOpenForm(\'\',\'\', \'55261f6b593bdba\', t,\'Καθηγητής\');\n    }\nelse{\n    if(nuIsGA()){\n        nuOpenForm(\'\',\'\', \'55261f6b593bdba\', 26,\'Καθηγητής\');\n        }\n    else{\n        alert(\"Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με καθηγητή!\");\n        }\n    }\n   ','2015-04-09 09:50:48','globeadmin','2015-04-09 09:50:48','globeadmin','2015-12-26 20:24:42','globeadmin'),('5526248a1750be3','5526248a08ac66d','onchange','sumoSetHashSelectedIds(this);\n\n/*var x = document.getElementById(\'form_absence_date\');\nvar y = document.getElementById(\'absence_class\');\nvar class_id = y.options[y.selectedIndex].value;\n\nnuSetHash(\'absence_date\',x.value);\nnuSetHash(\'absence_class_id\',class_id);\n\nnuRunPHP(\'create_absence_class_table\',\'absence_iframe\');*/','2015-04-09 10:04:42','globeadmin','2018-02-03 20:26:33','globeadmin','2018-05-30 22:45:39','globeadmin'),('5526248a21156d2','5526248a08ac66d','onblur','nuFORM.edited = 0;','2015-04-09 10:04:42','globeadmin','2015-04-09 10:04:42','globeadmin','2018-05-30 22:45:39','globeadmin'),('552770f93791f70','552770f92198fc8','onblur','nuFORM.edited = 0;','2015-04-10 09:43:05','globeadmin','2015-04-10 09:43:05','globeadmin','2018-06-01 10:06:54','globeadmin'),('552cf4f2016f350','552cf4f1e6ed0c5','onblur','nuFORM.edited = 0;','2015-04-14 14:07:30','globeadmin','2015-04-14 14:07:30','globeadmin','2018-06-28 21:21:54','globeadmin'),('552cf50a56e1ef4','552cf50a483c12f','onchange','/*var x = document.getElementById(\'form_absence_date\');\nvar y = document.getElementById(\'absence_class\');\nvar class_id = y.options[y.selectedIndex].value;\n\nnuSetHash(\'absence_date\',x.value);\nnuSetHash(\'absence_class_id\',class_id);\n\nnuRunPHP(\'create_absence_class_table\',\'absence_iframe\');*/','2015-04-14 14:07:54','globeadmin','2016-01-24 16:54:33','globeadmin','2018-08-13 00:14:31','globeadmin'),('552cf50a5e3546f','552cf50a483c12f','onblur','nuFORM.edited = 0;','2015-04-14 14:07:54','globeadmin','2015-04-14 14:07:54','globeadmin','2018-08-13 00:14:31','globeadmin'),('552cf54cd847074','552cf54cc9a29c3','onblur','nuFORM.edited = 0;','2015-04-14 14:09:00','globeadmin','2015-04-14 14:09:00','globeadmin','2018-02-25 10:57:22','globeadmin'),('552cf54ce47c0e4','552cf54cc9a29c3','onclick','function isInt(value) {\n  return !isNaN(value) && (function(x) { return (x | 0) === x; })(parseFloat(value))\n}\n\nvar to_date = document.getElementById(\'to_date\').value;\nvar absence_limit = document.getElementById(\'absence_limit\').value;\n\nif(to_date==\'\'){\n    alert (\'Παρακαλώ συμπληρώστε την ημερομηνία Έως...\');\n} else {\n    if (!isInt(absence_limit) || absence_limit<0){\n        alert (\'Παρακαλώ συμπληρώστε έναν θετικό ακεραιο αριθμό ως Όριο Συνόλου Απουσιών...\');\n    } else {\n        var all_class_ids = [];\n        var s = document.getElementById(\'export_class_id\');\n        var selected_class_id = s.options[s.selectedIndex].value;\n        var class_id=selected_class_id;\n        \n        if(selected_class_id==0){\n            for (var i = 1; i < s.options.length; i++) {\n                class_id=s.options[i].value;\n                all_class_ids.push(class_id);\n            }\n        } else {\n            all_class_ids.push(class_id);\n        }\n        \n        if(all_class_ids.length>0){\n            class_id = all_class_ids.join(); \n        } else {\n            class_id = \"\";\n        }\n        \n        nuSetHash(\'class_id\',class_id);\n        \n        if(document.getElementById(\'manager_sign\').checked){\n            nuSetHash(\'m_sign\',\'1\');\n        } else {\n           nuSetHash(\'m_sign\',\'0\'); \n        }\n        \n        if(document.getElementById(\'asistmanager_sign\').checked){\n            nuSetHash(\'a_sign\',\'1\');\n        } else {\n           nuSetHash(\'a_sign\',\'0\'); \n        }\n        \n        if(document.getElementById(\'teacher_sign\').checked){\n            nuSetHash(\'t_sign\',\'1\');\n        } else {\n           nuSetHash(\'t_sign\',\'0\'); \n        }\n        \n        if(document.getElementById(\'exclude_has_left_school\').checked){\n            nuSetHash(\'has_left_school\',\'1\');\n        } else {\n           nuSetHash(\'has_left_school\',\'0\'); \n        }        \n    \n        //alert(\'Λειτουργία υπό κατασκευή...\');\n        \n        var r = document.getElementById(\'note_type\');\n        var nt = r.options[r.selectedIndex].value;\n        \n        switch(nt) {\n            case \'0\':\n                nuPrintPDF(\'absence_totals\',\'search_iframe\');\n                selected_option = nt;\n                break;\n            case \'1\':\n                nuPrintPDF(\'absence_notes_short_new\',\'search_iframe\');\n                selected_option = nt;\n                break;\n            case \'2\':\n                nuPrintPDF(\'absence_notes_short_student\',\'search_iframe\');\n                selected_option = nt;\n                break;\n            case \'3\':\n                nuPrintPDF(\'absence_notes_short_new_ya\',\'search_iframe\');\n                selected_option = nt;\n                break;\n            case \'4\':\n                nuPrintPDF(\'absence_notes_short_student_ya\',\'search_iframe\');\n                selected_option = nt;\n                break;\n            case \'5\':\n                nuRunPHP(\'absence_totals\',\'search_iframe\');\n                selected_option = nt;\n                break;\n            case \'6\':\n                nuRunPHP(\'create_student_absence_email_list\',\'search_iframe\');\n                selected_option = nt;\n                break;\n            case \'7\':\n                nuRunPHP(\'create_student_absence_sms_list\',\'search_iframe\');\n                selected_option = nt;\n                break;    \n            default:\n                alert(\'Λειτουργία υπό Κατασκευή..\')\n        } \n    }\n}','2015-04-14 14:09:00','globeadmin','2018-02-20 20:51:39','globeadmin','2018-02-25 10:57:22','globeadmin'),('552cf57867f93cd','552cf57859531e4','onblur','nuFORM.edited = 0;','2015-04-14 14:09:44','globeadmin','2015-04-14 14:09:44','globeadmin','2018-06-28 20:57:01','globeadmin'),('552cf5b0596aee0','552cf5b04ab5202','onblur','nuFORM.edited = 0;','2015-04-14 14:10:40','globeadmin','2015-04-14 14:10:40','globeadmin','2018-06-28 20:59:59','globeadmin'),('552cf6434d1e32b','552cf6433e77f00','onclick','var t=get_session_variable(\'teacher_id\');\n\nif  (($.isNumeric(t)) && (t!=-1)) {\n    //alert(\'Λειτουργία υπό κατασκευή...\');\n    nuOpenForm(\'\',\'\', \'552cf4b2df9bcce\', t,\'Καθηγητής\');\n    }\nelse{\n    if(nuIsGA()){\n        nuOpenForm(\'\',\'\', \'552cf4b2df9bcce\', 26,\'Καθηγητής\');\n        }\n    else{\n        alert(\"Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με καθηγητή!\");\n        }\n    }\n ','2015-04-14 14:13:07','globeadmin','2015-04-14 16:50:22','globeadmin','2015-12-26 20:44:57','globeadmin'),('552cff5ca776963','552cff5c9660cc1','onblur','nuFORM.edited = 0;','2015-04-14 14:51:56','globeadmin','2015-04-14 14:51:56','globeadmin','2018-08-05 11:21:48','globeadmin'),('552d0e6f8545b6a','552d0e6f742e2fd','onblur','nuFORM.edited = 0;','2015-04-14 15:56:15','globeadmin','2015-04-14 15:56:15','globeadmin','2015-04-14 17:02:03','globeadmin'),('552d0e97212d7db','552d0e971016a76','onblur','nuFORM.edited = 0;','2015-04-14 15:56:55','globeadmin','2015-04-14 15:56:55','globeadmin','2015-04-16 20:58:29','globeadmin'),('552d0eb1c24fb97','552d0eb1b138a56','onblur','nuFORM.edited = 0;','2015-04-14 15:57:21','globeadmin','2015-04-14 15:57:21','globeadmin','2015-04-16 11:00:56','globeadmin'),('552d12d193eb37a','552d12d18064ae6','onblur','nuFORM.edited = 0;','2015-04-14 16:14:57','globeadmin','2015-04-14 16:14:57','globeadmin','2018-08-05 11:18:05','globeadmin'),('552f6ce567cf8f4','552f6ce5592b3f3','onblur','nuFORM.edited = 0;','2015-04-16 11:03:49','globeadmin','2015-04-16 11:03:49','globeadmin','2018-06-28 22:43:47','globeadmin'),('552f76249b14967','552f76248c70278','onchange','/*var x = document.getElementById(\'form_absence_date\');\nvar y = document.getElementById(\'absence_class\');\nvar class_id = y.options[y.selectedIndex].value;\n\nnuSetHash(\'absence_date\',x.value);\nnuSetHash(\'absence_class_id\',class_id);\n\nnuRunPHP(\'create_absence_class_table\',\'absence_iframe\');*/','2015-04-16 11:43:16','globeadmin','2016-01-24 16:55:02','globeadmin','2018-06-28 22:45:29','globeadmin'),('552f7624a74a204','552f76248c70278','onblur','nuFORM.edited = 0;','2015-04-16 11:43:16','globeadmin','2015-04-16 11:43:16','globeadmin','2018-06-28 22:45:29','globeadmin'),('55393f20a94eeeb','55393f209836538','onclick','\nvar t=get_session_variable(\'teacher_id\');\n\nif  (($.isNumeric(t)) && (t!=-1)) {\n    nuOpenForm(\'\',\'\', \'5538ff58cb7b4b8\', t,\'Καθηγητής\');\n    }\nelse{\n    if(nuIsGA()){\n        nuOpenForm(\'\',\'\', \'5538ff58cb7b4b8\', 26,\'Καθηγητής\');\n        }\n    else{\n        alert(\"Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με καθηγητή!\");\n        }\n    }\n   ','2015-04-23 21:51:12','globeadmin','2015-04-23 21:51:12','globeadmin','2015-10-10 17:47:31','globeadmin'),('5539006ab7f3342','5539006a9836616','onblur','nuFORM.edited = 0;','2015-04-23 17:23:38','globeadmin','2015-04-23 17:23:38','globeadmin','2018-11-18 23:11:36','globeadmin'),('5539052b0d0ea3d','5539052af01a423','onclick','var x = document.getElementById(\'form_absence_date\');\nvar absence_date = x.value;\n\nnuSetHash(\'absence_date\',absence_date);\n//alert(nuGetHash(\'absence_date\'));\n\n\nif($(\'#period_count\').val()==\'8\'){\n    nuPrintPDF(\'absence_all_class_day_table8\',\'absence_iframe\');\n} else {\n    nuPrintPDF(\'absence_all_class_day_table\',\'absence_iframe\');   \n}\n\n    \n\n','2015-04-23 17:43:55','globeadmin','2018-11-19 23:32:30','globeadmin','2018-11-19 23:32:31','globeadmin'),('553baa903200d8c','553baa90235aebd','onblur','nuFORM.edited = 0;','2015-04-25 17:54:08','globeadmin','2015-04-25 17:54:08','globeadmin','2015-04-25 18:13:47','globeadmin'),('554c7188ef175b1','54f0ac403b2b132','onmouseover','this.style.cursor=\'pointer\';','2015-05-08 11:19:21','globeadmin','2015-05-08 11:19:21','globeadmin','2015-05-08 11:19:21','globeadmin'),('553e917ac23d4a0','553e917ab37f580','onchange','show_lesson();','2015-04-27 22:43:54','globeadmin','2015-04-29 20:21:00','globeadmin','2016-10-27 22:12:00','globeadmin'),('5548d8d9ebc0327','5548d53a6a578fa','onmouseout','this.style.cursor=\'auto\';','2015-05-05 17:51:05','globeadmin','2018-01-12 00:35:42','globeadmin','2018-01-12 00:35:43','globeadmin'),('553e917acbecc98','553e917ab37f580','onblur','nuFORM.edited = 0;','2015-04-27 22:43:54','globeadmin','2015-04-27 22:43:54','globeadmin','2016-10-27 22:12:00','globeadmin'),('5548d8d9e1f883f','5548d53a6a578fa','onmouseover','this.style.cursor=\'pointer\';','2015-05-05 17:51:05','globeadmin','2015-05-05 17:51:05','globeadmin','2018-01-12 00:35:43','globeadmin'),('553e9221ce5a311','553e9221bfb4673','onchange','show_lesson();\n','2015-04-27 22:46:41','globeadmin','2015-04-29 20:20:47','globeadmin','2016-10-27 22:12:22','globeadmin'),('554c70d62201f6c','54f0ac4033d8282','onmouseover','this.style.cursor=\'pointer\';','2015-05-08 11:16:22','globeadmin','2015-05-08 11:18:37','globeadmin','2015-11-22 22:33:28','globeadmin'),('553e9221d81fbbc','553e9221bfb4673','onblur','nuFORM.edited = 0;','2015-04-27 22:46:41','globeadmin','2015-04-27 22:46:41','globeadmin','2016-10-27 22:12:22','globeadmin'),('5548d53a78fd7d2','5548d53a6a578fa','onclick','var y = document.getElementById(\'absence_class_id\');\n\nif(y.selectedIndex==y.length-1){\n  y.selectedIndex=1;  \n} else {\n  y.selectedIndex=y.selectedIndex+1;  \n}\n\n$(\'#absence_class_id\').trigger( \"onchange\" );','2015-05-05 17:35:38','globeadmin','2016-07-18 00:11:47','globeadmin','2018-01-12 00:35:43','globeadmin'),('5548d53a82c3310','5548d53a6a578fa','onblur','nuFORM.edited = 0;','2015-05-05 17:35:38','globeadmin','2015-05-05 17:35:38','globeadmin','2018-01-12 00:35:43','globeadmin'),('553e92f4aea0c52','553e92f4963377e','onblur','nuFORM.edited = 0;','2015-04-27 22:50:12','globeadmin','2015-04-27 22:50:12','globeadmin','2018-07-13 22:48:23','globeadmin'),('553e8e0a963347b','553e8e0a878ef80','onclick','\nvar t=get_session_variable(\'teacher_id\');\n\nif  (($.isNumeric(t)) && (t!=-1)) {\n    nuOpenForm(\'\',\'\', \'553e8f779634e69\', t,\'Καθηγητής\');\n    }\nelse{\n    if(nuIsGA()){\n        nuOpenForm(\'\',\'\', \'553e8f779634e69\', 26,\'Καθηγητής\');\n        }\n    else{\n        alert(\"Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με καθηγητή!\");\n        }\n    }\n   ','2015-04-27 22:29:14','globeadmin','2015-04-27 22:36:26','globeadmin','2015-12-26 20:48:25','globeadmin'),('5547aa4dddf927d','5547aa4dcf54d25','onblur','nuFORM.edited = 0;','2015-05-04 20:20:13','globeadmin','2015-05-04 20:20:13','globeadmin','2015-10-23 11:28:24','globeadmin'),('553e99689ff7328','553e9968915140f','onclick','var s = document.getElementById(\'student\');\nvar std=s.value;\n\nvar d = document.getElementById(\'absence_date\');\nvar ad=d.value;\n\nvar p = document.getElementById(\'period\');\nvar prd = p.options[p.selectedIndex].value;\n\nvar t = document.getElementById(\'absence_type\');\nvar at = t.options[t.selectedIndex].value;\n\nif(ad==\'\'){\n    alert(\'Παρακαλώ επιλέξτε ημερομηνία..\');\n} else if (prd==0){\n    alert(\'Παρακαλώ επιλέξτε ώρα..\');\n} else if (std==\'\'){\n    alert(\'Παρακαλώ επιλέξτε μαθητή..\');\n} else if (at==0){\n    alert(\'Παρακαλώ επιλέξτε τύπο απουσίας..\');\n} else{\n    nuRunPHP(\'add_student_registered_absence\',\'search_iframe\');\n}\n','2015-04-27 23:17:44','globeadmin','2015-04-29 22:10:26','globeadmin','2016-12-06 13:47:09','globeadmin'),('553e9a54bd5ba4d','553e9a54ae9ef65','onblur','nuFORM.edited = 0;','2015-04-27 23:21:40','globeadmin','2015-04-27 23:21:40','globeadmin','2016-05-12 17:01:06','globeadmin'),('55479c46ddf92d2','55479c46cf54cf0','onblur','nuFORM.edited = 0;','2015-05-04 19:20:22','globeadmin','2015-05-04 19:20:22','globeadmin','2016-01-21 23:09:45','globeadmin'),('554110d754af5c1','554110d7439678a','onchange','/*var x = document.getElementById(\'form_absence_date\');\nvar y = document.getElementById(\'absence_class\');\nvar class_id = y.options[y.selectedIndex].value;\n\nnuSetHash(\'absence_date\',x.value);\nnuSetHash(\'absence_class_id\',class_id);\n\nnuRunPHP(\'create_absence_class_table\',\'absence_iframe\');*/\n','2015-04-29 20:11:51','globeadmin','2015-04-29 20:11:51','globeadmin','2016-10-27 22:13:24','globeadmin'),('554110d75e733ee','554110d7439678a','onblur','nuFORM.edited = 0;','2015-04-29 20:11:51','globeadmin','2015-04-29 20:11:51','globeadmin','2016-10-27 22:13:24','globeadmin'),('554c70d62e36d69','54f0ac4033d8282','onmouseout','this.style.cursor=\'auto\';','2015-05-08 11:16:22','globeadmin','2015-05-08 11:18:37','globeadmin','2015-11-22 22:33:28','globeadmin'),('554c718904b99ac','54f0ac403b2b132','onmouseout','this.style.cursor=\'auto\';','2015-05-08 11:19:21','globeadmin','2015-05-08 11:19:21','globeadmin','2015-05-08 11:19:21','globeadmin'),('554c71b92bc6ae0','54f0ac40427efc9','onmouseover','this.style.cursor=\'pointer\';','2015-05-08 11:20:09','globeadmin','2015-05-08 11:20:09','globeadmin','2015-05-08 11:20:09','globeadmin'),('554c71b9358ddc9','54f0ac40427efc9','onmouseout','this.style.cursor=\'auto\';','2015-05-08 11:20:09','globeadmin','2015-05-08 11:20:09','globeadmin','2015-05-08 11:20:09','globeadmin'),('554c71e0e2e257f','54f0ac4049d1a78','onmouseover','this.style.cursor=\'pointer\';','2015-05-08 11:20:49','globeadmin','2015-05-08 11:20:49','globeadmin','2015-10-04 14:38:06','globeadmin'),('554c71e0f3f7ab7','54f0ac4049d1a78','onmouseout','this.style.cursor=\'auto\';','2015-05-08 11:20:49','globeadmin','2015-05-08 11:20:49','globeadmin','2015-10-04 14:38:06','globeadmin'),('59d88688ea1b666','59d88688d6ac4e5','onclick','nuOpenForm(\'\',\'\', \'54a65ecc3f14737\', \'#nu_user_id#\',\'Στοιχεία Λογαριασμού\');\n','2017-10-07 10:47:20','globeadmin','2017-10-07 10:47:20','globeadmin','2017-10-07 10:47:21','globeadmin'),('556188d001882e6','556188cfe6faff0','onclick','nuSetHash(\'std_id\',\'#RECORD_ID#\');\nnuPrintPDF(\'attendance_student_book\');','2015-05-24 11:16:16','globeadmin','2015-05-26 15:01:32','globeadmin','2018-08-06 22:00:21','globeadmin'),('568835425af331b','56883542476b1e0','onblur','nuFORM.edited = 0;','2016-01-02 22:38:26','globeadmin','2016-01-02 22:38:26','globeadmin','2016-05-25 13:36:05','globeadmin'),('5687a7a420bf320','5687a7a4121ad72','onblur','nuFORM.edited = 0;','2016-01-02 12:34:12','globeadmin','2016-01-02 12:34:12','globeadmin','2016-01-02 15:05:40','globeadmin'),('55618ef16595d08','55618ef156f1878','onclick','nuOpenForm(\'\',\'\', \'5564d8431a9da4b\', \'#RECORD_ID#\',\'Βιβλία Φοίτησης\');\n','2015-05-24 11:42:25','globeadmin','2018-08-13 10:28:31','globeadmin','2018-08-13 10:28:32','globeadmin'),('5564d3e6b6df647','5564d3e6a5c6aa4','onclick','var t=get_session_variable(\'teacher_id\');\n\nif  (($.isNumeric(t)) && (t!=-1)) {\n    //alert(\'Λειτουργία υπό κατασκευή...\');\n    nuOpenForm(\'\',\'\', \'5564d8431a9da4b\', t,\'Καθηγητής\');\n    }\nelse{\n    if(nuIsGA()){\n        nuOpenForm(\'\',\'\', \'5564d8431a9da4b\', 26,\'Καθηγητής\');\n        }\n    else{\n        alert(\"Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με καθηγητή!\");\n        }\n    }\n ','2015-05-26 23:13:26','globeadmin','2015-05-26 23:34:09','globeadmin','2015-12-26 20:30:08','globeadmin'),('5565ed6c43bb097','5565ed6c32a47fa','onclick','var x = document.getElementById(\'student_id\');\nvar ids = sumoGetSelectedIds(x);\n\n\nif(ids){\n    \n    var ids_array = ids.split(\",\");\n    \n    if(ids_array.length==1){\n        nuSetHash(\'std_id\',ids);\n        nuPrintPDF(\'attendance_student_book\',\'search_iframe\'); \n    } else {\n        if(ids_array.length<10 || confirm(\'Θα δημιουργηθούν τα βιβλία φοίτησης για πολλούς μαθητές! Η ενέργεια αυτή ενδέχεται να διαρκέσει αρκετό χρόνο!\\nΘέλετε να συνεχίσετε;\')){\n            nuSetHash(\'std_id\',ids);\n            nuPrintPDF(\'attendance_book\',\'search_iframe\');    \n        }\n    }\n} else {\n    alert(\'Παρακαλώ επιλέξτε πρώτα τους μαθητές...\')    \n}\n    \n\n','2015-05-27 19:14:36','globeadmin','2018-08-13 10:21:14','globeadmin','2018-08-13 10:22:13','globeadmin'),('5565edf35261081','5565edf34148c3b','onclick','var x = document.getElementById(\'class\');\nvar class_id = x.options[x.selectedIndex].value;\n\nif(class_id==\'\'){\n    alert(\'Παρακαλώ επιλέξτε πρώτα το τμήμα...\')\n}\nelse{\n    nuSetHash(\'std_id\',\'\');\n    nuSetHash(\'class_id\',class_id);\n    nuPrintPDF(\'attendance_book\');    \n}','2015-05-27 19:16:51','globeadmin','2018-08-13 10:12:07','globeadmin','2018-08-13 10:20:38','globeadmin'),('55698cf4b602ae0','55698cf498b4c1a','onblur','nuFORM.edited = 0;','2015-05-30 13:12:04','globeadmin','2015-05-30 13:12:04','globeadmin','2017-02-02 11:12:21','globeadmin'),('556f50386b3edb0','556f50385a269d3','onclick','nuPrintPDF(\'students_conpare_full\');','2015-06-03 22:06:32','globeadmin','2015-06-03 22:20:42','globeadmin','2015-06-03 22:20:42','globeadmin'),('55fd506ea4eb509','55fd506e964702e','onclick','var x = document.getElementById(\"id_from\");\nvar id_from = x.options[x.selectedIndex].value;\n\nvar x = document.getElementById(\"id_to\");\nvar id_to = x.options[x.selectedIndex].value;\n\nif (id_from==\'\'){\n    alert(\'Παρακαλώ Επιλέξτε ΑΠΟ Access Level\');\n    }\nelse{\n    if(id_to==\'\'){\n        alert(\'Παρακαλώ Επιλέξτε ΠΡΟΣ Access Level\');\n        }\n    else {\n        nuRunPHP(\'copy_access_level\',\'msgiFrame\');\n        }\n}','2015-09-19 15:09:18','globeadmin','2015-09-19 15:29:36','globeadmin','2016-02-09 20:05:43','globeadmin'),('55fd5283a75c6be','55fd528398b81fe','onclick',';','2015-09-19 15:18:11','globeadmin','2015-09-19 15:18:11','globeadmin','2015-09-19 15:23:27','globeadmin'),('55fdba5a89a520c','55fdb9f2454ac71','onclick','alert(\'Λειτουργία υπό κατασκευή...\');','2015-09-19 22:41:14','globeadmin','2015-09-19 22:41:14','globeadmin','2015-10-10 20:28:24','globeadmin'),('55fdbed7a961d04','55fdbed79abd541','onclick','alert(\'Λειτουργία υπό κατασκευή...\');','2015-09-19 23:00:23','globeadmin','2015-09-19 23:00:23','globeadmin','2015-10-10 20:08:37','globeadmin'),('55fdd002d071eae','55fdd002c1cd83b','onclick','\nvar t=get_session_variable(\'teacher_id\');\n\nif  (($.isNumeric(t)) && (t!=-1)) {\n    nuOpenForm(\'\',\'\', \'548338073921bfe\', t,\'Καθηγητής\');\n    }\nelse{\n    if(nuIsGA()){\n        nuOpenForm(\'\',\'\', \'548338073921bfe\', 26,\'Καθηγητής\');\n        }\n    else{\n        alert(\"Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με καθηγητή!\");\n        }\n    }\n   ','2015-09-20 00:13:38','globeadmin','2015-09-20 00:13:38','globeadmin','2015-10-10 14:27:23','globeadmin'),('56037f624a3335a','554517be190c6df','onclick','nuOpenForm(\'\',\'\', \'554517bdc18334d\', \'\',\'Ποινές\');','2015-09-24 07:43:14','globeadmin','2015-09-24 07:43:14','globeadmin','2015-10-10 19:59:18','globeadmin'),('56037eb1195d72b','54705a95ebf9025','onclick','nuOpenForm(\'\',\'\', \'54705a95c4e91c2\', \'\',\'Άίθουσες Διδασκαλίας\');','2015-09-24 07:40:17','globeadmin','2015-09-24 07:41:21','globeadmin','2015-10-10 19:58:45','globeadmin'),('55ff07b9655c202','54a65fff354d8b8','onclick','nuOpenForm(\'\',\'\', \'54a65ecc3f14737\', \'#nu_user_id#\',\'Στοιχεία Λογαριασμού\');\n','2015-09-20 22:23:37','globeadmin','2017-10-06 23:55:08','globeadmin','2017-10-07 10:47:10','globeadmin'),('56044cb750be0d5','5470c079af3351a','onclick','nuOpenForm(\'\',\'\', \'5470c07906bfd70\', \'1\',\'Στοιχεία Σχολείου\');','2015-09-24 22:19:19','globeadmin','2015-09-24 22:19:19','globeadmin','2015-10-10 20:00:56','globeadmin'),('560457b4951aac2','547372d07c4826f','onclick','nuOpenForm(\'\',\'\', \'547372d029461f4\', \'\',\'Καθηγητές\');','2015-09-24 23:06:12','globeadmin','2015-09-24 23:06:12','globeadmin','2015-10-10 20:00:29','globeadmin'),('56045dfcd494963','5475b35ecd9b059','onclick','nuOpenForm(\'\',\'\', \'5476201e5a3d38f\', \'\',\'Μαθητές\');','2015-09-24 23:33:00','globeadmin','2015-09-24 23:33:00','globeadmin','2015-10-10 19:59:43','globeadmin'),('560462b3cacf586','5470b6d801dc3d2','onclick','nuOpenForm(\'\',\'\', \'5470b6d7c79d3b9\', \'\',\'Τμήματα\');','2015-09-24 23:53:07','globeadmin','2015-09-24 23:55:21','globeadmin','2015-10-10 20:00:06','globeadmin'),('5607b6c3c506044','55254791c1f8883','onclick','nuOpenForm(\'\',\'\', \'5525421c67a48bc\', \'0\',\'Διδασκαλίες για τις οποίες δεν έχουν καταχωρηθεί απουσίες\');','2015-09-27 12:28:35','globeadmin','2015-09-27 12:30:07','globeadmin','2015-10-10 17:39:38','globeadmin'),('56098a9a71c55ec','547489b122b5194','onclick','nuOpenForm(\'\',\'\', \'547489b0d4efe7c\', \'\',\'Μαθήματα\');','2015-09-28 21:44:42','globeadmin','2015-09-28 21:50:38','globeadmin','2015-10-10 20:06:45','globeadmin'),('56098fe3324ccc2','5470b05bb8f75a3','onclick','nuOpenForm(\'\',\'\', \'5470b05b91e73a0\', \'\',\'Τομείς Μαθημάτων\');','2015-09-28 22:07:15','globeadmin','2015-09-28 22:07:15','globeadmin','2015-10-10 20:07:34','globeadmin'),('5609aa9f71c5bbe','54a31362a1b3991','onclick','nuOpenForm(\'\',\'\', \'54a312a5698c8f9\', \'\',\'Υπολοιπόμενη Βαθμολογία\');','2015-09-29 00:01:19','globeadmin','2015-09-29 00:01:19','globeadmin','2015-10-10 20:12:35','globeadmin'),('5609abb44f98c11','54a2694f8c421a9','onclick','nuOpenForm(\'\',\'\', \'54a26a8d05fa91d\', \'0\',\'Εξαγωγή Βαθμολογίας στο Excel\');','2015-09-29 00:05:56','globeadmin','2015-10-09 11:11:36','globeadmin','2015-10-10 20:13:03','globeadmin'),('560a7fcd3067b96','54ce8141c823c30','onclick','nuOpenForm(\'\',\'\', \'54ce7f0188a78ec\', \'\',\'Ειδικότητες - Κατευθύνσεις\');','2015-09-29 15:10:53','globeadmin','2015-09-29 15:13:18','globeadmin','2015-10-10 20:08:07','globeadmin'),('560c27e2158c7be','54a6b0beeae8931','onclick','nuOpenForm(\'\',\'\', \'54df20f94548357\', \'0\',\'Εισαγωγή Ωρολογίου\');','2015-09-30 21:20:18','globeadmin','2015-09-30 21:22:56','globeadmin','2015-10-10 20:21:56','globeadmin'),('560c30e7e782594','5478cb56bab7a08','onclick','nuOpenForm(\'\',\'\', \'54df1259eb4def9\', \'0\',\'Εισαγωγή Μαθητών\');','2015-09-30 21:58:47','globeadmin','2015-09-30 21:58:47','globeadmin','2015-10-10 20:22:21','globeadmin'),('560c33d6be01752','54d65e12698519e','onclick','nuOpenForm(\'\',\'\', \'54d65f0144e61a3\', \'0\',\'Εισαγωγή Ποινών\');','2015-09-30 22:11:18','globeadmin','2015-09-30 22:11:18','globeadmin','2015-10-10 20:23:08','globeadmin'),('560d7a830dd6f74','54a6afe52c7907e','onclick','nuOpenForm(\'\',\'\', \'54df1dbf0f931e5\', \'0\',\'Εισαγωγή Κατανομής Μαθητών\');','2015-10-01 21:25:07','globeadmin','2015-10-01 21:26:22','globeadmin','2015-10-10 20:22:45','globeadmin'),('560d87ab9de060e','548d79dc97cdd70','onclick','nuOpenForm(\'\',\'\', \'nuuser\', \'\',\'Λογαριασμοί Χρηστών\');','2015-10-01 22:21:15','globeadmin','2015-10-01 22:24:53','globeadmin','2015-12-26 21:02:32','globeadmin'),('560ecb40a81248a','54a52d4b5c7875d','onclick','nuOpenForm(\'\',\'\', \'54a52c3dcf3610b\', \'1\',\'Ρυθμίσεις Αποστολής Email\');','2015-10-02 21:21:52','globeadmin','2015-10-02 21:21:52','globeadmin','2015-12-26 21:00:01','globeadmin'),('560fe07885b36d4','54a9a7dcb03e105','onclick','nuOpenForm(\'\',\'\', \'54aa751b6567046\', \'0\',\'Δημιουργία Λογαριασμών Μαθητών\');','2015-10-03 17:04:40','globeadmin','2015-10-03 17:04:40','globeadmin','2015-10-10 20:25:30','globeadmin'),('560feb98993bc1d','54b2d878ef81a4f','onclick','nuOpenForm(\'\',\'\', \'54b2d9dd8417a3d\', \'0\',\'Ορισμός Υπευθύνου Τμήματος\');','2015-10-03 17:52:08','globeadmin','2015-10-03 17:52:08','globeadmin','2015-10-10 20:24:50','globeadmin'),('560ff16ec04cb67','54706cd523c6f19','onclick','nuOpenForm(\'\',\'\', \'54706cd4f34daae\', \'\',\'Ημέρες Διδασκαλίας\');','2015-10-03 18:17:02','globeadmin','2015-10-03 18:17:02','globeadmin','2015-10-10 20:58:47','globeadmin'),('560ff3566115b83','54707442d11dfe1','onclick','nuOpenForm(\'\',\'\', \'54707442a2bcae4\', \'\',\'Διδακτικές Ώρες-Κουδούνια\');','2015-10-03 18:25:10','globeadmin','2015-10-03 18:25:10','globeadmin','2015-10-10 20:01:56','globeadmin'),('560ff5582b5fcf5','54706f6b65b2110','onclick','nuOpenForm(\'\',\'\', \'54706f6b39c1b38\', \'\',\'Τάξεις\');','2015-10-03 18:33:44','globeadmin','2015-10-03 18:33:44','globeadmin','2015-10-10 20:52:04','globeadmin'),('56102f588710db2','5501e21801c55be','onclick','var open_absence_books = 0;\nopen_absence_books = get_session_variable(\'open_absence_books\');\n\nif(open_absence_books==0){\n    nuOpenForm(\'\',\'\', \'5501db35db0c716\', \'#RECORD_ID#\',\'Καταχώριση Aπουσιών στη Τάξη\');\n} else {\n    nuOpenForm(\'\',\'\', \'5787f33aaa172a1\', \'#RECORD_ID#\',\'Καταχώριση Aπουσιών στη Τάξη\');\n}','2015-10-03 22:41:12','globeadmin','2016-07-17 21:47:11','globeadmin','2021-02-26 22:39:07','globeadmin'),('5610312805acd55','55127beea98c3f9','onclick','nuOpenForm(\'\',\'\', \'55127aebdf42446\', \'#RECORD_ID#\',\'Αναζήτηση Απουσιών\');','2015-10-03 22:48:56','globeadmin','2015-10-03 22:48:56','globeadmin','2017-10-07 01:12:55','globeadmin'),('561032d2a1ecd9e','551a37491337e19','onclick','nuOpenForm(\'\',\'\', \'551a34a930825c0\', \'#RECORD_ID#\',\'Αναζήτηση Αιτημάτων Διαγραφής\');','2015-10-03 22:56:02','globeadmin','2018-08-04 12:00:04','globeadmin','2018-08-04 12:00:05','globeadmin'),('561036882568838','552c11af569cdd3','onclick','nuOpenForm(\'\',\'\', \'55261f6b593bdba\', \'#RECORD_ID#\',\'Εξαγωγή Απουσιών στο Excel\');','2015-10-03 23:11:52','globeadmin','2015-10-03 23:11:52','globeadmin','2021-02-26 21:34:51','globeadmin'),('561038289d09b1f','552fb3d1c22647a','onclick','nuOpenForm(\'\',\'\', \'552cf4b2df9bcce\', \'#RECORD_ID#\',\'Επικοινωνία Σχολείου - Γονέων\');','2015-10-03 23:18:48','globeadmin','2016-04-24 08:50:09','globeadmin','2018-07-24 10:08:02','globeadmin'),('56103a9a849f80c','5501320972642a9','onclick','nuOpenForm(\'\',\'\', \'54f735c7d56625f\', \'#RECORD_ID#\',\'Καταχώριση Aπουσιών Hμέρας\');','2015-10-03 23:29:14','globeadmin','2015-10-03 23:29:14','globeadmin','2018-07-24 10:13:26','globeadmin'),('56103c8b1452ed9','5538faf91943f16','onclick','nuOpenForm(\'\',\'\', \'5538ff58cb7b4b8\', \'#RECORD_ID#\',\'Εκτύπωση Απουσιολογίων Ημέρας\');','2015-10-03 23:37:31','globeadmin','2015-10-03 23:37:31','globeadmin','2017-10-07 01:15:36','globeadmin'),('561044d29f7bcec','5495db5b8e961e0','onclick','nuOpenForm(\'\',\'\', \'5495dad1762dc2c\', \'#RECORD_ID#\',\'Εκτύπωση Βαθμολογίας\');','2015-10-04 00:12:50','globeadmin','2015-10-04 00:13:44','globeadmin','2017-10-07 11:22:38','globeadmin'),('5610d37038b71ee','547d6e656ede283','onclick','nuOpenForm(\'\',\'\', \'562362d2ef4f556\', \'#RECORD_ID#\',\'Καταχώριση Βαθμολογίας\');','2015-10-04 10:21:20','globeadmin','2015-10-23 00:11:27','globeadmin','2022-01-08 10:58:26','globeadmin'),('5610ed2f2c7fffa','55181c36cbd6eac','onclick','nuOpenForm(\'\',\'\', \'551821232f9553f\', \'#RECORD_ID#\',\'Αναζήτηση Απουσιών\');','2015-10-04 12:11:11','globeadmin','2015-10-04 12:11:11','globeadmin','2019-11-13 12:58:52','globeadmin'),('56110fe986d5052','56110fe9782f20b','onclick','openStudent(this);','2015-10-04 14:39:21','globeadmin','2015-10-04 14:39:21','globeadmin','2015-10-04 14:50:18','globeadmin'),('56110fe9909a80a','56110fe9782f20b','onmouseover','this.style.cursor=\'pointer\';','2015-10-04 14:39:21','globeadmin','2015-10-04 14:39:21','globeadmin','2015-10-04 14:50:18','globeadmin'),('56110fe99a5e7ba','56110fe9782f20b','onmouseout','this.style.cursor=\'auto\';','2015-10-04 14:39:21','globeadmin','2015-10-04 14:39:21','globeadmin','2015-10-04 14:50:18','globeadmin'),('56116e601b86220','55222ba962f666c','onclick','nuOpenForm(\'\',\'\', \'551821232f9553f\', \'#RECORD_ID#\',\'Αναζήτηση Απουσιών\');','2015-10-04 21:22:24','globeadmin','2015-10-04 21:22:24','globeadmin','2017-11-29 21:53:18','globeadmin'),('561177287f9f630','55222ed5804082a','onclick','nuOpenForm(\'\',\'\', \'55222f79d342b66\', \'#RECORD_ID#\',\'Δικαιολόγηση Απουσιών\');','2015-10-04 21:59:52','globeadmin','2015-10-04 21:59:52','globeadmin','2017-11-29 21:56:30','globeadmin'),('5613dafbec294dc','5613dafbdb10107','onclick','var t=get_session_variable(\'teacher_id\');\n\nif  (($.isNumeric(t)) && (t!=-1)) {\n    nuOpenForm(\'\',\'\', \'5613deecec28ad6\', t,\'Καθηγητής\');\n    }\nelse{\n    if(nuIsGA()){\n        nuOpenForm(\'\',\'\', \'5613deecec28ad6\', 26,\'Καθηγητής\');\n        }\n    else{\n        alert(\"Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με καθηγητή!\");\n        }\n    }\n   ','2015-10-06 17:30:19','globeadmin','2015-10-06 17:48:36','globeadmin','2015-10-10 20:09:33','globeadmin'),('5613dff4b402120','5613dff4a2eab75','onblur','nuFORM.edited = 0;','2015-10-06 17:51:32','globeadmin','2015-10-06 17:51:32','globeadmin','2015-10-07 18:42:02','globeadmin'),('5613e05d2667cec','5613e05d1550b5c','onblur','nuFORM.edited = 0;','2015-10-06 17:53:17','globeadmin','2015-10-06 17:53:17','globeadmin','2017-10-03 00:21:56','globeadmin'),('5613e0c9f379fbf','5613e0c9dff2343','onblur','nuFORM.edited = 0;','2015-10-06 17:55:06','globeadmin','2015-10-06 17:55:06','globeadmin','2018-07-28 11:41:29','globeadmin'),('5613e171d3bd265','5613e171c5172eb','onblur','nuFORM.edited = 0;','2015-10-06 17:57:53','globeadmin','2015-10-06 17:57:53','globeadmin','2018-07-28 11:41:16','globeadmin'),('5613e1ec3ed004f','5613e1ec302a374','onblur','nuFORM.edited = 0;','2015-10-06 17:59:56','globeadmin','2015-10-06 17:59:56','globeadmin','2015-10-08 22:08:39','globeadmin'),('5613e638350c117','5613e63817c02f8','onclick','var x = document.getElementById(\'when_date\');\nvar when_date = x.value;\n\nvar x = document.getElementById(\'from_period_id\');\nvar from_period_id = x.value;\n\nvar x = document.getElementById(\'to_period_id\');\nvar to_period_id = x.value;\n\nvar x = document.getElementById(\'subject_id\');\nvar subject_id = x.value;\n\nvar x = document.getElementById(\'class_id\');\nvar class_id = x.value;\n\nvar x = document.getElementById(\'classroom_id\');\nvar classroom_id = x.value;\n\nvar x = document.getElementById(\'teacher_id\');\nvar teacher_id = x.value;\n\nvar all_class_ids = nuGetHash(\'class_id_sumo\');\n\nif(when_date!=\'\'){\n    if(from_period_id!=\'\'){\n        if(to_period_id!=\'\'){\n            if(subject_id!=\'\'){\n                if(all_class_ids!=\'()\'){\n                    if(classroom_id!=\'\' || subject_id==\'1\'){\n                        if(teacher_id!=\'\' || subject_id==\'1\'){\n                            if(from_period_id<=to_period_id){\n                            \n                                if(confirm(\'Το Ωρολόγιο Πρόγραμμα θα μεταβληθεί!\\nΕίστε Σίγουρος;\')){\n                                    nuAjax(\'celebration\',\'display_ajax_result\');\n                                }\n                                \n                            } else {\n                             alert(\'Παρακαλώ επιλέξτε σωστα τις Ώρες Από και Έως!\');\n                            }\n                        } else {\n                            alert(\'Παρακαλώ επιλέξτε «Επιβλέπων Καθηγητή»!\');\n                        }    \n                    } else {\n                        alert(\'Παρακαλώ επιλέξτε «Αίθουσα»!\');\n                    }     \n                } else {\n                    alert(\'Παρακαλώ επιλέξτε «Τμήμα»!\');\n                }    \n            } else {\n                alert(\'Παρακαλώ επιλέξτε «Δραστηριότητα»!\');\n            }    \n        } else {\n            alert(\'Παρακαλώ επιλέξτε «έως Ώρα»!\');\n        }\n    } else {\n    alert(\'Παρακαλώ επιλέξτε «από Ώρα»!\');\n    }    \n} else {\n    alert(\'Παρακαλώ επιλέξτε «Ημέρα»!\');\n}\n\n','2015-10-06 18:18:16','globeadmin','2017-10-03 00:50:02','globeadmin','2017-10-03 00:50:03','globeadmin'),('5614ca38bacf085','5614ca38ac2ab25','onblur','nuFORM.edited = 0;','2015-10-07 10:31:04','globeadmin','2015-10-07 10:31:04','globeadmin','2015-10-11 19:40:14','globeadmin'),('5615647cf264704','5615647ce3be898','onblur','nuFORM.edited = 0;','2015-10-07 21:29:17','globeadmin','2015-10-07 21:29:17','globeadmin','2015-10-09 21:29:46','globeadmin'),('5618f634cd918e0','5618f634ba09918','onclick','open_teacher_form(\'548338073921bfe\');\n   ','2015-10-10 14:27:48','globeadmin','2017-10-22 18:44:05','globeadmin','2022-11-30 11:52:15','globeadmin'),('5618f8226496716','5618f82255f28b4','onclick','open_teacher_form(\'561922d0a8f28d2\');\n','2015-10-10 14:36:02','globeadmin','2017-10-22 18:45:58','globeadmin','2018-07-23 00:25:45','globeadmin'),('5618f86e70cb871','5618f86e6225d30','onclick','open_teacher_form(\'56192be786c61d7\');\n','2015-10-10 14:37:18','globeadmin','2017-10-22 18:46:55','globeadmin','2018-07-23 00:28:46','globeadmin'),('5618f8a0d76de32','5618f8a0c8afab1','onclick','open_teacher_form(\'571354ed43a4d47\');\n   ','2015-10-10 14:38:08','globeadmin','2017-10-22 18:45:15','globeadmin','2018-07-23 00:31:35','globeadmin'),('5618f8ca33c2778','5618f8ca251e41b','onclick','open_teacher_form(\'56192b05ed5032f\');\n   ','2015-10-10 14:38:50','globeadmin','2017-10-22 18:47:34','globeadmin','2020-10-18 00:03:58','globeadmin'),('561a1a62a7bfcf2','5619532d4c2e45d','onclick','nuOpenForm(\'\',\'\', \'54730f661a9b822\', \'\',\'Λόγοι Απουσίας Μαθητή\');','2015-10-11 11:14:26','globeadmin','2015-10-11 11:14:26','globeadmin','2018-01-09 21:02:30','globeadmin'),('561a1b599436388','5619536d81e43b6','onclick','nuOpenForm(\'\',\'\', \'54707c8612b1b6b\', \'\',\'Λόγοι Δικαιολόγησης Απουσίας\');','2015-10-11 11:18:33','globeadmin','2015-10-11 11:18:33','globeadmin','2018-01-09 21:03:25','globeadmin'),('561a1c671c95428','561953a2deaa494','onclick','nuOpenForm(\'\',\'\', \'5470788787e004a\', \'\',\'Λόγοι Αίτησης Διαγραφής Απουσίας\');','2015-10-11 11:23:03','globeadmin','2018-08-05 12:37:56','globeadmin','2018-08-05 12:37:57','globeadmin'),('5618fc70d755759','5618fc70c8b1419','onclick','open_teacher_form(\'56192a12e86c93e\');\n','2015-10-10 14:54:24','globeadmin','2017-10-22 18:44:38','globeadmin','2018-07-23 00:28:01','globeadmin'),('561923063ff7a57','561923063155c9e','onclick','\nvar t=get_session_variable(\'teacher_id\');\n\nif  (($.isNumeric(t)) && (t!=-1)) {\n    nuOpenForm(\'\',\'\', \'55127aebdf42446\', t,\'Καθηγητής\');\n    }\nelse{\n    if(nuIsGA()){\n        nuOpenForm(\'\',\'\', \'55127aebdf42446\', 26,\'Καθηγητής\');\n        }\n    else{\n        alert(\"Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με καθηγητή!\");\n        }\n    }\n   ','2015-10-10 17:39:02','globeadmin','2015-10-10 17:39:02','globeadmin','2018-07-23 18:26:41','globeadmin'),('5619231ac3cd87c','5619231ab529279','onclick','var t=get_session_variable(\'teacher_id\');\n\nif(($.isNumeric(t)) && (t!=-1)){\n    nuOpenForm(\'\',\'\', \'551a34a930825c0\', t,\'Καθηγητής\');\n} else {\n    if(nuIsGA()){\n        nuOpenForm(\'\',\'\', \'551a34a930825c0\', 26,\'Καθηγητής\');\n    } else{\n        alert(\"Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με καθηγητή!\");\n    }\n}\n   ','2015-10-10 17:39:22','globeadmin','2018-08-04 11:38:57','globeadmin','2018-08-04 11:45:47','globeadmin'),('5619233286c4c03','56192332781e971','onclick','nuOpenForm(\'\',\'\', \'5525421c67a48bc\', \'#RECORD_ID#\',\'Διδασκαλίες για τις οποίες δεν έχουν καταχωρηθεί απουσίες\');','2015-10-10 17:39:46','globeadmin','2016-10-19 19:58:56','globeadmin','2021-02-25 21:07:32','globeadmin'),('561923464268863','5619234633c438a','onclick','\nvar t=get_session_variable(\'teacher_id\');\n\nif  (($.isNumeric(t)) && (t!=-1)) {\n    nuOpenForm(\'\',\'\', \'54f735c7d56625f\', t,\'Καθηγητής\');\n    }\nelse{\n    if(nuIsGA()){\n        nuOpenForm(\'\',\'\', \'54f735c7d56625f\', 26,\'Καθηγητής\');\n        }\n    else{\n        alert(\"Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με καθηγητή!\");\n        }\n    }\n   ','2015-10-10 17:40:06','globeadmin','2015-10-10 17:40:06','globeadmin','2016-11-19 20:01:11','globeadmin'),('5619235b9a4c78f','5619235b8ba83bd','onclick','\nvar t=get_session_variable(\'teacher_id\');\n\nif  (($.isNumeric(t)) && (t!=-1)) {\n    nuOpenForm(\'\',\'\', \'553e8f779634e69\', t,\'Καθηγητής\');\n    }\nelse{\n    if(nuIsGA()){\n        nuOpenForm(\'\',\'\', \'553e8f779634e69\', 26,\'Καθηγητής\');\n        }\n    else{\n        alert(\"Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με καθηγητή!\");\n        }\n    }\n   ','2015-10-10 17:40:27','globeadmin','2015-10-10 17:40:27','globeadmin','2018-07-13 22:58:11','globeadmin'),('5619236dc15c7f3','5619236db2b8200','onclick','\nvar t=get_session_variable(\'teacher_id\');\n\nif  (($.isNumeric(t)) && (t!=-1)) {\n    nuOpenForm(\'\',\'\', \'55261f6b593bdba\', t,\'Καθηγητής\');\n    }\nelse{\n    if(nuIsGA()){\n        nuOpenForm(\'\',\'\', \'55261f6b593bdba\', 26,\'Καθηγητής\');\n        }\n    else{\n        alert(\"Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με καθηγητή!\");\n        }\n    }\n   ','2015-10-10 17:40:45','globeadmin','2015-10-10 17:40:45','globeadmin','2016-11-30 16:59:42','globeadmin'),('56192386c15c73c','56192386b2b8360','onclick','var t=get_session_variable(\'teacher_id\');\n\nif  (($.isNumeric(t)) && (t!=-1)) {\n    //alert(\'Λειτουργία υπό κατασκευή...\');\n    nuOpenForm(\'\',\'\', \'552cf4b2df9bcce\', t,\'Επικοινωνία Σχολείου - Γονέων\');\n    }\nelse{\n    if(nuIsGA()){\n        nuOpenForm(\'\',\'\', \'552cf4b2df9bcce\', 26,\'Επικοινωνία Σχολείου - Γονέων\');\n        }\n    else{\n        alert(\"Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με καθηγητή!\");\n        }\n    }\n ','2015-10-10 17:41:10','globeadmin','2016-04-24 08:52:18','globeadmin','2016-04-24 08:52:43','globeadmin'),('561923a2f2333c1','561923a2e38c1e9','onclick','var t=get_session_variable(\'teacher_id\');\n\nif  (($.isNumeric(t)) && (t!=-1)) {\n    nuOpenForm(\'\',\'\', \'5564d8431a9da4b\', t,\'Καθηγητής\');\n} else{\n    if(nuIsGA()){\n        nuOpenForm(\'\',\'\', \'5564d8431a9da4b\', 26,\'Καθηγητής\');\n    } else{\n        alert(\"Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με καθηγητή!\");\n    }\n}\n ','2015-10-10 17:41:39','globeadmin','2018-08-13 10:29:07','globeadmin','2018-08-13 10:29:07','globeadmin'),('5619251738a49dd','561925172a005a6','onclick','\nvar t=get_session_variable(\'teacher_id\');\n\nif  (($.isNumeric(t)) && (t!=-1)) {\n    nuOpenForm(\'\',\'\', \'5538ff58cb7b4b8\', t,\'Καθηγητής\');\n    }\nelse{\n    if(nuIsGA()){\n        nuOpenForm(\'\',\'\', \'5538ff58cb7b4b8\', 26,\'Καθηγητής\');\n        }\n    else{\n        alert(\"Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με καθηγητή!\");\n        }\n    }\n   ','2015-10-10 17:47:51','globeadmin','2015-10-10 17:47:51','globeadmin','2016-10-27 12:50:36','globeadmin'),('561943d7c8b2c6c','561943d7ba0b35c','onclick','nuOpenForm(\'\',\'\', \'54705a95c4e91c2\', \'\',\'Άίθουσες Διδασκαλίας\');','2015-10-10 19:59:03','globeadmin','2015-10-10 19:59:03','globeadmin','2016-02-04 21:19:16','globeadmin'),('561943f28ba6849','561943f27d028b8','onclick','nuOpenForm(\'\',\'\', \'580cdf151b06780\', \'#RECORD_ID#\',\'Ποινές\');','2015-10-10 19:59:30','globeadmin','2016-10-24 08:44:25','globeadmin','2021-10-24 21:28:14','globeadmin'),('5619440a781e7eb','5619440a697893b','onclick','nuOpenForm(\'\',\'\', \'5476201e5a3d38f\', \'\',\'Μαθητές\');','2015-10-10 19:59:54','globeadmin','2015-10-10 19:59:54','globeadmin','2018-07-23 13:55:38','globeadmin'),('5619442381e28fe','56194423733ecd7','onclick','nuOpenForm(\'\',\'\', \'5470b6d7c79d3b9\', \'\',\'Τμήματα\');','2015-10-10 20:00:19','globeadmin','2015-10-10 20:00:19','globeadmin','2018-07-29 18:19:12','globeadmin'),('56194439add47c7','561944399f2e900','onclick','nuOpenForm(\'\',\'\', \'547372d029461f4\', \'\',\'Καθηγητές\');','2015-10-10 20:00:41','globeadmin','2015-10-10 20:00:41','globeadmin','2018-07-23 13:59:16','globeadmin'),('561944569f2ecb0','56194456908a2b2','onclick','nuOpenForm(\'\',\'\', \'5470c07906bfd70\', \'1\',\'Στοιχεία Σχολείου\');','2015-10-10 20:01:10','globeadmin','2015-10-10 20:01:10','globeadmin','2018-01-09 21:09:31','globeadmin'),('5619446e44d98aa','5619446e36351b5','onclick','nuOpenForm(\'\',\'\', \'547081ceb3d2146\', \'1\',\'Σχολικό Έτος\');','2015-10-10 20:01:34','globeadmin','2015-10-10 20:01:34','globeadmin','2018-01-09 21:08:11','globeadmin'),('56194490e5fb81d','56194490d7559d1','onclick','nuOpenForm(\'\',\'\', \'54707442a2bcae4\', \'\',\'Διδακτικές Ώρες-Κουδούνια\');','2015-10-10 20:02:08','globeadmin','2015-10-10 20:02:08','globeadmin','2018-01-09 21:07:01','globeadmin'),('561945b1510e8a8','561945b1426ae33','onclick','nuOpenForm(\'\',\'\', \'547489b0d4efe7c\', \'\',\'Μαθήματα\');','2015-10-10 20:06:57','globeadmin','2015-10-10 20:06:57','globeadmin','2016-03-13 18:30:20','globeadmin'),('561945e649bb89f','561945e63b179b0','onclick','nuOpenForm(\'\',\'\', \'5470b05b91e73a0\', \'\',\'Τομείς Μαθημάτων\');','2015-10-10 20:07:50','globeadmin','2015-10-10 20:07:50','globeadmin','2015-12-26 22:55:31','globeadmin'),('56194607bc7a77b','56194607add6314','onclick','nuOpenForm(\'\',\'\', \'54ce7f0188a78ec\', \'\',\'Ειδικότητες - Κατευθύνσεις\');','2015-10-10 20:08:23','globeadmin','2015-10-10 20:08:23','globeadmin','2016-03-13 18:00:52','globeadmin'),('56194622474a86c','5619462238a49fe','onclick','//if(\'#nu_user_group#\'==\'globeadmin\'){\n    //nuOpenForm(\'\',\'\', \'561a90ab2457a16\', \'#RECORD_ID#\',\'Ωρολόγια Προγράμματα\');\n    nuOpenForm(\'\',\'\', \'5684e68b302da76\', \'\',\'Ωρολόγια Προγράμματα\');\n    \n//} else {\n//    alert(\'Λειτουργία υπό κατασκευή...\');\n//}\n','2015-10-10 20:08:50','globeadmin','2016-01-03 12:23:25','globeadmin','2017-10-05 22:01:47','globeadmin'),('5619465b3633b53','5619465b278f3fc','onclick','var t=get_session_variable(\'teacher_id\');\n\nif  (($.isNumeric(t)) && (t!=-1)) {\n    nuOpenForm(\'\',\'\', \'5613deecec28ad6\', t,\'Καθηγητής\');\n    }\nelse{\n    if(nuIsGA()){\n        nuOpenForm(\'\',\'\', \'5613deecec28ad6\', 26,\'Καθηγητής\');\n        }\n    else{\n        alert(\"Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με καθηγητή!\");\n        }\n    }\n   ','2015-10-10 20:09:47','globeadmin','2015-10-10 20:09:47','globeadmin','2015-12-26 22:54:05','globeadmin'),('561946ea6e5ac84','561946ea5fb68b5','onclick','nuOpenForm(\'\',\'\', \'547070c91793d3b\', \'\',\'Περίοδοι Αξιολόγησης\');','2015-10-10 20:12:10','globeadmin','2016-06-07 15:04:42','globeadmin','2018-02-01 11:44:32','globeadmin'),('5619471175ad843','561947116709285','onclick','nuOpenForm(\'\',\'\', \'54a312a5698c8f9\', \'#RECORD_ID#\',\'Υπολειπόμενη Βαθμολογία\');','2015-10-10 20:12:49','globeadmin','2016-07-10 15:04:09','globeadmin','2018-02-01 11:44:48','globeadmin'),('5619472bbeeb86a','5619472bb047874','onclick','nuOpenForm(\'\',\'\', \'54a26a8d05fa91d\', \'0\',\'Εξαγωγή Βαθμολογίας στο Excel\');','2015-10-10 20:13:15','globeadmin','2015-10-10 20:13:15','globeadmin','2018-02-01 11:44:53','globeadmin'),('561949407f7199c','5619494070cd322','onclick','nuOpenForm(\'\',\'\', \'54df20f94548357\', \'0\',\'Εισαγωγή Ωρολογίου\');','2015-10-10 20:22:08','globeadmin','2015-10-10 20:22:08','globeadmin','2016-11-30 17:28:58','globeadmin'),('56194959649a0c0','561949595381687','onclick','nuOpenForm(\'\',\'\', \'54df1259eb4def9\', \'#RECORD_ID#\',\'Εισαγωγή Μαθητών\');\n','2015-10-10 20:22:33','globeadmin','2017-09-20 19:06:38','globeadmin','2020-04-02 11:33:59','globeadmin'),('5619496fba09831','5619496fab65252','onclick','nuOpenForm(\'\',\'\', \'54df1dbf0f931e5\', \'0\',\'Εισαγωγή Κατανομής Μαθητών\');','2015-10-10 20:22:55','globeadmin','2015-10-10 20:22:55','globeadmin','2019-11-06 14:12:50','globeadmin'),('561949875ad288c','561949874c2e2ad','onclick','nuOpenForm(\'\',\'\', \'54d65f0144e61a3\', \'#RECORD_ID#\',\'Εισαγωγή Ποινών\');','2015-10-10 20:23:19','globeadmin','2016-11-18 18:21:57','globeadmin','2016-11-18 18:21:57','globeadmin'),('561949f28ba686f','561949f27d02548','onclick','nuOpenForm(\'\',\'\', \'57ece27c6e12afd\', \'0\',\'Ορισμός Υπεύθυνου Καθηγητή\');','2015-10-10 20:25:06','globeadmin','2016-09-29 12:53:30','globeadmin','2022-01-08 14:12:01','globeadmin'),('56194a16167671b','56194a1607d1b2c','onclick','nuOpenForm(\'\',\'\', \'54aa751b6567046\', \'0\',\'Δημιουργία Λογαριασμών Μαθητών\');','2015-10-10 20:25:42','globeadmin','2015-10-10 20:25:42','globeadmin','2020-09-24 22:15:47','globeadmin'),('56194a547f71933','56194a5470cba8e','onclick','nuOpenForm(\'null\',\'null\', \'58d616cfeb60afc\', \'null\',\'Λογαριασμοί Χρηστών\');','2015-10-10 20:26:44','globeadmin','2017-03-29 20:26:33','globeadmin','2017-03-29 20:29:56','globeadmin'),('56194a9967078c6','56194a995861983','onclick','nuOpenForm(\'\',\'\', \'54a52c3dcf3610b\', \'1\',\'Ρυθμίσεις Αποστολής Email\');','2015-10-10 20:27:53','globeadmin','2015-10-10 20:27:53','globeadmin','2016-07-13 20:01:35','globeadmin'),('56194ac5956a8bd','56194ac586c48ed','onclick','nuOpenForm(\'\',\'\', \'562229979f567be\', \'#RECORD_ID#\',\'Διαγραφή Όλων\');','2015-10-10 20:28:37','globeadmin','2015-10-17 14:02:11','globeadmin','2018-01-09 18:54:25','globeadmin'),('561950c4ed4e849','561950c4deaa4e3','onclick','nuOpenForm(\'\',\'\', \'54706f6b39c1b38\', \'\',\'Τάξεις\');','2015-10-10 20:54:12','globeadmin','2015-10-10 20:54:12','globeadmin','2015-12-26 23:03:45','globeadmin'),('561951f30f29d8e','561951f3007f32b','onclick','nuOpenForm(\'\',\'\', \'54706cd4f34daae\', \'\',\'Ημέρες Διδασκαλίας\');','2015-10-10 20:59:15','globeadmin','2015-10-10 20:59:15','globeadmin','2018-01-09 21:07:39','globeadmin'),('561a1eb8a06b8cb','5619525e38a4a8f','onclick','nuOpenForm(\'\',\'\', \'5470802845f7427\', \'\',\'Τύποι Σχολείων\');','2015-10-11 11:32:56','globeadmin','2015-10-11 11:32:56','globeadmin','2020-03-31 21:39:42','globeadmin'),('561a3d583c5391c','561952463d883e3','onclick','nuOpenForm(\'\',\'\', \'54736dab44212c7\', \'\',\'Τύποι Μαθημάτων\');\n','2015-10-11 13:43:36','globeadmin','2015-11-05 20:13:22','globeadmin','2016-03-14 22:48:12','globeadmin'),('561a4858cc5e90a','56195280007f47b','onclick','nuOpenForm(\'\',\'\', \'5470b3806384141\', \'\',\'Ειδικότητες Καθηγητών\');','2015-10-11 14:30:32','globeadmin','2015-10-11 14:30:32','globeadmin','2018-01-09 21:04:13','globeadmin'),('561a9185e7a60bb','561a9185d901d18','onblur','nuFORM.edited = 0;','2015-10-11 19:42:45','globeadmin','2015-10-11 19:42:45','globeadmin','2016-01-02 12:32:05','globeadmin'),('561a9a38c7e90dd','561a9a38b944c12','onblur','nuFORM.edited = 0;','2015-10-11 20:19:52','globeadmin','2015-10-11 20:19:52','globeadmin','2016-01-02 12:32:50','globeadmin'),('561a9a9ebe26d57','561a9a9ead0fd3c','onblur','nuFORM.edited = 0;','2015-10-11 20:21:34','globeadmin','2015-10-11 20:21:34','globeadmin','2016-01-02 12:33:19','globeadmin'),('561a9b5c097af8d','561a9b5beefabb1','onblur','nuFORM.edited = 0;','2015-10-11 20:24:44','globeadmin','2015-10-11 20:24:44','globeadmin','2016-01-02 12:33:57','globeadmin'),('561a9c90ec88193','561a9c90d8fffad','onblur','nuFORM.edited = 0;','2015-10-11 20:29:53','globeadmin','2015-10-11 20:29:53','globeadmin','2016-01-02 12:34:49','globeadmin'),('561a9c9102299af','561a9c90d8fffad','onclick','nuRunPHP(\'search_timetable\',\'showiframe\');','2015-10-11 20:29:53','globeadmin','2015-10-13 23:25:54','globeadmin','2016-01-02 12:34:49','globeadmin'),('561a9d90be26c97','561a9d90ad0e04b','onblur','nuFORM.edited = 0;','2015-10-11 20:34:08','globeadmin','2015-10-11 20:34:08','globeadmin','2016-01-02 12:36:33','globeadmin'),('561aa02c37dde69','561aa02c245614e','onblur','nuFORM.edited = 0;','2015-10-11 20:45:16','globeadmin','2015-10-11 20:45:16','globeadmin','2016-01-02 12:36:53','globeadmin'),('561eb40ad41fb0f','561eb40ac097bd6','onclick','var t=get_session_variable(\'teacher_id\');\n\nif  (($.isNumeric(t)) && (t!=-1)) {\n    nuOpenForm(\'\',\'\', \'5613deecec28ad6\', t,\'Καθηγητής\');\n    }\nelse{\n    if(nuIsGA()){\n        nuOpenForm(\'\',\'\', \'5613deecec28ad6\', 26,\'Καθηγητής\');\n        }\n    else{\n        alert(\"Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με καθηγητή!\");\n        }\n    }\n   ','2015-10-14 22:59:06','globeadmin','2015-10-14 22:59:06','globeadmin','2015-12-26 22:54:37','globeadmin'),('561eb456b1f3796','561eb456a0dabf9','onclick','nuOpenForm(\'\',\'\', \'54df20f94548357\', \'0\',\'Εισαγωγή Ωρολογίου\');','2015-10-14 23:00:22','globeadmin','2015-10-14 23:00:22','globeadmin','2015-12-26 22:49:35','globeadmin'),('561eb5985a0f426','561eb59848f6c5f','onclick','nuOpenFormInFrame(\'5621401c573dfb8\',\'-1\');','2015-10-14 23:05:44','globeadmin','2015-10-16 21:30:26','globeadmin','2016-01-03 11:03:40','globeadmin'),('562238f6bca2c57','562238f6adfe192','onclick','if(confirm(\'Η ενέργεια αυτή θα ΔΙΑΓΡΑΨΕΙ ΟΛΑ ΤΑ ΔΕΔΟΜΕΝΑ στη βάση δεδομένων!\\nΕίστε Σίγουρος;\')){\n    if(confirm(\'Είστε Πραγματικά Σίγουρος;\')){\n        nuRunPHP(\'delete_all\' , \'deleteifame\');\n    }\n}','2015-10-17 15:03:02','globeadmin','2015-10-17 17:58:28','globeadmin','2015-10-17 17:58:28','globeadmin'),('561eb6aa811db2a','561eb6aa6b2502e','onclick','nuOpenFormInFrame(\'562003aa49d836a\',\'#RECORD_ID#\');','2015-10-14 23:10:18','globeadmin','2015-10-15 22:54:47','globeadmin','2016-01-02 22:40:23','globeadmin'),('561eb7777c3d5c6','561eb7776b24b6f','onclick','nuOpenFormInFrame(\'561fe384a42ad55\',\'#RECORD_ID#\');\n','2015-10-14 23:13:43','globeadmin','2015-10-15 22:54:07','globeadmin','2015-12-26 23:01:34','globeadmin'),('561fe6bac658b55','561fe6bab7b4792','onclick','var s = document.getElementById(\'timetable_date\');\nvar timetable_date=s.options[s.selectedIndex].value;\n\nif(timetable_date==\'\'){\n    alert(\'Παρακαλώ επιλέξτε ημερομηνία έναρξης ισχύος ωρολογίου\');\n} else {\n    if(confirm(\'Το ωρολόγιο θα διαγραφεί οριστικά! Είστε σίγουρος;\')){\n        nuAjax(\'remove_timetable\',\'dsplayAjaxMessage\');\n    }\n}\n','2015-10-15 20:47:38','globeadmin','2015-10-15 21:54:59','globeadmin','2016-01-02 22:31:45','globeadmin'),('561fe464316bf67','561fe46422c5de5','onblur','nuFORM.edited = 0;','2015-10-15 20:37:40','globeadmin','2015-10-15 20:37:40','globeadmin','2015-10-15 22:51:26','globeadmin'),('562004d32f130bf','562004d32056818','onclick','var s = document.getElementById(\'timetable_date\');\nvar timetable_date=s.options[s.selectedIndex].value;\n\nvar s = document.getElementById(\'new_timetable_date\');\nvar new_timetable_date=s.value;\n\nif(timetable_date==\'\'){\n    alert(\'Παρακαλώ επιλέξτε ημερομηνία έναρξης ισχύος του ωρολογίου που θα αντιγραφεί...\');\n} else if(new_timetable_date==\'\'){\n    alert(\'Παρακαλώ επιλέξτε ημερομηνία έναρξης ισχύος του νέου ωρολογίου που θα δημιουργηθεί...\');\n} else {\n    if(confirm(\'Το ωρολόγιο θα αντιγραφεί στη νέα ημερομηνία! Είστε σίγουρος;\')){\n        nuAjax(\'copy_timetable\',\'dsplayAjaxMessage\');\n    }\n}\n','2015-10-15 22:56:03','globeadmin','2015-10-15 23:37:05','globeadmin','2016-01-02 22:38:40','globeadmin'),('562003e6c8c9b6a','562003e6ba23e31','onblur','nuFORM.edited = 0;','2015-10-15 22:52:06','globeadmin','2015-10-15 22:52:06','globeadmin','2015-10-15 23:07:35','globeadmin'),('562006f3a1b9bc5','562006f39315883','onblur','nuFORM.edited = 0;','2015-10-15 23:05:07','globeadmin','2015-10-15 23:05:07','globeadmin','2016-01-02 22:38:03','globeadmin'),('562239755d6bb89','562239754ec7106','onclick',';','2015-10-17 15:05:09','globeadmin','2015-10-17 15:05:09','globeadmin','2016-07-12 00:34:34','globeadmin'),('562364003f87434','5623640030e1450','onchange','var x = document.getElementById(\'class_subject_selection\');\nvar class_subject_id = x.options[x.selectedIndex].value;\n\nvar pos = class_subject_id.search(\',\');\nvar id1= class_subject_id.substr(0, pos);\nvar id2= class_subject_id.substring(pos+1, class_subject_id.length);\n\nif(markEdited){\n    markEdited =  false;\n    nuFORM.edited = \'0\';\n    $(\'#savebtn\').removeClass(\'nuNotSaved\');\n    $(\'#savebtn\').addClass(\'nuButton\');\n}\n\nnuSetHash(\'class_id\',id1);\nnuSetHash(\'subject_id\',id2);\n\nnuRunPHP(\'create_mark_table\' , \'marks_iframe\');\n//$(\'#marks_iframe\').focus();\n//load iframe','2015-10-18 12:18:56','globeadmin','2022-02-08 23:51:59','globeadmin','2022-02-08 23:51:59','globeadmin'),('56236cac976b48f','56236cac88c6d92','onclick','var x = document.getElementById(\'class_subject_selection\');\nvar class_subject_id = x.options[x.selectedIndex].value;\n\nvar pos = class_subject_id.search(\',\');\nvar c= class_subject_id.substr(0, pos);\nvar s= class_subject_id.substring(pos+1, class_subject_id.length);\n\nvar y = document.getElementById(\'grading_period_iddsp\');\nvar g = y.value;\n\n//var c=get_session_variable(\'class_id\');\n//var s=get_session_variable(\'subject_id\');\n\n//alert(g);\nif(g!=\'\'){\n    if(c!=\'\'){\n        set_session_variable(\'mark_print_grading_period_id\',g);\n        set_session_variable(\'mark_print_class_id\',c);\n        set_session_variable(\'mark_print_subject_id\',s);\n\n        nuPrintPDF(\'marks_print\');\n    } else {\n        alert(\'Παρακαλώ επιλέξτε πρώτα τμήμα-μάθημα!\');\n    \n    }\n} else {\n    alert(\'Δεν υπάρχει ενεργή βαθμολογική περίοδος!\');    \n}\n','2015-10-18 12:55:56','globeadmin','2015-10-25 11:46:53','globeadmin','2016-01-21 18:51:16','globeadmin'),('56236c5b8da7354','56236c5b7f02e84','onclick','var iframe = document.getElementById(\'marks_iframe\');\nvar innerDoc = (iframe.contentDocument) ? iframe.contentDocument : iframe.contentWindow.document;\nvar a = innerDoc.getElementsByClassName(\'value_text\');\n\n/*var y = document.getElementById(\'period_absence_class\');\nvar class_id = y.options[y.selectedIndex].value;*/\n\nif (a.length>0){\n    \n        var json_str = \'[\';\n        \n        for(i=0;i<a.length;i++){\n    \n            if(!validateInputText(a[i],innerDoc)) {a[i].focus();return;}\n            \n            var id      = a[i].id;\n            var value   = a[i].value;\n            var v=parseFloat(value.replace(\',\',\'.\'));\n            \n            json_str=json_str+\'{\"id\":\"\'+id+\'\", \"value\":\"\'+(isNaN(v) ? \'NULL\' : v.toString())+\'\"},\';\n\n        }\n        \n        if(json_str.slice(-1)==\',\'){\n            json_str = json_str.slice(0,-1);  \n        }\n        json_str = json_str+\']\';\n    \n        nuSetHash(\'json_mark\',json_str);\n        //nuAjax(\'update_marks\',\'foo\');// Καταχώριση Βαθμολογίας\n        nuRunPHP(\'update_marks\' , \'marks_iframe\'); // Επαναφόρτωση Βαθμολογίκής Κατάστασης\n}else {\n    alert(\'Δεν υπάρχουν στοιχεία προς καταχώριση...\');\n}','2015-10-18 12:54:35','globeadmin','2015-10-24 20:14:19','globeadmin','2018-07-14 23:30:06','globeadmin'),('562e7732bba9d0d','562e7732ad03b7c','onchange','var x = document.getElementById(\'grading_period_id\');\nvar grading_period_id = x.options[x.selectedIndex].value;\nnuAjax(\'pass_teachers_lessons_new\',\'refresh_lessons\');','2015-10-26 20:55:46','globeadmin','2015-10-26 21:17:33','globeadmin','2022-01-22 10:45:46','globeadmin'),('562e7732c56f3cc','562e7732ad03b7c','onblur','nuFORM.edited = 0;','2015-10-26 20:55:46','globeadmin','2015-10-26 20:55:46','globeadmin','2022-01-22 10:45:46','globeadmin'),('562e7784a33fc96','562e7784949b643','onchange','var x = document.getElementById(\"class_subject_selection\");\nvar class_subject_id = x.options[x.selectedIndex].value;\n\nvar pos = class_subject_id.search(\",\");\nvar class_id= class_subject_id.substr(0, pos);\nvar subject_id= class_subject_id.substring(pos+1, class_subject_id.length);\n\nnuSetHash(\'class_id\',class_id);\nnuSetHash(\'subject_id\',subject_id);\n\nnuRunPHP(\'show_marks_teacher\' , \'marks_showiframe\');','2015-10-26 20:57:08','globeadmin','2015-10-27 19:47:32','globeadmin','2022-01-22 10:44:33','globeadmin'),('562e7784af74d3c','562e7784949b643','onblur','nuFORM.edited = 0;','2015-10-26 20:57:08','globeadmin','2015-10-26 20:57:08','globeadmin','2022-01-22 10:44:33','globeadmin'),('562fc524b54d947','562fc524a6a798a','onclick','nuOpenForm(\'\',\'\', \'562e770b79c0722\', \'#RECORD_ID#\',\'Εμφάνιση Βαθμολογίας\');','2015-10-27 20:40:36','globeadmin','2015-10-27 20:42:32','globeadmin','2022-01-08 11:00:04','globeadmin'),('56312e7a4d2f7fc','56312e7a3e8b9f3','onchange','nuAjax(\'pass_mark_class\',\'pollute_class\');\n$(\'#subject_id\').empty();','2015-10-28 22:22:18','globeadmin','2015-10-28 23:01:02','globeadmin','2020-04-02 19:41:12','globeadmin'),('5631391b4c9469e','5631391b3dede85','onclick','nuOpenForm(\'\',\'\', \'56312e4782e78b4\', \'#RECORD_ID#\',\'Εμφάνιση Βαθμολογίας\');','2015-10-28 23:07:39','globeadmin','2015-10-28 23:07:39','globeadmin','2018-02-04 11:46:41','globeadmin'),('56312e936a89ab5','56312e9356f5236','onchange','nuRunPHP(\'show_marks_teacher\' , \'marks_showiframe\');','2015-10-28 22:22:43','globeadmin','2015-10-28 22:45:37','globeadmin','2020-04-02 14:43:19','globeadmin'),('5688359d4288e9c','5688359d33e4cb9','onclick','var s = document.getElementById(\'new_timetable_date\');\nvar new_timetable_date=s.value;\n\nif(new_timetable_date==\'\'){\n    alert(\'Παρακαλώ επιλέξτε ημερομηνία έναρξης ισχύος του νέου ωρολογίου που θα δημιουργηθεί...\');\n} else {\n    if(confirm(\'Το ωρολόγιο θα αντιγραφεί στη νέα ημερομηνία! Είστε σίγουρος;\')){\n        nuAjax(\'copy_timetable_new\',\'dsplayAjaxMessage\');\n    }\n}\n','2016-01-02 22:39:57','globeadmin','2016-01-02 22:39:57','globeadmin','2016-05-25 13:38:10','globeadmin'),('5687a761b33b2dc','5687a761a496f47','onblur','nuFORM.edited = 0;','2016-01-02 12:33:05','globeadmin','2016-01-02 12:33:05','globeadmin','2016-10-08 20:16:03','globeadmin'),('5687a78262aacd1','5687a7825405d70','onblur','nuFORM.edited = 0;','2016-01-02 12:33:38','globeadmin','2016-01-02 12:33:38','globeadmin','2016-10-08 20:16:13','globeadmin'),('565b3306bf81deb','5619474570cd719','onclick','nuOpenForm(\'\',\'\', \'565b05b5e424081\', \'#RECORD_ID#\',\'Εκτύπωση Βαθμολογίας\');','2015-11-29 19:16:54','globeadmin','2015-11-29 19:20:08','globeadmin','2018-02-01 11:44:57','globeadmin'),('5631318427f4cf3','56313184195078a','onchange','nuAjax(\'pass_mark_subject\',\'pollute_subject\');','2015-10-28 22:35:16','globeadmin','2015-10-28 22:57:56','globeadmin','2016-03-13 14:39:50','globeadmin'),('565b05de9ae2c19','565b05de8c3cd99','onchange','nuAjax(\'pass_mark_class\',\'pollute_class\');\n$(\'#subject_id\').empty();','2015-11-29 16:04:14','globeadmin','2015-11-29 16:04:14','globeadmin','2016-07-24 16:19:18','globeadmin'),('565b06089601591','565b0608875aeb3','onchange','nuAjax(\'pass_mark_subject\',\'pollute_subject\');','2015-11-29 16:04:56','globeadmin','2015-11-29 16:04:56','globeadmin','2015-11-29 18:11:30','globeadmin'),('565b21c305f5ce7','565b21c2eb75730','onclick','var x = document.getElementById(\'grading_period_id\');\nvar grading_period_id = x.value;\n\nvar y = document.getElementById(\'class_id\');\nvar class_id = y.value;\n\nvar z = document.getElementById(\'subject_id\');\nvar subject_id = z.value;\n\nif(grading_period_id==\'\'){\n    alert(\'Παρακαλώ επιλέξτε βαθμολογική περίοδο...\');\n} else{\n    if(class_id!=\'\' && subject_id!=\'\'){\n        set_session_variable(\'mark_print_grading_period_id\',grading_period_id);\n        set_session_variable(\'mark_print_class_id\',class_id);\n        set_session_variable(\'mark_print_subject_id\',subject_id);\n        nuPrintPDF(\'marks_print\',\'marks_showiframe\');    \n    } else {\n        nuPrintPDF(\'marks_print_manager\',\'marks_showiframe\'); \n    }\n     \n}\n\n\n        ','2015-11-29 18:03:15','globeadmin','2015-11-29 19:10:45','globeadmin','2018-02-04 11:35:12','globeadmin'),('5687a7d820bf46f','5687a7d8121acbe','onblur','nuFORM.edited = 0;','2016-01-02 12:35:04','globeadmin','2016-01-02 12:35:04','globeadmin','2018-07-13 19:58:58','globeadmin'),('5687a7d82cf43e8','5687a7d8121acbe','onclick','nuRunPHP(\'search_timetable_new\',\'showiframe\');','2016-01-02 12:35:04','globeadmin','2016-01-02 13:10:21','globeadmin','2018-07-13 19:58:58','globeadmin'),('5687a8268c2b30b','5687a8267d86edb','onblur','nuFORM.edited = 0;','2016-01-02 12:36:22','globeadmin','2016-01-02 12:36:22','globeadmin','2018-07-13 19:59:25','globeadmin'),('5688e44fed14a9f','5688e44fde6ecb6','onclick','nuOpenFormInFrame(\'5688ee0218ad763\',\'-1\');','2016-01-03 11:05:19','globeadmin','2016-01-03 11:52:07','globeadmin','2016-05-22 21:42:02','globeadmin'),('56b7450f53606bd','56b7450f44b0b6f','onclick','nuOpenFormInFrame(\'58d616cfeb60afc\', $(\'#user_id\').val());','2016-02-07 15:22:23','globeadmin','2018-07-29 10:37:52','globeadmin','2018-07-29 10:37:53','globeadmin'),('56b7462997b1087','56b74629890cb6e','onclick','if(confirm(\'Αυτόματη δημιουργία λογαριασμού;\')){\n    nuAjax(\'create_teacher_account\',\'show_ajax_result\');\n    nuReloadForm();\n} else {\n    nuOpenForm(\'\',\'\', \'nuuser\', \'-1\',\'Λογαριασμοί Χρηστών\');    \n}\n','2016-02-07 15:27:05','globeadmin','2016-04-27 13:34:10','globeadmin','2017-11-29 21:37:29','globeadmin'),('56b74c1ad4ba59f','56b74c1ac615b00','onclick','nuOpenFormInFrame(\'547081ceb3d2146\', \'1\');','2016-02-07 15:52:26','globeadmin','2016-02-07 15:57:08','globeadmin','2016-03-10 13:12:37','globeadmin'),('56b74e6e9c972c2','56b74e6e8b7dca5','onclick','nuOpenFormInFrame(\'547070c91793d3b\', \'#grading_period_id#\');','2016-02-07 16:02:22','globeadmin','2016-02-07 16:02:22','globeadmin','2016-02-07 16:04:49','globeadmin'),('56c9961eea9efea','56c989026456b54','onchange','if(document.getElementById(\'is_number\').checked){\n   $(\'[id*=start_value]\').show();\n   $(\'[id*=end_value]\').show();\n   $(\'[id*=num_of_decimals]\').show();\n   $(\'[id*=mark_type_value_subform]\').hide();\n} else {\n   $(\'[id*=start_value]\').hide();\n   $(\'[id*=end_value]\').hide();\n   $(\'[id*=num_of_decimals]\').hide();\n   $(\'[id*=mark_type_value_subform]\').show();\n};\n\n\n\n','2016-02-21 12:49:02','globeadmin','2016-02-21 15:08:32','globeadmin','2017-08-20 15:47:13','globeadmin'),('52e87d7b7cf0424','52e87d7b7100d14','onchange','var width = $(\'#fw_form_width\').val();\nwidth = (width > 300) ? 300 : width;\n$(\'#fw_form_width\').val(width);\n\n$(\'#fw_form_listbox option:selected\').each(function() {\n    $(this).attr(\'nu_ed_width\', width);\n});','2014-01-29 15:03:07','globeadmin','2014-02-11 09:51:02','globeadmin','2014-02-11 09:51:02','globeadmin'),('56e553ef34fcd31','56e553ef1c94d43','onchange','nuRunPHP(\'myfoo\' , \'teaching_showiframe\');\nnuAjax(\'find_class_subjects_json\',\'pollute_subject_json\');','2016-03-13 13:50:07','globeadmin','2016-03-14 09:50:14','globeadmin','2016-03-14 09:50:14','globeadmin'),('56e55403a54c208','56e5540394353fe','onchange','var c = document.getElementById(\'class_id\');\nvar selected_class_id = c.options[c.selectedIndex].value;\n\nvar s = document.getElementById(\'subject_id\');\nvar selected_subject_id = s.options[s.selectedIndex].value;\n\nset_session_variable(\'class_id\',selected_class_id);\nset_session_variable(\'subject_id\',selected_subject_id);  \n\nnuRunPHP(\'create_teaching_book\' , \'teaching_showiframe\');','2016-03-13 13:50:27','globeadmin','2016-03-13 14:58:36','globeadmin','2016-03-13 15:14:14','globeadmin'),('56e596021495520','56e5960205f007f','onclick','nuOpenForm(\'\',\'\', \'56e553b8d3afa56\', \'#RECORD_ID#\',\'Ημερολόγιο Διδασκαλιών\');','2016-03-13 18:32:02','globeadmin','2016-03-13 18:45:58','globeadmin','2018-07-23 10:07:35','globeadmin'),('552dcd64bb1a94e','552dcd64ad5bf49','onclick','nuFastFormBrowseView();','2015-04-15 12:01:00','globeadmin','2015-04-15 12:02:39','globeadmin','2015-04-15 12:02:39','globeadmin'),('52e1f5be868c8d0','52e1d677888a8c8','onclick','selectAll(\'fw_table_listbox\');','2014-01-24 16:10:22','globeadmin','2014-01-24 16:11:12','globeadmin','2014-02-06 09:45:56','globeadmin'),('52ef266d89d8a8a','52ef2592bc39a21','onclick','var selected = $(\'#sfw_form_listbox option:selected\');\n\nif( selected.length === 1 && selected.is(\':not(:last-child)\') ) {\n    var after = selected[0].index + 1;\n    selected.insertAfter($(\'#sfw_form_listbox option:eq(\'+after+\')\'));\n}','2014-02-03 16:17:33','globeadmin','2014-02-03 16:17:33','globeadmin','2014-02-11 10:21:31','globeadmin'),('52e99b8b3de6ea3','52e1cd8771f75fd','onkeyup','if(event.which === 46 ) {\n    $(\'option:selected\', $(this)).remove();\n    $(this).change();\n}','2014-01-30 11:23:39','globeadmin','2014-01-30 11:23:39','globeadmin','2014-02-06 15:28:40','globeadmin'),('52e6f55b15d8c85','52e6f4bf935ab8d','onclick','$(\'#sfw_form_listbox option:selected\').each(function() {\n    $(this).remove()\n});\n$(\'#sfw_form_title\').val(\'\');\n$(\'#sfw_form_width\').val(\'\');\n$(\'#sfw_form_lookup\').val(\'\');\n$(\'#sfw_form_lookup\').change();','2014-01-28 11:10:03','globeadmin','2014-02-11 13:09:20','globeadmin','2014-02-11 13:09:21','globeadmin'),('542b88536e600a8','14580c12e28024','ondblclick','nuOpenAce(\"PHP\", this.id, \"After Delete\");','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('552dd635973ae30','552dd5e743157ed','onclick','alert(\'Coming Soon!\');','2015-04-15 12:38:37','globeadmin','2015-04-15 12:38:37','globeadmin','2015-04-15 12:38:37','globeadmin'),('542b88536ed92bc','1455245046bab3','ondblclick','nuOpenAce(\"PHP\", this.id, \"Lookup PHP\");','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('52ef264fc68ea31','52ef2584e7b33c3','onclick','var selected = $(\'#sfw_form_listbox option:selected\');\n\nif(selected.length === 1  && selected.is(\':not(:first-child)\') ) {\n    var before = selected[0].index - 1;\n    selected.insertBefore($(\'#sfw_form_listbox option:eq(\'+before+\')\'));\n}','2014-02-03 16:17:03','globeadmin','2014-02-03 16:17:03','globeadmin','2014-02-11 10:21:16','globeadmin'),('542b885370b728c','51db33e43a91032','ondblclick','nuOpenAce(\"HTML\", this.id, \"Header\");','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('56ef01dd86444b3','56ef01dd6dda665','onclick','nuPrintPDF(\'penalty\');','2016-03-20 22:02:37','globeadmin','2016-03-20 22:06:09','globeadmin','2019-02-05 22:41:29','globeadmin'),('56f1835c1d8c757','56f1835c0ecfc1c','onchange','var x = document.getElementById(\'class_subject_selection\');\nvar class_subject_id = x.options[x.selectedIndex].value;\n\nvar pos = class_subject_id.search(\',\');\nvar class_id= class_subject_id.substr(0, pos);\nvar subject_id= class_subject_id.substring(pos+1, class_subject_id.length);\n\nset_session_variable(\'class_id\',class_id);\nset_session_variable(\'subject_id\',subject_id);\n\nnuRunPHP(\'create_teaching_book\' , \'registered_cards_iframe\');\n','2016-03-22 19:39:40','globeadmin','2016-03-22 19:58:53','globeadmin','2022-09-23 00:41:18','globeadmin'),('56f18d5c13b03a9','56f18d5c050b964','onchange','var x = document.getElementById(\'class_subject_selection\');\nvar class_subject_id = x.options[x.selectedIndex].value;\n\nvar pos = class_subject_id.search(\',\');\nvar class_id= class_subject_id.substr(0, pos);\nvar subject_id= class_subject_id.substring(pos+1, class_subject_id.length);\n\nset_session_variable(\'class_id\',class_id);\nset_session_variable(\'subject_id\',subject_id);\n\nnuRunPHP(\'create_comments_book\' , \'comments_iframe\');\n','2016-03-22 20:22:20','globeadmin','2016-03-22 20:22:20','globeadmin','2022-01-31 10:13:55','globeadmin'),('57090a358c7eedc','57090a3576860aa','onclick','window.open(\'http://www.easysms.gr\', \'_blank\');','2016-04-09 16:57:09','globeadmin','2016-04-09 17:22:58','globeadmin','2019-07-27 23:25:34','globeadmin'),('570a1db91c42329','570a1db90d86343','onclick','var mobile_number = prompt(\'Παρακαλώ εισάγετε τον αριθμό τηλεφώνου : \',\'\');    \n        \nif (mobile_number != null) {\n    if(mobile_number.trim() != \'\'){\n        \n        nuSetHash(\'mobile_number\',mobile_number);\n        nuRunPHP(\'send_test_sms\');\n    } else {\n        alert(\'Ο αριθμός τηλεφώνου απαιτείται!\');            \n    }\n} else {\n        alert(\'Ο αριθμός τηλεφώνου απαιτείται!\');       \n}\n','2016-04-10 12:32:41','globeadmin','2016-04-12 22:51:07','globeadmin','2016-04-14 09:33:36','globeadmin'),('571baf09a002a1e','571baf099145e78','onclick','nuRunPHP(\'create_teacher_sms_list\',\'search_iframe\');','2016-04-23 20:21:13','globeadmin','2016-04-23 20:42:56','globeadmin','2016-04-23 20:42:56','globeadmin'),('570c9baf78f78b9','570a05de3704db2','onchange','nuAjax(\'find_sms_gateway_details\',\'pollute_sms_details\');\nnuRunPHP(\'sms_get_balance\',\'sms_balance_disp\');','2016-04-12 09:54:39','globeadmin','2016-04-12 10:32:45','globeadmin','2019-07-27 23:14:05','globeadmin'),('571baea2e9284c4','571baea2da82420','onkeyup','$(\'#num_of_chars_left\').val($(\'#max_num_of_chars\').val()-this.value.length);','2016-04-23 20:19:30','globeadmin','2016-04-23 20:19:30','globeadmin','2016-07-10 22:09:24','globeadmin'),('571baec69145871','571baec6802d9b9','onblur','nuFORM.edited = 0;','2016-04-23 20:20:06','globeadmin','2016-04-23 20:20:06','globeadmin','2018-08-04 10:14:55','globeadmin'),('571baee7591d3cc','571baee74a78fde','onblur','nuFORM.edited = 0;','2016-04-23 20:20:39','globeadmin','2016-04-23 20:20:39','globeadmin','2017-03-18 16:24:27','globeadmin'),('570fef69a7620c3','570fef6998a535c','onclick','open_sms_frame($(\'#phone1\').val());\n','2016-04-14 22:28:41','globeadmin','2016-04-16 16:16:28','globeadmin','2018-08-06 22:08:24','globeadmin'),('570ff778851bbdb','570ff77876760cf','onclick','open_sms_frame($(\'#phone2\').val());','2016-04-14 23:03:04','globeadmin','2016-04-16 16:17:16','globeadmin','2018-08-06 22:04:40','globeadmin'),('570ff79cda8f6d3','570ff79cc979f95','onclick','open_sms_frame($(\'#mobile\').val());','2016-04-14 23:03:40','globeadmin','2016-04-16 16:17:52','globeadmin','2018-08-06 22:07:53','globeadmin'),('570ff8ed4812a2f','570ff8ed36fe241','onclick','open_sms_frame($(\'#parent_phone1\').val());','2016-04-14 23:09:17','globeadmin','2016-04-16 16:18:33','globeadmin','2018-08-06 22:04:17','globeadmin'),('570ff94f62ee19e','570ff94f5447bcb','onclick','open_sms_frame($(\'#parent_phone2\').val());','2016-04-14 23:10:55','globeadmin','2016-04-16 16:19:15','globeadmin','2018-08-06 22:06:36','globeadmin'),('570ff961bad1a75','570ff961ac2d540','onclick','open_sms_frame($(\'#parent_phone3\').val());','2016-04-14 23:11:13','globeadmin','2016-04-16 16:19:46','globeadmin','2018-08-06 22:08:39','globeadmin'),('571a7a4b0b11218','571a7a4af0787b3','onblur','nuFORM.edited = 0;','2016-04-22 22:23:55','globeadmin','2016-04-22 22:23:55','globeadmin','2021-03-09 15:15:22','globeadmin'),('571a7ab93e564ee','571a7ab92f999b5','onblur','nuFORM.edited = 0;','2016-04-22 22:25:45','globeadmin','2016-04-22 22:25:45','globeadmin','2021-03-09 16:01:46','globeadmin'),('571a7b74e923d47','571a7b74da801e1','onclick','nuRunPHP(\'create_student_sms_list\',\'search_iframe\');','2016-04-22 22:28:52','globeadmin','2016-04-22 22:30:46','globeadmin','2021-03-09 16:01:08','globeadmin'),('571207401383f9c','5711eb0e4457b16','onkeyup','$(\'#num_of_chars_left\').val($(\'#max_num_of_chars\').val()-this.value.length);','2016-04-16 12:34:56','globeadmin','2016-04-16 12:39:09','globeadmin','2018-01-06 10:15:46','globeadmin'),('5719d606e92b269','5719d606da86bce','onblur','nuFORM.edited = 0;','2016-04-22 10:43:02','globeadmin','2016-04-22 10:43:02','globeadmin','2018-07-01 00:49:05','globeadmin'),('5713e65aa5e2ac5','5713e65a94ca415','onblur','nuFORM.edited = 0;','2016-04-17 22:39:06','globeadmin','2016-04-17 22:39:06','globeadmin','2016-07-07 23:34:58','globeadmin'),('5713dfd2ccf1e1e','5713dfd2bbdbb76','onblur','nuFORM.edited = 0;','2016-04-17 22:11:14','globeadmin','2016-04-17 22:11:14','globeadmin','2016-07-07 23:30:43','globeadmin'),('5713e01c6b494be','5713e01c57c137f','onblur','nuFORM.edited = 0;','2016-04-17 22:12:28','globeadmin','2016-04-17 22:12:28','globeadmin','2016-07-07 23:33:40','globeadmin'),('5713e066a1009ec','5713e0668fea02a','onblur','nuFORM.edited = 0;','2016-04-17 22:13:42','globeadmin','2016-04-17 22:13:42','globeadmin','2018-07-13 09:42:31','globeadmin'),('5713e0817ed33bf','5713e0816dba8b3','onclick','nuRunPHP(\'search_sms\',\'search_iframe\');','2016-04-17 22:14:09','globeadmin','2016-04-21 09:45:46','globeadmin','2019-07-27 13:10:37','globeadmin'),('571baf426553e53','571baf42543cc5f','onblur','nuFORM.edited = 0;','2016-04-23 20:22:10','globeadmin','2016-04-23 20:22:10','globeadmin','2018-07-01 00:50:11','globeadmin'),('571bcdb0a9af8b7','571bcdb098975dd','onclick','nuOpenForm(\'\',\'\', \'5713df2963f613a\', \'#RECORD_ID#\',\'Καθηγητής\');\n \n   ','2016-04-23 22:32:00','globeadmin','2016-04-23 22:49:05','globeadmin','2016-11-19 20:00:47','globeadmin'),('571b2cc68b74628','571b2cc6709a7ec','onkeyup','$(\'#num_of_chars_left\').val($(\'#max_num_of_chars\').val()-this.value.length);','2016-04-23 11:05:26','globeadmin','2016-04-23 11:38:23','globeadmin','2018-02-04 10:14:19','globeadmin'),('57123745a5ffc83','571237459006b15','onclick','open_sms_frame($(\'#phone1\').val());','2016-04-16 15:59:49','globeadmin','2016-04-16 16:23:54','globeadmin','2021-01-26 20:14:52','globeadmin'),('5713df6bb217b89','5713df6ba100abe','onblur','nuFORM.edited = 0;','2016-04-17 22:09:31','globeadmin','2016-04-17 22:09:31','globeadmin','2016-07-07 23:31:53','globeadmin'),('5713e3a4862598a','5713e3a4750d245','onblur','nuFORM.edited = 0;','2016-04-17 22:27:32','globeadmin','2016-04-17 22:27:32','globeadmin','2016-07-20 19:55:12','globeadmin'),('5713dfb4136695c','5713dfb4024fe89','onblur','nuFORM.edited = 0;','2016-04-17 22:10:44','globeadmin','2016-04-17 22:10:44','globeadmin','2016-07-30 19:07:10','globeadmin'),('571237a9d944e33','571237a9c34bd78','onclick','open_sms_frame($(\'#mobile\').val());','2016-04-16 16:01:29','globeadmin','2016-04-16 16:24:28','globeadmin','2016-10-08 10:51:35','globeadmin'),('571e6e2dcfc7fe3','571e6e2dbeafe20','onclick','nuOpenForm(\'\',\'\', \'54a65ecc3f14737\', \'#nu_user_id#\',\'Στοιχεία Λογαριασμού\');\n','2016-04-25 22:21:17','globeadmin','2016-12-01 15:53:38','globeadmin','2018-07-25 14:03:29','globeadmin'),('5713df4ef1904ec','5713df4ede0827d','onblur','nuFORM.edited = 0;','2016-04-17 22:09:03','globeadmin','2016-04-17 22:09:03','globeadmin','2016-07-07 23:30:02','globeadmin'),('571237ed6b6819b','571237ed556ef4e','onclick','open_sms_frame($(\'#phone2\').val());','2016-04-16 16:02:37','globeadmin','2016-04-16 16:25:10','globeadmin','2016-10-08 10:51:53','globeadmin'),('57134f66d890405','57134f66c509d61','onclick','open_teacher_form(\'56192c691b58858\');','2016-04-17 11:55:02','globeadmin','2017-10-22 18:48:58','globeadmin','2018-07-23 00:32:29','globeadmin'),('571bce0c7dbc31d','571bce0c6f17fda','onclick','nuOpenForm(\'\',\'\', \'5719cb61e92d4e8\', \'#RECORD_ID#\',\'Καθηγητής\');\n \n   ','2016-04-23 22:33:32','globeadmin','2016-04-23 22:50:27','globeadmin','2018-03-10 19:11:17','globeadmin'),('571bce1c3496969','571bce1c25d9f1d','onclick','nuOpenForm(\'\',\'\', \'571bae293e43d23\', \'#RECORD_ID#\',\'Καθηγητής\');\n \n   ','2016-04-23 22:33:48','globeadmin','2016-04-23 22:51:32','globeadmin','2018-03-10 19:08:27','globeadmin'),('571bce2b9b20c22','571bce2b8c63d04','onclick','nuOpenForm(\'\',\'\', \'572af54adfe5517\', \'#RECORD_ID#\',\'Καθηγητής\');\n\n \n   ','2016-04-23 22:34:03','globeadmin','2016-05-05 19:56:57','globeadmin','2018-03-10 19:10:35','globeadmin'),('571bce3ce45d151','571bce3cd5a1e48','onclick','nuOpenForm(\'\',\'\', \'572b615e795d4d1\', \'#RECORD_ID#\',\'Καθηγητής\'); \n','2016-04-23 22:34:20','globeadmin','2016-05-05 19:56:27','globeadmin','2018-03-10 19:09:23','globeadmin'),('571e77f37300abc','571e77f3645c4c1','onclick','nuAjax(\'create_parent_account\',\'show_ajax_result\');\nnuReloadForm();','2016-04-25 23:02:59','globeadmin','2016-04-27 13:35:16','globeadmin','2017-11-29 21:48:24','globeadmin'),('5793c8b5077e579','5793c8b4ecfc583','onclick','if(confirm(\'Θα δημιουργηθεί και θα λάβετε ένα αντίγραφο της βάσης δεδομένων του συστήματος σας!\\nΕίστε σίγουρος;\')){\n    showLoader();\n    nuAjax(\'backup_db_file\',\'get_backup_file\',{async:true});\n}','2016-07-23 22:42:45','globeadmin','2018-01-09 19:04:49','globeadmin','2018-01-09 19:04:50','globeadmin'),('5a551628eccb8db','5a551628ca9c56d','onchange','sumoSetHashSelectedIds(this);','2018-01-09 21:21:13','globeadmin','2018-01-09 21:21:13','globeadmin','2018-01-09 21:27:26','globeadmin'),('571face187dc3b2','571face1745391f','onclick','nuOpenFormInFrame(\'58d616cfeb60afc\', $(\'#parent_user_id\').val());','2016-04-26 21:01:05','globeadmin','2018-07-29 22:17:10','globeadmin','2018-07-29 22:17:11','globeadmin'),('571fb9404ad2acf','571fb940374aa1f','onclick','if($(\'#birth_date\').val()!=\'\'){\n    if(confirm(\'Θέλετε να χρησιμοποιηθεί η «Ημερομηνία Γέννησης» ως κωδικός;\')){\n        nuSetHash(\'use_birthdate_as_pass\', \'1\');\n    } else {\n        nuSetHash(\'use_birthdate_as_pass\', \'0\');\n    } \n} else {\n    nuSetHash(\'use_birthdate_as_pass\', \'0\');\n}\n\nnuAjax(\'create_student_account\',\'show_ajax_result\');\nnuReloadForm();\n','2016-04-26 21:53:52','globeadmin','2016-04-27 13:35:49','globeadmin','2018-07-29 22:16:27','globeadmin'),('571fb969aa0a423','571fb96998f29ff','onclick','nuOpenFormInFrame(\'58d616cfeb60afc\', $(\'#user_id\').val());','2016-04-26 21:54:33','globeadmin','2018-07-29 22:18:11','globeadmin','2018-08-06 22:00:11','globeadmin'),('5720b2ff54ae5c2','5720b2ff439779e','onclick','sisApprove(\'Θα πραγματοποιηθεί επαναφορά του κωδικού πρόσβασης!\\nΕίστε σίγουρος;\',\'Ερώτηση\',\'resetPassword\');\n','2016-04-27 15:39:27','globeadmin','2016-07-09 14:20:49','globeadmin','2018-07-29 10:36:48','globeadmin'),('57829db1d4681b1','57829db1c5c40e1','onblur','nuFORM.edited = 0;','2016-07-10 22:10:41','globeadmin','2016-07-10 22:10:41','globeadmin','2020-10-17 23:12:13','globeadmin'),('5721031eb28800c','5721031ea17170b','onclick','sisApprove (\'Θα πραγματοποιηθεί επαναφορά του κωδικού πρόσβασης του Μαθητή!\\nΕίστε σίγουρος;\',\'Ερώτηση\',\'resetPassword\',$(\'#user_id\').val());\n','2016-04-27 21:21:18','globeadmin','2016-07-09 14:30:46','globeadmin','2018-07-29 22:17:42','globeadmin'),('5787f3cc8cc950a','5787f3cc76d1d05','onchange','nuRunPHP(\'create_absence_period_table_open\',\'period_absence_iframe\');\n','2016-07-14 23:19:24','globeadmin','2021-04-04 14:11:37','globeadmin','2022-09-24 22:50:52','globeadmin'),('5721043697ac212','572104368905f9d','onclick','sisApprove (\'Θα πραγματοποιηθεί επαναφορά του κωδικού πρόσβασης του Γονέα!\\nΕίστε σίγουρος;\',\'Ερώτηση\',\'resetPassword\',$(\'#parent_user_id\').val());\n','2016-04-27 21:25:58','globeadmin','2016-07-09 14:31:22','globeadmin','2018-08-06 21:58:18','globeadmin'),('572af74ec50bf82','572af74eb3f35c7','onblur','nuFORM.edited = 0;','2016-05-05 10:33:34','globeadmin','2016-05-05 10:33:34','globeadmin','2021-03-09 15:15:55','globeadmin'),('572af77bcedcd39','572af77bbb47fc5','onblur','nuFORM.edited = 0;','2016-05-05 10:34:19','globeadmin','2016-05-05 10:34:19','globeadmin','2021-03-09 15:16:16','globeadmin'),('572af7a76d2731a','572af7a7572d5fe','onclick','nuRunPHP(\'create_student_email_list\',\'search_iframe\');','2016-05-05 10:35:03','globeadmin','2016-05-05 11:36:56','globeadmin','2020-06-19 12:52:30','globeadmin'),('572af7e1db05076','572af7e1c9ede05','onblur','nuFORM.edited = 0;','2016-05-05 10:36:01','globeadmin','2016-05-05 10:36:01','globeadmin','2017-11-04 20:15:18','globeadmin'),('572b66586364229','572b6658524cfec','onblur','nuFORM.edited = 0;','2016-05-05 18:27:20','globeadmin','2016-05-05 18:27:20','globeadmin','2018-08-04 10:15:41','globeadmin'),('572b6735a54e6f4','572b673591c5484','onclick','nuRunPHP(\'create_teacher_email_list\',\'search_iframe\');\n//nuRunPHP(\'create_teacher_own_mark_email_list\',\'search_iframe\');\n','2016-05-05 18:31:01','globeadmin','2016-07-09 23:19:03','globeadmin','2018-12-04 22:36:20','globeadmin'),('572b680abb464f6','572b680aa54ee69','onblur','nuFORM.edited = 0;','2016-05-05 18:34:34','globeadmin','2016-05-05 18:34:34','globeadmin','2018-07-01 00:16:26','globeadmin'),('57348bec237561b','57348bec0b0ba77','onchange','show_lesson();','2016-05-12 16:58:04','globeadmin','2016-05-12 16:58:04','globeadmin','2016-05-12 17:57:36','globeadmin'),('57348bec2fa8fc6','57348bec0b0ba77','onblur','nuFORM.edited = 0;','2016-05-12 16:58:04','globeadmin','2016-05-12 16:58:04','globeadmin','2016-05-12 17:57:36','globeadmin'),('57348c260febe66','57348c25dcffd9b','onblur','nuFORM.edited = 0;','2016-05-12 16:59:02','globeadmin','2016-05-12 16:59:02','globeadmin','2016-05-12 17:30:48','globeadmin'),('57348cbfd836bc2','57348cbfc9799ee','onblur','nuFORM.edited = 0;','2016-05-12 17:01:35','globeadmin','2016-05-12 17:01:35','globeadmin','2016-05-12 17:22:37','globeadmin'),('5738afd8880f58f','5738afd876f6f98','onblur','nuFORM.edited = 0;','2016-05-15 20:20:24','globeadmin','2016-05-15 20:20:24','globeadmin','2018-08-05 00:15:52','globeadmin'),('5738bff5acad233','5738bff596b6181','onblur','nuFORM.edited = 0;','2016-05-15 21:29:09','globeadmin','2016-05-15 21:29:09','globeadmin','2018-08-04 21:07:59','globeadmin'),('57418b28ed18063','57418b28de5b6fa','onclick','//if(nuIsGA()){\n    nuOpenForm(\'\',\'\', \'57400922b87c65a\', \'\',\'Γενικά Κριτήρια Αξιολόγησης\');\n//} else {\n//    alert(\'Λειτουργία υπό κατασκευή!\');\n//}','2016-05-22 13:34:16','globeadmin','2016-05-22 15:20:38','globeadmin','2016-05-25 09:05:20','globeadmin'),('5741a1f10046f31','5741a1f0e5ac8ae','onclick','nuOpenForm(\'\',\'\', \'57400922b87c65a\', \'\',\'Γενικά Κριτήρια Αξιολόγησης\');\n','2016-05-22 15:11:29','globeadmin','2016-07-11 12:26:04','globeadmin','2022-01-08 10:57:39','globeadmin'),('5783c0f7d82b69e','5783c0f7c9871d8','onclick','open_email_frame($(\'#email\').val());','2016-07-11 18:53:27','globeadmin','2016-07-11 18:53:27','globeadmin','2021-04-04 21:18:13','globeadmin'),('574580726dfdbca','574580725f5967b','onblur','nuFORM.edited = 0;','2016-05-25 13:37:38','globeadmin','2016-05-25 13:37:38','globeadmin','2016-05-31 11:59:08','globeadmin'),('574580c346f16f1','574580c338496dc','onclick','var s = document.getElementById(\'new_critirion_general_id\');\nvar new_critirion_general_id=s.value;\n\nif(new_critirion_general_id==\'\'){\n    alert(\'Παρακαλώ επιλέξτε πρώτα το «Γενικό Κριτήριο» στο οποίο θα προσαρτηθεί ο κλώνος...\');\n} else {\n    if(confirm(\'Το «Ειδικό Κριτήριο» θα κλωνοποιηθεί! Είστε σίγουρος;\')){\n        nuAjax(\'clone_special_critirion_ajax\',\'dsplayAjaxMessage\');\n    }\n}\n','2016-05-25 13:38:59','globeadmin','2016-05-25 14:53:54','globeadmin','2016-05-25 14:53:55','globeadmin'),('5756bc6cd55a4e8','5756bc6cc69ddba','onclick','if(nuIsGA()){\n    nuOpenForm(\'\',\'\', \'5762f95837d99ee\', \'26\',\'Αποστολή Αξιολόγησης με Email\');\n} else {\n    alert(\'Λειτουργία υπό κατασκευή...\');    \n}\n\n','2016-06-07 15:22:04','globeadmin','2016-06-16 22:15:46','globeadmin','2021-10-24 21:17:52','globeadmin'),('5762f9cc7ea7036','5762f9cc6d8e1b3','onblur','nuFORM.edited = 0;','2016-06-16 22:11:08','globeadmin','2016-06-16 22:11:08','globeadmin','2016-06-16 22:19:55','globeadmin'),('5762f9e979c3110','5762f9e9663cb10','onblur','nuFORM.edited = 0;','2016-06-16 22:11:37','globeadmin','2016-06-16 22:11:37','globeadmin','2016-06-16 22:11:37','globeadmin'),('5762fa09e7a04da','5762fa09d4182c2','onclick','var g = document.getElementById(\'grading_period\');\nvar grading_period_id = g.options[g.selectedIndex].value;\n\nif(grading_period_id==\'\'){\n    alert(\'Παρακαλώ επιλέξτε Περίοδο Αξιολόγησης...\');\n} else{\n    nuRunPHP(\'create_student_mark_email_list\',\'search_iframe\');\n}\n\n','2016-06-16 22:12:09','globeadmin','2016-06-16 23:28:59','globeadmin','2016-07-24 15:55:39','globeadmin'),('5762fa3e63cba77','5762fa3e52b4b70','onblur','nuFORM.edited = 0;','2016-06-16 22:13:02','globeadmin','2016-06-16 22:13:02','globeadmin','2016-06-16 22:13:02','globeadmin'),('5762fc257000baa','5762fc255ee9bb8','onblur','nuFORM.edited = 0;','2016-06-16 22:21:09','globeadmin','2016-06-16 22:21:09','globeadmin','2016-06-16 23:27:27','globeadmin'),('5762fd8a74e4bda','5762fd8a63ca5df','onblur','nuFORM.edited = 0;','2016-06-16 22:27:06','globeadmin','2016-06-16 22:27:06','globeadmin','2016-06-16 23:32:16','globeadmin'),('57829d7786611ee','57829d7777a3dc8','onkeyup','$(\'#num_of_chars_left\').val($(\'#max_num_of_chars\').val()-this.value.length);','2016-07-10 22:09:43','globeadmin','2016-07-10 22:09:43','globeadmin','2020-10-17 23:10:59','globeadmin'),('5787f650682bd85','5787f6505714fb4','onchange','nuAjax(\'find_teacher_period\',\'pollute_period\');','2016-07-14 23:30:08','globeadmin','2016-07-16 18:53:02','globeadmin','2021-04-04 12:31:04','globeadmin'),('577eb378438d65c','577eb3783277e99','onclick','nuOpenForm(\'\',\'\', \'577ebb808309312\', \'#RECORD_ID#\',\'Καθηγητής\');\n \n   ','2016-07-07 22:54:32','globeadmin','2016-07-07 23:36:45','globeadmin','2016-11-30 16:52:04','globeadmin'),('57822f67bfc95c2','57822f67b10b0f0','onblur','nuFORM.edited = 0;','2016-07-10 14:20:07','globeadmin','2016-07-10 14:20:07','globeadmin','2020-10-18 01:02:32','globeadmin'),('577ebbde9b71b2f','577ebbde87e962c','onblur','nuFORM.edited = 0;','2016-07-07 23:30:22','globeadmin','2016-07-07 23:30:22','globeadmin','2016-07-07 23:30:23','globeadmin'),('577ebc0676d6296','577ebc0665bd0fb','onblur','nuFORM.edited = 0;','2016-07-07 23:31:02','globeadmin','2016-07-07 23:31:02','globeadmin','2020-09-23 10:30:30','globeadmin'),('577ebc2b104a290','577ebc2af35713b','onblur','nuFORM.edited = 0;','2016-07-07 23:31:39','globeadmin','2016-07-07 23:31:39','globeadmin','2017-11-25 15:56:59','globeadmin'),('577ebc47dfcd2b1','577ebc47cc46eaa','onblur','nuFORM.edited = 0;','2016-07-07 23:32:07','globeadmin','2016-07-07 23:32:07','globeadmin','2016-07-07 23:32:08','globeadmin'),('577ebc63daebbdb','577ebc63c7636be','onblur','nuFORM.edited = 0;','2016-07-07 23:32:35','globeadmin','2016-07-07 23:32:35','globeadmin','2016-07-21 01:06:34','globeadmin'),('577ebc82e724119','577ebc82d60b568','onclick','nuRunPHP(\'search_email\',\'search_iframe\');','2016-07-07 23:33:06','globeadmin','2016-07-08 00:03:01','globeadmin','2017-10-03 15:34:02','globeadmin'),('577ebcb4438dd8e','577ebcb43006fef','onblur','nuFORM.edited = 0;','2016-07-07 23:33:56','globeadmin','2016-07-07 23:33:56','globeadmin','2016-07-07 23:33:56','globeadmin'),('577ebce47e25bf2','577ebce46a9efad','onblur','nuFORM.edited = 0;','2016-07-07 23:34:44','globeadmin','2016-07-07 23:34:44','globeadmin','2018-07-13 09:32:03','globeadmin'),('577ebd023ead39d','577ebd022d95fa8','onblur','nuFORM.edited = 0;','2016-07-07 23:35:14','globeadmin','2016-07-07 23:35:14','globeadmin','2016-07-07 23:39:03','globeadmin'),('5787f3cc990426e','5787f3cc76d1d05','onblur','nuFORM.edited = 0;','2016-07-14 23:19:24','globeadmin','2016-07-14 23:19:24','globeadmin','2022-09-24 22:50:52','globeadmin'),('5787f401dd5a45d','5787f401c762df8','onclick','var iframe = document.getElementById(\'period_absence_iframe\');\nvar innerDoc = (iframe.contentDocument) ? iframe.contentDocument : iframe.contentWindow.document;\n\nvar a = innerDoc.getElementsByClassName(\'absence\');\n\nif (a.length>0){\n    \n        var ids = \'\';\n        \n        for(i=0;i<a.length;i++){\n    \n            res = a[i].id.split(\'_\');\n        \n            absence_reason_id=parseInt(res[2]);\n        \n            if(absence_reason_id!=0){\n                if (ids == \'\'){\n                    ids =  a[i].id;\n                } else {\n                    ids = ids+\';\'+a[i].id;\n                }\n            }\n        }\n    \n        if (ids != \'\'){\n            nuSetHash(\'absence_id_list\',ids);\n            nuAjax(\'add_period_absences\',\'foo\');        // Καταχώριση Απουσίών\n                                                        // Η Δήλωση Καταχώρισης Απουσίών πραγματοποιείται από το add_period_absences\n            //nuAjax(\'register_period_cards\',\'foo\');    // Δήλωση Καταχώρισης Απουσίών\n        } else {\n            nuAjax(\'register_period_cards\',\'foo\');      // Δήλωση Καταχώρισης Απουσίών\n        }\n    \n        if(ajaxSucced){\n            nuRunPHP(\'create_absence_period_table_open\',\'period_absence_iframe\'); // Επαναφόρτωση Απουσιολογίου\n            ajaxSucced = false;\n        } else {\n            alert(\'Παρουσιάστηκε πρόβλημα κατά τη καταχώριση των απουσιών!\\nΠαρακαλώ ξαναπροσπαθήστε αργότερα!\');    \n        }\n} else {\n    alert(\'Δεν υπάρχουν στοιχεία προς καταχώριση...\');\n}\n','2016-07-14 23:20:17','globeadmin','2016-07-17 00:48:01','globeadmin','2021-04-05 21:32:32','globeadmin'),('578bcc846e351c6','578bca583d62e19','onchange','if(document.getElementById(\'open_absence_books\').checked){\n   nuDisable(\'set_absence_time_limit\',\'00:00:00\');\n} else {\n   nuEnable(\'set_absence_time_limit\',\'00:00:00\');\n}','2016-07-17 21:20:52','globeadmin','2016-07-17 21:21:27','globeadmin','2019-07-02 22:24:55','globeadmin'),('578f9b47bd45818','578f9b47ae8938c','onclick','nuOpenFormInFrame(\'578e9b35d4d3cf8\', \'#RECORD_ID#\');\n//nuOpenForm(\'\',\'\', \'572b615e795d4d1\', \'#RECORD_ID#\',\'Καθηγητής\'); \n','2016-07-20 18:39:51','globeadmin','2016-07-20 19:04:44','globeadmin','2017-10-06 23:44:57','globeadmin'),('5787f65071ee9d0','5787f6505714fb4','onblur','nuFORM.edited = 0;','2016-07-14 23:30:08','globeadmin','2016-07-14 23:30:08','globeadmin','2021-04-04 12:31:04','globeadmin'),('5787f6f07942cc5','5787f6f0682a496','onchange','nuAjax(\'find_teacher_class\',\'pollute_class\');\n','2016-07-14 23:32:48','globeadmin','2016-07-15 15:27:38','globeadmin','2022-01-08 15:40:11','globeadmin'),('5787f6f08306d73','5787f6f0682a496','onblur','nuFORM.edited = 0;','2016-07-14 23:32:48','globeadmin','2016-07-14 23:32:48','globeadmin','2022-01-08 15:40:11','globeadmin'),('57daceeb5222678','54aaac5d169a703','onmouseover','this.style.cursor=\'pointer\';','2016-09-15 19:40:11','globeadmin','2016-09-15 19:40:11','globeadmin','2017-10-15 13:05:18','globeadmin'),('57daceeb5be69c7','54aaac5d169a703','onmouseout','this.style.cursor=\'auto\';','2016-09-15 19:40:11','globeadmin','2016-09-15 19:40:11','globeadmin','2017-10-15 13:05:18','globeadmin'),('57e17565c9f6179','57e17565b40149f','onclick','if(confirm(\'Θα δημιουργηθούν και θα αντιστοιχηθούν λογαριασμοί γονέων!\\nΗ ενέργεια αυτή δεν μπορεί να αναιρεθεί!\\n\\nΕίστε σίγουρος;\')){\n    alert(\'Προσοχή : Οι κωδικοί πρόσβασης των νέων λογαριασμών θα εμφανιστούν εδώ για μία και μοναδική φορά.\\nΣτη βάση δεδομένων αποθηκεύονται κρυπτογραφημένοι. Παρακαλώ αποθηκεύστε τους για μελλοντική χρήση!\');\n    nuRunPHP(\'create_parent_mass_accounts\',\'create_account_iframe\');    \n}\n','2016-09-20 20:44:05','globeadmin','2016-09-23 08:26:25','globeadmin','2021-09-07 19:51:46','globeadmin'),('57e43569273d36d','57e4262a2d28251','onchange','nuRunPHP(\'count_parent_accounts\',\'display1\');','2016-09-22 22:47:53','globeadmin','2016-09-22 22:47:53','globeadmin','2016-09-24 18:34:14','globeadmin'),('57e6dd5202fde5d','57e6dd51e139150','onblur','nuFORM.edited = 0;','2016-09-24 23:08:50','globeadmin','2016-09-24 23:08:50','globeadmin','2016-09-24 23:20:54','globeadmin'),('57e6bdf6326f052','57e6bdf61c82107','onblur','nuFORM.edited = 0;','2016-09-24 20:55:02','globeadmin','2016-09-24 20:55:02','globeadmin','2016-09-24 23:07:27','globeadmin'),('57e6de99cf5c42a','57e6de99b6fac6a','onblur','nuFORM.edited = 0;','2016-09-24 23:14:17','globeadmin','2016-09-24 23:14:17','globeadmin','2016-09-24 23:20:28','globeadmin'),('57e6df1b8aab33b','57e6df1b6fdd6ac','onblur','nuFORM.edited = 0;','2016-09-24 23:16:27','globeadmin','2016-09-24 23:16:27','globeadmin','2016-09-24 23:20:11','globeadmin'),('57e6df286129578','57e6df28465765e','onblur','nuFORM.edited = 0;','2016-09-24 23:16:40','globeadmin','2016-09-24 23:16:40','globeadmin','2016-09-24 23:19:25','globeadmin'),('57e78df9a8c5709','57e78df98dfebbd','onclick','nuOpenForm(\'\',\'\', \'57e15c6777df58a\', \'#RECORD_ID#\',\'Δημιουργία Λογαριασμών Γονέων\');','2016-09-25 11:42:33','globeadmin','2016-09-25 11:46:30','globeadmin','2016-11-18 18:21:23','globeadmin'),('57ed564c2ac392c','57ed564c12604cf','onclick','var id_array = [];\n\nvar t = document.getElementById(\'teacher_id\');\nvar t_id = t.options[t.selectedIndex].value;\n\nvar iframe = document.getElementById(\'search_iframe\');\nvar innerDoc = (iframe.contentDocument) ? iframe.contentDocument : iframe.contentWindow.document;\n\nvar c1 = innerDoc.getElementsByClassName(\'chk_1\');\n        \nfor(var i=0, n=c1.length;i<n;i++) {\n    if(c1[i].checked){\n        id_array.push(c1[i].id);\n    }\n} \n    \nids = id_array.join();\n    \nif(typeof id_array != \'undefined\' && id_array != null && id_array.length > 0){\n    var msg= (t_id!=\'\' ? \'Θα οριστεί νέος υπεύθυνος καθηγητής για \'+id_array.length+\' μαθητές!\\nΕίστε σίγουρος;\' : \'Θα οριστεί ότι \'+id_array.length+\' μαθητές δεν θα έχουν υπέυθυνο καθηγητή!\\nΕίστε σίγουρος;\');\n    if(confirm(msg)){\n        nuSetHash(\'student_id_list\', ids);\n        nuRunPHP(\'set_students_responsible\',\'search_iframe\');\n        t.selectedIndex=0;\n    }\n            \n} else {\n    alert (\'Παρακαλώ επιλέξτε πρώτα τους μαθητές!\');\n}','2016-09-29 20:58:36','globeadmin','2016-10-01 12:49:19','globeadmin','2018-06-21 18:51:27','globeadmin'),('57ed5a6bc95ece6','57ece36a61572ed','onchange','var t = document.getElementById(\'teacher_id\');\nt.selectedIndex=0;\nnuRunPHP(\'create_student_responsible_list\',\'search_iframe\');','2016-09-29 21:16:11','globeadmin','2016-09-29 23:24:21','globeadmin','2016-11-19 14:54:54','globeadmin'),('580233fdee03da7','580233fdd81161d','onclick','nuRunPHP(\'myFILE\',\'ifile\');\nnuSetHash(\'FILES\' , \'\');\n','2016-10-15 16:49:50','globeadmin','2016-10-15 16:49:50','globeadmin','2017-03-27 21:09:00','globeadmin'),('58022a6ccfe7142','58022a6cb9fa23a','onclick','nuRunPHP(\'myFILE\',\'ifile\');\nnuSetHash(\'FILES\' , \'\');\n','2016-10-15 16:09:00','globeadmin','2016-10-15 16:09:00','globeadmin','2017-11-04 20:14:24','globeadmin'),('5802232ec590c65','5802232eafaac00','onclick','nuRunPHP(\'myFILE\',\'ifile\');\nnuSetHash(\'FILES\' , \'\');\n','2016-10-15 15:38:06','globeadmin','2016-10-15 15:38:06','globeadmin','2016-10-15 16:48:56','globeadmin'),('58025800a7b30cd','5802580091ccd40','onclick','nuRunPHP(\'myFILE\',\'ifile\');\nnuSetHash(\'FILES\' , \'\');\n','2016-10-15 19:23:28','globeadmin','2016-10-15 19:23:28','globeadmin','2016-10-15 19:23:29','globeadmin'),('5802592351a1944','580259233bb6c04','onclick','nuRunPHP(\'myFILE\',\'ifile\');\nnuSetHash(\'FILES\' , \'\');\n','2016-10-15 19:28:19','globeadmin','2016-10-15 19:28:19','globeadmin','2016-10-24 19:07:25','globeadmin'),('58025a10363a200','58025a102050760','onclick','nuRunPHP(\'myFILE\',\'ifile\');\nnuSetHash(\'FILES\' , \'\');\n','2016-10-15 19:32:16','globeadmin','2016-10-15 19:32:16','globeadmin','2016-10-15 19:32:16','globeadmin'),('580275828dd029a','5802758277e0be7','onclick','nuRunPHP(\'myFILE\',\'ifile\');\nnuSetHash(\'FILES\' , \'\');\n','2016-10-15 21:29:22','globeadmin','2016-10-15 21:29:22','globeadmin','2017-10-15 13:22:26','globeadmin'),('580cdf696408f3c','580cdf694e16f3c','onblur','nuFORM.edited = 0;','2016-10-23 19:03:53','globeadmin','2016-10-23 19:03:53','globeadmin','2021-10-24 21:41:13','globeadmin'),('580cdf86e7c6c0a','580cdf86d1d731a','onblur','nuFORM.edited = 0;','2016-10-23 19:04:22','globeadmin','2016-10-23 19:04:22','globeadmin','2021-10-24 21:41:40','globeadmin'),('580cdfc1b6cf536','580cdfc1a0e32dc','onblur','nuFORM.edited = 0;','2016-10-23 19:05:21','globeadmin','2016-10-23 19:05:21','globeadmin','2021-10-24 21:43:48','globeadmin'),('580ce6fd1ebbb7c','580ce6fd065f33e','onblur','nuFORM.edited = 0;','2016-10-23 19:36:13','globeadmin','2016-10-23 19:36:13','globeadmin','2021-10-24 21:42:34','globeadmin'),('580ce02591371e8','580ce025766533d','onclick','nuRunPHP(\'search_penalty\',\'search_iframe\');','2016-10-23 19:07:01','globeadmin','2016-10-23 20:34:55','globeadmin','2021-10-25 15:50:05','globeadmin'),('580ce04be517ab1','580ce04bcdf0f7a','onblur','nuFORM.edited = 0;','2016-10-23 19:07:39','globeadmin','2016-10-23 19:07:39','globeadmin','2021-10-24 21:46:49','globeadmin'),('580ce07b6964abe','580ce07b5107672','onblur','nuFORM.edited = 0;','2016-10-23 19:08:27','globeadmin','2016-10-23 19:08:27','globeadmin','2021-10-24 21:45:45','globeadmin'),('580ce0b53f78b65','580ce0b5298af04','onblur','nuFORM.edited = 0;','2016-10-23 19:09:25','globeadmin','2016-10-23 19:09:25','globeadmin','2021-10-24 21:43:16','globeadmin'),('580ce7bc42f369a','580ce7bc2aa1db9','onblur','nuFORM.edited = 0;','2016-10-23 19:39:24','globeadmin','2016-10-23 19:39:24','globeadmin','2018-03-05 19:14:50','globeadmin'),('580da136ea1c3ad','580da136ca4c9d4','onclick','nuOpenForm(\'\',\'\', \'580cdf151b06780\', \'#RECORD_ID#\',\'Ποινές\');','2016-10-24 08:50:46','globeadmin','2016-10-24 08:50:47','globeadmin','2022-01-08 11:00:10','globeadmin'),('580e31cad542013','580e31cabf56abb','onclick','nuRunPHP(\'myFILE\',\'ifile\');\nnuSetHash(\'FILES\' , \'\');\n','2016-10-24 19:07:38','globeadmin','2016-10-24 19:07:38','globeadmin','2022-02-11 20:43:08','globeadmin'),('5810d3b22ae05b4','5810d3b1c4b94cf','onclick','nuOpenForm(\'\',\'\', \'580e312bc544f2e\', \'#RECORD_ID#\',\'Εισαγωγή Συνόλων Απουσιών\');','2016-10-26 19:02:58','globeadmin','2016-10-26 19:55:39','globeadmin','2016-10-26 20:13:24','globeadmin'),('580e323dad48f8e','580e323d975931a','onclick',';\nnuRunPHP(\'penalty_read\',\'insert_penalty_iframe\');','2016-10-24 19:09:33','globeadmin','2016-10-24 19:09:33','globeadmin','2022-02-11 21:15:56','globeadmin'),('580e32579c00eab','580e3257860f2c0','onclick','nuAjax(\'prev_absences_read\',\'update_iframe\');','2016-10-24 19:09:59','globeadmin','2016-10-25 21:08:49','globeadmin','2022-02-11 21:16:18','globeadmin'),('58124f6da23c189','58124f6d876e704','onchange','show_lesson();','2016-10-27 22:03:09','globeadmin','2016-10-27 22:03:09','globeadmin','2016-10-27 22:03:10','globeadmin'),('58124f6dac000b5','58124f6d876e704','onblur','nuFORM.edited = 0;','2016-10-27 22:03:09','globeadmin','2016-10-27 22:03:09','globeadmin','2016-10-27 22:03:10','globeadmin'),('58124f84dcaf834','58124f84c6bfcfc','onchange','show_lesson();\n','2016-10-27 22:03:32','globeadmin','2016-10-27 22:03:32','globeadmin','2016-10-27 22:03:33','globeadmin'),('58124f84e6737d4','58124f84c6bfcfc','onblur','nuFORM.edited = 0;','2016-10-27 22:03:32','globeadmin','2016-10-27 22:03:32','globeadmin','2016-10-27 22:03:33','globeadmin'),('58124f9e738ee31','58124f9e5da2a9e','onchange','/*var x = document.getElementById(\'form_absence_date\');\nvar y = document.getElementById(\'absence_class\');\nvar class_id = y.options[y.selectedIndex].value;\n\nnuSetHash(\'absence_date\',x.value);\nnuSetHash(\'absence_class_id\',class_id);\n\nnuRunPHP(\'create_absence_class_table\',\'absence_iframe\');*/\n','2016-10-27 22:03:58','globeadmin','2016-10-27 22:03:58','globeadmin','2016-10-27 22:03:59','globeadmin'),('58124f9e7d529f4','58124f9e5da2a9e','onblur','nuFORM.edited = 0;','2016-10-27 22:03:58','globeadmin','2016-10-27 22:03:58','globeadmin','2016-10-27 22:03:59','globeadmin'),('58124fbbb2dfed2','58124fbb896f7a5','onblur','nuFORM.edited = 0;','2016-10-27 22:04:27','globeadmin','2016-10-27 22:04:27','globeadmin','2016-10-27 22:04:28','globeadmin'),('58124fdbc15aa73','58124fdbab6ea87','onclick','var s = document.getElementById(\'student\');\nvar std=s.value;\n\nvar d = document.getElementById(\'absence_date\');\nvar ad=d.value;\n\nvar p = document.getElementById(\'period\');\nvar prd = p.options[p.selectedIndex].value;\n\nvar t = document.getElementById(\'absence_type\');\nvar at = t.options[t.selectedIndex].value;\n\nif(ad==\'\'){\n    alert(\'Παρακαλώ επιλέξτε ημερομηνία..\');\n} else if (prd==0){\n    alert(\'Παρακαλώ επιλέξτε ώρα..\');\n} else if (std==\'\'){\n    alert(\'Παρακαλώ επιλέξτε μαθητή..\');\n} else if (at==0){\n    alert(\'Παρακαλώ επιλέξτε τύπο απουσίας..\');\n} else{\n    nuRunPHP(\'add_student_registered_absence\',\'search_iframe\');\n}\n','2016-10-27 22:04:59','globeadmin','2016-10-27 22:04:59','globeadmin','2016-10-27 22:07:17','globeadmin'),('5812518abf5e231','5812518aa9712c6','onchange','show_lesson();','2016-10-27 22:12:10','globeadmin','2016-10-27 22:12:10','globeadmin','2016-10-27 22:32:32','globeadmin'),('5812518ac91dfc6','5812518aa9712c6','onblur','nuFORM.edited = 0;','2016-10-27 22:12:10','globeadmin','2016-10-27 22:12:10','globeadmin','2016-10-27 22:32:32','globeadmin'),('5812519f1bb6c5b','5812519f05c4923','onchange','show_lesson();\n','2016-10-27 22:12:31','globeadmin','2016-10-27 22:12:31','globeadmin','2016-10-27 22:32:51','globeadmin'),('5812519f257484b','5812519f05c4923','onblur','nuFORM.edited = 0;','2016-10-27 22:12:31','globeadmin','2016-10-27 22:12:31','globeadmin','2016-10-27 22:32:51','globeadmin'),('58146a1764342ac','58146a174bd04b6','onchange','var t = document.getElementById(\'advisor_id\');\nt.selectedIndex=0;\nnuRunPHP(\'create_student_advisor_list\',\'search_iframe\');','2016-10-29 12:21:27','globeadmin','2016-10-29 12:39:10','globeadmin','2018-12-04 21:21:21','globeadmin'),('581251dd7aa2d4e','581251dd64b96c8','onchange','/*var x = document.getElementById(\'form_absence_date\');\nvar y = document.getElementById(\'absence_class\');\nvar class_id = y.options[y.selectedIndex].value;\n\nnuSetHash(\'absence_date\',x.value);\nnuSetHash(\'absence_class_id\',class_id);\n\nnuRunPHP(\'create_absence_class_table\',\'absence_iframe\');*/\n','2016-10-27 22:13:33','globeadmin','2016-10-27 22:13:33','globeadmin','2016-10-27 22:13:34','globeadmin'),('581251dd8466cd6','581251dd64b96c8','onblur','nuFORM.edited = 0;','2016-10-27 22:13:33','globeadmin','2016-10-27 22:13:33','globeadmin','2016-10-27 22:13:34','globeadmin'),('58146a5dcd28c13','58146a5db4ce238','onclick','var id_array = [];\n\nvar t = document.getElementById(\'advisor_id\');\nvar t_id = t.options[t.selectedIndex].value;\n\nvar iframe = document.getElementById(\'search_iframe\');\nvar innerDoc = (iframe.contentDocument) ? iframe.contentDocument : iframe.contentWindow.document;\n\nvar c1 = innerDoc.getElementsByClassName(\'chk_1\');\n        \nfor(var i=0, n=c1.length;i<n;i++) {\n    if(c1[i].checked){\n        id_array.push(c1[i].id);\n    }\n} \n    \nids = id_array.join();\n    \nif(typeof id_array != \'undefined\' && id_array != null && id_array.length > 0){\n    var msg= (t_id!=\'\' ? \'Θα οριστεί νέος ατομικός σύμβουλος για \'+id_array.length+\' μαθητές!\\nΕίστε σίγουρος;\' : \'Θα οριστεί ότι \'+id_array.length+\' μαθητές δεν θα έχουν ατομικό σύμβουλο!\\nΕίστε σίγουρος;\');\n    if(confirm(msg)){\n        nuSetHash(\'student_id_list\', ids);\n        nuRunPHP(\'set_students_advisor\',\'search_iframe\');\n        t.selectedIndex=0;\n    }\n            \n} else {\n    alert (\'Παρακαλώ επιλέξτε πρώτα τους μαθητές!\');\n}','2016-10-29 12:22:37','globeadmin','2016-10-29 12:42:29','globeadmin','2018-12-04 21:22:38','globeadmin'),('582b42c1e6b8691','582b42c1d0c9592','onclick','nuOpenFormInFrame(\'582b3fe8c3f39e6\',\'#RECORD_ID#\');','2016-11-15 19:15:45','globeadmin','2016-11-15 19:29:09','globeadmin','2016-11-15 19:29:10','globeadmin'),('582b449b7c8818f','582b449b6698e98','onclick','nuOpenFormInFrame(\'582b40cc7c93c9c\',\'#RECORD_ID#\');','2016-11-15 19:23:39','globeadmin','2016-11-15 19:30:30','globeadmin','2016-11-15 19:30:30','globeadmin'),('5830322b92e7dd3','5830322b7a82f2a','onclick','nuRunPHP(\'search_notification\',\'search_iframe\');\n','2016-11-19 13:06:19','globeadmin','2016-11-26 15:48:39','globeadmin','2017-08-24 16:20:27','globeadmin'),('58d6ad8c316fa72','58d66ad17ab9278','onchange','if(document.getElementById(\'login_with_email_account\').checked){\n    if(checkEmail($(\'#sus_email\').val())){\n            $(\'[id*=sus_login_name]\').hide();\n            $(\'[id*=nupassword]\').hide();\n            $(\'[id*=nuretyped]\').hide();\n    } else {\n        \n        var es = \'\';\n        var s = document.getElementById(\'email_servers\');\n\n        for (var i = 0; i < s.options.length; i++) {\n            if(s.options[i].text!=\'\'){\n                es += \'\\n@\'+s.options[i].text;\n            }\n        } \n        alert(\'Προσοχή: Η επιλογή αυτή είναι διαθέσιμη μόνο για τους παρακάτω λογαριασμούς email :\'+es);\n        \n        document.getElementById(\'login_with_email_account\').checked = false;\n        $(\'[id*=sus_login_name]\').show();\n        $(\'[id*=nupassword]\').show();\n        $(\'[id*=nuretyped]\').show(); \n    }\n} else {\n    $(\'[id*=sus_login_name]\').show();\n    $(\'[id*=nupassword]\').show();\n    $(\'[id*=nuretyped]\').show();   \n}','2017-03-25 19:49:00','globeadmin','2017-03-27 21:24:26','globeadmin','2017-04-03 08:08:28','globeadmin'),('583ee83aa698cc4','583ee83a86ddc26','onclick','nuOpenForm(\'\',\'\', \'583031e43183ea3\', \'#RECORD_ID#\',\'Καθηγητής\');\n \n   ','2016-11-30 16:54:50','globeadmin','2016-11-30 17:09:57','globeadmin','2016-12-02 15:18:58','globeadmin'),('583ef27fa2118cd','583ef27f6c5d468','onclick','nuOpenForm(\'\',\'\', \'582762fe10beed3\', \'\',\'Τύποι Ειδοποιήσεων\');\n\n\n','2016-11-30 17:38:39','globeadmin','2016-11-30 19:56:37','globeadmin','2018-01-09 21:03:03','globeadmin'),('583ef3173b234f3','583ef316e6285b5','onclick','nuOpenForm(\'\',\'\', \'58275eceb901234\', \'\',\'Κατηγορίες Ειδοποιήσεων Email\');\n\n\n','2016-11-30 17:41:11','globeadmin','2016-12-06 16:52:49','globeadmin','2018-01-08 22:14:39','globeadmin'),('583f1769955f86a','583f17697f712c5','onclick','nuOpenForm(\'\',\'\', \'5c053bad46326aa\', \'#RECORD_ID#\',\'Ορισμός Ατομικού Συμβούλου\');','2016-11-30 20:16:09','globeadmin','2018-12-06 01:45:10','globeadmin','2018-12-06 01:45:11','globeadmin'),('58402a63bca003d','58402a6390adae4','onclick','if(\'#nu_user_group#\'==\'Parents\' || nuIsGA()){ \n    var email_address = \'#parent_email#\';\n    if(email_address.trim()==\'\'){\n        var teacher_name = $(\'#teacher_id\').val();\n        var msg = \'Προσοχή : Δεν υπάρχει για εσάς καταχωρημένη διεύθυνση email.\\nΠαρακαλώ γνωστοποιείστε την διεύθυνση email σας στον «Υπεύθυνο Καθηγητή»\'+(teacher_name.trim()==\'\' ? \'\' : \' (\'+teacher_name+\')\');\n        alert(msg);    \n    } else {\n        nuOpenFormInFrame(\'584128b691c711a\', \'#RECORD_ID#\');\n    }    \n} else {\n    var email_address = \'#email#\';\n    if(email_address.trim()==\'\'){\n        var teacher_name = $(\'#teacher_id\').val();\n        var msg = \'Προσοχή : Δεν υπάρχει για εσάς καταχωρημένη διεύθυνση email.\\nΠαρακαλώ γνωστοποιείστε την διεύθυνση email σας στον «Υπεύθυνο Καθηγητή»\'+(teacher_name.trim()==\'\' ? \'\' : \' (\'+teacher_name+\')\');\n        alert(msg);    \n    } else {\n        nuOpenFormInFrame(\'584117d1d046e30\', \'#RECORD_ID#\');    \n    }    \n}\n\n','2016-12-01 15:49:23','globeadmin','2017-09-10 18:32:52','globeadmin','2018-07-25 14:07:43','globeadmin'),('584599ed9725e64','584599ed813c99d','onclick','nuPrintPDF(\'search_absence_list\');','2016-12-05 18:46:37','globeadmin','2016-12-05 19:48:49','globeadmin','2017-11-23 08:26:22','globeadmin'),('58469cb015b303f','58469cafef04b9a','onclick','nuPrintPDF(\'search_absence_list\');','2016-12-06 13:10:40','globeadmin','2016-12-06 13:10:40','globeadmin','2016-12-06 13:10:40','globeadmin'),('584bdb82a6d9d12','584bdb828e7d003','onclick','var ids = get_selected_ids();\nif(typeof ids != \'undefined\' && ids != null){\n    if(confirm(\'Θα εισάγετε -μαζικά- αιτήματα διαγραφής στις επιλεγμένες απουσίες!\\nΕίστε σίγουρος;\')){\n        nuOpenFormInFrame(\'584bd01a9203a9a\', \'#RECORD_ID#\')\n    }\n}','2016-12-10 12:40:02','globeadmin','2018-08-05 00:03:25','globeadmin','2018-08-07 15:15:06','globeadmin'),('585e8d358a289ef','55129303800b34e','onchange','sumoSetHashSelectedIds(this);','2016-12-24 16:59:01','globeadmin','2016-12-24 19:54:20','globeadmin','2019-03-10 11:10:46','globeadmin'),('585eba6130d178c','5738afd876f6f98','onchange','sumoSetHashSelectedIds(this);','2016-12-24 20:11:45','globeadmin','2016-12-24 20:11:45','globeadmin','2018-08-05 00:15:52','globeadmin'),('585f9ae178254fa','551280cbbf8530f','onchange','sumoSetHashSelectedIds(this);','2016-12-25 12:09:37','globeadmin','2016-12-25 12:09:37','globeadmin','2018-08-05 00:20:26','globeadmin'),('585f9ae96708339','55127dcf345abf4','onchange','sumoSetHashSelectedIds(this);','2016-12-25 12:09:45','globeadmin','2016-12-25 12:09:45','globeadmin','2019-11-06 09:18:17','globeadmin'),('585f9af0f22b616','5512aa9f05f9517','onchange','sumoSetHashSelectedIds(this);','2016-12-25 12:09:53','globeadmin','2016-12-25 12:09:53','globeadmin','2021-10-28 17:20:58','globeadmin'),('585f9af87a847ea','55127b84875e51e','onchange','sumoSetHashSelectedIds(this);','2016-12-25 12:10:00','globeadmin','2016-12-25 12:10:00','globeadmin','2019-11-06 09:18:45','globeadmin'),('5860d48b779b164','5738bff596b6181','onchange','sumoSetHashSelectedIds(this);','2016-12-26 10:27:55','globeadmin','2016-12-26 10:27:55','globeadmin','2018-08-04 21:07:59','globeadmin'),('5860d4955f20d0d','5787bce41eec5ca','onchange','sumoSetHashSelectedIds(this);','2016-12-26 10:28:05','globeadmin','2016-12-26 10:28:05','globeadmin','2016-12-26 10:28:06','globeadmin'),('5860d49ce5668ff','55182267c48246a','onchange','sumoSetHashSelectedIds(this);','2016-12-26 10:28:13','globeadmin','2016-12-26 10:28:13','globeadmin','2016-12-26 10:28:14','globeadmin'),('5860dfad081a732','54aaae2f00a154c','onchange','sumoSetHashSelectedIds(this);','2016-12-26 11:15:25','globeadmin','2016-12-26 11:15:25','globeadmin','2020-09-15 13:42:12','globeadmin'),('5860e6748dfcc30','578e9c7e006f0ee','onchange','sumoSetHashSelectedIds(this);','2016-12-26 11:44:20','globeadmin','2016-12-26 11:44:20','globeadmin','2017-03-14 20:30:37','globeadmin'),('58663a6f4323f1b','58303b568f3beff','onchange','sumoSetHashSelectedIds(this);','2016-12-30 12:43:59','globeadmin','2016-12-30 12:43:59','globeadmin','2016-12-30 12:46:44','globeadmin'),('58663a75babdcaf','5830388ebd03b3d','onchange','sumoSetHashSelectedIds(this);','2016-12-30 12:44:05','globeadmin','2016-12-30 12:44:05','globeadmin','2018-01-09 21:16:35','globeadmin'),('58c83abb2f246a9','572af74eb3f35c7','onchange','sumoSetHashSelectedIds(this);','2017-03-14 20:47:23','globeadmin','2017-03-14 20:47:23','globeadmin','2021-03-09 15:15:55','globeadmin'),('58c83e057379040','572af77bbb47fc5','onchange','sumoSetHashSelectedIds(this);','2017-03-14 21:01:25','globeadmin','2017-03-14 21:01:25','globeadmin','2021-03-09 15:16:16','globeadmin'),('58cd39d4ad3ba6a','572b65b7f36f3fc','onchange','sumoSetHashSelectedIds(this);','2017-03-18 15:44:52','globeadmin','2017-03-18 15:44:52','globeadmin','2020-09-23 10:31:30','globeadmin'),('58cd3a4506e177d','572b6658524cfec','onchange','sumoSetHashSelectedIds(this);','2017-03-18 15:46:45','globeadmin','2017-03-18 15:46:45','globeadmin','2018-08-04 10:15:41','globeadmin'),('58cd4085860ac83','571a7ab92f999b5','onchange','sumoSetHashSelectedIds(this);','2017-03-18 16:13:25','globeadmin','2017-03-18 16:13:25','globeadmin','2021-03-09 16:01:46','globeadmin'),('58cd408cc7ebb56','571a7a4af0787b3','onchange','sumoSetHashSelectedIds(this);','2017-03-18 16:13:32','globeadmin','2017-03-18 16:13:32','globeadmin','2021-03-09 15:15:22','globeadmin'),('58cd4308d52e997','571baec6802d9b9','onchange','sumoSetHashSelectedIds(this);','2017-03-18 16:24:08','globeadmin','2017-03-18 16:24:08','globeadmin','2018-08-04 10:14:55','globeadmin'),('58cd431a8dd7dbe','571baee74a78fde','onchange','sumoSetHashSelectedIds(this);','2017-03-18 16:24:26','globeadmin','2017-03-18 16:24:26','globeadmin','2017-03-18 16:24:27','globeadmin'),('58d78f1c635b3ea','58d6220a9044554','onchange','if(!checkEmail($(\'#sus_email\').val())){\n    if(document.getElementById(\'login_with_email_account\').checked){\n        document.getElementById(\'login_with_email_account\').checked = false;\n        $(\'[id*=sus_login_name]\').show();\n        $(\'[id*=nupassword]\').show();\n        $(\'[id*=nuretyped]\').show();    \n    }\n}','2017-03-26 12:51:24','globeadmin','2017-03-27 08:28:30','globeadmin','2017-03-27 08:38:31','globeadmin'),('58e153405ddec96','58e14de150b4d83','onmouseover','if($(\'#state\').val()!=\'ΤΡΕΧΟΥΣΑ\'){\n    this.style.cursor=\'pointer\';\n}','2017-04-02 22:38:40','globeadmin','2017-04-02 22:40:10','globeadmin','2018-06-30 12:18:31','globeadmin'),('58e1534067a96f1','58e14de150b4d83','onmouseout','if($(\'#state\').val()!=\'ΤΡΕΧΟΥΣΑ\'){\n    this.style.cursor=\'auto\';\n}\n\n','2017-04-02 22:38:40','globeadmin','2017-04-02 22:40:10','globeadmin','2018-06-30 12:18:31','globeadmin'),('58e1695e9e7732e','58e14de150b4d83','onclick','if($(\'#state\').val()!=\'ΤΡΕΧΟΥΣΑ\'){\n    if(confirm(\'Αυτή η περίοδος αξιολόγησης θα οριστεί ως η τρέχουσα ενεργή!\\nΕίστε Σίγουρος;\')){\n        nuAjax(\'set_active_grading_period\',\'set_active\');\n    }\n}\n','2017-04-03 00:13:02','globeadmin','2017-04-03 00:22:37','globeadmin','2018-06-30 12:18:31','globeadmin'),('59997e4bea3bc17','599954a0368120c','onchange','if(document.getElementById(\'allDay\').checked){\n    nuDisable(\'start_time\',\'00:00:00\');\n    nuDisable(\'end_time\',\'00:00:00\');\n    $(\'[id*=start_time]\').hide();\n    $(\'[id*=end_time]\').hide();\n    $(\'[id*=period]\').hide();\n    document.getElementById(\'period_start\').selectedIndex = 0;\n    document.getElementById(\'period_end\').selectedIndex = 0;\n} else {\n    $(\'[id*=start_time]\').show();\n    $(\'[id*=end_time]\').show();\n    $(\'[id*=period]\').show();\n    nuEnable(\'start_time\',\'00:00:00\');\n    nuEnable(\'end_time\',\'00:00:00\');\n    document.getElementById(\'period_start\').selectedIndex = 0;\n    document.getElementById(\'period_end\').selectedIndex = 0;\n}','2017-08-20 15:19:23','globeadmin','2018-04-27 23:54:41','globeadmin','2018-04-27 23:54:42','globeadmin'),('599b467b0759a8f','599b361a636564a','onchange','hide_all_publication_elements();\n\nvar s = this.options[this.selectedIndex].value;\n\nif(s==3){\n    $(\'[id*=teacher_id_select]\').show();    \n}  else if(s==4){\n    $(\'[id*=students_check]\').show();\n    $(\'[id*=parents_check]\').show();    \n}  else if(s==5){\n    $(\'[id*=students_check]\').show();\n    $(\'[id*=parents_check]\').show();\n    $(\'[id*=grade_id_select]\').show();\n}  else if(s==6){\n    $(\'[id*=students_check]\').show();\n    $(\'[id*=parents_check]\').show();\n    $(\'[id*=class_id_select]\').show();\n}  else if(s==7){\n    $(\'[id*=students_check]\').show();\n    $(\'[id*=parents_check]\').show(); \n    $(\'[id*=student_id_select]\').show();\n} ','2017-08-21 23:45:47','globeadmin','2017-09-13 19:31:40','globeadmin','2021-10-09 23:07:05','globeadmin'),('599b47aa59b5656','599b47aa464ad12','onclick','function check_publication_fields(){\n    var s1 = document.getElementById(\'selection1\');\n    var s = s1.options[s1.selectedIndex].value;\n    if (s==\'\'){\n        alert(\'Παρακαλώ επιλέξτε σε ποιους θα γίνει η κοινοποίηση!\');\n        return 0;\n    } else if(s==3){\n        var teachers_id_list = nuGetHash(\'teacher_id_select_sumo\');\n        if ((typeof teachers_id_list == \'undefined\') || teachers_id_list.trim()==\'\'){\n            alert(\'Παρακαλώ επιλέξτε καθηγητές!\');\n            return 0;\n        }\n    } else if(s==4){\n        if(document.getElementById(\'students_check\').checked == false && document.getElementById(\'parents_check\').checked == false){\n            alert(\'Παρακαλώ επιλέξτε αν η κοινοποίηση θα γίνει «σε Μαθητές» ή και «σε Γονείς»!\');\n            return 0;\n        }\n    } else if(s==5){\n        if(document.getElementById(\'students_check\').checked == false && document.getElementById(\'parents_check\').checked == false){\n            alert(\'Παρακαλώ επιλέξτε αν η κοινοποίηση θα γίνει «σε Μαθητές» ή και «σε Γονείς»!\'); \n            return 0;\n        } else {\n            var grade_id_list = nuGetHash(\'grade_id_select_sumo\');\n            if (typeof grade_id_list == \'undefined\' || grade_id_list.trim()==\'\'){\n                alert(\'Παρακαλώ επιλέξτε τάξεις!\');\n                return 0;\n            }\n        }     \n    } else if(s==6){\n        if(document.getElementById(\'students_check\').checked == false && document.getElementById(\'parents_check\').checked == false){\n            alert(\'Παρακαλώ επιλέξτε αν η κοινοποίηση θα γίνει «σε Μαθητές» ή και «σε Γονείς»!\');\n            return 0;\n        } else {\n            var class_id_list = nuGetHash(\'class_id_select_sumo\');\n            if (typeof class_id_list == \'undefined\' || class_id_list.trim()==\'\'){\n                alert(\'Παρακαλώ επιλέξτε τμήματα!\');\n                return 0;\n            }\n        }     \n    } else if(s==7){\n        if(document.getElementById(\'students_check\').checked == false && document.getElementById(\'parents_check\').checked == false){\n            alert(\'Παρακαλώ επιλέξτε αν η κοινοποίηση θα γίνει «σε Μαθητές» ή και «σε Γονείς»!\');\n            return 0;\n        } else {\n            var student_id_list = nuGetHash(\'student_id_select_sumo\');\n            if (typeof student_id_list == \'undefined\' || student_id_list.trim()==\'\'){\n                alert(\'Παρακαλώ επιλέξτε μαθητές!\');\n                return 0;\n            }\n        }     \n    } else if(s!=0 && s!=1 && s!=2 && s!=8){\n        alert(\'Δεν είναι έγκυρη επιλογή!\');\n        return 0;\n    }\n    return 1;\n}\nif(check_publication_fields()){\n    \n    showLoader();\n    \n    if(document.getElementById(\'inform_check\').checked){\n        nuSetHash(\'inform_check_hash\',\'1\');    \n    } else {\n        nuSetHash(\'inform_check_hash\',\'0\');    \n    }\n    \n    if(document.getElementById(\'students_check\').checked){\n        nuSetHash(\'students_check_hash\',\'1\');    \n    } else {\n        nuSetHash(\'students_check_hash\',\'0\');    \n    }\n    \n    if(document.getElementById(\'parents_check\').checked){\n        nuSetHash(\'parents_check_hash\',\'1\');    \n    } else {\n        nuSetHash(\'parents_check_hash\',\'0\');    \n    }\n    if(document.getElementById(\'do_check\').checked){\n        nuAjax(\'check_publish_calendar_event\',\'display_check_result\',{async:true});\n    } else {\n        nuAjax(\'publish_calendar_event\',\'display_publish_result\',{async:true});    \n    }\n}\n    ','2017-08-21 23:50:50','globeadmin','2018-04-24 14:45:15','globeadmin','2021-10-09 22:53:15','globeadmin'),('599bd6770472985','599bd676e50e242','onblur','nuFORM.edited = 0;','2017-08-22 10:00:07','globeadmin','2017-08-22 10:00:07','globeadmin','2017-08-26 17:09:16','globeadmin'),('599bd6770e2e750','599bd676e50e242','onchange','sumoSetHashSelectedIds(this);','2017-08-22 10:00:07','globeadmin','2017-08-22 10:00:07','globeadmin','2017-08-26 17:09:16','globeadmin'),('599c6f406f49e6f','599c6f4059501e7','onblur','nuFORM.edited = 0;','2017-08-22 20:52:00','globeadmin','2017-08-22 20:52:00','globeadmin','2017-10-18 22:45:02','globeadmin'),('599c6f96bfa5653','599c6f96ac3a98e','onblur','nuFORM.edited = 0;','2017-08-22 20:53:26','globeadmin','2017-08-22 20:53:26','globeadmin','2017-10-18 22:45:58','globeadmin'),('599c72202e39f59','599c72201befb21','onblur','nuFORM.edited = 0;','2017-08-22 21:04:16','globeadmin','2017-08-22 21:04:16','globeadmin','2017-10-18 23:42:21','globeadmin'),('599c72203a7f6f6','599c72201befb21','onchange','sumoSetHashSelectedIds(this);','2017-08-22 21:04:16','globeadmin','2017-08-22 21:04:16','globeadmin','2017-10-18 23:42:21','globeadmin'),('599c74983922a8a','599c749825929f1','onblur','nuFORM.edited = 0;','2017-08-22 21:14:48','globeadmin','2017-08-22 21:14:48','globeadmin','2017-10-18 23:41:35','globeadmin'),('599c74984331701','599c749825929f1','onchange','sumoSetHashSelectedIds(this);','2017-08-22 21:14:48','globeadmin','2017-08-22 21:14:48','globeadmin','2017-10-18 23:41:35','globeadmin'),('599c76b1f1819ae','599c76b1db8a318','onblur','nuFORM.edited = 0;','2017-08-22 21:23:46','globeadmin','2017-08-22 21:23:46','globeadmin','2020-09-23 09:59:01','globeadmin'),('599c76b20721ece','599c76b1db8a318','onchange','sumoSetHashSelectedIds(this);','2017-08-22 21:23:46','globeadmin','2017-08-22 21:23:46','globeadmin','2020-09-23 09:59:01','globeadmin'),('59a287fa13c41d4','59a287f9ef7e72a','onclick','var iframe = document.getElementById(\'participants_iframe\');\nvar innerDoc = (iframe.contentDocument) ? iframe.contentDocument : iframe.contentWindow.document;\n\nvar c1 = innerDoc.getElementsByClassName(\'chk_1\');\nvar id_array = [];\n\nfor(var i=0, n=c1.length;i<n;i++) {\n    if(c1[i].checked){\n        id_array.push(c1[i].id);\n    }\n}\n\nvar id_list = id_array.join(\',\');\n        \nif(id_list!=\'\'){\n    if(confirm(\'Θα αφαιρέσετε τους επιλεγμένους συμμετέχοντες!\\n Είστε σίγουρος;\')){\n        showLoader();\n        nuSetHash(\'id_list\', id_list);\n        \n        if(document.getElementById(\'inform_check\').checked){\n            nuSetHash(\'inform_check_hash\',\'1\');    \n        } else {\n            nuSetHash(\'inform_check_hash\',\'0\');    \n        }\n    \n        nuAjax(\'delete_event_calendar_participants\',\'display_delete_result\',{async:true});\n    }\n} else {\n    alert(\'Παρακαλώ επιλέξτε πρώτα τους συμμετέχοντες που θέλετε να αφαιρέσετε!\');    \n}','2017-08-27 11:51:06','globeadmin','2017-11-02 21:52:12','globeadmin','2020-09-18 22:06:38','globeadmin'),('59a5d1770d0ba5b','59a5c63730cac7f','onchange','var s = this.options[this.selectedIndex].value;\n\nif(s!=\'\'){\n    $(\'#start_time\').val(s);\n}','2017-08-29 23:41:27','globeadmin','2018-04-19 13:22:42','globeadmin','2020-09-14 22:48:28','globeadmin'),('59a6e23da8c46bd','59a6e23d97b27c9','onclick','open_teacher_form(\'599591df20eb2f7\');','2017-08-30 19:05:17','globeadmin','2017-10-22 18:48:15','globeadmin','2018-07-23 00:26:38','globeadmin'),('59a975451775c4f','59a9754503f38d6','onchange','nuAjax(\'find_teacher_cards\',\'pollute_cards\');','2017-09-01 17:57:09','globeadmin','2017-09-01 18:14:25','globeadmin','2018-07-01 11:10:15','globeadmin'),('59a9845135f3dfd','59a98451226bc29','onclick','if($(\'#test_date\').val() == \'\'){ \n    alert(\'Παρακαλώ συμπληρώστε πρώτα την «Ημερομηνία»\');\n    return;  \n}\n\nvar e = document.getElementById(\'period_class_subject_id\');\n\nvar id = e.options[e.selectedIndex].value;    \nif(id == \'\'){ \n    alert(\'Παρακαλώ επιλέξτε πρώτα τη «Διδασκαλία»\');\n    return;  \n}  \n\nif(!document.getElementById(\'is_exam\').checked && !document.getElementById(\'is_test\').checked){ \n    alert(\'Παρακαλώ επιλέξτε πρώτα αν πρόκειται για Διαγώνισμα ή Τεστ!\');\n    return;  \n}\n\nif((document.getElementById(\'publish_students_check\').checked || document.getElementById(\'publish_parents_check\').checked) \n        && !(confirm(\'Προσοχή! Η εξέταση θα γίνει γνωστή σε Μαθητές/Γονείς!\\nΕίστε Σίγουρος;\'))){\n    return;\n}\n\nif((document.getElementById(\'no_check\').checked && document.getElementById(\'is_exam\').checked) \n        && !(confirm(\'Προσοχή! Δεν θα πραγματοποιηθούν οι έλεγχοι για τα ημερήσια και τα εβδομαδιαία όρια διαγωνισμάτων ανά μαθητή!\\nΕίστε Σίγουρος;\'))){\n    return;\n}\n\n//showLoader();\nnuSetHash(\'is_exam_hash\', (document.getElementById(\'is_exam\').checked ? \'1\' : \'0\'));\nnuSetHash(\'is_test_hash\', (document.getElementById(\'is_test\').checked ? \'1\' : \'0\'));\nnuSetHash(\'no_check_hash\', (document.getElementById(\'no_check\').checked ? \'1\' : \'0\'));\n\nnuSetHash(\'publish_students_check_hash\', (document.getElementById(\'publish_students_check\').checked ? \'1\' : \'0\'));\nnuSetHash(\'publish_parents_check_hash\', (document.getElementById(\'publish_parents_check\').checked ? \'1\' : \'0\'));\n\nnuAjax(\'program_calendar_test\',\'add_calendar_test\');\n','2017-09-01 19:01:21','globeadmin','2017-11-05 13:10:15','globeadmin','2020-09-18 19:16:20','globeadmin'),('59a987507d7d2c0','59a9829856b27f3','onchange','if(this.checked){\n    document.getElementById(\'is_test\').checked = false;    \n}\n\n\n','2017-09-01 19:14:08','globeadmin','2017-09-01 19:14:08','globeadmin','2017-09-02 23:22:12','globeadmin'),('59a98767b15d1d7','59a982f59111763','onchange','if(this.checked){\n    document.getElementById(\'is_exam\').checked = false;    \n}','2017-09-01 19:14:31','globeadmin','2017-09-01 19:14:31','globeadmin','2017-09-02 22:57:14','globeadmin'),('59aa7132d8147b0','59a975682af005a','onchange','var s = this.options[this.selectedIndex];\nvar l = s.getAttribute(\'location\');\n$(\'#location\').val(l);','2017-09-02 11:52:02','globeadmin','2017-09-02 11:53:21','globeadmin','2017-11-20 15:28:32','globeadmin'),('59ab0fba4bb4a0b','59ab0d5356c2fac','onchange','if($(\'#test_date\').val() != \'\'){\n    nuAjax(\'find_teacher_cards\',\'pollute_cards\');\n}','2017-09-02 23:08:26','globeadmin','2017-09-02 23:08:26','globeadmin','2017-11-05 13:01:14','globeadmin'),('59c2941201ce542','59c29411dd89c2c','onchange','sumoSetHashSelectedIds(this);','2017-09-20 19:15:14','globeadmin','2017-09-20 19:15:14','globeadmin','2020-09-24 18:43:02','globeadmin'),('59d294cb02863fa','59d294cae30e06c','onchange','sumoSetHashSelectedIds(this);','2017-10-02 22:34:35','globeadmin','2017-10-02 22:34:35','globeadmin','2017-10-02 22:44:45','globeadmin'),('59d2ab7835ef704','5613e05d1550b5c','onchange','sumoSetHashSelectedIds(this);','2017-10-03 00:11:20','globeadmin','2017-10-03 00:11:20','globeadmin','2017-10-03 00:21:56','globeadmin'),('59d67f4ee625622','59d67f4ed20f512','onclick','open_teacher_form(\'59d7d65650da67c\');','2017-10-05 21:51:58','globeadmin','2017-10-06 22:31:10','globeadmin','2018-07-24 09:19:28','globeadmin'),('59d67f7ba38b640','59d67f7b9002f0e','onclick','open_teacher_form(\'59d7d7da6d30b22\');','2017-10-05 21:52:43','globeadmin','2017-10-06 22:33:19','globeadmin','2018-07-24 09:25:47','globeadmin'),('59d89292ef01c64','59d89292db86055','onclick','nuOpenForm(\'\',\'\', \'55222f79d342b66\', \'\',\'Δικαιολόγηση Απουσιών\');','2017-10-07 11:38:43','globeadmin','2017-10-07 11:38:43','globeadmin','2017-10-07 11:44:01','globeadmin'),('59d8991595a053e','59d89915821ddb8','onclick','nuOpenForm(\'\',\'\', \'562e770b79c0722\', \'#RECORD_ID#\',\'Εμφάνιση Βαθμολογίας\');','2017-10-07 12:06:29','globeadmin','2017-10-07 12:06:29','globeadmin','2018-05-22 19:04:35','globeadmin'),('59d67fa8eccbee2','59d67fa8d92aa75','onclick','open_teacher_form(\'59d7d6e9ecc73da\');\n   ','2017-10-05 21:53:28','globeadmin','2017-10-06 22:31:52','globeadmin','2021-02-26 22:53:03','globeadmin'),('59d67fd43f3acb1','59d67fd42bb7ed1','onclick','open_teacher_form(\'59d7d7986aed52d\');','2017-10-05 21:54:12','globeadmin','2017-10-06 22:32:52','globeadmin','2018-07-24 09:23:24','globeadmin'),('59d89a67137303f','59d89a66f197e44','onclick','nuOpenForm(\'\',\'\', \'57400922b87c65a\', \'\',\'Γενικά Κριτήρια Αξιολόγησης\');\n','2017-10-07 12:12:07','globeadmin','2017-10-07 12:12:07','globeadmin','2022-01-13 09:25:56','globeadmin'),('59d6810a76a0613','59d6810a6318667','onclick','open_teacher_form(\'599591df20eb2f7\');','2017-10-05 21:59:22','globeadmin','2017-10-06 19:05:47','globeadmin','2017-12-23 16:39:54','globeadmin'),('59d68cdca034307','59d68cdc8cb0a40','onclick','open_teacher_form(\'56eae5254137ba7\');','2017-10-05 22:49:48','globeadmin','2017-10-06 21:50:18','globeadmin','2018-07-23 09:19:17','globeadmin'),('59d88c6e00fbf32','59d88c6de197d6c','onclick','nuOpenForm(\'\',\'\', \'5495dad1762dc2c\', \'#RECORD_ID#\',\'Εκτύπωση Βαθμολογίας\');','2017-10-07 11:12:30','globeadmin','2017-10-07 11:12:30','globeadmin','2017-10-07 11:28:32','globeadmin'),('59d682ff4226a9d','59d682ff2277896','onclick','open_teacher_form(\'59d7d745b1eecbf\');','2017-10-05 22:07:43','globeadmin','2017-10-06 22:32:21','globeadmin','2018-07-24 09:39:25','globeadmin'),('59d6871eea80917','59d6871ed701c09','onclick','open_teacher_form(\'56e052ae98309fe\');','2017-10-05 22:25:18','globeadmin','2017-10-06 21:48:58','globeadmin','2017-10-28 21:57:49','globeadmin'),('59d68c4a2b69dfa','59d68c4a17db084','onclick','open_teacher_form(\'59d7d837262870c\');','2017-10-05 22:47:22','globeadmin','2017-10-06 22:33:54','globeadmin','2018-07-24 09:33:59','globeadmin'),('59d88cc28e61acf','59d88cc27adf3b2','onclick','nuOpenForm(\'\',\'\', \'562362d2ef4f556\', \'#RECORD_ID#\',\'Καταχώριση Βαθμολογίας\');','2017-10-07 11:13:54','globeadmin','2017-10-07 11:13:54','globeadmin','2018-07-23 22:21:02','globeadmin'),('59e1e3cd6a9ff39','59e1e3cd5832d70','onclick','var s=get_session_variable(\'student_id\');\n\nif  (($.isNumeric(s)) && (s!=-1)) {\n    if(\'#nu_user_group#\'==\'Parents\'){\n        nuOpenForm(\'\',\'\', \'54a6fde1ab6eb6d\', s,\'Μαθητής\');\n    } else {\n        nuOpenForm(\'\',\'\', \'59e22e4fa1018fd\', s,\'Μαθητής\');\n    }\n} else{\n    if(nuIsGA()){\n        nuOpenForm(\'\',\'\', \'59e22e4fa1018fd\', 463,\'Μαθητής\');  //  student = \'54a6fde1ab6eb6d\'\n    } else{\n        alert(\"Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με Μαθητή/Γονέα!\");\n    }\n}   \n\n\n','2017-10-14 13:15:41','globeadmin','2022-01-08 22:17:25','globeadmin','2022-01-08 22:17:26','globeadmin'),('59e1e3e623c3a71','59e1e3e61041527','onclick','var s=get_session_variable(\'student_id\');\n\nif  (($.isNumeric(s)) && (s!=-1)) {\n            nuOpenForm(\'\',\'\', \'59e22f9965b5362\', s,\'Μαθητής\');\n} else{\n    if(nuIsGA()){\n        nuOpenForm(\'\',\'\', \'59e22f9965b5362\', 1,\'Μαθητής\');    \n    } else{\n        alert(\"Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με Μαθητή/Γονέα!\");\n    }\n}    \n','2017-10-14 13:16:06','globeadmin','2017-10-24 23:09:03','globeadmin','2022-01-08 22:15:52','globeadmin'),('59e1e4004853a13','59e1e40034cb30b','onclick','var s=get_session_variable(\'student_id\');\n\nif  (($.isNumeric(s)) && (s!=-1)) {\n            nuOpenForm(\'\',\'\', \'59e22fca2af8d03\', s,\'Μαθητής\');\n} else{\n    if(nuIsGA()){\n        nuOpenForm(\'\',\'\', \'59e22fca2af8d03\', 463,\'Μαθητής\');    \n    } else{\n        alert(\"Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με Μαθητή/Γονέα!\");\n    }\n}  \n','2017-10-14 13:16:32','globeadmin','2022-01-08 14:23:17','globeadmin','2022-01-08 22:05:33','globeadmin'),('59e1e423ca11fe9','59e1e423b6202f3','onclick','var s=get_session_variable(\'student_id\');\n\nif  (($.isNumeric(s)) && (s!=-1)) {\n            nuOpenForm(\'\',\'\', \'59ac07f003930c8\', s,\'Μαθητής\');\n} else{\n    if(nuIsGA()){\n        nuOpenForm(\'\',\'\', \'59ac07f003930c8\', 546,\'Μαθητής\');    \n    } else{\n        alert(\"Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με Μαθητή/Γονέα!\");\n    }\n}  \n','2017-10-14 13:17:07','globeadmin','2020-09-15 22:53:12','globeadmin','2020-09-15 22:53:13','globeadmin'),('59e1e446bfdf322','59e1e446a9cfe90','onclick','var s=get_session_variable(\'student_id\');\n\nif  (($.isNumeric(s)) && (s!=-1)) {\n            nuOpenForm(\'\',\'\', \'59e22ed0a598932\', s,\'Μαθητής\');\n} else{\n    if(nuIsGA()){\n        nuOpenForm(\'\',\'\', \'59e22ed0a598932\', 283,\'Μαθητής\');    \n    } else{\n        alert(\"Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με Μαθητή/Γονέα!\");\n    }\n}  ','2017-10-14 13:17:42','globeadmin','2018-07-05 21:44:18','globeadmin','2018-07-25 09:19:19','globeadmin'),('59e1e461a74e3be','59e1e46193ea74e','onclick','var s=get_session_variable(\'student_id\');\n\nif  (($.isNumeric(s)) && (s!=-1)) {\n            nuOpenForm(\'\',\'\', \'59e22f4f52546e3\', s,\'Μαθητής\');\n} else{\n    if(nuIsGA()){\n        nuOpenForm(\'\',\'\', \'59e22f4f52546e3\', 1,\'Μαθητής\');    \n    } else{\n        alert(\"Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με Μαθητή/Γονέα!\");\n    }\n}  \n\n','2017-10-14 13:18:09','globeadmin','2017-10-24 23:11:01','globeadmin','2018-07-25 09:23:45','globeadmin'),('59e1e47c1f4c665','59e1e47c0b04541','onclick','var s=get_session_variable(\'student_id\');\n\nif  (($.isNumeric(s)) && (s!=-1)) {\n            nuOpenForm(\'\',\'\', \'59e22ff819cd774\', s,\'Μαθητής\');\n} else{\n    if(nuIsGA()){\n        nuOpenForm(\'\',\'\', \'59e22ff819cd774\', 523,\'Μαθητής\');    \n    } else{\n        alert(\"Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με Μαθητή/Γονέα!\");\n    }\n}  ','2017-10-14 13:18:36','globeadmin','2020-11-08 18:32:40','globeadmin','2020-11-08 18:32:40','globeadmin'),('59e1e498e920d08','59e1e498d58f972','onclick','nuOpenForm(\'\', \'\', \'59e90833df79d7d\', \'\', \'Ηλεκτρονικές Ψηφοφορίες & Δηλώσεις\');','2017-10-14 13:19:04','globeadmin','2018-03-10 17:28:34','globeadmin','2021-02-26 20:58:48','globeadmin'),('59e1e4b489e323f','59e1e4b4764cd6a','onclick','var s=get_session_variable(\'student_id\');\n\nif  (($.isNumeric(s)) && (s!=-1)) {\n            nuOpenForm(\'\',\'\', \'59e23027879009a\', s,\'Μαθητής\');\n} else{\n    if(nuIsGA()){\n        nuOpenForm(\'\',\'\', \'59e23027879009a\', 1,\'Μαθητής\');    \n    } else{\n        alert(\"Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με Μαθητή/Γονέα!\");\n    }\n}  ','2017-10-14 13:19:32','globeadmin','2017-10-24 23:13:25','globeadmin','2018-07-25 09:33:32','globeadmin'),('59e213904638498','59e1e3cd5832d70','onmouseover','var pimage=\'boy\';\nvar g = $(\'#student_gender\').val();\nif(g==\'\' || g==\'Α\'){\n    pimage=\'boy\';    \n} else {\n    pimage=\'girl\';    \n}\ndocument.getElementById(\'img_ucard_id\').src=\'images/\'+pimage+\'b.png\';\nthis.style.cursor=\'pointer\';','2017-10-14 16:39:28','globeadmin','2017-10-24 23:02:34','globeadmin','2022-01-08 22:17:26','globeadmin'),('59e21390509f624','59e1e3cd5832d70','onmouseout','var pimage=\'boy\';\nvar g = $(\'#student_gender\').val();\nif(g==\'\' || g==\'Α\'){\n    pimage=\'boy\';    \n} else {\n    pimage=\'girl\';    \n}\ndocument.getElementById(\'img_ucard_id\').src=\'images/\'+pimage+\'.png\';\nthis.style.cursor=\'auto\';','2017-10-14 16:39:28','globeadmin','2017-10-24 23:02:34','globeadmin','2022-01-08 22:17:26','globeadmin'),('59e31ca540ffbb6','59e31ca52d77dc4','onclick','if(\'#nu_user_group#\'==\'Parents\'){// || nuIsGA()){ \n    var email_address = \'#parent_email#\';\n    if(email_address.trim()==\'\'){\n        var teacher_name = $(\'#teacher_id\').val();\n        var msg = \'Προσοχή : Δεν υπάρχει για εσάς καταχωρημένη διεύθυνση email.\\nΠαρακαλώ γνωστοποιείστε την διεύθυνση email σας στον «Υπεύθυνο Καθηγητή»\'+(teacher_name.trim()==\'\' ? \'\' : \' (\'+teacher_name+\')\');\n        alert(msg);    \n    } else {\n        nuOpenFormInFrame(\'584128b691c711a\', \'#RECORD_ID#\');\n    }    \n} else {\n    var email_address = \'#email#\';\n    if(email_address.trim()==\'\'){\n        var teacher_name = $(\'#teacher_id\').val();\n        var msg = \'Προσοχή : Δεν υπάρχει για εσάς καταχωρημένη διεύθυνση email.\\nΠαρακαλώ γνωστοποιείστε την διεύθυνση email σας στον «Υπεύθυνο Καθηγητή»\'+(teacher_name.trim()==\'\' ? \'\' : \' (\'+teacher_name+\')\');\n        alert(msg);    \n    } else {\n        nuOpenFormInFrame(\'584117d1d046e30\', \'#RECORD_ID#\');    \n    }    \n}\n\n','2017-10-15 11:30:29','globeadmin','2022-01-08 22:18:33','globeadmin','2022-01-08 22:18:33','globeadmin'),('59e31cec1ea2521','59e31cec0b1f451','onclick','nuOpenForm(\'\',\'\', \'54a65ecc3f14737\', \'#nu_user_id#\',\'Στοιχεία Λογαριασμού\');\n','2017-10-15 11:31:40','globeadmin','2017-10-15 11:31:40','globeadmin','2017-10-21 10:59:19','globeadmin'),('59f849d6b9469b0','59f849d6a5c4130','onblur','nuFORM.edited = 0;','2017-10-31 12:00:54','globeadmin','2017-10-31 12:00:54','globeadmin','2019-02-10 00:07:38','globeadmin'),('59f849d6c306b65','59f849d6a5c4130','onchange','sumoSetHashSelectedIds(this);','2017-10-31 12:00:54','globeadmin','2017-10-31 12:00:54','globeadmin','2019-02-10 00:07:38','globeadmin'),('59f84bbbb0b4599','59f84bbb9d30ffe','onclick','var ids = nuGetHash(\'student_id_select_sumo\');\n\nif(ids !=\'\'){\n    if (confirm(\'Θα εισαχθούν όλοι οι επιλεγμένοι μαθητές στο τμήμα!\\nΕίστε σίγουρος?\')) {\n        nuAjax(\'add_students_to_class\' , \'add_students_result\');\n    }\n} else {\n    alert(\'Παρακαλώ επιλέξτε πρώτα τους μαθητές που θέλετε να προσθέσετε στο τμήμα!\');    \n}','2017-10-31 12:08:59','globeadmin','2017-10-31 16:26:53','globeadmin','2018-07-17 00:57:21','globeadmin'),('59f84c791dbeac2','59f84c790a3bb16','onclick','var iframe = document.getElementById(\'student_iframe\');\nvar innerDoc = (iframe.contentDocument) ? iframe.contentDocument : iframe.contentWindow.document;\n\nvar c1 = innerDoc.getElementsByClassName(\'chk_1\');\nvar id_array = [];\n\nfor(var i=0, n=c1.length;i<n;i++) {\n    if(c1[i].checked){\n        id_array.push(c1[i].id);\n    }\n}\n\nvar id_list = id_array.join(\',\');\n        \nif(id_list!=\'\'){\n    if(confirm(\'Θα αφαιρεθούν όλοι οι επιλεγμένοι μαθητές από το τμήμα!\\nΕίστε σίγουρος;\')){\n        nuSetHash(\'id_list\', id_list);\n        nuAjax(\'remove_students_from_class\',\'remove_students_result\');\n    }\n} else {\n    alert(\'Παρακαλώ επιλέξτε πρώτα τους μαθητές που θέλετε να αφαιρέσετε!\');    \n}\n','2017-10-31 12:12:09','globeadmin','2017-10-31 16:56:54','globeadmin','2018-07-17 00:57:35','globeadmin'),('59e7ad3564cc10b','59e7ad3533fac86','onblur','nuFORM.edited = 0;','2017-10-18 22:36:21','globeadmin','2017-10-18 22:36:21','globeadmin','2017-11-03 07:40:39','globeadmin'),('59e7ad356e9c6b6','59e7ad3533fac86','onchange','sumoSetHashSelectedIds(this);','2017-10-18 22:36:21','globeadmin','2017-10-18 22:36:21','globeadmin','2017-11-03 07:40:39','globeadmin'),('59e7aedbbe1cf7e','59e7aedbaa9a31d','onblur','nuFORM.edited = 0;','2017-10-18 22:43:23','globeadmin','2017-10-18 22:43:23','globeadmin','2017-11-03 07:40:05','globeadmin'),('59e7aedbc7e6367','59e7aedbaa9a31d','onchange','sumoSetHashSelectedIds(this);','2017-10-18 22:43:23','globeadmin','2017-10-18 22:43:23','globeadmin','2017-11-03 07:40:05','globeadmin'),('59e7af646855485','59e7af6454e1072','onblur','nuFORM.edited = 0;','2017-10-18 22:45:40','globeadmin','2017-10-18 22:45:40','globeadmin','2017-10-31 00:02:40','globeadmin'),('59e7af8854bfe00','59e7af884136d36','onblur','nuFORM.edited = 0;','2017-10-18 22:46:16','globeadmin','2017-10-18 22:46:16','globeadmin','2017-10-31 00:02:57','globeadmin'),('59e7b0f0ba74703','59e7b0f0a6dbecb','onclick','function check_fields(){\n    \n    var s1 = document.getElementById(\'selection1\');\n    var s = s1.options[s1.selectedIndex].value;\n    \n    if (s==\'\'){\n        alert(\'Παρακαλώ επιλέξτε σε ποιους θα γίνει η κοινοποίηση!\');\n        return 0;\n    } else if(s==1){\n        if(document.getElementById(\'students_check\').checked == false && document.getElementById(\'parents_check\').checked == false){\n            alert(\'Παρακαλώ επιλέξτε αν η κοινοποίηση θα γίνει «σε Μαθητές» ή και «σε Γονείς»!\'); \n            return 0;\n        } else {\n            var grade_id_list = nuGetHash(\'grade_id_select_sumo\');\n            if (typeof grade_id_list == \'undefined\' || grade_id_list.trim()==\'\'){\n                alert(\'Παρακαλώ επιλέξτε τάξεις!\');\n                return 0;\n            }\n        }     \n    } else if(s==2){\n        if(document.getElementById(\'students_check\').checked == false && document.getElementById(\'parents_check\').checked == false){\n            alert(\'Παρακαλώ επιλέξτε αν η κοινοποίηση θα γίνει «σε Μαθητές» ή και «σε Γονείς»!\');\n            return 0;\n        } else {\n            var class_id_list = nuGetHash(\'class_id_select_sumo\');\n            if (typeof class_id_list == \'undefined\' || class_id_list.trim()==\'\'){\n                alert(\'Παρακαλώ επιλέξτε τμήματα!\');\n                return 0;\n            }\n        }     \n    } else if(s==3){\n        if(document.getElementById(\'students_check\').checked == false && document.getElementById(\'parents_check\').checked == false){\n            alert(\'Παρακαλώ επιλέξτε αν η κοινοποίηση θα γίνει «σε Μαθητές» ή και «σε Γονείς»!\');\n            return 0;\n        } else {\n            var student_id_list = nuGetHash(\'student_id_select_sumo\');\n            if (typeof student_id_list == \'undefined\' || student_id_list.trim()==\'\'){\n                alert(\'Παρακαλώ επιλέξτε μαθητές!\');\n                return 0;\n            }\n        }     \n    } else {\n        alert(\'Δεν είναι έγκυρη επιλογή!\');\n        return 0;\n    }\n    return 1;\n}\nif(check_fields()){\n    showLoader();\n    //nuSetHash(\'inform_check_hash\', (document.getElementById(\'inform_check\').checked) ? \'1\' : \'0\');\n    nuSetHash(\'students_check_hash\', (document.getElementById(\'students_check\').checked) ? \'1\' : \'0\');\n    nuSetHash(\'parents_check_hash\', (document.getElementById(\'parents_check\').checked) ? \'1\' : \'0\');\n    nuAjax(\'add_ballot_voters\',\'add_voters_result\',{async:true});}','2017-10-18 22:52:16','globeadmin','2017-10-24 08:39:44','globeadmin','2017-10-31 00:03:12','globeadmin'),('59e7bc6ad80880a','59e7bc6ababad06','onchange','$(\'[id*=grade_id_select]\').hide();\n$(\'[id*=class_id_select]\').hide();\n$(\'[id*=student_id_select]\').hide();\n    \nvar s = this.options[this.selectedIndex].value;\n\nif(s==1){\n    $(\'[id*=grade_id_select]\').show();    \n} else if(s==2){\n    $(\'[id*=class_id_select]\').show();\n} else if(s==3){\n    $(\'[id*=student_id_select]\').show();\n} ','2017-10-18 23:41:14','globeadmin','2017-10-24 15:41:51','globeadmin','2017-11-03 07:38:12','globeadmin'),('59e7bc995dd88b6','59e7bc994ab8101','onblur','nuFORM.edited = 0;','2017-10-18 23:42:01','globeadmin','2017-10-18 23:42:01','globeadmin','2017-10-31 00:02:23','globeadmin'),('59e7bc9967a880a','59e7bc994ab8101','onchange','sumoSetHashSelectedIds(this);','2017-10-18 23:42:01','globeadmin','2017-10-18 23:42:01','globeadmin','2017-10-31 00:02:23','globeadmin'),('59e7bcdcf02b1ec','59e7bcdcdca89d5','onblur','nuFORM.edited = 0;','2017-10-18 23:43:09','globeadmin','2017-10-18 23:43:09','globeadmin','2017-10-31 00:02:07','globeadmin'),('59e7bcdd05d06e9','59e7bcdcdca89d5','onchange','sumoSetHashSelectedIds(this);','2017-10-18 23:43:09','globeadmin','2017-10-18 23:43:09','globeadmin','2017-10-31 00:02:07','globeadmin'),('59e7c1e55f794a1','59e7c1e53fc06ac','onclick','nuAjax(\'add_students_to_ballot_choices\' , \'add_students_choices_result\');','2017-10-19 00:04:37','globeadmin','2017-10-21 22:33:24','globeadmin','2017-11-18 22:25:22','globeadmin'),('59e7c34074acbda','59e7c34061216b5','onclick','var iframe = document.getElementById(\'results_iframe\');\n\niframe.contentWindow.focus();\niframe.contentWindow.print();','2017-10-19 00:10:24','globeadmin','2017-10-22 17:30:24','globeadmin','2017-10-31 08:21:53','globeadmin'),('59eaff3f72ce3bd','59eaff3f5583afa','onclick','var s=get_session_variable(\'student_id\');\n\nif  (($.isNumeric(s)) && (s!=-1)) {\n    nuOpenFormInFrame(\'566086607663544\',s)\n} else{\n    if(nuIsGA()){\n        nuOpenFormInFrame(\'566086607663544\',1)\n    } else{\n        alert(\"Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με Μαθητή/Γονέα!\");\n    }\n}  ','2017-10-21 11:03:11','globeadmin','2017-10-24 15:57:28','globeadmin','2018-07-25 14:00:10','globeadmin'),('59eb212d2301ce2','59eb212d0f72642','onclick','var iframe = document.getElementById(\'ballot_box_iframe\');\n\nvar ids = iframe.contentWindow.get_selected();\nvar t = iframe.contentWindow.count_selected();\n\nvar msg = (ids == \'-1\' ?  \'Η ψηφήσετε «Λευκό»!\\nΕίστε Σίγουρος;\' : \'Κάνετε \'+t+\' επιλογές!\\n\\nΗ ψήφος σας θα καταχωρηθεί!\\nΕίστε Σίγουρος;\' );\n\nif(confirm(msg)){\n    nuSetHash(\'choices_id_list\', ids);\n    nuAjax(\'student_ballot_vote\',\'vote_result\');\n}','2017-10-21 13:27:57','globeadmin','2017-10-21 16:21:39','globeadmin','2017-10-21 20:23:13','globeadmin'),('59ecba863bed7c7','59ecba86210d70b','onclick','nuOpenForm(\'\', \'\', \'59e5cdf8d43772d\', \'\', \'Ηλεκτρονικές Ψηφοφορίες & Δηλώσεις\');\n','2017-10-22 18:34:30','globeadmin','2018-03-10 17:31:49','globeadmin','2018-07-23 00:29:32','globeadmin'),('59f4bacf4fd3e34','59f4bacf3c4fe05','onclick','nuOpenForm(\'\', \'\', \'59e5cdf8d43772d\', \'\', \'Ηλεκτρονικές Ψηφοφορίες & Δηλώσεις\');','2017-10-28 20:13:51','globeadmin','2018-03-10 17:32:31','globeadmin','2018-03-10 17:32:32','globeadmin'),('59f483967c79390','59f4839668f6cb5','onclick','nuRunPHP(\'show_participants_ballot\',\'participants_iframe\');','2017-10-28 16:18:14','globeadmin','2017-10-28 16:18:14','globeadmin','2017-10-31 09:06:14','globeadmin'),('59f47ffb4b85036','59f47ffb33214c8','onclick','nuRunPHP(\'ballot_google_chart\',\'graph_iframe\');','2017-10-28 16:02:51','globeadmin','2017-10-28 16:08:18','globeadmin','2017-10-28 16:16:31','globeadmin'),('59f481b5d329ffb','59f481b5bf9d01f','onclick','nuRunPHP(\'ballot_results\',\'results_iframe\');','2017-10-28 16:10:13','globeadmin','2017-10-28 16:10:13','globeadmin','2017-10-28 16:14:21','globeadmin'),('59f821620b255ba','59f82161df7848e','onclick','var iframe = document.getElementById(\'participants_iframe\');\nvar innerDoc = (iframe.contentDocument) ? iframe.contentDocument : iframe.contentWindow.document;\n\nvar c1 = innerDoc.getElementsByClassName(\'chk_1\');\nvar id_array = [];\n\nfor(var i=0, n=c1.length;i<n;i++) {\n    if(c1[i].checked){\n        id_array.push(c1[i].id);\n    }\n}\n\nvar id_list = id_array.join(\',\');\n        \nif(id_list!=\'\'){\n    if(confirm(\'Θα αφαιρέσετε τους επιλεγμένους συμμετέχοντες!\\n Είστε σίγουρος;\')){\n        showLoader();\n        nuSetHash(\'id_list\', id_list);\n        //nuSetHash(\'inform_check_hash\', (document.getElementById(\'inform_check\').checked) ? \'1\' : \'0\');\n        nuAjax(\'delete_ballot_voters\',\'delete_voters_result\',{async:true});\n    }\n} else {\n    alert(\'Παρακαλώ επιλέξτε πρώτα τους συμμετέχοντες που θέλετε να αφαιρέσετε!\');    \n}','2017-10-31 09:08:18','globeadmin','2017-10-31 09:09:46','globeadmin','2017-10-31 14:56:56','globeadmin'),('59fe0391b41b3eb','59fe0391a09b48d','onclick','nuRunPHP(\'myFILE\',\'ifile\');\nnuSetHash(\'FILES\' , \'\');\n','2017-11-04 20:14:41','globeadmin','2017-11-04 20:14:41','globeadmin','2017-11-04 20:14:42','globeadmin'),('59fe03d428d315f','59fe03d4090a900','onblur','nuFORM.edited = 0;','2017-11-04 20:15:48','globeadmin','2017-11-04 20:15:48','globeadmin','2017-11-04 20:49:13','globeadmin'),('5a0d31995d163f9','5a0d31993129587','onchange','if(document.getElementById(\'open_absence_books\').checked){\n   nuDisable(\'set_absence_time_limit\',\'00:00:00\');\n} else {\n   nuEnable(\'set_absence_time_limit\',\'00:00:00\');\n}','2017-11-16 08:35:05','globeadmin','2017-11-16 08:35:05','globeadmin','2017-11-16 19:11:25','globeadmin'),('5a0d333c0903149','5a0d333be9a98ad','onchange','if(document.getElementById(\'open_absence_books\').checked){\n   nuDisable(\'set_absence_time_limit\',\'00:00:00\');\n} else {\n   nuEnable(\'set_absence_time_limit\',\'00:00:00\');\n}','2017-11-16 08:42:04','globeadmin','2017-11-16 08:42:04','globeadmin','2018-07-13 10:58:46','globeadmin'),('5a0d34428eb5b3f','5a0d34427b14770','onchange','if(document.getElementById(\'open_absence_books\').checked){\n   nuDisable(\'set_absence_time_limit\',\'00:00:00\');\n} else {\n   nuEnable(\'set_absence_time_limit\',\'00:00:00\');\n}','2017-11-16 08:46:26','globeadmin','2017-11-16 08:46:26','globeadmin','2018-02-05 23:09:34','globeadmin'),('5a1010e9eb997c3','5a1010e9d339207','onclick','nuOpenForm(\'\',\'\', \'5a1011c80a896b3\', \'#RECORD_ID#\',\'Συγχωνεύσεις\');\n\n\n','2017-11-18 12:52:25','globeadmin','2017-11-18 13:04:52','globeadmin','2019-08-06 11:49:51','globeadmin'),('5a102b4abf63cc0','5a102b4aabe23b8','onclick','var c1 = document.getElementById(\'class_id_1\');\nvar cid_1 = c1.options[c1.selectedIndex].value;\nvar ctext_1 = c1.options[c1.selectedIndex].text;\nctext_1 = ctext_1.substring(0,ctext_1.indexOf(\'(\')-1);\n\nvar c2 = document.getElementById(\'class_id_2\');\nvar cid_2 = c2.options[c2.selectedIndex].value;\nvar ctext_2 = c2.options[c2.selectedIndex].text;\nctext_2 = ctext_2.substring(0,ctext_2.indexOf(\'(\')-1);\n\nif(cid_1!=\'\' && cid_2!=\'\'){\n    if(cid_1!=cid_2){\n        if(confirm(\'Προσοχή! Οτιδήποτε σχετίζεται με το τμήμα \'+ctext_2+\' θα συσχετισθεί με το τμήμα \'+ctext_1+\' και στη συνέχεια το τμήμα \'+ctext_2+\' θα διαγραφεί!\\nΗ ενέργεια αυτή δεν μπορεί να αναιρεθεί!\\n Είστε Σίγουρος;\')){\n            nuAjax(\'merge_class\' , \'display_merge_result\');\n        }\n    } else {\n        alert(\'Προσοχή! Δεν μπορείτε να συγχωνεύσετε ένα τμήμα με τον εαυτό του!\');    \n    }\n} else {\n    alert(\'Παρακαλώ επιλέξτε πρώτα τα τμήματα!\');\n}','2017-11-18 14:44:58','globeadmin','2017-11-18 22:47:19','globeadmin','2017-11-26 11:46:45','globeadmin'),('5a1056d4857255b','5a1056d4745b554','onclick','var c1 = document.getElementById(\'teacher_id_1\');\nvar cid_1 = c1.options[c1.selectedIndex].value;\nvar ctext_1 = c1.options[c1.selectedIndex].text;\n\nvar c2 = document.getElementById(\'teacher_id_2\');\nvar cid_2 = c2.options[c2.selectedIndex].value;\nvar ctext_2 = c2.options[c2.selectedIndex].text;\n\nif(cid_1!=\'\' && cid_2!=\'\'){\n    if(cid_1!=cid_2){\n        if(confirm(\'Προσοχή! Οτιδήποτε σχετίζεται με τον καθηγητή \'+ctext_2+\' θα συσχετισθεί με τον καθηγητή \'+ctext_1+\' και στη συνέχεια ο καθηγητής \'+ctext_2+\' θα διαγραφεί!\\nΗ ενέργεια αυτή δεν μπορεί να αναιρεθεί!\\n Είστε Σίγουρος;\')){\n            nuAjax(\'merge_teacher\' , \'display_merge_result\');\n        }\n    } else {\n        alert(\'Προσοχή! Δεν μπορείτε να συγχωνεύσετε ένα καθηγητή με τον εαυτό του!\');    \n    }\n} else {\n    alert(\'Παρακαλώ επιλέξτε πρώτα τους καθηγητές!\');\n}','2017-11-18 17:50:44','globeadmin','2017-11-18 22:46:54','globeadmin','2017-11-26 11:47:02','globeadmin'),('5a10571498e42d1','5a10571485593e0','onclick','var c1 = document.getElementById(\'subject_id_1\');\nvar cid_1 = c1.options[c1.selectedIndex].value;\nvar ctext_1 = c1.options[c1.selectedIndex].text;\n\nvar c2 = document.getElementById(\'subject_id_2\');\nvar cid_2 = c2.options[c2.selectedIndex].value;\nvar ctext_2 = c2.options[c2.selectedIndex].text;\n\nif(cid_1!=\'\' && cid_2!=\'\'){\n    if(cid_1!=cid_2){\n        if(confirm(\'Προσοχή! Οτιδήποτε σχετίζεται με το μάθημα \'+ctext_2+\' θα συσχετισθεί με το μάθημα \'+ctext_1+\' και στη συνέχεια το μάθημα \'+ctext_2+\' και τα σχόλια για τους μαθητές που το συνοδεύουν, θα διαγραφούν!\\nΗ ενέργεια αυτή δεν μπορεί να αναιρεθεί!\\n Είστε Σίγουρος;\')){\n            nuAjax(\'merge_subject\' , \'display_merge_result\');\n        }\n    } else {\n        alert(\'Προσοχή! Δεν μπορείτε να συγχωνεύσετε ένα μάθημα με τον εαυτό του!\');    \n    }\n} else {\n    alert(\'Παρακαλώ επιλέξτε πρώτα τα μαθήματα!\');\n}','2017-11-18 17:51:48','globeadmin','2017-11-26 10:33:07','globeadmin','2020-09-27 18:27:00','globeadmin'),('5a12e47b194ebe9','5a12e47b05d08f4','onclick','nuRunPHP(\'find_calendar_test_dates\',\'search_iframe\');','2017-11-20 16:19:39','globeadmin','2017-11-20 20:00:34','globeadmin','2017-11-20 20:16:49','globeadmin'),('5a193ae6e6709e4','5a193ad13438b95','onclick','nuRunPHP(\'search_card\',\'search_iframe\');','2017-11-25 11:41:58','globeadmin','2017-11-25 13:23:46','globeadmin','2018-07-12 19:50:42','globeadmin'),('5a193b4575db8fa','5a193b4564bb6b6','onclick','if(confirm(\'Όλες οι καταχωρίσεις θα διαγραφουν!\\nΕίστε Σίγουρος;\')){\n    nuRunPHP(\'clear_card\',\'search_iframe\');    \n}\n','2017-11-25 11:43:33','globeadmin','2017-11-28 08:21:56','globeadmin','2017-11-28 08:21:57','globeadmin'),('5a4e654ed030f28','580ce6fd065f33e','onchange','sumoSetHashSelectedIds(this)','2018-01-04 19:33:02','globeadmin','2018-01-04 19:33:02','globeadmin','2021-10-24 21:42:34','globeadmin'),('5a4e8a79ef53367','5a4e8a79dbdc9cf','onclick','open_sms_frame($(\'#phone1\').val());\n','2018-01-04 22:11:38','globeadmin','2018-01-04 22:11:38','globeadmin','2018-01-04 22:59:40','globeadmin'),('5a4e919dbe19cec','5a4e919daa99f5f','onclick','open_email_frame($(\'#email\').val());','2018-01-04 22:42:05','globeadmin','2018-01-04 22:42:05','globeadmin','2018-01-15 20:08:47','globeadmin'),('5a4e9240c4f41d8','5a4e9240b1769bf','onclick','open_email_frame($(\'#parent_email\').val());','2018-01-04 22:44:48','globeadmin','2018-01-04 22:44:48','globeadmin','2018-01-15 20:08:14','globeadmin'),('5a4e940f3d54faf','5a4e940f29cdaaf','onclick','open_sms_frame($(\'#phone2\').val());\n','2018-01-04 22:52:31','globeadmin','2018-01-04 22:52:31','globeadmin','2018-01-04 22:53:00','globeadmin'),('5a4e9453001b01a','5a4e9452dbd9725','onclick','open_sms_frame($(\'#mobile\').val());\n','2018-01-04 22:53:39','globeadmin','2018-01-04 22:53:39','globeadmin','2018-01-04 22:54:37','globeadmin'),('5a4e94b046a13db','5a4e94b03326875','onclick','open_sms_frame($(\'#parent_phone1\').val());\n','2018-01-04 22:55:12','globeadmin','2018-01-04 22:55:12','globeadmin','2018-01-04 22:55:42','globeadmin'),('5a4e94e6aa920b6','5a4e94e6970f78a','onclick','open_sms_frame($(\'#parent_phone2\').val());\n','2018-01-04 22:56:06','globeadmin','2018-01-04 22:56:06','globeadmin','2018-01-04 22:56:33','globeadmin'),('5a4e951a9d191b2','5a4e951a884cf7f','onclick','open_sms_frame($(\'#parent_phone3\').val());\n','2018-01-04 22:56:58','globeadmin','2018-01-04 22:56:58','globeadmin','2018-01-05 23:35:57','globeadmin'),('5a4f538709beafe','5a4f5386ea563e7','onclick','showLoader();\nnuRunPHP(\'search_penalty\',\'search_iframe\');\nnuAjax(\'penalty_export\',\'get_excel_file\',{async:true});','2018-01-05 12:29:27','globeadmin','2018-01-05 23:14:46','globeadmin','2018-02-05 23:15:17','globeadmin'),('5a5240fc4bf8fd6','5a5240fc275f443','onclick','nuPrintPDF(\'penalty_book\');\nnuRunPHP(\'search_penalty\',\'search_iframe\');','2018-01-07 17:47:08','globeadmin','2018-01-07 20:55:56','globeadmin','2021-10-24 21:47:17','globeadmin'),('5a52720bd9c39b5','5a52720bade5ef3','onblur','nuFORM.edited = 0;','2018-01-07 21:16:27','globeadmin','2018-01-07 21:16:27','globeadmin','2021-10-24 21:48:11','globeadmin'),('5a54bedfa6d7abf','5a54bedf84ac6e4','onclick','nuOpenForm(\'\',\'\', \'5a4e32f55d7faf5\', \'\',\'Τύποι Ποινών\');\n\n\n','2018-01-09 15:08:47','globeadmin','2018-01-09 15:12:55','globeadmin','2018-01-09 19:25:34','globeadmin'),('5a54bf38204fc93','5a54bf380cc7513','onclick','nuOpenForm(\'\',\'\', \'5a54c08c836c142\', \'1\',\'Γενικές Παράμετροι Σχολείου\');\n\n\n','2018-01-09 15:10:16','globeadmin','2018-01-09 20:55:52','globeadmin','2018-01-09 21:01:59','globeadmin'),('5a54e28f6ceffe8','5a54e28f59749d3','onclick','if(nuIsGA()){\n    nuOpenForm(\'\',\'\', \'5a36abffedf9461\', \'26\',\'Ενημέρωση Συστήματος\');\n} else {\n    alert(\'Λειτουργία υπό κατασκευή!\');    \n}','2018-01-09 17:41:03','globeadmin','2018-01-09 18:48:14','globeadmin','2018-02-04 19:14:01','globeadmin'),('5a574c2718bd2a0','5650b0f292b8acb','onchange','if(is_type_allday(this.value)){\n    nuDisable(\'period_id\',\'\');\n} else {\n    nuEnable(\'period_id\');\n}','2018-01-11 13:36:07','globeadmin','2018-01-11 13:40:29','globeadmin','2018-03-10 16:57:33','globeadmin'),('5a5ce2bcc599164','5a5ce2bca5d9736','onblur','nuFORM.edited = 0;','2018-01-15 19:19:56','globeadmin','2018-01-15 19:19:56','globeadmin','2021-10-24 21:44:27','globeadmin'),('5a72e2958b7d327','5a72e29570a3e24','onclick','nuOpenForm(\'\',\'\', \'580cdf151b06780\', \'#RECORD_ID#\',\'Ποινές\');','2018-02-01 11:49:09','globeadmin','2018-02-01 11:49:09','globeadmin','2022-01-13 09:25:20','globeadmin'),('5a774099257e04b','5a7740991218b05','onclick','nuOpenForm(\'\',\'\', \'5a7738b60e35797\', \'1\',\'Επιλογές Σύνδεσης Χρηστών\');\n','2018-02-04 19:19:21','globeadmin','2018-02-04 19:22:34','globeadmin','2018-02-04 19:24:52','globeadmin'),('5a78c83a6d00a40','5a78c83a4ae8571','onchange','if(document.getElementById(\'open_absence_books\').checked){\n   nuDisable(\'set_absence_time_limit\',\'00:00:00\');\n} else {\n   nuEnable(\'set_absence_time_limit\',\'00:00:00\');\n}','2018-02-05 23:10:18','globeadmin','2018-02-05 23:10:18','globeadmin','2019-11-06 09:59:11','globeadmin'),('5a78d60b62ef93c','5a78d60b4a8b7b5','onchange','if(document.getElementById(\'open_absence_books\').checked){\n   nuDisable(\'set_absence_time_limit\',\'00:00:00\');\n} else {\n   nuEnable(\'set_absence_time_limit\',\'00:00:00\');\n}','2018-02-06 00:09:15','globeadmin','2018-02-06 00:09:15','globeadmin','2018-07-13 19:17:42','globeadmin'),('5ad86b78dec207f','5ad86b78b7564c2','onchange','var s = this.options[this.selectedIndex].value;\n\nif(s!=\'\'){\n    $(\'#end_time\').val(s);\n}','2018-04-19 13:12:08','globeadmin','2018-04-19 13:21:54','globeadmin','2020-09-14 22:50:27','globeadmin'),('5b0eefff4776555','5b0eefff2ca187e','onblur','nuFORM.edited = 0;','2018-05-30 21:39:59','globeadmin','2018-05-30 21:39:59','globeadmin','2018-06-01 10:06:00','globeadmin'),('5b0eefff513a54b','5b0eefff2ca187e','onchange','sumoSetHashSelectedIds(this);','2018-05-30 21:39:59','globeadmin','2018-05-30 21:39:59','globeadmin','2018-06-01 10:06:00','globeadmin'),('5b0ef3078a10523','5b0ef30776c3af7','onblur','nuFORM.edited = 0;','2018-05-30 21:52:55','globeadmin','2018-05-30 21:52:55','globeadmin','2018-06-03 01:26:08','globeadmin'),('5b0efc216269b8f','5b0ef30776c3af7','onchange','var s = this.options[this.selectedIndex].value;\n\n$(\'[id*=class_id]\').hide(); \n$(\'[id*=show_only_sums]\').hide();\n$(\'[id*=student_id]\').hide();  \n$(\'[id*=show_zero]\').hide();\n$(\'[id*=max_rows]\').hide();\n\nif(s==\'1\'){\n    $(\'[id*=class_id]\').show(); \n    $(\'[id*=show_only_sums]\').show();\n}  else if(s==\'2\'){\n    $(\'[id*=student_id]\').show();\n    $(\'[id*=show_zero]\').show();\n    $(\'[id*=max_rows]\').show();\n} ','2018-05-30 22:31:45','globeadmin','2018-06-01 15:03:24','globeadmin','2018-06-03 01:26:08','globeadmin'),('5b10f0d2afbf702','5b10f0d299cb24c','onblur','nuFORM.edited = 0;','2018-06-01 10:08:02','globeadmin','2018-06-01 10:08:02','globeadmin','2018-06-01 15:06:53','globeadmin'),('5b112b93a270f9a','5b112b9376bce83','onblur','nuFORM.edited = 0;','2018-06-01 14:18:43','globeadmin','2018-06-01 14:18:43','globeadmin','2018-06-01 15:14:32','globeadmin'),('5b116c9a370d127','5b116c9a1c2015a','onblur','nuFORM.edited = 0;','2018-06-01 18:56:10','globeadmin','2018-06-01 18:56:10','globeadmin','2018-12-03 16:31:11','globeadmin'),('5b116cb36f0dc31','5b116cb35b86ec3','onblur','nuFORM.edited = 0;','2018-06-01 18:56:35','globeadmin','2018-06-01 18:56:35','globeadmin','2018-06-03 01:18:16','globeadmin'),('5b116e314e793bd','5b116e3131282e2','onclick','showLoader();\nnuAjax(\'absence_class_book\',\'get_zip_file\',{async:true});\n\n\n//nuRunPHP(\'absence_class_book\',\'search_iframe\');','2018-06-01 19:02:57','globeadmin','2018-06-02 08:49:17','globeadmin','2018-06-02 08:49:18','globeadmin'),('5b1f9aac5907048','5b1f9aac45942e7','onclick','nuOpenFormInFrame(\'5b1f98c3701d658\', $(\'#user_id\').val());','2018-06-12 13:04:28','globeadmin','2018-07-29 10:38:50','globeadmin','2018-07-29 10:38:51','globeadmin'),('5b213e50a20cfb7','5b213e508e742fd','onclick','nuOpenFormInFrame(\'5b1f98c3701d658\', $(\'#user_id\').val());','2018-06-13 18:54:56','globeadmin','2018-07-29 22:18:52','globeadmin','2018-07-29 22:18:52','globeadmin'),('5b51f90868dc33b','5b51eaab0a419a2','ondblclick','nuOpenAce(\"SQL\", this.id, \"\");','2018-07-20 18:00:24','globeadmin','2018-07-20 18:00:24','globeadmin','2018-07-20 18:11:32','globeadmin'),('5b51fc8b5d35768','5b51eba8974ad0d','ondblclick','nuOpenAce(\"Javascript\", this.id, \"Event Javascript\");','2018-07-20 18:15:23','globeadmin','2018-07-20 18:15:23','globeadmin','2018-07-20 18:16:40','globeadmin'),('5b51fcaaef9e641','5b51ebedcf579d1','ondblclick','nuOpenAce(\"Javascript\", this.id, \"Event Javascript\");','2018-07-20 18:15:54','globeadmin','2018-07-20 18:15:55','globeadmin','2018-07-20 18:15:55','globeadmin'),('5b51fcafb292c9f','5b51ebd72959c87','ondblclick','nuOpenAce(\"Javascript\", this.id, \"Event Javascript\");','2018-07-20 18:15:59','globeadmin','2018-07-20 18:15:59','globeadmin','2018-07-20 18:16:00','globeadmin'),('5b213ef8585cc5b','5b213ef844df1b4','onclick','nuOpenFormInFrame(\'5b1f98c3701d658\', $(\'#parent_user_id\').val());','2018-06-13 18:57:44','globeadmin','2018-07-29 22:19:32','globeadmin','2018-08-06 22:00:32','globeadmin'),('5b3805dc754e084','552d12d18064ae6','onchange','var s = this.options[this.selectedIndex].value;\n\nhide_all();\n\nif(s==7){\n    $(\'[id*=sms_disp]\').show();    \n} else if (s==3 || s==4){\n    $(\'[id*=label1]\').show();\n    $(\'[id*=framehtml]\').show();\n    $(\'[id*=manager_sign]\').show();\n    $(\'[id*=asistmanager_sign]\').show();\n    $(\'[id*=teacher_sign]\').show();    \n}\n\n\n\n\n\n\n','2018-07-01 01:36:12','globeadmin','2018-08-05 11:18:04','globeadmin','2018-08-05 11:18:05','globeadmin'),('5c06d4dd6ad1768','5c06d4dd59bdbe3','onchange','var c = document.getElementById(\'class_id\');\nc.selectedIndex=0;\n\nnuRunPHP(\'create_student_advisor_list\',\'search_iframe\');','2018-12-04 21:26:21','globeadmin','2018-12-04 22:56:15','globeadmin','2018-12-08 20:49:42','globeadmin'),('5c06d3d3f11b813','5c06d3d3e4e3187','onchange','var g = document.getElementById(\'grade_id\');\ng.selectedIndex=0;\n\nnuRunPHP(\'create_student_advisor_list\',\'search_iframe\');','2018-12-04 21:21:56','globeadmin','2018-12-04 22:55:53','globeadmin','2018-12-08 20:11:33','globeadmin'),('5c06d40da7dcc8d','5c06d40d96c36fb','onclick','var id_array = [];\n\nvar t_id = nuGetHash(\'advisor_id_sumo\');\n\nvar iframe = document.getElementById(\'search_iframe\');\nvar innerDoc = (iframe.contentDocument) ? iframe.contentDocument : iframe.contentWindow.document;\n\nvar c1 = innerDoc.getElementsByClassName(\'chk_1\');\n        \nfor(var i=0, n=c1.length;i<n;i++) {\n    if(c1[i].checked){\n        id_array.push(c1[i].id);\n    }\n} \n    \nids = id_array.join();\n    \nif(typeof id_array != \'undefined\' && id_array != null && id_array.length > 0){\n    if(typeof t_id == \'undefined\' || t_id == null || t_id==\'\'){\n        msg = \'Θα οριστεί ότι \'+id_array.length+\' μαθητές δεν θα έχουν ατομικό σύμβουλο!\\nΕίστε σίγουρος;\'    \n    } else if(!t_id.includes(\',\')){\n        msg = \'Ο επιλεγμένος καθηγητής θα οριστεί ως ατομικός σύμβουλος για \'+id_array.length+\' μαθητές!\\nΕίστε σίγουρος;\'    \n    } else {\n        msg = \'Οι επιλεγμένοι καθηγητές θα οριστούν με κλήρωση ως ατομικοί σύμβουλοι σε \'+id_array.length+\' μαθητές!\\nΕίστε σίγουρος;\';\n    }\n    \n    if(confirm(msg)){\n        nuSetHash(\'student_id_list\', ids);\n        nuRunPHP(\'set_students_advisor\',\'search_iframe\');\n    }\n            \n} else {\n    alert (\'Παρακαλώ επιλέξτε πρώτα τους μαθητές!\');\n}','2018-12-04 21:22:53','globeadmin','2018-12-04 23:15:57','globeadmin','2020-09-19 17:13:08','globeadmin'),('5c06d8c75267500','5c06d3ef3c6e67b','onchange','sumoSetHashSelectedIds(this);','2018-12-04 21:43:03','globeadmin','2018-12-04 21:43:03','globeadmin','2018-12-08 20:24:07','globeadmin'),('5c0c1265bdd337c','5c0c0b0b7be89df','onchange','nuRunPHP(\'create_student_advisor_list\',\'search_iframe\');','2018-12-08 20:50:13','globeadmin','2018-12-08 20:50:13','globeadmin','2018-12-08 20:50:14','globeadmin'),('6175a8f15d1f4f0','6175a8f15200034','onblur','nuFORM.edited = 0;','2021-10-24 21:41:53','globeadmin','2021-10-24 21:41:53','globeadmin','2022-01-07 20:35:39','globeadmin'),('5c84d4d72625a04','5c84d4d70186858','onblur','nuFORM.edited = 0;','2019-03-10 11:11:51','globeadmin','2019-03-10 11:11:51','globeadmin','2019-03-10 11:11:52','globeadmin'),('5c84d4d7325a645','5c84d4d70186858','onchange','sumoSetHashSelectedIds(this);','2019-03-10 11:11:51','globeadmin','2019-03-10 11:11:51','globeadmin','2019-03-10 11:11:52','globeadmin'),('5dc273ca291ed00','5dc273ca1371406','onblur','nuFORM.edited = 0;','2019-11-06 09:18:34','globeadmin','2019-11-06 09:18:34','globeadmin','2019-11-06 09:53:42','globeadmin'),('5dc273ca2bfbb9d','5dc273ca1371406','onchange','sumoSetHashSelectedIds(this);','2019-11-06 09:18:34','globeadmin','2019-11-06 09:18:34','globeadmin','2019-11-06 09:53:42','globeadmin'),('5dc273ea18c3228','5dc273e9f1159ed','onblur','nuFORM.edited = 0;','2019-11-06 09:19:06','globeadmin','2019-11-06 09:19:06','globeadmin','2019-11-06 09:39:31','globeadmin'),('5dc273ea1e1f0df','5dc273e9f1159ed','onchange','sumoSetHashSelectedIds(this);','2019-11-06 09:19:06','globeadmin','2019-11-06 09:19:06','globeadmin','2019-11-06 09:39:31','globeadmin'),('5dc278f0a4cf966','5dc278f099b40ee','onblur','nuFORM.edited = 0;','2019-11-06 09:40:32','globeadmin','2019-11-06 09:40:32','globeadmin','2019-11-06 09:55:22','globeadmin'),('5dc278f0a7b9491','5dc278f099b40ee','onchange','sumoSetHashSelectedIds(this);','2019-11-06 09:40:32','globeadmin','2019-11-06 09:40:32','globeadmin','2019-11-06 09:55:22','globeadmin'),('5dc28887bccec6f','5dc27c99ea8ebf5','onclick','showLoader();\nnuAjax(\'students_excel_export\',\'get_excel_file\',{async:true});','2019-11-06 10:47:03','globeadmin','2019-11-06 10:47:03','globeadmin','2021-04-01 20:18:25','globeadmin'),('5e8392b3ccc5e08','5e8392b3bb14cfd','onclick','nuOpenForm(\'\',\'\', \'5e85a2a072783b3\', \'#RECORD_ID#\',\'Διασύνδεση με Open eClass\');','2020-03-31 21:57:55','globeadmin','2020-04-02 11:34:25','globeadmin','2020-08-24 19:34:09','globeadmin'),('5e85bd02b2f5a84','5e85bd02a820251','onblur','nuFORM.edited = 0;','2020-04-02 13:22:58','globeadmin','2020-04-02 13:22:58','globeadmin','2020-04-05 13:49:17','globeadmin'),('5e85bd02b5d2ef4','5e85bd02a820251','onchange','sumoSetHashSelectedIds(this);','2020-04-02 13:22:58','globeadmin','2020-04-02 13:22:58','globeadmin','2020-04-05 13:49:17','globeadmin'),('5e85c1bd7e9417f','5e85c1bd73f2a6d','onblur','nuFORM.edited = 0;','2020-04-02 13:43:09','globeadmin','2020-04-02 13:43:09','globeadmin','2020-08-25 09:33:44','globeadmin'),('5e85c1bd816b3a4','5e85c1bd73f2a6d','onchange','sumoSetHashSelectedIds(this);','2020-04-02 13:43:09','globeadmin','2020-04-02 13:43:09','globeadmin','2020-08-25 09:33:44','globeadmin'),('5e85cf7678db470','5e85cf766d277cf','onblur','nuFORM.edited = 0;','2020-04-02 14:41:42','globeadmin','2020-04-02 14:41:42','globeadmin','2020-08-25 09:49:11','globeadmin'),('5e85cf767bbf36f','5e85cf766d277cf','onchange','sumoSetHashSelectedIds(this);','2020-04-02 14:41:42','globeadmin','2020-04-02 14:41:42','globeadmin','2020-08-25 09:49:11','globeadmin'),('5e86162a265a54d','5e85b2af3452fbf','onclick','nuAjax(\'eclass_db_check\',\'db_check_result\');','2020-04-02 19:43:22','globeadmin','2020-04-02 19:43:22','globeadmin','2020-04-05 13:47:58','globeadmin'),('5e87721c50e2fbe','5e87721c4558a90','onclick','nuRunPHP(\'eclass_get_hierarchy\',\'hierarchy_iframe\');\n\n','2020-04-03 20:27:56','globeadmin','2020-04-04 10:57:22','globeadmin','2020-04-04 10:57:22','globeadmin'),('5e89b2ea1153b68','5e86099653e5c9e','onclick','nuSetHash(\'is_teacher\',\'1\');\n\nvar iframe = document.getElementById(\'hierarchy_iframe\');\nif(typeof iframe.contentWindow.get_selection === \'function\' ){\n    var hierarchy_id = iframe.contentWindow.get_selection();\n    nuSetHash(\'hierarchy_id\',hierarchy_id);\n    nuAjax(\'eclass_send_users\',\'send_users_result\');\n} else {\n    alert(\"Παρακαλώ πραγματοποιήστε πρώτα τη σύνδεση με τη βάση δεδομένων του Eclass!\");\n}\n\n','2020-04-05 13:28:58','globeadmin','2020-08-22 11:24:51','globeadmin','2020-08-22 11:24:51','globeadmin'),('5e89b9d46c96445','5e8609a4cf18fb5','onclick','nuSetHash(\'is_teacher\',\'0\');\n\nvar iframe = document.getElementById(\'hierarchy_iframe\');\nif(typeof iframe.contentWindow.get_selection === \'function\' ){\n    var hierarchy_id = iframe.contentWindow.get_selection();\n    nuSetHash(\'hierarchy_id\',hierarchy_id);\n    nuAjax(\'eclass_send_users\',\'send_users_result\');\n} else {\n    alert(\"Παρακαλώ πραγματοποιήστε πρώτα τη σύνδεση με τη βάση δεδομένων του Eclass!\");\n}','2020-04-05 13:58:28','globeadmin','2020-08-22 11:25:59','globeadmin','2020-08-22 11:26:00','globeadmin'),('5f3a665c6463b76','5e8609b2a822a5d','onclick','var iframe = document.getElementById(\'hierarchy_iframe\');\nif(typeof iframe.contentWindow.get_selection === \'function\' ){\n    var hierarchy_id = iframe.contentWindow.get_selection();\n    showLoader();\n    nuSetHash(\'hierarchy_id\',hierarchy_id);\n    nuAjax(\'eclass_send_lessons\',\'send_lessons_result\',{async:true});\n} else {\n    alert(\"Παρακαλώ πραγματοποιήστε πρώτα τη σύνδεση με τη βάση δεδομένων του Eclass!\");\n}\n','2020-08-17 14:13:32','globeadmin','2020-08-25 11:29:32','globeadmin','2020-08-25 11:29:32','globeadmin'),('5f5fc9298072027','5f5fc9296b31c19','onchange','var s = this.options[this.selectedIndex].value;\n\nif(s!=\'\'){\n    $(\'#start_time\').val(s);\n}','2020-09-14 22:48:57','globeadmin','2020-09-14 22:48:57','globeadmin','2020-09-14 23:03:50','globeadmin'),('5f5fc994dbfa61b','5f5fc994d09a4ab','onchange','var s = this.options[this.selectedIndex].value;\n\nif(s!=\'\'){\n    $(\'#end_time\').val(s);\n}','2020-09-14 22:50:44','globeadmin','2020-09-14 22:50:44','globeadmin','2020-09-14 22:50:45','globeadmin'),('5f611dceb12608d','5f60a3222e3cfc5','onclick','var teacher_id_list = nuGetHash(\'teacher_id_sumo\');\n   \nif (typeof teacher_id_list == \'undefined\'){\n    alert(\'Παρακαλώ επιλεξτε πρώτα καθηγητή/ες!\');    \n} else if(teacher_id_list.trim()==\'\'){\n    alert(\'Παρακαλώ επιλεξτε πρώτα καθηγητή/ες!\');    \n} else if($(\'#from_date\').val()==\'\'){\n    alert(\'Παρακαλώ επιλεξτε πρώτα ημερομηνία «Από»\');    \n} else if($(\'#to_date\').val()==\'\'){\n    alert(\'Παρακαλώ επιλεξτε πρώτα ημερομηνία «Έως»\');    \n} else {\n    nuRunPHP(\'search_appointment\', \'search_iframe\');\n}\n','2020-09-15 23:02:22','globeadmin','2020-09-25 10:44:46','globeadmin','2020-12-21 21:12:17','globeadmin'),('5f633c171683bc0','5f609ac070dc411','onblur','nuFORM.edited = 0;','2020-09-17 13:36:07','globeadmin','2020-09-17 13:36:07','globeadmin','2020-09-25 10:40:57','globeadmin'),('5f633c1719607ae','5f609ac070dc411','onchange','sumoSetHashSelectedIds(this);','2020-09-17 13:36:07','globeadmin','2020-09-17 13:36:07','globeadmin','2020-09-25 10:40:57','globeadmin'),('5f6733fe57fa426','5f6712b3cc23204','onclick','nuRunPHP(\'teacher_appointments\',\'appointments_iframe\');','2020-09-20 13:50:38','globeadmin','2020-09-20 13:50:38','globeadmin','2020-09-22 22:48:11','globeadmin'),('5f683ed026caaac','5f683ed013157dd','onblur','nuFORM.edited = 0;','2020-09-21 08:49:04','globeadmin','2020-09-21 08:49:04','globeadmin','2020-09-22 22:47:42','globeadmin'),('5f683ed029a6335','5f683ed013157dd','onchange','sumoSetHashSelectedIds(this);','2020-09-21 08:49:04','globeadmin','2020-09-21 08:49:04','globeadmin','2020-09-22 22:47:42','globeadmin'),('5f6a54e91207903','5f6a54e906ab6ce','onblur','nuFORM.edited = 0;','2020-09-22 22:47:53','globeadmin','2020-09-22 22:47:53','globeadmin','2020-09-23 10:31:40','globeadmin'),('5f6a54e91571722','5f6a54e906ab6ce','onchange','sumoSetHashSelectedIds(this);','2020-09-22 22:47:53','globeadmin','2020-09-22 22:47:53','globeadmin','2020-09-23 10:31:40','globeadmin'),('5f6a550daa53857','5f6a550d9f6ab84','onclick','nuRunPHP(\'teacher_appointments\',\'appointments_iframe\');','2020-09-22 22:48:29','globeadmin','2020-09-22 22:48:29','globeadmin','2020-09-23 10:28:37','globeadmin'),('5f6afa074e23236','5f6afa07338ae2d','onblur','nuFORM.edited = 0;','2020-09-23 10:32:23','globeadmin','2020-09-23 10:32:23','globeadmin','2020-09-23 14:42:21','globeadmin'),('5f6afa0751414f2','5f6afa07338ae2d','onchange','sumoSetHashSelectedIds(this);','2020-09-23 10:32:23','globeadmin','2020-09-23 10:32:23','globeadmin','2020-09-23 14:42:21','globeadmin'),('5f6cbec6310544c','5f6cbec625f52e9','onchange','sumoSetHashSelectedIds(this);','2020-09-24 18:44:06','globeadmin','2020-09-24 18:44:06','globeadmin','2020-09-24 22:08:38','globeadmin'),('5f6ceecbc49c79b','5f6ceecbb17d4bc','onchange','sumoSetHashSelectedIds(this);','2020-09-24 22:08:59','globeadmin','2020-09-24 22:08:59','globeadmin','2020-09-24 22:10:36','globeadmin'),('5f7cd79ee946711','5f7cd79ed11a744','onblur','nuFORM.edited = 0;','2020-10-06 23:46:23','globeadmin','2020-10-06 23:46:23','globeadmin','2020-10-07 00:00:48','globeadmin'),('5f7cd84a0374414','5f7cd849ecd0a89','onblur','nuFORM.edited = 0;','2020-10-06 23:49:14','globeadmin','2020-10-06 23:49:14','globeadmin','2020-10-07 00:03:57','globeadmin'),('5f7cd8924e8d878','5f7cd89243ff40d','onblur','nuFORM.edited = 0;','2020-10-06 23:50:26','globeadmin','2020-10-06 23:50:26','globeadmin','2020-10-07 00:53:29','globeadmin'),('5f7cd8925166a1f','5f7cd89243ff40d','onclick','showLoader();\nnuRunPHP(\'allday_absence_students\',\'search_iframe\');','2020-10-06 23:50:26','globeadmin','2020-10-07 00:53:28','globeadmin','2020-10-07 00:53:29','globeadmin'),('5f7cd8cdb7a828e','5f7cd8cda30b07f','onblur','nuFORM.edited = 0;','2020-10-06 23:51:25','globeadmin','2020-10-06 23:51:25','globeadmin','2020-10-07 09:31:08','globeadmin'),('5f7d5ddfd4645b8','5f7d5ddfc3877c3','onblur','nuFORM.edited = 0;','2020-10-07 09:19:11','globeadmin','2020-10-07 09:19:11','globeadmin','2020-10-07 09:27:50','globeadmin'),('5f7d5ddfd74fe84','5f7d5ddfc3877c3','onchange','sumoSetHashSelectedIds(this);','2020-10-07 09:19:11','globeadmin','2020-10-07 09:19:11','globeadmin','2020-10-07 09:27:50','globeadmin'),('5f7d601f95b37e0','5f7d601f8adea24','onblur','nuFORM.edited = 0;','2020-10-07 09:28:47','globeadmin','2020-10-07 09:28:47','globeadmin','2020-10-07 09:28:48','globeadmin'),('5f7d601f989dee4','5f7d601f8adea24','onchange','sumoSetHashSelectedIds(this);','2020-10-07 09:28:47','globeadmin','2020-10-07 09:28:47','globeadmin','2020-10-07 09:28:48','globeadmin'),('5f8b4fde94602c2','5f8b4fde898b62d','onkeyup','$(\'#num_of_chars_left\').val($(\'#max_num_of_chars\').val()-this.value.length);','2020-10-17 23:11:10','globeadmin','2020-10-17 23:11:10','globeadmin','2020-10-17 23:11:11','globeadmin'),('5f8b503f1622f93','5f8b503f0b304a2','onblur','nuFORM.edited = 0;','2020-10-17 23:12:47','globeadmin','2020-10-17 23:12:47','globeadmin','2020-10-18 01:52:59','globeadmin'),('5f8b6a28972f50e','5f8b6a288bf8289','onblur','nuFORM.edited = 0;','2020-10-18 01:03:20','globeadmin','2020-10-18 01:03:20','globeadmin','2022-09-17 21:41:03','globeadmin'),('6038103e68a0537','6038103e55eb2de','onblur','nuFORM.edited = 0;','2021-02-25 23:01:50','globeadmin','2021-02-25 23:01:50','globeadmin','2021-04-01 13:56:23','globeadmin'),('60395549e7541c9','60395549d067a9b','onclick','nuRunPHP(\'absence_my_card_not_registered\',\'pending_iframe\');','2021-02-26 22:08:41','globeadmin','2021-02-26 22:26:28','globeadmin','2021-04-04 14:16:42','globeadmin'),('6065a4c080f268c','6065a4c0707376d','onblur','nuFORM.edited = 0;','2021-04-01 13:47:28','globeadmin','2021-04-01 13:47:28','globeadmin','2021-04-01 14:03:24','globeadmin'),('6065a4e9e77582f','6065a4e9d56300a','onblur','nuFORM.edited = 0;','2021-04-01 13:48:09','globeadmin','2021-04-01 13:48:09','globeadmin','2021-04-01 13:58:32','globeadmin'),('6065a73aaaa3a94','6065a4c0707376d','onclick','var o = document.getElementById(\'search_iframe\');\nshowElementLoader(o);','2021-04-01 13:58:02','globeadmin','2021-04-01 13:58:02','globeadmin','2021-04-01 14:03:24','globeadmin'),('6065a757b15fdc4','6065a4e9d56300a','onclick','var o = document.getElementById(\'search_iframe\');\nhideElementLoader(o);','2021-04-01 13:58:31','globeadmin','2021-04-01 13:58:31','globeadmin','2021-04-01 13:58:32','globeadmin'),('606a0330e13e4e3','606a0330cc2a552','onclick','set_no_lesson();','2021-04-04 21:19:28','globeadmin','2021-04-04 21:40:17','globeadmin','2021-04-04 21:40:18','globeadmin'),('606a043aafd9fbd','606a0330cc2a552','onmouseover','this.style.cursor=\'pointer\';','2021-04-04 21:23:54','globeadmin','2021-04-04 21:23:54','globeadmin','2021-04-04 21:40:18','globeadmin'),('606a043ab2f2b61','606a0330cc2a552','onmouseout','this.style.cursor=\'auto\';','2021-04-04 21:23:54','globeadmin','2021-04-04 21:23:54','globeadmin','2021-04-04 21:40:18','globeadmin'),('6133be98c6358e9','6133be98b3a77d1','onclick','open_email_frame($(\'#parent_email2\').val());','2021-09-04 21:44:40','globeadmin','2021-09-04 21:44:51','globeadmin','2021-09-04 21:44:52','globeadmin'),('6175a8d4776f193','6175a8d464cdaa1','onblur','nuFORM.edited = 0;','2021-10-24 21:41:24','globeadmin','2021-10-24 21:41:24','globeadmin','2022-01-07 20:35:26','globeadmin'),('6175a5e0a7103b8','6175a5e08ed6a39','onclick','nuOpenForm(\'\',\'\', \'6175a7faca903a3\', \'#RECORD_ID#\',\'Επιβραβεύσεις\');','2021-10-24 21:28:48','globeadmin','2022-02-12 19:44:50','globeadmin','2022-02-12 19:44:51','globeadmin'),('6175a926d1eaab2','6175a926c645fd2','onblur','nuFORM.edited = 0;','2021-10-24 21:42:46','globeadmin','2021-10-24 21:42:46','globeadmin','2022-01-07 20:45:57','globeadmin'),('6175a926d4bcca7','6175a926c645fd2','onchange','sumoSetHashSelectedIds(this)','2021-10-24 21:42:46','globeadmin','2021-10-24 21:42:46','globeadmin','2022-01-07 20:45:57','globeadmin'),('6175a952179f103','6175a9520363869','onblur','nuFORM.edited = 0;','2021-10-24 21:43:30','globeadmin','2021-10-24 21:43:30','globeadmin','2022-01-07 20:42:42','globeadmin'),('6175a96eb516846','6175a96e9ca7164','onblur','nuFORM.edited = 0;','2021-10-24 21:43:58','globeadmin','2021-10-24 21:43:58','globeadmin','2022-01-07 20:43:14','globeadmin'),('6175a9971c191b3','6175a997072d15e','onblur','nuFORM.edited = 0;','2021-10-24 21:44:39','globeadmin','2021-10-24 21:44:39','globeadmin','2022-01-07 20:36:08','globeadmin'),('6175a9c1e62ab67','6175a9c1ceeae42','onclick','nuRunPHP(\'search_reward\',\'search_iframe\');','2021-10-24 21:45:21','globeadmin','2021-10-25 15:52:16','globeadmin','2022-01-07 19:34:30','globeadmin'),('6175a9eea08000e','6175a9ee95e07e5','onblur','nuFORM.edited = 0;','2021-10-24 21:46:06','globeadmin','2021-10-24 21:46:06','globeadmin','2021-11-08 20:54:22','globeadmin'),('6175aa23bdd8512','6175aa23b368d04','onblur','nuFORM.edited = 0;','2021-10-24 21:46:59','globeadmin','2021-10-24 21:46:59','globeadmin','2021-10-24 21:47:00','globeadmin'),('61d9512f944b4fd','61d9512f75161f5','onclick','nuOpenForm(\'\',\'\', \'6175a7faca903a3\', \'#RECORD_ID#\',\'Ποινές\');','2022-01-08 10:54:07','globeadmin','2022-01-08 10:54:07','globeadmin','2022-01-08 10:55:11','globeadmin'),('6175aa7398313a6','6175aa738d3578b','onblur','nuFORM.edited = 0;','2021-10-24 21:48:19','globeadmin','2021-10-24 21:48:19','globeadmin','2021-10-24 21:48:28','globeadmin'),('617ab1dca62376f','617ab1dc7b9198e','onblur','nuFORM.edited = 0;','2021-10-28 17:21:16','globeadmin','2021-10-28 17:21:16','globeadmin','2021-11-13 21:25:05','globeadmin'),('617ab1dcadf928e','617ab1dc7b9198e','onchange','sumoSetHashSelectedIds(this);','2021-10-28 17:21:16','globeadmin','2021-10-28 17:21:16','globeadmin','2021-11-13 21:25:05','globeadmin'),('6190114d7699615','6175a96e9ca7164','onchange','sumoSetHashSelectedIds(this);','2021-11-13 21:26:05','globeadmin','2021-11-13 21:26:05','globeadmin','2022-01-07 20:43:14','globeadmin'),('619014eacc61c40','6175a9520363869','onchange','sumoSetHashSelectedIds(this);','2021-11-13 21:41:30','globeadmin','2021-11-13 21:41:30','globeadmin','2022-01-07 20:42:42','globeadmin'),('619015b8aea195e','6175a997072d15e','onchange','sumoSetHashSelectedIds(this);','2021-11-13 21:44:56','globeadmin','2021-11-13 21:44:56','globeadmin','2022-01-07 20:36:08','globeadmin'),('61d952a559b792c','61d952a54f2e2c9','onclick','nuOpenForm(\'\',\'\', \'6175a7faca903a3\', \'#RECORD_ID#\',\'Ποινές\');','2022-01-08 11:00:21','globeadmin','2022-01-08 11:00:21','globeadmin','2022-01-08 11:00:22','globeadmin'),('61d9940e9245046','61d88ea5b65b611','onchange','var nodm = $(\'#reward_type_id_medals option[value=\\\'\'+$(\"#reward_type_id option:selected\").val()+\'\\\']\').text();\nif(!nodm) nodm = 1;\nsetMedalValue(nodm);','2022-01-08 15:39:26','globeadmin','2022-01-08 15:48:57','globeadmin','2022-01-08 15:48:58','globeadmin'),('61d9982a21e9d42','616db61c4fe9c5e','onchange','var nodm = $(\'#reward_type_id_medals option[value=\\\'\'+$(\"#reward_type_id option:selected\").val()+\'\\\']\').text();\nif(!nodm) nodm = 1;\nif(nodm>5) nodm = 5;\nsetMedalValue(nodm);','2022-01-08 15:56:58','globeadmin','2022-01-08 15:58:32','globeadmin','2022-01-08 15:58:33','globeadmin'),('6206ad561793c1b','6206ad560eb324b','onblur','nuFORM.edited = 0;','2022-02-11 20:39:18','globeadmin','2022-02-11 20:39:18','globeadmin','2022-02-12 14:43:26','globeadmin'),('6206ad5619404e4','6206ad560eb324b','onclick','nuRunPHP(\'absences_compare\',\'search_iframe\');','2022-02-11 20:39:18','globeadmin','2022-02-11 21:19:47','globeadmin','2022-02-12 14:43:26','globeadmin'),('6206ad8711efeac','6206ad870c623e3','onblur','nuFORM.edited = 0;','2022-02-11 20:40:07','globeadmin','2022-02-11 20:40:07','globeadmin','2022-02-12 00:36:25','globeadmin'),('6206ae4816d5b5c','6206ae481171181','onclick','nuRunPHP(\'myFILE\',\'ifile\');\nnuSetHash(\'FILES\' , \'\');\n','2022-02-11 20:43:20','globeadmin','2022-02-11 20:43:20','globeadmin','2022-02-11 21:13:19','globeadmin'),('6207ab929da4605','6207ab9289de325','onblur','nuFORM.edited = 0;','2022-02-12 14:44:02','globeadmin','2022-02-12 14:44:02','globeadmin','2022-02-12 14:44:50','globeadmin'),('6207ab92a07d119','6207ab9289de325','onclick','var iframe = document.getElementById(\'search_iframe\');\n\niframe.contentWindow.focus();\niframe.contentWindow.print();\n','2022-02-12 14:44:02','globeadmin','2022-02-12 14:44:02','globeadmin','2022-02-12 14:44:50','globeadmin');
/*!40000 ALTER TABLE `zzzsys_event` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `zzzsys_file`
--

DROP TABLE IF EXISTS `zzzsys_file`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `zzzsys_file` (
  `zzzsys_file_id` varchar(25) NOT NULL DEFAULT '',
  `sfi_filepicker` varchar(2000) NOT NULL,
  `sfi_code` varchar(10) DEFAULT NULL,
  `sfi_description` text,
  `sfi_type` varchar(50) NOT NULL,
  `sfi_size` varchar(10) NOT NULL,
  `sfi_name` varchar(255) NOT NULL,
  `sfi_group` varchar(200) DEFAULT NULL,
  `sfi_blob` longblob,
  `zzzsys_file_log_added_at` datetime NOT NULL,
  `zzzsys_file_log_added_by` varchar(25) NOT NULL,
  `zzzsys_file_log_changed_at` datetime NOT NULL,
  `zzzsys_file_log_changed_by` varchar(25) NOT NULL,
  `zzzsys_file_log_viewed_at` datetime NOT NULL,
  `zzzsys_file_log_viewed_by` varchar(25) NOT NULL,
  PRIMARY KEY (`zzzsys_file_id`),
  KEY `sfi_code` (`sfi_code`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `zzzsys_file`
--

LOCK TABLES `zzzsys_file` WRITE;
/*!40000 ALTER TABLE `zzzsys_file` DISABLE KEYS */;
/*!40000 ALTER TABLE `zzzsys_file` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `zzzsys_form`
--

DROP TABLE IF EXISTS `zzzsys_form`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `zzzsys_form` (
  `zzzsys_form_id` varchar(25) NOT NULL DEFAULT '',
  `sfo_name` varchar(50) DEFAULT NULL,
  `sfo_title` varchar(50) DEFAULT NULL,
  `sfo_sql` mediumtext,
  `sfo_table` varchar(100) DEFAULT NULL,
  `sfo_primary_key` varchar(100) DEFAULT NULL,
  `sfo_width` int(11) NOT NULL,
  `sfo_height` int(11) NOT NULL,
  `sfo_breadcrumb` varchar(1000) NOT NULL,
  `sfo_add_button` char(1) DEFAULT NULL,
  `sfo_save_button` char(1) DEFAULT NULL,
  `sfo_delete_button` char(1) DEFAULT NULL,
  `sfo_clone_button` char(1) DEFAULT NULL,
  `sfo_new_button` char(1) DEFAULT NULL,
  `sfo_print_button` char(1) DEFAULT NULL,
  `sfo_add_title` varchar(50) DEFAULT NULL,
  `sfo_save_title` varchar(50) DEFAULT NULL,
  `sfo_delete_title` varchar(50) DEFAULT NULL,
  `sfo_clone_title` varchar(50) DEFAULT NULL,
  `sfo_new_title` varchar(50) DEFAULT NULL,
  `sfo_print_title` varchar(50) DEFAULT NULL,
  `sfo_add_button_display_condition` varchar(255) DEFAULT NULL,
  `sfo_save_button_display_condition` varchar(255) DEFAULT NULL,
  `sfo_delete_button_display_condition` varchar(255) DEFAULT NULL,
  `sfo_clone_button_display_condition` varchar(255) DEFAULT NULL,
  `sfo_new_button_display_condition` varchar(255) DEFAULT NULL,
  `sfo_print_button_display_condition` varchar(255) DEFAULT NULL,
  `sfo_custom_code_run_before_save` mediumtext,
  `sfo_custom_code_run_before_browse` mediumtext,
  `sfo_custom_code_run_before_delete` mediumtext NOT NULL,
  `sfo_custom_code_run_before_open` mediumtext,
  `sfo_custom_code_run_after_save` mediumtext,
  `sfo_custom_code_run_after_delete` mediumtext,
  `sfo_custom_code_run_javascript` mediumtext,
  `sfo_redirect_form_id` varchar(25) DEFAULT NULL,
  `sfo_row_height` int(11) NOT NULL,
  `sfo_rows` int(11) NOT NULL,
  `zzzsys_form_log_added_at` datetime NOT NULL,
  `zzzsys_form_log_added_by` varchar(25) NOT NULL,
  `zzzsys_form_log_changed_at` datetime NOT NULL,
  `zzzsys_form_log_changed_by` varchar(25) NOT NULL,
  `zzzsys_form_log_viewed_at` datetime NOT NULL,
  `zzzsys_form_log_viewed_by` varchar(25) NOT NULL,
  `sfo_type` varchar(20) NOT NULL,
  `sfo_play_buttons` tinyint(1) NOT NULL DEFAULT '0',
  `sfo_play_buttons_display_condition` varchar(512) DEFAULT NULL,
  PRIMARY KEY (`zzzsys_form_id`),
  KEY `sfo_name` (`sfo_name`),
  KEY `sfo_title` (`sfo_title`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `zzzsys_form`
--

LOCK TABLES `zzzsys_form` WRITE;
/*!40000 ALTER TABLE `zzzsys_form` DISABLE KEYS */;
INSERT INTO `zzzsys_form` VALUES ('53a914a2d4f6e8c','ReportWizard','Report Wizard','select * from zzzsys_form','zzzsys_form','zzzsys_form_id',900,500,'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,'$name = \'#sad_name#\';\r\n$table = \'#sad_table#\';\r\n$selected = \'#selectedList#\';\r\n$order = \'#orderList#\';\r\n$selectedValue = \'#selectedValueList#\';\r\n$where = \'#sad_where_clause#\';\r\nif($where == \'\') {\r\n	$where = \'\';\r\n} else {\r\n	$where = \'WHERE \'.$where;\r\n}\r\n\r\n$table_id = \'#\'.\'TABLE_ID#\';\r\n\r\n$sql_var = \'$sql\';\r\n\r\n//table sql\r\n$table_sql = <<<EOSQL\r\n$sql_var = \"\r\n	CREATE TABLE $table_id\r\n	SELECT\r\n		*\r\n	FROM\r\n		$table\r\n	$where\r\n\";\r\nnuRunQuery($sql_var);\r\nEOSQL;\r\n\r\n$table_sql = str_replace(\"\'\",\"\\\'\",$table_sql);\r\n\r\n$pip = uniqid(1);\r\n\r\n$sql = \"\r\n	INSERT INTO zzzsys_php (\r\n		zzzsys_php_id,\r\n		slp_code,\r\n		slp_description,\r\n		slp_group,\r\n		slp_php,\r\n		slp_zzzsys_form_id,\r\n		slp_nonsecure\r\n	) VALUES (\r\n		\'$pip\',\r\n		\'$name\',\r\n		\'$name\',\r\n		\'$name\',\r\n		\'$table_sql\',\r\n		\'51bf99ca103dbd5\',\r\n		\'1\'\r\n	)\r\n\";\r\nnuRunQuery($sql);\r\n\r\n//layout\r\n$r = nuReportR();\r\n\r\n$objNum = 1000;\r\n$left = 50;\r\n$fieldTop = 5;\r\n$labelTop = 40;\r\n\r\n$r->groups[2]->sections[0]->objects[] = nuReportO(\'labelTitle\', 5, 50, \"label\", $name, 500, \'l\', 0, 20, 25);\r\n$r->groups[2]->sections[0]->height = 70;\r\n\r\n$footerText = \'Page #page# of #pages#, Printed: #code#, Printed On: #year#-#month#-#day# #hour#:#minute#:#second#\';\r\n$r->groups[2]->sections[1]->objects[] = nuReportO(\'labelFooter\', 5, 50, \"label\", $footerText, 700, \'l\', 0, 10, 18);\r\n\r\n$attributes = explode(\",\",$selectedValue);\r\n$fields = explode(\",\",$selected);\r\n\r\nfor($i = 0; $i < sizeof($attributes); $i++) {\r\n\r\n	$attr = explode(\";\",$attributes[$i]);\r\n\r\n	if(($left + $attr[1]) >= 840) {\r\n		$left = 50;\r\n		$labelTop += 25;\r\n		$fieldTop += 25;\r\n		$r->groups[0]->sections[0]->height = $fieldTop + 30;\r\n		$r->groups[2]->sections[0]->height = $labelTop + 30;\r\n	}\r\n	\r\n	$objNum++;\r\n	\r\n	$r->groups[2]->sections[0]->objects[] = nuReportO(\'label\'.$objNum, $labelTop, $left, \"label\", $attr[0], $attr[1], $attr[2], $attr[3], 10, 18);\r\n	$r->groups[0]->sections[0]->objects[] = nuReportO(\'object\'.$objNum, $fieldTop, $left, \"field\", $fields[$i], $attr[1], $attr[2], $attr[3], 10, 18);\r\n	\r\n	$left += $attr[1] + 20;\r\n\r\n}\r\n\r\n$labelTop += 25;\r\n\r\n$r->groups[2]->sections[0]->objects[] = nuReportO(\'headerLine\', $labelTop , 20, \"label\", \'\', 800, \'l\', 0, 20, 3);\r\n\r\n$orders = explode(\",\",$order);\r\n\r\nfor($i = 0; $i < (sizeof($orders)); $i++) {\r\n	$r->groups[($i+3)]->sections[0]->height = 20;\r\n	$r->groups[($i+3)]->sections[1]->height = 20;\r\n	$r->groups[($i+3)]->sortField = $orders[$i];\r\n}\r\n\r\n$layout = json_encode($r);\r\n\r\n//creating the report\r\n$id = uniqid(1);\r\n\r\n$sql = \"\r\n	INSERT INTO zzzsys_report (\r\n		zzzsys_report_id,\r\n		sre_code,\r\n		sre_description,\r\n		sre_group,\r\n		sre_zzzsys_form_id,\r\n		sre_zzzsys_php_id,\r\n		sre_layout\r\n	) VALUES (\r\n		\'$id\',\r\n		\'$name\',\r\n		\'$name\',\r\n		\'Custom\',\r\n		\'51bf99ca103dbd5\',\r\n		\'$pip\',\r\n		\'$layout\'\r\n	)\r\n\";\r\nnuRunQuery($sql);\r\n\r\nfunction nuReportR(){\r\n\r\n	$o                   = new stdClass;\r\n\r\n	$o->bottom           = 260;\r\n	$o->currentGroup     = 0;\r\n	$o->height           = 297;\r\n	$o->left             = 30;\r\n	$o->orientation      = \"P\";\r\n	$o->paper            = \"A4\";\r\n	$o->right            = 30;\r\n	$o->top              = 30;\r\n	$o->width            = 210;\r\n	$o->groups[]         = nuReportG(10);\r\n	$o->groups[]         = nuReportG(0);\r\n	$o->groups[]         = nuReportG(1);\r\n	$o->groups[]         = nuReportG(2);\r\n	$o->groups[]         = nuReportG(3);\r\n	$o->groups[]         = nuReportG(4);\r\n	$o->groups[]         = nuReportG(5);\r\n	$o->groups[]         = nuReportG(6);\r\n	$o->groups[]         = nuReportG(7);\r\n	$o->groups[]         = nuReportG(8);\r\n	$o->groups[]         = nuReportG(9);\r\n\r\n	return $o;\r\n\r\n}\r\n\r\n	\r\nfunction nuReportG($f){\r\n\r\n	$g                    = new stdClass;\r\n	$h                    = 0;\r\n	$l                    = \'\';\r\n		\r\n	if($f == 10){$l = \'Detail\';$h = 40;}\r\n	if($f == 0) {$l = \'Report\';$h = 40;}\r\n	if($f == 1) {$l = \'Page\';$h = 40;}\r\n\r\n	$g->sortBy            = \"a\";\r\n	$g->sortField         = $l;\r\n\r\n	$s                    = new stdClass;\r\n\r\n	$s->color             = \"#FFFFFF\";\r\n	$s->height            = $h;\r\n	$s->id                = \"\";\r\n	$s->label             = $l . \" Header\";\r\n	$s->margins           = 4;\r\n	$s->objects           = array();\r\n	$s->page_break        = 0;\r\n	$s->top               = 110;\r\n\r\n	$g->sections[]        = $s;\r\n	\r\n	if($f == 10){return $g;}                       //-- no second section\r\n\r\n	$s                    = new stdClass;\r\n\r\n	$s->color             = \"#FFFFFF\";\r\n	$s->height            = $h;\r\n	$s->id                = \"\";\r\n	$s->label             = $l . \" Footer\";\r\n	$s->margins           = 6;\r\n	$s->objects           = array();\r\n	$s->page_break        = 0;\r\n	$s->top               = 150;\r\n\r\n	$g->sections[]        = $s;\r\n	\r\n	return $g;\r\n	\r\n}\r\n	\r\n\r\n\r\nfunction nuReportO($i, $t, $l, $type, $field, $width, $align, $format, $fontSize, $height){\r\n\r\n	$o                    = new stdClass;\r\n\r\n	if($i == \'headerLine\') {\r\n		$o->backgroundColor   = \"black\";\r\n	} else {\r\n		$o->backgroundColor   = \"white\";\r\n	}	\r\n	\r\n	$o->borderColor       = \"black\";\r\n	$o->borderWidth       = 0;\r\n	$o->fieldName         = \"$field\";        //-- trp_delivery_date for field or Customer Name for label\r\n	$o->fontColor         = \"black\";\r\n	$o->fontFamily        = \"helvetica\";\r\n	$o->fontSize          = \"$fontSize\";\r\n	\r\n	if($type = \'label\' && $i != \'labelFooter\') {\r\n		$o->fontWeight        = \"B\";\r\n	} else {\r\n		$o->fontWeight        = \"\";\r\n	}	\r\n	\r\n	$o->format            = \"$format\";        // blank or 0-31\r\n	$o->group             = 0;\r\n	$o->height            = $height;\r\n	$o->id                = $i;        //-- eg. object1009 starting at 1000\r\n	$o->left              = $l;\r\n	$o->maxRows           = 0;\r\n	$o->minRows           = 0;\r\n	$o->name              = $i;        //-- eg. object1009 starting at 1000\r\n	$o->objectType        = \"$type\";\r\n	$o->section           = 0;\r\n	$o->selected          = 0;\r\n	$o->textAlign         = \"$align\";\r\n	$o->top               = $t;\r\n	$o->width             = $width;\r\n	$o->zIndex            = 100;\r\n\r\n	return $o;\r\n	\r\n}',NULL,'var tableFields = Array();\r\n\r\nfunction nuLoadEditGlobal() {\r\n	if(\'#nu_new_record#\' == \'1\') {\r\n		$(\'#columns\').empty();\r\n		$(\'#selected\').empty();\r\n		$(\'#order\').empty();\r\n	}\r\n	\r\n	updateListbox();\r\n}\r\n\r\nfunction nuOnSave() {\r\n	\r\n	var selectedList = \'\';\r\n	$(\'#selected option\').each(function() {\r\n		selectedList = selectedList + $(this).text() + \',\';\r\n	});\r\n	\r\n	$(\'#selectedList\').val(selectedList.substring(0, selectedList.length -1));\r\n	\r\n	var orderList = \'\';\r\n	$(\'#order option\').each(function() {\r\n		orderList = orderList + $(this).text() + \',\';\r\n	});\r\n	\r\n	$(\'#orderList\').val(orderList.substring(0, orderList.length -1));\r\n	\r\n	var selectedValueList = \'\';\r\n	$(\'#selected option\').each(function() {\r\n		selectedValueList = selectedValueList + $(this).val() + \',\';\r\n	});\r\n	\r\n	$(\'#selectedValueList\').val(selectedValueList.substring(0, selectedValueList.length -1));\r\n		\r\n	return true;\r\n}\r\n\r\nfunction showColumnData() {\r\n	if($(\'#selected\').find(\'option:selected\').length > 1) {\r\n		$(\'#colname\').val(\'\');\r\n		$(\'#width\').val(\'\');\r\n		$(\'#align\').val(\'\');\r\n		$(\'#format\').val(\'\');\r\n	} else {\r\n		var values = $(\'#selected\').find(\'option:selected\').val().split(\";\");\r\n		$(\'#colname\').val(values[0]);\r\n		$(\'#width\').val(values[1]);\r\n		$(\'#align\').val(values[2]);\r\n		$(\'#format\').val(values[3]);\r\n	}\r\n}\r\n\r\nfunction updateColumnData() {\r\n	$(\'#selected\').find(\'option:selected\').each(function() {\r\n		var updateValue = $(\'#colname\').val() + \';\' + $(\'#width\').val() + \';\' + $(\'#align\').val() + \';\' + $(\'#format\').val();\r\n		$(this).val(updateValue);\r\n	});\r\n}\r\n\r\nfunction updateListbox() {\r\n\r\n	$(\'#columns\').empty();\r\n\r\n	var url = \'nucall.php?p=getTableColumns&table=\'+$(\'#sad_table\').val();\r\n\r\n	var response = $.ajax({\r\n	  url:  url,\r\n	  context: document.body,\r\n	  async: false\r\n	}).responseText;\r\n\r\n	tableFields = Array();\r\n	\r\n	if(response != \'\') {\r\n		var parts = response.split(\";\");\r\n		\r\n		for(var i = 0; i < parts.length; i++) {\r\n			var opt = \'<option value=\"\' + parts[i] + \'\">\' + parts[i] + \'</option>\';\r\n			$(\'#columns\').append(opt);\r\n			tableFields.push(parts[i]);\r\n		}\r\n	}\r\n}\r\n\r\nfunction addField() {\r\n	$(\'#columns\').find(\':selected\').each(function() {\r\n		var opt = \'<option value=\"\' + nuFieldTitle(this.value, tableFields) + \';100;l;0\">\' + this.value + \'</option>\';\r\n		$(\'#selected\').append(opt);\r\n	});\r\n}\r\n\r\nfunction removeField() {\r\n	$(\'#selected\').find(\':selected\').each(function() {\r\n		 $(\"#selected option:eq(\" + this.index + \")\").remove();\r\n	});\r\n}\r\n\r\nfunction moveField(pdir) {\r\n\r\n	if(pdir) {\r\n	//move up\r\n		$(\'#selected option:selected\').each(function(){\r\n			$(this).insertBefore($(this).prev());\r\n		});\r\n	} else {\r\n	//move down\r\n		$(\'#selected option:selected\').each(function(){\r\n			$(this).insertAfter($(this).next());\r\n		});\r\n	}\r\n	\r\n}\r\n\r\nfunction addOrder() {\r\n	$(\'#selected\').find(\':selected\').each(function() {\r\n		var opt = \'<option value=\"\' + this.text + \'\">\' + this.text + \'</option>\';\r\n		$(\'#order\').append(opt);\r\n	});\r\n}\r\n\r\nfunction removeOrder() {\r\n	$(\'#order\').find(\':selected\').each(function() {\r\n		 $(\"#order option:eq(\" + this.index + \")\").remove();\r\n	});\r\n}\r\n\r\nfunction moveOrder(pdir) {\r\n\r\n	if(pdir) {\r\n	//move up\r\n		$(\'#order option:selected\').each(function(){\r\n			$(this).insertBefore($(this).prev());\r\n		});\r\n	} else {\r\n	//move down\r\n		$(\'#order option:selected\').each(function(){\r\n			$(this).insertAfter($(this).next());\r\n		});\r\n	}\r\n	\r\n}',NULL,0,0,'2014-06-24 16:03:15','globeadmin','2014-06-26 16:48:43','globeadmin','2014-10-01 10:02:21','globeadmin','',0,NULL),('54705a95c4e91c2','classroom','Αίθουσες Διδασκαλίας','select * from classroom','classroom','id',960,520,'select short_name from classroom where id=\'#RECORD_ID#\'','1','1','1',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'SELECT IF(\'#RECORD_ID#\'=\'-1\',\'0\',\'1\')',NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,35,0,'0000-00-00 00:00:00','','2018-07-29 15:28:17','globeadmin','2018-07-29 15:28:17','globeadmin','',1,NULL),('54706cd4f34daae','day','Ημέρες','select * from day','day','id',960,520,'SELECT name from day where id=\'#RECORD_ID#\'','1','1','1',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'select if(\'#RECORD_ID#\'>4,\'1\',\'0\')',NULL,NULL,NULL,NULL,NULL,'$sql = \"    SELECT COUNT(*)\n            FROM card\n            WHERE day_id = \'#RECORD_ID#\'\n        \";\n$retval = nuRunQuery($sql);\n$row    = db_fetch_row($retval);\n\nif($row[0]!=0){\n    $MESSAGE = \'Προσοχή : Υπάρχουν διδασκαλίες στην ημέρα αυτή! Η διαγραφή δε μπορεί να πραγματοποιηθεί!\';\n    nuDisplayError($MESSAGE);\n    return;    \n}',NULL,NULL,NULL,NULL,NULL,50,0,'0000-00-00 00:00:00','','2016-03-05 14:02:27','globeadmin','2018-07-29 15:29:23','globeadmin','',1,NULL),('54706f6b39c1b38','grade','Τάξεις','select * from grade','grade','id',960,520,'select name from grade where id=#RECORD_ID#','1','1','1',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'select if(\'#RECORD_ID#\'>3,\'1\',\'0\')',NULL,NULL,NULL,NULL,NULL,'$sql = \"    SELECT COUNT(*)\n            FROM class\n            WHERE grade_id = \'#RECORD_ID#\'\n        \";\n$retval = nuRunQuery($sql);\n$row    = db_fetch_row($retval);\n\nif($row[0]!=0){\n    $MESSAGE = \'Προσοχή : Υπάρχουν τμήματα για την τάξη αυτή! Η διαγραφή δε μπορεί να πραγματοποιηθεί!\';\n    nuDisplayError($MESSAGE);\n    return;    \n}\n\n\n$sql = \"    SELECT COUNT(*)\n            FROM student\n            WHERE grade_id = \'#RECORD_ID#\'\n        \";\n$retval = nuRunQuery($sql);\n$row    = db_fetch_row($retval);\n\nif($row[0]!=0){\n    $MESSAGE = \'Προσοχή : Υπάρχουν μαθητές στην τάξη αυτή! Η διαγραφή δε μπορεί να πραγματοποιηθεί!\';\n    nuDisplayError($MESSAGE);\n    return;    \n}\n\n\n$sql = \"    SELECT COUNT(*)\n            FROM subject\n            WHERE grade_id = \'#RECORD_ID#\'\n        \";\n$retval = nuRunQuery($sql);\n$row    = db_fetch_row($retval);\n\nif($row[0]!=0){\n    $MESSAGE = \'Προσοχή : Υπάρχουν μαθήματα στην τάξη αυτή! Η διαγραφή δε μπορεί να πραγματοποιηθεί!\';\n    nuDisplayError($MESSAGE);\n    return;    \n}',NULL,NULL,NULL,NULL,NULL,50,0,'0000-00-00 00:00:00','','2016-03-05 14:01:53','globeadmin','2018-07-29 15:33:29','globeadmin','',1,NULL),('547070c91793d3b','grading_period','Περίοδοι Αξιολόγησης','select *,gid \nfrom grading_period \ninner join (select ifNULL(grading_period_id,0) as gid from school as sch where id=1) as gid on 1=1\norder by name','grading_period','id',960,550,'select name from grading_period where id = \'#RECORD_ID#\'','1',NULL,'1',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'select if(\'#RECORD_ID#\'>3,\'1\',\'0\')',NULL,NULL,NULL,NULL,NULL,'$sql = \"    SELECT COUNT(*)\n            FROM mark\n            WHERE grading_period_id = \'#RECORD_ID#\'\n        \";\n$retval = nuRunQuery($sql);\n$row    = db_fetch_row($retval);\n\nif($row[0]!=0){\n    $MESSAGE = \'Προσοχή : Υπάρχουν καταχωρημένοι βαθμοί στη βαθμολογική περίοδο αυτή! Η διαγραφή δε μπορεί να πραγματοποιηθεί!\';\n    nuDisplayError($MESSAGE);\n    return;    \n}\n\n$sql = \"    SELECT COUNT(*)\n            FROM school\n            WHERE grading_period_id = \'#RECORD_ID#\'\n        \";\n$retval = nuRunQuery($sql);\n$row    = db_fetch_row($retval);\n\nif($row[0]!=0){\n    $MESSAGE = \'Προσοχή : Αυτή η βαθμολογική περίοδος είναι η τρέχουσα! Η διαγραφή δε μπορεί να πραγματοποιηθεί!\';\n    nuDisplayError($MESSAGE);\n    return;    \n}\n',NULL,'if (\'#subject_id_list#\'!=\'#\'.\'subject_id_list\'.\'#\' ){\n    \n    $sql = \"UPDATE subject SET is_marked=0 WHERE id>=10\";\n    nuRunQuery($sql);\n    \n    if(\'#subject_id_list#\'!=\'\'){\n        $sql = \"UPDATE subject SET is_marked=1 WHERE id IN (#subject_id_list#)\";\n        nuRunQuery($sql);\n    }    \n}\n',NULL,'function nuLoadBrowse() {\n    var rows = nuBrowseRows();\n     \n    var row_len = rows.toString().length;\n    var pad = \"0000\";\n     \n    for( var i = 0; i < rows; i++ ) {\n        var rowString = i.toString();\n        var rowNum = pad.substring(0, pad.length - rowString.length ) + rowString;\n        var id = \'row_\'+rowNum+\'_col_1\';\n        if( $(\"div[id=\'\"+id+\"\']\").text().trim().match(/Τρέχουσα/) ) {\n            $(\"div[id^=\'row_\"+rowNum+\"\']\").css(\"color\", \"green\");\n        }\n    }\n}\n\nfunction set_active(param){\n    $(\'#state\').val(\'ΤΡΕΧΟΥΣΑ\');\n    $(\'#state\').css(\'background-color\', \'LightYellow\');\n    $(\'#state\').css(\'color\', \'green\');\n    document.getElementById(\'state\').style.cursor=\'auto\';\n}\n\nfunction nuLoadEdit() {\n    $(\'#state\').css(\'fontSize\', \'14px\');\n    $(\'#state\').css(\'font-weight\', \'bold\');\n    \n    if($(\'#state\').val()==\'ΤΡΕΧΟΥΣΑ\'){\n        $(\'#state\').css(\'background-color\', \'LightYellow\');\n        $(\'#state\').css(\'color\', \'green\');    \n    } else {\n        $(\'#state\').css(\'background-color\', \'LightYellow\');\n        $(\'#state\').css(\'color\', \'red\');  \n    }\n    $(\'#state\').attr(\'readonly\', true);\n    \n    $(\'#label1\').css(\'fontSize\', \'10px\');\n    $(\'#label1\').css(\'font-style\', \'italic\');\n    \n    $(\'#label2\').css(\'fontSize\', \'10px\');\n    $(\'#label2\').css(\'font-style\', \'italic\');\n}\n\nfunction nuOnSave(){     \n    if($(\'#num_of_decimals\').val()==\'\') $(\'#num_of_decimals\').val(\'0\');\n    return true; \n}',NULL,50,0,'0000-00-00 00:00:00','','2019-08-03 23:23:32','globeadmin','2021-09-04 21:36:57','globeadmin','',0,NULL),('54707442a2bcae4','period','Διδακτικές Ώρες','select * from period','period','id',960,520,'select name from period where id=\'#RECORD_ID#\'','1','1','1',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'select if(\'#RECORD_ID#\'>7,\'1\',\'0\')',NULL,NULL,NULL,NULL,NULL,'$sql = \"    SELECT COUNT(*)\n            FROM card\n            WHERE period_id = \'#RECORD_ID#\'\n        \";\n$retval = nuRunQuery($sql);\n$row    = db_fetch_row($retval);\n\nif($row[0]!=0){\n    $MESSAGE = \'Προσοχή : Υπάρχουν διδασκαλίες στην ώρα αυτή! Η διαγραφή δε μπορεί να πραγματοποιηθεί!\';\n    nuDisplayError($MESSAGE);\n    return;    \n}',NULL,NULL,NULL,NULL,NULL,50,0,'0000-00-00 00:00:00','','2016-03-05 19:18:40','globeadmin','2019-11-03 18:24:57','globeadmin','',1,NULL),('5470788787e004a','justification_request_reason','Λόγοι Αίτησης Διαγραφής Απουσίας','select * \nfrom justification_request_reason\norder by id','justification_request_reason','id',960,520,'SELECT name from justification_request_reason where id=\'#RECORD_ID#\'','1','1','1',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'select if(\'#RECORD_ID#\'>2 and \'#RECORD_ID#\'<>8,\'1\',\'0\')',NULL,NULL,NULL,NULL,NULL,'$sql = \"    SELECT COUNT(*)\n            FROM justification_request\n            WHERE justification_request_reason_id = \'#RECORD_ID#\'\n        \";\n$retval = nuRunQuery($sql);\n$row    = db_fetch_row($retval);\n\nif($row[0]!=0){\n    $MESSAGE = \'Προσοχή : Υπάρχουν καταχωρημένα αιτήματα δικαιολόγησης με το λόγο αυτό! Η διαγραφή δε μπορεί να πραγματοποιηθεί!\';\n    nuDisplayError($MESSAGE);\n    return;    \n}',NULL,NULL,NULL,NULL,NULL,35,0,'0000-00-00 00:00:00','','2018-08-09 18:05:39','globeadmin','2018-08-09 18:08:31','globeadmin','',1,NULL),('54707c8612b1b6b','justified_reason','Λόγοι Δικαιολόγησης Απουσίας','select * from justified_reason WHERE id>0 and id<>3 order by id','justified_reason','id',960,520,'select name from justified_reason where id=\'#RECORD_ID#\'','1','1','1',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'SELECT IF(\'#RECORD_ID#\'=\'-1\' or \'#RECORD_ID#\'=\'3\',\'0\',\'1\')',NULL,NULL,NULL,NULL,NULL,'$sql = \"    SELECT COUNT(*)\n            FROM absence\n            WHERE justified_reason_id = \'#RECORD_ID#\'\n        \";\n$retval = nuRunQuery($sql);\n$row    = db_fetch_row($retval);\n\nif($row[0]!=0){\n    $MESSAGE = \'Προσοχή : Υπάρχουν δικαιολογημένες απουσίες με το λόγο αυτό! Η διαγραφή δε μπορεί να πραγματοποιηθεί!\';\n    nuDisplayError($MESSAGE);\n    return;    \n}',NULL,NULL,NULL,NULL,NULL,40,0,'0000-00-00 00:00:00','','2019-11-03 18:57:13','globeadmin','2019-11-03 18:57:13','globeadmin','',1,NULL),('5470802845f7427','school_type','Τύποι Σχολείων','select * from school_type','school_type','id',960,520,'SELECT name from school_type where id=\'#RECORD_ID#\'','1','1','0',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,50,0,'0000-00-00 00:00:00','','2015-11-22 09:34:01','globeadmin','2020-04-02 11:28:35','globeadmin','',0,NULL),('547081ceb3d2146','school_year','Σχολικά Έτη','select * from school_year','school_year','id',960,520,'select short_name from school_year where id=#RECORD_ID#','1','1','0',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function foo(param){\n    ;\n}',NULL,35,0,'0000-00-00 00:00:00','','2015-03-06 19:51:58','globeadmin','2019-11-03 18:27:46','globeadmin','',0,NULL),('5470b05b91e73a0','section','Τομείς Μαθημάτων','select * from section','section','id',960,520,'SELECT name from section where id=\'#RECORD_ID#\'','1','1','1',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'SELECT IF(\'#RECORD_ID#\'=\'-1\',\'0\',\'1\')',NULL,NULL,NULL,NULL,NULL,'$sql = \"    SELECT COUNT(*)\n            FROM speciality\n            WHERE section_id = \'#RECORD_ID#\'\n        \";\n$retval = nuRunQuery($sql);\n$row    = db_fetch_row($retval);\n\nif($row[0]!=0){\n    $MESSAGE = \'Προσοχή : Υπάρχουν κατευθύνσεις μαθημάτων στον τομέα αυτό! Η διαγραφή δε μπορεί να πραγματοποιηθεί!\';\n    nuDisplayError($MESSAGE);\n    return;    \n}',NULL,NULL,NULL,NULL,NULL,50,0,'0000-00-00 00:00:00','','2018-07-29 15:34:06','globeadmin','2018-07-29 15:34:07','globeadmin','',1,NULL),('5470b3806384141','teaching_field','Ειδικότητες Καθηγητών','select * \nfrom teaching_field\norder by short_name','teaching_field','id',960,520,'SELECT short_name from teaching_field where id=\'#RECORD_ID#\'','1','1','1',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'SELECT IF(\'#RECORD_ID#\'=\'-1\',\'0\',\'1\')',NULL,NULL,NULL,NULL,NULL,'$sql = \"    SELECT COUNT(*)\n            FROM teacher\n            WHERE teaching_field_id = \'#RECORD_ID#\'\n        \";\n$retval = nuRunQuery($sql);\n$row    = db_fetch_row($retval);\nif($row[0]!=0){\n    $MESSAGE = \'Προσοχή : Υπάρχουν καθηγητές με αυτήν την ειδικότητα! Η διαγραφή δε μπορεί να πραγματοποιηθεί!\';\n    nuDisplayError($MESSAGE);\n    return;    \n}',NULL,NULL,NULL,NULL,NULL,25,100,'0000-00-00 00:00:00','','2018-08-05 11:34:35','globeadmin','2018-08-05 11:34:35','globeadmin','',1,NULL),('5470b6d7c79d3b9','class','Τμήματα','select class.*,t_short \nfrom class\nleft join (select teacher.short_name as t_short, teacher.id as t_id from teacher) as t ON t.t_id = class.post_teacher_id\norder by class.short_name','class','id',960,500,'select short_name from class where id=#RECORD_ID#','1','1','1',NULL,NULL,NULL,NULL,NULL,'Διαγραφή Τμήματος',NULL,NULL,NULL,NULL,NULL,'SELECT IF(\'#RECORD_ID#\'=\'-1\',\'0\',\'1\')',NULL,NULL,NULL,'/*$arr = nuSubformArray(\'student_class_subform\',false);\n$student_id_array = array();\n\nfor( $idx = 0; $idx < count($arr); $idx++ ) {\n    $student_id_array[] = $nuHash[$arr[$idx].\'student_id\'];\n}\n\nif(count($student_id_array) != count(array_unique($student_id_array))) {\n        $MESSAGE = \'Προσόχη : Δεν μπορεί ο ίδιος μαθητής να ανήκει περισσότερες από μια φορές στο τμήμα... \';\n        nuDisplayError($MESSAGE);\n        return;\n}*/\n\n',NULL,'/***********************************************************/\n$sql = \"    SELECT COUNT(*)\n            FROM student_class\n            WHERE class_id = \'#RECORD_ID#\'\n        \";\n$retval = nuRunQuery($sql);\n$row    = db_fetch_row($retval);\nif($row[0]!=0){\n    $MESSAGE = \'Προσοχή : Υπάρχουν μαθητές στο τμήμα αυτό! Η διαγραφή δε μπορεί να πραγματοποιηθεί!\';\n    nuDisplayError($MESSAGE);\n    return;    \n}\n/***********************************************************/\n$sql = \"    SELECT COUNT(*)\n            FROM card\n            WHERE class_id = \'#RECORD_ID#\'\n        \";\n$retval = nuRunQuery($sql);\n$row    = db_fetch_row($retval);\nif($row[0]!=0){\n    $MESSAGE = \'Προσοχή : Υπάρχουν διδασκαλίες στο ΩΠ για το τμήμα αυτό! Η διαγραφή δε μπορεί να πραγματοποιηθεί!\';\n    nuDisplayError($MESSAGE);\n    return;    \n}\n/***********************************************************/\n$sql = \"    SELECT COUNT(*)\n            FROM mark\n            WHERE class_id = \'#RECORD_ID#\'\n        \";\n$retval = nuRunQuery($sql);\n$row    = db_fetch_row($retval);\nif($row[0]!=0){\n    $MESSAGE = \'Προσοχή : Υπάρχουν καταχωρημένες αξιολογήσεις στο τμήμα αυτό! Η διαγραφή δε μπορεί να πραγματοποιηθεί!\';\n    nuDisplayError($MESSAGE);\n    return;    \n}',NULL,NULL,NULL,'function add_students_result(param){\n    if(param==\'\'){\n        alert(\'Προσοχή: Παρουσιάστηκε πρόβλημα κατά την προσθήκη των μαθητών στο τμήμα!\');\n    } else{\n        alert(param);\n    } \n    nuRunPHP(\'create_student_class_list\',\'student_iframe\');\n}\n\nfunction remove_students_result(param){\n    if(param==\'\'){\n        alert(\'Προσοχή: Παρουσιάστηκε πρόβλημα κατά την αφαίρεση των μαθητών από το τμήμα!\');\n    } else{\n        alert(\'Η αφαίρεση των μαθητών πραγματοποιήθηκε επιτυχώς!\');\n    }   \n    nuRunPHP(\'create_student_class_list\',\'student_iframe\');\n}\n\nfunction nuLoadEdit() {\n    sumoTransform(\'student_id_select\',true,true);\n}',NULL,25,50,'0000-00-00 00:00:00','','2018-07-29 15:25:22','globeadmin','2022-01-08 15:26:10','globeadmin','',1,NULL),('5470c07906bfd70','school','Στοιχεία Σχολείου','select * from school','school','id',960,520,'select \'Στοιχεία Σχολείου και Επικοινωνίας\'','0','1','0',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,0,0,'0000-00-00 00:00:00','','2018-01-09 15:24:32','globeadmin','2018-01-09 15:24:32','globeadmin','',0,NULL),('54730f661a9b822','absence_reason','Λόγοι Απουσίας Μαθητή','select * from absence_reason','absence_reason','id',960,520,'select name from absence_reason where id=\'#RECORD_ID#\'','1','1','1',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'select if(\'#RECORD_ID#\'>3,\'1\',\'0\')',NULL,NULL,NULL,NULL,NULL,'$sql = \"    SELECT COUNT(*)\n            FROM absence\n            WHERE absence_reason_id = \'#RECORD_ID#\'\n        \";\n$retval = nuRunQuery($sql);\n$row    = db_fetch_row($retval);\n\nif($row[0]!=0){\n    $MESSAGE = \'Προσοχή : Υπάρχουν καταχωρημένες απουσίες με το λόγο αυτό! Η διαγραφή δε μπορεί να πραγματοποιηθεί!\';\n    nuDisplayError($MESSAGE);\n    return;    \n}',NULL,NULL,NULL,NULL,NULL,50,0,'0000-00-00 00:00:00','','2016-03-05 14:05:15','globeadmin','2016-03-05 14:05:15','globeadmin','',0,NULL),('54736dab44212c7','subject_type','Τύποι Μαθημάτων','select * from subject_type','subject_type','id',960,520,'SELECT name from subject_type where id=\'#RECORD_ID#\'','1','1','1',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'select if(\'#RECORD_ID#\'>2,\'1\',\'0\')',NULL,NULL,NULL,NULL,NULL,'$sql = \"    SELECT COUNT(*)\n            FROM subject\n            WHERE subject_type_id = \'#RECORD_ID#\'\n        \";\n$retval = nuRunQuery($sql);\n$row    = db_fetch_row($retval);\n\nif($row[0]!=0){\n    $MESSAGE = \'Προσοχή : Υπάρχουν μαθήματα αυτού του τύπου! Η διαγραφή δε μπορεί να πραγματοποιηθεί!\';\n    nuDisplayError($MESSAGE);\n    return;    \n}',NULL,NULL,NULL,NULL,NULL,50,0,'0000-00-00 00:00:00','','2016-03-05 14:06:38','globeadmin','2018-07-29 15:36:05','globeadmin','',0,NULL),('547372d029461f4','teacher','Καθηγητές','select * \nfrom teacher \norder by short_name','teacher','id',960,700,'select concat(IFNULL(surname,\'\'),\' \',IFNULL(name,\'\')) from teacher where id=#RECORD_ID#','1','1','1',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'SELECT IF(\'#RECORD_ID#\'=\'-1\',\'0\',\'1\')',NULL,NULL,NULL,NULL,NULL,'/***********************************************************/\n$sql = \"    SELECT COUNT(*)\n            FROM card\n            WHERE teacher_id = \'#RECORD_ID#\'\n        \";\n$retval = nuRunQuery($sql);\n$row    = db_fetch_row($retval);\nif($row[0]!=0){\n    $MESSAGE = \'Προσοχή : Υπάρχουν διδασκαλίες από τον καθηγητή! Η διαγραφή δε μπορεί να πραγματοποιηθεί!\';\n    nuDisplayError($MESSAGE);\n    return;    \n}	\n/***********************************************************/\n$sql = \"    SELECT COUNT(*)\n            FROM mark\n            WHERE post_teacher_id = \'#RECORD_ID#\'\n        \";\n$retval = nuRunQuery($sql);\n$row    = db_fetch_row($retval);\nif($row[0]!=0){\n    $MESSAGE = \'Προσοχή : Υπάρχουν καταχωρημένοι βαθμοί από τον καθηγητή! Η διαγραφή δε μπορεί να πραγματοποιηθεί!\';\n    nuDisplayError($MESSAGE);\n    return;    \n}\n/***********************************************************/\n$sql = \"    SELECT COUNT(*)\n            FROM absence\n            WHERE post_teacher_id = \'#RECORD_ID#\'\n        \";\n$retval = nuRunQuery($sql);\n$row    = db_fetch_row($retval);\nif($row[0]!=0){\n    $MESSAGE = \'Προσοχή : Υπάρχουν καταχωρημένες απουσίες από τον καθηγητή! Η διαγραφή δε μπορεί να πραγματοποιηθεί!\';\n    nuDisplayError($MESSAGE);\n    return;    \n}\n/***********************************************************/\n$sql = \"    SELECT COUNT(*)\n            FROM absence\n            WHERE justified_teacher_id = \'#RECORD_ID#\'\n        \";\n$retval = nuRunQuery($sql);\n$row    = db_fetch_row($retval);\nif($row[0]!=0){\n    $MESSAGE = \'Προσοχή : Υπάρχουν δικαιολογημένες απουσίες από τον καθηγητή! Η διαγραφή δε μπορεί να πραγματοποιηθεί!\';\n    nuDisplayError($MESSAGE);\n    return;    \n}\n/***********************************************************/\n$sql = \"    SELECT COUNT(*)\n            FROM class\n            WHERE post_teacher_id = \'#RECORD_ID#\'\n        \";\n$retval = nuRunQuery($sql);\n$row    = db_fetch_row($retval);\nif($row[0]!=0){\n    $MESSAGE = \'Προσοχή : Ο καθηγητής έχει οριστεί καταχωρητής σε τμήμα! Η διαγραφή δε μπορεί να πραγματοποιηθεί!\';\n    nuDisplayError($MESSAGE);\n    return;    \n}\n/***********************************************************/\n$sql = \"    SELECT COUNT(*)\n            FROM student\n            WHERE teacher_id = \'#RECORD_ID#\'\n        \";\n$retval = nuRunQuery($sql);\n$row    = db_fetch_row($retval);\nif($row[0]!=0){\n    $MESSAGE = \'Προσοχή : Ο καθηγητής είναι υπεύθυνος σε μαθητές! Η διαγραφή δε μπορεί να πραγματοποιηθεί!\';\n    nuDisplayError($MESSAGE);\n    return;    \n}\n/***********************************************************/\n$sql = \"    SELECT COUNT(*)\n            FROM justification_request\n            WHERE post_teacher_id = \'#RECORD_ID#\'\n        \";\n$retval = nuRunQuery($sql);\n$row    = db_fetch_row($retval);\nif($row[0]!=0){\n    $MESSAGE = \'Προσοχή : Ο καθηγητής έχει καταχωρήσει αίτηματα δικαιολόγησης! Η διαγραφή δε μπορεί να πραγματοποιηθεί!\';\n    nuDisplayError($MESSAGE);\n    return;    \n}\n/***********************************************************/\n$sql = \"    SELECT COUNT(*)\n            FROM justification_request\n            WHERE proceeded_teacher_id = \'#RECORD_ID#\'\n        \";\n$retval = nuRunQuery($sql);\n$row    = db_fetch_row($retval);\nif($row[0]!=0){\n    $MESSAGE = \'Προσοχή : Ο καθηγητής έχει εγκρίνει αίτηματα δικαιολόγησης! Η διαγραφή δε μπορεί να πραγματοποιηθεί!\';\n    nuDisplayError($MESSAGE);\n    return;    \n}\n/***********************************************************/\n$sql = \"    SELECT COUNT(*)\n            FROM penalty\n            WHERE teacher_id = \'#RECORD_ID#\'\n        \";\n$retval = nuRunQuery($sql);\n$row    = db_fetch_row($retval);\nif($row[0]!=0){\n    $MESSAGE = \'Προσοχή : Ο καθηγητής έχει επιβάλει ποινές! Η διαγραφή δε μπορεί να πραγματοποιηθεί!\';\n    nuDisplayError($MESSAGE);\n    return;    \n}\n/***********************************************************/\n$sql = \"    SELECT COUNT(*)\n            FROM registered_card\n            WHERE teacher_id = \'#RECORD_ID#\'\n        \";\n$retval = nuRunQuery($sql);\n$row    = db_fetch_row($retval);\nif($row[0]!=0){\n    $MESSAGE = \'Προσοχή : Ο καθηγητής έχει καταχωρήσει απουσίες! Η διαγραφή δε μπορεί να πραγματοποιηθεί!\';\n    nuDisplayError($MESSAGE);\n    return;    \n}\n/***********************************************************/\n\n$sql = \"    DELETE \n            FROM zzzsys_user \n            WHERE zzzsys_user_id = \'#user_id#\'\n        \";\nnuRunQuery($sql);\n\n',NULL,NULL,NULL,'function resetPassword(){\n    var user_id = $(\'#user_id\').val();\n    nuSetHash(\'account_id\', user_id);\n    nuAjax(\'reset_account_password\',\'show_ajax_result\');    \n}\n\nfunction show_ajax_result(param){\n    sisMessage(param);\n}\n\nfunction delete_appointment_availability_result(param){\n   nuRunPHP(\'teacher_appointment_availability\',\'availability_iframe\'); \n}\n\nfunction set_appointment_washeld_result(param){\n    if(param && param!=\'\'){\n        var json_data = JSON.parse(param);\n        if(json_data[0]>0){\n            \n            var iframe = document.getElementById(\'appointments_iframe\');\n            var innerDoc = (iframe.contentDocument) ? iframe.contentDocument : iframe.contentWindow.document;\n\n            var r = innerDoc.getElementById(json_data[0]);\n            var bgcolor = (json_data[1]==1 ? \'LightGreen\' : (json_data[1]==0 ? \'#ffeb99\' : \'LightBlue\'));\n            r.style.backgroundColor = bgcolor;\n        } else {\n            alert(\'Προσοχή! Παρουσιάστηκε σφάλμα!\\nΗ δήλωση δεν πραγματοποιήθηκε!\');    \n        }\n    } else {\n        alert(\'Προσοχή! Παρουσιάστηκε σφάλμα!\\nΗ δήλωση δεν πραγματοποιήθηκε!\');\n    }\n}\n\n\nfunction delete_appointment_result(param){\n    if(param && param!=\'\'){ \n            var iframe = document.getElementById(\'appointments_iframe\');\n            var innerDoc = (iframe.contentDocument) ? iframe.contentDocument : iframe.contentWindow.document;\n            var r = innerDoc.getElementById(param);\n            if(r){\n                r.parentNode.removeChild(r);    \n            }\n    } else {\n        alert(\'Προσοχή! Παρουσιάστηκε σφάλμα!\\nΗ διαγραφή δεν πραγματοποιήθηκε!\')    \n    }\n}\n\nfunction validate_phone_number(phone_text){\n    \n    //eliminate every char except 0-9\n    var justNums = phone_text.replace(/[^0-9]/g, \'\');\n\n    if (justNums.length == 12){ // it\'s probably a valid phone number with country code in front\n        return(\'+\'+justNums);    \n    } else if (justNums.length == 10){ // it\'s probably a valid greek phone number\n        return(\'+30\'+justNums);\n    } else {\n        return false;\n    }\n}\n\nvar have_sms_balance = false;\nvar t_id=\'#RECORD_ID#\';\n\nfunction check_balance(param){\n    if(param!=\'N/A\' && param!=\'\' && param>0){\n       have_sms_balance = true; \n    } else {\n        have_sms_balance = false;\n    } \n}\n\nfunction open_sms_frame(phone_number){\n    var teacher_id = get_session_variable(\'teacher_id\');\n    teacher_id = (teacher_id!=-1 ? teacher_id  : 26);\n\n    var nb = validate_phone_number(phone_number);\n\n    if(nb){\n        set_session_variable(\'sms_mobile_number\',nb);\n        set_session_variable(\'sms_student_id\',\'-1\');\n        set_session_variable(\'sms_teacher_id\',\'#RECORD_ID#\');\n        \n        //nuAjax(\'sms_get_active_balance\',\'check_balance\');\n        \n        //if(have_sms_balance){\n            nuOpenFormInFrame(\'5711e1d915f5011\', teacher_id);\n        //} else {\n        //    alert(\'Έχει εξαντληθεί το υπόλοιπο μηνυμάτων στο λογαριασμό αποστολής!\\nΔεν μπορεί να πραγματοποιηθεί αποστολή SMS!\');\n        //}        \n    } else {\n        alert(\'Ο αριθμός τηλεφώνου δεν είναι έγκυρος!\');    \n    }    \n}\n\nfunction open_email_frame(email_address){\n    \n    var teacher_id = get_session_variable(\'teacher_id\');\n    teacher_id = (teacher_id!=-1 ? teacher_id  : 26);\n\n    set_session_variable(\'email_subject\',\'\');\n    set_session_variable(\'email_text\',\'\');\n    set_session_variable(\'email_recipients\',email_address);\n    \n    set_session_variable(\'sms_student_id\',\'-1\');\n    set_session_variable(\'sms_teacher_id\',\'#RECORD_ID#\');\n    \n    nuOpenFormInFrame(\'54a4107cddefff1\', teacher_id);\n}\n\nfunction nuLoadEdit() {\n    $(\'#appointment_from\').val($(\'#date_from_disp\').val());\n    $(\'#appointment_to\').val($(\'#date_to_disp\').val());\n    sumoTransform(\'appointment_student_id\',true,true);\n}',NULL,30,50,'0000-00-00 00:00:00','','2020-09-22 22:07:16','globeadmin','2021-01-26 20:15:02','globeadmin','',1,NULL),('547489b0d4efe7c','c00subject','Μαθήματα','select subject.*,subject_id,g_name,s_name,t_name\nfrom subject \nleft join ( select distinct subject_id\n            from card \n            where card.valid_from =(select max(timetable.start_date) from timetable)   \n            and class_id is not NULL) as crd on subject.id=crd.subject_id\nLEFT JOIN (SELECT id as g_id, short_name as g_name from grade) as g ON subject.grade_id=g.g_id\nLEFT JOIN (SELECT id as s_id, short_name as s_name, section_id as s_section_id from speciality) as s ON subject.speciality_id=s.s_id\nLEFT JOIN (SELECT id as t_id, short_name as t_name from subject_type) as t ON subject.subject_type_id=t.t_id\nLEFT JOIN (SELECT id as st_id, short_name as st_name from section) as st ON s.s_section_id=st.st_id\nwhere id>=10\norder by if(subject_id is null,\'Όχι\',\'Διδάσκεται\'),g_name,st_name,s_name,name,t_name DESC','subject','id',960,550,'select short_name from subject where id=#RECORD_ID#','1','0','1',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'select if(\'#RECORD_ID#\'>=10,\'1\',\'0\')',NULL,NULL,NULL,'$arr = nuSubformArray(\'subject_critirion_general_subform\',false);\n$critirio_id_array = array();\n\nfor( $idx = 0; $idx < count($arr); $idx++ ) {\n    $critirio_id_array[] = $nuHash[$arr[$idx].\'critirion_general_id\'];\n}\n\nif(count($critirio_id_array) != count(array_unique($critirio_id_array))) {\n        $MESSAGE = \'Προσοχή : Δεν μπορεί το ίδιο κριτήριο να αντιστοιχηθεί περισσότερες από μια φορές στο ίδιο μάθημα... \';\n        nuDisplayError($MESSAGE);\n        return;\n}\n\n$sql = \"    SELECT exam_curriculum\n            FROM subject\n            WHERE id=\'#RECORD_ID#\'\n        \";\n$retval = nuRunQuery($sql);\n\nif($row = db_fetch_row($retval)){\n    if($row[0]!=\'#exam_curriculum#\'){\n        $sql =\" UPDATE subject SET\n                    exam_curriculum_modified_at=NOW(),\n                    exam_curriculum_post_teacher_id = (SELECT teacher_id FROM session_variables WHERE session_id=\'#session_id#\')\n                WHERE id =\'#RECORD_ID#\'\";\n        nuRunQuery($sql);        \n    }\n}\n\n',NULL,'$sql = \"    SELECT COUNT(*)\n            FROM card\n            WHERE subject_id = \'#RECORD_ID#\'\n        \";\n$retval = nuRunQuery($sql);\n$row    = db_fetch_row($retval);\n\nif($row[0]!=0){\n    $MESSAGE = \'Προσοχή : Υπάρχουν διδασκαλίες με το μάθημα αυτό! Η διαγραφή δε μπορεί να πραγματοποιηθεί!\';\n    nuDisplayError($MESSAGE);\n    return;    \n}\n\n$sql = \"    SELECT COUNT(*)\n            FROM mark\n            WHERE subject_id = \'#RECORD_ID#\'\n        \";\n$retval = nuRunQuery($sql);\n$row    = db_fetch_row($retval);\n\nif($row[0]!=0){\n    $MESSAGE = \'Προσοχή : Υπάρχουν καταχωρημένοι βαθμοί στο μάθημα αυτό! Η διαγραφή δε μπορεί να πραγματοποιηθεί!\';\n    nuDisplayError($MESSAGE);\n    return;    \n}\n\n$sql = \"    SELECT COUNT(*)\n            FROM comment\n            WHERE subject_id = \'#RECORD_ID#\' and\n            ((teacher_comments is not NULL and trim(teacher_comments)<>\'\') OR (student_comments is not NULL and trim(student_comments) <>\'\'))\n        \";\n$retval = nuRunQuery($sql);\n$row    = db_fetch_row($retval);\n\nif($row[0]!=0){\n    $MESSAGE = \'Προσοχή : Υπάρχουν καταχωρημένα σχόλια στο μάθημα αυτό! Η διαγραφή δε μπορεί να πραγματοποιηθεί!\';\n    nuDisplayError($MESSAGE);\n    return;    \n}',NULL,NULL,'$sql = \"    DELETE\n            FROM comment\n            WHERE subject_id = \'#RECORD_ID#\'\n        \";\nnuRunQuery($sql);','function passTinymceContents(){\n    var y = document.getElementById(\'exam_curriculum\').value;\n    return(y);\n}\n\nfunction nuLoadEdit() {\n    $(\'#label1\').css(\"fontSize\", \"10px\");\n    $(\'#label1\').css(\'font-style\', \'italic\');\n}\n\nfunction nuOnSave(){     \n    if($(\'#absence_counts\').val()==\'0\' && !confirm(\'Για το μάθημα αυτό οι απουσίες θα καταχωρίζονται ως μη μετρήσιμες (διεγραμμένες)!\\nΕίστε σίγουρος;\'))\n            return false;\n    return true; \n}',NULL,40,150,'0000-00-00 00:00:00','','2022-02-14 11:00:17','globeadmin','2022-02-14 11:00:18','globeadmin','',1,NULL),('5474c1d7bef6b64','01subject','Διδασκόμενα Μαθήματα','select * \nfrom subject \nwhere subject.id in (\nselect distinct subject_id\nfrom card \nwhere card.valid_from =(select max(timetable.start_date) from timetable where (timetable.start_date <= curdate()))   \nand class_id is not NULL\n)\norder by short_name','subject','id',700,400,'','0','1','0',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,25,120,'2014-11-25 19:52:23','globeadmin','2016-01-04 10:17:01','globeadmin','2016-01-04 10:17:01','globeadmin','',0,NULL),('548338073921bfe','teacher_home','Καθηγητής','select * from teacher','teacher','id',1000,550,'select concat(IFNULL(surname,\'\'),\' \',IFNULL(name,\'\')) from teacher where id=#RECORD_ID#','0','1','0',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function get_excel_file(param){\n    if(param!=\'\' && param!=\'-1\'){\n        nuSetHash(\'backup_file_name\', param);\n        nuSetHash(\'send_file_name\', \'class_export.xls\');\n        nuRunPHP(\'backup_db_get_file\',\'hidden_iframe\');\n    } else {\n        alert(\'Η δημιουργία του αρχείου Excel απέτυχε!\'); \n    }\n    hideLoader();\n}\n\nfunction show_ajax_message(param){\n    alert(param);\n}\n\nfunction ajax_results(param){\n    if(param && param !=\'\' && param !=\'0\'){\n        e = document.getElementById(\'ab_warning_id\');\n        e.style.display = \'block\';\n        e.title = \'Έχετε \'+param+\' διδασκαλίες σε εκκρεμότητα\';\n    }\n}\n\nfunction nuLoadEdit() {\n    \n    set_session_variable(\'class_id\',-1);\n    set_session_variable(\'subject_id\',-1);\n    set_session_variable(\'mark_print_grading_period_id\',-1);\n    set_session_variable(\'mark_print_class_id\',-1);\n    set_session_variable(\'mark_print_subject_id\',-1);\n    \n    loadImg(\'log_user\');\n    loadImg(\'pabsen\');\n    loadImg(\'grprint\');\n    loadImg(\'mpost\');\n    \n    \n    $(\'#sms_disp\').css(\'fontSize\', \'18px\');\n    $(\'#sms_disp\').css(\'font-weight\', \'bold\');\n    $(\'#sms_disp\').css(\'background-color\', \'LightYellow\');\n    $(\'#sms_disp\').css(\'color\', \'red\');\n\n    if (typeof myInterval != \'undefined\'){\n        if(myInterval){\n            clearInterval(myInterval);\n        }\n    }\n    \n    if (typeof myTimeOut != \'undefined\'){\n        if(myTimeOut){\n            clearTimeout(myTimeOut);\n        }\n    }\n    \n    $(\'#abcence_periodbtn\').focus();\n    nuAjax(\'absence_has_card_not_registered\' , \'ajax_results\',{async:true});\n}',NULL,0,0,'0000-00-00 00:00:00','','2021-02-27 09:47:24','globeadmin','2022-01-08 10:51:55','globeadmin','',0,NULL),('5794b8d73636f76','system_check','Έλεγχος Συστήματος και Δεδομένων','select * from teacher','teacher','id',960,520,'select \'Έλεγχος Συστήματος και Δεδομένων\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function nuLoadEdit() {\n    sisMessage(\'Η λειτουργία αυτή είναι υπό κατασκευή...<br><br>Έχουν υλοποιηθεί μόνο οι βασικοί έλεγχοι που αφορούν τα  εξωτερικά δεδομένα και τις αρχικές ρυθμίσεις του συστήματος.\');\n}',NULL,0,0,'2016-07-24 15:47:19','globeadmin','2016-08-01 22:56:44','globeadmin','2021-03-09 14:58:24','globeadmin','',0,NULL),('5476201e5a3d38f','student2','Μαθητές','select student.*,grade_short_name\nfrom student \nleft join (select id as gid, short_name as grade_short_name from grade) as g on g.gid=student.grade_id\ninner join session_variables ON session_variables.session_id = \'#session_id#\'\nWHERE \n    (student.teacher_id = session_variables.teacher_id OR \n    student.advisor_id = session_variables.teacher_id OR\n    \'#nu_user_group#\' = \'Managers\' OR\n    \'#nu_user_group#\' = \'AssistManagers\' OR\n    \'#nu_user_group#\' = \'Administrators\' OR\n    \'#nu_user_group#\' = \'Secretaries\' OR\n    \'#nu_user_group#\' = \'globeadmin\')\norder by student.grade_id,student.surname,student.name,student.fathers_name\n','student','id',1050,800,'select concat(surname,\' \',name) from student where id=#RECORD_ID#','1','1','1',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'select if(\n            \'#nu_user_group#\'=\'Managers\' or \n            \'#nu_user_group#\'=\'AssistManagers\' or\n            \'#nu_user_group#\'=\'Administrators\' or\n            \'#nu_user_group#\'=\'globeadmin\'\n        ,\'1\',\'0\')','select if(\'#nu_user_group#\' IN (\'Managers\',\'AssistManagers\',\'Administrators\',\'globeadmin\',\'Secretaries\') OR session_variables.teacher_id=\'#teacher_id#\',\'1\',\'0\')\nfrom session_variables\nwhere session_id = \'#session_id#\'','select if(\'#nu_user_group#\' IN (\'Managers\',\'AssistManagers\',\'Administrators\',\'globeadmin\') OR session_variables.teacher_id=\'#teacher_id#\',\'1\',\'0\')\nfrom session_variables\nwhere session_id = \'#session_id#\'',NULL,NULL,NULL,NULL,NULL,'$sql = \"    SELECT COUNT(*)\n            FROM absence\n            WHERE student_id = \'#RECORD_ID#\'\n        \";\n$retval = nuRunQuery($sql);\n$row    = db_fetch_row($retval);\n\nif($row[0]!=0){\n    $MESSAGE = \'Προσοχή : Υπάρχουν καταχωρημένες απουσίες στο μαθητή! Η διαγραφή δε μπορεί να πραγματοποιηθεί!\';\n    nuDisplayError($MESSAGE);\n    return;    \n}\n\n\n$sql = \"    SELECT COUNT(*)\n            FROM mark\n            WHERE student_id = \'#RECORD_ID#\'\n        \";\n$retval = nuRunQuery($sql);\n$row    = db_fetch_row($retval);\n\nif($row[0]!=0){\n    $MESSAGE = \'Προσοχή : Υπάρχουν καταχωρημένοι βαθμοί στο μαθητή! Η διαγραφή δε μπορεί να πραγματοποιηθεί!\';\n    nuDisplayError($MESSAGE);\n    return;    \n}\n\n$sql = \"    SELECT COUNT(*)\n            FROM student_class\n            WHERE student_id = \'#RECORD_ID#\'\n        \";\n$retval = nuRunQuery($sql);\n$row    = db_fetch_row($retval);\n\nif($row[0]!=0){\n    $MESSAGE = \'Προσοχή : Ο μαθητής ανήκει σε τμήματα! Η διαγραφή δε μπορεί να πραγματοποιηθεί!\';\n    nuDisplayError($MESSAGE);\n    return;    \n}\n\n$sql = \"    DELETE \n            FROM zzzsys_user \n            WHERE zzzsys_user_id = \'#user_id#\'\n        \";\nnuRunQuery($sql);\n\n$sql = \"    DELETE \n            FROM zzzsys_user \n            WHERE zzzsys_user_id = \'#parent_user_id#\'\n        \";\nnuRunQuery($sql);\n\n ',NULL,NULL,NULL,'function update_student_status(param){\n    if(document.getElementById(\'state\')){\n        if(param!=\'-1\'){\n            if( param != document.getElementById(\'state\').innerHTML)\n                $(\'#state\').fadeOut(2000,function() {\n                    $(this).html(param).fadeIn(3600);\n                });\n        } else {\n            $(\'#state\').fadeOut(2000,function() {\n                    $(this).html(\'- - -\').fadeIn(3600);\n                });\n            //document.getElementById(\'state\').innerHTML=\'- - -\';\n        }\n    } else {\n        if(myInterval){\n            clearInterval(myInterval);\n        }    \n    }\n}\n\nfunction tickEvent(){\n    nuAjax(\'get_student_absence_state\',\'update_student_status\',{async:true});    \n}\n\nvar myInterval;\n\nfunction reload_classes(param){\n    nuRunPHP(\'student_classes\',\'student_class\');\n}\n\nfunction resetPassword(user_id){\n    nuSetHash(\'account_id\', user_id);\n    nuAjax(\'reset_account_password\',\'show_ajax_result\');\n}\n\nfunction show_ajax_result(param){\n    sisMessage(param);\n}\n\nfunction validate_phone_number(phone_text){\n    \n    //eliminate every char except 0-9\n    var justNums = phone_text.replace(/[^0-9]/g, \'\');\n\n    if (justNums.length == 12){ // it\'s probably a valid phone number with country code in front\n        return(\'+\'+justNums);    \n    } else if (justNums.length == 10){ // it\'s probably a valid greek phone number\n        return(\'+30\'+justNums);\n    } else {\n        return false;\n    }\n}\nvar have_sms_balance = false;\n\nfunction check_balance(param){\n    if(param!=\'N/A\' && param!=\'\' && param>0){\n       have_sms_balance = true; \n    } else {\n        have_sms_balance = false;\n    } \n}\n\nfunction open_sms_frame(phone_number){\n    var teacher_id = get_session_variable(\'teacher_id\');\n    teacher_id = (teacher_id!=-1 ? teacher_id  : 26);\n\n    var nb = validate_phone_number(phone_number);\n\n    if(nb){\n        set_session_variable(\'sms_mobile_number\',nb);\n        set_session_variable(\'sms_student_id\',\'#RECORD_ID#\');\n        set_session_variable(\'sms_teacher_id\',\'-1\');\n        \n        //nuAjax(\'sms_get_active_balance\',\'check_balance\');\n        \n        //if(have_sms_balance){\n            nuOpenFormInFrame(\'5711e1d915f5011\', teacher_id);\n        //} else {\n        //    alert(\'Έχει εξαντληθεί το υπόλοιπο μηνυμάτων στο λογαριασμό αποστολής!\\nΔεν μπορεί να πραγματοποιηθεί αποστολή SMS!\');\n        //}\n            \n    } else {\n        alert(\'Ο αριθμός τηλεφώνου δεν είναι έγκυρος!\');    \n    }    \n}\n\nfunction open_email_frame(email_address){\n    \n    var teacher_id = get_session_variable(\'teacher_id\');\n    teacher_id = (teacher_id!=-1 ? teacher_id  : 26);\n\n    set_session_variable(\'email_subject\',\'\');\n    set_session_variable(\'email_text\',\'\');\n    set_session_variable(\'email_recipients\',email_address);\n    \n    set_session_variable(\'sms_student_id\',\'#RECORD_ID#\');\n    set_session_variable(\'sms_teacher_id\',\'-1\');\n    \n    nuOpenFormInFrame(\'54a4107cddefff1\', teacher_id);\n}\n\nfunction disable_field(field){\n    $(\'#\'+field).css(\'background-color\', \'#ccc2b8\');\n\n    if ($(\'#\'+field).is(\'select\')) {\n      $(\'#\'+field).prop(\'disabled\', true);\n   } else {\n      $(\'#\'+field).prop(\'readonly\',true);\n   }\n\n}\n\nfunction nuLoadEdit() {\n\n    if(myInterval){\n        clearInterval(myInterval);\n    }\n    \n    tickEvent();\n    \n    myInterval=setInterval(tickEvent,60000);\n    \n    loadImg(\'search\');\n    loadImg(\'sbook\');\n    loadImg(\'jasabs\');\n// Απενεργοποιεί συγκεκριμένα πεδία για τους καθηγητές!    \n    if(\'#nu_user_group#\'!=\'Managers\' && \'#nu_user_group#\'!=\'AssistManagers\' && \'#nu_user_group#\'!=\'globeadmin\' && \'#nu_user_group#\'!=\'Administrators\'){\n        // Καθηγητής\n        disable_field(\'registration_number\');\n        disable_field(\'surname\');\n        disable_field(\'name\');\n        disable_field(\'fathers_name\');\n        disable_field(\'mothers_name\');\n        disable_field(\'mothers_surname\');\n        disable_field(\'gender\');\n        disable_field(\'speciality_id\');\n        disable_field(\'grade_id\');\n        disable_field(\'parent_surname\');\n        disable_field(\'parent_name\');\n        disable_field(\'user_id\');\n        disable_field(\'parent_user_id\'); \n        disable_field(\'teacher_id\');\n        disable_field(\'advisor_id\');\n        disable_field(\'prev_an_justified_absences\');\n        disable_field(\'prev_justified_absences\');\n    } \n\n    $(\'#absence_counts_sum_disp\').css(\'fontSize\', \'18px\');\n    $(\'#absence_counts_sum_disp\').css(\'font-weight\', \'bold\');\n    $(\'#absence_counts_sum_disp\').css(\'background-color\', \'LightYellow\');\n    $(\'#absence_counts_sum_disp\').css(\'color\', \'red\');\n    \n    $(\'#justified_absence_nocounts_disp\').css(\'fontSize\', \'18px\');\n    $(\'#justified_absence_nocounts_disp\').css(\'font-weight\', \'bold\');\n    $(\'#justified_absence_nocounts_disp\').css(\'background-color\', \'LightYellow\');\n    $(\'#justified_absence_nocounts_disp\').css(\'color\', \'green\');    \n\n    /*$(\'#unjustified_absence_sum_disp\').css(\'fontSize\', \'18px\');\n    $(\'#unjustified_absence_sum_disp\').css(\'font-weight\', \'bold\');\n    $(\'#unjustified_absence_sum_disp\').css(\'background-color\', \'LightYellow\');\n    $(\'#unjustified_absence_sum_disp\').css(\'color\', \'red\');\n\n    $(\'#justified_absence_sum_disp\').css(\'fontSize\', \'18px\');\n    $(\'#justified_absence_sum_disp\').css(\'font-weight\', \'bold\');\n    $(\'#justified_absence_sum_disp\').css(\'background-color\', \'LightYellow\');\n    $(\'#justified_absence_sum_disp\').css(\'color\', \'green\');\n    \n    $(\'#parent_justified_days_disp\').css(\'fontSize\', \'18px\');\n    $(\'#parent_justified_days_disp\').css(\'font-weight\', \'bold\');\n    $(\'#parent_justified_days_disp\').css(\'background-color\', \'LightYellow\');\n    $(\'#parent_justified_days_disp\').css(\'color\', \'#FFA500\'); */  \n    \n    $(\'#label_student\').css(\'fontSize\', \'14px\');\n    $(\'#label_student\').css(\'font-weight\', \'bold\');\n    $(\'#label_student\').css(\'text-decoration\', \'underline\');\n    \n    $(\'#label_parent\').css(\'fontSize\', \'14px\');\n    $(\'#label_parent\').css(\'font-weight\', \'bold\');\n    $(\'#label_parent\').css(\'text-decoration\', \'underline\');\n\n    $(\'#nuButton0\').focus();\n    \n    nuFORM.edited = 0;\n}',NULL,25,100,'2014-11-26 20:46:54','globeadmin','2021-03-24 11:07:56','globeadmin','2022-01-08 11:22:25','globeadmin','',1,'select if(\'#nu_user_group#\' IN (\'Administrators\',\'Managers\',\'AssistManagers\',\'Secretaries\',\'Teachers\'),\'1\',\'0\')'),('5478c7e75911cd4','upload_data','Upload ASC Timetable and mySchool Data','select * from zzzsys_file','zzzsys_file','zzzsys_file_id',0,0,'','0','1','1',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,'//fetch the uploaded file information\n$S = stripslashes(\'#FILES#\');\n$J = json_decode($S);\n\n$name = $J[0]->{\'name\'};\n$type = $J[0]->{\'type\'};\n$error = $J[0]->{\'error\'};\n$size  = $J[0]->{\'size\'};\n\n$uploaddir= sys_get_temp_dir();\n$uploadfile = $uploaddir .\'/\'.$name;\n\n//obtain the contents of the file\n$contents = file_get_contents($uploadfile);\n$contents = addslashes($contents);\n\n//put the file information and contents into the database\n$s = \"\n    UPDATE zzzsys_file\n    SET\n        sfi_blob = \'$contents\',\n        sfi_name = \'$name\',\n        sfi_type = \'$type\',\n        sfi_size = \'$size\'\n    WHERE zzzsys_file_id = \'#RECORD_ID#\'\n\";\n\nnuRunQuery($s);\n//delete the temporary file.\nunlink($uploadfile);\n',NULL,NULL,NULL,0,0,'2014-11-28 21:07:19','globeadmin','2014-11-30 21:02:43','globeadmin','2015-02-15 12:52:47','globeadmin','',0,NULL),('547d6ec60ac6bdd','set_marks','Καταχώριση Βαθμολογίας','select * from teacher','teacher','id',1100,950,'',NULL,'1',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'','$sql=\"CREATE TEMPORARY TABLE IF NOT EXISTS mark_#nu_user_id#_#session_id# (\n  id INT NULL,\n  value DECIMAL(4,1) NULL DEFAULT 0,\n  added_when DATETIME NULL,\n  grading_period_id INT NULL,\n  student_id INT NULL,\n  subject_id INT NULL,\n  post_teacher_id INT NULL,\n  student_registration_number VARCHAR(100) NULL,\n  student_surname VARCHAR(100) NULL,\n  student_name VARCHAR(100) NULL,\n  student_fathers_name VARCHAR(100) NULL,\n  post_teacher_short VARCHAR(100) NULL,\n  student_has_left_school TINYINT(1),\n  class_id INT NULL,\n  published BOOLEAN NULL DEFAULT FALSE,\n  comments varchar(5000) NULL) ENGINE=MEMORY  DEFAULT CHARSET=utf8\";\n$retval = nuRunQuery($sql);\n\n$sql=\"delete from mark_#nu_user_id#_#session_id# where 1\";\n$retval = nuRunQuery($sql);\n\n$sql=\"select grading_period_id,subject_id,class_id from session_variables WHERE session_id=\'#session_id#\'\";\n$retval = nuRunQuery($sql);\n\n$grading_period_id=-1;\n$subject_id=-1;\n$class_id=-1;\n        \nif($retval){\n    if($row = db_fetch_row($retval)) {\n        $grading_period_id=(is_null($row[0]) ? -1 : $row[0]);\n        $subject_id=(is_null($row[1]) ? -1 : $row[1]);\n        $class_id=(is_null($row[2]) ? -1 : $row[2]);\n        }\n    }\n\nif (($grading_period_id!=-1) && ($subject_id!=-1) && ($class_id!=-1)){\n    \n    $sql=\"insert into mark_#nu_user_id#_#session_id# \n    SELECT \n	        null as id,\n            0 as value,\n            now() as added_when,\n            \".$grading_period_id.\" as grading_period_id,\n            student_class.student_id as student_id,\n            \".$subject_id.\" as subject_id,\n            #RECORD_ID# as post_teacher_id,\n            student.registration_number as student_registration_number,\n            student.surname as student_surname,\n            student.name as student_name,\n            student.fathers_name as student_fathers_name,\n            null as post_teacher_short,\n            student.has_left_school as student_has_left_school,\n            student_class.class_id,\n            0,\n            NULL\n        FROM student_class\n        inner join student\n        on student_class.student_id=student.id\n        WHERE\n	        student_class.class_id=\".$class_id;\n    $retval = nuRunQuery($sql);   \n    \n    $sql=\"insert into mark\n        SELECT \n	        tmp_tbl.id,\n            tmp_tbl.value,\n            tmp_tbl.added_when,\n            tmp_tbl.grading_period_id,\n            tmp_tbl.student_id,\n            tmp_tbl.subject_id,\n            tmp_tbl.post_teacher_id,\n            tmp_tbl.class_id,\n            0,\n            NULL\n        FROM mark_#nu_user_id#_#session_id# as tmp_tbl\n        WHERE\n            (tmp_tbl.grading_period_id,tmp_tbl.subject_id,tmp_tbl.student_id) not in\n            (select \n                m2.grading_period_id,m2.subject_id,m2.student_id \n                from mark as m2 \n                where \n                    m2.grading_period_id=\".$grading_period_id.\" and m2.subject_id=\".$subject_id.\")\";\n    $retval = nuRunQuery($sql); \n\n    $sql=\"update mark_#nu_user_id#_#session_id# as t, mark\n        set t.id = mark.id,\n        t.value = mark.value, \n        t.post_teacher_id = mark.post_teacher_id,\n        t.added_when=mark.added_when,\n        t.published=mark.published,\n        t.comments=mark.comments\n    where \n        t.grading_period_id=mark.grading_period_id and\n        t.subject_id=mark.subject_id and\n        t.student_id=mark.student_id\";\n    $retval = nuRunQuery($sql);\n\n    $sql=\"update mark_#nu_user_id#_#session_id# as t, teacher\n        set t.post_teacher_short = teacher.short_name\n    where t.post_teacher_id=teacher.id\";\n    $retval = nuRunQuery($sql);\n    \n}else{\n    //nuDebug($grading_period_id.\",\".$subject_id.\",\".$class_id);\n}\n',NULL,NULL,'function disable_field(field){\n    $(\'#\'+field).css(\'background-color\', \'#ccc2b8\');\n\n    if ($(\'#\'+field).is(\'select\')) {\n      $(\'#\'+field).prop(\'disabled\', true);\n   } else {\n      $(\'#\'+field).prop(\'readonly\',true);\n   }\n\n}\n\nfunction foo(param){\n    ;\n}\nfunction pass_session_variable(param){\n    nuSetHash(\'varval\', param);\n}\nfunction get_session_variable(varname){\n    nuSetHash(\'varname\', varname);\n    nuAjax(\'getSessionVariable\',\'pass_session_variable\');\n    return nuGetHash(\'varval\');\n}\nfunction set_session_variable(varname,varval){\n    nuSetHash(\'varname\', varname);\n    nuSetHash(\'varval\', varval);\n    nuAjax(\'setSessionVariable\',\'foo\');\n}\n\nfunction nuLoadEdit() {\n    var class_id = get_session_variable(\'class_id\');\n    var subject_id = get_session_variable(\'subject_id\');\n    \n    $(\'#granding_period_end_date\').css(\'background-color\', \'red\');\n    $(\'#granding_period_end_date\').css(\'color\', \'white\');\n    \n    if (class_id!=-1 && subject_id!=-1){\n        $(\'#class_subject_selection\').val(class_id+\',\'+subject_id);\n    }\n    \n    var subFormPrefixes = nuSubformArray(\'mark_subform\', true);\n    \n    for( var index in subFormPrefixes) {\n        if($(\'#\'+subFormPrefixes[index]+\'student_has_left_school\').val()==\'ΟΧΙ\'){\n            $(\'#\'+subFormPrefixes[index]+\'student_has_left_school\').css(\'background-color\', \'red\');\n            $(\'#\'+subFormPrefixes[index]+\'student_has_left_school\').css(\'color\', \'white\');\n        }\n        \n        if($(\'#\'+subFormPrefixes[index]+\'published_dsp\').val()==\'ΝΑΙ\'){\n            $(\'#\'+subFormPrefixes[index]+\'published_dsp\').css(\'background-color\', \'red\');\n            $(\'#\'+subFormPrefixes[index]+\'published_dsp\').css(\'color\', \'white\');\n            \n            //Απενεργοποίηση της επεξεργασίας του βαθμού value\n            disable_field(subFormPrefixes[index]+\'value\');\n        }      \n    }\n    \n    if(subFormPrefixes.length>0){\n        $(\'#\'+subFormPrefixes[0]+\'value\').focus();\n        $(\'#\'+subFormPrefixes[0]+\'value\').select();    \n    } else{\n        $(\'#class_subject_selection\').focus();\n    }\n}\n\nfunction nuOnSave(){ \n      //Place all of the fields data-prefixes in an array.\n    var subFormPrefixes = nuSubformArray(\'mark_subform\', true);\n \n    //Loop through each of the rows.\n    for( var index in subFormPrefixes) {\n        //Obtain value on the current row\n        var value  = $(\'#\'+subFormPrefixes[index]+\'value\').val();\n        if(value!=\'\'){\n            var v=parseFloat(value.replace(\',\',\'.\'));\n            if (v<0 || v>20){\n                alert(\'Παρακαλώ εισάγετε βαθμούς από Μηδέν (0) εως Είκοσι (20)!\');\n                $(\'#\'+subFormPrefixes[index]+\'value\').focus();\n                $(\'#\'+subFormPrefixes[index]+\'value\').select();\n                return false;\n            }\n            \n            if (v==0 && ($(\'#\'+subFormPrefixes[index]+\'student_has_left_school\').val()!=\'ΟΧΙ\')){\n                var student_full_name=($(\'#\'+subFormPrefixes[index]+\'student_surname\').val())+\' \'+($(\'#\'+subFormPrefixes[index]+\'student_name\').val());\n                if(!confirm(\'Το μαθητή \'+student_full_name+\' τον έχετε βαθμολογήσει με μηδέν (0,0)\\nπαρότι είναι ενεργός (δεν έχει εγκαταλείψει το σχολειό)!\\n\\nΕίστε σίγουρος;\')){\n                    return false;    \n                }    \n            }\n            \n        } else if ($(\'#\'+subFormPrefixes[index]+\'student_has_left_school\').val()!=\'ΟΧΙ\') {\n            var student_full_name=($(\'#\'+subFormPrefixes[index]+\'student_surname\').val())+\' \'+($(\'#\'+subFormPrefixes[index]+\'student_name\').val())\n            if(!confirm(\'Για το μαθητή \'+student_full_name+\' δεν έχετε καταχωρήσει βαθμό\\nπαρότι είναι ενεργός (δεν έχει εγκαταλείψει το σχολειό)!\\n\\nΕίστε σίγουρος;\')){\n                return false;        \n            }    \n        }\n        \n    }\n    \n    var ch_desimals = false;\n    var num_of_decimals = get_session_variable(\'grading_period_decimals\');\n    \n    if (num_of_decimals<0) num_of_decimals=0;\n    \n    for( index in subFormPrefixes) {\n        //Obtain value on the current row\n        value  = $(\'#\'+subFormPrefixes[index]+\'value\').val();\n        if(value!=\'\'){\n            v=parseFloat(value.replace(\',\',\'.\'));\n        \n            vd=v.toFixed(num_of_decimals);\n            vd=parseFloat(vd.toString());\n            vd=vd.toFixed(1);\n        \n            vds=vd.toString();\n            vds=vds.replace(\'.\',\',\');\n        \n            if (v!=vd){\n                $(\'#\'+subFormPrefixes[index]+\'value\').val(vds);\n                ch_desimals = true;\n            }\n        }\n    }\n        \n    if (ch_desimals){\n        alert(\'Απαιτούνται ακέραιοι βαθμοί σε αυτή τη βαθμολογική περίοδο!\\n\\nΟι αλλαγές δεν αποθηκεύτηκαν!\\n\\nΑν συμφωνείτε με τις στρογγυλοποιήσεις, αποθηκεύστε ξανά!\');    \n        return false;\n    }\n    \n    return true; \n}\n\n',NULL,0,0,'2014-12-02 09:48:22','globeadmin','2021-03-24 11:12:34','globeadmin','2021-03-24 11:12:34','globeadmin','',0,NULL),('54835ec50abe722','foo_home','Home Form for All','select * from foo','foo','foo',960,520,'select \'Καλώς Ήρθατε\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'','nuRunPHP(\'addSessionVariablesRow\');\nnuRunPHP(\'initializeSessionVariables\');',NULL,NULL,'function openUser(student_id){\n    if($.isNumeric(student_id)){\n        if (student_id!=\'-1\'){\n            nuOpenForm(\'54835ec50abe722\',\'-1\', \'54a6fde1ab6eb6d\', student_id,\'Μαθητής\');\n        } else{\n            \n            $(\'#user_not_found_msg1\').width(620);\n            $(\'#user_not_found_msg2\').width(620);\n            \n            $(\'#user_not_found_msg1\').css(\'fontSize\', \'18px\');\n            $(\'#user_not_found_msg1\').css(\'font-weight\', \'bold\');\n            $(\'#user_not_found_msg1\').css(\'background-color\', \'#FAF0E6\');\n            $(\'#user_not_found_msg1\').css(\'color\', \'red\');\n            $(\'#user_not_found_msg1\').val(\"Ο Λογαριασμός αυτός δεν είναι συνδεδεμένος με μαθητή ή γονέα!\");\n            \n            \n            $(\'#user_not_found_msg2\').css(\'fontSize\', \'18px\');\n            $(\'#user_not_found_msg2\').css(\'font-weight\', \'bold\');\n            $(\'#user_not_found_msg2\').css(\'background-color\', \'#FAF0E6\');\n            $(\'#user_not_found_msg2\').css(\'color\', \'red\');\n            $(\'#user_not_found_msg2\').val(\"Παρακαλώ επικοινωνήστε με το διαχειριστή του συστήματος!\");\n        }\n    } else{\n        nuReloadForm();\n    }    \n}\n\nfunction nuLoadEdit() {\n    var s=get_session_variable(\'student_id\');\n    \n    setTimeout(function(){openUser(s);},1000);\n}\n\n',NULL,0,0,'2014-12-06 21:53:41','globeadmin','2021-03-24 11:23:58','globeadmin','2021-03-24 11:23:58','globeadmin','',0,NULL),('54d65f0144e61a3','penalty_read','Εισάγει τις ποινές από αρχείο excel του myschool','select * from teacher','teacher','id',1000,530,'select \'Εισαγωγή Ποινών από Αρχείο Excel\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'','$sql=\"delete from penalty_in where 1\";\nnuRunQuery($sql);',NULL,NULL,'function nuLoadEdit() {\n    nuSetHash(\'FILES\' , \'\');\n}',NULL,0,0,'2015-02-07 20:52:49','globeadmin','2018-07-02 09:23:39','globeadmin','2018-07-02 09:23:39','globeadmin','',0,NULL),('5495dad1762dc2c','print_marks','Εκτύπωση Βαθμολογίας','select * from teacher','teacher','id',960,520,'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function foo(param){\n    ;\n}\nfunction pass_session_variable(param){\n    nuSetHash(\'varval\', param);\n}\nfunction get_session_variable(varname){\n    nuSetHash(\'varname\', varname);\n    nuAjax(\'getSessionVariable\',\'pass_session_variable\');\n    return nuGetHash(\'varval\');\n}\nfunction set_session_variable(varname,varval){\n    nuSetHash(\'varname\', varname);\n    nuSetHash(\'varval\', varval);\n    nuAjax(\'setSessionVariable\',\'foo\');\n}\n\nfunction refresh_lessons(param){\n    $(\'#print_marks_class_subject_selection\').empty()\n    if(!param==\'\'){\n    var ln = param.split(\'\\n\'); \n    for(i=0;i<ln.length;i++){  \n        var fld=ln[i].split(\'\\t\');\n        $(\'#print_marks_class_subject_selection\').append(\'<option value=\"\'+fld[0]+\'\">\'+fld[1]+\'</option>\'); \n        }\n    }\n}\n\nfunction nuLoadEdit() {\n    var grading_period_id = get_session_variable(\'mark_print_grading_period_id\');\n    //var class_id = get_session_variable(\'mark_print_class_id\');\n    //var subject_id = get_session_variable(\'mark_print_subject_id\');\n    \n    $(\'#marks_print_help_label\').css(\"fontSize\", \"10px\");\n    $(\'#marks_print_help_label\').css(\'font-style\', \'italic\');\n\n    if (grading_period_id!=-1){\n        $(\'#print_marks_grading_period_selection\').val(grading_period_id);\n        }\n}',NULL,0,0,'2014-12-20 22:23:45','globeadmin','2015-11-21 23:39:40','globeadmin','2020-04-02 16:20:08','globeadmin','',0,NULL),('54ce7f0188a78ec','speciality','Ειδικότητες','select *,s.s_name \nfrom speciality\ninner join (select id as s_id, short_name as s_name from section) as s on s.s_id=speciality.section_id\norder by section_id,name','speciality','id',960,520,'select short_name from speciality where id=#RECORD_ID#','1','1','1',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'SELECT IF(\'#RECORD_ID#\'=\'-1\',\'0\',\'1\')',NULL,NULL,NULL,NULL,NULL,'$sql = \"    SELECT COUNT(*)\n            FROM student\n            WHERE speciality_id = \'#RECORD_ID#\'\n        \";\n$retval = nuRunQuery($sql);\n$row    = db_fetch_row($retval);\n\nif($row[0]!=0){\n    $MESSAGE = \'Προσοχή : Υπάρχουν μαθητές στην ειδικότητα αυτή! Η διαγραφή δε μπορεί να πραγματοποιηθεί!\';\n    nuDisplayError($MESSAGE);\n    return;    \n}\n\n\n$sql = \"    SELECT COUNT(*)\n            FROM subject\n            WHERE speciality_id = \'#RECORD_ID#\'\n        \";\n$retval = nuRunQuery($sql);\n$row    = db_fetch_row($retval);\n\nif($row[0]!=0){\n    $MESSAGE = \'Προσοχή : Υπάρχουν μαθήματα στην ειδικότητα αυτή! Η διαγραφή δε μπορεί να πραγματοποιηθεί!\';\n    nuDisplayError($MESSAGE);\n    return;    \n}\n',NULL,NULL,NULL,NULL,NULL,35,50,'0000-00-00 00:00:00','','2018-07-29 15:35:19','globeadmin','2018-07-29 15:35:19','globeadmin','',1,NULL),('54a26a8d05fa91d','export_marks_excel','Εξαγωγή Βαθμολογίας στο Excel','select * from foo','foo','foo',960,550,'select \'Εξαγωγή Βαθμολογίας στο Excel\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function foo(param){\n    ;\n}\nfunction pass_session_variable(param){\n    nuSetHash(\'varval\', param);\n}\nfunction get_session_variable(varname){\n    nuSetHash(\'varname\', varname);\n    nuAjax(\'getSessionVariable\',\'pass_session_variable\');\n    return nuGetHash(\'varval\');\n}\nfunction set_session_variable(varname,varval){\n    nuSetHash(\'varname\', varname);\n    nuSetHash(\'varval\', varval);\n    nuAjax(\'setSessionVariable\',\'foo\');\n}\n\nfunction nuLoadEdit() {\n    nuSetHash(\'export_grading_period_id\', 0);\n}\n',NULL,0,0,'2014-12-30 11:04:13','globeadmin','2018-07-28 11:43:25','globeadmin','2018-07-28 11:43:25','globeadmin','',0,NULL),('54a312a5698c8f9','teachers_owe_marks','Μαθήματα Χωρίς Αξιολόγηση','select * from teacher','teacher','id',960,450,'select \'Μαθήματα Χωρίς Αξιολόγηση\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function nuLoadEdit() {\n\n}\n',NULL,0,0,'2014-12-30 23:01:25','globeadmin','2018-07-28 11:48:11','globeadmin','2020-10-17 23:16:13','globeadmin','',0,NULL),('54a4107cddefff1','send_email','Στέλνει μαζικά emails','select * from teacher','teacher','id',860,560,'select \'Αποστολή Email\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function passTinymceContents(){\n    var y = document.getElementById(\'email_text\').value;\n    return(y);\n}\n\nfunction display_sent_result(param){\n    hideLoader();\n    alert(param);\n    nuRemoveModal();\n}\n\nfunction nuLoadEdit() {\n    $(\'#reciever_name\').css(\'fontSize\', \'16px\');\n    $(\'#reciever_name\').css(\'font-weight\', \'bold\');\n    $(\'#reciever_name\').css(\'background-color\', \'#FAF0E6\');\n    $(\'#reciever_name\').css(\'color\', \'#25237A\');\n    \n    $(\'#email_recipients\').val(get_session_variable(\'email_recipients\'));\n    $(\'#email_subject\').val(get_session_variable(\'email_subject\'));\n    $(\'#email_text\').val(get_session_variable(\'email_text\'));\n}\n',NULL,0,0,'2014-12-31 17:04:28','globeadmin','2021-03-24 11:17:18','globeadmin','2021-03-24 11:17:18','globeadmin','',0,NULL),('54a52c3dcf3610b','email_settings','Email and SMS Settings','select * from zzzsys_setup','zzzsys_setup','zzzsys_setup_id',960,530,'select \'Ρυθμίσεις Αποστολής Email - SMS\'',NULL,'1',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,'$sql=\"update sms_gateway set active=0\";\nnuRunQuery($sql);\n\nif(\'#sms_gateway_id#\'!=\'\'){\n    $sql=\"  update sms_gateway set \n                active=1,\n                login_name=\'#sms_login_name#\',\n                login_password=\'#sms_login_password#\',\n                api_key = \'#sms_api_key#\',\n                originator=\'#sms_originator#\'\n            where id=\'#sms_gateway_id#\'\";\n    nuRunQuery($sql);\n}\n',NULL,'function pollute_sms_details(param){\n\n    if(param!=\'\'){\n        var json_data = JSON.parse(param);\n        \n        $(\'#sms_login_name\').val(json_data[0][1]);\n        $(\'#sms_login_password\').val(json_data[0][2]);\n        $(\'#sms_api_key\').val(json_data[0][3]);\n        $(\'#sms_originator\').val(json_data[0][4]);\n    } else {\n        $(\'#sms_login_name\').val(\'\');\n        $(\'#sms_login_password\').val(\'\');\n        $(\'#sms_api_key\').val(\'\');\n        $(\'#sms_originator\').val(\'\');    \n    }\n}\n\nfunction nuLoadEdit() {  \n    $(\'#emails_settings_label1\').css(\'fontSize\', \'12px\');\n    $(\'#emails_settings_label1\').css(\'font-weight\', \'bold\');\n    $(\'#emails_settings_label1\').css(\'font-style\', \'italic\');\n\n    $(\'#emails_settings_label2\').css(\'font-style\', \'italic\');\n    $(\'#emails_settings_label3\').css(\'font-style\', \'italic\');\n    $(\'#emails_settings_label4\').css(\'font-style\', \'italic\');\n    $(\'#emails_settings_label5\').css(\'font-style\', \'italic\');\n    $(\'#emails_settings_label6\').css(\'font-style\', \'italic\');\n    $(\'#emails_settings_label7\').css(\'font-style\', \'italic\');\n    $(\'#emails_settings_label8\').css(\'font-style\', \'italic\');\n    \n    $(\'#sms_gateway_id\').val($(\'#sms_gateway_id_disp\').val());\n    $(\'#sms_login_name\').val($(\'#sms_login_name_disp\').val());\n    $(\'#sms_login_password\').val($(\'#sms_login_password_disp\').val());\n    $(\'#sms_api_key\').val($(\'#sms_api_key_disp\').val());\n    $(\'#sms_originator\').val($(\'#sms_originator_disp\').val());\n    \n    $(\'#sms_originator\').attr(\'maxlength\',11);\n    \n    nuRunPHP(\'sms_get_balance\',\'sms_balance_disp\');\n}',NULL,0,0,'2015-01-01 13:15:09','globeadmin','2019-07-27 23:23:28','globeadmin','2019-07-27 23:23:28','globeadmin','',0,NULL),('54a65ecc3f14737','change_account','Στοιχεία Λογαριασμού','select * from zzzsys_user','zzzsys_user','zzzsys_user_id',960,530,'select concat(\'Λογαριασμός (\',\'#nu_user_name#\',\')\')',NULL,'1',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'select if(\'#login_with_email_account#\'=\'0\' or \'#nu_user_group#\'=\'globeadmin\',\'1\',\'0\')',NULL,NULL,NULL,NULL,'$sql = \"select md5(CONCAT(zzzsys_user.sus_login_name, \'#oldpass#\')),zzzsys_user.sus_login_password \n        from zzzsys_user \n        WHERE zzzsys_user_id = \'#nu_user_id#\'\";\n$retval=nuRunQuery($sql);\n\nif($row = db_fetch_row($retval)){\n   if($row[0]!=$row[1]){\n        $MESSAGE = \'Κωδικός πρόσβασης δεν είναι σωστός!\';\n        nuDisplayError($MESSAGE);\n        return;\n    }\n} else {\n    $MESSAGE = \'Παρουσιάστηκε σφάλμα κατά τον έλεγχο του κωδικού πρόσβασης! Η αλλαγή δεν πραγματοποιήθηκε!\';\n    nuDisplayError($MESSAGE);\n    return;\n}',NULL,'','if(\'#nu_user_group#\'!=\'globeadmin\' && \'#nu_user_id#\'!=\'#RECORD_ID#\'){\n    $MESSAGE = \'Προσοχή! Δεν έχετε άδεια πρόσβασης στον λογαριασμό αυτόν!\';\n    nuDisplayError($MESSAGE);\n    return;\n}','function nuGetPost($Field_Name) {\n    $form_post = $_POST[\'nuWindow\'][\'form_data\'][\'data\'][0][\'records\'][0][\'fields\'];\n    for ($x = 0; $x < count($form_post); $x++) {\n       if ( $form_post[$x][\'field\'] == $Field_Name ) {\n           return $form_post[$x][\'value\'];\n       }\n    }\n    return null;\n}\n\n$user = nuGetPost(\'sus_login_name\');\n$pass = nuGetPost(\'nupassword\');\nif($pass != \'\') {\n	$sql = \"UPDATE zzzsys_user SET sus_login_password = md5(CONCAT(\'$user\', \'$pass\')) WHERE zzzsys_user_id = \'#RECORD_ID#\'\";\n	nuRunQuery($sql);\n}',NULL,'function checkStrengthMsg(password){\n        \n        var msg = \'\';\n        \n        //if the password not set\n		if (!password || (password.length < 6)) { \n			msg += (\'\\nΟ κωδικός πρόσβασης θα πρέπει να αποτελείται από τουλάχιστον έξι (6) χαρακτήρες!\');\n		}\n		\n		//Must have characters\n		if (!password.match(/([a-zA-Z])/)){\n		    msg += (\'\\nΟ κωδικός πρόσβασης θα πρέπει να περιέχει τουλάχιστον ένα γράμμα!\'); \n		} \n		\n        //Must have numbers\n		if (!password.match(/([0-9])/)){\n		    msg += (\'\\nΟ κωδικός πρόσβασης θα πρέπει να περιέχει τουλάχιστον ένα αριθμο!\'); \n		} \n		\n		//Must have at least one special character\n		if (!password.match(/([!,%,&,@,#,$,^,*,?,_,~])/)) {\n		    msg += (\'\\nΟ κωδικός πρόσβασης θα πρέπει να περιέχει τουλάχιστον ένα ειδικό χαρακτήρα (!,%,&,@,#,$,^,*,?,_,~)!\'); \n		}\n		\n		return msg;\n	}\n\nfunction nuLoadEdit() {\n    $(\'#oldpass_hide\').hide();\n    $(\'#change_account_label1\').css(\'fontSize\', \'14px\');\n    $(\'#change_account_label1\').css(\'font-weight\', \'bold\');\n    $(\'#change_account_label1\').css(\'font-style\', \'italic\');\n\n    $(\'#change_account_label2\').css(\'font-style\', \'italic\');\n    $(\'#change_account_label3\').css(\'font-style\', \'italic\');\n    $(\'#change_account_label4\').css(\'font-style\', \'italic\');\n	}\n\n\nfunction nuOnSave() {\n    \n    var pass     = document.getElementById(\'nupassword\').value;\n	var repass  = document.getElementById(\'nuretyped\').value;\n	var logname = document.getElementById(\'sus_login_name\').value;\n	\n    //checkLogin\n	if(logname.length<3) {\n		alert(\'Το «Όνομα Χρήστη» πρέπει να αποτελείται από τουλάχιστον τρεις (3) χαρακτήρες!\');\n		return false;\n	} \n	\n	//checkPasswords\n	if(!pass){\n	    alert(\'Παρακαλώ συμπληρώστε το «Νέο Κωδικό Πρόσβασης»\');\n		return false;\n	}\n	\n    if(pass != repass) {\n        alert(\'Ο «Κωδικός Πρόσβασης» δεν ταιριάζει με την «Επιβεβαίωση Κωδικού»...\');\n        return false;\n    } \n    \n    var m = checkStrengthMsg(pass);\n    \n    if(m!=\'\'){\n        if(\'#nu_user_group#\'==\'Students\'){\n            if(!confirm(\'Ο κωδικός πρόσβασης δεν είναι αρκετά ισχυρός :\'+m+\'\\n\\nΘέλετε να συνεχίσετε;\')){\n                return false;    \n            } else {\n                \n            }   \n        } else {\n            alert(m);\n            return false;    \n        }\n    }\n    \n	return true;\n}',NULL,0,0,'2015-01-02 11:03:08','globeadmin','2018-07-28 00:36:31','globeadmin','2018-07-28 00:36:31','globeadmin','',0,NULL),('54a6fde1ab6eb6d','student_personal_parent','Μαθητής - Γονέας - Προσωπικά Στοιχεία','select * from student','student','id',1050,520,'select concat(IFNULL(surname,\'\'),\' \',IFNULL(name,\'\'), \' (Στοιχεία Μαθητή)\') from student where id=#RECORD_ID#',NULL,'1',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'SELECT allow_parents_to_edit FROM school',NULL,NULL,NULL,NULL,'$sql = \"SELECT allow_parents_to_edit FROM school\";\n$retval = nuRunQuery($sql);\nif($retval && $row = db_fetch_row($retval)){\n    if((\'#nu_user_group#\'!=\'globeadmin\' && \'#nu_user_group#\'!=\'Parents\') || $row[0]!=\'1\'){\n        $MESSAGE = \'Προσοχή! Η αποθήκευση δεν επιτρέπεται!\';\n        nuDisplayError($MESSAGE);\n        return;\n    }\n}\n\n$sql = \"SELECT * FROM student WHERE id=\'#RECORD_ID#\'\";\n$retval = nuRunQuery($sql);\nif($retval && $row = db_fetch_array($retval)){\n    if( \'#surname#\' != $row[\'surname\'] ||\n        \'#name#\' != $row[\'name\'] ||\n        \'#fathers_name#\' != $row[\'fathers_name\'] ||\n        \'#mothers_name#\' != $row[\'mothers_name\'] ||\n        \'#mothers_surname#\' != $row[\'mothers_surname\'] ||\n        \'#parent_surname#\' != $row[\'parent_surname\'] ||\n        \'#parent_name#\' != $row[\'parent_name\'] ||\n        \'#registration_number#\' != $row[\'registration_number\']){\n        $MESSAGE = \'Προσοχή! Δεν επιτρέπεται η τροποποίηση αυτών των στοιχείων!\';\n        nuDisplayError($MESSAGE);\n        return;\n    }\n}',NULL,'','nuRunPHP(\'check_permission_lib\');\n\nif(!check_permission()){\n    $MESSAGE = \'Προσοχή! Δεν έχετε άδεια πρόσβασης στα δεδομένα αυτά!\';\n    nuDisplayError($MESSAGE);\n    return;\n}',NULL,NULL,'function enable_edit(){\n    nuEnable(\'street\');\n    nuEnable(\'area\');\n    nuEnable(\'city\');\n    nuEnable(\'zipcode\');\n    nuEnable(\'phone1\');\n    nuEnable(\'phone2\');\n    nuEnable(\'mobile\');\n    nuEnable(\'email\');\n    nuEnable(\'parent_street\');\n    nuEnable(\'parent_area\');\n    nuEnable(\'parent_zipcode\');\n    nuEnable(\'parent_phone1\');\n    nuEnable(\'parent_phone2\');\n    nuEnable(\'parent_phone3\');\n    nuEnable(\'parent_email\');\n    nuEnable(\'parent_email2\');\n}\n\nfunction nuLoadEdit() {\n\n    loadImg(\'log_user\');\n    loadImg(\'notification_type\');\n    \n    \n    $(\'#label_student\').css(\'fontSize\', \'14px\');\n    $(\'#label_student\').css(\'font-weight\', \'bold\');\n    $(\'#label_student\').css(\'text-decoration\', \'underline\');\n    \n    $(\'#label_parent\').css(\'fontSize\', \'14px\');\n    $(\'#label_parent\').css(\'font-weight\', \'bold\');\n    $(\'#label_parent\').css(\'text-decoration\', \'underline\');\n    \n    if($(\'#allow_parents_to_edit_disp\').val()==\'1\'){\n        enable_edit();    \n    }\n    \n    $(\'#nuButton0\').focus();\n}',NULL,0,0,'2015-01-02 22:21:53','globeadmin','2021-09-06 20:12:21','globeadmin','2021-09-06 20:12:21','globeadmin','',0,NULL),('59da63096606dc0','students_home_new','Students New Home Form','select * from student','student','id',1000,530,'select \'Μαθητής\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'','nuRunPHP(\'addSessionVariablesRow\');\nnuRunPHP(\'initializeSessionVariables\');\n',NULL,NULL,'function update_student_status(param){\n    if(document.getElementById(\'state\')){\n        if(param!=\'-1\'){\n            if( param != document.getElementById(\'state\').innerHTML)\n                $(\'#state\').fadeOut(2000,function() {\n                    $(this).html(param).fadeIn(3600);\n                });\n        } else {\n            $(\'#state\').fadeOut(2000,function() {\n                    $(this).html(\'- - -\').fadeIn(3600);\n                });\n            //document.getElementById(\'state\').innerHTML=\'- - -\';\n        }\n    } else {\n        if(myInterval){\n            clearInterval(myInterval);\n        }    \n    }\n}\n\nfunction open_student_form(form_id){\n    \n    var s=get_session_variable(\'student_id\');\n\n    if  (($.isNumeric(s)) && (s!=-1)) {\n            nuOpenForm(\'\',\'\', form_id, s,\'Μαθητής\');\n    } else{\n        if(nuIsGA()){\n            nuOpenForm(\'\',\'\', form_id, 1,\'Μαθητής\');    \n        } else{\n            alert(\"Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με Μαθητή/Γονέα!\");\n        }\n    }    \n}\n\nfunction tickEvent(){\n    nuAjax(\'get_student_absence_state\',\'update_student_status\',{async:true});    \n}\n\nvar myInterval;\n\nfunction nuLoadEdit() { \n    \n    if(myInterval){\n        clearInterval(myInterval);\n    }\n    \n    if($(\'#show_student_status\').val()==\'1\'){\n        tickEvent();\n        myInterval=setInterval(tickEvent,60000);    \n    }\n    \n    loadImg(\'boy\');\n    loadImg(\'girl\');\n    \n    loadImg(\'absences\');\n    loadImg(\'amark\');\n    \n    loadImg(\'calendar\');\n    loadImg(\'pmsg\');\n    loadImg(\'cards_cup\');\n    \n    loadImg(\'subles\');\n    loadImg(\'teach\');\n    loadImg(\'school2\');\n    \n    var pimage=\'boy\';\n    var g = $(\'#student_gender\').val();\n    if(g==\'\' || g==\'Α\'){\n        pimage=\'boy\';    \n    } else {\n        pimage=\'girl\';    \n    }\n    document.getElementById(\'img_ucard_id\').src=\'images/\'+pimage+\'.png\';\n    \n    var ob = $(\'#open_ballot\').val();\n    if(ob!=\'\' && ob!=\'0\'){\n        document.getElementById(\'check_id\').style.display = \'block\';    \n    }\n    \n    $(\'#sisyphos_info_label2\').css(\'background-color\', \'#faf0e6\');\n    $(\'#sisyphos_info_label2\').css(\'color\', \'#666666\');\n    $(\'#sisyphos_info_label21\').css(\'background-color\', \'#faf0e6\');\n    $(\'#sisyphos_info_label21\').css(\'color\', \'#666666\');\n    \n    $(\'#student_state\').css(\'fontSize\', \'10px\');\n    $(\'#student_state\').css(\'font-weight\', \'bold\');\n    \n    set_session_variable(\'system_url\',window.location.href);\n    \n    \n}\n',NULL,0,0,'2017-10-08 20:40:25','globeadmin','2022-01-08 14:20:41','globeadmin','2022-01-08 14:20:41','globeadmin','',0,NULL),('54aa751b6567046','student_user_creation','Δημιουργία Λογαριασμών για τους Μαθητές','select * from foo','foo','foo',960,520,'select \'Δημιουργία Λογαριασμών για τους Μαθητές\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'','nuRunPHP(\'clean_up_user_ids\');',NULL,NULL,'function nuLoadEdit() {  \n    $(\'#create_std_acc_home_display\').css(\'fontSize\', \'14px\');\n    $(\'#create_std_acc_home_display\').css(\'font-weight\', \'bold\');\n    $(\'#create_std_acc_home_display\').css(\'font-style\', \'italic\');\n\n    $(\'#create_std_acc_home_label1\').css(\'font-style\', \'italic\');\n    $(\'#create_std_acc_home_label2\').css(\'font-style\', \'italic\');\n}',NULL,0,0,'2015-01-05 13:27:23','globeadmin','2016-09-20 20:40:39','globeadmin','2020-09-24 22:08:25','globeadmin','',0,NULL),('54b2d9dd8417a3d','set_class_responsible','Ορισμός Υπευθύνου Τμήματος','select * from foo','foo','foo',960,520,'select \'Ορισμός Υπευθύνου Τμήματος\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,0,0,'2015-01-11 22:15:25','globeadmin','2015-11-21 20:59:35','globeadmin','2016-09-29 12:44:00','globeadmin','',0,NULL),('54df1259eb4def9','student_read','Εισάγει τους μαθητές από αρχείο excel του myschool','select * from foo','foo','foo',1000,550,'select \'Εισαγωγή Μαθητών από Αρχείο Excel\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'','$sql=\"delete from student_in where 1\";\nnuRunQuery($sql);',NULL,NULL,'function nuLoadEdit() {\n    nuSetHash(\'FILES\' , \'\');\n}',NULL,0,0,'2015-02-14 11:16:09','globeadmin','2018-07-03 13:00:41','globeadmin','2020-04-02 16:11:27','globeadmin','',0,NULL),('54df1dbf0f931e5','student_class_read','Εισάγει τις κατανομές μαθητών σε τμήματα από αρχεί','select * from teacher','teacher','id',1000,530,'select \'Εισαγωγή Κατανομής Μαθητών σε Τμήματα από Αρχείο Excel\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'','$sql=\"delete from student_class_in where 1\";\nnuRunQuery($sql);',NULL,NULL,'function nuLoadEdit() {\n    nuSetHash(\'FILES\' , \'\');\n}',NULL,0,0,'2015-02-14 12:04:47','globeadmin','2018-07-12 23:43:30','globeadmin','2020-09-24 18:44:35','globeadmin','',0,NULL),('54df20f94548357','timetable_read','Εισάγει το ωρολόγιο πρόγραμμα από αρχείο xml  του ','select * from foo','foo','foo',1000,600,'select \'Εισαγωγή Ωρολογίου Προγράμματος από Αρχείο XML του ASC Timetables\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'','//$sql=\"delete from penalty_in where 1\";\n//nuRunQuery($sql);',NULL,NULL,'function nuLoadEdit() {\n    nuSetHash(\'FILES\' , \'\');\n}',NULL,0,0,'2015-02-14 12:18:33','globeadmin','2018-07-02 23:10:21','globeadmin','2020-04-02 16:11:51','globeadmin','',0,NULL),('54f735c7d56625f','set_day_absences','Καταχώριση απουσιών ημέρας','select * from teacher','teacher','id',960,530,'select \'Καταχώριση Aπουσιών Hμέρας\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function show_justification_request(absence_id,number_of_pending_requests){\n    var iframe = document.getElementById(\'absence_iframe\');\n    var innerDoc = (iframe.contentDocument) ? iframe.contentDocument : iframe.contentWindow.document;\n\n    var a = innerDoc.getElementById(\'absence_\'+absence_id);\n    if(a){\n        \n        a.style.backgroundImage = (number_of_pending_requests==0 ? \'\' : \'linear-gradient(225deg, #00b6b6, #00b6b6 6px, transparent 6px, transparent)\');\n    }\n}\n\nfunction reload_absence_table(){\n    nuRunPHP(\'create_absence_class_table\',\'absence_iframe\'); // Επαναφόρτωση Απουσιολογίου\n}\n\nvar t_post_id=\'#RECORD_ID#\';\nvar t_id=\'#RECORD_ID#\';\nvar s_id=-1;\nvar t_name=\'\';\nvar s_name=\'\';\n\nvar p_id=-1;\n\nfunction nuLoadEdit() {\n    var n   = (\'#name#\'==\'#\'+\'name\'+\'#\' ? \'\' : \'#name#\');\n    var s   = (\'#surname#\'==\'#\'+\'surname\'+\'#\' ? \'\' : \'#surname#\');\n    t_name  = (n==\'\' || s==\'\' ? s+n : s+\' \'+n);\n}',NULL,0,0,'2015-03-04 18:41:43','globeadmin','2022-09-24 23:06:17','globeadmin','2022-09-24 23:06:17','globeadmin','',0,NULL),('5501db35db0c716','set_period_absences','Καταχώριση απουσιών Ώρας','select * from teacher','teacher','id',960,1450,'select \'Καταχώριση Aπουσιών στη Τάξη\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'var ajaxSucced = false;\n\nfunction foo(param){\n    ajaxSucced = true;\n}\n\nfunction open_rc(param){\n    if(!param || param==\'-1\'){\n        alert(\'Δεν βρέθηκαν σημειώσεις διδασκαλίας!\\nΠρέπει να γίνει καταχώριση των απουσιών για να δημιουργηθούν σημειώσεις διδασκαλίας!\');\n    } else {\n        nuOpenFormInFrame(\'56dd9f180d22b31\',param);\n    }\n}\n\nfunction timeToMillis(tm){\n    \n    var res = tm.split(\":\");\n    \n    hours=parseInt(res[0]);\n    minutes=parseInt(res[1]);\n    seconds=parseInt(res[2]);\n    \n    return((hours*3600+minutes*60+seconds)*1000);\n}\n\nfunction millisToTime(ms){\n\n    x = ms / 1000;\n\n    hours = Math.floor(x/3600);\n    x %= 3600;\n    \n    minutes = Math.floor(x/60);\n    x %= 60;\n    \n    seconds = x;\n\n    seconds=(seconds<10?\'0\'+seconds:seconds);\n    minutes=(minutes<10?\'0\'+minutes:minutes);\n    hours=(hours<10?\'0\'+hours:hours);\n\n    return (hours+\':\'+minutes+\':\'+seconds);\n}\n\n\nvar SessionTime=100000;\nvar tickDuration=1000;\nvar myInterval;\nvar myTimeOut;\nvar flag=true;\nvar audio = new Audio(\'sample/beep.mp3\');\n\n\nfunction tickEvent(){\n    SessionTime=(SessionTime-tickDuration);\n    $(\'#period_absence_timeleft_text\').val(millisToTime(SessionTime));\n    if(SessionTime<120000){\n        if(flag){\n            $(\'#period_absence_timeleft_text\').css(\'background-color\', \'white\');\n            $(\'#period_absence_timeleft_text\').css(\'color\', \'red\');\n            audio.play();\n            flag=false;\n        } else {\n            $(\'#period_absence_timeleft_text\').css(\'background-color\', \'red\');\n            $(\'#period_absence_timeleft_text\').css(\'color\', \'white\');\n            audio.play();\n            flag=true;\n        }\n    }\n}\n\nfunction SessionExpireEvent(){ \n    clearInterval(myInterval);\n    $(\'#period_absence_timeleft_text\').val(\'00:00:00\');\n    $(\'#period_absence_timeleft_text\').css(\'background-color\', \'Grey\');\n    $(\'#period_absence_timeleft_text\').css(\'color\', \'black\');\n    alert(\"Ο διαθέσιμος χρόνος για τη καταχώριση των απουσιών έληξε!\\nΠαρακαλώ σημειώστε χειρόγραφα τις απουσίες και ενημερώστε τη διεύθυνση του σχολείου!\");\n}\n\n//setInterval( function() { funca(10,3); }, 500 );\n\nfunction nuLoadEdit() {\n    $(\'#period_absence_timeleft_text\').css(\'fontSize\', \'24px\');\n    $(\'#period_absence_timeleft_text\').css(\'font-weight\', \'bold\');\n    $(\'#period_absence_timeleft_text\').css(\'background-color\', \'red\');\n    $(\'#period_absence_timeleft_text\').css(\'color\', \'white\');\n    \n    if(myInterval){\n        clearInterval(myInterval);\n    }\n    \n    if(myTimeOut){\n        clearTimeout(myTimeOut);\n    }\n    \n    var tm= (!($(\'#period_absence_timeleft_disp\').val()) ? \'00:00:00\' : $(\'#period_absence_timeleft_disp\').val());\n    \n    \n    SessionTime=timeToMillis(tm);\n    \n    if(SessionTime>0){\n        SessionTime +=1000;\n        myInterval=setInterval(tickEvent,tickDuration);\n        myTimeOut=setTimeout(SessionExpireEvent,SessionTime);\n    } else {\n        $(\'#period_absence_timeleft_text\').val(\'00:00:00\');\n        $(\'#period_absence_timeleft_text\').css(\'background-color\', \'Grey\');\n        $(\'#period_absence_timeleft_text\').css(\'color\', \'black\');        \n    }\n    \n    var c=document.getElementById(\'period_absence_class\');\n    \n    if(c.length==1){\n        nuRunPHP(\'show_message_have_not_lesson\',\'period_absence_iframe\');\n    } else{\n        if(c.length==2){\n            c.selectedIndex=1;\n        } \n        $(\'#period_absence_class\').trigger( \"onchange\" );\n    } \n}\n',NULL,0,0,'2015-03-12 20:30:13','globeadmin','2016-03-19 22:21:00','globeadmin','2019-07-02 12:47:10','globeadmin','',0,NULL),('5509671b4e81a07','absence_curdate_teacher','Απουσία','select * \nfrom absence ','absence','id',800,600,'select \'Απουσία\'','0','1','0',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'select if(\'#nu_user_group#\'=\'Students\',\'0\',\'1\')',NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function get_selected_ids(){\n    return \'#RECORD_ID#\';\n}\n\nfunction pending_requests(number_of_pending_requests){\n    if (typeof parent.show_justification_request === \'function\') {\n        parent.show_justification_request(\'#RECORD_ID#\',number_of_pending_requests);\n    }    \n}\n\nfunction reload_requests(){\n    nuRunPHP(\'show_absence_justification_requests\',\'justification_requests_iframe\'); \n}\n\nfunction open_new_justification_request(param){\n    nuOpenFormInFrame(\'550dbae55f33b5f\',param);\n}\n\nfunction disable_field(field){\n    $(\'#\'+field).css(\'background-color\', \'#ccc2b8\');\n\n    if ($(\'#\'+field).is(\'select\')) {\n      $(\'#\'+field).prop(\'disabled\', true);\n   } else {\n      $(\'#\'+field).prop(\'readonly\',true);\n   }\n\n}\n\nvar form_id = \'#FORM_ID#\';\n\nfunction nuLoadEdit() {\n    teacher_id=get_session_variable(\'teacher_id\');\n    nuSetHash(\'teacher_id\', teacher_id);\n    \n    if(\'#absence_date#\'!=$(\'#server_date\').val() || teacher_id!=\'#post_teacher_id#\'){\n        disable_field(\'comments\');\n    } \n\n    if(\'#nu_user_group#\'!=\'Managers\' && \'#nu_user_group#\'!=\'Administrators\'){\n       disable_field(\'absence_reason_id\'); \n    }\n}\n\n\nfunction nuOnSave(){     \n    /*var absence_reason = $(\'#absence_reason_id\').val();\n    \n    if(absence_reason == \'\'){\n        alert(\'Προσοχή : Δεν μπορεί ο Λόγος Απουσίας να είναι κενός!\');\n        return false;  \n    }else{ \n        return true; \n    }*/\n    \n    teacher_id=get_session_variable(\'teacher_id\');\n    \n    if((\'#absence_date#\'!=$(\'#server_date\').val() || teacher_id!=\'#post_teacher_id#\') && \'#nu_user_group#\'!=\'Managers\' && \'#nu_user_group#\'!=\'Administrators\'){\n        alert(\'Δεν έχετε δικαίωμα αποθήκευσης!\\nΗ αποθήκευση δεν πραγματοποιήθηκε !\');\n        return false;\n    }else{ \n        return true; \n    }\n}',NULL,0,0,'0000-00-00 00:00:00','','2022-10-05 20:27:42','globeadmin','2022-10-05 20:27:42','globeadmin','',0,NULL),('550dbae55f33b5f','justification_request','Αίτημα Δικαιολόγησης Απουσίας','select * from justification_request','justification_request','id',600,500,'select \'Αίτημα Δικαιολόγησης Απουσίας\'','0','1','0',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'select if(\'#nu_user_group#\'=\'Students\' OR \'#nu_user_group#\'=\'Parents\',\'0\',\'1\')','select if(\'#teacher_id#\'=\'#post_teacher_id#\',\'1\',\'0\')',NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function disable_field(field){\n    $(\'#\'+field).css(\'background-color\', \'#ccc2b8\');\n\n    if ($(\'#\'+field).is(\'select\')) {\n      $(\'#\'+field).prop(\'disabled\', true);\n   } else {\n      $(\'#\'+field).prop(\'readonly\',true);\n   }\n\n}\n\nfunction nuLoadEdit() {\n\n    var teacher_id = get_session_variable(\'teacher_id\');\n    nuSetHash(\'teacher_id\', teacher_id);\n    \n    if(\'#proceeded#\'==\'1\' || teacher_id!=\'#post_teacher_id#\'){\n        disable_field(\'justification_request_reason_id\');\n        disable_field(\'comments\');\n    }\n    \n    if(\'#proceeded#\'==\'1\' || \'#nu_user_group#\'!=\'Managers\'){\n        disable_field(\'proceeded_comments\');\n    } \n    \n    if(\'#nu_edited_record#\'==\'1\' && parent.form_id==\'5509671b4e81a07\'){\n        parent.nuRunPHP(\'show_absence_justification_requests\',\'justification_requests_iframe\');\n    }\n    \n    nuFORM.edited = 0;\n}\n\nfunction nuOnSave(){     \n    var request_reason_id = $(\'#justification_request_reason_id\').val();\n    var cm = $(\'#comments\').val();\n    \n    if(cm.trim()==\'\' && request_reason_id==\'8\'){ \n        alert(\'Παρακαλώ συμπληρώστε τον λόγο που αιτήστε την δικαιολόγηση στα «Σχόλια Αίτησης»\');\n        return false;  \n    }else{ \n        return true; \n    }\n}',NULL,0,0,'0000-00-00 00:00:00','','2021-03-24 11:13:50','globeadmin','2021-03-24 11:13:50','globeadmin','',0,NULL),('550e7a89ef1692e','id_genarator','Δημιουργεί νέα ids','select * from foo','foo','foo',0,0,'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function set_id(param){\n    $(\'#id\').val(param);\n}\n',NULL,0,0,'2015-03-22 10:17:14','globeadmin','2015-03-22 10:31:08','globeadmin','2015-03-22 10:31:08','globeadmin','',0,NULL),('55127aebdf42446','absence_search','Αναζήτηση Απουσιών','select * from teacher','teacher','id',1050,600,'select \'Αναζήτηση Απουσιών\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function get_selected_ids(){\n    var id_array = [];\n\n    var iframe = document.getElementById(\'search_iframe\');\n    var innerDoc = (iframe.contentDocument) ? iframe.contentDocument : iframe.contentWindow.document;\n\n    var c1 = innerDoc.getElementsByClassName(\'chk_1\');\n        \n    for(var i=0, n=c1.length;i<n;i++) {\n        if(c1[i].checked){\n            id_array.push(c1[i].id);\n        }\n    } \n    \n    ids = id_array.join();\n    \n    if(typeof id_array == \'undefined\' || id_array == null || id_array.length == 0){\n        alert (\'Παρακαλώ επιλέξτε πρώτα τις απουσίες!\');\n        return;\n    }\n    \n    return ids;\n}\n\nfunction reload_requests(){\n    nuRunPHP(\'search_teacher_absence\',\'search_iframe\');    \n}\n    \nfunction add_new_justification_request(absence_id){\n    if(confirm(\'Θα εισάγετε ένα νέο αίτημα διαγραφής για να μη ληφθεί υπόψη η απουσία αυτή!\\nΕίστε σίγουρος;\')){\n        nuSetHash(\'absence_id\', absence_id);\n        nuSetHash(\'teacher_id\', get_session_variable(\'teacher_id\'));\n        nuAjax(\'add_justification_request\',\'open_new_justification_request\');// Καταχώριση Αιτήματος\n        nuRunPHP(\'search_teacher_absence\',\'search_iframe\'); // Επαναφόρτωση απουσιών\n    }\n}\n\nfunction open_new_justification_request(param){\n    nuOpenFormInFrame(\'550dbae55f33b5f\',param);\n}\n\nfunction nuLoadEdit() {\n//$(\'#absence_teacher_id\').val(\'#RECORD_ID#\');\n$(\'#from_date\').val($(\'#current_date\').val());\n$(\'#to_date\').val($(\'#current_date\').val());\n\nsumoTransform(\'period_id\',false,false);\nsumoTransform(\'justified_reason_id\',false,true);\n\nsumoTransform(\'class_id\',false,true);\nsumoTransform(\'subject_id\',true,true);\nsumoTransform(\'student_id\',true,true);\nsumoTransform(\'absence_teacher_id\',false,true);\n\nnuFORM.edited = 0;\n\n}',NULL,0,0,'2015-03-25 11:07:55','globeadmin','2018-08-07 14:59:26','globeadmin','2020-10-08 23:42:27','globeadmin','',0,NULL),('551821232f9553f','absence_student_search','Αναζήτηση Απουσιών','select * from student','student','id',1000,600,'select \'Αναζήτηση Απουσιών\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function add_new_justification_request(absence_id){\n    if(confirm(\'Θα εισάγετε ένα νέο αίτημα δικαιολόγησης για να μη ληφθεί υπόψη η απουσία αυτή!\\nΕίστε σίγουρος;\')){\n        nuSetHash(\'absence_id\', absence_id);\n        nuSetHash(\'teacher_id\', get_session_variable(\'teacher_id\'));\n        nuAjax(\'add_justification_request\',\'open_new_justification_request\');// Καταχώριση Αιτήματος\n        nuRunPHP(\'search_teacher_absence\',\'search_iframe\'); // Επαναφόρτωση απουσιών\n    }\n}\n\nfunction open_new_justification_request(param){\n    nuOpenFormInFrame(\'550dbae55f33b5f\',param);\n}\n\n\nfunction nuLoadEdit() {\n    nuSetHash(\'student_id_sumo\', \'#RECORD_ID#\');\n    $(\'#from_date\').val($(\'#current_month_first_date\').val());\n    $(\'#to_date\').val($(\'#current_date\').val());\n    \n    sumoTransform(\'period_id\',false,false);\n    sumoTransform(\'subject_id\',true,true);\n    sumoTransform(\'justified_reason_id\',false,false);\n    \n    nuFORM.edited = 0;\n}',NULL,0,0,'2015-03-29 18:58:27','globeadmin','2018-07-13 23:10:16','globeadmin','2018-08-04 20:57:31','globeadmin','',0,NULL),('551a34a930825c0','justification_request_search','Αναζήτηση αιτημάτων διαγραφής απουσιών','select * from teacher','teacher','id',1200,550,'select \'Αναζήτηση Αιτημάτων Διαγραφής Απουσιών\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function nuLoadEdit() {\n    \n    if( \'#nu_user_group#\'!=\'globeadmin\' && \n        \'#nu_user_group#\'!=\'Administrators\' && \n        \'#nu_user_group#\'!=\'Managers\' && \n        \'#nu_user_group#\'!=\'AssistManagers\'){\n        $(\'#request_teacher_id\').val(\'#RECORD_ID#\');        \n    }\n    \n    $(\'#from_date\').val($(\'#current_date\').val());\n    $(\'#to_date\').val($(\'#current_date\').val());\n    sumoTransform(\'justification_request_reason_id\',false,true);\n    nuFORM.edited = 0;\n}',NULL,0,0,'2015-03-31 08:46:17','globeadmin','2018-08-04 11:47:35','globeadmin','2018-08-04 11:47:35','globeadmin','',0,NULL),('55222f79d342b66','justify_student_absence','Δικαιολόγηση απουσιών μαθητή','select student.*,grade_short_name\nfrom student \ninner join (select teacher_id as t,session_id as s from session_variables) as sv on 1=1\nleft join (select id as gid, short_name as grade_short_name from grade) as g on g.gid=student.grade_id\nwhere sv.s=\'#session_id#\' and \n(sv.t=student.teacher_id OR \'#nu_user_group# \'=\'Managers\' OR \'#nu_user_group# \'=\'globeadmin\' OR \'#nu_user_group#\'=\'AssistManagers\')\norder by student.grade_id,student.surname,student.name,student.fathers_name','student','id',1000,650,'select concat(surname,\' \',name) from student where id=#RECORD_ID#',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function show_ajax_result(param){\n    if(param) {alert(param);}\n}\n\nfunction nuLoadEdit() {\n    $(\'#absence_date\').css(\'fontSize\', \'14px\');\n    $(\'#absence_date\').css(\'font-weight\', \'bold\');\n    $(\'#absence_date\').css(\'color\', \'#25237A\');     \n    \n    $(\'#justify_reason\').css(\'fontSize\', \'14px\');\n    $(\'#justify_reason\').css(\'font-weight\', \'bold\');\n    $(\'#justify_reason\').css(\'color\', \'#25237A\');\n}',NULL,25,60,'2015-04-06 10:02:17','globeadmin','2018-08-05 14:06:17','globeadmin','2018-08-14 10:07:24','globeadmin','',0,NULL),('5525421c67a48bc','absence_card_not_registered','Διδασκαλίες για τις οποίες δεν έχουν καταχωρηθεί α','select * from teacher','teacher','id',1000,600,'select \'Μη καταχωρισμένες Διδασκαλίες\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function nuLoadEdit() {\n    $(\'#from_date\').val($(\'#prev_date\').val());\n    $(\'#to_date\').val($(\'#prev_date\').val());\n\n    sumoTransform(\'period_id\',false,false);\n\n    nuFORM.edited = 0;\n}',NULL,0,0,'2015-04-08 17:58:36','globeadmin','2020-10-17 23:57:49','globeadmin','2022-09-17 21:45:16','globeadmin','',0,NULL),('55261f6b593bdba','absence_export_excel','Εξαγωγή των απουσιών στο Excel','select * from teacher','teacher','id',1000,800,'select \'Εξαγωγή Απουσιών στο Excel\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function get_excel_file(param){\n    if(param!=\'\' && param!=\'-1\'){\n        nuSetHash(\'backup_file_name\', param);\n        //nuSetHash(\'send_file_name\', \'absence_export.xls\');\n        nuRunPHP(\'backup_db_get_file\',\'search_iframe\');\n    } else {\n        alert(\'Η δημιουργία του αρχείου Excel απέτυχε!\'); \n    }\n    hideLoader();\n}\n\nfunction nuLoadEdit() {\n    sumoTransform(\'class_id\',false,true);\n    sumoTransform(\'student_id\',true,true);\n    $(\'#from_date\').val($(\'#prev_date\').val());\n    $(\'#to_date\').val($(\'#prev_date\').val());\n    $(\'#max_rows\').val(\'999\');\n    $(\'[id*=class_id]\').hide(); \n    $(\'[id*=show_only_sums]\').hide();\n    $(\'[id*=student_id]\').hide(); \n    $(\'[id*=show_zero]\').hide();\n    $(\'[id*=max_rows]\').hide();\n    \n}',NULL,0,0,'2015-04-09 09:42:51','globeadmin','2018-06-01 15:03:59','globeadmin','2022-02-12 10:09:59','globeadmin','',0,NULL),('552cf4b2df9bcce','absence_notes','Επικοινωνία Σχολείου - Γονέων για τις Απουσίες','select * from teacher','teacher','id',1000,900,'select \'Επικοινωνία Σχολείου - Γονέων για τις Απουσίες\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function display_sent_result(param){\n    hideLoader();\n    alert(param);\n}\n\nfunction hide_all(){\n    $(\'[id*=sms_disp]\').hide();\n    $(\'[id*=label1]\').hide();\n    $(\'[id*=framehtml]\').hide();\n    $(\'[id*=manager_sign]\').hide();\n    $(\'[id*=asistmanager_sign]\').hide();\n    $(\'[id*=teacher_sign]\').hide();\n}\n\nvar selected_option = 1;\n\nfunction nuLoadEdit() {\n    \n    var all_class_ids = [];\n    var all_class_names = [];\n\n    var s = document.getElementById(\'export_class_id\');\n \n    if(s.options.length>2){\n        for (var i = 0; i < s.options.length; i++) {\n        \n            var class_id=s.options[i].value;\n            var class_name=s.options[i].text;\n        \n            all_class_ids.push(class_id);\n            all_class_names.push(class_name);\n            }\n    \n        $(\'#export_class_id\').empty();\n        $(\'#export_class_id\').append(\"<option value=0>Όλα τα Τμήματα μου</option>\");\n    \n        for(i=0;i<all_class_ids.length;i++){\n            if(all_class_names[i]!=\'\'){\n            $(\'#export_class_id\').append(\'<option value=\"\'+all_class_ids[i]+\'\">\'+all_class_names[i]+\'</option>\'); \n                }\n            }\n        }\n        \n    $(\'#to_date\').val($(\'#prev_date\').val());\n    $(\'#absence_limit\').val(30);\n    document.getElementById(\'manager_sign\').checked = true;\n    document.getElementById(\'teacher_sign\').checked = true;\n    document.getElementById(\'exclude_has_left_school\').checked = true;\n\n    document.getElementById(\'note_type\').selectedIndex=1;\n    \n    $(\'#note_type\').css(\'fontSize\', \'14px\');\n    $(\'#note_type\').css(\'font-weight\', \'bold\');\n    $(\'#note_type\').css(\'color\', \'#25237A\');\n    \n    $(\'#to_date\').css(\'fontSize\', \'16px\');\n    $(\'#to_date\').css(\'font-weight\', \'bold\');\n    $(\'#to_date\').css(\'color\', \'#25237A\'); \n\n    $(\'#absence_limit\').css(\'fontSize\', \'16px\');\n    $(\'#absence_limit\').css(\'font-weight\', \'bold\');\n    $(\'#absence_limit\').css(\'color\', \'#25237A\'); \n\n    $(\'#sms_disp\').css(\'fontSize\', \'14px\');\n    $(\'#sms_disp\').css(\'font-weight\', \'bold\');\n    $(\'#sms_disp\').css(\'background-color\', \'#FAF0E6\');\n    $(\'#sms_disp\').css(\'color\', \'red\');\n    \n    hide_all();\n    \n    nuFORM.edited = 0;\n}',NULL,0,0,'2015-04-14 14:06:26','globeadmin','2021-03-24 11:20:39','globeadmin','2021-09-07 20:55:37','globeadmin','',0,NULL),('5538ff58cb7b4b8','print_absence_book','Εμφανίζει σε PDF τα απουσιολόγια όλων των τμημάτων','select * from teacher','teacher','id',1000,750,'select \'Εκτύπωση Απουσιολογίων Ημέρας\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,0,0,'2015-04-23 17:19:04','globeadmin','2015-04-23 17:19:04','globeadmin','2015-04-25 18:04:59','globeadmin','',0,NULL),('553e8f779634e69','add_student_absence','Καταχώριση Μεμονωμένης Απουσίας Μαθητή','select * from teacher','teacher','id',850,520,'select \'Καταχώριση Μεμονωμένης Απουσίας Μαθητή\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function show_lesson(){\n    var s = document.getElementById(\'student\');\n    var std=s.value;\n\n    var d = document.getElementById(\'absence_date\');\n    var ad=d.value;\n\n    var p = document.getElementById(\'period\');\n    var prd = p.options[p.selectedIndex].value;\n\n    if(ad!=\'\' && prd!=0 && std!=\'\'){\n        nuRunPHP(\'search_studens_registered_card\',\'search_iframe\');\n    }\n}',NULL,0,0,'2015-04-27 22:35:19','globeadmin','2015-04-29 20:23:28','globeadmin','2019-11-05 13:35:32','globeadmin','',0,NULL),('554517bdc18334d','penalty','Ποινές','select penalty.*,std.student_name\nfrom penalty\ninner join (select id as s_id,concat(student.surname,\' \',student.name) as student_name from student) as std on penalty.student_id=std.s_id\norder by std.student_name,date_enforced','penalty','id',960,700,'select \'Ποινή\'','1','1','1',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'select if(  \'#RECORD_ID#\'=\'-1\' or\n            \'#nu_user_group#\'=\'globeadmin\' or \n            \'#nu_user_group#\'=\'Administrators\' or \n            \'#nu_user_group#\'=\'Managers\' or \n            \'#nu_user_group#\'=\'AssistManagers\',\'1\',\'0\')','select if(  \'#nu_user_group#\'=\'globeadmin\' or \n            \'#nu_user_group#\'=\'Administrators\' or \n            \'#nu_user_group#\'=\'Managers\' or \n            \'#nu_user_group#\'=\'AssistManagers\',\'1\',\'0\')',NULL,NULL,NULL,'$sql = \"    SELECT type\n            FROM penalty\n            WHERE id=\'#RECORD_ID#\'\n        \";\n$retval = nuRunQuery($sql);\n\nif($row = db_fetch_row($retval)){\n    $sql=\"update session_variables set student_comments_edited=\".($row[0]!=\'#type#\' ? \"1\" : \"0\").\" where session_id=\'#session_id#\'\";\n    $retval = nuRunQuery($sql);\n}',NULL,'',NULL,'nuRunPHP(\'notification_add_lib\');\n\n$sql=\"UPDATE penalty SET modified_at=NOW() WHERE id=\'#RECORD_ID#\'\";\nnuRunQuery($sql);\n\n$sql=\"  UPDATE penalty SET modifier_teacher_id=(SELECT IF(teacher_id=-1,NULL,teacher_id) FROM session_variables WHERE session_id=\'#session_id#\')\n        WHERE id=\'#RECORD_ID#\'\";    \nnuRunQuery($sql);\n\n\n$sql=\"select student_comments_edited from session_variables where session_id=\'#session_id#\'\";\n$retval = nuRunQuery($sql);\n$row=db_fetch_row($retval);\n\nif($row[0]==\'1\' || \'#nu_new_record#\'==\'1\'){\n\n    if($row[0]==\'1\'){\n        $sql=\"update session_variables set student_comments_edited=0 where session_id=\'#session_id#\'\";\n        $retval = nuRunQuery($sql);\n    }\n    \n    new_penalty_notification(\'#RECORD_ID#\'); \n}\n',NULL,'function is_type_allday(type_name){\n\n    var x = document.getElementById(\'type_all_day\');\n    \n    for (var i = 0; i < x.length; i++) {\n        if(x.options[i].value==type_name){\n            if(x.options[i].text==\'1\'){\n                return true;    \n            }    \n        }\n    }\n\n    return false;    \n}\n\nfunction validate_phone_number(phone_text){\n    \n    //eliminate every char except 0-9\n    var justNums = phone_text.replace(/[^0-9]/g, \'\');\n\n    if (justNums.length == 12){ // it\'s probably a valid phone number with country code in front\n        return(\'+\'+justNums);    \n    } else if (justNums.length == 10){ // it\'s probably a valid greek phone number\n        return(\'+30\'+justNums);\n    } else {\n        return false;\n    }\n}\n\nfunction open_sms_frame(phone_number){\n    var teacher_id = get_session_variable(\'teacher_id\');\n    teacher_id = (teacher_id!=-1 ? teacher_id  : 26);\n    \n    var student_id = $(\'#student_id\').val();\n\n    var nb = validate_phone_number(phone_number);\n\n    if(nb){\n        set_session_variable(\'sms_mobile_number\',nb);\n        set_session_variable(\'sms_student_id\',student_id);\n        set_session_variable(\'sms_teacher_id\',\'-1\');\n        \n        nuOpenFormInFrame(\'5711e1d915f5011\', teacher_id);\n        \n    } else {\n        alert(\'Ο αριθμός τηλεφώνου δεν είναι έγκυρος!\');    \n    }    \n}\n\nfunction create_sms_text(){\n    \n    var p =  document.getElementById(\'type\');\n    var penalty_type = p.options[p.selectedIndex].text;\n    \n    var student_name = $( \'#student_id option:selected\' ).text();\n    student_name = student_name.substring(4);\n    \n    var de = $(\'#date_enforced\').val();\n    \n    var period_name = $( \'#period_id option:selected\' ).text();\n    period_name = (period_name !=\'\' ? \' \'+period_name+\' ΩΡΑ\' : \'\');\n    \n    var txt = \'ΣΑΣ ΕΝΗΜΕΡΩΝΟΥΜΕ ΟΤΙ ΣΤΙΣ \'+de+period_name+\' Ο ΜΑΘΗΤΗΣ \'+student_name+\' ΤΙΜΩΡΗΘΗΚΕ ΜΕ \'+penalty_type;\n    \n    return txt;\n}\n\nfunction open_email_frame(email_address){\n    \n    var teacher_id = get_session_variable(\'teacher_id\');\n    teacher_id = (teacher_id!=-1 ? teacher_id  : 26);\n\n    var student_id = $(\'#student_id\').val();\n    \n    //****************************************************************************************\n    var p =  document.getElementById(\'type\');\n    var penalty_type = p.options[p.selectedIndex].text;\n    \n    var student_name = $( \'#student_id option:selected\' ).text();\n    student_name = student_name.substring(4);\n    \n    var de = $(\'#date_enforced\').val();\n    \n    var period_name = $( \'#period_id option:selected\' ).text();\n    period_name = (period_name !=\'\' ? \' \'+period_name+\' ΩΡΑ\' : \'\');\n    \n    var penalty_reason = $(\'#reason\').val();\n    penalty_reason = (penalty_reason!=\'\' ? \' λόγω του ότι :<br><br><i>\'+penalty_reason+\'</i>\' : \'\');\n    \n    var penalty_carrier = $(\'#carrier\').val();\n    var teacher_name = $( \'#teacher_id option:selected\' ).text();\n    \n    var pc = \'\';\n    \n    if(penalty_carrier==\'\'){\n        if(teacher_name!=\'\'){\n            pc=teacher_name;    \n        }\n    } else {\n        pc=penalty_carrier;   \n    }\n    \n    pc = (pc!=\'\' ? \'<br><br>Φορέας Επιβολής : \'+pc : \'\');\n    \n    var txt = \'Σας ενημερώνουμε ότι στις <b>\'+de+period_name+\'</b> ο μαθητής <b>\'+student_name+\'</b> τιμωρήθηκε με την ποινή <b>\'+penalty_type+\'</b>\'+penalty_reason+pc;\n    \n    //****************************************************************************************\n    \n    set_session_variable(\'email_subject\',\'Επιβολή Ποινής\');\n    set_session_variable(\'email_text\',txt);\n    set_session_variable(\'email_recipients\',email_address);\n    \n    set_session_variable(\'sms_student_id\',student_id);\n    set_session_variable(\'sms_teacher_id\',\'-1\');\n    \n    nuOpenFormInFrame(\'54a4107cddefff1\', teacher_id);\n}\n\nfunction nuLoadEdit() {\n    \n    if(is_type_allday($(\'#type\').val())){\n        nuDisable(\'period_id\');\n    }\n\n    $(\'#label1\').css(\'fontSize\', \'10px\');\n    $(\'#label1\').css(\'font-style\', \'italic\');\n    \n    $(\'#label_student\').css(\'fontSize\', \'14px\');\n    $(\'#label_student\').css(\'font-weight\', \'bold\');\n    $(\'#label_student\').css(\'text-decoration\', \'underline\');\n    \n    $(\'#label_parent\').css(\'fontSize\', \'14px\');\n    $(\'#label_parent\').css(\'font-weight\', \'bold\');\n    $(\'#label_parent\').css(\'text-decoration\', \'underline\');\n}\n\n\nfunction nuOnSave(){ \n\n    if($(\'#student_id\').val() == \'\'){ \n        alert(\'Παρακαλώ συμπληρώστε πρώτα τον «Μαθητή»\');\n        return false;  \n    }\n    \n    if($(\'#type\').val() == \'\'){ \n        alert(\'Παρακαλώ συμπληρώστε πρώτα τον «Τύπο Ποινής»\');\n        return false;  \n    }\n    \n    if($(\'#date_enforced\').val() == \'\'){ \n        alert(\'Παρακαλώ συμπληρώστε πρώτα την «Ημερομηνία»\');\n        return false;  \n    }\n    \n        if( \'#nu_user_group#\'!=\'globeadmin\' && \n        \'#nu_user_group#\'!=\'Administrators\' && \n        \'#nu_user_group#\'!=\'Managers\' && \n        \'#nu_user_group#\'!=\'AssistManagers\'){\n        if(!confirm(\'Προσοχή! Μετά την καταχώριση της ποινής δεν θα μπορείτε να την τροποποιήσετε ή να τη διαγράψετε!\\nΕίστε σίγουρος;\')){\n            return false;\n        }\n        \n    }\n    \n    return true;\n}',NULL,30,100,'0000-00-00 00:00:00','','2018-01-11 14:46:55','globeadmin','2022-01-07 21:47:52','globeadmin','',0,NULL),('55479f1837f6df0','student_cards_not_registered','Εμφανίζει τις διδασκαλίες του μαθητή που δεν έχουν','select * from student','student','id',1000,500,'select \'Διδασκαλίες που δεν έχουν καταχωρηθεί\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function nuLoadEdit() { \n    var x = parent.document.getElementById(\'absence_date\');\n    nuSetHash(\'absence_date\',x.value);\n    nuRunPHP(\'student_cards_date\',\'not_registered_cards_iframe\');\n}',NULL,0,0,'2015-05-04 19:32:24','globeadmin','2018-07-12 20:14:41','globeadmin','2018-07-12 20:17:56','globeadmin','',0,NULL),('5564d8431a9da4b','attendance_book','Δημιουργία Βιβλίων Φοιτησης ανα τμήμα','select * from teacher','teacher','id',960,800,'select \'Βιβλία Φοίτησης Μαθητών\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function nuLoadEdit() {\n    sumoTransform(\'student_id\',true,true);\n    nuFORM.edited = 0;\n}',NULL,0,0,'2015-05-26 23:32:03','globeadmin','2018-08-13 10:14:45','globeadmin','2022-02-12 10:13:25','globeadmin','',0,NULL),('55fd4faf6572ec3','copy_access_level','Αντιγράφει τα δικαιώματα ενος access level σε ένα ','select * from foo','foo','foo',960,650,'select \'Αντιγραφή Δικαιωμάτων Access Level\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,0,0,'2015-09-19 15:06:07','globeadmin','2015-09-19 15:06:07','globeadmin','2017-11-25 11:28:24','globeadmin','',0,NULL),('5684e68b302da76','timetable','Ωρολόγια Προγραμμάτα','select *\nfrom timetable\ninner join (select max(start_date) as pdate from timetable where start_date<=curdate()) as prog_date on 1=1\norder by start_date desc','timetable','id',960,600,'select CONCAT(\'Ωρολόγιο Προγράμμα με ενεργοποίηση στις \',DATE_FORMAT(start_date,\'%d-%m-%Y\'))\nfrom timetable\nwhere id=\'#RECORD_ID#\'','1','1','1',NULL,NULL,NULL,'Προσθήκη Νέου Ωρολογίου',NULL,NULL,NULL,NULL,NULL,NULL,'select if(\'#RECORD_ID#\'=\'-1\' or \'#start_date#\'>curdate(),\'1\',\'0\')','select if (\'#start_date#\'>curdate(),\'1\',\'0\')',NULL,NULL,NULL,'if(trim(\'#start_date#\') == \'\' ) {\n    $MESSAGE = \'Παρακαλώ συμπηρώστε την ημερομηνία «Έναρξης Ισχύος» του ωρολογίου προγράμματος!\';\n    nuDisplayError($MESSAGE);\n    return;\n} else if(\'#start_date#\'<=date(\"Y-m-d\")){\n    $MESSAGE = \'H ημερομηνία «Έναρξης Ισχύος» του ωρολογίου προγράμματος πρέπει να είναι μελλοντική!\';\n    nuDisplayError($MESSAGE);\n    return;    \n} else {\n    if(\'#RECORD_ID#\'==\'-1\'){\n        $sql=\"select count(*) from timetable where start_date=\'#start_date#\'\";\n    } else {\n        $sql=\"select count(*) from timetable where start_date=\'#start_date#\' and id<>\'#RECORD_ID#\'\";\n    }\n    if($rv=nuRunQuery($sql)){\n        if($row=db_fetch_row($rv)){\n            if($row[0]==1){\n                $MESSAGE = \'Υπάρχει ήδη καταχωρημένο ωρολόγιο πρόγραμμα με αυτήν την ημερομηνία «Έναρξης Ισχύος»!\';\n                nuDisplayError($MESSAGE);\n                return;    \n            } else {\n                if(\'#RECORD_ID#\'!=\'-1\'){ // Αλλάγη της ημερομηνίας έναρξης υπάρχοντος προγράμματος - πρέπει να αλλάζουν και οι διδασκαλίες\n                    $sql = \"    UPDATE card\n                                INNER JOIN timetable on card.valid_from = timetable.start_date\n                                SET valid_from=\'#start_date#\'\n                                WHERE timetable.id=\'#RECORD_ID#\'\";\n                    nuRunQuery($sql);\n                }\n            }\n        } else {\n            $MESSAGE = \'Δεν μπόρεσε να εκτελεστεί η διαδικασία ελέγχου!\';\n            nuDisplayError($MESSAGE);\n            return;    \n        }\n    } else {\n        $MESSAGE = \'Πρόβλημα επικοινωνίας με τη βάση δεδομένων\';\n        nuDisplayError($MESSAGE);\n        return;        \n    }\n}',NULL,'if(\'#RECORD_ID#\'!=\'-1\'){\n    $sql = \"DELETE FROM card WHERE valid_from IN (SELECT start_date FROM timetable WHERE id=\'#RECORD_ID#\')\";\n    nuRunQuery($sql);\n}',NULL,NULL,NULL,'function foo(param){\n    ;\n}\nfunction pass_session_variable(param){\n    nuSetHash(\'varval\', param);\n}\nfunction get_session_variable(varname){\n    nuSetHash(\'varname\', varname);\n    nuAjax(\'getSessionVariable\',\'pass_session_variable\');\n    return nuGetHash(\'varval\');\n}\nfunction set_session_variable(varname,varval){\n    nuSetHash(\'varname\', varname);\n    nuSetHash(\'varval\', varval);\n    nuAjax(\'setSessionVariable\',\'foo\');\n}\n\nfunction loadImg(img_name) { \n    i = new Image(); \n    i.src = \'images/\'+img_name+\'.png\';\n    \n    ib = new Image(); \n    ib.src = \'images/\'+img_name+\'b.png\';    \n}\n\nfunction disable_field(field){\n    //$(\'#\'+field).css(\'background-color\', \'#ccc2b8\');\n\n    //if ($(\'#\'+field).is(\'select\')) {\n      $(\'#\'+field).prop(\'disabled\', true);\n   //} else {\n   //   $(\'#\'+field).prop(\'readonly\',true);\n   //}\n\n}\n\nfunction nuLoadBrowse() {\n    var rows = nuBrowseRows();\n     \n    var row_len = rows.toString().length;\n    var pad = \"0000\";\n     \n    for( var i = 0; i < rows; i++ ) {\n        var rowString = i.toString();\n        var rowNum = pad.substring(0, pad.length - rowString.length ) + rowString;\n        var id = \'row_\'+rowNum+\'_col_1\';\n        if( $(\"div[id=\'\"+id+\"\']\").text().trim().match(/Ενεργό/) ) {\n            $(\"div[id^=\'row_\"+rowNum+\"\']\").css(\"color\", \"green\");\n        }\n    }\n}\n\nfunction nuLoadEdit() {\n    \n/*  loadImg(\'timeadd\');\n    loadImg(\'timecp\');\n    loadImg(\'timerem\');\n    loadImg(\'timeup\');\n    loadImg(\'celebr\');\n */   \n    var x = document.getElementById(\"current_timetable\");\n  \n    if(\'#RECORD_ID#\'!=-1 && \'#start_date#\'<=x.value){\n        $(\'#start_date\').prop(\'disabled\', true);\n    }\n    \n    $(\'#current_timetable\').hide();    \n    $(\'#label1\').css(\"fontSize\", \"10px\");\n    $(\'#label1\').css(\'font-style\', \'italic\');\n    nuFORM.edited = 0;\n}',NULL,30,30,'2015-12-31 10:25:47','globeadmin','2021-03-24 11:14:34','globeadmin','2021-03-24 11:14:34','globeadmin','',0,NULL),('5613deecec28ad6','declare_celebration','Ορισμός εκδήλωσης ή εκδρομής','select * from teacher','teacher','id',960,530,'select \'Μεταβολή Ωρολογίου Ημέρας\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function display_ajax_result(param){\n    if(param){\n        alert(param);\n    }\n}\n\nfunction nuLoadEdit() {\n    sumoTransform(\'class_id\',false,true);\n}',NULL,0,0,'2015-10-06 17:47:08','globeadmin','2018-07-28 11:40:29','globeadmin','2018-07-28 11:40:29','globeadmin','',0,NULL),('5616c3a5f23ccc8','card','card','select * from card','card','id',780,300,'select \'Διδασκαλία\'',NULL,'1',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'select if(\'#valid_from#\'>curdate(),\'1\',\'0\')',NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function after_delete(param){\n    parent.nuRunPHP(\'search_timetable_new\',\'showiframe\');\n    nuRemoveModal();\n}\n\nfunction nuLoadEdit() {\n    if(\'#nu_edited_record#\'==1){\n        parent.nuRunPHP(\'search_timetable_new\',\'showiframe\');\n        nuRemoveModal();\n    }\n}\n',NULL,0,0,'0000-00-00 00:00:00','','2017-10-31 11:31:34','globeadmin','2017-10-31 11:31:35','globeadmin','',0,NULL),('5618f5cc92f9c9e','managers_home_new','Managers New Home Form','select * from teachers','teacher','id',1000,520,'select \'Διευθυντής\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'','nuRunPHP(\'addSessionVariablesRow\');\nnuRunPHP(\'initializeSessionVariables\');\n',NULL,NULL,'function open_teacher_form(form_id){\n    \n    var t=get_session_variable(\'teacher_id\');\n\n    if  (($.isNumeric(t)) && (t!=-1)) {\n        nuOpenForm(\'\',\'\', form_id, t,\'Καθηγητής\');\n    } else{\n        if(nuIsGA()){\n            nuOpenForm(\'\',\'\', form_id, 27,\'Καθηγητής\');\n        } else{\n            alert(\"Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με καθηγητή!\");\n        }\n    }    \n}\n\nfunction new_version_check(param){\n    if(param==\'1\'){\n        document.getElementById(\'info_id\').style.display = \'block\';    \n    }\n}\n\nfunction nuLoadEdit() {  \n    loadImg(\'ucard\');\n    loadImg(\'school2\');\n    loadImg(\'absences\');\n    loadImg(\'amark\');\n    loadImg(\'message_center\');\n    loadImg(\'config\');   \n    \n    loadImg(\'calendar\');\n    loadImg(\'elections\');\n    loadImg(\'subles\');\n    \n    /*if( \'#nu_user_group#\'==\'globeadmin\' || \'#nu_user_group#\'==\'Administrators\' || \'#nu_user_group#\'==\'Managers\'){\n        nuAjax(\'check_for_new_version\',\'new_version_check\',{async:true});\n    }*/\n    \n    $(\'#sisyphos_info_label2\').css(\'background-color\', \'#faf0e6\');\n    $(\'#sisyphos_info_label2\').css(\'color\', \'#666666\');\n    $(\'#sisyphos_info_label21\').css(\'background-color\', \'#faf0e6\');\n    $(\'#sisyphos_info_label21\').css(\'color\', \'#666666\');\n    \n    set_session_variable(\'system_url\',window.location.href);\n}\n',NULL,0,0,'2015-10-10 14:26:04','globeadmin','2022-11-30 11:53:02','globeadmin','2022-11-30 11:53:02','globeadmin','',0,NULL),('599591df20eb2f7','teacher_calendar','Ημερολόγιο Σχολείου Καθηγητή','SELECT * FROM teacher','teacher','id',1150,650,'select \'Ημερολόγιο\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'','nuRunPHP(\'check_permission_lib\');\n\nif(!check_permission(\'1\')){\n    $MESSAGE = \'Προσοχή! Δεν έχετε άδεια πρόσβασης στα δεδομένα αυτά!\';\n    nuDisplayError($MESSAGE);\n    return;\n}',NULL,NULL,'var selectedDate=\'\'; \nvar selectedTime=\'\'; \nvar selectedEndDate=\'\'; \nvar selectedEndTime=\'\';\n\nfunction nuLoadEdit() {\n    nuSetHash(\'show_all_exams\', \'0\');\n}\n',NULL,0,0,'2017-08-17 15:53:51','globeadmin','2017-11-12 16:20:06','globeadmin','2020-10-06 23:53:55','globeadmin','',0,NULL),('599954a01e175cd','calendar_event','calendar_event','SELECT * FROM calendar_event','calendar_event','id',700,500,'Select \'Συμβάν Ημερολογίου\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'nuRunPHP(\'notification_add_lib\');\nnuRunPHP(\'send_email_calendar_event\');\n\nif( (\'#start_date#\'.\'T\'.\"#start_time#\">\'#end_date#\'.\'T\'.\"#end_time#\" && \'#allDay#\'==\'1\') || \n    ((\'#start_date#\'.\'T\'.\"#start_time#\">=\'#end_date#\'.\'T\'.\"#end_time#\" && \'#allDay#\'==\'0\'))){\n    $MESSAGE = \'Προσοχή! Δεν μπορεί η έναρξη του συμβάντος να είναι μεταγενέστερη της λήξης!\';\n    nuDisplayError($MESSAGE);\n    return;\n}\n\n$sql = \"        \n    SELECT\n        ifNULL(location,\'\'),\n        title,\n        start_date,\n        start_time,\n        end_date,\n        end_time,\n        allDay,\n        description,\n        calendar_event.teacher_id,\n        session_variables.teacher_id\n    FROM calendar_event\n    INNER JOIN session_variables    ON  session_variables.session_id = \'#session_id#\'\n    WHERE \n        id=\'#RECORD_ID#\'\";\n\n$retval=nuRunQuery($sql);\n$row = db_fetch_row($retval);\n\n$new_title      = \'#title#\';\n$new_location   = \'#location#\';\n$new_start_date = \'#start_date#\';\n$new_start_time = \'#start_time#\';\n$new_end_date   = \'#end_date#\';\n$new_end_time   = \'#end_time#\';\n$new_allDay     = (\'#allDay#\'==\'1\' ? \'ΝΑΙ\' : \'ΌΧΙ\');\n$new_description= \'#description#\';\n\nif( $row[8]!=$row[9] &&\n    ($row[0]!=\'#location#\' ||\n    $row[1]!=\'#title#\' ||\n    $row[2]!=\'#start_date#\' ||\n    $row[3]!=\'#start_time#\' ||\n    $row[4]!=\'#end_date#\' ||\n    $row[5]!=\'#end_time#\' ||\n    $row[6]!=\'#allDay#\' ||\n    $row[7]!=\'#description#\'\n    )\n    ){        \n        calendar_event_owner_email(\'#RECORD_ID#\',8,$new_title,$new_location,$new_start_date,$new_start_time,$new_end_date,$new_end_time,$new_allDay,$new_description);\n    }\n\nif( \'#inform_check_hash#\'==\'1\' &&\n    ($row[0]!=\'#location#\' ||\n    $row[1]!=\'#title#\' ||\n    $row[2]!=\'#start_date#\' ||\n    $row[3]!=\'#start_time#\' ||\n    $row[4]!=\'#end_date#\' ||\n    $row[5]!=\'#end_time#\' ||\n    $row[6]!=\'#allDay#\')\n    ){\n        $sql = \"SELECT id,user_group_id FROM calendar_event_access WHERE calendar_event_id=\'#RECORD_ID#\'\";\n        $rv = nuRunQuery($sql);\n        while($r=db_fetch_row($rv)){\n            if($r[1]==\'547de4c65675a29\' || $r[1]==\'5717ba3eb32c252\'){\n                calendar_event_notification($r[0],8,$new_title,$new_location,$new_start_date,$new_start_time,$new_end_date,$new_end_time,$new_allDay);\n            } else if($r[1]!=\'999999999999999\'){\n                calendar_event_email($r[0],8,$new_title,$new_location,$new_start_date,$new_start_time,$new_end_date,$new_end_time,$new_allDay,$new_description);\n            }        \n        }    \n    }\n    ',NULL,'',NULL,NULL,NULL,'function sisConfirm(title_msg, output_msg, onSuccessFunction, onCancelFunction, w=400){\n    if (!title_msg)\n        title_msg = \'Ερώτηση\';\n\n    if (!output_msg)\n        output_msg = \'Δεν υπάρχει μήνυμα για να εμφανιστεί!\';\n        \n    output_msg = output_msg.replace(/(?:\\r\\n|\\r|\\n)/g, \'<br />\');\n    \n    var bAccepts = false;\n    \n    $(\'<div></div>\').html(output_msg).dialog({\n        title: \'<img src=\"images/warning.png\" width=16 height=16 /> \'+title_msg,\n        resizable: false,\n        modal: true,\n        zIndex: 10000,\n        autoOpen: true,\n        width: w,\n        \n        buttons: {\n          \'Ναι\': function () {\n                bAccepts = true;\n                $(this).dialog(\'close\');\n          },\n          \'Όχι\': function () {\n                $(this).dialog(\'close\');\n          }\n        },\n        close: function (event, ui) {\n            if(bAccepts){\n                if(onSuccessFunction){\n                    onSuccessFunction();        \n                }    \n            } else {\n                if(onCancelFunction){\n                    onCancelFunction();    \n                }\n            }\n            $(this).remove();\n        }\n    });\n}\nfunction have_participants(){\n    var iframe = document.getElementById(\'participants_iframe\');\n    var innerDoc = (iframe.contentDocument) ? iframe.contentDocument : iframe.contentWindow.document;\n\n    var c1 = innerDoc.getElementsByClassName(\'chk_1\');\n    \n    if (typeof c1 !== \'undefined\' && c1.length > 0) {\n        return true;\n    } else {\n        return false;\n    }\n}\n\nfunction close_me(param){\n    hideLoader();\n    if(param!=\'\'){\n        alert(\'Η διαγραφή πραγματοποιήθηκε επιτυχώς!\\n\'+param)\n    }\n    var iframe = parent.document.getElementById(\'calendar_iframe\');\n    iframe.contentWindow.remove_event(\'#RECORD_ID#\');\n    nuRemoveModal();\n}\n\n\nfunction display_publish_result(param){\n    if(param!=\'-1\'){\n        alert(param);\n        nuRunPHP(\'show_participants_calendar_event\',\'participants_iframe\');\n    } else {\n        alert(\'Προσοχή: Παρουσιάστηκε πρόβλημα κατά την κοινοποίηση του συμβάντος!\');    \n    }\n    hideLoader();\n}\n\nfunction display_delete_result(param){\n    if(param==\'-1\'){\n        alert(\'Προσοχή: Παρουσιάστηκε πρόβλημα κατά την αφαίρεση των συμμετεχόντων!\');\n    } else if(param !=\'\'){\n        alert(\'Η αφαίρεση των συμμετεχόντων πραγματοποιήθηκε επιτυχώς!\\n\'+param);\n    }\n    nuRunPHP(\'show_participants_calendar_event\',\'participants_iframe\');\n    hideLoader();\n}\n\nfunction display_check_result(param){\n    if(param!=\'-1\'){\n        if(param!=\'0\'){\n            sisConfirm(\'Προειδοποίηση\', param+\'\\n\\nΘέλετε να συνεχίσετε με την κοινοποίηση;\', function(){nuAjax(\'publish_calendar_event\',\'display_publish_result\',{async:true});}, function(){alert(\'Η κοινοποίηση ακυρώθηκε!\');hideLoader();},650);\n        } else {\n            nuAjax(\'publish_calendar_event\',\'display_publish_result\',{async:true});    \n        }    \n    } else {\n        alert(\'Προσοχή: Παρουσιάστηκε πρόβλημα κατά την κοινοποίηση του συμβάντος!\');\n        hideLoader();\n    }\n}\n\n\n\nfunction hide_all_publication_elements() { \n    $(\'[id*=teacher_id_select]\').hide(); \n    $(\'[id*=students_check]\').hide();\n    $(\'[id*=parents_check]\').hide();\n    $(\'[id*=grade_id_select]\').hide();\n    $(\'[id*=class_id_select]\').hide();\n    $(\'[id*=student_id_select]\').hide();\n    \n    document.getElementById(\'students_check\').checked = true;\n    document.getElementById(\'parents_check\').checked = true;\n    //$(\'[id*=button1]\').hide();\n}\n\nfunction nuLoadEdit() {\n    \n    if(\'#nu_new_record#\'==\'1\'){\n        if(parent.selectedDate!=\'\'){\n            $(\'#start_date\').val(parent.selectedDate);\n        }\n        if(parent.selectedTime!=\'\'){\n            $(\'#start_time\').val(parent.selectedTime);        \n        }\n        \n        if(parent.selectedEndDate!=\'\'){\n            $(\'#end_date\').val(parent.selectedEndDate);\n        }\n        if(parent.selectedEndTime!=\'\'){\n            $(\'#end_time\').val(parent.selectedEndTime);        \n        }\n    }\n    \n    if(\'#nu_edited_record#\'==\'1\'){\n        var iframe = parent.document.getElementById(\'calendar_iframe\');\n        //var innerDoc = (iframe.contentDocument) ? iframe.contentDocument : iframe.contentWindow.document;\n        iframe.contentWindow.update_event(\'#RECORD_ID#\',$(\'#title\').val(),(document.getElementById(\'allDay\').checked ? \'1\' : \'0\'),\'#start_date#T#start_time#\',\'#end_date#T#end_time#\',$(\'#description\').val(),$(\'#location\').val());\n    }\n    \n    if(document.getElementById(\'allDay\').checked){\n        nuDisable(\'start_time\');\n        nuDisable(\'end_time\');\n        $(\'[id*=start_time]\').hide();\n        $(\'[id*=end_time]\').hide();\n        $(\'[id*=period]\').hide();\n        nuFORM.edited = 0;\n    }\n    \n    if(     \'#nu_user_group#\'==\'globeadmin\' || \n            \'#nu_user_group#\'==\'Managers\' || \n            \'#nu_user_group#\'==\'AssistManagers\' || \n            \'#nu_user_group#\'==\'Administrators\' ||\n            \'#nu_user_group#\'==\'Secretaries\'){\n                \n        $(\'#selection1\').append(\'<option value=0>Όλο το Σχολείο</option>\');\n        $(\'#selection1\').append(\'<option value=1>Διεύθυνση του Σχολείου</option>\');\n        $(\'#selection1\').append(\'<option value=2>Όλους τους Καθηγητές</option>\');\n        $(\'#selection1\').append(\'<option value=3>Συγκεκριμένους Καθηγητές</option>\');\n        $(\'#selection1\').append(\'<option value=4>Όλους τους Μαθητές / Γονείς</option>\');\n        $(\'#selection1\').append(\'<option value=5>Όλους τους Μαθητές / Γονείς Τάξης</option>\');\n        $(\'#selection1\').append(\'<option value=6>Όλους τους Μαθητές / Γονείς Τμήματος</option>\');\n        $(\'#selection1\').append(\'<option value=7>Συγκεκριμένους Μαθητές / Γονείς</option>\');\n        if(\'#is_exam#\'!=\'1\' && \'#is_test#\'!=\'1\'){\n            $(\'#selection1\').append(\'<option value=8>Δημόσιο (για την Ιστοσελίδα του Σχολείου)</option>\');\n        }\n\n    } else {\n        $(\'#selection1\').append(\'<option value=1>Διεύθυνση του Σχολείου</option>\');\n        $(\'#selection1\').append(\'<option value=2>Όλους τους Καθηγητές</option>\');\n        $(\'#selection1\').append(\'<option value=3>Συγκεκριμένους Καθηγητές</option>\');\n        $(\'#selection1\').append(\'<option value=6>Όλους τους Μαθητές / Γονείς ενός Τμήματος</option>\');\n        $(\'#selection1\').append(\'<option value=7>Συγκεκριμένους Μαθητές / Γονείς</option>\');            \n    }\n    \n    sumoTransform(\'teacher_id_select\',false,true);\n    sumoTransform(\'class_id_select\',false,true);\n    sumoTransform(\'grade_id_select\',false,false);\n    sumoTransform(\'student_id_select\',true,true);\n    \n    $(\'#label1\').css(\'fontSize\', \'10px\');\n    $(\'#label1\').css(\'font-style\', \'italic\');\n    \n    $(\'#title\').css(\'fontSize\', \'16px\');\n    $(\'#title\').css(\'font-weight\', \'bold\');\n    \n    document.getElementById(\'do_check\').checked = true;\n    \n    hide_all_publication_elements();\n    \n}\n\n\nfunction nuOnSave(){ \n\n    if($(\'#title\').val() == \'\'){ \n        alert(\'Παρακαλώ συμπληρώστε πρώτα τον «Τίτλο»\');\n        return false;  \n    }\n    \n    if($(\'#start_date\').val() == \'\'){ \n        alert(\'Παρακαλώ συμπληρώστε πρώτα την ημερομηνία «Από»\');\n        return false;  \n    }\n    \n    if($(\'#end_date\').val() == \'\'){ \n        alert(\'Παρακαλώ συμπληρώστε πρώτα την ημερομηνία «Έως»\');\n        return false;  \n    }\n    \n    if(!document.getElementById(\'allDay\').checked){\n        \n        if(!/^([01]?[0-9]|2[0-3]):[0-5][0-9]/.test($(\'#start_time\').val())){\n            alert(\'Παρακαλώ συμπληρώστε σωστά την ώρα «Από»\');\n            return false;     \n        }\n        \n        if(!/^([01]?[0-9]|2[0-3]):[0-5][0-9]/.test($(\'#end_time\').val())){\n            alert(\'Παρακαλώ συμπληρώστε σωστά την ώρα «Έως»\');\n            return false;     \n        }\n        \n    }\n    \n    return true;\n}',NULL,0,0,'0000-00-00 00:00:00','','2018-04-27 14:36:07','globeadmin','2021-10-09 23:07:30','globeadmin','',0,NULL),('59fe027dd6fe9f8','ballot_student_email','Μαζική Αποστολή Email στους Συμμετέχοντες Μαθητές ','select * from teacher','teacher','id',960,1700,'select \'Αποστολή Email\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function display_sent_result(param){\n    hideLoader();\n    alert(param);\n}\n\nfunction passTinymceContents(){\n    return(\'\');\n}\n\nfunction nuLoadEdit() {\n    nuSetHash(\'FILES\' , \'\');\n}',NULL,0,0,'2017-11-04 20:10:05','globeadmin','2021-10-19 23:36:53','globeadmin','2021-10-19 23:36:53','globeadmin','',0,NULL),('61744f1b13259e3','reward_type','reward_type','SELECT * \nFROM reward_type\nINNER JOIN session_variables ON session_id = \'#session_id#\'\nWHERE\nreward_type.teacher_id = session_variables.teacher_id OR\nreward_type.is_public = 1','reward_type','id',800,350,'SELECT name from reward_type WHERE id=\"#RECORD_ID#\"','1','1','1',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'SELECT IF(\'#nu_new_record#\'=\'1\' OR \'#teacher_id#\'=session_variables.teacher_id OR \'#nu_user_group#\' IN (\'globeadmin\',\'Managers\',\'Administrators\',\'AssistManagers\'), \'1\',\'0\')\nFROM session_variables WHERE session_id=\'#session_id#\'','SELECT IF(\'#teacher_id#\'=session_variables.teacher_id OR \'#nu_user_group#\' IN (\'globeadmin\',\'Managers\',\'Administrators\',\'AssistManagers\'), \'1\',\'0\')\nFROM session_variables WHERE session_id=\'#session_id#\'',NULL,NULL,NULL,NULL,NULL,'$sql = \"    SELECT COUNT(*)\n            FROM reward\n            WHERE reward_type_id = \'#RECORD_ID#\'\n        \";\n$retval = nuRunQuery($sql);\n$row    = db_fetch_row($retval);\nif($row[0]!=0){\n    $MESSAGE = \'Προσοχή : Υπάρχουν επιβραβεύσεις με τον λόγο αυτόν! Η διαγραφή δε μπορεί να πραγματοποιηθεί!\';\n    nuDisplayError($MESSAGE);\n    return;    \n}',NULL,NULL,NULL,'function nuLoadEdit() {\n\n    \n}\n\nfunction nuLoadBrowse() {\n    var rows = nuBrowseRows();\n    var pad = \"0000\";\n     \n    for( var i = 0; i < rows; i++ ) {\n        var rowString = i.toString();\n        var rowNum = pad.substring(0, pad.length - rowString.length ) + rowString;\n        \n        var id = \'row_\'+rowNum+\'_col_1\';\n        \n        if( $(\"div[id=\'\"+id+\"\']\").text().trim().match(/Ναι/) ) {\n            $(\"div[id^=\'row_\"+rowNum+\"_col_1\']\").css(\'color\', \'orange\');\n        }\n        if( $(\"div[id=\'\"+id+\"\']\").text().trim().match(/Όχι/) ) {\n            $(\"div[id^=\'row_\"+rowNum+\"_col_1\']\").css(\'color\', \'green\');\n        }\n    }\n}\n\nfunction nuOnSave(){ \n    \n    var dnom = $(\'#default_number_of_medals\').val();\n\n    if(dnom == \'\'){\n        $(\'#default_number_of_medals\').val(\'1\');\n        return true;\n    } else if(dnom < 1 || dnom > 10){\n        alert(\'Προσοχή : Ο προκαθορισμένος αριθμός μεταλλίων πρέπει να είναι μεταξύ 1 και 10!\');\n        return false;     \n    }\n    \n    return true;\n}',NULL,0,0,'2021-10-24 22:00:45','','2022-01-08 15:28:42','globeadmin','2022-01-08 15:28:42','globeadmin','',0,NULL),('561922d0a8f28d2','managers_absence','Managers absence form','select * from teachers','teacher','id',1000,520,'select \'Απουσίες\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'','nuRunPHP(\'check_permission_lib\');\n\nif(!check_permission(\'1\')){\n    $MESSAGE = \'Προσοχή! Δεν έχετε άδεια πρόσβασης στα δεδομένα αυτά!\';\n    nuDisplayError($MESSAGE);\n    return;\n}\n',NULL,NULL,'function foo(param){\n    ;\n}\nfunction pass_session_variable(param){\n    nuSetHash(\'varval\', param);\n}\nfunction get_session_variable(varname){\n    nuSetHash(\'varname\', varname);\n    nuAjax(\'getSessionVariable\',\'pass_session_variable\');\n    return nuGetHash(\'varval\');\n}\nfunction set_session_variable(varname,varval){\n    nuSetHash(\'varname\', varname);\n    nuSetHash(\'varval\', varval);\n    nuAjax(\'setSessionVariable\',\'foo\');\n}\n\nfunction loadImg(img_name) { \n    i = new Image(); \n    i.src = \'images/\'+img_name+\'.png\';\n    \n    ib = new Image(); \n    ib.src = \'images/\'+img_name+\'b.png\';    \n}\n\nfunction nuLoadEdit() { \n    \n    loadImg(\'search\');\n    loadImg(\'rsearch\');\n    loadImg(\'notreg\');\n    \n    loadImg(\'dabsen\');\n    loadImg(\'sabsen\');\n    loadImg(\'excel\');\n    \n    loadImg(\'abprint\');\n    loadImg(\'pmsg\');\n    loadImg(\'sbook\');\n}',NULL,0,0,'2015-10-10 17:38:08','globeadmin','2018-01-09 19:13:53','globeadmin','2018-08-13 10:29:13','globeadmin','',0,NULL),('56192a12e86c93e','managers_school','Managers school form','select * from teachers','teacher','id',1000,520,'select \'Το Σχολείο μου\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'','nuRunPHP(\'check_permission_lib\');\n\nif(!check_permission(\'1\')){\n    $MESSAGE = \'Προσοχή! Δεν έχετε άδεια πρόσβασης στα δεδομένα αυτά!\';\n    nuDisplayError($MESSAGE);\n    return;\n}',NULL,NULL,'function foo(param){\n    ;\n}\nfunction pass_session_variable(param){\n    nuSetHash(\'varval\', param);\n}\nfunction get_session_variable(varname){\n    nuSetHash(\'varname\', varname);\n    nuAjax(\'getSessionVariable\',\'pass_session_variable\');\n    return nuGetHash(\'varval\');\n}\nfunction set_session_variable(varname,varval){\n    nuSetHash(\'varname\', varname);\n    nuSetHash(\'varval\', varval);\n    nuAjax(\'setSessionVariable\',\'foo\');\n}\n\nfunction loadImg(img_name) { \n    i = new Image(); \n    i.src = \'images/\'+img_name+\'.png\';\n    \n    ib = new Image(); \n    ib.src = \'images/\'+img_name+\'b.png\';    \n}\n\nfunction nuLoadEdit() {  \n    loadImg(\'std\');\n    loadImg(\'class\');\n    loadImg(\'teach\');\n    loadImg(\'school\');\n    loadImg(\'croom\');\n    loadImg(\'syear\');\n    loadImg(\'clock\');\n    loadImg(\'week\');\n}',NULL,0,0,'2015-10-10 18:09:06','globeadmin','2018-01-09 19:16:06','globeadmin','2018-01-09 19:16:06','globeadmin','',0,NULL),('561a90ab2457a16','search_timetable','Αναζήτηση Διδασκαλιών','select * from teacher','teacher','id',960,520,'select \'Ωρολόγια Προγράμματα\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function foo(param){\n    ;\n}\nfunction pass_session_variable(param){\n    nuSetHash(\'varval\', param);\n}\nfunction get_session_variable(varname){\n    nuSetHash(\'varname\', varname);\n    nuAjax(\'getSessionVariable\',\'pass_session_variable\');\n    return nuGetHash(\'varval\');\n}\nfunction set_session_variable(varname,varval){\n    nuSetHash(\'varname\', varname);\n    nuSetHash(\'varval\', varval);\n    nuAjax(\'setSessionVariable\',\'foo\');\n}\n\nfunction loadImg(img_name) { \n    i = new Image(); \n    i.src = \'images/\'+img_name+\'.png\';\n    \n    ib = new Image(); \n    ib.src = \'images/\'+img_name+\'b.png\';    \n}\n\n\nfunction nuLoadEdit() {\n    \n    loadImg(\'timeadd\');\n    loadImg(\'timecp\');\n    loadImg(\'timerem\');\n    loadImg(\'timeup\');\n    loadImg(\'celebr\');\n    \n    //$(\'#absence_teacher_id\').val(\'#RECORD_ID#\');\n    $(\'#label1\').css(\"fontSize\", \"10px\");\n    $(\'#label1\').css(\'font-style\', \'italic\');\n    \n    $(\'#datedisp\').css(\"background-color\", \"red\");\n    $(\'#datedisp\').css(\"color\", \"white\");\n    //$(\'#datedisp\').css(\"fontSize\", \"14px\");\n    $(\'#datedisp\').css(\"font-weight\", \"bold\");\n    nuFORM.edited = 0;\n}',NULL,0,0,'2015-10-11 19:39:07','globeadmin','2015-12-26 23:10:10','globeadmin','2018-07-13 20:02:17','globeadmin','',0,NULL),('561fe384a42ad55','remove_timetable','Διαγραφή Ωρολογίου','select * from teacher','teacher','id',700,300,'select \'Διαγραφή Ωρολογίου\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function foo(param){\n    ;\n}\nfunction pass_session_variable(param){\n    nuSetHash(\'varval\', param);\n}\nfunction get_session_variable(varname){\n    nuSetHash(\'varname\', varname);\n    nuAjax(\'getSessionVariable\',\'pass_session_variable\');\n    return nuGetHash(\'varval\');\n}\nfunction set_session_variable(varname,varval){\n    nuSetHash(\'varname\', varname);\n    nuSetHash(\'varval\', varval);\n    nuAjax(\'setSessionVariable\',\'foo\');\n}\n\nfunction dsplayAjaxMessage(param){\n    if(param!=\'\'){\n        alert(param);\n    }\n    parent.nuReloadForm();    \n    nuRemoveModal();\n}\n\nfunction nuLoadEdit() {\n    nuFORM.edited = 0;\n    $(\'#label1\').css(\"fontSize\", \"11px\");\n    $(\'#label1\').css(\'font-style\', \'italic\');\n}',NULL,0,0,'2015-10-15 20:33:56','globeadmin','2015-10-15 21:43:11','globeadmin','2016-01-02 22:31:38','globeadmin','',0,NULL),('562003aa49d836a','copy_timetable','Αντιγραφή Ωρολογίου','select * from teacher','teacher','id',700,300,'select \'Αντιγραφή Ωρολογίου\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function foo(param){\n    ;\n}\nfunction pass_session_variable(param){\n    nuSetHash(\'varval\', param);\n}\nfunction get_session_variable(varname){\n    nuSetHash(\'varname\', varname);\n    nuAjax(\'getSessionVariable\',\'pass_session_variable\');\n    return nuGetHash(\'varval\');\n}\nfunction set_session_variable(varname,varval){\n    nuSetHash(\'varname\', varname);\n    nuSetHash(\'varval\', varval);\n    nuAjax(\'setSessionVariable\',\'foo\');\n}\n\nfunction dsplayAjaxMessage(param){\n    if(param!=\'\'){\n        alert(param);\n    }\n    parent.nuReloadForm();    \n    nuRemoveModal();\n}\n\nfunction nuLoadEdit() {\n    nuFORM.edited = 0;\n    $(\'#label1\').css(\"fontSize\", \"11px\");\n    $(\'#label1\').css(\'font-style\', \'italic\');\n}',NULL,0,0,'2015-10-15 22:51:06','globeadmin','2015-10-15 23:02:22','globeadmin','2016-01-02 22:34:11','globeadmin','',0,NULL),('56192b05ed5032f','managers_config','Managers configuration form','select * from teachers','teacher','id',1000,520,'select \'Ρυθμίσεις και Εργασίες Διαχείρισης\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'','nuRunPHP(\'check_permission_lib\');\n\nif(!check_permission(\'1\')){\n    $MESSAGE = \'Προσοχή! Δεν έχετε άδεια πρόσβασης στα δεδομένα αυτά!\';\n    nuDisplayError($MESSAGE);\n    return;\n}\n',NULL,NULL,'function get_backup_file(param){\n    if(param!=\'\' && param!=\'-1\'){\n        nuSetHash(\'backup_file_name\', param);\n        nuRunPHP(\'backup_db_get_file\',\'hidden_iframe\');\n    } else {\n        alert(\'Η δημιουργία του αντιγράφου ασφαλείας απέτυχε!\'); \n    } \n    hideLoader();\n}\n\nfunction display_ajax_result(param){\n    hideLoader();\n    alert(param);\n}\n\nfunction new_version_check(param){\n    if(param==\'1\'){\n        document.getElementById(\'info_id\').style.display = \'block\';    \n    }\n}\n\nfunction nuLoadEdit() {  \n\n    loadImg(\'upstd\');\n    loadImg(\'upchart\');\n    loadImg(\'upcards\');\n    loadImg(\'uptimetbl\');\n    loadImg(\'absences_upload\');\n    loadImg(\'parents_create_accounts\');\n    loadImg(\'advisor\');\n    loadImg(\'tchclass\');\n    loadImg(\'stdaccadd\');\n    \n    loadImg(\'useracc\');\n    loadImg(\'system_check\');\n    loadImg(\'merge\');\n    loadImg(\'emailconf\');\n    loadImg(\'clear_tmp\');\n    loadImg(\'backup\');\n    loadImg(\'update\');\n    loadImg(\'deleteall\');\n    \n    loadImg(\'sliders\');\n    loadImg(\'cards_config\');\n    loadImg(\'teachspec\');\n    loadImg(\'notification_category\');\n    loadImg(\'notification_type\');\n    loadImg(\'schools\');\n    loadImg(\'abconf\');\n    loadImg(\'justconf\');\n    loadImg(\'reqconf\');\n    \n    /*if( \'#nu_user_group#\'==\'globeadmin\' || \'#nu_user_group#\'==\'Administrators\' || \'#nu_user_group#\'==\'Managers\'){\n        nuAjax(\'check_for_new_version\',\'new_version_check\',{async:true});\n    }*/\n}',NULL,0,0,'2015-10-10 18:13:09','globeadmin','2019-07-25 10:13:34','globeadmin','2019-07-25 10:13:34','globeadmin','',0,NULL),('5787f33aaa172a1','set_period_absences_open','Καταχώριση απουσιών Ώρας - Ανοιχτό','select * from teacher','teacher','id',960,1480,'select \'Καταχώριση Aπουσιών\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'','nuRunPHP(\'check_permission_lib\');\n\nif(!check_permission(\'1\')){\n    $MESSAGE = \'Προσοχή! Δεν έχετε άδεια πρόσβασης στα δεδομένα αυτά!\';\n    nuDisplayError($MESSAGE);\n    return;\n}',NULL,NULL,'function show_justification_request(absence_id,number_of_pending_requests){\n    var iframe = document.getElementById(\'period_absence_iframe\');\n    var innerDoc = (iframe.contentDocument) ? iframe.contentDocument : iframe.contentWindow.document;\n\n    var a = innerDoc.getElementById(\'absence_\'+absence_id);\n    if(a){\n        a.style.backgroundImage = (number_of_pending_requests==0 ? \'\' : \'linear-gradient(225deg, #00b6b6, #00b6b6 6px, transparent 6px, transparent)\');\n    }\n}\n\nfunction set_comments(cell_id,comments){}\n\nfunction pollute_period(param){\n   \n    $(\'#absence_period_id\').empty();\n    $(\'#absence_period_id\').append(\'<option value=\"\"></option>\');\n   \n    if(param && param!=\'\'){\n        var json_data = JSON.parse(param);\n       \n        for(var i=0; i < json_data.length;i++){ \n            $(\'#absence_period_id\').append(\'<option value=\"\'+json_data[i][0]+\'\">\'+json_data[i][1]+\'</option>\');\n        }\n    \n        if(json_data.length==1){\n            $(\'#absence_period_id\').val(json_data[0][0]);\n        }\n    }\n    $(\'#absence_period_id\').trigger( \"onchange\" );\n}\n\nfunction pollute_class(param){\n   \n    $(\'#absence_class_id\').empty();\n    $(\'#absence_class_id\').append(\'<option value=\"\"></option>\');\n   \n    if(param && param!=\'\'){\n        var json_data = JSON.parse(param);\n        for(var i=0; i < json_data.length;i++){ \n            $(\'#absence_class_id\').append(\'<option value=\"\'+json_data[i][0]+\'\">\'+json_data[i][1]+\'</option>\');\n        }\n        if(json_data.length==1){\n            $(\"#absence_class_id\").val(json_data[0][0]);\n        }\n    }\n    $(\'#absence_class_id\').trigger( \"onchange\" );\n}\n\nvar ajaxSucced = false;\nfunction foo(param){\n    ajaxSucced = true;\n}\n\nfunction open_rc(param){\n    if(!param || param==\'-1\'){\n        alert(\'Δεν βρέθηκαν σημειώσεις διδασκαλίας!\\nΠρέπει να γίνει καταχώριση των απουσιών για να δημιουργηθούν σημειώσεις διδασκαλίας!\');\n    } else {\n        nuOpenFormInFrame(\'56dd9f180d22b31\',param);\n    }\n}\n\nfunction enable_setbtn(){\n    $(\'#period_absence_setbtn\').removeClass(\'disabled\').prop(\'disabled\', false);\n    $(\'#no_lesson_img\').removeClass(\'disabledimg\').prop(\'disabled\', false);\n}\n\nfunction disable_setbtn(){\n    $(\'#period_absence_setbtn\').addClass(\'disabled\').prop(\'disabled\', true);\n    $(\'#no_lesson_img\').addClass(\'disabledimg\').prop(\'disabled\', true);\n}\n\nfunction set_no_lesson(){\n    if($(\'#absence_date\').val()!=\'\' && $(\'#absence_period_id\').val()!=\'\' && $(\'#absence_class_id\').val()!=\'\'){\n    \n        var iframe = document.getElementById(\'period_absence_iframe\');\n        var innerDoc = (iframe.contentDocument) ? iframe.contentDocument : iframe.contentWindow.document;\n        var a = innerDoc.getElementsByClassName(\'absence\');\n\n        if (a.length>0){\n    \n            if(confirm(\'Η διδασκαλία αυτή θα καταχωρηθεί ως μη πραγματοποιηθείσα!\\nΗ ενέργεια αυτή δεν μπορεί να αναιρεθεί από εσάς!\\nΕίστε σίγουρος;\')){\n        \n                var reason = prompt(\'Παρακαλώ εισάγετε το λόγο για τον οποίο δεν πραγματοποιήθηκε η διδασκαλία\',\'\');    \n        \n                if (reason != null) {\n                    if(reason.trim() != \'\'){\n                        nuSetHash(\'no_lesson_comments\',reason);\n                    } else {\n                        nuSetHash(\'no_lesson_comments\',\'\'); \n                    }\n                } else {\n                    nuSetHash(\'no_lesson_comments\',\'\');    \n                }\n        \n                nuSetHash(\'no_lesson_period_id\',$(\'#absence_period_id\').val());\n                nuAjax(\'register_no_lesson_cards\',\'foo\'); // Δήλωση Καταχώρισης Απουσίών\n                reload_absence_table();\n            }\n        } else {\n            alert(\'Η Διδασκαλία έχει ήδη καταχωρηθεί. Δεν μπορεί να τροποποιηθεί!\');    \n        }\n    } else {\n        alert(\'Παρακαλώ επιλέξτε πρώτα απουσιολόγιο...\');    \n    }\n}\n\nfunction reload_absence_table(){\n    nuRunPHP(\'create_absence_period_table_open\',\'period_absence_iframe\'); // Επαναφόρτωση Απουσιολογίου\n}\n\nvar t_id=\'#RECORD_ID#\';\nvar t_post_id=\'#RECORD_ID#\';\nvar s_id=-1;\nvar s_name=\'\';\nvar sb_id=-1;\nvar sb_name=\'\';\n\nfunction nuLoadEdit() {\n    disable_setbtn();\n    $(\'#absence_date\').val($(\'#current_date\').val())\n    $(\'#absence_date\').trigger( \"onchange\" );\n    \n    var cp_id  = $(\'#current_period_id\').val();\n    var opts = document.getElementById(\'absence_period_id\');\n\n    if(cp_id!=\'\'){\n        \n        for(var i = 0; i < opts.options.length; ++i){\n            if( opts.options[i].value == cp_id){\n                if(opts.options[opts.selectedIndex].value!=cp_id){\n                    opts.selectedIndex = i;\n                    $(\'#absence_period_id\').trigger( \"onchange\" );\n                }\n                break;\n            }\n        }\n        \n    }\n \n}\n',NULL,0,0,'2016-07-14 23:16:58','globeadmin','2022-12-21 12:48:23','globeadmin','2022-12-21 12:48:23','globeadmin','',0,NULL),('56192be786c61d7','managers_mark','Managers marks form','select * from teachers','teacher','id',1000,520,'select \'Αξιολόγηση Μαθητών και Ποινές\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'','nuRunPHP(\'check_permission_lib\');\n\nif(!check_permission(\'1\')){\n    $MESSAGE = \'Προσοχή! Δεν έχετε άδεια πρόσβασης στα δεδομένα αυτά!\';\n    nuDisplayError($MESSAGE);\n    return;\n}\n',NULL,NULL,'function foo(param){\n    ;\n}\nfunction pass_session_variable(param){\n    nuSetHash(\'varval\', param);\n}\nfunction get_session_variable(varname){\n    nuSetHash(\'varname\', varname);\n    nuAjax(\'getSessionVariable\',\'pass_session_variable\');\n    return nuGetHash(\'varval\');\n}\nfunction set_session_variable(varname,varval){\n    nuSetHash(\'varname\', varname);\n    nuSetHash(\'varval\', varval);\n    nuAjax(\'setSessionVariable\',\'foo\');\n}\n\nfunction loadImg(img_name) { \n    i = new Image(); \n    i.src = \'images/\'+img_name+\'.png\';\n    \n    ib = new Image(); \n    ib.src = \'images/\'+img_name+\'b.png\';    \n}\n\nfunction nuLoadEdit() {  \n    \n    loadImg(\'mark\');\n    loadImg(\'gradenot\');\n    loadImg(\'grexcel\');\n    loadImg(\'grprint\');\n    loadImg(\'mark_email\');\n    loadImg(\'cards\');\n    loadImg(\'cup.png\');\n}',NULL,0,0,'2015-10-10 18:16:55','globeadmin','2021-10-24 21:33:11','globeadmin','2021-10-24 21:33:11','globeadmin','',0,NULL),('562229979f567be','remove_all','Διαγραφή Όλων των Στοιχείων','select * from teacher','teacher','id',960,600,'select \'Διαγραφή Όλων των Στοιχείων\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function nuLoadEdit() {\n    \n    $(\'#label1\').css(\'fontSize\', \'12px\');\n    $(\'#label1\').css(\'font-style\', \'italic\');\n    //$(\'#label1\').css(\"background-color\", \"red\");\n    $(\'#label1\').css(\'color\', \'red\');\n    $(\'#label1\').css(\'font-weight\', \'bold\');\n    \n    $(\'#label2\').css(\'fontSize\', \'12px\');\n    $(\'#label2\').css(\'font-style\', \'italic\');\n    $(\'#label2\').css(\'color\', \'red\');\n    $(\'#label2\').css(\'font-weight\', \'bold\');\n    \n    $(\'#label3\').css(\'fontSize\', \'12px\');\n    $(\'#label3\').css(\'font-style\', \'italic\');\n    $(\'#label3\').css(\'color\', \'red\');\n    $(\'#label3\').css(\'font-weight\', \'bold\');\n    \n    $(\'#mypass_hide\').hide();\n    nuFORM.edited = 0;\n}',NULL,0,0,'2015-10-17 13:57:27','globeadmin','2016-07-12 00:30:37','globeadmin','2016-07-12 00:44:29','globeadmin','',0,NULL),('56192c691b58858','managers_subject','Managers subject form','select * from teachers','teacher','id',1000,520,'select \'Μαθήματα και Διδασκαλίες\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'','nuRunPHP(\'check_permission_lib\');\n\nif(!check_permission(\'1\')){\n    $MESSAGE = \'Προσοχή! Δεν έχετε άδεια πρόσβασης στα δεδομένα αυτά!\';\n    nuDisplayError($MESSAGE);\n    return;\n}\n',NULL,NULL,'function foo(param){\n    ;\n}\nfunction pass_session_variable(param){\n    nuSetHash(\'varval\', param);\n}\nfunction get_session_variable(varname){\n    nuSetHash(\'varname\', varname);\n    nuAjax(\'getSessionVariable\',\'pass_session_variable\');\n    return nuGetHash(\'varval\');\n}\nfunction set_session_variable(varname,varval){\n    nuSetHash(\'varname\', varname);\n    nuSetHash(\'varval\', varval);\n    nuAjax(\'setSessionVariable\',\'foo\');\n}\n\nfunction loadImg(img_name) { \n    i = new Image(); \n    i.src = \'images/\'+img_name+\'.png\';\n    \n    ib = new Image(); \n    ib.src = \'images/\'+img_name+\'b.png\';    \n}\n\nfunction nuLoadEdit() {  \n    loadImg(\'books\');\n    loadImg(\'timetable\');\n    loadImg(\'celebr\');\n    \n    loadImg(\'letters\');\n    loadImg(\'section\');\n    loadImg(\'tree\');\n    \n    loadImg(\'ebooks\');\n    loadImg(\'subcat\');\n    loadImg(\'critirion\');\n    \n}',NULL,0,0,'2015-10-10 18:19:05','globeadmin','2017-11-12 16:19:37','globeadmin','2021-10-24 21:25:06','globeadmin','',0,NULL),('5621401c573dfb8','card_insert','Εισαγωγή Διδασκαλίας','select * from card','card','id',850,500,'select \'Εισαγωγή Νέας Διδασκαλίας\'',NULL,'1',NULL,NULL,'1',NULL,NULL,NULL,NULL,NULL,'Νέα Διδασκαλία',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'$today = date(\'Y-m-d\');\nif(\'#valid_from#\'<=$today){\n    $MESSAGE = \'Προσοχή: H ημερομηνία έναρξης ισχύος της διδασκαλίας  πρέπει να είναι μεγαλύτερη της σημερινής!\';\n    nuDisplayError($MESSAGE);\n    return;\n}',NULL,'',NULL,NULL,NULL,'function nuLoadEdit() {\n    $(\'#label1\').css(\"fontSize\", \"11px\");\n    $(\'#label1\').css(\'font-style\', \'italic\');\n    \n    $(\'#label2\').css(\"fontSize\", \"11px\");\n    $(\'#label2\').css(\'font-style\', \'italic\');\n    \n    $(\'#label3\').css(\"fontSize\", \"11px\");\n    $(\'#label3\').css(\'font-style\', \'italic\');\n    \n    \n    $(\'#label4\').css(\"fontSize\", \"11px\");\n    $(\'#label4\').css(\'font-style\', \'italic\');\n    \n    $(\'#label5\').css(\"fontSize\", \"12px\");\n    $(\'#label5\').css(\'font-weight\', \'bold\');\n\n}',NULL,0,0,'2015-10-16 21:21:16','globeadmin','2015-10-16 23:16:24','globeadmin','2016-01-03 11:44:40','globeadmin','',0,NULL),('562362d2ef4f556','set_marks_new','Καταχώριση Αξιολόγησης','select * from teacher','teacher','id',1100,530,'select \'Καταχώριση Αξιολόγησης\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'','nuRunPHP(\'check_permission_lib\');\n\nif(!check_permission(\'1\')){\n    $MESSAGE = \'Προσοχή! Δεν έχετε άδεια πρόσβασης στα δεδομένα αυτά!\';\n    nuDisplayError($MESSAGE);\n    return;\n}',NULL,NULL,'var markEdited = false;\n\nfunction mark_edited() {\n    if(!markEdited){\n        markEdited =  true;\n        nuFORM.edited = \'1\';\n        $(\'#savebtn\').removeClass(\'nuButton\');\n        $(\'#savebtn\').addClass(\'nuNotSaved\');\n    }\n}\n\nfunction make_note_red(img_id,comments){\n    var iframe = document.getElementById(\'marks_iframe\');\n    var innerDoc = (iframe.contentDocument) ? iframe.contentDocument : iframe.contentWindow.document;\n\n    var x = innerDoc.getElementById(img_id);\n    x.src = \'images/edit_red.png\';\n    if(comments==\'\'){\n        x.title = \'Περιγραφική Αξιολόγηση / Σχολιασμός Βαθμού\';    \n    } else {\n        x.title = \'Σχόλια : \'+comments+\'...\';    \n    }\n    \n}\n\nfunction make_note_blank(img_id){\n    var iframe = document.getElementById(\'marks_iframe\');\n    var innerDoc = (iframe.contentDocument) ? iframe.contentDocument : iframe.contentWindow.document;\n\n    var x = innerDoc.getElementById(img_id);\n    x.src = \'images/edit.png\';\n    x.title = \'Σχολιασμός Βαθμού\';\n}\n\nfunction validateInputText(inp,frm){\n                \n    var value       = inp.value;\n    var cell = frm.getElementById(\'hls_\'+inp.id);\n    var rg_cell = frm.getElementById(\'rg_\'+inp.id);\n    var surname_cell = frm.getElementById(\'surname_\'+inp.id);\n    var name_cell = frm.getElementById(\'name_\'+inp.id);\n    var fathers_name_cell = frm.getElementById(\'fathers_name_\'+inp.id);\n    \n    var std_full_name = surname_cell.innerHTML.slice(3,-4)+\' \'+name_cell.innerHTML.slice(3,-4)+\' πατ. \'+fathers_name_cell.innerHTML.slice(3,-4);    \n    \n    if(value.trim()!=\'\'){\n        var v=parseFloat(value.replace(\',\',\'.\'));\n        if(!isNaN(v)){\n            if (v<0 || v>20){\n                alert(\'Παρακαλώ εισάγετε βαθμούς από Μηδέν (0) εως Είκοσι (20)!\');\n                return false;\n            } else {\n                if(v==0){\n                    if(cell.innerHTML ==\'ΝΑΙ\' && ($(\'#mark_required\').val()==\'1\')){\n                        return(confirm(\'Προσοχή : Ο Μαθητής \'+std_full_name+\' φοιτά και τον βαθμολογήσατε με Μηδέν! Θέλετε να συνεχίσετε;\'));\n                    }\n                }\n            }\n        } else {\n            alert(value+\': Μη έγκυρος βαθμός!\');\n            return false;\n        }\n    } else {\n        if(cell.innerHTML ==\'ΝΑΙ\' && ($(\'#mark_required\').val()==\'1\')){\n            return(confirm(\'Προσοχή : Ο Μαθητής \'+std_full_name+\' φοιτά και δεν του βάλατε βαθμό! Θέλετε να συνεχίσετε;\'));\n        }\n    }\n    return true; \n}\n\nfunction nuLoadEdit() {\n    \n    $(\'#granding_period_end_date\').css(\'background-color\', \'red\');\n    $(\'#granding_period_end_date\').css(\'color\', \'white\');\n    \n    $(\'#grading_period_iddsp\').hide();\n    \n}\n\n/*function nuOnSave(){ \n    \n    var ch_desimals = false;\n    var num_of_decimals = get_session_variable(\'grading_period_decimals\');\n    \n    if (num_of_decimals<0) num_of_decimals=0;\n    \n    for( index in subFormPrefixes) {\n        //Obtain value on the current row\n        value  = $(\'#\'+subFormPrefixes[index]+\'value\').val();\n        if(value!=\'\'){\n            v=parseFloat(value.replace(\',\',\'.\'));\n        \n            vd=v.toFixed(num_of_decimals);\n            vd=parseFloat(vd.toString());\n            vd=vd.toFixed(1);\n        \n            vds=vd.toString();\n            vds=vds.replace(\'.\',\',\');\n        \n            if (v!=vd){\n                $(\'#\'+subFormPrefixes[index]+\'value\').val(vds);\n                ch_desimals = true;\n            }\n        }\n    }\n        \n    if (ch_desimals){\n        alert(\'Απαιτούνται ακέραιοι βαθμοί σε αυτή τη βαθμολογική περίοδο!\\n\\nΟι αλλαγές δεν αποθηκεύτηκαν!\\n\\nΑν συμφωνείτε με τις στρογγυλοποιήσεις, αποθηκεύστε ξανά!\');    \n        return false;\n    }\n    \n    return true; \n}*/\n\n',NULL,0,0,'2015-10-18 12:13:55','globeadmin','2022-02-08 23:41:05','globeadmin','2022-02-08 23:51:03','globeadmin','',0,NULL),('6206ad009f3ac5e','absence_compare','Σύγκριση συνόλου απουσιών ανά ημέρα με άλλα συστήμ','select * from teacher','teacher','id',1000,600,'select \'Σύγκριση Απουσιών με Άλλα Συστήματα\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function reload_iframe(param){\n    sisMessage(param);\n    //nuRunPHP(\'\',\'iframe\');\n}\n\nfunction nuLoadEdit() {\n    nuSetHash(\'FILES\' , \'\');\n    nuFORM.edited = 0;\n}',NULL,0,0,'2022-02-11 20:37:52','globeadmin','2022-02-11 20:57:04','globeadmin','2022-02-12 00:40:40','globeadmin','',0,NULL),('562d11f6d45ccf1','mark','Λεπτομέρειες Βαθμού','select * from mark','mark','id',750,520,'select \'Λεπτομέρειες Βαθμού\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function foo(param){\n    ;\n}\nfunction pass_session_variable(param){\n    nuSetHash(\'varval\', param);\n}\nfunction get_session_variable(varname){\n    nuSetHash(\'varname\', varname);\n    nuAjax(\'getSessionVariable\',\'pass_session_variable\');\n    return nuGetHash(\'varval\');\n}\nfunction set_session_variable(varname,varval){\n    nuSetHash(\'varname\', varname);\n    nuSetHash(\'varval\', varval);\n    nuAjax(\'setSessionVariable\',\'foo\');\n}\n\nfunction dsplayAjaxMessage(param){\n    if(param!=\'\'){\n        alert(param);\n    }\n    parent.nuReloadForm();    \n    nuRemoveModal();\n}\n\nfunction nuLoadEdit() {\n    //$(\'#value\').css(\'fontSize\', \'18px\');\n    //$(\'#value\').css(\'font-weight\', \'bold\');\n    //$(\'#value\').css(\'background-color\', \'LightYellow\');\n    //$(\'#comments\').css(\'fontSize\', \'14px\');\n    //$(\'#comments\').css(\'font-weight\', \'bold\');\n    //$(\'#comments\').css(\'background-color\', \'LightYellow\');\n    \n    /*var value = $(\'#value\').val();\n    \n    if(value==\'\'){\n        value=\'Ν/Α\'\n    } else {\n        var v=parseFloat(value);\n        value = value.replace(\'.\',\',\');\n        if(v<10){\n            $(\'#value\').css(\'color\', \'red\');\n            $(\'#comments\').css(\'color\', \'red\');\n        } else if(v<17){\n            $(\'#value\').css(\'color\', \'blue\');\n            $(\'#comments\').css(\'color\', \'blue\');\n        } else {\n            $(\'#value\').css(\'color\', \'green\');\n            $(\'#comments\').css(\'color\', \'green\');\n        }\n    }\n    $(\'#value\').val(value);*/\n    \n    nuSetHash(\'table_name\',\'mark\');\n    nuSetHash(\'table_field\',\'comments\');\n    nuSetHash(\'id_name\',\'id\'); \n    nuSetHash(\'id_value\',\'#RECORD_ID#\');\n    \n    nuRunPHP(\'show_html_field\',\'comments_iframe\');\n}',NULL,0,0,'2015-10-25 19:31:34','globeadmin','2016-07-24 22:56:42','globeadmin','2017-04-02 08:29:18','globeadmin','',0,NULL),('5627e58b8ed5f6d','mark_comments','Σχόλια Βαθμού','select * from mark','mark','id',1000,630,'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'','$sql=\"  CREATE TEMPORARY TABLE IF NOT EXISTS #TABLE_ID# AS \n        (SELECT \n		    mark.id as mark_id,\n		    critirion_special.id as critirion_special_id\n        FROM mark\n        INNER JOIN subject 						ON subject.id								=	mark.subject_id\n        INNER JOIN subject_critirion_general 	ON subject_critirion_general.subject_id		=	subject.id\n        INNER JOIN critirion_general 			ON critirion_general.id						=	subject_critirion_general.critirion_general_id\n        INNER JOIN critirion_special 			ON critirion_special.critirion_general_id	= 	critirion_general.id\n        WHERE mark.id=\'#RECORD_ID#\')\n    \";\nnuRunQuery($sql);\n\n$sql=\"  DELETE FROM mark_critirion_special_level\n        WHERE\n            mark_id = \'#RECORD_ID#\' AND\n            ((mark_id,critirion_special_id) NOT IN \n            (SELECT mark_id,critirion_special_id FROM #TABLE_ID#))\n        \";\nnuRunQuery($sql);\n\n$sql=\"  DELETE FROM #TABLE_ID#\n        WHERE \n            (mark_id,critirion_special_id) IN \n            (SELECT mark_id,critirion_special_id FROM mark_critirion_special_level where mark_id=\'#RECORD_ID#\')\n        \";\nnuRunQuery($sql);\n\n$sql=\"  INSERT INTO  mark_critirion_special_level (\n            id,\n            mark_id,\n            critirion_special_id,\n            critirion_special_level_id)\n        (SELECT\n            NULL,\n            mark_id,\n            critirion_special_id,\n            NULL\n            FROM #TABLE_ID#)\n        \";\nnuRunQuery($sql);\n','if (\'#criritia_JSON#\'!=\'\' && \'#criritia_JSON#\'!=\'#\'.\'criritia_JSON#\' && \'#criritia_JSON#\'!=\'[]\'){\n    \n    nuRunPHP(\'update_mark_critiria\');\n    \n    $sql=\"UPDATE mark SET added_when=NOW() WHERE id=\'#RECORD_ID#\'\";\n    nuRunQuery($sql);\n}',NULL,'function open_next_student(param){\n    if(param==\'-1\' || param==\'\'){\n        alert(\'Αυτός είναι ο τελευταίος μαθητής του τμήματος!\');    \n    } else {\n        //parent.nuOpenFormInFrame(\'5627e58b8ed5f6d\', param);\n        window.nuSession.breadCrumb.pop();\n        nuOpenForm(\'\',\'\', \'5627e58b8ed5f6d\', param,\'Αρχική\');    \n    } \n}\n\nfunction open_prev_student(param){\n    if(param==\'-1\' || param==\'\'){\n        alert(\'Αυτός είναι ο πρώτος μαθητής του τμήματος!\');    \n    } else {\n        //parent.nuOpenFormInFrame(\'5627e58b8ed5f6d\', param);\n        window.nuSession.breadCrumb.pop();\n        nuOpenForm(\'\',\'\', \'5627e58b8ed5f6d\', param,\'Αρχική\');    \n    } \n}\n\nfunction strip(html){\n   var tmp = document.createElement(\"DIV\");\n   tmp.innerHTML = html;\n   return tmp.textContent || tmp.innerText || \"\";\n}\n\nfunction is_blank(){\n    plaintext = strip($(\'#comments\').val()).trim();\n    if(plaintext!=\'\'){return false;}\n    if($(\'#critiria_count\').val()!=\'0\' && $(\'#critiria_count\').val()!=\'\') {return false;}\n    return true;\n}\n\nfunction passTinymceContents(){\n    var y = document.getElementById(\'comments\').value;\n    return(y);\n}\n\nfunction foo(param){\n    ;\n}\nfunction pass_session_variable(param){\n    nuSetHash(\'varval\', param);\n}\nfunction get_session_variable(varname){\n    nuSetHash(\'varname\', varname);\n    nuAjax(\'getSessionVariable\',\'pass_session_variable\');\n    return nuGetHash(\'varval\');\n}\nfunction set_session_variable(varname,varval){\n    nuSetHash(\'varname\', varname);\n    nuSetHash(\'varval\', varval);\n    nuAjax(\'setSessionVariable\',\'foo\');\n}\n\nfunction dsplayAjaxMessage(param){\n    if(param!=\'\'){\n        alert(param);\n    }\n    parent.nuReloadForm();    \n    nuRemoveModal();\n}\n\nfunction after_save_critiria(param){\n    ;\n}\n\nfunction nuLoadEdit() {\n    \n    if(!is_blank()){\n        parent.make_note_red(\'img_\'+\'#RECORD_ID#\',plaintext.substr(0, 20));\n    } else {\n        parent.make_note_blank(\'img_\'+\'#RECORD_ID#\') ;\n    }\n\n    nuFORM.edited = 0;\n    $(\'#label1\').css(\"fontSize\", \"11px\");\n    $(\'#label1\').css(\'font-style\', \'italic\');\n    \n    if($(\'#critiria_subject_count\').val()!=\'0\' && $(\'#critiria_subject_count\').val()!=\'\') {\n        $(\'#tab1\').trigger(\'click\');\n    }\n}',NULL,0,0,'2015-10-21 22:20:43','globeadmin','2018-07-23 09:37:23','globeadmin','2018-07-23 09:37:23','globeadmin','',0,NULL),('562e770b79c0722','show_teachers_marks','Εμφάνιση Αξιολόγησης','select * from teacher','teacher','id',1050,1050,'select \'Εμφάνιση Αξιολόγησης\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function foo(param){\n    ;\n}\nfunction pass_session_variable(param){\n    nuSetHash(\'varval\', param);\n}\nfunction get_session_variable(varname){\n    nuSetHash(\'varname\', varname);\n    nuAjax(\'getSessionVariable\',\'pass_session_variable\');\n    return nuGetHash(\'varval\');\n}\nfunction set_session_variable(varname,varval){\n    nuSetHash(\'varname\', varname);\n    nuSetHash(\'varval\', varval);\n    nuAjax(\'setSessionVariable\',\'foo\');\n}\n\nfunction refresh_lessons(param){\n    $(\'#class_subject_selection\').empty()\n    $(\'#class_subject_selection\').append(\'<option value=\"\"></option>\');\n    if(!param==\'\'){\n    var ln = param.split(\'\\n\'); \n    for(i=0;i<ln.length;i++){  \n        var fld=ln[i].split(\'\\t\');\n        $(\'#class_subject_selection\').append(\'<option value=\"\'+fld[0]+\'\">\'+fld[1]+\'</option>\'); \n        }\n    }\n}\n\nfunction nuLoadEdit() {\n    \n}',NULL,0,0,'2015-10-26 20:55:07','globeadmin','2016-07-24 23:26:21','globeadmin','2018-02-04 14:42:50','globeadmin','',0,NULL),('56312e4782e78b4','show_manager_marks','Εμφάνιση Όλης της Αξιολόγησης','select * from teacher','teacher','id',1050,1050,'select \'Εμφάνιση Αξιολόγησης\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function lock(g,c,s,state){\n    nuSetHash(\'g_id\',g);\n    nuSetHash(\'s_id\',s);\n    nuSetHash(\'c_id\',c);\n    nuSetHash(\'to_publish\',(state ? \'1\' : \'0\'));\n    nuAjax(\'publish_marks\',\'after_lock\');\n}\n\nfunction after_lock(param){\n    nuRunPHP(\'show_marks_teacher\' , \'marks_showiframe\');\n}\n\nfunction pollute_class(param){\n    $(\'#class_id\').empty();\n    $(\'#class_id\').append(\'<option value=\"\"></option>\');\n    if(!param==\'\'){\n        var ln = param.split(\'\\n\'); \n        for(i=0;i<ln.length;i++){  \n            var fld=ln[i].split(\'\\t\');\n            $(\'#class_id\').append(\'<option value=\"\'+fld[0]+\'\">\'+fld[1]+\'</option>\'); \n        }\n    }\n}\n\nfunction pollute_subject(param){\n    $(\'#subject_id\').empty();\n    $(\'#subject_id\').append(\'<option value=\"\"></option>\');\n    if(!param==\'\'){\n        var ln = param.split(\'\\n\'); \n        for(i=0;i<ln.length;i++){  \n            var fld=ln[i].split(\'\\t\');\n            $(\'#subject_id\').append(\'<option value=\"\'+fld[0]+\'\">\'+fld[1]+\'</option>\'); \n        }\n    }\n}\n\nfunction nuLoadEdit() {\n    \n}',NULL,0,0,'2015-10-28 22:21:27','globeadmin','2018-02-04 13:02:29','globeadmin','2020-04-02 19:43:36','globeadmin','',0,NULL),('5a7738b60e35797','connection_setup','Επιλογές Σύνδεσης Χρηστών','SELECT * FROM zzzsys_setup','zzzsys_setup','zzzsys_setup_id',960,500,'Select \'Επιλογές Σύνδεσης Χρηστών\'',NULL,'1',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,0,0,'2018-02-04 18:45:42','globeadmin','2018-07-28 11:59:24','globeadmin','2018-07-28 11:59:25','globeadmin','',0,NULL),('565217dbaa6d49a','teacher_tmp','Καθηγητής','select * from teacher','teacher','id',1000,520,'select \'Καθηγητής τμπ\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function foo(param){\n    ;\n}\nfunction pass_session_variable(param){\n    nuSetHash(\'varval\', param);\n}\nfunction get_session_variable(varname){\n    nuSetHash(\'varname\', varname);\n    nuAjax(\'getSessionVariable\',\'pass_session_variable\');\n    return nuGetHash(\'varval\');\n}\nfunction set_session_variable(varname,varval){\n    nuSetHash(\'varname\', varname);\n    nuSetHash(\'varval\', varval);\n    nuAjax(\'setSessionVariable\',\'foo\');\n}\n\nfunction nuLoadEdit() {\n\n}',NULL,0,0,'2015-11-22 21:30:35','globeadmin','2015-11-22 21:37:23','globeadmin','2015-11-22 21:37:23','globeadmin','',0,NULL),('565b05b5e424081','print_manager_marks','Εκτύπωση όλης της βαθμολογίας βάση κριτηρίων','select * from teacher','teacher','id',960,710,'select \'Εκτύπωση Βαθμολογίας\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function foo(param){\n    ;\n}\nfunction pass_session_variable(param){\n    nuSetHash(\'varval\', param);\n}\nfunction get_session_variable(varname){\n    nuSetHash(\'varname\', varname);\n    nuAjax(\'getSessionVariable\',\'pass_session_variable\');\n    return nuGetHash(\'varval\');\n}\nfunction set_session_variable(varname,varval){\n    nuSetHash(\'varname\', varname);\n    nuSetHash(\'varval\', varval);\n    nuAjax(\'setSessionVariable\',\'foo\');\n}\n\nfunction pollute_class(param){\n    $(\'#class_id\').empty();\n    $(\'#class_id\').append(\'<option value=\"\"></option>\');\n    if(!param==\'\'){\n        var ln = param.split(\'\\n\'); \n        for(i=0;i<ln.length;i++){  \n            var fld=ln[i].split(\'\\t\');\n            $(\'#class_id\').append(\'<option value=\"\'+fld[0]+\'\">\'+fld[1]+\'</option>\'); \n        }\n    }\n}\n\nfunction pollute_subject(param){\n    $(\'#subject_id\').empty();\n    $(\'#subject_id\').append(\'<option value=\"\"></option>\');\n    if(!param==\'\'){\n        var ln = param.split(\'\\n\'); \n        for(i=0;i<ln.length;i++){  \n            var fld=ln[i].split(\'\\t\');\n            $(\'#subject_id\').append(\'<option value=\"\'+fld[0]+\'\">\'+fld[1]+\'</option>\'); \n        }\n    }\n}\n\nfunction nuLoadEdit() {\n    $(\'#label1\').css(\"fontSize\", \"10px\");\n    $(\'#label1\').css(\'font-style\', \'italic\');    \n}',NULL,0,0,'2015-11-29 16:03:33','globeadmin','2015-11-29 19:36:31','globeadmin','2015-11-29 19:36:31','globeadmin','',0,NULL),('566086607663544','student_teachers_comments','Ημέρες και ώρες που δέχονται για ενημερώση οι καθη','select * from student','student','id',750,430,'select \'Ημέρες και Ώρες Ενημέρωσης από τους Καθηγητές\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,0,0,'2015-12-03 20:13:52','globeadmin','2015-12-03 21:43:29','globeadmin','2018-06-12 12:54:55','globeadmin','',0,NULL),('568834bf97fe8a1','copy_timetable_new','Κλωνοποίηση Ωρολογίου','select * from timetable','timetable','id',630,300,'select \'Κλωνοποίηση Ωρολογίου\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function foo(param){\n    ;\n}\nfunction pass_session_variable(param){\n    nuSetHash(\'varval\', param);\n}\nfunction get_session_variable(varname){\n    nuSetHash(\'varname\', varname);\n    nuAjax(\'getSessionVariable\',\'pass_session_variable\');\n    return nuGetHash(\'varval\');\n}\nfunction set_session_variable(varname,varval){\n    nuSetHash(\'varname\', varname);\n    nuSetHash(\'varval\', varval);\n    nuAjax(\'setSessionVariable\',\'foo\');\n}\n\nfunction dsplayAjaxMessage(param){\n    if(param!=\'\'){\n        alert(param);\n    }\n    parent.nuReloadForm();    \n    nuRemoveModal();\n}\n\nfunction nuLoadEdit() {\n    nuFORM.edited = 0;\n    $(\'#label1\').css(\"fontSize\", \"11px\");\n    $(\'#label1\').css(\'font-style\', \'italic\');\n}',NULL,0,0,'2016-01-02 22:36:15','globeadmin','2016-01-02 22:53:02','globeadmin','2016-05-25 13:32:54','globeadmin','',0,NULL),('5688ee0218ad763','card_insert_new','Εισαγωγή Νεας  Διδασκαλίας','select * from card','card','id',650,250,'select \'Εισαγωγή Νέας Διδασκαλίας\'',NULL,'1',NULL,NULL,'1',NULL,NULL,NULL,NULL,NULL,'Νέα Διδασκαλία',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'$today = date(\'Y-m-d\');\nif(\'#valid_from#\'<=$today){\n    $MESSAGE = \'Προσοχή: H ημερομηνία έναρξης ισχύος της διδασκαλίας  πρέπει να είναι μεταγενέστερη της σημερινής!\';\n    nuDisplayError($MESSAGE);\n    return;\n}',NULL,'',NULL,NULL,NULL,'function nuLoadEdit() {\n    var x = document.getElementById(\'valid_from\');\n    var start_date = parent.document.getElementById(\'start_date\').value;\n    \n    x.value = start_date;\n    \n    $(\'#valid_from\').prop(\'disabled\', true);\n}',NULL,0,0,'2016-01-03 11:46:42','globeadmin','2016-01-03 12:12:55','globeadmin','2017-10-03 23:25:19','globeadmin','',0,NULL),('56c989024e5f43c','mark_type','Τύποι Βαθμών','select * from mark_type','mark_type','id',960,520,'select name from mark_type where id=\'#RECORD_ID#\'','1','1','0',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function nuLoadEdit() { \n    \n    if(document.getElementById(\'is_number\').checked){\n        $(\'[id*=start_value]\').show();\n        $(\'[id*=end_value]\').show();\n        $(\'[id*=num_of_decimals]\').show();\n        $(\'[id*=mark_type_value_subform]\').hide();\n    } else {\n        $(\'[id*=start_value]\').hide();\n        $(\'[id*=end_value]\').hide();\n        $(\'[id*=num_of_decimals]\').hide();\n        $(\'[id*=mark_type_value_subform]\').show();\n    }\n}',NULL,0,0,'0000-00-00 00:00:00','','2016-02-21 15:17:37','globeadmin','2017-08-20 15:48:22','globeadmin','',0,NULL),('56e98e66abfe2c1','comment_teacher','Σχόλια Καθηγητή','select * from comment','comment','id',960,960,'',NULL,'0',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'$sql = \"    SELECT student_comments\n            FROM comment\n            WHERE id=\'#RECORD_ID#\'\n        \";\n$retval = nuRunQuery($sql);\n\nif($row = db_fetch_row($retval)){\n    if($row[0]!=\'#student_comments#\'){\n        $sql=\"update session_variables set student_comments_edited=1 where session_id=\'#session_id#\'\";\n        $retval = nuRunQuery($sql);\n    }\n}',NULL,'',NULL,'nuRunPHP(\'notification_add_lib\');\n\n$sql = \"    UPDATE comment a \n            INNER JOIN session_variables b ON b.session_id=\'#session_id#\'  \n            SET a.post_teacher_id = b.teacher_id,\n                a.changed_at = now(),\n                a.student_comments_changed_at = if(b.student_comments_edited=1,now(),a.student_comments_changed_at)\n            WHERE id=\'#RECORD_ID#\'\";\nnuRunQuery($sql);\n\n$sql=\"select student_comments_edited from session_variables where session_id=\'#session_id#\'\";\n$retval = nuRunQuery($sql);\n$row=db_fetch_row($retval);\n\nif($row[0]==\'1\'){\n\n    $sql=\"update session_variables set student_comments_edited=0 where session_id=\'#session_id#\'\";\n    $retval = nuRunQuery($sql);\n    \n    update_comment_notification(\'#RECORD_ID#\'); \n}',NULL,'function open_next_student(param){\n    if(param==\'-1\' || param==\'\'){\n        alert(\'Αυτός είναι ο τελευταίος μαθητής του τμήματος!\');    \n    } else {\n        window.nuSession.breadCrumb.pop();\n        nuOpenForm(\'\',\'\', \'56e98e66abfe2c1\', param,\'Σχόλια Καθηγητή\');    \n    } \n}\n\nfunction open_prev_student(param){\n    if(param==\'-1\' || param==\'\'){\n        alert(\'Αυτός είναι ο πρώτος μαθητής του τμήματος!\');    \n    } else {\n        window.nuSession.breadCrumb.pop();\n        nuOpenForm(\'\',\'\', \'56e98e66abfe2c1\', param,\'Σχόλια Καθηγητή\');    \n    } \n}\n\nfunction passTinymceContents(){\n    var x = document.getElementById(\'teacher_comments\').value;\n    var y = document.getElementById(\'student_comments\').value;\n    \n    var iframe1 = document.getElementById(\'tinymce_editor\');\n    var iframe2 = document.getElementById(\'tinymce_editor2\');\n    \n    iframe1.contentWindow.setHTML(x);\n    iframe2.contentWindow.setHTML(y);\n    \n    return(\'doNotSetHTML\');\n}\n\n\nfunction nuLoadEdit() {\n    $(\'#label1\').css(\'fontSize\', \'14px\');\n    $(\'#label1\').css(\'font-weight\', \'bold\');\n    //$(\'#label1\').css(\'background-color\', \'LightYellow\');\n    $(\'#label1\').css(\'color\', \'#A52A2A\');\n    \n    $(\'#label2\').css(\'fontSize\', \'14px\');\n    $(\'#label2\').css(\'font-weight\', \'bold\');\n    //$(\'#label1\').css(\'background-color\', \'LightYellow\');\n    $(\'#label2\').css(\'color\', \'#A52A2A\');\n    \n    $(\'#student_disp\').css(\'fontSize\', \'14px\');\n    $(\'#student_disp\').css(\'font-weight\', \'bold\');\n    $(\'#student_disp\').css(\'background-color\', \'#FAF0E6\');\n    $(\'#student_disp\').css(\'color\', \'#A52A2A\');\n    \n    $(\'#class_lesson_disp\').css(\'fontSize\', \'14px\');\n    $(\'#class_lesson_disp\').css(\'font-weight\', \'bold\');\n    $(\'#class_lesson_disp\').css(\'background-color\', \'#FAF0E6\');\n    $(\'#class_lesson_disp\').css(\'color\', \'#A52A2A\');\n    \n    $(\'#last_update_disp\').css(\'fontSize\', \'14px\');\n    $(\'#last_update_disp\').css(\'font-weight\', \'bold\');\n    $(\'#last_update_disp\').css(\'background-color\', \'#FAF0E6\');\n    $(\'#last_update_disp\').css(\'color\', \'#A52A2A\');\n    \n    \n    $(\'#hide_to_student_label\').css(\'fontSize\', \'12px\');\n    $(\'#hide_to_student_label\').css(\'font-weight\', \'bold\');\n    //$(\'#hide_to_student_label\').css(\'background-color\', \'#FAF0E6\');\n    $(\'#hide_to_student_label\').css(\'color\', \'#EE0000\');\n}',NULL,0,0,'2016-03-16 18:48:38','globeadmin','2021-03-24 11:21:27','globeadmin','2021-03-24 11:21:27','globeadmin','',0,NULL),('56dd9f180d22b31','registered_card','Περιεχόμενο Διδασκαλίας','select * from registered_card','registered_card','id',960,520,'select \'Περιεχόμενο Διδασκαλίας\'',NULL,'0',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,'if(\'#update_connections#\'==\'1\'){\n$sql=\"  \nUPDATE registered_card AS other_rg\nINNER JOIN registered_card AS this_rg ON this_rg.id = \'#RECORD_ID#\'\nINNER JOIN card AS this_card ON this_card.id = this_rg.card_id\nINNER JOIN card AS other_card ON other_card.id = other_rg.card_id\nSET other_rg.comments = this_rg.comments\nWHERE\n    other_rg.id <> \'#RECORD_ID#\' AND\n    other_rg.card_date = this_rg.card_date AND\n    other_card.day_id = this_card.day_id AND\n    other_card.period_id = this_card.period_id AND\n    other_card.subject_id = this_card.subject_id AND\n    other_card.classroom_id <=> this_card.classroom_id AND\n    other_card.teacher_id = this_card.teacher_id AND\n    other_rg.no_lesson = 0 AND\n    other_rg.prime = 1\n\";\nnuRunQuery($sql);\n}',NULL,'function passTinymceContents(){\n    var y = document.getElementById(\'comments\').value;\n    return(y);\n}\n\nfunction nuLoadEdit() {\n    $(\'#card_date\').css(\'fontSize\', \'14px\');\n    $(\'#card_date\').css(\'font-weight\', \'bold\');\n    $(\'#card_date\').css(\'background-color\', \'LightYellow\');\n    $(\'#card_date\').css(\'color\', \'#A52A2A\');\n    \n    $(\'#period_disp\').css(\'fontSize\', \'14px\');\n    $(\'#period_disp\').css(\'font-weight\', \'bold\');\n    $(\'#period_disp\').css(\'background-color\', \'LightYellow\');\n    $(\'#period_disp\').css(\'color\', \'#A52A2A\');\n    \n    $(\'#class_lesson_disp\').css(\'fontSize\', \'14px\');\n    $(\'#class_lesson_disp\').css(\'font-weight\', \'bold\');\n    $(\'#class_lesson_disp\').css(\'background-color\', \'LightYellow\');\n    $(\'#class_lesson_disp\').css(\'color\', \'#A52A2A\');\n}',NULL,0,0,'2016-03-07 17:32:40','globeadmin','2021-04-04 20:14:01','globeadmin','2022-12-21 12:48:45','globeadmin','',0,NULL),('56e052ae98309fe','teachingbook','Ημερολόγιο Διδασκαλίων','select * from teacher','teacher','id',1000,650,'select \'Ημερολόγιο Διδασκαλίων\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function set_comments(cell_id,comments){\n    var iframe = document.getElementById(\'registered_cards_iframe\');\n    var innerDoc = (iframe.contentDocument) ? iframe.contentDocument : iframe.contentWindow.document;\n\n    var x = innerDoc.getElementById(\'td\'+cell_id);\n    var y = innerDoc.getElementById(\'img_\'+cell_id);\n\n    if(x){\n        x.innerHTML = comments;\n    }\n    \n    if(y){\n        if(comments.trim() !=\'\'){\n            y.src = \'images/edit_red.png\';\n        } else {\n            y.src = \'images/edit.png\';\n        }\n    }\n}\n\nfunction nuLoadEdit() {\n    var class_id    = get_session_variable(\'class_id\');\n    var subject_id  = get_session_variable(\'subject_id\');\n    if(class_id!=-1 && subject_id!=-1){\n        var selection_id = class_id+\',\'+subject_id;\n\n        var c=document.getElementById(\'class_subject_selection\');\n        c.value =   selection_id;  \n\n        $(\'#period_absence_class\').trigger( \"onchange\" );    \n    }\n}\n',NULL,0,0,'2016-03-09 18:43:26','globeadmin','2017-10-07 13:18:46','globeadmin','2022-12-21 12:47:00','globeadmin','',0,NULL),('56e553b8d3afa56','show_teaching_books','Εμφάνιση Ημερολογίου Διδασκαλιών','select * from teacher','teacher','id',960,520,'select \'Εμφάνιση Ημερολογίου Διδασκαλιών\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function foo(param){\n    ;\n}\nfunction pass_session_variable(param){\n    nuSetHash(\'varval\', param);\n}\nfunction get_session_variable(varname){\n    nuSetHash(\'varname\', varname);\n    nuAjax(\'getSessionVariable\',\'pass_session_variable\');\n    return nuGetHash(\'varval\');\n}\nfunction set_session_variable(varname,varval){\n    nuSetHash(\'varname\', varname);\n    nuSetHash(\'varval\', varval);\n    nuAjax(\'setSessionVariable\',\'foo\');\n}\n\nfunction pollute_subject(param){\n    $(\'#subject_id\').empty();\n    $(\'#subject_id\').append(\'<option value=\"\"></option>\');\n    if(!param==\'\'){\n        var ln = param.split(\'\\n\'); \n        for(i=0;i<ln.length;i++){  \n            var fld=ln[i].split(\'\\t\');\n            $(\'#subject_id\').append(\'<option value=\"\'+fld[0]+\'\">\'+fld[1]+\'</option>\'); \n        }\n    }\n}\n\nfunction pollute_subject_json(param){\n    \n    $(\'#subject_id\').empty();\n    $(\'#subject_id\').append(\'<option value=\"\"></option>\');\n    \n    if(param!=\'\'){\n        var json_data = JSON.parse(param);\n        \n        for(var i=0; i < json_data.length;i++){  \n            $(\'#subject_id\').append(\'<option value=\"\'+json_data[i][0]+\'\">\'+json_data[i][1]+\'</option>\'); \n        }\n        \n    }\n}\n\nfunction set_comments(cell_id,comments){\n    var iframe = document.getElementById(\'teaching_showiframe\');\n    var innerDoc = (iframe.contentDocument) ? iframe.contentDocument : iframe.contentWindow.document;\n    \n    var x = innerDoc.getElementById(\'td\'+cell_id);\n    var y = innerDoc.getElementById(\'img_\'+cell_id);\n\n    if(x){\n        x.innerHTML = comments;\n    }\n    \n    if(y){\n        if(comments.trim() !=\'\'){\n            y.src = \'images/edit_red.png\';\n        } else {\n            y.src = \'images/edit.png\';\n        }\n    }\n}\n\nfunction nuLoadEdit() {\n    \n}',NULL,0,0,'2016-03-13 13:49:12','globeadmin','2016-10-09 10:31:48','globeadmin','2016-10-09 10:31:48','globeadmin','',0,NULL),('56ea588f03c272b','comment_student','Παρατηρήσεις για το Μαθητή - Γονέα','select * from comment','comment','id',960,520,'select \'Παρατηρήσεις Διδασκαλίας\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'','if(\'#nu_user_group#\'==\'Students\'){\n    $sql = \"    UPDATE comment \n            SET student_viewed_at = now()\n            WHERE ID=\'#RECORD_ID#\'\";\n    nuRunQuery($sql);        \n} elseif (\'#nu_user_group#\'==\'Parents\'){\n    $sql = \"    UPDATE comment \n            SET parent_viewed_at = now()\n            WHERE ID=\'#RECORD_ID#\'\";    \n    nuRunQuery($sql);\n}\n',NULL,NULL,'function foo(param){\n    ;\n}\nfunction pass_session_variable(param){\n    nuSetHash(\'varval\', param);\n}\nfunction get_session_variable(varname){\n    nuSetHash(\'varname\', varname);\n    nuAjax(\'getSessionVariable\',\'pass_session_variable\');\n    return nuGetHash(\'varval\');\n}\nfunction set_session_variable(varname,varval){\n    nuSetHash(\'varname\', varname);\n    nuSetHash(\'varval\', varval);\n    nuAjax(\'setSessionVariable\',\'foo\');\n}\n\n\nfunction nuLoadEdit() {\n    $(\'#student_disp\').css(\'fontSize\', \'14px\');\n    $(\'#student_disp\').css(\'font-weight\', \'bold\');\n    $(\'#student_disp\').css(\'background-color\', \'#FAF0E6\');\n    $(\'#student_disp\').css(\'color\', \'#A52A2A\');\n    \n    $(\'#class_lesson_disp\').css(\'fontSize\', \'14px\');\n    $(\'#class_lesson_disp\').css(\'font-weight\', \'bold\');\n    $(\'#class_lesson_disp\').css(\'background-color\', \'#FAF0E6\');\n    $(\'#class_lesson_disp\').css(\'color\', \'#A52A2A\');\n    \n\n    $(\'#teacher_disp\').css(\'fontSize\', \'14px\');\n    $(\'#teacher_disp\').css(\'font-weight\', \'bold\');\n    $(\'#teacher_disp\').css(\'background-color\', \'#FAF0E6\');\n    $(\'#teacher_disp\').css(\'color\', \'#A52A2A\');\n    \n    \n    nuSetHash(\'table_name\',\'comment\');\n    nuSetHash(\'table_field\',\'student_comments\');\n    nuSetHash(\'id_name\',\'id\'); \n    nuSetHash(\'id_value\',\'#RECORD_ID#\');\n    \n    nuRunPHP(\'show_html_field\',\'comments_iframe\');\n}',NULL,0,0,'2016-03-17 09:11:11','globeadmin','2021-03-24 11:22:00','globeadmin','2021-03-24 11:22:00','globeadmin','',0,NULL),('56eae5254137ba7','class_subject_comments','Παρατηρήσεις Καθηγητή για ένα Τμήμα - Μάθημα','select * from teacher','teacher','id',1000,650,'select \'Σχόλια για τους Μαθητές\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'','nuRunPHP(\'check_permission_lib\');\n\nif(!check_permission(\'1\')){\n    $MESSAGE = \'Προσοχή! Δεν έχετε άδεια πρόσβασης στα δεδομένα αυτά!\';\n    nuDisplayError($MESSAGE);\n    return;\n}',NULL,NULL,'function nuLoadEdit() {\n\n    var class_id    = get_session_variable(\'class_id\');\n    var subject_id  = get_session_variable(\'subject_id\');\n\n    if(class_id!=-1 && subject_id!=-1){\n        var selection_id = class_id+\',\'+subject_id;\n\n        var c=document.getElementById(\'class_subject_selection\');\n        c.value =   selection_id;  \n\n        $(\'#period_absence_class\').trigger( \"onchange\" );    \n    }\n    \n    \n}\n\n\n',NULL,0,0,'2016-03-17 19:11:01','globeadmin','2017-11-12 16:25:57','globeadmin','2019-03-09 10:39:14','globeadmin','',0,NULL),('59d7d65650da67c','teacher_personal','Καθηγητής - Προσωπικά Στοιχεία','select * from teacher','teacher','id',1000,520,'select concat(IFNULL(surname,\'\'),\' \',IFNULL(name,\'\')) from teacher where id=#RECORD_ID#','0','1','0',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'','nuRunPHP(\'check_permission_lib\');\n\nif(!check_permission(\'1\')){\n    $MESSAGE = \'Προσοχή! Δεν έχετε άδεια πρόσβασης στα δεδομένα αυτά!\';\n    nuDisplayError($MESSAGE);\n    return;\n}\n',NULL,NULL,'function nuLoadEdit() {\n    \n    loadImg(\'log_user\');\n    \n    /*$(\'#sms_disp\').css(\'fontSize\', \'18px\');\n    $(\'#sms_disp\').css(\'font-weight\', \'bold\');\n    $(\'#sms_disp\').css(\'background-color\', \'LightYellow\');\n    $(\'#sms_disp\').css(\'color\', \'red\');*/\n\n    //$(\'#nuButton0\').focus();\n}',NULL,0,0,'2017-10-06 22:15:34','globeadmin','2017-11-12 15:40:15','globeadmin','2018-07-28 00:38:23','globeadmin','',0,NULL),('nuphp','aph','PHP Code','SELECT * FROM  zzzsys_php ORDER BY slp_code','zzzsys_php','zzzsys_php_id',1000,0,'','1','1','1','1','','','','','','','','','SELECT IF(\'#slp_group#\' = \'nubuilder\',\'0\',\'1\');','SELECT IF(\'#slp_group#\' = \'nubuilder\',\'0\',\'1\');','SELECT IF(\'#slp_group#\' = \'nubuilder\',\'0\',\'1\');','SELECT IF(\'#slp_group#\' = \'nubuilder\',\'0\',\'1\');','','','','','','','','','  \r\n    $(document).ready(function() {\r\n\r\n\r\n        $(\"#slp_php\").css(\'background-color\', \'#FFE8CA\');\r\n        $(\"#slp_php\").css(\'font-family\', \'Courier New\');\r\n        $(\"#slp_php\").css(\'font-size\', \'14px\');\r\n        $(\"#slp_php\").attr( \'wrap\', \'off\');\r\n\r\n    });\r\n\r\n','',0,0,'0000-00-00 00:00:00','','2013-10-16 15:15:33','globeadmin','2013-11-08 11:19:17','globeadmin','browse',0,NULL),('nutranslate','tra','Translation','SELECT * FROM zzzsys_translate \r\nORDER BY trl_language, trl_english','zzzsys_translate','zzzsys_translate_id',900,0,'','1','1','1','1','0','1','','','','','','','','','','','','','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00','','browse',0,NULL),('nuformwizard','FW','Form Wizard','select * from zzzsys_debug','zzzsys_debug','zzzsys_debug_id',1300,600,'SELECT \'CREATE FORM\'','','1','','','','','','Create Form','','','','','','','','','','','function getProperties($attr) {\r\n    $type               = \'text\';\r\n    $height             = \'\';\r\n    $width              = $attr[3];\r\n    $title              = $attr[4];\r\n    $lookup             = $attr[5];\r\n    $lookup_code        = $attr[6];\r\n    $lookup_description = $attr[7];\r\n    $align              = \'l\';\r\n    $format             = \'\';\r\n    \r\n    switch ($attr[1]) {\r\n        case \'date\':\r\n            $format = \'6\';\r\n            break;\r\n        case \'int\':\r\n            $align  = \'r\';\r\n            $format = \'0\';\r\n            break;\r\n        case \'double\':\r\n            $align = \'r\';\r\n            if($attr[2] <= 5) {\r\n                $format = $attr[2];\r\n            }\r\n            else {\r\n                $format = \'5\';\r\n            }\r\n            break;\r\n        case \'decimal\':\r\n            $align = \'r\';\r\n            if($attr[2] <= 5) {\r\n                $format = $attr[2];\r\n            }\r\n            else {\r\n                $format = \'5\';\r\n            }\r\n            break;\r\n        case \'text\':\r\n            $type   = \'textarea\';\r\n            $height = \'150\';\r\n            $width  = \'250\';\r\n            break;\r\n    } \r\n    if( $lookup !== \'\' ) {\r\n        $type = \'lookup\';\r\n    }\r\n      \r\n    $values = array(\r\n        \"align\"              => $align,\r\n        \"format\"             => $format,\r\n        \"width\"              => $width,\r\n        \"title\"              => $title,\r\n        \"height\"             => $height,\r\n        \"type\"               => $type,\r\n        \"lookup\"             => $lookup,\r\n        \"lookup_code\"        => $lookup_code,\r\n        \"lookup_description\" => $lookup_description\r\n    );\r\n    return $values;\r\n}\r\n\r\n\r\n$form    = nuID();\r\n$sql     = \"SELECT * FROM #fw_table_name#\";\r\n$table   = \'#fw_table_name#\';\r\n$primary = \'#fw_hidden_primary#\';\r\n$columns = array();\r\n$browse  = \'#fw_browse_listbox#\';\r\n$fields  = \'#fw_form_listbox#\';\r\n\r\nif( $table === \'\') {\r\n    nuDisplayError(\'A table needs to be chosen.\');\r\n    return;\r\n}\r\n\r\nif( $primary === \'\') {\r\n    nuDisplayError(\"Form Wizard can\'t detect Primary Key on selected table.\");\r\n    return;\r\n}\r\n\r\nif( $browse === \'\' && $fields === \'\' ) {\r\n    nuDisplayError(\'No fields chosen to display\');\r\n    return;\r\n}\r\n\r\n$s = \"\r\n    INSERT INTO zzzsys_form (zzzsys_form_id, sfo_name, sfo_sql, sfo_table, sfo_primary_key, sfo_title,sfo_add_button, sfo_save_button, sfo_delete_button)\r\n    VALUES (\'$form\',\'$table\',\'$sql\',\'$table\',\'$primary\', \'$table\', \'1\', \'1\', \'1\');\r\n\";\r\n\r\nnuRunQuery($s);\r\n    \r\nif($browse !== \'\' ) {\r\n    $browse = explode(\'#nuSep#\',$browse );\r\n    foreach( $browse as $value ) {\r\n        $columns[] = explode(\'#nuSepr#\',$value);\r\n    }\r\n\r\n    $order = 10;\r\n    $s = \"INSERT INTO zzzsys_browse (zzzsys_browse_id, sbr_zzzsys_form_id, sbr_title, sbr_display, sbr_align, sbr_format,sbr_searchable, sbr_sort, sbr_visible, sbr_order, sbr_width) VALUES \";\r\n\r\n    for($idx = 0; $idx < count($columns); $idx++) {\r\n        $id     = nuID();\r\n        $column = $columns[$idx];\r\n        $prop   = getProperties($column);\r\n     \r\n        $s .= \"(\'$id\', \'$form\', \'\".$prop[\'title\'].\"\', \'\".$column[0].\"\', \'\".$prop[\'align\'].\"\', \'\".$prop[\'format\'].\"\', 1, \'\".$column[0].\"\', \'\', \'$order\', \'\".$prop[\'width\'].\"\'), \";\r\n        \r\n        $order +=10;   \r\n    }\r\n    $s = rtrim($s, \', \');\r\n    nuRunQuery($s);\r\n}\r\n\r\nif( $fields !== \'\' ) {\r\n    $fieldarr  = explode(\'#nuSep#\', $fields);\r\n    $allfields = array();\r\n\r\n    foreach($fieldarr as $value) {\r\n        $allfields[] = explode(\'#nuSepr#\', $value);\r\n    }\r\n\r\n    $sql = \"\r\n        INSERT INTO zzzsys_object (zzzsys_object_id, sob_zzzsys_form_id, sob_all_column_number, sob_all_name, sob_all_order_number, sob_all_tab_number, sob_all_tab_title, sob_all_title, sob_all_type, sob_all_width, sob_all_height, sob_all_align, sob_text_format, sob_all_no_blanks, sob_all_read_only, sob_all_no_duplicates, sob_all_clone, sob_lookup_code_field, sob_lookup_description_field, sob_lookup_zzzsys_form_id, sob_lookup_id_field, sob_lookup_code_width, sob_lookup_description_width) VALUES\r\n    \";\r\n\r\n    $o = 10;\r\n    $c = 10;\r\n\r\n    for( $idx = 0; $idx < count($allfields); $idx++ ) {\r\n        $prim  = nuID();\r\n        $field = $allfields[$idx];\r\n        $prop  = getProperties($field);\r\n        $form_id = \'\';\r\n        \r\n        if( $prop[\"lookup\"] !== \'\' ) {\r\n            $s = \"SELECT sfo_primary_key FROM zzzsys_form WHERE zzzsys_form_id = ?\";\r\n            \r\n            $qry = nuRunQuery($s, array($prop[\"lookup\"]));\r\n            $res = db_fetch_object($qry);\r\n            $form_id = $res->sfo_primary_key;\r\n        }\r\n        \r\n        $sql .= \"( \'$prim\', \'$form\', \'$c\', \'\".$field[0].\"\', \'$o\', \'10\', \'Details\', \'\".$prop[\'title\'].\"\', \'\".$prop[\'type\'].\"\', \'\".$prop[\'width\'].\"\',\'\".$prop[\'height\'].\"\',  \'\".$prop[\'align\'].\"\', \'\".$prop[\'format\'].\"\', \'0\',\'0\',\'0\',\'1\', \'\".$prop[\"lookup_code\"].\"\', \'\".$prop[\"lookup_description\"].\"\', \'\".$prop[\"lookup\"].\"\', \'\".$form_id.\"\', \'100\', \'250\'), \";\r\n        \r\n        $o = $o + 10;\r\n        if( $o >= 150 ) {\r\n            $o = 10;\r\n            $c = $c + 10;\r\n        }\r\n    }\r\n    $sql = rtrim($sql, \', \');\r\n    nuRunQuery($sql);\r\n}\r\n$primary = nuID();\r\n$field   = $table.\'btn\';\r\n$record  = ($browse == \'\') ? \'-1\' : \'\';\r\n\r\n$sql     = \"\r\n    INSERT INTO zzzsys_object (zzzsys_object_id, sob_zzzsys_form_id, sob_button_zzzsys_form_id,sob_button_browse_filter,sob_button_skip_browse_record_id, sob_all_column_number, sob_all_name, sob_all_order_number, sob_all_tab_number, sob_all_tab_title, sob_all_title, sob_all_type, sob_all_width, sob_all_height, sob_all_align, sob_text_format, sob_all_no_blanks, sob_all_read_only, sob_all_no_duplicates, sob_all_clone) \r\n    VALUES (\'$primary\', \'nuhome\', \'$form\',\'\',\'$record\', \'10\', \'$field\', \'10\', \'1051\', \'Wizard\', \'$table\', \'button\', \'120\', \'30\', \'l\', \'\', \'0\', \'0\', \'0\', \'0\')\r\n\";\r\n\r\nnuRunQuery($sql);\r\n\r\nnuRunQuery(\"UPDATE zzzsys_object SET sob_all_top = \'0\' WHERE sob_all_top IS NULL;\");\r\nnuRunQuery(\"UPDATE zzzsys_object SET sob_all_left = \'0\' WHERE sob_all_left IS NULL;\");\r\nnuRunQuery(\"UPDATE zzzsys_object SET sob_all_clone = \'0\' WHERE sob_all_clone IS NULL;\");\r\nnuRunQuery(\"UPDATE zzzsys_object SET sob_all_align = \'0\' WHERE sob_all_align IS NULL;\");\r\nnuRunQuery(\"UPDATE zzzsys_object SET sob_all_no_blanks = \'0\' WHERE sob_all_no_blanks IS NULL;\");\r\nnuRunQuery(\"UPDATE zzzsys_object SET sob_all_read_only = \'0\' WHERE sob_all_read_only IS NULL;\");\r\nnuRunQuery(\"UPDATE zzzsys_object SET sob_all_align = \'l\' WHERE sob_all_align IS NULL;\");\r\nnuRunQuery(\"UPDATE zzzsys_object SET sob_all_no_duplicates = \'0\' WHERE sob_all_no_duplicates IS NULL;\");\r\n\r\nnuRunQuery(\"UPDATE zzzsys_object SET sob_all_top = \'0\' WHERE sob_all_top = \'\';\");\r\nnuRunQuery(\"UPDATE zzzsys_object SET sob_all_left = \'0\' WHERE sob_all_left = \'\';\");\r\nnuRunQuery(\"UPDATE zzzsys_object SET sob_all_clone = \'0\' WHERE sob_all_clone = \'\';\");\r\nnuRunQuery(\"UPDATE zzzsys_object SET sob_all_align = \'0\' WHERE sob_all_align = \'\';\");\r\nnuRunQuery(\"UPDATE zzzsys_object SET sob_all_no_blanks = \'0\' WHERE sob_all_no_blanks = \'\';\");\r\nnuRunQuery(\"UPDATE zzzsys_object SET sob_all_read_only = \'0\' WHERE sob_all_read_only = \'\';\");\r\nnuRunQuery(\"UPDATE zzzsys_object SET sob_all_align = \'l\' WHERE sob_all_align = \'\';\");\r\nnuRunQuery(\"UPDATE zzzsys_object SET sob_all_no_duplicates = \'0\' WHERE sob_all_no_duplicates = \'\';\");\r\n\r\n','','','$sql = \"\nSELECT TABLE_NAME, COLUMN_NAME, COLUMN_KEY, DATA_TYPE, NUMERIC_SCALE, NUMERIC_PRECISION, CHARACTER_MAXIMUM_LENGTH\nFROM INFORMATION_SCHEMA.COLUMNS\nWHERE TABLE_SCHEMA = database()\n\";\n\n$js = \"function fetch_columns() {window.columns = [\";\n\n$q = nuRunQuery($sql);\n\n$r = db_fetch_array($q);\n\n$js .= \"[\\\"\" . $r[0] . \"\\\" , \\\"\" . $r[1] . \"\\\" , \\\"\" . $r[2] . \"\\\" , \\\"\" . $r[3] . \"\\\" , \\\"\" . $r[4] . \"\\\" , \\\"\" . $r[5]. \"\\\" , \\\"\" . $r[6] . \"\\\"]\";\nwhile($r = db_fetch_array($q)) {\n    $js .= \",[\\\"\" . $r[0] . \"\\\" , \\\"\" . $r[1] . \"\\\" , \\\"\" . $r[2] . \"\\\" , \\\"\" . $r[3] . \"\\\" , \\\"\" . $r[4] . \"\\\" , \\\"\" . $r[5]. \"\\\" , \\\"\" . $r[6]. \"\\\"]\";\n}\n$js .= \"];}\";\n\nnuAddJavascript($js);','','','function selectAll(listbox) {\r\n    var select = $(\'#\'+listbox);\r\n    $(\'option\', select).prop(\'selected\', 1);\r\n}\r\n\r\n$(\"#fw_table_listbox\").empty();\r\n$(\"#fw_form_listbox\").empty();\r\n$(\"#fw_browse_listbox\").empty();\r\n\r\nfunction nuOnSave() {\r\n    $(\'#fw_browse_listbox option\').each(function() {\r\n        var bw_width = $(this).attr(\'nu_bw_width\');\r\n        var bw_title = $(this).attr(\'nu_bw_title\');\r\n\r\n        var value = $(this).attr(\'value\');\r\n        $(this).attr(\'value\', value+\'#nuSepr#\'+bw_width+\'#nuSepr#\'+bw_title);\r\n\r\n    });\r\n    \r\n    $(\'#fw_form_listbox option\').each(function() {\r\n        var ed_width           = $(this).attr(\'nu_ed_width\');\r\n        var ed_title           = $(this).attr(\'nu_ed_title\');\r\n        var value              = $(this).attr(\'value\');\r\n        var lookup             = $(this).attr(\'nu_lookup\');\r\n        var lookup_code        = $(this).attr(\'nu_lookup_code\');\r\n        var lookup_description = $(this).attr(\'nu_lookup_description\');\r\n        $(this).attr(\'value\', value+\'#nuSepr#\'+ed_width+\'#nuSepr#\'+ed_title+\'#nuSepr#\'+lookup+\'#nuSepr#\'+lookup_code+\'#nuSepr#\'+lookup_description);\r\n    });\r\n\r\n    $(\'#fw_browse_listbox option\').prop(\'selected\', 1);\r\n    $(\'#fw_form_listbox option\').prop(\'selected\',1);\r\n    return true;\r\n}\r\n\r\nfunction nuLoadEdit() {\r\n    $(\'#nuBreadCrumb_1\').remove();\r\n    $(\'#nuArrow_0\').remove();\r\n    $(\"input[id$=\'_up\']\").val($(\'<div>\').html(\'&uarr;\').text());\r\n    $(\"input[id$=\'wn\']\").val($(\'<div>\').html(\'&darr;\').text());\r\n}\r\n','',0,0,'2014-01-24 12:11:05','globeadmin','2014-02-11 10:40:49','globeadmin','2014-03-13 14:12:09','globeadmin','browse',0,NULL),('nuform','for','nuBuilder Form','SELECT  zzzsys_form_id,\nIFNULL(sfo_name,\'\'),\nIFNULL(sfo_title,\'\'),\nIFNULL(sfo_table,\'\')  \nFROM zzzsys_form   \nWHERE (zzzsys_form_id NOT LIKE \'nu%\' AND zzzsys_form_id <> \'5269ae8512ebfd3\')     \nORDER BY sfo_name  ','zzzsys_form','zzzsys_form_id',1000,0,'','1','1','1','1','','','','','','','','','','SELECT 1','','','','','','','','','$s = \"SELECT * FROM zzzsys_browse WHERE sbr_zzzsys_form_id = \'#RECORD_ID#\' ORDER BY sbr_order\";\n$t = nuRunQuery($s);\n$o = 0;\n\nwhile($r = db_fetch_object($t)){\n\n   $o = $o + 10;\n   $u = \"UPDATE zzzsys_browse SET sbr_order = \'$o\' WHERE zzzsys_browse_id = \'$r->zzzsys_browse_id\'\";\n   \n   nuRunQuery($u);\n\n}\n','','\n    $(document).ready(function() {\n    \n    if(nuFORM.tip == \'Edit\'){\n\n\n        $(\"textarea[id*=\'display_condition\']\").css(\'background-color\', \'#D2F4D5\');\n        $(\"textarea[id*=\'display_condition\']\").css(\'font-family\', \'Courier New\');\n        $(\"textarea[id*=\'display_condition\']\").css(\'font-size\', \'14px\');\n        $(\"textarea[id*=\'display_condition\']\").attr( \'wrap\', \'off\');\n\n        $(\"#sfo_breadcrumb\").css(\'background-color\', \'#D2F4D5\');\n        $(\"#sfo_breadcrumb\").css(\'font-family\', \'Courier New\');\n        $(\"#sfo_breadcrumb\").css(\'font-size\', \'14px\');\n        $(\"#sfo_breadcrumb\").attr( \'wrap\', \'off\');\n\n        $(\"textarea[id*=\'sql\']\").css(\'background-color\', \'#D2F4D5\');\n        $(\"textarea[id*=\'sql\']\").css(\'font-family\', \'Courier New\');\n        $(\"textarea[id*=\'sql\']\").css(\'font-size\', \'14px\');\n        $(\"textarea[id*=\'sql\']\").attr( \'wrap\', \'off\');\n\n        $(\"textarea[id*=\'sfo_custom_code_run\']\").css(\'background-color\', \'#FFE8CA\');\n        $(\"textarea[id*=\'sfo_custom_code_run\']\").css(\'font-family\', \'Courier New\');\n        $(\"textarea[id*=\'sfo_custom_code_run\']\").css(\'font-size\', \'14px\');\n        $(\"textarea[id*=\'sfo_custom_code_run\']\").attr( \'wrap\', \'off\');\n\n        $(\"textarea[id*=\'javascript\']\").css(\'background-color\', \'#CAE1FF\');\n        $(\"textarea[id*=\'javascript\']\").css(\'font-family\', \'Courier New\');\n        $(\"textarea[id*=\'javascript\']\").css(\'font-size\', \'14px\');\n        $(\"textarea[id*=\'javascript\']\").attr( \'wrap\', \'off\');\n\n        $(\"textarea[id*=\'sob_html_code\']\").css(\'background-color\', \'#EEE4EC\');\n        $(\"textarea[id*=\'sob_html_code\']\").css(\'font-family\', \'Courier New\');\n        $(\"textarea[id*=\'sob_html_code\']\").css(\'font-size\', \'14px\');\n        $(\"textarea[id*=\'sob_html_code\']\").attr( \'wrap\', \'off\');\n        $(\"[id^=\'nu_holder_sfo_custom_code_run_\']\").css(\'visibility\', \'hidden\');\n    }\n\n    });\n\n    function nuShowCode(pThis){\n\n        $(\"[id^=\'sfo_custom_code_run_\']\").css(\'width\',      \'0px\');\n        $(\"[id^=\'sfo_custom_code_run_\']\").css(\'height\',     \'0px\');\n        $(\"[id^=\'sfo_custom_code_run_\']\").css(\'visibility\', \'hidden\');\n        $(\"[id^=\'sfo_custom_code_run_\']\").css(\'visibility\', \'hidden\');\n        $(\"[id^=\'nu_holder_sfo_custom_code_run_\']\").css(\'visibility\', \'hidden\');\n        $(\".nuCodeTabsSelected\").removeClass(\'nuCodeTabsSelected\');\n\n        $(\"#sfo_custom_code_run_\"+pThis.id.substr(7)).css(\'width\',      \'900px\');\n        $(\"#sfo_custom_code_run_\"+pThis.id.substr(7)).css(\'height\',     \'400px\');\n        $(\"#sfo_custom_code_run_\"+pThis.id.substr(7)).css(\'visibility\', \'visible\');\n        $(\"#nu_holder_sfo_custom_code_run_\"+pThis.id.substr(7)).css(\'visibility\', \'visible\');\n        $(\"#\"+pThis.id).addClass(\'nuCodeTabsSelected\');\n    }   \n\n    function nuPopulateSort(t){\n\n        var p = \'#\' + $(\'#\'+t.id).attr(\'data-prefix\') + \'sbr_sort\';\n        if($(p).val() == \'\'){\n        $(p).val(t.value)\n        \n    }\n\n    }','',0,0,'0000-00-00 00:00:00','','2015-04-14 11:42:50','globeadmin','2015-04-14 11:42:50','globeadmin','browse',0,NULL),('nuformsandsubforms','fsf','Forms And Subforms','SELECT * FROM #TABLE_ID#\nORDER BY thecode','#TABLE_ID#','theid',900,0,'','0','0','0','0','0','0','','','','','','','','','','','','','','\r\n$s = \"\r\nCREATE TABLE #TABLE_ID# \r\nSELECT \r\nzzzsys_form_id AS theid, \r\nsfo_name      AS thecode, \r\nsfo_title     AS thedesc \r\nFROM zzzsys_form \r\nWHERE (zzzsys_form_id NOT LIKE \'#nu_denied#\' OR zzzsys_form_id = \'nuhome\')\r\n\r\n\r\n\";\r\n\r\nnuRunQuery($s);\r\n\r\n\r\n$s = \"\r\nINSERT INTO #TABLE_ID#  \r\nSELECT \r\nzzzsys_object_id                    AS theid, \r\nsob_all_name                       AS thecode,\r\nCONCAT(\'Subform of : \', sfo_title) AS thedesc\r\nFROM zzzsys_object\r\nINNER JOIN zzzsys_form ON sob_zzzsys_form_id = zzzsys_form_id\r\nWHERE sob_all_type = \'subform\'\r\nAND sob_zzzsys_form_id NOT LIKE \'#nu_denied#\'\r\n\";\r\n\r\nnuRunQuery($s);\r\n','','','','','','',0,0,'0000-00-00 00:00:00','','2013-10-10 14:10:11','globeadmin','2015-04-14 11:31:29','globeadmin','browse',0,NULL),('5269ae8512ebfd3','allrep','All Reports','SELECT * FROM zzzsys_report','zzzsys_report','zzzsys_report_id',900,0,'','1','1','1','1','','','','','','','','','','','','','','','','','','','','','','',0,0,'2013-10-25 10:04:29','globeadmin','2013-10-25 10:04:29','globeadmin','2014-10-21 09:36:20','globeadmin','browse',0,NULL),('nugroup','ugr','User Groups','SELECT * FROM zzzsys_user_group \nLEFT JOIN  zzzsys_access_level ON sug_zzzsys_access_level_id = zzzsys_access_level_id','zzzsys_user_group','zzzsys_user_group_id',900,0,'SELECT \'#sug_code#\'','1','1','1','1','',NULL,'','','','','',NULL,'','SELECT 1','','','',NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,0,0,'0000-00-00 00:00:00','','2013-10-22 14:59:12','globeadmin','2013-10-22 14:59:12','globeadmin','browse',0,NULL),('nurunphp','rph','Run Procedure','SELECT * FROM zzzsys_php\r\nINNER JOIN zzzsys_form ON slp_zzzsys_form_id = zzzsys_form_id\r\nLEFT JOIN zzzsys_access_level_php ON slp_zzzsys_php_id = zzzsys_php_id\r\nLEFT JOIN zzzsys_access_level ON slp_zzzsys_access_level_id = zzzsys_access_level_id\r\nWHERE \r\n(\r\n   sal_code = \'#nu_access_level#\' \r\n   AND slp_list != \'0\'\r\n) \r\nOR \'#nu_access_level#\' = \'globeadmin\'\r\nGROUP BY zzzsys_php_id\r\nORDER BY slp_code','zzzsys_php','zzzsys_php_id',900,0,'','0','0','1','1','','','','','','','','','','','','','','','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00','','browse',0,NULL),('nusetup','set','Setup','SELECT * FROM zzzsys_setup','zzzsys_setup','zzzsys_setup_id',1000,0,'','0','1','0','0','','','','','','','','','','','','','','','','','','','','','  \r\n    $(document).ready(function(){\r\n\r\n\r\n        $(\"#set_css\").css(\'background-color\', \'#EDD0FC\');\r\n        $(\"#set_css\").css(\'font-family\', \'Courier New\');\r\n        $(\"#set_css\").css(\'font-size\', \'14px\');\r\n        $(\"#set_css\").attr( \'wrap\', \'off\');\r\n\r\n    });\r\n\r\n','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2013-11-18 16:30:46','globeadmin','browse',0,NULL),('nuupdatenubuilder','updateNubuilder','Update nuBuilder','select * from zzzsys_setup','zzzsys_setup','zzzsys_setup_id',900,500,'SELECT \'\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function loadUpdater() {\n    switchButtonToProgress();\n    var xmlhttp;\n    xmlhttp = new XMLHttpRequest();\n    xmlhttp.onreadystatechange=function() {\n        if (xmlhttp.readyState==4 && xmlhttp.status==200)  {\n                displayUpdaterResponse(xmlhttp.responseText);                  \n        } else if (xmlhttp.readyState==4 && xmlhttp.status!=200)  {\n                displayUpdaterServerError();                  \n        }\n    }\n    xmlhttp.open(\"GET\",\"nuphpgit.php?sessid=#session_id#\",true);\n    xmlhttp.send();\n}\nfunction switchButtonToProgress() {\n    var contents = \'<img src=\"ajax-loader.gif\">\';\n    document.getElementById(\"Runbtn\").style.display = \'none\';\n    document.getElementById(\"updateNubuilderProgress\").innerHTML=contents;\n    document.getElementById(\"updateNubuilderMessageDetails\").innerHTML=\'Please wait...\';\n}\nfunction switchProgressToButton() {\n    var contents = \'\';\n    document.getElementById(\"updateNubuilderProgress\").innerHTML=contents;\n    document.getElementById(\"updateNubuilderMessageDetails\").innerHTML=contents;\n    document.getElementById(\"Runbtn\").style.display = \'block\';\n}\n\nfunction displayUpdaterServerError() {\n    switchProgressToButton();\n    document.getElementById(\"updateNubuilderMessageDetails\").innerHTML=\'Update failed, internal server error!\';\n}\n\nfunction displayUpdaterResponse(JsonText) {\n    switchProgressToButton();\n\n    //var contents = \'<textarea rows=\"20\" cols=\"145\">\'+JsonText+\'</textarea>\';\n    //document.getElementById(\"updateNubuilderResponse\").innerHTML=contents;\n\n    obj = $.parseJSON(JsonText);\n    var result = \'<br><b>Result</b>: \' + obj.message + \'<br><br>\';\n    document.getElementById(\"updateNubuilderProgress\").innerHTML=result;\n\n    if ( obj.message == \'ERRORS\' ) {\n        displayMessageDetails(obj.errors, obj.dbupdate);\n    }\n    if ( obj.message == \'SUCCESS\' ) {\n        displayMessageDetails(obj.success, obj.dbupdate);\n    }\n  \n}\n\nfunction displayMessageDetails(message, dbupdate) {\n\n    var contents = \'<br><br><textarea rows=\"20\" cols=\"145\">\'; \n    contents = loopContents(contents, message);\n    contents = loopContents(contents, dbupdate.summary1);\n    contents = loopContents(contents, dbupdate.summary2);\n    contents = loopContents(contents, dbupdate.sqlErrors);\n    contents = loopContents(contents, dbupdate.warnings);\n    contents = contents + \'</textarea>\';\n	\n    document.getElementById(\"updateNubuilderMessageDetails\").innerHTML=contents;\n}\n\nfunction loopContents(contents, obj) {\n\n    if (obj instanceof Array) {\n        for (var i = 0; i < obj.length; i++) {\n            contents = contents + obj[i];\n            contents = contents + \'&nbsp;\';\n            contents = contents + \'\\r\';      \n        }\n    }\n    return contents; \n}',NULL,0,0,'2014-07-09 16:21:36','globeadmin','2014-07-15 13:06:56','globeadmin','2014-07-15 13:07:18','globeadmin','browse',0,NULL),('nusubformwizard','SFW','Subform Wizard','select * from zzzsys_debug','zzzsys_debug','zzzsys_debug_id',0,600,'','','1','','','','','','Create Subform','','','','','','','','','','','function getProperties($attr) {\r\n    \r\n    $type   = \'text\';\r\n    $height = \'\';\r\n    $width  = $attr[3];\r\n    $title  = $attr[4];\r\n    $lookup = $attr[5];\r\n    $lc     = $attr[6];\r\n    $ld     = $attr[7];\r\n    $align  = \'l\';\r\n    $format = \'\';\r\n    \r\n    switch ($attr[1]) {\r\n        case \'date\':\r\n            $format = \'6\';\r\n            break;\r\n        case \'int\':\r\n            $align  = \'r\';\r\n            $format = \'0\';\r\n            break;\r\n        case \'double\':\r\n            $align = \'r\';\r\n            if($attr[2] <= 5) {\r\n                $format = $attr[2];\r\n            }\r\n            else {\r\n                $format = \'5\';\r\n            }\r\n            break;\r\n        case \'decimal\':\r\n            $align = \'r\';\r\n            if($attr[2] <= 5) {\r\n                $format = $attr[2];\r\n            }\r\n            else {\r\n                $format = \'5\';\r\n            }\r\n            break;\r\n        case \'text\':\r\n            $type   = \'textarea\';\r\n            $height = \'150\';\r\n            $width  = \'250\';\r\n            break;\r\n    } \r\n      \r\n      \r\n    if( $lookup != \'\' ) {\r\n        $type = \'lookup\';\r\n    }\r\n    \r\n    $values = array(\r\n        \"align\"   => $align,\r\n        \"format\"  => $format,\r\n        \"width\"   => $width,\r\n        \"title\"   => $title,\r\n        \"height\"  => $height,\r\n        \"type\"    => $type,\r\n        \"lookup\"  => $lookup,\r\n        \"lc\"      => $lc,\r\n        \"ld\"      => $ld\r\n    );\r\n    \r\n    return $values;\r\n}\r\n\r\n\r\n$subform = nuID();\r\n$form    = \'#sfw_form_id#\';\r\n$table   = \'#sfw_table_name#\';\r\n$primary = \'#sfw_hidden_primary#\';\r\n$foreign = \'#sfw_foreign_key#\';\r\n$type    = \'#sfw_subform_type#\';\r\n\r\n$sql     = \"SELECT * FROM $table WHERE $foreign = \'#\".\'RECORD_ID\'.\"#\'\";\r\n\r\n$fields  = \'#sfw_form_listbox#\';\r\n$fieldarr  = explode(\'#nuSep#\', $fields);\r\n\r\nif( $table === \'\' || $primary === \'\') {\r\n    nuDisplayError(\'A table needs to be chosen.\');\r\n    return;\r\n}\r\n\r\nif( $fields === \'\' ) {\r\n    nuDisplayError(\'At least one field must be chosen.\');\r\n    return;\r\n}\r\n\r\nif( $form === \'\' ) {\r\n    nuDisplayError(\'No form selected\');\r\n    return;\r\n}\r\n\r\nif( $foreign === \'\' ) {\r\n    nuDisplayError(\'No foreign key selected\');\r\n    return;\r\n}\r\n\r\n$fieldarr  = explode(\'#nuSep#\', $fields);\r\n$allfields = array();\r\n\r\nforeach($fieldarr as $value) {\r\n    $allfields[] = explode(\'#nuSepr#\', $value);\r\n}\r\n\r\nif( $type === \'\' ) {\r\n    $type = \'g\';\r\n}\r\nelse if( $type === \'f\' ) {\r\n    $height = 50*count($fieldarr);\r\n}\r\n\r\n//build subform object\r\n$s = \"\r\n    INSERT INTO zzzsys_object (zzzsys_object_id, sob_zzzsys_form_id, sob_all_access_key, sob_all_title, sob_all_name, sob_all_tab_title, sob_all_tab_number, sob_all_column_number, sob_all_order_number, sob_all_top, sob_all_left, sob_all_width, sob_all_height, sob_all_clone, sob_all_align, sob_all_no_blanks, sob_all_no_duplicates, sob_all_read_only, sob_all_type, sob_subform_table, sob_subform_primary_key, sob_subform_foreign_key, sob_subform_addable, sob_subform_deletable, sob_subform_type, sob_subform_sql, sob_subform_row_height) VALUES\r\n    (\'$subform\', \'$form\',\'\', \'\".$table.\"_subform\',\'\".$table.\"_subform\',\'Wizard\', \'12345\',\'10\',\'10\',\'10\', \'10\',\'900\',\'300\',\'1\',\'l\',\'0\',\'0\',\'0\',\'subform\',\'$table\', \'$primary\', \'$foreign\',\'1\',\'1\',\'$type\',\'\".addslashes($sql).\"\', \'20\')\r\n\";\r\nnuRunQuery($s);\r\n\r\n\r\n$s = \"\r\n    INSERT INTO zzzsys_object (zzzsys_object_id, sob_zzzsys_form_id, sob_all_column_number, sob_all_name, sob_all_order_number, sob_all_tab_number, sob_all_tab_title, sob_all_title, sob_all_type, sob_all_width, sob_all_height, sob_all_align, sob_text_format, sob_all_no_blanks, sob_all_read_only, sob_all_no_duplicates, sob_all_clone, sob_lookup_code_field, sob_lookup_description_field, sob_lookup_zzzsys_form_id, sob_lookup_id_field, sob_lookup_code_width, sob_lookup_description_width) VALUES\r\n    \r\n\";\r\n\r\n$o = 10;\r\n$c = 10;\r\n$hasTextArea = false;\r\n\r\nfor( $idx = 0; $idx < count($allfields); $idx++ ) {\r\n    $prim  = nuID();\r\n    $field = $allfields[$idx];\r\n    $prop  = getProperties($field);\r\n    $form_id = \'\';\r\n    \r\n    if( $prop[\"lookup\"] !== \'\' ) {\r\n        $sq = \"SELECT sfo_primary_key FROM zzzsys_form WHERE zzzsys_form_id = ?\";\r\n        \r\n        $qry = nuRunQuery($sq, array($prop[\"lookup\"]));\r\n        $res = db_fetch_object($qry);\r\n        $form_id = $res->sfo_primary_key;\r\n    }\r\n    if( $prop[\"type\"] == \'textarea\' and $type == \'g\' and !$hasTextArea) {\r\n        $sq = \"UPDATE zzzsys_object SET sob_subform_row_height=\'175\' WHERE zzzsys_object_id = \'$subform\'\";\r\n        nuRunQuery($sq);\r\n        $hasTextArea = true;\r\n    }\r\n    \r\n    $s .= \"( \'$prim\', \'$subform\', \'$c\', \'\".$field[0].\"\', \'$o\', \'10\', \'Details\', \'\".$prop[\'title\'].\"\', \'\".$prop[\'type\'].\"\', \'\".$prop[\'width\'].\"\',\'\".$prop[\'height\'].\"\',  \'\".$prop[\'align\'].\"\', \'\".$prop[\'format\'].\"\', \'0\',\'0\',\'0\',\'1\', \'\".$prop[\"lc\"].\"\', \'\".$prop[\"ld\"].\"\', \'\".$prop[\"lookup\"].\"\', \'\".$form_id.\"\', \'100\', \'250\'), \";\r\n    \r\n    $o = $o + 10;\r\n    if( $o >= 150 ) {\r\n        $o = 10;\r\n        $c = $c + 10;\r\n    }\r\n}\r\n$s = rtrim($s, \', \');\r\nnuRunQuery($s);\r\nnuRunQuery(\"UPDATE zzzsys_object SET sob_all_top = \'0\' WHERE sob_all_top IS NULL;\");\r\nnuRunQuery(\"UPDATE zzzsys_object SET sob_all_left = \'0\' WHERE sob_all_left IS NULL;\");\r\nnuRunQuery(\"UPDATE zzzsys_object SET sob_all_clone = \'0\' WHERE sob_all_clone IS NULL;\");\r\nnuRunQuery(\"UPDATE zzzsys_object SET sob_all_align = \'0\' WHERE sob_all_align IS NULL;\");\r\nnuRunQuery(\"UPDATE zzzsys_object SET sob_all_no_blanks = \'0\' WHERE sob_all_no_blanks IS NULL;\");\r\nnuRunQuery(\"UPDATE zzzsys_object SET sob_all_read_only = \'0\' WHERE sob_all_read_only IS NULL;\");\r\nnuRunQuery(\"UPDATE zzzsys_object SET sob_all_align = \'l\' WHERE sob_all_align IS NULL;\");\r\nnuRunQuery(\"UPDATE zzzsys_object SET sob_all_no_duplicates = \'0\' WHERE sob_all_no_duplicates IS NULL;\");\r\n\r\nnuRunQuery(\"UPDATE zzzsys_object SET sob_all_top = \'0\' WHERE sob_all_top = \'\';\");\r\nnuRunQuery(\"UPDATE zzzsys_object SET sob_all_left = \'0\' WHERE sob_all_left = \'\';\");\r\nnuRunQuery(\"UPDATE zzzsys_object SET sob_all_clone = \'0\' WHERE sob_all_clone = \'\';\");\r\nnuRunQuery(\"UPDATE zzzsys_object SET sob_all_align = \'0\' WHERE sob_all_align = \'\';\");\r\nnuRunQuery(\"UPDATE zzzsys_object SET sob_all_no_blanks = \'0\' WHERE sob_all_no_blanks = \'\';\");\r\nnuRunQuery(\"UPDATE zzzsys_object SET sob_all_read_only = \'0\' WHERE sob_all_read_only = \'\';\");\r\nnuRunQuery(\"UPDATE zzzsys_object SET sob_all_align = \'l\' WHERE sob_all_align = \'\';\");\r\nnuRunQuery(\"UPDATE zzzsys_object SET sob_all_no_duplicates = \'0\' WHERE sob_all_no_duplicates = \'\';\");\r\n\r\n','','','$sql = \"\nSELECT TABLE_NAME, COLUMN_NAME, COLUMN_KEY, DATA_TYPE, NUMERIC_SCALE, NUMERIC_PRECISION, CHARACTER_MAXIMUM_LENGTH\nFROM INFORMATION_SCHEMA.COLUMNS\nWHERE TABLE_SCHEMA = database()\n\";\n\n$js = \"function fetch_columns() {window.columns = [\";\n\n$q = nuRunQuery($sql);\n\n$r = db_fetch_array($q);\n\n$js .= \"[\\\"\" . $r[0] . \"\\\" , \\\"\" . $r[1] . \"\\\" , \\\"\" . $r[2] . \"\\\" , \\\"\" . $r[3] . \"\\\" , \\\"\" . $r[4] . \"\\\" , \\\"\" . $r[5]. \"\\\" , \\\"\" . $r[6] . \"\\\"]\";\nwhile($r = db_fetch_array($q)) {\n    $js .= \",[\\\"\" . $r[0] . \"\\\" , \\\"\" . $r[1] . \"\\\" , \\\"\" . $r[2] . \"\\\" , \\\"\" . $r[3] . \"\\\" , \\\"\" . $r[4] . \"\\\" , \\\"\" . $r[5]. \"\\\" , \\\"\" . $r[6]. \"\\\"]\";\n}\n$js .= \"];}\";\n\nnuAddJavascript($js);','','','function nuLoadEdit() {\n    $(\'#sfw_table_listbox\').empty();\n    $(\'#sfw_form_listbox\').empty();\n    $(\'#nuBreadCrumb_1\').remove();\n    $(\'#nuArrow_0\').remove();\n    $(\'#sfw_form_up\').val($(\'<div>\').html(\'&uarr;\').text());\n    $(\'#sfw_form_down\').val($(\'<div>\').html(\'&darr;\').text());\n}\n\nfunction selectAll(listbox) {\n    var select = $(\'#\'+listbox);\n    $(\'option\', select).prop(\'selected\', 1);\n}\n\nfunction nuOnSave() {\n    selectAll(\'sfw_form_listbox\');\n    $(\'#sfw_form_listbox option\').each(function() {\n        var ed_width = $(this).attr(\'nu_ed_width\');\n        var ed_title = $(this).attr(\'nu_ed_title\');\n        var lookup   = $(this).attr(\'nu_lookup\');\n        var lc       = $(this).attr(\'nu_lookup_code\');\n        var ld       = $(this).attr(\'nu_lookup_description\');\n        var value = $(this).attr(\'value\');\n        $(this).attr(\'value\', value+\'#nuSepr#\'+ed_width+\'#nuSepr#\'+ed_title+\'#nuSepr#\'+lookup+\'#nuSepr#\'+lc+\'#nuSepr#\'+ld);\n    });\n    return true;\n}',NULL,0,0,'2014-01-31 15:34:09','globeadmin','2014-02-11 13:01:54','globeadmin','2014-02-11 13:01:54','globeadmin','browse',0,NULL),('nuemail','EMAIL','Email','select * from zzzsys_debug','zzzsys_debug','zzzsys_debug_id',500,300,'','','1','','','','','','Send Email','','','','','','','','','','','if(\'#replyto#\' == \'\'){\r\n    nuDisplayError(\'User must have an Email Address\');\r\n    return;\r\n}\r\n\r\n$to = \'#to#\';\r\nif ( \'#sendcopy#\' == \'1\' ) {\r\n    $to.=\',\'.\'#replyto#\'; \r\n}\r\n\r\nnuDebug(\'#sendcopy#\');\r\n\r\nif(\'#nu_pdf_code#\'!=\'\') {\r\n    nuEmail(\'#nu_pdf_code#\', $to, \'#subject#\',\'#message#\', $hashData);\r\n}\r\nelse if(\'#nu_php_code#\'!=\'\') {\r\n    nuEmail(\'#nu_php_code#\', $to, \'#subject#\',\'#message#\', $hashData);\r\n}\r\nelse {\r\n    nuEmail(\'\', $to, \'#subject#\',\'#message#\', $hashData);\r\n}','','','','','','function nuLoadEdit(){\r\n\r\n    if  (\'#nu_smtp_to_address#\' === \'\' ) {\r\n        \r\n        ifNonValidEmailSetup();\r\n        \r\n    } else {\r\n        \r\n       ifValidEmailSetup(); \r\n    \r\n    } // end nu_smtp_to_address   \r\n} //end nuLoadEdit\r\n\r\nfunction ifValidEmailSetup() {\r\n    \r\n    $(\'#alertmessage1\').remove();\r\n    var sendcopymsg = \'Send me (#nu_smtp_to_address#) a copy\';\r\n    $(\'#sendcopyword\').html(sendcopymsg);\r\n\r\n    nuFORM.record_id = nuFORM.nu_previous_record_id;   //-- so pdf and php use the previous record_id\r\n\r\n    if(nuFORM.closedown !== undefined) {\r\n      nuRemoveModal();\r\n    }\r\n\r\n    var mess = \'\';\r\n    var m    = \'\';\r\n    nuFORM.closedown = 1;\r\n    if(nuFORM.nu_pdf_code !== \'\') {\r\n\r\n        mess = nuValidatePDF(nuFORM.nu_pdf_code);\r\n        m    = \'\';\r\n\r\n        if(mess.length > 0) {\r\n\r\n            for(var i = 0 ; i < mess.length ; i++){\r\n                m = m + mess[i] + \"\\r\";\r\n            }\r\n\r\n            alert(m);\r\n            nuRemoveModal();\r\n            return;\r\n		}\r\n	}\r\n\r\n    if(nuFORM.nu_php_code !== \'\') {\r\n\r\n        mess = nuValidatePHP(nuFORM.nu_php_code);\r\n        m    = \'\';\r\n\r\n        if(mess.length > 0) {\r\n\r\n            for(var ii = 0 ; ii < mess.length ; ii++){\r\n                m = m + mess[ii] + \"\\r\";\r\n            }\r\n\r\n            alert(m);\r\n            nuRemoveModal();\r\n            return;\r\n		}\r\n    }\r\n}\r\n\r\nfunction ifNonValidEmailSetup() {\r\n\r\n    $(\'#to\').remove();\r\n    $(\'#replytoname\').remove();\r\n    $(\'#replyto\').remove();\r\n    $(\'#from\').remove();\r\n    $(\'#subject\').remove();\r\n    $(\'#message\').remove();\r\n    $(\'#title_to\').remove();\r\n    $(\'#title_replytoname\').remove();\r\n    $(\'#title_replyto\').remove();\r\n    $(\'#title_from\').remove();\r\n    $(\'#title_subject\').remove();\r\n    $(\'#title_message\').remove();\r\n    $(\'#nuButton0\').remove();\r\n    $(\'#sendcopy\').remove();\r\n    $(\'#title_sendcopy\').remove();\r\n    $(\'#sendcopyword\').remove();\r\n\r\n}\r\n',NULL,0,0,'2014-01-20 14:22:15','globeadmin','2014-02-06 12:53:51','globeadmin','2014-02-06 12:53:52','globeadmin','browse',0,NULL),('nunoaccess','noaccess','No access if not globeadmin','SELECT * FROM zzzsys_form\r\nWHERE \r\n(\r\nzzzsys_form_id NOT LIKE \'#nu_denied#\'\r\nOR \r\nzzzsys_form_id\r\nIN (\'nuemail\',\'nuhome\',\'nugroup\',\'nuimage\',\'nulevel\',\'nunoaccess\',\'nuuser\' ,\'nurunreport\' ,\'nurunphp\',\'nureport\' ,\'nuphp\',\'nunoaccess\')\r\n)\r\nORDER BY sfo_name\r\n','zzzsys_form','zzzsys_form_id',0,0,'','0','0','0','0','0','0',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'nuform',0,0,'2014-02-07 13:07:46','globeadmin','2014-02-07 13:49:58','globeadmin','2014-02-07 14:06:07','globeadmin','browse',0,NULL),('nulevel','acc','Access Level','SELECT * FROM zzzsys_access_level','zzzsys_access_level','zzzsys_access_level_id',1000,0,'SELECT \'#sal_code#\'','1','1','1','1','',NULL,'','','','','',NULL,'','','','','',NULL,NULL,NULL,'','\n','','','',NULL,0,0,'0000-00-00 00:00:00','','2013-10-22 15:01:53','globeadmin','2015-04-14 11:40:59','globeadmin','browse',0,NULL),('nureport','are','Add Reports','SELECT * FROM zzzsys_report\nLEFT JOIN zzzsys_php ON sre_zzzsys_php_id = zzzsys_php_id\n','zzzsys_report','zzzsys_report_id',900,0,'','1','1','1','1','','','','','','','','','SELECT IF(\'#sre_group#\' = \'nubuilder\',\'0\',\'1\');','SELECT IF(\'#sre_group#\' = \'nubuilder\',\'0\',\'1\');','SELECT IF(\'#sre_group#\' = \'nubuilder\',\'0\',\'1\');','SELECT IF(\'#sre_group#\' = \'nubuilder\',\'0\',\'1\');','','','if(\'#sre_zzzsys_sql#\' == \'\' and \'#sre_zzzsys_php_id#\' == \'\'){\n\n   $MESS = \"SQL or PHP is required to create a Report..\"; \n   nuDisplayError($MESS);\n\n}\n','','','','','','\r\nfunction nuLoadEdit() { \r\n    \r\n   if(nuFORM.tip == \'Edit\'){\r\n\r\n      $(\'#sre_zzzsys_sql\').css(\'background-color\', \'#FFE8CA\');\r\n      $(\'#sre_zzzsys_sql\').css(\'font-family\', \'Courier New\');\r\n      $(\'#sre_zzzsys_sql\').css(\'font-size\', \'14px\');\r\n      $(\'#sre_zzzsys_sql\').attr(\'wrap\', \'off\');\r\n    }\r\n\r\n}\r\n\r\n','',0,0,'0000-00-00 00:00:00','','2014-09-24 12:40:47','globeadmin','2014-09-24 12:40:47','globeadmin','browse',0,NULL),('nuhome','home','Home','select * from zzzsys_debug','zzzsys_debug','zzzsys_debug_id',0,0,'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,0,0,'2014-02-10 14:05:42','globeadmin','2014-02-10 14:05:42','globeadmin','2014-02-10 14:05:42','globeadmin','browse',0,NULL),('nuuser','use','Users','SELECT * FROM zzzsys_user \r\nLEFT JOIN zzzsys_user_group ON  sus_zzzsys_user_group_id =  zzzsys_user_group_id \r\nLEFT JOIN  zzzsys_access_level ON sug_zzzsys_access_level_id = zzzsys_access_level_id \r\nORDER BY sus_name','zzzsys_user','zzzsys_user_id',900,0,'SELECT \'#sus_name#\'','1','1','1','1','','','','','','','','','','','','','','','','','','','function nuGetPost($Field_Name) {\n    $form_post = $_POST[\'nuWindow\'][\'form_data\'][\'data\'][0][\'records\'][0][\'fields\'];\n    for ($x = 0; $x < count($form_post); $x++) {\n       if ( $form_post[$x][\'field\'] == $Field_Name ) {\n           return $form_post[$x][\'value\'];\n       }\n    }\n    return null;\n}\n\n$user = nuGetPost(\'sus_login_name\');\n$pass = nuGetPost(\'nupassword\');\nif($pass != \'\') {\n	$sql = \"UPDATE zzzsys_user SET sus_login_password = md5(CONCAT(\'$user\', \'$pass\')) WHERE zzzsys_user_id = \'#RECORD_ID#\'\";\n	nuRunQuery($sql);\n}','','function nuOnSave() {\n	//checkPasswords\n	if(document.getElementById(\'nuretyped\').value != document.getElementById(\'nupassword\').value) {\n		alert(\"\'New Password\' and \'Retype New Password\' do not match..\");\n		return false;\n	} else if(document.getElementById(\'sus_login_password\').value == \'\' && document.getElementById(\'nuretyped\').value == \'\') {\n		alert(\"\'New Password\' and \'Retype New Password\' do not match..\");\n		return false;\n	}\n	return true;\n}','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00','','browse',0,NULL),('nurunreport','rre','Run Report','SELECT * FROM zzzsys_report\r\nINNER JOIN zzzsys_form ON sre_zzzsys_form_id = zzzsys_form_id\r\nLEFT JOIN zzzsys_access_level_report ON slr_zzzsys_report_id = zzzsys_report_id\r\nLEFT JOIN zzzsys_access_level ON slr_zzzsys_access_level_id = zzzsys_access_level_id\r\nWHERE (sal_code = \'#nu_access_level#\' OR \'#nu_access_level#\' = \'globeadmin\')\r\nGROUP BY zzzsys_report_id \r\nORDER BY sre_code','zzzsys_report','zzzsys_report_id',900,0,'','0','0','1','1','','','','','','','','','','','','','','','','','','','','','','',0,0,'0000-00-00 00:00:00','','2014-09-22 10:35:18','globeadmin','2014-09-24 12:40:23','globeadmin','browse',0,NULL),('nudebug','bug','Debug','SELECT * FROM zzzsys_debug \nORDER BY deb_added DESC\n','zzzsys_debug','zzzsys_debug_id',0,0,'','0','1','0','0','0',NULL,NULL,'Delete Chosen Period',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,'',NULL,'$seconds = \'#deb_delete#\';\r\n\r\n$sql = \'SELECT * FROM zzzsys_debug\';\r\n$t   = nuRunQuery($sql);\r\n\r\nwhile($r = db_fetch_object($t)){\r\n    if(strtotime(date(\"Y-m-d H:i:s\")) - strtotime($r->deb_added) > $seconds) {\r\n        nuRunQuery(\"DELETE FROM zzzsys_debug WHERE zzzsys_debug_id = \'$r->zzzsys_debug_id\'\");\r\n    }\r\n}\r\n',NULL,NULL,NULL,0,0,'0000-00-00 00:00:00','','2014-01-10 13:05:22','globeadmin','2014-01-10 13:05:23','globeadmin','browse',0,NULL),('nufastform','faf','Fast Form','SELECT * \nFROM zzzsys_form\nWHERE zzzsys_form_id NOT LIKE \'nu%\'\nAND sfo_table NOT LIKE \'zzzsys_%\'\nORDER BY sfo_title\n','zzzsys_form','zzzsys_form_id',0,0,'','1','1',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'$s = nuGetJSONSubform(\'fast_form_subform\');\n$j = json_decode($s);\n\nfor($i = 0 ; $i-1 < count($j) ; $i++){                                            //-- loop through JSON\n    \n    if($j[$i]->nuDelete == \'1\' and $j[$i]->nuPrimaryKey != \'\'){\n        nuRemoveFastField($j[$i]->nuPrimaryKey);\n    }    \n}\n\n\n\nfunction nuRemoveFastField($i){\n    \n    $s = \"\n        SELECT * \n        FROM zzzsys_object\n        WHERE zzzsys_object_id = \'$i\'\n    \";\n    \n    $t = nuRunQuery($s);\n    $o = db_fetch_object($t);\n    \n    $s = \"\n        SELECT * \n        FROM zzzsys_form\n        WHERE zzzsys_form_id = \'$o->sob_zzzsys_form_id\'\n    \";\n    \n    $t = nuRunQuery($s);\n    $f = db_fetch_object($t);\n    \n    $s = \"\n        DELETE FROM zzzsys_browse\n        WHERE sbr_zzzsys_form_id = \'$f->zzzsys_form_id\'\n        AND sbr_display = \'$o->sob_all_name\'\n    \";\n\n    nuRunQuery($s);                                                             //-- remove Browse Column\n\n}\n\n',NULL,'',NULL,'$GLOBALS[\'nuObjectOrder\']      = 100;\r\n\r\n\r\n$a  = array();\r\n$t  = nuRunQuery(\"SELECT * FROM zzzsys_form WHERE zzzsys_form_id = \'#RECORD_ID#\'\");\r\n$FO = db_fetch_object($t);\r\n\r\nif($FO->sfo_table == \'\'){                                                        //-- add a new form and table\r\n\r\n    $FO->sfo_table = nuFastFormForm($FO);\r\n\r\n}\r\n\r\n$s = \"\r\n    SELECT * \r\n    FROM zzzsys_object \r\n    WHERE sob_zzzsys_form_id = \'$FO->zzzsys_form_id\'\r\n    ORDER BY sob_all_name DESC, zzzsys_object_id\r\n\";\r\n\r\n$t = nuRunQuery($s);\r\n\r\nwhile($OO = db_fetch_object($t)){\r\n    \r\n    if($OO->sob_all_name == \'\'){\r\n    \r\n        $OO->sob_all_name  = nuGetUniqueName($OO->sob_all_title, $a);\r\n        nuAddFastFormObject($FO, $OO);\r\n        \r\n    }\r\n        \r\n    $a[] = $OO->sob_all_name;\r\n    \r\n    $GLOBALS[\'nuObjectOrder\'] = $GLOBALS[\'nuObjectOrder\'] + 1;\r\n    \r\n}\r\n\r\n$s = \"\r\n    DELETE FROM zzzsys_object\r\n    WHERE IFNULL(sob_all_name,\'\') = \'\' \r\n    AND IFNULL(sob_all_type,\'\') = \'\'\r\n\";\r\n\r\nnuRunQuery($s);\r\n\r\n\r\n\r\n//--------------------------------- Functions-----------------------------------\r\n\r\nfunction nuAddFastFormObject($FO, $OO){                                //-- Add Form Object and Browse Column\r\n\r\n    $bid = nuID();\r\n\r\n    $d   = $FO->sfo_table.\'_id\';\r\n    $ord = $GLOBALS[\'nuObjectOrder\'];\r\n    $tit = nuValidTitle($OO->sob_all_title);\r\n\r\n    $s   = \"\r\n    \r\n        UPDATE zzzsys_object\r\n        SET \r\n        sob_all_name = \'$OO->sob_all_name\',\r\n        sob_all_tab_title = \'Main\',\r\n        sob_all_tab_number = \'10\',\r\n        sob_all_column_number = \'10\',\r\n        sob_all_order_number = \'$ord\',\r\n        sob_all_clone = \'1\',\r\n        sob_all_align = \'l\',\r\n        sob_all_no_blanks = \'0\',\r\n        sob_all_read_only = \'0\',\r\n        sob_all_no_duplicates = \'0\',\r\n        sob_all_left = \'0\',\r\n        sob_all_top = \'0\'\r\n        WHERE zzzsys_object_id = \'$OO->zzzsys_object_id\'\r\n\r\n    \";\r\n\r\n    nuRunQuery($s);                                                             //-- add Object\r\n\r\n    $s   = \"\r\n    \r\n    	INSERT INTO zzzsys_browse\r\n    	(\r\n    	zzzsys_browse_id,\r\n    	sbr_zzzsys_form_id,\r\n    	sbr_title,\r\n    	sbr_display,\r\n    	sbr_sort,\r\n    	sbr_align,\r\n    	sbr_order,\r\n    	sbr_width\r\n    	)\r\n    	VALUES\r\n    	(\r\n    	\'$bid\',\r\n    	\'$FO->zzzsys_form_id\',\r\n    	\'$tit\',\r\n    	\'$OO->sob_all_name\',\r\n    	\'$OO->sob_all_name\',\r\n    	\'l\',\r\n    	\'$ord\',\r\n    	150\r\n    	)\r\n	\r\n    \";\r\n    \r\n    nuRunQuery($s);                                                             //-- add Browse\r\n\r\n    nuUpdateObject($bid, $OO, $FO);\r\n    \r\n}\r\n\r\n\r\n\r\nfunction nuUpdateObject($bid, $OO, $FO){\r\n\r\n    $t = 40;\r\n\r\n    if($OO->sob_all_type == \'Text\'){\r\n    \r\n        $osql = \"sob_all_type = \'text\', sob_all_width = 200\";\r\n        $bsql = \"sbr_align = \'l\'\";\r\n        $asql = \"ADD $OO->sob_all_name VARCHAR(300) NOT NULL\";\r\n        \r\n	}\r\n    if($OO->sob_all_type == \'Date\'){\r\n    \r\n        $osql = \"sob_all_type = \'text\', sob_all_width = 90, sob_text_format = \'6\'\";\r\n        $bsql = \"sbr_align = \'l\', sbr_format = \'6\'\";\r\n        $asql = \"ADD $OO->sob_all_name DATE NOT NULL\";\r\n        \r\n	}\r\n    if($OO->sob_all_type == \'Number\'){\r\n    \r\n        $osql = \"sob_all_type = \'text\', sob_all_width = 80, sob_text_format = \'2\', sob_all_align = \'r\'\";\r\n        $bsql = \"sbr_align = \'r\', sbr_format = \'2\'\";\r\n        $asql = \"ADD $OO->sob_all_name DECIMAL(12,2) NOT NULL\";\r\n        \r\n	}\r\n    if($OO->sob_all_type == \'Auto Number\'){\r\n    \r\n        $auto = \'auto_\' . $OO->zzzsys_object_id . \'_\' . $FO->sfo_table ;\r\n        $osql = \"sob_all_type = \'text\', sob_all_width = 60, sob_all_align = \'r\', sob_all_read_only = \'1\', sob_all_default_value_sql = \'#$auto#\'\";\r\n        $bsql = \"sbr_align = \'r\'\";\r\n        $asql = \"ADD $OO->sob_all_name INT NOT NULL\";\r\n        \r\n        $atab = \"\r\n                CREATE TABLE $auto (\r\n                id int(11) NOT NULL AUTO_INCREMENT,\r\n                extra_field varchar(25) NOT NULL,\r\n                PRIMARY KEY (id),\r\n                KEY extra_field (extra_field)\r\n                )\r\n        \";\r\n        \r\n        nuRunQuery($atab);\r\n        \r\n	}\r\n    if($OO->sob_all_type == \'Password\'){\r\n    \r\n        $osql = \"sob_all_type = \'text\', sob_all_width = 100, sob_text_type = \'password\'\";\r\n        $bsql = \"\";\r\n        $asql = \"ADD $OO->sob_all_name VARCHAR(300) NOT NULL\";\r\n        $s = \"DELETE FROM zzzsys_browse WHERE zzzsys_browse_id = \'$bid\'\";\r\n        nuRunQuery($s);\r\n        \r\n	}\r\n   if($OO->sob_all_type == \'Checkbox\'){\r\n    \r\n        $osql = \"sob_all_type = \'checkbox\', sob_all_width = 10\";\r\n        $bsql = \"sbr_display = \'$OO->sob_all_name\', sbr_sort = \'$OO->sob_all_name\'\";\r\n        $asql = \"ADD $OO->sob_all_name VARCHAR(1) NOT NULL\";\r\n        \r\n	}\r\n    if($OO->sob_all_type == \'Text Area\'){\r\n    \r\n        $osql = \"sob_all_type = \'textarea\', sob_all_height = 200, sob_all_width = 200\";\r\n        $bsql = \"sbr_align = \'l\'\";\r\n        $asql = \"ADD $OO->sob_all_name TEXT NOT NULL\";\r\n        \r\n	}\r\n    if($OO->sob_all_type == \'Drop Down\'){\r\n    \r\n        $osql = \"sob_all_type = \'dropdown\', sob_all_width = 50, sob_dropdown_sql = \'0|No|1|Yes\'\";\r\n        $bsql = \"sbr_display = \'$OO->sob_all_name\', sbr_sort = \'$OO->sob_all_name\'\";\r\n        $asql = \"ADD $OO->sob_all_name VARCHAR(300) NOT NULL\";\r\n        \r\n	}\r\n    if($OO->sob_all_type == \'Listbox\'){\r\n    \r\n        $LBN = \'listbox_\' . $OO->zzzsys_object_id . \'_\' . $OO->sob_all_name;\r\n\r\n        $s    = \"\r\n                CREATE TABLE $LBN (\r\n                id VARCHAR(25) NOT NULL, \r\n                choice VARCHAR(200) NOT NULL, \r\n                PRIMARY KEY (id)\r\n                )\r\n                 ENGINE = MyISAM;\r\n                \";\r\n                \r\n        nuRunQuery($s);\r\n        \r\n    \r\n        $s    = \"\r\n                INSERT INTO $LBN\r\n                (id, choice) \r\n                VALUES \r\n                (\'1\', \'Choice 1\'), (\'2\', \'Choice 2\'), (\'3\', \'Choice 3\');\r\n                \";\r\n                \r\n        nuRunQuery($s);\r\n        \r\n\r\n        $osql = \"sob_all_type = \'listbox\', sob_all_width = 200, sob_all_height = 70, sob_listbox_sql = \'SELECT id, choice FROM $LBN\'\";\r\n        $asql = \"ADD $OO->sob_all_name TEXT NOT NULL\";\r\n        $s = \"DELETE FROM zzzsys_browse WHERE zzzsys_browse_id = \'$bid\'\";\r\n        nuRunQuery($s);\r\n        \r\n	}\r\n    if($OO->sob_all_type == \'Word\'){\r\n    \r\n        $osql = \"sob_all_type = \'words\', sob_all_width = 200\";\r\n        $bsql = \"\";\r\n        $asql = \"\";\r\n        $s = \"DELETE FROM zzzsys_browse WHERE zzzsys_browse_id = \'$bid\'\";\r\n        nuRunQuery($s);\r\n        \r\n	}\r\n    if($OO->sob_all_type == \'Display\'){\r\n    \r\n        $osql = \"sob_all_type = \'display\', sob_all_width = 200, sob_display_sql = \'SELECT CURDATE()\'\";\r\n        $bsql = \"\";\r\n        $asql = \"\";\r\n        $s = \"DELETE FROM zzzsys_browse WHERE zzzsys_browse_id = \'$bid\'\";\r\n        nuRunQuery($s);\r\n        \r\n	}\r\n    if($OO->sob_all_type == \'HTML\'){\r\n    \r\n        $osql = \"sob_all_type = \'html\', sob_all_width = 200, sob_all_height = 200, sob_html_code = \'<div style=\\\"background-color:lightblue;height:200px;width:200px\\\">Hello World</div>\'\";\r\n        $bsql = \"\";\r\n        $asql = \"\";\r\n        $s = \"DELETE FROM zzzsys_browse WHERE zzzsys_browse_id = \'$bid\'\";\r\n        nuRunQuery($s);\r\n        \r\n	}\r\n    if($OO->sob_all_type == \'Hidden Field\'){\r\n    \r\n        $osql = \"sob_all_type = \'text\', sob_all_display_condition = \'SELECT 0\'\";\r\n        $bsql = \"\";\r\n        $asql = \"ADD $OO->sob_all_name VARCHAR(300) NOT NULL\";\r\n        $s = \"DELETE FROM zzzsys_browse WHERE zzzsys_browse_id = \'$bid\'\";\r\n        nuRunQuery($s);\r\n        \r\n	}\r\n    if($OO->sob_all_type == \'Javascript Button\'){\r\n    \r\n        $osql = \"sob_all_type = \'button\', sob_all_height = 30, sob_all_width = 200\";\r\n        $bsql = \"\";\r\n        $asql = \"\";\r\n        $s = \"DELETE FROM zzzsys_browse WHERE zzzsys_browse_id = \'$bid\'\";\r\n        nuRunQuery($s);\r\n\r\n        $eid = nuID();\r\n        $s = \"INSERT INTO zzzsys_event (zzzsys_event_id, sev_zzzsys_object_id, sev_name, sev_javascript) VALUES (\'$eid\',\'$OO->zzzsys_object_id\',\'onclick\',\'alert(123);\')\";\r\n        nuRunQuery($s);\r\n        \r\n	}\r\n    if($OO->sob_all_type == \'Open Form Button\'){\r\n    \r\n        $osql = \"sob_all_type = \'button\', sob_all_height = 30, sob_all_width = 200, sob_button_zzzsys_form_id = \'nudebug\'\";\r\n        $bsql = \"\";\r\n        $asql = \"\";\r\n        $s = \"DELETE FROM zzzsys_browse WHERE zzzsys_browse_id = \'$bid\'\";\r\n        nuRunQuery($s);\r\n\r\n	}\r\n\r\n    if($osql != \'\'){\r\n        \r\n        $s = \"UPDATE zzzsys_object SET $osql WHERE zzzsys_object_id = \'$OO->zzzsys_object_id\' \";\r\n        nuRunQuery($s);\r\n\r\n    }\r\n    \r\n    if($bsql != \'\'){\r\n        \r\n        $s = \"UPDATE zzzsys_browse SET $bsql WHERE zzzsys_browse_id = \'$bid\'\";\r\n        nuRunQuery($s);\r\n\r\n    }    \r\n    \r\n    if($asql != \'\'){\r\n        \r\n        $s = \"ALTER TABLE $FO->sfo_table $asql\";\r\n        nuRunQuery($s);\r\n\r\n    }    \r\n}\r\n\r\n\r\nfunction nuFastFormForm($FO){\r\n\r\n    $t   = nuRunQuery(\"SELECT COUNT(*) FROM zzzsys_form\");\r\n    $r   = db_fetch_row($t);\r\n    $n   = $r[0];\r\n    $tn  = nuGetTableName();\r\n    $p   = $tn . \'_id\';\r\n    $b   = nuID();\r\n    $a   = nuID();\r\n\r\n    $s   = \"\r\n    \r\n        UPDATE zzzsys_form\r\n        SET\r\n        sfo_name = \'FF$n\', \r\n        sfo_sql = \'SELECT * FROM $tn\', \r\n        sfo_table = \'$tn\', \r\n        sfo_primary_key = \'$p\', \r\n        sfo_add_button = \'1\', \r\n        sfo_save_button = \'1\', \r\n        sfo_delete_button = \'1\', \r\n        sfo_clone_button = \'1\', \r\n        sfo_print_button = \'1\'\r\n        WHERE zzzsys_form_id = \'$FO->zzzsys_form_id\'\r\n        \r\n    \";\r\n\r\n    nuRunQuery($s);                                                                             //-- create new form\r\n\r\n    $s   = \"\r\n    \r\n        INSERT INTO zzzsys_object\r\n        (\r\n        zzzsys_object_id, \r\n        sob_zzzsys_form_id,\r\n        sob_all_name,\r\n        sob_all_type,\r\n        sob_all_title,\r\n        sob_all_tab_title,\r\n        sob_all_tab_number,\r\n        sob_all_column_number,\r\n        sob_all_order_number,\r\n        sob_all_clone,\r\n        sob_all_align,\r\n        sob_all_no_blanks,\r\n        sob_all_read_only,\r\n        sob_all_no_duplicates,\r\n        sob_all_width,\r\n        sob_all_height,\r\n        sob_button_zzzsys_form_id\r\n        ) \r\n        VALUES \r\n        (\r\n        \'$b\', \r\n        \'nuhome\', \r\n        \'btn$tn\', \r\n        \'button\',\r\n        \'$FO->sfo_title\',\r\n        \'Home\',\r\n        \'10\',\r\n        \'10\',\r\n        \'10\',\r\n        \'1\',\r\n        \'l\',\r\n        \'0\',\r\n        \'0\',\r\n        \'0\',\r\n        \'200\',\r\n        \'30\',\r\n        \'$FO->zzzsys_form_id\'\r\n        )\r\n\r\n    \";\r\n\r\n    nuRunQuery($s);                                                             //-- add Form to Fast Form Access Level\r\n\r\n    $s   = \"\r\n\r\n        INSERT INTO zzzsys_access_level_form \r\n        (\r\n        zzzsys_access_level_form_id, \r\n        slf_zzzsys_access_level_id, \r\n        slf_zzzsys_form_id \r\n        ) \r\n        VALUES\r\n        (\r\n        \'$a\', \r\n        \'nufastformlevel\', \r\n        \'$FO->zzzsys_form_id\'\r\n        );\r\n\r\n    \";\r\n\r\n    nuRunQuery($s);                                                             //-- add Button to Home\r\n    \r\n    \r\n    $s = \"CREATE TABLE $tn ($p VARCHAR(25) NOT NULL, PRIMARY KEY ($p)) ENGINE = MyISAM\";\r\n\r\n    nuRunQuery($s); //-- create new table\r\n\r\n    return $tn;        \r\n    \r\n}\r\n\r\nfunction nuGetTableName(){\r\n\r\n    $n = \'#sfo_title#\';\r\n    \r\n    $s = \"\r\n    \r\n	SELECT TABLE_NAME\r\n	FROM INFORMATION_SCHEMA.TABLES\r\n	WHERE TABLE_SCHEMA = \'$db\'\r\n	GROUP BY TABLE_NAME\r\n    \r\n    \";\r\n    \r\n    $t = nuRunQuery($s);\r\n    $a = array();\r\n    \r\n    while($r = db_fetch_row($t)){\r\n        $a[] = $r[0];\r\n    }\r\n\r\n    return nuGetUniqueName($n, $a);\r\n\r\n}\r\n\r\nfunction nuValidName($n){\r\n    \r\n    $v = preg_replace(\"/[^0-9a-zA-Z _]/\", \"\", $n);\r\n    \r\n    return str_replace(\' \', \'_\', strtolower($v));\r\n}\r\n\r\n\r\nfunction nuValidTitle($n){\r\n    \r\n    return trim(preg_replace(\"/[^0-9a-zA-Z _]/\", \"\", $n));\r\n    \r\n}\r\n\r\n\r\nfunction nuGetUniqueName($name, $a){\r\n\r\n    $n = nuValidName($name);\r\n    \r\n    $c = \'\';\r\n    \r\n    while(true){\r\n\r\n\r\n        if(array_search($n . $c, $a) == \'\'){\r\n            return $n . $c;\r\n        }else{\r\n  \r\n            if($c == \'\'){\r\n                $c = 1;\r\n            }else{\r\n                $c = $c + 1;\r\n            }\r\n\r\n       }\r\n       \r\n    }\r\n\r\n}\r\n\r\n',NULL,'function nuFastFormObject(t){\n    \n    var r = $(\'#\' + t.id).attr(\'data-prefix\');\n    var p = $(\'#\' + r + \'_nuPrimaryKey\').val();\n    \n    if(p == \'\'){\n        alert(\'This Fast Form must be saved first.\')\n    }else{\n        nuOpenFormInFrame(\'nuobject\', p);\n    }\n    \n}\n\nfunction nuFastFormFormView(){\n    \n    var p = \'#RECORD_ID#\';\n    \n    if(p == \'-1\'){\n        alert(\'This Fast Form must be saved first.\')\n    }else{\n        nuOpenFormInFrame(p, \'-1\');\n    }\n    \n}\n\n\nfunction nuFastFormBrowseView(){\n    \n    var p = \'#RECORD_ID#\';\n    \n    if(p == \'-1\'){\n        alert(\'This Fast Form must be saved first.\')\n    }else{\n        nuOpenBrowseInFrame(p);\n    }\n    \n}\n\nfunction nuFastFormForm(){\n    \n    var p = \'#RECORD_ID#\';\n    \n    if(p == \'-1\'){\n        alert(\'This Fast Form must be saved first.\')\n    }else{\n        nuOpenFormInFrame(\'nuform\', p);\n    }\n    \n}\n\nfunction nuLoadEdit(){ \n\n    nuPopulateFFSubform();\n    $(\'#ff_talk\').html(nuTranslate(\'\"Add an Object to this Form\"\'));\n\n    \n}\n\nfunction nuHideLastSFRow(){ \n\n\n    var s = nuSubformArray(\'fast_form_subform\', true);\n\n    $(\'#\' + s[s.length-1] + \'_nuRow\').css(\'visibility\', \'hidden\');\n    $(\'#\' + s[s.length-1] + \'_nuDelete\').prop(\'checked\', true)\n\n}\n\n\nfunction nuAddFFObject(pthis){\n\n    var s = nuSubformArray(\'fast_form_subform\', true);\n    var r = s[s.length-1];\n\n    $(\"[id$=\'fast_form_object_properties\']\").val(\'P\');\n    $(\'#\' + r + \'_nuRow\').css(\'visibility\', \'visible\');\n    $(\'#\' + r + \'fast_form_object_description\').html(\'&nbsp;\' + pthis.value + \' (\'+ $(\'#\'+pthis.id).attr(\'data-type\') + \')\');\n    $(\'#\' + r + \'sob_all_type\').val($(\'#\'+pthis.id).val());\n    $(\'#\' + r + \'sob_all_title\').val(pthis.value + \' \' + s.length);\n    $(\'#\' + r + \'sob_all_title\').focus();\n\n    nuAddRow(\'fast_form_subform\');\n\n    nuHideLastSFRow();\n\n    var o = String(pthis.value).toLowerCase().replaceAll(\' \', \'_\', true);\n    \n}\n\n\nfunction nuPopulateFFSubform(){\n\n    var i = 0;\n    var r = \'\';\n    var s = nuSubformArray(\'fast_form_subform\', true);\n    \n    for(i = 0 ; i < s.length ; i++){\n        \n        $(\'#\' + s[i] + \'_nuRow\').css(\'visibility\', \'visible\');\n        $(\'#\' + s[i] + \'_nuDelete\').prop(\'checked\', false)\n        $(\'#\' + s[i] + \'fast_form_object_description\').html(\'&nbsp;\' + String($(\'#\' + s[i] + \'sob_all_type\').val()).toUpperCase());\n    }\n\n    $(\"[id$=\'fast_form_object_properties\']\").val(\'P\');\n    $(\"[id$=\'fast_form_object_properties\']\").attr(\'title\',\'Edit Properties\');\n    $(\"#fast_form_properties\").attr(\'title\',\'Edit Properties\');\n    $(\"#fast_form_form_view\").attr(\'title\',\'View Edit Form\');\n    $(\"#fast_form_browse_view\").attr(\'title\',\'View Browse Form\');\n\n    nuHideLastSFRow();\n    \n}\n',NULL,0,0,'2015-03-11 12:21:31','globeadmin','2015-04-15 12:04:02','globeadmin','2015-04-15 12:04:02','globeadmin','browse',0,NULL),('nuimage','ima','Images','SELECT * FROM zzzsys_file ORDER BY sfi_group, sfi_code','zzzsys_file','zzzsys_file_id',900,0,'SELECT \'#sfi_code#\'','1','1','1','','','','Add Image','','','','','','','','','','','','','','','','\n$J           = json_decode(\"#FILES#\");\n\nif($J[0]->name == \'\'){return;}\n\n$dt          = new DateTime();\n$date        = $dt->format(\'Y-m-d H:i:s\');\n\n$name        = $J[0]->name;\n$type        = $J[0]->type;\n$size        = $J[0]->size;\n\n$uploaddir   = sys_get_temp_dir();\n$contents    = file_get_contents($uploaddir . \'/\' . $J[0]->name);\n$contents    = addslashes($contents);\n\n$s           = \"\nUPDATE zzzsys_file \nSET \nsfi_blob                   = \'$contents\',  \nsfi_name                   = \'$name\',  \nsfi_type                   = \'$type\',  \nsfi_size                   = \'$size\', \nzzzsys_file_log_changed_at = \'$date\'\n\nWHERE zzzsys_file_id       = \'#RECORD_ID#\'\n\";\n\nnuRunQuery($s);\n\nunlink(\'tmp/\' . $J[0]->name);\n','','function captureImageClip() {\n    var htmlContent = document.getElementById(\'display_image_clip_textarea\').value;\n    window.prompt (\"Copy to clipboard: Ctrl+C, Enter\", htmlContent);\n}\n\nfunction nuLoadEdit() {\n    nuFORM.FILES = null;\n}\n','',0,0,'0000-00-00 00:00:00','','2014-02-19 10:35:14','globeadmin','2014-02-19 10:35:14','globeadmin','browse',0,NULL),('nuindex','ind','Index','SELECT * FROM zzzsys_debug','zzzsys_debug','zzzsys_debug_id',900,0,'','0','0','0','0','','','','','','','','','','','','','','','','','','$s = \"\n\n    SELECT * \n    FROM zzzsys_setup\n    WHERE zzzsys_setup_id = \'1\'\n\n\";\n\n$t = nuRunQuery($s);\n\n$r = db_fetch_object($t);\n\nif($r->set_splash != \'1\'){\n\n    $nb = \'<strong><strong><span style=\"color: #78C13A; text-shadow: 1px 1px #D0D7D1;\">nu</span><span style=\"color: #03AAE9; text-shadow: 1px 1px #D0D7D1;\">Builder</span></strong><span style=\"color: #FB0003; text-shadow: 1px 1px #D0D7D1;\"><i>Pro</i></span></strong>\';\n\n    $h = \'<img id=\"talkingmike\" style=\"position:absolute;left:10px;top:10px\" src=\"mike.png\" width=\"64\" height=\"133\">\';\n    $h = $h . \'<div id=\"miketalking\" style=\"position:absolute;left:100px;top:10px\">\';\n    $h = $h . \'Hi, welcome to \' . $nb . \'.<br><br>The easiest way to get started<br>with \' . $nb . \' is with a <strong>Fast Form</strong>.<br><br>\';\n    $h = $h . \'To learn how to create a <strong>Fast Form</strong> please<br>check out this video.<br><br>\';\n    $h = $h . \'<a href=\"https://www.youtube.com/watch?v=P7SHJtikcTM\" target=\"_blank\"><strong>Here</strong></a>\';\n    $h = $h . \'</div>\';\n    $h = $h . \'<div  style=\"position:absolute;left:50px;top:200px\"><input type=\"checkbox\" id=\"nuCheckClose\"> Do not show this message again</div>\';\n    $h = $h . \'<input id=\"closesplash\" onclick=\"nuCloseSplash()\" type=\"button\" value=\"OK\" style=\"background-color:#7CC342;color:white;padding:2px;position:absolute;left:350px;top:200px;width:50px\"/>\';\n\n    \n    $j = \"\n\n	var e = document.createElement(\'div\');\n	\n	e.setAttribute(\'id\', \'nuSplash\');\n	\n	$(\'#nu_tab_area0\').append(e);\n	\n	$(\'#nuSplash\').css({\n		\'width\'            : 450,\n		\'height\'           : 250,\n		\'top\'              : -10,\n		\'left\'             : 250,\n		\'position\'         : \'absolute\',\n		\'background-color\' : \'white\',\n		\'color\'            : \'black\',\n		\'z-index\'          : 5000,\n		\'border-width\'     : \'1px\',\n		\'border-color\'     : \'black\',\n		\'border-style\'     : \'solid\',\n		\'filter\'           : \'Alpha(Opacity=100)\',\n		\'opacity\'          : \'1\',\n		\'box-shadow\'       : \'5px 5px 5px #888888\'\n	})\n\n	$(\'#nuSplash\').html(\'$h\');\n\n    \n    \";\n\n    nuAddJavascript($j);\n    \n}\n\n','nuRunQuery(\"UPDATE zzzsys_setup SET set_splash = \'1\'\");','','function nuLoadEdit() { \n    \n    $(\'#homeform\').css(\'background-color\',\'#7CC342\');\n    \n    $(\'#fafbtn\').attr(\'title\',\"Create a Form and it\'s Table with no programming\");\n\n}\n\nfunction nuCloseSplash(){\n    \n    var s = $(\'#nuCheckClose\').is(\':checked\');\n    \n    $(\'#nuSplash\').remove();\n\n    if(s){\n        nuSaveForm();        \n    }\n\n}','',0,0,'0000-00-00 00:00:00','','2015-04-20 10:12:37','globeadmin','2015-04-20 10:12:37','globeadmin','browse',0,NULL),('nuobject','obj','nuBuilder Objects','SELECT form_name, zzzsys_object.* \nFROM zzzsys_object\nINNER JOIN #TABLE_ID# ON zzzsys_object.sob_zzzsys_form_id = #TABLE_ID#.form_id \nORDER BY form_name, sob_all_tab_number, sob_all_column_number, sob_all_order_number \n','zzzsys_object','zzzsys_object_id',1000,0,'','1','1','1','1','','1','','','','','','','','','','','','','$f        = \'#sob_zzzsys_form_id#\';\r\n$n        = \'#sob_all_name#\';\r\n$id       = \'#RECORD_ID#\';\r\n$iscloned = \'#nu_cloned_record#\';\r\n$s        = \"SELECT zzzsys_object_id, sob_all_type, sob_all_name FROM zzzsys_object WHERE sob_zzzsys_form_id = ? AND sob_all_name = ? \";\r\n\r\nif( $iscloned == 0 ) {\r\n    $s   .= \"AND zzzsys_object_id != ? \";\r\n    $t    = nuRunQuery($s, array($f, $n, $id));\r\n}else{\r\n    $t    = nuRunQuery($s, array($f, $n));\r\n}\r\n$r        = db_fetch_object($t);\r\nif($r->zzzsys_object_id != \'\'){\r\n\r\n        $MESS = \"There is already an Object with the Field Name $r->sob_all_name\"; \r\n        nuDisplayError($MESS);\r\n}\r\n\r\nif( preg_match(\'/[[:blank:]]/\', $n) === 1 ) {\r\n    $MESS = \"Field name cannot contain space characters\";\r\n    nuDisplayError($MESS);\r\n}\r\n\r\nif(\'#sob_all_type#\' == \'iframe\'){\r\n\r\n    if(\'#sob_iframe_zzzsys_php_id#\' == \'\' and \'#sob_iframe_zzzsys_report_id#\' == \'\'){\r\n\r\n        $MESS = \"Both PHP to Run and Report to Run cannot be left blank..  (TAB : iFrame)\"; \r\n        nuDisplayError($MESS);\r\n    }\r\n\r\n}\r\n\r\nif(\'#sob_all_type#\' == \'browse\'){\r\n    if(\'#sob_browse_zzzsys_form_id#\' == \'\'){\r\n\r\n        $MESS = \"Browse cannot be left blank..  (TAB : Browse)\"; \r\n        nuDisplayError($MESS);\r\n    }\r\n\r\n    if(\'#sob_all_width#\' == \'\' or \'#sob_all_width#\' == \'0\'){\r\n\r\n        $MESS = \"Width must be over zero..  (TAB : All)\"; \r\n        nuDisplayError($MESS);\r\n    }\r\n    \r\n}\r\n\r\n\r\nif(\'#sob_all_type#\' == \'button\'){\r\n\r\n    if(\'#sob_all_width#\' == \'\' or \'#sob_all_width#\' == \'0\'){\r\n\r\n        $MESS = \"Width must be over zero..  (TAB : All)\"; \r\n        nuDisplayError($MESS);\r\n    }\r\n\r\n}\r\n\r\nif(\'#sob_all_type#\' == \'display\'){\r\n\r\n    if(\'#sob_all_width#\' == \'\' or \'#sob_all_width#\' == \'0\'){\r\n\r\n        $MESS = \"Width must be over zero..  (TAB : All)\"; \r\n        nuDisplayError($MESS);\r\n    }\r\n\r\n    if(\'#sob_display_sql#\' == \'\'){\r\n\r\n        $MESS = \"SQL cannot be left blank..  (TAB : Display)\"; \r\n        nuDisplayError($MESS);\r\n    }\r\n\r\n}\r\n\r\nif(\'#sob_all_type#\' == \'dropdown\'){\r\n\r\n    if(\'#sob_all_width#\' == \'\' or \'#sob_all_width#\' == \'0\'){\r\n\r\n        $MESS = \"Width must be over zero..  (TAB : All)\"; \r\n        nuDisplayError($MESS);\r\n\r\n    }\r\n    if(\'#sob_dropdown_sql#\' == \'\'){\r\n\r\n        $MESS = \"SQL cannot be left blank..  (TAB : Dropdown)\"; \r\n        nuDisplayError($MESS);\r\n\r\n    }\r\n}\r\n\r\nif(\'#sob_all_type#\' == \'html\'){\r\n\r\n    if(\'#sob_all_width#\' == \'\' or \'#sob_all_width#\' == \'0\'){\r\n\r\n        $MESS = \"Width must be over zero..  (TAB : All)\"; \r\n        nuDisplayError($MESS);\r\n\r\n    }\r\n\r\n\r\n    if(\'#sob_html_code#\' == \'\'){\r\n\r\n        $MESS = \"HTML cannot be left blank..  (TAB : HTML)\"; \r\n        nuDisplayError($MESS);\r\n\r\n    }\r\n\r\n}\r\n\r\n\r\nif(\'#sob_all_type#\' == \'listbox\'){\r\n\r\n    if(\'#sob_all_width#\' == \'\' or \'#sob_all_width#\' == \'0\'){\r\n\r\n        $MESS = \"Width must be over zero..  (TAB : All)\"; \r\n        nuDisplayError($MESS);\r\n\r\n    }\r\n\r\n    if(\'#sob_listbox_sql#\' == \'\'){\r\n\r\n        $MESS = \"SQL cannot be left blank..  (TAB : Listbox)\"; \r\n        nuDisplayError($MESS);\r\n\r\n    }\r\n\r\n}\r\nif(\'#sob_all_type#\' == \'lookup\'){\r\n\r\n    if(\'#sob_lookup_id_field#\' == \'\'){\r\n\r\n        $MESS = \"ID Field cannot be left blank..  (TAB : Lookup)\"; \r\n        nuDisplayError($MESS);\r\n\r\n    }\r\n\r\n    if(\'#sob_lookup_code_field#\' == \'\'){\r\n\r\n        $MESS = \"Code Field cannot be left blank..  (TAB : Lookup)\"; \r\n        nuDisplayError($MESS);\r\n\r\n    }\r\n\r\n    if(\'#sob_lookup_description_field#\' == \'\'){\r\n\r\n        $MESS = \"Description Field cannot be left blank..  (TAB : Lookup)\"; \r\n        nuDisplayError($MESS);\r\n\r\n    }\r\n\r\n    if(\'#codesob_lookup_zzzsys_form_id#\' == \'\'){\r\n\r\n        $MESS = \"Form to Lookup cannot be left blank..  (TAB : Lookup)\"; \r\n        nuDisplayError($MESS);\r\n\r\n    }\r\n\r\n    if(\'#sob_lookup_code_width#\' == \'\' or \'#sob_lookup_code_width#\' == \'0\'){\r\n\r\n        $MESS = \"Code Width must be over zero..  (TAB : Lookup)\"; \r\n        nuDisplayError($MESS);\r\n\r\n    }\r\n\r\n}\r\nif(\'#sob_all_type#\' == \'subform\'){\r\n\r\n    if(\'#sob_all_width#\' == \'\' or \'#sob_all_width#\' == \'0\'){\r\n\r\n        $MESS = \"Width must be over zero..  (TAB : All)\"; \r\n        nuDisplayError($MESS);\r\n\r\n    }\r\n\r\n\r\n}\r\nif(\'#sob_all_type#\' == \'text\'){\r\n\r\n    if(\'#sob_all_width#\' == \'\' or \'#sob_all_width#\' == \'0\'){\r\n\r\n        $MESS = \"Width must be over zero..  (TAB : All)\"; \r\n        //nuDisplayError($MESS);\r\n\r\n    }\r\n\r\n}\r\nif(\'#sob_all_type#\' == \'textarea\'){\r\n\r\n    if(\'#sob_all_width#\' == \'\' or \'#sob_all_width#\' == \'0\'){\r\n\r\n        $MESS = \"Width must be over zero..  (TAB : All)\"; \r\n        nuDisplayError($MESS);\r\n\r\n    }\r\n\r\n}\r\nif(\'#sob_all_type#\' == \'words\'){\r\n\r\n    if(\'#sob_all_width#\' == \'\' or \'#sob_all_width#\' == \'0\'){\r\n\r\n        $MESS = \"Width must be over zero..  (TAB : All)\"; \r\n        nuDisplayError($MESS);\r\n\r\n    }\r\n\r\n}\r\n','$sql  = \"\r\n\r\nCREATE TABLE #TABLE_ID# \r\nSELECT zzzsys_form_id AS form_id, \r\nCONCAT(sfo_name, \' (form)\') AS form_name \r\nFROM zzzsys_form \r\nWHERE (zzzsys_form_id NOT LIKE \'#nu_denied#\' OR zzzsys_form_id = \'nuhome\')\r\n\r\n\";\r\n\r\nnuRunQuery($sql);\r\n\r\n$sql  = \"\r\n\r\nINSERT INTO #TABLE_ID# \r\nSELECT zzzsys_object_id AS form_id,\r\nCONCAT(sob_all_name,\' (subform)\') AS form_name \r\nFROM zzzsys_object \r\nWHERE sob_all_type = \'subform\'\r\nAND sob_zzzsys_form_id NOT LIKE \'#nu_denied#\'\";\r\n\r\nnuRunQuery($sql);\r\n','','','','','\r\n\r\nfunction nuLoadBrowse(){\r\n\r\n    for(var RW = 0 ; RW < nuBrowseRows() ; RW ++){\r\n\r\n        var B = nuGridValue(RW, 3);\r\n\r\n        if(B != \'\'){\r\n            nuGridClass(RW, 3, \'nu_\'+B, false);\r\n            nuGridClass(RW, 3, \'nuBrowseCell\', true);\r\n            nuGridClass(RW, 3, \'nuSelectedTab\', true);\r\n        }\r\n\r\n    }\r\n    \r\n}\r\n\r\nfunction nuLoadEdit(){\r\n\r\n    $(\'#sob_all_type\').addClass(\'nu_\'+$(\'#sob_all_type\').val());\r\n    \r\n    $(\"#sob_all_type > option\").each(function() {\r\n        $(this).addClass(\'nu_\'+this.value);\r\n    });\r\n\r\n\r\n    $(\"textarea[id*=\'sql\']\").css(\'background-color\', \'#D2F4D5\');\r\n    $(\"textarea[id*=\'sql\']\").css(\'font-family\', \'Courier New\');\r\n    $(\"textarea[id*=\'sql\']\").css(\'font-size\', \'14px\');\r\n    $(\"textarea[id*=\'sql\']\").attr( \'wrap\', \'off\');\r\n\r\n    $(\"#sob_lookup_php\").css(\'background-color\', \'#FFE8CA\');\r\n    $(\"#sob_lookup_php\").css(\'font-family\', \'Courier New\');\r\n    $(\"#sob_lookup_php\").css(\'font-size\', \'14px\');\r\n    $(\"#sob_lookup_php\").attr( \'wrap\', \'off\');\r\n\r\n    $(\"#sob_all_display_condition\").css(\'background-color\', \'#D2F4D5\');\r\n    $(\"#sob_all_display_condition\").css(\'font-family\', \'Courier New\');\r\n    $(\"#sob_all_display_condition\").css(\'font-size\', \'14px\');\r\n    $(\"#sob_all_display_condition\").attr( \'wrap\', \'off\');\r\n\r\n    $(\"textarea[id*=\'javascript\']\").css(\'background-color\', \'#CAE1FF\');\r\n    $(\"textarea[id*=\'javascript\']\").css(\'font-family\', \'Courier New\');\r\n    $(\"textarea[id*=\'javascript\']\").css(\'font-size\', \'14px\');\r\n    $(\"textarea[id*=\'javascript\']\").attr( \'wrap\', \'off\');\r\n\r\n    $(\"#sob_html_code\").css(\'background-color\', \'#FDD0DF\');\r\n    $(\"#sob_html_code\").css(\'font-family\', \'Courier New\');\r\n    $(\"#sob_html_code\").css(\'font-size\', \'14px\');\r\n    $(\"#sob_html_code\").attr( \'wrap\', \'off\');\r\n\r\n    nuHideTabs();\r\n    \r\n}\r\n\r\n    \r\n\r\nfunction nuHideTabs(){\r\n\r\n	var t = $(\'#sob_all_type\').val();\r\n	\r\n	for(var i = 0 ; i < 12 ; i++){\r\n		$(\'#tab\'+i).css(\'color\',\'\');\r\n	}\r\n	\r\n	$(\'#tab0\').css(\'color\',\'red\');\r\n	$(\'#tab1\').css(\'color\',\'red\');\r\n\r\n	if(t == \'browse\'){\r\n		$(\'#tab10\').css(\'color\',\'red\');\r\n		$(\'#tab1\').css(\'color\',\'\');\r\n	}\r\n	if(t == \'button\'){\r\n		$(\'#tab2\').css(\'color\',\'red\')\r\n	}\r\n	if(t == \'display\'){\r\n		$(\'#tab3\').css(\'color\',\'red\')\r\n	}\r\n	if(t == \'dropdown\'){\r\n		$(\'#tab4\').css(\'color\',\'red\')\r\n	}\r\n	if(t == \'html\'){\r\n		$(\'#tab9\').css(\'color\',\'red\')\r\n		$(\'#tab1\').css(\'color\',\'\');\r\n	}\r\n	if(t == \'iframe\'){\r\n		$(\'#tab11\').css(\'color\',\'red\')\r\n		$(\'#tab1\').css(\'color\',\'\');\r\n	}\r\n	if(t == \'listbox\'){\r\n		$(\'#tab5\').css(\'color\',\'red\')\r\n	}\r\n	if(t == \'lookup\'){\r\n		$(\'#tab6\').css(\'color\',\'red\')\r\n		$(\'#tab1\').css(\'color\',\'\');\r\n	}\r\n	if(t == \'subform\'){\r\n		$(\'#tab7\').css(\'color\',\'red\')\r\n	}\r\n	if(t == \'text\'){\r\n		$(\'#tab8\').css(\'color\',\'red\')\r\n	}\r\n\r\n}\r\n\r\n\r\n','',0,0,'0000-00-00 00:00:00','','2014-02-05 10:30:57','globeadmin','2014-02-05 10:30:57','globeadmin','browse',0,NULL),('5711e1d915f5011','send_sms','Αποστολή SMS σε έναν αριθμό τηλεφώνου','select * from teacher','teacher','id',700,450,'select \'Αποστολή SMS σε Αριθμό Τηλεφώνου\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function display_sent_result(param){\n    hideLoader();\n    alert(param);\n    nuRemoveModal();\n}\n\nfunction nuLoadEdit() {\n    \n    if(typeof parent.create_sms_text === \'function\'){\n        $(\'#sms_text\').val(parent.create_sms_text());\n    }\n\n    $(\'#reciever_name\').css(\'fontSize\', \'16px\');\n    $(\'#reciever_name\').css(\'font-weight\', \'bold\');\n    $(\'#reciever_name\').css(\'background-color\', \'#FAF0E6\');\n    $(\'#reciever_name\').css(\'color\', \'#25237A\');\n    \n    $(\'#mobile_number\').css(\'fontSize\', \'16px\');\n    $(\'#mobile_number\').css(\'font-weight\', \'bold\');\n    $(\'#mobile_number\').css(\'background-color\', \'#FAF0E6\');\n    $(\'#mobile_number\').css(\'color\', \'#25237A\');\n\n    $(\'#sms_text\').css(\'fontSize\', \'16px\');\n    $(\'#sms_text\').css(\'font-weight\', \'bold\');\n    $(\'#sms_text\').css(\'background-color\', \'LightYellow\');\n    $(\'#sms_text\').css(\'color\', \'#25237A\');\n\n    $(\'#sms_disp\').css(\'fontSize\', \'16px\');\n    $(\'#sms_disp\').css(\'font-weight\', \'bold\');\n    $(\'#sms_disp\').css(\'background-color\', \'#FAF0E6\');\n    $(\'#sms_disp\').css(\'color\', \'red\');\n    \n    $(\'#sms_text\').attr(\'maxlength\',$(\'#max_num_of_chars\').val());\n    \n    $(\'#num_of_chars_left\').val($(\'#max_num_of_chars\').val() - $(\'#sms_text\').val().length);\n    \n    $(\'#num_of_chars_left\').css(\'fontSize\', \'10px\');\n    $(\'#num_of_chars_left\').css(\'font-weight\', \'bold\');\n    $(\'#num_of_chars_left\').css(\'background-color\', \'#FAF0E6\');\n    \n    \n}',NULL,0,0,'2016-04-16 09:55:21','globeadmin','2021-03-24 11:17:49','globeadmin','2021-03-24 11:17:49','globeadmin','',0,NULL),('571354ed43a4d47','message_center','Κέντρο Αποστολής Μηνυμάτων','select * from teachers','teacher','id',1000,520,'select \'Κέντρο Αποστολής Μηνυμάτων\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'','nuRunPHP(\'check_permission_lib\');\n\nif(!check_permission(\'1\')){\n    $MESSAGE = \'Προσοχή! Δεν έχετε άδεια πρόσβασης στα δεδομένα αυτά!\';\n    nuDisplayError($MESSAGE);\n    return;\n}\n',NULL,NULL,'function foo(param){\n    ;\n}\nfunction pass_session_variable(param){\n    nuSetHash(\'varval\', param);\n}\nfunction get_session_variable(varname){\n    nuSetHash(\'varname\', varname);\n    nuAjax(\'getSessionVariable\',\'pass_session_variable\');\n    return nuGetHash(\'varval\');\n}\nfunction set_session_variable(varname,varval){\n    nuSetHash(\'varname\', varname);\n    nuSetHash(\'varval\', varval);\n    nuAjax(\'setSessionVariable\',\'foo\');\n}\n\nfunction loadImg(img_name) { \n    i = new Image(); \n    i.src = \'images/\'+img_name+\'.png\';\n    \n    ib = new Image(); \n    ib.src = \'images/\'+img_name+\'b.png\';    \n}\n\nfunction nuLoadEdit() {  \n    loadImg(\'sms_search\');\n    loadImg(\'students_sms\');\n    loadImg(\'students_email\');\n    loadImg(\'teachers_sms\');\n    loadImg(\'teachers_email\');\n    loadImg(\'search_email\');\n    loadImg(\'notification\');\n}',NULL,0,0,'2016-04-17 12:18:37','globeadmin','2017-11-12 16:18:13','globeadmin','2017-11-12 16:18:13','globeadmin','',0,NULL),('5713df2963f613a','sms_search','Αναζήτηση Σταλθέντων SMS','select * from teacher','teacher','id',960,570,'select \'Αναζήτηση Σταλθέντων SMS\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function foo(param){\n    ;\n}\nfunction pass_session_variable(param){\n    nuSetHash(\'varval\', param);\n}\nfunction get_session_variable(varname){\n    nuSetHash(\'varname\', varname);\n    nuAjax(\'getSessionVariable\',\'pass_session_variable\');\n    return nuGetHash(\'varval\');\n}\nfunction set_session_variable(varname,varval){\n    nuSetHash(\'varname\', varname);\n    nuSetHash(\'varval\', varval);\n    nuAjax(\'setSessionVariable\',\'foo\');\n}\n\nfunction nuLoadEdit() {\n    \n    var all_teacher_ids = [];\n    var all_teacher_names = [];\n\n    var s = document.getElementById(\'teacher_id\');\n \n    for (var i = 0; i < s.options.length; i++) {\n        \n        var teacher_id=s.options[i].value;\n        var teacher_name=s.options[i].text;\n        \n        all_teacher_ids.push(teacher_id);\n        all_teacher_names.push(teacher_name);\n        }\n    \n    $(\'#teacher_id\').empty();\n    $(\'#teacher_id\').append(\"<option value=\'\'></option>\");\n    $(\'#teacher_id\').append(\"<option value=0>Εξαίρεση Καθηγητών</option>\");\n    \n    for(i=0;i<all_teacher_ids.length;i++){\n        if(all_teacher_names[i]!=\'\'){\n            $(\'#teacher_id\').append(\'<option value=\"\'+all_teacher_ids[i]+\'\">\'+all_teacher_names[i]+\'</option>\'); \n            }\n        }    \n\n    var all_student_ids = [];\n    var all_student_names = [];\n\n    s = document.getElementById(\'student_id\');\n \n    for (i = 0; i < s.options.length; i++) {\n        \n        var student_id=s.options[i].value;\n        var student_name=s.options[i].text;\n        \n        all_student_ids.push(student_id);\n        all_student_names.push(student_name);\n        }\n    \n    $(\'#student_id\').empty();\n    $(\'#student_id\').append(\"<option value=\'\'></option>\");\n    $(\'#student_id\').append(\"<option value=0>Εξαίρεση Μαθητών</option>\");\n    \n    for(i=0;i<all_student_ids.length;i++){\n        if(all_student_names[i]!=\'\'){\n            $(\'#student_id\').append(\'<option value=\"\'+all_student_ids[i]+\'\">\'+all_student_names[i]+\'</option>\'); \n            }\n        }\n        \n    $(\'#sender_id\').val(\'#RECORD_ID#\');\n    $(\'#from_date\').val($(\'#current_date\').val());\n    $(\'#to_date\').val($(\'#current_date\').val());\n    nuFORM.edited = 0;\n}',NULL,0,0,'2016-04-17 22:08:25','globeadmin','2018-07-13 09:42:51','globeadmin','2019-07-27 13:10:00','globeadmin','',0,NULL),('5719cb61e92d4e8','student_sent_sms','Μαζική Αποστολή SMS σε Μαθητές','select * from teacher','teacher','id',960,650,'select \'Μαζική Αποστολή SMS σε Μαθητές\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function display_sent_result(param){\n    hideLoader();\n    alert(param);\n}\n\nfunction nuLoadEdit() {\n\n    sumoTransform(\'class_id\',false,false);\n    sumoTransform(\'student_id\',true,true);\n\n    $(\'#sms_text\').css(\'fontSize\', \'16px\');\n    $(\'#sms_text\').css(\'font-weight\', \'bold\');\n    $(\'#sms_text\').css(\'background-color\', \'LightYellow\');\n    $(\'#sms_text\').css(\'color\', \'#25237A\');\n\n    $(\'#sms_disp\').css(\'fontSize\', \'16px\');\n    $(\'#sms_disp\').css(\'font-weight\', \'bold\');\n    $(\'#sms_disp\').css(\'background-color\', \'#FAF0E6\');\n    $(\'#sms_disp\').css(\'color\', \'red\');\n    \n    $(\'#sms_text\').attr(\'maxlength\',$(\'#max_num_of_chars\').val());\n    \n    $(\'#num_of_chars_left\').val($(\'#max_num_of_chars\').val());\n    \n    $(\'#num_of_chars_left\').css(\'fontSize\', \'10px\');\n    $(\'#num_of_chars_left\').css(\'font-weight\', \'bold\');\n    $(\'#num_of_chars_left\').css(\'background-color\', \'#FAF0E6\');\n    \n}',NULL,0,0,'2016-04-22 09:57:37','globeadmin','2021-03-24 11:18:48','globeadmin','2021-03-24 11:18:48','globeadmin','',0,NULL),('571bae293e43d23','teacher_sent_sms','Μαζική Αποστολή SMS σε Καθηγητές','select * from teacher','teacher','id',960,650,'select \'Μαζική Αποστολή SMS σε Καθηγητές\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function display_sent_result(param){\n    hideLoader();\n    alert(param);\n}\n\nfunction nuLoadEdit() {\n\n    sumoTransform(\'teacher_id\',false,true);\n    sumoTransform(\'select_teaching_field_id\',false,true);\n\n    $(\'#sms_text\').css(\'fontSize\', \'16px\');\n    $(\'#sms_text\').css(\'font-weight\', \'bold\');\n    $(\'#sms_text\').css(\'background-color\', \'LightYellow\');\n    $(\'#sms_text\').css(\'color\', \'#25237A\');\n\n    $(\'#sms_disp\').css(\'fontSize\', \'16px\');\n    $(\'#sms_disp\').css(\'font-weight\', \'bold\');\n    $(\'#sms_disp\').css(\'background-color\', \'#FAF0E6\');\n    $(\'#sms_disp\').css(\'color\', \'red\');\n    \n    $(\'#sms_text\').attr(\'maxlength\',$(\'#max_num_of_chars\').val());\n    \n    $(\'#num_of_chars_left\').val($(\'#max_num_of_chars\').val());\n    \n    $(\'#num_of_chars_left\').css(\'fontSize\', \'10px\');\n    $(\'#num_of_chars_left\').css(\'font-weight\', \'bold\');\n    $(\'#num_of_chars_left\').css(\'background-color\', \'#FAF0E6\');\n    \n}',NULL,0,0,'2016-04-23 20:17:29','globeadmin','2021-03-24 11:22:33','globeadmin','2021-03-24 11:22:33','globeadmin','',0,NULL),('572af54adfe5517','student_sent_email','Μαζική Αποστολή Email σε Μαθητές','select * from teacher','teacher','id',960,1730,'select \'Μαζική Αποστολή Email σε Μαθητές\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function display_sent_result(param){\n    hideLoader();\n    alert(param);\n}\n\nfunction passTinymceContents(){\n    return(\'\');\n}\n\nfunction nuLoadEdit() {\n    sumoTransform(\'class_id\',false,false);\n    sumoTransform(\'student_id\',true,true);\n    nuSetHash(\'FILES\' , \'\');\n}',NULL,0,0,'2016-05-05 10:24:58','globeadmin','2017-03-14 21:02:13','globeadmin','2021-12-11 20:34:13','globeadmin','',0,NULL),('572b615e795d4d1','teacher_sent_email','Μαζική Αποστολή Email σε Καθηγητές','select * from teacher','teacher','id',960,1070,'select \'Μαζική Αποστολή Email σε Καθηγητές\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function display_sent_result(param){\n    hideLoader();\n    alert(param);\n}\n\nfunction passTinymceContents(){\n    //var y = document.getElementById(\'email_text\').value;\n    //return(y);\n    return(\'\');\n}\n\nfunction nuLoadEdit() {\n    sumoTransform(\'teacher_id\',false,true);\n    sumoTransform(\'select_teaching_field_id\',false,true);\n    nuSetHash(\'FILES\' , \'\');\n}',NULL,0,0,'2016-05-05 18:06:06','globeadmin','2018-07-01 00:17:26','globeadmin','2021-02-27 09:46:00','globeadmin','',0,NULL),('57348bba8a00051','unjustify_absence','Ξε-Δικαιολόγηση Απουσιών μιας Μέρας ενός Μαθητή','select * from teacher','teacher','id',960,520,'select \'Ξε-Δικαιολόγηση Απουσιών μιας Μέρας ενός Μαθητή\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function show_ajax_result(param){\n    if(param) {alert(param);}\n}\n\nfunction show_lesson(){\n    var s = document.getElementById(\'student\');\n    var std=s.value;\n\n    var d = document.getElementById(\'absence_date\');\n    var ad=d.value;\n\n    if(ad!=\'\' && std!=\'\'){\n        nuRunPHP(\'student_day_absences\',\'search_iframe\');\n    }\n}',NULL,0,0,'2016-05-12 16:57:14','globeadmin','2016-05-12 18:01:40','globeadmin','2018-07-12 23:29:19','globeadmin','',0,NULL),('57400922b87c65a','critirion_general','Γενικά Κριτήρια Αξιολόγησης','SELECT critirion_general.*, sp_short_name,g_short_name\nFROM critirion_general\nleft join \n    (   select id as sp_id, \n        short_name as sp_short_name \n        from  speciality) as sp on critirion_general.speciality_id = sp.sp_id\nleft join \n    (   select id as g_id, \n        short_name as g_short_name \n        from  grade) as g on critirion_general.grade_id = g.g_id\ninner join session_variables on session_variables.session_id=\'#session_id#\'\nwhere (critirion_general.teacher_id=session_variables.teacher_id OR (\'#nu_user_group#\' IN (\'Managers\',\'AssistManagers\',\'Administrators\',\'Secretaries\',\'globeadmin\')))\norder by sp_short_name,g_short_name,name','critirion_general','id',960,600,'select name\nfrom critirion_general\nwhere id=\'#RECORD_ID#\'','1','1','1',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'if(\'#nu_user_group#\'!=\'Managers\' && \'#nu_user_group#\'!=\'AssistManagers\' && \'#nu_user_group#\'!=\'Administrators\' && \'#nu_user_group#\'!=\'globeadmin\'){\n    $sql = \"    SELECT COUNT(*)\n                FROM mark_critirion_special_level\n                INNER JOIN critirion_special ON mark_critirion_special_level.critirion_special_id=critirion_special.id\n                INNER JOIN critirion_general ON critirion_special.critirion_general_id = critirion_general.id\n                WHERE critirion_general.id = \'#RECORD_ID#\'\n        \";\n        \n    $retval = nuRunQuery($sql);\n    $row    = db_fetch_row($retval);\n    if($row[0]!=0){\n        $MESSAGE = \'Προσοχή : Υπάρχουν αξιολογήσεις με αυτό το γενικό κριτήριο! Το κριτήριο δε μπορεί να τροποποιηθεί!\';\n        nuDisplayError($MESSAGE);\n        return;    \n    }	\n\n    $sql = \"    SELECT COUNT(*)\n                FROM subject_critirion_general\n                WHERE critirion_general_id = \'#RECORD_ID#\'\n        \";\n        \n    $retval = nuRunQuery($sql);\n    $row    = db_fetch_row($retval);\n    if($row[0]!=0){\n        $MESSAGE = \'Προσοχή : Υπάρχουν μαθήματα συσχετιζόμενα με αυτό το γενικό κριτήριο! ο κριτήριο δε μπορεί να τροποποιηθεί!\';\n        nuDisplayError($MESSAGE);\n        return;    \n    }\n}\n',NULL,'$sql = \"    SELECT COUNT(*)\n            FROM mark_critirion_special_level\n            INNER JOIN critirion_special ON mark_critirion_special_level.critirion_special_id=critirion_special.id\n            INNER JOIN critirion_general ON critirion_special.critirion_general_id = critirion_general.id\n            WHERE critirion_general.id = \'#RECORD_ID#\'\n        \";\n        \n$retval = nuRunQuery($sql);\n$row    = db_fetch_row($retval);\nif($row[0]!=0){\n    $MESSAGE = \'Προσοχή : Υπάρχουν αξιολογήσεις με αυτό το γενικό κριτήριο! Η διαγραφή δε μπορεί να πραγματοποιηθεί!\';\n    nuDisplayError($MESSAGE);\n    return;    \n}	\n\n$sql = \"    SELECT COUNT(*)\n            FROM subject_critirion_general\n            WHERE critirion_general_id = \'#RECORD_ID#\'\n        \";\n        \n$retval = nuRunQuery($sql);\n$row    = db_fetch_row($retval);\nif($row[0]!=0){\n    $MESSAGE = \'Προσοχή : Υπάρχουν μαθήματα συσχετιζόμενα με αυτό το γενικό κριτήριο! Η διαγραφή δε μπορεί να πραγματοποιηθεί!\';\n    nuDisplayError($MESSAGE);\n    return;    \n}\n',NULL,'if(\'#ids#\'!=\'\' && \'#ids#\'!=\'#\'.\'ids#\'){\n    $ids = explode(\",\", \'#ids#\');\n    $i=1;\n    foreach($ids as $id) {\n        $sql=\"update critirion_special set hierarchy=\'\".$i.\"\' where id=\'\".$id.\"\'\";\n        nuRunQuery($sql);\n        $i++;    \n    }\n}','$sql = \"    DELETE critirion_special_level\n            FROM critirion_special_level\n            INNER JOIN critirion_special ON critirion_special_level.critirion_special_id = critirion_special.id\n            WHERE critirion_special.critirion_general_id = \'#RECORD_ID#\'\n        \";\nnuRunQuery($sql);\n\n\n$sql = \"    DELETE\n            FROM critirion_special\n            WHERE critirion_general_id = \'#RECORD_ID#\'\n        \";\nnuRunQuery($sql);\n','function foo(param){\n    ;\n}\nfunction pass_session_variable(param){\n    nuSetHash(\'varval\', param);\n}\nfunction get_session_variable(varname){\n    nuSetHash(\'varname\', varname);\n    nuAjax(\'getSessionVariable\',\'pass_session_variable\');\n    return nuGetHash(\'varval\');\n}\nfunction set_session_variable(varname,varval){\n    nuSetHash(\'varname\', varname);\n    nuSetHash(\'varval\', varval);\n    nuAjax(\'setSessionVariable\',\'foo\');\n}\n\nfunction on_clone(param){\n    alert(\'Το κριτήριο κλωνοποιήθηκε επιτυχώς!\');\n    nuOpenForm(\'57400922b87c65a\',\'#RECORD_ID#\', \'57400922b87c65a\', param,\'\');    \n}\n\nfunction nuLoadEdit() {\n    if(\'#RECORD_ID#\'!=\'-1\'){\n        \n        set_session_variable(\'critirion_general_id\',\'#RECORD_ID#\');\n        \n        var x = document.getElementById(\'name\');\n        var y = document.getElementById(\'description\');\n        \n        set_session_variable(\'critirion_general_full_name\',x.value+\' - \'+y.value);\n    } else {\n        var teacher_id = get_session_variable(\'teacher_id\');\n        var z = document.getElementById(\'teacher_id\');\n        z.value = teacher_id;\n    }\n    \n    $(\'#label1\').css(\"fontSize\", \"10px\");\n    $(\'#label1\').css(\'font-style\', \'italic\');\n}\n\nfunction nuOnSave() {\n\n    var iframe = document.getElementById(\'search_iframe\');\n    var innerDoc = (iframe.contentDocument) ? iframe.contentDocument : iframe.contentWindow.document;\n    \n    var x = innerDoc.getElementsByClassName(\"critiria\");\n    \n    var i;\n    ids=\'\';\n    for (i = 0; i < x.length; i++) {\n        ids=(ids==\'\' ? ids=x[i].id : ids+\',\'+x[i].id);\n    }\n    nuSetHash(\'ids\', ids)\n    return true;\n}',NULL,35,30,'0000-00-00 00:00:00','','2018-07-14 00:22:29','globeadmin','2020-09-18 01:08:15','globeadmin','',0,NULL),('578e9b35d4d3cf8','send_teacher_email','Αποστολή Email σε Καθηγητή','select * from teacher','teacher','id',850,570,'select \'Αποστολή Email σε Καθηγητή\'','0','0','0',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function passTinymceContents(){ \n    return(\'\');\n}\n\nfunction display_sent_result(param){\n    hideLoader();\n    alert(param);\n}\n\nfunction nuLoadEdit() {\n\n    var all_teacher_ids = [];\n    var all_teacher_names = [];\n\n    var s = document.getElementById(\"student_home_school_teacher_email\");\n \n    for (var i = 0; i < s.options.length; i++) {\n        \n        var teacher_id=s.options[i].value;\n        var teacher_name=s.options[i].text;\n        \n        all_teacher_ids.push(teacher_id);\n        all_teacher_names.push(teacher_name);\n        }\n    \n    $(\'#student_home_school_teacher_email\').empty();\n    $(\'#student_home_school_teacher_email\').append(\"<option value=-1>Τη Διεύθυνση του Σχολείου</option>\");\n    //$(\'#student_home_school_teacher_email\').append(\"<option value=0>Όλους τους Καθηγητές</option>\");\n    \n    for(i=0;i<all_teacher_ids.length;i++){\n        if(all_teacher_names[i]!=\'\'){\n            $(\'#student_home_school_teacher_email\').append(\'<option value=\"\'+all_teacher_ids[i]+\'\">\'+all_teacher_names[i]+\'</option>\'); \n        }\n    }\n\n    $(\'#student_home_school_teacher_email\').css(\'fontSize\', \'14px\');\n    \n    sumoTransform(\'student_home_school_teacher_email\',false,true);\n    \n    nuSetHash(\'FILES\' , \'\');\n}',NULL,0,0,'2016-07-20 00:27:17','globeadmin','2016-12-26 11:45:50','globeadmin','2019-07-25 12:18:20','globeadmin','',0,NULL),('5741fe1502bb6c2','critirion_special','Ειδικό Κριτήριο Αξιολόγησης','SELECT * FROM critirion_special','critirion_special','id',960,580,'select concat(left(description,20),if(description=left(description,20),\'\',\'...\'))\nfrom critirion_special\nwhere id=\'#RECORD_ID#\'','0','1','1',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'if(\'#nu_user_group#\'!=\'Managers\' && \'#nu_user_group#\'!=\'AssistManagers\' && \'#nu_user_group#\'!=\'Administrators\' && \'#nu_user_group#\'!=\'globeadmin\'){\n\n    $sql = \"    SELECT COUNT(*)\n                FROM mark_critirion_special_level\n                WHERE critirion_special_id = \'#RECORD_ID#\'\n            \";\n    $retval = nuRunQuery($sql);\n    $row    = db_fetch_row($retval);\n    if($row[0]!=0){\n        $MESSAGE = \'Προσοχή : Υπάρχουν βαθμοί με αυτό το ειδικό κριτήριο! Το κριτήριο δεν μπορεί να τροποποιηθεί!!\';\n        nuDisplayError($MESSAGE);\n        return;    \n    }\n\n    $sql = \"    SELECT COUNT(*)\n                FROM subject_critirion_general\n                INNER JOIN critirion_general ON critirion_general.id=subject_critirion_general.critirion_general_id\n                INNER JOIN critirion_special ON critirion_special.critirion_general_id = critirion_general.id\n                WHERE critirion_special.id = \'#RECORD_ID#\'\n            \";\n        \n    $retval = nuRunQuery($sql);\n    $row    = db_fetch_row($retval);\n    if($row[0]!=0){\n        $MESSAGE = \'Προσοχή : Υπάρχουν μαθήματα συσχετιζόμενα με αυτό το γενικό κριτήριο! Το κριτήριο δε μπορεί να τροποποιηθεί!\';\n        nuDisplayError($MESSAGE);\n        return;    \n    }\n}\n',NULL,'$sql = \"    SELECT COUNT(*)\n            FROM mark_critirion_special_level\n            WHERE critirion_special_id = \'#RECORD_ID#\'\n        \";\n$retval = nuRunQuery($sql);\n$row    = db_fetch_row($retval);\nif($row[0]!=0){\n    $MESSAGE = \'Προσοχή : Υπάρχουν βαθμοί με αυτό το ειδικό κριτήριο! Η διαγραφή δε μπορεί να πραγματοποιηθεί!\';\n    nuDisplayError($MESSAGE);\n    return;    \n}	\n\nif(\'#nu_user_group#\'!=\'Managers\' && \'#nu_user_group#\'!=\'AssistManagers\' && \'#nu_user_group#\'!=\'Administrators\' && \'#nu_user_group#\'!=\'globeadmin\'){\n    \n    $sql = \"    SELECT COUNT(*)\n                FROM subject_critirion_general\n                INNER JOIN critirion_general ON critirion_general.id=subject_critirion_general.critirion_general_id\n                INNER JOIN critirion_special ON critirion_special.critirion_general_id = critirion_general.id\n                WHERE critirion_special.id = \'#RECORD_ID#\'\n            \";\n        \n    $retval = nuRunQuery($sql);\n    $row    = db_fetch_row($retval);\n    if($row[0]!=0){\n        $MESSAGE = \'Προσοχή : Υπάρχουν μαθήματα συσχετιζόμενα με αυτό το γενικό κριτήριο! Η διαγραφή δε μπορεί να πραγματοποιηθεί!\';\n        nuDisplayError($MESSAGE);\n        return;    \n    }\n}',NULL,'if(\'#ids#\'!=\'\' && \'#ids#\'!=\'#\'.\'ids#\'){\n    $ids = explode(\",\", \'#ids#\');\n    $i=1;\n    foreach($ids as $id) {\n        $sql=\"update critirion_special_level set hierarchy=\'\".$i.\"\' where id=\'\".$id.\"\'\";\n        nuRunQuery($sql);\n        $i++;    \n    }\n}','$sql = \"    DELETE\n            FROM critirion_special_level\n            WHERE critirion_special_id = \'#RECORD_ID#\'\n        \";\nnuRunQuery($sql);','function foo(param){\n    ;\n}\nfunction pass_session_variable(param){\n    nuSetHash(\'varval\', param);\n}\nfunction get_session_variable(varname){\n    nuSetHash(\'varname\', varname);\n    nuAjax(\'getSessionVariable\',\'pass_session_variable\');\n    return nuGetHash(\'varval\');\n}\nfunction set_session_variable(varname,varval){\n    nuSetHash(\'varname\', varname);\n    nuSetHash(\'varval\', varval);\n    nuAjax(\'setSessionVariable\',\'foo\');\n}\n\nfunction nuLoadEdit() {\n    if(\'#RECORD_ID#\'==-1){\n        \n        var critirion_general_id = get_session_variable(\'critirion_general_id\');\n        var critirion_general_full_name = get_session_variable(\'critirion_general_full_name\');\n    \n        var x = document.getElementById(\'critirion_general_id\');\n        var y = document.getElementById(\'critirion_general_id_disp\');\n        \n        x.value=critirion_general_id;\n        y.value = critirion_general_full_name;\n    } else {\n        set_session_variable(\'critirion_special_id\',\'#RECORD_ID#\');\n    }\n}\n\nfunction nuOnSave() {\n\n    var iframe = document.getElementById(\'search_iframe\');\n    var innerDoc = (iframe.contentDocument) ? iframe.contentDocument : iframe.contentWindow.document;\n    \n    var x = innerDoc.getElementsByClassName(\"critiria\");\n    \n    var i;\n    ids=\'\';\n    for (i = 0; i < x.length; i++) {\n        ids=(ids==\'\' ? ids=x[i].id : ids+\',\'+x[i].id);\n    }\n    nuSetHash(\'ids\', ids)\n    return true;\n}',NULL,0,0,'0000-00-00 00:00:00','','2018-07-14 10:14:48','globeadmin','2018-07-14 10:14:48','globeadmin','',0,NULL),('5742996ed6426f1','critirion_special_level','Περιγραφή Ειδικού Κριτηρίου','SELECT * FROM critirion_special_level','critirion_special_level','id',600,350,'select \'Περιγραφή Ειδικού Κριτηρίου\'','0','1','0',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'if(\'#nu_user_group#\'!=\'Managers\' && \'#nu_user_group#\'!=\'AssistManagers\' && \'#nu_user_group#\'!=\'Administrators\' && \'#nu_user_group#\'!=\'globeadmin\'){\n\n    $sql = \"    SELECT COUNT(*)\n                FROM mark_critirion_special_level\n                WHERE critirion_special_level_id = \'#RECORD_ID#\'\n            \";\n    $retval = nuRunQuery($sql);\n    $row    = db_fetch_row($retval);\n    if($row[0]!=0){\n        $MESSAGE = \'Προσοχή : Υπάρχουν βαθμοί με αυτή τη περιγραφή! Η περιγραφή δε μπορεί να τροποποιηθεί!\';\n        nuDisplayError($MESSAGE);\n        return;    \n    }	\n\n    $sql = \"    SELECT COUNT(*)\n                FROM subject_critirion_general\n                INNER JOIN critirion_general ON critirion_general.id=subject_critirion_general.critirion_general_id\n                INNER JOIN critirion_special ON critirion_special.critirion_general_id = critirion_general.id\n                INNER JOIN critirion_special_level ON critirion_special_level.critirion_special_id = critirion_special.id\n                WHERE critirion_special_level.id = \'#RECORD_ID#\'\n            \";\n        \n    $retval = nuRunQuery($sql);\n    $row    = db_fetch_row($retval);\n    if($row[0]!=0){\n        $MESSAGE = \'Προσοχή : Υπάρχουν μαθήματα συσχετιζόμενα με αυτή τη περιγραφή! Η περιγραφή δε μπορεί να τροποποιηθεί!\';\n        nuDisplayError($MESSAGE);\n        return;    \n    }\n    \n}',NULL,'',NULL,NULL,NULL,'function foo(param){\n    ;\n}\nfunction pass_session_variable(param){\n    nuSetHash(\'varval\', param);\n}\nfunction get_session_variable(varname){\n    nuSetHash(\'varname\', varname);\n    nuAjax(\'getSessionVariable\',\'pass_session_variable\');\n    return nuGetHash(\'varval\');\n}\nfunction set_session_variable(varname,varval){\n    nuSetHash(\'varname\', varname);\n    nuSetHash(\'varval\', varval);\n    nuAjax(\'setSessionVariable\',\'foo\');\n}\n\nfunction after_delete(param){\n    parent.nuRunPHP(\'search_critirion_special_level\',\'search_iframe\');\n    nuRemoveModal();\n}\n\nfunction nuLoadEdit() {\n    \n    if(\'#RECORD_ID#\'==-1){\n        critirion_special_id = get_session_variable(\'critirion_special_id\');\n        var x = document.getElementById(\'critirion_special_id\');\n        x.value=critirion_special_id;\n    } else {\n        if(\'#nu_edited_record#\'==1){\n            parent.nuRunPHP(\'search_critirion_special_level\',\'search_iframe\');\n        }\n    }\n}\n',NULL,0,0,'0000-00-00 00:00:00','','2016-05-30 21:37:20','globeadmin','2017-10-29 19:27:27','globeadmin','',0,NULL),('57457fe729a1d1c','clone_critirion_special','Κλωνοποίηση Ειδικού Κριτηρίου','select * from critirion_special','critirion_special','id',700,250,'select \'Κλωνοποίηση Ειδικού Κριτηρίου\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function foo(param){\n    ;\n}\nfunction pass_session_variable(param){\n    nuSetHash(\'varval\', param);\n}\nfunction get_session_variable(varname){\n    nuSetHash(\'varname\', varname);\n    nuAjax(\'getSessionVariable\',\'pass_session_variable\');\n    return nuGetHash(\'varval\');\n}\nfunction set_session_variable(varname,varval){\n    nuSetHash(\'varname\', varname);\n    nuSetHash(\'varval\', varval);\n    nuAjax(\'setSessionVariable\',\'foo\');\n}\n\nfunction dsplayAjaxMessage(param){\n    if(param!=\'\'){\n        alert(param);\n    }\n    parent.nuReloadForm();    \n    nuRemoveModal();\n}\n\nfunction nuLoadEdit() {\n    nuFORM.edited = 0;\n    //$(\'#label1\').css(\"fontSize\", \"11px\");\n    //$(\'#label1\').css(\'font-style\', \'italic\');\n}',NULL,0,0,'2016-05-25 13:35:19','globeadmin','2016-05-25 14:40:01','globeadmin','2016-05-25 14:54:06','globeadmin','',0,NULL),('5762f95837d99ee','student_sent_mark_email','Μαζική Αποστολή Αξιολόγησης με Email σε Μαθητές','select * from teacher','teacher','id',960,1300,'select \'Μαζική Αποστολή Αξιολόγησης με Email σε Μαθητές-Γονείς\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function foo(param){\n    ;\n}\nfunction pass_session_variable(param){\n    nuSetHash(\'varval\', param);\n}\nfunction get_session_variable(varname){\n    nuSetHash(\'varname\', varname);\n    nuAjax(\'getSessionVariable\',\'pass_session_variable\');\n    return nuGetHash(\'varval\');\n}\nfunction set_session_variable(varname,varval){\n    nuSetHash(\'varname\', varname);\n    nuSetHash(\'varval\', varval);\n    nuAjax(\'setSessionVariable\',\'foo\');\n}\n\nfunction display_sent_result(param){\n    alert(param);\n}\n\n\nfunction nuLoadEdit() {\n\n}',NULL,0,0,'2016-06-16 22:09:12','globeadmin','2016-06-16 22:36:15','globeadmin','2016-10-07 22:06:42','globeadmin','',0,NULL),('577ebb808309312','email_search','Αναζήτηση Σταλθέντων Email','select * from teacher','teacher','id',1200,570,'select \'Αναζήτηση Σταλθέντων Email\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function get_selected_ids(){\n    var id_array = [];\n\n    var iframe = document.getElementById(\'search_iframe\');\n    var innerDoc = (iframe.contentDocument) ? iframe.contentDocument : iframe.contentWindow.document;\n\n    var c1 = innerDoc.getElementsByClassName(\'chk_1\');\n        \n    for(var i=0, n=c1.length;i<n;i++) {\n        if(c1[i].checked){\n            id_array.push(c1[i].id);\n        }\n    } \n    \n    ids = id_array.join();\n    \n    if(typeof id_array == \'undefined\' || id_array == null || id_array.length == 0){\n        alert (\'Παρακαλώ επιλέξτε πρώτα τα email!\');\n        return;\n    }\n    \n    return ids;\n}\n\nfunction display_sent_result(param){\n    hideLoader();\n    alert(param);\n}\n\nfunction display_delete_result(param){\n    hideLoader();\n    alert(param);\n    nuRunPHP(\'search_email\',\'search_iframe\')\n}\n\nfunction nuLoadEdit() {\n    \n    var all_teacher_ids = [];\n    var all_teacher_names = [];\n\n    var s = document.getElementById(\'teacher_id\');\n \n    for (var i = 0; i < s.options.length; i++) {\n        \n        var teacher_id=s.options[i].value;\n        var teacher_name=s.options[i].text;\n        \n        all_teacher_ids.push(teacher_id);\n        all_teacher_names.push(teacher_name);\n        }\n    \n    $(\'#teacher_id\').empty();\n    $(\'#teacher_id\').append(\"<option value=\'\'></option>\");\n    $(\'#teacher_id\').append(\"<option value=0>Εξαίρεση Καθηγητών</option>\");\n    \n    for(i=0;i<all_teacher_ids.length;i++){\n        if(all_teacher_names[i]!=\'\'){\n            $(\'#teacher_id\').append(\'<option value=\"\'+all_teacher_ids[i]+\'\">\'+all_teacher_names[i]+\'</option>\'); \n            }\n        }    \n\n    var all_student_ids = [];\n    var all_student_names = [];\n\n    s = document.getElementById(\'student_id\');\n \n    for (i = 0; i < s.options.length; i++) {\n        \n        var student_id=s.options[i].value;\n        var student_name=s.options[i].text;\n        \n        all_student_ids.push(student_id);\n        all_student_names.push(student_name);\n        }\n    \n    $(\'#student_id\').empty();\n    $(\'#student_id\').append(\"<option value=\'\'></option>\");\n    $(\'#student_id\').append(\"<option value=0>Εξαίρεση Μαθητών</option>\");\n    \n    for(i=0;i<all_student_ids.length;i++){\n        if(all_student_names[i]!=\'\'){\n            $(\'#student_id\').append(\'<option value=\"\'+all_student_ids[i]+\'\">\'+all_student_names[i]+\'</option>\'); \n            }\n        }\n        \n    $(\'#sender_id\').append(\"<option value=\'-1\'>ΕΙΔΟΠΟΙΗΣΕΙΣ</option>\");\n        \n    $(\'#sender_id\').val(\'#RECORD_ID#\');\n    $(\'#from_date\').val($(\'#current_date\').val());\n    $(\'#to_date\').val($(\'#current_date\').val());\n    nuFORM.edited = 0;\n}',NULL,0,0,'2016-07-07 23:28:48','globeadmin','2018-07-13 09:32:18','globeadmin','2021-01-24 16:08:37','globeadmin','',0,NULL),('57822e81b5ed24f','teacher_owe_mark sent_email','Μαζική Αποστολή Email σε Καθηγητές που υπολείποντα','select * from teacher','teacher','id',960,1650,'select \'Αποστολή Email στους Καθηγητές\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function display_sent_result(param){\n    hideLoader();\n    alert(param);\n}\n\nfunction passTinymceContents(){\n    var txt=\'\';\n    \n    var days_left = $(\'#date_dif_disp\').val();\n    \n    if(days_left<0){\n        txt =\'Η καταληκτική ημερομηνία για την παράδοση της αξιολόγησης της τρέχουσας περιόδου, <b>παρήλθε</b>!<br><br>Παρακαλώ όπως επικοινωνήστε με τη Διεύθυνση του Σχολείου!\';\n    } else {\n        txt = \'Παρακαλώ όπως ολοκληρώσετε την κατάθεση της αξιολόγησης σας.<br><br>Καταληκτική ημερομηνία : <b>\'+$(\'#end_date_disp\').val()+\'</b>\';\n        if (days_left==\'0\'){\n            txt +=\'<br><br>Μπορείτε να καταθέσετε την αξιολόγηση σας <b>μέχρι τέλος της ημέρας (23:59:59)</b>.\';\n        } else {\n            txt +=\'<br><br>Απομένουν <b>\'+days_left+\'</b> Ημέρες!\';\n        }\n    }\n    return(txt);\n}\n\nfunction nuLoadEdit() {\n    $(\'#subject\').val($(\'#subject_disp\').val());\n}',NULL,0,0,'2016-07-10 14:16:17','globeadmin','2016-07-10 17:55:56','globeadmin','2020-10-18 00:56:52','globeadmin','',0,NULL),('57829d0d8167dd0','teacher_owe_mark_sent_sms','Μαζική Αποστολή SMS σε Καθηγητές που υπολείπονται ','select * from teacher','teacher','id',960,1380,'select \'Αποστολή SMS σε Καθηγητές\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function display_sent_result(param){\n    hideLoader();\n    alert(param);\n}\n\nfunction nuLoadEdit() {\n\n    $(\'#sms_text\').css(\'fontSize\', \'16px\');\n    $(\'#sms_text\').css(\'font-weight\', \'bold\');\n    $(\'#sms_text\').css(\'background-color\', \'LightYellow\');\n    $(\'#sms_text\').css(\'color\', \'#25237A\');\n\n    $(\'#sms_disp\').css(\'fontSize\', \'16px\');\n    $(\'#sms_disp\').css(\'font-weight\', \'bold\');\n    $(\'#sms_disp\').css(\'background-color\', \'#FAF0E6\');\n    $(\'#sms_disp\').css(\'color\', \'red\');\n    \n    $(\'#sms_text\').attr(\'maxlength\',$(\'#max_num_of_chars\').val());\n    \n    $(\'#num_of_chars_left\').val($(\'#max_num_of_chars\').val());\n    \n    $(\'#num_of_chars_left\').css(\'fontSize\', \'10px\');\n    $(\'#num_of_chars_left\').css(\'font-weight\', \'bold\');\n    $(\'#num_of_chars_left\').css(\'background-color\', \'#FAF0E6\');\n    \n    var txt = \'\';\n    var days_left = $(\'#date_dif_disp\').val();\n    \n    days_left=0;\n    \n    if(days_left<0){\n        txt =\'Η ημερομηνία για την παράδοση της αξιολόγησης (\'+$(\'#subject_disp\').val()+\') παρήλθε! Παρακαλώ επικοινωνήστε με τη Διεύθυνση του Σχολείου!\';\n    } else {\n        txt = \'Παρακαλώ να ολοκληρώσετε την κατάθεση της αξιολόγησης σας (\'+$(\'#subject_disp\').val()+\'). Καταληκτική ημερομηνία:\'+$(\'#end_date_disp\').val();\n    }\n    \n    txt=txt.substring(0, $(\'#max_num_of_chars\').val());\n    \n    $(\'#num_of_chars_left\').val($(\'#max_num_of_chars\').val()-txt.length);\n    \n    $(\'#sms_text\').val(txt);\n    \n}',NULL,0,0,'2016-07-10 22:07:57','globeadmin','2021-03-24 11:23:14','globeadmin','2021-03-24 11:23:14','globeadmin','',0,NULL),('57dae2cd92d16c0','teachingbook_student','Ημερολόγιο Διδασκαλίων','select * from student','student','id',960,650,'select \'Ημερολόγιο Διδασκαλίων\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function set_comments(cell_id,comments){\n    var iframe = document.getElementById(\'registered_cards_iframe\');\n    var innerDoc = (iframe.contentDocument) ? iframe.contentDocument : iframe.contentWindow.document;\n\n    var x = innerDoc.getElementById(\'td\'+cell_id);\n    var y = innerDoc.getElementById(\'img_\'+cell_id);\n\n    x.innerHTML = comments;\n    \n    if(comments.trim() !=\'\'){\n        y.src = \'images/edit_red.png\';\n    } else {\n        y.src = \'images/edit.png\';\n    }\n    \n}\n\nfunction nuLoadEdit() {\n    var class_id    = get_session_variable(\'class_id\');\n    var subject_id  = get_session_variable(\'subject_id\');\n\n    var selection_id = class_id+\',\'+subject_id;\n\n    var c=document.getElementById(\'class_subject_selection\');\n    c.value =   selection_id;  \n\n    $(\'#period_absence_class\').trigger( \"onchange\" );\n   \n}\n',NULL,0,0,'2016-09-15 21:05:01','globeadmin','2017-11-12 16:34:14','globeadmin','2017-11-12 16:34:14','globeadmin','',0,NULL),('57e15c6777df58a','parent_user_creation','Δημιουργία Λογαριασμών για τους Γονείς','select * from teacher','teacher','id',1600,775,'select \'Δημιουργία Λογαριασμών για τους Γονείς\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'','//nuRunPHP(\'clean_up_user_ids\');',NULL,NULL,'function display_sent_result(param){\n    hideLoader();\n    alert(param);\n}\n\nfunction nuLoadEdit() {  \n    $(\'#display1\').css(\'fontSize\', \'14px\');\n    $(\'#display1\').css(\'font-weight\', \'bold\');\n    $(\'#display1\').css(\'font-style\', \'italic\');\n\n    $(\'#label1\').css(\'font-style\', \'italic\');\n    $(\'#label1\').css(\'fontSize\', \'11px\');\n    $(\'#label2\').css(\'font-style\', \'italic\');\n    $(\'#label2\').css(\'fontSize\', \'11px\');\n}',NULL,0,0,'2016-09-20 18:57:27','globeadmin','2021-09-07 20:18:33','globeadmin','2021-09-07 20:18:33','globeadmin','',0,NULL),('57e6bdac4fee426','send_parent_accounts_email','Στέλνει μαζικά emails με τους λογαριασμούς γονέων','select * from teacher','teacher','id',860,560,'select \'Αποστολή Κωδικών Γονέων με Email\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function passTinymceContents(){\n    var y = \'Σας ενημερώνουμε ότι στο πληροφοριακό σύστημα «Σίσυφος» του σχολείου μας έχει δημιουργηθεί λογαριασμός πρόσβασης<br>για το γονέα του μαθητή -student- με τα εξής στοιχεία :<br><br>Όνομα Χρήστη : -username-<br>Κωδικός : -password-\';\n    return(y);\n}\n\nfunction display_sent_result(param){\n    hideLoader();\n    alert(param);\n    nuRemoveModal();\n}\n\nfunction nuLoadEdit() {\n    $(\'#email_subject\').val(\'Στοιχεία Λογαριασμού Γονέα για το Π.Σ. Σίσυφος\');\n}\n',NULL,0,0,'2016-09-24 20:53:48','globeadmin','2016-09-24 23:24:16','globeadmin','2021-09-07 20:15:25','globeadmin','',0,NULL),('57ece27c6e12afd','set_class_responsible_new','Ορισμός Υπεύθυνου Καθηγητή','select * from teacher','teacher','id',960,750,'select \'Ορισμός Υπεύθυνου Καθηγητή\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,0,0,'2016-09-29 12:44:28','globeadmin','2016-09-29 12:45:09','globeadmin','2018-06-30 11:49:10','globeadmin','',0,NULL),('580ba2a48260384','penalty_teacher','Ποινή κατά τη διάρκεια του μαθήματος','select *\nfrom penalty','penalty','id',750,450,'select \'Παρατήρηση-Ποινή\'','0','1','0',NULL,NULL,NULL,NULL,'Υποβολή',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'$sql = \"    SELECT COUNT(*)\n            FROM penalty\n            WHERE \n                student_id = \'#student_id#\' AND\n                date_enforced = \'#date_enforced#\' AND\n                period_id = \'#period_id#\' AND\n                type = \'Καθυστερημένη Είσοδος στην Τάξη\'\n        \";\n$retval = nuRunQuery($sql);\n$row    = db_fetch_row($retval);\n\nif($row[0]!=0 && \'#type#\'==\'Καθυστερημένη Είσοδος στην Τάξη\'){\n    $MESSAGE = \"Προσοχή : Υπάρχει ήδη καταχωρημένη η ποινή της καθυστερημένης εισόδου στη τάξη.\\nΔεν μπορείτε να την καταχωρίσετε δύο φορές!\";\n    nuDisplayError($MESSAGE);\n    return;    \n}',NULL,'',NULL,'nuRunPHP(\'notification_add_lib\');\n\nif (\'#nu_new_record#\'==\'1\'){\n    new_penalty_notification(\'#RECORD_ID#\');\n}',NULL,'function nuLoadEdit() { \n    if(\'#nu_new_record#\'==\'1\'){\n        var opts =  parent.document.getElementById(\'absence_period_id\');\n        var de =    parent.document.getElementById(\'absence_date\');\n        var p_id = -1;\n        \n        if(opts){\n            p_id = opts.options[opts.selectedIndex].value;     \n        } else {\n            if (typeof parent.p_id !== \'undefined\') {\n                p_id = parent.p_id;\n            }\n        }\n        \n        if(p_id!=-1){\n            $(\'#period_id\').val(p_id);\n        } else {\n            nuEnable(\'period_id\');    \n        }\n\n        if(parent.t_id!=-1){\n            $(\'#teacher_id\').val(parent.t_id);\n        } else {\n            nuEnable(\'teacher_id\');    \n        }\n        \n        $(\'#post_teacher_id\').val(parent.t_post_id);\n        \n        $(\'#student_id\').val(parent.s_id);\n        $(\'#student_name\').val(parent.s_name);\n        \n        $(\'#date_enforced\').val(de.value);\n        \n        $(\'#carrier\').hide();\n        $(\'#student_id\').hide();\n        $(\'#date_added\').hide();\n    } else {\n        /*if(confirm(\'Η παρατήρηση/ποινή σας υποβλήθηκε επιτυχώς!\\n\\nΘέλετε να εκτυπωθεί;\')){\n            nuPrintPDF(\'penalty_report\');    \n        }*/\n        alert(\'Η παρατήρηση/ποινή σας υποβλήθηκε επιτυχώς!\');\n        nuRemoveModal();    \n    }\n}\n\nfunction nuOnSave(){     \n    \n    var tp = document.getElementById(\'type\');\n    var type = tp.options[tp.selectedIndex].value;\n    \n    var p = document.getElementById(\'period_id\');\n    var period = p.options[p.selectedIndex].value;\n    \n    var th = document.getElementById(\'teacher_id\');\n    var teacher = th.options[th.selectedIndex].value;\n    \n    if(type == \'\'){\n        alert(\'Παρακαλώ συμπληρώστε τον τύπο της ποινής!\');\n        return false;  \n    }\n    \n    if(period == \'\'){\n        alert(\'Παρακαλώ συμπληρώστε τη διδακτική ώρα της ποινής!\');\n        return false;  \n    }\n    \n    if(teacher == \'\'){\n        alert(\'Παρακαλώ συμπληρώστε τον καθηγητή της ποινής!\');\n        return false;  \n    }\n    \n    $(\'#carrier\').val(th.options[th.selectedIndex].text);\n    \n    return true;\n}',NULL,30,100,'2016-10-22 20:32:20','globeadmin','2018-10-17 22:22:40','globeadmin','2021-10-20 23:47:22','globeadmin','',0,NULL),('5830025d8a778f9','notification_key','Πεδίο Αντικατάστασης','SELECT * FROM notification_key','notification_key','id',800,500,'select name from notification_key where id=\'#RECORD_ID#\'','1','1','1',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,0,100,'0000-00-00 00:00:00','','2017-09-10 23:02:16','globeadmin','2017-09-10 23:02:17','globeadmin','',0,NULL),('580cdf151b06780','penalty_search','Αναζήτηση Ποινών','select * from teacher','teacher','id',1000,600,'select \'Αναζήτηση Ποινών\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function get_excel_file(param){\n    if(param!=\'\' && param!=\'-1\'){\n        nuSetHash(\'backup_file_name\', param);\n        nuSetHash(\'send_file_name\', \'penalty_export.xls\');\n        nuRunPHP(\'backup_db_get_file\',\'hidden_iframe\');\n    } else {\n        alert(\'Η δημιουργία του αρχείου Excel απέτυχε!\'); \n    } \n    hideLoader();\n}\n\nfunction nuLoadEdit() {\n    sumoTransform(\'type\',false,true);\n    $(\'#from_date\').val($(\'#start_date\').val());\n    $(\'#to_date\').val($(\'#current_date\').val());\n    \n    if( \'#nu_user_group#\'!=\'globeadmin\' && \n        \'#nu_user_group#\'!=\'Administrators\' && \n        \'#nu_user_group#\'!=\'Managers\' && \n        \'#nu_user_group#\'!=\'AssistManagers\'){\n        $(\'#teacher_id\').val(\'#RECORD_ID#\');        \n    }\n    \n    nuFORM.edited = 0;\n}',NULL,0,0,'2016-10-23 19:02:29','globeadmin','2018-07-13 19:49:06','globeadmin','2021-10-24 21:35:22','globeadmin','',0,NULL),('580e312bc544f2e','absence_read','Εισάγει τα σύνολα των απουσιών εκτός συστήματος','select * from teacher','teacher','id',960,530,'select \'Σύνολα Απουσιών Εκτός Συστήματος\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function reload_iframe(param){\n    sisMessage(param);\n    nuRunPHP(\'prev_students_absences\',\'insert_iframe\');\n}\n\nfunction update_iframe(param){\n    //alert(param);\n    var absences = JSON.parse(param);\n    \n    var iframe = document.getElementById(\'insert_iframe\');\n    var innerDoc = (iframe.contentDocument) ? iframe.contentDocument : iframe.contentWindow.document;\n    \n    var rgnumb_not_found=\'\';\n    var lines_ignored = 0;\n\n    for(var i=0, n=absences.length;i<n;i++) {\n        if(absences[i][0]==-1){\n            rgnumb_not_found= (rgnumb_not_found==\'\' ? absences[i][1] : rgnumb_not_found+\',\'+absences[i][1])    \n        } else if(absences[i][0]==-2){\n            lines_ignored = absences[i][1];   \n        } else {\n            var a = innerDoc.getElementById(\'a_\'+absences[i][0]);\n            var d = innerDoc.getElementById(\'d_\'+absences[i][0]);\n            \n            if(a.value!=absences[i][1]){\n                a.style.backgroundColor = \'#ff9999\';\n                a.value = absences[i][1];\n            } else {\n                a.style.backgroundColor = \'lightGreen\';\n            }\n            \n            if(d.value!=absences[i][2]){\n                d.style.backgroundColor = \'#ff9999\';\n                d.value = absences[i][2];\n            } else {\n                d.style.backgroundColor = \'lightGreen\' ; \n            }\n        }\n    }\n    \n    var msg=\'Τα δεδομένα από το αρχείο Excel εισήχθησαν επιτυχώς!\';\n    if(lines_ignored>0){\n       msg+= \'\\n\'+lines_ignored+\' γραμμές στο αρχείο αγνοήθηκαν!\';\n    }\n    \n    if(rgnumb_not_found!=\'\'){\n       msg+= \'\\nΠροσοχή : Οι ΑΜ <b>\'+rgnumb_not_found+\'</b> δεν βρέθηκαν στους μαθητές και <b>αγνοήθηκαν</b>!\';\n    }\n    \n    sisMessage(msg);\n    \n}\n\nfunction nuLoadEdit() {\n    nuSetHash(\'FILES\' , \'\');\n}',NULL,0,0,'2016-10-24 19:04:59','globeadmin','2018-07-02 09:32:03','globeadmin','2022-02-11 21:16:33','globeadmin','',0,NULL),('5812516a1bf18a5','add_student_absence_table','Καταχώριση Μεμονωμένης Απουσίας Μαθητή κατευθείαν ','select * from teacher','teacher','id',600,300,'select \'Καταχώριση Απουσίας Μαθητή\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function after_absence_add(param){\n    parent.reload_absence_table(); // Επαναφόρτωση Απουσιολογίου\n    nuRemoveModal();\n}\n\nfunction nuLoadEdit() { \n        var de =    parent.document.getElementById(\'absence_date\');\n\n        $(\'#student\').val(parent.s_id);\n        $(\'#student_name\').val(parent.s_name);\n    \n        $(\'#absence_date\').val(de.value);\n        $(\'#period\').val(parent.p_id);\n    \n        $(\'#student\').hide();\n}',NULL,0,0,'2016-10-27 22:11:38','globeadmin','2022-09-24 23:07:25','globeadmin','2022-09-24 23:07:25','globeadmin','',0,NULL),('581469f72e8002c','set_advisors','Ορισμός Ατομικού Συμβούλου Μαθητών','select * from teacher','teacher','id',960,750,'select \'Ορισμός Ατομικού Συμβούλου Μαθητών\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,0,0,'2016-10-29 12:20:55','globeadmin','2016-10-29 12:26:18','globeadmin','2018-12-04 21:18:38','globeadmin','',0,NULL),('58275eceb901234','notification_category','Κατηγορίες Ειδοποιήσεων','SELECT * \nFROM notification_category \nORDER BY hierarchy','notification_category','id',960,530,'SELECT name FROM notification_category \nWHERE id=\'#RECORD_ID#\'','1','1','1',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function passTinymceContents(){\n    var y = document.getElementById(\'header\').value;\n    return(y);\n}\n\nfunction nuLoadEdit() { \n    \n}\n\nfunction nuOnSave(){\n    var iframe = document.getElementById(\'header_tinymce\');\n    var htmltext = iframe.contentWindow.getHTML();\n    $(\'#header\').val(htmltext);\n    return true;\n}',NULL,0,0,'0000-00-00 00:00:00','','2016-11-15 18:00:47','globeadmin','2016-11-16 19:06:32','globeadmin','',0,NULL),('582762fe10beed3','notification_type','Τύποι Ειδοποιήσεων','SELECT notification_type.*, cname\nFROM notification_type\nLEFT JOIN (select id as cid, name as cname, hierarchy as chierarchy from notification_category) as c on c.cid=notification_type.category_id\nORDER BY chierarchy,hierarchy','notification_type','id',960,530,'select name from notification_type where id = \'#RECORD_ID#\'','1','1','1',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'select if(\'#nu_user_group#\'=\'globeadmin\',\'1\',\'0\')',NULL,'select if(\'#nu_user_group#\'=\'globeadmin\',\'1\',\'0\')',NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function passTinymceContents(){\n    var y = document.getElementById(\'header\').value;\n    return(y);\n}\n\nfunction load_header(){\n    nuSetHash(\'table_name\',\'notification_type\');\n    nuSetHash(\'table_field\',\'header\');\n    nuSetHash(\'id_name\',\'id\'); \n    nuSetHash(\'id_value\',\'#RECORD_ID#\');\n    nuRunPHP(\'show_html_field\',\'header_html\');    \n}\n\nfunction load_content(){\n    nuSetHash(\'table_name\',\'notification_type\');\n    nuSetHash(\'table_field\',\'content\');\n    nuSetHash(\'id_name\',\'id\'); \n    nuSetHash(\'id_value\',\'#RECORD_ID#\');\n    nuRunPHP(\'show_html_field\',\'content_html\');    \n}\n\nfunction nuLoadEdit() {\n    load_header();\n    load_content();\n}\n',NULL,0,0,'0000-00-00 00:00:00','','2016-11-15 20:29:29','globeadmin','2016-12-06 16:54:30','globeadmin','',0,NULL),('582b3fe8c3f39e6','notification_type_header','Τύποι Ειδοποιήσεων - Κεφαλίδα','SELECT * FROM notification_type','notification_type','id',960,530,'select name from notification_type where id = \'#RECORD_ID#\'','0','1','0',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function passTinymceContents(){\n    var y = document.getElementById(\'header\').value;\n    return(y);\n}\n\nfunction nuLoadEdit() {\n    if(\'#nu_edited_record#\'==\'1\'){\n        parent.load_header();\n        nuRemoveModal();\n    }\n}\n\nfunction nuOnSave(){\n    var iframe = document.getElementById(\'header_tinymce\');\n    var htmltext = iframe.contentWindow.getHTML();\n    $(\'#header\').val(htmltext);\n    \n    nuFORM.edited = 1;\n    \n    return true;\n}',NULL,0,0,'2016-11-15 19:03:36','globeadmin','2016-11-15 20:45:13','globeadmin','2016-11-20 18:21:23','globeadmin','',0,NULL),('582b40cc7c93c9c','notification_type_content','Τύποι Ειδοποιήσεων - Περιεχόμενο','SELECT * FROM notification_type','notification_type','id',960,480,'select name from notification_type where id = \'#RECORD_ID#\'','0','1','0',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function passTinymceContents(){\n    var y = document.getElementById(\'content\').value;\n    return(y);\n}\n\nfunction nuLoadEdit() {\n    if(\'#nu_edited_record#\'==\'1\'){\n        parent.load_content();\n        nuRemoveModal();\n    }\n}\n\nfunction nuOnSave(){\n    var iframe = document.getElementById(\'content_tinymce\');\n    var htmltext = iframe.contentWindow.getHTML();\n    $(\'#content\').val(htmltext);\n    \n    nuFORM.edited = 1;\n    \n    return true;\n}\n\n',NULL,0,0,'2016-11-15 19:07:24','globeadmin','2016-11-18 19:12:13','globeadmin','2016-11-18 19:12:14','globeadmin','',0,NULL),('583031e43183ea3','notifivation_search','Ειδοποιήσεις Email σε Μαθητές/Γονείς','select * from teacher','teacher','id',960,530,'select \'Ειδοποιήσεις Email σε Μαθητές/Γονείς\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function display_sent_result(param){\n    hideLoader();\n    nuRunPHP(\'search_notification\',\'search_iframe\');\n    alert(param);\n}\n\nfunction get_selected_ids(){\n    var id_array = [];\n\n    var iframe = document.getElementById(\'search_iframe\');\n    var innerDoc = (iframe.contentDocument) ? iframe.contentDocument : iframe.contentWindow.document;\n\n    var c1 = innerDoc.getElementsByClassName(\'chk_1\');\n        \n    for(var i=0, n=c1.length;i<n;i++) {\n        if(c1[i].checked){\n            id_array.push(c1[i].id);\n        }\n    } \n    \n    ids = id_array.join();\n    \n    if(typeof id_array == \'undefined\' || id_array == null || id_array.length == 0){\n        alert (\'Παρακαλώ επιλέξτε πρώτα τις ειδοποιήσεις!\');\n        return;\n    }\n    \n    return ids;\n}\n\nfunction nuLoadEdit() { \n    $(\'#from_date\').val($(\'#start_date\').val());\n    $(\'#to_date\').val($(\'#cur_date\').val());\n    $(\'#pending\').val(\'1\');\n    \n    sumoTransform(\'type_id\',false,true);\n    sumoTransform(\'student_id\',true,true);\n}',NULL,0,0,'2016-11-19 13:05:08','globeadmin','2018-07-13 19:39:13','globeadmin','2018-07-13 19:39:13','globeadmin','',0,NULL),('5830097228cb500','notification_type_admin','Τύποι Ειδοποιήσεων','SELECT notification_type.*, cname\nFROM notification_type\nLEFT JOIN (select id as cid, name as cname, hierarchy as chierarchy from notification_category) as c on c.cid=notification_type.category_id\nORDER BY chierarchy,hierarchy','notification_type','id',960,530,'select name from notification_type where id = \'#RECORD_ID#\'','0','1','0',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'\n',NULL,0,0,'2016-11-19 10:12:34','globeadmin','2016-11-19 10:12:34','globeadmin','2016-11-19 10:12:34','globeadmin','',0,NULL),('5831a1813b1b74d','notification','Ειδοποίηση','SELECT * FROM notification','notification','id',1060,550,'select concat(\'Ειδοποίηση Αρθ. \',id)\nfrom notification where id=\'#RECORD_ID#\'','0','1','1',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function display_sent_result(param){\n    hideLoader();\n    alert(param);\n}\n\nfunction passTinymceContents(){\n    var y = document.getElementById(\'content\').value;\n    return(y);\n}\n\nfunction nuLoadEdit() {\n    if(\'#nu_edited_record#\'==\'1\'){\n        parent.nuRunPHP(\'search_notification\',\'search_iframe\');\n        //parent.load_header();\n    }\n}\n\nfunction nuOnSave(){\n    var iframe = document.getElementById(\'content_tinymce\');\n    var htmltext = iframe.contentWindow.getHTML();\n    $(\'#content\').val(htmltext);\n    nuFORM.edited = 1;\n    return true;\n}',NULL,0,0,'0000-00-00 00:00:00','','2018-07-05 12:23:50','globeadmin','2018-07-05 12:23:50','globeadmin','',0,NULL),('584117d1d046e30','student_notofication_choices','Επιλογές ειδοποιήσεων email Μαθητή','SELECT * FROM student','student','id',700,400,'select \'Επιλογές Ειδοποιήσεων με email\'',NULL,'1',NULL,NULL,NULL,NULL,NULL,'Αποθήκευση Επιλογών',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function nuLoadEdit() { \n    if($(\'#select_new_penalty_notification\').val()==\'0\'){\n        nuDisable(\'new_penalty_notification\');\n    }\n\n    if($(\'#select_new_absence_notification\').val()==\'0\'){\n        nuDisable(\'new_absence_notification\');\n        nuDisable(\'group_new_absence_notification\');\n    }\n    \n    if($(\'#new_absence_notification\').val()==\'0\'){\n        nuDisable(\'group_new_absence_notification\');\n        document.getElementById(\"group_new_absence_notification\").checked = false;\n    }    \n    \n    if($(\'#select_justify_absence_notification\').val()==\'0\'){\n        nuDisable(\'justify_absence_notification\');    \n    }\n    \n    if($(\'#select_delete_absence_notification\').val()==\'0\'){\n        nuDisable(\'delete_absence_notification\');    \n    }\n    \n    if($(\'#select_update_comment_notification\').val()==\'0\'){\n        nuDisable(\'update_comment_notification\');    \n    }\n    \n    if($(\'#select_new_calendar_event_notification\').val()==\'0\'){\n        nuDisable(\'new_calendar_event_notification\');    \n    }    \n    \n    document.getElementById(\'group_new_absence_notification\').title = \'Επιλέξτε αν δεν επιθυμείτε να ενημερώνεστε αναλυτικά για τις νέες απουσίες αλλά μόνο για το συνολικό τους αριθμό ανά ημέρα στη περίπτωση που ο μαθητής απουσίαζε όλη την ημέρα\';\n    \n}',NULL,0,0,'2016-12-02 08:42:25','globeadmin','2017-09-09 15:50:08','globeadmin','2022-01-08 22:14:59','globeadmin','',0,NULL),('584128b691c711a','parent_notofication_choices','Επιλογές ειδοποιήσεων email Γονέα','SELECT * FROM student','student','id',700,400,'select \'Επιλογές Ειδοποιήσεων με email\'',NULL,'1',NULL,NULL,NULL,NULL,NULL,'Αποθήκευση Επιλογών',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function nuLoadEdit() { \n    if($(\'#select_new_penalty_notification\').val()==\'0\'){\n        nuDisable(\'parent_new_penalty_notification\')    \n    }\n    \n    if($(\'#select_new_absence_notification\').val()==\'0\'){\n        nuDisable(\'parent_new_absence_notification\')    \n    }\n    \n    if($(\'#select_justify_absence_notification\').val()==\'0\'){\n        nuDisable(\'parent_justify_absence_notification\')    \n    }\n    \n    if($(\'#select_delete_absence_notification\').val()==\'0\'){\n        nuDisable(\'parent_delete_absence_notification\')    \n    }\n    \n    if($(\'#select_update_comment_notification\').val()==\'0\'){\n        nuDisable(\'parent_update_comment_notification\')    \n    }\n    \n    if($(\'#select_new_calendar_event_notification\').val()==\'0\'){\n        nuDisable(\'parent_new_calendar_event_notification\');    \n    }\n    \n    document.getElementById(\'parent_group_new_absence_notification\').title = \'Επιλέξτε αν δεν επιθυμείτε να ενημερώνεστε αναλυτικά για τις νέες απουσίες αλλά μόνο για το συνολικό τους αριθμό ανά ημέρα στη περίπτωση που ο μαθητής απουσίαζε όλη την ημέρα\';\n    \n}',NULL,0,0,'2016-12-02 09:54:30','globeadmin','2017-09-09 15:37:41','globeadmin','2022-01-08 22:12:05','globeadmin','',0,NULL),('584a5c7c116e00c','student_select_teacher','Επιλογή Καθηγητών από τους μαθητές','SELECT * FROM student','student','id',600,300,'select \'Επιλογή Καθηγητών\'',NULL,'1',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'$arr = nuSubformArray(\'teacher_student_subform\',false);\n$teacher_id_array = array();\n\nfor( $idx = 0; $idx < count($arr); $idx++ ) {\n    if(!is_null($nuHash[$arr[$idx].\'teacher_id\']) && $nuHash[$arr[$idx].\'teacher_id\'] != \'\'){\n        $teacher_id_array[] = $nuHash[$arr[$idx].\'teacher_id\'];    \n    }\n}\n\nif(count($teacher_id_array) != count(array_unique($teacher_id_array))) {\n        $MESSAGE = \'Προσοχή : Δεν μπορείτε να επιλέξετε τον ίδιο καθηγητή περισσότερες από μια φορές... \';\n        nuDisplayError($MESSAGE);\n        return;\n}\n',NULL,'',NULL,NULL,NULL,'function nuLoadEdit() {\n    if(\'#nu_edited_record#\'==\'1\'){\n        alert(\'Οι προτιμήσεις σας καταχωρήθηκαν επιτυχώς!\');\n        nuRemoveModal();\n    }\n}\n\nfunction nuOnSave(){     \n    nuFORM.edited = 1;\n    return true;\n}',NULL,0,0,'2016-12-09 09:25:48','globeadmin','2016-12-14 19:21:07','globeadmin','2016-12-14 19:21:07','globeadmin','',0,NULL),('584bd01a9203a9a','massively_justification_request','Μαζική Εισαγωγή Αιτημάτων Δικαιολόγησης σε επιλεγμ','SELECT * FROM teacher','teacher','id',600,300,'select \'Μαζική Εισαγωγή Αιτημάτων Δικαιολόγησης\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function display_insert_results(param){\n    \n    alert(param);\n    \n    if (typeof parent.reload_requests === \'function\') {\n        parent.reload_requests();\n    }\n    //parent.nuRunPHP(\'search_teacher_absence\',\'search_iframe\');\n    \n    nuRemoveModal();\n}\n',NULL,0,0,'2016-12-10 11:51:22','globeadmin','2018-08-07 15:09:44','globeadmin','2020-09-14 22:05:04','globeadmin','',0,NULL),('58d616cfeb60afc','acc_set','Λογαριασμοί Χρηστών','SELECT * FROM zzzsys_user \nLEFT JOIN zzzsys_user_group ON  sus_zzzsys_user_group_id =  zzzsys_user_group_id \nLEFT JOIN  zzzsys_access_level ON sug_zzzsys_access_level_id = zzzsys_access_level_id \nORDER BY sus_name','zzzsys_user','zzzsys_user_id',960,520,'select sus_name\nfrom zzzsys_user\nwhere zzzsys_user_id=\'#RECORD_ID#\'','1','1',NULL,NULL,NULL,NULL,'Δημιουργία Νέου Λογαριασμού',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'$sql = \"    SELECT COUNT(*)\n            FROM zzzsys_user \n            WHERE   sus_login_name = \'#sus_login_name#\' AND \n                    zzzsys_user_id<>\'#RECORD_ID#\'\n        \";\n$retval = nuRunQuery($sql);\n$row    = db_fetch_row($retval);\nif($row[0]!=0){\n    $MESSAGE = \'Προσοχή : Το Όνομα Χρήστη «#sus_login_name#» χρησιμοποιείται από κάποιον άλλο χρήστη!\';\n    nuDisplayError($MESSAGE);\n    return;    \n}	',NULL,'',NULL,'function nuGetPost($Field_Name) {\n    $form_post = $_POST[\'nuWindow\'][\'form_data\'][\'data\'][0][\'records\'][0][\'fields\'];\n    for ($x = 0; $x < count($form_post); $x++) {\n       if ( $form_post[$x][\'field\'] == $Field_Name ) {\n           return $form_post[$x][\'value\'];\n       }\n    }\n    return null;\n}\n\n$user = nuGetPost(\'sus_login_name\');\n$pass = nuGetPost(\'nupassword\');\nif($pass != \'\') {\n	$sql = \"UPDATE zzzsys_user SET sus_login_password = md5(CONCAT(\'$user\', \'$pass\')) WHERE zzzsys_user_id = \'#RECORD_ID#\'\";\n	nuRunQuery($sql);\n}','$sql = \"    UPDATE teacher \n            SET user_id = NULL \n            WHERE user_id = \'#RECORD_ID#\'\";\nnuRunQuery($sql);\n\n$sql = \"    UPDATE student \n            SET user_id = NULL \n            WHERE user_id = \'#RECORD_ID#\'\";\nnuRunQuery($sql);\n\n$sql = \"    UPDATE student \n            SET parent_user_id = NULL \n            WHERE parent_user_id = \'#RECORD_ID#\'\";\nnuRunQuery($sql);','function checkEmail(email){\n    \n    var s = document.getElementById(\'email_servers\');\n \n    for (var i = 0; i < s.options.length; i++) {\n        var domain_name  = s.options[i].text;\n        \n        if(domain_name!=\'\' && email.trim().endsWith(\'@\'+domain_name)){\n            return true;\n        }\n    } \n    \n    return false;\n    \n    /*if( email.trim().match(/@gmail\\.com$/)   ||\n        email.trim().match(/@sch\\.gr$/)      ||\n        email.trim().match(/@yahoo\\.gr$/)    ||\n        email.trim().match(/@hotmail\\.com$/)){\n        return true;\n    } else {\n        return false;\n    } */  \n}\n\nfunction checkStrength(password){\n        \n        var msg = \'\';\n        \n        //if the password not set\n		if (!password || (password.length < 6)) { \n			msg += (\'\\nΟ κωδικός πρόσβασης θα πρέπει να αποτελείται από τουλάχιστον έξι (6) χαρακτήρες!\');\n		}\n		\n		//Must have characters\n		if (!password.match(/([a-zA-Z])/)){\n		    msg += (\'\\nΟ κωδικός πρόσβασης θα πρέπει να περιέχει τουλάχιστον ένα γράμμα!\'); \n		} \n		\n        //Must have numbers\n		if (!password.match(/([0-9])/)){\n		    msg += (\'\\nΟ κωδικός πρόσβασης θα πρέπει να περιέχει τουλάχιστον ένα αριθμο!\'); \n		} \n		\n		//Must have at least one special character\n		if (!password.match(/([!,%,&,@,#,$,^,*,?,_,~])/)) {\n		    msg += (\'\\nΟ κωδικός πρόσβασης θα πρέπει να περιέχει τουλάχιστον ένα ειδικό χαρακτήρα (!,%,&,@,#,$,^,*,?,_,~)!\'); \n		}\n		\n		return msg;\n	}\n\nfunction nuLoadEdit() {\n    if(document.getElementById(\'login_with_email_account\').checked){\n        $(\'[id*=sus_login_name]\').hide();\n        $(\'[id*=nupassword]\').hide();\n        $(\'[id*=nuretyped]\').hide();\n    } \n}\n\n\nfunction nuOnSave() {\n\n    if(document.getElementById(\'login_with_email_account\').checked){\n\n        if(checkEmail($(\'#sus_email\').val())){        //OK\n                $(\'#sus_login_name\').val($(\'#sus_email\').val().trim());\n                $(\'#nupassword\').val(\'sisyphos\');\n                $(\'#nuretyped\').val(\'sisyphos\');\n        } else {    \n		    alert(\'Προσοχή : Δεν υποστηρίζεται η σύνδεση με αυτό τον τύπο λογαριασμού email!\');\n		    return false;        \n        }\n    } else {\n        \n        var pass    = document.getElementById(\'nupassword\').value;\n	    var repass  = document.getElementById(\'nuretyped\').value;\n	    \n	    var logname = document.getElementById(\'sus_login_name\').value;\n	    var logname_orig = document.getElementById(\'sus_login_name_orig\').value;\n	    \n	    //checkLogin\n	    if(logname==\'\') {\n            alert(\'Παρακαλώ συμπληρώστε πρώτα το «Όνομα Χρήστη»!\');\n		    return false;\n	    } \n	    \n        if(pass==\'\' && repass==\'\'){\n            if(logname!=logname_orig){\n		        alert(\'Προσοχή : Το «Όνομα Χρήστη» άλλαξε! Πρέπει να εισάγετε εκνέου και τον «Κωδικό Πρόσβασης»!\');\n		        return false;                \n            } \n        } else {\n            if(pass != repass) {\n                alert(\'Ο «Κωδικός Πρόσβασης» δεν ταιριάζει με την «Επιβεβαίωση Κωδικού»...\');\n                return false;\n            } \n            var m = checkStrength(pass)\n            if(m!=\'\'){\n                if(!confirm(\'Ο κωδικός πρόσβασης δεν είναι αρκετά ισχυρός :\'+m+\'\\n\\nΘέλετε να συνεχίσετε;\')){\n                    return false;    \n                }\n            }           \n        }\n    }\n    \n    return true;\n}',NULL,0,100,'2017-03-25 09:05:52','globeadmin','2018-07-28 11:47:19','globeadmin','2020-12-15 17:56:40','globeadmin','',0,NULL),('59a96e2c710af4a','calendar_test','Προγραμματισμός διαγωνίσματος ή τεστ','SELECT * FROM teacher','teacher','id',650,400,'Select \'Προγραμματισμός Διαγωνίσματος ή Τεστ\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function add_calendar_test(param){\n    //hideLoader();\n    if(param && param!=\'\'){\n        var json_data = JSON.parse(param);\n        if(json_data[0]>0){\n            var iframe = parent.document.getElementById(\'calendar_iframe\');\n            iframe.contentWindow.add_event(json_data[0],json_data[1],json_data[2],json_data[3],json_data[4],json_data[5],json_data[6],json_data[7],json_data[8],json_data[9]);\n            nuRemoveModal();    \n        }\n    }\n}\n\nfunction pollute_cards(param){\n   \n    $(\'#period_class_subject_id\').empty();\n    $(\'#period_class_subject_id\').append(\'<option value=\"\"></option>\');\n   \n    if(param && param!=\'\'){\n        var json_data = JSON.parse(param);\n       \n        for(var i=0; i < json_data.length;i++){ \n            $(\'#period_class_subject_id\').append(\'<option value=\"\'+json_data[i][0]+\'\" location=\"\'+json_data[i][2]+\'\">\'+json_data[i][1]+\'</option>\');\n        }\n        \n        if(json_data.length==1){\n            $(\'#period_class_subject_id\').val(json_data[0][0]);\n        }\n        $(\'#location\').val(\'\');\n        \n    }\n}\n\nfunction nuLoadEdit() {\n\n}\n',NULL,0,0,'2017-09-01 17:26:52','globeadmin','2017-12-06 21:09:28','globeadmin','2020-09-18 19:10:30','globeadmin','',0,NULL),('59ac07f003930c8','student_calendar','Ημερολόγιο Σχολείου Μαθητή - Γονέα','SELECT * FROM student','student','id',1150,650,'select \'Ημερολόγιο\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'','nuRunPHP(\'check_permission_lib\');\n\nif(!check_permission()){\n    $MESSAGE = \'Προσοχή! Δεν έχετε άδεια πρόσβασης στα δεδομένα αυτά!\';\n    nuDisplayError($MESSAGE);\n    return;\n}',NULL,NULL,'function delete_appointment_result(param){\n    if(param && param!=\'\'){ \n        //hideLoader();\n        alert(\'Η διαγραφή πραγματοποιήθηκε επιτυχώς!\')\n        var iframe = document.getElementById(\'calendar_iframe\');\n        iframe.contentWindow.remove_event(param);\n    } else {\n        alert(\'Προσοχή! Παρουσιάστηκε σφάλμα!\\nΗ διαγραφή δεν πραγματοποιήθηκε!\')    \n    }\n}',NULL,0,0,'2017-09-03 16:47:28','globeadmin','2020-09-24 12:17:13','globeadmin','2020-09-24 12:19:53','globeadmin','',0,NULL),('59c292e97e52d3e','delete_student_class','Διαγράφει κατανομές μαθητών σε τμήματα','select * from teacher','teacher','id',550,400,'select \'Διαγραφή Κατανομής Μαθητών σε Τμήματα\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function display_delete_result(param){\n    if(param=\'OK\'){\n        alert(\'Η διαγραφή πραγματοποιήθηκε!\');\n        nuRemoveModal();\n    } else {\n        alert(\'Προσοχή : Παρουσιάστηκε πρόβλημα κατά τη διαγραφή!\');\n    }\n}\n\nfunction nuLoadEdit() {\n    sumoTransform(\'class_id\',false,true);\n}',NULL,0,0,'2017-09-20 19:10:17','globeadmin','2017-09-20 21:21:43','globeadmin','2020-09-24 18:39:39','globeadmin','',0,NULL),('59cfad675ee667a','myemail','Εμφανίζει ένα email','SELECT * FROM email','email','id',850,500,'SELECT \'Μήνυμα Email\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function display_sent_result(param){\n    hideLoader();\n    if(param){alert(param);}\n}\n\nfunction nuLoadEdit() { \n    if( \'#nu_user_group#\'!=\'globeadmin\' &&\n        \'#nu_user_group#\'!=\'Administrators\' && \n        \'#nu_user_group#\'!=\'Managers\' && \n        \'#nu_user_group#\'!=\'AssistManagers\' &&\n        \'#nu_user_group#\'!=\'Secretaries\'){\n        \n        var email_addr = $(\'#email_address\').val();\n        var name_replace = email_addr.replace(/./g, \'*\');\n        $(\'#email_address\').val(name_replace);\n    }\n    \n    \n    $(\'#sender_id_disp\').css(\'background-color\', \'#fffff0\');\n    $(\'#sent_at_disp\').css(\'background-color\', \'#fffff0\');\n    $(\'#email_address\').css(\'background-color\', \'#fffff0\');\n    $(\'#fail_code_disp\').css(\'background-color\', \'#fffff0\');\n    $(\'#fail_comments\').css(\'background-color\', \'#fffff0\');\n    $(\'#student_id_disp\').css(\'background-color\', \'#fffff0\');\n    $(\'#teacher_id_disp\').css(\'background-color\', \'#fffff0\');\n    $(\'#email_subject\').css(\'background-color\', \'#fffff0\');\n}',NULL,0,0,'0000-00-00 00:00:00','','2018-07-05 11:04:25','globeadmin','2018-07-05 11:04:25','globeadmin','',0,NULL),('59d294a40ecced8','add_student_to_classes','Προσθήκη Μαθητή σε τμήματα','select * from teacher','student','id',550,400,'select \'Προσθήκη Μαθητή σε Τμήματα\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function display_add_result(param){\n    if(param=\'OK\'){\n        parent.reload_classes(param);\n        nuRemoveModal();\n    } else {\n        alert(\'Προσοχή : Παρουσιάστηκε πρόβλημα κατά την εισαγωγή!\');\n    }\n}\n\nfunction nuLoadEdit() {\n    sumoTransform(\'class_id\',false,true);\n}',NULL,0,0,'2017-10-02 22:33:56','globeadmin','2017-10-02 22:53:21','globeadmin','2017-10-02 22:57:58','globeadmin','',0,NULL),('59d67ca712d3ffa','teachers_home_new','Teachers New Home Form','select * from teacher','teacher','id',1000,520,'select \'Καθηγητής\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'','nuRunPHP(\'addSessionVariablesRow\');\nnuRunPHP(\'initializeSessionVariables\');\n',NULL,NULL,'function open_teacher_form(form_id){\n    \n    var t=get_session_variable(\'teacher_id\');\n\n    if  (($.isNumeric(t)) && (t!=-1)) {\n        nuOpenForm(\'\',\'\', form_id, t,\'Καθηγητής\');\n    } else{\n        if(nuIsGA()){\n            nuOpenForm(\'\',\'\', form_id, 26,\'Καθηγητής\');\n        } else{\n            alert(\"Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με Καθηγητή!\");\n        }\n    }    \n}\n\nfunction ajax_results(param){\n    if(param && param !=\'\' && param !=\'0\'){\n        e = document.getElementById(\'ab_warning_id\');\n        e.style.display = \'block\';\n        e.title = \'Έχετε \'+param+\' διδασκαλίες σε εκκρεμότητα\';\n    }\n}\n\n\nfunction nuLoadEdit() {  \n    loadImg(\'ucard\');\n    loadImg(\'absences\');\n    loadImg(\'std\');\n    loadImg(\'calendar\');\n    loadImg(\'amark\');\n    loadImg(\'message_center\');\n    loadImg(\'subles\');\n    loadImg(\'ebooks\');\n    loadImg(\'advisor\');\n    \n    set_session_variable(\'class_id\',-1);\n    set_session_variable(\'subject_id\',-1);\n    \n    $(\'#sisyphos_info_label2\').css(\'background-color\', \'#faf0e6\');\n    $(\'#sisyphos_info_label2\').css(\'color\', \'#666666\');\n    $(\'#sisyphos_info_label21\').css(\'background-color\', \'#faf0e6\');\n    $(\'#sisyphos_info_label21\').css(\'color\', \'#666666\');\n\n    set_session_variable(\'system_url\',window.location.href);\n    nuAjax(\'absence_has_card_not_registered\' , \'ajax_results\',{async:true});\n}\n',NULL,0,0,'2017-10-05 21:40:39','globeadmin','2021-03-22 19:49:22','globeadmin','2021-03-22 19:49:22','globeadmin','',0,NULL),('59d7d6e9ecc73da','teacher_absences','Καθηγητής - Απουσίες','select * from teacher','teacher','id',1000,520,'select \'Απουσίες\'','0','0','0',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'','nuRunPHP(\'check_permission_lib\');\n\nif(!check_permission(\'1\')){\n    $MESSAGE = \'Προσοχή! Δεν έχετε άδεια πρόσβασης στα δεδομένα αυτά!\';\n    nuDisplayError($MESSAGE);\n    return;\n}',NULL,NULL,'function ajax_results(param){\n    if(param && param !=\'\' && param !=\'0\'){\n        e = document.getElementById(\'ab_warning_id\');\n        e.style.display = \'block\';\n        e.title = \'Έχετε \'+param+\' διδασκαλίες σε εκκρεμότητα\';\n    }\n}\n\nfunction nuLoadEdit() {\n    \n    set_session_variable(\'class_id\',-1);\n    set_session_variable(\'subject_id\',-1);\n    set_session_variable(\'mark_print_grading_period_id\',-1);\n    set_session_variable(\'mark_print_class_id\',-1);\n    set_session_variable(\'mark_print_subject_id\',-1);\n    \n    \n    loadImg(\'pabsen\');\n    loadImg(\'search\');\n    loadImg(\'rsearch\');\n    loadImg(\'pmsg\');\n    loadImg(\'sbook\');\n    loadImg(\'jasabs\');\n    loadImg(\'dabsen\');\n    loadImg(\'abprint\');\n    loadImg(\'excel\');\n    \n    if (typeof myInterval != \'undefined\'){\n        if(myInterval){\n            clearInterval(myInterval);\n        }\n    }\n    \n    if (typeof myTimeOut != \'undefined\'){\n        if(myTimeOut){\n            clearTimeout(myTimeOut);\n        }\n    }\n    \n    $(\'#abcence_periodbtn\').focus();\n    \n    nuAjax(\'absence_has_card_not_registered\' , \'ajax_results\',{async:true});\n}',NULL,0,0,'2017-10-06 22:18:02','globeadmin','2021-02-27 09:46:55','globeadmin','2021-02-27 09:46:55','globeadmin','',0,NULL),('59d7d745b1eecbf','teacher_student_responsible','Καθηγητής - Υπεύθυνος σε Μαθητές ','select * from teacher','teacher','id',1000,530,'select \'Μαθητές\'','0','0','0',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'','nuRunPHP(\'check_permission_lib\');\n\nif(!check_permission(\'1\')){\n    $MESSAGE = \'Προσοχή! Δεν έχετε άδεια πρόσβασης στα δεδομένα αυτά!\';\n    nuDisplayError($MESSAGE);\n    return;\n}',NULL,NULL,'function openStudent(pThis){\n    var student_id = $(\'#\' + nuRowPrefix(pThis) + \'_nuPrimaryKey\').val();\n    nuOpenForm(\'\',\'\', \'5476201e5a3d38f\', student_id,\'Μαθητής\');\n    //nuOpenFormInFrame(\'5476201e5a3d38f\',student_id); //--open form in floating window\n}\n\nfunction get_excel_file(param){\n    if(param!=\'\' && param!=\'-1\'){\n        nuSetHash(\'backup_file_name\', param);\n        nuSetHash(\'send_file_name\', \'students_export.xls\');\n        nuRunPHP(\'backup_db_get_file\',\'hidden_iframe\');\n    } else {\n        alert(\'Η δημιουργία του αρχείου Excel απέτυχε!\'); \n    }\n    hideLoader();\n}\n',NULL,0,0,'2017-10-06 22:19:33','globeadmin','2018-07-03 01:47:16','globeadmin','2021-03-09 19:39:02','globeadmin','',0,NULL),('59d7d7986aed52d','teacher_marks','Καθηγητής - Αξιολόγηση και Ποινές','select * from teacher','teacher','id',1000,520,'select \'Αξιολόγηση Μαθητών\'','0','0','0',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'','nuRunPHP(\'check_permission_lib\');\n\nif(!check_permission(\'1\')){\n    $MESSAGE = \'Προσοχή! Δεν έχετε άδεια πρόσβασης στα δεδομένα αυτά!\';\n    nuDisplayError($MESSAGE);\n    return;\n}',NULL,NULL,'function nuLoadEdit() {\n    \n    set_session_variable(\'class_id\',-1);\n    set_session_variable(\'subject_id\',-1);\n    set_session_variable(\'mark_print_grading_period_id\',-1);\n    set_session_variable(\'mark_print_class_id\',-1);\n    set_session_variable(\'mark_print_subject_id\',-1);\n    \n    loadImg(\'marks\');\n    loadImg(\'grprint\');\n    loadImg(\'mpost\');\n    loadImg(\'critirion\');\n    loadImg(\'cards\');\n}',NULL,0,0,'2017-10-06 22:20:56','globeadmin','2017-11-12 16:24:31','globeadmin','2017-11-12 16:24:32','globeadmin','',0,NULL),('59d7d7da6d30b22','teacher_messages','Καθηγητής - Μηνύματα','select * from teacher','teacher','id',1000,520,'select \'Μηνύματα\'','0','0','0',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'','nuRunPHP(\'check_permission_lib\');\n\nif(!check_permission(\'1\')){\n    $MESSAGE = \'Προσοχή! Δεν έχετε άδεια πρόσβασης στα δεδομένα αυτά!\';\n    nuDisplayError($MESSAGE);\n    return;\n}',NULL,NULL,'function nuLoadEdit() {\n    \n    loadImg(\'sms_search\');\n    loadImg(\'students_sms\');\n    loadImg(\'search_email\');\n    loadImg(\'students_email\');\n    loadImg(\'teachers_email\');\n    \n    $(\'#sms_disp\').css(\'fontSize\', \'18px\');\n    $(\'#sms_disp\').css(\'font-weight\', \'bold\');\n    $(\'#sms_disp\').css(\'background-color\', \'LightYellow\');\n    $(\'#sms_disp\').css(\'color\', \'red\');\n\n}',NULL,0,0,'2017-10-06 22:22:02','globeadmin','2017-11-12 16:23:41','globeadmin','2017-11-12 16:23:41','globeadmin','',0,NULL),('59d7d837262870c','teacher_subjects','Καθηγητής - Διδασκαλίες','select * from teacher','teacher','id',1000,520,'select \'Διδασκαλίες\'','0','1','0',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'','nuRunPHP(\'check_permission_lib\');\n\nif(!check_permission(\'1\')){\n    $MESSAGE = \'Προσοχή! Δεν έχετε άδεια πρόσβασης στα δεδομένα αυτά!\';\n    nuDisplayError($MESSAGE);\n    return;\n}',NULL,NULL,'function get_excel_file(param){\n    if(param!=\'\' && param!=\'-1\'){\n        nuSetHash(\'backup_file_name\', param);\n        nuSetHash(\'send_file_name\', \'class_export.xls\');\n        nuRunPHP(\'backup_db_get_file\',\'hidden_iframe\');\n    } else {\n        alert(\'Η δημιουργία του αρχείου Excel απέτυχε!\'); \n    }\n    hideLoader();\n}\n\n\nfunction nuLoadEdit() {\n    set_session_variable(\'class_id\',-1);\n    set_session_variable(\'subject_id\',-1);\n}',NULL,0,0,'2017-10-06 22:23:35','globeadmin','2018-02-06 00:07:50','globeadmin','2018-07-13 10:56:30','globeadmin','',0,NULL),('59e22e4fa1018fd','student_personal','Μαθητής - Προσωπικά Στοιχεία','select * from student','student','id',1050,520,'select concat(IFNULL(surname,\'\'),\' \',IFNULL(name,\'\'), \' (Στοιχεία Μαθητή)\') from student where id=#RECORD_ID#',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'','nuRunPHP(\'check_permission_lib\');\n\nif(!check_permission()){\n    $MESSAGE = \'Προσοχή! Δεν έχετε άδεια πρόσβασης στα δεδομένα αυτά!\';\n    nuDisplayError($MESSAGE);\n    return;\n}',NULL,NULL,'function nuLoadEdit() {\n\n    loadImg(\'log_user\');\n    loadImg(\'notification_type\');\n    \n    $(\'#nuButton0\').focus();\n}\n',NULL,0,0,'2017-10-14 18:33:35','globeadmin','2017-11-12 16:28:13','globeadmin','2017-11-12 16:35:48','globeadmin','',0,NULL),('59e22ed0a598932','student_mark','Μαθητής - Αξιολόγηση','select * from student','student','id',1050,520,'select concat(IFNULL(surname,\'\'),\' \',IFNULL(name,\'\'), \' (Αξιολόγηση)\') from student where id=#RECORD_ID#',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'','nuRunPHP(\'check_permission_lib\');\n\nif(!check_permission()){\n    $MESSAGE = \'Προσοχή! Δεν έχετε άδεια πρόσβασης στα δεδομένα αυτά!\';\n    nuDisplayError($MESSAGE);\n    return;\n}',NULL,NULL,'function nuLoadEdit() {\n    $(\'#nuButton0\').focus();\n}\n',NULL,0,0,'2017-10-14 18:35:44','globeadmin','2017-11-12 16:32:07','globeadmin','2017-11-12 16:32:07','globeadmin','',0,NULL),('59e22f4f52546e3','student_message','Μαθητής - Αποστολή Email','select * from student','student','id',1050,550,'select \'Αποστολή Μηνύματος σε Καθηγητές\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'','nuRunPHP(\'check_permission_lib\');\n\nif(!check_permission()){\n    $MESSAGE = \'Προσοχή! Δεν έχετε άδεια πρόσβασης στα δεδομένα αυτά!\';\n    nuDisplayError($MESSAGE);\n    return;\n}',NULL,NULL,'function passTinymceContents(){ \n    return(\'\');\n}\n\nfunction display_sent_result(param){\n    hideLoader();\n    alert(param);\n}\n\nfunction show_email_results(param){\n    alert(param);\n}\n\n\nfunction refresh_lessons(param){\n    $(\'#print_marks_class_subject_selection\').empty()\n    if(!param==\'\'){\n    var ln = param.split(\'\\n\'); \n    for(i=0;i<ln.length;i++){  \n        var fld=ln[i].split(\'\\t\');\n        $(\'#print_marks_class_subject_selection\').append(\'<option value=\"\'+fld[0]+\'\">\'+fld[1]+\'</option>\'); \n        }\n    }\n}\n\nfunction nuLoadEdit() {\n    \n    loadImg(\'sendmail\');\n    \n    var all_teacher_ids = [];\n    var all_teacher_names = [];\n\n    var s = document.getElementById(\"student_home_school_teacher_email\");\n \n    for (var i = 0; i < s.options.length; i++) {\n        \n        var teacher_id=s.options[i].value;\n        var teacher_name=s.options[i].text;\n        \n        all_teacher_ids.push(teacher_id);\n        all_teacher_names.push(teacher_name);\n        }\n    \n    $(\'#student_home_school_teacher_email\').empty();\n    $(\'#student_home_school_teacher_email\').append(\"<option value=-1>Τη Διεύθυνση του Σχολείου</option>\");\n    \n    for(i=0;i<all_teacher_ids.length;i++){\n        if(all_teacher_names[i]!=\'\'){\n            $(\'#student_home_school_teacher_email\').append(\'<option value=\"\'+all_teacher_ids[i]+\'\">\'+all_teacher_names[i]+\'</option>\'); \n            }\n        }\n    \n    \n    sumoTransform(\'student_home_school_teacher_email\',false,true);\n    \n    nuSetHash(\'FILES\' , \'\');\n    $(\'#nuButton0\').focus();\n}\n',NULL,0,0,'2017-10-14 18:37:51','globeadmin','2021-02-16 15:14:13','globeadmin','2021-02-16 15:14:13','globeadmin','',0,NULL),('59e22f9965b5362','student_absence','Μαθητής - Απουσίες','select * from student','student','id',1050,520,'select concat(IFNULL(surname,\'\'),\' \',IFNULL(name,\'\'), \' (Απουσίες)\') from student where id=#RECORD_ID#',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'','nuRunPHP(\'check_permission_lib\');\n\nif(!check_permission()){\n    $MESSAGE = \'Προσοχή! Δεν έχετε άδεια πρόσβασης στα δεδομένα αυτά!\';\n    nuDisplayError($MESSAGE);\n    return;\n}',NULL,NULL,'function nuLoadEdit() {\n    \n    loadImg(\'search\');\n\n    \n    /*$(\'#unjustified_absence_sum_disp\').css(\'fontSize\', \'18px\');\n    $(\'#unjustified_absence_sum_disp\').css(\'font-weight\', \'bold\');\n    $(\'#unjustified_absence_sum_disp\').css(\'background-color\', \'LightYellow\');\n    $(\'#unjustified_absence_sum_disp\').css(\'color\', \'red\');\n\n    $(\'#justified_absence_sum_disp\').css(\'fontSize\', \'18px\');\n    $(\'#justified_absence_sum_disp\').css(\'font-weight\', \'bold\');\n    $(\'#justified_absence_sum_disp\').css(\'background-color\', \'LightYellow\');\n    $(\'#justified_absence_sum_disp\').css(\'color\', \'green\');\n    \n    $(\'#parent_justified_days_disp\').css(\'fontSize\', \'18px\');\n    $(\'#parent_justified_days_disp\').css(\'font-weight\', \'bold\');\n    $(\'#parent_justified_days_disp\').css(\'background-color\', \'LightYellow\');\n    $(\'#parent_justified_days_disp\').css(\'color\', \'#FFA500\');*/\n    \n    \n    $(\'#prev_total_absences\').css(\'background-color\', \'LightYellow\');\n    $(\'#absence_counts_insystem_disp\').css(\'background-color\', \'LightYellow\');\n    \n    $(\'#absence_counts_sum_disp\').css(\'fontSize\', \'20px\');\n    $(\'#absence_counts_sum_disp\').css(\'font-weight\', \'bold\');\n    $(\'#absence_counts_sum_disp\').css(\'background-color\', \'LightYellow\');\n    $(\'#absence_counts_sum_disp\').css(\'color\', \'red\');    \n\n    $(\'#justified_absence_nocounts_disp\').css(\'fontSize\', \'16px\');\n    $(\'#justified_absence_nocounts_disp\').css(\'font-weight\', \'bold\');\n    $(\'#justified_absence_nocounts_disp\').css(\'background-color\', \'LightYellow\');\n    $(\'#justified_absence_nocounts_disp\').css(\'color\', \'#00AA00\');\n    \n    $(\'#nuButton0\').focus();\n}\n',NULL,0,0,'2017-10-14 18:39:05','globeadmin','2018-03-10 17:14:10','globeadmin','2020-04-02 16:25:30','globeadmin','',0,NULL),('59e22fca2af8d03','student_penalty','Μαθητής - Ποινές','select * from student','student','id',1050,520,'select concat(IFNULL(surname,\'\'),\' \',IFNULL(name,\'\'), \' (Ποινές & Επιβραβεύσεις)\') from student where id=#RECORD_ID#',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'','nuRunPHP(\'check_permission_lib\');\n\nif(!check_permission()){\n    $MESSAGE = \'Προσοχή! Δεν έχετε άδεια πρόσβασης στα δεδομένα αυτά!\';\n    nuDisplayError($MESSAGE);\n    return;\n}',NULL,NULL,'function nuLoadEdit() {\n    $(\'#nuButton0\').focus();\n}\n',NULL,0,0,'2017-10-14 18:39:54','globeadmin','2022-01-08 14:26:20','globeadmin','2022-01-08 14:26:20','globeadmin','',0,NULL),('59e22ff819cd774','student_subject','Μαθητής - Διδασκαλίες','select * from student','student','id',1050,700,'select concat(IFNULL(surname,\'\'),\' \',IFNULL(name,\'\'), \' (Διδασκαλίες & ΩΠ)\') from student where id=#RECORD_ID#',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'','nuRunPHP(\'check_permission_lib\');\n\nif(!check_permission()){\n    $MESSAGE = \'Προσοχή! Δεν έχετε άδεια πρόσβασης στα δεδομένα αυτά!\';\n    nuDisplayError($MESSAGE);\n    return;\n}',NULL,NULL,'function nuLoadEdit() {\n    $(\'#nuButton0\').focus();\n}\n',NULL,0,0,'2017-10-14 18:40:40','globeadmin','2018-07-13 10:40:36','globeadmin','2018-07-13 10:40:36','globeadmin','',0,NULL),('59e23027879009a','student_school','Μαθητής - Στοιχεία Σχολείου','select * from student','student','id',1050,520,'select \'Πληροφορίες για το Σχολείο\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'','nuRunPHP(\'check_permission_lib\');\n\nif(!check_permission()){\n    $MESSAGE = \'Προσοχή! Δεν έχετε άδεια πρόσβασης στα δεδομένα αυτά!\';\n    nuDisplayError($MESSAGE);\n    return;\n}',NULL,NULL,'function nuLoadEdit() {\n    $(\'#nuButton0\').focus();\n}\n',NULL,0,0,'2017-10-14 18:41:27','globeadmin','2018-06-17 09:51:32','globeadmin','2018-06-17 09:51:32','globeadmin','',0,NULL),('59e5cdf8d43772d','ballot','ballot','SELECT b1.*,b2.ballot_state\nFROM ballot as b1\nINNER JOIN (select id as b_id,\nif(is_active=\'0\',\'Ανενεργή\',if(NOW() BETWEEN CONCAT(start_date,\' \',start_time) AND CONCAT(end_date,\' \',end_time),\'Ανοιχτή Κάλπη\',\nif(NOW()>CONCAT(end_date,\' \',end_time),\'Ολοκληρώθηκε\',\'Θα Ενεργοποιηθεί\')\n)) \nas ballot_state from ballot) as b2 ON b1.id=b2.b_id\nwhere   \'#nu_user_group#\' IN (\'Managers\',\'AssistManagers\',\'Administrators\',\'globeadmin\') OR\n        teacher_id = (select teacher_id from session_variables where session_id=\'#session_id#\') OR\n        is_shared = 1\norder by is_active desc,b2.ballot_state,start_date desc,start_time desc,end_date desc,end_time desc','ballot','id',1000,600,'SELECT CONCAT(LEFT(name, 30),IF(LENGTH(name)>30,\'...\',\'\')) FROM ballot WHERE id=\'#RECORD_ID#\'','1','1','1',NULL,NULL,NULL,'Νέα Ψηφοφορία',NULL,NULL,NULL,NULL,NULL,NULL,'select if((\'#nu_user_group#\' IN (\'globeadmin\',\'Managers\',\'AssistManagers\',\'Administrators\')) OR \'#nu_new_record#\'=\'1\' OR \'#teacher_id#\'=teacher_id,\'1\',\'0\')  \nfrom session_variables \nwhere session_id=\'#session_id#\'','select if((\'#nu_user_group#\' IN (\'globeadmin\',\'Managers\',\'AssistManagers\',\'Administrators\')) OR \'#teacher_id#\'=teacher_id,\'1\',\'0\')  \nfrom session_variables \nwhere session_id=\'#session_id#\'',NULL,NULL,NULL,'nuRunPHP(\'notification_add_lib\');\n\n$cur_datetime = date(\'Y-m-d H:i:s\');\n\n$sql = \"    SELECT COUNT(*)\n            FROM ballot_paper\n            WHERE ballot_id = \'#RECORD_ID#\'\n        \";\n$retval = nuRunQuery($sql);\n$row    = db_fetch_row($retval);\n$papers = $row[0];\n\n$sql = \"    SELECT is_anonymous,max_numb_of_choices\n            FROM ballot\n            WHERE id = \'#RECORD_ID#\'\n        \";\n$retval = nuRunQuery($sql);\n$row    = db_fetch_row($retval);\n$is_anonymous = $row[0];\n$max_numb_of_choices = $row[1];\n\n\nif(\'#start_date#\'.\'T\'.\"#start_time#\">=\'#end_date#\'.\'T\'.\"#end_time#\"){\n    $MESSAGE = \'Προσοχή! Δεν μπορεί η έναρξη τής ψηφοφορίας να είναι μεταγενέστερη της λήξης!\';\n    nuDisplayError($MESSAGE);\n    return;\n}\n\nif($papers>0 && \'#start_date#\'.\' \'.\"#start_time#\"> $cur_datetime){\n    $MESSAGE = \'Προσοχή! Έχουν ήδη καταχωρηθεί ψήφοι! Δεν μπορείτε να μεταθέσετε την έναρξη της ψηφοφορίας!\';\n    nuDisplayError($MESSAGE);\n    return;    \n}\n\nif($papers>0 && \'#is_anonymous#\' != $is_anonymous){\n    $MESSAGE = \'Προσοχή! Έχουν ήδη καταχωρηθεί ψήφοι! Δεν μπορείτε να αλλάξετε το ανώνυμο/επώνυμο της ψηφοφορίας!\';\n    nuDisplayError($MESSAGE);\n    return;     \n}\n\nif($papers>0 && \'#max_numb_of_choices#\' != $max_numb_of_choices){\n    $MESSAGE = \'Προσοχή! Έχουν ήδη καταχωρηθεί ψήφοι! Δεν μπορείτε να αλλάξετε τον μέγιστο αριθμό των επιλογών της ψηφοφορίας!\';\n    nuDisplayError($MESSAGE);\n    return;     \n}\n\nif((\'#ids#\'!=\'\' && \'#ids#\'!=\'#\'.\'ids#\') && $papers>0){\n    $MESSAGE = \'Προσοχή! Έχουν ήδη καταχωρηθεί ψήφοι! Δεν μπορείτε να αλλάξετε τη σειρά των υποψηφίων\';\n    nuDisplayError($MESSAGE);\n    return; \n}\n\nif(\'#calendar_event_id#\'!=\'\' && \'#calendar_event_id#\'!= \'#\'.\'calendar_event_id#\'){\n\n    $sql = \"        \n        SELECT\n            name,\n            start_date,\n            start_time,\n            end_date,\n            end_time\n        FROM ballot \n        WHERE \n            id=\'#RECORD_ID#\'\";\n\n    $retval=nuRunQuery($sql);\n    $row = db_fetch_row($retval);\n    \n    \n    $new_title      = \'Ψηφοφορία :\'.\'#name#\';\n    $new_location   = \'\';\n    $new_start_date = \'#start_date#\';\n    $new_start_time = \'#start_time#\';\n    $new_end_date   = \'#end_date#\';\n    $new_end_time   = \'#end_time#\';\n    $new_allDay     = \'ΌΧΙ\';\n    $new_description= \'#description#\';      \n        \n    if( \'#create_notification#\'==\'1\' && \'#is_active#\'==\'1\' &&\n        ($row[0]!=\'#name#\' ||\n        $row[1]!=\'#start_date#\' ||\n        $row[2]!=\'#start_time#\' ||\n        $row[3]!=\'#end_date#\' ||\n        $row[4]!=\'#end_time#\')\n        ){\n        \n        $sql = \"SELECT id,user_group_id FROM calendar_event_access WHERE calendar_event_id=\'#calendar_event_id#\'\";\n        $rv = nuRunQuery($sql);\n        while($r=db_fetch_row($rv)){\n            if($r[1]==\'547de4c65675a29\' || $r[1]==\'5717ba3eb32c252\'){\n                calendar_event_notification($r[0],8,$new_title,$new_location,$new_start_date,$new_start_time,$new_end_date,$new_end_time,$new_allDay);\n            }       \n        }\n    }\n    \n    $sql = \"    UPDATE calendar_event SET\n                    title=\'$new_title\',\n                    start_date=\'$new_start_date\',\n                    start_time=\'$new_start_time\',\n                    end_date=\'$new_end_date\',\n                    end_time=\'$new_end_time\',\n                    description=\'$new_description\'\n                WHERE\n                    id=\'#calendar_event_id#\'\";\n    nuRunQuery($sql);\n}\n\n\n',NULL,'/***********************************************************/\n$sql = \"    SELECT COUNT(*)\n            FROM ballot_paper\n            WHERE ballot_id = \'#RECORD_ID#\'\n        \";\n$retval = nuRunQuery($sql);\n$row    = db_fetch_row($retval);\nif($row[0]!=0){\n    $MESSAGE = \'Προσοχή : Έχουν ήδη ψηφίσει \'.$row[0].\' ψηφοφόροι!! Η διαγραφή δε μπορεί να πραγματοποιηθεί!\';\n    nuDisplayError($MESSAGE);\n    return;    \n}\n/***********************************************************/',NULL,'if(\'#is_active#\'==\'0\'){\n    $sql=\"UPDATE ballot SET create_notification=\'0\' where id=\'#RECORD_ID#\'\";\n    nuRunQuery($sql);\n}\n\nif(\'#ids#\'!=\'\' && \'#ids#\'!=\'#\'.\'ids#\'){\n    $ids = explode(\",\", \'#ids#\');\n    $i=1;\n    foreach($ids as $id) {\n        $sql=\"update ballot_choice set hierarchy=\'\".$i.\"\' where id=\'\".$id.\"\'\";\n        nuRunQuery($sql);\n        $i++;    \n    }\n}\nif(\'#nu_new_record#\'==\'1\'){\n    $sql = \"\n            INSERT INTO calendar_event (\n                                    id,\n                                    title,\n                                    description,\n                                    allDay,\n                                    start_date,\n                                    end_date,\n                                    start_time,\n                                    end_time,\n                                    color,\n                                    backgroundColor,\n                                    borderColor,\n                                    textColor,\n                                    is_exam,\n                                    is_test,\n                                    is_ballot,\n                                    teacher_id ,\n                                    location,\n                                    exam_class_id,\n                                    exam_subject_id)\n                                VALUES(\n                                    NULL,\n                                    \'Ψηφοφορία : #name#\',\n                                    \'#description#\',\n                                    \'0\',\n                                    \'#start_date#\',\n                                    \'#end_date#\',\n                                    \'#start_time#\',\n                                    \'#end_time#\',\n                                    \'#FFA500\',\n                                    NULL,\n                                    NULL,\n                                    NULL,\n                                    \'0\',\n                                    \'0\',\n                                    \'1\',\n                                    \'#teacher_id#\',\n                                    \'\',\n                                    NULL,\n                                    NULL)\n            \";\n    $t = nuRunQuery($sql,NULL,true);\n    \n    $sql = \"UPDATE ballot SET calendar_event_id=$t WHERE id=\'#RECORD_ID#\'\";\n    nuRunQuery($sql);\n} else if(\'#nu_edited_record#\'==\'1\' && \'#calendar_event_id#\'!=\'\' && \'#calendar_event_id#\'!= \'#\'.\'calendar_event_id#\'){\n    $sql = \"    UPDATE calendar_event SET\n                    title           = \'Ψηφοφορία : #name#\',\n                    description     = \'#description#\',\n                    start_date      = \'#start_date#\',\n                    end_date        = \'#end_date#\',\n                    start_time      = \'#start_time#\',\n                    end_time        = \'#end_time#\'\n                WHERE id = \'#calendar_event_id#\'\n            \";\n    nuRunQuery($sql);    \n}','// CLEAN UP\n\nnuRunPHP(\'notification_add_lib\');\n\n$sql = \"DELETE FROM ballot_choice WHERE ballot_id = \'#RECORD_ID#\'\";\n$retval = nuRunQuery($sql);\n\n$sql = \"DELETE FROM ballot_voter WHERE ballot_id = \'#RECORD_ID#\'\";\n$retval = nuRunQuery($sql);\n\n$sql = \"DELETE FROM ballot_vote WHERE ballot_paper_id IN (SELECT ballot_paper.id FROM ballot_paper WHERE  ballot_id = \'#RECORD_ID#\')\";\n$retval = nuRunQuery($sql);\n\n$sql = \"DELETE FROM ballot_paper WHERE ballot_id = \'#RECORD_ID#\'\";\n$retval = nuRunQuery($sql);\n\n\nif(\'#calendar_event_id#\'!=\'\' && \'#calendar_event_id#\'!= \'#\'.\'calendar_event_id#\'){\n\n    if(\'#create_notification#\'==\'1\'){\n        $sql = \"SELECT id,user_group_id FROM calendar_event_access WHERE calendar_event_id=\'#calendar_event_id#\'\";\n        $retval = nuRunQuery($sql);\n\n        while($row=db_fetch_row($retval)){\n            if($row[1]==\'547de4c65675a29\' || $row[1]==\'5717ba3eb32c252\'){\n                calendar_event_notification($row[0],9);\n            }\n        }\n    }\n\n    $sql=\"DELETE FROM calendar_event WHERE id=\'#calendar_event_id#\'\";\n    nuRunQuery($sql);\n\n    $sql=\"DELETE FROM calendar_event_access WHERE calendar_event_id=\'#calendar_event_id#\'\";\n    nuRunQuery($sql);    \n}\n\n\n','var my_id = \'#RECORD_ID#\';\n\n\nfunction delete_voters_result(param){\n    if(param==\'-1\'){\n        alert(\'Προσοχή: Παρουσιάστηκε πρόβλημα κατά την αφαίρεση των ψηφοφόρων!\');\n    } else if(param !=\'\'){\n        alert(\'Η αφαίρεση των ψηφοφόρων πραγματοποιήθηκε επιτυχώς!\\n\'+param);\n    }\n    nuRunPHP(\'show_participants_ballot\',\'participants_iframe\');\n    hideLoader();\n}\n\nfunction add_voters_result(param){\n    if(param==\'-1\'){\n        alert(\'Προσοχή: Παρουσιάστηκε πρόβλημα κατά την προσθήκη των ψηφοφόρων!\');\n    } else if(param !=\'\'){\n        alert(\'Η προσθήκη των ψηφοφόρων πραγματοποιήθηκε επιτυχώς!\\n\'+param);\n    }\n    nuRunPHP(\'show_participants_ballot\',\'participants_iframe\');\n    hideLoader();\n}\n\n\nfunction delete_choices_result(param){\n    if(param==\'\'){\n        alert(\'Προσοχή: Παρουσιάστηκε πρόβλημα κατά την αφαίρεση των υποψηφιοτήτων!\');\n    } else{\n        alert(\'Η αφαίρεση των υποψηφιοτήτων πραγματοποιήθηκε επιτυχώς!\');\n    }   \n    nuRunPHP(\'show_ballot_choices\',\'choices_iframe\');\n}\n\nfunction add_students_choices_result(param){\n    if(param==\'\'){\n        alert(\'Προσοχή: Παρουσιάστηκε πρόβλημα κατά την προσθήκη των υποψηφίων!\');\n    } else{\n        alert(param);\n    } \n    nuRunPHP(\'show_ballot_choices\',\'choices_iframe\');\n}\n\nfunction reorder_choices_result(){\n    nuRunPHP(\'show_ballot_choices\',\'choices_iframe\');    \n}\n\nfunction nuLoadEdit() { \n    \n    $(\'#selection1\').empty();\n    \n    if(     \'#nu_user_group#\'==\'globeadmin\' || \n            \'#nu_user_group#\'==\'Managers\' || \n            \'#nu_user_group#\'==\'AssistManagers\' || \n            \'#nu_user_group#\'==\'Administrators\' ||\n            \'#nu_user_group#\'==\'Secretaries\'){\n        $(\'#selection1\').append(\'<option value=1>Όλους τους Μαθητές / Γονείς Τάξης</option>\');\n        $(\'#selection1\').append(\'<option value=2>Όλους τους Μαθητές / Γονείς Τμήματος</option>\');\n        $(\'#selection1\').append(\'<option value=3>Συγκεκριμένους Μαθητές / Γονείς</option>\');\n        \n    } else {\n        $(\'#selection1\').append(\'<option value=2>Όλους τους Μαθητές / Γονείς ενός Τμήματος</option>\');\n        $(\'#selection1\').append(\'<option value=3>Συγκεκριμένους Μαθητές / Γονείς</option>\');            \n    }\n\n    sumoTransform(\'student_id_select\',true,true);\n    sumoTransform(\'class_id_select\',false,true);\n    sumoTransform(\'grade_id_select\',false,false);\n    \n    sumoTransform(\'choice_student_id_select\',true,true);\n    \n    document.getElementById(\'students_check\').checked = true;\n    \n    $(\'[id*=grade_id_select]\').hide();\n    $(\'[id*=class_id_select]\').hide();\n    \n    $(\'#selection1\').val(\'3\');\n    \n    $(\'#max_numb_of_choices\').css(\'fontSize\', \'18px\');\n    $(\'#max_numb_of_choices\').css(\'font-weight\', \'bold\');\n    $(\'#max_numb_of_choices\').css(\'background-color\', \'LightYellow\');\n    $(\'#max_numb_of_choices\').css(\'color\', \'green\');\n    \n    var s = $(\'#status\').val();\n    \n    $(\'#status\').css(\'fontSize\', \'18px\');\n    $(\'#status\').css(\'font-weight\', \'bold\');\n    $(\'#status\').css(\'color\', \'LightYellow\');\n    \n    if(s==\'Ανοιχτή Κάλπη\'){\n        $(\'#status\').css(\'background-color\', \'green\');    \n    } else if(s==\'Θα Ενεργοποιηθεί\'){\n        $(\'#status\').css(\'background-color\', \'orange\');    \n    } else if(s==\'Ολοκληρώθηκε\'){\n        $(\'#status\').css(\'background-color\', \'blue\');    \n    } else if(s==\'Ανενεργή\'){\n        $(\'#status\').css(\'background-color\', \'gray\');    \n    }\n    \n    if(!document.getElementById(\'is_active\').checked){\n        nuDisable(\'create_notification\');\n        document.getElementById(\'create_notification\').checked = false;\n    }\n}\n\n\nfunction nuLoadBrowse() {\n    var rows = nuBrowseRows();\n     \n    var row_len = rows.toString().length;\n    var pad = \"0000\";\n     \n    for( var i = 0; i < rows; i++ ) {\n        var rowString = i.toString();\n        var rowNum = pad.substring(0, pad.length - rowString.length ) + rowString;\n        var id = \'row_\'+rowNum+\'_col_5\';\n        if( $(\"div[id=\'\"+id+\"\']\").text().trim().match(/Ανοιχτή Κάλπη/) ) {\n            $(\"div[id^=\'row_\"+rowNum+\"\']\").css(\'color\', \'LightYellow\');\n            $(\"div[id^=\'row_\"+rowNum+\"\']\").css(\'font-weight\', \'bold\');\n            $(\"div[id^=\'row_\"+rowNum+\"\']\").css(\'background-color\', \'green\');\n        }\n        if( $(\"div[id=\'\"+id+\"\']\").text().trim().match(/Θα Ενεργοποιηθεί/) ) {\n            $(\"div[id^=\'row_\"+rowNum+\"\']\").css(\'color\', \'orange\');\n        }\n        if( $(\"div[id=\'\"+id+\"\']\").text().trim().match(/Ολοκληρώθηκε/) ) {\n            $(\"div[id^=\'row_\"+rowNum+\"\']\").css(\'color\', \'blue\');\n        }\n    }\n}\n\n\n\nfunction nuOnSave(){ \n\n    if($(\'#name\').val() == \'\'){ \n        alert(\'Παρακαλώ συμπληρώστε πρώτα το «Όνομα»\');\n        return false;  \n    }\n    \n    if($(\'#start_date\').val() == \'\'){ \n        alert(\'Παρακαλώ συμπληρώστε πρώτα την ημερομηνία «Από»\');\n        return false;  \n    }\n    \n    if($(\'#end_date\').val() == \'\'){ \n        alert(\'Παρακαλώ συμπληρώστε πρώτα την ημερομηνία «Έως»\');\n        return false;  \n    }\n    \n    if(!/^([01]?[0-9]|2[0-3]):[0-5][0-9]/.test($(\'#start_time\').val())){\n        alert(\'Παρακαλώ συμπληρώστε σωστά την ώρα «Από»\');\n        return false;     \n    }\n        \n    if(!/^([01]?[0-9]|2[0-3]):[0-5][0-9]/.test($(\'#end_time\').val())){\n        alert(\'Παρακαλώ συμπληρώστε σωστά την ώρα «Έως»\');\n        return false;     \n    }\n        \n    if($(\'#max_numb_of_choices\').val() == \'\' || Number($(\'#max_numb_of_choices\').val())<=0){ \n        alert(\'O «Μέγιστος Αριθμός Επιλογών» πρέπει να είναι ένας θετικός ακέραιος αριθμός!\');\n        return false;  \n    }\n    \n    var iframe = document.getElementById(\'choices_iframe\');\n    var innerDoc = (iframe.contentDocument) ? iframe.contentDocument : iframe.contentWindow.document;\n    \n    var x = innerDoc.getElementsByClassName(\"choices\");\n    \n    var i;\n    var ids=\'\';\n    var changed = false;\n    \n    for (i = 0; i < x.length; i++) {\n        ids=(ids==\'\' ? ids=x[i].id : ids+\',\'+x[i].id);\n        \n        if(x[i].getAttribute(\'hierarchy\') != (i+1)){changed=true;};\n    }\n    if(changed){\n        nuSetHash(\'ids\', ids);    \n    } else {\n        nuSetHash(\'ids\', \'\');\n    }\n    \n    return true;\n}',NULL,40,50,'0000-00-00 00:00:00','','2017-11-05 12:53:29','globeadmin','2021-10-23 22:10:40','globeadmin','',0,NULL),('59e90833df79d7d','ballot_student','Ψηφοφορίες - Μαθητής','SELECT b1.*,b2.ballot_state\nFROM ballot as b1\nINNER JOIN session_variables ON session_variables.session_id = \'#session_id#\'\nINNER JOIN (\nselect id as b_id,if(is_active=\'0\',\'Ανενεργή\',if(NOW() BETWEEN CONCAT(start_date,\' \',start_time) AND CONCAT(end_date,\' \',end_time),\'Ανοιχτή Κάλπη\',if(NOW()>CONCAT(end_date,\' \',end_time),\'Ολοκληρώθηκε\',\'Θα Ενεργοποιηθεί\'))) as ballot_state \nfrom ballot\n) as b2 ON b1.id=b2.b_id\nwhere \n    (session_variables.student_id IN (select student_id from ballot_voter where ballot_voter.ballot_id=b1.id and (if(\'#nu_user_group#\'=\'Parents\',1,0))=ballot_voter.is_parent) OR\n    session_variables.student_id IN (select student_id from ballot_choice where ballot_choice.ballot_id=b1.id )) and\n    b1.is_active = 1 \norder by is_active desc,b2.ballot_state,start_date desc,start_time desc,end_date desc,end_time desc','ballot','id',1000,850,'SELECT name FROM ballot WHERE id=\'#RECORD_ID#\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function vote_result(param){\n    if(param==\'OK\'){\n        alert(\'Η ψήφος σας καταχωρήθηκε!\');\n        $(\'#numb_of_choices_disp\').hide();\n        $(\'#vote_btn_img\').hide();\n    } else {\n        alert(\'Προσοχή: Παρουσιάστηκε πρόβλημα κατά την καταχώριση!\\nΗ ψήφος σας ΔΕΝ καταχωρήθηκε!\')    \n    }\n    nuRunPHP(\'student_ballot_paper\',\'ballot_box_iframe\');\n}\n\nfunction set_description(cell_id,description){\n    var iframe = document.getElementById(\'choices_iframe\');\n    var innerDoc = (iframe.contentDocument) ? iframe.contentDocument : iframe.contentWindow.document;\n\n    var y = innerDoc.getElementById(\'img_\'+cell_id);\n\n    if(y){\n        if(description.trim() !=\'\'){\n            y.src = \'images/edit_red.png\';\n        } else {\n            y.src = \'images/edit.png\';\n        }\n    }\n}\n\nfunction set_num_of_choices(n){\n    if(n>0){\n        if(n.toString()==\'#max_numb_of_choices#\'){\n            $(\'#numb_of_choices_disp\').val(\'Δεν έχετε άλλες επιλογές\');    \n        } else {\n            $(\'#numb_of_choices_disp\').val(\'Επιλέξατε \'+n+\' / #max_numb_of_choices# επιλογές\');   \n        }\n    } else {\n        $(\'#numb_of_choices_disp\').val(\'Έχετε μέχρι #max_numb_of_choices# επιλογές\');\n    }\n}\n\nfunction nuLoadEdit() { \n    \n    $(\'#numb_of_choices_disp\').css(\'fontSize\', \'12px\');\n    $(\'#numb_of_choices_disp\').css(\'font-weight\', \'bold\');\n    $(\'#numb_of_choices_disp\').css(\'background-color\', \'LightYellow\');\n    $(\'#numb_of_choices_disp\').css(\'font-family\', \'Verdana\');\n    //$(\'#numb_of_choices_disp\').css(\'color\', \'green\');\n    \n    \n    var s = $(\'#status\').val();\n    \n    $(\'#status\').css(\'fontSize\', \'18px\');\n    $(\'#status\').css(\'font-weight\', \'bold\');\n    $(\'#status\').css(\'color\', \'LightYellow\');\n    \n    if(s==\'Ανοιχτή Κάλπη\'){\n        $(\'#status\').css(\'background-color\', \'green\');    \n    } else if(s==\'Θα Ενεργοποιηθεί\'){\n        $(\'#status\').css(\'background-color\', \'orange\');\n        $(\'#tab1\').trigger( \"click\" );\n    } else if(s==\'Ολοκληρώθηκε\'){\n        $(\'#status\').css(\'background-color\', \'blue\');\n        $(\'#tab2\').trigger( \"click\" );\n    } else if(s==\'Ανενεργή\'){\n        $(\'#status\').css(\'background-color\', \'gray\');    \n    }\n    \n    var a = $(\'#is_anonymous_disp\').val();\n    \n    $(\'#is_anonymous_disp\').css(\'fontSize\', \'18px\');\n    $(\'#is_anonymous_disp\').css(\'font-weight\', \'bold\');\n    $(\'#is_anonymous_disp\').css(\'color\', \'LightYellow\');\n    \n    if(a==\'Ανώνυμη Ψηφοφορία\'){\n        $(\'#is_anonymous_disp\').css(\'background-color\', \'green\');    \n    } else if(a==\'Επώνυμη Ψηφοφορία\'){\n        $(\'#is_anonymous_disp\').css(\'background-color\', \'DarkRed\');    \n    }\n\n    $(\'#name\').css(\'fontSize\', \'16px\');\n    $(\'#name\').css(\'font-weight\', \'bold\');\n    //$(\'#name\').css(\'color\', \'blue\');\n    $(\'#name\').css(\'background-color\', \'LightYellow\');\n    \n    $(\'#start_date_time_disp\').css(\'fontSize\', \'16px\');\n    $(\'#start_date_time_disp\').css(\'font-weight\', \'bold\');\n    //$(\'#name\').css(\'color\', \'blue\');\n    $(\'#start_date_time_disp\').css(\'background-color\', \'LightYellow\');\n    \n    $(\'#end_date_time_disp\').css(\'fontSize\', \'16px\');\n    $(\'#end_date_time_disp\').css(\'font-weight\', \'bold\');\n    //$(\'#name\').css(\'color\', \'blue\');\n    $(\'#end_date_time_disp\').css(\'background-color\', \'LightYellow\');\n    \n    $(\'#teacher_disp\').css(\'fontSize\', \'14px\');\n    $(\'#teacher_disp\').css(\'font-weight\', \'bold\');\n    //$(\'#name\').css(\'color\', \'blue\');\n    $(\'#teacher_disp\').css(\'background-color\', \'LightYellow\');    \n    \n    \n    document.getElementById(\'name\').title = $(\'#description\').val();\n}\n\n\nfunction nuLoadBrowse() {\n    var rows = nuBrowseRows();\n     \n    var row_len = rows.toString().length;\n    var pad = \"0000\";\n     \n    for( var i = 0; i < rows; i++ ) {\n        var rowString = i.toString();\n        var rowNum = pad.substring(0, pad.length - rowString.length ) + rowString;\n        var id = \'row_\'+rowNum+\'_col_5\';\n        if( $(\"div[id=\'\"+id+\"\']\").text().trim().match(/Ανοιχτή Κάλπη/) ) {\n            $(\"div[id^=\'row_\"+rowNum+\"\']\").css(\'color\', \'green\'); //LightYellow\n            $(\"div[id^=\'row_\"+rowNum+\"\']\").css(\'font-weight\', \'bold\');\n            //$(\"div[id^=\'row_\"+rowNum+\"\']\").css(\'background-color\', \'green\');\n        }\n        if( $(\"div[id=\'\"+id+\"\']\").text().trim().match(/Θα Ενεργοποιηθεί/) ) {\n            $(\"div[id^=\'row_\"+rowNum+\"\']\").css(\"color\", \'orange\');\n        }\n        if( $(\"div[id=\'\"+id+\"\']\").text().trim().match(/Ολοκληρώθηκε/) ) {\n            $(\"div[id^=\'row_\"+rowNum+\"\']\").css(\"color\", \'blue\');\n        }\n    }\n}\n',NULL,35,50,'2017-10-19 23:16:52','globeadmin','2018-10-06 22:43:17','globeadmin','2019-11-07 12:59:07','globeadmin','',0,NULL),('59ea67cf8d2d9b3','ballot_choice_description','Η περιγραφή μιας επιλογής ψηφοφορίας','SELECT * FROM ballot_choice','ballot_choice','id',800,450,'select CONCAT(\'Επιλογή : \',name) from ballot_choice where id=\'#RECORD_ID#\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function nuLoadEdit() { \n    nuSetHash(\'table_name\', \'ballot_choice\');\n    nuSetHash(\'table_field\', \'description\');\n    nuSetHash(\'id_name\', \'id\');\n    nuSetHash(\'id_value\', \'#RECORD_ID#\');\n    nuRunPHP(\'show_html_field\',\'description_html\')\n}\n',NULL,0,0,'0000-00-00 00:00:00','','2017-10-21 00:35:38','globeadmin','2017-10-31 10:48:00','globeadmin','',0,NULL),('59eaf663b08f216','ballot_choice_description_edit','Επεξεργασία της περιγραφής μιας επιλογής ψηφοφορία','SELECT * FROM ballot_choice','ballot_choice','id',950,450,'select CONCAT(\'Επιλογή : \',name) from ballot_choice where id=\'#RECORD_ID#\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function passTinymceContents(){\n    var y = document.getElementById(\'description\').value;\n    return(y);\n}\n\nfunction nuLoadEdit() { \n    \n}\n',NULL,0,0,'2017-10-21 10:25:23','globeadmin','2017-10-21 10:42:56','globeadmin','2017-10-31 10:48:06','globeadmin','',0,NULL),('59f607fc7a2c0b2','ballot_choice_edit','Επεξεργασία μιας επιλογής ψηφοφορίας','SELECT * FROM ballot_choice','ballot_choice','id',950,500,'select CONCAT(\'Επιλογή : \',name) from ballot_choice where id=\'#RECORD_ID#\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function passTinymceContents(){\n    var y = document.getElementById(\'description\').value;\n    return(y);\n}\n\nfunction after_delete(param){\n    parent.nuRunPHP(\'show_ballot_choices\',\'choices_iframe\');\n    nuRemoveModal();\n}\n\nfunction nuLoadEdit() {\n    \n    if(\'#RECORD_ID#\'==-1){\n        var ballot_id = parent.my_id;\n        var x = document.getElementById(\'ballot_id\');\n        x.value=ballot_id;\n    } else {\n        if(\'#nu_edited_record#\'==1){\n            parent.nuRunPHP(\'show_ballot_choices\',\'choices_iframe\');\n            nuRemoveModal();\n        }\n    }\n}\n',NULL,0,0,'2017-10-29 18:55:24','globeadmin','2017-10-29 20:02:00','globeadmin','2017-11-06 16:46:11','globeadmin','',0,NULL),('5a1011c80a896b3','merge','Συγχωνεύσεις','select * from teacher','teacher','id',960,520,'select \'Συγχωνεύσεις\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function display_merge_result(param){\n    if(param!=\'-1\'){\n        if(param!=\'\'){\n            alert(param);\n        } else {\n            alert(\'Η συνένωση πραγματοποίηθηκε!\');\n        } \n        nuReloadForm();\n    } else{\n        alert(\'Παρουσιάστηκε σφάλμα κατά τη συνένωση! Η συνένωση δεν πραγματοποιήθηκε!\');    \n    }\n}\n\nfunction nuLoadEdit() {\n    sisMessage(\'<b>Προσοχή!</b><br><br>Η διαδικασία των συγχωνεύσεων δίδεται αποκλειστικά και μόνο για τη διόρθωση των από λάθους δίπλων εισαγωγών Τμημάτων, Καθηγητών και Μαθημάτων, κατά την μαζική εισαγωγή εξωτερικών δεδομένων.<br><br>Παρακαλώ χρησιμοποιήστε τη διαδικασία αυτή με προσοχή και μόνο όταν είναι απολύτως απαραίτητο, καθότι μπορεί να οδηγήσει σε ένα ασυνεπές σύστημα!\');\n}',NULL,0,0,'2017-11-18 12:56:08','globeadmin','2017-11-26 16:46:02','globeadmin','2017-11-26 16:46:02','globeadmin','',0,NULL),('5a193801b52abb9','un_register_card','Αναίρεση Καταχώρισης Διδασκαλίας','select * from foo','foo','foo',960,600,'select \'Αναίρεση Καταχώρισης Διδασκαλίας\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,0,0,'2017-11-25 11:29:37','globeadmin','2017-11-25 20:21:31','globeadmin','2018-12-03 16:17:39','globeadmin','',0,NULL),('5a28402a618a46f','check_exams','Έλεγχος Διαγωνισμάτων','SELECT * FROM teacher','teacher','id',700,500,'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function get_selected_ids(){\n    var id_array = [];\n\n    var iframe = document.getElementById(\'check_iframe\');\n    var innerDoc = (iframe.contentDocument) ? iframe.contentDocument : iframe.contentWindow.document;\n\n    var c1 = innerDoc.getElementsByClassName(\'chk_1\');\n        \n    for(var i=0, n=c1.length;i<n;i++) {\n        if(c1[i].checked){\n            id_array.push(c1[i].id);\n        }\n    } \n    \n    ids = id_array.join();\n    \n    if(typeof id_array == \'undefined\' || id_array == null || id_array.length == 0){\n        alert (\'Παρακαλώ επιλέξτε πρώτα τα διαγωνίσματα!\');\n        return;\n    }\n    \n    return ids;\n}\nfunction delete_exams_results(param){\n    \n    if(param!=\'-1\'){\n        \n        var iframe = parent.document.getElementById(\'calendar_iframe\');\n        \n        var ids = get_selected_ids();\n        var ids_array = ids.split(\',\');\n        \n        for(var i=0, n=ids_array.length;i<n;i++) {\n            iframe.contentWindow.remove_event(ids_array[i]);\n        }\n        \n        alert(\'Η διαγραφή πραγματοποιήθηκε επιτυχώς!\\n\'+param);\n        \n        nuRunPHP(\'check_teacher_calendar_exams\',\'check_iframe\');\n        \n    } else {\n        alert(\'Προσοχή! Παρουσιάστηκε πρόβλημα κατά τη διαγραφή!\');\n    }\n    \n    hideLoader();\n}',NULL,0,0,'2017-12-06 21:08:26','globeadmin','2017-12-09 16:20:46','globeadmin','2017-12-09 20:16:35','globeadmin','',0,NULL),('5a36abffedf9461','updater','Ενημέρωση Συστήματος','SELECT * FROM teacher','teacher','id',1000,600,'select \'Ενημέρωση Συστήματος\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function unzip_results(param){\n    var iframe = document.getElementById(\'progress_iframe\');\n    if(param!=\'\' && param!=\'-1\'){\n        iframe.contentWindow.show_button(); \n        iframe.contentWindow.set_message(\'Η αποσυμπίεση ολοκληρώθηκε! \'+param+\' αρχεία δημιουργήθηκαν!\');\n        display_msg(\'Το αρχείο λήψης αποσυμπιέστηκε επιτυχώς! \'+param+\' αρχεία δημιουργήθηκαν!\',\'check\');\n    } else {\n        iframe.contentWindow.set_message(\'Η αποσυμπίεση απέτυχε!\');\n        display_msg(\'Παρουσιάστηκε σφάλμα κατά την αποσυμπίεση του αρχείου! Η αποσυμπίεση του αρχείου απέτυχε!\',\'error\',\'red\');\n    }\n}\n\nfunction copy_results(param){\n    \n    var iframe = document.getElementById(\'progress_iframe\');\n    \n    if(param!=\'\'){\n        \n        obj = JSON.parse(param);\n            \n        if ( obj.message == \'ERRORS\' ) {\n\n            iframe.contentWindow.set_message(\'Η αντιγραφή των αρχείων απέτυχε!\');\n    \n            for (var i = 0; i < obj.errors.length; i++) {\n                display_msg(obj.errors[i],\'error\',\'red\');\n            }    \n        } else if ( obj.message == \'SUCCESS\' ) {\n            \n              \n            if(obj.dir_created.length>0 || obj.file_created.length>0 || obj.file_replaced.length>0){\n                iframe.contentWindow.set_message(\'Η αντιγραφή των αρχείων πραγματοποιήθηκε!\');  \n            } else {\n                iframe.contentWindow.set_message(\'Δεν βρέθηκαν νέα αρχεία για αντιγραφή!\'); \n                display_msg(\'Ο έλεγχος των αρχείων ολοκληρώθηκε!\',\'check\');\n            }\n              \n            iframe.contentWindow.show_button();\n              \n            if(obj.dir_created.length>0){\n                display_msg(\'Νέοι κατάλογοι...\');\n                for (var i = 0; i < obj.dir_created.length; i++) {\n                  display_msg(obj.dir_created[i],\'check\');\n                }\n            }\n\n            if(obj.file_created.length>0){\n                display_msg(\'Νέα αρχεία...\');\n                for (var i = 0; i < obj.file_created.length; i++) {\n                  display_msg(obj.file_created[i],\'check\');\n                }\n            }\n\n            if(obj.file_replaced.length>0){\n                display_msg(\'Αντικατάσταση αρχείων...\');\n                for (var i = 0; i < obj.file_replaced.length; i++) {\n                  display_msg(obj.file_replaced[i],\'check\');\n                }\n            }\n              \n        }        \n    } else {\n        iframe.contentWindow.set_message(\'Η αντιγραφή απέτυχε!\');\n        display_msg(\'Παρουσιάστηκε σφάλμα κατά την αντιγραφή των αρχείων! Η αντιγραφή απέτυχε!\',\'error\',\'red\');\n    }\n}\n\nfunction get_backup_file(param){\n    \n    var iframe = document.getElementById(\'progress_iframe\');\n    \n    if(param!=\'\' && param!=\'-1\'){\n        \n        display_msg(\'Το αντίγραφο ασφαλείας δημιουργήθηκε!\',\'check\');\n        \n        nuSetHash(\'backup_file_name\', param);\n        nuRunPHP(\'backup_db_get_file\',\'hidden_iframe\');\n        \n        iframe.contentWindow.set_message(\'Παρακαλώ περιμένετε να ολοκληρωθεί η λήψη του αντιγράφου ασφαλείας!\');\n        iframe.contentWindow.show_button();\n    } else {\n        \n        display_msg(\'Η δημιουργία του αντιγράφου ασφαλείας απέτυχε! Παρακαλώ δημιουργήστε το χειροκίνητα πριν προχωρήσετε!\',\'stop\'); \n    \n        iframe.contentWindow.set_message(\'Παρακαλώ λάβετε αντίγραφο ασφαλείας πριν προχωρήσετε!\');\n        iframe.contentWindow.show_button();\n    } \n}\n\nfunction update_db_results(param){\n    \n}\n\nfunction cleanup_results(param){\n    \n}\n\nfunction display_msg(msg,img=null,color=null){\n    var iframe = document.getElementById(\'msg_iframe\');\n    iframe.contentWindow.add_msg(msg,img,color);\n}\n\nfunction nuLoadEdit() {\n    $(\'#system_version_dsp\').css(\'fontSize\', \'16px\');\n    $(\'#system_version_dsp\').css(\'font-weight\', \'bold\');\n    $(\'#system_version_dsp\').css(\'background-color\', \'LightYellow\');\n    $(\'#system_version_dsp\').css(\'color\', \'#FFA500\'); \n}',NULL,0,0,'2017-12-17 19:40:16','globeadmin','2018-01-01 11:24:27','globeadmin','2018-01-09 18:45:11','globeadmin','',0,NULL),('5a4e32f55d7faf5','penalty_type','penalty_type','SELECT * FROM penalty_type','penalty_type','id',960,450,'select name from penalty_type where id=\'#RECORD_ID#\'','1','1','1',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'SELECT IF(\'#RECORD_ID#\'=\'-1\',\'0\',\'1\')',NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,35,20,'0000-00-00 00:00:00','','2018-07-29 15:40:30','globeadmin','2019-11-03 18:26:09','globeadmin','',1,NULL),('5a54c08c836c142','school_parameters','Γενικοί Παράμετροι Σχολείου','select * from school','school','id',960,600,'select \'Γενικές Παράμετροι Σχολείου\'','0','1','0',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function passTinymceContents(){\n    var x = document.getElementById(\'email_absence_text\').value;\n    return(x);\n}\n\nfunction replaceAll(str, find, replace) {\n    return str.replace(new RegExp(find, \'g\'), replace);\n}\n\nfunction compute_numb_of_chars(){\n    var txt = replaceAll($(\'#sms_absence_text\').val(),\'-student-\',\'\');\n    txt = replaceAll(txt,\'-date-\',\'\');\n    txt = replaceAll(txt,\'-total-\',\'\');\n    txt = replaceAll(txt,\'-unjustified-\',\'\');\n    txt = replaceAll(txt,\'-justified-\',\'\');\n\n    $(\'#num_of_chars\').val(txt.length);\n}\n\nfunction nuLoadEdit() { \n    if(document.getElementById(\'open_absence_books\').checked){\n            nuDisable(\'set_absence_time_limit\',\'00:00:00\');\n    }\n    compute_numb_of_chars();\n}\n\nfunction nuOnSave(){\n    var iframe = document.getElementById(\'email_tinymce\');\n    var htmltext = iframe.contentWindow.getHTML();\n    $(\'#email_absence_text\').val(htmltext);\n    return true;\n}\n',NULL,0,0,'2018-01-09 15:15:56','globeadmin','2022-09-24 23:21:52','globeadmin','2022-09-24 23:21:52','globeadmin','',0,NULL),('5a607704e048c15','mass_comments','Μαζική προσθήκη σχολίων για ένα Τμήμα - Μάθημα','select * from teacher','teacher','id',1000,1350,'select \'Μαζική Προσθήκη Σχολίων\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'','nuRunPHP(\'check_permission_lib\');\n\nif(!check_permission(\'1\')){\n    $MESSAGE = \'Προσοχή! Δεν έχετε άδεια πρόσβασης στα δεδομένα αυτά!\';\n    nuDisplayError($MESSAGE);\n    return;\n}',NULL,NULL,'function add_result(param){\n    hideLoader();\n    alert(param);\n    nuGoToForm(2);\n}\n\nfunction passTinymceContents(){\n    return(\'\');\n}\n\nfunction nuLoadEdit() {\n\n    var class_id    = get_session_variable(\'class_id\');\n    var subject_id  = get_session_variable(\'subject_id\');\n\n    if(class_id!=-1 && subject_id!=-1){\n           \n    }\n    \n}\n\n\n',NULL,0,0,'2018-01-18 12:29:24','globeadmin','2019-07-06 23:58:52','globeadmin','2019-07-08 13:11:21','globeadmin','',0,NULL),('5b04854d1104747','subject_exam_curriculum','Εξεταστέα Ύλη Μαθήματος',NULL,'subject','id',960,520,'select short_name from subject where id=#RECORD_ID#','0','0','0',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'\n',NULL,'',NULL,'if(\'#nu_edited_record#\'==\'1\'){\n    $sql =\" UPDATE subject SET\n                exam_curriculum_modified_at=NOW(),\n                exam_curriculum_post_teacher_id = (SELECT teacher_id FROM session_variables WHERE session_id=\'#session_id#\')\n            WHERE id =\'#RECORD_ID#\'\";\n    nuRunQuery($sql);\n}',NULL,'function passTinymceContents(){\n    var y = document.getElementById(\'exam_curriculum\').value;\n    return(y);\n}\n\nfunction strip(html){\n   var tmp = document.createElement(\"DIV\");\n   tmp.innerHTML = html;\n   return tmp.textContent || tmp.innerText || \"\";\n}\n\nfunction is_blank(){\n    plaintext = strip($(\'#exam_curriculum\').val()).trim();\n    if(plaintext!=\'\'){return false;}\n    return true;\n}\n\nfunction nuLoadEdit() {\n\n    if(\'#nu_edited_record#\'==\'1\'){\n        parent.nuRunPHP(\'teacher_lessons\',\'teacher_lessons\');\n    }\n    \n    $(\'#lesson_disp\').css(\'fontSize\', \'14px\');\n    $(\'#lesson_disp\').css(\'font-weight\', \'bold\');\n    $(\'#lesson_disp\').css(\'background-color\', \'LightYellow\');\n    $(\'#lesson_disp\').css(\'color\', \'#A52A2A\');\n    \n    $(\'#last_update_disp\').css(\'fontSize\', \'14px\');\n    $(\'#last_update_disp\').css(\'font-weight\', \'bold\');\n    $(\'#last_update_disp\').css(\'background-color\', \'LightYellow\');\n    $(\'#last_update_disp\').css(\'color\', \'#A52A2A\');    \n}',NULL,0,0,'2018-05-23 00:02:05','globeadmin','2018-05-24 00:06:59','globeadmin','2018-05-24 21:55:50','globeadmin','',0,NULL),('5b070b1a5c6dfb0','subject_exam_curriculum_student','Εξεταστέα Ύλη Μαθήματος για τον Μαθητή',NULL,'subject','id',960,520,'select short_name from subject where id=#RECORD_ID#','0','0','0',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'\n',NULL,'',NULL,NULL,NULL,'function nuLoadEdit() {\n    $(\'#lesson_disp\').css(\'fontSize\', \'14px\');\n    $(\'#lesson_disp\').css(\'font-weight\', \'bold\');\n    $(\'#lesson_disp\').css(\'background-color\', \'LightYellow\');\n    $(\'#lesson_disp\').css(\'color\', \'#A52A2A\');\n\n    nuSetHash(\'table_name\',\'subject\');\n    nuSetHash(\'table_field\',\'exam_curriculum\');\n    nuSetHash(\'id_name\',\'id\'); \n    nuSetHash(\'id_value\',\'#RECORD_ID#\');\n    \n    nuRunPHP(\'show_html_field\',\'exam_curriculum_iframe\');\n}',NULL,0,0,'2018-05-24 21:57:30','globeadmin','2018-05-24 21:59:07','globeadmin','2018-05-25 00:38:19','globeadmin','',0,NULL),('5b116c78852ee89','print_class_absence_books','Εκτύπωση Απουσιολογίων Τμήματος','select * from teacher','teacher','id',600,350,'select \'Απουσιολόγια Τμήματος\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function get_zip_file(param){\n    if(param!=\'\' && param!=\'-1\'){\n        var x = document.getElementById(\'get_zip\');\n        if(x.checked){\n            nuSetHash(\'backup_file_name\', param);\n            nuSetHash(\'send_file_name\', \'absence_export.zip\');\n            nuRunPHP(\'backup_db_get_file\',\'search_iframe\');            \n        } else {\n            sisMessage(\'Το αρχείο <b>\'+param+\'</b><br>δημιουργήθηκε επιτυχώς!\',\'Πληροφορία\');    \n        }\n    } else {\n        alert(\'Η δημιουργία του αρχείου απέτυχε!\'); \n    }\n    hideLoader();\n}\n\nfunction nuLoadEdit() {\n    \n}',NULL,0,0,'2018-06-01 18:55:36','globeadmin','2018-06-03 01:42:38','globeadmin','2018-12-03 16:18:27','globeadmin','',0,NULL),('5b1f98c3701d658','user_login_log','Ιστορικό σύνδεσης','select * from zzzsys_user','zzzsys_user','zzzsys_user_id',750,460,'select \'Ιστορικό Σύνδεσης Χρήστη\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,0,0,'2018-06-12 12:56:19','globeadmin','2018-06-13 19:09:09','globeadmin','2018-06-13 19:12:34','globeadmin','',0,NULL),('5b51e592c69b21a','menu_item','Στοιχεία Κεντρικού Μενού','SELECT * \nFROM zzzsys_menu_item \norder by sme_name, sme_order_number,sme_label','zzzsys_menu_item','zzzsys_menu_item_id',960,600,'SELECT sme_name from zzzsys_menu_item where zzzsys_menu_item_id=\'#RECORD_ID#\'','1','1','1','1',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function nuLoadEdit() {\n    $(\'#sme_display_condition\').css(\'background-color\', \'#d2f4d5\');\n    \n    $(\'#sme_onclick_code\').css(\'background-color\', \'#cae1ff\');\n    $(\'#sme_onmouseover_code\').css(\'background-color\', \'#cae1ff\');\n    $(\'#sme_onmouseout_code\').css(\'background-color\', \'#cae1ff\');\n}\n\n\n',NULL,0,100,'2018-07-20 16:37:22','globeadmin','2018-07-24 18:03:30','globeadmin','2018-07-24 18:05:47','globeadmin','',0,NULL),('5c053bad46326aa','set_advisors_new','Ορισμός Ατομικού Συμβούλου Μαθητών','select * from teacher','teacher','id',960,830,'select \'Ορισμός Ατομικού Συμβούλου Μαθητών\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function nuLoadEdit() {\n    document.getElementById(\'gender\').selectedIndex = 0;\n    nuRunPHP( \'create_student_advisor_list\',\'search_iframe\');\n    sumoTransform(\'advisor_id\',false,true);\n    $(\'#label1\').css(\"fontSize\", \"11px\");\n    $(\'#label1\').css(\'font-style\', \'italic\');\n    $(\'#label2\').css(\"fontSize\", \"11px\");\n    $(\'#label2\').css(\'font-style\', \'italic\');\n    $(\'#label3\').css(\"fontSize\", \"11px\");\n    $(\'#label3\').css(\'font-style\', \'italic\');\n    $(\'#label4\').css(\"fontSize\", \"11px\");\n    $(\'#label4\').css(\'font-style\', \'italic\');\n}',NULL,0,0,'2018-12-03 16:20:29','globeadmin','2018-12-08 20:49:19','globeadmin','2018-12-08 20:49:19','globeadmin','',0,NULL),('5c838179bfcf3d0','table_comment','Προσθήκη σχόλιου για ένα μαθητή από το απουσιολόγι','select * from teacher','teacher','id',860,550,'select \'Προσθήκη Σχόλιου σε Μαθητή\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function add_result(param){\n    hideLoader();\n    alert(param);\n    nuRemoveModal();\n}\n\nfunction passTinymceContents(){\n    var opts =  parent.document.getElementById(\'absence_period_id\');\n    var period_name = opts ? \', \'+opts.options[opts.selectedIndex].text+\' Ώρα: \' : \'\';\n    return(parent.document.getElementById(\'absence_date\').value+period_name);\n}\n\nfunction nuLoadEdit() { \n    $(\'#student_name\').val(parent.s_name);\n    $(\'#subject_name\').val(parent.sb_name);\n    document.getElementById(\'teacher_chk\').checked = true;\n}\n\n\n',NULL,0,0,'2019-03-09 11:03:54','globeadmin','2019-03-09 16:41:32','globeadmin','2021-10-20 23:35:48','globeadmin','',0,NULL),('5dc273803a8d0d6','export_students_to_excel','Εξαγωγή Στοιχείων Μαθητών σε Excel','select * from teacher','teacher','id',650,500,'select \'Εξαγωγή Στοιχείων Μαθητών σε Excel\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function get_excel_file(param){\n    if(param!=\'\' && param!=\'-1\'){\n        nuSetHash(\'backup_file_name\', param);\n        nuSetHash(\'send_file_name\', \'students_export.xls\');\n        nuRunPHP(\'backup_db_get_file\',\'hidden_iframe\');\n    } else {\n        alert(\'Η δημιουργία του αρχείου Excel απέτυχε!\'); \n    }\n    hideLoader();\n}\n\nfunction nuLoadEdit() {\n    sumoTransform(\'grade_id\',false,true);\n    sumoTransform(\'class_id\',false,true);\n    sumoTransform(\'student_id\',true,true);\n    \n    $(\'#label1\').css(\"fontSize\", \"10px\");\n    $(\'#label1\').css(\'font-style\', \'italic\');\n    //nuFORM.edited = 0;\n}',NULL,0,0,'2019-11-06 09:17:20','globeadmin','2019-11-06 10:47:44','globeadmin','2021-04-01 20:19:08','globeadmin','',0,NULL),('5e85a2a072783b3','openeclass','Διασύνδεση με Open eClass','select * from teacher','teacher','id',960,1200,'SELECT \'Διασύνδεση με Open eClass\'','0','0','0',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function db_check_result(param){\n    if(!param==\'\'){\n        if(param==\'1\'){\n            $(\'#check_label\').css(\'color\', \'green\');\n            $(\'#check_label\').text(\'Επιτυχής Σύνδεση!\');\n            nuRunPHP(\'eclass_get_hierarchy\',\'hierarchy_iframe\');\n        } else {\n            $(\'#check_label\').css(\'color\', \'red\');\n            $(\'#check_label\').text(param);    \n        }\n    } else {\n        $(\'#check_label\').css(\'color\', \'orange\');\n        $(\'#check_label\').text(\'Παρουσιάστηκε σφάλμα κατά τον έλεγχο!\');    \n    }\n}\n\nfunction send_users_result(param){\n    if(!param==\'\'){\n        sisMessage(param);\n    } else {\n        sisMessage(\'Παρουσιάστηκε σφάλμα!\');    \n    }\n}\n\nfunction send_lessons_result(param){\n    if(!param==\'\'){\n        sisMessage(param);\n    } else {\n        sisMessage(\'Παρουσιάστηκε σφάλμα!\');    \n    }\n    hideLoader();\n}\n\nfunction set_server_folder(param){\n    $(\'#server_folder\').val(param);    \n}\n\nfunction nuLoadEdit() {\n    sumoTransform(\'teacher_id\',true,true);\n    sumoTransform(\'student_id\',true,true);\n    sumoTransform(\'lesson_id\',true,true);\n    \n    $(\'#server_address\').val(\'127.0.0.1\');\n    $(\'#server_port\').val(\'3306\');\n\n    $(\'#merge_label\').css(\"fontSize\", \"10px\");\n    $(\'#merge_label\').css(\'font-style\', \'italic\');\n    $(\'#create_users_label\').css(\"fontSize\", \"10px\");\n    $(\'#create_users_label\').css(\'font-style\', \'italic\');    \n    \n    $(\'#check_label\').css(\'fontSize\', \'18px\');\n    $(\'#check_label\').css(\'font-weight\', \'bold\');\n    $(\'#check_label\').css(\'color\', \'red\');\n    \n    nuAjax(\'eclass_get_tmpdir\' ,\'set_server_folder\');\n}',NULL,50,0,'2020-04-02 11:30:24','globeadmin','2020-08-25 11:30:06','globeadmin','2020-08-25 11:30:06','globeadmin','',0,NULL),('5f5fc06e94c4759','appointment_teacher_availability','Διαθεσιμότητα Καθηγητή για Ραντεβού','select * from appointment_teacher_availability','appointment_teacher_availability','id',600,350,'select \'Διαθεσιμότητα Καθηγητή για Ραντεβού\'',NULL,'1','0',NULL,'1',NULL,NULL,NULL,NULL,NULL,'Προσθήκη Νέας',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'$from = \'#start_time#\';\n$to = \'#end_time#\';\n\n$sql = \"SELECT start_time,end_time\n        FROM appointment_teacher_availability \n        WHERE \n            teacher_id=#teacher_id# AND \n            day_id =#day_id# AND\n            id<>#RECORD_ID#\";\n$retval = nuRunQuery($sql);\nif($retval){\n    while($row = db_fetch_row($retval)){\n        $from_compare = $row[0];\n        $to_compare = $row[1];\n        if(($from >= $from_compare && $from < $to_compare) || ($from_compare >= $from && $from_compare < $to)){\n            $MESSAGE = \'Προσοχή : Βρέθηκε επικάλυψη με άλλη διαθεσιμότητα του καθηγητή!\\nΠαρακαλώ διορθώστε!\';\n            nuDisplayError($MESSAGE);\n            return;                       \n        }\n    }\n}',NULL,'',NULL,NULL,NULL,'function nuLoadEdit() {\n\n    var teacher_id = get_session_variable(\'teacher_id\');\n    nuSetHash(\'teacher_id\', teacher_id);\n    \n    if(\'#nu_new_record#\'==\'1\'){\n        $(\'#teacher_id\').val(parent.t_id);    \n    }\n    \n    if(\'#nu_edited_record#\'==\'1\'){\n        parent.nuRunPHP(\'teacher_appointment_availability\',\'availability_iframe\');\n    }\n    \n    nuFORM.edited = 0;\n}\n\nfunction nuOnSave(){     \n    \n    var st = $(\'#start_time\').val();\n    var et = $(\'#end_time\').val();\n    \n    var inputVal = parent.document.getElementById(\'appointment_duration\').value;\n   \n    \n    if(!/^([01]?[0-9]|2[0-3]):[0-5][0-9]/.test(st)){\n        alert(\'Παρακαλώ συμπληρώστε σωστά την ώρα «Από»\');\n        return false;     \n    }\n        \n    if(!/^([01]?[0-9]|2[0-3]):[0-5][0-9]/.test(et)){\n        alert(\'Παρακαλώ συμπληρώστε σωστά την ώρα «Έως»\');\n        return false;     \n    }\n\n    if(et<=st) {\n        alert(\'Προσοχή! Η ώρα «Από» πρέπει να είναι μικρότερη της ώρας «Έως»!\');\n        return false;          \n    }\n    \n    var s = st.split(\":\");\n    var e = et.split(\":\");\n    \n    var sms = parseInt(s[0])*3600+parseInt(s[1])*60+(s[2] ? parseInt(s[2]) : 0);\n    var ems = parseInt(e[0])*3600+parseInt(e[1])*60+(e[2] ? parseInt(e[2]) : 0);\n    \n    var ms = ems-sms;\n    \n    if(ms<(parseInt(inputVal)*60)){\n        alert(\'Προσοχή! Η διάρκεια της διαθεσιμότητας δεν μπορεί να είναι μικρότερη από τη διάρκεια ενός ραντεβού!\');\n        return false;         \n    }\n    \n    return true; \n   \n}',NULL,0,0,'2020-09-14 22:11:42','globeadmin','2020-09-23 09:41:28','globeadmin','2020-09-24 14:34:15','globeadmin','',0,NULL),('5f609a0c726f729','student_appointment','Γονέας - Νέο Ηλεκτρονικό Ραντεβού','select * from student','student','id',900,520,'select \'Νέο Ηλεκτρονικό Ραντεβού\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'','nuRunPHP(\'check_permission_lib\');\n\nif(!check_permission()){\n    $MESSAGE = \'Προσοχή! Δεν έχετε άδεια πρόσβασης στα δεδομένα αυτά!\';\n    nuDisplayError($MESSAGE);\n    return;\n}',NULL,NULL,'function add_appointment_result(param){\n    if(param && param!=\'\'){\n        var json_data = JSON.parse(param);\n        if(json_data[0]>0){\n            var iframe = parent.document.getElementById(\'calendar_iframe\');\n            iframe.contentWindow.add_event(json_data[0],json_data[1],json_data[2],json_data[3],json_data[4],json_data[5],json_data[6],json_data[7],json_data[8],json_data[9],1,0);\n            var iframe = document.getElementById(\'search_iframe\');\n            var innerDoc = (iframe.contentDocument) ? iframe.contentDocument : iframe.contentWindow.document;\n\n            var r = innerDoc.getElementById(json_data[10]);\n            r.parentNode.style.backgroundColor = \'LightGreen\';\n            r.style.cursor=\'auto\';\n            r.onclick = function() {};\n            r.onmouseover = function() {};\n            r.onmouseout = function() {};\n            innerDoc.getElementById(\'handshake_\'+json_data[10]).src=\'images/check.png\';\n            \n            var rows = innerDoc.getElementsByClassName(json_data[11]);\n            for (var i = 0; i < rows.length; i++){\n                if(rows[i] != r){\n                    rows[i].parentNode.style.backgroundColor = \'LightGray\';\n                    rows[i].onclick = function() {};\n                    rows[i].onmouseover = function() {};\n                    rows[i].onmouseout = function() {};\n                    var image_x = innerDoc.getElementById(\'handshake_\'+rows[i].id);\n                    image_x.src=\'images/stop.png\';\n                    image_x.style.height = \'20px\';\n                    image_x.style.width = \'20px\';\n                }\n            }\n            alert(\'Η δέσμευση πραγματοποιήθηκε επιτυχώς!\');\n            hideLoader();\n            \n        } else {\n            alert(\'Προσοχή! Παρουσιάστηκε σφάλμα κατά την εισαγωγή του αιτήματος!\\nΗ δέσμευση δεν πραγματοποιήθηκε!\');    \n        }\n    }\n}\n\nfunction nuLoadEdit() {\n    $(\'#nuButton0\').focus();\n    sumoTransform(\'teacher_id\',true,true);\n}\n',NULL,0,0,'2020-09-15 13:40:12','globeadmin','2020-09-25 10:41:44','globeadmin','2020-12-21 21:11:59','globeadmin','',0,NULL),('5f68d148d9f3222','appointment_comments','Σχόλια ενός ραντεβού','SELECT * FROM calendar_event','calendar_event','id',900,450,'Select \'Σχόλια Ραντεβού\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function passTinymceContents(){\n    var y = document.getElementById(\'comments\').value;\n    return(y);\n}\n\nfunction nuLoadEdit() {\n    if(\'#nu_edited_record#\'==\'1\'){\n    }\n}\n',NULL,0,0,'2020-09-21 19:14:00','globeadmin','2020-09-21 19:29:29','globeadmin','2020-09-23 10:04:25','globeadmin','',0,NULL),('5f6a50545e4de79','teacher_appointments','Ραντεβού Καθηγητή','select * \nfrom teacher \norder by short_name','teacher','id',1050,850,'select \'Ηλεκτρονικά Ραντεβού Καθηγητή\'','0','1','0',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function delete_appointment_availability_result(param){\n   nuRunPHP(\'teacher_appointment_availability\',\'availability_iframe\'); \n}\n\nfunction set_appointment_washeld_result(param){\n    if(param && param!=\'\'){\n        var json_data = JSON.parse(param);\n        if(json_data[0]>0){\n            \n            var iframe = document.getElementById(\'appointments_iframe\');\n            var innerDoc = (iframe.contentDocument) ? iframe.contentDocument : iframe.contentWindow.document;\n\n            var r = innerDoc.getElementById(json_data[0]);\n            var bgcolor = (json_data[1]==1 ? \'LightGreen\' : (json_data[1]==0 ? \'#ffeb99\' : \'LightBlue\'));\n            r.style.backgroundColor = bgcolor;\n        } else {\n            alert(\'Προσοχή! Παρουσιάστηκε σφάλμα!\\nΗ δήλωση δεν πραγματοποιήθηκε!\');    \n        }\n    } else {\n        alert(\'Προσοχή! Παρουσιάστηκε σφάλμα!\\nΗ δήλωση δεν πραγματοποιήθηκε!\');\n    }\n}\n\nfunction delete_appointment_result(param){\n    if(param && param!=\'\'){ \n            var iframe = document.getElementById(\'appointments_iframe\');\n            var innerDoc = (iframe.contentDocument) ? iframe.contentDocument : iframe.contentWindow.document;\n            var r = innerDoc.getElementById(param);\n            if(r){\n                r.parentNode.removeChild(r);    \n            }\n    } else {\n        alert(\'Προσοχή! Παρουσιάστηκε σφάλμα!\\nΗ διαγραφή δεν πραγματοποιήθηκε!\')    \n    }\n}\n\nvar t_id=\'#RECORD_ID#\';\n\n\nfunction nuLoadEdit() {\n    $(\'#appointment_from\').val($(\'#date_from_disp\').val());\n    $(\'#appointment_to\').val($(\'#date_to_disp\').val());\n    sumoTransform(\'appointment_student_id\',true,true);\n    sumoTransform(\'teacher_id\',true,true);\n}',NULL,30,50,'2020-09-22 22:28:20','globeadmin','2020-09-23 12:04:35','globeadmin','2020-09-24 10:05:43','globeadmin','',1,NULL),('5f6cbe6fd03a211','delete_parent_accounts','Διαγράφει μαζικά λογαριασμούς γονέων','select * from teacher','teacher','id',650,400,'select \'Μαζική διαγραφή λογαριασμών γονέων\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function display_delete_result(param){\n    if(param=\'OK\'){\n        alert(\'Η διαγραφή πραγματοποιήθηκε!\');\n        nuRemoveModal();\n    } else {\n        alert(\'Προσοχή : Παρουσιάστηκε πρόβλημα κατά τη διαγραφή!\');\n    }\n}\n\nfunction nuLoadEdit() {\n    sumoTransform(\'student_id\',true,true);\n}',NULL,0,0,'2020-09-24 18:42:39','globeadmin','2020-09-24 18:50:18','globeadmin','2020-09-25 10:42:54','globeadmin','',0,NULL),('5f6cee92b5f274a','delete_student_accounts','Διαγράφει μαζικά λογαριασμούς μαθητών','select * from teacher','teacher','id',650,400,'select \'Μαζική διαγραφή λογαριασμών μαθητών\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function display_delete_result(param){\n    if(param=\'OK\'){\n        alert(\'Η διαγραφή πραγματοποιήθηκε!\');\n        nuRemoveModal();\n    } else {\n        alert(\'Προσοχή : Παρουσιάστηκε πρόβλημα κατά τη διαγραφή!\');\n    }\n}\n\nfunction nuLoadEdit() {\n    sumoTransform(\'student_id\',true,true);\n}',NULL,0,0,'2020-09-24 22:08:02','globeadmin','2020-09-24 22:08:02','globeadmin','2020-09-24 22:11:41','globeadmin','',0,NULL),('5f7cd744d8ace2f','allday_absence','Βρίσκει τους μαθητές που απουσίαζαν όλη τη μέρα απ','select * from teacher','teacher','id',1000,600,'select \'Μαθητές με Ολοήμερη Απουσία\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function nuLoadEdit() {\n    $(\'#absence_date\').val($(\'#current_date\').val());\n    sumoTransform(\'class_id\',false,true);\n    sumoTransform(\'grade_id\',false,false);\n    nuFORM.edited = 0;\n}',NULL,0,0,'2020-10-06 23:44:52','globeadmin','2020-10-08 23:43:00','globeadmin','2020-10-08 23:43:00','globeadmin','',0,NULL),('5f8b4f77ca6b53e','teacher_list_send_sms','Μαζική Αποστολή SMS σε Καθηγητές μιας λίστας','select * from teacher','teacher','id',960,600,'select \'Αποστολή SMS σε Καθηγητές\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function display_sent_result(param){\n    hideLoader();\n    alert(param);\n}\n\nfunction nuLoadEdit() {\n\n    $(\'#sms_text\').css(\'fontSize\', \'16px\');\n    $(\'#sms_text\').css(\'font-weight\', \'bold\');\n    $(\'#sms_text\').css(\'background-color\', \'LightYellow\');\n    $(\'#sms_text\').css(\'color\', \'#25237A\');\n\n    $(\'#sms_disp\').css(\'fontSize\', \'16px\');\n    $(\'#sms_disp\').css(\'font-weight\', \'bold\');\n    $(\'#sms_disp\').css(\'background-color\', \'#FAF0E6\');\n    $(\'#sms_disp\').css(\'color\', \'red\');\n    \n    $(\'#sms_text\').attr(\'maxlength\',$(\'#max_num_of_chars\').val());\n    \n    $(\'#num_of_chars_left\').val($(\'#max_num_of_chars\').val());\n    \n    $(\'#num_of_chars_left\').css(\'fontSize\', \'10px\');\n    $(\'#num_of_chars_left\').css(\'font-weight\', \'bold\');\n    $(\'#num_of_chars_left\').css(\'background-color\', \'#FAF0E6\');\n    \n    var txt = $(\'#text_disp\').val();;\n    \n    txt=txt.substring(0, $(\'#max_num_of_chars\').val());\n    \n    $(\'#num_of_chars_left\').val($(\'#max_num_of_chars\').val()-txt.length);\n    \n    $(\'#sms_text\').val(txt);\n    \n}',NULL,0,0,'2020-10-17 23:09:27','globeadmin','2021-03-24 11:19:44','globeadmin','2021-03-24 11:19:44','globeadmin','',0,NULL),('5f8b690f7120805','teacher_list_send_email','Μαζική Αποστολή Email σε Καθηγητές σε Καθηγητές μι','select * from teacher','teacher','id',960,900,'select \'Αποστολή Email στους Καθηγητές\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function display_sent_result(param){\n    hideLoader();\n    alert(param);\n}\n\nfunction passTinymceContents(){\n    return($(\'#text_disp\').val());\n}\n\nfunction nuLoadEdit() {\n    $(\'#subject\').val($(\'#subject_disp\').val());\n}',NULL,0,0,'2020-10-18 00:58:39','globeadmin','2020-10-18 01:10:00','globeadmin','2022-09-17 21:39:26','globeadmin','',0,NULL),('60380fd5e427d6b','absence_my_card_not_registered','Διδασκαλίες καθηγητή που που δεν έχουν καταχωρηθεί','select * from teacher','teacher','id',900,600,'select \'Μη καταχωρισμένες Διδασκαλίες Καθηγητή\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function nuLoadEdit() {\n    nuFORM.edited = 0;\n}',NULL,0,0,'2021-02-25 23:00:06','globeadmin','2021-02-25 23:15:43','globeadmin','2021-04-01 13:45:53','globeadmin','',0,NULL),('616c8bafd921bae','reward_teacher','Επιβράβευση κατά τη διάρκεια του μαθήματος','select *\nfrom reward','reward','id',800,500,'select \'Επιβράβευση\'','0','1','0',NULL,NULL,NULL,NULL,'Απονομή Επιβράβευσης',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,'nuRunPHP(\'notification_add_lib\');\n\nif (\'#nu_new_record#\'==\'1\'){\n    new_reward_notification(\'#RECORD_ID#\');\n}',NULL,'function nuLoadEdit() { \n    if(\'#nu_new_record#\'==\'1\'){\n        var opts =  parent.document.getElementById(\'absence_period_id\');\n        var de =    parent.document.getElementById(\'absence_date\');\n        var p_id = -1;\n        \n        if(opts){\n            p_id = opts.options[opts.selectedIndex].value;     \n        } else {\n            if (typeof parent.p_id !== \'undefined\') {\n                p_id = parent.p_id;\n            }\n        }\n        \n        if(p_id!=-1){\n            $(\'#period_id\').val(p_id);\n        } else {\n            nuEnable(\'period_id\');    \n        }\n\n        if(parent.t_id!=-1){\n            $(\'#teacher_id\').val(parent.t_id);\n        } else {\n            nuEnable(\'teacher_id\');    \n        }\n        \n        $(\'#student_id\').val(parent.s_id);\n        $(\'#student_name\').val(parent.s_name);\n        \n        $(\'#subject_id\').val(parent.sb_id);\n        $(\'#subject_name\').val((parent.sb_name.startsWith(\'Καταχωρισμένο - \') ? parent.sb_name.substring(16) : parent.sb_name));\n        \n        $(\'#date_enforced\').val(de.value);\n        \n        $(\'#student_id\').hide();\n        $(\'#subject_id\').hide();\n        $(\'#date_added\').hide();\n    } else {\n        alert(\'Η επιβράβευση σας απονεμήθηκε επιτυχώς!\');\n        nuRemoveModal();    \n    }\n}\n\nfunction nuOnSave(){     \n    \n    var tp = document.getElementById(\'reward_type_id\');\n    var type = tp.options[tp.selectedIndex].value;\n    \n    var p = document.getElementById(\'period_id\');\n    var period = p.options[p.selectedIndex].value;\n    \n    var th = document.getElementById(\'teacher_id\');\n    var teacher = th.options[th.selectedIndex].value;\n    \n    if(type == \'\'){\n        alert(\'Παρακαλώ συμπληρώστε τον λόγο της επιβράβευσης!\');\n        return false;  \n    }\n    \n    if(period == \'\'){\n        alert(\'Παρακαλώ συμπληρώστε τη διδακτική ώρα της επιβράβευσης!\');\n        return false;  \n    }\n    \n    if(teacher == \'\'){\n        alert(\'Παρακαλώ συμπληρώστε τον καθηγητή της επιβράβευσης!\');\n        return false;  \n    }\n    \n    var nof = getMedalValue();\n    if(nof>=1 && nof<=5){\n        $(\'#number_of_medals\').val(getMedalValue());\n        return true;\n    } else {\n        alert(\'Λάθος αριθμός μεταλλίων : \'+nof);\n        return false;         \n    }\n    \n    \n}',NULL,30,100,'2021-10-17 23:46:39','globeadmin','2022-01-08 18:45:22','globeadmin','2022-01-08 18:45:22','globeadmin','',0,NULL),('6175a7faca903a3','reward_search','Αναζήτηση Επιβραβεύσεων','select * from teacher','teacher','id',1000,600,'select \'Αναζήτηση Επιβραβεύσεων\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'function nuLoadEdit() {\n    sumoTransform(\'reward_type_id\',false,true);\n    sumoTransform(\'subject_id\',true,true);\n    sumoTransform(\'student_id\',true,true);\nsumoTransform(\'teacher_id\',true,true);\nsumoTransform(\'class_id\',true,true);\n    $(\'#from_date\').val($(\'#start_date\').val());\n    $(\'#to_date\').val($(\'#current_date\').val());\n    \n    if( \'#nu_user_group#\'!=\'globeadmin\' && \n        \'#nu_user_group#\'!=\'Administrators\' && \n        \'#nu_user_group#\'!=\'Managers\' && \n        \'#nu_user_group#\'!=\'AssistManagers\'){\n        $(\'#teacher_id\').val(\'#RECORD_ID#\');        \n    }\n    \n    nuFORM.edited = 0;\n}',NULL,0,0,'2021-10-24 21:37:46','globeadmin','2021-11-13 21:45:14','globeadmin','2022-01-08 18:43:54','globeadmin','',0,NULL),('61d88d6b6d133c3','reward_all','Επιβράβευση','select *\nfrom reward','reward','id',800,500,'select \'Επιβράβευση\'','0','1','0',NULL,NULL,NULL,NULL,'Απονομή Επιβράβευσης',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,'nuRunPHP(\'notification_add_lib\');\n\nif (\'#nu_new_record#\'==\'1\'){\n    new_reward_notification(\'#RECORD_ID#\');\n}',NULL,'function nuLoadEdit() { \n    $(\'#label1\').css(\'fontSize\', \'10px\');\n    $(\'#label1\').css(\'font-style\', \'italic\');\n    \n    if(\'#nu_new_record#\'==\'1\'){\n        $(\'#teacher_id\').val($(\'#teacher_iddisp\').val());\n    } else {\n        alert(\'Η επιβράβευση σας απονεμήθηκε επιτυχώς!\');\n        nuRemoveModal(); \n        \n    }\n}\n\nfunction nuOnSave(){     \n\n    var s = document.getElementById(\'student_id\');\n    var student_id = s.options[s.selectedIndex].value;\n    if(student_id == \'\'){\n        alert(\'Παρακαλώ επιλέξτε τον μαθητή!\');\n        return false;  \n    }\n    \n    if($(\'#date_enforced\').val() == \'\'){\n        alert(\'Παρακαλώ συμπληρώστε την ημερομηνία!\');\n        return false;  \n    }    \n    \n    var tp = document.getElementById(\'reward_type_id\');\n    var type = tp.options[tp.selectedIndex].value;\n    if(type == \'\'){\n        alert(\'Παρακαλώ συμπληρώστε τον λόγο της επιβράβευσης!\');\n        return false;  \n    }\n    \n    var nof = getMedalValue();\n    \n    if(nof>=1 && nof<=10){\n        $(\'#number_of_medals\').val(getMedalValue());\n        return true;\n    } else {\n        alert(\'Λάθος αριθμός μεταλλίων : \'+nof);\n        return false;         \n    }\n}',NULL,30,100,'2022-01-07 20:58:51','globeadmin','2022-01-08 18:43:20','globeadmin','2022-01-08 18:43:20','globeadmin','',0,NULL);
/*!40000 ALTER TABLE `zzzsys_form` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `zzzsys_form_action`
--

DROP TABLE IF EXISTS `zzzsys_form_action`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `zzzsys_form_action` (
  `zzzsys_form_action_id` varchar(25) NOT NULL DEFAULT '',
  `sfa_zzzsys_form_id` varchar(25) DEFAULT NULL,
  `sfa_button_title` varchar(50) DEFAULT NULL,
  `sfa_button_javascript` mediumtext,
  `sfa_button_display_condition` varchar(512) DEFAULT NULL,
  `zzzsys_form_action_log_added_at` datetime NOT NULL,
  `zzzsys_form_action_log_added_by` varchar(25) NOT NULL,
  `zzzsys_form_action_log_changed_at` datetime NOT NULL,
  `zzzsys_form_action_log_changed_by` varchar(25) NOT NULL,
  `zzzsys_form_action_log_viewed_at` datetime NOT NULL,
  `zzzsys_form_action_log_viewed_by` varchar(25) NOT NULL,
  PRIMARY KEY (`zzzsys_form_action_id`),
  KEY `sfa_zzzsys_form_id` (`sfa_zzzsys_form_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `zzzsys_form_action`
--

LOCK TABLES `zzzsys_form_action` WRITE;
/*!40000 ALTER TABLE `zzzsys_form_action` DISABLE KEYS */;
INSERT INTO `zzzsys_form_action` VALUES ('53a914a2ed96156','53a914a2d4f6e8c','Create Report','nuSaveForm()',NULL,'2014-06-24 16:03:15','globeadmin','2014-06-24 16:03:15','globeadmin','2014-10-01 10:02:21','globeadmin'),('549d860a5268b68','547d6ec60ac6bdd','Εμφάνιση PDF','var g=get_session_variable(\'grading_period_id\');\nvar c=get_session_variable(\'class_id\');\nvar s=get_session_variable(\'subject_id\');\n\nif(c!=-1){\n    set_session_variable(\'mark_print_grading_period_id\',g);\n    set_session_variable(\'mark_print_class_id\',c);\n    set_session_variable(\'mark_print_subject_id\',s);\n\n    nuPrintPDF(\'marks_print\');\n} else {\n    alert(\'Παρακαλώ επιλέξτε πρώτα τμήμα-μάθημα!\');\n    \n}','select \'1\'','2014-12-26 18:00:10','globeadmin','2015-01-17 16:38:19','globeadmin','2021-03-24 11:12:34','globeadmin'),('5803ce4d8372996','56e98e66abfe2c1','< Προηγούμενος Μαθητής','nuAjax(\'find_prev_student_comments\',\'open_prev_student\');\n//nuGoToForm(3,false);',NULL,'2016-10-16 22:00:29','globeadmin','2016-10-17 15:40:35','globeadmin','2021-03-24 11:21:27','globeadmin'),('5627f3209146dc1','5627e58b8ed5f6d','< Προηγούμενος Μαθητής','nuAjax(\'find_prev_student_mark\',\'open_prev_student\');',NULL,'2015-10-21 23:18:40','globeadmin','2017-12-17 18:03:54','globeadmin','2018-07-23 09:37:24','globeadmin'),('568832b5b2d702a','5684e68b302da76','Κλωνοποίηση','nuOpenFormInFrame(\'568834bf97fe8a1\',\'#RECORD_ID#\');','select if(\'#RECORD_ID#\'<>\'-1\',\'1\',\'0\')','2016-01-02 22:27:33','globeadmin','2016-01-03 10:49:55','globeadmin','2021-03-24 11:14:34','globeadmin'),('56dda32da962993','56dd9f180d22b31','Αποθήκευση Σχολίων','var iframetmc = document.getElementById(\'tinymce_editor\');\nvar htmltext = iframetmc.contentWindow.getHTML();\n\n$(\'#comments\').val(htmltext);\n\nif (typeof parent.set_comments === \'function\') { \n    parent.set_comments(\'#RECORD_ID#\',htmltext);    \n}\n\nvar c = $(\'#connections_disp\').val();\nnuSetHash(\'update_connections\', \'0\');\nif (c!=\'\' && c!=\'0\'){\n    var msg = (c==\'1\' ? \n            \'Βρέθηκε συνδιδασκαλία με ένα άλλο τμήμα. Θέλετε να ενημερωθούν και τα σχόλια αυτής;\' : \n            \'Βρέθηκαν συνδιδασκαλίες με \'+c+\' άλλα τμήματα. Θέλετε να ενημερωθούν και τα σχόλια αυτών;\');\n    if(confirm(msg)){\n        nuSetHash(\'update_connections\', \'1\');\n    }\n}\n\nnuSaveForm();',NULL,'2016-03-07 17:50:05','globeadmin','2022-11-30 11:54:33','globeadmin','2022-12-21 12:48:45','globeadmin'),('56e2cd5fa7501e5','56e052ae98309fe','Εκτύπωση Ημερολογίου','var iframe = document.getElementById(\'registered_cards_iframe\');\n\n//var frm = document.getElementById(\'registered_cards_iframe\').contentWindow;\niframe.contentWindow.focus();\niframe.contentWindow.print();\n',NULL,'2016-03-11 15:51:27','globeadmin','2016-03-11 16:00:56','globeadmin','2022-12-21 12:47:00','globeadmin'),('56e341b7804aad7','5501db35db0c716','Σημειώσεις Διδασκαλίας','nuAjax(\'find_registered_card\',\'open_rc\');',NULL,'2016-03-12 00:07:51','globeadmin','2016-03-12 00:42:28','globeadmin','2019-07-02 12:47:12','globeadmin'),('56e5677b60f0547','56e553b8d3afa56','Εκτύπωση Ημερολογίου','var iframe = document.getElementById(\'teaching_showiframe\');\n\niframe.contentWindow.focus();\niframe.contentWindow.print();',NULL,'2016-03-13 15:13:31','globeadmin','2016-03-13 15:15:50','globeadmin','2016-10-09 10:31:49','globeadmin'),('5803d19f68ddab4','56e98e66abfe2c1','Αποθήκευση Σχολίων','var iframe1 = document.getElementById(\'tinymce_editor\');\nvar htmltext1 = iframe1.contentWindow.getHTML();\n\nvar iframe2 = document.getElementById(\'tinymce_editor2\');\nvar htmltext2 = iframe2.contentWindow.getHTML();\n\nvar prev_std_comments = $(\'#student_comments\').val();\n\nif(prev_std_comments.trim() != htmltext2.trim()){\n    nuFORM.edited = 1;\n} else {\n    nuFORM.edited = 0;\n}\n\n$(\'#teacher_comments\').val(htmltext1);\n$(\'#student_comments\').val(htmltext2);\n\n//if (typeof parent.set_comments === \'function\') { \n//    parent.set_comments(\'td#RECORD_ID#\',htmltext);    \n//}\n\nif(document.getElementById(\'hide_to_student\').checked && htmltext2!=\'\'){\n    sisMessage(\'Τα σχόλια προς το Μαθητή/Γονέα θα εμφανίζονται μόνο στο Γονέα και όχι στον Μαθητή!\');\n}\n\n\nnuSaveForm();',NULL,'2016-10-16 22:14:39','globeadmin','2016-12-02 22:07:57','globeadmin','2021-03-24 11:21:27','globeadmin'),('5803d19f72a0df3','56e98e66abfe2c1','Επόμενος Μαθητής >','nuAjax(\'find_next_student_comments\',\'open_next_student\');',NULL,'2016-10-16 22:14:39','globeadmin','2016-10-16 22:26:03','globeadmin','2021-03-24 11:21:27','globeadmin'),('5711f1f630cfba9','5711e1d915f5011','Αποστολή Μηνύματος','if($(\'#sms_text\').val().trim()!=\'\'){\n    var sms_left = $(\'#sms_disp\').val();\n    if (sms_left==\'UL\' || sms_left > 0){\n        showLoader();\n        nuAjax(\'send_sms\',\'display_sent_result\',{async:true});\n    } else {\n        alert(\'Το υπόλοιπό των μηνυμάτων σας δεν επαρκεί για την αποστολή!\');\n    }\n} else {\n    alert(\'Παρακαλώ συμπληρώστε το μήνυμα σας!\');\n}',NULL,'2016-04-16 11:04:06','globeadmin','2016-07-11 23:30:53','globeadmin','2021-03-24 11:17:49','globeadmin'),('571a859ad32ca74','5719cb61e92d4e8','Αποστολή Μηνυμάτων','var phones_array = [];\n\nfunction search_phone(phone){\n    for(var z=0; z<phones_array.length;z++){\n        if(phones_array[z][2]==phone) {return true;}\n    }\n    return false;\n}\n\n\nfunction add_phones_from_checks(chk_array,txt){\n    for(var i=0, n=chk_array.length;i<n;i++) {\n        if(chk_array[i].checked){\n            var data = chk_array[i].id.split(\'_\'); \n            if (data[0] != \'all\'){\n                if(!search_phone(data[2])){\n                    var phone = [-1,data[1],data[2],txt];\n                    phones_array.push(phone);\n                }\n            }\n        }\n    }    \n}\n\nfunction esc (val) {\n    if (typeof(val)!=\'string\') return val;\n    return val\n      .replace(/[\\\\]/g, \'\\\\\\\\\')\n      .replace(/[\\n]/g, \'\\\\n\')\n      .replace(/[\\r]/g, \'\\\\r\')\n      .replace(/[\\t]/g, \'\\\\t\')\n    ; \n}\n\nif($(\'#sms_text\').val().trim()!=\'\'){\n    \n    var iframe = document.getElementById(\'search_iframe\');\n    var innerDoc = (iframe.contentDocument) ? iframe.contentDocument : iframe.contentWindow.document;\n\n    var c1 = innerDoc.getElementsByClassName(\'chk_1\');\n    var c2 = innerDoc.getElementsByClassName(\'chk_2\');\n    var c3 = innerDoc.getElementsByClassName(\'chk_3\');\n    var c4 = innerDoc.getElementsByClassName(\'chk_4\');\n    var c5 = innerDoc.getElementsByClassName(\'chk_5\');\n    var c6 = innerDoc.getElementsByClassName(\'chk_6\');\n    \n    add_phones_from_checks(c1,$(\'#sms_text\').val());\n    add_phones_from_checks(c2,$(\'#sms_text\').val());\n    add_phones_from_checks(c3,$(\'#sms_text\').val());\n    add_phones_from_checks(c4,$(\'#sms_text\').val());\n    add_phones_from_checks(c5,$(\'#sms_text\').val());\n    add_phones_from_checks(c6,$(\'#sms_text\').val());\n    \n    var phones_JSON = JSON.stringify(phones_array);\n    phones_JSON = esc(phones_JSON);\n    \n    if(phones_JSON!=\'[]\'){\n        var sms_left = $(\'#sms_disp\').val();\n        if (sms_left==\'UL\' || sms_left >= phones_array.length){\n            if(confirm(\'Θα στείλετε \'+phones_array.length+\' SMS!\\nΕίστε σίγουρος;\')){\n                showLoader();\n                nuSetHash(\'phones_JSON\', phones_JSON);\n                nuAjax(\'send_mass_sms\',\'display_sent_result\',{async:true});\n            }\n        } else {\n            alert(\'Έχετε επιλέξει να στείλετε \'+phones_array.length+\' SMS.\\nΤο υπόλοιπό των μηνυμάτων σας (\'+sms_left+\') δεν επαρκεί για την αποστολή!\');\n        }\n    } else {\n        alert (\'Παρακαλώ επιλέξτε πρώτα τα τηλέφωνα προορισμού!\');\n    }\n} else {\n    alert(\'Παρακαλώ συμπληρώστε πρώτα το μήνυμα σας!\');\n}',NULL,'2016-04-22 23:12:10','globeadmin','2016-10-08 08:56:58','globeadmin','2021-03-24 11:18:48','globeadmin'),('571bae294806306','571bae293e43d23','Αποστολή Μηνυμάτων','var phones_array = [];\n\nfunction search_phone(phone){\n    for(var z=0; z<phones_array.length;z++){\n        if(phones_array[z][2]==phone) {return true;}\n    }\n    return false;\n}\n\n\nfunction add_phones_from_checks(chk_array,txt){\n    for(var i=0, n=chk_array.length;i<n;i++) {\n        if(chk_array[i].checked){\n            var data = chk_array[i].id.split(\'_\'); \n            if (data[0] != \'all\'){\n                if(!search_phone(data[2])){\n                    var phone = [data[1],-1,data[2],txt];\n                    phones_array.push(phone);\n                }\n            }\n        }\n    }    \n}\n\nfunction esc (val) {\n    if (typeof(val)!=\'string\') return val;\n    return val\n      .replace(/[\\\\]/g, \'\\\\\\\\\')\n      .replace(/[\\n]/g, \'\\\\n\')\n      .replace(/[\\r]/g, \'\\\\r\')\n      .replace(/[\\t]/g, \'\\\\t\')\n    ; \n}\n\nif($(\'#sms_text\').val().trim()!=\'\'){\n    \n    var iframe = document.getElementById(\'search_iframe\');\n    var innerDoc = (iframe.contentDocument) ? iframe.contentDocument : iframe.contentWindow.document;\n\n    var c1 = innerDoc.getElementsByClassName(\'chk_1\');\n    var c2 = innerDoc.getElementsByClassName(\'chk_2\');\n    var c3 = innerDoc.getElementsByClassName(\'chk_3\');\n    \n    add_phones_from_checks(c1,$(\'#sms_text\').val());\n    add_phones_from_checks(c2,$(\'#sms_text\').val());\n    add_phones_from_checks(c3,$(\'#sms_text\').val());\n    \n    var phones_JSON = JSON.stringify(phones_array);\n    phones_JSON = esc(phones_JSON);\n    \n    if(phones_JSON!=\'[]\'){\n        var sms_left = $(\'#sms_disp\').val();\n        if (sms_left==\'UL\' || sms_left >= phones_array.length){\n            if(confirm(\'Θα στείλετε \'+phones_array.length+\' SMS!\\nΕίστε σίγουρος;\')){\n                showLoader();\n                nuSetHash(\'phones_JSON\', phones_JSON);\n                nuAjax(\'send_mass_sms\',\'display_sent_result\',{async:true});\n            }\n        } else {\n            alert(\'Έχετε επιλέξει να στείλετε \'+phones_array.length+\' SMS.\\nΤο υπόλοιπό των μηνυμάτων σας (\'+sms_left+\') δεν επαρκεί για την αποστολή!\');\n        }\n    } else {\n        alert (\'Παρακαλώ επιλέξτε πρώτα τα τηλέφωνα προορισμού!\');\n    }\n} else {\n    alert(\'Παρακαλώ συμπληρώστε πρώτα το μήνυμα σας!\');\n}',NULL,'2016-04-23 20:17:29','globeadmin','2016-10-08 08:58:04','globeadmin','2021-03-24 11:22:34','globeadmin'),('571d1e06b5f7f58','552cf4b2df9bcce','Αποστολή SMS ή Email','var iframe = document.getElementById(\'search_iframe\');\nvar innerDoc = (iframe.contentDocument) ? iframe.contentDocument : iframe.contentWindow.document;\n\nvar phones_array = [];\nvar emails_array = [];\n\nfunction esc (val) {\n    if (typeof(val)!=\'string\') return val;\n    return val\n      .replace(/[\\\\]/g, \'\\\\\\\\\')\n      .replace(/[\\n]/g, \'\\\\n\')\n      .replace(/[\\r]/g, \'\\\\r\')\n      .replace(/[\\t]/g, \'\\\\t\')\n    ; \n}\n\nfunction replaceAll(str, find, replace) {\n    return str.replace(new RegExp(find, \'g\'), replace);\n}\n\nfunction search_email(email,student_id){\n    for(var z=0; z<emails_array.length;z++){\n        if(emails_array[z][2]==email && emails_array[z][1]==student_id) {return true;}\n    }\n    return false;\n}\n\nfunction search_phone(phone,student_id){\n    for(var z=0; z<phones_array.length;z++){\n        if(phones_array[z][2]==phone && phones_array[z][1]==student_id) {return true;}\n    }\n    return false;\n}\n\nfunction add_emails_from_checks(chk_array){\n    \n    var email_text = $(\'#email_default_text\').val();\n    \n    for(var i=0, n=chk_array.length;i<n;i++) {\n        if(chk_array[i].checked){\n            var data = chk_array[i].id.split(\',\'); \n            \n            if(!search_email(data[2],data[1])){\n                    \n                var stdname_full = innerDoc.getElementById(\'stdname_\'+data[1]).innerHTML;\n                stdname_full = replaceAll(stdname_full,\'<br>\',\' \');\n                    \n                var stdname = stdname_full;\n                stdname = stdname.substring(stdname.indexOf(\'-\')+2);\n                stdname = stdname.substring(0,stdname.indexOf(\'πατ.\'));\n                    \n                var a = innerDoc.getElementById(\'a_\'+data[1]).innerHTML;\n                var d = innerDoc.getElementById(\'d_\'+data[1]).innerHTML;\n                var s = innerDoc.getElementById(\'s_\'+data[1]).innerHTML;\n                    \n                var subject=\'Ενημέρωση Απουσιών, \'+stdname;\n                \n                var txt = replaceAll(email_text,\'-student-\',stdname);\n                txt = replaceAll(txt,\'-date-\',$(\'#to_date\').val());\n                txt = replaceAll(txt,\'-total-\',s);\n                txt = replaceAll(txt,\'-unjustified-\',a);\n                txt = replaceAll(txt,\'-justified-\',d);\n                \n                var email = [-1,data[1],data[2],subject,txt];\n                emails_array.push(email);\n            }\n        }\n    }    \n}\n\nfunction add_phones_from_checks(chk_array){\n    \n    var sms_text = $(\'#sms_default_text\').val();\n    \n    for(var i=0, n=chk_array.length;i<n;i++) {\n        if(chk_array[i].checked){\n            var data = chk_array[i].id.split(\'_\'); \n            if (data[0] != \'all\'){\n                if(!search_phone(data[2],data[1])){\n                    \n                    var stdname = innerDoc.getElementById(\'stdname_\'+data[1]).innerHTML;\n                    \n                    stdname = stdname.substring(stdname.indexOf(\'-\')+2);\n                    stdname = stdname.substring(0,stdname.indexOf(\'πατ.\'));\n                    stdname = replaceAll(stdname,\'<br>\',\'\');\n                    stdname = replaceAll(stdname,\'<b>\',\'\');\n                    stdname = replaceAll(stdname,\'</b>\',\'\');\n                    \n                    var a = innerDoc.getElementById(\'a_\'+data[1]).innerHTML;\n                    var d = innerDoc.getElementById(\'d_\'+data[1]).innerHTML;\n                    var s = innerDoc.getElementById(\'s_\'+data[1]).innerHTML;\n                    \n                    var txt = replaceAll(sms_text,\'-date-\',$(\'#to_date\').val());\n                    txt = replaceAll(txt,\'-total-\',s);\n                    txt = replaceAll(txt,\'-unjustified-\',a);\n                    txt = replaceAll(txt,\'-justified-\',d);\n                    \n                    txt = replaceAll(txt,\'<br>\',\'\');\n                    txt = replaceAll(txt,\'<b>\',\'\');\n                    txt = replaceAll(txt,\'</b>\',\'\');\n                    \n                    var free_space = 160 - (txt.length + $(\'#school_short_name\').val().length + 2);\n                    free_space = (free_space<0 ? 0 : free_space);\n                    \n                    stdname = stdname.substr(0,free_space);\n                    txt = replaceAll(txt,\'-student-\',stdname);\n                    \n                    var phone = [-1,data[1],data[2],txt];\n                    phones_array.push(phone);\n                }\n            }\n        }\n    }    \n}\n    \nif(selected_option==7){\n\n    var c1 = innerDoc.getElementsByClassName(\'chk_1\');\n    var c2 = innerDoc.getElementsByClassName(\'chk_2\');\n    var c3 = innerDoc.getElementsByClassName(\'chk_3\');\n    var c4 = innerDoc.getElementsByClassName(\'chk_4\');\n    var c5 = innerDoc.getElementsByClassName(\'chk_5\');\n    var c6 = innerDoc.getElementsByClassName(\'chk_6\');\n    \n    add_phones_from_checks(c1);\n    add_phones_from_checks(c2);\n    add_phones_from_checks(c3);\n    add_phones_from_checks(c4);\n    add_phones_from_checks(c5);\n    add_phones_from_checks(c6);\n    \n    var phones_JSON = JSON.stringify(phones_array);\n    \n    if(phones_JSON!=\'[]\'){\n        var sms_left = $(\'#sms_disp\').val();\n        if (sms_left==\'UL\' || sms_left >= phones_array.length){\n            if(confirm(\'Θα στείλετε \'+phones_array.length+\' SMS!\\nΕίστε σίγουρος;\')){\n                showLoader();\n                nuSetHash(\'phones_JSON\', phones_JSON);\n                nuAjax(\'send_mass_sms\',\'display_sent_result\',{async:true});\n            }\n        } else {\n            alert(\'Έχετε επιλέξει να στείλετε \'+phones_array.length+\' SMS.\\nΤο υπόλοιπό των μηνυμάτων σας (\'+sms_left+\') δεν επαρκεί για την αποστολή!\');\n        }\n    } else {\n        alert (\'Παρακαλώ επιλέξτε πρώτα τα τηλέφωνα προορισμού!\');\n    }\n} else if(selected_option==6){\n    var c1 = innerDoc.getElementsByClassName(\'chk_1\');\n    var c2 = innerDoc.getElementsByClassName(\'chk_2\');\n    var c3 = innerDoc.getElementsByClassName(\'chk_3\');\n    \n    add_emails_from_checks(c1);\n    add_emails_from_checks(c2);\n    add_emails_from_checks(c3);\n    \n    var emails_JSON = JSON.stringify(emails_array);\n    emails_JSON = esc(emails_JSON);\n    \n    if(emails_JSON!=\'[]\'){\n        if(confirm(\'Θα στείλετε \'+emails_array.length+\' Emails!\\nΕίστε σίγουρος;\')){\n            showLoader();\n            nuSetHash(\'emails_JSON\', emails_JSON);\n            nuAjax(\'send_mass_emails\',\'display_sent_result\',{async:true});\n        }\n\n    } else {\n        alert (\'Παρακαλώ επιλέξτε πρώτα τις διευθύνσεις email προορισμού!\');\n    }    \n} else {\n    alert (\'Παρακαλώ επιλέξτε πρώτα «Αποστολή SMS» ή «Αποστολή Email» και «Εμφάνιση»\');\n}\n',NULL,'2016-04-24 22:27:02','globeadmin','2021-09-07 20:55:37','globeadmin','2021-09-07 20:55:37','globeadmin'),('572af54aec1bbff','572af54adfe5517','Αποστολή Μηνυμάτων','function esc (val) {\n    if (typeof(val)!=\'string\') return val;\n    return val\n      .replace(/[\\\\]/g, \'\\\\\\\\\')\n      .replace(/[\\n]/g, \'\\\\n\')\n      .replace(/[\\r]/g, \'\\\\r\')\n      .replace(/[\\t]/g, \'\\\\t\')\n    ; \n}\n\nvar emails_array = [];\n\nfunction search_email(email){\n    for(var z=0; z<emails_array.length;z++){\n        if(emails_array[z][2]==email) {return true;}\n    }\n    return false;\n}\n\n\nfunction add_emails_from_checks(chk_array,subject,txt){\n    for(var i=0, n=chk_array.length;i<n;i++) {\n        if(chk_array[i].checked){\n            var data = chk_array[i].id.split(\',\'); \n                if(!search_email(data[2])){\n                    var email = [-1,data[1],data[2],subject,txt];\n                    emails_array.push(email);\n                }\n        }\n    }    \n}\n\nvar tinymce_iframe = document.getElementById(\'email_text_tinymce\');\nvar htmltext = tinymce_iframe.contentWindow.getHTML();\nvar email_subject  = $(\'#subject\').val();\n\nif(email_subject.trim()!=\'\'){\n    if(htmltext.trim()!=\'\'){\n\n        var iframe = document.getElementById(\'search_iframe\');\n        var innerDoc = (iframe.contentDocument) ? iframe.contentDocument : iframe.contentWindow.document;\n\n        var c1 = innerDoc.getElementsByClassName(\'chk_1\');\n        var c2 = innerDoc.getElementsByClassName(\'chk_2\');\n        var c3 = innerDoc.getElementsByClassName(\'chk_3\');\n    \n        add_emails_from_checks(c1,email_subject,htmltext);\n        add_emails_from_checks(c2,email_subject,htmltext);\n        add_emails_from_checks(c3,email_subject,htmltext);\n    \n        var emails_JSON = JSON.stringify(emails_array);\n        emails_JSON = esc(emails_JSON);\n        \n        if(emails_JSON!=\'[]\'){\n            \n            if(confirm(\'Θα στείλετε \'+emails_array.length+\' emails!\\nΕίστε σίγουρος;\')){\n                showLoader();\n                nuSetHash(\'emails_JSON\', emails_JSON);\n                nuAjax(\'send_mass_emails\',\'display_sent_result\',{async:true});\n            }\n            \n        } else {\n            sisMessage (\'Παρακαλώ επιλέξτε πρώτα τα emails προορισμού!\');\n        }\n    } else {\n        sisMessage(\'Παρακαλώ συμπληρώστε πρώτα το μήνυμα σας!\');\n    }\n} else {\n    sisMessage(\'Παρακαλώ συμπληρώστε πρώτα το θέμα του μηνύματος σας!\');\n}',NULL,'2016-05-05 10:24:58','globeadmin','2021-09-06 21:12:16','globeadmin','2021-12-11 20:34:13','globeadmin'),('573490f95449bd1','57348bba8a00051','Ξε-Δικαιολόγηση Απουσιών','var s = document.getElementById(\'student\');\nvar std=s.value;\n\nvar d = document.getElementById(\'absence_date\');\nvar ad=d.value;\n\nif(ad==\'\'){\n    alert(\'Παρακαλώ επιλέξτε πρώτα Ημερομηνία...\');\n} else if (std==\'\'){\n    alert(\'Παρακαλώ επιλέξτε πρώτα Μαθητή...\');\n} else{\n    nuAjax(\'unjustify_absences\',\'show_ajax_result\');\n    show_lesson();\n}',NULL,'2016-05-12 17:19:37','globeadmin','2016-05-12 18:02:18','globeadmin','2018-07-12 23:29:20','globeadmin'),('572b615e8591be2','572b615e795d4d1','Αποστολή Μηνυμάτων','function esc (val) {\n    if (typeof(val)!=\'string\') return val;\n    return val\n      .replace(/[\\\\]/g, \'\\\\\\\\\')\n      .replace(/[\\n]/g, \'\\\\n\')\n      .replace(/[\\r]/g, \'\\\\r\')\n      .replace(/[\\t]/g, \'\\\\t\')\n    ; \n}\n\nvar emails_array = [];\n\nfunction search_email(email){\n    for(var z=0; z<emails_array.length;z++){\n        if(emails_array[z][2]==email) {return true;}\n    }\n    return false;\n}\n\nfunction add_emails_from_checks(chk_array,subject,txt){\n    for(var i=0, n=chk_array.length;i<n;i++) {\n        if(chk_array[i].checked){\n            var data = chk_array[i].id.split(\',\'); \n            if(!search_email(data[2])){\n                var email = [data[1],-1,data[2],subject,txt];\n                emails_array.push(email);\n            }\n        }\n    }    \n}\n\nvar tinymce_iframe = document.getElementById(\'email_text_tinymce\');\nvar htmltext = tinymce_iframe.contentWindow.getHTML();\nvar email_subject  = $(\'#subject\').val();\n\nif(email_subject.trim()!=\'\'){\n    if(htmltext.trim()!=\'\'){\n\n        var iframe = document.getElementById(\'search_iframe\');\n        var innerDoc = (iframe.contentDocument) ? iframe.contentDocument : iframe.contentWindow.document;\n\n        var c1 = innerDoc.getElementsByClassName(\'chk_1\');\n        var c2 = innerDoc.getElementsByClassName(\'chk_2\');\n    \n        add_emails_from_checks(c1,email_subject,htmltext);\n        add_emails_from_checks(c2,email_subject,htmltext);\n    \n        var emails_JSON = JSON.stringify(emails_array);\n        emails_JSON = esc(emails_JSON);\n\n        if(emails_JSON!=\'[]\'){\n            if(confirm(\'Θα στείλετε \'+emails_array.length+\' emails!\\nΕίστε σίγουρος;\')){\n                showLoader();\n                nuSetHash(\'emails_JSON\', emails_JSON);\n                nuAjax(\'send_mass_emails\',\'display_sent_result\',{async:true});\n            }\n        } else {\n            alert (\'Παρακαλώ επιλέξτε πρώτα τα emails προορισμού!\');\n        }\n    } else {\n        alert(\'Παρακαλώ συμπληρώστε πρώτα το μήνυμα σας!\');\n    }\n} else {\n    alert(\'Παρακαλώ συμπληρώστε πρώτα το θέμα του μηνύματος σας!\');\n}',NULL,'2016-05-05 18:06:06','globeadmin','2021-01-25 13:31:01','globeadmin','2021-02-27 09:46:00','globeadmin'),('5742d12ce53fbc6','5742996ed6426f1','Διαγραφή','nuAjax(\'delete_critirion_special_level\',\'after_delete\');',NULL,'2016-05-23 12:45:16','globeadmin','2016-05-23 12:49:09','globeadmin','2017-10-29 19:27:27','globeadmin'),('574541690c56a1a','57400922b87c65a','Κλωνοποίηση','if(confirm(\'Το Γενικό Κριτήριο θα κλωνοποιηθεί σε όλο του το βάθος!\\nΕίστε σίγουρος;\')){\n    nuAjax(\'clone_general_critirio_ajax\' ,\'on_clone\');\n}\n','select if(\'#RECORD_ID#\'=-1,\'0\',\'1\')','2016-05-25 09:08:41','globeadmin','2016-05-25 09:16:02','globeadmin','2020-09-18 01:08:16','globeadmin'),('574581b77ca9db2','5741fe1502bb6c2','Κλωνοποίηση','nuOpenFormInFrame(\'57457fe729a1d1c\',\'#RECORD_ID#\');','select if(\'#RECORD_ID#\'<>\'-1\',\'1\',\'0\')','2016-05-25 13:43:03','globeadmin','2016-05-25 13:43:03','globeadmin','2018-07-14 10:14:48','globeadmin'),('574605beb65ecba','57400922b87c65a','Εκτύπωση','nuPrintPDF(\'critirion_general\');','select if(\'#RECORD_ID#\'=-1,\'0\',\'1\')','2016-05-25 23:06:22','globeadmin','2016-05-25 23:06:22','globeadmin','2020-09-18 01:08:16','globeadmin'),('5762f958440ea74','5762f95837d99ee','Αποστολή Αξιολόγησης','var emails_array = [];\n\nfunction esc (val) {\n    if (typeof(val)!=\'string\') return val;\n    return val\n      .replace(/[\\\\]/g, \'\\\\\\\\\')\n      .replace(/[\\n]/g, \'\\\\n\')\n      .replace(/[\\r]/g, \'\\\\r\')\n      .replace(/[\\t]/g, \'\\\\t\')\n    ; \n}\n\nfunction search_email(email,student_id){\n    for(var z=0; z<emails_array.length;z++){\n        if(emails_array[z][2]==email && emails_array[z][1]==student_id) {return true;}\n    }\n    return false;\n}\n\nfunction add_emails_from_checks(chk_array,subject,txt){\n    for(var i=0, n=chk_array.length;i<n;i++) {\n        if(chk_array[i].checked){\n            var data = chk_array[i].id.split(\',\'); \n                if(!search_email(data[2],data[1])){\n                    var email = [-1,data[1],data[2],subject,txt];\n                    emails_array.push(email);\n                }\n        }\n    }    \n}\n\nvar g = document.getElementById(\'grading_period\');\nvar grading_period_id = g.options[g.selectedIndex].value;\n\nif(grading_period_id!=\'\'){\n\n        var iframe = document.getElementById(\'search_iframe\');\n        var innerDoc = (iframe.contentDocument) ? iframe.contentDocument : iframe.contentWindow.document;\n\n        var c1 = innerDoc.getElementsByClassName(\'chk_1\');\n        var c2 = innerDoc.getElementsByClassName(\'chk_2\');\n    \n        add_emails_from_checks(c1,\'\',\'\');\n        add_emails_from_checks(c2,\'\',\'\');\n    \n        var emails_JSON = JSON.stringify(emails_array);\n        emails_JSON = esc(emails_JSON);\n        \n        if(emails_JSON!=\'[]\'){\n            if(confirm(\'Θα στείλετε \'+emails_array.length+\' emails!\\nΕίστε σίγουρος;\')){\n                \n                nuSetHash(\'emails_JSON\', emails_JSON); \n                //nuAjax(\'send_mass_emails\',\'display_sent_result\');\n                \n            }\n        } else {\n            alert (\'Παρακαλώ επιλέξτε πρώτα τα emails προορισμού!\');\n        }\n} else {\n    alert(\'Παρακαλώ επιλέξτε πρώτα την περίοδο αξιολόγησης...\');\n}',NULL,'2016-06-16 22:09:12','globeadmin','2016-10-07 22:06:42','globeadmin','2016-10-07 22:06:43','globeadmin'),('57822e81c4948ef','57822e81b5ed24f','Αποστολή Μηνυμάτων','var emails_array = [];\n\nfunction esc (val) {\n    if (typeof(val)!=\'string\') return val;\n    return val\n      .replace(/[\\\\]/g, \'\\\\\\\\\')\n      .replace(/[\\n]/g, \'\\\\n\')\n      .replace(/[\\r]/g, \'\\\\r\')\n      .replace(/[\\t]/g, \'\\\\t\')\n    ; \n}\n\nfunction search_email(email){\n    for(var z=0; z<emails_array.length;z++){\n        if(emails_array[z][2]==email) {return true;}\n    }\n    return false;\n}\n\nfunction add_emails_from_checks(chk_array,subject,txt){\n    for(var i=0, n=chk_array.length;i<n;i++) {\n        if(chk_array[i].checked){\n            var data = chk_array[i].id.split(\',\'); \n            if(!search_email(data[2])){\n                var email = [data[1],-1,data[2],subject,txt];\n                emails_array.push(email);\n            }\n        }\n    }    \n}\n\nvar tinymce_iframe = document.getElementById(\'email_text_tinymce\');\nvar htmltext = tinymce_iframe.contentWindow.getHTML();\nvar email_subject  = $(\'#subject\').val();\n\nif(email_subject.trim()!=\'\'){\n    if(htmltext.trim()!=\'\'){\n\n        var iframe = document.getElementById(\'search_iframe\');\n        var innerDoc = (iframe.contentDocument) ? iframe.contentDocument : iframe.contentWindow.document;\n\n        var c1 = innerDoc.getElementsByClassName(\'chk_1\');\n        var c2 = innerDoc.getElementsByClassName(\'chk_2\');\n    \n        add_emails_from_checks(c1,email_subject,htmltext);\n        add_emails_from_checks(c2,email_subject,htmltext);\n    \n        var emails_JSON = JSON.stringify(emails_array);\n        emails_JSON = esc(emails_JSON);\n        \n        if(emails_JSON!=\'[]\'){\n            if(confirm(\'Θα στείλετε \'+emails_array.length+\' emails!\\nΕίστε σίγουρος;\')){\n                showLoader();\n                nuSetHash(\'emails_JSON\', emails_JSON);\n                nuAjax(\'send_mass_emails\',\'display_sent_result\',{async:true});\n            }\n        } else {\n            alert (\'Παρακαλώ επιλέξτε πρώτα τα emails προορισμού!\');\n        }\n    } else {\n        alert(\'Παρακαλώ συμπληρώστε πρώτα το μήνυμα σας!\');\n    }\n} else {\n    alert(\'Παρακαλώ συμπληρώστε πρώτα το θέμα του μηνύματος σας!\');\n}',NULL,'2016-07-10 14:16:17','globeadmin','2016-10-07 21:43:12','globeadmin','2020-10-18 00:56:52','globeadmin'),('578248e79ff5a77','54a312a5698c8f9','Email στους Καθηγητές','nuOpenForm(\'\',\'\', \'57822e81b5ed24f\', \'#RECORD_ID#\',\'Καθηγητής\'); ',NULL,'2016-07-10 16:08:55','globeadmin','2016-07-10 16:10:05','globeadmin','2020-10-17 23:16:13','globeadmin'),('57824910e934ad9','54a312a5698c8f9','SMS στους Καθηγητές','nuOpenForm(\'\',\'\', \'57829d0d8167dd0\', \'#RECORD_ID#\',\'Καθηγητής\'); ',NULL,'2016-07-10 16:09:36','globeadmin','2016-07-10 22:14:21','globeadmin','2020-10-17 23:16:13','globeadmin'),('57829d0d8b2a2e6','57829d0d8167dd0','Αποστολή Μηνυμάτων','var phones_array = [];\n\nfunction search_phone(phone){\n    for(var z=0; z<phones_array.length;z++){\n        if(phones_array[z][2]==phone) {return true;}\n    }\n    return false;\n}\n\n\nfunction add_phones_from_checks(chk_array,txt){\n    for(var i=0, n=chk_array.length;i<n;i++) {\n        if(chk_array[i].checked){\n            var data = chk_array[i].id.split(\'_\'); \n            if (data[0] != \'all\'){\n                if(!search_phone(data[2])){\n                    var phone = [data[1],-1,data[2],txt];\n                    phones_array.push(phone);\n                }\n            }\n        }\n    }    \n}\n\nfunction esc (val) {\n    if (typeof(val)!=\'string\') return val;\n    return val\n      .replace(/[\\\\]/g, \'\\\\\\\\\')\n      .replace(/[\\n]/g, \'\\\\n\')\n      .replace(/[\\r]/g, \'\\\\r\')\n      .replace(/[\\t]/g, \'\\\\t\')\n    ; \n}\n\nif($(\'#sms_text\').val().trim()!=\'\'){\n    \n    var iframe = document.getElementById(\'search_iframe\');\n    var innerDoc = (iframe.contentDocument) ? iframe.contentDocument : iframe.contentWindow.document;\n\n    var c1 = innerDoc.getElementsByClassName(\'chk_1\');\n    var c2 = innerDoc.getElementsByClassName(\'chk_2\');\n    var c3 = innerDoc.getElementsByClassName(\'chk_3\');\n    \n    add_phones_from_checks(c1,$(\'#sms_text\').val());\n    add_phones_from_checks(c2,$(\'#sms_text\').val());\n    add_phones_from_checks(c3,$(\'#sms_text\').val());\n    \n    var phones_JSON = JSON.stringify(phones_array);\n    phones_JSON = esc(phones_JSON);\n    \n    if(phones_JSON!=\'[]\'){\n        var sms_left = $(\'#sms_disp\').val();\n        if (sms_left==\'UL\' || sms_left >= phones_array.length){\n            if(confirm(\'Θα στείλετε \'+phones_array.length+\' SMS!\\nΕίστε σίγουρος;\')){\n                showLoader();\n                nuSetHash(\'phones_JSON\', phones_JSON);\n                nuAjax(\'send_mass_sms\',\'display_sent_result\',{async:true});\n            }\n        } else {\n            alert(\'Έχετε επιλέξει να στείλετε \'+phones_array.length+\' SMS.\\nΤο υπόλοιπό των μηνυμάτων σας (\'+sms_left+\') δεν επαρκεί για την αποστολή!\');\n        }\n    } else {\n        alert (\'Παρακαλώ επιλέξτε πρώτα τα τηλέφωνα προορισμού!\');\n    }\n} else {\n    alert(\'Παρακαλώ συμπληρώστε πρώτα το μήνυμα σας!\');\n}',NULL,'2016-07-10 22:07:57','globeadmin','2016-10-08 08:59:32','globeadmin','2021-03-24 11:23:14','globeadmin'),('578361146ee5e2d','54a4107cddefff1','Αποστολή Μηνύματος','var emails_array = [];\n\nvar iframe = document.getElementById(\'email_text_tinymce\');\nvar htmltext = iframe.contentWindow.getHTML();\n\nvar email_subject       = $(\'#email_subject\').val();\nvar email_recipients     = $(\'#email_recipients\').val();\n\nvar teacher_id     = get_session_variable(\'sms_teacher_id\')\nvar student_id     = get_session_variable(\'sms_student_id\')\n\nfunction esc (val) {\n    if (typeof(val)!=\'string\') return val;\n    return val\n      .replace(/[\\\\]/g, \'\\\\\\\\\')\n      .replace(/[\\n]/g, \'\\\\n\')\n      .replace(/[\\r]/g, \'\\\\r\')\n      .replace(/[\\t]/g, \'\\\\t\')\n    ; \n}\n\nif(email_recipients.trim()!=\'\'){\n    if(email_subject.trim()!=\'\'){\n        if(htmltext.trim()!=\'\'){\n            \n            var recipients_array = email_recipients.split(\',\');\n            for(var i=0, n=recipients_array.length;i<n;i++) {\n                var email = [teacher_id,student_id,recipients_array[i],email_subject,htmltext];\n                emails_array.push(email);    \n            }\n                \n            var emails_JSON = JSON.stringify(emails_array);\n            emails_JSON = esc(emails_JSON);\n            \n            if(emails_JSON!=\'[]\'){\n                if(confirm(\'Θα στείλετε \'+emails_array.length+\' emails!\\nΕίστε σίγουρος;\')){\n                    showLoader();\n                    nuSetHash(\'emails_JSON\', emails_JSON);\n                    nuAjax(\'send_mass_emails\',\'display_sent_result\',{async:true});\n                }\n            } else {\n                alert (\'Παρακαλώ επιλέξτε πρώτα τα emails προορισμού!\');\n            }\n        } else {\n            alert(\'Παρακαλώ συμπληρώστε πρώτα το μήνυμα σας!\');\n        }\n    } else {\n        alert(\'Παρακαλώ συμπληρώστε πρώτα το θέμα του μηνύματος σας!\');\n    }\n} else {\n    alert(\'Παρακαλώ συμπληρώστε πρώτα τη διεύθυνση του παραλήπτη!\');\n}\n',NULL,'2016-07-11 12:04:20','globeadmin','2016-10-07 22:04:33','globeadmin','2021-03-24 11:17:19','globeadmin'),('57855318d597ac8','55222f79d342b66','Ξε-Δικαιολόγηση Όλων','var d = document.getElementById(\'absence_date\');\nvar ad=d.value;\n\nif(ad==\'\'){\n    alert(\'Παρακαλώ επιλέξτε πρώτα Ημερομηνία...\');\n} else{\n    nuAjax(\'unjustify_absences\',\'show_ajax_result\');\n    nuRunPHP(\'justify_student_day_absence\',\'absence_iframe\');    // Επαναφόρτωση Απουσιολογίου\n}','select if(\'#nu_user_group#\'=\'Managers\' OR \'#nu_user_group#\'=\'AssistManagers\' OR \'#nu_user_group#\'=\'globeadmin\',\'1\',\'0\')','2016-07-12 23:29:12','globeadmin','2016-07-12 23:34:34','globeadmin','2018-08-14 10:07:25','globeadmin'),('5787f33ab64bbd2','5787f33aaa172a1','Σημειώσεις Διδασκαλίας','nuAjax(\'find_registered_card\',\'open_rc\');','select \'0\n\'','2016-07-14 23:16:58','globeadmin','2021-04-05 23:10:03','globeadmin','2022-12-21 12:48:23','globeadmin'),('578bb8a5535a264','5787f33aaa172a1','Κενό - Δεν Έγινε Μάθημα','if($(\'#absence_date\').val()!=\'\' && $(\'#absence_period_id\').val()!=\'\' && $(\'#absence_class_id\').val()!=\'\'){\n    \n    var iframe = document.getElementById(\'period_absence_iframe\');\n    var innerDoc = (iframe.contentDocument) ? iframe.contentDocument : iframe.contentWindow.document;\n    var a = innerDoc.getElementsByClassName(\'absence\');\n\n    if (a.length>0){\n    \n        if(confirm(\'Η διδασκαλία αυτή θα καταχωρηθεί ως μη πραγματοποιηθείσα!\\nΗ ενέργεια αυτή δεν μπορεί να αναιρεθεί από εσάς!\\nΕίστε σίγουρος;\')){\n        \n            var reason = prompt(\'Παρακαλώ εισάγετε το λόγο για τον οποίο δεν πραγματοποιήθηκε η διδασκαλία\',\'\');    \n        \n            if (reason != null) {\n                if(reason.trim() != \'\'){\n                    nuSetHash(\'no_lesson_comments\',reason);\n                } else {\n                    nuSetHash(\'no_lesson_comments\',\'\'); \n                }\n            } else {\n                nuSetHash(\'no_lesson_comments\',\'\');    \n            }\n        \n            nuSetHash(\'no_lesson_period_id\',$(\'#absence_period_id\').val());\n            nuAjax(\'register_no_lesson_cards\',\'foo\'); // Δήλωση Καταχώρισης Απουσίών\n            nuRunPHP(\'create_absence_period_table_open\',\'period_absence_iframe\'); // Επαναφόρτωση Απουσιολογίου\n        }\n    } else {\n        alert(\'Η Διδασκαλία έχει ήδη καταχωρηθεί. Δεν μπορεί να τροποποιηθεί!\');    \n    }\n} else {\n    alert(\'Παρακαλώ επιλέξτε πρώτα απουσιολόγιο...\');    \n}','select \'10\'','2016-07-17 19:56:05','globeadmin','2021-04-05 23:10:03','globeadmin','2022-12-21 12:48:23','globeadmin'),('578e9f79f21fd29','578e9b35d4d3cf8','Αποστολή Μηνύματος','var iframe = document.getElementById(\'student_home_school_text_tinymce\');\nvar htmltext = iframe.contentWindow.getHTML();\n\nvar teachers_id_list = nuGetHash(\'student_home_school_teacher_email_sumo\');\n   \nif (typeof teachers_id_list == \'undefined\'){\n    alert(\'Παρακαλώ επιλέξτε παραλήπτη..\');    \n} else if(teachers_id_list.trim()==\'\'){\n    alert(\'Παρακαλώ επιλέξτε παραλήπτη..\');   \n} else if(htmltext.trim()==\'\'){\n    alert(\'Παρακαλώ γράψτε πρώτα το μήνυμα σας...\');\n} else{\n    \n    nuSetHash(\'teacher_ids\', teachers_id_list);\n    nuSetHash(\'email_subject\', \'Μήνυμα από \'+\'#surname#\'+\' \'+\'#name#\');\n    nuSetHash(\'email_content\', htmltext);\n    nuSetHash(\'is_student\', \'0\');\n    nuSetHash(\'sender_name\', \'καθηγητής \'+\'#surname#\'+\' \'+\'#name#\');\n    \n    showLoader();\n    nuAjax(\'send_email_to_teachers\',\'display_sent_result\',{async:true});\n    \n}\n',NULL,'2016-07-20 00:45:30','globeadmin','2019-07-25 12:18:20','globeadmin','2019-07-25 12:18:21','globeadmin'),('57dae2cd9efd5b3','57dae2cd92d16c0','Εκτύπωση Ημερολογίου','var iframe = document.getElementById(\'registered_cards_iframe\');\n\n//var frm = document.getElementById(\'registered_cards_iframe\').contentWindow;\niframe.contentWindow.focus();\niframe.contentWindow.print();\n',NULL,'2016-09-15 21:05:01','globeadmin','2016-09-15 21:05:01','globeadmin','2017-11-12 16:34:14','globeadmin'),('57e4c2e1ee7a82b','57e15c6777df58a','Αποστολή Κωδικών με Email','var iframe = document.getElementById(\'create_account_iframe\');\nvar innerDoc = (iframe.contentDocument) ? iframe.contentDocument : iframe.contentWindow.document;\n\nfunction count_checked(chk_array){\n    var c=0;\n    for(var i=0, n=chk_array.length;i<n;i++) {\n        if(chk_array[i].checked){\n            c++;    \n        }\n    }\n    return c;\n}\n\nvar c1 = innerDoc.getElementsByClassName(\'email_chk_1\');\nvar c2 = innerDoc.getElementsByClassName(\'email_chk_2\');\nvar c3 = innerDoc.getElementsByClassName(\'email_chk_3\');\n    \nif(count_checked(c1)+count_checked(c2)+count_checked(c3) > 0){\n    nuOpenFormInFrame(\'57e6bdac4fee426\', \'#RECORD_ID#\');\n} else {\n    alert (\'Παρακαλώ επιλέξτε πρώτα τις διευθύνσεις email προορισμού!\');\n}  \n\n\n',NULL,'2016-09-23 08:51:30','globeadmin','2021-09-07 20:11:05','globeadmin','2021-09-07 20:18:34','globeadmin'),('57e4c2e2104f6f6','57e15c6777df58a','Αποστολή Κωδικών με SMS','var iframe = document.getElementById(\'create_account_iframe\');\nvar innerDoc = (iframe.contentDocument) ? iframe.contentDocument : iframe.contentWindow.document;\n\nvar phones_array = [];\n\nfunction replaceAll(str, find, replace) {\n    return str.replace(new RegExp(find, \'g\'), replace);\n}\n\nfunction search_phone(phone,student_id){\n    for(var z=0; z<phones_array.length;z++){\n        if(phones_array[z][2]==phone && phones_array[z][1]==student_id) {return true;}\n    }\n    return false;\n}\n\nfunction add_phones_from_checks(chk_array){\n    for(var i=0, n=chk_array.length;i<n;i++) {\n        if(chk_array[i].checked){\n            var data = chk_array[i].id.split(\'_\'); \n            if (data[0] != \'all\'){\n                if(!search_phone(data[2],data[1])){\n                    \n                    var stdname = innerDoc.getElementById(\'stdname_\'+data[1]).innerHTML;\n                    \n                    stdname = stdname.substring(stdname.indexOf(\'-\')+2);\n                    stdname = stdname.substring(0,stdname.indexOf(\'πατ.\'));\n                    \n                    var username = innerDoc.getElementById(\'username_\'+data[1]).innerHTML;\n                    var pass = innerDoc.getElementById(\'pass_\'+data[1]).innerHTML;\n                    \n                    var txt = \'Λογαριασμός σύνδεσης γονέα στο Σίσυφο για το μαθητή \'+stdname+\' Όνομα Χρήστη:\'+username+\' Κωδικός:\'+pass;\n                    \n                    txt = replaceAll(txt,\'<br>\',\'\');\n                    txt = replaceAll(txt,\'<b>\',\'\');\n                    txt = replaceAll(txt,\'</b>\',\'\');\n                    \n                    var phone = [-1,data[1],data[2],txt];\n                    phones_array.push(phone);\n                }\n            }\n        }\n    }    \n}\n\nvar c1 = innerDoc.getElementsByClassName(\'chk_1\');\nvar c2 = innerDoc.getElementsByClassName(\'chk_2\');\nvar c3 = innerDoc.getElementsByClassName(\'chk_3\');\nvar c4 = innerDoc.getElementsByClassName(\'chk_4\');\nvar c5 = innerDoc.getElementsByClassName(\'chk_5\');\nvar c6 = innerDoc.getElementsByClassName(\'chk_6\');\n    \nadd_phones_from_checks(c1);\nadd_phones_from_checks(c2);\nadd_phones_from_checks(c3);\nadd_phones_from_checks(c4);\nadd_phones_from_checks(c5);\nadd_phones_from_checks(c6);\n    \nvar phones_JSON = JSON.stringify(phones_array);\n    \nif(phones_JSON!=\'[]\'){\n    var sms_left = $(\'#sms_disp\').val();\n    if (sms_left==\'UL\' || sms_left >= phones_array.length){\n        if(confirm(\'Θα στείλετε \'+phones_array.length+\' SMS!\\nΕίστε σίγουρος;\')){\n            showLoader();\n            nuSetHash(\'phones_JSON\', phones_JSON);\n            nuAjax(\'send_mass_sms\',\'display_sent_result\',{async:true});\n        }\n    } else {\n        alert(\'Έχετε επιλέξει να στείλετε \'+phones_array.length+\' SMS.\\nΤο υπόλοιπό των μηνυμάτων σας (\'+sms_left+\') δεν επαρκεί για την αποστολή!\');\n    }\n} else {\n    alert (\'Παρακαλώ επιλέξτε πρώτα τηλέφωνα προορισμού!\');\n}\n\n',NULL,'2016-09-23 08:51:30','globeadmin','2016-09-24 20:30:37','globeadmin','2021-09-07 20:18:34','globeadmin'),('57e6bdac5e8b8be','57e6bdac4fee426','Αποστολή Μηνυμάτων','var iframe = parent.document.getElementById(\'create_account_iframe\');\nvar innerDoc = (iframe.contentDocument) ? iframe.contentDocument : iframe.contentWindow.document;\n\nvar iframe_tinymce = document.getElementById(\'email_text_tinymce\');\nvar htmltext = iframe_tinymce.contentWindow.getHTML();\n\nvar email_subject       = $(\'#email_subject\').val();\n\nvar emails_array = [];\n\nfunction esc (val) {\n    if (typeof(val)!=\'string\') return val;\n    return val\n      .replace(/[\\\\]/g, \'\\\\\\\\\')\n      .replace(/[\\n]/g, \'\\\\n\')\n      .replace(/[\\r]/g, \'\\\\r\')\n      .replace(/[\\t]/g, \'\\\\t\')\n    ; \n}\n\nfunction replaceAll(str, find, replace) {\n    return str.replace(new RegExp(find, \'g\'), replace);\n}\n\nfunction search_email(email,student_id){\n    for(var z=0; z<emails_array.length;z++){\n        if(emails_array[z][2]==email && emails_array[z][1]==student_id) {return true;}\n    }\n    return false;\n}\n\nfunction add_emails_from_checks(chk_array){\n    for(var i=0, n=chk_array.length;i<n;i++) {\n        if(chk_array[i].checked){\n            var data = chk_array[i].id.split(\',\'); \n            \n            if(!search_email(data[2],data[1])){\n                    \n                var stdname_full = innerDoc.getElementById(\'stdname_\'+data[1]).innerHTML;\n                stdname_full = replaceAll(stdname_full,\'<br>\',\' \');\n                    \n                var stdname = stdname_full;\n                stdname = stdname.substring(stdname.indexOf(\'-\')+2);\n                stdname = stdname.substring(0,stdname.indexOf(\'πατ.\'));\n                    \n                var username = innerDoc.getElementById(\'username_\'+data[1]).innerHTML;\n                var pass = innerDoc.getElementById(\'pass_\'+data[1]).innerHTML;\n                    \n                var subject = replaceAll(email_subject,\'-student-\',stdname);\n                subject = replaceAll(subject,\'-username-\',username);\n                subject = replaceAll(subject,\'-password-\',pass);\n                \n                var txt = replaceAll(htmltext,\'-student-\',stdname);\n                txt = replaceAll(txt,\'-username-\',username);\n                txt = replaceAll(txt,\'-password-\',pass);\n                    \n                var email = [-1,data[1],data[2],subject,txt];\n                emails_array.push(email);\n            }\n        }\n    }    \n}\n\nif(email_subject.trim()!=\'\'){\n    if(htmltext.trim()!=\'\'){\n        if(htmltext.indexOf(\'-password-\') !=-1){\n            if(htmltext.indexOf(\'-username-\') !=-1){\n                var c1 = innerDoc.getElementsByClassName(\'email_chk_1\');\n                var c2 = innerDoc.getElementsByClassName(\'email_chk_2\');\n                var c3 = innerDoc.getElementsByClassName(\'email_chk_3\');\n                \n                add_emails_from_checks(c1);\n                add_emails_from_checks(c2);\n                add_emails_from_checks(c3);\n    \n                var emails_JSON = JSON.stringify(emails_array);\n                emails_JSON = esc(emails_JSON);\n                \n                if(emails_JSON!=\'[]\'){\n                    if(confirm(\'Θα στείλετε \'+emails_array.length+\' Emails!\\nΕίστε σίγουρος;\')){\n                        showLoader();\n                        nuSetHash(\'emails_JSON\', emails_JSON);\n                        nuAjax(\'send_mass_emails\',\'display_sent_result\',{async:true});\n                    }\n                } else {\n                    alert (\'Προσοχη : Δεν έχουν επιλέγει διευθύνσεις email προορισμού!\');\n                }\n            } else {\n                alert (\'Προσοχη : Λείπει το πεδίο -username- (Όνομα Χρήστη) από το περιεχόμενο του μηνύματος!\');    \n            }\n        } else {\n            alert (\'Προσοχη : Λείπει το πεδίο -password- (Κωδικός) από το περιεχόμενο του μηνύματος!\');    \n        }\n    } else {\n        alert(\'Παρακαλώ συμπληρώστε πρώτα το μήνυμα σας!\');\n    }\n} else {\n    alert(\'Παρακαλώ συμπληρώστε πρώτα το θέμα του μηνύματος σας!\');\n}\n',NULL,'2016-09-24 20:53:48','globeadmin','2021-09-07 20:15:25','globeadmin','2021-09-07 20:15:26','globeadmin'),('5807aaa045492d6','54f735c7d56625f','Μη καταχωρισμένες Διδασκαλίες','//nuOpenForm(\'\',\'\', \'5525421c67a48bc\', \'#RECORD_ID#\',\'Διδασκαλίες για τις οποίες δεν έχουν καταχωρηθεί απουσίες\');\nnuOpenFormInFrame(\'5525421c67a48bc\', \'#RECORD_ID#\');',NULL,'2016-10-19 20:17:20','globeadmin','2016-10-19 20:19:34','globeadmin','2022-09-24 23:06:18','globeadmin'),('580c7e4716ef481','580ba2a48260384','Ακύρωση','nuRemoveModal();',NULL,'2016-10-23 12:09:27','globeadmin','2016-10-23 12:09:27','globeadmin','2021-10-20 23:47:23','globeadmin'),('580d9bbdb49d905','580cdf151b06780','Εισαγωγή Νέας Ποινής','nuOpenForm(\'\',\'\', \'554517bdc18334d\', \'-1\',\'Εισαγωγή Ποινής\');',NULL,'2016-10-24 08:27:25','globeadmin','2018-01-02 13:55:44','globeadmin','2021-10-24 21:35:23','globeadmin'),('5a4b9c61605b1d9','554517bdc18334d','Εκτύπωση','nuPrintPDF(\'penalty_report\');\n',NULL,'2018-01-02 16:51:13','globeadmin','2018-01-02 16:51:13','globeadmin','2022-01-07 21:47:52','globeadmin'),('580e348cce686cb','580e312bc544f2e','Καταχώριση','var iframe = document.getElementById(\'insert_iframe\');\nvar innerDoc = (iframe.contentDocument) ? iframe.contentDocument : iframe.contentWindow.document;\n\nvar student_ids = innerDoc.getElementsByClassName(\'student_id\');\nvar adsence_array = [];\n\nfor(var i=0, n=student_ids.length;i<n;i++) {\n    var a = innerDoc.getElementById(\'a_\'+student_ids[i].id).value;\n    var d = innerDoc.getElementById(\'d_\'+student_ids[i].id).value;\n    \n    if(!a) a=0;\n    if(!d) d=0;\n    \n    var idad = [student_ids[i].id,a,d];\n    adsence_array.push(idad);\n}\n    \nvar adsence_JSON = JSON.stringify(adsence_array);\n    \nif(adsence_JSON!=\'[]\'){\n    if(confirm(\'Θα ενημερωθούν τα σύνολα των απουσιών εκτός συστήματος για κάθε μαθητή!\\nΕίστε σίγουρος;\')){\n        nuSetHash(\'adsence_JSON\', adsence_JSON);\n        //alert(adsence_JSON);\n        nuAjax(\'update_prev_absences\',\'reload_iframe\');\n    }\n} else {\n    alert (\'Δεν υπάρχει τίποτα προς καταχώριση!\');\n}    \n',NULL,'2016-10-24 19:19:24','globeadmin','2016-10-25 19:47:59','globeadmin','2022-02-11 21:16:33','globeadmin'),('583033178af4a20','583031e43183ea3','Σήμανση Επιλεγμένων ως Εκκρεμή','var ids = get_selected_ids();\nif(typeof ids != \'undefined\' && ids != null){\n    if(confirm(\'Θα ορίσετε ότι οι επιλεγμένες ειδοποιήσεις είναι σε εκκρεμότητα!\\nΕίστε σίγουρος;\')){\n        nuSetHash(\'notification_id_list\', ids);\n        nuRunPHP(\'set_notification_as_pending\',\'search_iframe\');\n    }\n}',NULL,'2016-11-19 13:10:15','globeadmin','2016-11-21 12:53:59','globeadmin','2018-07-13 19:39:13','globeadmin'),('5830331794b8ef7','583031e43183ea3','Διαγραφή Επιλεγμένων','var ids = get_selected_ids();\nif(typeof ids != \'undefined\' && ids != null){\n    if(confirm(\'Θα διαγράψετε τις επιλεγμένες ειδοποιήσεις!\\nΕίστε σίγουρος;\')){\n        nuSetHash(\'notification_id_list\', ids);\n        nuRunPHP(\'delete_notification\',\'search_iframe\');\n    }\n}\n',NULL,'2016-11-19 13:10:15','globeadmin','2016-11-21 12:56:38','globeadmin','2018-07-13 19:39:13','globeadmin'),('581252730e948cb','5812516a1bf18a5','Καταχώριση Απουσίας','var s = document.getElementById(\'student\');\nvar std=s.value;\n\nvar d = document.getElementById(\'absence_date\');\nvar ad=d.value;\n\nvar p = document.getElementById(\'period\');\nvar prd = p.options[p.selectedIndex].value;\n\nvar t = document.getElementById(\'absence_type\');\nvar at = t.options[t.selectedIndex].value;\n\nif(ad==\'\'){\n    alert(\'Προσοχή: Δεν έχει επιλεγεί ημερομηνία!\\nΠαρακαλώ επικοινωνήστε με το διαχειριστή του συστήματος!\');\n} else if(prd<=0){\n    alert(\'Προσοχή: Δεν έχει επιλεγεί ώρα!\\nΠαρακαλώ επικοινωνήστε με το διαχειριστή του συστήματος!\');\n} else if(std<=0){\n    alert(\'Προσοχή: Δεν έχει επιλεγεί Μαθητής!\\nΠαρακαλώ επικοινωνήστε με το διαχειριστή του συστήματος!\');\n} else if(at==0){\n    alert(\'Παρακαλώ επιλέξτε πρώτα τον τύπο της απουσίας...\');\n} else{\n    \n    var opts =  parent.document.getElementById(\'absence_class_id\');\n    nuSetHash(\'absence_class_id\',opts.options[opts.selectedIndex].value);\n    \n    nuSetHash(\'absence_period_id\',parent.p_id);\n    \n    var ids=std+\'_\'+prd+\'_\'+at;\n    nuSetHash(\'absence_id_list\',ids);\n    \n    nuAjax(\'add_student_absence\',\'after_absence_add\');\n}\n',NULL,'2016-10-27 22:16:03','globeadmin','2016-10-28 14:58:01','globeadmin','2022-09-24 23:07:25','globeadmin'),('5832ce613e46223','583031e43183ea3','Αποστολή Επιλεγμένων','var ids = get_selected_ids();\nif(typeof ids != \'undefined\' && ids != null){\n    if(confirm(\'Θα στείλετε τις επιλεγμένες ειδοποιήσεις!\\nΕίστε σίγουρος;\')){\n        showLoader();\n        nuSetHash(\'notification_id_list\', ids);\n        nuSetHash(\'silence_mode\', \'1\');\n        nuAjax(\'send_notification\',\'display_sent_result\',{async:true});\n    }\n}',NULL,'2016-11-21 12:37:21','globeadmin','2016-11-26 15:47:58','globeadmin','2018-07-13 19:39:13','globeadmin'),('584a65a2e0f2fa6','54a6fde1ab6eb6d','Δήλωση Προτίμησης Ατομικού Συμβούλου','nuOpenFormInFrame(\'584a5c7c116e00c\', \'#RECORD_ID#\');','select if(\'#nu_user_group#\'=\'globeadmin\' OR \'#nu_user_group#\'=\'Students\',\'0\',\'0\')','2016-12-09 00:00:00','globeadmin','2016-12-09 00:00:00','globeadmin','2021-09-06 20:12:21','globeadmin'),('584bd01a9e30606','584bd01a9203a9a','Καταχώριση Αιτήσεων','if (typeof parent.get_selected_ids === \'function\') {\n    \n    var ids = parent.get_selected_ids();\n    \n    if(typeof ids != \'undefined\' && ids != null){\n    \n        var request_reason_id = $(\'#justification_request_reason_id\').val();\n        var cm = $(\'#comments\').val();\n    \n        if(request_reason_id.trim()!=\'\'){\n            if(cm.trim()==\'\' && request_reason_id==\'8\'){ \n                alert(\'Παρακαλώ συμπληρώστε τον λόγο που αιτήστε την διαγραφή στo «Σχόλιο Αιτήσεων»\');\n            }else{ \n                if(confirm(\'Θα εισάγετε αιτήμα διαγραφής στις επιλεγμένες απουσίες!\\nΕίστε σίγουρος;\')){\n                    nuSetHash(\'absence_id_list\', ids);\n                    nuAjax(\'add_massively_justification_request\',\'display_insert_results\');// Καταχώριση Αιτήματων\n                }\n            }        \n        } else {\n            alert(\'Παρακαλώ συμπληρώστε τον «Λόγο Αιτήσεων»\'); \n        }\n    } else {\n        alert(\'Δεν έχετε επιλέξει απουσίες!\');    \n    }\n} else {\n    alert(\'Παρουσιάστηκε σφάλμα! Η εισαγωγή δεν πραγματοποιήθηκε!\');    \n}',NULL,'2016-12-10 11:51:22','globeadmin','2018-08-07 15:20:10','globeadmin','2020-09-14 22:05:04','globeadmin'),('58da935aed6ba28','58d616cfeb60afc','Διαγραφή Λογαριασμού','var c = true;\n\nif(document.getElementById(\'teacher\').value!=\'0\'){\n    if(!confirm(\'Ο λογαριασμός αυτός είναι συνδεδεμένος με καθηγητή!\\nΕίστε σίγουρος πως θέλετε να τον διαγράψετε;\')){c=false;}    \n} \n\nif(document.getElementById(\'student\').value!=\'0\' && c){\n    if(!confirm(\'Ο λογαριασμός αυτός είναι συνδεδεμένος με μαθητή!\\nΕίστε σίγουρος πως θέλετε να τον διαγράψετε;\')){c=false;}    \n} \n\nif(document.getElementById(\'parent\').value!=\'0\' && c){\n    if(!confirm(\'Ο λογαριασμός αυτός είναι συνδεδεμένος με γονέα μαθητή!\\nΕίστε σίγουρος πως θέλετε να τον διαγράψετε;\')){c=false;}    \n}\n\nif(c){nuDeleteForm();}',NULL,'2017-03-28 19:46:19','globeadmin','2017-03-28 20:01:58','globeadmin','2020-12-15 17:56:40','globeadmin'),('58e132aabeb68ae','547070c91793d3b','Αποθήκευση','var id_array = [];\n\nvar iframe = document.getElementById(\'subjects_iframe\');\nvar innerDoc = (iframe.contentDocument) ? iframe.contentDocument : iframe.contentWindow.document;\n\nvar c1 = innerDoc.getElementsByClassName(\'chk_1\');\n        \nfor(var i=0, n=c1.length;i<n;i++) {\n    if(c1[i].checked){\n        id_array.push(c1[i].id);\n    }\n} \nids = id_array.join();\n    \nif(typeof id_array != \'undefined\' && id_array != null){\n    if(c1.length>0){\n        if(id_array.length != 0 || confirm(\'Όλα τα μαθήματα θα οριστεί ότι δεν αξιολογούνται!\\nΕίστε σίγουρος;\')){\n            nuSetHash(\'subject_id_list\', ids);\n            nuSaveForm();    \n        }\n    } else {\n        nuSaveForm();\n    }   \n} else {\n    alert (\'Προσοχή : Προέκυψε πρόβλημα κατά την επεξεργασία των μαθημάτων!\');\n}\n',NULL,'2017-04-02 20:19:38','globeadmin','2021-09-04 21:36:57','globeadmin','2021-09-04 21:36:57','globeadmin'),('599b48786cd22e5','599954a01e175cd','Αποθήκευση','if(have_participants()){\n        if(confirm(\'Θέλετε να ενημερωθούν οι συμμετέχοντες για τη μεταβολή (εάν υπάρχει);\')){\n            document.getElementById(\'inform_check\').checked = true;\n            nuSetHash(\'inform_check_hash\', \'1\');    \n        } else {\n            document.getElementById(\'inform_check\').checked = false;\n            nuSetHash(\'inform_check_hash\', \'0\');    \n        }        \n}\n\nnuSaveForm();','select if(((\'#nu_user_group#\' IN (\'Managers\',\'AssistManagers\',\'Administrators\',\'Secretaries\',\'globeadmin\')) OR \'#nu_new_record#\'=\'1\' OR \'#teacher_id#\'=teacher_id) and \'#is_exam#\'<>\'1\' and \'#is_test#\'<>\'1\' and \'#is_ballot#\'<>\'1\' and \'#is_appointment#\'<>\'1\',\'1\',\'0\') from session_variables where session_id=\'#session_id#\'','2017-08-21 23:54:16','globeadmin','2020-09-18 22:05:32','globeadmin','2021-10-09 23:07:30','globeadmin'),('59a554f9ef8ebca','599591df20eb2f7','Εκτύπωση','var iframe = document.getElementById(\'calendar_iframe\');\niframe.contentWindow.focus();\niframe.contentWindow.print();',NULL,'2017-08-29 14:50:18','globeadmin','2020-09-21 08:41:50','globeadmin','2020-10-06 23:53:55','globeadmin'),('59a843ae4980350','599954a01e175cd','Διαγραφή','if(confirm(\'Το Συμβάν και όλες οι κοινοποιήσεις του θα διαγραφούν!\\nΕίστε Σιγουρος;\')){\n    \n    if(have_participants()){\n        if(confirm(\'Θέλετε να ενημερωθούν οι συμμετέχοντες για τη διαγραφή;\')){\n            document.getElementById(\'inform_check\').checked = true;\n            nuSetHash(\'inform_check_hash\', \'1\');    \n        } else {\n            document.getElementById(\'inform_check\').checked = false;\n            nuSetHash(\'inform_check_hash\', \'0\');    \n        }        \n    }\n    \n    showLoader();\n    nuAjax(\'delete_calendar_event\',\'close_me\',{async:true});\n}\n','SELECT if(((\'#nu_user_group#\' IN (\'globeadmin\',\'Managers\',\'AssistManagers\',\'Administrators\',\'Secretaries\')) OR \'#nu_new_record#\'=\'1\' OR \'#teacher_id#\'=teacher_id) AND\n         \'#is_ballot#\'<>\'1\' AND\n         (\'#is_appointment#\'<>\'1\' OR (\'#is_appointment#\'=\'1\' AND (NOW() < \'#start_date# #start_time#\'))),\'1\',\'0\')  \nFROM session_variables \nWHERE session_id=\'#session_id#\'','2017-08-31 20:13:18','globeadmin','2020-09-21 13:12:43','globeadmin','2021-10-09 23:07:30','globeadmin'),('59a9708a1553203','599591df20eb2f7','Προγ/σμός Εξέτασης','nuOpenFormInFrame(\'59a96e2c710af4a\',\'#RECORD_ID#\');',NULL,'2017-09-01 17:36:58','globeadmin','2020-09-21 08:41:50','globeadmin','2020-10-06 23:53:55','globeadmin'),('59aaf610666cacb','599591df20eb2f7','Εμφάνιση Διαγωνισμάτων','if(nuGetHash(\'show_all_exams\')==\'1\'){\n    nuSetHash(\'show_all_exams\', \'0\');\n    nuRunPHP(\'create_teacher_calendar\' ,\'calendar_iframe\');\n    $(\'#nuButton2\').val(\'Εμφάνιση Διαγωνισμάτων\');\n} else {\n    nuSetHash(\'show_all_exams\', \'1\');\n    nuRunPHP(\'create_teacher_calendar\' ,\'calendar_iframe\');    \n    $(\'#nuButton2\').val(\'Απόκρυψη Διαγωνισμάτων\');\n}\n',NULL,'2017-09-02 21:18:56','globeadmin','2020-09-21 08:42:23','globeadmin','2020-10-06 23:53:56','globeadmin'),('59f607fc929f8a8','59f607fc7a2c0b2','Αποθήκευση Επιλογής','var iframe = document.getElementById(\'tinymce_editor\');\nvar htmltext = iframe.contentWindow.getHTML();\n\nif($(\'#description\').val() != htmltext){\n    $(\'#description\').val(htmltext);\n    nuFORM.edited = 1;\n}\n\nnuSaveForm();','select if((\'#nu_user_group#\' IN (\'Managers\',\'AssistManagers\',\'Administrators\',\'globeadmin\')) OR s.teacher_id=b.teacher_id OR \'#RECORD_ID#\'=\'-1\',\'1\',\'0\')  \nFROM session_variables as s\nleft join ballot_choice as c ON c.id=\'#RECORD_ID#\'\nleft join ballot as b ON b.id=c.ballot_id\nwhere session_id=\'#session_id#\' ','2017-10-29 18:55:24','globeadmin','2017-11-06 16:40:57','globeadmin','2017-11-06 16:46:11','globeadmin'),('59ac07f014a353b','59ac07f003930c8','Εκτύπωση Ημερολογίου','var iframe = document.getElementById(\'calendar_iframe\');\niframe.contentWindow.focus();\niframe.contentWindow.print();',NULL,'2017-09-03 16:47:28','globeadmin','2017-09-03 16:47:28','globeadmin','2020-09-24 12:19:53','globeadmin'),('59c2911d8818185','54df1dbf0f931e5','Διαγραφή Υπάρχουσας Κατανομής','nuOpenFormInFrame(\'59c292e97e52d3e\', \'#RECORD_ID#\');',NULL,'2017-09-20 19:02:37','globeadmin','2017-09-20 19:16:56','globeadmin','2020-09-24 18:44:36','globeadmin'),('59c2a27076fe251','59c292e97e52d3e','Διαγραφή Κατανομής','var class_id_list = nuGetHash(\'class_id_sumo\');\n   \nif (typeof class_id_list == \'undefined\'){\n    alert(\'Παρακαλώ επιλέξτε πρώτα τα τμήματα...\');    \n} else if(class_id_list.trim()==\'\'){\n    alert(\'Παρακαλώ επιλέξτε πρώτα τα τμήματα...\');  \n} else if(confirm(\'Οι μαθητές από τα επιλεγμένα τμήματα θα διαγραφούν!\\nΕίστε Σίγουρος;\')){\n    nuAjax(\'student_class_delete_all\',\'display_delete_result\');\n}',NULL,'2017-09-20 20:16:32','globeadmin','2017-09-20 21:23:10','globeadmin','2020-09-24 18:39:39','globeadmin'),('59cfc9e1611d7ad','577ebb808309312','Επαναποστολή Επιλεγμένων','var ids = get_selected_ids();\n\nif(typeof ids != \'undefined\' && ids != null){\n    if(confirm(\'Τα επιλεγμένα μηνύματα θα σταλούν ξανά!\\nΕίστε σίγουρος;\')){\n        showLoader();\n        nuSetHash(\'email_id\', ids);\n        nuAjax(\'resend_email\',\'display_sent_result\',{async:true});\n    }\n}',NULL,'2017-09-30 19:44:17','globeadmin','2017-10-01 20:51:58','globeadmin','2021-01-24 16:08:37','globeadmin'),('59d294a424bd8b8','59d294a40ecced8','Προσθήκη στα Τμήματα','var class_id_list = nuGetHash(\'class_id_sumo\');\n   \nif (typeof class_id_list == \'undefined\'){\n    alert(\'Παρακαλώ επιλέξτε πρώτα τα τμήματα...\');    \n} else if(class_id_list.trim()==\'\'){\n    alert(\'Παρακαλώ επιλέξτε πρώτα τα τμήματα...\');  \n} else if(confirm(\'Ο μαθητής θα προσταθεί στα επιλεγμένα τμήματα!\\nΕίστε Σίγουρος;\')){\n    nuAjax(\'student_class_add\',\'display_add_result\');\n}',NULL,'2017-10-02 22:33:56','globeadmin','2017-10-02 22:33:56','globeadmin','2017-10-02 22:57:58','globeadmin'),('59cff809dd5fd05','59cfad675ee667a','Αποστολή Ξανά','if(confirm(\'Το email αυτό θα σταλεί ξανά!\\nΕίστε Σίγουρος;\')){\n    showLoader();\n    nuSetHash(\'email_id\', \'#RECORD_ID#\');            \n    nuAjax(\'resend_email\',\'display_sent_result\');\n}',NULL,'2017-09-30 23:01:13','globeadmin','2017-10-01 09:48:36','globeadmin','2018-07-05 11:04:26','globeadmin'),('59d3819316964ee','577ebb808309312','Διαγραφή Επιλεγμένων','var ids = get_selected_ids();\n\nif(typeof ids != \'undefined\' && ids != null){\n    if(confirm(\'Τα επιλεγμένα μηνύματα θα διαγραφούν!\\nΕίστε σίγουρος;\')){\n        showLoader();\n        nuSetHash(\'email_id\', ids);\n        nuAjax(\'delete_email\',\'display_delete_result\',{async:true});\n    }\n}','select if(\'#nu_user_group#\'=\'globeadmin\' or \'#nu_user_group#\'=\'Managers\' or \'#nu_user_group#\'=\'Administrators\',\'1\',\'0\')','2017-10-03 15:24:51','globeadmin','2017-10-03 15:37:42','globeadmin','2021-01-24 16:08:38','globeadmin'),('59d7f5029f96b52','59d7d745b1eecbf','Σύνολα Απουσιών','nuSetHash(\'absence_limit\',\'0\');\n//nuPrintPDF(\'absence_totals\');\nnuRunPHP(\'absence_totals\');\n','SELECT IF(\'#nu_user_group#\'=\'globeadmin\' OR count(*)>0, \'1\', \'0\')\nfrom student\nwhere teacher_id=\'#RECORD_ID#\' OR advisor_id=\'#RECORD_ID#\'','2017-10-07 00:26:26','globeadmin','2018-02-23 21:49:30','globeadmin','2021-03-09 19:39:02','globeadmin'),('59d7f502a99f8c2','59d7d745b1eecbf','Στοιχεία Μαθητών σε PDF','nuPrintPDF(\'teacher_students_full\');','SELECT IF(\'#nu_user_group#\'=\'globeadmin\' OR count(*)>0, \'1\', \'0\')\nfrom student\nwhere teacher_id=\'#RECORD_ID#\' OR advisor_id=\'#RECORD_ID#\'','2017-10-07 00:26:26','globeadmin','2018-02-23 21:49:30','globeadmin','2021-03-09 19:39:02','globeadmin'),('59eaf87d46413f8','59eaf663b08f216','Αποθήκευση Περιγραφής','var iframe = document.getElementById(\'tinymce_editor\');\nvar htmltext = iframe.contentWindow.getHTML();\n\n$(\'#description\').val(htmltext);\n\nif (typeof parent.set_description === \'function\') { \n    parent.set_description(\'#RECORD_ID#\',htmltext);    \n}\n\nnuSaveForm();','select if(((\'#nu_user_group#\' IN (\'globeadmin\',\'Managers\',\'AssistManagers\',\'Administrators\')) OR session_variables.student_id=\'#student_id#\'),\'1\',\'0\')  \nfrom session_variables where session_id=\'#session_id#\'','2017-10-21 10:34:21','globeadmin','2017-10-31 10:40:57','globeadmin','2017-10-31 10:48:07','globeadmin'),('59f842d901ba8a8','5616c3a5f23ccc8','Διαγραφή Διδασκαλίας','nuAjax(\'delete_card\',\'after_delete\');','select if(\'#valid_from#\'>curdate(),\'1\',\'0\')','2017-10-31 11:31:05','globeadmin','2017-10-31 11:31:05','globeadmin','2017-10-31 11:31:35','globeadmin'),('59fe027de5ac4f9','59fe027dd6fe9f8','Αποστολή Μηνυμάτων','function esc (val) {\n    if (typeof(val)!=\'string\') return val;\n    return val\n      .replace(/[\\\\]/g, \'\\\\\\\\\')\n      .replace(/[\\n]/g, \'\\\\n\')\n      .replace(/[\\r]/g, \'\\\\r\')\n      .replace(/[\\t]/g, \'\\\\t\')\n    ; \n}\n\nvar emails_array = [];\n\nfunction search_email(email){\n    for(var z=0; z<emails_array.length;z++){\n        if(emails_array[z][2]==email) {return true;}\n    }\n    return false;\n}\n\n\nfunction add_emails_from_checks(chk_array,subject,txt){\n    for(var i=0, n=chk_array.length;i<n;i++) {\n        if(chk_array[i].checked){\n            var data = chk_array[i].id.split(\',\'); \n                if(!search_email(data[2])){\n                    var email = [-1,data[1],data[2],subject,txt];\n                    emails_array.push(email);\n                }\n        }\n    }    \n}\n\nvar tinymce_iframe = document.getElementById(\'email_text_tinymce\');\nvar htmltext = tinymce_iframe.contentWindow.getHTML();\nvar email_subject  = $(\'#subject\').val();\n\nif(email_subject.trim()!=\'\'){\n    if(htmltext.trim()!=\'\'){\n\n        var iframe = document.getElementById(\'search_iframe\');\n        var innerDoc = (iframe.contentDocument) ? iframe.contentDocument : iframe.contentWindow.document;\n\n        var c1 = innerDoc.getElementsByClassName(\'chk_1\');\n        var c2 = innerDoc.getElementsByClassName(\'chk_2\');\n    \n        add_emails_from_checks(c1,email_subject,htmltext);\n        add_emails_from_checks(c2,email_subject,htmltext);\n    \n        var emails_JSON = JSON.stringify(emails_array);\n        emails_JSON = esc(emails_JSON);\n        \n        if(emails_JSON!=\'[]\'){\n          \n            if(confirm(\'Θα στείλετε \'+emails_array.length+\' emails!\\nΕίστε σίγουρος;\')){\n                showLoader();\n                nuSetHash(\'emails_JSON\', emails_JSON);\n                nuAjax(\'send_mass_emails\',\'display_sent_result\',{async:true});\n            }\n            \n        } else {\n            sisMessage (\'Παρακαλώ επιλέξτε πρώτα τα emails προορισμού!\');\n        }\n    } else {\n        sisMessage(\'Παρακαλώ συμπληρώστε πρώτα το μήνυμα σας!\');\n    }\n} else {\n    sisMessage(\'Παρακαλώ συμπληρώστε πρώτα το θέμα του μηνύματος σας!\');\n}',NULL,'2017-11-04 20:10:05','globeadmin','2017-11-05 12:56:53','globeadmin','2021-10-19 23:36:53','globeadmin'),('59fe2f761fd80cd','59e5cdf8d43772d','Αποστολή Email','set_session_variable(\'ballot_id\',\'#RECORD_ID#\');\nvar t=get_session_variable(\'teacher_id\');\nnuOpenForm(\'\',\'\', \'59fe027dd6fe9f8\', t,\'Αποστολή Email\'); ','select if((\'#nu_user_group#\' IN (\'globeadmin\',\'Managers\',\'AssistManagers\',\'Administrators\')) OR \'#teacher_id#\'=teacher_id,\'1\',\'0\')  \nfrom session_variables \nwhere session_id=\'#session_id#\'','2017-11-04 23:21:58','globeadmin','2017-11-04 23:21:58','globeadmin','2021-10-23 22:10:40','globeadmin'),('5a1669ee9d30c71','5470b6d7c79d3b9','Εκτύπωση','nuPrintPDF(\'class_print\');','SELECT IF(\'#RECORD_ID#\'=\'-1\',\'0\',\'1\')','2017-11-23 08:25:50','globeadmin','2018-07-29 15:24:32','globeadmin','2022-01-08 15:26:10','globeadmin'),('5a283f98079ef01','599591df20eb2f7','Έλεγχος Διαγωνισμάτων','nuOpenFormInFrame(\'5a28402a618a46f\',\'#RECORD_ID#\');',NULL,'2017-12-06 21:06:00','globeadmin','2017-12-06 21:11:28','globeadmin','2020-10-06 23:53:56','globeadmin'),('5a2ba04610aa03a','5a28402a618a46f','Διαγραφή Επιλεγμένων','\nvar ids = get_selected_ids();\n\nif(typeof ids != \'undefined\' && ids != null && ids !=\'\'){\n    if(confirm(\'Θα διαργάψετε τα επιλεγμένα διαγωνίσματα!\\nΕίστε σίγουρος;\')){\n        \n        if(document.getElementById(\'inform_check\').checked){\n            nuSetHash(\'inform_check_hash\', \'1\');    \n        } else {\n            nuSetHash(\'inform_check_hash\', \'0\'); \n        }\n        \n        nuSetHash(\'exams_id_list\', ids);\n        \n        showLoader();\n        nuAjax(\'delete_calendar_exams\',\'delete_exams_results\',{async:true});\n    }\n}',NULL,'2017-12-09 10:35:18','globeadmin','2017-12-09 20:16:35','globeadmin','2017-12-09 20:16:36','globeadmin'),('5a3694b0e1d5a37','5627e58b8ed5f6d','Αποθήκευση Περιγραφικής  Αξιολόγησης','function esc(val) {\n    if (typeof(val)!=\'string\') return val;\n    return val\n      .replace(/[\\\\]/g, \'\\\\\\\\\')\n      .replace(/[\\n]/g, \'\\\\n\')\n      .replace(/[\\r]/g, \'\\\\r\')\n      .replace(/[\\t]/g, \'\\\\t\')\n    ; \n}\n\nfunction strip(html){\n   var sel = document.createElement(\'select\');\n   var opt = document.createElement(\'option\');\n   \n   opt.value = 1;\n   opt.innerHTML = html;\n   sel.appendChild(opt);\n   \n   return sel.options[0].text.trim();\n}\n\nvar iframe = document.getElementById(\'comments_text_tinymce\');\nvar htmltext = iframe.contentWindow.getHTML();\nvar plaintext = iframe.contentWindow.getTEXT();\n$(\'#comments\').val(htmltext);\n\nvar criritia_iframe = document.getElementById(\'critiria_iframe\');\nvar criritia_innerDoc = (criritia_iframe.contentDocument) ? criritia_iframe.contentDocument : criritia_iframe.contentWindow.document;\nvar criritia_select = criritia_innerDoc.getElementsByClassName(\'critirion_select\');\nvar criritia_array = [];\n\nfor(var i=0, n=criritia_select.length;i<n;i++) {\n    var mark_special_level_id   = criritia_select[i].id;\n    var special_level_id        = criritia_select[i].options[criritia_select[i].selectedIndex].value;\n    var special_level_text      = criritia_select[i].options[criritia_select[i].selectedIndex].text.trim();\n    \n    var td_text = strip(criritia_innerDoc.getElementById(\'td_\'+mark_special_level_id).innerHTML);\n\n    var custom_text = (td_text==\'Παρακαλώ επιλέξτε...\' || td_text==special_level_text ? \'\' : esc(td_text));\n    \n    //if(custom_text!=\'\'){alert(\'Τροποποιήσατε την περιγραφή :\\n\'+special_level_text+\'\\nΣε:\\n\'+td_text);}\n    \n    var critirion = [mark_special_level_id,special_level_id,custom_text];\n    criritia_array.push(critirion);\n}\n\nvar criritia_JSON = JSON.stringify(criritia_array);\n\nif(criritia_JSON!=\'[]\'){\n    nuSetHash(\'criritia_JSON\', criritia_JSON);\n    //nuAjax(\'update_mark_critiria\',\'after_save_critiria\');\n}\n\nnuSaveForm();','select if (\'#published#\'=\'0\' AND curdate()>=grading_period.start_date AND curdate()<=grading_period.end_date,\'1\',\'0\')\nfrom grading_period\nwhere grading_period.id=\'#grading_period_id#\'\n','2017-12-17 18:00:48','globeadmin','2017-12-17 18:02:00','globeadmin','2018-07-23 09:37:24','globeadmin'),('5a3694b0ebe0ac6','5627e58b8ed5f6d','Επόμενος Μαθητής >','nuAjax(\'find_next_student_mark\',\'open_next_student\');',NULL,'2017-12-17 18:00:49','globeadmin','2017-12-17 19:05:32','globeadmin','2018-07-23 09:37:24','globeadmin'),('5a607d7738010c8','5a607704e048c15','Προσθήκη Σχολίων','function esc (val) {\n    if (typeof(val)!=\'string\') return val;\n    return val\n      .replace(/[\\\\]/g, \'\\\\\\\\\')\n      .replace(/[\\n]/g, \'\\\\n\')\n      .replace(/[\\r]/g, \'\\\\r\')\n      .replace(/[\\t]/g, \'\\\\t\')\n    ; \n}\n\nvar comments_array = [];\n\nvar tinymce_iframe = document.getElementById(\'tinymce_text\');\nvar htmltext = tinymce_iframe.contentWindow.getHTML();\n\nvar removed_p = false;\n\nif(htmltext.endsWith(\'</p>\')){\n    htmltext = htmltext.substring(0, htmltext.length-4); \n    removed_p = true;\n}\n\nvar iframe = document.getElementById(\'comments_iframe\');\nvar innerDoc = (iframe.contentDocument) ? iframe.contentDocument : iframe.contentWindow.document;\nvar c = innerDoc.getElementsByClassName(\'input_fields\');\n\nfor(var i=0, n=c.length;i<n;i++) {\n    var chk = innerDoc.getElementById(\'chk_\'+c[i].id);\n    if(chk.checked){\n        var txt = htmltext.trim()+\' \'+c[i].value.trim()+(removed_p ? \'</p>\' : \'\');\n        if(txt !=\' \'){\n            var comment = [c[i].id,txt];\n            comments_array.push(comment);     \n        }\n    }\n} \n\nvar comments_JSON = JSON.stringify(comments_array);\ncomments_JSON = esc(comments_JSON);  \n    \nif(comments_JSON!=\'[]\'){\n    if(document.getElementById(\'student_chk\').checked || document.getElementById(\'teacher_chk\').checked){\n        if(confirm(\'Θα ενημερωθούν μαζικά \'+comments_array.length+\' σχόλια μαθητών!\\nΕίστε σίγουρος;\')){\n            if(document.getElementById(\'student_chk\').checked){\n                nuSetHash(\'student_chk_hash\',\'1\');    \n            } else {\n                nuSetHash(\'student_chk_hash\',\'0\');    \n            }\n    \n            if(document.getElementById(\'teacher_chk\').checked){\n                nuSetHash(\'teacher_chk_hash\',\'1\');    \n            } else {\n                nuSetHash(\'teacher_chk_hash\',\'0\');    \n            } \n\n            showLoader();\n            nuSetHash(\'comments_JSON\',comments_JSON); \n            nuAjax(\'add_mass_comments\',\'add_result\',{async:true});\n        }\n    } else {\n        alert(\'Πρέπει πρώτα να επιλέξετε ποιούς αφορούν τα νέα σχόλια (Καθηγητή ή και Μαθητή/Γονέα)!\');        \n    }\n    \n} else {\n    alert(\'Δεν υπάρχει τίποτα για εισαγωγή!\');    \n}',NULL,'2018-01-18 12:56:55','globeadmin','2019-07-08 13:11:21','globeadmin','2019-07-08 13:11:22','globeadmin'),('5a9070815a12564','59d7d745b1eecbf','Στοιχεία Μαθητών σε Excel','showLoader();\nnuAjax(\'students_excel_export\',\'get_excel_file\',{async:true});','SELECT IF(\'#nu_user_group#\'=\'globeadmin\' OR count(*)>0, \'1\', \'0\')\nfrom student\nwhere teacher_id=\'#RECORD_ID#\' OR advisor_id=\'#RECORD_ID#\'','2018-02-23 21:50:25','globeadmin','2018-02-25 20:13:40','globeadmin','2021-03-09 19:39:02','globeadmin'),('5b048331d325de7','547489b0d4efe7c','Αποθήκευση','var iframe = document.getElementById(\'tinymce_editor\');\nvar htmltext = iframe.contentWindow.getHTML();\n\n$(\'#exam_curriculum\').val(htmltext);\n\nnuSaveForm();',NULL,'2018-05-22 23:53:05','globeadmin','2018-05-22 23:53:05','globeadmin','2022-02-14 11:00:18','globeadmin'),('5b04854d29687da','5b04854d1104747','Αποθήκευση','var iframe = document.getElementById(\'tinymce_editor\');\nvar htmltext = iframe.contentWindow.getHTML();\n\nif($(\'#exam_curriculum\').val() != htmltext){\n    nuFORM.edited = 1;\n    $(\'#exam_curriculum\').val(htmltext);\n}\n\nnuSaveForm();',NULL,'2018-05-23 00:02:05','globeadmin','2018-05-23 23:31:10','globeadmin','2018-05-24 21:55:51','globeadmin'),('5b0730cb79b92e3','5b070b1a5c6dfb0','Εκτύπωση','var iframe = document.getElementById(\'exam_curriculum_iframe\');\n\niframe.contentWindow.focus();\niframe.contentWindow.print();\n',NULL,'2018-05-25 00:38:19','globeadmin','2018-05-25 00:38:19','globeadmin','2018-05-25 00:38:20','globeadmin'),('5c08d798b766715','5c053bad46326aa','Εκτύπωση Όλων ανά Καθηγητή','nuPrintPDF(\'advisor\');',NULL,'2018-12-06 10:02:32','globeadmin','2018-12-06 10:04:07','globeadmin','2018-12-08 20:49:19','globeadmin'),('5c83817a434ac11','5c838179bfcf3d0','Προσθήκη','var iframe = document.getElementById(\'comment_tinymce\');\nvar new_comment = iframe.contentWindow.getHTML().trim();\nvar new_text = iframe.contentWindow.getTEXT().trim();\n\nif(parent.s_id != -1 && parent.sb_id != -1){\n    if(new_text != \'\'){\n        if(document.getElementById(\'student_chk\').checked || document.getElementById(\'teacher_chk\').checked){\n            \n                if(document.getElementById(\'student_chk\').checked){\n                    nuSetHash(\'student_chk_hash\',\'1\');    \n                } else {\n                    nuSetHash(\'student_chk_hash\',\'0\');    \n                }\n    \n                if(document.getElementById(\'teacher_chk\').checked){\n                    nuSetHash(\'teacher_chk_hash\',\'1\');    \n                } else {\n                    nuSetHash(\'teacher_chk_hash\',\'0\');    \n                } \n\n                showLoader();\n                \n                nuSetHash(\'new_comment\',new_comment);\n                nuSetHash(\'student_id\',parent.s_id);\n                nuSetHash(\'subject_id\',parent.sb_id);\n                \n                nuAjax(\'add_student_subject_comment\',\'add_result\',{async:true});\n            \n        } else {\n            alert(\'Πρέπει πρώτα να επιλέξετε ποιούς θα αφορά το σχόλιο (Καθηγητή ή και Μαθητή/Γονέα)!\');        \n        }\n    } else {\n        alert(\'Παρακαλώ γράψτε πρώτα το σχόλιο σας!\');    \n    }\n} else {\n    alert(\'Προσοχή : Ο μαθητής ή το μάθημα δε βρέθηκε! Η προσθήκη δεν πραγματοποιήθηκε!\');\n}',NULL,'2019-03-09 11:03:54','globeadmin','2019-03-09 16:40:32','globeadmin','2021-10-20 23:35:48','globeadmin'),('5c839aca2090880','5c838179bfcf3d0','Ακύρωση','nuRemoveModal();',NULL,'2019-03-09 12:51:54','globeadmin','2019-03-09 12:51:54','globeadmin','2021-10-20 23:35:48','globeadmin'),('5dc2b81c0b19cf2','54df1259eb4def9','Εξαγωγή Μαθητών στο Excel','nuOpenFormInFrame(\'5dc273803a8d0d6\', get_session_variable(\'teacher_id\'));',NULL,'2019-11-06 14:10:04','globeadmin','2019-11-06 14:15:09','globeadmin','2020-04-02 16:11:27','globeadmin'),('5f6097a05891541','59ac07f003930c8','Νέο Ηλεκτρονικό Ραντεβού','nuOpenFormInFrame(\'5f609a0c726f729\',\'#RECORD_ID#\');','SELECT IF((\'#nu_user_group#\'=\'Parents\' OR \'#nu_user_group#\'=\'globeadmin\') AND COUNT(*)>0,\'1\',\'0\')\nFROM teacher\nWHERE accept_appointments=1','2020-09-15 13:29:52','globeadmin','2020-09-15 13:41:44','globeadmin','2020-09-24 12:19:53','globeadmin'),('5f683d6323e80a4','599591df20eb2f7','Ηλεκτρονικά Ραντεβού','nuOpenForm(\'\',\'\', \'5f6a50545e4de79\', \'#RECORD_ID#\',\'Ηλεκτρονικά Ραντεβού Καθηγητή\');',NULL,'2020-09-21 08:42:59','globeadmin','2020-09-23 12:05:09','globeadmin','2020-10-06 23:53:56','globeadmin'),('5f68d3d281b8160','5f68d148d9f3222','Αποθήκευση Σχολίων','var iframe = document.getElementById(\'tinymce_editor\');\nvar htmltext = iframe.contentWindow.getHTML();\n$(\'#comments\').val(htmltext);\n\nvar iframe = parent.document.getElementById(\'appointments_iframe\');\nvar innerDoc = (iframe.contentDocument) ? iframe.contentDocument : iframe.contentWindow.document;\n\nvar y = innerDoc.getElementById(\'edit_img_#RECORD_ID#\');\n\nif(y){\n    if(htmltext.trim() !=\'\'){\n            y.src = \'images/edit_red.png\';\n    } else {\n            y.src = \'images/edit.png\';\n    }\n}\n\nnuSaveForm();',NULL,'2020-09-21 19:24:50','globeadmin','2020-09-21 20:59:04','globeadmin','2020-09-23 10:04:26','globeadmin'),('5f6cbd89385ac0d','57e15c6777df58a','Διαγραφή Υπαρχόντων Λογαρισμών','nuOpenFormInFrame(\'5f6cbe6fd03a211\', \'#RECORD_ID#\');',NULL,'2020-09-24 18:38:49','globeadmin','2020-09-24 18:46:21','globeadmin','2021-09-07 20:18:34','globeadmin'),('5f6cbe6fd4e0f53','5f6cbe6fd03a211','Διαγραφή Λογαριασμών','var student_id_list = nuGetHash(\'student_id_sumo\');\n   \nif (typeof student_id_list == \'undefined\'){\n    alert(\'Παρακαλώ επιλέξτε πρώτα τους λογαριασμούς...\');    \n} else if(student_id_list.trim()==\'\'){\n    alert(\'Παρακαλώ επιλέξτε πρώτα τους λογαριασμούς...\');  \n} else if(confirm(\'Οι επιλεγμένοι λογαριασμοί θα διαγραφούν!\\nΕίστε Σίγουρος;\')){\n    nuAjax(\'parent_account_delete\',\'display_delete_result\');\n}',NULL,'2020-09-24 18:42:39','globeadmin','2020-09-24 21:58:27','globeadmin','2020-09-25 10:42:54','globeadmin'),('5f6cee4487fb613','54aa751b6567046','Διαγραφή Υπαρχόντων Λογαρισμών','nuOpenFormInFrame(\'5f6cee92b5f274a\', \'#RECORD_ID#\');',NULL,'2020-09-24 22:06:44','globeadmin','2020-09-24 22:08:25','globeadmin','2020-09-24 22:08:25','globeadmin'),('5f6cee92c348e85','5f6cee92b5f274a','Διαγραφή Λογαριασμών','var student_id_list = nuGetHash(\'student_id_sumo\');\n   \nif (typeof student_id_list == \'undefined\'){\n    alert(\'Παρακαλώ επιλέξτε πρώτα τους λογαριασμούς...\');    \n} else if(student_id_list.trim()==\'\'){\n    alert(\'Παρακαλώ επιλέξτε πρώτα τους λογαριασμούς...\');  \n} else if(confirm(\'Οι επιλεγμένοι λογαριασμοί θα διαγραφούν!\\nΕίστε Σίγουρος;\')){\n    nuAjax(\'student_account_delete\',\'display_delete_result\');\n}',NULL,'2020-09-24 22:08:02','globeadmin','2020-09-24 22:11:41','globeadmin','2020-09-24 22:11:42','globeadmin'),('5f7cda5b87d6bf3','55127aebdf42446','Μαθητές με Ολοήμερη Απουσία','nuOpenForm(\'\',\'\', \'5f7cd744d8ace2f\', \'#RECORD_ID#\',\'Μαθητές με Ολοήμερη Απουσία\');',NULL,'2020-10-06 23:58:03','globeadmin','2020-10-08 23:42:27','globeadmin','2020-10-08 23:42:27','globeadmin'),('5f8b4f77d4eb44c','5f8b4f77ca6b53e','Αποστολή Μηνυμάτων','var phones_array = [];\n\nfunction search_phone(phone){\n    for(var z=0; z<phones_array.length;z++){\n        if(phones_array[z][2]==phone) {return true;}\n    }\n    return false;\n}\n\n\nfunction add_phones_from_checks(chk_array,txt){\n    for(var i=0, n=chk_array.length;i<n;i++) {\n        if(chk_array[i].checked){\n            var data = chk_array[i].id.split(\'_\'); \n            if (data[0] != \'all\'){\n                if(!search_phone(data[2])){\n                    var phone = [data[1],-1,data[2],txt];\n                    phones_array.push(phone);\n                }\n            }\n        }\n    }    \n}\n\nfunction esc (val) {\n    if (typeof(val)!=\'string\') return val;\n    return val\n      .replace(/[\\\\]/g, \'\\\\\\\\\')\n      .replace(/[\\n]/g, \'\\\\n\')\n      .replace(/[\\r]/g, \'\\\\r\')\n      .replace(/[\\t]/g, \'\\\\t\')\n    ; \n}\n\nif($(\'#sms_text\').val().trim()!=\'\'){\n    \n    var iframe = document.getElementById(\'search_iframe\');\n    var innerDoc = (iframe.contentDocument) ? iframe.contentDocument : iframe.contentWindow.document;\n\n    var c1 = innerDoc.getElementsByClassName(\'chk_1\');\n    var c2 = innerDoc.getElementsByClassName(\'chk_2\');\n    var c3 = innerDoc.getElementsByClassName(\'chk_3\');\n    \n    add_phones_from_checks(c1,$(\'#sms_text\').val());\n    add_phones_from_checks(c2,$(\'#sms_text\').val());\n    add_phones_from_checks(c3,$(\'#sms_text\').val());\n    \n    var phones_JSON = JSON.stringify(phones_array);\n    phones_JSON = esc(phones_JSON);\n    \n    if(phones_JSON!=\'[]\'){\n        var sms_left = $(\'#sms_disp\').val();\n        if (sms_left==\'UL\' || sms_left >= phones_array.length){\n            if(confirm(\'Θα στείλετε \'+phones_array.length+\' SMS!\\nΕίστε σίγουρος;\')){\n                showLoader();\n                nuSetHash(\'phones_JSON\', phones_JSON);\n                nuAjax(\'send_mass_sms\',\'display_sent_result\',{async:true});\n            }\n        } else {\n            alert(\'Έχετε επιλέξει να στείλετε \'+phones_array.length+\' SMS.\\nΤο υπόλοιπό των μηνυμάτων σας (\'+sms_left+\') δεν επαρκεί για την αποστολή!\');\n        }\n    } else {\n        alert (\'Παρακαλώ επιλέξτε πρώτα τα τηλέφωνα προορισμού!\');\n    }\n} else {\n    alert(\'Παρακαλώ συμπληρώστε πρώτα το μήνυμα σας!\');\n}',NULL,'2020-10-17 23:09:27','globeadmin','2020-10-17 23:09:27','globeadmin','2021-03-24 11:19:45','globeadmin'),('6206b4497b23408','5525421c67a48bc','Δεν Έγινε Μάθημα στα Επιλεγμένα','var id_array = [];\n\nvar iframe = document.getElementById(\'search_iframe\');\nvar innerDoc = (iframe.contentDocument) ? iframe.contentDocument : iframe.contentWindow.document;\n\nvar c1 = innerDoc.getElementsByClassName(\'chk_1\');\n        \nfor(var i=0, n=c1.length;i<n;i++) {\n    if(c1[i].checked){\n        id_array.push(c1[i].id);\n    }\n} \n    \nids = id_array.join();\n    \nif(typeof id_array != \'undefined\' && id_array != null && id_array.length > 0){\n    if(confirm(\'Για τις \'+id_array.length+\' επιλεγμένες διδασκαλίες θα οριστεί ότι δεν έγινε μάθημα!\\nΕίστε σίγουρος;\')){\n        \n        var reason = prompt(\'Παρακαλώ εισάγετε το λόγο για τον οποίο δεν πραγματοποιήθηκαν οι διδασκαλίες\',\'\');    \n        if (reason != null) {\n            if(reason.trim() != \'\'){\n                nuSetHash(\'no_lesson_comments\',reason);\n            } else {\n                nuSetHash(\'no_lesson_comments\',\'\'); \n            }\n        } else {\n            nuSetHash(\'no_lesson_comments\',\'\');    \n        }\n        nuSetHash(\'card_list\', ids);\n        nuRunPHP(\'register_no_lesson_mass\',\'search_iframe\');\n    }\n} else {\n    alert (\'Παρακαλώ επιλέξτε πρώτα τις διδασκαλίες!\');\n}',NULL,'2022-02-11 21:08:57','globeadmin','2022-02-11 21:08:57','globeadmin','2022-09-17 21:45:17','globeadmin'),('6206b4497800554','5525421c67a48bc','Email στους Διδάσκοντες','var iframe = document.getElementById(\'search_iframe\');\n\n\n\nif (typeof iframe.contentWindow.get_techers_ids === \'function\' && iframe.contentWindow.get_techers_ids()!=\'\') { \n\n    var txt = \'\';\n    if($(\'#from_date\').val() != $(\'#to_date\').val()){\n        txt = \'Κατά το χρονικό διάστημα από <b>\'+$(\'#from_date\').val()+\'</b> έως <b>\'+$(\'#to_date\').val()+\'</b>\';   \n    }\n    else {\n        txt = \'Στις <b>\'+$(\'#from_date\').val()+\'</b>\';\n    }\n    txt += \' βρέθηκαν διδασκαλίες σας για τις οποίες <b><u>δεν έχετε καταχωρίσει τις απουσίες</u></b> των μαθητών.<p>Παρακαλώ όπως το πράξετε άμεσα!</p><p>#surname# #name#</p>\';\n    \n    set_session_variable(\'email_recipients\',iframe.contentWindow.get_techers_ids());\n    set_session_variable(\'email_subject\',\'Καταχώριση απουσιών σε εκκρεμότητα\'); \n    set_session_variable(\'email_text\',txt);\n    nuOpenForm(\'\',\'\', \'5f8b690f7120805\', \'#RECORD_ID#\',\'Καθηγητής\'); \n\n} else {\n    alert(\'Δε βρέθηκαν διδάσκοντες!\');    \n}','select if(  \'#nu_user_group#\'=\'globeadmin\' or \n            \'#nu_user_group#\'=\'Administrators\' or \n            \'#nu_user_group#\'=\'Managers\' or \n            \'#nu_user_group#\'=\'AssistManagers\',\'1\',\'0\')','2022-02-11 21:08:57','globeadmin','2022-02-11 21:08:57','globeadmin','2022-09-17 21:45:16','globeadmin'),('6206b449799430b','5525421c67a48bc','SMS στους Διδάσκοντες','var iframe = document.getElementById(\'search_iframe\');\n\nif (typeof iframe.contentWindow.get_techers_ids === \'function\' && iframe.contentWindow.get_techers_ids()!=\'\') { \n\n    var txt = \'\';\n    if($(\'#from_date\').val() != $(\'#to_date\').val()){\n        txt = \'Από \'+$(\'#from_date\').val()+\' έως \'+$(\'#to_date\').val();   \n    }\n    else {\n        txt = \'Στις \'+$(\'#from_date\').val();\n    }\n    txt += \' έχετε διδασκαλίες όπου δεν έχετε καταχωρίσει τις απουσίες των μαθητών. Παρακαλώ όπως το πράξετε.\';\n    \n    set_session_variable(\'email_recipients\',iframe.contentWindow.get_techers_ids());\n    set_session_variable(\'email_text\',txt);\n    nuOpenForm(\'\',\'\', \'5f8b4f77ca6b53e\', \'#RECORD_ID#\',\'Καθηγητής\'); \n\n} else {\n    alert(\'Δε βρέθηκαν διδάσκοντες!\');    \n}','select if(  \'#nu_user_group#\'=\'globeadmin\' or \n            \'#nu_user_group#\'=\'Administrators\' or \n            \'#nu_user_group#\'=\'Managers\' or \n            \'#nu_user_group#\'=\'AssistManagers\',\'1\',\'0\')','2022-02-11 21:08:57','globeadmin','2022-02-11 21:08:57','globeadmin','2022-09-17 21:45:16','globeadmin'),('5f8b690f7f2d309','5f8b690f7120805','Αποστολή Μηνυμάτων','var emails_array = [];\n\nfunction esc (val) {\n    if (typeof(val)!=\'string\') return val;\n    return val\n      .replace(/[\\\\]/g, \'\\\\\\\\\')\n      .replace(/[\\n]/g, \'\\\\n\')\n      .replace(/[\\r]/g, \'\\\\r\')\n      .replace(/[\\t]/g, \'\\\\t\')\n    ; \n}\n\nfunction search_email(email){\n    for(var z=0; z<emails_array.length;z++){\n        if(emails_array[z][2]==email) {return true;}\n    }\n    return false;\n}\n\nfunction add_emails_from_checks(chk_array,subject,txt){\n    for(var i=0, n=chk_array.length;i<n;i++) {\n        if(chk_array[i].checked){\n            var data = chk_array[i].id.split(\',\'); \n            if(!search_email(data[2])){\n                var email = [data[1],-1,data[2],subject,txt];\n                emails_array.push(email);\n            }\n        }\n    }    \n}\n\nvar tinymce_iframe = document.getElementById(\'email_text_tinymce\');\nvar htmltext = tinymce_iframe.contentWindow.getHTML();\nvar email_subject  = $(\'#subject\').val();\n\nif(email_subject.trim()!=\'\'){\n    if(htmltext.trim()!=\'\'){\n\n        var iframe = document.getElementById(\'search_iframe\');\n        var innerDoc = (iframe.contentDocument) ? iframe.contentDocument : iframe.contentWindow.document;\n\n        var c1 = innerDoc.getElementsByClassName(\'chk_1\');\n        var c2 = innerDoc.getElementsByClassName(\'chk_2\');\n    \n        add_emails_from_checks(c1,email_subject,htmltext);\n        add_emails_from_checks(c2,email_subject,htmltext);\n    \n        var emails_JSON = JSON.stringify(emails_array);\n        emails_JSON = esc(emails_JSON);\n        \n        if(emails_JSON!=\'[]\'){\n            if(confirm(\'Θα στείλετε \'+emails_array.length+\' emails!\\nΕίστε σίγουρος;\')){\n                showLoader();\n                nuSetHash(\'emails_JSON\', emails_JSON);\n                nuAjax(\'send_mass_emails\',\'display_sent_result\',{async:true});\n            }\n        } else {\n            alert (\'Παρακαλώ επιλέξτε πρώτα τα emails προορισμού!\');\n        }\n    } else {\n        alert(\'Παρακαλώ συμπληρώστε πρώτα το μήνυμα σας!\');\n    }\n} else {\n    alert(\'Παρακαλώ συμπληρώστε πρώτα το θέμα του μηνύματος σας!\');\n}',NULL,'2020-10-18 00:58:39','globeadmin','2020-10-18 00:58:39','globeadmin','2022-09-17 21:39:27','globeadmin'),('616c8bafe25ce2c','616c8bafd921bae','Ακύρωση','nuRemoveModal();\n',NULL,'2021-10-17 23:46:39','globeadmin','2021-10-18 18:18:58','globeadmin','2022-01-08 18:45:23','globeadmin'),('6175a7fae37ece1','6175a7faca903a3','Απονομή Νέας Επιβράβευσης','nuOpenFormInFrame(\'61d88d6b6d133c3\', \'-1\');',NULL,'2021-10-24 21:37:46','globeadmin','2022-01-08 18:43:53','globeadmin','2022-01-08 18:43:54','globeadmin'),('6175acf64189ecc','6175a7faca903a3','Λόγοι Επιβράβευσης','nuOpenForm(\'\',\'\', \'61744f1b13259e3\', \'\',\'Λόγοι Επιβράβευσης\');',NULL,'2021-10-24 21:59:02','globeadmin','2021-10-28 12:41:51','globeadmin','2022-01-08 18:43:54','globeadmin'),('61d88d6b75077cd','61d88d6b6d133c3','Ακύρωση','nuRemoveModal();\n',NULL,'2022-01-07 20:58:51','globeadmin','2022-01-07 20:58:51','globeadmin','2022-01-08 18:43:20','globeadmin'),('62076b3a03c3752','5564d8431a9da4b','Σύγκριση Απουσιών με Άλλα Συστήματα','nuOpenForm(\'\',\'\', \'6206ad009f3ac5e\', \'#RECORD_ID\',\'Καθηγητής\');',NULL,'2022-02-12 10:09:30','globeadmin','2022-02-12 10:13:25','globeadmin','2022-02-12 10:13:26','globeadmin');
/*!40000 ALTER TABLE `zzzsys_form_action` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `zzzsys_lookup`
--

DROP TABLE IF EXISTS `zzzsys_lookup`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `zzzsys_lookup` (
  `zzzsys_lookup_id` varchar(25) NOT NULL DEFAULT '',
  `slo_zzzsys_object_id` varchar(25) DEFAULT NULL,
  `zzzsys_slo_table_field_name` varchar(100) DEFAULT NULL,
  `zzzsys_slo_object_name` varchar(100) DEFAULT NULL,
  `zzzsys_slo_field_function_name` varchar(2000) NOT NULL,
  `zzzsys_lookup_log_added_at` datetime NOT NULL,
  `zzzsys_lookup_log_added_by` varchar(25) NOT NULL,
  `zzzsys_lookup_log_changed_at` datetime NOT NULL,
  `zzzsys_lookup_log_changed_by` varchar(25) NOT NULL,
  `zzzsys_lookup_log_viewed_at` datetime NOT NULL,
  `zzzsys_lookup_log_viewed_by` varchar(25) NOT NULL,
  PRIMARY KEY (`zzzsys_lookup_id`),
  KEY `slo_zzzsys_object_id` (`slo_zzzsys_object_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `zzzsys_lookup`
--

LOCK TABLES `zzzsys_lookup` WRITE;
/*!40000 ALTER TABLE `zzzsys_lookup` DISABLE KEYS */;
INSERT INTO `zzzsys_lookup` VALUES ('52f30fe3c213bac','52f30d863684946',NULL,'sfw_hidden_form_sql','sfo_sql','2014-02-06 15:30:27','globeadmin','2014-02-12 14:10:13','globeadmin','2014-02-12 14:57:29','globeadmin'),('52faf0009e3fce0','52f30d863684946',NULL,'sfw_hidden_table','sfo_table','2014-02-12 14:52:32','globeadmin','2014-02-12 14:52:32','globeadmin','2014-02-12 14:57:29','globeadmin'),('1457f6ce830fc5','1457c6e9eb2c5b','12345','cusNotes','12345','0000-00-00 00:00:00','','0000-00-00 00:00:00','','2013-10-14 09:10:38','globeadmin'),('52f2fad4d283a83','52f2c18304ece6c',NULL,'fw_hidden_form_sql','sfo_sql','2014-02-06 14:00:36','globeadmin','2014-02-12 14:05:09','globeadmin','2014-02-12 14:55:36','globeadmin'),('52faefacb69bef2','52f2c18304ece6c',NULL,'fw_hidden_table','sfo_table','2014-02-12 14:51:08','globeadmin','2014-02-12 14:51:08','globeadmin','2014-02-12 14:55:36','globeadmin'),('54f2e3b8c0d2083','54f2dfd7ecc297d',NULL,'student_name','getStudentName()','2015-03-01 12:02:32','globeadmin','2015-03-01 12:02:32','globeadmin','2016-03-06 10:05:41','globeadmin'),('54f2eca67523820','54f2dfd7ecc297d',NULL,'student_fathers_name','getFatherstName()','2015-03-01 12:40:38','globeadmin','2015-03-01 12:40:38','globeadmin','2016-03-06 10:05:41','globeadmin'),('553e9584d33c30b','553e92f4963377e',NULL,'student_name','getStudentName()','2015-04-27 23:01:08','globeadmin','2015-04-27 23:01:08','globeadmin','2018-07-13 22:48:23','globeadmin'),('553e9584dd01b05','553e92f4963377e',NULL,'student_fathers_name','getFatherstName()','2015-04-27 23:01:08','globeadmin','2015-04-27 23:01:08','globeadmin','2018-07-13 22:48:23','globeadmin'),('56dbe63adaa4550','554517bddecd531',NULL,'student_name2','getStudentName()','2016-03-06 10:11:38','globeadmin','2016-03-06 10:11:38','globeadmin','2022-01-07 21:01:35','globeadmin'),('56dbe63ae469b48','554517bddecd531',NULL,'student_fathers_name2','getFatherstName()','2016-03-06 10:11:38','globeadmin','2016-03-06 10:11:38','globeadmin','2022-01-07 21:01:35','globeadmin'),('57348c25f087fcf','57348c25dcffd9b',NULL,'student_name','getStudentName()','2016-05-12 16:59:02','globeadmin','2016-05-12 16:59:02','globeadmin','2016-05-12 17:30:48','globeadmin'),('57348c260629814','57348c25dcffd9b',NULL,'student_fathers_name','getFatherstName()','2016-05-12 16:59:02','globeadmin','2016-05-12 16:59:02','globeadmin','2016-05-12 17:30:48','globeadmin'),('58124fbb9ce6f62','58124fbb896f7a5',NULL,'student_name','getStudentName()','2016-10-27 22:04:27','globeadmin','2016-10-27 22:04:27','globeadmin','2016-10-27 22:04:29','globeadmin'),('58124fbba6aae9b','58124fbb896f7a5',NULL,'student_fathers_name','getFatherstName()','2016-10-27 22:04:27','globeadmin','2016-10-27 22:04:27','globeadmin','2016-10-27 22:04:29','globeadmin'),('61d88e151ba6629','61d88e1512f3385',NULL,'student_name2','getStudentName()','2022-01-07 21:01:41','globeadmin','2022-01-07 21:01:41','globeadmin','2022-01-07 22:16:43','globeadmin'),('61d88e151e7fa21','61d88e1512f3385',NULL,'student_fathers_name2','getFatherstName()','2022-01-07 21:01:41','globeadmin','2022-01-07 21:01:41','globeadmin','2022-01-07 22:16:43','globeadmin');
/*!40000 ALTER TABLE `zzzsys_lookup` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `zzzsys_menu_item`
--

DROP TABLE IF EXISTS `zzzsys_menu_item`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `zzzsys_menu_item` (
  `zzzsys_menu_item_id` varchar(25) NOT NULL,
  `sme_parent_menu_item_id` varchar(25) DEFAULT NULL,
  `sme_name` varchar(50) NOT NULL,
  `sme_description` varchar(255) DEFAULT NULL,
  `sme_order_number` int(11) NOT NULL DEFAULT '0',
  `sme_image_name` varchar(50) DEFAULT NULL,
  `sme_label` varchar(255) DEFAULT NULL,
  `sme_title` varchar(255) DEFAULT NULL,
  `sme_onclick_code` varchar(5000) DEFAULT NULL,
  `sme_onmouseover_code` varchar(5000) DEFAULT NULL,
  `sme_onmouseout_code` varchar(5000) DEFAULT NULL,
  `sme_display_condition` varchar(1000) DEFAULT NULL,
  `zzzsys_menu_item_log_added_at` datetime NOT NULL,
  `zzzsys_menu_item_log_added_by` varchar(25) NOT NULL,
  `zzzsys_menu_item_log_changed_at` datetime NOT NULL,
  `zzzsys_menu_item_log_changed_by` varchar(25) NOT NULL,
  `zzzsys_menu_item_log_viewed_at` datetime NOT NULL,
  `zzzsys_menu_item_log_viewed_by` varchar(25) NOT NULL,
  PRIMARY KEY (`zzzsys_menu_item_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `zzzsys_menu_item`
--

LOCK TABLES `zzzsys_menu_item` WRITE;
/*!40000 ALTER TABLE `zzzsys_menu_item` DISABLE KEYS */;
INSERT INTO `zzzsys_menu_item` VALUES ('5b51eea7a4424e6',NULL,'Διεύθυνση','Προσωπικά στοιχεία και εργασίες των μελών της διεύθυνσης του Σχολείου',10,'ucard.png','Προσωπικά Στοιχεία','Προσωπικά Στοιχεία και Εργασίες','var t=get_session_variable(\'teacher_id\');\nif  (($.isNumeric(t)) && (t!=-1)) {\n    openFormFromMenu(\'548338073921bfe\', t, \'Καθηγητής\')\n} else{\n    alert(\'Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με καθηγητή!\');\n} ','highlightMainMenuImage(this);','downlightMainMenuImage(this);',NULL,'2018-07-20 17:16:07','globeadmin','2018-07-24 18:17:01','globeadmin','2018-07-24 18:17:01','globeadmin'),('5b5574070016b0b',NULL,'Διεύθυνση','Σχόλια για τους Μαθητές μου και τους Γονείς τους',130,'advisor.png','Σχόλια για τους Μαθητές μου','Σχόλια για τους Μαθητές μου και τους Γονείς τους','var t=get_session_variable(\'teacher_id\');\nif  (($.isNumeric(t)) && (t!=-1)) {\n    openFormFromMenu(\'56eae5254137ba7\', t, \'Καθηγητής\')\n} else{\n    alert(\'Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με καθηγητή!\');\n} ','highlightMainMenuImage(this);','downlightMainMenuImage(this);',NULL,'2018-07-23 09:21:59','globeadmin','2018-07-24 18:18:37','globeadmin','2018-07-24 18:18:37','globeadmin'),('5b52d17dd8bbcc2',NULL,'Διεύθυνση','Εργασίες απουσιών',70,'absences.png','Απουσίες','Εργασίες που αφορούν τις απουσίες','var t=get_session_variable(\'teacher_id\');\nif  (($.isNumeric(t)) && (t!=-1)) {\n    openFormFromMenu(\'561922d0a8f28d2\', t, \'Καθηγητής\')\n} else{\n    alert(\'Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με καθηγητή!\');\n} ','highlightMainMenuImage(this);','downlightMainMenuImage(this);',NULL,'2018-07-21 09:23:58','globeadmin','2018-07-24 18:17:54','globeadmin','2018-07-24 18:17:54','globeadmin'),('5b557ff86c68add',NULL,'Διεύθυνση','Περιεχόμενο των Διδασκαλιών του Καθηγητή',140,'ebooks.png','Περιεχόμενο Διδασκαλιών μου','Περιεχόμενο των Διδασκαλιών μου','var t=get_session_variable(\'teacher_id\');\nif  (($.isNumeric(t)) && (t!=-1)) {\n    openFormFromMenu(\'56e052ae98309fe\', t, \'Καθηγητής\')\n} else{\n    alert(\'Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με καθηγητή!\');\n} ','highlightMainMenuImage(this);','downlightMainMenuImage(this);',NULL,'2018-07-23 10:12:56','globeadmin','2018-07-25 19:30:10','globeadmin','2018-07-25 19:30:10','globeadmin'),('5b52d21c793154b',NULL,'Διεύθυνση','Ημερολόγιο',20,'calendar.png','Ημερολόγιο Σχολείου','Ημερολόγιο Σχολείου','var t=get_session_variable(\'teacher_id\');\nif  (($.isNumeric(t)) && (t!=-1)) {\n    openFormFromMenu(\'599591df20eb2f7\', t, \'Καθηγητής\')\n} else{\n    alert(\'Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με καθηγητή!\');\n} ','highlightMainMenuImage(this);','downlightMainMenuImage(this);',NULL,'2018-07-21 09:26:36','globeadmin','2018-07-24 18:17:21','globeadmin','2018-07-24 18:17:21','globeadmin'),('5b52d27b1758c37',NULL,'Διεύθυνση','Σχολείο - Μαθητές, Καθηγητές, Τμήματα κ.α',30,'school2.png','Το Σχολείο μου','Μαθητές, Καθηγητές, Τμήματα κ.α που αφορούν το Σχολείο μου','var t=get_session_variable(\'teacher_id\');\nif  (($.isNumeric(t)) && (t!=-1)) {\n    openFormFromMenu(\'56192a12e86c93e\', t, \'Καθηγητής\')\n} else{\n    alert(\'Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με καθηγητή!\');\n} ','highlightMainMenuImage(this);','downlightMainMenuImage(this);',NULL,'2018-07-21 09:28:11','globeadmin','2018-07-24 18:17:28','globeadmin','2018-07-24 18:17:28','globeadmin'),('5b52d420c655c7e',NULL,'Διεύθυνση','Αξιολόγηση μαθητών',40,'amark.png','Αξιολόγηση Μαθητών','Εργασίες που αφορούν την αξιολόγηση των μαθητών και τις ποινές τους','var t=get_session_variable(\'teacher_id\');\nif  (($.isNumeric(t)) && (t!=-1)) {\n    openFormFromMenu(\'56192be786c61d7\', t, \'Καθηγητής\')\n} else{\n    alert(\'Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με καθηγητή!\');\n} ','highlightMainMenuImage(this);','downlightMainMenuImage(this);',NULL,'2018-07-21 09:35:12','globeadmin','2018-07-24 18:17:35','globeadmin','2018-07-24 18:17:35','globeadmin'),('5b52d48f6bbf379',NULL,'Διεύθυνση','Ηλεκτρονικές ψηφοφορίες και δηλώσεις',80,'elections.png','Ψηφοφορίες & Δηλώσεις','Ηλεκτρονικές Ψηφοφορίες & Δηλώσεις','openFormFromMenu(\'59e5cdf8d43772d\', \'\',\'Ηλεκτρονικές Ψηφοφορίες & Δηλώσεις\');\n','highlightMainMenuImage(this);','downlightMainMenuImage(this);',NULL,'2018-07-21 09:37:03','globeadmin','2018-07-24 18:18:01','globeadmin','2018-07-24 21:28:38','globeadmin'),('5b52d539507e6af',NULL,'Διεύθυνση','Κέντρο Αποστολής Μηνυμάτων',50,'message_center.png','Κέντρο Αποστολής Μηνυμάτων','Κέντρο μαζικής αποστολής SMS και email','var t=get_session_variable(\'teacher_id\');\nif  (($.isNumeric(t)) && (t!=-1)) {\n    openFormFromMenu(\'571354ed43a4d47\', t, \'Καθηγητής\')\n} else{\n    alert(\'Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με καθηγητή!\');\n} ','highlightMainMenuImage(this);','downlightMainMenuImage(this);',NULL,'2018-07-21 09:39:53','globeadmin','2018-07-24 18:17:41','globeadmin','2018-07-24 18:17:41','globeadmin'),('5b52d5888fcec23',NULL,'Διεύθυνση','Μαθήματα και Διδασκαλίες',60,'subles.png','Μαθήματα και Διδασκαλίες','Θέματα που αφορούν τα μαθήματα τις διδασκαλίες και το ωρολόγιο πρόγραμμα','var t=get_session_variable(\'teacher_id\');\nif  (($.isNumeric(t)) && (t!=-1)) {\n    openFormFromMenu(\'56192c691b58858\', t, \'Καθηγητής\')\n} else{\n    alert(\'Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με καθηγητή!\');\n} ','highlightMainMenuImage(this);','downlightMainMenuImage(this);',NULL,'2018-07-21 09:41:12','globeadmin','2018-07-24 18:17:47','globeadmin','2018-07-24 18:17:47','globeadmin'),('5b5740fabd1ab7c',NULL,'Καθηγητής','Ηλεκτρονικές ψηφοφορίες και δηλώσεις',60,'elections.png','Ψηφοφορίες & Δηλώσεις','Ηλεκτρονικές Ψηφοφορίες & Δηλώσεις','openFormFromMenu(\'59e5cdf8d43772d\', \'\',\'Ηλεκτρονικές Ψηφοφορίες & Δηλώσεις\');\n','highlightMainMenuImage(this);','downlightMainMenuImage(this);',NULL,'2018-07-24 18:08:42','globeadmin','2018-07-24 18:20:16','globeadmin','2022-02-12 19:58:13','globeadmin'),('5b52d5efec5eeb5',NULL,'Διεύθυνση','Γενικές ρυθμίσεις και εργασίες για τη διαχείριση του συστήματος',180,'config.png','Ρυθμίσεις & Διαχείριση','Γενικές ρυθμίσεις και εργασίες για τη διαχείριση του συστήματος','var t=get_session_variable(\'teacher_id\');\nif  (($.isNumeric(t)) && (t!=-1)) {\n    openFormFromMenu(\'56192b05ed5032f\', t, \'Καθηγητής\')\n} else{\n    alert(\'Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με καθηγητή!\');\n} ','highlightMainMenuImage(this);','downlightMainMenuImage(this);',NULL,'2018-07-21 09:42:56','globeadmin','2018-07-24 18:19:32','globeadmin','2018-07-24 18:19:32','globeadmin'),('5b52d6656d50327',NULL,'Όλοι','Έξοδος από το σύστημα',1000,'power.png','Αποσύνδεση','Έξοδος από το Σύστημα','location.href =nuGetHome();','highlightMainMenuImage(this);','downlightMainMenuImage(this);',NULL,'2018-07-21 09:44:53','globeadmin','2018-07-24 18:16:10','globeadmin','2018-07-28 00:22:56','globeadmin'),('5b5584a9872fc66',NULL,'Διεύθυνση','Καταχώριση Aπουσιών στη Τάξη από τον  Καθηγητή',150,'pabsen.png','Καταχώριση των Aπουσιών μου','Καταχώριση απουσιών για μια διδασκαλία','var t=get_session_variable(\'teacher_id\');\n\nif  (($.isNumeric(t)) && (t!=-1)) {\n    var open_absence_books = 0;\n    open_absence_books = get_session_variable(\'open_absence_books\');\n    if(open_absence_books==0){\n        openFormFromMenu(\'5501db35db0c716\', t, \'Καταχώριση Aπουσιών στη Τάξη\')\n    } else {\n        openFormFromMenu(\'5787f33aaa172a1\', t, \'Καταχώριση Aπουσιών στη Τάξη\')\n    }\n    \n} else{\n    alert(\'Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με καθηγητή!\');\n} ','highlightMainMenuImage(this);','downlightMainMenuImage(this);',NULL,'2018-07-23 10:32:57','globeadmin','2018-07-24 18:18:52','globeadmin','2018-07-24 18:18:52','globeadmin'),('5b558654de2e9e3',NULL,'Διεύθυνση','Ποινές που έχουν επιβληθεί σε μαθητές',100,'cards.png','Ποινές Μαθητών','Ποινές που έχουν επιβληθεί σε μαθητές','var t=get_session_variable(\'teacher_id\');\nif  (($.isNumeric(t)) && (t!=-1)) {\n    openFormFromMenu(\'580cdf151b06780\', t, \'Καθηγητής\')\n} else{\n    alert(\'Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με καθηγητή!\');\n} ','highlightMainMenuImage(this);','downlightMainMenuImage(this);',NULL,'2018-07-23 10:40:05','globeadmin','2018-07-24 18:18:17','globeadmin','2022-02-12 19:54:20','globeadmin'),('5b55b4bc972078a',NULL,'Διεύθυνση','Καρτέλες Μαθητών',110,'std.png','Μαθητές','Καρτέλες Μαθητών','openFormFromMenu(\'5476201e5a3d38f\', \'\', \'Μαθητές\')\n','highlightMainMenuImage(this);','downlightMainMenuImage(this);',NULL,'2018-07-23 13:58:04','globeadmin','2018-07-24 18:18:24','globeadmin','2018-07-24 18:18:24','globeadmin'),('5b55b5478365d60',NULL,'Διεύθυνση','Καρτέλες Καθηγητών',120,'teach.png','Καθηγητές','Καρτέλες Καθηγητών','openFormFromMenu(\'547372d029461f4\', \'\', \'Καθηγητές\')\n','highlightMainMenuImage(this);','downlightMainMenuImage(this);',NULL,'2018-07-23 14:00:23','globeadmin','2018-07-24 18:18:30','globeadmin','2018-07-24 18:18:30','globeadmin'),('5b55f444a150d4a',NULL,'Διεύθυνση','Αναζήτηση Απουσιών Μαθητών',90,'search.png','Αναζήτηση Απουσιών','Αναζήτηση Απουσιών Μαθητών','var t=get_session_variable(\'teacher_id\');\nif  (($.isNumeric(t)) && (t!=-1)) {\n    openFormFromMenu(\'55127aebdf42446\', t, \'Καθηγητής\')\n} else{\n    alert(\'Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με καθηγητή!\');\n} ','highlightMainMenuImage(this);','downlightMainMenuImage(this);',NULL,'2018-07-23 18:29:08','globeadmin','2018-07-24 18:18:08','globeadmin','2022-02-12 19:39:55','globeadmin'),('5b55f4c89c27b65',NULL,'Διεύθυνση','Αναζήτηση αιτημάτων δικαιολόγησης απουσιών',160,'rsearch.png','Αιτήματα Διαγραφής Απουσιών','Αναζήτηση αιτημάτων δικαιολόγησης απουσιών','var t=get_session_variable(\'teacher_id\');\nif  (($.isNumeric(t)) && (t!=-1)) {\n    openFormFromMenu(\'551a34a930825c0\', t, \'Καθηγητής\')\n} else{\n    alert(\'Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με καθηγητή!\');\n} ','highlightMainMenuImage(this);','downlightMainMenuImage(this);',NULL,'2018-07-23 18:31:20','globeadmin','2018-07-24 18:18:59','globeadmin','2018-07-24 18:18:59','globeadmin'),('5b562b31ab550c0',NULL,'Διεύθυνση','Καταχώριση Αξιολόγησης',170,'mpost.png','Καταχώριση Αξιολόγησης','Καταχώριση της Αξιολόγησης μου','var t=get_session_variable(\'teacher_id\');\nif  (($.isNumeric(t)) && (t!=-1)) {\n    openFormFromMenu(\'562362d2ef4f556\', t, \'Καταχώριση Αξιολόγησης\')\n} else{\n    alert(\'Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με καθηγητή!\');\n} ','highlightMainMenuImage(this);','downlightMainMenuImage(this);','SELECT if(count(grading_period.id)>0,\'1\',\'0\')\nFROM school\n    left join grading_period ON school.grading_period_id=grading_period.id\nWHERE \n    CURDATE() between grading_period.start_date AND grading_period.end_date ','2018-07-23 22:23:29','globeadmin','2018-07-24 18:19:07','globeadmin','2018-07-24 18:19:07','globeadmin'),('5b56c4d75109104',NULL,'Καθηγητής','Προσωπικά στοιχεία καθηγητή',10,'ucard.png','Προσωπικά Στοιχεία','Προσωπικά Στοιχεία Καθηγητή','var t=get_session_variable(\'teacher_id\');\nif  (($.isNumeric(t)) && (t!=-1)) {\n    openFormFromMenu(\'59d7d65650da67c\', t, \'Καθηγητής\')\n} else{\n    alert(\'Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με καθηγητή!\');\n} ','highlightMainMenuImage(this);','downlightMainMenuImage(this);',NULL,'2018-07-24 09:19:03','globeadmin','2018-07-24 18:19:41','globeadmin','2022-02-12 19:57:18','globeadmin'),('5b56c62d59c9a9f',NULL,'Καθηγητής','Αξιολόγηση μαθητών',40,'amark.png','Αξιολόγηση Μαθητών','Εργασίες που αφορούν την αξιολόγηση των μαθητών και τις ποινές τους','var t=get_session_variable(\'teacher_id\');\nif  (($.isNumeric(t)) && (t!=-1)) {\n    openFormFromMenu(\'59d7d7986aed52d\', t, \'Καθηγητής\')\n} else{\n    alert(\'Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με καθηγητή!\');\n} ','highlightMainMenuImage(this);','downlightMainMenuImage(this);',NULL,'2018-07-24 09:24:45','globeadmin','2018-07-24 18:20:03','globeadmin','2022-02-12 19:57:53','globeadmin'),('5b56c6b8ac833a2',NULL,'Καθηγητής','Αποστολή & Αναζήτηση Μηνυμάτων',30,'message_center.png','Αποστολή & Αναζήτηση Μηνυμάτων','Αποστολή & Αναζήτηση Μηνυμάτων','var t=get_session_variable(\'teacher_id\');\nif  (($.isNumeric(t)) && (t!=-1)) {\n    openFormFromMenu(\'59d7d7da6d30b22\', t, \'Καθηγητής\')\n} else{\n    alert(\'Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με καθηγητή!\');\n} ','highlightMainMenuImage(this);','downlightMainMenuImage(this);',NULL,'2018-07-24 09:27:04','globeadmin','2018-07-24 18:19:56','globeadmin','2022-02-12 19:57:45','globeadmin'),('5b56c74243416ad',NULL,'Καθηγητής','Εργασίες απουσιών',50,'absences.png','Απουσίες','Εργασίες που αφορούν τις απουσίες','var t=get_session_variable(\'teacher_id\');\nif  (($.isNumeric(t)) && (t!=-1)) {\n    openFormFromMenu(\'59d7d6e9ecc73da\', t, \'Απουσίες\')\n} else{\n    alert(\'Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με καθηγητή!\');\n} ','highlightMainMenuImage(this);','downlightMainMenuImage(this);',NULL,'2018-07-24 09:29:22','globeadmin','2018-07-24 18:20:09','globeadmin','2022-02-12 19:58:04','globeadmin'),('5b56c919424f115',NULL,'Καθηγητής','Αναθέσεις Μαθημάτων και Ωρολόγιο Πρόγραμμα',90,'subles.png','Διδασκαλίες & ΩΠ','Αναθέσεις Μαθημάτων και Ωρολόγιο Πρόγραμμα','var t=get_session_variable(\'teacher_id\');\nif  (($.isNumeric(t)) && (t!=-1)) {\n    openFormFromMenu(\'59d7d837262870c\', t, \'Καταχώριση Αξιολόγησης\')\n} else{\n    alert(\'Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με καθηγητή!\');\n} ','highlightMainMenuImage(this);','downlightMainMenuImage(this);',NULL,'2018-07-24 09:37:13','globeadmin','2018-07-24 18:24:36','globeadmin','2022-02-12 19:58:37','globeadmin'),('5b56c9f16b65506',NULL,'Καθηγητής','Καρτέλες μαθητών υπεύθυνου καθηγητή',125,'std.png','Μαθητές που είμαι Υπεύθυνος','Οι καρτέλες των μαθητών για τους οποίους είμαι υπεύθυνος ή σύμβουλος','var t=get_session_variable(\'teacher_id\');\nif  (($.isNumeric(t)) && (t!=-1)) {\n    openFormFromMenu(\'59d7d745b1eecbf\', t, \'Μαθητές\')\n} else{\n    alert(\'Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με καθηγητή!\');\n} ','highlightMainMenuImage(this);','downlightMainMenuImage(this);','SELECT if(COUNT(*)>0,\'1\',\'0\')\nFROM student\nINNER JOIN session_variables ON session_id = \'#session_id#\'\nWHERE \n    student.teacher_id = session_variables.teacher_id OR\n    student.advisor_id = session_variables.teacher_id','2018-07-24 09:40:49','globeadmin','2018-07-24 18:23:16','globeadmin','2022-02-12 20:00:06','globeadmin'),('5b56d0e3a2543ef',NULL,'Καθηγητής','Επικοινωνία Σχολείου - Γονέων',130,'pmsg.png','Επικοινωνία Σχολείου - Γονέων','Επικοινωνία Σχολείου - Γονέων','var t=get_session_variable(\'teacher_id\');\nif  (($.isNumeric(t)) && (t!=-1)) {\n    openFormFromMenu(\'552cf4b2df9bcce\', t, \'Μαθητές\')\n} else{\n    alert(\'Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με καθηγητή!\');\n} ','highlightMainMenuImage(this);','downlightMainMenuImage(this);','SELECT if(COUNT(*)>0 or \'#nu_user_group#\'=\'Secretaries\',\'1\',\'0\')\nFROM student\nINNER JOIN session_variables ON session_id = \'#session_id#\'\nWHERE \n    student.teacher_id = session_variables.teacher_id','2018-07-24 10:10:27','globeadmin','2018-07-24 21:38:43','globeadmin','2022-02-12 20:00:28','globeadmin'),('5b57409ca27a001',NULL,'Καθηγητής','Ημερολόγιο',20,'calendar.png','Ημερολόγιο Σχολείου','Ημερολόγιο Σχολείου','var t=get_session_variable(\'teacher_id\');\nif  (($.isNumeric(t)) && (t!=-1)) {\n    openFormFromMenu(\'599591df20eb2f7\', t, \'Καθηγητής\')\n} else{\n    alert(\'Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με καθηγητή!\');\n} ','highlightMainMenuImage(this);','downlightMainMenuImage(this);',NULL,'2018-07-24 18:07:08','globeadmin','2018-07-24 18:19:49','globeadmin','2022-02-12 19:57:34','globeadmin'),('5b56d25297deb98',NULL,'Καθηγητής','Καταχώριση απουσιών τμήματος για ολόκληρη την ημέρα',140,'dabsen.png','Aπουσίες Τμήματος','Καταχώριση απουσιών τμήματος για ολόκληρη την ημέρα','var t=get_session_variable(\'teacher_id\');\nif  (($.isNumeric(t)) && (t!=-1)) {\n        openFormFromMenu(\'54f735c7d56625f\', t, \'Καταχώριση Aπουσιών Τμήματος\')\n} else{\n    alert(\'Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με καθηγητή!\');\n} ','highlightMainMenuImage(this);','downlightMainMenuImage(this);','select if(COUNT(*)>0 or \'#nu_user_group#\'=\'Secretaries\',\'1\',\'0\')\nfrom class \nINNER JOIN session_variables ON session_id = \'#session_id#\'\nWHERE \n    class.post_teacher_id = session_variables.teacher_id','2018-07-24 10:16:34','globeadmin','2018-07-24 21:38:55','globeadmin','2022-02-12 20:00:40','globeadmin'),('5b574145b0bebb5',NULL,'Καθηγητής','Αναζήτηση Απουσιών Μαθητών',120,'search.png','Αναζήτηση Απουσιών','Αναζήτηση Απουσιών Μαθητών','var t=get_session_variable(\'teacher_id\');\nif  (($.isNumeric(t)) && (t!=-1)) {\n    openFormFromMenu(\'55127aebdf42446\', t, \'Καθηγητής\')\n} else{\n    alert(\'Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με καθηγητή!\');\n} ','highlightMainMenuImage(this);','downlightMainMenuImage(this);',NULL,'2018-07-24 18:09:57','globeadmin','2018-07-24 20:02:18','globeadmin','2022-02-12 19:59:14','globeadmin'),('5b57418f208d5aa',NULL,'Καθηγητής','Ποινές που έχουν επιβληθεί σε μαθητές',110,'cards.png','Ποινές Μαθητών','Ποινές που έχουν επιβληθεί σε μαθητές','var t=get_session_variable(\'teacher_id\');\nif  (($.isNumeric(t)) && (t!=-1)) {\n    openFormFromMenu(\'580cdf151b06780\', t, \'Καθηγητής\')\n} else{\n    alert(\'Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με καθηγητή!\');\n} ','highlightMainMenuImage(this);','downlightMainMenuImage(this);',NULL,'2018-07-24 18:11:11','globeadmin','2018-07-24 18:25:37','globeadmin','2022-02-12 19:59:02','globeadmin'),('5b5741d9058ac5b',NULL,'Καθηγητής','Σχόλια για τους Μαθητές μου και τους Γονείς τους',80,'advisor.png','Σχόλια για τους Μαθητές μου','Σχόλια για τους Μαθητές μου και τους Γονείς τους','var t=get_session_variable(\'teacher_id\');\nif  (($.isNumeric(t)) && (t!=-1)) {\n    openFormFromMenu(\'56eae5254137ba7\', t, \'Καθηγητής\')\n} else{\n    alert(\'Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με καθηγητή!\');\n} ','highlightMainMenuImage(this);','downlightMainMenuImage(this);',NULL,'2018-07-24 18:12:25','globeadmin','2018-07-24 20:01:31','globeadmin','2022-02-12 19:58:22','globeadmin'),('5b5741f9dc51c9a',NULL,'Καθηγητής','Περιεχόμενο των Διδασκαλιών του Καθηγητή',100,'ebooks.png','Περιεχόμενο Διδασκαλιών μου','Περιεχόμενο των Διδασκαλιών μου','var t=get_session_variable(\'teacher_id\');\nif  (($.isNumeric(t)) && (t!=-1)) {\n    openFormFromMenu(\'56e052ae98309fe\', t, \'Καθηγητής\')\n} else{\n    alert(\'Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με καθηγητή!\');\n} ','highlightMainMenuImage(this);','downlightMainMenuImage(this);',NULL,'2018-07-24 18:12:57','globeadmin','2018-07-25 19:30:31','globeadmin','2022-02-12 19:58:47','globeadmin'),('5b5742359566eb0',NULL,'Καθηγητής','Καταχώριση Aπουσιών στη Τάξη από τον  Καθηγητή',150,'pabsen.png','Καταχώριση των Aπουσιών μου','Καταχώριση απουσιών για μια διδασκαλία','var t=get_session_variable(\'teacher_id\');\n\nif  (($.isNumeric(t)) && (t!=-1)) {\n    var open_absence_books = 0;\n    open_absence_books = get_session_variable(\'open_absence_books\');\n    if(open_absence_books==0){\n        openFormFromMenu(\'5501db35db0c716\', t, \'Καταχώριση Aπουσιών στη Τάξη\')\n    } else {\n        openFormFromMenu(\'5787f33aaa172a1\', t, \'Καταχώριση Aπουσιών στη Τάξη\')\n    }\n    \n} else{\n    alert(\'Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με καθηγητή!\');\n} ','highlightMainMenuImage(this);','downlightMainMenuImage(this);',NULL,'2018-07-24 18:13:57','globeadmin','2018-07-24 20:03:13','globeadmin','2022-02-12 20:00:58','globeadmin'),('5b57427877fc946',NULL,'Καθηγητής','Καταχώριση Αξιολόγησης',160,'mpost.png','Καταχώριση Αξιολόγησης','Καταχώριση της Αξιολόγησης μου','var t=get_session_variable(\'teacher_id\');\nif  (($.isNumeric(t)) && (t!=-1)) {\n    openFormFromMenu(\'562362d2ef4f556\', t, \'Καταχώριση Αξιολόγησης\')\n} else{\n    alert(\'Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με καθηγητή!\');\n} ','highlightMainMenuImage(this);','downlightMainMenuImage(this);','SELECT if(count(grading_period.id)>0,\'1\',\'0\')\nFROM school\n    left join grading_period ON school.grading_period_id=grading_period.id\nWHERE \n    CURDATE() between grading_period.start_date AND grading_period.end_date ','2018-07-24 18:15:04','globeadmin','2018-07-24 18:21:35','globeadmin','2022-02-12 20:01:12','globeadmin'),('5b578e56c0c5093',NULL,'Μαθητής-Γονέας','Πληροφορίες για τις Απουσίες του Μαθητή',30,'absences.png','Απουσίες','Πληροφορίες για τις Απουσίες του Μαθητή','var s=get_session_variable(\'student_id\');\n\nif  (($.isNumeric(s)) && (s!=-1)) {\n    openFormFromMenu(\'59e22f9965b5362\', s, \'Μαθητής\')\n} else{\n    alert(\"Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με Μαθητή/Γονέα!\");\n} \n\n','highlightMainMenuImage(this);','downlightMainMenuImage(this);',NULL,'2018-07-24 23:38:46','globeadmin','2018-07-25 19:20:59','globeadmin','2018-07-25 19:20:59','globeadmin'),('5b578fda8084e57',NULL,'Μαθητής-Γονέας','Αγόρι  - Προσωπικά Στοιχεία και Στοιχεία Σχολείου του Μαθητή',10,'boy.png','Στοιχεία Μαθητή','Προσωπικά Στοιχεία και Στοιχεία Σχολείου του Μαθητή','var s=get_session_variable(\'student_id\');\n\nif  (($.isNumeric(s)) && (s!=-1)) {\n    if(\'#nu_user_group#\'==\'Parents\'){\n        openFormFromMenu(\'54a6fde1ab6eb6d\', s, \'Μαθητής\')\n    } else {\n        openFormFromMenu(\'59e22e4fa1018fd\', s, \'Μαθητής\')\n    }    \n} else{\n    alert(\"Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με Μαθητή/Γονέα!\");\n} \n\n','highlightMainMenuImage(this);','downlightMainMenuImage(this);','select if(student.gender=\'Θ\',\'0\',\'1\')\nfrom student \nINNER JOIN session_variables ON session_id = \'#session_id#\'\nWHERE \n    student.id = session_variables.student_id','2018-07-24 23:45:14','globeadmin','2018-07-24 23:48:45','globeadmin','2018-07-25 19:20:31','globeadmin'),('5b5790d5c45d34e',NULL,'Μαθητής-Γονέας','Κορίτσι  - Προσωπικά Στοιχεία και Στοιχεία Σχολείου του Μαθητή',10,'girl.png','Στοιχεία Μαθητή','Προσωπικά Στοιχεία και Στοιχεία Σχολείου του Μαθητή','var s=get_session_variable(\'student_id\');\n\nif  (($.isNumeric(s)) && (s!=-1)) {\n    if(\'#nu_user_group#\'==\'Parents\'){\n        openFormFromMenu(\'54a6fde1ab6eb6d\', s, \'Μαθητής\')\n    } else {\n        openFormFromMenu(\'59e22e4fa1018fd\', s, \'Μαθητής\')\n    }    \n} else{\n    alert(\"Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με Μαθητή/Γονέα!\");\n} \n\n','highlightMainMenuImage(this);','downlightMainMenuImage(this);','select if(student.gender=\'Θ\',\'1\',\'0\')\nfrom student \nINNER JOIN session_variables ON session_id = \'#session_id#\'\nWHERE \n    student.id = session_variables.student_id','2018-07-24 23:49:25','globeadmin','2018-07-24 23:56:19','globeadmin','2018-07-24 23:56:19','globeadmin'),('5b5816e03c1cbcc',NULL,'Μαθητής-Γονέας','Αξιολόγηση του Μαθητή',20,'amark.png','Αξιολόγηση','Αξιολόγηση του Μαθητή','var s=get_session_variable(\'student_id\');\n\nif  (($.isNumeric(s)) && (s!=-1)) {\n    openFormFromMenu(\'59e22ed0a598932\', s, \'Μαθητής\');\n} else{\n    alert(\"Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με Μαθητή/Γονέα!\");\n} \n\n','highlightMainMenuImage(this);','downlightMainMenuImage(this);',NULL,'2018-07-25 09:21:20','globeadmin','2018-07-25 19:21:05','globeadmin','2018-07-25 19:21:05','globeadmin'),('5b581748bd55247',NULL,'Μαθητής-Γονέας','Ημερολόγιο Σχολείου',80,'calendar.png','Ημερολόγιο','Ημερολόγιο Σχολείου','var s=get_session_variable(\'student_id\');\n\nif  (($.isNumeric(s)) && (s!=-1)) {\n    openFormFromMenu(\'59ac07f003930c8\', s, \'Μαθητής\');\n} else{\n    alert(\"Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με Μαθητή/Γονέα!\");\n} \n\n','highlightMainMenuImage(this);','downlightMainMenuImage(this);',NULL,'2018-07-25 09:23:04','globeadmin','2018-07-25 19:26:33','globeadmin','2018-07-25 19:26:33','globeadmin'),('5b5817cbd57abff',NULL,'Μαθητής-Γονέας','Αποστολή Μηνύματος Email σε Καθηγητές',50,'pmsg.png','Αποστολή Μηνύματος','Αποστολή Μηνύματος Email σε Καθηγητές','var s=get_session_variable(\'student_id\');\n\nif  (($.isNumeric(s)) && (s!=-1)) {\n    openFormFromMenu(\'59e22f4f52546e3\', s, \'Μαθητής\');\n} else{\n    alert(\"Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με Μαθητή/Γονέα!\");\n} \n\n','highlightMainMenuImage(this);','downlightMainMenuImage(this);',NULL,'2018-07-25 09:25:15','globeadmin','2018-07-25 09:25:15','globeadmin','2018-07-25 09:25:55','globeadmin'),('5b5818353ddb875',NULL,'Μαθητής-Γονέας','Ποινές και Επιβραβεύσεις που έχουν Επιβληθεί στο Μαθητή',70,'cards_cup.png','Ποινές & Επιβραβεύσεις','Ποινές και Επιβραβεύσεις που έχουν Επιβληθεί στο Μαθητή','var s=get_session_variable(\'student_id\');\n\nif  (($.isNumeric(s)) && (s!=-1)) {\n    openFormFromMenu(\'59e22fca2af8d03\', s, \'Μαθητής\');\n} else{\n    alert(\"Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με Μαθητή/Γονέα!\");\n} \n\n','highlightMainMenuImage(this);','downlightMainMenuImage(this);',NULL,'2018-07-25 09:27:01','globeadmin','2022-02-12 20:07:05','globeadmin','2022-02-12 20:07:06','globeadmin'),('5b5818e89080185',NULL,'Μαθητής-Γονέας','Διδασκαλίες, Σχόλια Καθηγητών & Ωρολόγιο Πρόγραμμα',60,'subles.png','Διδασκαλίες & Πρόγραμμα','Διδασκαλίες, Σχόλια Καθηγητών & Ωρολόγιο Πρόγραμμα','var s=get_session_variable(\'student_id\');\n\nif  (($.isNumeric(s)) && (s!=-1)) {\n    openFormFromMenu(\'59e22ff819cd774\', s, \'Μαθητής\');\n} else{\n    alert(\"Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με Μαθητή/Γονέα!\");\n} \n\n','highlightMainMenuImage(this);','downlightMainMenuImage(this);',NULL,'2018-07-25 09:30:00','globeadmin','2018-07-25 19:22:06','globeadmin','2018-07-25 19:22:06','globeadmin'),('5b581981ad87f4c',NULL,'Μαθητής-Γονέας','Ηλεκτρονικές Ψηφοφορίες & Δηλώσεις',110,'elections.png','Ψηφοφορίες & Δηλώσεις','Ηλεκτρονικές Ψηφοφορίες & Δηλώσεις','openFormFromMenu(\'59e90833df79d7d\', \'\', \'Ηλεκτρονικές Ψηφοφορίες & Δηλώσεις\');','highlightMainMenuImage(this);','downlightMainMenuImage(this);',NULL,'2018-07-25 09:32:33','globeadmin','2018-07-25 19:26:40','globeadmin','2018-07-25 19:26:40','globeadmin'),('5b581a32db8d355',NULL,'Μαθητής-Γονέας','Πληροφορίες για το Σχολείο, Επικοινωνία',90,'school2.png','Πληροφορίες για το Σχολείο','Πληροφορίες για το Σχολείο, Επικοινωνία','var s=get_session_variable(\'student_id\');\n\nif  (($.isNumeric(s)) && (s!=-1)) {\n    openFormFromMenu(\'59e23027879009a\', s, \'Σχολείο\');\n} else{\n    alert(\"Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με Μαθητή/Γονέα!\");\n}','highlightMainMenuImage(this);','downlightMainMenuImage(this);',NULL,'2018-07-25 09:35:30','globeadmin','2018-07-25 09:36:57','globeadmin','2018-07-25 11:10:41','globeadmin'),('5b583079e10cc75',NULL,'Μαθητής-Γονέας','Λεπτομέρειες για την κάθε διδασκαλία που πραγματοποιήθηκε',120,'ebooks.png','Περιεχόμενο Διδασκαλιών','Λεπτομέρειες για την κάθε διδασκαλία που πραγματοποιήθηκε','var s=get_session_variable(\'student_id\');\n\nif  (($.isNumeric(s)) && (s!=-1)) {\n    openFormFromMenu(\'57dae2cd92d16c0\', s, \'Σχολείο\');\n} else{\n    alert(\"Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με Μαθητή/Γονέα!\");\n}','highlightMainMenuImage(this);','downlightMainMenuImage(this);','SELECT if(hide_teaching_calendar=1,\'0\',\'1\') \nFROM school where id=1','2018-07-25 11:10:33','globeadmin','2018-07-25 19:28:08','globeadmin','2018-07-25 19:28:08','globeadmin'),('5b5857e9917de04',NULL,'Μαθητής-Γονέας','Αναζήτηση με κριτήρια στις απουσίες του μαθητή',40,'search.png','Αναζήτηση Απουσιών','Αναζήτηση με κριτήρια στις απουσίες του μαθητή','var s=get_session_variable(\'student_id\');\n\nif  (($.isNumeric(s)) && (s!=-1)) {\n    openFormFromMenu(\'551821232f9553f\', s, \'Αναζήτηση Απουσιών\');\n} else{\n    alert(\"Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με Μαθητή/Γονέα!\");\n}','highlightMainMenuImage(this);','downlightMainMenuImage(this);',NULL,'2018-07-25 13:58:49','globeadmin','2018-07-25 19:25:49','globeadmin','2018-07-25 19:25:49','globeadmin'),('5b58589736ceccc',NULL,'Μαθητής-Γονέας','Ώρες Ενημέρωσης από τους Καθηγητές',100,'teach.png','Ώρες Ενημέρωσης Καθηγητών','Ώρες Ενημέρωσης από τους Καθηγητές','var s=get_session_variable(\'student_id\');\n\nif  (($.isNumeric(s)) && (s!=-1)) {\n    openFormFromMenu(\'566086607663544\', s, \'Ώρες Ενημέρωσης Καθηγητών\');\n} else{\n    alert(\"Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με Μαθητή/Γονέα!\");\n}','highlightMainMenuImage(this);','downlightMainMenuImage(this);',NULL,'2018-07-25 14:01:43','globeadmin','2018-07-25 19:23:47','globeadmin','2018-07-25 19:23:47','globeadmin'),('5b585adde2fd1d9',NULL,'Μαθητής-Γονέας','Επιλογές Ειδοποιήσεων',130,'notification_type.png','Επιλογές Ειδοποιήσεων','Επιλογές Ειδοποιήσεων','var s=get_session_variable(\'student_id\');\n\nif  (($.isNumeric(s)) && (s!=-1)) {\n    if(\'#nu_user_group#\'==\'Parents\'){ \n        openFormFromMenu(\'584128b691c711a\', s, \'Ώρες Ενημέρωσης Καθηγητών\');\n    } else {\n        openFormFromMenu(\'584117d1d046e30\', s, \'Ώρες Ενημέρωσης Καθηγητών\');\n    } \n} else{\n    alert(\"Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με Μαθητή/Γονέα!\");\n}\n\n','highlightMainMenuImage(this);','downlightMainMenuImage(this);','select if(\n(\'#nu_user_group#\'=\'Parents\' AND (student.parent_email IS NOT NULL) AND (TRIM(student.parent_email)<>\'\')) OR \n(\'#nu_user_group#\'=\'Students\' AND (student.email IS NOT NULL) AND (TRIM(student.email)<>\'\')),\'1\',\'0\')\nfrom student \nINNER JOIN session_variables ON session_id = \'#session_id#\'\nWHERE \n    student.id = session_variables.student_id','2018-07-25 14:11:26','globeadmin','2018-07-25 19:24:38','globeadmin','2018-07-25 19:24:38','globeadmin'),('6207f24347deb8a',NULL,'Διεύθυνση','Επιβραβεύσεις που έχουν απονεμηθεί σε μαθητές',115,'cup.png','Επιβραβεύσεις Μαθητών','Επιβραβεύσεις που έχουν απονεμηθεί σε μαθητές','var t=get_session_variable(\'teacher_id\');\nif  (($.isNumeric(t)) && (t!=-1)) {\n    openFormFromMenu(\'6175a7faca903a3\', t, \'Καθηγητής\')\n} else{\n    alert(\'Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με καθηγητή!\');\n} ','highlightMainMenuImage(this);','downlightMainMenuImage(this);',NULL,'2022-02-12 19:45:39','globeadmin','2022-02-12 19:47:20','globeadmin','2022-02-12 19:55:04','globeadmin'),('6207f4d0569a8c2',NULL,'Καθηγητής','Επιβραβεύσεις που έχουν απονεμηθεί σε μαθητές',125,'cup.png','Επιβραβεύσεις Μαθητών','Επιβραβεύσεις που έχουν απονεμηθεί σε μαθητές','var t=get_session_variable(\'teacher_id\');\nif  (($.isNumeric(t)) && (t!=-1)) {\n    openFormFromMenu(\'6175a7faca903a3\', t, \'Καθηγητής\')\n} else{\n    alert(\'Προσοχή : Ο λογαριασμός αυτός δεν είναι συνδεδεμένος με καθηγητή!\');\n} ','highlightMainMenuImage(this);','downlightMainMenuImage(this);',NULL,'2022-02-12 19:56:32','globeadmin','2022-02-12 19:56:32','globeadmin','2022-02-12 19:59:23','globeadmin');
/*!40000 ALTER TABLE `zzzsys_menu_item` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `zzzsys_object`
--

DROP TABLE IF EXISTS `zzzsys_object`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `zzzsys_object` (
  `zzzsys_object_id` varchar(25) NOT NULL DEFAULT '',
  `sob_zzzsys_form_id` varchar(25) DEFAULT NULL,
  `sob_all_access_key` char(1) DEFAULT NULL,
  `sob_all_admin_only` char(1) DEFAULT NULL,
  `sob_all_clone` char(1) DEFAULT NULL,
  `sob_all_column_number` int(11) DEFAULT NULL,
  `sob_all_display_condition` text,
  `sob_all_name` varchar(200) DEFAULT NULL,
  `sob_all_order_number` int(11) DEFAULT NULL,
  `sob_all_tab_number` int(11) DEFAULT NULL,
  `sob_all_tab_title` varchar(200) DEFAULT NULL,
  `sob_all_title` varchar(200) DEFAULT NULL,
  `sob_all_type` varchar(200) DEFAULT NULL,
  `sob_all_top` int(11) DEFAULT NULL,
  `sob_all_left` int(11) DEFAULT NULL,
  `sob_all_width` int(11) NOT NULL,
  `sob_all_height` int(11) NOT NULL,
  `sob_all_align` varchar(1) NOT NULL,
  `sob_all_no_blanks` varchar(1) NOT NULL,
  `sob_all_read_only` varchar(1) NOT NULL,
  `sob_all_default_value_sql` mediumtext NOT NULL,
  `sob_all_no_duplicates` varchar(1) NOT NULL,
  `sob_button_admin_only` char(1) DEFAULT NULL,
  `sob_button_left` int(11) DEFAULT NULL,
  `sob_button_skip_browse_record_id` varchar(200) DEFAULT NULL,
  `sob_button_zzzsys_form_id` varchar(25) DEFAULT NULL,
  `sob_button_browse_filter` varchar(255) DEFAULT NULL,
  `sob_browse_filter` varchar(500) NOT NULL,
  `sob_browse_zzzsys_form_id` varchar(25) NOT NULL,
  `sob_display_sql` mediumtext,
  `sob_dropdown_sql` mediumtext,
  `sob_html_code` longtext,
  `sob_iframe_zzzsys_php_id` varchar(25) NOT NULL,
  `sob_iframe_zzzsys_report_id` varchar(25) NOT NULL,
  `sob_listbox_sql` mediumtext,
  `sob_lookup_code_field` varchar(100) DEFAULT NULL,
  `sob_lookup_default_value_sql` mediumtext,
  `sob_lookup_description_field` varchar(255) DEFAULT NULL,
  `sob_lookup_sql` mediumtext,
  `sob_lookup_zzzsys_form_id` varchar(25) DEFAULT NULL,
  `sob_lookup_id_field` varchar(50) DEFAULT NULL,
  `sob_lookup_javascript` mediumtext,
  `sob_lookup_php` mediumtext NOT NULL,
  `sob_lookup_autocomplete` char(1) DEFAULT NULL,
  `sob_subform_row_height` int(11) DEFAULT NULL,
  `sob_subform_deletable` char(1) DEFAULT NULL,
  `sob_subform_addable` varchar(1) NOT NULL,
  `sob_subform_foreign_key` varchar(50) DEFAULT NULL,
  `sob_subform_primary_key` varchar(50) DEFAULT NULL,
  `sob_subform_sql` mediumtext,
  `sob_subform_table` varchar(100) DEFAULT NULL,
  `sob_text_format` varchar(50) DEFAULT NULL,
  `sob_text_type` varchar(50) NOT NULL,
  `sob_text_password` char(1) DEFAULT NULL,
  `sob_subform_type` varchar(1) NOT NULL,
  `sob_lookup_code_width` int(11) NOT NULL,
  `sob_lookup_description_width` int(11) NOT NULL,
  `zzzsys_object_log_added_at` datetime NOT NULL,
  `zzzsys_object_log_added_by` varchar(25) NOT NULL,
  `zzzsys_object_log_changed_at` datetime NOT NULL,
  `zzzsys_object_log_changed_by` varchar(25) NOT NULL,
  `zzzsys_object_log_viewed_at` datetime NOT NULL,
  `zzzsys_object_log_viewed_by` varchar(25) NOT NULL,
  PRIMARY KEY (`zzzsys_object_id`),
  KEY `sob_all_order_number` (`sob_all_order_number`),
  KEY `sob_all_tab_number` (`sob_all_tab_number`),
  KEY `sob_all_tab_title` (`sob_all_tab_title`),
  KEY `sob_zzzsys_form_id` (`sob_zzzsys_form_id`),
  KEY `sob_all_column_number` (`sob_all_column_number`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `zzzsys_object`
--

LOCK TABLES `zzzsys_object` WRITE;
/*!40000 ALTER TABLE `zzzsys_object` DISABLE KEYS */;
INSERT INTO `zzzsys_object` VALUES ('53aa24cc4c00e25','53a914a2d4f6e8c',NULL,NULL,'1',10,NULL,'align',290,10,'Details',NULL,'dropdown',108,619,60,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'l|left|r|right|c|center',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-06-25 11:24:28','globeadmin','2014-06-26 16:48:22','globeadmin','2014-10-01 10:02:21','globeadmin'),('52f2c18304ece6c','nuformwizard',NULL,NULL,'1',10,'','fw_form_lookup',10,10,'Details','Form To Lookup','lookup',401,865,400,0,'l','0','0','','0',NULL,NULL,'','','','','','','','','','','','sfo_name',NULL,'sfo_title',NULL,'nuform','zzzsys_form_id','$(\'#fw_form_listbox option:selected\').each(function() {\n    $(this).attr(\'nu_lookup\', $(\'#fw_form_lookup\').val());\n});\n\nvar sql = String($(\'#fw_hidden_form_sql\').val());\nvar table = $(\'#fw_hidden_table\').val();\nvar sql_arr = sql.toLowerCase().split(\" \");\n\nvar indices = new Array();\nvar tables  = new Array();\ntables.push(table.toLowerCase());\nvar idx = sql_arr.indexOf(\"join\");\nwhile( idx != -1 ) {\n    tables.push(sql_arr[idx+1]);\n    idx = sql_arr.indexOf(\"join\", idx+1);\n}\n\n\n$(\"select[id$=\'field\']\").empty();\n$(\"select[id$=\'field\']\").append(\'<option value=\"\"></option>\');\nfor( var idx = 0; idx < columns.length; idx++ ) {\n    if( tables.indexOf(columns[idx][0].toLowerCase()) != -1 && columns[idx][2] != \"PRI\" ) {\n        $(\'#fw_description_field\').append(\'<option value=\"\'+columns[idx][1]+\'\">\'+columns[idx][1]+\'</option>\');\n        $(\'#fw_code_field\').append(\'<option value=\"\'+columns[idx][1]+\'\">\'+columns[idx][1]+\'</option>\');\n    }\n}\n\n$(\'#fw_code_field\').find(\"option[value=\'\"+$(\'#fw_form_listbox option:selected\').attr(\'nu_lookup_code\')+\"\']\").attr(\"selected\",true);\n$(\'#fw_description_field\').find(\"option[value=\'\"+$(\'#fw_form_listbox option:selected\').attr(\'nu_lookup_description\')+\"\']\").attr(\"selected\",true);','','1',0,'','','','','','','','',NULL,'',100,150,'2014-02-06 09:56:03','globeadmin','2014-02-12 14:55:36','globeadmin','2014-02-12 14:55:36','globeadmin'),('52f3106d3ff3bdd','nusubformwizard',NULL,NULL,'1',10,'SELECT \'0\'','sfw_hidden_form_sql',1064,10,'Details','','text',0,0,60,0,'l','0','0','','0',NULL,NULL,'',NULL,'','','','','','','','','','',NULL,'',NULL,NULL,'','','','',0,'','','','','','','','',NULL,'',0,0,'2014-02-06 15:32:45','globeadmin','2014-02-12 14:06:24','globeadmin','2014-02-12 14:06:24','globeadmin'),('54c6c928bd669f9','nuphp',NULL,NULL,'1',10,NULL,'slp_list',60,10,'Details','Show in List','dropdown',0,0,60,30,'l','1','0','SELECT \'1\';','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'1|Yes|0|No',NULL,'','',NULL,'sfo_name',NULL,'sfo_title',NULL,'nuform','zzzsys_form_id',NULL,'',NULL,0,'1','1',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-01-27 09:39:28','globeadmin','2015-01-27 09:39:28','globeadmin','2015-01-27 09:39:45','globeadmin'),('54ffad928488d6e','54ffacae7d8599d',NULL,NULL,'1',20,NULL,'fast_form_object_properties',20,10,'Fast Form',NULL,'button',0,0,17,17,'l','1','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-11 13:20:58','globeadmin','2015-03-23 11:57:47','globeadmin','2015-03-27 16:35:32','globeadmin'),('53aa24e8509d3fc','53a914a2d4f6e8c',NULL,NULL,'1',10,NULL,'colname',300,10,'Details',NULL,'text',108,236,150,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-06-25 11:24:56','globeadmin','2014-06-25 14:30:22','globeadmin','2014-10-01 10:02:21','globeadmin'),('53a7c432f396097','53a914a2d4f6e8c',NULL,NULL,'1',10,NULL,'width',280,10,'Details',NULL,'text',108,450,150,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-06-23 15:37:47','globeadmin','2014-06-25 14:30:44','globeadmin','2014-10-01 10:02:21','globeadmin'),('53a7bec56762931','53a914a2d4f6e8c',NULL,NULL,'1',10,'SELECT 0','orderList',270,10,'Details',NULL,'text',20,234,200,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-06-23 15:14:37','globeadmin','2014-06-23 15:22:48','globeadmin','2014-10-01 10:02:21','globeadmin'),('53a7d53cab1e447','53a914a2d4f6e8c',NULL,NULL,'1',10,'SELECT 0','selectedValueList',260,10,'Details',NULL,'text',20,234,200,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-06-23 16:50:28','globeadmin','2014-06-23 16:50:29','globeadmin','2014-12-13 15:10:23','globeadmin'),('53a7bc81843cd9f','53a914a2d4f6e8c',NULL,NULL,'1',10,NULL,'moveOrderDown',240,10,'Details','ÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â¢ÃƒÆ’Ã†â€™Ãƒâ€šÃ‚Â¢ÃƒÆ’Ã‚Â¢ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡Ãƒâ€šÃ‚Â¬ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â ÃƒÆ’Ã†â€™Ãƒâ€šÃ‚Â¢ÃƒÆ’Ã‚Â¢ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡Ãƒâ€šÃ‚Â¬ÃƒÆ’Ã¢â‚¬Â¦ÃƒÂ¢Ã¢â€šÂ¬Ã…â€œ','button',392,530,30,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','','SELECT sac_column AS \'ID\', sac_column AS \'Name\' FROM zzzsys_adhoc_column WHERE sac_zzzsys_adhoc_id = \'#RECORD_ID#\' ORDER BY sac_order',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-06-23 15:04:57','globeadmin','2014-06-23 15:04:57','globeadmin','2014-10-01 10:02:21','globeadmin'),('53a7bbfcdde1d38','53a914a2d4f6e8c',NULL,NULL,'1',10,NULL,'order',200,10,'Details',NULL,'listbox',180,450,150,200,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','','SELECT \'x\', \'y\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-06-23 15:02:45','globeadmin','2014-06-25 14:08:23','globeadmin','2014-10-01 10:02:21','globeadmin'),('53a7bc5531e3033','53a914a2d4f6e8c',NULL,NULL,'1',10,NULL,'removeOrder',220,10,'Details','ÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â¢ÃƒÆ’Ã†â€™Ãƒâ€šÃ‚Â¢ÃƒÆ’Ã‚Â¢ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡Ãƒâ€šÃ‚Â¬ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â','button',260,398,30,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','','SELECT sac_column AS \'ID\', sac_column AS \'Name\' FROM zzzsys_adhoc_column WHERE sac_zzzsys_adhoc_id = \'#RECORD_ID#\' ORDER BY sac_order',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-06-23 15:04:13','globeadmin','2014-06-23 15:04:13','globeadmin','2014-10-01 10:02:21','globeadmin'),('53a7bc6ad1e7c9a','53a914a2d4f6e8c',NULL,NULL,'1',10,NULL,'moveOrderUp',230,10,'Details','ÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â¢ÃƒÆ’Ã†â€™Ãƒâ€šÃ‚Â¢ÃƒÆ’Ã‚Â¢ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡Ãƒâ€šÃ‚Â¬ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â ÃƒÆ’Ã†â€™Ãƒâ€šÃ‚Â¢ÃƒÆ’Ã‚Â¢ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡Ãƒâ€šÃ‚Â¬ÃƒÆ’Ã¢â‚¬Â¹Ãƒâ€¦Ã¢â‚¬Å“','button',392,489,30,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','','SELECT sac_column AS \'ID\', sac_column AS \'Name\' FROM zzzsys_adhoc_column WHERE sac_zzzsys_adhoc_id = \'#RECORD_ID#\' ORDER BY sac_order',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-06-23 15:04:35','globeadmin','2014-06-23 15:04:35','globeadmin','2014-10-01 10:02:21','globeadmin'),('53a7bc41a990aa4','53a914a2d4f6e8c',NULL,NULL,'1',10,NULL,'addOrder',210,10,'Details','ÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â¢ÃƒÆ’Ã†â€™Ãƒâ€šÃ‚Â¢ÃƒÆ’Ã‚Â¢ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡Ãƒâ€šÃ‚Â¬ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â ÃƒÆ’Ã†â€™Ãƒâ€šÃ‚Â¢ÃƒÆ’Ã‚Â¢ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡Ãƒâ€šÃ‚Â¬ÃƒÆ’Ã‚Â¢ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¾Ãƒâ€šÃ‚Â¢','button',223,398,30,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','','SELECT sac_column AS \'ID\', sac_column AS \'Name\' FROM zzzsys_adhoc_column WHERE sac_zzzsys_adhoc_id = \'#RECORD_ID#\' ORDER BY sac_order',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-06-23 15:03:54','globeadmin','2014-06-23 15:03:54','globeadmin','2014-10-01 10:02:21','globeadmin'),('53a7ba7b8b7ab4b','53a914a2d4f6e8c',NULL,NULL,'1',10,NULL,'sad_where_clause',190,10,'Details',NULL,'textarea',180,619,230,200,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-06-23 14:56:19','globeadmin','2014-06-25 14:32:13','globeadmin','2014-10-01 10:02:21','globeadmin'),('53a7a8295d51080','53a914a2d4f6e8c',NULL,NULL,'1',10,'SELECT 0','selectedList',250,10,'Details',NULL,'text',25,580,200,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-06-23 13:38:09','globeadmin','2014-06-23 15:14:27','globeadmin','2014-10-01 10:02:21','globeadmin'),('53a2774db3d7432','53a914a2d4f6e8c',NULL,NULL,'1',10,NULL,'moveFieldDown',180,10,'Details','ÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â¢ÃƒÆ’Ã†â€™Ãƒâ€šÃ‚Â¢ÃƒÆ’Ã‚Â¢ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡Ãƒâ€šÃ‚Â¬ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â ÃƒÆ’Ã†â€™Ãƒâ€šÃ‚Â¢ÃƒÆ’Ã‚Â¢ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡Ãƒâ€šÃ‚Â¬ÃƒÆ’Ã¢â‚¬Â¦ÃƒÂ¢Ã¢â€šÂ¬Ã…â€œ','button',392,318,30,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','','SELECT sac_column AS \'ID\', sac_column AS \'Name\' FROM zzzsys_adhoc_column WHERE sac_zzzsys_adhoc_id = \'#RECORD_ID#\' ORDER BY sac_order',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-06-19 15:08:21','globeadmin','2014-06-23 15:05:50','globeadmin','2014-10-01 10:02:21','globeadmin'),('53a2773b9894b78','53a914a2d4f6e8c',NULL,NULL,'1',10,NULL,'moveFieldUp',170,10,'Details','ÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â¢ÃƒÆ’Ã†â€™Ãƒâ€šÃ‚Â¢ÃƒÆ’Ã‚Â¢ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡Ãƒâ€šÃ‚Â¬ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â ÃƒÆ’Ã†â€™Ãƒâ€šÃ‚Â¢ÃƒÆ’Ã‚Â¢ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡Ãƒâ€šÃ‚Â¬ÃƒÆ’Ã¢â‚¬Â¹Ãƒâ€¦Ã¢â‚¬Å“','button',392,277,30,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','','SELECT sac_column AS \'ID\', sac_column AS \'Name\' FROM zzzsys_adhoc_column WHERE sac_zzzsys_adhoc_id = \'#RECORD_ID#\' ORDER BY sac_order',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-06-19 15:08:03','globeadmin','2014-06-23 15:05:50','globeadmin','2014-10-01 10:02:21','globeadmin'),('53a2744c77066f3','53a914a2d4f6e8c',NULL,NULL,'1',10,NULL,'removeFields',160,10,'Details','ÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â¢ÃƒÆ’Ã†â€™Ãƒâ€šÃ‚Â¢ÃƒÆ’Ã‚Â¢ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡Ãƒâ€šÃ‚Â¬ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â','button',260,185,30,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','','SELECT sac_column AS \'ID\', sac_column AS \'Name\' FROM zzzsys_adhoc_column WHERE sac_zzzsys_adhoc_id = \'#RECORD_ID#\' ORDER BY sac_order',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-06-19 14:55:32','globeadmin','2014-06-19 14:55:32','globeadmin','2014-10-01 10:02:21','globeadmin'),('53a2710dcff862d','53a914a2d4f6e8c',NULL,NULL,'1',10,NULL,'selected',140,10,'Details',NULL,'listbox',180,236,150,200,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','','SELECT \'x\', \'y\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-06-19 14:41:41','globeadmin','2014-06-25 14:08:23','globeadmin','2014-10-01 10:02:21','globeadmin'),('53a273b6a287e45','53a914a2d4f6e8c',NULL,NULL,'1',10,NULL,'addFields',150,10,'Details','ÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â¢ÃƒÆ’Ã†â€™Ãƒâ€šÃ‚Â¢ÃƒÆ’Ã‚Â¢ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡Ãƒâ€šÃ‚Â¬ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â ÃƒÆ’Ã†â€™Ãƒâ€šÃ‚Â¢ÃƒÆ’Ã‚Â¢ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡Ãƒâ€šÃ‚Â¬ÃƒÆ’Ã‚Â¢ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¾Ãƒâ€šÃ‚Â¢','button',223,185,30,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','','SELECT sac_column AS \'ID\', sac_column AS \'Name\' FROM zzzsys_adhoc_column WHERE sac_zzzsys_adhoc_id = \'#RECORD_ID#\' ORDER BY sac_order',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-06-19 14:53:02','globeadmin','2014-06-19 14:53:21','globeadmin','2014-10-01 10:02:21','globeadmin'),('53a261c9d8f8f50','53a914a2d4f6e8c',NULL,NULL,'1',10,NULL,'sad_table',120,10,'Details',NULL,'dropdown',108,19,150,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'SELECT \n	TABLE_NAME AS \'ID\',\n	TABLE_NAME AS \'Name\'\nFROM INFORMATION_SCHEMA.TABLES\nWHERE \n	TABLE_SCHEMA = \'mcnaughts\'',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-06-19 13:36:33','globeadmin','2014-06-25 14:08:23','globeadmin','2014-10-01 10:02:21','globeadmin'),('1457375b63c9bb','nuobject','','0','1',10,'','sob_button_browse_filter',110,20,'Button','Default Filter for Browse','text',0,0,200,0,'l','0','0','','0','',0,'','','','','','','','','','','','','','','','','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-02-05 10:31:01','globeadmin'),('53a268536ce48be','53a914a2d4f6e8c',NULL,NULL,'1',10,NULL,'columns',130,10,'Details',NULL,'listbox',180,19,150,200,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','','SELECT \'\'',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-06-19 14:04:27','globeadmin','2014-06-25 14:08:23','globeadmin','2014-10-01 10:02:21','globeadmin'),('5502101935e586d','54ffacae7d8599d',NULL,NULL,'1',10,'SELECT \'0\'','sob_all_type',100,10,'Fast Form','Type','text',0,0,0,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-13 08:45:53','globeadmin','2015-03-24 09:53:52','globeadmin','2015-03-27 16:35:32','globeadmin'),('51636fd0b0bc8a4','51636e4728362e8',NULL,'','1',10,'','sob_all_column_number',80,20,'Subform','Col','text',0,0,50,0,'r','0','0','','0',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',0,'1','1','','','','','0','',NULL,'',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('5269b7d216b8fdd','nuimage',NULL,NULL,'1',20,'SELECT 0','sfi_filepicker',80,10,'Main','','text',0,0,220,30,'l','0','0','','0',NULL,NULL,'','','','','','','','\n','','','','',NULL,'',NULL,'','','','','',0,'1','1','','','','','','',NULL,'',0,0,'2013-10-25 10:44:10','globeadmin','2013-10-25 13:42:08','globeadmin','2014-01-17 13:36:19','globeadmin'),('52e86699bf261e8','nuformwizard',NULL,NULL,'1',10,'','fw_browse_title',10,10,'Details','Title','text',348,525,275,0,'l','0','0','','0',NULL,NULL,'',NULL,'','','','','','','','','','',NULL,'',NULL,NULL,'','','','',0,'','','','','','','','',NULL,'',0,0,'2014-01-29 13:25:29','globeadmin','2014-02-06 09:49:45','globeadmin','2014-02-11 12:49:00','globeadmin'),('541b70ff0dca26c','nusetup',NULL,NULL,'1',10,NULL,'sample5',140,20,'Email Settings','<i>your_name</i>@gmail.com','words',108,652,200,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'1|Yes|0|No',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,0,'1','1',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-09-19 09:25:43','globeadmin','2014-09-19 09:25:43','globeadmin','2014-09-19 09:25:50','globeadmin'),('1455245046c00d','1455245046c010','','0','1',10,'','sbr_sort',25,10,'Select Fields','Sort','text',0,0,100,0,'l','1','0','','0','',0,'','','','','','','','','','','','','','','','','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2013-10-10 10:42:52','globeadmin'),('15023052d34bc7','nutranslate','','0','1',10,'','trl_translation',30,10,'Details','Translation','text',0,0,200,0,'l','0','0','','0',NULL,0,'','','','','','','','','','','','','','',NULL,'','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('51b7cfe62d9d754','51b7cf41d9f2c57',NULL,NULL,'1',10,'','slp_zzzsys_php_id',10,10,'Main','Procedures Allowed Access','lookup',0,0,250,0,'l','1','0','','0',NULL,NULL,'','','','','','','','','','','','slp_code',NULL,'slp_description',NULL,'nuphp','zzzsys_php_id','','','1',0,'1','1','','','','','','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-04-29 13:18:17','globeadmin','2015-04-29 13:18:17','globeadmin'),('51b7cf41d9f2c57','nulevel',NULL,NULL,'1',10,'','phpAccess',10,60,'Procedures',' ','subform',30,230,450,380,'l','0','0','','0',NULL,NULL,'','','','','','','','','','','','sre_code',NULL,'sre_description',NULL,'nureport','zzzsys_report_id','','','',22,'1','1','slp_zzzsys_access_level_id','zzzsys_access_level_php_id','SELECT * \nFROM zzzsys_access_level_php \nINNER JOIN zzzsys_php ON zzzsys_php_id = slp_zzzsys_php_id\nWHERE slp_zzzsys_access_level_id = \'#RECORD_ID#\' \nORDER BY slp_code','zzzsys_access_level_php','','',NULL,'g',100,250,'0000-00-00 00:00:00','','2013-10-21 09:45:45','globeadmin','2015-04-14 11:40:59','globeadmin'),('53a2612fce4c57a','53a914a2d4f6e8c',NULL,NULL,'1',10,NULL,'sad_name',10,10,'Details',NULL,'text',46,19,370,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-06-19 13:33:59','globeadmin','2014-06-25 14:31:27','globeadmin','2014-10-01 10:02:21','globeadmin'),('1455245046ba92','nuobject','','0','1',10,'','sob_lookup_code_field',20,100,'Lookup','Code Field','text',0,0,200,0,'l','0','0','','0','',0,'','','','','','','','','','','','','','','','','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-02-05 10:31:02','globeadmin'),('1455245046ba9f','nuobject','','0','1',10,'','sob_lookup_description_field',30,100,'Lookup','Description Field','text',0,0,200,0,'l','0','0','','0','',0,'','','','','','','','','','','','','','','','','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-02-05 10:31:02','globeadmin'),('54ffa26abfc2fce','nufastform',NULL,NULL,'1',10,NULL,'fast_form_html',60,10,'Fast Form',NULL,'html',18,458,520,400,'l','1','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<div id=\'ff_talk\'      style=\'position:absolute;left:10px;width:220px;height:40px;top:60px;text-align:center;text-weight:bold;font-style:italic;\'>\"Add an Object to this Form\"</div>\n<img id=\'talkingmike\'  style=\'position:absolute;left:40px;top:100px\' src=\'mike.png\' width=\'128\' height=\'266\'>\n<div id=\'ff_objects\'   style=\'position:absolute;left:230px;width:300px;height:400px\'>\n<br>\n&nbsp;<input id=\'ffo01\' data-type=\'TEXT\' value=\'Text\' class=\'nuButton\' onclick= \'nuAddFFObject(this)\' style=\'width:140px;height:30px;\'>\n&nbsp;<input id=\'ffo02\' data-type=\'TEXT\' value=\'Date\' class=\'nuButton\' onclick= \'nuAddFFObject(this)\' style=\'width:140px;height:30px;\'>\n<br><br>\n&nbsp;<input id=\'ffo03\' data-type=\'TEXT\' value=\'Number\' class=\'nuButton\' onclick= \'nuAddFFObject(this)\' style=\'width:140px;height:30px;\'>\n&nbsp;<input id=\'ffo07\' data-type=\'TEXTAREA\' value=\'Text Area\' class=\'nuButton\' onclick= \'nuAddFFObject(this)\' style=\'width:140px;height:30px;\'>\n<br><br>\n&nbsp;<input id=\'ffo06\' data-type=\'CHECKBOX\' value=\'Checkbox\' class=\'nuButton\' onclick= \'nuAddFFObject(this)\' style=\'width:140px;height:30px;\'>\n&nbsp;<input id=\'ffo08\' data-type=\'DROPDOWN\' value=\'Drop Down\' class=\'nuButton\' onclick= \'nuAddFFObject(this)\' style=\'width:140px;height:30px;\'>\n<br><br>\n&nbsp;<input id=\'ffo09\' data-type=\'LISTBOX\' value=\'Listbox\' class=\'nuButton\' onclick= \'nuAddFFObject(this)\' style=\'width:140px;height:30px;\'>\n&nbsp;<input id=\'ffo10\' data-type=\'WORD\' value=\'Word\' class=\'nuButton\' onclick= \'nuAddFFObject(this)\' style=\'width:140px;height:30px;\'>\n<br><br>\n&nbsp;<input id=\'ffo04\' data-type=\'TEXT\' value=\'Auto Number\' class=\'nuButton\' onclick= \'nuAddFFObject(this)\' style=\'width:140px;height:30px;\'>\n&nbsp;<input id=\'ffo12\' data-type=\'HTML\' value=\'HTML\' class=\'nuButton\' onclick= \'nuAddFFObject(this)\' style=\'width:140px;height:30px;\'>\n<br><br>\n&nbsp;<input id=\'ffo11\' data-type=\'DISPLAY\' value=\'Display\' class=\'nuButton\' onclick= \'nuAddFFObject(this)\' style=\'width:140px;height:30px;\'>\n&nbsp;<input id=\'ffo14\' data-type=\'TEXT\' value=\'Hidden Field\' class=\'nuButton\' onclick= \'nuAddFFObject(this)\' style=\'width:140px;height:30px;\'>\n<br><br>\n&nbsp;<input id=\'ffo15\' data-type=\'BUTTON\' value=\'Javascript Button\' class=\'nuButton\' onclick= \'nuAddFFObject(this)\' style=\'width:140px;height:30px;\'>\n&nbsp;<input id=\'ffo16\' data-type=\'BUTTON\' value=\'Open Form Button\' class=\'nuButton\' onclick= \'nuAddFFObject(this)\' style=\'width:140px;height:30px;\'>\n<br><br>\n&nbsp;<input id=\'ffo05\' data-type=\'TEXT\' value=\'Password\' class=\'nuButton\' onclick= \'nuAddFFObject(this)\' style=\'width:140px;height:30px;\'>\n<br><br>\n\n</div>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-11 12:33:22','globeadmin','2015-04-13 12:22:14','globeadmin','2015-04-15 12:04:02','globeadmin'),('52f30d863684946','nusubformwizard',NULL,NULL,'1',10,'','sfw_form_lookup',10,10,'Details','Form to Lookup','lookup',396,473,300,0,'l','0','0','','0',NULL,NULL,'',NULL,'','','','','','','','','','sfo_name',NULL,'sfo_title',NULL,'nuform','zzzsys_form_id','$(\'#sfw_form_listbox option:selected\').each(function() {\n    $(this).attr(\'nu_lookup\', $(\'#sfw_form_lookup\').val());\n});\n\nvar sql = String($(\'#sfw_hidden_form_sql\').val());\nvar table = $(\'#sfw_hidden_table\').val();\nvar sql_arr = sql.toLowerCase().split(\" \");\n\nvar indices = new Array();\nvar tables  = new Array();\ntables.push(table.toLowerCase());\n\nvar idx = sql_arr.indexOf(\"join\");\nwhile( idx != -1 ) {\n    tables.push(sql_arr[idx+1]);\n    idx = sql_arr.indexOf(\"join\", idx+1);\n}\n\n\n$(\"select[id$=\'field\']\").empty();\n$(\"select[id$=\'field\']\").append(\'<option value=\"\"></option>\');\nfor( var idx = 0; idx < columns.length; idx++ ) {\n    if( tables.indexOf(columns[idx][0].toLowerCase()) != -1 && columns[idx][2] != \"PRI\" ) {\n        $(\'#sfw_description_field\').append(\'<option value=\"\'+columns[idx][1]+\'\">\'+columns[idx][1]+\'</option>\');\n        $(\'#sfw_code_field\').append(\'<option value=\"\'+columns[idx][1]+\'\">\'+columns[idx][1]+\'</option>\');\n    }\n}\n\n$(\'#sfw_code_field\').find(\"option[value=\'\"+$(\'#sfw_form_listbox option:selected\').attr(\'nu_lookup_code\')+\"\']\").attr(\"selected\",true);\n$(\'#sfw_description_field\').find(\"option[value=\'\"+$(\'#sfw_form_listbox option:selected\').attr(\'nu_lookup_description\')+\"\']\").attr(\"selected\",true);','','1',0,'','','','','','','','',NULL,'',100,150,'2014-02-06 15:20:22','globeadmin','2014-02-12 14:57:29','globeadmin','2014-02-12 14:57:29','globeadmin'),('52eb2bb50ee12a7','nusubformwizard',NULL,NULL,'1',20,'','sfw_form_listbox',40,10,'Details','Form Fields','listbox',92,496,275,250,'l','1','0','','0',NULL,NULL,'','','','','','','','','','','SELECT 1','',NULL,'',NULL,'','','','','',0,'','','','','','','','',NULL,'',0,0,'2014-01-31 15:51:01','globeadmin','2014-02-03 13:05:53','globeadmin','2014-02-11 13:01:55','globeadmin'),('1455245046ba58','nuobject','','0','1',10,'','sob_all_no_duplicates',170,10,'All','Stop Duplicates','dropdown',0,0,70,100,'l','1','0','SELECT 0','0',NULL,NULL,'','','','','','','1|Yes|0|No','','','','','','','',NULL,'','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-02-05 10:31:00','globeadmin'),('1455245046bfb8','nuobject','','0','1',20,'','sob_subform_table',200,120,'Subform','Table Name','text',0,0,200,0,'l','0','0','','0',NULL,0,'','','','','','','','','','','','','','',NULL,'','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-02-05 10:31:03','globeadmin'),('1456ca1f6158bc','nuobject','','0','1',10,'','sob_zzzsys_form_id',10,10,'All','Displayed On','lookup',0,0,300,100,'l','1','0','','0','',0,'','','','','','','SELECT * FROM #TABLE_ID# order by thename','','','','','thecode','','thedesc','','nuformsandsubforms','theid','','','',0,'1','1','','','','','','','','',75,250,'0000-00-00 00:00:00','','2014-02-01 12:43:59','globeadmin','2014-02-05 10:30:58','globeadmin'),('52eec8197ff4686','nusubformwizard',NULL,NULL,'1',20,'','sfw_foreign_key',20,10,'Details','Foreign Key','dropdown',43,495,275,0,'l','1','0','','0',NULL,NULL,'','','','','','','\'\'','','','','','',NULL,'',NULL,'','','','','',0,'','','','','','','','',NULL,'',0,0,'2014-02-03 09:35:05','globeadmin','2014-02-03 09:35:43','globeadmin','2014-02-11 13:01:55','globeadmin'),('5518979176fd7ad','nufastform',NULL,NULL,'1',10,NULL,'fast_form_form_view',40,10,'Fast Form','E','button',23,37,17,17,'l','1','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-30 10:53:45','globeadmin','2015-04-15 12:04:13','globeadmin','2015-04-15 12:04:13','globeadmin'),('145934e14a98e5','nugroup','','0','1',10,'','sug_description',20,10,'Main','Description','text',0,0,250,0,'l','0','0','','0','',0,'','','','','','','','','','','','','','','','','','','','',0,'1','1','','','','','','','','',80,240,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2013-10-22 14:59:13','globeadmin'),('145773a2a6e1b9','nuform','','0','1',10,'','sfo_save_button',30,20,'Action Buttons','Save Button','dropdown',0,0,70,100,'l','0','0','','0','',0,'','','','','','','1|Yes|0|No','','','','','','','','','','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2015-04-14 11:42:51','globeadmin'),('145737841574fa','nuindex','','1','1',10,'','ObjectsButton',100,500,'Setup','Objects','button',107,487,120,30,'l','0','0','','0','1',0,'','nuobject','','','','','','','','','','','','','','','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-07-15 13:37:04','globeadmin'),('52faef8591d2a5b','nuformwizard',NULL,NULL,'1',10,'SELECT \'0\'','fw_hidden_table',41202,10,'Details',NULL,'text',0,0,60,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-02-12 14:50:29','globeadmin','2014-02-12 14:50:29','globeadmin','2014-02-12 14:50:31','globeadmin'),('52eb2bc0e407dcc','nusubformwizard',NULL,NULL,'1',10,'','sfw_form_title',10,10,'Details','Title','text',347,540,275,0,'l','0','0','','0',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',0,'','','','','','','','',NULL,'',0,0,'2014-01-31 15:51:13','globeadmin','2014-01-31 15:58:36','globeadmin','2014-02-11 13:01:54','globeadmin'),('14575d3a98d24e','nuform','','0','1',10,'','sfo_title',20,10,'General','Description','text',0,0,250,0,'l','0','0','','0','',0,'','','','','','','','','','','','','','','','','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2015-04-14 11:42:50','globeadmin'),('1457742314bc68','1455245046c010','','0','1',10,'','sbr_format',35,10,'Select Fields','Format','dropdown',0,0,100,100,'l','0','0','','0','',0,NULL,'',NULL,'','','','0|10000|1|10000.0|2|10000.00|3|10000.000|4|10000.0000|5|10000.00000|6|13-Jan-2007|7|13-01-2007|8|Jan-13-2007|9|01-13-2007|10|13-Jan-07|11|13-01-07|12|Jan-13-07|13|01-13-07|14|10,000|15|10,000.0|16|10,000.00|17|10,000.000|18|10,000.0000|19|10,000.00000|20|10000|21|10000,0|22|10000,00|23|10000,000|24|10000,0000|25|10000,00000|26|10.000|27|10.000,0|28|10.000,00|29|10.000,000','','','','','','','','','',NULL,'','',NULL,0,'1','1','','','','','','',NULL,'b',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2013-10-10 10:42:53','globeadmin'),('54ffacf3491b363','54ffacae7d8599d',NULL,NULL,'1',10,NULL,'sob_all_title',10,10,'Fast Form','Title','text',0,0,200,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-11 13:18:19','globeadmin','2015-03-23 09:44:06','globeadmin','2015-03-27 16:35:32','globeadmin'),('14593559f334ca','nuindex','','0','1',10,'','homeform',20,500,'Setup','User Home','button',257,65,120,30,'l','0','0','','0','',0,'-1','nuhome','','','','','','','','','','','','','','','','','',NULL,0,'1','1','','','','','','',NULL,'',0,0,'0000-00-00 00:00:00','','2014-02-10 14:12:10','globeadmin','2014-07-15 13:33:56','globeadmin'),('1455245046ba3y','nuobject','','0','1',10,'','sob_all_height',120,10,'All','Height Pixels','text',0,0,60,0,'r','0','0','','0',NULL,NULL,'','','','','','','',NULL,'','','','','','',NULL,'','','','','',NULL,'1','1',NULL,NULL,NULL,NULL,'0','',NULL,'b',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-02-05 10:31:00','globeadmin'),('145773ab7798d4','nuform','','0','1',10,'','sfo_delete_button_display_condition',60,20,'Action Buttons','Display Condition','textarea',0,0,300,70,'l','0','0','','0','',0,'','','','','','','','','','','','','','','','','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2015-04-14 11:42:51','globeadmin'),('1455245046bad0','nuobject','','0','1',20,'','sob_subform_deletable',730,120,'Subform','Deleteable','dropdown',0,0,70,100,'l','0','0','','0',NULL,0,'','','','','','','1|Yes|0|No','','','','','','','',NULL,'','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-02-05 10:31:04','globeadmin'),('1455245046ba95','nuobject','','0','1',10,'','sob_lookup_code_width',470,100,'Lookup','Code Width','text',0,0,50,0,'r','0','0','','0',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',0,'1','1','','','','','0','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-02-05 10:31:02','globeadmin'),('SMTPAUTH100002','nusetup','','0','1',10,'','set_smtp_username',20,20,'Email Settings','Auth SMTP username','text',0,0,200,0,'l','0','0','','0',NULL,0,'','','','','','','1|Yes|0|No','','','','','','','',NULL,'','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2013-11-18 16:30:47','globeadmin'),('1455245046c003','1455245046c010','','0','1',10,'','sbr_title',10,10,'Browse Fields','Title','text',0,0,100,0,'l','0','0','','0','',0,NULL,'',NULL,'','','','','','','','','','','','','',NULL,'','',NULL,0,'1','1','','','','','','',NULL,'b',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2013-10-10 10:42:52','globeadmin'),('52f2f869865117b','nuformwizard',NULL,NULL,'1',10,'','fw_code_field',10,10,'Details','','dropdown',425,959,105,0,'l','0','0','','0',NULL,NULL,'',NULL,'','','','','SELECT \' \',\' \'','','','','','',NULL,'',NULL,NULL,'','','','',0,'','','','','','','','',NULL,'',0,0,'2014-02-06 13:50:17','globeadmin','2014-02-06 13:51:15','globeadmin','2014-02-11 12:49:00','globeadmin'),('52f2fa7814d0a53','nuformwizard',NULL,NULL,'1',10,'SELECT \'0\'','fw_hidden_form_sql',1063,10,'Details','','text',0,0,60,0,'l','0','0','','0',NULL,NULL,'',NULL,'','','','','','','','','','',NULL,'',NULL,NULL,'','','','',0,'','','','','','','','',NULL,'',0,0,'2014-02-06 13:59:04','globeadmin','2014-02-12 14:05:24','globeadmin','2014-02-12 14:05:24','globeadmin'),('52eb2afb7363ada','nusubformwizard',NULL,NULL,'1',10,'','sfw_table_select_all',30,10,'Details','Select All','button',66,160,275,20,'l','1','0','','0',NULL,NULL,'','','','','','','SELECT TABLE_NAME, TABLE_NAME\nFROM INFORMATION_SCHEMA.TABLES\nWHERE TABLE_NAME NOT LIKE \'zzzsys_%\'\nAND TABLE_SCHEMA = database()\n','','','','','',NULL,'',NULL,'','','','','',0,'','','','','','','','',NULL,'',0,0,'2014-01-31 15:47:55','globeadmin','2014-01-31 15:55:28','globeadmin','2014-02-11 13:01:55','globeadmin'),('52e6e33fbb3f431','nuformwizard',NULL,NULL,'1',10,'','fw_brwse_dwn',10,10,'Details','ÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â¢ÃƒÆ’Ã†â€™Ãƒâ€šÃ‚Â¢ÃƒÆ’Ã‚Â¢ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡Ãƒâ€šÃ‚Â¬ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚ÂÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã‚Â¦ÃƒÆ’Ã‚Â¢ÃƒÂ¢Ã¢â‚¬Å¡Ã‚Â¬Ãƒâ€¦Ã¢â‚¬Å“ÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â','button',209,485,50,50,'l','0','0','','0',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',0,'','','','','','','','',NULL,'',0,0,'2014-01-28 09:52:47','globeadmin','2014-02-11 10:21:49','globeadmin','2014-02-11 12:49:00','globeadmin'),('52e6e44874b1aa3','nuformwizard',NULL,NULL,'1',10,'','fw_field_down',10,10,'Details','ÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â¢ÃƒÆ’Ã†â€™Ãƒâ€šÃ‚Â¢ÃƒÆ’Ã‚Â¢ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡Ãƒâ€šÃ‚Â¬ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚ÂÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã‚Â¦ÃƒÆ’Ã‚Â¢ÃƒÂ¢Ã¢â‚¬Å¡Ã‚Â¬Ãƒâ€¦Ã¢â‚¬Å“ÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â','button',209,898,50,50,'l','0','0','','0',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',0,'','','','','','','','',NULL,'',0,0,'2014-01-28 09:57:12','globeadmin','2014-02-11 10:21:57','globeadmin','2014-02-11 12:49:00','globeadmin'),('52eb27e7ddc57f7','nuindex',NULL,NULL,'1',10,'SELECT \'0\'','rfwbtn',200,500,'Setup','Report Wizard','button',387,59,120,30,'l','0','0','','0',NULL,NULL,'-1','53a914a2d4f6e8c','','','','','','','','','','',NULL,'',NULL,'','','','','',0,'1','1','','','','','','',NULL,'',0,0,'2014-01-31 15:34:47','globeadmin','2014-02-03 13:38:48','globeadmin','2014-07-15 13:17:30','globeadmin'),('52e6e0a571faf6a','nuformwizard',NULL,NULL,'1',10,'','fw_brwse_up',10,10,'Details','ÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â¢ÃƒÆ’Ã†â€™Ãƒâ€šÃ‚Â¢ÃƒÆ’Ã‚Â¢ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡Ãƒâ€šÃ‚Â¬ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚ÂÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã‚Â¦ÃƒÆ’Ã‚Â¢ÃƒÂ¢Ã¢â‚¬Å¡Ã‚Â¬Ãƒâ€¦Ã¢â‚¬Å“ÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â','button',136,485,50,50,'l','0','0','','0',NULL,NULL,'',NULL,'','','','','','','','','','',NULL,'',NULL,NULL,'','','','',0,'','','','','','','','',NULL,'',0,0,'2014-01-28 09:41:41','globeadmin','2014-02-11 10:20:49','globeadmin','2014-02-11 12:49:00','globeadmin'),('52e6e3db34cf668','nuformwizard',NULL,NULL,'1',10,'','fw_field_up',10,10,'Details','ÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Â ÃƒÂ¢Ã¢â€šÂ¬Ã¢â€žÂ¢ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã‚Â ÃƒÆ’Ã‚Â¢ÃƒÂ¢Ã¢â‚¬Å¡Ã‚Â¬ÃƒÂ¢Ã¢â‚¬Å¾Ã‚Â¢ÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã‚Â¢ÃƒÂ¢Ã¢â‚¬Å¡Ã‚Â¬Ãƒâ€šÃ‚Â ÃƒÆ’Ã†â€™Ãƒâ€šÃ‚Â¢ÃƒÆ’Ã‚Â¢ÃƒÂ¢Ã¢â','button',136,897,50,50,'l','0','0','','0',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',0,'','','','','','','','',NULL,'',0,0,'2014-01-28 09:55:23','globeadmin','2014-02-11 10:21:02','globeadmin','2014-02-11 12:49:00','globeadmin'),('52f2f8ca88a7888','nuformwizard',NULL,NULL,'1',10,'','fw_description_field',10,10,'Details','','dropdown',425,1080,155,0,'l','0','0','','0',NULL,NULL,'','','','','','','SELECT \' \',\' \'','','','','','',NULL,'',NULL,'','','','','',0,'','','','','','','','',NULL,'',0,0,'2014-02-06 13:51:54','globeadmin','2014-02-06 13:52:37','globeadmin','2014-02-11 12:49:00','globeadmin'),('1455245046bfd1','nuobject','','0','1',10,'','sob_text_format',780,130,'Text','Format','dropdown',0,0,100,100,'l','0','0','','0',NULL,NULL,'','','','','','','0|10000|1|10000.0|2|10000.00|3|10000.000|4|10000.0000|5|10000.00000|6|13-Jan-2007|7|13-01-2007|8|Jan-13-2007|9|01-13-2007|10|13-Jan-07|11|13-01-07|12|Jan-13-07|13|01-13-07|14|10,000|15|10,000.0|16|10,000.00|17|10,000.000|18|10,000.0000|19|10,000.00000|20|10000|21|10000,0|22|10000,00|23|10000,000|24|10000,0000|25|10000,00000|26|10.000|27|10.000,0|28|10.000,00|29|10.000,000','','','','','',NULL,'',NULL,'','','','','',0,'1','1','','','','','','',NULL,'',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-02-05 10:31:04','globeadmin'),('1455245046c006','1455245046c010',NULL,'0','1',10,'','sbr_display',20,10,'Browse Fields','Display','text',0,0,100,0,'l','0','0','','0',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',0,'1','1','','','','','','',NULL,'',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2013-10-10 10:42:52','globeadmin'),('1455245046bab3','nuobject','','0','1',20,'','sob_lookup_php',600,100,'Lookup','PHP Functions','textarea',0,0,400,250,'l','0','0','','0',NULL,0,'','','','','','','','','','','','','','',NULL,'','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','2013-10-14 08:42:08','globeadmin','2014-02-05 10:31:02','globeadmin'),('1455245046bfad','nuobject','','0','1',20,'','sob_subform_primary_key',210,120,'Subform','Primary Key','text',0,0,200,0,'l','0','0','','0',NULL,0,'','','','','','','','','','','','','','',NULL,'','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-02-05 10:31:03','globeadmin'),('decafc0ffee003','nuform','','0','1',20,'','sfo_print_button_display_condition',120,20,'Action Buttons','Display Condition','textarea',0,0,300,70,'l','0','0','','0',NULL,0,'','','','','','','','','','','','','','','','','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2015-04-14 11:42:51','globeadmin'),('541b712b1b2acf8','nusetup',NULL,NULL,'1',10,NULL,'sample7',160,20,'Email Settings','465','words',152,652,200,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'1|Yes|0|No',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,0,'1','1',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-09-19 09:26:27','globeadmin','2014-09-19 09:26:27','globeadmin','2014-09-19 09:26:40','globeadmin'),('53c496f74a17c7e','nuindex',NULL,NULL,'1',10,NULL,'OtherWords',260,500,'Setup','<b>Other</b>','words',236,701,120,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-07-15 12:50:31','globeadmin','2014-07-15 12:50:31','globeadmin','2014-07-15 13:17:29','globeadmin'),('52e87d7b7100d14','nuformwizard',NULL,NULL,'1',10,'','fw_form_width',10,10,'Details','Width','text',378,925,275,0,'r','0','0','','0',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',0,'','','','','','','','',NULL,'',0,0,'2014-01-29 15:03:07','globeadmin','2014-02-06 09:53:41','globeadmin','2014-02-11 12:49:00','globeadmin'),('52eb2be10a06e51','nuformwizard',NULL,NULL,'1',10,'','fw_form_remove',60,10,'Details','Remove From Fields','button',449,959,275,20,'l','1','0','','0',NULL,NULL,'','','','','','','SELECT TABLE_NAME, TABLE_NAME\nFROM INFORMATION_SCHEMA.TABLES\nWHERE TABLE_NAME NOT LIKE \'zzzsys_%\'\nAND TABLE_SCHEMA = database()\n','','','','','',NULL,'',NULL,'','','','','',0,'','','','','','','','',NULL,'',0,0,'2014-01-31 15:51:45','globeadmin','2014-02-06 09:53:52','globeadmin','2014-02-11 13:06:35','globeadmin'),('52f30df94b69637','nusubformwizard',NULL,NULL,'1',10,'','sfw_code_field',10,10,'Details','','dropdown',419,564,105,0,'l','0','0','','0',NULL,NULL,'',NULL,'','','','','SELECT \' \', \' \'','','','','','',NULL,'',NULL,NULL,'','','','',0,'','','','','','','','',NULL,'',0,0,'2014-02-06 15:22:17','globeadmin','2014-02-06 15:22:31','globeadmin','2014-02-11 13:01:54','globeadmin'),('52faef8f29148f4','nusubformwizard',NULL,NULL,'1',10,'SELECT \'0\'','sfw_hidden_table',41202,10,'Details',NULL,'text',0,0,60,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-02-12 14:50:39','globeadmin','2014-02-12 14:50:39','globeadmin','2014-02-12 14:50:39','globeadmin'),('52ef2584e7b33c3','nusubformwizard',NULL,NULL,'1',20,'','sfw_form_up',10,10,'Details','ÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Â ÃƒÂ¢Ã¢â€šÂ¬Ã¢â€žÂ¢ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã‚Â ÃƒÆ’Ã‚Â¢ÃƒÂ¢Ã¢â‚¬Å¡Ã‚Â¬ÃƒÂ¢Ã¢â‚¬Å¾Ã‚Â¢ÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã‚Â¢ÃƒÂ¢Ã¢â‚¬Å¡Ã‚Â¬Ãƒâ€šÃ‚Â ÃƒÆ’Ã†â€™Ãƒâ€šÃ‚Â¢ÃƒÆ’Ã‚Â¢ÃƒÂ¢Ã¢â','button',142,854,50,50,'l','0','0','','0',NULL,NULL,'',NULL,'','','','','','','','','','',NULL,'',NULL,NULL,'','','','',0,'','','','','','','','',NULL,'',0,0,'2014-02-03 16:13:41','globeadmin','2014-02-11 10:21:16','globeadmin','2014-02-11 13:01:55','globeadmin'),('52eecb130a37807','nusubformwizard',NULL,NULL,'1',100,'SELECT 0','sfw_hidden_primary',100,10,'Details','','text',0,0,150,0,'l','0','0','','0',NULL,NULL,'',NULL,'','','','','','','','','','',NULL,'',NULL,NULL,'','','','',0,'','','','','','','','',NULL,'',0,0,'2014-02-03 09:47:47','globeadmin','2014-02-03 09:47:53','globeadmin','2014-02-11 13:01:55','globeadmin'),('537d43125b9ea7a','nureport',NULL,NULL,'0',10,NULL,'stror',37,10,'Main','<strong>OR..</strong>','words',0,0,100,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'slp_code',NULL,'slp_description',NULL,'nuphp','zzzsys_php_id',NULL,'',NULL,0,'1','1',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2014-05-22 10:21:38','globeadmin','2014-05-22 10:22:31','globeadmin','2014-09-24 12:40:48','globeadmin'),('52eb2adc1fe9a77','nuformwizard',NULL,NULL,'1',10,'','fw_table_fields_text',10,10,'Details','<b>Table and Fields</b>','words',23,100,275,0,'l','0','0','','0',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',0,'','','','','','','','',NULL,'',0,0,'2014-01-31 15:47:24','globeadmin','2014-02-06 09:52:39','globeadmin','2014-02-11 12:49:00','globeadmin'),('145934df1b12f7','nugroup','','0','1',10,'','sug_code',10,10,'Main','Code','text',0,0,100,0,'l','0','0','','0','',0,NULL,'','','','','','','','','','','','','','','','','','',NULL,0,'1','1','','','','','','',NULL,'',80,240,'0000-00-00 00:00:00','','2013-10-22 14:49:07','globeadmin','2013-10-22 14:59:13','globeadmin'),('145935addcfb3f','nuuser','','0','1',10,'','nupassword',30,10,'Details','New Password','text',0,0,150,0,'l','0','0','','0','',0,'','','','','','','','','','','','','','','','','','','','',0,'1','1','','','','','','password','1','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('1459201a4676c8','nuindex','','0','1',10,'','accessLevelButton',30,500,'Setup','Access Level','button',43,268,120,30,'l','0','0','','0','',0,NULL,'nulevel','','','','','','','','','','','','','','','','','',NULL,0,'1','1','','','','','','',NULL,'b',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-07-15 13:33:19','globeadmin'),('52e1d823b7e73e1','nuformwizard',NULL,NULL,'1',10,'','fw_table_add_to_form',50,10,'Details','Add to Form Objects','button',421,101,275,20,'l','1','0','','0',NULL,NULL,'','','','','','','SELECT TABLE_NAME, TABLE_NAME\nFROM INFORMATION_SCHEMA.TABLES\nWHERE TABLE_NAME NOT LIKE \'zzzsys_%\'\nAND TABLE_SCHEMA = database()\n','','','','','',NULL,'',NULL,'','','','','',0,'','','','','','','','',NULL,'',0,0,'2014-01-24 14:04:03','globeadmin','2014-02-06 09:45:31','globeadmin','2014-02-11 12:49:00','globeadmin'),('1459593a676418','1457c6e9eb2c5b','','0','1',10,'','zzzsys_slo_field_function_name',10,10,'S1','Field or Function Name','text',0,0,200,0,'l','1','0','','0',NULL,0,'','','','','','','','','','','','','','','','','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','2013-10-14 09:10:36','globeadmin','2013-10-14 09:10:38','globeadmin'),('52e6f46bb695a82','nuformwizard',NULL,NULL,'1',10,'','fw_browse_remove',60,10,'Details','Remove From Browse','button',396,550,275,20,'l','1','0','','0',NULL,NULL,'','','','','','','SELECT TABLE_NAME, TABLE_NAME\nFROM INFORMATION_SCHEMA.TABLES\nWHERE TABLE_NAME NOT LIKE \'zzzsys_%\'\nAND TABLE_SCHEMA = database()\n','','','','','',NULL,'',NULL,'','','','','',0,'','','','','','','','',NULL,'',0,0,'2014-01-28 11:06:03','globeadmin','2014-02-06 09:50:10','globeadmin','2014-02-11 13:07:23','globeadmin'),('52e1d6b61a8c8cd','nuformwizard',NULL,NULL,'1',20,'','fw_form_select_all',30,10,'Details','Select All','button',68,549,275,20,'l','1','0','','0',NULL,NULL,'','','','','','','SELECT TABLE_NAME, TABLE_NAME\nFROM INFORMATION_SCHEMA.TABLES\nWHERE TABLE_NAME NOT LIKE \'zzzsys_%\'\nAND TABLE_SCHEMA = database()\n','','','','','',NULL,'',NULL,'','','','','',0,'','','','','','','','',NULL,'',0,0,'2014-01-24 13:57:58','globeadmin','2014-02-06 09:45:09','globeadmin','2014-02-11 12:49:01','globeadmin'),('52e71b4b9405e1e','nuformwizard',NULL,NULL,'1',100,'SELECT \'0\'','fw_hidden_primary',100,10,'Details','','text',0,0,150,20,'l','0','0','','0',NULL,NULL,'',NULL,'','','','','','','','','','',NULL,'',NULL,NULL,'','','','',0,'','','','','','','','',NULL,'',0,0,'2014-01-28 13:51:55','globeadmin','2014-01-28 13:51:55','globeadmin','2014-02-11 12:49:01','globeadmin'),('145920ac55d738','nulevel','','0','1',10,'','sal_zzzsys_form_id',30,10,'Description','Home Page','lookup',0,0,250,100,'l','0','0','SELECT \'nuhome\'','0','',0,'','','','','','','SELECT zzzsys_form_id, sfo_name \nFROM zzzsys_form\nORDER BY sfo_name ','','','','','sfo_name','','sfo_title','','nunoaccess','zzzsys_form_id','','','',0,'1','1','','','','','','','','',100,250,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2015-04-14 11:40:59','globeadmin'),('1459205a300368','nulevel','','0','1',10,'','sal_description',20,10,'Description','Description','text',0,0,250,0,'l','1','0','','1','',0,'','','','','','','','','','','','','','','','','','','','',0,'1','1','','','','','','',NULL,'',0,0,'0000-00-00 00:00:00','','2013-11-11 07:57:27','globeadmin','2015-04-14 11:40:59','globeadmin'),('1455245046bff6','1455245046c010','','0','1',10,'','sbr_width',60,10,'Browse Fields','Width','text',0,0,100,0,'r','1','0','','0','',0,'','','','','','','','','','','','','','','','','','','','',0,'1','1','','','','','0','',NULL,'',0,0,'0000-00-00 00:00:00','','2014-01-10 09:53:12','globeadmin','2014-01-10 09:53:12','globeadmin'),('14580c11db5271','nuform','','0','1',10,'','sfo_custom_code_run_after_save',5,120,'Custom Code','','textarea',45,30,0,0,'l','0','0','','0','',0,'','','','','','','','','','','','','','','','','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2015-04-14 11:42:51','globeadmin'),('145787f625367a','145787d61a3837','','0','1',20,'','sfa_button_javascript',26,10,'Main','Javascript to Run','textarea',0,0,330,100,'l','0','0','','0','',0,'','','','','','','','','','','','','','','','','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2013-10-10 10:43:00','globeadmin'),('52e866facf32940','nuformwizard',NULL,NULL,'1',10,'','fw_browse_width',10,10,'Details','Width','text',370,515,275,0,'r','0','0','','0',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',0,'','','','','','','','',NULL,'',0,0,'2014-01-29 13:27:06','globeadmin','2014-02-06 09:49:59','globeadmin','2014-02-11 12:49:00','globeadmin'),('52eb2bcf8e9043d','nusubformwizard',NULL,NULL,'1',10,'','sfw_form_width',10,10,'Details','Width','text',371,530,275,0,'r','0','0','','0',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',0,'','','','','','','','',NULL,'',0,0,'2014-01-31 15:51:27','globeadmin','2014-01-31 15:58:55','globeadmin','2014-02-11 13:01:54','globeadmin'),('52e6f4bf935ab8d','nusubformwizard',NULL,NULL,'1',10,'','sfw_form_remove',60,10,'Details','Remove From Fields','button',443,564,275,20,'l','1','0','','0',NULL,NULL,'','','','','','','SELECT TABLE_NAME, TABLE_NAME\nFROM INFORMATION_SCHEMA.TABLES\nWHERE TABLE_NAME NOT LIKE \'zzzsys_%\'\nAND TABLE_SCHEMA = database()\n','','','','','',NULL,'',NULL,'','','','','',0,'','','','','','','','',NULL,'',0,0,'2014-01-28 11:07:27','globeadmin','2014-02-03 13:05:26','globeadmin','2014-02-11 13:09:20','globeadmin'),('145773a500ebd8','nuform','','0','1',10,'','sfo_save_button_display_condition',40,20,'Action Buttons','Display Condition','textarea',0,0,300,70,'l','0','0','','0','',0,'','','','','','','','','','','','','','','','','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2015-04-14 11:42:51','globeadmin'),('52eec5634507ad5','nusubformwizard',NULL,NULL,'1',10,'','sfw_form_id',10,10,'Details','Form','lookup',18,130,275,0,'l','1','0','','0',NULL,NULL,'','','','','','','','','','','','sfo_name',NULL,'sfo_title',NULL,'nuform','zzzsys_form_id','','','1',0,'','','','','','','','',NULL,'',100,150,'2014-02-03 09:23:31','globeadmin','2014-02-03 13:09:46','globeadmin','2014-02-11 13:01:54','globeadmin'),('537d4266d97ca33','nureport',NULL,NULL,'1',10,NULL,'sre_zzzsys_sql',35,10,'Main','SQL SELECT Used To Create #TABLE_ID#','textarea',0,0,373,200,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'slp_code',NULL,'slp_description',NULL,'nuphp','zzzsys_php_id',NULL,'',NULL,0,'1','1',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2014-05-22 10:18:46','globeadmin','2014-05-22 11:13:15','globeadmin','2014-09-24 12:40:48','globeadmin'),('52eb2b080f7337f','nusubformwizard',NULL,NULL,'1',10,'','sfw_table_listbox',40,10,'Details','Table Fields','listbox',93,89,275,300,'l','1','0','','0',NULL,NULL,'','','','','','','','','','','SELECT 1','',NULL,'',NULL,'','','','','',0,'','','','','','','','',NULL,'',0,0,'2014-01-31 15:48:08','globeadmin','2014-02-03 13:07:15','globeadmin','2014-02-11 13:01:55','globeadmin'),('52dca5205f97b07','nuemail',NULL,NULL,'1',10,'','message',60,10,'Message','Message','textarea',0,0,300,100,'l','0','0','SELECT \'#nu_email_message#\'','0',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',0,'','','','','','','','',NULL,'',0,0,'2014-01-20 15:25:04','globeadmin','2014-01-24 14:34:36','globeadmin','2014-02-06 12:53:52','globeadmin'),('52e87d2262e7976','nuformwizard',NULL,NULL,'1',10,'','fw_form_title',10,10,'Details','Title','text',352,935,275,0,'l','0','0','','0',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',0,'','','','','','','','',NULL,'',0,0,'2014-01-29 15:01:38','globeadmin','2014-02-06 09:53:28','globeadmin','2014-02-11 12:49:00','globeadmin'),('541b7116bd22da3','nusetup',NULL,NULL,'1',10,NULL,'sample6',150,20,'Email Settings','<i>Your Name</i>','words',130,652,200,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'1|Yes|0|No',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,0,'1','1',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-09-19 09:26:06','globeadmin','2014-09-19 09:26:06','globeadmin','2014-09-19 09:26:13','globeadmin'),('52f30e3b96640a4','nusubformwizard',NULL,NULL,'1',10,'','sfw_description_field',10,10,'Details','','dropdown',419,686,155,0,'l','0','0','','0',NULL,NULL,'','','','','','','SELECT \' \', \' \'','','','','','',NULL,'',NULL,'','','','','',0,'','','','','','','','',NULL,'',0,0,'2014-02-06 15:23:23','globeadmin','2014-02-06 15:26:23','globeadmin','2014-02-11 13:01:54','globeadmin'),('54ffa11a7df0592','nufastform',NULL,NULL,'1',10,NULL,'sfo_title',10,10,'Fast Form','Form Title','text',24,132,200,0,'l','0','0','','1',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-11 12:27:46','globeadmin','2015-03-20 10:20:01','globeadmin','2015-04-15 12:04:02','globeadmin'),('145773a9557383','nuform','','0','1',10,'','sfo_delete_button',50,20,'Action Buttons','Delete Button','dropdown',0,0,70,100,'l','0','0','','0','',0,'','','','','','','1|Yes|0|No','','','','','','','','','','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2015-04-14 11:42:51','globeadmin'),('52e1d624270c056','nuformwizard',NULL,NULL,'1',40,'','fw_browse_column',10,10,'Details','<b>Browse Column</b>','words',19,550,150,0,'l','1','0','','0',NULL,NULL,'',NULL,'','','','','','','','','','',NULL,'',NULL,NULL,'','','','',0,'','','','','','','','',NULL,'',0,0,'2014-01-24 13:55:32','globeadmin','2014-02-06 09:49:29','globeadmin','2014-02-11 12:49:01','globeadmin'),('52e1d87451efc70','nuformwizard',NULL,NULL,'1',10,'','fw_table_listbox',40,10,'Details','','listbox',89,99,275,300,'l','1','0','','0',NULL,NULL,'','','','','','','','','','','SELECT 1','',NULL,'',NULL,'','','','','',0,'','','','','','','','',NULL,'',0,0,'2014-01-24 14:05:24','globeadmin','2014-02-06 09:38:07','globeadmin','2014-02-11 12:49:00','globeadmin'),('52e1e031d97e900','nuformwizard',NULL,NULL,'1',10,'','fw_field_names_text',10,10,'Details','Field Names','words',66,16,100,0,'l','1','0','','0',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',0,'','','','','','','','',NULL,'',0,0,'2014-01-24 14:38:25','globeadmin','2014-01-24 14:38:26','globeadmin','2014-02-11 12:49:00','globeadmin'),('5202f0736f69f75','nuimage',NULL,NULL,'1',20,'','sfi_name',40,10,'Main','Name','text',260,80,250,0,'l','0','1','','0',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',0,'1','1','','','','','','',NULL,'',0,0,'0000-00-00 00:00:00','','2013-10-25 12:49:35','globeadmin','2014-01-17 13:36:19','globeadmin'),('563308984d4a7dc','nuemail',NULL,NULL,'1',10,NULL,'alertmessage1',80,10,'Message','Your login does not have an email account configured, please contact your administrator.','words',105,100,300,50,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,0,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-30 17:05:12','globeadmin','2015-10-30 17:21:16','globeadmin','2015-11-02 14:32:48','globeadmin'),('52e1d83f5e35df5','nuformwizard',NULL,NULL,'1',10,'','fw_table_add_to_browse',60,10,'Details','Add to Browse Column','button',395,100,275,20,'l','1','0','','0',NULL,NULL,'','','','','','','SELECT TABLE_NAME, TABLE_NAME\nFROM INFORMATION_SCHEMA.TABLES\nWHERE TABLE_NAME NOT LIKE \'zzzsys_%\'\nAND TABLE_SCHEMA = database()\n','','','','','',NULL,'',NULL,'','','','','',0,'','','','','','','','',NULL,'',0,0,'2014-01-24 14:04:31','globeadmin','2014-02-06 09:45:23','globeadmin','2014-02-20 09:41:46','globeadmin'),('5636c5b63f06778','nuemail',NULL,NULL,'1',10,NULL,'sendcopyword',90,10,'Message','Send me (#nu_smtp_to_address#) a copy','words',230,140,280,40,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,0,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-11-02 13:08:54','globeadmin','2015-11-02 13:56:21','globeadmin','2015-11-02 14:32:48','globeadmin'),('5636abff43779ab','nuemail',NULL,NULL,'1',10,NULL,'sendcopy',70,10,'Message','&nbsp;','checkbox',0,0,300,100,'l','1','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,0,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-11-02 11:19:11','globeadmin','2015-11-02 13:50:47','globeadmin','2015-11-02 14:32:48','globeadmin'),('52ef2592bc39a21','nusubformwizard',NULL,NULL,'1',10,'','sfw_form_down',10,10,'Details','ÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Â ÃƒÂ¢Ã¢â€šÂ¬Ã¢â€žÂ¢ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã‚Â ÃƒÆ’Ã‚Â¢ÃƒÂ¢Ã¢â‚¬Å¡Ã‚Â¬ÃƒÂ¢Ã¢â‚¬Å¾Ã‚Â¢ÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã‚Â¢ÃƒÂ¢Ã¢â‚¬Å¡Ã‚Â¬Ãƒâ€šÃ‚Â ÃƒÆ’Ã†â€™Ãƒâ€šÃ‚Â¢ÃƒÆ’Ã‚Â¢ÃƒÂ¢Ã¢â','button',200,854,50,50,'l','0','0','','0',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',0,'','','','','','','','',NULL,'',0,0,'2014-02-03 16:13:54','globeadmin','2014-02-11 10:21:31','globeadmin','2014-02-11 13:01:54','globeadmin'),('14580c19159999','nuform','','0','1',10,'','sfo_custom_code_run_javascript',1000,120,'Custom Code','','textarea',45,30,0,0,'l','0','0','','0','',0,'','','','','','','','','','','','','','','','','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2015-04-14 11:42:51','globeadmin'),('52e1d677888a8c8','nuformwizard',NULL,NULL,'1',10,'','fw_table_select_all',30,10,'Details','Select All','button',65,98,275,20,'l','1','0','','0',NULL,NULL,'','','','','','','SELECT TABLE_NAME, TABLE_NAME\nFROM INFORMATION_SCHEMA.TABLES\nWHERE TABLE_NAME NOT LIKE \'zzzsys_%\'\nAND TABLE_SCHEMA = database()\n','','','','','',NULL,'',NULL,'','','','','',0,'','','','','','','','',NULL,'',0,0,'2014-01-24 13:56:55','globeadmin','2014-02-06 09:45:56','globeadmin','2014-02-11 12:49:00','globeadmin'),('52e1d895e6fd1c0','nuformwizard',NULL,NULL,'1',40,'','fw_browse_listbox',30,10,'Details','','listbox',96,550,275,250,'l','1','0','','0',NULL,NULL,'','','','','','','','','','','SELECT 1','',NULL,'',NULL,'','','','','',0,'','','','','','','','',NULL,'',0,0,'2014-01-24 14:05:58','globeadmin','2014-02-06 09:49:19','globeadmin','2014-02-11 12:49:01','globeadmin'),('52eb27e7ddc57f6','nuindex',NULL,NULL,'1',10,'','sfwbtn',110,500,'Setup','SubForm Wizard','button',137,487,120,30,'l','0','0','','0',NULL,NULL,'-1','nusubformwizard','','','','','','','','','','',NULL,'',NULL,'','','','','',0,'1','1','','','','','','',NULL,'',0,0,'2014-01-31 15:34:47','globeadmin','2014-07-15 13:31:53','globeadmin','2014-07-15 13:37:24','globeadmin'),('52e1dfebdf15e8e','nuformwizard',NULL,NULL,'1',10,'','fw_form_fields_text',10,10,'Details','Form Fields','words',66,877,100,0,'l','1','0','','0',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',0,'','','','','','','','',NULL,'',0,0,'2014-01-24 14:37:16','globeadmin','2014-01-24 16:31:39','globeadmin','2014-02-12 14:54:01','globeadmin'),('14580c083db4cb','nuform','','0','1',10,'','sfo_custom_code_run_before_open',110,120,'Custom Code','','textarea',45,30,0,0,'l','0','0','','0','',0,'','','','','','','','','','','','','','','','','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2015-04-14 11:42:51','globeadmin'),('52e1d7bbc29ca2c','nuformwizard',NULL,NULL,'1',10,'','fw_table_name',20,10,'Details','Table Name','dropdown',42,30,275,0,'l','1','0','','0',NULL,NULL,'','','','','','','SELECT TABLE_NAME, TABLE_NAME\r\nFROM INFORMATION_SCHEMA.TABLES\r\nWHERE TABLE_NAME NOT LIKE \"zzzsys_%\"\r\nAND TABLE_NAME NOT LIKE \"___nu%\"\r\nAND TABLE_SCHEMA = database()','','','','','',NULL,'',NULL,'','','','','',0,'','','','','','','','',NULL,'',0,0,'2014-01-24 14:02:19','globeadmin','2014-02-07 16:20:09','globeadmin','2014-02-20 10:41:39','globeadmin'),('5269aa0e6195a30','nuobject',NULL,NULL,'0',10,'','oridword',20,210,'iFrame','OR..','words',0,0,100,0,'l','0','0','','0',NULL,NULL,'','','','','','','','','51da4dedb0b4171','522faef3a9b5178','','slp_code',NULL,'slp_description',NULL,'nuphp','zzzsys_php_id','','','',0,'1','1','','','','','','',NULL,'',100,250,'2013-10-25 09:45:26','globeadmin','2013-10-25 09:45:54','globeadmin','2014-02-05 10:31:05','globeadmin'),('145beab058be2c','nuform','','0','1',20,'','sfo_new_button',90,20,'Action Buttons','New Button','dropdown',0,0,70,100,'l','0','0','','0',NULL,0,'','','','','','','1|Yes|0|No','','','','','','','','','','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','2013-10-08 09:33:59','globeadmin','2015-04-14 11:42:51','globeadmin'),('145935b7f8eda6','nuuser','','0','1',10,'','sus_zzzsys_user_group_id',50,10,'Details','User Group','dropdown',0,0,150,100,'l','0','0','','0','',0,NULL,'','','','','','SELECT zzzsys_user_group_id, sug_code FROM zzzsys_user_group ORDER BY sug_code','','','','','','','','','','','','',NULL,0,'1','1','','','','','','',NULL,'b',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('145934e7305862','nuindex','','0','1',10,'','UserGroups',40,500,'Setup','User Groups','button',75,268,120,30,'l','0','0','','0','',0,NULL,'nugroup','','','','','','','','','','','','','','','','','',NULL,0,'1','1','','','','','','',NULL,'b',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-07-15 13:33:30','globeadmin'),('52e1beb4aaa0a2f','nuindex',NULL,NULL,'1',10,'','fwbtn',90,500,'Setup','Form Wizard','button',75,487,120,30,'l','0','0','','0',NULL,NULL,'-1','nuformwizard','','','','','','','','','','',NULL,'',NULL,'','','','','',0,'1','1','','','','','','',NULL,'',0,0,'2014-01-24 12:15:32','globeadmin','2014-07-15 13:31:30','globeadmin','2014-07-15 13:35:05','globeadmin'),('52e1dc5b3de4d20','nuformwizard',NULL,NULL,'1',10,'','fw_browse_column_text',10,10,'Details','Browse Columns','words',71,441,100,0,'l','1','0','','0',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',0,'','','','','','','','',NULL,'',0,0,'2014-01-24 14:22:03','globeadmin','2014-01-24 14:24:19','globeadmin','2014-02-11 12:49:00','globeadmin'),('528a92294b7032a','nuphp',NULL,NULL,'1',10,'','slp_nonsecure',50,10,'Details','Allow Non Secure Access','dropdown',0,0,60,30,'l','1','0','SELECT \'0\';','0',NULL,NULL,'','','','','','','1|Yes|0|No','','','','','sfo_name',NULL,'sfo_title',NULL,'nuform','zzzsys_form_id','','','',0,'1','1','','','','','','',NULL,'',100,250,'2013-11-19 09:18:17','globeadmin','2013-11-19 09:50:41','globeadmin','2013-11-19 09:50:41','globeadmin'),('52eb2b9d3b96d77','nusubformwizard',NULL,NULL,'1',40,'','sfw_form_select_all',20,10,'Details','Select All','button',66,565,275,20,'l','1','0','','0',NULL,NULL,'','','','','','','SELECT TABLE_NAME, TABLE_NAME\nFROM INFORMATION_SCHEMA.TABLES\nWHERE TABLE_NAME NOT LIKE \'zzzsys_%\'\nAND TABLE_SCHEMA = database()\n','','','','','',NULL,'',NULL,'','','','','',0,'','','','','','','','',NULL,'',0,0,'2014-01-31 15:50:37','globeadmin','2014-02-07 09:26:06','globeadmin','2014-02-11 13:01:55','globeadmin'),('1457739571a2f3','nuform','','0','1',10,'','sfo_add_button_display_condition',20,20,'Action Buttons','Display Condition','textarea',0,0,300,70,'l','0','0','','0','',0,'','','','','','','','','','','','','','','','','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2015-04-14 11:42:51','globeadmin'),('5164b8cee0f2dbc','nureport',NULL,'','0',10,'','sre_description',20,10,'Main','Description','text',0,0,250,0,'l','1','0','','1',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',0,'1','1','','','','','','',NULL,'',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-09-24 12:40:48','globeadmin'),('51b7a12f0ad36a3','nulevel',NULL,NULL,'1',10,'','reportAccess',10,50,'Reports',' ','subform',30,230,450,380,'l','0','0','','0',NULL,NULL,'','','','','','','','','','','','sre_code',NULL,'sre_description',NULL,'nureport','zzzsys_report_id','','','',22,'1','1','slr_zzzsys_access_level_id','zzzsys_access_level_report_id','SELECT * \r\nFROM zzzsys_access_level_report \r\nINNER JOIN zzzsys_report ON zzzsys_report_id = slr_zzzsys_report_id\r\nWHERE slr_zzzsys_access_level_id = \'#RECORD_ID#\' \r\nORDER BY sre_code\r\n','zzzsys_access_level_report','','',NULL,'g',100,250,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2015-04-14 11:40:59','globeadmin'),('145beaaeb6ff1a','nuform','','0','1',20,'','sfo_new_title',95,20,'Action Buttons','Title','text',0,0,200,0,'l','0','0','','0',NULL,0,'','','','','','','','','','','','','','','','','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','2013-10-08 09:34:33','globeadmin','2015-04-14 11:42:51','globeadmin'),('5164b8ac0b51901','nureport',NULL,'','0',10,'','sre_code',10,10,'Main','Code','text',0,0,150,0,'l','1','0','','1',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',0,'1','1','','','','','','',NULL,'',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-09-24 12:40:48','globeadmin'),('14feb929a82943','14feb8e8026465','','0','1',10,'','slf_save_button',30,10,'Main','Remove Save Btn.','dropdown',0,0,70,100,'l','0','0','','0',NULL,0,'','','','','','','1|Yes|0|No','','','','','sfo_name','','sfo_title',NULL,'form','zzzsys_form_id','','','',0,'1','1','','','','','','','','',240,240,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-09-19 12:26:23','globeadmin'),('51c3cabde7cd234','nureport',NULL,NULL,'1',10,'SELECT \'0\';','sre_layout',70,10,'Main','Lay Out','textarea',0,0,300,100,'l','0','0','','0',NULL,NULL,'','','','','','','SELECT * FROM zzzsys_form ORDER BY sfo_name','','','','','sfo_name',NULL,'sfo_title',NULL,'nuform','zzzsys_form_id','','','',0,'1','1','','','','','','',NULL,'',100,250,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-09-24 12:40:48','globeadmin'),('14f3852d29e5b9','14f3852d29db17',NULL,'','1',10,'','sob_all_tab_title',60,20,'Subform','Tab Title','text',0,0,170,0,'l','0','0','','0',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',NULL,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2013-10-10 10:42:28','globeadmin'),('145beab28ce1bb','nuform','','0','1',20,'','sfo_new_button_display_condition',100,20,'Action Buttons','Display Condition','textarea',0,0,300,70,'l','0','0','','0',NULL,0,'','','','','','','','','','','','','','','','','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','2013-10-08 09:35:00','globeadmin','2015-04-14 11:42:51','globeadmin'),('14feb92315662b','14feb8e8026465','','0','1',10,'','slf_add_button',20,10,'Main','Remove Add Btn.','dropdown',0,0,70,100,'l','0','0','','0',NULL,0,'','','','','','','1|Yes|0|No','','','','','sfo_name','','sfo_title',NULL,'form','zzzsys_form_id','','','',0,'1','1','','','','','','','','',240,240,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-09-19 12:26:23','globeadmin'),('521aa44b5653b9d','nudebug',NULL,NULL,'0',10,NULL,'deb_message',10,10,'Debug','Message','textarea',0,0,700,400,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'0000-00-00 00:00:00','','2013-10-25 14:22:36','globeadmin','2014-01-10 13:05:23','globeadmin'),('14feb92b66c04f','14feb8e8026465','','0','1',10,'','slf_delete_button',40,10,'Main','Remove Del. Btn.','dropdown',0,0,70,100,'l','0','0','','0',NULL,0,'','','','','','','1|Yes|0|No','','','','','sfo_name','','sfo_title',NULL,'form','zzzsys_form_id','','','',0,'1','1','','','','','','','','',240,240,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-09-19 12:26:23','globeadmin'),('52dca4df610358c','nuemail',NULL,NULL,'1',10,'','subject',50,10,'Message','Subject','text',0,0,250,0,'l','0','0','SELECT \'#nu_email_subject#\'','0',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',0,'','','','','','','','',NULL,'',0,0,'2014-01-20 15:23:59','globeadmin','2014-01-24 14:34:13','globeadmin','2014-02-06 12:53:52','globeadmin'),('14feb90091f111','14feb8e8026465','','0','1',10,'','slf_zzzsys_form_id',10,10,'Main','Forms Allowed Access','lookup',0,0,250,0,'l','1','0','','0',NULL,0,'','','','','','','','','','','','sfo_name','','sfo_title',NULL,'nunoaccess','zzzsys_form_id','','','1',0,'1','1','','','','','','','','',100,250,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-09-19 12:26:23','globeadmin'),('14f3852d29e774','14f3852d29db17',NULL,'','1',10,'','sob_all_title',35,20,'Subform','Title','text',0,0,230,0,'l','0','0','','0',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',NULL,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2013-10-10 10:42:28','globeadmin'),('52eb2b822843d25','nusubformwizard',NULL,NULL,'1',10,'','sfw_table_add_to_form',50,10,'Details','Add to Form Objects','button',397,159,275,20,'l','1','0','','0',NULL,NULL,'','','','','','','SELECT TABLE_NAME, TABLE_NAME\nFROM INFORMATION_SCHEMA.TABLES\nWHERE TABLE_NAME NOT LIKE \'zzzsys_%\'\nAND TABLE_SCHEMA = database()\n','','','','','',NULL,'',NULL,'','','','','',0,'','','','','','','','',NULL,'',0,0,'2014-01-31 15:50:10','globeadmin','2014-02-07 09:26:41','globeadmin','2014-02-11 13:01:55','globeadmin'),('52dca562de653cf','nuemail',NULL,NULL,'1',10,'','from',40,10,'Message','From','text',0,0,250,0,'l','0','1','SELECT \'#nu_smtp_from_address#\'','0',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',0,'','','','','','','','',NULL,'',0,0,'2014-01-20 15:26:11','globeadmin','2014-01-23 14:33:29','globeadmin','2014-02-06 12:53:52','globeadmin'),('5165e6dbc6b9514','14feb8e8026465',NULL,'0','1',10,'','slf_print_button',70,10,'Main','Remove Print Btn.','dropdown',0,0,70,100,'l','0','0','','0',NULL,NULL,'','','','','','','1|Yes|0|No','','','','','sfo_name',NULL,'sfo_title',NULL,'','zzzsys_form_id','','','',0,'1','1','','','','','','',NULL,'',240,240,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-09-19 12:26:23','globeadmin'),('14f02480d3c322','nuform','','0','1',10,'','sfo_rows',20,15,'Browse','Rows Per Page','text',0,0,50,0,'r','0','0','','0',NULL,0,'','','','','','','SELECT sst_class, sst_class FROM zzzsys_style ORDER BY sst_class','','','','','','','',NULL,'','','','','',0,'1','1','','','','','0','','','',0,0,'0000-00-00 00:00:00','','2014-01-10 09:56:33','globeadmin','2015-04-14 11:42:50','globeadmin'),('5269ec17618f6cb','nudebug',NULL,NULL,'0',10,'','deb_delete',20,10,'Debug','Delete records older than','dropdown',0,0,100,0,'l','0','0','','0',NULL,NULL,'','','','','','','60|A Minute|3600|An Hour|18000|5 Hours','','','','','',NULL,'',NULL,'','','','','',0,'','','','','','','','',NULL,'',0,0,'2013-10-25 14:27:11','globeadmin','2013-10-25 14:28:12','globeadmin','2014-02-17 16:32:19','globeadmin'),('51db33e43a91032','nusetup',NULL,NULL,'1',10,'','set_css',20,30,'Header','HTML','textarea',0,0,800,400,'l','0','0','','0',NULL,NULL,'','','','','','','1|Yes|0|No','','','','','',NULL,'',NULL,'','','','','',0,'1','1','','','','','','',NULL,'',0,0,'0000-00-00 00:00:00','','2013-10-31 14:33:11','globeadmin','2013-11-18 16:30:48','globeadmin'),('52dc9c6688c8c0e','nuemail',NULL,NULL,'1',10,'','to',10,10,'Message','To','text',0,0,250,0,'l','0','0','SELECT \'#nu_email_to#\'','0',NULL,NULL,'',NULL,'','','','','','','','','','',NULL,'',NULL,NULL,'','','','',0,'','','','','','','','',NULL,'',0,0,'2014-01-20 14:47:50','globeadmin','2014-01-24 14:32:54','globeadmin','2014-02-06 12:53:52','globeadmin'),('525b1a7d7714972','nuobject',NULL,NULL,'1',20,'','sob_lookup_javascript',550,100,'Lookup','Javascript','textarea',0,0,400,100,'l','0','0','','0',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','',NULL,'','',0,'1','1','','','','','','',NULL,'',0,0,'2013-10-14 08:41:09','globeadmin','2013-10-14 08:41:41','globeadmin','2014-02-05 10:31:02','globeadmin'),('1457c6e9eb2c5b','nuobject','','0','1',20,'','lookupSubform',800,100,'Lookup','Update Other Fields','subform',182,6,500,200,'l','0','0','','0','',0,'','','','','','','','','','','','','','','','','','','','',26,'1','1','slo_zzzsys_object_id','zzzsys_lookup_id','SELECT * FROM zzzsys_lookup WHERE slo_zzzsys_object_id = \'#RECORD_ID#\'','zzzsys_lookup','','','','g',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-02-05 10:31:03','globeadmin'),('5202f0d5809fafc','nuimage',NULL,NULL,'1',20,'','words3filescreen',25,10,'Main','<b>Image</b>','words',20,570,250,0,'l','0','0','','0',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',0,'1','1','','','','','','',NULL,'',0,0,'0000-00-00 00:00:00','','2013-12-30 13:45:21','globeadmin','2014-01-17 13:36:19','globeadmin'),('145787f999fb2e','145787d61a3837','','0','1',15,'','sfa_button_display_condition',30,10,'Main','Display Condition','textarea',0,0,150,100,'l','0','0','','0','',0,'','','','','','','','','','','','','','','','','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2013-10-10 10:43:00','globeadmin'),('52e1d6c72bec014','nuformwizard',NULL,NULL,'1',40,'','fw_browse_select_all',20,10,'Details','Select All','button',67,960,275,20,'l','1','0','','0',NULL,NULL,'','','','','','','SELECT TABLE_NAME, TABLE_NAME\nFROM INFORMATION_SCHEMA.TABLES\nWHERE TABLE_NAME NOT LIKE \'zzzsys_%\'\nAND TABLE_SCHEMA = database()\n','','','','','',NULL,'',NULL,'','','','','',0,'','','','','','','','',NULL,'',0,0,'2014-01-24 13:58:15','globeadmin','2014-02-06 09:45:15','globeadmin','2014-02-11 12:49:01','globeadmin'),('145d3d46168a33','nusetup','','0','1',10,'','set_time_out_minutes',140,10,'Setup','Timeout (minutes)','text',0,0,60,0,'r','1','0','','0',NULL,0,'','','','','','','','','','','','','','','','','','','','',0,'1','1','','','','','0','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2013-11-18 16:30:46','globeadmin'),('146bc0d39115da','nuform',NULL,'','1',10,'','sfo_custom_code_run_after_browse',20,120,'Custom Code','','textarea',45,30,0,0,'l','0','0','','0',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-01-09 17:09:33','globeadmin'),('14feb92eed6083','14feb8e8026465','','0','1',10,'','slf_new_button',60,10,'Main','Remove New Btn.','dropdown',0,0,70,100,'l','0','0','','0',NULL,0,'','','','','','','1|Yes|0|No','','','','','sfo_name','','sfo_title',NULL,'form','zzzsys_form_id','','','',0,'1','1','','','','','','','','',240,240,'0000-00-00 00:00:00','','2013-10-10 07:46:36','globeadmin','2014-09-19 12:26:23','globeadmin'),('1472e8d3ced629','nuindex','','1','1',10,'','imagesupload',190,500,'Setup','Images','button',289,701,120,30,'l','0','0','','0',NULL,0,'','nuimage','','','','','','','','','','','','',NULL,'','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-07-15 13:17:29','globeadmin'),('15023043618a09','nutranslate','','0','1',10,'','trl_language',10,10,'Details','Language','text',0,0,100,0,'l','0','0','','0',NULL,0,'','','','','','','','','','','','','','',NULL,'','','','','',0,'1','1','','','','','','','','b',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('515223cfd1c36e2','515222283d84654',NULL,'0','1',10,'','sev_javascript',20,10,'Detail','Javascript','textarea',100,100,400,100,'l','1','0','','0',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',100,'1','1','sev_zzzsys_object_id','zzzsys_event_id','SELECT * FROM zzzsys_event WHERE sev_zzzsys_object_id = \'#RECORD_ID#\'','zzzsys_event','','','','g',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('52dca4cf33cedb6','nuemail',NULL,NULL,'1',10,'','replytoname',20,10,'Message','Reply To Name','text',0,0,250,0,'l','0','1','SELECT \'#nu_smtp_to_name#\'','0',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',0,'','','','','','','','',NULL,'',0,0,'2014-01-20 15:23:43','globeadmin','2014-01-23 14:31:40','globeadmin','2014-02-06 12:53:52','globeadmin'),('52eb2aec64b5abd','nusubformwizard',NULL,NULL,'1',10,'','sfw_table_name',20,10,'Details','Table Name','dropdown',44,91,275,0,'l','1','0','','0',NULL,NULL,'','','','','','','SELECT TABLE_NAME, TABLE_NAME\r\nFROM INFORMATION_SCHEMA.TABLES\r\nWHERE TABLE_NAME NOT LIKE \"zzzsys_%\"\r\nAND TABLE_NAME NOT LIKE \"___nu%\"\r\nAND TABLE_SCHEMA = database()','','','','','',NULL,'',NULL,'','','','','',0,'','','','','','','','',NULL,'',0,0,'2014-01-31 15:47:40','globeadmin','2014-02-07 16:20:24','globeadmin','2014-02-11 13:01:54','globeadmin'),('52e1d571a65d25a','nuformwizard',NULL,NULL,'1',20,'','fw_form_objects',10,10,'Details','<b>Form Objects</b>','words',22,960,150,0,'l','0','0','','0',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',0,'','','','','','','','',NULL,'',0,0,'2014-01-24 13:52:33','globeadmin','2014-02-06 09:53:17','globeadmin','2014-02-11 12:49:01','globeadmin'),('1459744b2e8b26','nuindex','','0','1',10,'','Runrep',130,500,'Setup','Run Report','button',289,487,120,30,'l','0','0','','0',NULL,0,'','nurunreport','','','','','','','','','','','','','','','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','2014-07-15 13:38:17','globeadmin','2014-07-15 13:39:05','globeadmin'),('15087459201b94','nusetup','','0','1',10,'','set_smtp_test_email',80,20,'Email Settings','Test Email ','button',0,0,120,30,'l','0','0','','0',NULL,0,'','','','','','','1|Yes|0|No','','','','','','','',NULL,'','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2013-11-18 16:30:48','globeadmin'),('14595a08007a13','nugroup','','0','1',10,'','sug_zzzsys_access_level_id',40,10,'Main','Access Level','dropdown',0,0,250,100,'l','0','0','','0',NULL,0,'','','','','','','SELECT zzzsys_access_level_id, CONCAT(sal_code,\' - (\',sal_description,\')\') FROM zzzsys_access_level ORDER BY sal_code','','','','','','','','','','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2013-10-22 14:59:13','globeadmin'),('524a51edb1281a4','nusetup',NULL,NULL,'1',10,'','set_fonts',300,10,'Setup','Custom Fonts','textarea',0,0,150,200,'l','0','0','','0',NULL,NULL,'','','','','','','1|Yes|0|No','','','','','',NULL,'',NULL,'','','','','',0,'1','1','','','','','','',NULL,'',0,0,'2013-10-01 14:09:09','globeadmin','2013-10-01 14:09:23','globeadmin','2013-11-18 16:30:46','globeadmin'),('14f0247a001c92','nuform','','0','1',10,'','sfo_row_height',10,15,'Browse','Row Pixel Height','text',0,0,50,0,'r','0','0','','0',NULL,0,'','','','','','','SELECT zzzsys_style_id, sst_class FROM zzzsys_style ORDER BY sst_class','','','','','','','',NULL,'','','','','',0,'1','1','','','','','0','','','',0,0,'0000-00-00 00:00:00','','2014-01-10 09:55:31','globeadmin','2015-04-14 11:42:50','globeadmin'),('5164decb1b8a612','nureport',NULL,'','1',10,'','sre_group',30,10,'Main','Group','text',0,0,200,0,'l','0','0','','0',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',0,'1','1','','','','','','',NULL,'',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-09-24 12:40:48','globeadmin'),('14575e416b71b1','nuform','','0','1',10,'','sfo_table',60,10,'General','Table','text',0,0,250,0,'l','0','0','','0','',0,'','','','','','','','','','','','','','','','','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2015-04-14 11:42:50','globeadmin'),('1502304d649403','nutranslate','','0','1',10,'','trl_english',20,10,'Details','English','text',0,0,200,0,'l','0','0','','0',NULL,0,'','','','','','','','','','','','','','',NULL,'','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('515e599c390d2a5','nuform',NULL,'0','1',10,'','sfo_width',100,10,'General','Width','text',0,0,50,0,'r','0','0','','0',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',0,'1','1','','','','','','',NULL,'',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2015-04-14 11:42:50','globeadmin'),('5164b96d5905c71','nuobject',NULL,'','0',10,'','sob_iframe_zzzsys_php_id',10,210,'iFrame','PHP to Run','lookup',0,0,100,0,'l','0','0','','0',NULL,NULL,'','','','','','','','','','','','slp_code',NULL,'slp_description',NULL,'nuphp','zzzsys_php_id','','','',0,'1','1','','','','','','',NULL,'',100,250,'0000-00-00 00:00:00','','2013-10-25 09:31:02','globeadmin','2014-02-05 10:31:05','globeadmin'),('51636fdee304f88','51636e4728362e8',NULL,'','1',10,'','sob_all_order_number',90,20,'Subform','Ord','text',0,0,50,0,'r','0','0','','0',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',0,'1','1','','','','','0','',NULL,'',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('51d630727eb5bcc','nuuser',NULL,NULL,'1',10,'','nuretyped',35,10,'Details','Retype New Password','text',0,0,150,0,'l','0','0','','0',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',0,'1','1','','','','','','password',NULL,'',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('15023046831fc2','nuindex','','1','1',10,'','transbt',160,500,'Setup','Translation','button',107,701,120,30,'l','0','0','','0',NULL,0,'','nutranslate','','','','','','','','','','','','',NULL,'','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-07-15 13:39:20','globeadmin'),('514799c658a9a4d','nuobject',NULL,'0','1',20,'','sob_subform_row_height',225,120,'Subform','Row Height','text',0,0,50,0,'r','0','0','','0',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',NULL,'1','1','','','','','0','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-02-05 10:31:04','globeadmin'),('515222283d84654','nuobject',NULL,'0','1',10,'','sub_events',10,15,'Events','Events','subform',20,200,620,350,'l','0','0','','0',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',110,'1','1','sev_zzzsys_object_id','zzzsys_event_id','SELECT * FROM zzzsys_event WHERE sev_zzzsys_object_id = \'#RECORD_ID#\'','zzzsys_event','','','','g',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-02-05 10:31:01','globeadmin'),('51479fa5d17974d','nuobject',NULL,'0','1',20,'','sob_subform_addable',230,120,'Subform','Addable','dropdown',0,0,70,100,'l','0','0','','0',NULL,NULL,'','','','','','','1|Yes|0|No','','','','','',NULL,'',NULL,'','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-02-05 10:31:04','globeadmin'),('14731218d30f34','nuimage','','0','1',10,'','sfi_group',30,10,'Main','Group','text',137,78,100,0,'l','0','0','','0',NULL,0,'','','','','','','','','','','','','','',NULL,'','','','','',0,'1','1','','','','','','','0','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-01-17 13:36:18','globeadmin'),('52818c84074eb82','nusetup',NULL,NULL,'1',10,'','set_timezone',145,10,'Setup','Timezone','dropdown',0,0,160,0,'r','1','0','','0',NULL,NULL,'','','','','','','SELECT stz_timezone, stz_timezone FROM zzzsys_timezone','','','','','',NULL,'',NULL,'','','','','',0,'1','1','','','','','','',NULL,'',0,0,'2013-11-12 13:03:48','globeadmin','2013-11-12 14:44:47','globeadmin','2013-11-18 16:30:46','globeadmin'),('515223562d0a69d','515222283d84654',NULL,'0','1',10,'','sev_name',10,10,'Detail','Event Name','text',100,100,150,0,'l','1','0','','0',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',100,'1','1','sev_zzzsys_object_id','zzzsys_event_id','SELECT * FROM zzzsys_event WHERE sev_zzzsys_object_id = \'#RECORD_ID#\'','zzzsys_event','','','','g',0,0,'0000-00-00 00:00:00','','2014-01-28 15:13:30','globeadmin','2014-01-28 15:13:47','globeadmin'),('14feb93cbbff85','14feb8e8026465','','0','1',10,'','slf_clone_button',50,10,'Main','Remove Clone Btn.','dropdown',0,0,70,100,'l','0','0','','0',NULL,0,'','','','','','','1|Yes|0|No','','','','','sfo_name','','sfo_title',NULL,'form','zzzsys_form_id','','','',0,'1','1','','','','','','','','',240,240,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-09-19 12:26:23','globeadmin'),('54ffa05310db2d7','nuindex',NULL,NULL,'1',10,NULL,'fafbtn',10,500,'Setup','Fast Form','button',43,65,120,30,'l','0','0','','0',NULL,NULL,NULL,'nufastform',NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,0,'1','1',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-11 12:24:27','globeadmin','2015-04-14 12:52:42','globeadmin','2015-04-14 12:52:42','globeadmin'),('520421ea5f5cfc9','nuimage',NULL,NULL,'1',10,'SELECT \'#sfi_size#\' != \'\'','display_image_clip',55,10,'Main','Example','html',310,62,300,30,'l','0','1','','0',NULL,NULL,'','','','','','','','<div id=\"display_image_clip_div\" style=\"width: 30px; height:300px;\">\r\n\r\n\r\n<textarea id=\"display_image_clip_textarea\" class=\"nuReadOnly\" style=\"padding:15px;\" rows=\"2\" cols=\"45\">\r\n&lt;img id=\'img_#sfi_code#_id\' src=\'nufileget.php?i=#sfi_code#\'/&gt; \r\n</textarea>\r\n<br>\r\n</div>\r\n\r\n','','','','',NULL,'',NULL,'','','','','',0,'1','1','','','','','','',NULL,'',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2015-04-14 11:22:03','globeadmin'),('51b7c95778fcb78','51b7a12f0ad36a3',NULL,NULL,'1',10,'','slr_zzzsys_report_id',10,10,'Main','Reports Allowed Access','lookup',0,0,250,0,'l','1','0','','0',NULL,NULL,'','','','','','','','','','','','sre_code',NULL,'sre_description',NULL,'nureport','zzzsys_report_id','','','1',0,'1','1','','','','','','',NULL,'',100,250,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-09-19 12:20:17','globeadmin'),('5164afcc4510338','nuphp',NULL,'0','1',10,'','slp_code',10,10,'Details','Code','text',0,0,150,0,'l','1','0','','1',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',0,'1','1','','','','','','',NULL,'',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2013-11-08 11:19:18','globeadmin'),('5202eafc2df64bf','nuimage',NULL,NULL,'1',10,'','words1filescreen',1,10,'Main','<b>File</b>','words',20,40,250,0,'l','0','0','','0',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',0,'1','1','','','','','','',NULL,'',0,0,'0000-00-00 00:00:00','','2013-12-30 13:35:22','globeadmin','2014-01-17 13:36:18','globeadmin'),('5142b7878f23f81','nuobject',NULL,'0','1',20,'','sob_subform_type',780,120,'Subform','Subform Type','dropdown',0,0,70,0,'l','0','0','','0',NULL,NULL,'','','','','','','g|Grid|f|Form','','','','','',NULL,'',NULL,'','','','','',NULL,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-02-05 10:31:04','globeadmin'),('5164b0b68f0ede3','nuphp',NULL,'0','1',10,'','slp_group',30,10,'Details','Group','text',0,0,200,0,'l','1','0','','0',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',0,'1','1','','','','','','',NULL,'',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2013-11-08 11:19:19','globeadmin'),('5164e46713a6765','nureport',NULL,'0','1',10,'','sre_zzzsys_form_id',50,10,'Main','Criteria Form','lookup',0,0,300,100,'l','0','0','','0',NULL,NULL,'','','','','','','SELECT * FROM zzzsys_form ORDER BY sfo_name','','','','','sfo_name',NULL,'sfo_title',NULL,'nuform','zzzsys_form_id','','','',0,'1','1','','','','','','',NULL,'',100,250,'0000-00-00 00:00:00','','2013-11-01 13:18:26','globeadmin','2014-09-24 12:40:48','globeadmin'),('521accb821bfb3f','nuuser',NULL,NULL,'1',10,'','sus_email',15,10,'Details','Email','text',0,0,200,0,'l','0','0','','0',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',0,'1','1','','','','','','',NULL,'',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('51636e4728362e8','nuobject',NULL,'','0',10,'','object_subform',10,120,'Subform','Objects','subform',226,30,950,150,'l','0','0','','0',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',21,'1','1','sob_zzzsys_form_id','zzzsys_object_id','SELECT * FROM zzzsys_object WHERE sob_zzzsys_form_id = \'#RECORD_ID#\' \nORDER BY \nsob_all_tab_number, \nsob_all_column_number, \nsob_all_order_number','zzzsys_object','','',NULL,'g',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-02-05 10:31:03','globeadmin'),('545ad8a397d734d','nulevel',NULL,NULL,'1',10,NULL,'openformbtn',40,10,'Description','F','button',57,540,20,20,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'SELECT zzzsys_form_id, sfo_name \nFROM zzzsys_form\nORDER BY sfo_name ',NULL,'','',NULL,'sfo_name',NULL,'sfo_title',NULL,'nunoaccess','zzzsys_form_id',NULL,'',NULL,0,'1','1',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2014-11-06 12:40:43','globeadmin','2014-11-06 12:46:31','globeadmin','2015-04-14 11:40:59','globeadmin'),('14feb8e8026465','nulevel','','0','1',10,'','formAccess',10,40,'Forms','','subform',30,70,880,400,'l','0','0','','0',NULL,0,'','','','','','','','','','','','','','',NULL,'','','','','',22,'1','1','slf_zzzsys_access_level_id','zzzsys_access_level_form_id','SELECT * FROM zzzsys_access_level_form\nINNER JOIN zzzsys_form ON slf_zzzsys_form_id = zzzsys_form_id\nWHERE slf_zzzsys_access_level_id = \'#RECORD_ID#\'\nORDER BY sfo_name','zzzsys_access_level_form','','','','g',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2015-04-14 11:40:59','globeadmin'),('150c0145249c92','14f3852d29db17',NULL,'','1',10,'','sob_all_top',100,20,'Subform','Top','text',0,0,50,0,'r','0','0','','0',NULL,NULL,'','','','','','','','','','','','','','',NULL,'','','','','',0,'1','1','','','','','0','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2013-10-10 10:42:28','globeadmin'),('5164e7d44a71374','nuphp',NULL,'0','1',10,'','slp_zzzsys_form_id',40,10,'Details','Criteria Form','lookup',0,0,300,100,'l','0','0','','0',NULL,NULL,'','','','','','','SELECT * FROM zzzsys_form ORDER BY sfo_name','','','','','sfo_name',NULL,'sfo_title',NULL,'nuform','zzzsys_form_id','','','',0,'1','1','','','','','','',NULL,'',100,250,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2013-11-19 09:16:47','globeadmin'),('145beaad4c5279','nuform','','0','1',20,'','sfo_clone_title',75,20,'Action Buttons','Title','text',0,0,200,0,'l','0','0','','0',NULL,0,'','','','','','','','','','','','','','','','','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2015-04-14 11:42:51','globeadmin'),('14593559f334cf','nuindex','','0','1',10,'','Users',50,500,'Setup','Users','button',107,268,120,30,'l','0','0','','0','',0,NULL,'nuuser','','','','','','','','','','','','','','','','','',NULL,0,'1','1','','','','','','',NULL,'b',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-07-15 13:33:41','globeadmin'),('145aefc5710ffa','nuindex','','1','1',10,'','Setup',170,500,'Setup','System Setup','button',135,701,120,30,'l','0','0','','0',NULL,0,'1','nusetup','','','','','','','','','','','','','','','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-07-15 13:17:29','globeadmin'),('5164b9c2f01a215','nuindex',NULL,'0','1',10,'','repgtn',120,500,'Setup','Reports','button',257,487,120,30,'l','0','0','','0',NULL,NULL,'','nureport','','','','','','','','','','',NULL,'',NULL,'','','','','',0,'1','1','','','','','','',NULL,'',0,0,'0000-00-00 00:00:00','','2014-07-15 13:37:45','globeadmin','2014-07-15 13:37:45','globeadmin'),('1504975ff1dbbb','nuuser','','0','1',10,'SELECT 0','sus_login_password_was',100,10,'Details','','display',0,0,100,100,'l','0','0','','0',NULL,0,'','','','','','SELECT sus_login_password FROM zzzsys_user WHERE zzzsys_user_id = \'#recordID#\'','','','','','','','','',NULL,'','','','','',0,'1','1','','','','','','','1','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('52e1cd8771f75fd','nuformwizard',NULL,NULL,'1',20,'','fw_form_listbox',40,10,'Details','','listbox',94,960,275,250,'l','1','0','','0',NULL,NULL,'','','','','','','','','','','SELECT 1','',NULL,'',NULL,'','','','','',0,'','','','','','','','',NULL,'',0,0,'2014-01-24 13:18:47','globeadmin','2014-02-06 09:51:29','globeadmin','2014-02-11 12:49:01','globeadmin'),('145773ba26e1b9','nuform','','0','1',20,'','sfo_clone_button_display_condition',80,20,'Action Buttons','Display Condition','textarea',0,0,300,70,'l','0','0','','0','',0,'','','','','','','','','','','','','','','','','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2015-04-14 11:42:51','globeadmin'),('14ea879bf7c1a3','nuform','','0','1',10,'','sfo_redirect_form_id',5,15,'Browse','Form To Edit (if not this form)','lookup',0,0,250,0,'l','0','0','','0',NULL,0,'','','','','','','SELECT * FROM zzzsys_form ORDER BY sfo_name','','','','','sfo_name','','sfo_title',NULL,'nuform','zzzsys_form_id','','','',0,'1','1','','','','','','','','',100,250,'0000-00-00 00:00:00','','2014-01-10 09:51:24','globeadmin','2015-04-14 11:42:50','globeadmin'),('14fa5ac5c9a139','nuobject','','0','1',10,'','sob_browse_filter',20,200,'Browse','Default Filter for Browse','text',0,0,250,0,'l','0','0','','0',NULL,0,'','','','','','','','','','','','','','',NULL,'','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-02-05 10:31:05','globeadmin'),('5164b96d5905c7f','nureport',NULL,'','1',10,'','sre_zzzsys_php_id',40,10,'Main','PHP Used To Create #TABLE_ID#','lookup',0,0,100,0,'l','0','0','','0',NULL,NULL,'','','','','','','','','','','','slp_code',NULL,'slp_description',NULL,'nuphp','zzzsys_php_id','','','',0,'1','1','','','','','','',NULL,'',100,250,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-09-24 12:40:48','globeadmin'),('52c0df33aad29a8','nuimage',NULL,NULL,'1',20,'SELECT \'0\'','sfi_tmp_name',40,10,'Main','Name','text',250,45,350,0,'l','0','1','','0',NULL,NULL,'',NULL,'','','','','','','','','','',NULL,'',NULL,NULL,'','','','',0,'','','','','','','','',NULL,'',0,0,'2013-12-30 13:49:23','globeadmin','2014-01-17 09:43:24','globeadmin','2014-01-17 13:36:19','globeadmin'),('14580c12e28024','nuform','','0','1',10,'','sfo_custom_code_run_after_delete',10,120,'Custom Code','','textarea',45,30,0,0,'l','0','0','','0','',0,'','','','','','','','','','','','','','','','','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2015-04-14 11:42:51','globeadmin'),('5186d40c2a32069','nuform',NULL,NULL,'1',10,'','sfo_breadcrumb',100,10,'General','Breadcrumb Title','textarea',0,0,300,100,'l','0','0','','0',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',0,'1','1','','','','','','',NULL,'',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2015-04-14 11:42:50','globeadmin'),('14594a58489545','nuobject','','0','1',10,'','sob_text_type',840,130,'Text','Text Type','dropdown',0,0,100,100,'l','0','0','','0','',0,'','','','','','','password|Password','','','','','','','','','','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-02-05 10:31:05','globeadmin'),('52eefa250fc0f64','nusubformwizard',NULL,NULL,'1',10,'','sfw_subform_type',10,10,'Details','Subform Type','dropdown',18,486,275,0,'l','0','0','','0',NULL,NULL,'',NULL,'','','','','g|Grid|f|Form','','','','','',NULL,'',NULL,NULL,'','','','',0,'','','','','','','','',NULL,'',0,0,'2014-02-03 13:08:37','globeadmin','2014-02-03 14:01:03','globeadmin','2014-02-11 13:01:54','globeadmin'),('145935a528b09d','nuuser','','0','1',10,'','sus_name',10,10,'Details','Name','text',0,0,200,0,'l','0','0','','0','',0,'','','','','','','','','','','','','','','','','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('1455245046ba36','nuobject','','0','1',10,'','sob_all_type',20,10,'All','Type','dropdown',0,0,100,100,'l','1','0','','0','',0,'','','','','','','browse|Browse|button|Button|display|Display|dropdown|Drop Down|checkbox|Check Box|html|HTML|iframe|iFrame|listbox|List Box|lookup|Lookup|subform|SubForm|text|Text|textarea|Textarea|words|Words','','','','','','','','','','','','','',0,'1','1','','','','','','',NULL,'',0,0,'0000-00-00 00:00:00','','2013-10-25 10:20:37','globeadmin','2014-02-05 10:30:58','globeadmin'),('installerbtn','nuindex',NULL,NULL,'1',10,NULL,'UpdatenuBuilder',140,500,'Setup','Update nuBuilder','button',43,701,120,30,'l','0','0','','0',NULL,NULL,'-1','nuupdatenubuilder',NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-06-26 12:50:38','globeadmin','2014-07-15 13:01:14','globeadmin','2014-07-15 13:40:15','globeadmin'),('53bce051e2777b4','nuupdatenubuilder',NULL,NULL,'1',10,NULL,'Runbtn',10,10,'Main','Run','button',0,0,120,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-07-09 16:25:22','globeadmin','2014-07-09 16:25:22','globeadmin','2014-07-15 13:07:18','globeadmin'),('53c496801cdfc65','nuindex',NULL,NULL,'1',10,NULL,'SystemWords',280,500,'Setup','<b>System</b>','words',22,701,120,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-07-15 12:48:32','globeadmin','2014-07-15 12:48:32','globeadmin','2014-07-15 13:17:29','globeadmin'),('53c494a584e681c','nuindex',NULL,NULL,'1',10,NULL,'ReportsWords',230,500,'Setup','<b>Reports</b>','words',236,487,120,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-07-15 12:40:37','globeadmin','2014-07-15 13:38:34','globeadmin','2014-07-15 13:38:34','globeadmin'),('1455245046ba29','nuobject','','0','1',10,'','sob_all_order_number',80,10,'All','Order Number','text',0,0,40,0,'r','1','0','','0',NULL,NULL,'','','','','','','','','','','','','','',NULL,'','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-02-05 10:30:59','globeadmin'),('52dca552bc1c213','nuemail',NULL,NULL,'1',10,'','replyto',30,10,'Message','Reply To','text',0,0,250,0,'l','0','1','SELECT \'#nu_smtp_to_address#\'','0',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',0,'','','','','','','','',NULL,'',0,0,'2014-01-20 15:25:54','globeadmin','2014-01-23 13:45:24','globeadmin','2014-02-06 12:53:52','globeadmin'),('51678f239d70019','nureport',NULL,NULL,'1',10,'','repbld',60,10,'Main','Report Builder','button',0,0,120,30,'l','0','0','','0',NULL,NULL,'','','','','','','SELECT * FROM zzzsys_form ORDER BY sfo_name','','','','','sfo_name',NULL,'sfo_title',NULL,'nuform','zzzsys_form_id','','','',0,'1','1','','','','','','',NULL,'',100,250,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-09-24 12:40:48','globeadmin'),('522025e88174a00','nureport',NULL,NULL,'1',10,'','viewreport',1000,10,'Main','View','button',313,750,50,20,'l','0','0','','0',NULL,NULL,'','','','','','','SELECT * FROM zzzsys_form ORDER BY sfo_name','','','','','sfo_name',NULL,'sfo_title',NULL,'nuform','zzzsys_form_id','','','',0,'1','1','','','','','','',NULL,'',100,250,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-09-24 12:40:48','globeadmin'),('1457737c94bc68','nuform','','0','1',10,'','sfo_primary_key',70,10,'General','Primary Key','text',0,0,250,0,'l','0','0','','0','',0,'','','','','','','','','','','','','','','','','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2015-04-14 11:42:50','globeadmin'),('1455245046ba3z','nuobject','','0','1',10,'','sob_all_width',110,10,'All','Width Pixels','text',0,0,60,0,'r','1','0','','0',NULL,NULL,'','','','','','','','','','','','','','',NULL,'','','','','',0,'1','1','','','','','0','',NULL,'',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-09-19 12:10:44','globeadmin'),('53bce14c97273b5','nuupdatenubuilder',NULL,NULL,'1',10,NULL,'updateNubuilderMessageDetailsHTML3',20,10,'Main',NULL,'html',0,0,850,350,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<div id=\"updateNubuilderMessageDetails\"></div>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-07-09 16:29:32','globeadmin','2014-07-09 16:29:32','globeadmin','2014-07-15 13:07:18','globeadmin'),('51d9e82510ead25','nuuser',NULL,NULL,'1',10,'SELECT \'0\'','sus_login_password',37,10,'Details','Encrypted Password','text',0,0,150,0,'l','0','1','','0',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',0,'1','1','','','','','','password',NULL,'',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('51636ffdcf6c6eb','51636e4728362e8',NULL,'','1',10,'','sob_all_top',100,20,'Subform','Top','text',0,0,50,0,'r','0','0','','0',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',0,'1','1','','','','','0','',NULL,'',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('1472e93b996f3a','nuimage','','0','1',10,'','display_image',60,10,'Main','','html',70,520,300,100,'l','0','1','','0',NULL,0,'','','','','','','','<div style=\"width: 150px; height:150px; overflow:scroll;\">\r\n<br><br>\r\n<img style=\"background-color:lightgrey\'\" width=\"350\" height=\"250\" id=\'theimage\' align=\"middle\" src=\'nufileget.php?i=#sfi_code#\'/>\r\n</div>\r\n<script>\r\n    var date = new Date().toUTCString();\r\n    var src = $(\'#theimage\').attr(\'src\');\r\n    $(\'#theimage\').attr(\'src\', src+\'&t=\'+date);\r\n</script>\r\n\r\n','','','','','','',NULL,'','','','','',0,'1','1','','','','','','','0','',0,0,'0000-00-00 00:00:00','','2014-01-17 09:52:38','globeadmin','2015-04-14 11:24:25','globeadmin'),('14573719372039','nuindex','','1','1',10,'','FormsButton',80,500,'Setup','Forms','button',43,487,120,30,'l','0','0','','0','1',0,'','nuform','','','','','','','','','','','','','','','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-07-15 13:34:49','globeadmin'),('51636f427d270a5','51636e4728362e8',NULL,'','1',10,'','sob_all_name',30,20,'Subform','Name','text',0,0,230,0,'l','0','0','','0',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',0,'1','1','','','1','','','',NULL,'',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('1455245046ba0b','nuobject','','0','1',10,'','sob_all_align',150,10,'All','Align','dropdown',0,0,70,100,'l','1','0','SELECT \'l\'','0',NULL,0,'','','','','','','l|Left|r|Right|c|Center','','','','','','','',NULL,'','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-02-05 10:31:00','globeadmin'),('1455245046ba55','nuobject','','0','1',10,'','sob_all_no_blanks',160,10,'All','Stop Blanks','dropdown',0,0,70,100,'l','1','0','SELECT 0','0','',0,'','','','','','','1|Yes|0|No','','','','','','','','','','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-02-05 10:31:00','globeadmin'),('5202f0403f43ddb','nuimage',NULL,NULL,'1',20,'','sfi_size',40,10,'Main','Size','text',285,88,50,0,'l','0','1','','0',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',0,'1','1','','','','','','',NULL,'',0,0,'0000-00-00 00:00:00','','2013-10-25 12:48:47','globeadmin','2014-01-17 13:36:19','globeadmin'),('1455245046ba39','nuobject','','0','0',10,'','sob_all_left',100,10,'All','Left Pixels','text',0,0,60,0,'r','0','0','','0',NULL,NULL,'','','','','','','',NULL,'','','','','','',NULL,'','','','','',NULL,'1','1',NULL,NULL,NULL,NULL,'0','',NULL,'b',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-02-05 10:30:59','globeadmin'),('1455245046ba5e','nuobject','','0','1',10,'','sob_dropdown_sql',310,40,'Dropdown','SQL','textarea',0,0,900,300,'l','0','0','','0',NULL,0,'','','','','','','','','','','','','','',NULL,'','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-02-05 10:31:01','globeadmin'),('541b70e79659bad','nusetup',NULL,NULL,'1',10,NULL,'sample4',130,20,'Email Settings','smtp.gmail.com','words',86,652,200,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'1|Yes|0|No',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,0,'1','1',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-09-19 09:25:19','globeadmin','2014-09-19 09:25:19','globeadmin','2014-09-19 09:25:27','globeadmin'),('53aa4c5243b18dd','53a914a2d4f6e8c',NULL,NULL,'1',10,NULL,'description',20,10,'Details','<b>Description</b>','words',23,19,100,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-06-25 14:13:06','globeadmin','2014-06-25 14:13:10','globeadmin','2014-10-01 10:02:21','globeadmin'),('SMTPAUTH100007','nusetup','','0','1',10,'','set_smtp_port',60,20,'Email Settings','Auth SMTP port','text',0,0,100,0,'l','0','0','','0',NULL,0,'','','','','','','1|Yes|0|No','','','','','','','',NULL,'','','','','',0,'1','1','','','','','','','','b',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2013-11-18 16:30:48','globeadmin'),('1455245046ba0e','nuobject','','0','1',10,'','sob_all_clone',130,10,'All','Allow Cloning','dropdown',0,0,70,100,'l','1','0','SELECT 1','0','',0,'','','','','','','1|Yes|0|No','','','','','','','','','','','','','',0,'1','1','','','','','','',NULL,'',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-02-05 10:31:00','globeadmin'),('53bce0bd1c980e2','nuupdatenubuilder',NULL,NULL,'1',10,NULL,'updateNubuilderProgressHTML2',15,10,'Main',NULL,'html',0,0,200,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<div id=\"updateNubuilderProgress\"></div>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-07-09 16:27:09','globeadmin','2014-07-09 16:27:09','globeadmin','2014-07-15 13:07:18','globeadmin'),('1455245046ba12','nuobject','','0','1',10,'','sob_all_column_number',70,10,'All','Column Number','text',0,0,40,0,'r','1','0','','0',NULL,NULL,'','','','','','','','','','','','','','',NULL,'','','','','',0,'1','1','','','','','','',NULL,'',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-02-05 10:30:59','globeadmin'),('1455245046ba5b','nuobject','','0','1',10,'','sob_all_read_only',180,10,'All','Read Only','dropdown',0,0,70,100,'l','1','0','SELECT 0','0',NULL,NULL,'','','','','','','1|Yes|0|No','','','','','','','',NULL,'','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-02-05 10:31:00','globeadmin'),('53aa4c5f6027c61','53a914a2d4f6e8c',NULL,NULL,'1',10,NULL,'from',40,10,'Details','<b>FROM</b>','words',85,19,100,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-06-25 14:13:19','globeadmin','2014-06-25 14:13:19','globeadmin','2014-10-01 10:02:21','globeadmin'),('1455245046ba3e','nuobject','','0','0',10,'','sob_all_top',90,10,'All','Top Pixels','text',0,0,60,0,'r','0','0','','0',NULL,NULL,'','','','','','','',NULL,'','','','','','',NULL,'','','','','',NULL,'1','1',NULL,NULL,NULL,NULL,'0','',NULL,'b',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-02-05 10:30:59','globeadmin'),('53aa4c8104f6a38','53a914a2d4f6e8c',NULL,NULL,'1',10,NULL,'select',70,10,'Details','<b>SELECT</b>','words',155,236,100,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-06-25 14:13:53','globeadmin','2014-06-25 14:13:53','globeadmin','2014-10-01 10:02:21','globeadmin'),('53aa4c682e17e42','53a914a2d4f6e8c',NULL,NULL,'1',10,NULL,'fields',50,10,'Details','<b>Fields</b>','words',155,19,100,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-06-25 14:13:28','globeadmin','2014-06-25 14:13:28','globeadmin','2014-10-01 10:02:21','globeadmin'),('53aa4cb8801c31d','53a914a2d4f6e8c',NULL,NULL,'1',10,NULL,'columnname',110,10,'Details','<b>Field Name</b>','words',85,236,100,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-06-25 14:14:48','globeadmin','2014-06-25 14:14:58','globeadmin','2014-10-01 10:02:21','globeadmin'),('53aa4c776ec525d','53a914a2d4f6e8c',NULL,NULL,'1',10,NULL,'fieldwidth',60,10,'Details','<b>Field Width</b>','words',85,450,100,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-06-25 14:13:43','globeadmin','2014-06-25 14:13:43','globeadmin','2014-10-01 10:02:21','globeadmin'),('53aa4cabd015486','53a914a2d4f6e8c',NULL,NULL,'1',10,NULL,'alignment',100,10,'Details','<b>Alignment</b>','words',85,619,100,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-06-25 14:14:35','globeadmin','2014-06-25 14:14:36','globeadmin','2014-10-01 10:02:21','globeadmin'),('53aa4c9a52f8f7c','53a914a2d4f6e8c',NULL,NULL,'1',10,NULL,'where',90,10,'Details','<b>WHERE</b>','words',155,619,100,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-06-25 14:14:18','globeadmin','2014-06-25 14:31:43','globeadmin','2014-10-01 10:02:21','globeadmin'),('53aa4c8b35508df','53a914a2d4f6e8c',NULL,NULL,'1',10,NULL,'orderby',80,10,'Details','<b>ORDER BY</b>','words',155,450,100,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-06-25 14:14:03','globeadmin','2014-06-25 14:14:03','globeadmin','2014-10-01 10:02:21','globeadmin'),('53aba22054ddcda','53a914a2d4f6e8c',NULL,NULL,'1',10,NULL,'format',310,10,'Details',NULL,'dropdown',108,744,100,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'0|10000|1|10000.0|2|10000.00|3|10000.000|4|10000.0000|5|10000.00000|6|13-Jan-2007|7|13-01-2007|8|Jan-13-2007|9|01-13-2007|10|13-Jan-07|11|13-01-07|12|Jan-13-07|13|01-13-07|14|10,000|15|10,000.0|16|10,000.00|17|10,000.000|18|10,000.0000|19|10,000.00000|20|10000|21|10000,0|22|10000,00|23|10000,000|24|10000,0000|25|10000,00000|26|10.000|27|10.000,0|28|10.000,00|29|10.000,000',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-06-26 14:31:28','globeadmin','2014-06-26 14:31:28','globeadmin','2014-10-01 10:02:21','globeadmin'),('1455245046ba2f','nuobject','','0','1',10,'','sob_all_tab_title',50,10,'All','Tab Title','text',0,0,200,0,'l','1','0','','0',NULL,NULL,'','','','','','','','','','','','','','',NULL,'','','','','',0,'1','1','','','','','','',NULL,'',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-02-05 10:30:59','globeadmin'),('1455245046ba18','nuobject','','0','1',10,'','sob_all_name',40,10,'All','Field Name','text',0,0,200,0,'l','1','0','','0',NULL,0,'','','','','','','','','','','','','','','','','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-02-05 10:30:59','globeadmin'),('53aba2c18384fe0','53a914a2d4f6e8c',NULL,NULL,'1',10,NULL,'formatword',30,10,'Details','<b>Format</b>','words',85,744,100,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-06-26 14:34:09','globeadmin','2014-06-26 14:34:42','globeadmin','2014-10-01 10:02:21','globeadmin'),('541b70ca326eca0','nusetup',NULL,NULL,'1',10,NULL,'sample3',120,20,'Email Settings','<i>your_password</i>','words',64,652,200,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'1|Yes|0|No',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,0,'1','1',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-09-19 09:24:50','globeadmin','2014-09-19 09:24:50','globeadmin','2014-09-19 09:25:04','globeadmin'),('54ffa1a22a1b5de','nufastform',NULL,NULL,'1',10,NULL,'fast_form_properties',20,10,'Fast Form','P','button',23,397,17,17,'l','1','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-11 12:30:02','globeadmin','2015-03-23 09:49:00','globeadmin','2015-04-15 12:04:02','globeadmin'),('1455245046bff5','1455245046c010','','0','1',10,'','sbr_order',70,10,'Browse Fields','Order','text',0,0,100,0,'r','1','0','','0','',0,'','','','','','','','','','','','','','','','','','','','',0,'1','1','','','','','0','',NULL,'',0,0,'0000-00-00 00:00:00','','2014-01-10 09:54:23','globeadmin','2014-01-10 09:54:23','globeadmin'),('541b706a3ebfb42','nusetup',NULL,NULL,'1',10,NULL,'sample1',100,20,'Email Settings','Sample Settings for Gmail','words',19,651,200,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'1|Yes|0|No',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,0,'1','1',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-09-19 09:23:14','globeadmin','2014-09-19 09:32:09','globeadmin','2014-09-19 09:32:09','globeadmin'),('SMTPAUTH100001','nusetup','','0','1',10,'','smtp_w',10,20,'Email Settings','<b>Authenticated SMTP settings</b>','words',0,0,200,0,'l','0','0','','0',NULL,0,'','','','','','','1|Yes|0|No','','','','','','','',NULL,'','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','2014-09-19 09:33:01','globeadmin','2014-09-19 09:33:01','globeadmin'),('54ffae1936edba2','54ffacae7d8599d',NULL,NULL,'1',10,NULL,'fast_form_object_description',5,10,'Fast Form','Type','words',0,0,180,0,'l','1','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-11 13:23:13','globeadmin','2015-03-23 09:24:02','globeadmin','2015-03-27 16:35:32','globeadmin'),('1457738260ebd8','nuform','','0','1',10,'','sfo_add_button',10,20,'Action Buttons','Add Button','dropdown',0,0,70,100,'l','0','0','','0','',0,'','','','','','','1|Yes|0|No','','','','','','','','','','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2015-04-14 11:42:50','globeadmin'),('552dcd64ad5bf49','nufastform',NULL,NULL,'1',10,NULL,'fast_form_browse_view',30,10,'Fast Form','B','button',23,10,17,17,'l','1','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-04-15 12:01:00','globeadmin','2015-04-15 12:01:00','globeadmin','2015-04-15 12:04:02','globeadmin'),('1455245047bca2','nuobject','','0','1',10,'','sob_lookup_autocomplete',600,100,'Lookup','Autocomplete','dropdown',0,0,50,100,'l','0','0','','0',NULL,0,'','','','','','','1|Yes|0|No','','','','','','','',NULL,'','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-02-05 10:31:02','globeadmin'),('1455245046c009','1455245046c010','','0','1',10,'','sbr_align',30,10,'Select Fields','Align','dropdown',0,0,100,100,'l','0','0','','0','',0,NULL,'','','','','','l|Left|r|Right|c|Center','','','','','','','','','','','','',NULL,0,'1','1','','','','','','','','b',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2013-10-10 10:42:52','globeadmin'),('1455245046bfb5','nuobject','','0','1',30,'','sob_subform_sql',10,120,'Subform','SQL','textarea',0,0,400,150,'l','0','0','','0','',0,'','','','','','','','','','','','','','','','','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-02-05 10:31:04','globeadmin'),('1455245046ba87','nuobject','','0','1',10,'','sob_listbox_sql',440,90,'Listbox','SQL','textarea',0,0,900,300,'l','0','0','','0',NULL,0,'','','','','','','','','','','','','','',NULL,'','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-02-05 10:31:01','globeadmin'),('1455245046bf8a','nuobject','','0','1',20,'','sob_subform_foreign_key',220,120,'Subform','Foreign Key','text',0,0,200,0,'l','0','0','','0',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',NULL,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-02-05 10:31:03','globeadmin'),('145773b86d8eb5','nuform','','0','1',20,'','sfo_clone_button',70,20,'Action Buttons','Clone Button','dropdown',0,0,70,100,'l','0','0','','0','',0,'','','','','','','1|Yes|0|No','','','','','','','','','','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2015-04-14 11:42:51','globeadmin'),('145787d61a3837','nuform','','0','1',10,'','extraActionButtons',10,25,'Extra Action Buttons','Extra Action Buttons','subform',17,154,700,400,'l','0','0','','0','',0,'','','','','','','','','','','','','','','','','','','','',105,'1','1','sfa_zzzsys_form_id','zzzsys_form_action_id','SELECT * FROM zzzsys_form_action WHERE sfa_zzzsys_form_id = \'#RECORD_ID#\' ORDER BY zzzsys_form_action_id','zzzsys_form_action','','','','g',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2015-04-14 11:42:51','globeadmin'),('1455245046baab','nuobject','','0','1',20,'','sob_lookup_zzzsys_form_id',530,100,'Lookup','Form to Lookup','lookup',0,0,300,100,'l','0','0','','0',NULL,0,'','','','','','','SELECT * FROM zzzsys_form ORDER BY sfo_name','','','','','sfo_name','','sfo_title','','nuform','zzzsys_form_id','','','',0,'1','1','','','','','','','','',100,250,'0000-00-00 00:00:00','','2013-10-09 12:33:19','globeadmin','2014-02-05 10:31:02','globeadmin'),('1455245046ba15','nuobject','','0','1',20,'','sob_all_display_condition',20,10,'All','Display Condition','textarea',0,0,300,100,'l','0','0','','0','',0,'','','','','','','','','','','','','','','','','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-02-05 10:31:00','globeadmin'),('145787ef89be25','145787d61a3837','','0','1',10,'','sfa_button_title',10,10,'Main','Title','text',0,0,150,0,'l','0','0','','0','',0,'','','','','','','','','','','','','','','','','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2013-10-10 10:43:00','globeadmin'),('1455245046ba4c','nuobject','','0','1',10,'','sob_display_sql',250,30,'Display','SQL','textarea',0,0,900,300,'l','0','0','','0',NULL,0,'','','','','','','','','','','','','','',NULL,'','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-02-05 10:31:01','globeadmin'),('54705a95dae2179','54705a95c4e91c2',NULL,NULL,'1',10,NULL,'name',10,10,'Λεπτομέρειες','Πλήρες Όνομα :','text',60,70,250,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-11-21 19:53:43','globeadmin','2018-07-29 15:28:18','globeadmin'),('54705a95e234eea','54705a95c4e91c2',NULL,NULL,'1',10,NULL,'short_name',20,10,'Λεπτομέρειες','Συντομογραφία :','text',120,67,100,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-11-21 19:54:15','globeadmin','2018-07-29 15:28:18','globeadmin'),('56e0593e23001ef','56e052ae98309fe',NULL,NULL,'1',10,NULL,'registered_cards_iframe',20,10,'Διδασκαλίες',NULL,'iframe',45,16,940,550,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','SELECT class.short_name\nFROM session_variables\ninner join  class           on class.id         = session_variables.class_id\nWHERE session_variables.session_id=\'#session_id#\'',NULL,NULL,'56e0783347a0891','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2016-03-09 19:11:26','globeadmin','2017-10-07 13:19:05','globeadmin','2022-12-21 12:47:00','globeadmin'),('1457f678cd1e6d','nuobject','','0','1',10,'','sob_lookup_id_field',10,100,'Lookup','ID Field','text',0,0,200,0,'l','0','0','','0','',0,'','','','','','','','','','','','','','','','','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-02-05 10:31:01','globeadmin'),('145beaa184f563','nuform','','0','1',10,'','sfo_add_title',15,20,'Action Buttons','Title','text',0,0,200,0,'l','0','0','','0',NULL,0,'','','','','','','','','','','','','','','','','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2015-04-14 11:42:50','globeadmin'),('5202eff7ae7707a','nuimage',NULL,NULL,'1',20,'','sfi_type',30,10,'Main','Type','text',234,86,250,0,'l','0','1','','0',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',0,'1','1','','','','','','',NULL,'',0,0,'0000-00-00 00:00:00','','2013-10-25 12:48:03','globeadmin','2014-01-17 13:36:19','globeadmin'),('SMTPAUTH100008','nusetup','','0','1',10,'','set_smtp_use_ssl',70,20,'Email Settings','Auth SMTP use SSL','dropdown',0,0,100,100,'l','0','0','','0',NULL,0,'','','','','','','1|Yes|0|No','','','','','','','',NULL,'','','','','',0,'1','1','','','','','','','','b',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2013-11-18 16:30:48','globeadmin'),('54706cd5152119c','54706cd4f34daae',NULL,NULL,'1',10,NULL,'name',10,10,'Λεπτομέρειες','Όνομα :','text',60,70,250,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-11-21 20:20:04','globeadmin','2018-07-29 15:29:24','globeadmin'),('54706cd51c73d85','54706cd4f34daae',NULL,NULL,'1',10,NULL,'short_name',20,10,'Λεπτομέρειες','Συντομογραφία :','text',120,23,100,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-11-21 20:20:25','globeadmin','2018-07-29 15:29:24','globeadmin'),('54706cd523c6f19','54a433830716b84',NULL,NULL,'0',10,NULL,'daybtn',10,50,'Γενικά Στοιχεία Σχολείων',NULL,'html',50,60,220,100,'l','0','0','','0',NULL,NULL,'','54706cd4f34daae','','','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_week_id\').src=\'nufileget.php?i=weekb\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_week_id\').src=\'nufileget.php?i=week\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_week_id\' src=\'nufileget.php?i=week\' title=\'Οι ημέρες της εβδομάδας κατά τις οποίες γίνονται μαθήματα\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Ημέρες Διδασκαλίας</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',0,0,'0000-00-00 00:00:00','','2015-10-03 18:17:02','globeadmin','2015-12-26 21:06:03','globeadmin'),('54706f6b549af99','54706f6b39c1b38',NULL,NULL,'1',10,NULL,'name',10,10,'Λεπτομέρειες','\'Ονομα :','text',60,70,250,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-11-21 23:02:36','globeadmin','2018-07-29 15:33:30','globeadmin'),('54706f6b5bede8b','54706f6b39c1b38',NULL,NULL,'1',10,NULL,'short_name',20,10,'Λεπτομέρειες','Συντομογραφία :','text',120,25,100,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-11-21 23:02:12','globeadmin','2018-07-29 15:33:30','globeadmin'),('54706f6b65b2110','54a433830716b84',NULL,NULL,'0',10,NULL,'gradebtn',20,50,'Γενικά Στοιχεία Σχολείων',NULL,'html',170,60,220,100,'l','0','0','','0',NULL,NULL,'','54706f6b39c1b38','','','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_letters_id\').src=\'nufileget.php?i=lettersb\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_letters_id\').src=\'nufileget.php?i=letters\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_letters_id\' src=\'nufileget.php?i=letters\' title=\'Τάξεις\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Τάξεις</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',0,0,'0000-00-00 00:00:00','','2015-10-03 20:44:12','globeadmin','2015-12-26 21:06:03','globeadmin'),('547070c92637e94','547070c91793d3b',NULL,NULL,'1',10,NULL,'name',10,10,'Λεπτομέρειες','Όνομα : ','text',45,237,300,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-11-21 22:53:27','globeadmin','2021-09-04 21:36:57','globeadmin'),('547070c92d8aea7','547070c91793d3b',NULL,NULL,'1',10,NULL,'short_name',20,10,'Λεπτομέρειες','Συντομογραφία : ','text',97,187,150,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-11-21 22:53:38','globeadmin','2021-09-04 21:36:57','globeadmin'),('547070c934ddf3b','547070c91793d3b',NULL,NULL,'1',10,NULL,'start_date',60,10,'Λεπτομέρειες','Καταχώριση αξιολόγησης από : ','text',272,99,100,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',100,250,'0000-00-00 00:00:00','','2016-07-24 16:09:30','globeadmin','2021-09-04 21:36:57','globeadmin'),('547070c93c31282','547070c91793d3b',NULL,NULL,'1',10,NULL,'marks_publication_date',80,10,'Λεπτομέρειες','Εμφάνιση αξιολόγησης στους μαθητές : ','text',350,56,100,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',100,250,'0000-00-00 00:00:00','','2018-09-05 18:35:23','globeadmin','2021-09-04 21:36:58','globeadmin'),('54707442b160f04','54707442a2bcae4',NULL,NULL,'1',10,NULL,'name',10,10,'Λεπτομέρειες','Όνομα :','text',60,100,250,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-11-21 20:17:01','globeadmin','2019-11-03 18:24:57','globeadmin'),('54707442b8b619b','54707442a2bcae4',NULL,NULL,'1',10,NULL,'short_name',20,10,'Λεπτομέρειες','Συντομογραφία :','text',97,53,100,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-11-21 20:15:52','globeadmin','2019-11-03 18:24:57','globeadmin'),('54707442c006e09','54707442a2bcae4',NULL,NULL,'1',10,NULL,'start_time',30,10,'Λεπτομέρειες','Ξεκινά στίς :','text',163,76,100,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2014-11-22 17:38:07','globeadmin','2019-11-03 18:24:58','globeadmin'),('54707442c75a0c0','54707442a2bcae4',NULL,NULL,'1',10,NULL,'end_time',40,10,'Λεπτομέρειες','Τελειώνει στις :','text',200,62,100,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-11-05 20:11:12','globeadmin','2019-11-03 18:24:58','globeadmin'),('547078879685ea8','5470788787e004a',NULL,NULL,'1',10,NULL,'name',10,10,'Λεπτομέρειες','Όνομα :','text',60,137,500,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-11-21 22:47:41','globeadmin','2018-08-09 18:08:32','globeadmin'),('547078879dd91d3','5470788787e004a',NULL,NULL,'1',10,NULL,'short_name',20,10,'Λεπτομέρειες','Συντομογραφία :','text',150,87,350,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2018-08-07 15:53:36','globeadmin','2018-08-09 18:08:32','globeadmin'),('54707887a52be29','54a433830716b84',NULL,NULL,'0',10,NULL,'justification_request_reasonbtn',90,50,'Γενικά Στοιχεία Σχολείων','Λόγοι Αίτησης Δικ. Απουσίας','button',370,615,220,50,'l','0','0','','0',NULL,NULL,'','5470788787e004a','','','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',0,0,'0000-00-00 00:00:00','','2015-09-20 00:05:37','globeadmin','2015-12-26 21:06:04','globeadmin'),('54707c862155e40','54707c8612b1b6b',NULL,NULL,'1',10,NULL,'name',10,10,'Λεπτομέρειες','Περιγραφή :','text',60,130,350,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-11-21 22:42:50','globeadmin','2019-11-03 18:57:14','globeadmin'),('54707c8628a8eb8','54707c8612b1b6b',NULL,NULL,'1',10,NULL,'short_name',20,10,'Λεπτομέρειες','Συντομογραφία :','text',124,103,250,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-11-21 22:43:08','globeadmin','2019-11-03 18:57:14','globeadmin'),('54707c862ffbded','54707c8612b1b6b',NULL,NULL,'1',10,NULL,'counts',30,10,'Λεπτομέρειες','Προσμετρείται στις δικαιολογημένες απουσίες :','checkbox',187,170,100,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2014-11-22 14:19:59','globeadmin','2019-11-03 18:57:14','globeadmin'),('54707c86374ef6d','54a433830716b84',NULL,NULL,'0',10,NULL,'justified_reasonbtn',80,50,'Γενικά Στοιχεία Σχολείων','Λόγοι Δικαιολόγησης Απουσίας','button',220,615,220,50,'l','0','0','','0',NULL,NULL,'','54707c8612b1b6b','','','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',0,0,'0000-00-00 00:00:00','','2015-09-20 00:05:27','globeadmin','2015-12-26 21:06:04','globeadmin'),('54708028549ad4a','5470802845f7427',NULL,NULL,'1',10,NULL,'name',10,10,'Λεπτομέρειες','Όνομα :','text',60,70,300,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-11-21 20:24:23','globeadmin','2020-04-02 11:28:35','globeadmin'),('547080285bede94','5470802845f7427',NULL,NULL,'1',10,NULL,'short_name',20,10,'Λεπτομέρειες','Συντομογραφία :','text',120,23,250,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-11-21 20:24:46','globeadmin','2020-04-02 11:28:35','globeadmin'),('547080286340d38','54a433830716b84',NULL,NULL,'0',10,NULL,'school_typebtn',40,50,'Γενικά Στοιχεία Σχολείων','Τύποι Σχολείων','button',70,338,220,50,'l','0','0','','0',NULL,NULL,'','5470802845f7427','','','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',0,0,'0000-00-00 00:00:00','','2015-09-20 00:04:42','globeadmin','2015-12-26 21:06:03','globeadmin'),('547081cec27817f','547081ceb3d2146',NULL,NULL,'1',10,NULL,'name',10,10,'Λεπτομέρειες','Όνομα :','text',35,80,350,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-11-21 20:12:34','globeadmin','2019-11-03 18:27:46','globeadmin'),('547081cec9cb2f3','547081ceb3d2146',NULL,NULL,'1',10,NULL,'short_name',20,10,'Λεπτομέρειες','Συντομογραφία :','text',72,33,250,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-11-21 20:12:34','globeadmin','2019-11-03 18:27:46','globeadmin'),('547081ced11de0a','547081ceb3d2146',NULL,NULL,'1',10,NULL,'start_date',30,10,'Λεπτομέρειες','Ημερομηνία Έναρξης Μαθημάτων :','text',140,20,80,0,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-11-21 20:12:34','globeadmin','2019-11-03 18:27:46','globeadmin'),('547081ced870ee6','547081ceb3d2146',NULL,NULL,'1',10,NULL,'end_date',40,10,'Λεπτομέρειες','Ημερομηνία Λήξης  Μαθημάτων :','text',173,35,80,0,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-11-21 20:12:34','globeadmin','2019-11-03 18:27:46','globeadmin'),('5470b05ba08d16f','5470b05b91e73a0',NULL,NULL,'1',10,NULL,'name',10,10,'Λεπτομέρειες','Όνομα :','text',60,70,350,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-11-21 23:06:21','globeadmin','2018-07-29 15:34:07','globeadmin'),('5470b05ba7e01cc','5470b05b91e73a0',NULL,NULL,'1',10,NULL,'short_name',20,10,'Λεπτομέρειες','Συντομογραφία :','text',120,23,200,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-11-21 23:06:21','globeadmin','2018-07-29 15:34:07','globeadmin'),('5470b05baf330ad','5470b05b91e73a0',NULL,NULL,'1',10,NULL,'abbreviation',30,10,'Λεπτομέρειες','Συντόμευση :','text',180,42,50,0,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-11-21 23:06:21','globeadmin','2018-07-29 15:34:08','globeadmin'),('56c989025d03883','56c989024e5f43c',NULL,NULL,'1',10,NULL,'name',10,10,'Λεπτομέρειες','Όνομα Τύπου Βάθμού :','text',48,81,300,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2016-02-21 12:27:09','globeadmin','2017-08-20 15:48:22','globeadmin'),('56c989026456b54','56c989024e5f43c',NULL,NULL,'1',10,NULL,'is_number',20,10,'Λεπτομέρειες','Αριθμητικές Τιμές :','checkbox',48,662,100,0,'l','0','0','select \'1\'','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2016-02-21 12:36:34','globeadmin','2017-08-20 15:48:22','globeadmin'),('5470b3807bee2f8','5470b3806384141',NULL,NULL,'1',10,NULL,'name',10,10,'Λεπτομέρειες','Όνομα :','text',72,128,450,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-11-21 20:28:42','globeadmin','2018-08-05 11:34:36','globeadmin'),('5470b38083414fc','5470b3806384141',NULL,NULL,'1',10,NULL,'short_name',20,10,'Λεπτομέρειες','Συντομογραφία :','text',149,78,100,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-11-21 20:29:01','globeadmin','2018-08-05 11:34:36','globeadmin'),('5470b3808d0524a','54a433830716b84',NULL,NULL,'0',10,NULL,'teaching_fieldbtn',60,50,'Γενικά Στοιχεία Σχολείων','Ειδικότητες Καθηγητών','button',370,338,220,50,'l','0','0','','0',NULL,NULL,'','5470b3806384141','','','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',0,0,'0000-00-00 00:00:00','','2015-09-20 00:05:05','globeadmin','2015-12-26 21:06:03','globeadmin'),('5470b6d7d6433d3','5470b6d7c79d3b9',NULL,NULL,'1',10,NULL,'name',30,10,'Λεπτομέρειες','Πλήρες Όνομα :','text',183,112,500,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2016-07-11 00:19:33','globeadmin','2022-01-08 15:26:11','globeadmin'),('5470b6d7dd961e5','5470b6d7c79d3b9',NULL,NULL,'1',10,NULL,'short_name',20,10,'Λεπτομέρειες','Συντομογραφία :','text',111,108,120,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-11-21 19:22:48','globeadmin','2022-01-08 15:26:10','globeadmin'),('5470b6d7e4e91d7','5470b6d7c79d3b9',NULL,NULL,'1',10,NULL,'grade_id',10,10,'Λεπτομέρειες','Τάξη :','dropdown',38,170,60,0,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from grade',NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'0000-00-00 00:00:00','','2016-07-11 00:19:33','globeadmin','2022-01-08 15:26:10','globeadmin'),('5470b6d7ec3c0c0','5470b6d7c79d3b9',NULL,NULL,'1',10,NULL,'post_teacher_id',40,10,'Λεπτομέρειες','Καταχωρητής Απουσιών :','dropdown',263,56,200,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id, short_name from teacher order by short_name',NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-11-21 19:23:13','globeadmin','2022-01-08 15:26:11','globeadmin'),('56e2d4da4cfcc74','56dd9f180d22b31',NULL,NULL,'1',10,NULL,'period_disp',20,10,'Διδασκαλία',NULL,'display',24,192,60,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','SELECT period.name\nFROM registered_card\ninner join  card            on card.id          = registered_card.card_id\ninner join  period          on period.id         = card.period_id\nWHERE registered_card.id=\'#RECORD_ID#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2016-03-11 16:23:22','globeadmin','2016-03-11 16:24:17','globeadmin','2022-12-21 12:48:45','globeadmin'),('5470c07915641d8','5470c07906bfd70',NULL,NULL,'1',10,NULL,'name',10,10,'Λεπτομέρειες','Πλήρες Όνομα :','text',34,119,550,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2016-10-22 11:51:25','globeadmin','2018-01-09 15:24:34','globeadmin'),('5470c0791f28252','5470c07906bfd70',NULL,NULL,'1',10,NULL,'short_name',20,10,'Λεπτομέρειες','Όνομα :','text',88,165,400,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2016-10-22 11:51:55','globeadmin','2018-01-09 15:24:34','globeadmin'),('5470c079267b174','5470c07906bfd70',NULL,NULL,'1',10,NULL,'ministry',30,10,'Λεπτομέρειες','Υπουργείο :','text',142,142,550,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2016-10-22 11:52:11','globeadmin','2018-01-09 15:24:34','globeadmin'),('5470c0792dce08b','5470c07906bfd70',NULL,NULL,'1',10,NULL,'region',40,10,'Λεπτομέρειες','Περιφέρεια Εκπ/σης :','text',195,87,550,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2016-10-22 11:52:26','globeadmin','2018-01-09 15:24:34','globeadmin'),('5470c0793521050','5470c07906bfd70',NULL,NULL,'1',10,NULL,'intendancy',50,10,'Λεπτομέρειες','Διεύθυνση Εκπ/σης :','text',249,89,550,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2016-10-22 11:52:40','globeadmin','2018-01-09 15:24:34','globeadmin'),('5470c0793c7407b','5470c07906bfd70',NULL,NULL,'1',10,NULL,'phone1',70,20,'Επικοινωνία','Τηλέφωνο Διευθυντή :','text',53,659,100,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-11-21 19:42:35','globeadmin','2018-01-09 15:24:36','globeadmin'),('5470c07943c71ca','5470c07906bfd70',NULL,NULL,'1',10,NULL,'phone2',80,20,'Επικοινωνία','Τηλέφωνο Γραμματείας :','text',105,645,100,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-11-21 19:34:38','globeadmin','2018-01-09 15:24:36','globeadmin'),('5470c0794b1a038','5470c07906bfd70',NULL,NULL,'1',10,NULL,'fax',90,20,'Επικοινωνία','Fax :','text',157,758,100,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-11-21 19:34:38','globeadmin','2018-01-09 15:24:36','globeadmin'),('5470c079526d1f0','5470c07906bfd70',NULL,NULL,'1',10,NULL,'street',10,20,'Επικοινωνία','Οδός & Αριθμός :','text',53,24,350,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-11-21 19:37:13','globeadmin','2018-01-09 15:24:35','globeadmin'),('5470c07959c01d6','5470c07906bfd70',NULL,NULL,'1',10,NULL,'area',20,20,'Επικοινωνία','Περιοχή :','text',105,70,350,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-11-21 19:37:29','globeadmin','2018-01-09 15:24:35','globeadmin'),('5470c07961130ce','5470c07906bfd70',NULL,NULL,'1',10,NULL,'city',30,20,'Επικοινωνία','Πόλη :','text',157,86,350,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-11-21 19:37:42','globeadmin','2018-01-09 15:24:35','globeadmin'),('5470c07968661da','5470c07906bfd70',NULL,NULL,'1',10,NULL,'zipcode',40,20,'Επικοινωνία','Ταχ. Κώδικας :','text',208,37,100,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-11-21 19:34:38','globeadmin','2018-01-09 15:24:35','globeadmin'),('5470c0796fbab66','5470c07906bfd70',NULL,NULL,'1',10,NULL,'state',50,20,'Επικοινωνία','Πολιτεία :','text',260,70,200,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-11-21 19:38:27','globeadmin','2018-01-09 15:24:35','globeadmin'),('5470c0797719f0c','5470c07906bfd70',NULL,NULL,'1',10,NULL,'country',60,20,'Επικοινωνία','Χώρα :','text',312,82,200,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-11-21 19:38:38','globeadmin','2018-01-09 15:24:35','globeadmin'),('5470c0797e5f663','5470c07906bfd70',NULL,NULL,'1',10,NULL,'email',100,20,'Επικοινωνία','Email :','text',260,547,300,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-11-21 19:39:03','globeadmin','2018-01-09 15:24:36','globeadmin'),('5470c07985b2029','5470c07906bfd70',NULL,NULL,'1',10,NULL,'web_page',110,20,'Επικοινωνία','Ιστοσελίδα Σχολείου :','text',312,463,300,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2018-12-22 10:45:22','globeadmin','2018-12-22 10:45:22','globeadmin'),('5470c0798d05097','5a54c08c836c142',NULL,NULL,'1',10,'select \'0\'','num_days_absence_justification',30,10,'Παράμετροι','Χρονικό όριο σε ημέρες για τη δικαιολόγηση των απουσιών :','text',18,920,40,0,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'0000-00-00 00:00:00','','2018-08-05 12:32:38','globeadmin','2022-09-24 23:21:52','globeadmin'),('5470c079945808a','5470c07906bfd70',NULL,NULL,'1',10,NULL,'school_type_id',60,10,'Λεπτομέρειες','Τύπος Σχολείου :','dropdown',303,113,200,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,name from school_type',NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-11-21 19:34:38','globeadmin','2018-01-09 15:24:34','globeadmin'),('5470c0799bab121','5470c07906bfd70',NULL,NULL,'1',10,NULL,'school_year_id',70,10,'Λεπτομέρειες','Σχολικό Έτος :','display',366,127,200,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select school_year.name \nfrom school_year\ninner join school on school.school_year_id=school_year.id','select id,short_name from school_year',NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-11-21 19:34:38','globeadmin','2018-01-09 15:24:34','globeadmin'),('5470c079a2fe555','5470c07906bfd70',NULL,NULL,'1',10,NULL,'grading_period_id',90,10,'Λεπτομέρειες','Τρέχουσα Περίοδος Αξιολόγησης :','dropdown',421,13,200,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,name from grading_period',NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'0000-00-00 00:00:00','','2016-10-22 11:53:22','globeadmin','2018-01-09 15:24:35','globeadmin'),('569680f84fd9106','547489b0d4efe7c',NULL,NULL,'1',10,NULL,'myschool_name_id',70,10,'Λεπτομέρειες','Όνομα στο mySchool (Beta) : ','dropdown',444,39,500,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,name \nfrom myschool_subject_name \nwhere grade_id=\'#grade_id#\' and id not in (select distinct myschool_name_id from subject where myschool_name_id is not null and myschool_name_id<>\'#myschool_name_id#\')\norder by name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-01-13 18:53:12','globeadmin','2016-03-05 12:00:00','globeadmin','2022-02-14 11:00:18','globeadmin'),('54f73a9e8e97ae6','54f735c7d56625f',NULL,NULL,'1',10,NULL,'absence_iframe',40,10,'Απουσιολόγιο',NULL,'iframe',94,17,900,350,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from class order by short_name',NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2015-03-04 19:02:22','globeadmin','2018-06-26 22:33:21','globeadmin','2022-09-24 23:06:18','globeadmin'),('54f73a31a9747ec','54f735c7d56625f',NULL,NULL,'1',10,NULL,'absence_date',10,10,'Απουσιολόγιο','Ημερομηνία : ','text',33,37,80,40,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from class order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2015-03-04 19:00:33','globeadmin','2016-07-18 00:09:25','globeadmin','2022-09-24 23:06:18','globeadmin'),('5502d9426908d8f','5501db35db0c716',NULL,NULL,'1',10,NULL,'period_absence_timeleft_text',40,10,'Απουσιολόγιο',NULL,'text',16,786,120,40,'c','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-13 14:34:10','globeadmin','2015-03-14 17:19:04','globeadmin','2019-07-02 12:47:12','globeadmin'),('54f73993ba89b87','54f735c7d56625f',NULL,NULL,'1',10,NULL,'absence_class_id',20,10,'Απουσιολόγιο','Τμήμα : ','dropdown',35,219,100,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name \nfrom class where \n(post_teacher_id=#RECORD_ID# OR \n\'#nu_user_group#\'=\'Managers\' OR \n\'#nu_user_group#\'=\'AssistManagers\' OR\n\'#nu_user_group#\'=\'Secretaries\' OR\n\'#nu_user_group#\'=\'Administrators\' OR\n\'#nu_user_group#\'=\'globeadmin\') and\nid in (select distinct class_id from student_class)  \norder by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-04 18:57:55','globeadmin','2016-07-18 00:09:50','globeadmin','2022-09-24 23:06:18','globeadmin'),('54f4b9e39a9c7c1','54df1259eb4def9',NULL,NULL,'1',10,NULL,'student_update',80,10,'Εισαγωγή','Ενημέρωση ΟΛΩΝ των Στοιχείων των Μαθητών :','checkbox',18,655,100,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-02 21:28:35','globeadmin','2016-10-15 19:21:39','globeadmin','2021-09-04 23:32:16','globeadmin'),('54730f662bb0149','54730f661a9b822',NULL,NULL,'1',10,NULL,'name',10,10,'Λεπτομέρειες','Περιγραφή :','text',60,70,250,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-11-21 22:40:45','globeadmin','2016-03-05 14:05:16','globeadmin'),('54730f6633034ec','54730f661a9b822',NULL,NULL,'1',10,NULL,'short_name',20,10,'Λεπτομέρειες','Συντομογραφία :','text',120,45,100,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-11-21 22:41:01','globeadmin','2016-03-05 14:05:16','globeadmin'),('54730f663cc7204','54a433830716b84',NULL,NULL,'0',10,NULL,'absence_reasonbtn',70,50,'Γενικά Στοιχεία Σχολείων','Λόγοι Απουσίας Μαθητή','button',70,615,220,50,'l','0','0','','0',NULL,NULL,'','54730f661a9b822','','','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',0,0,'0000-00-00 00:00:00','','2015-09-20 00:05:16','globeadmin','2015-12-26 21:06:04','globeadmin'),('54736dab52c74e0','54736dab44212c7',NULL,NULL,'1',10,NULL,'name',10,10,'Λεπτομέρειες','Περιγραφή :','text',60,70,150,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-11-21 20:26:21','globeadmin','2018-07-29 15:36:06','globeadmin'),('54736dab5a1a0b0','54736dab44212c7',NULL,NULL,'1',10,NULL,'short_name',20,10,'Λεπτομέρειες','Συντομογραφία :','text',120,45,50,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-11-21 20:26:40','globeadmin','2018-07-29 15:36:06','globeadmin'),('54736dab616cf46','54a433830716b84',NULL,NULL,'0',10,NULL,'subject_typebtn',40,50,'Γενικά Στοιχεία Σχολείων','Τύποι Μαθημάτων','button',220,338,220,50,'l','0','0','','0',NULL,NULL,'','54736dab44212c7','','','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',0,0,'0000-00-00 00:00:00','','2015-09-20 00:04:54','globeadmin','2015-12-26 21:06:03','globeadmin'),('547372d037ec25a','547372d029461f4',NULL,NULL,'1',10,NULL,'short_name',10,10,'Λεπτομέρειες','Συντομογραφία :','text',36,39,200,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-11-21 19:25:57','globeadmin','2021-01-26 20:15:03','globeadmin'),('547372d03f3f055','547372d029461f4',NULL,NULL,'1',10,NULL,'name',40,10,'Λεπτομέρειες','Όνομα :','text',163,85,150,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-11-21 19:25:57','globeadmin','2021-01-26 20:15:03','globeadmin'),('547372d04692234','547372d029461f4',NULL,NULL,'1',10,NULL,'surname',30,10,'Λεπτομέρειες','Επώνυμο :','text',113,69,200,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-11-21 19:25:57','globeadmin','2021-01-26 20:15:03','globeadmin'),('547372d04de4ef0','547372d029461f4',NULL,NULL,'1',10,NULL,'gender',60,10,'Λεπτομέρειες','Φύλο :','dropdown',263,93,100,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'Α|ΑΝΔΡΑΣ|Θ|ΓΥΝΑΙΚΑ',NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-11-21 19:25:57','globeadmin','2021-01-26 20:15:03','globeadmin'),('547372d05537ee7','547372d029461f4',NULL,NULL,'1',10,NULL,'fathers_name',50,10,'Λεπτομέρειες','Όνομα Πατρός :','text',213,39,150,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-11-21 19:25:57','globeadmin','2021-01-26 20:15:03','globeadmin'),('547372d05c8ae70','547372d029461f4',NULL,NULL,'1',10,NULL,'email',80,10,'Λεπτομέρειες','Email :','text',426,91,250,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-11-21 19:25:57','globeadmin','2021-01-26 20:15:03','globeadmin'),('547372d063ddfb0','547372d029461f4',NULL,NULL,'1',10,NULL,'web_page',90,10,'Λεπτομέρειες','Ιστοσελίδα :','text',537,62,380,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2020-03-29 19:10:02','globeadmin','2021-01-26 20:15:03','globeadmin'),('547372d06b30e11','547372d029461f4',NULL,NULL,'1',10,NULL,'teaching_field_id',70,10,'Λεπτομέρειες','Ειδικότητα :','dropdown',345,62,250,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,CONCAT(ifNULL(short_name,\'\'),\' - \',ifNULL(name,\'\'))  \nfrom teaching_field\norder by short_name',NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'0000-00-00 00:00:00','','2018-08-04 10:13:11','globeadmin','2021-01-26 20:15:03','globeadmin'),('547372d07283e67','547372d029461f4',NULL,NULL,'1',10,'select if(  \'#nu_user_group#\'=\'globeadmin\' or \n            \'#nu_user_group#\'=\'Administrators\' or \n            \'#nu_user_group#\'=\'Managers\',\'1\',\'0\')','user_id',20,10,'Λεπτομέρειες','Όνομα Χρήστη :','dropdown',34,571,150,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select \n	zzzsys_user_id,\n	sus_login_name \nfrom zzzsys_user \n	where \n	zzzsys_user_id not in (select user_id from teacher where id<>\'#RECORD_ID#\' and user_id is not NULL) and\n	sus_zzzsys_user_group_id in (select zzzsys_user_group_id from zzzsys_user_group where sug_code not in (\'Students\',\'Parents\'))',NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2016-04-27 13:38:08','globeadmin','2021-01-26 20:15:03','globeadmin'),('547489b0eae7207','547489b0d4efe7c',NULL,NULL,'1',10,NULL,'name',20,10,'Λεπτομέρειες','Όνομα : ','text',152,162,500,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2016-01-13 18:59:07','globeadmin','2022-02-14 11:00:18','globeadmin'),('547489b0f23a1cf','547489b0d4efe7c',NULL,NULL,'1',10,NULL,'short_name',10,10,'Λεπτομέρειες','Συντομογραφία : ','text',104,112,250,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2016-01-13 18:59:07','globeadmin','2022-02-14 11:00:18','globeadmin'),('547489b105691f2','547489b0d4efe7c',NULL,NULL,'1',10,NULL,'is_marked',60,10,'Λεπτομέρειες','Βαθμολογείται : ','checkbox',342,119,60,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'1|Ναί|0|Όχι',NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2019-11-03 14:26:02','globeadmin','2022-02-14 11:00:18','globeadmin'),('547489b10cbca1a','547489b0d4efe7c',NULL,NULL,'1',10,NULL,'subject_type_id',30,10,'Λεπτομέρειες','Τύπος Μαθήματος : ','dropdown',199,92,100,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,name from subject_type',NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'0000-00-00 00:00:00','','2016-01-13 18:59:07','globeadmin','2022-02-14 11:00:18','globeadmin'),('547489b1140f175','547489b0d4efe7c',NULL,NULL,'1',10,NULL,'grade_id',50,10,'Λεπτομέρειες','Τάξη : ','dropdown',294,174,50,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from grade',NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'0000-00-00 00:00:00','','2016-01-13 18:59:07','globeadmin','2022-02-14 11:00:18','globeadmin'),('547489b11b62147','547489b0d4efe7c',NULL,NULL,'1',10,NULL,'speciality_id',40,10,'Λεπτομέρειες','Κατεύθυνση / Ειδικότητα : ','dropdown',247,60,400,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id, name from speciality\norder by section_id DESC,name',NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'0000-00-00 00:00:00','','2016-09-28 10:24:03','globeadmin','2022-02-14 11:00:18','globeadmin'),('5474b573893f49c','547489b0d4efe7c',NULL,NULL,'1',10,NULL,'xxx',90,10,'Λεπτομέρειες','Σύνολο Ωρών Διδασκαλίας : ','display',57,654,60,0,'c','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select count(distinct subject_id,day_id,period_id,classroom_id) \nfrom card \nwhere card.valid_from =(select max(timetable.start_date) from timetable where (timetable.start_date <= curdate()))   \nand subject_id=\'#RECORD_ID#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-11-25 18:59:31','globeadmin','2020-09-21 11:45:15','globeadmin','2022-02-14 11:00:18','globeadmin'),('5548d53a6a578fa','54f735c7d56625f',NULL,NULL,'1',10,NULL,'next_class',30,10,'Απουσιολόγιο',NULL,'html',32,378,32,32,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<html><body><img title=\'Επόμενο Τμήμα\' width=32 height=32 id=\'img_next_id\' src=\'images/next.png\'/></body></html>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-05-05 17:35:38','globeadmin','2015-12-26 21:22:14','globeadmin','2022-09-24 23:06:18','globeadmin'),('5474c4eed00db7d','5474c1d7bef6b64',NULL,NULL,'1',10,NULL,'name',10,10,'Λεπτομέρειες','Όνομα','text',70,126,500,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2014-11-25 20:05:34','globeadmin','2014-11-25 20:05:34','globeadmin','2016-01-04 10:17:02','globeadmin'),('5474c51f7829f91','5474c1d7bef6b64',NULL,NULL,'1',10,NULL,'short_name',20,10,'Λεπτομέρειες','Συντομογραφία','text',112,76,250,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2014-11-25 20:06:23','globeadmin','2014-11-25 20:06:23','globeadmin','2016-01-04 10:17:02','globeadmin'),('5474c52defcad41','5474c1d7bef6b64',NULL,NULL,'1',10,NULL,'speciality_id',30,10,'Λεπτομέρειες','Κατηγορία / Ειδικότητα','dropdown',155,31,400,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id, name from speciality',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2014-11-25 20:06:38','globeadmin','2014-11-25 20:06:38','globeadmin','2016-01-04 10:17:02','globeadmin'),('5474c53d2a09ded','5474c1d7bef6b64',NULL,NULL,'1',10,NULL,'grade_id',40,10,'Λεπτομέρειες','Τάξη','dropdown',201,136,50,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from grade',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2014-11-25 20:06:53','globeadmin','2014-11-25 20:06:53','globeadmin','2016-01-04 10:17:02','globeadmin'),('5474c54b8e2111e','5474c1d7bef6b64',NULL,NULL,'1',10,NULL,'subject_type_id',50,10,'Λεπτομέρειες','Τύπος Μαθήματος','dropdown',248,58,100,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,name from subject_type',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2014-11-25 20:07:07','globeadmin','2014-11-25 20:07:07','globeadmin','2016-01-04 10:17:02','globeadmin'),('5474c55be395d86','5474c1d7bef6b64',NULL,NULL,'1',10,NULL,'is_marked',60,10,'Λεπτομέρειες','Βαθμολογείται','dropdown',294,81,60,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'1|Ναί|0|Όχι',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2014-11-25 20:07:23','globeadmin','2014-11-25 20:07:23','globeadmin','2016-01-04 10:17:02','globeadmin'),('5474c56adeb3c01','5474c1d7bef6b64',NULL,NULL,'1',10,NULL,'xxx',70,10,'Λεπτομέρειες','Σύνολο Ωρών Διδασκαλίας','display',295,389,60,0,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select count(distinct subject_id,day_id,period_id,classroom_id) \nfrom card \nwhere card.valid_from =(select max(timetable.start_date) from timetable where (timetable.start_date <= curdate()))   \nand subject_id=\'#RECORD_ID#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-11-25 20:07:38','globeadmin','2016-01-04 10:21:55','globeadmin','2016-01-04 10:21:55','globeadmin'),('578674c94314417','56192b05ed5032f',NULL,NULL,'0',10,'select if(  \'#nu_user_group#\'=\'globeadmin\' or \n            \'#nu_user_group#\'=\'Administrators\' or \n            \'#nu_user_group#\'=\'Managers\',\'1\',\'0\')','clear_tmpbtn',60,20,'Σύστημα',NULL,'html',192,687,220,100,'l','0','0','','0',NULL,NULL,'1','54a52c3dcf3610b',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'clear_tmp_id\').src=\'images/clear_tmpb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'clear_tmp_id\').src=\'images/clear_tmp.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'clear_tmp_id\' src=\'images/clear_tmp.png\' title=\'Εκκαθάριση Προσωρινών Αρχείων (φάκελος tmp στον εξυπηρετητή)\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Εκκαθάριση Προσωρινών Αρχείων</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-07-13 20:05:13','globeadmin','2018-02-04 20:28:58','globeadmin','2019-07-25 10:13:35','globeadmin'),('5475b35dd75f17b','5476201e5a3d38f',NULL,NULL,'1',10,NULL,'registration_number',10,10,'Στοιχεία Μαθητή','Αριθμός Μητρώου :','text',36,76,60,0,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-10-04 20:02:54','globeadmin','2022-01-08 11:22:25','globeadmin'),('5475b35ddeb21df','5476201e5a3d38f',NULL,NULL,'1',10,NULL,'surname',20,10,'Στοιχεία Μαθητή','Επώνυμο :','text',82,127,300,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-10-04 20:10:49','globeadmin','2022-01-08 11:22:25','globeadmin'),('5475b35de605049','5476201e5a3d38f',NULL,NULL,'1',10,NULL,'name',30,10,'Στοιχεία Μαθητή','Όνομα :','text',129,143,300,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-10-04 20:11:22','globeadmin','2022-01-08 11:22:25','globeadmin'),('5475b35ded580a1','5476201e5a3d38f',NULL,NULL,'1',10,NULL,'fathers_name',40,10,'Στοιχεία Μαθητή','Όνομα Πατρός :','text',175,97,300,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-10-04 20:11:49','globeadmin','2022-01-08 11:22:25','globeadmin'),('5475b35e008706a','5476201e5a3d38f',NULL,NULL,'1',10,NULL,'mothers_name',50,10,'Στοιχεία Μαθητή','Όνομα Μητρός :','text',222,95,300,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-10-04 20:11:44','globeadmin','2022-01-08 11:22:25','globeadmin'),('5475b35e07da029','5476201e5a3d38f',NULL,NULL,'1',10,NULL,'gender',70,10,'Στοιχεία Μαθητή','Φύλο :','dropdown',315,151,100,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select if(\'#gender#\'=\'Α\',\'ΑΓΟΡΙ\',\'ΚΟΡΙΤΣΙ\')','Α|ΑΓΟΡΙ|Θ|ΚΟΡΙΤΣΙ',NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-10-04 20:35:30','globeadmin','2022-01-08 11:22:26','globeadmin'),('5475b35e1684751','5476201e5a3d38f',NULL,NULL,'1',10,NULL,'phone1',50,20,'Στοιχεία Επικοινωνίας','Τηλέφωνο 1 :','text',417,62,150,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2018-08-06 21:51:26','globeadmin','2022-01-08 11:22:27','globeadmin'),('5475b35e1dd3f5a','5476201e5a3d38f',NULL,NULL,'1',10,NULL,'phone2',60,20,'Στοιχεία Επικοινωνίας','Τηλέφωνο 2 :','text',464,62,150,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2018-08-06 21:51:44','globeadmin','2022-01-08 11:22:27','globeadmin'),('5475b35e25393a4','5476201e5a3d38f',NULL,NULL,'1',10,NULL,'mobile',70,20,'Στοιχεία Επικοινωνίας','Κινητό :','text',511,95,150,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2018-08-06 21:52:02','globeadmin','2022-01-08 11:22:27','globeadmin'),('5475b35e2c7940b','5476201e5a3d38f',NULL,NULL,'1',10,NULL,'email',80,20,'Στοιχεία Επικοινωνίας','Email :','text',599,99,250,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-11-21 19:14:59','globeadmin','2022-01-08 11:22:27','globeadmin'),('5475b35e33df380','5476201e5a3d38f',NULL,NULL,'1',10,NULL,'street',10,20,'Στοιχεία Επικοινωνίας','Οδός - Αριθμός :','text',197,45,300,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-11-21 19:14:59','globeadmin','2022-01-08 11:22:27','globeadmin'),('5475b35e3b1f05e','5476201e5a3d38f',NULL,NULL,'1',10,NULL,'area',20,20,'Στοιχεία Επικοινωνίας','Περιοχή :','text',247,86,250,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-11-21 19:14:59','globeadmin','2022-01-08 11:22:27','globeadmin'),('5475b35e4272485','5476201e5a3d38f',NULL,NULL,'1',10,NULL,'zipcode',40,20,'Στοιχεία Επικοινωνίας','Τ.Κ. :','text',346,109,80,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-11-21 19:14:59','globeadmin','2022-01-08 11:22:27','globeadmin'),('5475b35e49c5333','5476201e5a3d38f',NULL,NULL,'1',10,NULL,'city',30,20,'Στοιχεία Επικοινωνίας','Πόλη :','text',296,102,250,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-11-21 19:14:59','globeadmin','2022-01-08 11:22:27','globeadmin'),('5475b35e511f686','5476201e5a3d38f',NULL,NULL,'1',10,NULL,'speciality_id',130,10,'Στοιχεία Μαθητή','Ειδικότητα :','dropdown',177,650,300,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select short_name \nfrom speciality\nwhere id=\'#speciality_id#\'','select id,name from speciality',NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'0000-00-00 00:00:00','','2016-07-22 00:12:31','globeadmin','2022-01-08 11:22:26','globeadmin'),('5475b35e586b177','5476201e5a3d38f',NULL,NULL,'1',10,NULL,'grade_id',140,10,'Στοιχεία Μαθητή','Τάξη :','dropdown',131,682,80,0,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select short_name \nfrom grade\nwhere id=\'#grade_id#\'','select id,short_name from grade',NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'0000-00-00 00:00:00','','2016-07-22 00:12:31','globeadmin','2022-01-08 11:22:26','globeadmin'),('5475b35e5fbe08a','5476201e5a3d38f',NULL,NULL,'1',10,NULL,'teacher_id',150,10,'Στοιχεία Μαθητή','Υπεύθυνος Καθηγητής :','dropdown',270,578,250,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select concat(if(surname is null,\'\',concat(surname,\' \')), IFNULL(name,\'\')) from teacher where id=\'#teacher_id#\'','select  id,\n        concat(if(surname is null,\'\',concat(surname,\' \')), IFNULL(name,\'\')) as teacher_full_name\nfrom teacher\norder by teacher_full_name',NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'0000-00-00 00:00:00','','2016-07-22 00:12:31','globeadmin','2022-01-08 11:22:26','globeadmin'),('5475b35e6724244','5476201e5a3d38f',NULL,NULL,'1',10,NULL,'user_id',90,10,'Στοιχεία Μαθητή','Όνομα Χρήστη Μαθητή :','dropdown',463,47,150,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select \n	zzzsys_user_id,\n	sus_login_name \nfrom zzzsys_user \nwhere \n	zzzsys_user_id not in (select user_id from student where id<>\'#RECORD_ID#\' and user_id is not NULL) and\n	sus_zzzsys_user_group_id in (select zzzsys_user_group_id from zzzsys_user_group where sug_code=\'Students\')',NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2016-07-22 00:12:31','globeadmin','2022-01-08 11:22:26','globeadmin'),('5475b35e7d0a0c9','5476201e5a3d38f',NULL,NULL,'1',10,NULL,'has_left_school',160,10,'Στοιχεία Μαθητή','Έχει Εγκαταλείψει το Σχολείο :','dropdown',38,542,60,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'1|ΝΑΙ|0|ΟΧΙ',NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2016-07-22 00:12:31','globeadmin','2022-01-08 11:22:26','globeadmin'),('5475b35e845d106','5476201e5a3d38f',NULL,NULL,'1',10,NULL,'parent_surname',140,20,'Στοιχεία Επικοινωνίας','Επώνυμο Κηδεμόνα :','text',43,54,250,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2018-08-05 23:22:49','globeadmin','2022-01-08 11:22:27','globeadmin'),('5475b35e8bb0242','5476201e5a3d38f',NULL,NULL,'1',10,NULL,'parent_name',150,20,'Στοιχεία Επικοινωνίας','Όνομα  Κηδεμόνα :','text',43,476,250,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2018-08-05 23:23:07','globeadmin','2022-01-08 11:22:27','globeadmin'),('5475b35e9303132','5476201e5a3d38f',NULL,NULL,'1',10,NULL,'parent_phone1',190,20,'Στοιχεία Επικοινωνίας','Τηλέφωνο 1 :','text',417,583,150,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2018-08-06 21:54:37','globeadmin','2022-01-08 11:22:28','globeadmin'),('5475b35e9a560f4','5476201e5a3d38f',NULL,NULL,'1',10,NULL,'parent_phone2',200,20,'Στοιχεία Επικοινωνίας','Τηλέφωνο 2 :','text',464,583,150,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2018-08-06 21:54:53','globeadmin','2022-01-08 11:22:28','globeadmin'),('5475b35ea1a916c','5476201e5a3d38f',NULL,NULL,'1',10,NULL,'parent_phone3',210,20,'Στοιχεία Επικοινωνίας','Τηλέφωνο 3 :','text',511,583,150,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2018-08-06 21:55:09','globeadmin','2022-01-08 11:22:28','globeadmin'),('5475b35ea8fc157','5476201e5a3d38f',NULL,NULL,'1',10,NULL,'parent_street',160,20,'Στοιχεία Επικοινωνίας','Οδός - Αριθμός :','text',197,564,300,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2018-08-05 23:27:47','globeadmin','2022-01-08 11:22:28','globeadmin'),('5475b35eb04ef78','5476201e5a3d38f',NULL,NULL,'1',10,NULL,'parent_area',170,20,'Στοιχεία Επικοινωνίας','Περιοχή :','text',247,607,250,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2018-08-05 23:07:18','globeadmin','2022-01-08 11:22:28','globeadmin'),('5475b35eb7a2103','5476201e5a3d38f',NULL,NULL,'1',10,NULL,'parent_zipcode',180,20,'Στοιχεία Επικοινωνίας','Τ.Κ. :','text',346,631,100,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2018-08-05 23:07:54','globeadmin','2022-01-08 11:22:28','globeadmin'),('5475b35ebef5092','5476201e5a3d38f',NULL,NULL,'1',10,NULL,'parent_email',220,20,'Στοιχεία Επικοινωνίας','Πρωτεύον Email :','text',599,558,250,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2021-09-04 21:51:11','globeadmin','2022-01-08 11:22:28','globeadmin'),('5688351e428b301','568834bf97fe8a1',NULL,NULL,'1',10,NULL,'label1',10,10,'Κλωνοποίηση Ωρολογίου Προγράμματος','Προσοχή : Η ημερομηνία έναρξής του νέου ωρολογίου πρέπει να είναι μεταγενέστερη της σημερινής!','words',85,5,650,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-01-02 22:37:50','globeadmin','2016-01-03 10:50:41','globeadmin','2016-05-25 13:32:54','globeadmin'),('54ce7f01b499546','54ce7f0188a78ec',NULL,NULL,'1',10,NULL,'section_id',40,10,'Λεπτομέρειες','Τομέας :','dropdown',240,69,200,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from section',NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-11-21 23:11:04','globeadmin','2018-07-29 15:35:20','globeadmin'),('54ce7f01aae02db','54ce7f0188a78ec',NULL,NULL,'1',10,NULL,'abbreviation',30,10,'Λεπτομέρειες','Συντομογραφία :','text',180,23,60,0,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-11-21 23:11:04','globeadmin','2018-07-29 15:35:20','globeadmin'),('54ce7f01a3825c4','54ce7f0188a78ec',NULL,NULL,'1',10,NULL,'short_name',20,10,'Λεπτομέρειες','Σύντομο Όνομα :','text',120,21,400,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-11-21 23:11:04','globeadmin','2018-07-29 15:35:20','globeadmin'),('54ce7f019c2f755','54ce7f0188a78ec',NULL,NULL,'1',10,NULL,'name',10,10,'Λεπτομέρειες','Όνομα :','text',60,70,600,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-11-21 23:11:04','globeadmin','2018-07-29 15:35:20','globeadmin'),('548338077feceb6','59d7d65650da67c',NULL,NULL,'1',10,NULL,'email',60,10,'Προσωπικά Στοιχεία','Email :','text',267,108,300,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2017-10-06 22:47:38','globeadmin','2018-07-28 00:38:24','globeadmin'),('547d7913abe8da3','547d6ec60ac6bdd',NULL,NULL,'1',10,NULL,'granding_period',30,10,'Καταχώριση Βαθμολογίας','Βαθμολογική Περίοδος : ','display',18,16,150,80,'c','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','SELECT grading_period.name \nFROM session_variables,grading_period \nWHERE \n    session_variables.grading_period_id=grading_period.id and\n    session_variables.session_id=\'#session_id#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2014-12-02 10:32:19','globeadmin','2015-01-11 21:51:53','globeadmin','2021-03-24 11:12:35','globeadmin'),('547cce2dae59a60','5476201e5a3d38f',NULL,NULL,'1',10,NULL,'student_class',180,10,'Στοιχεία Μαθητή',NULL,'iframe',408,531,460,240,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'547cce2020be0b5','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-12-01 22:23:09','globeadmin','2018-08-05 22:51:53','globeadmin','2022-01-08 11:22:26','globeadmin'),('547d6e656ede283','59d7d7986aed52d',NULL,NULL,'0',10,'SELECT if(count(grading_period.id)>0,\'1\',\'0\')\nFROM school\n    left join grading_period ON school.grading_period_id=grading_period.id\nWHERE \n    CURDATE() between grading_period.start_date AND grading_period.end_date ','reg_markbtn',30,10,'Αξιολόγηση Μαθητών και Ποινές',NULL,'html',80,687,220,100,'l','0','0','','0',NULL,NULL,'#RECORD_ID# ','562362d2ef4f556',NULL,'','',NULL,NULL,'<table border=0 align=\"center\" CELLSPACING=0 CELLPADDING=0 width=\"100%\" \n                            onmouseover=\"document.getElementById(\'img_mpost_id\').src=\'images/mpostb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_mpost_id\').src=\'images/mpost.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\"center\">\n            <img width=98 height=74 id=\'img_mpost_id\' src=\'images/mpost.png\' title=\'Καταχώριση Αξιολόγησης\'/>    	\n        </td>\n    </tr>\n    <tr>\n        <td align=\"center\">\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Καταχώριση Αξιολόγησης</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-12-02 09:46:45','globeadmin','2017-10-07 01:07:46','globeadmin','2022-01-08 10:58:25','globeadmin'),('547d746016fa2bd','547d6ec60ac6bdd',NULL,NULL,'1',10,NULL,'class_subject_selection',20,10,'Καταχώριση Βαθμολογίας','Τμήμα-Μάθημα : ','dropdown',51,57,350,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'SELECT distinct CONCAT(class_id,\',\',subject_id), CONCAT(class_short,\' - \',subject_name,\' (\',subject_type_name,\')\')\nFROM \n(SELECT \n	active_card.id 				AS id,\n	active_card.valid_from 		AS valid_from,\n	active_card.subject_id 		AS subject_id,\n	active_card.teacher_id 		AS teacher_id,\n	active_card.class_id 		AS class_id,\n	active_card.classroom_id 	AS classroom_id,\n	active_card.day_id 			AS day_id,\n	active_card.period_id 		AS period_id,\n	teacher.short_name 			AS teacher_short,\n	teacher.surname 			AS teacher_surname,\n	teacher.name 				AS teacher_name,\n	day.name 					AS day_name,\n	day.short_name 				AS day_short,\n	period.short_name 			AS period_short,\n	period.name 				AS period_name,\n	class.short_name 			AS class_short,\n	class.name 					AS class_name,\n	subject.short_name 			AS subject_short,\n	subject.name 				AS subject_name,\n	subject.is_marked 			AS subject_is_marked,\n	subject_type.short_name 	AS subject_type_short,\n	subject_type.name 			AS subject_type_name,\n	classroom.short_name 		AS classroom_short,\n	classroom.name 				AS classroom_name,\n	teacher.email 				AS teacher_email,\n	teacher.user_id 			AS teacher_user_id \nFROM \n	(SELECT \n		card.id 			AS id,\n		card.valid_from 	AS valid_from,\n		card.subject_id 	AS subject_id,\n		card.teacher_id 	AS teacher_id,\n		card.class_id 		AS class_id,\n		card.classroom_id 	AS classroom_id,\n		card.day_id 		AS day_id,\n		card.period_id 		AS period_id \n	FROM card \n	WHERE card.valid_from =\n		(	SELECT max(timetable.start_date) \n			FROM timetable \n			WHERE (timetable.start_date <= curdate()))) as active_card \n	inner join subject 			on active_card.subject_id = subject.id \n	inner join teacher 			on active_card.teacher_id = teacher.id  \n	inner join day 				on active_card.day_id = day.id  \n	inner join period 			on active_card.period_id = period.id\n	inner join class 			on active_card.class_id = class.id	\n	left  join subject_type 	on subject.subject_type_id = subject_type.id  \n	left  join classroom 		on active_card.classroom_id = classroom.id  \nORDER BY \n	active_card.teacher_id,\n	active_card.day_id,\n	active_card.period_id\n) as active_card_full\nWHERE teacher_id=\'#RECORD_ID#\' and subject_is_marked\nORDER BY class_short,subject_name\n',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2014-12-02 10:12:16','globeadmin','2016-01-04 10:31:23','globeadmin','2021-03-24 11:12:35','globeadmin'),('54778399a6a6f0a','5476201e5a3d38f',NULL,NULL,'1',10,NULL,'std_lesson',10,40,'Διδασκαλίες',NULL,'iframe',27,29,970,460,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'5477806364bbd3b','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-11-27 22:03:37','globeadmin','2015-12-29 10:29:35','globeadmin','2022-01-08 11:22:28','globeadmin'),('5478c8593201d58','5478c7e75911cd4',NULL,NULL,'1',10,NULL,'sfi_code',10,10,'Αρχεία','Code','text',39,58,150,25,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-11-28 21:09:13','globeadmin','2014-11-28 21:09:13','globeadmin','2015-02-15 12:52:47','globeadmin'),('5478ce1d988b51b','5478c7e75911cd4',NULL,NULL,'1',10,NULL,'sfi_group',20,10,'Αρχεία','Group','text',60,52,150,25,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-11-28 21:33:49','globeadmin','2014-11-28 21:33:49','globeadmin','2015-02-15 12:52:47','globeadmin'),('54846ba198eebe5','59d7d65650da67c',NULL,NULL,'1',10,NULL,'gender',40,10,'Προσωπικά Στοιχεία','Φύλο :','dropdown',174,110,100,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'Α|ΑΝΔΡΑΣ|Θ|ΓΥΝΑΙΚΑ',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2014-12-07 17:00:49','globeadmin','2017-10-06 22:47:06','globeadmin','2018-07-28 00:38:24','globeadmin'),('54833807789a11d','59d7d65650da67c',NULL,NULL,'1',10,NULL,'fathers_name',30,10,'Προσωπικά Στοιχεία','Όνομα Πατρός :','text',132,57,300,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2017-10-06 22:46:51','globeadmin','2018-07-28 00:38:24','globeadmin'),('5478ce53a24f542','5478c7e75911cd4',NULL,NULL,'1',10,NULL,'sfi_description',30,10,'Αρχεία','Descripion','text',81,26,150,25,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-11-28 21:34:43','globeadmin','2014-11-28 21:34:43','globeadmin','2015-02-15 12:52:47','globeadmin'),('5478cefba4c0447','5478c7e75911cd4',NULL,NULL,'1',10,NULL,'ifile',40,10,'Αρχεία',NULL,'iframe',29,289,300,95,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'54da24749d82eb7','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-11-28 21:37:31','globeadmin','2015-02-10 17:43:35','globeadmin','2015-02-15 12:52:47','globeadmin'),('547cc4c5dcbcc66','5476201e5a3d38f',NULL,NULL,'1',10,NULL,'student_program',10,50,'Ωρολόγιο Πρόγραμμα',NULL,'iframe',24,14,1000,700,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'5a9d96938c5959e','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-12-01 21:43:01','globeadmin','2018-08-05 22:42:27','globeadmin','2022-01-08 11:22:28','globeadmin'),('5483380769f3dd8','59d7d65650da67c',NULL,NULL,'1',10,NULL,'surname',10,10,'Προσωπικά Στοιχεία','Επώνυμο :','text',47,84,300,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2017-10-06 22:46:21','globeadmin','2018-07-28 00:38:23','globeadmin'),('548338077146d4d','59d7d65650da67c',NULL,NULL,'1',10,NULL,'name',20,10,'Προσωπικά Στοιχεία','Όνομα :','text',89,101,300,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2017-10-06 22:46:36','globeadmin','2018-07-28 00:38:24','globeadmin'),('548d79dc97cdd70','54a433830716b84',NULL,NULL,'0',10,NULL,'admin_usersbtn',70,40,'Εργασίες Διαχείρισης',NULL,'html',50,615,220,100,'l','0','0','','0',NULL,NULL,NULL,'nuuser',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_useracc_id\').src=\'images/useraccb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_useracc_id\').src=\'images/useracc.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=98 height=74 id=\'img_useracc_id\' src=\'images/useracc.png\' title=\'Λογαριασμοί Χρηστών\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Λογαριασμοί Χρηστών</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-12-14 13:51:56','globeadmin','2015-12-26 21:02:32','globeadmin','2015-12-26 21:06:03','globeadmin'),('5484135519a5d3c','54835ec50abe722',NULL,NULL,'1',10,NULL,'user_not_found_msg2',20,10,'Αρχική',NULL,'text',355,159,0,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2014-12-07 10:44:05','globeadmin','2015-05-08 23:36:20','globeadmin','2021-03-24 11:23:59','globeadmin'),('54809cf7134817b','547d6ec60ac6bdd','',NULL,'1',10,NULL,'mark_subform',10,10,'Καταχώριση Βαθμολογίας',NULL,'subform',72,34,1050,800,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,25,'0','0','post_teacher_id','id','SELECT \n    mark.*, \n    student.registration_number as student_registration_number,\n    student.surname as student_surname,\n    student.name as student_name,\n    student.fathers_name as student_fathers_name\nFROM mark,session_variables,student_class,student\nwhere \n    mark.grading_period_id=session_variables.grading_period_id and \n    mark.subject_id=session_variables.subject_id and\n    student_class.class_id = session_variables.class_id and\n    session_variables.session_id=\'#session_id#\' and\n    mark.student_id=student_class.student_id and\n    student_class.student_id=student.id','mark',NULL,'',NULL,'g',0,0,'0000-00-00 00:00:00','','2015-06-01 10:37:05','globeadmin','2021-03-24 11:12:35','globeadmin'),('548c39cbadb3fe8','54809cf7134817b',NULL,NULL,'1',10,NULL,'student_surname',20,10,'Details','Επώνυμο','display',0,0,160,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select student_surname from mark_#nu_user_id#_#session_id# where id=#SUBFORM_RECORD_ID#',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-12-13 15:06:19','globeadmin','2014-12-16 19:12:59','globeadmin','2015-10-04 14:46:52','globeadmin'),('548c39cbb9e525d','54809cf7134817b',NULL,NULL,'1',10,NULL,'student_name',30,10,'Details','Όνομα','display',0,0,140,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select student_name from mark_#nu_user_id#_#session_id# where id=#SUBFORM_RECORD_ID#',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-12-13 15:06:19','globeadmin','2014-12-16 19:13:34','globeadmin','2015-10-04 14:46:52','globeadmin'),('548c39cbc61b668','54809cf7134817b',NULL,NULL,'1',10,NULL,'student_fathers_name',40,10,'Details','Πατρώνυμο','display',0,0,130,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select student_fathers_name from mark_#nu_user_id#_#session_id# where id=#SUBFORM_RECORD_ID#',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-12-13 15:06:19','globeadmin','2014-12-16 19:11:05','globeadmin','2015-10-04 14:47:21','globeadmin'),('548c39cbd4bfd5e','54809cf7134817b',NULL,NULL,'1',10,NULL,'value',50,10,'Details','Βαθμός','text',0,0,65,0,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'27','',NULL,'',0,0,'2014-12-13 15:06:19','globeadmin','2014-12-15 22:21:52','globeadmin','2015-10-04 14:46:52','globeadmin'),('54833807873fc0b','59d7d65650da67c',NULL,NULL,'1',10,NULL,'web_page',70,10,'Προσωπικά Στοιχεία','Ιστοσελίδα :','text',309,80,380,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2020-11-08 19:41:17','globeadmin','2020-11-08 19:41:17','globeadmin'),('5483602a5dbed1c','54835ec50abe722',NULL,NULL,'1',10,NULL,'user_not_found_msg1',10,10,'Αρχική',NULL,'text',323,159,0,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2014-12-06 21:59:38','globeadmin','2015-05-08 23:36:11','globeadmin','2021-03-24 11:23:59','globeadmin'),('54846bbee710467','59d7d65650da67c',NULL,NULL,'1',10,NULL,'teaching_field_id',50,10,'Προσωπικά Στοιχεία','Ειδικότητα :','dropdown',220,79,300,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,CONCAT(ifNULL(short_name,\'\'),\' - \',ifNULL(name,\'\'))  \nfrom teaching_field\norder by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2014-12-07 17:01:18','globeadmin','2018-08-04 10:13:47','globeadmin','2018-08-04 10:13:47','globeadmin'),('56c989026ba9c25','56c989024e5f43c',NULL,NULL,'1',10,NULL,'start_value',30,10,'Λεπτομέρειες','Τιμές Από : ','text',117,237,40,0,'r','0','0','select \'0\'','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'0000-00-00 00:00:00','','2016-02-21 12:37:00','globeadmin','2017-08-20 15:48:22','globeadmin'),('5484bccc60f0bf7','54835ec50abe722',NULL,NULL,'1',10,NULL,'welcom',30,10,'Αρχική',NULL,'html',120,220,500,150,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<img id=\'img_mySIS_welc_id\' src=\'images/mySIS_welc.png\'/> ','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2014-12-07 22:47:08','globeadmin','2015-12-26 20:42:44','globeadmin','2021-03-24 11:23:59','globeadmin'),('548c39cba17c60b','54809cf7134817b',NULL,NULL,'1',10,NULL,'student_registration_number',10,10,'Details','Α.Μ.','display',0,0,60,0,'c','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select student_registration_number from mark_#nu_user_id#_#session_id# where id=#SUBFORM_RECORD_ID#',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-12-13 15:06:19','globeadmin','2014-12-16 19:04:25','globeadmin','2015-10-04 14:46:52','globeadmin'),('548f40a38676c12','54809cf7134817b',NULL,NULL,'1',10,NULL,'added_when',60,10,'Details','Τελευταία Τροποποίηση','text',0,0,130,0,'r','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-12-15 22:12:19','globeadmin','2014-12-15 22:23:28','globeadmin','2015-10-04 14:46:52','globeadmin'),('549066f3ce23339','54809cf7134817b',NULL,NULL,'1',10,NULL,'student_has_left_school',45,10,'Details','Φοιτά','display',0,0,40,0,'c','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select IF(student_has_left_school,\'ΟΧΙ\' ,\'ΝΑΙ\') from mark_#nu_user_id#_#session_id# where id=#SUBFORM_RECORD_ID#',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-12-16 19:08:03','globeadmin','2014-12-16 19:10:00','globeadmin','2015-10-04 14:46:52','globeadmin'),('548fd366903db71','54809cf7134817b',NULL,NULL,'1',10,NULL,'post_teacher_short',80,10,'Details','Τροποποιήθηκε από ','display',0,0,130,0,'c','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select post_teacher_short from mark_#nu_user_id#_#session_id# where id=#SUBFORM_RECORD_ID#',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-12-16 08:38:30','globeadmin','2014-12-16 19:14:11','globeadmin','2015-10-04 14:46:52','globeadmin'),('54931c33d6ebe0d','547070c91793d3b',NULL,NULL,'1',10,NULL,'num_of_decimals',60,10,'Λεπτομέρειες','Βαθμοί με δεκαδικό ψηφίο: ','checkbox',210,127,80,0,'c','1','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'0|NAI|1|OXI',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2014-12-18 20:25:55','globeadmin','2019-08-03 21:41:31','globeadmin','2021-09-04 21:36:58','globeadmin'),('549487049e6ab2e','59d7d837262870c',NULL,NULL,'1',10,NULL,'teacher_lessons',10,10,'Αναθέσεις Μαθημάτων',NULL,'iframe',60,12,950,400,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'5494859e9bfaf58','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2014-12-19 22:13:56','globeadmin','2018-07-13 11:05:08','globeadmin','2018-07-13 11:05:08','globeadmin'),('5495d544b81914c','59d7d837262870c',NULL,NULL,'1',10,NULL,'teacher_programs',10,20,'Ωρολόγιο Πρόγραμμα',NULL,'iframe',24,14,950,430,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'5a9e7622e307049','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2014-12-20 22:00:04','globeadmin','2018-07-13 19:12:05','globeadmin','2018-07-13 19:12:06','globeadmin'),('5495db5b8e961e0','59d7d7986aed52d',NULL,NULL,'0',10,NULL,'print_markbtn',20,10,'Αξιολόγηση Μαθητών και Ποινές',NULL,'html',80,380,220,100,'l','0','0','','0',NULL,NULL,'#RECORD_ID# ','5495dad1762dc2c',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_grprint_id\').src=\'images/grprintb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_grprint_id\').src=\'images/grprint.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_grprint_id\' src=\'images/grprint.png\' title=\'Εκτύπωση Βαθμολογίας\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Εκτύπωση Βαθμολογίας</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-12-20 22:26:03','globeadmin','2017-10-07 01:07:46','globeadmin','2017-11-12 16:24:32','globeadmin'),('54972ec8a2089fa','5495dad1762dc2c',NULL,NULL,'1',10,NULL,'print_marks_grading_period_selection',20,10,'Εκτύπωση Βαθμολογίας',NULL,'dropdown',42,74,200,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'SELECT distinct grading_period.id,grading_period.name\nFROM grading_period\ninner join mark on grading_period.id=mark.grading_period_id\nwhere \nmark.subject_id in \n(\nselect distinct card.subject_id \nfrom card \nwhere card.valid_from =(SELECT max(timetable.start_date) FROM timetable)\nand teacher_id=\'#RECORD_ID#\'\n)\nORDER BY grading_period.name\n',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2014-12-21 22:34:16','globeadmin','2022-01-22 10:47:40','globeadmin','2022-01-22 10:50:54','globeadmin'),('54a2b91fcbea1b1','54a26a8d05fa91d',NULL,NULL,'1',10,NULL,'export_marks_type',20,10,'Εξαγωγή Βαθμολογίας','Ομαδοποίηση : ','dropdown',25,432,100,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'1|Ανά Τμήμα|0|Ανά Τάξη',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2014-12-30 16:39:27','globeadmin','2015-05-30 17:44:20','globeadmin','2018-07-28 11:43:26','globeadmin'),('54a26f38827dc65','54a26a8d05fa91d',NULL,NULL,'1',10,NULL,'export_marks_iframe',50,10,'Εξαγωγή Βαθμολογίας',NULL,'iframe',128,20,900,350,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2014-12-30 11:24:08','globeadmin','2018-07-28 11:44:04','globeadmin','2018-07-28 11:44:05','globeadmin'),('549c6b4f66318e7','547d6ec60ac6bdd',NULL,NULL,'1',10,NULL,'granding_period_end_date',40,10,'Καταχώριση Βαθμολογίας','Καταχώριση Βαθμολογίας Μέχρι τις :','display',36,626,80,80,'c','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','SELECT DATE_FORMAT(grading_period.end_date,\'%d-%m-%Y\') \nFROM session_variables,grading_period \nWHERE \n    session_variables.grading_period_id=grading_period.id and\n    session_variables.session_id=\'#session_id#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',100,250,'2014-12-25 21:53:51','globeadmin','2015-01-11 21:52:09','globeadmin','2021-03-24 11:12:35','globeadmin'),('549b25c11669f8c','5495dad1762dc2c',NULL,NULL,'1',10,NULL,'print_marks_class_subject_selection',40,10,'Εκτύπωση Βαθμολογίας',NULL,'listbox',107,74,700,250,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','','SELECT distinct CONCAT(class_id,\',\',subject_id), CONCAT(class_short,\' - \',subject_name,\' (\',subject_type_name,\')\')\nFROM \n(\nSELECT \n	active_card.id 				AS id,\n	active_card.valid_from 		AS valid_from,\n	active_card.subject_id 		AS subject_id,\n	active_card.teacher_id 		AS teacher_id,\n	active_card.class_id 		AS class_id,\n	active_card.classroom_id 	AS classroom_id,\n	active_card.day_id 			AS day_id,\n	active_card.period_id 		AS period_id,\n	teacher.short_name 			AS teacher_short,\n	teacher.surname 			AS teacher_surname,\n	teacher.name 				AS teacher_name,\n	day.name 					AS day_name,\n	day.short_name 				AS day_short,\n	period.short_name 			AS period_short,\n	period.name 				AS period_name,\n	class.short_name 			AS class_short,\n	class.name 					AS class_name,\n	subject.short_name 			AS subject_short,\n	subject.name 				AS subject_name,\n	subject.is_marked 			AS subject_is_marked,\n	subject_type.short_name 	AS subject_type_short,\n	subject_type.name 			AS subject_type_name,\n	classroom.short_name 		AS classroom_short,\n	classroom.name 				AS classroom_name,\n	teacher.email 				AS teacher_email,\n	teacher.user_id 			AS teacher_user_id \nFROM \n	(SELECT \n		card.id 			AS id,\n		card.valid_from 	AS valid_from,\n		card.subject_id 	AS subject_id,\n		card.teacher_id 	AS teacher_id,\n		card.class_id 		AS class_id,\n		card.classroom_id 	AS classroom_id,\n		card.day_id 		AS day_id,\n		card.period_id 		AS period_id \n	FROM card \n	WHERE card.valid_from =\n		(	SELECT max(timetable.start_date) \n			FROM timetable \n			WHERE (timetable.start_date <= curdate()))) as active_card \n	inner join subject 			on active_card.subject_id = subject.id \n	inner join teacher 			on active_card.teacher_id = teacher.id  \n	inner join day 				on active_card.day_id = day.id  \n	inner join period 			on active_card.period_id = period.id\n	inner join class 			on active_card.class_id = class.id	\n	left  join subject_type 	on subject.subject_type_id = subject_type.id  \n	left  join classroom 		on active_card.classroom_id = classroom.id  \nORDER BY \n	active_card.teacher_id,\n	active_card.day_id,\n	active_card.period_id\n)\nas active_card_full\nWHERE \n    teacher_id=#RECORD_ID# and \n    subject_id in \n        (select distinct mark.subject_id \n        from mark,session_variables \n        where\n            session_variables.session_id=\'#session_id#\' and\n            mark.grading_period_id = session_variables.mark_print_grading_period_id and\n            mark.class_id=active_card_full.class_id)\n    ORDER BY class_short,subject_name;',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2014-12-24 22:44:49','globeadmin','2016-01-04 10:43:31','globeadmin','2020-04-02 16:20:09','globeadmin'),('549ef7387b50521','5495dad1762dc2c',NULL,NULL,'1',10,NULL,'marks_show_all_pdf',50,10,'Εκτύπωση Βαθμολογίας','Εμφάνιση Επιλεγμένων σε Μορφή PDF','button',413,74,300,35,'c','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',100,250,'2014-12-27 20:15:20','globeadmin','2014-12-29 18:22:01','globeadmin','2020-04-02 16:20:09','globeadmin'),('54a26e2d4574a89','54a26a8d05fa91d',NULL,NULL,'1',10,NULL,'export_marks_btn',40,10,'Εξαγωγή Βαθμολογίας','Δημιουργία Αρχείων','button',74,79,200,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2014-12-30 11:19:41','globeadmin','2015-05-30 18:39:22','globeadmin','2018-07-28 11:43:26','globeadmin'),('54a0499b2863e52','5495dad1762dc2c',NULL,NULL,'1',10,NULL,'marks_print_help_label',60,10,'Εκτύπωση Βαθμολογίας','μπορείτε να επιλέξετε περισσότερα από ένα μαθήματα με πατημένο το πλήκτρο CTRL','words',361,74,500,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-12-28 20:19:07','globeadmin','2014-12-28 20:22:12','globeadmin','2020-04-02 16:20:09','globeadmin'),('54a313132ef436f','54a312a5698c8f9',NULL,NULL,'1',10,NULL,'teacher_owe_marks_iframe',10,10,'Μαθήματα Χωρίς Αξιολόγηση την Τρέχουσα Περίοδο',NULL,'iframe',27,30,880,350,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'54a30da411a6ba7','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-12-30 23:03:15','globeadmin','2018-07-17 01:02:11','globeadmin','2022-05-15 20:03:40','globeadmin'),('54a26c39d30d2c0','54a26a8d05fa91d',NULL,NULL,'1',10,NULL,'export_marks_grading_period_selection',10,10,'Εξαγωγή Βαθμολογίας','Περίοδος Αξιολόγησης : ','dropdown',25,29,200,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'SELECT distinct grading_period.id,grading_period.name\nFROM grading_period\ninner join mark on grading_period.id=mark.grading_period_id\nORDER BY grading_period.name\n',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2014-12-30 11:11:21','globeadmin','2016-07-24 16:18:18','globeadmin','2018-07-28 11:43:26','globeadmin'),('549fe813321d6b9','5495dad1762dc2c',NULL,NULL,'1',10,NULL,'marks_grading_period_label',10,10,'Εκτύπωση Βαθμολογίας','Περίοδος Αξιολόγησης','words',19,74,150,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-12-28 13:22:59','globeadmin','2016-07-24 23:27:38','globeadmin','2020-04-02 16:20:08','globeadmin'),('549fe88b0b0d69d','5495dad1762dc2c',NULL,NULL,'1',10,NULL,'marks_class_subject_label',30,10,'Εκτύπωση Βαθμολογίας','Τμήμα - Μάθημα','words',83,74,150,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-12-28 13:24:59','globeadmin','2014-12-28 13:24:59','globeadmin','2020-04-02 16:20:08','globeadmin'),('54a41108b1fc7b5','54a4107cddefff1',NULL,NULL,'1',10,NULL,'email_subject',20,10,'Αποστολή Email','Θέμα :','text',65,53,650,22,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-12-31 17:06:48','globeadmin','2016-07-11 12:10:55','globeadmin','2021-03-24 11:17:19','globeadmin'),('5783fd7ee81d3fb','5476201e5a3d38f',NULL,NULL,'0',10,'select if(student.email is not null and TRIM(student.email)!=\'\',\'1\',\'0\')\nfrom school  \nleft join student on student.id=\'#RECORD_ID#\' \nwhere  school.id=1','send_email_student_img',120,20,'Στοιχεία Επικοινωνίας',NULL,'html',595,403,34,31,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"this.style.cursor=\'pointer\';\"\n                            onmouseout=\"this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=30 height=30 id=\'img_email_student_send1\' src=\'images/email.png\' title=\'Αποστολή Email\'/>\n        </td>\n    </tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-07-11 23:11:43','globeadmin','2018-08-06 22:16:02','globeadmin','2022-01-08 11:22:27','globeadmin'),('54a41994a838651','54a4107cddefff1',NULL,NULL,'1',10,NULL,'email_recipients',10,10,'Αποστολή Email','Διεύθυνση :','text',39,23,450,120,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-12-31 17:43:16','globeadmin','2016-07-11 12:10:35','globeadmin','2021-03-24 11:17:19','globeadmin'),('54a52ce332f5ca2','54a52c3dcf3610b',NULL,NULL,'1',10,NULL,'set_smtp_username',10,10,'Ρυθμίσεις Αποστολής Email','Όνομα Χρήστη :','text',76,151,250,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-01-01 13:17:55','globeadmin','2019-07-25 00:24:49','globeadmin','2019-07-27 23:23:29','globeadmin'),('5688ee7b50d64af','5688ee0218ad763',NULL,NULL,'1',10,NULL,'period_id',40,10,'Εισαγωγή Νέας Διδασκαλίας','Ώρα :','dropdown',162,43,100,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from period',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2016-01-03 11:48:43','globeadmin','2016-01-03 11:48:43','globeadmin','2017-10-03 23:25:20','globeadmin'),('5688ee6a423049c','5688ee0218ad763',NULL,NULL,'1',10,NULL,'day_id',30,10,'Εισαγωγή Νέας Διδασκαλίας','Ημέρα :','dropdown',119,31,100,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,name from day',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2016-01-03 11:48:26','globeadmin','2016-01-03 11:48:26','globeadmin','2017-10-03 23:25:20','globeadmin'),('54a52d4b5c7875d','54a433830716b84',NULL,NULL,'0',10,NULL,'admin_emailbtn',80,40,'Εργασίες Διαχείρισης',NULL,'html',192,615,220,100,'l','0','0','','0',NULL,NULL,'1','54a52c3dcf3610b',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_emailconf_id\').src=\'images/emailconfb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_emailconf_id\').src=\'images/emailconf.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=98 height=74 id=\'img_emailconf_id\' src=\'images/emailconf.png\' title=\'Ρυθμίσεις Αποστολής Email\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Ρυθμίσεις Αποστολής Email</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-01-01 13:19:39','globeadmin','2015-12-26 21:00:00','globeadmin','2015-12-26 21:06:03','globeadmin'),('54a52e0e922dcaa','54a52c3dcf3610b',NULL,NULL,'1',10,NULL,'email_settings_testbtn',120,10,'Ρυθμίσεις Αποστολής Email','Αποστολή Test Email στο Λογαριασμό','button',424,317,300,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'password',NULL,'',0,0,'2015-01-01 13:22:54','globeadmin','2016-04-09 16:29:35','globeadmin','2019-07-27 23:23:30','globeadmin'),('54a52e70b93cddb','54a52c3dcf3610b',NULL,NULL,'1',10,NULL,'set_smtp_host',30,10,'Ρυθμίσεις Αποστολής Email','Διακομιστής (Email Server) :','text',184,78,250,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-01-01 13:24:32','globeadmin','2019-07-25 00:26:32','globeadmin','2019-07-27 23:23:29','globeadmin'),('54a52edacf3762d','54a52c3dcf3610b',NULL,NULL,'1',10,NULL,'set_smtp_from_address',60,10,'Ρυθμίσεις Αποστολής Email','Διεύθυνση από (from email) :','text',322,74,250,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-01-01 13:26:18','globeadmin','2019-07-25 00:25:09','globeadmin','2019-07-27 23:23:29','globeadmin'),('54a52f38b45acd6','54a52c3dcf3610b',NULL,NULL,'1',10,NULL,'set_smtp_from_name',70,10,'Ρυθμίσεις Αποστολής Email','Όνομα από (from name) :','text',361,92,350,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-01-01 13:27:52','globeadmin','2016-04-09 16:29:35','globeadmin','2019-07-27 23:23:29','globeadmin'),('54a52fc57ea6933','54a52c3dcf3610b',NULL,NULL,'1',10,NULL,'set_smtp_port',40,10,'Ρυθμίσεις Αποστολής Email','Θύρα Διακομιστή (port number) :','text',218,53,60,30,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-01-01 13:30:13','globeadmin','2019-07-24 15:02:29','globeadmin','2019-07-27 23:23:29','globeadmin'),('54a5306137d95d5','54a52c3dcf3610b',NULL,NULL,'1',10,NULL,'set_smtp_use_ssl',50,10,'Ρυθμίσεις Αποστολής Email','Ασφάλεια Σύνδεσης :','dropdown',251,119,80,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'ssl|SSL|tls|TLS',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-01-01 13:32:49','globeadmin','2019-07-24 15:02:05','globeadmin','2019-07-27 23:23:29','globeadmin'),('54a55c25df02263','54a52c3dcf3610b',NULL,NULL,'1',10,NULL,'emails_settings_label2',90,10,'Ρυθμίσεις Αποστολής Email','π.χ. 1epal-ag-nikol','words',85,640,200,30,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-01-01 16:39:33','globeadmin','2019-07-25 00:19:17','globeadmin','2019-07-27 23:23:29','globeadmin'),('54a55f87341c13f','54a52c3dcf3610b',NULL,NULL,'1',10,NULL,'emails_settings_label1',80,10,'Ρυθμίσεις Αποστολής Email','Παρακαλώ εισάγετε τις ρυθμίσεις του λογαριασμού, μέσω του οποίου θα πραγματοποιείται η αποστολή των emails από το Σίσυφο','words',26,43,800,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-01-01 16:53:59','globeadmin','2016-04-09 16:29:35','globeadmin','2019-07-27 23:23:29','globeadmin'),('54a55fdd0d0a9fa','54a52c3dcf3610b',NULL,NULL,'1',10,NULL,'emails_settings_label3',100,10,'Ρυθμίσεις Αποστολής Email','π.χ. 123!@#','words',119,640,200,30,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-01-01 16:55:25','globeadmin','2016-04-09 16:29:35','globeadmin','2019-07-27 23:23:30','globeadmin'),('54a560240346a42','54a52c3dcf3610b',NULL,NULL,'1',10,NULL,'emails_settings_label4',110,10,'Ρυθμίσεις Αποστολής Email','π.χ. 1ο ΕΠΑΛ ...','words',356,740,100,30,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-01-01 16:56:36','globeadmin','2016-04-09 16:29:35','globeadmin','2019-07-27 23:23:30','globeadmin'),('54a560316eb46c8','54a52c3dcf3610b',NULL,NULL,'1',10,NULL,'emails_settings_label5',130,10,'Ρυθμίσεις Αποστολής Email','π.χ. mail@1epal-ag-nikol.las.sch.gr','words',322,590,250,30,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-01-01 16:56:49','globeadmin','2019-07-25 00:21:28','globeadmin','2019-07-27 23:23:30','globeadmin'),('54a56044b310138','54a52c3dcf3610b',NULL,NULL,'1',10,NULL,'emails_settings_label6',140,10,'Ρυθμίσεις Αποστολής Email','π.χ. SSL','words',258,640,200,30,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-01-01 16:57:08','globeadmin','2019-07-24 15:21:46','globeadmin','2019-07-27 23:23:30','globeadmin'),('54a560528c009e6','54a52c3dcf3610b',NULL,NULL,'1',10,NULL,'emails_settings_label7',150,10,'Ρυθμίσεις Αποστολής Email','π.χ. 465','words',227,640,200,30,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-01-01 16:57:22','globeadmin','2016-04-09 16:29:35','globeadmin','2019-07-27 23:23:30','globeadmin'),('54a5605f95c28d1','54a52c3dcf3610b',NULL,NULL,'1',10,NULL,'emails_settings_label8',160,10,'Ρυθμίσεις Αποστολής Email','π.χ. mail.sch.gr','words',193,640,200,30,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-01-01 16:57:35','globeadmin','2019-07-25 00:20:02','globeadmin','2019-07-27 23:23:30','globeadmin'),('54a56a0b145d855','54a52c3dcf3610b',NULL,NULL,'1',10,NULL,'set_smtp_password',20,10,'Ρυθμίσεις Αποστολής Email','Κωδικός :','text',113,185,250,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'password',NULL,'',0,0,'2015-01-01 17:38:51','globeadmin','2019-07-25 00:26:10','globeadmin','2019-07-27 23:23:29','globeadmin'),('54a65f6bf14a750','54a65ecc3f14737',NULL,NULL,'1',10,NULL,'sus_login_name',10,10,'Στοιχεία Λογαριασμού','Όνομα Χρήστη :','text',53,223,150,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-01-02 11:05:48','globeadmin','2015-10-17 21:13:39','globeadmin','2018-07-28 00:36:32','globeadmin'),('54a65fff354d8b8','59d7d65650da67c',NULL,NULL,'0',10,NULL,'teacher_change_account',80,10,'Προσωπικά Στοιχεία',NULL,'html',355,94,220,100,'l','0','0','','0',NULL,NULL,'#nu_user_id# ','54a65ecc3f14737',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0  \n                            onmouseover=\"document.getElementById(\'img_log_user_id\').src=\'images/log_userb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_log_user_id\').src=\'images/log_user.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_log_user_id\' src=\'images/log_user.png\' title=\'Αλλαγή Κωδικού Πρόσβασης\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Λογαριασμός Πρόσβασης</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-01-02 11:08:15','globeadmin','2017-10-06 23:59:07','globeadmin','2018-07-28 00:38:24','globeadmin'),('54a6679d3a3102b','54a65ecc3f14737',NULL,NULL,'1',10,'select if(\'#login_with_email_account#\'=\'0\' or \'#nu_user_group#\'=\'globeadmin\',\'1\',\'0\')','nupassword',40,10,'Στοιχεία Λογαριασμού','Νέος Κωδικός Πρόσβασης :','text',171,155,150,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'password',NULL,'',100,250,'2015-01-02 11:40:45','globeadmin','2017-04-03 08:17:29','globeadmin','2018-07-28 00:36:32','globeadmin'),('54a667c8e786bf3','54a65ecc3f14737',NULL,NULL,'1',10,'select if(\'#login_with_email_account#\'=\'0\' or \'#nu_user_group#\'=\'globeadmin\',\'1\',\'0\')','nuretyped',50,10,'Στοιχεία Λογαριασμού','Επιβεβαίωση Νέου Κωδικού :','text',217,144,150,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'password',NULL,'',100,250,'2015-01-02 11:41:28','globeadmin','2017-04-03 08:17:42','globeadmin','2018-07-28 00:36:33','globeadmin'),('54a677e6d66fbc0','54a65ecc3f14737',NULL,NULL,'1',10,'select if(\'#login_with_email_account#\'=\'0\' or \'#nu_user_group#\'=\'globeadmin\',\'1\',\'0\')','change_account_label1',60,10,'Στοιχεία Λογαριασμού','Προσοχή!','words',284,69,200,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-01-02 12:50:14','globeadmin','2017-04-03 08:17:59','globeadmin','2018-07-28 00:36:33','globeadmin'),('54a6785d3a2f67f','54a65ecc3f14737',NULL,NULL,'1',10,'select if(\'#login_with_email_account#\'=\'0\' or \'#nu_user_group#\'=\'globeadmin\',\'1\',\'0\')','change_account_label2',70,10,'Στοιχεία Λογαριασμού','1. Ο Νέος Κωδικός Πρόσβασης πρέπει να αποτελείται από τουλάχιστον έξι (6) χαρακτήρες','words',314,88,550,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-01-02 12:52:13','globeadmin','2017-04-03 08:18:11','globeadmin','2018-07-28 00:36:33','globeadmin'),('54a678cb725829c','54a65ecc3f14737',NULL,NULL,'1',10,'select if(\'#login_with_email_account#\'=\'0\' or \'#nu_user_group#\'=\'globeadmin\',\'1\',\'0\')','change_account_label3',80,10,'Στοιχεία Λογαριασμού','2. Ο Νέος Κωδικός Πρόσβασης πρέπει να αποτελείται από γράμματα ΚΑΙ αριθμούς','words',343,88,550,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-01-02 12:54:03','globeadmin','2017-04-03 08:18:31','globeadmin','2018-07-28 00:36:33','globeadmin'),('54a6790168925d1','54a65ecc3f14737',NULL,NULL,'1',10,'select if(\'#login_with_email_account#\'=\'0\' or \'#nu_user_group#\'=\'globeadmin\',\'1\',\'0\')','change_account_label4',90,10,'Στοιχεία Λογαριασμού','3. Ο Νέος Κωδικός Πρόσβασης πρέπει να περιέχει τουλάχιστον ένα ειδικό χαρακτήρα (!,%,&,@,#,$,^,*,?,_,~)','words',371,88,600,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-01-02 12:54:57','globeadmin','2017-04-03 08:18:45','globeadmin','2018-07-28 00:36:33','globeadmin'),('54a6ff0c7a99ab5','54a6fde1ab6eb6d',NULL,NULL,'1',10,NULL,'name',30,10,'Στοιχεία Μαθητή','Όνομα :','text',69,100,300,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-01-02 22:26:52','globeadmin','2015-10-04 11:18:42','globeadmin','2021-09-06 20:12:22','globeadmin'),('5509671b5ab4ea6','5509671b4e81a07',NULL,NULL,'1',10,NULL,'absence_date',20,10,'Λεπτομέρειες','Ημερομηνία Απουσίας : ','text',57,90,80,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-03-18 21:05:50','globeadmin','2022-10-05 20:27:42','globeadmin'),('5509671b62083b3','5509671b4e81a07',NULL,NULL,'1',10,NULL,'posted_when',80,10,'Λεπτομέρειες','στις : ','text',191,503,140,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-03-18 21:05:50','globeadmin','2022-10-05 20:27:42','globeadmin'),('54a7b52222a1f82','54a6fde1ab6eb6d',NULL,NULL,'1',10,NULL,'registration_number',10,10,'Στοιχεία Μαθητή','Αριθμός Μητρώου :','text',27,626,100,0,'r','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-01-03 11:23:46','globeadmin','2016-01-30 10:27:17','globeadmin','2021-09-06 20:12:22','globeadmin'),('54a7b588b2ad092','54a6fde1ab6eb6d',NULL,NULL,'1',10,NULL,'surname',20,10,'Στοιχεία Μαθητή','Επώνυμο :','text',27,83,300,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-01-03 11:25:28','globeadmin','2015-10-04 11:18:28','globeadmin','2021-09-06 20:12:22','globeadmin'),('54a7b5e7cb15799','54a6fde1ab6eb6d',NULL,NULL,'1',10,NULL,'fathers_name',40,10,'Στοιχεία Μαθητή','Όνομα Πατρός :','text',110,54,300,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-01-03 11:27:03','globeadmin','2020-09-06 10:45:11','globeadmin','2021-09-06 20:12:22','globeadmin'),('54a7b5fd75a3fa6','54a6fde1ab6eb6d',NULL,NULL,'1',10,NULL,'mothers_name',50,10,'Στοιχεία Μαθητή','Όνομα Μητρός :','text',152,53,300,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-01-03 11:27:25','globeadmin','2015-10-04 11:19:15','globeadmin','2021-09-06 20:12:22','globeadmin'),('54a7b63e86bb467','5476201e5a3d38f',NULL,NULL,'1',10,NULL,'birth_date',80,10,'Στοιχεία Μαθητή','Ημερομηνία Γέννησης :','text',362,55,100,0,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',100,250,'2015-01-03 11:28:30','globeadmin','2015-10-04 20:21:01','globeadmin','2022-01-08 11:22:26','globeadmin'),('54a7b6f31b4d6aa','54a6fde1ab6eb6d',NULL,NULL,'1',10,NULL,'speciality_id',80,10,'Στοιχεία Μαθητή','Ειδικότητα :','display',69,672,250,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select short_name \nfrom speciality\nwhere id=\'#speciality_id#\'','select id,name from speciality',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2015-01-03 11:31:31','globeadmin','2015-10-04 11:28:00','globeadmin','2021-09-06 20:12:22','globeadmin'),('54a7b71b4c21660','54a6fde1ab6eb6d',NULL,NULL,'1',10,NULL,'grade_id',70,10,'Στοιχεία Μαθητή','Τάξη :','display',27,894,60,0,'c','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select short_name \nfrom grade\nwhere id=\'#grade_id#\'','select id,short_name from grade',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2015-01-03 11:32:11','globeadmin','2015-10-04 11:29:25','globeadmin','2021-09-06 20:12:22','globeadmin'),('54a7b732b78d5d5','54a6fde1ab6eb6d',NULL,NULL,'1',10,NULL,'teacher_id',90,10,'Στοιχεία Μαθητή','Υπεύθυνος Καθηγητής :','display',110,600,250,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select concat(if(surname is null,\'\',concat(surname,\' \')), IFNULL(name,\'\')) from teacher where id=\'#teacher_id#\'','select id,concat(if(surname is null,\'\',concat(surname,\' \')), IFNULL(name,\'\')) from teacher',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2015-01-03 11:32:34','globeadmin','2015-10-04 11:30:55','globeadmin','2021-09-06 20:12:22','globeadmin'),('54a7b82ebc6f57a','54a6fde1ab6eb6d',NULL,NULL,'1',10,NULL,'student_class',100,10,'Στοιχεία Μαθητή',NULL,'iframe',209,539,460,220,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'547cce2020be0b5','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-01-03 11:36:46','globeadmin','2015-10-04 11:37:46','globeadmin','2021-09-06 20:12:22','globeadmin'),('54a7b899c3c25d2','59e22ff819cd774',NULL,NULL,'1',10,NULL,'std_lessons',10,10,'Διδασκαλίες',NULL,'iframe',27,29,970,420,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'5477806364bbd3b','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-01-03 11:38:33','globeadmin','2017-10-15 11:38:06','globeadmin','2020-03-29 17:09:21','globeadmin'),('54a7b8b4955f660','59e22ff819cd774',NULL,NULL,'1',10,NULL,'student_program',10,20,'Ωρολόγιο Πρόγραμμα',NULL,'iframe',24,14,1000,600,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'5a9d96938c5959e','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-01-03 11:39:00','globeadmin','2018-07-13 10:40:57','globeadmin','2018-07-13 10:40:58','globeadmin'),('54a85bc4032bd41','59e22ed0a598932',NULL,NULL,'1',10,'select if ((select count(grading_period.id) from grading_period, mark\n            where \n                grading_period.id=mark.grading_period_id and\n                grading_period.marks_publication_date<=curdate() and\n                mark.student_id=#RECORD_ID#)>0,\'1\',\'0\')','student_mark_grade_period',10,10,'Αξιολόγηση','Περίοδος Αξιολόγησης :','dropdown',28,50,200,70,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select distinct grading_period.id,grading_period.name \nfrom \n    grading_period, mark\nwhere \n    grading_period.id=mark.grading_period_id and\n    ((grading_period.marks_publication_date<=curdate()) OR (\'#nu_user_group#\'=\'globeadmin\')) and\n    mark.student_id=#RECORD_ID#',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2015-01-03 23:14:44','globeadmin','2017-10-15 15:41:42','globeadmin','2018-07-05 13:10:57','globeadmin'),('54a912514a63f0e','547070c91793d3b',NULL,NULL,'1',10,NULL,'end_date',70,10,'Λεπτομέρειες','Καταχώριση αξιολόγησης μέχρι :  ','text',311,93,100,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',100,250,'2015-01-04 12:13:37','globeadmin','2016-07-24 16:09:30','globeadmin','2021-09-04 21:36:58','globeadmin'),('54a91b838c4d4b1','59e22ed0a598932',NULL,NULL,'1',10,'select if ((select count(grading_period.id) from grading_period, mark\n            where \n                grading_period.id=mark.grading_period_id and\n                grading_period.marks_publication_date<=curdate() and\n                mark.student_id=#RECORD_ID#)>0,\'1\',\'0\')','student_mark_printbtn',20,10,'Αξιολόγηση','Εκτύπωση','button',20,460,150,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2015-01-04 12:52:51','globeadmin','2017-10-15 15:41:42','globeadmin','2017-11-12 16:32:08','globeadmin'),('54a91c68a4b8f15','59e22ed0a598932',NULL,NULL,'1',10,'select if ((select count(grading_period.id) from grading_period, mark\n            where \n                grading_period.id=mark.grading_period_id and\n                grading_period.marks_publication_date<=curdate() and\n                mark.student_id=#RECORD_ID#)>0,\'1\',\'0\')','student_mark_showiframe',40,10,'Αξιολόγηση',NULL,'iframe',65,14,1000,390,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-01-04 12:56:40','globeadmin','2017-10-15 15:41:42','globeadmin','2017-11-12 16:32:08','globeadmin'),('54a92ce7df50a6b','5476201e5a3d38f',NULL,NULL,'1',10,'select if(((select count(grading_period.id) from grading_period, mark\n            where \n                grading_period.id=mark.grading_period_id and\n                mark.student_id=\'#RECORD_ID#\')>0) AND	\n			(teacher_id=\'#teacher_id#\' OR \n			\'#nu_user_group# \'=\'Managers\' OR \n			\'#nu_user_group#\'=\'AssistManagers\' OR\n			\'#nu_user_group# \'=\'Administrators\' OR\n			\'#nu_user_group# \'=\'globeadmin\')\n			,\'1\',\'0\')\nfrom session_variables\nwhere session_id=\'#session_id#\'','student_mark_grade_period',20,60,'Αξιολόγηση','Περίοδος Αξιολόγησης :','dropdown',38,80,200,70,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select distinct grading_period.id,grading_period.name \nfrom \n    grading_period, mark\nwhere \n    grading_period.id=mark.grading_period_id and\n    mark.student_id=#RECORD_ID#',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2015-01-04 14:07:03','globeadmin','2016-07-26 10:00:09','globeadmin','2022-01-08 11:22:28','globeadmin'),('54a92d38876b1b6','5476201e5a3d38f',NULL,NULL,'1',10,'select if(((select count(grading_period.id) from grading_period, mark\n            where \n                grading_period.id=mark.grading_period_id and\n                mark.student_id=\'#RECORD_ID#\')=0) AND	\n			(teacher_id=\'#teacher_id#\' OR \n			\'#nu_user_group# \'=\'Managers\' OR \n			\'#nu_user_group#\'=\'AssistManagers\' OR\n			\'#nu_user_group# \'=\'Administrators\' OR\n			\'#nu_user_group# \'=\'globeadmin\')\n			,\'1\',\'0\')\nfrom session_variables\nwhere session_id=\'#session_id#\'','student_mark_label1',10,60,'Αξιολόγηση','Δεν υπάρχει για το μαθητή δημοσιευμένη αξιολόγηση…','words',0,0,400,70,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2015-01-04 14:08:24','globeadmin','2016-07-25 23:58:42','globeadmin','2022-01-08 11:22:28','globeadmin'),('54aa76566f2b29a','54aa751b6567046',NULL,NULL,'1',10,NULL,'student_user_creationbtn',10,10,'Δημιουργία Λογαριασμών Μαθητών','Δημιουργία','button',77,466,200,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-01-05 13:32:38','globeadmin','2015-01-05 13:32:38','globeadmin','2020-09-24 22:08:26','globeadmin'),('54a92d922355469','5476201e5a3d38f',NULL,NULL,'1',10,'select if ((select count(grading_period.id) from grading_period, mark\n            where \n                grading_period.id=mark.grading_period_id and\n                mark.student_id=#RECORD_ID#)>0,\'1\',\'0\')','student_mark_showiframe',50,60,'Αξιολόγηση',NULL,'iframe',78,14,1000,420,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2015-01-04 14:09:54','globeadmin','2018-06-22 22:31:35','globeadmin','2022-01-08 11:22:28','globeadmin'),('54aa76dc9b1ba59','54aa751b6567046',NULL,NULL,'0',10,NULL,'create_std_acc_homeiframe',20,10,'Δημιουργία Λογαριασμών Μαθητών',NULL,'iframe',127,17,900,330,'l','0','0','','0',NULL,NULL,'0','54aa751b6567046',NULL,'','',NULL,NULL,NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-01-05 13:34:52','globeadmin','2015-11-22 09:56:20','globeadmin','2020-09-24 22:08:26','globeadmin'),('54aa77bc237c098','54aa751b6567046',NULL,NULL,'0',10,NULL,'create_std_acc_home_display',30,10,'Δημιουργία Λογαριασμών Μαθητών',NULL,'display',81,17,400,30,'l','0','0','','0',NULL,NULL,'0','54aa751b6567046',NULL,'','','select concat(\'Θα δημιουργηθούν - \',count(*),\' - λογαριασμοί μαθητών...\') from student where user_id is null and has_left_school=0',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-01-05 13:38:36','globeadmin','2018-07-08 10:43:15','globeadmin','2020-09-24 22:08:26','globeadmin'),('54aa7aab210b08d','54aa751b6567046',NULL,NULL,'0',10,NULL,'create_std_acc_home_label1',40,10,'Δημιουργία Λογαριασμών Μαθητών','Επιλέγοντας «Δημιουργία» θα δημιουργηθούν λογαριασμοί για όσους μαθητές δεν διαθέτουν ήδη λογαριασμό και δεν έχουν εγκαταλείψει το σχολείο.','words',11,17,900,30,'l','0','0','','0',NULL,NULL,'0','54aa751b6567046',NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-01-05 13:51:07','globeadmin','2016-09-20 20:20:45','globeadmin','2020-09-24 22:08:26','globeadmin'),('54aa7bace1e8804','54aa751b6567046',NULL,NULL,'0',10,NULL,'create_std_acc_home_label2',50,10,'Δημιουργία Λογαριασμών Μαθητών','Ο κάθε λογαριασμός θα έχει ως «Όνομα Χρήστη» τον αριθμό μητρώου του μαθητή και ως «Κωδικό» την ημερομηνία γέννησης του σε μορφή ηη-μμ-εεεε (π.χ. 03-05-1999).','words',35,17,900,30,'l','0','0','','0',NULL,NULL,'0','54aa751b6567046',NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-01-05 13:55:24','globeadmin','2015-11-21 21:01:39','globeadmin','2020-09-24 22:08:26','globeadmin'),('54aaa6c6cb423fb','59e23027879009a',NULL,NULL,'1',10,NULL,'student_home_school_name',10,10,'Σχολείο','Όνομα :','display',115,64,350,25,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select name from school where id=1',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-01-05 16:59:18','globeadmin','2017-10-15 15:59:27','globeadmin','2018-06-17 09:51:33','globeadmin'),('54aaa783e88e490','59e23027879009a',NULL,NULL,'1',10,NULL,'student_home_school_year',20,10,'Σχολείο','Σχολικό Έτος :','display',39,27,250,25,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select school_year.short_name from school,school_year where school.id=1 and school.school_year_id=school_year.id',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-01-05 17:02:27','globeadmin','2017-10-15 15:59:27','globeadmin','2018-06-17 09:51:33','globeadmin'),('54aaa98c9cdf403','59e23027879009a',NULL,NULL,'1',10,NULL,'student_home_school_street',30,10,'Σχολείο','Οδός & Αριθμός :','display',159,9,350,25,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select street from school where id=1',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-01-05 17:11:08','globeadmin','2017-10-15 15:59:27','globeadmin','2018-06-17 09:51:34','globeadmin'),('54aaa9f3cb42459','59e23027879009a',NULL,NULL,'1',10,NULL,'student_home_school_area',40,10,'Σχολείο','Περιοχή :','display',204,56,350,25,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select area from school where id=1',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-01-05 17:12:51','globeadmin','2017-10-15 15:59:27','globeadmin','2018-06-17 09:51:34','globeadmin'),('54aaaa5b3da83dd','59e23027879009a',NULL,NULL,'1',10,NULL,'student_home_school_city',50,10,'Σχολείο','Πόλη :','display',248,73,350,25,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select city from school where id=1',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-01-05 17:14:35','globeadmin','2017-10-15 15:59:27','globeadmin','2018-06-17 09:51:34','globeadmin'),('54aaaa9a058156d','59e23027879009a',NULL,NULL,'1',10,NULL,'student_home_school_zipcode',60,10,'Σχολείο','Ταχ. Κώδικας :','display',293,26,100,25,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select zipcode from school where id=1',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-01-05 17:15:38','globeadmin','2017-10-15 15:59:27','globeadmin','2018-06-17 09:51:34','globeadmin'),('54aaaadc7f93473','59e23027879009a',NULL,NULL,'1',10,NULL,'student_home_school_state',70,10,'Σχολείο','Πολιτεία :','display',337,56,200,25,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select state from school where id=1',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-01-05 17:16:44','globeadmin','2017-10-15 15:59:27','globeadmin','2018-06-17 09:51:34','globeadmin'),('54aaab1deaff38f','59e23027879009a',NULL,NULL,'1',10,NULL,'student_home_school_country',90,10,'Σχολείο','Χώρα :','display',383,69,200,25,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select country from school where id=1',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-01-05 17:17:49','globeadmin','2017-10-15 15:59:27','globeadmin','2018-06-17 09:51:34','globeadmin'),('54aaab915883856','59e23027879009a',NULL,NULL,'1',10,NULL,'student_home_school_phone1',100,10,'Σχολείο','Τηλέφωνο Διευθυντή :','display',39,578,130,25,'r','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select phone1 from school where id=1',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-01-05 17:19:45','globeadmin','2017-10-15 15:59:27','globeadmin','2018-06-17 09:51:34','globeadmin'),('54aaabb37841d18','59e23027879009a',NULL,NULL,'1',10,NULL,'student_home_school_phone2',110,10,'Σχολείο','Τηλέφωνο Γραμματείας :','display',76,563,130,25,'r','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select phone2 from school where id=1',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-01-05 17:20:19','globeadmin','2017-10-15 15:59:27','globeadmin','2018-06-17 09:51:34','globeadmin'),('54aaabe2c17fe93','59e23027879009a',NULL,NULL,'1',10,NULL,'student_home_school_fax',120,10,'Σχολείο','Fax :','display',114,676,130,25,'r','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select fax from school where id=1',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-01-05 17:21:06','globeadmin','2017-10-15 15:59:27','globeadmin','2018-06-17 09:51:34','globeadmin'),('54aaac1bd9e86b0','59e23027879009a',NULL,NULL,'1',10,NULL,'student_home_school_email',130,10,'Σχολείο','Email :','display',227,666,300,25,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select email from school where id=1',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-01-05 17:22:03','globeadmin','2017-10-15 15:59:27','globeadmin','2018-06-17 09:51:35','globeadmin'),('54aaac5d169a703','59e23027879009a',NULL,NULL,'1',10,NULL,'student_home_school_web_page',140,10,'Σχολείο','Ιστοσελίδα :','display',190,636,300,25,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select web_page from school where id=1',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-01-05 17:23:09','globeadmin','2017-10-15 15:59:27','globeadmin','2018-06-17 09:51:35','globeadmin'),('54aaae2f00a154c','59e22f4f52546e3',NULL,NULL,'1',10,NULL,'student_home_school_teacher_email',10,10,'Αποστολή Μηνύματος','Προς :','listbox',28,27,300,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select web_page from school where id=1','select distinct\n    teacher.id,\n    concat(IFNULL(teacher.surname,\'\'),IF(teacher.surname IS NULL OR teacher.name IS NULL,\'\',\' \'),IFNULL(teacher.name,\'\')) as teacher_full_name\nfrom    (\n                    select \n	                    card.id AS id,\n	                    card.valid_from AS valid_from,\n	                    card.subject_id AS subject_id,\n	                    card.teacher_id AS teacher_id,\n	                    card.class_id AS class_id,\n	                    card.classroom_id AS classroom_id,\n	                    card.day_id AS day_id,\n	                    card.period_id AS period_id \n                        from card \n                        where card.valid_from =(select max(timetable.start_date) from timetable where (timetable.start_date <= curdate()))\n                    ) \n            as active_card\nINNER JOIN teacher on (teacher.id=active_card.teacher_id OR teacher.id=\'#teacher_id#\' OR teacher.id=\'#advisor_id#\')\nwhere   active_card.class_id in (select distinct class_id from student_class where student_id=\'#RECORD_ID#\') and\n        ((teacher.email is not null and TRIM(teacher.email)<>\'\') or ((select count(*) from zzzsys_user where zzzsys_user_id=teacher.user_id and sus_email is not null and TRIM(sus_email)<>\'\')>0))\norder by teacher_full_name\n',NULL,'','','select distinct\n    teacher.id,\n    concat(IFNULL(teacher.surname,\'\'),IF(teacher.surname IS NULL OR teacher.name IS NULL,\'\',\' \'),IFNULL(teacher.name,\'\')) as teacher_full_name\nfrom    (\n                    select \n	                    card.id AS id,\n	                    card.valid_from AS valid_from,\n	                    card.subject_id AS subject_id,\n	                    card.teacher_id AS teacher_id,\n	                    card.class_id AS class_id,\n	                    card.classroom_id AS classroom_id,\n	                    card.day_id AS day_id,\n	                    card.period_id AS period_id \n                        from card \n                        where card.valid_from =(select max(timetable.start_date) from timetable where (timetable.start_date <= curdate()))\n                    ) \n            as active_card\nINNER JOIN teacher on (teacher.id=active_card.teacher_id OR teacher.id=\'#teacher_id#\' OR teacher.id=\'#advisor_id#\')\nwhere   active_card.class_id in (select distinct class_id from student_class where student_id=\'#RECORD_ID#\') and\n        ((teacher.email is not null and TRIM(teacher.email)<>\'\') or ((select count(*) from zzzsys_user where zzzsys_user_id=teacher.user_id and sus_email is not null and TRIM(sus_email)<>\'\')>0)) and\n        teacher.accept_email_from_students=1\norder by teacher_full_name\n',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-01-05 17:30:55','globeadmin','2017-10-15 15:48:13','globeadmin','2021-02-16 15:14:13','globeadmin'),('56d092b5eae0849','54a4107cddefff1',NULL,NULL,'1',10,NULL,'label1',50,10,'Αποστολή Email','Μήνυμα : ','words',92,32,200,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-02-26 20:00:22','globeadmin','2016-07-11 12:08:01','globeadmin','2021-03-24 11:17:19','globeadmin'),('56d148de0ca313c','562d11f6d45ccf1',NULL,NULL,'1',10,NULL,'comments_iframe',50,10,'Λεπτομέρειες','Περιγραφή : ','iframe',143,81,550,310,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-02-27 08:57:34','globeadmin','2016-07-24 23:02:26','globeadmin','2017-04-02 08:29:19','globeadmin'),('54aab29556125a2','59e22f4f52546e3',NULL,NULL,'1',10,NULL,'student_home_school_emailbtn',40,10,'Αποστολή Μηνύματος',NULL,'html',343,862,150,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_sendmail_id\').src=\'images/sendmailb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_sendmail_id\').src=\'images/sendmail.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=98 height=74 id=\'img_sendmail_id\' src=\'images/sendmail.png\' title=\'Αποστολή Μηνύματος\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Αποστολή Μηνύματος</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-01-05 17:49:41','globeadmin','2017-10-15 15:48:13','globeadmin','2021-02-16 15:14:13','globeadmin'),('578f99b34a70b01','59d7d7da6d30b22',NULL,NULL,'0',10,NULL,'btnimg1',10,10,'Αποστολή και Αναζήτηση Μηνυμάτων',NULL,'html',80,60,220,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'sms_search_id\').src=\'images/sms_searchb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'sms_search_id\').src=\'images/sms_search.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'sms_search_id\' src=\'images/sms_search.png\' title=\'Αναζήτηση Σταλθέντων SMS\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Αναζήτηση Σταλθέντων SMS</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-07-20 18:33:07','globeadmin','2017-10-07 00:51:18','globeadmin','2017-11-12 16:23:42','globeadmin'),('57dae313051002e','57dae2cd92d16c0',NULL,NULL,'1',10,NULL,'class_subject_selection',10,10,'Διδασκαλίες','Μάθημα : ','dropdown',14,31,600,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'SELECT CONCAT(card.class_id,\',\',card.subject_id) as c1, CONCAT(subject.name,if (subject_type.short_name is NULL,\'\',concat(\' (\',subject_type.short_name,\')\'))) as c2\nFROM card\ninner join subject 			on card.subject_id = subject.id \ninner join class 			on card.class_id = class.id\ninner join teacher 			on card.teacher_id = teacher.id\nleft  join subject_type 	on subject.subject_type_id = subject_type.id  \nWHERE \n    card.valid_from =(SELECT max(timetable.start_date) FROM timetable) and   \n    class.id in (select distinct class_id from student_class where student_id=\'#RECORD_ID#\')\nGROUP BY c1,c2\nHAVING SUM(teacher.hide_teaching_calendar)=0\nORDER BY class.short_name,subject.name,subject_type.name DESC\n',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-09-15 21:06:11','globeadmin','2017-11-16 19:02:24','globeadmin','2018-07-25 13:54:15','globeadmin'),('54b2dac10794544','54b2d9dd8417a3d',NULL,NULL,'1',10,NULL,'set_responsible_class',10,10,'Ορισμός Υπευθύνου Τμήματος','Τμήμα :','dropdown',26,63,150,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from class order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-01-11 22:19:13','globeadmin','2015-11-21 20:57:44','globeadmin','2016-09-29 12:46:34','globeadmin'),('54b2db273866aaa','54b2d9dd8417a3d',NULL,NULL,'1',10,NULL,'set_responsible_teacher',20,10,'Ορισμός Υπευθύνου Τμήματος','Καθηγητής :','dropdown',26,320,200,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from teacher order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-01-11 22:20:55','globeadmin','2015-11-21 20:57:54','globeadmin','2016-09-29 12:49:02','globeadmin'),('54b2dbabab261b6','54b2d9dd8417a3d',NULL,NULL,'1',10,NULL,'set_responsible_btn',30,10,'Ορισμός Υπευθύνου Τμήματος','Όρισμός','button',16,649,200,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-01-11 22:23:07','globeadmin','2015-01-11 22:23:07','globeadmin','2016-09-29 12:44:02','globeadmin'),('54b2ddae5823bd9','54b2d9dd8417a3d',NULL,NULL,'1',10,NULL,'set_responsible_info',40,10,'Ορισμός Υπευθύνου Τμήματος',NULL,'iframe',61,38,850,400,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-01-11 22:31:42','globeadmin','2015-11-21 20:59:09','globeadmin','2016-09-29 12:44:02','globeadmin'),('54b5807ac04676e','547372d029461f4',NULL,NULL,'1',10,NULL,'teacher_lessons',10,20,'Αναθέσεις Μαθημάτων',NULL,'iframe',53,14,900,420,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'5494859e9bfaf58','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-01-13 22:30:50','globeadmin','2020-09-22 22:34:19','globeadmin','2021-01-26 20:15:04','globeadmin'),('54b5810e2b5b1c4','547372d029461f4',NULL,NULL,'1',10,NULL,'teacher_Programs',10,30,'Διδασκαλίες',NULL,'iframe',23,16,900,580,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'5a9e7622e307049','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-01-13 22:33:18','globeadmin','2020-09-22 22:34:19','globeadmin','2021-01-26 20:15:05','globeadmin'),('55fdb9f2454ac71','54a433830716b84',NULL,NULL,'0',10,NULL,'delete_allbtn',90,40,'Εργασίες Διαχείρισης',NULL,'html',334,615,220,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_deleteall_id\').src=\'nufileget.php?i=deleteallb\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_deleteall_id\').src=\'nufileget.php?i=deleteall\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=98 height=74 id=\'img_deleteall_id\' src=\'nufileget.php?i=deleteall\' title=\'Διαγραφή όλων των στοιχείων για την έναρξη νέου Σχ. Έτους\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Διαγραφή Όλων</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-09-19 22:39:30','globeadmin','2015-10-03 18:03:26','globeadmin','2015-12-26 21:06:03','globeadmin'),('54d66050a8ff183','54d65f0144e61a3',NULL,NULL,'1',10,NULL,'insert_penaltybtn',70,10,'Εισαγωγή','Εισαγωγή Αρχείου','button',45,506,200,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-02-07 20:58:24','globeadmin','2016-10-15 19:29:52','globeadmin','2018-07-02 09:23:40','globeadmin'),('54d12f5630b1cb7','59e22ed0a598932',NULL,NULL,'1',10,'select if ((select count(grading_period.id) from grading_period, mark\n            where \n                grading_period.id=mark.grading_period_id and\n                grading_period.marks_publication_date<=curdate() and\n                mark.student_id=#RECORD_ID#)>0,\'0\',\'1\')\n    ','student_mark_disp1',30,10,'Αξιολόγηση','Δεν υπάρχει για εσάς δημοσιευμένη αξιολόγηση. Επόμενη δημοσίευση αξιολόγησης στις :','display',20,20,80,40,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select DATE_FORMAT(min(grading_period.marks_publication_date),\'%d-%m-%Y\')\nfrom grading_period, mark\nwhere \ngrading_period.id=mark.grading_period_id and\ngrading_period.marks_publication_date>curdate() and\nmark.student_id=#RECORD_ID#',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',100,250,'2015-02-03 22:28:06','globeadmin','2017-10-15 15:41:42','globeadmin','2017-11-12 16:32:08','globeadmin'),('54d660d64757149','54d65f0144e61a3',NULL,NULL,'1',10,NULL,'insert_penalty_iframe',60,10,'Εισαγωγή',NULL,'iframe',105,16,950,350,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-02-07 21:00:38','globeadmin','2018-07-02 09:23:25','globeadmin','2018-07-02 09:23:40','globeadmin'),('54d6626bb7a3dde','54d65f0144e61a3',NULL,NULL,'1',10,NULL,'upload_penaltybtn',50,10,'Εισαγωγή','Καταχώριση Ποινών','button',45,748,200,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-02-07 21:07:23','globeadmin','2016-10-15 19:29:52','globeadmin','2018-07-02 09:23:40','globeadmin'),('54d66db08e22a01','59e22fca2af8d03',NULL,NULL,'1',10,NULL,'student_penelty',10,10,'Ποινές',NULL,'iframe',10,15,1000,450,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'54d6660b538bea2','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-02-07 21:55:28','globeadmin','2022-01-08 14:18:41','globeadmin','2022-01-08 14:26:20','globeadmin'),('54d66ecc782b951','5476201e5a3d38f',NULL,NULL,'1',10,NULL,'student_penelty',10,90,'Ποινές',NULL,'iframe',94,28,970,410,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'54d6660b538bea2','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-02-07 22:00:12','globeadmin','2015-10-04 21:34:43','globeadmin','2022-01-08 11:37:11','globeadmin'),('59e3728b6656ada','54a6fde1ab6eb6d',NULL,NULL,'1',10,NULL,'vertical_line',180,20,'Στοιχεία Επικοινωνίας',NULL,'html',22,507,5,410,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table style=\"width: 0px; height: 100%; border-color::#b04b00;border-right-width: 1px; border-style: solid;\" border=0>\n<tr>\n<td>\n</td>\n</tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-15 17:36:59','globeadmin','2017-10-15 18:49:01','globeadmin','2021-09-06 20:12:24','globeadmin'),('54db8c2d803988f','54d65f0144e61a3',NULL,NULL,'1',10,NULL,'label1',20,10,'Εισαγωγή','Αρχείο : ','words',53,44,100,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-02-11 19:06:53','globeadmin','2016-10-15 19:29:52','globeadmin','2018-07-02 09:23:40','globeadmin'),('54da28b3bacf20a','54d65f0144e61a3',NULL,NULL,'1',10,NULL,'ifile',30,10,'Εισαγωγή',NULL,'iframe',45,113,350,50,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'54da24749d82eb7','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-02-10 17:50:11','globeadmin','2016-10-15 19:29:52','globeadmin','2018-07-02 09:23:40','globeadmin'),('54df129df29f2cf','54df1259eb4def9',NULL,NULL,'1',10,NULL,'label1',20,10,'Εισαγωγή','Αρχείο : ','words',47,59,100,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-02-14 11:17:18','globeadmin','2015-03-03 08:35:10','globeadmin','2020-04-02 16:11:27','globeadmin'),('54df12d42cdff81','54df1259eb4def9',NULL,NULL,'1',10,NULL,'ifile',30,10,'Εισαγωγή',NULL,'iframe',39,127,350,50,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'54da24749d82eb7','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-02-14 11:18:12','globeadmin','2015-03-03 08:35:10','globeadmin','2020-04-02 16:11:27','globeadmin'),('54df1333abd3c69','54df1259eb4def9',NULL,NULL,'1',10,NULL,'upload_studentbtn',100,10,'Εισαγωγή','Καταχώριση','button',90,748,200,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-02-14 11:19:47','globeadmin','2016-10-15 19:21:39','globeadmin','2020-04-02 16:11:27','globeadmin'),('54df13909abb4c9','54df1259eb4def9',NULL,NULL,'1',10,NULL,'insert_student_iframe',60,10,'Εισαγωγή',NULL,'iframe',137,16,950,350,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-02-14 11:21:20','globeadmin','2018-07-03 13:00:20','globeadmin','2020-04-02 16:11:27','globeadmin'),('54df13eabf5bc61','54df1259eb4def9',NULL,NULL,'1',10,NULL,'insert_studentbtn',50,10,'Εισαγωγή','Εισαγωγή Αρχείου','button',90,31,200,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-02-14 11:22:50','globeadmin','2016-10-15 19:21:39','globeadmin','2020-11-01 11:21:19','globeadmin'),('54df1df0e66be12','54df1dbf0f931e5',NULL,NULL,'1',10,NULL,'label1',20,10,'Εισαγωγή','Αρχείο : ','words',58,44,100,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-02-14 12:05:36','globeadmin','2016-10-15 19:26:30','globeadmin','2020-09-24 18:44:36','globeadmin'),('54df1e23d0714f7','54df1dbf0f931e5',NULL,NULL,'1',10,NULL,'ifile',30,10,'Εισαγωγή',NULL,'iframe',48,112,350,50,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'54da24749d82eb7','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-02-14 12:06:27','globeadmin','2016-10-15 19:26:30','globeadmin','2020-09-24 18:44:36','globeadmin'),('54df1e7fc91fd62','54df1dbf0f931e5',NULL,NULL,'1',10,NULL,'upload_student_classbtn',50,10,'Εισαγωγή','Καταχώριση Κατανομής','button',50,748,200,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-02-14 12:07:59','globeadmin','2016-10-15 19:26:30','globeadmin','2020-09-24 18:44:36','globeadmin'),('54df1eb605cfd4c','54df1dbf0f931e5',NULL,NULL,'1',10,NULL,'insert_student_class_iframe',60,10,'Εισαγωγή',NULL,'iframe',110,16,950,350,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-02-14 12:08:54','globeadmin','2018-07-12 23:43:08','globeadmin','2020-09-24 18:44:36','globeadmin'),('54df1ef9984bd44','54df1dbf0f931e5',NULL,NULL,'1',10,NULL,'insert_student_classbtn',70,10,'Εισαγωγή','Εισαγωγή Αρχείου','button',50,505,200,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-02-14 12:10:01','globeadmin','2016-10-15 19:26:30','globeadmin','2020-09-24 18:44:36','globeadmin'),('55031a2868f6575','5501db35db0c716',NULL,NULL,'1',10,NULL,'period_absence_timeleft_label1',20,10,'Απουσιολόγιο','Εναπομένων Χρόνος','words',12,645,130,40,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-13 19:11:04','globeadmin','2015-03-15 21:59:25','globeadmin','2019-07-02 12:47:12','globeadmin'),('54df21234f0c573','54df20f94548357',NULL,NULL,'1',10,NULL,'label1',30,10,'Εισαγωγή','Αρχείο : ','words',74,42,100,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-02-14 12:19:15','globeadmin','2015-11-28 16:18:00','globeadmin','2020-04-02 16:11:52','globeadmin'),('54df214bc92018c','54df20f94548357',NULL,NULL,'1',10,NULL,'ifile',40,10,'Εισαγωγή',NULL,'iframe',66,99,350,50,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'54da24749d82eb7','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-02-14 12:19:55','globeadmin','2015-11-28 16:18:00','globeadmin','2020-04-02 16:11:52','globeadmin'),('54df21aac43c3d0','54df20f94548357',NULL,NULL,'1',10,NULL,'upload_timetablebtn',110,10,'Εισαγωγή','Καταχώριση Ωρολογίου','button',126,766,200,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-02-14 12:21:30','globeadmin','2016-10-15 19:35:01','globeadmin','2020-04-02 16:12:12','globeadmin'),('54df21e03914ceb','54df20f94548357',NULL,NULL,'1',10,NULL,'insert_timetable_iframe',90,10,'Εισαγωγή',NULL,'iframe',183,16,950,350,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-02-14 12:22:24','globeadmin','2018-07-02 23:10:06','globeadmin','2020-04-02 16:11:52','globeadmin'),('54df221c602520c','54df20f94548357',NULL,NULL,'1',10,NULL,'insert_timetablebtn',100,10,'Εισαγωγή','Εισαγωγή Αρχείου','button',126,16,200,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-02-14 12:23:24','globeadmin','2016-10-15 19:35:01','globeadmin','2020-04-02 16:11:52','globeadmin'),('54e9b9d1c125d86','547489b0d4efe7c',NULL,NULL,'1',10,NULL,'disp_id',100,10,'Λεπτομέρειες','Κωδικός Μαθήματος : ','display',57,82,60,0,'c','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select #RECORD_ID#',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-02-22 13:13:21','globeadmin','2020-09-21 11:44:35','globeadmin','2022-02-14 11:00:18','globeadmin'),('54e61569c6c2b23','54df20f94548357',NULL,NULL,'1',10,NULL,'link1',10,10,'Εισαγωγή','Πρότυπο XML για το ASC Timetables :','html',9,19,70,25,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<a href=\'sample/asc_timetable.xml\' download>Λήψη</a>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-02-19 18:55:05','globeadmin','2015-11-28 16:18:00','globeadmin','2020-04-02 16:11:52','globeadmin'),('54e618f54cb0df5','54df20f94548357',NULL,NULL,'1',10,NULL,'valid_card_dates',70,10,'Εισαγωγή',NULL,'iframe',35,573,400,45,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<a href=\'asc_template.xml\'>Λήψη</a>','54e61e02a705c6d','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-02-19 19:10:13','globeadmin','2016-10-15 19:35:01','globeadmin','2020-04-02 16:11:52','globeadmin'),('54e623c862a9d90','54df20f94548357',NULL,NULL,'1',10,NULL,'label3',60,10,'Εισαγωγή','Ημερομηνίες Ενεργών Ωρολογίων : ','words',12,516,450,35,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-02-19 19:56:24','globeadmin','2016-10-15 19:35:01','globeadmin','2020-04-02 16:11:52','globeadmin'),('54e6e3b00735b80','54df20f94548357',NULL,NULL,'1',10,NULL,'link2',20,10,'Εισαγωγή','Προσοχή! Το αρχείο πρέπει να είναι αποθηκευμένο σε κωδικοποίηση UTF-8.','html',38,20,70,25,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<a href=\'sample/asc_sample.xml\' download>Δείγμα</a>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-02-20 09:35:12','globeadmin','2015-11-28 16:18:00','globeadmin','2020-04-02 16:11:52','globeadmin'),('54e627442811dd8','54df20f94548357',NULL,NULL,'1',10,NULL,'card_date',80,10,'Εισαγωγή','Έναρξη Ισχύος Νέου Ωρολογίου : ','text',88,668,100,45,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<a href=\'asc_template.xml\'>Λήψη</a>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2015-02-19 20:11:16','globeadmin','2016-10-15 19:35:01','globeadmin','2020-04-02 16:11:52','globeadmin'),('54e9bcb192cafcc','5474c1d7bef6b64',NULL,NULL,'1',10,NULL,'disp_id',80,10,'Λεπτομέρειες','Κωδικός Μαθήματος : ','display',20,39,60,0,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select #RECORD_ID#',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-02-22 13:25:37','globeadmin','2015-02-22 13:25:37','globeadmin','2016-01-04 10:17:02','globeadmin'),('59fe03d4090a900','59fe027dd6fe9f8',NULL,NULL,'1',10,NULL,'search_iframe',70,10,'Μαζική Αποστολή Email',NULL,'iframe',530,18,900,1100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from teacher order by short_name',NULL,'59fe057de3b97b4','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-11-04 20:15:48','globeadmin','2017-11-04 20:49:12','globeadmin','2021-10-19 23:36:54','globeadmin'),('54ef61c0c3e3820','54df1259eb4def9',NULL,NULL,'1',10,NULL,'account_creation',90,10,'Εισαγωγή','Δημιουργία και των Αντίστοιχων Χρηστών :','checkbox',51,688,100,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-02-26 20:11:12','globeadmin','2016-10-15 19:21:39','globeadmin','2020-04-02 16:11:27','globeadmin'),('54ef629bd4fa2ec','54df1259eb4def9',NULL,NULL,'1',10,NULL,'link1',10,10,'Εισαγωγή','Δείγμα .xls Αρχείου  : ','html',9,35,70,25,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<a href=\'sample/student.xls\' download>Λήψη</a>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-02-26 20:14:51','globeadmin','2015-03-03 08:35:10','globeadmin','2020-04-02 16:11:27','globeadmin'),('54ef69f9168dded','54d65f0144e61a3',NULL,NULL,'1',10,NULL,'link1',10,10,'Εισαγωγή','Δείγμα .xls Αρχείου  : ','html',12,17,70,25,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<a href=\'sample/penalty.xls\' download>Λήψη</a>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-02-26 20:46:17','globeadmin','2016-10-15 19:29:52','globeadmin','2018-07-02 09:23:39','globeadmin'),('54ef6a2b512445c','54df1dbf0f931e5',NULL,NULL,'1',10,NULL,'link1',10,10,'Εισαγωγή','Δείγμα .xls Αρχείου  : ','html',17,17,70,25,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<a href=\'sample/student_class.xls\' download>Λήψη</a>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-02-26 20:47:07','globeadmin','2016-10-15 19:26:30','globeadmin','2020-09-24 18:44:36','globeadmin'),('565b0608875aeb3','565b05b5e424081',NULL,NULL,'1',10,NULL,'class_id',20,10,'Βαθμολογία','Τμήμα :','dropdown',47,109,150,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'SELECT distinct class.id,class.short_name\nFROM class\nINNER JOIN mark on class.id=mark.class_id\nwhere\nmark.grading_period_id=\'#grading_period_id#\'\nORDER BY class.short_name\n',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-11-29 16:04:56','globeadmin','2015-11-29 16:04:56','globeadmin','2015-11-29 19:36:32','globeadmin'),('5659b978a211ac0','54df20f94548357',NULL,NULL,'1',10,'select if(\'#nu_user_group#\'=\'globeadmin\',\'1\',\'0\')','current_date',120,10,'Εισαγωγή','Τρέχουσα Ημερομηνία : ','display',135,243,100,45,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select CURDATE()','SELECT distinct valid_from,DATE_FORMAT(valid_from,\'%d-%m-%Y\')\nFROM card\nWHERE valid_from>CURDATE()','<a href=\'asc_template.xml\'>Λήψη</a>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2015-11-28 16:26:00','globeadmin','2016-10-15 19:35:01','globeadmin','2020-04-02 16:11:52','globeadmin'),('5659b81c0ab5232','54df20f94548357',NULL,NULL,'1',10,'select if(\'#nu_user_group#\'=\'globeadmin\',\'1\',\'0\')','active_timetables',130,10,'Εισαγωγή','Ενεργά Ωρολόγια : ','dropdown',135,505,100,45,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'SELECT distinct valid_from,DATE_FORMAT(valid_from,\'%d-%m-%Y\')\nFROM card\nWHERE valid_from>CURDATE()\nORDER BY valid_from','<a href=\'asc_template.xml\'>Λήψη</a>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2015-11-28 16:20:12','globeadmin','2016-10-15 19:35:01','globeadmin','2020-04-02 16:11:52','globeadmin'),('59d8862894ea414','548338073921bfe',NULL,NULL,'1',10,NULL,'email',60,40,'Προσωπικά Στοιχεία','Email :','text',267,127,300,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-07 10:45:44','globeadmin','2017-10-07 11:03:00','globeadmin','2022-01-08 10:51:56','globeadmin'),('54f871c9ceb5e0f','547081ceb3d2146','',NULL,'1',10,NULL,'holiday_subform',50,10,'Λεπτομέρειες','Αργίες :','subform',10,552,390,400,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,20,'1','1','school_year_id','id','SELECT * FROM holiday \nWHERE school_year_id = \'#RECORD_ID#\'\norder by holiday.holiday','holiday',NULL,'',NULL,'g',0,0,'0000-00-00 00:00:00','','2015-11-21 20:12:34','globeadmin','2019-11-03 18:27:46','globeadmin'),('59fe02dfd44de6b','59fe027dd6fe9f8',NULL,NULL,'1',10,NULL,'label1',20,10,'Μαζική Αποστολή Email','Μήνυμα :','words',53,28,750,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from class order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-11-04 20:11:43','globeadmin','2017-11-04 20:11:43','globeadmin','2021-10-19 23:36:53','globeadmin'),('59fe03167764286','59fe027dd6fe9f8',NULL,NULL,'1',10,NULL,'email_text_tinymce',30,10,'Μαζική Αποστολή Email',NULL,'iframe',77,22,900,380,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'56cc9f04b82528e','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-11-04 20:12:38','globeadmin','2017-11-04 20:12:38','globeadmin','2021-10-19 23:36:53','globeadmin'),('59fe0355a0cc6e7','59fe027dd6fe9f8',NULL,NULL,'1',10,NULL,'ifile',50,10,'Μαζική Αποστολή Email',NULL,'iframe',472,207,600,50,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from class order by short_name',NULL,'54da24749d82eb7','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-11-04 20:13:41','globeadmin','2017-11-04 20:13:41','globeadmin','2021-10-19 23:36:54','globeadmin'),('59fe0391a09b48d','59fe027dd6fe9f8',NULL,NULL,'0',10,NULL,'remove_attachment_img',60,10,'Μαζική Αποστολή Email',NULL,'html',481,39,19,19,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"this.style.cursor=\'pointer\';\"\n                            onmouseout=\"this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=17 height=17 id=\'img_remove_attachment\' src=\'images/reset_pass.png\' title=\'Επαναφορά Συνημμένου\'/>\n        </td>\n    </tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-11-04 20:14:41','globeadmin','2017-11-04 20:14:41','globeadmin','2021-10-19 23:36:54','globeadmin'),('59fe02c1a605468','59fe027dd6fe9f8',NULL,NULL,'1',10,NULL,'label2',30,10,'Μαζική Αποστολή Email','Επισύναψη Αρχείου : ','words',481,66,150,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from class order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-11-04 20:11:13','globeadmin','2017-11-04 20:11:13','globeadmin','2021-10-19 23:36:53','globeadmin'),('54f871c9d607370','54f871c9ceb5e0f',NULL,NULL,'1',10,NULL,'holiday',10,10,'Details','Ημερομηνία','text',0,0,100,0,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-03-06 20:35:43','globeadmin','2018-07-20 17:48:41','globeadmin'),('54f89e510dd534c','54f871c9ceb5e0f',NULL,NULL,'1',10,NULL,'description',20,10,'Details','Περιγραφή','text',0,0,220,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-03-05 20:20:01','globeadmin','2015-03-05 20:35:35','globeadmin','2018-07-20 17:23:07','globeadmin'),('54f89f95411a754','547081ceb3d2146',NULL,NULL,'1',10,NULL,'find_holidaysbtn',60,10,'Λεπτομέρειες','Εύρεση Αργιών','button',427,634,200,35,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',100,250,'2015-03-05 20:25:25','globeadmin','2015-11-22 09:46:48','globeadmin','2019-11-03 18:27:46','globeadmin'),('54fdb0cd8e94a69','54f735c7d56625f',NULL,NULL,'1',10,NULL,'form_absencebtn',50,10,'Απουσιολόγιο','Καταχώριση Απουσιών','button',29,449,200,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-09 16:40:13','globeadmin','2015-03-12 21:18:03','globeadmin','2022-09-24 23:06:18','globeadmin'),('5501320972642a9','59d7d6e9ecc73da',NULL,NULL,'0',10,'select if(\'#nu_user_group#\'=\'globeadmin\' OR count(*)>0,\'1\',\'0\') \nfrom class \nwhere post_teacher_id=#RECORD_ID#','abcence_classbtn',70,10,'Εργασίες Απουσιών',NULL,'html',50,687,220,100,'l','0','0','','0',NULL,NULL,'#RECORD_ID#','54f735c7d56625f',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_dabsen_id\').src=\'images/dabsenb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_dabsen_id\').src=\'images/dabsen.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_dabsen_id\' src=\'images/dabsen.png\' title=\'Καταχώριση απουσιών τμήματος για ολόκληρη την ημέρα\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Καταχώριση Aπουσιών Hμέρας</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-12 08:28:25','globeadmin','2017-10-07 01:10:19','globeadmin','2021-02-27 09:46:56','globeadmin'),('5501e21801c55be','59d7d6e9ecc73da',NULL,NULL,'0',10,NULL,'abcence_periodbtn',10,10,'Εργασίες Απουσιών',NULL,'html',50,73,220,100,'l','0','0','','0',NULL,NULL,'#RECORD_ID#','5501db35db0c716',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_pabsen_id\').src=\'images/pabsenb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_pabsen_id\').src=\'images/pabsen.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_pabsen_id\' src=\'images/pabsen.png\' title=\'Καταχώριση απουσιών για μια διδασκαλία\'/>\n            <img style=\"position: absolute;bottom: 35px;left: 150px;display: none;\" width=20 height=20 id=\'ab_warning_id\' src=\'images/warning.png\' title=\'\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Καταχώριση Aπουσιών</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-12 20:59:36','globeadmin','2021-02-26 22:35:19','globeadmin','2021-02-27 09:46:56','globeadmin'),('55127beea98c3f9','59d7d6e9ecc73da',NULL,NULL,'1',10,NULL,'absence_searchbtn',20,10,'Εργασίες Απουσιών',NULL,'html',192,73,220,100,'l','0','0','','0',NULL,NULL,'#RECORD_ID#','55127aebdf42446',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_search_id\').src=\'images/searchb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_search_id\').src=\'images/search.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_search_id\' src=\'images/search.png\' title=\'Αναζήτηση Απουσιών\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Αναζήτηση Απουσιών</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-25 11:12:14','globeadmin','2017-10-07 01:10:19','globeadmin','2021-02-27 09:46:56','globeadmin'),('5501e6395c1a1b6','5501db35db0c716',NULL,NULL,'1',10,NULL,'period_absence_iframe',70,10,'Απουσιολόγιο',NULL,'iframe',63,14,900,1330,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-12 21:17:13','globeadmin','2015-03-17 09:09:54','globeadmin','2019-07-02 12:47:13','globeadmin'),('55031fb38161b9d','5a54c08c836c142',NULL,NULL,'1',10,NULL,'set_absence_time_limit',20,10,'Παράμετροι','Χρονικό όριο για τη καταχώριση των απουσιών στην τάξη (00:00:00 για μέχρι το τέλος της ώρας) :','text',55,19,80,0,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-03-13 19:34:43','globeadmin','2018-02-03 23:21:16','globeadmin','2022-09-24 23:21:52','globeadmin'),('55045024ae6a0d1','5501db35db0c716',NULL,NULL,'1',10,NULL,'period_absence_timeleft_label2',30,10,'Απουσιολόγιο','για τη Καταχώριση','words',31,645,130,40,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-14 17:13:40','globeadmin','2015-03-15 21:59:43','globeadmin','2019-07-02 12:47:12','globeadmin'),('55040b2c78b50b7','5501db35db0c716',NULL,NULL,'1',10,NULL,'period_absence_timeleft_disp',50,10,'Απουσιολόγιο',NULL,'display',102,763,120,40,'c','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','SELECT \nif (\n	TIMEDIFF(period.end_time,CURTIME())<\n	TIMEDIFF(AddTime(period.start_time,if((school.set_absence_time_limit is NULL) OR (school.set_absence_time_limit =\'\') OR (school.set_absence_time_limit =\'00:00:00\'),\'23:59:59\',school.set_absence_time_limit)),CURTIME()),\n	if(TIMEDIFF(period.end_time,CURTIME())<\'00:00:00\',convert(\'00:00:00\',TIME),TIMEDIFF(period.end_time,CURTIME())),\n	if(TIMEDIFF(AddTime(period.start_time,if((school.set_absence_time_limit is NULL) OR (school.set_absence_time_limit =\'\') OR (school.set_absence_time_limit =\'00:00:00\'),\'23:59:59\',school.set_absence_time_limit)),CURTIME())<\'00:00:00\',convert(\'00:00:00\',TIME),TIMEDIFF(AddTime(period.start_time,if((school.set_absence_time_limit is NULL) OR (school.set_absence_time_limit =\'\') OR (school.set_absence_time_limit =\'00:00:00\'),\'23:59:59\',school.set_absence_time_limit)),CURTIME()))\n	)\nFROM card,period,school\nwhere\n    card.valid_from     = (select max(timetable.start_date) from timetable where (timetable.start_date <= curdate())) and\n	card.period_id      = period.id and\n    card.day_id         = DAYOFWEEK(CURDATE())-2 and\n    CURTIME() between period.start_time and period.end_time and\n    teacher_id          = \'#RECORD_ID#\' and \n    card.id not in (   select registered_card.card_id \n                                        from registered_card \n                                        where registered_card.card_date=CURDATE()) and\n    CURDATE() not in (select holiday.holiday from holiday)',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-14 12:19:24','globeadmin','2016-01-04 11:08:49','globeadmin','2019-07-02 12:47:12','globeadmin'),('55044f4c5b6748e','5501db35db0c716',NULL,NULL,'1',10,NULL,'period_absence_setbtn',60,10,'Απουσιολόγιο','Καταχώριση','button',14,383,180,35,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-14 17:10:04','globeadmin','2016-03-19 22:24:31','globeadmin','2019-07-02 12:47:13','globeadmin'),('55040e47d578a0d','5501db35db0c716',NULL,NULL,'1',10,NULL,'period_absence_class',10,10,'Απουσιολόγιο','Τμήμα :','dropdown',24,98,100,40,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'SELECT  class.id,class.short_name\nFROM card,period,class,school\nwhere\n    card.valid_from =(select max(timetable.start_date) from timetable where (timetable.start_date <= curdate())) and\n	card.period_id=period.id and\n    card.class_id=class.id and\n	card.day_id=DAYOFWEEK(CURDATE())-2 and\n    CURTIME() between period.start_time and period.end_time and\n    teacher_id=\'#RECORD_ID#\'',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-14 12:32:39','globeadmin','2016-07-14 23:19:42','globeadmin','2019-07-02 12:47:12','globeadmin'),('5b58150802802f1','nuhome',NULL,NULL,'1',10,NULL,'frame3html',20,10,'Globeadmin',NULL,'html',35,669,300,380,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<html>\n<body>\n<table width=100% height=100% border=1  cellspacing=0 bordercolor=red><tr><td></td></tr><table>\n</body>\n</html>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-07-25 09:13:28','globeadmin','2018-07-25 09:13:28','globeadmin','2018-07-25 09:13:28','globeadmin'),('5b5db6b4a673cc0','5470b3806384141',NULL,NULL,'1',10,NULL,'number_of_teachers',30,10,'Λεπτομέρειες','Αριθμός Καθηγητών :','display',226,51,60,0,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','SELECT COUNT(*)\nFROM teacher\nWHERE teaching_field_id = \'#RECORD_ID#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2018-07-29 15:44:36','globeadmin','2018-07-29 15:44:36','globeadmin','2018-08-05 11:34:36','globeadmin'),('5509671b695afd1','5509671b4e81a07',NULL,NULL,'1',10,NULL,'post_teacher_iddsp',70,10,'Λεπτομέρειες','Καταχωρήθηκε από : ','display',191,101,200,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select short_name from teacher where id=#post_teacher_id#',NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-03-21 14:56:07','globeadmin','2022-10-05 20:27:42','globeadmin'),('5509671b70adfdc','5509671b4e81a07',NULL,NULL,'1',10,NULL,'student_iddsp',10,10,'Λεπτομέρειες','Μαθητής : ','display',25,166,450,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select concat(registration_number,\' - \',surname,\' \',name,\' πατ. \',fathers_name) from student where id=#student_id#',NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-03-21 14:54:24','globeadmin','2022-10-05 20:27:42','globeadmin'),('5509671b7f53fbc','5509671b4e81a07',NULL,NULL,'1',10,NULL,'absence_reason_id',50,10,'Λεπτομέρειες','Λόγος Απουσίας : ','dropdown',159,121,200,0,'l','1','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select name from absence_reason where id=#absence_reason_id#','select id,name from absence_reason',NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-10-29 19:32:57','globeadmin','2022-10-05 20:27:42','globeadmin'),('5509671b86a6eed','5509671b4e81a07',NULL,NULL,'1',10,NULL,'comments',100,10,'Λεπτομέρειες','Παρατηρήσεις : ','textarea',223,135,450,90,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-03-21 14:54:52','globeadmin','2022-10-05 20:27:42','globeadmin'),('5509671b8df9f39','5509671b4e81a07',NULL,NULL,'1',10,NULL,'justifieddisp',110,10,'Λεπτομέρειες','Διακαιολογημένη : ','display',345,119,50,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select if(#justified#=0,\'Όχι\',\'Ναι\')',NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-03-18 21:18:42','globeadmin','2022-10-05 20:27:42','globeadmin'),('5509671b954cf10','5509671b4e81a07',NULL,NULL,'1',10,NULL,'justified_when',130,10,'Λεπτομέρειες','στις : ','text',377,503,140,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'0000-00-00 00:00:00','','2015-03-18 22:06:14','globeadmin','2022-10-05 20:27:42','globeadmin'),('5509671b9c9fe53','5509671b4e81a07',NULL,NULL,'1',10,NULL,'countsdisp',60,10,'Λεπτομέρειες','Προσμετρείται : ','display',159,536,50,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select if(#counts#=0,\'Όχι\',\'Ναι\')',NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-03-18 21:47:50','globeadmin','2022-10-05 20:27:42','globeadmin'),('5509671ba3f2e6f','5509671b4e81a07',NULL,NULL,'1',10,NULL,'justified_teacher_iddisp',120,10,'Λεπτομέρειες','Διακαιολογήθηκε από : ','display',377,91,200,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select short_name from teacher where id=ifnull(\'#justified_teacher_id#\',0)',NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-03-21 14:56:22','globeadmin','2022-10-05 20:27:42','globeadmin'),('5509b227a6eb95a','5509671b4e81a07',NULL,NULL,'1',10,NULL,'perioddisp',30,10,'Λεπτομέρειες','Ώρα Απουσίας : ','display',57,502,80,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select period.name from period,card where card.id=#card_id# and card.period_id=period.id',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2015-03-18 19:13:11','globeadmin','2015-03-18 21:05:50','globeadmin','2022-10-05 20:27:42','globeadmin'),('5509b2f116df0e8','5509671b4e81a07',NULL,NULL,'1',10,NULL,'subjectdisp',40,10,'Λεπτομέρειες','Μάθημα : ','display',89,168,450,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select subject.name from subject,card where card.id=#card_id# and card.subject_id=subject.id',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2015-03-18 19:16:33','globeadmin','2015-03-21 14:54:38','globeadmin','2022-10-05 20:27:42','globeadmin'),('5509cea2b590299','5509671b4e81a07',NULL,NULL,'1',10,NULL,'server_date',90,10,'Λεπτομέρειες',' ','display',255,292,70,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select curdate()',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-03-18 21:14:42','globeadmin','2015-03-18 21:18:42','globeadmin','2022-10-05 20:27:42','globeadmin'),('5509d559ba7393b','5509671b4e81a07',NULL,NULL,'1',10,NULL,'justified_reasondisp',140,10,'Λεπτομέρειες','Αιτιολογία Δικαιολόγησης : ','display',409,75,300,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select name \nfrom justified_reason \nwhere id = if(\'#justified_reason_id#\' is NULL OR \'#justified_reason_id#\'=\'\',\'-1\',\'#justified_reason_id#\')',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2015-03-18 21:43:21','globeadmin','2021-02-03 20:06:20','globeadmin','2022-10-05 20:27:42','globeadmin'),('5509db6673a4f2d','5509671b4e81a07',NULL,NULL,'1',10,NULL,'justified_comments',150,10,'Λεπτομέρειες','Παρατηρήσεις Δικαιολόγησης : ','textarea',442,49,450,80,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-03-18 22:09:10','globeadmin','2015-03-22 15:23:57','globeadmin','2022-10-05 20:27:43','globeadmin'),('550dbae5b717c4e','550dbae55f33b5f',NULL,NULL,'1',10,NULL,'proceeded_when',70,10,'Λεπτομέρειες','Ημερομηνία Διεκπεραίωσης : ','text',267,17,150,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-03-21 20:59:22','globeadmin','2021-03-24 11:13:51','globeadmin'),('550dbae599cbafb','550dbae55f33b5f',NULL,NULL,'1',10,NULL,'added_when',20,10,'Λεπτομέρειες','Ημερομηνία Καταχώρισης : ','text',44,28,150,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-03-21 21:08:21','globeadmin','2021-03-24 11:13:51','globeadmin'),('550dbae5a871a6b','550dbae55f33b5f',NULL,NULL,'1',10,NULL,'proceededdsp',50,10,'Λεπτομέρειες','Έχει Διαπεραιωθεί :','display',208,74,60,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select if(#proceeded#,\'Ναί\',\'Όχι\')',NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-03-21 21:44:45','globeadmin','2021-03-24 11:13:51','globeadmin'),('550dbae58b25a84','550dbae55f33b5f',NULL,NULL,'1',10,NULL,'comments',40,10,'Λεπτομέρειες','Σχόλια Αίτησης : ','textarea',102,90,350,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-03-21 21:44:45','globeadmin','2021-03-24 11:13:51','globeadmin'),('550dbae57c808e6','550dbae55f33b5f',NULL,NULL,'1',10,NULL,'justification_request_reason_id',30,10,'Λεπτομέρειες','Λόγος Αίτησης : ','dropdown',74,93,200,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,name from justification_request_reason',NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-03-21 21:44:45','globeadmin','2021-03-24 11:13:51','globeadmin'),('550dbae56dda40e','550dbae55f33b5f',NULL,NULL,'1',10,NULL,'post_teacher_id',10,10,'Λεπτομέρειες','Καθηγητής : ','display',15,114,200,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select short_name from teacher where id=ifnull(\'#post_teacher_id#\',-1)',NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-03-26 19:23:27','globeadmin','2021-03-24 11:13:51','globeadmin'),('550d4593873edeb','5509671b4e81a07',NULL,NULL,'1',10,'select if(\n    \'#nu_user_group#\'=\'Managers\' OR \n    \'#nu_user_group#\'=\'AssistManagers\' OR \n    \'#nu_user_group#\'=\'Teachers\' OR \n    \'#nu_user_group#\'=\'Secretaries\' OR\n    \'#nu_user_group#\'=\'Administrators\' OR\n    \'#nu_user_group#\'=\'Psychologists\' OR\n    \'#nu_user_group#\'=\'globeadmin\' \n    ,\'1\',\'0\')','justification_requestbtn',10,20,'Αιτήματα Διαγραφής','Καταχώριση Νέου Αιτήματος','button',28,42,200,35,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-03-21 12:18:59','globeadmin','2021-03-09 14:49:16','globeadmin','2022-10-05 20:27:43','globeadmin'),('550d53916ed4df6','5509671b4e81a07',NULL,NULL,'1',10,NULL,'justification_requests_iframe',20,20,'Αιτήματα Διαγραφής',NULL,'iframe',73,16,750,400,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'550d4eea3e00a18','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-03-21 13:18:41','globeadmin','2018-08-04 11:51:37','globeadmin','2022-10-05 20:27:43','globeadmin'),('552538cf8eb3827','nuhome',NULL,NULL,'1',10,NULL,'framehtml',10,10,'Globeadmin',NULL,'html',36,12,300,380,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<html>\n<body>\n<table width=100% height=100% border=1  cellspacing=0 bordercolor=red><tr><td></td></tr><table>\n</body>\n</html>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-04-08 17:18:55','globeadmin','2016-11-19 09:50:18','globeadmin','2016-11-19 09:51:01','globeadmin'),('550dc0209007de1','550dbae55f33b5f',NULL,NULL,'1',10,NULL,'proceeded_comments',80,10,'Λεπτομέρειες','Σχόλια Έγκρισης/Απόρριψης : ','textarea',296,12,350,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-03-21 21:01:52','globeadmin','2015-03-21 21:01:52','globeadmin','2021-03-24 11:13:52','globeadmin'),('550dc904704accb','550dbae55f33b5f',NULL,NULL,'1',10,NULL,'proceeded_teacher_iddsp',60,10,'Λεπτομέρειες','Διεκπεραιώθηκε από : ','display',237,57,200,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select short_name from teacher where id=IFNULL(\'#proceeded_teacher_id#\',-1)',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2015-03-21 21:39:48','globeadmin','2015-03-21 21:44:45','globeadmin','2021-03-24 11:13:51','globeadmin'),('550dca97afc51ac','550dbae55f33b5f',NULL,NULL,'1',10,'select if((not \'#proceeded#\') and \'#nu_user_group#\'=\'Managers\',\'1\',\'0\')','declinebtn',90,10,'Λεπτομέρειες','Απόρριψη','button',405,191,150,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2015-03-21 21:46:31','globeadmin','2015-03-21 21:52:41','globeadmin','2021-03-24 11:13:52','globeadmin'),('550dcb07508dc56','550dbae55f33b5f',NULL,NULL,'1',10,'select if((not \'#proceeded#\') and \'#nu_user_group#\'=\'Managers\',\'1\',\'0\')','approvebtn',100,10,'Λεπτομέρειες','Έγκριση','button',405,393,150,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2015-03-21 21:48:23','globeadmin','2015-03-26 19:35:01','globeadmin','2021-03-24 11:13:52','globeadmin'),('550e7b696db12c5','nuhome',NULL,NULL,'1',10,NULL,'idbtn',40,10,'Globeadmin','Δημιουγργία Νέου ID','button',288,64,200,35,'l','0','0','','0',NULL,NULL,'-1','550e7a89ef1692e',NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-22 10:20:57','globeadmin','2016-03-06 11:10:25','globeadmin','2016-05-12 17:13:05','globeadmin'),('550e7c128d6e4ec','550e7a89ef1692e',NULL,NULL,'1',10,NULL,'id',20,10,'Δημιουργία','Νέο ID','text',105,82,200,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-22 10:23:46','globeadmin','2015-03-22 10:25:51','globeadmin','2015-09-19 15:09:34','globeadmin'),('550e7c52617a9bb','550e7a89ef1692e',NULL,NULL,'1',10,NULL,'idbtn',10,10,'Δημιουργία','Δημιουργία','button',36,120,200,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-22 10:24:50','globeadmin','2015-03-22 10:24:50','globeadmin','2016-09-25 13:58:34','globeadmin'),('55127b84875e51e','55127aebdf42446',NULL,NULL,'1',10,NULL,'class_id',80,10,'Αναζήτηση','Τμήμα όπου έγινε η απουσία : ','listbox',132,26,150,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select distinct class.id,class.short_name \nfrom class\ninner join student_class on class.id=student_class.class_id\norder by class.short_name',NULL,'','','select distinct class.id,class.short_name \nfrom class\ninner join student_class on class.id=student_class.class_id\norder by class.short_name',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-25 11:10:28','globeadmin','2018-08-05 10:38:21','globeadmin','2020-10-08 23:42:28','globeadmin'),('55127ccbb0de71b','55127aebdf42446',NULL,NULL,'1',10,NULL,'from_date',20,10,'Αναζήτηση','Από : ','text',43,166,80,30,'r','0','0','select curdate()','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2015-03-25 11:15:55','globeadmin','2015-03-31 08:50:42','globeadmin','2020-10-08 23:42:28','globeadmin'),('55127cec20d42cc','55127aebdf42446',NULL,NULL,'1',10,NULL,'to_date',30,10,'Αναζήτηση','Έως : ','text',43,332,80,30,'r','0','0','select curdate()','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2015-03-25 11:16:28','globeadmin','2015-03-31 08:51:23','globeadmin','2020-10-08 23:42:28','globeadmin'),('55127dcf345abf4','55127aebdf42446',NULL,NULL,'1',10,NULL,'student_id',110,10,'Αναζήτηση','Μαθητής : ','listbox',175,139,400,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select student.id,concat(ifNULL(grade.short_name,\'\'),\' - \',student.surname,\' \',student.name,\' \',student.fathers_name) \nfrom student \nleft join grade on grade.id = student.grade_id\norder by student.grade_id,student.surname,student.name,student.fathers_name',NULL,'','','select student.id,concat(ifNULL(grade.short_name,\'\'),\' - \',student.surname,\' \',student.name,\' \',student.fathers_name) \nfrom student \nleft join grade on grade.id = student.grade_id\norder by student.grade_id,student.surname,student.name,student.fathers_name',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-25 11:20:15','globeadmin','2016-12-25 12:11:56','globeadmin','2020-10-08 23:42:28','globeadmin'),('551280cbbf8530f','55127aebdf42446',NULL,NULL,'1',10,NULL,'absence_teacher_id',120,10,'Αναζήτηση','Καταχωρίστηκε από :','listbox',221,79,350,0,'l','0','0','select #RECORD_ID#','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from teacher order by short_name',NULL,'','','select id,concat(ifNULL(surname,\'\'),if(surname is NULL OR name is NULL,\'\', \' \' ),ifNULL(name,\'\')) as fname\nfrom teacher \norder by fname',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-25 11:32:59','globeadmin','2018-08-05 00:20:26','globeadmin','2020-10-08 23:42:28','globeadmin'),('551282686ef2fcf','55127aebdf42446',NULL,NULL,'1',10,NULL,'label1',10,10,'Αναζήτηση','Επιλέξτε από τα παρακάτω κριτήρια αναζήτησης. Αφήνοντας κενό ένα κριτήριο, εμφανίζονται όλες οι αντίστοιχες απουσίες.','words',17,15,750,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from class order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-25 11:39:52','globeadmin','2015-03-25 19:39:56','globeadmin','2020-10-08 23:42:28','globeadmin'),('5512837f7d9a410','55127aebdf42446',NULL,NULL,'1',10,NULL,'searchbtn',130,10,'Αναζήτηση','Αναζήτηση','button',273,63,150,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from teacher order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-25 11:44:31','globeadmin','2016-05-15 20:34:43','globeadmin','2020-10-08 23:42:28','globeadmin'),('55128485122ca74','55127aebdf42446',NULL,NULL,'1',10,NULL,'search_iframe',150,10,'Αναζήτηση',NULL,'iframe',328,14,1000,200,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from teacher order by short_name',NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-25 11:48:53','globeadmin','2018-06-13 10:12:03','globeadmin','2021-04-01 10:49:08','globeadmin'),('551a35d0440a3b2','551a34a930825c0',NULL,NULL,'1',10,NULL,'to_date',30,10,'Αναζήτηση','Απουσίες Έως : ','text',50,242,80,30,'r','0','0','select curdate()','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2015-03-31 08:51:12','globeadmin','2015-04-01 10:32:32','globeadmin','2018-08-04 11:47:36','globeadmin'),('55128b5d47e445a','55127aebdf42446',NULL,NULL,'1',10,NULL,'current_date',140,10,'Αναζήτηση','Τρέχουσα Ημ/νια : ','display',353,369,80,30,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select DATE_FORMAT(curdate(),\'%d-%m-%Y\')',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-25 12:18:05','globeadmin','2016-05-15 20:34:43','globeadmin','2020-10-08 23:42:28','globeadmin'),('55129303800b34e','55127aebdf42446',NULL,NULL,'1',10,NULL,'period_id',40,10,'Αναζήτηση','Ώρα : ','listbox',42,504,80,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,name from period order by short_name',NULL,'','','select id,name from period order by short_name',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-25 12:50:43','globeadmin','2016-12-24 16:39:02','globeadmin','2020-10-08 23:42:28','globeadmin'),('5512948f171035b','55127aebdf42446',NULL,NULL,'1',10,NULL,'justified',50,10,'Αναζήτηση','Δικαιολογημένη ή Διαγραμμένη : ','dropdown',88,11,60,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'1|Ναι|0|Όχι',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-25 12:57:19','globeadmin','2018-08-05 00:26:38','globeadmin','2020-10-08 23:42:28','globeadmin'),('551295055b6c4d7','55127aebdf42446',NULL,NULL,'1',10,NULL,'counts',70,10,'Αναζήτηση','Μετράει :','dropdown',88,878,60,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'1|Ναι|0|Όχι',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-25 12:59:17','globeadmin','2016-12-24 16:57:29','globeadmin','2020-10-08 23:42:28','globeadmin'),('5512aa9f05f9517','55127aebdf42446',NULL,NULL,'1',10,NULL,'subject_id',90,10,'Αναζήτηση','Μάθημα : ','listbox',132,514,400,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select subject.id,concat(grade.short_name,section.abbreviation,if(section.abbreviation!=speciality.abbreviation,speciality.abbreviation,\'\'),\'-\',subject.name,\'-\',ifNull(subject_type.short_name,\'\'))\nfrom subject\ninner join grade on subject.grade_id=grade.id\ninner join speciality on subject.speciality_id=speciality.id\ninner join section on speciality.section_id=section.id\nleft  join subject_type on subject.subject_type_id=subject_type.id\nwhere subject.id in \n    (   select distinct subject_id\n        from card\n        where   card.valid_from =(select max(timetable.start_date) from timetable where (timetable.start_date <= curdate())) and\n                class_id is not NULL\n        )\norder by grade.short_name,section.abbreviation,speciality.abbreviation,subject.name',NULL,'','','select subject.id,concat(grade.short_name,section.abbreviation,if(section.abbreviation!=speciality.abbreviation,speciality.abbreviation,\'\'),\'-\',subject.name,\'-\',ifNull(subject_type.short_name,\'\'))\nfrom subject\ninner join grade on subject.grade_id=grade.id\ninner join speciality on subject.speciality_id=speciality.id\ninner join section on speciality.section_id=section.id\nleft  join subject_type on subject.subject_type_id=subject_type.id\nwhere subject.id in \n    (   select distinct subject_id\n        from card\n        where   card.valid_from =(select max(timetable.start_date) from timetable where (timetable.start_date <= curdate())) and\n                class_id is not NULL\n        )\norder by grade.short_name,section.abbreviation,speciality.abbreviation,subject.name',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-25 14:31:27','globeadmin','2018-08-05 00:15:17','globeadmin','2021-10-28 17:20:58','globeadmin'),('5512f489abfd236','55127aebdf42446',NULL,NULL,'1',10,NULL,'hide_has_left_school',100,10,'Αναζήτηση','Εξαίρεση μαθητών που έχουν εγκαταλείψει : ','dropdown',177,673,60,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'1|Ναι',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-25 19:46:49','globeadmin','2015-03-25 19:50:23','globeadmin','2020-10-08 23:42:28','globeadmin'),('5517dc6680285a1','59e22f9965b5362',NULL,NULL,'1',10,'SELECT IF(\'#nu_user_group#\'=\'Students\' AND hide_student_absence=1,\'0\',\'1\')\nFROM school WHERE id=1','absence_counts_sum_disp',90,10,'Απουσίες','Σύνολο μετρήσιμων απουσιών :','display',84,146,50,30,'c','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select count(*)+ifNULL(student.prev_an_justified_absences,0)+ifNULL(student.prev_justified_absences,0) \nfrom absence\ninner join student on student.id = \'#RECORD_ID#\'\nwhere student_id=\'#RECORD_ID#\' and counts=1;',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-29 14:05:10','globeadmin','2021-03-09 20:45:51','globeadmin','2021-03-09 20:45:51','globeadmin'),('5517dfd7913d406','59e22f9965b5362',NULL,NULL,'1',10,'select \'0\'','prev_justified_absences',30,10,'Απουσίες','Δικαιολογημένες μετρήσιμες απουσίες ΕΚΤΟΣ συστήματος : ','text',16,1028,50,30,'r','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-29 14:19:51','globeadmin','2018-03-08 21:46:56','globeadmin','2020-04-02 16:25:30','globeadmin'),('5517e0420fd87f5','59e22f9965b5362',NULL,NULL,'1',10,'select \'0\'','prev_an_justified_absences',10,10,'Απουσίες','Αδικαιολόγητες απουσίες ΕΚΤΟΣ συστήματος :  ','text',27,1016,50,30,'r','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-29 14:21:38','globeadmin','2018-03-08 21:46:40','globeadmin','2020-04-02 16:25:30','globeadmin'),('5517e19a5434623','59e22f9965b5362',NULL,NULL,'1',10,'select \'0\'','unjustified_absence_sum_disp',60,10,'Απουσίες','Σύνολο Αδικαιολόγητων Απουσιών :  ','display',54,1028,50,30,'c','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select count(*)+\'#prev_an_justified_absences#\' from absence where student_id=\'#RECORD_ID#\' and counts=1 and justified=0;',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-29 14:27:22','globeadmin','2018-03-08 21:07:42','globeadmin','2020-04-02 16:25:31','globeadmin'),('5517e24985084e0','59e22f9965b5362',NULL,NULL,'1',10,'select \'0\'','justified_absence_sum_disp',70,10,'Απουσίες','Σύνολο Δικαιολογημένων Μετρήσιμων Απουσιών :  ','display',43,1014,50,30,'c','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select count(*)+\'#prev_justified_absences#\' from absence where student_id=\'#RECORD_ID#\' and counts=1 and justified=1;',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-29 14:30:17','globeadmin','2018-03-08 21:07:58','globeadmin','2020-04-02 16:25:31','globeadmin'),('5517ecdf199c3b3','59e22f9965b5362',NULL,NULL,'1',10,'SELECT IF(\'#nu_user_group#\'=\'Students\' AND hide_student_absence=1,\'0\',\'1\')\nFROM school WHERE id=1','justified_absence_nocounts_disp',80,10,'Απουσίες','Μη Μετρήσιμες (Διαγραμμένες) Απουσίες :','display',84,447,50,30,'c','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select count(*) from absence where student_id=\'#RECORD_ID#\' and counts=0 and justified=1;',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-29 15:15:27','globeadmin','2019-11-13 12:57:12','globeadmin','2020-04-02 16:25:31','globeadmin'),('5518302a088531b','551821232f9553f',NULL,NULL,'1',10,NULL,'current_month_first_date',120,10,'Αναζήτηση','Πρώτη μέρα του μήνα : ','display',215,71,80,30,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select DATE_FORMAT(curdate(),\'01-%m-%Y\')',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-29 20:02:34','globeadmin','2016-07-14 19:33:06','globeadmin','2018-08-04 20:57:32','globeadmin'),('5517ee1c14bc7ad','59e22f9965b5362',NULL,NULL,'1',10,'select \'0\'','unjustified_absence_disp',30,10,'Απουσίες','Αδικαιολόγητες Απουσίες ΕΝΤΟΣ Συστήματος :  ','display',35,1028,50,30,'r','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select count(*) from absence where student_id=\'#RECORD_ID#\' and counts=1 and justified=0;',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-29 15:20:44','globeadmin','2018-03-08 21:06:42','globeadmin','2020-04-02 16:25:31','globeadmin'),('5517eefa8297503','59e22f9965b5362',NULL,NULL,'1',10,'select \'0\'','justified_absence_disp',40,10,'Απουσίες','Δικαιολογημένες Μετρήσιμες Απουσίες ΕΝΤΟΣ Συστήματος : ','display',45,1027,50,30,'r','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select count(*) from absence where student_id=\'#RECORD_ID#\' and counts=1 and justified=1;',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-29 15:24:26','globeadmin','2018-03-08 21:06:58','globeadmin','2020-04-02 16:25:31','globeadmin'),('55181c36cbd6eac','59e22f9965b5362',NULL,NULL,'1',10,'SELECT IF(\'#nu_user_group#\'=\'Students\' AND hide_student_absence=1,\'0\',\'1\')\nFROM school WHERE id=1','search_student_absencebtn',100,10,'Απουσίες',NULL,'html',13,783,180,100,'c','0','0','','0',NULL,NULL,'#RECORD_ID#','551821232f9553f',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_search_id\').src=\'images/searchb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_search_id\').src=\'images/search.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_search_id\' src=\'images/search.png\' title=\'Αναζητήστε με κριτήρια μία προς μία τις απουσίες σας\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Αναζήτηση Απουσιών</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-29 18:37:26','globeadmin','2019-11-13 12:58:51','globeadmin','2020-04-02 16:25:31','globeadmin'),('5518221796237e3','551821232f9553f',NULL,NULL,'1',10,NULL,'label1',10,10,'Αναζήτηση','Επιλέξτε από τα παρακάτω κριτήρια αναζήτησης. Αφήνοντας κενό ένα κριτήριο, εμφανίζονται όλες οι αντίστοιχες απουσίες.','words',16,20,750,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from class order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-29 19:02:31','globeadmin','2015-03-29 19:02:31','globeadmin','2018-08-04 20:57:31','globeadmin'),('55182239d32859d','551821232f9553f',NULL,NULL,'1',10,NULL,'from_date',20,10,'Αναζήτηση','Από : ','text',49,14,80,30,'r','0','0','select curdate()','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from class order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2015-03-29 19:03:05','globeadmin','2015-03-29 19:03:05','globeadmin','2018-08-04 20:57:31','globeadmin'),('551822528c5b4f0','551821232f9553f',NULL,NULL,'1',10,NULL,'to_date',30,10,'Αναζήτηση','Έως : ','text',49,162,80,30,'r','0','0','select curdate()','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from class order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2015-03-29 19:03:30','globeadmin','2015-03-29 19:03:30','globeadmin','2018-08-04 20:57:31','globeadmin'),('55182267c48246a','551821232f9553f',NULL,NULL,'1',10,NULL,'period_id',40,10,'Αναζήτηση','Ώρα : ','listbox',47,299,80,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,name from period order by short_name',NULL,'','','select id,name from period order by short_name',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-29 19:03:51','globeadmin','2016-12-26 10:28:12','globeadmin','2018-08-04 20:57:31','globeadmin'),('5518228dbfa0990','551821232f9553f',NULL,NULL,'1',10,NULL,'justified',60,10,'Αναζήτηση','Δικαιολογημένη ή Διαγραμμένη : ','dropdown',87,16,60,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'1|Ναι|0|Όχι',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-29 19:04:29','globeadmin','2018-08-04 20:49:26','globeadmin','2018-08-04 20:57:32','globeadmin'),('551822aa2842338','551821232f9553f',NULL,NULL,'1',10,'select \'0\'','counts',80,10,'Αναζήτηση','Προσμετρείται : ','dropdown',87,794,60,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'1|Ναι|0|Όχι',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-29 19:04:58','globeadmin','2018-08-04 20:56:47','globeadmin','2018-08-04 20:57:32','globeadmin'),('551822f16c9fd72','551821232f9553f',NULL,NULL,'1',10,NULL,'searchbtn',90,10,'Αναζήτηση','Αναζήτηση','button',124,64,150,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from teacher order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-29 19:06:09','globeadmin','2016-07-14 19:33:06','globeadmin','2018-08-04 20:57:32','globeadmin'),('55182309e9216e7','551821232f9553f',NULL,NULL,'1',10,NULL,'current_date',100,10,'Αναζήτηση','Τρέχουσα Ημ/νια : ','display',221,41,80,30,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select DATE_FORMAT(curdate(),\'%d-%m-%Y\')',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-29 19:06:34','globeadmin','2016-07-14 19:33:06','globeadmin','2018-08-04 20:57:32','globeadmin'),('55182330172b455','551821232f9553f',NULL,NULL,'1',10,NULL,'search_iframe',120,10,'Αναζήτηση',NULL,'iframe',179,16,950,350,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from teacher order by short_name',NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-29 19:07:12','globeadmin','2018-07-13 23:10:00','globeadmin','2018-08-04 20:57:32','globeadmin'),('551a35a2292f7cf','551a34a930825c0',NULL,NULL,'1',10,NULL,'from_date',20,10,'Αναζήτηση','Απουσίες Από : ','text',50,23,80,30,'r','0','0','select curdate()','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2015-03-31 08:50:26','globeadmin','2015-04-01 10:32:19','globeadmin','2018-08-04 11:47:36','globeadmin'),('551c27fbef1871e','59e22f9965b5362',NULL,NULL,'1',10,'SELECT IF(\'#nu_user_group#\'=\'Students\' AND hide_student_absence=1,\'0\',\'1\')\nFROM school WHERE id=1','absence_graph_iframe',110,10,'Απουσίες',' ','iframe',118,19,990,350,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select count(*)+#prev_an_justified_absences#+#prev_justified_absences# from absence where student_id=#RECORD_ID# and counts=1;',NULL,NULL,'55183736b84eee4','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-04-01 20:16:44','globeadmin','2019-11-13 12:57:48','globeadmin','2020-04-02 16:25:31','globeadmin'),('551a362ce79d41e','551a34a930825c0',NULL,NULL,'1',10,NULL,'label1',10,10,'Αναζήτηση','Επιλέξτε από τα παρακάτω κριτήρια αναζήτησης. Αφήνοντας κενό ένα κριτήριο, εμφανίζονται όλες οι αντίστοιχες αιτήσεις διαγραφής.','words',17,16,850,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-31 08:52:44','globeadmin','2018-08-04 11:47:35','globeadmin','2018-08-04 11:47:36','globeadmin'),('551a366685f6b14','551a34a930825c0',NULL,NULL,'1',10,'select if(  \'#nu_user_group#\'=\'globeadmin\' or \n            \'#nu_user_group#\'=\'Administrators\' or \n            \'#nu_user_group#\'=\'Managers\' or \n            \'#nu_user_group#\'=\'AssistManagers\',\'1\',\'0\')','request_teacher_id',40,10,'Αναζήτηση','Καθηγητής : ','dropdown',97,797,250,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from teacher order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-31 08:53:42','globeadmin','2016-01-24 17:50:47','globeadmin','2018-08-04 11:47:36','globeadmin'),('551a36a0aa969ab','551a34a930825c0',NULL,NULL,'1',10,NULL,'searchbtn',50,10,'Αναζήτηση','Αναζήτηση','button',90,58,150,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from teacher order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-31 08:54:40','globeadmin','2015-03-31 08:54:40','globeadmin','2018-08-04 11:48:38','globeadmin'),('551a36af021f796','551a34a930825c0',NULL,NULL,'1',10,NULL,'current_date',70,10,'Αναζήτηση','Τρέχουσα Ημ/νια : ','display',267,575,80,30,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select DATE_FORMAT(curdate(),\'%d-%m-%Y\')',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-31 08:54:55','globeadmin','2015-03-31 08:54:55','globeadmin','2018-08-04 11:47:36','globeadmin'),('551a36d18d48356','551a34a930825c0',NULL,NULL,'1',10,NULL,'justification_requests_iframe',70,10,'Αναζήτηση',NULL,'iframe',139,5,1170,350,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from teacher order by short_name',NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-31 08:55:29','globeadmin','2018-07-17 01:05:11','globeadmin','2018-08-04 11:47:36','globeadmin'),('551a37491337e19','59d7d6e9ecc73da',NULL,NULL,'1',10,NULL,'justicication_request_searchbtn',30,10,'Εργασίες Απουσιών',NULL,'html',334,73,220,100,'l','0','0','','0',NULL,NULL,'#RECORD_ID#','551a34a930825c0',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_rsearch_id\').src=\'images/rsearchb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_rsearch_id\').src=\'images/rsearch.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_rsearch_id\' src=\'images/rsearch.png\' title=\'Αναζήτηση Αιτημάτων Διαγραφής Απουσιών\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Αιτήμάτα Διαγραφής Απουσιών</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-31 08:57:29','globeadmin','2018-08-04 12:00:04','globeadmin','2021-02-27 09:46:56','globeadmin'),('551a3ddb6d8b44f','551a34a930825c0',NULL,NULL,'1',10,NULL,'proceeded',80,10,'Αναζήτηση','Διεκπαιρεωμένο : ','dropdown',49,459,60,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'1|Ναι|0|Όχι',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-03-31 09:25:31','globeadmin','2015-03-31 09:25:31','globeadmin','2018-08-04 11:47:36','globeadmin'),('5547aa4dcf54d25','55222f79d342b66',NULL,NULL,'1',10,NULL,'not_registered_cards_msg_iframe',40,10,'Απουσίες',NULL,'iframe',120,17,950,55,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2015-05-04 20:20:13','globeadmin','2015-05-04 20:27:04','globeadmin','2018-08-14 10:07:25','globeadmin'),('55222a56f08e951','5476201e5a3d38f',NULL,NULL,'1',10,NULL,'prev_an_justified_absences',10,80,'Απουσίες','Μετρήσιμες απουσίες ΕΚΤΟΣ συστήματος :','text',14,66,50,30,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select \'#prev_an_justified_absences#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-04-06 09:40:23','globeadmin','2018-08-06 09:50:38','globeadmin','2022-01-08 11:22:28','globeadmin'),('55479c46cf54cf0','55479f1837f6df0',NULL,NULL,'1',10,NULL,'not_registered_cards_iframe',10,10,'Διδασκαλίες Ημέρας',NULL,'iframe',22,16,950,400,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2015-05-04 19:20:22','globeadmin','2016-01-21 23:09:45','globeadmin','2018-07-12 20:17:57','globeadmin'),('55222ab84f6e013','5476201e5a3d38f',NULL,NULL,'1',10,NULL,'prev_justified_absences',20,80,'Απουσίες','Δικαιολογημένες Απουσίες ΕΚΤΟΣ Συστήματος : ','text',14,545,50,30,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select \'#prev_justified_absences#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-04-06 09:42:00','globeadmin','2018-08-06 09:51:12','globeadmin','2022-01-08 11:22:29','globeadmin'),('55222aeedd081f6','5476201e5a3d38f',NULL,NULL,'1',10,NULL,'unjustified_absence_disp',30,80,'Απουσίες','Μετρήσιμες απουσίες ΕΝΤΟΣ συστήματος : ','display',48,62,50,30,'r','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select count(*) from absence where student_id=\'#RECORD_ID#\' and counts=1 and justified=0;',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-04-06 09:42:54','globeadmin','2018-08-06 09:52:13','globeadmin','2022-01-08 11:22:29','globeadmin'),('552168ae4261715','54f735c7d56625f',NULL,NULL,'1',10,NULL,'form_absence_printbtn',60,10,'Απουσιολόγιο','Εκτύπωση Απουσιολογίου','button',29,695,200,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-04-05 19:54:06','globeadmin','2015-04-05 22:36:52','globeadmin','2022-09-24 23:06:18','globeadmin'),('55222b07c980917','5476201e5a3d38f',NULL,NULL,'1',10,NULL,'justified_absence_disp',40,80,'Απουσίες','Δικαιολογημένες Απουσίες ΕΝΤΟΣ Συστήματος : ','display',48,544,50,30,'r','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select count(*) from absence where student_id=\'#RECORD_ID#\' and counts=1 and justified=1;',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-04-06 09:43:19','globeadmin','2018-08-06 09:56:22','globeadmin','2022-01-08 11:22:29','globeadmin'),('55222b2ce6cc8ec','5476201e5a3d38f',NULL,NULL,'1',10,NULL,'justified_absence_nocounts_disp',50,80,'Απουσίες','Μη Μετρήσιμες (Διαγραμμένες) Απουσίες :','display',99,428,50,30,'r','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select count(*) from absence where student_id=\'#RECORD_ID#\' and counts=0 and justified=1;',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-04-06 09:43:56','globeadmin','2018-08-06 10:03:15','globeadmin','2022-01-08 11:22:29','globeadmin'),('55222b55b8692de','5476201e5a3d38f',NULL,NULL,'1',10,'select \'0\'','unjustified_absence_sum_disp',60,80,'Απουσίες','Σύνολο Αδικαιολόγητων Απουσιών :  ','words',20,900,50,30,'r','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select count(*)+\'#prev_an_justified_absences#\' from absence where student_id=\'#RECORD_ID#\' and counts=1 and justified=0;',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-04-06 09:44:37','globeadmin','2018-08-06 09:57:56','globeadmin','2022-01-08 11:22:29','globeadmin'),('55222b6f3973c85','5476201e5a3d38f',NULL,NULL,'1',10,'select \'0\'','justified_absence_sum_disp',70,80,'Απουσίες','Σύνολο Δικαιολογημένων Μετρήσιμων Απουσιών :  ','words',20,900,50,30,'r','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select count(*)+\'#prev_justified_absences#\' from absence where student_id=\'#RECORD_ID#\' and counts=1 and justified=1;',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-04-06 09:45:03','globeadmin','2018-08-06 09:58:57','globeadmin','2022-01-08 11:22:29','globeadmin'),('55222b8b915919f','5476201e5a3d38f',NULL,NULL,'1',10,NULL,'absence_counts_sum_disp',80,80,'Απουσίες','Σύνολο Μετρήσιμων Απουσιών :  ','display',99,126,50,30,'r','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select \n    count(*)+ifNULL(student.prev_an_justified_absences,0)+ifNULL(student.prev_justified_absences,0) \nfrom absence \ninner join student on student.id = \'#RECORD_ID#\'\nwhere \n    student_id=\'#RECORD_ID#\' and counts=1;',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-04-06 09:45:31','globeadmin','2021-03-09 20:09:21','globeadmin','2022-01-08 11:22:29','globeadmin'),('55222ba962f666c','5476201e5a3d38f',NULL,NULL,'1',10,'select if(\'#RECORD_ID#\'<>\'-1\',\'1\',\'0\')','search_student_absencebtn',90,80,'Απουσίες',NULL,'html',159,107,180,100,'c','0','0','','0',NULL,NULL,'#RECORD_ID#','551821232f9553f',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_search_id\').src=\'images/searchb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_search_id\').src=\'images/search.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_search_id\' src=\'images/search.png\' title=\'Αναζήτηση Απουσιών\'/>\n			<img /> \n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Αναζήτηση Απουσιών</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-04-06 09:46:01','globeadmin','2017-11-29 21:53:17','globeadmin','2022-01-08 11:22:29','globeadmin'),('55222be01e9a1fb','5476201e5a3d38f',NULL,NULL,'1',10,NULL,'absence_graph_iframe',120,80,'Απουσίες',' ','iframe',272,17,990,350,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'55183736b84eee4','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-04-06 09:46:56','globeadmin','2018-08-05 22:39:03','globeadmin','2022-01-08 11:22:29','globeadmin'),('5b67573dc4182b1','5476201e5a3d38f',NULL,NULL,'1',10,NULL,'vertical_line',130,20,'Στοιχεία Επικοινωνίας',NULL,'html',117,521,5,550,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table style=\"width: 0px; height: 100%; border-color::#b04b00;border-right-width: 1px; border-style: solid;\" border=0>\n<tr>\n<td>\n</td>\n</tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2018-08-05 22:59:57','globeadmin','2018-08-05 23:21:36','globeadmin','2022-01-08 11:22:27','globeadmin'),('565b05de8c3cd99','565b05b5e424081',NULL,NULL,'1',10,NULL,'grading_period_id',10,10,'Βαθμολογία','Περίοδος Αξιολόγησης :','dropdown',17,12,150,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'SELECT distinct grading_period.id,grading_period.name\nFROM grading_period\ninner join mark on grading_period.id=mark.grading_period_id\nORDER BY grading_period.name\n',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-11-29 16:04:14','globeadmin','2016-07-24 16:19:18','globeadmin','2016-07-24 16:19:18','globeadmin'),('55222ed5804082a','5476201e5a3d38f',NULL,NULL,'1',10,'select if((teacher_id=\'#teacher_id#\' OR \n			\'#nu_user_group# \'=\'Managers\' OR \n			\'#nu_user_group# \'=\'globeadmin\' OR \n			\'#nu_user_group#\'=\'AssistManagers\') AND \'#RECORD_ID#\'<>\'-1\',\'1\',\'0\')\nfrom session_variables\nwhere session_id=\'#session_id#\'\n','justifie_student_absencebtn',110,80,'Απουσίες',NULL,'html',159,699,180,100,'c','0','0','','0',NULL,NULL,'#RECORD_ID#','55222f79d342b66',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_jasabs_id\').src=\'images/jasabsb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_jasabs_id\').src=\'images/jasabs.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_jasabs_id\' src=\'images/jasabs.png\' title=\'Δικαιολόγηση απουσιών του μαθητή\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Δικαιολόγηση Απουσιών</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-04-06 09:59:33','globeadmin','2017-11-29 21:56:29','globeadmin','2022-01-08 11:22:29','globeadmin'),('552231ae3e5575d','55222f79d342b66',NULL,NULL,'1',10,NULL,'absence_date',10,10,'Απουσίες','Ημερομηνία Απουσιών : ','text',28,31,100,40,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2015-04-06 10:11:42','globeadmin','2018-08-05 14:06:28','globeadmin','2018-08-14 10:07:25','globeadmin'),('55223234608396b','55222f79d342b66',NULL,NULL,'1',10,NULL,'absence_iframe',50,10,'Απουσίες',NULL,'iframe',186,17,950,400,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2015-04-06 10:13:56','globeadmin','2016-01-19 11:21:06','globeadmin','2018-08-14 10:07:26','globeadmin'),('5522344a481b1a2','55222f79d342b66',NULL,NULL,'1',10,NULL,'justify_reason',20,10,'Απουσίες','Λόγος Δικαιολόγησης : ','dropdown',71,39,500,40,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,name \nfrom \njustified_reason \nwhere \'#nu_user_group#\'=\'Managers\' OR \'#nu_user_group#\'=\'AssistManagers\' OR teacher_access=1 \norder by counts desc,id',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2015-04-06 10:22:50','globeadmin','2022-01-31 16:19:24','globeadmin','2022-01-31 16:19:24','globeadmin'),('5522b35f4dd5a83','55222f79d342b66',NULL,NULL,'1',10,NULL,'justifybtn',30,10,'Απουσίες','Δικαιολόγηση','button',64,734,200,35,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-04-06 19:25:03','globeadmin','2015-04-06 19:26:47','globeadmin','2020-06-09 21:00:07','globeadmin'),('5523fe1aa3482fd','5a54c08c836c142',NULL,NULL,'1',10,'select \'0\'','parent_days_limit_justification',40,10,'Παράμετροι','Μέγιστος αριθμός από ημέρες στις οποίες μπορεί να δικαιολογήσει απουσίες ο κηδεμόνας :','text',110,928,40,0,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2015-04-07 18:56:10','globeadmin','2018-08-05 12:32:55','globeadmin','2022-09-24 23:21:52','globeadmin'),('552401fa0225f91','55222f79d342b66',NULL,NULL,'1',10,'select \'0\'','num_of_parent_days',60,10,'Απουσίες','Πλήθος Ημερών με Δικαιολογητικά από Κηδεμόνα : ','display',20,900,40,40,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select COUNT(distinct absence_date) \nfrom absence \nwhere student_id=#RECORD_ID# and \n        justified=1 and\n        justified_reason_id=1',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2015-04-07 19:12:42','globeadmin','2018-08-05 12:47:53','globeadmin','2018-08-14 10:07:26','globeadmin'),('552402abd8fe288','55222f79d342b66',NULL,NULL,'1',10,'select \'0\'','limit_num_of_parent_days',70,10,'Απουσίες','Όριο Πλήθους Ημερών : ','display',20,900,40,40,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select parent_days_limit_justification from school limit 1',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2015-04-07 19:15:39','globeadmin','2018-08-05 12:48:13','globeadmin','2018-08-14 10:07:26','globeadmin'),('55240424811a361','55222f79d342b66',NULL,NULL,'1',10,'select \'0\'','limit_num_of_justification_days',80,10,'Απουσίες',NULL,'iframe',20,900,250,30,'c','0','0','select \'find_last_justification_date\'','0',NULL,NULL,NULL,NULL,NULL,'','','select 	concat(num_days_absence_justification,\' Ημέρες\',\' -  Μέχρι και την \',DATE_FORMAT(DATE_ADD(CURDATE(), INTERVAL - (num_days_absence_justification+1) DAY),\'%d-%m-%Y\')) from school limit 1',NULL,NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2015-04-07 19:21:56','globeadmin','2018-08-05 12:46:57','globeadmin','2018-08-14 10:07:26','globeadmin'),('552549d058ff209','5525421c67a48bc',NULL,NULL,'1',10,NULL,'from_date',10,10,'Αναζήτηση','Από : ','text',29,47,80,30,'r','0','0','select curdate()','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2015-04-08 18:31:28','globeadmin','2015-04-08 18:31:28','globeadmin','2022-09-17 21:45:17','globeadmin'),('552549e9b837755','5525421c67a48bc',NULL,NULL,'1',10,NULL,'to_date',20,10,'Αναζήτηση','Έως : ','text',29,202,80,30,'r','0','0','select curdate()','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2015-04-08 18:31:53','globeadmin','2015-04-08 18:32:48','globeadmin','2022-09-17 21:45:17','globeadmin'),('55254a978760860','5525421c67a48bc',NULL,NULL,'1',10,NULL,'searchbtn',40,10,'Αναζήτηση','Αναζήτηση','button',21,553,160,35,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-04-08 18:34:47','globeadmin','2019-03-10 11:52:22','globeadmin','2022-09-17 21:45:17','globeadmin'),('55254ae87d9c8ea','5525421c67a48bc',NULL,NULL,'1',10,NULL,'search_iframe',60,10,'Αναζήτηση',NULL,'iframe',80,14,950,450,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-04-08 18:36:08','globeadmin','2019-03-10 11:52:22','globeadmin','2022-09-17 21:45:17','globeadmin'),('55254ee778bc26d','5525421c67a48bc',NULL,NULL,'1',10,NULL,'prev_date',50,10,'Αναζήτηση','Προηγούμενη Εργάσιμη Ημ/νια : ','display',175,93,80,30,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select DATE_FORMAT((CASE WEEKDAY(CURDATE()) \n                             WHEN 0 THEN date(SUBDATE(CURDATE(),3))\n                             WHEN 6 THEN date(SUBDATE(CURDATE(),2)) \n                             ELSE date(SUBDATE(CURDATE(),1))\n                        END),\'%d-%m-%Y\')',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-04-08 18:53:11','globeadmin','2019-03-10 11:52:22','globeadmin','2022-09-17 21:45:17','globeadmin'),('55261fac370f6c1','55261f6b593bdba',NULL,NULL,'1',10,NULL,'from_date',10,10,'Αναζήτηση','Από : ','text',22,50,80,30,'r','0','0','select curdate()','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2015-04-09 09:43:56','globeadmin','2015-04-09 09:43:56','globeadmin','2022-02-12 10:09:59','globeadmin'),('55261fc36572632','55261f6b593bdba',NULL,NULL,'1',10,NULL,'to_date',20,10,'Αναζήτηση','Έως : ','text',22,199,80,30,'r','0','0','select curdate()','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2015-04-09 09:44:19','globeadmin','2015-04-09 09:44:19','globeadmin','2022-02-12 10:09:59','globeadmin'),('55261fd71750db6','55261f6b593bdba',NULL,NULL,'1',10,NULL,'searchbtn',80,10,'Αναζήτηση','Δημιουργία Αρχείων','button',106,85,200,35,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-04-09 09:44:39','globeadmin','2018-05-30 22:40:36','globeadmin','2022-02-12 10:10:00','globeadmin'),('5526201b78f8d2f','55261f6b593bdba',NULL,NULL,'1',10,NULL,'search_iframe',100,10,'Αναζήτηση',NULL,'iframe',154,39,900,590,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-04-09 09:45:47','globeadmin','2018-05-30 22:41:25','globeadmin','2022-02-12 10:10:00','globeadmin'),('55262061e6d8545','55261f6b593bdba',NULL,NULL,'1',10,NULL,'prev_date',80,10,'Αναζήτηση','Προηγούμενη Εργάσιμη Ημ/νια : ','display',230,497,80,30,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select DATE_FORMAT((CASE WEEKDAY(CURDATE()) \n                             WHEN 0 THEN date(SUBDATE(CURDATE(),3))\n                             WHEN 6 THEN date(SUBDATE(CURDATE(),2)) \n                             ELSE date(SUBDATE(CURDATE(),1))\n                        END),\'%d-%m-%Y\')',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-04-09 09:46:58','globeadmin','2018-05-30 22:41:25','globeadmin','2022-02-12 10:10:00','globeadmin'),('5526248a08ac66d','55261f6b593bdba',NULL,NULL,'1',10,NULL,'class_id',40,10,'Αναζήτηση','Τμήμα : ','listbox',64,38,250,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select class.id, class.short_name\nfrom class\nwhere \n    post_teacher_id=\'#RECORD_ID#\' OR \n    \'#nu_user_group#\'=\'Managers\' OR \n    \'#nu_user_group#\'=\'AssistManagers\' OR\n    \'#nu_user_group#\'=\'Secretaries\' OR\n    \'#nu_user_group#\'=\'Administrators\' OR\n    \'#nu_user_group#\'=\'globeadmin\' OR\n    ((select count(*) from\n		(select id from student where teacher_id=\'#RECORD_ID#\') as ts,\n		(select student_id,class_id from student_class) as tc\n		where\n			ts.id=tc.student_id and\n			tc.class_id=class.id\n	) = (select count(*) from student_class where class_id=class.id) \n    and (select count(*) from student_class where class_id=class.id)>0)\norder by grade_id,short_name',NULL,'','','select id,short_name \nfrom class where \n    (post_teacher_id=\'#RECORD_ID#\' OR \n    \'#nu_user_group#\'=\'Managers\' OR \n    \'#nu_user_group#\'=\'AssistManagers\' OR\n    \'#nu_user_group#\'=\'Administrators\' OR\n    \'#nu_user_group#\'=\'globeadmin\' OR\n    id in ( select distinct student_class.class_id \n            from student_class,student\n            where \n                student_class.student_id=student.id and\n                student.teacher_id=\'#RECORD_ID#\')) AND\n    id in (select distinct student_class.class_id from student_class)\norder by short_name',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-04-09 10:04:42','globeadmin','2018-05-30 22:40:36','globeadmin','2022-02-12 10:10:00','globeadmin'),('552770f92198fc8','55261f6b593bdba',NULL,NULL,'1',10,NULL,'show_only_sums',50,10,'Αναζήτηση','Εμφάνιση Μόνο των Συνόλων : ','checkbox',62,409,30,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-04-10 09:43:05','globeadmin','2018-05-30 22:40:36','globeadmin','2022-02-12 10:10:00','globeadmin'),('56b7450f44b0b6f','547372d029461f4',NULL,NULL,'0',10,'select if((teacher.user_id IS NOT NULL) and (\'#nu_user_group#\'=\'globeadmin\' or \'#nu_user_group#\'=\'Administrators\' or \'#nu_user_group#\'=\'Managers\') and \'#RECORD_ID#\'<>\'-1\',\'1\',\'0\')\nfrom school\nleft join teacher ON teacher.id=\'#RECORD_ID#\'\nwhere school.id=\'1\'','edit_usertbtn',120,10,'Λεπτομέρειες',NULL,'html',35,837,20,20,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"this.style.cursor=\'pointer\';\"\n                            onmouseout=\"this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=16 height=16 id=\'img_modify\' src=\'images/modify.png\' title=\'Επεξεργασία Χρήστη\'/>\n        </td>\n    </tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-02-07 15:22:23','globeadmin','2017-11-29 21:38:10','globeadmin','2021-01-26 20:15:03','globeadmin'),('552c11af569cdd3','59d7d6e9ecc73da',NULL,NULL,'1',10,'select if (count(class.id)>0,\'1\',\'0\')\nfrom class\nwhere \n    post_teacher_id=\'#RECORD_ID#\' OR \n    \'#nu_user_group#\'=\'globeadmin\' OR\n    ((select count(*) from\n		(select id from student where teacher_id=\'#RECORD_ID#\') as ts,\n		(select student_id,class_id from student_class) as tc\n		where\n			ts.id=tc.student_id and\n			tc.class_id=class.id\n	) = (select count(*) from student_class where class_id=class.id) \n    and (select count(*) from student_class where class_id=class.id)>0)\norder by grade_id,short_name','absence_export_excelbtn',90,10,'Εργασίες Απουσιών',NULL,'html',334,687,220,100,'l','0','0','','0',NULL,NULL,'#RECORD_ID#','55261f6b593bdba',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_excel_id\').src=\'images/excelb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_excel_id\').src=\'images/excel.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_excel_id\' src=\'images/excel.png\' title=\'Εξαγωγή Απουσιών στο Excel\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Εξαγωγή Απουσιών στο Excel</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-04-13 21:57:51','globeadmin','2017-10-07 01:10:19','globeadmin','2021-02-27 09:46:56','globeadmin'),('552cf4f1e6ed0c5','552cf4b2df9bcce',NULL,NULL,'1',10,NULL,'to_date',30,10,'Ενημέρωση για τις Απουσίες','Από την Έναρξη, Έως : ','text',65,13,100,30,'r','0','0','select curdate()','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2015-04-14 14:07:30','globeadmin','2018-06-28 21:36:16','globeadmin','2021-09-07 20:55:38','globeadmin'),('552cf50a483c12f','552cf4b2df9bcce',NULL,NULL,'1',10,NULL,'export_class_id',50,10,'Ενημέρωση για τις Απουσίες','Τμήμα : ','dropdown',113,17,150,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select class.id, class.short_name\nfrom class\nwhere \n    (post_teacher_id=\'#RECORD_ID#\' OR \n    \'#nu_user_group#\'=\'Managers\' OR \n    \'#nu_user_group#\'=\'AssistManagers\' OR\n    \'#nu_user_group#\'=\'Administrators\' OR\n    \'#nu_user_group#\'=\'Secretaries\' OR\n    \'#nu_user_group#\'=\'globeadmin\' OR\n    ((select count(*) from\n		(select id from student where teacher_id=\'#RECORD_ID#\') as ts,\n		(select student_id,class_id from student_class) as tc\n		where\n			ts.id=tc.student_id and\n			tc.class_id=class.id\n	) = (select count(*) from student_class where class_id=class.id)))\n    and (select count(*) from student_class where class_id=class.id)>0\norder by grade_id,short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-04-14 14:07:54','globeadmin','2018-06-28 21:36:16','globeadmin','2021-09-07 20:55:38','globeadmin'),('552f6ce5592b3f3','552cf4b2df9bcce',NULL,NULL,'1',10,NULL,'exclude_has_left_school',70,10,'Ενημέρωση για τις Απουσίες','Εξαίρεση όσων έχουν εγκαταλείψει :','checkbox',109,733,40,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-04-16 11:03:49','globeadmin','2018-06-28 22:43:46','globeadmin','2021-09-07 20:55:38','globeadmin'),('552f76248c70278','552cf4b2df9bcce',NULL,NULL,'1',10,NULL,'export_student_id',60,10,'Ενημέρωση για τις Απουσίες','Μαθητής : ','dropdown',113,241,380,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select student.id,\nconcat(ifNULL(grade.short_name,\'\'),\' - \',student.surname,\' \',student.name,\' \',student.fathers_name)\nfrom student\nleft join grade on grade.id = student.grade_id\nwhere\n    \'#nu_user_group#\'=\'Managers\' OR \n    \'#nu_user_group#\'=\'AssistManagers\' OR\n    \'#nu_user_group#\'=\'Administrators\' OR\n    \'#nu_user_group#\'=\'Secretaries\' OR\n    \'#nu_user_group#\'=\'globeadmin\' OR\n    teacher_id=\'#RECORD_ID#\'\norder by student.grade_id,student.surname,student.name,student.fathers_name\n',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-04-16 11:43:16','globeadmin','2018-06-28 22:45:27','globeadmin','2021-09-07 20:55:38','globeadmin'),('552cf54cc9a29c3','552cf4b2df9bcce',NULL,NULL,'1',10,NULL,'searchbtn',80,10,'Ενημέρωση για τις Απουσίες','Εμφάνιση','button',160,64,200,35,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-04-14 14:09:00','globeadmin','2018-06-28 21:36:16','globeadmin','2021-09-07 20:55:38','globeadmin'),('552cf57859531e4','552cf4b2df9bcce',NULL,NULL,'1',10,'select \'0\'','prev_date',160,10,'Ενημέρωση για τις Απουσίες','Προηγούμενη Εργάσιμη Ημ/νια : ','display',19,624,80,30,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select DATE_FORMAT((CASE WEEKDAY(CURDATE()) \n                             WHEN 0 THEN date(SUBDATE(CURDATE(),3))\n                             WHEN 6 THEN date(SUBDATE(CURDATE(),2)) \n                             ELSE date(SUBDATE(CURDATE(),1))\n                        END),\'%d-%m-%Y\')',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-04-14 14:09:44','globeadmin','2018-06-28 21:36:16','globeadmin','2021-09-07 20:55:38','globeadmin'),('552cf5b04ab5202','552cf4b2df9bcce',NULL,NULL,'1',10,NULL,'search_iframe',140,10,'Ενημέρωση για τις Απουσίες',NULL,'iframe',221,16,950,600,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-04-14 14:10:40','globeadmin','2018-06-28 21:36:16','globeadmin','2021-09-07 20:55:38','globeadmin'),('552cff5c9660cc1','552cf4b2df9bcce',NULL,NULL,'1',10,NULL,'absence_limit',40,10,'Ενημέρωση για τις Απουσίες','Με σύνολο απουσιών τουλάχιστον : ','text',65,289,60,30,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',0,0,'2015-04-14 14:51:56','globeadmin','2018-08-05 11:21:47','globeadmin','2021-09-07 20:55:38','globeadmin'),('552d0e6f742e2fd','552cf4b2df9bcce',NULL,NULL,'1',10,NULL,'manager_sign',110,10,'Ενημέρωση για τις Απουσίες','Διευθυντής :','checkbox',162,511,40,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-04-14 15:56:15','globeadmin','2018-06-28 21:36:16','globeadmin','2021-09-07 20:55:38','globeadmin'),('552d0e971016a76','552cf4b2df9bcce',NULL,NULL,'1',10,NULL,'asistmanager_sign',120,10,'Ενημέρωση για τις Απουσίες','Υποδιευθυντής :','checkbox',162,631,40,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-04-14 15:56:55','globeadmin','2018-06-28 21:36:16','globeadmin','2021-09-07 20:55:38','globeadmin'),('552d0eb1b138a56','552cf4b2df9bcce',NULL,NULL,'1',10,NULL,'teacher_sign',130,10,'Ενημέρωση για τις Απουσίες','Υπεύθυνος Καθηγητής :','checkbox',162,783,40,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-04-14 15:57:21','globeadmin','2018-06-28 21:36:16','globeadmin','2021-09-07 20:55:38','globeadmin'),('552d0f23b88b9c5','552cf4b2df9bcce',NULL,NULL,'1',10,NULL,'framehtml',100,10,'Ενημέρωση για τις Απουσίες',NULL,'html',156,490,470,44,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<html>\n<body>\n<table width=100% height=100% border=1  cellspacing=0 bordercolor=red><tr><td></td></tr><table>\n</body>\n</html>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-04-14 15:59:15','globeadmin','2018-06-28 21:37:26','globeadmin','2021-09-07 20:55:38','globeadmin'),('552d0fdbbd6db99','552cf4b2df9bcce',NULL,NULL,'1',10,NULL,'label1',90,10,'Ενημέρωση για τις Απουσίες','Υπογραφές : ','words',168,399,200,80,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-04-14 16:02:19','globeadmin','2018-08-05 11:23:40','globeadmin','2021-09-07 20:55:38','globeadmin'),('552d12d18064ae6','552cf4b2df9bcce',NULL,NULL,'1',10,NULL,'note_type',10,10,'Ενημέρωση για τις Απουσίες','Μορφή Επικοινωνίας : ','dropdown',18,21,450,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'0|Συνοπτική Κατάσταση|5|Σύνολα ανά Λόγο Δικαιολόγησης ή Διαγραφής|3|Σύντομο Δελτίο|4|Σύντομο Δελτίο με Αποδεικτικό Μαθητή|6|Αποστολή Email|7|Αποστολή SMS',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-04-14 16:14:57','globeadmin','2018-08-05 11:07:53','globeadmin','2021-09-07 20:55:37','globeadmin'),('5a7619b517f7ec0','5a54c08c836c142',NULL,NULL,'1',10,NULL,'sms_absence_text',10,30,'SMS Κείμενο Απουσιών',NULL,'textarea',158,13,900,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2018-02-03 22:21:09','globeadmin','2018-02-03 23:22:02','globeadmin','2022-09-24 23:21:53','globeadmin'),('552fb3d1c22647a','59d7d6e9ecc73da',NULL,NULL,'1',10,'SELECT IF(\'#nu_user_group#\'=\'globeadmin\' OR count(*)>0, \'1\', \'0\')\nfrom student\nwhere \n    teacher_id=#RECORD_ID#','absence_notesbtn',40,10,'Εργασίες Απουσιών',NULL,'html',50,380,220,100,'l','0','0','','0',NULL,NULL,'#RECORD_ID#','552cf4b2df9bcce',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_pmsg_id\').src=\'images/pmsgb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_pmsg_id\').src=\'images/pmsg.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_pmsg_id\' src=\'images/pmsg.png\' title=\'Επικοινωνία Σχολείου - Γονέων\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Επικοινωνία Σχολείου - Γονέων</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-04-16 16:06:25','globeadmin','2017-10-07 01:10:19','globeadmin','2021-02-27 09:46:56','globeadmin'),('5538faf91943f16','59d7d6e9ecc73da',NULL,NULL,'1',10,'select if(\'#nu_user_group#\'=\'globeadmin\' OR count(*)>0,\'1\',\'0\') \nfrom class \nwhere post_teacher_id=#RECORD_ID#','print_absence_bookbtn',80,10,'Εργασίες Απουσιών',NULL,'html',192,687,220,100,'l','0','0','','0',NULL,NULL,'#RECORD_ID#','5538ff58cb7b4b8',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_abprint_id\').src=\'images/abprintb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_abprint_id\').src=\'images/abprint.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_abprint_id\' src=\'images/abprint.png\' title=\'Εκτύπωση Απουσιολογίων Ημέρας\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Εκτύπωση Απουσιολογίων Ημέρας</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-04-23 17:00:25','globeadmin','2017-10-07 01:10:19','globeadmin','2021-02-27 09:46:56','globeadmin'),('5539006a9836616','5538ff58cb7b4b8',NULL,NULL,'1',10,NULL,'form_absence_date',10,10,'Εκτύπωση Απουσιολογίων','Ημερομηνία : ','text',30,77,80,40,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2015-04-23 17:23:38','globeadmin','2015-04-23 19:24:40','globeadmin','2018-11-18 23:11:36','globeadmin'),('5539052af01a423','5538ff58cb7b4b8',NULL,NULL,'1',10,NULL,'print_absence_all_class_tablebtn',30,10,'Εκτύπωση Απουσιολογίων','Εμφάνιση PDF','button',24,604,200,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-04-23 17:43:55','globeadmin','2015-04-25 18:04:59','globeadmin','2018-11-19 23:32:30','globeadmin'),('55390559d05ee8e','5538ff58cb7b4b8',NULL,NULL,'1',10,NULL,'absence_iframe',40,10,'Εκτύπωση Απουσιολογίων',NULL,'iframe',80,17,950,600,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from class order by short_name',NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2015-04-23 17:44:41','globeadmin','2015-04-25 18:04:59','globeadmin','2015-04-25 18:05:00','globeadmin'),('553baa90235aebd','5538ff58cb7b4b8',NULL,NULL,'1',10,NULL,'show_regnchk',20,10,'Εκτύπωση Απουσιολογίων','Απόκρυψη Αριθμού Μητρώου Μαθητή : ','checkbox',30,301,40,40,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-04-25 17:54:08','globeadmin','2015-04-25 18:13:46','globeadmin','2015-04-25 18:13:47','globeadmin'),('56d4662c79a1d98','5627e58b8ed5f6d',NULL,NULL,'1',10,NULL,'comments_text_tinymce',40,10,'Ελεύθερο Κείμενο',NULL,'iframe',70,15,950,500,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'56cc9f04b82528e','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-02-29 17:39:24','globeadmin','2016-06-01 20:03:39','globeadmin','2018-07-23 09:37:25','globeadmin'),('553e917ab37f580','553e8f779634e69',NULL,NULL,'1',10,NULL,'absence_date',10,10,'Καταχώριση Απουσίας','Ημερομηνία : ','text',21,54,80,40,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2015-04-27 22:43:54','globeadmin','2015-04-28 00:07:31','globeadmin','2019-11-05 13:35:33','globeadmin'),('553e9221bfb4673','553e8f779634e69',NULL,NULL,'1',10,NULL,'period',20,10,'Καταχώριση Απουσίας','Ώρα : ','dropdown',21,238,50,40,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from period order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2015-04-27 22:46:41','globeadmin','2015-04-28 00:07:31','globeadmin','2019-11-05 13:35:33','globeadmin'),('553e92f4963377e','553e8f779634e69',NULL,NULL,'1',10,NULL,'student',30,10,'Καταχώριση Απουσίας','Μαθητής : ','lookup',70,71,100,40,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'registration_number',NULL,'surname',NULL,'5476201e5a3d38f','id','show_lesson();','function getStudentName() {\n    if (\'#call_type#\'==\'lookupcode\'){\n	    $fld = \'registration_number\';\n    } else {\n	    $fld = \'id\';\n    }\n    $sql = \"SELECT name FROM student WHERE \".$fld.\" = \'#RECORD_ID#\'\";\n    $q = nuRunQuery($sql);\n    $r = db_fetch_row($q);\n    return $r[0];\n}\nfunction getFatherstName() {\n    if (\'#call_type#\'==\'lookupcode\'){\n	    $fld = \'registration_number\';\n    } else {\n	    $fld = \'id\';\n    }\n    $sql = \"SELECT fathers_name FROM student WHERE \".$fld.\" = \'#RECORD_ID#\'\";\n    $q = nuRunQuery($sql);\n    $r = db_fetch_row($q);\n    return $r[0];\n}',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',40,200,'2015-04-27 22:50:12','globeadmin','2016-10-27 15:24:15','globeadmin','2019-11-05 13:35:33','globeadmin'),('553e953167d2a3c','553e8f779634e69',NULL,NULL,'1',10,NULL,'student_name',40,10,'Καταχώριση Απουσίας',NULL,'text',70,410,170,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-04-27 22:59:45','globeadmin','2015-04-28 00:07:31','globeadmin','2019-11-05 13:35:33','globeadmin'),('553e954621034a8','553e8f779634e69',NULL,NULL,'1',10,NULL,'student_fathers_name',50,10,'Καταχώριση Απουσίας','Πατ.','text',70,593,170,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-04-27 23:00:06','globeadmin','2015-04-28 00:07:31','globeadmin','2019-11-05 13:35:33','globeadmin'),('554517bde620679','554517bdc18334d',NULL,NULL,'1',10,NULL,'teacher_id',20,10,'Λεπτομέρειες','Καθηγητής :','dropdown',108,107,350,0,'l','0','0','select if(\n        teacher_id=-1 or \n        \'#nu_user_group#\'=\'globeadmin\' or \n        \'#nu_user_group#\'=\'Administrators\' or \n        \'#nu_user_group#\'=\'Managers\' or \n        \'#nu_user_group#\'=\'AssistManagers\'\n            ,NULL, teacher_id)\nfrom session_variables \nwhere session_id=\'#session_id#\'','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select  id,\n        concat(if(surname is null,\'\',concat(surname,\' \')), IFNULL(name,\'\')) as teacher_full_name\nfrom teacher\ninner join session_variables on session_id=\'#session_id#\'\nwhere   \'#nu_user_group#\'=\'globeadmin\' or \n        \'#nu_user_group#\'=\'Administrators\' or \n        \'#nu_user_group#\'=\'Managers\' or \n        \'#nu_user_group#\'=\'AssistManagers\' or\n        teacher.id = session_variables.teacher_id\norder by teacher_full_name\n',NULL,'','',NULL,'short_name',NULL,'name',NULL,'547372d029461f4','id',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',200,0,'0000-00-00 00:00:00','','2018-01-03 19:16:57','globeadmin','2022-01-07 21:47:53','globeadmin'),('553e9968915140f','553e8f779634e69',NULL,NULL,'1',10,NULL,'add_absencebtn',70,10,'Καταχώριση Απουσίας','Καταχώριση Απουσίας','button',126,431,200,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from teacher order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-04-27 23:17:44','globeadmin','2015-04-27 23:24:49','globeadmin','2019-11-05 13:35:33','globeadmin'),('553e9a54ae9ef65','553e8f779634e69',NULL,NULL,'1',10,NULL,'search_iframe',80,10,'Καταχώριση Απουσίας',NULL,'iframe',192,19,800,250,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-04-27 23:21:40','globeadmin','2015-04-29 20:24:56','globeadmin','2019-11-05 13:35:33','globeadmin'),('554517bddecd531','554517bdc18334d',NULL,NULL,'1',10,NULL,'student_id',10,10,'Λεπτομέρειες','*Μαθητής :','dropdown',28,112,500,0,'l','1','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select distinct student.id, concat(ifNULL(grade.short_name,\'\'),\' - \',student.surname,\' \',student.name,\' \',ifNULL(student.fathers_name,\'\'),\' (\',student.registration_number,\')\') \nfrom student\nleft join grade on grade.id = student.grade_id\norder by student.grade_id,student.surname,student.name,student.fathers_name',NULL,'','',NULL,'registration_number',NULL,'surname',NULL,'5476201e5a3d38f','id',NULL,'function getStudentName() {\n    if (\'#call_type#\'==\'lookupcode\'){\n	    $fld = \'registration_number\';\n    } else {\n	    $fld = \'id\';\n    }\n    $sql = \"SELECT name FROM student WHERE \".$fld.\" = \'#RECORD_ID#\'\";\n    $q = nuRunQuery($sql);\n    $r = db_fetch_row($q);\n    return $r[0];\n}\nfunction getFatherstName() {\n    if (\'#call_type#\'==\'lookupcode\'){\n	    $fld = \'registration_number\';\n    } else {\n	    $fld = \'id\';\n    }\n    $sql = \"SELECT fathers_name FROM student WHERE \".$fld.\" = \'#RECORD_ID#\'\";\n    $q = nuRunQuery($sql);\n    $r = db_fetch_row($q);\n    return $r[0];\n}',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',60,200,'0000-00-00 00:00:00','','2018-03-10 16:57:26','globeadmin','2022-01-07 21:47:53','globeadmin'),('553fad0da047524','5509671b4e81a07',NULL,NULL,'1',10,NULL,'teacher_lessondisp',70,10,'Λεπτομέρειες','Διδάσκων : ','display',124,157,450,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select teacher.short_name from teacher,card where card.id=#card_id# and card.teacher_id=teacher.id',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2015-04-28 18:53:49','globeadmin','2015-04-28 18:54:31','globeadmin','2022-10-05 20:27:42','globeadmin'),('554110d7439678a','553e8f779634e69',NULL,NULL,'1',10,NULL,'absence_type',60,10,'Καταχώριση Απουσίας','Είδος Απουσίας : ','dropdown',131,29,200,40,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,name from absence_reason order by id',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2015-04-29 20:11:51','globeadmin','2015-04-29 21:35:51','globeadmin','2019-11-05 13:35:33','globeadmin'),('554517bded73563','554517bdc18334d',NULL,NULL,'1',10,NULL,'date_enforced',30,10,'Λεπτομέρειες','*Ημερομηνία :','text',189,96,80,0,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'#nuSepEditnuSepr#varchar',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',100,250,'0000-00-00 00:00:00','','2018-01-03 20:08:05','globeadmin','2022-01-07 21:47:53','globeadmin'),('554517be00a286e','554517bdc18334d',NULL,NULL,'1',10,NULL,'reason',60,10,'Λεπτομέρειες','Αιτία :','textarea',230,142,700,150,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-11-21 20:43:25','globeadmin','2022-01-07 21:47:53','globeadmin'),('554517be07f5647','554517bdc18334d',NULL,NULL,'1',10,'select if(  \'#nu_user_group#\'=\'globeadmin\' or \n            \'#nu_user_group#\'=\'Administrators\' or \n            \'#nu_user_group#\'=\'Managers\' or \n            \'#nu_user_group#\'=\'AssistManagers\' or\n            \'#RECORD_ID#\'<>\'-1\',\'1\',\'0\')','carrier',70,10,'Λεπτομέρειες','Φορέας Επιβολής :','text',149,66,350,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2018-01-04 19:10:58','globeadmin','2022-01-07 21:47:53','globeadmin'),('56e553ef1c94d43','56e553b8d3afa56',NULL,NULL,'1',10,NULL,'class_id',10,10,'Ημερολόγιο Διδασκαλιών','Τμήμα :','dropdown',10,39,150,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'SELECT distinct class.id,class.short_name\nFROM class\nORDER BY class.short_name\n',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-03-13 13:50:07','globeadmin','2016-03-13 13:58:19','globeadmin','2016-10-09 10:31:49','globeadmin'),('5688ee587f37e9d','5688ee0218ad763',NULL,NULL,'1',10,NULL,'class_id',20,10,'Εισαγωγή Νέας Διδασκαλίας','Τμήμα :','dropdown',76,31,100,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from class',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2016-01-03 11:48:08','globeadmin','2016-01-03 11:48:08','globeadmin','2017-10-03 23:25:20','globeadmin'),('554520165d68936','554517bdc18334d',NULL,NULL,'1',10,'select \'0\'','student_name2',90,10,'Λεπτομέρειες',NULL,'display',69,711,170,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select name from student where id=\'#student_id#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-05-02 22:05:58','globeadmin','2018-01-02 13:39:08','globeadmin','2022-01-07 21:47:53','globeadmin'),('554525260315313','554517bdc18334d',NULL,NULL,'1',10,'select \'0\'','student_fathers_name2',100,10,'Λεπτομέρειες','Πατ.','display',116,685,170,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select fathers_name from student where id=\'#student_id#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-05-02 22:27:34','globeadmin','2018-01-02 13:38:49','globeadmin','2022-01-07 21:47:53','globeadmin'),('556188cfe6faff0','5476201e5a3d38f',NULL,NULL,'1',10,'select if(\'#RECORD_ID#\'<>\'-1\',\'1\',\'0\')','attendance_bookbtn',100,80,'Απουσίες',NULL,'html',159,404,180,100,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_sbook_id\').src=\'images/sbookb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_sbook_id\').src=\'images/sbook.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_sbook_id\' src=\'images/sbook.png\' title=\'Βιβλίο φοίτησης μαθητή\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Βιβλίο Φοίτησης</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-05-24 11:16:16','globeadmin','2017-11-29 21:53:42','globeadmin','2022-01-08 11:22:29','globeadmin'),('55618ef156f1878','59d7d6e9ecc73da',NULL,NULL,'1',10,'SELECT IF(\'#nu_user_group#\'=\'globeadmin\' OR count(*)>0, \'1\', \'0\')\nfrom student\nwhere \n    teacher_id=#RECORD_ID#','attendance_booksbtn',50,10,'Εργασίες Απουσιών',NULL,'html',192,380,220,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_sbook_id\').src=\'images/sbookb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_sbook_id\').src=\'images/sbook.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_sbook_id\' src=\'images/sbook.png\' title=\'Εμφάνιση PDF με το βιβλίο φοίτησης των μαθητών\'/>\n              	\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Βιβλίο Φοίτησης Μαθητών</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-05-24 11:42:25','globeadmin','2017-10-07 01:10:19','globeadmin','2021-02-27 09:46:56','globeadmin'),('5b7130dfdbe6e8a','5564d8431a9da4b',NULL,NULL,'1',10,NULL,'search_iframe',60,10,'Βιβλίο Φοίτησης',NULL,'iframe',83,10,920,650,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-08-13 10:18:55','globeadmin','2018-08-13 10:24:20','globeadmin','2022-02-12 10:13:26','globeadmin'),('5565ebdb1f1a936','5564d8431a9da4b',NULL,NULL,'1',10,'select \'0\'','class',30,10,'Βιβλίο Φοίτησης','Τμήμα : ','dropdown',15,925,300,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select class.id, class.short_name\nfrom class\nwhere \n    (post_teacher_id=\'#RECORD_ID#\' OR \n    \'#nu_user_group#\'=\'Managers\' OR \n    \'#nu_user_group#\'=\'AssistManagers\' OR\n    \'#nu_user_group#\'=\'Administrators\' OR\n    \'#nu_user_group#\'=\'Secretaries\' OR\n    \'#nu_user_group#\'=\'globeadmin\' OR\n    ((select count(*) from\n		(select id from student where teacher_id=\'#RECORD_ID#\') as ts,\n		(select student_id,class_id from student_class) as tc\n		where\n			ts.id=tc.student_id and\n			tc.class_id=class.id\n	) = (select count(*) from student_class where class_id=class.id)))\n    and (select count(*) from student_class where class_id=class.id)>0\norder by grade_id,short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-05-27 19:07:55','globeadmin','2018-08-13 10:17:35','globeadmin','2022-02-12 10:13:26','globeadmin'),('5565ed6c32a47fa','5564d8431a9da4b',NULL,NULL,'1',10,NULL,'student_bookbtn',20,10,'Βιβλίο Φοίτησης','Εμφάνιση Βιβλίου Φοίτησης','button',24,689,200,40,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-05-27 19:14:36','globeadmin','2018-08-13 10:22:12','globeadmin','2022-02-12 10:13:26','globeadmin'),('5565edf34148c3b','5564d8431a9da4b',NULL,NULL,'1',10,'select \'0\'','class_bookbtn',50,10,'Βιβλίο Φοίτησης','Εμφάνιση Βιβλίου Φοίτησης Τμήματος','button',31,939,250,40,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-05-27 19:16:51','globeadmin','2018-08-13 10:17:35','globeadmin','2022-02-12 10:13:26','globeadmin'),('55698cf498b4c1a','54a26a8d05fa91d',NULL,NULL,'1',10,NULL,'export_marks_publishedchk',30,10,'Εξαγωγή Βαθμολογίας','Παράλειψη Κλειδωμένων :','checkbox',24,676,100,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-05-30 13:12:04','globeadmin','2017-02-02 11:12:21','globeadmin','2018-07-28 11:43:26','globeadmin'),('556c0c6a0e76685','54809cf7134817b',NULL,NULL,'1',10,NULL,'published_dsp',90,10,'Details','Κλειδωμένο','display',0,0,100,0,'c','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select IF(published,\'ΝΑΙ\' ,\'ΟΧΙ\') from mark_#nu_user_id#_#session_id# where id=#SUBFORM_RECORD_ID#',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-06-01 10:40:26','globeadmin','2017-02-02 11:34:16','globeadmin','2017-02-02 11:34:16','globeadmin'),('5687a736cba6d9a','5684e68b302da76',NULL,NULL,'1',10,NULL,'start_date',10,10,'Διδασκαλίες','Έναρξη Ισχύος :','text',17,53,80,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2016-01-02 12:32:22','globeadmin','2016-01-02 15:14:24','globeadmin','2021-03-24 11:14:34','globeadmin'),('556f50385a269d3','54df1259eb4def9',NULL,NULL,'1',10,NULL,'compare_studentbtn',70,10,'Εισαγωγή','Εμφάνιση PDF Σύγκρισης','button',90,390,200,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-06-03 22:06:32','globeadmin','2016-10-15 19:21:39','globeadmin','2020-04-02 16:11:27','globeadmin'),('55f56bd035f3806','54a433830716b84',NULL,NULL,'1',10,NULL,'sisyphos_info_label1',20,500,'Πληροφορίες','Πληροφοριακό Σύστημα «Σίσυφος»','words',91,439,450,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-09-13 15:28:00','globeadmin','2015-09-13 16:29:47','globeadmin','2015-12-26 21:06:04','globeadmin'),('55f56cd572fe3e3','54a433830716b84',NULL,NULL,'1',10,NULL,'sisyphos_info_label2',30,500,'Πληροφορίες','Έκδοση 2016','words',115,439,450,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-09-13 15:32:21','globeadmin','2015-09-13 16:29:40','globeadmin','2015-12-26 21:06:04','globeadmin'),('55f56da7003db5d','54a433830716b84',NULL,NULL,'1',10,NULL,'sisyphos_info_label3',50,500,'Πληροφορίες','Περισσότερες πληροφορίες στην ιστοσελίδα  ','html',222,188,400,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<a href=\"http://www.sisyphos.gr\" target=\"_blank\">www.sisyphos.gr</a>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-09-13 15:35:51','globeadmin','2015-09-13 16:29:25','globeadmin','2015-12-26 21:06:04','globeadmin'),('55f56e1f470c2aa','54a433830716b84',NULL,NULL,'1',10,NULL,'sisyphos_info_label4',60,500,'Πληροφορίες','Επικοινωνία στο info@sisyphos.gr ή στη  ','html',261,205,400,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<a href=\"http://sisyphos.gr/index.php?page=contact.html\" target=\"_blank\">Φόρμα Επικοινωνίας</a>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-09-13 15:37:51','globeadmin','2015-09-13 16:29:18','globeadmin','2015-12-26 21:06:04','globeadmin'),('59d88688d6ac4e5','548338073921bfe',NULL,NULL,'0',10,NULL,'teacher_change_account',80,40,'Προσωπικά Στοιχεία',NULL,'html',355,113,220,100,'l','0','0','','0',NULL,NULL,'#nu_user_id# ','54a65ecc3f14737',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0  \n                            onmouseover=\"document.getElementById(\'img_log_user_id\').src=\'images/log_userb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_log_user_id\').src=\'images/log_user.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_log_user_id\' src=\'images/log_user.png\' title=\'Αλλαγή Κωδικού Πρόσβασης\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Λογαριασμός Πρόσβασης</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-07 10:47:20','globeadmin','2017-10-07 11:03:00','globeadmin','2022-01-08 10:51:56','globeadmin'),('55f570143384033','54a433830716b84',NULL,NULL,'1',10,NULL,'sisyphos_info_img1',10,500,'Πληροφορίες',NULL,'html',91,78,334,66,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<img id=\'img_sisyphos_id\' src=\'images/sisyphos.png\'/> ','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-09-13 15:46:12','globeadmin','2015-12-26 20:38:36','globeadmin','2015-12-26 21:06:04','globeadmin'),('55f571d3d4a6202','54a433830716b84',NULL,NULL,'1',10,NULL,'sisyphos_info_label6',70,500,'Πληροφορίες','Οδηγίες για τη χρήση του συστήματος στον  ','html',297,193,400,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<a href=\"http://sisyphos.gr/index.php?page=userguide.html\" target=\"_blank\">Οδηγό Χρήσης</a>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-09-13 15:53:39','globeadmin','2015-09-13 16:29:12','globeadmin','2015-12-26 21:06:04','globeadmin'),('55f572a7d4a49f9','54a433830716b84',NULL,NULL,'1',10,NULL,'sisyphos_info_label7',80,500,'Πληροφορίες','Ερωτήσεις, σχόλια, παρατηρήσεις και γνώμες στο  ','html',335,152,400,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<a href=\"http://www.sisyphos.gr/forum\" target=\"_blank\">Φόρουμ</a>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-09-13 15:57:11','globeadmin','2015-09-13 16:29:05','globeadmin','2015-12-26 21:06:04','globeadmin'),('59d8858d228a481','548338073921bfe',NULL,NULL,'1',10,NULL,'surname',10,40,'Προσωπικά Στοιχεία','Επώνυμο :','text',47,103,300,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-07 10:43:09','globeadmin','2017-10-07 11:03:00','globeadmin','2022-01-08 10:51:56','globeadmin'),('59d885aceb363eb','548338073921bfe',NULL,NULL,'1',10,NULL,'name',20,40,'Προσωπικά Στοιχεία','Όνομα :','text',89,120,300,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-07 10:43:41','globeadmin','2017-10-07 11:03:00','globeadmin','2022-01-08 10:51:56','globeadmin'),('59d885c7bea6229','548338073921bfe',NULL,NULL,'1',10,NULL,'fathers_name',30,40,'Προσωπικά Στοιχεία','Όνομα Πατρός :','text',132,76,300,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-07 10:44:07','globeadmin','2017-10-07 11:03:00','globeadmin','2022-01-08 10:51:56','globeadmin'),('55f57b111156823','54a433830716b84',NULL,NULL,'1',10,NULL,'sisyphos_info_label5',40,500,'Πληροφορίες','Copyright (c) 2014-2016','html',138,444,450,50,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<a href=\"http://sisyphos.gr/index.php?page=creator.html\" target=\"_blank\">Παπαδακάκης Νεκτάριος</a>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-09-13 16:33:05','globeadmin','2015-09-13 16:37:57','globeadmin','2015-12-26 21:06:04','globeadmin'),('59e3601ce4b1e25','54a6fde1ab6eb6d',NULL,NULL,'1',10,NULL,'parent_area',30,20,'Στοιχεία Επικοινωνίας','Περιοχή :','text',109,597,300,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-15 16:18:20','globeadmin','2017-10-15 17:26:07','globeadmin','2021-09-06 20:12:23','globeadmin'),('59e35cd64323e87','54a6fde1ab6eb6d',NULL,NULL,'1',10,NULL,'street',10,20,'Στοιχεία Επικοινωνίας','Οδός - Αριθμός :','text',62,41,300,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-15 16:04:22','globeadmin','2020-06-18 21:29:01','globeadmin','2021-09-06 20:12:23','globeadmin'),('59e35d3e5664a1f','54a6fde1ab6eb6d',NULL,NULL,'1',10,NULL,'area',50,20,'Στοιχεία Επικοινωνίας','Περιοχή :','text',109,84,300,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-15 16:06:06','globeadmin','2017-10-15 17:25:26','globeadmin','2021-09-06 20:12:23','globeadmin'),('59e35d7a14525ca','54a6fde1ab6eb6d',NULL,NULL,'1',10,NULL,'city',40,20,'Στοιχεία Επικοινωνίας','Πόλη :','text',155,101,300,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-15 16:07:06','globeadmin','2017-10-15 17:25:51','globeadmin','2021-09-06 20:12:23','globeadmin'),('59e35de1a1a6fb3','54a6fde1ab6eb6d',NULL,NULL,'1',10,NULL,'zipcode',70,20,'Στοιχεία Επικοινωνίας','Τ.Κ. :','text',202,108,100,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-15 16:08:49','globeadmin','2017-10-15 17:26:33','globeadmin','2021-09-06 20:12:23','globeadmin'),('59e35e2977ffbb0','54a6fde1ab6eb6d',NULL,NULL,'1',10,NULL,'phone1',90,20,'Στοιχεία Επικοινωνίας','Τηλέφωνο 1 :','text',248,61,150,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-15 16:10:01','globeadmin','2017-10-15 17:27:52','globeadmin','2021-09-06 20:12:23','globeadmin'),('59e35e5aa6445c0','54a6fde1ab6eb6d',NULL,NULL,'1',10,NULL,'phone2',110,20,'Στοιχεία Επικοινωνίας','Τηλέφωνο 2 :','text',295,61,150,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-15 16:10:50','globeadmin','2017-10-15 17:28:19','globeadmin','2021-09-06 20:12:23','globeadmin'),('59e35ecf6b61222','54a6fde1ab6eb6d',NULL,NULL,'1',10,NULL,'mobile',130,20,'Στοιχεία Επικοινωνίας','Κινητό :','text',341,93,150,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-15 16:12:47','globeadmin','2017-10-15 17:28:38','globeadmin','2021-09-06 20:12:23','globeadmin'),('59e35f0d30a1e0e','54a6fde1ab6eb6d',NULL,NULL,'1',10,NULL,'email',150,20,'Στοιχεία Επικοινωνίας','Email :','text',388,99,300,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-15 16:13:49','globeadmin','2017-10-15 17:26:55','globeadmin','2021-09-06 20:12:23','globeadmin'),('59e35f99352f549','54a6fde1ab6eb6d',NULL,NULL,'1',10,NULL,'parent_surname',150,10,'Στοιχεία Μαθητή','Επώνυμο Κηδεμόνα :','text',254,22,300,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-15 16:16:09','globeadmin','2017-10-15 16:42:05','globeadmin','2021-09-06 20:12:23','globeadmin'),('59e35fbcb4120dd','54a6fde1ab6eb6d',NULL,NULL,'1',10,NULL,'parent_name',140,10,'Στοιχεία Μαθητή','Όνομα Κηδεμόνα :','text',295,39,300,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-15 16:16:44','globeadmin','2017-10-15 16:42:24','globeadmin','2021-09-06 20:12:22','globeadmin'),('55fd5003a00b0c4','nuhome',NULL,NULL,'1',10,NULL,'copyaccessbtn',80,10,'Globeadmin','Αντιγραφή Access Level','button',365,64,200,35,'l','0','0','','0',NULL,NULL,'0','55fd4faf6572ec3',NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-09-19 15:07:31','globeadmin','2016-03-06 11:10:50','globeadmin','2017-11-25 11:29:52','globeadmin'),('55fd506e964702e','55fd4faf6572ec3',NULL,NULL,'1',10,NULL,'idbtn',30,10,'Αντιγραφή','Αντιγραφή','button',126,371,200,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-09-19 15:09:18','globeadmin','2015-09-19 15:14:28','globeadmin','2017-11-25 11:28:25','globeadmin'),('55fd513c8c81737','55fd4faf6572ec3',NULL,NULL,'1',10,NULL,'id_from',10,10,'Αντιγραφή','Access Level ΑΠΟ το οποίο θα αντιγραφούν τα δικαιώματα : ','dropdown',31,29,200,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'SELECT zzzsys_access_level_id,sal_code FROM zzzsys_access_level',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-09-19 15:12:44','globeadmin','2015-09-19 15:15:47','globeadmin','2017-11-25 11:28:25','globeadmin'),('55fd51731751f0d','55fd4faf6572ec3',NULL,NULL,'1',10,NULL,'id_to',20,10,'Αντιγραφή','Access Level ΠΡΟΣ το οποίο θα αντιγραφούν τα δικαιώματα : ','dropdown',79,20,200,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'SELECT zzzsys_access_level_id,sal_code FROM zzzsys_access_level',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-09-19 15:13:39','globeadmin','2015-09-19 15:16:04','globeadmin','2017-11-25 11:28:25','globeadmin'),('55fd528398b81fe','55fd4faf6572ec3',NULL,NULL,'1',10,NULL,'msgiFrame',40,10,'Αντιγραφή',NULL,'iframe',193,29,800,250,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-09-19 15:18:11','globeadmin','2015-09-19 15:18:50','globeadmin','2017-11-25 11:28:25','globeadmin'),('5688eebb13cb9b3','5688ee0218ad763',NULL,NULL,'1',10,NULL,'classroom_id',70,10,'Εισαγωγή Νέας Διδασκαλίας','Αίθουσα :','dropdown',162,247,100,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from classroom',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2016-01-03 11:49:47','globeadmin','2016-01-03 11:49:47','globeadmin','2017-10-03 23:25:21','globeadmin'),('5687a7825405d70','5684e68b302da76',NULL,NULL,'1',10,NULL,'teacher_id',50,10,'Διδασκαλίες','Καθηγητής :','dropdown',67,222,200,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from teacher order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-01-02 12:33:38','globeadmin','2016-01-02 13:01:31','globeadmin','2021-03-24 11:14:35','globeadmin'),('5687a7a4121ad72','5684e68b302da76',NULL,NULL,'1',10,NULL,'day_id',60,10,'Διδασκαλίες','Ημέρα :','dropdown',67,535,100,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,name from day order by id',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-01-02 12:34:12','globeadmin','2016-01-02 13:01:31','globeadmin','2021-03-24 11:14:35','globeadmin'),('5687a7d8121acbe','5684e68b302da76',NULL,NULL,'1',10,NULL,'showbtn',70,10,'Διδασκαλίες','Εμφάνιση','button',128,97,150,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-01-02 12:35:04','globeadmin','2016-01-02 13:01:31','globeadmin','2021-03-24 11:14:35','globeadmin'),('5687a8267d86edb','5684e68b302da76',NULL,NULL,'1',10,NULL,'showiframe',70,10,'Διδασκαλίες',NULL,'iframe',183,8,930,350,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'5687b0505b9ec15','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-01-02 12:36:22','globeadmin','2018-07-04 15:40:11','globeadmin','2021-03-24 11:14:35','globeadmin'),('5687a852128baf3','5684e68b302da76',NULL,NULL,'1',10,NULL,'current_timetable',80,10,'Διδασκαλίες',NULL,'display',21,299,80,30,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select ifNULL(max(valid_from),\'2000-01-01\') from card where valid_from<=curdate()',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-01-02 12:37:06','globeadmin','2016-01-02 13:01:31','globeadmin','2021-03-24 11:14:35','globeadmin'),('5687a873df9f7b0','5684e68b302da76',NULL,NULL,'1',10,NULL,'label1',90,10,'Διδασκαλίες','Επιλέξτε από τα παραπάνω κριτήρια αναζήτησης. Αφήνοντας κενό, το τμήμα τον καθηγητή ή την ημέρα, εμφανίζονται όλες οι αντίστοιχες διδασκαλίες.','words',100,30,700,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from class order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-01-02 12:37:39','globeadmin','2016-01-03 18:39:57','globeadmin','2021-03-24 11:14:35','globeadmin'),('5687ad8b396f7ed','5684e68b302da76',NULL,NULL,'1',10,NULL,'framehtml',20,10,'Διδασκαλίες',NULL,'html',51,17,720,125,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<html>\n<body>\n<table width=100% height=100% border=1  cellspacing=0 bordercolor=red><tr><td></td></tr><table>\n</body>\n</html>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-01-02 12:59:23','globeadmin','2016-01-03 18:40:13','globeadmin','2021-03-24 11:14:34','globeadmin'),('56883542476b1e0','568834bf97fe8a1',NULL,NULL,'1',10,NULL,'new_timetable_date',20,10,'Κλωνοποίηση Ωρολογίου Προγράμματος','Ημερομηνία Έναρξης Ισχύος του Νέου Ωρολογίου :','text',32,16,100,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2016-01-02 22:38:26','globeadmin','2016-01-02 22:50:22','globeadmin','2016-05-25 13:36:04','globeadmin'),('5688e44fde6ecb6','5684e68b302da76',NULL,NULL,'0',10,'select if (\'#start_date#\'>curdate() and \'#RECORD_ID#\'<>\'-1\',\'1\',\'0\')','add_card',30,10,'Διδασκαλίες',NULL,'html',63,748,180,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_timeadd_id\').src=\'images/timeaddb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_timeadd_id\').src=\'images/timeadd.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_timeadd_id\' src=\'images/timeadd.png\' title=\'Προσθήκη νέας διδασκαλίας στο ωρολόγιο\'/>\n             \n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Προσθήκη Νέας Διδασκαλίας</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-01-03 11:05:19','globeadmin','2016-05-22 21:42:02','globeadmin','2021-03-24 11:14:34','globeadmin'),('5688359d33e4cb9','568834bf97fe8a1',NULL,NULL,'1',10,NULL,'copybtn',30,10,'Κλωνοποίηση Ωρολογίου Προγράμματος','Κλωνοποίηση','button',24,437,150,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-01-02 22:39:57','globeadmin','2016-01-02 22:47:37','globeadmin','2016-05-25 13:38:10','globeadmin'),('56dda20eb80a7ee','56dd9f180d22b31',NULL,NULL,'1',10,'select \'0\'','comments',30,10,'Διδασκαλία',NULL,'textarea',278,734,100,100,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select \'1\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2016-03-07 17:45:18','globeadmin','2016-03-07 17:46:36','globeadmin','2022-12-21 12:48:45','globeadmin'),('56e5960205f007f','56192c691b58858',NULL,NULL,'0',10,NULL,'teaching_bookbtn',40,30,'Μαθήματα και Διδασκαλίες',NULL,'html',192,73,220,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_ebooks_id\').src=\'images/ebooksb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_ebooks_id\').src=\'images/ebooks.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_ebooks_id\' src=\'images/ebooks.png\' title=\'Ημερολόγια Διδασκαλιών\'/>\n            <img /> \n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Ημερολόγια Διδασκαλιών</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-03-13 18:32:02','globeadmin','2017-10-28 22:09:21','globeadmin','2021-10-24 21:25:06','globeadmin'),('56e5540394353fe','56e553b8d3afa56',NULL,NULL,'1',10,NULL,'subject_id',20,10,'Ημερολόγιο Διδασκαλιών','Μάθημα :','dropdown',38,26,750,250,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'SELECT distinct subject.id, concat(subject.name,if(subject_type.name is null,\'\',concat(\' (\',subject_type.name,\')\')))\nFROM subject\nLEFT JOIN subject_type ON subject_type.id = subject.subject_type_id\nwhere 1=0\nORDER BY subject.short_name\n',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-03-13 13:50:27','globeadmin','2016-03-13 13:58:19','globeadmin','2016-10-09 10:31:49','globeadmin'),('56dda0640ab34bb','56dd9f180d22b31',NULL,NULL,'1',10,NULL,'card_date',10,10,'Διδασκαλία','Ημερομηνία :','text',24,12,90,30,'c','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2016-03-07 17:38:12','globeadmin','2016-03-11 16:28:19','globeadmin','2022-12-21 12:48:45','globeadmin'),('56dda11508440f8','56dd9f180d22b31',NULL,NULL,'1',10,NULL,'class_lesson_disp',40,10,'Διδασκαλία','Τμήμα - Μάθημα :','display',24,267,550,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','SELECT concat (class.short_name,\' - \',subject.name,IF(subject_type.short_name IS NULL,\'\',CONCAT(\' (\',subject_type.short_name,\')\')))\nFROM registered_card\ninner join  card            on card.id          = registered_card.card_id\ninner join  class           on class.id         = card.class_id\ninner join  subject         on subject.id       = card.subject_id\nleft join   subject_type    on subject_type.id  = subject.subject_type_id\nWHERE registered_card.id=\'#RECORD_ID#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2016-03-07 17:41:09','globeadmin','2016-03-07 18:01:58','globeadmin','2022-12-21 12:48:45','globeadmin'),('56b74e6e8b7dca5','5470c07906bfd70',NULL,NULL,'0',10,NULL,'edit_grading_period',100,10,'Λεπτομέρειες',NULL,'html',421,434,20,20,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"this.style.cursor=\'pointer\';\"\n                            onmouseout=\"this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=16 height=16 id=\'img_modify\' src=\'images/modify.png\' title=\'Επεξεργασία Βαθ. Περιόδου\'/>\n        </td>\n    </tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-02-07 16:02:22','globeadmin','2016-02-07 16:08:01','globeadmin','2018-01-09 15:24:35','globeadmin'),('56b74629890cb6e','547372d029461f4',NULL,NULL,'0',10,'select if((teacher.user_id IS NULL) and (\'#nu_user_group#\'=\'globeadmin\' or \'#nu_user_group#\'=\'Administrators\' or \'#nu_user_group#\'=\'Managers\') and \'#RECORD_ID#\'<>\'-1\',\'1\',\'0\')\nfrom school\nleft join teacher ON teacher.id=\'#RECORD_ID#\'\nwhere school.id=\'1\'','add_usertbtn',130,10,'Λεπτομέρειες',NULL,'html',35,837,20,20,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"this.style.cursor=\'pointer\';\"\n                            onmouseout=\"this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=18 height=18 id=\'img_add\' src=\'images/add.png\' title=\'Προσθήκη Νέου Χρήστη\'/>\n        </td>\n    </tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-02-07 15:27:05','globeadmin','2017-11-29 21:37:28','globeadmin','2021-01-26 20:15:04','globeadmin'),('56b74c1ac615b00','5470c07906bfd70',NULL,NULL,'0',10,NULL,'edit_school_year',80,10,'Λεπτομέρειες',NULL,'html',365,434,20,20,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"this.style.cursor=\'pointer\';\"\n                            onmouseout=\"this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=16 height=16 id=\'img_modify\' src=\'images/modify.png\' title=\'Επεξεργασία Σχ. Έτους\'/>\n        </td>\n    </tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-02-07 15:52:26','globeadmin','2016-02-07 16:08:01','globeadmin','2018-01-09 15:24:34','globeadmin'),('578363e74083895','54a4107cddefff1',NULL,NULL,'1',10,NULL,'reciever_name',60,10,'Αποστολή Email','Προς :','display',12,55,600,40,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','SELECT \n    concat(\n        if(student.id is NULL,\'\',\n            concat(\n                if(student.surname is NULL,\'\',concat(student.surname,\' \')),\n                if(student.name is NULL,\'\',concat(student.name,\' \')),\n                if(student.fathers_name is NULL,\'\',concat (\'πατ. \',student.fathers_name ))\n                )\n            ),\n        if(teacher.id is NULL,\'\',\n            concat(\n                if(teacher.surname is NULL,\'\',concat(teacher.surname,\' \')),\n                if(teacher.name is NULL,\'\',concat(teacher.name,\' \'))\n                )\n            )\n        )\nFROM session_variables\nleft join teacher on teacher.id = sms_teacher_id\nleft join student on student.id = sms_student_id\nWHERE session_id=\'#session_id#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-07-11 12:16:23','globeadmin','2016-07-11 12:16:23','globeadmin','2021-03-24 11:17:19','globeadmin'),('56c9890272fc73e','56c989024e5f43c',NULL,NULL,'1',10,NULL,'end_value',40,10,'Λεπτομέρειες','Τιμές Έως :','text',158,241,40,0,'r','0','0','select \'20\'','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'0000-00-00 00:00:00','','2016-02-21 12:37:18','globeadmin','2017-08-20 15:48:22','globeadmin'),('56c989027a4f78f','56c989024e5f43c',NULL,NULL,'1',10,NULL,'num_of_decimals',50,10,'Λεπτομέρειες','Πλήθος Δεκαδικών Ψηφίων : ','dropdown',199,141,50,0,'c','0','0','select \'0\'','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'0|0|1|1|2|2',NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'0000-00-00 00:00:00','','2016-02-21 12:37:30','globeadmin','2017-08-20 15:48:23','globeadmin'),('56c9890281a2639','nuhome',NULL,NULL,'0',10,NULL,'mark_typebtn',70,10,'Globeadmin','Tύποι Βαθμών','button',210,382,200,35,'l','0','0','','0',NULL,NULL,'','56c989024e5f43c','','','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',0,0,'0000-00-00 00:00:00','','2016-03-06 11:11:02','globeadmin','2017-10-08 20:50:39','globeadmin'),('56c99466a15f743','56c989024e5f43c','',NULL,'1',10,NULL,'mark_type_value_subform',60,10,'Λεπτομέρειες','Λίστα Τιμών : ','subform',99,228,200,250,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,20,'1','1','mark_type_id','id','SELECT * FROM mark_type_value WHERE mark_type_id = \'#RECORD_ID#\'','mark_type_value',NULL,'',NULL,'g',0,0,'0000-00-00 00:00:00','','2016-02-21 12:45:10','globeadmin','2017-08-20 15:48:23','globeadmin'),('56c99466a8b2df4','56c99466a15f743',NULL,NULL,'1',10,NULL,'name',10,10,'Details','Όνομα Βαθμού','text',0,0,150,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2016-02-21 12:45:28','globeadmin','2016-02-21 15:07:07','globeadmin'),('56e99175f05b8a6','56e98e66abfe2c1',NULL,NULL,'1',10,NULL,'tinymce_editor',70,10,'Σχόλια Καθηγητή',NULL,'iframe',136,20,900,370,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'56cc9f04b82528e','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-03-16 19:01:42','globeadmin','2016-03-16 19:11:16','globeadmin','2021-03-24 11:21:28','globeadmin'),('56e990b0da60c09','56e98e66abfe2c1',NULL,NULL,'1',10,NULL,'class_lesson_disp',20,10,'Σχόλια Καθηγητή','Μάθημα :','display',47,103,700,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','SELECT concat (subject.name,IF(subject_type.short_name IS NULL,\'\',CONCAT(\' (\',subject_type.short_name,\')\')))\nFROM comment\ninner join  subject         on subject.id       = comment.subject_id\nleft join   subject_type    on subject_type.id  = subject.subject_type_id\nWHERE comment.id=\'#RECORD_ID#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2016-03-16 18:58:24','globeadmin','2016-03-17 20:39:56','globeadmin','2021-03-24 11:21:27','globeadmin'),('578f9a05bfa01da','59d7d7da6d30b22',NULL,NULL,'0',10,NULL,'btnimg2',20,10,'Αποστολή και Αναζήτηση Μηνυμάτων',NULL,'html',80,380,220,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'students_sms_id\').src=\'images/students_smsb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'students_sms_id\').src=\'images/students_sms.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'students_sms_id\' src=\'images/students_sms.png\' title=\'Μαζική Αποστολή SMS σε Μαθητές  - Γονείς\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Αποστολή SMS σε Μαθητές  - Γονείς</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-07-20 18:34:29','globeadmin','2018-03-10 19:12:08','globeadmin','2018-03-10 19:12:08','globeadmin'),('56d08edf31536cf','54a4107cddefff1',NULL,NULL,'1',10,NULL,'email_text_tinymce',30,10,'Αποστολή Email',NULL,'iframe',115,7,824,380,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'56cc9f04b82528e','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-02-26 19:43:59','globeadmin','2016-02-26 20:05:53','globeadmin','2021-03-24 11:17:19','globeadmin'),('56ec604e671c87c','56e98e66abfe2c1',NULL,NULL,'1',10,NULL,'last_update_disp',30,10,'Σχόλια Καθηγητή','Τελευταία Ενημέρωση :','display',78,20,700,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','SELECT concat (if(teacher.surname IS NULL,\'\',concat(teacher.surname,\' \')),IF(teacher.name IS NULL,\'\',CONCAT(teacher.name,\' \')),\' στις \' ,DATE_FORMAT(changed_at,\'%d-%m-%Y %H:%i:%s\'))\nFROM comment\ninner join  teacher         on teacher.id       = comment.post_teacher_id\nWHERE comment.id=\'#RECORD_ID#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2016-03-18 22:08:46','globeadmin','2016-03-18 22:28:17','globeadmin','2021-03-24 11:21:27','globeadmin'),('5688ee8d694030c','5688ee0218ad763',NULL,NULL,'1',10,NULL,'subject_id',50,10,'Εισαγωγή Νέας Διδασκαλίας','Μάθημα :','dropdown',76,249,250,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from subject order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2016-01-03 11:49:01','globeadmin','2016-01-03 11:56:52','globeadmin','2017-10-03 23:25:20','globeadmin'),('5688eea955b683a','5688ee0218ad763',NULL,NULL,'1',10,NULL,'teacher_id',60,10,'Εισαγωγή Νέας Διδασκαλίας','Καθηγητής :','dropdown',119,234,250,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from teacher order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2016-01-03 11:49:29','globeadmin','2016-01-03 11:49:29','globeadmin','2017-10-03 23:25:20','globeadmin'),('56dd9fcf1bc8ab4','56dd9f180d22b31',NULL,NULL,'1',10,NULL,'tinymce_editor',50,10,'Διδασκαλία',NULL,'iframe',59,17,900,400,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'56cc9f04b82528e','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-03-07 17:35:43','globeadmin','2016-03-07 17:46:17','globeadmin','2022-12-21 12:48:45','globeadmin'),('56cf52967ee2d78','59e22f4f52546e3',NULL,NULL,'1',10,NULL,'student_home_school_text_tinymce',50,10,'Αποστολή Μηνύματος',NULL,'iframe',92,17,800,400,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'56cc9f04b82528e','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-02-25 21:14:30','globeadmin','2017-10-15 15:48:13','globeadmin','2021-02-16 15:14:13','globeadmin'),('59e3610073cd9a1','54a6fde1ab6eb6d',NULL,NULL,'1',10,NULL,'parent_email',140,20,'Στοιχεία Επικοινωνίας','Πρωτεύον Email :','text',348,546,300,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-15 16:22:08','globeadmin','2021-09-06 21:15:07','globeadmin','2021-09-06 21:15:07','globeadmin'),('59e37162dc491b7','54a6fde1ab6eb6d',NULL,NULL,'1',10,NULL,'label_parent',160,20,'Στοιχεία Επικοινωνίας','Στοιχεία Επικοινωνίας Γονέα','words',27,566,300,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-15 17:32:02','globeadmin','2017-10-15 17:32:03','globeadmin','2021-09-06 20:12:24','globeadmin'),('59e3719c695916d','54a6fde1ab6eb6d',NULL,NULL,'1',10,NULL,'label_student',170,20,'Στοιχεία Επικοινωνίας','Στοιχεία Επικοινωνίας Μαθητή','words',27,54,300,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-15 17:33:00','globeadmin','2017-10-15 17:33:00','globeadmin','2021-09-06 20:12:24','globeadmin'),('59d885e883fde00','548338073921bfe',NULL,NULL,'1',10,NULL,'gender',40,40,'Προσωπικά Στοιχεία','Φύλο :','dropdown',174,129,100,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'Α|ΑΝΔΡΑΣ|Θ|ΓΥΝΑΙΚΑ',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-07 10:44:40','globeadmin','2017-10-07 11:03:00','globeadmin','2022-01-08 10:51:56','globeadmin'),('59d886083846588','548338073921bfe',NULL,NULL,'1',10,NULL,'teaching_field_id',50,40,'Προσωπικά Στοιχεία','Ειδικότητα :','dropdown',220,98,300,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,CONCAT(ifNULL(short_name,\'\'),\' - \',ifNULL(name,\'\'))  \nfrom teaching_field\norder by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2017-10-07 10:45:12','globeadmin','2018-08-04 10:12:24','globeadmin','2022-01-08 10:51:56','globeadmin'),('5614ca38ac2ab25','5613deecec28ad6',NULL,NULL,'1',10,NULL,'when_date',10,10,'Προγραμματισμός Εκδρομής, Εκδήλωσης ή Αναπλήρωσης για Σήμερα ή Αύριο','Ημέρα : ','dropdown',79,149,80,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select curdate(),\'Σήμερα\'\nunion\nselect DATE_ADD(curdate(), INTERVAL 1 DAY),\'Άυριο\'',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-07 10:31:04','globeadmin','2015-10-07 10:37:50','globeadmin','2018-07-28 11:40:30','globeadmin'),('5611a20dded7b81','55222f79d342b66',NULL,NULL,'1',10,'select \'0\'','label1',90,10,'Απουσίες','Δικαιολόγηση Απουσιών μέχρι και τις :','words',20,900,250,25,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select 	concat(num_days_absence_justification,\' Ημέρες\',\' -  Μέχρι και την \',DATE_FORMAT(DATE_ADD(CURDATE(), INTERVAL - (num_days_absence_justification+1) DAY),\'%d-%m-%Y\')) from school limit 1',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2015-10-05 01:02:53','globeadmin','2018-08-05 12:48:57','globeadmin','2018-08-14 10:07:26','globeadmin'),('5612bc192389785','59d7d6e9ecc73da',NULL,NULL,'1',10,'SELECT IF(  \'#nu_user_group#\'=\'globeadmin\' OR \n            \'#nu_user_group#\'=\'Managers\' OR \n            \'#nu_user_group#\'=\'AssistManagers\' OR\n            count(*)>0, \'1\', \'0\')\nfrom student\nwhere \n    teacher_id=#RECORD_ID#','justifie_student_absencebtn',60,10,'Εργασίες Απουσιών',NULL,'html',334,380,220,100,'c','0','0','','0',NULL,NULL,NULL,'55222f79d342b66',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_jasabs_id\').src=\'images/jasabsb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_jasabs_id\').src=\'images/jasabs.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_jasabs_id\' src=\'images/jasabs.png\' title=\'Δικαιολόγηση απουσιών του μαθητή\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Δικαιολόγηση Απουσιών</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-05 21:06:17','globeadmin','2017-10-07 01:10:19','globeadmin','2021-02-27 09:46:56','globeadmin'),('5612d62c768b88f','59e22f9965b5362',NULL,NULL,'1',10,'select \'0\'','parent_justified_days_disp',110,10,'Απουσίες','Δικαιολογητικά από Κηδεμόνα :','display',9,1014,90,30,'c','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select CONVERT(concat(COUNT(distinct absence_date),\' / \', parent_days_limit_justification) USING utf8)\nfrom absence,school\nwhere 	school.id=1 and\n		student_id=#RECORD_ID# and \n        justified=1 and\n        justified_reason_id=1',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-05 22:57:32','globeadmin','2018-03-08 21:06:13','globeadmin','2020-04-02 16:25:31','globeadmin'),('5612da78dd15869','5476201e5a3d38f',NULL,NULL,'1',10,'select \'0\'','parent_justified_days_disp',130,80,'Απουσίες','Δικαιολογητικά από Κηδεμόνα :','words',18,1031,90,30,'c','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select CONVERT(concat(COUNT(distinct absence_date),\' / \', parent_days_limit_justification) USING utf8)\nfrom absence,school\nwhere 	school.id=1 and\n		student_id=#RECORD_ID# and \n        justified=1 and\n        justified_reason_id=1',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-05 23:15:52','globeadmin','2018-08-06 09:53:37','globeadmin','2022-01-08 11:22:29','globeadmin'),('5613dff4a2eab75','5613deecec28ad6',NULL,NULL,'1',10,NULL,'from_period_id',20,10,'Προγραμματισμός Εκδρομής, Εκδήλωσης ή Αναπλήρωσης για Σήμερα ή Αύριο','Από : ','dropdown',128,162,80,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,name from period order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-06 17:51:32','globeadmin','2015-10-07 10:37:58','globeadmin','2018-07-28 11:40:30','globeadmin'),('5613e05d1550b5c','5613deecec28ad6',NULL,NULL,'1',10,NULL,'class_id',40,10,'Προγραμματισμός Εκδρομής, Εκδήλωσης ή Αναπλήρωσης για Σήμερα ή Αύριο','Τμήματα : ','listbox',172,137,250,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select distinct class.id,class.short_name \nfrom class\ninner join student_class on class.id=student_class.class_id\norder by class.short_name',NULL,'','','select distinct class.id,class.short_name \nfrom class\ninner join student_class on class.id=student_class.class_id\norder by class.short_name',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-06 17:53:17','globeadmin','2017-10-03 00:50:55','globeadmin','2018-07-28 11:40:30','globeadmin'),('5613e0c9dff2343','5613deecec28ad6',NULL,NULL,'1',10,NULL,'teacher_id',70,10,'Προγραμματισμός Εκδρομής, Εκδήλωσης ή Αναπλήρωσης για Σήμερα ή Αύριο','Επιβλέπων Καθηγητής : ','dropdown',326,55,300,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from teacher order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-06 17:55:06','globeadmin','2018-07-28 11:41:29','globeadmin','2018-07-28 11:41:29','globeadmin'),('5613e171c5172eb','5613deecec28ad6',NULL,NULL,'1',10,NULL,'subject_id',50,10,'Προγραμματισμός Εκδρομής, Εκδήλωσης ή Αναπλήρωσης για Σήμερα ή Αύριο','Δραστηριότητα : ','dropdown',227,100,400,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select subject.id,concat(ifNULL(grade.short_name,\'\'),ifNULL(section.abbreviation,\'\'),if(section.abbreviation!=speciality.abbreviation,ifNULL(speciality.abbreviation,\'\'),\'\'),\' \',subject.name,if(subject_type.short_name is NULL,\'\',concat(\'-\',subject_type.short_name))) as full_name\nfrom subject\nleft join grade on subject.grade_id=grade.id\nleft join speciality on subject.speciality_id=speciality.id\nleft join section on speciality.section_id=section.id\nleft  join subject_type on subject.subject_type_id=subject_type.id\nwhere   subject.id<10 OR \n        subject.id in \n    (   select distinct subject_id\n        from card\n        where   card.valid_from =(select max(timetable.start_date) from timetable where (timetable.start_date <= curdate())) and\n                class_id is not NULL\n        )\norder by  IF(subject.id<10,subject.id,full_name)\n',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-06 17:57:53','globeadmin','2018-07-28 11:41:15','globeadmin','2018-07-28 11:41:15','globeadmin'),('5613e1ec302a374','5613deecec28ad6',NULL,NULL,'1',10,NULL,'to_period_id',30,10,'Προγραμματισμός Εκδρομής, Εκδήλωσης ή Αναπλήρωσης για Σήμερα ή Αύριο','Έως και : ','dropdown',128,317,80,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,name from period order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-06 17:59:56','globeadmin','2015-10-08 22:08:39','globeadmin','2018-07-28 11:40:30','globeadmin'),('5613e63817c02f8','5613deecec28ad6',NULL,NULL,'1',10,NULL,'declarebtn',80,10,'Προγραμματισμός Εκδρομής, Εκδήλωσης ή Αναπλήρωσης για Σήμερα ή Αύριο','Ορισμός','button',406,197,200,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-06 18:18:16','globeadmin','2017-10-03 00:27:30','globeadmin','2018-07-28 11:40:30','globeadmin'),('5613e9284fe728a','5613deecec28ad6',NULL,NULL,'1',10,NULL,'label1',90,10,'Προγραμματισμός Εκδρομής, Εκδήλωσης ή Αναπλήρωσης για Σήμερα ή Αύριο','Προσοχή: Για να μεταβάλλετε το σημερινό ωρολόγιο πρόγραμμα δεν πρέπει να έχει γίνει καταχώριση απουσιών!','words',27,37,750,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-06 18:30:48','globeadmin','2018-03-10 19:00:56','globeadmin','2018-07-28 11:40:30','globeadmin'),('561406327216a7f','54707c8612b1b6b',NULL,NULL,'1',10,NULL,'teacher_access',40,10,'Λεπτομέρειες','Δικαιολόγηση και από τους Υπεύθυνους Καθηγητές :','checkbox',251,135,100,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-10-06 20:34:42','globeadmin','2015-10-06 20:41:46','globeadmin','2019-11-03 18:57:14','globeadmin'),('5615647ce3be898','5613deecec28ad6',NULL,NULL,'1',10,NULL,'classroom_id',60,10,'Προγραμματισμός Εκδρομής, Εκδήλωσης ή Αναπλήρωσης για Σήμερα ή Αύριο','Αίθουσα : ','dropdown',276,138,120,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select distinct id,short_name \nfrom classroom',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-07 21:29:17','globeadmin','2015-10-09 21:29:46','globeadmin','2018-07-28 11:40:30','globeadmin'),('5616c3a6056a0aa','5616c3a5f23ccc8',NULL,NULL,'1',10,NULL,'valid_from',10,10,'Λεπτομέρειες','Έναρξη Ισχύος :','text',61,25,80,0,'r','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-10-08 22:54:29','globeadmin','2017-10-31 11:31:36','globeadmin'),('5616c3a60cbceae','5616c3a5f23ccc8',NULL,NULL,'1',10,NULL,'subject_id',50,10,'Λεπτομέρειες','Μάθημα : ','dropdown',110,276,250,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from subject order by short_name',NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'0000-00-00 00:00:00','','2015-10-14 00:05:12','globeadmin','2017-10-31 11:31:36','globeadmin'),('5616c3a6140ff10','5616c3a5f23ccc8',NULL,NULL,'1',10,NULL,'teacher_id',60,10,'Λεπτομέρειες','Καθηγητής :','dropdown',157,265,250,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name \nfrom teacher\norder by short_name ',NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'0000-00-00 00:00:00','','2017-10-31 11:13:38','globeadmin','2017-10-31 11:31:36','globeadmin'),('5616c3a61b63291','5616c3a5f23ccc8',NULL,NULL,'1',10,NULL,'class_id',20,10,'Λεπτομέρειες','Τμήμα :','dropdown',110,74,100,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name \nfrom class\norder by short_name ',NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'0000-00-00 00:00:00','','2017-10-31 11:12:03','globeadmin','2017-10-31 11:31:36','globeadmin'),('5616c3a622b5f45','5616c3a5f23ccc8',NULL,NULL,'1',10,NULL,'classroom_id',70,10,'Λεπτομέρειες','Αίθουσα :','dropdown',205,279,100,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from classroom order by short_name',NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'0000-00-00 00:00:00','','2017-10-31 11:14:07','globeadmin','2017-10-31 11:31:36','globeadmin'),('5616c3a62a0908c','5616c3a5f23ccc8',NULL,NULL,'1',10,NULL,'day_id',30,10,'Λεπτομέρειες','Ημέρα :','dropdown',157,73,100,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,name from day order by id',NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'0000-00-00 00:00:00','','2017-10-31 11:12:34','globeadmin','2017-10-31 11:31:36','globeadmin'),('5616c3a6315c1bd','5616c3a5f23ccc8',NULL,NULL,'1',10,NULL,'period_id',40,10,'Λεπτομέρειες','Ώρα :','dropdown',204,85,100,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from period order by id',NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'0000-00-00 00:00:00','','2017-10-31 11:12:52','globeadmin','2017-10-31 11:31:36','globeadmin'),('5616c8991411a84','5616c3a5f23ccc8',NULL,NULL,'1',10,'select if(\'#valid_from#\'>curdate(),\'0\',\'1\')','label1',80,10,'Λεπτομέρειες','Προσοχή : Δεν μπορείτε να τροποποιήσετε αυτή τη διδασκαλία! Το πρόγραμμα στο οποίο ανήκει έχει τεθεί ήδη σε ισχύ!','words',22,10,730,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from period',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2015-10-08 22:48:41','globeadmin','2016-01-03 14:48:20','globeadmin','2017-10-31 11:31:36','globeadmin'),('5618f634ba09918','5618f5cc92f9c9e',NULL,NULL,'0',10,NULL,'teacher_homebtnimg',10,10,'Αρχικό Μενού',NULL,'html',50,73,220,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_ucard_id\').src=\'images/ucardb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_ucard_id\').src=\'images/ucard.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_ucard_id\' src=\'images/ucard.png\' title=\'Προσωπικά Στοιχεία και Εργασίες\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Προσωπικά Στοιχεία και Εργασίες</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-10 14:27:48','globeadmin','2017-10-28 20:26:58','globeadmin','2022-11-30 11:53:02','globeadmin'),('5618f6af5d45253','nuhome',NULL,NULL,'1',10,NULL,'mngbtn',50,10,'Globeadmin','Διευθυντής','button',55,64,200,35,'l','0','0','','0',NULL,NULL,'26','5618f5cc92f9c9e',NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-10 14:29:51','globeadmin','2016-03-06 11:10:13','globeadmin','2017-09-01 19:00:02','globeadmin'),('5618f82255f28b4','5618f5cc92f9c9e',NULL,NULL,'0',10,NULL,'absence_homebtnimg',20,10,'Αρχικό Μενού',NULL,'html',192,73,220,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_absences_id\').src=\'images/absencesb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_absences_id\').src=\'images/absences.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_absences_id\' src=\'images/absences.png\' title=\'Εργασίες που αφορούν τις απουσίες\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Απουσίες</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-10 14:36:02','globeadmin','2017-10-28 20:26:58','globeadmin','2022-11-30 11:53:02','globeadmin'),('5618f86e6225d30','5618f5cc92f9c9e',NULL,NULL,'0',10,'select if(  \'#nu_user_group#\'=\'globeadmin\' or \n            \'#nu_user_group#\'=\'Administrators\' or \n            \'#nu_user_group#\'=\'Managers\' or \n            \'#nu_user_group#\'=\'AssistManagers\',\'1\',\'0\')','mark_homebtnimg',50,10,'Αρχικό Μενού',NULL,'html',192,380,220,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_amark_id\').src=\'images/amarkb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_amark_id\').src=\'images/amark.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=86 height=74 id=\'img_amark_id\' src=\'images/amark.png\' title=\'Εργασίες που αφορούν την αξιολόγηση των μαθητών και τις ποινές τους\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Αξιολόγηση Μαθητών & Ποινές</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-10 14:37:18','globeadmin','2018-01-08 19:58:25','globeadmin','2022-11-30 11:53:03','globeadmin'),('5618f8a0c8afab1','5618f5cc92f9c9e',NULL,NULL,'0',10,NULL,'message_center_homebtnimg',70,10,'Αρχικό Μενού',NULL,'html',50,687,220,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_message_center_id\').src=\'images/message_centerb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_message_center_id\').src=\'images/message_center.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=92 height=74 id=\'img_message_center_id\' src=\'images/message_center.png\' title=\'Κέντρο μαζικής αποστολής SMS και email\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Κέντρο Αποστολής Μηνυμάτων</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-10 14:38:08','globeadmin','2017-10-28 20:26:58','globeadmin','2022-11-30 11:53:03','globeadmin'),('5618f8ca251e41b','5618f5cc92f9c9e',NULL,NULL,'0',10,'select if(  \'#nu_user_group#\'=\'globeadmin\' or \n            \'#nu_user_group#\'=\'Administrators\' or \n            \'#nu_user_group#\'=\'Managers\' or \n            \'#nu_user_group#\'=\'AssistManagers\',\'1\',\'0\')','config_homebtnimg',90,10,'Αρχικό Μενού',NULL,'html',334,687,220,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_config_id\').src=\'images/configb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_config_id\').src=\'images/config.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_config_id\' src=\'images/config.png\' title=\'Γενικές ρυθμίσεις και εργασίες για τη διαχείριση του συστήματος\'/>\n            <img style=\"position: absolute;top: 1px;left: 150px;display: none;\" width=20 height=20 id=\'info_id\' src=\'images/info-sign.png\' title=\'Νέα έκδοση διαθέσιμη\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Ρυθμίσεις & Εργασίες Διαχείρισης</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-10 14:38:50','globeadmin','2018-01-12 22:14:26','globeadmin','2022-11-30 11:53:03','globeadmin'),('5618fc70c8b1419','5618f5cc92f9c9e',NULL,NULL,'0',10,NULL,'school_homebtnimg',40,10,'Αρχικό Μενού',NULL,'html',50,380,220,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_school2_id\').src=\'images/school2b.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_school2_id\').src=\'images/school2.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_school2_id\' src=\'images/school2.png\' title=\'Μαθητές, Καθηγητές, Τμήματα κ.α που αφορούν το Σχολείο μου\'/> \n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Το Σχολείο μου</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-10 14:54:24','globeadmin','2017-10-28 20:26:58','globeadmin','2022-11-30 11:53:03','globeadmin'),('561923063155c9e','561922d0a8f28d2',NULL,NULL,'0',10,NULL,'search_absencebtn',10,20,'Απουσίες',NULL,'html',50,73,220,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_search_id\').src=\'images/searchb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_search_id\').src=\'images/search.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_search_id\' src=\'images/search.png\' title=\'Αναζήτηση Απουσιών\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Αναζήτηση Απουσιών</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-10 17:39:02','globeadmin','2017-10-28 20:39:03','globeadmin','2018-08-13 10:29:13','globeadmin'),('5619231ab529279','561922d0a8f28d2',NULL,NULL,'0',10,NULL,'search_justification_requestbtn',20,20,'Απουσίες',NULL,'html',192,73,220,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_rsearch_id\').src=\'images/rsearchb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_rsearch_id\').src=\'images/rsearch.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_rsearch_id\' src=\'images/rsearch.png\' title=\'Αναζήτηση αιτημάτων διαγραφής απουσιών\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Αιτήματα Διαγραφής Απουσιών</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-10 17:39:22','globeadmin','2018-08-04 11:38:57','globeadmin','2018-08-13 10:29:13','globeadmin'),('56192332781e971','561922d0a8f28d2',NULL,NULL,'0',10,NULL,'search_cardsbtn',30,20,'Απουσίες',NULL,'html',334,73,220,100,'l','0','0','','0',NULL,NULL,'0','5525421c67a48bc',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_notreg_id\').src=\'images/notregb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_notreg_id\').src=\'images/notreg.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_notreg_id\' src=\'images/notreg.png\' title=\'Διδασκαλίες για τις οποίες δεν έχουν καταχωρηθεί απουσίες\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Μη καταχωρισμένες Διδασκαλίες</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-10 17:39:46','globeadmin','2017-10-28 20:39:03','globeadmin','2021-02-25 21:07:31','globeadmin'),('5619234633c438a','561922d0a8f28d2',NULL,NULL,'0',10,NULL,'add_absence_class_day',40,20,'Απουσίες',NULL,'html',50,380,220,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_dabsen_id\').src=\'images/dabsenb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_dabsen_id\').src=\'images/dabsen.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_dabsen_id\' src=\'images/dabsen.png\' title=\'Καταχώριση Απουσιών Ημέρας\'/>\n            <img /> \n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Καταχώριση Απουσιών Ημέρας</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-10 17:40:06','globeadmin','2017-10-28 20:39:03','globeadmin','2018-08-13 10:29:13','globeadmin'),('5619235b8ba83bd','561922d0a8f28d2',NULL,NULL,'0',10,'select \'0\'','add_student_absencebtn',50,20,'Απουσίες',NULL,'html',192,380,220,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_sabsen_id\').src=\'images/sabsenb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_sabsen_id\').src=\'images/sabsen.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_sabsen_id\' src=\'images/sabsen.png\' title=\'Καταχώριση απουσίας για έναν συγκεκριμένο μαθητή\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Καταχώριση Απουσίας Μαθητή</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-10 17:40:27','globeadmin','2018-07-13 22:58:11','globeadmin','2018-08-13 10:29:14','globeadmin'),('5619236db2b8200','561922d0a8f28d2',NULL,NULL,'0',10,NULL,'absence_export_excelbtn',60,20,'Απουσίες',NULL,'html',334,380,220,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_excel_id\').src=\'images/excelb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_excel_id\').src=\'images/excel.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_excel_id\' src=\'images/excel.png\' title=\'Εξαγωγή Απουσιών στο Excel\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Εξαγωγή Απουσιών στο Excel</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-10 17:40:45','globeadmin','2017-10-28 20:39:03','globeadmin','2018-08-13 10:29:14','globeadmin'),('56192386b2b8360','561922d0a8f28d2',NULL,NULL,'0',10,NULL,'absence_noteslbtn',80,20,'Απουσίες',NULL,'html',192,687,220,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_pmsg_id\').src=\'images/pmsgb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_pmsg_id\').src=\'images/pmsg.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_pmsg_id\' src=\'images/pmsg.png\' title=\'Επικοινωνία Σχολείου - Γονέων\'/>\n\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Επικοινωνία Σχολείου - Γονέων</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-10 17:41:10','globeadmin','2017-10-28 20:39:03','globeadmin','2018-08-13 10:29:14','globeadmin'),('561923a2e38c1e9','561922d0a8f28d2',NULL,NULL,'0',10,NULL,'attendance_booksbtn',90,20,'Απουσίες',NULL,'html',334,687,220,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_sbook_id\').src=\'images/sbookb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_sbook_id\').src=\'images/sbook.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_sbook_id\' src=\'images/sbook.png\' title=\'Βιβλία φοίτησης μαθητών\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Βιβλία Φοίτησης Μαθητών</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-10 17:41:39','globeadmin','2017-10-28 20:39:03','globeadmin','2018-08-13 10:29:14','globeadmin'),('561925172a005a6','561922d0a8f28d2',NULL,NULL,'0',10,NULL,'print_absence_class_day',70,20,'Απουσίες',NULL,'html',50,687,220,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_abprint_id\').src=\'images/abprintb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_abprint_id\').src=\'images/abprint.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_abprint_id\' src=\'images/abprint.png\' title=\'Εκτύπωση Απουσιολογίων\'/>\n            <img /> \n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Εκτύπωση Απουσιολογίων</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-10 17:47:51','globeadmin','2017-10-28 20:39:03','globeadmin','2018-08-13 10:29:14','globeadmin'),('5619277b86c62a6','5618f5cc92f9c9e',NULL,NULL,'1',10,NULL,'sisyphos_info_img1',10,500,'Πληροφορίες',NULL,'html',91,102,334,66,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<img id=\'img_sisyphos_id\' src=\'images/sisyphos.png\'/> ','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-10 17:58:03','globeadmin','2015-12-26 20:38:54','globeadmin','2022-11-30 11:53:03','globeadmin'),('56192799add6c8f','5618f5cc92f9c9e',NULL,NULL,'1',10,NULL,'sisyphos_info_label1',20,500,'Πληροφορίες','Πληροφοριακό Σύστημα «Σίσυφος»','words',90,463,450,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-10 17:58:33','globeadmin','2015-10-10 22:38:04','globeadmin','2022-11-30 11:53:03','globeadmin'),('561927b77d02283','5618f5cc92f9c9e',NULL,NULL,'1',10,NULL,'sisyphos_info_label2',30,500,'Πληροφορίες','Έκδοση','display',112,469,150,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select version from school where id=1',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-10 17:59:03','globeadmin','2017-03-30 19:33:12','globeadmin','2022-11-30 11:53:03','globeadmin'),('561927d605616e3','5618f5cc92f9c9e',NULL,NULL,'1',10,NULL,'sisyphos_info_label5',50,500,'Πληροφορίες',NULL,'html',145,658,260,50,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 width=100% height=100%>\n<tr>\n<td valign=middle align=left>\n<a href=\"http://sisyphos.gr/index.php?page=creator.html\" target=\"_blank\">Παπαδακάκης Νεκτάριος</a>\n</td>\n</tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-10 17:59:34','globeadmin','2017-03-30 20:28:40','globeadmin','2022-11-30 11:53:03','globeadmin'),('561927f48ba8458','5618f5cc92f9c9e',NULL,NULL,'1',10,NULL,'sisyphos_info_label3',60,500,'Πληροφορίες','Περισσότερες πληροφορίες στην ιστοσελίδα  ','html',222,200,400,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 width=100% height=100%>\n<tr>\n<td valign=middle align=left>\n<a href=\"http://www.sisyphos.gr\" target=\"_blank\">www.sisyphos.gr</a>\n</td>\n</tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-10 18:00:04','globeadmin','2016-12-25 11:47:04','globeadmin','2022-11-30 11:53:03','globeadmin'),('5619280da41256d','5618f5cc92f9c9e',NULL,NULL,'1',10,NULL,'sisyphos_info_label4',70,500,'Πληροφορίες','Επικοινωνία στο info.sisyphos@gmail.com  ή στη  ','html',263,175,400,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 width=100% height=100%>\n<tr>\n<td valign=middle align=left>\n<a href=\"http://sisyphos.gr/index.php?page=contact.html\" target=\"_blank\">Φόρμα Επικοινωνίας</a>\n</td>\n</tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-10 18:00:29','globeadmin','2016-12-25 11:46:42','globeadmin','2022-11-30 11:53:03','globeadmin'),('5619282edc392c6','5618f5cc92f9c9e',NULL,NULL,'1',10,NULL,'sisyphos_info_label6',80,500,'Πληροφορίες','Οδηγίες για τη χρήση του συστήματος στον  ','html',304,205,400,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 width=100% height=100%>\n<tr>\n<td valign=middle align=left>\n<a href=\"http://sisyphos.gr/index.php?page=userguide.html\" target=\"_blank\">Οδηγό Χρήσης</a>\n</td>\n</tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-10 18:01:02','globeadmin','2016-12-25 11:46:17','globeadmin','2022-11-30 11:53:03','globeadmin'),('561928463635366','5618f5cc92f9c9e',NULL,NULL,'1',10,NULL,'sisyphos_info_label7',90,500,'Πληροφορίες','Ερωτήσεις, σχόλια, παρατηρήσεις και γνώμες στο  ','html',345,169,400,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 width=100% height=100%>\n<tr>\n<td valign=middle align=left>\n<a href=\"http://www.sisyphos.gr/forum\" target=\"_blank\">Φόρουμ</a>\n</td>\n</tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-10 18:01:26','globeadmin','2016-12-25 11:45:48','globeadmin','2022-11-30 11:53:03','globeadmin'),('5688ee43d98c897','5688ee0218ad763',NULL,NULL,'1',10,NULL,'valid_from',10,10,'Εισαγωγή Νέας Διδασκαλίας','Έναρξη Ισχύος :','text',21,90,80,0,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',100,250,'2016-01-03 11:47:47','globeadmin','2016-01-03 11:47:47','globeadmin','2017-10-03 23:25:20','globeadmin'),('561943d7ba0b35c','56192a12e86c93e',NULL,NULL,'0',10,'select if(  \'#nu_user_group#\'=\'globeadmin\' or \n            \'#nu_user_group#\'=\'Administrators\' or \n            \'#nu_user_group#\'=\'Managers\' or \n            \'#nu_user_group#\'=\'AssistManagers\',\'1\',\'0\')','classroombtn',60,10,'Το Σχολείο μου',NULL,'html',334,380,220,100,'c','0','0','','0',NULL,NULL,NULL,'54705a95c4e91c2',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_croom_id\').src=\'images/croomb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_croom_id\').src=\'images/croom.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_croom_id\' src=\'images/croom.png\' title=\'Άιθουσες Διδασκαλίας και Εργαστήρια\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Άιθουσες</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-10 19:59:03','globeadmin','2017-10-28 22:04:49','globeadmin','2018-01-09 19:16:07','globeadmin'),('561943f27d028b8','56192be786c61d7',NULL,NULL,'0',10,NULL,'penaltybtn',80,10,'Αξιολόγηση Μαθητών και Ποινές',NULL,'html',334,50,220,100,'l','0','0','','0',NULL,NULL,NULL,'554517bdc18334d',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_cards_id\').src=\'images/cardsb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_cards_id\').src=\'images/cards.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_cards_id\' src=\'images/cards.png\' title=\'Ποινές που έχουν επιβληθεί σε μαθητές\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Ποινές Μαθητών</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-10 19:59:30','globeadmin','2021-10-24 21:32:37','globeadmin','2021-10-24 21:33:12','globeadmin'),('59d89915821ddb8','548338073921bfe',NULL,NULL,'0',10,NULL,'show_markbtn',20,10,'Προσωπικές Εργασίες',NULL,'html',192,380,220,100,'l','0','0','','0',NULL,NULL,'#RECORD_ID# ','5495dad1762dc2c',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_marks_id\').src=\'images/marksb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_marks_id\').src=\'images/marks.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_marks_id\' src=\'images/marks.png\' title=\'Εμφάνιση της Αξιολόγησης μου\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Εμφάνιση της Αξιολόγησης μου</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-07 12:06:29','globeadmin','2022-01-08 10:50:23','globeadmin','2022-01-08 10:51:55','globeadmin'),('5619440a697893b','56192a12e86c93e',NULL,NULL,'0',10,NULL,'studentbtn',10,10,'Το Σχολείο μου',NULL,'html',50,73,220,100,'l','0','0','','0',NULL,NULL,NULL,'5476201e5a3d38f',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_std_id\').src=\'images/stdb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_std_id\').src=\'images/std.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_std_id\' src=\'images/std.png\' title=\'Καρτέλες Μαθητών\'/>\n            <img /> \n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Μαθητές</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-10 19:59:54','globeadmin','2017-10-28 22:04:49','globeadmin','2018-07-23 13:55:37','globeadmin'),('56194423733ecd7','56192a12e86c93e',NULL,NULL,'0',10,'select if(  \'#nu_user_group#\'=\'globeadmin\' or \n            \'#nu_user_group#\'=\'Administrators\' or \n            \'#nu_user_group#\'=\'Managers\' or \n            \'#nu_user_group#\'=\'AssistManagers\',\'1\',\'0\')','classbtn',20,10,'Το Σχολείο μου',NULL,'html',192,73,220,100,'l','0','0','','0',NULL,NULL,NULL,'5470b6d7c79d3b9',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_class_id\').src=\'images/classb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_class_id\').src=\'images/class.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_class_id\' src=\'images/class.png\' title=\'Καρτέλες Τμημάτων\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Τμήματα</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-10 20:00:19','globeadmin','2017-10-28 22:04:49','globeadmin','2018-07-29 18:19:11','globeadmin'),('561944399f2e900','56192a12e86c93e',NULL,NULL,'0',10,'select if(  \'#nu_user_group#\'=\'globeadmin\' or \n            \'#nu_user_group#\'=\'Administrators\' or \n            \'#nu_user_group#\'=\'Managers\' or \n            \'#nu_user_group#\'=\'AssistManagers\',\'1\',\'0\')','teacherbtn',40,10,'Το Σχολείο μου',NULL,'html',334,73,220,100,'l','0','0','','0',NULL,NULL,NULL,'547372d029461f4',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_teach_id\').src=\'images/teachb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_teach_id\').src=\'images/teach.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_teach_id\' src=\'images/teach.png\' title=\'Καρτέλες Καθηγητών\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Καθηγητές</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-10 20:00:41','globeadmin','2017-10-28 22:04:49','globeadmin','2018-07-23 13:59:15','globeadmin'),('56194456908a2b2','56192a12e86c93e',NULL,NULL,'0',10,'select if(  \'#nu_user_group#\'=\'globeadmin\' or \n            \'#nu_user_group#\'=\'Administrators\' or \n            \'#nu_user_group#\'=\'Managers\',\'1\',\'0\')','schoolbtn',40,10,'Το Σχολείο μου',NULL,'html',50,380,220,100,'l','0','0','','0',NULL,NULL,'1','5470c07906bfd70',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_school_id\').src=\'images/schoolb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_school_id\').src=\'images/school.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_school_id\' src=\'images/school.png\' title=\'Στοιχεία Σχολείου και Επικοινωνίας\'/> \n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Στοιχεία Σχολείου και Επικοινωνίας</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-10 20:01:10','globeadmin','2018-01-09 21:09:30','globeadmin','2018-01-09 21:09:30','globeadmin'),('5619446e36351b5','56192a12e86c93e',NULL,NULL,'0',10,'select if(  \'#nu_user_group#\'=\'globeadmin\' or \n            \'#nu_user_group#\'=\'Administrators\' or \n            \'#nu_user_group#\'=\'Managers\',\'1\',\'0\')','school_yearbtn',70,10,'Το Σχολείο μου',NULL,'html',50,687,220,100,'l','0','0','','0',NULL,NULL,'1','547081ceb3d2146',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_syear_id\').src=\'images/syearb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_syear_id\').src=\'images/syear.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_syear_id\' src=\'images/syear.png\' title=\'Σχολικό Έτος\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Σχολικό Έτος</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-10 20:01:34','globeadmin','2018-01-09 21:08:10','globeadmin','2018-01-09 21:08:11','globeadmin'),('56194490d7559d1','56192a12e86c93e',NULL,NULL,'0',10,'select if(  \'#nu_user_group#\'=\'globeadmin\' or \n            \'#nu_user_group#\'=\'Administrators\' or \n            \'#nu_user_group#\'=\'Managers\',\'1\',\'0\')','periodbtn',70,10,'Το Σχολείο μου',NULL,'html',334,687,220,100,'l','0','0','','0',NULL,NULL,NULL,'54707442a2bcae4',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_clock_id\').src=\'images/clockb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_clock_id\').src=\'images/clock.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_clock_id\' src=\'images/clock.png\' title=\'Διδακτικές Ώρες - Κουδούνια\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Διδακτικές Ώρες - Κουδούνι</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-10 20:02:08','globeadmin','2018-01-09 21:07:00','globeadmin','2018-01-09 21:07:01','globeadmin'),('561945b1426ae33','56192c691b58858',NULL,NULL,'0',10,NULL,'subjectbtn',10,30,'Μαθήματα και Διδασκαλίες',NULL,'html',50,73,220,100,'l','0','0','','0',NULL,NULL,NULL,'547489b0d4efe7c',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_books_id\').src=\'images/booksb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_books_id\').src=\'images/books.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_books_id\' src=\'images/books.png\' title=\'Μαθήματα\'/>\n            <img /> \n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Μαθήματα</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-10 20:06:57','globeadmin','2017-10-28 22:09:21','globeadmin','2021-10-24 21:25:06','globeadmin'),('561945e63b179b0','56192c691b58858',NULL,NULL,'0',10,NULL,'sectionbtn',80,30,'Μαθήματα και Διδασκαλίες',NULL,'html',334,380,220,100,'l','0','0','','0',NULL,NULL,NULL,'5470b05b91e73a0',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_section_id\').src=\'images/sectionb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_section_id\').src=\'images/section.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_section_id\' src=\'images/section.png\' title=\'Τομείς Μαθημάτων\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Τομείς Μαθημάτων</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-10 20:07:50','globeadmin','2017-10-28 22:09:21','globeadmin','2021-10-24 21:25:06','globeadmin'),('56194607add6314','56192c691b58858',NULL,NULL,'0',10,NULL,'specialitybtn',90,30,'Μαθήματα και Διδασκαλίες',NULL,'html',334,687,220,100,'l','0','0','','0',NULL,NULL,NULL,'54ce7f0188a78ec',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_tree_id\').src=\'images/treeb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_tree_id\').src=\'images/tree.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_tree_id\' src=\'images/tree.png\' title=\'Ειδικότητες ή Κατευθύνσεις\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Ειδικότητες - Κατευθύνσεις</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-10 20:08:23','globeadmin','2017-10-28 22:09:21','globeadmin','2021-10-24 21:25:06','globeadmin'),('5619462238a49fe','56192c691b58858',NULL,NULL,'0',10,NULL,'timetablesbtn',20,30,'Μαθήματα και Διδασκαλίες',NULL,'html',50,380,220,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_timetable_id\').src=\'images/timetableb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_timetable_id\').src=\'images/timetable.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_timetable_id\' src=\'images/timetable.png\' title=\'Ωρολόγια Προγράμματα\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Ωρολόγια Προγράμματα</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-10 20:08:50','globeadmin','2017-10-28 22:09:21','globeadmin','2021-10-24 21:25:06','globeadmin'),('5619465b278f3fc','56192c691b58858',NULL,NULL,'0',10,NULL,'celebrationbtn',30,30,'Μαθήματα και Διδασκαλίες',NULL,'html',50,687,220,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_celebr_id\').src=\'images/celebrb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_celebr_id\').src=\'images/celebr.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_celebr_id\' src=\'images/celebr.png\' title=\'Δήλωση εκδρομής, εκδήλωσης ή αναπλήρωσης στο σημερινό ή αυριανό ωρολόγιο\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Μεταβολή Ωρολογίου Ημέρας</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-10 20:09:47','globeadmin','2017-10-28 22:09:21','globeadmin','2021-10-24 21:25:06','globeadmin'),('561946ea5fb68b5','56192be786c61d7',NULL,NULL,'0',10,NULL,'grading_periodbtn',10,10,'Αξιολόγηση Μαθητών και Ποινές',NULL,'html',50,73,220,100,'l','0','0','','0',NULL,NULL,NULL,'547070c91793d3b',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_mark_id\').src=\'images/markb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_mark_id\').src=\'images/mark.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_mark_id\' src=\'images/mark.png\' title=\'Περίοδοι Αξιολόγησης\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Περίοδοι Αξιολόγησης</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-10 20:12:10','globeadmin','2021-10-24 21:17:34','globeadmin','2021-10-24 21:33:11','globeadmin'),('561947116709285','56192be786c61d7',NULL,NULL,'0',10,NULL,'teacher_owe_marks_homebtn',20,10,'Αξιολόγηση Μαθητών και Ποινές',NULL,'html',50,380,220,100,'l','0','0','','0',NULL,NULL,'0','54a312a5698c8f9',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_gradenot_id\').src=\'images/gradenotb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_gradenot_id\').src=\'images/gradenot.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_gradenot_id\' src=\'images/gradenot.png\' title=\'Υπολειπόμενη αξιολόγηση τρέχουσας περιόδου\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Υπολειπόμενη Αξιολόγηση Περιόδου</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-10 20:12:49','globeadmin','2021-10-24 21:24:30','globeadmin','2021-10-24 21:33:11','globeadmin'),('5619472bb047874','56192be786c61d7',NULL,NULL,'0',10,NULL,'mark_excel_homebtn',50,10,'Αξιολόγηση Μαθητών και Ποινές',NULL,'html',192,687,220,100,'l','0','0','','0',NULL,NULL,'0','54a26a8d05fa91d',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_grexcel_id\').src=\'images/grexcelb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_grexcel_id\').src=\'images/grexcel.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_grexcel_id\' src=\'images/grexcel.png\' title=\'Εξαγωγή Βαθμολογίας στο Excel\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Εξαγωγή Βαθμολογίας στο Excel</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-10 20:13:15','globeadmin','2021-10-24 21:24:51','globeadmin','2021-10-24 21:33:12','globeadmin'),('5619474570cd719','56192be786c61d7',NULL,NULL,'0',10,NULL,'marks_print_all_homebtn',40,10,'Αξιολόγηση Μαθητών και Ποινές',NULL,'html',192,380,220,100,'l','0','0','','0',NULL,NULL,'\'#RECORD_ID#\'','565b05b5e424081',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_grprint_id\').src=\'images/grprintb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_grprint_id\').src=\'images/grprint.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_grprint_id\' src=\'images/grprint.png\' title=\'Εκτύπωση τρέχουσας βαθμολογίας\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Εκτύπωση Βαθμολογίας</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-10 20:13:41','globeadmin','2021-10-24 21:24:30','globeadmin','2021-10-24 21:33:11','globeadmin'),('5619494070cd322','56192b05ed5032f',NULL,NULL,'0',10,NULL,'upload_asc_myschoolbtn',40,10,'Σχολείο',NULL,'html',192,73,220,100,'l','0','0','','0',NULL,NULL,'0','54df20f94548357',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_uptimetbl_id\').src=\'images/uptimetblb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_uptimetbl_id\').src=\'images/uptimetbl.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=98 height=74 id=\'img_uptimetbl_id\' src=\'images/uptimetbl.png\' title=\'Εισαγωγή ωρολογίου προγράμματος από το ASC Timetables\'/>\n            \n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Εισαγωγή Ωρολογίου Προγράμματος</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-10 20:22:08','globeadmin','2017-10-28 22:12:05','globeadmin','2019-07-25 10:13:34','globeadmin'),('561949595381687','56192b05ed5032f',NULL,NULL,'0',10,NULL,'upload_students_myschoolbtn',10,10,'Σχολείο',NULL,'html',50,73,220,100,'l','0','0','','0',NULL,NULL,'0','54df1259eb4def9',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_upstd_id\').src=\'images/upstdb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_upstd_id\').src=\'images/upstd.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=98 height=74 id=\'img_upstd_id\' src=\'images/upstd.png\' title=\'Εισαγωγή μαθητών από το myschool\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Εισαγωγή Μαθητών</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-10 20:22:33','globeadmin','2017-10-28 22:12:05','globeadmin','2020-04-02 11:33:59','globeadmin'),('5619496fab65252','56192b05ed5032f',NULL,NULL,'0',10,NULL,'upload_student_class_myschoolbtn',20,10,'Σχολείο',NULL,'html',50,380,220,100,'l','0','0','','0',NULL,NULL,'0','54df1dbf0f931e5',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_upchart_id\').src=\'images/upchartb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_upchart_id\').src=\'images/upchart.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=98 height=74 id=\'img_upchart_id\' src=\'images/upchart.png\' title=\'Εισαγωγή κατανομής μαθητών από το myschool\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Εισαγωγή Κατανομής Μαθητών</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-10 20:22:55','globeadmin','2017-10-28 22:12:05','globeadmin','2019-11-06 14:12:49','globeadmin'),('561949874c2e2ad','56192b05ed5032f',NULL,NULL,'0',10,NULL,'upload_penalty_myschoolbtn',30,10,'Σχολείο',NULL,'html',50,687,220,100,'l','0','0','','0',NULL,NULL,'0','54d65f0144e61a3',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_upcards_id\').src=\'images/upcardsb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_upcards_id\').src=\'images/upcards.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=98 height=74 id=\'img_upcards_id\' src=\'images/upcards.png\' title=\'Εισαγωγή ποινών από το myschool\'/>\n            \n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Εισαγωγή Ποινών</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-10 20:23:19','globeadmin','2017-10-28 22:12:05','globeadmin','2019-07-25 10:13:34','globeadmin'),('561949f27d02548','56192b05ed5032f',NULL,NULL,'0',10,NULL,'set_class_responsible_homebtn',70,10,'Σχολείο',NULL,'html',330,73,220,100,'l','0','0','','0',NULL,NULL,'0','54b2d9dd8417a3d',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_tchclass_id\').src=\'images/tchclassb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_tchclass_id\').src=\'images/tchclass.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=98 height=74 id=\'img_tchclass_id\' src=\'images/tchclass.png\' title=\'Ορισμός υπευθύνου καθηγητή μαζικά για μαθητές\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Ορισμός Υπεύθυνου Καθηγητή</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-10 20:25:06','globeadmin','2017-10-28 22:12:05','globeadmin','2022-01-08 14:12:01','globeadmin'),('56194a1607d1b2c','56192b05ed5032f',NULL,NULL,'0',10,'select if(  \'#nu_user_group#\'=\'globeadmin\' or \n            \'#nu_user_group#\'=\'Administrators\' or \n            \'#nu_user_group#\'=\'Managers\',\'1\',\'0\')','create_student_accountbtn',90,10,'Σχολείο',NULL,'html',330,687,220,100,'l','0','0','','0',NULL,NULL,'0','54aa751b6567046',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_stdaccadd_id\').src=\'images/stdaccaddb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_stdaccadd_id\').src=\'images/stdaccadd.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=98 height=74 id=\'img_stdaccadd_id\' src=\'images/stdaccadd.png\' title=\'Αυτόματη δημιουργία λογαριασμού χρήστη για κάθε μαθητή\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Δημιουργία Λογαριασμών Μαθητών</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-10 20:25:42','globeadmin','2017-10-28 22:12:05','globeadmin','2020-09-24 22:15:46','globeadmin'),('56194a5470cba8e','56192b05ed5032f',NULL,NULL,'0',10,'select if(  \'#nu_user_group#\'=\'globeadmin\' or \n            \'#nu_user_group#\'=\'Administrators\' or \n            \'#nu_user_group#\'=\'Managers\',\'1\',\'0\')','admin_usersbtn',10,20,'Σύστημα',NULL,'html',50,73,220,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_useracc_id\').src=\'images/useraccb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_useracc_id\').src=\'images/useracc.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=98 height=74 id=\'img_useracc_id\' src=\'images/useracc.png\' title=\'Λογαριασμοί Χρηστών\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Λογαριασμοί Χρηστών</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-10 20:26:44','globeadmin','2018-01-09 18:08:17','globeadmin','2019-07-25 10:13:35','globeadmin'),('56194a995861983','56192b05ed5032f',NULL,NULL,'0',10,'select if(  \'#nu_user_group#\'=\'globeadmin\' or \n            \'#nu_user_group#\'=\'Administrators\' or \n            \'#nu_user_group#\'=\'Managers\',\'1\',\'0\')','admin_emailbtn',40,20,'Σύστημα',NULL,'html',192,73,220,100,'l','0','0','','0',NULL,NULL,'1','54a52c3dcf3610b',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_emailconf_id\').src=\'images/emailconfb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_emailconf_id\').src=\'images/emailconf.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=98 height=74 id=\'img_emailconf_id\' src=\'images/emailconf.png\' title=\'Ρυθμίσεις Αποστολής Email - SMS\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Ρυθμίσεις Αποστολής Email - SMS</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-10 20:27:53','globeadmin','2018-01-09 18:14:24','globeadmin','2019-07-25 10:13:35','globeadmin'),('56194ac586c48ed','56192b05ed5032f',NULL,NULL,'0',10,'select if(  \'#nu_user_group#\'=\'globeadmin\' or \n            \'#nu_user_group#\'=\'Administrators\' or \n            \'#nu_user_group#\'=\'Managers\',\'1\',\'0\')','delete_allbtn',90,20,'Σύστημα',NULL,'html',330,687,220,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_deleteall_id\').src=\'images/deleteallb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_deleteall_id\').src=\'images/deleteall.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=98 height=74 id=\'img_deleteall_id\' src=\'images/deleteall.png\' title=\'Διαγραφή όλων των στοιχείων για την έναρξη νέου Σχ. Έτους\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Διαγραφή Όλων</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-10 20:28:37','globeadmin','2018-02-04 20:28:58','globeadmin','2019-07-25 10:13:35','globeadmin'),('561950c4deaa4e3','56192c691b58858',NULL,NULL,'0',10,NULL,'gradebtn',70,30,'Μαθήματα και Διδασκαλίες',NULL,'html',334,73,220,100,'l','0','0','','0',NULL,NULL,NULL,'54706f6b39c1b38',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_letters_id\').src=\'images/lettersb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_letters_id\').src=\'images/letters.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_letters_id\' src=\'images/letters.png\' title=\'Τάξεις\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Τάξεις</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-10 20:54:12','globeadmin','2017-10-28 22:09:21','globeadmin','2021-10-24 21:25:06','globeadmin'),('561951f3007f32b','56192a12e86c93e',NULL,NULL,'0',10,'select if(  \'#nu_user_group#\'=\'globeadmin\' or \n            \'#nu_user_group#\'=\'Administrators\' or \n            \'#nu_user_group#\'=\'Managers\',\'1\',\'0\')','daybtn',20,10,'Το Σχολείο μου',NULL,'html',192,687,220,100,'l','0','0','','0',NULL,NULL,NULL,'54706cd4f34daae',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_week_id\').src=\'images/weekb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_week_id\').src=\'images/week.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_week_id\' src=\'images/week.png\' title=\'Οι ημέρες της εβδομάδας κατά τις οποίες γίνονται μαθήματα\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Ημέρες Διδασκαλίας</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-10 20:59:15','globeadmin','2018-01-09 21:07:38','globeadmin','2018-01-09 21:07:38','globeadmin'),('561952463d883e3','56192c691b58858',NULL,NULL,'0',10,'select if(  \'#nu_user_group#\'=\'globeadmin\' or \n            \'#nu_user_group#\'=\'Administrators\' or \n            \'#nu_user_group#\'=\'Managers\' or \n            \'#nu_user_group#\'=\'AssistManagers\',\'1\',\'0\')','subject_typebtn',60,30,'Μαθήματα και Διδασκαλίες',NULL,'html',192,687,220,100,'l','0','0','','0',NULL,NULL,NULL,'54736dab44212c7',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_subcat_id\').src=\'images/subcatb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_subcat_id\').src=\'images/subcat.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_subcat_id\' src=\'images/subcat.png\' title=\'Τύποι/Κατηγορίες Μαθημάτων (Θ/Ε)\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Τύποι Μαθημάτων</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-10 21:00:38','globeadmin','2017-10-28 22:09:21','globeadmin','2021-10-24 21:25:06','globeadmin'),('5619525e38a4a8f','56192b05ed5032f',NULL,NULL,'0',10,'select if(  \'#nu_user_group#\'=\'globeadmin\' or \n            \'#nu_user_group#\'=\'Administrators\' or \n            \'#nu_user_group#\'=\'Managers\',\'1\',\'0\')','school_typebtn',60,30,'Παράμετροι',NULL,'html',192,687,220,100,'l','0','0','','0',NULL,NULL,NULL,'5470802845f7427',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_schools_id\').src=\'images/schoolsb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_schools_id\').src=\'images/schools.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=100 height=74 id=\'img_schools_id\' src=\'images/schools.png\' title=\'Τύποι/Κατηγορίες Σχολείων στην Ελλάδα\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Τύποι Σχολείων στην Ελλάδα</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-10 21:01:02','globeadmin','2018-01-09 21:02:52','globeadmin','2020-03-31 21:39:41','globeadmin'),('5a551628ca9c56d','551a34a930825c0',NULL,NULL,'1',10,NULL,'justification_request_reason_id',90,10,'Αναζήτηση','Λόγος Αίτησης :','listbox',49,660,350,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','','select id,name \nfrom  justification_request_reason\norder by id',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2018-01-09 21:21:12','globeadmin','2018-01-09 21:27:25','globeadmin','2018-08-04 11:47:36','globeadmin'),('56195280007f47b','56192b05ed5032f',NULL,NULL,'0',10,'select if(  \'#nu_user_group#\'=\'globeadmin\' or \n            \'#nu_user_group#\'=\'Administrators\' or \n            \'#nu_user_group#\'=\'Managers\',\'1\',\'0\')','teaching_fieldbtn',30,30,'Παράμετροι',NULL,'html',50,687,220,100,'l','0','0','','0',NULL,NULL,NULL,'5470b3806384141',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_teachspec_id\').src=\'images/teachspecb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_teachspec_id\').src=\'images/teachspec.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_teachspec_id\' src=\'images/teachspec.png\' title=\'Ειδικότητες καθηγητών στη δευτεροβάθμια εκπαίδευση\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Ειδικότητες Καθηγητών</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-10 21:01:36','globeadmin','2018-01-09 21:04:12','globeadmin','2019-07-25 10:13:36','globeadmin'),('5619532d4c2e45d','56192b05ed5032f',NULL,NULL,'0',10,'select if(  \'#nu_user_group#\'=\'globeadmin\' or \n            \'#nu_user_group#\'=\'Administrators\' or \n            \'#nu_user_group#\'=\'Managers\',\'1\',\'0\')','absence_reasonbtn',70,30,'Παράμετροι',NULL,'html',330,73,220,100,'l','0','0','','0',NULL,NULL,NULL,'54730f661a9b822',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_abconf_id\').src=\'images/abconfb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_abconf_id\').src=\'images/abconf.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_abconf_id\' src=\'images/abconf.png\' title=\'Λόγοι για τους οποίους μπορεί να απουσιάζει ένας μαθητής\'/>\n        </td>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Λόγοι Απουσίας Μαθητή</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-10 21:04:29','globeadmin','2018-01-09 21:02:29','globeadmin','2019-07-25 10:13:36','globeadmin'),('5619536d81e43b6','56192b05ed5032f',NULL,NULL,'0',10,'select if(  \'#nu_user_group#\'=\'globeadmin\' or \n            \'#nu_user_group#\'=\'Administrators\' or \n            \'#nu_user_group#\'=\'Managers\',\'1\',\'0\')','justified_reasonbtn',80,30,'Παράμετροι',NULL,'html',330,380,220,100,'l','0','0','','0',NULL,NULL,NULL,'54707c8612b1b6b',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_justconf_id\').src=\'images/justconfb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_justconf_id\').src=\'images/justconf.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_justconf_id\' src=\'images/justconf.png\' title=\'Λόγοι για τους οποίους μπορεί να δικαιολογηθεί μια απουσία\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Λόγοι Δικαιολόγησης Απουσίας</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-10 21:05:33','globeadmin','2018-01-09 21:03:24','globeadmin','2019-07-25 10:13:36','globeadmin'),('561953a2deaa494','56192b05ed5032f',NULL,NULL,'0',10,'select if(  \'#nu_user_group#\'=\'globeadmin\' or \n            \'#nu_user_group#\'=\'Administrators\' or \n            \'#nu_user_group#\'=\'Managers\',\'1\',\'0\')','justification_request_reasonbtn',90,30,'Παράμετροι',NULL,'html',330,687,220,100,'l','0','0','','0',NULL,NULL,NULL,'5470788787e004a',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_reqconf_id\').src=\'images/reqconfb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_reqconf_id\').src=\'images/reqconf.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_reqconf_id\' src=\'images/reqconf.png\' title=\'Λόγοι για τους οποίους μπορεί να αιτηθεί ένας καθηγητής να διαγραφεί μια απουσία\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Λόγοι Αίτησης Διαγραφής Απουσίας</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-10 21:06:26','globeadmin','2018-08-05 12:37:41','globeadmin','2019-07-25 10:13:36','globeadmin'),('561a9185d901d18','561a90ab2457a16',NULL,NULL,'1',10,NULL,'timetable_date',10,10,'Αναζήτηση Διδασκαλιών','Έναρξη Ισχύος :','dropdown',45,20,100,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select distinct valid_from, DATE_FORMAT(valid_from,\'%d-%m-%Y\')\nfrom card \norder by valid_from desc',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-11 19:42:45','globeadmin','2015-10-14 00:06:10','globeadmin','2018-07-13 20:02:18','globeadmin'),('561a9a38b944c12','561a90ab2457a16',NULL,NULL,'1',10,NULL,'class_id',20,10,'Αναζήτηση Διδασκαλιών','Τμήμα','dropdown',45,261,100,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select distinct class.id,class.short_name \nfrom class\ninner join student_class on class.id=student_class.class_id\norder by class.short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-11 20:19:52','globeadmin','2015-10-11 20:37:22','globeadmin','2018-07-13 20:02:18','globeadmin'),('561a9a9ead0fd3c','561a90ab2457a16',NULL,NULL,'1',10,NULL,'teacher_id',30,10,'Αναζήτηση Διδασκαλιών','Καθηγητής :','dropdown',45,446,200,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from teacher order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-11 20:21:34','globeadmin','2015-10-11 20:37:22','globeadmin','2018-07-13 20:02:18','globeadmin'),('561a9b5beefabb1','561a90ab2457a16',NULL,NULL,'1',10,NULL,'day_id',40,10,'Αναζήτηση Διδασκαλιών','Ημέρα :','dropdown',45,767,100,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,name from day order by id',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-11 20:24:44','globeadmin','2015-10-11 20:37:22','globeadmin','2018-07-13 20:02:18','globeadmin'),('561a9c90d8fffad','561a90ab2457a16',NULL,NULL,'1',10,NULL,'showbtn',50,10,'Αναζήτηση Διδασκαλιών','Εμφάνιση','button',81,33,150,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-11 20:29:53','globeadmin','2015-10-11 20:37:22','globeadmin','2018-07-13 20:02:18','globeadmin'),('561a9d90ad0e04b','561a90ab2457a16',NULL,NULL,'1',10,NULL,'showiframe',60,10,'Αναζήτηση Διδασκαλιών',NULL,'iframe',128,10,930,330,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-11 20:34:08','globeadmin','2015-10-11 21:02:07','globeadmin','2018-07-13 20:02:18','globeadmin'),('561aa02c245614e','561a90ab2457a16',NULL,NULL,'1',10,NULL,'datedisp',70,10,'Αναζήτηση Διδασκαλιών','Ενεργό Ωρολόγιο από τις :','display',14,20,80,30,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select DATE_FORMAT(ifNULL(max(valid_from),\'2000-01-01\'),\'%d-%m-%Y\') from card where valid_from<=curdate()',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-11 20:45:16','globeadmin','2015-10-11 20:47:27','globeadmin','2018-07-13 20:02:18','globeadmin'),('561aa7658fc22ed','561a90ab2457a16',NULL,NULL,'1',10,NULL,'label1',80,10,'Αναζήτηση Διδασκαλιών','Επιλέξτε από τα παραπάνω κριτήρια αναζήτησης. Αφήνοντας κενό, το τμήμα τον καθηγητή ή την ημέρα, εμφανίζονται όλες οι αντίστοιχες διδασκαλίες.','words',78,236,700,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from class order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-11 21:16:05','globeadmin','2015-10-14 00:12:14','globeadmin','2018-07-13 20:02:18','globeadmin'),('561eb40ac097bd6','561a90ab2457a16',NULL,NULL,'0',10,NULL,'celebrationbtn',50,20,'Εργαλεία',NULL,'html',270,338,220,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_celebr_id\').src=\'images/celebrb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_celebr_id\').src=\'images/celebr.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_celebr_id\' src=\'images/celebr.png\' title=\'Δήλωση εκδρομής, εκδήλωσης ή αναπλήρωσης στο σημερινό ή αυριανό ωρολόγιο\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Μεταβολή Ωρολογίου Ημέρας</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-14 22:59:06','globeadmin','2015-12-26 22:54:37','globeadmin','2018-07-13 20:02:19','globeadmin'),('561eb456a0dabf9','561a90ab2457a16',NULL,NULL,'0',10,NULL,'upload_asc_myschoolbtn',40,20,'Εργαλεία',NULL,'html',270,60,220,100,'l','0','0','','0',NULL,NULL,'0','54df20f94548357',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_timeup_id\').src=\'images/timeupb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_timeup_id\').src=\'images/timeup.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_timeup_id\' src=\'images/timeup.png\' title=\'Εισαγωγή ωρολογίου προγράμματος από το ASC Timetables\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Εισαγωγή από το ASC Timetables</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-14 23:00:22','globeadmin','2015-12-26 22:39:51','globeadmin','2018-07-13 20:02:18','globeadmin'),('561eb59848f6c5f','561a90ab2457a16',NULL,NULL,'0',10,NULL,'add_timetable',10,20,'Εργαλεία',NULL,'html',80,60,220,100,'l','0','0','','0',NULL,NULL,'0','54df20f94548357',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_timeadd_id\').src=\'images/timeaddb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_timeadd_id\').src=\'images/timeadd.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_timeadd_id\' src=\'images/timeadd.png\' title=\'Προσθήκη νέου ωρολογίου προγράμματος ή νέας διδασκαλίας\'/>\n             \n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Προσθήκη Διδασκαλίας-Ωρολογίου</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-14 23:05:44','globeadmin','2015-12-26 22:58:59','globeadmin','2018-07-13 20:02:18','globeadmin'),('561eb6aa6b2502e','561a90ab2457a16',NULL,NULL,'0',10,NULL,'copy_timetable',20,20,'Εργαλεία',NULL,'html',80,338,220,100,'l','0','0','','0',NULL,NULL,'0','54df20f94548357',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_timecp_id\').src=\'images/timecpb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_timecp_id\').src=\'images/timecp.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_timecp_id\' src=\'images/timecp.png\' title=\'Αντιγραφή ωρολογίου προγράμματος\'/>\n              \n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Αντιγραφή Ωρολογίου</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-14 23:10:18','globeadmin','2015-12-26 23:00:36','globeadmin','2018-07-13 20:02:18','globeadmin'),('561eb7776b24b6f','561a90ab2457a16',NULL,NULL,'0',10,NULL,'remove_timetable',30,20,'Εργαλεία',NULL,'html',80,615,220,100,'l','0','0','','0',NULL,NULL,'0','54df20f94548357',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_timerem_id\').src=\'images/timeremb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_timerem_id\').src=\'images/timerem.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_timerem_id\' src=\'images/timerem.png\' title=\'Διαγραφή ωρολογίου προγράμματος\'/>\n               \n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Διαγραφή Ωρολογίου</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-14 23:13:43','globeadmin','2015-12-26 23:01:34','globeadmin','2018-07-13 20:02:18','globeadmin'),('561fe46422c5de5','561fe384a42ad55',NULL,NULL,'1',10,NULL,'timetable_date',10,10,'Διαγραφή Ωρολογίου Προγράμματος','Ωρολόγιο με Έναρξη Ισχύος :','dropdown',105,65,100,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select distinct valid_from, DATE_FORMAT(valid_from,\'%d-%m-%Y\')\nfrom card\nwhere valid_from>curdate()\norder by valid_from desc',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-15 20:37:40','globeadmin','2015-10-15 23:11:06','globeadmin','2016-01-02 22:31:38','globeadmin'),('561fe4b6a69bd8b','561fe384a42ad55',NULL,NULL,'1',10,NULL,'label1',20,10,'Διαγραφή Ωρολογίου Προγράμματος','Προσοχή : Μπορείτε να διαγράψετε μόνο ωρολόγια με μελλοντική ημερομηνία έναρξης, που δεν έχουν τεθεί ακόμη σε ισχύ!','words',34,15,650,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from class order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-15 20:39:02','globeadmin','2015-10-15 23:11:06','globeadmin','2016-01-02 22:31:38','globeadmin'),('561fe6bab7b4792','561fe384a42ad55',NULL,NULL,'1',10,NULL,'deletebtn',30,10,'Διαγραφή Ωρολογίου Προγράμματος','Διαγραφή','button',95,412,150,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-15 20:47:38','globeadmin','2015-10-15 23:11:06','globeadmin','2016-01-02 22:31:45','globeadmin'),('562003e6ba23e31','562003aa49d836a',NULL,NULL,'1',10,NULL,'timetable_date',20,10,'Αντιγραφή Ωρολογίου Προγράμματος','Ωρολόγιο προς Αντιγραφή με Έναρξη Ισχύος :','dropdown',33,34,100,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select distinct valid_from, DATE_FORMAT(valid_from,\'%d-%m-%Y\')\nfrom card\norder by valid_from desc',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-15 22:52:06','globeadmin','2015-10-15 23:11:55','globeadmin','2016-01-02 22:34:11','globeadmin'),('562004d32056818','562003aa49d836a',NULL,NULL,'1',10,NULL,'copybtn',40,10,'Αντιγραφή Ωρολογίου Προγράμματος','Αντιγραφή','button',63,453,150,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-15 22:56:03','globeadmin','2015-10-15 23:12:49','globeadmin','2016-01-02 22:38:40','globeadmin'),('562005fd8bc27d0','562003aa49d836a',NULL,NULL,'1',10,NULL,'label1',10,10,'Αντιγραφή Ωρολογίου Προγράμματος','Προσοχή : Η ημερομηνία έναρξής του νέου ωρολογίου πρέπει να είναι μεγαλύτερη από τη σημερινή!','words',120,23,650,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-15 23:01:01','globeadmin','2015-10-15 23:11:55','globeadmin','2016-01-02 22:37:33','globeadmin'),('562006f39315883','562003aa49d836a',NULL,NULL,'1',10,NULL,'new_timetable_date',30,10,'Αντιγραφή Ωρολογίου Προγράμματος','Νέο Ωρολογίο με Ημερομηνία Έναρξης Ισχύος :','text',80,26,100,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2015-10-15 23:05:07','globeadmin','2015-10-15 23:11:55','globeadmin','2016-01-02 22:38:02','globeadmin'),('562140512b4c34f','5621401c573dfb8',NULL,NULL,'1',10,NULL,'label1',90,10,'Εισαγωγή Νέας Διδασκαλίας','Προσοχή :','words',8,23,750,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2015-10-16 21:22:09','globeadmin','2015-10-16 21:52:47','globeadmin','2016-01-03 11:44:41','globeadmin'),('5621406f7e4df30','5621401c573dfb8',NULL,NULL,'1',10,NULL,'class_id',30,10,'Εισαγωγή Νέας Διδασκαλίας','Τμήμα :','dropdown',263,144,100,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from class',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2015-10-16 21:22:39','globeadmin','2015-10-16 21:52:47','globeadmin','2016-01-03 11:47:59','globeadmin'),('56214084525c01d','5621401c573dfb8',NULL,NULL,'1',10,NULL,'day_id',40,10,'Εισαγωγή Νέας Διδασκαλίας','Ημέρα :','dropdown',306,144,100,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,name from day',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2015-10-16 21:23:00','globeadmin','2015-10-16 21:52:47','globeadmin','2016-01-03 11:48:19','globeadmin'),('56214099a2ed132','5621401c573dfb8',NULL,NULL,'1',10,NULL,'period_id',50,10,'Εισαγωγή Νέας Διδασκαλίας','Ώρα :','dropdown',349,156,100,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from period',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2015-10-16 21:23:21','globeadmin','2015-10-16 21:52:47','globeadmin','2016-01-03 11:48:36','globeadmin'),('562140a83ed4066','5621401c573dfb8',NULL,NULL,'1',10,NULL,'subject_id',60,10,'Εισαγωγή Νέας Διδασκαλίας','Μάθημα : ','dropdown',263,382,250,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from subject order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2015-10-16 21:23:36','globeadmin','2015-10-16 21:52:47','globeadmin','2016-01-04 11:21:14','globeadmin'),('562140b791d6189','5621401c573dfb8',NULL,NULL,'1',10,NULL,'teacher_id',70,10,'Εισαγωγή Νέας Διδασκαλίας','Καθηγητής :','dropdown',306,371,250,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from teacher order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2015-10-16 21:23:51','globeadmin','2015-10-16 23:15:50','globeadmin','2016-01-03 11:49:22','globeadmin'),('562140c4e4d8236','5621401c573dfb8',NULL,NULL,'1',10,NULL,'classroom_id',80,10,'Εισαγωγή Νέας Διδασκαλίας','Αίθουσα :','dropdown',349,385,100,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from classroom',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2015-10-16 21:24:04','globeadmin','2015-10-16 21:52:47','globeadmin','2016-01-03 11:49:39','globeadmin'),('562140eea2f0ef8','5621401c573dfb8',NULL,NULL,'1',10,NULL,'valid_from',20,10,'Εισαγωγή Νέας Διδασκαλίας','Έναρξη Ισχύος :','text',224,96,80,0,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',100,250,'2015-10-16 21:24:46','globeadmin','2015-10-16 21:52:47','globeadmin','2016-01-03 11:47:30','globeadmin'),('562143920b8f27f','5621401c573dfb8',NULL,NULL,'1',10,NULL,'label2',100,10,'Εισαγωγή Νέας Διδασκαλίας','- Μπορείτε να εισάγετε διδασκαλίες μόνο σε μελλοντικές ημερομηνίες.','words',30,48,750,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2015-10-16 21:36:02','globeadmin','2015-10-16 21:52:47','globeadmin','2016-01-03 11:44:41','globeadmin'),('562145ec76fb1a8','5621401c573dfb8',NULL,NULL,'1',10,NULL,'label4',120,10,'Εισαγωγή Νέας Διδασκαλίας','- Εισάγοντας μια διδασκαλία σε ημερομηνία που υπάρχει ήδη καταχωρημένο ωρολόγιο πρόγραμμα, η διδασκαλία προστίθεται στο ωρολόγιο αυτό.','words',92,48,750,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2015-10-16 21:46:04','globeadmin','2015-10-16 21:52:47','globeadmin','2016-01-03 11:44:41','globeadmin'),('5621439aa07c1c5','5621401c573dfb8',NULL,NULL,'1',10,NULL,'label3',110,10,'Εισαγωγή Νέας Διδασκαλίας','- Εισάγοντας μια διδασκαλία σε ημερομηνία που δεν υπάρχει ήδη καταχωρημένο ωρολόγιο πρόγραμμα, δημιουργείται ένα νέο ωρολόγιο πρόγραμμα στην ημερομηνία αυτή!','words',52,48,750,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2015-10-16 21:36:10','globeadmin','2015-10-16 21:48:43','globeadmin','2016-01-03 11:44:41','globeadmin'),('562146b92b4d94a','5621401c573dfb8',NULL,NULL,'1',10,NULL,'framehtml',10,10,'Εισαγωγή Νέας Διδασκαλίας',NULL,'html',195,60,700,200,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<html>\n<body>\n<table width=100% height=100% border=1  cellspacing=0 bordercolor=red><tr><td></td></tr><table>\n</body>\n</html>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-16 21:49:29','globeadmin','2015-10-16 21:54:09','globeadmin','2016-01-03 11:44:40','globeadmin'),('562148a7f10d162','5621401c573dfb8',NULL,NULL,'1',10,NULL,'valid_card_dates',130,10,'Εισαγωγή Νέας Διδασκαλίας',NULL,'iframe',140,60,700,45,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'54e61e02a705c6d','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-16 21:57:44','globeadmin','2015-10-16 22:04:45','globeadmin','2016-01-03 11:44:41','globeadmin'),('56214ac01ca7a0e','5621401c573dfb8',NULL,NULL,'1',10,NULL,'label5',140,10,'Εισαγωγή Νέας Διδασκαλίας','Ενεργά Ωρολόγια Προγράμματα :','words',118,510,250,0,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2015-10-16 22:06:40','globeadmin','2015-10-16 22:08:03','globeadmin','2016-01-03 11:44:41','globeadmin'),('562229da7366235','562229979f567be',NULL,NULL,'1',10,NULL,'label1',10,10,'Διαγραφή Όλων','Προσοχή : Επιλέγοντας «Διαγραφή» θα διαγράψετε όλα τα στοιχεία της βάσης δεδομένων για να εκκινήσετε μια καινούργια σχολική χρονιά!','words',20,9,900,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-17 13:58:34','globeadmin','2015-10-17 14:18:18','globeadmin','2016-07-12 00:44:29','globeadmin'),('56222e054c56453','562229979f567be',NULL,NULL,'1',10,NULL,'label2',20,10,'Διαγραφή Όλων','Θα διαγραφούν : Όλες οι απουσίες και όλα τα αιτήματα δικαιολόγησης απουσιών, όλοι οι βαθμοί, όλα τα ωρολόγια προγράμματα, όλα τα Email-SMS','words',44,9,900,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-17 14:16:21','globeadmin','2016-07-12 00:39:58','globeadmin','2016-07-12 00:44:29','globeadmin'),('5622303e820a999','562229979f567be',NULL,NULL,'1',10,NULL,'delete_student',100,10,'Διαγραφή Όλων','Διαγραφή Μαθητών :','dropdown',172,18,700,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'0|Να ΜΗ διαγραφούν οι μαθητές|\n1|Να διαγραφούν ΟΛΟΙ οι μαθητές|\n2|Διαγραφή των μαθητών της τελευταίας τάξης και προαγωγή των υπολοίπων – εξαίρεση όσων έχουν εγκαταλείψει|\n3|Διαγραφή των μαθητών της τελευταίας τάξης ΚΑΙ όσων έχουν εγκαταλείψει και προαγωγή των υπολοίπων\n',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-17 14:25:50','globeadmin','2016-07-12 19:36:08','globeadmin','2016-07-12 19:36:08','globeadmin'),('5622308933ec438','562229979f567be',NULL,NULL,'1',10,NULL,'delete_class',40,10,'Διαγραφή Όλων','Διαγραφή Τμημάτων :','checkbox',104,17,30,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-17 14:27:05','globeadmin','2016-07-12 00:44:29','globeadmin','2016-07-12 00:44:29','globeadmin'),('5622310e16a02cf','562229979f567be',NULL,NULL,'1',10,NULL,'delete_classroom',50,10,'Διαγραφή Όλων','Διαγραφή Αιθουσών :','checkbox',104,182,30,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-17 14:29:18','globeadmin','2016-07-12 00:44:29','globeadmin','2016-07-12 00:44:29','globeadmin'),('5622316a3b3dc72','562229979f567be',NULL,NULL,'1',10,NULL,'delete_teacher',60,10,'Διαγραφή Όλων','Διαγραφή Καθηγητών :','checkbox',104,350,30,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-17 14:30:50','globeadmin','2016-07-12 00:44:29','globeadmin','2016-07-12 00:44:30','globeadmin'),('5622319b22d5277','562229979f567be',NULL,NULL,'1',10,NULL,'delete_subject',70,10,'Διαγραφή Όλων','Διαγραφή Μαθημάτων :','checkbox',104,521,30,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-17 14:31:39','globeadmin','2016-07-12 00:44:29','globeadmin','2016-07-12 00:44:30','globeadmin'),('56223871ba31840','562229979f567be',NULL,NULL,'1',10,NULL,'mypass',120,10,'Διαγραφή Όλων','Κωδικός Πρόσβασης :','text',231,67,150,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'password',NULL,'',0,0,'2015-10-17 15:00:49','globeadmin','2016-07-12 00:44:29','globeadmin','2016-07-12 00:44:30','globeadmin'),('562238f6adfe192','562229979f567be',NULL,NULL,'1',10,NULL,'deletebtn',130,10,'Διαγραφή Όλων','Διαγραφή','button',224,405,150,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'password',NULL,'',0,0,'2015-10-17 15:03:02','globeadmin','2016-07-12 00:44:29','globeadmin','2016-07-12 00:44:30','globeadmin'),('562239754ec7106','562229979f567be',NULL,NULL,'1',10,NULL,'deleteifame',140,10,'Διαγραφή Όλων',NULL,'iframe',279,18,900,250,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'password',NULL,'',0,0,'2015-10-17 15:05:09','globeadmin','2016-07-12 00:34:34','globeadmin','2016-07-12 00:44:30','globeadmin'),('56223caebca4141','562229979f567be',NULL,NULL,'1',10,NULL,'mypass_hide',110,10,'Διαγραφή Όλων',NULL,'text',133,356,150,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'password',NULL,'',0,0,'2015-10-17 15:18:54','globeadmin','2016-07-12 00:44:29','globeadmin','2016-07-12 00:44:30','globeadmin'),('56228eda16a02fc','54a65ecc3f14737',NULL,NULL,'1',10,'select if(\'#login_with_email_account#\'=\'0\' or \'#nu_user_group#\'=\'globeadmin\',\'1\',\'0\')\n','oldpass',30,10,'Στοιχεία Λογαριασμού','Κωδικός Πρόσβασης :','text',125,187,150,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'password',NULL,'',100,250,'2015-10-17 21:09:30','globeadmin','2017-04-03 08:15:42','globeadmin','2018-07-28 00:36:32','globeadmin'),('56228eebcdb96b9','54a65ecc3f14737',NULL,NULL,'1',10,NULL,'oldpass_hide',20,10,'Στοιχεία Λογαριασμού',NULL,'text',412,98,150,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'password',NULL,'',100,250,'2015-10-17 21:09:47','globeadmin','2015-10-17 21:09:47','globeadmin','2018-07-28 00:36:32','globeadmin'),('5623630d09d2eb4','562362d2ef4f556',NULL,NULL,'1',10,NULL,'granding_period',10,10,'Καταχώριση Αξιολόγησης','Περίοδος Αξιολόγησης : ','display',21,16,200,80,'c','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','SELECT grading_period.name\nFROM school,grading_period \nWHERE \n    school.grading_period_id=grading_period.id AND \n    CURDATE() between grading_period.start_date AND grading_period.end_date \nlimit 1',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-10-18 12:14:53','globeadmin','2018-06-28 12:11:50','globeadmin','2022-02-08 23:51:03','globeadmin'),('5623640030e1450','562362d2ef4f556',NULL,NULL,'1',10,NULL,'class_subject_selection',50,10,'Καταχώριση Αξιολόγησης','Τμήμα - Μάθημα : ','dropdown',68,50,530,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'SELECT distinct CONCAT(class_id,\',\',subject_id), CONCAT(class_short,\' - \',subject_name,if (subject_type_name is NULL,\'\',concat(\' (\',subject_type_name,\')\')))\nFROM \n(\nSELECT \n	active_card.id 				AS id,\n	active_card.valid_from 		AS valid_from,\n	active_card.subject_id 		AS subject_id,\n	active_card.teacher_id 		AS teacher_id,\n	active_card.class_id 		AS class_id,\n	active_card.classroom_id 	AS classroom_id,\n	active_card.day_id 			AS day_id,\n	active_card.period_id 		AS period_id,\n	teacher.short_name 			AS teacher_short,\n	teacher.surname 			AS teacher_surname,\n	teacher.name 				AS teacher_name,\n	day.name 					AS day_name,\n	day.short_name 				AS day_short,\n	period.short_name 			AS period_short,\n	period.name 				AS period_name,\n	class.short_name 			AS class_short,\n	class.name 					AS class_name,\n	subject.short_name 			AS subject_short,\n	subject.name 				AS subject_name,\n	subject.is_marked 			AS subject_is_marked,\n	subject_type.short_name 	AS subject_type_short,\n	subject_type.name 			AS subject_type_name,\n	classroom.short_name 		AS classroom_short,\n	classroom.name 				AS classroom_name,\n	teacher.email 				AS teacher_email,\n	teacher.user_id 			AS teacher_user_id \nFROM \n	(SELECT \n		card.id 			AS id,\n		card.valid_from 	AS valid_from,\n		card.subject_id 	AS subject_id,\n		card.teacher_id 	AS teacher_id,\n		card.class_id 		AS class_id,\n		card.classroom_id 	AS classroom_id,\n		card.day_id 		AS day_id,\n		card.period_id 		AS period_id \n	FROM card \n	WHERE card.valid_from =\n		(	SELECT max(timetable.start_date) \n			FROM timetable)) as active_card \n	inner join subject 			on active_card.subject_id = subject.id \n	inner join teacher 			on active_card.teacher_id = teacher.id  \n	inner join day 				on active_card.day_id = day.id  \n	inner join period 			on active_card.period_id = period.id\n	inner join class 			on active_card.class_id = class.id	\n	left  join subject_type 	on subject.subject_type_id = subject_type.id  \n	left  join classroom 		on active_card.classroom_id = classroom.id  \nORDER BY \n	active_card.teacher_id,\n	active_card.day_id,\n	active_card.period_id\n)\nas active_card_full\nWHERE teacher_id=\'#RECORD_ID#\' and subject_is_marked\nORDER BY class_short,subject_name,subject_type_name DESC\n',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-10-18 12:18:56','globeadmin','2018-06-28 12:11:07','globeadmin','2022-02-08 23:51:59','globeadmin'),('5623643d02802ea','562362d2ef4f556',NULL,NULL,'1',10,NULL,'granding_period_end_date',20,10,'Καταχώριση Αξιολόγησης','Καταχώριση Αξιολόγησης Μέχρι τις :','display',21,395,80,80,'c','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','SELECT DATE_FORMAT(grading_period.end_date,\'%d-%m-%Y\')\nFROM school,grading_period \nWHERE \n    school.grading_period_id=grading_period.id AND \n    CURDATE() between grading_period.start_date AND grading_period.end_date \nlimit 1',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',100,250,'2015-10-18 12:19:57','globeadmin','2016-07-24 23:30:41','globeadmin','2022-02-08 23:51:03','globeadmin'),('56236c5b7f02e84','562362d2ef4f556',NULL,NULL,'1',10,NULL,'savebtn',60,10,'Καταχώριση Αξιολόγησης','Καταχώριση','button',61,720,160,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-10-18 12:54:35','globeadmin','2016-07-24 23:30:41','globeadmin','2022-02-08 23:51:03','globeadmin'),('56236cac88c6d92','562362d2ef4f556',NULL,NULL,'1',10,NULL,'printbtn',70,10,'Καταχώριση Αξιολόγησης','Εκτύπωση','button',61,903,160,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-10-18 12:55:56','globeadmin','2016-07-24 23:30:41','globeadmin','2022-02-08 23:51:03','globeadmin'),('56236d65271d3cf','562362d2ef4f556',NULL,NULL,'1',10,NULL,'marks_iframe',80,10,'Καταχώριση Αξιολόγησης',NULL,'iframe',116,10,1060,350,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-10-18 12:59:01','globeadmin','2018-06-28 11:51:03','globeadmin','2022-02-08 23:51:03','globeadmin'),('5687a761a496f47','5684e68b302da76',NULL,NULL,'1',10,NULL,'class_id',30,10,'Διδασκαλίες','Τμήμα','dropdown',67,55,100,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select distinct class.id,class.short_name \nfrom class\norder by class.short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-01-02 12:33:05','globeadmin','2016-10-08 20:16:02','globeadmin','2021-03-24 11:14:35','globeadmin'),('57ffbfb2c36d90f','572b615e795d4d1',NULL,NULL,'1',10,NULL,'label2',20,10,'Μαζική Αποστολή Email','Επισύναψη Αρχείου : ','words',481,66,150,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from class order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-10-13 20:09:06','globeadmin','2016-10-13 20:11:02','globeadmin','2021-02-27 09:46:00','globeadmin'),('562ca26493cd0a0','562362d2ef4f556',NULL,NULL,'1',10,NULL,'grading_period_iddsp',40,10,'Καταχώριση Αξιολόγησης',NULL,'display',10,703,150,80,'c','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','SELECT grading_period.id\nFROM school,grading_period \nWHERE \n    school.grading_period_id=grading_period.id AND \n    CURDATE() between grading_period.start_date AND grading_period.end_date \nlimit 1',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-10-25 11:35:32','globeadmin','2016-07-24 23:30:41','globeadmin','2022-02-08 23:51:03','globeadmin'),('5627e7fc14c3ee0','5627e58b8ed5f6d',NULL,NULL,'1',10,'select \'0\'','comments',10,10,'Ελεύθερο Κείμενο','Σχόλια : ','textarea',40,11,550,250,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-10-21 22:31:08','globeadmin','2016-06-01 19:59:50','globeadmin','2018-07-23 09:37:25','globeadmin'),('5627f2036f1a983','5627e58b8ed5f6d',NULL,NULL,'1',10,NULL,'studentdisp',20,10,'Ελεύθερο Κείμενο','Μαθητής : ','display',16,60,550,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','SELECT concat(`registration_number`,\' - \',`surname`,\' \',`name`,\' πατ. \',`fathers_name`)\n\nFROM `student` WHERE id = \'#student_id#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-10-21 23:13:55','globeadmin','2016-06-01 19:59:50','globeadmin','2018-07-23 09:37:25','globeadmin'),('562d1254ca96ef9','562d11f6d45ccf1',NULL,NULL,'1',10,NULL,'studentdisp',10,10,'Λεπτομέρειες','Μαθητής : ','display',14,93,550,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','SELECT concat(`registration_number`,\' - \',`surname`,\' \',`name`,\' πατ. \',`fathers_name`)\n\nFROM `student` WHERE id = \'#student_id#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-10-25 19:33:08','globeadmin','2015-10-25 19:33:08','globeadmin','2017-04-02 08:29:19','globeadmin'),('562d15e8a8697d2','562d11f6d45ccf1',NULL,NULL,'1',10,NULL,'subjectdisp',20,10,'Λεπτομέρειες','Μάθημα : ','display',45,96,550,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','SELECT concat(subject.name, if(subject_type.name is NULL,\'\',concat(\' (\',subject_type.name,\')\')))\nFROM subject\ninner join subject_type on subject.subject_type_id=subject_type.id\nWHERE subject.id = \'#subject_id#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-10-25 19:48:24','globeadmin','2015-10-25 20:35:09','globeadmin','2017-04-02 08:29:19','globeadmin'),('562d16bfb22ce80','562d11f6d45ccf1',NULL,NULL,'1',10,NULL,'grading_perioddisp',30,10,'Λεπτομέρειες','Περίοδος Αξιολόγησης : ','display',76,10,550,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','SELECT name\nFROM grading_period\nWHERE id = \'#grading_period_id#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-10-25 19:51:59','globeadmin','2016-07-24 23:00:01','globeadmin','2017-04-02 08:29:19','globeadmin'),('562d1837ecc4ec5','562d11f6d45ccf1',NULL,NULL,'1',10,NULL,'teacherdisp',40,10,'Λεπτομέρειες','Καθηγητής : ','display',108,80,550,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','SELECT concat(ifNULL(surname,\'\'),if(name is NULL OR surname is NULL,\'\',\' \'),ifNULL(name,\'\'))\nFROM teacher \nWHERE id = \'#post_teacher_id#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-10-25 19:58:16','globeadmin','2015-10-25 20:35:09','globeadmin','2017-04-02 08:29:19','globeadmin'),('57967dfce78e8d1','5476201e5a3d38f',NULL,NULL,'1',10,'select if(((select count(grading_period.id) from grading_period, mark\n            where \n                grading_period.id=mark.grading_period_id and\n                mark.student_id=\'#RECORD_ID#\')>0) AND	\n			(teacher_id=\'#teacher_id#\' OR \n			\'#nu_user_group# \'=\'Managers\' OR \n			\'#nu_user_group#\'=\'AssistManagers\' OR\n			\'#nu_user_group# \'=\'Administrators\' OR\n			\'#nu_user_group# \'=\'globeadmin\')\n			,\'1\',\'0\')\nfrom session_variables\nwhere session_id=\'#session_id#\'','student_mark_printbtn',30,60,'Αξιολόγηση','Εκτύπωση','button',29,530,150,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2016-07-26 00:00:45','globeadmin','2016-07-26 00:00:45','globeadmin','2022-01-08 11:22:28','globeadmin'),('562e7732ad03b7c','562e770b79c0722',NULL,NULL,'1',10,NULL,'grading_period_id',10,10,'Αξιολόγηση','Περίοδος Αξιολόγησης:','dropdown',17,17,200,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'SELECT distinct grading_period.id,grading_period.name\nFROM grading_period\ninner join mark on grading_period.id=mark.grading_period_id\nwhere \nmark.subject_id in \n    (\n    select distinct card.subject_id \n    from card where \n        card.valid_from =(SELECT max(timetable.start_date) FROM timetable) and\n        teacher_id=\'#RECORD_ID#\'\n    )\nORDER BY grading_period.name\n',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-10-26 20:55:46','globeadmin','2022-01-22 10:45:46','globeadmin','2022-01-22 10:45:46','globeadmin'),('56312e7a3e8b9f3','56312e4782e78b4',NULL,NULL,'1',10,NULL,'grading_period_id',10,10,'Αξιολόγηση','Περίοδος Αξιολόγησης :','dropdown',17,26,150,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'SELECT distinct grading_period.id,grading_period.name\nFROM grading_period\ninner join mark on grading_period.id=mark.grading_period_id\nORDER BY grading_period.name\n',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-10-28 22:22:18','globeadmin','2016-07-24 16:12:11','globeadmin','2020-04-02 19:43:37','globeadmin'),('562e7784949b643','562e770b79c0722',NULL,NULL,'1',10,NULL,'class_subject_selection',20,10,'Αξιολόγηση','Τμήμα - Μάθημα :','dropdown',49,52,750,250,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'SELECT distinct CONCAT(class_id,\',\',subject_id), CONCAT(class_short,\' - \',subject_name,if (subject_type_name is NULL,\'\',concat(\' (\',subject_type_name,\')\')))\nFROM \n(\nSELECT \n	active_card.id 				AS id,\n	active_card.valid_from 		AS valid_from,\n	active_card.subject_id 		AS subject_id,\n	active_card.teacher_id 		AS teacher_id,\n	active_card.class_id 		AS class_id,\n	active_card.classroom_id 	AS classroom_id,\n	active_card.day_id 			AS day_id,\n	active_card.period_id 		AS period_id,\n	teacher.short_name 			AS teacher_short,\n	teacher.surname 			AS teacher_surname,\n	teacher.name 				AS teacher_name,\n	day.name 					AS day_name,\n	day.short_name 				AS day_short,\n	period.short_name 			AS period_short,\n	period.name 				AS period_name,\n	class.short_name 			AS class_short,\n	class.name 					AS class_name,\n	subject.short_name 			AS subject_short,\n	subject.name 				AS subject_name,\n	subject.is_marked 			AS subject_is_marked,\n	subject_type.short_name 	AS subject_type_short,\n	subject_type.name 			AS subject_type_name,\n	classroom.short_name 		AS classroom_short,\n	classroom.name 				AS classroom_name,\n	teacher.email 				AS teacher_email,\n	teacher.user_id 			AS teacher_user_id \nFROM \n	(SELECT \n		card.id 			AS id,\n		card.valid_from 	AS valid_from,\n		card.subject_id 	AS subject_id,\n		card.teacher_id 	AS teacher_id,\n		card.class_id 		AS class_id,\n		card.classroom_id 	AS classroom_id,\n		card.day_id 		AS day_id,\n		card.period_id 		AS period_id \n	FROM card \n	WHERE card.valid_from =\n		(	SELECT max(timetable.start_date) \n			FROM timetable)) as active_card \n	inner join subject 			on active_card.subject_id = subject.id \n	inner join teacher 			on active_card.teacher_id = teacher.id  \n	inner join day 				on active_card.day_id = day.id  \n	inner join period 			on active_card.period_id = period.id\n	inner join class 			on active_card.class_id = class.id	\n	left  join subject_type 	on subject.subject_type_id = subject_type.id  \n	left  join classroom 		on active_card.classroom_id = classroom.id  \nORDER BY \n	active_card.teacher_id,\n	active_card.day_id,\n	active_card.period_id\n) as active_card_full\nWHERE \n    teacher_id=\'#RECORD_ID#\' and \n    (subject_id, class_id) in \n        (select distinct mark.subject_id, mark.class_id \n        from mark \n        where\n            mark.grading_period_id = \'#grading_period_id#\') \n    ORDER BY class_short,subject_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-10-26 20:57:08','globeadmin','2022-01-22 10:39:55','globeadmin','2022-01-22 10:44:33','globeadmin'),('56312e9356f5236','56312e4782e78b4',NULL,NULL,'1',10,NULL,'subject_id',30,10,'Αξιολόγηση','Μάθημα :','dropdown',75,112,750,250,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'SELECT distinct subject.id, concat(subject.name,if(subject_type.name is null,\'\',concat(\' (\',subject_type.name,\')\')))\nFROM subject\nINNER JOIN mark ON mark.subject_id=subject.id\nLEFT JOIN subject_type ON subject_type.id = subject.subject_type_id\nwhere\n    mark.grading_period_id=\'#grading_period_id#\' and\n    mark.class_id=\'#class_id#\'\nORDER BY subject.short_name\n',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-10-28 22:22:43','globeadmin','2016-07-24 16:12:11','globeadmin','2020-04-02 19:43:37','globeadmin'),('562e77974679b6b','562e770b79c0722',NULL,NULL,'1',10,NULL,'marks_showiframe',30,10,'Αξιολόγηση',NULL,'iframe',84,15,1000,900,'c','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',100,250,'2015-10-26 20:57:27','globeadmin','2016-07-24 23:26:21','globeadmin','2018-02-04 14:42:51','globeadmin'),('562fc524a6a798a','59d7d7986aed52d',NULL,NULL,'0',10,NULL,'show_markbtn',10,10,'Αξιολόγηση Μαθητών και Ποινές',NULL,'html',80,73,220,100,'l','0','0','','0',NULL,NULL,'#RECORD_ID# ','5495dad1762dc2c',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_marks_id\').src=\'images/marksb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_marks_id\').src=\'images/marks.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_marks_id\' src=\'images/marks.png\' title=\'Εμφάνιση Αξιολόγησης\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Εμφάνιση Αξιολόγησης</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-27 20:40:36','globeadmin','2017-10-07 01:07:46','globeadmin','2022-01-08 11:00:03','globeadmin'),('5631391b3dede85','56192be786c61d7',NULL,NULL,'0',10,NULL,'show_marksbtn',30,10,'Αξιολόγηση Μαθητών και Ποινές',NULL,'html',192,50,220,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_marks_id\').src=\'images/marksb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_marks_id\').src=\'images/marks.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_marks_id\' src=\'images/marks.png\' title=\'Εμφάνιση αξιολόγησης\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Εμφάνιση Αξιολόγησης</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-10-28 23:07:39','globeadmin','2021-10-24 21:24:30','globeadmin','2021-10-24 21:33:11','globeadmin'),('56312ff5c261a09','56312e4782e78b4',NULL,NULL,'1',10,NULL,'marks_showiframe',40,10,'Αξιολόγηση',NULL,'iframe',108,15,1000,880,'c','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',100,250,'2015-10-28 22:28:37','globeadmin','2016-07-24 16:12:11','globeadmin','2020-04-02 19:43:37','globeadmin'),('565b21c2eb75730','565b05b5e424081',NULL,NULL,'1',10,NULL,'show_pdfbtn',40,10,'Βαθμολογία','Εμφάνιση PDF','button',59,731,200,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-11-29 18:03:15','globeadmin','2015-11-29 18:03:15','globeadmin','2018-02-04 11:35:11','globeadmin'),('56313184195078a','56312e4782e78b4',NULL,NULL,'1',10,NULL,'class_id',20,10,'Αξιολόγηση','Τμήμα :','dropdown',46,123,150,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'SELECT distinct class.id,class.short_name\nFROM class\nINNER JOIN mark on class.id=mark.class_id\nwhere\nmark.grading_period_id=\'#grading_period_id#\'\nORDER BY class.short_name\n',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-10-28 22:35:16','globeadmin','2016-07-24 16:12:11','globeadmin','2020-04-02 19:43:37','globeadmin'),('5650b0f292b8acb','554517bdc18334d',NULL,NULL,'1',10,NULL,'type',40,10,'Λεπτομέρειες','*Τύπος Ποινής :','dropdown',68,84,350,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select n.nm1,n.nm2\nfrom\n((SELECT name as nm1,name  as nm2\nFROM penalty_type\nLEFT JOIN penalty ON penalty.id = \'#RECORD_ID#\'\nWHERE\n    ((penalty_type.teacher_access=1 OR\n    \'#nu_user_group#\'=\'globeadmin\' OR \n    \'#nu_user_group#\'=\'Administrators\' OR \n    \'#nu_user_group#\'=\'Managers\' OR \n    \'#nu_user_group#\'=\'AssistManagers\') AND\n    penalty_type.on_form=1) OR penalty_type.name =penalty.type)\nUNION\n(SELECT DISTINCT `type` as nm1,`type` as nm2\nfrom penalty\nwhere \n    `type` not in (select name from penalty_type) and \n    `type` is not null and \n    (\'#nu_user_group#\'=\'globeadmin\' OR \n    \'#nu_user_group#\'=\'Administrators\' OR \n    \'#nu_user_group#\'=\'Managers\' OR \n    \'#nu_user_group#\'=\'AssistManagers\')\n    )) as n',NULL,'','',NULL,NULL,NULL,'#nuSepEditnuSepr#varchar',NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-11-21 19:59:14','globeadmin','2018-02-09 13:42:07','globeadmin','2022-01-07 21:47:53','globeadmin'),('5650b2619527e79','554517bdc18334d',NULL,NULL,'1',10,NULL,'date_addeddisp',110,10,'Λεπτομέρειες','Ημερομηνία Καταχώρισης :','display',561,20,150,0,'r','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select DATE_FORMAT(date_added,\'%d-%m-%Y %T\')\nfrom penalty\nwhere id=\'#RECORD_ID#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-11-21 20:05:21','globeadmin','2015-11-21 20:10:15','globeadmin','2022-01-07 21:47:53','globeadmin'),('565219241580419','59d7d745b1eecbf',NULL,NULL,'1',10,NULL,'teacher_studentsifame',10,100,'Μαθητές που είμαι Υπεύθυνος ή Σύμβουλος',NULL,'iframe',18,16,950,450,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'56521e303a1e26c','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-11-22 21:36:04','globeadmin','2018-07-03 01:47:27','globeadmin','2021-03-09 19:39:02','globeadmin'),('565b06283e1ec56','565b05b5e424081',NULL,NULL,'1',10,NULL,'subject_id',30,10,'Βαθμολογία','Μάθημα :','dropdown',75,98,550,250,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'SELECT distinct subject.id, concat(subject.name,if(subject_type.name is null,\'\',concat(\' (\',subject_type.name,\')\')))\nFROM subject\nINNER JOIN mark ON mark.subject_id=subject.id\nLEFT JOIN subject_type ON subject_type.id = subject.subject_type_id\nwhere\n    mark.grading_period_id=\'#grading_period_id#\' and\n    mark.class_id=\'#class_id#\'\nORDER BY subject.short_name\n',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-11-29 16:05:28','globeadmin','2015-11-29 19:32:35','globeadmin','2017-03-18 16:32:13','globeadmin'),('565b066f6ef0e4b','565b05b5e424081',NULL,NULL,'1',10,NULL,'marks_showiframe',50,10,'Βαθμολογία',NULL,'iframe',104,15,910,550,'c','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',100,250,'2015-11-29 16:06:39','globeadmin','2015-11-29 19:35:20','globeadmin','2015-11-29 19:36:32','globeadmin'),('565b2d7f2d07c3a','565b05b5e424081',NULL,NULL,'1',10,NULL,'label1',60,10,'Βαθμολογία','Επιλέξτε περίοδο αξιολόγησης. Αφήνοντας κενό το τμήμα ή το μάθημα εμφανίζονται όλες οι αντίστοιχες βαθμολογικές καταστάσεις.','words',19,315,630,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from class order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-11-29 18:53:19','globeadmin','2016-07-24 16:20:00','globeadmin','2016-07-24 16:20:00','globeadmin'),('56607bd98296ad6','59d7d65650da67c',NULL,NULL,'1',10,NULL,'comments_for_students',90,10,'Προσωπικά Στοιχεία',NULL,'textarea',47,541,400,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-12-03 19:28:57','globeadmin','2017-10-06 22:48:26','globeadmin','2018-07-28 00:38:24','globeadmin'),('566086e7654ae06','566086607663544',NULL,NULL,'1',10,NULL,'teachers_comments',10,10,'Ημέρες και Ώρες Ενημέρωσης από τους Καθηγητές',NULL,'iframe',16,17,700,350,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'56608bc656a4d24','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-12-03 20:16:07','globeadmin','2015-12-03 21:43:43','globeadmin','2020-03-29 16:26:45','globeadmin'),('56607c35124a5af','59d7d65650da67c',NULL,NULL,'1',10,NULL,'comments_for_students_label',100,10,'Προσωπικά Στοιχεία','Ημέρες και Ώρες Ενημέρωσης Γονέων :','words',25,544,350,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-12-03 19:30:29','globeadmin','2017-10-06 22:48:43','globeadmin','2020-11-08 19:41:59','globeadmin'),('5661ebf59f72ad2','547372d029461f4',NULL,NULL,'1',10,NULL,'comments_for_students',100,10,'Λεπτομέρειες',NULL,'textarea',163,482,400,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-12-04 21:39:33','globeadmin','2015-12-04 21:39:33','globeadmin','2021-01-26 20:15:03','globeadmin'),('5661ec5f3195abf','547372d029461f4',NULL,NULL,'1',10,NULL,'comments_for_students_label',110,10,'Λεπτομέρειες','Ημέρες και Ώρες Ενημέρωσης Γονέων :','words',135,484,350,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2015-12-04 21:41:19','globeadmin','2015-12-04 21:41:19','globeadmin','2021-01-26 20:15:03','globeadmin'),('56e5542263614da','56e553b8d3afa56',NULL,NULL,'1',10,NULL,'teaching_showiframe',30,10,'Ημερολόγιο Διδασκαλιών',NULL,'iframe',64,21,900,400,'c','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',100,250,'2016-03-13 13:50:58','globeadmin','2016-03-13 14:01:39','globeadmin','2016-10-09 10:31:49','globeadmin'),('1455245046ba3h','nuobject','','0','1',10,'','sob_button_zzzsys_form_id',80,20,'Button','Form To Launch via Browse','lookup',0,0,300,100,'l','0','0','','0',NULL,0,'','','','','','','SELECT zzzsys_form_id, sfo_name FROM zzzsys_form ORDER BY sfo_name','','','','','sfo_name','','sfo_title',NULL,'nunoaccess','zzzsys_form_id','','','',0,'1','1','','','','','','','','',100,250,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-02-05 10:31:01','globeadmin'),('56e9926c84edeb7','56e98e66abfe2c1',NULL,NULL,'1',10,NULL,'student_disp',10,10,'Σχόλια Καθηγητή','Μαθητής :','display',19,99,700,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','SELECT concat (student.surname,\' \',student.name,IF(student.fathers_name IS NULL,\'\',CONCAT(\' πατ. \',student.fathers_name)))\nFROM comment\ninner join  student           on student.id         = comment.student_id\nWHERE comment.id=\'#RECORD_ID#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2016-03-16 19:05:48','globeadmin','2016-03-16 20:41:04','globeadmin','2021-03-24 11:21:27','globeadmin'),('56e9959dc467fe2','56e98e66abfe2c1',NULL,NULL,'1',10,'select \'0\'','teacher_comments',40,10,'Σχόλια Καθηγητή',NULL,'text',0,0,50,50,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-03-16 19:19:25','globeadmin','2016-03-16 19:19:25','globeadmin','2021-03-24 11:21:27','globeadmin'),('56e99638c1f8c11','56e98e66abfe2c1',NULL,NULL,'1',10,NULL,'tinymce_editor2',110,10,'Σχόλια Καθηγητή',NULL,'iframe',536,20,900,370,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'56cc9f04b82528e','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-03-16 19:22:00','globeadmin','2016-10-22 12:28:01','globeadmin','2021-03-24 11:21:28','globeadmin'),('56e997b778b936d','56e98e66abfe2c1',NULL,NULL,'1',10,'select \'0\'','student_comments',40,10,'Σχόλια Καθηγητή',NULL,'text',0,0,50,50,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-03-16 19:28:23','globeadmin','2016-03-16 19:28:23','globeadmin','2021-03-24 11:21:27','globeadmin'),('56e99844d30debe','56e98e66abfe2c1',NULL,NULL,'1',10,NULL,'label1',60,10,'Σχόλια Καθηγητή','Προσωπικά Σχόλια Καθηγητή :','words',114,43,550,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-03-16 19:30:44','globeadmin','2016-03-16 19:36:26','globeadmin','2021-03-24 11:21:27','globeadmin'),('56e998712f7c719','56e98e66abfe2c1',NULL,NULL,'1',10,NULL,'label2',80,10,'Σχόλια Καθηγητή','Παρατηρήσεις προς το Μαθητή - Γονέα :','words',514,43,400,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-03-16 19:31:29','globeadmin','2016-10-22 12:28:21','globeadmin','2021-03-24 11:21:28','globeadmin'),('56ea594af092b99','56ea588f03c272b',NULL,NULL,'1',10,NULL,'student_disp',10,10,'Παρατηρήσεις του Καθηγητή προς το Μαθητή - Γονέα','Μαθητής :','display',14,55,700,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','SELECT concat (student.surname,\' \',student.name,IF(student.fathers_name IS NULL,\'\',CONCAT(\' πατ. \',student.fathers_name)))\nFROM comment\ninner join  student           on student.id         = comment.student_id\nWHERE comment.id=\'#RECORD_ID#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2016-03-17 09:14:19','globeadmin','2016-03-17 09:25:11','globeadmin','2021-03-24 11:22:00','globeadmin'),('56ea595fa9c6646','56ea588f03c272b',NULL,NULL,'1',10,NULL,'class_lesson_disp',20,10,'Παρατηρήσεις του Καθηγητή προς το Μαθητή - Γονέα','Μάθημα :','display',41,59,700,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','SELECT concat (subject.name,IF(subject_type.short_name IS NULL,\'\',CONCAT(\' (\',subject_type.short_name,\')\')))\nFROM comment\ninner join  subject         on subject.id       = comment.subject_id\nleft join   subject_type    on subject_type.id  = subject.subject_type_id\nWHERE comment.id=\'#RECORD_ID#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2016-03-17 09:14:39','globeadmin','2016-03-17 20:41:05','globeadmin','2021-03-24 11:22:00','globeadmin'),('56eae63d3ec84c9','56eae5254137ba7',NULL,NULL,'1',10,NULL,'comments_iframe',20,10,'Λίστα Μαθητών',NULL,'iframe',74,17,940,520,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'56eae990f0fff5f','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2016-03-17 19:15:41','globeadmin','2018-01-18 12:22:13','globeadmin','2019-03-09 10:39:15','globeadmin'),('56ea59c3a753d38','56ea588f03c272b',NULL,NULL,'1',10,NULL,'comments_iframe',30,10,'Παρατηρήσεις του Καθηγητή προς το Μαθητή - Γονέα',NULL,'iframe',94,21,900,370,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-03-17 09:16:19','globeadmin','2016-03-17 09:25:11','globeadmin','2021-03-24 11:22:00','globeadmin'),('54ffacae7d8599d','nufastform',NULL,NULL,'1',10,NULL,'fast_form_subform',50,10,'Fast Form','Objects on Form','subform',57,16,460,350,'l','1','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,21,'1','1','sob_zzzsys_form_id','zzzsys_object_id','SELECT * \nFROM zzzsys_object\nWHERE sob_zzzsys_form_id = \'#RECORD_ID#\'\nORDER BY \nsob_all_tab_number, \nsob_all_column_number,  \nsob_all_order_number','zzzsys_object',NULL,'',NULL,'g',0,0,'2015-03-11 13:17:10','globeadmin','2015-03-24 10:06:55','globeadmin','2015-04-15 12:04:02','globeadmin'),('56ec68b2a4259cb','56ea588f03c272b',NULL,NULL,'1',10,NULL,'teacher_disp',40,10,'Παρατηρήσεις του Καθηγητή προς το Μαθητή - Γονέα','Καθηγητής :','display',67,43,700,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','SELECT concat (if(teacher.surname IS NULL,\'\',concat(teacher.surname,\' \')),IF(teacher.name IS NULL,\'\',CONCAT(teacher.name,\' \')))\nFROM comment\ninner join  teacher         on teacher.id       = comment.post_teacher_id\nWHERE comment.id=\'#RECORD_ID#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2016-03-18 22:44:34','globeadmin','2016-03-18 22:44:34','globeadmin','2021-03-24 11:22:00','globeadmin'),('56ec6bd153951ef','56eae5254137ba7',NULL,NULL,'1',10,'select \'0\'','class_subject_disp',10,10,'Λίστα Μαθητών','Τμήμα - Μάθημα :','display',447,132,700,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','SELECT concat (class.short_name,\' - \',subject.name,IF(subject_type.short_name IS NULL,\'\',CONCAT(\' (\',subject_type.name,\')\')))\nFROM session_variables\nINNER JOIN  class               on class.id         = session_variables.class_id\nINNER JOIN  subject             on subject.id       = session_variables.subject_id\nLEFT  JOIN  subject_type        on subject_type.id  = subject.subject_type_id\nWHERE\nsession_variables.session_id=\'#session_id#\' ',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-03-18 22:57:53','globeadmin','2017-04-29 10:57:49','globeadmin','2019-03-09 10:39:15','globeadmin'),('150206dfea0401','nuindex','','1','1',10,'','Debugbt',180,500,'Setup','Debug','button',257,701,120,30,'l','0','0','','0',NULL,0,'','nudebug','','','','','','','','','','','','',NULL,'','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-07-15 13:40:29','globeadmin'),('14f3852d29e0d9','14f3852d29db17',NULL,'','1',10,'','sob_all_name',30,20,'Subform','Name','text',0,0,230,0,'l','0','0','','0',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2013-10-10 10:42:28','globeadmin'),('14f3852d29db17','nuform',NULL,'','0',10,'','object_subform',10,200,'Reorder Form Objects','Objects','subform',10,30,950,350,'l','0','0','','0',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',21,'1','0','sob_zzzsys_form_id','zzzsys_object_id','SELECT * FROM zzzsys_object WHERE sob_zzzsys_form_id = \'#RECORD_ID#\' \nORDER BY \nsob_all_tab_number, \nsob_all_column_number, \nsob_all_order_number','zzzsys_object','','','','g',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2015-04-14 11:42:51','globeadmin'),('552dd5e743157ed','nuindex',NULL,NULL,'1',10,NULL,'farbtn',20,500,'Setup','Fast Report','button',75,65,120,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,0,'1','1',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2015-04-15 12:37:19','globeadmin','2015-04-15 12:38:37','globeadmin','2015-04-15 12:38:37','globeadmin'),('52c0db485a17ec1','nuimage',NULL,NULL,'1',20,'','nufile',70,10,'Main','Upload File','iframe',164,48,380,60,'l','0','0','','0',NULL,NULL,'',NULL,'','','','','','','52c0da99b95c264','','','',NULL,'',NULL,NULL,'','','','',0,'','','','','','','','',NULL,'',0,0,'2013-12-30 13:32:40','globeadmin','2013-12-30 13:32:40','globeadmin','2014-01-17 13:36:19','globeadmin'),('14f3852d29df28','14f3852d29db17',NULL,'','1',10,'','sob_all_column_number',80,20,'Subform','Col','text',0,0,50,0,'r','0','0','','0',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',NULL,'1','1','','','','','0','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2013-10-10 10:42:28','globeadmin'),('515e59ae459628c','nuform',NULL,'0','1',10,'','sfo_height',100,10,'General','Height','text',0,0,50,0,'r','0','0','','0',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',0,'1','1','','','','','','',NULL,'',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2015-04-14 11:42:50','globeadmin'),('5164b02e24345c9','nuindex',NULL,'0','1',10,'','phpbtn',60,500,'Setup','PHP Procedures','button',257,268,120,30,'l','0','0','','0',NULL,NULL,'','nuphp','','','','','','','','','','',NULL,'',NULL,'','','','','',0,'1','1','','','','','','',NULL,'',0,0,'0000-00-00 00:00:00','','2014-07-15 13:35:37','globeadmin','2014-07-15 13:35:37','globeadmin'),('14f3852d29e282','14f3852d29db17',NULL,'','1',10,'','sob_all_order_number',90,20,'Subform','Ord','text',0,0,50,0,'r','0','0','','0',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',NULL,'1','1','','','','','0','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2013-10-10 10:42:28','globeadmin'),('5164b083b1b6c36','nuphp',NULL,'0','1',10,'','slp_description',20,10,'Details','Description','text',0,0,250,0,'l','1','0','','1',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',0,'1','1','','','','','','',NULL,'',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2013-11-08 11:19:18','globeadmin'),('53c4840e17cfb82','nuindex',NULL,NULL,'1',10,NULL,'PermissionsWords',270,500,'Setup','<b>Permissions</b>','words',22,268,120,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-07-15 11:29:50','globeadmin','2014-07-15 12:17:26','globeadmin','2014-07-15 13:17:27','globeadmin'),('1455245046ba2c','nuobject','','0','1',10,'','sob_all_tab_number',60,10,'All','Tab Number','text',0,0,40,0,'r','1','0','','0',NULL,NULL,'','','','','','','','','','','','','','',NULL,'','','','','',0,'1','1','','','','','0','',NULL,'',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-02-05 10:30:59','globeadmin'),('decafc0ffee002','nuform','','0','1',20,'','sfo_print_title',115,20,'Action Buttons','Title','text',0,0,200,0,'l','0','0','','0',NULL,0,'','','','','','','','','','','','','','','','','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2015-04-14 11:42:51','globeadmin'),('1455245046baa3','nuobject','','0','1',10,'','sob_lookup_description_width',510,100,'Lookup','Description Width','text',0,0,50,0,'r','0','0','','0',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',0,'1','1','','','','','0','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-02-05 10:31:02','globeadmin'),('decafc0ffee001','nuform','','0','1',20,'','sfo_print_button',110,20,'Action Buttons','Print Button','dropdown',0,0,70,100,'l','0','0','','0',NULL,0,'','','','','','','1|Yes|0|No','','','','','','','','','','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2015-04-14 11:42:51','globeadmin'),('SMTPAUTH100004','nusetup','','0','1',10,'','set_smtp_host',40,20,'Email Settings','Auth SMTP host','text',0,0,200,0,'l','0','0','','0',NULL,0,'','','','','','','1|Yes|0|No','','','','','','','',NULL,'','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2013-11-18 16:30:48','globeadmin'),('516370102c486a1','51636e4728362e8',NULL,'','1',10,'','sob_all_left',110,20,'Subform','Left','text',0,0,50,0,'r','0','0','','0',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',0,'1','1','','','','','0','',NULL,'',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('51636fb70e91bd7','51636e4728362e8',NULL,'','1',10,'','sob_all_tab_number',70,20,'Subform','Tab','text',0,0,30,0,'r','0','0','','0',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',0,'1','1','','','','','0','',NULL,'',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('516340b344b54b4','nuobject',NULL,'0','1',20,'','sob_all_default_value_sql',30,10,'All','Default Value','textarea',0,0,300,100,'l','0','0','','0',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',0,'1','1','','','','','','',NULL,'',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-02-05 10:31:00','globeadmin'),('150c014660db40','14f3852d29db17',NULL,'','1',10,'','sob_all_left',110,20,'Subform','Left','text',0,0,50,0,'r','0','0','','0',NULL,NULL,'','','','','','','','','','','','','','',NULL,'','','','','',0,'1','1','','','','','0','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2013-10-10 10:42:28','globeadmin'),('14575e368d59f9','nuform','','0','1',20,'','sfo_sql',40,10,'General','SQL','textarea',0,0,350,250,'l','0','0','','0','',0,'','','','','','','','','','','','','','','','','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2015-04-14 11:42:50','globeadmin'),('1455245046ba67','nuobject','','0','1',10,'','sob_html_code',10,160,'HTML','HTML','textarea',0,0,900,400,'l','0','0','','0',NULL,0,'','','','','','','','','','','','','','',NULL,'','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-02-05 10:31:05','globeadmin'),('541b70a5c8e47e9','nusetup',NULL,NULL,'1',10,NULL,'sample2',110,20,'Email Settings','<i>your_name</i>@gmail.com','words',42,652,200,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'1|Yes|0|No',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,0,'1','1',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-09-19 09:24:13','globeadmin','2014-09-19 09:24:13','globeadmin','2014-09-19 09:24:35','globeadmin'),('53c48f71eab8e46','nuindex',NULL,NULL,'1',10,NULL,'CodeWords',220,500,'Setup','<b>Code</b>','words',236,268,120,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-07-15 12:18:26','globeadmin','2014-07-15 13:36:26','globeadmin','2014-07-15 13:36:26','globeadmin'),('SMTPAUTH100005','nusetup','','0','1',10,'','set_smtp_from_address',50,20,'Email Settings','Auth SMTP From Address','text',0,0,200,0,'l','0','0','','0',NULL,0,'','','','','','','1|Yes|0|No','','','','','','','',NULL,'','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2013-11-18 16:30:48','globeadmin'),('1455245046c01f','nuform','','0','1',10,NULL,'sfo_name',10,10,'General','Code','text',0,0,100,0,'l','0','0','','1','',0,'','','','','','','','','','','','','','','','','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2015-04-14 11:42:50','globeadmin'),('53c4953a7e44151','nuindex',NULL,NULL,'1',10,NULL,'FormsWords',240,500,'Setup','<b>Start</b>','words',22,65,120,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-07-15 12:43:06','globeadmin','2015-04-13 11:53:21','globeadmin','2015-04-13 11:53:21','globeadmin'),('SMTPAUTH100006','nusetup','','0','1',10,'','set_smtp_from_name',50,20,'Email Settings','Auth SMTP From Name','text',0,0,200,0,'l','0','0','','0',NULL,0,'','','','','','','1|Yes|0|No','','','','','','','',NULL,'','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2013-11-18 16:30:48','globeadmin'),('53c496124b40fa7','nuindex',NULL,NULL,'1',10,NULL,'ScreensWords',210,500,'Setup','<b>User Screens</b>','words',236,65,120,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-07-15 12:46:42','globeadmin','2014-07-15 12:46:42','globeadmin','2014-07-15 13:17:27','globeadmin'),('1455245046ba33','nuobject','','0','1',10,'','sob_all_title',30,10,'All','Title','text',0,0,200,0,'l','0','0','','0','',0,'','','','','','','','','','','','','','','','','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-02-05 10:30:58','globeadmin'),('53c49572bbc61b5','nuindex',NULL,NULL,'1',10,NULL,'ObjectsWords',250,500,'Setup','<b>Develop</b>','words',22,487,120,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-07-15 12:44:02','globeadmin','2015-04-13 11:47:22','globeadmin','2015-04-13 11:47:22','globeadmin'),('51636f63f416664','51636e4728362e8',NULL,'','1',10,'','sob_all_title',35,20,'Subform','Title','text',0,0,230,0,'l','0','0','','0',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',0,'1','1','','','1','','','',NULL,'',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('SMTPAUTH100003','nusetup','','0','1',10,'','set_smtp_password',30,20,'Email Settings','Auth SMTP password','text',0,0,200,0,'l','0','0','','0',NULL,0,'','','','','','','1|Yes|0|No','','','','','','','',NULL,'','','','','',0,'1','1','','','','','','','1','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2013-11-18 16:30:48','globeadmin'),('phpMyAdminbtn','nuindex',NULL,NULL,'1',10,NULL,'phpMyAdminbtn',150,500,'Setup','Database','button',75,701,120,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-06-26 12:50:38','globeadmin','2014-07-15 13:32:12','globeadmin','2014-07-15 13:32:12','globeadmin'),('541b714939bb0d5','nusetup',NULL,NULL,'1',10,NULL,'sample8',170,20,'Email Settings','Yes','words',173,652,200,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'1|Yes|0|No',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,0,'1','1',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-09-19 09:26:57','globeadmin','2014-09-19 09:26:57','globeadmin','2014-09-19 09:26:57','globeadmin'),('15021bce9c7549','nusetup','','0','1',10,'','set_language',250,10,'Setup','Language','dropdown',0,0,100,100,'l','0','0','','0',NULL,0,'','','','','','','SELECT trl_language, trl_language FROM zzzsys_translate \r\nGROUP BY trl_language\r\nORDER BY trl_language\r\n','','','','','','','',NULL,'','','','','',0,'1','1','','','','','','','','b',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2013-11-18 16:30:46','globeadmin'),('1472e8d8b36588','nuimage','','0','1',10,'','sfi_code',10,10,'Main','Code','text',85,83,50,0,'l','1','0','','1',NULL,0,'','','','','','','','','','','','','','',NULL,'','','','','',0,'1','1','','','','','','','0','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-01-17 13:36:18','globeadmin'),('51636f9b34802ec','51636e4728362e8',NULL,'','1',10,'','sob_all_tab_title',60,20,'Subform','Tab Title','text',0,0,170,0,'l','0','0','','0',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',0,'1','1','','','','','','',NULL,'',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('1455245046c010','nuform','','0','1',10,'','browseColumns',10,15,'Browse','Browse Columns','subform',100,110,789,300,'l','0','0','','0','',0,'','','','','','','','','','','','','','','','','','','','',22,'1','1','sbr_zzzsys_form_id','zzzsys_browse_id','SELECT * FROM zzzsys_browse WHERE sbr_zzzsys_form_id = \'#RECORD_ID#\' ORDER BY sbr_order','zzzsys_browse','','','','g',0,0,'0000-00-00 00:00:00','','2013-09-10 09:30:34','globeadmin','2015-04-14 11:42:50','globeadmin'),('14f3852d29e41e','14f3852d29db17',NULL,'','1',10,'','sob_all_tab_number',70,20,'Subform','Tab','text',0,0,30,0,'r','0','0','','0',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',NULL,'1','1','','','','','0','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2013-10-10 10:42:28','globeadmin'),('1459205808b808','nulevel','','0','1',10,'','sal_code',10,10,'Description','Code','text',0,0,100,0,'l','1','0','','1','',0,'','','','','','','','','','','','','','','','','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','2013-11-11 07:56:51','globeadmin','2015-04-14 11:40:59','globeadmin'),('515377f3c87787c','nuform',NULL,'0','1',10,'','codetabs',1100,120,'Custom Code',' ','html',0,0,1,1,'l','0','0','','0',NULL,NULL,'','','','','','','','<style>\r\n   .nuCodeTabs         {background-color:grey;color:#124E72;color:white;margin:2px;padding:3px;border-width:0px;border-style:none;}\r\n   .nuCodeTabs:hover   {background-color:#FF8C00;cursor:default}\r\n   .nuCodeTabsSelected {background-color:orange}\r\n</style>\r\n\r\n\r\n<div style=\"position:absolute;left:40px;\">\r\n  <span id=\'nuCode_before_browse\' class=\'nuCodeTabs\' onclick=\'nuShowCode(this)\' class=\'nuGradient\'> Before Browse </span>\r\n  <span id=\'nuCode_before_open\'   class=\'nuCodeTabs\' onclick=\'nuShowCode(this)\' class=\'nuGradient\'> Before Open </span>\r\n  <span id=\'nuCode_before_save\'   class=\'nuCodeTabs\' onclick=\'nuShowCode(this)\' class=\'nuGradient\'> Before Save </span>\r\n  <span id=\'nuCode_before_delete\' class=\'nuCodeTabs\' onclick=\'nuShowCode(this)\' class=\'nuGradient\'> Before Delete </span>\r\n  <span id=\'nuCode_after_save\'    class=\'nuCodeTabs\' onclick=\'nuShowCode(this)\' class=\'nuGradient\'> After Save </span>\r\n  <span id=\'nuCode_after_delete\'  class=\'nuCodeTabs\' onclick=\'nuShowCode(this)\' class=\'nuGradient\'> After Delete </span>\r\n  <span id=\'nuCode_javascript\'    class=\'nuCodeTabs\' onclick=\'nuShowCode(this)\' class=\'nuGradient\'> Javascript </span>\r\n</div>\r\n\r\n','','','','',NULL,'',NULL,'','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2015-04-14 11:42:51','globeadmin'),('1457c73b54bc68','1457c6e9eb2c5b','','0','1',10,'','zzzsys_slo_object_name',20,10,'S1','Object Name','text',0,0,230,0,'l','1','0','','0','',0,'','','','','','','','','','','','','','','','','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','2013-10-11 13:22:38','globeadmin','2013-10-14 09:10:38','globeadmin'),('1460b1faf70520','nuobject','','0','1',10,'','sob_button_skip_browse_record_id',110,20,'Button','Record ID','text',0,0,120,0,'l','0','0','','0',NULL,0,'','','','','','','SELECT zzzsys_form_id, sfo_name FROM zzzsys_form ORDER BY sfo_name','','','','','','','',NULL,'','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-02-05 10:31:01','globeadmin'),('145935a9b4e00d','nuuser','','0','1',10,'','sus_login_name',20,10,'Details','User Name','text',0,0,200,0,'l','0','0','','0','',0,'','','','','','','','','','','','','','','','','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('5164b0fcc6e8515','nuphp',NULL,'0','1',10,'','slp_php',40,20,'PHP Code','PHP','textarea',0,0,900,400,'l','1','0','','0',NULL,NULL,'','','','','','','','','','','','',NULL,'',NULL,'','','','','',0,'1','1','','','','','','',NULL,'',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2014-09-19 12:07:38','globeadmin'),('542b41a007a0d02','nuform',NULL,NULL,'1',10,NULL,'sfo_custom_code_run_before_delete',7,120,'Custom Code',NULL,'textarea',45,30,1,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,0,'1','1',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2014-10-01 09:19:52','globeadmin','2014-10-01 09:19:52','globeadmin','2015-04-14 11:42:51','globeadmin'),('145beaa6469387','nuform','','0','1',10,'','sfo_delete_title',55,20,'Action Buttons','Title','text',0,0,200,0,'l','0','0','','0',NULL,0,'','','','','','','','','','','','','','','','','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2015-04-14 11:42:51','globeadmin'),('5269a983bdb5bdf','nuobject',NULL,NULL,'0',10,'','sob_iframe_zzzsys_report_id',30,210,'iFrame','Report to Run','lookup',0,0,100,0,'l','0','0','','0',NULL,NULL,'','','','','','','','','','','','sre_code',NULL,'sre_description',NULL,'5269ae8512ebfd3','zzzsys_report_id','','','',0,'1','1','','','','','','',NULL,'',100,250,'2013-10-25 09:43:07','globeadmin','2013-10-25 09:44:44','globeadmin','2014-02-05 10:31:06','globeadmin'),('14593167adb25a','nuindex','','0','1',10,'','runphpbutton',70,500,'Setup','Run Procedure','button',289,268,120,30,'l','0','0','','0','',0,'','nurunphp','','','','','','','','','','','','','','','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','2014-07-15 13:35:56','globeadmin','2014-07-15 13:35:56','globeadmin'),('145bea9e09d919','nuform','','0','1',10,'','sfo_save_title',35,20,'Action Buttons','Title','text',0,0,200,0,'l','0','0','','0',NULL,0,'','','','','','','','','','','','','','','','','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2015-04-14 11:42:51','globeadmin'),('14b171429ee70d','nuform','','0','1',10,'','sfo_custom_code_run_before_save',115,120,'Custom Code','','textarea',45,30,0,0,'l','0','0','','0',NULL,0,'','','','','','','','','','','','','','',NULL,'','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2015-04-14 11:42:51','globeadmin'),('1472e8dd001218','nuimage','','0','1',10,'','sfi_description',20,10,'Main','Description','text',112,48,250,100,'l','0','0','','0',NULL,0,'','','','','','','','','','','','','','',NULL,'','','','','',0,'1','1','','','','','','','0','',0,0,'0000-00-00 00:00:00','','2013-10-25 13:46:49','globeadmin','2014-01-17 13:36:18','globeadmin'),('146bc0d39135da','nuform','','0','1',10,'','sfo_custom_code_run_before_browse',10,120,'Custom Code','','textarea',45,30,0,0,'l','0','0','','0',NULL,0,'','','','','','','','','','','','','','',NULL,'','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2015-04-14 11:42:51','globeadmin'),('14fa457aece384','nuobject','','0','1',10,'','sob_browse_zzzsys_form_id',10,200,'Browse','Browse','lookup',0,0,250,100,'l','0','0','','0',NULL,0,'','','','','','','SELECT * FROM zzzsys_form ORDER BY sfo_name','','','','','sfo_name','','sfo_title',NULL,'nuform','zzzsys_form_id','','','',0,'1','1','','','','','','','','',100,250,'0000-00-00 00:00:00','','2013-10-09 12:33:29','globeadmin','2014-02-05 10:31:05','globeadmin'),('56f1835c0ecfc1c','56e052ae98309fe',NULL,NULL,'1',10,'select if (\'#nu_user_group#\'=\'Students\' OR \'#nu_user_group#\'=\'Parents\',\'0\',\'1\')','class_subject_selection',10,10,'Διδασκαλίες','Τμήμα - Μάθημα : ','dropdown',14,31,600,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'SELECT distinct CONCAT(class_id,\',\',subject_id), CONCAT(class.short_name,\' - \',subject.name,if (subject_type.name is NULL,\'\',concat(\' (\',subject_type.name,\')\')))\nFROM \n	(SELECT \n		card.id 			AS id,\n		card.subject_id 	AS subject_id,\n		card.teacher_id 	AS teacher_id,\n		card.class_id 		AS class_id\n	FROM card \n	WHERE card.valid_from = (SELECT max(timetable.start_date) FROM timetable)) as active_card \n	inner join subject 			on active_card.subject_id = subject.id \n	inner join class 			on active_card.class_id = class.id	\n	left  join subject_type 	on subject.subject_type_id = subject_type.id  \nWHERE teacher_id=\'#RECORD_ID#\'\nORDER BY class.short_name,subject.name,subject_type.name DESC\n',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-03-22 19:39:40','globeadmin','2022-01-31 10:14:41','globeadmin','2022-12-21 12:47:00','globeadmin'),('56eea333722120b','562229979f567be',NULL,NULL,'1',10,NULL,'label3',30,10,'Διαγραφή Όλων','όλα τα ημερολόγια διδασκαλιών, όλα τα σχόλια των καθηγητών, όλες οι αργίες, όλες οι ποινές, και όσα από τα παρακάτω επιλέξετε :','words',68,9,900,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-03-20 15:18:43','globeadmin','2016-07-12 00:44:29','globeadmin','2016-07-12 00:44:29','globeadmin'),('56ef01dd6dda665','5476201e5a3d38f',NULL,NULL,'1',10,NULL,'penelty_print_btn',20,90,'Ποινές','Εκτύπωση Ποινών','button',38,733,200,35,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-03-20 22:02:37','globeadmin','2016-03-20 22:02:37','globeadmin','2022-01-08 11:22:29','globeadmin'),('56f18d5c050b964','56eae5254137ba7',NULL,NULL,'1',10,NULL,'class_subject_selection',30,10,'Λίστα Μαθητών','Τμήμα - Μάθημα : ','dropdown',28,31,600,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'SELECT distinct CONCAT(class_id,\',\',subject_id), CONCAT(class.short_name,\' - \',subject.name,if (subject_type.name is NULL,\'\',concat(\' (\',subject_type.name,\')\')))\nFROM \n	(SELECT \n		card.id 			AS id,\n		card.subject_id 	AS subject_id,\n		card.teacher_id 	AS teacher_id,\n		card.class_id 		AS class_id\n	FROM card \n	WHERE card.valid_from = (SELECT max(timetable.start_date) FROM timetable)) as active_card \n	inner join subject 			on active_card.subject_id = subject.id \n	inner join class 			on active_card.class_id = class.id	\n	left  join subject_type 	on subject.subject_type_id = subject_type.id  \nWHERE teacher_id=\'#RECORD_ID#\'\nORDER BY class.short_name,subject.name,subject_type.name DESC\n',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-03-22 20:22:20','globeadmin','2022-01-31 10:13:54','globeadmin','2022-01-31 10:13:54','globeadmin'),('56f688cfac3b679','54df20f94548357',NULL,NULL,'1',10,'select if(\'#nu_user_group#\'=\'globeadmin\',\'1\',\'0\')','timetable_count',140,10,'Εισαγωγή','Πλήθος Προγραμμάτων : ','display',135,334,50,45,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select count(*) from timetable','SELECT distinct valid_from,DATE_FORMAT(valid_from,\'%d-%m-%Y\')\nFROM card\nWHERE valid_from>CURDATE()','<a href=\'asc_template.xml\'>Λήψη</a>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-03-26 15:04:15','globeadmin','2016-10-15 19:35:01','globeadmin','2020-04-02 16:11:52','globeadmin'),('579b44224429920','5794b8d73636f76',NULL,NULL,'1',10,NULL,'system_check_iframe',10,10,'Έλεγχος Συστήματος και Δεδομένων',NULL,'iframe',11,10,920,450,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'5794ba3aab6842f','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-07-29 14:55:14','globeadmin','2016-07-29 15:31:03','globeadmin','2021-03-09 14:58:24','globeadmin'),('57090a3576860aa','54a52c3dcf3610b',NULL,NULL,'0',10,'select \'0\'','easysms_img',60,20,'Ρυθμίσεις Αποστολής SMS',NULL,'html',97,643,130,26,'l','0','0','','0',NULL,NULL,'0',NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"this.style.cursor=\'pointer\';\"\n                            onmouseout=\"this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=127 height=25 id=\'img_easysms\' src=\'images/easysms.png\' title=\'easySMS\'/>\n        </td>\n    </tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-09 16:57:09','globeadmin','2019-07-27 23:25:34','globeadmin','2019-07-27 23:25:34','globeadmin'),('5709068008aad6a','54a52c3dcf3610b',NULL,NULL,'1',10,NULL,'sms_settings_label1',10,20,'Ρυθμίσεις Αποστολής SMS','Ο Σίσυφος μπορεί να στέλνει SMS μέσω SMS Gateway (συνήθως απαιτείται εγγραφή και υπάρχει κόστος χρήσης).','words',20,20,800,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-09 16:41:20','globeadmin','2017-11-12 13:11:29','globeadmin','2019-07-27 23:23:30','globeadmin'),('570907cd2ad72b1','54a52c3dcf3610b',NULL,NULL,'1',10,NULL,'sms_settings_label2',20,20,'Ρυθμίσεις Αποστολής SMS','Παρακαλώ εισάγετε τα στοιχεία του SMS Gateway, μέσω του οποίου θα πραγματοποιείται η αποστολή των SMS :','words',48,20,830,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-09 16:46:53','globeadmin','2016-04-10 10:57:19','globeadmin','2019-07-27 23:23:30','globeadmin'),('5709113b4f76368','54a52c3dcf3610b',NULL,NULL,'1',10,NULL,'sms_login_name',40,20,'Ρυθμίσεις Αποστολής SMS','Όνομα Χρήστη :','text',148,132,300,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-09 17:27:07','globeadmin','2018-02-28 20:15:34','globeadmin','2019-07-27 23:23:30','globeadmin'),('5709117af099b2d','54a52c3dcf3610b',NULL,NULL,'1',10,NULL,'sms_api_key',70,20,'Ρυθμίσεις Αποστολής SMS','API Key :','text',235,166,300,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-09 17:28:11','globeadmin','2019-07-27 23:16:55','globeadmin','2019-07-27 23:23:30','globeadmin'),('570a05de3704db2','54a52c3dcf3610b',NULL,NULL,'1',10,NULL,'sms_gateway_id',30,20,'Ρυθμίσεις Αποστολής SMS','Λογαριασμός / Πάροχος : ','dropdown',92,70,220,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,name from sms_gateway;',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-10 10:50:54','globeadmin','2016-04-12 10:01:13','globeadmin','2019-07-27 23:23:30','globeadmin'),('570a09604f70645','54a52c3dcf3610b',NULL,NULL,'1',10,'select if(\'#nu_user_group#\'=\'globeadmin\',\'1\',\'0\')','sms_login_password_disp',80,20,'Ρυθμίσεις Αποστολής SMS','Κωδικός :','display',376,680,200,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select login_password \nfrom sms_gateway where active=1 \nlimit 1',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-10 11:05:52','globeadmin','2016-04-10 11:18:14','globeadmin','2019-07-27 23:23:30','globeadmin'),('570a0ac8ce64cfe','54a52c3dcf3610b',NULL,NULL,'1',10,'select if(\'#nu_user_group#\'=\'globeadmin\',\'1\',\'0\')','sms_gateway_id_disp',120,20,'Ρυθμίσεις Αποστολής SMS','Πάροχος : ','display',305,673,200,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select id \nfrom sms_gateway where active=1 \nlimit 1',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-10 11:11:52','globeadmin','2016-04-10 11:17:24','globeadmin','2019-07-27 23:23:31','globeadmin'),('570a0b25915bf1c','54a52c3dcf3610b',NULL,NULL,'1',10,'select if(\'#nu_user_group#\'=\'globeadmin\',\'1\',\'0\')','sms_login_name_disp',140,20,'Ρυθμίσεις Αποστολής SMS','Όνομα Χρήστη :','display',340,646,200,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select login_name\nfrom sms_gateway where active=1 \nlimit 1',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-10 11:13:25','globeadmin','2016-04-10 11:17:57','globeadmin','2019-07-27 23:23:31','globeadmin'),('570a1db90d86343','54a52c3dcf3610b',NULL,NULL,'1',10,NULL,'sms_settings_testbtn',140,20,'Ρυθμίσεις Αποστολής SMS','Αποστολή Test SMS','button',405,272,200,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'password',NULL,'',0,0,'2016-04-10 12:32:41','globeadmin','2016-04-12 10:34:40','globeadmin','2019-07-27 23:23:31','globeadmin'),('570a9a8f2641648','54a52c3dcf3610b',NULL,NULL,'1',10,NULL,'sms_originator',90,20,'Ρυθμίσεις Αποστολής SMS','Αποστολέας :','text',278,142,100,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-10 21:25:19','globeadmin','2016-04-10 21:43:19','globeadmin','2019-07-27 23:23:30','globeadmin'),('570a9c6e45fdf9f','54a52c3dcf3610b',NULL,NULL,'1',10,'select if(\'#nu_user_group#\'=\'globeadmin\',\'1\',\'0\')','sms_originator_disp',110,20,'Ρυθμίσεις Αποστολής SMS','Αποστολέας :','display',446,656,200,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select originator \nfrom sms_gateway where active=1 \nlimit 1',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-10 21:33:18','globeadmin','2016-04-10 21:33:18','globeadmin','2019-07-27 23:23:31','globeadmin'),('570aa0493004b26','54a52c3dcf3610b',NULL,NULL,'1',10,NULL,'sms_balance_disp',130,20,'Ρυθμίσεις Αποστολής SMS','Υπόλοιπο Μηνυμάτων :','iframe',327,88,80,50,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select originator \nfrom sms_gateway where active=1 \nlimit 1',NULL,NULL,'570a9f835bf5454','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-10 21:49:45','globeadmin','2016-04-10 22:05:42','globeadmin','2019-07-27 23:23:31','globeadmin'),('570fef6998a535c','5476201e5a3d38f',NULL,NULL,'0',10,'select if(student.phone1 !=\'\' and count(*)>0,\'1\',\'0\')\nfrom sms_gateway\ninner join student on student.id = \'#RECORD_ID#\'\nwhere active=1\n','send_sms_img_1',90,20,'Στοιχεία Επικοινωνίας',NULL,'html',409,307,34,31,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"this.style.cursor=\'pointer\';\"\n                            onmouseout=\"this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=30 height=30 id=\'img_modify11\' src=\'images/sms_icon.png\' title=\'Αποστολή SMS\'/>\n        </td>\n    </tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-14 22:28:41','globeadmin','2018-08-06 22:08:23','globeadmin','2022-01-08 11:22:27','globeadmin'),('570ff77876760cf','5476201e5a3d38f',NULL,NULL,'0',10,'select if(student.phone2 !=\'\' and count(*)>0,\'1\',\'0\')\nfrom sms_gateway\ninner join student on student.id = \'#RECORD_ID#\'\nwhere active=1\n','send_sms_img_2',100,20,'Στοιχεία Επικοινωνίας',NULL,'html',456,307,34,31,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"this.style.cursor=\'pointer\';\"\n                            onmouseout=\"this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=30 height=30 id=\'img_modify12\' src=\'images/sms_icon.png\' title=\'Αποστολή SMS\'/>\n        </td>\n    </tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-14 23:03:04','globeadmin','2018-08-06 22:03:29','globeadmin','2022-01-08 11:22:27','globeadmin'),('570ff79cc979f95','5476201e5a3d38f',NULL,NULL,'0',10,'select if(student.mobile !=\'\' and count(*)>0,\'1\',\'0\')\nfrom sms_gateway\ninner join student on student.id = \'#RECORD_ID#\'\nwhere active=1\n','send_sms_img_3',110,20,'Στοιχεία Επικοινωνίας',NULL,'html',503,307,34,31,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"this.style.cursor=\'pointer\';\"\n                            onmouseout=\"this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=30 height=30 id=\'img_modify13\' src=\'images/sms_icon.png\' title=\'Αποστολή SMS\'/>\n        </td>\n    </tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-14 23:03:40','globeadmin','2018-08-06 22:07:16','globeadmin','2022-01-08 11:22:27','globeadmin'),('570ff8ed36fe241','5476201e5a3d38f',NULL,NULL,'0',10,'select if(student.parent_phone1 != \'\' and count(*)>0,\'1\',\'0\')\nfrom sms_gateway\ninner join student ON student.id=\'#RECORD_ID#\'\nwhere active=1\n','send_sms_img_4',230,20,'Στοιχεία Επικοινωνίας',NULL,'html',409,826,30,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"this.style.cursor=\'pointer\';\"\n                            onmouseout=\"this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=30 height=30 id=\'img_modify21\' src=\'images/sms_icon.png\' title=\'Αποστολή SMS\'/>\n        </td>\n    </tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-14 23:09:17','globeadmin','2018-08-06 22:01:11','globeadmin','2022-01-08 11:22:28','globeadmin'),('570ff94f5447bcb','5476201e5a3d38f',NULL,NULL,'0',10,'select if(student.parent_phone2 !=\'\' and count(*)>0,\'1\',\'0\')\nfrom sms_gateway\ninner join student on student.id = \'#RECORD_ID#\'\nwhere active=1\n','send_sms_img_5',240,20,'Στοιχεία Επικοινωνίας',NULL,'html',456,822,31,31,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"this.style.cursor=\'pointer\';\"\n                            onmouseout=\"this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=30 height=30 id=\'img_modify22\' src=\'images/sms_icon.png\' title=\'Αποστολή SMS\'/>\n        </td>\n    </tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-14 23:10:55','globeadmin','2018-08-06 22:06:35','globeadmin','2022-01-08 11:22:28','globeadmin'),('570ff961ac2d540','5476201e5a3d38f',NULL,NULL,'0',10,'select if(student.parent_phone3!=\'\' and count(*)>0,\'1\',\'0\')\nfrom sms_gateway\ninner join student ON student.id=\'#RECORD_ID#\'\nwhere active=1\n','send_sms_img_6',250,20,'Στοιχεία Επικοινωνίας',NULL,'html',503,826,31,31,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"this.style.cursor=\'pointer\';\"\n                            onmouseout=\"this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=30 height=30 id=\'img_modify23\' src=\'images/sms_icon.png\' title=\'Αποστολή SMS\'/>\n        </td>\n    </tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-14 23:11:13','globeadmin','2018-08-06 21:59:58','globeadmin','2022-01-08 11:22:28','globeadmin'),('571237459006b15','547372d029461f4',NULL,NULL,'0',10,'select if(\'#phone1#\'!=\'\' and count(*)>0,\'1\',\'0\')\nfrom sms_gateway\nwhere active=1','send_sms_img_1',190,10,'Λεπτομέρειες',NULL,'html',412,833,34,31,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"this.style.cursor=\'pointer\';\"\n                            onmouseout=\"this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=30 height=30 id=\'img_modify1\' src=\'images/sms_icon.png\' title=\'Αποστολή SMS\'/>\n        </td>\n    </tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-16 15:59:49','globeadmin','2016-10-08 10:51:15','globeadmin','2021-01-26 20:15:04','globeadmin'),('5711e692d944c38','5711e1d915f5011',NULL,NULL,'1',10,NULL,'mobile_number',10,10,'Αποστολή SMS','Αριθμός Τηλεφώνου :','display',41,28,150,40,'r','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','SELECT sms_mobile_number \nFROM session_variables \nWHERE session_id=\'#session_id#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-16 10:15:30','globeadmin','2016-04-16 10:22:39','globeadmin','2021-03-24 11:17:50','globeadmin'),('5711e8d37049a22','5711e1d915f5011',NULL,NULL,'1',10,'select if(\'#nu_user_group#\'=\'globeadmin\',\'1\',\'0\')','max_num_of_chars',20,10,'Αποστολή SMS',NULL,'display',309,635,30,30,'r','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','SELECT 159-CHAR_LENGTH(short_name) \nFROM school\nWHERE id=1',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-16 10:25:07','globeadmin','2016-04-16 12:28:56','globeadmin','2021-03-24 11:17:50','globeadmin'),('57121fa51865ade','59d7d7da6d30b22',NULL,NULL,'1',10,NULL,'sms_disp',60,10,'Αποστολή και Αναζήτηση Μηνυμάτων','SMS Μηνύματα :','display',35,756,100,0,'r','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select CONCAT(count(*),\' / \',IF(\'#sms_limit#\'=\'\',\'UL\',\'#sms_limit#\'))\nfrom sms\nwhere sender_id=\'#RECORD_ID#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-04-16 14:19:01','globeadmin','2017-10-07 00:52:10','globeadmin','2017-11-12 16:23:42','globeadmin'),('5711eb0e4457b16','5711e1d915f5011',NULL,NULL,'1',10,NULL,'sms_text',30,10,'Αποστολή SMS',NULL,'textarea',92,15,650,180,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-16 10:34:38','globeadmin','2016-04-16 21:18:09','globeadmin','2021-03-24 11:17:50','globeadmin'),('5711f1311113c3b','5711e1d915f5011',NULL,NULL,'1',10,'select if(\'#nu_user_group#\'=\'globeadmin\',\'1\',\'0\')','label1',40,10,'Αποστολή SMS','Μήνυμα :','words',69,23,200,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-16 11:00:49','globeadmin','2016-04-16 11:01:49','globeadmin','2021-03-24 11:17:50','globeadmin'),('5711f712ea5bd6f','5711e1d915f5011',NULL,NULL,'1',10,NULL,'reciever_name',50,10,'Αποστολή SMS','Προς :','display',12,28,600,40,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','SELECT \n    concat(\n        if(student.id is NULL,\'\',\n            concat(\n                if(student.surname is NULL,\'\',concat(student.surname,\' \')),\n                if(student.name is NULL,\'\',concat(student.name,\' \')),\n                if(student.fathers_name is NULL,\'\',concat (\'πατ. \',student.fathers_name ))\n                )\n            ),\n        if(teacher.id is NULL,\'\',\n            concat(\n                if(teacher.surname is NULL,\'\',concat(teacher.surname,\' \')),\n                if(teacher.name is NULL,\'\',concat(teacher.name,\' \'))\n                )\n            )\n        )\nFROM session_variables\nleft join teacher on teacher.id = sms_teacher_id\nleft join student on student.id = sms_student_id\nWHERE session_id=\'#session_id#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-16 11:25:54','globeadmin','2016-04-16 12:17:57','globeadmin','2021-03-24 11:17:50','globeadmin'),('571205b24baad74','5711e1d915f5011',NULL,NULL,'1',10,NULL,'num_of_chars_left',60,10,'Αποστολή SMS',NULL,'text',280,635,30,30,'r','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-16 12:28:18','globeadmin','2016-04-16 12:40:26','globeadmin','2021-03-24 11:17:50','globeadmin'),('57121f817eefbe5','59d7d65650da67c',NULL,NULL,'1',10,NULL,'phone1',110,10,'Προσωπικά Στοιχεία','Σταθερό Τηλέφωνο :','text',174,551,150,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-04-16 14:18:25','globeadmin','2017-10-06 22:49:07','globeadmin','2018-07-28 00:38:24','globeadmin'),('57121fbf99cac55','59d7d65650da67c',NULL,NULL,'1',10,NULL,'mobile',120,10,'Προσωπικά Στοιχεία','Κινητό Τηλέφωνο :','text',218,562,150,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-04-16 14:19:27','globeadmin','2017-10-06 22:49:24','globeadmin','2018-07-28 00:38:24','globeadmin'),('5712249eafc3c53','59d7d65650da67c',NULL,NULL,'1',10,NULL,'phone2',130,10,'Προσωπικά Στοιχεία','Άλλο Τηλέφωνο :','text',267,571,150,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-04-16 14:40:14','globeadmin','2017-10-06 22:49:52','globeadmin','2018-07-28 00:38:25','globeadmin'),('5712276a8642f93','547372d029461f4',NULL,NULL,'1',10,NULL,'phone1',140,10,'Λεπτομέρειες','Σταθέρο Τηλέφωνο :','text',426,545,150,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-04-16 14:52:10','globeadmin','2016-04-16 14:55:21','globeadmin','2021-01-26 20:15:04','globeadmin'),('57122790cf80ff2','547372d029461f4',NULL,NULL,'1',10,NULL,'mobile',150,10,'Λεπτομέρειες','Κινητό Τηλέφωνο :','text',482,555,150,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-04-16 14:52:48','globeadmin','2016-04-16 14:55:56','globeadmin','2021-01-26 20:15:04','globeadmin'),('571227b16414ba0','547372d029461f4',NULL,NULL,'1',10,NULL,'phone2',160,10,'Λεπτομέρειες','Άλλο Τηλέφωνο :','text',537,564,150,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-04-16 14:53:21','globeadmin','2016-04-16 14:55:38','globeadmin','2021-01-26 20:15:04','globeadmin'),('571227de249b09c','547372d029461f4',NULL,NULL,'1',10,NULL,'sms_disp',170,10,'Λεπτομέρειες','Σταλθέντα SMS Μηνυμάτα :','display',292,591,60,0,'r','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select count(*)\nfrom sms\nwhere sender_id=\'#RECORD_ID#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-04-16 14:54:06','globeadmin','2016-04-16 21:29:43','globeadmin','2021-01-26 20:15:04','globeadmin'),('57122a2d2e5ee8f','547372d029461f4',NULL,NULL,'1',10,NULL,'sms_limit',180,10,'Λεπτομέρειες','Όριο SMS Μηνυμάτων :','text',345,614,60,0,'r','0','0','select \'0\'','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-04-16 15:03:57','globeadmin','2017-11-16 08:30:15','globeadmin','2021-01-26 20:15:04','globeadmin'),('571237a9c34bd78','547372d029461f4',NULL,NULL,'0',10,'select if(\'#mobile#\'!=\'\' and count(*)>0,\'1\',\'0\')\nfrom sms_gateway\nwhere active=1\n','send_sms_img_2',200,10,'Λεπτομέρειες',NULL,'html',468,833,34,31,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"this.style.cursor=\'pointer\';\"\n                            onmouseout=\"this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=30 height=30 id=\'img_modify2\' src=\'images/sms_icon.png\' title=\'Αποστολή SMS\'/>\n        </td>\n    </tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-16 16:01:29','globeadmin','2016-10-08 10:51:34','globeadmin','2021-01-26 20:15:04','globeadmin'),('571237ed556ef4e','547372d029461f4',NULL,NULL,'0',10,'select if(\'#phone2#\'!=\'\' and count(*)>0,\'1\',\'0\')\nfrom sms_gateway\nwhere active=1\n','send_sms_img_3',210,10,'Λεπτομέρειες',NULL,'html',523,833,34,31,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"this.style.cursor=\'pointer\';\"\n                            onmouseout=\"this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=30 height=30 id=\'img_modify3\' src=\'images/sms_icon.png\' title=\'Αποστολή SMS\'/>\n        </td>\n    </tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-16 16:02:37','globeadmin','2016-10-08 10:51:52','globeadmin','2021-01-26 20:15:04','globeadmin'),('571280cab6b261c','5711e1d915f5011',NULL,NULL,'1',10,NULL,'sms_disp',70,10,'Αποστολή SMS','Υπόλοιπο Μηνυμάτων :','display',292,24,60,0,'r','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select IF(\'#sms_limit#\'=\'\',\'UL\',\'#sms_limit#\'-count(*))\nfrom sms\nwhere sender_id=\'#RECORD_ID#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-04-16 21:13:30','globeadmin','2016-04-16 21:21:15','globeadmin','2021-03-24 11:17:50','globeadmin'),('57134f66c509d61','5618f5cc92f9c9e',NULL,NULL,'0',10,'select if(  \'#nu_user_group#\'=\'globeadmin\' or \n            \'#nu_user_group#\'=\'Administrators\' or \n            \'#nu_user_group#\'=\'Managers\' or \n            \'#nu_user_group#\'=\'AssistManagers\',\'1\',\'0\')','subject_homebtnimg',80,10,'Αρχικό Μενού',NULL,'html',192,687,220,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_subles_id\').src=\'images/sublesb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_subles_id\').src=\'images/subles.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=98 height=74 id=\'img_subles_id\' src=\'images/subles.png\' title=\'Θέματα που αφορούν τα μαθήματα τις διδασκαλίες και το ωρολόγιο πρόγραμμα\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Μαθήματα και Διδασκαλίες</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-17 11:55:02','globeadmin','2017-10-28 20:26:58','globeadmin','2022-11-30 11:53:03','globeadmin'),('5713df4ede0827d','5713df2963f613a',NULL,NULL,'1',10,NULL,'from_date',20,10,'Αναζήτηση','Από : ','text',45,18,80,30,'r','0','0','select curdate()','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2016-04-17 22:09:02','globeadmin','2016-04-17 22:59:33','globeadmin','2019-07-27 13:10:00','globeadmin'),('5713df6ba100abe','5713df2963f613a',NULL,NULL,'1',10,NULL,'to_date',30,10,'Αναζήτηση','Έως : ','text',45,152,80,30,'r','0','0','select curdate()','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2016-04-17 22:09:31','globeadmin','2016-07-07 23:40:40','globeadmin','2019-07-27 13:10:00','globeadmin'),('5713e65a94ca415','5713df2963f613a',NULL,NULL,'1',10,NULL,'state',40,10,'Αναζήτηση','Κατάσταση Μηνύματος :','dropdown',43,287,150,30,'l','0','0','select #RECORD_ID#','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'1|Στάλθηκε|2|Παραδόθηκε|3|Απέτυχε',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-17 22:39:06','globeadmin','2016-07-07 23:40:40','globeadmin','2019-07-27 13:10:00','globeadmin'),('5713dfb4024fe89','5713df2963f613a',NULL,NULL,'1',10,NULL,'student_id',60,10,'Αναζήτηση','Παραλήπτης Μαθητής : ','dropdown',79,17,300,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select distinct student.id, concat(ifNULL(grade.short_name,\'\'),\' - \',student.surname,\' \',student.name,\' \',student.fathers_name) \nfrom student\nleft join grade on grade.id = student.grade_id\nleft join (    select distinct student_id as s_id\n                            from student_class\n                            inner join card ON card.class_id=student_class.class_id\n                            where\n                                card.valid_from=(select max(start_date) from timetable) and   \n                                card.teacher_id=\'#RECORD_ID#\') as s ON s.s_id = student.id\nwhere\n        \'#nu_user_group#\'=\'globeadmin\' OR \n        \'#nu_user_group#\'=\'Administrators\' OR \n        \'#nu_user_group#\'=\'Managers\' OR \n        \'#nu_user_group#\'=\'AssistManagers\' OR\n        \'#nu_user_group#\'=\'Secretaries\' OR\n        s.s_id is not null OR\n        student.teacher_id = \'#RECORD_ID#\'\norder by student.grade_id,student.surname,student.name,student.fathers_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-17 22:10:44','globeadmin','2016-07-21 01:05:27','globeadmin','2019-07-27 13:10:00','globeadmin'),('5713dfd2bbdbb76','5713df2963f613a',NULL,NULL,'1',10,NULL,'teacher_id',70,10,'Αναζήτηση','Παραλήπτης Καθηγητής :','dropdown',79,529,250,30,'l','0','0','select #RECORD_ID#','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select  id,\n        concat(if(surname is null,\'\',concat(surname,\' \')), IFNULL(name,\'\')) as teacher_full_name\nfrom teacher\norder by teacher_full_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-17 22:11:14','globeadmin','2016-07-07 23:40:40','globeadmin','2019-07-27 13:10:00','globeadmin'),('5713dff1247df78','5713df2963f613a',NULL,NULL,'1',10,NULL,'label1',10,10,'Αναζήτηση','Επιλέξτε από τα παρακάτω κριτήρια αναζήτησης. Αφήνοντας κενό ένα κριτήριο, εμφανίζονται όλα τα αντίστοιχα SMS.','words',11,11,750,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from class order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-17 22:11:45','globeadmin','2016-04-17 23:18:47','globeadmin','2019-07-27 13:10:00','globeadmin'),('5713e01c57c137f','5713df2963f613a',NULL,NULL,'1',10,'select if(\'#nu_user_group#\'=\'globeadmin\',\'1\',\'0\')','current_date',90,10,'Αναζήτηση','Τρέχουσα Ημ/νια : ','display',114,734,80,30,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select DATE_FORMAT(curdate(),\'%d-%m-%Y\')',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-17 22:12:28','globeadmin','2016-07-07 23:40:40','globeadmin','2019-07-27 13:10:00','globeadmin'),('5713e0668fea02a','5713df2963f613a',NULL,NULL,'1',10,NULL,'search_iframe',100,10,'Αναζήτηση',NULL,'iframe',160,20,900,350,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from teacher order by short_name',NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-17 22:13:42','globeadmin','2018-07-13 09:42:30','globeadmin','2019-07-27 13:10:01','globeadmin'),('5713e0816dba8b3','5713df2963f613a',NULL,NULL,'1',10,NULL,'searchbtn',80,10,'Αναζήτηση','Αναζήτηση','button',114,46,150,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from teacher order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-17 22:14:09','globeadmin','2016-07-07 23:40:40','globeadmin','2019-07-27 13:10:36','globeadmin'),('571d201c2acf0f6','552cf4b2df9bcce',NULL,NULL,'1',10,NULL,'sms_disp',20,10,'Ενημέρωση για τις Απουσίες','Υπόλοιπο SMS Μηνυμάτων :','display',16,730,60,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select IF(\'#sms_limit#\'=\'\',\'UL\',\'#sms_limit#\'-count(*))\nfrom sms\nwhere sender_id=\'#RECORD_ID#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-04-24 22:35:56','globeadmin','2018-06-28 21:36:16','globeadmin','2021-09-07 20:55:37','globeadmin'),('5713e3a4750d245','5713df2963f613a',NULL,NULL,'1',10,'select if(\'#nu_user_group#\'=\'globeadmin\' or \n        \'#nu_user_group#\'=\'Administrators\' or \n        \'#nu_user_group#\'=\'Managers\' or \n        \'#nu_user_group#\'=\'AssistManagers\',\'1\',\'0\')','sender_id',50,10,'Αναζήτηση','Αποστολέας :','dropdown',43,597,250,30,'l','0','0','select #RECORD_ID#','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select  id,\n        concat(if(surname is null,\'\',concat(surname,\' \')), IFNULL(name,\'\')) as teacher_full_name\nfrom teacher\nWHERE ( \'#nu_user_group#\'=\'globeadmin\' or \n        \'#nu_user_group#\'=\'Administrators\' or \n        \'#nu_user_group#\'=\'Managers\' or \n        \'#nu_user_group#\'=\'AssistManagers\')\n        OR id=\'#RECORD_ID#\'\norder by teacher_full_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-17 22:27:32','globeadmin','2016-07-20 19:55:12','globeadmin','2019-07-27 13:10:00','globeadmin'),('5717de59b10525a','5476201e5a3d38f',NULL,NULL,'1',10,NULL,'parent_user_id',110,10,'Στοιχεία Μαθητή','Όνομα Χρήστη Γονέα :','dropdown',562,59,150,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select \n	zzzsys_user_id,\n	sus_login_name \nfrom zzzsys_user \nwhere \n	zzzsys_user_id not in (select parent_user_id from student where id<>\'#RECORD_ID#\' and parent_user_id is not NULL) and\n	sus_zzzsys_user_group_id in (select zzzsys_user_group_id from zzzsys_user_group where sug_code=\'Parents\')',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-04-20 22:54:01','globeadmin','2016-07-22 00:12:31','globeadmin','2022-01-08 11:22:26','globeadmin'),('57166a8465f101f','547372d029461f4',NULL,NULL,'1',10,NULL,'last_login_disp',220,10,'Λεπτομέρειες','Τελευταία Σύνδεση :','display',71,547,150,0,'r','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','SELECT ifNULL(DATE_FORMAT(max(zzzsys_user_log.sul_start),\'%d-%m-%Y %H:%i:%s\'),\'N/A\')\nFROM teacher\nLEFT JOIN  zzzsys_user_log ON  teacher.user_id = zzzsys_user_log.sul_zzzsys_user_id\nWHERE teacher.id = \"#RECORD_ID#\"',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-04-19 20:27:32','globeadmin','2018-07-30 10:15:20','globeadmin','2021-01-26 20:15:04','globeadmin'),('57166e814634454','5476201e5a3d38f',NULL,NULL,'1',10,NULL,'last_login_disp',100,10,'Στοιχεία Μαθητή','Τελευταία Σύνδεση Μαθητή :','display',502,25,150,0,'r','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','SELECT ifNULL(DATE_FORMAT(max(zzzsys_user_log.sul_start),\'%d-%m-%Y %H:%i:%s\'),\'N/A\')\nFROM student\nLEFT JOIN  zzzsys_user_log ON  student.user_id = zzzsys_user_log.sul_zzzsys_user_id\nWHERE student.id = \"#RECORD_ID#\"',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-04-19 20:44:33','globeadmin','2018-07-30 09:57:37','globeadmin','2022-01-08 11:22:26','globeadmin'),('5717dedb851315a','5476201e5a3d38f',NULL,NULL,'1',10,NULL,'last_parent_login_disp',120,10,'Στοιχεία Μαθητή','Τελευταία Σύνδεση Γονέα :','display',594,36,150,0,'r','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','SELECT ifNULL(DATE_FORMAT(max(zzzsys_user_log.sul_start),\'%d-%m-%Y %H:%i:%s\'),\'N/A\')\nFROM student\nLEFT JOIN  zzzsys_user_log ON  student.parent_user_id = zzzsys_user_log.sul_zzzsys_user_id\nWHERE student.id = \"#RECORD_ID#\"',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-04-20 22:56:11','globeadmin','2018-07-30 09:58:49','globeadmin','2022-01-08 11:22:26','globeadmin'),('5719d606da86bce','5719cb61e92d4e8',NULL,NULL,'1',10,NULL,'search_iframe',60,10,'Μαζική Αποστολή SMS',NULL,'iframe',225,20,900,350,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from teacher order by short_name',NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-22 10:43:02','globeadmin','2018-07-01 00:49:04','globeadmin','2021-03-24 11:18:49','globeadmin'),('571a7a4af0787b3','5719cb61e92d4e8',NULL,NULL,'1',10,NULL,'student_id',40,10,'Μαζική Αποστολή SMS','Μαθητής : ','listbox',170,263,350,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select distinct student.id, concat(ifNULL(grade.short_name,\'\'),\' - \',student.surname,\' \',student.name,\' \',student.fathers_name) \nfrom student\nleft join grade on grade.id = student.grade_id\nleft join (    select distinct student_id as s_id\n                            from student_class\n                            inner join card ON card.class_id=student_class.class_id\n                            where\n                                card.valid_from=(select max(start_date) from timetable) and   \n                                card.teacher_id=\'#RECORD_ID#\') as s ON s.s_id = student.id\nwhere\n        \'#nu_user_group#\'=\'globeadmin\' OR \n        \'#nu_user_group#\'=\'Administrators\' OR \n        \'#nu_user_group#\'=\'Managers\' OR \n        \'#nu_user_group#\'=\'AssistManagers\' OR\n        \'#nu_user_group#\'=\'Secretaries\' OR\n        s.s_id is not null OR\n        student.teacher_id = \'#RECORD_ID#\'\norder by student.grade_id,student.surname,student.name,student.fathers_name',NULL,'','','select distinct student.id, concat(ifNULL(grade.short_name,\'\'),\' - \',student.surname,\' \',student.name,\' \',student.fathers_name) \nfrom student\nleft join grade on grade.id = student.grade_id\nleft join (    select distinct student_id as s_id\n                            from student_class\n                            inner join card ON card.class_id=student_class.class_id\n                            where\n                                card.valid_from=(select max(start_date) from timetable) and   \n                                card.teacher_id=\'#RECORD_ID#\') as s ON s.s_id = student.id\nwhere\n        \'#nu_user_group#\'=\'globeadmin\' OR \n        \'#nu_user_group#\'=\'Administrators\' OR \n        \'#nu_user_group#\'=\'Managers\' OR \n        \'#nu_user_group#\'=\'AssistManagers\' OR\n        \'#nu_user_group#\'=\'Secretaries\' OR\n        \'#nu_user_group#\'=\'Psychologists\' OR\n        s.s_id is not null OR\n        student.teacher_id = \'#RECORD_ID#\' OR\n        student.advisor_id = \'#RECORD_ID#\'\norder by student.grade_id,student.surname,student.name,student.fathers_name',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-22 22:23:55','globeadmin','2021-03-09 15:15:21','globeadmin','2021-03-24 11:18:49','globeadmin'),('571a7ab92f999b5','5719cb61e92d4e8',NULL,NULL,'1',10,NULL,'class_id',30,10,'Μαζική Αποστολή SMS','Τμήμα : ','listbox',170,28,150,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select distinct class.id,class.short_name \nfrom class\ninner join student_class on class.id=student_class.class_id\nleft join ( select distinct class_id as c_id\n            from card\n            where   card.valid_from=(select max(start_date) from timetable) and \n                    card.teacher_id=\'#RECORD_ID#\') as c ON c.c_id=class.id\nleft join ( select class.id as c_id\n            from class\n            where\n                (   select count(*)\n                    from student \n                    inner join student_class ON student.id=student_class.student_id\n                    where \n                    teacher_id=\'#RECORD_ID#\' AND\n                    student_class.class_id = class.id) = (select count(*) from student_class where class_id=class.id)\n                ) as c1 ON c1.c_id=class.id\nwhere   \'#nu_user_group#\'=\'globeadmin\' OR \n        \'#nu_user_group#\'=\'Administrators\' OR \n        \'#nu_user_group#\'=\'Managers\' OR \n        \'#nu_user_group#\'=\'AssistManagers\' OR\n        \'#nu_user_group#\'=\'Secretaries\' OR\n        c.c_id IS NOT NULL OR\n        c1.c_id IS NOT NULL \norder by class.short_name',NULL,'','','select distinct class.id,class.short_name \nfrom class\ninner join student_class on class.id=student_class.class_id\nleft join ( select distinct class_id as c_id\n            from card\n            where   card.valid_from=(select max(start_date) from timetable) and \n                    card.teacher_id=\'#RECORD_ID#\') as c ON c.c_id=class.id\nleft join ( select class.id as c_id\n            from class\n            where\n                (   select count(*)\n                    from student \n                    inner join student_class ON student.id=student_class.student_id\n                    where \n                    teacher_id=\'#RECORD_ID#\' AND\n                    student_class.class_id = class.id) = (select count(*) from student_class where class_id=class.id)\n                ) as c1 ON c1.c_id=class.id\nwhere   \'#nu_user_group#\'=\'globeadmin\' OR \n        \'#nu_user_group#\'=\'Administrators\' OR \n        \'#nu_user_group#\'=\'Managers\' OR \n        \'#nu_user_group#\'=\'AssistManagers\' OR\n        \'#nu_user_group#\'=\'Secretaries\' OR\n        \'#nu_user_group#\'=\'Psychologists\' OR\n        c.c_id IS NOT NULL OR\n        c1.c_id IS NOT NULL\norder by class.short_name',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-22 22:25:45','globeadmin','2021-03-09 15:15:01','globeadmin','2021-03-24 11:18:49','globeadmin'),('571a7b270d6b97e','5719cb61e92d4e8',NULL,NULL,'1',10,NULL,'label1',10,10,'Μαζική Αποστολή SMS','Μήνυμα :','words',17,23,750,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from class order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-22 22:27:35','globeadmin','2016-04-23 11:22:43','globeadmin','2021-03-24 11:18:48','globeadmin'),('571b323c8691dbb','5719cb61e92d4e8',NULL,NULL,'1',10,'select if(\'#nu_user_group#\'=\'globeadmin\',\'1\',\'0\')','max_num_of_chars',80,10,'Μαζική Αποστολή SMS',NULL,'display',175,888,30,30,'r','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','SELECT 159-CHAR_LENGTH(short_name) \nFROM school\nWHERE id=1',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-23 11:28:44','globeadmin','2016-04-23 11:28:44','globeadmin','2021-03-24 11:18:49','globeadmin'),('571a7b74da801e1','5719cb61e92d4e8',NULL,NULL,'1',10,NULL,'searchbtn',50,10,'Μαζική Αποστολή SMS','Εμφάνιση Μαθητών','button',162,716,150,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from teacher order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-22 22:28:52','globeadmin','2016-04-23 11:22:43','globeadmin','2021-03-24 11:18:49','globeadmin'),('571b31cacd606c2','5719cb61e92d4e8',NULL,NULL,'1',10,NULL,'sms_disp',70,10,'Μαζική Αποστολή SMS','Υπόλοιπο Μηνυμάτων :','display',13,720,60,0,'r','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select IF(\'#sms_limit#\'=\'\',\'UL\',\'#sms_limit#\'-count(*))\nfrom sms\nwhere sender_id=\'#RECORD_ID#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-04-23 11:26:50','globeadmin','2016-04-23 11:26:50','globeadmin','2021-03-24 11:18:49','globeadmin'),('571b2cc6709a7ec','5719cb61e92d4e8',NULL,NULL,'1',10,NULL,'sms_text',20,10,'Μαζική Αποστολή SMS',NULL,'textarea',40,20,900,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-23 11:05:26','globeadmin','2016-04-23 11:23:14','globeadmin','2021-03-24 11:18:49','globeadmin'),('571b328ddc066d5','5719cb61e92d4e8',NULL,NULL,'1',10,NULL,'num_of_chars_left',90,10,'Μαζική Αποστολή SMS',NULL,'text',147,886,30,30,'r','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-23 11:30:05','globeadmin','2016-04-23 11:30:05','globeadmin','2021-03-24 11:18:49','globeadmin'),('571bae8219a3c68','571bae293e43d23',NULL,NULL,'1',10,NULL,'label1',10,10,'Μαζική Αποστολή SMS','Μήνυμα :','words',17,23,750,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from class order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-23 20:18:58','globeadmin','2016-04-23 20:18:58','globeadmin','2021-03-24 11:22:34','globeadmin'),('571baea2da82420','571bae293e43d23',NULL,NULL,'1',10,NULL,'sms_text',20,10,'Μαζική Αποστολή SMS',NULL,'textarea',40,20,900,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-23 20:19:30','globeadmin','2016-04-23 20:19:30','globeadmin','2021-03-24 11:22:34','globeadmin'),('571baec6802d9b9','571bae293e43d23',NULL,NULL,'1',10,NULL,'select_teaching_field_id',40,10,'Μαζική Αποστολή SMS','Ειδικότητα : ','listbox',170,377,250,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select  id,\n        concat(if(short_name is null,\'\',concat(short_name,\'-\')), IFNULL(name,\'\'))\nfrom teaching_field\norder by short_name',NULL,'','','select  id,\n        concat(if(short_name is null,\'\',concat(short_name,\'-\')), IFNULL(name,\'\'))\nfrom teaching_field\norder by short_name',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-23 20:20:06','globeadmin','2017-03-18 16:24:08','globeadmin','2021-03-24 11:22:34','globeadmin'),('571baee74a78fde','571bae293e43d23',NULL,NULL,'1',10,NULL,'teacher_id',30,10,'Μαζική Αποστολή SMS','Καθηγητής : ','listbox',170,29,250,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select  id,\n        concat(if(surname is null,\'\',concat(surname,\' \')), IFNULL(name,\'\')) as teacher_full_name\nfrom teacher\norder by teacher_full_name',NULL,'','','select  id,\n        concat(if(surname is null,\'\',concat(surname,\' \')), IFNULL(name,\'\')) as teacher_full_name\nfrom teacher\norder by teacher_full_name',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-23 20:20:39','globeadmin','2017-03-18 16:24:26','globeadmin','2021-03-24 11:22:34','globeadmin'),('571bcdb098975dd','571354ed43a4d47',NULL,NULL,'0',10,NULL,'btnimg1',10,10,'SMS - Email',NULL,'html',50,73,220,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'sms_search_id\').src=\'images/sms_searchb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'sms_search_id\').src=\'images/sms_search.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'sms_search_id\' src=\'images/sms_search.png\' title=\'Αναζήτηση Σταλθέντων SMS\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Αναζήτηση Σταλθέντων SMS</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-23 22:32:00','globeadmin','2017-10-28 22:07:24','globeadmin','2017-11-12 16:18:14','globeadmin'),('571baf099145e78','571bae293e43d23',NULL,NULL,'1',10,NULL,'searchbtn',50,10,'Μαζική Αποστολή SMS','Εμφάνιση Καθηγητών','button',162,719,150,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from teacher order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-23 20:21:13','globeadmin','2016-04-23 20:41:28','globeadmin','2021-03-24 11:22:34','globeadmin'),('571baf42543cc5f','571bae293e43d23',NULL,NULL,'1',10,NULL,'search_iframe',60,10,'Μαζική Αποστολή SMS',NULL,'iframe',223,20,900,350,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from teacher order by short_name',NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-23 20:22:10','globeadmin','2018-07-01 00:50:10','globeadmin','2021-03-24 11:22:34','globeadmin'),('571baf651e86684','571bae293e43d23',NULL,NULL,'1',10,NULL,'sms_disp',70,10,'Μαζική Αποστολή SMS','Υπόλοιπο Μηνυμάτων :','display',13,720,60,0,'r','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select IF(\'#sms_limit#\'=\'\',\'UL\',\'#sms_limit#\'-count(*))\nfrom sms\nwhere sender_id=\'#RECORD_ID#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-04-23 20:22:45','globeadmin','2016-04-23 20:22:45','globeadmin','2021-03-24 11:22:34','globeadmin'),('571baf86cbdc56a','571bae293e43d23',NULL,NULL,'1',10,'select if(\'#nu_user_group#\'=\'globeadmin\',\'1\',\'0\')','max_num_of_chars',80,10,'Μαζική Αποστολή SMS',NULL,'display',175,888,30,30,'r','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','SELECT 159-CHAR_LENGTH(short_name) \nFROM school\nWHERE id=1',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-23 20:23:18','globeadmin','2016-04-23 20:23:18','globeadmin','2021-03-24 11:22:34','globeadmin'),('571bafaf01395da','571bae293e43d23',NULL,NULL,'1',10,NULL,'num_of_chars_left',90,10,'Μαζική Αποστολή SMS',NULL,'text',147,886,30,30,'r','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-23 20:23:59','globeadmin','2016-04-23 20:23:59','globeadmin','2021-03-24 11:22:34','globeadmin'),('571fb940374aa1f','5476201e5a3d38f',NULL,NULL,'0',10,'select if((student.user_id IS NULL) and (\'#nu_user_group#\'=\'globeadmin\' or \'#nu_user_group#\'=\'Administrators\' or \'#nu_user_group#\'=\'Managers\' or \'#nu_user_group#\'=\'AssistManagers\') and \'#RECORD_ID#\'<>\'-1\',\'1\',\'0\')\nfrom school\nleft join student ON student.id=\'#RECORD_ID#\'\nwhere school.id=\'1\'','add_userbtn',190,10,'Στοιχεία Μαθητή',NULL,'html',463,359,20,20,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"this.style.cursor=\'pointer\';\"\n                            onmouseout=\"this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=18 height=18 id=\'img_add_user\' src=\'images/add.png\' title=\'Δημιουργία Λογαριασμού για το Μαθητή\'/>\n        </td>\n    </tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-26 21:53:52','globeadmin','2017-11-29 21:44:51','globeadmin','2022-01-08 11:22:26','globeadmin'),('571bce0c6f17fda','571354ed43a4d47',NULL,NULL,'0',10,NULL,'btnimg2',20,10,'SMS - Email',NULL,'html',50,380,220,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'students_sms_id\').src=\'images/students_smsb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'students_sms_id\').src=\'images/students_sms.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'students_sms_id\' src=\'images/students_sms.png\' title=\'Μαζική Αποστολή SMS σε Μαθητές - Γονείς\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Αποστολή SMS σε Μαθητές - Γονείς</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-23 22:33:32','globeadmin','2018-03-10 19:11:16','globeadmin','2018-03-10 19:11:16','globeadmin'),('571bce1c25d9f1d','571354ed43a4d47',NULL,NULL,'0',10,NULL,'btnimg3',30,10,'SMS - Email',NULL,'html',50,687,220,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'teachers_sms_id\').src=\'images/teachers_smsb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'teachers_sms_id\').src=\'images/teachers_sms.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'teachers_sms_id\' src=\'images/teachers_sms.png\' title=\'Μαζική Αποστολή SMS σε Καθηγητές\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Αποστολή SMS σε Καθηγητές</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-23 22:33:48','globeadmin','2017-10-28 22:07:24','globeadmin','2018-03-10 19:08:27','globeadmin'),('571bce2b8c63d04','571354ed43a4d47',NULL,NULL,'0',10,NULL,'btnimg4',50,10,'SMS - Email',NULL,'html',192,380,220,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'students_email_id\').src=\'images/students_emailb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'students_email_id\').src=\'images/students_email.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'students_email_id\' src=\'images/students_email.png\' title=\'Μαζική Αποστολή Email σε Μαθητές - Γονείς\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Αποστολή Email σε Μαθητές - Γονείς</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-23 22:34:03','globeadmin','2018-03-10 19:10:34','globeadmin','2018-03-10 19:10:34','globeadmin'),('571bce3cd5a1e48','571354ed43a4d47',NULL,NULL,'0',10,NULL,'btnimg5',60,10,'SMS - Email',NULL,'html',192,687,220,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'teachers_email_id\').src=\'images/teachers_emailb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'teachers_email_id\').src=\'images/teachers_email.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'teachers_email_id\' src=\'images/teachers_email.png\' title=\'Μαζική Αποστολή Email σε Καθηγητές\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Αποστολή Email σε Καθηγητές</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-23 22:34:20','globeadmin','2017-10-28 22:07:24','globeadmin','2018-03-10 19:09:22','globeadmin'),('571face1745391f','5476201e5a3d38f',NULL,NULL,'0',10,'select if((student.parent_user_id IS NOT NULL) and (\'#nu_user_group#\'=\'globeadmin\' or \'#nu_user_group#\'=\'Administrators\' or \'#nu_user_group#\'=\'Managers\' or \'#nu_user_group#\'=\'AssistManagers\') and \'#RECORD_ID#\'<>\'-1\',\'1\',\'0\')\nfrom school\nleft join student ON student.id=\'#RECORD_ID#\'\nwhere school.id=\'1\'','edit_parent_usertbtn',210,10,'Στοιχεία Μαθητή',NULL,'html',561,359,20,20,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"this.style.cursor=\'pointer\';\"\n                            onmouseout=\"this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=16 height=16 id=\'img_modify_parent_user\' src=\'images/modify.png\' title=\'Επεξεργασία Χρήστη Γονέα\'/>\n        </td>\n    </tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-26 21:01:05','globeadmin','2017-11-29 21:49:03','globeadmin','2022-01-08 11:22:26','globeadmin'),('571e6e2dbeafe20','54a6fde1ab6eb6d',NULL,NULL,'0',10,NULL,'parent_change_account',120,10,'Στοιχεία Μαθητή',NULL,'html',348,283,200,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0  \n                            onmouseover=\"document.getElementById(\'img_log_user_id\').src=\'images/log_userb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_log_user_id\').src=\'images/log_user.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_log_user_id\' src=\'images/log_user.png\' title=\'Αλλαγή Κωδικού Πρόσβασης\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Ο Λογαριασμός μου</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-25 22:21:17','globeadmin','2017-10-21 11:01:07','globeadmin','2021-09-06 20:12:22','globeadmin'),('59eaff3f5583afa','59e23027879009a',NULL,NULL,'0',10,NULL,'teachers_imgbtn',80,10,'Σχολείο',NULL,'html',310,706,220,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_teach_id\').src=\'images/teachb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_teach_id\').src=\'images/teach.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_teach_id\' src=\'images/teach.png\' title=\'Ημέρες και Ώρες Ενημέρωσης από τους Καθηγητές\'/>\n            <img /> \n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Ώρες Ενημέρωσης απο τους Καθηγητές</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-21 11:03:11','globeadmin','2017-10-21 11:03:11','globeadmin','2018-07-25 14:00:10','globeadmin'),('571e77f3645c4c1','5476201e5a3d38f',NULL,NULL,'0',10,'select if((student.parent_user_id IS NULL) and (\'#nu_user_group#\'=\'globeadmin\' or \'#nu_user_group#\'=\'Administrators\' or \'#nu_user_group#\'=\'Managers\' or \'#nu_user_group#\'=\'AssistManagers\') and \'#RECORD_ID#\'<>\'-1\',\'1\',\'0\')\nfrom school\nleft join student ON student.id=\'#RECORD_ID#\'\nwhere school.id=\'1\'','add_parentbtn',200,10,'Στοιχεία Μαθητή',NULL,'html',561,359,20,20,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"this.style.cursor=\'pointer\';\"\n                            onmouseout=\"this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=18 height=18 id=\'img_add_parent_user\' src=\'images/add.png\' title=\'Δημιουργία Λογαριασμού για το Γονέα\'/>\n        </td>\n    </tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-25 23:02:59','globeadmin','2017-11-29 21:48:23','globeadmin','2022-01-08 11:22:26','globeadmin'),('571fb96998f29ff','5476201e5a3d38f',NULL,NULL,'0',10,'select if((student.user_id IS NOT NULL) and (\'#nu_user_group#\'=\'globeadmin\' or \'#nu_user_group#\'=\'Administrators\' or \'#nu_user_group#\'=\'Managers\' or \'#nu_user_group#\'=\'AssistManagers\') and \'#RECORD_ID#\'<>\'-1\',\'1\',\'0\')\nfrom school\nleft join student ON student.id=\'#RECORD_ID#\'\nwhere school.id=\'1\'','edit_usertbtn',220,10,'Στοιχεία Μαθητή',NULL,'html',463,359,20,20,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"this.style.cursor=\'pointer\';\"\n                            onmouseout=\"this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=16 height=16 id=\'img_modify_user\' src=\'images/modify.png\' title=\'Επεξεργασία Χρήστη Μαθητή\'/>\n        </td>\n    </tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-26 21:54:33','globeadmin','2017-11-29 21:45:53','globeadmin','2022-01-08 11:22:26','globeadmin'),('5720b2ff439779e','547372d029461f4',NULL,NULL,'0',10,'select if((teacher.user_id IS NOT NULL) and (\'#nu_user_group#\'=\'globeadmin\' or \'#nu_user_group#\'=\'Administrators\' or \'#nu_user_group#\'=\'Managers\') and \'#RECORD_ID#\'<>\'-1\',\'1\',\'0\')\nfrom school\nleft join teacher ON teacher.id=\'#RECORD_ID#\'\nwhere school.id=\'1\'','reset_user_passbtn',230,10,'Λεπτομέρειες',NULL,'html',35,871,20,20,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"this.style.cursor=\'pointer\';\"\n                            onmouseout=\"this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=18 height=18 id=\'img_reset_pass\' src=\'images/reset_pass.png\' title=\'Επαναφόρα Password\'/>\n        </td>\n    </tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-27 15:39:27','globeadmin','2017-11-29 21:36:14','globeadmin','2021-01-26 20:15:04','globeadmin'),('5721031ea17170b','5476201e5a3d38f',NULL,NULL,'0',10,'select if((student.user_id IS NOT NULL) and (\'#nu_user_group#\'=\'globeadmin\' or \'#nu_user_group#\'=\'Administrators\' or \'#nu_user_group#\'=\'Managers\' or \'#nu_user_group#\'=\'AssistManagers\') and \'#RECORD_ID#\'<>\'-1\',\'1\',\'0\')\nfrom school\nleft join student ON student.id=\'#RECORD_ID#\'\nwhere school.id=\'1\'','reset_user_passbtn',230,10,'Στοιχεία Μαθητή',NULL,'html',463,393,20,20,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"this.style.cursor=\'pointer\';\"\n                            onmouseout=\"this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=18 height=18 id=\'img_reset_pass\' src=\'images/reset_pass.png\' title=\'Επαναφόρα Password Μαθητή\'/>\n        </td>\n    </tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-27 21:21:18','globeadmin','2017-11-29 21:46:26','globeadmin','2022-01-08 11:22:26','globeadmin'),('572104368905f9d','5476201e5a3d38f',NULL,NULL,'0',10,'select if((student.parent_user_id IS NOT NULL) and (\'#nu_user_group#\'=\'globeadmin\' or \'#nu_user_group#\'=\'Administrators\' or \'#nu_user_group#\'=\'Managers\' or \'#nu_user_group#\'=\'AssistManagers\') and \'#RECORD_ID#\'<>\'-1\',\'1\',\'0\')\nfrom school\nleft join student ON student.id=\'#RECORD_ID#\'\nwhere school.id=\'1\'','reset_parent_passbtn',240,10,'Στοιχεία Μαθητή',NULL,'html',561,393,20,20,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"this.style.cursor=\'pointer\';\"\n                            onmouseout=\"this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=18 height=18 id=\'img_reset_parent_pass\' src=\'images/reset_pass.png\' title=\'Επαναφόρα Password Γονέα\'/>\n        </td>\n    </tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-04-27 21:25:58','globeadmin','2017-11-29 21:49:32','globeadmin','2022-01-08 11:22:27','globeadmin'),('572af6d434ff955','572af54adfe5517',NULL,NULL,'1',10,NULL,'label1',20,10,'Μαζική Αποστολή Email','Μήνυμα :','words',53,28,750,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from class order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-05-05 10:31:32','globeadmin','2016-10-15 15:59:17','globeadmin','2021-12-11 20:34:13','globeadmin'),('572b20d594380a4','572af54adfe5517',NULL,NULL,'1',10,NULL,'subject',10,10,'Μαζική Αποστολή Email','Θέμα :','text',20,33,700,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-05-05 13:30:45','globeadmin','2016-05-05 18:20:17','globeadmin','2021-12-11 20:34:13','globeadmin'),('572af74eb3f35c7','572af54adfe5517',NULL,NULL,'1',10,NULL,'class_id',40,10,'Μαζική Αποστολή Email','Τμήμα : ','listbox',538,35,170,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select distinct class.id,class.short_name \nfrom class\ninner join student_class on class.id=student_class.class_id\nleft join ( select distinct class_id as c_id\n            from card\n            where   card.valid_from=(select max(start_date) from timetable) and \n                    card.teacher_id=\'#RECORD_ID#\') as c ON c.c_id=class.id\nleft join ( select class.id as c_id\n            from class\n            where\n                (   select count(*)\n                    from student \n                    inner join student_class ON student.id=student_class.student_id\n                    where \n                    teacher_id=\'#RECORD_ID#\' AND\n                    student_class.class_id = class.id) = (select count(*) from student_class where class_id=class.id)\n                ) as c1 ON c1.c_id=class.id\nwhere   \'#nu_user_group#\'=\'globeadmin\' OR \n        \'#nu_user_group#\'=\'Administrators\' OR \n        \'#nu_user_group#\'=\'Managers\' OR \n        \'#nu_user_group#\'=\'AssistManagers\' OR\n        \'#nu_user_group#\'=\'Secretaries\' OR\n        c.c_id IS NOT NULL OR\n        c1.c_id IS NOT NULL \norder by class.short_name',NULL,'','','select distinct class.id,class.short_name \nfrom class\ninner join student_class on class.id=student_class.class_id\nleft join ( select distinct class_id as c_id\n            from card\n            where   card.valid_from=(select max(start_date) from timetable) and \n                    card.teacher_id=\'#RECORD_ID#\') as c ON c.c_id=class.id\nleft join ( select class.id as c_id\n            from class\n            where\n                (   select count(*)\n                    from student \n                    inner join student_class ON student.id=student_class.student_id\n                    where \n                    teacher_id=\'#RECORD_ID#\' AND\n                    student_class.class_id = class.id) = (select count(*) from student_class where class_id=class.id)\n                ) as c1 ON c1.c_id=class.id\nwhere   \'#nu_user_group#\'=\'globeadmin\' OR \n        \'#nu_user_group#\'=\'Administrators\' OR \n        \'#nu_user_group#\'=\'Managers\' OR \n        \'#nu_user_group#\'=\'AssistManagers\' OR\n        \'#nu_user_group#\'=\'Secretaries\' OR\n        \'#nu_user_group#\'=\'Psychologists\' OR\n        c.c_id IS NOT NULL OR\n        c1.c_id IS NOT NULL\norder by class.short_name',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-05-05 10:33:34','globeadmin','2021-03-09 15:15:55','globeadmin','2021-12-11 20:34:13','globeadmin'),('572af77bbb47fc5','572af54adfe5517',NULL,NULL,'1',10,NULL,'student_id',70,10,'Μαζική Αποστολή Email','Μαθητής : ','listbox',538,300,350,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select distinct student.id, concat(ifNULL(grade.short_name,\'\'),\' - \',student.surname,\' \',student.name,\' \',student.fathers_name) \nfrom student\nleft join grade on grade.id = student.grade_id\nleft join (    select distinct student_id as s_id\n                            from student_class\n                            inner join card ON card.class_id=student_class.class_id\n                            where\n                                card.valid_from=(select max(start_date) from timetable) and   \n                                card.teacher_id=\'#RECORD_ID#\') as s ON s.s_id = student.id\nwhere\n        \'#nu_user_group#\'=\'globeadmin\' OR \n        \'#nu_user_group#\'=\'Administrators\' OR \n        \'#nu_user_group#\'=\'Managers\' OR \n        \'#nu_user_group#\'=\'AssistManagers\' OR\n        \'#nu_user_group#\'=\'Secretaries\' OR\n        s.s_id is not null OR\n        student.teacher_id = \'#RECORD_ID#\'\norder by student.grade_id,student.surname,student.name,student.fathers_name',NULL,'','','select distinct student.id, concat(ifNULL(grade.short_name,\'\'),\' - \',student.surname,\' \',student.name,\' \',student.fathers_name) \nfrom student\nleft join grade on grade.id = student.grade_id\nleft join (    select distinct student_id as s_id\n                            from student_class\n                            inner join card ON card.class_id=student_class.class_id\n                            where\n                                card.valid_from=(select max(start_date) from timetable) and   \n                                card.teacher_id=\'#RECORD_ID#\') as s ON s.s_id = student.id\nwhere\n        \'#nu_user_group#\'=\'globeadmin\' OR \n        \'#nu_user_group#\'=\'Administrators\' OR \n        \'#nu_user_group#\'=\'Managers\' OR \n        \'#nu_user_group#\'=\'AssistManagers\' OR\n        \'#nu_user_group#\'=\'Secretaries\' OR\n        \'#nu_user_group#\'=\'Psychologists\' OR\n        s.s_id is not null OR\n        student.teacher_id = \'#RECORD_ID#\' OR\n        student.advisor_id = \'#RECORD_ID#\'\norder by student.grade_id,student.surname,student.name,student.fathers_name',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-05-05 10:34:19','globeadmin','2021-03-09 15:16:15','globeadmin','2021-12-11 20:34:13','globeadmin'),('572af7a7572d5fe','572af54adfe5517',NULL,NULL,'1',10,NULL,'searchbtn',100,10,'Μαζική Αποστολή Email','Εμφάνιση Μαθητών','button',531,763,150,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from teacher order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-05-05 10:35:03','globeadmin','2016-10-15 16:00:32','globeadmin','2021-12-11 20:34:14','globeadmin'),('572af7e1c9ede05','572af54adfe5517',NULL,NULL,'1',10,NULL,'search_iframe',70,10,'Μαζική Αποστολή Email',NULL,'iframe',571,18,900,1100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from teacher order by short_name',NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-05-05 10:36:01','globeadmin','2016-10-15 16:00:32','globeadmin','2021-12-11 20:34:14','globeadmin'),('572af9c8dfe5ce0','572af54adfe5517',NULL,NULL,'1',10,NULL,'email_text_tinymce',30,10,'Μαζική Αποστολή Email',NULL,'iframe',77,22,900,380,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'56cc9f04b82528e','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-05-05 10:44:08','globeadmin','2016-10-15 15:59:17','globeadmin','2021-12-11 20:34:13','globeadmin'),('572b63ca60f2d61','572b615e795d4d1',NULL,NULL,'1',10,NULL,'subject',10,10,'Μαζική Αποστολή Email','Θέμα :','text',20,33,700,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-05-05 18:16:26','globeadmin','2016-05-05 18:21:25','globeadmin','2021-02-27 09:46:00','globeadmin'),('572b642580aff6e','572b615e795d4d1',NULL,NULL,'1',10,NULL,'label1',30,10,'Μαζική Αποστολή Email','Μήνυμα :','words',53,28,750,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from class order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-05-05 18:17:57','globeadmin','2016-05-05 18:21:25','globeadmin','2021-02-27 09:46:01','globeadmin'),('572b64634887658','572b615e795d4d1',NULL,NULL,'1',10,NULL,'email_text_tinymce',40,10,'Μαζική Αποστολή Email',NULL,'iframe',77,22,900,380,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'56cc9f04b82528e','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-05-05 18:18:59','globeadmin','2016-05-05 18:21:25','globeadmin','2021-02-27 09:46:01','globeadmin'),('572b65b7f36f3fc','572b615e795d4d1',NULL,NULL,'1',10,NULL,'teacher_id',70,10,'Μαζική Αποστολή Email','Καθηγητής : ','listbox',538,45,250,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select  id,\n        concat(if(surname is null,\'\',concat(surname,\' \')), IFNULL(name,\'\')) as teacher_full_name\nfrom teacher\norder by teacher_full_name',NULL,'','','select  id,\n        concat(if(surname is null,\'\',concat(surname,\' \')), IFNULL(name,\'\')) as teacher_full_name\nfrom teacher\norder by teacher_full_name',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-05-05 18:24:40','globeadmin','2017-03-18 15:44:52','globeadmin','2021-02-27 09:46:01','globeadmin'),('572b6658524cfec','572b615e795d4d1',NULL,NULL,'1',10,NULL,'select_teaching_field_id',80,10,'Μαζική Αποστολή Email','Ειδικότητα : ','listbox',538,404,250,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select  id,\n        concat(if(short_name is null,\'\',concat(short_name,\'-\')), IFNULL(name,\'\'))\nfrom teaching_field\norder by short_name',NULL,'','','select  id,\n        concat(if(short_name is null,\'\',concat(short_name,\'-\')), IFNULL(name,\'\'))\nfrom teaching_field\norder by short_name',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-05-05 18:27:20','globeadmin','2017-03-18 15:46:45','globeadmin','2021-02-27 09:46:01','globeadmin'),('572b673591c5484','572b615e795d4d1',NULL,NULL,'1',10,NULL,'searchbtn',90,10,'Μαζική Αποστολή Email','Εμφάνιση Καθηγητών','button',531,757,150,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from teacher order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-05-05 18:31:01','globeadmin','2016-10-15 15:56:08','globeadmin','2021-02-27 09:46:01','globeadmin'),('572b680aa54ee69','572b615e795d4d1',NULL,NULL,'1',10,NULL,'search_iframe',100,10,'Μαζική Αποστολή Email',NULL,'iframe',591,18,900,400,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from teacher order by short_name',NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-05-05 18:34:34','globeadmin','2018-07-01 00:16:25','globeadmin','2021-02-27 09:46:01','globeadmin'),('57348bec0b0ba77','57348bba8a00051',NULL,NULL,'1',10,NULL,'absence_date',10,10,'Καταχώριση Απουσίας','Ημερομηνία : ','text',20,10,80,40,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2016-05-12 16:58:04','globeadmin','2016-05-12 16:58:04','globeadmin','2018-07-12 23:29:20','globeadmin'),('57348c25dcffd9b','57348bba8a00051',NULL,NULL,'1',10,NULL,'student',20,10,'Καταχώριση Απουσίας','Μαθητής : ','lookup',20,198,100,40,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'registration_number',NULL,'surname',NULL,'5476201e5a3d38f','id','show_lesson();','function getStudentName() {\n    if (\'#call_type#\'==\'lookupcode\'){\n	    $fld = \'registration_number\';\n    } else {\n	    $fld = \'id\';\n    }\n    $sql = \"SELECT name FROM student WHERE \".$fld.\" = \'#RECORD_ID#\'\";\n    $q = nuRunQuery($sql);\n    $r = db_fetch_row($q);\n    return $r[0];\n}\nfunction getFatherstName() {\n    if (\'#call_type#\'==\'lookupcode\'){\n	    $fld = \'registration_number\';\n    } else {\n	    $fld = \'id\';\n    }\n    $sql = \"SELECT fathers_name FROM student WHERE \".$fld.\" = \'#RECORD_ID#\'\";\n    $q = nuRunQuery($sql);\n    $r = db_fetch_row($q);\n    return $r[0];\n}',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',40,200,'2016-05-12 16:59:02','globeadmin','2016-05-12 16:59:02','globeadmin','2018-07-12 23:29:20','globeadmin'),('57348c59d341d0e','57348bba8a00051',NULL,NULL,'1',10,NULL,'student_name',30,10,'Καταχώριση Απουσίας',NULL,'text',20,536,170,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-05-12 16:59:53','globeadmin','2016-05-12 16:59:53','globeadmin','2018-07-12 23:29:20','globeadmin'),('57348c7ca267f0c','57348bba8a00051',NULL,NULL,'1',10,NULL,'student_fathers_name',40,10,'Καταχώριση Απουσίας','Πατ.','text',20,727,170,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-05-12 17:00:28','globeadmin','2016-05-12 17:00:28','globeadmin','2018-07-12 23:29:20','globeadmin'),('57348cbfc9799ee','57348bba8a00051',NULL,NULL,'1',10,NULL,'search_iframe',50,10,'Καταχώριση Απουσίας',NULL,'iframe',59,18,900,350,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-05-12 17:01:35','globeadmin','2016-05-12 17:22:37','globeadmin','2018-07-12 23:29:20','globeadmin'),('5738afd876f6f98','55127aebdf42446',NULL,NULL,'1',10,NULL,'justified_reason_id',60,10,'Αναζήτηση','Λόγος Δικαιολόγησης ή Διαγραφής :','listbox',85,319,250,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name \nfrom justified_reason \norder by id',NULL,'','','select id,short_name \nfrom justified_reason \norder by id',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-05-15 20:20:24','globeadmin','2018-08-05 00:15:51','globeadmin','2020-10-08 23:42:28','globeadmin'),('5738bff596b6181','551821232f9553f',NULL,NULL,'1',10,NULL,'justified_reason_id',70,10,'Αναζήτηση','Λόγος Δικαιολόγησης ή Διαγραφής :','listbox',87,300,200,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name \nfrom justified_reason \norder by id',NULL,'','','select distinct justified_reason.id,justified_reason.short_name \nfrom justified_reason\ninner join absence on (absence.student_id = \'#RECORD_ID#\' and absence.justified_reason_id=justified_reason.id)\norder by justified_reason.id',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-05-15 21:29:09','globeadmin','2018-08-04 21:07:58','globeadmin','2018-08-04 21:07:58','globeadmin'),('57400922d5c86f0','57400922b87c65a',NULL,NULL,'1',10,NULL,'name',10,10,'Λεπτομέρειες','Όνομα :','text',14,46,360,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2016-05-30 08:49:16','globeadmin','2020-09-18 01:08:16','globeadmin'),('57400922dd1b430','57400922b87c65a',NULL,NULL,'1',10,NULL,'description',50,10,'Λεπτομέρειες','Περιγραφή :','textarea',75,21,760,50,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2016-05-27 22:14:20','globeadmin','2020-09-18 01:08:16','globeadmin'),('57400922e46f8d8','57400922b87c65a',NULL,NULL,'1',10,NULL,'speciality_id',20,10,'Λεπτομέρειες','Ειδικότητα :','dropdown',14,534,250,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from speciality',NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'0000-00-00 00:00:00','','2016-05-30 08:49:16','globeadmin','2020-09-18 01:08:16','globeadmin'),('574f118309863c7','5627e58b8ed5f6d',NULL,NULL,'1',10,NULL,'critiria_iframe',10,20,'Κριτήρια Αξιολόγησης',NULL,'iframe',73,15,950,500,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'574ea919042d569','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-06-01 19:46:59','globeadmin','2016-06-08 13:21:36','globeadmin','2018-07-23 09:37:25','globeadmin'),('57408974e00ae93','57400922b87c65a',NULL,NULL,'1',10,NULL,'search_iframe',60,10,'Λεπτομέρειες',NULL,'iframe',176,19,900,350,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'57401ba6d83b3e9','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-05-21 19:14:44','globeadmin','2018-07-14 00:22:10','globeadmin','2020-09-18 01:08:16','globeadmin'),('57418b28de5b6fa','56192c691b58858',NULL,NULL,'0',10,NULL,'critirion_general_btn',50,30,'Μαθήματα και Διδασκαλίες',NULL,'html',192,380,220,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_critiria_id\').src=\'images/critirionb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_critiria_id\').src=\'images/critirion.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_critiria_id\' src=\'images/critirion.png\' title=\'Γενικά Κριτήρια Περιγραφικής Αξιολόγησης\'/>\n            <img /> \n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Κριτήρια Περιγραφικής Αξιολόγησης</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-05-22 13:34:16','globeadmin','2017-10-28 22:09:21','globeadmin','2021-10-24 21:25:06','globeadmin'),('5741a1f0e5ac8ae','59d7d7986aed52d',NULL,NULL,'0',10,NULL,'critirion_general_btn',40,10,'Αξιολόγηση Μαθητών και Ποινές',NULL,'html',270,73,220,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_critiria_id\').src=\'images/critirionb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_critiria_id\').src=\'images/critirion.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_critiria_id\' src=\'images/critirion.png\' title=\'Γενικά Κριτήρια Περιγραφικής Αξιολόγησης\'/>\n            <img /> \n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Κριτήρια Περιγραφικής Αξιολόγησης</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-05-22 15:11:29','globeadmin','2017-10-07 01:07:46','globeadmin','2022-01-08 10:57:38','globeadmin'),('5741fe150a0c80c','5741fe1502bb6c2',NULL,NULL,'1',10,NULL,'description',20,10,'Λεπτομέρειες','Περιγραφή :','textarea',57,48,800,50,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2016-05-23 10:34:43','globeadmin','2018-07-14 10:14:49','globeadmin'),('5741fe15115f816','5741fe1502bb6c2',NULL,NULL,'1',10,NULL,'critirion_general_id_disp',10,10,'Λεπτομέρειες','Γενικό Κριτήριο :','display',24,21,800,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select concat(name,\' - \', description)\nfrom critirion_general\nwhere id = \'#critirion_general_id#\'',NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'0000-00-00 00:00:00','','2016-05-23 10:34:43','globeadmin','2018-07-14 10:14:48','globeadmin'),('57420aca8de2af8','5741fe1502bb6c2',NULL,NULL,'1',10,'select \'0\'','critirion_general_id',40,10,'Λεπτομέρειες','Γενικό Κριτήριο :','text',651,-3,100,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select concat(name,\' - \', description)\nfrom critirion_general\nwhere id = \'#critirion_general_id#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2016-05-22 22:38:50','globeadmin','2016-05-23 10:34:43','globeadmin','2018-07-14 10:14:49','globeadmin'),('574292238a9370f','5741fe1502bb6c2',NULL,NULL,'1',10,NULL,'search_iframe',30,10,'Λεπτομέρειες',NULL,'iframe',160,19,900,350,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'57428fad993ae6b','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-05-23 08:16:19','globeadmin','2018-07-14 10:14:23','globeadmin','2018-07-14 10:14:49','globeadmin'),('5742996edd95f5e','5742996ed6426f1',NULL,NULL,'1',10,NULL,'description',30,10,'Περιγραφή Ειδικού Κριτηρίου',NULL,'textarea',28,12,550,250,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2016-05-23 10:36:14','globeadmin','2017-10-29 19:27:28','globeadmin'),('5742996ee4e8873','5742996ed6426f1',NULL,NULL,'1',10,'select \'0\'','hierarchy',10,10,'Περιγραφή Ειδικού Κριτηρίου','Hierarchy','text',10,11,100,0,'r','0','0','select ifNULL(max(hierarchy),0)+1\nfrom critirion_special_level\ninner join session_variables on session_id=\'#session_id#\'\nwhere critirion_special_level.critirion_special_id = session_variables.critirion_special_id\n','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'0000-00-00 00:00:00','','2016-05-23 14:06:39','globeadmin','2017-10-29 19:27:28','globeadmin'),('5742996eec3b4c1','5742996ed6426f1',NULL,NULL,'1',10,'select \'0\'','critirion_special_id',20,10,'Περιγραφή Ειδικού Κριτηρίου','Critirion Special','text',10,194,100,0,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'0000-00-00 00:00:00','','2016-05-23 14:06:55','globeadmin','2017-10-29 19:27:28','globeadmin'),('574f15be15bb404','5627e58b8ed5f6d',NULL,NULL,'1',10,NULL,'studentdisp2',20,20,'Κριτήρια Αξιολόγησης','Μαθητής : ','display',16,60,550,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','SELECT concat(`registration_number`,\' - \',`surname`,\' \',`name`,\' πατ. \',`fathers_name`)\n\nFROM `student` WHERE id = \'#student_id#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-06-01 20:05:02','globeadmin','2016-06-08 13:24:56','globeadmin','2018-07-23 09:37:25','globeadmin'),('5743d0409b85646','57400922b87c65a',NULL,NULL,'1',10,NULL,'teacher_id',30,10,'Λεπτομέρειες','Δημιουργός :','dropdown',45,16,300,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,\nconcat(ifNULL(surname,\'\'),if(surname is not NULL and name is not NULL,\' \',\'\'),ifNULL(name,\'\')) as full_name\nfrom teacher\norder by full_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2016-05-24 06:53:36','globeadmin','2016-05-30 08:49:16','globeadmin','2020-09-18 01:08:16','globeadmin'),('574580725f5967b','57457fe729a1d1c',NULL,NULL,'1',10,NULL,'new_critirion_general_id',10,10,'Κλωνοποίηση Ειδικού Κριτηρίου Περιγραφικής Αξιολόγησης','Προσάρτηση στο Γενικό Κριτήριο :','dropdown',31,17,450,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'SELECT  critirion_general.id, \n        concat (critirion_general.name,\' - \',critirion_general.description,\n                    if(sp_short_name is NULL,\'\',concat(\' (\',sp_short_name,\')\')))\nFROM critirion_general\nleft join \n    (   select id as sp_id, \n        short_name as sp_short_name \n        from  speciality) as sp on critirion_general.speciality_id = sp.sp_id\ninner join session_variables on session_variables.session_id=\'#session_id#\'\nwhere \n        (critirion_general.teacher_id=session_variables.teacher_id OR \n        (\'#nu_user_group#\' IN (\'Managers\',\'AssistManagers\',\'Administrators\',\'Secretaries\',\'globeadmin\'))) and\n        \n        ((critirion_general.id not in (select distinct critirion_general_id from subject_critirion_general)) OR \n        (\'#nu_user_group#\' IN (\'Managers\',\'AssistManagers\',\'Administrators\',\'Secretaries\',\'globeadmin\'))) and\n        \n        (critirion_general.id not in (  select distinct cg.id\n                                        from critirion_general as cg\n                                        inner join critirion_special ON cg.id=critirion_special.critirion_general_id\n                                        inner join mark_critirion_special_level ON \n                                        critirion_special.id=mark_critirion_special_level.critirion_special_id))\norder by sp_short_name,name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-05-25 13:37:38','globeadmin','2016-05-31 11:59:07','globeadmin','2016-05-31 11:59:07','globeadmin'),('5742ac991084248','5741fe1502bb6c2',NULL,NULL,'1',10,'select \'0\'','hierarchy',60,10,'Λεπτομέρειες','Ηierarchy','text',651,938,100,0,'l','0','0','select ifNULL(max(hierarchy),0)+1\nfrom critirion_special\ninner join session_variables on session_id=\'#session_id#\'\nwhere critirion_special.critirion_general_id = session_variables.critirion_general_id\n','0',NULL,NULL,NULL,NULL,NULL,'','','select concat(name,\' - \', description)\nfrom critirion_general\nwhere id = \'#critirion_general_id#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2016-05-23 10:09:13','globeadmin','2016-05-23 10:33:16','globeadmin','2018-07-14 10:14:49','globeadmin'),('574580c338496dc','57457fe729a1d1c',NULL,NULL,'1',10,NULL,'clonebtn',20,10,'Κλωνοποίηση Ειδικού Κριτηρίου Περιγραφικής Αξιολόγησης','Κλωνοποίηση','button',100,96,150,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-05-25 13:38:59','globeadmin','2016-05-25 13:38:59','globeadmin','2016-05-25 14:54:06','globeadmin'),('5745d0c72b360cd','547489b0d4efe7c','',NULL,'1',10,NULL,'subject_critirion_general_subform',10,20,'Κριτήρια Περιγραφικής Αξιολόγησης',NULL,'subform',16,42,900,380,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,25,'1','1','subject_id','id','SELECT * \nFROM subject_critirion_general \nWHERE subject_id = \'#RECORD_ID#\'\norder by id','subject_critirion_general',NULL,'',NULL,'g',0,0,'0000-00-00 00:00:00','','2016-06-01 19:08:20','globeadmin','2022-02-14 11:00:18','globeadmin'),('5745d0c732874de','5745d0c72b360cd',NULL,NULL,'1',10,NULL,'critirion_general_id',10,10,'Details','Γενικά Κριτήρια για την Αξιολόγηση του Μαθήματος','dropdown',0,0,820,24,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'SELECT  critirion_general.id, \n        concat (\'**\',critirion_general.name,\' - \',critirion_general.description,\' (\',\'Όλες οι Ειδικότητες, Όλες οι Τάξεις\',\')\') as full_name\nFROM critirion_general\nwhere (critirion_general.speciality_id is NULL) and (critirion_general.grade_id is NULL)\n\nUNION\n\nSELECT  critirion_general.id, \n        concat (\'*\',critirion_general.name,\' - \',critirion_general.description,\' (Όλες οι Ειδικότητες, \',grade.name,\')\') as full_name\nFROM critirion_general\nINNER JOIN grade ON critirion_general.grade_id=grade.id\nwhere grade_id=\'#grade_id#\' and (critirion_general.speciality_id is NULL)\n\nUNION\n\nSELECT  critirion_general.id, \n        concat (\'*\',critirion_general.name,\' - \',critirion_general.description,\' (\',speciality.short_name,\', Όλες οι Τάξεις)\') as full_name\nFROM critirion_general\nINNER JOIN speciality ON critirion_general.speciality_id=speciality.id\nwhere speciality_id=\'#speciality_id#\' and (critirion_general.grade_id is NULL)\n\nUNION\n\nSELECT  critirion_general.id, \n        concat (critirion_general.name,\' - \',critirion_general.description,\' (\',speciality.short_name,\', \',grade.name,\')\') as full_name\nFROM critirion_general\nINNER JOIN speciality ON critirion_general.speciality_id=speciality.id\nINNER JOIN grade ON critirion_general.grade_id=grade.id\nwhere speciality_id=\'#speciality_id#\' and grade_id=\'#grade_id#\'\n\norder by full_name',NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'0000-00-00 00:00:00','','2016-05-29 11:19:22','globeadmin','2016-12-18 22:17:49','globeadmin'),('57489bf30503a9e','57400922b87c65a',NULL,NULL,'1',10,NULL,'grade_id',40,10,'Λεπτομέρειες','Τάξη :','dropdown',45,739,80,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name\nfrom grade\norder by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2016-05-27 22:11:47','globeadmin','2016-05-30 08:49:16','globeadmin','2020-09-18 01:08:16','globeadmin'),('5749e8404d6aba7','57400922b87c65a',NULL,NULL,'1',10,NULL,'label1',70,10,'Λεπτομέρειες','Αφήνοντας κενά τα πεδία «Τάξη» ή και «Ειδικότητα», το κριτήριο θα μπορεί να αντιστοιχηθεί με τα μαθήματα όλων των τάξεων ή και όλων των ειδικοτήτων','words',136,19,900,20,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-05-28 21:49:36','globeadmin','2016-05-28 21:52:56','globeadmin','2020-09-18 01:08:16','globeadmin'),('574bdb74be76fb5','57400922b87c65a',NULL,NULL,'1',10,NULL,'subjects_iframe',10,20,'Συσχετιζόμενα Μαθήματα',NULL,'iframe',26,39,650,450,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'574bd5bd5a5bede','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-05-30 09:19:32','globeadmin','2016-05-30 09:21:46','globeadmin','2020-09-18 01:08:16','globeadmin'),('57540b16ef24e9f','5627e58b8ed5f6d',NULL,NULL,'1',10,'select \'0\'','critiria_count',30,20,'Κριτήρια Αξιολόγησης','Αριθμός : ','display',15,863,40,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','SELECT count(*)\nFROM mark_critirion_special_level\nWHERE mark_id=\'#RECORD_ID#\' AND critirion_special_level_id IS NOT NULL',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-06-05 14:20:55','globeadmin','2016-06-05 14:22:39','globeadmin','2018-07-23 09:37:25','globeadmin'),('575426c3b21be27','547070c91793d3b',NULL,NULL,'1',10,NULL,'mark_required',30,10,'Λεπτομέρειες','Απαιτούνται Βαθμοί : ','checkbox',161,161,10,0,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'0|NAI|1|OXI',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-06-05 16:18:59','globeadmin','2016-06-05 16:50:28','globeadmin','2021-09-04 21:36:57','globeadmin'),('575428c5a5e5357','547070c91793d3b',NULL,NULL,'1',10,NULL,'label1',40,10,'Λεπτομέρειες','(Αποεπιλέξτε στην περίπτωση που η περίοδος αφορά μόνο περιγραφική αξιολόγηση)','words',165,332,600,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'0|NAI|1|OXI',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-06-05 16:27:33','globeadmin','2017-08-30 22:48:01','globeadmin','2021-09-04 21:36:57','globeadmin'),('57542b3d555424e','562362d2ef4f556',NULL,NULL,'1',10,'select \'0\'','mark_required',30,10,'Καταχώριση Αξιολόγησης','Απαιτούνται Βαθμοί : ','display',11,908,40,30,'c','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','SELECT grading_period.mark_required\nFROM school,grading_period \nWHERE \n    school.grading_period_id=grading_period.id AND \n    CURDATE() between grading_period.start_date AND grading_period.end_date \nlimit 1',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-06-05 16:38:05','globeadmin','2016-07-24 23:30:41','globeadmin','2022-02-08 23:51:03','globeadmin'),('5756bc6cc69ddba','56192be786c61d7',NULL,NULL,'0',10,'select \'0\'','send_marksbtn',60,10,'Αξιολόγηση Μαθητών και Ποινές',NULL,'html',334,687,220,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_marks_send_id\').src=\'images/mark_emailb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_marks_send_id\').src=\'images/mark_email.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_marks_send_id\' src=\'images/mark_email.png\' title=\'Αποστολή αξιολόγησης με email (Υπό Κατασκευή)\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Αποστολή Αξιολόγησης (ΥΚ)</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-06-07 15:22:04','globeadmin','2021-10-24 21:27:42','globeadmin','2021-10-24 21:33:12','globeadmin'),('5757bed19ffad24','562d11f6d45ccf1',NULL,NULL,'1',10,NULL,'critiria_iframe',10,30,'Κριτήρια Αξιολόγησης',NULL,'iframe',20,8,720,430,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'5757b8458c72cf3','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-06-08 09:44:33','globeadmin','2016-07-24 23:00:51','globeadmin','2018-07-05 21:44:37','globeadmin'),('5757f0d945a7855','5627e58b8ed5f6d',NULL,NULL,'1',10,NULL,'subjectdisp1',30,10,'Ελεύθερο Κείμενο','Μάθημα : ','display',42,63,550,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','SELECT concat(subject.name, if(subject_type.name is NULL,\'\',concat(\' (\',subject_type.name,\')\')))\nFROM subject\ninner join subject_type on subject.subject_type_id=subject_type.id\nWHERE subject.id = \'#subject_id#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-06-08 13:18:01','globeadmin','2016-06-08 13:18:12','globeadmin','2018-07-23 09:37:25','globeadmin'),('5757f1ebcbee7f0','5627e58b8ed5f6d',NULL,NULL,'1',10,NULL,'subjectdisp2',40,20,'Κριτήρια Αξιολόγησης','Μάθημα : ','display',42,63,550,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','SELECT concat(subject.name, if(subject_type.name is NULL,\'\',concat(\' (\',subject_type.name,\')\')))\nFROM subject\ninner join subject_type on subject.subject_type_id=subject_type.id\nWHERE subject.id = \'#subject_id#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-06-08 13:22:35','globeadmin','2016-06-08 13:23:50','globeadmin','2018-07-23 09:37:25','globeadmin'),('5762f9cc6d8e1b3','5762f95837d99ee',NULL,NULL,'1',10,NULL,'class_id',30,10,'Αποστολή Αξιολόγησης','Τμήμα : ','dropdown',72,161,100,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select distinct class.id,class.short_name \nfrom class\ninner join student_class on class.id=student_class.class_id\norder by class.short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-06-16 22:11:08','globeadmin','2016-06-16 22:31:56','globeadmin','2016-10-07 22:06:43','globeadmin'),('5762f9e9663cb10','5762f95837d99ee',NULL,NULL,'1',10,NULL,'student_id',40,10,'Αποστολή Αξιολόγησης','Μαθητής : ','dropdown',72,358,300,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select student.id,concat(ifNULL(grade.short_name,\'\'),\' - \',student.surname,\' \',student.name,\' \',student.fathers_name) \nfrom student \nleft join grade on grade.id = student.grade_id\norder by student.grade_id,student.surname,student.name,student.fathers_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-06-16 22:11:37','globeadmin','2016-06-16 22:31:56','globeadmin','2016-10-07 22:06:43','globeadmin'),('5762fa09d4182c2','5762f95837d99ee',NULL,NULL,'1',10,NULL,'searchbtn',50,10,'Αποστολή Αξιολόγησης','Εμφάνιση Μαθητών','button',64,757,150,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from teacher order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-06-16 22:12:09','globeadmin','2016-06-16 22:31:56','globeadmin','2016-10-07 22:06:43','globeadmin'),('5762fa3e52b4b70','5762f95837d99ee',NULL,NULL,'1',10,NULL,'search_iframe',60,10,'Αποστολή Αξιολόγησης',NULL,'iframe',143,20,900,1100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from teacher order by short_name',NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-06-16 22:13:02','globeadmin','2016-06-16 22:31:56','globeadmin','2016-10-07 22:06:43','globeadmin'),('5762fc255ee9bb8','5762f95837d99ee',NULL,NULL,'1',10,NULL,'grade_id',20,10,'Αποστολή Αξιολόγησης','Τάξη : ','dropdown',72,23,60,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select distinct grade.id,grade.short_name \nfrom grade\norder by grade.short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-06-16 22:21:09','globeadmin','2016-06-16 22:31:56','globeadmin','2016-10-07 22:06:43','globeadmin'),('5762fd8a63ca5df','5762f95837d99ee',NULL,NULL,'1',10,NULL,'grading_period',10,10,'Αποστολή Αξιολόγησης','Περίοδος Αξιολόγησης','dropdown',25,32,150,70,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select distinct grading_period.id,grading_period.name \nfrom grading_period\ninner join mark ON grading_period.id=mark.grading_period_id \norder by grading_period.name \n\n    ',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2016-06-16 22:27:06','globeadmin','2016-06-16 22:31:56','globeadmin','2016-10-07 22:06:43','globeadmin'),('577eb3783277e99','571354ed43a4d47',NULL,NULL,'0',10,NULL,'btnimg6',40,10,'SMS - Email',NULL,'html',192,73,220,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'search_email_id\').src=\'images/search_emailb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'search_email_id\').src=\'images/search_email.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'search_email_id\' src=\'images/search_email.png\' title=\'Αναζήτηση Σταλθέντων Email\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Αναζήτηση Σταλθέντων Email</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-07-07 22:54:32','globeadmin','2017-10-28 22:07:24','globeadmin','2017-11-12 16:18:14','globeadmin'),('577ebbbd4d530b6','577ebb808309312',NULL,NULL,'1',10,NULL,'label1',10,10,'Αναζήτηση','Επιλέξτε από τα παρακάτω κριτήρια αναζήτησης. Αφήνοντας κενό ένα κριτήριο, εμφανίζονται όλα τα αντίστοιχα Email.','words',11,11,750,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from class order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-07-07 23:29:49','globeadmin','2016-07-07 23:29:49','globeadmin','2021-01-24 16:08:38','globeadmin'),('577ebbde87e962c','577ebb808309312',NULL,NULL,'1',10,NULL,'from_date',20,10,'Αναζήτηση','Από : ','text',45,18,80,30,'r','0','0','select curdate()','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2016-07-07 23:30:22','globeadmin','2016-07-07 23:30:22','globeadmin','2021-01-24 16:08:38','globeadmin'),('577ebc0665bd0fb','577ebb808309312',NULL,NULL,'1',10,NULL,'teacher_id',70,10,'Αναζήτηση','Παραλήπτης Καθηγητής :','dropdown',79,764,250,30,'l','0','0','select #RECORD_ID#','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select  id,\n        concat(if(surname is null,\'\',concat(surname,\' \')), IFNULL(name,\'\')) as teacher_full_name\nfrom teacher\norder by teacher_full_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-07-07 23:31:02','globeadmin','2016-07-07 23:42:00','globeadmin','2021-01-24 16:08:38','globeadmin'),('577ebc2af35713b','577ebb808309312',NULL,NULL,'1',10,'select if(\'#nu_user_group#\'=\'globeadmin\' or \n        \'#nu_user_group#\'=\'Administrators\' or \n        \'#nu_user_group#\'=\'Managers\' or \n        \'#nu_user_group#\'=\'AssistManagers\',\'1\',\'0\')','sender_id',50,10,'Αναζήτηση','Αποστολέας :','dropdown',43,832,250,30,'l','0','0','select #RECORD_ID#','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select  id,\n        concat(if(surname is null,\'\',concat(surname,\' \')), IFNULL(name,\'\')) as teacher_full_name\nfrom teacher\nWHERE ( \'#nu_user_group#\'=\'globeadmin\' or \n        \'#nu_user_group#\'=\'Administrators\' or \n        \'#nu_user_group#\'=\'Managers\' or \n        \'#nu_user_group#\'=\'AssistManagers\')\n        OR id=\'#RECORD_ID#\'\norder by teacher_full_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-07-07 23:31:39','globeadmin','2016-07-20 19:55:43','globeadmin','2021-01-24 16:08:38','globeadmin'),('577ebc47cc46eaa','577ebb808309312',NULL,NULL,'1',10,NULL,'to_date',30,10,'Αναζήτηση','Έως : ','text',45,196,80,30,'r','0','0','select curdate()','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2016-07-07 23:32:07','globeadmin','2016-07-07 23:42:00','globeadmin','2021-01-24 16:08:38','globeadmin'),('577ebc63c7636be','577ebb808309312',NULL,NULL,'1',10,NULL,'student_id',60,10,'Αναζήτηση','Παραλήπτης Μαθητής : ','dropdown',79,17,300,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select distinct student.id, concat(ifNULL(grade.short_name,\'\'),\' - \',student.surname,\' \',student.name,\' \',student.fathers_name) \nfrom student\nleft join grade on grade.id = student.grade_id\nleft join (    select distinct student_id as s_id\n                            from student_class\n                            inner join card ON card.class_id=student_class.class_id\n                            where\n                                card.valid_from=(select max(start_date) from timetable) and   \n                                card.teacher_id=\'#RECORD_ID#\') as s ON s.s_id = student.id\nwhere\n        \'#nu_user_group#\'=\'globeadmin\' OR \n        \'#nu_user_group#\'=\'Administrators\' OR \n        \'#nu_user_group#\'=\'Managers\' OR \n        \'#nu_user_group#\'=\'AssistManagers\' OR\n        \'#nu_user_group#\'=\'Secretaries\' OR\n        s.s_id is not null OR\n        student.teacher_id = \'#RECORD_ID#\'\norder by student.grade_id,student.surname,student.name,student.fathers_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-07-07 23:32:35','globeadmin','2016-07-21 01:06:34','globeadmin','2021-01-24 16:08:38','globeadmin'),('577ebc82d60b568','577ebb808309312',NULL,NULL,'1',10,NULL,'searchbtn',80,10,'Αναζήτηση','Αναζήτηση','button',114,46,150,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from teacher order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-07-07 23:33:06','globeadmin','2016-07-07 23:42:00','globeadmin','2021-01-24 16:08:38','globeadmin'),('577ebcb43006fef','577ebb808309312',NULL,NULL,'1',10,'select if(\'#nu_user_group#\'=\'globeadmin\',\'1\',\'0\')','current_date',90,10,'Αναζήτηση','Τρέχουσα Ημ/νια : ','display',114,969,80,30,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select DATE_FORMAT(curdate(),\'%d-%m-%Y\')',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-07-07 23:33:56','globeadmin','2016-07-07 23:42:00','globeadmin','2021-01-24 16:08:38','globeadmin'),('577ebce46a9efad','577ebb808309312',NULL,NULL,'1',10,NULL,'search_iframe',100,10,'Αναζήτηση',NULL,'iframe',160,14,1150,350,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from teacher order by short_name',NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-07-07 23:34:44','globeadmin','2018-07-13 09:32:01','globeadmin','2021-01-24 16:08:38','globeadmin'),('577ebd022d95fa8','577ebb808309312',NULL,NULL,'1',10,NULL,'state',40,10,'Αναζήτηση','Κατάσταση Μηνύματος :','dropdown',43,438,150,30,'l','0','0','select #RECORD_ID#','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'0|Στάλθηκε|1|Λάθος Διεύθυνση|2|Απέτυχε',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-07-07 23:35:14','globeadmin','2016-07-07 23:42:00','globeadmin','2021-01-24 16:08:38','globeadmin'),('57822ecba4d7b41','57822e81b5ed24f',NULL,NULL,'1',10,NULL,'subject',10,10,'Μαζική Αποστολή Email','Θέμα :','text',20,33,700,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-07-10 14:17:31','globeadmin','2016-07-10 14:17:31','globeadmin','2020-10-18 01:00:57','globeadmin'),('57822ef1396c96f','57822e81b5ed24f',NULL,NULL,'1',10,NULL,'label1',20,10,'Μαζική Αποστολή Email','Μήνυμα :','words',57,28,120,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from class order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-07-10 14:18:09','globeadmin','2016-07-10 15:28:13','globeadmin','2020-10-18 01:01:20','globeadmin'),('57822f38dcfe9e4','57822e81b5ed24f',NULL,NULL,'1',10,NULL,'email_text_tinymce',30,10,'Μαζική Αποστολή Email',NULL,'iframe',82,23,900,380,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'56cc9f04b82528e','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-07-10 14:19:20','globeadmin','2016-07-10 14:19:20','globeadmin','2020-10-18 01:01:47','globeadmin'),('57822f67b10b0f0','57822e81b5ed24f',NULL,NULL,'1',10,NULL,'search_iframe',40,10,'Μαζική Αποστολή Email',NULL,'iframe',470,23,900,1100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from teacher order by short_name',NULL,'57811f7eb6d75f3','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-07-10 14:20:07','globeadmin','2016-07-10 15:16:27','globeadmin','2020-10-18 01:02:31','globeadmin'),('57829e01668b690','57829d0d8167dd0',NULL,NULL,'1',10,'select if(\'#nu_user_group#\'=\'globeadmin\',\'1\',\'0\')','max_num_of_chars',60,10,'Μαζική Αποστολή SMS',NULL,'display',8,155,30,30,'r','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','SELECT 159-CHAR_LENGTH(short_name) \nFROM school\nWHERE id=1',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-07-10 22:12:01','globeadmin','2016-07-10 22:25:57','globeadmin','2021-03-24 11:23:15','globeadmin'),('57829e2b0ea980f','57829d0d8167dd0',NULL,NULL,'1',10,NULL,'num_of_chars_left',40,10,'Μαζική Αποστολή SMS',NULL,'text',147,886,30,30,'r','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-07-10 22:12:43','globeadmin','2016-07-10 22:25:57','globeadmin','2021-03-24 11:23:15','globeadmin'),('57829f8883d906f','57829d0d8167dd0',NULL,NULL,'1',10,'select \'0\'','end_date_disp',70,10,'Μαζική Αποστολή SMS',NULL,'display',8,208,80,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select DATE_FORMAT(grading_period.end_date,\'%d-%m-%Y\')\nfrom school,grading_period\nwhere school.grading_period_id=grading_period.id','select id,short_name from class order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-07-10 22:18:32','globeadmin','2018-08-18 19:16:57','globeadmin','2021-03-24 11:23:15','globeadmin'),('57829d4f5a57f41','57829d0d8167dd0',NULL,NULL,'1',10,NULL,'label1',10,10,'Μαζική Αποστολή SMS','Μήνυμα :','words',17,23,120,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from class order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-07-10 22:09:03','globeadmin','2016-07-10 22:17:00','globeadmin','2021-03-24 11:23:14','globeadmin'),('57829d7777a3dc8','57829d0d8167dd0',NULL,NULL,'1',10,NULL,'sms_text',30,10,'Μαζική Αποστολή SMS',NULL,'textarea',40,20,900,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-07-10 22:09:43','globeadmin','2016-07-10 22:25:57','globeadmin','2021-03-24 11:23:15','globeadmin'),('57829db1c5c40e1','57829d0d8167dd0',NULL,NULL,'1',10,NULL,'search_iframe',50,10,'Μαζική Αποστολή SMS',NULL,'iframe',169,20,900,1100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from teacher order by short_name',NULL,'57815cda5c980f5','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-07-10 22:10:41','globeadmin','2016-07-10 23:48:57','globeadmin','2021-03-24 11:23:15','globeadmin'),('57829de13f7d463','57829d0d8167dd0',NULL,NULL,'1',10,NULL,'sms_disp',20,10,'Μαζική Αποστολή SMS','Υπόλοιπο Μηνυμάτων :','display',13,720,60,0,'r','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select IF(\'#sms_limit#\'=\'\',\'UL\',\'#sms_limit#\'-count(*))\nfrom sms\nwhere sender_id=\'#RECORD_ID#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-07-10 22:11:29','globeadmin','2016-07-10 22:25:57','globeadmin','2021-03-24 11:23:15','globeadmin'),('5783c0f7c9871d8','547372d029461f4',NULL,NULL,'0',10,'select if(TRIM(\'#email#\')!=\'\',\'1\',\'0\')','send_email_img',240,10,'Λεπτομέρειες',NULL,'html',422,399,34,31,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"this.style.cursor=\'pointer\';\"\n                            onmouseout=\"this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=30 height=30 id=\'img_email_sentd\' src=\'images/email.png\' title=\'Αποστολή Email\'/>\n        </td>\n    </tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-07-11 18:53:27','globeadmin','2016-07-11 21:53:25','globeadmin','2021-04-04 21:18:12','globeadmin'),('57823f4940bea65','57822e81b5ed24f',NULL,NULL,'1',10,'select \'0\'','end_date_disp',50,10,'Μαζική Αποστολή Email',NULL,'display',58,145,80,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select DATE_FORMAT(grading_period.end_date,\'%d-%m-%Y\')\nfrom school,grading_period\nwhere school.grading_period_id=grading_period.id','select id,short_name from class order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-07-10 15:27:53','globeadmin','2016-07-10 16:05:03','globeadmin','2020-10-18 00:56:53','globeadmin'),('57823fbbee13f1c','57822e81b5ed24f',NULL,NULL,'1',10,'select \'0\'','date_dif_disp',60,10,'Μαζική Αποστολή Email',NULL,'display',58,246,40,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select DATEDIFF(grading_period.end_date,CURDATE())\nfrom school,grading_period\nwhere school.grading_period_id=grading_period.id','select id,short_name from class order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-07-10 15:29:48','globeadmin','2016-07-10 16:05:21','globeadmin','2020-10-18 00:56:53','globeadmin'),('578240822d36bc3','57822e81b5ed24f',NULL,NULL,'1',10,'select \'0\'','subject_disp',70,10,'Μαζική Αποστολή Email',NULL,'display',58,306,250,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select concat (\'Παράδοση Αξιολόγησης - \',grading_period.name)\nfrom school,grading_period\nwhere school.grading_period_id=grading_period.id','select id,short_name from class order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-07-10 15:33:06','globeadmin','2016-07-10 16:05:39','globeadmin','2020-10-18 01:03:54','globeadmin'),('57829fae24a1b2a','57829d0d8167dd0',NULL,NULL,'1',10,'select \'0\'','date_dif_disp',80,10,'Μαζική Αποστολή SMS',NULL,'display',8,310,40,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select DATEDIFF(grading_period.end_date,CURDATE())\nfrom school,grading_period\nwhere school.grading_period_id=grading_period.id','select id,short_name from class order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-07-10 22:19:10','globeadmin','2018-08-18 19:16:40','globeadmin','2021-03-24 11:23:15','globeadmin'),('57829fd4c0e28fc','57829d0d8167dd0',NULL,NULL,'1',10,'select \'0\'','subject_disp',90,10,'Μαζική Αποστολή SMS',NULL,'display',8,373,250,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select grading_period.name\nfrom school,grading_period\nwhere school.grading_period_id=grading_period.id','select id,short_name from class order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-07-10 22:19:48','globeadmin','2018-08-18 19:16:21','globeadmin','2021-03-24 11:23:15','globeadmin'),('5783feb45a84acd','5476201e5a3d38f',NULL,NULL,'0',10,'select if(student.parent_email is not null and TRIM(student.parent_email)!=\'\',\'1\',\'0\')\nfrom school  \nleft join student on student.id=\'#RECORD_ID#\' \nwhere  school.id=1\n','send_email_parent_img',270,20,'Στοιχεία Επικοινωνίας',NULL,'html',593,935,34,31,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"this.style.cursor=\'pointer\';\"\n                            onmouseout=\"this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=30 height=30 id=\'img_email_parent_send2\' src=\'images/email.png\' title=\'Αποστολή Email\'/>\n        </td>\n    </tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-07-11 23:16:52','globeadmin','2018-08-06 22:17:29','globeadmin','2022-01-08 11:22:28','globeadmin'),('57840b1ed978bd9','562229979f567be',NULL,NULL,'1',10,NULL,'delete_critiria',80,10,'Διαγραφή Όλων','Διαγραφή Κριτηρίων Αξιολόγησης :','checkbox',104,699,30,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-07-12 00:09:50','globeadmin','2016-07-12 00:44:29','globeadmin','2016-07-12 00:44:30','globeadmin'),('57840c937a400d9','562229979f567be',NULL,NULL,'1',10,NULL,'delete_student_class',90,10,'Διαγραφή Όλων','Διαγραφή Κατανομής Μαθητών σε Τμήματα :','checkbox',138,17,30,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-07-12 00:16:03','globeadmin','2016-07-12 00:44:29','globeadmin','2016-07-12 00:44:30','globeadmin'),('5787bce41eec5ca','551821232f9553f',NULL,NULL,'1',10,NULL,'subject_id',50,10,'Αναζήτηση','Μάθημα : ','listbox',47,456,450,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'SELECT distinct\n	subject.id,concat(subject.name,if(subject_type.short_name is NULL,\'\', concat(\' (\',subject_type.short_name,\')\')))\nFROM card \n	inner join subject 			on card.subject_id = subject.id \n	inner join class 			on card.class_id = class.id\n	left  join subject_type 	on subject.subject_type_id = subject_type.id\n	left  join speciality 	on subject.speciality_id = speciality.id\nwhere class.id in (select distinct class_id from student_class where student_id=\'#RECORD_ID#\') and subject.id>=10	\nORDER BY \n	speciality.name,\n    subject.name,\n	subject_type.short_name DESC',NULL,'','','SELECT distinct\n	subject.id,concat(subject.name,if(subject_type.short_name is NULL,\'\', concat(\' (\',subject_type.short_name,\')\')))\nFROM card \n	inner join subject 			on card.subject_id = subject.id \n	inner join class 			on card.class_id = class.id\n	left  join subject_type 	on subject.subject_type_id = subject_type.id\n	left  join speciality 	on subject.speciality_id = speciality.id\nwhere class.id in (select distinct class_id from student_class where student_id=\'#RECORD_ID#\') and subject.id>=10	\nORDER BY \n	speciality.name,\n    subject.name,\n	subject_type.short_name DESC',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-07-14 19:25:08','globeadmin','2016-12-26 10:28:05','globeadmin','2018-08-04 20:57:32','globeadmin'),('5787f3cc76d1d05','5787f33aaa172a1',NULL,NULL,'1',10,NULL,'absence_class_id',30,10,'Απουσιολόγιο','Τμήμα :','dropdown',28,419,150,40,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'SELECT  class.id,\n        class.short_name\nFROM class\nwhere 1=0',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-07-14 23:19:24','globeadmin','2016-07-17 00:40:01','globeadmin','2022-12-21 12:48:23','globeadmin'),('5787f401c762df8','5787f33aaa172a1',NULL,NULL,'1',10,NULL,'period_absence_setbtn',50,10,'Απουσιολόγιο','Καταχώριση','button',22,662,180,35,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-07-14 23:20:17','globeadmin','2021-04-04 15:52:35','globeadmin','2022-12-21 12:48:23','globeadmin'),('5787f4241a0bdc0','5787f33aaa172a1',NULL,NULL,'1',10,NULL,'period_absence_iframe',40,10,'Απουσιολόγιο',NULL,'iframe',72,22,900,1330,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-07-14 23:20:52','globeadmin','2016-07-17 00:40:01','globeadmin','2022-12-21 12:48:23','globeadmin'),('578bca583d62e19','5a54c08c836c142',NULL,NULL,'1',10,NULL,'open_absence_books',10,10,'Παράμετροι','Ανοικτά απουσιολόγια :','checkbox',17,448,20,0,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-07-17 21:11:36','globeadmin','2018-02-03 23:21:16','globeadmin','2022-09-24 23:21:52','globeadmin'),('5787f6505714fb4','5787f33aaa172a1',NULL,NULL,'1',10,NULL,'absence_date',10,10,'Απουσιολόγιο','Ημερομηνία : ','text',26,62,80,40,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from class order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2016-07-14 23:30:08','globeadmin','2016-07-17 00:40:01','globeadmin','2022-12-21 12:48:23','globeadmin'),('5787f6f0682a496','5787f33aaa172a1',NULL,NULL,'1',10,NULL,'absence_period_id',20,10,'Απουσιολόγιο','Ώρα :','dropdown',28,263,80,40,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'SELECT  id,short_name\nFROM period\nwhere 1=1',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-07-14 23:32:48','globeadmin','2016-07-17 00:40:01','globeadmin','2022-12-21 12:48:23','globeadmin'),('5787f85ae71e5f1','5787f33aaa172a1',NULL,NULL,'1',10,'select \'0\'','current_date',60,10,'Απουσιολόγιο','Τρέχουσα Ημερομηνία : ','display',50,11,80,40,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select DATE_FORMAT(curdate(),\'%d-%m-%Y\')',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2016-07-14 23:38:50','globeadmin','2016-07-16 00:42:42','globeadmin','2022-12-21 12:48:23','globeadmin'),('5787f943a533481','5787f33aaa172a1',NULL,NULL,'1',10,'select \'0\'','current_period_id',70,10,'Απουσιολόγιο','Τρέχουσα Διδακτική Ώρα : ','display',50,400,80,40,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select id\nfrom period\nwhere CURTIME() between period.start_time and period.end_time\nlimit 1',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2016-07-14 23:42:43','globeadmin','2016-07-16 00:43:11','globeadmin','2022-12-21 12:48:23','globeadmin'),('578e9c7e006f0ee','578e9b35d4d3cf8',NULL,NULL,'1',10,NULL,'student_home_school_teacher_email',10,10,'Αποστολή Email σε Καθηγητή','Προς :','listbox',18,35,400,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select web_page from school where id=1','select \n    id,\n    CONCAT(IF(surname is null,\'\', concat(surname,\' \')),IFNULL(name,\'\')) as full_name \nfrom teacher \nwhere\n    (email is not null and TRIM(email)<>\'\') or ((select count(*) from zzzsys_user where zzzsys_user_id=user_id and sus_email is not null and TRIM(sus_email)<>\'\')>0)\norder by full_name\n',NULL,'','','select \n    id,\n    CONCAT(IF(surname is null,\'\', concat(surname,\' \')),IFNULL(name,\'\')) as full_name \nfrom teacher \nwhere\n    (email is not null and TRIM(email)<>\'\') or ((select count(*) from zzzsys_user where zzzsys_user_id=user_id and sus_email is not null and TRIM(sus_email)<>\'\')>0)\norder by full_name\n',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-07-20 00:32:46','globeadmin','2016-12-26 11:44:20','globeadmin','2019-07-25 12:18:21','globeadmin'),('578e9cea3b06bed','578e9b35d4d3cf8',NULL,NULL,'1',10,NULL,'student_home_school_text_tinymce',20,10,'Αποστολή Email σε Καθηγητή',NULL,'iframe',50,14,800,400,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'56cc9f04b82528e','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-07-20 00:34:34','globeadmin','2016-07-20 00:44:45','globeadmin','2019-07-25 12:18:21','globeadmin'),('578f9a7b988e9cd','59d7d7da6d30b22',NULL,NULL,'0',10,NULL,'btnimg6',40,10,'Αποστολή και Αναζήτηση Μηνυμάτων',NULL,'html',270,60,220,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'search_email_id\').src=\'images/search_emailb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'search_email_id\').src=\'images/search_email.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'search_email_id\' src=\'images/search_email.png\' title=\'Αναζήτηση Σταλθέντων Email\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Αναζήτηση Σταλθέντων Email</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-07-20 18:36:27','globeadmin','2017-10-07 00:51:18','globeadmin','2017-11-12 16:23:42','globeadmin'),('578f9ae10d67cae','59d7d7da6d30b22',NULL,NULL,'0',10,NULL,'btnimg4',50,10,'Αποστολή και Αναζήτηση Μηνυμάτων',NULL,'html',270,380,220,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'students_email_id\').src=\'images/students_emailb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'students_email_id\').src=\'images/students_email.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'students_email_id\' src=\'images/students_email.png\' title=\'Μαζική Αποστολή Email σε Μαθητές  - Γονείς\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Αποστολή Email σε Μαθητές  - Γονείς</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-07-20 18:38:09','globeadmin','2018-03-10 19:12:50','globeadmin','2018-03-10 19:12:51','globeadmin'),('578f9b47ae8938c','59d7d7da6d30b22',NULL,NULL,'0',10,NULL,'btnimg5',60,10,'Αποστολή και Αναζήτηση Μηνυμάτων',NULL,'html',270,687,220,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'teachers_email_id\').src=\'images/teachers_emailb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'teachers_email_id\').src=\'images/teachers_email.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'teachers_email_id\' src=\'images/teachers_email.png\' title=\'Μαζική Αποστολή Email σε Καθηγητές\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Αποστολή Email σε Καθηγητές</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-07-20 18:39:51','globeadmin','2017-10-07 00:51:18','globeadmin','2017-11-12 16:23:42','globeadmin'),('5791389cbde07b9','5476201e5a3d38f',NULL,NULL,'1',10,NULL,'mothers_surname',60,10,'Στοιχεία Μαθητή','Γένος :','text',268,149,300,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-07-22 00:03:24','globeadmin','2016-07-22 00:03:24','globeadmin','2022-01-08 11:22:26','globeadmin'),('57913bc421a1de2','54a6fde1ab6eb6d',NULL,NULL,'1',10,NULL,'mothers_surname',60,10,'Στοιχεία Μαθητή','Γένος :','text',194,106,300,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-07-22 00:16:52','globeadmin','2016-07-22 00:17:20','globeadmin','2021-09-06 20:12:22','globeadmin'),('57939f0273a2f79','56192b05ed5032f',NULL,NULL,'0',10,'select if(  \'#nu_user_group#\'=\'globeadmin\' or \n            \'#nu_user_group#\'=\'Administrators\' or \n            \'#nu_user_group#\'=\'Managers\',\'1\',\'0\')','system_checkbtn',50,20,'Σύστημα',NULL,'html',192,380,220,100,'l','0','0','','0',NULL,NULL,'1','54a52c3dcf3610b',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'system_check_id\').src=\'images/system_checkb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'system_check_id\').src=\'images/system_check.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'system_check_id\' src=\'images/system_check.png\' title=\'Έλεγχος Συστήματος & Δεδομένων (Υπό Κατασκευή)\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Έλεγχος Συστήματος & Δεδομένων</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-07-23 19:44:50','globeadmin','2018-02-04 20:28:58','globeadmin','2019-07-25 10:13:35','globeadmin'),('5793c8b4ecfc583','56192b05ed5032f',NULL,NULL,'0',10,'select if(  \'#nu_user_group#\'=\'globeadmin\' or \n            \'#nu_user_group#\'=\'Administrators\' or \n            \'#nu_user_group#\'=\'Managers\',\'1\',\'0\')','backupbtn',70,20,'Σύστημα',NULL,'html',330,73,220,100,'l','0','0','','0',NULL,NULL,'1','54a52c3dcf3610b',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'backup_id\').src=\'images/backupb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'backup_id\').src=\'images/backup.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'backup_id\' src=\'images/backup.png\' title=\'Λήψη Αντιγράφου Ασφαλείας της Βάσης Δεδομένων\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Λήψη Αντιγράφου Ασφαλείας ΒΔ</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-07-23 22:42:45','globeadmin','2018-02-04 20:28:58','globeadmin','2019-07-25 10:13:35','globeadmin'),('57dae3598600331','57dae2cd92d16c0',NULL,NULL,'1',10,NULL,'registered_cards_iframe',20,10,'Διδασκαλίες',NULL,'iframe',45,16,900,550,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','SELECT class.short_name\nFROM session_variables\ninner join  class           on class.id         = session_variables.class_id\nWHERE session_variables.session_id=\'#session_id#\'',NULL,NULL,'56e0783347a0891','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2016-09-15 21:07:21','globeadmin','2017-10-07 13:20:51','globeadmin','2017-11-12 16:34:14','globeadmin'),('57ece36a61572ed','57ece27c6e12afd',NULL,NULL,'1',10,NULL,'class_id',10,10,'Ορισμός Υπεύθυνου Καθηγητή','Τμήμα :','dropdown',18,146,150,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name \nfrom class \norder by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-09-29 12:48:26','globeadmin','2016-09-29 12:48:26','globeadmin','2018-06-30 11:49:11','globeadmin'),('57e15cd73f8401c','57e15c6777df58a',NULL,NULL,'0',10,NULL,'label1',10,10,'Δημιουργία Λογαριασμών Γονέων','Επιλέγοντας «Δημιουργία» θα δημιουργηθούν λογαριασμοί για όσους γονείς δεν διαθέτουν ήδη λογαριασμό και το παιδί τους δεν έχει εγκαταλείψει το σχολείο.','words',14,17,1200,30,'l','0','0','','0',NULL,NULL,'0','54aa751b6567046',NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-09-20 18:59:19','globeadmin','2016-09-22 21:49:05','globeadmin','2021-09-07 20:18:34','globeadmin'),('57e172a3872a479','57e15c6777df58a',NULL,NULL,'0',10,NULL,'label2',20,10,'Δημιουργία Λογαριασμών Γονέων','Ο κάθε λογαριασμός θα έχει ως «Όνομα Χρήστη» το ΑΜ-parent και ένα τυχαίο ισχυρό «Κωδικό».','words',14,785,700,30,'l','0','0','','0',NULL,NULL,'0','54aa751b6567046',NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-09-20 20:32:19','globeadmin','2016-09-22 21:50:19','globeadmin','2021-09-07 20:18:34','globeadmin'),('57e1739d360c560','57e15c6777df58a',NULL,NULL,'0',10,NULL,'display1',30,10,'Δημιουργία Λογαριασμών Γονέων',NULL,'iframe',32,155,380,40,'l','0','0','','0',NULL,NULL,'0','54aa751b6567046',NULL,'','','select concat(\'Θα δημιουργθούν -\',count(*),\'- λογαριασμοί γονέων...\') from student where parent_user_id is null and has_left_school=0',NULL,NULL,'57e4314804e765c','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-09-20 20:36:29','globeadmin','2016-09-22 22:54:30','globeadmin','2021-09-07 20:18:34','globeadmin'),('57e17565b40149f','57e15c6777df58a',NULL,NULL,'1',10,NULL,'account_creationbtn',40,10,'Δημιουργία Λογαριασμών Γονέων','Δημιουργία','button',35,569,200,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-09-20 20:44:05','globeadmin','2016-09-20 20:44:05','globeadmin','2021-09-07 20:18:34','globeadmin'),('57e175d515155de','57e15c6777df58a',NULL,NULL,'0',10,NULL,'create_account_iframe',50,10,'Δημιουργία Λογαριασμών Γονέων',NULL,'iframe',80,1,1580,640,'l','0','0','','0',NULL,NULL,'0','54aa751b6567046',NULL,'','',NULL,NULL,NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-09-20 20:45:57','globeadmin','2021-09-07 20:18:51','globeadmin','2021-09-07 20:18:51','globeadmin'),('57e4262a2d28251','57e15c6777df58a',NULL,NULL,'1',10,NULL,'grade_id',60,10,'Δημιουργία Λογαριασμών Γονέων','Τάξη :','dropdown',42,28,80,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id, short_name from grade order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-09-22 21:42:50','globeadmin','2016-09-22 21:53:06','globeadmin','2021-09-07 20:18:34','globeadmin'),('57e69d6b761d79c','57e15c6777df58a',NULL,NULL,'1',10,NULL,'sms_disp',70,10,'Δημιουργία Λογαριασμών Γονέων','Υπόλοιπο SMS Μηνυμάτων :','display',45,1206,60,0,'r','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select IF(\'#sms_limit#\'=\'\',\'UL\',\'#sms_limit#\'-count(*))\nfrom sms\nwhere sender_id=\'#RECORD_ID#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-09-24 18:36:11','globeadmin','2016-09-24 18:36:11','globeadmin','2021-09-07 20:18:34','globeadmin'),('57e6df28465765e','57e6bdac4fee426',NULL,NULL,'1',10,NULL,'msg4',50,10,'Αποστολή Κωδικών Γονέων με Email','-password- => Κωδικός','words',33,536,150,22,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-09-24 23:16:40','globeadmin','2016-09-24 23:25:32','globeadmin','2021-09-07 20:15:26','globeadmin'),('57e6bdf61c82107','57e6bdac4fee426',NULL,NULL,'1',10,NULL,'email_subject',60,10,'Αποστολή Κωδικών Γονέων με Email','Θέμα :','text',69,53,650,22,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-09-24 20:55:02','globeadmin','2016-09-24 23:25:32','globeadmin','2021-09-07 20:15:26','globeadmin'),('57e6be284107090','57e6bdac4fee426',NULL,NULL,'1',10,NULL,'email_text_tinymce',70,10,'Αποστολή Κωδικών Γονέων με Email',NULL,'iframe',115,7,824,380,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'56cc9f04b82528e','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-09-24 20:55:52','globeadmin','2016-09-24 23:25:32','globeadmin','2021-09-07 20:15:26','globeadmin'),('57e6be7d8a97974','57e6bdac4fee426',NULL,NULL,'1',10,NULL,'label1',10,10,'Αποστολή Κωδικών Γονέων με Email','Μήνυμα : ','words',92,32,200,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-09-24 20:57:17','globeadmin','2016-09-24 23:25:32','globeadmin','2021-09-07 20:15:26','globeadmin'),('57e6dd51e139150','57e6bdac4fee426',NULL,NULL,'1',10,NULL,'msg1',20,10,'Αποστολή Κωδικών Γονέων με Email','Συμπληρώστε το θέμα και το περιεχόμενο του μηνύματος που θα σταλεί. Τα παρακάτω αντικαθίστανται ως εξής :','words',10,19,750,22,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-09-24 23:08:50','globeadmin','2016-09-24 23:25:32','globeadmin','2021-09-07 20:15:26','globeadmin'),('57e6de99b6fac6a','57e6bdac4fee426',NULL,NULL,'1',10,NULL,'msg2',30,10,'Αποστολή Κωδικών Γονέων με Email','-student- => Ονοματεπώνυμο Μαθητή','words',33,36,250,22,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-09-24 23:14:17','globeadmin','2016-09-24 23:25:32','globeadmin','2021-09-07 20:15:26','globeadmin'),('57e6df1b6fdd6ac','57e6bdac4fee426',NULL,NULL,'1',10,NULL,'msg3',40,10,'Αποστολή Κωδικών Γονέων με Email','-username- => Όνομα Χρήστη','words',33,311,200,22,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-09-24 23:16:27','globeadmin','2016-09-24 23:25:32','globeadmin','2021-09-07 20:15:26','globeadmin'),('57e78df98dfebbd','56192b05ed5032f',NULL,NULL,'0',10,'select if(  \'#nu_user_group#\'=\'globeadmin\' or \n            \'#nu_user_group#\'=\'Administrators\' or \n            \'#nu_user_group#\'=\'Managers\',\'1\',\'0\')','create_parent_accountbtn',60,10,'Σχολείο',NULL,'html',192,687,220,100,'l','0','0','','0',NULL,NULL,'0','54aa751b6567046',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'parents_create_accounts_id\').src=\'images/parents_create_accountsb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'parents_create_accounts_id\').src=\'images/parents_create_accounts.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=98 height=74 id=\'parents_create_accounts_id\' src=\'images/parents_create_accounts.png\' title=\'Αυτόματη δημιουργία λογαριασμού χρήστη για κάθε γονέα\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Δημιουργία Λογαριασμών Γονέων</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-09-25 11:42:33','globeadmin','2017-10-28 22:12:05','globeadmin','2019-07-25 10:13:35','globeadmin'),('57ece40d2db2cfe','57ece27c6e12afd',NULL,NULL,'1',10,NULL,'teacher_id',20,10,'Ορισμός Υπεύθυνου Καθηγητή','Νέος Υπεύθυνος Καθηγητής :','dropdown',54,20,350,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select  id,\n        concat(if(surname is null,\'\',concat(surname,\' \')), IFNULL(name,\'\')) as teacher_full_name\nfrom teacher\norder by teacher_full_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-09-29 12:51:09','globeadmin','2018-06-30 11:48:24','globeadmin','2018-06-30 11:49:11','globeadmin'),('57ed5598217a263','57ece27c6e12afd',NULL,NULL,'1',10,NULL,'search_iframe',40,10,'Ορισμός Υπεύθυνου Καθηγητή',NULL,'iframe',89,19,900,600,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select  id,\n        concat(if(surname is null,\'\',concat(surname,\' \')), IFNULL(name,\'\')) as teacher_full_name\nfrom teacher\norder by teacher_full_name',NULL,'57ed57dd13deb39','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-09-29 20:55:36','globeadmin','2016-09-29 23:03:23','globeadmin','2018-06-30 11:49:11','globeadmin'),('57ed564c12604cf','57ece27c6e12afd',NULL,NULL,'1',10,NULL,'set_btn',30,10,'Ορισμός Υπεύθυνου Καθηγητή','Ορισμός','button',44,615,160,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select  id,\n        concat(if(surname is null,\'\',concat(surname,\' \')), IFNULL(name,\'\')) as teacher_full_name\nfrom teacher\norder by teacher_full_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-09-29 20:58:36','globeadmin','2016-09-29 21:42:00','globeadmin','2018-06-30 11:49:11','globeadmin'),('57ffc0aea33e77a','572b615e795d4d1',NULL,NULL,'1',10,NULL,'ifile',50,10,'Μαζική Αποστολή Email',NULL,'iframe',472,207,600,50,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from class order by short_name',NULL,'54da24749d82eb7','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-10-13 20:13:18','globeadmin','2016-10-15 15:56:08','globeadmin','2021-02-27 09:46:01','globeadmin'),('58022a074022435','572af54adfe5517',NULL,NULL,'1',10,NULL,'label2',20,10,'Μαζική Αποστολή Email','Επισύναψη Αρχείου : ','words',481,66,150,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from class order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-10-15 16:07:19','globeadmin','2016-10-15 16:07:19','globeadmin','2021-12-11 20:34:13','globeadmin'),('5802232eafaac00','572b615e795d4d1',NULL,NULL,'0',10,NULL,'remove_attachment_img',60,10,'Μαζική Αποστολή Email',NULL,'html',481,39,19,19,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"this.style.cursor=\'pointer\';\"\n                            onmouseout=\"this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=17 height=17 id=\'img_remove_attachment\' src=\'images/reset_pass.png\' title=\'Επαναφορά Συνημμένου\'/>\n        </td>\n    </tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-10-15 15:38:06','globeadmin','2016-10-15 15:56:08','globeadmin','2021-02-27 09:46:01','globeadmin'),('58022a49167805e','572af54adfe5517',NULL,NULL,'1',10,NULL,'ifile',50,10,'Μαζική Αποστολή Email',NULL,'iframe',472,207,600,50,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from class order by short_name',NULL,'54da24749d82eb7','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-10-15 16:08:25','globeadmin','2016-10-15 16:08:25','globeadmin','2021-12-11 20:34:13','globeadmin'),('58022a6cb9fa23a','572af54adfe5517',NULL,NULL,'0',10,NULL,'remove_attachment_img',60,10,'Μαζική Αποστολή Email',NULL,'html',481,39,19,19,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"this.style.cursor=\'pointer\';\"\n                            onmouseout=\"this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=17 height=17 id=\'img_remove_attachment\' src=\'images/reset_pass.png\' title=\'Επαναφορά Συνημμένου\'/>\n        </td>\n    </tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-10-15 16:09:00','globeadmin','2016-10-15 16:09:00','globeadmin','2021-12-11 20:34:13','globeadmin'),('580232d941777b4','578e9b35d4d3cf8',NULL,NULL,'1',10,NULL,'label2',30,10,'Αποστολή Email σε Καθηγητή','Επισύναψη Αρχείου : ','words',470,66,150,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from class order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-10-15 16:44:57','globeadmin','2016-10-15 16:45:49','globeadmin','2019-07-25 12:18:21','globeadmin'),('5802336a6d05e74','578e9b35d4d3cf8',NULL,NULL,'1',10,NULL,'ifile',40,10,'Αποστολή Email σε Καθηγητή',NULL,'iframe',460,210,600,50,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from class order by short_name',NULL,'54da24749d82eb7','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-10-15 16:47:22','globeadmin','2016-10-15 16:47:22','globeadmin','2019-07-25 12:18:21','globeadmin'),('580233fdd81161d','578e9b35d4d3cf8',NULL,NULL,'0',10,NULL,'remove_attachment_img',50,10,'Αποστολή Email σε Καθηγητή',NULL,'html',470,35,19,19,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"this.style.cursor=\'pointer\';\"\n                            onmouseout=\"this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=17 height=17 id=\'img_remove_attachment\' src=\'images/reset_pass.png\' title=\'Επαναφορά Συνημμένου\'/>\n        </td>\n    </tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-10-15 16:49:49','globeadmin','2016-10-15 16:49:50','globeadmin','2019-07-25 12:18:21','globeadmin'),('580256bc4baedd5','54df1259eb4def9',NULL,NULL,'0',10,NULL,'remove_attachment_img',40,10,'Εισαγωγή',NULL,'html',47,31,19,19,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"this.style.cursor=\'pointer\';\"\n                            onmouseout=\"this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=17 height=17 id=\'img_remove_attachment\' src=\'images/reset_pass.png\' title=\'Επαναφορά Αρχείου\'/>\n        </td>\n    </tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-10-15 19:18:04','globeadmin','2016-10-15 19:21:39','globeadmin','2020-04-03 20:25:18','globeadmin'),('5802580091ccd40','54df1dbf0f931e5',NULL,NULL,'0',10,NULL,'remove_attachment_img',40,10,'Εισαγωγή',NULL,'html',57,13,19,19,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"this.style.cursor=\'pointer\';\"\n                            onmouseout=\"this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=17 height=17 id=\'img_remove_attachment\' src=\'images/reset_pass.png\' title=\'Επαναφορά Αρχείου\'/>\n        </td>\n    </tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-10-15 19:23:28','globeadmin','2016-10-15 19:26:30','globeadmin','2020-09-24 18:44:36','globeadmin'),('580259233bb6c04','54d65f0144e61a3',NULL,NULL,'0',10,NULL,'remove_attachment_img',40,10,'Εισαγωγή',NULL,'html',52,12,19,19,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"this.style.cursor=\'pointer\';\"\n                            onmouseout=\"this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=17 height=17 id=\'img_remove_attachment\' src=\'images/reset_pass.png\' title=\'Επαναφορά Αρχείου\'/>\n        </td>\n    </tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-10-15 19:28:19','globeadmin','2016-10-15 19:29:52','globeadmin','2018-07-02 09:23:40','globeadmin'),('58025a102050760','54df20f94548357',NULL,NULL,'0',10,NULL,'remove_attachment_img',50,10,'Εισαγωγή',NULL,'html',73,16,19,19,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"this.style.cursor=\'pointer\';\"\n                            onmouseout=\"this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=17 height=17 id=\'img_remove_attachment\' src=\'images/reset_pass.png\' title=\'Επαναφορά Αρχείου\'/>\n        </td>\n    </tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-10-15 19:32:16','globeadmin','2016-10-15 19:32:16','globeadmin','2020-04-02 16:11:52','globeadmin'),('580271568467c6a','59e22f4f52546e3',NULL,NULL,'1',10,NULL,'ifile',30,10,'Αποστολή Μηνύματος',NULL,'iframe',22,591,420,50,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from class order by short_name',NULL,'54da24749d82eb7','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-10-15 21:11:34','globeadmin','2017-10-15 15:48:13','globeadmin','2021-02-16 15:14:13','globeadmin'),('580273a87e00946','59e22f4f52546e3',NULL,NULL,'1',10,NULL,'attach_label',20,10,'Αποστολή Μηνύματος','Επισύναψη Αρχείου : ','words',32,453,150,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from class order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-10-15 21:21:28','globeadmin','2017-10-15 15:48:13','globeadmin','2021-02-16 15:14:13','globeadmin'),('5802758277e0be7','59e22f4f52546e3',NULL,NULL,'0',10,NULL,'remove_attachment_img',70,10,'Αποστολή Μηνύματος',NULL,'html',31,426,19,19,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"this.style.cursor=\'pointer\';\"\n                            onmouseout=\"this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=17 height=17 id=\'img_remove_attachment\' src=\'images/reset_pass.png\' title=\'Επαναφορά Συνημμένου\'/>\n        </td>\n    </tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-10-15 21:29:22','globeadmin','2017-10-15 15:48:13','globeadmin','2021-02-16 15:14:14','globeadmin'),('580276f77e49784','59e22f4f52546e3',NULL,NULL,'1',10,NULL,'msg_label',60,10,'Αποστολή Μηνύματος','Μήνυμα :','words',64,23,150,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from class order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-10-15 21:35:35','globeadmin','2017-10-15 15:48:13','globeadmin','2021-02-16 15:14:13','globeadmin'),('580b29ba8a439e9','5a54c08c836c142',NULL,NULL,'1',10,NULL,'exam_day_limit',50,10,'Παράμετροι','Όριο διαγωνισμάτων μαθητή ανά ημέρα :','text',166,345,40,0,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2016-10-22 11:56:26','globeadmin','2018-02-03 23:21:16','globeadmin','2022-09-24 23:21:52','globeadmin'),('580b29f85465834','5a54c08c836c142',NULL,NULL,'1',10,NULL,'absence_total_limit',60,10,'Παράμετροι','Όριο συνόλου απουσιών :','text',121,432,40,0,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2016-10-22 11:57:28','globeadmin','2018-02-03 23:21:16','globeadmin','2022-09-24 23:21:53','globeadmin'),('580b2a964f23271','5a54c08c836c142',NULL,NULL,'1',10,NULL,'hide_teaching_calendar',80,10,'Παράμετροι','Απόκρυψη ημερολογίων διδασκαλιών  από τους Γονείς/Μαθητές :','checkbox',257,208,20,0,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-10-22 12:00:06','globeadmin','2018-02-03 23:21:16','globeadmin','2022-09-24 23:21:53','globeadmin'),('580b2f408cc6cec','56e98e66abfe2c1',NULL,NULL,'1',10,NULL,'hide_to_student',100,10,'Σχόλια Καθηγητή',NULL,'checkbox',503,889,30,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-10-22 12:20:00','globeadmin','2016-10-22 12:28:46','globeadmin','2021-03-24 11:21:28','globeadmin'),('580ba2f267595b9','580ba2a48260384',NULL,NULL,'1',10,NULL,'date_enforced',10,10,'Υποβολή Παρατήρησης / Ποινής','Ημερομηνία Ποινής :','text',19,8,80,0,'r','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,'#nuSepEditnuSepr#varchar',NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',100,250,'2016-10-22 20:33:38','globeadmin','2016-10-23 12:12:26','globeadmin','2021-10-20 23:47:23','globeadmin'),('580b30823fe9ca7','56e98e66abfe2c1',NULL,NULL,'1',10,NULL,'hide_to_student_label',90,10,'Σχόλια Καθηγητή','Απόκρυψη σχολίων από το Μαθητή και εμφάνιση τους μόνο στο Γονέα :','words',511,472,450,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-10-22 12:25:22','globeadmin','2016-10-22 13:57:33','globeadmin','2021-03-24 11:21:28','globeadmin'),('580ba317a1d583f','580ba2a48260384',NULL,NULL,'1',10,NULL,'date_added',40,10,'Υποβολή Παρατήρησης / Ποινής',NULL,'text',103,419,150,0,'r','0','1','select NOW()','0',NULL,NULL,NULL,NULL,NULL,'','','select DATE_FORMAT(date_added,\'%d-%m-%Y %T\')\nfrom penalty\nwhere id=\'#RECORD_ID#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-10-22 20:34:15','globeadmin','2016-10-23 12:12:26','globeadmin','2021-10-20 23:47:23','globeadmin'),('580ba33470efa5d','580ba2a48260384',NULL,NULL,'1',10,NULL,'type',20,10,'Υποβολή Παρατήρησης / Ποινής','Τύπος :','dropdown',121,87,250,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'SELECT name as nm1,name as nm2\nFROM penalty_type\nWHERE\n    penalty_type.teacher_access=1 and\n    penalty_type.on_absence_table=1',NULL,'','',NULL,NULL,NULL,'#nuSepEditnuSepr#varchar',NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-10-22 20:34:44','globeadmin','2018-01-04 17:10:37','globeadmin','2021-10-20 23:47:23','globeadmin'),('580ba34cbc92a21','580ba2a48260384',NULL,NULL,'1',10,NULL,'reason',70,10,'Υποβολή Παρατήρησης / Ποινής','Σχόλια :','textarea',157,85,600,200,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-10-22 20:35:08','globeadmin','2016-10-23 12:12:26','globeadmin','2021-10-20 23:47:23','globeadmin'),('580baa3cb0edd9e','580ba2a48260384',NULL,NULL,'1',10,NULL,'period_id',30,10,'Υποβολή Παρατήρησης / Ποινής','Διδακτική Ώρα :','dropdown',19,236,60,0,'r','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name\nfrom period\n',NULL,'','',NULL,NULL,NULL,'#nuSepEditnuSepr#varchar',NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',100,250,'2016-10-22 21:04:44','globeadmin','2016-10-23 12:12:26','globeadmin','2021-10-20 23:47:23','globeadmin'),('580bab45add949d','580ba2a48260384',NULL,NULL,'1',10,NULL,'student_name',50,10,'Υποβολή Παρατήρησης / Ποινής','Μαθητής :','text',52,70,450,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'Καθυστερημένη Είσοδος|Καθυστερημένη Είσοδος|Παρατήρηση|Παρατήρηση|Επίπληξη|Επίπληξη',NULL,'','',NULL,NULL,NULL,'#nuSepEditnuSepr#varchar',NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-10-22 21:09:09','globeadmin','2016-10-23 12:12:26','globeadmin','2021-10-20 23:47:23','globeadmin'),('580bab5f3624e6c','580ba2a48260384',NULL,NULL,'1',10,NULL,'student_id',60,10,'Υποβολή Παρατήρησης / Ποινής',NULL,'text',43,618,50,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'Καθυστερημένη Είσοδος|Καθυστερημένη Είσοδος|Παρατήρηση|Παρατήρηση|Επίπληξη|Επίπληξη',NULL,'','',NULL,NULL,NULL,'#nuSepEditnuSepr#varchar',NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-10-22 21:09:35','globeadmin','2016-10-23 12:12:26','globeadmin','2021-10-20 23:47:23','globeadmin'),('580babe86dfa41a','580ba2a48260384',NULL,NULL,'1',10,NULL,'teacher_id',80,10,'Υποβολή Παρατήρησης / Ποινής','Καθηγητής :','dropdown',85,58,300,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select  id,\n        concat(if(surname is null,\'\',concat(surname,\' \')), IFNULL(name,\'\')) as teacher_full_name\nfrom teacher\norder by teacher_full_name',NULL,'','',NULL,NULL,NULL,'#nuSepEditnuSepr#varchar',NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-10-22 21:11:52','globeadmin','2016-11-17 19:41:59','globeadmin','2021-10-20 23:47:23','globeadmin'),('580bac33b221d33','580ba2a48260384',NULL,NULL,'1',10,NULL,'carrier',90,10,'Υποβολή Παρατήρησης / Ποινής',NULL,'text',378,17,300,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'Καθυστερημένη Είσοδος|Καθυστερημένη Είσοδος|Παρατήρηση|Παρατήρηση|Επίπληξη|Επίπληξη',NULL,'','',NULL,NULL,NULL,'#nuSepEditnuSepr#varchar',NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-10-22 21:13:07','globeadmin','2016-11-17 19:44:45','globeadmin','2021-10-20 23:47:23','globeadmin'),('580c84220b7708b','554517bdc18334d',NULL,NULL,'1',10,NULL,'period_id',50,10,'Λεπτομέρειες','Διδακτική Ώρα :','dropdown',190,281,80,0,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name\nfrom period',NULL,'','',NULL,NULL,NULL,'#nuSepEditnuSepr#varchar',NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',100,250,'2016-10-23 12:34:26','globeadmin','2016-10-23 12:34:26','globeadmin','2022-01-07 21:47:53','globeadmin'),('580cdf4b68ffe50','580cdf151b06780',NULL,NULL,'1',10,NULL,'label1',10,10,'Αναζήτηση','Επιλέξτε από τα παρακάτω κριτήρια αναζήτησης. Αφήνοντας κενό ένα κριτήριο, εμφανίζονται όλες οι αντίστοιχες ποινές.','words',13,15,750,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from class order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-10-23 19:03:23','globeadmin','2016-10-23 19:51:05','globeadmin','2021-10-24 21:40:44','globeadmin'),('580cdf694e16f3c','580cdf151b06780',NULL,NULL,'1',10,NULL,'from_date',20,10,'Αναζήτηση','Από : ','text',44,9,80,30,'r','0','0','select curdate()','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2016-10-23 19:03:53','globeadmin','2016-10-23 19:03:53','globeadmin','2021-10-24 21:41:13','globeadmin'),('580cdf86d1d731a','580cdf151b06780',NULL,NULL,'1',10,NULL,'to_date',30,10,'Αναζήτηση','Έως : ','text',44,141,80,30,'r','0','0','select curdate()','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2016-10-23 19:04:22','globeadmin','2016-10-23 19:04:22','globeadmin','2021-10-24 21:41:40','globeadmin'),('580cdfc1a0e32dc','580cdf151b06780',NULL,NULL,'1',10,NULL,'student_id',60,10,'Αναζήτηση','Μαθητής : ','dropdown',85,10,350,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select distinct student.id, concat(ifNULL(grade.short_name,\'\'),\' - \',student.surname,\' \',student.name,\' \',student.fathers_name) \nfrom student\ninner join penalty on penalty.student_id = student.id\nleft join grade on grade.id = student.grade_id\nwhere 1\norder by student.grade_id,student.surname,student.name,student.fathers_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-10-23 19:05:21','globeadmin','2018-03-05 19:16:32','globeadmin','2021-10-24 21:43:47','globeadmin'),('5aa3f43e2af586f','59e22f9965b5362',NULL,NULL,'1',10,'SELECT IF(\'#nu_user_group#\'=\'Students\' AND hide_student_absence=1,\'0\',\'1\')\nFROM school WHERE id=1','absence_counts_insystem_disp',130,10,'Απουσίες','Μετρήσιμες απουσίες ΕΝΤΟΣ συστήματος :','display',50,72,50,30,'c','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select count(*)\nfrom absence \nwhere \nstudent_id=\'#RECORD_ID#\' and \ncounts=1;',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-03-10 17:05:34','globeadmin','2019-11-13 12:58:00','globeadmin','2020-04-02 16:25:31','globeadmin'),('5aa192ffad5801a','59e22f9965b5362',NULL,NULL,'1',10,'SELECT IF(\'#nu_user_group#\'=\'Students\' AND hide_student_absence=1,\'0\',\'1\')\nFROM school WHERE id=1','prev_total_absences',20,10,'Απουσίες','Μετρήσιμες απουσίες ΕΚΤΟΣ συστήματος :','display',16,72,50,30,'c','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select ifNULL(prev_an_justified_absences,0)+ifNULL(prev_justified_absences,0)\nfrom student \nwhere id=\'#RECORD_ID#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-03-08 21:46:07','globeadmin','2019-11-13 12:53:48','globeadmin','2020-04-02 16:25:30','globeadmin'),('580ce6fd065f33e','580cdf151b06780',NULL,NULL,'1',10,NULL,'type',40,10,'Αναζήτηση','Τύπος Ποινής : ','listbox',43,272,250,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select distinct type,type\nfrom penalty\norder by type',NULL,'','','select distinct type,type\nfrom penalty\norder by type',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-10-23 19:36:13','globeadmin','2018-01-04 19:33:02','globeadmin','2021-10-24 21:42:34','globeadmin'),('580ce025766533d','580cdf151b06780',NULL,NULL,'1',10,NULL,'searchbtn',80,10,'Αναζήτηση','Αναζήτηση','button',126,45,150,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from teacher order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-10-23 19:07:01','globeadmin','2016-10-23 19:07:01','globeadmin','2021-10-25 15:50:05','globeadmin'),('580ce04bcdf0f7a','580cdf151b06780',NULL,NULL,'1',10,'select \'0\'','current_date',100,10,'Αναζήτηση','Τρέχουσα Ημ/νια : ','display',10,973,80,30,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select DATE_FORMAT(curdate(),\'%d-%m-%Y\')',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-10-23 19:07:39','globeadmin','2016-10-23 20:32:46','globeadmin','2021-10-24 21:46:48','globeadmin'),('580ce07b5107672','580cdf151b06780',NULL,NULL,'1',10,NULL,'search_iframe',100,10,'Αναζήτηση',NULL,'iframe',182,17,950,350,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from teacher order by short_name',NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-10-23 19:08:27','globeadmin','2018-07-13 19:48:42','globeadmin','2021-10-24 21:45:45','globeadmin'),('580ce0b5298af04','580cdf151b06780',NULL,NULL,'1',10,NULL,'teacher_id',50,10,'Αναζήτηση','Καθηγητής : ','dropdown',46,645,250,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select  id,\n        concat(if(surname is null,\'\',concat(surname,\' \')), IFNULL(name,\'\')) as teacher_full_name\nfrom teacher\norder by teacher_full_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-10-23 19:09:25','globeadmin','2018-01-15 19:17:27','globeadmin','2021-10-24 21:43:15','globeadmin'),('5a5ce2bca5d9736','580cdf151b06780',NULL,NULL,'1',10,NULL,'class_id',70,10,'Αναζήτηση','Τμήμα : ','dropdown',85,450,80,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name\nfrom class\norder by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-01-15 19:19:56','globeadmin','2018-01-15 19:20:19','globeadmin','2021-10-24 21:44:27','globeadmin'),('58402a6390adae4','54a6fde1ab6eb6d',NULL,NULL,'0',10,NULL,'notification_choices_img',130,10,'Στοιχεία Μαθητή',NULL,'html',348,77,200,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0  \n                            onmouseover=\"document.getElementById(\'img_notification_id\').src=\'images/notification_typeb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_notification_id\').src=\'images/notification_type.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_notification_id\' src=\'images/notification_type.png\' title=\'Επιλογές Ειδοποιήσεων\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Επιλογές Ειδοποιήσεων</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-12-01 15:49:23','globeadmin','2016-12-02 09:51:59','globeadmin','2021-09-06 20:12:22','globeadmin'),('580ce7bc2aa1db9','580cdf151b06780',NULL,NULL,'1',10,NULL,'carrier',70,10,'Αναζήτηση','Φορέας Επιβολής : ','dropdown',85,605,250,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select distinct TRIM(ifNULL(carrier,\'-\')),TRIM(ifNULL(carrier,\'ΔΕΝ ΕΧΕΙ ΟΡΙΣΤΕΙ\'))\nfrom penalty\norder by TRIM(carrier)',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-10-23 19:39:24','globeadmin','2018-01-08 16:55:10','globeadmin','2021-10-24 21:35:23','globeadmin'),('580da136ca4c9d4','59d7d7986aed52d',NULL,NULL,'0',10,NULL,'penaltybtn',50,10,'Αξιολόγηση Μαθητών και Ποινές',NULL,'html',270,380,220,100,'l','0','0','','0',NULL,NULL,NULL,'554517bdc18334d',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_cards_id\').src=\'images/cardsb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_cards_id\').src=\'images/cards.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_cards_id\' src=\'images/cards.png\' title=\'Ποινές Μαθητών\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Ποινές</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-10-24 08:50:46','globeadmin','2018-01-04 18:37:08','globeadmin','2022-01-08 11:00:10','globeadmin'),('580e3164bd9d5d9','580e312bc544f2e',NULL,NULL,'1',10,NULL,'link1',10,10,'Εισαγωγή','Δείγμα .xls Αρχείου  : ','html',12,29,70,25,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<a href=\'sample/absence.xls\' download>Λήψη</a>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-10-24 19:05:56','globeadmin','2016-10-24 19:11:56','globeadmin','2022-02-11 21:16:33','globeadmin'),('580e31857423c99','580e312bc544f2e',NULL,NULL,'1',10,NULL,'label1',20,10,'Εισαγωγή','Αρχείο : ','words',53,60,100,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-10-24 19:06:29','globeadmin','2016-10-24 19:06:29','globeadmin','2022-02-11 21:16:33','globeadmin'),('580e31adabf8b47','580e312bc544f2e',NULL,NULL,'1',10,NULL,'ifile',30,10,'Εισαγωγή',NULL,'iframe',45,129,350,50,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'54da24749d82eb7','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-10-24 19:07:09','globeadmin','2016-10-24 19:07:09','globeadmin','2022-02-11 21:16:33','globeadmin'),('580e31cabf56abb','580e312bc544f2e',NULL,NULL,'0',10,NULL,'remove_attachment_img',40,10,'Εισαγωγή',NULL,'html',52,28,19,19,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"this.style.cursor=\'pointer\';\"\n                            onmouseout=\"this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=17 height=17 id=\'img_remove_attachment\' src=\'images/reset_pass.png\' title=\'Επαναφορά Αρχείου\'/>\n        </td>\n    </tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-10-24 19:07:38','globeadmin','2016-10-24 19:07:38','globeadmin','2022-02-11 21:16:33','globeadmin'),('5810d3b1c4b94cf','56192b05ed5032f',NULL,NULL,'0',10,NULL,'upload_absencesbtn',50,10,'Σχολείο',NULL,'html',192,380,220,100,'l','0','0','','0',NULL,NULL,'0','54df20f94548357',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_upabsences_id\').src=\'images/absences_uploadb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_upabsences_id\').src=\'images/absences_upload.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_upabsences_id\' src=\'images/absences_upload.png\' title=\'Εισαγωγή συνόλων απουσιών εκτός συστήματος\'/>\n            \n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Εισαγωγή Απουσιών Εκτός Συστήματος</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-10-26 19:02:58','globeadmin','2017-10-28 22:12:05','globeadmin','2019-07-25 10:13:35','globeadmin'),('580e323d975931a','580e312bc544f2e',NULL,NULL,'1',10,NULL,'insert_iframe',60,10,'Εισαγωγή',NULL,'iframe',105,19,910,350,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'580e35e0d0e50a6','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-10-24 19:09:33','globeadmin','2018-07-02 09:31:50','globeadmin','2022-02-11 21:16:33','globeadmin'),('580e3257860f2c0','580e312bc544f2e',NULL,NULL,'1',10,NULL,'insert_file_btn',60,10,'Εισαγωγή','Εισαγωγή Αρχείου','button',45,577,170,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-10-24 19:09:59','globeadmin','2016-10-25 21:06:35','globeadmin','2022-02-11 21:16:33','globeadmin'),('5811d1af3bc973b','54a6fde1ab6eb6d',NULL,NULL,'1',10,NULL,'advisor_id',110,10,'Στοιχεία Μαθητή','Ατομικός Σύμβουλος Μαθητή :','display',152,565,250,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select concat(if(surname is null,\'\',concat(surname,\' \')), IFNULL(name,\'\')) from teacher where id=\'#advisor_id#\'\n','select id,concat(if(surname is null,\'\',concat(surname,\' \')), IFNULL(name,\'\')) from teacher',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2016-10-27 13:06:39','globeadmin','2016-10-27 13:06:39','globeadmin','2021-09-06 20:12:22','globeadmin'),('5811d3ccc9e777a','5476201e5a3d38f',NULL,NULL,'1',10,NULL,'advisor_id',170,10,'Στοιχεία Μαθητή','Ατομικός Σύμβουλος Μαθητή :','dropdown',315,542,250,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select concat(if(surname is null,\'\',concat(surname,\' \')), IFNULL(name,\'\')) from teacher where id=\'#teacher_id#\'','select  id,\n        concat(if(surname is null,\'\',concat(surname,\' \')), IFNULL(name,\'\')) as teacher_full_name\nfrom teacher\norder by teacher_full_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2016-10-27 13:15:40','globeadmin','2016-10-27 13:15:40','globeadmin','2022-01-08 11:22:26','globeadmin'),('58146a5db4ce238','581469f72e8002c',NULL,NULL,'1',10,NULL,'set_btn',30,10,'Ορισμός Ατομικού Συμβούλου','Ορισμός','button',46,599,160,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select  id,\n        concat(if(surname is null,\'\',concat(surname,\' \')), IFNULL(name,\'\')) as teacher_full_name\nfrom teacher\norder by teacher_full_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-10-29 12:22:37','globeadmin','2016-10-29 12:26:18','globeadmin','2018-12-04 21:22:37','globeadmin'),('58146a174bd04b6','581469f72e8002c',NULL,NULL,'1',10,NULL,'class_id',10,10,'Ορισμός Ατομικού Συμβούλου','Τμήμα :','dropdown',15,146,150,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name \nfrom class \norder by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-10-29 12:21:27','globeadmin','2016-10-29 12:26:18','globeadmin','2018-12-04 21:21:21','globeadmin'),('58146a45447f93d','581469f72e8002c',NULL,NULL,'1',10,NULL,'advisor_id',20,10,'Ορισμός Ατομικού Συμβούλου','Νέος Σύμβουλος Μαθητών :','dropdown',56,29,350,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select  id,\n        concat(if(surname is null,\'\',concat(surname,\' \')), IFNULL(name,\'\')) as teacher_full_name\nfrom teacher\norder by teacher_full_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-10-29 12:22:13','globeadmin','2018-06-30 09:49:22','globeadmin','2018-12-04 21:22:09','globeadmin'),('581251c8032fc94','5812516a1bf18a5',NULL,NULL,'1',10,NULL,'student_name',40,10,'Καταχώριση Απουσίας','Μαθητής :','text',93,62,400,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-10-27 22:13:12','globeadmin','2016-10-27 22:19:33','globeadmin','2022-09-24 23:07:26','globeadmin'),('581251dd64b96c8','5812516a1bf18a5',NULL,NULL,'1',10,NULL,'absence_type',50,10,'Καταχώριση Απουσίας','Είδος Απουσίας : ','dropdown',147,15,200,40,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,name from absence_reason order by id',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2016-10-27 22:13:33','globeadmin','2016-10-27 22:13:33','globeadmin','2022-09-24 23:07:26','globeadmin'),('5812519f05c4923','5812516a1bf18a5',NULL,NULL,'1',10,NULL,'period',20,10,'Καταχώριση Απουσίας','Ώρα : ','dropdown',37,234,50,40,'c','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from period order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2016-10-27 22:12:31','globeadmin','2016-10-27 22:21:07','globeadmin','2022-09-24 23:07:26','globeadmin'),('581251b3e3d57ca','5812516a1bf18a5',NULL,NULL,'1',10,NULL,'student',30,10,'Καταχώριση Απουσίας',NULL,'text',33,358,100,40,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-10-27 22:12:52','globeadmin','2016-10-27 22:17:15','globeadmin','2022-09-24 23:07:26','globeadmin'),('5812518aa9712c6','5812516a1bf18a5',NULL,NULL,'1',10,NULL,'absence_date',10,10,'Καταχώριση Απουσίας','Ημερομηνία : ','text',39,40,80,40,'r','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2016-10-27 22:12:10','globeadmin','2016-10-27 22:20:52','globeadmin','2022-09-24 23:07:26','globeadmin'),('58146aa0950cdb2','581469f72e8002c',NULL,NULL,'1',10,NULL,'search_iframe',40,10,'Ορισμός Ατομικού Συμβούλου',NULL,'iframe',92,19,900,600,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select  id,\n        concat(if(surname is null,\'\',concat(surname,\' \')), IFNULL(name,\'\')) as teacher_full_name\nfrom teacher\norder by teacher_full_name',NULL,'58146cff692dbf3','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-10-29 12:23:44','globeadmin','2016-10-29 12:38:20','globeadmin','2018-12-04 21:23:14','globeadmin'),('583f17697f712c5','56192b05ed5032f',NULL,NULL,'0',10,NULL,'set_student_advisorbtn',80,10,'Σχολείο',NULL,'html',330,380,220,100,'l','0','0','','0',NULL,NULL,'0','54b2d9dd8417a3d',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_advisor_id\').src=\'images/advisorb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_advisor_id\').src=\'images/advisor.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=98 height=74 id=\'img_advisor_id\' src=\'images/advisor.png\' title=\'Ορισμός ατομικού συμβούλου μαζικά για μαθητές\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Ορισμός Ατομικού Συμβούλου Μαθητών</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-11-30 20:16:09','globeadmin','2017-10-28 22:12:05','globeadmin','2019-07-25 10:13:35','globeadmin'),('58275ecec7b079b','58275eceb901234',NULL,NULL,'1',10,NULL,'name',10,10,'Λεπτομέρειες','Όνομα :','text',31,61,400,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2016-11-15 18:08:40','globeadmin','2016-11-16 19:06:33','globeadmin'),('58275ececefea4b','58275eceb901234',NULL,NULL,'1',10,NULL,'header',20,10,'Λεπτομέρειες','Κεφαλίδα στο Μήνυμα :','textarea',142,50,500,80,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2016-11-15 18:07:37','globeadmin','2016-11-16 19:06:33','globeadmin'),('58275eced64c847','58275eceb901234',NULL,NULL,'1',10,NULL,'hierarchy',30,10,'Λεπτομέρειες','Ιεραρχία :','text',31,550,40,0,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'0000-00-00 00:00:00','','2016-11-15 18:09:21','globeadmin','2016-11-16 19:06:33','globeadmin'),('582762fe2df9542','582762fe10beed3',NULL,NULL,'1',10,NULL,'name',10,10,'Λεπτομέρειες','Όνομα : ','text',24,62,400,0,'l','1','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2016-11-20 10:25:55','globeadmin','2016-12-06 16:54:32','globeadmin'),('582762fe354c2f2','582b3fe8c3f39e6',NULL,NULL,'1',10,NULL,'header',10,10,'Κεφαλίδα','Κεφαλίδα Ειδοποιήσεων :','textarea',50,30,700,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2016-11-15 19:05:09','globeadmin','2016-11-20 18:21:23','globeadmin'),('582762fe3c9f405','582b40cc7c93c9c',NULL,NULL,'1',10,'SELECT \'0\'','content',10,10,'Περιεχόμενο Ειδοποίησης','Περιεχόμενο : ','textarea',423,50,300,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2016-11-18 18:33:32','globeadmin','2016-11-18 19:12:14','globeadmin'),('582762fe43f749c','582762fe10beed3',NULL,NULL,'1',10,NULL,'active',30,10,'Λεπτομέρειες','Ενεργό : ','checkbox',58,58,100,0,'l','0','0','select \'1\'','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2016-11-14 19:00:17','globeadmin','2016-12-06 16:54:32','globeadmin'),('582762fe4b45302','582762fe10beed3',NULL,NULL,'1',10,NULL,'selectable',40,10,'Λεπτομέρειες','Απο-επιλέξιμο από τους Γονείς/Μαθητές :','checkbox',60,234,100,0,'l','0','0','select \'1\'','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2016-11-14 19:00:17','globeadmin','2016-12-06 16:54:32','globeadmin'),('582762fe52a0c81','582762fe10beed3',NULL,NULL,'1',10,NULL,'hierarchy',50,10,'Λεπτομέρειες','Ιεραρχία στην κατηγορία του : ','text',59,603,40,0,'r','0','0','select \'0\'','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'0000-00-00 00:00:00','','2016-11-14 19:00:17','globeadmin','2016-12-06 16:54:32','globeadmin'),('582762fe5bb0735','582762fe10beed3',NULL,NULL,'1',10,NULL,'category_id',20,10,'Λεπτομέρειες','Κατηγορία :','dropdown',24,604,150,0,'l','1','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,name from notification_category order by hierarchy',NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'0000-00-00 00:00:00','','2016-11-20 10:25:18','globeadmin','2016-12-06 16:54:32','globeadmin'),('582b37533be735d','58275eceb901234',NULL,NULL,'1',10,NULL,'label1',50,10,'Λεπτομέρειες','Κεφαλίδα στο μήνυμα :','words',65,38,600,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2016-11-15 18:26:59','globeadmin','2016-11-15 18:28:52','globeadmin','2016-11-16 19:06:33','globeadmin'),('5829edf5ce68eaa','582b3fe8c3f39e6',NULL,NULL,'1',10,NULL,'header_tinymce',20,10,'Κεφαλίδα',NULL,'iframe',30,2,930,380,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'56cc9f04b82528e','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-11-14 19:01:41','globeadmin','2016-11-27 15:54:19','globeadmin','2016-11-27 15:54:20','globeadmin'),('5829f1b9609c5db','582b40cc7c93c9c',NULL,NULL,'1',10,NULL,'content_tinymce',20,10,'Περιεχόμενο Ειδοποίησης',NULL,'iframe',15,2,930,400,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'56cc9f04b82528e','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-11-14 19:17:45','globeadmin','2016-11-27 18:52:46','globeadmin','2016-11-27 18:52:46','globeadmin'),('582b339c4812e2a','58275eceb901234',NULL,NULL,'1',10,NULL,'header_tinymce',40,10,'Λεπτομέρειες',NULL,'iframe',87,3,930,380,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'56cc9f04b82528e','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-11-15 18:11:08','globeadmin','2016-11-27 15:52:31','globeadmin','2016-11-27 15:52:31','globeadmin'),('582b38b6620438a','582762fe10beed3',NULL,NULL,'1',10,NULL,'header_html',60,10,'Λεπτομέρειες',NULL,'iframe',129,6,930,120,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2016-11-15 18:32:54','globeadmin','2016-11-27 15:53:13','globeadmin','2016-12-06 16:54:33','globeadmin'),('582b3a2cdda2839','582762fe10beed3',NULL,NULL,'1',10,NULL,'content_html',70,10,'Λεπτομέρειες',NULL,'iframe',306,6,930,160,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2016-11-15 18:39:08','globeadmin','2016-11-27 15:53:30','globeadmin','2016-12-06 16:54:33','globeadmin'),('582b3c088275098','582762fe10beed3',NULL,NULL,'1',10,NULL,'label1',80,10,'Λεπτομέρειες','Κεφαλίδα τύπου ειδοποίησης στο μήνυμα  : ','words',105,23,600,40,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2016-11-15 18:47:04','globeadmin','2016-11-15 19:10:31','globeadmin','2016-12-06 16:54:33','globeadmin'),('582b3cb8ad97440','582762fe10beed3',NULL,NULL,'1',10,NULL,'label2',90,10,'Λεπτομέρειες','Περιεχόμενο ειδοποίησης  : ','words',284,23,600,40,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2016-11-15 18:50:00','globeadmin','2016-11-15 18:50:00','globeadmin','2016-12-06 16:54:33','globeadmin'),('582b42c1d0c9592','582762fe10beed3',NULL,NULL,'0',10,NULL,'header_edit_img',100,10,'Λεπτομέρειες',NULL,'html',98,294,22,22,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"this.style.cursor=\'pointer\';\"\n                            onmouseout=\"this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=20 height=20 id=\'img_modify1\' src=\'images/modify.png\' title=\'Επεξεργασία Κεφαλίδας\'/>\n        </td>\n    </tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-11-15 19:15:45','globeadmin','2016-11-15 19:21:52','globeadmin','2016-12-06 16:54:33','globeadmin'),('582b449b6698e98','582762fe10beed3',NULL,NULL,'0',10,NULL,'content_edit_img',110,10,'Λεπτομέρειες',NULL,'html',277,198,22,22,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"this.style.cursor=\'pointer\';\"\n                            onmouseout=\"this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=20 height=20 id=\'img_modify1\' src=\'images/modify.png\' title=\'Επεξεργασία Περιεχομένου\'/>\n        </td>\n    </tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-11-15 19:23:39','globeadmin','2016-11-15 19:23:39','globeadmin','2016-12-06 16:54:33','globeadmin'),('582b50b85c9a992','582762fe10beed3',NULL,NULL,'1',10,'select \'0\'','header',120,10,'Λεπτομέρειες','Κεφαλίδα Ειδοποιήσεων :','textarea',459,944,700,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-11-15 20:15:20','globeadmin','2016-11-15 20:19:49','globeadmin','2016-12-06 16:54:33','globeadmin'),('582b50db5f005f6','582762fe10beed3',NULL,NULL,'1',10,'select \'0\'','content',130,10,'Λεπτομέρειες','Περιεχόμενο : ','textarea',455,-4,300,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-11-15 20:15:55','globeadmin','2016-11-16 19:01:04','globeadmin','2016-12-06 16:54:34','globeadmin'),('582f25b06650491','554517bdc18334d',NULL,NULL,'1',10,NULL,'post_teacher_id',80,10,'Λεπτομέρειες','Καταχωρήθηκε από :','dropdown',562,381,250,0,'l','0','1','select if(teacher_id=-1,NULL, teacher_id)\nfrom session_variables \nwhere session_id=\'#session_id#\'','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select  id,\n        concat(if(surname is null,\'\',concat(surname,\' \')), IFNULL(name,\'\')) as teacher_full_name\nfrom teacher\norder by teacher_full_name\n',NULL,'','',NULL,'short_name',NULL,'name',NULL,'547372d029461f4','id',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',200,0,'2016-11-18 18:00:48','globeadmin','2018-01-03 19:34:31','globeadmin','2022-01-07 21:47:53','globeadmin'),('582f293f0e805a8','580ba2a48260384',NULL,NULL,'1',10,NULL,'post_teacher_id',100,10,'Υποβολή Παρατήρησης / Ποινής','Καταχωρητής :','dropdown',374,43,300,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select  id,\n        concat(if(surname is null,\'\',concat(surname,\' \')), IFNULL(name,\'\')) as teacher_full_name\nfrom teacher\norder by teacher_full_name',NULL,'','',NULL,NULL,NULL,'#nuSepEditnuSepr#varchar',NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-11-18 18:15:59','globeadmin','2016-11-18 18:15:59','globeadmin','2021-10-20 23:47:23','globeadmin'),('582f301e385d9b2','582b40cc7c93c9c',NULL,NULL,'1',10,NULL,'keys_iframe',10,20,'Πεδία Αντικάταστασης',NULL,'iframe',20,62,700,400,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'582c94ea0c52b86','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-11-18 18:45:18','globeadmin','2018-07-02 09:07:50','globeadmin','2018-07-02 09:07:50','globeadmin'),('5830025da0702ca','5830025d8a778f9',NULL,NULL,'1',10,NULL,'name',10,10,'Λεπτομέρειες','Όνομα :','text',29,56,250,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2016-11-19 09:46:06','globeadmin','2017-09-10 23:02:18','globeadmin'),('5830025da7c2fbc','5830025d8a778f9',NULL,NULL,'1',10,NULL,'description',20,10,'Λεπτομέρειες','Περιγραφή :','text',69,32,500,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2016-11-19 09:45:57','globeadmin','2017-09-10 23:02:18','globeadmin'),('5830025daf161ed','nuhome',NULL,NULL,'0',10,NULL,'notification_keybtn',60,10,'Globeadmin','Πεδία Ειδοποιήσεων','button',55,727,200,35,'l','0','0','','0',NULL,NULL,'','5830025d8a778f9','','','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',0,0,'0000-00-00 00:00:00','','2016-11-19 09:48:15','globeadmin','2018-08-02 20:35:12','globeadmin'),('5830046f61f9bcf','nuhome',NULL,NULL,'1',10,NULL,'frame2html',30,10,'Globeadmin',NULL,'html',36,340,300,380,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<html>\n<body>\n<table width=100% height=100% border=1  cellspacing=0 bordercolor=red><tr><td></td></tr><table>\n</body>\n</html>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-11-19 09:51:11','globeadmin','2016-11-19 09:51:11','globeadmin','2018-07-25 09:13:21','globeadmin'),('5830056063bd067','nuhome',NULL,NULL,'0',10,NULL,'notification_type_keybtn',90,10,'Globeadmin','Πέδια σε Τύπους Ειδοποιήσης','button',133,727,200,35,'l','0','0','','0',NULL,NULL,'','5830097228cb500','','','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',0,0,'0000-00-00 00:00:00','','2016-11-19 10:26:42','globeadmin','2016-11-27 15:59:24','globeadmin'),('583012862ec1dd7','583012862765b0a',NULL,NULL,'1',10,NULL,'type_id',10,10,'Details','Τύπος Ειδοποίησης','dropdown',0,0,300,0,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,name from notification_type order by category_id,hierarchy',NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'0000-00-00 00:00:00','','2016-11-19 10:56:40','globeadmin','2018-07-20 17:48:59','globeadmin'),('58300a051c2dcc5','5830097228cb500','',NULL,'1',10,NULL,'notification_type_key_subform',10,10,'Πεδία Αντικατάστασης',NULL,'subform',33,78,400,400,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,20,'1','1','type_id','id','SELECT * FROM notification_type_key WHERE type_id = \'#RECORD_ID#\'','notification_type_key',NULL,'',NULL,'g',0,0,'0000-00-00 00:00:00','','2016-11-19 10:48:51','globeadmin','2016-11-19 10:48:52','globeadmin'),('58300a052381013','58300a051c2dcc5',NULL,NULL,'1',10,NULL,'key_id',10,10,'Πεδίο Αντικατάστασης','Πεδίο Αντικατάστασης','dropdown',0,0,300,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'SELECT id,name FROM  notification_key order by name ',NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'0000-00-00 00:00:00','','2016-11-19 10:49:05','globeadmin','2016-11-19 10:49:05','globeadmin'),('583012862765b0a','5830025d8a778f9','',NULL,'1',10,NULL,'notification_type_key_subform',30,10,'Λεπτομέρειες',NULL,'subform',104,53,400,300,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,20,'1','1','key_id','id','SELECT * FROM notification_type_key WHERE key_id = \'#RECORD_ID#\'','notification_type_key',NULL,'',NULL,'g',0,0,'0000-00-00 00:00:00','','2016-11-19 10:52:54','globeadmin','2017-09-10 23:02:18','globeadmin'),('5830351fe3f80a7','583031e43183ea3',NULL,NULL,'1',10,NULL,'from_date',20,10,'Αναζήτηση','Συμβάντα Από :','text',16,21,80,35,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select  id,\n        concat(if(surname is null,\'\',concat(surname,\' \')), IFNULL(name,\'\')) as teacher_full_name\nfrom teacher\norder by teacher_full_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2016-11-19 13:18:56','globeadmin','2016-12-15 20:53:16','globeadmin','2018-07-13 19:39:14','globeadmin'),('5830322b7a82f2a','583031e43183ea3',NULL,NULL,'1',10,NULL,'search_btn',80,10,'Αναζήτηση','Αναζήτηση','button',55,766,160,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select  id,\n        concat(if(surname is null,\'\',concat(surname,\' \')), IFNULL(name,\'\')) as teacher_full_name\nfrom teacher\norder by teacher_full_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-11-19 13:06:19','globeadmin','2016-11-19 14:59:05','globeadmin','2018-07-13 19:39:15','globeadmin'),('5830324deab5f42','583031e43183ea3',NULL,NULL,'1',10,NULL,'search_iframe',90,10,'Αναζήτηση',NULL,'iframe',110,21,900,350,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select  id,\n        concat(if(surname is null,\'\',concat(surname,\' \')), IFNULL(name,\'\')) as teacher_full_name\nfrom teacher\norder by teacher_full_name',NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-11-19 13:06:54','globeadmin','2018-07-13 19:38:36','globeadmin','2018-07-13 19:39:15','globeadmin'),('58303543e3e48a7','583031e43183ea3',NULL,NULL,'1',10,NULL,'to_date',30,10,'Αναζήτηση',' Έως :','text',16,217,80,35,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select  id,\n        concat(if(surname is null,\'\',concat(surname,\' \')), IFNULL(name,\'\')) as teacher_full_name\nfrom teacher\norder by teacher_full_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2016-11-19 13:19:32','globeadmin','2016-11-19 14:59:05','globeadmin','2018-07-13 19:39:14','globeadmin'),('583036bc26e02d7','583031e43183ea3',NULL,NULL,'1',10,'select \'0\'','cur_date',10,10,'Αναζήτηση',NULL,'display',8,944,100,35,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select date_format(curdate(),\'%d-%m-%Y\')','select  id,\n        concat(if(surname is null,\'\',concat(surname,\' \')), IFNULL(name,\'\')) as teacher_full_name\nfrom teacher\norder by teacher_full_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2016-11-19 13:25:48','globeadmin','2016-11-19 14:59:05','globeadmin','2018-07-13 19:39:14','globeadmin'),('5830388ebd03b3d','583031e43183ea3',NULL,NULL,'1',10,NULL,'type_id',50,10,'Αναζήτηση','Τύπος Ειδοποίησης :','listbox',16,588,200,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,name from notification_type order by category_id,hierarchy',NULL,'','','select id,name from notification_type order by category_id,hierarchy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2016-11-19 13:33:34','globeadmin','2016-12-30 12:46:05','globeadmin','2018-07-13 19:39:14','globeadmin'),('583039876955d08','583031e43183ea3',NULL,NULL,'1',10,NULL,'pending',40,10,'Αναζήτηση','Σε Εκκρεμότητα :','dropdown',16,360,100,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'1|Ναί|0|Όχι|-1|Απέτυχε',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2016-11-19 13:37:43','globeadmin','2017-02-02 19:59:05','globeadmin','2018-07-13 19:39:14','globeadmin'),('58303b568f3beff','583031e43183ea3',NULL,NULL,'1',10,NULL,'student_id',60,10,'Αναζήτηση','Μαθητής : ','listbox',61,21,350,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select distinct student.id, concat(ifNULL(grade.short_name,\'\'),\' - \',student.surname,\' \',student.name,\' \',student.fathers_name) \nfrom student\nleft join grade on grade.id = student.grade_id\norder by student.grade_id,student.surname,student.name,student.fathers_name',NULL,'','','select distinct student.id, concat(ifNULL(grade.short_name,\'\'),\' - \',student.surname,\' \',student.name,\' \',student.fathers_name) \nfrom student\nleft join grade on grade.id = student.grade_id\norder by student.grade_id,student.surname,student.name,student.fathers_name',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-11-19 13:45:26','globeadmin','2016-12-30 12:46:43','globeadmin','2018-07-13 19:39:14','globeadmin'),('58303c89defafb7','583031e43183ea3',NULL,NULL,'1',10,NULL,'is_parent',70,10,'Αναζήτηση','Περιορισμός σε :','dropdown',61,474,180,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'1|Μόνο προς τους Γονείς|0|Μόνο προς τους Μαθητές',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2016-11-19 13:50:33','globeadmin','2016-11-19 14:59:05','globeadmin','2018-07-13 19:39:14','globeadmin'),('5831a181475015c','5831a1813b1b74d',NULL,NULL,'1',10,NULL,'added_at_disp',30,10,'Λεπτομέρειες','Ημερομηνία Προσθήκης :','display',38,472,150,0,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','SELECT DATE_FORMAT(added_at,\'%d-%m-%Y %T\') FROM  notification WHERE id=\'#RECORD_ID#\'',NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2016-11-20 18:20:36','globeadmin','2018-07-05 12:23:51','globeadmin'),('5831a1814ea94b3','5831a1813b1b74d',NULL,NULL,'1',10,NULL,'type_id_disp',20,10,'Λεπτομέρειες','Τύπος Ειδοποίησης :','display',38,19,300,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select name from notification_type where id=\'#type_id#\'',NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'0000-00-00 00:00:00','','2016-11-20 15:57:12','globeadmin','2018-07-05 12:23:51','globeadmin'),('5831a18155f5ea4','5831a1813b1b74d',NULL,NULL,'1',10,'select \'0\'','content',70,10,'Λεπτομέρειες','Περιεχόμενο :','textarea',10,931,250,150,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2016-11-20 18:26:24','globeadmin','2018-07-05 12:23:51','globeadmin'),('5831a1815d55559','5831a1813b1b74d',NULL,NULL,'1',10,NULL,'student_id',40,10,'Λεπτομέρειες','Μαθητής :','display',70,83,500,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select concat(ifNULL(student.surname,\'\'),if(student.surname is NULL OR student.name is NULL,\'\',\' \'),ifNULL(student.name,\'\'),if(student.fathers_name is NULL,\'\',\' πατ. \'),ifNULL(student.fathers_name,\'\')) \nfrom student\nwhere id=\'#student_id#\'',NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'0000-00-00 00:00:00','','2016-11-20 15:57:12','globeadmin','2018-07-05 12:23:51','globeadmin'),('5831a181649bfc5','5831a1813b1b74d',NULL,NULL,'1',10,NULL,'is_parent',50,10,'Λεπτομέρειες','Προς το Γονέα :','checkbox',101,51,50,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2016-11-20 15:57:12','globeadmin','2018-07-05 12:23:51','globeadmin'),('5831a1816bf370c','5831a1813b1b74d',NULL,NULL,'1',10,NULL,'pending',10,10,'Λεπτομέρειες','Σε Εκκρεμότητα :','checkbox',7,43,50,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2016-11-20 18:20:36','globeadmin','2018-07-05 12:23:51','globeadmin'),('5831a77e4f670bb','5831a1813b1b74d',NULL,NULL,'1',10,NULL,'email_to_disp',60,10,'Λεπτομέρειες','Διεύθυνση Email :','display',102,198,400,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select if(\'#is_parent#\'=\'1\',parent_email,email)\nfrom student\nwhere id=\'#student_id#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-11-20 15:39:10','globeadmin','2016-11-20 18:20:36','globeadmin','2018-07-05 12:23:51','globeadmin'),('5831ce67b40f45d','5831a1813b1b74d',NULL,NULL,'1',10,NULL,'content_tinymce',80,10,'Λεπτομέρειες',NULL,'iframe',137,20,1000,380,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'56cc9f04b82528e','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-11-20 18:25:11','globeadmin','2018-07-05 12:24:15','globeadmin','2018-07-05 12:24:15','globeadmin'),('5831bf97b6b4122','5831a1813b1b74d',NULL,NULL,'1',10,'select if(\'#email_id#\'=\'\',\'0\',\'1\')','email_iframe',10,20,'Συσχετιζόμενο Email',NULL,'iframe',29,3,1030,450,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'5831b9019b61979','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-11-20 17:21:59','globeadmin','2018-07-05 12:25:47','globeadmin','2018-07-05 12:25:48','globeadmin'),('583ee83a86ddc26','571354ed43a4d47',NULL,NULL,'0',10,NULL,'btnimg7',70,10,'SMS - Email',NULL,'html',334,73,220,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'notification_id\').src=\'images/notificationb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'notification_id\').src=\'images/notification.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'notification_id\' src=\'images/notification.png\' title=\'Ειδοποιήσεις με Email\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Ειδοποιήσεις με Email</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-11-30 16:54:50','globeadmin','2017-10-28 22:07:24','globeadmin','2017-11-12 16:18:15','globeadmin'),('583ef27f6c5d468','56192b05ed5032f',NULL,NULL,'0',10,'select if(  \'#nu_user_group#\'=\'globeadmin\' or \n            \'#nu_user_group#\'=\'Administrators\' or \n            \'#nu_user_group#\'=\'Managers\',\'1\',\'0\')','notification_typebtn',50,30,'Παράμετροι',NULL,'html',192,380,220,100,'l','0','0','','0',NULL,NULL,'1','54a52c3dcf3610b',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'notification_type_id\').src=\'images/notification_typeb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'notification_type_id\').src=\'images/notification_type.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'notification_type_id\' src=\'images/notification_type.png\' title=\'Τύποι Ειδοποιήσεων με Email\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Τύποι Ειδοποιήσεων με Email</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-11-30 17:38:39','globeadmin','2018-01-09 18:08:17','globeadmin','2019-07-25 10:13:36','globeadmin'),('583ef316e6285b5','56192b05ed5032f',NULL,NULL,'0',10,'select if(  \'#nu_user_group#\'=\'globeadmin\' or \n            \'#nu_user_group#\'=\'Administrators\' or \n            \'#nu_user_group#\'=\'Managers\',\'1\',\'0\')','notification_categorybtn',40,30,'Παράμετροι',NULL,'html',192,73,220,100,'l','0','0','','0',NULL,NULL,'1','54a52c3dcf3610b',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'notification_category_id\').src=\'images/notification_categoryb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'notification_category_id\').src=\'images/notification_category.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'notification_category_id\' src=\'images/notification_category.png\' title=\'Κατηγορίες Ειδοποιήσεων Email\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Κατηγορίες Ειδοποιήσεων με Email</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-11-30 17:41:11','globeadmin','2018-01-09 18:15:44','globeadmin','2019-07-25 10:13:36','globeadmin'),('584118909cde798','584117d1d046e30',NULL,NULL,'1',10,NULL,'email',10,10,'Επιλογές Ειδοποιήσεων Μαθητή','Διεύθυνση Email :','text',27,34,400,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-12-02 08:45:36','globeadmin','2016-12-02 09:07:52','globeadmin','2022-01-08 22:14:59','globeadmin'),('58411b9253b0081','584117d1d046e30',NULL,NULL,'1',10,'select if(active=\'1\',\'1\',\'0\')\nfrom notification_type \nwhere id=4','new_penalty_notification',30,10,'Επιλογές Ειδοποιήσεων Μαθητή','Καταχώριση Ποινών :','checkbox',96,155,50,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-12-02 08:58:26','globeadmin','2017-09-09 16:04:38','globeadmin','2022-01-08 22:14:59','globeadmin'),('58411bfe2292f03','584117d1d046e30',NULL,NULL,'1',10,'select if(active=\'1\',\'1\',\'0\')\nfrom notification_type \nwhere id=1','new_absence_notification',40,10,'Επιλογές Ειδοποιήσεων Μαθητή','Καταχώριση Απουσιών :','checkbox',132,136,50,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-12-02 09:00:14','globeadmin','2017-09-09 16:04:38','globeadmin','2022-01-08 22:14:59','globeadmin'),('58411c22227ad0f','584117d1d046e30',NULL,NULL,'1',10,'select if(active=\'1\',\'1\',\'0\')\nfrom notification_type \nwhere id=2','justify_absence_notification',60,10,'Επιλογές Ειδοποιήσεων Μαθητή','Δικαιολόγηση Απουσιών :','checkbox',168,127,50,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-12-02 09:00:50','globeadmin','2017-09-09 16:04:38','globeadmin','2022-01-08 22:14:59','globeadmin'),('58411c6fd96807f','584117d1d046e30',NULL,NULL,'1',10,'select if(active=\'1\',\'1\',\'0\')\nfrom notification_type \nwhere id=3','delete_absence_notification',70,10,'Επιλογές Ειδοποιήσεων Μαθητή','Διαγραφή Απουσιών :','checkbox',204,150,50,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-12-02 09:02:07','globeadmin','2017-09-09 16:04:38','globeadmin','2022-01-08 22:14:59','globeadmin'),('58411cf837e76cb','584117d1d046e30',NULL,NULL,'1',10,'select if(active=\'1\',\'1\',\'0\')\nfrom notification_type \nwhere id=5','update_comment_notification',80,10,'Επιλογές Ειδοποιήσεων Μαθητή','Σχόλια Καθηγητών :','checkbox',239,160,50,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-12-02 09:04:24','globeadmin','2017-09-09 16:04:38','globeadmin','2022-01-08 22:14:59','globeadmin'),('58411e73458f353','584117d1d046e30',NULL,NULL,'1',10,NULL,'label1',20,10,'Επιλογές Ειδοποιήσεων Μαθητή','Επιθυμώ να ενημερώνομαι στην παραπάνω διεύθυνση email για :  ','words',68,28,400,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-12-02 09:10:43','globeadmin','2017-09-09 16:04:38','globeadmin','2022-01-08 22:14:59','globeadmin'),('5841229fb56f1e0','584117d1d046e30',NULL,NULL,'1',10,'select \'0\'','select_new_penalty_notification',100,10,'Επιλογές Ειδοποιήσεων Μαθητή',NULL,'display',97,316,30,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select selectable\nfrom notification_type \nwhere id=4',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-12-02 09:28:31','globeadmin','2017-09-09 16:04:38','globeadmin','2022-01-08 22:14:59','globeadmin'),('5841233781c4616','584117d1d046e30',NULL,NULL,'1',10,'select \'0\'','select_new_absence_notification',110,10,'Επιλογές Ειδοποιήσεων Μαθητή',NULL,'display',140,316,30,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select selectable\nfrom notification_type \nwhere id=1',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-12-02 09:31:03','globeadmin','2017-09-09 16:04:38','globeadmin','2022-01-08 22:15:00','globeadmin'),('5841237c707ad4b','584117d1d046e30',NULL,NULL,'1',10,'select \'0\'','select_justify_absence_notification',120,10,'Επιλογές Ειδοποιήσεων Μαθητή',NULL,'display',168,316,30,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select selectable\nfrom notification_type \nwhere id=2',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-12-02 09:32:12','globeadmin','2017-09-09 16:04:38','globeadmin','2022-01-08 22:15:00','globeadmin'),('584123c9c824fe6','584117d1d046e30',NULL,NULL,'1',10,'select \'0\'','select_delete_absence_notification',130,10,'Επιλογές Ειδοποιήσεων Μαθητή',NULL,'display',197,316,30,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select selectable\nfrom notification_type \nwhere id=3',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-12-02 09:33:29','globeadmin','2017-09-09 16:04:38','globeadmin','2022-01-08 22:15:00','globeadmin'),('584124119990125','584117d1d046e30',NULL,NULL,'1',10,'select \'0\'','select_update_comment_notification',140,10,'Επιλογές Ειδοποιήσεων Μαθητή',NULL,'display',244,317,30,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select selectable\nfrom notification_type \nwhere id=5',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-12-02 09:34:41','globeadmin','2017-09-09 16:04:38','globeadmin','2022-01-08 22:15:00','globeadmin'),('58412962b31f9a7','584128b691c711a',NULL,NULL,'1',10,NULL,'parent_email',10,10,'Επιλογές Ειδοποιήσεων Γονέα','Διεύθυνση Email :','text',27,34,400,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-12-02 09:57:22','globeadmin','2016-12-02 10:06:35','globeadmin','2022-01-08 22:12:05','globeadmin'),('58412980cdec690','584128b691c711a',NULL,NULL,'1',10,'select if(active=\'1\',\'1\',\'0\')\nfrom notification_type \nwhere id=4','parent_new_penalty_notification',30,10,'Επιλογές Ειδοποιήσεων Γονέα','Καταχώριση Ποινών :','checkbox',96,155,50,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-12-02 09:57:52','globeadmin','2017-09-09 16:02:13','globeadmin','2022-01-08 22:12:05','globeadmin'),('5841299f144bd8c','584128b691c711a',NULL,NULL,'1',10,'select if(active=\'1\',\'1\',\'0\')\nfrom notification_type \nwhere id=1','parent_new_absence_notification',40,10,'Επιλογές Ειδοποιήσεων Γονέα','Καταχώριση Απουσιών :','checkbox',131,136,50,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-12-02 09:58:23','globeadmin','2017-09-09 16:02:13','globeadmin','2022-01-08 22:12:05','globeadmin'),('584129bdb06ee7b','584128b691c711a',NULL,NULL,'1',10,'select if(active=\'1\',\'1\',\'0\')\nfrom notification_type \nwhere id=2','parent_justify_absence_notification',60,10,'Επιλογές Ειδοποιήσεων Γονέα','Δικαιολόγηση Απουσιών :','checkbox',167,127,50,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-12-02 09:58:53','globeadmin','2017-09-09 16:02:13','globeadmin','2022-01-08 22:12:05','globeadmin'),('584129d9894b2eb','584128b691c711a',NULL,NULL,'1',10,'select if(active=\'1\',\'1\',\'0\')\nfrom notification_type \nwhere id=3','parent_delete_absence_notification',70,10,'Επιλογές Ειδοποιήσεων Γονέα','Διαγραφή Απουσιών :','checkbox',202,150,50,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-12-02 09:59:21','globeadmin','2017-09-09 16:02:13','globeadmin','2022-01-08 22:12:05','globeadmin'),('584129f992f93e5','584128b691c711a',NULL,NULL,'1',10,'select if(active=\'1\',\'1\',\'0\')\nfrom notification_type \nwhere id=5','parent_update_comment_notification',80,10,'Επιλογές Ειδοποιήσεων Γονέα','Σχόλια Καθηγητών :','checkbox',237,160,50,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-12-02 09:59:53','globeadmin','2017-09-09 16:02:13','globeadmin','2022-01-08 22:12:05','globeadmin'),('58412a178920146','584128b691c711a',NULL,NULL,'1',10,NULL,'label1',20,10,'Επιλογές Ειδοποιήσεων Γονέα','Επιθυμώ να ενημερώνομαι στην παραπάνω διεύθυνση email για :  ','words',68,28,400,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-12-02 10:00:23','globeadmin','2017-09-09 16:02:13','globeadmin','2022-01-08 22:12:05','globeadmin'),('58412a3702c2cce','584128b691c711a',NULL,NULL,'1',10,'select \'0\'','select_new_penalty_notification',100,10,'Επιλογές Ειδοποιήσεων Γονέα',NULL,'display',97,316,30,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select selectable\nfrom notification_type \nwhere id=4',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-12-02 10:00:55','globeadmin','2017-09-09 16:02:13','globeadmin','2022-01-08 22:12:06','globeadmin'),('58412a54422f44e','584128b691c711a',NULL,NULL,'1',10,'select \'0\'','select_new_absence_notification',110,10,'Επιλογές Ειδοποιήσεων Γονέα',NULL,'display',140,316,30,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select selectable\nfrom notification_type \nwhere id=1',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-12-02 10:01:24','globeadmin','2017-09-09 16:02:13','globeadmin','2022-01-08 22:12:06','globeadmin'),('58412a6fc109863','584128b691c711a',NULL,NULL,'1',10,'select \'0\'','select_justify_absence_notification',120,10,'Επιλογές Ειδοποιήσεων Γονέα',NULL,'display',168,316,30,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select selectable\nfrom notification_type \nwhere id=2',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-12-02 10:01:51','globeadmin','2017-09-09 16:02:13','globeadmin','2022-01-08 22:12:06','globeadmin'),('58412a8ed6ffa87','584128b691c711a',NULL,NULL,'1',10,'select \'0\'','select_delete_absence_notification',130,10,'Επιλογές Ειδοποιήσεων Γονέα',NULL,'display',197,316,30,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select selectable\nfrom notification_type \nwhere id=3',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-12-02 10:02:23','globeadmin','2017-09-09 16:02:13','globeadmin','2022-01-08 22:12:06','globeadmin'),('58412accca8b966','584128b691c711a',NULL,NULL,'1',10,'select \'0\'','select_update_comment_notification',140,10,'Επιλογές Ειδοποιήσεων Γονέα',NULL,'display',344,316,30,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select selectable\nfrom notification_type \nwhere id=5',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-12-02 10:03:24','globeadmin','2017-09-09 16:02:13','globeadmin','2022-01-08 22:12:06','globeadmin'),('584599ed813c99d','55127aebdf42446',NULL,NULL,'1',10,NULL,'printbtn',160,10,'Αναζήτηση','Εκτύπωση','button',273,285,150,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from teacher order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-12-05 18:46:37','globeadmin','2016-12-05 18:46:37','globeadmin','2020-10-08 23:42:28','globeadmin'),('58469cafef04b9a','551821232f9553f',NULL,NULL,'1',10,NULL,'printbtn',130,10,'Αναζήτηση','Εκτύπωση','button',124,766,150,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from teacher order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-12-06 13:10:40','globeadmin','2016-12-06 13:10:40','globeadmin','2018-08-04 20:57:32','globeadmin'),('584a5cd177f9934','584a5c7c116e00c','',NULL,'1',10,NULL,'teacher_student_subform',10,10,'Επιλογή Καθηγητών',NULL,'subform',14,44,530,200,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,20,'0','0','student_id','id','SELECT * \nFROM teacher_student \nWHERE student_id = \'#RECORD_ID#\'\norder by hierarchy_teacher','teacher_student',NULL,'',NULL,'g',0,0,'0000-00-00 00:00:00','','2016-12-09 09:38:37','globeadmin','2017-05-11 09:19:06','globeadmin'),('584a5cd17f4a87b','584a5cd177f9934',NULL,NULL,'1',10,NULL,'teacher_id',20,10,'Details','Καθηγητής','dropdown',0,0,400,0,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select  id,\n        concat(if(surname is null,\'\',concat(surname,\' \')), IFNULL(name,\'\')) as teacher_full_name\nfrom teacher\norder by teacher_full_name',NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'0000-00-00 00:00:00','','2016-12-09 09:37:59','globeadmin','2017-05-11 09:19:07','globeadmin'),('59da77d514de23e','nuhome',NULL,NULL,'0',10,NULL,'teachersbtn',120,10,'Globeadmin','Καθηγητής','button',133,64,200,35,'l','0','0','','0',NULL,NULL,'-1','59d67ca712d3ffa',NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-08 22:09:09','globeadmin','2017-10-08 22:09:09','globeadmin','2017-10-17 12:32:20','globeadmin'),('584a5f1a312a960','584a5cd177f9934',NULL,NULL,'1',10,NULL,'hierarchy_teacher',10,10,'Details','Σειρά Προτίμησης','text',0,0,80,0,'c','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select  id,\n        concat(if(surname is null,\'\',concat(surname,\' \')), IFNULL(name,\'\')) as teacher_full_name\nfrom teacher\norder by teacher_full_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2016-12-09 09:36:58','globeadmin','2016-12-09 09:38:31','globeadmin','2017-05-11 09:19:07','globeadmin'),('584bd068b8e056a','584bd01a9203a9a',NULL,NULL,'1',10,NULL,'justification_request_reason_id',10,10,'Εισαγωγή Αιτημάτων Διαγραφής','Λόγος Αιτήσεων :','dropdown',31,26,300,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,name from justification_request_reason',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2016-12-10 11:52:40','globeadmin','2018-08-07 15:11:05','globeadmin','2020-09-14 22:05:04','globeadmin'),('584bd082b8cb162','584bd01a9203a9a',NULL,NULL,'1',10,NULL,'comments',20,10,'Εισαγωγή Αιτημάτων Διαγραφής','Σχόλιο Αιτήσεων :','textarea',74,24,400,120,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-12-10 11:53:06','globeadmin','2018-08-07 15:11:05','globeadmin','2020-09-14 22:05:04','globeadmin'),('584bdb828e7d003','55127aebdf42446',NULL,NULL,'1',10,NULL,'mjs_btn',170,10,'Αναζήτηση','Εισαγωγή Αιτημάτων Διαγραφής','button',273,770,220,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2016-12-10 12:40:02','globeadmin','2018-08-05 00:04:05','globeadmin','2020-10-08 23:42:29','globeadmin'),('5852e856a54cf4d','583031e43183ea3',NULL,NULL,'1',10,'select \'0\'','start_date',100,10,'Αναζήτηση',NULL,'display',8,944,100,35,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select date_format(school_year.start_date,\'%d-%m-%Y\')\nfrom school\nINNER JOIN school_year ON school.school_year_id = school_year.id\nlimit 1','select  id,\n        concat(if(surname is null,\'\',concat(surname,\' \')), IFNULL(name,\'\')) as teacher_full_name\nfrom teacher\norder by teacher_full_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2016-12-15 21:00:38','globeadmin','2016-12-15 21:03:01','globeadmin','2018-07-13 19:39:15','globeadmin'),('586698fe953f515','5741fe1502bb6c2',NULL,NULL,'1',10,NULL,'is_editable',50,10,'Λεπτομέρειες','Επιτρέπεται η τροποποίηση των περιγραφών κατά την καταχώριση :','checkbox',119,51,40,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2016-12-30 19:27:26','globeadmin','2016-12-30 19:27:26','globeadmin','2018-07-14 10:14:49','globeadmin'),('586a2164ae9447d','584117d1d046e30',NULL,NULL,'1',10,'select if(sum(active)=2,\'1\',\'0\')\nfrom notification_type \nwhere id in (1,6)','group_new_absence_notification',50,10,'Επιλογές Ειδοποιήσεων Μαθητή','Συνοπτική Παρουσίαση :','checkbox',132,335,50,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-01-02 11:46:12','globeadmin','2017-09-09 16:04:38','globeadmin','2022-01-08 22:14:59','globeadmin'),('58d61720898b32c','58d616cfeb60afc',NULL,NULL,'1',10,NULL,'sus_login_name',50,10,'Στοιχεία Λογαριασμού Σύνδεσης','Όνομα Χρήστη :','text',293,201,250,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-03-25 09:07:12','globeadmin','2017-03-25 15:17:49','globeadmin','2020-12-15 17:56:41','globeadmin'),('58d621b3e869d01','58d616cfeb60afc',NULL,NULL,'1',10,NULL,'sus_name',10,10,'Στοιχεία Λογαριασμού Σύνδεσης','Όνομα :','text',34,248,500,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-03-25 09:52:20','globeadmin','2017-03-25 15:17:49','globeadmin','2020-12-15 17:56:40','globeadmin'),('58d61771d28eabc','58d616cfeb60afc',NULL,NULL,'1',10,NULL,'nupassword',60,10,'Στοιχεία Λογαριασμού Σύνδεσης','Νέος Κωδικός Πρόσβασης :','text',338,135,250,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'password',NULL,'',100,250,'2017-03-25 09:08:33','globeadmin','2017-03-25 10:04:57','globeadmin','2020-12-15 17:56:41','globeadmin'),('58d6179618e9a1f','58d616cfeb60afc',NULL,NULL,'1',10,NULL,'nuretyped',70,10,'Στοιχεία Λογαριασμού Σύνδεσης','Επιβεβαίωση Νέου Κωδικού :','text',384,123,250,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'password',NULL,'',100,250,'2017-03-25 09:09:10','globeadmin','2017-03-25 10:04:57','globeadmin','2020-12-15 17:56:41','globeadmin'),('58d6220a9044554','58d616cfeb60afc',NULL,NULL,'1',10,NULL,'sus_email',20,10,'Στοιχεία Λογαριασμού Σύνδεσης','Email :','text',80,254,500,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-03-25 09:53:46','globeadmin','2017-03-25 15:17:49','globeadmin','2020-12-15 17:56:40','globeadmin'),('58d622e2ccb159e','58d616cfeb60afc',NULL,NULL,'1',10,NULL,'sus_zzzsys_user_group_id',40,10,'Στοιχεία Λογαριασμού Σύνδεσης','Ομάδα Χρηστών - Ρόλος :','dropdown',209,143,500,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'SELECT \n    zzzsys_user_group_id, \n    concat(sug_code,\' - \',ifNULL(sal_description,\'\')) \nFROM zzzsys_user_group \nLEFT JOIN  zzzsys_access_level ON sug_zzzsys_access_level_id = zzzsys_access_level_id \nORDER BY zzzsys_user_group_id',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-03-25 09:57:22','globeadmin','2017-03-25 15:17:49','globeadmin','2020-12-15 17:56:41','globeadmin'),('58d66ad17ab9278','58d616cfeb60afc',NULL,NULL,'1',10,NULL,'login_with_email_account',30,10,'Στοιχεία Λογαριασμού Σύνδεσης','Σύνδεση με τον Λογαριασμό Email :','checkbox',125,85,0,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-03-25 15:04:17','globeadmin','2017-03-25 15:14:12','globeadmin','2020-12-15 17:56:40','globeadmin'),('58da9016ade0c06','58d616cfeb60afc',NULL,NULL,'1',10,'select \'0\'','teacher',90,10,'Στοιχεία Λογαριασμού Σύνδεσης','teacher_count','display',427,321,30,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','SELECT count(*) FROM teacher WHERE user_id=\'#RECORD_ID#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-03-28 19:32:22','globeadmin','2017-03-28 19:50:32','globeadmin','2020-12-15 17:56:41','globeadmin'),('58d8a4bc505f8ab','58d616cfeb60afc',NULL,NULL,'1',10,'select \'0\'','sus_login_name_orig',80,10,'Στοιχεία Λογαριασμού Σύνδεσης',NULL,'display',430,293,150,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select sus_login_name\nfrom zzzsys_user\nwhere zzzsys_user_id=\'#RECORD_ID#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-03-27 08:35:56','globeadmin','2017-03-28 19:50:32','globeadmin','2020-12-15 17:56:41','globeadmin'),('58d94ed386cfb1e','58d616cfeb60afc',NULL,NULL,'1',10,'select \'0\'','email_servers',100,10,'Στοιχεία Λογαριασμού Σύνδεσης','Email Servers : ','dropdown',386,619,150,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'SELECT id,domain_name  FROM email_login_server order by id',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-03-27 20:41:39','globeadmin','2017-03-27 20:58:41','globeadmin','2020-12-15 17:56:41','globeadmin'),('58da90800f2e2c5','58d616cfeb60afc',NULL,NULL,'1',10,'select \'0\'','student',110,10,'Στοιχεία Λογαριασμού Σύνδεσης','student_count','display',427,454,30,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','SELECT count(*) FROM student WHERE user_id=\'#RECORD_ID#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-03-28 19:34:08','globeadmin','2017-03-28 19:37:27','globeadmin','2020-12-15 17:56:41','globeadmin'),('58da90e5279ff66','58d616cfeb60afc',NULL,NULL,'1',10,'select \'0\'','parent',120,10,'Στοιχεία Λογαριασμού Σύνδεσης','parent_count','display',427,594,30,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','SELECT count(*) FROM student WHERE parent_user_id=\'#RECORD_ID#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-03-28 19:35:49','globeadmin','2017-03-28 19:37:13','globeadmin','2020-12-15 17:56:41','globeadmin'),('58dd3fc888cc62e','5618f5cc92f9c9e',NULL,NULL,'1',10,NULL,'sisyphos_info_label21',40,500,'Πληροφορίες',NULL,'display',155,463,200,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select concat(\'Copyright (c) 2014-\',YEAR(CURDATE()))',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-03-30 20:26:32','globeadmin','2019-11-03 14:01:59','globeadmin','2022-11-30 11:53:03','globeadmin'),('59e35fe38f5aa9b','54a6fde1ab6eb6d',NULL,NULL,'1',10,NULL,'parent_street',20,20,'Στοιχεία Επικοινωνίας','Οδός - Αριθμός :','text',62,554,300,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-15 16:17:23','globeadmin','2017-10-15 17:24:23','globeadmin','2021-09-06 20:12:23','globeadmin'),('59d886648b0255d','548338073921bfe',NULL,NULL,'1',10,NULL,'web_page',70,40,'Προσωπικά Στοιχεία','Ιστοσελίδα :','text',309,99,300,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-07 10:46:44','globeadmin','2020-11-08 19:37:12','globeadmin','2022-01-08 10:51:56','globeadmin'),('58e126ceaa1401c','547070c91793d3b',NULL,NULL,'1',10,NULL,'subjects_iframe',10,20,'Μαθήματα που Αξιολογούνται',NULL,'iframe',18,1,940,440,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'58e11da705d0093','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',100,250,'2017-04-02 19:29:02','globeadmin','2017-04-02 20:13:39','globeadmin','2022-02-06 13:49:54','globeadmin'),('58e14de150b4d83','547070c91793d3b',NULL,NULL,'1',10,NULL,'state',100,10,'Λεπτομέρειες','Κατάσταση :','display',25,752,100,30,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select if(grading_period_id=\'#RECORD_ID#\',\'ΤΡΕΧΟΥΣΑ\',\'ΑΝΕΝΕΡΓΗ\') from school where id=1',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-04-02 22:15:45','globeadmin','2017-04-02 22:37:45','globeadmin','2021-09-04 21:36:58','globeadmin'),('58e1dc0ec7d6247','54a65ecc3f14737',NULL,NULL,'1',10,'select if(\'#login_with_email_account#\'=\'1\' or \'#nu_user_group#\'=\'globeadmin\',\'1\',\'0\')','change_account_label5',100,10,'Στοιχεία Λογαριασμού','Κωδικός Πρόσβασης : Ο κωδικός σας για το παραπάνω email!','words',89,185,600,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-04-03 08:22:22','globeadmin','2017-04-03 08:22:22','globeadmin','2018-07-28 00:36:33','globeadmin'),('599597e22776111','599591df20eb2f7',NULL,NULL,'1',10,NULL,'calendar_iframe',10,10,'Ημερολόγιο Σχολείου',NULL,'iframe',14,15,1100,580,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'5995b81c6de4f2e','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-08-17 16:19:30','globeadmin','2017-08-17 18:50:27','globeadmin','2020-10-06 23:53:56','globeadmin'),('599954a027df822','599954a01e175cd',NULL,NULL,'1',10,NULL,'title',10,10,'Λεπτομέρειες','*Τίτλος :','text',30,79,550,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2017-08-24 13:39:17','globeadmin','2021-10-09 23:07:30','globeadmin'),('599954a02f2e11d','599954a01e175cd',NULL,NULL,'1',10,NULL,'description',20,10,'Λεπτομέρειες','Περιγραφή :','textarea',73,58,550,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2017-08-20 12:46:09','globeadmin','2021-10-09 23:07:30','globeadmin'),('599954a0368120c','599954a01e175cd',NULL,NULL,'1',10,NULL,'allDay',80,10,'Λεπτομέρειες','Ολοήμερο :','checkbox',279,61,50,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2017-08-20 14:50:33','globeadmin','2021-10-09 23:07:31','globeadmin'),('599954a03dd3f3a','599954a01e175cd',NULL,NULL,'1',10,NULL,'start_date',30,10,'Λεπτομέρειες','*Από :','text',192,90,100,0,'r','0','0','select curdate()','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',100,250,'0000-00-00 00:00:00','','2017-08-24 13:39:50','globeadmin','2021-10-09 23:07:30','globeadmin'),('599954a04526eff','599954a01e175cd',NULL,NULL,'1',10,NULL,'end_date',50,10,'Λεπτομέρειες','*Έως :','text',235,88,100,0,'r','0','0','select curdate()','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',100,250,'0000-00-00 00:00:00','','2017-08-24 13:40:13','globeadmin','2021-10-09 23:07:31','globeadmin'),('599b04913ed14cc','599954a01e175cd',NULL,NULL,'1',10,'select if(((\'#nu_user_group#\' IN (\'globeadmin\',\'Managers\',\'AssistManagers\',\'Administrators\',\'Secretaries\',\'Teachers\',\'Psychologists\')) OR \'#teacher_id#\'=teacher_id) AND \'#nu_new_record#\'=\'0\',\'1\',\'0\')  \nfrom session_variables \nwhere session_id=\'#session_id#\'','participants_iframe',110,20,'Κοινοποίηση',NULL,'iframe',182,15,650,260,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'59a17e291687ee8','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-08-21 19:04:33','globeadmin','2021-03-09 14:51:45','globeadmin','2021-10-09 23:07:32','globeadmin'),('599b361a636564a','599954a01e175cd',NULL,NULL,'1',10,'select if(((\'#nu_user_group#\' IN (\'globeadmin\',\'Managers\',\'AssistManagers\',\'Administrators\',\'Secretaries\')) OR \'#teacher_id#\'=teacher_id) AND \'#nu_new_record#\'=\'0\',\'1\',\'0\')  \nfrom session_variables \nwhere session_id=\'#session_id#\'','selection1',10,20,'Κοινοποίηση','Κοινοποίηση σε :','dropdown',20,20,300,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,name from school where 0=1',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-08-21 22:35:54','globeadmin','2017-08-23 22:50:11','globeadmin','2021-10-09 23:07:31','globeadmin'),('599b47aa464ad12','599954a01e175cd',NULL,NULL,'1',10,'select if(((\'#nu_user_group#\' IN (\'globeadmin\',\'Managers\',\'AssistManagers\',\'Administrators\',\'Secretaries\')) OR \'#teacher_id#\'=teacher_id) AND \'#nu_new_record#\'=\'0\',\'1\',\'0\')  \nfrom session_variables \nwhere session_id=\'#session_id#\'','button1',80,20,'Κοινοποίηση','Κοινοποίηση','button',20,514,160,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,name from school where 0=1',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-08-21 23:50:50','globeadmin','2017-08-27 11:52:29','globeadmin','2021-10-09 23:07:31','globeadmin'),('599954a0786ea90','599954a01e175cd',NULL,NULL,'1',10,NULL,'teacher_id_disp',90,10,'Λεπτομέρειες','Δημιουργήθηκε από :','display',384,5,300,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select concat(if(surname is null,\'\',concat(surname,\' \')), IFNULL(name,\'\'))\nfrom teacher\nwhere id=\'#teacher_id#\'',NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'0000-00-00 00:00:00','','2017-08-27 14:53:34','globeadmin','2021-10-09 23:07:31','globeadmin'),('5999764dacaf219','599954a01e175cd',NULL,NULL,'1',10,NULL,'end_time',60,10,'Λεπτομέρειες',NULL,'text',235,245,60,0,'r','0','0','select \'00:00:00\'','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-08-20 14:45:17','globeadmin','2017-08-20 15:45:30','globeadmin','2021-10-09 23:07:31','globeadmin'),('599975bf132e285','599954a01e175cd',NULL,NULL,'1',10,NULL,'start_time',40,10,'Λεπτομέρειες',NULL,'text',192,245,60,0,'r','0','0','select \'00:00:00\'','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-08-20 14:42:55','globeadmin','2017-08-20 15:45:49','globeadmin','2021-10-09 23:07:31','globeadmin'),('59999100ca00d3d','599954a01e175cd',NULL,NULL,'1',10,'select \'0\'','teacher_id',90,10,'Λεπτομέρειες','Καθηγητής','text',298,558,40,0,'l','0','0','select if(teacher_id=-1,26,teacher_id) from session_variables where session_id=\'#session_id#\'','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2017-08-20 16:39:12','globeadmin','2017-08-20 16:50:26','globeadmin','2021-10-09 23:07:31','globeadmin'),('599bd676e50e242','599954a01e175cd',NULL,NULL,'1',10,NULL,'teacher_id_select',20,20,'Κοινοποίηση','Καθηγητές : ','listbox',52,46,300,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select  id,\n        concat(if(surname is null,\'\',concat(surname,\' \')), IFNULL(name,\'\')) as teacher_full_name\nfrom teacher\norder by teacher_full_name',NULL,'','','select  id,\n        concat(if(surname is null,\'\',concat(surname,\' \')), IFNULL(name,\'\')) as teacher_full_name\nfrom teacher\norder by teacher_full_name',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-08-22 10:00:07','globeadmin','2017-08-24 13:57:31','globeadmin','2021-10-09 23:07:31','globeadmin'),('599c6f4059501e7','599954a01e175cd',NULL,NULL,'1',10,NULL,'students_check',30,20,'Κοινοποίηση','σε Μαθητές : ','checkbox',52,127,40,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-08-22 20:52:00','globeadmin','2017-08-23 22:38:07','globeadmin','2021-10-09 23:07:31','globeadmin'),('599c6f96ac3a98e','599954a01e175cd',NULL,NULL,'1',10,NULL,'parents_check',40,20,'Κοινοποίηση','σε Γονείς : ','checkbox',52,244,40,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-08-22 20:53:26','globeadmin','2017-08-23 22:38:27','globeadmin','2021-10-09 23:07:31','globeadmin'),('599c72201befb21','599954a01e175cd',NULL,NULL,'1',10,NULL,'class_id_select',60,20,'Κοινοποίηση','Τμήματα : ','listbox',85,58,200,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','','select distinct class.id,class.short_name \nfrom class\ninner join student_class on class.id=student_class.class_id\nleft join ( select distinct card.class_id as c_id\n            from card\n            inner join session_variables as sv1 ON sv1.session_id=\'#session_id#\'\n            where   card.valid_from=(select max(start_date) from timetable) and \n                    card.teacher_id=sv1.teacher_id) as c ON c.c_id=class.id\nleft join ( select class.id as c_id\n            from class\n            where\n                (   select count(*)\n                    from student\n                    inner join session_variables as sv2 ON sv2.session_id=\'#session_id#\'\n                    inner join student_class ON student.id=student_class.student_id\n                    where \n                    student.teacher_id=sv2.teacher_id AND\n                    student_class.class_id = class.id) = (select count(*) from student_class where class_id=class.id)\n                ) as c1 ON c1.c_id=class.id\nwhere   \'#nu_user_group#\'=\'globeadmin\' OR \n        \'#nu_user_group#\'=\'Administrators\' OR \n        \'#nu_user_group#\'=\'Managers\' OR \n        \'#nu_user_group#\'=\'AssistManagers\' OR\n        \'#nu_user_group#\'=\'Secretaries\' OR\n        c.c_id IS NOT NULL OR\n        c1.c_id IS NOT NULL \norder by class.short_name',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-08-22 21:04:16','globeadmin','2017-08-24 13:54:57','globeadmin','2021-10-09 23:07:31','globeadmin'),('599c749825929f1','599954a01e175cd',NULL,NULL,'1',10,NULL,'grade_id_select',50,20,'Κοινοποίηση','Τάξεις : ','listbox',85,73,150,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','','select grade.id,grade.short_name\nfrom grade\norder by grade.short_name',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-08-22 21:14:48','globeadmin','2017-08-24 13:54:30','globeadmin','2021-10-09 23:07:31','globeadmin'),('599c76b1db8a318','599954a01e175cd',NULL,NULL,'1',10,NULL,'student_id_select',70,20,'Κοινοποίηση','Μαθητές : ','listbox',85,58,300,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','','select distinct student.id, concat(ifNULL(grade.short_name,\'\'),\' - \',student.surname,\' \',student.name,\' \',student.fathers_name) \nfrom student\ninner join session_variables as sv1 ON sv1.session_id=\'#session_id#\'\nleft join grade on grade.id = student.grade_id\nleft join (    select distinct student_class.student_id as s_id\n                            from student_class\n                            inner join session_variables as sv2 ON sv2.session_id=\'#session_id#\'\n                            inner join card ON card.class_id=student_class.class_id\n                            where\n                                card.valid_from=(select max(start_date) from timetable) and   \n                                card.teacher_id=sv2.teacher_id) as s ON s.s_id = student.id\nwhere\n        \'#nu_user_group#\'=\'globeadmin\' OR \n        \'#nu_user_group#\'=\'Administrators\' OR \n        \'#nu_user_group#\'=\'Managers\' OR \n        \'#nu_user_group#\'=\'AssistManagers\' OR\n        \'#nu_user_group#\'=\'Secretaries\' OR\n        s.s_id is not null OR\n        student.teacher_id = sv1.teacher_id OR\n        student.advisor_id = sv1.teacher_id\norder by student.grade_id,student.surname,student.name,student.fathers_name\n',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-08-22 21:23:46','globeadmin','2017-10-18 21:54:02','globeadmin','2021-10-09 23:07:31','globeadmin'),('599ead825943bb9','599954a01e175cd',NULL,NULL,'1',10,NULL,'label1',110,10,'Λεπτομέρειες','* Απαιτείται','words',425,45,150,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2017-08-24 13:42:10','globeadmin','2017-08-24 15:32:09','globeadmin','2021-10-09 23:07:31','globeadmin'),('599eb27b2a85897','599954a01e175cd',NULL,NULL,'1',10,'select if(((\'#nu_user_group#\' IN (\'globeadmin\',\'Managers\',\'AssistManagers\',\'Administrators\',\'Secretaries\',\'Teachers\',\'Psychologists\')) OR \'#teacher_id#\'=teacher_id) AND \'#nu_new_record#\'=\'0\',\'1\',\'0\')  \nfrom session_variables \nwhere session_id=\'#session_id#\'','label2',100,20,'Κοινοποίηση','Συμμετέχοντες : ','words',147,18,150,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-08-24 14:03:23','globeadmin','2021-03-09 14:52:22','globeadmin','2021-10-09 23:07:32','globeadmin'),('59a287f9ef7e72a','599954a01e175cd',NULL,NULL,'1',10,'select if(((\'#nu_user_group#\' IN (\'globeadmin\',\'Managers\',\'AssistManagers\',\'Administrators\',\'Secretaries\')) OR \'#teacher_id#\'=teacher_id) AND \'#nu_new_record#\'=\'0\',\'1\',\'0\')  \nfrom session_variables \nwhere session_id=\'#session_id#\'','button2',90,20,'Κοινοποίηση','Αφαίρεση Επιλεγμένων','button',140,514,160,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,name from school where 0=1',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-08-27 11:51:06','globeadmin','2017-08-27 11:54:11','globeadmin','2021-10-09 23:07:32','globeadmin'),('59a28a12ac6c579','599954a01e175cd',NULL,NULL,'1',10,'select if(((\'#nu_user_group#\' IN (\'globeadmin\',\'Managers\',\'AssistManagers\',\'Administrators\',\'Secretaries\')) OR \'#teacher_id#\'=teacher_id) AND \'#nu_new_record#\'=\'0\',\'1\',\'0\')  \nfrom session_variables \nwhere session_id=\'#session_id#\'','hr1',120,20,'Κοινοποίηση',NULL,'html',118,13,450,10,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<hr style=\"width: 100%; height: 0px; background-color:#b04b00; color:#b0b0b0;border: 1px solid;\">','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-08-27 12:00:02','globeadmin','2017-09-30 15:29:30','globeadmin','2021-10-09 23:07:32','globeadmin'),('59a5654658d8aad','599954a01e175cd',NULL,NULL,'1',10,NULL,'location',70,10,'Λεπτομέρειες','Τοποθεσία :','text',322,59,300,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-08-29 15:59:50','globeadmin','2017-08-29 15:59:50','globeadmin','2021-10-09 23:07:31','globeadmin'),('59a5c63730cac7f','599954a01e175cd',NULL,NULL,'1',10,NULL,'period_start',130,10,'Λεπτομέρειες',NULL,'dropdown',193,318,20,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select start_time,concat (name,\' - \',start_time)\nfrom period\norder by start_time',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-08-29 22:53:27','globeadmin','2018-04-19 13:20:44','globeadmin','2021-10-09 23:07:31','globeadmin'),('59d886b45c6c294','548338073921bfe',NULL,NULL,'1',10,NULL,'comments_for_students',100,40,'Προσωπικά Στοιχεία',NULL,'textarea',47,541,400,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-07 10:48:04','globeadmin','2017-10-07 11:03:00','globeadmin','2022-01-08 10:51:56','globeadmin'),('59d886d0b920cb8','548338073921bfe',NULL,NULL,'1',10,NULL,'comments_for_students_label',100,40,'Προσωπικά Στοιχεία','Ημέρες και Ώρες Ενημέρωσης Γονέων :','words',25,544,350,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-07 10:48:32','globeadmin','2017-10-07 11:03:00','globeadmin','2022-01-08 10:51:56','globeadmin'),('59d886f057abf06','548338073921bfe',NULL,NULL,'1',10,NULL,'phone1',110,40,'Προσωπικά Στοιχεία','Σταθερό Τηλέφωνο :','text',174,551,150,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-07 10:49:04','globeadmin','2017-10-07 11:03:00','globeadmin','2022-01-08 10:51:56','globeadmin'),('59a6e23d97b27c9','5618f5cc92f9c9e',NULL,NULL,'0',10,NULL,'fullcalendar',30,10,'Αρχικό Μενού',NULL,'html',334,73,220,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0  \n                            onmouseover=\"document.getElementById(\'img_calendar\').src=\'images/calendarb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_calendar\').src=\'images/calendar.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_calendar\' src=\'images/calendar.png\' title=\'Ημερολόγιο Σχολείου\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Ημερολόγιο Σχολείου</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-08-30 19:05:17','globeadmin','2017-10-28 20:26:58','globeadmin','2022-11-30 11:53:03','globeadmin'),('59a98451226bc29','59a96e2c710af4a',NULL,NULL,'1',10,NULL,'program_btn',30,10,'Προγραμματισμός Διαγωνίσματος ή Τεστ','Καταχώριση','button',288,308,220,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-09-01 19:01:21','globeadmin','2017-09-01 19:07:29','globeadmin','2020-09-18 19:16:20','globeadmin'),('59a9754503f38d6','59a96e2c710af4a',NULL,NULL,'1',10,NULL,'test_date',10,10,'Προγραμματισμός Διαγωνίσματος ή Τεστ','Ημερομηνία : ','text',88,16,80,40,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from class order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2017-09-01 17:57:09','globeadmin','2017-09-01 18:51:54','globeadmin','2020-09-18 19:10:30','globeadmin'),('59a975682af005a','59a96e2c710af4a',NULL,NULL,'1',10,NULL,'period_class_subject_id',20,10,'Προγραμματισμός Διαγωνίσματος ή Τεστ','Διδασκαλία :','dropdown',126,23,450,40,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'SELECT  id,short_name\nFROM period\nwhere 0=1',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-09-01 17:57:44','globeadmin','2017-09-01 21:37:45','globeadmin','2020-09-18 19:10:30','globeadmin'),('59a982f59111763','59a96e2c710af4a',NULL,NULL,'1',10,NULL,'is_test',60,10,'Προγραμματισμός Διαγωνίσματος ή Τεστ','Ολιγόλεπτο Τεστ  :','checkbox',18,213,40,40,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-09-01 18:55:33','globeadmin','2017-09-01 18:55:33','globeadmin','2020-09-18 19:10:30','globeadmin'),('59a9829856b27f3','59a96e2c710af4a',NULL,NULL,'1',10,NULL,'is_exam',40,10,'Προγραμματισμός Διαγωνίσματος ή Τεστ','Ωριαίο Διαγώνισμα :','checkbox',18,39,40,40,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-09-01 18:54:00','globeadmin','2017-09-02 23:22:11','globeadmin','2020-09-18 19:10:30','globeadmin'),('59aa4dd4cca6e7e','5a54c08c836c142',NULL,NULL,'1',10,'select \'0\'','absence_anjustified_limit',70,10,'Παράμετροι','Όριο αδικαιολόγητων απουσιών :','text',54,708,40,0,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2017-09-02 09:21:08','globeadmin','2018-08-05 12:35:07','globeadmin','2022-09-24 23:21:53','globeadmin'),('59aa4e20303d3d3','5a54c08c836c142',NULL,NULL,'1',10,NULL,'exam_week_limit',90,10,'Παράμετροι','Όριο διαγωνισμάτων μαθητή ανά εβδομάδα :','text',212,323,40,0,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2017-09-02 09:22:24','globeadmin','2018-02-03 23:21:16','globeadmin','2022-09-24 23:21:53','globeadmin'),('59aa69a3b309d7a','59a96e2c710af4a',NULL,NULL,'1',10,NULL,'location',50,10,'Προγραμματισμός Διαγωνίσματος ή Τεστ','Τοποθεσία : ','text',168,24,300,40,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-09-02 11:19:47','globeadmin','2017-09-02 11:22:30','globeadmin','2020-09-18 19:10:30','globeadmin'),('59ab0d5356c2fac','59a96e2c710af4a',NULL,NULL,'1',10,'select if((\'#nu_user_group#\' IN (\'globeadmin\',\'Managers\',\'AssistManagers\',\'Administrators\',\'Secretaries\')),\'1\',\'0\')','all_cards',70,10,'Προγραμματισμός Διαγωνίσματος ή Τεστ','Όλες οι διδασκαλίες :','checkbox',83,205,40,40,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-09-02 22:58:11','globeadmin','2017-11-05 13:00:30','globeadmin','2020-09-18 19:10:31','globeadmin'),('59ab1157e216e12','59a96e2c710af4a',NULL,NULL,'1',10,NULL,'publish_students_check',90,10,'Προγραμματισμός Διαγωνίσματος ή Τεστ','Κοινοποίηση στους Μαθητές :','checkbox',228,22,40,40,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-09-02 23:15:19','globeadmin','2017-09-02 23:22:58','globeadmin','2020-09-18 19:10:31','globeadmin'),('59ab117a5946a55','59a96e2c710af4a',NULL,NULL,'1',10,NULL,'publish_parents_check',100,10,'Προγραμματισμός Διαγωνίσματος ή Τεστ','Κοινοποίηση στους Γονείς :','checkbox',228,238,40,40,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-09-02 23:15:54','globeadmin','2017-09-02 23:15:54','globeadmin','2020-09-18 19:10:31','globeadmin'),('59ac08ad143e426','59ac07f003930c8',NULL,NULL,'1',10,NULL,'calendar_iframe',10,10,'Ημερολόγιο Σχολείου',NULL,'iframe',14,15,1100,580,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'59ac0890dc7beb0','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-09-03 16:50:37','globeadmin','2017-09-03 16:50:37','globeadmin','2020-09-24 12:19:53','globeadmin'),('59e3605dce8bd34','54a6fde1ab6eb6d',NULL,NULL,'1',10,NULL,'parent_zipcode',60,20,'Στοιχεία Επικοινωνίας','Τ.Κ. :','text',163,621,100,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-15 16:19:25','globeadmin','2017-10-15 16:46:19','globeadmin','2021-09-06 20:12:23','globeadmin'),('59e3608178fb995','54a6fde1ab6eb6d',NULL,NULL,'1',10,NULL,'parent_phone1',80,20,'Στοιχεία Επικοινωνίας','Τηλέφωνο 1 :','text',209,574,150,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-15 16:20:01','globeadmin','2017-10-15 17:28:59','globeadmin','2021-09-06 20:12:23','globeadmin'),('59e360aa85234a2','54a6fde1ab6eb6d',NULL,NULL,'1',10,NULL,'parent_phone2',100,20,'Στοιχεία Επικοινωνίας','Τηλέφωνο 2 :','text',255,574,150,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-15 16:20:42','globeadmin','2017-10-15 17:29:14','globeadmin','2021-09-06 20:12:23','globeadmin'),('59e360cd3bcfbfd','54a6fde1ab6eb6d',NULL,NULL,'1',10,NULL,'parent_phone3',120,20,'Στοιχεία Επικοινωνίας','Τηλέφωνο 3 :','text',302,574,150,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-15 16:21:17','globeadmin','2017-10-15 17:29:32','globeadmin','2021-09-06 20:12:23','globeadmin'),('59b3c766b1f52d3','584117d1d046e30',NULL,NULL,'1',10,'select if(active=\'1\',\'1\',\'0\')\nfrom notification_type \nwhere id=7','new_calendar_event_notification',90,10,'Επιλογές Ειδοποιήσεων Μαθητή','Συμβάντα Ημερολογίου :','checkbox',311,135,50,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-09-09 13:50:14','globeadmin','2017-09-10 18:30:48','globeadmin','2022-01-08 22:14:59','globeadmin'),('59b3da19a241df7','584117d1d046e30',NULL,NULL,'1',10,'select \'0\'','select_new_calendar_event_notification',150,10,'Επιλογές Ειδοποιήσεων Μαθητή',NULL,'display',244,317,30,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select selectable\nfrom notification_type \nwhere id=7',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-09-09 15:10:01','globeadmin','2017-09-09 16:04:38','globeadmin','2022-01-08 22:15:00','globeadmin'),('59b3dcb38148924','584128b691c711a',NULL,NULL,'1',10,'select if(active=\'1\',\'1\',\'0\')\nfrom notification_type \nwhere id=7','parent_new_calendar_event_notification',90,10,'Επιλογές Ειδοποιήσεων Γονέα','Συμβάντα Ημερολογίου :','checkbox',308,135,50,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-09-09 15:21:07','globeadmin','2017-09-10 18:33:31','globeadmin','2022-01-08 22:12:06','globeadmin'),('59b3dd00eeb527e','584128b691c711a',NULL,NULL,'1',10,'select \'0\'','select_new_calendar_event_notification',150,10,'Επιλογές Ειδοποιήσεων Γονέα',NULL,'display',0,0,30,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select selectable\nfrom notification_type \nwhere id=7',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-09-09 15:22:25','globeadmin','2017-09-09 16:02:13','globeadmin','2022-01-08 22:12:06','globeadmin'),('59b3dfac33a6631','584128b691c711a',NULL,NULL,'1',10,'select if(sum(active)=2,\'1\',\'0\')\nfrom notification_type \nwhere id in (1,6)','parent_group_new_absence_notification',50,10,'Επιλογές Ειδοποιήσεων Γονέα','Συνοπτική Παρουσίαση :','checkbox',131,335,50,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-09-09 15:33:48','globeadmin','2017-09-09 16:02:13','globeadmin','2022-01-08 22:12:05','globeadmin'),('59c29411dd89c2c','59c292e97e52d3e',NULL,NULL,'1',10,NULL,'class_id',10,10,'Διαγραφή Κατανομής Μαθητών σε Τμήματα','Τμήματα : ','listbox',18,30,300,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','','select class.id,concat(class.short_name,\' (\',count(*),\' μαθητές)\')\nfrom class\ninner join student_class on class.id=student_class.class_id\ngroup by class.short_name,class.id\n',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-09-20 19:15:14','globeadmin','2017-09-20 20:17:55','globeadmin','2020-09-24 18:43:02','globeadmin'),('59c636430fde060','547372d029461f4',NULL,NULL,'1',10,NULL,'accept_email_from_students',250,10,'Λεπτομέρειες','Μπορούν οι Μαθητές/Γονείς να του/της στέλνουν emails :','checkbox',472,33,50,0,'l','0','0','select \'1\'','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-09-23 13:24:03','globeadmin','2018-08-06 19:12:11','globeadmin','2021-01-26 20:15:04','globeadmin'),('59cf88601741285','599954a01e175cd',NULL,NULL,'1',10,'select if(((\'#nu_user_group#\' IN (\'globeadmin\',\'Managers\',\'AssistManagers\',\'Administrators\',\'Secretaries\')) OR \'#teacher_id#\'=teacher_id) AND \'#nu_new_record#\'=\'0\',\'1\',\'0\')  \nfrom session_variables \nwhere session_id=\'#session_id#\'','inform_check',130,20,'Κοινοποίηση','Ενημέρωση συμμετεχόντων :','checkbox',100,486,40,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-09-30 15:04:48','globeadmin','2018-04-24 14:28:21','globeadmin','2021-10-09 23:07:32','globeadmin'),('59cf97b5a0208c7','599954a01e175cd',NULL,NULL,'1',10,'SELECT \'0\'','participants_numb_disp',110,10,'Λεπτομέρειες','Αριθμός Συμμετεχόντων :','display',384,476,40,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select count(*)\nfrom calendar_event_access\nwhere calendar_event_id=\'#RECORD_ID#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2017-09-30 16:10:13','globeadmin','2017-09-30 16:11:11','globeadmin','2021-10-09 23:07:31','globeadmin'),('59cfad676d839f4','59cfad675ee667a',NULL,NULL,'1',10,NULL,'sender_id_disp',10,10,'Λεπτομέρειες','Αποστολέας :','display',199,94,450,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','SELECT if(\'#sender_id#\'=\'-1\',\'ΕΙΔΟΠΟΙΗΣΕΙΣ\',concat(if(teacher.surname is NULL,\'\',teacher.surname),if(teacher.name is NULL,\'\',concat(\' \',teacher.name))))\nFROM teacher \nWHERE (id=\'#sender_id#\') or (\'#sender_id#\'=\'-1\' AND id=26)',NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'0000-00-00 00:00:00','','2017-09-30 22:49:35','globeadmin','2018-07-05 11:04:26','globeadmin'),('59cfad6774d415e','59cfad675ee667a',NULL,NULL,'1',10,NULL,'sent_at_disp',20,10,'Λεπτομέρειες','Απεστάλη στις :','display',152,82,150,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select DATE_FORMAT(\'#sent_at#\',\'%d-%m-%Y %H:%i:%s\')',NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2017-09-30 22:49:09','globeadmin','2018-07-05 11:04:26','globeadmin'),('59cfad677c2daee','59cfad675ee667a',NULL,NULL,'1',10,NULL,'email_address',30,10,'Λεπτομέρειες','Προς :','text',25,135,450,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2017-09-30 21:50:32','globeadmin','2018-07-05 11:04:26','globeadmin'),('59cfad67837a404','59cfad675ee667a',NULL,NULL,'1',10,NULL,'email_subject',10,20,'Μήνυμα','Θέμα :','text',23,17,600,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2018-07-05 11:05:35','globeadmin','2018-07-05 11:05:35','globeadmin'),('59cfad678acd0ce','59cfad675ee667a',NULL,NULL,'1',10,NULL,'email_text_iframe',20,20,'Μήνυμα',NULL,'iframe',60,16,800,370,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<html>\n<boby bgcolor=lightyellow>\n#email_text#\n</body>\n</html>','59cfe983ac3c809','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2018-07-05 11:05:00','globeadmin','2018-07-05 11:05:00','globeadmin'),('59cfad67922029c','59cfad675ee667a',NULL,NULL,'1',10,NULL,'fail_code_disp',40,10,'Λεπτομέρειες','Κατάσταση :','display',281,101,250,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','SELECT IF(\'#fail_code#\'= \'0\',\'Στάλθηκε\',IF(\'#fail_code#\'= \'1\',\'Λάθος Διεύθυνση\',\'Απέτυχε\'))',NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2017-09-30 22:49:53','globeadmin','2018-07-05 11:04:26','globeadmin'),('59cfad6799733be','59cfad675ee667a',NULL,NULL,'1',10,'select if(fail_comments is NULL or TRIM(fail_comments)=\'\',\'0\',\'1\')\nfrom email\nwhere id=\'#RECORD_ID#\'','fail_comments',50,10,'Λεπτομέρειες','Σχόλια Αποτυχίας :','textarea',328,59,450,80,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2017-09-30 23:00:12','globeadmin','2018-07-05 11:04:26','globeadmin'),('59cfad67a0c666a','59cfad675ee667a',NULL,NULL,'1',10,'SELECT if(student_id IS NULL or student_id=-1, \'0\', \'1\')\nFROM email\nWHERE id = \'#RECORD_ID#\'','student_id_disp',60,10,'Λεπτομέρειες','Παραλήπτης Μαθητής :','display',72,37,450,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select concat(if(student.surname is NULL,\'\',student.surname),if(student.name is NULL,\'\',concat(\' \',student.name)),if(student.fathers_name is NULL,\'\',concat(\' πατ. \',student.fathers_name)))\nfrom student\nwhere id = \'#student_id#\'',NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'0000-00-00 00:00:00','','2017-09-30 22:54:41','globeadmin','2018-07-05 11:04:26','globeadmin'),('59cfad67a818f58','59cfad675ee667a',NULL,NULL,'1',10,'SELECT if(teacher_id IS NULL or teacher_id=-1, \'0\', \'1\')\nFROM email\nWHERE id = \'#RECORD_ID#\'','teacher_id_disp',70,10,'Λεπτομέρειες','Παραλήπτης Καθηγητής :','display',72,26,450,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','SELECT concat(if(teacher.surname is NULL,\'\',teacher.surname),if(teacher.name is NULL,\'\',concat(\' \',teacher.name)))\nFROM teacher \nWHERE id=\'#teacher_id#\'',NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'0000-00-00 00:00:00','','2017-09-30 22:54:19','globeadmin','2018-07-05 11:04:26','globeadmin'),('59cfad67b44e2a2','nuhome',NULL,NULL,'0',10,NULL,'studentsbtn',120,10,'Globeadmin','Μαθητής','button',210,64,200,35,'l','0','0','','0',NULL,NULL,'523','59da63096606dc0','','','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',0,0,'0000-00-00 00:00:00','','2020-11-08 18:30:40','globeadmin','2020-11-08 18:30:40','globeadmin'),('59d294cae30e06c','59d294a40ecced8',NULL,NULL,'1',10,NULL,'class_id',10,10,'Προσθήκη Μαθητή σε Τμήματα','Τμήματα : ','listbox',18,30,300,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','','select class.id,class.short_name\nfrom class\nwhere class.id not in (select distinct class_id from student_class where student_id=\'#RECORD_ID#\')\nORDER BY class.short_name',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-02 22:34:35','globeadmin','2017-10-02 22:44:45','globeadmin','2017-10-02 22:57:59','globeadmin'),('59d67d4a6f33a58','59d67ca712d3ffa',NULL,NULL,'1',10,NULL,'sisyphos_info_img1',10,500,'Πληροφορίες',NULL,'html',91,102,334,66,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<img id=\'img_sisyphos_id\' src=\'images/sisyphos.png\'/> ','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-05 21:43:22','globeadmin','2017-10-05 21:43:22','globeadmin','2021-03-22 19:49:23','globeadmin'),('59d67d6fd81825f','59d67ca712d3ffa',NULL,NULL,'1',10,NULL,'sisyphos_info_label1',20,500,'Πληροφορίες','Πληροφοριακό Σύστημα «Σίσυφος»','words',90,463,450,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-05 21:43:59','globeadmin','2017-10-05 21:43:59','globeadmin','2021-03-22 19:49:24','globeadmin'),('59d67d93e6acb2e','59d67ca712d3ffa',NULL,NULL,'1',10,NULL,'sisyphos_info_label2',30,500,'Πληροφορίες','Έκδοση','display',112,469,150,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select version from school where id=1',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-05 21:44:35','globeadmin','2017-10-05 21:44:36','globeadmin','2021-03-22 19:49:24','globeadmin'),('59d67dbb54304a4','59d67ca712d3ffa',NULL,NULL,'1',10,NULL,'sisyphos_info_label21',40,500,'Πληροφορίες',NULL,'display',155,463,200,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select concat(\'Copyright (c) 2014-\',YEAR(CURDATE()))',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-05 21:45:15','globeadmin','2019-11-03 14:01:02','globeadmin','2021-03-22 19:49:24','globeadmin'),('59d67ded0ac5b34','59d67ca712d3ffa',NULL,NULL,'1',10,NULL,'sisyphos_info_label5',50,500,'Πληροφορίες',NULL,'html',145,649,260,50,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 width=100% height=100%>\n<tr>\n<td valign=middle align=left>\n<a href=\"http://sisyphos.gr/index.php?page=creator.html\" target=\"_blank\">Παπαδακάκης Νεκτάριος</a>\n</td>\n</tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-05 21:46:05','globeadmin','2017-10-05 21:46:05','globeadmin','2021-03-22 19:49:24','globeadmin'),('59d67e287119c58','59d67ca712d3ffa',NULL,NULL,'1',10,NULL,'sisyphos_info_label3',60,500,'Πληροφορίες','Περισσότερες πληροφορίες στην ιστοσελίδα  ','html',222,200,400,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 width=100% height=100%>\n<tr>\n<td valign=middle align=left>\n<a href=\"http://www.sisyphos.gr\" target=\"_blank\">www.sisyphos.gr</a>\n</td>\n</tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-05 21:47:04','globeadmin','2017-10-05 21:47:04','globeadmin','2021-03-22 19:49:24','globeadmin'),('59d67e5953b4f24','59d67ca712d3ffa',NULL,NULL,'1',10,NULL,'sisyphos_info_label4',70,500,'Πληροφορίες','Επικοινωνία στο info.sisyphos@gmail.com  ή στη  ','html',263,175,400,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 width=100% height=100%>\n<tr>\n<td valign=middle align=left>\n<a href=\"http://sisyphos.gr/index.php?page=contact.html\" target=\"_blank\">Φόρμα Επικοινωνίας</a>\n</td>\n</tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-05 21:47:53','globeadmin','2017-10-05 21:47:53','globeadmin','2021-03-22 19:49:24','globeadmin'),('59d67e86a6958d8','59d67ca712d3ffa',NULL,NULL,'1',10,NULL,'sisyphos_info_label6',80,500,'Πληροφορίες','Οδηγίες για τη χρήση του συστήματος στον  ','html',304,205,400,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 width=100% height=100%>\n<tr>\n<td valign=middle align=left>\n<a href=\"http://sisyphos.gr/index.php?page=userguide.html\" target=\"_blank\">Οδηγό Χρήσης</a>\n</td>\n</tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-05 21:48:38','globeadmin','2017-10-05 21:48:38','globeadmin','2021-03-22 19:49:24','globeadmin'),('59d67ec6cd7ee94','59d67ca712d3ffa',NULL,NULL,'1',10,NULL,'sisyphos_info_label7',90,500,'Πληροφορίες','Ερωτήσεις, σχόλια, παρατηρήσεις και γνώμες στο  ','html',345,169,400,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 width=100% height=100%>\n<tr>\n<td valign=middle align=left>\n<a href=\"http://www.sisyphos.gr/forum\" target=\"_blank\">Φόρουμ</a>\n</td>\n</tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-05 21:49:42','globeadmin','2017-10-05 21:50:37','globeadmin','2021-03-22 19:49:24','globeadmin'),('59d67f4ed20f512','59d67ca712d3ffa',NULL,NULL,'0',10,NULL,'teacher_homebtnimg',10,10,'Αρχικό Μενού',NULL,'html',50,73,220,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_ucard_id\').src=\'images/ucardb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_ucard_id\').src=\'images/ucard.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_ucard_id\' src=\'images/ucard.png\' title=\'Προσωπικά Στοιχεία\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Προσωπικά Στοιχεία</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-05 21:51:58','globeadmin','2017-10-07 01:24:31','globeadmin','2021-03-22 19:49:23','globeadmin'),('59d67f7b9002f0e','59d67ca712d3ffa',NULL,NULL,'0',10,NULL,'message_center_homebtnimg',70,10,'Αρχικό Μενού',NULL,'html',50,687,220,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_message_center_id\').src=\'images/message_centerb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_message_center_id\').src=\'images/message_center.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=92 height=74 id=\'img_message_center_id\' src=\'images/message_center.png\' title=\'Αποστολή και Αναζήτηση Μηνυμάτων SMS και email\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Αποστολή & Αναζήτηση Μηνυμάτων</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-05 21:52:43','globeadmin','2017-10-28 20:29:16','globeadmin','2021-03-22 19:49:23','globeadmin'),('59d67fa8d92aa75','59d67ca712d3ffa',NULL,NULL,'0',10,NULL,'absence_homebtnimg',20,10,'Αρχικό Μενού',NULL,'html',192,73,220,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_absences_id\').src=\'images/absencesb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_absences_id\').src=\'images/absences.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_absences_id\' src=\'images/absences.png\' title=\'Εργασίες που αφορούν τις απουσίες\'/>\n            <img style=\"position: absolute;bottom: 30px;left: 155px;display: none;\" width=20 height=20 id=\'ab_warning_id\' src=\'images/warning.png\' title=\'\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Απουσίες</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-05 21:53:28','globeadmin','2021-02-26 22:53:02','globeadmin','2021-03-22 19:49:23','globeadmin'),('59d67fd42bb7ed1','59d67ca712d3ffa',NULL,NULL,'0',10,NULL,'mark_homebtnimg',50,10,'Αρχικό Μενού',NULL,'html',192,380,220,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_amark_id\').src=\'images/amarkb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_amark_id\').src=\'images/amark.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=86 height=74 id=\'img_amark_id\' src=\'images/amark.png\' title=\'Αξιολόγηση μαθητών και ποινές που έχω επιβάλει\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Αξιολόγηση Μαθητών & Ποινές</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-05 21:54:12','globeadmin','2017-10-07 01:24:31','globeadmin','2021-03-22 19:49:23','globeadmin'),('59d6810a6318667','59d67ca712d3ffa',NULL,NULL,'0',10,NULL,'fullcalendar',30,10,'Αρχικό Μενού',NULL,'html',334,73,220,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0  \n                            onmouseover=\"document.getElementById(\'img_calendar\').src=\'images/calendarb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_calendar\').src=\'images/calendar.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_calendar\' src=\'images/calendar.png\' title=\'Ημερολόγιο Σχολείου\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Ημερολόγιο</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-05 21:59:22','globeadmin','2017-10-28 20:28:26','globeadmin','2021-03-22 19:49:23','globeadmin'),('59d68cdc8cb0a40','59d67ca712d3ffa',NULL,NULL,'0',10,NULL,'advisebtn',100,10,'Αρχικό Μενού',NULL,'html',334,687,220,100,'l','0','0','','0',NULL,NULL,'0','54b2d9dd8417a3d',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_advisor_id\').src=\'images/advisorb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_advisor_id\').src=\'images/advisor.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=98 height=74 id=\'img_advisor_id\' src=\'images/advisor.png\' title=\'Σχόλια για τους Μαθητές μου και τους Γονείς τους\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Σχόλια για τους Μαθητές μου</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-05 22:49:48','globeadmin','2017-10-07 01:24:31','globeadmin','2021-03-22 19:49:23','globeadmin'),('59d682ff2277896','59d67ca712d3ffa',NULL,NULL,'0',10,NULL,'studentbtn',40,10,'Αρχικό Μενού',NULL,'html',50,380,220,100,'l','0','0','','0',NULL,NULL,NULL,'5476201e5a3d38f',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_std_id\').src=\'images/stdb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_std_id\').src=\'images/std.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_std_id\' src=\'images/std.png\' title=\'Οι καρτέλες των μαθητών για τους οποίους είμαι υπεύθυνος ή σύμβουλος\'/>\n            <img /> \n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Μαθητές που είμαι Υπεύθυνος</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-05 22:07:43','globeadmin','2017-10-28 20:28:26','globeadmin','2021-03-22 19:49:23','globeadmin'),('59d8870d4b18d5d','548338073921bfe',NULL,NULL,'1',10,NULL,'mobile',120,40,'Προσωπικά Στοιχεία','Κινητό Τηλέφωνο :','text',218,562,150,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-07 10:49:33','globeadmin','2017-10-07 11:03:00','globeadmin','2022-01-08 10:51:56','globeadmin'),('59d88735e4d420a','548338073921bfe',NULL,NULL,'1',10,NULL,'phone2',140,40,'Προσωπικά Στοιχεία','Άλλο Τηλέφωνο :','text',267,571,150,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-07 10:50:13','globeadmin','2017-10-07 11:03:00','globeadmin','2022-01-08 10:51:56','globeadmin'),('59d887a22632864','548338073921bfe',NULL,NULL,'1',10,NULL,'sms_disp',90,40,'Προσωπικά Στοιχεία','SMS Μηνύματα :','display',363,621,100,0,'r','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select CONCAT(count(*),\' / \',IF(\'#sms_limit#\'=\'\',\'UL\',\'#sms_limit#\'))\nfrom sms\nwhere sender_id=\'#RECORD_ID#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-07 10:52:02','globeadmin','2017-10-07 11:03:00','globeadmin','2022-01-08 10:51:56','globeadmin'),('59d8893f4eac395','548338073921bfe',NULL,NULL,'1',10,NULL,'teacher_lessons',10,50,'Αναθέσεις Μαθημάτων',NULL,'iframe',44,12,950,420,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'5494859e9bfaf58','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-07 10:58:55','globeadmin','2017-11-16 08:45:28','globeadmin','2022-01-08 10:51:56','globeadmin'),('59d889b1dc06e08','548338073921bfe',NULL,NULL,'1',10,NULL,'teacher_Programs',10,60,'Ωρολόγιο Πρόγραμμα',NULL,'iframe',24,14,950,430,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'5a9e7622e307049','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-07 11:00:50','globeadmin','2018-03-06 13:51:40','globeadmin','2022-01-08 10:51:57','globeadmin'),('59d88b4a1c965b8','548338073921bfe',NULL,NULL,'0',10,NULL,'abcence_periodbtn',10,10,'Προσωπικές Εργασίες',NULL,'html',50,73,220,100,'l','0','0','','0',NULL,NULL,'#RECORD_ID#','5501db35db0c716',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_pabsen_id\').src=\'images/pabsenb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_pabsen_id\').src=\'images/pabsen.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_pabsen_id\' src=\'images/pabsen.png\' title=\'Καταχώριση απουσιών για μια διδασκαλία\'/>\n            <img style=\"position: absolute;bottom: 35px;left: 150px;display: none;\" width=20 height=20 id=\'ab_warning_id\' src=\'images/warning.png\' title=\'\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Καταχώριση των Aπουσιών μου</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-07 11:07:38','globeadmin','2022-01-08 10:50:23','globeadmin','2022-01-08 10:51:55','globeadmin'),('59d6871ed701c09','59d67ca712d3ffa',NULL,NULL,'0',10,'select \'0\'','teaching_bookbtn',90,10,'Αρχικό Μενού',NULL,'html',192,670,220,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_ebooks_id\').src=\'images/ebooksb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_ebooks_id\').src=\'images/ebooks.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_ebooks_id\' src=\'images/ebooks.png\' title=\'Ημερολόγια Διδασκαλιών\'/>\n            <img /> \n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Ημερολόγια Διδασκαλιών</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-05 22:25:18','globeadmin','2017-10-28 21:57:48','globeadmin','2021-03-22 19:49:23','globeadmin'),('59d68c4a17db084','59d67ca712d3ffa',NULL,NULL,'0',10,NULL,'subject_homebtnimg',80,10,'Αρχικό Μενού',NULL,'html',192,687,220,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_subles_id\').src=\'images/sublesb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_subles_id\').src=\'images/subles.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=98 height=74 id=\'img_subles_id\' src=\'images/subles.png\' title=\'Αναθέσεις Μαθημάτων και Ωρολόγιο Πρόγραμμα\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Διδασκαλίες & Ωρολόγιο Πρόγραμμα</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-05 22:47:22','globeadmin','2017-10-28 20:29:16','globeadmin','2021-03-22 19:49:23','globeadmin'),('59d88c6de197d6c','548338073921bfe',NULL,NULL,'0',10,NULL,'print_markbtn',30,10,'Προσωπικές Εργασίες',NULL,'html',192,687,220,100,'l','0','0','','0',NULL,NULL,'#RECORD_ID# ','5495dad1762dc2c',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_grprint_id\').src=\'images/grprintb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_grprint_id\').src=\'images/grprint.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_grprint_id\' src=\'images/grprint.png\' title=\'Εκτύπωση Βαθμολογίας\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Εκτύπωση της Βαθμολογίας μου</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-07 11:12:30','globeadmin','2022-01-08 10:50:23','globeadmin','2022-01-08 10:51:55','globeadmin'),('59d88cc27adf3b2','548338073921bfe',NULL,NULL,'0',10,'SELECT if(count(grading_period.id)>0,\'1\',\'0\')\nFROM school\n    left join grading_period ON school.grading_period_id=grading_period.id\nWHERE \n    CURDATE() between grading_period.start_date AND grading_period.end_date ','reg_markbtn',40,10,'Προσωπικές Εργασίες',NULL,'html',192,73,220,100,'l','0','0','','0',NULL,NULL,'#RECORD_ID# ','562362d2ef4f556',NULL,'','',NULL,NULL,'<table border=0 align=\"center\" CELLSPACING=0 CELLPADDING=0 width=\"100%\" \n                            onmouseover=\"document.getElementById(\'img_mpost_id\').src=\'images/mpostb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_mpost_id\').src=\'images/mpost.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\"center\">\n            <img width=98 height=74 id=\'img_mpost_id\' src=\'images/mpost.png\' title=\'Καταχώριση Αξιολόγησης\'/>    	\n        </td>\n    </tr>\n    <tr>\n        <td align=\"center\">\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Καταχώριση Αξιολόγησης</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-07 11:13:54','globeadmin','2022-01-08 10:50:23','globeadmin','2022-01-08 10:51:55','globeadmin'),('59d89292db86055','561922d0a8f28d2',NULL,NULL,'1',10,NULL,'justifie_student_absencebtn',60,20,'Απουσίες',NULL,'html',192,380,220,100,'c','0','0','','0',NULL,NULL,NULL,'55222f79d342b66',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_jasabs_id\').src=\'images/jasabsb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_jasabs_id\').src=\'images/jasabs.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_jasabs_id\' src=\'images/jasabs.png\' title=\'Δικαιολόγηση απουσιών του μαθητή\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Δικαιολόγηση Απουσιών</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-07 11:38:42','globeadmin','2017-10-28 20:39:03','globeadmin','2018-08-13 10:29:14','globeadmin'),('59d89a66f197e44','548338073921bfe',NULL,NULL,'0',10,NULL,'critirion_general_btn',50,10,'Προσωπικές Εργασίες',NULL,'html',334,687,220,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_critiria_id\').src=\'images/critirionb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_critiria_id\').src=\'images/critirion.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_critiria_id\' src=\'images/critirion.png\' title=\'Γενικά Κριτήρια Περιγραφικής Αξιολόγησης\'/>\n            <img /> \n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Κριτήρια Περιγραφικής Αξιολόγησης</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-07 12:12:07','globeadmin','2022-01-13 09:25:56','globeadmin','2022-01-13 09:25:56','globeadmin'),('59e1e0978c55125','59da63096606dc0',NULL,NULL,'1',10,NULL,'sisyphos_info_img1',10,500,'Πληροφορίες',NULL,'html',91,102,334,66,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<img id=\'img_sisyphos_id\' src=\'images/sisyphos.png\'/> ','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-14 13:01:59','globeadmin','2017-10-14 13:13:04','globeadmin','2022-01-08 14:20:42','globeadmin'),('59e1e0ba36cb4b1','59da63096606dc0',NULL,NULL,'1',10,NULL,'sisyphos_info_label1',20,500,'Πληροφορίες','Πληροφοριακό Σύστημα «Σίσυφος»','words',90,463,450,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-14 13:02:34','globeadmin','2017-10-14 13:13:04','globeadmin','2022-01-08 14:20:42','globeadmin'),('59e1e0dc8755cbe','59da63096606dc0',NULL,NULL,'1',10,NULL,'sisyphos_info_label2',30,500,'Πληροφορίες','Έκδοση','display',112,469,150,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select version from school where id=1',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-14 13:03:08','globeadmin','2017-10-14 13:13:04','globeadmin','2022-01-08 14:20:42','globeadmin'),('59e1e106cfca2f4','59da63096606dc0',NULL,NULL,'1',10,NULL,'sisyphos_info_label5',50,500,'Πληροφορίες',NULL,'html',143,652,250,50,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 width=100% height=100%>\n<tr>\n<td valign=middle align=left>\n<a href=\"http://sisyphos.gr/index.php?page=creator.html\" target=\"_blank\">Παπαδακάκης Νεκτάριος</a>\n</td>\n</tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-14 13:03:50','globeadmin','2019-11-03 14:05:52','globeadmin','2022-01-08 14:20:42','globeadmin'),('59e1e13758b285b','59da63096606dc0',NULL,NULL,'1',10,NULL,'sisyphos_info_label3',60,500,'Πληροφορίες','Περισσότερες πληροφορίες στην ιστοσελίδα  ','html',222,200,400,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 width=100% height=100%>\n<tr>\n<td valign=middle align=left>\n<a href=\"http://www.sisyphos.gr\" target=\"_blank\">www.sisyphos.gr</a>\n</td>\n</tr>\n</table>\n\n','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-14 13:04:39','globeadmin','2017-10-14 13:14:39','globeadmin','2022-01-08 14:20:42','globeadmin'),('59e1e15fb7cea14','59da63096606dc0',NULL,NULL,'1',10,NULL,'sisyphos_info_label21',40,500,'Πληροφορίες',NULL,'display',155,463,200,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select concat(\'Copyright (c) 2014-\',YEAR(CURDATE()))',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-14 13:05:19','globeadmin','2019-11-03 14:06:05','globeadmin','2022-01-08 14:20:42','globeadmin'),('59e1e18940164f9','59da63096606dc0',NULL,NULL,'1',10,NULL,'sisyphos_info_label4',70,500,'Πληροφορίες','Επικοινωνία στο info.sisyphos@gmail.com ή στη  ','html',263,175,400,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 width=100% height=100%>\n<tr>\n<td valign=middle align=left>\n<a href=\"http://sisyphos.gr/index.php?page=contact.html\" target=\"_blank\">Φόρμα Επικοινωνίας</a>\n</td>\n</tr>\n</table>\n','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-14 13:06:01','globeadmin','2017-10-14 13:13:04','globeadmin','2022-01-08 14:20:42','globeadmin'),('59e1e1ada68a0e4','59da63096606dc0',NULL,NULL,'1',10,NULL,'sisyphos_info_label6',80,500,'Πληροφορίες','Οδηγίες για τη χρήση του συστήματος στον  ','html',304,205,400,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 width=100% height=100%>\n<tr>\n<td valign=middle align=left>\n<a href=\"http://sisyphos.gr/index.php?page=userguide.html\" target=\"_blank\">Οδηγό Χρήσης</a>\n</td>\n</tr>\n</table>\n','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-14 13:06:37','globeadmin','2017-10-14 13:13:04','globeadmin','2022-01-08 14:20:42','globeadmin'),('59e1e1cd1184587','59da63096606dc0',NULL,NULL,'1',10,NULL,'sisyphos_info_label7',90,500,'Πληροφορίες','Ερωτήσεις, σχόλια, παρατηρήσεις και γνώμες στο  ','html',345,169,400,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 width=100% height=100%>\n<tr>\n<td valign=middle align=left>\n<a href=\"http://www.sisyphos.gr/forum\" target=\"_blank\">Φόρουμ</a>\n</td>\n</tr>\n</table>\n','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-14 13:07:09','globeadmin','2017-10-14 13:13:04','globeadmin','2022-01-08 14:20:42','globeadmin'),('59e1e3cd5832d70','59da63096606dc0',NULL,NULL,'0',10,NULL,'student_homebtnimg',20,10,'Αρχικό Μενού',NULL,'html',50,73,220,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100%>\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_ucard_id\' src=\'images/boy.png\' title=\'Προσωπικά Στοιχεία και Στοιχεία Σχολείου του Μαθητή\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Στοιχεία Μαθητή</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-14 13:15:41','globeadmin','2017-10-24 15:52:46','globeadmin','2022-01-08 22:17:25','globeadmin'),('59e21657a87accd','59da63096606dc0',NULL,NULL,'1',10,'select \'0\'','student_gender',100,500,'Πληροφορίες','Φύλο Μαθητή','display',382,381,40,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select gender\nfrom student\ninner join session_variables ON student.id = session_variables.student_id\nwhere session_id = \'#session_id#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-14 16:51:19','globeadmin','2017-10-14 16:59:04','globeadmin','2022-01-08 14:20:43','globeadmin'),('59e1e3e61041527','59da63096606dc0',NULL,NULL,'0',10,NULL,'absence_homebtnimg',20,10,'Αρχικό Μενού',NULL,'html',192,73,220,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_absences_id\').src=\'images/absencesb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_absences_id\').src=\'images/absences.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_absences_id\' src=\'images/absences.png\' title=\'Πληροφορίες για τις Απουσίες του Μαθητή\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Απουσίες</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-14 13:16:06','globeadmin','2017-10-14 18:18:05','globeadmin','2022-01-08 22:15:51','globeadmin'),('59e1e40034cb30b','59da63096606dc0',NULL,NULL,'0',10,NULL,'penalty_imgbtn',60,10,'Αρχικό Μενού',NULL,'html',334,380,220,100,'l','0','0','','0',NULL,NULL,NULL,'5476201e5a3d38f',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_cards_id\').src=\'images/cards_cupb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_cards_id\').src=\'images/cards_cup.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=99 height=74 id=\'img_cards_id\' src=\'images/cards_cup.png\' title=\'Ποινές και Επιβραβεύσεις που έχουν Επιβληθεί ή Αποδοθεί στο Μαθητή\'/>\n            <img /> \n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Ποινές & Επιβραβεύσεις</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-14 13:16:32','globeadmin','2022-01-08 14:12:11','globeadmin','2022-01-08 22:05:32','globeadmin'),('59e1e423b6202f3','59da63096606dc0',NULL,NULL,'0',10,NULL,'fullcalendar',40,10,'Αρχικό Μενού',NULL,'html',50,380,220,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0  \n                            onmouseover=\"document.getElementById(\'img_calendar\').src=\'images/calendarb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_calendar\').src=\'images/calendar.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_calendar\' src=\'images/calendar.png\' title=\'Ημερολόγιο Σχολείου\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Ημερολόγιο</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-14 13:17:07','globeadmin','2017-10-14 13:17:07','globeadmin','2022-01-08 14:20:42','globeadmin'),('59e1e446a9cfe90','59da63096606dc0',NULL,NULL,'0',10,NULL,'mark_homebtnimg',30,10,'Αρχικό Μενού',NULL,'html',334,73,220,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_amark_id\').src=\'images/amarkb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_amark_id\').src=\'images/amark.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=86 height=74 id=\'img_amark_id\' src=\'images/amark.png\' title=\'Αξιολόγηση - Βαθμολογία\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Αξιολόγηση - Βαθμολογία</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-14 13:17:42','globeadmin','2017-10-14 18:48:09','globeadmin','2022-01-08 14:20:41','globeadmin'),('59e1e46193ea74e','59da63096606dc0',NULL,NULL,'0',10,NULL,'send_messagebtnimg',50,10,'Αρχικό Μενού',NULL,'html',192,380,220,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_message_id\').src=\'images/pmsgb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_message_id\').src=\'images/pmsg.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_message_id\' src=\'images/pmsg.png\' title=\'Αποστολή Μηνύματος Email σε Καθηγητές\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Αποστολή Μηνύματος</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-14 13:18:09','globeadmin','2017-10-14 18:48:09','globeadmin','2022-01-08 14:20:42','globeadmin'),('59e1e47c0b04541','59da63096606dc0',NULL,NULL,'0',10,NULL,'subject_homebtnimg',80,10,'Αρχικό Μενού',NULL,'html',50,647,300,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_subles_id\').src=\'images/sublesb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_subles_id\').src=\'images/subles.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=98 height=74 id=\'img_subles_id\' src=\'images/subles.png\' title=\'Διδασκαλίες, Σχόλια Καθηγητών και Ωρολόγιο Πρόγραμμα\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Διδασκαλίες, Σχόλια Καθηγητών & Πρόγραμμα</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-14 13:18:36','globeadmin','2017-10-21 11:09:04','globeadmin','2022-01-08 14:20:42','globeadmin'),('59e1e498d58f972','59da63096606dc0',NULL,NULL,'0',10,NULL,'vote_imgbtn',80,10,'Αρχικό Μενού',NULL,'html',192,687,220,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_vote_id\').src=\'images/electionsb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_vote_id\').src=\'images/elections.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_vote_id\' src=\'images/elections.png\' title=\'Ηλεκτρονικές Ψηφοφορίες & Δηλώσεις\'/>\n            <img style=\"position: absolute;top: 1px;left: 150px;display: none;\" width=20 height=20 id=\'check_id\' src=\'images/check.png\' title=\'Ανοιχτή Κάλπη\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Ηλεκτρονικές Ψηφοφορίες & Δηλώσεις</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-14 13:19:04','globeadmin','2018-03-10 17:21:38','globeadmin','2022-01-08 14:20:42','globeadmin'),('59e1e4b4764cd6a','59da63096606dc0',NULL,NULL,'0',10,NULL,'school_imgbtn',90,10,'Αρχικό Μενού',NULL,'html',334,687,220,100,'l','0','0','','0',NULL,NULL,'0','54b2d9dd8417a3d',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_school_id\').src=\'images/school2b.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_school_id\').src=\'images/school2.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_school_id\' src=\'images/school2.png\' title=\'Πληροφορίες για το Σχολείο\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Πληροφορίες για το Σχολείο, Επικοινωνία</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-14 13:19:32','globeadmin','2017-10-21 11:09:46','globeadmin','2022-01-08 14:20:42','globeadmin'),('59e31aca1b0afec','59e22e4fa1018fd',NULL,NULL,'1',10,NULL,'registration_number',10,10,'Στοιχεία Μαθητή','Αριθμός Μητρώου :','text',44,35,100,0,'r','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-15 11:22:34','globeadmin','2017-10-15 11:22:34','globeadmin','2017-11-12 16:35:49','globeadmin'),('59e31aedc857967','59e22e4fa1018fd',NULL,NULL,'1',10,NULL,'surname',20,10,'Στοιχεία Μαθητή','Επώνυμο :','text',86,83,300,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-15 11:23:09','globeadmin','2017-10-15 11:23:09','globeadmin','2017-11-12 16:35:49','globeadmin'),('59e31b0c000e695','59e22e4fa1018fd',NULL,NULL,'1',10,NULL,'name',30,10,'Στοιχεία Μαθητή','Όνομα :','text',127,100,300,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-15 11:23:40','globeadmin','2017-10-15 11:23:40','globeadmin','2017-11-12 16:35:49','globeadmin'),('59e31b2d7f44037','59e22e4fa1018fd',NULL,NULL,'1',10,NULL,'fathers_name',40,10,'Στοιχεία Μαθητή','Όνομα Πατρός :','text',169,54,300,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-15 11:24:13','globeadmin','2017-10-15 11:24:13','globeadmin','2017-11-12 16:35:49','globeadmin'),('59e31b52889417e','59e22e4fa1018fd',NULL,NULL,'1',10,NULL,'mothers_name',50,10,'Στοιχεία Μαθητή','Όνομα Μητρός :','text',210,53,300,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-15 11:24:50','globeadmin','2017-10-15 11:24:50','globeadmin','2017-11-12 16:35:49','globeadmin'),('59e31b74ddf11f9','59e22e4fa1018fd',NULL,NULL,'1',10,NULL,'mothers_surname',60,10,'Στοιχεία Μαθητή','Γένος :','text',252,106,300,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-15 11:25:24','globeadmin','2017-10-15 11:25:24','globeadmin','2017-11-12 16:35:49','globeadmin'),('59e31b99997ff28','59e22e4fa1018fd',NULL,NULL,'1',10,NULL,'grade_id',70,10,'Στοιχεία Μαθητή','Τάξη :','display',44,894,60,0,'c','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select short_name \nfrom grade\nwhere id=\'#grade_id#\'','select id,short_name from grade',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2017-10-15 11:26:01','globeadmin','2017-10-15 11:26:01','globeadmin','2017-11-12 16:35:49','globeadmin'),('59e31bc5b1d40c7','59e22e4fa1018fd',NULL,NULL,'1',10,NULL,'speciality_id',80,10,'Στοιχεία Μαθητή','Ειδικότητα :','display',86,672,250,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select short_name \nfrom speciality\nwhere id=\'#speciality_id#\'','select id,name from speciality',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2017-10-15 11:26:45','globeadmin','2017-10-15 11:26:45','globeadmin','2017-11-12 16:35:49','globeadmin'),('59e31be4c06d2f3','59e22e4fa1018fd',NULL,NULL,'1',10,NULL,'teacher_id',90,10,'Στοιχεία Μαθητή','Υπεύθυνος Καθηγητής :','display',127,600,250,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select concat(if(surname is null,\'\',concat(surname,\' \')), IFNULL(name,\'\')) from teacher where id=\'#teacher_id#\'','select id,concat(if(surname is null,\'\',concat(surname,\' \')), IFNULL(name,\'\')) from teacher',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2017-10-15 11:27:16','globeadmin','2017-10-15 11:27:16','globeadmin','2017-11-12 16:35:50','globeadmin'),('59e31c3dac98f21','59e22e4fa1018fd',NULL,NULL,'1',10,NULL,'student_class',100,10,'Στοιχεία Μαθητή',NULL,'iframe',226,538,460,220,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'547cce2020be0b5','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-15 11:28:45','globeadmin','2017-10-15 11:28:45','globeadmin','2017-11-12 16:35:50','globeadmin'),('59e31c6b34eec15','59e22e4fa1018fd',NULL,NULL,'1',10,NULL,'advisor_id',110,10,'Στοιχεία Μαθητή','Ατομικός Σύμβουλος Μαθητή :','display',169,566,250,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select concat(if(surname is null,\'\',concat(surname,\' \')), IFNULL(name,\'\')) from teacher where id=\'#advisor_id#\'\n','select id,concat(if(surname is null,\'\',concat(surname,\' \')), IFNULL(name,\'\')) from teacher',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2017-10-15 11:29:31','globeadmin','2017-10-15 11:29:31','globeadmin','2017-11-12 16:35:50','globeadmin'),('59e31ca52d77dc4','59e22e4fa1018fd',NULL,NULL,'0',10,NULL,'notification_choices_img',130,10,'Στοιχεία Μαθητή',NULL,'html',321,77,200,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0  \n                            onmouseover=\"document.getElementById(\'img_notification_id\').src=\'images/notification_typeb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_notification_id\').src=\'images/notification_type.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_notification_id\' src=\'images/notification_type.png\' title=\'Επιλογές Ειδοποιήσεων\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Επιλογές Ειδοποιήσεων</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-15 11:30:29','globeadmin','2017-10-15 11:30:29','globeadmin','2022-01-08 22:18:33','globeadmin'),('59e31cec0b1f451','59e22e4fa1018fd',NULL,NULL,'0',10,NULL,'parent_change_account',120,10,'Στοιχεία Μαθητή',NULL,'html',321,283,200,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0  \n                            onmouseover=\"document.getElementById(\'img_log_user_id\').src=\'images/log_userb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_log_user_id\').src=\'images/log_user.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_log_user_id\' src=\'images/log_user.png\' title=\'Αλλαγή Κωδικού Πρόσβασης\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Ο Λογαριασμός μου</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-15 11:31:40','globeadmin','2017-10-21 10:59:18','globeadmin','2017-11-12 16:35:50','globeadmin'),('59e3827b79a7556','54a6fde1ab6eb6d',NULL,NULL,'1',10,'SELECT IF(allow_parents_to_edit=1,\'0\',\'1\') FROM school','label_message',190,20,'Στοιχεία Επικοινωνίας','Σε περίπτωση λάθους ή ελλείψεων στα στοιχεία επικοινωνίας, παρακαλώ επικοινωνήστε με τον υπεύθυνο Καθηγητή για τη διόρθωση τους.','words',444,68,900,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-15 18:44:59','globeadmin','2020-09-06 10:18:18','globeadmin','2021-09-06 20:12:24','globeadmin'),('59e388c0ab8b24f','59e22f4f52546e3',NULL,NULL,'1',10,'select \'0\'','registration_number',80,10,'Αποστολή Μηνύματος','ΑΜ :','text',120,941,50,0,'r','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-15 19:11:44','globeadmin','2017-10-15 19:16:19','globeadmin','2021-02-16 15:14:14','globeadmin'),('59e388d6d76fa51','59e22f4f52546e3',NULL,NULL,'1',10,'select \'0\'','surname',90,10,'Αποστολή Μηνύματος','Επώνυμο :','text',157,905,50,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-15 19:12:06','globeadmin','2017-10-15 19:16:31','globeadmin','2021-02-16 15:14:14','globeadmin'),('59e388e984652ed','59e22f4f52546e3',NULL,NULL,'1',10,'select \'0\'','name',100,10,'Αποστολή Μηνύματος','Όνομα :','text',198,921,50,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-15 19:12:25','globeadmin','2017-10-15 19:16:46','globeadmin','2021-02-16 15:14:14','globeadmin'),('59e5cdf909aa105','59e5cdf8d43772d',NULL,NULL,'1',10,NULL,'name',30,10,'Λεπτομέρειες','Όνομα :','text',102,103,700,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2017-10-20 15:15:16','globeadmin','2021-10-23 22:10:40','globeadmin'),('59e5cdf910e7511','59e5cdf8d43772d',NULL,NULL,'1',10,NULL,'description',40,10,'Λεπτομέρειες','Περιγραφή :','textarea',148,79,700,70,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2017-10-20 15:15:16','globeadmin','2021-10-23 22:10:40','globeadmin'),('59e5cdf918918d1','59e5cdf8d43772d',NULL,NULL,'1',10,NULL,'start_date',60,10,'Λεπτομέρειες','Έναρξή Ψηφοφορίας (Άνοιγμα Κάλπης) :','text',263,42,100,0,'r','0','0','SELECT DATE_ADD(CURDATE(), INTERVAL 1 DAY)','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',100,250,'0000-00-00 00:00:00','','2017-10-20 15:15:16','globeadmin','2021-10-23 22:10:40','globeadmin'),('59e5cdf91f82cf2','59e5cdf8d43772d',NULL,NULL,'1',10,NULL,'start_time',70,10,'Λεπτομέρειες',NULL,'text',263,391,70,0,'r','0','0','select \'00:00:00\'','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2017-10-20 15:15:16','globeadmin','2021-10-23 22:10:40','globeadmin'),('59e5cdf926d5fdb','59e5cdf8d43772d',NULL,NULL,'1',10,NULL,'max_numb_of_choices',100,10,'Λεπτομέρειες','Μέγιστος Αριθμός Επιλογών (Σταυροί Προτίμησης) :','text',384,50,60,0,'c','0','0','select \'1\'','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'0000-00-00 00:00:00','','2017-10-20 15:15:16','globeadmin','2021-10-23 22:10:41','globeadmin'),('59e5cdf92e282d4','59e5cdf8d43772d',NULL,NULL,'1',10,NULL,'is_active',10,10,'Λεπτομέρειες','Ενεργή Ψηφοφορία :','checkbox',33,100,100,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2017-10-17 15:35:43','globeadmin','2021-10-23 22:10:40','globeadmin'),('59fe02a0cab2de8','59fe027dd6fe9f8',NULL,NULL,'1',10,NULL,'subject',10,10,'Μαζική Αποστολή Email','Θέμα :','text',20,33,700,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-11-04 20:10:40','globeadmin','2017-11-04 20:10:40','globeadmin','2021-10-19 23:36:53','globeadmin'),('59e5d19c1ad01bf','59e5cdf8d43772d',NULL,NULL,'1',10,NULL,'end_date',80,10,'Λεπτομέρειες','Λήξη Ψηφοφορίας (Κλείσιμο Κάλπης):','text',306,58,100,0,'r','0','0','SELECT DATE_ADD(CURDATE(), INTERVAL 1 DAY)','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',100,250,'2017-10-17 12:47:08','globeadmin','2017-10-20 15:15:16','globeadmin','2021-10-23 22:10:41','globeadmin'),('59e5d1f73a54086','59e5cdf8d43772d',NULL,NULL,'1',10,NULL,'end_time',90,10,'Λεπτομέρειες',NULL,'text',306,391,70,0,'r','0','0','select \'23:59:59\'','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-17 12:48:39','globeadmin','2017-10-20 15:15:16','globeadmin','2021-10-23 22:10:41','globeadmin'),('59f849d6a5c4130','5470b6d7c79d3b9',NULL,NULL,'1',10,'select if(\'#RECORD_ID#\'<>\'-1\',\'1\',\'0\')','student_id_select',10,20,'Μαθητές','Μαθητές : ','listbox',26,22,420,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','','select distinct student.id, concat(ifNULL(grade.short_name,\'\'),\' - \',student.surname,\' \',student.name,\' \',ifNULL(student.fathers_name,\'\'),\' - \',student.registration_number) \nfrom student\nleft join grade on grade.id = student.grade_id\norder by student.grade_id,student.surname,student.name,student.fathers_name\n',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-31 12:00:54','globeadmin','2019-02-10 00:07:38','globeadmin','2022-01-08 15:26:11','globeadmin'),('59e62fd86e27329','59e5cdf8d43772d',NULL,NULL,'1',10,NULL,'participants_iframe',80,30,'Ψηφοφόροι',NULL,'iframe',142,13,920,400,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'59e6312e9944cb9','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-17 19:29:12','globeadmin','2017-10-31 09:15:49','globeadmin','2021-10-23 22:10:41','globeadmin'),('59f84bbb9d30ffe','5470b6d7c79d3b9',NULL,NULL,'1',10,'select if(\'#RECORD_ID#\'<>\'-1\',\'1\',\'0\')','Insert_studentdtn',20,20,'Μαθητές','Προσθήκη Μαθητών','button',22,550,180,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-31 12:08:59','globeadmin','2018-07-17 00:57:20','globeadmin','2022-01-08 15:26:11','globeadmin'),('59e79a2fab1fc92','59e5cdf8d43772d',NULL,NULL,'1',10,'select \'0\'','teacher_id',120,10,'Λεπτομέρειες','Δημιουργήθηκε από :','text',427,806,40,0,'c','0','1','select if(teacher_id=-1,26,teacher_id) \nfrom session_variables \nwhere session_id = \'#session_id#\'','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2017-10-18 21:15:11','globeadmin','2017-10-20 15:15:16','globeadmin','2021-10-23 22:10:41','globeadmin'),('59e6578aa3c36bd','59e5cdf8d43772d',NULL,NULL,'1',10,NULL,'results_iframe',30,40,'Αποτελέσματα',NULL,'iframe',68,14,950,470,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'59eb9e1160272cc','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-17 22:18:34','globeadmin','2017-10-22 15:48:00','globeadmin','2021-10-23 22:10:42','globeadmin'),('59e79afdd8f1f40','59e5cdf8d43772d',NULL,NULL,'1',10,NULL,'teacher_disp',110,10,'Λεπτομέρειες','Δημιουργήθηκε από :','display',464,39,300,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select concat(if(surname is null,\'\',concat(surname,\' \')), IFNULL(name,\'\')) as teacher_full_name\nfrom teacher\nwhere id = \'#teacher_id#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2017-10-18 21:18:37','globeadmin','2017-10-18 21:20:03','globeadmin','2021-10-23 22:10:41','globeadmin'),('59e7ad3533fac86','59e5cdf8d43772d',NULL,NULL,'1',10,'select if(((\'#nu_user_group#\' IN (\'globeadmin\',\'Managers\',\'AssistManagers\',\'Administrators\')) OR \'#teacher_id#\'=teacher_id) AND \'#nu_new_record#\'=\'0\',\'1\',\'0\')  \nfrom session_variables \nwhere session_id=\'#session_id#\'','choice_student_id_select',10,20,'Επιλογές ή Υποψήφιοι','Μαθητές : ','listbox',32,34,400,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','','select distinct student.id, concat(ifNULL(grade.short_name,\'\'),\' - \',student.surname,\' \',student.name,\' \',student.fathers_name) \nfrom student\ninner join session_variables as sv1 ON sv1.session_id=\'#session_id#\'\nleft join grade on grade.id = student.grade_id\nleft join (    select distinct student_class.student_id as s_id\n                            from student_class\n                            inner join session_variables as sv2 ON sv2.session_id=\'#session_id#\'\n                            inner join card ON card.class_id=student_class.class_id\n                            where\n                                card.valid_from=(select max(start_date) from timetable) and   \n                                card.teacher_id=sv2.teacher_id) as s ON s.s_id = student.id\nwhere\n        \'#nu_user_group#\'=\'globeadmin\' OR \n        \'#nu_user_group#\'=\'Administrators\' OR \n        \'#nu_user_group#\'=\'Managers\' OR \n        \'#nu_user_group#\'=\'AssistManagers\' OR\n        \'#nu_user_group#\'=\'Secretaries\' OR\n        s.s_id is not null OR\n        student.teacher_id = sv1.teacher_id OR\n        student.advisor_id = sv1.teacher_id\norder by student.grade_id,student.surname,student.name,student.fathers_name\n',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-18 22:36:21','globeadmin','2017-11-03 07:40:38','globeadmin','2021-10-23 22:10:41','globeadmin'),('59e7aedbaa9a31d','59e5cdf8d43772d',NULL,NULL,'1',10,'select if(((\'#nu_user_group#\' IN (\'globeadmin\',\'Managers\',\'AssistManagers\',\'Administrators\')) OR \'#teacher_id#\'=teacher_id) AND \'#nu_new_record#\'=\'0\',\'1\',\'0\')  \nfrom session_variables \nwhere session_id=\'#session_id#\'','student_id_select',20,30,'Ψηφοφόροι','Μαθητές : ','listbox',63,90,400,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','','select distinct student.id, concat(ifNULL(grade.short_name,\'\'),\' - \',student.surname,\' \',student.name,\' \',student.fathers_name) \nfrom student\ninner join session_variables as sv1 ON sv1.session_id=\'#session_id#\'\nleft join grade on grade.id = student.grade_id\nleft join (    select distinct student_class.student_id as s_id\n                            from student_class\n                            inner join session_variables as sv2 ON sv2.session_id=\'#session_id#\'\n                            inner join card ON card.class_id=student_class.class_id\n                            where\n                                card.valid_from=(select max(start_date) from timetable) and   \n                                card.teacher_id=sv2.teacher_id) as s ON s.s_id = student.id\nwhere\n        \'#nu_user_group#\'=\'globeadmin\' OR \n        \'#nu_user_group#\'=\'Administrators\' OR \n        \'#nu_user_group#\'=\'Managers\' OR \n        \'#nu_user_group#\'=\'AssistManagers\' OR\n        \'#nu_user_group#\'=\'Secretaries\' OR\n        s.s_id is not null OR\n        student.teacher_id = sv1.teacher_id OR\n        student.advisor_id = sv1.teacher_id\norder by student.grade_id,student.surname,student.name,student.fathers_name\n',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-18 22:43:23','globeadmin','2017-10-31 00:01:52','globeadmin','2021-10-23 22:10:41','globeadmin'),('59e7af6454e1072','59e5cdf8d43772d',NULL,NULL,'1',10,'select if(((\'#nu_user_group#\' IN (\'globeadmin\',\'Managers\',\'AssistManagers\',\'Administrators\')) OR \'#teacher_id#\'=teacher_id) AND \'#nu_new_record#\'=\'0\',\'1\',\'0\')  \nfrom session_variables \nwhere session_id=\'#session_id#\'','students_check',50,30,'Ψηφοφόροι','τους Μαθητές : ','checkbox',100,161,40,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-18 22:45:40','globeadmin','2017-10-31 00:02:39','globeadmin','2021-10-23 22:10:41','globeadmin'),('59e7af884136d36','59e5cdf8d43772d',NULL,NULL,'1',10,'select if(((\'#nu_user_group#\' IN (\'globeadmin\',\'Managers\',\'AssistManagers\',\'Administrators\')) OR \'#teacher_id#\'=teacher_id) AND \'#nu_new_record#\'=\'0\',\'1\',\'0\')  \nfrom session_variables \nwhere session_id=\'#session_id#\'','parents_check',60,30,'Ψηφοφόροι','τους Γονείς : ','checkbox',100,313,40,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-18 22:46:16','globeadmin','2017-10-31 00:02:56','globeadmin','2021-10-23 22:10:41','globeadmin'),('59e7b0f0a6dbecb','59e5cdf8d43772d',NULL,NULL,'1',10,'select if(((\'#nu_user_group#\' IN (\'globeadmin\',\'Managers\',\'AssistManagers\',\'Administrators\')) OR \'#teacher_id#\'=teacher_id) AND \'#nu_new_record#\'=\'0\',\'1\',\'0\')  \nfrom session_variables \nwhere session_id=\'#session_id#\'','add_participants_btn',70,30,'Ψηφοφόροι','Προσθήκη','button',53,612,160,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,name from school where 0=1',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-18 22:52:16','globeadmin','2017-10-31 00:03:11','globeadmin','2021-10-23 22:10:41','globeadmin'),('59e7bc6ababad06','59e5cdf8d43772d',NULL,NULL,'1',10,'select if(((\'#nu_user_group#\' IN (\'globeadmin\',\'Managers\',\'AssistManagers\',\'Administrators\')) OR \'#teacher_id#\'=teacher_id) AND \'#nu_new_record#\'=\'0\',\'1\',\'0\')  \nfrom session_variables \nwhere session_id=\'#session_id#\'','selection1',10,30,'Ψηφοφόροι','Προσθήκη :','dropdown',24,84,300,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,name from school where 0=1',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-18 23:41:14','globeadmin','2017-10-31 00:01:34','globeadmin','2021-10-23 22:10:41','globeadmin'),('59e7bc994ab8101','59e5cdf8d43772d',NULL,NULL,'1',10,'select if(((\'#nu_user_group#\' IN (\'globeadmin\',\'Managers\',\'AssistManagers\',\'Administrators\')) OR \'#teacher_id#\'=teacher_id) AND \'#nu_new_record#\'=\'0\',\'1\',\'0\')  \nfrom session_variables \nwhere session_id=\'#session_id#\'','grade_id_select',40,30,'Ψηφοφόροι','Τάξεις : ','listbox',63,105,150,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','','select grade.id,grade.short_name\nfrom grade\norder by grade.short_name',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-18 23:42:01','globeadmin','2017-10-31 00:02:22','globeadmin','2021-10-23 22:10:41','globeadmin'),('59e7bcdcdca89d5','59e5cdf8d43772d',NULL,NULL,'1',10,'select if(((\'#nu_user_group#\' IN (\'globeadmin\',\'Managers\',\'AssistManagers\',\'Administrators\')) OR \'#teacher_id#\'=teacher_id) AND \'#nu_new_record#\'=\'0\',\'1\',\'0\')  \nfrom session_variables \nwhere session_id=\'#session_id#\'','class_id_select',30,30,'Ψηφοφόροι','Τμήματα : ','listbox',63,91,200,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','','select distinct class.id,class.short_name \nfrom class\ninner join student_class on class.id=student_class.class_id\nleft join ( select distinct card.class_id as c_id\n            from card\n            inner join session_variables as sv1 ON sv1.session_id=\'#session_id#\'\n            where   card.valid_from=(select max(start_date) from timetable) and \n                    card.teacher_id=sv1.teacher_id) as c ON c.c_id=class.id\nleft join ( select class.id as c_id\n            from class\n            where\n                (   select count(*)\n                    from student\n                    inner join session_variables as sv2 ON sv2.session_id=\'#session_id#\'\n                    inner join student_class ON student.id=student_class.student_id\n                    where \n                    student.teacher_id=sv2.teacher_id AND\n                    student_class.class_id = class.id) = (select count(*) from student_class where class_id=class.id)\n                ) as c1 ON c1.c_id=class.id\nwhere   \'#nu_user_group#\'=\'globeadmin\' OR \n        \'#nu_user_group#\'=\'Administrators\' OR \n        \'#nu_user_group#\'=\'Managers\' OR \n        \'#nu_user_group#\'=\'AssistManagers\' OR\n        \'#nu_user_group#\'=\'Secretaries\' OR\n        c.c_id IS NOT NULL OR\n        c1.c_id IS NOT NULL \norder by class.short_name',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-18 23:43:09','globeadmin','2017-10-31 00:02:07','globeadmin','2021-10-23 22:10:41','globeadmin'),('59e7c1e53fc06ac','59e5cdf8d43772d',NULL,NULL,'1',10,'select if(((\'#nu_user_group#\' IN (\'globeadmin\',\'Managers\',\'AssistManagers\',\'Administrators\')) OR \'#teacher_id#\'=teacher_id) AND \'#nu_new_record#\'=\'0\',\'1\',\'0\')  \nfrom session_variables \nwhere session_id=\'#session_id#\'','add_choices_btn',20,20,'Επιλογές ή Υποψήφιοι','Προσθήκη Μαθητών','button',28,546,160,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,name from school where 0=1',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-19 00:04:37','globeadmin','2017-10-30 23:59:17','globeadmin','2021-10-23 22:10:41','globeadmin'),('59f4839668f6cb5','59e5cdf8d43772d',NULL,NULL,'0',10,NULL,'reload_participants_img',120,30,'Ψηφοφόροι',NULL,'html',30,945,19,19,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"this.style.cursor=\'pointer\';\"\n                            onmouseout=\"this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=17 height=17 id=\'img_remove_attachment\' src=\'images/reset_pass.png\' title=\'Ανανέωση ψηφοφόρων\'/>\n        </td>\n    </tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-28 16:18:14','globeadmin','2017-10-28 16:18:14','globeadmin','2021-10-23 22:10:42','globeadmin'),('59e7c34061216b5','59e5cdf8d43772d',NULL,NULL,'1',10,'select if(\'#nu_new_record#\'=\'0\',\'1\',\'0\')','print_results_btn',20,40,'Αποτελέσματα','Εκτύπωση','button',23,22,160,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,name from school where 0=1',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-19 00:10:24','globeadmin','2017-10-31 08:21:52','globeadmin','2021-10-23 22:10:42','globeadmin'),('59e8f81265927df','59e5cdf8d43772d',NULL,NULL,'1',10,NULL,'status',110,10,'Λεπτομέρειες',NULL,'display',37,760,200,35,'c','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select if(is_active=\'0\',\'Ανενεργή\',if(NOW() BETWEEN CONCAT(start_date,\' \',start_time) AND CONCAT(end_date,\' \',end_time),\'Ανοιχτή Κάλπη\',\nif(NOW()>CONCAT(end_date,\' \',end_time),\'Ολοκληρώθηκε\',\'Θα Ενεργοποιηθεί\')))\nfrom ballot\nwhere id=\'#RECORD_ID#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-19 22:08:02','globeadmin','2017-10-20 16:04:37','globeadmin','2021-10-23 22:10:41','globeadmin'),('59e8fa94555f00b','59e5cdf8d43772d',NULL,NULL,'1',10,NULL,'is_anonymous',20,10,'Λεπτομέρειες','Ανώνυμη Ψηφοφορία :','checkbox',33,314,100,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-19 22:18:44','globeadmin','2017-10-19 22:18:44','globeadmin','2021-10-23 22:10:40','globeadmin'),('59fc9cd225ef446','59e5cdf8d43772d',NULL,NULL,'1',10,NULL,'create_notification',150,10,'Λεπτομέρειες','Δημιουργία Ειδοποιήσεων για Μαθητές/Γονείς :','checkbox',379,580,100,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-11-03 18:44:02','globeadmin','2017-11-03 18:44:02','globeadmin','2021-10-23 22:10:41','globeadmin'),('59e9e5ea6631a26','59e90833df79d7d',NULL,NULL,'1',10,NULL,'ballot_box_iframe',80,10,'Κάλπη',NULL,'iframe',185,54,860,600,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'59ea6f7db44655c','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-20 15:02:50','globeadmin','2017-10-22 09:56:32','globeadmin','2019-11-07 12:59:08','globeadmin'),('59e9e63c6acde43','59e90833df79d7d',NULL,NULL,'1',10,NULL,'choices_iframe',10,20,'Πληροφορίες για τις Υποψηφιότητες',NULL,'iframe',31,24,930,750,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'59ea53ae2bbc384','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-20 15:04:12','globeadmin','2017-10-24 00:11:42','globeadmin','2019-11-07 12:59:08','globeadmin'),('59e9e68201c01b8','59e90833df79d7d',NULL,NULL,'1',10,NULL,'results_iframe',10,30,'Αποτελέσματα',NULL,'iframe',47,14,950,740,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'59ecb4b6b724284','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-20 15:05:22','globeadmin','2017-10-22 18:19:44','globeadmin','2019-11-07 13:12:58','globeadmin'),('59e9ea1e2b54c25','59e90833df79d7d',NULL,NULL,'1',10,NULL,'is_anonymous_disp',20,10,'Κάλπη',NULL,'display',20,37,230,0,'c','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select if(\'#is_anonymous#\'=1,\'Ανώνυμη Ψηφοφορία\',\'Επώνυμη Ψηφοφορία\')',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-20 15:20:46','globeadmin','2017-10-20 22:02:20','globeadmin','2019-11-07 12:59:08','globeadmin'),('59e9ea3976f2e21','59e90833df79d7d',NULL,NULL,'1',10,NULL,'name',60,10,'Κάλπη',NULL,'text',70,37,900,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-20 15:21:13','globeadmin','2017-10-21 13:37:47','globeadmin','2019-11-07 12:59:08','globeadmin'),('59e9ea5b153663a','59e90833df79d7d',NULL,NULL,'1',10,'select \'0\'','description',10,10,'Κάλπη','Περιγραφή :','textarea',24,600,40,10,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-20 15:21:47','globeadmin','2017-10-20 22:02:20','globeadmin','2019-11-07 12:59:08','globeadmin'),('59e9ea78aef7b79','59e90833df79d7d',NULL,NULL,'1',10,NULL,'start_date_time_disp',30,10,'Κάλπη','Από :','display',20,293,155,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select concat(DATE_FORMAT(\'#start_date#\',\'%d-%m-%Y\'),\' \',\'#start_time#\')',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',100,250,'2017-10-20 15:22:16','globeadmin','2017-10-20 22:02:20','globeadmin','2019-11-07 12:59:08','globeadmin'),('59ea67cf94805ef','59ea67cf8d2d9b3',NULL,NULL,'1',10,NULL,'description_html',10,10,'Περιγραφή Επιλογής/Υποψηφίου',NULL,'iframe',27,12,750,350,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'54a2700ab351809','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2017-10-21 00:28:11','globeadmin','2017-10-31 10:48:01','globeadmin'),('59ea439d00040b0','59e90833df79d7d',NULL,NULL,'1',10,NULL,'end_date_time_disp',40,10,'Κάλπη','Έως :','display',20,496,155,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select concat(DATE_FORMAT(\'#end_date#\',\'%d-%m-%Y\'),\' \',\'#end_time#\')',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',100,250,'2017-10-20 21:42:37','globeadmin','2017-10-20 22:02:20','globeadmin','2019-11-07 12:59:08','globeadmin'),('59e9eaf5e9394a2','59e90833df79d7d',NULL,NULL,'1',10,'select if(ballot.is_active=\'1\' and (NOW() BETWEEN CONCAT(ballot.start_date,\' \',ballot.start_time) AND CONCAT(ballot.end_date,\' \',ballot.end_time)) and ballot_voter.voted=0, \'1\',\'0\')\nfrom ballot\ninner join session_variables ON session_id = \'#session_id#\'\nleft join ballot_voter on (ballot.id = ballot_voter.ballot_id and ballot_voter.student_id = session_variables.student_id)\nwhere ballot.id=\'#RECORD_ID#\'','numb_of_choices_disp',70,10,'Κάλπη',NULL,'display',154,60,250,0,'c','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select \'Έχετε μέχρι #max_numb_of_choices# επιλογές\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2017-10-20 15:24:22','globeadmin','2017-10-21 13:53:23','globeadmin','2019-11-07 12:59:08','globeadmin'),('59e9eb15543e607','59e90833df79d7d',NULL,NULL,'1',10,NULL,'teacher_disp',20,30,'Αποτελέσματα','Δημιουργός της Ψηφοφορίας :','display',10,457,300,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select concat(if(surname is null,\'\',concat(surname,\' \')), IFNULL(name,\'\')) as teacher_full_name\nfrom teacher\nwhere id = \'#teacher_id#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2017-10-20 15:24:53','globeadmin','2017-10-21 00:03:05','globeadmin','2019-11-07 12:59:08','globeadmin'),('59e9eb33cc1e677','59e90833df79d7d',NULL,NULL,'1',10,NULL,'status',50,10,'Κάλπη',NULL,'display',20,708,230,35,'c','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select if(is_active=\'0\',\'Ανενεργή\',if(NOW() BETWEEN CONCAT(start_date,\' \',start_time) AND CONCAT(end_date,\' \',end_time),\'Ανοιχτή Κάλπη\',\nif(NOW()>CONCAT(end_date,\' \',end_time),\'Ολοκληρώθηκε\',\'Θα Ενεργοποιηθεί\')))\nfrom ballot\nwhere id=\'#RECORD_ID#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-20 15:25:23','globeadmin','2017-10-20 22:18:04','globeadmin','2019-11-07 12:59:08','globeadmin'),('59f608735551d19','59f607fc7a2c0b2',NULL,NULL,'1',10,'select \'0\'','description',40,10,'Λεπτομέρειες Επιλογής/Υποψηφίου',NULL,'textarea',70,20,100,100,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2017-10-29 18:57:23','globeadmin','2017-10-29 19:24:26','globeadmin','2017-11-06 16:46:11','globeadmin'),('59eaef9c6e03426','59e5cdf8d43772d',NULL,NULL,'1',10,NULL,'display_results',50,10,'Λεπτομέρειες','Εμφάνιση Αποτελεσμάτων/Ψήφων στους Μαθητές/Γονείς :','checkbox',301,514,100,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-21 09:56:28','globeadmin','2018-10-20 17:45:19','globeadmin','2021-10-23 22:10:40','globeadmin'),('59eaf9f88c1efac','59eaf663b08f216',NULL,NULL,'1',10,'select \'0\'','description',10,10,'Περιγραφή Επιλογής/Υποψηφίου',NULL,'textarea',20,20,100,100,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2017-10-21 10:40:40','globeadmin','2017-10-21 10:55:22','globeadmin','2017-10-31 10:48:07','globeadmin'),('59eafa42367d8ab','59eaf663b08f216',NULL,NULL,'1',10,NULL,'tinymce_editor',20,10,'Περιγραφή Επιλογής/Υποψηφίου',NULL,'iframe',9,13,900,400,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'56cc9f04b82528e','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-21 10:41:54','globeadmin','2017-10-21 10:55:22','globeadmin','2017-10-31 10:48:07','globeadmin'),('59eb212d0f72642','59e90833df79d7d',NULL,NULL,'0',10,'select if(ballot.is_active=\'1\' and (NOW() BETWEEN CONCAT(ballot.start_date,\' \',ballot.start_time) AND CONCAT(ballot.end_date,\' \',ballot.end_time)) and ballot_voter.voted=0, \'1\',\'0\')\nfrom ballot\ninner join session_variables ON session_id = \'#session_id#\'\nleft join ballot_voter on (ballot.id = ballot_voter.ballot_id and ballot_voter.student_id = session_variables.student_id)\nwhere ballot.id=\'#RECORD_ID#\'','vote_btn_img',90,10,'Κάλπη',NULL,'html',101,734,180,80,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_ucard_id\').src=\'images/give_voteb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_ucard_id\').src=\'images/give_vote.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=60 height=60 id=\'img_ucard_id\' src=\'images/give_vote.png\' title=\'Καταχώριση Επιλογών\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family:Verdana;font-size:9pt;font-weight: bold;color: black;\'>Καταχώριση Επιλογών</span>\n        </td>\n    </tr>\n    \n</table>\n\n\n                    \n                    ','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-21 13:27:57','globeadmin','2017-10-21 20:23:12','globeadmin','2019-11-07 12:59:08','globeadmin'),('59ecba86210d70b','5618f5cc92f9c9e',NULL,NULL,'0',10,NULL,'vote_imgbtn',60,10,'Αρχικό Μενού',NULL,'html',334,380,220,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_vote_id\').src=\'images/electionsb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_vote_id\').src=\'images/elections.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_vote_id\' src=\'images/elections.png\' title=\'Ηλεκτρονικές Ψηφοφορίες & Δηλώσεις\'/>\n            <img /> \n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Ηλεκτρονικές Ψηφοφορίες & Δηλώσεις</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-22 18:34:30','globeadmin','2018-03-10 17:20:50','globeadmin','2022-11-30 11:53:03','globeadmin'),('59f25ab91583d52','59e5cdf8d43772d',NULL,NULL,'1',10,NULL,'graph_iframe',10,50,'Ροή Ψηφοφορίας',NULL,'iframe',43,13,950,500,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'59f2469383bbd98','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-27 00:59:21','globeadmin','2017-10-27 00:59:21','globeadmin','2021-10-23 22:10:42','globeadmin'),('59f47ffb33214c8','59e5cdf8d43772d',NULL,NULL,'0',10,NULL,'reload_graph_img',20,50,'Ροή Ψηφοφορίας',NULL,'html',30,945,19,19,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"this.style.cursor=\'pointer\';\"\n                            onmouseout=\"this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=17 height=17 id=\'img_remove_attachment\' src=\'images/reset_pass.png\' title=\'Ανανέωση Γραφήματος\'/>\n        </td>\n    </tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-28 16:02:51','globeadmin','2017-10-28 16:15:19','globeadmin','2021-10-23 22:10:42','globeadmin'),('59f481b5bf9d01f','59e5cdf8d43772d',NULL,NULL,'0',10,NULL,'reload_results_img',40,40,'Αποτελέσματα',NULL,'html',30,945,19,19,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"this.style.cursor=\'pointer\';\"\n                            onmouseout=\"this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=17 height=17 id=\'img_remove_attachment\' src=\'images/reset_pass.png\' title=\'Ανανέωση Αποτελεσμάτων\'/>\n        </td>\n    </tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-28 16:10:13','globeadmin','2017-10-28 16:14:20','globeadmin','2021-10-23 22:10:42','globeadmin'),('59f4879946ac4f1','59e5cdf8d43772d',NULL,NULL,'1',10,NULL,'is_shared',140,10,'Λεπτομέρειες','Εμφάνιση σε Όλους τους Καθηγητές :','checkbox',458,635,100,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-28 16:35:21','globeadmin','2017-10-28 16:53:43','globeadmin','2021-10-23 22:10:41','globeadmin'),('59f4bacf3c4fe05','59d67ca712d3ffa',NULL,NULL,'0',10,NULL,'vote_imgbtn',60,10,'Αρχικό Μενού',NULL,'html',334,380,220,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_vote_id\').src=\'images/electionsb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_vote_id\').src=\'images/elections.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_vote_id\' src=\'images/elections.png\' title=\'Ηλεκτρονικές Ψηφοφορίες & Δηλώσεις\'/>\n            <img /> \n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Ηλεκτρονικές Ψηφοφορίες & Δηλώσεις</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-28 20:13:51','globeadmin','2018-03-10 17:22:47','globeadmin','2021-03-22 19:49:23','globeadmin'),('59f4dcc34b5f063','59e5cdf8d43772d',NULL,NULL,'1',10,NULL,'choices_iframe',40,20,'Επιλογές ή Υποψήφιοι',NULL,'iframe',75,30,920,450,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'59f4d865bbf74c4','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-28 22:38:43','globeadmin','2017-10-28 22:39:51','globeadmin','2021-10-23 22:10:41','globeadmin'),('59f608ac3566ad9','59f607fc7a2c0b2',NULL,NULL,'1',10,NULL,'tinymce_editor',50,10,'Λεπτομέρειες Επιλογής/Υποψηφίου',NULL,'iframe',103,14,900,400,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'56cc9f04b82528e','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-29 18:58:20','globeadmin','2017-10-29 19:24:26','globeadmin','2017-11-06 16:46:12','globeadmin'),('59f60b0cae106bd','59f607fc7a2c0b2',NULL,NULL,'1',10,NULL,'name',10,10,'Λεπτομέρειες Επιλογής/Υποψηφίου','Όνομα Επιλογής :','text',16,23,750,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-29 19:08:28','globeadmin','2017-10-29 19:24:26','globeadmin','2017-11-06 16:46:11','globeadmin'),('59f60bef6b7e2f1','59f607fc7a2c0b2',NULL,NULL,'1',10,'select if(\'#student_id#\'<>\'\',\'1\',\'0\')','student_name_disp',20,10,'Λεπτομέρειες Επιλογής/Υποψηφίου','Μαθητής :','display',48,68,750,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select CONCAT(student.registration_number,\'-\',student.surname,\' \',student.name,\' \',IF(student.fathers_name IS NULL,\'\',CONCAT(\' πατ. \',student.fathers_name)))\nfrom student\nwhere id=\'#student_id#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-29 19:12:15','globeadmin','2017-10-29 19:24:26','globeadmin','2017-11-06 16:46:11','globeadmin'),('59f60cdceebe096','59f607fc7a2c0b2',NULL,NULL,'1',10,NULL,'labe1',30,10,'Λεπτομέρειες Επιλογής/Υποψηφίου','Περιγραφή :','words',81,27,300,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-29 19:16:13','globeadmin','2017-10-29 19:24:26','globeadmin','2017-11-06 16:46:11','globeadmin'),('59f61155c4d8d23','59f607fc7a2c0b2',NULL,NULL,'1',10,'select \'0\'','ballot_id',60,10,'Λεπτομέρειες Επιλογής/Υποψηφίου','Ψηφοφορία :','text',72,798,40,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-29 19:35:17','globeadmin','2017-10-29 19:59:47','globeadmin','2017-11-06 16:46:12','globeadmin'),('59f82161df7848e','59e5cdf8d43772d',NULL,NULL,'0',10,'select if(((\'#nu_user_group#\' IN (\'globeadmin\',\'Managers\',\'AssistManagers\',\'Administrators\')) OR \'#teacher_id#\'=teacher_id) AND \'#nu_new_record#\'=\'0\',\'1\',\'0\')  \nfrom session_variables \nwhere session_id=\'#session_id#\'','remove_participants_img',90,30,'Ψηφοφόροι',NULL,'html',114,870,19,19,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"this.style.cursor=\'pointer\';\"\n                            onmouseout=\"this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=20 height=20 id=\'img_remove_participants\' src=\'images/d.png\' title=\'Διαγραφή Επιλεγμένων\'/>\n        </td>\n    </tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-10-31 09:08:18','globeadmin','2017-10-31 09:19:04','globeadmin','2021-10-23 22:10:41','globeadmin'),('59f84c790a3bb16','5470b6d7c79d3b9',NULL,NULL,'1',10,'select if(\'#RECORD_ID#\'<>\'-1\',\'1\',\'0\')','delete_studentdtn',30,20,'Μαθητές','Αφαίρεση Επιλεγμένων','button',22,746,180,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-31 12:12:09','globeadmin','2018-07-17 00:57:34','globeadmin','2022-01-08 15:26:11','globeadmin'),('59f84f0a3489306','5470b6d7c79d3b9',NULL,NULL,'1',10,NULL,'student_iframe',40,20,'Μαθητές',NULL,'iframe',74,9,920,350,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'59f84dae26c5aa0','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-10-31 12:23:06','globeadmin','2018-07-17 00:53:15','globeadmin','2022-01-08 15:26:11','globeadmin'),('59feefa32d126ff','59a96e2c710af4a',NULL,NULL,'1',10,'select if((\'#nu_user_group#\' IN (\'globeadmin\',\'Managers\',\'AssistManagers\',\'Administrators\',\'Secretaries\')),\'1\',\'0\')','no_check',80,10,'Προγραμματισμός Διαγωνίσματος ή Τεστ','Παράκαμψη Ελέγχων :','checkbox',291,63,40,40,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-11-05 13:01:55','globeadmin','2017-11-05 13:01:55','globeadmin','2020-09-18 19:10:31','globeadmin'),('59fe04616a542a9','nuhome',NULL,NULL,'1',10,NULL,'un_register_btn',110,10,'Globeadmin','Αναίρεση Καταχώρισης','button',55,382,200,35,'l','0','0','','0',NULL,NULL,'0','5a193801b52abb9',NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-11-04 20:18:09','globeadmin','2017-11-25 11:30:32','globeadmin','2018-07-20 16:42:21','globeadmin'),('59ff464f8ecb031','59da63096606dc0',NULL,NULL,'0',10,'select \'0\'','open_ballot',100,10,'Αρχικό Μενού',NULL,'display',236,941,30,30,'l','0','0','','0',NULL,NULL,'0',NULL,NULL,'','','SELECT count(*)\nFROM ballot\nINNER JOIN session_variables ON session_variables.session_id = \'#session_id#\'\nWHERE\n	(session_variables.student_id IN (select student_id from ballot_voter where ballot_voter.ballot_id=ballot.id and (if(\'#nu_user_group#\'=\'Parents\',1,0))=ballot_voter.is_parent) OR\n    session_variables.student_id IN (select student_id from ballot_choice where ballot_choice.ballot_id=ballot.id )) and\n    ballot.is_active = 1 AND\n	NOW() BETWEEN CONCAT(start_date,\' \',start_time) AND CONCAT(end_date,\' \',end_time)',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-11-05 19:11:43','globeadmin','2017-11-05 19:25:46','globeadmin','2022-01-08 14:20:42','globeadmin'),('5a0d31993129587','547372d029461f4',NULL,NULL,'1',10,NULL,'hide_teaching_calendar',20,20,'Αναθέσεις Μαθημάτων','Απόκρυψη ημερολογίων διδασκαλιών  από τους Γονείς/Μαθητές :','checkbox',18,390,30,0,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-11-16 08:35:05','globeadmin','2020-09-22 22:34:19','globeadmin','2021-01-26 20:15:04','globeadmin'),('5a0d333be9a98ad','59d7d837262870c',NULL,NULL,'1',10,NULL,'hide_teaching_calendar',20,10,'Αναθέσεις Μαθημάτων','Απόκρυψη ημερολογίων διδασκαλιών  από τους Γονείς/Μαθητές :','checkbox',18,438,30,0,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-11-16 08:42:04','globeadmin','2017-11-16 08:42:20','globeadmin','2018-07-13 10:58:45','globeadmin'),('5a0d34427b14770','548338073921bfe',NULL,NULL,'1',10,NULL,'hide_teaching_calendar',20,50,'Αναθέσεις Μαθημάτων','Απόκρυψη ημερολογίων διδασκαλιών  από τους Γονείς/Μαθητές :','checkbox',10,357,30,0,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-11-16 08:46:26','globeadmin','2017-11-16 08:46:26','globeadmin','2022-01-08 10:51:56','globeadmin'),('5a1010e9d339207','56192b05ed5032f',NULL,NULL,'0',10,'select if(  \'#nu_user_group#\'=\'globeadmin\' or \n            \'#nu_user_group#\'=\'Administrators\' or \n            \'#nu_user_group#\'=\'Managers\',\'1\',\'0\')','mergebtn',30,20,'Σύστημα',NULL,'html',50,688,220,100,'l','0','0','','0',NULL,NULL,'1','54a52c3dcf3610b',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'merge_id\').src=\'images/mergeb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'merge_id\').src=\'images/merge.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'merge_id\' src=\'images/merge.png\' title=\'Συγχωνεύσεις\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Συγχωνεύσεις</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-11-18 12:52:25','globeadmin','2019-08-06 11:49:51','globeadmin','2019-08-06 11:49:51','globeadmin'),('5a10154c675d3af','5a1011c80a896b3',NULL,NULL,'1',10,NULL,'hr1',10,10,'Συγχωνεύσεις',NULL,'html',125,8,920,10,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<hr style=\"width: 100%; height: 0px; background-color:#b04b00; color:#b0b0b0;border: 1px solid;\">','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-11-18 13:11:08','globeadmin','2017-11-26 11:48:20','globeadmin','2020-04-02 12:49:35','globeadmin'),('5a10158c7d255b3','5a1011c80a896b3',NULL,NULL,'1',10,NULL,'hr2',20,10,'Συγχωνεύσεις',NULL,'html',265,8,920,10,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<hr style=\"width: 100%; height: 0px; background-color:#b04b00; color:#b0b0b0;border: 1px solid;\">','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-11-18 13:12:12','globeadmin','2017-11-26 11:48:38','globeadmin','2017-11-26 16:46:03','globeadmin'),('5a102994c571736','5a1011c80a896b3',NULL,NULL,'1',10,NULL,'class_id_1',30,10,'Συγχωνεύσεις','Τμήμα που θα παραμείνει : ','dropdown',29,137,250,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select class.id,concat(class.short_name,\' (\',count(student_class.new_id),\' μαθητές)\')\nfrom class\nleft join student_class on class.id=student_class.class_id\ngroup by class.short_name,class.id\n',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-11-18 14:37:40','globeadmin','2017-11-18 18:09:56','globeadmin','2017-11-26 16:46:03','globeadmin'),('5a102a177bd80ef','5a1011c80a896b3',NULL,NULL,'1',10,NULL,'class_id_2',40,10,'Συγχωνεύσεις','Τμήμα που θα συγχωνευτεί και θα διαγραφεί : ','dropdown',76,29,250,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select class.id,concat(class.short_name,\' (\',count(student_class.new_id),\' μαθητές)\')\nfrom class\nleft join student_class on class.id=student_class.class_id\ngroup by class.short_name,class.id\n',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-11-18 14:39:51','globeadmin','2017-11-18 18:10:07','globeadmin','2017-11-26 16:46:04','globeadmin'),('5a102b4aabe23b8','5a1011c80a896b3',NULL,NULL,'1',10,NULL,'merge_class_btn',50,10,'Συγχωνεύσεις','Συγχώνευση Τμημάτων','button',71,746,180,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-11-18 14:44:58','globeadmin','2017-11-26 11:46:45','globeadmin','2017-11-26 16:46:04','globeadmin'),('5a1054857850fd0','5a1011c80a896b3',NULL,NULL,'1',10,NULL,'subject_id_1',90,10,'Συγχωνεύσεις','Μάθημα που θα παραμείνει : ','dropdown',313,125,620,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select subject.id,concat(ifNULL(grade.short_name,\'\'),ifNULL(section.abbreviation,\'\'),if(section.abbreviation!=speciality.abbreviation,ifNULL(speciality.abbreviation,\'\'),\'\'),\' \',subject.name,if(subject_type.short_name is NULL,\'\',concat(\'-\',subject_type.short_name))) as full_name\nfrom subject\nleft join grade on subject.grade_id=grade.id\nleft join speciality on subject.speciality_id=speciality.id\nleft join section on speciality.section_id=section.id\nleft  join subject_type on subject.subject_type_id=subject_type.id\nwhere   subject.id>=10 \norder by full_name\n',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-11-18 17:40:53','globeadmin','2017-11-26 16:48:21','globeadmin','2017-11-26 16:48:21','globeadmin'),('5a1054c1587da5b','5a1011c80a896b3',NULL,NULL,'1',10,NULL,'teacher_id_2',70,10,'Συγχωνεύσεις','Καθηγητής που θα συγχωνευτεί και θα διαγραφεί : ','dropdown',209,3,300,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select  id,\n        concat(if(surname is null,\'\',concat(surname,\' \')), IFNULL(name,\'\')) as teacher_full_name\nfrom teacher\norder by teacher_full_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-11-18 17:41:53','globeadmin','2017-11-18 18:04:28','globeadmin','2017-11-26 16:46:04','globeadmin'),('5a1055892722cce','5a1011c80a896b3',NULL,NULL,'1',10,NULL,'teacher_id_1',60,10,'Συγχωνεύσεις','Καθηγητής που θα παραμείνει : ','dropdown',163,110,300,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select  id,\n        concat(if(surname is null,\'\',concat(surname,\' \')), IFNULL(name,\'\')) as teacher_full_name\nfrom teacher\norder by teacher_full_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-11-18 17:45:13','globeadmin','2017-11-18 18:04:14','globeadmin','2017-11-26 16:46:04','globeadmin'),('5a1055bfecb44a2','5a1011c80a896b3',NULL,NULL,'1',10,NULL,'subject_id_2',100,10,'Συγχωνεύσεις','Μάθημα που θα συγχωνευτεί και θα διαγραφεί : ','dropdown',365,18,620,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select subject.id,concat(ifNULL(grade.short_name,\'\'),ifNULL(section.abbreviation,\'\'),if(section.abbreviation!=speciality.abbreviation,ifNULL(speciality.abbreviation,\'\'),\'\'),\' \',subject.name,if(subject_type.short_name is NULL,\'\',concat(\'-\',subject_type.short_name))) as full_name\nfrom subject\nleft join grade on subject.grade_id=grade.id\nleft join speciality on subject.speciality_id=speciality.id\nleft join section on speciality.section_id=section.id\nleft  join subject_type on subject.subject_type_id=subject_type.id\nwhere   subject.id>=10 \norder by full_name\n',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-11-18 17:46:08','globeadmin','2017-11-26 16:48:36','globeadmin','2017-11-26 16:48:36','globeadmin'),('5a1056d4745b554','5a1011c80a896b3',NULL,NULL,'1',10,NULL,'merge_teacher_btn',80,10,'Συγχωνεύσεις','Συγχώνευση Καθηγητών','button',204,746,180,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-11-18 17:50:44','globeadmin','2017-11-26 11:47:01','globeadmin','2017-11-26 16:46:04','globeadmin'),('5a10571485593e0','5a1011c80a896b3',NULL,NULL,'1',10,NULL,'merge_subject_btn',110,10,'Συγχωνεύσεις','Συγχώνευση Μαθημάτων','button',410,746,180,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-11-18 17:51:48','globeadmin','2017-11-26 11:47:18','globeadmin','2020-09-27 18:27:00','globeadmin'),('5a12d90d654f080','59a96e2c710af4a',NULL,NULL,'1',10,NULL,'search_class_subject_id',10,20,'Εύρεση Ελεύθερων Ημερομηνιών','Για το τμήμα - μάθημα :','dropdown',54,13,450,40,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'SELECT distinct CONCAT(class.id,\',\',subject.id), CONCAT(class.short_name,\' - \',subject.name,if (subject_type.short_name is NULL,\'\',concat(\' (\',subject_type.short_name,\')\')))\nFROM card\nINNER JOIN subject 			on card.subject_id = subject.id \nINNER JOIN teacher 			on card.teacher_id = teacher.id  \nINNER JOIN class 			on card.class_id = class.id	\nLEFT  JOIN subject_type 	on subject.subject_type_id = subject_type.id  \nWHERE \n	card.valid_from = (SELECT max(timetable.start_date) FROM timetable) AND\n	teacher_id=\'#RECORD_ID#\'\nORDER BY class.short_name,subject.name,subject_type.name DESC',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-11-20 15:30:53','globeadmin','2017-11-20 20:15:07','globeadmin','2020-09-18 19:10:31','globeadmin'),('5a12d9d716b84f0','59a96e2c710af4a',NULL,NULL,'1',10,NULL,'search_date',20,20,'Εύρεση Ελεύθερων Ημερομηνιών','Θέλω να προγραμματίσω το διαγώνισμα μου μέχρι τις :','text',17,11,80,40,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'SELECT distinct CONCAT(class.id,\',\',subject.id), CONCAT(class.short_name,\' - \',subject.name,if (subject_type.name is NULL,\'\',concat(\' (\',subject_type.name,\')\')))\nFROM card\nINNER JOIN subject 			on card.subject_id = subject.id \nINNER JOIN teacher 			on card.teacher_id = teacher.id  \nINNER JOIN class 			on card.class_id = class.id	\nLEFT  JOIN subject_type 	on subject.subject_type_id = subject_type.id  \nWHERE \n	card.valid_from = (SELECT max(timetable.start_date) FROM timetable) AND\n	teacher_id=\'#RECORD_ID#\'\nORDER BY class.short_name,subject.name,subject_type.name DESC',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2017-11-20 15:34:15','globeadmin','2017-11-20 16:27:15','globeadmin','2020-09-18 19:10:31','globeadmin'),('5a12e47b05d08f4','59a96e2c710af4a',NULL,NULL,'1',10,NULL,'search_btn',30,20,'Εύρεση Ελεύθερων Ημερομηνιών','Εύρεση Ημερομηνιών','button',91,417,180,35,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-11-20 16:19:39','globeadmin','2017-11-20 20:16:48','globeadmin','2020-09-18 19:10:31','globeadmin'),('5a12e5a102dbe1a','59a96e2c710af4a',NULL,NULL,'1',10,NULL,'search_iframe',40,20,'Εύρεση Ελεύθερων Ημερομηνιών',NULL,'iframe',89,29,350,250,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-11-20 16:24:33','globeadmin','2017-11-20 20:13:13','globeadmin','2020-09-18 19:10:31','globeadmin'),('5a19392706f9582','5a193801b52abb9',NULL,NULL,'1',10,NULL,'card_date',10,10,'Αναίρεση Καταχώρισης','Ημερομηνία :','text',26,27,80,30,'r','0','0','select curdate()','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2017-11-25 11:34:31','globeadmin','2017-11-25 11:34:31','globeadmin','2018-12-03 16:17:39','globeadmin'),('5a1939e28cbd630','5a193801b52abb9',NULL,NULL,'1',10,NULL,'class_id',20,10,'Αναίρεση Καταχώρισης','Τμήμα :','dropdown',28,213,120,30,'r','0','0','select curdate()','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name \nfrom class \nwhere 1\norder by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-11-25 11:37:38','globeadmin','2017-11-25 11:37:38','globeadmin','2018-12-03 16:17:39','globeadmin'),('5a193a412109ff2','5a193801b52abb9',NULL,NULL,'1',10,NULL,'period_id',30,10,'Αναίρεση Καταχώρισης','Ώρα :','dropdown',28,409,80,30,'r','0','0','select curdate()','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name \nfrom period \nwhere 1\norder by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-11-25 11:39:13','globeadmin','2017-11-25 11:39:13','globeadmin','2018-12-03 16:17:39','globeadmin'),('5a193ad13438b95','5a193801b52abb9',NULL,NULL,'1',10,NULL,'find_btn',40,10,'Αναίρεση Καταχώρισης','Εύρεση','button',22,558,120,35,'r','0','0','select curdate()','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-11-25 11:41:37','globeadmin','2017-11-25 11:41:58','globeadmin','2018-12-03 16:17:39','globeadmin'),('5a193b4564bb6b6','5a193801b52abb9',NULL,NULL,'1',10,NULL,'clear_btn',50,10,'Αναίρεση Καταχώρισης','Εκκαθάριση Καταχωρίσεων','button',22,728,180,35,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-11-25 11:43:33','globeadmin','2017-11-25 20:24:44','globeadmin','2018-12-03 16:17:39','globeadmin'),('5a193c11298ed72','5a193801b52abb9',NULL,NULL,'1',10,NULL,'search_iframe',60,10,'Αναίρεση Καταχώρισης',NULL,'iframe',82,20,900,450,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-11-25 11:46:57','globeadmin','2017-11-25 20:21:49','globeadmin','2018-12-03 16:17:39','globeadmin'),('5a282e213da5f6a','5a28402a618a46f',NULL,NULL,'1',10,NULL,'check_iframe',20,10,'Έλεγχος Διαγωνισμάτων',NULL,'iframe',41,8,660,400,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'5a28162b9f2ddc4','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-12-06 19:51:29','globeadmin','2017-12-09 10:31:02','globeadmin','2017-12-09 20:16:36','globeadmin'),('5a2b9f0c29efd76','5a28402a618a46f',NULL,NULL,'1',10,NULL,'inform_check',10,10,'Έλεγχος Διαγωνισμάτων','Ενημέρωση Συμμετεχόντων κατά τη Διαγραφή :','checkbox',12,335,40,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-12-09 10:30:04','globeadmin','2017-12-09 10:34:14','globeadmin','2017-12-09 20:16:36','globeadmin'),('5a36a2c10d0a6c3','5627e58b8ed5f6d',NULL,NULL,'1',10,'select \'0\'','critiria_subject_count',30,20,'Κριτήρια Αξιολόγησης','Αριθμός : ','display',0,0,40,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','SELECT count(*)\nFROM mark_critirion_special_level\nWHERE mark_id=\'#RECORD_ID#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2017-12-17 19:00:49','globeadmin','2017-12-17 19:00:49','globeadmin','2018-07-23 09:37:25','globeadmin'),('5a36b5bc3760e7f','5a36abffedf9461',NULL,NULL,'1',10,NULL,'progress_iframe',20,10,'Ενημέρωση Συστήματος',NULL,'iframe',54,17,950,70,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'5a36b672b84479b','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-12-17 20:21:48','globeadmin','2017-12-31 16:17:22','globeadmin','2018-01-09 18:45:12','globeadmin'),('5a36c5b6ed5ebe4','5a36abffedf9461',NULL,NULL,'1',10,NULL,'system_version_dsp',10,10,'Ενημέρωση Συστήματος','Τρέχουσα Έκδοση Συστήματος :','display',20,49,80,40,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select version\nfrom school\nwhere id=1',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-12-17 21:29:59','globeadmin','2017-12-29 15:13:46','globeadmin','2018-01-09 18:45:12','globeadmin'),('5a3c1a8dba3c1eb','5a36abffedf9461',NULL,NULL,'1',10,NULL,'msg_iframe',30,10,'Ενημέρωση Συστήματος',NULL,'iframe',137,17,950,400,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'5a3c17afa650e8f','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-12-21 22:33:17','globeadmin','2017-12-22 19:22:36','globeadmin','2018-01-09 18:45:12','globeadmin'),('5a3d58b25ca317d','5a36abffedf9461',NULL,NULL,'1',10,NULL,'hidden_iframe',40,10,'Ενημέρωση Συστήματος',NULL,'iframe',10,917,50,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2017-12-22 21:10:42','globeadmin','2017-12-22 21:11:30','globeadmin','2018-01-09 18:45:12','globeadmin'),('5a4d1868152d601','554517bdc18334d',NULL,NULL,'1',10,NULL,'modified_from',150,10,'Λεπτομέρειες','Τροποποιήθηκε από :','display',602,376,250,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select concat(if(surname is null,\'\',concat(surname,\' \')), IFNULL(name,\'\'))\nfrom teacher\nwhere id=\'#modifier_teacher_id#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2018-01-03 19:52:40','globeadmin','2018-01-03 20:03:01','globeadmin','2022-01-07 21:47:53','globeadmin'),('5a4d131b6c20954','554517bdc18334d',NULL,NULL,'1',10,NULL,'modified_at',140,10,'Λεπτομέρειες','Ημερομηνία Τροποποίησης :','display',602,11,150,0,'r','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select if(modified_at is NULL,\'\',DATE_FORMAT(modified_at,\'%d-%m-%Y %T\'))\nfrom penalty\nwhere id=\'#RECORD_ID#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2018-01-03 19:30:03','globeadmin','2018-01-03 19:30:03','globeadmin','2022-01-07 21:47:53','globeadmin'),('5a4d0bf878bcb5f','554517bdc18334d',NULL,NULL,'1',10,NULL,'apology',120,10,'Λεπτομέρειες','Απολογία Μαθητή :','textarea',395,66,700,150,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2018-01-03 18:59:36','globeadmin','2018-01-03 19:01:50','globeadmin','2022-01-07 21:47:53','globeadmin'),('5a4d0ebca9fab4b','554517bdc18334d',NULL,NULL,'1',10,'select if(  \'#nu_user_group#\'=\'globeadmin\' or \n            \'#nu_user_group#\'=\'Administrators\' or \n            \'#nu_user_group#\'=\'Managers\' or \n            \'#nu_user_group#\'=\'AssistManagers\' or\n            \'#RECORD_ID#\'<>\'-1\',\'1\',\'0\')','after_referral',130,10,'Λεπτομέρειες','Μετά από Παραπομπή :','checkbox',144,548,20,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2018-01-03 19:11:24','globeadmin','2018-01-04 19:11:17','globeadmin','2022-01-07 21:47:53','globeadmin'),('5a4d1c8236ea959','554517bdc18334d',NULL,NULL,'1',10,NULL,'label1',160,10,'Λεπτομέρειες','* Απαιτείται','words',631,22,150,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2018-01-03 20:10:10','globeadmin','2018-01-03 20:10:10','globeadmin','2022-01-07 21:47:53','globeadmin'),('5a4e32f56b6fd5b','5a4e32f55d7faf5',NULL,NULL,'1',10,NULL,'name',10,10,'Λεπτομέρειες','Όνομα :','text',42,119,600,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2018-07-28 11:39:30','globeadmin','2019-11-03 18:26:10','globeadmin'),('5a4e32f572bb28c','5a4e32f55d7faf5',NULL,NULL,'1',10,NULL,'on_absence_table',20,10,'Λεπτομέρειες','Επιβολή από το Απουσιολόγιο :','checkbox',99,126,100,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2018-01-04 16:03:59','globeadmin','2019-11-03 18:26:10','globeadmin'),('5a4e32f57a0f1b1','5a4e32f55d7faf5',NULL,NULL,'1',10,NULL,'teacher_access',30,10,'Λεπτομέρειες','Επιβολή από όλους τους Καθηγητές :','checkbox',214,93,100,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2018-01-04 16:03:59','globeadmin','2019-11-03 18:26:10','globeadmin'),('5a566f118baf762','5a4e32f55d7faf5',NULL,NULL,'1',10,NULL,'all_day',60,10,'Λεπτομέρειες','Ολοήμερη Ποινή :','checkbox',272,206,40,40,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2018-01-10 21:52:49','globeadmin','2018-01-10 22:09:28','globeadmin','2019-11-03 18:26:10','globeadmin'),('5a4e3c627f000e1','5a4e32f55d7faf5',NULL,NULL,'1',10,NULL,'on_form',40,10,'Λεπτομέρειες','Επιβολή από τη Φόρμα Ποινών :','checkbox',157,119,100,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2018-01-04 16:38:26','globeadmin','2018-01-04 16:38:26','globeadmin','2019-11-03 18:26:10','globeadmin'),('5a4e7396a0d52d7','554517bdc18334d',NULL,NULL,'1',10,NULL,'vertical_line',10,20,'Ενημέρωση Μαθητή/Γονέα',NULL,'html',27,465,5,610,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table style=\"width: 0px; height: 100%; border-color::#b04b00;border-right-width: 1px; border-style: solid;\" border=0>\n<tr>\n<td>\n</td>\n</tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2018-01-04 20:33:58','globeadmin','2018-01-04 20:40:50','globeadmin','2022-01-07 21:47:53','globeadmin'),('5a4e7445105de75','554517bdc18334d',NULL,NULL,'1',10,NULL,'label_parent',20,20,'Ενημέρωση Μαθητή/Γονέα','Στοιχεία Επικοινωνίας Γονέα','words',37,525,300,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2018-01-04 20:36:53','globeadmin','2018-01-04 20:39:57','globeadmin','2022-01-07 21:47:53','globeadmin'),('5a4e7463ee66a02','554517bdc18334d',NULL,NULL,'1',10,NULL,'label_student',30,20,'Ενημέρωση Μαθητή/Γονέα','Στοιχεία Επικοινωνίας Μαθητή','words',37,40,300,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2018-01-04 20:37:24','globeadmin','2018-01-04 20:39:37','globeadmin','2022-01-07 21:47:53','globeadmin'),('5a4e75e37d13a70','554517bdc18334d',NULL,NULL,'1',10,NULL,'phone1',40,20,'Ενημέρωση Μαθητή/Γονέα','Τηλέφωνο 1 :','display',110,26,200,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select student.phone1\nfrom student\ninner join penalty on penalty.student_id = student.id\nwhere penalty.id = \'#RECORD_ID#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2018-01-04 20:43:47','globeadmin','2018-01-04 22:31:51','globeadmin','2022-01-07 21:47:54','globeadmin'),('5a4e76553d54060','554517bdc18334d',NULL,NULL,'1',10,NULL,'phone2',50,20,'Ενημέρωση Μαθητή/Γονέα','Τηλέφωνο 2 :','display',162,26,200,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select student.phone2\nfrom student\ninner join penalty on penalty.student_id = student.id\nwhere penalty.id = \'#RECORD_ID#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2018-01-04 20:45:41','globeadmin','2018-01-04 22:48:07','globeadmin','2022-01-07 21:47:54','globeadmin'),('5a4e768ec5d25b6','554517bdc18334d',NULL,NULL,'1',10,NULL,'mobile',60,20,'Ενημέρωση Μαθητή/Γονέα','Κινητό :','display',214,58,200,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select student.mobile\nfrom student\ninner join penalty on penalty.student_id = student.id\nwhere penalty.id = \'#RECORD_ID#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2018-01-04 20:46:38','globeadmin','2018-01-04 22:48:08','globeadmin','2022-01-07 21:47:54','globeadmin'),('5a4e7705c31b726','554517bdc18334d',NULL,NULL,'1',10,NULL,'parent_phone1',80,20,'Ενημέρωση Μαθητή/Γονέα','Τηλέφωνο 1 :','display',110,505,200,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select student.parent_phone1\nfrom student\ninner join penalty on penalty.student_id = student.id\nwhere penalty.id = \'#RECORD_ID#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2018-01-04 20:48:37','globeadmin','2018-01-04 22:48:07','globeadmin','2022-01-07 21:47:54','globeadmin'),('5a4e771ceef77e9','554517bdc18334d',NULL,NULL,'1',10,NULL,'parent_phone2',90,20,'Ενημέρωση Μαθητή/Γονέα','Τηλέφωνο 2 :','display',162,505,200,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select student.parent_phone2\nfrom student\ninner join penalty on penalty.student_id = student.id\nwhere penalty.id = \'#RECORD_ID#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2018-01-04 20:49:01','globeadmin','2018-01-04 22:48:07','globeadmin','2022-01-07 21:47:54','globeadmin'),('5a4e7731132ab28','554517bdc18334d',NULL,NULL,'1',10,NULL,'parent_phone3',100,20,'Ενημέρωση Μαθητή/Γονέα','Τηλέφωνο 3 :','display',214,505,200,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select student.parent_phone3\nfrom student\ninner join penalty on penalty.student_id = student.id\nwhere penalty.id = \'#RECORD_ID#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2018-01-04 20:49:21','globeadmin','2018-01-04 22:48:07','globeadmin','2022-01-07 21:47:54','globeadmin'),('5a4e77d51525d8d','554517bdc18334d',NULL,NULL,'1',10,NULL,'email',70,20,'Ενημέρωση Μαθητή/Γονέα','Email :','display',293,64,300,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select student.email\nfrom student\ninner join penalty on penalty.student_id = student.id\nwhere penalty.id = \'#RECORD_ID#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2018-01-04 20:52:05','globeadmin','2018-01-04 22:48:07','globeadmin','2022-01-07 21:47:54','globeadmin'),('5a4e7813633350e','554517bdc18334d',NULL,NULL,'1',10,NULL,'parent_email',110,20,'Ενημέρωση Μαθητή/Γονέα','Email :','display',293,543,300,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select student.parent_email\nfrom student\ninner join penalty on penalty.student_id = student.id\nwhere penalty.id = \'#RECORD_ID#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2018-01-04 20:53:07','globeadmin','2018-01-04 22:48:49','globeadmin','2022-01-07 21:47:54','globeadmin'),('5a4e8a79dbdc9cf','554517bdc18334d',NULL,NULL,'0',10,'select if(student.phone1 IS NOT NULL and student.phone1 <> \'\' and  sms_gateway.id IS NOT NULL,\'1\',\'0\')\nfrom student\ninner join penalty on penalty.student_id = student.id\nleft join sms_gateway ON sms_gateway.active=1\nwhere \n    penalty.id = \'#RECORD_ID#\'','phone1_img_send',120,20,'Ενημέρωση Μαθητή/Γονέα',NULL,'html',101,317,34,31,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"this.style.cursor=\'pointer\';\"\n                            onmouseout=\"this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=30 height=30 id=\'img_modify11\' src=\'images/sms_icon.png\' title=\'Αποστολή SMS\'/>\n        </td>\n    </tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-01-04 22:11:37','globeadmin','2018-01-04 22:48:49','globeadmin','2022-01-07 21:47:54','globeadmin'),('5a4e919daa99f5f','554517bdc18334d',NULL,NULL,'0',10,'select if(student.email IS NOT NULL and trim(student.email) <> \'\',\'1\',\'0\')\nfrom student\ninner join penalty on penalty.student_id = student.id\nwhere \n    penalty.id = \'#RECORD_ID#\'','send_email_student_img',180,20,'Ενημέρωση Μαθητή/Γονέα',NULL,'html',286,417,34,31,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"this.style.cursor=\'pointer\';\"\n                            onmouseout=\"this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=30 height=30 id=\'img_email_student_send1\' src=\'images/email.png\' title=\'Αποστολή Email\'/>\n        </td>\n    </tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-01-04 22:42:05','globeadmin','2018-01-15 20:08:46','globeadmin','2022-01-07 21:47:54','globeadmin'),('5a4e9240b1769bf','554517bdc18334d',NULL,NULL,'0',10,'select if(student.parent_email IS NOT NULL and trim(student.parent_email) <> \'\',\'1\',\'0\')\nfrom student\ninner join penalty on penalty.student_id = student.id\nwhere \n    penalty.id = \'#RECORD_ID#\'','send_email_parent_img',190,20,'Ενημέρωση Μαθητή/Γονέα',NULL,'html',286,896,34,31,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"this.style.cursor=\'pointer\';\"\n                            onmouseout=\"this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=30 height=30 id=\'img_email_student_send1\' src=\'images/email.png\' title=\'Αποστολή Email\'/>\n        </td>\n    </tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-01-04 22:44:48','globeadmin','2018-01-15 20:08:14','globeadmin','2022-01-07 21:47:54','globeadmin'),('5a4e940f29cdaaf','554517bdc18334d',NULL,NULL,'0',10,'select if(student.phone2 IS NOT NULL and student.phone2 <> \'\' and  sms_gateway.id IS NOT NULL,\'1\',\'0\')\nfrom student\ninner join penalty on penalty.student_id = student.id\nleft join sms_gateway ON sms_gateway.active=1\nwhere \n    penalty.id = \'#RECORD_ID#\'','phone2_img_send',130,20,'Ενημέρωση Μαθητή/Γονέα',NULL,'html',153,317,34,31,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"this.style.cursor=\'pointer\';\"\n                            onmouseout=\"this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=30 height=30 id=\'img_modify11\' src=\'images/sms_icon.png\' title=\'Αποστολή SMS\'/>\n        </td>\n    </tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-01-04 22:52:31','globeadmin','2018-01-04 22:52:31','globeadmin','2022-01-07 21:47:54','globeadmin'),('5a4e9452dbd9725','554517bdc18334d',NULL,NULL,'0',10,'select if(student.mobile IS NOT NULL and student.mobile <> \'\' and  sms_gateway.id IS NOT NULL,\'1\',\'0\')\nfrom student\ninner join penalty on penalty.student_id = student.id\nleft join sms_gateway ON sms_gateway.active=1\nwhere \n    penalty.id = \'#RECORD_ID#\'','mobile_img_send',140,20,'Ενημέρωση Μαθητή/Γονέα',NULL,'html',205,317,34,31,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"this.style.cursor=\'pointer\';\"\n                            onmouseout=\"this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=30 height=30 id=\'img_modify11\' src=\'images/sms_icon.png\' title=\'Αποστολή SMS\'/>\n        </td>\n    </tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-01-04 22:53:39','globeadmin','2018-01-04 22:53:39','globeadmin','2022-01-07 21:47:54','globeadmin'),('5a4e94b03326875','554517bdc18334d',NULL,NULL,'0',10,'select if(student.parent_phone1 IS NOT NULL and student.parent_phone1 <> \'\' and  sms_gateway.id IS NOT NULL,\'1\',\'0\')\nfrom student\ninner join penalty on penalty.student_id = student.id\nleft join sms_gateway ON sms_gateway.active=1\nwhere \n    penalty.id = \'#RECORD_ID#\'','parent_phone1_img_send',150,20,'Ενημέρωση Μαθητή/Γονέα',NULL,'html',101,798,34,31,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"this.style.cursor=\'pointer\';\"\n                            onmouseout=\"this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=30 height=30 id=\'img_modify11\' src=\'images/sms_icon.png\' title=\'Αποστολή SMS\'/>\n        </td>\n    </tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-01-04 22:55:12','globeadmin','2018-01-04 22:55:12','globeadmin','2022-01-07 21:47:54','globeadmin'),('5a4e94e6970f78a','554517bdc18334d',NULL,NULL,'0',10,'select if(student.parent_phone2 IS NOT NULL and student.parent_phone2 <> \'\' and  sms_gateway.id IS NOT NULL,\'1\',\'0\')\nfrom student\ninner join penalty on penalty.student_id = student.id\nleft join sms_gateway ON sms_gateway.active=1\nwhere \n    penalty.id = \'#RECORD_ID#\'','parent_phone2_img_send',160,20,'Ενημέρωση Μαθητή/Γονέα',NULL,'html',153,798,34,31,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"this.style.cursor=\'pointer\';\"\n                            onmouseout=\"this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=30 height=30 id=\'img_modify11\' src=\'images/sms_icon.png\' title=\'Αποστολή SMS\'/>\n        </td>\n    </tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-01-04 22:56:06','globeadmin','2018-01-04 22:56:06','globeadmin','2022-01-07 21:47:54','globeadmin'),('5a4e951a884cf7f','554517bdc18334d',NULL,NULL,'0',10,'select if(student.parent_phone3 IS NOT NULL and student.parent_phone3 <> \'\' and  sms_gateway.id IS NOT NULL,\'1\',\'0\')\nfrom student\ninner join penalty on penalty.student_id = student.id\nleft join sms_gateway ON sms_gateway.active=1\nwhere \n    penalty.id = \'#RECORD_ID#\'','parent_phone3_img_send',170,20,'Ενημέρωση Μαθητή/Γονέα',NULL,'html',205,798,34,31,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"this.style.cursor=\'pointer\';\"\n                            onmouseout=\"this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=30 height=30 id=\'img_modify11\' src=\'images/sms_icon.png\' title=\'Αποστολή SMS\'/>\n        </td>\n    </tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-01-04 22:56:58','globeadmin','2018-01-04 22:56:58','globeadmin','2022-01-07 21:47:54','globeadmin'),('5a4f5386ea563e7','580cdf151b06780',NULL,NULL,'1',10,NULL,'exportbtn',110,10,'Αναζήτηση','Εξαγωγή στο Excel','button',126,780,150,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from teacher order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-01-05 12:29:27','globeadmin','2018-01-05 12:30:47','globeadmin','2021-10-24 21:35:23','globeadmin'),('5a4f5615bd9c134','580cdf151b06780',NULL,NULL,'1',10,'select \'0\'','hidden_iframe',150,10,'Αναζήτηση',NULL,'iframe',10,950,20,20,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-01-05 12:40:21','globeadmin','2018-07-13 19:48:22','globeadmin','2021-10-24 21:35:23','globeadmin'),('5a60761766e63e9','56eae5254137ba7',NULL,NULL,'1',10,NULL,'add_mass_btn',40,10,'Λίστα Μαθητών','Μαζική Προσθήκη','button',23,776,160,35,'l','0','0','','0',NULL,NULL,'#RECORD_ID#','5a607704e048c15',NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2018-01-18 12:25:27','globeadmin','2018-01-18 12:29:56','globeadmin','2019-03-09 10:39:15','globeadmin'),('5a508fdf9f445e0','54a4107cddefff1',NULL,NULL,'1',10,'select \'0\'','email_text',60,10,'Αποστολή Email',NULL,'text',23,753,40,40,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-01-06 10:59:11','globeadmin','2018-01-06 10:59:59','globeadmin','2021-03-24 11:17:19','globeadmin'),('5a5240fc275f443','580cdf151b06780',NULL,NULL,'1',10,NULL,'printbtn',120,10,'Αναζήτηση','Εκτύπωση','button',126,588,150,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-01-07 17:47:08','globeadmin','2018-01-07 17:47:08','globeadmin','2021-10-24 21:47:16','globeadmin'),('5a52720bade5ef3','580cdf151b06780',NULL,NULL,'1',10,'select \'0\'','start_date',130,10,'Αναζήτηση','Αρχή Μαθημάτων : ','display',13,783,80,30,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select DATE_FORMAT(school_year.start_date,\'%d-%m-%Y\')\nfrom school\ninner join school_year on school_year.id = school.school_year_id\nwhere school.id=1',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-01-07 21:16:27','globeadmin','2018-01-07 21:17:16','globeadmin','2021-10-24 21:48:11','globeadmin'),('5a54bedf84ac6e4','56192b05ed5032f',NULL,NULL,'0',10,'select if(  \'#nu_user_group#\'=\'globeadmin\' or \n            \'#nu_user_group#\'=\'Administrators\' or \n            \'#nu_user_group#\'=\'Managers\',\'1\',\'0\')','penalty_typebtn',20,30,'Παράμετροι',NULL,'html',50,380,220,100,'l','0','0','','0',NULL,NULL,'1','54a52c3dcf3610b',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'cards_config_id\').src=\'images/cards_configb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'cards_config_id\').src=\'images/cards_config.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'cards_config_id\' src=\'images/cards_config.png\' title=\'Τύποι Ποινών\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Τύποι Ποινών</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-01-09 15:08:47','globeadmin','2018-01-09 18:15:44','globeadmin','2019-07-25 10:13:35','globeadmin');
INSERT INTO `zzzsys_object` VALUES ('5a54bf380cc7513','56192b05ed5032f',NULL,NULL,'0',10,'select if(  \'#nu_user_group#\'=\'globeadmin\' or \n            \'#nu_user_group#\'=\'Administrators\' or \n            \'#nu_user_group#\'=\'Managers\',\'1\',\'0\')','general_parametersbtn',10,30,'Παράμετροι',NULL,'html',50,73,220,100,'l','0','0','','0',NULL,NULL,'1','54a52c3dcf3610b',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'sliders_id\').src=\'images/slidersb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'sliders_id\').src=\'images/sliders.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'sliders_id\' src=\'images/sliders.png\' title=\'Γενικές Παράμετροι Σχολείου\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Γενικές Παράμετροι Σχολείου</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-01-09 15:10:16','globeadmin','2018-01-09 20:55:18','globeadmin','2019-07-25 10:13:35','globeadmin'),('5a54e28f59749d3','56192b05ed5032f',NULL,NULL,'0',10,'select if(  \'#nu_user_group#\'=\'globeadmin\' or \n            \'#nu_user_group#\'=\'Administrators\' or \n            \'#nu_user_group#\'=\'Managers\',\'1\',\'0\')','updatebtn',80,20,'Σύστημα',NULL,'html',330,380,220,100,'l','0','0','','0',NULL,NULL,'1','54a52c3dcf3610b',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'update_id\').src=\'images/updateb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'update_id\').src=\'images/update.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'update_id\' src=\'images/update.png\' title=\'Ενημέρωση Συστήματος\'/>\n            <img style=\"position: absolute;top: 1px;left: 150px;display: none;\" width=20 height=20 id=\'info_id\' src=\'images/info-sign.png\' title=\'Νέα έκδοση διαθέσιμη\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Ενημέρωση Συστήματος (ΥΚ)</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-01-09 17:41:03','globeadmin','2018-02-04 20:28:58','globeadmin','2019-07-25 10:13:35','globeadmin'),('5a54f3fd829beb0','56192b05ed5032f',NULL,NULL,'0',10,'select \'0\'','hidden_iframe',100,20,'Σύστημα',NULL,'iframe',10,960,20,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_deleteall_id\').src=\'images/deleteallb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_deleteall_id\').src=\'images/deleteall.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=98 height=74 id=\'img_deleteall_id\' src=\'images/deleteall.png\' title=\'Διαγραφή όλων των στοιχείων για την έναρξη νέου Σχ. Έτους\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Διαγραφή Όλων</span>\n        </td>\n    </tr>\n    \n</table>','54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-01-09 18:55:25','globeadmin','2018-02-04 20:27:15','globeadmin','2019-07-25 10:13:35','globeadmin'),('5a5619d54635f06','5a4e32f55d7faf5',NULL,NULL,'1',10,NULL,'absence_reason_id',50,10,'Λεπτομέρειες','Συνδεδεμένος Τύπος Απουσίας :','dropdown',329,120,200,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'SELECT id,name\nFROM  absence_reason\norder by id\n',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2018-01-10 15:49:09','globeadmin','2018-01-10 15:49:38','globeadmin','2019-11-03 18:26:10','globeadmin'),('5a5745a3d496331','554517bdc18334d',NULL,NULL,'1',10,'select \'0\'','type_all_day',170,10,'Λεπτομέρειες',NULL,'dropdown',20,850,40,0,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'SELECT name,all_day\nFROM penalty_type\norder by all_day desc',NULL,'','',NULL,NULL,NULL,'#nuSepEditnuSepr#varchar',NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2018-01-11 13:08:19','globeadmin','2018-01-11 13:09:58','globeadmin','2022-01-07 21:47:53','globeadmin'),('5a6077c30670140','5a607704e048c15',NULL,NULL,'1',10,NULL,'comments_iframe',50,10,'Λίστα Μαθητών',NULL,'iframe',450,18,940,835,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'5a60719e03a40ca','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2018-01-18 12:32:35','globeadmin','2019-07-06 23:47:26','globeadmin','2019-07-08 13:11:23','globeadmin'),('5a607b0308fbef2','5a607704e048c15',NULL,NULL,'1',10,NULL,'comment_label',30,10,'Λίστα Μαθητών','Κοινό Σχόλιο για Όλους :','words',51,25,400,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-01-18 12:46:27','globeadmin','2019-07-07 00:04:12','globeadmin','2019-07-08 13:11:23','globeadmin'),('5a607b751c31b11','5a607704e048c15',NULL,NULL,'1',10,NULL,'teacher_chk',10,10,'Λίστα Μαθητών','Για τον Καθηγητή :','checkbox',11,49,40,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-01-18 12:48:21','globeadmin','2018-01-18 17:16:10','globeadmin','2019-07-08 13:11:23','globeadmin'),('5a607ba3da7e2e4','5a607704e048c15',NULL,NULL,'1',10,NULL,'student_chk',20,10,'Λίστα Μαθητών','Για τον Μαθητή/Γονέα :','checkbox',11,206,40,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-01-18 12:49:07','globeadmin','2018-01-18 17:16:27','globeadmin','2019-07-08 13:11:23','globeadmin'),('5a72e29570a3e24','548338073921bfe',NULL,NULL,'0',10,NULL,'penaltybtn',60,10,'Προσωπικές Εργασίες',NULL,'html',334,73,220,100,'l','0','0','','0',NULL,NULL,NULL,'554517bdc18334d',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_cards_id\').src=\'images/cardsb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_cards_id\').src=\'images/cards.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_cards_id\' src=\'images/cards.png\' title=\'Ποινές που έχουν επιβληθεί σε μαθητές\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Ποινές Μαθητών</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-02-01 11:49:09','globeadmin','2022-01-13 09:25:20','globeadmin','2022-01-13 09:25:20','globeadmin'),('5a75b90f3217e84','552cf4b2df9bcce',NULL,NULL,'1',10,'select \'0\'','email_default_text',170,10,'Ενημέρωση για τις Απουσίες','Κείμενο email : ','display',65,950,80,30,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select email_absence_text from school where id = 1',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-02-03 15:28:47','globeadmin','2018-06-28 20:59:03','globeadmin','2021-09-07 20:55:38','globeadmin'),('5a75b96f761830e','552cf4b2df9bcce',NULL,NULL,'1',10,'select \'0\'','sms_default_text',150,10,'Ενημέρωση για τις Απουσίες','Κείμενο SMS : ','display',65,940,80,30,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select sms_absence_text from school where id = 1',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-02-03 15:30:23','globeadmin','2018-06-28 21:36:16','globeadmin','2021-09-07 20:55:38','globeadmin'),('5a75c16f6d7fd11','552cf4b2df9bcce',NULL,NULL,'1',10,'select \'0\'','school_short_name',180,10,'Ενημέρωση για τις Απουσίες','Συντομογραφία Σχολείου : ','display',65,922,80,30,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select short_name from school where id = 1',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-02-03 16:04:31','globeadmin','2018-02-03 16:05:09','globeadmin','2021-09-07 20:55:38','globeadmin'),('5a761ac52333912','5a54c08c836c142',NULL,NULL,'1',10,NULL,'email_absence_text',10,20,'EMAIL Κείμενο Απουσιών',NULL,'textarea',131,14,900,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2018-02-03 22:25:41','globeadmin','2018-02-03 23:21:16','globeadmin','2022-09-24 23:21:53','globeadmin'),('5a761f3d8fe83d2','5a54c08c836c142',NULL,NULL,'1',10,NULL,'sms_label1',20,30,'SMS Κείμενο Απουσιών','Το παρακάτω κείμενο χρησιμοποιείται κατά την μαζική αποστολή SMS προς τους Γονείς για τις απουσίες. Τα παρακάτω πεδία αντικαθίστανται ως εξής :','words',27,16,910,40,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2018-02-03 22:44:45','globeadmin','2018-02-04 10:28:04','globeadmin','2022-09-24 23:21:53','globeadmin'),('5a76205567f6df0','5a54c08c836c142',NULL,NULL,'1',10,NULL,'sms_label2',30,30,'SMS Κείμενο Απουσιών','-student- =>Ονοματεπώνυμο Μαθητή, -date- =>Ημερομηνία υπολογισμού απουσιών','words',55,16,900,40,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2018-02-03 22:49:25','globeadmin','2018-02-03 23:22:02','globeadmin','2022-09-24 23:21:53','globeadmin'),('5a76245ecdfe671','5a54c08c836c142',NULL,NULL,'1',10,NULL,'email_label1',30,20,'EMAIL Κείμενο Απουσιών','Το παρακάτω κείμενο χρησιμοποιείται κατά την μαζική αποστολή EMAIL προς τους Γονείς για τις απουσίες. Τα παρακάτω αντικαθίστανται ως εξής :','words',27,16,900,40,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2018-02-03 23:06:38','globeadmin','2018-02-03 23:21:16','globeadmin','2022-09-24 23:21:53','globeadmin'),('5a762202d496063','5a54c08c836c142',NULL,NULL,'1',10,NULL,'sms_label3',40,30,'SMS Κείμενο Απουσιών','-total- =>Σύνολο απουσιών, -unjustified- =>Αδικαιολόγητες απουσίες, -justified- =>Δικαιολογημένες απουσίες','words',83,16,900,40,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2018-02-03 22:56:34','globeadmin','2018-02-03 23:22:02','globeadmin','2022-09-24 23:21:54','globeadmin'),('5a7624ba86f12a8','5a54c08c836c142',NULL,NULL,'1',10,NULL,'email_label2',40,20,'EMAIL Κείμενο Απουσιών','-student- =>Ονοματεπώνυμο Μαθητή, -date- =>Ημερομηνία υπολογισμού απουσιών','words',55,16,900,40,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2018-02-03 23:08:10','globeadmin','2018-02-03 23:21:16','globeadmin','2022-09-24 23:21:53','globeadmin'),('5a7624ea845e5e3','5a54c08c836c142',NULL,NULL,'1',10,NULL,'email_label3',50,20,'EMAIL Κείμενο Απουσιών','-total- =>Σύνολο απουσιών, -unjustified- =>Αδικαιολόγητες απουσίες, -justified- =>Δικαιολογημένες απουσίες','words',83,16,900,40,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2018-02-03 23:08:58','globeadmin','2018-02-03 23:21:16','globeadmin','2022-09-24 23:21:53','globeadmin'),('5a76258b1fe0f45','5a54c08c836c142',NULL,NULL,'1',10,NULL,'email_tinymce',20,20,'EMAIL Κείμενο Απουσιών',NULL,'iframe',108,17,900,380,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'56cc9f04b82528e','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2018-02-03 23:11:39','globeadmin','2018-02-03 23:21:16','globeadmin','2022-09-24 23:21:53','globeadmin'),('5a76c1c78849652','5a54c08c836c142',NULL,NULL,'1',10,NULL,'num_of_chars',50,30,'SMS Κείμενο Απουσιών','Πλήθος σταθερών χαρακτήρων (χωρίς τα πεδία αντικατάστασης) :','text',119,494,40,40,'c','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2018-02-04 10:18:15','globeadmin','2018-02-04 10:28:47','globeadmin','2022-09-24 23:21:54','globeadmin'),('5a92fc5445a6a98','59d7d745b1eecbf',NULL,NULL,'1',10,NULL,'hidden_iframe',20,100,'Μαθητές που είμαι Υπεύθυνος ή Σύμβουλος',NULL,'iframe',9,975,10,10,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2018-02-25 20:11:32','globeadmin','2018-02-25 20:11:32','globeadmin','2021-03-09 19:39:02','globeadmin'),('5a7739f4ae6d042','5a7738b60e35797',NULL,NULL,'1',10,NULL,'set_time_out_minutes',30,10,'Επιλογές Σύνδεσης και Παραμονής Χρηστών','Χρόνος αδράνειας για την αυτόματη αποσύνδεση (σε λεπτά) :','text',240,93,60,0,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2018-02-04 18:51:00','globeadmin','2018-02-04 19:24:20','globeadmin','2018-07-28 11:59:25','globeadmin'),('5a773ac16218073','5a7738b60e35797',NULL,NULL,'1',10,NULL,'set_numb_of_login_attempts',10,10,'Επιλογές Σύνδεσης και Παραμονής Χρηστών','Μέγιστος αριθμός αποτυχημένων προσπαθειών σύνδεσης :','text',80,105,60,0,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2018-02-04 18:54:25','globeadmin','2018-02-04 19:24:20','globeadmin','2018-07-28 11:59:25','globeadmin'),('5a773b0c5cf6097','5a7738b60e35797',NULL,NULL,'1',10,NULL,'set_lock_login_minutes',20,10,'Επιλογές Σύνδεσης και Παραμονής Χρηστών','Χρόνος προσμέτρησης των αποτυχημένων προσπαθειών (σε λεπτά) :','text',160,45,60,0,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2018-02-04 18:55:40','globeadmin','2018-02-04 19:24:20','globeadmin','2018-07-28 11:59:25','globeadmin'),('5a7740991218b05','56192b05ed5032f',NULL,NULL,'0',10,'select if(  \'#nu_user_group#\'=\'globeadmin\' or \n            \'#nu_user_group#\'=\'Administrators\' or \n            \'#nu_user_group#\'=\'Managers\',\'1\',\'0\')','login_setupbtn',20,20,'Σύστημα',NULL,'html',50,380,220,100,'l','0','0','','0',NULL,NULL,'1','54a52c3dcf3610b',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'key_id\').src=\'images/keyb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'key_id\').src=\'images/key.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'key_id\' src=\'images/key.png\' title=\'Επιλογές Σύνδεσης και Παραμονής Χρηστών\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Επιλογές Σύνδεσης Χρηστών</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-02-04 19:19:21','globeadmin','2018-02-04 20:28:58','globeadmin','2019-07-25 10:13:35','globeadmin'),('5a78c83a4ae8571','548338073921bfe',NULL,NULL,'1',10,NULL,'hidden_iframe',30,50,'Αναθέσεις Μαθημάτων',NULL,'iframe',10,970,10,10,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2018-02-05 23:10:18','globeadmin','2018-02-05 23:10:52','globeadmin','2022-01-08 10:51:56','globeadmin'),('5a78d60b4a8b7b5','59d7d837262870c',NULL,NULL,'1',10,NULL,'hidden_iframe',30,10,'Αναθέσεις Μαθημάτων',NULL,'iframe',14,916,30,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2018-02-06 00:09:15','globeadmin','2018-07-13 19:17:41','globeadmin','2018-07-13 19:17:41','globeadmin'),('5ad86b78b7564c2','599954a01e175cd',NULL,NULL,'1',10,NULL,'period_end',140,10,'Λεπτομέρειες',NULL,'dropdown',237,318,20,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select end_time,concat (name,\' - \',end_time)\nfrom period\norder by start_time',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2018-04-19 13:12:08','globeadmin','2018-04-19 13:20:50','globeadmin','2021-10-09 23:07:31','globeadmin'),('5adf013b970370e','599954a01e175cd',NULL,NULL,'1',10,'select if(((\'#nu_user_group#\' IN (\'globeadmin\',\'Managers\',\'AssistManagers\',\'Administrators\',\'Secretaries\')) OR \'#teacher_id#\'=teacher_id) AND \'#nu_new_record#\'=\'0\',\'1\',\'0\')  \nfrom session_variables \nwhere session_id=\'#session_id#\'','do_check',140,20,'Κοινοποίηση','Έλεγχος κατά την κοινοποίηση :','checkbox',64,471,40,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-04-24 13:04:43','globeadmin','2018-04-24 13:04:43','globeadmin','2021-10-09 23:07:32','globeadmin'),('5b0481378ff6961','547489b0d4efe7c',NULL,NULL,'1',10,NULL,'exam_curriculum',10,30,'Εξεταστέα Ύλη',NULL,'textarea',63,733,100,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2018-05-22 23:44:39','globeadmin','2018-05-22 23:44:39','globeadmin','2022-02-14 11:00:18','globeadmin'),('5b0481a250374ce','547489b0d4efe7c',NULL,NULL,'1',10,NULL,'tinymce_editor',20,30,'Εξεταστέα Ύλη',NULL,'iframe',39,17,900,400,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'56cc9f04b82528e','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-05-22 23:46:26','globeadmin','2018-05-22 23:47:28','globeadmin','2022-02-14 11:00:18','globeadmin'),('5b0485d0aa8bad5','5b04854d1104747',NULL,NULL,'1',10,NULL,'exam_curriculum',10,30,'Εξεταστέα Ύλη',NULL,'textarea',100,706,100,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2018-05-23 00:04:16','globeadmin','2018-05-23 00:04:16','globeadmin','2018-05-24 21:55:51','globeadmin'),('5b048611acd0bd0','5b04854d1104747',NULL,NULL,'1',10,NULL,'tinymce_editor',20,30,'Εξεταστέα Ύλη',NULL,'iframe',68,20,900,400,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'56cc9f04b82528e','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-05-23 00:05:21','globeadmin','2018-05-23 00:18:16','globeadmin','2018-05-24 22:00:24','globeadmin'),('5b0486dca294469','5b04854d1104747',NULL,NULL,'1',10,NULL,'lesson_disp',30,30,'Εξεταστέα Ύλη','Μάθημα :','display',7,83,750,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select concat(grade.short_name,section.abbreviation,if(section.abbreviation!=speciality.abbreviation,speciality.abbreviation,\'\'),\'-\',subject.name,IF(subject_type.short_name IS NULL,\'\',CONCAT(\' (\',subject_type.short_name,\')\')))\nfrom subject\ninner join grade on subject.grade_id=grade.id\ninner join speciality on subject.speciality_id=speciality.id\ninner join section on speciality.section_id=section.id\nleft  join subject_type on subject.subject_type_id=subject_type.id\nWHERE subject.id=\'#RECORD_ID#\'\n',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2018-05-23 00:08:44','globeadmin','2018-05-23 22:23:42','globeadmin','2018-05-24 21:59:36','globeadmin'),('5b0487786ef7fca','nuhome',NULL,NULL,'1',10,NULL,'exam_btn',130,10,'Globeadmin','Απουσιολόγια Τμήματος','button',133,382,200,35,'l','0','0','','0',NULL,NULL,'26','5b116c78852ee89',NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-05-23 00:11:20','globeadmin','2018-06-01 18:58:00','globeadmin','2018-12-03 16:31:58','globeadmin'),('5b05d6065c6e3de','5b04854d1104747',NULL,NULL,'1',10,NULL,'last_update_disp',40,30,'Εξεταστέα Ύλη','Τελευταία Ενημέρωση :','display',40,4,750,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','SELECT concat (if(teacher.surname IS NULL,\'\',concat(teacher.surname,\' \')),IF(teacher.name IS NULL,\'\',CONCAT(teacher.name,\' \')),\' στις \' ,DATE_FORMAT(ifNULL(exam_curriculum_modified_at,\'00-00-0000 00:00:00\'),\'%d-%m-%Y %H:%i:%s\'))\nFROM subject\ninner join  teacher on teacher.id = subject.exam_curriculum_post_teacher_id\nWHERE subject.id=\'#RECORD_ID#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2018-05-23 23:58:46','globeadmin','2018-05-24 00:05:07','globeadmin','2018-05-24 21:55:51','globeadmin'),('5b070bb2154844d','5b070b1a5c6dfb0',NULL,NULL,'1',10,NULL,'lesson_disp',20,30,'Εξεταστέα Ύλη','Μάθημα :','display',19,57,750,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select concat(grade.short_name,section.abbreviation,if(section.abbreviation!=speciality.abbreviation,speciality.abbreviation,\'\'),\'-\',subject.name,IF(subject_type.short_name IS NULL,\'\',CONCAT(\' (\',subject_type.short_name,\')\')))\nfrom subject\ninner join grade on subject.grade_id=grade.id\ninner join speciality on subject.speciality_id=speciality.id\ninner join section on speciality.section_id=section.id\nleft  join subject_type on subject.subject_type_id=subject_type.id\nWHERE subject.id=\'#RECORD_ID#\'\n',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2018-05-24 22:00:02','globeadmin','2018-05-24 22:00:02','globeadmin','2018-05-25 00:38:20','globeadmin'),('5b070bebc77016a','5b070b1a5c6dfb0',NULL,NULL,'1',10,NULL,'exam_curriculum_iframe',10,30,'Εξεταστέα Ύλη',NULL,'iframe',57,18,900,400,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-05-24 22:00:59','globeadmin','2018-05-24 22:04:00','globeadmin','2018-05-25 00:38:20','globeadmin'),('5b0eefff2ca187e','55261f6b593bdba',NULL,NULL,'1',10,NULL,'student_id',60,10,'Αναζήτηση','Μαθητής : ','listbox',64,23,400,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select distinct student.id, concat(ifNULL(grade.short_name,\'\'),\' - \',student.surname,\' \',student.name,\' \',student.fathers_name) \nfrom student\nleft join grade on grade.id = student.grade_id\nleft join (    select distinct student_id as s_id\n                            from student_class\n                            inner join card ON card.class_id=student_class.class_id\n                            where\n                                card.valid_from=(select max(start_date) from timetable) and   \n                                card.teacher_id=\'#RECORD_ID#\') as s ON s.s_id = student.id\nwhere\n        \'#nu_user_group#\'=\'globeadmin\' OR \n        \'#nu_user_group#\'=\'Administrators\' OR \n        \'#nu_user_group#\'=\'Managers\' OR \n        \'#nu_user_group#\'=\'AssistManagers\' OR\n        \'#nu_user_group#\'=\'Secretaries\' OR\n        s.s_id is not null OR\n        student.teacher_id = \'#RECORD_ID#\'\norder by student.grade_id,student.surname,student.name,student.fathers_name',NULL,'','','select distinct student.id, concat(ifNULL(grade.short_name,\'\'),\' - \',student.registration_number,\' - \', student.surname,\' \',student.name,\' \',student.fathers_name) \nfrom student\nleft join grade on grade.id = student.grade_id\nwhere\n        \'#nu_user_group#\'=\'globeadmin\' OR \n        \'#nu_user_group#\'=\'Administrators\' OR \n        \'#nu_user_group#\'=\'Managers\' OR \n        \'#nu_user_group#\'=\'AssistManagers\' OR\n        \'#nu_user_group#\'=\'Secretaries\' OR\n        student.teacher_id = \'#RECORD_ID#\'\norder by student.grade_id,student.surname,student.name,student.fathers_name',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-05-30 21:39:59','globeadmin','2018-06-01 10:06:00','globeadmin','2022-02-12 10:10:00','globeadmin'),('5b0ef30776c3af7','55261f6b593bdba',NULL,NULL,'1',10,NULL,'export_type',30,10,'Αναζήτηση','Μορφή Εξαγόμενων Αρχείων : ','dropdown',24,352,320,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'1|Ανά Τμήμα|2|Αναλυτικά Σύνολα ανά Μαθητή και Ημερομηνία',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-05-30 21:52:55','globeadmin','2018-05-30 22:56:18','globeadmin','2022-02-12 10:09:59','globeadmin'),('5b10f0d299cb24c','55261f6b593bdba',NULL,NULL,'1',10,NULL,'show_zero',70,10,'Αναζήτηση','και τα Μηδενικά Σύνολα : ','checkbox',63,535,30,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-06-01 10:08:02','globeadmin','2018-06-01 14:17:24','globeadmin','2022-02-12 10:10:00','globeadmin'),('5b112b9376bce83','55261f6b593bdba',NULL,NULL,'1',10,NULL,'max_rows',100,10,'Αναζήτηση','Εγγραφές ανά Φύλλο : ','text',64,736,40,30,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',0,0,'2018-06-01 14:18:43','globeadmin','2018-06-01 15:04:27','globeadmin','2022-02-12 10:10:00','globeadmin'),('5b116c9a1c2015a','5b116c78852ee89',NULL,NULL,'1',10,NULL,'from_date',10,10,'Δημιουργία Απουσιολογίων','Από : ','text',57,31,80,30,'r','0','0','select curdate()','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2018-06-01 18:56:10','globeadmin','2018-06-03 01:23:28','globeadmin','2018-12-03 16:31:11','globeadmin'),('5b116cb35b86ec3','5b116c78852ee89',NULL,NULL,'1',10,NULL,'to_date',20,10,'Δημιουργία Απουσιολογίων','Έως : ','text',57,191,80,30,'r','0','0','select curdate()','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2018-06-01 18:56:35','globeadmin','2018-06-03 01:23:28','globeadmin','2018-12-03 16:18:28','globeadmin'),('5b116d827fb48b4','5b116c78852ee89',NULL,NULL,'1',10,NULL,'absence_class_id',30,10,'Δημιουργία Απουσιολογίων','Τμήμα : ','dropdown',58,344,150,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name \nfrom class \nwhere \n(post_teacher_id=#RECORD_ID# OR \n\'#nu_user_group#\'=\'Managers\' OR \n\'#nu_user_group#\'=\'AssistManagers\' OR\n\'#nu_user_group#\'=\'Secretaries\' OR\n\'#nu_user_group#\'=\'Administrators\' OR\n\'#nu_user_group#\'=\'globeadmin\') and\nid in (select distinct class_id from student_class)  \norder by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-06-01 19:00:02','globeadmin','2018-06-03 01:23:28','globeadmin','2018-12-03 16:18:28','globeadmin'),('5b116e3131282e2','5b116c78852ee89',NULL,NULL,'1',10,NULL,'create_btn',50,10,'Δημιουργία Απουσιολογίων','Δημιουργία','button',157,221,150,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-06-01 19:02:57','globeadmin','2018-06-03 01:23:28','globeadmin','2018-12-03 16:18:28','globeadmin'),('5b1317d9494498f','5b116c78852ee89',NULL,NULL,'1',10,NULL,'get_zip',40,10,'Δημιουργία Απουσιολογίων','Λήψη Αρχείων :','checkbox',161,32,80,30,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2018-06-03 01:19:05','globeadmin','2018-06-03 01:23:28','globeadmin','2018-12-03 16:18:28','globeadmin'),('5b11b46ca86462c','5b116c78852ee89',NULL,NULL,'1',10,NULL,'search_iframe',60,10,'Δημιουργία Απουσιολογίων',NULL,'iframe',128,423,100,100,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-06-02 00:02:36','globeadmin','2018-06-03 01:23:28','globeadmin','2018-12-03 16:18:28','globeadmin'),('5b13074a8411c05','54707c8612b1b6b',NULL,NULL,'1',10,NULL,'myschool_code',50,10,'Λεπτομέρειες','Κωδικός στο Myschool :','text',314,61,80,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2018-06-03 00:08:26','globeadmin','2018-06-03 00:09:32','globeadmin','2019-11-03 18:57:14','globeadmin'),('5b1f992143f5c6c','5b1f98c3701d658',NULL,NULL,'1',10,NULL,'login_iframe',20,10,'Ιστορικό Σύνδεσης',NULL,'iframe',50,13,700,350,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'5b1f96ff515d327','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-06-12 12:57:53','globeadmin','2018-06-13 19:09:09','globeadmin','2018-06-13 19:49:21','globeadmin'),('5b1f9aac45942e7','547372d029461f4',NULL,NULL,'0',10,'select if((teacher.user_id IS NOT NULL) and \'#RECORD_ID#\'<>\'-1\',\'1\',\'0\')\nfrom school\nleft join teacher ON teacher.id=\'#RECORD_ID#\'\nwhere school.id=\'1\'','login_log_img',260,10,'Λεπτομέρειες',NULL,'html',75,837,20,20,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"this.style.cursor=\'pointer\';\"\n                            onmouseout=\"this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=18 height=18 id=\'img_login\' src=\'images/info.png\' title=\'Ιστορικό Συνδέσεων\'/>\n        </td>\n    </tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-06-12 13:04:28','globeadmin','2018-07-15 21:41:57','globeadmin','2021-01-26 20:15:04','globeadmin'),('5b214b527f9f6cc','54a65ecc3f14737',NULL,NULL,'1',10,NULL,'login_iframe',10,20,'Ιστορικό Σύνδεσης',NULL,'iframe',20,100,700,420,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'5b1f96ff515d327','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-06-13 19:50:26','globeadmin','2018-06-13 19:52:40','globeadmin','2018-07-28 00:36:33','globeadmin'),('5b213e508e742fd','5476201e5a3d38f',NULL,NULL,'0',10,'select if((student.user_id IS NOT NULL) and \'#RECORD_ID#\'<>\'-1\',\'1\',\'0\')\nfrom school\nleft join student ON student.id=\'#RECORD_ID#\'\nwhere school.id=\'1\'','login_student_log_img',250,10,'Στοιχεία Μαθητή',NULL,'html',506,359,20,20,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"this.style.cursor=\'pointer\';\"\n                            onmouseout=\"this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=18 height=18 id=\'img_student_login\' src=\'images/info.png\' title=\'Ιστορικό Συνδέσεων Μαθητή\'/>\n        </td>\n    </tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-06-13 18:54:56','globeadmin','2018-06-13 19:03:04','globeadmin','2022-01-08 11:22:27','globeadmin'),('5b213ef844df1b4','5476201e5a3d38f',NULL,NULL,'0',10,'select if((student.parent_user_id IS NOT NULL) and \'#RECORD_ID#\'<>\'-1\',\'1\',\'0\')\nfrom school\nleft join student ON student.id=\'#RECORD_ID#\'\nwhere school.id=\'1\'','login_parent_log_img',260,10,'Στοιχεία Μαθητή',NULL,'html',597,359,20,20,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"this.style.cursor=\'pointer\';\"\n                            onmouseout=\"this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=18 height=18 id=\'img_parent_login\' src=\'images/info.png\' title=\'Ιστορικό Συνδέσεων Γονέα\'/>\n        </td>\n    </tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-06-13 18:57:44','globeadmin','2018-06-13 19:02:28','globeadmin','2022-01-08 11:22:27','globeadmin'),('5b214136e99356d','5b1f98c3701d658',NULL,NULL,'1',10,NULL,'sus_name',10,10,'Ιστορικό Σύνδεσης','Χρήστης :','text',16,41,500,40,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-06-13 19:07:19','globeadmin','2018-06-13 19:09:09','globeadmin','2018-06-13 19:12:35','globeadmin'),('5b51e679a8d014c','5b51e592c69b21a',NULL,NULL,'1',10,NULL,'sme_name',10,10,'Λεπτομέρειες','Ομάδα :','text',30,121,300,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2018-07-20 16:41:13','globeadmin','2018-07-24 17:57:15','globeadmin','2018-07-24 18:05:48','globeadmin'),('5b51e7120eb38d6','nuhome',NULL,NULL,'1',10,NULL,'menu_item_btn',140,10,'Globeadmin','Στοιχεία Μενού','button',210,728,200,35,'l','0','0','','0',NULL,NULL,NULL,'5b51e592c69b21a',NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-07-20 16:43:46','globeadmin','2018-07-20 16:43:46','globeadmin','2018-07-20 16:43:46','globeadmin'),('5b51e7e4b92672b','5b51e592c69b21a',NULL,NULL,'1',10,NULL,'sme_description',20,10,'Λεπτομέρειες','Περιγραφή :','text',80,97,700,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2018-07-20 16:47:16','globeadmin','2018-07-20 16:47:16','globeadmin','2018-07-24 18:05:48','globeadmin'),('5b51e85f217dcfb','5b51e592c69b21a',NULL,NULL,'1',10,NULL,'sme_order_number',30,10,'Λεπτομέρειες','Σειρά :','text',161,129,80,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2018-07-20 16:49:19','globeadmin','2018-07-20 16:49:19','globeadmin','2018-07-24 18:05:48','globeadmin'),('5b51e8b5dfbc18d','5b51e592c69b21a',NULL,NULL,'1',10,NULL,'sme_image_name',40,10,'Λεπτομέρειες','Όνομα Αρχείου Εικόνας :','text',211,23,300,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2018-07-20 16:50:45','globeadmin','2018-07-20 16:50:45','globeadmin','2018-07-24 18:05:49','globeadmin'),('5b51e9274f73613','5b51e592c69b21a',NULL,NULL,'1',10,NULL,'sme_label',50,10,'Λεπτομέρειες','Τίτλος :','text',262,125,500,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2018-07-20 16:52:39','globeadmin','2018-07-20 16:52:39','globeadmin','2018-07-24 18:05:49','globeadmin'),('5b51e95d9b03fe3','5b51e592c69b21a',NULL,NULL,'1',10,NULL,'sme_title',60,10,'Λεπτομέρειες','Αναδυόμενη Περιγραφή :','text',312,23,500,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2018-07-20 16:53:33','globeadmin','2018-07-20 16:53:33','globeadmin','2018-07-24 18:05:49','globeadmin'),('5b51eaab0a419a2','5b51e592c69b21a',NULL,NULL,'1',10,NULL,'sme_display_condition',70,10,'Λεπτομέρειες','Συνθήκη Εμφάνισης :','textarea',385,44,500,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2018-07-20 16:59:07','globeadmin','2018-07-20 17:00:13','globeadmin','2018-07-24 18:05:49','globeadmin'),('5b51eba8974ad0d','5b51e592c69b21a',NULL,NULL,'1',10,NULL,'sme_onclick_code',10,20,'Συμβάντα Ποντικιού','onclick :','textarea',41,83,700,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2018-07-20 17:03:20','globeadmin','2018-07-20 17:03:20','globeadmin','2018-07-24 18:05:49','globeadmin'),('5b51ebd72959c87','5b51e592c69b21a',NULL,NULL,'1',10,NULL,'sme_onmouseover_code',20,20,'Συμβάντα Ποντικιού','onmouseover :','textarea',206,43,700,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2018-07-20 17:04:07','globeadmin','2018-07-20 17:04:07','globeadmin','2018-07-24 18:05:49','globeadmin'),('5b51ebedcf579d1','5b51e592c69b21a',NULL,NULL,'1',10,NULL,'sme_onmouseout_code',30,20,'Συμβάντα Ποντικιού','onmouseout :','textarea',372,51,700,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2018-07-20 17:04:29','globeadmin','2018-07-20 17:04:29','globeadmin','2018-07-24 18:05:49','globeadmin'),('5b51edcc89e855b','5b51e592c69b21a',NULL,NULL,'1',10,NULL,'access_to',10,30,'Πρόσβαση',NULL,'subform',11,30,450,300,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,22,'1','1','slm_zzzsys_menu_item_id','zzzsys_access_level_menu_item_id','SELECT * \nFROM zzzsys_access_level_menu_item \nWHERE slm_zzzsys_menu_item_id = \'#RECORD_ID#\' \nORDER BY slm_zzzsys_access_level_id','zzzsys_access_level_menu_item',NULL,'',NULL,'g',100,250,'2018-07-20 17:12:28','globeadmin','2018-07-20 17:55:47','globeadmin','2018-07-24 18:05:49','globeadmin'),('5b51f73e5b30fab','5b51edcc89e855b',NULL,NULL,'1',10,NULL,'slm_zzzsys_access_level_id',10,10,'Details','Ομάδα Χρηστών','dropdown',0,0,400,0,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'SELECT  zzzsys_access_level_id,sal_description\nFROM zzzsys_access_level\nORDER BY sal_description desc',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2018-07-20 17:52:46','globeadmin','2018-07-20 17:55:16','globeadmin','2018-07-21 13:17:08','globeadmin'),('5b5f32a29ddb6bb','nuform','','0','1',10,NULL,'sfo_play_buttons',10,300,'Custom','Κουμπιά Εγγραφών :','checkbox',53,158,40,0,'l','0','0','','0','',0,'','','','','','','','','','','','','','','','','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2015-04-14 11:42:50','globeadmin'),('5b5f3311c24cb74','nuform','','0','1',10,NULL,'sfo_play_buttons_display_condition',20,300,'Custom','Συνθήκη Εμφάνισης Κουμπιών Εγγραφών :','textarea',104,29,400,200,'l','0','0','','0','',0,'','','','','','','','','','','','','','','','','','','','',0,'1','1','','','','','','','','',0,0,'0000-00-00 00:00:00','','0000-00-00 00:00:00','','2015-04-14 11:42:50','globeadmin'),('5b675d272e736da','5476201e5a3d38f',NULL,NULL,'1',10,NULL,'label_parent',270,20,'Στοιχεία Επικοινωνίας','Στοιχεία Επικοινωνίας Κηδεμόνα','words',129,655,300,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2018-08-05 23:25:11','globeadmin','2018-08-05 23:28:56','globeadmin','2022-01-08 11:22:28','globeadmin'),('5b675d623a863fb','5476201e5a3d38f',NULL,NULL,'1',10,NULL,'label_student',280,20,'Στοιχεία Επικοινωνίας','Στοιχεία Επικοινωνίας Μαθητή','words',130,142,300,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2018-08-05 23:26:10','globeadmin','2018-08-05 23:26:10','globeadmin','2022-01-08 11:22:28','globeadmin'),('5b69945a13abf6b','5470788787e004a',NULL,NULL,'1',10,NULL,'num_of_days_limit',30,10,'Λεπτομέρειες','Όριο σε εργάσιμες ημέρες για την εισαγωγή του αιτήματος :','text',240,132,60,0,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2018-08-07 15:45:14','globeadmin','2018-08-07 15:53:02','globeadmin','2018-08-09 18:08:32','globeadmin'),('5b709e4bed47213','5564d8431a9da4b',NULL,NULL,'1',10,NULL,'student_id',10,10,'Βιβλίο Φοίτησης','Μαθητές : ','listbox',30,60,500,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select student.id,concat(ifNULL(grade.short_name,\'\'),\' - \',student.surname,\' \',student.name,\' \',student.fathers_name) \nfrom student \nleft join grade on grade.id = student.grade_id\norder by student.grade_id,student.surname,student.name,student.fathers_name',NULL,'','','select student.id,concat(ifNULL(grade.short_name,\'\'),\' - \',student.surname,\' \',student.name,\' \',student.fathers_name) \nfrom student \nleft join grade on grade.id = student.grade_id\nwhere\n        \'#nu_user_group#\'=\'globeadmin\' OR \n        \'#nu_user_group#\'=\'Administrators\' OR \n        \'#nu_user_group#\'=\'Managers\' OR \n        \'#nu_user_group#\'=\'AssistManagers\' OR\n        \'#nu_user_group#\'=\'Secretaries\' OR\n        student.teacher_id = \'#RECORD_ID#\' OR\n        student.advisor_id = \'#RECORD_ID#\'\norder by student.grade_id,student.surname,student.name,student.fathers_name',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-08-12 23:53:32','globeadmin','2018-08-13 10:22:28','globeadmin','2022-02-12 10:13:26','globeadmin'),('5bf1d5d6749569c','5538ff58cb7b4b8',NULL,NULL,'1',10,'select \'0\'','period_count',50,10,'Εκτύπωση Απουσιολογίων','Πλήθος Ωρών : ','display',32,846,40,40,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select count(*) from period;',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-11-18 23:12:54','globeadmin','2018-11-18 23:13:29','globeadmin','2018-11-18 23:14:16','globeadmin'),('5bf1d64512ed660','54f735c7d56625f',NULL,NULL,'1',10,'select \'0\'','period_count',70,10,'Απουσιολόγιο','Πλήθος Ωρών : ','display',33,935,40,40,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select count(*) from period;',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-11-18 23:14:45','globeadmin','2018-11-18 23:15:46','globeadmin','2022-09-24 23:06:18','globeadmin'),('5c06d4dd59bdbe3','5c053bad46326aa',NULL,NULL,'1',10,NULL,'grade_id',10,10,'Ορισμός Ατομικού Συμβούλου','Τάξη :','dropdown',15,287,100,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name \nfrom grade \norder by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-12-04 21:26:21','globeadmin','2018-12-04 21:27:59','globeadmin','2018-12-08 20:49:41','globeadmin'),('5c053e9009293e6','nuhome',NULL,NULL,'1',10,NULL,'absence_comapre',150,10,'Globeadmin','Σύγκριση Απουσιών','button',288,382,200,35,'l','0','0','','0',NULL,NULL,'26','6206ad009f3ac5e',NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-12-03 16:32:48','globeadmin','2022-02-11 20:45:47','globeadmin','2022-02-11 20:45:47','globeadmin'),('5c06d3d3e4e3187','5c053bad46326aa',NULL,NULL,'1',10,NULL,'class_id',20,10,'Ορισμός Ατομικού Συμβούλου','Τμήμα :','dropdown',15,447,150,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name \nfrom class \norder by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-12-04 21:21:55','globeadmin','2018-12-04 21:21:55','globeadmin','2018-12-08 20:49:19','globeadmin'),('5c06d3ef3c6e67b','5c053bad46326aa',NULL,NULL,'1',10,NULL,'advisor_id',30,10,'Ορισμός Ατομικού Συμβούλου','Νέοι Σύμβουλοι Μαθητών :','listbox',56,18,450,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select  id,\n        concat(if(surname is null,\'\',concat(surname,\' \')), IFNULL(name,\'\')) as teacher_full_name\nfrom teacher\norder by teacher_full_name',NULL,'','','select  id,\n        concat(if(surname is null,\'\',concat(surname,\' \')), IFNULL(name,\'\')) as teacher_full_name\nfrom teacher\norder by teacher_full_name',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-12-04 21:22:23','globeadmin','2018-12-08 20:24:07','globeadmin','2018-12-08 20:49:19','globeadmin'),('5c06d40d96c36fb','5c053bad46326aa',NULL,NULL,'1',10,NULL,'set_btn',40,10,'Ορισμός Ατομικού Συμβούλου','Ορισμός','button',49,718,160,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select  id,\n        concat(if(surname is null,\'\',concat(surname,\' \')), IFNULL(name,\'\')) as teacher_full_name\nfrom teacher\norder by teacher_full_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-12-04 21:22:53','globeadmin','2018-12-04 21:22:53','globeadmin','2020-09-19 17:13:08','globeadmin'),('5c06d43fa7da394','5c053bad46326aa',NULL,NULL,'1',10,NULL,'search_iframe',50,10,'Ορισμός Ατομικού Συμβούλου',NULL,'iframe',174,19,900,600,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select  id,\n        concat(if(surname is null,\'\',concat(surname,\' \')), IFNULL(name,\'\')) as teacher_full_name\nfrom teacher\norder by teacher_full_name',NULL,'58146cff692dbf3','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-12-04 21:23:43','globeadmin','2018-12-04 22:15:40','globeadmin','2018-12-08 20:49:19','globeadmin'),('5c06daf22b5739a','5c053bad46326aa',NULL,NULL,'1',10,NULL,'label1',60,10,'Ορισμός Ατομικού Συμβούλου','Επιλέγοντας :','words',91,27,800,20,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-12-04 21:52:18','globeadmin','2018-12-04 22:08:24','globeadmin','2018-12-08 20:49:19','globeadmin'),('5c06de17a0874d5','5c053bad46326aa',NULL,NULL,'1',10,NULL,'label2',70,10,'Ορισμός Ατομικού Συμβούλου','- κανέναν καθηγητή, με τον ορισμό, οι επιλεγμένοι μαθητές δεν θα έχουν ατομικό σύμβουλο','words',111,52,800,20,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-12-04 22:05:43','globeadmin','2018-12-04 22:09:45','globeadmin','2018-12-08 20:49:19','globeadmin'),('5c06de23c7973fe','5c053bad46326aa',NULL,NULL,'1',10,NULL,'label3',80,10,'Ορισμός Ατομικού Συμβούλου','- έναν καθηγητή, με τον ορισμό, θα οριστεί αυτός ως ατομικός σύμβουλος στους επιλεγμένους μαθητές','words',132,52,800,20,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-12-04 22:05:55','globeadmin','2018-12-04 22:12:20','globeadmin','2018-12-08 20:49:19','globeadmin'),('5c06de30c5262dc','5c053bad46326aa',NULL,NULL,'1',10,NULL,'label4',90,10,'Ορισμός Ατομικού Συμβούλου','- περισσότερους από έναν καθηγητές, ο ορισμός του ατομικού συμβούλου στους επιλεγμένους μαθητές θα γίνει με τυχαίο τρόπο (κλήρωση)','words',152,52,800,20,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-12-04 22:06:08','globeadmin','2018-12-04 22:13:31','globeadmin','2018-12-08 20:49:19','globeadmin'),('5c0c0b0b7be89df','5c053bad46326aa',NULL,NULL,'1',10,NULL,'gender',100,10,'Ορισμός Ατομικού Συμβούλου','Φύλο :','dropdown',15,135,100,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'Α|Αγόρι|Θ|Κορίτσι',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2018-12-08 20:18:51','globeadmin','2018-12-08 20:48:09','globeadmin','2018-12-08 20:50:13','globeadmin'),('5c1df7f31aebd6f','5a54c08c836c142',NULL,NULL,'1',10,NULL,'system_url',130,10,'Παράμετροι','Διεύθυνση Ιστοσελίδας Σίσυφου :','text',483,389,300,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2018-12-22 10:38:11','globeadmin','2018-12-22 16:12:10','globeadmin','2022-09-24 23:21:53','globeadmin'),('5c1df953743cb26','5470c07906bfd70',NULL,NULL,'1',10,NULL,'system_url',120,20,'Επικοινωνία','Διεύθυνση Ιστοσελίδας Σίσυφου :','text',366,394,300,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2018-12-22 10:44:03','globeadmin','2018-12-22 16:11:45','globeadmin','2018-12-22 16:11:45','globeadmin'),('5c59f8e74bb3abb','nuhome',NULL,NULL,'1',10,NULL,'reward_btn',160,10,'Globeadmin','Επιβράβευση','button',288,728,200,35,'l','0','0','','0',NULL,NULL,NULL,'61744f1b13259e3',NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2019-02-05 22:58:15','globeadmin','2021-10-23 22:01:08','globeadmin','2021-10-23 22:01:09','globeadmin'),('5c8381bfc47f954','5c838179bfcf3d0',NULL,NULL,'1',10,NULL,'teacher_chk',10,10,'Προσθήκη Σχόλιου','Για τον Καθηγητή :','checkbox',74,49,40,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2019-03-09 11:05:03','globeadmin','2019-03-09 13:24:09','globeadmin','2021-10-20 23:35:49','globeadmin'),('5c8381e012308d2','5c838179bfcf3d0',NULL,NULL,'1',10,NULL,'student_chk',20,10,'Προσθήκη Σχόλιου','Για τον Μαθητή/Γονέα :','checkbox',74,206,40,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2019-03-09 11:05:36','globeadmin','2019-03-09 13:24:09','globeadmin','2021-10-20 23:35:49','globeadmin'),('5c839b04e3b54bc','5c838179bfcf3d0',NULL,NULL,'1',10,NULL,'student_name',30,10,'Προσθήκη Σχόλιου','Μαθητής :','text',11,22,500,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'Καθυστερημένη Είσοδος|Καθυστερημένη Είσοδος|Παρατήρηση|Παρατήρηση|Επίπληξη|Επίπληξη',NULL,'','',NULL,NULL,NULL,'#nuSepEditnuSepr#varchar',NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2019-03-09 12:52:53','globeadmin','2019-03-09 13:24:09','globeadmin','2021-10-20 23:35:49','globeadmin'),('5c84d4d70186858','5525421c67a48bc',NULL,NULL,'1',10,NULL,'period_id',30,10,'Αναζήτηση','Ώρα : ','listbox',27,362,80,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,name from period order by short_name',NULL,'','','select id,name from period order by short_name',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2019-03-10 11:11:51','globeadmin','2019-03-10 11:52:22','globeadmin','2022-09-17 21:45:17','globeadmin'),('5c839bdad208c76','5c838179bfcf3d0',NULL,NULL,'1',10,NULL,'subject_name',40,10,'Προσθήκη Σχόλιου','Μάθημα :','text',43,25,500,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'Καθυστερημένη Είσοδος|Καθυστερημένη Είσοδος|Παρατήρηση|Παρατήρηση|Επίπληξη|Επίπληξη',NULL,'','',NULL,NULL,NULL,'#nuSepEditnuSepr#varchar',NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2019-03-09 12:56:27','globeadmin','2019-03-09 13:24:09','globeadmin','2021-10-20 23:35:49','globeadmin'),('5c839dd0ac0b373','5c838179bfcf3d0',NULL,NULL,'1',10,NULL,'comment_tinymce',50,10,'Προσθήκη Σχόλιου',NULL,'iframe',111,7,824,380,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'Καθυστερημένη Είσοδος|Καθυστερημένη Είσοδος|Παρατήρηση|Παρατήρηση|Επίπληξη|Επίπληξη',NULL,'56cc9f04b82528e','',NULL,NULL,NULL,'#nuSepEditnuSepr#varchar',NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2019-03-09 13:04:48','globeadmin','2019-03-09 13:24:09','globeadmin','2021-10-20 23:35:49','globeadmin'),('5d123ee0664f450','59da63096606dc0',NULL,NULL,'0',10,'select show_student_status from school where id=1;','student_state',110,10,'Αρχικό Μενού',NULL,'html',455,1,980,24,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<style type=\'text/css\'>\n.circle {\n    border-radius: 50%;\n    width: 12px;\n    height: 12px;\n    vertical-align:middle;\n    opacity: .80;\n}\n.red {\n    background-color: red;\n}\n</style>\n\n<table border=0 CELLSPACING=0 CELLPADDING=0 width=100%>\n    <tr>\n        <td valign=\'middle\' align=\'left\' width=18px>\n            <div id=\'bullet\' class=\"circle red\"></div>    \n        </td>\n        <td valign=\'middle\' align=\'left\'>\n            <span id=\'state\' style=\'font-family: Arial, Helvetica, sans-serif;font-size: 10px;font-weight: bold;\'>- - -</span>\n        </td>\n    </tr>\n</table>\n\n<script>\n$(function () {\n    $(\'#bullet\').delay(5000).fadeOut(1600, function () {\n        fadeItIn();\n    });\n});\n\nfunction fadeItIn() {\n    $(\'#bullet\').fadeIn(1600, function () {\n        fadeItOut();\n    }).delay(2000);\n}\n\nfunction fadeItOut() {\n    $(\'#bullet\').fadeOut(1600, function () {\n        fadeItIn();\n    });\n}\n</script>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2019-06-25 18:33:52','globeadmin','2019-07-03 23:07:51','globeadmin','2022-01-08 14:20:42','globeadmin'),('5d1a76bf43ea07c','5476201e5a3d38f',NULL,NULL,'0',10,NULL,'student_state',270,10,'Στοιχεία Μαθητή',NULL,'html',657,12,1000,24,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<style type=\'text/css\'>\n.circle {\n    border-radius: 50%;\n    width: 12px;\n    height: 12px;\n    vertical-align:middle;\n    opacity: .80;\n}\n.red {\n    background-color: red;\n}\n</style>\n\n<table border=0 CELLSPACING=0 CELLPADDING=0 width=100%>\n    <tr>\n        <td valign=\'middle\' align=\'left\' width=18px>\n            <div id=\'bullet\' class=\"circle red\"></div>    \n        </td>\n        <td valign=\'middle\' align=\'left\'>\n            <span id=\'state\' style=\'font-family: Arial, Helvetica, sans-serif;font-size: 10px;font-weight: bold;\'>- - -</span>\n        </td>\n    </tr>\n</table>\n\n<script>\n$(function () {\n    $(\'#bullet\').delay(6000).fadeOut(1600, function () {\n        fadeItIn();\n    });\n});\n\nfunction fadeItIn() {\n    $(\'#bullet\').fadeIn(1600, function () {\n        fadeItOut();\n    }).delay(2000);\n}\n\nfunction fadeItOut() {\n    $(\'#bullet\').fadeOut(1600, function () {\n        fadeItIn();\n    });\n}\n</script>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2019-07-02 00:10:23','globeadmin','2019-07-03 23:09:05','globeadmin','2022-01-08 11:22:27','globeadmin'),('5d2109cfa0ed7cb','5a607704e048c15',NULL,NULL,'1',10,NULL,'tinymce_text',40,10,'Λίστα Μαθητών',NULL,'iframe',73,18,940,380,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'56cc9f04b82528e','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2019-07-06 23:51:27','globeadmin','2019-07-06 23:56:12','globeadmin','2019-07-08 13:11:23','globeadmin'),('5d3caeba9bbdeac','54a52c3dcf3610b',NULL,NULL,'1',10,NULL,'sms_login_password',50,20,'Ρυθμίσεις Αποστολής SMS','Κωδικός :','text',191,166,300,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2019-07-27 23:06:18','globeadmin','2019-07-27 23:08:58','globeadmin','2019-07-27 23:23:30','globeadmin'),('5d3cb02e2184363','54a52c3dcf3610b',NULL,NULL,'1',10,'select if(\'#nu_user_group#\'=\'globeadmin\',\'1\',\'0\')','sms_api_key_disp',100,20,'Ρυθμίσεις Αποστολής SMS','API Key :','display',411,680,200,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select api_key\nfrom sms_gateway where active=1 \nlimit 1',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2019-07-27 23:12:30','globeadmin','2019-07-27 23:19:49','globeadmin','2019-07-27 23:23:30','globeadmin'),('5d45d619edbe1cc','547070c91793d3b',NULL,NULL,'1',10,NULL,'label2',50,10,'Λεπτομέρειες','(Επιλέξτε εφόσον οι βαθμοί μπορεί να μην είναι ακέραιοι αλλά να έχουν ένα δεκαδικό ψηφίο π.χ. 15,6)','words',213,332,600,30,'l','0','0','\'0\'','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'0|NAI|1|OXI',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2019-08-03 21:44:42','globeadmin','2019-08-03 21:57:50','globeadmin','2021-09-04 21:36:57','globeadmin'),('5d1baf279d9629d','5a54c08c836c142',NULL,NULL,'1',10,NULL,'show_student_status',100,10,'Παράμετροι','Εμφάνιση τρέχουσας κατάστασης μαθητή στους Μαθητές/Γονείς :','checkbox',347,205,20,0,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2019-07-02 22:23:19','globeadmin','2019-07-02 22:29:40','globeadmin','2022-09-24 23:21:53','globeadmin'),('5d1bb1d74e07864','59da63096606dc0',NULL,NULL,'0',10,'select \'0\'','show_student_status',120,10,'Αρχικό Μενού',NULL,'display',417,958,20,20,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select show_student_status from school where id=1;',NULL,'<style type=\'text/css\'>\n\n@keyframes in-out {\n    0% {\n        transform: scale(1);\n        opacity: .25;\n    }\n    5% {\n        transform: scale(1);\n        opacity: .25;\n    }\n    10% {\n        transform: scale(1);\n        opacity: .35;\n    }\n    15% {\n        transform: scale(1);\n        opacity: .45;\n    }\n    20% {\n        transform: scale(1);\n        opacity: .55;\n    }\n    25% {\n        transform: scale(1);\n        opacity: .65;\n    }\n    30% {\n        transform: scale(1);\n        opacity: .75;\n    }\n    35% {\n        transform: scale(1);\n        opacity: .85;\n    }\n    40% {\n        transform: scale(1);\n        opacity: .95;\n    }\n    45% {\n        transform: scale(1);\n        opacity: 1;\n    }\n    50% {\n        transform: scale (1);\n        opacity: 1;\n    }\n    55% {\n        transform: scale(1);\n        opacity: 1;\n    }\n    60% {\n        transform: scale (1);\n        opacity: .95;\n    }\n    65% {\n        transform: scale(1);\n        opacity: .85;\n    }\n    70% {\n        transform: scale (1);\n        opacity: .75;\n    }\n    75% {\n        transform: scale(1);\n        opacity: .65;\n    }\n    80% {\n        transform: scale (1);\n        opacity: .55;\n    }\n    85% {\n        transform: scale(1);\n        opacity: .45;\n    }\n    90% {\n        transform: scale (1);\n        opacity: .35;\n    }\n    95% {\n        transform: scale(1);\n        opacity: .25;\n    }\n    100% {\n        transform: scale(1);\n        opacity: .25;\n    }\n}\n\n.circle {\n    border-radius: 50%;\n    width: 12px;\n    height: 12px;\n    vertical-align:middle;\n    opacity: .25;\n}\n\n.orange {\n    background-color: orange;\n    -webkit-animation: in-out 4s infinite;\n    -moz-animation: in-out 4s infinite;\n    -o-animation: in-out 4s infinite;\n    animation: in-out 4s infinite;\n}\n\n\n</style>\n<table border=0 CELLSPACING=0 CELLPADDING=0 width=100%>\n    <tr>\n        <td valign=\'middle\' align=\'center\' width=26px>\n            <div class=\"circle orange\"></div>    \n        </td>\n        <td valign=\'middle\' align=\'left\'>\n            <span id=\'state\' style=\'font-family: Arial, Helvetica, sans-serif;font-size: 10px;font-weight: bold;\'>- - -</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2019-07-02 22:34:47','globeadmin','2019-07-02 22:35:33','globeadmin','2022-01-08 14:20:42','globeadmin'),('5dbec072d959799','5618f5cc92f9c9e',NULL,NULL,'1',10,NULL,'sisyphos_privacy',100,500,'Πληροφορίες','Διαβάστε τη ','html',386,388,400,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 width=100% height=100%>\n<tr>\n<td valign=middle align=left>\n<a href=\"privacyPolicy.php\" target=\"_blank\">Δήλωση Ιδιωτικότητας</a>\n</td>\n</tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2019-11-03 13:56:34','globeadmin','2019-11-03 14:02:48','globeadmin','2022-11-30 11:53:03','globeadmin'),('5dbec10b6aecb36','59d67ca712d3ffa',NULL,NULL,'1',10,NULL,'sisyphos_privacy',100,500,'Πληροφορίες','Διαβάστε τη ','html',386,388,400,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 width=100% height=100%>\n<tr>\n<td valign=middle align=left>\n<a href=\"privacyPolicy.php\" target=\"_blank\">Δήλωση Ιδιωτικότητας</a>\n</td>\n</tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2019-11-03 13:59:07','globeadmin','2019-11-03 14:00:07','globeadmin','2021-03-22 19:49:24','globeadmin'),('5dbec220a2258d4','59da63096606dc0',NULL,NULL,'1',10,NULL,'sisyphos_privacy',110,500,'Πληροφορίες','Διαβάστε τη ','html',386,388,400,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 width=100% height=100%>\n<tr>\n<td valign=middle align=left>\n<a href=\"privacyPolicy.php\" target=\"_blank\">Δήλωση Ιδιωτικότητας</a>\n</td>\n</tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2019-11-03 14:03:44','globeadmin','2019-11-03 14:03:44','globeadmin','2022-01-08 14:20:43','globeadmin'),('5dbec7a5cfd9ed5','547489b0d4efe7c',NULL,NULL,'1',10,NULL,'absence_counts',80,10,'Λεπτομέρειες','Οι απουσίες θα προσμετρούνται : ','checkbox',389,18,60,0,'l','0','0','select \'1\'','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'1|Ναί|0|Όχι',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2019-11-03 14:27:17','globeadmin','2019-11-03 18:35:01','globeadmin','2022-02-14 11:00:18','globeadmin'),('5dbed79c6d53c2e','547489b0d4efe7c',NULL,NULL,'1',10,NULL,'label1',110,10,'Λεπτομέρειες','Προσοχή : Εάν οι απουσίες του μαθήματος δεν προσμετρούνται, αυτές θα καταχωρίζονται εν τη γενέσει τους ως διαγραμμένες','words',396,247,700,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2019-11-03 15:35:24','globeadmin','2019-11-03 18:36:11','globeadmin','2022-02-14 11:00:18','globeadmin'),('5dc273ca1371406','5dc273803a8d0d6',NULL,NULL,'1',10,NULL,'student_id',30,10,'Εξαγωγή','Μαθητής : ','listbox',86,12,450,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select student.id,concat(ifNULL(grade.short_name,\'\'),\' - \',student.surname,\' \',student.name,\' \',student.fathers_name) \nfrom student \nleft join grade on grade.id = student.grade_id\norder by student.grade_id,student.surname,student.name,student.fathers_name',NULL,'','','select student.id,concat(ifNULL(grade.short_name,\'\'),\' - \',student.surname,\' \',student.name,\' \',student.fathers_name) \nfrom student \nleft join grade on grade.id = student.grade_id\norder by student.grade_id,student.surname,student.name,student.fathers_name',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2019-11-06 09:18:34','globeadmin','2019-11-06 09:55:09','globeadmin','2021-04-01 20:19:09','globeadmin'),('5dc273e9f1159ed','5dc273803a8d0d6',NULL,NULL,'1',10,NULL,'class_id',20,10,'Εξαγωγή','Τμήμα : ','listbox',41,328,150,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select distinct class.id,class.short_name \nfrom class\ninner join student_class on class.id=student_class.class_id\norder by class.short_name',NULL,'','','select distinct class.id,class.short_name \nfrom class\ninner join student_class on class.id=student_class.class_id\norder by class.short_name',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2019-11-06 09:19:06','globeadmin','2019-11-06 09:55:09','globeadmin','2021-04-01 20:19:09','globeadmin'),('5dc27441cc32102','nuhome',NULL,NULL,'1',10,NULL,'export_students_btn',170,10,'Globeadmin','Εξαγωγή Μαθητών','button',365,728,200,35,'l','0','0','','0',NULL,NULL,'26','5dc273803a8d0d6',NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2019-11-06 09:20:33','globeadmin','2019-11-06 09:20:51','globeadmin','2019-11-06 09:20:51','globeadmin'),('5dc278f099b40ee','5dc273803a8d0d6',NULL,NULL,'1',10,NULL,'grade_id',10,10,'Εξαγωγή','Τάξη : ','listbox',41,36,150,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select distinct class.id,class.short_name \nfrom class\ninner join student_class on class.id=student_class.class_id\norder by class.short_name',NULL,'','','select  grade.id,grade.short_name \nfrom grade\norder by grade.short_name',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2019-11-06 09:40:32','globeadmin','2019-11-06 09:55:09','globeadmin','2021-04-01 20:19:09','globeadmin'),('5dc27b21eb59eb6','5dc273803a8d0d6',NULL,NULL,'1',10,NULL,'label1',50,10,'Εξαγωγή','Επιλέξτε από τα παρακάτω κριτήρια αναζήτησης. Αφήνοντας κενό ένα κριτήριο, θα συμπεριληφθούν όλοι οι αντίστοιχοι μαθητές.','words',13,4,600,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from class order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2019-11-06 09:49:54','globeadmin','2019-11-06 09:55:09','globeadmin','2021-04-01 20:19:09','globeadmin'),('5dc27c99ea8ebf5','5dc273803a8d0d6',NULL,NULL,'1',10,NULL,'export_btn',40,10,'Εξαγωγή','Εξαγωγή','button',149,75,150,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2019-11-06 09:56:10','globeadmin','2019-11-06 09:56:54','globeadmin','2021-04-01 20:19:09','globeadmin'),('5dc27d47e4f8df3','5dc273803a8d0d6',NULL,NULL,'1',10,NULL,'hidden_iframe',60,50,'Εξαγωγή',NULL,'iframe',0,0,10,10,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2019-11-06 09:59:03','globeadmin','2019-11-06 09:59:03','globeadmin','2021-04-01 20:20:13','globeadmin'),('5dcbde1705aaac9','5a54c08c836c142',NULL,NULL,'1',10,NULL,'hide_student_absence',110,10,'Παράμετροι','Απόκρυψη των απουσιών από στους Μαθητές :','checkbox',302,307,20,0,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2019-11-13 12:42:31','globeadmin','2019-11-13 12:46:54','globeadmin','2022-09-24 23:21:53','globeadmin'),('5dcbe28e44d426c','59e22f9965b5362',NULL,NULL,'1',10,'SELECT IF(\'#nu_user_group#\'=\'Students\' AND hide_student_absence=1,\'1\',\'0\')\nFROM school WHERE id=1','label_student',140,10,'Απουσίες','Οι απουσίες δεν εμφανίζονται στους μαθητές. Παρακαλώ επικοινωνήστε με τον Υπεύθυνο Καθηγητή σας!','words',30,20,800,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select count(*)\nfrom absence \nwhere \nstudent_id=\'#RECORD_ID#\' and \ncounts=1;',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2019-11-13 13:01:34','globeadmin','2019-11-13 14:01:50','globeadmin','2020-04-02 16:25:31','globeadmin'),('5e8392b3bb14cfd','56192b05ed5032f',NULL,NULL,'0',10,'select if(  \'#nu_user_group#\'=\'globeadmin\' or \n            \'#nu_user_group#\'=\'Administrators\' or \n            \'#nu_user_group#\'=\'Managers\',\'1\',\'0\')','eclass_btn',10,40,'Διασύνδεση ',NULL,'html',50,73,220,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_eclass_logo\').src=\'images/eclass_logob.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_eclass_logo\').src=\'images/eclass_logo.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_eclass_logo\' src=\'images/eclass_logo.png\' title=\'Διασύνδεση με το Open eClass\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Open eClass</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2020-03-31 21:57:55','globeadmin','2020-04-02 11:33:00','globeadmin','2020-08-24 19:34:08','globeadmin'),('5e85b005a6c8fda','5e85a2a072783b3',NULL,NULL,'1',10,NULL,'server_address',20,10,'LMS Open eClass','Εξυπηρετητής : ','text',68,84,250,45,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<a href=\'asc_template.xml\'>Λήψη</a>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2020-04-02 12:27:33','globeadmin','2020-04-02 22:14:07','globeadmin','2020-08-25 11:30:07','globeadmin'),('5e85b0af9b3c94d','5e85a2a072783b3',NULL,NULL,'1',10,NULL,'server_label',10,10,'LMS Open eClass','Στοιχεία Βάσης Δεδομένων που φιλοξενεί το Open eClass :','words',32,13,850,45,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<a href=\'asc_template.xml\'>Λήψη</a>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2020-04-02 12:30:23','globeadmin','2020-04-02 22:14:07','globeadmin','2020-08-25 11:30:07','globeadmin'),('5e85b14b340bae8','5e85a2a072783b3',NULL,NULL,'1',10,NULL,'user_name',50,10,'LMS Open eClass','Όνομα Χρήστη : ','text',160,79,250,45,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<a href=\'asc_template.xml\'>Λήψη</a>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2020-04-02 12:32:59','globeadmin','2020-04-02 22:14:07','globeadmin','2020-08-25 11:30:07','globeadmin'),('5e85b16a1865f9c','5e85a2a072783b3',NULL,NULL,'1',10,NULL,'db_name',40,10,'LMS Open eClass','Όνομα Βάσης Δεδομένων : ','text',114,16,250,45,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<a href=\'asc_template.xml\'>Λήψη</a>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2020-04-02 12:33:30','globeadmin','2020-04-02 22:14:07','globeadmin','2020-08-25 11:30:07','globeadmin'),('5e85b1d175ef3e1','5e85a2a072783b3',NULL,NULL,'1',10,NULL,'user_password',60,10,'LMS Open eClass','Κωδικός Χρήστη : ','text',160,451,250,45,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<a href=\'asc_template.xml\'>Λήψη</a>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'password',NULL,'',0,0,'2020-04-02 12:35:13','globeadmin','2020-04-02 22:14:07','globeadmin','2020-08-25 11:30:07','globeadmin'),('5e85b2af3452fbf','5e85a2a072783b3',NULL,NULL,'1',10,NULL,'check_db_btn',70,10,'LMS Open eClass','Σύνδεση','button',213,39,120,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<a href=\'asc_template.xml\'>Λήψη</a>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'password',NULL,'',0,0,'2020-04-02 12:38:55','globeadmin','2020-04-05 13:00:41','globeadmin','2020-08-25 11:30:07','globeadmin'),('5e85b364b8971ef','5e85a2a072783b3',NULL,NULL,'1',10,NULL,'server_port',30,10,'LMS Open eClass','Θύρα : ','text',68,514,80,45,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<a href=\'asc_template.xml\'>Λήψη</a>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2020-04-02 12:41:56','globeadmin','2020-04-02 22:14:07','globeadmin','2020-08-25 11:30:07','globeadmin'),('5e85b488ca0ae38','5e85a2a072783b3',NULL,NULL,'1',10,NULL,'check_label',80,10,'LMS Open eClass',NULL,'words',220,176,650,45,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<a href=\'asc_template.xml\'>Λήψη</a>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2020-04-02 12:46:48','globeadmin','2020-04-02 22:14:07','globeadmin','2020-08-25 11:30:07','globeadmin'),('5e85b547937f250','5e85a2a072783b3',NULL,NULL,'1',10,NULL,'hr1',90,10,'LMS Open eClass',NULL,'html',504,10,920,10,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<hr style=\"width: 100%; height: 0px; background-color:#b04b00; color:#b0b0b0;border: 1px solid;\">','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2020-04-02 12:49:59','globeadmin','2020-04-02 22:13:40','globeadmin','2020-08-25 11:30:07','globeadmin'),('5e85b5c1a87b069','5e85a2a072783b3',NULL,NULL,'1',10,NULL,'hr2',140,10,'LMS Open eClass',NULL,'html',631,10,920,10,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<hr style=\"width: 100%; height: 0px; background-color:#b04b00; color:#b0b0b0;border: 1px solid;\">','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2020-04-02 12:52:01','globeadmin','2020-04-02 22:13:06','globeadmin','2020-08-25 11:30:07','globeadmin'),('5e85b5cbe29de0c','5e85a2a072783b3',NULL,NULL,'1',10,NULL,'hr3',180,10,'LMS Open eClass',NULL,'html',761,10,920,10,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<hr style=\"width: 100%; height: 0px; background-color:#b04b00; color:#b0b0b0;border: 1px solid;\">','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2020-04-02 12:52:12','globeadmin','2020-04-02 22:13:06','globeadmin','2020-08-25 11:30:07','globeadmin'),('5e85b6637aab9b6','5e85a2a072783b3',NULL,NULL,'1',10,NULL,'teacher_label',100,10,'LMS Open eClass','Αποστολή Καθηγητών :','words',525,13,850,45,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<a href=\'asc_template.xml\'>Λήψη</a>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2020-04-02 12:54:43','globeadmin','2020-04-02 22:13:06','globeadmin','2020-08-25 11:30:07','globeadmin'),('5e85b67a728826f','5e85a2a072783b3',NULL,NULL,'1',10,NULL,'lesson_label',190,10,'LMS Open eClass','Αποστολή Διδασκαλιών και Κατανομής :','words',786,13,850,45,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<a href=\'asc_template.xml\'>Λήψη</a>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2020-04-02 12:55:06','globeadmin','2020-04-02 22:13:06','globeadmin','2020-08-25 11:30:07','globeadmin'),('5e85b6f445115cb','5e85a2a072783b3',NULL,NULL,'1',10,NULL,'student_label',150,10,'LMS Open eClass','Αποστολή Μαθητών:','words',651,13,850,45,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<a href=\'asc_template.xml\'>Λήψη</a>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2020-04-02 12:57:08','globeadmin','2020-04-02 22:13:06','globeadmin','2020-08-25 11:30:07','globeadmin'),('5e85bd02a820251','5e85a2a072783b3',NULL,NULL,'1',10,NULL,'teacher_id',120,10,'LMS Open eClass','Καθηγητές : ','listbox',558,20,450,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select  id,\n        concat(if(surname is null,\'\',concat(surname,\' \')), IFNULL(name,\'\')) as teacher_full_name\nfrom teacher\norder by teacher_full_name',NULL,'','','SELECT  id,\n        concat(if(surname is null,\'\',concat(surname,\' \')), IFNULL(name,\'\'),\' (\',zzzsys_user.sus_login_name,\')\') as teacher_full_name\nFROM teacher\nINNER JOIN zzzsys_user ON teacher.user_id=zzzsys_user.zzzsys_user_id\nORDER BY teacher_full_name',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2020-04-02 13:22:58','globeadmin','2020-04-02 22:13:06','globeadmin','2020-08-25 11:30:07','globeadmin'),('5e85c1bd73f2a6d','5e85a2a072783b3',NULL,NULL,'1',10,NULL,'student_id',160,10,'LMS Open eClass','Μαθητές : ','listbox',688,32,450,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select distinct student.id, concat(ifNULL(grade.short_name,\'\'),\' - \',student.surname,\' \',student.name,\' \',student.fathers_name) \nfrom student\nleft join grade on grade.id = student.grade_id\nleft join (    select distinct student_id as s_id\n                            from student_class\n                            inner join card ON card.class_id=student_class.class_id\n                            where\n                                card.valid_from=(select max(start_date) from timetable) and   \n                                card.teacher_id=\'#RECORD_ID#\') as s ON s.s_id = student.id\nwhere\n        \'#nu_user_group#\'=\'globeadmin\' OR \n        \'#nu_user_group#\'=\'Administrators\' OR \n        \'#nu_user_group#\'=\'Managers\' OR \n        \'#nu_user_group#\'=\'AssistManagers\' OR\n        \'#nu_user_group#\'=\'Secretaries\' OR\n        s.s_id is not null OR\n        student.teacher_id = \'#RECORD_ID#\'\norder by student.grade_id,student.surname,student.name,student.fathers_name',NULL,'','','SELECT distinct student.id, concat(ifNULL(grade.short_name,\'\'),\' - \',student.surname,\' \',student.name,\' \',student.fathers_name,\' (\',zzzsys_user.sus_login_name,\')\') \nFROM student\nLEFT JOIN grade ON grade.id = student.grade_id\nINNER JOIN zzzsys_user ON student.user_id=zzzsys_user.zzzsys_user_id\nORDER BY student.grade_id,student.surname,student.name,student.fathers_name',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2020-04-02 13:43:09','globeadmin','2020-04-02 22:13:06','globeadmin','2020-08-25 11:30:07','globeadmin'),('5e85cf766d277cf','5e85a2a072783b3',NULL,NULL,'1',10,NULL,'lesson_id',200,10,'LMS Open eClass','Διδασκαλίες : ','listbox',820,19,800,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select distinct student.id, concat(ifNULL(grade.short_name,\'\'),\' - \',student.surname,\' \',student.name,\' \',student.fathers_name) \nfrom student\nleft join grade on grade.id = student.grade_id\nleft join (    select distinct student_id as s_id\n                            from student_class\n                            inner join card ON card.class_id=student_class.class_id\n                            where\n                                card.valid_from=(select max(start_date) from timetable) and   \n                                card.teacher_id=\'#RECORD_ID#\') as s ON s.s_id = student.id\nwhere\n        \'#nu_user_group#\'=\'globeadmin\' OR \n        \'#nu_user_group#\'=\'Administrators\' OR \n        \'#nu_user_group#\'=\'Managers\' OR \n        \'#nu_user_group#\'=\'AssistManagers\' OR\n        \'#nu_user_group#\'=\'Secretaries\' OR\n        s.s_id is not null OR\n        student.teacher_id = \'#RECORD_ID#\'\norder by student.grade_id,student.surname,student.name,student.fathers_name',NULL,'','','SELECT CONCAT(subject.id,\'-\',class.id), CONCAT(subject.short_name,if(subject.name IS NULL,\'\',CONCAT(\' (\',subject.name,if(subject_type.short_name IS NULL,\'\',CONCAT(\' \',subject_type.short_name)),\')\')),\' - \',class.short_name,\' - \',GROUP_CONCAT(DISTINCT teacher.short_name SEPARATOR \', \')) AS full_name\nFROM card\nINNER JOIN subject 			on card.subject_id = subject.id \nINNER JOIN teacher 			on card.teacher_id = teacher.id  \nINNER JOIN class 			on card.class_id = class.id	\nleft  JOIN subject_type 	on subject.subject_type_id = subject_type.id \nWHERE card.valid_from = (SELECT max(timetable.start_date) FROM timetable)\nGROUP BY subject.id,class.id\nORDER BY \nCONCAT(subject.short_name,if(subject.name IS NULL,\'\',CONCAT(\' (\',subject.name,if(subject_type.short_name IS NULL,\'\',CONCAT(\' \',subject_type.short_name)),\')\')),\' - \',\' - \',GROUP_CONCAT(DISTINCT teacher.short_name SEPARATOR \', \'),class.short_name)\n',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2020-04-02 14:41:42','globeadmin','2020-08-25 09:49:10','globeadmin','2020-08-25 11:30:08','globeadmin'),('5e85e3226374d30','5e85a2a072783b3',NULL,NULL,'1',10,NULL,'merge_chk',210,10,'LMS Open eClass','Συγχώνευση τμημάτων για το ίδιο μάθημα με τον ίδιο διδάσκοντα :','checkbox',866,21,40,40,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<a href=\'asc_template.xml\'>Λήψη</a>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2020-04-02 16:05:38','globeadmin','2020-04-02 22:13:06','globeadmin','2020-08-25 11:30:08','globeadmin'),('5e85e651a3a4fe2','5e85a2a072783b3',NULL,NULL,'1',10,NULL,'merge_label',220,10,'LMS Open eClass','Προσοχή, με την επιλογή αυτή όλοι οι μαθητές όλων των τμημάτων θα μπουν μαζί στο ίδιο μάθημα με τον καθηγητή που τους διδάσκει το μάθημα αυτό','words',899,16,930,40,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<a href=\'asc_template.xml\'>Λήψη</a>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2020-04-02 16:19:13','globeadmin','2020-04-02 22:13:06','globeadmin','2020-08-25 11:30:08','globeadmin'),('5e86099653e5c9e','5e85a2a072783b3',NULL,NULL,'1',10,NULL,'teacher_send_btn',130,10,'LMS Open eClass','Αποστολή Καθηγητών','button',554,589,180,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<a href=\'asc_template.xml\'>Λήψη</a>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'password',NULL,'',0,0,'2020-04-02 18:49:42','globeadmin','2020-04-02 22:13:06','globeadmin','2020-08-25 11:30:07','globeadmin'),('5e8609a4cf18fb5','5e85a2a072783b3',NULL,NULL,'1',10,NULL,'student_send_btn',170,10,'LMS Open eClass','Αποστολή Μαθητών','button',683,587,180,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<a href=\'asc_template.xml\'>Λήψη</a>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'password',NULL,'',0,0,'2020-04-02 18:49:56','globeadmin','2020-04-02 18:53:13','globeadmin','2020-08-25 11:30:07','globeadmin'),('5e8609b2a822a5d','5e85a2a072783b3',NULL,NULL,'1',10,NULL,'lesson_send_btn',240,10,'LMS Open eClass','Αποστολή Διδασκαλιών','button',1033,13,180,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<a href=\'asc_template.xml\'>Λήψη</a>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'password',NULL,'',0,0,'2020-04-02 18:50:10','globeadmin','2020-04-02 22:13:06','globeadmin','2020-08-25 11:30:08','globeadmin'),('5e876c09b82a42f','5e85a2a072783b3',NULL,NULL,'1',10,NULL,'category_label',230,10,'LMS Open eClass','Κατάλογος Κατηγοριών  :','words',268,40,160,45,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<a href=\'asc_template.xml\'>Λήψη</a>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2020-04-03 20:02:01','globeadmin','2020-04-04 10:49:15','globeadmin','2020-08-25 11:30:08','globeadmin'),('5e87731b8f91cfd','5e85a2a072783b3',NULL,NULL,'1',10,NULL,'hierarchy_iframe',240,10,'LMS Open eClass',NULL,'iframe',264,198,700,150,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<a href=\'asc_template.xml\'>Λήψη</a>','54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2020-04-03 20:32:11','globeadmin','2020-08-23 13:17:42','globeadmin','2020-08-25 11:30:08','globeadmin'),('5e87721c4558a90','5e85a2a072783b3',NULL,NULL,'0',10,NULL,'refresh_hierarchy_img',250,10,'LMS Open eClass',NULL,'html',268,13,19,19,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"this.style.cursor=\'pointer\';\"\n                            onmouseout=\"this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=17 height=17 id=\'img_remove_attachment\' src=\'images/reset_pass.png\' title=\'Λήψη Κατηγοριών\'/>\n        </td>\n    </tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2020-04-03 20:27:56','globeadmin','2020-04-03 20:27:56','globeadmin','2020-08-25 11:30:08','globeadmin'),('5f3a678431b2328','5e85a2a072783b3',NULL,NULL,'1',10,NULL,'create_user_chk',230,10,'LMS Open eClass','Αποστολή και των σχετιζόμενων με τη διδασκαλία καθηγητών-μαθητών αν δεν υπάρχουν ήδη στο Open eClass:','checkbox',933,23,40,40,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<a href=\'asc_template.xml\'>Λήψη</a>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2020-08-17 14:18:28','globeadmin','2020-08-23 13:45:30','globeadmin','2020-08-25 11:30:08','globeadmin'),('5f3a6899d7db995','5e85a2a072783b3',NULL,NULL,'1',10,NULL,'create_users_label',260,10,'LMS Open eClass','Προσοχή, με την επιλογή αυτή όλοι οι καθηγητές και μαθητές που συμμετέχουν στις διδασκαλίες αν δεν υπάρχουν ήδη στο Open eClass θα αποσταλούν ταυτοχρόνως','words',966,16,930,40,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<a href=\'asc_template.xml\'>Λήψη</a>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2020-08-17 14:23:05','globeadmin','2020-08-23 13:46:49','globeadmin','2020-08-25 11:30:08','globeadmin'),('5f42410b15d4714','5e85a2a072783b3',NULL,NULL,'1',10,NULL,'server_folder',110,10,'LMS Open eClass','Φάκελος των αρχείων του Open eClassστον εξυπηρετητή :','text',455,20,400,45,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<a href=\'asc_template.xml\'>Λήψη</a>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2020-08-23 13:12:27','globeadmin','2020-08-23 13:45:13','globeadmin','2020-08-25 11:30:07','globeadmin'),('5f548a10690cc27','5a54c08c836c142',NULL,NULL,'1',10,NULL,'allow_parents_to_edit',120,10,'Παράμετροι','Να επιτρέπεται οι Γονείς να τροποποιούν τα στοιχεία επικοινωνίας :','checkbox',393,195,20,0,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2020-09-06 10:04:48','globeadmin','2020-09-06 10:04:48','globeadmin','2022-09-24 23:22:27','globeadmin'),('5f548e0625aef7a','54a6fde1ab6eb6d',NULL,NULL,'1',10,'SELECT \'0\'','allow_parents_to_edit_disp',180,20,'Στοιχεία Επικοινωνίας','Edit :','display',13,980,10,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','SELECT allow_parents_to_edit FROM school',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2020-09-06 10:21:42','globeadmin','2020-09-06 10:22:59','globeadmin','2021-09-06 20:12:24','globeadmin'),('5f5dfa67dac2d5b','547372d029461f4',NULL,NULL,'1',10,NULL,'accept_appointments',10,40,'Ηλεκτρονικά Ραντεβού','Δέχεται ο καθηγητής νέα ηλεκτρονικά ραντεβού :','checkbox',15,21,50,0,'l','0','0','select \'0\'','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2020-09-13 13:54:32','globeadmin','2020-09-22 22:44:25','globeadmin','2021-01-26 20:15:05','globeadmin'),('5f5dfb0f02d2e05','547372d029461f4',NULL,NULL,'1',10,NULL,'appointment_duration',20,40,'Ηλεκτρονικά Ραντεβού','Διάρκεια του κάθε ραντεβού (σε λεπτά) :','text',55,46,40,0,'r','0','0','select \'10\'','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2020-09-13 13:57:19','globeadmin','2020-09-22 22:44:25','globeadmin','2021-01-26 20:15:05','globeadmin'),('5f6710a5197da1d','547372d029461f4',NULL,NULL,'1',10,NULL,'appointment_from',50,40,'Ηλεκτρονικά Ραντεβού','Προγραμματισμένα ραντεβού από :','text',322,10,80,0,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',100,250,'2020-09-20 11:19:49','globeadmin','2020-09-22 22:39:52','globeadmin','2021-01-26 20:15:05','globeadmin'),('5f5fc0a4f39901a','5f5fc06e94c4759',NULL,NULL,'1',10,NULL,'day_id',10,10,'Διαθεσιμότητα Καθηγητή','Ημέρα :','dropdown',30,44,102,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'SELECT id,name from day',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2020-09-14 22:12:37','globeadmin','2020-09-14 22:59:08','globeadmin','2020-09-24 14:34:15','globeadmin'),('5f5dfd2750f2ea0','547372d029461f4',NULL,NULL,'1',10,NULL,'appointment_label1',30,40,'Ηλεκτρονικά Ραντεβού','Διαθεσιμότητα καθηγητή για μελλοντικά ραντεβού :','words',95,16,500,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2020-09-13 14:06:15','globeadmin','2020-09-22 22:44:25','globeadmin','2021-01-26 20:15:05','globeadmin'),('5f67121f7d9f5cd','547372d029461f4',NULL,NULL,'1',10,NULL,'appointment_to',60,40,'Ηλεκτρονικά Ραντεβού','έως : ','text',322,310,80,0,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',100,250,'2020-09-20 11:26:07','globeadmin','2020-09-22 22:39:27','globeadmin','2021-01-26 20:15:05','globeadmin'),('5f5e696ebe7a114','547372d029461f4',NULL,NULL,'1',10,NULL,'availability_iframe',40,40,'Ηλεκτρονικά Ραντεβού',NULL,'iframe',118,5,930,185,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'5f5e56bb6d78a38','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2020-09-13 21:48:14','globeadmin','2020-09-22 22:40:17','globeadmin','2021-01-26 20:15:05','globeadmin'),('5f5e2bcd9286c1a','547372d029461f4',NULL,NULL,'1',10,NULL,'appointments_iframe',90,40,'Ηλεκτρονικά Ραντεβού',NULL,'iframe',389,7,930,240,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'5f5e03747627db2','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2020-09-13 17:25:17','globeadmin','2020-09-22 22:36:55','globeadmin','2021-01-26 20:15:05','globeadmin'),('5f5fc8fa238b9b9','5f5fc06e94c4759',NULL,NULL,'1',10,NULL,'start_time',20,10,'Διαθεσιμότητα Καθηγητή','Από :','text',79,56,70,0,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2020-09-14 22:48:10','globeadmin','2020-09-16 14:14:55','globeadmin','2020-09-24 14:34:15','globeadmin'),('5f5fc9296b31c19','5f5fc06e94c4759',NULL,NULL,'1',10,NULL,'period_start',30,10,'Διαθεσιμότητα Καθηγητή',NULL,'dropdown',79,170,20,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select start_time,concat (name,\' - \',start_time)\nfrom period\norder by start_time',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2020-09-14 22:48:57','globeadmin','2020-09-14 22:48:57','globeadmin','2020-09-24 14:34:15','globeadmin'),('5f5fc96e01e73b7','5f5fc06e94c4759',NULL,NULL,'1',10,NULL,'label1',40,10,'Διαθεσιμότητα Καθηγητή','Σημείο συναντήσεων (για εξ αποστάσεως εισάγετε το URL π.χ. https://minedu-gov-gr.webex ...) :','words',175,1,560,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2020-09-14 22:50:06','globeadmin','2020-09-24 14:35:15','globeadmin','2020-09-24 14:35:15','globeadmin'),('5f5fc994d09a4ab','5f5fc06e94c4759',NULL,NULL,'1',10,NULL,'period_end',60,10,'Διαθεσιμότητα Καθηγητή',NULL,'dropdown',127,170,20,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select end_time,concat (name,\' - \',end_time)\nfrom period\norder by start_time',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2020-09-14 22:50:44','globeadmin','2020-09-15 14:29:13','globeadmin','2020-09-24 14:34:15','globeadmin'),('5f5fcdd172e9f8c','5f5fc06e94c4759',NULL,NULL,'1',10,NULL,'end_time',50,10,'Διαθεσιμότητα Καθηγητή','Έως :','text',127,55,70,0,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2020-09-14 23:08:49','globeadmin','2020-09-16 14:15:09','globeadmin','2020-09-24 14:34:15','globeadmin'),('5f5fceaf704fb5d','5f5fc06e94c4759',NULL,NULL,'1',10,NULL,'location',70,10,'Διαθεσιμότητα Καθηγητή',NULL,'text',207,31,500,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2020-09-14 23:12:31','globeadmin','2020-09-14 23:12:31','globeadmin','2020-09-24 14:34:15','globeadmin'),('5f6082f55f97731','5f5fc06e94c4759',NULL,NULL,'1',10,'select \'0\'','teacher_id',80,10,'Διαθεσιμότητα Καθηγητή','Καθηγητής :','text',238,36,40,0,'r','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2020-09-15 12:01:41','globeadmin','2020-09-15 12:04:50','globeadmin','2020-09-24 14:34:15','globeadmin'),('5f609ac070dc411','5f609a0c726f729',NULL,NULL,'1',10,NULL,'teacher_id',10,10,'Αναζήτηση διαθέσιμων ραντεβού','Καθηγητής :','listbox',21,11,400,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'SELECT distinct\n    teacher.id,\n    concat(IFNULL(teacher.surname,\'\'),IF(teacher.surname IS NULL OR teacher.name IS NULL,\'\',\' \'),IFNULL(teacher.name,\'\')) AS teacher_full_name\nFROM    (\n                    select \n	                    card.id AS id,\n	                    card.valid_from AS valid_from,\n	                    card.subject_id AS subject_id,\n	                    card.teacher_id AS teacher_id,\n	                    card.class_id AS class_id,\n	                    card.classroom_id AS classroom_id,\n	                    card.day_id AS day_id,\n	                    card.period_id AS period_id \n                        from card \n                        where card.valid_from =(select max(timetable.start_date) from timetable where (timetable.start_date <= curdate()))\n                    ) \n            AS active_card\nINNER JOIN teacher ON (teacher.id=active_card.teacher_id OR \n                        teacher.id=\'#teacher_id#\' OR \n                        teacher.id=\'#advisor_id#\'OR\n                        teacher.user_id IN (SELECT zzzsys_user_id FROM zzzsys_user WHERE sus_zzzsys_user_group_id IN(\'547de466910d843\')))\nWHERE   active_card.class_id in (select distinct class_id from student_class where student_id=\'#RECORD_ID#\') and\n        teacher.accept_appointments=1 AND\n        EXISTS(SELECT * FROM appointment_teacher_availability WHERE appointment_teacher_availability.teacher_id=teacher.id)\nORDER BY teacher_full_name\n',NULL,'','','SELECT distinct\n    teacher.id,\n    concat(IFNULL(teacher.surname,\'\'),IF(teacher.surname IS NULL OR teacher.name IS NULL,\'\',\' \'),IFNULL(teacher.name,\'\')) AS teacher_full_name\nFROM    (\n                    select \n	                    card.id AS id,\n	                    card.valid_from AS valid_from,\n	                    card.subject_id AS subject_id,\n	                    card.teacher_id AS teacher_id,\n	                    card.class_id AS class_id,\n	                    card.classroom_id AS classroom_id,\n	                    card.day_id AS day_id,\n	                    card.period_id AS period_id \n                        from card \n                        where card.valid_from =(select max(timetable.start_date) from timetable where (timetable.start_date <= curdate()))\n                    ) \n            AS active_card\nINNER JOIN teacher ON (teacher.id=active_card.teacher_id OR \n                        teacher.id=\'#teacher_id#\' OR \n                        teacher.id=\'#advisor_id#\'OR\n                        teacher.user_id IN (SELECT zzzsys_user_id FROM zzzsys_user WHERE sus_zzzsys_user_group_id IN(\'547de466910d843\')))\nWHERE   active_card.class_id in (select distinct class_id from student_class where student_id=\'#RECORD_ID#\') and\n        teacher.accept_appointments=1 AND\n        EXISTS(SELECT * FROM appointment_teacher_availability WHERE appointment_teacher_availability.teacher_id=teacher.id)\nORDER BY teacher_full_name\n',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2020-09-15 13:43:12','globeadmin','2020-09-24 13:02:00','globeadmin','2020-12-21 21:11:59','globeadmin'),('5f60a87b2aab771','5f609a0c726f729',NULL,NULL,'1',10,NULL,'search_iframe',50,10,'Αναζήτηση διαθέσιμων ραντεβού',NULL,'iframe',145,15,850,310,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',100,250,'2020-09-15 14:41:47','globeadmin','2020-09-17 19:03:16','globeadmin','2020-12-21 21:12:00','globeadmin'),('5f60a2bb0def0e3','5f609a0c726f729',NULL,NULL,'1',10,NULL,'to_date',30,10,'Αναζήτηση διαθέσιμων ραντεβού','Έως :','text',63,190,80,0,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',100,250,'2020-09-15 14:17:15','globeadmin','2020-09-15 14:21:37','globeadmin','2020-12-21 21:11:59','globeadmin'),('5f60a3222e3cfc5','5f609a0c726f729',NULL,NULL,'1',10,NULL,'search_btn',40,10,'Αναζήτηση διαθέσιμων ραντεβού','Αναζήτηση','button',104,81,150,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',100,250,'2020-09-15 14:18:58','globeadmin','2020-09-15 14:21:37','globeadmin','2020-12-21 21:12:16','globeadmin'),('5f6712b3cc23204','547372d029461f4',NULL,NULL,'1',10,NULL,'appointment_show_btn',80,40,'Ηλεκτρονικά Ραντεβού','Εμφάνιση','button',352,29,120,32,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',100,250,'2020-09-20 11:28:35','globeadmin','2020-09-22 22:38:47','globeadmin','2021-01-26 20:15:05','globeadmin'),('5f609e76a439711','5f609a0c726f729',NULL,NULL,'1',10,NULL,'from_date',20,10,'Αναζήτηση διαθέσιμων ραντεβού','Από :','text',63,49,80,0,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',100,250,'2020-09-15 13:59:02','globeadmin','2020-09-15 14:21:37','globeadmin','2020-12-21 21:11:59','globeadmin'),('5f6718365b246a9','547372d029461f4',NULL,NULL,'1',10,'select \'0\'','date_from_disp',100,40,'Ηλεκτρονικά Ραντεβού','2 εβδομάδες πρίν :','display',15,747,80,0,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','SELECT DATE_FORMAT(IF((DATE_ADD(CURDATE(), INTERVAL -2 WEEK))>school_year.start_date, (DATE_ADD(CURDATE(), INTERVAL -2 WEEK)), school_year.start_date),\'%d-%m-%Y\')\nFROM school\nINNER JOIN school_year ON school.school_year_id = school_year.id\nWHERE school.id=1',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',100,250,'2020-09-20 11:52:06','globeadmin','2020-09-22 22:37:55','globeadmin','2021-01-26 20:15:05','globeadmin'),('5f67195837e83e4','547372d029461f4',NULL,NULL,'1',10,'select \'0\'','date_to_disp',110,40,'Ηλεκτρονικά Ραντεβού','2 εβδομάδες μετά:','display',50,750,80,0,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','SELECT DATE_FORMAT(IF((DATE_ADD(CURDATE(), INTERVAL 2 WEEK))<school_year.end_date, (DATE_ADD(CURDATE(), INTERVAL 2 WEEK)), school_year.end_date),\'%d-%m-%Y\')\nFROM school\nINNER JOIN school_year ON school.school_year_id = school_year.id\nWHERE school.id=1',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',100,250,'2020-09-20 11:56:56','globeadmin','2020-09-22 22:37:35','globeadmin','2021-01-26 20:15:05','globeadmin'),('5f683ed013157dd','547372d029461f4',NULL,NULL,'1',10,NULL,'appointment_student_id',70,40,'Ηλεκτρονικά Ραντεβού','Γονέα Μαθητή : ','listbox',322,450,350,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select distinct student.id, concat(ifNULL(grade.short_name,\'\'),\' - \',student.surname,\' \',student.name,\' \',student.fathers_name) \nfrom student\nleft join grade on grade.id = student.grade_id\nleft join (    select distinct student_id as s_id\n                            from student_class\n                            inner join card ON card.class_id=student_class.class_id\n                            where\n                                card.valid_from=(select max(start_date) from timetable) and   \n                                card.teacher_id=\'#RECORD_ID#\') as s ON s.s_id = student.id\nwhere\n        \'#nu_user_group#\'=\'globeadmin\' OR \n        \'#nu_user_group#\'=\'Administrators\' OR \n        \'#nu_user_group#\'=\'Managers\' OR \n        \'#nu_user_group#\'=\'AssistManagers\' OR\n        \'#nu_user_group#\'=\'Secretaries\' OR\n        s.s_id is not null OR\n        student.teacher_id = \'#RECORD_ID#\'\norder by student.grade_id,student.surname,student.name,student.fathers_name',NULL,'','','select distinct student.id, concat(ifNULL(grade.short_name,\'\'),\' - \',student.surname,\' \',student.name,\' \',student.fathers_name) \nfrom student\nleft join grade on grade.id = student.grade_id\nleft join (    select distinct student_id as s_id\n                            from student_class\n                            inner join card ON card.class_id=student_class.class_id\n                            where\n                                card.valid_from=(select max(start_date) from timetable) and   \n                                card.teacher_id=\'#RECORD_ID#\') as s ON s.s_id = student.id\nwhere\n        \'547de466910d843\' = (SELECT sus_zzzsys_user_group_id FROM zzzsys_user WHERE zzzsys_user_id= \'#user_id#\') OR \n        s.s_id is not null OR\n        student.teacher_id = \'#RECORD_ID#\' OR\n        student.advisor_id = \'#RECORD_ID#\'\norder by student.grade_id,student.surname,student.name,student.fathers_name',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2020-09-21 08:49:04','globeadmin','2020-09-22 22:36:25','globeadmin','2021-01-26 20:15:05','globeadmin'),('5f68d311755917f','5f68d148d9f3222',NULL,NULL,'1',10,'select \'0\'','comments',10,10,'Σχόλια Ραντεβού',NULL,'textarea',0,0,100,100,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select \'1\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2020-09-21 19:21:37','globeadmin','2020-09-21 19:21:37','globeadmin','2020-09-23 10:04:26','globeadmin'),('5f68d362ad64a16','5f68d148d9f3222',NULL,NULL,'1',10,NULL,'tinymce_editor',20,10,'Σχόλια Ραντεβού',NULL,'iframe',1,1,870,370,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'56cc9f04b82528e','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2020-09-21 19:22:58','globeadmin','2020-09-21 19:27:40','globeadmin','2020-09-23 10:04:26','globeadmin'),('5f6a5445c5b8d3f','5f6a50545e4de79',NULL,NULL,'1',10,NULL,'accept_appointments',10,10,'Ηλεκτρονικά Ραντεβού Καθηγητή','Δέχεται ο καθηγητής νέα ηλεκτρονικά ραντεβού :','checkbox',15,30,50,0,'l','0','0','select \'0\'','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2020-09-22 22:45:09','globeadmin','2020-09-23 12:04:19','globeadmin','2020-09-24 10:05:43','globeadmin'),('5f6a5468a98cff4','5f6a50545e4de79',NULL,NULL,'1',10,NULL,'appointment_duration',20,10,'Ηλεκτρονικά Ραντεβού Καθηγητή','Διάρκεια του κάθε ραντεβού (σε λεπτά) :','text',55,55,40,0,'r','0','0','select \'10\'','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2020-09-22 22:45:44','globeadmin','2020-09-23 12:04:19','globeadmin','2020-09-24 10:05:43','globeadmin'),('5f6a54930272c55','5f6a50545e4de79',NULL,NULL,'1',10,NULL,'appointment_label1',30,10,'Ηλεκτρονικά Ραντεβού Καθηγητή','Διαθεσιμότητα καθηγητή για μελλοντικά ραντεβού :','words',95,25,500,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2020-09-22 22:46:27','globeadmin','2020-09-23 12:04:19','globeadmin','2020-09-24 10:05:43','globeadmin'),('5f6a54b4c35edba','5f6a50545e4de79',NULL,NULL,'1',10,NULL,'appointment_from',50,10,'Ηλεκτρονικά Ραντεβού Καθηγητή','Προγραμματισμένα ραντεβού από :','text',322,32,80,0,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',100,250,'2020-09-22 22:47:00','globeadmin','2020-09-23 12:04:19','globeadmin','2020-09-24 10:05:43','globeadmin'),('5f6a54d041c872a','5f6a50545e4de79',NULL,NULL,'1',10,NULL,'appointment_to',70,10,'Ηλεκτρονικά Ραντεβού Καθηγητή','έως : ','text',322,337,80,0,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',100,250,'2020-09-22 22:47:28','globeadmin','2020-09-23 12:04:19','globeadmin','2020-09-24 10:05:44','globeadmin'),('5f6a54e906ab6ce','5f6a50545e4de79',NULL,NULL,'1',10,NULL,'appointment_student_id',70,10,'Ηλεκτρονικά Ραντεβού Καθηγητή','Γονέα Μαθητή : ','listbox',359,32,350,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select distinct student.id, concat(ifNULL(grade.short_name,\'\'),\' - \',student.surname,\' \',student.name,\' \',student.fathers_name) \nfrom student\nleft join grade on grade.id = student.grade_id\nleft join (    select distinct student_id as s_id\n                            from student_class\n                            inner join card ON card.class_id=student_class.class_id\n                            where\n                                card.valid_from=(select max(start_date) from timetable) and   \n                                card.teacher_id=\'#RECORD_ID#\') as s ON s.s_id = student.id\nwhere\n        \'#nu_user_group#\'=\'globeadmin\' OR \n        \'#nu_user_group#\'=\'Administrators\' OR \n        \'#nu_user_group#\'=\'Managers\' OR \n        \'#nu_user_group#\'=\'AssistManagers\' OR\n        \'#nu_user_group#\'=\'Secretaries\' OR\n        s.s_id is not null OR\n        student.teacher_id = \'#RECORD_ID#\'\norder by student.grade_id,student.surname,student.name,student.fathers_name',NULL,'','','select distinct student.id, concat(ifNULL(grade.short_name,\'\'),\' - \',student.surname,\' \',student.name,\' \',student.fathers_name) \nfrom student\nleft join grade on grade.id = student.grade_id\nleft join (    select distinct student_id as s_id\n                            from student_class\n                            inner join card ON card.class_id=student_class.class_id\n                            where\n                                card.valid_from=(select max(start_date) from timetable) and   \n                                card.teacher_id=\'#RECORD_ID#\') as s ON s.s_id = student.id\nwhere\n        \'547de466910d843\' = (SELECT sus_zzzsys_user_group_id FROM zzzsys_user WHERE zzzsys_user_id= \'#user_id#\') OR \n        s.s_id is not null OR\n        student.teacher_id = \'#RECORD_ID#\' OR\n        student.advisor_id = \'#RECORD_ID#\'\norder by student.grade_id,student.surname,student.name,student.fathers_name',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2020-09-22 22:47:53','globeadmin','2020-09-23 12:04:19','globeadmin','2020-09-24 10:05:44','globeadmin'),('5f6a550d9f6ab84','5f6a50545e4de79',NULL,NULL,'1',10,NULL,'appointment_show_btn',80,10,'Ηλεκτρονικά Ραντεβού Καθηγητή','Εμφάνιση','button',400,43,120,32,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',100,250,'2020-09-22 22:48:29','globeadmin','2020-09-23 12:04:19','globeadmin','2020-09-24 10:05:44','globeadmin'),('5f6a5529dffb62f','5f6a50545e4de79',NULL,NULL,'1',10,'select \'0\'','date_from_disp',100,10,'Ηλεκτρονικά Ραντεβού Καθηγητή','2 εβδομάδες πρίν :','display',15,791,80,0,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','SELECT DATE_FORMAT(IF((DATE_ADD(CURDATE(), INTERVAL -2 WEEK))>school_year.start_date, (DATE_ADD(CURDATE(), INTERVAL -2 WEEK)), school_year.start_date),\'%d-%m-%Y\')\nFROM school\nINNER JOIN school_year ON school.school_year_id = school_year.id\nWHERE school.id=1',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',100,250,'2020-09-22 22:48:57','globeadmin','2020-09-23 12:04:19','globeadmin','2020-09-24 10:05:44','globeadmin'),('5f6a5545444b49b','5f6a50545e4de79',NULL,NULL,'1',10,'select \'0\'','date_to_disp',110,10,'Ηλεκτρονικά Ραντεβού Καθηγητή','2 εβδομάδες μετά:','display',50,794,80,0,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','SELECT DATE_FORMAT(IF((DATE_ADD(CURDATE(), INTERVAL 2 WEEK))<school_year.end_date, (DATE_ADD(CURDATE(), INTERVAL 2 WEEK)), school_year.end_date),\'%d-%m-%Y\')\nFROM school\nINNER JOIN school_year ON school.school_year_id = school_year.id\nWHERE school.id=1',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',100,250,'2020-09-22 22:49:25','globeadmin','2020-09-23 12:04:19','globeadmin','2020-09-24 10:05:44','globeadmin'),('5f6a556e8b59f5d','5f6a50545e4de79',NULL,NULL,'1',10,NULL,'availability_iframe',40,10,'Ηλεκτρονικά Ραντεβού Καθηγητή',NULL,'iframe',118,34,960,185,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'5f5e56bb6d78a38','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2020-09-22 22:50:06','globeadmin','2020-09-23 12:04:19','globeadmin','2020-09-24 10:05:43','globeadmin'),('5f6a55ac6d7e822','5f6a50545e4de79',NULL,NULL,'1',10,NULL,'appointments_iframe',90,10,'Ηλεκτρονικά Ραντεβού Καθηγητή',NULL,'iframe',440,34,960,350,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'5f5e03747627db2','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2020-09-22 22:51:08','globeadmin','2020-09-23 12:04:19','globeadmin','2020-09-24 10:05:44','globeadmin'),('5f6afa07338ae2d','5f6a50545e4de79',NULL,NULL,'1',10,'select if(\'#nu_user_group#\' IN (\'Managers\',\'AssistManagers\',\'Administrators\',\'Secretaries\',\'globeadmin\'),\'1\',\'0\') from session_variables where session_id=\'#session_id#\'','teacher_id',40,10,'Ηλεκτρονικά Ραντεβού Καθηγητή','Καθηγητή : ','listbox',321,482,350,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select  id,\n        concat(if(surname is null,\'\',concat(surname,\' \')), IFNULL(name,\'\')) as teacher_full_name\nfrom teacher\norder by teacher_full_name',NULL,'','','select  id,\n        concat(if(surname is null,\'\',concat(surname,\' \')), IFNULL(name,\'\')) as teacher_full_name\nfrom teacher\norder by teacher_full_name',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2020-09-23 10:32:23','globeadmin','2020-09-23 12:04:19','globeadmin','2020-09-24 10:05:43','globeadmin'),('5f6cbec625f52e9','5f6cbe6fd03a211',NULL,NULL,'1',10,NULL,'student_id',10,10,'Μαζική Διαγραφή Λογαριασμών Γονέων','Λογαριασμός Γονέα Μαθητή : ','listbox',18,8,400,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','','select student.id, concat(ifNULL(grade.short_name,\'\'),\' - \',ifnull(student.surname,\'\'),\' \',ifnull(student.name,\'\'),\' \',ifnull(student.fathers_name,\'\')) \nfrom student\nleft join grade on grade.id = student.grade_id\nwhere parent_user_id is not null\norder by student.grade_id,student.surname,student.name,student.fathers_name',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2020-09-24 18:44:06','globeadmin','2020-09-24 18:54:30','globeadmin','2020-09-25 10:42:54','globeadmin'),('5f6ceecbb17d4bc','5f6cee92b5f274a',NULL,NULL,'1',10,NULL,'student_id',10,10,'Μαζική Διαγραφή Λογαριασμών Μαθητών','Λογαριασμός Μαθητή : ','listbox',18,8,400,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','','select student.id, concat(ifNULL(grade.short_name,\'\'),\' - \',ifnull(student.surname,\'\'),\' \',ifnull(student.name,\'\'),\' \',ifnull(student.fathers_name,\'\')) \nfrom student\nleft join grade on grade.id = student.grade_id\nwhere user_id is not null\norder by student.grade_id,student.surname,student.name,student.fathers_name',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2020-09-24 22:08:59','globeadmin','2020-09-24 22:10:35','globeadmin','2020-09-24 22:11:42','globeadmin'),('5f7cd79ed11a744','5f7cd744d8ace2f',NULL,NULL,'1',10,NULL,'absence_date',10,10,'Αναζήτηση','Ημερομηνία :','text',29,50,80,30,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2020-10-06 23:46:23','globeadmin','2020-10-07 00:00:47','globeadmin','2020-10-08 23:43:01','globeadmin'),('5f7cd849ecd0a89','5f7cd744d8ace2f',NULL,NULL,'1',10,'select \'0\'','current_date',30,10,'Αναζήτηση','Εργάσιμη Ημ/νια : ','display',21,972,80,30,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select DATE_FORMAT((CASE WEEKDAY(CURDATE()) \n                             WHEN 5 THEN date(SUBDATE(CURDATE(),1))\n                             WHEN 6 THEN date(SUBDATE(CURDATE(),2)) \n                             ELSE CURDATE()\n                        END),\'%d-%m-%Y\')',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2020-10-06 23:49:14','globeadmin','2020-10-07 00:03:56','globeadmin','2020-10-08 23:43:01','globeadmin'),('5f7cd89243ff40d','5f7cd744d8ace2f',NULL,NULL,'1',10,NULL,'searchbtn',20,10,'Αναζήτηση','Αναζήτηση','button',74,45,160,35,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2020-10-06 23:50:26','globeadmin','2020-10-06 23:50:26','globeadmin','2020-10-08 23:43:01','globeadmin'),('5f7cd8cda30b07f','5f7cd744d8ace2f',NULL,NULL,'1',10,NULL,'search_iframe',60,10,'Αναζήτηση',NULL,'iframe',120,14,950,400,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2020-10-06 23:51:25','globeadmin','2020-10-07 09:31:08','globeadmin','2020-10-08 23:43:01','globeadmin'),('5f7d5ddfc3877c3','5f7cd744d8ace2f',NULL,NULL,'1',10,NULL,'class_id',40,10,'Αναζήτηση','Τμήμα : ','listbox',28,523,170,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','','select class.id,class.short_name \nfrom class\nwhere \n    exists (select new_id from student_class where student_class.class_id=class.id)\norder by class.short_name',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2020-10-07 09:19:11','globeadmin','2020-10-07 09:26:53','globeadmin','2020-10-08 23:43:01','globeadmin'),('5f7d601f8adea24','5f7cd744d8ace2f',NULL,NULL,'1',10,NULL,'grade_id',60,10,'Αναζήτηση','Τάξη : ','listbox',28,266,140,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','','select grade.id,grade.short_name \nfrom grade\norder by grade.short_name',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2020-10-07 09:28:47','globeadmin','2020-10-07 09:28:47','globeadmin','2020-10-08 23:43:01','globeadmin'),('5f8b4fa83b727fa','5f8b4f77ca6b53e',NULL,NULL,'1',10,NULL,'label1',10,10,'Μαζική Αποστολή SMS','Μήνυμα :','words',17,23,120,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from class order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2020-10-17 23:10:16','globeadmin','2020-10-17 23:10:16','globeadmin','2021-03-24 11:19:45','globeadmin'),('5f8b4fc3c75a9e3','5f8b4f77ca6b53e',NULL,NULL,'1',10,NULL,'sms_disp',20,10,'Μαζική Αποστολή SMS','Υπόλοιπο Μηνυμάτων :','display',13,720,60,0,'r','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select IF(\'#sms_limit#\'=\'\',\'UL\',\'#sms_limit#\'-count(*))\nfrom sms\nwhere sender_id=\'#RECORD_ID#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2020-10-17 23:10:43','globeadmin','2020-10-17 23:10:43','globeadmin','2021-03-24 11:19:45','globeadmin'),('5f8b4fde898b62d','5f8b4f77ca6b53e',NULL,NULL,'1',10,NULL,'sms_text',30,10,'Μαζική Αποστολή SMS',NULL,'textarea',40,20,900,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2020-10-17 23:11:10','globeadmin','2020-10-17 23:11:10','globeadmin','2021-03-24 11:19:45','globeadmin'),('5f8b50076fc2f9d','5f8b4f77ca6b53e',NULL,NULL,'1',10,NULL,'num_of_chars_left',40,10,'Μαζική Αποστολή SMS',NULL,'text',147,886,30,30,'r','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2020-10-17 23:11:51','globeadmin','2020-10-17 23:11:51','globeadmin','2021-03-24 11:19:45','globeadmin'),('5f8b503f0b304a2','5f8b4f77ca6b53e',NULL,NULL,'1',10,NULL,'search_iframe',50,10,'Μαζική Αποστολή SMS',NULL,'iframe',173,20,900,350,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from teacher order by short_name',NULL,'5f8b61c073af846','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2020-10-17 23:12:47','globeadmin','2020-10-18 00:32:13','globeadmin','2021-03-24 11:19:45','globeadmin'),('5f8b505f5c56f2c','5f8b4f77ca6b53e',NULL,NULL,'1',10,'select if(\'#nu_user_group#\'=\'globeadmin\',\'1\',\'0\')','max_num_of_chars',60,10,'Μαζική Αποστολή SMS',NULL,'display',8,155,30,30,'r','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','SELECT 159-CHAR_LENGTH(short_name) \nFROM school\nWHERE id=1',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2020-10-17 23:13:19','globeadmin','2020-10-17 23:13:19','globeadmin','2021-03-24 11:19:45','globeadmin'),('5f8b50b09bd2194','5f8b4f77ca6b53e',NULL,NULL,'1',10,'select \'0\'','text_disp',90,10,'Μαζική Αποστολή SMS',NULL,'display',8,373,250,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select email_text\nfrom session_variables\nwhere session_id=\'#session_id#\'','select id,short_name from class order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2020-10-17 23:14:40','globeadmin','2020-10-17 23:31:20','globeadmin','2021-03-24 11:19:45','globeadmin'),('5f8b69a4c0c50e0','5f8b690f7120805',NULL,NULL,'1',10,NULL,'subject',10,10,'Μαζική Αποστολή Email','Θέμα :','text',20,33,700,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2020-10-18 01:01:08','globeadmin','2020-10-18 01:01:08','globeadmin','2022-09-17 21:39:27','globeadmin'),('5f8b69be5271023','5f8b690f7120805',NULL,NULL,'1',10,NULL,'label1',20,10,'Μαζική Αποστολή Email','Μήνυμα :','words',57,28,120,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from class order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2020-10-18 01:01:34','globeadmin','2020-10-18 01:01:34','globeadmin','2022-09-17 21:39:27','globeadmin'),('5f8b69eba2fc000','5f8b690f7120805',NULL,NULL,'1',10,NULL,'email_text_tinymce',30,10,'Μαζική Αποστολή Email',NULL,'iframe',82,23,900,380,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'56cc9f04b82528e','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2020-10-18 01:02:19','globeadmin','2020-10-18 01:02:19','globeadmin','2022-09-17 21:39:27','globeadmin'),('5f8b6a288bf8289','5f8b690f7120805',NULL,NULL,'1',10,NULL,'search_iframe',40,10,'Μαζική Αποστολή Email',NULL,'iframe',481,24,900,350,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from teacher order by short_name',NULL,'5f8b6c6f9011cfc','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2020-10-18 01:03:20','globeadmin','2020-10-18 01:15:37','globeadmin','2022-09-17 21:41:02','globeadmin'),('5f8b6a63005af7f','5f8b690f7120805',NULL,NULL,'1',10,'select \'0\'','subject_disp',70,10,'Μαζική Αποστολή Email',NULL,'display',58,306,250,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select email_subject\nfrom session_variables\nwhere session_id=\'#session_id#\'','select id,short_name from class order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2020-10-18 01:04:19','globeadmin','2020-10-18 01:07:13','globeadmin','2022-09-17 21:39:27','globeadmin'),('5f8b6b562dde1c5','5f8b690f7120805',NULL,NULL,'1',10,'select \'0\'','text_disp',70,10,'Μαζική Αποστολή Email',NULL,'display',58,300,250,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select email_text\nfrom session_variables\nwhere session_id=\'#session_id#\'','select id,short_name from class order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2020-10-18 01:08:22','globeadmin','2020-10-18 01:08:22','globeadmin','2022-09-17 21:39:27','globeadmin'),('6038103e55eb2de','60380fd5e427d6b',NULL,NULL,'1',10,NULL,'search_iframe',10,10,'Εκκρεμείς Καταχωρίσεις',NULL,'iframe',44,15,850,500,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'603804125b80c1b','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2021-02-25 23:01:50','globeadmin','2021-02-25 23:16:22','globeadmin','2021-04-01 13:56:23','globeadmin'),('60395549d067a9b','5787f33aaa172a1',NULL,NULL,'1',10,NULL,'search_pending_btn',10,20,'Εκκρεμείς Καταχωρίσεις','Εύρεση','button',22,38,120,35,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2021-02-26 22:08:41','globeadmin','2021-04-04 14:16:41','globeadmin','2022-12-21 12:48:23','globeadmin'),('60395617011aa7d','5787f33aaa172a1',NULL,NULL,'1',10,NULL,'pending_iframe',20,20,'Εκκρεμείς Καταχωρίσεις',NULL,'iframe',63,15,850,420,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2021-02-26 22:12:07','globeadmin','2021-02-26 22:21:16','globeadmin','2022-12-21 12:48:23','globeadmin'),('6065a4c0707376d','60380fd5e427d6b',NULL,NULL,'1',10,NULL,'show_btn',20,10,'Εκκρεμείς Καταχωρίσεις','Show','button',9,29,100,30,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2021-04-01 13:47:28','globeadmin','2021-04-01 13:47:28','globeadmin','2021-04-01 14:03:23','globeadmin'),('6065a4e9d56300a','60380fd5e427d6b',NULL,NULL,'1',10,NULL,'hide_btn',30,10,'Εκκρεμείς Καταχωρίσεις','Hide','button',9,158,100,30,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2021-04-01 13:48:09','globeadmin','2021-04-01 13:48:09','globeadmin','2021-04-01 13:58:32','globeadmin'),('6069ee0c8684da5','56dd9f180d22b31',NULL,NULL,'1',10,'select \'0\'','connections_disp',60,10,'Διδασκαλία',NULL,'display',27,935,20,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','SELECT COUNT(*) \nFROM registered_card AS other_rg\nINNER JOIN registered_card AS this_rg ON this_rg.id = \'#RECORD_ID#\'\nINNER JOIN card AS this_card ON this_card.id = this_rg.card_id\nINNER JOIN card AS other_card ON other_card.id = other_rg.card_id\nWHERE\n    other_rg.id <> \'#RECORD_ID#\' AND\n    other_rg.card_date = this_rg.card_date AND\n    other_card.day_id = this_card.day_id AND\n    other_card.period_id = this_card.period_id AND\n    other_card.subject_id = this_card.subject_id AND\n    other_card.classroom_id <=> this_card.classroom_id AND\n    other_card.teacher_id = this_card.teacher_id AND\n    other_rg.no_lesson = 0 AND\n    other_rg.prime = 1',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2021-04-04 19:49:16','globeadmin','2021-04-04 20:16:39','globeadmin','2022-12-21 12:48:45','globeadmin'),('606a0330cc2a552','5787f33aaa172a1',NULL,NULL,'0',10,NULL,'no_lesson_img',80,10,'Απουσιολόγιο',NULL,'html',22,871,40,40,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<style>\n.disabledimg {\n    pointer-events: none;\n    opacity: 0.4;\n}\n</style>\n\n<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100%>\n    <tr>\n        <td align=\'center\'>\n            <img width=36 height=36 id=\'no_lesson_img_img\' src=\'images/unplug.png\' title=\'Κενό, δεν πραγματοποιήθηκε η διδασκαλία!\'/>\n        </td>\n    </tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2021-04-04 21:19:28','globeadmin','2021-04-04 21:32:46','globeadmin','2022-12-21 12:48:23','globeadmin'),('6133bd5dca2f850','5476201e5a3d38f',NULL,NULL,'1',10,NULL,'parent_email2',250,20,'Στοιχεία Επικοινωνίας','Δευτερεύον Email :','text',639,550,250,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2021-09-04 21:39:25','globeadmin','2021-09-04 21:42:26','globeadmin','2022-01-08 11:22:28','globeadmin'),('6133be98b3a77d1','5476201e5a3d38f',NULL,NULL,'0',10,'select if(student.parent_email2 is not null and TRIM(student.parent_email2)!=\'\',\'1\',\'0\')\nfrom school  \nleft join student on student.id=\'#RECORD_ID#\' \nwhere  school.id=1\n','send_email_parent2_img',300,20,'Στοιχεία Επικοινωνίας',NULL,'html',639,935,34,31,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"this.style.cursor=\'pointer\';\"\n                            onmouseout=\"this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=30 height=30 id=\'img_email_parent_send2\' src=\'images/email.png\' title=\'Αποστολή Email\'/>\n        </td>\n    </tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2021-09-04 21:44:40','globeadmin','2021-09-04 21:44:40','globeadmin','2022-01-08 11:22:28','globeadmin'),('61364b88ea10248','54a6fde1ab6eb6d',NULL,NULL,'1',10,NULL,'parent_email2',180,20,'Στοιχεία Επικοινωνίας','Δευτερεύον Email :','text',394,540,300,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2021-09-06 20:10:33','globeadmin','2021-09-06 20:10:40','globeadmin','2021-09-06 20:12:24','globeadmin'),('616c8cd05581a79','616c8bafd921bae',NULL,NULL,'0',10,NULL,'medals',10,10,'Επιβράβευση',NULL,'html',253,92,280,40,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'	<script>\n		function setMedalValue(v){\n\n			let m = document.getElementsByClassName(\"medal\").length;\n\n			for(let i=1;i<=m;i++){\n				if(i<=v){\n					document.getElementById(\'s\'+i).src=\'images/medal.png\';\n				} else {\n					document.getElementById(\'s\'+i).src=\'images/medal_blank.png\';\n				}\n			}\n			document.getElementById(\'valueMsg\').innerHTML = v+ (v==1 ? \" μετάλλιο\" : \" μετάλλια\");\n		}\n		function getMedalValue(){\n			let m = document.getElementsByClassName(\"medal\").length;\n			let x=0;\n			for(let i=1;i<=m;i++){\n				if(document.getElementById(\'s\'+i).getAttribute(\"src\").endsWith(\'medal.png\')) x++;\n			}\n			return x;            \n		}   \n	</script>\n\n	<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0>\n	<tr>\n		<td align=\'center\' onclick=\"setMedalValue(1)\" onmouseover=\"this.style.cursor=\'pointer\'\" onmouseout=\"this.style.cursor=\'auto\'\">\n			<img class=\"medal\" width=32 height=32 id=\'s1\' src=\'images/medal.png\' />\n		</td>\n		<td align=\'center\'  onclick=\"setMedalValue(2)\" onmouseover=\"this.style.cursor=\'pointer\'\" onmouseout=\"this.style.cursor=\'auto\'\">\n			<img class=\"medal\" width=32 height=32 id=\'s2\' src=\'images/medal_blank.png\' />\n		</td>\n		<td align=\'center\' onclick=\"setMedalValue(3)\" onmouseover=\"this.style.cursor=\'pointer\'\" onmouseout=\"this.style.cursor=\'auto\'\">\n			<img class=\"medal\" width=32 height=32 id=\'s3\' src=\'images/medal_blank.png\' />\n		</td>\n		<td align=\'center\' onclick=\"setMedalValue(4)\" onmouseover=\"this.style.cursor=\'pointer\'\" onmouseout=\"this.style.cursor=\'auto\'\">\n			<img class=\"medal\" width=32 height=32 id=\'s4\' src=\'images/medal_blank.png\' />\n		</td>\n		<td align=\'center\' onclick=\"setMedalValue(5)\" onmouseover=\"this.style.cursor=\'pointer\'\" onmouseout=\"this.style.cursor=\'auto\'\">\n			<img class=\"medal\" width=32 height=32 id=\'s5\' src=\'images/medal_blank.png\' />\n		</td>\n		<td id=\"valueMsg\" align=\'center\' width=90 style=\"font-family:Verdana;font-size:10pt;color: gray;vertical-align: middle\">\n			1 μετάλιο\n		</td>\n	</tr>\n	</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2021-10-17 23:51:28','globeadmin','2021-10-20 23:51:47','globeadmin','2022-01-08 18:45:23','globeadmin'),('61744f1b1debf01','61744f1b13259e3',NULL,NULL,'1',10,NULL,'name',10,10,'Λεπτομέρειες','Όνομα :','text',40,46,650,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2021-10-28 12:46:10','globeadmin','2022-01-08 15:28:42','globeadmin'),('61744f1b1df2726','61744f1b13259e3',NULL,NULL,'1',10,NULL,'description',20,10,'Λεπτομέρειες','Περιγραφή :','textarea',109,23,650,80,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2021-10-28 12:46:26','globeadmin','2022-01-08 15:28:42','globeadmin'),('61744f1b1df705d','61744f1b13259e3',NULL,NULL,'1',10,'SELECT \'0\'','teacher_id',30,10,'Λεπτομέρειες','Καθηγητής :','text',215,419,100,0,'r','0','0','SELECT teacher_id\nFROM session_variables\nWHERE session_id=\'#session_id#\'','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'0000-00-00 00:00:00','','2021-10-23 21:58:57','globeadmin','2022-01-08 15:28:42','globeadmin'),('616db609661ae95','616c8bafd921bae',NULL,NULL,'1',10,NULL,'date_enforced',20,10,'Επιβράβευση','Ημερομηνία :','text',34,14,80,0,'r','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,'#nuSepEditnuSepr#varchar',NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',100,250,'2021-10-18 20:59:37','globeadmin','2021-10-18 21:10:02','globeadmin','2022-01-08 18:45:23','globeadmin'),('616db61c4fe9c5e','616c8bafd921bae',NULL,NULL,'1',10,NULL,'reward_type_id',30,10,'Επιβράβευση','Λόγος :','dropdown',168,44,650,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'SELECT reward_type.id,reward_type.name\nFROM reward_type\nINNER JOIN session_variables ON session_variables.session_id = \'#session_id#\'\nWHERE\n    reward_type.is_public=1 OR\n    reward_type.teacher_id = session_variables.teacher_id\norder by reward_type.is_public, reward_type.name ',NULL,'','',NULL,NULL,NULL,'#nuSepEditnuSepr#varchar',NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2021-10-18 20:59:56','globeadmin','2022-01-07 21:35:35','globeadmin','2022-01-08 18:45:23','globeadmin'),('616db6305318023','616c8bafd921bae',NULL,NULL,'1',10,NULL,'period_id',50,10,'Επιβράβευση','Διδακτική Ώρα :','dropdown',35,187,60,0,'r','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name\nfrom period\n',NULL,'','',NULL,NULL,NULL,'#nuSepEditnuSepr#varchar',NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',100,250,'2021-10-18 21:00:16','globeadmin','2021-10-18 21:06:30','globeadmin','2022-01-08 18:45:23','globeadmin'),('616db64de4d37a0','616c8bafd921bae',NULL,NULL,'1',10,NULL,'date_added',50,10,'Επιβράβευση',NULL,'text',15,581,150,0,'r','0','1','select NOW()','0',NULL,NULL,NULL,NULL,NULL,'','','select DATE_FORMAT(date_added,\'%d-%m-%Y %T\')\nfrom penalty\nwhere id=\'#RECORD_ID#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2021-10-18 21:00:45','globeadmin','2021-10-18 21:06:44','globeadmin','2022-01-08 18:45:23','globeadmin'),('616db666becc3ca','616c8bafd921bae',NULL,NULL,'1',10,NULL,'student_name',70,10,'Επιβράβευση','Μαθητής :','text',79,29,450,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'Καθυστερημένη Είσοδος|Καθυστερημένη Είσοδος|Παρατήρηση|Παρατήρηση|Επίπληξη|Επίπληξη',NULL,'','',NULL,NULL,NULL,'#nuSepEditnuSepr#varchar',NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2021-10-18 21:01:10','globeadmin','2021-10-18 21:06:58','globeadmin','2022-01-08 18:45:23','globeadmin'),('616db679b1ef16c','616c8bafd921bae',NULL,NULL,'1',10,NULL,'student_id',70,10,'Επιβράβευση',NULL,'text',49,677,50,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'Καθυστερημένη Είσοδος|Καθυστερημένη Είσοδος|Παρατήρηση|Παρατήρηση|Επίπληξη|Επίπληξη',NULL,'','',NULL,NULL,NULL,'#nuSepEditnuSepr#varchar',NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2021-10-18 21:01:29','globeadmin','2021-10-18 21:07:10','globeadmin','2022-01-08 18:45:23','globeadmin'),('616db6919af97a0','616c8bafd921bae',NULL,NULL,'1',10,NULL,'comments',90,10,'Επιβράβευση','Σχόλιο :','textarea',320,41,650,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2021-10-18 21:01:53','globeadmin','2021-10-28 14:33:04','globeadmin','2022-01-08 18:45:23','globeadmin'),('616db6a37827936','616c8bafd921bae',NULL,NULL,'1',10,NULL,'teacher_id',100,10,'Επιβράβευση','Καθηγητής :','dropdown',123,17,350,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select  id,\n        concat(if(surname is null,\'\',concat(surname,\' \')), IFNULL(name,\'\')) as teacher_full_name\nfrom teacher\norder by teacher_full_name',NULL,'','',NULL,NULL,NULL,'#nuSepEditnuSepr#varchar',NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2021-10-18 21:02:11','globeadmin','2021-10-20 09:31:30','globeadmin','2022-01-08 18:45:23','globeadmin'),('616f28e6ae485dc','616c8bafd921bae',NULL,NULL,'1',10,NULL,'lebel1',40,10,'Επιβράβευση','Παρακαλώ επιλέξτε τον αριθμό των μεταλλίων ανάλογα με τη σπουδαιότητα της πράξης που επιβραβεύεται :','words',215,17,650,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,'#nuSepEditnuSepr#varchar',NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2021-10-19 23:21:58','globeadmin','2021-10-21 14:11:53','globeadmin','2022-01-08 18:45:23','globeadmin'),('61744f1b1dfba4c','61744f1b13259e3',NULL,NULL,'1',10,'SELECT IF(\'#nu_user_group#\' IN (\'globeadmin\',\'Managers\',\'Administrators\',\'AssistManagers\'), \'1\',\'0\')','is_public',40,10,'Λεπτομέρειες','Δημόσιο : ','checkbox',231,665,100,0,'l','0','0','SELECT \'0\'','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,'',NULL,'',NULL,'','',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'','',NULL,'',100,250,'0000-00-00 00:00:00','','2021-10-23 21:50:43','globeadmin','2022-01-08 15:28:42','globeadmin'),('61707f2a7cdac7d','616c8bafd921bae',NULL,NULL,'1',10,NULL,'subject_id',110,10,'Επιβράβευση',NULL,'text',85,680,40,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2021-10-20 23:42:18','globeadmin','2021-10-20 23:43:09','globeadmin','2022-01-08 18:45:23','globeadmin'),('61707ea57940317','616c8bafd921bae',NULL,NULL,'1',10,NULL,'subject_name',120,10,'Επιβράβευση','Μάθημα : ','text',34,355,340,30,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2021-10-20 23:40:05','globeadmin','2021-10-20 23:45:12','globeadmin','2022-01-08 18:45:23','globeadmin'),('6175a5e08ed6a39','56192be786c61d7',NULL,NULL,'0',10,NULL,'rewardbtn',70,10,'Αξιολόγηση Μαθητών και Ποινές',NULL,'html',334,380,220,100,'l','0','0','','0',NULL,NULL,NULL,'554517bdc18334d',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_cup_id\').src=\'images/cupb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_cup_id\').src=\'images/cup.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_cup_id\' src=\'images/cup.png\' title=\'Επιβραβεύσεις που έχουν αποδοθεί σε μαθητές\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Επιβραβεύσεις Μαθητών</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2021-10-24 21:28:48','globeadmin','2021-10-24 21:33:49','globeadmin','2022-02-12 19:44:50','globeadmin'),('6175a8b74ee11e3','6175a7faca903a3',NULL,NULL,'1',10,NULL,'label1',10,10,'Αναζήτηση','Επιλέξτε από τα παρακάτω κριτήρια αναζήτησης. Αφήνοντας κενό ένα κριτήριο, εμφανίζονται όλες οι αντίστοιχες επιβραβεύσεις.','words',13,15,750,30,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from class order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2021-10-24 21:40:55','globeadmin','2021-10-24 21:54:04','globeadmin','2022-01-08 18:43:54','globeadmin'),('6175a8d464cdaa1','6175a7faca903a3',NULL,NULL,'1',10,NULL,'from_date',20,10,'Αναζήτηση','Από : ','text',44,37,70,30,'r','0','0','select curdate()','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2021-10-24 21:41:24','globeadmin','2022-01-07 20:35:26','globeadmin','2022-01-08 18:43:54','globeadmin'),('6175a8f15200034','6175a7faca903a3',NULL,NULL,'1',10,NULL,'to_date',30,10,'Αναζήτηση','Έως : ','text',44,166,70,30,'r','0','0','select curdate()','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',0,0,'2021-10-24 21:41:53','globeadmin','2022-01-07 20:35:39','globeadmin','2022-01-08 18:43:54','globeadmin'),('6175a926c645fd2','6175a7faca903a3',NULL,NULL,'1',10,NULL,'reward_type_id',40,10,'Αναζήτηση','Λόγος Επιβράβευσης : ','listbox',81,18,800,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','','SELECT reward_type.id,CONCAT(reward_type.name,\' (\',IF(reward_type.is_public=1,\'ΔΗΜΟΣΙΟ-\',\'ΙΔΙΩΤΙΚΟ-\'),teacher.short_name,\')\')\nFROM reward_type\nINNER JOIN teacher ON reward_type.teacher_id = teacher.id\nORDER BY reward_type.is_public DESC, reward_type.teacher_id, reward_type.name ',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2021-10-24 21:42:46','globeadmin','2022-01-07 20:40:48','globeadmin','2022-01-08 18:43:54','globeadmin'),('6175a9520363869','6175a7faca903a3',NULL,NULL,'1',10,NULL,'teacher_id',50,10,'Αναζήτηση','Καθηγητής : ','listbox',119,529,350,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','','select  id,\n        concat(if(surname is null,\'\',concat(surname,\' \')), IFNULL(name,\'\')) as teacher_full_name\nfrom teacher\norder by teacher_full_name',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2021-10-24 21:43:30','globeadmin','2022-01-07 20:42:42','globeadmin','2022-01-08 18:43:54','globeadmin'),('6175a96e9ca7164','6175a7faca903a3',NULL,NULL,'1',10,NULL,'student_id',60,10,'Αναζήτηση','Μαθητής : ','listbox',119,10,400,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','','select distinct student.id, concat(ifNULL(grade.short_name,\'\'),\' - \',student.surname,\' \',student.name,\' \',student.fathers_name) \nfrom student\ninner join penalty on penalty.student_id = student.id\nleft join grade on grade.id = student.grade_id\nwhere 1\norder by student.grade_id,student.surname,student.name,student.fathers_name',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2021-10-24 21:43:58','globeadmin','2022-01-07 20:43:14','globeadmin','2022-01-08 18:43:54','globeadmin'),('6175a997072d15e','6175a7faca903a3',NULL,NULL,'1',10,NULL,'class_id',70,10,'Αναζήτηση','Τμήμα : ','listbox',42,295,110,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name\nfrom class\norder by short_name',NULL,'','','select id,short_name\nfrom class\norder by short_name',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2021-10-24 21:44:39','globeadmin','2022-01-07 20:36:07','globeadmin','2022-01-08 18:43:54','globeadmin'),('6175a9c1ceeae42','6175a7faca903a3',NULL,NULL,'1',10,NULL,'searchbtn',80,10,'Αναζήτηση','Αναζήτηση','button',165,73,150,35,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from teacher order by short_name',NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2021-10-24 21:45:21','globeadmin','2021-10-24 21:45:21','globeadmin','2022-01-08 18:43:54','globeadmin'),('6175a9ee95e07e5','6175a7faca903a3',NULL,NULL,'1',10,NULL,'search_iframe',100,10,'Αναζήτηση',NULL,'iframe',212,14,950,330,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name from teacher order by short_name',NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2021-10-24 21:46:06','globeadmin','2021-10-28 17:28:20','globeadmin','2022-01-08 18:43:54','globeadmin'),('6175aa23b368d04','6175a7faca903a3',NULL,NULL,'1',10,'select \'0\'','current_date',100,10,'Αναζήτηση','Τρέχουσα Ημ/νια : ','display',10,973,80,30,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select DATE_FORMAT(curdate(),\'%d-%m-%Y\')',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2021-10-24 21:46:59','globeadmin','2021-10-24 21:46:59','globeadmin','2022-01-08 18:43:55','globeadmin'),('61d88deb4806ead','61d88d6b6d133c3',NULL,NULL,'1',10,NULL,'date_enforced',40,10,'Επιβράβευση','*Ημερομηνία :','text',70,9,80,0,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,'#nuSepEditnuSepr#varchar',NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',100,250,'2022-01-07 21:00:59','globeadmin','2022-01-07 21:22:02','globeadmin','2022-01-08 18:43:21','globeadmin'),('6175aa738d3578b','6175a7faca903a3',NULL,NULL,'1',10,'select \'0\'','start_date',130,10,'Αναζήτηση','Αρχή Μαθημάτων : ','display',13,783,80,30,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','','select DATE_FORMAT(school_year.start_date,\'%d-%m-%Y\')\nfrom school\ninner join school_year on school_year.id = school.school_year_id\nwhere school.id=1',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2021-10-24 21:48:19','globeadmin','2021-10-24 21:48:27','globeadmin','2022-01-08 18:43:55','globeadmin'),('617a8e53b8b7af1','616c8bafd921bae',NULL,NULL,'1',10,'SELECT \'0\'','number_of_medals',130,10,'Επιβράβευση','Αριθμός Μεταλλιών :','text',79,609,40,30,'l','0','0','SELECT \'1\'','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',0,0,'2021-10-28 14:49:39','globeadmin','2021-10-28 14:52:59','globeadmin','2022-01-08 18:45:23','globeadmin'),('617ab1dc7b9198e','6175a7faca903a3',NULL,NULL,'1',10,NULL,'subject_id',90,10,'Αναζήτηση','Μάθημα : ','listbox',41,494,400,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select subject.id,concat(grade.short_name,section.abbreviation,if(section.abbreviation!=speciality.abbreviation,speciality.abbreviation,\'\'),\'-\',subject.name,\'-\',ifNull(subject_type.short_name,\'\'))\nfrom subject\ninner join grade on subject.grade_id=grade.id\ninner join speciality on subject.speciality_id=speciality.id\ninner join section on speciality.section_id=section.id\nleft  join subject_type on subject.subject_type_id=subject_type.id\nwhere subject.id in \n    (   select distinct subject_id\n        from card\n        where   card.valid_from =(select max(timetable.start_date) from timetable where (timetable.start_date <= curdate())) and\n                class_id is not NULL\n        )\norder by grade.short_name,section.abbreviation,speciality.abbreviation,subject.name',NULL,'','','select subject.id,concat(grade.short_name,section.abbreviation,if(section.abbreviation!=speciality.abbreviation,speciality.abbreviation,\'\'),\'-\',subject.name,\'-\',ifNull(subject_type.short_name,\'\'))\nfrom subject\ninner join grade on subject.grade_id=grade.id\ninner join speciality on subject.speciality_id=speciality.id\ninner join section on speciality.section_id=section.id\nleft  join subject_type on subject.subject_type_id=subject_type.id\nwhere subject.id in \n    (   select distinct subject_id\n        from card\n        where   card.valid_from =(select max(timetable.start_date) from timetable where (timetable.start_date <= curdate())) and\n                class_id is not NULL\n        )\norder by grade.short_name,section.abbreviation,speciality.abbreviation,subject.name',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2021-10-28 17:21:16','globeadmin','2021-10-28 17:40:24','globeadmin','2022-01-08 18:43:54','globeadmin'),('61d88e00275080a','61d88d6b6d133c3',NULL,NULL,'1',10,NULL,'period_id',70,10,'Επιβράβευση','Διδακτική Ώρα :','dropdown',72,188,80,0,'r','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select id,short_name\nfrom period',NULL,'','',NULL,NULL,NULL,'#nuSepEditnuSepr#varchar',NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'7','',NULL,'',100,250,'2022-01-07 21:01:20','globeadmin','2022-01-07 21:21:49','globeadmin','2022-01-08 18:43:21','globeadmin'),('61d88e1512f3385','61d88d6b6d133c3',NULL,NULL,'1',10,NULL,'student_id',10,10,'Επιβράβευση','*Μαθητής :','dropdown',20,24,500,0,'l','1','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select distinct student.id, concat(ifNULL(grade.short_name,\'\'),\' - \',student.surname,\' \',student.name,\' \',ifNULL(student.fathers_name,\'\'),\' (\',student.registration_number,\')\') \nfrom student\nleft join grade on grade.id = student.grade_id\norder by student.grade_id,student.surname,student.name,student.fathers_name',NULL,'','',NULL,'registration_number',NULL,'surname',NULL,'5476201e5a3d38f','id',NULL,'function getStudentName() {\n    if (\'#call_type#\'==\'lookupcode\'){\n	    $fld = \'registration_number\';\n    } else {\n	    $fld = \'id\';\n    }\n    $sql = \"SELECT name FROM student WHERE \".$fld.\" = \'#RECORD_ID#\'\";\n    $q = nuRunQuery($sql);\n    $r = db_fetch_row($q);\n    return $r[0];\n}\nfunction getFatherstName() {\n    if (\'#call_type#\'==\'lookupcode\'){\n	    $fld = \'registration_number\';\n    } else {\n	    $fld = \'id\';\n    }\n    $sql = \"SELECT fathers_name FROM student WHERE \".$fld.\" = \'#RECORD_ID#\'\";\n    $q = nuRunQuery($sql);\n    $r = db_fetch_row($q);\n    return $r[0];\n}',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',60,200,'2022-01-07 21:01:41','globeadmin','2022-01-07 21:21:49','globeadmin','2022-01-08 18:43:21','globeadmin'),('61d88e28585c231','61d88d6b6d133c3',NULL,NULL,'1',10,NULL,'teacher_id',30,10,'Επιβράβευση','Καθηγητής :','dropdown',394,17,350,0,'l','0','1','select if(\n        teacher_id=-1 or \n        \'#nu_user_group#\'=\'globeadmin\' or \n        \'#nu_user_group#\'=\'Administrators\' or \n        \'#nu_user_group#\'=\'Managers\' or \n        \'#nu_user_group#\'=\'AssistManagers\'\n            ,NULL, teacher_id)\nfrom session_variables \nwhere session_id=\'#session_id#\'','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'select  id,\n        concat(if(surname is null,\'\',concat(surname,\' \')), IFNULL(name,\'\')) as teacher_full_name\nfrom teacher\ninner join session_variables on session_id=\'#session_id#\'\nwhere   \'#nu_user_group#\'=\'globeadmin\' or \n        \'#nu_user_group#\'=\'Administrators\' or \n        \'#nu_user_group#\'=\'Managers\' or \n        \'#nu_user_group#\'=\'AssistManagers\' or\n        teacher.id = session_variables.teacher_id\norder by teacher_full_name\n',NULL,'','',NULL,'short_name',NULL,'name',NULL,'547372d029461f4','id',NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',200,0,'2022-01-07 21:02:00','globeadmin','2022-01-07 21:59:27','globeadmin','2022-01-08 18:43:21','globeadmin'),('61d88e4be1566a0','61d88d6b6d133c3',NULL,NULL,'1',10,NULL,'label1',100,10,'Επιβράβευση','* Απαιτείται','words',429,16,150,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2022-01-07 21:02:35','globeadmin','2022-01-07 21:21:49','globeadmin','2022-01-08 18:43:21','globeadmin'),('61d88e715713ed5','61d88d6b6d133c3',NULL,NULL,'1',10,NULL,'date_addeddisp',90,10,'Επιβράβευση','Ημερομηνία Καταχώρισης :','display',392,465,150,0,'r','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select DATE_FORMAT(date_added,\'%d-%m-%Y %T\')\nfrom penalty\nwhere id=\'#RECORD_ID#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2022-01-07 21:03:13','globeadmin','2022-01-07 21:21:49','globeadmin','2022-01-08 18:43:21','globeadmin'),('61d88ea5b65b611','61d88d6b6d133c3',NULL,NULL,'1',10,NULL,'reward_type_id',60,10,'Επιβράβευση','*Λόγος :','dropdown',119,39,650,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'SELECT reward_type.id,reward_type.name\nFROM reward_type\nINNER JOIN session_variables ON session_variables.session_id = \'#session_id#\'\nWHERE\n    reward_type.is_public=1 OR\n    reward_type.teacher_id = session_variables.teacher_id\norder by reward_type.is_public, reward_type.name ',NULL,'','',NULL,NULL,NULL,'#nuSepEditnuSepr#varchar',NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2022-01-07 21:04:05','globeadmin','2022-01-07 21:36:44','globeadmin','2022-01-08 18:43:21','globeadmin'),('61d88f08a7c6e2b','61d88d6b6d133c3',NULL,NULL,'1',10,NULL,'comments',80,10,'Επιβράβευση','Σχόλιο :','textarea',251,41,650,100,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2022-01-07 21:05:44','globeadmin','2022-01-07 21:26:20','globeadmin','2022-01-08 18:43:21','globeadmin'),('61d88f232edfb2a','61d88d6b6d133c3',NULL,NULL,'1',10,NULL,'lebel1',50,10,'Επιβράβευση','Παρακαλώ επιλέξτε τον αριθμό των μεταλλίων ανάλογα με τη σπουδαιότητα της πράξης που επιβραβεύεται :','words',163,17,650,0,'l','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,'#nuSepEditnuSepr#varchar',NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2022-01-07 21:06:11','globeadmin','2022-01-07 21:06:11','globeadmin','2022-01-08 18:43:21','globeadmin'),('61d88f5a7c40056','61d88d6b6d133c3',NULL,NULL,'0',10,NULL,'medals',20,10,'Επιβράβευση',NULL,'html',195,90,470,40,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'	<script>\n		function setMedalValue(v){\n\n			let m = document.getElementsByClassName(\"medal\").length;\n\n			for(let i=1;i<=m;i++){\n				if(i<=v){\n					document.getElementById(\'s\'+i).src=\'images/medal.png\';\n				} else {\n					document.getElementById(\'s\'+i).src=\'images/medal_blank.png\';\n				}\n			}\n			document.getElementById(\'valueMsg\').innerHTML = v+ (v==1 ? \" μετάλλιο\" : \" μετάλλια\");\n			\n		}\n		function getMedalValue(){\n			let m = document.getElementsByClassName(\"medal\").length;\n			let x=0;\n			for(let i=1;i<=m;i++){\n				if(document.getElementById(\'s\'+i).getAttribute(\"src\").endsWith(\'medal.png\')) x++;\n			}\n			return x;            \n		}   \n	</script>\n\n	<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0>\n	<tr>\n		<td align=\'center\' onclick=\"setMedalValue(1)\" onmouseover=\"this.style.cursor=\'pointer\'\" onmouseout=\"this.style.cursor=\'auto\'\">\n			<img class=\"medal\" width=32 height=32 id=\'s1\' src=\'images/medal.png\' />\n		</td>\n		<td align=\'center\'  onclick=\"setMedalValue(2)\" onmouseover=\"this.style.cursor=\'pointer\'\" onmouseout=\"this.style.cursor=\'auto\'\">\n			<img class=\"medal\" width=32 height=32 id=\'s2\' src=\'images/medal_blank.png\' />\n		</td>\n		<td align=\'center\' onclick=\"setMedalValue(3)\" onmouseover=\"this.style.cursor=\'pointer\'\" onmouseout=\"this.style.cursor=\'auto\'\">\n			<img class=\"medal\" width=32 height=32 id=\'s3\' src=\'images/medal_blank.png\' />\n		</td>\n		<td align=\'center\' onclick=\"setMedalValue(4)\" onmouseover=\"this.style.cursor=\'pointer\'\" onmouseout=\"this.style.cursor=\'auto\'\">\n			<img class=\"medal\" width=32 height=32 id=\'s4\' src=\'images/medal_blank.png\' />\n		</td>\n		<td align=\'center\' onclick=\"setMedalValue(5)\" onmouseover=\"this.style.cursor=\'pointer\'\" onmouseout=\"this.style.cursor=\'auto\'\">\n			<img class=\"medal\" width=32 height=32 id=\'s5\' src=\'images/medal_blank.png\' />\n		</td>\n		<td align=\'center\'  onclick=\"setMedalValue(6)\" onmouseover=\"this.style.cursor=\'pointer\'\" onmouseout=\"this.style.cursor=\'auto\'\">\n			<img class=\"medal\" width=32 height=32 id=\'s6\' src=\'images/medal_blank.png\' />\n		</td>\n		<td align=\'center\' onclick=\"setMedalValue(7)\" onmouseover=\"this.style.cursor=\'pointer\'\" onmouseout=\"this.style.cursor=\'auto\'\">\n			<img class=\"medal\" width=32 height=32 id=\'s7\' src=\'images/medal_blank.png\' />\n		</td>\n		<td align=\'center\' onclick=\"setMedalValue(8)\" onmouseover=\"this.style.cursor=\'pointer\'\" onmouseout=\"this.style.cursor=\'auto\'\">\n			<img class=\"medal\" width=32 height=32 id=\'s8\' src=\'images/medal_blank.png\' />\n		</td>\n		<td align=\'center\' onclick=\"setMedalValue(9)\" onmouseover=\"this.style.cursor=\'pointer\'\" onmouseout=\"this.style.cursor=\'auto\'\">\n			<img class=\"medal\" width=32 height=32 id=\'s9\' src=\'images/medal_blank.png\' />\n		</td>\n		<td align=\'center\' onclick=\"setMedalValue(10)\" onmouseover=\"this.style.cursor=\'pointer\'\" onmouseout=\"this.style.cursor=\'auto\'\">\n			<img class=\"medal\" width=32 height=32 id=\'s10\' src=\'images/medal_blank.png\' />\n		</td>\n		<td id=\"valueMsg\" align=\'center\' width=90 style=\"font-family:Verdana;font-size:10pt;color: gray;vertical-align: middle\">\n			1 μετάλιο\n		</td>\n	</tr>\n	</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2022-01-07 21:07:06','globeadmin','2022-01-07 22:24:16','globeadmin','2022-01-08 18:43:21','globeadmin'),('61d899b9dc54f5e','61d88d6b6d133c3',NULL,NULL,'1',10,'select \'0\'','teacher_iddisp',110,10,'Επιβράβευση',NULL,'display',20,755,20,0,'r','0','1','','0',NULL,NULL,NULL,NULL,NULL,'','','select teacher_id\nfrom session_variables\nwhere session_id=\'#session_id#\'',NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2022-01-07 21:51:21','globeadmin','2022-01-07 22:00:21','globeadmin','2022-01-08 18:43:21','globeadmin'),('61d8a1b1113ffa2','61d88d6b6d133c3',NULL,NULL,'1',10,'SELECT \'0\'','number_of_medals',120,10,'Επιβράβευση','Αριθμός Μεταλλιών :','text',19,748,40,30,'l','0','0','SELECT \'1\'','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',0,0,'2022-01-07 22:25:21','globeadmin','2022-01-07 22:25:21','globeadmin','2022-01-08 18:43:21','globeadmin'),('61d9512f75161f5','548338073921bfe',NULL,NULL,'0',10,NULL,'rewardbtn',70,10,'Προσωπικές Εργασίες',NULL,'html',334,380,220,100,'l','0','0','','0',NULL,NULL,NULL,'554517bdc18334d',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_cup_id\').src=\'images/cupb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_cup_id\').src=\'images/cup.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_cup_id\' src=\'images/cup.png\' title=\'Επιβραβεύσεις που έχουν αποδοθεί σε μαθητές\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Επιβραβεύσεις Μαθητών</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2022-01-08 10:54:07','globeadmin','2022-01-08 10:55:10','globeadmin','2022-01-08 10:55:10','globeadmin'),('61d952a54f2e2c9','59d7d7986aed52d',NULL,NULL,'0',10,NULL,'rewardbtn',70,10,'Αξιολόγηση Μαθητών και Ποινές',NULL,'html',270,687,220,100,'l','0','0','','0',NULL,NULL,NULL,'554517bdc18334d',NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"document.getElementById(\'img_cup_id\').src=\'images/cupb.png\';this.style.cursor=\'pointer\';\"\n                            onmouseout=\"document.getElementById(\'img_cup_id\').src=\'images/cup.png\';this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=74 height=74 id=\'img_cup_id\' src=\'images/cup.png\' title=\'Επιβραβεύσεις που έχουν αποδοθεί σε μαθητές\'/>\n        </td>\n    </tr>\n    <tr>\n        <td align=\'center\'>\n            <span style=\'font-family: Arial, Helvetica, sans-serif;font-size: 11px;font-weight: bold;\'>Επιβραβεύσεις Μαθητών</span>\n        </td>\n    </tr>\n    \n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2022-01-08 11:00:21','globeadmin','2022-01-08 11:00:21','globeadmin','2022-01-08 11:00:21','globeadmin'),('61d95b874886e88','5476201e5a3d38f',NULL,NULL,'1',10,NULL,'student_reward',10,100,'Επιβραβεύσεις',NULL,'iframe',39,15,1000,410,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'61d954057af2530','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2022-01-08 11:38:15','globeadmin','2022-01-08 11:39:35','globeadmin','2022-01-08 14:14:51','globeadmin'),('61d9807e2c47c0e','59e22fca2af8d03',NULL,NULL,'1',10,NULL,'student_reward',10,20,'Επιβραβεύσεις',NULL,'iframe',10,15,1000,450,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'61d954057af2530','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2022-01-08 14:15:58','globeadmin','2022-01-08 14:18:54','globeadmin','2022-01-08 14:26:20','globeadmin'),('61d98d8629e568a','61744f1b13259e3',NULL,NULL,'1',10,NULL,'default_number_of_medals',50,10,'Λεπτομέρειες','Προκαθορισμένος Αριθμός Μεταλλίων : ','text',235,46,30,0,'r','0','0','SELECT \'1\'','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,'0','',NULL,'',100,250,'2022-01-08 15:11:34','globeadmin','2022-01-08 15:17:31','globeadmin','2022-01-08 15:28:43','globeadmin'),('61d992646000054','61d88d6b6d133c3',NULL,NULL,'1',10,'select \'0\'','reward_type_id_medals',130,10,'Επιβράβευση',NULL,'dropdown',15,731,40,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'SELECT reward_type.id,reward_type.default_number_of_medals\nFROM reward_type\nINNER JOIN session_variables ON session_variables.session_id = \'#session_id#\'\nWHERE\n    reward_type.is_public=1 OR\n    reward_type.teacher_id = session_variables.teacher_id\norder by reward_type.is_public, reward_type.name ',NULL,'','',NULL,NULL,NULL,'#nuSepEditnuSepr#varchar',NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2022-01-08 15:32:20','globeadmin','2022-01-08 15:34:24','globeadmin','2022-01-08 18:43:21','globeadmin'),('61d99808beff58d','616c8bafd921bae',NULL,NULL,'1',10,'select \'0\'','reward_type_id_medals',130,10,'Επιβράβευση',NULL,'dropdown',15,730,40,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,'SELECT reward_type.id,reward_type.default_number_of_medals\nFROM reward_type\nINNER JOIN session_variables ON session_variables.session_id = \'#session_id#\'\nWHERE\n    reward_type.is_public=1 OR\n    reward_type.teacher_id = session_variables.teacher_id\norder by reward_type.is_public, reward_type.name ',NULL,'','',NULL,NULL,NULL,'#nuSepEditnuSepr#varchar',NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2022-01-08 15:56:24','globeadmin','2022-01-08 15:56:24','globeadmin','2022-01-08 18:45:23','globeadmin'),('61d9ef6c928600a','584128b691c711a',NULL,NULL,'1',10,'select if(active=\'1\',\'1\',\'0\')\nfrom notification_type \nwhere id=10','parent_new_reward_notification',110,10,'Επιλογές Ειδοποιήσεων Γονέα','Απονομή Επιβραβεύσεων :','checkbox',273,122,50,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2022-01-08 22:09:16','globeadmin','2022-01-08 22:09:16','globeadmin','2022-01-08 22:13:03','globeadmin'),('61d9f0881156ac5','584117d1d046e30',NULL,NULL,'1',10,'select if(active=\'1\',\'1\',\'0\')\nfrom notification_type \nwhere id=10','new_reward_notification',120,10,'Επιλογές Ειδοποιήσεων Μαθητή','Απονομή Επιβραβεύσεων :','checkbox',275,122,50,0,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2022-01-08 22:14:00','globeadmin','2022-01-08 22:14:00','globeadmin','2022-01-08 22:15:00','globeadmin'),('6206ad560eb324b','6206ad009f3ac5e',NULL,NULL,'1',10,NULL,'searchbtn',40,10,'Σύγκριση','Σύγκριση','button',110,15,160,35,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2022-02-11 20:39:18','globeadmin','2022-02-11 21:12:56','globeadmin','2022-02-12 14:43:26','globeadmin'),('6206ad870c623e3','6206ad009f3ac5e',NULL,NULL,'1',10,NULL,'search_iframe',50,10,'Σύγκριση',NULL,'iframe',166,15,950,350,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'54a2700ab351809','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2022-02-11 20:40:07','globeadmin','2022-02-11 21:12:56','globeadmin','2022-02-12 00:40:41','globeadmin'),('6206add63d2cfdd','6206ad009f3ac5e',NULL,NULL,'1',10,NULL,'ifile',30,10,'Σύγκριση',NULL,'iframe',47,54,350,50,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'54da24749d82eb7','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2022-02-11 20:41:26','globeadmin','2022-02-11 20:46:51','globeadmin','2022-02-12 00:40:41','globeadmin'),('6206ae481171181','6206ad009f3ac5e',NULL,NULL,'0',10,NULL,'remove_attachment_img',20,10,'Σύγκριση',NULL,'html',58,22,19,19,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<table border=0 align=\'center\' CELLSPACING=0 CELLPADDING=0 width=100% \n                            onmouseover=\"this.style.cursor=\'pointer\';\"\n                            onmouseout=\"this.style.cursor=\'auto\';\">\n    <tr>\n        <td align=\'center\'>\n            <img width=17 height=17 id=\'img_remove_attachment\' src=\'images/reset_pass.png\' title=\'Επαναφορά Αρχείου\'/>\n        </td>\n    </tr>\n</table>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2022-02-11 20:43:20','globeadmin','2022-02-11 21:12:56','globeadmin','2022-02-12 00:40:41','globeadmin'),('6206b1f3d9e2950','6206ad009f3ac5e',NULL,NULL,'1',10,NULL,'link1',10,10,'Σύγκριση','Δείγμα .xls Αρχείου  : ','html',14,28,70,25,'l','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,'<a href=\'sample/absence_compare.xls\' download>Λήψη</a>','','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2022-02-11 20:58:59','globeadmin','2022-02-11 21:12:56','globeadmin','2022-02-12 00:40:41','globeadmin'),('6207ab9289de325','6206ad009f3ac5e',NULL,NULL,'1',10,NULL,'printbtn',60,10,'Σύγκριση','Εκτύπωση','button',110,805,160,35,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',0,0,'2022-02-12 14:44:02','globeadmin','2022-02-12 14:44:50','globeadmin','2022-02-12 14:44:50','globeadmin'),('632f6740361aa17','5a54c08c836c142',NULL,NULL,'1',10,NULL,'add_absence_later',140,10,'Παράμετροι','Να επιτρέπεται οι καθηγητές να εισάγουν απουσίες ετεροχρονισμένα στο απουσιολόγιο :','checkbox',438,74,20,0,'c','0','0','','0',NULL,NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,NULL,'',NULL,NULL,NULL,NULL,NULL,'',NULL,'',100,250,'2022-09-24 23:23:28','globeadmin','2022-09-24 23:23:28','globeadmin','2022-09-24 23:23:28','globeadmin');
/*!40000 ALTER TABLE `zzzsys_object` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `zzzsys_php`
--

DROP TABLE IF EXISTS `zzzsys_php`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `zzzsys_php` (
  `zzzsys_php_id` varchar(25) NOT NULL DEFAULT '',
  `slp_code` varchar(250) NOT NULL,
  `slp_description` varchar(250) NOT NULL,
  `slp_group` varchar(250) NOT NULL,
  `slp_php` text NOT NULL,
  `slp_zzzsys_form_id` varchar(25) NOT NULL,
  `slp_nonsecure` varchar(1) DEFAULT '0',
  `zzzsys_php_log_added_at` datetime NOT NULL,
  `zzzsys_php_log_added_by` varchar(25) NOT NULL,
  `zzzsys_php_log_changed_at` datetime NOT NULL,
  `zzzsys_php_log_changed_by` varchar(25) NOT NULL,
  `zzzsys_php_log_viewed_at` datetime NOT NULL,
  `zzzsys_php_log_viewed_by` varchar(25) NOT NULL,
  `slp_list` varchar(1) NOT NULL,
  PRIMARY KEY (`zzzsys_php_id`),
  KEY `sat_all_code` (`slp_code`),
  KEY `sat_all_description` (`slp_description`),
  KEY `slp_zzzsys_form_id` (`slp_zzzsys_form_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `zzzsys_php`
--

LOCK TABLES `zzzsys_php` WRITE;
/*!40000 ALTER TABLE `zzzsys_php` DISABLE KEYS */;
INSERT INTO `zzzsys_php` VALUES ('5477806364bbd3b','student_lessons','Διδασκαλίες Μαθητή','student','$sql = \"SELECT max(timetable.start_date) \n		FROM timetable\";\n$rv = nuRunQuery($sql);\n$r = db_fetch_row($rv);\n$current_timetable_date = $r[0];\n\n$sql = \"SELECT hide_teaching_calendar \n		FROM school where id=1\";\n$rv2 = nuRunQuery($sql);\n$r2 = db_fetch_row($rv2);\n$hide_teaching_calendar = $r2[0];\n\n	\n$sql = \"SELECT distinct\n	subject.name 				AS subject_name,\n	subject_type.name 			AS subject_type_name,\n	class.id,\n	subject.id,\n	comment.id,\n	comment.student_comments,\n	comment.hide_to_student,\n	if(comment.student_comments_changed_at>comment.student_viewed_at and \'#nu_user_group#\'=\'Students\',\'1\',\'0\'),\n	if(comment.student_comments_changed_at>comment.parent_viewed_at and \'#nu_user_group#\'=\'Parents\',\'1\',\'0\'),\n	TRIM(ifNULL(subject.exam_curriculum,\'\'))\nFROM \n	(SELECT \n		card.id 			AS id,\n		card.valid_from 	AS valid_from,\n		card.subject_id 	AS subject_id,\n		card.class_id 		AS class_id\n	FROM card \n	WHERE card.valid_from = \'\".$current_timetable_date.\"\') as active_card \n	inner join subject 			on active_card.subject_id = subject.id \n	inner join class 			on active_card.class_id = class.id\n	left  join subject_type 	on subject.subject_type_id = subject_type.id\n	left  join comment			on (comment.subject_id = subject.id and comment.student_id=\'#RECORD_ID#\')\nwhere class.id in (select distinct class_id from student_class where student_id=\'#RECORD_ID#\')	\nORDER BY \n	class.short_name,\n	subject_name,\n	subject_type_name DESC\";\n	\n$retval = nuRunQuery($sql);\n\nprint \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n        \n        <STYLE TYPE=\\\"text/css\\\">\n            .sisTableLine tr:nth-child(even){\n	            background-color: LightSteelBlue;\n            }	\n            .sisTableLine TD{\n                font-weight: normal;    \n            }\n        </STYLE>\n\n        <script>\n            function openTeachingBook(class_id,subject_id){\n                parent.set_session_variable(\'class_id\',class_id);\n                parent.set_session_variable(\'subject_id\',subject_id);\n                parent.nuOpenForm(\'\',\'\', \'57dae2cd92d16c0\', \'#RECORD_ID#\',\'Ημερολόγιο Διδασκαλιών\');\n            }\n            \n            function showComments(comment_id,img){\n                if(img.src!=\'images/note2.png\'){\n                    img.src=\'images/note2.png\';   \n                }\n                parent.nuOpenFormInFrame(\'56ea588f03c272b\',comment_id);\n            }\n            \n            function openExamCurriculum(subject_id){\n                parent.nuOpenFormInFrame(\'5b070b1a5c6dfb0\', subject_id );\n            } \n        </script>\n    </head>\n\n    <body onload=\\\"adjustIframeHeight()\\\">\";\n\nif(!$retval ){\n    print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν τα δεδομένα!</span>\");\n} else {\n    print (\"\n            <table CLASS=\\\"sisTableLine\\\" cellspacing=0 width=100%>\n                <tr height=45> \n                    <th width=350>Μάθημα</th> \n                    <th width=80 align=center>Κατηγορία</th> \n                    <th width=250>Καθηγητής</th>\n                    <th width=100  align=center>Παρατηρήσεις Καθηγητή</th>\n                    \".($hide_teaching_calendar ? \"\" : \"<th width=100  align=center>Ημερολόγιο Διδασκαλιών</th>\").\"\n                    <th width=80  align=center><b>Εξεταστέα Ύλη Μαθήματος</b></th>\n                    \n                </tr>\");\n                \n    while($row = db_fetch_row($retval)){\n    \n        $sql=\"  SELECT distinct\n                        concat(IF(teacher.surname IS NULL,\'\',teacher.surname),IF(teacher.surname IS NULL,\'\',\' \'),IF(teacher.name IS NULL,\'\',teacher.name)),\n                        teacher.hide_teaching_calendar,\n                        IFNULL(teacher.web_page,\'\')\n                FROM card\n                INNER JOIN teacher on card.teacher_id = teacher.id \n                WHERE \n                    card.valid_from = \'\".$current_timetable_date.\"\' AND\n                    card.class_id   = \".$row[2].\" and\n                    card.subject_id = \".$row[3].\"\n                \";\n        $rv2 = nuRunQuery($sql);\n        $teacher_names = \"\";\n        $hide_teacher_book=0;\n        while($r2 = db_fetch_row($rv2)){\n            $nm = ($r2[2]==\'\' ? $r2[0] : \"<a href=\\\"\".$r2[2].\"\\\" target=\\\"_blank\\\">\".$r2[0].\"</a>\");\n            \n            $teacher_names = ($teacher_names == \"\" ? $nm : $teacher_names.\", \".$nm);\n            if($r2[1]==\'1\'){$hide_teacher_book=1;}\n        }\n       \n        print \"\n                <tr height=35>\n                    <td>\".$row[0]. \"</td>\n                    <td align=center>\" .$row[1]. \"</td>\n                    <td>\".$teacher_names.\"</td>\";\n        if(is_null($row[4]) || $row[5]==\'\' || ($row[6]==\'1\' && \'#nu_user_group#\'==\'Students\')){\n            print \"\n                    <td></td>\n            \";    \n        } else {\n            print \"\n                    <td align=center><img src=\\\"images/note2\".($row[7]==\'1\' || $row[8]==\'1\' ? \'_new\' : \'\').\".png\\\" width=20 height=20 onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\" onclick=\\\"showComments(\".$row[4].\",this)\\\" title=\\\"Παρατηρήσεις του καθηγητή προς το μαθητή-Γονέα για το μάθημα αυτό\\\"></td>\n            \";\n        }\n                    \n        print \"            \n                    \".($hide_teaching_calendar ? \"\" : \n                    ($hide_teacher_book ? \"<td align=center></td>\" : \"<td align=center><img src=\\\"images/ebooks.png\\\" width=20 height=20 onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\" onclick=\\\"openTeachingBook(\".$row[2].\",\".$row[3].\")\\\" title=\\\"Λεπτομέρειες για την κάθε διδασκαλία που πραγματοποιήθηκε\\\"></td>\")\n                    ).\"\n                    <td align=center>\n                        \".($row[9]==\"\" ? \"\" : \"<img src=\\\"images/book-bookmark.png\\\" width=20 height=20 onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\" onclick=\\\"openExamCurriculum(\".$row[3].\")\\\" title=\\\"Ύλη εξετάσεων για το συγκεκριμένο μάθημα\\\">\").\"\n                    </td>\n                </tr>\";\n    }\n    print (\"\n        </table>\");\n}\nprint \"\n    </body>\n</html>\";','','0','2014-11-27 21:49:55','globeadmin','2020-03-29 17:17:20','globeadmin','2020-11-09 08:18:13','globeadmin','0'),('547cce2020be0b5','student_classes','Τμήματα που ανήκει ο Μαθητής','student','$sql = \"SELECT concat(class.short_name,IF(class.name is Null,\'\',concat(\' (\',class.name,\')\'))),student_class.new_id,class.short_name\n        FROM student_class\n        INNER JOIN class ON student_class.class_id=class.id\n        where student_id=\'#RECORD_ID#\'\n        order by class.short_name\";\n\n$retval = nuRunQuery($sql);\n\nprint \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n        \n        <STYLE TYPE=\\\"text/css\\\">\n            .sisTableLine TH{\n                font-size:9pt;\n            }\n            \n            .sisTableLine TD{\n                font-size:9pt;\n                font-weight: normal;\n            }            \n            \n            \n            .sisTableLine tr:nth-child(even){\n	            background-color: LightSteelBlue;\n            }\n        </STYLE>\n\n\n        <script>\n            function remove_class(student_class_id){\n                if(confirm(\'Ο Μαθητής θα διαγραφεί από το τμήμα!\\\\nΕίστε Σίγουρος;\')){\n                    parent.nuSetHash(\'student_class_id\', student_class_id);\n                    parent.nuAjax(\'student_class_delete_row\',\'reload_classes\')\n                }\n            }\n            \n            function add_class(){\n                parent.nuOpenFormInFrame(\'59d294a40ecced8\', \'#RECORD_ID#\');\n            }\n        </script>\n    </head>\n\n    <body>\";\n\nif(!$retval){\n    print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν δεδομένα!</span>\");\n} else{\n    print \"\n        <table cellspacing=0 CLASS=\\\"sisTableLine\\\">\n            <tr height=30> \n                <th width=440>Τμήμα</th>\";\n        if( (\'#nu_user_group#\'==\'globeadmin\' ||\n            \'#nu_user_group#\'==\'Managers\' ||\n            \'#nu_user_group#\'==\'AssistManagers\' ||\n            \'#nu_user_group#\'==\'Administrators\') && \'#RECORD_ID#\'!=\'-1\'){\n            print \"\n                <th><img src=\\\"images/add.png\\\" width=16 height=16 onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\" onclick=\\\"add_class()\\\" title=\\\"Εσαγωγή του Μαθητή σε νέα τμήματα\\\"></th>\";\n        }\n        print \"            \n            </tr>\";\n        \n    while($row = db_fetch_row($retval)){\n            print \"\n            <tr height=26>\n                <td>\".$row[0]. \"</td>\";\n            if( (\'#nu_user_group#\'==\'globeadmin\' ||\n            \'#nu_user_group#\'==\'Managers\' ||\n            \'#nu_user_group#\'==\'AssistManagers\' ||\n            \'#nu_user_group#\'==\'Administrators\') && \'#RECORD_ID#\'!=\'-1\'){\n                print \"\n                <td><img src=\\\"images/x.png\\\" width=16 height=16 onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\" onclick=\\\"remove_class(\".$row[1].\")\\\" title=\\\"Διαγραφή του Μαθητή από το \".$row[2].\"\\\"></td>\";\n            }    \n            print \"\n            </tr>\";\n    }\n    print (\"\n        </table>\");\n}\nprint \"\n    </body>\n</html>\";','','0','2014-12-01 22:22:56','globeadmin','2018-07-16 10:23:04','globeadmin','2020-09-13 20:26:47','globeadmin','0'),('5494859e9bfaf58','teacher_lessons','Διδασκαλίες Καθηγητή','teacher','$sql = \"SELECT distinct\n            subject.name,\n            subject_type.name,\n            class.short_name,\n            subject.is_marked,\n            class.id,\n            subject.id,\n            TRIM(ifNULL(subject.exam_curriculum,\'\'))\n        FROM \n	        (SELECT \n		        card.id 			AS id,\n		        card.valid_from 	AS valid_from,\n		        card.subject_id 	AS subject_id,\n		        card.teacher_id 	AS teacher_id,\n		        card.class_id 		AS class_id,\n		        card.classroom_id 	AS classroom_id,\n		        card.day_id 		AS day_id,\n		        card.period_id 		AS period_id \n	        FROM card \n	        WHERE card.valid_from =\n		        (	SELECT max(timetable.start_date) \n			        FROM timetable \n			        )) as active_card \n	        inner join subject 			on active_card.subject_id = subject.id \n	        inner join teacher 			on active_card.teacher_id = teacher.id  \n	        inner join day 				on active_card.day_id = day.id  \n	        inner join period 			on active_card.period_id = period.id\n	        inner join class 			on active_card.class_id = class.id	\n	        left  join subject_type 	on subject.subject_type_id = subject_type.id  \n	        left  join classroom 		on active_card.classroom_id = classroom.id  \n        WHERE active_card.teacher_id=\'#RECORD_ID#\'\n        ORDER BY class.short_name,subject.name,subject_type.name DESC\";\n\n$retval = nuRunQuery($sql);\n\nprint \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n        \n        <STYLE TYPE=\\\"text/css\\\">\n            .sisTableLine TD{\n                font-weight: normal;\n            }\n            .sisTableLine tr:nth-child(even){\n	            background-color: LightSteelBlue;\n            }\n        </STYLE>\n\n        <script>\n            function openTeachingBook(class_id,subject_id){\n                parent.set_session_variable(\'class_id\',class_id);\n                parent.set_session_variable(\'subject_id\',subject_id);\n                parent.nuOpenForm(\'\',\'\', \'56e052ae98309fe\', \'#RECORD_ID#\',\'Ημερολόγιο Διδασκαλιών\');\n            }\n            \n            function openConnentList(class_id,subject_id){\n                parent.set_session_variable(\'class_id\',class_id);\n                parent.set_session_variable(\'subject_id\',subject_id);\n                parent.nuOpenForm(\'\',\'\', \'56eae5254137ba7\', \'#RECORD_ID#\',\'Σχόλια για τους Μαθητές της Διδασκαλίας\');\n            }\n            \n            function openExamCurriculum(subject_id){\n                parent.nuOpenFormInFrame(\'5b04854d1104747\', subject_id );\n            } \n            \n            function get_students(class_id,subject_id){\n                parent.showLoader();\n                parent.set_session_variable(\'class_id\',class_id);\n                parent.set_session_variable(\'subject_id\',subject_id);\n                parent.nuAjax(\'class_excel_export\',\'get_excel_file\',{async:true});\n            }\n        </script>\n    \n    </head>\n\n    <body onload=\\\"adjustIframeHeight()\\\">\";\n\nif(!$retval ){\n    print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν τα δεδομένα!</span>\");\n} else{\n    print (\"\n        <table CLASS=\\\"sisTableLine\\\" cellspacing=0 width=100%>\n            <tr height=45> \n                <th width=60>Τμήμα</th> \n                <th width=350>Μάθημα</th> \n                <th width=80  align=center>Κατηγορία</th> \n                <th width=80  align=center>Βαθμολογείται</th>\n                <th width=100  align=center>Ημερολόγιο Διδασκαλιών</th>\n                <th width=80  align=center>Σχόλια για τους Μαθητές</th>\n                <th width=80  align=center>Εξεταστέα Ύλη Μαθήματος</th>\n            </tr>\");\n    \n    $subject_ids = array();\n    \n    while($row = db_fetch_row($retval)){\n        \n        if(array_search($row[5],$subject_ids) === false){\n            $show_exam_curriculum = true;\n            $subject_ids[] = $row[5];\n        } else {\n            $show_exam_curriculum = false;   \n        }\n        \n        print \"\n            <tr height=35>\n                <td>\n                <img src=\\\"images/disk_save.png\\\" width=16 height=16 onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\" onclick=\\\"get_students(\".$row[4].\",\".$row[5].\")\\\" title=\\\"Λήψη Αρχείου Excel με τους Μαθητές\\\">\".$row[2]. \"</a></td>\n                <td>\" .$row[0]. \"</td>\n                <td align=center>\" . $row[1]. \"</td>\n                <td align=center>\" .($row[3]==0 ? \'Όχι\' : \'Ναι\'). \"</td>\n                <td align=center><img src=\\\"images/ebooks.png\\\" width=20 height=20 onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\" onclick=\\\"openTeachingBook(\".$row[4].\",\".$row[5].\")\\\" title=\\\"Λεπτομέρειες για την κάθε διδασκαλία που πραγματοποιήθηκε\\\"></td>\n                <td align=center><img src=\\\"images/edit_red.png\\\" width=20 height=20 onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\" onclick=\\\"openConnentList(\".$row[4].\",\".$row[5].\")\\\" title=\\\"Σχόλια για κάθε μαθητή όσον αφορά τη συγκεκριμένη διδασκαλία\\\"></td>\n                <td align=center>\".($show_exam_curriculum ? \"<img src=\\\"images/\".($row[6]==\"\" ? \"book.png\" : \"book-bookmark.png\").\"\\\" width=20 height=20 onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\" onclick=\\\"openExamCurriculum(\".$row[5].\")\\\" title=\\\"Ύλη εξετάσεων για το συγκεκριμένο μάθημα\\\">\" : \"\").\"</td>\n            </tr>\";\n    }\n    print (\"\n        </table>\");\n}\nprint \"\n    </body>\n</html>\";','','0','2014-12-19 22:07:58','globeadmin','2018-08-02 21:43:46','globeadmin','2018-08-02 21:43:46','globeadmin','0'),('5487369544262a7','addSessionVariablesRow','Προσθέτει μια γραμμή στον πίνακα session_variables για τη τρέχουσα περίοδο','sisyphos','//Clean up inactive session rows\n\n$sql = \"DELETE FROM session_variables WHERE session_id not in (select distinct zzzsys_session_id from zzzsys_session)\"; \n$retval = nuRunQuery($sql);\n\n//Check if row has allready added \n$sql = \"select count(*) as cnt from session_variables WHERE session_id=\'#session_id#\'\";\n$retval = nuRunQuery($sql);\n\nif($retval ){\n    if($row = db_fetch_row($retval)) {\n        if($row[0]==0){\n            $sql = \"INSERT INTO session_variables (temp_id,session_id) VALUES (NULL,\'#session_id#\')\"; \n            $retval2 = nuRunQuery($sql);\n        }\n    }\n}\n\n','','0','2014-12-09 19:51:17','globeadmin','2017-11-12 13:26:18','globeadmin','2021-03-09 15:12:16','globeadmin','0'),('54889d24766371b','setSessionVariable','Ορίζει την τιμή μιας session variable με όνομα varname','sisyphos','if(\'#varname#\'!=\'#\'.\'varname#\' && \'#varname#\'!=\'\' && \'#varname#\'!=\'student_id\' && \'#varname#\'!=\'teacher_id\' && \'#varval#\'!=\'#\'.\'varval#\'){\n    $sql=\"update session_variables set `#varname#`=\'#varval#\' where session_id=\'#session_id#\'\";\n    $retval = nuRunQuery($sql);\n    $nuParameters = -1;    \n}\n\n','','0','2014-12-10 21:21:08','globeadmin','2017-11-12 14:55:02','globeadmin','2017-11-12 14:55:02','globeadmin','0'),('548b2b8d4b3f282','initializeSessionVariables','Αρχικοποιεί τις session_variables','sisyphos','$sql=\"select id from student where user_id=\'#nu_user_id#\' OR parent_user_id=\'#nu_user_id#\' limit 1\";\n$retval = nuRunQuery($sql);\n\n$student = -1;\nif($retval){\n    if($row = db_fetch_row($retval)) {\n        $student=$row[0];\n    }\n}\n\n$sql=\"select id from teacher where user_id=\'#nu_user_id#\' limit 1\";\n$retval = nuRunQuery($sql);\n\n$teacher = -1;\nif($retval ){\n    if($row = db_fetch_row($retval)) {\n        $teacher=$row[0];\n    }\n}\n\n$sql=\"  SELECT \n            grading_period.id,\n            ifNULL(grading_period.num_of_decimals,0),\n            school.open_absence_books\n    FROM school,grading_period \n    WHERE school.grading_period_id=grading_period.id \n    and CURDATE() between grading_period.start_date and grading_period.end_date limit 1\";\n$retval = nuRunQuery($sql);\n\n$grading_period = -1;\n$num_of_decimals = 0;\n\nif($retval){\n    if($row = db_fetch_row($retval)) {\n        $grading_period=$row[0];\n        $num_of_decimals=$row[1];\n    }\n}\n\n$sql=\"SELECT open_absence_books FROM school WHERE id=1\";\n$retval = nuRunQuery($sql);\n\n$open_absence_books = 0;\n\nif($retval){\n    if($row = db_fetch_row($retval)) {\n        $open_absence_books=$row[0];\n    }\n}\n\n$sql=\"  UPDATE session_variables SET \n            student_id=\".$student.\", \n            teacher_id=\".$teacher.\", \n            grading_period_id=\".$grading_period.\", \n            grading_period_decimals=\".$num_of_decimals.\",\n            open_absence_books=\".$open_absence_books.\"\n        WHERE session_id=\'#session_id#\'\";\nnuRunQuery($sql);\n','','0','2014-12-12 19:53:17','globeadmin','2016-10-09 15:26:32','globeadmin','2021-03-09 15:12:51','globeadmin','0'),('548897f34ce2b64','getSessionVariable','Βρίσκει την τιμή μιας session variable με όνομα varname','sisyphos','$nuParameters = -1;\n\nif(\'#varname#\'!=\'#\'.\'varname#\' && \'#varname#\'!=\'\'){\n\n    if(\'#varname#\'==\'student_id\'){\n        $sql=\"select id from student where user_id=\'#nu_user_id#\' OR parent_user_id=\'#nu_user_id#\' limit 1\";    \n    } else if(\'#varname#\'==\'teacher_id\'){\n        $sql=\"select id from teacher where user_id=\'#nu_user_id#\' limit 1\";\n    } else {\n        $sql=\"select `#varname#` from session_variables where session_id=\'#session_id#\' limit 1\";\n    }\n    \n    $retval = nuRunQuery($sql);\n    \n    if($retval ){\n        if($row = db_fetch_row($retval)) {\n            if (!is_null($row[0])){\n                $nuParameters=$row[0];\n            }\n        }\n    }    \n}\n\n','','0','2014-12-10 20:58:59','globeadmin','2017-11-12 14:21:41','globeadmin','2017-11-12 14:21:41','globeadmin','0'),('5495d3357b0fb7c','teacher_programs','Πρόγραμμα Καθηγητή','teacher','$sql = \"select  \n	    dp.day_name,\n	    dp.period_short_name,\n	    c.subject_name,\n	    c.subject_type_name,\n        c.classroom_short,\n        c.class_short,\n        dp.day_id\n	from (	select day.id as day_id,day.name as day_name,day.short_name as day_short_name, period.id as period_id,period.name as period_name,period.short_name as period_short_name\n			from day,period\n			order by day.id,period.id) as dp\n	left join (\n	\n                SELECT\n	                active_card.day_id 			AS day_id,\n	                active_card.period_id 		AS period_id,\n	                day.name 					AS day_name,\n	                period.short_name 			AS period_short,\n	                subject.name 				AS subject_name,\n	                subject_type.name 			AS subject_type_name,\n	                classroom.short_name 		AS classroom_short,\n	                class.short_name 			AS class_short\n                FROM \n	                (SELECT \n		                card.id 			AS id,\n		                card.valid_from 	AS valid_from,\n		                card.subject_id 	AS subject_id,\n		                card.teacher_id 	AS teacher_id,\n		                card.class_id 		AS class_id,\n		                card.classroom_id 	AS classroom_id,\n		                card.day_id 		AS day_id,\n		                card.period_id 		AS period_id \n	                FROM card \n	                WHERE card.valid_from =\n		                (	SELECT max(timetable.start_date) \n			                FROM timetable \n			                WHERE (timetable.start_date <= curdate()))) as active_card \n	                inner join subject 			on active_card.subject_id = subject.id \n	                inner join teacher 			on active_card.teacher_id = teacher.id  \n	                inner join day 				on active_card.day_id = day.id  \n	                inner join period 			on active_card.period_id = period.id\n	                inner join class 			on active_card.class_id = class.id	\n	                left  join subject_type 	on subject.subject_type_id = subject_type.id  \n	                left  join classroom 		on active_card.classroom_id = classroom.id  \n                WHERE active_card.teacher_id is NULL OR active_card.teacher_id=\'#RECORD_ID#\' \n				) as c ON (c.day_id=dp.day_id AND c.period_id=dp.period_id)\n	\n    order by dp.day_id,dp.period_id\";\n\n$retval = nuRunQuery($sql);\n\nprint \"<html>\";\nprint \" <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n        <STYLE TYPE=\\\"text/css\\\">\n            .sisTableLine TD{\n                font-weight: normal;\n            }\n        </STYLE>\n    </head>\n\n    <body onload=\\\"adjustIframeHeight()\\\">\";\n\nif(!$retval ){\n    print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν τα δεδομένα!</span>\");\n} else{\n    print (\"\n        <table CLASS=\\\"sisTableLine\\\" cellspacing=0 width=100%>\n            <tr height=30> \n                <th width=100 align=center>Ημέρα</th> \n                <th width=80 align=center>Ώρα</th> \n                <th width=100 align=center>Τμήμα</th> \n                <th width=400 align=center>Μάθημα</th> \n                <th width=140 align=center>Κατηγορία</th> \n                <th width=80 align=center>Αίθουσα</th>\n            </tr>\");\n                \n    $color1 = \'LightBlue\';\n    $color2 = \'LightSteelBlue\';\n    \n    $color = $color2;\n    $cur_day=-1;\n    \n    while($row = db_fetch_row($retval)){\n        if ($cur_day!=$row[6]){$color = ($color==$color1 ? $color2 : $color1);$cur_day=$row[6];}\n        print \"\n            <tr style=\\\"background-color:$color;\\\" height=25>\n                <td align=center valign=center>\".$row[0].\"</td>\n                <td align=center valign=center>\".$row[1].\"</td>\n                <td align=center valign=center>\".$row[5].\"</td>\n                <td align=left valign=center>\".$row[2].\"</td>\n                <td align=center valign=center>\".$row[3].\"</td>\n                <td align=center valign=center>\".$row[4].\"</td>\n            </tr>\";\n    }\n    print (\"\n        </table>\");\n}\n    \nprint \"\n    </body>\n</html>\";','','0','2014-12-20 21:51:17','globeadmin','2018-07-15 23:13:33','globeadmin','2018-07-28 19:52:06','globeadmin','0'),('5498454b86171f6','print_marks','Εκτυπώνει τους βαθμούς συγκεκριμένου τμήματος και μαθήματος','sisyphos','$sql=\"SELECT distinct CONCAT(teacher_name,\' \',IFNULL(teacher_surname,\'\'))	\nFROM (SELECT\n	teacher.surname 			AS teacher_surname,\n	teacher.name 				AS teacher_name,\n	active_card.subject_id 		AS subject_id,\n	active_card.class_id 		AS class_id\nFROM \n	(SELECT \n		card.id 			AS id,\n		card.valid_from 	AS valid_from,\n		card.subject_id 	AS subject_id,\n		card.teacher_id 	AS teacher_id,\n		card.class_id 		AS class_id,\n		card.classroom_id 	AS classroom_id,\n		card.day_id 		AS day_id,\n		card.period_id 		AS period_id \n	FROM card \n	WHERE card.valid_from =\n		(	SELECT max(timetable.start_date) \n			FROM timetable \n			WHERE (timetable.start_date <= curdate()))) as active_card \n	inner join subject 			on active_card.subject_id = subject.id \n	inner join teacher 			on active_card.teacher_id = teacher.id  \n	inner join day 				on active_card.day_id = day.id  \n	inner join period 			on active_card.period_id = period.id\n	inner join class 			on active_card.class_id = class.id	\n	left  join subject_type 	on subject.subject_type_id = subject_type.id  \n	left  join classroom 		on active_card.classroom_id = classroom.id ) as active_card_full, session_variables\nwhere \n	session_variables.session_id = \'#session_id#\' and\n    active_card_full.subject_id = session_variables.mark_print_subject_id and\n    active_card_full.class_id = session_variables.mark_print_class_id\";    \n    \n$retval = nuRunQuery($sql);\n$teachers=\'\';\n$first=true;\n\nif($retval ){\n        while($row = db_fetch_row($retval)){\n            if($first){\n                $teachers=$row[0];\n                $first=false;\n                }\n            else{\n                $teachers=$teachers.\'\n\'.$row[0];\n                }\n            }\n    }\n\n$sql=\"DROP TEMPORARY TABLE IF EXISTS #TABLE_ID#\";\nnuRunQuery($sql);\n\n$sql=\"CREATE TEMPORARY TABLE #TABLE_ID# DEFAULT CHARACTER SET=utf8\nSELECT\n    if(mark.value is null,\'-\',mark.value) as value_p,\n	mark.grading_period_id as grading_period_id,\n	mark.student_id as student_id,\n	mark.subject_id as print_marks_subject_id,\n	mark.post_teacher_id as post_teacher_id,\n    grading_period.name as grading_period_name,\n    student.name as student_name,\n    student.surname as student_surname,\n    student.fathers_name as student_fathers_name,\n    student.registration_number as student_registration_number,\n    subject.name as subject_name,\n    subject_type.name as subject_type_name,\n    concat(subject.name,\' (\',subject_type.name,\')\') as subject_full_name,\n    concat(IFNULL(teacher.name,\'\'),\' \',IFNULL(teacher.surname,\'\')) as teacher_name,\n    school.name as school_name,\n    school_year.name as school_year_name,\n    DATE_FORMAT(curdate(),\'%d-%m-%Y\') as cur_date,\n    class.short_name as class_short,\n    if(curdate()<=grading_period.end_date,\'Προσωρινή\',\'Οριστική\') as cond,\n     \'\".$teachers.\"\' as teacher_names\nFROM \n    mark,\n    subject_type, \n    grading_period,\n    student,\n    subject,\n    teacher,\n    school,\n    school_year,\n    session_variables,\n    class\nwhere\n    mark.grading_period_id=grading_period.id and\n    mark.student_id=student.id and\n    mark.subject_id=subject.id and\n    mark.post_teacher_id=teacher.id and\n    school_year.id=school.school_year_id and\n    subject.subject_type_id=subject_type.id and\n    session_variables.session_id=\'#session_id#\' and\n    mark.subject_id=session_variables.mark_print_subject_id and\n    mark.grading_period_id=session_variables.mark_print_grading_period_id and\n    class.id=session_variables.mark_print_class_id and\n    mark.class_id=session_variables.mark_print_class_id\n    \norder by student_surname,student_name,student_fathers_name\n\";\nnuRunQuery($sql);','','0','2014-12-22 18:22:35','globeadmin','2016-02-09 19:37:08','globeadmin','2018-07-16 15:55:16','globeadmin',''),('549ef456718c2ed','print_marks_teacher_full','Εκτυπώνει όλους τους επιλεγμένους βαθμούς του Καθηγητή','sisyphos','$sql=\"DROP TEMPORARY TABLE IF EXISTS #TABLE_ID#\";\nnuRunQuery($sql);\n\n$sql=\"CREATE TEMPORARY TABLE #TABLE_ID# DEFAULT CHARACTER SET=utf8\nSELECT\n    if(mark.value is null,\'-\',mark.value) as value_p,\n	mark.grading_period_id as grading_period_id,\n	mark.student_id as student_id,\n	mark.subject_id as subject_id,\n    mark.subject_id as subject_id2,\n	mark.post_teacher_id as post_teacher_id,\n    grading_period.name as grading_period_name,\n    student.name as student_name,\n    student.surname as student_surname,\n    student.fathers_name as student_fathers_name,\n    student.registration_number as student_registration_number,\n    subject.name as subject_name,\n    subject_type.name as subject_type_name,\n    concat(subject.name,\' (\',subject_type.name,\')\') as subject_full_name,\n    school.name as school_name,\n    school_year.name as school_year_name,\n    DATE_FORMAT(curdate(),\'%d-%m-%Y\') as cur_date,\n    class.id as class_id,\n    class.short_name as class_short,\n    if(curdate()<=grading_period.end_date,\'Προσωρινή\',\'Οριστική\') as cond,\n    \'                                                                                                                                                                                                        \' as teacher_names\nFROM \n    mark,\n    subject_type, \n    grading_period,\n    student,\n    subject,\n    school,\n    school_year,\n    class,\n    session_variables\nwhere\n    session_variables.session_id=\'#session_id#\' and\n    mark.grading_period_id=session_variables.mark_print_grading_period_id and\n    \n    mark.grading_period_id=grading_period.id and\n    mark.student_id=student.id and\n    mark.subject_id=subject.id and\n    school_year.id=school.school_year_id and\n    subject.subject_type_id=subject_type.id and\n    mark.class_id=class.id and\n\n    (mark.class_id,mark.subject_id) in (#print_class_subject_ids#)\n\norder by class_short,subject_full_name,student_surname,student_name,student_fathers_name\n\";\nnuRunQuery($sql);\n\n$sql=\"select distinct class_id,subject_id from #TABLE_ID#\";\n$rv = nuRunQuery($sql);\n\nif($rv){\n        while($row = db_fetch_row($rv)){\n            $class_id=$row[0];\n            $subject_id=$row[1];\n\n            $sql=\"  SELECT distinct CONCAT(teacher.name,\' \',IFNULL(teacher.surname,\'\'))	\n                    FROM \n	                    (SELECT \n                    		card.id 			AS id,\n                    		card.valid_from 	AS valid_from,\n                    		card.subject_id 	AS subject_id,\n                    		card.teacher_id 	AS teacher_id,\n                    		card.class_id 		AS class_id,\n                    		card.classroom_id 	AS classroom_id,\n                    		card.day_id 		AS day_id,\n                    		card.period_id 		AS period_id \n                    	FROM card \n                    	WHERE card.valid_from =\n                    		(	SELECT max(timetable.start_date) \n                    			FROM timetable \n                    			WHERE (timetable.start_date <= curdate()))) as active_card \n                    	inner join subject 			on active_card.subject_id = subject.id \n                    	inner join teacher 			on active_card.teacher_id = teacher.id  \n                    	inner join day 				on active_card.day_id = day.id  \n                    	inner join period 			on active_card.period_id = period.id\n                    	inner join class 			on active_card.class_id = class.id	\n                    	left  join subject_type 	on subject.subject_type_id = subject_type.id  \n                    	left  join classroom 		on active_card.classroom_id = classroom.id\n                    where \n                    	active_card.subject_id=\'\".$subject_id.\"\' and active_card.class_id=\'\".$class_id.\"\'\";\n                    	\n            $retval = nuRunQuery($sql);\n            $teachers=\'\';\n            $first=true;\n\n            if($retval){\n                while($row = db_fetch_row($retval)){\n                    if($first){\n                        $teachers=$row[0];\n                        $first=false;\n                        }\n                    else{\n                        $teachers=$teachers.\'\n\'.$row[0];\n                        }\n                    }\n                }\n            if(!$first){\n                $sql=\"update #TABLE_ID# set teacher_names=\'\".$teachers.\"\' where class_id=\".$class_id.\" and subject_id=\".$subject_id;\n                nuRunQuery($sql);\n                }\n            }\n    }\n','','0','2014-12-27 20:03:02','globeadmin','2016-02-09 19:37:14','globeadmin','2018-07-16 15:56:12','globeadmin',''),('54a06aabf3085fe','pass_teachers_lessons','Βρίσκει τις διδασκαλίες του καθηγητή','teacher','$sql=\"SELECT distinct CONCAT(class_id,\',\',subject_id), CONCAT(class_short,\' - \',subject_name,\' (\',subject_type_name,\')\')\nFROM \n(\nSELECT \n	active_card.id 				AS id,\n	active_card.valid_from 		AS valid_from,\n	active_card.subject_id 		AS subject_id,\n	active_card.teacher_id 		AS teacher_id,\n	active_card.class_id 		AS class_id,\n	active_card.classroom_id 	AS classroom_id,\n	active_card.day_id 			AS day_id,\n	active_card.period_id 		AS period_id,\n	teacher.short_name 			AS teacher_short,\n	teacher.surname 			AS teacher_surname,\n	teacher.name 				AS teacher_name,\n	day.name 					AS day_name,\n	day.short_name 				AS day_short,\n	period.short_name 			AS period_short,\n	period.name 				AS period_name,\n	class.short_name 			AS class_short,\n	class.name 					AS class_name,\n	subject.short_name 			AS subject_short,\n	subject.name 				AS subject_name,\n	subject.is_marked 			AS subject_is_marked,\n	subject_type.short_name 	AS subject_type_short,\n	subject_type.name 			AS subject_type_name,\n	classroom.short_name 		AS classroom_short,\n	classroom.name 				AS classroom_name,\n	teacher.email 				AS teacher_email,\n	teacher.user_id 			AS teacher_user_id \nFROM \n	(SELECT \n		card.id 			AS id,\n		card.valid_from 	AS valid_from,\n		card.subject_id 	AS subject_id,\n		card.teacher_id 	AS teacher_id,\n		card.class_id 		AS class_id,\n		card.classroom_id 	AS classroom_id,\n		card.day_id 		AS day_id,\n		card.period_id 		AS period_id \n	FROM card \n	WHERE card.valid_from = (SELECT max(timetable.start_date) FROM timetable)) as active_card \n	inner join subject 			on active_card.subject_id = subject.id \n	inner join teacher 			on active_card.teacher_id = teacher.id  \n	inner join day 				on active_card.day_id = day.id  \n	inner join period 			on active_card.period_id = period.id\n	inner join class 			on active_card.class_id = class.id	\n	left  join subject_type 	on subject.subject_type_id = subject_type.id  \n	left  join classroom 		on active_card.classroom_id = classroom.id  \nORDER BY \n	active_card.teacher_id,\n	active_card.day_id,\n	active_card.period_id\n) as active_card_full\nWHERE \n    teacher_id=#RECORD_ID# and \n    (subject_id, class_id) in \n        (select distinct mark.subject_id, mark.class_id \n        from mark,session_variables \n        where\n            session_variables.session_id=\'#session_id#\' and\n            mark.grading_period_id = session_variables.mark_print_grading_period_id) \n    ORDER BY class_short,subject_name\";\n    \n$retval = nuRunQuery($sql);\n$nuParameters = \'\';\n\nif($retval ){\n    while($row = db_fetch_row($retval)) {\n            if($nuParameters==\'\'){\n                $nuParameters=$row[0].\"\\t\".$row[1];\n            }\n            else{\n                $nuParameters=$nuParameters.\"\\n\".$row[0].\"\\t\".$row[1];\n            }\n        }\n    }','','0','2014-12-28 22:40:11','globeadmin','2022-01-22 10:49:47','globeadmin','2022-01-22 10:49:47','globeadmin','0'),('54a11e8a5b34dee','extract_marks_class','Εξάγει όλους τους βαθμούς σε αρχεία excel ανά τμήμα','manager','function greek_to_greeklish($string) { \nreturn strtr($string, array( \n    \'Α\' => \'A\',\n    \'Ά\' => \'A\',\n    \'Β\' => \'B\', \n    \'Γ\' => \'G\', \n    \'Δ\' => \'D\', \n    \'Ε\' => \'E\',\n    \'Έ\' => \'E\',\n    \'Ζ\' => \'Z\', \n    \'Η\' => \'H\',\n    \'Ή\' => \'H\',\n    \'Θ\' => \'Th\', \n    \'Ι\' => \'I\', \n    \'Ί\' => \'I\',\n    \'Κ\' => \'K\', \n    \'Λ\' => \'L\', \n    \'Μ\' => \'M\', \n    \'Ν\' => \'N\', \n    \'Ξ\' => \'Ks\', \n    \'Ο\' => \'O\',\n    \'Ό\' => \'O\',\n    \'Π\' => \'P\', \n    \'Ρ\' => \'R\', \n    \'Σ\' => \'S\', \n    \'Τ\' => \'T\', \n    \'Υ\' => \'Y\',\n    \'Ύ\' => \'Y\',\n    \'Φ\' => \'F\', \n    \'Χ\' => \'X\', \n    \'Ψ\' => \'Ps\', \n    \'Ω\' => \'O\',\n    \'Ώ\' => \'O\',\n    \'α\' => \'a\', \n    \'β\' => \'v\', \n    \'γ\' => \'g\', \n    \'δ\' => \'d\', \n    \'ε\' => \'e\', \n    \'ζ\' => \'z\', \n    \'η\' => \'h\', \n    \'θ\' => \'th\', \n    \'ι\' => \'i\', \n    \'κ\' => \'k\', \n    \'λ\' => \'l\', \n    \'μ\' => \'m\', \n    \'ν\' => \'n\', \n    \'ξ\' => \'ks\', \n    \'ο\' => \'o\', \n    \'π\' => \'p\', \n    \'ρ\' => \'r\', \n    \'σ\' => \'s\', \n    \'τ\' => \'t\', \n    \'υ\' => \'y\', \n    \'φ\' => \'f\', \n    \'χ\' => \'x\', \n    \'ψ\' => \'ps\', \n    \'ω\' => \'o\', \n    \'ς\' => \'s\', \n    \'ά\' => \'a\', \n    \'έ\' => \'e\', \n    \'ή\' => \'h\', \n    \'ί\' => \'i\', \n    \'ό\' => \'o\', \n    \'ύ\' => \'y\', \n    \'ώ\' => \'o\', \n    \'ϊ\' => \'i\', \n    \'ϋ\' => \'y\', \n    \'ΐ\' => \'i\', \n    \'ΰ\' => \'y\' \n    )); \n}\n\nfunction repair_file_name($string) { \nreturn strtr($string, array(\n    \' \' => \'_\',\n    \'\\\\\' => \'_\',\n    \'/\' => \'_\',\n    \':\' => \'_\', \n    \'*\' => \'_\', \n    \'?\' => \'_\', \n    \'\"\' => \'_\',\n    \'<\' => \'_\',\n    \'>\' => \'_\', \n    \'|\' => \'_\',\n    \',\' => \'_\'\n    )); \n}\n\nprint \"<html>\n    <head>\n\n        <meta charset=\\\"UTF-8\\\">\n        \n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n        \n        <style>\n            .sisTable tr:nth-child(even){\n	            background-color: LightSteelBlue;\n            }\n            a:link {\n                color:#0000AA;\n                background-color:transparent;\n                text-decoration:none;\n            }\n            a:visited {\n                color:#0000AA;\n                background-color:transparent;\n                text-decoration:none;\n            }\n            a:hover {\n                color:#ff0000;\n                background-color:transparent;\n                text-decoration:underline;\n            }\n            a:active {\n                color:#ff0000;\n                background-color:transparent;\n                text-decoration:underline;\n            }\n        </style>\n\n        <script type=\\\"text/javascript\\\">\n\n            function publish(check,grading_period_id,class_id,subject_id) {\n    \n                if(check.checked){\n                    if(confirm(\\\"Η βαθμολογία αυτή θα οριστεί ως κλειδωμένη! \\\\n\\\\nΕίστε Σίγουρος;\\\")){\n            \n                        parent.nuSetHash(\'g_id\',grading_period_id);\n                        parent.nuSetHash(\'s_id\',subject_id);\n                        parent.nuSetHash(\'c_id\',class_id);\n                        parent.nuSetHash(\'to_publish\',\'1\');\n                        parent.nuAjax(\'publish_marks\',\'foo\');\n            \n                        make_indeterminate();\n                    } else {\n                        check.checked = false;    \n                    }\n                } else {\n                    if(confirm(\\\"Η βαθμολογία αυτή θα οριστεί ως ξεκλείδωτη! \\\\n\\\\nΕίστε Σίγουρος;\\\")){\n            \n                        parent.nuSetHash(\'g_id\',grading_period_id);\n                        parent.nuSetHash(\'s_id\',subject_id);\n                        parent.nuSetHash(\'c_id\',class_id);\n                        parent.nuSetHash(\'to_publish\',\'0\');\n                        parent.nuAjax(\'publish_marks\',\'foo\');\n            \n                        make_indeterminate();\n                    } else {\n                        check.checked = true;\n                    }\n                }\n            }\n\n            function publish_all(check,grading_period_id) {\n    \n                if(check.checked){\n                    if(confirm(\\\"ΠΡΟΣΟΧΗ!\\\\n\\\\nΌΛΗ η καταχωρημένη βαθμολογία αυτής της βαθμολογικής περιόδου\\\\n(όχι μόνο αυτή που εμφανίζεται εδω)\\\\nθα οριστεί ως κλειδωμένη! \\\\n\\\\nΕίστε Σίγουρος;\\\")){\n            \n                        parent.nuSetHash(\'g_id\',grading_period_id);\n                        parent.nuSetHash(\'s_id\',\'\');\n                        parent.nuSetHash(\'c_id\',\'\');\n                        parent.nuSetHash(\'to_publish\',\'1\');\n                        parent.nuAjax(\'publish_marks\',\'foo\');\n            \n                        toggle(check);\n                    } else {\n                        check.checked = false;    \n                    }\n                } else {\n                    if(confirm(\\\"ΠΡΟΣΟΧΗ!\\\\n\\\\nΌΛΗ η καταχωρημένη βαθμολογία αυτής της βαθμολογικής περιόδου\\\\n(όχι μόνο αυτή που εμφανίζεται εδω)\\\\nθα οριστεί ως ξεκλείδωτη! \\\\n\\\\nΕίστε Σίγουρος;\\\")){\n            \n                        parent.nuSetHash(\'g_id\',grading_period_id);\n                        parent.nuSetHash(\'s_id\',\'\');\n                        parent.nuSetHash(\'c_id\',\'\');\n                        parent.nuSetHash(\'to_publish\',\'0\');\n                        parent.nuAjax(\'publish_marks\',\'foo\');\n            \n                        toggle(check);\n                    } else {\n                        check.checked = true;\n                    }\n                }\n            }\n\n            window.onload = function() {\n\n                var all_checked=true;\n                var all_an_checked=true;\n  \n                checkboxes = document.getElementsByClassName(\'publish_chk\');\n  \n                for(var i=0, n=checkboxes.length;i<n;i++) {\n                    if(checkboxes[i].checked){\n                        all_an_checked=false;\n                    } else {\n                        all_checked=false;\n                    }\n                }\n\n                var all_chk = document.getElementById(\'all_chk\');\n    \n                if(all_checked){\n                    all_chk.checked = true;\n                }\n\n                if(all_an_checked){\n                    all_chk.checked = false;\n                }\n    \n                if(!all_checked && !all_an_checked){\n                    all_chk.indeterminate = true;    \n                }\n            };\n        </script>\n    </head>\n    <body onload=\\\"adjustIframeHeight()\\\">\";\n\nrequire_once(\'Classes/PHPExcel.php\');\n\n$dir = \'tmp/marks_export_\'.date(\"YmdHis\");\n\nif(mkdir($dir)){\n\n$zip = new ZipArchive();\n$zip->open($dir.\'.zip\', ZipArchive::CREATE);\n\n$sql=\"DROP TEMPORARY TABLE IF EXISTS #TABLE_ID#\";\nnuRunQuery($sql);\n\n$sql=\"CREATE TEMPORARY TABLE #TABLE_ID# DEFAULT CHARACTER SET=utf8\n    SELECT\n	mark.grading_period_id as grading_period_id,\n	mark.subject_id as subject_id,\n	mark.class_id as class_id,\n	mark.published as published,\n	\n	student.registration_number as student_registration_number,\n	mark.value as value_p,\n	\n	student.surname as student_surname,\n	student.name as student_name,\n    student.fathers_name as student_fathers_name,\n    \n    grading_period.short_name as grading_period_short_name,\n    CAST(\'\' as CHAR(50)) as grade_short_name,\n    CAST(\'\' as CHAR(250)) as speciality_short_name,\n    class.short_name as class_short_name,\n    subject.name as subject_name,\n    CAST(\'\' as CHAR(50)) as subject_type_name,\n    subject.short_name as subject_short_name,\n    \n    subject.grade_id as subject_grade_id,\n    subject.speciality_id as subject_speciality_id,\n    subject.subject_type_id as subject_subject_type_id\nFROM \n    mark,\n    student,\n    subject,\n    grading_period,\n    class\nwhere\n    mark.grading_period_id=#export_grading_period_id# and\n    mark.grading_period_id=grading_period.id and\n    mark.student_id=student.id and\n    mark.subject_id=subject.id and\n    mark.class_id=class.id\norder by subject.grade_id,class_id,subject.speciality_id,subject_name,subject_type_name,student_surname,student_name,student_fathers_name\n\";\nnuRunQuery($sql);\n\n$sql=\"update #TABLE_ID# \n    INNER JOIN grade ON subject_grade_id=grade.id\n    SET grade_short_name=grade.short_name\";\nnuRunQuery($sql);\n\n$sql=\"update #TABLE_ID# \n    INNER JOIN subject_type ON subject_subject_type_id=subject_type.id\n    SET subject_type_name=subject_type.name\";\nnuRunQuery($sql);\n\n$sql=\"update #TABLE_ID# \n    INNER JOIN speciality ON subject_speciality_id=speciality.id\n    SET speciality_short_name=speciality.short_name\";\nnuRunQuery($sql);\n\nif(\'#export_marks_publishedchk#\'!=\'1\'){\n    $hide_published = false;\n} else {\n    $hide_published = true;\n}\n\n$sql=\"select distinct \n        grading_period_id,\n        class_id,\n        subject_id,\n        grading_period_short_name,\n        grade_short_name,\n        speciality_short_name,\n        class_short_name,\n        subject_name,\n        subject_type_name,\n        subject_short_name\n    from #TABLE_ID#\n    order by class_short_name,subject_name,subject_type_name\n    \";\n    \n$rv = nuRunQuery($sql);\n\nif($rv && db_num_rows($rv)>0) {\n    print (\"\n        <table cellspacing=0 CLASS=\\\"sisTable\\\" align=center>\n            <tr height=40>\n                <th width=50 align=center><a href=\'\".$dir.\".zip\'><img id=\'img_red_disk_s_id\' src=\'images/file-zip.png\' width=18 height=18 title=\'Λήψη Όλων\'></a></th>\n                <th width=70 align=center>Τμήμα</th> \n                <th width=480 align=center>Μάθημα</th>\n                <th width=100 align=center>Τύπος Μαθ.</th>\n                <th width=50 align=center>Κλειδωμένο<br><input type=\\\"checkbox\\\" id=\\\"all_chk\\\" title=\\\"Ορισμός Όλων ως Κλειδωμένα\\\" onclick=\\\"publish_all(this,#export_grading_period_id#)\\\"></th>\n            </tr>\");\n    while($row = db_fetch_row($rv)) {\n        $sql=\"select sum(value_p),count(*),sum(published),sum(if(value_p is NULL,0,1))\n                from #TABLE_ID#\n            where\n                grading_period_id=\".$row[0].\" and\n                class_id =\".$row[1].\" and\n                subject_id=\".$row[2];\n        \n        $rv2 = nuRunQuery($sql);\n        $r=db_fetch_row($rv2);\n        \n        $published = ($r[1]==$r[2] ? true : false);\n        \n        $is_emplty = ($r[3]==0 ? true : false);\n        \n        if(($r[0]>0 || $is_emplty) && (!$hide_published || ($hide_published && !$published))){\n        $sql=\"select \n                student_registration_number,\n                if(value_p is null,\'Δ\',value_p),\n                student_surname,\n                student_name,\n                student_fathers_name\n                from #TABLE_ID#\n            where\n                grading_period_id=\".$row[0].\" and\n                class_id =\".$row[1].\" and\n                subject_id=\".$row[2].\" order by student_surname,student_name,student_fathers_name\";\n                \n        $retval = nuRunQuery($sql);\n        if($retval){\n            \n            $objPHPExcel = new PHPExcel();\n            \n            $objPHPExcel->getProperties()->setCreator(\'Papadakakis Nektarios\')\n							 ->setLastModifiedBy(\'Papadakakis Nektarios\')\n							 ->setTitle(\'sisyphos Export for mySchool\')\n							 ->setSubject(\'sisyphos\')\n							 ->setDescription(\'Marks file for myschool information system\')\n							 ->setKeywords(\'Excel sisyphos myschool\')\n							 ->setCategory(\'sisyphos\');\n			\n            $objPHPExcel->getActiveSheet()->setTitle(\'Βαθμοί\');\n            \n            $objPHPExcel->getDefaultStyle()->getFont()->setName(\'Arial\')\n                                          ->setSize(10);\n            \n            $objPHPExcel->getActiveSheet() ->getColumnDimension(\'C\') ->setWidth(30);\n            $objPHPExcel->getActiveSheet() ->getColumnDimension(\'D\') ->setWidth(25);\n            $objPHPExcel->getActiveSheet() ->getColumnDimension(\'E\') ->setWidth(25);\n            \n            $i=1;\n            while($data = db_fetch_row($retval)){\n                $objPHPExcel->setActiveSheetIndex(0);\n                $objPHPExcel->getActiveSheet()->fromArray($data,NULL,\'A\'.$i);\n                $i++;\n                }\n\n            $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, \'Excel5\');\n\n            $filefordown=   \n                            ((is_null($row[4]) || trim($row[4])==\'\') ? \'Τάξη\' : $row[4]).\'_\'.\n                            ((is_null($row[5]) || trim($row[5])==\'\') ? \'Ειδικότητα\' : $row[5]).\'_\'.\n                            ((is_null($row[6]) || trim($row[6])==\'\') ? \'Τμήμα\' : $row[6]).\'_\'.\n                            ((is_null($row[7]) || trim($row[7])==\'\') ? ((is_null($row[9]) || trim($row[9])==\'\') ? \'Κωδ_Μαθήματος_\'.$row[1] : $row[9]) : $row[7]).\'_\'.\n                            (is_null($row[8]) ? \'\' : $row[8]).\'_\'.\n                            $row[3].\'.xls\';\n            \n            $filefordown=repair_file_name($filefordown);\n            \n            $filefordown=$dir.\'/\'.$filefordown;\n            \n            $objWriter->save($filefordown);\n            \n            $class_name=((is_null($row[6]) || trim($row[6])==\'\') ? \'Τμήμα\' : $row[6]);\n            $subject_name = ((is_null($row[7]) || trim($row[7])==\'\') ? ((is_null($row[9]) || trim($row[9])==\'\') ? \'Κωδ_Μαθήματος_\'.$row[1] : $row[9]) : $row[7]);\n            $subject_type = (is_null($row[8]) ? \' \' : $row[8]);\n            \n            print (\"\n            <tr height=27>\n                <td width=50 align=center><b><a href=\'\".$filefordown.\"\'><img id=\'img_disk_save_id\' src=\'images/sign-down.png\' width=18 height=18 title=\'Λήψη Αρχείου\'></a></b></td>\n                <td width=70 align=center><b>\".$class_name.\"</b></td>\n                <td width=480 align=left><b>\".$subject_name.\"</b></td>\n                <td width=100 align=center><b>\".$subject_type.\"</b></td>\n                <td align=center><input type=\\\"checkbox\\\" id=\\\"\".$row[0].\"_\".$row[1].\"_\".$row[2].\"\\\" title=\\\"\".$class_name.\"-\".$subject_name.\"(\".$subject_type.\") Ορισμός Κλειδώματος\\\" Class=\\\"publish_chk\\\" onclick=\\\"publish(this,\".$row[0].\",\".$row[1].\",\".$row[2].\")\\\"\".($published ? \'checked\' : \'\').\"></td>\n            </tr>\"); \n                \n            $zip->addFile($filefordown, basename(greek_to_greeklish($filefordown)));\n            }\n        }\n        }\n    print (\"\n        </table>\");\n}\nelse{\n    print (\"<span CLASS=\\\"msg\\\">Δεν έχουν καταχωρηθεί βαθμοί για τη βαθμολογική περίοδο!</span>\");\n}\n\n$zip->close();\n\n} else {\n    print (\"<span CLASS=\\\"msgError\\\">Προσοχή : Δεν μπορούν να αποθηκευτουν τα εξαγόμενα αρχεία στον εξυπηρετητή!<br>παρακαλώ επικοινωνήστε με το διαχειριστή του συστήματος!</span>\");    \n}   \n\nprint \"\n    </body>\n</html>\";\n\n\n\n\n\n','','0','2014-12-29 11:27:38','globeadmin','2018-07-15 11:57:27','globeadmin','2020-08-23 14:41:17','globeadmin','0'),('54a2700ab351809','myfoo','Do Nothing','sisyphos','print\"<html>\n    <body>\n    </body>\n</html>\";','','0','2014-12-30 11:27:38','globeadmin','2018-07-17 15:18:37','globeadmin','2018-07-17 15:18:37','globeadmin','0'),('54a2baf998a4dbd','extract_marks_grade','Εξάγει όλους τους βαθμούς σε αρχεία excel ανά τάξη','manager','function greek_to_greeklish($string) { \nreturn strtr($string, array( \n    \'Α\' => \'A\',\n    \'Ά\' => \'A\',\n    \'Β\' => \'B\', \n    \'Γ\' => \'G\', \n    \'Δ\' => \'D\', \n    \'Ε\' => \'E\',\n    \'Έ\' => \'E\',\n    \'Ζ\' => \'Z\', \n    \'Η\' => \'H\',\n    \'Ή\' => \'H\',\n    \'Θ\' => \'Th\', \n    \'Ι\' => \'I\', \n    \'Ί\' => \'I\',\n    \'Κ\' => \'K\', \n    \'Λ\' => \'L\', \n    \'Μ\' => \'M\', \n    \'Ν\' => \'N\', \n    \'Ξ\' => \'Ks\', \n    \'Ο\' => \'O\',\n    \'Ό\' => \'O\',\n    \'Π\' => \'P\', \n    \'Ρ\' => \'R\', \n    \'Σ\' => \'S\', \n    \'Τ\' => \'T\', \n    \'Υ\' => \'Y\',\n    \'Ύ\' => \'Y\',\n    \'Φ\' => \'F\', \n    \'Χ\' => \'X\', \n    \'Ψ\' => \'Ps\', \n    \'Ω\' => \'O\',\n    \'Ώ\' => \'O\',\n    \'α\' => \'a\', \n    \'β\' => \'v\', \n    \'γ\' => \'g\', \n    \'δ\' => \'d\', \n    \'ε\' => \'e\', \n    \'ζ\' => \'z\', \n    \'η\' => \'h\', \n    \'θ\' => \'th\', \n    \'ι\' => \'i\', \n    \'κ\' => \'k\', \n    \'λ\' => \'l\', \n    \'μ\' => \'m\', \n    \'ν\' => \'n\', \n    \'ξ\' => \'ks\', \n    \'ο\' => \'o\', \n    \'π\' => \'p\', \n    \'ρ\' => \'r\', \n    \'σ\' => \'s\', \n    \'τ\' => \'t\', \n    \'υ\' => \'y\', \n    \'φ\' => \'f\', \n    \'χ\' => \'x\', \n    \'ψ\' => \'ps\', \n    \'ω\' => \'o\', \n    \'ς\' => \'s\', \n    \'ά\' => \'a\', \n    \'έ\' => \'e\', \n    \'ή\' => \'h\', \n    \'ί\' => \'i\', \n    \'ό\' => \'o\', \n    \'ύ\' => \'y\', \n    \'ώ\' => \'o\', \n    \'ϊ\' => \'i\', \n    \'ϋ\' => \'y\', \n    \'ΐ\' => \'i\', \n    \'ΰ\' => \'y\' \n    )); \n}\n\nfunction repair_file_name($string) { \nreturn strtr($string, array(\n    \' \' => \'_\',\n    \'\\\\\' => \'_\',\n    \'/\' => \'_\',\n    \':\' => \'_\', \n    \'*\' => \'_\', \n    \'?\' => \'_\', \n    \'\"\' => \'_\',\n    \'<\' => \'_\',\n    \'>\' => \'_\', \n    \'|\' => \'_\'\n    )); \n}\n\nprint \"<html>\n    <head>\n\n        <meta charset=\\\"UTF-8\\\">\n        \n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n        \n        <style>\n            .sisTable tr:nth-child(even){\n	            background-color: LightSteelBlue;\n            }\n            a:link {\n                color:#0000AA;\n                background-color:transparent;\n                text-decoration:none;\n            }\n            a:visited {\n                color:#0000AA;\n                background-color:transparent;\n                text-decoration:none;\n            }\n            a:hover {\n                color:#ff0000;\n                background-color:transparent;\n                text-decoration:underline;\n            }\n            a:active {\n                color:#ff0000;\n                background-color:transparent;\n                text-decoration:underline;\n            }\n        </style>\n\n        <script type=\\\"text/javascript\\\">\n\n            function publish(check,grading_period_id,subject_id) {\n    \n                if(check.checked){\n                    if(confirm(\\\"Η βαθμολογία αυτή θα οριστεί ως κλειδωμένη! \\\\n\\\\nΕίστε Σίγουρος;\\\")){\n            \n                        parent.nuSetHash(\'g_id\',grading_period_id);\n                        parent.nuSetHash(\'s_id\',subject_id);\n                        parent.nuSetHash(\'c_id\',\'\');\n                        parent.nuSetHash(\'to_publish\',\'1\');\n                        parent.nuAjax(\'publish_marks\',\'foo\');\n            \n                        make_indeterminate();\n                    } else {\n                        check.checked = false;    \n                    }\n                } else {\n                    if(confirm(\\\"Η βαθμολογία αυτή θα οριστεί ως ξεκλείδωτη! \\\\n\\\\nΕίστε Σίγουρος;\\\")){\n            \n                        parent.nuSetHash(\'g_id\',grading_period_id);\n                        parent.nuSetHash(\'s_id\',subject_id);\n                        parent.nuSetHash(\'c_id\',\'\');\n                        parent.nuSetHash(\'to_publish\',\'0\');\n                        parent.nuAjax(\'publish_marks\',\'foo\');\n            \n                        make_indeterminate();\n                    } else {\n                        check.checked = true;\n                    }\n                }\n            }\n\n            function publish_all(check,grading_period_id) {\n    \n                if(check.checked){\n                    if(confirm(\\\"ΠΡΟΣΟΧΗ!\\\\n\\\\nΌΛΗ η καταχωρημένη βαθμολογία αυτής της βαθμολογικής περιόδου\\\\n(όχι μόνο αυτή που εμφανίζεται εδω)\\\\nθα οριστεί ως κλειδωμένη! \\\\n\\\\nΕίστε Σίγουρος;\\\")){\n            \n                        parent.nuSetHash(\'g_id\',grading_period_id);\n                        parent.nuSetHash(\'s_id\',\'\');\n                        parent.nuSetHash(\'c_id\',\'\');\n                        parent.nuSetHash(\'to_publish\',\'1\');\n                        parent.nuAjax(\'publish_marks\',\'foo\');\n            \n                        toggle(check);\n                    } else {\n                        check.checked = false;    \n                    }\n                } else {\n                    if(confirm(\\\"ΠΡΟΣΟΧΗ!\\\\n\\\\nΌΛΗ η καταχωρημένη βαθμολογία αυτής της βαθμολογικής περιόδου\\\\n(όχι μόνο αυτή που εμφανίζεται εδω)\\\\nθα οριστεί ως ξεκλείδωτη! \\\\n\\\\nΕίστε Σίγουρος;\\\")){\n            \n                        parent.nuSetHash(\'g_id\',grading_period_id);\n                        parent.nuSetHash(\'s_id\',\'\');\n                        parent.nuSetHash(\'c_id\',\'\');\n                        parent.nuSetHash(\'to_publish\',\'0\');\n                        parent.nuAjax(\'publish_marks\',\'foo\');\n            \n                        toggle(check);\n                    } else {\n                        check.checked = true;\n                    }\n                }\n            }\n\n            window.onload = function() {\n\n                var all_checked=true;\n                var all_an_checked=true;\n  \n                checkboxes = document.getElementsByClassName(\'publish_chk\');\n  \n                for(var i=0, n=checkboxes.length;i<n;i++) {\n                    if(checkboxes[i].checked){\n                        all_an_checked=false;\n                    } else {\n                        all_checked=false;\n                    }\n                }\n\n                var all_chk = document.getElementById(\'all_chk\');\n    \n                if(all_checked){\n                    all_chk.checked = true;\n                }\n\n                if(all_an_checked){\n                    all_chk.checked = false;\n                }\n    \n                if(!all_checked && !all_an_checked){\n                    all_chk.indeterminate = true;    \n                }\n            };\n\n            </script>\n    </head>\n    <body onload=\\\"adjustIframeHeight()\\\">\";\n\nrequire_once(\'Classes/PHPExcel.php\');\n\n$dir = \'tmp/marks_export_\'.date(\"YmdHis\");\n\nif(mkdir($dir)){\n\n$zip = new ZipArchive();\n$zip->open($dir.\'.zip\', ZipArchive::CREATE);\n\n$sql=\"DROP TEMPORARY TABLE IF EXISTS #TABLE_ID#\";\nnuRunQuery($sql);\n\n$sql=\"CREATE TEMPORARY TABLE #TABLE_ID# DEFAULT CHARACTER SET=utf8\n    SELECT\n	mark.grading_period_id as grading_period_id,\n	mark.subject_id as subject_id,\n	mark.class_id as class_id,\n	mark.published as published,\n	\n	student.registration_number as student_registration_number,\n	mark.value as value_p,\n	\n	student.surname as student_surname,\n	student.name as student_name,\n    student.fathers_name as student_fathers_name,\n    \n    grading_period.short_name as grading_period_short_name,\n    CAST(\'\' as CHAR(50)) as grade_short_name,\n    CAST(\'\' as CHAR(250)) as speciality_short_name,\n    class.short_name as class_short_name,\n    subject.name as subject_name,\n    CAST(\'\' as CHAR(50)) as subject_type_name,\n    subject.short_name as subject_short_name,\n    \n    subject.grade_id as subject_grade_id,\n    subject.speciality_id as subject_speciality_id,\n    subject.subject_type_id as subject_subject_type_id\nFROM \n    mark,\n    student,\n    subject,\n    grading_period,\n    class\nwhere\n    mark.grading_period_id=#export_grading_period_id# and\n    mark.grading_period_id=grading_period.id and\n    mark.student_id=student.id and\n    mark.subject_id=subject.id and\n    mark.class_id=class.id\norder by class_id,subject_short_name,student_surname,student_name,student_fathers_name\n\";\nnuRunQuery($sql);\n\n$sql=\"update #TABLE_ID# \n    INNER JOIN grade ON subject_grade_id=grade.id\n    SET grade_short_name=grade.short_name\";\nnuRunQuery($sql);\n\n$sql=\"update #TABLE_ID# \n    INNER JOIN subject_type ON subject_subject_type_id=subject_type.id\n    SET subject_type_name=subject_type.name\";\nnuRunQuery($sql);\n\n$sql=\"update #TABLE_ID# \n    INNER JOIN speciality ON subject_speciality_id=speciality.id\n    SET speciality_short_name=speciality.short_name\";\nnuRunQuery($sql);\n\nif(\'#export_marks_publishedchk#\'!=\'1\'){\n    $hide_published = false;\n} else {\n    $hide_published = true;\n}\n\n$sql=\"select distinct \n        grading_period_id,\n        subject_id,\n        grading_period_short_name,\n        grade_short_name,\n        speciality_short_name,\n        subject_name,\n        subject_type_name,\n        subject_short_name\n    from #TABLE_ID#\n    order by grade_short_name,speciality_short_name,subject_name,subject_type_name,subject_short_name\n    \";\n    \n$rv = nuRunQuery($sql);\n\nif($rv && db_num_rows($rv)>0) {\n    print (\"\n        <table cellspacing=0 CLASS=\\\"sisTable\\\" align=center>\n            <tr height=40>\n                <th width=50 align=center><a href=\'\".$dir.\".zip\'><img id=\'img_red_disk_s_id\' src=\'images/file-zip.png\'/ width=18 height=18 title=\'Λήψη Όλων\'></a></th>\n                <th width=70 align=center>Τάξη</th> \n                <th width=480 align=center>Μάθημα</th>\n                <th width=100 align=center>Τύπος Μαθ.</th>\n                <th width=50 align=center>Κλειδωμένο<br><input type=\\\"checkbox\\\" id=\\\"all_chk\\\" title=\\\"Ορισμός Όλων ως Κλειδωμένων ή Μη\\\" onclick=\\\"publish_all(this,#export_grading_period_id#)\\\"></th>\n            </tr>\");\n\n    while($row = db_fetch_row($rv)) {\n        $sql=\"select sum(value_p),count(*),sum(published),sum(if(value_p is NULL,0,1))\n                from #TABLE_ID#\n            where\n                grading_period_id=\".$row[0].\" and\n                subject_id=\".$row[1];\n        \n        $rv2 = nuRunQuery($sql);\n        $r=db_fetch_row($rv2);\n        \n        $published = ($r[1]==$r[2] ? true : false);\n        \n        $is_emplty = ($r[3]==0 ? true : false);\n        \n        if(($r[0]>0 || $is_emplty) && (!$hide_published || ($hide_published && !$published))){\n        $sql=\"select \n                student_registration_number,\n                if(value_p is null,\'Δ\',value_p),\n                student_surname,\n                student_name,\n                student_fathers_name\n            from #TABLE_ID#\n            where\n                grading_period_id=\".$row[0].\" and\n                subject_id=\".$row[1].\" order by student_surname,student_name,student_fathers_name\";\n\n        $retval = nuRunQuery($sql);\n        if($retval){\n            \n            $objPHPExcel = new PHPExcel();\n\n            $objPHPExcel->getProperties()->setCreator(\'Papadakakis Nektarios\')\n							 ->setLastModifiedBy(\'Papadakakis Nektarios\')\n							 ->setTitle(\'Sisyphos Export for mySchool\')\n							 ->setSubject(\'Marks\')\n							 ->setDescription(\'Marks file for myschool information system\')\n							 ->setKeywords(\'Excel Sisyphos myschool\')\n							 ->setCategory(\'Sisyphos\');\n			\n            $objPHPExcel->getActiveSheet()->setTitle(\'Βαθμοί\');\n            \n            $objPHPExcel->getDefaultStyle()->getFont()->setName(\'Arial\')\n                                          ->setSize(10);\n\n            $objPHPExcel->getActiveSheet() ->getColumnDimension(\'C\') ->setWidth(30);\n            $objPHPExcel->getActiveSheet() ->getColumnDimension(\'D\') ->setWidth(25);\n            $objPHPExcel->getActiveSheet() ->getColumnDimension(\'E\') ->setWidth(25);	\n            \n            $i=1;\n            while($data = db_fetch_row($retval)){\n                $objPHPExcel->setActiveSheetIndex(0);\n                $objPHPExcel->getActiveSheet()->fromArray($data,NULL,\'A\'.$i);\n                $i++;\n            }\n\n            $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, \'Excel5\');\n\n            $filefordown=\n                        ((is_null($row[3]) || trim($row[3])==\'\') ? \'Τάξη\' : $row[3]).\'_\'.\n                        ((is_null($row[4]) || trim($row[4])==\'\') ? \'Ειδικότητα\' : $row[4]).\'_\'.\n                        ((is_null($row[5]) || trim($row[5])==\'\') ? ((is_null($row[7]) || trim($row[7])==\'\') ? \'Κωδ_Μαθήματος_\'.$row[1] : $row[7]) : $row[5]).\'_\'.\n                        (is_null($row[6]) ? \'\' : $row[6]).\'_\'.\n                        $row[2].\'.xls\';\n            \n            $filefordown=repair_file_name($filefordown);\n            \n            $filefordown=$dir.\'/\'.$filefordown;\n            \n            $objWriter->save($filefordown);\n            \n            $grade_name = ((is_null($row[3]) || trim($row[3])==\'\') ? \'Τάξη\' : $row[3]);\n            $subject_name = ((is_null($row[5]) || trim($row[5])==\'\') ? ((is_null($row[7]) || trim($row[7])==\'\') ? \'Κωδ_Μαθήματος_\'.$row[1] : $row[7]) : $row[5]);\n            $subject_type = (is_null($row[6]) ? \'\' : $row[6]);\n            \n            print (\"\n            <tr height=27>\n                <td width=50 align=center><b><a href=\'\".$filefordown.\"\'><img id=\'img_disk_save_id\' src=\'images/sign-down.png\'/ width=18 height=18 title=\'Λήψη Αρχείου\'></a></b></td>\n                <td width=70 align=center><b>\".$grade_name.\"</b></td>\n                <td width=480 align=left><b>\".$subject_name.\"</b></td>\n                <td width=100 align=center><b>\".$subject_type.\"</b></td>\n                <td align=center><input type=\\\"checkbox\\\" id=\\\"\".$row[0].\"_\".$row[1].\"\\\" title=\\\"\".$grade_name.\"-\".$subject_name.\"(\".$subject_type.\") Ορισμός Κλειδώματος\\\" Class=\\\"publish_chk\\\" onclick=\\\"publish(this,\".$row[0].\",\".$row[1].\")\\\"\".($published ? \'checked\' : \'\').\"></td>\n            </tr>\"); \n        \n            $zip->addFile($filefordown, basename(greek_to_greeklish($filefordown)));\n        }\n    }\n    }\n    print (\"\n        </table>\");\n}\nelse{\n    print (\"<span CLASS=\\\"msg\\\">Δεν έχουν καταχωρηθεί βαθμοί για τη βαθμολογική περίοδο!</span>\");\n}\n    \n$zip->close();\n\n} else {\n    print (\"<span CLASS=\\\"msgError\\\">Προσοχή : Δεν μπορούν να αποθηκευτούν τα εξαγόμενα αρχεία στον εξυπηρετητή!<br>Παρακαλώ επικοινωνήστε με το διαχειριστή του συστήματος!</span>\");    \n} \nprint \"\n    </body>\n</html>\";\n','','0','2014-12-30 16:47:21','globeadmin','2018-07-15 11:59:30','globeadmin','2021-02-11 19:57:24','globeadmin','0'),('54a30da411a6ba7','teachers_owe_marks','Εμφανίζει τους καθηγητές που υπολείπονται στη κατάθεση αξιολόγησης','manager','$email_subject=\'Παράδοση Αξιολόγησης\';\n$email_recipients=\'\';\n$email_text=\'<p>Παρακαλώ όπως ολοκληρώσετε την παράδοση της αξιολόγησης σας.</p>\';\n$period_name=\'\';\n$period_end_date=null;\n$days_left=0;\n\n$sql=\"DROP TEMPORARY TABLE IF EXISTS #TABLE_ID#\";\nnuRunQuery($sql);\n\n$sql=\"CREATE TEMPORARY TABLE #TABLE_ID# DEFAULT CHARACTER SET=utf8\n    SELECT distinct \n        concat(IFNULL(teacher_surname,\'\'),IF(teacher_surname is NULL,\'\',\' \'),IFNULL(teacher_name,\'\')) as teacher_full_name,\n        class_short, \n        subject_name,\n        subject_type_name,\n        teacher_id,\n        teacher_email,\n        grading_period.name,\n        DATE_FORMAT(grading_period.end_date,\'%d-%m-%Y\'),\n        DATEDIFF(grading_period.end_date,CURDATE()),\n        teacher_user_id,\n        subject_id,\n        class_id\n    FROM \n(SELECT \n	active_card.id 				AS id,\n	active_card.valid_from 		AS valid_from,\n	active_card.subject_id 		AS subject_id,\n	active_card.teacher_id 		AS teacher_id,\n	active_card.class_id 		AS class_id,\n	active_card.classroom_id 	AS classroom_id,\n	active_card.day_id 			AS day_id,\n	active_card.period_id 		AS period_id,\n	teacher.short_name 			AS teacher_short,\n	teacher.surname 			AS teacher_surname,\n	teacher.name 				AS teacher_name,\n	day.name 					AS day_name,\n	day.short_name 				AS day_short,\n	period.short_name 			AS period_short,\n	period.name 				AS period_name,\n	class.short_name 			AS class_short,\n	class.name 					AS class_name,\n	subject.short_name 			AS subject_short,\n	subject.name 				AS subject_name,\n	subject.is_marked 			AS subject_is_marked,\n	subject_type.short_name 	AS subject_type_short,\n	subject_type.name 			AS subject_type_name,\n	classroom.short_name 		AS classroom_short,\n	classroom.name 				AS classroom_name,\n	teacher.email 				AS teacher_email,\n	teacher.user_id 			AS teacher_user_id \nFROM \n	(SELECT \n		card.id 			AS id,\n		card.valid_from 	AS valid_from,\n		card.subject_id 	AS subject_id,\n		card.teacher_id 	AS teacher_id,\n		card.class_id 		AS class_id,\n		card.classroom_id 	AS classroom_id,\n		card.day_id 		AS day_id,\n		card.period_id 		AS period_id \n	FROM card \n	WHERE card.valid_from =\n		(	SELECT max(timetable.start_date) \n			FROM timetable \n			)) as active_card \n	inner join subject 			on active_card.subject_id = subject.id \n	inner join teacher 			on active_card.teacher_id = teacher.id  \n	inner join day 				on active_card.day_id = day.id  \n	inner join period 			on active_card.period_id = period.id\n	inner join class 			on active_card.class_id = class.id	\n	left  join subject_type 	on subject.subject_type_id = subject_type.id  \n	left  join classroom 		on active_card.classroom_id = classroom.id  \nORDER BY \n	active_card.teacher_id,\n	active_card.day_id,\n	active_card.period_id\n) as active_card_full,school,grading_period\n    where \n        school.grading_period_id=grading_period.id and\n        subject_is_marked=true\norder by teacher_full_name,class_short, subject_name,subject_type_name\";\nnuRunQuery($sql);\n$mark_required=1;\n\n$sql = \"SELECT grading_period.mark_required\n        FROM grading_period\n        INNER JOIN school ON school.grading_period_id = grading_period.id\";\n$rv_mark_required = nuRunQuery($sql);\n\nif($rv_mark_required){\n    if($row_mark_required = db_fetch_row($rv_mark_required)){\n        $mark_required =  $row_mark_required[0];\n    }\n}\n                    // Βρίσκει τα μαθήματα για τα οποία έχει κατατεθεί βαθμολογία (σε έστω ένα μαθητή με >0)\n$sql=\"CREATE TEMPORARY TABLE #TABLE_ID#_2 DEFAULT CHARACTER SET=utf8\n    select distinct \n            subject_id,class_id \n    from mark,school\n    where \n            mark.grading_period_id=school.grading_period_id\n    group by subject_id,class_id\n    having sum(if(value>1,value,0))>0\";\nnuRunQuery($sql);\n\nif($mark_required==1){\n                    // Βρίσκει τα μαθήματα για τα οποία δεν έχει κατατεθεί για κανένα μαθητή (κενό για όλο το τμήμα)\n    $sql=\"CREATE TEMPORARY TABLE #TABLE_ID#_3 DEFAULT CHARACTER SET=utf8\n        select distinct \n            subject_id,class_id \n        from mark,school\n        where \n            mark.grading_period_id=school.grading_period_id\n        group by subject_id,class_id\n        having sum(if(value is NULL,0,1))=0\";\n    nuRunQuery($sql);\n\n    $sql=\"delete from #TABLE_ID# where (subject_id,class_id) in (select subject_id,class_id from #TABLE_ID#_3)\";\n    nuRunQuery($sql);    \n} else {\n                    // Βρίσκει τα μαθήματα για τα οποία έχουν κατατεθεί σχόλια (σε έστω ένα μαθητή)\n    $sql=\"CREATE TEMPORARY TABLE #TABLE_ID#_4 DEFAULT CHARACTER SET=utf8\n        SELECT  DISTINCT subject_id,class_id \n        FROM mark\n        INNER JOIN school ON mark.grading_period_id=school.grading_period_id\n        WHERE (mark.comments IS NOT NULL) AND (TRIM(mark.comments)<>\'\')\n            \";    \n    nuRunQuery($sql);\n\n                    // Βρίσκει τα μαθήματα για τα οποία έχει κατατεθεί περιγραφική αξιολόγηση (σε έστω ένα μαθητή)\n    $sql=\"CREATE TEMPORARY TABLE #TABLE_ID#_5 DEFAULT CHARACTER SET=utf8\n        SELECT  DISTINCT subject_id,class_id \n        FROM mark\n        INNER JOIN school ON mark.grading_period_id=school.grading_period_id\n        INNER JOIN mark_critirion_special_level ON mark.id = mark_critirion_special_level.mark_id\n        WHERE mark_critirion_special_level.critirion_special_level_id IS NOT NULL\n            \";    \n    nuRunQuery($sql);\n\n    $sql=\"delete from #TABLE_ID# where (subject_id,class_id) in (select subject_id,class_id from #TABLE_ID#_4)\";\n    nuRunQuery($sql);\n    \n    $sql=\"delete from #TABLE_ID# where (subject_id,class_id) in (select subject_id,class_id from #TABLE_ID#_5)\";\n    nuRunQuery($sql);\n}\n\n$sql=\"delete from #TABLE_ID# where (subject_id,class_id) in (select subject_id,class_id from #TABLE_ID#_2)\";\nnuRunQuery($sql);\n\n$sql=\"update #TABLE_ID# \n        inner join zzzsys_user \n        on #TABLE_ID#.teacher_user_id=zzzsys_user.zzzsys_user_id\n        set teacher_email=zzzsys_user.sus_email\n        where teacher_email is null\";\nnuRunQuery($sql);\n\n$sql=\"update #TABLE_ID# \n        inner join zzzsys_user \n        on #TABLE_ID#.teacher_user_id=zzzsys_user.zzzsys_user_id\n        set teacher_email=concat(IFNULL(teacher_email,\'\'),IF(zzzsys_user.sus_email=NULL,\'\',concat(\',\',zzzsys_user.sus_email)))\n        where teacher_email!=zzzsys_user.sus_email\";\nnuRunQuery($sql); \n\n        \n$sql=\"SELECT * from #TABLE_ID#\";\n$retval = nuRunQuery($sql);\n\nprint \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n\n        <STYLE TYPE=\\\"text/css\\\">\n            .sisTable TH{\n                font-size:1.1em;\n            }\n        </STYLE>\n    </head>\n\n<body onload=\\\"adjustIframeHeight()\\\">\";\n\nif($retval){\n    if(db_num_rows($retval)>0){\n        print (\"\n            <table cellspacing=0 CLASS=\\\"sisTable\\\">\n                <tr height=25> \n                    <th width=300 align=left>Καθηγητής</th> \n                    <th width=70 align=center>Τμήμα</th> \n                    <th width=400 align=left>Μάθημα</th>\n                    <th width=100 align=center>Τύπος Μαθ.</th>\n                </tr>\");\n        \n        $color1=\"LightBlue\";\n        $color2=\"LightSteelBlue\";\n        \n        $color = $color2;\n        \n        $prev_teacher = \"\";\n\n        while($row = db_fetch_row($retval)){\n        \n            $period_name=$row[6];\n            $period_end_date=$row[7];\n            $days_left=$row[8];\n            \n            if($prev_teacher!=$row[0]){\n                $color = ($color==$color1 ? $color2 : $color1);\n                $prev_teacher=$row[0];\n            }\n            \n            print \"\n                <tr style=\\\"background-color:$color;\\\" height=20>\n                    <td align=left>\".$row[0].\"</td>\n                    <td align=center>\".$row[1].\"</td>\n                    <td align=left>\". $row[2].\"</td>\n                    <td align=center>\". $row[3].\"</td>\n                </tr>\";\n        }\n    \n        print (\"\n            </table>\");\n    \n        $sql=\"select distinct teacher_email from #TABLE_ID# where teacher_email is not null order by teacher_email\";\n        $rv = nuRunQuery($sql);\n    \n        while($r = db_fetch_row($rv)){\n            if ($email_recipients==\'\'){\n                $email_recipients=$r[0];\n            } else{\n                $email_recipients=$email_recipients.\',\'.$r[0];\n            }\n        }\n    } else{\n        print (\"<span CLASS=\\\"msg\\\"><p>Δε βρέθηκαν μαθήματα!</p><p>Η παράδοση της αξιολόγησης έχει ολοκληρωθεί!</p></span>\");\n    }\n}\nelse{\n    print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν τα δεδομένα!</span>\");\n}\n\n$email_subject=addslashes($email_subject.\' - \'. $period_name);\n\nif (!is_null($period_end_date)){\n    $email_text=  addslashes($email_text.\'<p>Καταληκτική ημερομηνία : \'.$period_end_date).\'.</p><p>Απομένουν \'.$days_left.\' Ημέρες!</p>\';\n    }\n    \n$sql=\"update session_variables set email_subject=\'\".$email_subject.\"\',email_recipients=\'\".$email_recipients.\"\', email_text=\'\".$email_text.\"\' where session_id=\'#session_id#\'\";\nnuRunQuery($sql);\n\nprint \"\n    </body>\n</html>\";','','0','2014-12-30 22:40:04','globeadmin','2022-05-15 21:34:38','globeadmin','2022-05-15 21:34:38','globeadmin','0'),('54a3e7ba6b7fc63','print_marks_full','Εκτυπώνει όλους τους βαθμούς της τρέχουσας περιόδου','sisyphos','$sql=\"DROP TEMPORARY TABLE IF EXISTS #TABLE_ID#\";\nnuRunQuery($sql);\n\n$sql=\"CREATE TEMPORARY TABLE #TABLE_ID# DEFAULT CHARACTER SET=utf8\nSELECT\n    if(mark.value is null,\'-\',mark.value) as value_p,\n	mark.grading_period_id as grading_period_id,\n	mark.student_id as student_id,\n	mark.subject_id as subject_id,\n    mark.subject_id as subject_id2,\n	mark.post_teacher_id as post_teacher_id,\n    grading_period.name as grading_period_name,\n    student.name as student_name,\n    student.surname as student_surname,\n    student.fathers_name as student_fathers_name,\n    student.registration_number as student_registration_number,\n    subject.name as subject_name,\n    subject_type.name as subject_type_name,\n    concat(subject.name,\' (\',subject_type.name,\')\') as subject_full_name,\n    school.name as school_name,\n    school_year.name as school_year_name,\n    DATE_FORMAT(curdate(),\'%d-%m-%Y\') as cur_date,\n    class.id as class_id,\n    class.short_name as class_short,\n    if(curdate()<=grading_period.end_date,\'Προσωρινή\',\'Οριστική\') as cond,\n    \'                                                                                                                                                                                                        \' as teacher_names\nFROM \n    mark,\n    subject_type, \n    grading_period,\n    student,\n    subject,\n    school,\n    school_year,\n    class\nwhere\n    mark.grading_period_id=school.grading_period_id and\n    mark.grading_period_id=grading_period.id and\n    mark.student_id=student.id and\n    mark.subject_id=subject.id and\n    school_year.id=school.school_year_id and\n    subject.subject_type_id=subject_type.id and\n    mark.class_id=class.id\norder by class_short,subject_full_name,student_surname,student_name,student_fathers_name\n\";\nnuRunQuery($sql);\n\n$sql=\"select distinct class_id,subject_id from #TABLE_ID#\";\n$rv = nuRunQuery($sql);\n\nif($rv){\n        while($row = db_fetch_row($rv)){\n            $class_id=$row[0];\n            $subject_id=$row[1];\n            \n            $sql=\"  SELECT distinct CONCAT(teacher.name,\' \',IFNULL(teacher.surname,\'\'))	\n                    FROM \n	                    (SELECT \n                    		card.id 			AS id,\n                    		card.valid_from 	AS valid_from,\n                    		card.subject_id 	AS subject_id,\n                    		card.teacher_id 	AS teacher_id,\n                    		card.class_id 		AS class_id,\n                    		card.classroom_id 	AS classroom_id,\n                    		card.day_id 		AS day_id,\n                    		card.period_id 		AS period_id \n                    	FROM card \n                    	WHERE card.valid_from =\n                    		(	SELECT max(timetable.start_date) \n                    			FROM timetable \n                    			WHERE (timetable.start_date <= curdate()))) as active_card \n                    	inner join subject 			on active_card.subject_id = subject.id \n                    	inner join teacher 			on active_card.teacher_id = teacher.id  \n                    	inner join day 				on active_card.day_id = day.id  \n                    	inner join period 			on active_card.period_id = period.id\n                    	inner join class 			on active_card.class_id = class.id	\n                    	left  join subject_type 	on subject.subject_type_id = subject_type.id  \n                    	left  join classroom 		on active_card.classroom_id = classroom.id\n                    where \n                    	active_card.subject_id=\'\".$subject_id.\"\' and active_card.class_id=\'\".$class_id.\"\'\";\n\n            $retval = nuRunQuery($sql);\n            $teachers=\'\';\n            $first=true;\n\n            if($retval){\n                while($row = db_fetch_row($retval)){\n                    if($first){\n                        $teachers=$row[0];\n                        $first=false;\n                        }\n                    else{\n                        $teachers=$teachers.\'\n\'.$row[0];\n                        }\n                    }\n                }\n            if(!$first){\n                $sql=\"update #TABLE_ID# set teacher_names=\'\".$teachers.\"\' where class_id=\".$class_id.\" and subject_id=\".$subject_id;\n                nuRunQuery($sql);\n                }\n            }\n    }\n','','0','2014-12-31 14:10:34','globeadmin','2016-02-09 19:37:28','globeadmin','2018-07-16 15:55:37','globeadmin',''),('54a57904c1b4546','myTESTEMAIL','my test mail','sisyphos','use PHPMailer\\PHPMailer\\PHPMailer;\nuse PHPMailer\\PHPMailer\\Exception;\n\nprint \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n    </head>\n\n    <body>\n        Ρυθμίσεις Ηλεκτρονικού Ταχυδρομείου : <br>===========================<br>\n    \";\n\n$setup                      = $GLOBALS[\'nuSetup\'];                                      //-- Read SMTP AUTH Settings from zzsys_setup table	\n\nif (!empty($setup->set_smtp_username))          { $setup->set_smtp_username = trim($setup->set_smtp_username);}                       else{$errorText .= \"SMTP Username not set.<br>\";}\nif (!empty($setup->set_smtp_password)) 	        { $setup->set_smtp_password = trim($setup->set_smtp_password);}                       else{$errorText .= \"SMTP Password not set.<br>\";}\nif (!empty($setup->set_smtp_host))              { $setup->set_smtp_host = trim($setup->set_smtp_host);}                               else{$errorText .= \"SMTP Host not set.<br>\";}\nif (!empty($setup->set_smtp_from_address))      { $setup->set_smtp_from_address = trim($setup->set_smtp_from_address);}               else{$errorText .= \"SMTP From Address not set.<br>\";}\nif (!empty($setup->set_smtp_port))              { $setup->set_smtp_port = intval($setup->set_smtp_port);}                             else{$errorText .= \"SMTP PORT not set.<br>\";}\nif (!empty($setup->set_smtp_use_ssl))           { $setup->set_smtp_use_ssl = trim($setup->set_smtp_use_ssl);}                         else{$setup->set_smtp_use_ssl = \'\';}\nif (!empty($setup->set_smtp_from_name))         { $SMTPname = trim($setup->set_smtp_from_name);}	                              else{$SMTPname = \"nuBuilder\";}\n\nif ($errorText != \'\') {\n	print(\"Δεν μπόρεσε να στείλει το e-mail, το ακόλουθο μήνυμα λάθους εμφανίστηκε:<br>\" . $errorText);\n} else {\n\n	print \"\n	    <table border=0>\";\n	print \"<tr><td>Διακομιστής (Email Server)</td><td> : \".$setup->set_smtp_host.\"</td></tr>\";\n	print \"<tr><td>Θύρα Διακομιστή (port number)</td><td> : \".$setup->set_smtp_port.\"</td></tr>\";\n	print \"<tr><td>Χρήση SSL</td><td> : \".($setup->set_smtp_use_ssl ? \'ΝΑΙ\' : \'ΌΧΙ\').\"</td></tr>\";\n	print \"<tr><td>Όνομα Χρήστη</td><td> : \".$setup->set_smtp_username.\"</td></tr>\";\n	print \"<tr><td>Κωδικός</td><td> : \".(str_repeat(\"*\", strlen($setup->set_smtp_password))).\"</td></tr>\";\n	print \"<tr><td>Διεύθυνση από (from email)</td><td> : \".$setup->set_smtp_from_address.\"</td></tr>\";\n	print \"<tr><td>Όνομα από (from name)</td><td> : \".$setup->set_smtp_from_name.\"</td></tr>\";\n	print \"\n	    </table>\";\n	$content = iconv(\'UTF-8\',\'ISO-8859-7//IGNORE\',\"<h2>Δοκιμή Ηλεκτρονικού Ταχυδρομείου</h2>\");\n	$subject = iconv(\'UTF-8\',\'ISO-8859-7//IGNORE\',\"Δοκιμή Ηλεκτρονικού Ταχυδρομείου\");\n\n	//require_once(\"phpmailer/class.phpmailer.php\");\n	require \'PHPMailer/src/Exception.php\';\n    require \'PHPMailer/src/PHPMailer.php\';\n    require \'PHPMailer/src/SMTP.php\';\n\n	$mail                    = new PHPMailer();\n	$mail->IsSMTP();\n	$mail->setLanguage(\'el\');\n	$mail->Host              = $setup->set_smtp_host;\n	$mail->Port              = $setup->set_smtp_port;\n	$mail->SMTPAuth          = true;\n	$mail->SMTPSecure        = $setup->set_smtp_use_ssl ? $setup->set_smtp_use_ssl : \'\';\n	$mail->CharSet           = \'iso-8859-7\';\n\n	$mail->Username  = $setup->set_smtp_username;\n	$mail->Password  = $setup->set_smtp_password;\n	\n	$mail->From              = $setup->set_smtp_from_address;\n	$mail->FromName          = iconv(\'UTF-8\',\'ISO-8859-7//IGNORE\',$setup->set_smtp_from_name);\n\n	$mail->AddAddress($setup->set_smtp_from_address,$setup->set_smtp_from_name);\n	$mail->AddReplyTo($setup->set_smtp_from_address,$setup->set_smtp_from_name);\n\n	$mail->AddReplyTo        = $setup->set_smtp_from_address;\n	$mail->AddAddress        = $setup->set_smtp_from_address;\n	$mail->WordWrap          = 80;\n	$mail->IsHTML(true);\n	$mail->Subject           = $subject;\n	$mail->Body              = $content;\n\n	print \"<br>Μήνυμα PhpMailer :<br>===========================<br>\";\n\n	if(!$mail->Send()) {\n		print \"Λάθος αποστολής: \".$mail->ErrorInfo;;\n	} else {\n		print \"Μήνυμα εστάλει!\";\n	} \n}\nprint \"\n    </body>\n</html>\";\n','','0','2015-01-01 18:42:44','globeadmin','2019-07-25 10:18:38','globeadmin','2019-07-25 10:18:38','globeadmin','0'),('54a921725907fab','show_marks_student','Εμφανίζει τους Βαθμούς του Μαθητή','sisyphos','function format_mark_value($value,$num_of_decimals){\n                    \n    $pieces = explode(\".\", $value);\n    $new_value =  $value;\n    \n    if(strlen($pieces[0])==1){\n        $pieces[0]=\'0\'.$pieces[0];    \n    }\n    \n    if(count($pieces)==2){\n        if($num_of_decimals==0 && $pieces[1]==\'0\'){\n            $new_value = $pieces[0];   \n        } else {\n            $new_value = $pieces[0].\',\'.$pieces[1];    \n        }\n    }\n    \n    return($new_value);\n}\n\n$sql=\"DROP TEMPORARY TABLE IF EXISTS #TABLE_ID#\";\nnuRunQuery($sql);\n\n$sql=\"CREATE TEMPORARY TABLE #TABLE_ID# DEFAULT CHARACTER SET=utf8\nSELECT\n    \n    mark.id as mark_id,\n    mark.value as value_p,\n    \n	mark.grading_period_id as grading_period_id,\n	grading_period.num_of_decimals as grading_period_num_of_decimals,\n	mark.student_id as student_id,\n	mark.subject_id as subject_id,\n	mark.post_teacher_id as post_teacher_id,\n    \n    grading_period.name as grading_period_name,\n    \n    student.name as student_name,\n    student.surname as student_surname,\n    student.fathers_name as student_fathers_name,\n    student.registration_number as student_registration_number,\n    \n    subject.name as subject_name,\n    subject_type.name as subject_type_name,\n    concat(subject.name,\' (\',subject_type.name,\')\') as subject_full_name,\n    \n    school.name as school_name,\n    school_year.name as school_year_name,\n    \n    DATE_FORMAT(curdate(),\'%d-%m-%Y\') as cur_date,\n    \n    class.id as class_id,\n    class.short_name as class_short,\n    CAST(\'\' as CHAR(255)) as teacher_names,\n    CAST(mark.comments as CHAR(255)) as mark_comments,\n    0                                           as critiria_count\nFROM mark\nINNER JOIN grading_period   ON mark.grading_period_id=grading_period.id  \nINNER JOIN student          ON mark.student_id=student.id\nINNER JOIN class            ON mark.class_id=class.id\nINNER JOIN subject          ON mark.subject_id=subject.id\nINNER JOIN school           ON 1=1\nINNER JOIN school_year      ON school_year.id=school.school_year_id\nLEFT  JOIN subject_type     ON subject.subject_type_id=subject_type.id\nwhere\n    mark.grading_period_id=#student_mark_grade_period_id# and\n    mark.student_id=#RECORD_ID#\norder by class_short,subject_name,subject_type_name DESC\n\";\nnuRunQuery($sql);\n\n$sql=\"select distinct class_id,subject_id from #TABLE_ID#\";\n$rv = nuRunQuery($sql);\n\nif($rv){\n        while($row = db_fetch_row($rv)){\n            $class_id=$row[0];\n            $subject_id=$row[1];\n            \n            $sql=\"  SELECT distinct CONCAT(IF(teacher.surname is null,\'\', concat(teacher.surname,\' \')),IFNULL(teacher.name,\'\'))\n                    FROM \n	                    (SELECT \n		                    card.id 			AS id,\n		                    card.valid_from 	AS valid_from,\n		                    card.subject_id 	AS subject_id,\n		                    card.teacher_id 	AS teacher_id,\n		                    card.class_id 		AS class_id,\n		                    card.classroom_id 	AS classroom_id,\n		                    card.day_id 		AS day_id,\n		                    card.period_id 		AS period_id \n	                    FROM card \n	                    WHERE card.valid_from =\n		                    (	SELECT max(timetable.start_date) \n			                    FROM timetable \n			                    WHERE (timetable.start_date <= curdate()))) \n	                as active_card \n	                inner join subject 			on active_card.subject_id = subject.id \n	                inner join teacher 			on active_card.teacher_id = teacher.id  \n	                inner join day 				on active_card.day_id = day.id  \n	                inner join period 			on active_card.period_id = period.id\n	                inner join class 			on active_card.class_id = class.id	\n	                left  join subject_type 	on subject.subject_type_id = subject_type.id  \n	                left  join classroom 		on active_card.classroom_id = classroom.id\n	                where \n	                    active_card.subject_id=\'\".$subject_id.\"\' and active_card.class_id=\'\".$class_id.\"\'\n                    ORDER BY \n    	                active_card.teacher_id,\n	                    active_card.day_id,\n	                    active_card.period_id\";\n\n            $retval = nuRunQuery($sql);\n            $teachers=\'\';\n            $first=true;\n\n            if($retval){\n                while($row = db_fetch_row($retval)){\n                    if($first){\n                        $teachers=$row[0];\n                        $first=false;\n                    } else{\n                        $teachers=$teachers.\', \'.$row[0];\n                    }\n                }\n            }\n            if(!$first){\n                $sql=\"update #TABLE_ID# set teacher_names=\'\".$teachers.\"\' where class_id=\".$class_id.\" and subject_id=\".$subject_id;\n                nuRunQuery($sql);\n                }\n        }\n}\n\n$sql=\"SELECT mark_id FROM #TABLE_ID#\";\n$retval = nuRunQuery($sql);\n            \nwhile($row = db_fetch_row($retval)){\n                \n    $sql = \"    SELECT count(*)\n                FROM mark_critirion_special_level\n                WHERE \n                    mark_id=\'\".$row[0].\"\' AND \n                    critirion_special_level_id IS NOT NULL\";\n    $rv2=nuRunQuery($sql);\n    $r2 = db_fetch_row($rv2);\n                \n    if($r2[0]!=\'0\'){\n        $sql=\"  update #TABLE_ID# set critiria_count=\'\".$r2[0].\"\' where mark_id=\".$row[0];\n        nuRunQuery($sql);\n    }\n}\n\n$sql=\"select\n        subject_name,\n        subject_type_name,\n        value_p,\n        teacher_names,\n        class_short,\n        mark_comments,\n        mark_id,\n        critiria_count,\n        grading_period_num_of_decimals\n    from #TABLE_ID#\n    order by class_short,subject_name,subject_type_name DESC\";\n\n$retval = nuRunQuery($sql);\n\nprint \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n        \n        <script type=\\\"text/javascript\\\">\n            function openMarkDetails(mark_id){\n                parent.nuOpenFormInFrame(\'562d11f6d45ccf1\',mark_id);\n            }\n        </script>\n        \n        <STYLE TYPE=\\\"text/css\\\">\n			\n			.sisTableLine TD{\n                font-weight: normal;    \n            }            \n            \n            .sisTableLine TH{\n                font-size:9pt;\n            }\n            \n            .value {\n                font-weight: bold;\n                font-size:10pt;\n            }\n\n        </STYLE>\n    </head>\n\n    <body  onload=\\\"adjustIframeHeight()\\\">\n        <table border=0 cellspacing=0 align=center CLASS=\\\"sisTableLine\\\">\";\n\nif($retval){ \n if (db_num_rows($retval)>0){\n    print (\"\n            <tr height=40> \n                <th width=400 align=center>Μάθημα</th>\n                <th width=100 align=center>Κατηγορία</th>\n                <th width=90 align=center>Βαθμός</th>\n                <th width=90 align=center>Περιγραφική Αξιολόγηση</th>\n                <th width=300 align=center>Καθηγητές</th> \n            </tr>\");\n    \n    while($row = db_fetch_row($retval)){\n        print \"\n            <tr height=35>\n                <td align=left>\".$row[0].\"</td>\n                <td align=center>\".$row[1].\"</td>\n                <td align=center><span\".(is_null($row[2]) ? \"\" : \" CLASS=\\\"value\\\"\").\">\".($row[2]<10 ? \"<font color=\'red\'>\" : ($row[2]<14 ? \"<font color=\'Orange\'>\" : ($row[2]<17 ? \"<font color=\'blue\'>\" : \"<font color=\'green\'>\"))).format_mark_value($row[2],$row[8]).\"</font></span></td>\n                <td align=center>\".((is_null($row[5]) || $row[5]==\'\') && $row[7]==\'0\' ? \"&nbsp;</td>\" : \"<img CLASS=\\\"evaluation\\\" onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\" onclick=\\\"openMarkDetails(\".$row[6].\")\\\" id=\\\"img_\".$row[6].\"\\\" title=\\\"\".((is_null($row[5]) || $row[5]==\'\') ? \"Περιγραφική Αξιολόγηση\" :\'Σχόλια Καθηγητή : \'.mb_substr(strip_tags($row[5]), 0, 20,\"UTF-8\").\'...\').\"\\\" width=18 height=18 src=\\\"images/note2.png\\\"></b></td>\").\"\n                <td align=left>\".$row[3].\"</td>\n            </tr>\";\n    }\n    print (\"\n            </table>\");\n\n } else {\n    print (\"<span CLASS=\\\"msg\\\">Δεν βρέθηκε αξιολογήση...</span>\"); \n }\n} else{\n    print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν τα δεδομένα!</span>\");\n}\nprint \"\n    </body>\n</html>\";','','0','2015-01-04 13:18:10','globeadmin','2018-07-16 10:34:24','globeadmin','2018-07-16 10:34:24','globeadmin','0'),('54a9704fd26ded5','student_account_creation','Δημιουργεί λογαριασμούς για τους μαθητές που δεν έχουν ήδη λογαρισμό','manager','$sql=\"select \n        id,\n        registration_number,\n        DATE_FORMAT(birth_date,\'%d-%m-%Y\'),\n        surname,\n        name,\n        email \n    from student where user_id is null and has_left_school=0\";\n\n$retval = nuRunQuery($sql);\n\n$i=0;\n\nif($retval){\n    print \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n        \n        <STYLE TYPE=\\\"text/css\\\">\n            .sisTable TD{\n                font-size:9pt;\n            }\n            .sisTable TH{\n                font-size:9pt;\n            }\n            .sisTable tr:nth-child(even){\n	            background-color: LightSteelBlue;\n            }\n        </STYLE>\n    </head>\n\n<body onload=\\\"adjustIframeHeight()\\\">\";\n\n    if(db_num_rows($retval)>0){\n    \n        print (\"\n        <table cellspacing=0 align=center CLASS=\\\"sisTable\\\">\n            <tr> \n                <th width=500 align=center>Μαθητής</th>\n                <th width=150 align=center>Όνομα Χρήστη</th>\n                <th width=150 align=center>Κωδικός</th>\n            </tr>\");\n\n        while($row = db_fetch_row($retval)){\n        \n            $sql=\"select count(*) from zzzsys_user where sus_login_name=\'\".$row[1].\"\'\"; \n        \n            $rv = nuRunQuery($sql);\n            $cnt=db_fetch_row($rv);\n        \n            if($cnt[0]==0){\n            //User Creation\n                $id=nuID();\n                $sql = \"insert into zzzsys_user (\n                    zzzsys_user_id,\n                    sus_zzzsys_user_group_id,\n                    sus_name,\n                    sus_email,\n                    sus_login_name,\n                    sus_login_password,\n                    zzzsys_user_log_added_at,\n                    zzzsys_user_log_added_by,\n                    zzzsys_user_log_changed_at,\n                    zzzsys_user_log_changed_by,\n                    zzzsys_user_log_viewed_at,\n                    zzzsys_user_log_viewed_by\n                    )\n                    values(\n                    \'\".$id.\"\',\n                    \'547de4c65675a29\',\n                    \'\".$row[3].\' \'.$row[4].\"\',\n                    \'\".$row[5].\"\',\n                    \'\".$row[1].\"\',\n                    md5(CONCAT(\'\".$row[1].\"\', \'\".$row[2].\"\')),\n                    NOW(),\n                    \'globeadmin\',\n                    NOW(),\n                    \'globeadmin\',\n                    NOW(),\n                    \'globeadmin\'\n                    )\";\n	            nuRunQuery($sql);\n	        \n	            $sql=\"update student set user_id=\'\".$id.\"\' where id=\".$row[0];\n	            nuRunQuery($sql);\n            \n                print \"\n                <tr>\n                    <td align=left>\".$row[3].\' \'.$row[4].\"</td>\n                    <td align=center>\".$row[1].\"</td>\n                    <td align=right>\".$row[2].\"</td>\n                </tr>\";\n                \n            } else{\n                print \"\n                <tr style=\\\"background-color:OrangeRed;\\\">\n                    <td align=left> <font color=white>Ο Λογαριασμός υπάρχει ήδη...</font></td>\n                    <td align=center><font color=white>\".$row[1].\"</font></td>\n                    <td align=right><font color=white>N/A</font></td>\n                </tr>\";           \n            } \n        }\n    } else {\n        print \"<span CLASS=\\\"msg\\\">Όλοι οι μαθητές διαθέτουν λογαριασμό!</span>\";\n    }\n\n    print \"\n    </body>\n</html>\";\n}\n','','0','2015-01-04 18:54:39','globeadmin','2018-07-13 01:10:50','globeadmin','2018-07-16 10:26:22','globeadmin','0'),('54aa72ec60858cc','clean_up_user_ids','Διαγράφει από τους Μαθητές και τους Καθηγητές ανύπαρκους λογαριασμούς (αν έχουν διαγραφεί από λάθος)','manager','$sql=\"update student \n        set user_id=null\n    where \n        (select count(*) from zzzsys_user where zzzsys_user_id=user_id)=0\";\nnuRunQuery($sql );\n\n$sql=\"update teacher \n        set user_id=null\n    where \n        (select count(*) from zzzsys_user where zzzsys_user_id=user_id)=0\";\nnuRunQuery($sql );\n','','0','2015-01-05 13:18:04','globeadmin','2015-01-05 13:21:12','globeadmin','2016-03-02 18:31:42','globeadmin',''),('5794ba3aab6842f','system_check','Έλεγχος Συστήματος και Δεδομένων','manager','function print_row($msg,$img=null,$color=null){\n    if(is_null($img)){\n            print(\"\n                <tr height=35>\n                    <td valign=center  colspan=2>\n                    \".(is_null($color) ? \"\" : \"<font color=\".$color.\">\").\"\n                    \".$msg.\"\n                    \".(is_null($color) ? \"\" : \"</font>\").\"\n                    </td>\n                </tr>\");    \n    } else {\n        print(\"\n                <tr height=35>\n                    <td width=35 align=left valign=bottom>\n                        <img width=24 height=24 src=\\\"images/\".$img.\".png\\\">\n                    </td>\n                    <td valign=bottom>\n                    \".(is_null($color) ? \"\" : \"<font color=\".$color.\">\").\"\n                    \".$msg.\"\n                    \".(is_null($color) ? \"\" : \"</font>\").\"\n                    </td>\n                </tr>\");\n    }\n    flush();\n}\n\nprint \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n        \n        <STYLE TYPE=\\\"text/css\\\">\n            .sisTable, .sisTable TD{\n                border:none;\n                background-color:white;\n            }\n            .sisTable TH{\n                font-size:1.1em;\n                border:none;\n                background-color:white;\n            }\n        </STYLE>\n\n    </head>\n\n    <body onload=\\\"adjustIframeHeight()\\\">\n        <table CLASS=\\\"sisTable\\\" cellspacing=5 width=100% height=100%>\n            <tr width=100% height=100%>\n                <td valign=top>\n                    <table CLASS=\\\"sisTable\\\" cellspacing=0 width=100%>\";\n\nflush();\n\n//******************************************** Τμήματα *******************************************************************\n\nprint_row(\'<b>Έλεγχος Τμημάτων...</b>\'); \n\n$sql=\"  SELECT short_name \n        FROM class\n        GROUP BY short_name\n        HAVING COUNT(*)>1\";\n$retval = nuRunQuery($sql);\n\nif($retval){\n    if(db_num_rows($retval)>0){\n        while($row=db_fetch_row($retval)){\n            print_row(\'Η συντομογραφία <b>«\'.$row[0].\'»</b> υπάρχει σε περισσότερα από ένα τμήματα!\',\'error\',\'red\');    \n        }\n    } else {\n        print_row(\'Οι συντομογραφίες των τμημάτων είναι μοναδικές!\',\'check\');\n    }\n}\n\n$sql=\"  SELECT \n            short_name,\n            name,\n            grade_id,\n            if(short_name is NULL,if(name is NULL,\'Χωρίς Όνομα\',name),short_name)\n        FROM class\n        WHERE \n            short_name IS NULL OR TRIM(short_name)=\'\' OR\n            name IS NULL OR TRIM(name)=\'\' OR\n            grade_id is NULL\";\n$retval = nuRunQuery($sql);\n\nif($retval){\n    if(db_num_rows($retval)>0){\n        while($row=db_fetch_row($retval)){\n        \n            if(is_null($row[0]) || $row[0]==\'\'){\n                print_row(\'Στο τμήμα <b>«\'.$row[3].\'»</b> δεν έχει συμπληρωθεί η Συνομογραφία!\',\'error\',\'red\');    \n            }\n            \n            if(is_null($row[1]) || $row[1]==\'\'){\n                print_row(\'Στο τμήμα <b>«\'.$row[3].\'»</b> δεν έχει συμπληρωθεί το Όνομα!\',\'error\',\'red\');    \n            }\n            \n            if(is_null($row[2]) || $row[2]==\'\'){\n                print_row(\'Στο τμήμα <b>«\'.$row[3].\'»</b> δεν έχει συμπληρωθεί η Τάξη!\',\'stop\');    \n            }    \n        }\n    } else {\n        print_row(\'Οι λεπτομέρειες όλων των τμημάτων έχουν συμπληρωθεί!\',\'check\');\n    }\n}\n\n$sql=\"  SELECT class.short_name \n        FROM class\n        WHERE id not in (select distinct class_id from student_class)\";\n$retval = nuRunQuery($sql);\n\nif($retval){\n    if(db_num_rows($retval)>0){\n        while($row=db_fetch_row($retval)){\n            print_row(\'Το τμήμα <b>«\'.$row[0].\'»</b> είναι άδειο από μαθητές!\',\'warning\');    \n        }\n    } else {\n        print_row(\'Δεν υπάρχουν τμήματα χωρίς μαθητές!\',\'check\');\n    }\n}\n\n$sql=\"  SELECT distinct class.short_name \n        FROM class\n        INNER JOIN card ON card.class_id=class.id\n        WHERE \n            card.valid_from >= (select max(start_date) from timetable where start_date<=curdate()) and\n            class.id not in (select distinct class_id from student_class)\";\n$retval = nuRunQuery($sql);\n\nif($retval){\n    if(db_num_rows($retval)>0){\n        while($row=db_fetch_row($retval)){\n            print_row(\'Το τμήμα <b>«\'.$row[0].\'»</b> είναι άδειο από μαθητές αλλά υπάρχουν διδασκαλίες του σε ενεργό Ωρολόγιο Πρόγραμμα!\',\'error\',\'red\');    \n        }\n    } else {\n        print_row(\'Όλα τα τμήματα που υπάρχουν σε ενεργό Ωρολόγιο Πρόγραμμα έχουν μαθητές!\',\'check\');\n    }\n}\n\n$sql=\"  SELECT distinct class.short_name \n        FROM class\n        INNER JOIN student_class ON student_class.class_id=class.id\n        WHERE \n            class.id not in (select distinct class_id from card)\";\n$retval = nuRunQuery($sql);\n\nif($retval){\n    if(db_num_rows($retval)>0){\n        while($row=db_fetch_row($retval)){\n            print_row(\'Το τμήμα <b>«\'.$row[0].\'»</b> έχει μαθητές αλλά δεν έχει διδασκαλίες σε κανένα Ωρολόγιο Πρόγραμμα!\',\'warning\');    \n        }\n    } else {\n        print_row(\'Όλα τα τμήματα με μαθητές έχουν διδασκαλίες σε κάποιο Ωρολόγιο Πρόγραμμα!\',\'check\');\n    }\n}\n\n//******************************************** Μαθητές *******************************************************************\nprint_row(\'<hr>\'); \nprint_row(\'<b>Έλεγχος Μαθητών...</b>\'); \n$sql=\"  SELECT concat(\n                if(student.registration_number IS NULL OR student.registration_number=\'\',\'\',CONCAT(student.registration_number,\'-\')),\n                ifNULL(student.surname,\'\'),\n                if(student.surname is NULL OR student.name IS NULL,\'\',\' \'),\n                ifNULL(student.name,\'\'),\n                IF(student.fathers_name IS NULL OR student.fathers_name=\'\',\'\',CONCAT(\' πατ. \',student.fathers_name))\n                )\n        FROM student\n        WHERE student.id not in (select distinct student_id from student_class)\n        ORDER BY surname,name,fathers_name\";\n$retval = nuRunQuery($sql);\n\nif($retval){\n    if(db_num_rows($retval)>0){\n        while($row=db_fetch_row($retval)){\n            print_row(\'Ο μαθητής <b>«\'.$row[0].\'»</b> δεν ανήκει σε κανένα τμήμα!\',\'warning\');    \n        }\n    } else {\n        print_row(\'Όλοι οι μαθητές ανήκουν σε τμήματα\',\'check\');\n    }\n}\n\n$sql=\"  SELECT concat(\n                if(student.registration_number IS NULL OR student.registration_number=\'\',\'\',CONCAT(student.registration_number,\'-\')),\n                ifNULL(student.surname,\'\'),\n                if(student.surname is NULL OR student.name IS NULL,\'\',\' \'),\n                ifNULL(student.name,\'\'),\n                IF(student.fathers_name IS NULL OR student.fathers_name=\'\',\'\',CONCAT(\' πατ. \',student.fathers_name))\n                ),\n                student.registration_number,\n                student.surname,\n                student.name,\n                student.fathers_name,\n                student.grade_id\n        FROM student\n        WHERE\n            student.registration_number IS NULL OR TRIM(student.registration_number)=\'\' OR\n            student.surname IS NULL OR TRIM(student.surname)=\'\' OR\n            student.name IS NULL OR TRIM(student.name)=\'\' OR\n            student.fathers_name IS NULL OR TRIM(student.fathers_name)=\'\' OR\n            student.grade_id IS NULL\n        ORDER BY surname,name,fathers_name\";\n$retval = nuRunQuery($sql);\n\nif($retval){\n    if(db_num_rows($retval)>0){\n        while($row=db_fetch_row($retval)){\n            $m = \'\';\n            $m .= (is_null($row[1]) ||  trim($row[1])==\'\' ? \'Αριθμός Μητρωόυ\' : \'\');\n            $m .= (is_null($row[2]) ||  trim($row[2])==\'\' ? \'-Επώνυμο\' : \'\');\n            $m .= (is_null($row[3]) ||  trim($row[3])==\'\' ? \'-Όνομα\' : \'\');\n            $m .= (is_null($row[4]) ||  trim($row[4])==\'\' ? \'-Όνομα Πατρός\' : \'\');\n            $m .= (is_null($row[5]) ||  trim($row[5])==\'\' ? \'-Τάξη\' : \'\');\n            print_row(\'Για τον μαθητή <b>«\'.$row[0].\'»</b> δεν έχουν συμπληρωθεί τα : <b>\'.$m.\'</b>\',\'stop\');    \n        }\n    } else {\n        print_row(\'Οι βασικές λεπτομέρειες όλων των μαθητών έχουν συμπληρωθεί!\',\'check\');\n    }\n}\n\n$sql=\"  SELECT ifNULL(count(*),0)\n        FROM student\n        WHERE student.user_id IS NULL\n        ORDER BY surname,name,fathers_name\";\n$retval = nuRunQuery($sql);\n\nif($retval){\n\n    if($row=db_fetch_row($retval)){\n        if($row[0]>0){    \n            print_row(\'Για <b>\'.$row[0].\' μαθητές</b> δεν έχει δημιουργηθεί λογαριασμός σύνδεσης!\',\'info-sign\');\n        } else {\n            print_row(\'Για όλους τους μαθητές έχει δημιουργηθεί λογαριασμός σύνδεσης!\',\'check\');    \n        }\n    }\n}\n\n$sql=\"  SELECT concat(\n                if(student.registration_number IS NULL OR student.registration_number=\'\',\'\',CONCAT(student.registration_number,\'-\')),\n                ifNULL(student.surname,\'\'),\n                if(student.surname is NULL OR student.name IS NULL,\'\',\' \'),\n                ifNULL(student.name,\'\'),\n                IF(student.fathers_name IS NULL OR student.fathers_name=\'\',\'\',CONCAT(\' πατ. \',student.fathers_name))\n                )\n        FROM student\n        INNER JOIN zzzsys_user ON student.user_id = zzzsys_user.zzzsys_user_id\n        WHERE  zzzsys_user.sus_zzzsys_user_group_id<>\'547de4c65675a29\'\n        ORDER BY surname,name,fathers_name\";\n$retval = nuRunQuery($sql);\n\nif($retval){\n    if(db_num_rows($retval)>0){\n        while($row=db_fetch_row($retval)){\n            print_row(\'Ο λογαριασμός σύνδεσης του μαθητή <b>«\'.$row[0].\'»</b> δεν έχει τα σωστα δικαιώματα πρόσβασης!\',\'error\',\'red\');    \n        }\n    } else {\n        print_row(\'Όλοι οι λογαριασμοί των μαθητών έχουν σωστά δικαιώματα πρόσβασης!\',\'check\');\n    }\n}\n\n$sql=\"  SELECT concat(\n                if(student.registration_number IS NULL OR student.registration_number=\'\',\'\',CONCAT(student.registration_number,\'-\')),\n                ifNULL(student.surname,\'\'),\n                if(student.surname is NULL OR student.name IS NULL,\'\',\' \'),\n                ifNULL(student.name,\'\'),\n                IF(student.fathers_name IS NULL OR student.fathers_name=\'\',\'\',CONCAT(\' πατ. \',student.fathers_name))\n                )\n        FROM student\n        INNER JOIN zzzsys_user ON student.parent_user_id = zzzsys_user.zzzsys_user_id\n        WHERE  zzzsys_user.sus_zzzsys_user_group_id<>\'5717ba3eb32c252\'\n        ORDER BY surname,name,fathers_name\";\n$retval = nuRunQuery($sql);\n\nif($retval){\n    if(db_num_rows($retval)>0){\n        while($row=db_fetch_row($retval)){\n            print_row(\'Ο λογαριασμός σύνδεσης του <b>Γονέα</b> του μαθητή <b>«\'.$row[0].\'»</b> δεν έχει τα σωστα δικαιώματα πρόσβασης!\',\'error\',\'red\');    \n        }\n    } else {\n        print_row(\'Όλοι οι λογαριασμοί των γονέων έχουν σωστά δικαιώματα πρόσβασης!\',\'check\');\n    }\n}\n\n\n$sql=\"  SELECT ifNULL(count(*),0)\n        FROM student\n        WHERE student.teacher_id IS NULL\n        ORDER BY surname,name,fathers_name\";\n$retval = nuRunQuery($sql);\n\nif($retval){\n    if($row=db_fetch_row($retval)){\n        if($row[0]>0){\n            print_row(\'Για <b>\'.$row[0].\' μαθητές</b> δεν έχει οριστεί υπεύθυνος καθηγητής!\',\'warning\');   \n        } else{\n            print_row(\'Για όλους τους μαθητές έχει οριστεί υπεύθυνος καθηγητής!\',\'check\');\n        }\n    }\n}\n\n$sql=\"  SELECT  student.id,\n                concat(\n                if(student.registration_number IS NULL OR student.registration_number=\'\',\'\',CONCAT(student.registration_number,\'-\')),\n                ifNULL(student.surname,\'\'),\n                if(student.surname is NULL OR student.name IS NULL,\'\',\' \'),\n                ifNULL(student.name,\'\'),\n                IF(student.fathers_name IS NULL OR student.fathers_name=\'\',\'\',CONCAT(\' πατ. \',student.fathers_name))\n                )\n        FROM student\n        ORDER BY surname,name,fathers_name\";\n$retval = nuRunQuery($sql);\n\nif($retval){\n\n    $blank_found = false;\n    \n    while($row=db_fetch_row($retval)){\n    \n        $sql=\"  select  \n	                dp.day_id,\n		            dp.period_id,\n		            dp.day_name,\n	                dp.period_name,\n	                c.subject_id\n	            from (	select \n				            day.id as day_id,\n				            day.name as day_name,\n				            period.id as period_id,\n				            period.name as period_name\n			            from day,period\n			            order by day.id,period.id) as dp\n	            left join (\n                        SELECT distinct\n                	        day_id 			AS day_id,\n	                        period_id 		AS period_id,\n					        subject_id 		AS subject_id	                \n                        FROM card\n				        WHERE \n				            card.valid_from = (SELECT max(timetable.start_date) FROM timetable) AND\n						    card.class_id in (select distinct class_id from student_class where student_id=\'\".$row[0].\"\')\n				        ) as c ON (c.day_id=dp.day_id AND c.period_id=dp.period_id)\n                order by dp.day_id,dp.period_id\n            \";\n            \n            $rv=nuRunQuery($sql);\n            \n            $cur_day_id = -1;\n            $period_blank = -1;\n            $period_blank_name = \'\';\n            \n            while($r=db_fetch_row($rv)){\n            \n                if($r[0]!=$cur_day_id){ // new day\n                   $cur_day_id = $r[0];\n                   $period_blank = -1;\n                }\n                \n                if(is_null($r[4])){     // black found\n                   $period_blank = $r[1];\n                   $period_blank_name = $r[3];\n                } else {\n                   if($period_blank!=-1){\n                        print_row(\'Ο μαθητής <b>«\'.$row[1].\'»</b> την \'.$r[2].\', την \'.$period_blank_name.\' έχει κενό στο ΩΠ!\',\'stop\');\n                        $blank_found = true;\n                   }\n                   $period_blank=-1;\n                }\n            }\n    }\n\n    if(!$blank_found){\n        print_row(\'Το ωρολόγιο πρόγραμμα όλων των μαθητών δεν έχει κενά!\',\'check\');    \n    }\n}\n\n//******************************************** Καθηγητές *****************************************************************\nprint_row(\'<hr>\'); \nprint_row(\'<b>Έλεγχος Καθηγητών...</b>\'); \n\n$sql=\"  SELECT short_name \n        FROM teacher\n        GROUP BY short_name\n        HAVING COUNT(*)>1\";\n$retval = nuRunQuery($sql);\n\nif($retval){\n    if(db_num_rows($retval)>0){\n        while($row=db_fetch_row($retval)){\n            print_row(\'Η συντομογραφία <b>«\'.$row[0].\'»</b> υπάρχει σε περισσότερους από έναν Καθηγητές!\',\'error\',\'red\');    \n        }\n    } else {\n        print_row(\'Οι συντομογραφίες των Καθηγητών είναι μοναδικές!\',\'check\');\n    }\n}\n\n$sql=\"  SELECT concat(\n                ifNULL(surname,\'\'),\n                if(surname is NULL OR name IS NULL,\'\',\' \'),\n                ifNULL(name,\'\')\n                ),\n                short_name,\n                surname,\n                name,\n                user_id\n        FROM teacher\n        WHERE\n            surname IS NULL OR TRIM(surname)=\'\' OR\n            name IS NULL OR TRIM(name)=\'\' OR\n            short_name IS NULL OR TRIM(short_name)=\'\' OR\n            user_id IS NULL\n        ORDER BY surname,name\";\n$retval = nuRunQuery($sql);\n\nif($retval){\n    if(db_num_rows($retval)>0){\n        while($row=db_fetch_row($retval)){\n            $m = \'\';\n            $m .= (is_null($row[1]) ||  trim($row[1])==\'\' ? \'Συντομογραφία\' : \'\');\n            $m .= (is_null($row[2]) ||  trim($row[2])==\'\' ? \'-Επώνυμο\' : \'\');\n            $m .= (is_null($row[3]) ||  trim($row[3])==\'\' ? \'-Όνομα\' : \'\');\n            if($m!=\'\'){\n                print_row(\'Για τον Καθηγητή <b>«\'.$row[0].\'»</b> δεν έχουν συμπληρωθεί τα : <b>\'.$m.\'</b>\',\'stop\');\n            }\n            if(is_null($row[4])){\n                print_row(\'Για τον Καθηγητή <b>«\'.$row[0].\'»</b> δεν έχει δημιουργηθεί λογαριασμός σύνδεσης!\',\'stop\');\n            }\n        }\n    } else {\n        print_row(\'Οι βασικές λεπτομέρειες όλων των Καθηγητών έχουν συμπληρωθεί!\',\'check\');\n    }\n}\n\n$sql=\"  SELECT concat(\n                ifNULL(surname,\'\'),\n                if(surname is NULL OR name IS NULL,\'\',\' \'),\n                ifNULL(name,\'\'))\n        FROM teacher\n        INNER JOIN zzzsys_user ON teacher.user_id = zzzsys_user.zzzsys_user_id\n        WHERE  zzzsys_user.sus_zzzsys_user_group_id IN (\'547de4c65675a29\',\'5717ba3eb32c252\')\n        ORDER BY surname,name\n        \";\n$retval = nuRunQuery($sql);\n\nif($retval){\n    if(db_num_rows($retval)>0){\n        while($row=db_fetch_row($retval)){\n            print_row(\'Ο λογαριασμός σύνδεσης του καθηγητή <b>«\'.$row[0].\'»</b> δεν έχει τα σωστα δικαιώματα πρόσβασης!\',\'error\',\'red\');    \n        }\n    } else {\n        print_row(\'Όλοι οι λογαριασμοί των καθηγητών έχουν σωστά δικαιώματα πρόσβασης!\',\'check\');\n    }\n}\n\n//******************************************** Αίθουσες ***********************************************************\nprint_row(\'<hr>\');\nprint_row(\'<b>Έλεγχος Αιθουσών...</b>\'); \n\n$sql=\"  SELECT short_name \n        FROM classroom\n        GROUP BY short_name\n        HAVING COUNT(*)>1\";\n$retval = nuRunQuery($sql);\n\nif($retval){\n    if(db_num_rows($retval)>0){\n        while($row=db_fetch_row($retval)){\n            print_row(\'Η συντομογραφία <b>«\'.$row[0].\'»</b> υπάρχει σε περισσότερες από μία αίθουσες!\',\'error\',\'red\');    \n        }\n    } else {\n        print_row(\'Οι συντομογραφίες των αιθουσών είναι μοναδικές!\',\'check\');\n    }\n}\n//******************************************** Μαθήματα ***********************************************************\nprint_row(\'<hr>\');\nprint_row(\'<b>Έλεγχος Μαθημάτων...</b>\'); \n\n$sql=\"  SELECT short_name \n        FROM subject\n        GROUP BY short_name\n        HAVING COUNT(*)>1\";\n$retval = nuRunQuery($sql);\n\nif($retval){\n    if(db_num_rows($retval)>0){\n        while($row=db_fetch_row($retval)){\n            print_row(\'Η συντομογραφία <b>«\'.$row[0].\'»</b> υπάρχει σε περισσότερα από ένα μαθήματα!\',\'error\',\'red\');    \n        }\n    } else {\n        print_row(\'Οι συντομογραφίες των μαθημάτων είναι μοναδικές!\',\'check\');\n    }\n}\n\n$sql=\"  SELECT if(short_name IS NULL OR TRIM(short_name)=\'\',IF(name IS NULL OR TRIM(name)=\'\',\'Χωρίς Όνομα\',name),short_name),\n                short_name,\n                name,\n                subject_type_id,\n                speciality_id,\n                grade_id\n        FROM subject\n        WHERE\n            (name IS NULL OR TRIM(name)=\'\' OR\n            short_name IS NULL OR TRIM(short_name)=\'\' OR\n            subject_type_id IS NULL OR\n            speciality_id IS NULL OR\n            grade_id IS NULL) AND id>=10\n        ORDER BY short_name,name\";\n$retval = nuRunQuery($sql);\n\nif($retval){\n    if(db_num_rows($retval)>0){\n        while($row=db_fetch_row($retval)){\n            $m = \'\';\n            $m .= (is_null($row[1]) ||  trim($row[1])==\'\' ? \'Συντομογραφία\' : \'\');\n            $m .= (is_null($row[2]) ||  trim($row[2])==\'\' ? \'-Όνομα\' : \'\');\n            $m .= (is_null($row[3]) ? \'-Τύπος Μαθήματος\' : \'\');\n            $m .= (is_null($row[4]) ? \'-Ειδικότητα\' : \'\');\n            $m .= (is_null($row[5]) ? \'-Τάξη\' : \'\');\n            print_row(\'Για το μάθημα <b>«\'.$row[0].\'»</b> δεν έχουν συμπληρωθεί τα : <b>\'.$m.\'</b>\',\'stop\');    \n        }\n    } else {\n        print_row(\'Οι βασικές λεπτομέρειες όλων των μαθημάτων έχουν συμπληρωθεί!\',\'check\');\n    }\n}\n//******************************************** Ειδικότητες ***********************************************************\nprint_row(\'<hr>\'); \nprint_row(\'<b>Έλεγχος Ειδικοτήτων...</b>\');\n$sql=\"  SELECT \n            if (name is null or trim(name)=\'\',if(short_name is null or trim(short_name)=\'\',\'Χωρίς Όνομα\',short_name),name) as full_name\n        FROM speciality\n        WHERE section_id IS NULL\n        ORDER BY full_name\";\n$retval = nuRunQuery($sql);\n\nif($retval){\n    if(db_num_rows($retval)>0){\n        while($row=db_fetch_row($retval)){\n            print_row(\'Η ειδικότητα <b>«\'.$row[0].\'»</b> δεν έχει αντιστοιχηθεί σε τομέα!\',\'stop\');    \n        }\n    } else {\n        print_row(\'Όλες οι ειδικότητες έχουν αντιστοιχηθεί σε τομείς!\',\'check\');\n    }\n}\n\n//******************************************** Διδακτικές Ώρες ***********************************************************\nprint_row(\'<hr>\'); \nprint_row(\'<b>Έλεγχος Διδακτικών Ωρών...</b>\');\n$sql=\"  SELECT \n            id,\n            name,\n            start_time,\n            end_time\n        FROM period\n        ORDER BY id\";\n$retval = nuRunQuery($sql);\n\nif($retval){\n    $err=false;\n    $cur_time =\'00:00:00\';\n    \n    while($row=db_fetch_row($retval)){\n        \n        $start_time = $row[2];\n        $end_time = $row[3];\n        \n        if($start_time<$cur_time){\n            print_row(\'Η <b>«\'.$row[1].\'»</b> ξεκινά πρίν την ολοκλήρωση της προηγούμενης ώρας!\',\'error\',\'red\');\n            $err=true;\n        }\n        \n        if($end_time<$start_time){\n            print_row(\'Η <b>«\'.$row[1].\'»</b> δεν έχει οριστεί σωστά! Τελειώνει πριν ξεκινήσει!\',\'error\',\'red\');\n            $err=true;\n        }\n        \n        $cur_time = $end_time;\n    }\n    \n    if(!$err){\n        print_row(\'Οι διδακτικές ώρες έχουν ρυθμιστεί σωστά!\',\'check\');    \n    }\n}\n//******************************************** Περίοδοι Αξιολόγησης ***********************************************************\nprint_row(\'<hr>\'); \nprint_row(\'<b>Έλεγχος Περιόδων Αξιολόγησης...</b>\');\n\n$sql=\"  SELECT \n            id,\n            name,\n            short_name,\n            start_date,\n            end_date,\n            marks_publication_date\n        FROM grading_period\n        ORDER BY name\";\n$retval = nuRunQuery($sql);\n\nif($retval){\n\n    $err=false;\n    \n    while($row=db_fetch_row($retval)){\n        $start_date = $row[3];\n        $end_date = $row[4];    \n        $marks_publication_date = $row[5];\n        \n        if($end_date<$start_date){\n            print_row(\'Στην περίοδο αξιολόγησης <b>«\'.$row[1].\'»</b> η καταχώριση λήγει πριν ξεκινήσει!\',\'error\',\'red\');\n            $err=true;\n        }\n        \n        if($marks_publication_date<$end_date){\n            print_row(\'Στην περίοδο αξιολόγησης <b>«\'.$row[1].\'»</b> η δημοσίευση της αξιολόγησης στους μαθητές γίνεται πριν ολοκληρωθεί η κατάθεση της!\',\'stop\');    \n            $err=true;\n        }\n    }\n    \n    if(!$err){\n        print_row(\'Οι ημερομηνίες στις περιόδους αξιολόγησης έχουν ρυθμιστεί σωστά!\',\'check\');    \n    }\n    \n}\n//******************************************** Σχολικό Έτος ***********************************************************\nprint_row(\'<hr>\'); \nprint_row(\'<b>Έλεγχος Σχολικού Έτους...</b>\');\n\n$sql=\"  SELECT \n            id,\n            if (name is null or trim(name)=\'\',if(short_name is null or trim(short_name)=\'\',\'Χωρίς Όνομα\',short_name),name) as full_name,\n            start_date,\n            end_date\n        FROM school_year\n        ORDER BY full_name\";\n$retval = nuRunQuery($sql);\n\nif($retval){\n\n    while($row=db_fetch_row($retval)){\n        $err=false;\n        $start_date = $row[2];\n        $end_date = $row[3];    \n        \n        if($end_date<$start_date){\n            print_row(\'Το <b>«\'.$row[1].\'»</b> λήγει πριν ξεκινήσει!\',\'error\',\'red\');\n            $err=true;\n        }\n    \n        $sql=\"  SELECT ifNULL(count(*),0) FROM holiday where school_year_id=\'\".$row[0].\"\'\";\n        $rv = nuRunQuery($sql);\n\n        if($r=db_fetch_row($rv)){\n            if($r[0]==0){\n                print_row(\'Για το <b>«\'.$row[1].\'»</b> δεν έχουν οριστεί αργίες!\',\'error\');\n                $err=true;\n            }\n        }\n        \n        if(!$err){\n            print_row (\'Το <b>«\'.$row[1].\'»</b> έχει ρυθμιστεί σωστά!\',\'check\');    \n        }    \n    }\n    \n    \n}\n//******************************************** Ρυθμίσεις email / SMS ***********************************************************\nprint_row(\'<hr>\'); \nprint_row(\'<b>Έλεγχος Ρυθμίσεων Email και SMS</b>\');\n\n$sql=\"  SELECT  \n            set_smtp_username,\n            set_smtp_password,\n            set_smtp_host,\n            set_smtp_from_address,\n            set_smtp_from_name,\n            set_smtp_port,\n            set_smtp_use_ssl\n        FROM zzzsys_setup WHERE zzzsys_setup_id=1\";\n$retval = nuRunQuery($sql);\n\nif($retval && $row=db_fetch_row($retval)){\n    $m = \'\';\n    \n    $m .= (is_null($row[0]) ||  trim($row[0])==\'\' ? \'Όνομα Χρήστη\' : \'\');\n    $m .= (is_null($row[1]) ||  trim($row[1])==\'\' ? \'-Κωδικός\' : \'\');\n    $m .= (is_null($row[2]) ||  trim($row[2])==\'\' ? \'-Διακομιστής\' : \'\');\n    $m .= (is_null($row[3]) ||  trim($row[3])==\'\' ? \'-Διεύθυνση από\' : \'\');\n    $m .= (is_null($row[4]) ||  trim($row[4])==\'\' ? \'-Όνομα από\' : \'\');    \n    $m .= (is_null($row[5]) ? \'-Θύρα Διακομιστή\' : \'\');\n    $m .= (is_null($row[6]) ? \'-Χρήση SSL\' : \'\');\n    \n    if($m != \'\'){\n        print_row(\'Στις ρυθμίσεις αποστολής Email δεν έχουν συμπληρωθεί τα : <b>\'.$m.\'</b>\',\'error\',\'red\');    \n    } else{\n        print_row(\'Όλες οι ρυθμίσεις για την αποστολή των Email έχουν συμπληρωθεί!\',\'check\');\n    }\n    \n    \n}\n\n$sql=\"  SELECT \n            login_name,\n            login_password,\n            originator,\n            name,\n            class_name,\n            api_key\n        FROM sms_gateway\n        WHERE active=1\";\n$retval = nuRunQuery($sql);\n\nif($retval){\n    if(db_num_rows($retval)>0){\n        $row=db_fetch_row($retval);\n        $m = \'\';\n        \n        if(is_null($row[5]) ||  trim($row[5])==\'\'){\n            $m .= (is_null($row[0]) ||  trim($row[0])==\'\' ? \'Όνομα Χρήστη\' : \'\');\n            $m .= (is_null($row[1]) ||  trim($row[1])==\'\' ? \'-Κωδικός\' : \'\'); \n            \n            $m .= ($m!=\'\' ? \' ή API Key\' : \'\');\n        }\n\n        $m .= (is_null($row[2]) ||  trim($row[2])==\'\' ? \'-Αποστολέας\' : \'\');\n    \n        if($m != \'\'){\n            print_row(\'Στις ρυθμίσεις αποστολής SMS δεν έχουν συμπληρωθεί τα : <b>\'.$m.\'</b>\',\'stop\');    \n        } else{\n            print_row(\'Οι ρυθμίσεις για την αποστολή των SMS έχουν συμπληρωθεί!\',\'check\');\n        }\n    \n        if(is_null($row[3]) ||  trim($row[3])==\'\' || is_null($row[4]) ||  trim($row[4])==\'\'){\n            print_row(\'O Λογαριασμός-Πάροχος που έχετε επιλέξει για την αποστολή των SMS δεν έχει ρυθμιστεί σωστά!\',\'error\',\'red\');\n        }\n    } else {\n        print_row(\'Δεν έχετε επιλέξει Λογαριασμό-Πάροχο για την αποστολή των SMS!\',\'warning\');\n    }\n  \n}\n\n//************************************************************************************************************************\nprint \" \n                    </td>\n                </tr>\n            </table>    \n        </table>\n    </body>\n</html>\";','','0','2016-07-24 15:53:14','globeadmin','2019-08-06 11:43:04','globeadmin','2019-08-06 11:43:04','globeadmin','0'),('5794ba9e70d0672','backup_db_file','Λήψη αντιγράφου ασφαλείας της βάσης δεδομένων σε αρχείο','manager','nuRunPHP(\'backup_db_lib\');\n\n$db = nuRunQuery();\n\n$nuParameters = \'-1\';\n\nif(\'#backup_file_name#\'!=\'\' && \'#backup_file_name#\'!=\'#\'.\'backup_file_name#\'){\n    $backup_name = \'#backup_file_name#\';    \n} else {\n    $backup_name = sys_get_temp_dir().DIRECTORY_SEPARATOR.$db[1].\".sql\";    \n}\n    try {\n	\n	    $db = nuRunQuery();\n\n	    $db_dumper = Shuttle_Dumper::create(array(\n		    \'host\' => $db[0],\n		    \'username\' => $db[2],\n		    \'password\' => $db[3],\n		    \'db_name\' => $db[1],\n	    ));\n\n	    $db_dumper->dump($backup_name);\n	    \n	    $nuParameters = $backup_name;\n\n    } catch(Shuttle_Exception $e) {\n        nuDebug(\"Couldn\'t dump database: \" . $e->getMessage());\n        $nuError = \"Παρουσιάστηκε σφάλμα κατά την εξαγωγή της βάσης δεδομένων!\";\n    }\n','','0','2016-07-24 15:54:54','globeadmin','2017-12-29 22:27:59','globeadmin','2021-04-01 20:30:31','globeadmin','0'),('54b3853f5280e06','set_class_responsible','Ορίζει υπέυθυνο καθηγητή για τους μαθητές ενός τμήματος','manager','\n$sql=\"update student inner join student_class \n    on student.id=student_class.student_id\n    set teacher_id=#teacher_id#\n    where \n        student_class.class_id=#class_id#\";\n\nnuRunQuery($sql);\n\n$sql=\"SELECT student.registration_number,student.surname,student.name, student.parent_name,teacher.short_name\nFROM student\ninner join student_class on student.id=student_class.student_id\ninner join teacher on student.teacher_id=teacher.id\nwhere student_class.class_id=#class_id#\norder by student.surname,student.name, student.parent_name\n\";\n\n$retval = nuRunQuery($sql);\n\nprint \"<html><body>\";\n\nif($retval && db_num_rows($retval)>0){\n\n    print (\"<table border=0  cellspacing=0>\n                <tr bgcolor=LightSalmon> \n                    <td width=80 align=center><b>Α.Μ.</b></td> \n                    <td width=200 align=left><b>Επώνυμο</b></td> \n                    <td width=180 align=left><b>Όνομα</b></td>\n                    <td width=180 align=left><b>Πατρώνυμο</b></td>\n                    <td width=200 align=left><b>Υπεύθυνος Καθητής</b></td>\n                </tr>\");\n\n    $i = 0;\n\n    while($row = db_fetch_row($retval)){\n    \n        if($i==0){\n            print \"\n                <tr bgcolor=LightBlue>\n                    <td align=center>\".$row[0].\"</td>\n                    <td align=left>\".$row[1].\"</td>\n                    <td align=left>\". $row[2].\"</td>\n                    <td align=left>\". $row[3].\"</td>\n                    <td align=left>\". $row[4].\"</td>\n                </tr>\";\n            $i=1;\n        }\n        else{\n            print \"\n                <tr bgcolor=LightSteelBlue>\n                    <td align=center>\".$row[0].\"</td>\n                    <td align=left>\".$row[1].\"</td>\n                    <td align=left>\". $row[2].\"</td>\n                    <td align=left>\". $row[3].\"</td>\n                    <td align=left>\". $row[4].\"</td>\n                </tr>\";\n            $i=0;\n        }\n    }\n    \n    print (\"</table>\");\n}\nelse{\n    print (\"<b><i>Δεν ανακτήθηκαν τα δεδομένα!</i></b>\");\n}\n\nprint \"</body></html>\";\n','','0','2015-01-12 10:26:39','globeadmin','2016-03-03 20:45:39','globeadmin','2018-07-16 23:25:10','globeadmin',''),('54d1374c9e8d38a','penalty_read','Διαβάζει τις ποινές που έχουν επιβληθεί από αρχείο excel του myschool','manager','require_once(\'Classes/PHPExcel.php\');\n\nfunction getCellDate($data){\n    if(strtotime($data)){\n        $st = strtotime($data);\n        return date(\'Y-m-d\',$st);    \n    } else if(PHPExcel_Shared_Date::isDateTime($data)) {\n        $cellValue = $data->getValue();\n        $dateValue = PHPExcel_Shared_Date::ExcelToPHP($cellValue);                       \n        return date(\'Y-m-d\',$dateValue);                          \n    } else {                        \n        return \"\";                                                   \n    } \n}\n\n\nprint \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n        \n        <STYLE TYPE=\\\"text/css\\\">\n            .sisTable TD{\n                font-size:7pt;\n            }\n        </STYLE>\n    </head>\n    <body onload=\\\"adjustIframeHeight()\\\">\";\n\n//fetch the uploaded file information\n$S = stripslashes(\'#FILES#\');\n$J = json_decode($S);\n\n$name = $J[0]->{\'name\'};\n$type = $J[0]->{\'type\'};\n$error = $J[0]->{\'error\'};\n$size  = $J[0]->{\'size\'};\n\n$uploaddir= sys_get_temp_dir();\n$uploadfile = $uploaddir .\'/\'.$name;\n\n$inputFileName = $uploadfile;\n$objPHPExcel = PHPExcel_IOFactory::load($inputFileName);\n$objWorksheet = $objPHPExcel->getActiveSheet();\n$highestRow = $objWorksheet->getHighestRow();\n\n$curValueA=\'\';$curValueB=\'\';$curValueC=\'\';\n$sql=\"delete from penalty_in where 1\";\nnuRunQuery($sql);\n\nfor ($row = 1; $row <= $highestRow; ++$row) { \n    $cellValueA = $objWorksheet->getCell(\'A\'.$row)\n                                    ->getFormattedValue();\n    $cellValueB = $objWorksheet->getCell(\'B\'.$row)\n                                    ->getFormattedValue();\n    $cellValueC = $objWorksheet->getCell(\'C\'.$row)\n                                    ->getFormattedValue();\n    \n    $cellValueD = getCellDate($objWorksheet->getCell(\'D\'.$row)); \n    \n    $cellValueE = $objWorksheet->getCell(\'E\'.$row)\n                                    ->getFormattedValue();\n    $cellValueF = $objWorksheet->getCell(\'F\'.$row)\n                                    ->getFormattedValue();\n    $cellValueG = $objWorksheet->getCell(\'G\'.$row)\n                                    ->getFormattedValue();\n    $cellValueH = $objWorksheet->getCell(\'H\'.$row)\n                                    ->getFormattedValue();\n    \n    if ($cellValueD != \'\') {\n        \n        $curValueA=(is_null($cellValueA) || $cellValueA==\'\'? $curValueA : $cellValueA);\n        $curValueB=(is_null($cellValueB) || $cellValueB==\'\'? $curValueB : $cellValueB);\n        $curValueC=(is_null($cellValueC) || $cellValueC==\'\'? $curValueC : $cellValueC);\n        \n        if ($curValueA!=\'\'){\n            \n            $sql=\"insert into penalty_in \n                        (id,\n                        student_id,\n                        teacher_id,\n                        registration_number,\n                        name,\n                        surname,\n                        date_enforced,\n                        type,\n                        reason,\n                        carrier,\n                        allredy_exists) \n                    values \n                        (NULL,\n                        NULL,\n                        NULL,\'\".\n                        $curValueA.\"\',\'\".\n                        $curValueB.\"\',\'\".\n                        $curValueC.\"\',\'\".\n                        $cellValueD.\"\',\'\".\n                        $cellValueF.\"\',\'\".\n                        addslashes($cellValueG).\"\',\'\".\n                        $cellValueH.\"\',0)\";\n            nuRunQuery($sql);\n        }\n    }\n}\n\nunlink($uploadfile);\n\n$sql=\"update penalty_in \ninner join student on penalty_in.registration_number=student.registration_number\nset penalty_in.student_id=student.id\";\nnuRunQuery($sql);\n\n$sql=\"update penalty_in \ninner join teacher on penalty_in.carrier=teacher.short_name\nset penalty_in.teacher_id=teacher.id\";\nnuRunQuery($sql);\n\n$sql=\"DELETE p1 \nFROM penalty_in p1, penalty_in p2 \nWHERE p1.id > p2.id and\n    p1.student_id=p2.student_id and\n    p1.date_enforced=p2.date_enforced and\n    p1.type=p2.type and\n    p1.reason=p2.reason and\n    p1.carrier=p2.carrier\";\nnuRunQuery($sql);\n\n$sql=\"update penalty_in \n        inner join penalty on \n                    penalty_in.student_id=penalty.student_id and\n                    penalty_in.date_enforced=penalty.date_enforced and\n                    penalty_in.type=penalty.type and\n                    penalty_in.reason=penalty.reason and\n                    penalty_in.carrier=penalty.carrier\n        set penalty_in.allredy_exists=1\";\nnuRunQuery($sql);\n\n$sql=\"select * from penalty_in order by student_id,date_enforced\";\n$retval=nuRunQuery($sql);\n\nif($retval && db_num_rows($retval)>0) {\n\n    print (\"\n        <table cellspacing=0 CLASS=\\\"sisTable\\\">\n            <tr height=40>\n                <th width=60 align=center>A/A</th>\n                <th width=60 align=center>A.M.</th> \n                <th width=200 align=center>Επώνυμο</th>\n                <th width=180 align=center>Όνομα</th>\n                <th width=100 align=center>Ημερομηνία</th>\n                <th width=150 align=center>Τύπος Ποινής</th>\n                <th width=300 align=center>Αιτία</th>\n                <th width=150 align=center>Φορέας Επιβολής</th>\n            </tr>\");  \n            \n    $j=1;\n    \n    $color_error=\'OrangeRed\';\n    $color_exists=\'LightSteelBlue\';\n    $color_insert=\'LightGreen\';\n    \n    while($row = db_fetch_row($retval)) {\n    \n        if(is_null($row[1])){\n            $color=$color_error;\n        } else if ($row[10]==1){\n            $color=$color_exists;\n        } else {\n            $color=$color_insert;\n        }\n    \n        print (\"\n            <tr style=\\\"background-color:$color;\\\" height=25>\n                <td align=center>\".$j.\"</td>\n                <td align=center>\".$row[3].\"</td>\n                <td align=left>\".$row[4].\"</td>\n                <td align=left>\".$row[5].\"</td>\n                <td align=left>\".date_format(date_create_from_format(\"Y-m-d\",$row[6]),\"d-m-Y\").\"</td>\n                <td align=left>\".(is_null($row[7]) || $row[7]==\'\'? \'&nbsp;\' : $row[7]).\"</td>\n                <td align=left>\".(is_null($row[8]) || $row[8]==\'\'? \'&nbsp;\' : $row[8]).\"</td>\n                <td align=left>\".(is_null($row[9]) || $row[9]==\'\'? \'&nbsp;\' : $row[9]).\"</td>\n                </tr>\");\n        $j++;    \n    }\n    print (\"\n        </table>\");\n}\nelse{\n    print \"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν δεδομένα...</span>\";\n}\n\nprint \"\n    </body>\n</html>\";\n','','0','2015-02-03 23:02:04','globeadmin','2019-08-05 23:37:22','globeadmin','2022-02-11 21:55:05','globeadmin','0'),('54d65d126230684','penalty_insert','Εισάγει τις ποινές που έχουν διαβαστεί από το αρχείο excel','manager','nuRunPHP(\'notification_add_lib\');\n\nprint \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n    </head>\n    <body>\n    \";\n\n$sql=\"select count(*) \n    from penalty_in \n    where (student_id is not NULL) and allredy_exists=0\";\n$retval=nuRunQuery($sql);\n\nif($retval && db_num_rows($retval)>0) {\n    $row = db_fetch_row($retval);\n    if($row[0]>0){\n        \n        $sql=\"  SELECT \n                    student_id,\n                    teacher_id,\n                    date_enforced,\n                    type,\n                    reason,\n                    carrier,\n                    \'#RECORD_ID#\'\n                FROM penalty_in \n                WHERE (student_id is not NULL) and allredy_exists=0\n                ORDER BY student_id,date_enforced\";\n        $rv=nuRunQuery($sql);\n        \n        while($r=db_fetch_row($rv)){\n            $sql=\"  INSERT INTO penalty (\n                    student_id,\n                    teacher_id,\n                    date_enforced,\n                    type,\n                    reason,\n                    carrier,\n                    post_teacher_id) VALUES (\n                    \'\".$r[0].\"\',\n                    \'\".$r[1].\"\',\n                    \'\".$r[2].\"\',\n                    \'\".$r[3].\"\',\n                    \'\".$r[4].\"\',\n                    \'\".$r[5].\"\',\n                    \'\".$r[6].\"\'\n                    )\";\n            $new_id = nuRunQuery($sql,null,true);\n            \n            new_penalty_notification($new_id);\n        }\n        print \"<span CLASS=\\\"msgSuccess\\\">Εισήχθησαν \".$row[0].\" νέες ποινές!</span>\";\n    } else {\n        print \"<span CLASS=\\\"msg\\\">Δεν υπάρχουν ποινές προς εισαγωγή...</span>\";\n    }\n} else{\n    print \"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν δεδομένα...</span>\";\n}\n\nprint \"\n    </body>\n</html>\";\n','','0','2015-02-07 20:44:34','globeadmin','2018-07-16 11:57:18','globeadmin','2021-01-04 21:33:58','globeadmin','0'),('54d6660b538bea2','penalty_student_show','Εμφανίζει τις ποινές του μαθητή','student','print \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n        \n        <STYLE TYPE=\\\"text/css\\\">\n            .sisTableLine TH{\n                font-size:9pt;\n            }\n             .sisTableLine TD{\n                font-weight: normal;\n            }           \n\n            .sisTableLine tr:nth-child(even){\n	            background-color: LightSteelBlue;\n            }\n        </STYLE>\n    \n    </head>\n\n    <body onload=\\\"adjustIframeHeight()\\\">\";\n\n$sql=\"  select \n            date_enforced,\n            type,\n            reason,\n            carrier,\n            ifNULL(period.name,\'\'),\n            if(penalty.teacher_id IS NULL,\'\',concat(ifNULL(teacher.surname,\'\'),if(teacher.surname IS NOT NULL AND teacher.name IS NOT NULL,\' \',\'\'),ifNULL(teacher.name,\'\')))\n        from penalty\n        LEFT JOIN period ON penalty.period_id=period.id\n        LEFT JOIN teacher ON teacher.id = penalty.teacher_id\n        where student_id=#RECORD_ID# \n        order by date_enforced\";\n        \n$retval=nuRunQuery($sql);\n\nif($retval) {\n    if(db_num_rows($retval)>0) {\n    \n        print (\"\n        <table CLASS=\\\"sisTableLine\\\" cellspacing=0 width=100%>\n            <tr height=35>\n                <th width=50 align=center>A/A</th>\n                <th width=80 align=center>Ημερομηνία</th>\n                <th width=60 align=center>Ώρα</th>\n                <th width=100 align=center>Τύπος Ποινής</th>\n                <th width=370 align=center>Αιτία</td>\n                <th width=150 align=center>Καθηγητής</th>\n                <th width=150 align=center>Φορέας Επιβολής</th>\n            </tr>\");\n            \n        $j=1;\n    \n        while($row = db_fetch_row($retval)) {\n    \n        print (\"\n            <tr  height=25>\n                <td align=center>\".$j.\"</td>\n                <td align=center>\".date_format(date_create_from_format(\"Y-m-d\",$row[0]),\"d-m-Y\").\"</td>\n                <td align=center>\".(is_null($row[4]) || $row[4]==\'\'? \'&nbsp;\' : $row[4]).\"</td>\n                <td align=center>\".(is_null($row[1]) || $row[1]==\'\'? \'&nbsp;\' : $row[1]).\"</td>\n                <td align=left>\".(is_null($row[2]) || $row[2]==\'\'? \'&nbsp;\' : $row[2]).\"</td>\n                <td align=center>\".(is_null($row[5]) || $row[5]==\'\'? \'&nbsp;\' : $row[5]).\"</td>\n                <td align=center>\".(is_null($row[3]) || $row[3]==\'\'? \'&nbsp;\' : $row[3]).\"</td>\n            </tr>\");\n        $j++;    \n        }\n        print (\"\n        </table>\");\n    }\n    else{\n        print (\"<span CLASS=\\\"msgSuccess\\\">Δεν έχουν επιβληθεί ποινές!</span>\");\n    }\n}\nelse{\n    print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν δεδομένα...</span>\");\n}\nprint \"\n    </body>\n</html>\";\n','','0','2015-02-07 21:22:51','globeadmin','2018-07-15 13:23:39','globeadmin','2022-01-08 11:05:32','globeadmin','0'),('54da24749d82eb7','myFILE','my Upload File','manager','$h = \"\n<html>\n    <body>\n        <form enctype=\'multipart/form-data\' action=\'myupload.php\' method=\'POST\'>\n            <input name=\'userfile\' type=\'file\' onchange=\'this.form.submit()\' />\n        </form>\n    </body>\n</html> \n\";\n\nprint $h;\n','','0','2015-02-10 17:32:04','globeadmin','2018-07-17 15:20:00','globeadmin','2019-08-03 23:53:07','globeadmin','0'),('54df2384b808c9b','student_read','Διαβάζει τους μαθητές από αρχείο excel του myschool','manager','require_once(\'Classes/PHPExcel.php\');\n\n/*function validateDate($date, $format = \'m-d-y\'){\n    $d = DateTime::createFromFormat($format, $date);\n    return $d && $d->format($format) == $date;\n}*/\n\nfunction getCellDate($data){\n    if(strtotime($data)){\n        $st = strtotime($data);\n        return date(\'Y-m-d\',$st);    \n    } else if(PHPExcel_Shared_Date::isDateTime($data)) {\n        $cellValue = $data->getValue();\n        $dateValue = PHPExcel_Shared_Date::ExcelToPHP($cellValue);                       \n        return date(\'Y-m-d\',$dateValue);                          \n    } else {                        \n        return \"\";                                                   \n    } \n}\n\nprint \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n\n        <STYLE TYPE=\\\"text/css\\\">\n            .sisTable, .sisTable TD{\n                font-size:7pt;\n            }\n            .sisTable TH{\n                font-size:7pt;\n            }\n    \n            div:before{content:attr(title); display:none; }\n            div:hover::before{ width:200px; display:block; background:yellow; border:1px solid black; padding:8px; margin:25px 0 0 10px; }\n            div:hover{z-index:10; position:relative;}\n        </STYLE>\n    </head>\n    <body onload=\\\"adjustIframeHeight()\\\">\";\n\n//fetch the uploaded file information\n$S = stripslashes(\'#FILES#\');\n$J = json_decode($S);\n\n$name = $J[0]->{\'name\'};\n$type = $J[0]->{\'type\'};\n$error = $J[0]->{\'error\'};\n$size  = $J[0]->{\'size\'};\n\n$uploaddir= sys_get_temp_dir();\n$uploadfile = $uploaddir .\'/\'.$name;\n\n$inputFileName = $uploadfile;\n\n$objPHPExcel = PHPExcel_IOFactory::load($inputFileName);\n$objWorksheet = $objPHPExcel->getActiveSheet();\n$highestRow = $objWorksheet->getHighestRow();\n\n\n$sql=\"delete from student_in where 1\";\nnuRunQuery($sql);\n\n//------------------------------------------------------------------------------------------------------\n$db_params = nuRunQuery();\n$link = mysqli_connect($db_params[0], $db_params[2], $db_params[3], $db_params[1]);\n\nif (mysqli_connect_errno()) {\n    nuDebug(\"Connect failed: %s\\n\", mysqli_connect_error());\n}\n//------------------------------------------------------------------------------------------------------\n\nfor ($row = 1; $row <= $highestRow; ++$row) { \n    $cellValueA = $objWorksheet->getCell(\'A\'.$row)\n                                    ->getFormattedValue();\n    $cellValueB = $objWorksheet->getCell(\'B\'.$row)\n                                    ->getFormattedValue();\n    $cellValueC = $objWorksheet->getCell(\'C\'.$row)\n                                    ->getFormattedValue();\n    $cellValueD = $objWorksheet->getCell(\'D\'.$row)\n                                    ->getFormattedValue();\n    $cellValueE = $objWorksheet->getCell(\'E\'.$row)\n                                    ->getFormattedValue();\n    $cellValueF = $objWorksheet->getCell(\'F\'.$row)\n                                    ->getFormattedValue();\n                                    \n    $cellValueG = getCellDate($objWorksheet->getCell(\'G\'.$row));\n    \n    $cellValueH = $objWorksheet->getCell(\'H\'.$row)\n                                    ->getFormattedValue();\n    $cellValueI = $objWorksheet->getCell(\'I\'.$row)\n                                    ->getFormattedValue();\n    $cellValueJ = $objWorksheet->getCell(\'J\'.$row)\n                                    ->getFormattedValue();\n    $cellValueK = $objWorksheet->getCell(\'K\'.$row)\n                                    ->getFormattedValue();\n    $cellValueL = $objWorksheet->getCell(\'L\'.$row)\n                                    ->getFormattedValue();\n    $cellValueM = $objWorksheet->getCell(\'M\'.$row)\n                                    ->getFormattedValue();\n    $cellValueN = $objWorksheet->getCell(\'N\'.$row)\n                                    ->getFormattedValue();\n    $cellValueO = $objWorksheet->getCell(\'O\'.$row)\n                                    ->getFormattedValue();\n    $cellValueP = $objWorksheet->getCell(\'P\'.$row)\n                                    ->getFormattedValue();\n    $cellValueQ = $objWorksheet->getCell(\'Q\'.$row)\n                                    ->getFormattedValue();\n    $cellValueR = $objWorksheet->getCell(\'R\'.$row)\n                                    ->getFormattedValue();\n    $cellValueS = $objWorksheet->getCell(\'S\'.$row)\n                                    ->getFormattedValue();\n    $cellValueT = $objWorksheet->getCell(\'T\'.$row)\n                                    ->getFormattedValue();\n    $cellValueU = $objWorksheet->getCell(\'U\'.$row)\n                                    ->getFormattedValue();\n    $cellValueV = $objWorksheet->getCell(\'V\'.$row)\n                                    ->getFormattedValue();\n    $cellValueW = $objWorksheet->getCell(\'W\'.$row)\n                                    ->getFormattedValue();\n    $cellValueX = $objWorksheet->getCell(\'X\'.$row)\n                                    ->getFormattedValue();\n    $cellValueY = $objWorksheet->getCell(\'Y\'.$row)\n                                    ->getFormattedValue();\n    $cellValueZ = $objWorksheet->getCell(\'Z\'.$row)\n                                    ->getFormattedValue();\n    $cellValueAA = $objWorksheet->getCell(\'AA\'.$row)\n                                    ->getFormattedValue();\n    $cellValueAB = $objWorksheet->getCell(\'AB\'.$row)\n                                    ->getFormattedValue();                                \n                                    \n    \n    \n    if($cellValueG!=\'\' && !is_null($cellValueE) && $cellValueE!=\'\' && is_numeric($cellValueE)){  \n    \n    /*if (!is_null($cellValueE) && !is_null($cellValueG) && $cellValueE!=\'\' && $cellValueG!=\'\' && is_numeric($cellValueE) && \n                    (\n                    validateDate($cellValueG,\'m-d-Y\') || \n                    validateDate($cellValueG,\'m/d/Y\') ||\n                    validateDate($cellValueG,\'m-d-y\') || \n                    validateDate($cellValueG,\'m/d/y\')\n                    )) {*/\n                    \n        $sql=\"insert into student_in \n                        (student_id,\n                        name,\n                        surname,\n                        fathers_name,\n                        mothers_name,\n                        registration_number,\n                        gender,\n                        birth_date,\n                        phone1,\n                        phone2,\n                        mobile,\n                        email,\n                        street,\n                        area,\n                        zipcode,\n                        city,\n                        parent_name,\n                        parent_surname,\n                        parent_phone1,\n                        parent_phone2,\n                        parent_phone3,\n                        parent_email,\n                        parent_street,\n                        parent_area,\n                        parent_zipcode,\n                        speciality,\n                        grade,\n                        mothers_surname,\n                        parent_email2\n                        ) \n                    values \n                        (NULL,\'\". \n                        mysqli_real_escape_string($link,$cellValueA).\"\',\'\".\n                        mysqli_real_escape_string($link,$cellValueB).\"\',\'\".\n                        mysqli_real_escape_string($link,$cellValueC).\"\',\'\".\n                        mysqli_real_escape_string($link,$cellValueD).\"\',\'\".\n                        $cellValueE.\"\',\'\".\n                        mysqli_real_escape_string($link,$cellValueF).\"\',\'\".\n                        $cellValueG.\"\',\'\".\n                        mysqli_real_escape_string($link,$cellValueH).\"\',\'\".\n                        mysqli_real_escape_string($link,$cellValueI).\"\',\'\".\n                        mysqli_real_escape_string($link,$cellValueJ).\"\',\'\".\n                        mysqli_real_escape_string($link,$cellValueK).\"\',\'\".\n                        mysqli_real_escape_string($link,$cellValueL).\"\',\'\".\n                        mysqli_real_escape_string($link,$cellValueM).\"\',\'\".\n                        mysqli_real_escape_string($link,$cellValueN).\"\',\'\".\n                        mysqli_real_escape_string($link,$cellValueO).\"\',\'\".\n                        mysqli_real_escape_string($link,$cellValueP).\"\',\'\".\n                        mysqli_real_escape_string($link,$cellValueQ).\"\',\'\".\n                        mysqli_real_escape_string($link,$cellValueR).\"\',\'\".\n                        mysqli_real_escape_string($link,$cellValueS).\"\',\'\".\n                        mysqli_real_escape_string($link,$cellValueT).\"\',\'\".\n                        mysqli_real_escape_string($link,$cellValueU).\"\',\'\".\n                        mysqli_real_escape_string($link,$cellValueV).\"\',\'\".\n                        mysqli_real_escape_string($link,$cellValueW).\"\',\'\".\n                        mysqli_real_escape_string($link,$cellValueX).\"\',\'\".\n                        mysqli_real_escape_string($link,$cellValueY).\"\',\'\".\n                        mysqli_real_escape_string($link,$cellValueZ).\"\',\'\".\n                        mysqli_real_escape_string($link,$cellValueAA).\"\',\'\".\n                        mysqli_real_escape_string($link,$cellValueAB).\"\')\";\n        nuRunQuery($sql);\n    }\n}\n\n//unlink($uploadfile);\n\n$sql=\"update student_in \ninner join student on student_in.registration_number=student.registration_number\nset student_in.student_id=student.id\";\nnuRunQuery($sql);\n\n$sql=\"SELECT \n    student_in.student_id,\n    student_in.name,\n    student_in.surname,\n    student_in.fathers_name,\n    student_in.mothers_name,\n    student_in.registration_number,\n    student_in.gender,\n    student_in.birth_date,\n    student_in.phone1,\n    student_in.phone2,\n    student_in.mobile,\n    student_in.email,\n    student_in.street,\n    student_in.area,\n    student_in.zipcode,\n    student_in.city,\n    student_in.parent_name,\n    student_in.parent_surname,\n    student_in.parent_phone1,\n    student_in.parent_phone2,\n    student_in.parent_phone3,\n    student_in.parent_email,\n    student_in.parent_street,\n    student_in.parent_area,\n    student_in.parent_zipcode,\n    student_in.speciality,\n    student_in.grade,\n    student.id,\n    student.name,\n    student.surname,\n    student.fathers_name,\n    student.mothers_name,\n    student.registration_number,\n    student.gender,\n    student.birth_date,\n    student.phone1,\n    student.phone2,\n    student.mobile,\n    student.email,\n    student.street,\n    student.area,\n    student.zipcode,\n    student.city,\n    student.parent_name,\n    student.parent_surname,\n    student.parent_phone1,\n    student.parent_phone2,\n    student.parent_phone3,\n    student.parent_email,\n    student.parent_street,\n    student.parent_area,\n    student.parent_zipcode,\n    \'\',\n    student.grade_id, \n    IF(student.grade_id IS NULL,NULL,grade.short_name),\n    student_in.mothers_surname,\n    student.mothers_surname,\n    student_in.parent_email2,\n    student.parent_email2\nFROM student_in \nLEFT JOIN student on student_in.student_id=student.id\nLEFT JOIN grade ON grade.id = student.grade_id\nORDER BY \n    student_in.grade,\n    student_in.surname,\n    student_in.name,\n    student_in.fathers_name\";\n\n$retval=nuRunQuery($sql);\n\nif($retval && db_num_rows($retval)>0) {\n\n    print (\"\n        <table cellspacing=0 CLASS=\\\"sisTable\\\">\n            <tr height=40>\n                <th width=40 align=center>A/A</th>\n                <th width=80 align=center>Όνομα<br>Μαθητή</th>	\n                <th width=80 align=center>Επώνυμο<br>Μαθητή</th>	\n                <th width=60 align=center>Όνομα<br>Πατέρα</th>\n                <th width=60 align=center>Όνομα<br>Μητέρας</th>\n                <th width=60 align=center>Γένος</th>\n                <th width=60 align=center>Αριθμός<br>Μητρώου</th>\n                <th width=50 align=center>Φύλο</th>\n                <th width=80 align=center>Ημ/νια<br>Γέννησης</th>\n                <th width=80 align=center>Τηλ.1<br>Μαθητή</th>\n                <th width=80 align=center>Τηλ.2<br>Μαθητή</th>\n                <th width=80 align=center>Κινητό<br>Μαθητή</th>\n                <th width=100 align=center>eMail<br>Μαθητή</th>\n                <th width=100 align=center>Διεύθυνση,<br>Οδός-Αριθμός</th>\n                <th width=100 align=center>Διεύθυνση,<br>Περιοχή</th>\n                <th width=80 align=center>Διεύθυνση,<br>Τ.Κ.</th>\n                <th width=100 align=center>Τοποθεσία<br>Διεύθ. Μαθητή</th>\n                <th width=60 align=center>Όνομα<br>Κηδεμόνα</th>\n                <th width=80 align=center>Επώνυμο<br>Κηδεμόνα</th>\n                <th width=80 align=center>Τηλ.1<br>Κηδεμόνα</th>\n                <th width=80 align=center>Τηλ.2<br>Κηδεμόνα</th>\n                <th width=80 align=center>Τηλ.3<br>Κηδεμόνα</th>\n                <th width=100 align=center>eMail<br>Κηδεμόνα</th>\n                <th width=100 align=center>Διεύθυνση<br>Κηδεμόνα</th>\n                <th width=100 align=center>Περιοχή<br>Κηδεμόνα</th>\n                <th width=80 align=center>Τ.Κ.<br>Κηδεμόνα</th>\n                <th width=80 align=center>Ειδικότητα</th>\n                <th width=60 align=center>Τάξη</th>\n                <th width=100 align=center>eMail 2<br>Κηδεμόνα</th>\n            </tr>\");  \n            \n    $j=1;\n    \n    $color_error=\'OrangeRed\';\n    $color_exists=\'LightSteelBlue\';\n    $color_insert=\'LightGreen\';\n    $color_diff=\'Yellow\';\n    \n    while($row = db_fetch_row($retval)) {\n    \n        if(is_null($row[0])){\n            $color=$color_insert;\n        } else { \n            $color=$color_exists;\n        } \n        \n        print (\"\n            <tr style=\\\"background-color:$color;\\\" height=25>\n                <td align=center>\".$j.\"</td>\n                <td style=\\\"background-color:\".($color==$color_insert ? $color_insert : ($row[1]==$row[28] ? $color : $color_diff)).\";\\\" align=left\".($row[1]!=$row[28] ? \' title=\"\'.$row[28].\'\"\' : \'\').\">\".(is_null($row[1]) || $row[1]==\'\'? \'&nbsp;\' : $row[1]).\"</td>\n                <td style=\\\"background-color:\".($color==$color_insert ? $color_insert : ($row[2]==$row[29] ? $color : $color_diff)).\";\\\" align=left\".($row[2]!=$row[29] ? \' title=\"\'.$row[29].\'\"\' : \'\').\">\".(is_null($row[2]) || $row[2]==\'\'? \'&nbsp;\' : $row[2]).\"</td>\n                <td style=\\\"background-color:\".($color==$color_insert ? $color_insert : ($row[3]==$row[30] ? $color : $color_diff)).\";\\\" align=left\".($row[3]!=$row[30] ? \' title=\"\'.$row[30].\'\"\' : \'\').\">\".(is_null($row[3]) || $row[3]==\'\'? \'&nbsp;\' : $row[3]).\"</td>\n                <td style=\\\"background-color:\".($color==$color_insert ? $color_insert : ($row[4]==$row[31] ? $color : $color_diff)).\";\\\" align=left\".($row[4]!=$row[31] ? \' title=\"\'.$row[31].\'\"\' : \'\').\">\".(is_null($row[4]) || $row[4]==\'\'? \'&nbsp;\' : $row[4]).\"</td>\n                <td style=\\\"background-color:\".($color==$color_insert ? $color_insert : ($row[55]==$row[56] ? $color : $color_diff)).\";\\\" align=left\".($row[55]!=$row[56] ? \' title=\"\'.$row[56].\'\"\' : \'\').\">\".(is_null($row[55]) || $row[55]==\'\'? \'&nbsp;\' : $row[55]).\"</td>\n                <td style=\\\"background-color:\".($color==$color_insert ? $color_insert : ($row[5]==$row[32] ? $color : $color_diff)).\";\\\" align=left\".($row[5]!=$row[32] ? \' title=\"\'.$row[32].\'\"\' : \'\').\">\".(is_null($row[5]) || $row[5]==\'\'? \'&nbsp;\' : $row[5]).\"</td>\n                <td style=\\\"background-color:\".($color==$color_insert ? $color_insert : ($row[6]==$row[33] ? $color : $color_diff)).\";\\\" align=left\".($row[6]!=$row[33] ? \' title=\"\'.$row[33].\'\"\' : \'\').\">\".(is_null($row[6]) || $row[6]==\'\'? \'&nbsp;\' : $row[6]).\"</td>\n                <td style=\\\"background-color:\".($color==$color_insert ? $color_insert : ($row[7]==$row[34] ? $color : $color_diff)).\";\\\" align=left\".($row[7]!=$row[34] ? \' title=\"\'.date_format(date_create_from_format(\"Y-m-d\",$row[34]),\"d-m-Y\").\'\"\' : \'\').\">\".date_format(date_create_from_format(\"Y-m-d\",$row[7]),\"d-m-Y\").\"</td>\n                <td style=\\\"background-color:\".($color==$color_insert ? $color_insert : ($row[8]==$row[35] ? $color : $color_diff)).\";\\\" align=left\".($row[8]!=$row[35] ? \' title=\"\'.$row[35].\'\"\' : \'\').\">\".(is_null($row[8]) || $row[8]==\'\'? \'&nbsp;\' : $row[8]).\"</td>\n                <td style=\\\"background-color:\".($color==$color_insert ? $color_insert : ($row[9]==$row[36] ? $color : $color_diff)).\";\\\" align=left\".($row[9]!=$row[36] ? \' title=\"\'.$row[36].\'\"\' : \'\').\">\".(is_null($row[9]) || $row[9]==\'\'? \'&nbsp;\' : $row[9]).\"</td>\n                <td style=\\\"background-color:\".($color==$color_insert ? $color_insert : ($row[10]==$row[37] ? $color : $color_diff)).\";\\\" align=left\".($row[10]!=$row[37] ? \' title=\"\'.$row[37].\'\"\' : \'\').\">\".(is_null($row[10]) || $row[10]==\'\'? \'&nbsp;\' : $row[10]).\"</td>\n                <td style=\\\"background-color:\".($color==$color_insert ? $color_insert : ($row[11]==$row[38] ? $color : $color_diff)).\";\\\" align=left\".($row[11]!=$row[38] ? \' title=\"\'.$row[38].\'\"\' : \'\').\">\".(is_null($row[11]) || $row[11]==\'\'? \'&nbsp;\' : $row[11]).\"</td>\n                <td style=\\\"background-color:\".($color==$color_insert ? $color_insert : ($row[12]==$row[39] ? $color : $color_diff)).\";\\\" align=left\".($row[12]!=$row[39] ? \' title=\"\'.$row[39].\'\"\' : \'\').\">\".(is_null($row[12]) || $row[12]==\'\'? \'&nbsp;\' : $row[12]).\"</td>\n                <td style=\\\"background-color:\".($color==$color_insert ? $color_insert : ($row[13]==$row[40] ? $color : $color_diff)).\";\\\" align=left\".($row[13]!=$row[40] ? \' title=\"\'.$row[40].\'\"\' : \'\').\">\".(is_null($row[13]) || $row[13]==\'\'? \'&nbsp;\' : $row[13]).\"</td>\n                <td style=\\\"background-color:\".($color==$color_insert ? $color_insert : ($row[14]==$row[41] ? $color : $color_diff)).\";\\\" align=left\".($row[14]!=$row[41] ? \' title=\"\'.$row[41].\'\"\' : \'\').\">\".(is_null($row[14]) || $row[14]==\'\'? \'&nbsp;\' : $row[14]).\"</td>\n                <td style=\\\"background-color:\".($color==$color_insert ? $color_insert : ($row[15]==$row[42] ? $color : $color_diff)).\";\\\" align=left\".($row[15]!=$row[42] ? \' title=\"\'.$row[42].\'\"\' : \'\').\">\".(is_null($row[15]) || $row[15]==\'\'? \'&nbsp;\' : $row[15]).\"</td>\n                <td style=\\\"background-color:\".($color==$color_insert ? $color_insert : ($row[16]==$row[43] ? $color : $color_diff)).\";\\\" align=left\".($row[16]!=$row[43] ? \' title=\"\'.$row[43].\'\"\' : \'\').\">\".(is_null($row[16]) || $row[16]==\'\'? \'&nbsp;\' : $row[16]).\"</td>\n                <td style=\\\"background-color:\".($color==$color_insert ? $color_insert : ($row[17]==$row[44] ? $color : $color_diff)).\";\\\" align=left\".($row[17]!=$row[44] ? \' title=\"\'.$row[44].\'\"\' : \'\').\">\".(is_null($row[17]) || $row[17]==\'\'? \'&nbsp;\' : $row[17]).\"</td>\n                <td style=\\\"background-color:\".($color==$color_insert ? $color_insert : ($row[18]==$row[45] ? $color : $color_diff)).\";\\\" align=left\".($row[18]!=$row[45] ? \' title=\"\'.$row[45].\'\"\' : \'\').\">\".(is_null($row[18]) || $row[18]==\'\'? \'&nbsp;\' : $row[18]).\"</td>\n                <td style=\\\"background-color:\".($color==$color_insert ? $color_insert : ($row[19]==$row[46] ? $color : $color_diff)).\";\\\" align=left\".($row[19]!=$row[46] ? \' title=\"\'.$row[46].\'\"\' : \'\').\">\".(is_null($row[19]) || $row[19]==\'\'? \'&nbsp;\' : $row[19]).\"</td>\n                <td style=\\\"background-color:\".($color==$color_insert ? $color_insert : ($row[20]==$row[47] ? $color : $color_diff)).\";\\\" align=left\".($row[20]!=$row[47] ? \' title=\"\'.$row[47].\'\"\' : \'\').\">\".(is_null($row[20]) || $row[20]==\'\'? \'&nbsp;\' : $row[20]).\"</td>\n                <td style=\\\"background-color:\".($color==$color_insert ? $color_insert : ($row[21]==$row[48] ? $color : $color_diff)).\";\\\" align=left\".($row[21]!=$row[48] ? \' title=\"\'.$row[48].\'\"\' : \'\').\">\".(is_null($row[21]) || $row[21]==\'\'? \'&nbsp;\' : $row[21]).\"</td>\n                <td style=\\\"background-color:\".($color==$color_insert ? $color_insert : ($row[22]==$row[49] ? $color : $color_diff)).\";\\\" align=left\".($row[22]!=$row[49] ? \' title=\"\'.$row[49].\'\"\' : \'\').\">\".(is_null($row[22]) || $row[22]==\'\'? \'&nbsp;\' : $row[22]).\"</td>\n                <td style=\\\"background-color:\".($color==$color_insert ? $color_insert : ($row[23]==$row[50] ? $color : $color_diff)).\";\\\" align=left\".($row[23]!=$row[50] ? \' title=\"\'.$row[50].\'\"\' : \'\').\">\".(is_null($row[23]) || $row[23]==\'\'? \'&nbsp;\' : $row[23]).\"</td>\n                <td style=\\\"background-color:\".($color==$color_insert ? $color_insert : ($row[24]==$row[51] ? $color : $color_diff)).\";\\\" align=left\".($row[24]!=$row[51] ? \' title=\"\'.$row[51].\'\"\' : \'\').\">\".(is_null($row[24]) || $row[24]==\'\'? \'&nbsp;\' : $row[24]).\"</td>\n                <td style=\\\"background-color:\".($color==$color_insert ? $color_insert : ($row[25]==$row[52] ? $color : $color_diff)).\";\\\" align=left\".($row[25]!=$row[52] ? \' title=\"\'.$row[52].\'\"\' : \'\').\">\".(is_null($row[25]) || $row[25]==\'\'? \'&nbsp;\' : $row[25]).\"</td>\n                <td style=\\\"background-color:\".($color==$color_insert ? $color_insert : ($row[26]==$row[54] ? $color : $color_diff)).\";\\\" align=left\".($row[26]!=$row[54] ? \' title=\"\'.$row[54].\'\"\' : \'\').\">\".(is_null($row[26]) || $row[26]==\'\'? \'&nbsp;\' : $row[26]).\"</td>\n                <td style=\\\"background-color:\".($color==$color_insert ? $color_insert : ($row[57]==$row[58] ? $color : $color_diff)).\";\\\" align=left\".($row[57]!=$row[58] ? \' title=\"\'.$row[58].\'\"\' : \'\').\">\".(is_null($row[57]) || $row[57]==\'\'? \'&nbsp;\' : $row[57]).\"</td>\n            </tr>\");\n        $j++;    \n        }\n    print (\"\n            </table>\");\n}\nelse{\n    print \"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν δεδομένα...</span>\";\n}\nprint \"\n    </body>\n</html>\";\n','','0','2015-02-14 12:29:24','globeadmin','2021-09-04 23:29:27','globeadmin','2022-02-11 21:22:57','globeadmin','0'),('54df23b8e8dd0cf','student_class_read','Διαβάζει την κατανομή των μαθητών σε τμήματα από αρχείο excel του myschool','manager','require_once(\'Classes/PHPExcel.php\');\n\nprint \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n        \n    <STYLE TYPE=\\\"text/css\\\">\n        .sisTable TD{\n            font-size:7pt;\n        }\n    </STYLE>\n    </head>\n    <body onload=\\\"adjustIframeHeight()\\\">\";\n\n//fetch the uploaded file information\n$S = stripslashes(\'#FILES#\');\n$J = json_decode($S);\n\n$name = $J[0]->{\'name\'};\n$type = $J[0]->{\'type\'};\n$error = $J[0]->{\'error\'};\n$size  = $J[0]->{\'size\'};\n\n$uploaddir= sys_get_temp_dir();\n$uploadfile = $uploaddir .\'/\'.$name;\n\n$inputFileName = $uploadfile;\n$objPHPExcel = PHPExcel_IOFactory::load($inputFileName);\n$objWorksheet = $objPHPExcel->getActiveSheet();\n$highestRow = $objWorksheet->getHighestRow();\n\n$sql=\"delete from student_class_in where 1\";\nnuRunQuery($sql);\n\nfor ($row = 1; $row <= $highestRow; ++$row) { \n    $cellValueA = $objWorksheet->getCell(\'A\'.$row)\n                                    ->getFormattedValue();\n    $cellValueB = $objWorksheet->getCell(\'B\'.$row)\n                                    ->getFormattedValue();\n    $cellValueD = $objWorksheet->getCell(\'D\'.$row)\n                                    ->getFormattedValue();\n    $cellValueF = $objWorksheet->getCell(\'F\'.$row)\n                                    ->getFormattedValue();\n    $cellValueG = $objWorksheet->getCell(\'G\'.$row)\n                                    ->getFormattedValue();\n    \n    if (!is_null($cellValueA) && !is_null($cellValueB) && $cellValueA!=\'\' && $cellValueB!=\'\' && is_numeric($cellValueA)) {\n            \n        $sql=\"insert into student_class_in (\n                        id,\n                        student_id,\n                        class_id,\n                        registration_number,\n                        class,\n                        surname,\n                        name,\n                        fathers_name,\n                        allredy_exists) \n                    values (\n                        NULL,\n                        NULL,\n                        NULL,\'\".\n                        $cellValueA.\"\',\'\".\n                        $cellValueB.\"\',\'\".\n                        $cellValueD.\"\',\'\".\n                        $cellValueF.\"\',\'\".\n                        $cellValueG.\"\',0)\";\n        nuRunQuery($sql);\n    }\n}\n\nunlink($uploadfile);\n\n$sql=\"update student_class_in \ninner join student on student_class_in.registration_number=student.registration_number\nset student_class_in.student_id=student.id\";\nnuRunQuery($sql);\n\n$sql=\"update student_class_in \ninner join class on student_class_in.class=class.short_name\nset student_class_in.class_id=class.id\";\nnuRunQuery($sql);\n\n$sql=\"DELETE s1 \nFROM student_class_in s1, student_class_in s2 \nWHERE s1.id > s2.id and\n    s1.registration_number=s2.registration_number and\n    s1.class=s2.class\";\nnuRunQuery($sql);\n\n$sql=\"update student_class_in \n        inner join student_class on \n                    student_class_in.student_id=student_class.student_id and\n                    student_class_in.class_id=student_class.class_id\n        set student_class_in.allredy_exists=1\";\nnuRunQuery($sql);\n\n$sql=\"select * from student_class_in order by class,surname,name,fathers_name\";\n$retval=nuRunQuery($sql);\n\nif($retval && db_num_rows($retval)>0) {\n\n    print (\"\n        <table cellspacing=0 CLASS=\\\"sisTable\\\" align=center>\n            <tr height=40>\n                <th width=60 align=center>A/A</th>\n                <th width=100 align=center>Τμήμα</th>\n                <th width=60 align=center>A.M.</th> \n                <th width=250 align=center>Επώνυμο</th>\n                <th width=200 align=center>Όνομα</th>\n                <th width=200 align=center>Όνομα Πατρός</th>\n            </tr>\");  \n            \n    $j=1;\n    \n    $color_error=\'OrangeRed\';\n    $color_exists=\'LightSteelBlue\';\n    $color_insert=\'LightGreen\';\n    \n    $color_class=\'LightGreen\';\n    \n    while($row = db_fetch_row($retval)) {\n    \n        if(is_null($row[1])){\n            $color=$color_error;\n        } else if ($row[8]==1){\n            $color=$color_exists;\n        } else {\n            $color=$color_insert;\n        }\n        \n        $new_class = (is_null($row[2]) ? true : false);\n        $color_class = (is_null($row[2]) ? \'Green\' : $color);\n    \n        print (\"\n            <tr style=\\\"background-color:$color;\\\" height=25>\n                <td align=center>\".$j.\"</td>\n                <td align=center style=\\\"background-color:$color_class;\\\"\".($new_class ? \" title=\\\"Νέο Τμήμα\\\"\" : \"\").\">\".$row[4].\"</td>\n                <td align=left>\".$row[3].\"</td>\n                <td align=left>\".$row[5].\"</td>\n                <td align=left>\".(is_null($row[6]) || $row[6]==\'\'? \'&nbsp;\' : $row[6]).\"</td>\n                <td align=left>\".(is_null($row[7]) || $row[7]==\'\'? \'&nbsp;\' : $row[7]).\"</td>\n            </tr>\");\n        $j++;    \n    }\n    print (\"\n        </table>\");\n}\nelse{\n    print \"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν δεδομένα...</span>\";\n}\nprint \"\n    </body>\n</html>\";\n','','0','2015-02-14 12:30:16','globeadmin','2019-08-05 23:23:37','globeadmin','2022-02-11 21:32:50','globeadmin','0'),('56e0783347a0891','create_teaching_book','Δημιουργεί το ημερολόγιο διδασκαλιών ενός μαθήματος σε ένα τμήμα','sisyphos','function translateMonthName($month) { \nreturn strtr($month, array(\n    \'Jan\' => \'Ιανουάριος\',\n    \'Feb\' => \'Φεβρουάριος\',\n    \'Mar\' => \'Μάρτιος\',\n    \'Apr\' => \'Απρίλιος\', \n    \'May\' => \'Μάιος\', \n    \'Jun\' => \'Ιούνιος\', \n    \'Jul\' => \'Ιούλιος\',\n    \'Aug\' => \'Αύγουστος\',\n    \'Sep\' => \'Σεπτέμβριος\',\n    \'Oct\' => \'Οκτώβριος\',\n    \'Nov\' => \'Νοέμβριος\',\n    \'Dec\' => \'Δεκέμβριος\'\n    )); \n}\n\n$no_lesson_color    = \"#eeeeaa\";\n$month_name         =\"\";\n\nprint \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">        \n        \n        <STYLE TYPE=\\\"text/css\\\">\n        \n        .myTable TH{\n            font-family:Verdana;\n            font-size:9pt;\n            border:none;\n            background-color:#FAF0E6;\n        }\n\n        .myTable, .myTable TD{\n            font-family:Verdana;\n            font-size:8pt;\n            border:none;\n            background-color:#FAF0E6;\n        }\n        \n        .sisTable TH{\n            font-size:1.2em;\n        }\n        \n\n        table.print-friendly tr td, table.print-friendly tr th {\n            page-break-inside: avoid;\n        }\n        \n        @media print{\n            #pager,\n            form,\n            .no-print{\n                display: none !important;\n                height: 0;\n            }\n            \n            .no-print, \n            .no-print *{\n                display: none !important;\n                height: 0;\n            }\n        }            \n        \n        </STYLE>\n    </head>\n\n    <body onload=\\\"adjustIframeHeight()\\\">\";\n    \n    \n$sql = \"SELECT max(timetable.start_date) \n		FROM timetable \n		WHERE (timetable.start_date <= curdate())\";\n		\n$rv = nuRunQuery($sql);\n$r = db_fetch_row($rv);\n$current_timetable_date = $r[0];\n\n\n$sql=\"  SELECT distinct\n                concat(IF(teacher.surname IS NULL,\'\',teacher.surname),IF(teacher.surname IS NULL,\'\',\' \'),IF(teacher.name IS NULL,\'\',teacher.name)),\n                class.short_name, \n                concat (subject.name,IF(subject_type.short_name IS NULL,\'\',CONCAT(\' (\',subject_type.name,\')\'))),\n                teacher.id,\n                session_variables.teacher_id\n        FROM card\n        INNER JOIN  teacher             on card.teacher_id = teacher.id\n		INNER JOIN  class               on class.id         = card.class_id\n        INNER JOIN  subject             on subject.id       = card.subject_id\n        INNER JOIN  session_variables   on (session_variables.subject_id = card.subject_id and session_variables.class_id = card.class_id)\n        LEFT  JOIN  subject_type        on subject_type.id  = subject.subject_type_id\n        WHERE\n            session_variables.session_id=\'#session_id#\' and\n            card.valid_from = \'\".$current_timetable_date.\"\'\n        \";\n        \n$rv2 = nuRunQuery($sql);\n\n$teacher_names  = \"\";\n$class_name     = \"\";\n$subject_name   = \"\";\n$is_teacher_lesson = false;\n\n\nwhile($r2 = db_fetch_row($rv2)){\n    $teacher_names  = ($teacher_names == \"\" ? $r2[0] : $teacher_names.\", \".$r2[0]);\n    $class_name     = $r2[1];\n    $subject_name   = $r2[2];\n    \n    if($r2[3]==$r2[4]){\n        $is_teacher_lesson = true;    \n    }\n}\n            \n$sql = \"    SELECT \n	            registered_card.id,\n	            registered_card.card_date,\n	            day.name,\n	            registered_card.comments,\n	            registered_card.no_lesson,\n	            period.name\n            FROM registered_card\n            INNER JOIN card 				on card.id          = registered_card.card_id\n            INNER JOIN day                  on card.day_id      = day.id\n            INNER JOIN period               on card.period_id   = period.id\n            INNER JOIN session_variables 	on (session_variables.subject_id = card.subject_id and session_variables.class_id = card.class_id)\n            WHERE \n	            session_variables.session_id=\'#session_id#\' and \n	            registered_card.prime=1\n            ORDER BY registered_card.card_date,period.id\";\n$retval = nuRunQuery($sql);\nif($retval){\n    if(db_num_rows($retval)>0){\n\n        print (\"\n        <table width=100% cellspacing=0 CLASS=\\\"sisTable print-friendly\\\" align=center>\n            <tr style=\\\"background-color:#FAF0E6;\\\">\n                <th style=\\\"background-color:#FAF0E6;\\\" colspan=\".(\'#nu_user_group#\'!=\'Students\' && \'#nu_user_group#\'!=\'Parents\' && $is_teacher_lesson ? \"5\" : \"4\").\">\");\n        print (\"\n                    <table width=100% cellspacing=0 CLASS=\\\"myTable\\\" align=center>\");\n        print(\"\n                        <tr height=30>\n                            <th align=center>\n                                Ημερολόγιο Διδασκαλιών\n                            </th>\n                        </tr>\");\n        print(\"\n                        <tr height=30>\n                            <th align=center>\n                                \".$class_name.\" - \".$subject_name.\"\n                            </th>\n                        </tr>\");\n        print(\"\n                        <tr height=30>\n                            <th align=center>\n                                Διδάσκοντες : \".$teacher_names.\"\n                            </th>\n                        </tr>\");\n        \n        print (\"\n                    </table>\n                </th>\n            </tr>\");\n        \n        while($row = db_fetch_row($retval)) {\n            \n            $dt = new DateTime($row[1]);\n            $m  = $dt->format(\"M\");\n            if ($m != $month_name){     // εκτύπωση του μήνα\n            \n                $month_name = $m;\n\n                print(\"\n            <tr height=30>\n                <th align=center colspan=\".(\'#nu_user_group#\'!=\'Students\'&& \'#nu_user_group#\'!=\'Parents\'  && $is_teacher_lesson ? \"5\" : \"4\").\">\n                    \".translateMonthName($month_name).\" - \".$dt->format(\"Y\").\"\n                </th>\n            </tr>\");\n            } \n            print(\"\n            <tr\".($row[4]==1 ? \" style=\\\"background-color:$no_lesson_color;\\\"\" : \"\").\" height=30>            \n                <td align=center width=70>\n                    \".$dt->format(\"d-m-Y\").\"\n                </td>\n                 \n                <td align=center width=70>\n                    \".$row[2].\"\n                </td>\n                \n                <td align=center width=70>\n                    \".$row[5].\"\n                </td>\n                 \n                <td id=\\\"td\".$row[0].\"\\\">\n                    \".($row[4]==1 ? ((is_null($row[3]) || $row[3]==\'\') ? \"<b><i>Κενό - Δεν έγινε το μάθημα</i></b>\" : \"<b><i>Κενό - \".$row[3].\"</i></b>\") : $row[3]).\"\n                </td>\n                \");\n                 \n                if(\'#nu_user_group#\'!=\'Students\'&& \'#nu_user_group#\'!=\'Parents\'  && $is_teacher_lesson){\n                    if($row[4]==1){\n                        print(\"<td align=center width=40>&nbsp;</td>\n                        \");    \n                    } else {\n                        print(\"<td align=center width=40 onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\" onclick=\\\"parent.nuOpenFormInFrame(\'56dd9f180d22b31\',\'\".$row[0].\"\')\\\">\n                    \".($row[4]==1 ? \"&nbsp;\" : \"<img id=\\\"img_\".$row[0].\"\\\" class=\\\"no-print\\\" src=\\\"images/\".((is_null($row[3]) || $row[3]==\'\') ? \"edit.png\" : \"edit_red.png\").\"\\\" width=16 height=16 title=\\\"Επεξεργασία\\\">\").\"\n                </td>\n                \");    \n                    }\n                }\n            print(\"\n            </tr>\n            \");\n        \n        }\n        \n        /*print (\"\n            \n            <table border=0  width=100% cellspacing=0 CLASS=\\\"mytable\\\" align=center>\n                <tr width=100%>\n                    <td colspan=2 width=100%>\n                        <br>Κλείνεται σήμερα \".date(\"d-m-Y\").\" το παρόν βιβλίο ύλης σύμφωνα με τις κείμενες διατάξεις. Ως εξεταστέα ύλη ορίζεται η διδαχθείσα.<br><br>\n                    </td>\n                </tr>\n                <tr width=100%>\n                    <td width=50% align=center valign=top>\n                    Ο Διευθυντής<br>\n                    \n                    </td>\n                    <td width=50% align=center valign=top>\n                    Οι Καθηγητές<br>\n                            \n                    </td>\n                </tr>                \n            </table>\n        \");*/\n        \n        print (\"\n        </table>\");\n        \n    } else {\n        print \"<span CLASS=\\\"msg\\\">Δε βρέθηκαν διδασκαλίες. Παρακαλώ επιλέξτε Τμήμα-Μάθημα!</span>\";\n    }\n} else {\n    print \"<span CLASS=\\\"msgError\\\">Παρουσιάστηκε σφάλμα κατά την ανάκτηση των δεδομένων...</span>\";    \n}                        \nprint \"\n    </body>\n</html>\";','','1','2016-03-09 21:23:31','globeadmin','2021-04-04 15:43:23','globeadmin','2022-09-23 00:41:40','globeadmin','1'),('5b38fdbabafa92b','iframe_template','Πρότυπο για iframe','globeadmin','print \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n        \n        <STYLE TYPE=\\\"text/css\\\">\n            .sisTable TH{\n                font-size:1.1em;\n            }\n            \n            .sisTable tr:nth-child(even){\n	            background-color: LightSteelBlue;\n            }\n        </STYLE>\n    </head>\n    <body onload=\\\"adjustIframeHeight()\\\">\";\n\n\nprint (\"\n        <table cellspacing=0 CLASS=\\\"sisTable\\\" align=center>\n            <tr height=50>\n                <th width=350 align=center></th>\n            </tr>\");\nprint (\"            \n            <tr height=30>            \n                <td style=\\\"background-color:red;\\\" align=right></td>\");\n\nprint (\"\n            </tr>\");\n\nprint (\"\n        </table>\");\n\nprint \"\n    </body>\n</html>\";\n','','0','2018-07-01 19:13:46','globeadmin','2018-07-17 15:17:35','globeadmin','2018-07-17 21:40:28','globeadmin','0'),('54df242190f8a42','timetable_read','Διαβάζει το ωρολόγιο πρόγραμμα από αρχείο XML του ASC Timetables','manager','print \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n    </head>\n\n    <body onload=\\\"adjustIframeHeight()\\\">\n        <table cellspacing=0 style=\\\"border:none;background-color:lightYellow;\\\" width:100% height=100%>\n            <tr>\n                <td>\n                    <br>\";\n\n//fetch the uploaded file information\n$S = stripslashes(\'#FILES#\');\n$J = json_decode($S);\n\n$name = $J[0]->{\'name\'};\n$type = $J[0]->{\'type\'};\n$error = $J[0]->{\'error\'};\n$size  = $J[0]->{\'size\'};\n\n$uploaddir= sys_get_temp_dir();\n$uploadfile = $uploaddir .\'/\'.$name;\n\n$inputFileName = $uploadfile;\n\n$contents = file_get_contents($inputFileName);\n\nif ($contents === false) {\n    print \"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν δεδομένα...</span>\";\n} else{\n    \n    $pos=strpos($contents, \'<?\');\n    \n    if($pos!==false){\n     $contents=substr($contents, strpos($contents, \"?>\")+3);\n    } \n    \n    $xml = simplexml_load_string($contents);\n\n    if ($xml === false) {\n        print \"<span CLASS=\\\"msgError\\\">Αδυναμία φόρτωσης XML αρχείου...\\n\";\n        foreach(libxml_get_errors() as $error) {\n            echo \"\\t\", $error->message;\n        }\n        print \"</span>\";\n    } else{\n//***************************************** teacher ********************************************************    \n        $sql=\"delete from teacher_in where 1\";\n        nuRunQuery($sql);\n        \n        $columns = explode(\",\", $xml->teachers[\"columns\"]);\n        \n        foreach ($xml->teachers->teacher as $t) {\n            $val=\'\';\n            foreach ($columns as $c) {\n                if ($val==\'\'){\n                    $val=\"\'\".$t[0][$c].\"\'\";\n                } else{\n                    $val=$val.\",\".\"\'\".$t[0][$c].\"\'\";\n                }\n            }\n        \n            $sql=\"insert into teacher_in (\".implode(\",\",$columns).\") values (\".$val.\")\";\n            nuRunQuery($sql);           \n        }\n//**************************************** class *********************************************************    \n        $sql=\"delete from class_in where 1\";\n        nuRunQuery($sql);\n        \n        $columns = explode(\",\", $xml->classes[\"columns\"]);\n        \n        foreach ($xml->classes->class as $t) {\n            $val=\'\';\n            foreach ($columns as $c) {\n                if ($val==\'\'){\n                    $val=\"\'\".$t[0][$c].\"\'\";\n                } else{\n                    $val=$val.\",\".\"\'\".$t[0][$c].\"\'\";\n                }\n            }\n            \n            $sql=\"insert into class_in (\".implode(\",\",$columns).\") values (\".$val.\")\";\n            nuRunQuery($sql);\n        }\n//******************************************* subject ******************************************************    \n        $sql=\"delete from subject_in where 1\";\n        nuRunQuery($sql);\n        \n        $columns = explode(\",\", $xml->subjects[\"columns\"]);\n        foreach ($xml->subjects->subject as $t) {\n            $val=\'\';\n            foreach ($columns as $c) {\n                if ($val==\'\'){\n                    $val=\"\'\".$t[0][$c].\"\'\";\n                } else{\n                    $val=$val.\",\".\"\'\".$t[0][$c].\"\'\";\n                }\n            }\n                        \n            $sql=\"insert into subject_in (\".implode(\",\",$columns).\") values (\".$val.\")\";\n            nuRunQuery($sql);\n        }\n//****************************************** classroom *******************************************************    \n        $sql=\"delete from classroom_in where 1\";\n        nuRunQuery($sql);\n        \n        $columns = explode(\",\", $xml->classrooms[\"columns\"]);\n        \n        foreach ($xml->classrooms->classroom as $t) {\n            $val=\'\';\n            foreach ($columns as $c) {\n                if ($val==\'\'){\n                    $val=\"\'\".$t[0][$c].\"\'\";\n                } else{\n                    $val=$val.\",\".\"\'\".$t[0][$c].\"\'\";\n                }\n            }\n\n            $sql=\"insert into classroom_in (\".implode(\",\",$columns).\") values (\".$val.\")\";\n            nuRunQuery($sql);\n        }\n//****************************************** group *******************************************************     \n \n        $sql=\"delete from group_in where 1\";\n        nuRunQuery($sql);\n        \n        $columns = explode(\",\", $xml->groups[\"columns\"]);\n        \n        foreach ($xml->groups->group as $t) {\n            $val=\'\';\n            foreach ($columns as $c) {\n                if ($val==\'\'){\n                    $val=\"\'\".$t[0][$c].\"\'\";\n                } else{\n                    $val=$val.\",\".\"\'\".$t[0][$c].\"\'\";\n                }\n            }\n\n            $sql=\"insert into group_in (\".implode(\",\",$columns).\") values (\".$val.\")\";\n            nuRunQuery($sql);\n        }\n//******************************************* card ******************************************************    \n        $sql=\"delete from card_in where 1\";\n        nuRunQuery($sql);\n        $sql=\"ALTER TABLE card_in AUTO_INCREMENT = 1\";\n        nuRunQuery($sql);\n        \n        $columns = explode(\",\", $xml->cards[\"columns\"]);\n        \n        foreach ($xml->cards->card as $t) {\n            $val=\'\';\n            foreach ($columns as $c) {\n                if ($val==\'\'){\n                    $val=\"\'\".$t[0][$c].\"\'\";\n                } else{\n                    $val=$val.\",\".\"\'\".$t[0][$c].\"\'\";\n                }\n            }\n            \n            $sql=\"insert into card_in (\".implode(\",\",$columns).\") values (\".$val.\")\";\n            nuRunQuery($sql);\n        }\n//*************************************** Split Rows **********************************************************\n        \n        $sql=\"SELECT\n                new_id,	\n                day,	\n                period,	\n                classids,	\n                groupids,	\n                subjectid,	\n                teacherids,	\n                classroomid \n            from card_in \n            where LOCATE(\',\',teacherids)>0\";\n        \n        $retval=nuRunQuery($sql);\n        \n        if($retval ){\n        \n            while($row = db_fetch_row($retval)){\n                $teachers=explode(\",\",$row[6]);\n                foreach ($teachers as $t) {\n                    $sql=\"insert into card_in\n                    values (NULL,\'\".$row[1].\"\',\'\".$row[2].\"\',\'\".$row[3].\"\',\'\".$row[4].\"\',\'\".$row[5].\"\',\'\".$t.\"\',\'\".$row[7].\"\',NULL,NULL,NULL,NULL)\";\n                    nuRunQuery($sql);\n                }\n                $sql=\"delete from card_in where new_id=\".$row[0];\n                nuRunQuery($sql);\n            }\n        }\n\n        $sql=\"SELECT\n                new_id,	\n                day,	\n                period,	\n                classids,	\n                groupids,	\n                subjectid,	\n                teacherids,	\n                classroomid \n            from card_in \n            where LOCATE(\',\',groupids)>0\";\n        \n        $retval=nuRunQuery($sql);\n        \n        if($retval ){\n        \n            while($row = db_fetch_row($retval)){\n                $groups=explode(\",\",$row[4]);\n                foreach ($groups as $g) {\n                    $sql=\"insert into card_in values (NULL,\'\".$row[1].\"\',\'\".$row[2].\"\',\'\".$row[3].\"\',\'\".$g.\"\',\'\".$row[5].\"\',\'\".$row[6].\"\',\'\".$row[7].\"\',NULL,NULL,NULL,NULL)\";\n                    nuRunQuery($sql);\n                }\n                $sql=\"delete from card_in where new_id=\".$row[0];\n                nuRunQuery($sql);\n            }\n        }\n//*************************************************************************************************\n        $sql=\"UPDATE group_in \n            INNER JOIN class_in ON group_in.classid = class_in.id\n            SET group_in.name = class_in.name \n            WHERE group_in.entireclass=1\";\n        nuRunQuery($sql);\n        \n        $sql=\"UPDATE classroom_in \n            INNER JOIN classroom ON classroom.short_name = classroom_in.short\n            SET classroom_in.new_id = classroom.id\";\n        nuRunQuery($sql);\n        \n        $sql=\"UPDATE group_in \n            INNER JOIN class ON class.short_name = group_in.name\n            SET group_in.new_id = class.id\";\n        nuRunQuery($sql);\n\n        $sql=\"UPDATE teacher_in \n            INNER JOIN teacher ON teacher.short_name = teacher_in.short\n            SET teacher_in.new_id = teacher.id\";\n        nuRunQuery($sql);\n\n        $sql=\"UPDATE subject_in \n            INNER JOIN subject ON subject.id = subject_in.id\n            SET subject_in.new_id = subject.id\n            WHERE subject.id<>0\n            \";\n        nuRunQuery($sql);\n        \n        $sql=\"UPDATE subject_in \n            INNER JOIN subject ON subject.short_name = subject_in.short\n            SET subject_in.new_id = subject.id\n            where subject_in.new_id is null\";\n        nuRunQuery($sql);\n        \n        $color_error=\'OrangeRed\';\n        $color_exists=\'LightSteelBlue\';\n        $color_insert=\'LightGreen\';        \n        \n//****************************************Show Class (table group_in)****************************************     \n        $sql=\"select distinct new_id,name from group_in order by name\";\n        $retval=nuRunQuery($sql);\n        \n        if($retval && db_num_rows($retval)>0) {\n\n            print (\"\n                    <table align=center cellspacing=0 CLASS=\\\"sisTable\\\">\n                        <tr height=40>\n                            <th colspan=2 align=center>Τμήματα</th>\n                        </tr>\n                        <tr height=40>\n                            <th width=60 align=center>A/A</th>\n                            <th width=250 align=center>Τμήμα</th>\n                        </tr>\");  \n            \n            $j=1;\n    \n            while($row = db_fetch_row($retval)) {\n            \n                $color= (is_null($row[0]) ? (is_null($row[1]) || $row[1]==\'\' ? $color_error : $color_insert) : $color_exists);\n    \n                print (\"\n                        <tr style=\\\"background-color:$color;\\\" height=25>\n                            <td align=center>\".$j.\"</td>\n                            <td align=center>\".(is_null($row[1]) || $row[1]==\'\'? \'&nbsp;\' : $row[1]).\"</td>\n                        </tr>\");\n                $j++;    \n            }\n            print (\"\n                    </table>\n                    <br>\");\n        }        \n//****************************************Show Teachers*********************************************************        \n        $sql=\"select new_id,name,short from teacher_in order by name,short\";\n        $retval=nuRunQuery($sql);\n        \n        if($retval && db_num_rows($retval)>0) {\n\n            print (\"\n                    <table align=center cellspacing=0 CLASS=\\\"sisTable\\\">\n                        <tr height=40>\n                            <th colspan=3 align=center>Καθηγητές</th>\n                        </tr>\n                        <tr height=40>\n                            <th width=60 align=center>A/A</th>\n                            <th width=300 align=center>Όνοματεπώνυμο</th>\n                            <th width=200 align=center>Συντομογραφία</th>\n                        </tr>\"); \n            \n            $j=1;\n    \n            while($row = db_fetch_row($retval)) {\n    \n                $color= (is_null($row[0]) ? (is_null($row[2]) || $row[2]==\'\' ? $color_error : $color_insert) : $color_exists);\n                \n                print (\"\n                        <tr style=\\\"background-color:$color;\\\" height=25>\n                            <td align=center>\".$j.\"</td>\n                            <td align=left>\".(is_null($row[1]) || $row[1]==\'\'? \'&nbsp;\' : $row[1]).\"</td>\n                            <td align=left>\".(is_null($row[2]) || $row[2]==\'\'? \'&nbsp;\' : $row[2]).\"</td>\n                        </tr>\");\n                $j++;    \n            }\n            print (\"\n                    </table>\n                    <br>\");\n        }\n\n//****************************************Show Classrooms****************************************************   \n        $sql=\"select new_id,name,short from classroom_in order by name,short\";\n        $retval=nuRunQuery($sql);\n        \n        if($retval && db_num_rows($retval)>0) {\n                \n            print (\"\n                    <table align=center cellspacing=0 CLASS=\\\"sisTable\\\">\n                        <tr height=40>\n                            <th colspan=3 align=center>Αίθουσες</th>\n                        </tr>\n                        <tr height=40>\n                            <th width=60 align=center>A/A</th>\n                            <th width=300 align=center>Όνομα</th>\n                            <th width=200 align=center>Συντομογραφία</th>\n                        </tr>\"); \n            $j=1;\n    \n            while($row = db_fetch_row($retval)) {\n            \n                $color= (is_null($row[0]) ? (is_null($row[2]) || $row[2]==\'\' ? $color_error : $color_insert) : $color_exists);\n    \n                print (\"\n                        <tr style=\\\"background-color:$color;\\\" height=25>\n                            <td align=center>\".$j.\"</td>\n                            <td align=left>\".(is_null($row[1]) || $row[1]==\'\'? \'&nbsp;\' : $row[1]).\"</td>\n                            <td align=left>\".(is_null($row[2]) || $row[2]==\'\'? \'&nbsp;\' : $row[2]).\"</td>\n                        </tr>\");\n                $j++;    \n            }\n            print (\"\n                    </table>\n                    <br>\");\n        }\n//****************************************Show Subjects******************************************************   \n        $sql=\"select new_id,name,short from subject_in order by name,short\";\n        $retval=nuRunQuery($sql);\n        \n        if($retval && db_num_rows($retval)>0) {\n\n            print (\"\n                    <table align=center cellspacing=0 CLASS=\\\"sisTable\\\">\n                        <tr height=40>\n                            <th colspan=3 align=center>Μαθήματα</th>\n                        </tr>\n                        <tr height=40>\n                            <th width=60 align=center>A/A</th>\n                            <th width=300 align=center>Όνομα</th>\n                            <th width=200 align=center>Συντομογραφία</th>\n                        </tr>\");            \n            $j=1;\n    \n            while($row = db_fetch_row($retval)) {\n                \n                $color= (is_null($row[0]) ? (is_null($row[2]) || $row[2]==\'\' ? $color_error : $color_insert) : $color_exists);\n    \n                print (\"\n                        <tr style=\\\"background-color:$color;\\\" height=25>\n                            <td align=center>\".$j.\"</td>\n                            <td align=left>\".(is_null($row[1]) || $row[1]==\'\'? \'&nbsp;\' : $row[1]).\"</td>\n                            <td align=left>\".(is_null($row[2]) || $row[2]==\'\'? \'&nbsp;\' : $row[2]).\"</td>\n                        </tr>\");\n                $j++;    \n            }\n            print (\"\n                    </table>\n                    <br>\");\n        }\n//****************************************Show Cards********************************************************* \n\n        $sql=\"CREATE TEMPORARY TABLE #TABLE_ID# DEFAULT CHARACTER SET=utf8\n            SELECT distinct \n                day,	\n                period,	\n                groupids,	\n                subjectid,	\n                teacherids,	\n                classroomid,\n                CAST(\'\' as CHAR(255)) day_short_name,\n                CAST(\'\' as CHAR(255)) period_short_name,\n                CAST(\'\' as CHAR(255)) group_name,\n                CAST(\'\' as CHAR(255)) subject_short,\n                CAST(\'\' as CHAR(255)) teacher_short,\n                CAST(\'\' as CHAR(255)) classroom_short\n            FROM card_in\";\n            nuRunQuery($sql);\n            \n        $sql=\"update #TABLE_ID# \n                inner join day on #TABLE_ID#.day=day.id\n            set #TABLE_ID#.day_short_name=day.name\";\n        nuRunQuery($sql);\n        \n        $sql=\"update #TABLE_ID# \n                inner join period on #TABLE_ID#.period=period.id\n            set #TABLE_ID#.period_short_name=period.short_name\";\n        nuRunQuery($sql);\n        \n        $sql=\"update #TABLE_ID# \n                inner join group_in on #TABLE_ID#.groupids=group_in.id\n            set #TABLE_ID#.group_name=group_in.name\";\n        nuRunQuery($sql);\n        \n        $sql=\"update #TABLE_ID# \n                inner join subject_in on #TABLE_ID#.subjectid=subject_in.id\n            set #TABLE_ID#.subject_short=subject_in.name\";\n        nuRunQuery($sql);\n        \n        $sql=\"update #TABLE_ID# \n                inner join teacher_in on #TABLE_ID#.teacherids=teacher_in.id\n            set #TABLE_ID#.teacher_short=teacher_in.short\";\n        nuRunQuery($sql);\n        \n        $sql=\"update #TABLE_ID# \n                inner join classroom_in on #TABLE_ID#.classroomid=classroom_in.id\n            set #TABLE_ID#.classroom_short=classroom_in.short\";\n        nuRunQuery($sql);\n\n        $sql=\"select distinct\n                group_name,\n                day_short_name,\n                period_short_name,\n                subject_short,\n                teacher_short,\n                classroom_short \n            from #TABLE_ID# \n            order by group_name,day,period,subject_short,teacher_short\";\n        $retval=nuRunQuery($sql);\n        \n        if($retval && db_num_rows($retval)>0) {\n            print (\"\n                    <table align=center cellspacing=0 CLASS=\\\"sisTable\\\">\n                        <tr height=40>\n                            <th colspan=7 align=center>Διδασκαλίες</th>\n                        </tr>\n                        <tr height=40>\n                            <th width=60 align=center>A/A</th>\n                            <th width=60 align=center>Τμήμα</th>\n                            <th width=100 align=center>Ημέρα</th>\n                            <th width=50 align=center>Ώρα</th>\n                            <th width=300 align=center>Μάθημα</th>\n                            <th width=210 align=center>Καθηγητής</th>\n                            <th width=80 align=center>Αίθουσα</th>\n                        </tr>\");              \n            $j=1;\n            \n            while($row = db_fetch_row($retval)) {\n    \n                print (\"\n                        <tr style=\\\"background-color:$color_insert;\\\" height=25>\n                            <td align=center>\".$j.\"</td>\n                            <td align=center>\".(is_null($row[0]) || $row[0]==\'\'? \'&nbsp;\' : $row[0]).\"</td>\n                            <td align=left>\".(is_null($row[1]) || $row[1]==\'\'? \'&nbsp;\' : $row[1]).\"</td>\n                            <td align=center>\".(is_null($row[2]) || $row[2]==\'\'? \'&nbsp;\' : $row[2]).\"</td>\n                            <td align=left>\".(is_null($row[3]) || $row[3]==\'\'? \'&nbsp;\' : $row[3]).\"</td>\n                            <td align=left>\".(is_null($row[4]) || $row[4]==\'\'? \'&nbsp;\' : $row[4]).\"</td>\n                            <td align=center>\".(is_null($row[5]) || $row[5]==\'\'? \'&nbsp;\' : $row[5]).\"</td>\n                        </tr>\");\n                $j++;    \n            }\n            print (\"\n                    </table>\n                    <br>\");\n        }        \n    }     \n}\n\n//unlink($uploadfile);\nprint \"\n                </td>\n            </tr>\n        </table>\n    </body>\n</html>\";\n','','0','2015-02-14 12:32:01','globeadmin','2018-07-15 21:49:36','globeadmin','2018-07-15 21:49:36','globeadmin','0'),('54df249e87338f1','student_insert','Εισάγει τους μαθητές που έχουν διαβαστεί από το αρχείο excel','manager','print \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">        \n\n        <STYLE TYPE=\\\"text/css\\\">\n            .sisTable TD{\n                font-size:9pt;\n            }\n            .sisTable TH{\n                font-size:9pt;\n            }\n            .sisTable tr:nth-child(even){\n	            background-color: LightSteelBlue;\n            }\n        </STYLE>\n    </head>\n    <body onload=\\\"adjustIframeHeight()\\\">\";\n\n$sql=\"UPDATE student_in \nINNER JOIN grade ON student_in.grade = grade.short_name\nSET student_in.grade = grade.id\";\nnuRunQuery($sql);\n\n$sql=\"UPDATE student_in\nSET student_in.grade = NULL\nwhere student_in.grade not in (select distinct id from grade)\";\nnuRunQuery($sql);\n\n$sql=\"select count(*) \n    from student_in \n    where student_id is NULL\";\n$r1=nuRunQuery($sql);\n\nif($r1 && db_num_rows($r1)>0) {\n    $row = db_fetch_row($r1);\n    if($row[0]>0){\n        $sql=\"insert into student\n                (id,\n                name,\n                surname,\n                fathers_name,\n                mothers_name,\n                registration_number,\n                gender,\n                birth_date,\n                phone1,\n                phone2,\n                mobile,\n                email,\n                street,\n                area,\n                zipcode,\n                city,\n                parent_name,\n                parent_surname,\n                parent_phone1,\n                parent_phone2,\n                parent_phone3,\n                parent_email,\n                parent_street,\n                parent_area,\n                parent_zipcode,\n                speciality_id,\n                grade_id,\n                teacher_id,\n                user_id,\n                parent_user_id,\n                prev_an_justified_absences,\n                prev_justified_absences,\n                has_left_school,\n                mothers_surname,\n                parent_email2) \n            select distinct \n                NULL,\n                name,\n                surname,\n                fathers_name,\n                mothers_name, \n                registration_number, \n                gender, \n                birth_date, \n                phone1,\n                phone2,\n                mobile, \n                email, \n                street, \n                area, \n                zipcode, \n                city, \n                parent_name,\n                parent_surname,\n                parent_phone1, \n                parent_phone2, \n                parent_phone3,\n                parent_email, \n                parent_street, \n                parent_area,\n                parent_zipcode,\n                NULL, \n                grade,\n                NULL,\n                NULL,\n                NULL,\n                0,\n                0,\n                0,\n                mothers_surname,\n                parent_email2\n            from student_in \n            where \n                student_id is NULL\";\n        $r2=nuRunQuery($sql);\n        if($r2){\n            print \"\n        <span CLASS=\\\"msg\\\">Εισήχθησαν \".$row[0].\" νέοι μαθητές!</span>\";\n            if(\'#user_creation#\'==\'YES\'){\n//****************************************Create accounts for new students************************************\n                $sql=\"select \n                        id,\n                        registration_number,\n                        DATE_FORMAT(birth_date,\'%d-%m-%Y\'),\n                        surname,\n                        name,\n                        email \n                    from student \n                    where registration_number in (select registration_number from student_in where student_id is NULL)\";\n\n                $retval = nuRunQuery($sql);\n\n                if($retval){\n                    print (\"\n        <br><br>\n        <table cellspacing=0 align=center CLASS=\\\"sisTable\\\">\n            <tr> \n                <th width=500 align=center>Μαθητής</th>\n                <th width=150 align=center>Όνομα Χρήστη</th>\n                <th width=150 align=center>Κωδικός</th>\n            </tr>\");\n                    \n                    while($row = db_fetch_row($retval)){\n        \n                        $sql=\"select count(*) from zzzsys_user where sus_login_name=\'\".$row[1].\"\'\"; \n        \n                        $rv = nuRunQuery($sql);\n                        $cnt=db_fetch_row($rv);\n        \n                        if($cnt[0]==0){\n                            //User Creation\n                            $id=nuID();\n                            $sql = \"insert into zzzsys_user (\n                                    zzzsys_user_id,\n                                    sus_zzzsys_user_group_id,\n                                    sus_name,\n                                    sus_email,\n                                    sus_login_name,\n                                    sus_login_password,\n                                    zzzsys_user_log_added_at,\n                                    zzzsys_user_log_added_by,\n                                    zzzsys_user_log_changed_at,\n                                    zzzsys_user_log_changed_by,\n                                    zzzsys_user_log_viewed_at,\n                                    zzzsys_user_log_viewed_by\n                                    )\n                                    values(\n                                    \'\".$id.\"\',\n                                    \'547de4c65675a29\',\n                                    \'\".$row[3].\' \'.$row[4].\"\',\n                                    \'\".$row[5].\"\',\n                                    \'\".$row[1].\"\',\n                                    md5(CONCAT(\'\".$row[1].\"\', \'\".$row[2].\"\')),\n                                    NOW(),\n                                    \'globeadmin\',\n                                    NOW(),\n                                    \'globeadmin\',\n                                    NOW(),\n                                    \'globeadmin\'\n                                    )\";\n                	        nuRunQuery($sql);\n	        \n                	        $sql=\"update student set user_id=\'\".$id.\"\' where id=\".$row[0];\n                	        nuRunQuery($sql);\n	                        \n	                        $color = ($color==$color1 ? $color2 : $color1);\n	                        \n                            print \"\n            <tr>\n                <td align=left>\".$row[3].\' \'.$row[4].\"</td>\n                <td align=center>\".$row[1].\"</td>\n                <td align=right>\".$row[2].\"</td>\n            </tr>\";\n                        \n                        } else{\n                             print \"\n            <tr style=\\\"background-color:OrangeRed;\\\">\n                <td align=left> <font color=white>Ο Λογαριασμός υπάρχει ήδη..</font></td>\n                <td align=center><font color=white>\".$row[1].\"</font></td>\n                <td align=right><font color=white>N/A</font></td>\n            </tr>\";           \n                        } \n                    }\n                \n                    print \"\n        </table>\";\n                }\n//************************************************************************************************************************\n            } else {;}\n        } else {\n            print \"<span CLASS=\\\"msgError\\\">Παρουσιάστηκε πρόβλημα κατά την εισαγωγή των νέων μαθητών!<br>Δεν εισήχθησαν νέες εγγραφές!</span>\";\n        }\n    } else {\n        print \"<span CLASS=\\\"msg\\\">Δεν υπάρχουν νέοι μαθητές προς εισαγωγή...</span>\";    \n    }\n} else{\n    print \"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν δεδομένα...</span>\";\n}\n\nif(\'#update_students#\'==\'YES\'){\n    nuRunPHP(\'student_update\');\n}\n\nprint \"\n    </body>\n</html>\";\n','','0','2015-02-14 12:34:06','globeadmin','2021-09-04 22:09:58','globeadmin','2021-09-04 23:36:13','globeadmin','0'),('54df24c6566897c','student_class_insert','Εισάγει την κατανομή των μαθητών σε τμήματα που έχουν διαβαστεί από το αρχείο excel','manager','print \"<html>\n    <head>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n    </head>\n    <body>\";\n\n//κάνω εισαγωγή τα τμήματα που δεν υπάρχουν ήδη στο σύστημα\n$sql=\"insert into class (short_name) \n	select distinct class \n    from student_class_in \n    where class not in (select short_name from class)\";\nnuRunQuery($sql);\n\n//ενημερώνω τα id των τμημάτων\n$sql=\"update student_class_in \ninner join class on student_class_in.class=class.short_name\nset student_class_in.class_id=class.id\nwhere student_class_in.class_id is null\n\";\nnuRunQuery($sql);\n\n$sql=\"select count(*) \n    from student_class_in \n    where (student_id is not NULL) and (class_id is not NULL) and allredy_exists=0\";\n$retval=nuRunQuery($sql);\n\nif($retval && db_num_rows($retval)>0) {\n    $row = db_fetch_row($retval);\n    if($row[0]>0){\n        $sql=\"insert into student_class \n            (class_id,student_id) \n            select class_id,student_id \n            from student_class_in \n            where (student_id is not NULL) and (class_id is not NULL) and allredy_exists=0\";\n        nuRunQuery($sql);\n        print \"<span CLASS=\\\"msgSuccess\\\">Εισήχθησαν \".$row[0].\" νέοι μαθητές σε τμήματα!</span>\";\n    } else {\n        print \"<span CLASS=\\\"msg\\\">Δεν υπάρχουν κατανομές προς εισαγωγή...</span>\";\n    }\n} else{\n    print \"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν δεδομένα...</span>\";\n}\n\nprint \"\n    </body>\n</html>\";\n','','0','2015-02-14 12:34:46','globeadmin','2018-07-15 23:20:13','globeadmin','2018-07-15 23:20:13','globeadmin','0'),('54df2503ce004f5','timetable_insert','Εισάγει το ωρολόγιο πρόγραμμα που έχει διαβαστεί από αρχείο XML','manager','print \"<html>\n    <head>\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n    </head>\n    <body onload=\\\"adjustIframeHeight()\\\">\";\n\n$curent_date=date(\'Y-m-d\');\n\n$sql=\"SELECT count(*) FROM registered_card WHERE card_date=\'#card_date#\'\";\n$rv1=nuRunQuery($sql);\n$r1 = db_fetch_row($rv1);\n\n$sql=\"select count(*) from timetable\";\n$rv=nuRunQuery($sql);\n$r = db_fetch_row($rv);\n\nif(\'#card_date#\'>$curent_date || (\'#card_date#\'==$curent_date && $r1[0]==0) || $r[0]==0){\n\n    $sql=\"delete from card where valid_from=\'#card_date#\'\";\n    nuRunQuery($sql);\n\n    $sql=\"delete from timetable where start_date=\'#card_date#\'\";\n    nuRunQuery($sql);\n    \n    //*********************************************classroom******************************************************\n    $sql=\"select count(*) from classroom_in where new_id is NULL\";\n    $retval=nuRunQuery($sql);\n\n    if($retval && db_num_rows($retval)>0) {\n        $row = db_fetch_row($retval);\n        if($row[0]>0){\n\n            $sql=\"insert into classroom (name,short_name) \n            select distinct name,short from classroom_in where new_id is NULL\";\n            nuRunQuery($sql);\n\n            $sql=\"UPDATE classroom_in \n            INNER JOIN classroom ON classroom.short_name = classroom_in.short\n            SET classroom_in.new_id = classroom.id\n            where new_id is NULL\";\n            nuRunQuery($sql);\n        \n            print \"<span CLASS=\\\"msgSuccess\\\">Εισήχθησαν \".$row[0].\" νέες αίθουσες!</span><br>\";\n        } else {\n            print \"<span CLASS=\\\"msg\\\">Δεν υπάρχουν νέες αίθουσες προς εισαγωγή...</span><br>\";\n        }\n    } else{\n        print \"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν δεδομένα για νέες αίθουσες!</span><br>\";\n    }\n    //*********************************************class******************************************************\n    $sql=\"select count(distinct name) from group_in where new_id is NULL\";\n    $retval=nuRunQuery($sql);\n\n    if($retval && db_num_rows($retval)>0) {\n        $row = db_fetch_row($retval);\n        if($row[0]>0){\n\n            $sql=\"insert into class (short_name) \n            select distinct name from group_in where new_id is NULL\";\n            nuRunQuery($sql);\n\n            $sql=\"UPDATE group_in \n            INNER JOIN class ON class.short_name = group_in.name\n            SET group_in.new_id = class.id\n            where new_id is NULL\";\n            nuRunQuery($sql);\n    \n            print \"<span CLASS=\\\"msgSuccess\\\">Εισήχθησαν \".$row[0].\" νέα τμήματα!</span><br>\";\n        } else {\n            print \"<span CLASS=\\\"msg\\\">Δεν υπάρχουν νέα τμήματα προς εισαγωγή...</span><br>\";\n        }\n    } else{\n        print \"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν δεδομένα για νέα τμήματα!</span><br>\";\n    }\n    //*********************************************teacher******************************************************\n    $sql=\"select count(*) from teacher_in where new_id is NULL\";\n    $retval=nuRunQuery($sql);\n\n    if($retval && db_num_rows($retval)>0) {\n        $row = db_fetch_row($retval);\n        if($row[0]>0){\n\n            $sql=\"insert into teacher (name,short_name) \n            select distinct name,short from teacher_in where new_id is NULL\";\n            nuRunQuery($sql);\n\n            $sql=\"UPDATE teacher_in \n            INNER JOIN teacher ON teacher.short_name = teacher_in.short\n            SET teacher_in.new_id = teacher.id\n            where new_id is NULL\";\n            nuRunQuery($sql);\n\n            print \"<span CLASS=\\\"msgSuccess\\\">Εισήχθησαν \".$row[0].\" νέοι καθηγητές!</span><br>\";\n        } else {\n            print \"<span CLASS=\\\"msg\\\">Δεν υπάρχουν νέοι καθηγητές προς εισαγωγή...</span><br>\";\n        }\n    } else{\n        print \"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν δεδομένα για νέους καθηγητές!</span><br>\";\n    }\n    //*********************************************subject******************************************************\n    $sql=\"select count(*) from subject_in where new_id is NULL\";\n    $retval=nuRunQuery($sql);\n\n    if($retval && db_num_rows($retval)>0) {\n        $row = db_fetch_row($retval);\n        if($row[0]>0){\n        \n            $sql=\"ALTER TABLE subject ADD COLUMN tmp_id varchar(100) NULL\";\n            nuRunQuery($sql);\n            $sql=\"insert into subject (name,short_name,tmp_id) \n            select distinct subject_in.name,subject_in.short,subject_in.id \n            from subject_in where new_id is NULL\";\n            nuRunQuery($sql);\n\n            $sql=\"UPDATE subject_in \n            INNER JOIN subject ON subject.tmp_id = subject_in.id\n            SET subject_in.new_id = subject.id\";\n            nuRunQuery($sql);\n\n            $sql=\"ALTER TABLE subject DROP COLUMN tmp_id\";\n            nuRunQuery($sql);\n    \n            print \"<span CLASS=\\\"msgSuccess\\\">Εισήχθησαν \".$row[0].\" νέα μαθήματα!</span><br>\";\n        } else {\n            print \"<span CLASS=\\\"msg\\\">Δεν υπάρχουν νέα μαθήματα προς εισαγωγή...</span><br>\";\n        }\n    } else{\n        print \"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν δεδομένα για νέα μαθήματα!</span><br>\";\n    }\n//*********************************************card******************************************************\n    $sql=\"UPDATE card_in\n    INNER JOIN group_in ON group_in.id = card_in.groupids\n    SET card_in.group_new_id = group_in.new_id\";\n    nuRunQuery($sql);\n\n    $sql=\"UPDATE card_in\n    INNER JOIN subject_in ON subject_in.id = card_in.subjectid\n    SET card_in.subject_new_id = subject_in.new_id\";\n    nuRunQuery($sql);\n\n    $sql=\"UPDATE card_in\n    INNER JOIN teacher_in ON teacher_in.id = card_in.teacherids\n    SET card_in.teacher_new_id = teacher_in.new_id\";\n    nuRunQuery($sql);\n\n    $sql=\"UPDATE card_in\n    INNER JOIN classroom_in ON classroom_in.id = card_in.classroomid\n    SET card_in.classroom_new_id = classroom_in.new_id\";\n    nuRunQuery($sql);\n\n    $sql=\"select count(distinct \'#card_date#\',subject_new_id,teacher_new_id,IFNULL(group_new_id,0),IFNULL(classroom_new_id,0),day,period) FROM card_in\";\n    $retval=nuRunQuery($sql);\n\n    if($retval && db_num_rows($retval)>0) {\n        $row = db_fetch_row($retval);\n        if($row[0]>0){\n        \n            $sql=\"insert into card (valid_from,subject_id,teacher_id,class_id,classroom_id,day_id,period_id) \n            SELECT distinct \'#card_date#\',subject_new_id,teacher_new_id,group_new_id,classroom_new_id,day,period FROM card_in\";\n            nuRunQuery($sql);\n            \n            $sql=\"insert into timetable (start_date) values (\'#card_date#\')\";\n            nuRunQuery($sql);\n        \n            print \"<span CLASS=\\\"msgSuccess\\\">Εισήχθησαν \".$row[0].\" νέες διδασκαλίες!</span><br>\";\n        } else {\n            print \"<span CLASS=\\\"msg\\\">Δεν υπάρχουν νέες διδασκαλίες προς εισαγωγή...</span><br>\";\n        }\n    } else{\n        print \"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν δεδομένα για νέες διδασκαλίες!</span><br>\";\n    }\n            \n} else{\n    if(\'#card_date#\'==$curent_date){\n        print \"<span CLASS=\\\"msgError\\\">Προσοχή : Έχετε ήδη καταχωρίσει διδασκαλίες για σήμερα!<br>Παρακαλώ επιλέξτε μεταγενέστερη ημερομηνία έναρξης ισχύος για το νέο πρόγραμμα!</span><br>\";\n    } else {\n        print \"<span CLASS=\\\"msgError\\\">Προσοχή : Η ημερομηνία έναρξης ισχύος του νέου προγράμματος δεν μπορεί να έχει περάσει!</span><br>\";\n    }\n}\n\nprint \"\n    </body>\n</html>\";\n','','0','2015-02-14 12:35:47','globeadmin','2018-09-15 20:04:51','globeadmin','2018-09-15 20:04:51','globeadmin','0'),('54e61e02a705c6d','show_card_valid_dates','Εμφανίζει τις ημερομηνίες των προγραμμάτων που είναι ενεργά ή που θα ενεργοποιηθούν','manager','print \"<html>\n    <head>        \n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">        \n    </head>\n    <body>\";\n\n$sql=\"  SELECT distinct DATE_FORMAT(start_date,\'%d-%m-%Y\')\n        FROM timetable\n        WHERE start_date >= IFNULL((    SELECT max(start_date) \n                                        FROM timetable\n                                        WHERE start_date<=CURDATE()),CURDATE())\n        ORDER BY start_date\";\n\n\n$retval=nuRunQuery($sql);\n\nif($retval) {\n    if(db_num_rows($retval)>0) {\n    \n        $color_active=\'LightGreen\';\n        $color_inactive=\'LightBlue\';\n        $color=$color_active;\n        \n        print \"\n        <right>\n            <table CLASS=\\\"sisTable\\\" cellspacing=0 cellpadding=3 align=right>\n                <tr>\";\n        \n        while($row = db_fetch_row($retval)) {\n                print \"\n                    <td align=center style=\\\"background-color:$color;\\\">\".$row[0].\"</td>\";\n                $color=$color_inactive;\n        }\n        print (\"\n                </tr>\n            </table>\n        </right>\");\n    } else {\n        print (\"<span CLASS=\\\"msg\\\">Δεν υπάρχουν καταχωρημένα ωρολόγια προγράμματα!</span>\");\n    }\n} else {\n    print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν δεδομένα...</span>\");\n}\nprint \"\n    </body>\n</html>\";\n','','0','2015-02-19 19:31:46','globeadmin','2018-07-16 10:29:29','globeadmin','2018-07-16 10:29:29','globeadmin','0'),('54eb5821b763976','student_class_delete','Διαγράφει όλους τους μαθητές ενός τμήματος','manager','$sql=\"delete from student_class where class_id=#RECORD_ID#\";\nnuRunQuery($sql);\n\n','','0','2015-02-23 18:41:05','globeadmin','2015-02-23 18:43:11','globeadmin','2017-10-02 22:09:30','globeadmin',''),('54f4afe911e357f','student_update','Ενημερώνει ΟΛΑ τα στοιχεία των μαθητών με τα στοιχεία που έχουν διαβαστεί από το αρχείο excel','manager','function update_field($field,$field_in=null){\n\n    $field_in = (is_null($field_in) ? $field : $field_in);\n    \n    $sql=\"select count(*)\n    from student\n    inner join student_in on student.id=student_in.student_id\n    where (student.\".$field.\"!=student_in.\".$field_in.\") OR student.\".$field.\" IS NULL\";\n    $retval=nuRunQuery($sql);\n    \n    if($retval && db_num_rows($retval)>0) {\n        $row = db_fetch_row($retval);\n        if($row[0]>0){\n            $sql=\"  update student\n                    inner join student_in on student.id=student_in.student_id\n                        set student.\".$field.\"=student_in.\".$field_in.\" \n                    where (student.\".$field.\"!=student_in.\".$field_in.\") OR student.\".$field.\" IS NULL\";\n            $rv=nuRunQuery($sql);\n            \n            if($rv){\n                print \"<span CLASS=\\\"msgSuccess\\\">Τροποποιήθηκαν - \".$row[0].\" - εγγραφές του πεδίου <u>\".$field.\"</u></span><br>\";\n            }\n        }\n    }\n} \n\nupdate_field(\'name\');\nupdate_field(\'surname\');\nupdate_field(\'fathers_name\');\nupdate_field(\'mothers_name\');\nupdate_field(\'gender\');\nupdate_field(\'birth_date\');\nupdate_field(\'phone1\');\nupdate_field(\'phone2\');\nupdate_field(\'mobile\');\nupdate_field(\'email\');\nupdate_field(\'street\');\nupdate_field(\'area\');\nupdate_field(\'zipcode\');\nupdate_field(\'city\');\nupdate_field(\'parent_name\');\nupdate_field(\'parent_surname\');\nupdate_field(\'parent_phone1\');\nupdate_field(\'parent_phone2\');\nupdate_field(\'parent_phone3\');\nupdate_field(\'parent_email\');\nupdate_field(\'parent_email2\');\nupdate_field(\'parent_street\');\nupdate_field(\'parent_area\');\nupdate_field(\'parent_zipcode\');\nupdate_field(\'mothers_surname\');\nupdate_field(\'grade_id\',\'grade\');\n','','0','2015-03-02 20:46:01','globeadmin','2021-09-04 23:34:46','globeadmin','2021-09-04 23:34:46','globeadmin','0'),('54f729629379af4','create_absence_period_table','Δημιουργία απουσιολογίου τμήματος μιας μόνο ώρας','teacher','function have_adsence($absence_array, $student_id){\n    foreach ($absence_array as $absence) {\n        if($absence[0]==$student_id){\n                return $absence;\n        }\n    }\n    return false;\n}\n\nprint \"<html>\n<head>\n<meta charset=\\\"UTF-8\\\">\n<script type=\\\"text/javascript\\\">\n\nvar TableBackgroundNormalColor = \\\"LightBlue\\\";\nvar TableBackgroundMouseoverColor = \\\"Gold\\\";\n\nfunction ChangeBackgroundColor(cell) {\n    cell.style.cursor=\\\"pointer\\\";\n    cell.parentNode.style.backgroundColor = TableBackgroundMouseoverColor;\n}\n\nfunction RestoreBackgroundColor(cell) {\n    cell.style.cursor=\\\"auto\\\";\n    cell.parentNode.style.backgroundColor = TableBackgroundNormalColor; \n} \n\nfunction add_adsence(student_id, period_id, class_id){\n    if(confirm(\\\"Θα επιβληθεί η ποινή της ωριαίας απομάκρυνσης στο μαθητή! Είστε σίγουρος;\\\")){\n        var ids=student_id+\\\"_\\\"+period_id+\\\"_\\\"+\\\"2\\\";                  //create ids         \n        \n        parent.nuSetHash(\'absence_id_list\',ids);\n        parent.nuSetHash(\'absence_class_id\',class_id);\n        parent.nuSetHash(\'absence_period_id\',period_id);\n        \n        parent.nuAjax(\'add_student_absence\',\'foo\');// Καταχώριση Απουσίας\n            \n        parent.nuRunPHP(\'create_absence_period_table\',\'period_absence_iframe\'); // Επαναφόρτωση Απουσιολογίου\n    }\n}\n\nvar absence_reason_array = [];\nabsence_reason_array.push([\\\"0\\\", \\\"Παρών\\\" , \\\"Π\\\"]);\n\";\n\n$sql=\"SELECT * FROM absence_reason\";\n$retval=nuRunQuery($sql);\nwhile($reason_row=db_fetch_row($retval)){\nprint \"absence_reason_array.push([\\\"\".$reason_row[0].\"\\\", \\\"\".$reason_row[1].\"\\\", \\\"\".$reason_row[2].\"\\\"]);\n\";\n}\n\nprint \"\n\nfunction change_state(cell,evt) {\n\n    var res = cell.id.split(\\\"_\\\");\n    var prev_index = parseInt(res[2]);\n    \n    evt = evt || window.event;\n    var button = evt.which || evt.button;\n    \n    if(button==3){\n        new_index = prev_index-1;\n        if (new_index<0) {\n            new_index = absence_reason_array.length-1;\n        }        \n    } else {\n        new_index = prev_index+1;\n        if (new_index>=absence_reason_array.length) {\n            new_index=0;\n        }    \n    }\n    \n    cell.innerHTML = absence_reason_array[new_index][2];\n    cell.id=res[0]+\\\"_\\\"+res[1]+\\\"_\\\"+new_index;\n    \n    if(new_index==0){\n        n=parseInt(document.getElementById(\'num_of_students\').innerHTML);\n        n++;\n        document.getElementById(\'num_of_students\').innerHTML=n.toString();    \n    } else if(prev_index==0) {\n        n=parseInt(document.getElementById(\'num_of_students\').innerHTML);\n        n--;\n        document.getElementById(\'num_of_students\').innerHTML=n.toString();       \n    }\n    \n    if(new_index==0){\n        cell.style.backgroundColor = \\\"lightGreen\\\";\n    } else if(new_index==1) {\n        cell.style.backgroundColor = \\\"OrangeRed\\\";\n    } else if(new_index==2) {\n        cell.style.backgroundColor = \\\"Magenta\\\";\n    } else if(new_index==3) {\n        cell.style.backgroundColor = \\\"FireBrick\\\";\n    } else {\n        cell.style.backgroundColor = \\\"Red\\\";\n    }\n    \n    cell.title=absence_reason_array[new_index][1];\n}\n</script>\n\n</head>\n\n<body oncontextmenu=\\\"return false;\\\">\";\n\nif (\'#absence_class_id#\'==\'#\'.\'absence_class_id\'.\'#\' || \'#absence_class_id#\'==\'\'){\n    print \"<b><i>Παρακαλώ επιλέξτε τμήμα ...</i></b>\";\n} else {\n\n    $absence_date = date(\'Y-m-d\');\n    $day_of_week = idate(\'w\', strtotime($absence_date))-1;\n    \n    $sql=\"  SELECT period.id,period.name\n            FROM period\n            WHERE CURTIME() between period.start_time and period.end_time\";\n    $retval_period=nuRunQuery($sql);\n    \n    $sql=\"SELECT short_name FROM class WHERE id=#absence_class_id#\";\n    $retval_class=nuRunQuery($sql);\n    \n    if($retval_period && $retval_class){\n        if(db_num_rows($retval_period)!=0){\n            if(db_num_rows($retval_period)==1){\n            \n                $row_class = db_fetch_row($retval_class);\n                $class_name= $row_class[0];\n                \n                $row_period=db_fetch_row($retval_period);\n                $period_id=$row_period[0];\n                $period_name=$row_period[1];\n                                                // Βρίσκω τον εναπομείναντα χρόνο για καταχώριση\n                $sql1=\"  SELECT \n                            if (TIMEDIFF(period.end_time,CURTIME())<\n	                        TIMEDIFF(AddTime(period.start_time,if((school.set_absence_time_limit is NULL) OR (school.set_absence_time_limit =\'\') OR (school.set_absence_time_limit =\'00:00:00\'),\'23:59:59\',school.set_absence_time_limit)),CURTIME()),\n	                        if(TIMEDIFF(period.end_time,CURTIME())<\'00:00:00\',convert(\'00:00:00\',TIME),TIMEDIFF(period.end_time,CURTIME())),\n	                        if(TIMEDIFF(AddTime(period.start_time,if((school.set_absence_time_limit is NULL) OR (school.set_absence_time_limit =\'\') OR (school.set_absence_time_limit =\'00:00:00\'),\'23:59:59\',school.set_absence_time_limit)),CURTIME())<\'00:00:00\',convert(\'00:00:00\',TIME),TIMEDIFF(AddTime(period.start_time,if((school.set_absence_time_limit is NULL) OR (school.set_absence_time_limit =\'\') OR (school.set_absence_time_limit =\'00:00:00\'),\'23:59:59\',school.set_absence_time_limit)),CURTIME())))\n                        FROM \n                        (\n                            SELECT \n	                            card.id AS id,\n	                            card.valid_from AS valid_from,\n	                            card.subject_id AS subject_id,\n	                            card.teacher_id AS teacher_id,\n	                            card.class_id AS class_id,\n	                            card.classroom_id AS classroom_id,\n	                            card.day_id AS day_id,\n	                            card.period_id AS period_id \n                            FROM card \n                            WHERE card.valid_from =(select max(timetable.start_date) from timetable where (timetable.start_date <= curdate()))\n                        ) as active_card,period,school\n                        WHERE \n	                        active_card.period_id=period.id and \n	                        active_card.teacher_id=\'#RECORD_ID#\' and \n	                        active_card.class_id=\'#absence_class_id#\' and \n                            active_card.day_id=DAYOFWEEK(CURDATE())-2 and \n                            CURTIME() between period.start_time and period.end_time and \n                            active_card.id not in (   select registered_card.card_id \n                                        from registered_card \n                                        where registered_card.card_date=CURDATE()) and \n                            CURDATE() not in (select holiday.holiday from holiday)\";\n\n                $retval_time=nuRunQuery($sql1);\n\n                                                               // Βρίσκω τις διδασκαλίες του τμήματος τη συγκρκριμένη μέρα και ώρα\n                $sql=\"SELECT \n	                                active_card.id 				AS id,\n	                                teacher.short_name 			AS teacher_short,\n                                	subject.short_name 			AS subject_short,\n                                	classroom.short_name 		AS classroom_short,\n									if(rg.id is NULL,0,1)\n                                FROM \n                                	(SELECT \n                                		card.id 			AS id,\n                                		card.valid_from 	AS valid_from,\n                                		card.subject_id 	AS subject_id,\n                                		card.teacher_id 	AS teacher_id,\n                                		card.class_id 		AS class_id,\n                                		card.classroom_id 	AS classroom_id,\n                                		card.day_id 		AS day_id,\n                                		card.period_id 		AS period_id \n                                	FROM card \n                                	WHERE card.valid_from =\n                                		(	SELECT max(timetable.start_date) \n                                			FROM timetable \n                                			WHERE (timetable.start_date <= curdate()))) as active_card \n                                	inner join subject 			on active_card.subject_id = subject.id \n                                	inner join teacher 			on active_card.teacher_id = teacher.id  \n                                	inner join day 				on active_card.day_id = day.id  \n                                	inner join period 			on active_card.period_id = period.id\n                                	inner join class 			on active_card.class_id = class.id	\n                                	left  join subject_type 	on subject.subject_type_id = subject_type.id  \n                                	left  join classroom 		on active_card.classroom_id = classroom.id\n									LEFT JOIN (\n                                            select registered_card.id as id,registered_card.card_id as card_id \n                                            from registered_card\n                                            where DATE_FORMAT(registered_card.card_date, \'%Y-%m-%d\')=\'\".$absence_date.\"\') as rg on active_card.id=rg.card_id\n                                WHERE \n                                    active_card.class_id=\'#absence_class_id#\' and \n                                    active_card.day_id=\'\".$day_of_week.\"\' and \n                                    active_card.period_id=\'\".$period_id.\"\' and \n                                    CURDATE() not in (select holiday.holiday from holiday)\n                                ORDER BY active_card.period_id,teacher.short_name\";\n                \n                $rv_card=nuRunQuery($sql);\n                \n                if($rv_card && db_num_rows($rv_card)>0){\n                    \n                    $card_array = array();\n                \n                    $teacher_name=\'\';\n                    $subject_name=\'\';\n                    $have_registered=false;\n                \n                    while($card_row=db_fetch_row($rv_card)){\n                        $card_array[]= array($card_row[0],$card_row[1],$card_row[2],$card_row[3],$card_row[4]);\n                    \n                        if($teacher_name==\'\'){\n                            $teacher_name=$card_row[1];\n                        } else {\n                            $teacher_name=$teacher_name.\', \'.$card_row[1];\n                        }\n                    \n                        if($subject_name==\'\'){\n                            $subject_name=$card_row[2];\n                        } else {\n                            if($subject_name!=$card_row[2]){\n                            $subject_name=$subject_name.\',\'.$card_row[2];\n                            }\n                        }\n                    \n                        if($card_row[4]==1){\n                            $have_registered=true;\n                        }\n                    }\n                    \n                    if($have_registered){\n                       $subject_name=\'Καταχωρημένο - \'.$subject_name;  \n                    }                                                          // Βρίσκω τις ήδη καταχωρημένες απουσίες του τμήματος τη συγκρκριμένη μέρα και ώρα\n                    $sql=\"  SELECT  \n                                    student.id,\n                                    absence_reason.short_name,\n                                    absence_reason.name,\n                                    absence.id\n                                FROM \n                                    absence,\n                                    student,\n                                    student_class,\n                                    absence_reason,\n                                    card\n                                WHERE \n                                    absence.student_id = student.id and\n                                    absence.card_id = card.id and\n                                    student_class.student_id = student.id and\n                                    absence_reason.id = absence.absence_reason_id and\n                                    student_class.class_id=#absence_class_id# and\n                                    card.period_id=\".$period_id.\" and \n                                    DATE_FORMAT(absence_date, \'%Y-%m-%d\')=\'\".$absence_date.\"\'\";\n                    $rv_absence=nuRunQuery($sql);\n                    $absence_array = array();\n                                \n                    while($absence_row=db_fetch_row($rv_absence)){\n                        $absence_array[]= array($absence_row[0],$absence_row[1],$absence_row[2],$absence_row[3]);  \n                    }               \n                    \n                    print \"<table border=1  cellspacing=0 align=center>\";\n                    \n                    print \" <tr bgcolor=LightSalmon height=40>\n                            <td colspan=3 align=center valign=center>\n                                <b><font size=\\\"+1\\\">\n                                    \".date(\'d-m-Y\',strtotime($absence_date)).\" - \".$period_name.\n                                \"</font></b>\n                            </td>\n                            </tr>\n                            \n                            <tr bgcolor=LightSalmon height=40>\n                            <td colspan=3 align=center valign=center>\n                                <b><font size=\\\"+1\\\">Τμήμα : \".$class_name.\"\".\n                                \"</font></b>\n                            </td>\n                            </tr>\n                            \n                            <tr bgcolor=LightSalmon height=40>\n                            <td colspan=3 align=left valign=center>\n                                <b><font size=\\\"+1\\\">\n                                    \".$subject_name.\" - \".$teacher_name.\n                                \"</font></b>\n                            </td>\n                            </tr>\n                            \";\n                            \n                    $sql=\"  SELECT registration_number,surname,name,fathers_name,has_left_school,student.id\n                                        FROM student \n                                        inner join student_class on student.id=student_class.student_id\n                                        WHERE student_class.class_id=#absence_class_id#\n                                        order by surname,name,fathers_name\";\n                    $rv_student=nuRunQuery($sql);\n                    \n                    if(!($have_registered)){\n                    \n                        $row_time = db_fetch_row($retval_time);\n                        \n                        if($row_time[0]==\'00:00:00\'){   // Έχει λήξει το χρονικό όριο καταχώρισης\n                            print \"<tr bgcolor=Salmon height=40>\n                                    <td colspan=2 align=left valign=center width=680><b><font size=\\\"+1\\\">Έχει λήξει το χρονικό όριο καταχώρισης των απουσιών...</font></b></td>\n                                    </tr>\";\n                        } else{\n                            $num_of_students=0;\n                            while($row_student = db_fetch_row($rv_student)){\n                                print \"<tr bgcolor=LightBlue height=40 >\";\n                                print \"<td align=left valign=center width=600><b>\".$row_student[1].\" \".$row_student[2].\"</b> - \".$row_student[3].\"</td>\";\n                            \n                                if($row_student[4]==0){\n                                    print \"<td id=\\\"\".$row_student[5].\"_\".$period_id.\"_0\\\" bgcolor=lightGreen class=\\\"absence\\\" title=\\\"Παρουσία\\\" align=center valign=center width=80 onmousedown=\\\"change_state(this,event);\\\" onmouseover=\\\"ChangeBackgroundColor(this)\\\" onmouseout=\\\"RestoreBackgroundColor(this)\\\">Π</td>\";\n                                    $num_of_students++;\n                                } else{\n                                    print \"<td id=\\\"\".$row_student[5].\"_\".$period_id.\"_1\\\" bgcolor=OrangeRed class=\\\"absence\\\" title=\\\"Απουσία\\\" align=center valign=center width=80 onmousedown=\\\"change_state(this,event);\\\" onmouseover=\\\"ChangeBackgroundColor(this)\\\" onmouseout=\\\"RestoreBackgroundColor(this)\\\">Α</td>\";\n                                }\n                            \n                                print \"</tr>\";    \n                            }\n                            \n                            print \" <tr bgcolor=LightSalmon height=40>\n                                        <td align=right valign=center width=600><b><font size=\\\"+1\\\">Αριθμός Παρόντων Μαθητών&nbsp;</font></b></td>\n                                        <td id=\\\"num_of_students\\\" align=center valign=center width=80>\".$num_of_students.\"</td>\n                                    </tr>\";\n                        }\n                    } else {\n                        while($row_student = db_fetch_row($rv_student)){\n                            print \"<tr bgcolor=LightBlue height=40 >\";\n                            print \"<td align=left valign=center width=520><b>\".$row_student[1].\" \".$row_student[2].\"</b> - \".$row_student[3].\"</td>\";\n                            \n                            if($s=have_adsence($absence_array,$row_student[5])){\n                                print \"<td bgcolor=LightBlue align=center valign=center width=80>&nbsp;</td>\";\n                                print \"<td bgcolor=Brown title=\\\"Καταχωρημένο-\".$s[2].\"\\\" onclick=\\\"parent.nuOpenFormInFrame(\'5509671b4e81a07\',\'\".$s[3].\"\')\\\" align=center valign=center width=80 onmouseover=\\\"ChangeBackgroundColor(this)\\\" onmouseout=\\\"RestoreBackgroundColor(this)\\\">\".$s[1].\"</td>\";\n                            } else {\n                                print \"<td bgcolor=LightBlue onclick=\\\"add_adsence(\'\".$row_student[5].\"\',\'\".$period_id.\"\',\'#absence_class_id#\')\\\" title=\\\"Επιβολή Ποινής - ΩΑ\\\" align=center valign=center width=80 onmouseover=\\\"ChangeBackgroundColor(this)\\\" onmouseout=\\\"RestoreBackgroundColor(this)\\\"><img src=\\\"images/get_out.png\\\" width=25 heght=25></td>\";\n                                print \"<td bgcolor=DarkOliveGreen title=\\\"Καταχωρημένο-Παρουσία\\\" align=center valign=center width=80>Π</td>\";\n                            }                            \n                            \n                            print \"</tr>\";\n                        }\n                    }\n                } else {\n                    print \"<b><i>Δεν έχετε μάθημα αυτήν την ώρα...</i></b>\";\n                }\n            } else {\n                print \"<b><i>ΠΡΟΣΟΧΗ : Δεν έχουν οριστεί σωστά οι διάρκειες των ωρών διδασκαλίας...</i></b>\";\n            }\n        } else {\n            print \"<b><i>Δεν διεξάγεται καμία διδασκαλία αυτή τη στιγμή στο σχολείο...</i></b>\"; \n        }\n    } else{\n        print \"<b><i>Παρουσιάστηκε πρόβλημα στην ανάκτηση των δεδομένων...</i></b>\";   \n    }\n}\n               \nprint \"</body></html>\";\n','','0','2015-03-04 17:48:50','globeadmin','2016-01-23 20:07:23','globeadmin','2019-11-05 18:54:44','globeadmin',''),('54f8ae257942c56','find_school_year_holidays','Βρίσκει τις αργίες του τρέχοντος σχολικού έτους τις εισάγει στον πίνακα holiday','manager','function orthodox_eastern($year) {\n    $a = $year % 4;\n    $b = $year % 7;\n    $c = $year % 19;\n    $d = (19 * $c + 15) % 30;\n    $e = (2 * $a + 4 * $b - $d + 34) % 7;\n    $month = floor(($d + $e + 114) / 31);\n    $day = (($d + $e + 114) % 31) + 1;\n   \n    $de = mktime(0, 0, 0, $month, $day + 13, $year);\n   \n    return $de;\n} \n\nfunction insert_holiday($date,$description,$school_year_id,$start_date,$end_date) {\n    $sql=\"select count(*) from holiday where holiday.holiday=\'\".$date.\"\' and school_year_id=\".$school_year_id;\n    $rv=nuRunQuery($sql);\n    if($rv){\n        $row=db_fetch_row($rv);\n        if($row[0]==0){\n            if($date>=$start_date and $date <=$end_date){\n                $sql=\"insert into holiday (id,holiday,description,school_year_id) values (NULL,\'\".$date.\"\',\'\".$description.\"\',\".$school_year_id.\")\";\n                nuRunQuery($sql);\n            }\n        }\n    }\n}\n\n$sql=\"select id,start_date,end_date from school_year where id=#RECORD_ID#\";\n\n$rv=nuRunQuery($sql);\n\nif($rv && db_num_rows($rv)>0){\n    if($row=db_fetch_row($rv)){\n\n        $d = DateTime::createFromFormat(\"Y-m-d\", $row[1]);\n        $year_start = $d->format(\"Y\");\n\n        $d = DateTime::createFromFormat(\"Y-m-d\", $row[2]);\n        $year_end = $d->format(\"Y\");\n    \n        insert_holiday($year_start.\'-10-28\',\'28η Οκτωβρίου (Εθνική Εορτή)\',$row[0],$row[1],$row[2]);\n        \n        insert_holiday($year_start.\'-12-24\',\'Διακοπές Χριστουγέννων\',$row[0],$row[1],$row[2]);\n        insert_holiday($year_start.\'-12-25\',\'Διακοπές Χριστουγέννων\',$row[0],$row[1],$row[2]);\n        insert_holiday($year_start.\'-12-26\',\'Διακοπές Χριστουγέννων\',$row[0],$row[1],$row[2]);\n        insert_holiday($year_start.\'-12-27\',\'Διακοπές Χριστουγέννων\',$row[0],$row[1],$row[2]);\n        insert_holiday($year_start.\'-12-28\',\'Διακοπές Χριστουγέννων\',$row[0],$row[1],$row[2]);\n        insert_holiday($year_start.\'-12-29\',\'Διακοπές Χριστουγέννων\',$row[0],$row[1],$row[2]);\n        insert_holiday($year_start.\'-12-30\',\'Διακοπές Χριστουγέννων\',$row[0],$row[1],$row[2]);\n        insert_holiday($year_start.\'-12-31\',\'Διακοπές Χριστουγέννων\',$row[0],$row[1],$row[2]);\n        insert_holiday($year_end.\'-01-01\',\'Διακοπές Χριστουγέννων\',$row[0],$row[1],$row[2]);\n        insert_holiday($year_end.\'-01-02\',\'Διακοπές Χριστουγέννων\',$row[0],$row[1],$row[2]);\n        insert_holiday($year_end.\'-01-03\',\'Διακοπές Χριστουγέννων\',$row[0],$row[1],$row[2]);\n        insert_holiday($year_end.\'-01-04\',\'Διακοπές Χριστουγέννων\',$row[0],$row[1],$row[2]);\n        insert_holiday($year_end.\'-01-05\',\'Διακοπές Χριστουγέννων\',$row[0],$row[1],$row[2]);\n        insert_holiday($year_end.\'-01-06\',\'Διακοπές Χριστουγέννων\',$row[0],$row[1],$row[2]);\n        insert_holiday($year_end.\'-01-07\',\'Διακοπές Χριστουγέννων\',$row[0],$row[1],$row[2]);\n        insert_holiday($year_end.\'-01-30\',\'Τριών Ιεραρχών\',$row[0],$row[1],$row[2]);\n        \n        insert_holiday($year_end.\'-03-25\',\'25 Μαρτίου (Εθνική Εορτή)\',$row[0],$row[1],$row[2]);\n        insert_holiday($year_end.\'-05-01\',\'Πρωτομαγιά\',$row[0],$row[1],$row[2]);\n        \n        \n        $easter_date = orthodox_eastern($year_end);\n        \n        insert_holiday(date(\'Y-m-d\',$easter_date),\'Διακοπές Πάσχα\',$row[0],$row[1],$row[2]);\n        insert_holiday(date(\'Y-m-d\', strtotime(date(\'Y-m-d\',$easter_date). \' - 48 days\')),\'Καθαρά Δευτέρα\',$row[0],$row[1],$row[2]);\n        \n        insert_holiday(date(\'Y-m-d\', strtotime(date(\'Y-m-d\',$easter_date). \' - 1 days\')),\'Διακοπές Πάσχα\',$row[0],$row[1],$row[2]);\n        insert_holiday(date(\'Y-m-d\', strtotime(date(\'Y-m-d\',$easter_date). \' - 2 days\')),\'Διακοπές Πάσχα\',$row[0],$row[1],$row[2]);\n        insert_holiday(date(\'Y-m-d\', strtotime(date(\'Y-m-d\',$easter_date). \' - 3 days\')),\'Διακοπές Πάσχα\',$row[0],$row[1],$row[2]);\n        insert_holiday(date(\'Y-m-d\', strtotime(date(\'Y-m-d\',$easter_date). \' - 4 days\')),\'Διακοπές Πάσχα\',$row[0],$row[1],$row[2]);\n        insert_holiday(date(\'Y-m-d\', strtotime(date(\'Y-m-d\',$easter_date). \' - 5 days\')),\'Διακοπές Πάσχα\',$row[0],$row[1],$row[2]);\n        insert_holiday(date(\'Y-m-d\', strtotime(date(\'Y-m-d\',$easter_date). \' - 6 days\')),\'Διακοπές Πάσχα\',$row[0],$row[1],$row[2]);\n        insert_holiday(date(\'Y-m-d\', strtotime(date(\'Y-m-d\',$easter_date). \' + 1 days\')),\'Διακοπές Πάσχα\',$row[0],$row[1],$row[2]);\n        insert_holiday(date(\'Y-m-d\', strtotime(date(\'Y-m-d\',$easter_date). \' + 2 days\')),\'Διακοπές Πάσχα\',$row[0],$row[1],$row[2]);\n        insert_holiday(date(\'Y-m-d\', strtotime(date(\'Y-m-d\',$easter_date). \' + 3 days\')),\'Διακοπές Πάσχα\',$row[0],$row[1],$row[2]);\n        insert_holiday(date(\'Y-m-d\', strtotime(date(\'Y-m-d\',$easter_date). \' + 4 days\')),\'Διακοπές Πάσχα\',$row[0],$row[1],$row[2]);\n        insert_holiday(date(\'Y-m-d\', strtotime(date(\'Y-m-d\',$easter_date). \' + 5 days\')),\'Διακοπές Πάσχα\',$row[0],$row[1],$row[2]);\n        \n        insert_holiday(date(\'Y-m-d\', strtotime(date(\'Y-m-d\',$easter_date). \' + 50 days\')),\'Αγίου Πνεύματος\',$row[0],$row[1],$row[2]);\n        \n    }\n};\n\n','','0','2015-03-05 21:27:33','globeadmin','2018-02-18 17:03:44','globeadmin','2019-08-05 23:25:35','globeadmin','0'),('5507176562eedae','show_message_have_not_lesson','Εμφανίζει απλά μήνυμα ότι ο καθηγητής δεν έχει μάθημα','teacher','print (\"<html>\n    <body>\n        <table style=\\\"font-family:Verdana;font-size:10pt;\\\" border=0  cellspacing=0 width=100%>\n            <tr height=35>\n                <th align=left style=\\\"color:blue;\\\">\n                    <i>Δεν έχετε μάθημα αυτή τη στιγμή...</i>\n                </th>\n            </tr>\n        </table>\n    </body>\n</html>\");','','0','2015-03-16 19:48:21','globeadmin','2018-06-21 18:56:46','globeadmin','2018-07-16 23:25:47','globeadmin','0'),('5507d4d7b50b99c','register_period_cards','Καταχωρεί οτι λήφθησαν οι απουσίες της συγκεκριμένης ώρας για ένα τμήμα','teacher','\nif (\'#absence_date#\'!=\'#\'.\'absence_date\'.\'#\' && \'#absence_date#\'!=\'\'){\n    $absence_date = \'#absence_date#\';\n} else {\n    $absence_date = date(\'Y-m-d\');\n}\n$day_of_week = idate(\'w\', strtotime($absence_date))-1;\n\nif (\'#absence_period_id#\'!=\'#\'.\'absence_period_id\'.\'#\' && \'#absence_period_id#\'!=\'\'){\n    $period_id = \'#absence_period_id#\';\n} else {\n    $sql =\"select id from period where curtime() between period.start_time and period.end_time\";\n    $rv=nuRunQuery($sql);\n    if($rv && db_num_rows($rv)>0){\n        $r = db_fetch_row($rv);\n        $period_id = $r[0];\n    } else{\n        $period_id = \'-1\';\n    }\n}\n\nif (\'#absence_class_id#\'!=\'#\'.\'absence_class_id\'.\'#\' && \'#absence_class_id#\'!=\'\' && is_int(#absence_class_id#)){\n\n    $sql=\"select max(valid_from) from card where valid_from<=\'\".$absence_date.\"\'\"; \n    $rv=nuRunQuery($sql);\n    \n    if($rv && db_num_rows($rv)>0){\n        $card_date = db_fetch_row($rv);\n    \n        $sql=\"  SELECT card.id \n                FROM card,period\n                WHERE\n                    card.period_id=period.id and \n                    period.id=\'\".$period_id.\"\' and \n                    valid_from=\'\".$card_date[0].\"\' and\n                    card.class_id=\'#absence_class_id#\' and\n                    day_id=\".$day_of_week.\" and\n                    card.id not in (   select registered_card.card_id \n                                        from registered_card \n                                        where DATE_FORMAT(registered_card.card_date, \'%Y-%m-%d\')=\'\".$absence_date.\"\')\";\n                                        \n        $retval=nuRunQuery($sql);\n        \n        if($retval && db_num_rows($retval)>0){\n        \n            $is_primary=1;\n        \n            while($card_ids=db_fetch_row($retval)){\n                $sql=\"  INSERT INTO registered_card (\n                            id,\n                            card_date,\n                            posted_when,\n                            card_id,\n                            teacher_id,\n                            prime\n                        ) VALUES (\n                            NULL,\n                            \'\".$absence_date.\"\',\n                            \'\".date(\'Y-m-d H:i:s\').\"\',\n                            \".$card_ids[0].\",\n                            #RECORD_ID#,\n                            \".$is_primary.\"\n                        )\";\n                $rg_id = nuRunQuery($sql,NULL,true);\n                \n                if($is_primary==1){\n                    \n                    $is_primary=0;\n                    \n                    $sql=\"  SELECT other_rg.comments \n                            FROM registered_card AS other_rg\n                            INNER JOIN registered_card AS this_rg ON this_rg.id = \'$rg_id\'\n                            INNER JOIN card AS this_card ON this_card.id = this_rg.card_id\n                            INNER JOIN card AS other_card ON other_card.id = other_rg.card_id\n                            WHERE\n                                other_rg.id <> \'$rg_id\' AND\n                                other_rg.card_date = this_rg.card_date AND\n                                other_card.day_id = this_card.day_id AND\n                                other_card.period_id = this_card.period_id AND\n                                other_card.subject_id = this_card.subject_id AND\n                                other_card.classroom_id <=> this_card.classroom_id AND\n                                other_card.teacher_id = this_card.teacher_id AND\n                                other_rg.no_lesson = 0 AND\n                                other_rg.prime = 1\n                            LIMIT 1\";\n                    $rv = nuRunQuery($sql);\n                    if($rv && db_num_rows($rv)>0 && $row=db_fetch_row($rv)){\n                        $sql = \"UPDATE registered_card SET comments=\'{$row[0]}\' WHERE id=\'$rg_id\'\";\n                        nuRunQuery($sql);\n                    }\n                }              \n            }\n            \n        } else {\n            nuDebug(\'register_period_cards - card(s) to register NOT found!\');\n        }\n    } else {\n        nuDebug(\'register_period_cards - active program NOT found!\');\n    } \n} else {\n   nuDebug(\'register_period_cards - Hash Variables NOT set properly\'); \n}\n','','0','2015-03-17 09:16:39','globeadmin','2021-04-05 22:12:27','globeadmin','2021-04-05 22:12:27','globeadmin','0'),('54fdfd017b6a60e','register_class_cards','Καταχωρεί οτι λήφθησαν οι απουσίες μιας μέρας για ένα τμήμα','teacher','$cur_date_time = date(\'Y-m-d H:i:s\');\n\nif (\'#absence_date#\'==\'#\'.\'absence_date\'.\'#\' || \'#absence_date#\'==\'\'){\n    $absence_date = date(\'Y-m-d\');\n} else {\n    $absence_date = \'#absence_date#\';\n}  \n\n$day_of_week = idate(\'w\', strtotime($absence_date))-1;\n\nif (\'#absence_class_id#\'!=\'#\'.\'absence_class_id\'.\'#\' && \'#absence_class_id#\'!=\'\' && is_int(#absence_class_id#)){\n\n    $sql=\"select max(valid_from) from card where valid_from<=\'\".$absence_date.\"\'\"; \n    $rv=nuRunQuery($sql);\n    \n    if($rv && db_num_rows($rv)>0){\n        $card_date = db_fetch_row($rv);\n        \n        $sql=\"  SELECT card.id,card.period_id,period.start_time \n                FROM card\n                INNER JOIN period ON period.id=card.period_id\n                WHERE\n                    valid_from=\'\".$card_date[0].\"\' and\n                    card.class_id=#absence_class_id# and\n                    day_id=\".$day_of_week.\" and \n                    card.id not in (   select registered_card.card_id \n                                        from registered_card \n                                        where DATE_FORMAT(registered_card.card_date, \'%Y-%m-%d\')=\'\".$absence_date.\"\')\n                ORDER BY card.period_id\n                \";\n\n        $retval=nuRunQuery($sql);\n        \n        if($retval && db_num_rows($retval)>0){\n            \n            $end_time = \"00:00:00\";\n            $card_array = array();\n            \n            while($card_row=db_fetch_row($retval)){\n            \n                $card_array[]= array($card_row[0],$card_row[1]);\n                \n                if($card_row[2]>$end_time){$end_time = $card_row[2];}\n            }\n            \n            if($absence_date.\' \'.$end_time < $cur_date_time){\n            \n                $is_primary     = 0;\n                $prev_period_id = -1;\n            \n                foreach ($card_array as $card_ids) {\n                //while($card_ids=db_fetch_row($retval)){\n            \n                    if($prev_period_id != $card_ids[1]){\n                        $is_primary     = 1;\n                        $prev_period_id = $card_ids[1];\n                    } else {\n                        $is_primary     = 0;\n                    }\n                \n                    $sql=\"  INSERT INTO registered_card (\n                            id,\n                            card_date,\n                            posted_when,\n                            card_id,\n                            teacher_id,\n                            prime\n                        ) VALUES (\n                            NULL,\n                            \'\".$absence_date.\"\',\n                            \'\".date(\'Y-m-d H:i:s\').\"\',\n                            \".$card_ids[0].\",\n                            #RECORD_ID#,\n                            \".$is_primary.\"\n                        )\";\n                    nuRunQuery($sql);              \n                }\n            } else {\n                $nuError=\'Προσοχή! Δεν μπορείτε να κάνετε καταχώριση σε διδασκαλίες που δεν έχουν πραγματοποιηθεί!\';    \n            }\n        } else {\n            nuDebug(\'register_class_cards - retrive error 1\');\n        }\n    } else {\n        nuDebug(\'register_class_cards - retrive error 2\');\n    } \n} else {\n   nuDebug(\'register_class_cards - Hash Variables NOT set properly\'); \n}\n','','0','2015-03-09 22:05:21','globeadmin','2017-10-08 10:37:06','globeadmin','2017-10-08 10:38:30','globeadmin','0'),('54ff33e86cd65f8','add_class_absences','Καταχωρεί τις απουσίες ενός τμήματος για μία ολόκληρη μέρα   ','teacher','nuRunPHP(\'notification_add_lib\');\n\nfunction find_card($cards, $period){\n    foreach ($cards as $card) {\n        if($card[1]==$period){\n            return $card;\n        }\n    }\n    return;\n}\n\n$cur_date_time = date(\'Y-m-d H:i:s\');\n\nif (\'#absence_date#\'==\'#\'.\'absence_date\'.\'#\' || \'#absence_date#\'==\'\'){\n    $absence_date = date(\'Y-m-d\');\n} else {\n    $absence_date = \'#absence_date#\';\n}\n\n$day_of_week = idate(\'w\', strtotime($absence_date))-1;\n\nif (\'#absence_id_list#\'!=\'#\'.\'absence_id_list\'.\'#\' && \'#absence_id_list#\'!=\'\' && \'#absence_class_id#\'!=\'#\'.\'absence_class_id\'.\'#\' && \'#absence_class_id#\'!=\'\'){\n    \n    $sql=\"select max(valid_from) from card where valid_from<=\'\".$absence_date.\"\'\"; \n    $rv=nuRunQuery($sql);\n    \n    if($rv && db_num_rows($rv)>0){\n        \n        $card_date = db_fetch_row($rv);\n        \n        $sql=\"  SELECT card.id,card.period_id,period.start_time,subject.absence_counts\n                FROM card\n                INNER JOIN period ON period.id=card.period_id\n                INNER JOIN subject ON subject.id=card.subject_id\n                WHERE\n                    card.valid_from=\'\".$card_date[0].\"\' and\n                    card.class_id=#absence_class_id# and\n                    day_id=\".$day_of_week.\" and \n                    card.id not in (   select registered_card.card_id \n                                        from registered_card \n                                        where DATE_FORMAT(registered_card.card_date, \'%Y-%m-%d\')=\'\".$absence_date.\"\')\";\n        $retval=nuRunQuery($sql);  \n        \n        if($retval && db_num_rows($retval)>0){\n\n            $end_time = \"00:00:00\";\n            \n            while($card_row=db_fetch_row($retval)){\n            \n                $cards[]= array($card_row[0],$card_row[1],$card_row[3]);\n                \n                if($card_row[2]>$end_time){$end_time = $card_row[2];}\n            }\n            \n            if($absence_date.\' \'.$end_time < $cur_date_time){\n\n                $absences = explode(\";\", \'#absence_id_list#\');\n            \n                foreach ($absences as $absence_str) {\n                \n                    $absence=explode(\"_\", $absence_str);\n                    $student_id=$absence[0];\n                    $period_id=$absence[1];\n                    $absence_reason_id=$absence[2];\n                \n                    $card    = find_card($cards, $period_id);\n                    $card_id = ($card ? $card[0] : 0);\n                \n                    if($absence_reason_id>0 && $student_id>0 && $period_id>0 && $card_id>0){ // In case of error - Ignore\n                            \n                        $sql=\"  INSERT INTO absence (\n                                    id,\n                                    absence_date,\n                                    posted_when,\n                                    post_teacher_id,\n                                    student_id,\n                                    card_id,\n                                    absence_reason_id,\n                                    comments,\n                                    justified,\n                                    justified_when,\n                                    justified_comments,\n                                    counts,\n                                    justified_teacher_id,\n                                    justified_reason_id) \n                                VALUES (\n                                    NULL,\n                                    \'\".$absence_date.\"\',\n                                    \'\".date(\'Y-m-d H:i:s\').\"\',\n                                    #RECORD_ID#,\n                                    \".$student_id.\",\n                                    \".$card_id.\",\n                                    \".$absence_reason_id.\",\n                                    NULL,\n                                    \".($card[2]==\'1\'? \'0\': \'1\').\",\n                                    \".($card[2]==\'1\'? \'NULL\': \"\'\".date(\'Y-m-d H:i:s\'.\"\'\")).\",\n                                    \".($card[2]==\'1\'? \'NULL\': \"\'Στο αντίστοιχο μάθημα έχει οριστεί ότι οι απουσίες δεν προσμετρούνται\'\").\",\n                                    \".($card[2]==\'1\'? \'1\': \'0\').\",\n                                    \".($card[2]==\'1\'? \'NULL\': \'#RECORD_ID#\').\",\n                                    \".($card[2]==\'1\'? \'NULL\': \'0\').\"\n                                    )\";\n                                    \n                        $new_id = nuRunQuery($sql,null,true);\n                    \n                        new_absence_notification($new_id);\n                        if($card[2]!=\'1\') justify_absence_notification($new_id);\n                    \n                    } else {\n                        nuDebug(\'add_class_absences - problem with absence string=\'.$absence_str.\' card=\'.$card_id.\' date=\'.$absence_date);    \n                    }\n                }\n            \n                nuRunPHP(\'register_class_cards\');\n        \n            } else {\n                $nuError=\'Προσοχή! Δεν μπορείτε να κάνετε καταχώριση σε διδασκαλίες που δεν έχουν πραγματοποιηθεί!\';\n                //nuDebug(\'******* Πρόβλημα ********\');    \n            }\n        } else {\n            nuDebug(\'add_class_absences - Cards Not Found - class_id=#absence_class_id#, absence_date=\'.$absence_date.\', absence_id_list=#absence_id_list#\');\n        }\n    } else {\n        nuDebug(\'add_class_absences - Timetable not found\');\n    } \n} else {\n   nuDebug(\'add_class_absences - Hash Variables NOT set properly\'); \n}\n','','0','2015-03-10 20:11:52','globeadmin','2019-11-05 11:48:06','globeadmin','2022-09-24 22:24:47','globeadmin','0'),('550737d00a4a57b','add_period_absences','Καταχωρεί τις απουσίες ενός τμήματος για μία ώρα','teacher','nuRunPHP(\'notification_add_lib\');\n\nfunction find_card($cards, $period){\n    foreach ($cards as $card) {\n        if($card[1]==$period){\n            return $card;\n        }\n    }\n    return;\n}\n\nif (\'#absence_date#\'!=\'#\'.\'absence_date\'.\'#\' && \'#absence_date#\'!=\'\'){\n    $absence_date = \'#absence_date#\';\n} else {\n    $absence_date = date(\'Y-m-d\');\n}\n\n$day_of_week = idate(\'w\', strtotime($absence_date))-1;\n\nif (\'#absence_id_list#\'!=\'#\'.\'absence_id_list\'.\'#\' && \'#absence_id_list#\'!=\'\' && \'#absence_class_id#\'!=\'#\'.\'absence_class_id\'.\'#\' && \'#absence_class_id#\'!=\'\' && \'#absence_period_id#\'!=\'#\'.\'absence_period_id\'.\'#\' && \'#absence_period_id#\'!=\'\'){\n    \n    $sql=\"select max(valid_from) from card where valid_from<=\'\".$absence_date.\"\'\"; \n    $rv=nuRunQuery($sql);\n    \n    if($rv && db_num_rows($rv)>0){\n        \n        $card_date = db_fetch_row($rv);\n        \n        $sql=\"  SELECT card.id,card.period_id,subject.absence_counts\n                FROM card\n                INNER JOIN subject ON subject.id=card.subject_id\n                WHERE\n                    valid_from=\'\".$card_date[0].\"\' and \n                    card.class_id=\'#absence_class_id#\' and \n                    card.period_id=\'#absence_period_id#\' and  \n                    day_id=\".$day_of_week.\" and \n                    card.id not in (   select registered_card.card_id  \n                                        from registered_card \n                                        where DATE_FORMAT(registered_card.card_date, \'%Y-%m-%d\')=\'\".$absence_date.\"\')\";\n        $retval=nuRunQuery($sql);  \n        \n        if($retval && db_num_rows($retval)>0){\n\n            while($card_row=db_fetch_row($retval)){\n                $cards[]= array($card_row[0],$card_row[1],$card_row[2]);  \n            }\n\n            $absences = explode(\";\", \'#absence_id_list#\');\n            \n            foreach ($absences as $absence_str) {\n                \n                $absence=explode(\"_\", $absence_str);\n                $student_id=$absence[0];\n                $period_id=$absence[1];\n                $absence_reason_id=$absence[2];\n                \n                $card = find_card($cards, $period_id);\n                $card_id = ($card ? $card[0] : 0);\n                \n                if($absence_reason_id>0 && $student_id>0 && $period_id>0 && $card_id>0){ // In case of error - Ignore\n                            \n                    $sql=\"INSERT INTO absence (\n                        \n                        id,\n                        absence_date,\n                        posted_when,\n                        post_teacher_id,\n                        student_id,\n                        card_id,\n                        absence_reason_id,\n                        comments,\n                        \n                        justified,\n                        justified_when,\n                        justified_comments,\n                        counts,\n                        justified_teacher_id,\n                        justified_reason_id                        \n                        ) VALUES (\n                        \n                        NULL,\n                        \'\".$absence_date.\"\',\n                        \'\".date(\'Y-m-d H:i:s\').\"\',\n                        \'#RECORD_ID#\',\n                        \".$student_id.\",\n                        \".$card_id.\",\n                        \".$absence_reason_id.\",\n                        NULL,\n                        \n                        \".($card[2]==\'1\'? \'0\': \'1\').\",\n                        \".($card[2]==\'1\'? \'NULL\': \"\'\".date(\'Y-m-d H:i:s\'.\"\'\")).\",\n                        \".($card[2]==\'1\'? \'NULL\': \"\'Στο αντίστοιχο μάθημα έχει οριστεί ότι οι απουσίες δεν προσμετρούνται\'\").\",\n                        \".($card[2]==\'1\'? \'1\': \'0\').\",\n                        \".($card[2]==\'1\'? \'NULL\': \'#RECORD_ID#\').\",\n                        \".($card[2]==\'1\'? \'NULL\': \'0\').\")\";\n                    \n                    $new_id = nuRunQuery($sql,null,true);\n                    new_absence_notification($new_id); \n                    if($card[2]!=\'1\') justify_absence_notification($new_id);\n\n                } else {\n                    nuDebug(\'add_period_absences - problem with absence - \'.$absence_str);    \n                }\n            }\n            \n            nuRunPHP(\'register_period_cards\');\n            \n        } else {\n            nuDebug(\'add_period_absences - Cards Not Found\');\n        }\n    } else {\n        nuDebug(\'add_period_absences - Timetable not found\');\n    } \n} else {\n   nuDebug(\'add_period_absences - Hash Variables NOT set properly\'); \n}\n','','0','2015-03-16 22:06:40','globeadmin','2019-11-05 11:47:52','globeadmin','2021-04-05 21:33:12','globeadmin','0'),('55004dd5e43f2f2','create_absence_class_table','Δημιουργία απουσιολογίου τμήματος ολόκληρης ημέρας','teacher','function have_card($array, $key){\n    foreach ($array as $c) {\n        if($c[1]==$key){\n            return $c;\n        }\n    }\n    return;\n}\n\nfunction have_absence($absence_array, $student_id,$card){\n    foreach ($absence_array as $absence) {\n        if($absence[0]==$student_id && $absence[3]==$card[1]){// && $absence[4]==$card[0]){\n                return $absence;\n        }\n    }\n    return;\n}\n\nfunction have_penalty($penalty_array, $period_id,$student_id){\n    foreach ($penalty_array as $penalty) {\n        if($penalty[2]==$student_id && ($penalty[6]==-1 || $penalty[6]==$period_id)){\n                return $penalty;\n        }\n    }\n    return false;\n}\n\nprint \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n\n        <STYLE TYPE=\\\"text/css\\\">\n            .sisTable, .sisTable TD{\n                font-size:10pt;\n                border-color:#595959;\n            }\n            .sisTable TH{\n                font-size:12pt;\n                border-color:#595959;\n            }\n        </STYLE>\n\n        <script type=\\\"text/javascript\\\">\n\n            var TableBackgroundNormalColor = \\\"LightBlue\\\";\n            var TableBackgroundNormalColor2 = \\\"LightSalmon\\\";\n            var TableBackgroundMouseoverColor = \\\"Gold\\\";\n\n            function ChangeBackgroundColor(cell,class_id) {\n                ChangeCursor(cell);\n                cell.parentNode.style.backgroundColor = TableBackgroundMouseoverColor;\n                var x = document.getElementsByClassName(class_id);\n                x[0].style.backgroundColor = TableBackgroundMouseoverColor; \n            }\n\n            function RestoreBackgroundColor(cell,class_id) {\n                RestoreCursor(cell);\n                cell.parentNode.style.backgroundColor = TableBackgroundNormalColor; \n                var x = document.getElementsByClassName(class_id);\n                x[0].style.backgroundColor =TableBackgroundNormalColor2 ; \n            } \n\n            function ChangeThisBackgroundColor(cell) {\n                ChangeCursor(cell);\n                cell.parentNode.style.backgroundColor = TableBackgroundMouseoverColor;\n            }\n\n            function RestoreThisBackgroundColor(cell) {\n                RestoreCursor(cell);\n                cell.parentNode.style.backgroundColor = TableBackgroundNormalColor; \n            }\n\n            function add_after_student_absence(student_id, student_name, period_id,evt,teacher_id) {\n    \n                evt = evt || window.event;\n                var button = evt.which || evt.button;\n    \n                if(button==2){\n                    add_penalty(student_id, student_name, teacher_id, period_id, evt);\n                    return;\n                }\n    \n                if(confirm(\'Θα καταχωρίσετε -εκ των υστέρων, σε κλειστό απουσιολόγιο- απουσία σε μαθητή.\\\\nΜετά την καταχώριση, το απουσιολόγιο θα επαναφορτωθεί.\\\\n\\\\nΕίστε σίγουρος;\')){\n                    parent.s_id = student_id;\n                    parent.s_name = student_name;\n                    parent.p_id = period_id;\n                    parent.nuOpenFormInFrame(\'5812516a1bf18a5\',\'#RECORD_ID#\');\n                }\n            }\n\n            function show_absence(absence_id,evt,student_id,student_name,period_id,teacher_id) {\n    \n                evt = evt || window.event;\n                var button = evt.which || evt.button;\n    \n                if(button==2){\n                    add_penalty(student_id, student_name, teacher_id, period_id, evt);\n                    return;\n                }\n    \n                parent.nuOpenFormInFrame(\'5509671b4e81a07\',absence_id)    \n            }\n\n\n            var absence_reason_array = [];\n            absence_reason_array.push([\\\"0\\\", \\\"Παρών\\\" , \\\"Π\\\"]);\";\n\n$sql=\"SELECT * FROM absence_reason\";\n$retval=nuRunQuery($sql);\nwhile($reason_row=db_fetch_row($retval)){\nprint \"\n            absence_reason_array.push([\\\"\".$reason_row[0].\"\\\", \\\"\".$reason_row[1].\"\\\", \\\"\".$reason_row[2].\"\\\"]);\";\n}\n\nprint \"\n            function change_state(cell,evt,student_id,student_name,period_id,teacher_id) {\n\n                var res = cell.id.split(\\\"_\\\");\n                var prev_index = parseInt(res[2]);\n    \n                evt = evt || window.event;\n                var button = evt.which || evt.button;\n    \n                if(button==2){\n                    add_penalty(student_id, student_name, teacher_id, period_id, evt);\n                    return;\n                }\n                else if(button==3){\n                    new_index = prev_index-1;\n                    if (new_index<0) {\n                        new_index = absence_reason_array.length-1;\n                    }        \n                } else {\n                    new_index = prev_index+1;\n                    if (new_index>=absence_reason_array.length) {\n                        new_index=0;\n                    }    \n                }\n\n                cell.innerHTML = absence_reason_array[new_index][2];\n                cell.id=res[0]+\\\"_\\\"+res[1]+\\\"_\\\"+new_index;\n    \n                if(new_index==0){\n                    cell.style.backgroundColor = \\\"lightGreen\\\";\n                } else if(new_index==1) {\n                    cell.style.backgroundColor = \\\"OrangeRed\\\";\n                } else if(new_index==2) {\n                    cell.style.backgroundColor = \\\"Magenta\\\";\n                } else if(new_index==3) {\n                    cell.style.backgroundColor = \\\"FireBrick\\\";\n                } else {\n                    cell.style.backgroundColor = \\\"Red\\\";\n                }\n                cell.title=absence_reason_array[new_index][1];\n            }\n\n            function change_stubent_state (student_id,evt){\n\n                evt = evt || window.event;\n                var button = evt.which || evt.button;\n    \n                var matches = [];\n                var elems = document.getElementsByTagName(\\\"*\\\");\n    \n                for (var i=0; i<elems.length; i++) {\n                    if (elems[i].id.indexOf(student_id+\\\"_\\\") == 0)\n                        matches.push(elems[i]);\n                }\n\n                var prev_index = -1;\n                var all_same = true;\n    \n                for (var i=0; i<matches.length; i++) {\n                    var res = matches[i].id.split(\\\"_\\\");\n                    var cur_index = parseInt(res[2]);\n        \n                    if(prev_index != -1 && prev_index != cur_index){\n                        all_same = false;\n                    }\n        \n                    prev_index = cur_index;\n                }\n    \n                var new_index = 0;\n    \n                if(all_same){\n                    if(button==3){\n                        new_index = prev_index-1;\n                        if (new_index<0) {\n                            new_index = absence_reason_array.length-1;\n                        }        \n                    } else {\n                        new_index = prev_index+1;\n                        if (new_index>=absence_reason_array.length) {\n                            new_index=0;\n                        }    \n                    }\n                } else {\n                    if(button==3){\n                        new_index = 0;\n                    } else {\n                        new_index = 1;\n                    }    \n                }\n    \n                for (var i=0; i<matches.length; i++) {\n                    res = matches[i].id.split(\\\"_\\\");\n    \n                    matches[i].innerHTML = absence_reason_array[new_index][2];\n                    matches[i].id=res[0]+\\\"_\\\"+res[1]+\\\"_\\\"+new_index;\n    \n                    if(new_index==0){\n                        matches[i].style.backgroundColor = \\\"lightGreen\\\";\n                    } else if(new_index==1) {\n                        matches[i].style.backgroundColor = \\\"OrangeRed\\\";\n                    } else if(new_index==2) {\n                        matches[i].style.backgroundColor = \\\"Magenta\\\";\n                    } else if(new_index==3) {\n                        matches[i].style.backgroundColor = \\\"FireBrick\\\";\n                    } else {\n                        matches[i].style.backgroundColor = \\\"Red\\\";\n                    }\n                    matches[i].title=absence_reason_array[new_index][1];\n                }\n            }\n\n            function set_no_lesson(period_id){\n                if(confirm(\\\"Η διδασκαλία αυτή θα καταχωρηθεί -άμεσα- ως μη πραγματοποιηθείσα!\\\\nΤο απουσιολόγιο θα επαναφορτωθεί!\\\\n\\\\nΕίστε σίγουρος;\\\")){\n        \n                    var reason = prompt(\\\"Παρακαλώ εισάγετε το λόγο για τον οποίο δεν πραγματοποιήθηκε η διδασκαλία\\\",\\\"\\\");    \n        \n                    if (reason != null) {\n                        if(reason.trim() != \\\"\\\"){\n                            parent.nuSetHash(\'no_lesson_comments\',reason);\n                        } else {\n                            parent.nuSetHash(\'no_lesson_comments\',\'\'); \n                        }\n                    } else {\n                        parent.nuSetHash(\'no_lesson_comments\',\'\');    \n                    }\n        \n                    parent.nuSetHash(\'no_lesson_period_id\',period_id);\n                    parent.nuAjax(\'register_no_lesson_cards\',\'foo\'); // Δήλωση Καταχώρισης Απουσίών\n                    parent.nuRunPHP(\'create_absence_class_table\',\'absence_iframe\'); // Επαναφόρτωση Απουσιολογίου\n                }\n            }\n            \n            function set_yes_lesson(period_id){\n                if(confirm(\\\"Το κενό αυτό θα καταργηθεί -άμεσα- και η διδασκαλία θα επανέλθει!\\\\nΤο απουσιολόγιο θα επαναφορτωθεί!\\\\n\\\\nΕίστε σίγουρος;\\\")){\n                    parent.nuSetHash(\'no_lesson_period_id\',period_id);\n                    parent.nuAjax(\'un_register_no_lesson_cards\',\'foo\'); // Δήλωση Καταχώρισης Απουσίών\n                    parent.nuRunPHP(\'create_absence_class_table\',\'absence_iframe\'); // Επαναφόρτωση Απουσιολογίου\n                }\n            }\n\n            function add_penalty(student_id, student_name, teacher_id, period_id, evt){\n    \n                evt.stopPropagation();\n    \n                parent.s_id = student_id;\n                parent.s_name = student_name;\n    \n                parent.t_id = teacher_id;\n                parent.p_id = period_id;\n        \n                parent.nuOpenFormInFrame(\'580ba2a48260384\',\'-1\');\n            }\n\n        </script>\n\n    </head>\n\n    <body oncontextmenu=\\\"return false;\\\" onload=\\\"adjustIframeHeight()\\\">\";\n\nif (\'#absence_class_id#\'==\'#\'.\'absence_class_id\'.\'#\' || \'#absence_class_id#\'==\'\'){\n    print \"\n        <span CLASS=\\\"msg\\\">Παρακαλώ επιλέξτε τμήμα ...</span>\";\n} else {\n    if (\'#absence_date#\'==\'#\'.\'absence_date\'.\'#\' || \'#absence_date#\'==\'\'){\n        $absence_date = date(\'Y-m-d\');\n    } else {\n        $absence_date = \'#absence_date#\';\n    }  \n    \n    //$day_of_week = date(\'N\', $absence_date)-1;\n    $day_of_week = idate(\'w\', strtotime($absence_date))-1;\n    \n    if($absence_date<=date(\'Y-m-d\')){\n        $sql=\"SELECT count(*) FROM day WHERE id=\".$day_of_week;\n        $rv1=nuRunQuery($sql);\n        \n        if($rv1 && db_num_rows($rv1)>0){\n            $row1 = db_fetch_row($rv1);\n    \n            if($row1[0]==1){\n                $sql=\"SELECT start_date,end_date FROM school,school_year WHERE school.school_year_id=school_year.id\";\n                $rv2=nuRunQuery($sql);\n    \n                if($rv2 && db_num_rows($rv2)>0){\n                    $row2 = db_fetch_row($rv2);\n    \n                    if($absence_date>=$row2[0] && $absence_date<=$row2[1]){\n                        $sql=\"  select if(\'\".$absence_date.\"\' in (SELECT holiday.holiday \n                                FROM school,school_year,holiday \n                                WHERE school.school_year_id = school_year.id and holiday.school_year_id=school_year.id \n                                ORDER BY holiday.holiday),\'1\',\'0\')\";   \n                        $rv3=nuRunQuery($sql);\n                        if($rv3 && db_num_rows($rv3)>0){\n                            $row3 = db_fetch_row($rv3);\n                            if($row3[0]==0){                            // ΟΛΑ ΚΑΛΑ! Δημιουργία απουσιολογίου\n                            \n                                $sql=\"SELECT id,name FROM period\";\n                                $rv4=nuRunQuery($sql);\n                                $num_of_periods=db_num_rows($rv4);\n                                \n                                $sql=\"SELECT short_name FROM class WHERE id=#absence_class_id#\";\n                                $rv5=nuRunQuery($sql);\n                                $row5 = db_fetch_row($rv5);\n                                                               \n                                                               // Βρίσκω τις διδασκαλίες του τμήματος τη συγκρκριμένη μέρα\n                                                               \n                                $sql=\"select max(valid_from) from card where valid_from<=\'\".$absence_date.\"\'\"; \n                                $rv6=nuRunQuery($sql);\n                                $card_date = db_fetch_row($rv6);\n\n//************************************************************************************************************************************* \n                                $sql=\"  CREATE TEMPORARY TABLE IF NOT EXISTS #TABLE_ID# AS\n                                        SELECT distinct\n                                	        card.period_id AS p_id,\n                                	        sc1.student_id AS s_id,\n                                	        class.short_name AS c_name\n                                        FROM card\n                                        INNER JOIN student_class AS sc1 ON sc1.class_id=\'#absence_class_id#\'\n                                        INNER JOIN student_class AS sc2 ON sc1.student_id=sc2.student_id\n                                        INNER JOIN class ON (class.id = card.class_id AND class.id=sc2.class_id)\n                                        WHERE                                                    \n                                            card.valid_from=\'\".$card_date[0].\"\' and\n                                            card.day_id=\'$day_of_week\'\n                                        ORDER BY \n                                            card.period_id,\n                                            sc1.student_id,\n                                            class.short_name\";\n                                nuRunQuery($sql);\n//************************************************************************************************************************************* \n                                $sql=\"  SELECT \n                                                        card.id,\n                                                        card.period_id,\n                                                        teacher.short_name,\n                                                        subject.short_name,\n                                                        classroom.short_name,\n                                                        if(rg.id is NULL,0,1),\n                                                        if(rg.id is NULL,0,rg.no_lesson),\n                                                        teacher.id\n                                                    FROM card\n                                                    inner join teacher on card.teacher_id=teacher.id\n                                                    inner join subject on card.subject_id=subject.id\n                                                    LEFT join classroom on card.classroom_id=classroom.id\n                                                    LEFT JOIN (\n                                                                select registered_card.id as id,registered_card.card_id as card_id, registered_card.no_lesson as no_lesson\n                                                                from registered_card\n                                                                where DATE_FORMAT(registered_card.card_date, \'%Y-%m-%d\')=\'\".$absence_date.\"\') as rg on card.id=rg.card_id\n                                                    WHERE\n                                                        valid_from=\'\".$card_date[0].\"\' and\n                                                        card.class_id=#absence_class_id# and\n                                                        day_id=\".$day_of_week;\n                                        \n                                    $rv_card=nuRunQuery($sql);\n                                    $card_array = array();\n                                \n                                    while($card_row=db_fetch_row($rv_card)){\n                                        $card_array[]= array($card_row[0],$card_row[1],$card_row[2],$card_row[3],$card_row[4],$card_row[5],$card_row[6],$card_row[7]);  \n                                    }\n                                                                                // Βρίσκω τις ήδη καταχωρημένες απουσίες τη συγκρκριμένη μέρα\n                                    $sql=\"  SELECT  \n                                            student.id,\n                                            absence_reason.short_name,\n                                            absence_reason.name,\n                                            card.period_id,\n                                            card.id,\n                                            absence.id,\n                                            absence.counts\n                                        FROM absence\n                                        INNER JOIN student          ON absence.student_id = student.id\n                                        INNER JOIN absence_reason   ON absence.absence_reason_id = absence_reason.id\n                                        INNER JOIN card             ON absence.card_id = card.id\n                                        INNER JOIN student_class    ON student_class.student_id = student.id\n                                        WHERE \n                                            student_class.class_id=\'#absence_class_id#\' and\n                                            DATE_FORMAT(absence_date, \'%Y-%m-%d\')=\'\".$absence_date.\"\'\";\n                                $rv_absence=nuRunQuery($sql);\n                                $absence_array = array();\n                                \n                                while($absence_row=db_fetch_row($rv_absence)){\n                                    \n                                    $sql = \"SELECT COUNT(*) FROM justification_request WHERE absence_id=\'\".$absence_row[5].\"\' AND proceeded=0\";\n                                    \n                                    $rv_request = nuRunQuery($sql);\n                                    $request_row = db_fetch_row($rv_request);\n                                    \n                                    $absence_array[]= array($absence_row[0],$absence_row[1],$absence_row[2],$absence_row[3],$absence_row[4],$absence_row[5],$absence_row[6],$request_row[0]);  \n                                }\n                                \n                                                                            // Βρίσκω τις ποινές των μαθητών του  τμήματος τη συγκρκριμένη μέρα που επιφέρουν απουσίες\n                                $sql=\"  SELECT  \n                                                penalty.id,\n                                                penalty.type,\n                                                student.id,\n                                                penalty_type.absence_reason_id,\n                                                absence_reason.short_name,\n                                                absence_reason.name,\n                                                ifNULL(penalty.period_id,\'-1\')\n                                        FROM penalty\n                                        INNER JOIN penalty_type     ON penalty.type         = penalty_type.name\n                                        INNER JOIN absence_reason   ON absence_reason.id    = penalty_type.absence_reason_id  \n                                        INNER JOIN student          ON student.id           = penalty.student_id\n                                        INNER JOIN student_class    ON (student.id          = student_class.student_id) AND student_class.class_id=\'#absence_class_id#\'\n                                        WHERE \n                                            penalty.date_enforced = \'$absence_date\' AND\n                                            penalty_type.absence_reason_id IS NOT NULL\";\n                                \n                                $rv_penalty=nuRunQuery($sql);\n                                $penalty_array = array();\n                                \n                                while($penalty_row=db_fetch_row($rv_penalty)){\n                                    $penalty_array[]= array($penalty_row[0],$penalty_row[1],$penalty_row[2],$penalty_row[3],$penalty_row[4],$penalty_row[5],$penalty_row[6]);  \n                                }\n                                \n                                print \"\n        <table cellspacing=0 align=center CLASS=\\\"sisTable\\\">\";\n                                print \"\n            <tr height=40><th colspan=\".($num_of_periods+1).\" align=center valign=center><b>Ημερομηνία : \".date(\'d-m-Y\',strtotime($absence_date)).\" - Τμήμα : \".$row5[0].\"</b></th></tr>\"; \n                                \n                                $tr1=\"\n            <tr height=20 style=\\\"background-color:LightSalmon;\\\">\";\n                                $tr2=\"\n            <tr height=40 style=\\\"background-color:LightSalmon;\\\">\";\n                                \n                                $tr1=$tr1.\"\n                <td align=center valign=center width=400 rowspan=2><b>Μαθητής / Ώρα</b></td>\";\n                                \n                                while($row4 = db_fetch_row($rv4)){\n                                   \n                                    $lesson = \'\';\n                                    foreach ($card_array as $card) {\n                                        if($card[1]==$row4[0]){\n                                                $lesson = $card[3];\n                                            }\n                                    }\n                                    \n                                    foreach ($card_array as $card) {\n                                        if($card[1]==$row4[0]){\n                                            if($lesson == \'\'){\n                                                $lesson = $card[2];\n                                            } else {\n                                                $lesson = $lesson.\',\'.$card[2];\n                                            }\n                                        }\n                                    }\n                                    \n                                    $registered = false;\n                                    $no_lesson = false;\n                                    foreach ($card_array as $card) {\n                                        if($card[1]==$row4[0] && $card[5]==1){\n                                                if($card[6]==1){\n                                                    if(!$registered){$lesson = \'Κενό-\'.$lesson;}\n                                                    $no_lesson = true;\n                                                } else {\n                                                    if(!$registered){$lesson = \'Καταχωρημένο-\'.$lesson;}\n                                                }\n                                                $registered=true;\n                                        }\n                                    }\n                                    \n                                    if($lesson == \'\'){\n                                        $lesson = \'Μάθημα με άλλο τμήμα\';\n                                        $tr1=$tr1.\"\n                <td style=\\\"background-color:Gray;\\\" align=center title=\\\"\".$lesson.\"\\\" valign=center width=60 rowspan=2><b>\".$row4[1].\"</b></td>\";\n                                    } else {\n                                        if($registered){\n                                            if($no_lesson){\n                                                $tr2=$tr2.\"\n                <td style=\\\"background-color:DarkOliveGreen;\\\" align=center title=\\\"\".$lesson.\"\\\" valign=center width=60><b>\".$row4[1].\"</b></td>\";\n                                                $tr1=$tr1.\"\n                <td align=center style=\\\"background-color:#d99b00;\\\" onclick=\\\"set_yes_lesson(\".$row4[0].\")\\\" title=\\\"Αναιρεί το κενό\\\" valign=center width=60 onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\"><font size=-2 color=\\\"#ecefff\\\" face=\\\"Helvetica\\\">Μάθημα</font></td>\";\n                                            } else {\n                                                $tr1=$tr1.\"\n                <td style=\\\"background-color:DarkOliveGreen;\\\" align=center title=\\\"\".$lesson.\"\\\" valign=center width=60 rowspan=2><b>\".$row4[1].\"</b></td>\";    \n                                            }\n                                            \n                                        } else {\n                                            $tr2=$tr2.\"\n                <td align=center title=\\\"\".$lesson.\"\\\" valign=center width=60 class=\\\"period\".$row4[0].\"\\\"><b>\".$row4[1].\"</b></td>\";\n                                            $tr1=$tr1.\"\n                <td align=center style=\\\"background-color:#d99b00;\\\" onclick=\\\"set_no_lesson(\".$row4[0].\")\\\" title=\\\"Ορίζεται ότι αυτή η διδασκαλία δεν πραγματοποιήθηκε\\\" valign=center width=60 onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\"><font size=-1 color=\\\"#ecefff\\\" face=\\\"Helvetica\\\">Κενό</font></td>\";\n                                        }\n                                        \n                                    }\n                                    \n                                }\n                                $tr1=$tr1.\"\n            </tr>\";\n                                $tr2=$tr2.\"\n            </tr>\";\n                                print $tr1;\n                                print $tr2;\n                                \n                                $sql=\"  SELECT registration_number,surname,name,fathers_name,has_left_school,student.id\n                                        FROM student \n                                        inner join student_class on student.id=student_class.student_id\n                                        WHERE student_class.class_id=#absence_class_id#\n                                        order by surname,name,fathers_name\";\n                                $rv_student=nuRunQuery($sql);\n                                \n                                while($row_student = db_fetch_row($rv_student)){\n                                    print \"\n            <tr height=40 >\";\n                                    print \"\n                <td align=left valign=center width=300 onmousedown=\\\"change_stubent_state(\'\".$row_student[5].\"\',event)\\\" onmouseover=\\\"ChangeThisBackgroundColor(this)\\\" onmouseout=\\\"RestoreThisBackgroundColor(this)\\\">\";\n                                    print \"<img src=\\\"images/cards.png\\\" width=30 heght=30 onmousedown=\\\"add_penalty(\'\".$row_student[5].\"\',\'\".$row_student[1].\" \".$row_student[2].\" πατ. \".$row_student[3].\"\',-1,-1,event)\\\" title=\\\"Υποβολή Παρατήρησης-Ποινής\\\" onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\"> \";\n                                    print $row_student[0].\' - <b>\'.$row_student[1].\' \'.$row_student[2].\'</b> - \'.$row_student[3].\"\n                </td>\";\n                                    \n                                    for($i=1;$i<=$num_of_periods;$i++){\n                                        \n                                        $class_id=\'period\'.$i;\n                                        \n                                        if($card = have_card($card_array,$i)){\n                                            if($card[5]!=1){\n                                                if($row_student[4]==0){\n                                                \n                                                    if($penalty = have_penalty($penalty_array,$i,$row_student[5])){\n                                                        $color = ($penalty[3]==\'1\' ? \"OrangeRed\" : ($penalty[3]==\'2\' ? \"Magenta\" : ($penalty[3]==\'3\' ? \"FireBrick\" : \"Red\")));\n                                                        print \"\n                <td id=\\\"\".$row_student[5].\"_\".$i.\"_\".$penalty[3].\"\\\" style=\\\"background-color:$color;\\\" class=\\\"absence\\\" title=\\\"\".$row_student[5].\"\\\" align=center valign=center width=60 onmousedown=\\\"change_state(this,event,\'\".$row_student[5].\"\',\'\".$row_student[1].\" \".$row_student[2].\" πατ. \".$row_student[3].\"\',\'\".$i.\"\',\'\".$card[7].\"\')\\\" onmouseover=\\\"ChangeBackgroundColor(this,\'\".$class_id.\"\')\\\" onmouseout=\\\"RestoreBackgroundColor(this,\'\".$class_id.\"\')\\\">\".$penalty[4].\"\n                </td>\";\n                                                    } else{\n                                                        print \"\n                <td id=\\\"\".$row_student[5].\"_\".$i.\"_0\\\" style=\\\"background-color:lightGreen;\\\" class=\\\"absence\\\" title=\\\"Παρουσία\\\" align=center valign=center width=60 onmousedown=\\\"change_state(this,event,\'\".$row_student[5].\"\',\'\".$row_student[1].\" \".$row_student[2].\" πατ. \".$row_student[3].\"\',\'\".$i.\"\',\'\".$card[7].\"\')\\\" onmouseover=\\\"ChangeBackgroundColor(this,\'\".$class_id.\"\')\\\" onmouseout=\\\"RestoreBackgroundColor(this,\'\".$class_id.\"\')\\\">Π\n                </td>\";    \n                                                    }\n                                                    \n                                                } else{\n                                                    print \"\n                <td id=\\\"\".$row_student[5].\"_\".$i.\"_1\\\" style=\\\"background-color:OrangeRed;\\\" class=\\\"absence\\\" title=\\\"Απουσία\\\" align=center valign=center width=60 onmousedown=\\\"change_state(this,event,\'\".$row_student[5].\"\',\'\".$row_student[1].\" \".$row_student[2].\" πατ. \".$row_student[3].\"\',\'\".$i.\"\',\'\".$card[7].\"\')\\\" onmouseover=\\\"ChangeBackgroundColor(this,\'\".$class_id.\"\')\\\" onmouseout=\\\"RestoreBackgroundColor(this,\'\".$class_id.\"\')\\\">Α\n                </td>\";\n                                                }\n                                                \n                                            } else {\n                                                if($s=have_absence($absence_array,$row_student[5],$card)){\n                                                    print \"\n                <td id=\\\"absence_\".$s[5].\"\\\" style=\\\"background-color:\".($s[6]==\'0\' ? \"#7d5454\" : \"Brown\").\";\".($s[7]==\'0\' ? \"\" : \"background-image: linear-gradient(225deg, #00b6b6, #00b6b6 6px, transparent 6px, transparent);\").\"\\\" title=\\\"Καταχωρημένο-\".$s[2].($s[7]==\'0\' ? \"\" : \"-με αίτημα διαγραφής σε εκκρεμότητα\").\"\\\" onmousedown=\\\"show_absence(\'\".$s[5].\"\',event,\'\".$row_student[5].\"\',\'\".$row_student[1].\" \".$row_student[2].\" πατ. \".$row_student[3].\"\',\'\".$i.\"\',\'\".$card[7].\"\')\\\" onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\" align=center valign=center width=60>\".$s[1].\"\n                </td>\";\n                                                } else {\n                                                    if($card[6]!=1){\n                                                        print \"\n                <td style=\\\"background-color:DarkOliveGreen;\\\" title=\\\"Καταχωρημένο-Παρουσία\\\" onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\" align=center valign=center width=60 onmousedown=\\\"add_after_student_absence(\'\".$row_student[5].\"\',\'\".$row_student[1].\" \".$row_student[2].\" πατ. \".$row_student[3].\"\',\'\".$i.\"\',event,\'\".$card[7].\"\')\\\">Π\n                </td>\";\n                                                    } else {\n                                                        print \"\n                <td style=\\\"background-color:DarkOliveGreen;\\\" title=\\\"Κενό\\\" align=center valign=center width=60>\n                </td>\";\n                                                    }\n                                                }\n                                            }\n                                        } else {\n\n                                        \n                                            $sql=\"  SELECT distinct c_name\n                                                    FROM #TABLE_ID#\n                                                    WHERE                                                    \n                                                        p_id=\'$i\' and\n                                                        s_id=\'\".$row_student[5].\"\'\";\n                                            $rv_class=nuRunQuery($sql);\n                                            \n                                            $t1=\"\";\n                                            if(db_num_rows($rv_class)==0){\n                                                $t = \"Δεν έχει μάθημα\";\n                                            } else {\n                                                $t = \"Μάθημα με \";\n                                                while($row_class=db_fetch_row($rv_class)){\n                                                    $t1 .= ($t1==\"\" ? $row_class[0] : \" \".$row_class[0]);   \n                                                }\n                                                $t .= $t1;\n                                            }\n                                            print \"\n                <td style=\\\"background-color:Grey;color:LightGrey;font-size:8px;\\\" title=\\\"$t\\\" align=center valign=center width=60>$t1\n                </td>\";                                                    \n                                        }\n                                    }\n                                    print \"\n            </tr>\";\n                                }\n                                print \"\n        </table>\";\n                            } else {\n                                print \"<span CLASS=\\\"msgError\\\">Δεν μπορείτε να καταχωρήσετε απουσίες σε ημερομηνίες αργιών...</span>\";\n                            }\n                        } else {\n                            print \"<span CLASS=\\\"msgError\\\">Παρουσιάστηκε πρόβλημα στην ανάκτηση των δεδομένων...</span>\";\n                        }\n                    } else {\n                        print \"<span CLASS=\\\"msgError\\\">Μπορείτε να καταχωρήσετε απουσίες μόνο εντός του τρέχοντος σχολικού έτους...</span>\";\n                    }\n                } else {\n                    print \"<span CLASS=\\\"msgError\\\">Παρουσιάστηκε πρόβλημα στην ανάκτηση των δεδομένων...</span>\"; \n                }\n            } else {\n                print \"<span CLASS=\\\"msgError\\\">Παρακαλώ επιλέξτε ημερομηνία με ημέρα λειτουργίας τους σχολείου...</span>\";  \n            }\n        } else {\n            print \"<span CLASS=\\\"msgError\\\">Παρουσιάστηκε πρόβλημα στην ανάκτηση των δεδομένων...</span>\";    \n        }\n    } else {\n        print \"<span CLASS=\\\"msgError\\\">Δεν μπορείτε να καταχωρήσετε απουσίες σε μελλοντικές ημερομηνίες...</span>\";    \n    }\n}\n\nprint \"\n    </body>\n</html>\";\n','','0','2015-03-11 16:14:45','globeadmin','2021-01-17 13:37:17','globeadmin','2022-09-24 22:25:03','globeadmin','0'),('550c7f9aba73fb6','add_student_absence','Καταχωρεί την απουσία για ένα μαθητή για μία ώρα','teacher','nuRunPHP(\'notification_add_lib\');\n\nfunction find_card($cards, $period){\n    foreach ($cards as $card) {\n        if($card[1]==$period){\n            return $card;\n        }\n    }\n    return;\n}\n\nif (\'#absence_date#\'!=\'#\'.\'absence_date\'.\'#\' && \'#absence_date#\'!=\'\'){\n    $absence_date = \'#absence_date#\';\n} else {\n    $absence_date = date(\'Y-m-d\');\n}\n\n$day_of_week = idate(\'w\', strtotime($absence_date))-1;\n\nif (\'#absence_id_list#\'!=\'#\'.\'absence_id_list\'.\'#\' && \'#absence_id_list#\'!=\'\' && \'#absence_class_id#\'!=\'#\'.\'absence_class_id\'.\'#\' && \'#absence_class_id#\'!=\'\' && \'#absence_period_id#\'!=\'#\'.\'absence_period_id\'.\'#\' && \'#absence_period_id#\'!=\'\'){\n    \n    $sql=\"select max(valid_from) from card where valid_from<=\'\".$absence_date.\"\'\"; \n    $rv=nuRunQuery($sql);\n    \n    if($rv && db_num_rows($rv)>0){\n        \n        $card_date = db_fetch_row($rv);\n        \n        $sql=\"  SELECT card.id,card.period_id,subject.absence_counts\n                FROM card\n                INNER JOIN subject ON subject.id=card.subject_id\n                WHERE\n                    valid_from=\'\".$card_date[0].\"\' and \n                    card.class_id=\'#absence_class_id#\' and \n                    card.period_id=\'#absence_period_id#\' and  \n                    day_id=\".$day_of_week;\nnuDebug($sql);\n        $retval=nuRunQuery($sql);  \n       \n        if($retval && db_num_rows($retval)>0){\n\n            while($card_row=db_fetch_row($retval)){\n                $cards[]= array($card_row[0],$card_row[1],$card_row[2]);  \n            }\n\n            $absences = explode(\";\", \'#absence_id_list#\');\n            \n            foreach ($absences as $absence_str) {\n                \n                $absence=explode(\"_\", $absence_str);\n                $student_id=$absence[0];\n                $period_id=$absence[1];\n                $absence_reason_id=$absence[2];\n                \n                $card = find_card($cards, $period_id);\n                $card_id = ($card ? $card[0] : 0);\n                \n                if($absence_reason_id>0 && $student_id>0 && $period_id>0 && $card_id>0){ // In case of error - Ignore\n                            \n                    $sql=\"INSERT INTO absence (\n                        \n                        id,\n                        absence_date,\n                        posted_when,\n                        post_teacher_id,\n                        student_id,\n                        card_id,\n                        absence_reason_id,\n                        comments,\n                        \n                        justified,\n                        justified_when,\n                        justified_comments,\n                        counts,\n                        justified_teacher_id,\n                        justified_reason_id                             \n                        ) VALUES (\n                        \n                        NULL,\n                        \'\".$absence_date.\"\',\n                        \'\".date(\'Y-m-d H:i:s\').\"\',\n                        \'#RECORD_ID#\',\n                        \".$student_id.\",\n                        \".$card_id.\",\n                        \".$absence_reason_id.\",\n                        NULL,\n                        \n                        \".($card[2]==\'1\'? \'0\': \'1\').\",\n                        \".($card[2]==\'1\'? \'NULL\': \"\'\".date(\'Y-m-d H:i:s\'.\"\'\")).\",\n                        \".($card[2]==\'1\'? \'NULL\': \"\'Στο αντίστοιχο μάθημα έχει οριστεί ότι οι απουσίες δεν προσμετρούνται\'\").\",\n                        \".($card[2]==\'1\'? \'1\': \'0\').\",\n                        \".($card[2]==\'1\'? \'NULL\': \'#RECORD_ID#\').\",\n                        \".($card[2]==\'1\'? \'NULL\': \'0\').\")\";\n                        \n                    $new_id = nuRunQuery($sql,null,true);\n                    new_absence_notification($new_id);\n                    if($card[2]!=\'1\') justify_absence_notification($new_id);\n                    \n                } else {\n                    nuDebug(\'add_period_absences - problem with absence - \'.$absence_str);    \n                }\n            }\n        } else {\n            nuDebug(\'add_period_absences - Cards Not Found\');\n        }\n    } else {\n        nuDebug(\'add_period_absences - Timetable not found\');\n    } \n} else {\n   nuDebug(\'add_period_absences - Hash Variables NOT set properly\'); \n}\n','','0','2015-03-20 22:14:18','globeadmin','2019-11-05 13:41:07','globeadmin','2019-11-05 13:41:07','globeadmin','0'),('552124aeebd01bf','print_absence_class_table','Εκτύπωση απουσιολογίου τμήματος ολοκληρης ημέρας','teacher','function have_card($array, $key){\n    foreach ($array as $c) {\n        if($c[1]==$key){\n            return $c;\n        }\n    }\n    return;\n}\n\nfunction have_absence($absence_array, $student_id,$card){\n    foreach ($absence_array as $absence) {\n        if($absence[0]==$student_id && $absence[3]==$card[1]){ // && $absence[4]==$card[0]){\n                return $absence;\n        }\n    }\n    return;\n}\n\n\n$sql=\"DROP TEMPORARY TABLE IF EXISTS #TABLE_ID#\";\nnuRunQuery($sql);\n\n$sql=\"CREATE TEMPORARY TABLE #TABLE_ID# (\n        school_name VARCHAR(100) CHARACTER SET \'utf8\' COLLATE \'utf8_general_ci\' NOT NULL,\n        school_year_name VARCHAR(100) CHARACTER SET \'utf8\' COLLATE \'utf8_general_ci\' NOT NULL,\n        cur_date VARCHAR(50) CHARACTER SET \'utf8\' COLLATE \'utf8_general_ci\' NOT NULL,\n        abs_date VARCHAR(50) CHARACTER SET \'utf8\' COLLATE \'utf8_general_ci\' NOT NULL,\n        class_name VARCHAR(50) CHARACTER SET \'utf8\' COLLATE \'utf8_general_ci\' NOT NULL,\n        student_name VARCHAR(255) CHARACTER SET \'utf8\' COLLATE \'utf8_general_ci\' NOT NULL\n) DEFAULT CHARACTER SET=utf8\";\nnuRunQuery($sql);\n\n$error_message=\'\';\n\nif (\'#absence_class_id#\'==\'#\'.\'absence_class_id\'.\'#\' || \'#absence_class_id#\'==\'\'){\n    $error_message =  \"Παρακαλώ επιλέξτε τμήμα ...\";\n} else {\n    if (\'#absence_date#\'==\'#\'.\'absence_date\'.\'#\' || \'#absence_date#\'==\'\'){\n        $absence_date = date(\'Y-m-d\');\n    } else {\n        $absence_date = \'#absence_date#\';\n    }  \n    \n    $day_of_week = idate(\'w\', strtotime($absence_date))-1;\n    \n    if($absence_date<=date(\'Y-m-d\')){\n        $sql=\"SELECT count(*) FROM day WHERE id=\".$day_of_week;\n        $rv1=nuRunQuery($sql);\n        \n        if($rv1 && db_num_rows($rv1)>0){\n            $row1 = db_fetch_row($rv1);\n    \n            if($row1[0]==1){\n                $sql=\"SELECT start_date,end_date,school.name, school_year.name FROM school,school_year WHERE school.school_year_id=school_year.id\";\n                $rv2=nuRunQuery($sql);\n    \n                if($rv2 && db_num_rows($rv2)>0){\n                    $row2 = db_fetch_row($rv2);\n                    \n                    $school_name=$row2[2];\n                    $school_year_name=$row2[3];\n                    \n                    if($absence_date>=$row2[0] && $absence_date<=$row2[1]){\n                        $sql=\"  select if(\'\".$absence_date.\"\' in (SELECT holiday.holiday \n                                FROM school,school_year,holiday \n                                WHERE school.school_year_id = school_year.id and holiday.school_year_id=school_year.id \n                                ORDER BY holiday.holiday),\'1\',\'0\')\";   \n                        $rv3=nuRunQuery($sql);\n                        if($rv3 && db_num_rows($rv3)>0){\n                            $row3 = db_fetch_row($rv3);\n                            if($row3[0]==0){                            // ΟΛΑ ΚΑΛΑ! Δημιουργία απουσιολογίου\n                            \n                                $sql=\"SELECT id,name,short_name FROM period\";\n                                $rv4=nuRunQuery($sql);\n                                $num_of_periods=db_num_rows($rv4);\n                                $period_array = array();\n                                \n                                $sql=\"SELECT short_name FROM class WHERE id=#absence_class_id#\";\n                                $rv5=nuRunQuery($sql);\n                                $row5 = db_fetch_row($rv5);\n                                                               \n                                                               // Βρίσκω τις διδασκαλίες του τμήματος τη συγκρκριμένη μέρα\n                                                               \n                                $sql=\"select max(valid_from) from card where valid_from<=\'\".$absence_date.\"\'\"; \n                                $rv6=nuRunQuery($sql);\n                                $card_date = db_fetch_row($rv6);\n                                    \n                                $sql=\"  SELECT \n                                                        card.id,\n                                                        card.period_id,\n                                                        teacher.short_name,\n                                                        subject.name,\n                                                        classroom.short_name,\n                                                        if(rg.id is NULL,0,1),\n                                                        if(rg.id is NULL,0,rg.no_lesson)\n                                                    FROM card\n                                                    inner join teacher on card.teacher_id=teacher.id\n                                                    inner join subject on card.subject_id=subject.id\n                                                    LEFT join classroom on card.classroom_id=classroom.id\n                                                    LEFT JOIN (\n                                                                select registered_card.id as id,registered_card.card_id as card_id,registered_card.no_lesson as no_lesson\n                                                                from registered_card\n                                                                where DATE_FORMAT(registered_card.card_date, \'%Y-%m-%d\')=\'\".$absence_date.\"\') as rg on card.id=rg.card_id\n                                                    WHERE\n                                                        valid_from=\'\".$card_date[0].\"\' and\n                                                        card.class_id=#absence_class_id# and\n                                                        day_id=\".$day_of_week;\n                                        \n                                $rv_card=nuRunQuery($sql);\n                                $card_array = array();\n                                \n                                while($card_row=db_fetch_row($rv_card)){\n                                    $card_array[]= array($card_row[0],$card_row[1],$card_row[2],$card_row[3],$card_row[4],$card_row[5],$card_row[6]);  \n                                }\n                                                                                // Βρίσκω τις ήδη καταχωρημένες απουσίες τη συγκρκριμένη μέρα\n                                $sql=\"  SELECT  \n                                            student.id,\n                                            absence_reason.short_name,\n                                            absence_reason.name,\n                                            card.period_id,\n                                            card.id\n                                        FROM \n                                            absence,\n                                            student,\n                                            student_class,\n                                            absence_reason,\n                                            card\n                                        WHERE \n                                            absence.student_id = student.id and\n                                            absence.card_id = card.id and\n                                            student_class.student_id = student.id and\n                                            absence_reason.id = absence.absence_reason_id and\n                                            student_class.class_id=#absence_class_id# and\n                                            DATE_FORMAT(absence_date, \'%Y-%m-%d\')=\'\".$absence_date.\"\'\";\n                                $rv_absence=nuRunQuery($sql);\n                                $absence_array = array();\n                                \n                                while($absence_row=db_fetch_row($rv_absence)){\n                                    $absence_array[]= array($absence_row[0],$absence_row[1],$absence_row[2],$absence_row[3],$absence_row[4]);  \n                                }                                \n                            \n                                $insert_sql=\"insert into #TABLE_ID# values (\'\".$school_name.\"\', \'\".$school_year_name.\"\', DATE_FORMAT(CURDATE(),\'%d-%m-%Y\'), DATE_FORMAT(\'\".$absence_date.\"\',\'%d-%m-%Y\'), \'\".$row5[0].\"\', \'Μαθητής/Ώρα\'\";\n                                $cnt=0;\n                                while($row4 = db_fetch_row($rv4)){\n                                    $cnt++;\n                                    $sql=\"ALTER TABLE #TABLE_ID# \n                                            ADD COLUMN period_name\".$cnt.\" VARCHAR(50) CHARACTER SET \'utf8\' COLLATE \'utf8_general_ci\' NULL,\n                                            ADD COLUMN subject_name\".$cnt.\" VARCHAR(1000) CHARACTER SET \'utf8\' COLLATE \'utf8_general_ci\' NULL,\n                                            ADD COLUMN absence_name\".$cnt.\" VARCHAR(50) CHARACTER SET \'utf8\' COLLATE \'utf8_general_ci\' NULL\n                                            \";\n                                    nuRunQuery($sql);\n                                    \n                                    $lesson = \'\';\n                                    foreach ($card_array as $card) {\n                                        if($card[1]==$row4[0]){\n                                                $lesson = $card[3];\n                                                if(!is_null($card[4])){\n                                                    $lesson = $lesson.\', Αιθ. \'.$card[4];\n                                                }\n                                            }\n                                    }\n                                    \n                                    foreach ($card_array as $card) {\n                                        if($card[1]==$row4[0]){\n                                            if($lesson == \'\'){\n                                                $lesson = $card[2];\n                                            } else {\n                                                $lesson = $lesson.\', \'.$card[2];\n                                            }\n                                        }\n                                    }\n                                    \n                                    $registered=false;\n                                    foreach ($card_array as $card) {\n                                        if($card[1]==$row4[0] && $card[5]==1){\n                                                if($card[6]==1){\n                                                    if(!$registered){$lesson = \'ΚΕΝΟ - \'.$lesson;}\n                                                } else {\n                                                    if(!$registered){$lesson = \'Καταχωρημένο - \'.$lesson;}\n                                                }\n                                                $registered=true;\n                                        }\n                                    }                                    \n                                    \n                                    if($lesson == \'\'){\n                                        $lesson = \'#F#555555|Μάθημα με άλλο τμήμα\';\n                                    }\n                                    \n                                    $period_array[]= array($row4[1],$lesson);\n                                    \n                                    $insert_sql=$insert_sql.\", \'\".$row4[1].\"\' ,\'\".$lesson.\"\' , \'\".$row4[2].\"\'\";\n                                }\n                                \n                                $insert_sql=$insert_sql.\")\";\n                                nuRunQuery($insert_sql);\n \n \n                                $sql=\"  SELECT registration_number,surname,name,fathers_name,has_left_school,student.id\n                                        FROM student \n                                        inner join student_class on student.id=student_class.student_id\n                                        WHERE student_class.class_id=#absence_class_id#\n                                        order by surname,name,fathers_name\";\n                                $rv_student=nuRunQuery($sql);\n                                \n                                while($row_student = db_fetch_row($rv_student)){\n                                    \n                                    $student_name= $row_student[0].\' - \'.$row_student[1].\' \'.$row_student[2].\' - \'.$row_student[3];\n                                    \n                                    if($row_student[4]==1){\n                                        $student_name=\'#B#D3D3D3|\'.$student_name;\n                                    }\n                                    \n                                    $insert_sql=\"insert into #TABLE_ID# values (\'\".$school_name.\"\', \'\".$school_year_name.\"\', DATE_FORMAT(CURDATE(),\'%d-%m-%Y\'), DATE_FORMAT(\'\".$absence_date.\"\',\'%d-%m-%Y\'), \'\".$row5[0].\"\', \'\".$student_name.\"\'\";\n                                    \n                                    for($i=1;$i<=$num_of_periods;$i++){\n                                        \n                                        $class_id=\'period\'.$i;\n                                        \n                                        if($card = have_card($card_array,$i)){\n                                            if($card[5]!=1){\n                                                $insert_sql=$insert_sql.\", \'\".$period_array[$i-1][0].\"\' ,\'\".$period_array[$i-1][1].\"\' ,\'\".($row_student[4]==1 ? \'#B#D3D3D3|\' : \'\' ).\"\'\";\n                                            } else {\n                                                if($s=have_absence($absence_array,$row_student[5],$card)){\n                                                    $insert_sql=$insert_sql.\", \'\".$period_array[$i-1][0].\"\' ,\'\".$period_array[$i-1][1].\"\' , \'\".($row_student[4]==1 ? \'#B#D3D3D3|\'.$s[1] : $s[1] ).\"\'\";\n                                                } else {\n                                                    if($card[6]!=1){\n                                                        $insert_sql=$insert_sql.\", \'\".$period_array[$i-1][0].\"\' ,\'\".$period_array[$i-1][1].\"\' , \'\".($row_student[4]==1 ? \'#B#D3D3D3|#F#555555|Π\' : \'#F#555555|Π\' ).\"\'\";\n                                                    } else {\n                                                        $insert_sql=$insert_sql.\", \'\".$period_array[$i-1][0].\"\' ,\'\".$period_array[$i-1][1].\"\' , \'\".($row_student[4]==1 ? \'#B#D3D3D3|#F#555555|-\' : \'#F#555555|-\' ).\"\'\";\n                                                    }\n                                                    \n                                                }\n                                            }\n                                        } else {\n                                            $insert_sql=$insert_sql.\", \'\".$period_array[$i-1][0].\"\' ,\'\".$period_array[$i-1][1].\"\' , \'\".($row_student[4]==1 ? \'#B#D3D3D3|X\' : \'X\' ).\"\'\";    \n                                        }\n                                    }\n                                    \n                                    $insert_sql=$insert_sql.\")\";\n                                    nuRunQuery($insert_sql);\n                                }\n                            } else {\n                                $error_message = \"Δεν μπορείτε να τυπώσετε απουσίες σε ημερομηνίες αργιών...\";\n                            }\n                        } else {\n                            $error_message = \"Παρουσιάστηκε πρόβλημα στην ανάκτηση των δεδομένων...\";\n                        }\n                    } else {\n                        $error_message = \"Μπορείτε να τυπώσετε απουσίες μόνο εντός του τρέχοντος σχολικού έτους...\";\n                    }\n                } else {\n                    $error_message = \"Παρουσιάστηκε πρόβλημα στην ανάκτηση των δεδομένων...\"; \n                }\n            } else {\n                $error_message = \"Παρακαλώ επιλέξτε ημερομηνία με ημέρα λειτουργίας τους σχολείου...\";  \n            }\n        } else {\n            $error_message = \"Παρουσιάστηκε πρόβλημα στην ανάκτηση των δεδομένων...\";    \n        }\n    } else {\n        $error_message = \"Δεν μπορείτε να τυπώσετε απουσίες σε μελλοντικές ημερομηνίες...\";    \n    }\n}\n\n\n','','0','2015-04-05 15:03:59','globeadmin','2021-01-20 09:16:48','globeadmin','2021-01-20 09:16:48','globeadmin','0'),('550d4eea3e00a18','show_absence_justification_requests','Εμφανίζει τα αιτήματα διαγραφής μιας απουσίας','sisyphos','print \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n        \n        <script type=\\\"text/javascript\\\">\n\n            function delete_request(request_id) {\n                parent.nuSetHash(\'justification_request_id\',request_id);\n                parent.nuAjax(\'delete_justification_request\',\'foo\');// Διαγραφή Αιτήματος\n                parent.nuRunPHP(\'show_absence_justification_requests\',\'justification_requests_iframe\'); // Επαναφόρτωση Αιτημάτων\n            }\n\n            function request_info(request_id){\n                parent.nuOpenFormInFrame(\'550dbae55f33b5f\',request_id);   \n            }\n\n            function approve_request(request_id,current_teacher_id){\n                parent.nuSetHash(\'justification_request_id\',request_id);\n                //parent.nuSetHash(\'current_teacher_id\',current_teacher_id);\n                parent.nuSetHash(\'proceeded_comments\',\'\');\n                parent.nuAjax(\'aprove_justification_request\',\'foo\');// Έγκριση Αιτήματος\n                parent.nuReloadForm(); // Επαναφόρτωση φόρμας    \n            }\n\n            function decline_request(request_id,current_teacher_id){\n                parent.nuSetHash(\'justification_request_id\',request_id);\n                //parent.nuSetHash(\'current_teacher_id\',current_teacher_id);\n                parent.nuSetHash(\'proceeded_comments\',\'\');\n    \n                parent.nuAjax(\'decline_justification_request\',\'foo\');// Απόρριψη Αιτήματος\n                parent.nuRunPHP(\'show_absence_justification_requests\',\'justification_requests_iframe\'); // Επαναφόρτωση Αιτημάτων\n            }\n\n        </script>\n    </head>\n\n    <body>\";\n\n$sql=\"  select \n            justification_request.id,\n            justification_request.absence_id,\n            justification_request.post_teacher_id,\n            justification_request.justification_request_reason_id,\n            justification_request.comments,\n            DATE_FORMAT(justification_request.added_when,\'%d-%m-%Y %H:%i\'),\n            justification_request.proceeded,\n            justification_request.proceeded_comments,\n            justification_request.proceeded_when,\n            teacher.short_name,\n            justification_request_reason.short_name,\n            if(justification_request.proceeded,\'Ναι\',\'Όχι\')\n        from justification_request\n            left join teacher on justification_request.post_teacher_id=teacher.id\n            inner join justification_request_reason on justification_request.justification_request_reason_id=justification_request_reason.id\n        where \n            absence_id=#RECORD_ID# \n        order by added_when,post_teacher_id\";\n        \n$retval=nuRunQuery($sql);\n\n$pending_requests = 0;\n\nif($retval) {\n    if(db_num_rows($retval)>0) {\n    \n        print (\"\n        <table cellspacing=0 CLASS=\\\"sisTable\\\">\n            <tr height=40>\n                <th width=130 align=center>Ημερομηνία/Ώρα</th>\n                <th width=220 align=center>Καθηγητής</th>\n                <th width=150 align=center>Λόγος Αίτησης</th>\n                <th width=50 align=center>Διεκ/νο</th>\n                <th width=50 align=center>Πλ/ριες</th>\n                <th width=50 align=center>Διαγραφή</th>\");\n        \n        if(\'#nu_user_group#\'==\'Managers\'){        \n            print (\"\n                <th width=50 align=center>Απόρριψη</th>\n                <th width=50 align=center>Έγκριση</th>\");\n        }\n        \n        print (\"\n            </tr>\");\n        \n        while($row = db_fetch_row($retval)) {\n            \n            if(!$row[6]) $pending_requests++;\n            \n            print (\"\n            <tr\".($row[6] ? \"\" : \" style=\\\"background-color:LightGreen;\\\"\").\" height=35>\n                <td align=center>\".$row[5].\"</td>\n                <td align=left>\".(is_null($row[9]) || $row[9]==\'\'? \'&nbsp;\' : $row[9]).\"</td>\n                <td align=left>\".(is_null($row[10]) || $row[10]==\'\'? \'&nbsp;\' : $row[10]).\"</td>\n                <td align=center>\".(is_null($row[11]) || $row[11]==\'\'? \'&nbsp;\' : $row[11]).\"</td>\n                <td align=center title=\\\"Πληροφορίες/Επεξεργασία\\\" onclick=\\\"request_info(\".$row[0].\")\\\" onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\"><img src=\\\"images/info.png\\\"></td>\");\n                \n            $sql=\"select ifnull(teacher_id,-1) from session_variables where session_id=\'#session_id#\' limit 1\";\n            $rv_sv=nuRunQuery($sql);\n        \n            if($rv_sv){\n                if(db_num_rows($rv_sv)>0){\n                    $r=db_fetch_row($rv_sv);\n                    $current_teacher=$r[0];\n                } else {\n                $current_teacher=-1; \n                }\n            } else {\n                $current_teacher=-1;\n            }\n        \n            if(!($row[6])){\n                if($row[2]==$current_teacher){\n                    print (\"\n                <td align=center title=\\\"Διαγραφή Αιτήματος\\\" onclick=\\\"delete_request(\".$row[0].\")\\\" onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\"><img src=\\\"images/d.png\\\"></td>\");\n                } else {\n                    print (\"\n                <td align=center>&nbsp;</td>\");\n                }\n        \n                if(\'#nu_user_group#\'==\'Managers\'){\n                    print (\"\n                <td align=center title=\\\"Απόρριψη Αιτήματος\\\" onclick=\\\"decline_request(\".$row[0].\",\".$current_teacher.\")\\\" onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\"><img src=\\\"images/x.png\\\"></td>\");\n                    print (\"\n                <td align=center title=\\\"Έγκριση Αιτήματος\\\" onclick=\\\"approve_request(\".$row[0].\",\".$current_teacher.\")\\\" onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\"><img src=\\\"images/y.png\\\"></td>\");\n                }\n            } else {\n                print (\"\n                <td align=center>&nbsp;</td>\");\n                if(\'#nu_user_group#\'==\'Managers\'){\n                    print (\"\n                <td align=center>&nbsp;</td>\n                <td align=center>&nbsp;</td>\");\n                }\n            }\n            print (\"\n            </tr>\");\n        }\n        print (\"\n        </table>\");\n    }\n    else{\n        print (\"<span CLASS=\\\"msg\\\">Δεν υπάρχουν αιτήματα διαγραφής!</span>\");\n    }\n}\nelse{\n    print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν δεδομένα...</span>\");\n}\nprint \"\n        <script type=\\\"text/javascript\\\">\n            if (typeof parent.pending_requests === \'function\') {\n                parent.pending_requests($pending_requests);\n            }\n        </script>\n    </body>\n</html>\";\n','','0','2015-03-21 12:58:50','globeadmin','2019-11-05 22:18:43','globeadmin','2020-09-15 12:12:45','globeadmin','0'),('550d5651ba833e2','add_justification_request','Προσθέτει ένα καινούργιο αίτημα δικαιολόγησης απουσίας','teacher','if (\'#absence_id#\'==\'#\'.\'absence_id\'.\'#\' || \'#absence_id#\'==\'\'){\n    $r_id=\'#RECORD_ID#\';\n}  else {\n    $r_id=\'#absence_id#\';\n}\n$sql=\"select count(*) from justification_request where absence_id=\'$r_id\' and post_teacher_id=#teacher_id#\";\n$retval = nuRunQuery($sql);\nif($retval){\n    $row = db_fetch_row($retval);\n    if($row[0]==0){\n        $sql=\"  insert \n                into justification_request (\n                    id,\n                    absence_id,\n                    post_teacher_id,\n                    justification_request_reason_id,\n                    comments,\n                    added_when,\n                    proceeded,\n                    proceeded_teacher_id,\n                    proceeded_comments,\n                    proceeded_when) \n                values(\n                    NULL,\n                    \'$r_id\',\n                    #teacher_id#,\n                    1,\n                    NULL,\n                    NOW(),\n                    0,\n                    NULL,\n                    NULL,\n                    NULL\n                    )\n        \";\n        $id=nuRunQuery($sql,null,true);\n        $nuParameters = $id;\n    } else {\n        $nuError=\'Έχετε ήδη καταχωρίσει ένα αίτημα για την απουσία αυτή! Δεν μπορείτε να καταχωρήσετε δύο αιτήματα για την ίδια απουσία...\';\n        $nuParameters = \'\';\n    }\n} else {\n        $nuParameters = \'\';    \n}\n ','','0','2015-03-21 13:30:25','globeadmin','2016-12-04 19:11:53','globeadmin','2017-09-10 22:38:46','globeadmin','0'),('550db8c2a38fc30','delete_justification_request','Διαγράφει αίτημα δικαιολόγησης απουσίας','teacher','if (\'#justification_request_id#\'!=\'#\'.\'justification_request_id\'.\'#\' && \'#justification_request_id#\'!=\'\'){\n    \n    $sql=\"delete from justification_request where id=#justification_request_id#\";\n    nuRunQuery($sql);\n}','','0','2015-03-21 20:30:26','globeadmin','2015-03-21 20:36:02','globeadmin','2020-09-15 12:20:13','globeadmin',''),('550e7cdc443015a','id_generator','Δημιουργεί ένα νέο id ','admin','$nuParameters=nuID();','','0','2015-03-22 10:27:08','globeadmin','2016-02-09 19:35:08','globeadmin','2016-03-02 18:41:29','globeadmin',''),('55128eb9652ead5','search_teacher_absence','Αναζητά καθηγητής απουσίες με συγκεκριμένα κριτίρια','teacher','print \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n\n        <script type=\\\"text/javascript\\\">\n            function show_absence_info(absence_id){\n                parent.nuOpenFormInFrame(\'5509671b4e81a07\',absence_id)    \n            }\n        </script>\n    </head>\n\n    <body onload=\\\"adjustIframeHeight()\\\">\";\n\n$is_student=0;\n$num_of_justified=0;\n$num_of_an_justified=0;\n$num_of_no_counts=0;\n\n$sql=\"  SELECT \n            absence.id,\n            DATE_FORMAT(absence.absence_date,\'%d-%m-%Y\'),\n            period.short_name,\n            concat(student.surname,\' \',student.name,\' πατ. \',student.fathers_name),\n            absence_reason.short_name,\n            class.short_name,\n            concat(subject.name,\'-\',subject_type.short_name),\n            teacher.short_name,\n            if(absence.justified,\'Ναι\',\'Όχι\'),\n            justified_reason.short_name,\n            if(absence.counts,\'Ναι\',\'Όχι\'),\n            absence_reason.id,\n            EXISTS(SELECT justification_request.id FROM justification_request WHERE justification_request.absence_id=absence.id AND proceeded=0)\n        FROM absence\n            INNER JOIN teacher          ON  absence.post_teacher_id         = teacher.id\n            INNER JOIN student          ON  absence.student_id              = student.id\n            INNER JOIN card             ON  absence.card_id                 = card.id\n            INNER JOIN absence_reason   ON  absence.absence_reason_id       = absence_reason.id\n            LEFT JOIN  justified_reason ON  absence.justified_reason_id     = justified_reason.id\n            INNER JOIN subject          ON  card.subject_id                 = subject.id\n            INNER JOIN class            ON  card.class_id                   = class.id\n            INNER JOIN period           ON  card.period_id                  = period.id\n            LEFT JOIN subject_type      ON  subject.subject_type_id         = subject_type.id\n            \n        WHERE\n\";\n\nif(\'#from_date#\'!=\'#\'.\'from_date#\' && \'#from_date#\'!=\'\'){\n    $sql=$sql.\" absence.absence_date >= \'#from_date#\' and \n    \";\n}\nif(\'#to_date#\'!=\'#\'.\'to_date#\' && \'#to_date#\'!=\'\'){\n    $sql=$sql.\" absence.absence_date <= \'#to_date#\' and \n    \";\n}\nif(\'#period_id_sumo#\'!=\'#\'.\'period_id_sumo#\' && \'#period_id_sumo#\'!=\'\'){\n    $sql=$sql.\" period.id IN (#period_id_sumo#) and \n    \";\n}\nif(\'#justified#\'!=\'#\'.\'justified#\' && \'#justified#\'!=\'\'){\n    $sql=$sql.\" absence.justified = \'#justified#\' and \n    \";\n}\nif(\'#counts#\'!=\'#\'.\'counts#\' && \'#counts#\'!=\'\'){\n    $sql=$sql.\" absence.counts = \'#counts#\' and \n    \";\n}\nif(\'#justified_reason_id_sumo#\'!=\'#\'.\'justified_reason_id_sumo#\' && \'#justified_reason_id_sumo#\'!=\'\'){\n    $sql=$sql.\" absence.justified_reason_id IN (#justified_reason_id_sumo#) and \n    \";\n}\n\nif(\'#class_id_sumo#\'!=\'#\'.\'class_id_sumo#\' && \'#class_id_sumo#\'!=\'\'){\n    $sql=$sql.\" class.id IN (#class_id_sumo#) and \n    \";\n}\nif(\'#subject_id_sumo#\'!=\'#\'.\'subject_id_sumo#\' && \'#subject_id_sumo#\'!=\'\'){\n    $sql=$sql.\" subject.id IN (#subject_id_sumo#) and \n    \";\n}\nif(\'#student_id_sumo#\'!=\'#\'.\'student_id_sumo#\' && \'#student_id_sumo#\'!=\'\'){\n    $sql=$sql.\" student.id IN (#student_id_sumo#) and \n    \";\n    $is_student=1;\n}\nif(\'#absence_teacher_id_sumo#\'!=\'#\'.\'absence_teacher_id_sumo#\' && \'#absence_teacher_id_sumo#\'!=\'\'){\n    $sql=$sql.\" teacher.id IN (#absence_teacher_id_sumo#) and \n    \";\n}\nif(\'#hide_has_left_school#\'!=\'#\'.\'hide_has_left_school#\' && \'#hide_has_left_school#\'!=\'\'){\n    $sql=$sql.\" student.has_left_school = 0 and \n    \";\n}\n$sql=$sql.\"\n    1=1\n    order by absence.absence_date,period.id,student.surname,student.name,student.fathers_name\n\";\n       \n$retval=nuRunQuery($sql);\n\nif($retval) {\n    if(db_num_rows($retval)>0) {\n    \n        print (\"\n        <table cellspacing=0 CLASS=\\\"sisTable\\\">\n            <tr height=45>\n                <th width=70 align=center>Ημερομηνία</th>\n                <th width=40 align=center>Ώρα</th>\n                <th width=200 align=center>Μαθητής</th>\n                <th width=40 align=center>Λόγος Απουσίας</th>\n                <th width=50 align=center>Τμήμα</th>\n                <th width=100 align=center>Μάθημα</th>\n                <th width=120 align=center>Καταχωρητής</th>\n                <th width=50 align=center>Δικ/μενη</th>\n                <th width=100 align=center>Δικαιολόγηση ή Διαγραφή</th>\n                <th width=50 align=center>Μετράει</th>\n                <th width=50 align=center>Πληρ/ρίες</th>\");\n                \n        if(\'#nu_user_group#\' != \'Parents\' && \'#nu_user_group#\' != \'Students\'){\n            print (\"\n                <th width=60 align=center>\n                    <b>Επιλογή</b><br>\n                    Όλα<input type=\\\"checkbox\\\" id=\\\"all_chk_1\\\" title=\\\"Επιλογή Όλων\\\" onclick=\\\"toggle(this,\'chk_1\')\\\">\n                </th>\");        \n        }\n        \n        print (\"\n            </tr>\");\n        \n        $color_justified        = \'#ade6ad\';\n        $color_not_justified    = \'LightBlue\';\n        $color_deleted          = \'LightGreen\';\n        $color_penalty          = \'OrangeRed\';\n        $color_request_pending  = \'#00e6e6\';\n        \n        $color=$color_not_justified;\n    \n        while($row = db_fetch_row($retval)) {\n    \n            if($row[10]==\'Ναι\'){\n                if($row[8]==\'Ναι\'){\n                    $num_of_justified++;\n                    $color=$color_justified;\n                } else {\n                    if($row[12]==\'1\'){\n                        $color=$color_request_pending;    \n                    } else {\n                        if($row[11]==\'1\'){\n                            $color=$color_not_justified;    \n                        } else {\n                            $color=$color_penalty;    \n                        }                        \n                    }\n                    $num_of_an_justified++;\n                    \n                }\n            } else {\n                $num_of_no_counts++;\n                $color=$color_deleted;\n            }            \n    \n            print (\"\n            <tr style=\\\"background-color:$color;\\\" height=35>\n                <td align=center>\".(is_null($row[1]) || $row[1]==\'\'? \'&nbsp;\' : $row[1]).\"</td>\n                <td align=center>\".(is_null($row[2]) || $row[2]==\'\'? \'&nbsp;\' : $row[2]).\"</td>\n                <td align=left>\".(is_null($row[3]) || $row[3]==\'\'? \'&nbsp;\' : $row[3]).\"</td>\n                <td align=center>\".(is_null($row[4]) || $row[4]==\'\'? \'&nbsp;\' : $row[4]).\"</td>\n                <td align=center>\".(is_null($row[5]) || $row[5]==\'\'? \'&nbsp;\' : $row[5]).\"</td>\n                <td align=left>\".(is_null($row[6]) || $row[6]==\'\'? \'&nbsp;\' : $row[6]).\"</td>\n                <td align=left>\".(is_null($row[7]) || $row[7]==\'\'? \'&nbsp;\' : $row[7]).\"</td>\n                <td align=center>\".(is_null($row[8]) || $row[8]==\'\'? \'&nbsp;\' : $row[8]).\"</td>\n                <td align=left>\".(is_null($row[9]) || $row[9]==\'\'? \'&nbsp;\' : $row[9]).\"</td>\n                <td align=center>\".(is_null($row[10]) || $row[10]==\'\'? \'&nbsp;\' : $row[10]).\"</td>\n                <td align=center title=\\\"Πληροφορίες/Επεξεργασία\\\" onclick=\\\"show_absence_info(\".$row[0].\")\\\" onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\">\n                    <img width=16 height=16 src=\\\"images/info.png\\\">\n                </td>\");\n            if(\'#nu_user_group#\' != \'Parents\' && \'#nu_user_group#\' != \'Students\'){\n                print (\"\n                <td align=center>\n                    \".($row[10]==\'Ναι\' ? \"<input type=\\\"checkbox\\\" CLASS=\\\"chk_1\\\" id=\\\"\".$row[0].\"\\\" title=\\\"Επιλογή Απουσίας\\\" onclick=\\\"make_indeterminate(\'all_chk_1\')\\\">\" : \"&nbsp;\").\"\n                </td>\");        \n            }\n            print (\"\n            </tr>\");\n        }\n       \n        $colspan = (\'#nu_user_group#\' != \'Parents\' && \'#nu_user_group#\' != \'Students\' ? \'2\' : \'1\');\n        \n        if($is_student==1){\n            print(\"\n            <tr height=25>\n                <th align=right colspan=10>Σύνολο Διαγραμμένων : </th>\n                <th align=center colspan=$colspan>$num_of_no_counts</th>\n            </tr>\n            <tr height=25>\n                <th align=right colspan=10>Σύνολο Μετρήσιμων Δικαιολογημένων : </th>\n                <th align=center colspan=$colspan>$num_of_justified</th>\n            </tr>\n            <tr height=25>\n                <th align=right colspan=10>Σύνολο Αδικαιολόγητών : </th>\n                <th align=center colspan=$colspan>$num_of_an_justified</th>\n            </tr>\n            <tr height=25>\n                <th align=right colspan=10>Σύνολο : </th>\n                <th align=center colspan=$colspan>\".($num_of_justified+$num_of_an_justified).\"</th>\n            </tr>\");\n        }\n        \n        print (\"\n        </table>\");\n\n        print (\"\n        <br>\n        <table border=0 cellspacing=0 cellpadding=6 CLASS=\\\"sisTable\\\" align=center>\n            <tr>\n                <td bgcolor=\\\"$color_not_justified\\\" align=center>Αδικαιολόγητη</td>\n                <td bgcolor=\\\"$color_penalty\\\" align=center>Λόγω Ποινής</td>\n                <td bgcolor=\\\"$color_request_pending\\\">Αδικαιολόγητη με Αίτημα Διαγραφής</td>\n                <td bgcolor=\\\"$color_justified\\\" align=center>Δικαιολογημένη Μετρήσιμη</td>\n                <td bgcolor=\\\"$color_deleted\\\" align=center>Διαγραμμένη</td>\n            </tr>\n        </table>\");\n    }\n    else{\n        print (\"<span CLASS=\\\"msg\\\">Δε βρέθηκαν απουσίες...</span>\");\n    }\n}\nelse{\n    print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν δεδομένα...</span>\");\n}\nprint \"\n    </body>\n</html>\";\n','','0','2015-03-25 12:32:25','globeadmin','2018-08-04 21:06:18','globeadmin','2022-02-11 21:38:02','globeadmin','0'),('5515ac288fe7f65','decline_justification_request','Απορρίπτει ένα αίτημα δικαιολόγησης απουσίας','manager','$sql=\"select ifnull(teacher_id,-1) from session_variables where session_id=\'#session_id#\' limit 1\";\n$rv_sv=nuRunQuery($sql);\n        \nif($rv_sv){\n    if(db_num_rows($rv_sv)>0){\n        $r=db_fetch_row($rv_sv);\n        $current_teacher=$r[0];\n    } else {\n        $current_teacher=-1; \n    }\n} else {\n    $current_teacher=-1;\n}\n\n$sql=\"  UPDATE \n        justification_request set \n            proceeded=1,\n            proceeded_teacher_id=\".$current_teacher.\",\n            proceeded_comments=\'#proceeded_comments#\',\n            proceeded_when=NOW()\n        WHERE\n            id=#justification_request_id#\n            \";\nnuRunQuery($sql);','','0','2015-03-27 21:14:48','globeadmin','2015-03-27 21:42:33','globeadmin','2016-03-02 18:35:52','globeadmin',''),('5516d2815e269ce','aprove_justification_request','Εγκρίνει ένα αίτημα δικαιολόγησης απουσίας','manager','nuRunPHP(\'notification_add_lib\');\n\n$sql=\"  select ifnull(teacher_id,-1), justification_request.absence_id\n        from session_variables \n        INNER JOIN justification_request ON justification_request.id=\'#justification_request_id#\'\n        where \n        session_id=\'#session_id#\' limit 1\";\n$rv_sv=nuRunQuery($sql);\n        \nif($rv_sv){\n    if(db_num_rows($rv_sv)>0){\n        $r=db_fetch_row($rv_sv);\n        $current_teacher=$r[0];\n        $absence_id = $r[1];\n    } else {\n        $current_teacher=-1; \n    }\n} else {\n    $current_teacher=-1;\n    $absence_id = -1;\n}\n\n$sql=\"  UPDATE \n        justification_request,absence,justified_reason\n        set \n            justification_request.proceeded=1,\n            justification_request.proceeded_teacher_id=\".$current_teacher.\",\n            justification_request.proceeded_comments=if(\'#proceeded_comments#\'=\'\',justification_request.proceeded_comments,\'#proceeded_comments#\'),\n            justification_request.proceeded_when=NOW(),\n            absence.justified=1,\n            absence.justified_when=NOW(),\n            absence.counts=justified_reason.counts,\n            absence.justified_teacher_id=\".$current_teacher.\",\n            absence.justified_comments=if(\'#proceeded_comments#\'=\'\',justification_request.proceeded_comments,\'#proceeded_comments#\'),\n            absence.justified_reason_id=3\n        WHERE\n            justified_reason.id=3 and \n            justification_request.id=#justification_request_id# and\n            justification_request.absence_id=absence.id\n            \";\nnuRunQuery($sql);\n\nif($absence_id != -1){\n    delete_absence_notification($absence_id);   \n}\n\n\n','','0','2015-03-28 18:10:41','globeadmin','2016-12-04 21:36:30','globeadmin','2021-04-12 19:23:38','globeadmin','0'),('55183736b84eee4','absence_student_google_chart','Δημιουργεί γράφημα με τις απουσίες του μαθητή ανά μήνα','student','ob_start();\nprint \'hi\';\n\n$sql=\"  select prev_an_justified_absences,prev_justified_absences\n        from student\n        where id=#RECORD_ID#\";\n$rv = nuRunQuery($sql);\n$row = db_fetch_row($rv);\n$prev_an_justified_absences = $row[0];\n$prev_justified_absences = $row[1];\n\n$sql=\"  select \n            school_year.start_date,\n            school_year.end_date,\n            school.absence_anjustified_limit,\n            school.absence_total_limit\n        from school_year\n        inner join school on school_year.id=school.school_year_id\n    \";\n$rv = nuRunQuery($sql);\n$row = db_fetch_row($rv);\n$starting_date = $row[0];\n$ending_date = $row[1];\n$curdate = date(\"Y-m-d\");\n$absence_anjustified_limit = $row[2];\n$absence_total_limit = $row[3];\n\n$start    = new DateTime($starting_date);\n$start->modify(\'first day of this month\');\n$end      = new DateTime(($curdate>$ending_date ? $ending_date : $curdate));\n$end->modify(\'first day of next month\');\n$interval = DateInterval::createFromDateString(\'1 month\');\n$period   = new DatePeriod($start, $interval, $end);\n\n$months = array();\n\nforeach ($period as $dt) {\n    $start_month_date = $dt->format(\"Y-m-d\");\n    \n    $dt->modify(\'last day of this month\');\n    $end_month_date = $dt->format(\"Y-m-d\");\n    \n    $month_name = $dt->format(\"M\");\n    \n    $months[] = array($start_month_date,$end_month_date,$month_name);\n}\n\n$chart_data   = array();\n\nforeach ($months as $month) {\n\n    $sql = \"    \n            select count(*) \n            from absence \n            where \n                student_id=#RECORD_ID# and\n                counts=1 and\n                absence_date between \'\".$starting_date.\"\' and \'\".$month[1].\"\'\";\n                \n    $rv = nuRunQuery($sql);\n    $row = db_fetch_row($rv);\n    $counts_absences=$row[0];\n    $counts_absences += $prev_an_justified_absences+$prev_justified_absences;\n    \n    $sql = \"    \n            select count(*) \n            from absence \n            where \n                student_id=#RECORD_ID# and\n                counts=0 and\n                absence_date between \'\".$starting_date.\"\' and \'\".$month[1].\"\'\";\n    $rv = nuRunQuery($sql);\n    $row = db_fetch_row($rv);\n    $deleted_absences=$row[0];\n    \n    $chart_data[] = \"[\\\"\".$month[2].\"\\\",$counts_absences,$deleted_absences,$absence_total_limit]\";\n\n}\n\n$js_string = implode(\',\', $chart_data);\n \n$gg = \"\n \n<html>\n  <head>\n    <script type=\'text/javascript\' src=\'https://www.google.com/jsapi\'></script>\n    <script type=\'text/javascript\'>\n	\n	google.load(\'visualization\', \'1\', {packages: [\'corechart\', \'line\']});\n	google.setOnLoadCallback(drawAxisTickColors);\n	\n	function drawAxisTickColors() {\n        \n      \n	  var data = new google.visualization.DataTable();\n      data.addColumn(\'string\', \'X\');\n      data.addColumn(\'number\', \'\\u03A3\\u03CD\\u03BD\\u03BF\\u03BB\\u03BF\');\n	  data.addColumn(\'number\', \'\\u0394\\u03B9\\u03B1\\u03B3\\u03C1\\u03B1\\u03BC\\u03BC\\u03AD\\u03BD\\u03B5\\u03C2\');\n	  data.addColumn(\'number\', \'\\u038C\\u03C1\\u03B9\\u03BF \\u03A3\\u03C5\\u03BD\\u03CC\\u03BB\\u03BF\\u03C5\');\n\n      data.addRows([\n      \n        \".$js_string.\" \n        \n      ]);\n\n      var options = {\n        hAxis: {\n          title: \'\',\n          textStyle: {\n            color: \'#01579b\',\n            fontSize: 14,\n            bold: true,\n            italic: true\n          },\n          titleTextStyle: {\n            color: \'#01579b\',\n            fontSize: 14,\n            bold: true,\n            italic: true\n          }\n        },\n        vAxis: {\n          title: \'\',\n          textStyle: {\n            color: \'#1a237e\',\n            fontSize: 14,\n            bold: true\n          },\n          titleTextStyle: {\n            color: \'#1a237e\',\n            fontSize: 14,\n            bold: true\n          }\n        },\n        colors: [\'#ff0000\',\'#00aa00\',\'#880000\'],\n        backgroundColor: \'#FAF0E6\',\n        lineWidth: 2,\n        series: {\n            2: { lineDashStyle: [4, 4] }\n          }\n      };\n      var chart = new google.visualization.LineChart(document.getElementById(\'chart_div\'));\n      chart.draw(data, options);\n      }\n    </script>\n  </head>\n  <body>\n    <div id=\'chart_div\' style=\'width: 950px; height: 330px;\'></div>\n  </body>\n</html>\n \n\";\n \nob_end_clean();\necho $gg; \n','','0','2015-03-29 20:32:38','globeadmin','2021-03-24 11:35:05','globeadmin','2021-03-24 11:35:05','globeadmin','0'),('5adc50f42d58755','check_publish_calendar_event','Ελέγχει για επικαλύψεις συμβάντων πριν την κοινοποίηση ','Teachers','function find_names($ids, $teachers=true){\n    \n    $names = array();\n\n    if(count($ids)>0){\n        $ids_str = implode(\",\",$ids);\n        \n        if($teachers){\n            $sql=\"  SELECT ifNULL(surname,\'\') as surname,if(name is NULL,\'\',LEFT(name, 3)) as name, \'\' as grade_name\n                    FROM teacher\n                    WHERE id in ($ids_str)\n                    ORDER BY surname,name\";\n        } else {\n            $sql=\"  SELECT ifNULL(student.surname,\'\') as surname,if(student.name is NULL,\'\',LEFT(student.name, 3)) as name, if(grade.short_name IS NULL,\'\', CONCAT(\'(\',grade.short_name,\')\')) as grade_name\n                    FROM student\n                    INNER JOIN grade ON grade.id = student.grade_id\n                    WHERE student.id in ($ids_str)\n                    ORDER BY student.grade_id,student.surname,student.name\";\n        }\n            \n        $retval = nuRunQuery($sql);\n    \n        while($o = db_fetch_object($retval)){  \n            $names[] = $o->surname.\" \".$o->name.\" \".$o->grade_name;\n        }\n    }\n    \n    return (implode(\", \", $names));\n}\n\nfunction find_teachers($start,$finish){ //βρίσκει τους καθηγητές που έχουν ήδη συμβάν ημερολογίου παράλληλα με και εκτός το τρέχον συμβάν\n    \n    $ids = array();\n    \n    $sql=\"  SELECT *\n            FROM #TABLE_ID#\n            WHERE (user_group_id IS NULL) OR user_group_id NOT IN (\'547de4c65675a29\',\'5717ba3eb32c252\', \'999999999999999\')\";\n    $retval = nuRunQuery($sql);\n    \n    while($o = db_fetch_object($retval)){\n        if(!is_null($o->teacher_id)){\n            $ids[] = $o->teacher_id;    \n        } else {\n            $sql=\"  SELECT id\n                    FROM teacher\n                    INNER JOIN zzzsys_user ON zzzsys_user.zzzsys_user_id = teacher.user_id\n                    WHERE zzzsys_user.sus_zzzsys_user_group_id = \'{$o->user_group_id}\'\n                \";\n            $rv = nuRunQuery($sql);\n            while($r = db_fetch_row($rv)){\n                $ids[] = $r[0];   \n            }    \n        }\n    }\n    \n    $sql=\"  SELECT DISTINCT teacher_id\n            FROM calendar_event \n            WHERE \n                (CONCAT(start_date,\' \',IF(allDay=1,\'00:00:00\',start_time)) < \'$finish\' AND \n                CONCAT(end_date,\' \',IF(allDay=1,\'23:59:59\',end_time)) > \'$start\') AND\n                id <> \'#RECORD_ID#\' AND\n                is_ballot = 0\n        \";\n    nuRunQuery($sql);    \n    $rv = nuRunQuery($sql);\n    while($r = db_fetch_row($rv)){\n        $ids[] = $r[0];   \n    }\n    \n    return $ids;\n}\n\nfunction find_students($parents=false){\n    \n    $ids = array();\n    \n    $sql=\"  SELECT *\n            FROM #TABLE_ID#\n            WHERE user_group_id =\'\".($parents ? \"5717ba3eb32c252\" : \"547de4c65675a29\").\"\'\";\n    $retval = nuRunQuery($sql);\n    \n    while($o = db_fetch_object($retval)){\n        if(!is_null($o->class_id)){\n            $sql = \"SELECT student_id FROM student_class WHERE class_id=\'{$o->class_id}\'\";\n        } else {\n            $sql = \"SELECT id FROM student WHERE \".(!is_null($o->student_id) ? \"id=\'{$o->student_id}\'\" : (!is_null($o->grade_id) ? \"grade_id=\'{$o->grade_id}\'\" : \"1\"));\n        }\n            \n        $rv = nuRunQuery($sql);\n        while($r = db_fetch_row($rv)){\n            $ids[] = $r[0];   \n        }\n    }\n    return $ids;\n}\n\n$nuParameters = \'-1\';\n\nif (\'#selection1#\' == \'#\'.\'selection1\'.\'#\' || \'#selection1#\' == \'\') {\n    $nuError = \"Προσοχή: Επιλέξτε πρώτα σε ποιους θα γίνει η κοινοποίηση!\";    \n} else {\n\n    $sql=\"  SELECT \n                CONCAT(start_date,\' \',IF(allDay=1,\'00:00:00\',start_time))  as start,\n                CONCAT(end_date,\' \',IF(allDay=1,\'23:59:59\',end_time))    as finish\n            FROM calendar_event\n            WHERE id=\'#RECORD_ID#\'\";\n    $retval = nuRunQuery($sql);\n    $o = db_fetch_object($retval);\n    \n    $start  = $o->start;\n    $finish = $o->finish;\n  \n    $sql=\"  CREATE TEMPORARY TABLE IF NOT EXISTS #TABLE_ID# AS\n            (SELECT  \n                    calendar_event_access.id            AS id,\n                    calendar_event_access.teacher_id    AS teacher_id,\n                    calendar_event_access.student_id    AS student_id,\n                    calendar_event_access.grade_id      AS grade_id,\n                    calendar_event_access.class_id      AS class_id,\n                    calendar_event_access.user_group_id AS user_group_id\n            FROM calendar_event_access \n            INNER JOIN calendar_event ON calendar_event.id = calendar_event_access.calendar_event_id\n            WHERE \n                (CONCAT(calendar_event.start_date,\' \',IF(calendar_event.allDay=1,\'00:00:00\',calendar_event.start_time)) < \'$finish\' AND \n                CONCAT(calendar_event.end_date,\' \',IF(calendar_event.allDay=1,\'23:59:59\',calendar_event.end_time)) > \'$start\') AND\n                calendar_event.id <> \'#RECORD_ID#\' AND\n                calendar_event.is_ballot = 0)\n    \";\n    nuRunQuery($sql);\n\n    $t_ids = find_teachers($start,$finish);\n    $s_ids = find_students(false);\n    $p_ids = find_students(true);\n\n    $teachers_names = \"\";\n    $students_names = \"\";\n    $parents_names = \"\";\n\n    if (\'#selection1#\' == \'0\') {\n        $teachers_names = find_names($t_ids,true);\n        $students_names = find_names($s_ids,false);\n        $parents_names = find_names($p_ids,false);\n    } elseif (\'#selection1#\' == \'1\') {\n        $ids = array();\n        $sql=\"  SELECT id\n                FROM teacher\n                INNER JOIN zzzsys_user ON zzzsys_user.zzzsys_user_id = teacher.user_id\n                WHERE zzzsys_user.sus_zzzsys_user_group_id IN (\'547de466910d843\',\'547de49454047c6\',\'5601b00712ca90c\',\'568946b83ec3baa\')\n            \";\n        $rv = nuRunQuery($sql);\n        while($r = db_fetch_row($rv)){\n            $ids[] = $r[0];   \n        }\n    \n        $teachers_names = find_names(array_intersect($t_ids,$ids),true);\n    \n    } elseif (\'#selection1#\' == \'2\') {\n        $ids = array();\n        $sql=\"  SELECT id\n                FROM teacher\n                INNER JOIN zzzsys_user ON zzzsys_user.zzzsys_user_id = teacher.user_id\n                WHERE zzzsys_user.sus_zzzsys_user_group_id IN (\'547de466910d843\',\'547de49454047c6\',\'5601b00712ca90c\',\'568946b83ec3baa\',\'547de4b10fa7616\',\'60475b01603a277\')\n            \";\n        $rv = nuRunQuery($sql);\n        while($r = db_fetch_row($rv)){\n            $ids[] = $r[0];   \n        }\n    \n        $teachers_names = find_names(array_intersect($t_ids,$ids),true);\n    \n    } elseif (\'#selection1#\' == \'3\') {\n        if(\'#teacher_id_select_sumo#\'!=\'#\'.\'teacher_id_select_sumo#\' && \'#teacher_id_select_sumo#\'!=\'\'){\n    \n            $ids = explode(\",\", \"#teacher_id_select_sumo#\");\n        \n            $teachers_names = find_names(array_intersect($t_ids,$ids),true);\n\n        } else {\n            $nuError = \"Προσοχή: Επιλέξτε πρώτα καθηγητές!\";     \n        }\n    } elseif (\'#selection1#\' == \'8\') {\n        $nuParameters = \'0\';\n    } elseif (\'#selection1#\' == \'4\' || \'#selection1#\' == \'5\' || \'#selection1#\' == \'6\' || \'#selection1#\' == \'7\') {\n    \n        if( \'#students_check_hash#\'==\'#\'.\'students_check_hash#\' || \'#students_check_hash#\'==\'\' || \n            \'#parents_check_hash#\'==\'#\'.\'parents_check_hash#\' || \'#parents_check_hash#\'==\'\' || \n            (\'#students_check_hash#\'==\'0\' && \'#parents_check_hash#\'==\'0\')){\n            $nuError = \"Προσοχή: Επιλέξτε πρώτα αν η κοινοποίηση θα γίνει «σε Μαθητές» ή και «σε Γονείς»!!\"; \n        } else {\n            if (\'#selection1#\' == \'4\'){\n                $sql=\"SELECT id FROM student WHERE 1\";\n            } elseif (\'#selection1#\' == \'5\') {\n                if(\'#grade_id_select_sumo#\'!=\'#\'.\'grade_id_select_sumo#\' && \'#grade_id_select_sumo#\'!=\'\'){\n                    $sql=\"SELECT id FROM student WHERE grade_id IN (#grade_id_select_sumo#)\";\n                } else {\n                    $nuError = \"Προσοχή: Επιλέξτε πρώτα τάξεις!\";\n                    $sql=\"\";\n                }    \n            } elseif (\'#selection1#\' == \'6\') {\n                if(\'#class_id_select_sumo#\'!=\'#\'.\'class_id_select_sumo#\' && \'#class_id_select_sumo#\'!=\'\'){\n                    $sql = \"SELECT student_id FROM student_class WHERE class_id IN (#class_id_select_sumo#)\";\n                } else {\n                    $nuError = \"Προσοχή: Επιλέξτε πρώτα τμήματα!\";\n                    $sql=\"\";\n                }     \n            } elseif (\'#selection1#\' == \'7\') {\n                if(\'#student_id_select_sumo#\'!=\'#\'.\'student_id_select_sumo#\' && \'#student_id_select_sumo#\'!=\'\'){\n                    $sql=\"SELECT id FROM student WHERE id IN (#student_id_select_sumo#)\";\n                } else {\n                    $nuError = \"Προσοχή: Επιλέξτε πρώτα μαθητές!\";\n                    $sql=\"\";\n                }\n            }\n            \n            if($sql!=\"\"){\n                if(\'#students_check_hash#\'==\'1\'){\n                    $ids = array();\n                    $rv = nuRunQuery($sql);\n                    while($r = db_fetch_row($rv)){\n                        $ids[] = $r[0];   \n                    }\n                    $students_names = find_names(array_intersect($s_ids,$ids),false);\n                }\n                if(\'#parents_check_hash#\'==\'1\'){\n                    $ids = array();\n                    $rv = nuRunQuery($sql);\n                    while($r = db_fetch_row($rv)){\n                        $ids[] = $r[0];   \n                    }\n                    $parents_names = find_names(array_intersect($p_ids,$ids),false);                \n                }        \n            }\n        }\n    } \n\n    $nuParameters = $teachers_names!=\"\" || $students_names!=\"\" || $parents_names!=\"\" ? \"<b>Οι παρακάτω συμμετέχουν ήδη σε συμβάν ημερολογίου κατά το συγκεκριμένο χρονικό διάστημα:</b>\" : \"0\";\n    $nuParameters .= $teachers_names==\"\" ? \"\" : \"\\n<b><u>ΚΑΘΗΓΗΤΕΣ</u> : </b> \".$teachers_names;\n    $nuParameters .= $students_names==\"\" ? \"\" : \"\\n<b><u>ΜΑΘΗΤΕΣ</u> : </b> \".$students_names;\n    $nuParameters .= $parents_names==\"\"  ? \"\" : \"\\n<b><u>ΓΟΝΕΙΣ</u> : </b> \".$parents_names;\n}\n','','0','2018-04-22 12:08:04','globeadmin','2021-03-09 14:06:31','globeadmin','2021-10-09 22:54:50','globeadmin','0'),('551a39550972489','search_absence_justification_requests','Αναζήτηση αιτημάτων διαγραφής','sisyphos','function is_other_teacher(\n            $request_id,\n            $absence_id,\n            $card_id,\n            $class_id,\n            $request_post_teacher_id,\n            $absence_post_teacher_id,\n            $card_teacher_id,\n            $class_post_teacher_id){\n            \n    if( $request_post_teacher_id == $absence_post_teacher_id || \n        $request_post_teacher_id == $card_teacher_id){ //||\n        //$request_post_teacher_id == $class_post_teacher_id){\n        return false;    \n    } else {\n        $sql = \"SELECT c1.teacher_id\n                FROM card AS c1\n                INNER JOIN card AS c2 ON c2.id = \'$card_id,\'\n                WHERE\n                    c1.valid_from   = c2.valid_from AND\n                    c1.day_id       = c2.day_id AND\n                    c1.period_id    = c2.period_id AND\n                    c1.class_id     = c2.class_id\n                \";\n        $rv=nuRunQuery($sql);\n        while($r = db_fetch_row($rv)) {\n            if($request_post_teacher_id == $r[0]){\n                return false;    \n            }\n        }\n    }\n    return true;\n}\n\nprint \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n        \n        <script type=\\\"text/javascript\\\">\n\n            function show_absence_info(absence_id){\n                parent.nuOpenFormInFrame(\'5509671b4e81a07\',absence_id)    \n            }\n\n            function request_info(request_id){\n                parent.nuOpenFormInFrame(\'550dbae55f33b5f\',request_id);   \n            }\n\n            function delete_request(request_id) {\n                parent.nuSetHash(\'justification_request_id\',request_id);\n                parent.nuAjax(\'delete_justification_request\',\'foo\');// Διαγραφή Αιτήματος\n                parent.nuRunPHP(\'search_absence_justification_requests\',\'justification_requests_iframe\'); // Επαναφόρτωση Αιτημάτων\n            }\n\n            function approve_request(request_id,current_teacher_id){\n                parent.nuSetHash(\'justification_request_id\',request_id);\n                //parent.nuSetHash(\'current_teacher_id\',current_teacher_id);\n                parent.nuSetHash(\'proceeded_comments\',\'\');\n    \n                parent.nuAjax(\'aprove_justification_request\',\'foo\');// Έγκριση Αιτήματος\n                parent.nuRunPHP(\'search_absence_justification_requests\',\'justification_requests_iframe\'); // Επαναφόρτωση Αιτημάτων\n            }\n\n            function decline_request(request_id,current_teacher_id){\n                parent.nuSetHash(\'justification_request_id\',request_id);\n                //parent.nuSetHash(\'current_teacher_id\',current_teacher_id);\n                parent.nuSetHash(\'proceeded_comments\',\'\');\n    \n                parent.nuAjax(\'decline_justification_request\',\'foo\');// Απόρριψη Αιτήματος\n                parent.nuRunPHP(\'search_absence_justification_requests\',\'justification_requests_iframe\'); // Επαναφόρτωση Αιτημάτων\n            }\n\n        </script>\n\n        <STYLE TYPE=\\\"text/css\\\">\n            .sisTable TD{\n                font-size:7pt;\n            }\n        </STYLE>\n    </head>\n\n    <body onload=\\\"adjustIframeHeight()\\\">\";\n\n$sql=\"  SELECT \n            justification_request.id,\n            justification_request.absence_id,\n            justification_request.post_teacher_id,\n            justification_request.justification_request_reason_id,\n            justification_request.comments,\n            DATE_FORMAT(justification_request.added_when,\'%d-%m-%Y %H:%i\'),\n            justification_request.proceeded,\n            justification_request.proceeded_comments,\n            justification_request.proceeded_when,\n            t1.short_name,\n            justification_request_reason.short_name,\n            if(justification_request.proceeded,\'Ναι\',\'Όχι\'),\n            \n            DATE_FORMAT(absence.absence_date,\'%d-%m-%Y\'),\n            period.short_name,\n            concat(student.surname,\' \',student.name,\' πατ. \',student.fathers_name),\n            absence_reason.short_name,\n            class.short_name,\n            concat(subject.name,\'-\',subject_type.short_name),\n            t2.short_name,\n            if(absence.justified,\'Ναι\',\'Όχι\'),\n            justified_reason.short_name,\n            if(absence.counts,\'Ναι\',\'Όχι\'),\n            \n            absence.post_teacher_id,\n            card.id,\n            card.teacher_id,\n            class.id,\n            ifNULL(class.post_teacher_id,\'-1\'),\n            t3.short_name,\n            absence_reason.id\n        FROM justification_request\n            LEFT JOIN   teacher as t1                ON  justification_request.post_teacher_id                   = t1.id\n            INNER JOIN  justification_request_reason ON  justification_request.justification_request_reason_id   = justification_request_reason.id\n            INNER JOIN  absence                      ON  justification_request.absence_id                        = absence.id\n            INNER JOIN  teacher as t2                ON  absence.post_teacher_id                                 = t2.id\n            INNER JOIN  student                      ON  absence.student_id                                      = student.id\n            INNER JOIN  card                         ON  absence.card_id                                         = card.id\n            INNER JOIN  absence_reason               ON  absence.absence_reason_id                               = absence_reason.id\n            LEFT JOIN   justified_reason             ON  absence.justified_reason_id                             = justified_reason.id\n            INNER JOIN  subject                      ON  card.subject_id                                         = subject.id\n            INNER JOIN  class                        ON  card.class_id                                           = class.id\n            INNER JOIN  period                       ON  card.period_id                                          = period.id\n            INNER JOIN  teacher as t3                ON  card.teacher_id                                         = t3.id\n            LEFT JOIN  subject_type                  ON  subject.subject_type_id                                 = subject_type.id\n        WHERE\n\";\n\nif(\'#from_date#\'!=\'#\'.\'from_date#\' && \'#from_date#\'!=\'\'){\n    $sql=$sql.\" absence.absence_date >= \'#from_date#\' and \n    \";\n}\nif(\'#to_date#\'!=\'#\'.\'to_date#\' && \'#to_date#\'!=\'\'){\n    $sql=$sql.\" absence.absence_date <= \'#to_date#\' and \n    \";\n}\nif(\'#proceeded#\'!=\'#\'.\'proceeded#\' && \'#proceeded#\'!=\'\'){\n    $sql=$sql.\" justification_request.proceeded = \'#proceeded#\' and \n    \";\n}\n\nif(\'#request_teacher_id#\'!=\'#\'.\'request_teacher_id#\' && \'#request_teacher_id#\'!=\'\'){\n    $sql=$sql.\" justification_request.post_teacher_id = \'#request_teacher_id#\' and \n    \";\n}\n\nif(\'#justification_request_reason_id_sumo#\'!=\'#\'.\'justification_request_reason_id_sumo#\' && \'#justification_request_reason_id_sumo#\'!=\'\'){\n    $sql=$sql.\" justification_request.justification_request_reason_id IN (#justification_request_reason_id_sumo#) and \n    \";\n}\n\n$sql=$sql.\"\n    1=1\n    order by absence.absence_date,period.id,student.surname,student.name,student.fathers_name\n\";\n\n$retval=nuRunQuery($sql);\n\nif($retval) {\n    if(db_num_rows($retval)>0) {\n    \n        print (\"\n        <table cellspacing=0 CLASS=\\\"sisTable\\\">\n            <tr height=40>\n                <th style=\\\"background-color:Salmon;\\\" align=center colspan=\".(\'#nu_user_group#\'==\'Managers\'? \"7\" : \"5\").\">Αίτημα Διαγραφής</th>\n                <th align=center colspan=8>Στοιχεία Απουσίας</th>\n            </tr>\");\n\n        print (\"\n            <tr height=40>\n                <th style=\\\"background-color:Salmon;\\\" width=100 align=center>Ημερομηνία/Ώρα Αιτήματος</th>\n                <th style=\\\"background-color:Salmon;\\\" width=150 align=center>Καθηγητής</th>\n                <th style=\\\"background-color:Salmon;\\\" width=90  align=center>Λόγος Αίτησης</th>\n                <th style=\\\"background-color:Salmon;\\\" width=40  align=center>Διεκ/νο</th>\n                <th style=\\\"background-color:Salmon;\\\" width=40  align=center>Διαγραφή</th>\");\n        \n        if(\'#nu_user_group#\'==\'Managers\'){        \n            print (\"\n                <th style=\\\"background-color:Salmon;\\\" width=50 align=center>Απόρριψη</th>\n                <th style=\\\"background-color:Salmon;\\\" width=50 align=center>Έγκριση</th>\");\n        }\n        \n        print (\"\n                <th width=70 align=center>Ημερομηνία</th>\n                <th width=40 align=center>Ώρα</th>\n                <th width=200 align=center>Μαθητής</th>\n                <th width=40 align=center>Λόγος Απουσίας</th>\n                <th width=50 align=center>Τμήμα</th>\n                <th width=120 align=center>Καταχωριστής / Διδάσκων</th>\n                <th width=50 align=center>Δικ/μενη</th>\n                <th width=50 align=center>Αναλυτικές Πληροφορίες</th>\n            </tr>\");\n    \n        $color_done=\'LightSteelBlue\';\n        $color_active=\'LightGreen\';\n        $color_active_other = \'#FFD700\';\n        \n        $color_penalty=\'OrangeRed\';\n        $color_a=\'LightSkyBlue\';\n        \n        $color=$color_active;\n        \n        while($row = db_fetch_row($retval)) {\n    \n        if($row[6]){\n            $color=$color_done;\n        } else {\n            $color=(is_other_teacher(\n            $row[0],//$request_id\n            $row[1],//$absence_id\n            $row[23],//$card_id\n            $row[25],//$class_id\n            $row[2],//$request_post_teacher_id\n            $row[22],//$absence_post_teacher_id\n            $row[24],//$card_teacher_id\n            $row[26]/*$class_post_teacher_id*/) ? $color_active_other : $color_active);\n        }\n    \n        print (\"\n            <tr style=\\\"background-color:$color;\\\" height=35>\n                <td align=center>\".$row[5].\"</td>\n                <td align=left>\".(is_null($row[9]) || $row[9]==\'\'? \'&nbsp;\' : $row[9]).\"</td>\n                <td align=left>\".(is_null($row[10]) || $row[10]==\'\'? \'&nbsp;\' : $row[10]).\"</td>\n                <td align=center>\".(is_null($row[11]) || $row[11]==\'\'? \'&nbsp;\' : $row[11]).\"</td>\");\n                \n        $sql=\"select ifnull(teacher_id,-1) from session_variables where session_id=\'#session_id#\' limit 1\";\n        $rv_sv=nuRunQuery($sql);\n        \n        if($rv_sv){\n            if(db_num_rows($rv_sv)>0){\n                $r=db_fetch_row($rv_sv);\n                $current_teacher=$r[0];\n            } else {\n               $current_teacher=-1; \n            }\n        } else {\n            $current_teacher=-1;\n        }\n        \n        if(!($row[6])){\n            if($row[2]==$current_teacher){\n                print (\"\n                <td align=center title=\\\"Διαγραφή Αιτήματος\\\" onclick=\\\"delete_request(\".$row[0].\")\\\" onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\"><img src=\\\"images/d.png\\\"></td>\");\n            } else {\n                print (\"\n                <td align=center>&nbsp;</td>\");\n            }\n        \n            if(\'#nu_user_group#\'==\'Managers\'){\n                print (\"\n                <td align=center title=\\\"Απόρριψη Αιτήματος\\\" onclick=\\\"decline_request(\".$row[0].\",\".$current_teacher.\")\\\" onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\"><img src=\\\"images/x.png\\\"></td>\");\n                print (\"\n                <td align=center title=\\\"Έγκριση Αιτήματος\\\" onclick=\\\"approve_request(\".$row[0].\",\".$current_teacher.\")\\\" onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\"><img src=\\\"images/y.png\\\"></td>\");\n            }\n        } else {\n            print (\"\n                <td align=center>&nbsp;</td>\");\n            if(\'#nu_user_group#\'==\'Managers\'){\n                print (\"\n                <td align=center>&nbsp;</td>\n                <td align=center>&nbsp;</td>\");\n            }\n        }\n        \n        \n        $color_absence= $row[28]==\'1\' ? $color_a  : $color_penalty;\n        \n        print (\"\n                <td align=right style=\\\"background-color:$color_absence;\\\">\".(is_null($row[12]) || $row[12]==\'\'? \'&nbsp;\' : $row[12]).\"</td>\n                <td align=center style=\\\"background-color:$color_absence;\\\">\".(is_null($row[13]) || $row[13]==\'\'? \'&nbsp;\' : $row[13]).\"</td>\n                <td align=left style=\\\"background-color:$color_absence;\\\">\".(is_null($row[14]) || $row[14]==\'\'? \'&nbsp;\' : $row[14]).\"</td>\n                <td align=center style=\\\"background-color:$color_absence;\\\">\".(is_null($row[15]) || $row[15]==\'\'? \'&nbsp;\' : $row[15]).\"</td>\n                <td align=center style=\\\"background-color:$color_absence;\\\">\".(is_null($row[16]) || $row[16]==\'\'? \'&nbsp;\' : $row[16]).\"</td>\n                \n                <td align=left style=\\\"background-color:$color_absence;\\\">\".(is_null($row[18]) || $row[18]==\'\'? \'&nbsp;\' : $row[18].\' / \'.$row[27]).\"</td>\n                <td align=center style=\\\"background-color:$color_absence;\\\">\".(is_null($row[19]) || $row[19]==\'\'? \'&nbsp;\' : $row[19]).\"</td>\n                \n                <td align=center style=\\\"background-color:$color_absence;\\\" title=\\\"Πληροφορίες/Επεξεργασία\\\" onclick=\\\"show_absence_info(\".$row[1].\")\\\" onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\"><img src=\\\"images/info.png\\\"></td>\n            </tr>\");      \n        }\n        print (\"\n        </table>\");\n    }\n    else{\n        print (\"<span CLASS=\\\"msg\\\">Δεν υπάρχουν αιτήματα διαγραφής!</span>\");\n    }\n}\nelse{\n    print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν δεδομένα...</span>\");\n}\nprint \"\n    </body>\n</html>\";\n','','0','2015-03-31 09:06:13','globeadmin','2018-08-04 11:50:09','globeadmin','2018-08-04 11:50:09','globeadmin','0'),('552233092acee07','justify_student_day_absence','Διακαιολόγηση απουσιών μαθητή μιας ημέρας','teacher','print \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n        \n        <script type=\\\"text/javascript\\\">\n            function show_absence_info(absence_id){\n                parent.nuOpenFormInFrame(\'5509671b4e81a07\',absence_id)    \n            }\n        </script>\n\n    </head>\n    <body>\";\n    \n$cur_date = date(\"Y-m-d\");\n$absence_date = \'#absence_date#\';\n\nif($absence_date<=$cur_date){\n$sql=\"  SELECT \n            absence.id,\n            DATE_FORMAT(absence.absence_date,\'%d-%m-%Y\'),\n            period.short_name,\n            concat(student.surname,\' \',student.name,\' πατ. \',student.fathers_name),\n            absence_reason.name,\n            class.short_name,\n            concat(subject.name,if(subject_type.short_name is NULL,\'\',concat(\'-\',subject_type.short_name))),\n            teacher.short_name,\n            if(absence.justified,\'Ναι\',\'Όχι\'),\n            justified_reason.short_name,\n            if(absence.counts,\'Ναι\',\'Όχι\'),\n            absence.absence_reason_id\n        FROM absence\n            INNER JOIN teacher          ON  absence.post_teacher_id         = teacher.id\n            INNER JOIN student          ON  absence.student_id              = student.id\n            INNER JOIN card             ON  absence.card_id                 = card.id\n            INNER JOIN absence_reason   ON  absence.absence_reason_id       = absence_reason.id\n            LEFT JOIN  justified_reason ON  absence.justified_reason_id     = justified_reason.id\n            INNER JOIN subject          ON  card.subject_id                 = subject.id\n            INNER JOIN class            ON  card.class_id                   = class.id\n            INNER JOIN period           ON  card.period_id                  = period.id\n            LEFT JOIN subject_type     ON  subject.subject_type_id         = subject_type.id\n        WHERE\n        absence.absence_date = \'#absence_date#\' and\n        student.id = \'#RECORD_ID#\'\n        order by period.id\n\";\n        \n$retval=nuRunQuery($sql);\n\nif($retval) {\n    if(db_num_rows($retval)>0) {\n    \n        print (\"\n        <form>\n            <table cellspacing=0 CLASS=\\\"sisTable\\\">\n                <tr height=45>\n                    <th width=40 align=center>Ώρα</th>\n                    <th width=100 align=center>Λόγος Απουσίας</th>\n                    <th width=50 align=center>Τμήμα</th>\n                    <th width=150 align=center>Μάθημα</th>\n                    <th width=150 align=center>Καθηγητής</th>\n                    <th width=50 align=center>Δικαιολογημένη</th>\n                    <th width=120 align=center>Λόγος Δικαιολόγησης</th>\n                    <th width=50 align=center>Μετράει</th>\n                    <th width=50 align=center>Αναλυτικές Πληροφορίες</th>\n                    <th width=50 align=center>Δικαιολόγηση<input id=\\\"all_chk\\\" type=\\\"checkbox\\\" name=\\\"justify_all\\\" title=\\\"Επιλογή/Αποεπιλογή Όλων\\\" onclick=\\\"toggle(this,\'justify_chk\')\\\"></th>\n                </tr>\");\n        \n        $color_justified=\'LightGreen\';\n        $color_not_justified=\'LightBlue\';\n        $color_penalty = \'OrangeRed\';\n        \n        $color=$color_not_justified;\n    \n        while($row = db_fetch_row($retval)) {\n    \n            if($row[8]==\'Ναι\'){\n                $color=$color_justified;\n            } else {\n                if($row[11]==1){\n                    $color=$color_not_justified;\n                } else {\n                    $color=$color_penalty;\n                }\n            }\n    \n            print (\"\n                <tr style=\\\"background-color:$color;\\\" height=35>\n                    <td align=center>\".(is_null($row[2]) || $row[2]==\'\'? \'&nbsp;\' : $row[2]).\"</td>\n                    <td align=center>\".(is_null($row[4]) || $row[4]==\'\'? \'&nbsp;\' : $row[4]).\"</td>\n                    <td align=center>\".(is_null($row[5]) || $row[5]==\'\'? \'&nbsp;\' : $row[5]).\"</td>\n                    <td align=left>\".(is_null($row[6]) || $row[6]==\'\'? \'&nbsp;\' : $row[6]).\"</td>\n                    <td align=left>\".(is_null($row[7]) || $row[7]==\'\'? \'&nbsp;\' : $row[7]).\"</td>\n                    <td align=center>\".(is_null($row[8]) || $row[8]==\'\'? \'&nbsp;\' : $row[8]).\"</td>\n                    <td align=left>\".(is_null($row[9]) || $row[9]==\'\'? \'&nbsp;\' : $row[9]).\"</td>\n                    <td align=center>\".(is_null($row[10]) || $row[10]==\'\'? \'&nbsp;\' : $row[10]).\"</td>\n                    <td align=center title=\\\"Πληροφορίες/Επεξεργασία\\\" onclick=\\\"show_absence_info(\".$row[0].\")\\\" onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\"><img src=\\\"images/info.png\\\"></td>\");\n\n            if($row[8]==\'Ναι\' || ($row[11]!=1 && \'#nu_user_group#\'!=\'Managers\')){\n                print (\"\n                    <td align=center>&nbsp;</td>\");   \n            } else {\n                print (\"\n                    <td align=center><input type=\\\"checkbox\\\" id=\\\"\".$row[0].\"\\\" title=\\\"Δικαιολόγηση\\\" Class=\\\"justify_chk\\\" onclick=\\\"make_indeterminate(\'all_chk\')\\\"></td>\");\n            }\n            print (\"\n                </tr>\");\n        }\n        print (\"\n            </table>\n        </form>\");\n    }\n    else{\n        print (\"<br><span CLASS=\\\"msg\\\">Δε βρέθηκαν απουσίες...</span>\");\n    }\n}\nelse{\n    print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν δεδομένα...</span>\");\n}\n} else {\n    print (\"<span CLASS=\\\"msgError\\\">Δεν μπορούν να υπάρξουν απουσίες σε μελλοντικές ημερομηνίες...</span>\");    \n}\nprint \"\n    </body>\n</html>\";\n','','0','2015-04-06 10:17:29','globeadmin','2018-07-15 12:05:29','globeadmin','2018-07-16 11:56:31','globeadmin','0'),('5522ba5ae053074','justify_absences','Δικαιολόγηση Απουσιών','teacher','nuRunPHP(\'notification_add_lib\');\n\nfunction last_justification_date(){\n    $sql=\"select CURDATE(), num_days_absence_justification from school limit 1\";\n    $retval=nuRunQuery($sql);\n    $row=db_fetch_row($retval);\n    \n    $cur_date   =   $row[0];\n    $num_days   =   $row[1];\n    \n    $sql=\"SELECT holiday FROM holiday WHERE DAYOFWEEK(holiday) not in (1,7)\";\n    $retval=nuRunQuery($sql);\n    $holidays = array();\n    \n    if($retval && db_num_rows($retval)>0){\n        while($row=db_fetch_row($retval)){\n            $holidays[]= $row[0];\n        }\n    }\n    \n    $weekend = array(\'Sun\',\'Sat\');\n    $date = new DateTime($cur_date);\n    $prevDay = clone $date;\n    \n    $i = 0; \n    $lastDate = $cur_date; \n    \n    while ($i < $num_days)\n    {\n        $di = new DateInterval(\'P1D\');\n        $di->invert = 1; // Proper negative date interval\n        \n        $prevDay->add($di); \n        \n        if (in_array($prevDay->format(\'Y-m-d\'), $holidays)) continue; \n        if (in_array($prevDay->format(\'D\'), $weekend)) continue;\n        \n        $lastDate = $prevDay->format(\'Y-m-d\');\n        $i++;\n    }\n    \n    return $lastDate;\n}\n\n$sql=\"select ifnull(teacher_id,-1) from session_variables where session_id=\'#session_id#\' limit 1\";\n$rv_sv=nuRunQuery($sql);\n        \nif($rv_sv){\n    if(db_num_rows($rv_sv)>0){\n        $r=db_fetch_row($rv_sv);\n        $current_teacher=$r[0];\n    } else {\n        $current_teacher=-1; \n    }\n} else {\n    $current_teacher=-1;\n}\n\n$sql=\"  select COUNT(distinct absence_date) \n        from absence \n        where \n            student_id=#RECORD_ID# and \n            justified=1 and\n            justified_reason_id=1\";\n        \n$retval=nuRunQuery($sql);\n$row1=db_fetch_row($retval);\n\n\n$sql=\"select parent_days_limit_justification, DATE_ADD(CURDATE(), INTERVAL - (num_days_absence_justification+1) DAY), DATE_FORMAT(DATE_ADD(CURDATE(), INTERVAL - (num_days_absence_justification+1) DAY),\'%d-%m-%Y\') from school limit 1\";\n$retval=nuRunQuery($sql);\n$row2=db_fetch_row($retval);\n\n$last_date = last_justification_date();\n\nif(\'#absence_date#\'>=$last_date){\n    if(\'#justify_reason_id#\'==\'1\' && $row1[0]>=$row2[0]){\n        $nuError=\'Προσοχή! Δεν μπορούν να δικαιολογηθούν επιπλέον απουσίες από Κηδεμόνα! Έχει εξαντληθεί το όριο πλήθους ημερών με δικαιολογητικά από τον κηδεμόνα...\'.$row1[0].\">=\".$row2[0];\n    } else {\n    \n        $sql=\"select counts from justified_reason where id=#justify_reason_id#\";\n        $r=nuRunQuery($sql);\n        $rw=db_fetch_row($r);    \n           \n        $sql=\"  UPDATE \n        absence\n        set \n            absence.justified=1,\n            absence.justified_when=NOW(),\n            absence.counts=\".$rw[0].\",\n            absence.justified_teacher_id=\".$current_teacher.\",\n            justified_reason_id=#justify_reason_id#\n        WHERE absence.id in (#absence_id_list#) and absence.justified=0\n            \";\n        nuRunQuery($sql);\n    \n        $ids = explode(\',\',\'#absence_id_list#\');\n        foreach($ids as $id){\n            justify_absence_notification($id);\n        }\n    }\n} else {\n    $d=new DateTime($last_date);\n    $nuError=\"Προσοχή! Δεν μπορείτε να δικαιολογήσετε απουσίες πριν τις \".$d->format(\'d-m-Y\').\" ...\";\n}\n\n\n','','0','2015-04-06 19:54:50','globeadmin','2016-12-04 21:53:47','globeadmin','2020-06-09 21:00:48','globeadmin','0'),('55255886b0e2e42','absence_card_not_registered','Βρίσκει τις διδασκαλίες για τις οποίες δεν έχουν καταχωρηθεί απουσίες','manager','function createDateRangeArray($strDateFrom,$strDateTo){\n    // takes two dates formatted as YYYY-MM-DD and creates an\n    // inclusive array of the dates between the from and to dates.\n\n    $aryRange=array();\n\n    $iDateFrom=mktime(0,0,0,substr($strDateFrom,5,2),     substr($strDateFrom,8,2),substr($strDateFrom,0,4));\n    $iDateTo=mktime(0,0,0,substr($strDateTo,5,2),     substr($strDateTo,8,2),substr($strDateTo,0,4));\n\n    if ($iDateTo>=$iDateFrom)\n    {\n        array_push($aryRange,date(\'Y-m-d\',$iDateFrom)); // first entry\n        while ($iDateFrom<$iDateTo)\n        {\n            $iDateFrom+=86400; // add 24 hours\n            array_push($aryRange,date(\'Y-m-d\',$iDateFrom));\n        }\n    }\n    return $aryRange;\n}\n\n$teachers = array();\n\nprint \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">                \n                \n        <STYLE TYPE=\\\"text/css\\\">\n        .sisTable, .sisTable TD{\n                    font-size:7pt;\n                }\n        .sisTable TH{\n                    font-size:8pt;\n                }\n        </STYLE>\n\n    </head>\n\n    <body onload=\\\"adjustIframeHeight()\\\">\";\n\n\nif (\'#from_date#\'!=\'#\'.\'from_date\'.\'#\' && \'#from_date#\'!=\'\'){\n    if (\'#to_date#\'!=\'#\'.\'to_date\'.\'#\' && \'#to_date#\'!=\'\'){\n        \n        $to_date = \'#to_date#\' > date(\"Y-m-d\") ? date(\"Y-m-d\") : \'#to_date#\';\n        $from_date = \'#from_date#\' > date(\"Y-m-d\") ? date(\"Y-m-d\") : \'#from_date#\';\n\n        $days = createDateRangeArray($from_date,$to_date);\n        \n        if( count($days)>0){\n            print (\"<table border=1  cellspacing=0 CLASS=\\\"sisTable\\\" align=center>\n                        <tr height=45>\n                            <th width=80 align=center>Ημερομηνία</th>\n                            <th width=80 align=center>Ημέρα</th>\n                            <th width=50 align=center>Ώρα</th>\n                            <th width=50 align=center>Τμήμα</th>\n                            <th width=180 align=center>Μάθημα</th>\n                            <th width=140 align=center>Καθηγητής</th>\n                            <th width=50 align=center>Αίθουσα</td>\n                            <th width=140 align=center>Καταχωρητής</th>\n                            <th width=80 align=center>\n                                Επιλογή <br>\n                                 Όλα<input type=\\\"checkbox\\\" id=\\\"all_chk_1\\\" title=\\\"Επιλογή Όλων\\\" onclick=\\\"toggle(this,\'chk_1\')\\\">\n                            </th>\n                </tr>\");\n        \n       \n            foreach ($days as $absence_date) {\n            \n                $day_of_week = idate(\'w\', strtotime($absence_date))-1;\n                                \n                $sql=\"select max(valid_from) from card where valid_from<=\'\".$absence_date.\"\'\"; \n                $retval=nuRunQuery($sql);\n                $row = db_fetch_row($retval);\n                $card_date=$row[0];\n\n                $sql=\"SELECT \n                        card.id,\n                        day.name,\n                        period.short_name,\n                        class.short_name,\n                        subject.name,\n                        t1.short_name,\n                        classroom.short_name,\n                        t2.short_name,\n                        t1.id\n                    FROM card\n                        INNER JOIN      teacher as t1   on      card.teacher_id=t1.id\n                        INNER JOIN      subject         on      card.subject_id=subject.id\n                        INNER JOIN      class           on      card.class_id=class.id\n                        INNER JOIN      period          on      card.period_id=period.id\n                        INNER JOIN      day             on      card.day_id=day.id\n                        LEFT JOIN       classroom       on      card.classroom_id=classroom.id\n                        LEFT JOIN       teacher as t2   on      class.post_teacher_id=t2.id\n                    WHERE\n                        valid_from=\'\".$card_date.\"\' and\n                        day_id=\".(idate(\'w\', strtotime($absence_date))-1).\" and\n                        card.id not in ( select card_id \n                                from registered_card \n                                where DATE_FORMAT(registered_card.card_date, \'%Y-%m-%d\')=\'\".$absence_date.\"\') and\n                        \'\".$absence_date.\"\' not in ( select holiday.holiday \n                                                from holiday \n                                                    inner join school_year on holiday.school_year_id=school_year.id\n                                                    inner join school on school.school_year_id=school_year.id)\";\n                    if(\'#nu_user_group#\'!=\'Managers\' && \'#nu_user_group#\'!=\'Administrators\' && \'#nu_user_group#\'!=\'AssistManagers\' && \'#nu_user_group#\'!=\'Secretaries\' && \'#nu_user_group#\'!=\'globeadmin\'){\n                        $sql= $sql.\"\n                            AND  t2.id = \'#RECORD_ID#\'\";\n                    }\n                    if(\'#period_id_sumo#\'!=\'#\'.\'period_id_sumo\'.\'#\' && \'#period_id_sumo#\'!=\'\'){\n                        $sql= $sql.\"\n                            AND  period.id IN (#period_id_sumo#)\";\n                    }\n                    \n                    $sql= $sql.\"\n                    ORDER BY \n                        class.short_name,period.id,t1.short_name\";\n                                                        \n                $retval=nuRunQuery($sql);\n            \n                if($retval){\n                    if(db_num_rows($retval)>0){\n                        while($row = db_fetch_row($retval)) {\n                            $teachers[] = $row[8];\n                            print (\"<tr height=35>\n                                        <td align=center>\".date(\"d-m-Y\",strtotime($absence_date)).\"</td>\n                                        <td align=center>\".(is_null($row[1]) || $row[1]==\'\'? \'&nbsp;\' : $row[1]).\"</td>\n                                        <td align=center>\".(is_null($row[2]) || $row[2]==\'\'? \'&nbsp;\' : $row[2]).\"</td>\n                                        <td align=center>\".(is_null($row[3]) || $row[3]==\'\'? \'&nbsp;\' : $row[3]).\"</td>\n                                        <td align=left>\".(is_null($row[4]) || $row[4]==\'\'? \'&nbsp;\' : $row[4]).\"</td>\n                                        <td align=left>\".(is_null($row[5]) || $row[5]==\'\'? \'&nbsp;\' : $row[5]).\"</td>\n                                        <td align=center>\".(is_null($row[6]) || $row[6]==\'\'? \'&nbsp;\' : $row[6]).\"</td>\n                                        <td align=left>\".(is_null($row[7]) || $row[7]==\'\'? \'&nbsp;\' : $row[7]).\"</td>\n                                        <td align=center><input type=\\\"checkbox\\\" CLASS=\\\"chk_1\\\" id=\\\"\".$row[0].\"/\".$absence_date.\"\\\" title=\\\"Επιλογή Διδασκαλίας\\\" onclick=\\\"make_indeterminate(\'all_chk_1\')\\\"></td>\n                                    </tr>\");                    \n                        }\n                    } else {\n                    \n                    }\n                } else{\n                    $message=\"Παρουσιάστηκε σφάλμα κατά την ανάκτηση των δεδομένων...\";\n                    nudebug($message);\n                }    \n            }\n        }else{\n            print \"<span CLASS=\\\"msgError\\\">Παρακαλώ ορίστε σωστά τις ημερομηνίες...</span>\";    \n        }\n    } else {\n        print \"<span CLASS=\\\"msgError\\\">Παρακαλώ ορίστε την ημερομηνία έως...</span>\";    \n    }   \n} else {\n   print \"<span CLASS=\\\"msgError\\\">Παρακαλώ ορίστε την ημερομηνία από...</span>\"; \n}\n\nprint \"\n        <script>\n            function get_techers_ids() {\n                return(\'\".implode(\",\", array_unique($teachers)).\"\');\n            }\n        </script>\n    </body>\n</html>\";','','0','2015-04-08 19:34:14','globeadmin','2020-10-18 00:15:57','globeadmin','2022-09-17 21:47:39','globeadmin','0'),('55262fb4d34fbc0','extract_absence_class','Εξάγει τις απουσίες σε αρχεία excel ανά τμήμα','teacher','\nrequire_once(\'Classes/PHPExcel.php\');\n\nfunction greek_to_greeklish($string) { \nreturn strtr($string, array( \n    \'Α\' => \'A\',\n    \'Ά\' => \'A\',\n    \'Β\' => \'B\', \n    \'Γ\' => \'G\', \n    \'Δ\' => \'D\', \n    \'Ε\' => \'E\',\n    \'Έ\' => \'E\',\n    \'Ζ\' => \'Z\', \n    \'Η\' => \'H\',\n    \'Ή\' => \'H\',\n    \'Θ\' => \'Th\', \n    \'Ι\' => \'I\', \n    \'Ί\' => \'I\',\n    \'Κ\' => \'K\', \n    \'Λ\' => \'L\', \n    \'Μ\' => \'M\', \n    \'Ν\' => \'N\', \n    \'Ξ\' => \'Ks\', \n    \'Ο\' => \'O\',\n    \'Ό\' => \'O\',\n    \'Π\' => \'P\', \n    \'Ρ\' => \'R\', \n    \'Σ\' => \'S\', \n    \'Τ\' => \'T\', \n    \'Υ\' => \'Y\',\n    \'Ύ\' => \'Y\',\n    \'Φ\' => \'F\', \n    \'Χ\' => \'X\', \n    \'Ψ\' => \'Ps\', \n    \'Ω\' => \'O\',\n    \'Ώ\' => \'O\',\n    \'α\' => \'a\', \n    \'β\' => \'v\', \n    \'γ\' => \'g\', \n    \'δ\' => \'d\', \n    \'ε\' => \'e\', \n    \'ζ\' => \'z\', \n    \'η\' => \'h\', \n    \'θ\' => \'th\', \n    \'ι\' => \'i\', \n    \'κ\' => \'k\', \n    \'λ\' => \'l\', \n    \'μ\' => \'m\', \n    \'ν\' => \'n\', \n    \'ξ\' => \'ks\', \n    \'ο\' => \'o\', \n    \'π\' => \'p\', \n    \'ρ\' => \'r\', \n    \'σ\' => \'s\', \n    \'τ\' => \'t\', \n    \'υ\' => \'y\', \n    \'φ\' => \'f\', \n    \'χ\' => \'x\', \n    \'ψ\' => \'ps\', \n    \'ω\' => \'o\', \n    \'ς\' => \'s\', \n    \'ά\' => \'a\', \n    \'έ\' => \'e\', \n    \'ή\' => \'h\', \n    \'ί\' => \'i\', \n    \'ό\' => \'o\', \n    \'ύ\' => \'y\', \n    \'ώ\' => \'o\', \n    \'ϊ\' => \'i\', \n    \'ϋ\' => \'y\', \n    \'ΐ\' => \'i\', \n    \'ΰ\' => \'y\' \n    )); \n}\n\nfunction repair_file_name($string) { \nreturn strtr($string, array(\n    \' \' => \'_\',\n    \'\\\\\' => \'_\',\n    \'/\' => \'_\',\n    \':\' => \'_\', \n    \'*\' => \'_\', \n    \'?\' => \'_\', \n    \'\"\' => \'_\',\n    \'<\' => \'_\',\n    \'>\' => \'_\', \n    \'|\' => \'_\'\n    )); \n}\n\nfunction createDateRangeArray($strDateFrom,$strDateTo) {\n\n    $sql=\"  select holiday.holiday \n            from holiday\n            inner join school_year on holiday.school_year_id=school_year.id\n            inner join school on school.school_year_id = school_year.id\";\n    $retval=nuRunQuery($sql);\n    \n    $holiday_array = array();\n    while($row=db_fetch_row($retval)){\n        array_push($holiday_array,$row[0]);\n    }\n    \n    $sql=\"select id from day\";\n    $retval=nuRunQuery($sql);\n    \n    $day_array = array();\n    while($row=db_fetch_row($retval)){\n        array_push($day_array,$row[0]);\n    }\n    \n    $aryRange=array();\n\n    $iDateFrom=mktime(1,0,0,substr($strDateFrom,5,2),     substr($strDateFrom,8,2),substr($strDateFrom,0,4));\n    $iDateTo=mktime(1,0,0,substr($strDateTo,5,2),     substr($strDateTo,8,2),substr($strDateTo,0,4));\n\n    if ($iDateTo>=$iDateFrom)\n    {\n    \n        $day_of_week = idate(\'w\', strtotime(date(\'Y-m-d\',$iDateFrom)))-1;\n        if(in_array($day_of_week,$day_array)){\n                array_push($aryRange,date(\'Y-m-d\',$iDateFrom)); // first entry\n            }\n    \n        while ($iDateFrom<$iDateTo)\n        {\n            $iDateFrom+=86400; // add 24 hours\n            \n            $day_of_week = idate(\'w\', strtotime(date(\'Y-m-d\',$iDateFrom)))-1;\n            if(in_array($day_of_week,$day_array)){\n                array_push($aryRange,date(\'Y-m-d\',$iDateFrom));\n            }\n        }\n    }\n\n    return array_diff($aryRange, $holiday_array);\n}\n\nfunction createExcelFile($date_from,$date_to,$class_id,$class_name,$dir) {\n    $sql=\"  SELECT  \n                student.registration_number,\n                sum(if(ab.counts is null,0,ab.counts)),\n                sum(if(ab.counts is null,0,if(ab.justified,ab.counts,0))),\n                student.surname,\n                student.name,\n                student.fathers_name\n            FROM student_class\n                INNER JOIN  student     ON  student_class.student_id    =   student.id\n                LEFT JOIN ( select absence.student_id, absence.counts, absence.justified\n                            from absence\n                            where   absence.counts=1 and\n                                    DATE_FORMAT(absence.absence_date, \'%Y-%m-%d\') between \'\".$date_from.\"\' AND \'\".$date_to.\"\')\n                    as ab ON student_class.student_id    =   ab.student_id\n            WHERE \n		        student_class.class_id=\".$class_id.\"\n            GROUP BY student.registration_number,student.surname,student.name,student.fathers_name\";\n            \n    $retval = nuRunQuery($sql);\n    \n    $objPHPExcel = new PHPExcel();\n            \n    $objPHPExcel->getProperties()->setCreator(\'Papadakakis Nektarios\')\n					 ->setLastModifiedBy(\'Papadakakis Nektarios\')\n					 ->setTitle(\'Sisyphos Export for mySchool\')\n					 ->setSubject(\'Absence\')\n					 ->setDescription(\'Absence file for myschool information system\')\n					 ->setKeywords(\'Excel Sisyphos myschool\')\n					 ->setCategory(\'Sisyphos\');\n			\n    $objPHPExcel->getActiveSheet()->setTitle(\'Απουσίες\');\n            \n    $objPHPExcel->getDefaultStyle()->getFont()->setName(\'Arial\')\n                                          ->setSize(10);\n            \n    $objPHPExcel->getActiveSheet() ->getColumnDimension(\'D\') ->setWidth(35);\n    $objPHPExcel->getActiveSheet() ->getColumnDimension(\'E\') ->setWidth(25);\n    $objPHPExcel->getActiveSheet() ->getColumnDimension(\'F\') ->setWidth(25);\n            \n    $i=1;\n    while($data = db_fetch_row($retval)){\n        $objPHPExcel->setActiveSheetIndex(0);\n        $objPHPExcel->getActiveSheet()->fromArray($data,NULL,\'A\'.$i);\n        $i++;\n    }\n\n    $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, \'Excel5\');\n\n    $filefordown= $class_name.\"_\".$date_from.($date_from==$date_to ? \'\' : \"_Έως_\".$date_to).\'.xls\';\n            \n    $filefordown=repair_file_name($filefordown);\n            \n    $filefordown=$dir.\'/\'.$filefordown;\n            \n    $objWriter->save($filefordown);\n    \n    return $filefordown;\n}\n\n\nprint \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n        \n        <STYLE TYPE=\\\"text/css\\\">\n            .fulltable{\n                font-family:Verdana;\n                font-size:9pt;\n                border-collapse: collapse; \n                border: none;\n                border-spacing: 0px;\n                padding: 10px;\n            }\n            .fulltable TD{\n                padding: 10px;\n            }            \n            .sisTable TD, .sisTable TH{\n                font-size:1.1em;\n                border-collapse: separate;\n            }\n    \n            a:link {\n                color:#0000AA;\n                background-color:transparent;\n                text-decoration:none;\n            }\n            \n            a:visited {\n                color:#0000AA;\n                background-color:transparent;\n                text-decoration:none;\n            }\n            a:hover {\n                color:#ff0000;\n                background-color:transparent;\n                text-decoration:underline;\n            }\n            a:active {\n                color:#ff0000;\n                background-color:transparent;\n                text-decoration:underline;\n            }\n        </STYLE>\n    </head>\n<body onload=\\\"adjustIframeHeight()\\\">\";\n\n$class_ids = array();\n\nif(\'#class_id_sumo#\'!=\'#\'.\'class_id_sumo#\' && \'#class_id_sumo#\'!=\'\'){ \n\n    $sql=\"  select class.id, class.short_name,class.grade_id\n                from class\n                where \n                    id IN (#class_id_sumo#)\n                order by grade_id,short_name\";\n            \n    $retval = nuRunQuery($sql);\n    if($retval) {\n        if(db_num_rows($retval)>0){\n            while($row = db_fetch_row($retval)) {\n                $class_ids[]= array($row[0],$row[1],$row[2]);  \n            }\n        }\n    }\n\n    if (\'#from_date#\'!=\'#\'.\'from_date\'.\'#\' && \'#from_date#\'!=\'\'){\n        if (\'#to_date#\'!=\'#\'.\'to_date\'.\'#\' && \'#to_date#\'!=\'\'){\n\n            $days = createDateRangeArray(\'#from_date#\',\'#to_date#\');\n    \n            if(count($days)>0){\n                if(count($class_ids)>0) {\n                \n                    $dir = \'tmp/absence_export_#RECORD_ID#_\'.date(\"YmdHis\");\n                    if(mkdir($dir)){\n               \n                        if(count($class_ids)>1 || (count($class_ids)==1 && count($days)>1 && \'#show_only_sums#\'!=\'1\')){\n                            $create_zip_file=true;\n                            $zip = new ZipArchive();\n                            $zip->open($dir.\'.zip\', ZipArchive::CREATE);\n                            print (\"<span style=\\\"font-family:Verdana;font-size:10pt;font-weight: bold;\\\"><a href=\\\"\".$dir.\".zip\\\"><center>Λήψη Όλων</center></a></span></p>\");\n                        } else {\n                            $create_zip_file=false;    \n                        }\n\n                        print (\"\n    <table class=\\\"fulltable\\\" align=center>\");\n                \n                        $i=1;\n                        $grade_id=0;\n                        foreach ($class_ids as $class_id) {\n                    \n                            if($i==1){\n                                print(\"\n        <tr>\");    \n                            } else if ($grade_id!=$class_id[2]){\n                                print(\"\n        </tr>\n        <tr>\");\n                                $i=1;\n                            }\n                    \n                            $grade_id=$class_id[2];\n                    \n                    \n                            print (\"\n            <td>\n                <table class=\\\"sisTable\\\" cellspacing=0>\");\n                                \n                            if(\'#show_only_sums#\'!=\'1\'){            \n                                print (\"\n                    <tr>\n                        <th align=center width=150 height=30>\".$class_id[1].\"</th>\n                    </tr>\");\n\n                                foreach ($days as $day) {\n                                    $ff=createExcelFile($day,$day,$class_id[0],$class_id[1],$dir);\n                                    if($create_zip_file){\n                                        $zip->addFile($ff, basename(greek_to_greeklish($ff)));\n                                    }\n                                    print (\"    \n                    <tr>\n                        <td align=center height=30><b><a href=\\\"\".$ff.\"\\\">\".date(\"d-m-Y\",strtotime($day)).\"</a></b></td>\n                    </tr>\");\n                                }\n                            }\n                    \n                            if(count($days)>1 || \'#show_only_sums#\'==\'1\'){\n                                $ff=createExcelFile(\'#from_date#\',\'#to_date#\',$class_id[0],$class_id[1],$dir);\n                                if($create_zip_file){\n                                    $zip->addFile($ff, basename(greek_to_greeklish($ff)));\n                                }\n                                print (\"    \n                    <tr>\n                        <th align=center height=30 width=150><b><a href=\\\"\".$ff.\"\\\">\".$class_id[1].\" Σύνολα</a></b></th>\n                    </tr>\");\n                            }\n                    \n                            print (\"\n                </table>\n            </td>\");\n                            if($i==4){\n                                print(\"\n        </tr>\");\n                                $i=1;\n                            } else {\n                                $i++;\n                            }\n                        }\n                        print (\"\n        </tr>\n    </table>\");\n                        if($create_zip_file){\n                            $zip->close();\n                        }\n                    } else {\n                        print (\"<span CLASS=\\\"msgError\\\">Προσοχή : Δεν μπορούν να αποθηκευτουν τα εξαγόμενα αρχεία στον εξυπηρετητή!<br>παρακαλώ επικοινωνήστε με το διαχειριστή του συστήματος!</span>\");    \n                    }\n                } else{\n                    print (\"<span CLASS=\\\"msg\\\">Παρακαλώ επιλέξτε τμήμα...</span>\");\n                }    \n            } else {\n                print (\"<span CLASS=\\\"msg\\\">Δε βρέθηκαν ημερομηνίες λειτουργίας του σχολείου στο μεσοδιάστημα από και έως...</span>\");    \n            }\n        } else {\n            print (\"<span CLASS=\\\"msg\\\">Παρακαλώ ορίσετε την ημερομηνία έως...</span>\");\n        }\n    } else {\n        print (\"<span CLASS=\\\"msg\\\">Παρακαλώ ορίσετε την ημερομηνία από...</span>\");    \n    }\n} else {\n    print (\"<span CLASS=\\\"msg\\\">>Παρακαλώ επιλέξτε τμήμα...</span>\");    \n}\nprint \"\n    </body>\n</html>\";','','0','2015-04-09 10:52:20','globeadmin','2018-07-15 11:54:30','globeadmin','2020-11-01 11:27:50','globeadmin','0'),('552ea7c73b78c04','print_absence_notes_short','Δημιουργεί τον πίνακα για τα δελτια απουσιών στη σύντομη μοφή τους','teacher','if (\'#to_date#\'==\'#\'.\'to_date\'.\'#\' || \'#to_date#\'==\'\' || \'#to_date#\'>date(\'Y-m-d\')){\n        $to_date = date(\'Y-m-d\');\n} else {\n    $to_date = date_format(date_create_from_format(\'Y-m-d\',\'#to_date#\'),\'Y-m-d\');\n}\n\n$sql=\"DROP TEMPORARY TABLE IF EXISTS #TABLE_ID#\";\nnuRunQuery($sql);\n\n$sql=\"CREATE TEMPORARY TABLE #TABLE_ID# DEFAULT CHARACTER SET=utf8\nSELECT \n                concat(if(school.city is null,\'Ημερομηνία : \',concat(school.city,\', \')),DATE_FORMAT(curdate(),\'%d-%m-%Y\')) as cur_date,\n                concat(\'Ημερομηνία Έκδοσης Δελτίου : \',DATE_FORMAT(curdate(),\'%d-%m-%Y\')) as issue_date, \n                student.id as student_id,\n                concat(ifNull(student.surname,\'\'),\' \',ifNull(student.name,\'\'),\' πατ. \',ifNull(student.fathers_name,\'\'),\' (Α.Μ. \',ifNull(student.registration_number,\'\'),\')\') as student_full_name,\n                student.phone1                                  as student_phone1,\n                student.phone2                                  as student_phone2,\n                student.mobile                                  as student_mobile,\n                student.email                                   as student_email,\n                student.street                                  as student_street,\n                student.area                                    as student_area,\n                student.zipcode                                 as student_zipcode,\n                student.city                                    as student_city,\n                concat (ifnull(student.parent_surname,\'\'),if (student.parent_surname is null,\'\',\' \'),ifnull(student.parent_name,\'\')) as student_parent_full_name,\n                \n                if (concat(ifNull(student.parent_street,\'\'),ifNull(student.parent_area,\'\'),ifNull(student.parent_zipcode,\'\'))=\'\',\n                concat(ifNull(student.street,\'\'),       if(student.street is null or trim(student.street)=\'\' or student.area is null or trim(student.area)=\'\',\'\',\', \'),       ifNull(student.area,\'\')),\n                concat(ifNull(student.parent_street,\'\'),if(student.parent_street is null or trim(student.parent_street)=\'\' or student.parent_area is null or trim(student.parent_area)=\'\',\'\',\', \'),ifNull(student.parent_area,\'\'))) as address1,\n                \n                if (concat(ifNull(student.parent_street,\'\'),ifNull(student.parent_area,\'\'),ifNull(student.parent_zipcode,\'\'))=\'\',\n                concat(ifNull(student.zipcode,\'\'),       if(student.zipcode is null or trim(student.zipcode)=\'\' or student.city is null or trim(student.city)=\'\',\'\',\', \'),       ifNull(student.city,\'\')),\n                concat(if(student.parent_zipcode is null or trim(student.parent_zipcode)=\'\',\'\',\'Τ.Κ. \'),ifNull(student.parent_zipcode,\'\'))) as address2,\n    \n                student.parent_phone1                           as student_parent_phone1,\n                student.parent_phone2                           as student_parent_phone2,\n                student.parent_phone3                           as student_parent_phone3,\n                student.parent_email                            as student_parent_email,\n                \n                student.parent_street                           as student_parent_street,\n                student.parent_area                             as student_parent_area,\n                student.parent_zipcode                          as student_parent_zipcode,\n                school.name                                     as school_name,\n                school.short_name                               as school_short_name,\n                school.ministry                                 as school_ministry,\n                school.region                                   as school_region,\n                school.intendancy                               as school_intendancy,\n                concat(ifNull(school.phone1,\'\'),if(school.phone2 is null,\'\',concat(\', \',school.phone2)))        as school_phone,\n                school.fax                                                                                      as school_fax,\n                concat(ifNull(school.street,\'\'),if(school.area is null,\'\',concat(\', \',school.area)))            as school_street_area,\n                concat(ifNull(school.zipcode,\'\'),if(school.city is null,\'\',concat(\', \',school.city)))           as school_zipcode_city,\n                concat(ifNull(school.state,\'\'),if(school.country is null,\'\',concat(\', \',school.country)))       as school_state_country,\n                school.email                                                                                    as school_email,\n                school.web_page                                                                                 as school_web_page,\n                if(\'#m_sign#\'=\'1\',\'Ο Διευθυντής\',\'\')                                                            as manager_label,\n                if(\'#a_sign#\'=\'1\',\'Ο Υποδιευθυντής\',\'\')                                                         as assistmanager_label,\n                if(\'#t_sign#\'=\'1\',\'Ο Καθηγητής\',\'\')                                                             as teacher_label,\n                CAST(if(\'#m_sign#\'=\'1\',\'\',\'\') as CHAR(255))                                                     as manager_name,\n                CAST(if(\'#a_sign#\'=\'1\',\'\',\'\') as CHAR(255))                                                     as assistmanager_name,\n                if(\'#t_sign#\'=\'1\',concat(ifNull(teacher.surname,\'\'),if(teacher.surname is null,\'\',\' \'),ifNull(teacher.name,\'\')),\'\') as teacher_name,\n                if(student.gender=\'Θ\',\'Σας πληροφορούμε ότι η μαθήτρια\',\'Σας πληροφορούμε ότι ο μαθητής\') as text1,\n                if(student.gender=\'Θ\',\'Έλαβα γνώση για τις απουσίες της\',\'Έλαβα γνώση για τις απουσίες του\') as text10,\n                if(student.gender=\'Θ\',\'Η μαθήτρια\',\'Ο μαθητής\') as text100,\n                concat(\'από την έναρξη της σχολικής χρονιάς έως και τις \',DATE_FORMAT(\'\".$to_date.\"\',\'%d-%m-%Y\')) as text2,\n                \'πραγματοποίησε\' as text3,\n                concat(sum(if(ab.counts is null,0,if(ab.justified,0,ab.counts)))+ifnull(prev_an_justified_absences,0),\' αδικαιολόγητες απουσίες,\') as text4,\n                concat(sum(if(ab.counts is null,0,if(ab.justified,ab.counts,0)))+ifnull(prev_justified_absences,0),\' δικαιολογημένες απουσίες,\') as text5,\n                concat(sum(if(ab.counts is null,0,ab.counts))+ifnull(prev_an_justified_absences,0)+ifnull(prev_justified_absences,0),\' απουσίες συνολικά.\') as text6,\n                sum(if(ab.counts is null,0,ab.counts))+ifnull(prev_an_justified_absences,0)+ifnull(prev_justified_absences,0) as synolo,\n                sum(if(ab.counts is null,0,if(ab.justified,ab.counts,0)))+ifnull(prev_justified_absences,0) as dikaiologimenes,\n                sum(if(ab.counts is null,0,if(ab.justified,0,ab.counts)))+ifnull(prev_an_justified_absences,0) as adikaiologites\n            FROM student\";\n\nif(\'#class_id#\'!=\'#\'.\'class_id#\' && \'#class_id#\'!=\'\' ){\n$sql=$sql.\"\n                INNER JOIN  (select distinct student_id from student_class where class_id in (#class_id#)) as sc ON  student.id = sc.student_id\";\n}\n\n$sql=$sql.\"\n                INNER JOIN school on 1=1\n                INNER JOIN school_year on school.school_year_id = school_year.id\n                LEFT JOIN teacher on student.teacher_id=teacher.id \n                LEFT JOIN ( select \n								    absence.student_id,\n									absence.counts,\n									absence.justified\n							from absence\n							where absence.counts=1 AND DATE_FORMAT(absence.absence_date, \'%Y-%m-%d\') <= \'\".$to_date.\"\') \n						as ab ON student.id    =   ab.student_id\n            WHERE\n\";\n\nif(\'#class_id#\'==\'#\'.\'class_id#\' || \'#class_id#\'==\'\'){\n$sql=$sql.\" student.teacher_id = \'#RECORD_ID#\' and \n\";\n}\n\nif(\'#export_student_id#\'!=\'#\'.\'export_student_id#\' && \'#export_student_id#\'!=\'\' ){\n    $sql=$sql.\" student.id = \'#export_student_id#\' and \n\";\n}\n\nif(\'#has_left_school#\'!=\'#\'.\'has_left_school#\' && \'#has_left_school#\'!=\'\' && \'#has_left_school#\'==\'1\'){\n    $sql=$sql.\" student.has_left_school = 0 and \n    \";\n}\n\nif(\'#absence_limit#\'!=\'#\'.\'absence_limit#\' && \'#absence_limit#\'!=\'\'){\n    $limit=#absence_limit#;\n} else {\n    $limit=0;\n}\n\n$sql=$sql.\"\n            1=1\n            GROUP BY student.id\n            HAVING synolo>=\".$limit.\"\n            ORDER BY student.grade_id,student.surname,student.name,student.fathers_name\n\";\n\nnuRunQuery($sql);\n\nif(\'#m_sign#\'==\'1\'){\n    $sql=\"  SELECT concat(ifNull(surname,\'\'),if(surname is null,\'\',\' \'),ifNull(name,\'\')) \n        FROM teacher \n        inner join zzzsys_user on teacher.user_id=zzzsys_user.zzzsys_user_id\n        inner join zzzsys_user_group on zzzsys_user.sus_zzzsys_user_group_id=zzzsys_user_group.zzzsys_user_group_id\n        WHERE zzzsys_user_group.sug_code=\'Managers\'\";\n    $retval=nuRunQuery($sql);\n\n    if(db_num_rows($retval)==1){\n        $row=db_fetch_row($retval);\n        $sql=\"update #TABLE_ID# set manager_name=\'\".$row[0].\"\' where 1\";\n        nuRunQuery($sql);\n    }\n}\n\nif(\'#a_sign#\'==\'1\'){\n    $sql=\"  SELECT concat(ifNull(surname,\'\'),if(surname is null,\'\',\' \'),ifNull(name,\'\')) \n        FROM teacher \n        inner join zzzsys_user on teacher.user_id=zzzsys_user.zzzsys_user_id\n        inner join zzzsys_user_group on zzzsys_user.sus_zzzsys_user_group_id=zzzsys_user_group.zzzsys_user_group_id\n        WHERE zzzsys_user_group.sug_code=\'AssistManagers\'\";\n    $retval=nuRunQuery($sql);\n\n    if(db_num_rows($retval)==1){\n        $row=db_fetch_row($retval);\n        $sql=\"update #TABLE_ID# set assistmanager_name=\'\".$row[0].\"\' where 1\";\n        nuRunQuery($sql);\n    }\n}\n\n','','0','2015-04-15 21:02:47','globeadmin','2016-01-28 21:33:07','globeadmin','2021-09-07 20:42:54','globeadmin',''),('5537d807e48c62b','register_no_lesson_cards','Καταχωρεί οτι μια συγκεκριμένη ώρα δεν έγινε μάθημα','teacher','\nfunction esc($str){\n    $db_params = nuRunQuery();\n    $link = mysqli_connect($db_params[0], $db_params[2], $db_params[3], $db_params[1]);\n\n    if (mysqli_connect_errno()) {\n        nuDebug(\"Connect failed: %s\\n\", mysqli_connect_error());\n        return \'\';\n    }\n    return(mysqli_real_escape_string($link,$str));\n}\n\nif (\'#absence_date#\'!=\'#\'.\'absence_date\'.\'#\' && \'#absence_date#\'!=\'\'){\n    $absence_date = \'#absence_date#\';\n} else {\n    $absence_date = date(\'Y-m-d\');\n}  \n$day_of_week = idate(\'w\', strtotime($absence_date))-1;\n\nif (\'#absence_class_id#\'!=\'#\'.\'absence_class_id\'.\'#\' && \'#absence_class_id#\'!=\'\' && is_int(#absence_class_id#)){\n    if (\'#no_lesson_period_id#\'!=\'#\'.\'no_lesson_period_id\'.\'#\' && \'#no_lesson_period_id#\'!=\'\' && is_int(#no_lesson_period_id#)){\n\n        $sql=\"select max(valid_from) from card where valid_from<=\'\".$absence_date.\"\'\"; \n        $rv=nuRunQuery($sql);\n    \n        if($rv && db_num_rows($rv)>0){\n            $card_date = db_fetch_row($rv);\n        \n            $sql=\"  SELECT card.id \n                FROM card,period\n                WHERE\n                    card.period_id=period.id and \n                    valid_from=\'\".$card_date[0].\"\' and\n                    card.class_id=\'#absence_class_id#\' and\n                    day_id=\".$day_of_week.\" and\n                    period_id=\'#no_lesson_period_id#\' and \n                    card.id not in (   select registered_card.card_id \n                                        from registered_card \n                                        where DATE_FORMAT(registered_card.card_date, \'%Y-%m-%d\')=\'\".$absence_date.\"\')\";\n                                                    \n            $retval=nuRunQuery($sql);\n        \n            if($retval && db_num_rows($retval)>0){\n            \n                if (\'#no_lesson_comments#\'!=\'#\'.\'no_lesson_comments\'.\'#\' && \'#no_lesson_comments#\'!=\'\'){\n                    $comments = \'#no_lesson_comments#\';\n                } else {\n                    $comments = \'\';\n                }\n                \n                $is_primary=1;\n                \n                while($card_ids=db_fetch_row($retval)){\n                    $sql=\"  INSERT INTO registered_card (\n                                id,\n                                card_date,\n                                posted_when,\n                                card_id,\n                                comments,\n                                teacher_id,\n                                no_lesson,\n                                prime\n                            ) VALUES (\n                                NULL,\n                                \'\".$absence_date.\"\',\n                                \'\".date(\'Y-m-d H:i:s\').\"\',\n                                \".$card_ids[0].\",\n                                \'\".esc($comments).\"\',\n                                #RECORD_ID#,\n                                1,\n                                \".$is_primary.\"\n                        )\";\n                    nuRunQuery($sql); \n                    \n                    $is_primary=0;\n                }\n            \n            } else {\n                nuDebug(\'register_no_lesson_cards - retrive error 1\');\n            }\n        } else {\n            nuDebug(\'register_no_lesson_cards - retrive error 2\');\n        } \n    } else {\n        nuDebug(\'register_no_lesson_cards - Hash Variables NOT set properly\');   \n    }\n} else {\n   nuDebug(\'register_no_lesson_cards - Hash Variables NOT set properly\'); \n}\n','','0','2015-04-22 20:19:03','globeadmin','2017-02-01 16:15:48','globeadmin','2019-03-10 16:15:24','globeadmin','0'),('5539081d564cca6','print_absence_all_classes_day_table','Εκτύπωση απουσιολογίου όλων των τμημάτων ενός καθηγητή μιας ημέρας','teacher','function have_card($array, $key){\n    foreach ($array as $c) {\n        if($c[1]==$key){\n            return $c;\n        }\n    }\n    return;\n}\n\n\nfunction have_absence($absence_array, $student_id,$card){\n    foreach ($absence_array as $absence) {\n        if($absence[0]==$student_id && $absence[3]==$card[1]){// && $absence[4]==$card[0]){\n                return $absence;\n        }\n    }\n    return;\n}\n\n$sql=\"DROP TEMPORARY TABLE IF EXISTS #TABLE_ID#\";\nnuRunQuery($sql);\n\n$sql=\"CREATE TEMPORARY TABLE #TABLE_ID# (\n        school_name VARCHAR(100) CHARACTER SET \'utf8\' COLLATE \'utf8_general_ci\' NOT NULL,\n        school_year_name VARCHAR(100) CHARACTER SET \'utf8\' COLLATE \'utf8_general_ci\' NOT NULL,\n        cur_date VARCHAR(50) CHARACTER SET \'utf8\' COLLATE \'utf8_general_ci\' NOT NULL,\n        abs_date VARCHAR(50) CHARACTER SET \'utf8\' COLLATE \'utf8_general_ci\' NOT NULL,\n        class_id INT NOT NULL,\n        class_name VARCHAR(50) CHARACTER SET \'utf8\' COLLATE \'utf8_general_ci\' NOT NULL,\n        student_name VARCHAR(255) CHARACTER SET \'utf8\' COLLATE \'utf8_general_ci\' NOT NULL,\n        hls INT NOT NULL,\n        aa VARCHAR(5) CHARACTER SET \'utf8\' COLLATE \'utf8_general_ci\' NULL\n) DEFAULT CHARACTER SET=utf8\";\nnuRunQuery($sql);\n\n$error_message=\'\';\n\nif (\'#absence_date#\'==\'#\'.\'absence_date\'.\'#\' || \'#absence_date#\'==\'\'){\n    $absence_date = date(\'Y-m-d\');\n} else {\n    $absence_date = date_format(date_create_from_format(\'d-m-Y\',\'#absence_date#\'),\'Y-m-d\');\n}  \n    \n$day_of_week = idate(\'w\', strtotime($absence_date))-1;\n\n    $sql=\"SELECT count(*) FROM day WHERE id=\".$day_of_week;\n    $rv1=nuRunQuery($sql);\n    \n    if($rv1 && db_num_rows($rv1)>0){\n        $row1 = db_fetch_row($rv1);\n\n        if($row1[0]==1){\n            $sql=\"SELECT start_date,end_date,school.name, school_year.name FROM school,school_year WHERE school.school_year_id=school_year.id\";\n            $rv2=nuRunQuery($sql);\n\n            if($rv2 && db_num_rows($rv2)>0){\n                $row2 = db_fetch_row($rv2);\n                    \n                $school_name=$row2[2];\n                $school_year_name=$row2[3];\n                    \n                if($absence_date>=$row2[0] && $absence_date<=$row2[1]){\n                    $sql=\"  select if(\'\".$absence_date.\"\' in (SELECT holiday.holiday \n                            FROM school,school_year,holiday \n                            WHERE school.school_year_id = school_year.id and holiday.school_year_id=school_year.id \n                            ORDER BY holiday.holiday),\'1\',\'0\')\";   \n                    $rv3=nuRunQuery($sql);\n                    if($rv3 && db_num_rows($rv3)>0){\n                        $row3 = db_fetch_row($rv3);\n                        if($row3[0]==0){                            // ΟΛΑ ΚΑΛΑ! Δημιουργία απουσιολογίου\n                        \n                            $sql=\"SELECT id,name,short_name FROM period\";\n                            $rv4=nuRunQuery($sql);\n                            $num_of_periods=db_num_rows($rv4);\n                            $cnt=0;\n                            $period_array = array();\n                            \n                            while($period_row=db_fetch_row($rv4)){\n                                $period_array[]= array($period_row[0],$period_row[1],$period_row[2]);\n                                $cnt++;\n                                $sql=\"ALTER TABLE #TABLE_ID# \n                                        ADD COLUMN period_name\".$cnt.\" VARCHAR(50) CHARACTER SET \'utf8\' COLLATE \'utf8_general_ci\' NULL,\n                                        ADD COLUMN subject_name\".$cnt.\" VARCHAR(255) CHARACTER SET \'utf8\' COLLATE \'utf8_general_ci\' NULL,\n                                        ADD COLUMN absence_name\".$cnt.\" VARCHAR(50) CHARACTER SET \'utf8\' COLLATE \'utf8_general_ci\' NULL\n                                        \";\n                                nuRunQuery($sql);\n                            }\n                            \n                            $sql=\"select max(valid_from) from card where valid_from<=\'\".$absence_date.\"\'\"; \n                            $rv6=nuRunQuery($sql);\n                            $card_date = db_fetch_row($rv6);\n\n                            $sql=\"  select id,short_name \n                                    from class \n                                    where \n                                        (post_teacher_id=#RECORD_ID# OR \n                                        \'#nu_user_group#\'=\'Managers\' OR\n                                        \'#nu_user_group#\'=\'Administrators\' OR\n                                        \'#nu_user_group#\'=\'Secretaries\' OR\n                                        \'#nu_user_group#\'=\'AssistManagers\' OR\n                                        \'#nu_user_group#\'=\'globeadmin\') and\n                                        id in (select distinct class_id from student_class) and\n                                        (   select count(*) \n                                            from card \n                                            where \n                                                valid_from=\'\".$card_date[0].\"\' and\n                                                card.class_id=class.id and\n                                                day_id=\".$day_of_week.\") > 0\n                                    order by short_name\";    \n                                \n                            $rv5=nuRunQuery($sql);\n                            $class_array = array();\n                                \n                            while($class_row=db_fetch_row($rv5)){\n                                $class_array[]= array($class_row[0],$class_row[1]);  \n                            }\n                            \n                            foreach ($class_array as $class_row) {\n                                                           // Βρίσκω τις διδασκαλίες του τμήματος τη συγκρκριμένη μέρα\n                                $sql=\"  SELECT \n                                                    card.id,\n                                                    card.period_id,\n                                                    teacher.short_name,\n                                                    subject.name,\n                                                    classroom.short_name,\n                                                    if(rg.id is NULL,0,1),\n                                                    if(rg.id is NULL,0,rg.no_lesson)\n                                                FROM card\n                                                inner join teacher on card.teacher_id=teacher.id\n                                                inner join subject on card.subject_id=subject.id\n                                                LEFT join classroom on card.classroom_id=classroom.id\n                                                LEFT JOIN (\n                                                            select registered_card.id as id,registered_card.card_id as card_id,registered_card.no_lesson as no_lesson\n                                                            from registered_card\n                                                            where DATE_FORMAT(registered_card.card_date, \'%Y-%m-%d\')=\'\".$absence_date.\"\') as rg on card.id=rg.card_id\n                                                WHERE\n                                                    valid_from=\'\".$card_date[0].\"\' and\n                                                    card.class_id=\".$class_row[0].\" and\n                                                    day_id=\".$day_of_week;\n                                    \n                                $rv_card=nuRunQuery($sql);\n                                $card_array = array();\n                                \n                                while($card_row=db_fetch_row($rv_card)){\n                                    $card_array[]= array($card_row[0],$card_row[1],$card_row[2],$card_row[3],$card_row[4],$card_row[5],$card_row[6]);  \n                                }\n                                                                                // Βρίσκω τις ήδη καταχωρημένες απουσίες τη συγκρκριμένη μέρα\n                                $sql=\"  SELECT  \n                                        student.id,\n                                        absence_reason.short_name,\n                                        absence_reason.name,\n                                        card.period_id,\n                                        card.id\n                                    FROM \n                                        absence,\n                                        student,\n                                        student_class,\n                                        absence_reason,\n                                        card\n                                    WHERE \n                                        absence.student_id = student.id and\n                                        absence.card_id = card.id and\n                                        student_class.student_id = student.id and\n                                        absence_reason.id = absence.absence_reason_id and\n                                        student_class.class_id=\".$class_row[0].\" and\n                                        DATE_FORMAT(absence_date, \'%Y-%m-%d\')=\'\".$absence_date.\"\'\";\n                                $rv_absence=nuRunQuery($sql);\n                                $absence_array = array();\n                            \n                                while($absence_row=db_fetch_row($rv_absence)){\n                                    $absence_array[]= array($absence_row[0],$absence_row[1],$absence_row[2],$absence_row[3],$absence_row[4]);  \n                                }                                \n                            \n                                $insert_sql=\"insert into #TABLE_ID# values (\'\".$school_name.\"\', \'\".$school_year_name.\"\', DATE_FORMAT(CURDATE(),\'%d-%m-%Y\'), DATE_FORMAT(\'\".$absence_date.\"\',\'%d-%m-%Y\'), \'\".$class_row[0].\"\', \'\".$class_row[1].\"\', \'Μαθητής/Ώρα\',0,\'ΑΑ\'\";\n                        \n                                $lesson_array = array();\n                            \n                                foreach ($period_array as $period_row) {\n    \n                                    $lesson = \'\';\n                                    foreach ($card_array as $card) {\n                                        if($card[1]==$period_row[0]){\n                                            $lesson = $card[3];\n                                            \n                                            if(!is_null($card[4])){\n                                                $lesson = $lesson.\', Αιθ. \'.$card[4];\n                                            }\n                                        }\n                                    }\n                                    \n                                    foreach ($card_array as $card) {\n                                        if($card[1]==$period_row[0]){\n                                            if($lesson == \'\'){\n                                                $lesson = $card[2];\n                                            } else {\n                                                $lesson = $lesson.\', \'.$card[2];\n                                            }\n                                        }\n                                    }\n                                    \n                                    $registered=false;\n                                    foreach ($card_array as $card) {\n                                        if($card[1]==$period_row[0] && $card[5]==1){\n                                                if($card[6]==1){\n                                                    if(!$registered){$lesson = \'ΚΕΝΟ - \'.$lesson;}\n                                                } else {\n                                                    if(!$registered){$lesson = \'Καταχωρημένο - \'.$lesson;}\n                                                }\n                                                $registered=true;\n                                        }\n                                    }                                    \n                                    \n                                    if($lesson == \'\'){\n                                        $lesson = \'#F#555555|Μάθημα με άλλο τμήμα\';\n                                    }\n                                    \n                                    $lesson_array[]= array($period_row[1],$lesson);\n                                    \n                                    $insert_sql=$insert_sql.\", \'\".$period_row[1].\"\' ,\'\".$lesson.\"\' , \'\".$period_row[2].\"\'\";\n                                }\n                                \n                                $insert_sql=$insert_sql.\")\";\n                                nuRunQuery($insert_sql);\n\n                                $sql=\"  SELECT registration_number,surname,name,fathers_name,has_left_school,student.id\n                                    FROM student \n                                    inner join student_class on student.id=student_class.student_id\n                                    WHERE student_class.class_id=\".$class_row[0].\"\n                                    order by surname,name,fathers_name\";\n                                $rv_student=nuRunQuery($sql);\n                                \n                                $j=0;\n                                while($row_student = db_fetch_row($rv_student)){\n                                    $j++;\n                                    if(\'#show_regnchk#\'==\'1\'){ \n                                        $student_name= str_pad($j, 2, \"0\", STR_PAD_LEFT).\'. \'.$row_student[1].\' \'.$row_student[2].\' - \'.$row_student[3];    \n                                    } else {\n                                        $student_name= $row_student[0].\' - \'.$row_student[1].\' \'.$row_student[2].\' - \'.$row_student[3];    \n                                    }\n                                    \n                                    if($row_student[4]==1){\n                                        $student_name=\'#B#D3D3D3|\'.$student_name;\n                                    }\n\n                                    $insert_sql=\"insert into #TABLE_ID# values (\'\".$school_name.\"\', \'\".$school_year_name.\"\', DATE_FORMAT(CURDATE(),\'%d-%m-%Y\'), DATE_FORMAT(\'\".$absence_date.\"\',\'%d-%m-%Y\'), \'\".$class_row[0].\"\', \'\".$class_row[1].\"\', \'\".$student_name.\"\',\".$row_student[4].\", \'\".$j.\"\'\";\n                                \n                                    for($i=1;$i<=$num_of_periods;$i++){\n                                    \n                                        $class_id=\'period\'.$i;\n                                    \n                                        if($card = have_card($card_array,$i)){\n                                            if($card[5]!=1){\n                                                $insert_sql=$insert_sql.\", \'\".$lesson_array[$i-1][0].\"\' ,\'\".$lesson_array[$i-1][1].\"\' ,\'\".($row_student[4]==1 ? \'#B#D3D3D3|\' : \'\' ).\"\'\";\n                                            } else {\n                                                if($s=have_absence($absence_array,$row_student[5],$card)){\n                                                    $insert_sql=$insert_sql.\", \'\".$lesson_array[$i-1][0].\"\' ,\'\".$lesson_array[$i-1][1].\"\' , \'\".($row_student[4]==1 ? \'#B#D3D3D3|\'.$s[1] : $s[1] ).\"\'\";\n                                                } else {\n                                                    if($card[6]!=1){\n                                                        $insert_sql=$insert_sql.\", \'\".$lesson_array[$i-1][0].\"\' ,\'\".$lesson_array[$i-1][1].\"\' , \'\".($row_student[4]==1 ? \'#B#D3D3D3|#F#555555|Π\' : \'#F#555555|Π\' ).\"\'\";\n                                                    } else {\n                                                        $insert_sql=$insert_sql.\", \'\".$lesson_array[$i-1][0].\"\' ,\'\".$lesson_array[$i-1][1].\"\' , \'\".($row_student[4]==1 ? \'#B#D3D3D3|#F#555555|-\' : \'#F#555555|-\' ).\"\'\";\n                                                    }\n                                                    \n                                                }\n                                            }\n                                        } else {\n                                            $insert_sql=$insert_sql.\", \'\".$lesson_array[$i-1][0].\"\' ,\'\".$lesson_array[$i-1][1].\"\' , \'\".($row_student[4]==1 ? \'#B#D3D3D3|X\' : \'X\' ).\"\'\";    \n                                        }\n                                        \n                                    }\n                                     \n                                    $insert_sql=$insert_sql.\")\";\n                                    nuRunQuery($insert_sql);\n                                }\n                            }\n                        } else {\n                            $error_message = \"Δεν μπορείτε να τυπώσετε απουσίες σε ημερομηνίες αργιών...\";\n                        }\n                    } else {\n                        $error_message = \"Παρουσιάστηκε πρόβλημα στην ανάκτηση των δεδομένων...\";\n                    }\n                } else {\n                    $error_message = \"Μπορείτε να τυπώσετε απουσίες μόνο εντός του τρέχοντος σχολικού έτους...\";\n                }\n            } else {\n                $error_message = \"Παρουσιάστηκε πρόβλημα στην ανάκτηση των δεδομένων...\"; \n            }\n        } else {\n            $error_message = \"Παρακαλώ επιλέξτε ημερομηνία με ημέρα λειτουργίας τους σχολείου...\";  \n        }\n    } else {\n        $error_message = \"Παρουσιάστηκε πρόβλημα στην ανάκτηση των δεδομένων...\";    \n    }\n    \nif($error_message!=\'\'){\n    nuDisplayError($error_message);\n}\n\n','','0','2015-04-23 17:56:29','globeadmin','2021-01-26 10:06:21','globeadmin','2021-01-26 10:06:21','globeadmin','0'),('553fe1e308e7e3a','search_studens_registered_card','Βρίσκει καταχωρημένη διδασκαλία για μαθητή ημέρα και ώρα','teacher','print \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n        \n        <script type=\\\"text/javascript\\\">\n            function show_absence_info(absence_id){\n                parent.nuOpenFormInFrame(\'5509671b4e81a07\',absence_id)    \n            }\n        </script>\n\n        <STYLE TYPE=\\\"text/css\\\">\n            .sisTable TD, .sisTable TH{\n                font-size:9pt;\n            }\n        </STYLE>\n\n    </head>\n\n    <body>\";\n\n$sql=\"  SELECT \n                class.short_name,\n                subject.name,\n                teacher.short_name,\n                card.id,\n                registered_card.no_lesson\n        FROM registered_card\n            inner join card on registered_card.card_id=card.id\n            inner join subject on card.subject_id=subject.id\n            inner join teacher on card.teacher_id=teacher.id\n            inner join class on card.class_id=class.id\n        WHERE \n            card_date=\'#absence_date#\'\n            and card.period_id=#period#\n            and card.class_id in (select distinct class_id from student_class where student_id=#student#)\";\n$retval=nuRunQuery($sql);\n\nif($retval){\n    if (db_num_rows($retval)>0){\n        $teachers_names=\'\';\n        \n        $card_array = array();\n        \n        while($row=db_fetch_row($retval)){\n            \n            $card_array[]= $row[3];\n            \n            $class_short_name=$row[0];\n            $subject_name=$row[1];\n            $no_lesson=$row[4];\n            \n            if($teachers_names==\'\'){\n                $teachers_names=$row[2];\n            } else {\n                $teachers_names=$teachers_names.\', \'.$row[2];   \n            }\n        }\n        \n        $sql = \"SELECT absence.id,absence_reason.short_name,absence_reason.name\n                FROM absence\n                INNER JOIN absence_reason ON absence.absence_reason_id=absence_reason.id\n                WHERE\n                    absence_date=\'#absence_date#\' AND\n                    student_id=#student# AND\n                    card_id IN (\".implode(\',\',$card_array).\")\";\n        $rv = nuRunQuery($sql);\n        \n        if($rv && db_num_rows($rv)>0) {\n            $row=db_fetch_row($rv);\n            \n            $have_absence=true;\n            $absence_id=$row[0];\n            $absence_short_name=$row[1];\n            $absence_name=$row[2];\n        }\n        \n        $bcolor = ( $have_absence ? \'DarkRed\' : ($no_lesson ? \'DarkOliveGreen\' : \'LightGreen\' ));\n        $fcolor = ( $have_absence ? \'white\' : ($no_lesson ? \'white\' : \'black\' ));\n        \n        print (\"\n        <table CLASS=\\\"sisTable\\\" cellspacing=0 align=center>\n            <tr height=50>\n                    <th width=100 align=center>Τμήμα</th>\n                    <th width=350 align=center>Μάθημα</th>\n                    <th width=350 align=center>Καθηγητής</th>\n            </tr>\n                    \n            <tr style=\\\"background-color:$bcolor;\\\" height=50>\n                    <td align=center><font color=\".$fcolor.\">\".$class_short_name.\"</font></td>\n                    <td align=center><font color=\".$fcolor.\">\".$subject_name.\"</font></td>\n                    <td align=center><font color=\".$fcolor.\">\".$teachers_names.\"</font></td>\n            </tr>\n            <tr style=\\\"background-color:$bcolor;\\\" height=50>\n                <td colspan=3 valign=\\\"middle\\\" align=center>\");\n        \n        if(!$have_absence){\n            if($no_lesson){\n                print (\"<b><i><font color=\".$fcolor.\">Η διδασκαλία αυτή δεν πραγματοποιήθηκε (κενό)!</font></i></b>\");    \n            } else {\n                print (\"<b><i><font color=\".$fcolor.\">Δεν υπάρχει καταχωρημένη απουσία!</font></i></b>\");                \n            }\n    \n        } else {\n            print (\"<b><i><font color=\".$fcolor.\">Καταχωρημένη \".$absence_name.\" στο μαθητή! <img src=\\\"images/info.png\\\" onclick=\\\"show_absence_info(\".$absence_id.\")\\\" onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\" title=\\\"Πληροφορίες Απουσίας\\\"></font></i></b>\");                \n        }\n        print(\"\n                </td>\n            </tr>\n        </table>\");\n       \n    } else {\n        print (\"<span CLASS=\\\"msg\\\">Δε βρέθηκαν καταχωρημένες διδασκαλίες...</span>\");    \n    }\n} else {\n    print (\"<span CLASS=\\\"msgError\\\">Παρουσιάστηκε πρόβλημα κατά την ανάκτηση των δεδομένων!<br>Παρακαλώ ξαναπροσπαθήστε...</span>\");    \n}\n\nprint (\"\n    </body>\n</html>\");\n','','0','2015-04-28 22:39:15','globeadmin','2018-07-16 10:50:41','globeadmin','2018-07-16 23:22:52','globeadmin','0'),('5541240a041c4ee','add_student_registered_absence','Καταχωρεί απουσία σε έναν μαθητή σε ήδη καταχωρημένη διδασκαλία','teacher','nuRunPHP(\'notification_add_lib\');\n\n$sql=\"  SELECT \n                class.short_name,\n                subject.name,\n                teacher.short_name,\n                card.id,\n                registered_card.no_lesson,\n                subject.absence_counts\n        FROM registered_card\n            inner join card on registered_card.card_id=card.id\n            inner join subject on card.subject_id=subject.id\n            inner join teacher on card.teacher_id=teacher.id\n            inner join class on card.class_id=class.id\n        WHERE \n            card_date=\'#absence_date#\'\n            and card.period_id=#period#\n            and card.class_id in (select distinct class_id from student_class where student_id=#student#)\";\nnuDebug($sql);\n$retval=nuRunQuery($sql);\n\n$msg=\'\';\n\nif($retval){\n    if (db_num_rows($retval)>0){\n    \n        $teachers_names=\'\';\n        \n        $card_array = array();\n        \n        while($row=db_fetch_row($retval)){\nnuDebug(print_r($row,1));           \n            $card_array[]= $row[3];\n            \n            $class_short_name=$row[0];\n            $subject_name=$row[1];\n            $absence_counts=$row[5];\n            $no_lesson=$row[4];\n            \n            if($teachers_names==\'\'){\n                $teachers_names=$row[2];\n            } else {\n                $teachers_names=$teachers_names.\', \'.$row[2];   \n            }\n        }\n        \n        $sql = \"SELECT absence.id,absence_reason.short_name,absence_reason.name\n                FROM absence\n                INNER JOIN absence_reason ON absence.absence_reason_id=absence_reason.id\n                WHERE\n                    absence_date=\'#absence_date#\' AND\n                    student_id=#student# AND\n                    card_id IN (\".implode(\',\',$card_array).\")\";\n        $rv = nuRunQuery($sql);\n        \n        if($rv && db_num_rows($rv)>0) {\n            $row=db_fetch_row($rv);\n            \n            $have_absence=true;\n            $absence_id=$row[0];\n            $absence_short_name=$row[1];\n            $absence_name=$row[2];\n        }\n        \n        if(!$have_absence){\n           if(!$no_lesson){ \n                $sql=\"INSERT INTO absence (\n                        id,\n                        absence_date,\n                        posted_when,\n                        post_teacher_id,\n                        student_id,\n                        card_id,\n                        absence_reason_id,\n                        comments,\n                        \n                        justified,\n                        justified_when,\n                        justified_comments,\n                        counts,\n                        justified_teacher_id,\n                        justified_reason_id                        \n                        ) VALUES (\n                        NULL,\n                        \'#absence_date#\',\n                        \'\".date(\'Y-m-d H:i:s\').\"\',\n                        #RECORD_ID#,\n                        #student#,\n                        \".$card_array[0].\",\n                        #absence_type#,\n                        NULL,\n                        \n                        \".($absence_counts==\'1\'? \'0\': \'1\').\",\n                        \".($absence_counts==\'1\'? \'NULL\': \"\'\".date(\'Y-m-d H:i:s\'.\"\'\")).\",\n                        \".($absence_counts==\'1\'? \'NULL\': \"\'Στο αντίστοιχο μάθημα έχει οριστεί ότι οι απουσίες δεν προσμετρούνται\'\").\",\n                        \".($absence_counts==\'1\'? \'1\': \'0\').\",\n                        \".($absence_counts==\'1\'? \'NULL\': \'#RECORD_ID#\').\",\n                        \".($absence_counts==\'1\'? \'NULL\': \'0\').\")\";\n                        \n                    $new_id = nuRunQuery($sql,null,true);\n                    new_absence_notification($new_id);\n                    if($absence_counts!=\'1\') justify_absence_notification($new_id);\n        \n           } else {\n                $msg=\"<span CLASS=\\\"msg\\\">Η διδασκαλία αυτή δεν πραγματοποιήθηκε (κενό)!<br>Δεν μπορεί να γίνει καταχώριση απουσίας...</span>\";   \n           }\n        } else {\n            $msg=\"<span CLASS=\\\"msgError\\\">Ο μαθητής έχει ήδη καταχωρημένη απουσία αυτή την ώρα!<br>Δεν μπορεί να γίνει νέα καταχώριση...</span>\";\n        }\n    } else {\n        $msg=\"<span CLASS=\\\"msg\\\">Δε βρέθηκαν καταχωρημένες διδασκαλίες...</span>\";\n    }\n} else {\n    $msg=\"<span CLASS=\\\"msgError\\\">Παρουσιάστηκε πρόβλημα κατά την ανάκτηση των δεδομένων...</span>\";\n}\n\nif($msg!=\'\'){\n    print \"<html>\n        <head>\n            <meta charset=\\\"UTF-8\\\">\n            <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n        </head>\n\n        <body>\n            $msg\n        </body>\n    </html>\";\n} else {\n    nuRunPHP(\'search_studens_registered_card\');    \n}\n\n','','0','2015-04-29 21:33:46','globeadmin','2019-11-05 13:05:07','globeadmin','2019-11-05 13:05:07','globeadmin','0'),('554797f3cce46e4','student_cards_not_registered','Βρίσκει τις διδασκαλίες του μαθητή σε μια συγκεκριμένη ημερομηνία για τις οποίες δεν έχουν καταχωρηθεί απουσίες','teacher','print \"\n<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n        \n        <STYLE TYPE=\\\"text/css\\\">\n            .mytable TH{\n                font-size:1.1em;\n            }\n        </STYLE>\n    </head>\n    <body>\";\n\n\nif (\'#absence_date#\'!=\'#\'.\'absence_date\'.\'#\' && \'#absence_date#\'!=\'\'){\n\n    $absence_date = date_format(date_create_from_format(\'d-m-Y\',\'#absence_date#\'),\'Y-m-d\');\n            \n    print (\"\n        <table cellspacing=0 CLASS=\\\"sisTable\\\" align=center>\n            <tr height=45>\n                <th width=80 align=center>Ημερομηνία</th>\n                <th width=80 align=center>Ημέρα</th>\n                <th width=50 align=center>Ώρα</th>\n                <th width=50 align=center>Τμήμα</th>\n                <th width=220 align=center>Μάθημα</th>\n                <th width=160 align=center>Καθηγητής</th>\n                <th width=50 align=center>Αίθουσα</th>\n                <th width=160 align=center>Καταχωρητής</th>\n            </tr>\");\n\n    $day_of_week = idate(\'w\', strtotime($absence_date))-1;\n                                \n    $sql=\"select max(valid_from) from card where valid_from<=\'\".$absence_date.\"\'\"; \n    $retval=nuRunQuery($sql);\n    $row = db_fetch_row($retval);\n    $card_date=$row[0];\n\n    $sql=\"          SELECT \n                        card.id,\n                        day.name,\n                        period.short_name,\n                        class.short_name,\n                        subject.name,\n                        t1.short_name,\n                        classroom.short_name,\n                        t2.short_name\n                    FROM card\n                        INNER JOIN      teacher as t1   on      card.teacher_id=t1.id\n                        INNER JOIN      subject         on      card.subject_id=subject.id\n                        INNER JOIN      class           on      card.class_id=class.id\n                        INNER JOIN      period          on      card.period_id=period.id\n                        INNER JOIN      day             on      card.day_id=day.id\n                        LEFT  JOIN      classroom       on      card.classroom_id=classroom.id\n                        LEFT JOIN       teacher as t2   on      class.post_teacher_id=t2.id\n                    WHERE\n                        valid_from=\'\".$card_date.\"\' and\n                        day_id=\".(idate(\'w\', strtotime($absence_date))-1).\" and\n                        card.id not in ( select card_id \n                                from registered_card\n                                where DATE_FORMAT(registered_card.card_date, \'%Y-%m-%d\')=\'\".$absence_date.\"\') and\n                        \'\".$absence_date.\"\' not in ( select holiday.holiday \n                                                from holiday \n                                                    inner join school_year on holiday.school_year_id=school_year.id\n                                                    inner join school on school.school_year_id=school_year.id) and\n                        card.class_id in (select distinct class_id from student_class where student_id=#RECORD_ID#)\n                    ORDER BY \n                        period.id,class.short_name,t1.short_name\";\n                                                        \n    $retval=nuRunQuery($sql);\n            \n    if($retval){\n        if(db_num_rows($retval)>0){\n            while($row = db_fetch_row($retval)) {\n                print (\"\n                <tr height=35>\n                    <td align=center>\".date(\"d-m-Y\",strtotime($absence_date)).\"</td>\n                    <td align=center>\".(is_null($row[1]) || $row[1]==\'\'? \'&nbsp;\' : $row[1]).\"</td>\n                    <td align=center>\".(is_null($row[2]) || $row[2]==\'\'? \'&nbsp;\' : $row[2]).\"</td>\n                    <td align=center>\".(is_null($row[3]) || $row[3]==\'\'? \'&nbsp;\' : $row[3]).\"</td>\n                    <td align=left>\".(is_null($row[4]) || $row[4]==\'\'? \'&nbsp;\' : $row[4]).\"</td>\n                    <td align=left>\".(is_null($row[5]) || $row[5]==\'\'? \'&nbsp;\' : $row[5]).\"</td>\n                    <td align=center>\".(is_null($row[6]) || $row[6]==\'\'? \'&nbsp;\' : $row[6]).\"</td>\n                    <td align=left>\".(is_null($row[7]) || $row[7]==\'\'? \'&nbsp;\' : $row[7]).\"</td>\n                </tr>\");                    \n            }\n        } else {\n            print \"<span CLASS=\\\"msg\\\">Δε βρέθηκαν δεδομένα...</span>\";    \n        }\n    } else{\n        print \"<span CLASS=\\\"msgError\\\">Παρουσιάστηκε σφάλμα κατά την ανάκτηση των δεδομένων...</span>\";\n    }    \n} else {\n   print \"<span CLASS=\\\"msg\\\">Παρακαλώ ορίστε την ημερομηνία απουσιών...</span>\"; \n}\n\nprint \"\n    </body>\n</html>\";','','0','2015-05-04 19:01:55','globeadmin','2018-07-15 23:10:11','globeadmin','2019-08-05 23:29:45','globeadmin','0'),('5547a512d1c5bd2','student_cards_not_registered_msg','Βρίσκει σε πόσες διδασκαλίες του μαθητή σε μια συγκεκριμένη ημερομηνία δεν έχουν καταχωρηθεί απουσίες','teacher','print \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\"> \n\n        <STYLE TYPE=\\\"text/css\\\">\n            .sisTable TH{\n                font-size:1.1em;\n            }\n        </STYLE>\n    </head>\n    <body>\";\n\n\nif (\'#absence_date#\'!=\'#\'.\'absence_date\'.\'#\' && \'#absence_date#\'!=\'\'){\n\n    $absence_date=\'#absence_date#\';\n    $cur_date = date(\"Y-m-d\");\n    \n    if($absence_date<=$cur_date){\n        $day_of_week = idate(\'w\', strtotime($absence_date))-1;\n                                \n        $sql=\"select max(valid_from) from card where valid_from<=\'\".$absence_date.\"\'\"; \n        $retval=nuRunQuery($sql);\n        $row = db_fetch_row($retval);\n        $card_date=$row[0];\n\n        $sql=\"  SELECT count(distinct period_id)\n                FROM card\n                WHERE\n                    valid_from=\'\".$card_date.\"\' and\n                    day_id=\".(idate(\'w\', strtotime($absence_date))-1).\" and\n                    card.id not in (    select card_id \n                                        from registered_card\n                                        where DATE_FORMAT(registered_card.card_date, \'%Y-%m-%d\')=\'\".$absence_date.\"\') and\n                    \'\".$absence_date.\"\' not in (    select holiday.holiday \n                                                    from holiday \n                                                    inner join school_year on holiday.school_year_id=school_year.id\n                                                    inner join school on school.school_year_id=school_year.id) and\n                    card.class_id in (select distinct class_id from student_class where student_id=#RECORD_ID#)\";\n\n        $retval=nuRunQuery($sql);\n            \n        if($retval){\n            $row = db_fetch_row($retval);\n            print (\"\n        <table align=center cellspacing=0 CLASS=\\\"sisTable\\\" width=750 height=35>\n            <tr height=35>\");\n        \n            if($row[0]>0){\n                print (\"\n                <td style=\\\"background-color:OrangeRed;\\\" align=center valign=middle>\n                    Υπάρχουν <b>\".$row[0].\"</b> διδασκαλίες που δεν έχουν καταχωρηθεί σε αυτήν την ημερομηνία! Είναι πιθανόν να προστεθούν και άλλες απουσίες! \n                    <img src=\\\"images/info.png\\\" onclick=\\\"parent.nuOpenFormInFrame(\'55479f1837f6df0\', \'#RECORD_ID#\')\\\" onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\" title=\\\"Περισσότερες πληροφορίες για τις διδασκαλίες αυτές\\\">\n                </td>\");    \n            } else {\n                print (\"\n                <td style=\\\"background-color:lightgreen;\\\" align=center valign=middle>\n                    Όλες οι διδασκαλίες έχουν καταχωρηθεί σε αυτήν την ημερομηνία!\n                    <img src=\\\"images/info.png\\\" onclick=\\\"parent.nuOpenFormInFrame(\'55479f1837f6df0\', \'#RECORD_ID#\')\\\" onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\" title=\\\"Περισσότερες πληροφορίες για τις διδασκαλίες αυτές\\\">\n                </td>\");    \n            }\n                      \n            print (\"\n            </tr>\n        </table>\");                    \n        } else{\n            print \"<span CLASS=\\\"msgError\\\">Παρουσιάστηκε σφάλμα κατά την ανάκτηση των δεδομένων...</span>\";;\n        }\n    } else {\n            print (\"\n        <table align=center cellspacing=0 CLASS=\\\"sisTable\\\" width=750 height=35>\n            <tr height=35>\n                <td style=\\\"background-color:Magenta;\\\" align=center valign=middle><b>Δεν μπορείτε να δικαιολογήσετε απουσίες σε μελλοντική ημερομηνία!</b></td>\n            </tr>\n        </table>\");    \n    }\n} \nprint \"\n    </body>\n</html>\";','','0','2015-05-04 19:57:54','globeadmin','2018-07-16 10:24:31','globeadmin','2018-07-16 10:24:31','globeadmin','0'),('563634de56f2b28','old_print_absence_all_classes_day_table','Παλαιό - Εκτύπωση απουσιολογίου όλων των τμημάτων ενός καθηγητή μιας ημέρας','teacher','function have_card($array, $key){\n    foreach ($array as $c) {\n        if($c[1]==$key){\n            return true;\n        }\n    }\n    return false;\n}\n\nfunction have_registered($array, $period){\n    foreach ($array as $card) {\n        if($card[1]==$period && $card[5]==1){\n                return true;\n        }\n    }\n    return false;\n}\n\nfunction have_no_lesson($array, $period){\n    foreach ($array as $card) {\n        if($card[1]==$period && $card[6]==1){\n                return true;\n        }\n    }\n    return false;\n}\n\nfunction have_adsence($absence_array, $student_id,$period_id){\n    foreach ($absence_array as $absence) {\n        if($absence[0]==$student_id && $absence[3]==$period_id){\n                return $absence;\n        }\n    }\n    return false;\n}\n\n$sql=\"DROP TEMPORARY TABLE IF EXISTS #TABLE_ID#\";\nnuRunQuery($sql);\n\n$sql=\"CREATE TEMPORARY TABLE #TABLE_ID# (\n        school_name VARCHAR(100) CHARACTER SET \'utf8\' COLLATE \'utf8_general_ci\' NOT NULL,\n        school_year_name VARCHAR(100) CHARACTER SET \'utf8\' COLLATE \'utf8_general_ci\' NOT NULL,\n        cur_date VARCHAR(50) CHARACTER SET \'utf8\' COLLATE \'utf8_general_ci\' NOT NULL,\n        abs_date VARCHAR(50) CHARACTER SET \'utf8\' COLLATE \'utf8_general_ci\' NOT NULL,\n        class_id INT NOT NULL,\n        class_name VARCHAR(50) CHARACTER SET \'utf8\' COLLATE \'utf8_general_ci\' NOT NULL,\n        student_name VARCHAR(255) CHARACTER SET \'utf8\' COLLATE \'utf8_general_ci\' NOT NULL,\n        hls INT NOT NULL,\n        aa VARCHAR(5) CHARACTER SET \'utf8\' COLLATE \'utf8_general_ci\' NULL\n) DEFAULT CHARACTER SET=utf8\";\nnuRunQuery($sql);\n\n$error_message=\'\';\n\nif (\'#absence_date#\'==\'#\'.\'absence_date\'.\'#\' || \'#absence_date#\'==\'\'){\n    $absence_date = date(\'Y-m-d\');\n} else {\n    $absence_date = date_format(date_create_from_format(\'d-m-Y\',\'#absence_date#\'),\'Y-m-d\');\n}  \n    \n$day_of_week = idate(\'w\', strtotime($absence_date))-1;\n\n    $sql=\"SELECT count(*) FROM day WHERE id=\".$day_of_week;\n    $rv1=nuRunQuery($sql);\n    \n    if($rv1 && db_num_rows($rv1)>0){\n        $row1 = db_fetch_row($rv1);\n\n        if($row1[0]==1){\n            $sql=\"SELECT start_date,end_date,school.name, school_year.name FROM school,school_year WHERE school.school_year_id=school_year.id\";\n            $rv2=nuRunQuery($sql);\n\n            if($rv2 && db_num_rows($rv2)>0){\n                $row2 = db_fetch_row($rv2);\n                    \n                $school_name=$row2[2];\n                $school_year_name=$row2[3];\n                    \n                if($absence_date>=$row2[0] && $absence_date<=$row2[1]){\n                    $sql=\"  select if(\'\".$absence_date.\"\' in (SELECT holiday.holiday \n                            FROM school,school_year,holiday \n                            WHERE school.school_year_id = school_year.id and holiday.school_year_id=school_year.id \n                            ORDER BY holiday.holiday),\'1\',\'0\')\";   \n                    $rv3=nuRunQuery($sql);\n                    if($rv3 && db_num_rows($rv3)>0){\n                        $row3 = db_fetch_row($rv3);\n                        if($row3[0]==0){                            // ΟΛΑ ΚΑΛΑ! Δημιουργία απουσιολογίου\n                        \n                            $sql=\"SELECT id,name,short_name FROM period\";\n                            $rv4=nuRunQuery($sql);\n                            $num_of_periods=db_num_rows($rv4);\n                            $cnt=0;\n                            $period_array = array();\n                            \n                            while($period_row=db_fetch_row($rv4)){\n                                $period_array[]= array($period_row[0],$period_row[1],$period_row[2]);\n                                $cnt++;\n                                $sql=\"ALTER TABLE #TABLE_ID# \n                                        ADD COLUMN period_name\".$cnt.\" VARCHAR(50) CHARACTER SET \'utf8\' COLLATE \'utf8_general_ci\' NULL,\n                                        ADD COLUMN subject_name\".$cnt.\" VARCHAR(255) CHARACTER SET \'utf8\' COLLATE \'utf8_general_ci\' NULL,\n                                        ADD COLUMN absence_name\".$cnt.\" VARCHAR(50) CHARACTER SET \'utf8\' COLLATE \'utf8_general_ci\' NULL\n                                        \";\n                                nuRunQuery($sql);\n                            }\n                            \n                            $sql=\"select max(valid_from) from card where valid_from<=\'\".$absence_date.\"\'\"; \n                            $rv6=nuRunQuery($sql);\n                            $card_date = db_fetch_row($rv6);\n\n                            $sql=\"  select id,short_name \n                                    from class \n                                    where \n                                        (post_teacher_id=#RECORD_ID# OR \n                                        \'#nu_user_group#\'=\'Managers\' OR\n                                        \'#nu_user_group#\'=\'Administrators\' OR\n                                        \'#nu_user_group#\'=\'AssistManagers\' OR\n                                        \'#nu_user_group#\'=\'globeadmin\') and\n                                        id in (select distinct class_id from student_class) and\n                                        (   select count(*) \n                                            from card \n                                            where \n                                                valid_from=\'\".$card_date[0].\"\' and\n                                                card.class_id=class.id and\n                                                day_id=\".$day_of_week.\") > 0\n                                    order by short_name\";    \n                                \n                            $rv5=nuRunQuery($sql);\n                            $class_array = array();\n                                \n                            while($class_row=db_fetch_row($rv5)){\n                                $class_array[]= array($class_row[0],$class_row[1]);  \n                            }\n                            \n                            foreach ($class_array as $class_row) {\n                                                           // Βρίσκω τις διδασκαλίες του τμήματος τη συγκρκριμένη μέρα\n                                $sql=\"  SELECT \n                                                    card.id,\n                                                    card.period_id,\n                                                    teacher.short_name,\n                                                    subject.name,\n                                                    classroom.short_name,\n                                                    if(rg.id is NULL,0,1),\n                                                    if(rg.id is NULL,0,rg.no_lesson)\n                                                FROM card\n                                                inner join teacher on card.teacher_id=teacher.id\n                                                inner join subject on card.subject_id=subject.id\n                                                LEFT join classroom on card.classroom_id=classroom.id\n                                                LEFT JOIN (\n                                                            select registered_card.id as id,registered_card.card_id as card_id,registered_card.no_lesson as no_lesson\n                                                            from registered_card\n                                                            where DATE_FORMAT(registered_card.card_date, \'%Y-%m-%d\')=\'\".$absence_date.\"\') as rg on card.id=rg.card_id\n                                                WHERE\n                                                    valid_from=\'\".$card_date[0].\"\' and\n                                                    card.class_id=\".$class_row[0].\" and\n                                                    day_id=\".$day_of_week;\n                                    \n                                $rv_card=nuRunQuery($sql);\n                                $card_array = array();\n                                \n                                while($card_row=db_fetch_row($rv_card)){\n                                    $card_array[]= array($card_row[0],$card_row[1],$card_row[2],$card_row[3],$card_row[4],$card_row[5],$card_row[6]);  \n                                }\n                                                                                // Βρίσκω τις ήδη καταχωρημένες απουσίες τη συγκρκριμένη μέρα\n                                $sql=\"  SELECT  \n                                        student.id,\n                                        absence_reason.short_name,\n                                        absence_reason.name,\n                                        card.period_id\n                                    FROM \n                                        absence,\n                                        student,\n                                        student_class,\n                                        absence_reason,\n                                        card\n                                    WHERE \n                                        absence.student_id = student.id and\n                                        absence.card_id = card.id and\n                                        student_class.student_id = student.id and\n                                        absence_reason.id = absence.absence_reason_id and\n                                        student_class.class_id=\".$class_row[0].\" and\n                                        DATE_FORMAT(absence_date, \'%Y-%m-%d\')=\'\".$absence_date.\"\'\";\n                                $rv_absence=nuRunQuery($sql);\n                                $absence_array = array();\n                            \n                                while($absence_row=db_fetch_row($rv_absence)){\n                                    $absence_array[]= array($absence_row[0],$absence_row[1],$absence_row[2],$absence_row[3]);  \n                                }                                \n                            \n                                $insert_sql=\"insert into #TABLE_ID# values (\'\".$school_name.\"\', \'\".$school_year_name.\"\', DATE_FORMAT(CURDATE(),\'%d-%m-%Y\'), DATE_FORMAT(\'\".$absence_date.\"\',\'%d-%m-%Y\'), \'\".$class_row[0].\"\', \'\".$class_row[1].\"\', \'Μαθητής/Ώρα\',0,\'ΑΑ\'\";\n                        \n                                $lesson_array = array();\n                            \n                                foreach ($period_array as $period_row) {\n    \n                                    $lesson = \'\';\n                                    foreach ($card_array as $card) {\n                                        if($card[1]==$period_row[0]){\n                                            $lesson = $card[3];\n                                            \n                                            if(!is_null($card[4])){\n                                                $lesson = $lesson.\', Αιθ. \'.$card[4];\n                                            }\n                                        }\n                                    }\n                                    \n                                    foreach ($card_array as $card) {\n                                        if($card[1]==$period_row[0]){\n                                            if($lesson == \'\'){\n                                                $lesson = $card[2];\n                                            } else {\n                                                $lesson = $lesson.\', \'.$card[2];\n                                            }\n                                        }\n                                    }\n                                    \n                                    $registered=false;\n                                    foreach ($card_array as $card) {\n                                        if($card[1]==$period_row[0] && $card[5]==1){\n                                                if($card[6]==1){\n                                                    if(!$registered){$lesson = \'ΚΕΝΟ - \'.$lesson;}\n                                                } else {\n                                                    if(!$registered){$lesson = \'Καταχωρημένο - \'.$lesson;}\n                                                }\n                                                $registered=true;\n                                        }\n                                    }                                    \n                                    \n                                    if($lesson == \'\'){\n                                        $lesson = \'#F#555555|Μάθημα με άλλο τμήμα\';\n                                    }\n                                    \n                                    $lesson_array[]= array($period_row[1],$lesson);\n                                    \n                                    $insert_sql=$insert_sql.\", \'\".$period_row[1].\"\' ,\'\".$lesson.\"\' , \'\".$period_row[2].\"\'\";\n                                }\n                                \n                                $insert_sql=$insert_sql.\")\";\n                                nuRunQuery($insert_sql);\n\n                                $sql=\"  SELECT registration_number,surname,name,fathers_name,has_left_school,student.id\n                                    FROM student \n                                    inner join student_class on student.id=student_class.student_id\n                                    WHERE student_class.class_id=\".$class_row[0].\"\n                                    order by surname,name,fathers_name\";\n                                $rv_student=nuRunQuery($sql);\n                                \n                                $j=0;\n                                while($row_student = db_fetch_row($rv_student)){\n                                    $j++;\n                                    if(\'#show_regnchk#\'==\'1\'){ \n                                        $student_name= str_pad($j, 2, \"0\", STR_PAD_LEFT).\'. \'.$row_student[1].\' \'.$row_student[2].\' - \'.$row_student[3];    \n                                    } else {\n                                        $student_name= $row_student[0].\' - \'.$row_student[1].\' \'.$row_student[2].\' - \'.$row_student[3];    \n                                    }\n                                    \n                                    if($row_student[4]==1){\n                                        $student_name=\'#B#D3D3D3|\'.$student_name;\n                                    }\n\n                                    $insert_sql=\"insert into #TABLE_ID# values (\'\".$school_name.\"\', \'\".$school_year_name.\"\', DATE_FORMAT(CURDATE(),\'%d-%m-%Y\'), DATE_FORMAT(\'\".$absence_date.\"\',\'%d-%m-%Y\'), \'\".$class_row[0].\"\', \'\".$class_row[1].\"\', \'\".$student_name.\"\',\".$row_student[4].\", \'\".$j.\"\'\";\n                                \n                                    for($i=1;$i<=$num_of_periods;$i++){\n                                    \n                                        $class_id=\'period\'.$i;\n                                    \n                                        if(!have_card($card_array,$i)){\n                                            $insert_sql=$insert_sql.\", \'\".$lesson_array[$i-1][0].\"\' ,\'\".$lesson_array[$i-1][1].\"\' , \'\".($row_student[4]==1 ? \'#B#D3D3D3|X\' : \'X\' ).\"\'\";\n                                        } else {\n                                            if(!have_registered($card_array,$i)){\n                                                $insert_sql=$insert_sql.\", \'\".$lesson_array[$i-1][0].\"\' ,\'\".$lesson_array[$i-1][1].\"\' ,\'\".($row_student[4]==1 ? \'#B#D3D3D3|\' : \'\' ).\"\'\";\n                                            } else {\n                                                if($s=have_adsence($absence_array,$row_student[5],$i)){\n                                                    $insert_sql=$insert_sql.\", \'\".$lesson_array[$i-1][0].\"\' ,\'\".$lesson_array[$i-1][1].\"\' , \'\".($row_student[4]==1 ? \'#B#D3D3D3|\'.$s[1] : $s[1] ).\"\'\";\n                                                } else {\n                                                    if(!have_no_lesson($card_array,$i)){\n                                                        $insert_sql=$insert_sql.\", \'\".$lesson_array[$i-1][0].\"\' ,\'\".$lesson_array[$i-1][1].\"\' , \'\".($row_student[4]==1 ? \'#B#D3D3D3|#F#555555|Π\' : \'#F#555555|Π\' ).\"\'\";\n                                                    } else {\n                                                        $insert_sql=$insert_sql.\", \'\".$lesson_array[$i-1][0].\"\' ,\'\".$lesson_array[$i-1][1].\"\' , \'\".($row_student[4]==1 ? \'#B#D3D3D3|#F#555555|-\' : \'#F#555555|-\' ).\"\'\";\n                                                    }\n                                                    \n                                                }\n                                            }\n                                        }\n                                        \n                                    }\n                                     \n                                    $insert_sql=$insert_sql.\")\";\n                                    nuRunQuery($insert_sql);\n                                }\n                            }\n                        } else {\n                            $error_message = \"Δεν μπορείτε να τυπώσετε απουσίες σε ημερομηνίες αργιών...\";\n                        }\n                    } else {\n                        $error_message = \"Παρουσιάστηκε πρόβλημα στην ανάκτηση των δεδομένων...\";\n                    }\n                } else {\n                    $error_message = \"Μπορείτε να τυπώσετε απουσίες μόνο εντός του τρέχοντος σχολικού έτους...\";\n                }\n            } else {\n                $error_message = \"Παρουσιάστηκε πρόβλημα στην ανάκτηση των δεδομένων...\"; \n            }\n        } else {\n            $error_message = \"Παρακαλώ επιλέξτε ημερομηνία με ημέρα λειτουργίας τους σχολείου...\";  \n        }\n    } else {\n        $error_message = \"Παρουσιάστηκε πρόβλημα στην ανάκτηση των δεδομένων...\";    \n    }\n\nif($error_message!=\'\'){\n    nuDisplayError($error_message);\n}\n\n','','0','2015-11-01 17:50:54','globeadmin','2016-03-02 18:47:14','globeadmin','2016-03-02 18:47:14','globeadmin',''),('55490413c23b81c','un_register_no_lesson_cards','Καταχωρεί οτι μια συγκεκριμένη ώρα δεν έγινε κενό αλλά μάθημα','teacher','if (\'#absence_date#\'==\'#\'.\'absence_date\'.\'#\' || \'#absence_date#\'==\'\'){\n    $absence_date = date(\'Y-m-d\');\n} else {\n    $absence_date = \'#absence_date#\';\n}  \n\n$day_of_week = idate(\'w\', strtotime($absence_date))-1;\n\nif (\'#absence_class_id#\'!=\'#\'.\'absence_class_id\'.\'#\' && \'#absence_class_id#\'!=\'\' && is_int(#absence_class_id#)){\n    if (\'#no_lesson_period_id#\'!=\'#\'.\'no_lesson_period_id\'.\'#\' && \'#no_lesson_period_id#\'!=\'\' && is_int(#no_lesson_period_id#)){\n\n        $sql=\"select max(valid_from) from card where valid_from<=\'\".$absence_date.\"\'\"; \n        $rv=nuRunQuery($sql);\n    \n        if($rv && db_num_rows($rv)>0){\n            $card_date = db_fetch_row($rv);\n        \n            $sql=\"  SELECT card.id \n                FROM card,period\n                WHERE\n                    card.period_id=period.id and \n                    valid_from=\'\".$card_date[0].\"\' and\n                    card.class_id=#absence_class_id# and\n                    day_id=\".$day_of_week.\" and\n                    period_id=#no_lesson_period_id# and \n                    card.id in (   select registered_card.card_id \n                                        from registered_card \n                                        where DATE_FORMAT(registered_card.card_date, \'%Y-%m-%d\')=\'\".$absence_date.\"\')\";\n                                                    \n            $retval=nuRunQuery($sql);\n        \n            if($retval && db_num_rows($retval)>0){\n            \n                while($card_ids=db_fetch_row($retval)){\n                    $sql=\"  delete \n                            from registered_card \n                            where\n                                card_date=\'\".$absence_date.\"\' and\n                                card_id = \".$card_ids[0].\" and\n                                no_lesson = 1\";\n                    nuRunQuery($sql);              \n                }\n            \n            } else {\n                nuDebug(\'register_no_lesson_cards - retrive error 1\');\n            }\n        } else {\n            nuDebug(\'register_no_lesson_cards - retrive error 2\');\n        } \n    } else {\n        nuDebug(\'register_no_lesson_cards - Hash Variables NOT set properly\');   \n    }\n} else {\n   nuDebug(\'register_no_lesson_cards - Hash Variables NOT set properly\'); \n}\n','','0','2015-05-05 20:55:31','globeadmin','2016-07-18 00:33:38','globeadmin','2016-07-18 00:33:38','globeadmin','0'),('555d8a344f6f95a','create_attendance_books','Δημιουργία βιβλίων φοίτησης','teacher','function translateMonthName($month) { \nreturn strtr($month, array(\n    \'Jan\' => \'Ιανουάριος\',\n    \'Feb\' => \'Φεβρουάριος\',\n    \'Mar\' => \'Μάρτιος\',\n    \'Apr\' => \'Απρίλιος\', \n    \'May\' => \'Μάιος\', \n    \'Jun\' => \'Ιούνιος\', \n    \'Jul\' => \'Ιούλιος\',\n    \'Aug\' => \'Αύγουστος\',\n    \'Sep\' => \'Σεπτέμβριος\',\n    \'Oct\' => \'Οκτώβριος\',\n    \'Nov\' => \'Νοέμβριος\',\n    \'Dec\' => \'Δεκέμβριος\'\n    )); \n}\n\nfunction createDateRangeArray($strDateFrom,$strDateTo)\n{\n    $sql=\"  select holiday.holiday \n            from holiday\n            inner join school_year on holiday.school_year_id=school_year.id\n            inner join school on school.school_year_id = school_year.id\";\n    $retval=nuRunQuery($sql);\n    \n    $holiday_array = array();\n    while($row=db_fetch_row($retval)){\n        array_push($holiday_array,$row[0]);\n    }\n    \n    $sql=\"select id from day\";\n    $retval=nuRunQuery($sql);\n    \n    $day_array = array();\n    while($row=db_fetch_row($retval)){\n        array_push($day_array,$row[0]);\n    }\n    \n    $aryRange=array();\n\n    $iDateFrom=mktime(1,0,0,substr($strDateFrom,5,2),     substr($strDateFrom,8,2),substr($strDateFrom,0,4));\n    $iDateTo=mktime(1,0,0,substr($strDateTo,5,2),     substr($strDateTo,8,2),substr($strDateTo,0,4));\n\n    if ($iDateTo>=$iDateFrom)\n    {\n    \n        $day_of_week = idate(\'w\', strtotime(date(\'Y-m-d\',$iDateFrom)))-1;\n        if(in_array($day_of_week,$day_array)){\n                array_push($aryRange,date(\'Y-m-d\',$iDateFrom)); // first entry\n            }\n    \n        while ($iDateFrom<$iDateTo)\n        {\n            $iDateFrom+=86400; // add 24 hours\n            \n            $day_of_week = idate(\'w\', strtotime(date(\'Y-m-d\',$iDateFrom)))-1;\n            if(in_array($day_of_week,$day_array)){\n                array_push($aryRange,date(\'Y-m-d\',$iDateFrom));\n            }\n        }\n    }\n\n    return array_diff($aryRange, $holiday_array);\n}\n\n$sql=\"DROP TEMPORARY TABLE IF EXISTS #TABLE_ID#_student\";\nnuRunQuery($sql);\n\n$sql=\"CREATE TEMPORARY TABLE #TABLE_ID#_student DEFAULT CHARACTER SET=utf8\nSELECT\n    student.id as student_id,\n    student.id as s_id,\n    student.name as student_name,\n    student.surname as student_surname,\n    student.fathers_name as student_fathers_name,\n    student.registration_number as student_registration_number,\n    concat (student.registration_number,\' - \',ifNull(student.surname,\'\'),\' \',ifNull(student.name,\'\'),\' πατ. \',ifNull(student.fathers_name,\'\')) as student_full_name,\n    school.name as school_name,\n    school_year.name as school_year_name,\n    DATE_FORMAT(curdate(),\'%d-%m-%Y\') as cur_date,\n    student.prev_justified_absences as student_prev_justified_absences,\n    student.prev_an_justified_absences as student_prev_an_justified_absences,\n    ifnull(student.prev_justified_absences,0)+ifnull(student.prev_an_justified_absences,0) as student_prev_synolo\nFROM \n    student,\n    school,\n    school_year\nwhere\n    school_year.id=school.school_year_id\n    \";\n\n\nif(\'#std_id#\'!=\'#\'.\'std_id#\' && \'#std_id#\'!=\'\'){\n    $sql=$sql.\" and student.id IN (#std_id#) \n    \";\n} else if(\'#class_id#\'!=\'#\'.\'class_id#\' && \'#class_id#\'!=\'\'){\n    $sql=$sql.\" and student.id in (select distinct student_id from student_class where class_id=\'#class_id#\') \n    \";    \n} else if(\'#tch_id#\'!=\'#\'.\'tch_id#\' && \'#tch_id#\'!=\'\'){\n    $sql=$sql.\" and student.teacher_id= \'#tch_id#\' \n    \";    \n}\n\n$sql=$sql.\" order by student_surname,student_name,student_fathers_name,student_id\n\";\n\nnuRunQuery($sql);\n\n$sql=\"  select start_date,end_date\n        from school_year\n        inner join school on school_year.id=school.school_year_id\n    \";\n    \n$rv = nuRunQuery($sql);\n$row = db_fetch_row($rv);\n$starting_date  = $row[0];\n$ending_date    = $row[1];\n\n$prev_date      = date(\"Y-m-d\");\n$tmp_date       = new DateTime($prev_date);\n$tmp_date->modify(\'-1 day\');\n$prev_date      = $tmp_date->format(\"Y-m-d\");\n$until_date = ($ending_date<$prev_date  ? $ending_date : $prev_date);\n\n$start    = new DateTime($starting_date);\n$start->modify(\'first day of this month\');\n\n$end      = new DateTime($until_date);\n$end->modify(\'first day of next month\');\n\n$interval = DateInterval::createFromDateString(\'1 month\');\n$period   = new DatePeriod($start, $interval, $end);\n\n$sql=\"DROP TEMPORARY TABLE IF EXISTS #TABLE_ID#_month\";\nnuRunQuery($sql);\n$sql=\"CREATE TEMPORARY TABLE #TABLE_ID#_month (\n        month_id INT NOT NULL AUTO_INCREMENT,\n        start_month_date DATE NOT NULL,\n        end_month_date DATE NOT NULL,\n        month_name VARCHAR(50) CHARACTER SET \'utf8\' COLLATE \'utf8_general_ci\' NOT NULL,\n    PRIMARY KEY (month_id)) DEFAULT CHARACTER SET=utf8 AUTO_INCREMENT=1\";\nnuRunQuery($sql);\n\n$sql=\"insert into #TABLE_ID#_month values(NULL,\'2010-08-01\',\'2010-08-31\',\'Πρό Έναρξης\')\";\nnuRunQuery($sql);\n\nforeach ($period as $dt) {\n    $start_month_date = $dt->format(\"Y-m-d\");\n    \n    $dt->modify(\'last day of this month\');\n    $end_month_date = $dt->format(\"Y-m-d\");\n    $month_name = $dt->format(\"M\");\n    \n    $sql=\"insert into #TABLE_ID#_month values(NULL,\'\".$start_month_date.\"\',\'\".$end_month_date.\"\',\'\".translateMonthName($month_name).\"\')\";\n    nuRunQuery($sql);\n}\n\n$sql=\"DROP TEMPORARY TABLE IF EXISTS #TABLE_ID#\";\nnuRunQuery($sql);\n\n$sql=\"CREATE TEMPORARY TABLE #TABLE_ID# DEFAULT CHARACTER SET=utf8 ROW_FORMAT=DYNAMIC\nSELECT *\nFROM \n    #TABLE_ID#_student,\n    #TABLE_ID#_month\nwhere 1\norder by student_surname,student_name,student_fathers_name,start_month_date\n\";\nnuRunQuery($sql);\n\n\nfor ($i = 1; $i <= 31; $i++) {\n    $sql=\"ALTER TABLE #TABLE_ID#\n            ADD COLUMN d\".$i.\" VARCHAR(15) CHARACTER SET \'utf8\' COLLATE \'utf8_general_ci\' NULL DEFAULT \'#B#D3D3D3|\',\n            ADD COLUMN a\".$i.\" VARCHAR(15) CHARACTER SET \'utf8\' COLLATE \'utf8_general_ci\' NULL DEFAULT \'#B#D3D3D3|\',\n            ADD COLUMN s\".$i.\" VARCHAR(15) CHARACTER SET \'utf8\' COLLATE \'utf8_general_ci\' NULL DEFAULT \'#B#D3D3D3|\',\n            ADD COLUMN ss\".$i.\" VARCHAR(15) CHARACTER SET \'utf8\' COLLATE \'utf8_general_ci\' NULL DEFAULT \'#B#D3D3D3|\',\n            ADD COLUMN g\".$i.\" VARCHAR(15) CHARACTER SET \'utf8\' COLLATE \'utf8_general_ci\' NULL DEFAULT \'#B#D3D3D3|\'\n            \";\n    nuRunQuery($sql);\n}\n\n$sql=\"ALTER TABLE #TABLE_ID# \n            ADD COLUMN dm VARCHAR(15) CHARACTER SET \'utf8\' COLLATE \'utf8_general_ci\' NULL DEFAULT \'\',\n            ADD COLUMN am VARCHAR(15) CHARACTER SET \'utf8\' COLLATE \'utf8_general_ci\' NULL DEFAULT \'\',\n            ADD COLUMN sm VARCHAR(15) CHARACTER SET \'utf8\' COLLATE \'utf8_general_ci\' NULL DEFAULT \'\',\n            ADD COLUMN ssm VARCHAR(15) CHARACTER SET \'utf8\' COLLATE \'utf8_general_ci\' NULL DEFAULT \'\',\n            ADD COLUMN gm VARCHAR(15) CHARACTER SET \'utf8\' COLLATE \'utf8_general_ci\' NULL DEFAULT \'\'\n            \";\n    nuRunQuery($sql);\n    \n$date_array=createDateRangeArray($starting_date, $until_date);\n\n\n$sql=\"  SELECT distinct\n            month_id,\n            start_month_date\n        FROM #TABLE_ID#\n        order by month_id\n        \";\n$retval = nuRunQuery($sql);\nwhile($row=db_fetch_row($retval)){\n    \n    for ($i = 1; $i <= 31; $i++) {\n        \n        $dt = new DateTime($row[1]);\n        \n        $m = $dt->format(\"m\");\n        $y = $dt->format(\"Y\");\n        \n        $d= ($i<10 ? ($y.\'-\'.$m.\'-0\'.$i) : ($y.\'-\'.$m.\'-\'.$i));\n        \n        if(in_array($d,$date_array)){\n            $sql=\"  update #TABLE_ID# set \n                        d\".$i.\"=\'\',\n                        a\".$i.\"=\'\',\n                        s\".$i.\"=\'\',\n                        ss\".$i.\"=\'\',\n                        g\".$i.\"=\'\'\n                    where\n                        month_id=\".$row[0].\"\n            \";\n            nuRunQuery($sql);\n        }\n        \n    }\n\n}\n\n$sql=\"  SELECT \n            absence.student_id,\n            absence.absence_date,\n            sum(if(justified,counts,0)) as dik, \n            sum(if(justified,0,counts)) as adik,\n            sum(counts) as syn,\n            sum(1) as ss,\n            sum(if(justified=1 and counts=0,1,0)) as dieg\n        FROM absence\n        INNER JOIN #TABLE_ID#_student ON absence.student_id=#TABLE_ID#_student.student_id\n        GROUP BY student_id,absence_date\"; \n$retval = nuRunQuery($sql);\n\nwhile($row=db_fetch_row($retval)){\n    if($row[5]>0){\n        \n        $dt = new DateTime($row[1]);\n        \n        $d = $dt->format(\"j\");\n        $m = translateMonthName($dt->format(\"M\"));\n        $y = $dt->format(\"Y\");\n        \n        $sql=\"  update #TABLE_ID# set \n                    d\".$d.\"=\'\".($row[2]==0 ? \'\' : $row[2]).\"\',\n                    a\".$d.\"=\'\".($row[3]==0 ? \'\' : $row[3]).\"\',\n                    s\".$d.\"=\'\".$row[4].\"\',\n                    ss\".$d.\"=\'\".$row[5].\"\',\n                    g\".$d.\"=\'\".($row[6]==0 ? \'\' : $row[6]).\"\'\n                where\n                    student_id=\".$row[0].\" and \n                    month_name=\'\".$m.\"\'\n            \";\n            nuRunQuery($sql);\n    }\n}\n\n$sql=\"  SELECT \n            absence.student_id,\n            month(absence.absence_date),\n            sum(if(justified,counts,0)) as dik, \n            sum(if(justified,0,counts)) as adik,\n            sum(counts) as syn,\n            count(*) as ss,\n            sum(if(justified and counts=0,1,0)) as dieg\n        FROM absence\n        INNER JOIN #TABLE_ID#_student ON absence.student_id=#TABLE_ID#_student.student_id\n        GROUP BY student_id,month(absence.absence_date)\"; \n$retval = nuRunQuery($sql);\n\nwhile($row=db_fetch_row($retval)){\n    if($row[5]>0){\n        \n        $dt = new DateTime(\'2000-\'.($row[1]<10 ? \'0\'.$row[1] : $row[1]).\'-01\');\n        $m = translateMonthName($dt->format(\"M\"));\n        \n        $sql=\"  update #TABLE_ID# set \n                    dm=\'\".($row[2]==0 ? \'\' : $row[2]).\"\',\n                    am=\'\".($row[3]==0 ? \'\' : $row[3]).\"\',\n                    sm=\'\".$row[4].\"\',\n                    ssm=\'\".$row[5].\"\',\n                    gm=\'\".($row[6]==0 ? \'\' : $row[6]).\"\'\n                where\n                    student_id=\".$row[0].\" and \n                    month_name=\'\".$m.\"\'\n            \";\n            nuRunQuery($sql);\n    }\n}\n\n$sql=\"  select  \n            student_id, \n            student_prev_justified_absences,\n            student_prev_an_justified_absences,\n            student_prev_synolo\n        from #TABLE_ID#_student \n        where \n            student_prev_synolo>0\";\n            \n$retval = nuRunQuery($sql);\nwhile($row=db_fetch_row($retval)){\n    if($row[1]>0){\n            $d = $row[1];\n    } else {\n        $d = \'\';\n    }\n\n    if($row[2]>0){\n        $a = $row[2];\n    } else {\n        $a = \'\';\n    }\n    \n    if($row[3]>0){\n        $s = $row[3];\n    } else {\n        $s = \'\';\n    }\n\n    $sql=\"  update #TABLE_ID# set \n                    dm=\'\".$d.\"\',\n                    am=\'\".$a.\"\',\n                    sm=\'\".$s.\"\',\n                    ssm=\'\".$s.\"\'\n            where\n                    student_id=\".$row[0].\" and \n                    month_name=\'Πρό Έναρξης\'\n            \";\n    nuRunQuery($sql);\n}\n\n\n\n','','0','2015-05-21 10:33:08','globeadmin','2021-02-04 09:51:03','globeadmin','2021-02-26 21:25:10','globeadmin','0'),('5569e34f68bcbbb','publish_marks','Ορίζει ως κλειδωμένους η όχι τους βαθμούς ενός μαθήματος ','manager','if(\'#g_id#\'!=\'#\'.\'g_id#\' && \'#g_id#\'!=\'\' && \'#to_publish#\'!=\'#\'.\'to_publish#\' && \'#to_publish#\'!=\'\'){\n    $sql=\"CREATE TEMPORARY TABLE #TABLE_ID# DEFAULT CHARACTER SET=utf8\n            select distinct \n                subject_id,class_id \n            from mark\n            where grading_period_id=#g_id#\n            group by subject_id,class_id\n            having sum(value)=0\";\n    nuRunQuery($sql);\n\n    $sql=\"  update mark\n            set published = #to_publish#,added_when=added_when\n            where \n                grading_period_id=#g_id# \n                and (subject_id,class_id) not in (select subject_id,class_id from #TABLE_ID#)\n\";    \n\n    if(\'#s_id#\'!=\'#\'.\'s_id#\' && \'#s_id#\'!=\'\'){\n        $sql=$sql.\" and subject_id=#s_id#\n        \";\n    }\n    if(\'#c_id#\'!=\'#\'.\'c_id#\' && \'#c_id#\'!=\'\'){\n        $sql=$sql.\" and class_id = #c_id#\n        \";\n    }\n    \n    nuRunQuery($sql);    \n}','','0','2015-05-30 19:20:31','globeadmin','2017-02-02 11:25:39','globeadmin','2018-02-04 12:56:28','globeadmin','0'),('56cc9f04b82528e','create_tinymce','Δημιουργεί ένα TinyMCE HTML editor','sisyphos','print \"<html>\n<head>\n  <script src=\\\"tinymce/tinymce.min.js\\\"></script>\n  <script type=\\\"text/javascript\\\">\n  \n  tinymce.init({\n    selector: \'#tinymcetextarea\',\n    language: \'el\',\n    theme: \'modern\',\n    skin: \'lightgray\',\n    statusbar: false,\n    resize: false,\n    browser_spellcheck: true,\n    entity_encoding : \'raw\',\n    removed_menuitems: \'visualaid\',\n    plugins: \'table, textcolor, paste, autoresize, link, fullscreen\',\n    autoresize_min_height: 250,\n    autoresize_on_init: true,\n    toolbar: \'save | undo redo | bold italic underline | alignleft aligncenter alignright alignjustify | bullist numlist | outdent indent | fontselect fontsizeselect forecolor backcolor\',\n    /*setup: function(tinymcetextarea) {\n      tinymcetextarea.on(\'init\', function(e) {\n        tinymcetextarea.execCommand(\'mceFullScreen\');\n      });\n    }*/\n  });\n  \n  \n  function getHTML(){\n    return (tinyMCE.get(\'tinymcetextarea\').getContent());      \n  }\n  \n  function getTEXT(){\n    return (tinyMCE.get(\'tinymcetextarea\').getContent({ format: \'text\' }));      \n  }\n  \n  function setHTML(html){\n   tinyMCE.get(\'tinymcetextarea\').setContent(html);      \n  }\n  \n  function initializeHTML(){\n    var html = parent.passTinymceContents();\n    if(html != \'doNotSetHTML\'){\n        setHTML(html);  \n    }\n  }  \n  </script>\n</head>\n\n<body onload=\\\"initializeHTML();\\\">\n  <form method=\\\"post\\\">\n    <textarea id=\\\"tinymcetextarea\\\"></textarea>\n  </form>\n</body>\n</html>\";','','1','2016-02-23 20:03:48','globeadmin','2020-12-14 14:00:14','globeadmin','2020-12-14 14:54:26','globeadmin','0'),('55fd4a4b286857e','copy_access_level','Αντιγράφει όλα τα δικαιώματα ενός access_level σε ένα άλλο','admin','print \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n    </head>\n    <body>\";\n\nprint \"<span CLASS=\\\"msg\\\" style=\\\"color:gray;\\\"><p>*******************  FORMS *******************</span></p>\";\n$sql=\"  SELECT slf_zzzsys_form_id \n        FROM zzzsys_access_level_form \n        WHERE slf_zzzsys_access_level_id=\'#id_from#\' and \n        slf_zzzsys_form_id not in (SELECT slf_zzzsys_form_id FROM zzzsys_access_level_form WHERE slf_zzzsys_access_level_id=\'#id_to#\')\";\n\n$retval=nuRunQuery($sql);\n\nif($retval) {\n    $nbr=db_num_rows($retval);\n    if($nbr>0) {\n        while($row = db_fetch_row($retval)) {\n            \n            $sql=\"INSERT INTO zzzsys_access_level_form \n                    (   zzzsys_access_level_form_id,\n                        slf_zzzsys_access_level_id,	\n                        slf_zzzsys_form_id,\n                        slf_add_button,\n                        slf_save_button,\n                        slf_delete_button,\n                        slf_clone_button,\n                        slf_new_button,\n                        slf_print_button,\n                        zzzsys_access_level_form_log_added_at,\n                        zzzsys_access_level_form_log_added_by,\n                        zzzsys_access_level_form_log_changed_at,\n                        zzzsys_access_level_form_log_changed_by,\n                        zzzsys_access_level_form_log_viewed_at,\n                        zzzsys_access_level_form_log_viewed_by) VALUES\n                    (   \n                    \'\".nuID().\"\',\n                    \'#id_to#\',\n                    \'\".$row[0].\"\',\n                    \'\',\n                    \'\',\n                    \'\',\n                    \'\',\n                    \'\',\n                    \'\',\n                    now(),\n                    \'globeadmin\',\n                    now(),\n                    \'globeadmin\',\n                    now(),\n                    \'globeadmin\'\n                    )\";\n            \n            nuRunQuery($sql);\n            \n        }\n        print (\"<span CLASS=\\\"msgSuccess\\\">Δόθηκε πρόσβαση σε \".$nbr.\" φόρμες!</span>\");\n    }\n    else{\n        print (\"<span CLASS=\\\"msg\\\">Δεν υπάρχουν φόρμες που να χρειάζεται να δοθεί πρόσβαση!</span>\");\n    }\n}\nelse{\n    print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν δεδομένα για τις φόρμες...</span>\");\n}\n\nprint \"<br><br><span CLASS=\\\"msg\\\" style=\\\"color:gray;\\\"><p>*******************    REPORTS  *******************</span></p>\";\n$sql=\"  SELECT slr_zzzsys_report_id \n        FROM zzzsys_access_level_report \n        WHERE slr_zzzsys_access_level_id=\'#id_from#\' and \n        slr_zzzsys_report_id not in (SELECT slr_zzzsys_report_id FROM zzzsys_access_level_report WHERE slr_zzzsys_access_level_id=\'#id_to#\')\";\n\n$retval=nuRunQuery($sql);\n\nif($retval) {\n    $nbr=db_num_rows($retval);\n    if($nbr>0) {\n        while($row = db_fetch_row($retval)) {\n            \n            $sql=\"INSERT INTO zzzsys_access_level_report \n                    (   zzzsys_access_level_report_id,\n                        slr_zzzsys_access_level_id,\n                        slr_zzzsys_report_id,\n                        zzzsys_access_level_report_log_added_at,\n                        zzzsys_access_level_report_log_added_by,\n                        zzzsys_access_level_report_log_changed_at,\n                        zzzsys_access_level_report_log_changed_by,\n                        zzzsys_access_level_report_log_viewed_at,\n                        zzzsys_access_level_report_log_viewed_by) VALUES\n                    (   \n                    \'\".nuID().\"\',\n                    \'#id_to#\',\n                    \'\".$row[0].\"\',\n                    now(),\n                    \'globeadmin\',\n                    now(),\n                    \'globeadmin\',\n                    now(),\n                    \'globeadmin\'\n                    )\";\n            \n            nuRunQuery($sql);\n            \n        }\n        print (\"<span CLASS=\\\"msgSuccess\\\">Δόθηκε πρόσβαση σε \".$nbr.\" αναφορές!</span>\");\n    }\n    else{\n        print (\"<span CLASS=\\\"msg\\\">Δεν υπάρχουν αναφορές που να χρειάζεται να δοθεί πρόσβαση!</span>\");\n    }\n}\nelse{\n    print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν δεδομένα για τις αναφορές...</span>\");\n}\n\n\n\nprint \"<br><br><span CLASS=\\\"msg\\\" style=\\\"color:gray;\\\"><p>*******************  php CODE  *******************</span></p>\";\n$sql=\"  SELECT slp_zzzsys_php_id \n        FROM zzzsys_access_level_php \n        WHERE slp_zzzsys_access_level_id=\'#id_from#\' and \n        slp_zzzsys_php_id not in (SELECT slp_zzzsys_php_id FROM zzzsys_access_level_php WHERE slp_zzzsys_access_level_id=\'#id_to#\')\";\n\n\n$retval=nuRunQuery($sql);\n\nif($retval) {\n    $nbr=db_num_rows($retval);\n    if($nbr>0) {\n        while($row = db_fetch_row($retval)) {\n            \n            $sql=\"INSERT INTO zzzsys_access_level_php \n                    (   zzzsys_access_level_php_id,	\n                        slp_zzzsys_access_level_id,\n                        slp_zzzsys_php_id,\n                        zzzsys_access_level_php_log_added_at,\n                        zzzsys_access_level_php_log_added_by,\n                        zzzsys_access_level_php_log_changed_at,\n                        zzzsys_access_level_php_log_changed_by,\n                        zzzsys_access_level_php_log_viewed_at,\n                        zzzsys_access_level_php_log_viewed_by) VALUES\n                    (   \n                    \'\".nuID().\"\',\n                    \'#id_to#\',\n                    \'\".$row[0].\"\',\n                    now(),\n                    \'globeadmin\',\n                    now(),\n                    \'globeadmin\',\n                    now(),\n                    \'globeadmin\'\n                    )\";\n            \n            nuRunQuery($sql);\n            \n        }\n        print (\"<span CLASS=\\\"msgSuccess\\\">Δόθηκε πρόσβαση σε \".$nbr.\" php διαδικασίες!</span>\");\n    }\n    else{\n        print (\"<span CLASS=\\\"msg\\\">Δεν υπάρχουν php διαδικασίες που να χρειάζεται να δοθεί πρόσβαση!</span>\");\n    }\n}\nelse{\n    print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν δεδομένα για τις php διαδικασίες...</span>\");\n}\n\nprint \"\n    </body>\n</html>\";\n','','0','2015-09-19 14:43:07','globeadmin','2018-07-17 15:09:05','globeadmin','2018-07-17 15:09:05','globeadmin','0'),('57965e409e50885','print_marks_student','Εκτύπώνει τους Βαθμούς του Μαθητή για μια Περίοδο','student','function format_mark_value($value,$num_of_decimals){\n                    \n    $pieces = explode(\".\", $value);\n    $new_value =  $value;\n    \n    if(strlen($pieces[0])==1){\n        $pieces[0]=\'0\'.$pieces[0];    \n    }\n    \n    if(count($pieces)==2){\n        if($num_of_decimals==0 && $pieces[1]==\'0\'){\n            $new_value = $pieces[0];   \n        } else {\n            $new_value = $pieces[0].\',\'.$pieces[1];    \n        }\n    }\n    \n    return($new_value);\n}\n\n$sql=\"DROP TEMPORARY TABLE IF EXISTS #TABLE_ID#\";\nnuRunQuery($sql);\n\n$sql=\"CREATE TEMPORARY TABLE #TABLE_ID# DEFAULT CHARACTER SET=utf8\nSELECT\n    mark.id                             as mark_id,\n	mark.subject_id                     as subject_id,\n    mark.class_id                       as class_id,\n    \n    school.name                         as school_name,\n    school_year.name                    as school_year_name,\n    DATE_FORMAT(curdate(),\'%d-%m-%Y\')   as cur_date,\n    grading_period.name                 as grading_period_name,\n    concat( student.registration_number,\'-\',\n            ifNULL(student.surname,\'\'),\n            if(student.surname is NULL OR student.name is NULL,\'\',\' \'),\n            ifNULL(student.name,\'\'),\n            if(student.fathers_name is NULL,\'\',concat(\' πατ. \',student.fathers_name))) as student_full_name,\n\n    concat( ifNULL(subject.name,\'\'),\n            if(subject_type.short_name is NULL,\'\', concat(\' (\',subject_type.short_name,\')\'))) as subject_full_name,\n\n    class.short_name                    as class_short,\n    \n    mark.value                          as value_p,\n    \n	grading_period.num_of_decimals      as grading_period_num_of_decimals,\n    \n    CAST(\'\' as CHAR(255))               as teacher_names,\n    CAST(ifNULL(mark.comments,\'\') as CHAR(255))    as mark_comments,\n    CAST(\'\' as CHAR(15))                as value_formated,\n    0                                   as critiria_count\nFROM mark\nINNER JOIN grading_period   ON mark.grading_period_id=grading_period.id  \nINNER JOIN student          ON mark.student_id=student.id\nINNER JOIN class            ON mark.class_id=class.id\nINNER JOIN subject          ON mark.subject_id=subject.id\nINNER JOIN school           ON 1=1\nINNER JOIN school_year      ON school_year.id=school.school_year_id\nLEFT  JOIN subject_type     ON subject.subject_type_id=subject_type.id\nwhere\n    mark.grading_period_id=\'#student_mark_grade_period_id#\' and\n    mark.student_id=\'#RECORD_ID#\'\norder by class_short,subject.name,subject_type.name DESC\n\";\nnuRunQuery($sql);\n\n$sql=\"select distinct class_id,subject_id from #TABLE_ID#\";\n$rv = nuRunQuery($sql);\n\nif($rv){\n        while($row = db_fetch_row($rv)){\n            $class_id=$row[0];\n            $subject_id=$row[1];\n            \n            $sql=\"  SELECT distinct CONCAT(IF(teacher.surname is null,\'\', concat(teacher.surname,\' \')),IFNULL(teacher.name,\'\'))\n                    FROM \n	                    (SELECT \n		                    card.id 			AS id,\n		                    card.valid_from 	AS valid_from,\n		                    card.subject_id 	AS subject_id,\n		                    card.teacher_id 	AS teacher_id,\n		                    card.class_id 		AS class_id,\n		                    card.classroom_id 	AS classroom_id,\n		                    card.day_id 		AS day_id,\n		                    card.period_id 		AS period_id \n	                    FROM card \n	                    WHERE card.valid_from =\n		                    (	SELECT max(timetable.start_date) \n			                    FROM timetable)) as active_card \n	                inner join subject 			on active_card.subject_id = subject.id \n	                inner join teacher 			on active_card.teacher_id = teacher.id  \n	                inner join day 				on active_card.day_id = day.id  \n	                inner join period 			on active_card.period_id = period.id\n	                inner join class 			on active_card.class_id = class.id	\n	                left  join subject_type 	on subject.subject_type_id = subject_type.id  \n	                left  join classroom 		on active_card.classroom_id = classroom.id\n	                where \n	                    active_card.subject_id=\'\".$subject_id.\"\' and active_card.class_id=\'\".$class_id.\"\'\n                    ORDER BY \n    	                active_card.teacher_id,\n	                    active_card.day_id,\n	                    active_card.period_id\";\n\n            $retval = nuRunQuery($sql);\n            $teachers=\'\';\n            $first=true;\n\n            if($retval){\n                while($row = db_fetch_row($retval)){\n                    if($first){\n                        $teachers=$row[0];\n                        $first=false;\n                    } else{\n                        $teachers=$teachers.\', \'.$row[0];\n                    }\n                }\n            }\n            if(!$first){\n                $sql=\"  update #TABLE_ID# set \n                        teacher_names=\'\".$teachers.\"\' \n                        where class_id=\".$class_id.\" and subject_id=\".$subject_id;\n                nuRunQuery($sql);\n                }\n        }\n}\n\n$sql=\"  SELECT \n            mark_id,\n            value_p,\n            grading_period_num_of_decimals,\n            mark_comments \n        FROM #TABLE_ID#\";\n$retval = nuRunQuery($sql);\n            \nwhile($row = db_fetch_row($retval)){\n                \n    $sql = \"    SELECT count(*)\n                FROM mark_critirion_special_level\n                WHERE \n                    mark_id=\'\".$row[0].\"\' AND \n                    critirion_special_level_id IS NOT NULL\";\n    $rv2=nuRunQuery($sql);\n    $r2 = db_fetch_row($rv2);\n                \n    \n    $sql=\"  update #TABLE_ID# set \n                critiria_count=\'\".$r2[0].\"\',\n                value_formated=\'\".format_mark_value($row[1],$row[2]).\"\',\n                mark_comments=\'\".strip_tags($row[3]).\"\'\n                where mark_id=\".$row[0];\n    nuRunQuery($sql);\n   \n}','','0','2016-07-25 21:45:20','globeadmin','2016-07-26 00:46:56','globeadmin','2016-07-26 18:44:23','globeadmin','0'),('56d08b4c33c56c4','show_html_field','Εμφανίζει ως ιστοσελίδα τα περιεχόμενα ενός πεδίου ενος πίνακα συγκεκριμένης εγγραφής','sisyphos','print (\"<html>\n    <head>\n        <style>\n            body {\n                background-color: #ffffe0;\n                    font-family: \\\"Verdana\\\";\n                    font-size: 12px;\n            }\n            table, td, tr {\n                font-family: \\\"Verdana\\\";\n                font-size: 12px;                \n            }\n\n        </style>\n    </head>\n    <body>\n        <table border=0 width=100% height=100%  cellspacing=\\\"0\\\" cellpadding=\\\"0\\\">\n            <tr>\n                <td valign=top>\n\");\nif (    \'#table_name#\'  !=\'#\'.\'table_name\'.\'#\'  && \'#table_name#\'   !=\'\' &&\n        \'#table_field#\' !=\'#\'.\'table_field\'.\'#\' && \'#table_field#\'  !=\'\' &&\n        \'#id_name#\'     !=\'#\'.\'id_name\'.\'#\'     && \'#id_name#\'      !=\'\' &&\n        \'#id_value#\'    !=\'#\'.\'id_value\'.\'#\'    && \'#id_value#\'     !=\'\'){\n        \n    $sql=\"SELECT #table_field# FROM #table_name# WHERE #id_name# = \'#id_value#\'\"; \n    $retval=nuRunQuery($sql);\n    if($retval){\n        if($row = db_fetch_row($retval)){\n            print ($row[0]);    \n        } else {\n            print(\"&nbsp;\");   \n        }\n    } else {\n        print(\"&nbsp;\");    \n    }      \n} else {\n    print(\"&nbsp;\");\n}\nprint (\"\n               </td>\n            </tr>\n        </table>            \n     </body>           \n</html>\");','','1','2016-02-26 19:28:44','globeadmin','2018-07-05 10:40:36','globeadmin','2018-07-16 10:32:21','globeadmin','0'),('565ac873e409ddc','print_marks_manager','Εκτυπώνει τους βαθμούς που επιλέγει ο Διευθυντής','manager','$sql=\"DROP TEMPORARY TABLE IF EXISTS #TABLE_ID#\";\nnuRunQuery($sql);\n\n$sql=\"CREATE TEMPORARY TABLE #TABLE_ID# DEFAULT CHARACTER SET=utf8\nSELECT\n    if(mark.value is null,\'-\',mark.value) as value_p,\n	mark.grading_period_id as grading_period_id,\n	mark.student_id as student_id,\n	mark.subject_id as subject_id,\n    mark.subject_id as subject_id2,\n	mark.post_teacher_id as post_teacher_id,\n    grading_period.name as grading_period_name,\n    student.name as student_name,\n    student.surname as student_surname,\n    student.fathers_name as student_fathers_name,\n    student.registration_number as student_registration_number,\n    subject.name as subject_name,\n    ifNULL(subject_type.name,\'\') as subject_type_name,\n    concat(subject.name,\' (\',subject_type.name,\')\') as subject_full_name,\n    school.name as school_name,\n    school_year.name as school_year_name,\n    DATE_FORMAT(curdate(),\'%d-%m-%Y\') as cur_date,\n    class.id as class_id,\n    class.short_name as class_short,\n    if(curdate()<=grading_period.end_date,\'Προσωρινή\',\'Οριστική\') as cond,\n    \'                                                                                                                                                                                                        \' as teacher_names\nFROM mark\nINNER JOIN  grading_period  ON mark.grading_period_id=grading_period.id\nINNER JOIN  student         ON mark.student_id=student.id\nINNER JOIN  subject         ON mark.subject_id=subject.id\nINNER JOIN  class           ON mark.class_id=class.id\nINNER JOIN  school          ON 1=1\nINNER JOIN  school_year     ON school_year.id=school.school_year_id\nLEFT JOIN   subject_type    ON subject.subject_type_id=subject_type.id\nWHERE\n    mark.grading_period_id=\'#grading_period_id#\' and\n\";\n\nif(\'#class_id#\'!=\'#\'.\'class_id#\' && \'#class_id#\'!=\'\'){\n    $sql=$sql.\" class.id = \'#class_id#\' and \n    \";\n}\nif(\'#subject_id#\'!=\'#\'.\'subject_id#\' && \'#subject_id#\'!=\'\'){\n    $sql=$sql.\" subject.id = \'#subject_id#\' and  \n    \";\n}\n$sql=$sql.\"\n    1=1\n    order by class_short,subject_full_name,student_surname,student_name,student_fathers_name\n\";\n\nnuRunQuery($sql);\n\n$sql=\"select distinct class_id,subject_id from #TABLE_ID#\";\n$rv = nuRunQuery($sql);\n\nif($rv){\n        while($row = db_fetch_row($rv)){\n            $class_id=$row[0];\n            $subject_id=$row[1];\n\n            $sql=\"  SELECT distinct CONCAT(teacher.name,\' \',IFNULL(teacher.surname,\'\'))	\n                    FROM \n	                    (SELECT \n                    		card.id 			AS id,\n                    		card.valid_from 	AS valid_from,\n                    		card.subject_id 	AS subject_id,\n                    		card.teacher_id 	AS teacher_id,\n                    		card.class_id 		AS class_id,\n                    		card.classroom_id 	AS classroom_id,\n                    		card.day_id 		AS day_id,\n                    		card.period_id 		AS period_id \n                    	FROM card \n                    	WHERE card.valid_from =\n                    		(	SELECT max(timetable.start_date) \n                    			FROM timetable \n                    			WHERE (timetable.start_date <= curdate()))) as active_card \n                    	inner join subject 			on active_card.subject_id = subject.id \n                    	inner join teacher 			on active_card.teacher_id = teacher.id  \n                    	inner join day 				on active_card.day_id = day.id  \n                    	inner join period 			on active_card.period_id = period.id\n                    	inner join class 			on active_card.class_id = class.id	\n                    	left  join subject_type 	on subject.subject_type_id = subject_type.id  \n                    	left  join classroom 		on active_card.classroom_id = classroom.id\n                    where \n                    	active_card.subject_id=\'\".$subject_id.\"\' and active_card.class_id=\'\".$class_id.\"\'\";\n\n            $retval = nuRunQuery($sql);\n            $teachers=\'\';\n            $first=true;\n\n            if($retval){\n                while($row = db_fetch_row($retval)){\n                    if($first){\n                        $teachers=$row[0];\n                        $first=false;\n                        }\n                    else{\n                        $teachers=$teachers.\'\n\'.$row[0];\n                        }\n                    }\n                }\n            if(!$first){\n                $sql=\"update #TABLE_ID# set teacher_names=\'\".$teachers.\"\' where class_id=\".$class_id.\" and subject_id=\".$subject_id;\n                nuRunQuery($sql);\n                }\n            }\n    }\n','','0','2015-11-29 11:42:11','globeadmin','2016-02-09 19:35:58','globeadmin','2016-03-03 20:39:56','globeadmin',''),('561191a369a4a78','find_last_justification_date','Βρίσκει την τελευταία ημερομηνία για την οποία μπορουν να δικαιολογηθούν απουσίες','sisyphos','function last_justification_date(){\n    $sql=\"select CURDATE(), num_days_absence_justification from school limit 1\";\n    $retval=nuRunQuery($sql);\n    $row=db_fetch_row($retval);\n    \n    $cur_date   =   $row[0];\n    $num_days   =   $row[1];\n    \n    $sql=\"SELECT holiday FROM holiday WHERE DAYOFWEEK(holiday) not in (1,7)\";\n    $retval=nuRunQuery($sql);\n    $holidays = array();\n    \n    if($retval && db_num_rows($retval)>0){\n        while($row=db_fetch_row($retval)){\n            $holidays[]= $row[0];\n        }\n    }\n    \n    $weekend = array(\'Sun\',\'Sat\');\n    $date = new DateTime($cur_date);\n    $prevDay = clone $date;\n    \n    $i = 0; \n    $lastDate = $cur_date; \n    \n    while ($i < $num_days)\n    {\n        $di = new DateInterval(\'P1D\');\n        $di->invert = 1; // Proper negative date interval\n        \n        $prevDay->add($di); \n        \n        if (in_array($prevDay->format(\'Y-m-d\'), $holidays)) continue; \n        if (in_array($prevDay->format(\'D\'), $weekend)) continue;\n        \n        $lastDate = $prevDay->format(\'Y-m-d\');\n        $i++;\n    }\n    \n    return $lastDate;\n}\n\n$d=new DateTime(last_justification_date());\n\nprint \"\n<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n    </head>\n    <body>\n        <span CLASS=\\\"msg\\\" style=\\\"color:#666666;\\\">\".$d->format(\'d-m-Y\').\"</span>\n    </body>\n</html>\";\n\n\n\n','','0','2015-10-04 23:52:51','globeadmin','2018-07-17 15:52:28','globeadmin','2018-07-17 15:52:29','globeadmin','0'),('561542b85b07cd4','celebration','Μεταβάλει το ωρολόγιο πρόγραμμα σε περίπτωση γιορτής εκδρομής κτλ','manager','$nuParameters =\'\';\n\nif(\'#when_date#\'==\'\' || \'#from_period_id#\'==\'\' || \'#to_period_id#\'==\'\' || \'#subject_id#\'==\'\' || \'#class_id_sumo#\'==\'\' || (\'#classroom_id#\'==\'\' && \'#subject_id#\'!=\'1\') || (\'#teacher_id#\'==\'\' && \'#subject_id#\'!=\'1\')){\n    $nuError = \'Παρακαλώ συμπληρώστε όλα τα πεδία της φόρμας...\';\n} else {\n\n\n    $sql=\"SELECT count(*) FROM holiday WHERE holiday=\'#when_date#\'\";\n    $ret=nuRunQuery($sql);\n    $row=db_fetch_row($ret);\n    \n    if($row[0]>0){\n        $is_holiday=true; \n    } else { \n        $is_holiday=false;\n    }\n    \n    $weekend = array(\'Sun\',\'Sat\');\n    $date = new DateTime(\'#when_date#\');\n    \n    if (in_array($date->format(\'D\'), $weekend) || $is_holiday){\n        $nuError =  \'ΠΡΟΣΟΧΗ! Δεν μπορείτε να ορίσετε αναπλήρωση σε ημέρα που δεν λειτουργεί το σχολείο!\';\n    } else{\n\n        $sql=\"SELECT count(*) FROM registered_card WHERE card_date=\'#when_date#\'\";\n        $r=nuRunQuery($sql);\n        if($r){\n            $rw    = db_fetch_row($r);\n            if($rw[0]==0){\n\n\n                    $sql=\"SELECT count(*) FROM registered_card WHERE card_date=\'#when_date#\'\";\n                    $r1=nuRunQuery($sql);\n                    $rw1    = db_fetch_row($r1);\n                \n                if($rw1[0]==0){\n        \n                    $sql=\"select IFNULL(MAX(valid_from), \'2000-01-01\') from card where valid_from <= \'#when_date#\'\";\n                    $retval=nuRunQuery($sql);\n                    $row = db_fetch_row($retval);\n            \n                    if($row[0]!=\'2000-01-01\'){\n                        $active_program_date = $row[0];\n\n                        $di         = new DateInterval(\'P1D\');\n                        $date->add($di);\n                        $next_date  = $date->format(\'Y-m-d\');\n            \n                        $day_of_week = idate(\'w\', strtotime(\'#when_date#\'))-1;\n            \n                        $sql    = \"SELECT count(*) FROM card WHERE valid_from=\'\".$next_date.\"\'\";\n                        $rv     = nuRunQuery($sql);\n                        $row    = db_fetch_row($rv);\n            \n                        if($row[0]==0){             // Δεν υπάρχει καταχωρημένο πρόγραμμα για την επόμενη μέρα - εισαγωγή του τρέχοντος\n                            $sql=\"  INSERT INTO card (\n                                    valid_from,\n                                    subject_id,\n                                    teacher_id,\n                                    class_id,\n                                    classroom_id,\n                                    day_id,\n                                    period_id) \n                                SELECT \n                                    \'\".$next_date.\"\',\n                                    subject_id,\n                                    teacher_id,\n                                    class_id,\n                                    classroom_id,\n                                    day_id,\n                                    period_id\n                                FROM card WHERE valid_from=\'\".$active_program_date.\"\'\";\n                            nuRunQuery($sql);\n                            \n                            $sql=\"insert into timetable (start_date) values (\'\".$next_date.\"\')\";\n                            nuRunQuery($sql);\n                        } \n            \n\n                        $sql    = \"CREATE TEMPORARY TABLE IF NOT EXISTS #TABLE_ID#  AS (SELECT * FROM card WHERE valid_from=\'\".$active_program_date.\"\')\";\n                        nuRunQuery($sql);\n            \n                                               // Σβήνω τις διδασκαλίες που είχε το τμήμα/τα αυτή τη μέρα και αυτές τις ώρες από τον προσωρινό πίνακα\n                        $sql= \" DELETE FROM #TABLE_ID# \n                                WHERE \n                                    class_id in (#class_id_sumo#) and \n                                    day_id=\'\".$day_of_week.\"\' and \n                                    period_id BETWEEN #from_period_id# AND #to_period_id#\";    \n                        nuRunQuery($sql);\n            \n                        if(\'#subject_id#\'!=\'1\'){\n                                                // Εισάγω τις νέες διδασκαλίες στον προσωρινο πίνακα\n                            $sql=\"INSERT INTO #TABLE_ID# (\n                                    id,\n                                    valid_from,\n                                    subject_id,\n                                    teacher_id,\n                                    class_id,\n                                    classroom_id,\n                                    day_id,\n                                    period_id) \n                                SELECT \n                                    NULL,\n                                    \'\".$active_program_date.\"\',\n                                    \'#subject_id#\',\n                                    \'#teacher_id#\',\n                                    class.id,\n                                    \'#classroom_id#\',\n                                    \'\".$day_of_week.\"\',\n                                    period.id\n                                FROM period,class \n                                WHERE \n                                    class.id in (#class_id_sumo#) and\n                                    period.id BETWEEN #from_period_id# AND #to_period_id#\n                                ORDER BY class.id\";\n                            nuRunQuery($sql);\n                        }\n            \n                                                // Σβήνω αν υπαρχει πρόγραμμα στην ημερομηνία αυτή                        \n                        $sql=\"delete from card where valid_from=\'#when_date#\'\";\n                        nuRunQuery($sql);\n                        \n                        $sql=\"delete from timetable where start_date=\'#when_date#\'\";\n                        nuRunQuery($sql);\n            \n                                                // Εισάγω νέο-αλλαγμένο πρόγραμμα που θα ισχύσει για την ημερομηνία αυτή\n                        $sql=\"INSERT INTO card (\n                                id,\n                                valid_from,\n                                subject_id,\n                                teacher_id,\n                                class_id,\n                                classroom_id,\n                                day_id,\n                                period_id) \n                            SELECT \n                                NULL,\n                                \'#when_date#\',\n                                subject_id,\n                                teacher_id,\n                                class_id,\n                                classroom_id,\n                                day_id,\n                                period_id\n                            FROM #TABLE_ID# where 1=1\";\n                        nuRunQuery($sql);\n                        \n                        $sql=\"insert into timetable (start_date) values (\'#when_date#\')\";\n                        nuRunQuery($sql);\n                    \n                    $nuParameters = \"Η μεταβολή πραγματοποιήθηκε!\";\n                    } else {\n                        $nuError = \"Δεν υπάρχει καταχωρημένο και ενεργό ωρολόγιο πρόγραμμα!\";     \n                    }\n                } else {\n                    $nuError = \"ΠΡΟΣΟΧΗ! Έχει καταχωρήθει ότι διδασκαλίες έχουν πραγματοποιηθεί!<br>Δεν μπορεί να γίνει μεταβολή του Ωρολογίου Προγράμματος!\";     \n                }\n                \n                } else {\n                $nuError = \"ΠΡΟΣΟΧΗ! Εχουν καταχωρηθεί απουσίες για την ημερομηνία αυτή! Δεν μπορεί να γίνει μεταβολή του Ωρολογίου Προγράμματος!\";\n            }\n        } else {\n            $nuError =  \"Παρουσιάστηκε σφάλμα κατά την ανάκτηση των δεδομένων...\";\n        }\n    }\n}\n','','0','2015-10-07 19:05:12','globeadmin','2017-10-31 20:03:29','globeadmin','2017-10-31 20:03:29','globeadmin','0'),('59d3619f0eb43b8','delete_email','Διαγράφει ένα ή περισσότερα email','Manager','if(\'#email_id#\'!=\'#\'.\'email_id#\' && \'#email_id#\'!=\'\'){\n                                      \n        \n        $sql=\"  SELECT Count(Distinct email_id) \n                FROM notification \n                WHERE email_id IN (#email_id#)\";\n        \n        $rv1 = nuRunQuery($sql);\n        $r1 = db_fetch_row($rv1);\n        \n        $sql=\"  SELECT COUNT(*)\n                FROM email\n                WHERE \n                    id IN (#email_id#) AND\n                    id NOT IN (SELECT Distinct email_id FROM notification WHERE email_id IN (#email_id#))\";\n        $rv2 = nuRunQuery($sql);\n        $r2 = db_fetch_row($rv2);\n        \n        \n        if($r2[0]>0){\n            $sql=\"  DELETE FROM email \n                WHERE\n                    id IN (#email_id#) AND\n                    id NOT IN (SELECT Distinct email_id FROM notification WHERE email_id IN (#email_id#))\n            \";\n            nuRunQuery($sql);\n        }\n        \n        $nuParameters = ($r2[0]==0 ? $nuParameters = \"Δεν Διαγράφησαν Emails!\" : $nuParameters = \"Διαγράφησαν \".$r2[0].\" Emails!\");\n        \n        if($r1[0]>0) {$nuParameters=$nuParameters.\"\\nΔεν διαγράφησαν \".$r1[0].\" Emails γιατί συνδέονται με ενημερώσεις. Διαγράψτε πρώτα τις ενημερώσεις αυτές!\";}\n    \n} else{\n    $nuParameters = \"Προσοχή! Η λίστα των email δεν έχει οριστεί σωστά!\\nΤα email δεν διαγράφησαν!\"; \n}\n','','0','2017-10-03 13:08:31','globeadmin','2017-10-03 15:32:06','globeadmin','2019-07-23 19:21:53','globeadmin','0'),('561c0a55ec1ed91','print_absence_totals','Δημιουργεί τον πίνακα για τη συνοπτικη κατάσταση απουσιών','teacher','if (\'#to_date#\'==\'#\'.\'to_date\'.\'#\' || \'#to_date#\'==\'\' || \'#to_date#\'>date(\'Y-m-d\')){\n        $to_date = date(\'Y-m-d\');\n} else {\n    $to_date = date_format(date_create_from_format(\'Y-m-d\',\'#to_date#\'),\'Y-m-d\');\n}\n\n$sql=\"DROP TEMPORARY TABLE IF EXISTS #TABLE_ID#\";\nnuRunQuery($sql);\n\n$sql=\"CREATE TEMPORARY TABLE #TABLE_ID# DEFAULT CHARACTER SET=utf8\nSELECT \n                concat(if(school.city is null,\'Ημερομηνία : \',concat(school.city,\', \')),DATE_FORMAT(curdate(),\'%d-%m-%Y\')) as cur_date, \n                student.id as student_id,\n                concat(\n                            ifNull(student.surname,\'\'),\n                            \' \',\n                            ifNull(student.name,\'\'),\n                            \' πατ. \',\n                            ifNull(student.fathers_name,\'\')\n                        ) as student_full_name,\n                student.phone1                                  as student_phone1,\n                student.phone2                                  as student_phone2,\n                student.mobile                                  as student_mobile,\n                student.email                                   as student_email,\n                student.street                                  as student_street,\n                student.area                                    as student_area,\n                student.zipcode                                 as student_zipcode,\n                student.city                                    as student_city,\n                concat (ifnull(student.parent_surname,\'\'),if (student.parent_surname is null,\'\',\' \'),ifnull(student.parent_name,\'\')) as student_parent_full_name,\n                \n                if (concat(ifNull(student.parent_street,\'\'),ifNull(student.parent_area,\'\'),ifNull(student.parent_zipcode,\'\'))=\'\',\n                concat(ifNull(student.street,\'\'),       if(student.street is null or trim(student.street)=\'\' or student.area is null or trim(student.area)=\'\',\'\',\', \'),       ifNull(student.area,\'\')),\n                concat(ifNull(student.parent_street,\'\'),if(student.parent_street is null or trim(student.parent_street)=\'\' or student.parent_area is null or trim(student.parent_area)=\'\',\'\',\', \'),ifNull(student.parent_area,\'\'))) as address1,\n                \n                if (concat(ifNull(student.parent_street,\'\'),ifNull(student.parent_area,\'\'),ifNull(student.parent_zipcode,\'\'))=\'\',\n                concat(ifNull(student.zipcode,\'\'),       if(student.zipcode is null or trim(student.zipcode)=\'\' or student.city is null or trim(student.city)=\'\',\'\',\', \'),       ifNull(student.city,\'\')),\n                concat(if(student.parent_zipcode is null or trim(student.parent_zipcode)=\'\',\'\',\'Τ.Κ. \'),ifNull(student.parent_zipcode,\'\'))) as address2,\n    \n                student.parent_phone1                           as student_parent_phone1,\n                student.parent_phone2                           as student_parent_phone2,\n                student.parent_phone3                           as student_parent_phone3,\n                student.parent_email                            as student_parent_email,\n                \n                student.parent_street                           as student_parent_street,\n                student.parent_area                             as student_parent_area,\n                student.parent_zipcode                          as student_parent_zipcode,\n                school.name                                     as school_name,\n                school.short_name                               as school_short_name,\n                school.ministry                                 as school_ministry,\n                school.region                                   as school_region,\n                school.intendancy                               as school_intendancy,\n                concat(ifNull(school.phone1,\'\'),if(school.phone2 is null,\'\',concat(\', \',school.phone2)))        as school_phone,\n                school.fax                                                                                      as school_fax,\n                concat(ifNull(school.street,\'\'),if(school.area is null,\'\',concat(\', \',school.area)))            as school_street_area,\n                concat(ifNull(school.zipcode,\'\'),if(school.city is null,\'\',concat(\', \',school.city)))           as school_zipcode_city,\n                concat(ifNull(school.state,\'\'),if(school.country is null,\'\',concat(\', \',school.country)))       as school_state_country,\n                school.email                                                                                    as school_email,\n                school.web_page                                                                                 as school_web_page,\n                if(\'#m_sign#\'=\'1\',\'Ο Διευθυντής\',\'\')                                                            as manager_label,\n                if(\'#a_sign#\'=\'1\',\'Ο Υποδιευθυντής\',\'\')                                                         as assistmanager_label,\n                if(\'#t_sign#\'=\'1\',\'Ο Καθηγητής\',\'\')                                                             as teacher_label,\n                CAST(if(\'#m_sign#\'=\'1\',\'\',\'\') as CHAR(255))                                                     as manager_name,\n                CAST(if(\'#a_sign#\'=\'1\',\'\',\'\') as CHAR(255))                                                     as assistmanager_name,\n                if(\'#t_sign#\'=\'1\',concat(ifNull(teacher.surname,\'\'),if(teacher.surname is null,\'\',\' \'),ifNull(teacher.name,\'\')),\'\') as teacher_name,\n                if(student.gender=\'Θ\',\'Σας πληροφορούμε ότι η μαθήτρια\',\'Σας πληροφορούμε ότι ο μαθητής\') as text1,\n                if(student.gender=\'Θ\',\'Έλαβα γνώση για τις απουσίες της\',\'Έλαβα γνώση για τις απουσίες του\') as text10,\n                concat(\'από την έναρξη της σχολικής χρονιάς έως και τις \',DATE_FORMAT(\'\".$to_date.\"\',\'%d-%m-%Y\')) as text2,\n                \'πραγματοποίησε\' as text3,\n                concat(sum(if(ab.counts is null,0,if(ab.justified,0,ab.counts)))+ifnull(prev_an_justified_absences,0),\' αδικαιολόγητες απουσίες,\') as text4,\n                concat(sum(if(ab.counts is null,0,if(ab.justified,ab.counts,0)))+ifnull(prev_justified_absences,0),\' δικαιολογημένες απουσίες,\') as text5,\n                concat(sum(if(ab.counts is null,0,ab.counts))+ifnull(prev_an_justified_absences,0)+ifnull(prev_justified_absences,0),\' απουσίες συνολικά.\') as text6,\n                sum(if(ab.counts is null,0,ab.counts))+ifnull(prev_an_justified_absences,0)+ifnull(prev_justified_absences,0) as synolo,\n                sum(if(ab.counts is null,0,if(ab.justified,ab.counts,0)))+ifnull(prev_justified_absences,0) as dikaiologimenes,\n                sum(if(ab.counts is null,0,if(ab.justified,0,ab.counts)))+ifnull(prev_an_justified_absences,0) as adikaiologites\n            FROM student\";\n\nif(\'#class_id#\'!=\'#\'.\'class_id#\' && \'#class_id#\'!=\'\' ){\n$sql=$sql.\"\n                INNER JOIN  (select distinct student_id from student_class where class_id in (#class_id#)) as sc ON  student.id = sc.student_id\";\n}\n\n$sql=$sql.\"\n                INNER JOIN school on 1=1\n                INNER JOIN school_year on school.school_year_id = school_year.id\n                LEFT JOIN teacher on student.teacher_id=teacher.id \n                LEFT JOIN ( select \n								    absence.student_id,\n									absence.counts,\n									absence.justified\n							from absence\n							where absence.counts=1 AND DATE_FORMAT(absence.absence_date, \'%Y-%m-%d\') <= \'\".$to_date.\"\') \n						as ab ON student.id    =   ab.student_id\n            WHERE\n\";\n\nif(\'#class_id#\'==\'#\'.\'class_id#\' || \'#class_id#\'==\'\'){\n$sql=$sql.\" student.teacher_id = \'#RECORD_ID#\' and \n\";\n}\n\nif(\'#export_student_id#\'!=\'#\'.\'export_student_id#\' && \'#export_student_id#\'!=\'\' ){\n    $sql=$sql.\" student.id = \'#export_student_id#\' and \n\";\n}\n\nif(\'#has_left_school#\'!=\'#\'.\'has_left_school#\' && \'#has_left_school#\'!=\'\' && \'#has_left_school#\'==\'1\'){\n    $sql=$sql.\" student.has_left_school = 0 and \n    \";\n}\n\nif(\'#absence_limit#\'!=\'#\'.\'absence_limit#\' && \'#absence_limit#\'!=\'\'){\n    $limit=#absence_limit#;\n} else {\n    $limit=0;\n}\n\n$sql=$sql.\"\n            1=1\n            GROUP BY student.id\n            HAVING synolo>=\".$limit.\"\n            ORDER BY student.grade_id,student.surname,student.name,student.fathers_name\n\";\n\nnuRunQuery($sql);\n\n$sql=\"  SELECT concat(ifNull(surname,\'\'),if(surname is null,\'\',\' \'),ifNull(name,\'\')) \n        FROM teacher \n        inner join zzzsys_user on teacher.user_id=zzzsys_user.zzzsys_user_id\n        inner join zzzsys_user_group on zzzsys_user.sus_zzzsys_user_group_id=zzzsys_user_group.zzzsys_user_group_id\n        WHERE zzzsys_user_group.sug_code=\'Managers\'\";\n$retval=nuRunQuery($sql);\n\nif(db_num_rows($retval)==1){\n    $row=db_fetch_row($retval);\n    $sql=\"update #TABLE_ID# set manager_name=\'\".$row[0].\"\' where 1\";\n    nuRunQuery($sql);\n}\n\n$sql=\"  SELECT concat(ifNull(surname,\'\'),if(surname is null,\'\',\' \'),ifNull(name,\'\')) \n        FROM teacher \n        inner join zzzsys_user on teacher.user_id=zzzsys_user.zzzsys_user_id\n        inner join zzzsys_user_group on zzzsys_user.sus_zzzsys_user_group_id=zzzsys_user_group.zzzsys_user_group_id\n        WHERE zzzsys_user_group.sug_code=\'AssistManagers\'\";\n$retval=nuRunQuery($sql);\n\nif(db_num_rows($retval)==1){\n    $row=db_fetch_row($retval);\n    $sql=\"update #TABLE_ID# set assistmanager_name=\'\".$row[0].\"\' where 1\";\n    nuRunQuery($sql);\n}\n\n\n','','0','2015-10-12 22:30:29','globeadmin','2015-10-12 22:33:59','globeadmin','2021-09-07 20:43:58','globeadmin',''),('5636594106c1894','old_print_absence_class_table','Παλαιό - Εκτύπωση απουσιολογίου τμήματος ολοκληρης ημέρας','teacher','function have_card($array, $key){\n    foreach ($array as $c) {\n        if($c[1]==$key){\n            return true;\n        }\n    }\n    return false;\n}\n\nfunction have_registered($array, $period){\n    foreach ($array as $card) {\n        if($card[1]==$period && $card[5]==1){\n                return true;\n        }\n    }\n    return false;\n}\n\nfunction have_no_lesson($array, $period){\n    foreach ($array as $card) {\n        if($card[1]==$period && $card[6]==1){\n                return true;\n        }\n    }\n    return false;\n}\n\nfunction have_adsence($absence_array, $student_id,$period_id){\n    foreach ($absence_array as $absence) {\n        if($absence[0]==$student_id && $absence[3]==$period_id){\n                return $absence;\n        }\n    }\n    return false;\n}\n\n$sql=\"DROP TEMPORARY TABLE IF EXISTS #TABLE_ID#\";\nnuRunQuery($sql);\n\n$sql=\"CREATE TEMPORARY TABLE #TABLE_ID# (\n        school_name VARCHAR(100) CHARACTER SET \'utf8\' COLLATE \'utf8_general_ci\' NOT NULL,\n        school_year_name VARCHAR(100) CHARACTER SET \'utf8\' COLLATE \'utf8_general_ci\' NOT NULL,\n        cur_date VARCHAR(50) CHARACTER SET \'utf8\' COLLATE \'utf8_general_ci\' NOT NULL,\n        abs_date VARCHAR(50) CHARACTER SET \'utf8\' COLLATE \'utf8_general_ci\' NOT NULL,\n        class_name VARCHAR(50) CHARACTER SET \'utf8\' COLLATE \'utf8_general_ci\' NOT NULL,\n        student_name VARCHAR(255) CHARACTER SET \'utf8\' COLLATE \'utf8_general_ci\' NOT NULL\n) DEFAULT CHARACTER SET=utf8\";\nnuRunQuery($sql);\n\n$error_message=\'\';\n\nif (\'#absence_class_id#\'==\'#\'.\'absence_class_id\'.\'#\' || \'#absence_class_id#\'==\'\'){\n    $error_message =  \"Παρακαλώ επιλέξτε τμήμα ...\";\n} else {\n    if (\'#absence_date#\'==\'#\'.\'absence_date\'.\'#\' || \'#absence_date#\'==\'\'){\n        $absence_date = date(\'Y-m-d\');\n    } else {\n        $absence_date = date_format(date_create_from_format(\'d-m-Y\',\'#absence_date#\'),\'Y-m-d\');\n    }  \n    \n    $day_of_week = idate(\'w\', strtotime($absence_date))-1;\n    \n    if($absence_date<=date(\'Y-m-d\')){\n        $sql=\"SELECT count(*) FROM day WHERE id=\".$day_of_week;\n        $rv1=nuRunQuery($sql);\n        \n        if($rv1 && db_num_rows($rv1)>0){\n            $row1 = db_fetch_row($rv1);\n    \n            if($row1[0]==1){\n                $sql=\"SELECT start_date,end_date,school.name, school_year.name FROM school,school_year WHERE school.school_year_id=school_year.id\";\n                $rv2=nuRunQuery($sql);\n    \n                if($rv2 && db_num_rows($rv2)>0){\n                    $row2 = db_fetch_row($rv2);\n                    \n                    $school_name=$row2[2];\n                    $school_year_name=$row2[3];\n                    \n                    if($absence_date>=$row2[0] && $absence_date<=$row2[1]){\n                        $sql=\"  select if(\'\".$absence_date.\"\' in (SELECT holiday.holiday \n                                FROM school,school_year,holiday \n                                WHERE school.school_year_id = school_year.id and holiday.school_year_id=school_year.id \n                                ORDER BY holiday.holiday),\'1\',\'0\')\";   \n                        $rv3=nuRunQuery($sql);\n                        if($rv3 && db_num_rows($rv3)>0){\n                            $row3 = db_fetch_row($rv3);\n                            if($row3[0]==0){                            // ΟΛΑ ΚΑΛΑ! Δημιουργία απουσιολογίου\n                            \n                                $sql=\"SELECT id,name,short_name FROM period\";\n                                $rv4=nuRunQuery($sql);\n                                $num_of_periods=db_num_rows($rv4);\n                                $period_array = array();\n                                \n                                $sql=\"SELECT short_name FROM class WHERE id=#absence_class_id#\";\n                                $rv5=nuRunQuery($sql);\n                                $row5 = db_fetch_row($rv5);\n                                                               \n                                                               // Βρίσκω τις διδασκαλίες του τμήματος τη συγκρκριμένη μέρα\n                                                               \n                                $sql=\"select max(valid_from) from card where valid_from<=\'\".$absence_date.\"\'\"; \n                                $rv6=nuRunQuery($sql);\n                                $card_date = db_fetch_row($rv6);\n                                    \n                                $sql=\"  SELECT \n                                                        card.id,\n                                                        card.period_id,\n                                                        teacher.short_name,\n                                                        subject.name,\n                                                        classroom.short_name,\n                                                        if(rg.id is NULL,0,1),\n                                                        if(rg.id is NULL,0,rg.no_lesson)\n                                                    FROM card\n                                                    inner join teacher on card.teacher_id=teacher.id\n                                                    inner join subject on card.subject_id=subject.id\n                                                    LEFT join classroom on card.classroom_id=classroom.id\n                                                    LEFT JOIN (\n                                                                select registered_card.id as id,registered_card.card_id as card_id,registered_card.no_lesson as no_lesson\n                                                                from registered_card\n                                                                where DATE_FORMAT(registered_card.card_date, \'%Y-%m-%d\')=\'\".$absence_date.\"\') as rg on card.id=rg.card_id\n                                                    WHERE\n                                                        valid_from=\'\".$card_date[0].\"\' and\n                                                        card.class_id=#absence_class_id# and\n                                                        day_id=\".$day_of_week;\n                                        \n                                $rv_card=nuRunQuery($sql);\n                                $card_array = array();\n                                \n                                while($card_row=db_fetch_row($rv_card)){\n                                    $card_array[]= array($card_row[0],$card_row[1],$card_row[2],$card_row[3],$card_row[4],$card_row[5],$card_row[6]);  \n                                }\n                                                                                // Βρίσκω τις ήδη καταχωρημένες απουσίες τη συγκρκριμένη μέρα\n                                $sql=\"  SELECT  \n                                            student.id,\n                                            absence_reason.short_name,\n                                            absence_reason.name,\n                                            card.period_id\n                                        FROM \n                                            absence,\n                                            student,\n                                            student_class,\n                                            absence_reason,\n                                            card\n                                        WHERE \n                                            absence.student_id = student.id and\n                                            absence.card_id = card.id and\n                                            student_class.student_id = student.id and\n                                            absence_reason.id = absence.absence_reason_id and\n                                            student_class.class_id=#absence_class_id# and\n                                            DATE_FORMAT(absence_date, \'%Y-%m-%d\')=\'\".$absence_date.\"\'\";\n                                $rv_absence=nuRunQuery($sql);\n                                $absence_array = array();\n                                \n                                while($absence_row=db_fetch_row($rv_absence)){\n                                    $absence_array[]= array($absence_row[0],$absence_row[1],$absence_row[2],$absence_row[3]);  \n                                }                                \n                            \n                                $insert_sql=\"insert into #TABLE_ID# values (\'\".$school_name.\"\', \'\".$school_year_name.\"\', DATE_FORMAT(CURDATE(),\'%d-%m-%Y\'), DATE_FORMAT(\'\".$absence_date.\"\',\'%d-%m-%Y\'), \'\".$row5[0].\"\', \'Μαθητής/Ώρα\'\";\n                                $cnt=0;\n                                while($row4 = db_fetch_row($rv4)){\n                                    $cnt++;\n                                    $sql=\"ALTER TABLE #TABLE_ID# \n                                            ADD COLUMN period_name\".$cnt.\" VARCHAR(50) CHARACTER SET \'utf8\' COLLATE \'utf8_general_ci\' NULL,\n                                            ADD COLUMN subject_name\".$cnt.\" VARCHAR(255) CHARACTER SET \'utf8\' COLLATE \'utf8_general_ci\' NULL,\n                                            ADD COLUMN absence_name\".$cnt.\" VARCHAR(50) CHARACTER SET \'utf8\' COLLATE \'utf8_general_ci\' NULL\n                                            \";\n                                    nuRunQuery($sql);\n                                    \n                                    $lesson = \'\';\n                                    foreach ($card_array as $card) {\n                                        if($card[1]==$row4[0]){\n                                                $lesson = $card[3];\n                                                if(!is_null($card[4])){\n                                                    $lesson = $lesson.\', Αιθ. \'.$card[4];\n                                                }\n                                            }\n                                    }\n                                    \n                                    foreach ($card_array as $card) {\n                                        if($card[1]==$row4[0]){\n                                            if($lesson == \'\'){\n                                                $lesson = $card[2];\n                                            } else {\n                                                $lesson = $lesson.\', \'.$card[2];\n                                            }\n                                        }\n                                    }\n\n                                    $registered=false;\n                                    foreach ($card_array as $card) {\n                                        if($card[1]==$row4[0] && $card[5]==1){\n                                                if($card[6]==1){\n                                                    if(!$registered){$lesson = \'ΚΕΝΟ - \'.$lesson;}\n                                                } else {\n                                                    if(!$registered){$lesson = \'Καταχωρημένο - \'.$lesson;}\n                                                }\n                                                $registered=true;\n                                        }\n                                    }                                    \n                                    \n                                    if($lesson == \'\'){\n                                        $lesson = \'#F#555555|Μάθημα με άλλο τμήμα\';\n                                    }\n                                    \n                                    $period_array[]= array($row4[1],$lesson);\n                                    \n                                    $insert_sql=$insert_sql.\", \'\".$row4[1].\"\' ,\'\".$lesson.\"\' , \'\".$row4[2].\"\'\";\n                                }\n                                \n                                $insert_sql=$insert_sql.\")\";\n                                nuRunQuery($insert_sql);\n \n                                $sql=\"  SELECT registration_number,surname,name,fathers_name,has_left_school,student.id\n                                        FROM student \n                                        inner join student_class on student.id=student_class.student_id\n                                        WHERE student_class.class_id=#absence_class_id#\n                                        order by surname,name,fathers_name\";\n                                $rv_student=nuRunQuery($sql);\n                                \n                                while($row_student = db_fetch_row($rv_student)){\n                                    \n                                    $student_name= $row_student[0].\' - \'.$row_student[1].\' \'.$row_student[2].\' - \'.$row_student[3];\n                                    \n                                    if($row_student[4]==1){\n                                        $student_name=\'#B#D3D3D3|\'.$student_name;\n                                    }\n                                    \n                                    $insert_sql=\"insert into #TABLE_ID# values (\'\".$school_name.\"\', \'\".$school_year_name.\"\', DATE_FORMAT(CURDATE(),\'%d-%m-%Y\'), DATE_FORMAT(\'\".$absence_date.\"\',\'%d-%m-%Y\'), \'\".$row5[0].\"\', \'\".$student_name.\"\'\";\n                                    \n                                    for($i=1;$i<=$num_of_periods;$i++){\n                                        \n                                        $class_id=\'period\'.$i;\n                                        \n                                        if(!have_card($card_array,$i)){\n                                            $insert_sql=$insert_sql.\", \'\".$period_array[$i-1][0].\"\' ,\'\".$period_array[$i-1][1].\"\' , \'\".($row_student[4]==1 ? \'#B#D3D3D3|X\' : \'X\' ).\"\'\";\n                                        } else {\n                                            if(!have_registered($card_array,$i)){\n                                                $insert_sql=$insert_sql.\", \'\".$period_array[$i-1][0].\"\' ,\'\".$period_array[$i-1][1].\"\' ,\'\".($row_student[4]==1 ? \'#B#D3D3D3|\' : \'\' ).\"\'\";\n                                            } else {\n                                                if($s=have_adsence($absence_array,$row_student[5],$i)){\n                                                    $insert_sql=$insert_sql.\", \'\".$period_array[$i-1][0].\"\' ,\'\".$period_array[$i-1][1].\"\' , \'\".($row_student[4]==1 ? \'#B#D3D3D3|\'.$s[1] : $s[1] ).\"\'\";\n                                                } else {\n                                                    if(!have_no_lesson($card_array,$i)){\n                                                        $insert_sql=$insert_sql.\", \'\".$period_array[$i-1][0].\"\' ,\'\".$period_array[$i-1][1].\"\' , \'\".($row_student[4]==1 ? \'#B#D3D3D3|#F#555555|Π\' : \'#F#555555|Π\' ).\"\'\";\n                                                    } else {\n                                                        $insert_sql=$insert_sql.\", \'\".$period_array[$i-1][0].\"\' ,\'\".$period_array[$i-1][1].\"\' , \'\".($row_student[4]==1 ? \'#B#D3D3D3|#F#555555|-\' : \'#F#555555|-\' ).\"\'\";\n                                                    }\n                                                    \n                                                }\n                                            }\n                                        }\n                                    }\n                                    \n                                    $insert_sql=$insert_sql.\")\";\n                                    nuRunQuery($insert_sql);\n                                }\n                            } else {\n                                $error_message = \"Δεν μπορείτε να τυπώσετε απουσίες σε ημερομηνίες αργιών...\";\n                            }\n                        } else {\n                            $error_message = \"Παρουσιάστηκε πρόβλημα στην ανάκτηση των δεδομένων...\";\n                        }\n                    } else {\n                        $error_message = \"Μπορείτε να τυπώσετε απουσίες μόνο εντός του τρέχοντος σχολικού έτους...\";\n                    }\n                } else {\n                    $error_message = \"Παρουσιάστηκε πρόβλημα στην ανάκτηση των δεδομένων...\"; \n                }\n            } else {\n                $error_message = \"Παρακαλώ επιλέξτε ημερομηνία με ημέρα λειτουργίας τους σχολείου...\";  \n            }\n        } else {\n            $error_message = \"Παρουσιάστηκε πρόβλημα στην ανάκτηση των δεδομένων...\";    \n        }\n    } else {\n        $error_message = \"Δεν μπορείτε να τυπώσετε απουσίες σε μελλοντικές ημερομηνίες...\";    \n    }\n}\n','','0','2015-11-01 20:26:09','globeadmin','2016-03-02 18:48:04','globeadmin','2016-03-02 18:48:04','globeadmin',''),('561d62acbdd0ab8','search_timetable','Αναζήτηση Διδασκαλιών Ωρολογίου με Κριτίρια','manager','print \"<html>\n<head>\n<meta charset=\\\"UTF-8\\\">\n\n<script type=\\\"text/javascript\\\">\n\nfunction ChangeCursor(cell) {\n    cell.style.cursor=\\\"pointer\\\";\n}\n\nfunction RestoreCursor(cell) {\n    cell.style.cursor=\\\"auto\\\";\n}\n\nfunction show_card_info(card_id){\n    parent.nuOpenFormInFrame(\'5616c3a5f23ccc8\',card_id);    \n}\n\n</script>\n\n<STYLE TYPE=\\\"text/css\\\">\n    .boldtable, .boldtable TD{\n        font-family:Verdana;\n        font-size:7pt;\n        border-style:solid;\n        border-width:thin;\n        border-color:Gray;\n    }\n    .boldtable TH{\n        font-family:Verdana;\n        font-size:8pt;\n        border-style:solid;\n        border-width:thin;\n        border-color:Gray;\n    }\n</STYLE>\n</head>\n\n<body>\";\n\n$sql=\"SELECT \n        card.id 					AS 	id,\n        DATE_FORMAT(card.valid_from,\'%d-%m-%Y\') AS 	valid_from,\n		\n        concat(if(teacher.surname is NULL,\'\',concat(teacher.surname,\' \')),ifNULL(teacher.name,\'\')) as teacher_full_name,\n		day.name 					AS 	day_name,\n        day.short_name 				AS 	day_short,\n        \n		period.short_name 			AS 	period_short,\n        period.name 				AS 	period_name,\n        \n		class.short_name 			AS 	class_short,\n        class.name 					AS 	class_name,\n        \n		subject.short_name 			AS 	subject_short,\n        subject.name 				AS 	subject_name,\n        subject_type.short_name 	AS 	subject_type_short,\n        subject_type.name 			AS 	subject_type_name,\n        \n		classroom.short_name 		AS 	classroom_short,\n        classroom.name 				AS 	classroom_name\n    FROM\n        card\n        INNER JOIN 	subject 		ON 	card.subject_id = subject.id\n        INNER JOIN 	teacher 		ON 	card.teacher_id = teacher.id\n        INNER JOIN 	class 			ON 	card.class_id = class.id\n        INNER JOIN 	day 			ON 	card.day_id = day.id\n        INNER JOIN 	period 			ON 	card.period_id = period.id\n        LEFT JOIN 	subject_type 	ON 	subject.subject_type_id = subject_type.id\n        LEFT JOIN 	classroom 		ON 	card.classroom_id = classroom.id\n	WHERE card.valid_from=\'#timetable_date#\' AND\n    \n\";\n\n$order_text=\"ORDER BY card.day_id , card.period_id, class.short_name , teacher.short_name\";\n\nif(\'#class_id#\'!=\'#\'.\'class_id#\' && \'#class_id#\'!=\'\'){\n    $sql=$sql.\" class.id = \'#class_id#\' and \n    \";\n} \n\nif(\'#teacher_id#\'!=\'#\'.\'teacher_id#\' && \'#teacher_id#\'!=\'\'){\n    $sql=$sql.\" teacher.id = \'#teacher_id#\' and \n    \";\n} else {\n    $order_text=\"ORDER BY class.short_name ,card.day_id , card.period_id, teacher.short_name\"; \n}\n\nif(\'#day_id#\'!=\'#\'.\'day_id#\' && \'#day_id#\'!=\'\'){\n    $sql=$sql.\" day.id = \'#day_id#\' and \n    \";\n}\n\n$sql=$sql.\"\n    1=1\n    \".$order_text.\"\n\";\n       \n$retval=nuRunQuery($sql);\n\nif($retval) {\n    if(db_num_rows($retval)>0) {\n    \n        print (\"<table border=1  cellspacing=0 CLASS=\\\"boldtable\\\">\n            <tr bgcolor=LightSalmon height=45>\n                <td width=70    align=center><b>Έναρξη Ισχύος</b></td>\n                <td width=70    align=center><b>Τμήμα</b></td>\n                <td width=70    align=center><b>Ημέρα</b></td>\n                <td width=70    align=center><b>Ώρα</b></td>\n                <td width=220   align=center><b>Μάθημα</b></td>\n                <td width=70    align=center><b>Τύπος Μαθήματος</b></td>\n                <td width=180   align=center><b>Καθηγητής</b></td>\n                <td width=70    align=center><b>Αίθουσα</b></td>\n                <td width=50    align=center><b>Αναλυτικές Πληροφορίες</b></td>\");\n        print (\"</tr>\");\n        \n        $color1 =\'LightSkyBlue\';\n        $color2 =\'#48D1CC\';\n        \n        $color = $color1;\n        \n        $prev_day=\'\';\n        while($row = db_fetch_row($retval)) {\n            \n            if($prev_day==\'\'){\n                $prev_day=$row[3];\n            }\n            \n            if($row[3]!=$prev_day){\n                if($color == $color1){\n                   $color = $color2; \n                } else {\n                    $color = $color1;\n                }  \n            }\n            \n            print (\"<tr bgcolor=\".$color.\" height=35>\n                <td align=right>\".  (is_null($row[1]) || $row[1]==\'\'? \'&nbsp;\' : $row[1]).\"</td>\n                <td align=center>\". (is_null($row[7]) || $row[7]==\'\'? \'&nbsp;\' : $row[7]).\"</td>\n                <td align=center>\". (is_null($row[3]) || $row[3]==\'\'? \'&nbsp;\' : $row[3]).\"</td>\n                <td align=center>\". (is_null($row[5]) || $row[5]==\'\'? \'&nbsp;\' : $row[5]).\"</td>\n                <td align=left>\".   (is_null($row[10]) || $row[10]==\'\'? \'&nbsp;\' : $row[10]).\"</td>\n                <td align=center>\". (is_null($row[11]) || $row[11]==\'\'? \'&nbsp;\' : $row[11]).\"</td>\n                <td align=left>\".   (is_null($row[2]) || $row[2]==\'\'? \'&nbsp;\' : $row[2]).\"</td>\n                <td align=center>\".   (is_null($row[13]) || $row[13]==\'\'? \'&nbsp;\' : $row[13]).\"</td>\n                <td align=center title=\\\"Πληροφορίες/Επεξεργασία\\\" onclick=\\\"show_card_info(\".$row[0].\")\\\" onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\"><img src=\\\"images/info.png\\\"></td>\n                \");\n            print (\"</tr>\");\n        \n            $prev_day=$row[3];\n        }\n       \n        print (\"</table>\");\n    }\n    else{\n        print (\"<b><i><br>Δε βρέθηκαν διδασκαλίες...</i></b>\");\n    }\n}\nelse{\n    print (\"<b><i><br>Δεν ανακτήθηκαν δεδομένα...</i></b>\");\n}\nprint \"</body></html>\";\n','','0','2015-10-13 22:59:40','globeadmin','2017-10-02 16:07:35','globeadmin','2018-07-13 20:06:21','globeadmin','0'),('561feead7838ca8','remove_timetable','Διαγράφει το ωρολόγιο πρόγραμμα που ξεκινά να ισχύει σε μια συγκεκριμένη ημερομηνία ','manager','if(\'#timetable_date#\'!=\'#\'.\'timetable_date#\' && \'#timetable_date#\'!=\'\'){\n    $today = date(\'Y-m-d\');\n    if(\'#timetable_date#\'>$today){\n    \n        $sql=\"delete from card where valid_from=\'#timetable_date#\'\";\n        $retval=nuRunQuery($sql);\n        if($retval){\n            \n            $nuParameters = \'Το ωρολόγιο διαγράφηκε επιτυχώς!\';\n            \n            $sql=\"delete from timetable where start_date=\'#timetable_date#\'\";\n            nuRunQuery($sql);\n            \n        } else {\n            $nuParameters = \'Παρουσιάστηκε πρόβλημα κατά τη διαγραφή του ωρολογίου! Η διαγράφη δεν πραγματοποιήθηκε!\';\n        }\n          \n    } else {\n       $nuError = \'Το ωρολόγιο δεν μπορεί να διαγραφεί εφόσον έχει τεθεί ήδη σε ισχύ!\'; \n    }\n    \n} else {\n    $nuError = \'Παρακαλώ επιλέξτε πρώτα ημερομηνία έναρξης ισχύος ωρολογίου\';\n}','','0','2015-10-15 21:21:33','globeadmin','2016-02-09 19:36:05','globeadmin','2016-03-03 20:41:40','globeadmin',''),('56200a1fadf03a4','copy_timetable','Αντιγράφει το ωρολόγιο πρόγραμμα που ξεκινά να ισχύει σε μια συγκεκριμένη ημερομηνία σε μια άλλη ημερομηνία','manager','if(\'#timetable_date#\'!=\'#\'.\'timetable_date#\' && \'#timetable_date#\'!=\'\'){\n    if(\'#new_timetable_date#\'!=\'#\'.\'new_timetable_date#\' && \'#new_timetable_date#\'!=\'\'){\n        \n        $today = date(\'Y-m-d\');\n        \n        if(\'#new_timetable_date#\'>$today){\n    \n            // έλεγχος ότι δεν υπάρχει ήδη ωρολόγιο στη νέα ημερομηνία\n            $sql=\"select count(*) from card where valid_from=\'#new_timetable_date#\'\";\n            $retval=nuRunQuery($sql);\n            \n            if($row = db_fetch_row($retval)){\n                if($row[0]==0){\n                \n                        $sql=\"insert into card (\n                                    id,	\n                                    valid_from,\n                                    subject_id,\n                                    teacher_id,\n                                    class_id,\n                                    classroom_id,\n                                    day_id,\n                                    period_id)                        \n                        select \n                                    NULL,	\n                                    \'#new_timetable_date#\',\n                                    subject_id,\n                                    teacher_id,\n                                    class_id,\n                                    classroom_id,\n                                    day_id,\n                                    period_id\n                        from card \n                        where valid_from=\'#timetable_date#\'\";\n                        $rv=nuRunQuery($sql);\n            \n                        if($rv){\n                            $nuParameters = \'Το ωρολόγιο αντιγράφηκε επιτυχώς!\';\n                            \n                            $sql=\"insert into timetable (start_date) values (\'#new_timetable_date#\')\";\n                            nuRunQuery($sql);\n                        } else {\n                            $nuParameters = \'Παρουσιάστηκε πρόβλημα κατά την αντιγραφή του ωρολογίου! Η αντιγράφη δεν πραγματοποιήθηκε!\';\n                        }                \n            \n                } else {\n                    $nuError = \'Υπάρχει ήδη καταχωρημένο ωρολόγιο στην ημερομηνία αυτή! Παρακαλώ διαγράψτε το πρώτα! Η αντιγραφή δεν πραγματοποιήθηκε!\';    \n                }    \n            } else {\n                $nuError = \'Παρουσιάστηκε πρόβλημα κατά την αντιγραφή του ωρολογίου! Η αντιγράφη δεν πραγματοποιήθηκε!\';    \n            }\n\n        } else {\n            $nuError = \'Το ωρολόγιο δεν μπορεί να αντιγραφεί σε ημερομηνία μικρότερη ή ιση της σημερινής!\'; \n        }\n    } else {\n        $nuError = \'Παρακαλώ επιλέξτε πρώτα ημερομηνία έναρξης ισχύος του νέου ωρολογίου που θα δημιουργηθεί!\';    \n    }\n} else {\n    $nuError = \'Παρακαλώ επιλέξτε πρώτα την ημερομηνία έναρξης ισχύος ωρολογίου που θα ανττιγραφεί!\';\n}','','0','2015-10-15 23:18:39','globeadmin','2016-02-09 19:36:11','globeadmin','2016-03-02 18:32:40','globeadmin',''),('56223ed375d706d','delete_all','Διαγραφεί όλα τα δεδομένα για εκκίνηση νέας χρονιάς','manager','function clear_table($table,$table_name,$start_ai,$silent,$exclude_id,$id_name){\n\n        $sql    = \'select count(*) from \'.$table.\" where \".$id_name.\">=\".$start_ai.\" and \".$id_name.\"<>\".$exclude_id;\n        $rv     = nuRunQuery($sql);\n        \n        if($r = db_fetch_row($rv)){\n            \n            $sql=\"delete from \".$table.\" where \".$id_name.\">=\".$start_ai.\" and \".$id_name.\"<>\".$exclude_id;\n            nuRunQuery($sql);\n\n            if($start_ai>=0){\n                $sql=\"ALTER TABLE \".$table.\" AUTO_INCREMENT = \".$start_ai;\n                nuRunQuery($sql);\n            } else if($exclude_id>=0){\n                $sql=\"ALTER TABLE \".$table.\" AUTO_INCREMENT = \".($exclude_id+1);\n                nuRunQuery($sql);\n            }\n            \n            if(!$silent) {\n                print \"<span CLASS=\\\"msgSuccess\\\">Διαγράφησαν \".$r[0].\" $table_name!</span><br>\";\n            }\n            \n        } else {\n            print \"<span CLASS=\\\"msgError\\\">Παρουσιάστηκε πρόβλημα! Δεν διαγράφησαν $table_name!</span><br>\";\n        }  \n} \n\n$sql = \"select md5(CONCAT(zzzsys_user.sus_login_name, \'#mypass#\')),zzzsys_user.sus_login_password \n        from zzzsys_user \n        WHERE zzzsys_user_id = \'#nu_user_id#\'\";\n$retval=nuRunQuery($sql);\n\nprint \"<html>\n    <head>\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n    </head>\n    <body onload=\\\"adjustIframeHeight()\\\">\";\n\nif($row = db_fetch_row($retval)){\n\n   if($row[0]==$row[1]){\n\n        clear_table(\'absence\',\'Απουσίες\',                                       1,0,-1,\'id\');\n        clear_table(\'justification_request\',\'Αιτήματα Δικαιολόγησης Απουσιών\',  1,0,-1,\'id\');\n        clear_table(\'card\',\'Διδασκαλίες\',                                       1,0,-1,\'id\');\n        clear_table(\'timetable\',\'Ωρολόγια Προγράμματα\',                         1,0,-1,\'id\');\n        clear_table(\'holiday\',\'Αργίες\',                                         1,0,-1,\'id\');\n        clear_table(\'mark\',\'Βαθμοί\',                                            1,0,-1,\'id\');\n        clear_table(\'penalty\',\'Ποινές\',                                         1,0,-1,\'id\');\n        clear_table(\'comment\',\'Σχόλια Καθηγητών\',                               1,0,-1,\'id\');\n        clear_table(\'registered_card\',\'Καταχωρήσεις Διδασκαλιών\',               1,1,-1,\'id\');\n        \n        clear_table(\'email\',\'Emails\',                                           1,0,-1,\'id\');\n        clear_table(\'sms\',\'SMS\',                                                1,0,-1,\'id\');\n        clear_table(\'mark_critirion_special_level\',\'Περιγραφικές Αξιολογήσεις\', 1,0,-1,\'id\');\n        clear_table(\'notification\',\'Ειδοποιήσεις\',                              1,0,-1,\'id\');\n        clear_table(\'teacher_student\',\'Σχέσεις Μαθητών Καθηγητών\',              1,1,-1,\'id\');\n        \n        clear_table(\'ballot\',\'Ψηφοφορίες\',                                      1,0,-1,\'id\');\n        clear_table(\'ballot_choice\',\'Ψηφοφορίες-Υποψήφιοι\',                     1,1,-1,\'id\');\n        clear_table(\'ballot_paper\',\'Ψηφοφορίες-Ψηφοδέλια\',                      1,1,-1,\'id\');\n        clear_table(\'ballot_vote\',\'Ψηφοφορίες-Ψήφοι\',                           1,1,-1,\'id\');\n        clear_table(\'ballot_voter\',\'Ψηφοφορίες-Ψηφοφόροι\',                      1,1,-1,\'id\');\n\n        clear_table(\'calendar_event_access\',\'Κοινοποιήσεις συμβάντων ημερολογίου\', 1,1,-1,\'id\');\n        clear_table(\'calendar_event\',\'Συμβάντα Ημερολογίου\',                    1,0,-1,\'id\');        \n        \n        clear_table(\'card_in\',\'card_in\',                     1,1,-1,\'new_id\');\n        clear_table(\'class_in\',\'class_in\',                  -1,1,-1,\'id\');\n        clear_table(\'classroom_in\',\'classroom_in\',          -1,1,-1,\'id\');\n        clear_table(\'group_in\',\'group_in\',                  -1,1,-1,\'id\');\n        clear_table(\'penalty_in\',\'penalty_in\',               1,1,-1,\'id\');\n        clear_table(\'student_in\',\'student_in\',              -1,1,-1,\'student_id\');\n        clear_table(\'subject_in\',\'subject_in\',              -1,1,-1,\'id\');\n        clear_table(\'student_class_in\',\'student_class_in\',   1,1,-1,\'id\');\n        clear_table(\'teacher_in\',\'teacher_in\',              -1,1,-1,\'id\');\n        \n        \n        if(\'#delete_class#\'==\'1\'){\n            clear_table(\'class\',\'Τμήματα\',1,0,-1,\'id\');\n            \n        }\n        \n        if(\'#delete_student#\'==\'1\'){\n            clear_table(\'student\',\'Μαθητές\',1,0,-1,\'id\');\n    \n            $sql=\"delete from zzzsys_user where sus_zzzsys_user_group_id=\'547de4c65675a29\'\";\n            nuRunQuery($sql);\n            \n            $sql=\"delete from zzzsys_user where sus_zzzsys_user_group_id=\'5717ba3eb32c252\'\";\n            nuRunQuery($sql);\n        } elseif (\'#delete_student#\'==\'2\' || \'#delete_student#\'==\'3\'){\n            \n            $sql=\"select max(grade_id) from student\";\n            $rv1 = nuRunQuery($sql);\n            $r1 = db_fetch_row($rv1);\n            \n            if(!is_null($r1[0])){\n                $sql=\"  delete from zzzsys_user \n                        where \n                            sus_zzzsys_user_group_id=\'547de4c65675a29\' and\n                            zzzsys_user_id in (select user_id from student where grade_id=\".$r1[0].\" and has_left_school=0)\";\n                nuRunQuery($sql);\n                \n                $sql=\"  delete from zzzsys_user \n                        where \n                            sus_zzzsys_user_group_id=\'5717ba3eb32c252\' and\n                            zzzsys_user_id in (select parent_user_id from student where grade_id=\".$r1[0].\" and has_left_school=0)\";\n                nuRunQuery($sql);\n                \n                $sql=\"  delete from student_class \n                        where student_id in (select id from student where grade_id=\".$r1[0].\" and has_left_school=0)\";\n                nuRunQuery($sql);\n            \n                $sql    = \"select count(*) from student where grade_id=\".$r1[0].\" and has_left_school=0\";\n                $rv2    = nuRunQuery($sql);\n                $r2     = db_fetch_row($rv2);\n       \n                $sql=\"delete from student where grade_id=\".$r1[0].\" and has_left_school=0\";\n                nuRunQuery($sql);\n            \n                $sql=\"update student set grade_id=grade_id+1 where has_left_school=0\";\n                nuRunQuery($sql);\n                \n                print \"<span CLASS=\\\"msgSuccess\\\">Διαγράφησαν \".$r2[0].\" μαθητές της τελευταίας τάξης!</span><br>\";\n                \n                if (\'#delete_student#\'==\'3\'){\n                \n                    $sql=\"  delete from zzzsys_user \n                            where \n                                sus_zzzsys_user_group_id=\'547de4c65675a29\' and\n                                zzzsys_user_id in (select user_id from student where has_left_school=1)\";\n                    nuRunQuery($sql);\n                \n                    $sql=\"  delete from zzzsys_user \n                            where \n                                sus_zzzsys_user_group_id=\'5717ba3eb32c252\' and\n                                zzzsys_user_id in (select parent_user_id from student where has_left_school=1)\";\n                    nuRunQuery($sql);\n                    \n                    $sql=\"  delete from student_class \n                            where student_id in (select id from student where has_left_school=1)\";\n                    nuRunQuery($sql);\n            \n                    $sql    = \"select count(*) from student where has_left_school=1\";\n                    $rv3    = nuRunQuery($sql);\n                    $r3     = db_fetch_row($rv3);\n       \n                    $sql=\"delete from student where has_left_school=1\";\n                    nuRunQuery($sql);\n            \n                    print \"<span CLASS=\\\"msgSuccess\\\">Διαγράφησαν \".$r3[0].\" μαθητές που έχουν εγκαταλείψει το σχολείο!</span><br>\";\n                }\n            \n                $sql=\"  update student set \n                            prev_an_justified_absences=0,\n                            prev_justified_absences=0,\n                            teacher_id=NULL,\n                            has_left_school=0\n                        where 1\";\n                nuRunQuery($sql); \n            }\n        }\n        \n        $sql=\"UPDATE student SET advisor_id=NULL, teacher_id=NULL WHERE 1\";\n        nuRunQuery($sql);\n\n        if(\'#delete_student#\'==\'1\' || \'#delete_class#\'==\'1\' || \'#delete_student_class#\'==\'1\'){\n            clear_table(\'student_class\',\'Κατανομές Μαθητών σε Τμήματα\',1,0,-1,\'new_id\');\n        }        \n        \n        if(\'#delete_classroom#\'==\'1\'){\n            clear_table(\'classroom\',\'Αίθουσες\',1,0,-1,\'id\');\n        }\n        \n        if(\'#delete_teacher#\'==\'1\'){ // Διαγραφή και λογαριασμών\n            clear_table(\'teacher\',\'Καθηγητές\',-1,0,intval(\'#RECORD_ID#\'),\'id\');\n            $sql=\"DELETE FROM zzzsys_user WHERE \n                    zzzsys_user_id not in (select user_id from teacher) AND \n                    zzzsys_user_id not in (select user_id from student) AND \n                    zzzsys_user_id not in (select parent_user_id from student)\"; \n            nuRunQuery($sql);\n        } else {\n            $sql=\"UPDATE teacher SET comments_for_students=NULL WHERE 1\";\n            nuRunQuery($sql);\n            $sql=\"UPDATE teacher SET sms_limit=0 WHERE \n                    user_id in (SELECT zzzsys_user_id FROM zzzsys_user WHERE sus_zzzsys_user_group_id ΙΝ (\'547de4b10fa7616\',\'60475b01603a277\'))\";\n            nuRunQuery($sql);\n            \n            $sql=\"UPDATE class SET post_teacher_id=NULL WHERE 1\";\n            nuRunQuery($sql);\n        }\n        \n        if(\'#delete_subject#\'==\'1\'){\n            clear_table(\'subject\',\'Μαθήματα\',10,0,-1,\'id\');\n            clear_table(\'subject_critirion_general\',\'Κριτήρια Αξιολόγησης Μαθήματος\',1,0,-1,\'id\');\n        } else {\n            $sql=\"UPDATE subject SET \n                    exam_curriculum=NULL, \n                    exam_curriculum_modified_at=NULL, \n                    exam_curriculum_post_teacher_id=NULL, \n                    is_marked=1 \n                WHERE 1\";\n            nuRunQuery($sql);\n        }\n        \n        if(\'#delete_critiria#\'==\'1\'){\n            clear_table(\'critirion_general\',\'Γενικά Κριτήρια Αξιολόγησης\',              1,0,-1,\'id\');\n            clear_table(\'critirion_special\',\'Ειδικά Κριτήρια Αξιολόγησης\',              1,0,-1,\'id\');\n            clear_table(\'critirion_special_level\',\'Περιγραφές Κριτηρίων Αξιολόγησης\',   1,0,-1,\'id\');\n            \n            if(\'#delete_subject#\'!=\'1\'){\n                clear_table(\'subject_critirion_general\',\'Κριτήρια Αξιολόγησης Μαθήματος\',1,0,-1,\'id\');\n            }\n        }\n        \n        $sql=\"DELETE FROM zzzsys_debug WHERE 1\";\n        nuRunQuery($sql);\n        $sql=\"DELETE FROM zzzsys_user_log WHERE 1\";\n        nuRunQuery($sql);\n        $sql=\"DELETE FROM zzzsys_user_login_failure WHERE 1\";\n        nuRunQuery($sql);\n        $sql=\"DELETE FROM zzzsys_session WHERE zzzsys_session_id!=\'#session_id#\'\";\n        nuRunQuery($sql);\n        $sql=\"DELETE FROM session_variables WHERE session_id!=\'#session_id#\'\";\n        nuRunQuery($sql);\n   } else {\n        print \"<span CLASS=\\\"msgError\\\">Ο Κωδικός Πρόσβασης που πληκτρολογήσατε δεν είναι σωστός!<br>Η διαγραφή δεν πραγματοποιήθηκε!</span>\";\n   }\n} else {\n    print \"<span CLASS=\\\"msgError\\\">Παρουσιάστηκε πρόβλημα κατά την εκτέλεση της εντολής.<br>Η διαγραφή δεν πραγματοποιήθηκε!</span>\";\n}\n\nprint \'\n    </body>\n</html>\';\n','','0','2015-10-17 15:28:03','globeadmin','2021-03-09 14:08:14','globeadmin','2021-03-09 14:08:14','globeadmin','1'),('562378beaaf323a','create_mark_table','Δημιουργία βαθμολογικής κατάστασης για ένα τμήμα και ένα μάθημα','teacher','print \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n\";\nif (\'#class_id#\'==\'#\'.\'class_id\'.\'#\' || \'#class_id#\'==\'\' || \'#subject_id#\'==\'#\'.\'subject_id\'.\'#\' || \'#subject_id#\'==\'\'){\n    print \"\n    </head>\n    <body>\n        <span CLASS=\\\"msg\\\">Παρακαλώ επιλέξτε Τμήμα - Μάθημα...</span>\n    </body>\";\n} else {\n    $sql=\"  SELECT grading_period.id,ifNULL(grading_period.num_of_decimals,0),grading_period.name,grading_period.mark_required\n            FROM school,grading_period \n            WHERE \n                school.grading_period_id=grading_period.id AND \n                CURDATE() between grading_period.start_date AND grading_period.end_date \n            limit 1\";\n    $retval=nuRunQuery($sql);\n    if($retval){\n        if(db_num_rows($retval)>0){\n            \n            $row                = db_fetch_row($retval);\n            $grading_period_id  = $row[0];\n            $num_of_decimals    = $row[1];\n            $grading_period_name= $row[2];\n            $mark_required      = $row[3];\n            \n            $sql        = \"SELECT short_name from class where id=#class_id#\";\n            $retval     = nuRunQuery($sql);\n            $row        = db_fetch_row($retval);\n            $class_name = $row[0];\n            \n            $sql        = \" SELECT concat(subject.name,IF(subject_type.name is NULL,\'\',concat(\' (\',subject_type.name,\')\'))) \n                            FROM subject \n                            LEFT JOIN subject_type on subject.`subject_type_id`=subject_type.id\n                            WHERE subject.id=#subject_id#\";\n            $retval     = nuRunQuery($sql);\n            $row        = db_fetch_row($retval);\n            $subject_name = $row[0];\n            \n            // Δημιουργία Βαθμολογίας αν δεν υπάρχει ήδη!\n            \n            $sql=\"CREATE TEMPORARY TABLE IF NOT EXISTS #TABLE_ID# (\n                id INT NULL,\n                value DECIMAL(4,1) NULL DEFAULT 0,\n                added_when DATETIME NULL,\n                grading_period_id INT NULL,\n                student_id INT NULL,\n                subject_id INT NULL,\n                post_teacher_id INT NULL,\n                student_registration_number VARCHAR(100) NULL,\n                student_surname VARCHAR(100) NULL,\n                student_name VARCHAR(100) NULL,\n                student_fathers_name VARCHAR(100) NULL,\n                post_teacher_short VARCHAR(100) NULL,\n                student_has_left_school TINYINT(1),\n                class_id INT NULL,\n                published BOOLEAN NULL DEFAULT FALSE,\n                comments varchar(5000) NULL,\n                others_marks VARCHAR(30) NULL,\n                critiria_count INT NULL DEFAULT 0) ENGINE=MEMORY  DEFAULT CHARSET=utf8\";\n            $retval = nuRunQuery($sql);\n\n            $sql=\"DELETE FROM #TABLE_ID# WHERE 1\";\n            $retval = nuRunQuery($sql);\n\n            $sql=\"INSERT INTO #TABLE_ID# \n                    SELECT \n	                    null as id,\n                        \".($mark_required ? \'1\' : \'NULL\').\" as value,\n                        now() as added_when,\n                        \".$grading_period_id.\" as grading_period_id,\n                        student_class.student_id as student_id,\n                        #subject_id# as subject_id,\n                        #RECORD_ID# as post_teacher_id,\n                        student.registration_number as student_registration_number,\n                        student.surname as student_surname,\n                        student.name as student_name,\n                        student.fathers_name as student_fathers_name,\n                        null as post_teacher_short,\n                        student.has_left_school as student_has_left_school,\n                        student_class.class_id,\n                        0,\n                        NULL,\n                        NULL,\n                        0\n                    FROM student_class\n                        INNER JOIN student ON student_class.student_id=student.id\n                    WHERE\n	                    student_class.class_id=#class_id#\";\n            $retval = nuRunQuery($sql);   \n    \n            $sql=\"INSERT INTO mark\n                    SELECT \n	                        tmp_tbl.id,\n                            tmp_tbl.value,\n                            tmp_tbl.added_when,\n                            tmp_tbl.grading_period_id,\n                            tmp_tbl.student_id,\n                            tmp_tbl.subject_id,\n                            tmp_tbl.post_teacher_id,\n                            tmp_tbl.class_id,\n                            0,\n                            NULL\n                    FROM #TABLE_ID# as tmp_tbl\n                    WHERE\n                        (tmp_tbl.grading_period_id,tmp_tbl.subject_id,tmp_tbl.student_id) not in\n                            (select \n                                m2.grading_period_id,m2.subject_id,m2.student_id \n                                from mark as m2 \n                                where \n                                m2.grading_period_id=\".$grading_period_id.\" and m2.subject_id=#subject_id#)\";\n            $retval = nuRunQuery($sql); \n\n            $sql=\"update #TABLE_ID# as t, mark set \n                        t.id = mark.id,\n                        t.value = mark.value, \n                        t.post_teacher_id = mark.post_teacher_id,\n                        t.added_when=mark.added_when,\n                        t.published=mark.published,\n                        t.comments=mark.comments\n                    where \n                        t.grading_period_id=mark.grading_period_id and\n                        t.subject_id=mark.subject_id and\n                        t.student_id=mark.student_id\";\n            $retval = nuRunQuery($sql);\n\n            $sql=\"update #TABLE_ID# as t, teacher\n                    set t.post_teacher_short = teacher.short_name\n                    where t.post_teacher_id=teacher.id\";\n            $retval = nuRunQuery($sql);\n            \n                        //Καθαρίζει τον πίνακα των βαθμολογιών από τυχών λάθος μαθητές (λόγω ανακατανομής)\n            \n            $sql=\"  select count(*) \n                    from  mark \n                    where \n                        grading_period_id=\".$grading_period_id.\" and \n                        subject_id=#subject_id# and \n                        class_id=#class_id# and\n                        student_id not in (select student_id from #TABLE_ID#)\";\n            \n            $vvv = nuRunQuery($sql);\n            $rrr = db_fetch_row($vvv);\n            \n            if($rrr[0]!=0){\n                nuDebug(\'Θα σβηνονταν \'.$rrr[0].\' βαθμοί!\');\n            }\n            \n            /*$sql=\"delete from  mark \n                    where \n                        grading_period_id=\".$grading_period_id.\" and \n                        subject_id=#subject_id# and \n                        class_id=#class_id# and\n                        student_id not in (select student_id from #TABLE_ID#)\";\n            $retval = nuRunQuery($sql);*/\n            \n            //Ευρεση άλλης βαθμολογίας αν υπάρχει\n            $sql=\"  SELECT\n                        id,\n                        student_id\n                    FROM #TABLE_ID#\";\n            $retval = nuRunQuery($sql);\n            \n            while($row = db_fetch_row($retval)){\n                $sql=\"  SELECT grading_period_id,ifNull(value,\'-\') \n                        FROM mark \n                        WHERE \n                            student_id=\".$row[1].\" AND\n                            subject_id=#subject_id# AND\n                            grading_period_id<>\".$grading_period_id.\"\n                            ORDER BY grading_period_id\";\n                $rv=nuRunQuery($sql);\n                \n                $others_marks=\'\';\n                while($r = db_fetch_row($rv)){\n                    $pieces = explode(\".\", $r[1]);\n                    \n                    if(strlen($pieces[0])==1){\n                        $pieces[0]=\'0\'.$pieces[0];    \n                    }\n                    if(count($pieces)!=2){\n                        $v=$r[1]; \n                    } else {\n                        $v=($pieces[1]==0 ?  $pieces[0] : $pieces[0].\',\'.$pieces[1]);\n                    }\n                    if($others_marks==\'\'){\n                        $others_marks=$v;\n                    } else {\n                        $others_marks=$others_marks.\'/\'.$v;\n                    }    \n                }\n                \n                $sql = \"    SELECT count(*)\n                            FROM mark_critirion_special_level\n                            WHERE \n                                mark_id=\'\".$row[0].\"\' AND \n                                critirion_special_level_id IS NOT NULL\";\n                $rv2=nuRunQuery($sql);\n                $r2 = db_fetch_row($rv2);\n                \n                if($others_marks!=\'\' || $r2[0]!=\'0\'){\n                    //$others_marks=str_replace(\".\",\",\",$others_marks);\n                    $sql=\"  update #TABLE_ID# set \n                                others_marks=\'\".$others_marks.\"\',\n                                critiria_count=\'\".$r2[0].\"\'\n                            where id=\".$row[0];\n                    nuRunQuery($sql);\n                }\n            }\n            // Τελος Δημιουργίας Βαθμολογίας\n            \n            // Δημιουργία Βαθμολογικής Κατάστασης\n            print \" \n        <script type=\\\"text/javascript\\\">\n\n            var TableBackgroundNormalColor = \\\"LightBlue\\\";\n            var TableBackgroundMouseoverColor = \\\"Gold\\\";\n\n            function ChangeBackgroundColor(cell,input) {\n                cell.parentNode.style.backgroundColor = TableBackgroundMouseoverColor;\n                input.select();\n            }\n            \n            function RestoreBackgroundColor(cell,input) {\n                cell.parentNode.style.backgroundColor = TableBackgroundNormalColor;\n                if(!validateInputText(input)){\n                    window.setTimeout(function (){input.focus();}, 0);\n                }\n            } \n            \n            function openComments(mark_id){\n                parent.nuOpenFormInFrame(\'5627e58b8ed5f6d\',mark_id);\n            }\n            \n            function gotToNextInput(inp){\n                var a = document.getElementsByClassName(\'value_text\');\n                \n                for(var i=0;i<a.length;i++){\n                    if(a[i]==inp){\n                        if(i+1<a.length){\n                            a[i+1].focus();\n                        }\n                    }\n                }\n            }\n            \n            function gotToPrevInput(inp){\n                var a = document.getElementsByClassName(\'value_text\');\n                \n                for(var i=0;i<a.length;i++){\n                    if(a[i]==inp){\n                        if(i-1>=0){\n                            a[i-1].focus();\n                        }\n                    }\n                }\n            }\n            \n            function validateInputText(inp){\n                \n                var value = inp.value;\n                \n                if(value!=\'\'){\n                    var v=parseFloat(value.replace(\',\',\'.\'));\n                    if(!isNaN(v)){\n                        if (v<0 || v>20){\n                            alert(\'Παρακαλώ εισάγετε βαθμούς από Μηδέν (0) εως Είκοσι (20)!\');\n                            return false;\n                        } else {\n                            new_value=v.toString();\n                            piecies = new_value.split(\\\".\\\");\n                            \n                            if(piecies[0].length==1){\n                                piecies[0] = \'0\'+piecies[0];\n                            }\n \n                            if(piecies.length==2){\n                                if(\".$num_of_decimals.\"==0){\n                                    alert(\\\"Απαιτούνται ακέραιοι βαθμοί  στη τρέχουσα βαθμολογική περίοδο!\\\");\n                                    inp.value = piecies[0];\n                                } else {\n                                    //inp.value=new_value.replace(\'.\',\',\');   // Πρέπει να κρατά μόνο το 1 δεκαδικό αν υπάρχουν περισσότερα!  \n                                    inp.value=piecies[0]+\',\'+piecies[1].substr(0,\".$num_of_decimals.\");\n                                }\n                            } else {\n                                if(\".$num_of_decimals.\"==0){\n                                    inp.value = piecies[0];\n                                } else {\n                                    inp.value = piecies[0]+\',0\';    \n                                }\n                            }\n                            \n                            /*if(v==0){\n                                var cell = document.getElementById(\'hls_\'+inp.id);\n                                if(cell.innerHTML ==\'ΝΑΙ\'){\n                                    alert(\'Προσοχή : Ο Μαθητής φοιτά και τον βαθμολογήσατε με Μηδέν!\');\n                                }\n                            }*/\n                        }\n                    } else {\n                        inp.value = \'\';    \n                    }\n                } else {\n                    /* \n                    var cell = document.getElementById(\'hls_\'+inp.id);\n                    if(cell.innerHTML ==\'ΝΑΙ\'){\n                        alert(\'Προσοχή : Ο Μαθητής φοιτά και δεν του βάλατε βαθμό!\');\n                    }*/\n                }\n                \n               return true; \n            }\n            \n            function validateInputKey(event,inp){\n            \n                var x = event.which || event.keyCode;\n                \n                switch(x) {\n                            // Backspace\n                    case 8:\n                        break;\n                        \n                            // Delete\n                    case 46:\n                        break;                        \n                            //TAB\n                    case 9:\n                        break;\n \n                             //ENTER\n                    case 13:\n                        gotToNextInput(inp);\n                        break;                       \n                    \n                            //ESC\n                    case 27:\n                        break;\n\n                            //END\n                    case 35:\n                        break;                       \n \n                            //HOME\n                    case 36:\n                        break;\n\n                            //LEFT ARROW\n                    case 37:\n                        break;                       \n \n                            //UP ARROW\n                    case 38:\n                        gotToPrevInput(inp);\n                        break;\n                                        \n                            //RIGHT ARROW\n                    case 39:\n                        break;                       \n \n                            //DOWN ARROW\n                    case 40:\n                        gotToNextInput(inp);\n                        break;\n                    \n                            //NUMBERS\n                    case 48: \n                    case 49: \n                    case 50: \n                    case 51: \n                    case 52: \n                    case 53: \n                    case 54: \n                    case 55: \n                    case 56: \n                    case 57:\n                        break;\n                        \n                            //NUMPADS\n                    case 96:\n                    case 97:\n                    case 98:\n                    case 99:\n                    case 100:\n                    case 101:\n                    case 102:\n                    case 103:\n                    case 104:\n                    case 105:\n                        break;\n                        \n                            //DECIMAL POINT\n                    case 110:\n                        break;\n                        \n                            //COMMA\n                    case 188:\n                        break;\n                        \n                            //DOT\n                    case 190:\n                        break;\n                    \n                    case 113:\n                        openComments(inp.id);\n                        break;\n                        \n                    default:\n                        return false;\n                } \n                \n            }\n            \n            window.onload = function (){\n                adjustIframeHeight();\n                var a = document.getElementsByClassName(\'value_text\');\n                if (a.length>0){\n                    a[0].focus();\n                    a[0].select();\n                }\n            }\n        </script>\n        \n        <STYLE TYPE=\\\"text/css\\\">\n        \n            .sisTable, .sisTable TD{\n                border-color:#595959;\n            }\n            .sisTable TH{\n                font-size:10pt;\n                border-color:#595959;\n            }        \n        \n            .smallText{\n                font-family:Verdana;\n                font-size:6pt;                \n            }\n            \n            .valText{\n                font-family:Verdana;\n                font-size:11pt;\n                color: Brown;\n                text-align: right;\n                font-weight: bold;\n                padding-right: 7px;                \n            }\n            \n            input[type=\\\"text\\\"]{\n                font-family:Verdana;\n                font-size:11pt;\n                color: Brown;\n                background-color: LightYellow;\n                text-align: right;\n                font-weight: bold;\n                \n            }\n            \n            input[type=\\\"text\\\"]:focus {\n                 color: LightYellow;\n                 background-color: Brown;\n            }\n        </STYLE>\n    </head>\n\n    <body>\n        <form>\n        <table cellspacing=0 align=center CLASS=\\\"sisTable\\\">\n            <tr height=35>\n                <th colspan=11 align=center valign=center>\n                    Βαθμολογική Κατάσταση - \".$grading_period_name.\"\n                </th>\n            </tr>\n            <tr height=35>\n                <th colspan=11 align=center valign=center>\n                    \".$class_name.\" - \".$subject_name.\"\n                </th>\n            </tr>\n            <tr height=40>\n                <th width=45 align=center valign=center>Α.Μ.</th>\n                <th width=190 align=center valign=center>Επώνυμο</th>\n                <th width=150 align=center valign=center>Όνομα</th>\n                <th width=100 align=center valign=center>Πατρώνυμο</th>\n                <th width=45 align=center valign=center>Φοιτά</th>\n                <th width=70 align=center valign=center>Βαθμός</th>\n                <th width=80 align=center valign=center>Τελευταία Τροποποίηση</th>\n                <th width=120 align=center valign=center>Τροποποιήθηκε Από</th>\n                <th width=60 align=center valign=center>Κλειδ/νο</th>\n                <th width=80 align=center valign=center>Περιγραφική Αξιολόγηση</th>\n                <th width=80 align=center valign=center>Άλλοι Βαθμοί</th>\n            </tr>\n\";\n            $color_normal   = \"LightBlue\";\n            $color_disabled = \"LightGray\";\n            $color          = $color_normal;\n            \n            $sql=\"  SELECT\n                        id,\n                        student_registration_number,\n                        student_surname,\n                        student_name,\n                        student_fathers_name,\n                        IF(student_has_left_school,\'ΟΧΙ\',\'ΝΑΙ\'),\n                        value,\n                        DATE_FORMAT(added_when,\'%d-%m-%Y %T\'),\n                        post_teacher_short,\n                        IF(published,\'ΝΑΙ\',\'ΟΧΙ\'),\n                        comments,\n                        others_marks,\n                        critiria_count\n                    FROM #TABLE_ID#\n                    ORDER BY student_surname,student_name,student_fathers_name\";\n            $retval = nuRunQuery($sql);\n            while($row = db_fetch_row($retval)){\n                \n                $color = ($row[9]==\'ΝΑΙ\' ? $color_disabled : $color_normal);\n                \n                if(is_null($row[6]) || $row[6]==\'\'){\n                    $value= \'&nbsp;\';   \n                } else {\n                    $pieces = explode(\".\", $row[6]);\n                    \n                    if(strlen($pieces[0])==1){\n                        $pieces[0]=\'0\'.$pieces[0];    \n                    }\n                    if(count($pieces)!=2){\n                        $value=$row[6]; \n                    } else {\n                        if($num_of_decimals==0 && $pieces[1]==\'0\'){\n                            $value = $pieces[0];   \n                        } else {\n                            $value = $pieces[0].\',\'.$pieces[1];    \n                        }\n                    }\n                }\n\n                print \"         <tr style=\\\"background-color:$color;\\\" height=25>\n                \";\n                print \"             <td id=\\\"rg_\".$row[0].\"\\\" align=center><b>\".(is_null($row[1]) || $row[1]==\'\'? \'&nbsp;\' : $row[1]).\"</b></td>\n                \";\n                print \"             <td id=\\\"surname_\".$row[0].\"\\\" align=left><b>\".(is_null($row[2]) || $row[2]==\'\'? \'&nbsp;\' : $row[2]).\"</b></td>\n                \";\n                print \"             <td id=\\\"name_\".$row[0].\"\\\" align=left><b>\".(is_null($row[3]) || $row[3]==\'\'? \'&nbsp;\' : $row[3]).\"</b></td>\n                \";\n                print \"             <td id=\\\"fathers_name_\".$row[0].\"\\\" align=left><b>\".(is_null($row[4]) || $row[4]==\'\'? \'&nbsp;\' : $row[4]).\"</b></td>\n                \";\n                print \"             <td id=\\\"hls_\".$row[0].\"\\\" align=center\".($row[5]==\'ΟΧΙ\' ? \" style=\\\"background-color:red;\\\"\" : \"\").\">\".(is_null($row[5]) || $row[5]==\'\'? \'&nbsp;\' : $row[5]).\"</td>\n                \";\n                if($row[9]==\'ΝΑΙ\'){\n                    print \"             <td align=right><span CLASS=\\\"valText\\\">\".$value.\"</span></td>\n                \";    \n                } else {\n                    print \"             <td align=center> <input id=\\\"\".$row[0].\"\\\" class=\\\"value_text\\\" type=\\\"text\\\" size=4 name=\\\"v_\".$row[0].\"\\\" value=\\\"\".$value.\"\\\" onfocus=\\\"ChangeBackgroundColor(this.parentNode,this)\\\" onblur=\\\"RestoreBackgroundColor(this.parentNode,this)\\\" onkeydown=\\\"return validateInputKey(event,this);\\\" onchange=\\\"parent.mark_edited();\\\"></td>\n                \";    \n                }\n                print \"             <td align=center><span CLASS=\\\"smallText\\\">\".(is_null($row[7]) || $row[7]==\'\'? \'&nbsp;\' : $row[7]).\"</span></td>\n                \";\n                print \"             <td align=center>\".(is_null($row[8]) || $row[8]==\'\'? \'&nbsp;\' : $row[8]).\"</td> \n                \";\n                print \"             <td align=center>\".(is_null($row[9]) || $row[9]==\'\'? \'&nbsp;\' : $row[9]).\"</td>\n                \";\n                print \"             <td align=center onclick=\\\"openComments(\".$row[0].\")\\\" onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\"><img id=\\\"img_\".$row[0].\"\\\" title=\\\"\".(is_null($row[10]) || $row[10]==\'\' ? \'Περιγραφική Αξιολόγηση / Σχολιασμός Βαθμού\' : \'Σχολιασμός Βαθμού : \'.mb_substr(strip_tags($row[10]), 0, 20,\"UTF-8\").\'...\').\"\\\" width=20 height=20 src=\'images/\".((is_null($row[10]) || $row[10]==\'\') && $row[12]==\'0\' ? \'edit.png\' : \'edit_red.png\').\"\'/></td>\n                \";\n                print \"             <td align=center>\".(is_null($row[11]) || $row[11]==\'\'? \'&nbsp;\' : $row[11]).\"</td>\n                \";\n                print \"         </tr>\n                \";\n            }\nprint \"     </table>\n        </form>\n    </body>\n\";\n            // Τελος Δημιουργίας Βαθμολογικής Κατάστασης\n            \n        } else {\n            print \"\n    </head>\n    <body>\n        <span CLASS=\\\"msgError\\\">Δεν υπάρχει ενεργή βαθμολογική περίοδος...</span>\n    </body>\";        \n        }\n    } else {\n        print \"\n    </head>\n    <body>\n        <span CLASS=\\\"msgError\\\">Παρουσιάστηκε πρόβλημα κατά την ανάκτηση των δεδομένων!</span>\n    </body>\";\n    }\n} \nprint \"\n</html>\";','','0','2015-10-18 13:47:26','globeadmin','2022-02-08 23:33:07','globeadmin','2022-02-08 23:33:07','globeadmin','0'),('562b7741ab50baf','update_marks','Ενημέρωση Βαθμών','teacher','$json_str = stripslashes(\'#json_mark#\'); \n$json = json_decode($json_str,true);\n\nif (json_last_error() === JSON_ERROR_NONE) {\n    //do something with $json. It\'s ready to use\n    \n    $sql=\"  SELECT grading_period.id,grading_period.num_of_decimals\n            FROM school,grading_period \n            WHERE \n                school.grading_period_id=grading_period.id AND \n                CURDATE() between grading_period.start_date AND grading_period.end_date \n            \";\n    $retval=nuRunQuery($sql);\n    \n    if($retval){\n        if(db_num_rows($retval)>0){\n            \n            $row = db_fetch_row($retval);\n            $grading_period_id  = $row[0];\n            $num_of_decimals    = $row[1];\n            \n            foreach($json as $mark){\n                $is_OK = true;\n                $value=$mark[\'value\'];\n                \n                if($value!=\'NULL\'){\n                    if(!is_numeric($value)){\n                        $is_OK=false;       \n                    } else {\n                        $v = floatval($value);\n                        if ($v<0 OR $v>20){\n                            $is_OK=false;\n                        } else {\n                            $pieces = explode(\".\", $value);\n                            if(count($pieces)==2){\n                                if(strlen($pieces[1])>$num_of_decimals){\n                                    $is_OK=false;    \n                                }    \n                            }\n                        }\n                    }   \n                }\n                \n                if($is_OK){\n                    $sql=\"update mark set value=\".$mark[\'value\'].\",post_teacher_id=\'#RECORD_ID#\' where id=\".$mark[\'id\'].\" and grading_period_id=\".$grading_period_id;\n                    nuRunQuery($sql);     \n                }\n            }\n        } else {\n            nudebug(\'Καταχώριση Βαθμολογίας : Δεν βρέθηκε βαθμολογική περίοδος!\');\n        }\n    } else {\n        nudebug(\'Καταχώριση Βαθμολογίας : Πρόβλημα κατά την ανάκτηση της βαθμολογικής περιόδου!\');\n    }\n} else {\n    nudebug(\'Καταχώριση Βαθμολογίας : Δεν μπόρεσα να  αποκωδικοποιήσω το : \'.\'#json_mark#\');\n} \nnuRunPHP(\'create_mark_table\');','','0','2015-10-24 15:19:13','globeadmin','2016-07-09 23:29:54','globeadmin','2018-05-31 00:02:13','globeadmin','0'),('562e7c9f1816a51','pass_teachers_lessons_new','Βρίσκει τις διδασκαλίες του καθηγητή - Νέο','teacher','$sql=\"SELECT distinct CONCAT(class_id,\',\',subject_id), CONCAT(class_short,\' - \',subject_name,if (subject_type_name is NULL,\'\',concat(\' (\',subject_type_name,\')\')))\nFROM \n(\nSELECT \n	active_card.id 				AS id,\n	active_card.valid_from 		AS valid_from,\n	active_card.subject_id 		AS subject_id,\n	active_card.teacher_id 		AS teacher_id,\n	active_card.class_id 		AS class_id,\n	active_card.classroom_id 	AS classroom_id,\n	active_card.day_id 			AS day_id,\n	active_card.period_id 		AS period_id,\n	teacher.short_name 			AS teacher_short,\n	teacher.surname 			AS teacher_surname,\n	teacher.name 				AS teacher_name,\n	day.name 					AS day_name,\n	day.short_name 				AS day_short,\n	period.short_name 			AS period_short,\n	period.name 				AS period_name,\n	class.short_name 			AS class_short,\n	class.name 					AS class_name,\n	subject.short_name 			AS subject_short,\n	subject.name 				AS subject_name,\n	subject.is_marked 			AS subject_is_marked,\n	subject_type.short_name 	AS subject_type_short,\n	subject_type.name 			AS subject_type_name,\n	classroom.short_name 		AS classroom_short,\n	classroom.name 				AS classroom_name,\n	teacher.email 				AS teacher_email,\n	teacher.user_id 			AS teacher_user_id \nFROM \n	(SELECT \n		card.id 			AS id,\n		card.valid_from 	AS valid_from,\n		card.subject_id 	AS subject_id,\n		card.teacher_id 	AS teacher_id,\n		card.class_id 		AS class_id,\n		card.classroom_id 	AS classroom_id,\n		card.day_id 		AS day_id,\n		card.period_id 		AS period_id \n	FROM card \n	WHERE card.valid_from =\n		(SELECT max(timetable.start_date) FROM timetable)) as active_card \n	inner join subject 			on active_card.subject_id = subject.id \n	inner join teacher 			on active_card.teacher_id = teacher.id  \n	inner join day 				on active_card.day_id = day.id  \n	inner join period 			on active_card.period_id = period.id\n	inner join class 			on active_card.class_id = class.id	\n	left  join subject_type 	on subject.subject_type_id = subject_type.id  \n	left  join classroom 		on active_card.classroom_id = classroom.id  \nORDER BY \n	active_card.teacher_id,\n	active_card.day_id,\n	active_card.period_id\n)\nas active_card_full\nWHERE \n    teacher_id=\'#RECORD_ID#\' and \n    (subject_id, class_id) in \n        (select distinct mark.subject_id, mark.class_id \n        from mark \n        where\n            mark.grading_period_id = \'#grading_period_id#\') \nORDER BY class_short,subject_name,subject_type_name DESC\";\n    \n$retval = nuRunQuery($sql);\n$nuParameters = \'\';\n\nif($retval ){\n    while($row = db_fetch_row($retval)) {\n            if($nuParameters==\'\'){\n                $nuParameters=$row[0].\"\\t\".$row[1];\n            }\n            else{\n                $nuParameters=$nuParameters.\"\\n\".$row[0].\"\\t\".$row[1];\n            }\n        }\n    }','','0','2015-10-26 21:18:55','globeadmin','2022-01-22 10:46:39','globeadmin','2022-01-22 10:46:39','globeadmin','0'),('562e80fdcf335fe','show_marks_teacher','Εμφανίζει τους βαθμούς του καθηγητή σε ένα μάθημα και ένα τμήμα','teacher','function format_mark_value($value,$num_of_decimals){\n                    \n    $pieces = explode(\".\", $value);\n    $new_value =  $value;\n    \n    if(strlen($pieces[0])==1){\n        $pieces[0]=\'0\'.$pieces[0];    \n    }\n    \n    if(count($pieces)==2){\n        if($num_of_decimals==0 && $pieces[1]==\'0\'){\n            $new_value = $pieces[0];   \n        } else {\n            $new_value = $pieces[0].\',\'.$pieces[1];    \n        }\n    }\n    \n    return($new_value);\n}\n\n$sql=\"DROP TEMPORARY TABLE IF EXISTS #TABLE_ID#\";\nnuRunQuery($sql);\n\n$sql=\"CREATE TEMPORARY TABLE #TABLE_ID# DEFAULT CHARACTER SET=utf8\nSELECT\n    \n    mark.id                                     as mark_id,\n    \n    grading_period.name                         as grading_period_name,\n    grading_period.num_of_decimals              as grading_period_num_of_decimals,\n    IF(grading_period.end_date<curdate(),\'ΝΑΙ\',\'ΟΧΙ\')     as period_ended,\n    class.short_name                            as class_short,\n    concat(subject.name,if(subject_type.name is null,\'\',concat(\'(\',subject_type.name,\')\'))) as subject_full_name,\n    \n    student.registration_number                 as student_registration_number,\n    student.surname                             as student_surname,\n    student.name                                as student_name,\n    student.fathers_name                        as student_fathers_name,\n    IF(student.has_left_school,\'ΟΧΙ\',\'ΝΑΙ\')     as hls,\n    \n    mark.value                                  as value_p,\n    \n    DATE_FORMAT(mark.added_when,\'%d-%m-%Y %T\')  as mark_added_when,\n    CONCAT(IF(teacher.surname is null,\'\', concat(teacher.surname,\' \')),IFNULL(teacher.name,\'\')) as post_teacher_full_name,\n    \n    CAST(\'\' as CHAR(255))                       as teacher_names,\n    IF(mark.published,\'ΝΑΙ\',\'ΟΧΙ\')              as mark_published,\n    CAST(mark.comments as CHAR(255))            as mark_comments,\n    0                                           as critiria_count\nFROM mark\n    INNER JOIN grading_period   ON mark.grading_period_id=grading_period.id  \n    INNER JOIN student          ON mark.student_id=student.id\n    INNER JOIN class            ON mark.class_id=class.id\n    INNER JOIN subject          ON mark.subject_id=subject.id\n    INNER JOIN teacher          ON mark.post_teacher_id=teacher.id\n    LEFT  JOIN subject_type     ON subject.subject_type_id=subject_type.id\nwhere\n    mark.grading_period_id  = \'#grading_period_id#\' and\n    mark.subject_id         = \'#subject_id#\' and \n    mark.class_id           = \'#class_id#\'\norder by subject_full_name\n\";\n\nnuRunQuery($sql);\n\n$sql=\"  SELECT distinct CONCAT(IF(teacher.surname is null,\'\', concat(teacher.surname,\' \')),IFNULL(teacher.name,\'\'))\n                    FROM \n	                    (SELECT \n		                    card.id 			AS id,\n		                    card.valid_from 	AS valid_from,\n		                    card.subject_id 	AS subject_id,\n		                    card.teacher_id 	AS teacher_id,\n		                    card.class_id 		AS class_id,\n		                    card.classroom_id 	AS classroom_id,\n		                    card.day_id 		AS day_id,\n		                    card.period_id 		AS period_id \n	                    FROM card \n	                    WHERE card.valid_from =\n		                    (	SELECT max(timetable.start_date) \n			                    FROM timetable \n			                    WHERE (timetable.start_date <= curdate()))) \n	                as active_card \n	                inner join subject 			on active_card.subject_id = subject.id \n	                inner join teacher 			on active_card.teacher_id = teacher.id  \n	                inner join day 				on active_card.day_id = day.id  \n	                inner join period 			on active_card.period_id = period.id\n	                inner join class 			on active_card.class_id = class.id	\n	                left  join subject_type 	on subject.subject_type_id = subject_type.id  \n	                left  join classroom 		on active_card.classroom_id = classroom.id\n	                where \n	                    active_card.subject_id=\'#subject_id#\' and active_card.class_id=\'#class_id#\'\n                    ORDER BY \n    	                active_card.teacher_id,\n	                    active_card.day_id,\n	                    active_card.period_id\";\n	                    \n$retval = nuRunQuery($sql);\n$teachers=\'\';\n$first=true;\n\nif($retval){\n    while($row = db_fetch_row($retval)){\n        if($first){\n            $teachers=$row[0];\n            $first=false;\n        } else{\n            $teachers=$teachers.\' ,\'.$row[0];\n        }\n    }\n}\n\nif(!$first){\n    $sql=\"update #TABLE_ID# set teacher_names=\'\".$teachers.\"\'\";\n    nuRunQuery($sql);\n}\n\n$sql=\"SELECT mark_id FROM #TABLE_ID#\";\n$retval = nuRunQuery($sql);\n            \nwhile($row = db_fetch_row($retval)){\n                \n    $sql = \"    SELECT count(*)\n                FROM mark_critirion_special_level\n                WHERE \n                    mark_id=\'\".$row[0].\"\' AND \n                    critirion_special_level_id IS NOT NULL\";\n    $rv2=nuRunQuery($sql);\n    $r2 = db_fetch_row($rv2);\n                \n    if($r2[0]!=\'0\'){\n        $sql=\"  update #TABLE_ID# set critiria_count=\'\".$r2[0].\"\' where mark_id=\".$row[0];\n        nuRunQuery($sql);\n    }\n}\n\n$sql = \"SELECT COUNT(*),SUM(IF(mark_published=\'ΝΑΙ\',1,0)),SUM(IF(mark_published=\'ΟΧΙ\',1,0)) FROM #TABLE_ID#\";\n$rv3 = nuRunQuery($sql);\n$r3 = db_fetch_row($rv3);\n\n$all_published = ($r3[0]==$r3[1] ? true : false);\n$all_not_published = ($r3[0]==$r3[2] ? true : false);\n$lock_permission = ((\'#nu_user_group#\'==\'globeadmin\' || \'#nu_user_group#\'==\'Managers\' || \'#nu_user_group#\'==\'Administrators\') && \'#FORM_ID#\'==\'56312e4782e78b4\' ? true : false);\n\n$sql=\"  SELECT\n            mark_id,\n            grading_period_name,\n            class_short,\n            subject_full_name,\n            teacher_names,\n            student_registration_number,\n            student_surname,\n            student_name,\n            student_fathers_name,\n            hls,  \n            value_p,  \n            mark_added_when,\n            post_teacher_full_name,  \n            mark_published,\n            period_ended,\n            mark_comments,\n            critiria_count,\n            grading_period_num_of_decimals\n    from #TABLE_ID#\n    order by student_surname,student_name,student_fathers_name\";\n\n$retval = nuRunQuery($sql);\n\n\nprint \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n\n        <script type=\\\"text/javascript\\\">\n            \n            function openMarkDetails(mark_id){\n                parent.nuOpenFormInFrame(\'562d11f6d45ccf1\',mark_id);\n            }\n            \n            function lock(locker){\n                if (typeof parent.lock === \'function\') { \n                    parent.lock(\'#grading_period_id#\',\'#class_id#\',\'#subject_id#\',locker.checked);\n                } else {\n                    alert(\'Η λειτουργία δεν επιτρέπετε από αυτήν τη φόρμα!\');\n                }\n                \n            }\n        </script>\n        \n        <STYLE TYPE=\\\"text/css\\\">\n            \n            .sisTable TH{\n                font-size:9pt;\n            }\n            \n            .smallText{\n                font-family:Verdana;\n                font-size:6pt;                \n            }\n            \n            .valText_Bad{\n                font-family:Verdana;\n                font-size:11pt;\n                color: red;\n                text-align: right;\n                font-weight: bold;\n                padding-right: 7px;                \n            }\n            \n            .valText_Good{\n                font-family:Verdana;\n                font-size:11pt;\n                color: Orange;\n                text-align: right;\n                font-weight: bold;\n                padding-right: 7px;                \n            }\n            \n            .valText_VeryGood{\n                font-family:Verdana;\n                font-size:11pt;\n                color: blue;\n                text-align: right;\n                font-weight: bold;\n                padding-right: 7px;                \n            }\n            \n            .valText_Excellent{\n                font-family:Verdana;\n                font-size:11pt;\n                color: green;\n                text-align: right;\n                font-weight: bold;\n                padding-right: 7px;                \n            }            \n        </STYLE>\n\n\n    </head>\n\n    <body onload=\\\"adjustIframeHeight()\\\">\";\n    \nif($retval){ \n    if(db_num_rows($retval)>0){\n\n        $row = db_fetch_row($retval);\n    \n        $grading_period_name    = $row[1];\n        $class_name             = $row[2];\n        $subject_name           = $row[3];\n        $teacher_names          = $row[4];\n    \n        $color_disabled = \"LightGray\";\n            \n        print \"\n        <table cellspacing=0 align=center CLASS=\\\"sisTable\\\">\n            <tr height=35>\n                <th colspan=10 align=center valign=center>\n                    Βαθμολογική Κατάσταση - $grading_period_name\n                </th>\n            </tr>\n            <tr height=35>\n                <th colspan=10 align=center valign=center>\n                    $class_name - $subject_name\n                </th>\n            </tr>\n            <tr height=35>\n                <th colspan=10 align=center valign=center>\n                    Διδάσκοντες - $teacher_names\n                </th>\n            </tr>\n            <tr height=40>\n                <th width=45 align=center valign=center>Α.Μ.</th>\n                <th width=215 align=center valign=center>Επώνυμο</th>\n                <th width=150 align=center valign=center>Όνομα</th>\n                <th width=125 align=center valign=center>Πατρώνυμο</th>\n                <th width=45 align=center valign=center>Φοιτά</th>\n                <th width=70 align=center valign=center>Βαθμός</th>\n                <th width=80 align=center valign=center>Τελευταία Τροποποίηση</th>\n                <th width=150 align=center valign=center>Τροποποιήθηκε Από</th>\n                <th width=60 align=center valign=center>Κλειδ/νο\".(!$lock_permission ? \"\" : \n                    \"<input type=\\\"checkbox\\\" title=\\\"\".($all_published ? \"Ξεκλείδωμα Όλων\" : \"Κλείδωμα Όλων\").\"\\\" onclick=\\\"lock(this);\\\"\".($all_published ? \" checked\" : \"\").\">\").\"</th>\n                <th width=80 align=center valign=center>Περιγραφική Αξιολόγηση</th>\n            </tr>\";\n            \n        while($row){\n\n                print \"\n            <tr\".($row[13]==\'ΝΑΙ\' || $row[14]==\'ΝΑΙ\' ? \" style=\\\"background-color:$color_disabled;\\\"\" : \"\" ).\" height=25>\";\n                print \"             <td align=center><b>\".  (is_null($row[5]) || $row[5]==\'\'? \'&nbsp;\' : $row[5]).\"</b></td>\n                \";\n                print \"             <td  align=left><b>\".   (is_null($row[6]) || $row[6]==\'\'? \'&nbsp;\' : $row[6]).\"</b></td>\n                \";\n                print \"             <td align=left><b>\".    (is_null($row[7]) || $row[7]==\'\'? \'&nbsp;\' : $row[7]).\"</b></td>\n                \";\n                print \"             <td align=left><b>\".    (is_null($row[8]) || $row[8]==\'\'? \'&nbsp;\' : $row[8]).\"</b></td>\n                \";\n                print \"             <td align=center><b>\".    (is_null($row[9]) || $row[9]==\'\'? \'&nbsp;\' : $row[9]).\"</b></td>\n                \";\n                print \"             <td align=right><span CLASS=\\\"\".($row[10]<10 ? \"valText_Bad\" : ($row[10]<14 ? \"valText_Good\" : ($row[10]<17 ? \"valText_VeryGood\" : \"valText_Excellent\"))).\"\\\">\".format_mark_value($row[10],$row[17]).\"</span></td>\n                \";    \n                print \"             <td align=center><span CLASS=\\\"smallText\\\">\".(is_null($row[11]) || $row[11]==\'\'? \'&nbsp;\' : $row[11]).\"</span></td>\n                \";\n                print \"             <td align=center><span CLASS=\\\"smallText\\\">\".     (is_null($row[12]) || $row[12]==\'\'? \'&nbsp;\' : $row[12]).\"</span></td> \n                \";\n                print \"             <td align=center>\".     (is_null($row[13]) || $row[13]==\'\'? \'&nbsp;\' : $row[13]).\"</td>\n                \";\n                print \"             <td align=center>\".((is_null($row[15]) || $row[15]==\'\') && $row[16]==\'0\' ? \"&nbsp;\" : \"<img onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\" onclick=\\\"openMarkDetails(\".$row[0].\")\\\" id=\\\"img_\".$row[0].\"\\\" title=\\\"\".((is_null($row[15]) || $row[15]==\'\') ? \"Περιγραφική Αξιολόγηση\" : \'Σχόλια Καθηγητή : \'.mb_substr(strip_tags($row[15]), 0, 20,\"UTF-8\").\'...\').\"\\\" width=22 height=22 src=\\\"images/note.png\\\"</b>\").\"</td>\n                \";\n                print \"\n            </tr>\";\n            \n            $row = db_fetch_row($retval);\n        }\n\n    print \"\n        </table>\";\n\n    } else {\n        print \"<span CLASS=\\\"msg\\\">Δε βρέθηκαν βαθμοί...</span>\";\n    } \n} else {\n    print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν τα δεδομένα!</span>\");    \n}\n\nprint \"\n    </body>\n</html>\";\n','','0','2015-10-26 21:37:33','globeadmin','2018-08-14 10:56:40','globeadmin','2018-08-14 10:56:40','globeadmin','0'),('563134ef69e16fd','pass_mark_class','Βρίσκει τα τμήματα για τα οποία έχει κατατεθεί βαθμολογία σε μια συγκεκριμένη βαθμολογική περίοδο','teacher','$sql=\"SELECT distinct class.id,class.short_name\nFROM class\nINNER JOIN mark on class.id=mark.class_id\nwhere\nmark.grading_period_id=\'#grading_period_id#\'\nORDER BY class.short_name\";\n    \n$retval = nuRunQuery($sql);\n$nuParameters = \'\';\n\nif($retval ){\n    while($row = db_fetch_row($retval)) {\n            if($nuParameters==\'\'){\n                $nuParameters=$row[0].\"\\t\".$row[1];\n            }\n            else{\n                $nuParameters=$nuParameters.\"\\n\".$row[0].\"\\t\".$row[1];\n            }\n        }\n    }','','0','2015-10-28 22:49:51','globeadmin','2015-10-28 22:49:51','globeadmin','2016-10-25 20:25:57','globeadmin',''),('563137091e32c73','pass_mark_subject','Βρίσκει τα μαθήματα ενός τμήματος για τα οποία έχει κατατεθεί βαθμολογία σε μια συγκεκριμένη βαθμολογική περίοδο','teacher','$sql=\"SELECT distinct subject.id, concat(subject.name,if(subject_type.name is null,\'\',concat(\' (\',subject_type.name,\')\')))\nFROM subject\nINNER JOIN mark ON mark.subject_id=subject.id\nLEFT JOIN subject_type ON subject_type.id = subject.subject_type_id\nwhere\n    mark.grading_period_id=\'#grading_period_id#\' and\n    mark.class_id=\'#class_id#\'\nORDER BY subject.name,subject_type.name DESC\";\n    \n$retval = nuRunQuery($sql);\n$nuParameters = \'\';\n\nif($retval ){\n    while($row = db_fetch_row($retval)) {\n            if($nuParameters==\'\'){\n                $nuParameters=$row[0].\"\\t\".$row[1];\n            }\n            else{\n                $nuParameters=$nuParameters.\"\\n\".$row[0].\"\\t\".$row[1];\n            }\n        }\n    }','','0','2015-10-28 22:58:49','globeadmin','2015-10-28 22:59:16','globeadmin','2016-10-25 20:26:25','globeadmin',''),('56521e303a1e26c','teacher_students','Εμφανίζει τους μαθητές ενός καθηγητή για επιλογή','teacher','$sql=\"DROP TEMPORARY TABLE IF EXISTS #TABLE_ID#\";\nnuRunQuery($sql);\n\n$sql=\"CREATE TEMPORARY TABLE #TABLE_ID# DEFAULT CHARACTER SET=utf8\n        SELECT \n            student.id,\n            student.registration_number,\n            student.surname,\n            student.name,\n            student.fathers_name,\n            grade.short_name,\n            student.prev_an_justified_absences,\n            student.prev_justified_absences,\n            if(advisor_id = \'#RECORD_ID#\',\'1\',\'0\') as is_advisor\n        FROM student\n        LEFT JOIN grade on grade.id=student.grade_id\n        WHERE \n            teacher_id = \'#RECORD_ID#\' OR \n            advisor_id = \'#RECORD_ID#\' OR\n            \'#nu_user_group#\'=\'Psychologists\'\n        ORDER BY grade_id,surname,name,fathers_name\";\nnuRunQuery($sql);\n\n$sql=\"ALTER TABLE #TABLE_ID#\nADD COLUMN adikaiologites INT NOT NULL DEFAULT 0,\nADD COLUMN dikaiologimenes INT NOT NULL DEFAULT 0,\nADD COLUMN synolo INT NOT NULL DEFAULT 0\";\n\nnuRunQuery($sql);\n\n\n$sql=\"SELECT id,prev_an_justified_absences,prev_justified_absences from #TABLE_ID#\";\n$rv = nuRunQuery($sql);\nif($rv){\n  while($r = db_fetch_row($rv)){\n\n    $sql=\"select ifNULL(sum(if(justified=1,0,1)),0),ifNULL(sum(justified),0),count(*) from absence where student_id=\".$r[0].\" and counts=1\";\n    $rv2 = nuRunQuery($sql);\n    $r2 = db_fetch_row($rv2);\n    \n    $sql=\"update #TABLE_ID# SET \n        adikaiologites=\".($r2[0]+$r[1]).\",\n        dikaiologimenes=\".($r2[1]+$r[2]).\",\n        synolo=\".($r2[2]+$r[1]+$r[2]).\"\n        where id=\".$r[0].\"\n    \";\n    nuRunQuery($sql);\n  }\n}\n        \n$sql=\"SELECT * from #TABLE_ID#\";       \n$retval = nuRunQuery($sql);\n\nprint \"\";\nprint \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">        \n\n        <script type=\\\"text/javascript\\\">\n        \n            var TableBackgroundNormalColor = \\\"LightBlue\\\";\n            var TableBackgroundNormalColorAdvisor = \\\"LightGreen\\\";\n            \n            var TableBackgroundMouseoverColor = \\\"Gold\\\";\n        \n            function ChangeBackgroundColor(row) {\n                row.style.cursor=\\\"pointer\\\";\n                row.style.backgroundColor = TableBackgroundMouseoverColor;\n            }\n\n            function RestoreBackgroundColor(row) {\n                row.style.cursor=\\\"auto\\\";\n                if(row.getAttribute(\'data-is-advisor\')==\'1\')\n                    row.style.backgroundColor = TableBackgroundNormalColorAdvisor;\n                else\n                    row.style.backgroundColor = TableBackgroundNormalColor; \n            }\n\n            function openStudent(student_id){\n                parent.nuOpenForm(\'\',\'\', \'5476201e5a3d38f\', student_id,\'Μαθητής\');\n                //parent.nuOpenFormInFrame(\'5476201e5a3d38f\',student_id); //--open form in floating window\n            }\n        </script>\n        \n        <STYLE TYPE=\\\"text/css\\\">\n            .mytable TH{\n                font-size:1.1em;\n            }\n            .sisTableLine TD{\n                font-weight: normal;\n            }            \n        </STYLE>\n\n    </head>\n\n    <body onload=\\\"adjustIframeHeight()\\\">\n        <table cellspacing=0 align=center CLASS=\\\"sisTableLine\\\">\";\n\n\nif($retval){\n    if(db_num_rows($retval)>0){\n        print (\"\n            <tr height=30> \n                    <th width=80 align=center>Α.Μ.</th>\n                    <th width=220 align=center>Επώνυμο</th>\n                    <th width=180 align=center>Όνομα</th>\n                    <th width=150 align=center>Πατρώνυμο</th>\n                    <th width=80 align=center>Τάξη</th>\n                    <th width=60 align=center>Αδικ.</th>\n                    <th width=60 align=center>Δικαιολ.</th>\n                    <th width=60 align=center>Σύνολο</th>\n            </tr>\");\n        \n        while($row = db_fetch_row($retval)){\n            print \"\n            <tr \".($row[8]==\"1\" ? \"style=\\\"background-color:lightGreen;\\\"\" : \"\" ).\"data-is-advisor=\\\"\".($row[8]).\"\\\" height=25 onclick=\\\"openStudent(\".$row[0].\")\\\" onmouseover=\\\"ChangeBackgroundColor(this)\\\" onmouseout=\\\"RestoreBackgroundColor(this)\\\">\n                    <td align=center>   \".$row[1].\"</td>\n                    <td align=left>     \".$row[2].\"</td>\n                    <td align=left>     \".$row[3].\"</td>\n                    <td align=left>     \".$row[4].\"</td>\n                    <td align=center>   \".(is_null($row[5]) ? \"&nbsp;\" : $row[5]).\"</td>\n                    <td align=right>     \".$row[9].\"</td>\n                    <td align=right>     \".$row[10].\"</td>\n                    <td align=right>     \".$row[11].\"</td>\n            </tr>\";\n        }\n        print (\"\n        </table>\");\n    } else {\n       print (\"<span CLASS=\\\"msg\\\">Δεν έχετε οριστεί υπεύθυνος σε μαθητές...</span>\"); \n    }\n} else {\n    print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν τα δεδομένα!</span>\");\n}\nprint \"\n    </body>\n</html>\";','','0','2015-11-22 21:57:36','globeadmin','2021-03-09 19:27:51','globeadmin','2021-03-09 19:27:51','globeadmin','0'),('56588495311fece','class_students','Εμφανίζει τους μαθητές ενός τμήματος με τα σύνολα των απουσιών τους','manager','$sql=\"DROP TEMPORARY TABLE IF EXISTS #TABLE_ID#\";\nnuRunQuery($sql);\n\n$sql=\"CREATE TEMPORARY TABLE #TABLE_ID# DEFAULT CHARACTER SET=utf8\n        SELECT \n            student.id,\n            student.registration_number,\n            student.surname,\n            student.name,\n            student.fathers_name,\n            grade.short_name,\n            student.prev_an_justified_absences,\n            student.prev_justified_absences\n        FROM student\n        LEFT JOIN grade on grade.id=student.grade_id\n        inner join student_class on student.id=student_class.student_id\n        WHERE student_class.class_id = \'#RECORD_ID#\'\n        ORDER BY grade_id,surname,name,fathers_name\";\nnuRunQuery($sql);\n\n$sql=\"ALTER TABLE #TABLE_ID#\nADD COLUMN adikaiologites INT NOT NULL DEFAULT 0,\nADD COLUMN dikaiologimenes INT NOT NULL DEFAULT 0,\nADD COLUMN synolo INT NOT NULL DEFAULT 0\";\n\nnuRunQuery($sql);\n\n$sql=\"SELECT id,prev_an_justified_absences,prev_justified_absences from #TABLE_ID#\";\n$rv = nuRunQuery($sql);\nif($rv){\n  while($r = db_fetch_row($rv)){\n\n    $sql=\"select ifNULL(sum(if(justified=1,0,1)),0),ifNULL(sum(justified),0),count(*) from absence where student_id=\".$r[0].\" and counts=1\";\n    $rv2 = nuRunQuery($sql);\n    $r2 = db_fetch_row($rv2);\n    \n    $sql=\"update #TABLE_ID# SET \n        adikaiologites=\".($r2[0]+$r[1]).\",\n        dikaiologimenes=\".($r2[1]+$r[2]).\",\n        synolo=\".($r2[2]+$r[1]+$r[2]).\"\n        where id=\".$r[0].\"\n    \";\n    nuRunQuery($sql);\n  }\n}\n        \n$sql=\"SELECT * from #TABLE_ID#\";       \n$retval = nuRunQuery($sql);\n\nprint \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">        \n\n        <script type=\\\"text/javascript\\\">\n        \n            var TableBackgroundNormalColor = \\\"LightBlue\\\";\n            var TableBackgroundMouseoverColor = \\\"LightSteelBlue\\\";\n\n            function ChangeBackgroundColor(row) {\n                row.style.backgroundColor = TableBackgroundMouseoverColor;\n            }\n\n            function RestoreBackgroundColor(row) {\n                row.style.backgroundColor = TableBackgroundNormalColor; \n            }\n        </script>\n        \n        <STYLE TYPE=\\\"text/css\\\">\n            .sisTable, .sisTable TD{\n                font-size:9pt;\n            }\n            \n            .sisTable TH{\n                font-size:10pt;\n            }\n        </STYLE>\n\n    </head>\n\n    <body onload=\\\"adjustIframeHeight()\\\">\n        <table cellspacing=0 align=center CLASS=\\\"sisTable\\\">\";\n\n\nif($retval){\n    if(db_num_rows($retval)>0){\n        print (\"\n            <tr height=30> \n                <th width=220 align=center>Επώνυμο</th>\n                <th width=180 align=center>Όνομα</th>\n                <th width=150 align=center>Πατρώνυμο</th>\n                <th width=60 align=center>Αδικ.</th>\n                <th width=60 align=center>Δικαιολ.</th>\n                <th width=60 align=center>Σύνολο</th>\n            </tr>\");\n        \n        while($row = db_fetch_row($retval)){\n            print \"\n            <tr height=25 onmouseover=\\\"ChangeBackgroundColor(this)\\\" onmouseout=\\\"RestoreBackgroundColor(this)\\\">\n                <td align=left>     \".$row[2].\"</td>\n                <td align=left>     \".$row[3].\"</td>\n                <td align=left>     \".$row[4].\"</td>\n                <td align=right>     \".$row[8].\"</td>\n                <td align=right>     \".$row[9].\"</td>\n                <td align=right>     \".$row[10].\"</td>\n            </tr>\";\n        }\n        print (\"\n        </table>\");\n    } else {\n       print (\"<span CLASS=\\\"msg\\\">Δεν έχετε οριστεί υπεύθυνος σε μαθητές!</span>\"); \n    }\n} else {\n    print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν τα δεδομένα!</span>\");\n}\nprint \"\n    </body>\n</html>\";','','0','2015-11-27 18:28:05','globeadmin','2018-07-15 23:01:47','globeadmin','2018-07-15 23:01:48','globeadmin','0'),('56608bc656a4d24','student_teachers_comments','Ημέρες και ώρες που ενημερώνουν οι διδάσκοντες ενός μαθητή','student','$sql = \"    select distinct\n                concat(IF(teacher.surname IS NULL,\'\',teacher.surname),IF(teacher.surname IS NULL,\'\',\' \'),IF(teacher.name IS NULL,\'\',teacher.name)) as teacher_full_name,\n                teacher.comments_for_students,\n                teaching_field.name,\n                IFNULL(teacher.web_page,\'\')\n            from    (\n                    select \n	                    card.id AS id,\n	                    card.valid_from AS valid_from,\n	                    card.subject_id AS subject_id,\n	                    card.teacher_id AS teacher_id,\n	                    card.class_id AS class_id,\n	                    card.classroom_id AS classroom_id,\n	                    card.day_id AS day_id,\n	                    card.period_id AS period_id \n                        from card \n                        where card.valid_from =(select max(timetable.start_date) from timetable where (timetable.start_date <= curdate()))\n                    ) \n            as active_card\n            INNER JOIN teacher on (teacher.id=active_card.teacher_id OR teacher.id=\'#teacher_id#\' OR teacher.id=\'#advisor_id#\')\n            LEFT JOIN teaching_field on teacher.teaching_field_id = teaching_field.id\n            where class_id in (select distinct class_id from student_class where student_id=#RECORD_ID#)\n            order by teacher_full_name\";\n\n$retval = nuRunQuery($sql);\n\nprint \"<html>\";\nprint \" <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n        \n        <STYLE TYPE=\\\"text/css\\\">\n            .sisTable TH{\n                font-size:1.2em;\n            }\n            .sisTable tr:nth-child(even){\n	            background-color: LightSteelBlue;\n            }	\n        </STYLE>\n    </head>\n\n    <body>\";\n\nif(!$retval ){\n    print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν τα δεδομένα!</span>\");\n} else{\n    print (\"\n        <table cellspacing=0 align=center CLASS=\\\"sisTable\\\">\n            <tr eight=35> \n                <th width=250 align=center>Καθηγητής</th>\n                <th width=150 align=center>Ειδικότητα</th>\n                <th width=300 align=center>Ημέρες και Ώρες</th> \n            </tr>\");\n\n    while($row = db_fetch_row($retval)){\n        print \"\n            <tr>\n                <td>\".$row[0].($row[3]==\'\' ? \'\' : \"<br>(<a href=\\\"\".$row[3].\"\\\" target=\\\"_blank\\\">\".$row[3].\"</a>)\").\"</td>\n                <td>\".(is_null($row[2]) ? \'&nbsp;\' : $row[2]).\"</td>\n                <td>\".(is_null($row[1]) ? \'&nbsp;-\' : $row[1]).\"</td>\n            </tr>\";\n    }\n    print (\"\n        </table>\");\n}\nprint \"\n    </body>\n</html>\";','','0','2015-12-03 20:36:54','globeadmin','2020-03-29 17:05:57','globeadmin','2020-03-29 17:05:57','globeadmin','0'),('5687b0505b9ec15','search_timetable_new','Αναζήτηση Διδασκαλιών Συγκεκριμένου Ωρολογίου με Κριτήρια','manager','print \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n        \n        <script type=\\\"text/javascript\\\">\n\n            function show_card_info(card_id){\n                parent.nuOpenFormInFrame(\'5616c3a5f23ccc8\',card_id);    \n            }\n        </script>\n\n        <STYLE TYPE=\\\"text/css\\\">\n            .sisTable TD{\n                font-size:7pt;\n            }\n        </STYLE>\n\n    </head>\n\n    <body onload=\\\"adjustIframeHeight()\\\">\";\n\n$sql=\"SELECT \n        card.id 					AS 	id,\n        DATE_FORMAT(card.valid_from,\'%d-%m-%Y\') AS 	valid_from,\n		\n        concat(if(teacher.surname is NULL,\'\',concat(teacher.surname,\' \')),ifNULL(teacher.name,\'\')) as teacher_full_name,\n		day.name 					AS 	day_name,\n        day.short_name 				AS 	day_short,\n        \n		period.short_name 			AS 	period_short,\n        period.name 				AS 	period_name,\n        \n		class.short_name 			AS 	class_short,\n        class.name 					AS 	class_name,\n        \n		subject.short_name 			AS 	subject_short,\n        subject.name 				AS 	subject_name,\n        subject_type.short_name 	AS 	subject_type_short,\n        subject_type.name 			AS 	subject_type_name,\n        \n		classroom.short_name 		AS 	classroom_short,\n        classroom.name 				AS 	classroom_name\n    FROM\n        card\n        INNER JOIN  timetable       ON  card.valid_from = timetable.start_date\n        INNER JOIN 	subject 		ON 	card.subject_id = subject.id\n        INNER JOIN 	teacher 		ON 	card.teacher_id = teacher.id\n        INNER JOIN 	class 			ON 	card.class_id = class.id\n        INNER JOIN 	day 			ON 	card.day_id = day.id\n        INNER JOIN 	period 			ON 	card.period_id = period.id\n        LEFT JOIN 	subject_type 	ON 	subject.subject_type_id = subject_type.id\n        LEFT JOIN 	classroom 		ON 	card.classroom_id = classroom.id\n	WHERE timetable.id=\'#RECORD_ID#\' AND\n    \n\";\n\n$order_text=\"ORDER BY card.day_id , card.period_id, class.short_name , teacher.short_name\";\n\nif(\'#class_id#\'!=\'#\'.\'class_id#\' && \'#class_id#\'!=\'\'){\n    $sql=$sql.\" class.id = \'#class_id#\' and \n    \";\n} \n\nif(\'#teacher_id#\'!=\'#\'.\'teacher_id#\' && \'#teacher_id#\'!=\'\'){\n    $sql=$sql.\" teacher.id = \'#teacher_id#\' and \n    \";\n} else {\n    $order_text=\"ORDER BY class.short_name ,card.day_id , card.period_id, teacher.short_name\"; \n}\n\nif(\'#day_id#\'!=\'#\'.\'day_id#\' && \'#day_id#\'!=\'\'){\n    $sql=$sql.\" day.id = \'#day_id#\' and \n    \";\n}\n\n$sql=$sql.\"\n    1=1\n    \".$order_text.\"\n\";\n       \n$retval=nuRunQuery($sql);\n\nif($retval) {\n    if(db_num_rows($retval)>0) {\n    \n        print (\"\n        <table cellspacing=0 CLASS=\\\"sisTable\\\">\n            <tr height=45>\n                <th width=70    align=center>Έναρξη Ισχύος</th>\n                <th width=70    align=center>Τμήμα</th>\n                <th width=70    align=center>Ημέρα</th>\n                <th width=70    align=center>Ώρα</th>\n                <th width=220   align=center>Μάθημα</th>\n                <th width=70    align=center>Τύπος Μαθήματος</th>\n                <th width=180   align=center>Καθηγητής</th>\n                <th width=70    align=center>Αίθουσα</th>\n                <th width=50    align=center>Αναλυτικές Πληροφορίες</th>\n            </tr>\");\n\n        $color1 =\'LightSkyBlue\';\n        $color2 =\'#48D1CC\';\n        \n        $color = $color2;\n        \n        $prev_day=\'\';\n        $prev_class=\'\';\n        while($row = db_fetch_row($retval)) {\n            \n            if($row[3]!=$prev_day || $row[7]!=$prev_class){\n                $color = ($color == $color1 ? $color2 : $color1);\n            }\n            \n            print (\"\n            <tr style=\\\"background-color:$color;\\\" height=35>\n                <td align=right>\".  (is_null($row[1]) || $row[1]==\'\'? \'&nbsp;\' : $row[1]).\"</td>\n                <td align=center>\". (is_null($row[7]) || $row[7]==\'\'? \'&nbsp;\' : $row[7]).\"</td>\n                <td align=center>\". (is_null($row[3]) || $row[3]==\'\'? \'&nbsp;\' : $row[3]).\"</td>\n                <td align=center>\". (is_null($row[5]) || $row[5]==\'\'? \'&nbsp;\' : $row[5]).\"</td>\n                <td align=left>\".   (is_null($row[10]) || $row[10]==\'\'? \'&nbsp;\' : $row[10]).\"</td>\n                <td align=center>\". (is_null($row[11]) || $row[11]==\'\'? \'&nbsp;\' : $row[11]).\"</td>\n                <td align=left>\".   (is_null($row[2]) || $row[2]==\'\'? \'&nbsp;\' : $row[2]).\"</td>\n                <td align=center>\".   (is_null($row[13]) || $row[13]==\'\'? \'&nbsp;\' : $row[13]).\"</td>\n                <td align=center title=\\\"Πληροφορίες/Επεξεργασία\\\" onclick=\\\"show_card_info(\".$row[0].\")\\\" onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\"><img src=\\\"images/info.png\\\"></td>\n            </tr>\");\n        \n            $prev_day=$row[3];\n            $prev_class=$row[7];\n        }\n       \n        print (\"\n        </table>\");\n    }\n    else{\n        print (\"<span CLASS=\\\"msg\\\">Δε βρέθηκαν διδασκαλίες...</span>\");\n    }\n}\nelse{\n    print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν δεδομένα...</span>\");\n}\nprint \"\n    </body>\n</html>\";\n','','0','2016-01-02 13:11:12','globeadmin','2018-07-15 23:00:23','globeadmin','2018-07-15 23:00:23','globeadmin','0'),('56883955e3ab0ac','copy_timetable_new','Αντιγράφει ένα συγκεκριμένο ωρολόγιο πρόγραμμα σε μια άλλη ημερομηνία','manager','if(\'#start_date#\'!=\'#\'.\'start_date#\' && \'#start_date#\'!=\'\'){\n    if(\'#new_timetable_date#\'!=\'#\'.\'new_timetable_date#\' && \'#new_timetable_date#\'!=\'\'){\n        \n        $today = date(\'Y-m-d\');\n        \n        if(\'#new_timetable_date#\'>$today){\n    \n            // έλεγχος ότι δεν υπάρχει ήδη ωρολόγιο στη νέα ημερομηνία\n            $sql=\"select count(*) from timetable where start_date=\'#new_timetable_date#\'\";\n            $retval=nuRunQuery($sql);\n            \n            if($row = db_fetch_row($retval)){\n                if($row[0]==0){\n                \n                        $sql=\"insert into card (\n                                    id,	\n                                    valid_from,\n                                    subject_id,\n                                    teacher_id,\n                                    class_id,\n                                    classroom_id,\n                                    day_id,\n                                    period_id)                        \n                        select \n                                    NULL,	\n                                    \'#new_timetable_date#\',\n                                    subject_id,\n                                    teacher_id,\n                                    class_id,\n                                    classroom_id,\n                                    day_id,\n                                    period_id\n                        from card \n                        where valid_from=\'#start_date#\'\";\n                        $rv=nuRunQuery($sql);\n            \n                        if($rv){\n                            $nuParameters = \'Το ωρολόγιο αντιγράφηκε επιτυχώς!\';\n                            \n                            $sql=\"insert into timetable (start_date) values (\'#new_timetable_date#\')\";\n                            nuRunQuery($sql);\n                        } else {\n                            $nuParameters = \'Παρουσιάστηκε πρόβλημα κατά την αντιγραφή του ωρολογίου! Η αντιγράφη δεν πραγματοποιήθηκε!\';\n                        }                \n            \n                } else {\n                    $nuError = \'Υπάρχει ήδη καταχωρημένο ωρολόγιο στην ημερομηνία αυτή! Παρακαλώ διαγράψτε το πρώτα! Η αντιγραφή δεν πραγματοποιήθηκε!\';    \n                }    \n            } else {\n                $nuError = \'Παρουσιάστηκε πρόβλημα κατά την αντιγραφή του ωρολογίου! Η αντιγράφη δεν πραγματοποιήθηκε!\';    \n            }\n\n        } else {\n            $nuError = \'Το ωρολόγιο δεν μπορεί να αντιγραφεί σε ημερομηνία μικρότερη ή ιση της σημερινής!\'; \n        }\n    } else {\n        $nuError = \'Παρακαλώ επιλέξτε πρώτα ημερομηνία έναρξης ισχύος του νέου ωρολογίου που θα δημιουργηθεί!\';    \n    }\n} else {\n    $nuError = \'Προσοχή : Δε βρεθηκε ωρολόγιο πρόγραμμα προς κλωνοποίηση!\';\n}','','0','2016-01-02 22:55:49','globeadmin','2016-02-09 19:36:18','globeadmin','2016-05-24 07:22:06','globeadmin',''),('56a11975eff1dd2','student_cards_date','Βρίσκει τις διδασκαλίες του μαθητή σε μια συγκεκριμένη ημερομηνία','teacher','print \"\n<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">            \n                \n        <STYLE TYPE=\\\"text/css\\\">\n            .mytable TH{\n                font-size:1.1em;\n            }\n        </STYLE>\n\n    </head>\n\n    <body>\";\n    \nif (\'#absence_date#\'!=\'#\'.\'absence_date\'.\'#\' && \'#absence_date#\'!=\'\'){\n\n    $absence_date = date_format(date_create_from_format(\'d-m-Y\',\'#absence_date#\'),\'Y-m-d\');\n    $day_of_week =  idate(\'w\', strtotime($absence_date))-1;        \n       \n    $sql=\"  SELECT count(*)\n            FROM holiday \n            INNER JOIN school_year  ON holiday.school_year_id=school_year.id\n            INNER JOIN school       ON school.school_year_id=school_year.id\n            WHERE holiday.holiday=\'\".$absence_date.\"\'\";\n    $rv1=nuRunQuery($sql);\n    \n    if($rv1){\n        $r1 = db_fetch_row($rv1);\n        if($r1[0]==0){\n            $sql=\"  SELECT count(*)\n                    FROM day \n                    WHERE id=\'\".$day_of_week.\"\'\";\n            $rv2=nuRunQuery($sql);\n            $r2 = db_fetch_row($rv2);\n            if($r2[0]!=0){\n            \n                $sql=\"select max(start_date) from timetable where start_date<=\'\".$absence_date.\"\'\"; \n                $rv3=nuRunQuery($sql);\n                $r3 = db_fetch_row($rv3);\n                $card_date=$r3[0];            \n            \n                print (\"\n        <table cellspacing=0 CLASS=\\\"sisTable\\\" align=center>\n            <tr height=45>\n                <th width=80 align=center>Ημερομηνία</th>\n                <th width=60 align=center>Ημέρα</th>\n                <th width=40 align=center>Ώρα</th>\n                <th width=50 align=center>Τμήμα</th>\n                <th width=200 align=center>Μάθημα</th>\n                <th width=150 align=center>Καθηγητής</th>\n                <th width=50 align=center>Αίθουσα</th>\n                <th width=120 align=center>Καταχωρητής</th>\n                <th width=160 align=center>Κατάσταση Διδασκαλίας</th>\n            </tr>\");\n\n\n                $sql=\"SELECT\n                        ifNULL(c.card_id,\'\'),\n	                    dp.day_name,\n	                    dp.period_short_name,\n	                    ifNULL(c.class_short,\'\'),\n	                    c.subject_full_name,\n	                    ifNULL(c.teacher_full_name,\'\'),\n	                    ifNULL(c.classroom_short,\'\'),\n	                    ifNULL(c.post_teacher_name,\'\'),\n	                    ifNULL(c.rg_no_lesson,\'-\'),\n	                    ifNULL(c.subject_name,\'\')\n	                from (	select day.id as day_id,day.name as day_name,day.short_name as day_short_name, period.id as period_id,period.name as period_name,period.short_name as period_short_name\n			                from day,period\n			                where day.id=\".$day_of_week.\"\n			                order by day.id,period.id) as dp\n	                left join (\n                                SELECT\n                                    active_card.id                      AS card_id,\n                	                active_card.day_id 			        AS day_id,\n	                                active_card.period_id 		        AS period_id,\n	                                day.name 					        AS day_name,	\n	                                period.short_name 			        AS period_short,\n	                                subject.name                        AS subject_name,\n                                    concat(ifNULL(subject.name,\'\'),if(subject_type.short_name is NULL, \'\', concat(\' (\',subject_type.short_name,\')\'))) as subject_full_name,	                                \n	                                classroom.short_name 		AS classroom_short,\n	                                class.short_name 			AS class_short,\n	                                concat(IF(teacher.surname IS NULL,\'\',teacher.surname),IF(teacher.surname IS NULL,\'\',\' \'),IF(teacher.name IS NULL,\'\',teacher.name)) as teacher_full_name,\n	                                rg.no_lesson                AS rg_no_lesson,\n	                                ifNUll(rg.teacher_short_name,t2.short_name) AS post_teacher_name\n                                FROM \n	                                (SELECT \n		                                card.id 			AS id,\n		                                card.valid_from 	AS valid_from,\n		                                card.subject_id 	AS subject_id,\n		                                card.teacher_id 	AS teacher_id,\n		                                card.class_id 		AS class_id,\n		                                card.classroom_id 	AS classroom_id,\n		                                card.day_id 		AS day_id,\n		                                card.period_id 		AS period_id\n	                                FROM card \n	                                WHERE card.valid_from =\'\".$card_date.\"\') as active_card \n	                                inner join subject 			on active_card.subject_id = subject.id \n	                                inner join teacher 			on active_card.teacher_id = teacher.id  \n	                                inner join day 				on active_card.day_id = day.id  \n	                                inner join period 			on active_card.period_id = period.id\n	                                inner join class 			on active_card.class_id = class.id	\n	                                left  join subject_type 	on subject.subject_type_id = subject_type.id  \n	                                left  join classroom 		on active_card.classroom_id = classroom.id\n	                                LEFT  JOIN teacher as t2    on class.post_teacher_id=t2.id\n	                                LEFT  JOIN \n	                                        (SELECT registered_card.id as id,\n	                                                card_id,\n	                                                no_lesson,\n	                                                teacher.short_name as teacher_short_name\n	                                        from registered_card\n	                                        left join teacher on teacher.id=registered_card.teacher_id\n	                                        where  DATE_FORMAT(card_date, \'%Y-%m-%d\')=\'\".$absence_date.\"\') as rg  \n	                                                            ON active_card.id=rg.card_id\n	                                                            \n                                WHERE  active_card.class_id in (select distinct class_id from student_class where student_id=\'#RECORD_ID#\')\n		                ) as c ON (c.day_id=dp.day_id AND c.period_id=dp.period_id)\n	\n                        order by dp.period_id\";\n                                       \n                $retval=nuRunQuery($sql);        \n                        \n                while($row = db_fetch_row($retval)) {\n                \n                    $color=\'lightblue\';\n                    \n                    if($row[9]==\'\'){\n                        $msg=\'Δεν υπάρχει διδασκαλία\';\n                        $color=\'LightGray\';\n                    } else if($row[8]==\'-\'){\n                        $msg=\'Δεν έχει καταχωρηθεί\';\n                        $color=\'red\';\n                    } else if($row[8]==\'1\'){\n                        $msg=\'Δεν έγινε μάθημα\';\n                        $color=\'#FFD700\';\n                    } else if($row[8]==\'0\'){\n                        $msg=\'Καταχωρήθηκε\';\n                        $color=\'lightgreen\';\n                    } else {\n                        $msg=\'Άγνωστο\';\n                    }\n                    print (\"\n            <tr style=\\\"background-color:$color;\\\" height=35>\n                <td align=center>\". date(\"d-m-Y\",strtotime($absence_date)).\"</td>\n                <td align=center>\". (is_null($row[1]) || $row[1]==\'\'? \'&nbsp;\' : $row[1]).\"</td>\n                <td align=center>\". (is_null($row[2]) || $row[2]==\'\'? \'&nbsp;\' : $row[2]).\"</td>\n                <td align=center>\". (is_null($row[3]) || $row[3]==\'\'? \'&nbsp;\' : $row[3]).\"</td>\n                <td align=left>\".   (is_null($row[4]) || $row[4]==\'\'? \'&nbsp;\' : $row[4]).\"</td>\n                <td align=left>\".   (is_null($row[5]) || $row[5]==\'\'? \'&nbsp;\' : $row[5]).\"</td>\n                <td align=center>\". (is_null($row[6]) || $row[6]==\'\'? \'&nbsp;\' : $row[6]).\"</td>\n                <td align=left>\".   (is_null($row[7]) || $row[7]==\'\'? \'&nbsp;\' : $row[7]).\"</td>\n                <td align=center>\".$msg.\"</td>\n            </tr>\");                    \n                }\n            } else {\n                print \"<span CLASS=\\\"msg\\\">Την ημέρα αυτή δε λειτούργει το σχολείο!<br>Δεν πραγματοποιήθηκαν διδασκαλίες!</span>\";    \n            }\n        } else {\n            print \"<span CLASS=\\\"msg\\\">Ημέρα αργίας!<br>Δεν πραγματοποιήθηκαν διδασκαλίες!</span>\";    \n        } \n    } else{\n        print \"<span CLASS=\\\"msgError\\\">Παρουσιάστηκε σφάλμα κατά την ανάκτηση των δεδομένων...</span>\";    \n    }\n} else {\n   print \"<span CLASS=\\\"msg\\\">Παρακαλώ ορίστε την ημερομηνία ...</span>\"; \n}\nprint \"\n    </body>\n</html>\";            \n','','0','2016-01-21 19:46:29','globeadmin','2018-07-16 10:25:58','globeadmin','2018-07-16 10:25:58','globeadmin','0'),('5b5cb6ec96e8b56','next_record','Βρίσκει την επόμενη εγγραφή σε μία φόρμα','sisyphos','$sql = \"    SELECT sfo_sql\n            FROM zzzsys_form\n            WHERE zzzsys_form_id = \'#FORM_ID#\'\";\n$retval=nuRunQuery($sql);\n\nif($retval){\n    if($row=db_fetch_row($retval)){\n    \n        $hashData = nuHashData();\n        $sql = nuReplaceHashes($row[0],$hashData);\n        \n        $rv=nuRunQuery($sql);\n        \n        $nuParameters = \'-1\';\n        $found = false;\n\n        while($r=db_fetch_array($rv)){\n\n            if($found){\n                $nuParameters = $r[\'id\'];\n                break;\n            }\n        \n            if($r[\'id\']==\'#RECORD_ID#\'){\n                $found = true;    \n            }  \n        }\n    } else {\n        $nuError = \"Προσοχή! Παρουσιάστηκε πρόβλημα κατά την ανάκτηση των δεδομένων!\";    \n    }\n} else {\n    $nuError = \"Προσοχή! Παρουσιάστηκε πρόβλημα κατά την ανάκτηση των δεδομένων!\";    \n}\n','','0','2018-07-28 21:33:16','globeadmin','2018-07-30 19:52:43','globeadmin','2018-07-30 19:52:43','globeadmin','0'),('5b5cb9cc119131f','prev_record','Βρίσκει την προηγούμενη εγγραφή σε μία φόρμα','sisyphos','$sql = \"    SELECT sfo_sql\n            FROM zzzsys_form\n            WHERE zzzsys_form_id = \'#FORM_ID#\'\";\n$retval=nuRunQuery($sql);\n\nif($retval){\n    if($row=db_fetch_row($retval)){\n        \n        $hashData = nuHashData();\n        $sql = nuReplaceHashes($row[0],$hashData);\n        \n        $rv=nuRunQuery($sql);\n        \n        $nuParameters = \'-1\';\n        $prev_id = \'-1\';\n\n        while($r=db_fetch_array($rv)){\n            \n            if($r[\'id\'] == \'#RECORD_ID#\'){\n                $nuParameters = $prev_id;\n                break;\n            } else {\n                $prev_id = $r[\'id\'];    \n            }            \n        }\n    } else {\n        $nuError = \"Προσοχή! Παρουσιάστηκε πρόβλημα κατά την ανάκτηση των δεδομένων!\";    \n    }\n} else {\n    $nuError = \"Προσοχή! Παρουσιάστηκε πρόβλημα κατά την ανάκτηση των δεδομένων!\";    \n}\n','','0','2018-07-28 21:45:32','globeadmin','2018-07-30 19:53:15','globeadmin','2018-07-30 19:53:15','globeadmin','0'),('56e66a88be4bdab','find_class_subjects_json','Νεο - Βρίσκει τα μαθήματα που διδάσκονται σε ένα τμήμα','teacher','$sql=\"SELECT distinct \n    subject.id , \n    concat(subject.name,if(subject_type.name is null,\'\',concat(\' (\',subject_type.name,\')\'))) as subject_name\nFROM subject\nINNER JOIN card on card.subject_id = subject.id\nLEFT JOIN subject_type ON subject_type.id = subject.subject_type_id\nWHERE card.class_id=\'#class_id#\' and \n    card.valid_from = (select max(start_date) from timetable where start_date <= curdate())\nORDER BY subject.name,subject_type.name DESC\";\n    \n$retval = nuRunQuery($sql);\n$data_array =  array();\n$nuParameters = \'\';\n\nif($retval){\n\n    while($row = db_fetch_row($retval)) {\n        $data_array[]= $row;      \n    }\n    \n    $json_string = json_encode($data_array);\n    $nuParameters = $json_string;\n}','','1','2016-03-14 09:38:48','globeadmin','2016-03-14 10:23:31','globeadmin','2016-10-25 20:28:30','globeadmin',''),('56e336066cc393d','find_registered_card','Βρίσκει - αν υπάρχει - τη κάρτα διδασκαλίας','teacher','if (\'#absence_date#\'!=\'#\'.\'absence_date\'.\'#\' && \'#absence_date#\'!=\'\'){\n    $absence_date = \'#absence_date#\';\n} else {\n    $absence_date = date(\'Y-m-d\');\n}\n\nif (\'#absence_period_id#\'!=\'#\'.\'absence_period_id\'.\'#\' && \'#absence_period_id#\'!=\'\'){\n    $period_id = \'#absence_period_id#\';\n} else {\n    $sql =\"select id from period where curtime() between period.start_time and period.end_time\";\n    $rv=nuRunQuery($sql);\n    if($rv && db_num_rows($rv)>0){\n        $r = db_fetch_row($rv);\n        $period_id = $r[0];\n    } else{\n        $period_id = \'-1\';\n    }\n}\n\nif (\'#absence_class_id#\'!=\'#\'.\'absence_class_id\'.\'#\' && \'#absence_class_id#\'!=\'\'){\n    $class_id = \'#absence_class_id#\';\n} else {\n    $class_id = \'-1\';\n}\n\nif($period_id != \'-1\' && $class_id != \'-1\'){\n    \n    $sql=\"  SELECT registered_card.id\n            FROM registered_card\n            INNER JOIN card on card.id = registered_card.card_id\n            WHERE\n                DATE_FORMAT(registered_card.card_date, \'%Y-%m-%d\') = \'\".$absence_date.\"\' and\n                registered_card.prime   = 1 and\n                card.period_id          = \'\".$period_id.\"\' and\n                card.class_id           = \'\".$class_id.\"\'\"; \n                \n    $retval=nuRunQuery($sql);\n        \n    if($retval && db_num_rows($retval)==1){\n        $row = db_fetch_row($retval);\n        $nuParameters = $row[0];\n    } else {\n        $nuParameters = \'-1\';\n    }\n} else {\n    $nuParameters = \'-1\';\n} \n','','1','2016-03-11 23:17:58','globeadmin','2016-07-17 00:31:46','globeadmin','2021-04-04 14:19:44','globeadmin','0'),('56e55fec572abc6','find_class_subjects','Βρίσκει τα μαθήματα που διδάσκονται σε ένα τμήμα','teacher','$sql=\"SELECT distinct subject.id, concat(subject.name,if(subject_type.name is null,\'\',concat(\' (\',subject_type.name,\')\')))\nFROM subject\nINNER JOIN card on card.subject_id = subject.id\nLEFT JOIN subject_type ON subject_type.id = subject.subject_type_id\nWHERE card.class_id=\'#class_id#\' and \n    card.valid_from = (select max(start_date) from timetable where start_date <= curdate())\nORDER BY subject.name,subject_type.name DESC\";\n    \n$retval = nuRunQuery($sql);\n$nuParameters = \'\';\n\nif($retval ){\n    while($row = db_fetch_row($retval)) {\n            if($nuParameters==\'\'){\n                $nuParameters=$row[0].\"\\t\".$row[1];\n            }\n            else{\n                $nuParameters=$nuParameters.\"\\n\".$row[0].\"\\t\".$row[1];\n            }\n        }\n    }','','1','2016-03-13 14:41:16','globeadmin','2016-03-13 14:51:54','globeadmin','2017-12-20 15:36:50','globeadmin',''),('56eae990f0fff5f','create_comments_book','Δημιουργεί λίστα με τα σχόλια για τους μαθητές ενός τμήματος και ενός μαθήματος','sisyphos','print \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n        \n        <STYLE TYPE=\\\"text/css\\\">\n            .sisTableLine TH{\n                font-size:9pt;\n            }\n            \n            .sisTableLine TD{\n	            font-weight: normal;\n            }\n            \n            .sisTableLine tr:nth-child(even){\n	            background-color: LightSteelBlue;\n            }\n        </STYLE>\n    </head>\n\n    <body onload=\\\"adjustIframeHeight()\\\">\";\n    \n// Δημιουργία εγγραφών για τους μαθητές του τμήματος αν δεν υπάρχουν ήδη\n\n$sql = \"CREATE TEMPORARY TABLE IF NOT EXISTS #TABLE_ID# AS \n        (   SELECT\n                student_class.student_id AS s_id\n            FROM student_class\n            INNER JOIN session_variables   ON (student_class.class_id = session_variables.class_id)\n            WHERE \n                session_variables.session_id=\'#session_id#\' AND\n                student_class.student_id not in \n                    (   SELECT comment.student_id \n                        FROM comment\n                        INNER JOIN session_variables as sv   ON (sv.subject_id = comment.subject_id)\n                        WHERE\n                            sv.session_id=\'#session_id#\'\n                    )\n        )\n        \";  \nnuRunQuery($sql);\n\n$sql = \" INSERT INTO comment (\n                id,	\n                student_id,\n                subject_id,\n                post_teacher_id,\n                changed_at,\n                student_viewed_at,\n                parent_viewed_at,\n                student_comments_changed_at)\n            SELECT\n                NULL,\n                s_id,\n                session_variables.subject_id,\n                #RECORD_ID#,\n                NOW(),\n                NOW(),\n                NOW(),\n                NOW()\n            FROM #TABLE_ID#,session_variables\n            WHERE session_variables.session_id=\'#session_id#\'\n        \";\nnuRunQuery($sql);    \n\n// ----------------------\n$sql=\"  SELECT \n                concat(class.short_name, \' - \', subject.name, IF(subject_type.short_name IS NULL,\'\',CONCAT(\' (\',subject_type.name,\')\')))\n        FROM session_variables\n		INNER JOIN  class               on class.id         = session_variables.class_id\n        INNER JOIN  subject             on subject.id       = session_variables.subject_id\n        LEFT  JOIN  subject_type        on subject_type.id  = subject.subject_type_id\n        WHERE\n            session_variables.session_id=\'#session_id#\'\n        \";\n$rv = nuRunQuery($sql);\n$r = db_fetch_row($rv);\n$class_subject_name = $r[0];\n\n\n$sql = \"    SELECT\n                comment.id,\n                student.registration_number,\n                student.surname,\n                student.name,\n                student.fathers_name,\n                ifNULL(comment.teacher_comments,\'\'),\n                ifNULL(comment.student_comments,\'\')\n            FROM comment\n            INNER JOIN session_variables    ON (session_variables.subject_id = comment.subject_id)\n            INNER JOIN student_class        ON (student_class.class_id = session_variables.class_id AND student_class.student_id = comment.student_id)\n            INNER JOIN student 	            ON student.id   = comment.student_id\n            WHERE \n	            session_variables.session_id=\'#session_id#\'\n            ORDER BY student.surname,student.name,student.fathers_name\";\n$retval = nuRunQuery($sql);\n\nif($retval){\n    if(db_num_rows($retval)>0){\n\n        print (\"\n            <table CLASS=\\\"sisTableLine\\\" cellspacing=0 width=100%>\n                <tr height=35>\n                    <th colspan=5>\".$class_subject_name.\"</th>\n                </tr>\n                <tr height=35> \n                    <th width=80 align=center><b>Α.Μ.</b></th> \n                    <th width=200><b>Επώνυμο</b></th> \n                    <th width=150><b>Όνομα</b></th>\n                    <th width=150><b>Όνομα Πατρός</b></th>\n                    <th width=100  align=center><b>Σχόλια</b></th>\n                    \n                </tr>\");\n        \n        while($row = db_fetch_row($retval)) {\n        \n            print(\"\n            <tr height=27>            \n                 \n                <td align=center>\n                    \".$row[1].\"\n                </td>\n                \n                <td>\n                    \".$row[2].\"\n                </td>\n                 \n                <td>\n                    \".$row[3].\"\n                </td>\n                \n                <td>\n                    \".$row[4].\"\n                </td>\n        \n                <td align=center width=40 onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\" onclick=\\\"parent.nuOpenForm(\'\',\'\', \'56e98e66abfe2c1\', \'\".$row[0].\"\',\'Σχόλια Καθηγητή\')\\\">\n                    <img src=\\\"images/\".($row[5]!=\'\' || $row[6]!=\'\' ? \"edit_red.png\" : \"edit.png\").\"\\\" width=16 height=16 title=\\\"Επεξεργασία\\\">\n                </td>\n            </tr>\");    \n        }\n        \n        print (\"    \n        </table>\");\n        \n    } else {\n        print \"<span CLASS=\\\"msg\\\">Δε βρέθηκαν μαθητές. Παρακαλώ επιλέξτε Τμήμα-Μάθημα!</span>\";\n    }\n} else {\n    print \"<span CLASS=\\\"msgError\\\">Παρουσιάστηκε σφάλμα κατά την ανάκτηση των δεδομένων...</span>\";    \n}                        \nprint \"\n    </body>\n</html>\";','','0','2016-03-17 19:29:52','globeadmin','2018-07-23 09:25:16','globeadmin','2019-03-09 16:42:15','globeadmin','0'),('52c0da99b95c264','FILE','Upload File','nubuilder','$h = \"\n\n<html>\n<body style=\'background-color:lightgrey\'>\n\n<form enctype=\'multipart/form-data\' action=\'nuupload.php\' method=\'POST\'>\n     <input name=\'userfile\' type=\'file\' />\n    <input type=\'submit\' value=\'Send File\' />\n</form>\n\n</body>\n</html> \n\n\";\n\nprint $h;\n','51bf99ca103dbd5','0','2013-12-30 13:29:45','globeadmin','2014-02-19 09:41:13','globeadmin','2019-08-03 23:52:56','globeadmin','1'),('530a8f8e78111c4','TESTEMAIL','Test Email Settings','nubuilder','echo \"<pre>\";\necho \"Testing Email Settings<br>======================<br>\";\n\n$setup                      = $GLOBALS[\'nuSetup\'];                                      //-- Read SMTP AUTH Settings from zzsys_setup table	\n\nif (!empty($setup->set_smtp_username))          { $setup->set_smtp_username = trim($setup->set_smtp_username);}                       else{$errorText .= \"SMTP Username not set.<br>\";}\nif (!empty($setup->set_smtp_password)) 	        { $setup->set_smtp_password = trim($setup->set_smtp_password);}                       else{$errorText .= \"SMTP Password not set.<br>\";}\nif (!empty($setup->set_smtp_host))              { $setup->set_smtp_host = trim($setup->set_smtp_host);}                               else{$errorText .= \"SMTP Host not set.<br>\";}\nif (!empty($setup->set_smtp_from_address))      { $setup->set_smtp_from_address = trim($setup->set_smtp_from_address);}               else{$errorText .= \"SMTP From Address not set.<br>\";}\nif (!empty($setup->set_smtp_port))              { $setup->set_smtp_port = intval($setup->set_smtp_port);}                             else{$errorText .= \"SMTP PORT not set.<br>\";}\nif (!empty($setup->set_smtp_use_ssl))           { $setup->set_smtp_use_ssl = (intval($setup->set_smtp_use_ssl) == 1) ? true : false;} else{$setup->set_smtp_use_ssl = false;}\nif (!empty($setup->set_smtp_from_name))         { $SMTPname = trim($setup->set_smtp_from_name);}	                              else{$SMTPname = \"nuBuilder\";}\n\nif ($errorText != \'\') {\n	nuDisplayError(\"Unable to send SMTP Email, the following error(s) occured:<br>\" . $errorText);\n	return;\n	\n}else{\n\n	echo \"<br>SMTPhost: \" .$setup->set_smtp_host;\n	echo \"<br>SMTPport: \" .$setup->set_smtp_port;\n	echo \"<br>SMTPauth: \" .$setup->set_smtp_use_ssl;\n	echo \"<br>SMTPuser: \" .$setup->set_smtp_username;\n	echo \"<br>SMTPpass: \" .$setup->set_smtp_password;\n	echo \"<br>SMTPfrom: \" .$setup->set_smtp_from_address;\n	echo \"<br>SMTPfnam: \" .$setup->set_smtp_from_name;\n\n	$content = \"<H1>Test Email Settings</h1>\";\n	$subject = \"Test Email Settings\";\n\n	require_once(\"phpmailer/class.phpmailer.php\");\n\n	$mail                    = new PHPMailer();\n	$mail->IsSMTP();\n	$mail->Host              = $setup->set_smtp_host;\n	$mail->Port              = $setup->set_smtp_port;\n	$mail->SMTPSecure        = $setup->set_smtp_use_ssl ? \'ssl\' : \'\';\n	$mail->SMTPAuth          = $setup->set_smtp_use_ssl;\n\n	if ($setup->set_smtp_use_ssl) {\n		$mail->Username  = $setup->set_smtp_username;\n		$mail->Password  = $setup->set_smtp_password;\n	}\n\n	$mail->From              = $setup->set_smtp_from_address;\n	$mail->FromName          = $setup->set_smtp_from_name;\n\n	$mail->AddAddress($setup->set_smtp_from_address,$setup->set_smtp_from_name);\n	$mail->AddReplyTo($setup->set_smtp_from_address,$setup->set_smtp_from_name);\n\n	$mail->AddReplyTo        = $setup->set_smtp_from_address;\n	$mail->AddAddress        = $setup->set_smtp_from_address;\n	$mail->WordWrap          = 80;\n	$mail->IsHTML(true);\n	$mail->Subject           = $subject;\n	$mail->Body              = $content;\n\n	echo \"<br><br>PhpMailer Says:<br>================<br><br>\";\n\n	if(!$mail->Send()) {\n		echo \"Error sending: \" . $mail->ErrorInfo;;\n	} else {\n		echo \"Test sent\";\n	} \n\n}\n	\necho \"</pre>\";\n','51bf99ca103dbd5','0','2014-02-24 11:17:18','globeadmin','2014-02-24 13:35:10','globeadmin','2019-07-25 10:41:57','globeadmin','1'),('570a196b80430d3','send_sms','Στέλνει ένα sms σε ένα αριθμό τηλεφώνου','teachers','nuRunPHP(\'sms_lib\');\n\n$sql=\"  SELECT \n            sms_mobile_number,\n            IFNull(sms_teacher_id,\'-1\'),\n            IFNull(sms_student_id,\'-1\')\n        FROM session_variables \n        WHERE session_id=\'#session_id#\'\";\n$retval = nuRunQuery($sql);\n\nif($retval){\n    if($row=db_fetch_row($retval)){\n    \n        if(get_active_gateway_balance()>=1){\n\n            $sql=\"  SELECT ifNULL(teacher.sms_limit,90000)-count(*)\n                    FROM sms\n                    INNER JOIN teacher on teacher.id=sms.sender_id\n                    WHERE sender_id=\'#RECORD_ID#\'\";\n            $rv = nuRunQuery($sql);\n            $r = db_fetch_row($rv);\n\n            if($r[0]>=1){\n                if(send_sms(\'#RECORD_ID#\',$row[0],\'#sms_text#\',$row[1],$row[2])){\n                    $nuParameters = \"Το μήνυμα σας στάλθηκε!\";    \n                } else {\n                    $nuError = \"Παρουσιάστηκε πρόβλημα κατά την αποστολή του μηνύματος!\";\n                }    \n            } else {\n                $nuError = \"Το υπόλοιπο των μηνυμάτων σας δεν επαρκεί για την αποστολή!\\nΤο μηνύμα δεν στάλθηκε!\";     \n            }\n        } else {\n            $nuError = \"Το υπόλοιπο του λογαριασμού δεν επαρκεί για την αποστολή!\\nΤο μηνύμα δεν στάλθηκε!\";    \n        }    \n    } else {\n        $nuError = \'Η αποστολή απέτυχε! Δε βρέθηκαν στοιχεία μηνύματος!\';    \n    }\n} else {\n    $nuError = \'Η αποστολή απέτυχε! Πρόβλημα στην επικοινωνία με τη Βάση Δεδομένων!\';\n}\n\n\n\n','','0','2016-04-10 12:14:19','globeadmin','2016-04-23 18:09:59','globeadmin','2019-07-27 23:38:56','globeadmin','0'),('570a9f835bf5454','sms_get_balance','Βρίσκει το υπόλοιπο μηνυμάτων από τον επιλεγμένο (στις ρυθμίσεις) sms gateway','teachers','nuRunPHP(\'sms_lib\');\n\nprint \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n        \n        <STYLE TYPE=\\\"text/css\\\">\n            .sisTable TH{\n                font-size:10pt;\n                color: red;\n            }\n        </STYLE>\n\n    </head>\n\n    <body>\n        <table CLASS=\\\"sisTable\\\" cellspacing=0 width=100% height=100%>\n            <tr>\n                <th align=center style=\\\"background-color:LightYellow;\\\">\n                    \";\nif($o=get_gateway_object(\'#sms_gateway_id#\')){\n    print($o->get_balance());\n} else {\n    print(\'N/A\');\n}\nprint (\"\n                </th>\n            </tr>\n        </table>\n    </body>\n</html>\");			\n','','0','2016-04-10 21:46:27','globeadmin','2019-07-27 16:12:18','globeadmin','2019-07-27 16:43:41','globeadmin','0'),('570c988f9d95164','find_sms_gateway_details','Βρίσκει τις λεπτομέρειες (Όνομα χρήστη, κωδικό κ.α.) ενός sms gateway','teachers','$sql=\"  SELECT \n            id,\n            login_name,\n            login_password,\n            api_key,\n            originator\n        FROM sms_gateway \n        WHERE id=\'#sms_gateway_id#\'\";\n        \n$retval = nuRunQuery($sql);\n\n$data_array =  array();\n$nuParameters = \'\';\n\nif($retval){\n    if($row = db_fetch_row($retval)) {\n        $data_array[]= $row;\n        $nuParameters = json_encode($data_array);\n    }\n}','','0','2016-04-12 09:41:19','globeadmin','2019-07-27 23:21:02','globeadmin','2019-07-27 23:21:02','globeadmin','0'),('570d43d53aebdc2','send_test_sms','Στέλνει ένα τεστ sms σε ένα αριθμό τηλεφώνου','teachers','nuRunPHP(\'sms_lib\');\n\nprint \"<html> \n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n        \n        <title>Σίσυφος|Αποστολή Δοκιμαστικού SMS</title>\n        \n        <STYLE TYPE=\\\"text/css\\\">\n            .sisTable, .sisTable TD, .sisTable TH{\n                font-size:10pt;\n                color: black;\n                font-weight: bold;\n                border=nome;\n            }\n        </STYLE>\n    </head>\n\n    <body>\n        <table CLASS=\\\"sisTable\\\" cellspacing=0>\n            <tr>\n                <td align = left>\";\n\nif($o=get_gateway_object(\'#sms_gateway_id#\')){\n\n	$sql    = \"SELECT short_name FROM school WHERE id=1\";\n	$retval = nuRunQuery($sql);\n	$row    = db_fetch_row($retval);\n	$txt    = $row[0].\' - Δοκιμαστικό SMS\';\n	\n    $result = $o->sendSMS(\'#mobile_number#\',$txt);\n    \n    if($result[\'state\']==1){\n        print(\"Το Μήνυμα στάλθηκε επιτυχώς!<br>----------------------------<br>Κωδικός μηνύματος : \".$result[\'code\'].\"<br>Παρατηρήσεις : \".$result[\'remarks\']);    \n    } else {\n        print(\"Προσοχή : Παρουσιάστηκε πρόβλημα κατά την αποστολή του μηνύματος!<br>Το Μήνυμα δε στάλθηκε!\".\"<br>Παρατηρήσεις : \".$result[\'remarks\']);    \n    }\n} else {\n    print(\"Προσοχή : Δεν κατέστει εφικτή η σύνδεση με τον Λογαριασμό  / Πάροχο !<br>Το Μήνυμα δε στάλθηκε!\");\n}\n\nprint (\"\n            </td>\n        </tr>\n    </table>\");			\n	\nprint \"\n    </body>\n</html>\";\n','','0','2016-04-12 21:52:05','globeadmin','2019-07-28 00:41:32','globeadmin','2019-07-28 00:41:32','globeadmin','0'),('570f37d999d041a','validate_sms_phone_number','validates a phone_number','gadmin','function validate_phone_number($phone_text){\n    \n    //eliminate every char except 0-9\n    $justNums = preg_replace(\"/[^0-9]/\", \'\', $phone_text);\n\n    if (strlen($justNums) == 12){ // it\'s probably a valid phone number with country code in front\n        return(\"+\".$justNums);    \n    } elseif (strlen($justNums) == 10){ // it\'s probably a valid greek phone number\n        return(\"+30\".$justNums);\n    } else {\n        return;\n    }\n}\n\nprint \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n        \n        <STYLE TYPE=\\\"text/css\\\">\n            .sisTable TH{\n                font-size:10pt;\n                color: red;\n            }\n        </STYLE>\n\n    </head>\n\n    <body>\n        <table CLASS=\\\"sisTable\\\" cellspacing=0 width=300 height=100>\n            <tr bgcolor=LightYellow>\n                <th align = center>\n                    \";\nif($nb=validate_phone_number(\'#mobile_number#\')){\n    print \"#mobile_number#\".\"->\".$nb;\n} else {\n    print \"Μη έγκυρη μορφή αριθμού!\";\n}\nprint (\"\n                </th>\n            </tr>\n        </table>\n    </body>\n</html>\");','','0','2016-04-14 09:25:29','globeadmin','2018-06-29 00:16:11','globeadmin','2019-07-27 16:15:58','globeadmin','0'),('571147d19d7d69a','sms_lib','sms library','teachers','require_once(\'smsAPI.php\');\n\nfunction esc($str){\n    $db_params = nuRunQuery();\n    $link = mysqli_connect($db_params[0], $db_params[2], $db_params[3], $db_params[1]);\n\n    if (mysqli_connect_errno()) {\n        nuDebug(\"Connect failed: %s\\n\", mysqli_connect_error());\n        return \'\';\n    }\n    return(mysqli_real_escape_string($link,$str));\n}\n\nfunction get_gateway_object($gateway_id){\n	\n	$sql=\"	SELECT \n				ifNULL(class_name,\'\'),\n				ifNULL(login_name,\'\'),\n				ifNULL(login_password,\'\'),\n				ifNULL(api_key,\'\'),\n				ifNULL(originator,\'\')\n			FROM sms_gateway \n			WHERE id=\'\".$gateway_id.\"\' \n			\";\n			\n	$retval = nuRunQuery($sql);\n        \n	if($retval){\n		if(db_num_rows($retval)>0){\n			\n			$row = db_fetch_row($retval);\n			\n			if($row[0]!=\'\' && (($row[1]!=\'\' && $row[2]!=\'\') || ($row[3]!=\'\')) && $row[4]!=\'\'){\n			    $class_name	= $row[0];\n			    $o = new $class_name($row[1],$row[2],$row[3],$row[4]);		\n			    return($o);\n			} else {\n			    return;\n			}\n		} else {\n			return; \n		}\n	} else {\n		return;\n	}\n}\n\nfunction get_active_gateway_id(){\n	\n	$sql=\"	SELECT id\n			FROM sms_gateway \n			WHERE active=1 \n			LIMIT 1\";\n			\n	$retval = nuRunQuery($sql);\n        \n	if($retval){\n		if(db_num_rows($retval)>0){\n			$row = db_fetch_row($retval);\n			return($row[0]);\n		} else {\n			return -1; \n		}\n	} else {\n		return -1;\n	}\n}\n\nfunction get_active_gateway_object(){\n    $id = get_active_gateway_id();\n    if($id != -1) return get_gateway_object($id); else return; \n}\n\nfunction get_active_gateway_balance(){\n\n    if($o=get_active_gateway_object()){\n        return($o->get_balance());\n    } else {\n        return(\'N/A\');\n    }\n}\n\nfunction update_gateway_sms_status($gateway_id){\n    if($o=get_gateway_object($gateway_id)){\n        \n        if(method_exists($o,\"get_delivery_reports\")){\n            if($result = $o->get_delivery_reports()){\n                foreach ($result as $code => $result) {\n                    $sql    = \"UPDATE sms SET state=\'\".$result[\'state\'].($result[\'remarks\'] !=\'\' ? \"\', remarks=\'\".$result[\'remarks\'] : \'\').\"\', state_changed_at=NOW() WHERE code=\'$code\' and gateway_id=\'\".$gateway_id.\"\'\";\n                    nuRunQuery($sql);\n                }\n            }\n        }\n        \n        if(method_exists($o,\"get_SMS_report\")){\n            $sql = \"SELECT id,code,state FROM sms WHERE state in (0,1) AND gateway_id=\'\".$gateway_id.\"\'\";\n            $rv = nuRunQuery($sql);\n            while($r=db_fetch_row($rv)){\n                if(($result = $o->get_SMS_report($r[1])) && ($result[\'state\'] != $r[2])){\n                    $sql = \"UPDATE sms SET state=\'\".$result[\'state\'].($result[\'remarks\'] !=\'\' ? \"\', remarks=\'\".$result[\'remarks\'] : \'\').\"\', state_changed_at=NOW() WHERE code=\'\".$r[1].\"\' and gateway_id=\'\".$gateway_id.\"\'\";\n                    nuRunQuery($sql);    \n                }\n            }\n        }\n        \n    }\n}\n\nfunction update_all_sms_status(){\n    $sql    = \"SELECT distinct gateway_id FROM sms\";\n    $retval = nuRunQuery($sql);\n\n    if($retval){\n        while($row=db_fetch_row($retval)){\n            update_gateway_sms_status($row[0]);\n        }\n    }\n}\n\nfunction validate_phone_number($phone_text){\n    \n    //eliminate every char except 0-9\n    $justNums = preg_replace(\"/[^0-9]/\", \'\', $phone_text);\n\n    if (strlen($justNums) == 12){ // it\'s probably a valid phone number with country code in front\n        return(\"+\".$justNums);    \n    } elseif (strlen($justNums) == 10){ // it\'s probably a valid greek phone number\n        return(\"+30\".$justNums);\n    } else {\n        return;\n    }\n}\n\nfunction send_sms($sender_id,$mobile_number,$sms_text,$teacher_id=null,$student_id=null,$active_object=null,$active_gateway_id=null){\n    \n    $o = (is_null($active_object) ? get_active_gateway_object() : $active_object);\n    \n    if($o){\n	    $sql    = \"SELECT short_name FROM school WHERE id=1\";\n	    $retval = nuRunQuery($sql);\n	    $row    = db_fetch_row($retval);\n	    $txt    = $row[0].\':\'.$sms_text;\n	\n        $result = $o->sendSMS($mobile_number,$txt);\n    \n        $sql=\"  INSERT INTO sms (\n                        id,\n                        sender_id,\n                        sent_at,\n                        phone_number,\n                        sms_text,\n                        gateway_id,\n                        code,\n                        state,\n                        state_changed_at,\n                        remarks,\n                        teacher_id,\n                        student_id\n                        )\n                VALUES (\n                        NULL,\n                        \'\".$sender_id.\"\',\n                        NOW(),\n                        \'\".$mobile_number.\"\',\n                        \'\".esc($txt).\"\',\n                        \'\".(is_null($active_gateway_id) ? get_active_gateway_id() : $active_gateway_id).\"\',\n                        \'\".$result[\'code\'].\"\',\n                        \'\".$result[\'state\'].\"\',\n                        NOW(),\n                        \'\".$result[\'remarks\'].\"\',\n                        \".(is_null($teacher_id) || $teacher_id==-1 ? \'NULL\' : $teacher_id).\",\n                        \".(is_null($student_id) || $student_id==-1 ? \'NULL\' : $student_id).\"\n                    )\";\n        nuRunQuery($sql);\n        \n        if($result[\'state\']==1){\n            return true;\n        } else {\n            return false;\n        }\n    } else {\n        return false;\n    }\n}\n','','0','2016-04-15 22:58:09','globeadmin','2019-07-28 20:04:35','globeadmin','2019-07-31 21:25:52','globeadmin','0'),('5712874ac076347','sms_get_active_balance','Βρίσκει το υπόλοιπο μηνυμάτων από τον τρέχοντα sms gateway','teachers','nuRunPHP(\'sms_lib\');\n$nuParameters = get_active_gateway_balance();\n\n\n','','0','2016-04-16 21:41:14','globeadmin','2016-04-16 21:45:30','globeadmin','2019-07-27 16:43:31','globeadmin','0'),('571867a3c69b329','search_sms','Αναζήτηση sms με συγκεκριμένα κριτίρια','teacher','nuRunPHP(\'sms_lib\');\nupdate_all_sms_status();\n\nprint \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n        \n        <STYLE TYPE=\\\"text/css\\\">\n            .sisTable TH{\n                font-size:0.9em;\n            }\n            .sisTable TD{\n                font-size:0.8em;\n            }\n        </STYLE>\n</head>\n\n<body onload=\\\"adjustIframeHeight()\\\">\";\n\n$sql=\"  SELECT\n            sms.id,\n            DATE_FORMAT(sms.sent_at,\'%d-%m-%Y %H:%i:%s\'),\n            concat(if(sender.surname is NULL,\'\',sender.surname),if(sender.name is NULL,\'\',concat(\' \',sender.name))) as sender_name,\n            concat(if(student.surname is NULL,\'\',student.surname),if(student.name is NULL,\'\',concat(\' \',student.name)),if(student.fathers_name is NULL,\'\',concat(\' πατ. \',student.fathers_name))) as student_name,\n            concat(if(teacher_recipient.surname is NULL,\'\',teacher_recipient.surname),if(teacher_recipient.name is NULL,\'\',concat(\' \',teacher_recipient.name))) as teacher_name,\n            phone_number,\n            sms_text,\n            sms_gateway.name,\n            IF(state= \'1\',\'Στάλθηκε\',IF(state= \'2\',\'Παραδόθηκε\',IF(state= \'3\',\'Απέτυχε\',\'N/A\'))),\n            state,\n            ifNULL(remarks,\'\')\n        FROM sms\n            INNER JOIN sms_gateway                      ON  sms.gateway_id  = sms_gateway.id\n            INNER JOIN teacher  AS sender               ON  sms.sender_id   = sender.id\n            LEFT JOIN student                           ON  sms.student_id  = student.id\n            LEFT JOIN teacher   AS teacher_recipient    ON  sms.teacher_id  = teacher_recipient.id\n        WHERE\n\";\n\nif(\'#from_date#\'!=\'#\'.\'from_date#\' && \'#from_date#\'!=\'\'){\n    $sql=$sql.\" DATE_FORMAT(sms.sent_at,\'%Y-%m-%d\') >= \'#from_date#\' and \n    \";\n}\nif(\'#to_date#\'!=\'#\'.\'to_date#\' && \'#to_date#\'!=\'\'){\n    $sql=$sql.\" DATE_FORMAT(sms.sent_at,\'%Y-%m-%d\') <= \'#to_date#\' and \n    \";\n}\nif(\'#sender_id#\'!=\'#\'.\'sender_id#\' && \'#sender_id#\'!=\'\'){\n    //if(\'#sender_id#\'!=\'#RECORD_ID#\' || \'#teacher_id#\'!=\'#RECORD_ID#\'){\n       $sql=$sql.\" sms.sender_id = \'#sender_id#\' and \n    \"; \n    //}\n}\nif(\'#state#\'!=\'#\'.\'state#\' && \'#state#\'!=\'\'){\n    $sql=$sql.\" sms.state = \'#state#\' and \n    \";\n}\nif(\'#student_id#\'!=\'#\'.\'student_id#\' && \'#student_id#\'!=\'\'){\n    $sql=$sql.\" (sms.student_id = \'#student_id#\' OR sms.student_id is NULL) and \n    \";\n}\nif(\'#teacher_id#\'!=\'#\'.\'teacher_id#\' && \'#teacher_id#\'!=\'\'){\n    $sql=$sql.\" (sms.teacher_id = \'#teacher_id#\' OR sms.teacher_id is NULL) and \n    \";\n}\n\n$sql=$sql.\"\n    1=1\n    order by sms.sent_at,sender_name,student_name,teacher_name\n\";\n       \n$retval=nuRunQuery($sql);\n\nif($retval) {\n    if(db_num_rows($retval)>0) {\n    \n        print (\"\n        <table cellspacing=0 CLASS=\\\"sisTable\\\">\n            <tr height=45>\n                <th width=80 align=center>Ημερομηνία / Ώρα</th>\n                <th width=190 align=center>Αποστολέας</th>\n                <th width=190 align=center>Παραλήπτης</th>\n                <th width=60 align=center>Τηλέφωνο</th>\n                <th width=200 align=center>Μήνυμα</th>\n                <th width=60 align=center>Λογαρισμός</th>\n                <th width=100 align=center>Κατάσταση</th>\n            </tr>\");\n        \n        $color_send     = \'LightBlue\';\n        $color_success  = \'LightGreen\';\n        $color_fail     = \'OrangeRed\';\n        \n        $color          = $color_send;\n    \n        $send           = 0;\n        $success        = 0;\n        $fail           = 0;\n        \n        \n        while($row = db_fetch_row($retval)) {\n            \n            if ($row[9]==\'3\'){\n                $fail += 1;\n                $color = $color_fail;\n            } elseif ($row[9]==\'2\') {\n                $success += 1;\n                $color = $color_success;\n            } else {\n                $send += 1;\n                $color = $color_send;\n            }\n             \n    \n            print (\"            \n            <tr style=\\\"background-color:$color;\\\" height=35>\n                <td align=right>\".(is_null($row[1]) || $row[1]==\'\'? \'&nbsp;\' : $row[1]).\"</td>\n                <td align=center>\".(is_null($row[2]) || $row[2]==\'\'? \'&nbsp;\' : $row[2]).\"</td>\n                <td align=left>\".(is_null($row[3]) || $row[3]==\'\'? \'\' : $row[3]).(is_null($row[4]) || $row[4]==\'\'? \'\' : $row[4]).\"</td>\n                <td align=center>\".(is_null($row[5]) || $row[5]==\'\'? \'&nbsp;\' : $row[5]).\"</td>\n                <td align=left>\".(is_null($row[6]) || $row[6]==\'\'? \'&nbsp;\' : $row[6]).\"</td>\n                <td align=left>\".(is_null($row[7]) || $row[7]==\'\'? \'&nbsp;\' : $row[7]).\"</td>\n                <td align=center>\".(is_null($row[8]) || $row[8]==\'\'? \'&nbsp;\' : $row[8].(is_null($row[10]) || $row[10]==\'\'? \'\' : \':<br>(\'.$row[10].\')\')).\"</td>\n            </tr>\");\n        }\n        if($send>0){\n            print (\"\n            <tr height=25>\n                <th align=right colspan=6>Στάλθηκαν : </th>\n                <th align=right>$send</th>\n            </tr>\");\n        }\n        \n        if($success>0){\n            print (\"\n            <tr height=25>\n                <th align=right colspan=6>Παραδόθηκαν : </th>\n                <th align=right>$success</th>\n            </tr>\");\n        }\n        \n        if($fail>0){\n            print (\"\n            <tr height=25>\n                <th align=right colspan=6>Απέτυχαν : </th>\n                <th align=right><b>$fail</b></th>\n            </tr>\");\n        }\n        \n        print (\"\n            <tr height=25>\n                <th align=right colspan=6>Σύνολο : </th>\n                <th align=right>\".($send+$success+$fail).\"</th>\n            </tr>\");\n            \n        print (\"\n        </table>\");\n    } else{\n        print (\"<span CLASS=\\\"msg\\\">Δε βρέθηκαν SMS...</span>\");\n    }\n} else{\n    print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν δεδομένα...</span>\");\n}\nprint \"\n    </body>\n</html>\";\n','','0','2016-04-21 08:39:47','globeadmin','2019-07-28 00:00:37','globeadmin','2022-02-11 21:59:27','globeadmin','0'),('5719cc13ce50b1c','create_student_sms_list','Δημιουργεί τη λίστα των μαθητών με τα τηλέφωνα τους για μαζική αποστολή sms','teacher','function validate_phone_number($phone_text){\n    \n    //eliminate every char except 0-9\n    $justNums = preg_replace(\"/[^0-9]/\", \'\', $phone_text);\n\n    if (strlen($justNums) == 12){ // it\'s probably a valid phone number with country code in front\n        return(\"+\".$justNums);    \n    } elseif (strlen($justNums) == 10){ // it\'s probably a valid greek phone number\n        return(\"+30\".$justNums);\n    } else {\n        return;\n    }\n}\n\nprint \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n\n        <script type=\\\"text/javascript\\\">\n\n            function toggle69(source,class_name) {\n                checkboxes = document.getElementsByClassName(class_name);\n                for(var i=0, n=checkboxes.length;i<n;i++) {\n                    id_name = checkboxes[i].id;\n                    if (id_name.indexOf(\\\"+3069\\\") >= 0){\n                        checkboxes[i].checked = source.checked;\n                    }\n                }\n            }\n\n            function make_indeterminate(chk_name,phone_number) {\n                var all_chk = document.getElementById(chk_name);\n                all_chk.indeterminate = true;\n                if (phone_number.indexOf(\\\"+3069\\\") >= 0){\n                    var all_chk69 = document.getElementById(chk_name+\\\"69\\\");\n                    all_chk69.indeterminate = true;\n                }\n            }\n        </script>\n    </head>\n    <body onload=\\\"adjustIframeHeight()\\\">\";\n\n$sql=\"  SELECT distinct\n            student.id,\n            grade.short_name,\n            concat(\n                student.registration_number,\n                \' -\',\n                if(student.surname is NULL,\'\',concat (\' \',student.surname)),\n                if(student.name is NULL,\'\',concat (\' \',student.name)),\n                if(student.fathers_name is NULL,\'\',concat (\'<br>πατ. \',student.fathers_name))\n            ),\n            student.phone1,\n            student.phone2,\n            student.mobile,\n            student.parent_phone1,\n            student.parent_phone2,\n            student.parent_phone3,\n            student.has_left_school\n            \n        FROM student\n        INNER JOIN grade on grade.id=student.grade_id\n        left join (    select distinct student_id as s_id\n                            from student_class\n                            inner join card ON card.class_id=student_class.class_id\n                            where\n                                card.valid_from=(select max(start_date) from timetable) and   \n                                card.teacher_id=\'#RECORD_ID#\') as s ON s.s_id = student.id\n        \";\n        \n\nif(\'#class_id_sumo#\'!=\'#\'.\'class_id_sumo#\' && \'#class_id_sumo#\'!=\'\'){\n    $sql=$sql.\" INNER JOIN student_class on (student_class.student_id=student.id AND student_class.class_id  IN (#class_id_sumo#))\n    \";\n}\n\n$sql=$sql.\"WHERE \n    \";\n    \nif(\'#student_id_sumo#\'!=\'#\'.\'student_id_sumo#\' && \'#student_id_sumo#\'!=\'\'){\n    $sql=$sql.\" student.id IN (#student_id_sumo#) and \n    \";\n}\n\n$sql=$sql.\"\n    (\'#nu_user_group#\'=\'globeadmin\' OR \n    \'#nu_user_group#\'=\'Administrators\' OR \n    \'#nu_user_group#\'=\'Managers\' OR \n    \'#nu_user_group#\'=\'AssistManagers\' OR\n    \'#nu_user_group#\'=\'Secretaries\' OR\n    \'#nu_user_group#\'=\'Psychologists\' OR\n    s.s_id is not null OR\n    student.teacher_id = \'#RECORD_ID#\' OR\n    student.advisor_id = \'#RECORD_ID#\')\n    ORDER BY student.grade_id,student.surname,student.name,student.fathers_name\n\";\n   \n$retval = nuRunQuery($sql);\n\nif($retval) {\n    if(db_num_rows($retval)>0) {\n    \n        print (\"\n        <table  cellspacing=0 CLASS=\\\"sisTable\\\">\n            <tr height=30>\n                <th width=50 align=center rowspan=2>Τάξη</th>\n                <th width=250 align=center rowspan=2>Μαθητής</th>\n                <th width=300 align=center colspan=3 style=\\\"border-right-width:thick;\\\">Τηλέφωνα Μαθητή</th>\n                <th width=300 align=center colspan=3>Τηλέφωνα Γονέα</th>\n            </tr>\");\n            \n        print (\"\n            <tr height=50>\n                <th width=90 align=center>Τηλέφωνο 1<br>\n                    Όλα<input type=\\\"checkbox\\\" id=\\\"all_chk_1\\\" title=\\\"Επιλογή Όλων\\\" onclick=\\\"toggle(this,\'chk_1\')\\\">\n                    69<input CLASS=\\\"chk_1\\\" type=\\\"checkbox\\\" id=\\\"all_chk_169\\\" title=\\\"Επιλογή Όλων των 69...\\\" onclick=\\\"toggle69(this,\'chk_1\')\\\">\n                </th>\n                \n                <th width=90 align=center>Τηλέφωνο 2<br>\n                    Όλα<input type=\\\"checkbox\\\" id=\\\"all_chk_2\\\" title=\\\"Επιλογή Όλων\\\" onclick=\\\"toggle(this,\'chk_2\')\\\">\n                    69<input CLASS=\\\"chk_2\\\" type=\\\"checkbox\\\" id=\\\"all_chk_269\\\" title=\\\"Επιλογή Όλων των 69...\\\" onclick=\\\"toggle69(this,\'chk_2\')\\\">\n                </th>\n                \n                <th width=90 align=center style=\\\"border-right-width:thick;\\\">Κινητό<br>\n                    Όλα<input type=\\\"checkbox\\\" id=\\\"all_chk_3\\\" title=\\\"Επιλογή Όλων\\\" onclick=\\\"toggle(this,\'chk_3\')\\\">\n                    69<input CLASS=\\\"chk_3\\\" type=\\\"checkbox\\\" id=\\\"all_chk_369\\\" title=\\\"Επιλογή Όλων των 69...\\\" onclick=\\\"toggle69(this,\'chk_3\')\\\">\n                </th>\n                \n                <th width=90 align=center>Τηλέφωνο 1<br>\n                    Όλα<input type=\\\"checkbox\\\" id=\\\"all_chk_4\\\" title=\\\"Επιλογή Όλων\\\" onclick=\\\"toggle(this,\'chk_4\')\\\">\n                    69<input CLASS=\\\"chk_4\\\" type=\\\"checkbox\\\" id=\\\"all_chk_469\\\" title=\\\"Επιλογή Όλων των 69...\\\" onclick=\\\"toggle69(this,\'chk_4\')\\\">\n                </th>\n                \n                <th width=90 align=center>Τηλέφωνο 2<br>\n                    Όλα<input type=\\\"checkbox\\\" id=\\\"all_chk_5\\\" title=\\\"Επιλογή Όλων\\\" onclick=\\\"toggle(this,\'chk_5\')\\\">\n                    69<input CLASS=\\\"chk_5\\\" type=\\\"checkbox\\\" id=\\\"all_chk_569\\\" title=\\\"Επιλογή Όλων των 69...\\\" onclick=\\\"toggle69(this,\'chk_5\')\\\">\n                </th>\n                \n                <th width=90 align=center>Τηλέφωνο 3<br>\n                    Όλα<input type=\\\"checkbox\\\" id=\\\"all_chk_6\\\" title=\\\"Επιλογή Όλων\\\" onclick=\\\"toggle(this,\'chk_6\')\\\">\n                    69<input CLASS=\\\"chk_6\\\" type=\\\"checkbox\\\" id=\\\"all_chk_669\\\" title=\\\"Επιλογή Όλων των 69...\\\" onclick=\\\"toggle69(this,\'chk_6\')\\\">\n                </th>\n            </tr>\");  \n        \n            \n        while($row = db_fetch_row($retval)) {\n                \n            print (\"    \n            <tr\".($row[9]==1 ? \" style=\\\"background-color:#EE82EE;\\\"\" : \"\").\" height=35>\n                <td align=center>\".(is_null($row[1]) || $row[1]==\'\'? \'&nbsp;\' : $row[1]).\"</td>\n                <td align=left>\".(is_null($row[2]) || $row[2]==\'\'? \'&nbsp;\' : $row[2]).\"</td>\");\n                \n                if(!is_null($row[3]) && $row[3]!=\'\'){\n                    if($nb=validate_phone_number($row[3])){\n                        print(\"\n                <td align=right title=\\\"\".$nb.\"\\\">\".$row[3].\"<input type=\\\"checkbox\\\" CLASS=\\\"chk_1\\\" id=\\\"1_\".$row[0].\"_\".$nb.\"\\\" title=\\\"Επιλογή Τηλεφώνου\\\" onclick=\\\"make_indeterminate(\'all_chk_1\',\'\".$nb.\"\')\\\"></td>\");\n                    } else {\n                        print(\"\n                <td style=\\\"background-color:red;\\\" align=right>\".$row[3].\"</td>\");\n                    }   \n                } else{\n                    print(\"\n                <td>&nbsp;</td>\");    \n                }\n\n                if(!is_null($row[4]) && $row[4]!=\'\'){\n                    if($nb=validate_phone_number($row[4])){\n                        print(\"\n                <td align=right title=\\\"\".$nb.\"\\\">\".$row[4].\"<input type=\\\"checkbox\\\" CLASS=\\\"chk_2\\\" id=\\\"1_\".$row[0].\"_\".$nb.\"\\\" title=\\\"Επιλογή Τηλεφώνου\\\" onclick=\\\"make_indeterminate(\'all_chk_2\',\'\".$nb.\"\')\\\"></td>\");\n                    } else {\n                        print(\"\n                <td style=\\\"background-color:red;\\\" align=right>\".$row[4].\"</td>\");\n                    }   \n                } else{\n                    print(\"\n                <td>&nbsp;</td>\");    \n                }\n                \n                if(!is_null($row[5]) && $row[5]!=\'\'){\n                    if($nb=validate_phone_number($row[5])){\n                        print(\"\n                <td align=right style=\\\"border-right-width:thick;\\\" title=\\\"\".$nb.\"\\\">\".$row[5].\"<input type=\\\"checkbox\\\" CLASS=\\\"chk_3\\\" id=\\\"1_\".$row[0].\"_\".$nb.\"\\\" title=\\\"Επιλογή Τηλεφώνου\\\" onclick=\\\"make_indeterminate(\'all_chk_3\',\'\".$nb.\"\')\\\"></td>\");\n                    } else {\n                        print(\"\n                <td style=\\\"border-right-width:thick;background-color:red;\\\" align=right>\".$row[5].\"</td>\");\n                    }   \n                } else{\n                    print(\"\n                <td style=\\\"border-right-width:thick;\\\">&nbsp;</td>\");    \n                }\n                \n                if(!is_null($row[6]) && $row[6]!=\'\'){\n                    if($nb=validate_phone_number($row[6])){\n                        print(\"\n                <td align=right title=\\\"\".$nb.\"\\\">\".$row[6].\"<input type=\\\"checkbox\\\" CLASS=\\\"chk_4\\\" id=\\\"1_\".$row[0].\"_\".$nb.\"\\\" title=\\\"Επιλογή Τηλεφώνου\\\" onclick=\\\"make_indeterminate(\'all_chk_4\',\'\".$nb.\"\')\\\"></td>\");\n                    } else {\n                        print(\"\n                <td style=\\\"background-color:red;\\\" align=right>\".$row[6].\"</td>\");\n                    }   \n                } else{\n                    print(\"\n                <td>&nbsp;</td>\");    \n                }\n \n                if(!is_null($row[7]) && $row[7]!=\'\'){\n                    if($nb=validate_phone_number($row[7])){\n                        print(\"\n                <td align=right title=\\\"\".$nb.\"\\\">\".$row[7].\"<input type=\\\"checkbox\\\" CLASS=\\\"chk_5\\\" id=\\\"1_\".$row[0].\"_\".$nb.\"\\\" title=\\\"Επιλογή Τηλεφώνου\\\" onclick=\\\"make_indeterminate(\'all_chk_5\',\'\".$nb.\"\')\\\"></td>\");\n                    } else {\n                        print(\"\n                <td style=\\\"background-color:red;\\\" align=right>\".$row[7].\"</td>\");\n                    }   \n                } else{\n                    print(\"\n                <td>&nbsp;</td>\");    \n                }\n\n                if(!is_null($row[8]) && $row[8]!=\'\'){\n                    if($nb=validate_phone_number($row[8])){\n                        print(\"\n                <td align=right title=\\\"\".$nb.\"\\\">\".$row[8].\"<input type=\\\"checkbox\\\" CLASS=\\\"chk_6\\\" id=\\\"1_\".$row[0].\"_\".$nb.\"\\\" title=\\\"Επιλογή Τηλεφώνου\\\" onclick=\\\"make_indeterminate(\'all_chk_6\',\'\".$nb.\"\')\\\"></td>\");\n                    } else {\n                        print(\"\n                <td style=\\\"background-color:red;\\\" align=right>\".$row[8].\"</td>\");\n                    }   \n                } else{\n                    print(\"\n                <td>&nbsp;</td>\");    \n                }\n                \n            print (\"\n            </tr>\");\n        }\n        print (\"\n        </table>\");\n    } else{\n        print (\"<span CLASS=\\\"msg\\\">Δε βρέθηκαν Μαθητές...</span>\");\n    }\n} else{\n    print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν δεδομένα...</span>\");\n}\nprint \"\n    </body>\n</html>\";\n','','0','2016-04-22 10:00:35','globeadmin','2021-03-09 16:02:06','globeadmin','2021-03-09 19:27:13','globeadmin','0'),('571b3a668693434','send_mass_sms','Στέλνει ένα sms σε πολλούς αριθμούς τηλεφώνων','teacher','nuRunPHP(\'sms_lib\');\n\n$json_str = stripslashes(\'#phones_JSON#\'); \n$json = json_decode($json_str,true);\n\nif (json_last_error() === JSON_ERROR_NONE) {\n\n    if($o=get_active_gateway_object()){\n    \n        if(get_active_gateway_balance()>=count($json)){\n\n            $sql=\"  SELECT ifNULL(teacher.sms_limit,90000)-count(*)\n                    FROM sms\n                    INNER JOIN teacher on teacher.id=sms.sender_id\n                    WHERE sender_id=\'#RECORD_ID#\'\";\n            $retval = nuRunQuery($sql);\n            $row = db_fetch_row($retval);\n\n            if($row[0]>=count($json)){\n                $sent=0;\n                $fail=0;\n                foreach ($json as $recipient){\n                    if(send_sms(\'#RECORD_ID#\',$recipient[2],$recipient[3],$recipient[0],$recipient[1],$o)){\n                        $sent++;    \n                    } else {\n                        $fail++;\n                    }\n                }\n                $nuParameters = \"Στάλθηκαν \".$sent.\" SMS!\";\n                if($fail>0) {$nuParameters=$nuParameters.\"\\nΑπέτυχαν \".$fail.\" SMS!\";}\n            } else {\n                $nuParameters = \"Το υπόλοιπο των μηνυμάτων σας δεν επαρκεί για την αποστολή!\\nΤα μηνύματα δεν στάλθηκαν!\";     \n            }\n        } else {\n            $nuParameters = \"Το υπόλοιπο του λογαριασμού δεν επαρκεί για την αποστολή των μηνυμάτων!\\nΤα μηνύματα δεν στάλθηκαν!\";    \n        }\n    } else{\n        $nuParameters = \"Παρουσιάστηκε πρόβλημα κατά την αποστολή των μηνυμάτων!\\nΤα μηνύματα δεν στάλθηκαν!\";    \n    }\n} else {\n    nuDebug(\'sent mass SMS : JSON ERROR -> #phones_JSON#\');\n    $nuError = \"Παρουσιάστηκε σφάλμα κατά την αποστολή των μηνυμάτων!\\nΤα μηνύματα δεν στάλθηκαν!\";\n}\n\n\n','','0','2016-04-23 12:03:34','globeadmin','2016-09-24 20:26:00','globeadmin','2019-07-27 16:42:42','globeadmin','0'),('571bb4109fea243','create_teacher_sms_list','Δημιουργεί τη λίστα των καθηγητών με τα τηλέφωνα τους για μαζική αποστολή sms','teacher','function validate_phone_number($phone_text){\n    \n    //eliminate every char except 0-9\n    $justNums = preg_replace(\"/[^0-9]/\", \'\', $phone_text);\n\n    if (strlen($justNums) == 12){ // it\'s probably a valid phone number with country code in front\n        return(\"+\".$justNums);    \n    } elseif (strlen($justNums) == 10){ // it\'s probably a valid greek phone number\n        return(\"+30\".$justNums);\n    } else {\n        return;\n    }\n}\nprint \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n        \n        <STYLE TYPE=\\\"text/css\\\">\n            .sisTable TH{\n                font-size:1.1em;\n            }\n        </STYLE>\n\n        <script>\n            function toggle69(source,class_name) {\n                checkboxes = document.getElementsByClassName(class_name);\n                for(var i=0, n=checkboxes.length;i<n;i++) {\n                    id_name = checkboxes[i].id;\n                    if (id_name.indexOf(\\\"+3069\\\") >= 0){\n                        checkboxes[i].checked = source.checked;\n                    }\n                }\n            }\n\n            function make_indeterminate(chk_name,phone_number) {\n                var all_chk = document.getElementById(chk_name);\n                all_chk.indeterminate = true;\n                if (phone_number.indexOf(\\\"+3069\\\") >= 0){\n                    var all_chk69 = document.getElementById(chk_name+\\\"69\\\");\n                    all_chk69.indeterminate = true;\n                }\n            }\n        </script>\n    </head>\n    <body onload=\\\"adjustIframeHeight()\\\">\";\n\n\n$sql=\"  SELECT \n            teacher.id,\n            concat(\n                if(teacher.surname is NULL,\'\',concat (teacher.surname,\' \')),\n                ifNULL(teacher.name,\'\')\n            ),\n            \'\',\n            teacher.mobile,\n            teacher.phone1,\n            teacher.phone2\n        FROM teacher\n        WHERE\n        \";\nif(\'#teacher_id_sumo#\'!=\'#\'.\'teacher_id_sumo#\' && \'#teacher_id_sumo#\'!=\'\'){\n    $sql=$sql.\" (teacher.id IN (#teacher_id_sumo#)) and \n    \";\n}\n\nif(\'#select_teaching_field_id_sumo#\'!=\'#\'.\'select_teaching_field_id_sumo#\' && \'#select_teaching_field_id_sumo#\'!=\'\'){\n    $sql=$sql.\" (teacher.teaching_field_id IN (#select_teaching_field_id_sumo#)) and \n    \";\n}\n\n$sql=$sql.\"\n    1=1\n    ORDER BY teacher.surname,teacher.name\n\";\n   \n$retval = nuRunQuery($sql);\n\nif($retval) {\n    if(db_num_rows($retval)>0) {\n    \n        print (\"\n        <table cellspacing=0 CLASS=\\\"sisTable\\\" align=center>\n            <tr height=35>\n                <th width=350 align=center>Καθηγητής</th>\n                \n                <th width=180 align=center>Κινητό<br>\n                    Όλα<input type=\\\"checkbox\\\" id=\\\"all_chk_1\\\" title=\\\"Επιλογή Όλων\\\" onclick=\\\"toggle(this,\'chk_1\')\\\">\n                    69...<input CLASS=\\\"chk_1\\\" type=\\\"checkbox\\\" id=\\\"all_chk_169\\\" title=\\\"Επιλογή Όλων των 69...\\\" onclick=\\\"toggle69(this,\'chk_1\')\\\">\n                </th>\n                \n                <th width=180 align=center>Τηλέφωνο 1<br>\n                    Όλα<input type=\\\"checkbox\\\" id=\\\"all_chk_2\\\" title=\\\"Επιλογή Όλων\\\" onclick=\\\"toggle(this,\'chk_2\')\\\">\n                    69...<input CLASS=\\\"chk_2\\\" type=\\\"checkbox\\\" id=\\\"all_chk_269\\\" title=\\\"Επιλογή Όλων των 69...\\\" onclick=\\\"toggle69(this,\'chk_2\')\\\">\n                </th>\n                \n                <th width=180 align=center>Τηλέφωνο 2<br>\n                    Όλα<input type=\\\"checkbox\\\" id=\\\"all_chk_3\\\" title=\\\"Επιλογή Όλων\\\" onclick=\\\"toggle(this,\'chk_3\')\\\">\n                    69...<input CLASS=\\\"chk_3\\\" type=\\\"checkbox\\\" id=\\\"all_chk_369\\\" title=\\\"Επιλογή Όλων των 69...\\\" onclick=\\\"toggle69(this,\'chk_3\')\\\">\n                </th>\n            </tr>\");\n        \n        while($row = db_fetch_row($retval)) {\n                \n            print (\"\n            <tr height=29>\n                <td align=left>\".(is_null($row[1]) || $row[1]==\'\'? \'&nbsp;\' : $row[1]).\"</td>\");\n                \n                if(!is_null($row[3]) && $row[3]!=\'\'){\n                    if($nb=validate_phone_number($row[3])){\n                        print(\"\n                <td align=right title=\\\"\".$nb.\"\\\">\".$row[3].\"<input type=\\\"checkbox\\\" CLASS=\\\"chk_1\\\" id=\\\"1_\".$row[0].\"_\".$nb.\"\\\" title=\\\"Επιλογή Τηλεφώνου\\\" onclick=\\\"make_indeterminate(\'all_chk_1\',\'\".$nb.\"\')\\\"></td>\");\n                    } else {\n                        print(\"\n                <td style=\\\"background-color:red;\\\" align=right>\".$row[3].\"</td>\");\n                    }   \n                } else{\n                    print(\"\n                <td>&nbsp;</td>\");    \n                }\n\n                if(!is_null($row[4]) && $row[4]!=\'\'){\n                    if($nb=validate_phone_number($row[4])){\n                        print(\"\n                <td align=right title=\\\"\".$nb.\"\\\">\".$row[4].\"<input type=\\\"checkbox\\\" CLASS=\\\"chk_2\\\" id=\\\"1_\".$row[0].\"_\".$nb.\"\\\" title=\\\"Επιλογή Τηλεφώνου\\\" onclick=\\\"make_indeterminate(\'all_chk_2\',\'\".$nb.\"\')\\\"></td>\");\n                    } else {\n                        print(\"\n                <td style=\\\"background-color:red;\\\" align=right>\".$row[4].\"</td>\");\n                    }   \n                } else{\n                    print(\"\n                <td>&nbsp;</td>\");    \n                }\n                \n                if(!is_null($row[5]) && $row[5]!=\'\'){\n                    if($nb=validate_phone_number($row[5])){\n                        print(\"\n                <td align=right title=\\\"\".$nb.\"\\\">\".$row[5].\"<input type=\\\"checkbox\\\" CLASS=\\\"chk_3\\\" id=\\\"1_\".$row[0].\"_\".$nb.\"\\\" title=\\\"Επιλογή Τηλεφώνου\\\" onclick=\\\"make_indeterminate(\'all_chk_3\',\'\".$nb.\"\')\\\"></td>\");\n                    } else {\n                        print(\"\n                <td style=\\\"background-color:red;\\\" align=right>\".$row[5].\"</td>\");\n                    }   \n                } else{\n                    print(\"\n                <td>&nbsp;</td>\");    \n                }\n            print (\"\n            </tr>\");\n        }\n        print (\"\n        </table>\");\n    } else{\n        print (\"<span CLASS=\\\"msg\\\">Δε βρέθηκαν Καθηγητές...</span>\");\n    }\n} else{\n    print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν δεδομένα...</span>\");\n}\nprint \"\n    </body>\n</html>\";\n','','0','2016-04-23 20:42:40','globeadmin','2018-07-15 00:48:55','globeadmin','2018-07-15 00:48:55','globeadmin','0'),('571c76ec5f95f4a','create_student_absence_sms_list','Δημιουργεί τη λίστα των μαθητών με απουσίες τα τηλέφωνα τους για μαζική αποστολή sms','teacher','function validate_phone_number($phone_text){\n    \n    //eliminate every char except 0-9\n    $justNums = preg_replace(\"/[^0-9]/\", \'\', $phone_text);\n\n    if (strlen($justNums) == 12){ // it\'s probably a valid phone number with country code in front\n        return(\"+\".$justNums);    \n    } elseif (strlen($justNums) == 10){ // it\'s probably a valid greek phone number\n        return(\"+30\".$justNums);\n    } else {\n        return;\n    }\n}\n\nif (\'#to_date#\'==\'#\'.\'to_date\'.\'#\' || \'#to_date#\'==\'\' || \'#to_date#\'>date(\'Y-m-d\')){\n        $to_date = date(\'Y-m-d\');\n} else {\n    $to_date = date_format(date_create_from_format(\'Y-m-d\',\'#to_date#\'),\'Y-m-d\');\n}\n\nif(\'#absence_limit#\'!=\'#\'.\'absence_limit#\' && \'#absence_limit#\'!=\'\'){\n    $limit=\'#absence_limit#\';\n} else {\n    $limit=\'0\';\n}\n\nprint \"<html>\n    <head>\n\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">        \n\n        <STYLE TYPE=\\\"text/css\\\">\n            .sisTable, .sisTable TD{\n                font-size:7pt;\n            }\n            .sisTable TH{\n                font-size:8pt;\n            }\n        </STYLE>\n\n        <script type=\\\"text/javascript\\\">\n\n            function toggle69(source,class_name) {\n                checkboxes = document.getElementsByClassName(class_name);\n                for(var i=0, n=checkboxes.length;i<n;i++) {\n                    id_name = checkboxes[i].id;\n                    if (id_name.indexOf(\\\"+3069\\\") >= 0){\n                        checkboxes[i].checked = source.checked;\n                    }\n                }\n            }\n\n            function make_indeterminate(chk_name,phone_number) {\n                var all_chk = document.getElementById(chk_name);\n                all_chk.indeterminate = true;\n                if (phone_number.indexOf(\\\"+3069\\\") >= 0){\n                    var all_chk69 = document.getElementById(chk_name+\\\"69\\\");\n                    all_chk69.indeterminate = true;\n                }\n            }\n        </script>\n    </head>\n    <body onload=\\\"adjustIframeHeight(600)\\\">\";\n\n$sql=\"DROP TEMPORARY TABLE IF EXISTS #TABLE_ID#\";\nnuRunQuery($sql);\n\n$sql=\"  CREATE TEMPORARY TABLE #TABLE_ID# DEFAULT CHARACTER SET=utf8\n        SELECT \n            student.id as student_id,\n            grade.short_name as grade_short_name,\n            concat(\n                student.registration_number,\n                \' -\',\n                if(student.surname is NULL,\'\',concat (\' \',student.surname)),\n                if(student.name is NULL,\'\',concat (\' \',student.name)),\n                if(student.fathers_name is NULL,\'\',concat (\'<br>πατ. \',student.fathers_name))\n            ) as student_full_name,\n            student.phone1,\n            student.phone2,\n            student.mobile,\n            student.parent_phone1,\n            student.parent_phone2,\n            student.parent_phone3,\n            student.has_left_school,\n            student.prev_an_justified_absences,\n            student.prev_justified_absences\n        FROM student\n        INNER JOIN grade on grade.id=student.grade_id \n        \";\n\nif(\'#class_id#\'!=\'#\'.\'class_id#\' && \'#class_id#\'!=\'\' ){\n$sql=$sql.\"\n                INNER JOIN  (select distinct student_id from student_class where class_id in (#class_id#)) as sc ON  student.id = sc.student_id \n\";\n} \n\n$sql=$sql.\"WHERE \n    \";\n    \nif(\'#class_id#\'==\'#\'.\'class_id#\' || \'#class_id#\'==\'\'){\n$sql=$sql.\" student.teacher_id = \'#RECORD_ID#\' and \n\";\n}\n\nif(\'#export_student_id#\'!=\'#\'.\'export_student_id#\' && \'#export_student_id#\'!=\'\' ){\n    $sql=$sql.\" student.id = \'#export_student_id#\' and \n\";\n}\n\nif(\'#has_left_school#\'!=\'#\'.\'has_left_school#\' && \'#has_left_school#\'!=\'\' && \'#has_left_school#\'==\'1\'){\n    $sql=$sql.\" student.has_left_school = 0 and \n    \";\n}\n\n$sql=$sql.\"\n    1=1\n    ORDER BY student.grade_id,student.surname,student.name,student.fathers_name\n\";\nnuRunQuery($sql);\n\n$sql=\"ALTER TABLE #TABLE_ID#\nADD COLUMN adikaiologites INT NOT NULL DEFAULT 0,\nADD COLUMN dikaiologimenes INT NOT NULL DEFAULT 0,\nADD COLUMN synolo INT NOT NULL DEFAULT 0\";\nnuRunQuery($sql);\n\n$sql=\"SELECT student_id,prev_an_justified_absences,prev_justified_absences from #TABLE_ID#\";\n$rv = nuRunQuery($sql);\nif($rv){\n  while($r = db_fetch_row($rv)){\n\n    $sql=\"select ifNULL(sum(if(justified=1,0,1)),0),ifNULL(sum(justified),0),count(*) from absence where student_id=\".$r[0].\" and counts=1 and absence_date<=\'\".$to_date.\"\'\";\n    $rv2 = nuRunQuery($sql);\n    $r2 = db_fetch_row($rv2);\n    \n    $sql=\"update #TABLE_ID# SET \n        adikaiologites=\".($r2[0]+$r[1]).\",\n        dikaiologimenes=\".($r2[1]+$r[2]).\",\n        synolo=\".($r2[2]+$r[1]+$r[2]).\"\n        where student_id=\".$r[0].\"\n    \";\n    nuRunQuery($sql);\n  }\n}\n\n$sql=\"DELETE FROM #TABLE_ID# WHERE synolo<\".$limit;\nnuRunQuery($sql);\n        \n$sql=\"SELECT * from #TABLE_ID#\";       \n$retval = nuRunQuery($sql);\n\nif($retval) {\n    if(db_num_rows($retval)>0) {\n    \n        print (\"\n        <table cellspacing=0 CLASS=\\\"sisTable\\\">\n            <tr height=30>\n                <th width=40 align=center rowspan=2>Τάξη</th>\n                <th width=220 align=center rowspan=2>Μαθητής</th>\n                <th width=270 align=center colspan=3 style=\\\"border-right-width:thick;\\\">Τηλέφωνα Μαθητή</th>\n                <th width=270 align=center colspan=3><b>Τηλέφωνα Γονέα</th>\n                <th width=90 align=center colspan=3>Απουσίες</th>\n            </tr>\");\n            \n        print (\"\n            <tr height=50>\n                \n                <th width=90 align=center>Τηλέφωνο 1<br>\n                    Όλα<input type=\\\"checkbox\\\" id=\\\"all_chk_1\\\" title=\\\"Επιλογή Όλων\\\" onclick=\\\"toggle(this,\'chk_1\')\\\">\n                    69<input CLASS=\\\"chk_1\\\" type=\\\"checkbox\\\" id=\\\"all_chk_169\\\" title=\\\"Επιλογή Όλων των 69...\\\" onclick=\\\"toggle69(this,\'chk_1\')\\\">\n                </th>\n                \n                <th width=90 align=center>Τηλέφωνο 2<br>\n                    Όλα<input type=\\\"checkbox\\\" id=\\\"all_chk_2\\\" title=\\\"Επιλογή Όλων\\\" onclick=\\\"toggle(this,\'chk_2\')\\\">\n                    69<input CLASS=\\\"chk_2\\\" type=\\\"checkbox\\\" id=\\\"all_chk_269\\\" title=\\\"Επιλογή Όλων των 69...\\\" onclick=\\\"toggle69(this,\'chk_2\')\\\">\n                </th>\n                \n                <th width=90 align=center style=\\\"border-right-width:thick;\\\">Κινητό<br>\n                    Όλα<input type=\\\"checkbox\\\" id=\\\"all_chk_3\\\" title=\\\"Επιλογή Όλων\\\" onclick=\\\"toggle(this,\'chk_3\')\\\">\n                    69<input CLASS=\\\"chk_3\\\" type=\\\"checkbox\\\" id=\\\"all_chk_369\\\" title=\\\"Επιλογή Όλων των 69...\\\" onclick=\\\"toggle69(this,\'chk_3\')\\\">\n                </th>\n                \n                <th width=90 align=center>Τηλέφωνο 1<br>\n                    Όλα<input type=\\\"checkbox\\\" id=\\\"all_chk_4\\\" title=\\\"Επιλογή Όλων\\\" onclick=\\\"toggle(this,\'chk_4\')\\\">\n                    69<input CLASS=\\\"chk_4\\\" type=\\\"checkbox\\\" id=\\\"all_chk_469\\\" title=\\\"Επιλογή Όλων των 69...\\\" onclick=\\\"toggle69(this,\'chk_4\')\\\">\n                </th>\n                \n                <th width=90 align=center>Τηλέφωνο 2<br>\n                    Όλα<input type=\\\"checkbox\\\" id=\\\"all_chk_5\\\" title=\\\"Επιλογή Όλων\\\" onclick=\\\"toggle(this,\'chk_5\')\\\">\n                    69<input CLASS=\\\"chk_5\\\" type=\\\"checkbox\\\" id=\\\"all_chk_569\\\" title=\\\"Επιλογή Όλων των 69...\\\" onclick=\\\"toggle69(this,\'chk_5\')\\\">\n                </th>\n                \n                <th width=90 align=center>Τηλέφωνο 3<br>\n                    Όλα<input type=\\\"checkbox\\\" id=\\\"all_chk_6\\\" title=\\\"Επιλογή Όλων\\\" onclick=\\\"toggle(this,\'chk_6\')\\\">\n                    69<input CLASS=\\\"chk_6\\\" type=\\\"checkbox\\\" id=\\\"all_chk_669\\\" title=\\\"Επιλογή Όλων των 69...\\\" onclick=\\\"toggle69(this,\'chk_6\')\\\">\n                </th>\n                \n                <th width=30 align=center>Α</th>\n                <th width=30 align=center>Δ</th>\n                <th width=30 align=center>Σ</th>\n            </tr>\");  \n        \n            \n        while($row = db_fetch_row($retval)) {\n                \n            print (\"   \n            <tr\".($row[9]==1 ? \" style=\\\"background-color:#EE82EE;\\\"\" : \"\").\" height=30>\n                <td align=center>\".(is_null($row[1]) || $row[1]==\'\'? \'&nbsp;\' : $row[1]).\"</td>\n                <td id=\\\"stdname_\".$row[0].\"\\\" align=left>\".(is_null($row[2]) || $row[2]==\'\'? \'&nbsp;\' : $row[2]).\"</td>\");\n                \n                if(!is_null($row[3]) && $row[3]!=\'\'){\n                    if($nb=validate_phone_number($row[3])){\n                        print(\"\n                <td align=right title=\\\"\".$nb.\"\\\">\".$row[3].\"<input type=\\\"checkbox\\\" CLASS=\\\"chk_1\\\" id=\\\"1_\".$row[0].\"_\".$nb.\"\\\" title=\\\"Επιλογή Τηλεφώνου\\\" onclick=\\\"make_indeterminate(\'all_chk_1\',\'\".$nb.\"\')\\\"></td>\");\n                    } else {\n                        print(\"\n                <td style=\\\"background-color:red;\\\" align=right>\".$row[3].\"</td>\");\n                    }   \n                } else{\n                    print(\"\n                <td>&nbsp;</td>\");    \n                }\n\n                if(!is_null($row[4]) && $row[4]!=\'\'){\n                    if($nb=validate_phone_number($row[4])){\n                        print(\"\n                <td align=right title=\\\"\".$nb.\"\\\">\".$row[4].\"<input type=\\\"checkbox\\\" CLASS=\\\"chk_2\\\" id=\\\"1_\".$row[0].\"_\".$nb.\"\\\" title=\\\"Επιλογή Τηλεφώνου\\\" onclick=\\\"make_indeterminate(\'all_chk_2\',\'\".$nb.\"\')\\\"></td>\");\n                    } else {\n                        print(\"\n                <td style=\\\"background-color:red;\\\" align=right>\".$row[4].\"</td>\");\n                    }   \n                } else{\n                    print(\"\n                <td>&nbsp;</td>\");    \n                }\n                \n                if(!is_null($row[5]) && $row[5]!=\'\'){\n                    if($nb=validate_phone_number($row[5])){\n                        print(\"\n                <td style=\\\"border-right-width:thick;\\\" align=right title=\\\"\".$nb.\"\\\">\".$row[5].\"<input type=\\\"checkbox\\\" CLASS=\\\"chk_3\\\" id=\\\"1_\".$row[0].\"_\".$nb.\"\\\" title=\\\"Επιλογή Τηλεφώνου\\\" onclick=\\\"make_indeterminate(\'all_chk_3\',\'\".$nb.\"\')\\\"></td>\");\n                    } else {\n                        print(\"\n                <td style=\\\"border-right-width:thick;background-color:red;\\\" align=right>\".$row[5].\"</td>\");\n                    }   \n                } else{\n                    print(\"\n                <td style=\\\"border-right-width:thick;\\\">&nbsp;</td>\");    \n                }\n                \n                if(!is_null($row[6]) && $row[6]!=\'\'){\n                    if($nb=validate_phone_number($row[6])){\n                        print(\"\n                <td align=right title=\\\"\".$nb.\"\\\">\".$row[6].\"<input type=\\\"checkbox\\\" CLASS=\\\"chk_4\\\" id=\\\"1_\".$row[0].\"_\".$nb.\"\\\" title=\\\"Επιλογή Τηλεφώνου\\\" onclick=\\\"make_indeterminate(\'all_chk_4\',\'\".$nb.\"\')\\\"></td>\");\n                    } else {\n                        print(\"\n                <td style=\\\"background-color:red;\\\" align=right>\".$row[6].\"</td>\");\n                    }   \n                } else{\n                    print(\"\n                <td>&nbsp;</td>\");    \n                }\n \n                if(!is_null($row[7]) && $row[7]!=\'\'){\n                    if($nb=validate_phone_number($row[7])){\n                        print(\"\n                <td align=right title=\\\"\".$nb.\"\\\">\".$row[7].\"<input type=\\\"checkbox\\\" CLASS=\\\"chk_5\\\" id=\\\"1_\".$row[0].\"_\".$nb.\"\\\" title=\\\"Επιλογή Τηλεφώνου\\\" onclick=\\\"make_indeterminate(\'all_chk_5\',\'\".$nb.\"\')\\\"></td>\");\n                    } else {\n                        print(\"\n                <td style=\\\"background-color:red;\\\" align=right>\".$row[7].\"</td>\");\n                    }   \n                } else{\n                    print(\"\n                <td>&nbsp;</td>\");    \n                }\n\n                if(!is_null($row[8]) && $row[8]!=\'\'){\n                    if($nb=validate_phone_number($row[8])){\n                        print(\"\n                <td align=right title=\\\"\".$nb.\"\\\">\".$row[8].\"<input type=\\\"checkbox\\\" CLASS=\\\"chk_6\\\" id=\\\"1_\".$row[0].\"_\".$nb.\"\\\" title=\\\"Επιλογή Τηλεφώνου\\\" onclick=\\\"make_indeterminate(\'all_chk_6\',\'\".$nb.\"\')\\\"></td>\");\n                    } else {\n                        print(\"\n                <td style=\\\"background-color:red;\\\" align=right>\".$row[8].\"</td>\");\n                    }   \n                } else{\n                    print(\"\n                <td>&nbsp;</td>\");    \n                }\n                \n                print (\"\n                <td id=\\\"a_\".$row[0].\"\\\" align=right><b>\".(is_null($row[12]) || $row[12]==\'\'? \'&nbsp;\' : $row[12]).\"</b></td>\n                <td id=\\\"d_\".$row[0].\"\\\" align=right><b>\".(is_null($row[13]) || $row[13]==\'\'? \'&nbsp;\' : $row[13]).\"</b></td>\n                <td id=\\\"s_\".$row[0].\"\\\" align=right><b>\".(is_null($row[14]) || $row[14]==\'\'? \'&nbsp;\' : $row[14]).\"</b></td>\n                \");\n                \n            print (\"            \n            </tr>\");\n        }\n        \n        print (\"\n        </table>\");\n    } else{\n        print (\"<span CLASS=\\\"msg\\\">Δε βρέθηκαν Μαθητές...</span>\");\n    }\n} else{\n    print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν δεδομένα...</span>\");\n}\nprint \"\n    </body>\n</html>\";\n','','0','2016-04-24 10:34:04','globeadmin','2018-07-15 00:35:03','globeadmin','2018-07-15 00:35:03','globeadmin','0'),('571e7a2a61eb15a','create_parent_account','Δημιουργεί λογαριασμό για τον γονέα ενός μαθητή','manager','// Generates a strong password of N length containing at least one lower case letter,\n// one uppercase letter, one digit, and one special character. The remaining characters\n// in the password are chosen at random from those four sets.\n//\n// The available characters in each set are user friendly - there are no ambiguous\n// characters such as i, l, 1, o, 0, etc. This, coupled with the $add_dashes option,\n// makes it much easier for users to manually type or speak their passwords.\n//\n// Note: the $add_dashes option will increase the length of the password by\n// floor(sqrt(N)) characters.\n\n\nfunction generateStrongPassword($length = 9, $add_dashes = false, $available_sets = \'luds\')\n{\n	$sets = array();\n	if(strpos($available_sets, \'l\') !== false)\n		$sets[] = \'abcdefghjkmnpqrstuvwxyz\';\n	if(strpos($available_sets, \'u\') !== false)\n		$sets[] = \'ABCDEFGHJKMNPQRSTUVWXYZ\';\n	if(strpos($available_sets, \'d\') !== false)\n		$sets[] = \'23456789\';\n	if(strpos($available_sets, \'s\') !== false)\n		$sets[] = \'!@#$%&*?\';\n	$all = \'\';\n	$password = \'\';\n	foreach($sets as $set)\n	{\n		$password .= $set[array_rand(str_split($set))];\n		$all .= $set;\n	}\n	$all = str_split($all);\n	for($i = 0; $i < $length - count($sets); $i++)\n		$password .= $all[array_rand($all)];\n	$password = str_shuffle($password);\n	if(!$add_dashes)\n		return $password;\n	$dash_len = floor(sqrt($length));\n	$dash_str = \'\';\n	while(strlen($password) > $dash_len)\n	{\n		$dash_str .= substr($password, 0, $dash_len) . \'-\';\n		$password = substr($password, $dash_len);\n	}\n	$dash_str .= $password;\n	return $dash_str;\n}\n\n$sql=\"  SELECT \n            id,\n            registration_number,\n            DATE_FORMAT(birth_date,\'%d-%m-%Y\'),\n            surname,\n            name,\n            parent_email\n        FROM student  \n        WHERE \n            id=\'#RECORD_ID#\' AND \n            parent_user_id is NULL\";\n    \n$retval = nuRunQuery($sql);\n\nif($retval){\n    if(db_num_rows($retval)>0){\n        if($row = db_fetch_row($retval)){\n            \n            $id=nuID();\n            $user_name = $row[1].\"-parent\";\n            $pas=generateStrongPassword(6);\n            \n            $sql=\"delete from zzzsys_user where sus_login_name=\'\".$user_name.\"\'\"; \n            nuRunQuery($sql);\n        \n            $sql = \"    insert into zzzsys_user (\n                                zzzsys_user_id,\n                                sus_zzzsys_user_group_id,\n                                sus_name,\n                                sus_email,\n                                sus_login_name,\n                                sus_login_password,\n                                zzzsys_user_log_added_at,\n                                zzzsys_user_log_added_by,\n                                zzzsys_user_log_changed_at,\n                                zzzsys_user_log_changed_by,\n                                zzzsys_user_log_viewed_at,\n                                zzzsys_user_log_viewed_by\n                                )\n                            values(\n                                \'\".$id.\"\',\n                                \'5717ba3eb32c252\',\n                                \'\".$row[3].\' \'.$row[4].\" (Γονέας)\',\n                                \'\".$row[5].\"\',\n                                \'\".$user_name.\"\',\n                                md5(CONCAT(\'\".$user_name.\"\', \'\".$pas.\"\')),\n                                NOW(),\n                                \'globeadmin\',\n                                NOW(),\n                                \'globeadmin\',\n                                NOW(),\n                                \'globeadmin\'\n                        )\";\n            nuRunQuery($sql);\n	        \n	        $sql=\"update student set parent_user_id=\'\".$id.\"\' where id=#RECORD_ID#\";\n            nuRunQuery($sql);\n            \n            $nuParameters = \"Ο λογαριασμός δημιουργήθηκε επιτυχώς!\\nΌνομα Χρήστη : \".$user_name.\"\\nΚωδικός : \".$pas;\n            \n        } else {\n            $nuError = \"Παρουσιάστηκε σφάλμα κατά τη δημιουργία του λογαριασμού!\\nΟ Λογαριασμός δε δημιουργήθηκε!\";    \n        } \n    } else {\n        $nuError = \"Προσοχή : Υπάρχει ήδη λογαριασμός για το Γονέα!\";    \n    }\n} else {\n    $nuError = \"Παρουσιάστηκε σφάλμα κατά τη δημιουργία του λογαριασμού!\\nΟ Λογαριασμός δε δημιουργήθηκε!\";    \n}','','0','2016-04-25 23:12:26','globeadmin','2016-04-25 23:53:40','globeadmin','2021-09-07 20:44:28','globeadmin','0'),('571faf73f0d67fa','create_student_account','Δημιουργεί λογαριασμό για ένα μαθητή','manager','// Generates a strong password of N length containing at least one lower case letter,\n// one uppercase letter, one digit, and one special character. The remaining characters\n// in the password are chosen at random from those four sets.\n//\n// The available characters in each set are user friendly - there are no ambiguous\n// characters such as i, l, 1, o, 0, etc. This, coupled with the $add_dashes option,\n// makes it much easier for users to manually type or speak their passwords.\n//\n// Note: the $add_dashes option will increase the length of the password by\n// floor(sqrt(N)) characters.\n\n\nfunction generateStrongPassword($length = 9, $add_dashes = false, $available_sets = \'luds\')\n{\n	$sets = array();\n	if(strpos($available_sets, \'l\') !== false)\n		$sets[] = \'abcdefghjkmnpqrstuvwxyz\';\n	if(strpos($available_sets, \'u\') !== false)\n		$sets[] = \'ABCDEFGHJKMNPQRSTUVWXYZ\';\n	if(strpos($available_sets, \'d\') !== false)\n		$sets[] = \'23456789\';\n	if(strpos($available_sets, \'s\') !== false)\n		$sets[] = \'!@#$%&*?\';\n	$all = \'\';\n	$password = \'\';\n	foreach($sets as $set)\n	{\n		$password .= $set[array_rand(str_split($set))];\n		$all .= $set;\n	}\n	$all = str_split($all);\n	for($i = 0; $i < $length - count($sets); $i++)\n		$password .= $all[array_rand($all)];\n	$password = str_shuffle($password);\n	if(!$add_dashes)\n		return $password;\n	$dash_len = floor(sqrt($length));\n	$dash_str = \'\';\n	while(strlen($password) > $dash_len)\n	{\n		$dash_str .= substr($password, 0, $dash_len) . \'-\';\n		$password = substr($password, $dash_len);\n	}\n	$dash_str .= $password;\n	return $dash_str;\n}\n\n$sql=\"  SELECT \n            id,\n            registration_number,\n            DATE_FORMAT(birth_date,\'%d-%m-%Y\'),\n            surname,\n            name,\n            email\n        FROM student  \n        WHERE \n            id=\'#RECORD_ID#\' AND \n            user_id is NULL\";\n    \n$retval = nuRunQuery($sql);\n\nif($retval){\n    if(db_num_rows($retval)>0){\n        if($row = db_fetch_row($retval)){\n            \n            $id=nuID();\n            $user_name = $row[1];\n            if(\'#use_birthdate_as_pass#\'==\'1\'){\n                $pas=$row[2];\n            } else {\n                $pas=generateStrongPassword(6);    \n            }\n            \n            $sql=\"delete from zzzsys_user where sus_login_name=\'\".$user_name.\"\'\"; \n            nuRunQuery($sql);\n        \n            $sql = \"    insert into zzzsys_user (\n                                zzzsys_user_id,\n                                sus_zzzsys_user_group_id,\n                                sus_name,\n                                sus_email,\n                                sus_login_name,\n                                sus_login_password,\n                                zzzsys_user_log_added_at,\n                                zzzsys_user_log_added_by,\n                                zzzsys_user_log_changed_at,\n                                zzzsys_user_log_changed_by,\n                                zzzsys_user_log_viewed_at,\n                                zzzsys_user_log_viewed_by\n                                )\n                            values(\n                                \'\".$id.\"\',\n                                \'547de4c65675a29\',\n                                \'\".$row[3].\' \'.$row[4].\"\',\n                                \'\".$row[5].\"\',\n                                \'\".$user_name.\"\',\n                                md5(CONCAT(\'\".$user_name.\"\', \'\".$pas.\"\')),\n                                NOW(),\n                                \'globeadmin\',\n                                NOW(),\n                                \'globeadmin\',\n                                NOW(),\n                                \'globeadmin\'\n                        )\";\n            nuRunQuery($sql);\n	        \n	        $sql=\"update student set user_id=\'\".$id.\"\' where id=#RECORD_ID#\";\n            nuRunQuery($sql);\n            \n            $nuParameters = \"Ο λογαριασμός δημιουργήθηκε επιτυχώς!\\nΌνομα Χρήστη : \".$user_name.\"\\nΚωδικός : \".$pas;\n            \n        } else {\n            $nuError = \"Παρουσιάστηκε σφάλμα κατά τη δημιουργία του λογαριασμού!\\nΟ Λογαριασμός δε δημιουργήθηκε!\";    \n        } \n    } else {\n        $nuError = \"Προσοχή : Υπάρχει ήδη λογαριασμός για το Μαθητή!\";    \n    }\n} else {\n    $nuError = \"Παρουσιάστηκε σφάλμα κατά τη δημιουργία του λογαριασμού!\\nΟ Λογαριασμός δε δημιουργήθηκε!\";    \n}','','0','2016-04-26 21:12:03','globeadmin','2016-04-26 21:17:36','globeadmin','2018-07-13 00:54:21','globeadmin','0'),('57208dbe24f2fad','create_teacher_account','Δημιουργεί λογαριασμό για ένα Καθηγητή','manager','// Generates a strong password of N length containing at least one lower case letter,\n// one uppercase letter, one digit, and one special character. The remaining characters\n// in the password are chosen at random from those four sets.\n//\n// The available characters in each set are user friendly - there are no ambiguous\n// characters such as i, l, 1, o, 0, etc. This, coupled with the $add_dashes option,\n// makes it much easier for users to manually type or speak their passwords.\n//\n// Note: the $add_dashes option will increase the length of the password by\n// floor(sqrt(N)) characters.\n\n\nfunction generateStrongPassword($length = 9, $add_dashes = false, $available_sets = \'luds\')\n{\n	$sets = array();\n	if(strpos($available_sets, \'l\') !== false)\n		$sets[] = \'abcdefghjkmnpqrstuvwxyz\';\n	if(strpos($available_sets, \'u\') !== false)\n		$sets[] = \'ABCDEFGHJKMNPQRSTUVWXYZ\';\n	if(strpos($available_sets, \'d\') !== false)\n		$sets[] = \'23456789\';\n	if(strpos($available_sets, \'s\') !== false)\n		$sets[] = \'!@#$%&*?\';\n	$all = \'\';\n	$password = \'\';\n	foreach($sets as $set)\n	{\n		$password .= $set[array_rand(str_split($set))];\n		$all .= $set;\n	}\n	$all = str_split($all);\n	for($i = 0; $i < $length - count($sets); $i++)\n		$password .= $all[array_rand($all)];\n	$password = str_shuffle($password);\n	if(!$add_dashes)\n		return $password;\n	$dash_len = floor(sqrt($length));\n	$dash_str = \'\';\n	while(strlen($password) > $dash_len)\n	{\n		$dash_str .= substr($password, 0, $dash_len) . \'-\';\n		$password = substr($password, $dash_len);\n	}\n	$dash_str .= $password;\n	return $dash_str;\n}\n\nfunction greek_to_greeklish($string) { \nreturn strtr($string, array( \n    \'Α\' => \'a\',\n    \'Ά\' => \'a\',\n    \'Β\' => \'v\', \n    \'Γ\' => \'g\', \n    \'Δ\' => \'d\', \n    \'Ε\' => \'e\',\n    \'Έ\' => \'e\',\n    \'Ζ\' => \'z\', \n    \'Η\' => \'i\',\n    \'Ή\' => \'i\',\n    \'Θ\' => \'th\', \n    \'Ι\' => \'i\', \n    \'Ί\' => \'i\',\n    \'Κ\' => \'k\', \n    \'Λ\' => \'l\', \n    \'Μ\' => \'m\', \n    \'Ν\' => \'n\', \n    \'Ξ\' => \'ks\', \n    \'Ο\' => \'o\',\n    \'Ό\' => \'o\',\n    \'Π\' => \'p\', \n    \'Ρ\' => \'r\', \n    \'Σ\' => \'s\', \n    \'Τ\' => \'t\', \n    \'Υ\' => \'u\',\n    \'Ύ\' => \'u\',\n    \'Φ\' => \'f\', \n    \'Χ\' => \'x\', \n    \'Ψ\' => \'ps\', \n    \'Ω\' => \'o\',\n    \'Ώ\' => \'o\',\n    \'α\' => \'a\', \n    \'β\' => \'v\', \n    \'γ\' => \'g\', \n    \'δ\' => \'d\', \n    \'ε\' => \'e\', \n    \'ζ\' => \'z\', \n    \'η\' => \'i\', \n    \'θ\' => \'th\', \n    \'ι\' => \'i\', \n    \'κ\' => \'k\', \n    \'λ\' => \'l\', \n    \'μ\' => \'m\', \n    \'ν\' => \'n\', \n    \'ξ\' => \'ks\', \n    \'ο\' => \'o\', \n    \'π\' => \'p\', \n    \'ρ\' => \'r\', \n    \'σ\' => \'s\', \n    \'τ\' => \'t\', \n    \'υ\' => \'u\', \n    \'φ\' => \'f\', \n    \'χ\' => \'x\', \n    \'ψ\' => \'ps\', \n    \'ω\' => \'o\', \n    \'ς\' => \'s\', \n    \'ά\' => \'a\', \n    \'έ\' => \'e\', \n    \'ή\' => \'i\', \n    \'ί\' => \'i\', \n    \'ό\' => \'o\', \n    \'ύ\' => \'u\', \n    \'ώ\' => \'o\', \n    \'ϊ\' => \'i\', \n    \'ϋ\' => \'u\', \n    \'ΐ\' => \'i\', \n    \'ΰ\' => \'u\' \n    )); \n}\n\nfunction repair_name($string) { return strtr($string, array(\n    \' \' => \'\',\n    \'\\\\\' => \'\',\n    \'/\' => \'\',\n    \':\' => \'\', \n    \'*\' => \'\', \n    \'?\' => \'\', \n    \'\"\' => \'\',\n    \'<\' => \'\',\n    \'>\' => \'\', \n    \'|\' => \'\'\n    )); \n}\n\n$sql=\"  SELECT \n            id,\n            short_name,\n            ifNULL(surname,\'\'),\n            ifNULL(name,\'\'),\n            ifNULL(email,\'\')\n        FROM teacher  \n        WHERE \n            id=\'#RECORD_ID#\' AND \n            user_id is NULL\";\n    \n$retval = nuRunQuery($sql);\n\nif($retval){\n    if(db_num_rows($retval)>0){\n        if($row = db_fetch_row($retval)){\n            \n            $id=nuID();\n            $user_name = greek_to_greeklish(repair_name($row[1]));\n            $pas=generateStrongPassword(6);    \n            \n            \n            $sql=\"select count(*) from zzzsys_user where sus_login_name=\'\".$user_name.\"\'\"; \n            $rv = nuRunQuery($sql);\n            $r = db_fetch_row($rv);\n            \n            if ($r[0]==0 && $user_name!=\'\'){\n                $sql = \"    insert into zzzsys_user (\n                                zzzsys_user_id,\n                                sus_zzzsys_user_group_id,\n                                sus_name,\n                                sus_email,\n                                sus_login_name,\n                                sus_login_password,\n                                zzzsys_user_log_added_at,\n                                zzzsys_user_log_added_by,\n                                zzzsys_user_log_changed_at,\n                                zzzsys_user_log_changed_by,\n                                zzzsys_user_log_viewed_at,\n                                zzzsys_user_log_viewed_by\n                                )\n                            values(\n                                \'\".$id.\"\',\n                                \'547de4b10fa7616\',\n                                \'\".$row[2].($row[2]!=\'\' && $row[3]!=\'\' ? \' \' : \'\').$row[3].\"\',\n                                \'\".$row[4].\"\',\n                                \'\".$user_name.\"\',\n                                md5(CONCAT(\'\".$user_name.\"\', \'\".$pas.\"\')),\n                                NOW(),\n                                \'globeadmin\',\n                                NOW(),\n                                \'globeadmin\',\n                                NOW(),\n                                \'globeadmin\'\n                        )\";\n                nuRunQuery($sql);\n	        \n	            $sql=\"update teacher set user_id=\'\".$id.\"\' where id=#RECORD_ID#\";\n                nuRunQuery($sql);\n            \n                $nuParameters = \"Ο λογαριασμός δημιουργήθηκε επιτυχώς!\\nΌνομα Χρήστη : \".$user_name.\"\\nΚωδικός : \".$pas;\n                \n            } else {\n                $nuError = \"Υπάρχει ήδη λογαριασμός με όνομα χρήστη \".$user_name.\"!\\nΟ Λογαριασμός δε δημιουργήθηκε!\";       \n            }\n        } else {\n            $nuError = \"Παρουσιάστηκε σφάλμα κατά τη δημιουργία του λογαριασμού!\\nΟ Λογαριασμός δε δημιουργήθηκε!\";    \n        } \n    } else {\n        $nuError = \"Προσοχή : Υπάρχει ήδη λογαριασμός για τον Καθηγητή!\";    \n    }\n} else {\n    $nuError = \"Παρουσιάστηκε σφάλμα κατά τη δημιουργία του λογαριασμού!\\nΟ Λογαριασμός δε δημιουργήθηκε!\";    \n}','','0','2016-04-27 13:00:30','globeadmin','2016-10-22 16:00:59','globeadmin','2021-03-09 14:08:31','globeadmin','0'),('5720bb3291b7333','reset_account_password','Επαναφέρει το password ενός λογαριασμού','manager','// Generates a strong password of N length containing at least one lower case letter,\n// one uppercase letter, one digit, and one special character. The remaining characters\n// in the password are chosen at random from those four sets.\n//\n// The available characters in each set are user friendly - there are no ambiguous\n// characters such as i, l, 1, o, 0, etc. This, coupled with the $add_dashes option,\n// makes it much easier for users to manually type or speak their passwords.\n//\n// Note: the $add_dashes option will increase the length of the password by\n// floor(sqrt(N)) characters.\n\n\nfunction generateStrongPassword($length = 9, $add_dashes = false, $available_sets = \'luds\')\n{\n	$sets = array();\n	if(strpos($available_sets, \'l\') !== false)\n		$sets[] = \'abcdefghjkmnpqrstuvwxyz\';\n	if(strpos($available_sets, \'u\') !== false)\n		$sets[] = \'ABCDEFGHJKMNPQRSTUVWXYZ\';\n	if(strpos($available_sets, \'d\') !== false)\n		$sets[] = \'23456789\';\n	if(strpos($available_sets, \'s\') !== false)\n		$sets[] = \'!@#$%&*?\';\n	$all = \'\';\n	$password = \'\';\n	foreach($sets as $set)\n	{\n		$password .= $set[array_rand(str_split($set))];\n		$all .= $set;\n	}\n	$all = str_split($all);\n	for($i = 0; $i < $length - count($sets); $i++)\n		$password .= $all[array_rand($all)];\n	$password = str_shuffle($password);\n	if(!$add_dashes)\n		return $password;\n	$dash_len = floor(sqrt($length));\n	$dash_str = \'\';\n	while(strlen($password) > $dash_len)\n	{\n		$dash_str .= substr($password, 0, $dash_len) . \'-\';\n		$password = substr($password, $dash_len);\n	}\n	$dash_str .= $password;\n	return $dash_str;\n}\n\n\n$sql=\"  SELECT \n            zzzsys_user_id,\n            sus_login_name\n        FROM zzzsys_user  \n        WHERE \n            zzzsys_user_id = \'#account_id#\'\";\n    \n$retval = nuRunQuery($sql);\n\nif($retval){\n    \n    if(db_num_rows($retval) == 1 ){\n        if($row = db_fetch_row($retval)){\n        \n            $user_name = $row[1];\n            $pas=generateStrongPassword(6);    \n            \n                $sql = \"    update  zzzsys_user \n                            set sus_login_password=md5(CONCAT(\'\".$user_name.\"\', \'\".$pas.\"\'))\n                            where zzzsys_user_id = \'#account_id#\'\";\n                nuRunQuery($sql);\n                \n                $nuParameters = \"Ο κωδικός άλλαξε επιτυχώς!\\nΌνομα Χρήστη : \".$user_name.\"\\nΝέος Κωδικός : \".$pas;\n        } else {\n            $nuError = \"Παρουσιάστηκε πρόβλημα κατά την αλλαγή!\\nΟ Κωδικός δεν άλλαξε!\";    \n        } \n    } else {\n        $nuError = \"Προσοχή : Ο Λογαριασμός δε βρέθηκε!\";    \n    }\n} else {\n    $nuError = \"Παρουσιάστηκε σφάλμα κατά την αλλαγή!\\nΟ Κωδικός δεν άλλαξε!\";    \n}','','0','2016-04-27 16:14:26','globeadmin','2016-04-27 16:43:37','globeadmin','2016-04-27 16:43:37','globeadmin','0'),('5728fe5eefef00e','send_emails_ajax','Για κληση μέσω Ajax - Στέλνει μαζικά emails σύμφωνα με τα πεδία του πίνακα session_variables','sisyphos','use PHPMailer\\PHPMailer\\PHPMailer;\nuse PHPMailer\\PHPMailer\\Exception;\n\n$setup                      = $GLOBALS[\'nuSetup\'];                                      //-- Read SMTP AUTH Settings from zzsys_setup table	\n\nif (!empty($setup->set_smtp_username))          { $setup->set_smtp_username = trim($setup->set_smtp_username);}                       else{$errorText .= \"SMTP Username not set.<br>\";}\nif (!empty($setup->set_smtp_password)) 	        { $setup->set_smtp_password = trim($setup->set_smtp_password);}                       else{$errorText .= \"SMTP Password not set.<br>\";}\nif (!empty($setup->set_smtp_host))              { $setup->set_smtp_host = trim($setup->set_smtp_host);}                               else{$errorText .= \"SMTP Host not set.<br>\";}\nif (!empty($setup->set_smtp_from_address))      { $setup->set_smtp_from_address = trim($setup->set_smtp_from_address);}               else{$errorText .= \"SMTP From Address not set.<br>\";}\nif (!empty($setup->set_smtp_port))              { $setup->set_smtp_port = intval($setup->set_smtp_port);}                             else{$errorText .= \"SMTP PORT not set.<br>\";}\nif (!empty($setup->set_smtp_use_ssl))           { $setup->set_smtp_use_ssl = trim($setup->set_smtp_use_ssl);}                         else{$setup->set_smtp_use_ssl = \'\';}\nif (!empty($setup->set_smtp_from_name))         { $SMTPname = trim($setup->set_smtp_from_name);}	                              else{$SMTPname = \"nuBuilder\";}\n\nif ($errorText != \'\') {\n	$nuError = \"Το e-mail δε μπορεσε να στείλει! Το ακόλουθο μήνυμα λάθους εμφανίστηκε: \".$errorText; \n}\nelse{\n                        // Όλα καλά! Οι ρυθμίσεις είναι ΟΚ, να σταλουν τα emails\n                        \n    $sql=\"  select \n                email_recipients,\n                email_subject,\n                email_text,\n                ifNULL(system_url,\'\')\n            from session_variables \n            where session_id=\'#session_id#\' limit 1\";\n    $retval = nuRunQuery($sql);\n   \n    if($retval && db_num_rows($retval)>0){ \n        if($row = db_fetch_row($retval)){\n\n                        // βρίσκει τις διευθύσεις των παραληπτών\n                        \n            if($row[0]==\'-1\'){  //Προς το σχολείο\n                $sql=\"select email from school where id=1\";\n                $rv = nuRunQuery($sql);\n                if ($rv && $r=db_fetch_row($rv)){\n                    if(!is_null($r[0]) && $r[0]!=\'\'){\n                        $emails[] = $r[0];\n                    }  \n                }\n            } else if ($row[0]==\'0\'){ // Προς Όλους τους Καθηγητές\n                $sql=\"  select teacher.email,zzzsys_user.sus_email\n                        from teacher\n                        left join zzzsys_user \n                        on teacher.user_id=zzzsys_user.zzzsys_user_id\";\n                $rv = nuRunQuery($sql);\n            \n                if ($rv){\n                    while ($r=db_fetch_row($rv)){\n                        if(!is_null($r[0]) && $r[0]!=\'\'){\n                            $emails[] = $r[0];\n                        }  \n                        if(!is_null($r[1]) && $r[1]!=\'\' && $r[1]!=$r[0]){\n                            $emails[] = $r[1];\n                        } \n                    }\n                }\n            } else if (is_numeric($row[0])){ // Προς έναν συγκεκριμένο καθηγητή\n                $sql=\"  select teacher.email,zzzsys_user.sus_email\n                        from teacher\n                        left join zzzsys_user \n                        on teacher.user_id=zzzsys_user.zzzsys_user_id\n                        where teacher.id=\".$row[0];\n                $rv = nuRunQuery($sql);\n            \n                if ($rv && $r=db_fetch_row($rv)){\n                    if(!is_null($r[0]) && $r[0]!=\'\'){\n                        $emails[] = $r[0];\n                    }  \n                    if(!is_null($r[1]) && $r[1]!=\'\' && $r[1]!=$r[0]){\n                        $emails[] = $r[1];\n                    } \n                }\n            \n            } else{ // Προς λίστα emails που χωρίζονται μεταξύ τους με κόμμα\n                $emails = explode(\',\',$row[0]);    \n            }\n        \n            $subject = (is_null($row[1]) ? \'\' : $row[1]);\n            $subject=iconv(\'UTF-8\',\'ISO-8859-7//IGNORE\',$subject);\n        \n            $content = (is_null($row[2]) ? \'\' : $row[2]);\n            $content = $content.\"<br><hr>Το μήνυμα αυτό στάλθηκε αυτόματα μέσω του Σίσυφου.<br>Μην απαντάτε σε αυτό το email!\";\n\n            $content = iconv(\'UTF-8\',\'ISO-8859-7//IGNORE\',$content);\n        \n            require \'PHPMailer/src/Exception.php\';\n            require \'PHPMailer/src/PHPMailer.php\';\n            require \'PHPMailer/src/SMTP.php\';\n        \n            $mail                    = new PHPMailer(true);\n            \n            try {\n            $mail->SMTPDebug         = 0;\n	        \n	        $mail->IsSMTP();\n	        $mail->setLanguage(\'el\');\n            $mail->Host              = $setup->set_smtp_host;\n	        $mail->Port              = $setup->set_smtp_port;\n	        $mail->SMTPAuth          = true;\n	        $mail->SMTPSecure        = $setup->set_smtp_use_ssl ? $setup->set_smtp_use_ssl : \'\';\n	        //$mail->SMTPAuth          = $setup->set_smtp_use_ssl;\n	        $mail->CharSet           = \'iso-8859-7\';\n\n		    $mail->Username  = $setup->set_smtp_username;\n		    $mail->Password  = $setup->set_smtp_password;\n\n	        $mail->From              = $setup->set_smtp_from_address;\n	        $mail->FromName          = iconv(\'UTF-8\',\'ISO-8859-7//IGNORE\',$setup->set_smtp_from_name);\n	        $mail->AddReplyTo($setup->set_smtp_from_address,iconv(\'UTF-8\',\'ISO-8859-7//IGNORE\',$setup->set_smtp_from_name));\n	        $mail->AddReplyTo        = $setup->set_smtp_from_address;\n	        $mail->WordWrap          = 80;\n	        $mail->IsHTML(true);\n	        $mail->Subject           = $subject;\n	        $mail->Body              = $content;  \n	    \n            $address_ok = 0;\n            $address_not_valid = 0;\n            \n            foreach ($emails as $email) {\n                if (filter_var($email, FILTER_VALIDATE_EMAIL)){ //address ok! send email\n	                $mail->AddBCC($email);\n	                $address_ok++;\n                } \n                else{ // mail address not in propper format\n                    $address_not_valid++;\n                }\n            }\n            $mail->Send();\n            \n            if($address_ok==1 && $address_not_valid==0){\n                $nuParameters = \"To email στάλθηκε επιτυχώς!\"; \n	        } else {\n                $nuParameters = \"Στάλθηκαν \".$address_ok.\" emails!\";\n                if($fail>0) {$nuParameters=$nuParameters.\"\\nΑπέτυχαν, λόγω λάθους στη διεύθυνση, \".$address_not_valid.\" emails!\";}  \n            }\n            \n            } catch (phpmailerException $e) {\n                $nuError = \"Το e-mail δε μπορεσε να στείλει! Το ακόλουθο μήνυμα λάθους εμφανίστηκε: \".strip_tags($e->errorMessage());\n            } catch (Exception $e) {\n                $nuError = \"Το e-mail δε μπορεσε να στείλει! Το ακόλουθο μήνυμα λάθους εμφανίστηκε: \".strip_tags($e->getMessage());\n            }\n        }\n    } \n}\n\n','','0','2016-05-03 22:39:10','globeadmin','2019-07-25 12:43:44','globeadmin','2020-09-18 01:17:48','globeadmin','0'),('572b066732990f9','create_student_email_list','Δημιουργεί τη λίστα των μαθητών με τα email τους για μαζική αποστολή email','teacher','print \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n        \n        <STYLE TYPE=\\\"text/css\\\">\n            .sisTable TH{\n                font-size:110%;\n            }\n        </STYLE>\n    </head>\n    <body onload=\\\"adjustIframeHeight()\\\">\";\n\n$sql=\"  SELECT distinct\n            student.id,\n            grade.short_name,\n            concat(\n                student.registration_number,\n                \' -\',\n                if(student.surname is NULL,\'\',concat (\' \',student.surname)),\n                if(student.name is NULL,\'\',concat (\' \',student.name)),\n                if(student.fathers_name is NULL,\'\',concat (\'<br>πατ. \',student.fathers_name))\n            ),\n            TRIM(student.email),\n            TRIM(student.parent_email),\n            student.has_left_school,\n            TRIM(student.parent_email2)\n            \n        FROM student\n        INNER JOIN grade on grade.id=student.grade_id\n        left join (    select distinct student_id as s_id\n                            from student_class\n                            inner join card ON card.class_id=student_class.class_id\n                            where\n                                card.valid_from=(select max(start_date) from timetable) and   \n                                card.teacher_id=\'#RECORD_ID#\') as s ON s.s_id = student.id\n        \";\n        \n\nif(\'#class_id_sumo#\'!=\'#\'.\'class_id_sumo#\' && \'#class_id_sumo#\'!=\'\'){\n    $sql=$sql.\" INNER JOIN student_class on (student_class.student_id=student.id AND student_class.class_id  IN (#class_id_sumo#))\n    \";\n}\n\n$sql=$sql.\"WHERE \n    \";\n\nif(\'#student_id_sumo#\'!=\'#\'.\'student_id_sumo#\' && \'#student_id_sumo#\'!=\'\'){\n    $sql=$sql.\" student.id IN (#student_id_sumo#) and \n    \";\n}\n\n$sql=$sql.\"\n    (\'#nu_user_group#\'=\'globeadmin\' OR \n    \'#nu_user_group#\'=\'Administrators\' OR \n    \'#nu_user_group#\'=\'Managers\' OR \n    \'#nu_user_group#\'=\'AssistManagers\' OR\n    \'#nu_user_group#\'=\'Secretaries\' OR\n    \'#nu_user_group#\'=\'Psychologists\' OR\n    s.s_id is not null OR\n    student.teacher_id = \'#RECORD_ID#\' OR\n    student.advisor_id = \'#RECORD_ID#\')\n    ORDER BY student.grade_id,student.surname,student.name,student.fathers_name\n\";\n$retval = nuRunQuery($sql);\n\nif($retval) {\n    if(db_num_rows($retval)>0) {\n    \n        print (\"\n        <table cellspacing=0 CLASS=\\\"sisTable\\\">\n            <tr height=50>\n                <th width=40 align=center>Τάξη</b></th>\n                <th width=225 align=center>Μαθητής</b></th>\n                <th width=225 align=center>\n                    Email Μαθητή<br>\n                    Όλα<input type=\\\"checkbox\\\" id=\\\"all_chk_1\\\" title=\\\"Επιλογή Όλων\\\" onclick=\\\"toggle(this,\'chk_1\')\\\">\n                </th>\n                <th width=225 align=center>\n                    Πρωτεύον Email Γονέα<br>\n                    Όλα<input type=\\\"checkbox\\\" id=\\\"all_chk_2\\\" title=\\\"Επιλογή Όλων\\\" onclick=\\\"toggle(this,\'chk_2\')\\\">\n                </th>\n                <th width=225 align=center>\n                    Δευτερεύον Email Γονέα<br>\n                    Όλα<input type=\\\"checkbox\\\" id=\\\"all_chk_3\\\" title=\\\"Επιλογή Όλων\\\" onclick=\\\"toggle(this,\'chk_3\')\\\">\n                </th>\n            </tr>\");\n            \n        while($row = db_fetch_row($retval)) {\n                \n            print (\"\n            <tr\".($row[5]==1 ? \" style=\\\"background-color:#EE82EE;\\\"\" : \"\").\" height=35>\n                <td align=center>\".(is_null($row[1]) || $row[1]==\'\'? \'&nbsp;\' : $row[1]).\"</td>\n                <td align=left>\".(is_null($row[2]) || $row[2]==\'\'? \'&nbsp;\' : $row[2]).\"</td>\");\n                \n                if(!is_null($row[3]) && $row[3]!=\'\'){\n                    if(filter_var($row[3], FILTER_VALIDATE_EMAIL)){\n                        print(\"\n                <td align=right>\".$row[3].\"<input type=\\\"checkbox\\\" CLASS=\\\"chk_1\\\" id=\\\"1,\".$row[0].\",\".$row[3].\"\\\" title=\\\"Επιλογή Email\\\" onclick=\\\"make_indeterminate(\'all_chk_1\')\\\"></td>\");\n                    } else {\n                        print(\"\n                <td style=\\\"background-color:red;\\\" align=right>\".$row[3].\"</td>\");\n                    }   \n                } else{\n                    print(\"\n                <td>&nbsp;</td>\");    \n                }\n\n                if(!is_null($row[4]) && $row[4]!=\'\'){\n                    if(filter_var($row[4], FILTER_VALIDATE_EMAIL)){\n                        print(\"\n                <td align=right>\".$row[4].\"<input type=\\\"checkbox\\\" CLASS=\\\"chk_2\\\" id=\\\"2,\".$row[0].\",\".$row[4].\"\\\" title=\\\"Επιλογή Email\\\" onclick=\\\"make_indeterminate(\'all_chk_2\')\\\"></td>\");\n                    } else {\n                        print(\"\n                <td style=\\\"background-color:red;\\\" align=right>\".$row[4].\"</td>\");\n                    }   \n                } else{\n                    print(\"\n                <td>&nbsp;</td>\");    \n                }\n                \n                if(!is_null($row[6]) && $row[6]!=\'\'){\n                    if(filter_var($row[6], FILTER_VALIDATE_EMAIL)){\n                        print(\"\n                <td align=right>\".$row[6].\"<input type=\\\"checkbox\\\" CLASS=\\\"chk_3\\\" id=\\\"3,\".$row[0].\",\".$row[6].\"\\\" title=\\\"Επιλογή Email\\\" onclick=\\\"make_indeterminate(\'all_chk_3\')\\\"></td>\");\n                    } else {\n                        print(\"\n                <td style=\\\"background-color:red;\\\" align=right>\".$row[6].\"</td>\");\n                    }   \n                } else{\n                    print(\"\n                <td>&nbsp;</td>\");    \n                }\n                \n            print (\"\n            </tr>\");\n        }\n        \n        print (\"\n        </table>\");\n    } else{\n        print (\"<span CLASS=\\\"msg\\\">Δε βρέθηκαν Μαθητές...</span>\");\n    }\n} else{\n    print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν δεδομένα...</span>\");\n}\nprint \"\n    </body>\n</html>\";\n','','0','2016-05-05 11:37:59','globeadmin','2021-09-06 21:09:31','globeadmin','2021-09-06 21:39:21','globeadmin','0'),('572b6f3ed13f95a','create_teacher_email_list','Δημιουργεί τη λίστα των καθηγητών με τα email τους για μαζική αποστολή email','teacher','print \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n        \n        <STYLE TYPE=\\\"text/css\\\">\n            .sisTable TH{\n                font-size:1.1em;\n            }\n        </STYLE>\n    </head>\n    <body onload=\\\"adjustIframeHeight()\\\">\";\n\n\n$sql=\"  SELECT \n            teacher.id,\n            concat(\n                if(teacher.surname is NULL,\'\',concat (teacher.surname,\' \')),\n                ifNULL(teacher.name,\'\')\n            ),\n            \'\',\n            TRIM(teacher.email),\n            TRIM(zzzsys_user.sus_email)\n        FROM teacher\n        LEFT JOIN zzzsys_user ON teacher.user_id=zzzsys_user.zzzsys_user_id\n        WHERE\n        \";\n\nif(\'#teacher_id_sumo#\'!=\'#\'.\'teacher_id_sumo#\' && \'#teacher_id_sumo#\'!=\'\'){\n    $sql=$sql.\" (teacher.id IN (#teacher_id_sumo#)) and \n    \";\n}\n\nif(\'#select_teaching_field_id_sumo#\'!=\'#\'.\'select_teaching_field_id_sumo#\' && \'#select_teaching_field_id_sumo#\'!=\'\'){\n    $sql=$sql.\" (teacher.teaching_field_id IN (#select_teaching_field_id_sumo#)) and \n    \";\n}\n$sql=$sql.\"\n    1=1\n    ORDER BY teacher.surname,teacher.name\n\";\n   \n$retval = nuRunQuery($sql);\n\nif($retval) {\n    if(db_num_rows($retval)>0) {\n    \n        print (\"\n        <table cellspacing=0 CLASS=\\\"sisTable\\\" align=center>\n            <tr height=50>\n                <th width=350 align=center>Καθηγητής</th>\n                \n                <th width=300 align=center>Email Καθηγητή<br>\n                    Όλα<input type=\\\"checkbox\\\" id=\\\"all_chk_1\\\" title=\\\"Επιλογή Όλων\\\" onclick=\\\"toggle(this,\'chk_1\')\\\">\n                </th>\n                \n                <th width=300 align=center>Email Λογαριασμού<br>\n                    Όλα<input type=\\\"checkbox\\\" id=\\\"all_chk_2\\\" title=\\\"Επιλογή Όλων\\\" onclick=\\\"toggle(this,\'chk_2\')\\\">\n                </th>\n            </tr>\");\n        \n        while($row = db_fetch_row($retval)) {\n                \n            print (\"            \n            <tr height=30>\n                <td align=left>\".(is_null($row[1]) || $row[1]==\'\'? \'&nbsp;\' : $row[1]).\"</td>\");\n                \n                if(!is_null($row[3]) && $row[3]!=\'\'){\n                    if(filter_var($row[3], FILTER_VALIDATE_EMAIL)){\n                        print(\"\n                <td align=right>\".$row[3].\"<input type=\\\"checkbox\\\" CLASS=\\\"chk_1\\\" id=\\\"1,\".$row[0].\",\".$row[3].\"\\\" title=\\\"Επιλογή Email\\\" onclick=\\\"make_indeterminate(\'all_chk_1\')\\\"></td>\");\n                    } else {\n                        print(\"\n                <td style=\\\"background-color:red;\\\" align=right>\".$row[3].\"</td>\");\n                    }   \n                } else{\n                    print(\"\n                <td>&nbsp;</td>\");    \n                }\n\n                if(!is_null($row[4]) && $row[4]!=\'\'){\n                    if(filter_var($row[4], FILTER_VALIDATE_EMAIL)){\n                        print(\"\n                <td align=right>\".$row[4].\"<input type=\\\"checkbox\\\" CLASS=\\\"chk_2\\\" id=\\\"2,\".$row[0].\",\".$row[4].\"\\\" title=\\\"Επιλογή Email\\\" onclick=\\\"make_indeterminate(\'all_chk_2\')\\\"></td>\");\n                    } else {\n                        print(\"\n                <td style=\\\"background-color:red;\\\" align=right>\".$row[4].\"</td>\");\n                    }   \n                } else{\n                    print(\"\n                <td>&nbsp;</td>\");    \n                }\n            print (\"\n            </tr>\");\n        }\n        print (\"\n        </table>\");\n    } else{\n        print (\"<span CLASS=\\\"msg\\\">Δε βρέθηκαν Καθηγητές...</span>\");\n    }\n} else{\n    print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν δεδομένα...</span>\");\n}\nprint \"\n    </body>\n</html>\";\n','','0','2016-05-05 19:05:18','globeadmin','2018-07-15 00:44:57','globeadmin','2018-07-15 00:44:57','globeadmin','0'),('572d973a2c31092','create_student_absence_email_list','Δημιουργεί τη λίστα των μαθητών με απουσίες τα email τους για μαζική αποστολή email','teacher','if (\'#to_date#\'==\'#\'.\'to_date\'.\'#\' || \'#to_date#\'==\'\' || \'#to_date#\'>date(\'Y-m-d\')){\n        $to_date = date(\'Y-m-d\');\n} else {\n    $to_date = date_format(date_create_from_format(\'Y-m-d\',\'#to_date#\'),\'Y-m-d\');\n}\n\nif(\'#absence_limit#\'!=\'#\'.\'absence_limit#\' && \'#absence_limit#\'!=\'\'){\n    $limit=\'#absence_limit#\';\n} else {\n    $limit=\'0\';\n}\n\nprint \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n\n    <STYLE TYPE=\\\"text/css\\\">\n        .sisTable TH{\n            font-size:9pt;\n        }\n    </STYLE>\n</head>\n<body onload=\\\"adjustIframeHeight(600)\\\">\";\n\n$sql=\"DROP TEMPORARY TABLE IF EXISTS #TABLE_ID#\";\nnuRunQuery($sql);\n\n$sql=\"  CREATE TEMPORARY TABLE #TABLE_ID# DEFAULT CHARACTER SET=utf8\n        SELECT \n            student.id as student_id,\n            grade.short_name as grade_short_name,\n            concat(\n                student.registration_number,\n                \' -\',\n                if(student.surname is NULL,\'\',concat (\' \',student.surname)),\n                if(student.name is NULL,\'\',concat (\' \',student.name)),\n                if(student.fathers_name is NULL,\'\',concat (\'<br>πατ. \',student.fathers_name))\n            ) as student_full_name,\n            TRIM(student.email),\n            TRIM(student.parent_email),\n            student.has_left_school,\n            student.prev_an_justified_absences,\n            student.prev_justified_absences,\n            TRIM(student.parent_email2)\n        FROM student\n        INNER JOIN grade on grade.id=student.grade_id \n        \";\n\nif(\'#class_id#\'!=\'#\'.\'class_id#\' && \'#class_id#\'!=\'\' ){\n$sql=$sql.\"\n                INNER JOIN  (select distinct student_id from student_class where class_id in (#class_id#)) as sc ON  student.id = sc.student_id \n\";\n} \n\n$sql=$sql.\"WHERE \n    \";\n    \nif(\'#class_id#\'==\'#\'.\'class_id#\' || \'#class_id#\'==\'\'){\n$sql=$sql.\" student.teacher_id = \'#RECORD_ID#\' and \n\";\n}\n\nif(\'#export_student_id#\'!=\'#\'.\'export_student_id#\' && \'#export_student_id#\'!=\'\' ){\n    $sql=$sql.\" student.id = \'#export_student_id#\' and \n\";\n}\n\nif(\'#has_left_school#\'!=\'#\'.\'has_left_school#\' && \'#has_left_school#\'!=\'\' && \'#has_left_school#\'==\'1\'){\n    $sql=$sql.\" student.has_left_school = 0 and \n    \";\n}\n\n$sql=$sql.\"\n    1=1\n    ORDER BY student.grade_id,student.surname,student.name,student.fathers_name\n\";\nnuRunQuery($sql);\n\n$sql=\"ALTER TABLE #TABLE_ID#\nADD COLUMN adikaiologites INT NOT NULL DEFAULT 0,\nADD COLUMN dikaiologimenes INT NOT NULL DEFAULT 0,\nADD COLUMN synolo INT NOT NULL DEFAULT 0\";\nnuRunQuery($sql);\n\n$sql=\"SELECT student_id,prev_an_justified_absences,prev_justified_absences from #TABLE_ID#\";\n$rv = nuRunQuery($sql);\nif($rv){\n  while($r = db_fetch_row($rv)){\n\n    $sql=\"select ifNULL(sum(if(justified=1,0,1)),0),ifNULL(sum(justified),0),count(*) from absence where student_id=\".$r[0].\" and counts=1 and absence_date<=\'\".$to_date.\"\'\";\n    $rv2 = nuRunQuery($sql);\n    $r2 = db_fetch_row($rv2);\n    \n    $sql=\"update #TABLE_ID# SET \n        adikaiologites=\".($r2[0]+$r[1]).\",\n        dikaiologimenes=\".($r2[1]+$r[2]).\",\n        synolo=\".($r2[2]+$r[1]+$r[2]).\"\n        where student_id=\".$r[0].\"\n    \";\n    nuRunQuery($sql);\n  }\n}\n\n$sql=\"DELETE FROM #TABLE_ID# WHERE synolo<\".$limit;\nnuRunQuery($sql);\n        \n$sql=\"SELECT * from #TABLE_ID#\";       \n$retval = nuRunQuery($sql);\n\nif($retval) {\n    if(db_num_rows($retval)>0) {\n\n        print (\"<table cellspacing=0 CLASS=\\\"sisTable\\\">\n            <tr height=50>\n                <th width=50 align=center>Τάξη</th>\n                <th width=300 align=center>Μαθητής</th>\n                \n                <th width=165 align=center>\n                    Email Μαθητή<br>\n                    Όλα<input type=\\\"checkbox\\\" id=\\\"all_chk_1\\\" title=\\\"Επιλογή Όλων\\\" onclick=\\\"toggle(this,\'chk_1\')\\\">\n                </th>\n                <th width=165 align=center>\n                    Email Γονέα<br>\n                    Όλα<input type=\\\"checkbox\\\" id=\\\"all_chk_2\\\" title=\\\"Επιλογή Όλων\\\" onclick=\\\"toggle(this,\'chk_2\')\\\">\n                </th>\n                <th width=165 align=center>\n                    Email Γονέα 2<br>\n                    Όλα<input type=\\\"checkbox\\\" id=\\\"all_chk_3\\\" title=\\\"Επιλογή Όλων\\\" onclick=\\\"toggle(this,\'chk_3\')\\\">\n                </th>\n                <th width=30 align=center><b>Α</b></th>\n                <th width=30 align=center><b>Δ</b></th>\n                <th width=30 align=center><b>Σ</b></th>\n            </tr>\");\n            \n        while($row = db_fetch_row($retval)) {\n                \n            print (\"\n            <tr\".($row[5]==1 ? \" style=\\\"background-color:#EE82EE;\\\"\" : \"\").\" height=30>\n                <td align=center>\".(is_null($row[1]) || $row[1]==\'\'? \'&nbsp;\' : $row[1]).\"</td>\n                <td id=\\\"stdname_\".$row[0].\"\\\" align=left>\".(is_null($row[2]) || $row[2]==\'\'? \'&nbsp;\' : $row[2]).\"</td>\");\n                \n                if(!is_null($row[3]) && $row[3]!=\'\'){\n                    if(filter_var($row[3], FILTER_VALIDATE_EMAIL)){\n                        print(\"\n                <td align=right>\".$row[3].\"<input type=\\\"checkbox\\\" CLASS=\\\"chk_1\\\" id=\\\"1,\".$row[0].\",\".$row[3].\"\\\" title=\\\"Επιλογή Email\\\" onclick=\\\"make_indeterminate(\'all_chk_1\')\\\"></td>\");\n                    } else {\n                        print(\"\n                <td style=\\\"background-color:red;\\\" align=right>\".$row[3].\"</td>\");\n                    }   \n                } else{\n                    print(\"\n                <td>&nbsp;</td>\");    \n                }\n\n                if(!is_null($row[4]) && $row[4]!=\'\'){\n                    if(filter_var($row[4], FILTER_VALIDATE_EMAIL)){\n                        print(\"\n                <td align=right>\".$row[4].\"<input type=\\\"checkbox\\\" CLASS=\\\"chk_2\\\" id=\\\"2,\".$row[0].\",\".$row[4].\"\\\" title=\\\"Επιλογή Email\\\" onclick=\\\"make_indeterminate(\'all_chk_2\')\\\"></td>\");\n                    } else {\n                        print(\"\n                <td style=\\\"background-color:red;\\\" align=right>\".$row[4].\"</td>\");\n                    }   \n                } else{\n                    print(\"\n                <td>&nbsp;</td>\");    \n                } \n                \n                \n                if(!is_null($row[8]) && $row[8]!=\'\'){\n                    if(filter_var($row[8], FILTER_VALIDATE_EMAIL)){\n                        print(\"\n                <td align=right>\".$row[8].\"<input type=\\\"checkbox\\\" CLASS=\\\"chk_3\\\" id=\\\"3,\".$row[0].\",\".$row[8].\"\\\" title=\\\"Επιλογή Email\\\" onclick=\\\"make_indeterminate(\'all_chk_3\')\\\"></td>\");\n                    } else {\n                        print(\"\n                <td style=\\\"background-color:red;\\\" align=right>\".$row[8].\"</td>\");\n                    }   \n                } else{\n                    print(\"\n                <td>&nbsp;</td>\");    \n                } \n                \n                \n                print (\"\n                <td id=\\\"a_\".$row[0].\"\\\" align=right><b>\".(is_null($row[9]) || $row[9]==\'\'? \'&nbsp;\' : $row[9]).\"</b></td>\n                <td id=\\\"d_\".$row[0].\"\\\" align=right><b>\".(is_null($row[10]) || $row[10]==\'\'? \'&nbsp;\' : $row[10]).\"</b></td>\n                <td id=\\\"s_\".$row[0].\"\\\" align=right><b>\".(is_null($row[11]) || $row[11]==\'\'? \'&nbsp;\' : $row[11]).\"</b></td>\n                \");\n            print (\"\n            </tr>\");\n        }\n        print (\"\n        </table>\");\n    } else{\n        print (\"<span CLASS=\\\"msg\\\">Δε βρέθηκαν Μαθητές...</span>\");\n    }\n} else{\n    print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν δεδομένα...</span>\");\n}\nprint \"\n    </body>\n</html>\";\n','','0','2016-05-07 10:20:26','globeadmin','2021-09-07 20:53:24','globeadmin','2021-09-07 20:53:24','globeadmin','0'),('572dbad6497d1fa','send_mass_emails','Στέλνει emails σε πολλούς αποδέκτες','teacher','use PHPMailer\\PHPMailer\\PHPMailer;\nuse PHPMailer\\PHPMailer\\Exception;\n\nrequire \'PHPMailer/src/Exception.php\';\nrequire \'PHPMailer/src/PHPMailer.php\';\nrequire \'PHPMailer/src/SMTP.php\';\n\nnuRunPHP(\"sisyphos_lib\");\n//nuRunPHP(\"encoding\");\n\nfunction esc($str){\n    $db_params = nuRunQuery();\n    $link = mysqli_connect($db_params[0], $db_params[2], $db_params[3], $db_params[1]);\n\n    if (mysqli_connect_errno()) {\n        nuDebug(\"Connect failed: %s\\n\", mysqli_connect_error());\n        return \'\';\n    }\n    return(mysqli_real_escape_string($link,$str));\n}\n\n$setup                      = $GLOBALS[\'nuSetup\'];                                      //-- Read SMTP AUTH Settings from zzsys_setup table	\n\nif (!empty($setup->set_smtp_username))          { $setup->set_smtp_username = trim($setup->set_smtp_username);}                       else{$errorText .= \"SMTP Username not set.<br>\";}\nif (!empty($setup->set_smtp_password)) 	        { $setup->set_smtp_password = trim($setup->set_smtp_password);}                       else{$errorText .= \"SMTP Password not set.<br>\";}\nif (!empty($setup->set_smtp_host))              { $setup->set_smtp_host = trim($setup->set_smtp_host);}                               else{$errorText .= \"SMTP Host not set.<br>\";}\nif (!empty($setup->set_smtp_from_address))      { $setup->set_smtp_from_address = trim($setup->set_smtp_from_address);}               else{$errorText .= \"SMTP From Address not set.<br>\";}\nif (!empty($setup->set_smtp_port))              { $setup->set_smtp_port = intval($setup->set_smtp_port);}                             else{$errorText .= \"SMTP PORT not set.<br>\";}\nif (!empty($setup->set_smtp_use_ssl))           { $setup->set_smtp_use_ssl = trim($setup->set_smtp_use_ssl);}                         else{$setup->set_smtp_use_ssl = \'\';}\nif (!empty($setup->set_smtp_from_name))         { $SMTPname = trim($setup->set_smtp_from_name);}	                                  else{$SMTPname = \"Sisyphos\";}\n\nif ($errorText == \'\'){\n                        // Όλα καλά! Οι ρυθμίσεις είναι ΟΚ, να σταλουν τα emails\n    \n    $json_str = stripslashes(\'#emails_JSON#\');\n    $json = json_decode($json_str,true);\n\n    if (json_last_error() === JSON_ERROR_NONE) {\n    \n        $attachment_error = false;\n        \n        $uploadfile = \'\';\n        if(\'#FILES#\'!=\'#\'.\'FILES\'.\'#\' && \'#FILES#\'!=\'\'){\n            \n            $S = stripslashes(\'#FILES#\');\n\n            $J = json_decode($S);\n            if (json_last_error() === JSON_ERROR_NONE) {\n                $file_name = $J[0]->{\'name\'};\n                $file_type = $J[0]->{\'type\'};\n                $file_error = $J[0]->{\'error\'};\n                $file_size  = $J[0]->{\'size\'};\n\n                if($file_error != 0){\n                    $attachment_error = true;    \n                } else {\n                    $uploaddir= sys_get_temp_dir();\n                    $uploadfile = $uploaddir .\'/\'.$file_name;    \n                }\n            } else{\n                $attachment_error = true;\n            }\n        }\n        \n        if(!$attachment_error){\n        \n            $mail                    = new PHPMailer(true);\n        \n            $mail->SMTPDebug         = 0;\n	        $mail->IsSMTP();\n	        $mail->setLanguage(\'el\');\n            $mail->Host              = $setup->set_smtp_host;\n            $mail->Port              = $setup->set_smtp_port;\n            $mail->SMTPAuth          = true;\n            $mail->SMTPSecure        = $setup->set_smtp_use_ssl ? $setup->set_smtp_use_ssl : \'\';\n            //$mail->SMTPAuth          = $setup->set_smtp_use_ssl;\n            //$mail->CharSet           = \'iso-8859-7\';\n            $mail->CharSet           = \'UTF-8\';\n            $mail->Encoding          = \'base64\';\n\n            $mail->Username  = $setup->set_smtp_username;\n            $mail->Password  = $setup->set_smtp_password;\n\n            $mail->From              = $setup->set_smtp_from_address;\n            $mail->FromName          = $setup->set_smtp_from_name;//iconv(\'UTF-8\',\'ISO-8859-7//IGNORE\',$setup->set_smtp_from_name);\n            $mail->AddReplyTo($setup->set_smtp_from_address,$setup->set_smtp_from_name);//iconv(\'UTF-8\',\'ISO-8859-7//IGNORE\',$setup->set_smtp_from_name));\n            $mail->AddReplyTo        = $setup->set_smtp_from_address;\n            $mail->WordWrap          = 80;\n            $mail->IsHTML(true);\n            \n            $system_url = get_system_url();\n            $school_name = get_school_name();\n                    \n            $footer = \"<br>                    \n<hr style=\\\"width: 100%; height: 0px; background-color:#b04b00; color:#b04b00;border: 1px solid;\\\">	\n<span style=\\\"color: #525c66;line-height: 150%;font-size: 14px;font-family: Sans-serif;\\\">\nΤο μήνυμα αυτό το έστειλε ο καθηγητής #surname# #name# μέσω του Σίσυφου. Αν θέλετε να απαντήσετε, παρακαλώ \".( $system_url==\'\' ? \"συνδεθείτε\": \"<a href=\\\"$system_url\\\">συνδεθείτε</a>\").\" και στείλτε και εσείς την απάντηση σας μέσω του Σίσυφου. Για λόγους ασφάλειας δεν κοινοποιείται η ηλεκτρονική διεύθυνση του αποστολέα.<br>\n<b>Παρακαλώ, μην απαντάτε σ’αυτό το email.</b>\n</span>\n<p></p>\n<hr style=\\\"width: 50%; margin-left:0; height: 0px; border-style: dotted; border-width: 1px 0px 0px; border-color: #525c66;\\\">\n<span style=\\\"color: #525c66;line-height: 150%;font-size: 10px;font-family: Sans-serif;\\\">\n<b>Διευκρίνιση ηλεκτρονικού ταχυδρομείου : </b>\n<br>\nΑυτό το ηλεκτρονικό μήνυμα (e-mail) μαζί με τα τυχόν επισυναπτόμενά του, είναι εμπιστευτικό και προορίζεται μόνο για χρήση από τα άτομα στα οποία απευθύνεται. Εάν δεν είστε ο προοριζόμενος παραλήπτης ή αρμόδιος για την παράδοση του μηνύματος στον προοριζόμενο παραλήπτη, παρακαλώ επιστρέψτε το στον αποστολέα και σας γνωρίζουμε ότι η αποθήκευση, ανάγνωση, μετάδοση, αναγραφή, αποκάλυψη, ανακοίνωση ή οποιασδήποτε άλλης μορφής χρήση οποιωνδήποτε πληροφοριών περιέχονται στο παρόν μήνυμα, δεν είναι σύννομη. \n<br>\nΠαρόλο που το $school_name έχει λάβει όλες τις απαιτούμενες προφυλάξεις για να διασφαλίσει ότι τα αποστελλόμενα μηνύματα ηλεκτρονικού ταχυδρομείου και τα όποια επισυναπτόμενα αρχεία τους έχουν ελεγχθεί για ιούς ή άλλο κακόβουλο λογισμικό, ωστόσο είναι ευθύνη του παραλήπτη να ελέγξει τη μη ύπαρξη ιών και κακόβουλου λογισμικού, πριν ανοίξετε οποιοδήποτε επισυναπτόμενο αρχείο. \n<br>\nΤο $school_name δεν αποδέχεται ουδεμία ευθύνη για το περιεχόμενο του παρόντος μηνύματος και σε καμία περίπτωση, δεν ευθύνεται για οιαδήποτε τυχόν ζημία λόγω αποθήκευσης ή ανάγνωσης του παρόντος, καθυστερημένης διαβίβασης, υποκλοπής, αλλοίωσης ή μόλυνσης με ιούς. Οι απόψεις που διατυπώνονται στο παρόν μήνυμα ανήκουν αποκλειστικά στον αποστολέα αυτού.\n</span>\n\";\n            //$footer = iconv(\'UTF-8\',\'ISO-8859-7//IGNORE\',$footer);        \n            \n            if($uploadfile!=\'\'){\n                $mail->AddAttachment($uploadfile,$file_name);\n            }\n        \n            $sent=0;\n            $fail=0;\n            $wrong_address = 0;\n        \n            foreach ($json as $recipient){\n            \n                $fail_code=0;\n                $fail_comments=\'\';\n            \n                $email_address = $recipient[2];\n            \n                if(!filter_var($email_address, FILTER_VALIDATE_EMAIL)){\n                    $wrong_address++;\n                    $fail_code=1;\n                    $fail_comments=\'Μη έγκυρη email διεύθυνση\';\n                } else {\n            \n                    $subject = $recipient[3];\n                    //$subject =iconv(\'UTF-8\',\'ISO-8859-7//IGNORE\',$subject);\n                    \n                    $content = $recipient[4];\n                    //$content = Encoding::toUTF8($content);\n                    //$content = iconv(\'UTF-8\',\'ISO-8859-7//IGNORE\',$content);\n                    \n                    if($content && trim($content) != \'\'){\n                        $content = $content.$footer;\n	                    $mail->Subject  = $subject;\n	                    $mail->Body     = $content;\n	                    $mail->ClearAllRecipients();\n                        $mail->AddAddress($email_address);\n            \n                        try {\n                            $mail->Send();\n                            $sent++;\n                        } catch (Exception $e) {\n                            $fail++;\n                            $fail_code = 2;\n                            $fail_comments = $e->errorMessage();\n                        } catch (\\Exception $e) {\n                            $fail++;\n                            $fail_code = 3;\n                            $fail_comments = $e->getMessage();;\n                        }\n                    } else {\n                            $fail++;\n                            $fail_code = 2;\n                            $fail_comments = \'Αποτυχία στη μετατροπή της κωδικοποίησης του περιεχομένου του μηνύματος.\'; \n                    }\n                }\n            \n                $sql=\"  INSERT INTO email (\n                        id,\n                        sender_id,\n                        sent_at,\n                        email_address,\n                        email_subject,\n                        email_text,\n                        fail_code,\n                        fail_comments,\n                        teacher_id,\n                        student_id\n                        )\n                    VALUES (\n                        NULL,\n                        \'#RECORD_ID#\',\n                        NOW(),\n                        \'\".$recipient[2].\"\',\n                        \'\".esc($recipient[3]).\"\',\n                        \'\".esc($recipient[4].($uploadfile!=\'\' ? \'<br>- \'.$file_name : \'\')).\"\',\n                        \'\".$fail_code.\"\',\n                        \'\".(is_null($fail_comments) || $fail_comments==\'\' ? \'\' : $fail_comments).\"\',\n                        \".(is_null($recipient[0]) || $recipient[0]==-1 ? \'NULL\' : $recipient[0]).\",\n                        \".(is_null($recipient[1]) || $recipient[1]==-1 ? \'NULL\' : $recipient[1]).\"\n                    )\";\n                nuRunQuery($sql);\n            }\n          \n            $nuParameters = \"Στάλθηκαν \".$sent.\" Emails!\";\n            if($fail>0) {$nuParameters=$nuParameters.\"\\nΑπέτυχαν \".$fail.\" Emails!\";}\n            if($wrong_address>0) {$nuParameters=$nuParameters.\"\\nΛάθος σε \".$wrong_address.\" διευθύνσεις!\";}\n        } else {\n            $nuError = \"Παρουσιάστηκε σφάλμα με το επισυναπτόμενο αρχείο!\\nΤα μηνύματα δεν στάλθηκαν!\";    \n        }\n    } else {\n        nuDebug(\'sent mass Emails : JSON ERROR -> #emails_JSON# -> \'.$json_str);\n        $nuError = \"Παρουσιάστηκε σφάλμα κατά την αποστολή των μηνυμάτων!\\nΤα μηνύματα δεν στάλθηκαν!\";\n    }\n} else{\n	$nuError = \"Το e-mail δε μπορεσε να στείλει! Το ακόλουθο μήνυμα λάθους εμφανίστηκε: \".$errorText; \n}\n\n','','0','2016-05-07 12:52:22','globeadmin','2020-11-30 00:19:13','globeadmin','2020-11-30 00:19:13','globeadmin','0'),('57349344d81f78b','student_day_absences','Βρίσκει τις απουσίες ενός μαθητή μιας ημέρας','teacher','print \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n        \n        <script type=\\\"text/javascript\\\">\n            function show_absence_info(absence_id){\n                parent.nuOpenFormInFrame(\'5509671b4e81a07\',absence_id)    \n            }\n        </script>\n\n        <STYLE TYPE=\\\"text/css\\\">\n            .sisTable TH{\n                font-size:1.1em;\n            }\n        </STYLE>\n    </head>\n\n    <body>\";\n$cur_date = date(\"Y-m-d\");\n$absence_date = \'#absence_date#\';\n\nif($absence_date<=$cur_date){\n    $sql=\"SELECT \n            absence.id,\n            DATE_FORMAT(absence.absence_date,\'%d-%m-%Y\'),\n            period.short_name,\n            concat(student.surname,\' \',student.name,\' πατ. \',student.fathers_name),\n            absence_reason.name,\n            class.short_name,\n            concat(subject.name,if(subject_type.short_name is NULL,\'\',concat(\'-\',subject_type.short_name))),\n            teacher.short_name,\n            if(absence.justified,\'Ναι\',\'Όχι\'),\n            justified_reason.short_name,\n            if(absence.counts,\'Ναι\',\'Όχι\'),\n            absence.absence_reason_id\n        FROM absence\n            INNER JOIN teacher          ON  absence.post_teacher_id         = teacher.id\n            INNER JOIN student          ON  absence.student_id              = student.id\n            INNER JOIN card             ON  absence.card_id                 = card.id\n            INNER JOIN absence_reason   ON  absence.absence_reason_id       = absence_reason.id\n            LEFT JOIN  justified_reason ON  absence.justified_reason_id     = justified_reason.id\n            INNER JOIN subject          ON  card.subject_id                 = subject.id\n            INNER JOIN class            ON  card.class_id                   = class.id\n            INNER JOIN period           ON  card.period_id                  = period.id\n            LEFT JOIN subject_type     ON  subject.subject_type_id         = subject_type.id\n        WHERE\n        absence.absence_date = \'#absence_date#\' and\n        student.id = \'#student#\'\n        order by period.id\";\n        \n    $retval=nuRunQuery($sql);\n\n    if($retval) {\n        if(db_num_rows($retval)>0) {\n    \n            print (\"\n        <form>\n            <table border=1  cellspacing=0 CLASS=\\\"mytable\\\">\n                <tr height=45>\n                    <th width=40 align=center>Ώρα</th>\n                    <th width=100 align=center>Λόγος Απουσίας</th>\n                    <th width=50 align=center>Τμήμα</th>\n                    <th width=150 align=center>Μάθημα</th>\n                    <th width=150 align=center>Καθηγητής</th>\n                    <th width=50 align=center>Δικαιολογημένη</th>\n                    <th width=120 align=center>Λόγος Δικαιολόγησης</th>\n                    <th width=50 align=center>Μετράει</th>\n                    <th width=50 align=center>Αναλυτικές Πληροφορίες</th>\n                </tr>\");\n//<td width=50 align=center><b>Δικαιολόγηση</b><input id=\\\"all_chk\\\" type=\\\"checkbox\\\" name=\\\"justify_all\\\" title=\\\"Επιλογή/Αποεπιλογή Όλων\\\" onclick=\\\"toggle(this,\'justify_chk\')\\\"></td>\");        \n            $color_justified=\'LightGreen\';\n            $color_not_justified=\'LightBlue\';\n            $color_penalty = \'OrangeRed\';\n        \n            $color=$color_not_justified;\n    \n            while($row = db_fetch_row($retval)) {\n    \n                if($row[8]==\'Ναι\'){\n                    $color=$color_justified;\n                } else {\n                    if($row[11]==1){\n                        $color=$color_not_justified;\n                    } else {\n                        $color=$color_penalty;\n                    }\n                }\n    \n                print (\"\n                <tr style=\\\"background-color:$color;\\\" height=35>\n                    <td align=center>\".(is_null($row[2]) || $row[2]==\'\'? \'&nbsp;\' : $row[2]).\"</td>\n                    <td align=center>\".(is_null($row[4]) || $row[4]==\'\'? \'&nbsp;\' : $row[4]).\"</td>\n                    <td align=center>\".(is_null($row[5]) || $row[5]==\'\'? \'&nbsp;\' : $row[5]).\"</td>\n                    <td align=left>\".(is_null($row[6]) || $row[6]==\'\'? \'&nbsp;\' : $row[6]).\"</td>\n                    <td align=left>\".(is_null($row[7]) || $row[7]==\'\'? \'&nbsp;\' : $row[7]).\"</td>\n                    <td align=center>\".(is_null($row[8]) || $row[8]==\'\'? \'&nbsp;\' : $row[8]).\"</td>\n                    <td align=left>\".(is_null($row[9]) || $row[9]==\'\'? \'&nbsp;\' : $row[9]).\"</td>\n                    <td align=center>\".(is_null($row[10]) || $row[10]==\'\'? \'&nbsp;\' : $row[10]).\"</td>\n                    <td align=center title=\\\"Πληροφορίες/Επεξεργασία\\\" onclick=\\\"show_absence_info(\".$row[0].\")\\\" onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\"><img src=\\\"images/info.png\\\"></td>\");\n\n            /*if($row[8]==\'Ναι\' || ($row[11]!=1 && \'#nu_user_group#\'!=\'Managers\')){\n                print (\"<td align=center>&nbsp;</td>\");   \n            } else {\n                    print (\"<td align=center><input type=\\\"checkbox\\\" id=\\\"\".$row[0].\"\\\" title=\\\"Δικαιολόγηση\\\" Class=\\\"justify_chk\\\" onclick=\\\"make_indeterminate(\'all_chk\')\\\"></td>\");\n            }*/\n                print (\"\n                </tr>\");\n            }\n            print (\"\n            </table>\n        </form>\");\n        } else{\n            print (\"<span CLASS=\\\"msg\\\">Δε βρέθηκαν απουσίες...</span>\");\n        }\n    } else{\n        print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν δεδομένα...</span>\");\n    }\n} else {\n    print (\"<span CLASS=\\\"msgError\\\">Δεν μπορούν να υπάρξουν απουσίες σε μελλοντικές ημερομηνίες...</span>\");    \n}\nprint \"\n    </body>\n</html>\";\n','','0','2016-05-12 17:29:24','globeadmin','2018-07-15 23:11:07','globeadmin','2018-07-15 23:11:07','globeadmin','0'),('573497529d89c8b','unjustify_absences','Ξε-Δικαιολογεί τις απουσιες ενός μαθητή μιας ημέρας','teacher','$cur_date = date(\"Y-m-d\");\n$absence_date = \'#absence_date#\';\n\n$student_id = (\'#student#\'!=\'\' && \'#student#\'!=\'#\'.\'student#\' ? \'#student#\' : \'#RECORD_ID#\' );\n\nif(\'#absence_date#\'!=\'\' && \'#absence_date#\'!=\'#\'.\'absence_date#\'){\n    if($student_id !=\'\' && $student_id!=\'-1\'){\n        if($absence_date<=$cur_date){\n            \n            $sql=\"  UPDATE absence \n                    SET\n                        justified=0,\n                        justified_when=NULL,\n                        justified_comments=NULL,\n                        counts=1,\n                        justified_teacher_id=NULL,\n                        justified_reason_id=NULL\n                    WHERE \n                        absence_date=\'#absence_date#\' AND\n                        student_id=\".$student_id.\"\n            \";\n            nuRunQuery($sql);\n            \n            $sql=\"  UPDATE justification_request\n                    SET \n                        proceeded=0,\n                        proceeded_teacher_id=NULL,\n                        proceeded_comments=NULL,\n                        proceeded_when=NULL\n                    WHERE\n                        absence_id IN\n                            (SELECT id\n                                FROM absence\n                            WHERE \n                                absence_date=\'#absence_date#\' AND\n                                student_id=\".$student_id.\")\n            \";\n            nuRunQuery($sql);    \n            \n        } else {\n            $nuError = \"Δεν υπάρχουν απουσίες σε μελλοντικές ημερομηνίες...\";\n        }\n    } else {\n        $nuError = \"Παρακαλώ επιλέξτε πρώτα μαθητή!\";    \n    }\n} else {\n    $nuError = \"Παρακαλώ επιλέξτε πρώτα ημερομηνία!\";   \n}\n','','0','2016-05-12 17:46:42','globeadmin','2017-03-13 19:24:59','globeadmin','2018-05-26 21:54:41','globeadmin','0'),('57401ba6d83b3e9','search_critirion_special','Αναζήτηση ειδικών κριτιρίων ενός συγκεκριμένου γενικού κριτιρίου αξιολόγησης','manager','function can_add_row(){\n    if(\'#RECORD_ID#\'==\'-1\') {return false;}\n    \n    if(\'#nu_user_group#\'!=\'Managers\' && \'#nu_user_group#\'!=\'AssistManagers\' && \'#nu_user_group#\'!=\'Administrators\' && \'#nu_user_group#\'!=\'globeadmin\'){\n        $sql = \"    SELECT COUNT(*)\n                    FROM mark_critirion_special_level\n                    INNER JOIN critirion_special ON mark_critirion_special_level.critirion_special_id=critirion_special.id\n                    INNER JOIN critirion_general ON critirion_special.critirion_general_id = critirion_general.id\n                    WHERE critirion_general.id = \'#RECORD_ID#\'\n            \";\n        \n        $retval = nuRunQuery($sql);\n        $row    = db_fetch_row($retval);\n        \n        if($row[0]!=0){return false;}	\n\n        $sql = \"    SELECT COUNT(*)\n                    FROM subject_critirion_general\n                    WHERE critirion_general_id = \'#RECORD_ID#\'\n            \";\n        \n        $retval = nuRunQuery($sql);\n        $row    = db_fetch_row($retval);\n        \n        if($row[0]!=0){ return false;}\n    } \n    \n    return true;\n}\n\nprint \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n\n        <script src=\\\"jquery/jquery-1.8.3.js\\\" type=\'text/javascript\'></script>\n        <script src=\\\"jquery/jquery-ui.js\\\" type=\'text/javascript\'></script>\n\n        <script type=\\\"text/javascript\\\">\n            function ol(){\n                $(\'#stable tbody\').sortable();\n                $(\'#stable img.move\').click(function() {\n                    var row = $(this).closest(\'tr\');\n                    if ($(this).hasClass(\'up\'))\n                        row.prev().before(row);\n                    else\n                        row.next().after(row);\n                });\n                \n                adjustIframeHeight();\n            }\n\n            function show_critirion_special_info(critirion_special_id){\n                parent.nuOpenForm(\'57400922b87c65a\',\'#RECORD_ID#\', \'5741fe1502bb6c2\', critirion_special_id,\'Ειδικό Κριτήριο\');\n                //parent.nuOpenFormInFrame(\'\',critirion_special_id);\n            }\n        </script>\n        \n        <STYLE TYPE=\\\"text/css\\\">\n            .sisTableLine TH{\n                font-size:10pt;\n            }\n            .sisTableLine TR{\n	            background-color: LightSkyBlue;\n            }\n        </STYLE>\n\n    </head>\n\n    <body onload=\\\"ol();\\\">\";\n\n$sql=\"  SELECT \n            critirion_special.id,\n            critirion_special.description\n        FROM critirion_special\n        INNER JOIN critirion_general on critirion_special.critirion_general_id=critirion_general.id\n	    WHERE critirion_special.critirion_general_id=\'#RECORD_ID#\'\n        ORDER BY critirion_special.hierarchy,critirion_special.name\n\";\n$retval=nuRunQuery($sql);\n\nif($retval) {\n        print (\"\n        <table width=800 cellspacing=0 CLASS=\\\"sisTableLine\\\" align=center>\n            <tr height=40>\n                <th align=center>Ειδικά Κριτήρια Αξιολόγησης</th>\n            </tr>\n        </table>\n        \n        <table id=\\\"stable\\\" width=800 cellspacing=0 CLASS=\\\"sisTableLine\\\" align=center>\");\n        \n        while($row = db_fetch_row($retval)) {\n            print (\"\n            <tr height=40>\n                <td id=\\\"\".$row[0].\"\\\" class=\\\"critiria\\\" align=left title=\\\"Πληροφορίες/Επεξεργασία\\\" onclick=\\\"show_critirion_special_info(\".$row[0].\")\\\" onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\">\".   (is_null($row[1]) || $row[1]==\'\'? \'&nbsp;\' : $row[1]).\"</td>\n                <td width=40 align=center><img title=\\\"Μετακίνηση Επάνω\\\" class=\\\"move up\\\" src=\\\"images/up.png\\\" width=18 height=18 onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\"></td>\n            </tr>\");\n        }\n        print (\"\n        </table>\");\n       \n        if(can_add_row()){        \n            print (\"\n        <table width=800 cellspacing=0 CLASS=\\\"sisTableLine\\\" align=center>\n            <tr height=40>\n                <td style=\\\"padding-right:28px\\\" width=40 align=right colspan=2><img title=\\\"Προσθήκη Νέου Ειδικού Κριτηρίου\\\" src=\\\"images/add.png\\\" onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\" onclick=\\\"show_critirion_special_info(-1)\\\"></td>\n            </tr>\n        </table>\");\n        }\n} else{\n    print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν δεδομένα...</span>\");\n}\nprint \"\n    </body>\n</html>\";\n','','0','2016-05-21 11:26:14','globeadmin','2018-07-16 10:43:52','globeadmin','2018-07-18 11:18:52','globeadmin','0'),('57428fad993ae6b','search_critirion_special_level','Αναζήτηση επιπέδων ενός συγκεκριμένου ειδικού κριτιρίου αξιολόγησης','manager','function can_add_row(){\n\n    if(\'#RECORD_ID#\'==\'-1\') {return false;}\n    \n    if(\'#nu_user_group#\'!=\'Managers\' && \'#nu_user_group#\'!=\'AssistManagers\' && \'#nu_user_group#\'!=\'Administrators\' && \'#nu_user_group#\'!=\'globeadmin\'){\n\n        $sql = \"    SELECT COUNT(*)\n                    FROM mark_critirion_special_level\n                    WHERE critirion_special_id = \'#RECORD_ID#\'\n                \";\n        $retval = nuRunQuery($sql);\n        $row    = db_fetch_row($retval);\n        \n        if($row[0]!=0){return false;}\n\n        $sql = \"    SELECT COUNT(*)\n                    FROM subject_critirion_general\n                    INNER JOIN critirion_general ON critirion_general.id=subject_critirion_general.critirion_general_id\n                    INNER JOIN critirion_special ON critirion_special.critirion_general_id = critirion_general.id\n                    WHERE critirion_special.id = \'#RECORD_ID#\'\n                \";\n        \n        $retval = nuRunQuery($sql);\n        $row    = db_fetch_row($retval);\n        \n        if($row[0]!=0){return false;}\n    }\n    \n    return true;\n}\n\nprint \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n        \n        <script src=\\\"jquery/jquery-1.8.3.js\\\" type=\'text/javascript\'></script>\n        <script src=\\\"jquery/jquery-ui.js\\\" type=\'text/javascript\'></script>\n\n        <script type=\\\"text/javascript\\\">\n\n            function ol(){\n                $(\'#stable tbody\').sortable();\n                $(\'#stable img.move\').click(function() {\n                    var row = $(this).closest(\'tr\');\n                    if ($(this).hasClass(\'up\'))\n                        row.prev().before(row);\n                    else\n                        row.next().after(row);\n                });    \n            \n                adjustIframeHeight();\n            }\n\n            function show_critirion_special_level(critirion_special_level_id){\n                //parent.nuOpenForm(\'5741fe1502bb6c2\',\'#RECORD_ID#\', \'5742996ed6426f1\', critirion_special_level_id,\'Επίπεδο Ειδικού Κριτηρίου\');\n                parent.nuOpenFormInFrame(\'5742996ed6426f1\',critirion_special_level_id);\n            }\n\n        </script>\n        \n        <STYLE TYPE=\\\"text/css\\\">\n            .sisTableLine TH{\n                font-size:9pt;\n            }\n            .sisTableLine TR{\n	            background-color: LightSkyBlue;\n            }\n            .sisTableLine TD{\n                font-weight: normal;\n                }\n        </STYLE>\n\n    </head>\n\n    <body onload=\\\"ol();\\\">\";\n\n$sql=\"  SELECT \n            critirion_special_level.id,\n            critirion_special_level.description\n        FROM critirion_special_level\n        INNER JOIN critirion_special on critirion_special_level.critirion_special_id=critirion_special.id\n	    WHERE critirion_special_level.critirion_special_id=\'#RECORD_ID#\'\n        ORDER BY critirion_special_level.hierarchy,critirion_special_level.name\n\";\n$retval=nuRunQuery($sql);\n\nif($retval) {\n    \n        print (\"\n        <table width=850 cellspacing=0 CLASS=\\\"sisTableLine\\\" align=center>\n            <tr height=40>\n                <th align=center>Περιγραφές Ειδικού Κριτηρίου</th>\n            </tr>\n        </table>\n        \n        <table id=\\\"stable\\\" width=850 cellspacing=0 CLASS=\\\"sisTableLine\\\" align=center>\");\n        \n        while($row = db_fetch_row($retval)) {\n            print (\"\n            <tr height=40>\n                <td id=\\\"\".$row[0].\"\\\" class=\\\"critiria\\\" align=left title=\\\"Πληροφορίες/Επεξεργασία\\\" onclick=\\\"show_critirion_special_level(\".$row[0].\")\\\" onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\">\".   (is_null($row[1]) || $row[1]==\'\'? \'&nbsp;\' : $row[1]).\"</td>\n                <td width=40 align=center><img title=\\\"Μετακίνηση Επάνω\\\" class=\\\"move up\\\" src=\\\"images/up.png\\\" width=18 height=18 onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\"></td>\n            </tr>\");\n        }\n        \n        print (\"\n        </table>\");\n       \n        if(can_add_row()){        \n            print (\"\n        <table width=850 cellspacing=0 CLASS=\\\"sisTableLine\\\" align=center>\n            <tr height=40>\n                <td style=\\\"padding-right:28px\\\" width=40 align=right colspan=2><img title=\\\"Προσθήκη Νέας Περιγραφής\\\" src=\\\"images/add.png\\\" onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\" onclick=\\\"show_critirion_special_level(-1)\\\"></td>\n            </tr>\n        </table>\");\n        }\n} else{\n    print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν δεδομένα...</span>\");\n}\nprint \"\n    </body>\n</html>\";\n','','0','2016-05-23 08:05:49','globeadmin','2018-07-14 10:13:26','globeadmin','2018-07-28 19:58:12','globeadmin','0'),('5742d24537ea41b','delete_critirion_special_level','Διαγράφει μια περιγραφή ενός ειδικού κριτηρίου','manager','$sql = \"    SELECT COUNT(*)\n            FROM mark_critirion_special_level\n            WHERE critirion_special_level_id = \'#RECORD_ID#\'\n        \";\n$retval = nuRunQuery($sql);\n$row    = db_fetch_row($retval);\n\nif($row[0]!=0){\n    $nuError = \'Προσοχή : Υπάρχουν βαθμοί με αυτήν την περιγραφή! Η διαγραφή δε μπορεί να πραγματοποιηθεί!\';\n} else {\n\n    if(\'#nu_user_group#\'!=\'Managers\' && \'#nu_user_group#\'!=\'AssistManagers\' && \'#nu_user_group#\'!=\'Administrators\' && \'#nu_user_group#\'!=\'globeadmin\'){\n    \n        $sql = \"    SELECT COUNT(*)\n                    FROM subject_critirion_general\n                    INNER JOIN critirion_general ON critirion_general.id=subject_critirion_general.critirion_general_id\n                    INNER JOIN critirion_special ON critirion_special.critirion_general_id = critirion_general.id\n                    INNER JOIN critirion_special_level ON critirion_special_level.critirion_special_id = critirion_special.id\n                    WHERE critirion_special_level.id = \'#RECORD_ID#\'\n                \";\n        \n        $rv = nuRunQuery($sql);\n        $r    = db_fetch_row($rv);\n        if($r[0]!=0){\n            $nuError = \'Προσοχή : Υπάρχουν μαθήματα συσχετιζόμενα με αυτή τη περιγραφή! Η διαγραφή δε μπορεί να πραγματοποιηθεί!\';\n        } else {\n            $sql=\"delete from critirion_special_level where id=\'#RECORD_ID#\'\";\n            nuRunQuery($sql);   \n        }\n    } else {\n        $sql=\"delete from critirion_special_level where id=\'#RECORD_ID#\'\";\n        nuRunQuery($sql);    \n    }\n}\n\n\n\n\n\n\n','','0','2016-05-23 12:49:57','globeadmin','2016-05-30 21:32:12','globeadmin','2016-05-30 21:32:12','globeadmin','0'),('57449ba8e93ac07','clone_critirio_lib','Βιβλιοθήκη συναρτήσεων για την κλωνοποίηση κριτηρίων περιγραφικής αξιολόγησης','teacher','function clone_critirion_special_level($critirion_special_level_id,$critirion_special_id){\n    \n    $sql = \"SELECT ifNULL(max(hierarchy),0)+1\n            FROM critirion_special_level\n            WHERE critirion_special_id=\'\".$critirion_special_id.\"\'\";\n    $retval = nuRunQuery($sql);\n    \n    if($retval){\n        \n        $row = db_fetch_row($retval);\n        \n        $new_id = nuNextNumber(\'critirion_special_level\');\n        \n        $sql=\"  UPDATE\n                    critirion_special_level AS a, critirion_special_level AS b\n                SET\n                    a.name=b.name,\n                    a.description=b.description,\n                    a.hierarchy=\'\".$row[0].\"\',\n                    a.critirion_special_id=\'\".$critirion_special_id.\"\'    \n                WHERE \n                    a.id=\'\".$new_id.\"\' AND\n                    b.id=\'\".$critirion_special_level_id.\"\'\n        \";\n        nuRunQuery($sql);\n        \n        return($new_id);\n        \n    } else {\n        return false;\n    }\n}\n\nfunction clone_critirion_special($critirion_special_id,$critirion_general_id){\n    \n    $sql = \"SELECT ifNULL(max(hierarchy),0)+1\n            FROM critirion_special\n            WHERE critirion_general_id=\'\".$critirion_general_id.\"\'\";\n    $retval = nuRunQuery($sql);\n    \n    if($retval){\n        \n        $row = db_fetch_row($retval);\n        \n        $new_id = nuNextNumber(\'critirion_special\');\n        \n        $sql=\"  UPDATE\n                    critirion_special AS a, critirion_special AS b\n                SET\n                    a.name=b.name,\n                    a.description=b.description,\n                    a.is_editable=b.is_editable,\n                    a.hierarchy=\'\".$row[0].\"\',\n                    a.critirion_general_id=\'\".$critirion_general_id.\"\'    \n                WHERE \n                    a.id=\'\".$new_id.\"\' AND\n                    b.id=\'\".$critirion_special_id.\"\'\n        \";\n        \n        nuRunQuery($sql);\n        \n        $sql = \"    SELECT id\n                    FROM critirion_special_level\n                    WHERE critirion_special_id=\'\".$critirion_special_id.\"\'\n                    ORDER BY hierarchy\n                    \";\n        $retval = nuRunQuery($sql);\n    \n        if($retval){\n        \n            while ($row=db_fetch_row($retval)){\n                if(!clone_critirion_special_level($row[0],$new_id)){return false;} \n            }\n            \n            return $new_id;\n\n        } else {\n            return false;\n        }\n    } else {\n        return false;\n    }    \n}\n\nfunction clone_critirion_general($critirion_general_id,$name=null){\n\n        $name = (is_null($name) ? \"CONCAT(b.name,\'-Αντίγραφο\')\":\"\'\".$name.\"\'\");\n        \n        $new_id = nuNextNumber(\'critirion_general\');\n\n        $sql=\"  UPDATE\n                    critirion_general AS a, critirion_general AS b\n                SET\n                    a.name=\".$name.\",\n                    a.description=b.description,\n                    a.grade_id=b.grade_id,\n                    a.speciality_id=b.speciality_id,\n                    a.teacher_id=b.teacher_id\n                WHERE\n                    b.id=\'\".$critirion_general_id.\"\' AND\n                    a.id = \'\".$new_id .\"\'\";\n        nuRunQuery($sql);\n        \n        $sql = \"    SELECT id\n                    FROM critirion_special\n                    WHERE critirion_general_id=\'\".$critirion_general_id.\"\'\n                    ORDER BY hierarchy\n                    \";\n        $retval = nuRunQuery($sql);\n    \n        if($retval){\n        \n            while ($row=db_fetch_row($retval)){\n                if(!clone_critirion_special($row[0],$new_id)){return false;} \n            }\n\n            return $new_id;\n\n        } else {\n            return false;\n        }\n}','','0','2016-05-24 21:21:28','globeadmin','2016-12-30 22:41:24','globeadmin','2016-12-30 22:41:24','globeadmin','0'),('57453d968dbad4a','clone_general_critirio_ajax','Κλωνοποιεί ένα γενικό κριτήριο με κλήση Ajax','teacher','nuRunPHP(\'clone_critirio_lib\');\nif(\'#new_name#\'!=\'\' && \'#new_name#\'!=\'#\'.\'new_name#\'){\n    nuDebug(\'#new_name#\');\n    if($new_id = clone_critirion_general(\'#RECORD_ID#\',\'#new_name#\')){\n       $nuParameters = $new_id;\n    } else {\n       $nuError = \"Προσοχή: Παρουσιάστηκε πρόβλημα κατά την κλωνοποίηση του κριτηρίου!\"; \n    }\n} else {\n    if($new_id = clone_critirion_general(\'#RECORD_ID#\')){\n        $nuParameters = $new_id;\n    } else {\n        $nuError = \"Προσοχή: Παρουσιάστηκε πρόβλημα κατά την κλωνοποίηση του κριτηρίου!\";\n    }\n}','','0','2016-05-25 08:52:22','globeadmin','2016-05-25 09:30:29','globeadmin','2021-02-26 21:38:32','globeadmin','0'),('57459161e5a0363','clone_special_critirion_ajax','Κλωνοποιεί ένα ειδικό κριτήριο με κλήση Ajax','teacher','\nnuRunPHP(\'clone_critirio_lib\');\n\nif(\'#new_critirion_general_id#\'!=\'\' && \'#new_critirion_general_id#\'!=\'#\'.\'new_critirion_general_id#\'){\n    if($new_id = clone_critirion_special(\'#RECORD_ID#\',\'#new_critirion_general_id#\')){\n       $nuParameters = \"Το κριτήριο κλωνοποιήθηκε επιτυχώς!\";\n    } else {\n       $nuError = \"Προσοχή: Παρουσιάστηκε πρόβλημα κατά την κλωνοποίηση του κριτηρίου!\"; \n    }\n} else {\n    $nuError = \"Παρακαλώ επιλέξτε πρώτα το «Γενικό Κριτήριο» στο οποίο θα προσαρτηθεί ο κλώνος...\";\n}','','0','2016-05-25 14:49:53','globeadmin','2016-05-25 14:55:19','globeadmin','2020-09-18 01:17:17','globeadmin','0'),('574bd5bd5a5bede','search_general_critirion_subject','Βρίσκει τα συσχετισμένα μαθήματα ενός συγκεκριμένου ειδικού κριτηρίου','teacher','$sql = \"    SELECT concat(\n                        ifNull(grade.short_name,\'\'),\n                        ifNull(section.abbreviation,\'\'),\n                        if(section.abbreviation!=speciality.abbreviation,ifNULL(speciality.abbreviation,\'\'),\'\'),\n                        \'-\',\n                        subject.name,\n                        if(subject_type.short_name is NULL,\'\',concat(\' (\',subject_type.short_name,\')\'))) as subject_full_name\n            FROM subject\n            LEFT JOIN grade                         ON subject.grade_id=grade.id\n            LEFT JOIN speciality                    ON subject.speciality_id=speciality.id\n            LEFT JOIN section                       ON speciality.section_id=section.id\n            LEFT JOIN subject_type                  ON subject.subject_type_id=subject_type.id\n            INNER JOIN subject_critirion_general    ON subject_critirion_general.subject_id = subject.id\n            WHERE	subject_critirion_general.critirion_general_id=\'#RECORD_ID#\'\n            ORDER BY subject_full_name\";\n\n$retval = nuRunQuery($sql);\n\nprint \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n        <style>\n            .sisTable tr:nth-child(even){\n	            background-color: LightSteelBlue;\n            }\n        </style>\n    </head>\n    <body>\";\n\nif(!$retval ){\n    print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν τα δεδομένα!</span>\");\n} else{\n    print (\"\n        <table CLASS=\\\"sisTable\\\" cellspacing=0 width=100%>\n            <tr height=30> \n                <th width=600 align=center>Μάθημα</th> \n            </tr>\");\n    \n    while($row = db_fetch_row($retval)){\n        print \"\n            <tr height=25>\n                <td align=left valign=center>\".$row[0].\"</td>\n            </tr>\";\n    }\n    print (\"\n    </table>\");\n}\n    \nprint \"\n    </body>\n</html>\";','','0','2016-05-30 08:55:09','globeadmin','2018-07-14 10:34:36','globeadmin','2018-07-16 10:45:16','globeadmin','0'),('574ea919042d569','create_mark_critirion','Δημιουργεί τη φόρμα με τα κριτήρια περιγραφικής αξιολόγησης για ένα βαθμό','teacher','print \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        \n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n        \n        <script src=\\\"jquery/jquery-1.8.3.js\\\" type=\'text/javascript\'></script>\n        <script src=\\\"jquery/jquery-ui.js\\\" type=\'text/javascript\'></script>\n        \n        <script>\n        \n            function escapeHtml(text) {\n                var map = {\n                    \'&\': \'&amp;\',\n                    \'<\': \'&lt;\',\n                    \'>\': \'&gt;\',\n                    \'\\\"\': \'&quot;\',\n                    \\\"\'\\\": \'\'\n                };\n\n                text = text.replace(/\\\\r?\\\\n|\\\\r/g, \' \');\n                return text.replace(/[&<>\\\"\']/g, function(m) { return map[m]; });\n            }\n            function showDropDown(select_id){\n                var links = \\\"\\\";\n                var count = 0;\n                \n                // Get the options from the hidden control\n                $\".\"options = $(\'#\'+select_id+\' option\');\n                $\".\"options.each(function(i, val) {	\n                    $\".\"option = $(this);\n                    links = links \n					    + \\\"<div class=\\\\\\\"optionDiv\\\\\\\" onclick=\\\\\\\"setSelectedOption(event,\'\\\"+ $\".\"option.val() + \\\"\',\'\\\" + escapeHtml($\".\"option.text()) + \\\"\',\'\\\" + select_id + \\\"\');\\\\\\\">\\\" +  escapeHtml($\".\"option.text()) + \\\"</div>\\\";\n				    count++;\n			    });\n\n			    // Generate the dvi based select control\n			    $\".\"dropDownDiv = $(\'#dropDownOptions_\'+select_id);\n			    \n			    \n			    var position = $(\'#td2_\'+select_id).offset();\n			    var new_top = 0;\n			    \n			    if (($(document).height()-position.top) < 190){\n                    new_top = (position.top-210)+\'px\';\n			    } else {\n			        new_top = (position.top-7)+\'px\';\n			    }\n			    \n			    $\".\"dropDownDiv.css({ top: new_top });\n			    $\".\"dropDownDiv.html(links);\n			    $\".\"dropDownDiv.show();\n			\n			    // Add a scroll bar if required\n			    if(count > 4){\n				    $\".\"dropDownDiv.addClass(\\\"scrollDiv\\\");\n			    }\n            }\n\n            function setSelectedOption(event,val, text, select_id){\n                $(\'#dropDownOptions_\'+select_id).hide();\n                $(\'#td_\'+select_id).html(text);\n                $(\'#\'+select_id).val(val);\n                event.stopPropagation();\n            }\n            \n            $(document).mouseup(function (e)  {\n                $( \\\".dropDownOptions\\\" ).each(function() {\n                    var container = $(this);\n                    if (container.has(e.target).length === 0){\n		                container.hide();\n		            }\n                });\n\n	        });\n	        \n	        //$(document).blur(function (e)  {\n            //    $( \\\".dropDownOptions\\\" ).each(function() {\n            //        var container = $(this);\n            //        if (container.has(e.target).length === 0){\n		    //            container.hide();\n		    //        }\n            //    });\n	        //});\n	        \n        </script>\n\n        <STYLE TYPE=\\\"text/css\\\">\n\n            .sisTableLine TH{\n                font-size:9pt;\n            }\n            \n            .sisTableLine TD{\n                font-weight: normal;\n            }\n      \n            .dropDownOptions{\n			    display: none;\n			    position: absolute;\n			    z-index: 5000;\n			    padding-top: 1px;\n			    overflow-x:none;\n			    padding-bottom: 0 !important;\n			    width: 590px;\n			    height: 180px;\n			    border: 1px solid #C8C8C8;\n			    background-color:#fff;\n			    box-shadow: 0 4px 3px #8C8C8C;\n		    }\n		\n		    .scrollDiv{\n			    height: 180px;\n			    overflow-y: auto;\n		    }\n		      \n		    .optionDiv {\n		        background-color: #FFFFFF;\n		        border-bottom: 1px solid #C8C8C8;\n		        font-family:Verdana;\n                font-size:8pt;\n		        padding-bottom: 3px;\n		        padding-left: 5px;\n		        padding-top: 3px;\n		        width: 97%;\n                min-height: 28px;\n		        cursor: default;\n		    }\n		\n		    .dropDownOptions div:hover{\n		        background-color: #ccc2b8;\n		    }\n		    \n        </STYLE>\n\n    </head>\n\n    <body>\";\n\n$sql = \"    SELECT \n                critirion_general.id,\n                mark_critirion_special_level.id,\n                mark_critirion_special_level.critirion_special_id,\n                ifNULL(mark_critirion_special_level.critirion_special_level_id,0),\n                \n                critirion_general.description,\n                critirion_special.description,\n                ifNULL(critirion_special_level.description,\'\'),\n                ifNULL(mark_critirion_special_level.custom_description,\'\'),\n                critirion_special.is_editable\n            \n            FROM mark\n            \n            INNER JOIN mark_critirion_special_level \n                    ON mark_critirion_special_level.mark_id =   mark.id\n                    \n            INNER JOIN critirion_special            \n                    ON critirion_special.id         = mark_critirion_special_level.critirion_special_id       \n            \n            LEFT JOIN  critirion_special_level      \n                    ON critirion_special_level.id   = mark_critirion_special_level.critirion_special_level_id        \n            \n            INNER JOIN critirion_general            \n                    ON critirion_general.id         = critirion_special.critirion_general_id \n                    \n            INNER JOIN subject 						\n                    ON subject.id                   = mark.subject_id\n            \n            INNER JOIN subject_critirion_general\n                    ON (subject_critirion_general.subject_id=subject.id AND subject_critirion_general.critirion_general_id=critirion_general.id)\n            WHERE mark.id=\'#RECORD_ID#\'\n            ORDER BY subject_critirion_general.id,critirion_general.id,critirion_special.hierarchy\n        \";\n$retval = nuRunQuery($sql);\n\nif(!$retval){\n    print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν τα δεδομένα!</span>\");\n} else if(db_num_rows($retval)==0){\n    print (\"<span CLASS=\\\"msg\\\">Δεν έχουν οριστεί κριτήρια αξιολόγησης για το συγκεκριμένο μάθημα!</span>\");\n} else {\n\n    $critirion_general_id=-1;\n    \n    while($row = db_fetch_row($retval)){\n        \n        if($row[0]!=$critirion_general_id && $critirion_general_id!=-1){ \n            print (\"    </table><br>\");\n        }\n        \n        if($row[0]!=$critirion_general_id){\n                print (\"\n        <table CLASS=\\\"sisTableLine\\\" cellspacing=0 width=100%>\n            <tr height=30> \n                <th align=center colspan=2>\".$row[4].\"</th> \n            </tr>\n            \");    \n        }\n        $critirion_general_id=$row[0];\n        \nprint \"\n            <tr height=45>\n                <td align=left valign=center width=320><b>\".$row[5].\":</b></td>\n                <td align=left valign=center>\";\n                    \nprint \"  \n                        <table width=\\\"98%;\\\" height=\\\"98%\\\" CLASS=\\\"sisTableLine\\\">\n                            <tr>\";\n        if($row[8]==\'1\'){                    \nprint \"\n                            <td style=\\\"border:none;\\\" id=\\\"td_\".$row[1].\"\\\" title=\\\"Ctrl+Click για επεξεργασία\\\" bgcolor=lightyellow width=\\\"98%\\\" height=\\\"99%\\\" onblur =\\\"this.contentEditable=\'false\';this.title=\'Ctrl+Click για επεξεργασία\';\\\" onclick=\\\"if(event.ctrlKey || event.metaKey){this.contentEditable=\'true\';this.focus();this.title=\'\';} else{if(this.contentEditable!=\'true\'){showDropDown(\'\".$row[1].\"\');}}\\\">\".($row[7]!=\'\' ? $row[7] : ($row[6]==\'\' ? \'Παρακαλώ επιλέξτε...\' : $row[6])).\"</td>\";\n        } else {\nprint \"\n                            <td style=\\\"border:none;\\\" id=\\\"td_\".$row[1].\"\\\" bgcolor=\\\"#ffffb3\\\" width=\\\"98%\\\" height=\\\"99%\\\" onclick=\\\"showDropDown(\'\".$row[1].\"\');\\\">\".($row[7]!=\'\' ? $row[7] : ($row[6]==\'\' ? \'Παρακαλώ επιλέξτε...\' : $row[6])).\"</td>\";\n        }\n\nprint \"   		                    \n 		                    </tr>\n 		                    <tr>\n 		                        <td style=\\\"border:none;\\\" id=\\\"td2_\".$row[1].\"\\\" width=\\\"98%\\\" height=\\\"2%\\\">\n 			                        <div id=\\\"dropDownOptions_\".$row[1].\"\\\" class=\\\"dropDownOptions\\\" style=\\\"display:none;\\\"/>\n 		                        </td>\n 	                        </tr>\n                            <tr>\n 		                        <td style=\\\"border:none;\\\" width=\\\"100%\\\">\n 			                        <select class=\\\"critirion_select\\\" id=\\\"\".$row[1].\"\\\" style=\\\"width:600px;display:none;\\\" >\";\n 			\n        print \"\n                                        <option value=\\\"0\\\">&nbsp;</option>\";\n        $sql=\"  SELECT id,description\n                FROM critirion_special_level\n                WHERE critirion_special_id = \'\".$row[2].\"\'\n                ORDER BY hierarchy\n            \";\n        $rv = nuRunQuery($sql);\n        \n        while($r = db_fetch_row($rv)){\n            print \"\n                                        <option value=\\\"\".$r[0].\"\\\" \".($r[0]==$row[3] ? \'selected\' : \'\').\">\".$r[1].\"</option>\";    \n        }\n        print \"\n			                        </select>\n 		                        </td>\n                            </tr>\n                        </table>\n                    \n               </td>\n            </tr>\n  \";\n    }\n    \n    print (\"    </table>\");\n}\n\nprint \"\n    </body>\n</html>\";','','0','2016-06-01 12:21:29','globeadmin','2022-01-15 12:14:19','globeadmin','2022-01-15 12:14:19','globeadmin','0'),('5757b8458c72cf3','show_mark_critirion','Εμφανίζει τα κριτήρια περιγραφικής αξιολόγησης για ένα βαθμό','teacher','print \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n        \n        <STYLE TYPE=\\\"text/css\\\">\n			.sisTableLine TD{\n                font-weight: normal;    \n            }\n			.sisTableLine TH{\n                font-size:9pt;   \n            }\n        </STYLE>\n    </head>\n    <body>\";\n\n$sql = \"    SELECT \n                critirion_general.id,\n                mark_critirion_special_level.id,\n                mark_critirion_special_level.critirion_special_id,\n                ifNULL(mark_critirion_special_level.critirion_special_level_id,0),\n                \n                critirion_general.description,\n                critirion_special.description,\n                ifNULL(critirion_special_level.description,\'\'),\n                ifNULL(mark_critirion_special_level.custom_description,\'\')\n            \n            FROM mark\n            \n            INNER JOIN mark_critirion_special_level \n                    ON mark_critirion_special_level.mark_id =   mark.id\n                    \n            INNER JOIN critirion_special            \n                    ON critirion_special.id         = mark_critirion_special_level.critirion_special_id       \n            \n            LEFT JOIN  critirion_special_level      \n                    ON critirion_special_level.id   = mark_critirion_special_level.critirion_special_level_id        \n            \n            INNER JOIN critirion_general            \n                    ON critirion_general.id         = critirion_special.critirion_general_id \n\n            WHERE mark.id=\'#RECORD_ID#\'\n            ORDER BY critirion_general.id,critirion_special.hierarchy\n        \";\n$retval = nuRunQuery($sql);\n\nif(!$retval){\n    print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν τα δεδομένα!</span>\");\n} else if(db_num_rows($retval)==0){\n    print (\"<span CLASS=\\\"msg\\\">Δε βρέθηκε περιγραφική αξιολόγηση με κριτήρια!</span>\");\n} else {\n    \n    $critirion_general_id=-1;\n    \n    while($row = db_fetch_row($retval)){\n        \n        if($row[0]!=$critirion_general_id && $critirion_general_id!=-1){ \n            print (\"\n        </table>\n        <br>\");\n        }\n        \n        if($row[0]!=$critirion_general_id){\n                print (\"\n        <table CLASS=\\\"sisTableLine\\\" cellspacing=0 width=100%>\n            <tr height=30> \n                <th align=center colspan=2>\".$row[4].\"</th> \n            </tr>\");    \n        }\n        $critirion_general_id=$row[0];\n        \n        print \"\n            <tr height=45>\n                <td align=left valign=center width=300><b>\".$row[5].\":</b></td>\n                <td align=left valign=center>\";\n\nprint \"  \n                    <table width=\\\"100%;\\\" CLASS=\\\"sisTableLine\\\">\n                        <tr>\n                            <td id=\\\"td_\".$row[1].\"\\\" style=\\\"background-color:lightyellow;\\\">\n 		                            \".($row[7]!=\'\' ? $row[7] : ($row[6]==\'\' ? \'Δεν ορίστηκε περιγραφή από το διδάσκοντα!\' : $row[6])).\"\n                            </td>\n                        </tr>\n                    </table>\n               </td>\n            </tr>\";\n    }\n    print (\"\n        </table>\");\n}\nprint \"\n    </body>\n</html>\";','','0','2016-06-08 09:16:37','globeadmin','2018-07-15 23:07:00','globeadmin','2018-07-15 23:07:00','globeadmin','0'),('5753f0e67512c07','update_mark_critiria','Ενημέρωση Περιγραφών αξιολόγησης ενός βαθμού','teacher','if (\'#criritia_JSON#\'!=\'\' && \'#criritia_JSON#\'!=\'#\'.\'criritia_JSON#\' && \'#criritia_JSON#\'!=\'[]\'){\n    $json_str = stripslashes(\'#criritia_JSON#\'); \n    $json = json_decode($json_str,true);\n\n    if (json_last_error() === JSON_ERROR_NONE) {\n        //do something with $json. It\'s ready to use\n        foreach($json as $mark_level){\n            $sql=\"  UPDATE mark_critirion_special_level \n                    set critirion_special_level_id=\".($mark_level[1]==0 ? \'NULL\' : $mark_level[1]).\",\n                    custom_description=\".($mark_level[2]==\"\" ? \"NULL\" : \"\'\".$mark_level[2].\"\'\").\"\n                    where id=\'\".$mark_level[0].\"\'\";\n            nuRunQuery($sql);     \n        }\n    } else {\n        nudebug(\'Καταχώριση Περιγραφών Βαθμού : Δεν μπόρεσα να  αποκωδικοποιήσω το : \'.\'#criritia_JSON#\');\n    } \n} else {\n    nudebug(\'Mη έγκυρο JSON : \'.\'#criritia_JSON#\');    \n}','','0','2016-06-05 12:29:10','globeadmin','2016-12-30 10:11:11','globeadmin','2016-12-30 10:11:11','globeadmin','0'),('575933c634d39e2','show_marks_student_full','Εμφανίζει τους βαθμούς του μαθητή μαζί και την περιγραφική','student','function format_mark_value($value,$num_of_decimals){\n                    \n    $pieces = explode(\".\", $value);\n    $new_value =  $value;\n    \n    if(strlen($pieces[0])==1){\n        $pieces[0]=\'0\'.$pieces[0];    \n    }\n    \n    if(count($pieces)==2){\n        if($num_of_decimals==0 && $pieces[1]==\'0\'){\n            $new_value = $pieces[0];   \n        } else {\n            $new_value = $pieces[0].\',\'.$pieces[1];    \n        }\n    }\n    \n    return($new_value);\n}\n\nfunction show_mark_table($student_id,$grading_period_id){\n\n    $output = \"\";\n\n    $table_style = \"STYLE=\\\"font-family:Verdana;font-size:9pt;\\\"\";\n    $critirio_td_style = \"STYLE=\\\"font-family:Verdana;font-size:8pt;vertical-align:top;\\\"\";\n    $critirio_th_style = \"STYLE=\\\"font-family:Verdana;font-size:8pt;\\\"\";\n\n    $output .= \"    \n        <table border=0 cellspacing=0 align=center \".$table_style.\">\";\n\n    $sql=\"DROP TEMPORARY TABLE IF EXISTS #TABLE_ID#\";\n    nuRunQuery($sql);\n\n    $sql=\"CREATE TEMPORARY TABLE #TABLE_ID# DEFAULT CHARACTER SET=utf8\n    SELECT\n    \n        mark.id as mark_id,\n        mark.value as value_p,\n    \n	    mark.grading_period_id as grading_period_id,\n	    grading_period.num_of_decimals as grading_period_num_of_decimals,\n	    mark.student_id as student_id,\n	    mark.subject_id as subject_id,\n	    mark.post_teacher_id as post_teacher_id,\n    \n        grading_period.name as grading_period_name,\n    \n        student.name as student_name,\n        student.surname as student_surname,\n        student.fathers_name as student_fathers_name,\n        student.registration_number as student_registration_number,\n    \n        subject.name as subject_name,\n        subject_type.name as subject_type_name,\n        concat(subject.name,\' (\',subject_type.name,\')\') as subject_full_name,\n    \n        school.name as school_name,\n        school_year.name as school_year_name,\n    \n        DATE_FORMAT(curdate(),\'%d-%m-%Y\') as cur_date,\n    \n        class.id as class_id,\n        class.short_name as class_short,\n        CAST(\'\' as CHAR(255)) as teacher_names,\n        CAST(mark.comments as CHAR(255)) as mark_comments,\n        0                                           as critiria_count\n    FROM mark\n    INNER JOIN grading_period   ON mark.grading_period_id=grading_period.id  \n    INNER JOIN student          ON mark.student_id=student.id\n    INNER JOIN class            ON mark.class_id=class.id\n    INNER JOIN subject          ON mark.subject_id=subject.id\n    INNER JOIN school           ON 1=1\n    INNER JOIN school_year      ON school_year.id=school.school_year_id\n    LEFT  JOIN subject_type     ON subject.subject_type_id=subject_type.id\n    where\n        mark.grading_period_id=\'\".$grading_period_id.\"\' and\n        mark.student_id=\'\".$student_id.\"\'\n    order by subject_full_name\n    \";\n    nuRunQuery($sql);\n\n    $sql=\"select distinct class_id,subject_id from #TABLE_ID#\";\n    $rv = nuRunQuery($sql);\n\n    if($rv){\n        while($row = db_fetch_row($rv)){\n            $class_id=$row[0];\n            $subject_id=$row[1];\n            \n            $sql=\"  SELECT distinct CONCAT(IF(teacher.surname is null,\'\', concat(teacher.surname,\' \')),IFNULL(teacher.name,\'\'))\n                    FROM \n	                    (SELECT \n		                    card.id 			AS id,\n		                    card.valid_from 	AS valid_from,\n		                    card.subject_id 	AS subject_id,\n		                    card.teacher_id 	AS teacher_id,\n		                    card.class_id 		AS class_id,\n		                    card.classroom_id 	AS classroom_id,\n		                    card.day_id 		AS day_id,\n		                    card.period_id 		AS period_id \n	                    FROM card \n	                    WHERE card.valid_from =\n		                    (	SELECT max(timetable.start_date) \n			                    FROM timetable \n			                    WHERE (timetable.start_date <= curdate()))) \n	                as active_card \n	                inner join subject 			on active_card.subject_id = subject.id \n	                inner join teacher 			on active_card.teacher_id = teacher.id  \n	                inner join day 				on active_card.day_id = day.id  \n	                inner join period 			on active_card.period_id = period.id\n	                inner join class 			on active_card.class_id = class.id	\n	                left  join subject_type 	on subject.subject_type_id = subject_type.id  \n	                left  join classroom 		on active_card.classroom_id = classroom.id\n	                where \n	                    active_card.subject_id=\'\".$subject_id.\"\' and active_card.class_id=\'\".$class_id.\"\'\n                    ORDER BY \n    	                active_card.teacher_id,\n	                    active_card.day_id,\n	                    active_card.period_id\";\n\n            $retval = nuRunQuery($sql);\n            $teachers=\'\';\n            $first=true;\n\n            if($retval){\n                while($row = db_fetch_row($retval)){\n                    if($first){\n                        $teachers=$row[0];\n                        $first=false;\n                    } else{\n                        $teachers=$teachers.\', \'.$row[0];\n                    }\n                }\n            }\n            if(!$first){\n                $sql=\"update #TABLE_ID# set teacher_names=\'\".$teachers.\"\' where class_id=\".$class_id.\" and subject_id=\".$subject_id;\n                nuRunQuery($sql);\n                }\n        }\n    }\n\n    $sql=\"SELECT mark_id FROM #TABLE_ID#\";\n    $retval = nuRunQuery($sql);\n            \n    while($row = db_fetch_row($retval)){\n                \n        $sql = \"    SELECT count(*)\n                    FROM mark_critirion_special_level\n                    WHERE \n                        mark_id=\'\".$row[0].\"\' AND \n                        critirion_special_level_id IS NOT NULL\";\n        $rv2=nuRunQuery($sql);\n        $r2 = db_fetch_row($rv2);\n                \n        if($r2[0]!=\'0\'){\n            $sql=\"  update #TABLE_ID# set critiria_count=\'\".$r2[0].\"\' where mark_id=\".$row[0];\n            nuRunQuery($sql);\n        }\n    }\n\n    $sql=\"  select\n                subject_name,\n                subject_type_name,\n                value_p,\n                teacher_names,\n                class_short,\n                mark_comments,\n                mark_id,\n                critiria_count,\n                grading_period_num_of_decimals\n            from #TABLE_ID#\n            order by subject_name,subject_type_name DESC\";\n\n    $retval = nuRunQuery($sql);\n\n    if($retval && db_num_rows($retval)>0){\n        $output .=\"\n                <tr bgcolor=LightSalmon height=40 \".$table_style.\"> \n                    <th width=400 align=center \".$table_style.\"><b>Μάθημα</b></th>\n                    <th width=100 align=center \".$table_style.\"><b>Κατηγορία</b></th>\n                    <th width=90 align=center \".$table_style.\"><b>Βαθμός</b></th>\n                    <th width=300 align=center \".$table_style.\"><b>Καθηγητές</b></th> \n                </tr>\n                <tr height=2 bgcolor=lightyellow \".$table_style.\">\n                    <td colspan=4 \".$table_style.\">\n                    </td>\n                </tr>\";\n\n        $color1 =\'LightBlue\';\n        $color2 =\'LightSteelBlue\';\n\n        $color = $color2;\n\n        while($row = db_fetch_row($retval)){\n        \n            $color = ($color==$color2 ? $color1 : $color2); \n        \n            $output .= \"\n                <tr bgcolor=\".$color.\" height=35 \".$table_style.\">\n                    <td align=left \".$table_style.\"><b>\".$row[0].\"</b></td>\n                    <td align=center \".$table_style.\"><b>\".$row[1].\"</b></td>\n                    <th align=center \".$table_style.\"><b>\".($row[2]<10 ? \"<font color=\'red\' size=+1>\" : ($row[2]<14 ? \"<font color=\'Orange\' size=+1>\" : ($row[2]<17 ? \"<font color=\'blue\' size=+1>\" : \"<font color=\'green\' size=+1>\"))).format_mark_value($row[2],$row[8]).\"</font></b></th>\n                    <td align=left \".$table_style.\"><b>\".$row[3].\"</b></td>\n                </tr>\";\n        \n            if($row[7]!=\'0\'){\n                $output .= \"\n                <tr bgcolor=\".$color.\" \".$table_style.\">\n                    <td colspan=4 height=5 \".$table_style.\">\n                    </td>\n                </tr>\n                <tr bgcolor=\".$color.\" \".$table_style.\">\n                    <td colspan=4 \".$table_style.\">\";          \n                $sql = \"    SELECT \n                                critirion_general.id,\n                                mark_critirion_special_level.id,\n                                mark_critirion_special_level.critirion_special_id,\n                                ifNULL(mark_critirion_special_level.critirion_special_level_id,0),\n                \n                                critirion_general.description,\n                                critirion_special.description,\n                                ifNULL(critirion_special_level.description,\'\')\n            \n                            FROM mark\n            \n                            INNER JOIN mark_critirion_special_level \n                                    ON mark_critirion_special_level.mark_id =   mark.id\n                    \n                            INNER JOIN critirion_special            \n                                    ON critirion_special.id         = mark_critirion_special_level.critirion_special_id       \n            \n                            LEFT JOIN  critirion_special_level      \n                                    ON critirion_special_level.id   = mark_critirion_special_level.critirion_special_level_id        \n            \n                            INNER JOIN critirion_general            \n                                    ON critirion_general.id         = critirion_special.critirion_general_id \n\n                            WHERE mark.id=\'\".$row[6].\"\'\n                            ORDER BY critirion_general.id,critirion_special.hierarchy\n                        \";\n                $rv = nuRunQuery($sql);\n\n                if($rv && db_num_rows($rv)>0){\n    \n                    $critirion_general_id=-1;\n    \n                    $output .= \"\n                        <table border=0 cellspacing=0 width=100% \".$critirio_th_style.\">\n                            <tr bgcolor=\".$color.\"  \".$critirio_th_style.\"> \n                                <th align=center colspan=3  \".$critirio_th_style.\">Κριτήρια Περιγραφικής Αξιολόγησης</th> \n                            </tr>\";\n                    while($r = db_fetch_row($rv)){\n        \n                        if($r[0]!=$critirion_general_id && $critirion_general_id!=-1){\n                            $output .= \"\n                            <tr bgcolor=\".$color.\" height=10 \".$critirio_td_style.\"> \n                                <td align=left colspan=3 \".$critirio_td_style.\"></td> \n                            </tr>\";    \n                        }\n                        \n                        if($r[0]!=$critirion_general_id){\n                            $output .= \"\n                            <tr bgcolor=\".$color.\" \".$critirio_td_style.\"> \n                                <td align=left colspan=3 \".$critirio_td_style.\"><b><i><u>\".$r[4].\" :</u></i></b></td> \n                            </tr>\";    \n                        }\n                    \n                        $output .= \"\n                            <tr bgcolor=\".$color.\"  \".$critirio_td_style.\">\n                                <td width=30  \".$critirio_td_style.\"></td>\n                                <td align=left width=200  \".$critirio_td_style.\"><b><i>\".$r[5].\" :</i></b></td>\n                                <td align=left  \".$critirio_td_style.\">              \n 		                            \".($r[6]==\'\' ? \' - \' : $r[6]).\"\n                               </td>\n                            </tr>\n                            <tr bgcolor=\".$color.\"  \".$critirio_td_style.\">\n                                <td width=30  \".$critirio_td_style.\"></td>\n                                <td colspan=2  \".$critirio_td_style.\"><hr style=\\\"border: 0; height: 1px; background: black;\\\" width=100%></td>\n                            </tr>\n                            \";\n                        $critirion_general_id=$r[0];\n                    }\n                    $output .= \"\n                            <tr bgcolor=\".$color.\" height=10 \".$critirio_td_style.\"> \n                                <td align=left colspan=3  \".$critirio_td_style.\"></td> \n                            </tr>\n                        </table>\";\n                }        \n            $output .= \"                \n                    </td>\n                </tr>\";      \n            }\n        \n        \n            if(!(is_null($row[5])) && $row[5]!=\'\'){\n                $output .= \"\n                <tr bgcolor=\".$color.\" \".$table_style.\">\n                    <td colspan=4 height=5 \".$table_style.\">\n                    </td>\n                </tr> \n                <tr bgcolor=\".$color.\" \".$table_style.\">\n                    <td colspan=4 \".$table_style.\">\n                        <table border=0  cellspacing=0 width=100% \".$critirio_th_style.\">\n                            <tr bgcolor=\".$color.\" \".$critirio_td_style.\">\n                                <td align=left colspan=2  \".$critirio_td_style.\"><b><i><u>Παρατηρήσεις Καθηγητή :</u></i></b></td>\n                            </tr>\n                            <tr bgcolor=\".$color.\"  \".$critirio_td_style.\">\n                                <td width=30  \".$critirio_td_style.\"></td>\n                                <td align=left  \".$critirio_td_style.\">\".$row[5].\"</td>\n                            </tr>\n                        </table>   \n                    </td>\n                </tr>\n                <tr bgcolor=\".$color.\" \".$table_style.\">\n                    <td colspan=4 height=5 \".$table_style.\">\n                    </td>\n                </tr> \n                \";    \n            }\n                \n            $output .= \"                \n                <tr height=2 bgcolor=lightyellow \".$table_style.\">\n                    <td colspan=4 \".$table_style.\">\n                    </td>\n                </tr>\";\n        }\n        $output .= \"</table>\";\n    } else{\n        $output .= \"<b><i>Δεν ανακτήθηκαν τα δεδομένα!</i></b>\";\n    }\n\n    return $output;\n}\n\nprint \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n    </head>\n\n    <body>\n    \".show_mark_table(\'#RECORD_ID#\',\'#student_mark_grade_period_id#\').\"\n    </body>\n</html>\";','','0','2016-06-09 12:15:50','globeadmin','2016-06-18 22:39:50','globeadmin','2018-07-05 13:29:28','globeadmin','0'),('576309a50223f96','create_student_mark_email_list','Δημιουργεί τη λίστα των μαθητών με τα email τους για μαζική αποστολή της αξιολόγησης τους με email','teacher','print \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n        \n        <STYLE TYPE=\\\"text/css\\\">\n            .sisTable TH{\n                font-size:110%;\n            }\n        </STYLE>\n    </head>\n    <body onload=\\\"adjustIframeHeight()\\\">\";\n\n\n$sql=\"  SELECT \n            student.id,\n            grade.short_name,\n            concat(\n                student.registration_number,\n                \' -\',\n                if(student.surname is NULL,\'\',concat (\' \',student.surname)),\n                if(student.name is NULL,\'\',concat (\' \',student.name)),\n                if(student.fathers_name is NULL,\'\',concat (\'<br>πατ. \',student.fathers_name))\n            ),\n            TRIM(student.email),\n            TRIM(student.parent_email),\n            student.has_left_school\n            \n        FROM student\n        INNER JOIN grade on grade.id=student.grade_id \n        \";\n        \n\n\nif(\'#class_id#\'!=\'#\'.\'class_id#\' && \'#class_id#\'!=\'\'){\n    $sql=$sql.\" INNER JOIN student_class on (student_class.student_id=student.id AND student_class.class_id=\'#class_id#\')\n    \";\n}\n\n$sql=$sql.\"WHERE \n    \";\n    \nif(\'#student_id#\'!=\'#\'.\'student_id#\' && \'#student_id#\'!=\'\'){\n    $sql=$sql.\" (student.id = \'#student_id#\') and \n    \";\n}\n\nif(\'#grade_id#\'!=\'#\'.\'grade_id#\' && \'#grade_id#\'!=\'\'){\n    $sql=$sql.\" (student.grade_id = \'#grade_id#\') and \n    \";\n}\n\n$sql=$sql.\"\n    student.id in (select distinct mark.student_id from mark where mark.grading_period_id=\'#grading_period#\')\n    ORDER BY student.grade_id,student.surname,student.name,student.fathers_name\n\";\n   \n$retval = nuRunQuery($sql);\n\nif($retval) {\n    if(db_num_rows($retval)>0) {\n    \n        print (\"\n        <table cellspacing=0 CLASS=\\\"sisTable\\\">\n            <tr height=50>\n            \n                <th width=50 align=center>Τάξη</th>\n                <th width=300 align=center>Μαθητής</th>\n                \n                <th width=300 align=center>\n                    Email Μαθητή<br>\n                    Όλα<input type=\\\"checkbox\\\" id=\\\"all_chk_1\\\" title=\\\"Επιλογή Όλων\\\" onclick=\\\"toggle(this,\'chk_1\')\\\">\n                </th>\n                <th width=300 align=center>\n                    Email Γονέα<br>\n                    Όλα<input type=\\\"checkbox\\\" id=\\\"all_chk_2\\\" title=\\\"Επιλογή Όλων\\\" onclick=\\\"toggle(this,\'chk_2\')\\\">\n                </th>\n            </tr>\");\n            \n        while($row = db_fetch_row($retval)) {\n                \n            print (\"\n            <tr\".($row[5]==1 ? \" style=\\\"background-color:#EE82EE;\\\"\" : \"\").\" height=35>\n                <td align=center>\".(is_null($row[1]) || $row[1]==\'\'? \'&nbsp;\' : $row[1]).\"</td>\n                <td align=left>\".(is_null($row[2]) || $row[2]==\'\'? \'&nbsp;\' : $row[2]).\"</td>\");\n                \n                if(!is_null($row[3]) && $row[3]!=\'\'){\n                    if(filter_var($row[3], FILTER_VALIDATE_EMAIL)){\n                        print(\"\n                <td align=right>\".$row[3].\"<input type=\\\"checkbox\\\" CLASS=\\\"chk_1\\\" id=\\\"1,\".$row[0].\",\".$row[3].\"\\\" title=\\\"Επιλογή Email\\\" onclick=\\\"make_indeterminate(\'all_chk_1\')\\\"></td>\");\n                    } else {\n                        print(\"\n                <td style=\\\"background-color:red;\\\" align=right>\".$row[3].\"</td>\");\n                    }   \n                } else{\n                    print(\"\n                <td>&nbsp;</td>\");    \n                }\n\n                if(!is_null($row[4]) && $row[4]!=\'\'){\n                    if(filter_var($row[4], FILTER_VALIDATE_EMAIL)){\n                        print(\"\n                <td align=right>\".$row[4].\"<input type=\\\"checkbox\\\" CLASS=\\\"chk_2\\\" id=\\\"2,\".$row[0].\",\".$row[4].\"\\\" title=\\\"Επιλογή Email\\\" onclick=\\\"make_indeterminate(\'all_chk_2\')\\\"></td>\");\n                    } else {\n                        print(\"\n                <td style=\\\"background-color:red;\\\" align=right>\".$row[4].\"</td>\");\n                    }   \n                } else{\n                    print(\"\n                <td>&nbsp;</td>\");    \n                }\n                \n            print (\"\n            </tr>\");\n        }\n        print (\"\n        </table>\");\n    } else{\n        print (\"<span CLASS=\\\"msg\\\">Δε βρέθηκαν Μαθητές...</span>\");\n    }\n} else{\n    print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν δεδομένα...</span>\");\n}\nprint \"\n    </body>\n</html>\";\n','','0','2016-06-16 23:18:45','globeadmin','2018-07-15 23:03:50','globeadmin','2018-07-15 23:03:50','globeadmin','0'),('577bdc658c7b9a8','clear_tmp','Διαγράφει τα προσωρινά αρχεία','manager','function recursiveRemoveDirectory($directory){\n    $a=0;\n    foreach(glob(\"{$directory}/*\") as $file){\n        if(is_dir($file)) { \n            $a += recursiveRemoveDirectory($file);\n        } else {\n            unlink($file);\n            $a++;\n        }\n    }\n    rmdir($directory);\n    $a++;\n    return($a);\n}\n\nfunction countFiles($directory){\n    $a=0;\n    foreach(glob(\"{$directory}/*\") as $file){\n        if(is_dir($file)) { \n            $a += countFiles($file);\n        } else {\n            $a++;\n        }\n    }\n    $a++;\n    return($a);\n}\n\n$total_files = countFiles(\'tmp\')-1;\n$removed_files = 0;\n\n$files=glob(\'tmp/*\');\nforeach($files as $file){\n        if(is_dir($file)) { \n            $removed_files += recursiveRemoveDirectory($file);\n        } else {\n            if($file !=\'tmp/send_notification_log.txt\'){\n                unlink($file);\n                $removed_files++;\n            } else {\n                $total_files--;\n            }\n        }\n}\n\nif($total_files==0){\n    $nuParameters =  (\'Ο φάκελος είναι κενός! Δεν υπάρχουν αρχεία για διαγραφή!\');    \n}  else{\n    if($total_files==$removed_files){\n        $nuParameters = (\'Διαγράφησαν \'.$removed_files.\' αρχεία/φάκελοι!\');    \n    } else {\n        $nuParameters = (\'Διαγράφησαν \'.$removed_files.\' αρχεία-φάκελοι! Η διαγραφή απέτυχε για \'.($total_files-$removed_files).\' αρχεία/φακέλους!\');\n    }    \n}\n\n\n','','0','2016-07-05 19:12:21','globeadmin','2016-12-18 19:42:51','globeadmin','2019-07-27 10:12:10','globeadmin','0'),('577ec3a08a5bebe','search_email','Αναζήτηση email με συγκεκριμένα κριτήρια','teacher','print \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n\n        <STYLE TYPE=\\\"text/css\\\">\n            .sisTable TD{\n                font-size:7pt;\n            }\n        </STYLE>\n\n        <script type=\\\"text/javascript\\\">\n            function resend(email_id) {\n                if(confirm(\\\"Το email αυτό θα σταλεί ξανά! \\\\nΕίστε Σίγουρος;\\\")){\n                    parent.showLoader();\n                    parent.nuSetHash(\'email_id\',email_id);\n                    parent.nuAjax(\'resend_email\',\'display_sent_result\');\n                }\n            }\n            function show_email_info(email_id){\n                parent.nuOpenFormInFrame(\'59cfad675ee667a\',email_id);\n            }\n        </script>\n    </head>\n\n    <body onload=\\\"adjustIframeHeight()\\\">\";\n\n$sql=\"  SELECT\n            email.id,\n            DATE_FORMAT(email.sent_at,\'%d-%m-%Y %H:%i:%s\'),\n            if(email.sender_id=\'-1\',\'ΕΙΔΟΠΟΙΉΣΕΙΣ\',concat(if(sender.surname is NULL,\'\',sender.surname),if(sender.name is NULL,\'\',concat(\' \',sender.name)))) as sender_name,\n            concat(if(student.surname is NULL,\'\',student.surname),if(student.name is NULL,\'\',concat(\' \',student.name)),if(student.fathers_name is NULL,\'\',concat(\' πατ. \',student.fathers_name))) as student_name,\n            concat(if(teacher_recipient.surname is NULL,\'\',teacher_recipient.surname),if(teacher_recipient.name is NULL,\'\',concat(\' \',teacher_recipient.name))) as teacher_name,\n            email_address,\n            email_subject,\n            email_text,\n            IF(fail_code= \'0\',\'Στάλθηκε\',IF(fail_code= \'1\',\'Λάθος Διεύθυνση\',\'Απέτυχε\')),\n            fail_code,\n            ifNull(fail_comments,\'\'),\n            teacher_recipient.id\n        FROM email\n            LEFT JOIN teacher  AS sender                ON  email.sender_id   = sender.id\n            LEFT JOIN student                           ON  email.student_id  = student.id\n            LEFT JOIN teacher   AS teacher_recipient    ON  email.teacher_id  = teacher_recipient.id\n        WHERE\n\";\n\nif(\'#from_date#\'!=\'#\'.\'from_date#\' && \'#from_date#\'!=\'\'){\n    $sql=$sql.\" DATE_FORMAT(email.sent_at,\'%Y-%m-%d\') >= \'#from_date#\' and \n    \";\n}\nif(\'#to_date#\'!=\'#\'.\'to_date#\' && \'#to_date#\'!=\'\'){\n    $sql=$sql.\" DATE_FORMAT(email.sent_at,\'%Y-%m-%d\') <= \'#to_date#\' and \n    \";\n}\nif(\'#sender_id#\'!=\'#\'.\'sender_id#\' && \'#sender_id#\'!=\'\'){\n    \n    //if(\'#sender_id#\'!=\'#RECORD_ID#\' || \'#teacher_id#\'!=\'#RECORD_ID#\'){\n       $sql=$sql.\" email.sender_id = \'#sender_id#\' and \n    \";\n    //}\n}\nif(\'#state#\'!=\'#\'.\'state#\' && \'#state#\'!=\'\'){\n    $sql=$sql.\" email.fail_code = \'#state#\' and \n    \";\n}\nif(\'#student_id#\'!=\'#\'.\'student_id#\' && \'#student_id#\'!=\'\'){\n    $sql=$sql.\" (email.student_id = \'#student_id#\' OR email.student_id is NULL) and \n    \";\n}\nif(\'#teacher_id#\'!=\'#\'.\'teacher_id#\' && \'#teacher_id#\'!=\'\'){\n    $sql=$sql.\" (email.teacher_id = \'#teacher_id#\' OR email.teacher_id is NULL) and \n    \";\n}\n\n$sql=$sql.\"\n    1=1\n    order by email.sent_at,sender_name,student_name,teacher_name\n\";\n\n$retval=nuRunQuery($sql);\n\nif($retval) {\n    if(db_num_rows($retval)>0) {\n        print (\"\n        <table cellspacing=0 CLASS=\\\"sisTable\\\">\n            <tr height=45>\n                <th width=50 align=center>Ημερομηνία Ώρα</th>\n                <th width=150 align=center>Αποστολέας</th>\n                <th width=150 align=center>Παραλήπτης</th>\n                <th width=100 align=center>Διεύθυνση</th>\n                <th width=120 align=center>Θέμα</th>\n                <th width=170 align=center>Μήνυμα</th>\n                <th width=50 align=center>Κατάσταση</th>\n                <th width=100 align=center>Μήνυμα Αποτυχίας</th>\n                <th width=50 align=center>Πληρ/ρίες</th>\n                <th width=60 align=center>\n                    <b>Επιλογή</b><br>\n                    Όλα<input type=\\\"checkbox\\\" id=\\\"all_chk_1\\\" title=\\\"Επιλογή Όλων\\\" onclick=\\\"toggle(this,\'chk_1\')\\\" checked>\n                </th>\n                \n            </tr>\");\n        \n        $color_send             = \'LightBlue\';\n        $color_wrong_address    = \'red\';\n        $color_fail             = \'OrangeRed\';\n        \n        $color          = $color_send;\n    \n        $send           = 0;\n        $wrong_address  = 0;\n        $fail           = 0;\n        \n        \n        while($row = db_fetch_row($retval)) {\n            \n            if ($row[9]==\'0\'){\n                $send += 1;\n                $color = $color_send;\n            } elseif ($row[9]==\'1\') {\n                $wrong_address += 1;\n                $color = $color_wrong_address;\n            } else {\n                $fail += 1;\n                $color = $color_fail;\n            }\n\n            $email_address = (is_null($row[5]) || $row[5]==\'\'? \'&nbsp;\' : $row[5]);\n            \n            if($row[7]!=\'\'){\n                $plain_text = trim(strip_tags($row[7]));\n                $plain_text = (strlen($plain_text)>100 ? mb_substr($plain_text, 0, 100,\"UTF-8\").\"...\" : $plain_text);\n            } else {\n                $plain_text =  \'&nbsp;\';  \n            }\n            if(!is_null($row[11])){\n                if( \'#nu_user_group#\'!=\'globeadmin\' && \n                    \'#nu_user_group#\'!=\'Administrators\' && \n                    \'#nu_user_group#\'!=\'Managers\' && \n                    \'#nu_user_group#\'!=\'AssistManagers\' &&\n                    \'#nu_user_group#\'!=\'Secretaries\'){\n                    $email_address = str_repeat(\"*\", strlen($email_address));    \n                }    \n            }\n            \n            print (\"\n            <tr style=\\\"background-color:$color;\\\" height=35>\n                <td align=right>\".(is_null($row[1]) || $row[1]==\'\'? \'&nbsp;\' : $row[1]).\"</td>\n                <td align=left>\".(is_null($row[2]) || $row[2]==\'\'? \'&nbsp;\' : $row[2]).\"</td>\n                <td align=left>\".(is_null($row[3]) || $row[3]==\'\'? \'\' : $row[3]).(is_null($row[4]) || $row[4]==\'\'? \'\' : $row[4]).\"</td>\n                <td align=left>\".$email_address.\"</td>\n                <td align=left>\".(is_null($row[6]) || $row[6]==\'\'? \'&nbsp;\' : $row[6]).\"</td>\n                <td align=left>$plain_text</td>\n                <td align=center>\".(is_null($row[8]) || $row[8]==\'\'? \'&nbsp;\' : $row[8]).\n                (($row[9]==\'0\' || $row[9]==\'1\' ? \'\' : \" <img src=\\\"images/sendmail.png\\\" title=\\\"Αποστολή Ξανά\\\" width=20 onmousedown=\\\"resend(\".$row[0].\");\\\" onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"Restorecursor(this)\\\">\")).\"</td>\n                <td align=left>\".(is_null($row[10]) || $row[10]==\'\'? \'&nbsp;\' : $row[10]).\"</td>\n                \n                <td align=center title=\\\"Πληροφορίες/Επεξεργασία\\\" onclick=\\\"show_email_info(\".$row[0].\")\\\" onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\">\n                    <img width=16 height=16 src=\\\"images/info.png\\\">\n                </td>\n                \n                <td align=center><input type=\\\"checkbox\\\" CLASS=\\\"chk_1\\\" id=\\\"\".$row[0].\"\\\" title=\\\"Επιλογή Email\\\" onclick=\\\"make_indeterminate(\'all_chk_1\')\\\" checked></td>\n            </tr>\");\n        }\n        if($send>0){\n            print (\"\n            <tr height=25>\n                <th align=right colspan=8>Στάλθηκαν : </th>\n                <th align=right colspan=2>$send</th>\n            </tr>\");\n        }\n        \n        if($wrong_address>0){\n            print (\"\n            <tr height=25>\n                <th align=right colspan=8>Λάθος Διεύθυνση : </th>\n                <th align=right colspan=2>$wrong_address</th>\n            </tr>\");\n        }\n        \n        if($fail>0){\n            print (\"\n            <tr height=25>\n                <th align=right colspan=8>Απέτυχαν : </th>\n                <th align=right colspan=2>$fail</th>\n            </tr>\");\n        }\n        \n        print (\"\n            <tr height=25>\n                <th align=right colspan=8>Σύνολο : </th>\n                <th align=right colspan=2>\".($send+$wrong_address+$fail).\"</th>\n            </tr>\n        </table>\");\n    } else{\n        print (\"<span CLASS=\\\"msg\\\">Δε βρέθηκαν Email...</span>\");\n    }\n} else{\n    print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν δεδομένα...</span>\");\n}\nprint \"\n    </body>\n</html>\";\n','','0','2016-07-08 00:03:28','globeadmin','2018-07-16 10:45:02','globeadmin','2021-01-24 16:07:38','globeadmin','0'),('57811f7eb6d75f3','create_teacher_owe_mark_email_list','Δημιουργεί τη λίστα των καθηγητών που υπολοίπονται στην αξιολόγηση με τα email τους για μαζική αποστολή email','manager','$mark_required=1;\n\n$sql = \"SELECT grading_period.mark_required\n        FROM grading_period\n        INNER JOIN school ON school.grading_period_id = grading_period.id\";\n$rv_mark_required = nuRunQuery($sql);\n\nif($rv_mark_required){\n    if($row_mark_required = db_fetch_row($rv_mark_required)){\n        $mark_required =  $row_mark_required[0];\n    }\n}\n\n$sql=\"DROP TEMPORARY TABLE IF EXISTS #TABLE_ID#\";\nnuRunQuery($sql);\n\n$sql=\"CREATE TEMPORARY TABLE #TABLE_ID# DEFAULT CHARACTER SET=utf8\n    SELECT distinct\n        card.teacher_id 	AS teacher_id,\n		card.subject_id 	AS subject_id,\n		card.class_id 		AS class_id\n	FROM card\n	inner join subject 			on card.subject_id = subject.id\n	WHERE card.valid_from = (SELECT max(timetable.start_date) FROM timetable) AND\n	    subject.is_marked=true\nORDER BY \n	teacher_id,subject_id,class_id\";\nnuRunQuery($sql);\n\n                    // Βρίσκει τα μαθήματα για τα οποία έχει κατατεθεί βαθμολογία (σε έστω ένα μαθητή με >0)\n$sql=\"CREATE TEMPORARY TABLE #TABLE_ID#_2 DEFAULT CHARACTER SET=utf8\n    select distinct \n            subject_id,class_id \n    from mark,school\n    where \n            mark.grading_period_id=school.grading_period_id\n    group by subject_id,class_id\n    having sum(value)>0\";\nnuRunQuery($sql);\n\nif($mark_required==1){\n                    // Βρίσκει τα μαθήματα για τα οποία δεν έχει κατατεθεί για κανένα μαθητή (κενό για όλο το τμήμα)\n    $sql=\"CREATE TEMPORARY TABLE #TABLE_ID#_3 DEFAULT CHARACTER SET=utf8\n        select distinct \n            subject_id,class_id \n        from mark,school\n        where \n            mark.grading_period_id=school.grading_period_id\n        group by subject_id,class_id\n        having sum(if(value is NULL,0,1))=0\";\n    nuRunQuery($sql);\n\n    $sql=\"delete from #TABLE_ID# where (subject_id,class_id) in (select subject_id,class_id from #TABLE_ID#_3)\";\n    nuRunQuery($sql);    \n} else {\n                    // Βρίσκει τα μαθήματα για τα οποία έχουν κατατεθεί σχόλια (σε έστω ένα μαθητή)\n    $sql=\"CREATE TEMPORARY TABLE #TABLE_ID#_4 DEFAULT CHARACTER SET=utf8\n        SELECT  DISTINCT subject_id,class_id \n        FROM mark\n        INNER JOIN school ON mark.grading_period_id=school.grading_period_id\n        WHERE (mark.comments IS NOT NULL) AND (TRIM(mark.comments)<>\'\')\n            \";    \n    nuRunQuery($sql);\n\n                    // Βρίσκει τα μαθήματα για τα οποία έχει κατατεθεί περιγραφική αξιολόγηση (σε έστω ένα μαθητή)\n    $sql=\"CREATE TEMPORARY TABLE #TABLE_ID#_5 DEFAULT CHARACTER SET=utf8\n        SELECT  DISTINCT subject_id,class_id \n        FROM mark\n        INNER JOIN school ON mark.grading_period_id=school.grading_period_id\n        INNER JOIN mark_critirion_special_level ON mark.id = mark_critirion_special_level.mark_id\n        WHERE mark_critirion_special_level.critirion_special_level_id IS NOT NULL\n            \";    \n    nuRunQuery($sql);\n\n    $sql=\"delete from #TABLE_ID# where (subject_id,class_id) in (select subject_id,class_id from #TABLE_ID#_4)\";\n    nuRunQuery($sql);\n    \n    $sql=\"delete from #TABLE_ID# where (subject_id,class_id) in (select subject_id,class_id from #TABLE_ID#_5)\";\n    nuRunQuery($sql);\n}\n\n$sql=\"delete from #TABLE_ID# where (subject_id,class_id) in (select subject_id,class_id from #TABLE_ID#_2)\";\nnuRunQuery($sql);\n\nprint \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n        \n        <STYLE TYPE=\\\"text/css\\\">\n            .sisTable TH{\n                font-size:1.1em;\n            }\n        </STYLE>\n    </head>\n    <body onload=\\\"adjustIframeHeight()\\\">\";\n\n\n$sql=\"  SELECT \n            teacher.id,\n            concat(\n                if(teacher.surname is NULL,\'\',concat (teacher.surname,\' \')),\n                ifNULL(teacher.name,\'\')\n            ),\n            \'\',\n            TRIM(teacher.email),\n            TRIM(zzzsys_user.sus_email)\n        FROM teacher\n        LEFT JOIN zzzsys_user ON teacher.user_id=zzzsys_user.zzzsys_user_id\n        WHERE teacher.id in (select distinct teacher_id from #TABLE_ID#)\n        ORDER BY teacher.surname,teacher.name\n        \";\n\n\n$retval = nuRunQuery($sql);\n\nif($retval) {\n    if(db_num_rows($retval)>0) {\n    \n        print (\"\n        <table cellspacing=0 CLASS=\\\"sisTable\\\" align=center>\n            <tr height=50>\n                <th width=350 align=center>Καθηγητής</th>\n                <th width=300 align=center>Email Καθηγητή<br>\n                    Όλα<input type=\\\"checkbox\\\" id=\\\"all_chk_1\\\" title=\\\"Επιλογή Όλων\\\" onclick=\\\"toggle(this,\'chk_1\')\\\">\n                </th>\n                <th width=300 align=center>Email Λογαριασμού<br>\n                    Όλα<input type=\\\"checkbox\\\" id=\\\"all_chk_2\\\" title=\\\"Επιλογή Όλων\\\" onclick=\\\"toggle(this,\'chk_2\')\\\">\n                </th>\n            </tr>\");\n        \n        while($row = db_fetch_row($retval)) {\n                \n            print (\"  \n            <tr bgcolor=LightBlue height=30>\n                <td align=left>\".(is_null($row[1]) || $row[1]==\'\'? \'&nbsp;\' : $row[1]).\"</td>\");\n                \n                if(!is_null($row[3]) && $row[3]!=\'\'){\n                    if(filter_var($row[3], FILTER_VALIDATE_EMAIL)){\n                        print(\"\n                <td align=right>\".$row[3].\"<input type=\\\"checkbox\\\" CLASS=\\\"chk_1\\\" id=\\\"1,\".$row[0].\",\".$row[3].\"\\\" title=\\\"Επιλογή Email\\\" onclick=\\\"make_indeterminate(\'all_chk_1\')\\\"></td>\");\n                    } else {\n                        print(\"\n                <td style=\\\"background-color:red;\\\" align=right>\".$row[3].\"</td>\");\n                    }   \n                } else{\n                    print(\"\n                <td>&nbsp;</td>\");    \n                }\n\n                if(!is_null($row[4]) && $row[4]!=\'\'){\n                    if(filter_var($row[4], FILTER_VALIDATE_EMAIL)){\n                        print(\"\n                <td align=right>\".$row[4].\"<input type=\\\"checkbox\\\" CLASS=\\\"chk_2\\\" id=\\\"2,\".$row[0].\",\".$row[4].\"\\\" title=\\\"Επιλογή Email\\\" onclick=\\\"make_indeterminate(\'all_chk_2\')\\\"></td>\");\n                    } else {\n                        print(\"\n                <td style=\\\"background-color:red;\\\" align=right>\".$row[4].\"</td>\");\n                    }   \n                } else{\n                    print(\"\n                <td>&nbsp;</td>\");    \n                }\n            print (\"\n            </tr>\");\n        }\n        print (\"\n        </table>\");\n    } else{\n        print (\"<span CLASS=\\\"msg\\\">Δε βρέθηκαν Καθηγητές...</span>\");\n    }\n} else{\n    print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν δεδομένα...</span>\");\n}\nprint \"\n    </body>\n</html>\";\n','','0','2016-07-09 18:59:58','globeadmin','2018-07-15 00:46:16','globeadmin','2021-02-26 22:59:33','globeadmin','0'),('57815cda5c980f5','create_teacher_owe_mark_sms_list','Δημιουργεί τη λίστα των καθηγητών με υπολειπόμενη αξιολόγηση με τα τηλέφωνα τους για μαζική αποστολή sms','manager','function validate_phone_number($phone_text){\n    \n    //eliminate every char except 0-9\n    $justNums = preg_replace(\"/[^0-9]/\", \'\', $phone_text);\n\n    if (strlen($justNums) == 12){ // it\'s probably a valid phone number with country code in front\n        return(\"+\".$justNums);    \n    } elseif (strlen($justNums) == 10){ // it\'s probably a valid greek phone number\n        return(\"+30\".$justNums);\n    } else {\n        return;\n    }\n}\n\n$mark_required=1;\n\n$sql = \"SELECT grading_period.mark_required\n        FROM grading_period\n        INNER JOIN school ON school.grading_period_id = grading_period.id\";\n$rv_mark_required = nuRunQuery($sql);\n\nif($rv_mark_required){\n    if($row_mark_required = db_fetch_row($rv_mark_required)){\n        $mark_required =  $row_mark_required[0];\n    }\n}\n\n$sql=\"DROP TEMPORARY TABLE IF EXISTS #TABLE_ID#\";\nnuRunQuery($sql);\n\n$sql=\"CREATE TEMPORARY TABLE #TABLE_ID# DEFAULT CHARACTER SET=utf8\n    SELECT distinct\n        card.teacher_id 	AS teacher_id,\n		card.subject_id 	AS subject_id,\n		card.class_id 		AS class_id\n	FROM card\n	inner join subject 			on card.subject_id = subject.id\n	WHERE card.valid_from = (SELECT max(timetable.start_date) FROM timetable) AND\n	    subject.is_marked=true\nORDER BY \n	teacher_id,subject_id,class_id\";\nnuRunQuery($sql);\n\n                    // Βρίσκει τα μαθήματα για τα οποία έχει κατατεθεί βαθμολογία (σε έστω ένα μαθητή με >0)\n$sql=\"CREATE TEMPORARY TABLE #TABLE_ID#_2 DEFAULT CHARACTER SET=utf8\n    select distinct \n            subject_id,class_id \n    from mark,school\n    where \n            mark.grading_period_id=school.grading_period_id\n    group by subject_id,class_id\n    having sum(value)>0\";\nnuRunQuery($sql);\n\nif($mark_required==1){\n                    // Βρίσκει τα μαθήματα για τα οποία δεν έχει κατατεθεί για κανένα μαθητή (κενό για όλο το τμήμα)\n    $sql=\"CREATE TEMPORARY TABLE #TABLE_ID#_3 DEFAULT CHARACTER SET=utf8\n        select distinct \n            subject_id,class_id \n        from mark,school\n        where \n            mark.grading_period_id=school.grading_period_id\n        group by subject_id,class_id\n        having sum(if(value is NULL,0,1))=0\";\n    nuRunQuery($sql);\n\n    $sql=\"delete from #TABLE_ID# where (subject_id,class_id) in (select subject_id,class_id from #TABLE_ID#_3)\";\n    nuRunQuery($sql);    \n} else {\n                    // Βρίσκει τα μαθήματα για τα οποία έχουν κατατεθεί σχόλια (σε έστω ένα μαθητή)\n    $sql=\"CREATE TEMPORARY TABLE #TABLE_ID#_4 DEFAULT CHARACTER SET=utf8\n        SELECT  DISTINCT subject_id,class_id \n        FROM mark\n        INNER JOIN school ON mark.grading_period_id=school.grading_period_id\n        WHERE (mark.comments IS NOT NULL) AND (TRIM(mark.comments)<>\'\')\n            \";    \n    nuRunQuery($sql);\n\n                    // Βρίσκει τα μαθήματα για τα οποία έχει κατατεθεί περιγραφική αξιολόγηση (σε έστω ένα μαθητή)\n    $sql=\"CREATE TEMPORARY TABLE #TABLE_ID#_5 DEFAULT CHARACTER SET=utf8\n        SELECT  DISTINCT subject_id,class_id \n        FROM mark\n        INNER JOIN school ON mark.grading_period_id=school.grading_period_id\n        INNER JOIN mark_critirion_special_level ON mark.id = mark_critirion_special_level.mark_id\n        WHERE mark_critirion_special_level.critirion_special_level_id IS NOT NULL\n            \";    \n    nuRunQuery($sql);\n\n    $sql=\"delete from #TABLE_ID# where (subject_id,class_id) in (select subject_id,class_id from #TABLE_ID#_4)\";\n    nuRunQuery($sql);\n    \n    $sql=\"delete from #TABLE_ID# where (subject_id,class_id) in (select subject_id,class_id from #TABLE_ID#_5)\";\n    nuRunQuery($sql);\n}\n\n$sql=\"delete from #TABLE_ID# where (subject_id,class_id) in (select subject_id,class_id from #TABLE_ID#_2)\";\nnuRunQuery($sql);\n\n\nprint \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n        \n        <STYLE TYPE=\\\"text/css\\\">\n            .sisTable TH{\n                font-size:1.1em;\n            }\n        </STYLE>\n\n        <script>\n            function toggle69(source,class_name) {\n                checkboxes = document.getElementsByClassName(class_name);\n                for(var i=0, n=checkboxes.length;i<n;i++) {\n                    id_name = checkboxes[i].id;\n                    if (id_name.indexOf(\\\"+3069\\\") >= 0){\n                        checkboxes[i].checked = source.checked;\n                    }\n                }\n            }\n\n            function make_indeterminate(chk_name,phone_number) {\n                var all_chk = document.getElementById(chk_name);\n                all_chk.indeterminate = true;\n                if (phone_number.indexOf(\\\"+3069\\\") >= 0){\n                    var all_chk69 = document.getElementById(chk_name+\\\"69\\\");\n                    all_chk69.indeterminate = true;\n                }\n            }\n        </script>\n    </head>\n    <body onload=\\\"adjustIframeHeight()\\\">\";\n\n\n$sql=\"  SELECT \n            teacher.id,\n            concat(\n                if(teacher.surname is NULL,\'\',concat (teacher.surname,\' \')),\n                ifNULL(teacher.name,\'\')\n            ),\n            \'\',\n            teacher.mobile,\n            teacher.phone1,\n            teacher.phone2\n        FROM teacher\n        WHERE teacher.id in (select distinct teacher_id from #TABLE_ID#)\n        ORDER BY teacher.surname,teacher.name\n        \";\n        \n$retval = nuRunQuery($sql);\n\nif($retval) {\n    if(db_num_rows($retval)>0) {\n    \n        print (\"\n        <table cellspacing=0 CLASS=\\\"sisTable\\\" align=center>\n            <tr height=35>\n                <th width=350 align=center>Καθηγητής</th>\n                \n                <th width=180 align=center>Κινητό<br>\n                    Όλα<input type=\\\"checkbox\\\" id=\\\"all_chk_1\\\" title=\\\"Επιλογή Όλων\\\" onclick=\\\"toggle(this,\'chk_1\')\\\">\n                    69...<input CLASS=\\\"chk_1\\\" type=\\\"checkbox\\\" id=\\\"all_chk_169\\\" title=\\\"Επιλογή Όλων των 69...\\\" onclick=\\\"toggle69(this,\'chk_1\')\\\">\n                </th>\n                \n                <th width=180 align=center>Τηλέφωνο 1<br>\n                    Όλα<input type=\\\"checkbox\\\" id=\\\"all_chk_2\\\" title=\\\"Επιλογή Όλων\\\" onclick=\\\"toggle(this,\'chk_2\')\\\">\n                    69...<input CLASS=\\\"chk_2\\\" type=\\\"checkbox\\\" id=\\\"all_chk_269\\\" title=\\\"Επιλογή Όλων των 69...\\\" onclick=\\\"toggle69(this,\'chk_2\')\\\">\n                </th>\n                \n                <th width=180 align=center>Τηλέφωνο 2<br>\n                    Όλα<input type=\\\"checkbox\\\" id=\\\"all_chk_3\\\" title=\\\"Επιλογή Όλων\\\" onclick=\\\"toggle(this,\'chk_3\')\\\">\n                    69...<input CLASS=\\\"chk_3\\\" type=\\\"checkbox\\\" id=\\\"all_chk_369\\\" title=\\\"Επιλογή Όλων των 69...\\\" onclick=\\\"toggle69(this,\'chk_3\')\\\">\n                </th>\n            </tr>\");\n        \n        while($row = db_fetch_row($retval)) {\n                \n            print (\"\n            <tr height=29>\n                <td align=left>\".(is_null($row[1]) || $row[1]==\'\'? \'&nbsp;\' : $row[1]).\"</td>\");\n                \n                if(!is_null($row[3]) && $row[3]!=\'\'){\n                    if($nb=validate_phone_number($row[3])){\n                        print(\"\n                <td align=right title=\\\"\".$nb.\"\\\">\".$row[3].\"<input type=\\\"checkbox\\\" CLASS=\\\"chk_1\\\" id=\\\"1_\".$row[0].\"_\".$nb.\"\\\" title=\\\"Επιλογή Τηλεφώνου\\\" onclick=\\\"make_indeterminate(\'all_chk_1\',\'\".$nb.\"\')\\\"></td>\");\n                    } else {\n                        print(\"\n                <td style=\\\"background-color:red;\\\" align=right>\".$row[3].\"</td>\");\n                    }   \n                } else{\n                    print(\"\n                <td>&nbsp;</td>\");    \n                }\n\n                if(!is_null($row[4]) && $row[4]!=\'\'){\n                    if($nb=validate_phone_number($row[4])){\n                        print(\"\n                <td align=right title=\\\"\".$nb.\"\\\">\".$row[4].\"<input type=\\\"checkbox\\\" CLASS=\\\"chk_2\\\" id=\\\"1_\".$row[0].\"_\".$nb.\"\\\" title=\\\"Επιλογή Τηλεφώνου\\\" onclick=\\\"make_indeterminate(\'all_chk_2\',\'\".$nb.\"\')\\\"></td>\");\n                    } else {\n                        print(\"\n                <td style=\\\"background-color:red;\\\" align=right>\".$row[4].\"</td>\");\n                    }   \n                } else{\n                    print(\"\n                <td>&nbsp;</td>\");    \n                }\n                \n                if(!is_null($row[5]) && $row[5]!=\'\'){\n                    if($nb=validate_phone_number($row[5])){\n                        print(\"\n                <td align=right title=\\\"\".$nb.\"\\\">\".$row[5].\"<input type=\\\"checkbox\\\" CLASS=\\\"chk_3\\\" id=\\\"1_\".$row[0].\"_\".$nb.\"\\\" title=\\\"Επιλογή Τηλεφώνου\\\" onclick=\\\"make_indeterminate(\'all_chk_3\',\'\".$nb.\"\')\\\"></td>\");\n                    } else {\n                        print(\"\n                <td style=\\\"background-color:red;\\\" align=right>\".$row[5].\"</td>\");\n                    }   \n                } else{\n                    print(\"\n                <td>&nbsp;</td>\");    \n                }\n                \n            print (\"\n            </tr>\");\n        }\n        \n        print (\"\n        </table>\");\n    } else{\n        print (\"<span CLASS=\\\"msg\\\">Δε βρέθηκαν Καθηγητές...</span>\");\n    }\n} else{\n    print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν δεδομένα...</span>\");\n}\nprint \"\n    </body>\n</html>\";\n','','0','2016-07-09 23:21:46','globeadmin','2018-07-15 00:47:39','globeadmin','2020-10-18 00:27:02','globeadmin','0'),('5788d1d89374f2b','find_teacher_period','Βρίσκει τις ώρες διδασκαλιών ενός καθηγητή μιας συγκεκριμένης ημερομηνίας','teacher','if(\'#absence_date#\'!=\'\' && \'#absence_date#\'!=\'#\'.\'absence_date#\'){\n    $sql=\"SELECT distinct \n        period.id , \n        period.short_name\n    FROM period\n    INNER JOIN card on card.period_id = period.id\n    INNER JOIN school ON school.id = 1\n    INNER JOIN school_year ON school_year.id = school.school_year_id\n    WHERE \n        card.teacher_id = \'#RECORD_ID#\' AND\n        card.valid_from = (select max(start_date) from timetable where start_date <= \'#absence_date#\') AND\n        card.day_id = DAYOFWEEK(\'#absence_date#\')-2 AND\n        \'#absence_date#\' between school_year.start_date AND school_year.end_date AND\n        \'#absence_date#\' NOT IN (select holiday.holiday from holiday)\n    ORDER BY period.id \";\n    \n    $retval = nuRunQuery($sql);\n    $data_array =  array();\n    $nuParameters = \'\';\n\n    if($retval){\n\n        while($row = db_fetch_row($retval)) {\n            $data_array[]= $row;      \n        }\n    \n        $json_string = json_encode($data_array);\n        $nuParameters = $json_string;\n    }\n} else {\n    $nuParameters = \'\';\n}','','0','2016-07-15 15:06:48','globeadmin','2016-07-16 14:57:41','globeadmin','2016-07-17 16:35:11','globeadmin','0'),('5788d587dcb311f','find_teacher_class','Βρίσκει τμήματα που έχει μάθημα ένας καθηγητής μια συγκεκριμένη ημερομηνία και ώρα','teacher','if(\'#absence_date#\'!=\'\' && \'#absence_date#\'!=\'#\'.\'absence_date#\' && \'#absence_period_id#\'!=\'\' && \'#absence_period_id#\'!=\'#\'.\'absence_period_id#\'){\n\n    $sql=\"SELECT distinct \n        class.id,\n        class.short_name\n    FROM class\n    INNER JOIN card on card.class_id = class.id\n    INNER JOIN school ON school.id = 1\n    INNER JOIN school_year ON school_year.id = school.school_year_id\n    WHERE \n        card.teacher_id = \'#RECORD_ID#\' AND\n        card.valid_from = (select max(start_date) from timetable where start_date <= \'#absence_date#\') AND\n        card.day_id = DAYOFWEEK(\'#absence_date#\')-2 AND\n        card.period_id = \'#absence_period_id#\' AND\n        \'#absence_date#\' between school_year.start_date AND school_year.end_date AND\n        \'#absence_date#\' NOT IN (select holiday.holiday from holiday)\n    ORDER BY class.short_name \";\n    \n    $retval = nuRunQuery($sql);\n    $data_array =  array();\n    $nuParameters = \'\';\n\n    if($retval){\n\n        while($row = db_fetch_row($retval)) {\n            $data_array[]= $row;      \n        }\n    \n        $json_string = json_encode($data_array);\n        $nuParameters = $json_string;\n    }\n} else {\n    $nuParameters = \'\';\n}','','0','2016-07-15 15:22:31','globeadmin','2016-07-16 15:00:28','globeadmin','2017-09-01 18:20:34','globeadmin','0'),('578a2334d076529','create_absence_period_table_open','Δημιουργία ΑΝΟΙΧΤΟΥ απουσιολογίου τμήματος μιας μόνο ώρας','teacher','function have_adsence($absence_array, $student_id){\n    foreach ($absence_array as $absence) {\n        if($absence[0]==$student_id){\n                return $absence;\n        }\n    }\n    return false;\n}\n\nfunction have_penalty($penalty_array, $student_id){\n    foreach ($penalty_array as $penalty) {\n        if($penalty[2]==$student_id){\n                return $penalty;\n        }\n    }\n    return false;\n}\n\nprint \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n\n        <STYLE TYPE=\\\"text/css\\\">\n            .sisTable TD{\n                font-size:10pt;\n                border-color:#595959;\n            }\n            .sisTable TH{\n                font-size:12pt;\n                border-color:#595959;\n            }\n            \n            .clock {\n                font-family: courier, sans-serif;\n                font-weight: bold;\n                color: #aa1111;\n                background-color: lightYellow;\n                font-size: 16px;\n                border-radius: 5%;\n                margin-right: 10px;\n                padding-top: 2px;\n                padding-right: 5px;\n                padding-bottom:0px;\n                padding-left: 5px;\n            }\n        </STYLE>\n\n        <script type=\\\"text/javascript\\\">\n\n            var start_time = 0;\n            var total_time = 0;\n            parent.disable_setbtn();\n            var TableBackgroundNormalColor = \\\"LightBlue\\\";\n            var TableBackgroundMouseoverColor = \\\"Gold\\\";\n\n            function ChangeBackgroundColor(cell) {\n                cell.style.cursor=\\\"pointer\\\";\n                cell.parentNode.style.backgroundColor = TableBackgroundMouseoverColor;\n            }\n\n            function RestoreBackgroundColor(cell) {\n                cell.style.cursor=\\\"auto\\\";\n                cell.parentNode.style.backgroundColor = TableBackgroundNormalColor; \n            } \n\n            function add_adsence(student_id, period_id, class_id){\n                if(confirm(\\\"Θα επιβληθεί η ποινή της ωριαίας απομάκρυνσης στο μαθητή! Είστε σίγουρος;\\\")){\n                    var ids=student_id+\\\"_\\\"+period_id+\\\"_\\\"+\\\"2\\\";                  //create ids         \n        \n                    parent.nuSetHash(\'absence_id_list\',ids);\n                    //parent.nuSetHash(\'absence_class_id\',class_id);\n                    //parent.nuSetHash(\'absence_period_id\',period_id);\n        \n                    parent.nuAjax(\'add_student_absence\',\'foo\');// Καταχώριση Απουσίας\n                    parent.nuRunPHP(\'create_absence_period_table_open\',\'period_absence_iframe\'); // Επαναφόρτωση Απουσιολογίου\n                }\n            }\n            \n            function add_after_student_absence(student_id, student_name, period_id) {\n    \n                if(confirm(\'Θα καταχωρίσετε -εκ των υστέρων, σε κλειστό απουσιολόγιο- απουσία σε μαθητή.\\\\nΜετά την καταχώριση, το απουσιολόγιο θα επαναφορτωθεί.\\\\n\\\\nΕίστε σίγουρος;\')){\n                    parent.s_id = student_id;\n                    parent.s_name = student_name;\n                    parent.p_id = period_id;\n                    parent.nuOpenFormInFrame(\'5812516a1bf18a5\',\'#RECORD_ID#\');\n                }\n            }            \n\n            function add_penalty(student_id, student_name){\n                //if(confirm(\\\"Θα υποβληθεί παταρήρηση-ποινή  για το μαθητή! Είστε σίγουρος;\\\")){\n                    parent.s_id = student_id;\n                    parent.s_name = student_name;\n                    parent.nuOpenFormInFrame(\'580ba2a48260384\',\'-1\');\n                //}\n            }\n\n            function add_comment(student_id, student_name, subject_id, subject_name){\n                if(subject_id != -1){\n                    parent.s_id = student_id;\n                    parent.s_name = student_name;\n                    parent.sb_id = subject_id;\n                    parent.sb_name = subject_name;\n                    parent.nuOpenFormInFrame(\'5c838179bfcf3d0\',\'#RECORD_ID#\');\n                } else {\n                    alert(\'Η διδακτική ώρα αφορά περισσότερα του ενός μαθήματα! Δεν μπορείτε να κάνετε σχολιασμό!\');\n                }\n            }\n            \n            function add_reward(student_id, student_name, subject_id, subject_name){\n                if(subject_id != -1){\n                    parent.s_id = student_id;\n                    parent.s_name = student_name;\n                    parent.sb_id = subject_id;\n                    parent.sb_name = subject_name;\n                    parent.nuOpenFormInFrame(\'616c8bafd921bae\',\'-1\');\n                } else {\n                    alert(\'Η διδακτική ώρα αφορά περισσότερα του ενός μαθήματα! Δεν μπορείτε να εισάγετε επιβράβευση από τη φόρμα διδασκαλίας!\');\n                }\n            }\n            \n            \n            function countdownTime(seconds){\n                if(seconds>0){\n                    var today = new Date();\n                    start_time = today.getHours()*3600 + today.getMinutes()*60 + today.getSeconds();\n                    total_time = seconds;\n                    \n                    var x = setInterval(function() {\n                    \n                        var curday = new Date();\n                        var time_left = total_time - ((curday.getHours()*3600 + curday.getMinutes()*60 + curday.getSeconds())-start_time)\n                    \n                        if(time_left>0){\n                            var minutes = Math.floor(time_left / 60);\n                            var seconds = Math.floor(time_left % 60);\n                            document.getElementById(\\\"counter\\\").innerHTML = (minutes<10 ? \\\"0\\\"+minutes : minutes) + \\\":\\\" + (seconds<10 ? \\\"0\\\"+seconds : seconds);\n                            time_left--;\n                        } else {\n                            clearInterval(x);\n                            document.getElementById(\\\"counter\\\").innerHTML = \\\"00:00\\\";    \n                        }\n                    }, 1000);\n                }\n            }\n\n            \n            var absence_reason_array = [];\n            absence_reason_array.push([\\\"0\\\", \\\"Παρών\\\" , \\\"Π\\\"]);\";\n\n$sql=\"SELECT * FROM absence_reason\";\n$retval=nuRunQuery($sql);\nwhile($reason_row=db_fetch_row($retval)){\n    print \"\n            absence_reason_array.push([\\\"\".$reason_row[0].\"\\\", \\\"\".$reason_row[1].\"\\\", \\\"\".$reason_row[2].\"\\\"]);\";\n}\n\nprint \"\n            function change_state(cell,evt) {\n\n                var res = cell.id.split(\\\"_\\\");\n                var prev_index = parseInt(res[2]);\n    \n                evt = evt || window.event;\n                var button = evt.which || evt.button;\n    \n                if(button==3){\n                    new_index = prev_index-1;\n                    if (new_index<0) {\n                        new_index = absence_reason_array.length-1;\n                    }        \n                } else {\n                    new_index = prev_index+1;\n                    if (new_index>=absence_reason_array.length) {\n                        new_index=0;\n                    }    \n                }\n    \n                cell.innerHTML = absence_reason_array[new_index][2];\n                cell.id=res[0]+\\\"_\\\"+res[1]+\\\"_\\\"+new_index;\n    \n                if(new_index==0){\n                    n=parseInt(document.getElementById(\'num_of_students\').innerHTML);\n                    n++;\n                    document.getElementById(\'num_of_students\').innerHTML=n.toString();    \n                } else if(prev_index==0) {\n                    n=parseInt(document.getElementById(\'num_of_students\').innerHTML);\n                    n--;\n                    document.getElementById(\'num_of_students\').innerHTML=n.toString();       \n                }\n    \n                if(new_index==0){\n                    cell.style.backgroundColor = \\\"lightGreen\\\";\n                } else if(new_index==1) {\n                    cell.style.backgroundColor = \\\"OrangeRed\\\";\n                } else if(new_index==2) {\n                    cell.style.backgroundColor = \\\"Magenta\\\";\n                } else if(new_index==3) {\n                    cell.style.backgroundColor = \\\"FireBrick\\\";\n                } else {\n                    cell.style.backgroundColor = \\\"Red\\\";\n                }\n                cell.title=absence_reason_array[new_index][1];\n            }\n        </script>\n    </head>\n\n    <body oncontextmenu=\\\"return false;\\\" onload=\\\"adjustIframeHeight()\\\">\";\n\nif (\'#absence_date#\'==\'#\'.\'absence_date\'.\'#\' || \'#absence_date#\'==\'\'){\n    print \"\n        <span CLASS=\\\"msg\\\">Παρακαλώ επιλέξτε «Ημερομηνία»...</span>\";\n} elseif (\'#absence_period_id#\'==\'#\'.\'absence_period_id\'.\'#\' || \'#absence_period_id#\'==\'\'){\n    print \"\n        <span CLASS=\\\"msg\\\">Παρακαλώ επιλέξτε «Ώρα»...</span>\";\n} elseif (\'#absence_class_id#\'==\'#\'.\'absence_class_id\'.\'#\' || \'#absence_class_id#\'==\'\'){\n    print \"\n        <span CLASS=\\\"msg\\\">Παρακαλώ επιλέξτε «Τμήμα»...</span>\";\n} else{\n\n    $sql = \"SELECT add_absence_later FROM school WHERE id=1\";\n    $retval = nuRunQuery($sql);\n    $row = db_fetch_row($retval);\n    $add_absence_later = $row[0];\n\n    $curdate    = date(\'Y-m-d\');\n    \n    $sql        = \" select id,TIME_TO_SEC(SUBTIME(period.end_time,CURTIME()))\n                    from period\n                    where CURTIME() between period.start_time and period.end_time\n                    limit 1\";\n    $retval_curperiod=nuRunQuery($sql);\n    \n    $curperiod = \'-1\';\n    $time_left = 0;\n    if($retval_curperiod){\n        if(db_num_rows($retval_curperiod)==1){\n            $row_curperiod = db_fetch_row($retval_curperiod);\n            $curperiod = $row_curperiod[0];\n            $time_left = $row_curperiod[1];\n        }\n    }\n    \n    $sql        = \" select ifNULL(max(id),-1)\n                    from period\n                    where CURTIME()>=period.start_time\";\n    $retval_lastperiod=nuRunQuery($sql);\n    \n    $lastperiod = \'-1\';\n    \n    if($retval_lastperiod){\n            $row_lastperiod = db_fetch_row($retval_lastperiod);\n            $lastperiod = $row_lastperiod[0];\n    }\n    \n    $absence_date = \'#absence_date#\';\n    $day_of_week = idate(\'w\', strtotime($absence_date))-1;\n    \n    if($absence_date<$curdate || ($absence_date==$curdate && \'#absence_period_id#\'<=$lastperiod)) {\n    \n    $sql=\"  SELECT period.name,TIME_FORMAT(period.start_time, \'%H:%i\'),TIME_FORMAT(period.end_time, \'%H:%i\')\n            FROM period\n            WHERE id=\'#absence_period_id#\'\";\n    $retval_period=nuRunQuery($sql);\n    \n    $sql=\"  SELECT short_name \n            FROM class \n            WHERE id=\'#absence_class_id#\'\";\n    $retval_class=nuRunQuery($sql);\n    \n    if($retval_period && $retval_class){\n        if(db_num_rows($retval_period)==1){\n            if(db_num_rows($retval_class)==1){\n            \n                $row_class  = db_fetch_row($retval_class);\n                $class_name = $row_class[0];\n                $class_id   = \'#absence_class_id#\';\n                \n                $row_period =db_fetch_row($retval_period);\n                $period_name=$row_period[0];\n                $period_start=$row_period[1];\n                $period_end=$row_period[2];\n                $period_id  =\'#absence_period_id#\';\n                                                               // Βρίσκω τις διδασκαλίες του τμήματος τη συγκρκριμένη μέρα και ώρα\n                $sql=\"SELECT \n	                                active_card.id 				AS id,\n	                                teacher.short_name 			AS teacher_short,\n                                	subject.short_name 			AS subject_short,\n                                	classroom.short_name 		AS classroom_short,\n									if(rg.id is NULL,0,1),\n									if(rg.id is NULL,0,rg.no_lesson),\n									active_card.subject_id      AS subject_id,\n									rg.id,\n									rg.prime\n									\n                                FROM \n                                	(SELECT \n                                		card.id 			AS id,\n                                		card.valid_from 	AS valid_from,\n                                		card.subject_id 	AS subject_id,\n                                		card.teacher_id 	AS teacher_id,\n                                		card.class_id 		AS class_id,\n                                		card.classroom_id 	AS classroom_id,\n                                		card.day_id 		AS day_id,\n                                		card.period_id 		AS period_id\n                                	FROM card \n                                	WHERE card.valid_from =\n                                		(	SELECT max(timetable.start_date) \n                                			FROM timetable \n                                			WHERE (timetable.start_date <= \'\".$absence_date.\"\'))) as active_card \n                                	inner join subject 			on active_card.subject_id = subject.id \n                                	inner join teacher 			on active_card.teacher_id = teacher.id  \n                                	inner join day 				on active_card.day_id = day.id  \n                                	inner join period 			on active_card.period_id = period.id\n                                	inner join class 			on active_card.class_id = class.id	\n                                	left  join subject_type 	on subject.subject_type_id = subject_type.id  \n                                	left  join classroom 		on active_card.classroom_id = classroom.id\n									LEFT JOIN (\n                                            select registered_card.id as id,registered_card.card_id as card_id, registered_card.no_lesson as no_lesson, registered_card.prime as prime\n                                            from registered_card\n                                            where DATE_FORMAT(registered_card.card_date, \'%Y-%m-%d\')=\'\".$absence_date.\"\') as rg on active_card.id=rg.card_id\n                                WHERE \n                                    active_card.class_id=\'\".$class_id.\"\' and \n                                    active_card.day_id=\'\".$day_of_week.\"\' and \n                                    active_card.period_id=\'\".$period_id.\"\' and \n                                    \'\".$absence_date.\"\' not in (select holiday.holiday from holiday)\n                                ORDER BY active_card.period_id,teacher.short_name\";\n                \n                $rv_card=nuRunQuery($sql);\n                \n                if($rv_card && db_num_rows($rv_card)>0){\n                    \n                    $card_array = array();\n                \n                    $teacher_name = \'\';\n                    $subject_name = \'\';\n                    $subject_id = -1;\n                    $have_registered=false;\n                    $registration_id = -1;\n                    $no_lesson = false;\n                \n                    while($card_row=db_fetch_row($rv_card)){\n                        $card_array[]= array($card_row[0],$card_row[1],$card_row[2],$card_row[3],$card_row[4],$card_row[5],$card_row[6]);\n                    \n                        if($teacher_name==\'\'){\n                            $teacher_name=$card_row[1];\n                        } else {\n                            $teacher_name=$teacher_name.\', \'.$card_row[1];\n                        }\n                    \n                        if($subject_name==\'\'){\n                            $subject_name=$card_row[2];\n                            $subject_id = $card_row[6];\n                        } else {\n                            if($subject_name!=$card_row[2]){\n                                $subject_name=$subject_name.\',\'.$card_row[2];\n                                $subject_id = -1;       // Περισσότερα από ένα μαθήματα\n                            }\n                        }\n                        \n                        if($card_row[4]==1){\n                            $have_registered = true;\n                            if($card_row[8] == 1) $registration_id = $card_row[7];\n                        }\n                        \n                        if($card_row[5]==1){\n                            $no_lesson=true;\n                        }\n                    }\n                    \n                    if($have_registered){\n                       if($no_lesson){\n                            $subject_name=\'Κενό - \'.$subject_name;   \n                       } else {\n                            $subject_name=\'Καταχωρισμένο - \'.$subject_name;   \n                       }\n                    }\n                    \n                                            // Βρίσκω τις ήδη καταχωρισμένες απουσίες του τμήματος τη συγκρκριμένη μέρα και ώρα\n                    $sql=\"  SELECT  \n                                    student.id,\n                                    absence_reason.short_name,\n                                    absence_reason.name,\n                                    absence.id,\n                                    absence.counts\n                                FROM \n                                    absence,\n                                    student,\n                                    student_class,\n                                    absence_reason,\n                                    card\n                                WHERE \n                                    absence.student_id = student.id and\n                                    absence.card_id = card.id and\n                                    student_class.student_id = student.id and\n                                    absence_reason.id = absence.absence_reason_id and\n                                    student_class.class_id=\'\".$class_id.\"\' and\n                                    card.period_id=\".$period_id.\" and \n                                    DATE_FORMAT(absence_date, \'%Y-%m-%d\')=\'\".$absence_date.\"\'\";\n                    $rv_absence=nuRunQuery($sql);\n                    $absence_array = array();\n                                \n                    while($absence_row=db_fetch_row($rv_absence)){\n                                                        \n                        $sql = \"SELECT COUNT(*) FROM justification_request WHERE absence_id=\'\".$absence_row[3].\"\' AND proceeded=0\";\n                                    \n                        $rv_request = nuRunQuery($sql);\n                        $request_row = db_fetch_row($rv_request);\n                    \n                        $absence_array[]= array($absence_row[0],$absence_row[1],$absence_row[2],$absence_row[3],$absence_row[4],$request_row[0]);  \n                    }               \n\n\n                                            // Βρίσκω τις ποινές των μαθητών του  τμήματος τη συγκρκριμένη μέρα (και ώρα) που επιφέρουν απουσίες\n                    $sql=\"  SELECT  \n                                    penalty.id,\n                                    penalty.type,\n                                    student.id,\n                                    penalty_type.absence_reason_id,\n                                    absence_reason.short_name,\n                                    absence_reason.name\n                            FROM penalty\n                            INNER JOIN penalty_type     ON penalty.type         = penalty_type.name\n                            INNER JOIN absence_reason   ON absence_reason.id    = penalty_type.absence_reason_id  \n                            INNER JOIN student          ON student.id           = penalty.student_id\n                            INNER JOIN student_class    ON (student.id          = student_class.student_id) AND student_class.class_id=\'$class_id\'\n                            WHERE \n                                penalty.date_enforced = \'$absence_date\' AND\n                                (penalty.period_id=\'$period_id\' OR penalty_type.all_day=1) AND\n                                penalty_type.absence_reason_id IS NOT NULL\";\n                                \n                    $rv_penalty=nuRunQuery($sql);\n                    $penalty_array = array();\n                                \n                    while($penalty_row=db_fetch_row($rv_penalty)){\n                        $penalty_array[]= array($penalty_row[0],$penalty_row[1],$penalty_row[2],$penalty_row[3],$penalty_row[4],$penalty_row[5]);  \n                    }\n                    \n                    $onprogress = ($curdate==$absence_date && $curperiod==$period_id && !$no_lesson);\n                    if(!$have_registered) \n                        print \"\n        <script type=\\\"text/javascript\\\">                        \n            parent.enable_setbtn();\n        </script>\";\n                                       \n                    print \"\n        <table cellspacing=0 align=center CLASS=\\\"sisTable\\\">\";\n                    print \" \n            <tr height=40>\n                <th colspan=3 align=center valign=center>\n                    \".date(\'d-m-Y\',strtotime($absence_date)).\" - \".$period_name.\" <span style=\\\"font-size: 75%;\\\">(\".$period_start.\"-\".$period_end.\")</span>\".($onprogress ? \"<div class=\\\"clock\\\" id=\\\"counter\\\" style=\\\"float: right;\\\" align=\\\"right\\\">--:--</div>\" : \"\").\"\n                </th>\n            </tr>\n                            \n            <tr height=40 valign=center>\n                <th colspan=\".($have_registered && !$no_lesson ? \"1 align=center style=\\\"border-right: 0;\\\"\" : \"3 align=center\").\" >\n                    Τμήμα : \".$class_name.\"\n                </th>\".($have_registered && !$no_lesson ? \"\n                <th colspan=2 align=center style=\\\"border-left: 0;\\\">\n                    <img src=\\\"images/ebooks.png\\\" width=36 heght=36 style=\\\"float: right; margin-right: 22px;vertical-align: middle;display: inline;\\\" title=\\\"Σημειώσεις Διδασκαλίας\\\"  onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\" onclick=\\\"parent.open_rc($registration_id);\\\">\n                </th>\n                \" : \"\").\n            \"\n            </tr>\n                            \n            <tr height=40>\n                <th colspan=3 align=left valign=center>\n                    \".$subject_name.\" - \".$teacher_name.\"\n                </th>\n            </tr>\";\n                            \n                    $sql=\"  SELECT registration_number,ifNULL(surname,\'\'),ifNULL(name,\'\'),ifNULL(fathers_name,\'\'),has_left_school,student.id\n                                        FROM student \n                                        inner join student_class on student.id=student_class.student_id\n                                        WHERE student_class.class_id=\'\".$class_id.\"\'\n                                        order by surname,name,fathers_name\";\n                    $rv_student=nuRunQuery($sql);\n                    \n                    if(!($have_registered)){\n                        \n                        $num_of_students=0;\n                        while($row_student = db_fetch_row($rv_student)){\n                            print \"\n                <tr height=40 >\";\n                            \n                            print \"\n                    <td align=left valign=center width=600>\";\n                            print \"<img src=\\\"images/cards.png\\\" width=30 heght=30 onclick=\\\"add_penalty(\'\".$row_student[5].\"\',\'\".$row_student[1].\" \".$row_student[2].\" πατ. \".$row_student[3].\"\')\\\" title=\\\"Υποβολή Παρατήρησης-Ποινής\\\" onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\">\";\n                            print \"<img style=\\\"margin-bottom: 3px;padding-right: 3px;padding-left: 3px;\\\" src=\\\"images/edit.png\\\" width=20 heght=20 onclick=\\\"add_comment(\'\".$row_student[5].\"\',\'\".$row_student[1].\" \".$row_student[2].\" πατ. \".$row_student[3].\"\', \'\".$subject_id.\"\',\'\".$subject_name.\"\')\\\" title=\\\"Προσθήκη Σχόλιου\\\" onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\">\";\n                            print \"<img src=\\\"images/medal.png\\\" width=24 heght=24 onclick=\\\"add_reward(\'\".$row_student[5].\"\',\'\".$row_student[1].\" \".$row_student[2].\" πατ. \".$row_student[3].\"\', \'\".$subject_id.\"\',\'\".$subject_name.\"\')\\\" title=\\\"Απονομή Επιβράβευσης\\\" onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\"> \";\n                            print \"<b>\".$row_student[1].\" \".$row_student[2].\"</b> - \".$row_student[3].\"\n                    </td>\";\n                            \n                            if($row_student[4]==0){\n                                if($penalty = have_penalty($penalty_array, $row_student[5])){\n                                    $color = ($penalty[3]==\'1\' ? \"OrangeRed\" : ($penalty[3]==\'2\' ? \"Magenta\" : ($penalty[3]==\'3\' ? \"FireBrick\" : \"Red\")));    \n                                    print \"\n                    <td id=\\\"\".$row_student[5].\"_\".$period_id.\"_\".$penalty[3].\"\\\" style=\\\"background-color:$color;\\\" class=\\\"absence\\\" title=\\\"\".$penalty[5].\"\\\" align=center valign=center width=80 onmousedown=\\\"change_state(this,event);\\\" onmouseover=\\\"ChangeBackgroundColor(this)\\\" onmouseout=\\\"RestoreBackgroundColor(this)\\\">\".$penalty[4].\"\n                    </td>\";\n                                } else {\n                                    print \"\n                    <td id=\\\"\".$row_student[5].\"_\".$period_id.\"_0\\\" style=\\\"background-color:lightGreen;\\\" class=\\\"absence\\\" title=\\\"Παρουσία\\\" align=center valign=center width=80 onmousedown=\\\"change_state(this,event);\\\" onmouseover=\\\"ChangeBackgroundColor(this)\\\" onmouseout=\\\"RestoreBackgroundColor(this)\\\">Π\n                    </td>\";\n                                    $num_of_students++;\n                                }\n                            } else{\n                                print \"\n                    <td id=\\\"\".$row_student[5].\"_\".$period_id.\"_1\\\" style=\\\"background-color:OrangeRed;\\\" class=\\\"absence\\\" title=\\\"Απουσία\\\" align=center valign=center width=80 onmousedown=\\\"change_state(this,event);\\\" onmouseover=\\\"ChangeBackgroundColor(this)\\\" onmouseout=\\\"RestoreBackgroundColor(this)\\\">Α\n                    </td>\";\n                            }\n                            \n                            print \"\n                </tr>\";    \n                        }\n                            \n                        print \" \n                <tr height=40>\n                    <th align=right valign=center width=600 colspan=1><b>Αριθμός Παρόντων Μαθητών&nbsp;</b></th>\n                    <th id=\\\"num_of_students\\\" align=center valign=center width=80>\".$num_of_students.\"</th>\n                </tr>\";\n                    } else {\n                        while($row_student = db_fetch_row($rv_student)){\n                            print \"<tr height=40 >\";\n                            print \"\n                    <td align=left valign=center width=\".(($curdate==$absence_date && $curperiod==$period_id && !$no_lesson) ? \"520\" : \"600\").\">\";\n                            print \"<img src=\\\"images/cards.png\\\" width=30 heght=30 onclick=\\\"add_penalty(\'\".$row_student[5].\"\',\'\".$row_student[1].\" \".$row_student[2].\" πατ. \".$row_student[3].\"\')\\\" title=\\\"Υποβολή Παρατήρησης-Ποινής\\\" onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\">\";\n                            print \"<img style=\\\"margin-bottom: 3px;padding-right: 3px;padding-left: 3px;\\\" src=\\\"images/edit.png\\\" width=20 heght=20 onclick=\\\"add_comment(\'\".$row_student[5].\"\',\'\".$row_student[1].\" \".$row_student[2].\" πατ. \".$row_student[3].\"\', \'\".$subject_id.\"\',\'\".$subject_name.\"\')\\\" title=\\\"Προσθήκη Σχόλιου\\\" onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\">\";\n                            print \"<img src=\\\"images/medal.png\\\" width=24 heght=24 onclick=\\\"add_reward(\'\".$row_student[5].\"\',\'\".$row_student[1].\" \".$row_student[2].\" πατ. \".$row_student[3].\"\', \'\".$subject_id.\"\',\'\".$subject_name.\"\')\\\" title=\\\"Απονομή Επιβράβευσης\\\" onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\"> \";\n                            print \"<b>\".$row_student[1].\" \".$row_student[2].\"</b> - \".$row_student[3].\"\n                    </td>\";\n                            \n                            \n                            if($s=have_adsence($absence_array,$row_student[5])){\n                                if($curdate==$absence_date && $curperiod==$period_id && !$no_lesson){\n                                    print \"\n                    <td align=center valign=center width=80>&nbsp;\n                    </td>\";\n                                }\n                                print \"\n                    <td id=\\\"absence_\".$s[3].\"\\\" style=\\\"background-color:\".($s[4]==\'0\' ? \"#7d5454\" : \"Brown\").\";\".($s[5]==\'0\' ? \"\" : \"background-image: linear-gradient(225deg, #00b6b6, #00b6b6 6px, transparent 6px, transparent);\").\";\\\" title=\\\"Καταχωρισμένο-\".$s[2].($s[5]==\'0\' ? \"\" : \"-με αίτημα διαγραφής σε εκκρεμότητα\").\"\\\" onclick=\\\"parent.nuOpenFormInFrame(\'5509671b4e81a07\',\'\".$s[3].\"\')\\\" align=center valign=center width=80 onmouseover=\\\"ChangeBackgroundColor(this)\\\" onmouseout=\\\"RestoreBackgroundColor(this)\\\">\".$s[1].\"\n                    </td>\";\n                            } else {\n                                if($curdate==$absence_date && $curperiod==$period_id && !$no_lesson){\n                                    print \"\n                    <td onclick=\\\"add_adsence(\'\".$row_student[5].\"\',\'\".$period_id.\"\',\'\".$class_id.\"\')\\\" title=\\\"Επιβολή Ωριαίας Απομάκρυνσης\\\" align=center valign=center width=80 onmouseover=\\\"ChangeBackgroundColor(this)\\\" onmouseout=\\\"RestoreBackgroundColor(this)\\\"><img src=\\\"images/get_out.png\\\" width=25 heght=25>\n                    </td>\";\n                                } \n                                if($no_lesson){\n                                    print \"\n                    <td style=\\\"background-color:DarkOliveGreen;\\\" title=\\\"Κενό\\\" align=center valign=center width=80>\n                    </td>\";\n                                } else {\n                                    if($add_absence_later == 1)\n                                        print \"\n                    <td style=\\\"background-color:DarkOliveGreen;\\\" title=\\\"Καταχωρισμένο-Παρουσία\\\" align=center valign=center width=80 onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\" onmousedown=\\\"add_after_student_absence(\'\".$row_student[5].\"\',\'\".$row_student[1].\" \".$row_student[2].\" πατ. \".$row_student[3].\"\',\'\".$period_id.\"\')\\\">Π\n                    </td>\";\n                                    else\n                                        print \"\n                    <td style=\\\"background-color:DarkOliveGreen;\\\" title=\\\"Καταχωρισμένο-Παρουσία\\\" align=center valign=center width=80 >Π\n                    </td>\";\n                                }        \n                            }                            \n                            print \"\n                </tr>\";\n                        }\n                        \n                    }\n                    print \"\n            </table>\";    \n                } else {\n                    print \"<span CLASS=\\\"msgError\\\">ΠΡΟΣΟΧΗ : Δεν βρέθηκαν οι διδασκαλίες...<br>Επικοινωνίστε με το διαχειριστή του συστήματος!</span>\";\n                }\n            } else {\n                print \"<span CLASS=\\\"msgError\\\">ΠΡΟΣΟΧΗ : Δεν βρέθηκε το τμήμα...<br>Επικοινωνίστε με το διαχειριστή του συστήματος!</span>\";\n            }\n        } else {\n            print \"<span CLASS=\\\"msgError\\\">ΠΡΟΣΟΧΗ : Δεν βρέθηκε η διδακτική ώρα...<br>Επικοινωνίστε με το διαχειριστή του συστήματος!</span>\"; \n        }\n    } else{\n        print \"<span CLASS=\\\"msgError\\\">Παρουσιάστηκε πρόβλημα στην ανάκτηση των δεδομένων...</i></b>\";   \n    }\n    } else {\n        print \"<span CLASS=\\\"msgError\\\">Δεν μπορείτε να καταχωρίσετε απουσίες σε διδασκαλίες που δεν έχουν πραγματοποιηθεί...</span>\";\n    }\n}\n               \nprint\n    ($onprogress ? \"<script>countdownTime($time_left)</script>\n    \" : \"\").\n    \"\n    </body>\n</html>\";\n','','0','2016-07-16 15:06:12','globeadmin','2022-09-24 23:18:51','globeadmin','2022-09-24 23:20:26','globeadmin','0'),('5790f5c50ba72b6','send_email_to_teachers','Στέλνει ένα emails σε καθηγητές σύμφωνα με μια λίστα από ids','sisyphos','//require_once(\"phpmailer/class.phpmailer.php\");\nuse PHPMailer\\PHPMailer\\PHPMailer;\nuse PHPMailer\\PHPMailer\\Exception;\n\nrequire \'PHPMailer/src/Exception.php\';\nrequire \'PHPMailer/src/PHPMailer.php\';\nrequire \'PHPMailer/src/SMTP.php\';\n\nnuRunPHP(\"sisyphos_lib\");\n\nfunction esc($str){\n    $db_params = nuRunQuery();\n    $link = mysqli_connect($db_params[0], $db_params[2], $db_params[3], $db_params[1]);\n\n    if (mysqli_connect_errno()) {\n        nuDebug(\"Connect failed: %s\\n\", mysqli_connect_error());\n        return \'\';\n    }\n    return(mysqli_real_escape_string($link,$str));\n}\n\n$is_student = (\'#is_student#\'==\'1\' ? true : false);\n\nfunction find_address($email_to_send,$emails){\n    foreach ($emails as $email) {\n        if($email[0]==$email_to_send){\n                return true;\n        }\n    }\n    return false;\n}\n\n$setup                      = $GLOBALS[\'nuSetup\'];                                      //-- Read SMTP AUTH Settings from zzsys_setup table	\n\nif (!empty($setup->set_smtp_username))          { $setup->set_smtp_username = trim($setup->set_smtp_username);}                       else{$errorText .= \"SMTP Username not set.<br>\";}\nif (!empty($setup->set_smtp_password)) 	        { $setup->set_smtp_password = trim($setup->set_smtp_password);}                       else{$errorText .= \"SMTP Password not set.<br>\";}\nif (!empty($setup->set_smtp_host))              { $setup->set_smtp_host = trim($setup->set_smtp_host);}                               else{$errorText .= \"SMTP Host not set.<br>\";}\nif (!empty($setup->set_smtp_from_address))      { $setup->set_smtp_from_address = trim($setup->set_smtp_from_address);}               else{$errorText .= \"SMTP From Address not set.<br>\";}\nif (!empty($setup->set_smtp_port))              { $setup->set_smtp_port = intval($setup->set_smtp_port);}                             else{$errorText .= \"SMTP PORT not set.<br>\";}\nif (!empty($setup->set_smtp_use_ssl))           { $setup->set_smtp_use_ssl = trim($setup->set_smtp_use_ssl);}                         else{$setup->set_smtp_use_ssl = \'\';}\nif (!empty($setup->set_smtp_from_name))         { $SMTPname = trim($setup->set_smtp_from_name);}	                              else{$SMTPname = \"Sisyphos\";}\n\nif ($errorText == \'\'){\n                        // Όλα καλά! Οι ρυθμίσεις είναι ΟΚ, να σταλουν τα emails\n    if( \'#teacher_ids#\'!=\'#\'.\'teacher_ids\'.\'#\' && \'#teacher_ids#\'!=\'\' &&\n        \'#email_subject#\'!=\'#\'.\'email_subject\'.\'#\' && \'#email_subject#\'!=\'\' &&\n        \'#email_content#\'!=\'#\'.\'email_content\'.\'#\' && \'#email_content#\'!=\'\'){\n        \n        $attachment_error = false;\n        \n        $uploadfile = \'\';\n        if(\'#FILES#\'!=\'#\'.\'FILES\'.\'#\' && \'#FILES#\'!=\'\'){\n            \n            $S = stripslashes(\'#FILES#\');\n\n            $J = json_decode($S);\n            if (json_last_error() === JSON_ERROR_NONE) {\n                $file_name = $J[0]->{\'name\'};\n                $file_type = $J[0]->{\'type\'};\n                $file_error = $J[0]->{\'error\'};\n                $file_size  = $J[0]->{\'size\'};\n\n                if($file_error != 0){\n                    $attachment_error = true;    \n                } else {\n                    $uploaddir= sys_get_temp_dir();\n                    $uploadfile = $uploaddir .\'/\'.$file_name;    \n                }\n            } else{\n                $attachment_error = true;\n            }\n        }\n        \n        if(!$attachment_error){\n        \n            $ids = explode(\",\", \'#teacher_ids#\');\n            $email_content = stripslashes(\'#email_content#\');\n            $emails_array = array();\n        \n            foreach($ids as $id){\n                if($id==-1){            //προς τη διέυθυνση του Σχολείου\n                    $sql=\"select email from school where id=1\";\n                    $rv = nuRunQuery($sql);\n                    if ($rv && $r=db_fetch_row($rv)){\n                        if(!is_null($r[0]) && $r[0]!=\'\' && !find_address($r[0],$emails_array)){\n                            $emails_array[]= array($r[0],\'#email_subject#\',$email_content,$id);\n                        }  \n                    }            \n                } elseif($id==0){       //προς όλους τους καθηγητές\n                    $sql=\"  select TRIM(teacher.email),TRIM(zzzsys_user.sus_email),teacher.id\n                            from teacher\n                            left join zzzsys_user \n                            on teacher.user_id=zzzsys_user.zzzsys_user_id\";\n                    $rv = nuRunQuery($sql);\n                \n                    if ($rv){\n                        while($r=db_fetch_row($rv)){\n                            if(!is_null($r[0]) && $r[0]!=\'\' && !find_address($r[0],$emails_array)){\n                                $emails_array[]= array($r[0],\'#email_subject#\',$email_content,$r[2]);\n                            }\n                    \n                            if(!is_null($r[1]) && $r[1]!=\'\' && !find_address($r[1],$emails_array)){\n                                $emails_array[]= array($r[1],\'#email_subject#\',$email_content,$r[2]);\n                            }\n                        }\n                    }\n                } else {                //προς ένα συγκεκριμένο καθηγητή\n                    $sql=\"  select TRIM(teacher.email),TRIM(zzzsys_user.sus_email)\n                            from teacher\n                            left join zzzsys_user \n                            on teacher.user_id=zzzsys_user.zzzsys_user_id\n                            where teacher.id=\'\".$id.\"\'\";\n                    $rv = nuRunQuery($sql);\n            \n                    if ($rv && $r=db_fetch_row($rv)){\n                        if(!is_null($r[0]) && $r[0]!=\'\' && !find_address($r[0],$emails_array)){\n                            $emails_array[]= array($r[0],\'#email_subject#\',$email_content,$id);\n                        }\n                    \n                        if(!is_null($r[1]) && $r[1]!=\'\' && !find_address($r[1],$emails_array)){\n                            $emails_array[]= array($r[1],\'#email_subject#\',$email_content,$id);\n                        }\n                    }\n                }    \n            }\n        \n            $mail                    = new PHPMailer(true);\n        \n            $mail->SMTPDebug         = 0;\n	        $mail->IsSMTP();\n	        $mail->setLanguage(\'el\');\n            $mail->Host              = $setup->set_smtp_host;\n            $mail->Port              = $setup->set_smtp_port;\n            $mail->SMTPAuth          = true;\n            $mail->SMTPSecure        = $setup->set_smtp_use_ssl ? $setup->set_smtp_use_ssl : \'\';\n            //$mail->SMTPAuth          = $setup->set_smtp_use_ssl;\n            $mail->CharSet           = \'iso-8859-7\';\n\n            $mail->Username  = $setup->set_smtp_username;\n            $mail->Password  = $setup->set_smtp_password;\n\n            $mail->From              = $setup->set_smtp_from_address;\n            $mail->FromName          = iconv(\'UTF-8\',\'ISO-8859-7//IGNORE\',$setup->set_smtp_from_name);\n            $mail->AddReplyTo($setup->set_smtp_from_address,iconv(\'UTF-8\',\'ISO-8859-7//IGNORE\',$setup->set_smtp_from_name));\n            $mail->AddReplyTo        = $setup->set_smtp_from_address;\n            $mail->WordWrap          = 80;\n            $mail->IsHTML(true);\n            \n            $system_url = get_system_url();\n            \n            $school_name = get_school_name();\n            $sender_name = (\'#sender_name#\'!=\'#\'.\'sender_name\'.\'#\' && \'#sender_name#\'!=\'\' ? \'το έστειλε ο \'.\'#sender_name#\' :  \'στάλθηκε\');\n          \n            $footer = \"<br>                    \n<hr style=\\\"width: 100%; height: 0px; background-color:#b04b00; color:#b04b00;border: 1px solid;\\\">	\n<span style=\\\"color: #525c66;line-height: 150%;font-size: 14px;font-family: Sans-serif;\\\">\nΤο μήνυμα αυτό $sender_name μέσω του Σίσυφου. Αν θέλετε να απαντήσετε, παρακαλώ \".( $system_url==\'\' ? \"συνδεθείτε\": \"<a href=\\\"$system_url\\\">συνδεθείτε</a>\").\" και στείλτε και εσείς την απάντηση σας μέσω του Σίσυφου. Για λόγους ασφάλειας δεν κοινοποιείται η ηλεκτρονική διεύθυνση του αποστολέα.<br>\n<b>Παρακαλώ, μην απαντάτε σ’αυτό το email.</b>\n</span>\n<p></p>\n<hr style=\\\"width: 50%; margin-left:0; height: 0px; border-style: dotted; border-width: 1px 0px 0px; border-color: #525c66;\\\">\n<span style=\\\"color: #525c66;line-height: 150%;font-size: 10px;font-family: Sans-serif;\\\">\n<b>Διευκρίνιση ηλεκτρονικού ταχυδρομείου : </b>\n<br>\nΑυτό το ηλεκτρονικό μήνυμα (e-mail) μαζί με τα τυχόν επισυναπτόμενά του, είναι εμπιστευτικό και προορίζεται μόνο για χρήση από τα άτομα στα οποία απευθύνεται. Εάν δεν είστε ο προοριζόμενος παραλήπτης ή αρμόδιος για την παράδοση του μηνύματος στον προοριζόμενο παραλήπτη, παρακαλώ επιστρέψτε το στον αποστολέα και σας γνωρίζουμε ότι η αποθήκευση, ανάγνωση, μετάδοση, αναγραφή, αποκάλυψη, ανακοίνωση ή οποιασδήποτε άλλης μορφής χρήση οποιωνδήποτε πληροφοριών περιέχονται στο παρόν μήνυμα, δεν είναι σύννομη. \n<br>\nΠαρόλο που το $school_name έχει λάβει όλες τις απαιτούμενες προφυλάξεις για να διασφαλίσει ότι τα αποστελλόμενα μηνύματα ηλεκτρονικού ταχυδρομείου και τα όποια επισυναπτόμενα αρχεία τους έχουν ελεγχθεί για ιούς ή άλλο κακόβουλο λογισμικό, ωστόσο είναι ευθύνη του παραλήπτη να ελέγξει τη μη ύπαρξη ιών και κακόβουλου λογισμικού, πριν ανοίξετε οποιοδήποτε επισυναπτόμενο αρχείο. \n<br>\nΤο $school_name δεν αποδέχεται ουδεμία ευθύνη για το περιεχόμενο του παρόντος μηνύματος και σε καμία περίπτωση, δεν ευθύνεται για οιαδήποτε τυχόν ζημία λόγω αποθήκευσης ή ανάγνωσης του παρόντος, καθυστερημένης διαβίβασης, υποκλοπής, αλλοίωσης ή μόλυνσης με ιούς. Οι απόψεις που διατυπώνονται στο παρόν μήνυμα ανήκουν αποκλειστικά στον αποστολέα αυτού.\n</span>\n\";\n            $footer = iconv(\'UTF-8\',\'ISO-8859-7//IGNORE\',$footer); \n            \n            if($uploadfile!=\'\'){\n                $mail->AddAttachment($uploadfile,$file_name);\n            }\n        \n            $sent=0;\n            $fail=0;\n            $wrong_address = 0;\n        \n            foreach ($emails_array as $recipient){\n            \n                $fail_code=0;\n                $fail_comments=\'\';\n            \n                $email_address = $recipient[0];\n            \n                if(!filter_var($email_address, FILTER_VALIDATE_EMAIL)){\n                    $wrong_address++;\n                    $fail_code=1;\n                    $fail_comments=\'Μη έγκυρη email διεύθυνση\';\n                } else {\n            \n                    $subject = $recipient[1];\n                    $subject =iconv(\'UTF-8\',\'ISO-8859-7//IGNORE\',$subject);\n        \n                    $content = $recipient[2];\n                    $content = iconv(\'UTF-8\',\'ISO-8859-7//IGNORE\',$content);\n                    \n                    if($content && trim($content) != \'\'){\n                        $content = $content.$footer;\n	                    $mail->Subject  = $subject;\n	                    $mail->Body     = $content;\n	                    $mail->ClearAllRecipients();\n                        $mail->AddAddress($email_address);\n            \n                        try {\n                            $mail->Send();\n                            $sent++;\n                        } catch (phpmailerException $e) {\n                            $fail++;\n                            $fail_code = 2;\n                            $fail_comments = $e->errorMessage();;\n                        } catch (Exception $e) {\n                            $fail++;\n                            $fail_code = 3;\n                            $fail_comments = $e->getMessage();;\n                        }\n                    } else {\n                            $fail++;\n                            $fail_code = 2;\n                            $fail_comments = \'Αποτυχία στη μετατροπή της κωδικοποίησης του περιεχομένου του μηνύματος.\'; \n                    }\n                }\n                if(!$is_student){       // το email στάλθηκε από καθηγητή και καταγράφεται\n                    $sql=\"  INSERT INTO email (\n                            id,\n                            sender_id,\n                            sent_at,\n                            email_address,\n                            email_subject,\n                            email_text,\n                            fail_code,\n                            fail_comments,\n                            teacher_id,\n                            student_id\n                            )\n                        VALUES (\n                            NULL,\n                            \'#RECORD_ID#\',\n                            NOW(),\n                            \'\".$recipient[0].\"\',\n                            \'\".esc($recipient[1]).\"\',\n                            \'\".esc($recipient[2].($uploadfile!=\'\' ? \'<br>- \'.$file_name : \'\')).\"\',\n                            \'\".$fail_code.\"\',\n                            \'\".(is_null($fail_comments) || $fail_comments==\'\' ? \'\' : $fail_comments).\"\',\n                            \".(is_null($recipient[3]) || $recipient[3]<=0 ? \'NULL\' : $recipient[3]).\",\n                            -1\n                        )\";\n                    nuRunQuery($sql);\n                }\n            }\n          \n            $nuParameters = \"Στάλθηκαν \".$sent.\" Emails!\";\n            if($fail>0) {$nuParameters=$nuParameters.\"\\nΑπέτυχαν \".$fail.\" Emails!\";}\n            if($wrong_address>0) {$nuParameters=$nuParameters.\"\\nΛάθος σε \".$wrong_address.\" διευθύνσεις!\";}\n        } else {\n            $nuError = \"Παρουσιάστηκε σφάλμα με το επισυναπτόμενο αρχείο!\\nΤα μηνύματα δεν στάλθηκαν!\";    \n        }    \n    } else {\n        $nuError = \"Παρακαλώ να ορίσετε παραλήπτη, θέμα και περιεχόμενο για το μήνυμα σας...\\nΤα μηνύματα δεν στάλθηκαν!\";\n    }\n} else{\n	$nuError = \"Το e-mail δε μπορεσε να στείλει! Το ακόλουθο μήνυμα λάθους εμφανίστηκε: \".$errorText; \n}\n','','0','2016-07-21 19:18:13','globeadmin','2019-07-25 12:14:41','globeadmin','2019-07-25 12:14:41','globeadmin','0'),('579785a44a87d70','print_marks_student_evaluation','Εκτύπώνει την περιγραφική αξιολόγηση του μαθητή για μια περίοδο','student','function format_mark_value($value,$num_of_decimals){\n                    \n    $pieces = explode(\".\", $value);\n    $new_value =  $value;\n    \n    if(strlen($pieces[0])==1){\n        $pieces[0]=\'0\'.$pieces[0];    \n    }\n    \n    if(count($pieces)==2){\n        if($num_of_decimals==0 && $pieces[1]==\'0\'){\n            $new_value = $pieces[0];   \n        } else {\n            $new_value = $pieces[0].\',\'.$pieces[1];    \n        }\n    }\n    \n    return($new_value);\n}\n\n$sql=\"DROP TEMPORARY TABLE IF EXISTS #TABLE_ID#\";\nnuRunQuery($sql);\n\n$sql=\"CREATE TEMPORARY TABLE #TABLE_ID# DEFAULT CHARACTER SET=utf8\nSELECT\n    mark.id                             as mark_id,\n	mark.subject_id                     as subject_id,\n	mark.subject_id                     as subject_id2,\n    mark.class_id                       as class_id,\n    \n    school.name                         as school_name,\n    school_year.name                    as school_year_name,\n    DATE_FORMAT(curdate(),\'%d-%m-%Y\')   as cur_date,\n    grading_period.name                 as grading_period_name,\n    concat( student.registration_number,\'-\',\n            ifNULL(student.surname,\'\'),\n            if(student.surname is NULL OR student.name is NULL,\'\',\' \'),\n            ifNULL(student.name,\'\'),\n            if(student.fathers_name is NULL,\'\',concat(\' πατ. \',student.fathers_name))) as student_full_name,\n\n    concat( ifNULL(subject.name,\'\'),\n            if(subject_type.short_name is NULL,\'\', concat(\' (\',subject_type.short_name,\')\'))) as subject_full_name,\n\n    class.short_name                    as class_short,\n    \n    mark.value                          as value_p,\n    \n	grading_period.num_of_decimals      as grading_period_num_of_decimals,\n    \n    CAST(\'\' as CHAR(255))               as teacher_names,\n    CAST(ifNULL(mark.comments,\'\') as CHAR(10000))    as mark_comments,\n    CAST(\'\' as CHAR(15))                as value_formated,\n    0                                   as critiria_count,\n                                    \n    critirion_general.id                                                    as critirion_general_id,\n    critirion_special.id                                                    as critirion_special_id,\n    mark_critirion_special_level.critirion_special_level_id                 as critirion_special_level_id,\n    \n    critirion_general.description                                           as critirion_general_description,\n    critirion_special.description                                           as critirion_special_description,\n    if(critirion_special.id IS NOT NULL AND mark_critirion_special_level.custom_description IS NULL AND critirion_special_level.description is NULL,\'Δεν έχει οριστεί περιγραφή...\',IFNULL(mark_critirion_special_level.custom_description,critirion_special_level.description))  as critirion_special_level_description,\n\n    if(mark.comments is NULL,\'\',\'Περιγραφή Καθηγητών :\')                    as comments_label\n    \nFROM mark\nINNER JOIN grading_period   ON mark.grading_period_id=grading_period.id  \nINNER JOIN student          ON mark.student_id=student.id\nINNER JOIN class            ON mark.class_id=class.id\nINNER JOIN subject          ON mark.subject_id=subject.id\nINNER JOIN school           ON 1=1\nINNER JOIN school_year      ON school_year.id=school.school_year_id\nLEFT  JOIN subject_type     ON subject.subject_type_id=subject_type.id\n\n\nLEFT JOIN mark_critirion_special_level \n                            ON mark_critirion_special_level.mark_id =   mark.id\nLEFT JOIN critirion_special            \n                            ON critirion_special.id         = mark_critirion_special_level.critirion_special_id       \nLEFT JOIN  critirion_special_level      \n                            ON critirion_special_level.id   = mark_critirion_special_level.critirion_special_level_id        \nLEFT JOIN critirion_general            \n                            ON critirion_general.id         = critirion_special.critirion_general_id\n                                    \nwhere\n    mark.grading_period_id=\'#student_mark_grade_period_id#\' and\n    mark.student_id=\'#RECORD_ID#\'\norder by class_short,subject.name,subject_type.name DESC,critirion_general.id,critirion_special.hierarchy\n\";\nnuRunQuery($sql);\n\n$sql=\"select distinct class_id,subject_id from #TABLE_ID#\";\n$rv = nuRunQuery($sql);\n\nif($rv){\n        while($row = db_fetch_row($rv)){\n            $class_id=$row[0];\n            $subject_id=$row[1];\n            \n            $sql=\"  SELECT distinct CONCAT(IF(teacher.surname is null,\'\', concat(teacher.surname,\' \')),IFNULL(teacher.name,\'\'))\n                    FROM \n	                    (SELECT \n		                    card.id 			AS id,\n		                    card.valid_from 	AS valid_from,\n		                    card.subject_id 	AS subject_id,\n		                    card.teacher_id 	AS teacher_id,\n		                    card.class_id 		AS class_id,\n		                    card.classroom_id 	AS classroom_id,\n		                    card.day_id 		AS day_id,\n		                    card.period_id 		AS period_id \n	                    FROM card \n	                    WHERE card.valid_from =\n		                    (	SELECT max(timetable.start_date) \n			                    FROM timetable)) as active_card \n	                inner join subject 			on active_card.subject_id = subject.id \n	                inner join teacher 			on active_card.teacher_id = teacher.id  \n	                inner join day 				on active_card.day_id = day.id  \n	                inner join period 			on active_card.period_id = period.id\n	                inner join class 			on active_card.class_id = class.id	\n	                left  join subject_type 	on subject.subject_type_id = subject_type.id  \n	                left  join classroom 		on active_card.classroom_id = classroom.id\n	                where \n	                    active_card.subject_id=\'\".$subject_id.\"\' and active_card.class_id=\'\".$class_id.\"\'\n                    ORDER BY \n    	                active_card.teacher_id,\n	                    active_card.day_id,\n	                    active_card.period_id\";\n\n            $retval = nuRunQuery($sql);\n            $teachers=\'\';\n            $first=true;\n\n            if($retval){\n                while($row = db_fetch_row($retval)){\n                    if($first){\n                        $teachers=$row[0];\n                        $first=false;\n                    } else{\n                        $teachers=$teachers.\', \'.$row[0];\n                    }\n                }\n            }\n            if(!$first){\n                $sql=\"  update #TABLE_ID# set \n                        teacher_names=\'\".$teachers.\"\' \n                        where class_id=\".$class_id.\" and subject_id=\".$subject_id;\n                nuRunQuery($sql);\n                }\n        }\n}\n\n$sql=\"  SELECT distinct\n            mark_id,\n            value_p,\n            grading_period_num_of_decimals,\n            mark_comments \n        FROM #TABLE_ID#\";\n$retval = nuRunQuery($sql);\n            \nwhile($row = db_fetch_row($retval)){\n                \n    $sql = \"    SELECT count(*)\n                FROM mark_critirion_special_level\n                WHERE \n                    mark_id=\'\".$row[0].\"\' AND \n                    (critirion_special_level_id IS NOT NULL OR custom_description IS NOT NULL)\";\n    $rv2=nuRunQuery($sql);\n    $r2 = db_fetch_row($rv2);\n                \n    $cm = strip_tags(html_entity_decode(trim($row[3])));\n    \n    $sql=\"  update #TABLE_ID# set \n                critiria_count=\'\".$r2[0].\"\',\n                value_formated=\'\".format_mark_value($row[1],$row[2]).\"\',\n                mark_comments=\'\".$cm.\"\'\n                where mark_id=\".$row[0];\n    nuRunQuery($sql);\n   \n}\n\n$sql=\"  DELETE FROM #TABLE_ID#\n        WHERE critiria_count=0 AND TRIM(mark_comments)=\'\'\";\nnuRunQuery($sql);\n\n','','0','2016-07-26 18:45:40','globeadmin','2016-12-30 12:24:22','globeadmin','2018-07-17 15:23:35','globeadmin','0'),('579a4c58a490a53','resend_email','Ξαναστέλνει ενά email','teacher','//require_once(\"phpmailer/class.phpmailer.php\");\nuse PHPMailer\\PHPMailer\\PHPMailer;\nuse PHPMailer\\PHPMailer\\Exception;\n\nrequire \'PHPMailer/src/Exception.php\';\nrequire \'PHPMailer/src/PHPMailer.php\';\nrequire \'PHPMailer/src/SMTP.php\';\n\nnuRunPHP(\"sisyphos_lib\");\n\nfunction esc($str){\n    $db_params = nuRunQuery();\n    $link = mysqli_connect($db_params[0], $db_params[2], $db_params[3], $db_params[1]);\n\n    if (mysqli_connect_errno()) {\n        nuDebug(\"Connect failed: %s\\n\", mysqli_connect_error());\n        return \'\';\n    }\n    return(mysqli_real_escape_string($link,$str));\n}\n\n$setup                      = $GLOBALS[\'nuSetup\'];                                      //-- Read SMTP AUTH Settings from zzsys_setup table	\n\nif (!empty($setup->set_smtp_username))          { $setup->set_smtp_username = trim($setup->set_smtp_username);}                       else{$errorText .= \"SMTP Username not set.<br>\";}\nif (!empty($setup->set_smtp_password)) 	        { $setup->set_smtp_password = trim($setup->set_smtp_password);}                       else{$errorText .= \"SMTP Password not set.<br>\";}\nif (!empty($setup->set_smtp_host))              { $setup->set_smtp_host = trim($setup->set_smtp_host);}                               else{$errorText .= \"SMTP Host not set.<br>\";}\nif (!empty($setup->set_smtp_from_address))      { $setup->set_smtp_from_address = trim($setup->set_smtp_from_address);}               else{$errorText .= \"SMTP From Address not set.<br>\";}\nif (!empty($setup->set_smtp_port))              { $setup->set_smtp_port = intval($setup->set_smtp_port);}                             else{$errorText .= \"SMTP PORT not set.<br>\";}\nif (!empty($setup->set_smtp_use_ssl))           { $setup->set_smtp_use_ssl = trim($setup->set_smtp_use_ssl);}                         else{$setup->set_smtp_use_ssl = \'\';}\nif (!empty($setup->set_smtp_from_name))         { $SMTPname = trim($setup->set_smtp_from_name);}	                              else{$SMTPname = \"nuBuilder\";}\n\nif ($errorText == \'\'){\n                        \n    if(\'#email_id#\'!=\'#\'.\'email_id#\' && \'#email_id#\'!=\'\'){\n                                                                // Όλα καλά! Οι ρυθμίσεις είναι ΟΚ, να σταλουν τα emails\n        $mail                    = new PHPMailer(true);\n        \n        $mail->SMTPDebug         = 0;\n        $mail->IsSMTP();\n        $mail->setLanguage(\'el\');\n        $mail->Host              = $setup->set_smtp_host;\n        $mail->Port              = $setup->set_smtp_port;\n        $mail->SMTPAuth          = true;\n        $mail->SMTPSecure        = $setup->set_smtp_use_ssl ? $setup->set_smtp_use_ssl : \'\';\n        //$mail->SMTPAuth          = $setup->set_smtp_use_ssl;\n        $mail->CharSet           = \'iso-8859-7\';\n\n        $mail->Username  = $setup->set_smtp_username;\n        $mail->Password  = $setup->set_smtp_password;\n\n        $mail->From              = $setup->set_smtp_from_address;\n        $mail->FromName          = iconv(\'UTF-8\',\'ISO-8859-7//IGNORE\',$setup->set_smtp_from_name);\n        $mail->AddReplyTo($setup->set_smtp_from_address,iconv(\'UTF-8\',\'ISO-8859-7//IGNORE\',$setup->set_smtp_from_name));\n        $mail->AddReplyTo        = $setup->set_smtp_from_address;\n        $mail->WordWrap          = 80;\n        $mail->IsHTML(true);\n\n\n        $sql = \"SELECT teacher.id, concat(if(teacher.surname is NULL,\'\',teacher.surname),if(teacher.name is NULL,\'\',concat(\' \',teacher.name)))\n                FROM teacher \n                INNER JOIN session_variables ON session_variables.teacher_id = teacher.id\n                WHERE session_variables.session_id = \'#session_id#\'\";\n        $rv = nuRunQuery($sql);\n    \n        if(db_num_rows($rv)==1){\n            $r= db_fetch_row($rv);\n            $teacher_id = $r[0];\n            $teacher_name = $r[1];\n        } else {\n            $teacher_id = 26;\n            $teacher_name = \"\";\n        }\n        \n        $system_url = get_system_url();\n        $school_name = get_school_name();\n        \n        $footer = \"<br>                    \n<hr style=\\\"width: 100%; height: 0px; background-color:#b04b00; color:#b04b00;border: 1px solid;\\\">	\n<span style=\\\"color: #525c66;line-height: 150%;font-size: 14px;font-family: Sans-serif;\\\">\nΤο μήνυμα αυτό το έστειλε ο καθηγητής $teacher_name μέσω του Σίσυφου. Αν θέλετε να απαντήσετε, παρακαλώ \".( $system_url==\'\' ? \"συνδεθείτε\": \"<a href=\\\"$system_url\\\">συνδεθείτε</a>\").\" και στείλτε και εσείς την απάντηση σας μέσω του Σίσυφου. Για λόγους ασφάλειας δεν κοινοποιείται η ηλεκτρονική διεύθυνση του αποστολέα.<br>\n<b>Παρακαλώ, μην απαντάτε σ’αυτό το email.</b>\n</span>\n<p></p>\n<hr style=\\\"width: 50%; margin-left:0; height: 0px; border-style: dotted; border-width: 1px 0px 0px; border-color: #525c66;\\\">\n<span style=\\\"color: #525c66;line-height: 150%;font-size: 10px;font-family: Sans-serif;\\\">\n<b>Διευκρίνιση ηλεκτρονικού ταχυδρομείου : </b>\n<br>\nΑυτό το ηλεκτρονικό μήνυμα (e-mail) μαζί με τα τυχόν επισυναπτόμενά του, είναι εμπιστευτικό και προορίζεται μόνο για χρήση από τα άτομα στα οποία απευθύνεται. Εάν δεν είστε ο προοριζόμενος παραλήπτης ή αρμόδιος για την παράδοση του μηνύματος στον προοριζόμενο παραλήπτη, παρακαλώ επιστρέψτε το στον αποστολέα και σας γνωρίζουμε ότι η αποθήκευση, ανάγνωση, μετάδοση, αναγραφή, αποκάλυψη, ανακοίνωση ή οποιασδήποτε άλλης μορφής χρήση οποιωνδήποτε πληροφοριών περιέχονται στο παρόν μήνυμα, δεν είναι σύννομη. \n<br>\nΠαρόλο που το $school_name έχει λάβει όλες τις απαιτούμενες προφυλάξεις για να διασφαλίσει ότι τα αποστελλόμενα μηνύματα ηλεκτρονικού ταχυδρομείου και τα όποια επισυναπτόμενα αρχεία τους έχουν ελεγχθεί για ιούς ή άλλο κακόβουλο λογισμικό, ωστόσο είναι ευθύνη του παραλήπτη να ελέγξει τη μη ύπαρξη ιών και κακόβουλου λογισμικού, πριν ανοίξετε οποιοδήποτε επισυναπτόμενο αρχείο. \n<br>\nΤο $school_name δεν αποδέχεται ουδεμία ευθύνη για το περιεχόμενο του παρόντος μηνύματος και σε καμία περίπτωση, δεν ευθύνεται για οιαδήποτε τυχόν ζημία λόγω αποθήκευσης ή ανάγνωσης του παρόντος, καθυστερημένης διαβίβασης, υποκλοπής, αλλοίωσης ή μόλυνσης με ιούς. Οι απόψεις που διατυπώνονται στο παρόν μήνυμα ανήκουν αποκλειστικά στον αποστολέα αυτού.\n</span>\n\";\n\n        $footer = iconv(\'UTF-8\',\'ISO-8859-7//IGNORE\',$footer);                                                                 \n                                                                \n        $sent=0;\n        $fail=0;\n        $wrong_address = 0;                                                        \n                                                                \n        $sql=\"SELECT \n                sender_id,\n	            email_address,\n	            email_subject,\n	            email_text,\n	            ifNULL(teacher_id,\'NULL\'),\n	            ifNULL(student_id,\'NULL\')\n            FROM email \n            WHERE id IN (#email_id#)\";\n        $retval = nuRunQuery($sql);\n    \n        if ($retval){\n            while($row = db_fetch_row($retval)){\n        \n                $fail_code=0;\n                $fail_comments=\'\';\n            \n                $email_address = $row[1];\n            \n                if(!filter_var($email_address, FILTER_VALIDATE_EMAIL)){\n                    $wrong_address++;\n                    $fail_code=1;\n                    $fail_comments=\'Μη έγκυρη email διεύθυνση\';\n                } else {\n                    $subject = $row[2];\n                    $subject =iconv(\'UTF-8\',\'ISO-8859-7//IGNORE\',$subject);\n        \n                    $content = $row[3];\n                    $content = iconv(\'UTF-8\',\'ISO-8859-7//IGNORE\',$content);\n                \n                    if($content && trim($content) != \'\'){\n                        $content = $content.$footer;\n	                    $mail->Subject  = $subject;\n	                    $mail->Body     = $content;\n	                    $mail->ClearAllRecipients();\n                        $mail->AddAddress($email_address);\n            \n                        try {\n                            $mail->Send();\n                            $sent++;\n                        } catch (phpmailerException $e) {\n                            $fail++;\n                            $fail_code = 2;\n                            $fail_comments = $e->errorMessage();;\n                        } catch (Exception $e) {\n                            $fail++;\n                            $fail_code = 3;\n                            $fail_comments = $e->getMessage();;\n                        }\n                    } else {\n                        $fail++;\n                        $fail_code = 2;\n                        $fail_comments = \'Αποτυχία στη μετατροπή της κωδικοποίησης του περιεχομένου του μηνύματος.\'; \n                    }\n                }\n            \n                $sql=\"  INSERT INTO email (\n                        id,\n                        sender_id,\n                        sent_at,\n                        email_address,\n                        email_subject,\n                        email_text,\n                        fail_code,\n                        fail_comments,\n                        teacher_id,\n                        student_id\n                        )\n                VALUES (\n                        NULL,\n                        \'$teacher_id\',\n                        NOW(),\n                        \'\".$row[1].\"\',\n                        \'\".esc($row[2]).\"\',\n                        \'\".esc($row[3]).\"\',\n                        \'\".$fail_code.\"\',\n                        \'\".(is_null($fail_comments) || $fail_comments==\'\' ? \'\' : $fail_comments).\"\',\n                        \".$row[4].\",\n                        \".$row[5].\"\n                    )\";\n                nuRunQuery($sql);\n            }\n            \n            $nuParameters = \"Στάλθηκαν \".$sent.\" Emails!\";\n            if($fail>0) {$nuParameters=$nuParameters.\"\\nΑπέτυχαν \".$fail.\" Emails!\";}\n            if($wrong_address>0) {$nuParameters=$nuParameters.\"\\nΛάθος σε \".$wrong_address.\" διευθύνσεις!\";}\n            \n        } else {\n            $nuParameters = \"Παρουσιάστηκε σφάλμα κατά την ανάκτηση των email!\\nΤα email δεν στάλθηκαν!\";\n        }\n    } else{\n	    $nuParameters = \"Προσοχή! Η λίστα των email δεν έχει οριστεί σωστά!\\nΤα email δεν στάλθηκαν!\"; \n    }\n} else{\n	$nuParameters = \"Τα e-mail δε μπόρεσαν να σταλούν! Το ακόλουθο μήνυμα λάθους εμφανίστηκε: \".$errorText; \n}\n\n','','0','2016-07-28 21:18:00','globeadmin','2019-07-25 12:37:34','globeadmin','2019-07-25 12:37:35','globeadmin','0'),('57e16edf9a33988','create_parent_mass_accounts','Δημιουργεί λογαριασμούς για τους γονείς που δεν έχουν ήδη λογαρισμό','manager','// Generates a strong password of N length containing at least one lower case letter,\n// one uppercase letter, one digit, and one special character. The remaining characters\n// in the password are chosen at random from those four sets.\n//\n// The available characters in each set are user friendly - there are no ambiguous\n// characters such as i, l, 1, o, 0, etc. This, coupled with the $add_dashes option,\n// makes it much easier for users to manually type or speak their passwords.\n//\n// Note: the $add_dashes option will increase the length of the password by\n// floor(sqrt(N)) characters.\n\nrequire_once(\'Classes/PHPExcel.php\');\n\nfunction generateStrongPassword($length = 9, $add_dashes = false, $available_sets = \'luds\'){\n	$sets = array();\n	if(strpos($available_sets, \'l\') !== false)\n		$sets[] = \'abcdefghjkmnpqrstuvwxyz\';\n	if(strpos($available_sets, \'u\') !== false)\n		$sets[] = \'ABCDEFGHJKMNPQRSTUVWXYZ\';\n	if(strpos($available_sets, \'d\') !== false)\n		$sets[] = \'23456789\';\n	if(strpos($available_sets, \'s\') !== false)\n		$sets[] = \'!@#$%&*?\';\n	$all = \'\';\n	$password = \'\';\n	foreach($sets as $set)\n	{\n		$password .= $set[array_rand(str_split($set))];\n		$all .= $set;\n	}\n	$all = str_split($all);\n	for($i = 0; $i < $length - count($sets); $i++)\n		$password .= $all[array_rand($all)];\n	$password = str_shuffle($password);\n	if(!$add_dashes)\n		return $password;\n	$dash_len = floor(sqrt($length));\n	$dash_str = \'\';\n	while(strlen($password) > $dash_len)\n	{\n		$dash_str .= substr($password, 0, $dash_len) . \'-\';\n		$password = substr($password, $dash_len);\n	}\n	$dash_str .= $password;\n	return $dash_str;\n}\n\nfunction validate_phone_number($phone_text){\n    \n    //eliminate every char except 0-9\n    $justNums = preg_replace(\"/[^0-9]/\", \'\', $phone_text);\n\n    if (strlen($justNums) == 12){ // it\'s probably a valid phone number with country code in front\n        return(\"+\".$justNums);    \n    } elseif (strlen($justNums) == 10){ // it\'s probably a valid greek phone number\n        return(\"+30\".$justNums);\n    } else {\n        return;\n    }\n}\n\n$filename = \'tmp/parent_account_export_#RECORD_ID#_\'.date(\"YmdHis\").\'.xls\';\n$objPHPExcel = new PHPExcel();\n$objPHPExcel->getProperties()->setCreator(\'Papadakakis Nektarios\')\n							 ->setLastModifiedBy(\'Papadakakis Nektarios\')\n							 ->setTitle(\'Sisyphos Parents Accounts Export\')\n							 ->setSubject(\'Accounts\')\n							 ->setDescription(\'Parents Accounts Export\')\n							 ->setKeywords(\'Excel Sisyphos Account Parent\')\n							 ->setCategory(\'Sisyphos\');\n			\n$objPHPExcel->getActiveSheet()->setTitle(\'Λογαριασμοί Γονέων\');\n$objPHPExcel->getDefaultStyle()->getFont()->setName(\'Arial\')\n                                          ->setSize(10);\n$objPHPExcel->getActiveSheet() ->getColumnDimension(\'A\') ->setWidth(6);\n$objPHPExcel->getActiveSheet() ->getColumnDimension(\'B\') ->setWidth(60);\n$objPHPExcel->getActiveSheet() ->getColumnDimension(\'C\') ->setWidth(30);\n$objPHPExcel->getActiveSheet() ->getColumnDimension(\'D\') ->setWidth(14);\n$objPHPExcel->getActiveSheet() ->getColumnDimension(\'E\') ->setWidth(9);\n$objPHPExcel->getActiveSheet() ->getColumnDimension(\'F\') ->setWidth(35);\n$objPHPExcel->getActiveSheet() ->getColumnDimension(\'G\') ->setWidth(35);\n$objPHPExcel->getActiveSheet() ->getColumnDimension(\'H\') ->setWidth(35);\n$objPHPExcel->getActiveSheet() ->getColumnDimension(\'I\') ->setWidth(21);\n$objPHPExcel->getActiveSheet() ->getColumnDimension(\'J\') ->setWidth(21);\n$objPHPExcel->getActiveSheet() ->getColumnDimension(\'K\') ->setWidth(24);\n$objPHPExcel->getActiveSheet() ->getColumnDimension(\'L\') ->setWidth(21);\n$objPHPExcel->getActiveSheet() ->getColumnDimension(\'M\') ->setWidth(21);\n$objPHPExcel->getActiveSheet() ->getColumnDimension(\'N\') ->setWidth(21);\n\n$sql=\"  SELECT \n            student.id,\n            grade.short_name,\n            \n            concat(\n                student.registration_number,\n                \' -\',\n                if(student.surname is NULL,\'\',concat (\' \',student.surname)),\n                if(student.name is NULL,\'\',concat (\' \',student.name)),\n                if(student.fathers_name is NULL,\'\',concat (\'<br>πατ. \',student.fathers_name))\n            ),\n            \n            student.phone1,\n            student.phone2,\n            student.mobile,\n            \n            student.parent_phone1,\n            student.parent_phone2,\n            student.parent_phone3,\n            \n            student.email,\n            student.parent_email,\n           \n            student.registration_number,\n            \n            concat(\n                ifNULL(student.parent_surname,\'\'),\n                if(student.parent_surname is NULL OR student.parent_name IS NULL,\'\',\' \'),    \n                ifNULL(student.parent_name,\'\')\n                ),\n            concat(\n                ifNULL(student.surname,\'\'),\n                if(student.surname is NULL OR student.name IS NULL,\'\',\' \'),    \n                ifNULL(student.name,\'\'),\n                \'  (Γονέας)\'\n                ),\n            student.parent_email2\n            \n        FROM student\n        INNER JOIN grade on grade.id=student.grade_id\n        WHERE \n            parent_user_id is null and \n            has_left_school=0\";\n\nif (\'#grade_id#\'!=\'#\'.\'grade_id\'.\'#\' && \'#grade_id#\'!=\'\'){\n    $sql = $sql.\"\n                and grade_id=\'#grade_id#\'\";\n}\n            \n$sql=$sql.\"\n        ORDER BY grade.short_name,student.surname,student.name,student.fathers_name\";\n\n$retval = nuRunQuery($sql);\n\n$i=0;\n\nif($retval){\n\n    print \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n\n        <STYLE TYPE=\\\"text/css\\\">\n            .sisTable, .sisTable TD{\n                font-size:7pt;\n            }\n            .sisTable TH{\n                font-size:7pt;\n            }\n        </STYLE>\n\n        <script type=\\\"text/javascript\\\">\n        function toggle69(source,class_name) {\n            checkboxes = document.getElementsByClassName(class_name);\n            for(var i=0, n=checkboxes.length;i<n;i++) {\n                id_name = checkboxes[i].id;\n                if (id_name.indexOf(\\\"+3069\\\") >= 0){\n                    checkboxes[i].checked = source.checked;\n                }\n            }\n        }\n\n        function make_indeterminate_phone(chk_name,phone_number) {\n            make_indeterminate(chk_name);\n            if (phone_number.indexOf(\\\"+3069\\\") >= 0){\n                var all_chk69 = document.getElementById(chk_name+\\\"69\\\");\n                all_chk69.indeterminate = true;\n            }\n        }\n\n        </script>\n    </head>\n    <body onload=\\\"adjustIframeHeight()\\\">\";\n\n    if(db_num_rows($retval)>0){\n        \n        $i=1;\n        \n        print (\"\n        <table cellspacing=0 CLASS=\\\"sisTable\\\">\n            <tr height=20> \n                <th width=35 align=center colspan=14>\n            \".\n            (is_writable(\'tmp\') ? \"<a href=\'\".$filename.\"\'>Λήψη Αρχείου Excel</a>\" : \"Το αρχείο Excel δεν μπόρεσε να δημιουργηθεί\")\n            .\"\n                </th>\n            </tr>\n            <tr height=30>\n                <th width=35 align=center rowspan=2>Τάξη</th>\n                <th width=220 align=center rowspan=2>Μαθητής</th>\n                <th width=150 align=center rowspan=2>Κηδεμόνας</th>\n                <th width=85 align=center rowspan=2>Όνομα Χρήστη</th>\n                <th width=65 align=center rowspan=2>Κωδικός</th>\n                <th width=150 align=center rowspan=2>\n                    Email Μαθητή<br>\n                    Όλα<input type=\\\"checkbox\\\" id=\\\"all_email_chk_1\\\" title=\\\"Επιλογή Όλων\\\" onclick=\\\"toggle(this,\'email_chk_1\')\\\">\n                </th>\n                <th width=150 align=center rowspan=2>\n                    Email Κηδεμόνα<br>\n                    Όλα<input type=\\\"checkbox\\\" id=\\\"all_email_chk_2\\\" title=\\\"Επιλογή Όλων\\\" onclick=\\\"toggle(this,\'email_chk_2\')\\\">\n                </th>\n                <th width=150 align=center rowspan=2>\n                    Email Κηδεμόνα 2<br>\n                    Όλα<input type=\\\"checkbox\\\" id=\\\"all_email_chk_3\\\" title=\\\"Επιλογή Όλων\\\" onclick=\\\"toggle(this,\'email_chk_3\')\\\">\n                </th>\n                <th width=270 align=center colspan=3>Τηλέφωνα Μαθητή</th>\n                <th width=270 align=center colspan=3>Τηλέφωνα Κηδεμόνα</th>\n            </tr>\");\n            \n        print (\"\n            <tr height=50>\n                \n                <th width=90 align=center>Τηλέφωνο 1<br>\n                    Όλα<input type=\\\"checkbox\\\" id=\\\"all_chk_1\\\" title=\\\"Επιλογή Όλων\\\" onclick=\\\"toggle(this,\'chk_1\')\\\">\n                    69<input CLASS=\\\"chk_1\\\" type=\\\"checkbox\\\" id=\\\"all_chk_169\\\" title=\\\"Επιλογή Όλων των 69...\\\" onclick=\\\"toggle69(this,\'chk_1\')\\\">\n                </th>\n                \n                <th width=90 align=center>Τηλέφωνο 2<br>\n                    Όλα<input type=\\\"checkbox\\\" id=\\\"all_chk_2\\\" title=\\\"Επιλογή Όλων\\\" onclick=\\\"toggle(this,\'chk_2\')\\\">\n                    69<input CLASS=\\\"chk_2\\\" type=\\\"checkbox\\\" id=\\\"all_chk_269\\\" title=\\\"Επιλογή Όλων των 69...\\\" onclick=\\\"toggle69(this,\'chk_2\')\\\">\n                </th>\n                \n                <th width=90 align=center>Κινητό<br>\n                    Όλα<input type=\\\"checkbox\\\" id=\\\"all_chk_3\\\" title=\\\"Επιλογή Όλων\\\" onclick=\\\"toggle(this,\'chk_3\')\\\">\n                    69<input CLASS=\\\"chk_3\\\" type=\\\"checkbox\\\" id=\\\"all_chk_369\\\" title=\\\"Επιλογή Όλων των 69...\\\" onclick=\\\"toggle69(this,\'chk_3\')\\\">\n                </th>\n                \n                <th width=90 align=center>Τηλέφωνο 1<br>\n                    Όλα<input type=\\\"checkbox\\\" id=\\\"all_chk_4\\\" title=\\\"Επιλογή Όλων\\\" onclick=\\\"toggle(this,\'chk_4\')\\\">\n                    69<input CLASS=\\\"chk_4\\\" type=\\\"checkbox\\\" id=\\\"all_chk_469\\\" title=\\\"Επιλογή Όλων των 69...\\\" onclick=\\\"toggle69(this,\'chk_4\')\\\">\n                </th>\n                \n                <th width=90 align=center>Τηλέφωνο 2<br>\n                    Όλα<input type=\\\"checkbox\\\" id=\\\"all_chk_5\\\" title=\\\"Επιλογή Όλων\\\" onclick=\\\"toggle(this,\'chk_5\')\\\">\n                    69<input CLASS=\\\"chk_5\\\" type=\\\"checkbox\\\" id=\\\"all_chk_569\\\" title=\\\"Επιλογή Όλων των 69...\\\" onclick=\\\"toggle69(this,\'chk_5\')\\\">\n                </th>\n                \n                <th width=90 align=center>Τηλέφωνο 3<br>\n                    Όλα<input type=\\\"checkbox\\\" id=\\\"all_chk_6\\\" title=\\\"Επιλογή Όλων\\\" onclick=\\\"toggle(this,\'chk_6\')\\\">\n                    69<input CLASS=\\\"chk_6\\\" type=\\\"checkbox\\\" id=\\\"all_chk_669\\\" title=\\\"Επιλογή Όλων των 69...\\\" onclick=\\\"toggle69(this,\'chk_6\')\\\">\n                </th>\n            </tr>\");\n            \n            $data = array(\n                    \'Τάξη\',\n                    \'Μαθητής\',\n                    \'Κηδεμόνας\',\n                    \'Όνομα Χρήστη\',\n                    \'Κωδικός\',\n                    \'Email Μαθητή\',\n                    \'Email Κηδεμόνα\',\n                    \'Email Κηδεμόνα 2\',\n                    \'Τηλέφωνο 1 Μαθητή\',\n                    \'Τηλέφωνο 2 Μαθητή\',\n                    \'Κινητό Τηλέφωνο Μαθητή\',\n                    \'Τηλέφωνο 1 Κηδεμόνα\',\n                    \'Τηλέφωνο 2 Κηδεμόνα\',\n                    \'Τηλέφωνο 3 Κηδεμόνα\'            \n                );         \n            \n            $objPHPExcel->setActiveSheetIndex(0);\n            $objPHPExcel->getActiveSheet()->fromArray($data,NULL,\'A\'.$i);\n            $objPHPExcel->getActiveSheet()->getStyle(\'A1:N1\')->getFont()->setBold(true);\n            \n        while($row = db_fetch_row($retval)){\n            \n            $i++;\n            \n            $user_name = $row[11].\"-parent\";\n            $sql=\"select count(*) from zzzsys_user where sus_login_name=\'\".$user_name.\"\'\"; \n            $rv = nuRunQuery($sql);\n            $cnt=db_fetch_row($rv);\n        \n            if($cnt[0]==0){\n                //User Creation\n                $id=nuID();\n                $pas=generateStrongPassword(6,false,\'lud\');\n            \n                $sql = \"insert into zzzsys_user (\n                    zzzsys_user_id,\n                    sus_zzzsys_user_group_id,\n                    sus_name,\n                    sus_email,\n                    sus_login_name,\n                    sus_login_password,\n                    zzzsys_user_log_added_at,\n                    zzzsys_user_log_added_by,\n                    zzzsys_user_log_changed_at,\n                    zzzsys_user_log_changed_by,\n                    zzzsys_user_log_viewed_at,\n                    zzzsys_user_log_viewed_by\n                    )\n                    values(\n                    \'\".$id.\"\',\n                    \'5717ba3eb32c252\',\n                    \'\".$row[13].\"\',\n                    \".(is_null($row[10]) ? \'NULL\' : \"\'\".$row[10].\"\'\").\",\n                    \'\".$user_name.\"\',\n                    md5(CONCAT(\'\".$user_name.\"\', \'\".$pas.\"\')),\n                    NOW(),\n                    \'globeadmin\',\n                    NOW(),\n                    \'globeadmin\',\n                    NOW(),\n                    \'globeadmin\'\n                    )\";\n	            nuRunQuery($sql);\n	        \n	            $sql=\"update student set parent_user_id=\'\".$id.\"\' where id=\".$row[0];\n	            nuRunQuery($sql);\n	            \n	            print (\"\n            <tr height=35>\n                <td align=center>\".(is_null($row[1]) || $row[1]==\'\'? \'&nbsp;\' : $row[1]).\"</td>\n                <td id=\\\"stdname_\".$row[0].\"\\\" align=left>\".(is_null($row[2]) || $row[2]==\'\'? \'&nbsp;\' : $row[2]).\"</td>\n                <td align=left>\".(is_null($row[12]) || $row[12]==\'\'? \'&nbsp;\' : $row[12]).\"</td>\n                <td id=\\\"username_\".$row[0].\"\\\" align=center>\".$user_name.\"</td>\n                <td id=\\\"pass_\".$row[0].\"\\\" align=center>\".$pas.\"</td>\n                \");\n                \n                \n                if(!is_null($row[9]) && $row[9]!=\'\'){\n                    if(filter_var($row[9], FILTER_VALIDATE_EMAIL)){\n                        print(\"\n                <td align=right>\".$row[9].\"<input type=\\\"checkbox\\\" CLASS=\\\"email_chk_1\\\" id=\\\"1,\".$row[0].\",\".$row[9].\"\\\" title=\\\"Επιλογή Email\\\" onclick=\\\"make_indeterminate(\'all_email_chk_1\')\\\"></td>\");\n                    } else {\n                        print(\"\n                <td style=\\\"background-color:red;\\\" align=right>\".$row[9].\"</td>\");\n                    }   \n                } else{\n                    print(\"\n                <td>&nbsp;</td>\");    \n                }\n\n                if(!is_null($row[10]) && $row[10]!=\'\'){\n                    if(filter_var($row[10], FILTER_VALIDATE_EMAIL)){\n                        print(\"\n                <td align=right>\".$row[10].\"<input type=\\\"checkbox\\\" CLASS=\\\"email_chk_2\\\" id=\\\"2,\".$row[0].\",\".$row[10].\"\\\" title=\\\"Επιλογή Email\\\" onclick=\\\"make_indeterminate(\'all_email_chk_2\')\\\"></td>\");\n                    } else {\n                        print(\"\n                <td style=\\\"background-color:red;\\\" align=right>\".$row[10].\"</td>\");\n                    }   \n                } else{\n                    print(\"\n                <td>&nbsp;</td>\");    \n                }\n                \n                if(!is_null($row[14]) && $row[14]!=\'\'){\n                    if(filter_var($row[14], FILTER_VALIDATE_EMAIL)){\n                        print(\"\n                <td align=right>\".$row[14].\"<input type=\\\"checkbox\\\" CLASS=\\\"email_chk_3\\\" id=\\\"3,\".$row[0].\",\".$row[14].\"\\\" title=\\\"Επιλογή Email\\\" onclick=\\\"make_indeterminate(\'all_email_chk_3\')\\\"></td>\");\n                    } else {\n                        print(\"\n                <td style=\\\"background-color:red;\\\" align=right>\".$row[14].\"</td>\");\n                    }   \n                } else{\n                    print(\"\n                <td>&nbsp;</td>\");    \n                }\n\n                if(!is_null($row[3]) && $row[3]!=\'\'){\n                    if($nb=validate_phone_number($row[3])){\n                        print(\"\n                <td align=right title=\\\"\".$nb.\"\\\">\".$row[3].\"<input type=\\\"checkbox\\\" CLASS=\\\"chk_1\\\" id=\\\"1_\".$row[0].\"_\".$nb.\"\\\" title=\\\"Επιλογή Τηλεφώνου\\\" onclick=\\\"make_indeterminate_phone(\'all_chk_1\',\'\".$nb.\"\')\\\"></td>\");\n                    } else {\n                        print(\"\n                <td style=\\\"background-color:red;\\\" align=right>\".$row[3].\"</td>\");\n                    }   \n                } else{\n                    print(\"\n                <td>&nbsp;</td>\");    \n                }\n\n                if(!is_null($row[4]) && $row[4]!=\'\'){\n                    if($nb=validate_phone_number($row[4])){\n                        print(\"\n                <td align=right title=\\\"\".$nb.\"\\\">\".$row[4].\"<input type=\\\"checkbox\\\" CLASS=\\\"chk_2\\\" id=\\\"1_\".$row[0].\"_\".$nb.\"\\\" title=\\\"Επιλογή Τηλεφώνου\\\" onclick=\\\"make_indeterminate_phone(\'all_chk_2\',\'\".$nb.\"\')\\\"></td>\");\n                    } else {\n                        print(\"\n                <td style=\\\"background-color:red;\\\" align=right>\".$row[4].\"</td>\");\n                    }   \n                } else{\n                    print(\"\n                <td>&nbsp;</td>\");    \n                }\n                \n                if(!is_null($row[5]) && $row[5]!=\'\'){\n                    if($nb=validate_phone_number($row[5])){\n                        print(\"\n                <td align=right title=\\\"\".$nb.\"\\\">\".$row[5].\"<input type=\\\"checkbox\\\" CLASS=\\\"chk_3\\\" id=\\\"1_\".$row[0].\"_\".$nb.\"\\\" title=\\\"Επιλογή Τηλεφώνου\\\" onclick=\\\"make_indeterminate_phone(\'all_chk_3\',\'\".$nb.\"\')\\\"></td>\");\n                    } else {\n                        print(\"\n                <td style=\\\"background-color:red;\\\" align=right>\".$row[5].\"</td>\");\n                    }   \n                } else{\n                    print(\"\n                <td>&nbsp;</td>\");    \n                }\n                \n                if(!is_null($row[6]) && $row[6]!=\'\'){\n                    if($nb=validate_phone_number($row[6])){\n                        print(\"\n                <td align=right title=\\\"\".$nb.\"\\\">\".$row[6].\"<input type=\\\"checkbox\\\" CLASS=\\\"chk_4\\\" id=\\\"1_\".$row[0].\"_\".$nb.\"\\\" title=\\\"Επιλογή Τηλεφώνου\\\" onclick=\\\"make_indeterminate_phone(\'all_chk_4\',\'\".$nb.\"\')\\\"></td>\");\n                    } else {\n                        print(\"\n                <td style=\\\"background-color:red;\\\" align=right>\".$row[6].\"</td>\");\n                    }   \n                } else{\n                    print(\"\n                <td>&nbsp;</td>\");    \n                }\n \n                if(!is_null($row[7]) && $row[7]!=\'\'){\n                    if($nb=validate_phone_number($row[7])){\n                        print(\"\n                <td align=right title=\\\"\".$nb.\"\\\">\".$row[7].\"<input type=\\\"checkbox\\\" CLASS=\\\"chk_5\\\" id=\\\"1_\".$row[0].\"_\".$nb.\"\\\" title=\\\"Επιλογή Τηλεφώνου\\\" onclick=\\\"make_indeterminate_phone(\'all_chk_5\',\'\".$nb.\"\')\\\"></td>\");\n                    } else {\n                        print(\"\n                <td style=\\\"background-color:red;\\\" align=right>\".$row[7].\"</td>\");\n                    }   \n                } else{\n                    print(\"\n                <td>&nbsp;</td>\");    \n                }\n\n                if(!is_null($row[8]) && $row[8]!=\'\'){\n                    if($nb=validate_phone_number($row[8])){\n                        print(\"\n                <td align=right title=\\\"\".$nb.\"\\\">\".$row[8].\"<input type=\\\"checkbox\\\" CLASS=\\\"chk_6\\\" id=\\\"1_\".$row[0].\"_\".$nb.\"\\\" title=\\\"Επιλογή Τηλεφώνου\\\" onclick=\\\"make_indeterminate_phone(\'all_chk_6\',\'\".$nb.\"\')\\\"></td>\");\n                    } else {\n                        print(\"\n                <td style=\\\"background-color:red;\\\" align=right>\".$row[8].\"</td>\");\n                    }   \n                } else{\n                    print(\"\n                <td>&nbsp;</td>\");    \n                }\n                \n                print (\"\n            </tr>\");\n	        \n            \n                $data = array(\n                    (is_null($row[1]) ? \'\' : $row[1]),\n                    (is_null($row[2]) ? \'\' : str_replace(\'<br>\',\' \',$row[2])),\n                    (is_null($row[12]) ? \'\' : $row[12]),\n                    $user_name,\n                    $pas,\n                    (is_null($row[9]) ? \'\' : $row[9]),\n                    (is_null($row[10]) ? \'\' : $row[10]),\n                    (is_null($row[14]) ? \'\' : $row[14]),\n                    (is_null($row[3]) ? \'\' : $row[3]),\n                    (is_null($row[4]) ? \'\' : $row[4]),\n                    (is_null($row[5]) ? \'\' : $row[5]),\n                    (is_null($row[6]) ? \'\' : $row[6]),\n                    (is_null($row[7]) ? \'\' : $row[7]),\n                    (is_null($row[8]) ? \'\' : $row[8])\n                );\n            } else {            // Ο Λογαριασμός υπάρχει ήδη..\n            \n                print (\"\n            <tr style=\\\"background-color:magenta;\\\" height=35>\n                <td align=center>\".(is_null($row[1]) || $row[1]==\'\'? \'&nbsp;\' : $row[1]).\"</td>\n                <td align=left>\".(is_null($row[2]) || $row[2]==\'\'? \'&nbsp;\' : $row[2]).\"</td>\n                <td align=left>\".(is_null($row[12]) || $row[12]==\'\'? \'&nbsp;\' : $row[12]).\"</td>\n                <td align=center>Υπαρκτός Λογ.</td>\n                <td align=center>-</td>\n                <td align=left>\".(is_null($row[9]) || $row[9]==\'\'? \'&nbsp;\' : $row[9]).\"</td>\n                <td align=left>\".(is_null($row[10]) || $row[10]==\'\'? \'&nbsp;\' : $row[10]).\"</td>\n                <td align=left>\".(is_null($row[14]) || $row[14]==\'\'? \'&nbsp;\' : $row[14]).\"</td>\n                <td align=left>\".(is_null($row[3]) || $row[3]==\'\'? \'&nbsp;\' : $row[3]).\"</td>\n                <td align=left>\".(is_null($row[4]) || $row[4]==\'\'? \'&nbsp;\' : $row[4]).\"</td>\n                <td align=left>\".(is_null($row[5]) || $row[5]==\'\'? \'&nbsp;\' : $row[5]).\"</td>\n                <td align=left>\".(is_null($row[6]) || $row[6]==\'\'? \'&nbsp;\' : $row[6]).\"</td>\n                <td align=left>\".(is_null($row[7]) || $row[7]==\'\'? \'&nbsp;\' : $row[7]).\"</td>\n                <td align=left>\".(is_null($row[8]) || $row[8]==\'\'? \'&nbsp;\' : $row[8]).\"</td>\n                \");\n            \n                $data = array(\n                    (is_null($row[1]) ? \'\' : $row[1]),\n                    (is_null($row[2]) ? \'\' : str_replace(\'<br>\',\' \',$row[2])),\n                    (is_null($row[12]) ? \'\' : $row[12]),\n                    \'Δεν Δημιουργήθηκε\',\n                    \'\',\n                    (is_null($row[9]) ? \'\' : $row[9]),\n                    (is_null($row[10]) ? \'\' : $row[10]),\n                    (is_null($row[14]) ? \'\' : $row[14]),\n                    (is_null($row[3]) ? \'\' : $row[3]),\n                    (is_null($row[4]) ? \'\' : $row[4]),\n                    (is_null($row[5]) ? \'\' : $row[5]),\n                    (is_null($row[6]) ? \'\' : $row[6]),\n                    (is_null($row[7]) ? \'\' : $row[7]),\n                    (is_null($row[8]) ? \'\' : $row[8])            \n                );         \n            }\n            \n            $objPHPExcel->setActiveSheetIndex(0);\n            $objPHPExcel->getActiveSheet()->fromArray($data,NULL,\'A\'.$i);\n        }\n        \n        print (\"\n        </table>\");\n        \n        if(is_writable(\'tmp\')){\n            $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, \'Excel5\');\n            $objWriter->save($filename);\n        }\n        \n    } else {\n        print \"<span CLASS=\\\"msg\\\">Όλοι οι γονείς διαθέτουν λογαριασμό!</span>\";\n    }\n    print \"\n    </body>\n</html>\";\n}\n\n','','0','2016-09-20 20:16:15','globeadmin','2021-09-07 20:24:39','globeadmin','2021-09-07 20:24:39','globeadmin','0'),('57e4314804e765c','count_parent_accounts','Μετρά πόσοι λογαριασμοί γονέων θα δημιουργηθούν','manager','$sql = \"    select count(*)\n            from student \n            where \n                parent_user_id is null and \n                has_left_school=0\";\n\nif (\'#grade_id#\'!=\'#\'.\'grade_id\'.\'#\' && \'#grade_id#\'!=\'\'){\n    $sql = $sql.\"\n                and grade_id=\'#grade_id#\'\";\n}\n$rv=nuRunQuery($sql);\n\nif($rv && db_num_rows($rv)>0){\n    $row = db_fetch_row($rv);\n    $txt = \'Θα δημιουργηθούν -\'.$row[0].\'- νέοι λογαριασμοί γονέων...\';\n} else {\n    $txt = \'Δεν θα δημιουργηθούν λογαριασμοί γονέων...\';\n}\n\nprint \"<html>\n<head>\n\n<meta charset=\\\"UTF-8\\\">\n\n<STYLE TYPE=\\\"text/css\\\">\n    .mytable, .mytable TD{\n        font-family:Verdana;\n        font-size:7pt;\n    }\n    .mytable TH{\n        font-family:Verdana;\n        font-size:8pt;\n    }\n</STYLE>\n\n</head>\n<body>\n<table border=0  cellspacing=0 CLASS=\\\"mytable\\\" width=100% height=100%>\n    <tr width=100% height=100%>\n        <th align=left valign=center>\n        \".$txt.\"\n        </th>\n    </tr>\n</table>\n</body>\n</html>\n\";\n','','0','2016-09-22 22:30:16','globeadmin','2016-09-22 22:53:37','globeadmin','2018-06-26 22:23:21','globeadmin','0'),('57ed57dd13deb39','create_student_responsible_list','Δημιουργεί λίστα μαθητών για επιλογή για τον μαζικό ορισμό υπευθυνου καθηγητή','manager','print \"<html>\n    <head>\n\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n\n        <STYLE TYPE=\\\"text/css\\\">\n            .sisTable TH{\n                font-size:110%;\n            }\n        </STYLE>\n\n    </head>\n    \n    <body onload=\\\"adjustIframeHeight()\\\">\";\n\n\n$sql=\"  SELECT \n            student.id,\n            grade.short_name,\n            concat(\n                student.registration_number,\n                \' -\',\n                if(student.surname is NULL,\'\',concat (\' \',student.surname)),\n                if(student.name is NULL,\'\',concat (\' \',student.name)),\n                if(student.fathers_name is NULL,\'\',concat (\' πατ. \',student.fathers_name))\n            ),\n            student.has_left_school,\n            teacher_id,\n            concat(if(teacher.surname is null,\'\',concat(teacher.surname,\' \')), IFNULL(teacher.name,\'\'))\n            \n        FROM student\n        INNER JOIN grade on grade.id=student.grade_id\n        LEFT JOIN teacher on teacher.id = student.teacher_id\n        \";\n        \n\n\nif(\'#class_id#\'!=\'#\'.\'class_id#\' && \'#class_id#\'!=\'\'){\n    $sql=$sql.\" INNER JOIN student_class on (student_class.student_id=student.id AND student_class.class_id=\'#class_id#\')\n    \";\n}\n\n$sql=$sql.\"\n    ORDER BY student.grade_id,student.surname,student.name,student.fathers_name\n\";\n   \n$retval = nuRunQuery($sql);\n\nif($retval) {\n    if(db_num_rows($retval)>0) {\n    \n        print (\"\n        <table cellspacing=0 CLASS=\\\"sisTable\\\" align=center>\n            <tr height=50>\n                <th width=50 align=center>Τάξη</th>\n                <th width=460 align=center>Μαθητής</th>\n                <th width=220 align=center>Υπεύθυνος Καθηγητής</th>\n                <th width=140 align=center>\n                    Επιλογή Μαθητή<br>\n                    Όλοι<input type=\\\"checkbox\\\" id=\\\"all_chk_1\\\" title=\\\"Επιλογή Όλων\\\" onclick=\\\"toggle(this,\'chk_1\')\\\" checked>\n                </th>\n            </tr>\");\n            \n        while($row = db_fetch_row($retval)) {\n            print (\"\n            <tr\".($row[3]==1 ? \" style=\\\"background-color:#FCBBFC;\\\"\" : \"\").\" height=35>\n                <td align=center>\".(is_null($row[1]) || $row[1]==\'\'? \'&nbsp;\' : $row[1]).\"</td>\n                <td align=left><b>\".(is_null($row[2]) || $row[2]==\'\'? \'&nbsp;\' : $row[2]).\"</b></td>\n                <td align=left>\".(is_null($row[5]) || $row[5]==\'\'? \'&nbsp;\' : $row[5]).\"</td>\n                <td align=center><input type=\\\"checkbox\\\" CLASS=\\\"chk_1\\\" id=\\\"\".$row[0].\"\\\" title=\\\"Επιλογή Μαθητή\\\" onclick=\\\"make_indeterminate(\'all_chk_1\')\\\" checked></td>\n            </tr>\");\n        }\n        \n        print (\"\n        </table>\");\n    } else{\n        print (\"<span CLASS=\\\"msg\\\">Δε βρέθηκαν Μαθητές...</span>\");\n    }\n} else{\n    print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν δεδομένα...</span>\");\n}\nprint \"\n    </body>\n</html>\";\n','','0','2016-09-29 21:05:17','globeadmin','2018-07-15 00:40:22','globeadmin','2018-07-15 00:40:22','globeadmin','0'),('57ed715f3c48a80','set_students_responsible','Ορίζει υπέυθυνο καθηγητή για τους μαθητές λίστας απο id','manager','$t_id = (\'#teacher_id#\' != \'#\'.\'teacher_id\'.\'#\' && \'#teacher_id#\' != \'\' ? \'#teacher_id#\' : \'NULL\');\n\nif(\'#student_id_list#\' != \'#\'.\'student_id_list\'.\'#\' && \'#student_id_list#\' != \'\'){\n    $sql=\"  UPDATE student \n                SET teacher_id=\".$t_id.\"\n            WHERE \n                student.id IN (#student_id_list#)\";\n    nuRunQuery($sql);\n\n    nuRunPHP(\'create_student_responsible_list\');\n} else {\n    $message = \'Παρακαλώ επιλέξτε πρώτα τους μαθητές!\';\n    nuDisplayError($message);    \n}','','0','2016-09-29 22:54:07','globeadmin','2016-10-01 12:45:07','globeadmin','2016-10-29 12:35:26','globeadmin','0'),('58038a698b9a3ec','find_next_student_comments','Βρίσκει τα σχόλια για τον επόμενο μαθητή στο ίδιο μάθημα','teacher','$sql = \"    SELECT\n                comment.id\n            FROM comment\n            INNER JOIN session_variables    ON (session_variables.subject_id = comment.subject_id)\n            INNER JOIN student_class        ON (student_class.class_id = session_variables.class_id AND student_class.student_id = comment.student_id)\n            INNER JOIN student 	            ON student.id   = comment.student_id\n            WHERE \n	            session_variables.session_id=\'#session_id#\'\n            ORDER BY student.surname,student.name,student.fathers_name\";\n$retval=nuRunQuery($sql);\n\n$found = false;\n$nuParameters = \'-1\';\n\nif($retval){\n    while($row=db_fetch_row($retval)){\n        if($found){\n            $nuParameters = $row[0];\n            break;\n        }\n        \n        if($row[0]==\'#RECORD_ID#\'){\n            $found = true;    \n        }  \n    }\n} else {\n    $nuError = \"Προσοχή! Παρουσιάστηκε πρόβλημα κατά την ανάκτηση των δεδομένων!\";    \n}\n  \n','','0','2016-10-16 17:10:49','globeadmin','2016-10-16 21:49:43','globeadmin','2018-07-30 19:23:54','globeadmin','0'),('58038a9f6de6bc9','find_prev_student_comments','Βρίσκει τα σχόλια για τον προηγούμενο μαθητή στο ίδιο μάθημα','teacher','$sql = \"    SELECT\n                comment.id\n            FROM comment\n            INNER JOIN session_variables    ON (session_variables.subject_id = comment.subject_id)\n            INNER JOIN student_class        ON (student_class.class_id = session_variables.class_id AND student_class.student_id = comment.student_id)\n            INNER JOIN student 	            ON student.id   = comment.student_id\n            WHERE \n	            session_variables.session_id=\'#session_id#\'\n            ORDER BY student.surname,student.name,student.fathers_name\";\n$retval=nuRunQuery($sql);\n\n$prev_id = \'-1\';\n$nuParameters = \'-1\';\n\nif($retval){\n    while($row=db_fetch_row($retval)){\n        \n        if($row[0]==\'#RECORD_ID#\'){\n            $nuParameters = $prev_id;\n            break;\n        } else {\n            $prev_id = $row[0];    \n        }\n    }\n} else {\n    $nuError = \"Προσοχή! Παρουσιάστηκε πρόβλημα κατά την ανάκτηση των δεδομένων!\";    \n}','','0','2016-10-16 17:11:43','globeadmin','2016-10-16 21:59:06','globeadmin','2018-07-28 21:45:44','globeadmin','0'),('580cf554357ba80','search_penalty','Αναζήτηση Ποινών','Teacher','print \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n        \n        <script type=\\\"text/javascript\\\">\n\n            function show_penalty_info(penalty_id){\n                parent.nuOpenForm(\'\',\'\', \'554517bdc18334d\', penalty_id,\'Εισαγωγή Ποινής\');\n                //parent.nuOpenFormInFrame(\'554517bdc18334d\',penalty_id)    \n            }\n\n        </script>\n\n    </head>\n\n    <body onload=\\\"adjustIframeHeight()\\\">\";\n\n$sql=\"  SELECT \n            penalty.id,\n            DATE_FORMAT(penalty.date_enforced,\'%d-%m-%Y\'),\n            period.short_name,\n            concat(grade.short_name,\'-\',student.surname,\' \',student.name,\' πατ. \',student.fathers_name),\n            type,\n            reason,\n            concat(if(teacher.surname is null,\'\',concat(teacher.surname,\' \')), IFNULL(teacher.name,\'\')),\n            carrier,\n            student.id,\n            grade.short_name\n        FROM penalty\n            INNER JOIN student          ON  penalty.student_id              = student.id\n            INNER JOIN grade            ON  grade.id                        = student.grade_id\n            LEFT JOIN teacher           ON  penalty.teacher_id              = teacher.id\n            LEFT JOIN period            ON  penalty.period_id               = period.id\";\n            \nif(\'#class_id#\'!=\'#\'.\'class_id#\' && \'#class_id#\'!=\'\'){\n    $sql=$sql.\" \n            INNER JOIN student_class on (student_class.student_id=student.id AND student_class.class_id=#class_id#)\";\n} \n\n$sql=$sql.\"            \n        WHERE\n\";\n\nif(\'#from_date#\'!=\'#\'.\'from_date#\' && \'#from_date#\'!=\'\'){\n    $sql=$sql.\" penalty.date_enforced >= \'#from_date#\' and \n    \";\n}\nif(\'#to_date#\'!=\'#\'.\'to_date#\' && \'#to_date#\'!=\'\'){\n    $sql=$sql.\" penalty.date_enforced <= \'#to_date#\' and \n    \";\n}\n\nif(\'#student_id#\'!=\'#\'.\'student_id#\' && \'#student_id#\'!=\'\'){\n    $sql=$sql.\" student.id = \'#student_id#\' and \n    \";\n    $is_student=1;\n}\n\nif(\'#teacher_id#\'!=\'#\'.\'teacher_id#\' && \'#teacher_id#\'!=\'\'){\n    $sql=$sql.\" penalty.teacher_id = \'#teacher_id#\' and \n    \";\n}\n\nif(\'#type_sumo#\'!=\'#\'.\'type_sumo#\' && \'#type_sumo#\'!=\'\'){\n    \n    $pieces = explode(\",\", \'#type_sumo#\');\n    foreach($pieces as &$piece){\n        $piece = \"\'\".$piece.\"\'\";\n    }\n    $types = implode(\",\",$pieces);\n    \n    $sql=$sql.\" penalty.type IN ($types) and \n    \";\n}\n\nif(\'#carrier#\'!=\'#\'.\'carrier#\' && \'#carrier#\'!=\'\'){\n    if(\'#carrier#\'==\'-\'){\n        $sql=$sql.\" penalty.carrier IS NULL and \n    \";        \n    } else {\n        $sql=$sql.\" penalty.carrier = \'#carrier#\' and \n    \";        \n    }\n    \n\n}\n\n$sql=$sql.\"\n    1=1\n    order by grade.short_name,student.surname,student.name,student.fathers_name,penalty.date_enforced,penalty.period_id\n\";\n      \n$retval=nuRunQuery($sql);\n\n//$show_info = (\'#nu_user_group#\'==\'globeadmin\' || \'#nu_user_group#\'==\'Administrators\' || \'#nu_user_group#\'==\'Managers\' || \'#nu_user_group#\'==\'AssistManagers\' ? true : false);\n$show_info = true;\nif($retval) {\n    if(db_num_rows($retval)>0) {\n    \n        print (\"\n        <table cellspacing=0 CLASS=\\\"sisTable\\\">\n            <tr height=45>\n                <th width=70 align=center>Ημ/νία</th>\n                <th width=40 align=center>Διδ.Ώρα</th>\n                <th width=200 align=center>Μαθητής</th>\n                <th width=100 align=center>Τύπος Ποινής</th>\n                <th width=200 align=center>Αιτιολόγηση</th>\n                <th width=100 align=center>Καθηγητής</th>\n                <th width=100 align=center>Φορέας Επιβολής</th>\n                \".($show_info ? \"<th width=50 align=center>Αναλυτικές Πληροφορίες</th>\" : \"\").\"\n            </tr>\");\n        \n        $color1 =\'LightSkyBlue\';\n        $color2 =\'#48D1CC\';\n        \n        $student_id=-1;\n        $color = $color2;\n        \n        while($row = db_fetch_row($retval)) {\n        \n            if($student_id != $row[8]){\n                $color = ($color==$color1 ? $color2 : $color1);\n                $student_id = $row[8];\n            }\n    \n            print (\"\n            <tr style=\\\"background-color:$color;\\\" height=35>\n                <td align=center>\".(is_null($row[1]) || $row[1]==\'\'? \'&nbsp;\' : $row[1]).\"</td>\n                <td align=center>\".(is_null($row[2]) || $row[2]==\'\'? \'&nbsp;\' : $row[2]).\"</td>\n                <td align=left>\".(is_null($row[3]) || $row[3]==\'\'? \'&nbsp;\' : $row[3]).\"</td>\n                <td align=left>\".(is_null($row[4]) || $row[4]==\'\'? \'&nbsp;\' : $row[4]).\"</td>\n                <td align=left>\".(is_null($row[5]) || $row[5]==\'\'? \'&nbsp;\' : $row[5]).\"</td>\n                <td align=left>\".(is_null($row[6]) || $row[6]==\'\'? \'&nbsp;\' : $row[6]).\"</td>\n                <td align=left>\".(is_null($row[7]) || $row[7]==\'\'? \'&nbsp;\' : $row[7]).\"</td>\n                \".($show_info ? \"<td align=center title=\\\"Πληροφορίες/Επεξεργασία\\\" onclick=\\\"show_penalty_info(\".$row[0].\")\\\" onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\"><img src=\\\"images/info.png\\\"></td>\" : \"\").\"\n             </tr>\");\n        }\n        \n        print (\"\n        </table>\");\n    }\n    else{\n        print (\"<span CLASS=\\\"msg\\\">Δε βρέθηκαν ποινές...</span>\");\n    }\n}\nelse{\n    print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν δεδομένα...</span>\");\n}\nprint \"\n    </body>\n</html>\";\n','','0','2016-10-23 20:37:24','globeadmin','2018-07-13 19:52:44','globeadmin','2021-10-25 15:50:23','globeadmin','0');
INSERT INTO `zzzsys_php` VALUES ('580e35e0d0e50a6','prev_students_absences','Εμφανίζει τις απουσίες προ έναρξης του συστήματος των μαθητών','Manager','print \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n        \n        <STYLE TYPE=\\\"text/css\\\">\n            .sisTable TH{\n                font-size:1.1em;\n            }\n            input { \n                text-align: right; \n            }\n    \n        </STYLE>\n\n        <script type=\\\"text/javascript\\\">\n\n            var TableBackgroundNormalColor = \\\"LightBlue\\\";\n            var TableBackgroundMouseoverColor = \\\"Gold\\\";\n            var TableBackgroundPrevColor = \\\"LightBlue\\\";\n            \n            function ChangeBackgroundColor(cell,input) {\n                TableBackgroundPrevColor = cell.parentNode.style.backgroundColor;\n                cell.parentNode.style.backgroundColor = TableBackgroundMouseoverColor;\n                input.select();\n            }\n            \n            function RestoreBackgroundColor(cell,input) {\n                cell.parentNode.style.backgroundColor = TableBackgroundPrevColor;\n                if(input.value==\'\') {input.value=\'0\'};\n            }\n\n            function validateInputKey(event,inp){\n            \n                var x = event.which || event.keyCode;\n         \n                switch(x) {\n                            // Backspace\n                    case 8:\n                        break;\n                        \n                            // Delete\n                    case 46:\n                        break;                        \n                            //TAB\n                    case 9:\n                        break;\n                             //ENTER\n                    case 13:\n                        break;                       \n                            //ESC\n                    case 27:\n                        break;\n                            //END\n                    case 35:\n                        break;                       \n                            //HOME\n                    case 36:\n                        break;\n                            //LEFT ARROW\n                    case 37:\n                        break;                       \n                            //UP ARROW\n                    case 38:\n                        break;\n                            //RIGHT ARROW\n                    case 39:\n                        break;                       \n                            //DOWN ARROW\n                    case 40:\n                        break;\n                    \n                            //NUMBERS\n                    case 48: \n                    case 49: \n                    case 50: \n                    case 51: \n                    case 52: \n                    case 53: \n                    case 54: \n                    case 55: \n                    case 56: \n                    case 57:\n                        break;\n                        \n                            //NUMPADS\n                    case 96:\n                    case 97:\n                    case 98:\n                    case 99:\n                    case 100:\n                    case 101:\n                    case 102:\n                    case 103:\n                    case 104:\n                    case 105:\n                        break;\n                    default:\n                        return false;\n                } \n                \n            }\n\n        </script>\n    </head>\n    <body onload=\\\"adjustIframeHeight()\\\">\";\n\n\n$sql=\"  SELECT \n            student.id,\n            grade.short_name,\n            student.registration_number,\n            student.surname,\n            student.name,\n            student.fathers_name,\n            prev_an_justified_absences,\n            ifNULL(prev_justified_absences,0),\n            ifNULL(student.has_left_school,0)\n        FROM student\n        INNER JOIN grade on grade.id=student.grade_id\n        ORDER BY student.grade_id,student.surname,student.name,student.fathers_name\n\";\n   \n$retval = nuRunQuery($sql);\n\nif($retval) {\n    if(db_num_rows($retval)>0) {\n    \n        print (\"\n        <table cellspacing=0 CLASS=\\\"sisTable\\\">\n            <tr height=40>\n                <th width=50 align=center>Τάξη</th>\n                <th width=50 align=center>A.M.</th>\n                <th width=200 align=center>Επώνυμο</th>\n                <th width=150 align=center>Όνομα</th>\n                <th width=150 align=center>Πατρώνυμο</th>\n                <th width=100 align=center>Αδικαιολόγητες</th>\n                <th width=100 align=center>Δικαιολογημένες</th>\n            </tr>\");\n            \n        while($row = db_fetch_row($retval)) {\n            print (\"\n            <tr\".($row[8]==1 ? \" style=\\\"background-color:#EE82EE;\\\"\" : \"\").\" height=30>\n                <td align=center>\".(is_null($row[1]) || $row[1]==\'\'? \'&nbsp;\' : $row[1]).\"</td>\n                <td align=center class=\\\"student_id\\\" id=\\\"\".$row[0].\"\\\">\".(is_null($row[2]) || $row[2]==\'\'? \'&nbsp;\' : $row[2]).\"</td>\n                <td align=left>\".(is_null($row[3]) || $row[3]==\'\'? \'&nbsp;\' : $row[3]).\"</td>\n                <td align=left>\".(is_null($row[4]) || $row[4]==\'\'? \'&nbsp;\' : $row[4]).\"</td>\n                <td align=left>\".(is_null($row[5]) || $row[5]==\'\'? \'&nbsp;\' : $row[5]).\"</td>\n                <td align=center> <input id=\\\"a_\".$row[0].\"\\\" type=\\\"text\\\" size=4 name=\\\"a_\".$row[0].\"\\\" value=\\\"\".$row[6].\"\\\" onkeydown=\\\"return validateInputKey(event,this);\\\" onfocus=\\\"ChangeBackgroundColor(this.parentNode,this)\\\" onblur=\\\"RestoreBackgroundColor(this.parentNode,this)\\\"></td>                \n                <td align=center> <input id=\\\"d_\".$row[0].\"\\\" type=\\\"text\\\" size=4 name=\\\"d_\".$row[0].\"\\\" value=\\\"\".$row[7].\"\\\" onkeydown=\\\"return validateInputKey(event,this);\\\" onfocus=\\\"ChangeBackgroundColor(this.parentNode,this)\\\" onblur=\\\"RestoreBackgroundColor(this.parentNode,this)\\\"></td>                \n            </tr>\");\n        }\n        print (\"\n        </table>\");\n    } else{\n        print (\"<span CLASS=\\\"msg\\\">Δε βρέθηκαν Μαθητές...</span>\");\n    }\n} else{\n    print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν δεδομένα...</span>\");\n}\nprint \"\n    </body>\n</html>\";\n','','0','2016-10-24 19:25:04','globeadmin','2018-07-15 13:26:48','globeadmin','2018-07-15 13:26:48','globeadmin','0'),('580f89b9d0103ee','update_prev_absences','Ενημερώνει τις απουσίες εκτός συστήματος για όλους τους μαθητές','Manager','$json_str = stripslashes(\'#adsence_JSON#\');\n$json = json_decode($json_str,true);\n\nif (json_last_error() === JSON_ERROR_NONE) {\n\n    foreach($json as $student){\n        $sql = \"    UPDATE student set\n                        prev_an_justified_absences=\".$student[1].\",\n                        prev_justified_absences=\".$student[2].\"\n                    WHERE id=\'\".$student[0].\"\'\";\n        nuRunQuery($sql);\n    }\n    \n    $nuParameters=\'Η ενημέρωση πραγματοποιήθηκε!\';\n\n} else {\n    nuDebug(\'Update Prev Absences : JSON ERROR -> #adsence_JSON# -> \'.$json_str);\n    $nuError = \"Παρουσιάστηκε σφάλμα κατά την ενημέρωση!\\nΤα Σύνολα των απουσιών εκτός συστήματος δεν ενημερώθηκαν!\";\n}\n    \n    ','','0','2016-10-25 19:35:05','globeadmin','2016-10-25 19:46:42','globeadmin','2018-01-18 12:19:18','globeadmin','0'),('580f8ebfe3c4e82','prev_absences_read','Διαβάζει τα σύνολα των απουσιών εκτός συστήματος απο αρχείο του excel','Manager','require_once(\'Classes/PHPExcel.php\');\n\nif(\'#FILES#\'!=\'\'){\n$S = stripslashes(\'#FILES#\');\n$J = json_decode($S);\n\nif (json_last_error() === JSON_ERROR_NONE) {\n    $name = $J[0]->{\'name\'};\n    $type = $J[0]->{\'type\'};\n    $error = $J[0]->{\'error\'};\n    $size  = $J[0]->{\'size\'};\n\n    $uploaddir= sys_get_temp_dir();\n    $uploadfile = $uploaddir .\'/\'.$name;\n\n    $inputFileName = $uploadfile;\n    $objPHPExcel = PHPExcel_IOFactory::load($inputFileName);\n    $objWorksheet = $objPHPExcel->getActiveSheet();\n    $highestRow = $objWorksheet->getHighestRow();\n\n    $sql=\"CREATE TEMPORARY TABLE IF NOT EXISTS #TABLE_ID# (\n                student_id INT NULL,\n                registration_number VARCHAR(100) NULL,\n                prev_an_justified_absences INT NULL,\n                prev_justified_absences INT NULL) ENGINE=MEMORY  DEFAULT CHARSET=utf8\";\n    $retval = nuRunQuery($sql);\n\n    $sql=\"DELETE FROM #TABLE_ID# WHERE 1\";\n    $retval = nuRunQuery($sql);\n\n    $lines_ignored = 0;\n    for ($row = 1; $row <= $highestRow; ++$row) {\n\n        $cellValueA = $objWorksheet->getCell(\'A\'.$row)\n                                    ->getFormattedValue();\n        $cellValueB = $objWorksheet->getCell(\'B\'.$row)\n                                    ->getFormattedValue();\n        $cellValueC = $objWorksheet->getCell(\'C\'.$row)\n                                    ->getFormattedValue();\n        if(is_numeric($cellValueA) && is_numeric($cellValueB) && is_numeric($cellValueC)){\n            $sql=\"INSERT INTO #TABLE_ID# VALUES (NULL,$cellValueA,$cellValueB,$cellValueC)\"; \n            nuRunQuery($sql);\n        } else {\n            $lines_ignored++;    \n        }\n    }\n\n    $sql=\"  UPDATE #TABLE_ID# \n            INNER JOIN student on #TABLE_ID#.registration_number=student.registration_number\n            SET \n                #TABLE_ID#.student_id=student.id\";\n    nuRunQuery($sql);\n\n    $sql=\"  SELECT \n                student_id,\n                registration_number,\n                prev_an_justified_absences,\n                prev_justified_absences\n            FROM #TABLE_ID#\";\n    $retval = nuRunQuery($sql);\n\n    $absences=array();\n\n    while($r = db_fetch_row($retval)){\n        if(!is_null($r[0])){\n            $absences[]= array($r[0],$r[2],$r[3]);    \n        } else {\n            $absences[]= array(\'-1\',$r[1],\'0\');\n        }        \n    }\n    \n    if($lines_ignored>0) $absences[]=array(\'-2\',$lines_ignored,\'0\');\n\n    $json_string = json_encode($absences);\n    $nuParameters = $json_string;\n} else {\n    nuDebug(\'Read Absence from Excel : JSON ERROR -> #FILES# -> \'.$S);\n    $nuError = \"Παρουσιάστηκε σφάλμα κατά την εισαγωγή του αρχείου!\\nΤα Σύνολα των απουσιών εκτός συστήματος δεν εισήχθησαν από το αρχείο Excel!\";\n}\n} else {\n    $nuError = \"Παρακαλώ επιλέξτε πρώτα αρχείο!\";\n}\n    \n    ','','0','2016-10-25 19:56:31','globeadmin','2016-10-25 21:21:05','globeadmin','2022-02-11 21:58:19','globeadmin','0'),('58146cff692dbf3','create_student_advisor_list','Δημιουργεί λίστα μαθητών για επιλογή για τον μαζικό ορισμό ατομικού συμβούλου','manager','print \"<html>\n    <head>\n\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n\n        <STYLE TYPE=\\\"text/css\\\">\n            .sisTable TH{\n                font-size:110%;\n            }\n            .sisTable TR{\n	            background-color: #ade6ad;\n            }\n        </STYLE>\n\n    </head>\n    \n    <body onload=\\\"adjustIframeHeight()\\\">\";\n\n\n$sql=\"  SELECT \n            student.id,\n            grade.short_name,\n            concat(\n                student.registration_number,\n                \' -\',\n                if(student.surname is NULL,\'\',concat (\' \',student.surname)),\n                if(student.name is NULL,\'\',concat (\' \',student.name)),\n                if(student.fathers_name is NULL,\'\',concat (\' πατ. \',student.fathers_name))\n            ),\n            student.has_left_school,\n            advisor_id,\n            concat(if(teacher.surname is null,\'\',concat(teacher.surname,\' \')), IFNULL(teacher.name,\'\'))\n            \n        FROM student\n        INNER JOIN grade on grade.id=student.grade_id\n        LEFT JOIN teacher on teacher.id = student.advisor_id\n        \";\n        \n\n\nif(\'#class_id#\'!=\'#\'.\'class_id#\' && \'#class_id#\'!=\'\'){\n    $sql=$sql.\" INNER JOIN student_class on (student_class.student_id=student.id AND student_class.class_id=\'#class_id#\')\n    \";\n}\n\n $sql=$sql.\" WHERE\n    \";\n \nif(\'#grade_id#\'!=\'#\'.\'grade_id#\' && \'#grade_id#\'!=\'\'){\n    $sql=$sql.\"student.grade_id = \'#grade_id#\' AND\n    \";\n}\n\nif(\'#gender#\'!=\'#\'.\'gender#\' && \'#gender#\'!=\'\' && \'#gender#\'!=\'Ο\'){\n    $sql=$sql.\"student.gender = \'#gender#\' AND\n    \";\n}\n\n$sql=$sql.\"\n    1=1\n    ORDER BY student.grade_id,student.surname,student.name,student.fathers_name\n\";\n   \n$retval = nuRunQuery($sql);\n\nif($retval) {\n    if(db_num_rows($retval)>0) {\n    \n        print (\"\n        <table cellspacing=0 CLASS=\\\"sisTable\\\" align=center>\n            <tr height=50>\n                <th width=50 align=center>Τάξη</th>\n                <th width=460 align=center>Μαθητής</th>\n                <th width=220 align=center>Ατομικός Σύμβουλος</th>\n                <th width=140 align=center>\n                    Επιλογή Μαθητή<br>\n                    Όλοι<input type=\\\"checkbox\\\" id=\\\"all_chk_1\\\" title=\\\"Επιλογή Όλων\\\" onclick=\\\"toggle(this,\'chk_1\')\\\" checked>\n                </th>\n            </tr>\");\n            \n        while($row = db_fetch_row($retval)) {\n            print (\"\n            <tr\".($row[3]==1 ? \" style=\\\"background-color:#FCBBFC;\\\"\" : \"\").\" height=35>\n                <td align=center>\".(is_null($row[1]) || $row[1]==\'\'? \'&nbsp;\' : $row[1]).\"</td>\n                <td align=left><b>\".(is_null($row[2]) || $row[2]==\'\'? \'&nbsp;\' : $row[2]).\"</b></td>\n                <td align=left>\".(is_null($row[5]) || $row[5]==\'\'? \'&nbsp;\' : $row[5]).\"</td>\n                <td align=center><input type=\\\"checkbox\\\" CLASS=\\\"chk_1\\\" id=\\\"\".$row[0].\"\\\" title=\\\"Επιλογή Μαθητή\\\" onclick=\\\"make_indeterminate(\'all_chk_1\')\\\" checked></td>\n            </tr>\");\n        }\n        \n        print (\"\n        </table>\");\n    } else{\n        print (\"<span CLASS=\\\"msg\\\">Δε βρέθηκαν Μαθητές...</span>\");\n    }\n} else{\n    print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν δεδομένα...</span>\");\n}\nprint \"\n    </body>\n</html>\";\n','','0','2016-10-29 12:33:51','globeadmin','2018-12-08 20:44:51','globeadmin','2022-02-11 22:00:07','globeadmin','0'),('58146d78c37daaa','set_students_advisor','Ορίζει ατομικό σύμβουλο για τους μαθητές λίστας απο id','manager','if(\'#student_id_list#\' != \'#\'.\'student_id_list\'.\'#\' && \'#student_id_list#\' != \'\'){\n\n    if(\'#advisor_id_sumo#\' == \'#\'.\'advisor_id_sumo\'.\'#\' || \'#advisor_id_sumo#\' == \'\'){\n        $sql=\"  UPDATE student \n                    SET advisor_id=NULL\n                WHERE \n                    student.id IN (#student_id_list#)\";\n        nuRunQuery($sql);    \n    } else if (strpos(\'#advisor_id_sumo#\', \',\') === FALSE){\n        $sql=\"  UPDATE student \n                    SET advisor_id=\'#advisor_id_sumo#\'\n                WHERE \n                    student.id IN (#student_id_list#)\"; \n        nuRunQuery($sql);\n    } else {\n        \n        $student_ids = explode(\",\", \"#student_id_list#\");\n        \n        $t_ids = explode(\",\", \"#advisor_id_sumo#\");\n        $teachers = array();\n        foreach($t_ids as $id) {\n            $teachers[] = array(\"id\"=>$id, \"numb_of_students\"=>0);\n        }\n        \n        $max_numb_of_students  = floor(count($student_ids) / count($teachers));\n        \n        foreach($student_ids as $student_id) {\n           \n            $available_teachers = array_filter($teachers, \n                                                function ($teacher) use ($max_numb_of_students) {\n                                                        return ($teacher[\'numb_of_students\'] < $max_numb_of_students);\n                                                    }\n                                                ); \n            \n            if(count($available_teachers)==0){\n                $available_teachers = array_filter($teachers, \n                                                function ($teacher) use ($max_numb_of_students) {\n                                                        return ($teacher[\'numb_of_students\'] == $max_numb_of_students);\n                                                    }\n                                                );     \n            }\n            \n            if(count($available_teachers)==0){      //ERROR\n                $message = \'Παρουσιάστηκε σφάλμα κατά τον ορισμό!!!!!\';\n                nuDisplayError($message);    \n            } else {\n                \n                $t = rand (1, count($available_teachers));\n                $i=1;\n                \n                foreach($available_teachers as $teacher){\n                    if($i==$t){\n                        $teacher_id = $teacher[\'id\'];\n                        break;\n                    } \n                    $i++;\n                }\n                \n                $sql=\"  UPDATE student \n                            SET advisor_id=\'$teacher_id\'\n                        WHERE \n                        student.id =\'$student_id\'\"; \n                nuRunQuery($sql);\n                \n                for($i=0;$i<count($teachers);$i++){\n                    if($teachers[$i][\'id\'] == $teacher_id){\n                        $teachers[$i][\'numb_of_students\'] = ($teachers[$i][\'numb_of_students\'])+1;\n                        nuDebug(\"Found : \".$teacher_id);\n                        break;\n                    }    \n                }\n            }\n        }\n    }\n\n    nuRunPHP(\'create_student_advisor_list\');\n    \n} else {\n    $message = \'Παρακαλώ επιλέξτε πρώτα τους μαθητές!\';\n    nuDisplayError($message);    \n}','','0','2016-10-29 12:35:52','globeadmin','2018-12-06 01:41:25','globeadmin','2022-02-11 21:59:50','globeadmin','0'),('581653a9568cda7','student_cards_absences_date','Βρίσκει τις διδασκαλίες/απουσίες του μαθητή σε μια συγκεκριμένη ημερομηνία','teacher','print \"\n<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">            \n                \n        <STYLE TYPE=\\\"text/css\\\">\n            .mytable TH{\n                font-size:1.1em;\n            }\n        </STYLE>\n\n    </head>\n\n    <body>\";\n\n\nif (\'#absence_date#\'!=\'#\'.\'absence_date\'.\'#\' && \'#absence_date#\'!=\'\'){\n\n    $absence_date = date_format(date_create_from_format(\'d-m-Y\',\'#absence_date#\'),\'Y-m-d\');\n    $day_of_week =  idate(\'w\', strtotime($absence_date))-1;        \n       \n    $sql=\"  SELECT count(*)\n            FROM holiday \n            INNER JOIN school_year  ON holiday.school_year_id=school_year.id\n            INNER JOIN school       ON school.school_year_id=school_year.id\n            WHERE holiday.holiday=\'\".$absence_date.\"\'\";\n    $rv1=nuRunQuery($sql);\n    \n    if($rv1){\n        $r1 = db_fetch_row($rv1);\n        if($r1[0]==0){\n            $sql=\"  SELECT count(*)\n                    FROM day \n                    WHERE id=\'\".$day_of_week.\"\'\";\n            $rv2=nuRunQuery($sql);\n            $r2 = db_fetch_row($rv2);\n            if($r2[0]!=0){\n            \n                $sql=\"select max(start_date) from timetable where start_date<=\'\".$absence_date.\"\'\"; \n                $rv3=nuRunQuery($sql);\n                $r3 = db_fetch_row($rv3);\n                $card_date=$r3[0];            \n            \n                print (\"\n        <table cellspacing=0 CLASS=\\\"sisTable\\\" align=center>\n            <tr height=45>\n                <th width=80 align=center>Ημερομηνία</th>\n                <th width=60 align=center>Ημέρα</th>\n                <th width=40 align=center>Ώρα</th>\n                <th width=50 align=center>Τμήμα</th>\n                <th width=200 align=center>Μάθημα</th>\n                <th width=150 align=center>Καθηγητής</th>\n                <th width=50 align=center>Αίθουσα</th>\n                <th width=120 align=center>Καταχωρητής</th>\n                <th width=160 align=center>Κατάσταση Διδασκαλίας</th>\n                <th width=60 align=center>Απουσία</th>\n                <th width=60 align=center>Δικαιολ.</th>\n                <th width=60 align=center>Μετράει</th>\n            </tr>\");\n                \n                $sql=\"DROP TEMPORARY TABLE IF EXISTS #TABLE_ID#\";\n                nuRunQuery($sql);\n\n                $sql=\"CREATE TEMPORARY TABLE #TABLE_ID# DEFAULT CHARACTER SET=utf8\n                    SELECT\n                        ifNULL(c.card_id,\'\')            AS t_card_id,\n	                    dp.day_name                     AS t_day_name,\n	                    dp.period_short_name            AS t_period_short_name,\n	                    ifNULL(c.class_short,\'\')        AS t_class_short_name,\n	                    c.subject_full_name             AS t_subject_full_name,\n	                    ifNULL(c.teacher_full_name,\'\')  AS t_teacher_full_name,\n	                    ifNULL(c.classroom_short,\'\')    AS t_classroom_short_name,\n	                    ifNULL(c.post_teacher_name,\'\')  AS t_post_teacher_name,\n	                    ifNULL(c.rg_no_lesson,\'-\')      AS t_no_lesson,\n	                    ifNULL(c.subject_name,\'\')       AS t_subject_name,\n	                    CAST(\'\' as CHAR(50))            AS t_absence_type,\n	                    CAST(\'\' as CHAR(20))            AS t_absence_justified,\n	                    CAST(\'\' as CHAR(50))            AS t_justified_reason_short_name,\n	                    CAST(\'\' as CHAR(20))            AS t_absence_counts\n	                from (	select day.id as day_id,day.name as day_name,day.short_name as day_short_name, period.id as period_id,period.name as period_name,period.short_name as period_short_name\n			                from day,period\n			                where day.id=\".$day_of_week.\"\n			                order by day.id,period.id) as dp\n	                left join (\n                                SELECT\n                                    active_card.id                      AS card_id,\n                	                active_card.day_id 			        AS day_id,\n	                                active_card.period_id 		        AS period_id,\n	                                day.name 					        AS day_name,	\n	                                period.short_name 			        AS period_short,\n	                                subject.name                        AS subject_name,\n                                    concat(ifNULL(subject.name,\'\'),if(subject_type.short_name is NULL, \'\', concat(\' (\',subject_type.short_name,\')\'))) as subject_full_name,	                                \n	                                classroom.short_name 		AS classroom_short,\n	                                class.short_name 			AS class_short,\n	                                concat(IF(teacher.surname IS NULL,\'\',teacher.surname),IF(teacher.surname IS NULL,\'\',\' \'),IF(teacher.name IS NULL,\'\',teacher.name)) as teacher_full_name,\n	                                rg.no_lesson                AS rg_no_lesson,\n	                                ifNUll(rg.teacher_short_name,t2.short_name) AS post_teacher_name\n                                FROM \n	                                (SELECT \n		                                card.id 			AS id,\n		                                card.valid_from 	AS valid_from,\n		                                card.subject_id 	AS subject_id,\n		                                card.teacher_id 	AS teacher_id,\n		                                card.class_id 		AS class_id,\n		                                card.classroom_id 	AS classroom_id,\n		                                card.day_id 		AS day_id,\n		                                card.period_id 		AS period_id\n	                                FROM card \n	                                WHERE card.valid_from =\'\".$card_date.\"\') as active_card \n	                                inner join subject 			on active_card.subject_id = subject.id \n	                                inner join teacher 			on active_card.teacher_id = teacher.id  \n	                                inner join day 				on active_card.day_id = day.id  \n	                                inner join period 			on active_card.period_id = period.id\n	                                inner join class 			on active_card.class_id = class.id	\n	                                left  join subject_type 	on subject.subject_type_id = subject_type.id  \n	                                left  join classroom 		on active_card.classroom_id = classroom.id\n	                                LEFT  JOIN teacher as t2    on class.post_teacher_id=t2.id\n	                                LEFT  JOIN \n	                                        (SELECT registered_card.id as id,\n	                                                card_id,\n	                                                no_lesson,\n	                                                teacher.short_name as teacher_short_name\n	                                        from registered_card\n	                                        left join teacher on teacher.id=registered_card.teacher_id\n	                                        where  DATE_FORMAT(card_date, \'%Y-%m-%d\')=\'\".$absence_date.\"\') as rg  \n	                                                            ON active_card.id=rg.card_id\n	                                                            \n                                WHERE  active_card.class_id in (select distinct class_id from student_class where student_id=\'#RECORD_ID#\')\n		                ) as c ON (c.day_id=dp.day_id AND c.period_id=dp.period_id)\n	\n                        order by dp.period_id\";\n                nuRunQuery($sql);\n                \n                $sql=\"select t_card_id from #TABLE_ID#\";\n                $rv4=nuRunQuery($sql);\n                while($r4 = db_fetch_row($rv4)) {\n                    if($r4!=\'\'){\n                        $sql = \"    SELECT  absence_reason.name,\n                                            if(absence.justified,\'Ναι\',\'Όχι\'),\n                                            justified_reason.short_name,\n                                            if(absence.counts,\'Ναι\',\'Όχι\')\n                                    FROM absence\n                                    INNER JOIN absence_reason ON absence.absence_reason_id = absence_reason.id\n                                    LEFT JOIN  justified_reason ON  absence.justified_reason_id     = justified_reason.id\n                                    WHRE \n                                        absence.absence_date    = \'\".$absence_date.\"\' AND\n                                        absence.card_id         = \'\".$r4[0].\"\' AND\n                                        absence.student_id      =\'#RECORD_ID#\'\"; \n                        $rv5=nuRunQuery($sql);\n                        \n                        if(db_num_rows($rv5>0)){\n                            $r5 = db_fetch_row($rv5);\n                            $sql = \"    UPDATE #TABLE_ID# SET\n                                            t_absence_type                  =\'\".$r5[0].\"\',\n	                                        t_absence_justified             =\'\".$r5[1].\"\',\n	                                        t_justified_reason_short_name   =\'\".$r5[2].\"\',\n	                                       t_absence_counts                 =\'\".$r5[3].\"\'\n                                        WHERE t_card_id=\'\".$r4[0].\"\'\";\n                            nuRunQuery($sql);\n                        }\n                        \n                        \n                    } // else no card - ignore\n                    \n                }\n                \n                $sql=\"select * from #TABLE_ID#\";\n                                       \n                $retval=nuRunQuery($sql);        \n                        \n                while($row = db_fetch_row($retval)) {\n                \n                    $color=\'lightblue\';\n                    \n                    if($row[9]==\'\'){\n                        $msg=\'Δεν υπάρχει διδασκαλία\';\n                        $color=\'LightGray\';\n                    } else if($row[8]==\'-\'){\n                        $msg=\'Δεν έχει καταχωρηθεί\';\n                        $color=\'red\';\n                    } else if($row[8]==\'1\'){\n                        $msg=\'Δεν έγινε μάθημα\';\n                        $color=\'yellow\';\n                    } else if($row[8]==\'0\'){\n                        $msg=\'Καταχωρήθηκε\';\n                        $color=\'lightgreen\';\n                    } else {\n                        $msg=\'Άγνωστο\';\n                    }\n                    print (\"\n            <tr style=\\\"background-color:$color;\\\" height=35>\n                <td align=center>\". date(\"d-m-Y\",strtotime($absence_date)).\"</td>\n                <td align=center>\". (is_null($row[1]) || $row[1]==\'\'? \'&nbsp;\' : $row[1]).\"</td>\n                <td align=center>\". (is_null($row[2]) || $row[2]==\'\'? \'&nbsp;\' : $row[2]).\"</td>\n                <td align=center>\". (is_null($row[3]) || $row[3]==\'\'? \'&nbsp;\' : $row[3]).\"</td>\n                <td align=left>\".   (is_null($row[4]) || $row[4]==\'\'? \'&nbsp;\' : $row[4]).\"</td>\n                <td align=left>\".   (is_null($row[5]) || $row[5]==\'\'? \'&nbsp;\' : $row[5]).\"</td>\n                <td align=center>\". (is_null($row[6]) || $row[6]==\'\'? \'&nbsp;\' : $row[6]).\"</td>\n                <td align=left>\".   (is_null($row[7]) || $row[7]==\'\'? \'&nbsp;\' : $row[7]).\"</td>\n                <td align=center>\".$msg.\"</td>\n            </tr>\");                    \n                    \n                }\n            } else {\n                print \"<span CLASS=\\\"msg\\\">Την ημέρα αυτή δε λειτούργει το σχολείο!<br>Δεν πραγματοποιήθηκαν διδασκαλίες!!</span>\";    \n            }\n        } else {\n            print \"<span CLASS=\\\"msg\\\">Ημέρα αργίας!<br>Δεν πραγματοποιήθηκαν διδασκαλίες!</span>\";    \n        } \n    } else{\n        print \"<span CLASS=\\\"msgError\\\">Παρουσιάστηκε σφάλμα κατά την ανάκτηση των δεδομένων...</span>\";    \n    }\n} else {\n   print \"<span CLASS=\\\"msg\\\">Παρακαλώ ορίστε την ημερομηνία...</span>\"; \n}\nprint \"\n    </body>\n</html>\";            \n','','0','2016-10-30 22:10:17','globeadmin','2018-07-15 23:08:55','globeadmin','2019-08-05 23:30:41','globeadmin','0'),('582c94ea0c52b86','notification_type_keys','Κλειδιά για ένα συγκεκριμένο τύπο ειδοποίησης','Manager','$sql = \"    SELECT \n                notification_key.name,\n                notification_key.description\n            FROM  notification_key\n            INNER JOIN notification_type_key    ON notification_key.id = notification_type_key.key_id\n            INNER JOIN notification_type        ON notification_type.id = notification_type_key.type_id\n        WHERE notification_type.id=\'#RECORD_ID#\'\n        ORDER BY name\";\n        \n$retval = nuRunQuery($sql);\n\nprint \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n        \n        <STYLE TYPE=\\\"text/css\\\">\n            .sisTable TD{\n                font-size:1.1em;\n                border:none;\n            }\n            .sisTable TH{\n                font-size:1.1em;\n                border:none;\n            }\n            .sisTable tr:nth-child(even){\n	            background-color: LightSteelBlue;\n            }	\n        </STYLE>\n\n    </head>\n    <body>\";\n\nif(!$retval){\n    print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν τα δεδομένα!</span>\");\n} else{\n    print (\"\n        <table cellspacing=0 CLASS=\\\"sisTable\\\">\n            <tr height=20> \n                <th width=700 colspan=2>Πεδία Αντικατάστασης</th>\n            </tr>\n            \");\n            \n    if(db_num_rows($retval)==0){\n    print (\"\n            <tr height=25> \n                <td width=700 colspan=2>Δεν βρέθηκαν πεδία!</td>\n            </tr>\n            \");\n    } else {\n\n        while($row = db_fetch_row($retval)){\n            print \"\n            <tr height=20>\n                <td width=200>\".$row[0]. \"</td>\n                <td width=500>\".$row[1]. \"</td>\n            </tr>\";\n            }\n    }\n    print (\"\n        </table>\");\n}\nprint \"\n    </body>\n</html>\";','','0','2016-11-16 19:18:34','globeadmin','2018-07-15 12:06:52','globeadmin','2022-01-08 20:45:42','globeadmin','0'),('58304c1fb6f7121','search_notification','Αναζήτηση ειδοποιήσεων με κριτίρια','manager','nuRunPHP(\'group_new_absence_notification\'); // Ομαδοποίηση ειδοποιήσεων για νέες απουσίες όπου αυτό απαιτείται\n\nprint \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n        \n        <STYLE TYPE=\\\"text/css\\\">\n            .sisTable TD{\n                font-size:7pt;\n            }\n        </STYLE>\n\n    </head>\n    <body onload=\\\"adjustIframeHeight()\\\">\";\n\n\n$sql=\"  SELECT\n            notification.id,\n            DATE_FORMAT(notification.occurred_at,\'%d-%m-%Y %T\'),\n            notification.content,\n            notification.is_parent,\n            notification.pending,\n            \n            notification_type.name,\n            \n            concat(if(grade.short_name is NULL,\'\',concat(grade.short_name,\' \')),student.registration_number,\'-\',if(student.surname is NULL,\'\',student.surname),if(student.name is NULL,\'\',concat(\' \',student.name)),if(student.fathers_name is NULL,\'\',concat(\' πατ. \',student.fathers_name))) as student_name,\n            email.fail_code,\n            ifNULL(email.id,\'-1\'),\n            IF(notification.is_parent=1,ifNUll(student.parent_email,\'\'),ifNULL(student.email,\'\'))\n            \n        FROM notification\n        INNER JOIN notification_type        ON notification.type_id             = notification_type.id\n        INNER JOIN notification_category    ON notification_type.category_id    = notification_category.id\n        INNER JOIN student                  ON notification.student_id          = student.id\n        LEFT JOIN grade                     ON student.grade_id                 = grade.id\n        LEFT JOIN email                     ON notification.email_id    = email.id\n        WHERE \n            1=1\n        \";\n\n\nif(\'#from_date#\'!=\'#\'.\'from_date#\' && \'#from_date#\'!=\'\'){\n    $sql=$sql.\"\n            AND notification.occurred_at >= \'#from_date# 00:00:00\'\n    \";\n}\n\nif(\'#to_date#\'!=\'#\'.\'to_date#\' && \'#to_date#\'!=\'\'){\n    $sql=$sql.\"\n            AND notification.occurred_at <= \'#to_date# 23:59:59\'\n    \";\n}\n\nif(\'#type_id_sumo#\'!=\'#\'.\'type_id_sumo#\' && \'#type_id_sumo#\'!=\'\'){\n    $sql=$sql.\"\n            AND notification.type_id IN (#type_id_sumo#)\n    \";\n}\n\nif(\'#student_id_sumo#\'!=\'#\'.\'student_id_sumo#\' && \'#student_id_sumo#\'!=\'\'){\n    $sql=$sql.\"\n            AND notification.student_id IN (#student_id_sumo#)\n    \";\n}\n\nif(\'#is_parent#\'!=\'#\'.\'is_parent#\' && \'#is_parent#\'!=\'\'){\n    $sql=$sql.\"\n            AND notification.is_parent = \'#is_parent#\'\n    \";\n}\n\nif(\'#pending#\'!=\'#\'.\'pending#\' && \'#pending#\'!=\'\'){\n    if(\'#pending#\'==\'1\' || \'#pending#\'==\'0\'){\n        $sql=$sql.\"\n            AND notification.pending = \'#pending#\'\n        \";\n    } else if(\'#pending#\'==\'-1\'){\n        $sql=$sql.\"\n            AND (email.fail_code is not NULL AND email.fail_code <> \'0\')\n        \";\n    }\n}\n\n$sql=$sql.\"\n    ORDER BY\n        grade.short_name,\n        student_name,\n        notification.is_parent,\n        notification_category.hierarchy,\n        notification_type.hierarchy,\n        notification.type_id,\n        notification.occurred_at,\n        notification.id\n\";\n\n$retval = nuRunQuery($sql);\n\nif($retval) {\n    if(db_num_rows($retval)>0) {\n        print (\"\n        <table cellspacing=0 CLASS=\\\"sisTable\\\" align=center>\n            <tr height=50>\n                <th width=30 align=center>AA</th>\n                <th width=270 align=center>Όνομα Μαθητή</th>\n                <th width=40 align=center>Πρός</th>\n                <th width=100 align=center>Διεύθυνση Παραλήπτη</th>\n                <th width=60 align=center>Ημερομηνία Συμβάντος</th>\n                <th width=80 align=center>Τύπος Ειδοποίησης</th>\n                <th width=150 align=center>Περιεχόμενο</th>\n                <th width=50 align=center>Σε Εκκρεμότητα</th>\n                <th width=30 align=center>Πληροφορίες Επεξεργασία</th>\n                <th width=60 align=center>\n                    Επιλογή<br>\n                    Όλα<input type=\\\"checkbox\\\" id=\\\"all_chk_1\\\" title=\\\"Επιλογή Όλων\\\" onclick=\\\"toggle(this,\'chk_1\')\\\" checked>\n                </th>\n            </tr>\");\n        \n        $i=1;    \n        while($row = db_fetch_row($retval)) {\n        \n            $color = ($row[8]==\'-1\' ? \"LightBlue\" : ($row[7]==\'0\' ? \'LightGreen\' : \"#OrangeRed\"));\n            \n            print (\"\n            <tr style=\\\"background-color:$color;\\\" height=30>\n                <td align=center>\".$i.\"</td>\n                <td align=left>\".(is_null($row[6]) || $row[6]==\'\'? \'&nbsp;\' : $row[6]).\"</td>\n                <td align=center title=\\\"\".($row[3]==\'1\' ?  \'Γονέα\' : \'Μαθητή\').\"\\\">\".($row[3]==\'1\' ?  \'Γονέα\' : \'Μαθητή\').\"</td>\n                <td align=center\".(filter_var($row[9], FILTER_VALIDATE_EMAIL) ? \'\' : \'  bgcolor=RED\').\">\".$row[9].\"</td>\n                <td align=left>\".(is_null($row[1]) || $row[1]==\'\'? \'&nbsp;\' : $row[1]).\"</td>\n                <td align=left>\".(is_null($row[5]) || $row[5]==\'\'? \'&nbsp;\' : $row[5]).\"</td>\n                <td align=left>\".(is_null($row[2]) || $row[2]==\'\'? \'&nbsp;\' : mb_substr(strip_tags($row[2]), 0, 40,\"UTF-8\").\'...\').\"</td>\n                <td align=center>\".($row[4]==\'1\'? \'ΝΑΙ\' : \'ΌΧΙ\').\"</td>\n                <td align=center title=\\\"Πληροφορίες/Επεξεργασία\\\" onclick=\\\"parent.nuOpenFormInFrame(\'5831a1813b1b74d\',\".$row[0].\")\\\" onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\"><img src=\\\"images/info.png\\\"></td>\n                <td align=center><input type=\\\"checkbox\\\" CLASS=\\\"chk_1\\\" id=\\\"\".$row[0].\"\\\" title=\\\"Επιλογή Μαθητή\\\" onclick=\\\"make_indeterminate(\'all_chk_1\')\\\" checked></td>\n            </tr>\");\n            $i++;    \n        }\n        \n        print (\"\n        </table>\");\n    } else{\n        print (\"<span CLASS=\\\"msg\\\">Δε βρέθηκαν Ειδοποιήσεις...</span>\");\n    }\n} else{\n    print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν δεδομένα...</span>\");\n}\nprint \"\n    </body>\n</html>\";\n','','0','2016-11-19 14:57:03','globeadmin','2018-07-16 10:46:13','globeadmin','2019-11-03 18:43:12','globeadmin','0'),('5831b9019b61979','show_email','Εμφανίζει ένα email σε iframe','teacher','print \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n\n        <STYLE TYPE=\\\"text/css\\\">\n            .sisTable TH{\n                font-size:7pt;\n            }\n            .sisTable TR{\n	            background-color: white;\n            }\n            \n            .mytable TH{\n                font-family:Verdana;\n                font-size:8pt;\n                border-style:none;\n                border-width:0px;\n                border-color:Gray;\n	            background-color:LightSalmon;\n            }\n\n            .mytable, .mytable TD{\n                font-family:Verdana;\n                font-size:8pt;\n                border-style:none;\n                border-width:0px;\n                border-color:Gray;\n            }\n            .mytable TR{\n	            background-color: inherit;\n            }\n            .mytable TH{\n	            background-color: inherit;\n            }\n            \n        </STYLE>\n\n        <script type=\\\"text/javascript\\\">\n            function resend(email_id) {\n                if(confirm(\\\"Το email αυτό θα σταλεί ξανά! \\\\nΕίστε Σίγουρος;\\\")){\n                    parent.showLoader();\n                    parent.nuSetHash(\'email_id\',email_id);\n                    parent.nuAjax(\'resend_email\',\'display_sent_result\',{async:true});\n                }\n            }\n        </script>\n\n    </head>\n    <body>\";\n\nif(\'#email_id#\'!=\'#\'.\'email_id#\' && \'#email_id#\'!=\'\'){\n    $sql=\"  SELECT\n                DATE_FORMAT(email.sent_at,\'%d-%m-%Y %H:%i:%s\'),\n                email_address,\n                email_subject,\n                email_text,\n                IF(fail_code= \'0\',\'Στάλθηκε\',IF(fail_code= \'1\',\'Λάθος Διεύθυνση\',\'Απέτυχε\')),\n                ifNull(fail_comments,\'\'),\n                fail_code\n        FROM email\n        WHERE id=\'#email_id#\'\";\n        \n    $retval=nuRunQuery($sql);\n\n    if($retval) {\n        if($row=db_fetch_row($retval)) {\n        \n        print (\"\n        <table cellspacing=0 CLASS=\\\"sisTable\\\">\");\n        \n        print (\"\n            <tr height=30>\n                <th align=center colspan=2 style=\\\"font-size:10pt;background-color:coral;\\\">\n                    Στοιχεία Μηνύματος Email\n                </th>\n            </tr>\");\n        \n        print (\"\n            <tr height=30>\n                <th>\n                    Στάλθηκε στίς:\n                </th>\n                <td>\n\".$row[0].\"\n                </td>\n            </tr>\");\n        \n        print (\"\n            <tr height=30>\n                <th>\n                    Προς:\n                </th>\n                <td>\n\".$row[1].\"\n                </td>\n            </tr>\");\n        print (\"\n            <tr height=30>\n                <th>\n                    Θέμα:\n                </th>\n                <td>\n\".$row[2].\"\n                </td>\n            </tr>\");\n        print (\"\n            <tr height=30>\n                <th>\n                    Μήνυμα:\n                </th>\n                <td>\n<table CLASS=\\\"mytable\\\">\n<tr>\n<td>\n\".$row[3].\"\n</td>\n</tr>\n</table>\n                </td>\n            </tr>\");\n        print (\"\n            <tr height=30>\n                <th>\n                    Κατάσταση:\n                </th>\n                <td style=\\\"color:\".($row[6]==\'0\' ? \"green\" : \"red\").\";\\\">\n                    <b>\".$row[4].\"</b>\n            \".(($row[6]==\'0\' || $row[6]==\'1\' ? \'\' : \" <img src=\\\"images/sendmail.png\\\" title=\\\"Αποστολή Ξανά\\\" width=20 onmousedown=\\\"resend(\'#email_id#\');\\\" onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"Restorecursor(this)\\\">\")).\"\n                </td>\n            </tr>\n        \");\n        if($row[5]!=\'\'){\n            print (\"\n            <tr height=30>\n                <th>\n                    Αποτυχία Αποστολής:\n                </th>\n                <td style=\\\"color:red;\\\">\n\".$row[5].\"\n                </td>\n            </tr>\");\n        }\n        print (\"\n        </table>\");\n        } else {\n            print (\"<span CLASS=\\\"msg\\\">Δε βρέθηκε το Email...</span>\");\n        }   \n    } else {\n        print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν δεδομένα...</span>\");    \n    }\n} else {\n    print (\"<span CLASS=\\\"msg\\\">Δε βρέθηκε Email...</span>\");  \n}\nprint \"\n    </body>\n</html>\";','','0','2016-11-20 16:53:53','globeadmin','2018-07-16 10:31:06','globeadmin','2018-07-16 12:30:28','globeadmin','0'),('5831f3f9cb4503b','delete_notification','Διαγράφει τις ειδοποιήσεις μιας λίστας απο id','manager','if(\'#notification_id_list#\' != \'#\'.\'notification_id_list\'.\'#\' && \'#notification_id_list#\' != \'\'){\n    $sql=\"  DELETE FROM notification where id in (#notification_id_list#)\";\n    nuRunQuery($sql);\n\n    nuRunPHP(\'search_notification\');\n} else {\n    $message = \'Παρακαλώ επιλέξτε πρώτα τις ειδοποιήσεις!\';\n    nuDisplayError($message);    \n}','','0','2016-11-20 21:05:29','globeadmin','2016-11-20 21:09:30','globeadmin','2016-11-21 18:21:56','globeadmin','0'),('5832d0065f53e2f','set_notification_as_pending','Ορίζει ως εκκρεμή τις ειδοποιήσεις από μια λίστα id','manager','if(\'#notification_id_list#\' != \'#\'.\'notification_id_list\'.\'#\' && \'#notification_id_list#\' != \'\'){\n    $sql=\"UPDATE notification SET pending=1 WHERE id in (#notification_id_list#)\";\n    nuRunQuery($sql);\n\n    nuRunPHP(\'search_notification\');\n} else {\n    $message = \'Παρακαλώ επιλέξτε πρώτα τις ειδοποιήσεις!\';\n    nuDisplayError($message);    \n}','','0','2016-11-21 12:44:22','globeadmin','2016-11-21 12:45:59','globeadmin','2016-11-21 12:45:59','globeadmin','0'),('58331f44ad5ba4e','send_notification','Στέλνει τις ειδοποιήσεις μιας λίστας απο id ή όσες είναι σε εκκρεμότητα','manager','//require_once(\"phpmailer/class.phpmailer.php\");\nuse PHPMailer\\PHPMailer\\PHPMailer;\nuse PHPMailer\\PHPMailer\\Exception;\n\nrequire \'PHPMailer/src/Exception.php\';\nrequire \'PHPMailer/src/PHPMailer.php\';\nrequire \'PHPMailer/src/SMTP.php\';\n\nnuRunPHP(\"sisyphos_lib\");\n\nfunction my_esc($str){\n    $db_params = nuRunQuery();\n    $link = mysqli_connect($db_params[0], $db_params[2], $db_params[3], $db_params[1]);\n\n    if (mysqli_connect_errno()) {\n        nuDebug(\"Connect failed: %s\\n\", mysqli_connect_error());\n        return \'\';\n    }\n    return(mysqli_real_escape_string($link,$str));\n}\n\nfunction nextID($table_name,$temp_key){\n\n    $temp_id    = nuID();\n	\n    $sql        = \"INSERT IGNORE $table_name SET $temp_key =  \'$temp_id\'\";        //-- insert to create next number\n    nuRunQuery($sql);\n    \n    $sql        = \"SELECT id FROM $table_name WHERE $temp_key = \'$temp_id\'\";    //-- get next number\n    $retval     = nuRunQuery($sql);\n    $row        = db_fetch_row($retval);\n	\n	$sql        = \"UPDATE $table_name SET $temp_key = NULL WHERE id = \'\".$row[0].\"\'\"; \n	nuRunQuery($sql);\n	\n    return $row[0];                                                        	    //-- return next number\n}\n\n$system_url = get_system_url();\n$school_name = get_school_name();\n\n$setup                      = $GLOBALS[\'nuSetup\'];                                      //-- Read SMTP AUTH Settings from zzsys_setup table	\n\nif (!empty($setup->set_smtp_username))          { $setup->set_smtp_username = trim($setup->set_smtp_username);}                       else{$errorText .= \"SMTP Username not set.<br>\";}\nif (!empty($setup->set_smtp_password)) 	        { $setup->set_smtp_password = trim($setup->set_smtp_password);}                       else{$errorText .= \"SMTP Password not set.<br>\";}\nif (!empty($setup->set_smtp_host))              { $setup->set_smtp_host = trim($setup->set_smtp_host);}                               else{$errorText .= \"SMTP Host not set.<br>\";}\nif (!empty($setup->set_smtp_from_address))      { $setup->set_smtp_from_address = trim($setup->set_smtp_from_address);}               else{$errorText .= \"SMTP From Address not set.<br>\";}\nif (!empty($setup->set_smtp_port))              { $setup->set_smtp_port = intval($setup->set_smtp_port);}                             else{$errorText .= \"SMTP PORT not set.<br>\";}\nif (!empty($setup->set_smtp_use_ssl))           { $setup->set_smtp_use_ssl = trim($setup->set_smtp_use_ssl);}                         else{$setup->set_smtp_use_ssl = \'\';}\nif (!empty($setup->set_smtp_from_name))         { $SMTPname = trim($setup->set_smtp_from_name);}	                              else{$SMTPname = \"nuBuilder\";}\n\nif ($errorText == \'\'){// Όλα καλά! Οι ρυθμίσεις είναι ΟΚ, να σταλουν οι ειδοποιήσεις\n\n//------------------------------------------------------------------------------------------------------------------------------------\n                // Ομαδοποίηση ειδοποιήσεων για νέες απουσίες όπου αυτό απαιτείται \n    if(\'#silence_mode#\' != \'1\'){\n        nuRunPHP(\'group_new_absence_notification\');\n    }\n//------------------------------------------------------------------------------------------------------------------------------------    \n                        \n    if(\'#TABLE_ID#\' != \'#\'.\'TABLE_ID\'.\'#\' && \'#TABLE_ID#\' != \'\'){\n        $tmp_table=\'#TABLE_ID#\';\n    } else {\n        $tmp_table=\'__\'.nuID().\'__\';\n    }\n    \n    $sql=\"DROP TABLE IF EXISTS \".$tmp_table;\n    nuRunQuery($sql);\n   \n    if(\'#notification_id_list#\' != \'#\'.\'notification_id_list\'.\'#\' && \'#notification_id_list#\' != \'\'){\n        $sql=\"CREATE TABLE \".$tmp_table.\" DEFAULT CHARACTER SET=utf8 SELECT * FROM notification where id in (#notification_id_list#)\";\n    } else {\n        $sql=\"CREATE TABLE \".$tmp_table.\" DEFAULT CHARACTER SET=utf8 SELECT * FROM notification where pending=1\";\n    }\n    nuRunQuery($sql);\n//------------------------------------------------------------------------------------------------------------------------------------\n                // αγνόηση συμβάντων εισαγωγής απουσιών για τα οποία δεν έχει ολοκληρωθεί η καταχώρηση των απουσιών του μαθητή την ημέρα αυτή \n    $absence_deleted = 0;\n    \n    $sql=\"  SELECT DISTINCT \n                student_id,\n                DATE_FORMAT(occurred_at, \'%Y-%m-%d\') \n            FROM \".$tmp_table.\" \n            WHERE \n                type_id=1 AND \n                occurred_at IS NOT NULL\";\n    $retval = nuRunQuery($sql);\n    \n    if($retval) {\n        while($row = db_fetch_row($retval)) {\n        \n            $sql=\"  SELECT count(distinct period_id)\n                    FROM card\n                    WHERE\n                        valid_from=(select max(c.valid_from) from card as c where c.valid_from<=\'\".$row[1].\"\') and\n                        day_id=\".(idate(\'w\', strtotime($row[1]))-1).\" and\n                        card.id not in (    select card_id \n                                            from registered_card\n                                            where DATE_FORMAT(registered_card.card_date, \'%Y-%m-%d\')=\'\".$row[1].\"\') and\n                    \'\".$row[1].\"\' not in (    select holiday.holiday \n                                                    from holiday \n                                                    inner join school_year on holiday.school_year_id=school_year.id\n                                                    inner join school on school.school_year_id=school_year.id) and\n                    card.class_id in (select distinct class_id from student_class where student_id=\'\".$row[0].\"\')\";\n            \n            $rv = nuRunQuery($sql);\n            $r = db_fetch_row($rv);\n            \n            if($r[0]>0){\n                \n                $sql=\"  SELECT count(*) \n                        FROM \".$tmp_table.\" \n                        WHERE \n                            student_id=\'\".$row[0].\"\' AND \n                            type_id=1 AND \n                            DATE_FORMAT(occurred_at, \'%Y-%m-%d\')=\'\".$row[1].\"\'\n                            \";                \n                $rv1 = nuRunQuery($sql);\n                $r1 = db_fetch_row($rv1);\n                $absence_deleted += $r1[0];\n                \n                $sql=\"  DELETE FROM \".$tmp_table.\" \n                        WHERE \n                            student_id=\'\".$row[0].\"\' AND \n                            type_id=1 AND \n                            DATE_FORMAT(occurred_at, \'%Y-%m-%d\')=\'\".$row[1].\"\'\n                            \";\n                nuRunQuery($sql);\n            }\n        }\n    }\n//---------------------------------------------------------------------------------------------------------------------------------------   \n    $sql=\"  SELECT DISTINCT student_id,is_parent FROM \".$tmp_table;\n    $retval = nuRunQuery($sql);\n\n    if($retval) {\n    \n        $sent=0;\n        $fail=0;\n        $wrong_address = 0; \n        \n        $notifications_total=0;\n        $notifications_total_sent=0;\n        $notifications_total_fail=0;\n            \n        if(db_num_rows($retval)>0) {\n            $mail                    = new PHPMailer(true);\n       \n            $mail->SMTPDebug         = 0;\n	        $mail->IsSMTP();\n	        $mail->setLanguage(\'el\');\n            $mail->Host              = $setup->set_smtp_host;\n            $mail->Port              = $setup->set_smtp_port;\n            $mail->SMTPAuth          = true;\n            $mail->SMTPSecure        = $setup->set_smtp_use_ssl ? $setup->set_smtp_use_ssl : \'\';\n            //$mail->CharSet           = \'iso-8859-7\';\n            \n            $mail->CharSet           = \'UTF-8\';\n            $mail->Encoding          = \'base64\';\n\n            $mail->Username  = $setup->set_smtp_username;\n            $mail->Password  = $setup->set_smtp_password;\n\n            $mail->From              = $setup->set_smtp_from_address;\n            $mail->FromName          = $setup->set_smtp_from_name;//iconv(\'UTF-8\',\'ISO-8859-7//IGNORE\',$setup->set_smtp_from_name);\n            $mail->AddReplyTo($setup->set_smtp_from_address,$setup->set_smtp_from_name);//iconv(\'UTF-8\',\'ISO-8859-7//IGNORE\',$setup->set_smtp_from_name));\n            $mail->AddReplyTo        = $setup->set_smtp_from_address;\n            $mail->WordWrap          = 80;\n            $mail->IsHTML(true);\n\n            $subject = \"Σίσυφος - Ενημερωτικό Δελτίο\";\n            //$subject = $subject_orig;//iconv(\'UTF-8\',\'ISO-8859-7//IGNORE\',$subject_orig);\n            $mail->Subject  = $subject;\n            \n            while($row = db_fetch_row($retval)) {\n                \n                $notifications_current = 0;\n                \n                $sql=\"  SELECT\n                        \".$tmp_table.\".id,\n                        DATE_FORMAT(\".$tmp_table.\".occurred_at,\'%d-%m-%Y %T\'),\n                        \".$tmp_table.\".content,\n            \n                        notification_category.id,\n                        notification_category.header,\n                        \n                        notification_type.id,\n                        notification_type.name,\n                        notification_type.header,\n                        \n                        student.registration_number,\n                        concat(if(student.surname is NULL,\'\',student.surname),if(student.name is NULL,\'\',concat(\' \',student.name)),if(student.fathers_name is NULL,\'\',concat(\' πατ. \',student.fathers_name))) as student_name,\n                        \n                        if(\'\".$row[1].\"\'=\'1\',ifNUll(student.parent_email,\'\'),ifNULL(student.email,\'\')) as target_email,\n                        ifNUll(student.parent_email2,\'\')\n                        \n                    FROM \".$tmp_table.\"\n                    INNER JOIN notification_type        ON \".$tmp_table.\".type_id             = notification_type.id\n                    INNER JOIN notification_category    ON notification_type.category_id    = notification_category.id\n                    INNER JOIN student                  ON \".$tmp_table.\".student_id          = student.id\n                    WHERE \".$tmp_table.\".student_id=\'\".$row[0].\"\' AND \".$tmp_table.\".is_parent=\'\".$row[1].\"\' AND TRIM(if(\'\".$row[1].\"\'=\'1\',ifNUll(student.parent_email,\'\'),ifNULL(student.email,\'\')))<>\'\'\n                    ORDER BY\n                        notification_category.hierarchy,\n                        notification_category.id,\n                        notification_type.hierarchy,\n                        \".$tmp_table.\".type_id,\n                        \".$tmp_table.\".occurred_at,\n                        \".$tmp_table.\".id\n                    \";\n                $rv = nuRunQuery($sql);\n                if(db_num_rows($rv)>0){\n                    \n                    $r = db_fetch_row($rv);\n                    \n                    $fail_code=0;\n                    $fail_comments=\'\';\n                    $email_address = trim($r[10]);\n                    $secondary_email_address = trim($r[11]);\n\n$content=\"\n		<table align=center style=\\\"width: 960px!important;border-spacing: 5px 5px;\\\">\n			<tr>\n				<td align=center style=\\\"color: #525c66;line-height: 150%;font-size: 16px;font-family: Sans-serif;\\\">\n					<h2>Σίσυφος - Ενημερωτικό Δελτίο</h2>\n				</td>\n			</tr>\n			<tr>\n				<td align=center>\n					<hr style=\\\"width: 100%; height: 0px; background-color:#b04b00; color:#b04b00;border: 1px solid;\\\">\n				</td>\n			</tr>\n			<tr>\n				<th align=left style=\\\"color: #525c66;line-height: 150%;font-size: 16px;font-family: Sans-serif;\\\">\n					Μαθητής : \".$r[9].\" (ΑΜ:\".$r[8].\")\n				</th>\n			</tr>\n			<tr>\n				<td align=center>\n					<hr style=\\\"width: 100%; height: 0px; background-color:#b04b00; color:#b04b00;border: 1px solid;\\\">\n				</td>\n			</tr>			\n			<tr>\n				<td align=left style=\\\"width: 960px;color: #525c66;line-height: 150%;font-size: 16px;font-family: Sans-serif;\\\">\n					<table style=\\\"width: 960px!important;margin-top: 0px;margin-bottom: 0px;margin-right: 0px;margin-left: 0px;border:0px;border-spacing: 0px 0px;\\\">                    \n                    \";\n                    \n                    $category_id = $r[3];\n                    $category_header = $r[4];\n                    \n                    $type_id = $r[5];\n                    $type_header = $r[7];\n                    \n                    $content.=\"\n						<tr>\n							<td width=100%>\n								\".$category_header.\"\n							</td>\n						</tr>                    \n                    \";\n                    \n                    $content.=\"\n						<tr>\n							<td >\n								\".$type_header.\"\n							</td>\n						</tr>                    \n                    \";\n                    do {\n                        \n                        $notifications_total++;\n                        $notifications_current++;\n                        \n                        if($category_id != $r[3]){\n                            $category_id = $r[3];\n                            $category_header = $r[4];\n                            $content.=\"\n						<tr>\n							<td >\n								\".$category_header.\"\n							</td>\n						</tr>                    \n                            \";                        \n                                \n                        }\n                        \n                        if($type_id != $r[5]){\n                            $type_id = $r[5];\n                            $type_header = $r[7];\n                            $content.=\"\n						<tr>\n							<td >\n								\".$type_header.\"\n							</td>\n						</tr>                    \n                            \";\n                        }\n \n                        $content.=\"\n						<tr>\n							<td >\n								\".$r[2].\"\n							</td>\n						</tr>                    \n                        \";\n                        \n                    } while($r = db_fetch_row($rv));\n                    \n                    $content .=\"\n                    					</table>\n				</td>\n			</tr>\n			<tr>\n				<td align=center>\n					<hr style=\\\"width: 100%; height: 0px; background-color:#b04b00; color:#b04b00;border: 1px solid;\\\">\n				</td>\n			</tr>			\n			<tr>\n				<td align=left style=\\\"color: #525c66;line-height: 150%;font-size: 14px;font-family: Sans-serif;\\\">\n					Το δελτίο αυτό δημιουργήθηκε στις \".date(\'d-m-Y H:i:s\').\" και στάλθηκε αυτόματα από το Σίσυφο. Για πληρέστερη ενημέρωση \".( $system_url==\'\' ? \"συνδεθείτε\": \"<a href=\\\"$system_url\\\">συνδεθείτε</a>\").\" στο σύστημα.<br><b>Παρακαλώ, μην απαντάτε σ’αυτό το email.</b>\n				</td>\n			</tr>\n			<tr>\n				<td align=center>\n					<hr style=\\\"width: 50%; margin-left:0; height: 0px; border-style: dotted; border-width: 1px 0px 0px; border-color: #525c66;\\\">\n				</td>\n			</tr>\n			<tr>\n				<td align=left style=\\\"color: #525c66;line-height: 150%;font-size: 10px;font-family: Sans-serif;\\\">\n					<b>Διευκρίνιση ηλεκτρονικού ταχυδρομείου : </b>\n                    <br>\n                    Αυτό το ηλεκτρονικό μήνυμα (e-mail) μαζί με τα τυχόν επισυναπτόμενά του, είναι εμπιστευτικό και προορίζεται μόνο για χρήση από τα άτομα στα οποία απευθύνεται. Εάν δεν είστε ο προοριζόμενος παραλήπτης ή αρμόδιος για την παράδοση του μηνύματος στον προοριζόμενο παραλήπτη, παρακαλώ επιστρέψτε το στον αποστολέα και σας γνωρίζουμε ότι η αποθήκευση, ανάγνωση, μετάδοση, αναγραφή, αποκάλυψη, ανακοίνωση ή οποιασδήποτε άλλης μορφής χρήση οποιωνδήποτε πληροφοριών περιέχονται στο παρόν μήνυμα, δεν είναι σύννομη. \n                    <br>\n                    Το $school_name σε καμία περίπτωση δεν ευθύνεται για οιαδήποτε τυχόν ζημία λόγω αποθήκευσης ή ανάγνωσης του παρόντος, καθυστερημένης διαβίβασης, υποκλοπής ή αλλοίωσης.\n				</td>\n			</tr>\n		</table>\n		            \";\n                    //$content_orig = $content;\n                    //$content = iconv(\'UTF-8\',\'ISO-8859-7//IGNORE\',$content);\n                    \n                    if(!filter_var($email_address, FILTER_VALIDATE_EMAIL)){\n                        $wrong_address++;\n                        $notifications_total_fail+=$notifications_current;\n                        $fail_code=1;\n                        $fail_comments=\'Μη έγκυρη email διεύθυνση\';\n                    } else {\n        \n	                    $mail->Body     = $content;\n	                    $mail->ClearAllRecipients();\n                        $mail->AddAddress($email_address);\n                        \n                        if($row[1]==\'1\' && filter_var($secondary_email_address, FILTER_VALIDATE_EMAIL))\n                            $mail->AddCC($secondary_email_address);\n            \n                        try {\n                            $mail->Send();\n                            $sent++;\n                            $notifications_total_sent+=$notifications_current;\n                        } catch (phpmailerException $e) {\n                            $fail++;\n                            $notifications_total_fail+=$notifications_current;\n                            $fail_code = 2;\n                            $fail_comments = $e->errorMessage();;\n                        } catch (Exception $e) {\n                            $fail++;\n                            $notifications_total_fail+=$notifications_current;\n                            $fail_code = 3;\n                            $fail_comments = $e->getMessage();;\n                        }\n                    }\n                    \n                    $e_id = nextID(\'email\',\'email_address\');\n                    \n                    $sql=\"  UPDATE email SET\n                                sender_id       =-1,\n                                sent_at         =NOW(),\n                                email_address   =\'\".$email_address.\"\',\n                                email_subject   =\'\".$subject.\"\',\n                                email_text      =\'\".(my_esc($content)).\"\',\n                                fail_code       =\'\".$fail_code.\"\',\n                                fail_comments   =\'\".(is_null($fail_comments) || $fail_comments==\'\' ? \'\' : $fail_comments).\"\',\n                                teacher_id      =-1,\n                                student_id      =\'\".$row[0].\"\'\n                            WHERE id=\'\".$e_id.\"\'\";\n\n                    nuRunQuery($sql);\n                    \n                    $sql = \"SELECT DISTINCT id from \".$tmp_table.\" where \".$tmp_table.\".student_id=\'\".$row[0].\"\' AND \".$tmp_table.\".is_parent=\'\".$row[1].\"\'\";\n                    $result = nuRunQuery($sql);\n                    $ids = array();\n                    while($id = db_fetch_row($result)) $ids[] = $id[0];\n                    \n                    if(count($ids) >0 ){\n                        $sql = \"UPDATE notification SET email_id=\'\".$e_id.\"\'\".($fail_code==0 ? \",pending=\'0\'\" : \"\").\" WHERE id IN (\".implode(\",\", $ids).\")\";\n                        nuRunQuery($sql);\n                    }\n                    \n                }\n            }\n            \n            $nuParameters=\'\';\n            \n            if($absence_deleted>0) {$nuParameters.=\"\\n\".$absence_deleted.\" ειδοποιήσεις καταχώρισης απουσιών αγνοήθηκαν (δεν έχει ολοκληρωθεί η καταχώριση ανά ημέρα και μαθητή)!\";}\n            if($notifications_total>0) {$nuParameters.=\"\\nΕπεξεργάστηκαν \".$notifications_total.\" ειδοποιήσεις!\";}\n            if($notifications_total_sent>0) {$nuParameters.=\"\\nΣτάλθηκαν \".$notifications_total_sent.\" ειδοποιήσεις!\";}\n            \n            if($notifications_total_fail>0) {$nuParameters.=\"\\nΑπέτυχαν \".$notifications_total_fail.\" ειδοποιήσεις!\";}\n    \n            if($sent>0) {$nuParameters.=\"\\nΣτάλθηκαν \".$sent.\" Emails!\";}\n            if($fail>0) {$nuParameters.=\"\\nΑπέτυχαν \".$fail.\" Emails!\";}\n            if($wrong_address>0) {$nuParameters.=\"\\nΛάθος σε \".$wrong_address.\" διευθύνσεις email!\";}\n            \n            $nuParameters=trim($nuParameters);\n\n        } else{\n            $nuError=\'\';\n            if($absence_deleted>0) {$nuError.=\"\\n\".$absence_deleted.\" ειδοποιήσεις καταχώρισης απουσιών αγνοήθηκαν (δεν έχει ολοκληρωθεί η καταχώριση ανά ημέρα και μαθητή)!\";}\n            $nuError .= \"\\nΔε βρέθηκαν ειδοποιήσεις για αποστολή...\";\n        }\n        \n        if(\'#silence_mode#\' != \'1\'){\n            $txt=date(\'d-m-Y H:i:s\').\"\\n---------------------------------------->\\n\";\n            if($nuError!=\'\'){\n                $txt.=$nuError.\"\\n\";\n            }\n    \n            if($nuParameters!=\'\'){\n                $txt.=$nuParameters.\"\\n\";\n            }\n            $txt.=\"<----------------------------------------\\n\";\n    \n            file_put_contents(\'tmp/send_notification_log.txt\', $txt.PHP_EOL , FILE_APPEND | LOCK_EX);\n    \n            if($fail>0 || $wrong_address>0){            // send email to school for failure\n    \n                $subject = \"Σίσυφος - Αναφορά Σφαλμάτων Αποστολής Ενημερωτικών Δελτίων\";//iconv(\'UTF-8\',\'ISO-8859-7//IGNORE\',\"Σίσυφος - Αναφορά Σφαλμάτων Αποστολής Ενημερωτικών Δελτίων\");\n        \n                $content= \"Σας ενημερώνουμε ότι κατά την αυτόματη αποστολή των ενημερωτικών δελτίων : \\n\\n\".$nuParameters;\n    	        //$content = iconv(\'UTF-8\',\'ISO-8859-7//IGNORE\',$content);\n	    \n		        $mail                    = new PHPMailer();\n	            $mail->IsSMTP();\n	            $mail->setLanguage(\'el\');\n	            $mail->Host              = $setup->set_smtp_host;\n	            $mail->Port              = $setup->set_smtp_port;\n	            $mail->SMTPAuth          = true;\n	            $mail->SMTPSecure        = $setup->set_smtp_use_ssl ? $setup->set_smtp_use_ssl : \'\';\n	            //$mail->CharSet           = \'iso-8859-7\';\n                $mail->CharSet           = \'UTF-8\';\n                $mail->Encoding          = \'base64\';\n                \n	            $mail->Username  = $setup->set_smtp_username;\n	            $mail->Password  = $setup->set_smtp_password;\n	\n	            $mail->From              = $setup->set_smtp_from_address;\n	            $mail->FromName          = $setup->set_smtp_from_name;//iconv(\'UTF-8\',\'ISO-8859-7//IGNORE\',$setup->set_smtp_from_name);\n\n	            $mail->AddAddress($setup->set_smtp_from_address,$setup->set_smtp_from_name);\n	            $mail->AddReplyTo($setup->set_smtp_from_address,$setup->set_smtp_from_name);\n\n	            $mail->AddReplyTo        = $setup->set_smtp_from_address;\n	            $mail->AddAddress        = $setup->set_smtp_from_address;\n	            $mail->WordWrap          = 80;\n	            $mail->IsHTML(false);\n	            $mail->Subject           = $subject;\n	            $mail->Body              = $content;\n                $mail->Send();\n            }\n        } \n    } else{\n        $nuError = \'Δεν ανακτήθηκαν δεδομένα...\';\n    }\n    \n    $sql=\"DROP TABLE IF EXISTS \".$tmp_table;\n    nuRunQuery($sql);\n    \n} else{\n	$nuError = \"Οι ειδοποιήσεις δε μπορεσαν να σταλούν! Το ακόλουθο μήνυμα λάθους εμφανίστηκε: \".$errorText; \n}\n\n\n\n','','1','2016-11-21 18:22:28','globeadmin','2022-01-23 22:09:26','globeadmin','2022-09-24 21:39:01','globeadmin','0'),('583a9ecc6d7c907','notification_add_lib','Βιβλιοθήκη για την προσθήκη νέων ειδοποιήσεων','teacher','function esc($str){\n    $db_params = nuRunQuery();\n    $link = mysqli_connect($db_params[0], $db_params[2], $db_params[3], $db_params[1]);\n\n    if (mysqli_connect_errno()) {\n        nuDebug(\"Connect failed: %s\\n\", mysqli_connect_error());\n        return \'\';\n    }\n    return(mysqli_real_escape_string($link,$str));\n}\n\nfunction nextID($table_name,$temp_key){\n\n    $temp_id    = nuID();\n	\n    $sql        = \"INSERT IGNORE $table_name SET $temp_key =  \'$temp_id\'\";        //-- insert to create next number\n    nuRunQuery($sql);\n    \n    $sql        = \"SELECT id FROM $table_name WHERE $temp_key = \'$temp_id\'\";    //-- get next number\n    $retval     = nuRunQuery($sql);\n    $row        = db_fetch_row($retval);\n	\n	$sql        = \"UPDATE $table_name SET $temp_key = NULL WHERE id = \'\".$row[0].\"\'\"; \n	nuRunQuery($sql);\n	\n    return $row[0];                                                        	    //-- return next number\n}\n\nfunction new_absence_notification($absence_id){\n\n$sql = \"    SELECT \n                absence.id,	\n                DATE_FORMAT(absence.absence_date,\'%d-%m-%Y\'),\n                absence.comments,\n                \n                absence_reason.name,\n                period.name,\n                ifNULL(subject.name,subject.short_name),\n                concat(ifNULL(teacher.surname,\'\'),if(teacher.surname is NULL OR teacher.name is NULL,\'\',\' \'),ifNULL(teacher.name,\'\')),\n                \n                student_id,\n                student.email,\n                student.new_absence_notification,\n                student.parent_email,\n                student.parent_new_absence_notification,\n                \n                notification_type.content,\n                CONCAT(absence.absence_date,\' \', period.start_time)\n                \n            FROM absence\n            INNER JOIN absence_reason    ON  absence.absence_reason_id   = absence_reason.id\n            INNER JOIN student           ON  absence.student_id          = student.id\n            INNER JOIN card              ON  absence.card_id             = card.id\n            INNER JOIN period            ON  card.period_id              = period.id\n            INNER JOIN subject           ON  card.subject_id             = subject.id\n            INNER JOIN teacher           ON  card.teacher_id             = teacher.id\n            INNER JOIN notification_type ON  notification_type.id        = 1\n            WHERE \n                absence.id = \'$absence_id\' AND\n                notification_type.active = 1 AND\n                student.has_left_school = 0 AND\n                ((student.email IS NOT NULL AND TRIM(student.email)<>\'\' AND student.new_absence_notification=1)\n                OR (student.parent_email IS NOT NULL AND TRIM(student.parent_email)<>\'\' AND student.parent_new_absence_notification=1))\";\n    \n    $retval     = nuRunQuery($sql);\n    \n    if($retval && db_num_rows($retval)==1){\n        $row        = db_fetch_row($retval);\n        \n        $content    = $row[12];\n        \n        $content = str_replace(\'-date-\',$row[1],$content);\n        $content = str_replace(\'-period-\',$row[4],$content);\n        $content = str_replace(\'-reason-\',$row[3],$content);\n        $content = str_replace(\'-subject-\',$row[5],$content);\n        $content = str_replace(\'-teacher-\',$row[6],$content);\n\n        if($row[9]==\'1\' && !is_null($row[8]) && trim($row[8])<>\'\'){\n            $sql=\"  INSERT INTO notification(\n                        id,	\n                        added_at,\n                        type_id,	\n                        content,\n                        student_id,\n                        is_parent,\n                        pending,\n                        email_id,\n                        associated_id,\n                        occurred_at\n                    ) VALUES (\n                        NULL,\n                        NOW(),\n                        1,\n                        \'\".esc($content).\"\',\n                        \'\".$row[7].\"\',\n                        0,\n                        1,\n                        NULL,\n                        \'$absence_id\',\n                        \'\".$row[13].\"\'\n                    )\n                \";\n            nuRunQuery($sql);\n        }\n      \n        if($row[11]==\'1\' && !is_null($row[10]) && trim($row[10])<>\'\'){\n            $sql=\"  INSERT INTO notification(\n                        id,	\n                        added_at,\n                        type_id,	\n                        content,\n                        student_id,\n                        is_parent,\n                        pending,\n                        email_id,\n                        associated_id,\n                        occurred_at\n                    ) VALUES (\n                        NULL,\n                        NOW(),\n                        1,\n                        \'\".esc($content).\"\',\n                        \'\".$row[7].\"\',\n                        1,\n                        1,\n                        NULL,\n                        \'$absence_id\',\n                        \'\".$row[13].\"\'\n                    )\n                \";\n            nuRunQuery($sql);              \n        }\n    }\n}\n\nfunction justify_absence_notification($absence_id){\n    $sql = \" SELECT \n                absence.id,	\n                DATE_FORMAT(absence.absence_date,\'%d-%m-%Y\'),\n                absence.comments,\n                \n                absence_reason.name,\n                period.name,\n                ifNULL(subject.name,subject.short_name),\n                concat(ifNULL(teacher.surname,\'\'),if(teacher.surname is NULL OR teacher.name is NULL,\'\',\' \'),ifNULL(teacher.name,\'\')),\n                \n                student_id,\n                student.email,\n                student.justify_absence_notification,\n                student.parent_email,\n                student.parent_justify_absence_notification,\n                \n                notification_type.content,\n                justified_reason.name,\n                if(absence.counts,\'ΝΑΙ\',\'ΌΧΙ\'),\n                CONCAT(absence.absence_date,\' \', period.start_time)\n                \n            FROM absence\n            INNER JOIN absence_reason    ON  absence.absence_reason_id   = absence_reason.id\n            INNER JOIN student           ON  absence.student_id          = student.id\n            INNER JOIN justified_reason  ON  absence.justified_reason_id = justified_reason.id\n            INNER JOIN card              ON  absence.card_id             = card.id\n            INNER JOIN period            ON  card.period_id              = period.id\n            INNER JOIN subject           ON  card.subject_id             = subject.id\n            INNER JOIN teacher           ON  card.teacher_id             = teacher.id\n            INNER JOIN notification_type ON  notification_type.id        = 2\n            WHERE \n                absence.id = \'$absence_id\' AND\n                notification_type.active = 1 AND\n                absence.justified = 1 AND\n                ((student.email IS NOT NULL AND TRIM(student.email)<>\'\' AND student.justify_absence_notification=1)\n                OR (student.parent_email IS NOT NULL AND TRIM(student.parent_email)<>\'\' AND student.parent_justify_absence_notification=1))\";\n    \n    $retval     = nuRunQuery($sql);\n    \n    if($retval && db_num_rows($retval)==1){\n        $row        = db_fetch_row($retval);\n        \n        $content    = $row[12];\n\n        $content = str_replace(\'-date-\',$row[1],$content);\n        $content = str_replace(\'-period-\',$row[4],$content);\n        $content = str_replace(\'-reason-\',$row[3],$content);\n        $content = str_replace(\'-subject-\',$row[5],$content);\n        $content = str_replace(\'-teacher-\',$row[6],$content);\n        \n        $content = str_replace(\'-jreason-\',$row[13],$content);\n        $content = str_replace(\'-counts-\',$row[14],$content);\n\n        if($row[9]==\'1\' && !is_null($row[8]) && trim($row[8])<>\'\'){\n            $sql=\"  INSERT INTO notification(\n                        id,	\n                        added_at,\n                        type_id,	\n                        content,\n                        student_id,\n                        is_parent,\n                        pending,\n                        email_id,\n                        associated_id,\n                        occurred_at\n                    ) VALUES (\n                        NULL,\n                        NOW(),\n                        2,\n                        \'\".esc($content).\"\',\n                        \'\".$row[7].\"\',\n                        0,\n                        1,\n                        NULL,\n                        \'$absence_id\',\n                        NOW()\n                    )\n                \";\n            nuRunQuery($sql);\n        }\n      \n        if($row[11]==\'1\' && !is_null($row[10]) && trim($row[10])<>\'\'){\n            $sql=\"  INSERT INTO notification(\n                        id,	\n                        added_at,\n                        type_id,	\n                        content,\n                        student_id,\n                        is_parent,\n                        pending,\n                        email_id,\n                        associated_id,\n                        occurred_at\n                    ) VALUES (\n                        NULL,\n                        NOW(),\n                        2,\n                        \'\".esc($content).\"\',\n                        \'\".$row[7].\"\',\n                        1,\n                        1,\n                        NULL,\n                        \'$absence_id\',\n                        NOW()\n                    )\n                \";\n            nuRunQuery($sql);              \n        }\n    }    \n}\n\nfunction delete_absence_notification($absence_id){\n    $sql = \" SELECT \n                absence.id,	\n                DATE_FORMAT(absence.absence_date,\'%d-%m-%Y\'),\n                absence.comments,\n                \n                absence_reason.name,\n                period.name,\n                ifNULL(subject.name,subject.short_name),\n                concat(ifNULL(teacher.surname,\'\'),if(teacher.surname is NULL OR teacher.name is NULL,\'\',\' \'),ifNULL(teacher.name,\'\')),\n                \n                student_id,\n                student.email,\n                student.delete_absence_notification,\n                student.parent_email,\n                student.parent_delete_absence_notification,\n                \n                notification_type.content,\n                justification_request_reason.name,\n                CONCAT(absence.absence_date,\' \', period.start_time)\n                \n            FROM absence\n            INNER JOIN absence_reason                   ON  absence.absence_reason_id                               = absence_reason.id\n            INNER JOIN justification_request            ON  justification_request.absence_id                        = absence.id\n            INNER JOIN justification_request_reason     ON  justification_request.justification_request_reason_id   = justification_request_reason.id\n            INNER JOIN student                          ON  absence.student_id                                      = student.id\n            \n            INNER JOIN card                             ON  absence.card_id                                         = card.id\n            INNER JOIN period                           ON  card.period_id                                          = period.id\n            INNER JOIN subject                          ON  card.subject_id                                         = subject.id\n            INNER JOIN teacher                          ON  justification_request.post_teacher_id                   = teacher.id\n            INNER JOIN notification_type                ON  notification_type.id                                    = 3\n            WHERE \n                absence.id = \'$absence_id\'          AND\n                notification_type.active = 1        AND\n                absence.justified = 1               AND\n                justification_request.proceeded=1   AND\n                ((student.email IS NOT NULL AND TRIM(student.email)<>\'\' AND student.delete_absence_notification=1)\n                OR (student.parent_email IS NOT NULL AND TRIM(student.parent_email)<>\'\' AND student.parent_delete_absence_notification=1))\n            ORDER BY justification_request.proceeded_when DESC\n            LIMIT 1\n            \";\n    \n    $retval     = nuRunQuery($sql);\n    \n    if($retval && db_num_rows($retval)==1){\n        $row        = db_fetch_row($retval);\n        \n        $content    = $row[12];\n\n        $content = str_replace(\'-date-\',$row[1],$content);\n        $content = str_replace(\'-period-\',$row[4],$content);\n        $content = str_replace(\'-reason-\',$row[3],$content);\n        $content = str_replace(\'-subject-\',$row[5],$content);\n        \n        $content = str_replace(\'-reqteacher-\',$row[6],$content);\n        $content = str_replace(\'-dreason-\',$row[13],$content);\n\n        if($row[9]==\'1\' && !is_null($row[8]) && trim($row[8])<>\'\'){\n            $sql=\"  INSERT INTO notification(\n                        id,	\n                        added_at,\n                        type_id,	\n                        content,\n                        student_id,\n                        is_parent,\n                        pending,\n                        email_id,\n                        associated_id,\n                        occurred_at\n                    ) VALUES (\n                        NULL,\n                        NOW(),\n                        3,\n                        \'\".esc($content).\"\',\n                        \'\".$row[7].\"\',\n                        0,\n                        1,\n                        NULL,\n                        \'$absence_id\',\n                        NOW()\n                    )\n                \";\n            nuRunQuery($sql);\n        }\n      \n        if($row[11]==\'1\' && !is_null($row[10]) && trim($row[10])<>\'\'){\n            $sql=\"  INSERT INTO notification(\n                        id,	\n                        added_at,\n                        type_id,	\n                        content,\n                        student_id,\n                        is_parent,\n                        pending,\n                        email_id,\n                        associated_id,\n                        occurred_at\n                    ) VALUES (\n                        NULL,\n                        NOW(),\n                        3,\n                        \'\".esc($content).\"\',\n                        \'\".$row[7].\"\',\n                        1,\n                        1,\n                        NULL,\n                        \'$absence_id\',\n                        NOW()\n                    )\n                \";\n            nuRunQuery($sql);              \n        }\n    }    \n}\n\nfunction new_penalty_notification($penalty_id){\n    $sql = \" SELECT \n                penalty.id,	\n                DATE_FORMAT(penalty.date_enforced,\'%d-%m-%Y\'),\n                penalty.type,\n                penalty.reason,\n                penalty.carrier,\n                \n                period.name,\n                \n                concat(ifNULL(teacher.surname,\'\'),if(teacher.surname is NULL OR teacher.name is NULL,\'\',\' \'),ifNULL(teacher.name,\'\')),\n                \n                penalty.student_id,\n                student.email,\n                student.new_penalty_notification,\n                student.parent_email,\n                student.parent_new_penalty_notification,\n                \n                notification_type.content,\n                CONCAT(penalty.date_enforced,\' \', ifNULL(period.start_time,\'00:00:00\'))\n                \n            FROM penalty\n            INNER JOIN student                          ON  penalty.student_id                                      = student.id\n            LEFT JOIN period                            ON  penalty.period_id                                       = period.id\n            LEFT JOIN teacher                           ON  penalty.teacher_id                                      = teacher.id\n            INNER JOIN notification_type                ON  notification_type.id                                    = 4\n            WHERE \n                penalty.id = \'$penalty_id\'          AND\n                notification_type.active = 1        AND\n                ((student.email IS NOT NULL AND TRIM(student.email)<>\'\' AND student.new_penalty_notification=1)\n                OR (student.parent_email IS NOT NULL AND TRIM(student.parent_email)<>\'\' AND student.parent_new_penalty_notification=1))\n            \";\n    \n    $retval     = nuRunQuery($sql);\n    \n    if($retval && db_num_rows($retval)==1){\n        $row        = db_fetch_row($retval);\n        \n        $content    = $row[12];\n        \n        $content = str_replace(\'-date-\',$row[1],$content);\n        $content = str_replace(\'-type-\',$row[2],$content);\n        $content = str_replace(\'-cause-\',$row[3],$content);\n        $content = str_replace(\'-carrier-\',$row[4],$content);\n        $content = str_replace(\'-period-\',$row[5],$content);\n        $content = str_replace(\'-teacher-\',$row[6],$content);\n\n        if($row[9]==\'1\' && !is_null($row[8]) && trim($row[8])<>\'\'){\n            $sql=\"  INSERT INTO notification(\n                        id,	\n                        added_at,\n                        type_id,	\n                        content,\n                        student_id,\n                        is_parent,\n                        pending,\n                        email_id,\n                        associated_id,\n                        occurred_at\n                    ) VALUES (\n                        NULL,\n                        NOW(),\n                        4,\n                        \'\".esc($content).\"\',\n                        \'\".$row[7].\"\',\n                        0,\n                        1,\n                        NULL,\n                        \'$penalty_id\',\n                        \'\".$row[13].\"\'\n                    )\n                \";\n            nuRunQuery($sql);\n        }\n      \n        if($row[11]==\'1\' && !is_null($row[10]) && trim($row[10])<>\'\'){\n            $sql=\"  INSERT INTO notification(\n                        id,	\n                        added_at,\n                        type_id,	\n                        content,\n                        student_id,\n                        is_parent,\n                        pending,\n                        email_id,\n                        associated_id,\n                        occurred_at\n                    ) VALUES (\n                        NULL,\n                        NOW(),\n                        4,\n                        \'\".esc($content).\"\',\n                        \'\".$row[7].\"\',\n                        1,\n                        1,\n                        NULL,\n                        \'$penalty_id\',\n                        \'\".$row[13].\"\'\n                    )\n                \";\n            nuRunQuery($sql);              \n        }\n    }        \n}\n\nfunction update_comment_notification($comment_id){\n\n    $sql = \"    SELECT \n                comment.id,	\n                DATE_FORMAT(comment.changed_at,\'%d-%m-%Y %T\'),\n                comment.student_comments,\n                comment.hide_to_student,\n                \n                subject_id,\n                ifNULL(subject.name,subject.short_name),\n                \n                concat(ifNULL(teacher.surname,\'\'),if(teacher.surname is NULL OR teacher.name is NULL,\'\',\' \'),ifNULL(teacher.name,\'\')),\n                \n                student_id,\n                student.email,\n                student.update_comment_notification,\n                student.parent_email,\n                student.parent_update_comment_notification,\n                \n                notification_type.content\n                \n            FROM comment\n            INNER JOIN student           ON  comment.student_id         = student.id\n            INNER JOIN subject           ON  comment.subject_id         = subject.id\n            INNER JOIN teacher           ON  comment.post_teacher_id    = teacher.id\n            INNER JOIN notification_type ON  notification_type.id        = 5\n            WHERE \n                comment.id = \'$comment_id\' AND\n                notification_type.active = 1 AND\n                ((student.email IS NOT NULL AND TRIM(student.email)<>\'\' AND student.update_comment_notification=1)\n                OR (student.parent_email IS NOT NULL AND TRIM(student.parent_email)<>\'\' AND student.parent_update_comment_notification=1))\";\n\n    $retval     = nuRunQuery($sql);\n    \n    if($retval && db_num_rows($retval)==1){\n        $row        = db_fetch_row($retval);\n        \n        $content    = $row[12];\n        \n        $txt = strip_tags($row[2]);\n        $len = mb_strlen($txt);\n        $pos = ($len > 100 ? $len-100 : 0);\n        \n        $content = str_replace(\'-subject-\',$row[5],$content);\n        $content = str_replace(\'-postteacher-\',$row[6],$content);\n        $content = str_replace(\'-comments-\',\'...\'.mb_substr($txt, $pos, 100,\"UTF-8\"),$content);\n        $content = str_replace(\'-datetime-\',$row[1],$content);\n\n        if($row[3]==\'0\' && $row[9]==\'1\' && !is_null($row[8]) && trim($row[8])<>\'\'){\n        \n            $sql = \"    DELETE FROM notification \n                        WHERE \n                            type_id=5 AND\n                            student_id=\'\".$row[7].\"\' AND\n                            is_parent=0 AND\n                            pending = 1 AND\n                            associated_id = \'$comment_id\'\n                            \";\n            nuRunQuery($sql);\n            \n            $sql = \" INSERT INTO notification(\n                        id,	\n                        added_at,\n                        type_id,	\n                        content,\n                        student_id,\n                        is_parent,\n                        pending,\n                        email_id,\n                        associated_id,\n                        occurred_at\n                    ) VALUES (\n                        NULL,\n                        NOW(),\n                        5,\n                        \'\".esc($content).\"\',\n                        \'\".$row[7].\"\',\n                        0,\n                        1,\n                        NULL,\n                        \'$comment_id\',\n                        NOW()\n                    )\n                \";\n            nuRunQuery($sql);\n        }\n      \n        if($row[11]==\'1\' && !is_null($row[10]) && trim($row[10])<>\'\'){\n            \n            $sql = \"    DELETE FROM notification \n                        WHERE \n                            type_id=5 AND\n                            student_id=\'\".$row[7].\"\' AND\n                            is_parent=1 AND\n                            pending = 1 AND\n                            associated_id = \'$comment_id\'\n                            \";\n            nuRunQuery($sql);\n            \n            $sql=\"  INSERT INTO notification(\n                        id,	\n                        added_at,\n                        type_id,	\n                        content,\n                        student_id,\n                        is_parent,\n                        pending,\n                        email_id,\n                        associated_id,\n                        occurred_at\n                    ) VALUES (\n                        NULL,\n                        NOW(),\n                        5,\n                        \'\".esc($content).\"\',\n                        \'\".$row[7].\"\',\n                        1,\n                        1,\n                        NULL,\n                        \'$comment_id\',\n                        NOW()\n                    )\n                \";\n            nuRunQuery($sql);              \n        }\n    }    \n}\n\n\nfunction calendar_event_notification(   $calendar_event_access_id,\n                                        $notification_type_id,\n                                        $new_title=\'\',\n                                        $new_location=\'\',\n                                        $new_start_date=\'\',\n                                        $new_start_time=\'\',\n                                        $new_end_date=\'\',\n                                        $new_end_time=\'\',\n                                        $new_allDay=\'\'){\n\n    $sql = \"    SELECT \n                \n                calendar_event_access.id,\n                ifNULL(calendar_event_access.student_id,\'-1\'),\n                ifNULL(calendar_event_access.class_id,\'-1\'),\n                ifNULL(calendar_event_access.grade_id,\'-1\'),\n                calendar_event_access.user_group_id,\n                \n                calendar_event.id,\n                calendar_event.title,\n                calendar_event.description,\n                calendar_event.location,\n                CONCAT(DATE_FORMAT(calendar_event.start_date,\'%d-%m-%Y\'),\' \' ,calendar_event.start_time),\n                CONCAT(DATE_FORMAT(calendar_event.end_date,\'%d-%m-%Y\'),\' \' ,calendar_event.end_time),\n                IF(calendar_event.allDay=\'1\',\'ΝΑΙ\',\'ΌΧΙ\'),\n                \n                concat(ifNULL(t1.surname,\'\'),if(t1.surname is NULL OR t1.name is NULL,\'\',\' \'),ifNULL(t1.name,\'\')),\n                concat(ifNULL(t2.surname,\'\'),if(t2.surname is NULL OR t2.name is NULL,\'\',\' \'),ifNULL(t2.name,\'\')),\n                notification_type.content\n                \n            FROM calendar_event_access\n            INNER JOIN session_variables    ON  session_variables.session_id = \'#session_id#\'\n            INNER JOIN calendar_event       ON  calendar_event.id       = calendar_event_access.calendar_event_id\n            INNER JOIN teacher as t1        ON  t1.id                   = calendar_event.teacher_id\n            INNER JOIN teacher as t2        ON  t2.id                   = session_variables.teacher_id\n            INNER JOIN notification_type    ON  notification_type.id    = \".$notification_type_id.\"\n            WHERE \n                notification_type.active = 1 AND\n                calendar_event_access.id = \'$calendar_event_access_id\' AND\n                calendar_event_access.user_group_id IN (\'547de4c65675a29\',\'5717ba3eb32c252\')\";\n\n    $retval     = nuRunQuery($sql);\n    \n    if($retval && db_num_rows($retval)==1){\n        $row        = db_fetch_row($retval);\n        \n        $content    = $row[14];\n        \n        $content = str_replace(\'-title-\',$row[6],$content);\n        $content = str_replace(\'-description-\',$row[7],$content);\n        $content = str_replace(\'-location-\',$row[8],$content);\n        $content = str_replace(\'-from-\',$row[9],$content);\n        $content = str_replace(\'-to-\',$row[10],$content);\n        $content = str_replace(\'-allday-\',$row[11],$content);\n        $content = str_replace(\'-teacher-\',$row[12],$content);\n        $content = str_replace(\'-postteacher-\',$row[13],$content);\n        \n        if($notification_type_id==8){\n        \n            $ns = date(\'d-m-Y\', strtotime($new_start_date));\n            $ns .= \' \'.$new_start_time;\n            \n            $ne = date(\'d-m-Y\', strtotime($new_end_date));\n            $ne .= \' \'.$new_end_time;\n            \n            $content = str_replace(\'-newtitle-\',$new_title,$content);\n            $content = str_replace(\'-newlocation-\',$new_location,$content);\n            $content = str_replace(\'-newfrom-\',$ns,$content);\n            $content = str_replace(\'-newto-\',$ne,$content);\n            $content = str_replace(\'-newallday-\',$new_allDay,$content);\n        }\n     \n        $sql = \"SELECT id\n                FROM student\n                WHERE \n                    student.has_left_school = 0 AND \n                    \".($row[4]==\'547de4c65675a29\' ? \n                        \"(student.email IS NOT NULL AND TRIM(student.email)<>\'\' AND student.new_calendar_event_notification=1)\" : \n                        \"(student.parent_email IS NOT NULL AND TRIM(student.parent_email)<>\'\' AND student.parent_new_calendar_event_notification=1)\").\"\n                    \";\n    \n        if($row[1]!=\'-1\'){\n            $sql .=\"AND student.id = \'\".$row[1].\"\'\";        \n        } else {\n            if($row[2]!=\'-1\'){\n                $sql .=\"AND student.id IN (SELECT student_id FROM student_class WHERE class_id=\'\".$row[2].\"\')\";    \n            } else if($row[3]!=\'-1\'){\n                $sql .=\"AND student.grade_id = \'\".$row[3].\"\'\";    \n            } \n        }\n        \n        $rv     = nuRunQuery($sql);\n        while($r = db_fetch_row($rv)){\n\n            $sql = \"    SELECT COUNT(*) \n                        FROM notification \n                        WHERE \n                            type_id=\".$notification_type_id.\" AND\n                            student_id=\'\".$r[0].\"\' AND\n                            is_parent=\".($row[4]==\'547de4c65675a29\' ? \'0\' : \'1\').\" AND\n                            pending = 1 AND\n                            associated_id = \'\".$row[5].\"\'\n                            \";\n            $rv2 = nuRunQuery($sql);\n            $r2 = db_fetch_row($rv2);\n        \n            if($r2[0]==\'0\'){\n                $sql=\"  INSERT INTO notification(\n                        id,	\n                        added_at,\n                        type_id,	\n                        content,\n                        student_id,\n                        is_parent,\n                        pending,\n                        email_id,\n                        associated_id,\n                        occurred_at\n                    ) VALUES (\n                        NULL,\n                        NOW(),\n                        \".$notification_type_id.\",\n                        \'\".esc($content).\"\',\n                        \'\".$r[0].\"\',\n                        \".($row[4]==\'547de4c65675a29\' ? \'0\' : \'1\').\",\n                        1,\n                        NULL,\n                        \'\".$row[5].\"\',\n                        NOW()\n                    )\n                \";\n                nuRunQuery($sql);\n            }\n        }\n    }\n}\n\nfunction new_reward_notification($reward_id) {\n\n    $sql=\"SELECT \n            reward.id,\n            DATE_FORMAT(reward.date_enforced,\'%d-%m-%Y\'),\n            reward_type.name,\n            reward.comments,\n            ifNULL(period.name,\'\'),\n            ifNULL(subject.name,subject.short_name),\n            concat(ifNULL(teacher.surname,\'\'),if(teacher.surname is NULL OR teacher.name is NULL,\'\',\' \'),ifNULL(teacher.name,\'\')),\n            reward.student_id,\n            student.email,\n            student.new_penalty_notification,\n            student.parent_email,\n            student.parent_new_penalty_notification,            \n            notification_type.content,\n            reward.number_of_medals,\n            if(reward.teacher_id IS NULL,\'\',concat(ifNULL(teacher.surname,\'\'),if(teacher.surname IS NOT NULL AND teacher.name IS NOT NULL,\' \',\'\'),ifNULL(teacher.name,\'\'))),\n            CONCAT(reward.date_enforced,\' \', ifNULL(period.start_time,\'00:00:00\'))\n        FROM reward\n        INNER JOIN reward_type ON reward_type.id = reward.reward_type_id\n        INNER JOIN student ON reward.student_id = student.id\n        INNER JOIN notification_type ON  notification_type.id = 10\n        LEFT JOIN period ON reward.period_id=period.id\n        LEFT JOIN teacher ON teacher.id = reward.teacher_id\n        LEFT JOIN subject ON reward.subject_id = subject.id \n        WHERE \n                reward.id = \'$reward_id\'        AND\n                notification_type.active = 1    AND\n                ((student.email IS NOT NULL AND TRIM(student.email)<>\'\' AND student.new_reward_notification=1)\n                OR (student.parent_email IS NOT NULL AND TRIM(student.parent_email)<>\'\' AND student.parent_new_reward_notification =1))\";\n    \n    $retval     = nuRunQuery($sql);\n    \n    if($retval && db_num_rows($retval)==1){\n        $row        = db_fetch_row($retval);\n        \n        $content    = $row[12];\n        \n        $content = str_replace(\'-date-\',$row[1],$content);\n        $content = str_replace(\'-period-\',$row[4],$content);\n        $content = str_replace(\'-type-\',$row[2],$content);\n        $content = str_replace(\'-medals-\',$row[13],$content);\n        $content = str_replace(\'-teacher-\',$row[6],$content);\n\n        if($row[9]==\'1\' && !is_null($row[8]) && trim($row[8])<>\'\'){\n            $sql=\"  INSERT INTO notification(\n                        id,	\n                        added_at,\n                        type_id,	\n                        content,\n                        student_id,\n                        is_parent,\n                        pending,\n                        email_id,\n                        associated_id,\n                        occurred_at\n                    ) VALUES (\n                        NULL,\n                        NOW(),\n                        10,\n                        \'\".esc($content).\"\',\n                        \'\".$row[7].\"\',\n                        0,\n                        1,\n                        NULL,\n                        \'$reward_id\',\n                        \'\".$row[15].\"\'\n                    )\n                \";\n            nuRunQuery($sql);\n        }\n      \n        if($row[11]==\'1\' && !is_null($row[10]) && trim($row[10])<>\'\'){\n            $sql=\"  INSERT INTO notification(\n                        id,	\n                        added_at,\n                        type_id,	\n                        content,\n                        student_id,\n                        is_parent,\n                        pending,\n                        email_id,\n                        associated_id,\n                        occurred_at\n                    ) VALUES (\n                        NULL,\n                        NOW(),\n                        10,\n                        \'\".esc($content).\"\',\n                        \'\".$row[7].\"\',\n                        1,\n                        1,\n                        NULL,\n                        \'$reward_id\',\n                        \'\".$row[15].\"\'\n                    )\n                \";\n            nuRunQuery($sql);              \n        }\n    }\n}\n','','1','2016-11-27 10:52:28','globeadmin','2022-01-08 22:04:54','globeadmin','2022-01-08 22:04:54','globeadmin','0'),('58458875d6799f3','print_search_absence_list','Εκτυπώνει λίστα αναζήτησης απουσιών με συγκεκριμένα κριτίρια','sisyphos','$sql=\"DROP TEMPORARY TABLE IF EXISTS #TABLE_ID#\";\nnuRunQuery($sql);\n\n$sql=\"CREATE TEMPORARY TABLE #TABLE_ID# DEFAULT CHARACTER SET=utf8\n        SELECT \n            absence.id,\n            DATE_FORMAT(absence.absence_date,\'%d-%m-%Y\')                            AS absence_absence_date,\n            period.short_name                                                       AS period_name,\n            concat(student.surname,\' \',student.name,\' πατ. \',student.fathers_name)  AS student_name,\n            absence_reason.short_name                                               AS absence_reason_name,\n            class.short_name                                                        AS class_name,\n            concat(subject.name,\'-\',subject_type.short_name)                        AS subject_name,\n            teacher.short_name                                                      AS teacher_name,\n            if(absence.justified,\'Ναι\',\'Όχι\')                                       AS absence_justified,\n            justified_reason.short_name                                             AS justified_reason_name,\n            if(absence.counts,\'Ναι\',\'Όχι\')                                          AS absence_counts,\n            school.name                                                             AS school_name,\n            school_year.name                                                        AS school_year_name,\n            DATE_FORMAT(curdate(),\'%d-%m-%Y\')                                       AS cur_date,\n            1                                                                       AS total_n,\n            if(absence.counts,0,1)                                                  AS not_counts_n,\n            if(absence.justified,0,1)                                               AS not_justified_n,\n            if(absence.justified and absence.counts,1,0)                            AS justified_counts_n,\n            absence.counts                                                          AS counts_n\n   \n        FROM absence\n            INNER JOIN teacher          ON  absence.post_teacher_id         = teacher.id\n            INNER JOIN student          ON  absence.student_id              = student.id\n            INNER JOIN card             ON  absence.card_id                 = card.id\n            INNER JOIN absence_reason   ON  absence.absence_reason_id       = absence_reason.id\n            LEFT JOIN  justified_reason ON  absence.justified_reason_id     = justified_reason.id\n            INNER JOIN subject          ON  card.subject_id                 = subject.id\n            INNER JOIN class            ON  card.class_id                   = class.id\n            INNER JOIN period           ON  card.period_id                  = period.id\n            LEFT JOIN subject_type      ON  subject.subject_type_id         = subject_type.id\n            INNER JOIN school           ON  school.id                       = 1\n            INNER JOIN school_year      ON  school_year.id                  = school.school_year_id\n        WHERE\n\";\n\nif(\'#from_date#\'!=\'#\'.\'from_date#\' && \'#from_date#\'!=\'\'){\n    $sql=$sql.\" absence.absence_date >= \'#from_date#\' and \n    \";\n}\nif(\'#to_date#\'!=\'#\'.\'to_date#\' && \'#to_date#\'!=\'\'){\n    $sql=$sql.\" absence.absence_date <= \'#to_date#\' and \n    \";\n}\nif(\'#period_id_sumo#\'!=\'#\'.\'period_id_sumo#\' && \'#period_id_sumo#\'!=\'\'){\n    $sql=$sql.\" period.id IN (#period_id_sumo#) and \n    \";\n}\nif(\'#justified#\'!=\'#\'.\'justified#\' && \'#justified#\'!=\'\'){\n    $sql=$sql.\" absence.justified = \'#justified#\' and \n    \";\n}\nif(\'#counts#\'!=\'#\'.\'counts#\' && \'#counts#\'!=\'\'){\n    $sql=$sql.\" absence.counts = \'#counts#\' and \n    \";\n}\nif(\'#justified_reason_id_sumo#\'!=\'#\'.\'justified_reason_id_sumo#\' && \'#justified_reason_id_sumo#\'!=\'\'){\n    $sql=$sql.\" absence.justified_reason_id IN (#justified_reason_id_sumo#) and \n    \";\n}\n\nif(\'#class_id_sumo#\'!=\'#\'.\'class_id_sumo#\' && \'#class_id_sumo#\'!=\'\'){\n    $sql=$sql.\" class.id IN (#class_id_sumo#) and \n    \";\n}\nif(\'#subject_id_sumo#\'!=\'#\'.\'subject_id_sumo#\' && \'#subject_id_sumo#\'!=\'\'){\n    $sql=$sql.\" subject.id IN (#subject_id_sumo#) and \n    \";\n}\nif(\'#student_id_sumo#\'!=\'#\'.\'student_id_sumo#\' && \'#student_id_sumo#\'!=\'\'){\n    $sql=$sql.\" student.id IN (#student_id_sumo#) and \n    \";\n    $is_student=1;\n}\nif(\'#absence_teacher_id_sumo#\'!=\'#\'.\'absence_teacher_id_sumo#\' && \'#absence_teacher_id_sumo#\'!=\'\'){\n    $sql=$sql.\" teacher.id IN (#absence_teacher_id_sumo#) and \n    \";\n}\nif(\'#hide_has_left_school#\'!=\'#\'.\'hide_has_left_school#\' && \'#hide_has_left_school#\'!=\'\'){\n    $sql=$sql.\" student.has_left_school = 0 and \n    \";\n}\n$sql=$sql.\"\n    1=1\n    order by absence.absence_date,period.id,student.surname,student.name,student.fathers_name\n\";\n\nnuRunQuery($sql);\n\n\n\n','','0','2016-12-05 17:32:05','globeadmin','2017-11-27 23:11:40','globeadmin','2017-11-27 23:11:40','globeadmin','0'),('584bdd251a7b996','add_massively_justification_request','Προσθέτει μαζικά ένα καινούργιο αίτημα δικαιολόγησης σε επιλεγμένες απουσίες','teacher','function last_date_request(){\n    \n    $sql=\"  SELECT CURDATE(), ifNULL(num_of_days_limit,\'\'), school_year.start_date\n            FROM school \n            INNER JOIN school_year ON school_year.id = school.school_year_id\n            LEFT JOIN justification_request_reason ON justification_request_reason.id=\'#justification_request_reason_id#\'\n            WHERE school.id = 1\";\n            \n    $retval=nuRunQuery($sql);\n    $row=db_fetch_row($retval);\n    \n    $cur_date   =   $row[0];\n    \n    if($row[1]==\'\'){\n        return $row[2];  \n    }\n    \n    $num_days   =   $row[1];\n    \n    $sql=\"SELECT holiday FROM holiday WHERE DAYOFWEEK(holiday) not in (1,7)\";\n    $retval=nuRunQuery($sql);\n    $holidays = array();\n    \n    if($retval && db_num_rows($retval)>0){\n        while($row=db_fetch_row($retval)){\n            $holidays[]= $row[0];\n        }\n    }\n    \n    $weekend = array(\'Sun\',\'Sat\');\n    $date = new DateTime($cur_date);\n    $prevDay = clone $date;\n    \n    $i = 0; \n    $lastDate = $cur_date; \n    \n    while ($i < $num_days)\n    {\n        $di = new DateInterval(\'P1D\');\n        $di->invert = 1; // Proper negative date interval\n        \n        $prevDay->add($di); \n        \n        if (in_array($prevDay->format(\'Y-m-d\'), $holidays)) continue; \n        if (in_array($prevDay->format(\'D\'), $weekend)) continue;\n        \n        $lastDate = $prevDay->format(\'Y-m-d\');\n        $i++;\n    }\n    \n    return $lastDate;\n}\n\nif (\'#absence_id_list#\'!=\'#\'.\'absence_id_list\'.\'#\' && \'#absence_id_list#\'!=\'\'){\n    if (\'#justification_request_reason_id#\'!=\'#\'.\'justification_request_reason_id\'.\'#\' && \'#justification_request_reason_id#\'!=\'\'){  \n        \n        $ids = explode(\',\',\'#absence_id_list#\'); \n        \n        $insert = 0;\n        $fail = 0;\n        $out_of_limit = 0;\n        \n        $last_date = last_date_request();\n        \n        nuDebug($last_date);\n        \n        foreach ($ids as $r_id) {\n            $sql=\"select id from justification_request where absence_id=\'$r_id\' and post_teacher_id=\'#RECORD_ID#\'\";\n            $retval = nuRunQuery($sql);\n            if($retval){\n                if(db_num_rows($retval)==0) {\n                    \n                    $sql = \"select absence_date from absence where id=\'$r_id\'\";\n                    $rv = nuRunQuery($sql);\n                    if($r = db_fetch_row($rv)){\n                        \n                        $absence_date = $r[0];\n                        \n                        if($absence_date >= $last_date || \'#nu_user_group#\'==\'Managers\'){\n                            $sql= \" insert \n                                    into justification_request (\n                                        id,\n                                        absence_id,\n                                        post_teacher_id,\n                                        justification_request_reason_id,\n                                        comments,\n                                        added_when,\n                                        proceeded,\n                                        proceeded_teacher_id,\n                                        proceeded_comments,\n                                        proceeded_when) \n                                        values(\n                                        NULL,\n                                        \'$r_id\',\n                                        \'#RECORD_ID#\',\n                                        \'#justification_request_reason_id#\',\n                                        \'#comments#\',\n                                        NOW(),\n                                        0,\n                                        NULL,\n                                        NULL,\n                                        NULL)\";\n                            nuRunQuery($sql);\n                            $insert++;\n                        } else {\n                            $out_of_limit++;    \n                        }\n                    } else {\n                        nuDebug(\"Δε βρέθηκε η απουσία με id=$r_id κατά την εισαγωγή αιτήματος διαγραφής!\");  \n                    }\n                } else {\n                    $fail++;\n                }\n            }\n        }\n        $nuParameters = \"\";\n        $nuParameters .= ($insert>0 ? \'Εισήχθησαν \'.$insert.\' νέα αιτήματα! \' : \'\');\n        $nuParameters .= ($fail>0 ? \"Απέτυχαν $fail αιτήματα λόγω του ότι έχετε ήδη εισάγει αιτήματα για τις απουσίες αυτές!\" : \"\");\n        $nuParameters .= ($out_of_limit>0 ? \"Απέτυχαν $out_of_limit αιτήματα λόγω του ότι οι απουσίες πραγματοποιήθηκαν πριν το όριο (\".date_format(date_create($last_date), \'d-m-Y\').\") για το συγκεκριμένο λόγο διαγραφής!\" : \"\");\n    }  else {\n        $nuError=\'Παρακαλώ συμπληρώστε τον «Λόγο Αιτήσεων»...\';\n        $nuParameters = \'\';    \n    }\n}  else {\n    $nuError=\'Παρακαλώ επιλέξτε πρώτα τις απουσίες...\';\n    $nuParameters = \'\';    \n}\n\n ','','0','2016-12-10 12:47:01','globeadmin','2018-08-07 18:05:59','globeadmin','2018-08-07 18:05:59','globeadmin','0'),('586a43af3613920','group_new_absence_notification','Ομαδοποιεί σύμφωνα με τις ρυθμίσεις τις ειδοποιήσεις νέων απουσιών ανά ημέρα','manager','function esc($str){\n    $db_params = nuRunQuery();\n    $link = mysqli_connect($db_params[0], $db_params[2], $db_params[3], $db_params[1]);\n\n    if (mysqli_connect_errno()) {\n        nuDebug(\"Connect failed: %s\\n\", mysqli_connect_error());\n        return \'\';\n    }\n    return(mysqli_real_escape_string($link,$str));\n}\n\nif(\'#TABLE_ID#\' != \'#\'.\'TABLE_ID\'.\'#\' && \'#TABLE_ID#\' != \'\'){\n        $tmp_table=\'#TABLE_ID#\';\n} else {\n        $tmp_table=\'__\'.nuID().\'__\';\n}\n\n$sql=\"DROP TABLE IF EXISTS \".$tmp_table;\nnuRunQuery($sql);\n\n$sql=\" CREATE TABLE $tmp_table DEFAULT CHARACTER SET=utf8 \n        SELECT  \n            notification.id             AS notification_id,\n            notification.student_id     AS student_id,\n            notification.is_parent      AS is_parent,\n            absence.absence_date        AS absence_date,\n            absence.id                  AS absence_id,\n            card.period_id              AS period_id,\n            card.class_id               AS class_id,\n            absence_reason.short_name   AS absence_reason_short_name,\n            period.short_name           AS period_short_name,\n            absence_reason.name         AS absence_reason_name\n        FROM notification\n        INNER JOIN notification_type    ON (notification_type.id=6 AND notification_type.active=1)\n        INNER JOIN student              ON student.id = notification.student_id\n        INNER JOIN absence              ON absence.id = notification.associated_id\n        INNER JOIN absence_reason       ON absence.absence_reason_id   = absence_reason.id\n        INNER JOIN card                 ON card.id = absence.card_id\n        INNER JOIN period               ON card.period_id = period.id\n        where \n            notification.pending=1 AND\n            notification.type_id=1 AND\n            (student.group_new_absence_notification = 1 OR student.parent_group_new_absence_notification = 1)\n            \";\nnuRunQuery($sql);\n\n$sql=\"  SELECT \n            student_id,\n            absence_date,\n            is_parent,\n            COUNT(*)\n        FROM $tmp_table\n        GROUP BY student_id,absence_date,is_parent\n    \";\n    \n$retval= nuRunQuery($sql);\nif($retval){\n    while($row=db_fetch_row($retval)){\n\n        $sql=\"  SELECT count(distinct period_id)\n                FROM card\n                WHERE\n                    valid_from=(select max(c.valid_from) from card as c where c.valid_from<=\'\".$row[1].\"\') and\n                    day_id=\".(idate(\'w\', strtotime($row[1]))-1).\" and\n                    card.id not in (    select card_id \n                                            from registered_card\n                                            where DATE_FORMAT(registered_card.card_date, \'%Y-%m-%d\')=\'\".$row[1].\"\') and\n                \'\".$row[1].\"\' not in (    select holiday.holiday \n                                                    from holiday \n                                                    inner join school_year on holiday.school_year_id=school_year.id\n                                                    inner join school on school.school_year_id=school_year.id) and\n                card.class_id in (select distinct class_id from student_class where student_id=\'\".$row[0].\"\')\";\n        \n        $rv = nuRunQuery($sql);\n        $r = db_fetch_row($rv);\n        \n        if($r[0]==0){           // Έχει ολοκληρωθεί η καταχώρηση των απουσιών\n                                // Βρίσκω πόσες απουσίες θα είχε πάρει ο μαθητής αν έλλειπε όλη την ημέρα \n            $sql = \"    SELECT count(distinct card.period_id) \n                        FROM registered_card\n                        INNER JOIN card ON card.id = registered_card.card_id\n                        WHERE \n                            registered_card.card_date=\'\".$row[1].\"\' AND\n                            registered_card.no_lesson = 0 AND\n                            card.class_id in (select distinct class_id from student_class where student_id=\'\".$row[0].\"\')\";    \n            $rv1 = nuRunQuery($sql);\n            $r1 = db_fetch_row($rv1);\n            \n            if($r1[0]==$row[3]){  // Ο Μαθητής έλειπε όλη την ημέρα. Να γίνει η συγχώνευση\n\n                $sql = \"    SELECT\n                                absence_reason_short_name,\n                                period_short_name,\n                                notification_type.content,\n                                DATE_FORMAT(absence_date,\'%d-%m-%Y\'),\n                                notification_id,\n                                absence_reason_name\n                            FROM $tmp_table\n                            INNER JOIN notification_type ON  notification_type.id = 6\n                            WHERE \n                                student_id = \'\".$row[0].\"\' AND\n                                absence_date = \'\".$row[1].\"\' AND\n                                is_parent = \'\".$row[2].\"\'\n                            ORDER BY period_id\";   \n                $rv2 = nuRunQuery($sql);\n                \n                $reasons = \'\';\n                $periods = \'\';\n                $nids = \'\';\n                $common_reason = \'\';\n                \n                while($r2 = db_fetch_row($rv2)){\n                    $reasons .= ($reasons==\'\'? $r2[0] : \',\'.$r2[0]);\n                    $periods .= ($periods==\'\'? $r2[1] : \',\'.$r2[1]);\n                    $nids .= ($nids==\'\'? $r2[4] : \',\'.$r2[4]);\n                    \n                    $content    = $r2[2];\n                    $d = $r2[3];\n                    \n                    if($common_reason==\'\'){\n                        $common_reason=$r2[5];   \n                    } else {\n                        if($common_reason!=$r2[5]){\n                            $common_reason=\'N/A\';\n                        }\n                    }\n                }\n                \n                $content = str_replace(\'-date-\',$d,$content);\n                $content = str_replace(\'-absences-\',$row[3],$content);\n                $content = str_replace(\'-period-\',$periods,$content);\n                \n                if($common_reason!=\'N/A\' && $common_reason!=\'\'){\n                    $content = str_replace(\'-reason-\',$common_reason,$content);    \n                } else {\n                    $content = str_replace(\'-reason-\',$reasons,$content);   \n                }\n            \n                $sql=\"  INSERT INTO notification(\n                        id,	\n                        added_at,\n                        type_id,	\n                        content,\n                        student_id,\n                        is_parent,\n                        pending,\n                        email_id,\n                        associated_id,\n                        occurred_at\n                    ) VALUES (\n                        NULL,\n                        NOW(),\n                        6,\n                        \'\".esc($content).\"\',\n                        \'\".$row[0].\"\',\n                        \'\".$row[2].\"\',\n                        1,\n                        NULL,\n                        NULL,\n                        \'\".$row[1].\"\'\n                    )\n                \";\n                nuRunQuery($sql);\n                \n                $sql = \"DELETE FROM notification WHERE id in ($nids)\";\n                nuRunQuery($sql);\n            }\n        }\n    }\n}\n\n$sql=\"DROP TABLE IF EXISTS \".$tmp_table;\nnuRunQuery($sql);','','1','2017-01-02 14:12:31','globeadmin','2022-01-23 20:59:23','globeadmin','2022-01-23 20:59:23','globeadmin','0'),('58e11da705d0093','create_subject_marked_list','Δημιουργεί τη λίστα μαθημάτων για τον ορισμό αν βαθμολογούνται ή όχι','manager','print \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n\n        <STYLE TYPE=\\\"text/css\\\">\n            .sisTable TH{\n                font-size:1.1em;\n            }\n        </STYLE>\n    </head>\n    <body onload=\\\"adjustIframeHeight()\\\">\";\n\n$sql=\"  SELECT\n            subject.id,\n            grade.short_name as g_name,\n            speciality.short_name as s_name ,\n            subject.short_name,\n            subject.name,\n            subject_type.short_name as t_name,\n            is_marked,\n            if(scg.subject_id is NULL,\'-\',scg.cnt)\n            \n        FROM subject \n        INNER JOIN ( select distinct subject_id\n                    from card \n                    where card.valid_from =(select max(timetable.start_date) from timetable)   \n                    and class_id is not NULL) as crd on subject.id=crd.subject_id\n        LEFT JOIN ( select subject_id,count(*) as cnt from subject_critirion_general group by subject_id) as scg ON subject.id=scg.subject_id \n        LEFT JOIN   grade           ON subject.grade_id         =   grade.id\n        LEFT JOIN   speciality      ON subject.speciality_id    =   speciality.id\n        LEFT JOIN   subject_type    ON subject.subject_type_id  =   subject_type.id\n        LEFT JOIN   section         ON speciality.section_id    =   section.id\n        WHERE subject.id>=10\n        ORDER BY g_name,section.short_name,s_name,subject.name,t_name DESC\";\n   \n$retval = nuRunQuery($sql);\n\nif($retval) {\n    if(db_num_rows($retval)>0) {\n    \n        print (\"<table cellspacing=0 CLASS=\\\"sisTable\\\" align=center>\n            <tr height=50>\n                <th width=50 align=center>Τάξη</th>\n                <th width=100 align=center>Ειδικότητα</th>\n                <th width=100 align=center>Συντομογραφία</th>\n                <th width=300 align=center>Όνομα</th>\n                <th width=50 align=center>Τύπος</th>\n                <th width=100 align=center>Κριτήρια Αξιολόγησης</th>\n                <th width=100 align=center>\n                    Αξιολογείται<br>\n                    Όλα<input type=\\\"checkbox\\\" id=\\\"all_chk_1\\\" title=\\\"Επιλογή Όλων\\\" onclick=\\\"toggle(this,\'chk_1\')\\\">\n                </th>\n            </tr>\");\n            \n        while($row = db_fetch_row($retval)) {\n            print (\"\n            <tr height=35>\n                <td align=center>\".(is_null($row[1]) || $row[1]==\'\'? \'&nbsp;\' : $row[1]).\"</td>\n                <td align=left>\".(is_null($row[2]) || $row[2]==\'\'? \'&nbsp;\' : $row[2]).\"</td>\n                <td align=left>\".(is_null($row[3]) || $row[3]==\'\'? \'&nbsp;\' : $row[3]).\"</td>\n                <td align=left>\".(is_null($row[4]) || $row[4]==\'\'? \'&nbsp;\' : $row[4]).\"</td>\n                <td align=center>\".(is_null($row[5]) || $row[5]==\'\'? \'&nbsp;\' : $row[5]).\"</td>\n                <td align=center>\".(is_null($row[7]) || $row[7]==\'\'? \'&nbsp;\' : $row[7]).\"</td>\n                <td align=center><input type=\\\"checkbox\\\" CLASS=\\\"chk_1\\\" id=\\\"\".$row[0].\"\\\" title=\\\"Επιλογή Μαθήματος\\\" onclick=\\\"make_indeterminate(\'all_chk_1\')\\\" \".($row[6]==\'1\' ? \"checked\" : \"\").\"></td>\n            </tr>\");\n        }\n        \n        print (\"\n        </table>\");\n    } else{\n        print (\"<span CLASS=\\\"msg\\\">Δε βρέθηκαν Μαθήματα...</span>\");\n    }\n} else{\n    print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν δεδομένα...</span>\");\n}\nprint \"\n    </body>\n</html>\";\n','','0','2017-04-02 18:49:59','globeadmin','2022-02-06 13:53:37','globeadmin','2022-02-06 13:54:32','globeadmin','0'),('58e168017ad4042','set_active_grading_period','Ορίζει τη τρέχουσα περίοδο αξιολόγησης','manager','$sql=\"update school set grading_period_id=\'#RECORD_ID#\' where id=1\";\nnuRunQuery($sql);','','0','2017-04-03 00:07:13','globeadmin','2017-04-03 00:07:13','globeadmin','2017-04-03 00:12:06','globeadmin','0'),('5936973c3ee9341','create_demo','Τροποποιεί όλα τα προσωπικά στοιχεία ώστε ο Σίσυφος να λειτουργήσει ως σύστημα επίδειξης','globeadmin',';','','0','2017-06-06 14:51:24','globeadmin','2017-06-06 14:51:24','globeadmin','2018-08-10 21:44:48','globeadmin','0'),('5995b81c6de4f2e','create_teacher_calendar','Δημιουργεί το Ημερολόγιο Σχολείου ενός Καθηγητή','Teacher','function color_name_to_hex($color_name) {\n    // standard 147 HTML color names\n    $colors  =  array(\n        \'aliceblue\'=>\'F0F8FF\',\n        \'antiquewhite\'=>\'FAEBD7\',\n        \'aqua\'=>\'00FFFF\',\n        \'aquamarine\'=>\'7FFFD4\',\n        \'azure\'=>\'F0FFFF\',\n        \'beige\'=>\'F5F5DC\',\n        \'bisque\'=>\'FFE4C4\',\n        \'black\'=>\'000000\',\n        \'blanchedalmond \'=>\'FFEBCD\',\n        \'blue\'=>\'0000FF\',\n        \'blueviolet\'=>\'8A2BE2\',\n        \'brown\'=>\'A52A2A\',\n        \'burlywood\'=>\'DEB887\',\n        \'cadetblue\'=>\'5F9EA0\',\n        \'chartreuse\'=>\'7FFF00\',\n        \'chocolate\'=>\'D2691E\',\n        \'coral\'=>\'FF7F50\',\n        \'cornflowerblue\'=>\'6495ED\',\n        \'cornsilk\'=>\'FFF8DC\',\n        \'crimson\'=>\'DC143C\',\n        \'cyan\'=>\'00FFFF\',\n        \'darkblue\'=>\'00008B\',\n        \'darkcyan\'=>\'008B8B\',\n        \'darkgoldenrod\'=>\'B8860B\',\n        \'darkgray\'=>\'A9A9A9\',\n        \'darkgreen\'=>\'006400\',\n        \'darkgrey\'=>\'A9A9A9\',\n        \'darkkhaki\'=>\'BDB76B\',\n        \'darkmagenta\'=>\'8B008B\',\n        \'darkolivegreen\'=>\'556B2F\',\n        \'darkorange\'=>\'FF8C00\',\n        \'darkorchid\'=>\'9932CC\',\n        \'darkred\'=>\'8B0000\',\n        \'darksalmon\'=>\'E9967A\',\n        \'darkseagreen\'=>\'8FBC8F\',\n        \'darkslateblue\'=>\'483D8B\',\n        \'darkslategray\'=>\'2F4F4F\',\n        \'darkslategrey\'=>\'2F4F4F\',\n        \'darkturquoise\'=>\'00CED1\',\n        \'darkviolet\'=>\'9400D3\',\n        \'deeppink\'=>\'FF1493\',\n        \'deepskyblue\'=>\'00BFFF\',\n        \'dimgray\'=>\'696969\',\n        \'dimgrey\'=>\'696969\',\n        \'dodgerblue\'=>\'1E90FF\',\n        \'firebrick\'=>\'B22222\',\n        \'floralwhite\'=>\'FFFAF0\',\n        \'forestgreen\'=>\'228B22\',\n        \'fuchsia\'=>\'FF00FF\',\n        \'gainsboro\'=>\'DCDCDC\',\n        \'ghostwhite\'=>\'F8F8FF\',\n        \'gold\'=>\'FFD700\',\n        \'goldenrod\'=>\'DAA520\',\n        \'gray\'=>\'808080\',\n        \'green\'=>\'008000\',\n        \'greenyellow\'=>\'ADFF2F\',\n        \'grey\'=>\'808080\',\n        \'honeydew\'=>\'F0FFF0\',\n        \'hotpink\'=>\'FF69B4\',\n        \'indianred\'=>\'CD5C5C\',\n        \'indigo\'=>\'4B0082\',\n        \'ivory\'=>\'FFFFF0\',\n        \'khaki\'=>\'F0E68C\',\n        \'lavender\'=>\'E6E6FA\',\n        \'lavenderblush\'=>\'FFF0F5\',\n        \'lawngreen\'=>\'7CFC00\',\n        \'lemonchiffon\'=>\'FFFACD\',\n        \'lightblue\'=>\'ADD8E6\',\n        \'lightcoral\'=>\'F08080\',\n        \'lightcyan\'=>\'E0FFFF\',\n        \'lightgoldenrodyellow\'=>\'FAFAD2\',\n        \'lightgray\'=>\'D3D3D3\',\n        \'lightgreen\'=>\'90EE90\',\n        \'lightgrey\'=>\'D3D3D3\',\n        \'lightpink\'=>\'FFB6C1\',\n        \'lightsalmon\'=>\'FFA07A\',\n        \'lightseagreen\'=>\'20B2AA\',\n        \'lightskyblue\'=>\'87CEFA\',\n        \'lightslategray\'=>\'778899\',\n        \'lightslategrey\'=>\'778899\',\n        \'lightsteelblue\'=>\'B0C4DE\',\n        \'lightyellow\'=>\'FFFFE0\',\n        \'lime\'=>\'00FF00\',\n        \'limegreen\'=>\'32CD32\',\n        \'linen\'=>\'FAF0E6\',\n        \'magenta\'=>\'FF00FF\',\n        \'maroon\'=>\'800000\',\n        \'mediumaquamarine\'=>\'66CDAA\',\n        \'mediumblue\'=>\'0000CD\',\n        \'mediumorchid\'=>\'BA55D3\',\n        \'mediumpurple\'=>\'9370D0\',\n        \'mediumseagreen\'=>\'3CB371\',\n        \'mediumslateblue\'=>\'7B68EE\',\n        \'mediumspringgreen\'=>\'00FA9A\',\n        \'mediumturquoise\'=>\'48D1CC\',\n        \'mediumvioletred\'=>\'C71585\',\n        \'midnightblue\'=>\'191970\',\n        \'mintcream\'=>\'F5FFFA\',\n        \'mistyrose\'=>\'FFE4E1\',\n        \'moccasin\'=>\'FFE4B5\',\n        \'navajowhite\'=>\'FFDEAD\',\n        \'navy\'=>\'000080\',\n        \'oldlace\'=>\'FDF5E6\',\n        \'olive\'=>\'808000\',\n        \'olivedrab\'=>\'6B8E23\',\n        \'orange\'=>\'FFA500\',\n        \'orangered\'=>\'FF4500\',\n        \'orchid\'=>\'DA70D6\',\n        \'palegoldenrod\'=>\'EEE8AA\',\n        \'palegreen\'=>\'98FB98\',\n        \'paleturquoise\'=>\'AFEEEE\',\n        \'palevioletred\'=>\'DB7093\',\n        \'papayawhip\'=>\'FFEFD5\',\n        \'peachpuff\'=>\'FFDAB9\',\n        \'peru\'=>\'CD853F\',\n        \'pink\'=>\'FFC0CB\',\n        \'plum\'=>\'DDA0DD\',\n        \'powderblue\'=>\'B0E0E6\',\n        \'purple\'=>\'800080\',\n        \'red\'=>\'FF0000\',\n        \'rosybrown\'=>\'BC8F8F\',\n        \'royalblue\'=>\'4169E1\',\n        \'saddlebrown\'=>\'8B4513\',\n        \'salmon\'=>\'FA8072\',\n        \'sandybrown\'=>\'F4A460\',\n        \'seagreen\'=>\'2E8B57\',\n        \'seashell\'=>\'FFF5EE\',\n        \'sienna\'=>\'A0522D\',\n        \'silver\'=>\'C0C0C0\',\n        \'skyblue\'=>\'87CEEB\',\n        \'slateblue\'=>\'6A5ACD\',\n        \'slategray\'=>\'708090\',\n        \'slategrey\'=>\'708090\',\n        \'snow\'=>\'FFFAFA\',\n        \'springgreen\'=>\'00FF7F\',\n        \'steelblue\'=>\'4682B4\',\n        \'tan\'=>\'D2B48C\',\n        \'teal\'=>\'008080\',\n        \'thistle\'=>\'D8BFD8\',\n        \'tomato\'=>\'FF6347\',\n        \'turquoise\'=>\'40E0D0\',\n        \'violet\'=>\'EE82EE\',\n        \'wheat\'=>\'F5DEB3\',\n        \'white\'=>\'FFFFFF\',\n        \'whitesmoke\'=>\'F5F5F5\',\n        \'yellow\'=>\'FFFF00\',\n        \'yellowgreen\'=>\'9ACD32\');\n\n    $color_name = strtolower($color_name);\n    \n    if (isset($colors[$color_name])){\n        return (\'#\' . $colors[$color_name]);\n    } else {\n        return ($color_name);\n    }\n}\n\nfunction step_color($rgb, $steps) {\n    \n    $steps = max(-255, min(255, $steps));\n    \n    $rgb = color_name_to_hex($rgb);\n   \n    if(!preg_match(\'/#([a-f0-9]{3}){1,2}\\b/i\', $rgb)) {nuDebug(\'Wrong Color:\'.$rgb);return $rgb;}\n    \n    $rgb = str_replace(\'#\', \'\', $rgb);\n    \n    if (strlen($rgb) == 3) {\n        $rgb = str_repeat(substr($rgb,0,1), 2).str_repeat(substr($rgb,1,1), 2).str_repeat(substr($rgb,2,1), 2);\n    }\n    \n    $color_parts = str_split($rgb, 2);\n    \n    $return = \'#\';\n    \n    foreach ($color_parts as $color) {\n        $color   = hexdec($color); // Convert to decimal\n        $color   = max(0,min(255,$color + $steps)); // Adjust color\n        $return .= str_pad(dechex($color), 2, \'0\', STR_PAD_LEFT); // Make two char hex code\n    }\n\n    return $return;\n}\n\nfunction search_event($ea, $event_id){\n    foreach ($ea as $event) {\n        if($event[0]==$event_id){\n                return true;\n        }\n    }\n    return false;\n}\n\n$datetime = new DateTime(\'now\');\n$datetime_string = $datetime->format(\'c\');\n$sql = \"    SELECT school_year.start_date,school_year.end_date\n            FROM school\n            INNER JOIN school_year ON school.school_year_id = school_year.id\n            WHERE school.id=1\";\n$retval = nuRunQuery($sql);\n\n$row = db_fetch_row($retval);\n\n$start_year = date(\'Y\', strtotime($row[0]));\n$end_year = date(\'Y\', strtotime($row[1]));\n\n$start_date = $start_year.\"-09-01\";\n$end_date = $end_year.\"-07-01\";\n\n$datetime_current = $datetime->format(\'Y-m-d\');\n$datetime_current = ($datetime_current>$end_date ? $end_date : ($datetime_current<$start_date ? $start_date : $datetime_current));\n\n$sql = \" SELECT distinct holiday,description FROM holiday ORDER BY holiday\";\n$rv = nuRunQuery($sql);\n\n$holiday_array = array();\n\nwhile ($r = db_fetch_row($rv)){\n    $holiday_array[]= array($r[0],$r[1]);    \n}\n\n//--------------------------------------------Εύρσεση συμβάντων του συγκεκριμένου καθηγητή--------------------------------------------\n\n$event_array = array();\n\n$sql = \"    SELECT \n                id,\n                title,\n                ifNULL(description,\'\'),\n                allDay,\n                start_date,\n                end_date,\n                start_time, \n                end_time,\n                ifNULL(color,\'\'),\n                ifNULL(backgroundColor,\'\'),\n                ifNULL(borderColor,\'\'),\n                ifNULL(textColor,\'\'),\n                is_exam,\n                is_test,\n                ifNULL(location,\'\'),\n                \'#RECORD_ID#\'\n            FROM calendar_event\n            WHERE teacher_id=\'#RECORD_ID#\'\n        \";\n$rv1 = nuRunQuery($sql);\n\nwhile ($r1 = db_fetch_row($rv1)){\n    if(!search_event($event_array,$r1[0])){\n        $event_array[]= $r1;    \n    }\n        \n}\n\n$sql = \"    SELECT \n                calendar_event.id,\n                calendar_event.title,\n                ifNULL(calendar_event.description,\'\'),\n                calendar_event.allDay,\n                calendar_event.start_date,\n                calendar_event.end_date,\n                calendar_event.start_time, \n                calendar_event.end_time,\n                ifNULL(calendar_event.color,\'\'),\n                ifNULL(calendar_event.backgroundColor,\'\'),\n                ifNULL(calendar_event.borderColor,\'\'),\n                ifNULL(calendar_event.textColor,\'\'),\n                calendar_event.is_exam,\n                calendar_event.is_test,\n                ifNULL(calendar_event.location,\'\'),\n                ifNULL(calendar_event.teacher_id,\'-1\')\n            FROM calendar_event\n            INNER JOIN calendar_event_access ON calendar_event.id = calendar_event_access.calendar_event_id\n            WHERE \n                calendar_event_access.teacher_id = \'#RECORD_ID#\' OR\n                calendar_event_access.user_group_id IN (SELECT zzzsys_user_group_id FROM zzzsys_user_group WHERE sug_code = \'#nu_user_group#\')\n        \";\n$rv2 = nuRunQuery($sql);\n\nwhile ($r2 = db_fetch_row($rv2)){\n    if(!search_event($event_array,$r2[0])){\n        $event_array[]= $r2;    \n    }\n}\n\nif(\'#show_all_exams#\'==\'1\'){\n    $sql = \"    SELECT \n                calendar_event.id,\n                calendar_event.title,\n                ifNULL(calendar_event.description,\'\'),\n                calendar_event.allDay,\n                calendar_event.start_date,\n                calendar_event.end_date,\n                calendar_event.start_time, \n                calendar_event.end_time,\n                ifNULL(calendar_event.color,\'\'),\n                ifNULL(calendar_event.backgroundColor,\'\'),\n                ifNULL(calendar_event.borderColor,\'\'),\n                ifNULL(calendar_event.textColor,\'\'),\n                calendar_event.is_exam,\n                calendar_event.is_test,\n                ifNULL(calendar_event.location,\'\'),\n                ifNULL(calendar_event.teacher_id,\'-1\')\n            FROM calendar_event\n            WHERE is_exam=\'1\'\n        \";\n    $rv3 = nuRunQuery($sql);\n\n    while ($r3 = db_fetch_row($rv3)){\n        if(!search_event($event_array,$r3[0])){\n        $event_array[]= $r3;    \n        }\n    }    \n}\n//------------------------------------------------------------------------------------------------------------------------------------\n\nprint\"\n<!DOCTYPE html>\n<html>\n<head>\n    <meta charset=\'utf-8\' />\n    <link href=\'calendar/fullcalendar.min.css\' rel=\'stylesheet\' />\n    <link href=\'calendar/fullcalendar.print.min.css\' rel=\'stylesheet\' media=\'print\' />\n    \n    <script src=\'calendar/lib/moment.min.js\'></script>\n    <script src=\'calendar/lib/jquery.min.js\'></script>\n    <script src=\'calendar/fullcalendar.min.js\'></script>\n    <script src=\'calendar/locale/el.js\'></script>\n    <script>\n        var holiday_array = [];\n\";\n    \nforeach ($holiday_array as $holiday) {\n    print \"     holiday_array.push([\\\"\".$holiday[0].\"\\\", \\\"\".$holiday[1].\"\\\"]);\n\";\n} \n\nprint\"    \n	$(document).ready(function() {\n		$(\'#calendar\').fullCalendar({\n			defaultDate: \'$datetime_current\',\n			editable: false,\n			aspectRatio: 2,\n			fixedWeekCount: false,\n			eventLimit: true,\n			minTime: \'07:00:00\',\n			maxTime: \'22:00:00\',\n			nowIndicator: true,\n		    visibleRange: \n		        {\n                start: \'\".$start_date.\"\',\n                end: \'\".$end_date.\"\'\n                },\n            validRange: \n		        {\n                start: \'\".$start_date.\"\',\n                end: \'\".$end_date.\"\'\n                },\n			now: \".json_encode($datetime_string).\",\n			header: \n			    {\n		            left:   \'prev,next today\',\n                    center: \'title\',\n                    right:  \'month,agendaWeek,agendaDay,listMonth\'\n			    },\n\n            dayRender: function (date, cell) \n                {\n                    var d=date.format(\'YYYY-MM-DD\');\n                    for (var i = 0; i < holiday_array.length; i++) {\n                        if (d==holiday_array[i][0]) {\n                            cell.css(\\\"background-color\\\", \\\"#ffdb99\\\");\n                            break;\n                        }\n                    }\n                },\n                \n            dayClick: function(date, jsEvent, view) {\n            \n                parent.selectedDate = date.format(\'DD-MM-YYYY\');\n                parent.selectedTime = date.format(\'HH:mm:ss\');\n                \n                date.add(30,\'m\');\n                \n                parent.selectedEndDate = date.format(\'DD-MM-YYYY\');\n                parent.selectedEndTime = date.format(\'HH:mm:ss\');\n                \n                if(view.name == \'month\' || view.name == \'agendaWeek\') {\n                    //$(\'#calendar\').fullCalendar(\'changeView\', \'agendaDay\');\n                    $(\'#calendar\').fullCalendar(\'gotoDate\', date);      \n                }\n                parent.nuOpenFormInFrame(\'599954a01e175cd\',\'-1\');\n            },\n                \n            eventClick: function(calEvent, jsEvent, view) {\n                if(calEvent.id>0){\n                    parent.nuOpenFormInFrame(\'599954a01e175cd\',calEvent.id)\n                }\n            },\n            \n            eventMouseover: function(calEvent, jsEvent, view) {\n                if(calEvent.id>0){\n                    this.style.cursor=\\\"pointer\\\";\n                } else{\n                    this.style.cursor=\\\"auto\\\";    \n                }\n                if (!($(\'#eventContent\').is(\':visible\'))){\n		            \n		            var position = $(this).offset();\n		            var overlap = false;\n		            \n		            var new_top = position.top;\n		            var new_left = position.left-410;\n		            \n		            if (new_left < 10){\n                        new_left = position.left+$(this).width()+10;\n		            }\n		            \n		            if (new_left > $(document).width()-420){\n                        new_left = $(document).width()-445;\n                        overlap = true;\n                        new_top += $(this).height()+5;\n		            }\n\n		            if (($(document).height()-position.top) < 250){\n                        if(overlap){\n                            new_top = position.top-250;    \n                        } else {\n                            new_top = position.top+$(this).height()-245;    \n                        }\n		            }\n			    \n		            $(\'#eventContent\').css({ top: new_top+\'px\' });\n		            $(\'#eventContent\').css({ left: new_left+\'px\' });\n		            \n		            $(\'#eventTitle\').html(calEvent.title);\n		            $(\'#eventTitle\').css({ color: calEvent.color });\n		            \n		            $(\'#startTime\').html(moment(calEvent.start).format(\'MMM Do h:mm A\'));\n		            if(moment(calEvent.end).format(\'MMM Do h:mm A\')==\'Invalid date\'){\n		                $(\'#endTime\').html(\'\');    \n		            } else {\n		                $(\'#endTime\').html(moment(calEvent.end).format(\'MMM Do h:mm A\'));    \n		            }\n                    $(\'#allDay\').html(calEvent.allDay ? \'Ναί\' : \'Όχι\');\n                    $(\'#eventDescription\').html(calEvent.description);\n                    $(\'#eventLocation\').html(calEvent.location);\n\n		            $(\'#eventContent\').show();\n		        \n		        }\n		\n                $(this).bind(\'wheel\', function(e){\n                    var scrollTo = $(\'#eventContent\').scrollTop() - (e.originalEvent.deltaY*-1);\n                    $(\'#eventContent\').scrollTop(scrollTo);\n                });\n		        \n            },\n            eventMouseout: function(calEvent, jsEvent, view) {\n                $(\'#eventContent\').hide();\n                this.style.cursor=\\\"auto\\\";\n            },           \n            \n            eventSources: [\n\n                {\n                    events: [\";\n                    \n$last_holiday = end(array_keys($holiday_array));\nforeach ($holiday_array as $holiday) {\n    print\"\n                        {\n					        title: \'\".$holiday[1].\"\',\n					        start: \'\".$holiday[0].\"\',\n					        color: \'green\',\n					        allDay: true,\n					        description: \'Αργία\',\n					        location: \'\'\n				        },\n				        {\n                            start: \'\".$holiday[0].\"T00:00:00\',\n                            end: \'\".$holiday[0].\"T23:59:59\',\n                            rendering: \'background\'\n                        }\".($holiday[0]!=$last_holiday[0] ? \',\' : \'\');\n}                     \n\nprint\"\n                    ]\n                },\n                \n                {\n                    events: [\";\n                    \n$last_event = end(array_keys($event_array));\nforeach ($event_array as $event) {\n    $c = ($event[8]!=\'\' ? $event[8] : \'#3a87ad\');\n    $c = ($event[15]==\'#RECORD_ID#\' ? step_color($c, -50) : $c);\n    print\"\n                        {\n                            id: \'\".$event[0].\"\',\n                            title: \".json_encode($event[1],JSON_HEX_APOS).\",\n                            allDay: \".($event[3]==\'1\' ? \'true\' : \'false\').\",\n                            start: \'\".$event[4].($event[3]==\'0\' ? \'T\'.$event[6] : \'\'  ).\"\',\n                            end: \'\".$event[5].($event[3]==\'0\' ? \'T\'.$event[7] : \'\'  ).\"\',\n                            color: \'$c\',\n                            \".($event[9]!=\'\' ? \"backgroundColor: \'\".$event[9].\"\',\n                            \" : \'\').($event[10]!=\'\' ? \"borderColor: \'\".$event[10].\"\',\n                            \" : \'\').($event[11]!=\'\' ? \"textColor: \'\".$event[11].\"\',\n                            \" : \'\').\n                            \"description: \".json_encode(preg_replace(\"/\\r\\n|\\r|\\n/\",\'<br/>\',$event[2]),JSON_HEX_APOS).\",\n                            is_exam: \'\".$event[12].\"\',\n					        is_test: \'\".$event[13].\"\',\n					        location: \'\".$event[14].\"\'\n				        }\".($event!=$last_event ? \',\' :\'\');\n}                     \n\nprint\"\n                    ]\n                }\n            ]\n        });\n\n	});\n	\nfunction add_event(id,title,allDay,start,end,color,is_exam,is_test,description,location){\n        var new_event = \n                        {\n                            id: id,\n                            title: title,\n                            allDay: (allDay==\'1\' ? true : false),\n                            start: start,\n                            end: end,\n                            color: color,\n                            description: description,\n                            is_exam: is_exam,\n					        is_test: is_test,\n					        location: location\n				        };\n		$(\'#calendar\').fullCalendar(\'gotoDate\', start);\n        $(\\\"#calendar\\\").fullCalendar( \'renderEvent\', new_event);\n}\n\nfunction update_event(id,title,allDay,start,end,description,location){\n    var e = $(\\\"#calendar\\\").fullCalendar(\'clientEvents\', id);\n    if(e[0] != null){\n        e[0].title          = title;\n        e[0].allDay         = (allDay==\'1\' ? true : false);\n        e[0].start          = start;\n        e[0].end            = end;\n        e[0].description    = description;\n	    e[0].location       = location;\n	    $(\\\"#calendar\\\").fullCalendar(\'updateEvent\', e[0]);\n    } else{\n        add_event(id,title,allDay,start,end,\'#3a87ad\',\'0\',\'0\',description,location);\n    }\n}\n\nfunction remove_event(id){\n    $(\\\"#calendar\\\").fullCalendar(\'removeEvents\', id);\n}\n</script>\n<style>\n	body {\n		margin: 0px 10px;\n		padding: 0;\n		font-family: \\\"Lucida Grande\\\",Helvetica,Arial,Verdana,sans-serif;\n		font-size: 14px;\n	}\n	\n	.eventContents{\n			    display: none;\n			    position: absolute;\n			    z-index: 5000;\n			    padding-top: 1px;\n                padding-right: 20px;\n                padding-left: 20px;\n			    overflow-x:none;\n			    padding-bottom: 0 !important;\n			    width: 360px;\n			    height: 240px;\n			    border-radius: 15px;\n			    border: 1px solid #C8C8C8;\n			    background-color:#fff;\n			    box-shadow: 0 4px 3px #8C8C8C;\n			    overflow-y: auto;\n	}\n\n	#calendar {\n		max-width: 1050px;\n		margin: 0 auto;\n	}\n	\n	.fc-mon { background-color:#ffffe6; }\n	.fc-tue { background-color:#ffffe6; }\n	.fc-wed { background-color:#ffffe6; }\n	.fc-thu { background-color:#ffffe6; }\n	.fc-fri { background-color:#ffffe6; }\n	.fc-sat { background-color:#ffdb99; }\n    .fc-sun { background-color:#ffdb99; }\n    .fc-today { background-color:#ffff80 !important; color:#ff0000 !important;}\n    .fc-bgevent { background-color:#ffa600 !important; }\n\n</style>\n</head>\n<body>\n    <div id=\\\"eventContent\\\" class=\\\"eventContents\\\" title=\\\"Λεπτομέρειες Συμβάντος\\\">\n        \n        <p><font size=+1><b><span id=\\\"eventTitle\\\"></span></b></font></p>\n        \n        <table border=0>\n            <tr>\n                <td width=70><b>Έναρξη</b></td>\n                <td> : </td>\n                <td><span id=\\\"startTime\\\"></span></td>\n            </tr>\n            <tr>\n                <td width=70><b>Λήξη</b></td>\n                <td> : </td>\n                <td><span id=\\\"endTime\\\"></span></td>           \n            </tr>\n            <tr>\n                <td width=70><b>Ολοήμερο</b></td>\n                <td> : </td>\n                <td><span id=\\\"allDay\\\"></span></td>\n            </tr>\n            <tr>\n                <td width=70><b>Τοποθεσία</b></td>\n                <td> : </td>\n                <td><span id=\\\"eventLocation\\\"></span></td>\n            </tr>\n            <tr>\n                <td width=70><b>Περιγραφή</b></td>\n                <td> : </td>\n                <td></td>\n            </tr>\n            <tr>\n                <td colspan=3><span id=\\\"eventDescription\\\" style=\\\"font-size: 12px;\\\"></span></td>\n            </tr>\n        </table>\n    </div>\n	<div id=\'calendar\'></div>\n</body>\n</html>\";','','0','2017-08-17 18:37:00','globeadmin','2022-01-10 21:38:22','globeadmin','2022-01-10 21:38:22','globeadmin','0'),('599efd331c64642','publish_calendar_event','Κοινοποιεί ένα συμβάν Ημερολογίου','Teachers','nuRunPHP(\'notification_add_lib\');\nnuRunPHP(\'send_email_calendar_event\');\n\n$nuParameters = \'-1\';\n$publish_id = nuID();\n\nif (\'#selection1#\' == \'#\'.\'selection1\'.\'#\' || \'#selection1#\' == \'\') {\n    $nuError = \"Προσοχή: Επιλέξτε πρώτα σε ποιους θα γίνει η κοινοποίηση!\";    \n} elseif (\'#selection1#\' == \'0\') {\n\n    $sql = \"INSERT INTO calendar_event_access (\n                id,\n                calendar_event_id,\n                teacher_id,\n                student_id,\n                grade_id,\n                class_id,\n                user_group_id,\n                publish_id\n                )\n            SELECT\n                NULL,\n                \'#RECORD_ID#\',\n                NULL,\n                NULL,\n                NULL,\n                NULL,\n                zzzsys_user_group_id,\n                \'$publish_id\'\n            FROM zzzsys_user_group WHERE 1\n    \";\n    $t = nuRunQuery($sql,NULL,true);\n    if($t<>-1){$nuParameters = \'Η Κοινοποίηση πραγματοποιήθηκε επιτυχώς!\';} else {$nuError = \"Προσοχή: Παρουσιάστηκε σφάλμα κατά την κοινοποίηση!\";}\n    \n} elseif (\'#selection1#\' == \'1\') {\n\n    $sql = \"INSERT INTO calendar_event_access (\n                id,\n                calendar_event_id,\n                teacher_id,\n                student_id,\n                grade_id,\n                class_id,\n                user_group_id,\n                publish_id\n                )\n            SELECT\n                NULL,\n                \'#RECORD_ID#\',\n                NULL,\n                NULL,\n                NULL,\n                NULL,\n                zzzsys_user_group_id,\n                \'$publish_id\'\n            FROM zzzsys_user_group \n            WHERE zzzsys_user_group_id IN (\'547de466910d843\',\'547de49454047c6\',\'5601b00712ca90c\',\'568946b83ec3baa\')\n    \";\n    $t = nuRunQuery($sql,NULL,true);\n    if($t<>-1){$nuParameters = \'Η Κοινοποίηση πραγματοποιήθηκε επιτυχώς!\';} else {$nuError = \"Προσοχή: Παρουσιάστηκε σφάλμα κατά την κοινοποίηση!\";}\n        \n} elseif (\'#selection1#\' == \'2\') {\n    $sql = \"INSERT INTO calendar_event_access (\n                id,\n                calendar_event_id,\n                teacher_id,\n                student_id,\n                grade_id,\n                class_id,\n                user_group_id,\n                publish_id\n                )\n            SELECT\n                NULL,\n                \'#RECORD_ID#\',\n                NULL,\n                NULL,\n                NULL,\n                NULL,\n                zzzsys_user_group_id,\n                \'$publish_id\'\n            FROM zzzsys_user_group \n            WHERE zzzsys_user_group_id IN (\'547de466910d843\',\'547de49454047c6\',\'5601b00712ca90c\',\'568946b83ec3baa\',\'547de4b10fa7616\',\'60475b01603a277\')\n    \";\n    $t = nuRunQuery($sql,NULL,true);\n    if($t<>-1){$nuParameters = \'Η Κοινοποίηση πραγματοποιήθηκε επιτυχώς!\';} else {$nuError = \"Προσοχή: Παρουσιάστηκε σφάλμα κατά την κοινοποίηση!\";} \n} elseif (\'#selection1#\' == \'3\') {\n    if(\'#teacher_id_select_sumo#\'!=\'#\'.\'teacher_id_select_sumo#\' && \'#teacher_id_select_sumo#\'!=\'\'){\n        $sql = \"INSERT INTO calendar_event_access (\n                id,\n                calendar_event_id,\n                teacher_id,\n                student_id,\n                grade_id,\n                class_id,\n                user_group_id,\n                publish_id\n                )\n            SELECT\n                NULL,\n                \'#RECORD_ID#\',\n                teacher.id,\n                NULL,\n                NULL,\n                NULL,\n                NULL,\n                \'$publish_id\'\n            FROM teacher WHERE id IN(#teacher_id_select_sumo#)\n        \";\n        $t = nuRunQuery($sql,NULL,true);\n        if($t<>-1){$nuParameters = \'Η Κοινοποίηση πραγματοποιήθηκε επιτυχώς!\';} else {$nuError = \"Προσοχή: Παρουσιάστηκε σφάλμα κατά την κοινοποίηση!\";}\n    } else {\n        $nuError = \"Προσοχή: Επιλέξτε πρώτα καθηγητές!\";     \n    }\n} elseif (\'#selection1#\' == \'8\') {\n        $sql = \"INSERT INTO calendar_event_access (\n                id,\n                calendar_event_id,\n                teacher_id,\n                student_id,\n                grade_id,\n                class_id,\n                user_group_id,\n                publish_id)\n            VALUES (\n                NULL,\n                \'#RECORD_ID#\',\n                NULL,\n                NULL,\n                NULL,\n                NULL,\n                \'999999999999999\',\n                \'$publish_id\')\";\n        $t = nuRunQuery($sql,NULL,true);\n        if($t<>-1){$nuParameters = \'Η Κοινοποίηση πραγματοποιήθηκε επιτυχώς!\';} else {$nuError = \"Προσοχή: Παρουσιάστηκε σφάλμα κατά την κοινοποίηση!\";}\n    \n} elseif (\'#selection1#\' == \'4\' || \'#selection1#\' == \'5\' || \'#selection1#\' == \'6\' || \'#selection1#\' == \'7\') {\n    \n    if( \'#students_check_hash#\'==\'#\'.\'students_check_hash#\' || \'#students_check_hash#\'==\'\' || \n        \'#parents_check_hash#\'==\'#\'.\'parents_check_hash#\' || \'#parents_check_hash#\'==\'\' || \n        (\'#students_check_hash#\'==\'0\' && \'#parents_check_hash#\'==\'0\')){\n        $nuError = \"Προσοχή: Επιλέξτε πρώτα αν η κοινοποίηση θα γίνει «σε Μαθητές» ή και «σε Γονείς»!!\"; \n    } else {\n        if (\'#selection1#\' == \'4\'){\n\n            $sql = \"INSERT INTO calendar_event_access (\n                            id,\n                            calendar_event_id,\n                            teacher_id,\n                            student_id,\n                            grade_id,\n                            class_id,\n                            user_group_id,\n                            publish_id\n                            )\n                        SELECT\n                            NULL,\n                            \'#RECORD_ID#\',\n                            NULL,\n                            NULL,\n                            NULL,\n                            NULL,\n                            zzzsys_user_group_id,\n                            \'$publish_id\'\n                    FROM zzzsys_user_group \n                    WHERE zzzsys_user_group_id IN (\n                        \".(\'#students_check_hash#\'==\'1\' ? \'\\\'547de4c65675a29\\\'\' :\'\').\"\n                        \".(\'#students_check_hash#\'==\'1\' && \'#parents_check_hash#\'==\'1\'? \',\' :\'\').\"\n                        \".(\'#parents_check_hash#\'==\'1\' ? \'\\\'5717ba3eb32c252\\\'\':\'\').\")\n            \";\n            $t = nuRunQuery($sql,NULL,true);\n            if($t<>-1){$nuParameters = \'Η Κοινοποίηση πραγματοποιήθηκε επιτυχώς!\';} else {$nuError = \"Προσοχή: Παρουσιάστηκε σφάλμα κατά την κοινοποίηση!\";}\n        } elseif (\'#selection1#\' == \'5\') {\n            if(\'#grade_id_select_sumo#\'!=\'#\'.\'grade_id_select_sumo#\' && \'#grade_id_select_sumo#\'!=\'\'){\n                $sql = \"INSERT INTO calendar_event_access (\n                            id,\n                            calendar_event_id,\n                            teacher_id,\n                            student_id,\n                            grade_id,\n                            class_id,\n                            user_group_id,\n                            publish_id\n                            )\n                        SELECT\n                            NULL,\n                            \'#RECORD_ID#\',\n                            NULL,\n                            NULL,\n                            id,\n                            NULL,\n                            zzzsys_user_group_id,\n                            \'$publish_id\'\n                    FROM grade \n                    inner join zzzsys_user_group ON zzzsys_user_group_id in (\n                        \".(\'#students_check_hash#\'==\'1\' ? \'\\\'547de4c65675a29\\\'\' :\'\').\"\n                        \".(\'#students_check_hash#\'==\'1\' && \'#parents_check_hash#\'==\'1\'? \',\' :\'\').\"\n                        \".(\'#parents_check_hash#\'==\'1\' ? \'\\\'5717ba3eb32c252\\\'\':\'\').\")\n                    WHERE id IN(#grade_id_select_sumo#)\n                \";\n                $t = nuRunQuery($sql,NULL,true);\n                if($t<>-1){$nuParameters = \'Η Κοινοποίηση πραγματοποιήθηκε επιτυχώς!\';} else {$nuError = \"Προσοχή: Παρουσιάστηκε σφάλμα κατά την κοινοποίηση!\";}\n            } else {\n                $nuError = \"Προσοχή: Επιλέξτε πρώτα τάξεις!\";     \n            }    \n        } elseif (\'#selection1#\' == \'6\') {\n            if(\'#class_id_select_sumo#\'!=\'#\'.\'class_id_select_sumo#\' && \'#class_id_select_sumo#\'!=\'\'){\n                $sql = \"INSERT INTO calendar_event_access (\n                            id,\n                            calendar_event_id,\n                            teacher_id,\n                            student_id,\n                            grade_id,\n                            class_id,\n                            user_group_id,\n                            publish_id\n                            )\n                        SELECT\n                            NULL,\n                            \'#RECORD_ID#\',\n                            NULL,\n                            NULL,\n                            NULL,\n                            id,\n                            zzzsys_user_group_id,\n                            \'$publish_id\'\n                    FROM class \n                    inner join zzzsys_user_group ON zzzsys_user_group_id in (\n                        \".(\'#students_check_hash#\'==\'1\' ? \'\\\'547de4c65675a29\\\'\' :\'\').\"\n                        \".(\'#students_check_hash#\'==\'1\' && \'#parents_check_hash#\'==\'1\'? \',\' :\'\').\"\n                        \".(\'#parents_check_hash#\'==\'1\' ? \'\\\'5717ba3eb32c252\\\'\':\'\').\")\n                    WHERE id IN(#class_id_select_sumo#)\n                \";\n                $t = nuRunQuery($sql,NULL,true);\n                if($t<>-1){$nuParameters = \'Η Κοινοποίηση πραγματοποιήθηκε επιτυχώς!\';} else {$nuError = \"Προσοχή: Παρουσιάστηκε σφάλμα κατά την κοινοποίηση!\";}\n            } else {\n                $nuError = \"Προσοχή: Επιλέξτε πρώτα τμήματα!\";     \n            }     \n        } elseif (\'#selection1#\' == \'7\') {\n            if(\'#student_id_select_sumo#\'!=\'#\'.\'student_id_select_sumo#\' && \'#student_id_select_sumo#\'!=\'\'){\n                $sql = \"INSERT INTO calendar_event_access (\n                            id,\n                            calendar_event_id,\n                            teacher_id,\n                            student_id,\n                            grade_id,\n                            class_id,\n                            user_group_id,\n                            publish_id\n                            )\n                        SELECT\n                            NULL,\n                            \'#RECORD_ID#\',\n                            NULL,\n                            id,\n                            NULL,\n                            NULL,\n                            zzzsys_user_group_id,\n                            \'$publish_id\'\n                    FROM student \n                    inner join zzzsys_user_group ON zzzsys_user_group_id in (\n                        \".(\'#students_check_hash#\'==\'1\' ? \'\\\'547de4c65675a29\\\'\' :\'\').\"\n                        \".(\'#students_check_hash#\'==\'1\' && \'#parents_check_hash#\'==\'1\'? \',\' :\'\').\"\n                        \".(\'#parents_check_hash#\'==\'1\' ? \'\\\'5717ba3eb32c252\\\'\':\'\').\")\n                    WHERE id IN(#student_id_select_sumo#)\n                \";\n                $t = nuRunQuery($sql,NULL,true);\n                if($t<>-1){$nuParameters = \'Η Κοινοποίηση πραγματοποιήθηκε επιτυχώς!\';} else {$nuError = \"Προσοχή: Παρουσιάστηκε σφάλμα κατά την κοινοποίηση!\";}\n            } else {\n                $nuError = \"Προσοχή: Επιλέξτε πρώτα μαθητές!\";     \n            }\n        }        \n    }\n}  else {\n    $nuError = \"Προσοχή: Αυτή δεν είναι μια έγκυρη επιλογή!\";    \n}\n        // Clean up dublicates if any. Δεν είναι και ο καλύτερος τρόπος αλλά για να γίνει σωστά χρειάζονται πάρα πολοί έλεγχοι. \n$sql = \"DELETE a\nFROM calendar_event_access as a, calendar_event_access as b\nWHERE\n        (a.calendar_event_id = b.calendar_event_id) AND\n        (a.teacher_id = b.teacher_id OR (a.teacher_id IS NULL AND b.teacher_id IS NULL)) AND\n        (a.student_id = b.student_id OR (a.student_id IS NULL AND b.student_id IS NULL)) AND    \n        (a.grade_id = b.grade_id OR (a.grade_id IS NULL AND b.grade_id IS NULL)) AND\n        (a.class_id = b.class_id OR (a.class_id IS NULL AND b.class_id IS NULL)) AND\n        (a.user_group_id = b.user_group_id OR (a.user_group_id IS NULL AND b.user_group_id IS NULL)) AND\n        a.id > b.id\";\nnuRunQuery($sql);\n\nif(\'#inform_check_hash#\'==\'1\'){\n    $sql =\"SELECT id FROM calendar_event_access WHERE publish_id=\'$publish_id\' AND user_group_id IN (\'547de4c65675a29\',\'5717ba3eb32c252\')\";\n    $rv = nuRunQuery($sql);\n    while($r = db_fetch_row($rv)){\n        calendar_event_notification($r[0],7);\n    }\n\n    $sql =\"SELECT id FROM calendar_event_access WHERE publish_id=\'$publish_id\' AND (user_group_id IS NULL OR user_group_id NOT IN (\'547de4c65675a29\',\'5717ba3eb32c252\', \'999999999999999\'))\";\n    $rv2 = nuRunQuery($sql);\n    while($r2 = db_fetch_row($rv2)){\n        $m = calendar_event_email($r2[0],7);\n        if($m ==\"-1\"){\n            $nuParameters .= \"\\nΤα email ενημέρωσης προς τους καθηγητές δεν μπόρεσαν να σταλούν!\";\n        } else if($m !=\"\"){\n            $nuParameters .= \"\\n\".$m;\n        }\n    }\n}\n\n$sql =\"SELECT count(*) FROM calendar_event_access WHERE publish_id=\'$publish_id\'\";\n$retval = nuRunQuery($sql);\n$row = db_fetch_row($retval);\n\nif($row[0]>0){\n    $sql=\"  SELECT \n                calendar_event.teacher_id,\n                session_variables.teacher_id\n        FROM calendar_event\n        INNER JOIN session_variables    ON  session_variables.session_id = \'#session_id#\'\n        WHERE \n            calendar_event.id=\'#RECORD_ID#\'\";\n    $rv3 = nuRunQuery($sql);        \n        \n    if($r3 = db_fetch_row($rv3)){\n        if($r3[0]!=$r3[1]){\n            $m = calendar_event_owner_email(\'#RECORD_ID#\',7);\n            $nuParameters .= \"\\n\".$m;\n        }    \n    }\n}\n\n','','0','2017-08-24 19:22:11','globeadmin','2021-03-09 14:10:02','globeadmin','2021-10-09 23:20:55','globeadmin','0'),('59a17e291687ee8','show_participants_calendar_event','Εμφανίζει τους συμμετέχοντες σε ένα συμβάν του ημερολογίου','Teacher','print \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n        <STYLE TYPE=\\\"text/css\\\">\n			.sisTableLine TD{\n                font-weight: normal;    \n            }\n        </STYLE>\n    </head>\n    <body>\";\n\n$sql=\"  SELECT\n                calendar_event_access.id,\n                calendar_event_access.teacher_id,\n                calendar_event_access.student_id,\n                calendar_event_access.grade_id,\n                calendar_event_access.class_id,\n                calendar_event_access.user_group_id,\n				if(calendar_event_access.teacher_id IS NOT NULL,concat(if(teacher.surname is null,\'\',concat(teacher.surname,\' \')), IFNULL(teacher.name,\'\'),\', Καθηγητής\'),\n				if(calendar_event_access.grade_id IS NOT NULL,concat(\'Τάξη \',grade.short_name,\', Όλοι οι \',sug_description),\n				if(calendar_event_access.class_id IS NOT NULL,concat(\'Τμήμα \',class.short_name,\', Όλοι οι \',sug_description),\n				if(calendar_event_access.student_id IS NOT NULL,concat( student.registration_number,\'-\',ifNULL(student.surname,\'\'),if(student.surname is NULL OR student.name is NULL,\'\',\' \'),ifNULL(student.name,\'\'),if(student.fathers_name is NULL,\'\',concat(\' πατ. \',student.fathers_name)),\n				        if(user_group_id=\'547de4c65675a29\',\', Μαθητής\',if(user_group_id=\'5717ba3eb32c252\',\', Γονέας\',\'\'))),\n                if(calendar_event_access.user_group_id IS NOT NULL,\n                if(calendar_event_access.user_group_id=\'999999999999999\',\'Δημόσιο (για την Ιστοσελίδα του Σχολείου)\',concat(\'Όλοι οι \',sug_description))    \n                ,\'\')))))\n        FROM calendar_event_access\n        LEFT JOIN teacher           ON calendar_event_access.teacher_id     = teacher.id\n        LEFT JOIN student           ON calendar_event_access.student_id     = student.id\n        LEFT JOIN grade             ON calendar_event_access.grade_id       = grade.id\n        LEFT JOIN class             ON calendar_event_access.class_id       = class.id\n        LEFT JOIN zzzsys_user_group ON calendar_event_access.user_group_id  = zzzsys_user_group.zzzsys_user_group_id \n        WHERE\n            calendar_event_id=\'#RECORD_ID#\'\n        ORDER BY    \n                    student.surname,\n                    student.name,\n                    student.fathers_name,\n                    class.short_name,\n                    grade.short_name,\n                    teacher.surname,\n                    teacher.name,\n                    calendar_event_access.user_group_id\n\";\n\n$retval = nuRunQuery($sql);\n\n\nif($retval) {\n    if(db_num_rows($retval)>0) {\n        print (\"\n        <table cellspacing=0 CLASS=\\\"sisTableLine\\\" align=center width=600>\n            <tr height=30>\n                <th width=50 align=right colspan=2 width=600>\n                    Επιλογή Όλων<input type=\\\"checkbox\\\" id=\\\"all_chk_1\\\" title=\\\"Επιλογή Όλων\\\" onclick=\\\"toggle(this,\'chk_1\')\\\">\n                </th>\n            </tr>\");\n        \n        while($row = db_fetch_row($retval)) {\n                \n            print (\"            \n            <tr height=27>\n                <td align=left>\".$row[6].\" \".$row[7].\" \".$row[8].\" \".$row[9].\" \".$row[10].\"</td>\");\n            print(\"<td align=right><input type=\\\"checkbox\\\" CLASS=\\\"chk_1\\\" id=\\\"\".$row[0].\"\\\" title=\\\"Επιλογή\\\" onclick=\\\"make_indeterminate(\'all_chk_1\')\\\"></td>\");\n            print (\"            </tr>\");\n        }\n        print (\"\n        </table>\");\n    } else{\n        print (\"<span CLASS=\\\"msg\\\">Το συμβάν δεν έχει κοινοποιηθεί!</span>\");\n    }\n} else{\n    print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν δεδομένα...</span>\");\n}\nprint \"\n    </body>\n</html>\";','','0','2017-08-26 16:56:57','globeadmin','2018-07-16 10:37:18','globeadmin','2018-07-16 10:37:18','globeadmin','0'),('59a29391abf2a01','delete_event_calendar_participants','Διαγράφει επιλεγμένους συμμετέχοντες σε ένα συμβάν ημερολογίου','Teachers','nuRunPHP(\'notification_add_lib\');\nnuRunPHP(\'send_email_calendar_event\');\n$nuParameters = \'\';\n\nif(\'#id_list#\'!=\'#\'.\'id_list#\' && \'#id_list#\'!=\'\'){\n\n    if(\'#inform_check_hash#\'==\'1\'){\n        $sql = \"SELECT id,user_group_id FROM calendar_event_access WHERE id IN (#id_list#) AND calendar_event_id=\'#RECORD_ID#\'\";\n        $retval = nuRunQuery($sql);\n    \n        while($row=db_fetch_row($retval)){\n            if($row[1]==\'547de4c65675a29\' || $row[1]==\'5717ba3eb32c252\'){ \n                calendar_event_notification($row[0],9);\n            } else if($row[1]!=\'999999999999999\'){\n                $m = calendar_event_email($row[0],10);\n                if($m!=\'-1\' && $m !=\'\'){\n                    $nuParameters .= ($nuParameters != \"\" ? \"\\n\" : \"\").$m;    \n                }\n            }\n        }\n    }\n    \n    \n    $sql=\"  SELECT \n                calendar_event.teacher_id,\n                session_variables.teacher_id\n        FROM calendar_event\n        INNER JOIN session_variables    ON  session_variables.session_id = \'#session_id#\'\n        WHERE \n            calendar_event.id=\'#RECORD_ID#\'\";\n    $retval = nuRunQuery($sql);        \n        \n    if($row = db_fetch_row($retval)){\n        if($row[0]!=$row[1]){\n            $m = calendar_event_owner_email(\'#RECORD_ID#\',7);\n            $nuParameters .= ($nuParameters != \"\" ? \"\\n\" : \"\").$m;\n        }    \n    }\n    \n    $sql=\"DELETE FROM calendar_event_access WHERE id IN (#id_list#) AND calendar_event_id=\'#RECORD_ID#\'\";\n    nuRunQuery($sql);\n    \n} else {\n    $nuParameters = \'-1\';    \n}\n','','0','2017-08-27 12:40:33','globeadmin','2017-12-14 23:15:13','globeadmin','2017-12-14 23:15:13','globeadmin','0'),('59a844651845ca6','delete_calendar_event','Διαγράφει ένα συμβάν ημερολογίου','Teachers','nuRunPHP(\'notification_add_lib\');\nnuRunPHP(\'send_email_calendar_event\');\n\n$nuParameters = \'\';\n\nif(\'#FORM_ID#\'==\'5a28402a618a46f\'){\n    if(\'#calendar_event_id#\'!=\'\' && \'#calendar_event_id#\'!=\'#\'.\'calendar_event_id#\'){\n        $id = \'#calendar_event_id#\'; \n    } else {\n        $id = \'-1\';\n        $nuParameters = \'-1\';\n    }\n} else {\n    $id = \'#RECORD_ID#\';\n}\n\nif(\'#inform_check_hash#\'==\'1\'){\n    $sql = \"SELECT id,user_group_id FROM calendar_event_access WHERE calendar_event_id=\'$id\'\";\n    $retval = nuRunQuery($sql);\n\n    while($row=db_fetch_row($retval)){\n        if($row[1]==\'547de4c65675a29\' || $row[1]==\'5717ba3eb32c252\'){\n            calendar_event_notification($row[0],9);\n        } else if($row[1]!=\'999999999999999\'){\n            $m = calendar_event_email($row[0],9);\n            if($m!=\'-1\' && $m !=\'\'){\n                $nuParameters .= ($nuParameters != \"\" ? \"\\n\" : \"\").$m;    \n            }\n        }\n    }\n}\n\n$sql=\"  SELECT \n                calendar_event.teacher_id,\n                session_variables.teacher_id\n        FROM calendar_event\n        INNER JOIN session_variables    ON  session_variables.session_id = \'#session_id#\'\n        WHERE \n            calendar_event.id=\'$id\'\";\n$retval = nuRunQuery($sql);        \n        \nif($row = db_fetch_row($retval)){\n    if($row[0]!=$row[1]){\n        $m = calendar_event_owner_email($id,9);\n        $nuParameters .= ($nuParameters != \"\" ? \"\\n\" : \"\").$m;\n    }    \n}\n\n$sql=\"DELETE FROM calendar_event WHERE id=\'$id\'\";\nnuRunQuery($sql);\n\n$sql=\"DELETE FROM calendar_event_access WHERE calendar_event_id=\'$id\'\";\nnuRunQuery($sql);\n','','0','2017-08-31 20:16:21','globeadmin','2017-12-14 21:44:49','globeadmin','2020-09-22 13:30:47','globeadmin','0'),('59a97ae0711178e','find_teacher_cards','Βρίσκει τις διδασκαλίες που έχει ένας καθηγητής μια συγκεκριμένη ημερομηνία','teacher','if(\'#test_date#\'!=\'\' && \'#test_date#\'!=\'#\'.\'test_date#\'){\n\n    $sql=\"SELECT distinct   CONCAT(period.id,\',\',class.id,\',\',subject_id),\n                    CONCAT(\n                        ifNULL(period.name,period.short_name),\n                        \' - \',\n                        class.short_name,\n                        \' - \',\n                        ifNULL(subject.name,subject.short_name),\n                        if(subject_type.short_name IS NULL,\'\',CONCAT(\' (\',subject_type.short_name,\') \')),\n                        if(classroom.name IS NULL,if(classroom.short_name IS NULL,\'\',CONCAT(\' - \',classroom.short_name)),CONCAT(\' - \',classroom.name))\n                        ),\n                    if(classroom.name IS NULL,if(classroom.short_name IS NULL,\'\',classroom.short_name),classroom.name)\n    FROM card\n    INNER JOIN period ON period.id = card.period_id\n    INNER JOIN class on card.class_id = class.id\n    INNER JOIN subject ON subject.id = card.subject_id\n    INNER JOIN school ON school.id = 1\n    INNER JOIN school_year ON school_year.id = school.school_year_id\n    LEFT JOIN subject_type ON subject_type.id = subject.subject_type_id\n    LEFT JOIN classroom ON classroom.id = card.classroom_id\n    WHERE\";\n    if(\'#all_cards#\'!=\'1\'){\n        $sql.=\"\n        card.teacher_id = \'#RECORD_ID#\' AND\";\n    }\n    \n    $sql.=\"    \n        card.valid_from = (select max(start_date) from timetable where start_date <= \'#test_date#\') AND\n        card.day_id = DAYOFWEEK(\'#test_date#\')-2 AND\n        \'#test_date#\' between school_year.start_date AND school_year.end_date AND\n        \'#test_date#\' NOT IN (select holiday.holiday from holiday)\n    ORDER BY period.id,class.short_name,subject.short_name\";\n    \n    $retval = nuRunQuery($sql);\n    $data_array =  array();\n    $nuParameters = \'\';\n\n    if($retval){\n\n        while($row = db_fetch_row($retval)) {\n            $data_array[]= $row;      \n        }\n    \n        $json_string = json_encode($data_array);\n        $nuParameters = $json_string;\n    }\n} else {\n    $nuParameters = \'\';\n}','','0','2017-09-01 18:21:04','globeadmin','2017-09-03 10:07:20','globeadmin','2017-12-20 15:37:16','globeadmin','0'),('59a9a9964302541','program_calendar_test','Προγραμματίζει ένα Διαγώνισμα ή Τεστ στο Ημερολόγιο','Teacher','nuRunPHP(\'notification_add_lib\');\nnuRunPHP(\'send_email_calendar_event\');\n\n$publish_id = nuID();\n\nfunction check_exam_limits($exam_date,$class_id,$exam_day_limit,$exam_week_limit){\n\n    $first_date = new DateTime($exam_date);\n    $last_date = new DateTime($exam_date);\n    \n    $week_number = $first_date->format(\"W\");\n    $year_number = $first_date->format(\"Y\");\n\n    $first_date->setISODate($year_number, $week_number);\n    $last_date->setISODate($year_number, $week_number, 7);\n    \n    $sql = \"SELECT student_id FROM student_class WHERE class_id=\'$class_id\'\";\n    $rv = nuRunQuery($sql);\n    while($r = db_fetch_row($rv)){\n        $sql = \"\n                SELECT count(*)\n                FROM calendar_event\n                WHERE \n                    start_date = \'$exam_date\' AND\n                    is_exam = \'1\' AND\n                    exam_class_id IN (SELECT DISTINCT class_id FROM student_class WHERE student_id=\'\".$r[0].\"\')\"\n            ; \n        $rv1 = nuRunQuery($sql);\n        $r1 = db_fetch_row($rv1);\n        \n        if($r1[0]>=$exam_day_limit){\n            return false;    \n        }\n        \n        $sql = \"\n                SELECT count(*)\n                FROM calendar_event\n                WHERE \n                    start_date BETWEEN \'\".$first_date->format(\"Y-m-d\").\"\' AND \'\".$last_date->format(\"Y-m-d\").\"\' AND\n                    is_exam = \'1\' AND\n                    exam_class_id IN (SELECT DISTINCT class_id FROM student_class WHERE student_id=\'\".$r[0].\"\')\"\n            ;\n        $rv2 = nuRunQuery($sql);\n        $r2 = db_fetch_row($rv2);\n        \n        if($r2[0]>=$exam_week_limit){\n            return false;    \n        }\n    }\n    return true;\n}\n\n$cur_date = date(\"Y-m-d\");\n$nuParameters = \'\';\n\nif(\'#test_date#\'!=\'#\'.\'test_date#\' && \'#test_date#\'!=\'\'){\n    if(\'#test_date#\'>=$cur_date){\n        if(\'#period_class_subject_id#\'!=\'#\'.\'period_class_subject_id#\' && \'#period_class_subject_id#\'!=\'\'){\n            if(\'#is_exam_hash#\'!=\'#\'.\'is_exam_hash#\' && \'#is_exam_hash#\'!=\'\' && \'#is_test_hash#\'!=\'#\'.\'is_test_hash#\' && \'#is_test_hash#\'!=\'\'){\n                if(\'#is_exam_hash#\'!=\'#is_test_hash#\'){\n                    $ids = explode(\",\", \'#period_class_subject_id#\');\n                    if(sizeof($ids) == 3){\n\n                        $location = (\'#location#\'==\'#\'.\'location#\' ? \'\' : \'#location#\');\n                    \n                        $sql=\"\n                                SELECT\n                                        school.exam_day_limit,\n                                        school.exam_week_limit,\n                                        period.start_time,\n                                        period.end_time,\n                                        class.short_name,\n                                        subject.short_name,\n                                        ifNULL(subject.name,\'\')\n                                FROM school \n                                INNER JOIN period   ON period.id = \'\".$ids[0].\"\'\n                                INNER JOIN class    ON class.id = \'\".$ids[1].\"\'\n                                INNER JOIN subject  ON subject.id = \'\".$ids[2].\"\'\n                                WHERE school.id=1\n                        \";\n                        $retval = nuRunQuery($sql);\n                        $row = db_fetch_row($retval);\n\n                        if(\'#is_test_hash#\'==\'1\' || \'#no_check_hash#\'==\'1\' || (\'#is_exam_hash#\'==\'1\' && check_exam_limits(\'#test_date#\',$ids[1],$row[0],$row[1]))){\n\n                            $sql = \"\n                                INSERT INTO calendar_event (\n                                    id,\n                                    title,\n                                    description,\n                                    allDay,\n                                    start_date,\n                                    end_date,\n                                    start_time,\n                                    end_time,\n                                    color,\n                                    backgroundColor,\n                                    borderColor,\n                                    textColor,\n                                    is_exam,\n                                    is_test,\n                                    teacher_id ,\n                                    location,\n                                    exam_class_id,\n                                    exam_subject_id)\n                                VALUES(\n                                    NULL,\n                                    \'\".(\'#is_exam_hash#\'==\'1\' ? \'Διαγώνισμα\' : \'Τεστ\').\" \".$row[4].\' (\'.$row[5].\")\',\n                                    \'\".($row[6]!=\'\' ? (\'#is_exam_hash#\'==\'1\' ? \'Διαγώνισμα\' : \'Τεστ\').\" στο τμήμα \".$row[4].\" και στο μάθημα «\".$row[6] : \'\').\"»\',\n                                    \'0\',\n                                    \'#test_date#\',\n                                    \'#test_date#\',\n                                    \'\".$row[2].\"\',\n                                    \'\".$row[3].\"\',\n                                    \'\".((\'#is_exam_hash#\'==\'1\' ? \'red\' : \'#FFD700\')).\"\',\n                                    NULL,\n                                    NULL,\n                                    NULL,\n                                    \'#is_exam_hash#\',\n                                    \'#is_test_hash#\',\n                                    \'#RECORD_ID#\',\n                                    \'$location\',\n                                    \'\".$ids[1].\"\',\n                                    \'\".$ids[2].\"\'\n                                )\";\n                            \n                            $t = nuRunQuery($sql,NULL,true);\n                            \n                            \n                            \n                            // Κοινοποιση στους διδάσκοντες\n                            \n                            $sql = \"INSERT INTO calendar_event_access (\n                                                id,\n                                                calendar_event_id,\n                                                teacher_id,\n                                                student_id,\n                                                grade_id,\n                                                class_id,\n                                                user_group_id,\n                                                publish_id\n                                                )\n                                            SELECT\n                                                NULL,\n                                                \'$t\',\n                                                teacher.id,\n                                                NULL,\n                                                NULL,\n                                                NULL,\n                                                NULL,\n                                                \'$publish_id\'\n                                            FROM teacher WHERE id IN(\n                                                            SELECT DISTINCT teacher_id \n                                                            FROM card \n                                                            WHERE\n                                                                card.valid_from = (select max(start_date) from timetable where start_date <= \'#test_date#\') AND\n                                                                card.class_id = \'\".$ids[1].\"\' AND\n                                                                card.subject_id = \'\".$ids[2].\"\' AND\n                                                                card.teacher_id <> \'#RECORD_ID#\')\n                                    \";\n                            \n                            $cea = nuRunQuery($sql,NULL,true);\n                            // Αποστολή Email στους καθηγητές\n                            if($cea!=\'-1\'){\n                                $sql =\"SELECT id FROM calendar_event_access WHERE publish_id=\'$publish_id\' AND (user_group_id IS NULL OR user_group_id NOT IN (\'547de4c65675a29\',\'5717ba3eb32c252\',\'999999999999999\'))\";\n                                $rv3 = nuRunQuery($sql);\n                                while($r3 = db_fetch_row($rv3)){\n                                    calendar_event_email($r3[0],7);\n                                }\n                            }\n                            \n                            // Κοινοποίηση στους Μαθητές - Γονείς\n                            if(\'#publish_students_check_hash#\'==\'1\'){\n                                $sql = \"INSERT INTO calendar_event_access (\n                                            id,\n                                            calendar_event_id,\n                                            teacher_id,\n                                            student_id,\n                                            grade_id,\n                                            class_id,\n                                            user_group_id,\n                                            publish_id) \n                                        VALUES(\n                                            NULL,\n                                            \'$t\',\n                                            NULL,\n                                            NULL,\n                                            NULL,\n                                            \'\".$ids[1].\"\',\n                                            \'547de4c65675a29\',\n                                            \'$publish_id\'\n                                        )\n                                \";\n            \n                                $cea = nuRunQuery($sql,NULL,true);\n                                calendar_event_notification($cea,7);\n                                \n                            }\n                            if(\'#publish_parents_check_hash#\'==\'1\'){\n                                $sql = \"INSERT INTO calendar_event_access (\n                                        id,\n                                        calendar_event_id,\n                                        teacher_id,\n                                        student_id,\n                                        grade_id,\n                                        class_id,\n                                        user_group_id,\n                                        publish_id\n                                        )\n                                    VALUES(\n                                        NULL,\n                                        \'$t\',\n                                        NULL,\n                                        NULL,\n                                        NULL,\n                                        \'\".$ids[1].\"\',\n                                        \'5717ba3eb32c252\',\n                                        \'$publish_id\'\n                                        )\n                                \";\n                                $cea = nuRunQuery($sql,NULL,true);\n                                calendar_event_notification($cea,7);\n                            }\n\n                            $data_array =  array(\n                                    $t,\n                                    (\'#is_exam_hash#\'==\'1\' ? \'Διαγώνισμα\' : \'Τεστ\').\" \".$row[4].\' (\'.$row[5].\")\",\n                                    \'0\',\n                                    \'#test_date#T\'.$row[2],\n                                    \'#test_date#T\'.$row[3],\n                                    (\'#is_exam_hash#\'==\'1\' ? \'red\' : \'#FFD700\'),\n                                    \'#is_exam_hash#\',\n                                    \'#is_test_hash#\',\n                                    ($row[6]!=\'\' ? (\'#is_exam_hash#\'==\'1\' ? \'Διαγώνισμα\' : \'Τεστ\').\" στο τμήμα \".$row[4].\" και στο μάθημα «\".$row[6] : \'\').\"»\",\n                                    $location\n                                    );\n                            $json_string = json_encode($data_array);\n                            $nuParameters = $json_string;    \n                        } else {\n                            $nuError = \"Προσοχή:Στο τμήμα αυτό υπάρχουν μαθητές που θα υπερβούν του επιτρεπόμενο ημερήσιο ή εβδομαδιαίο όριο διαγωνισμάτων!\\nΑν πάραυτα επιθυμητέ να προγραμματίσετε το διαγώνισμα σας, επικοινωνήστε με τη Διεύθυνση του Σχολείου!!\";    \n                        }\n                    } else {\n                        $nuError = \"Προσοχή: Παρουσιάστηκε πρόβλημα με την εύρεση της διδασκαλίας!\";    \n                    }\n                }else {\n                    $nuError = \"Προσοχή: Δεν ορίστηκε σωστά εάν πρόκειται για διαγώνισμα ή τεστ!\";    \n                }\n            } else {\n                $nuError = \"Προσοχή: Δεν ορίστηκε εάν πρόκειται για διαγώνισμα ή τεστ!\";    \n            }\n        } else{\n            $nuError = \"Προσοχή: Δεν ορίστηκε η διδασκαλία στην οποία θα γίνει η εξέταση!\";    \n        }\n    } else {\n        $nuError = \"Προσοχή: η ημερομηνία της εξέτασης δεν μπορεί να έχει παρέλθει!\";    \n    }\n} else {\n    $nuError = \"Προσοχή: Δεν ορίστηκε η ημερομηνία της εξέτασης!\";    \n}','','0','2017-09-01 21:40:22','globeadmin','2017-11-05 13:05:10','globeadmin','2020-09-18 21:35:39','globeadmin','0'),('59ac0890dc7beb0','create_student_calendar','Δημιουργεί το Ημερολόγιο Σχολείου ενός Μαθητή ή Γονέα','Student','function search_event($ea, $event_id){\n    foreach ($ea as $event) {\n        if($event[0]==$event_id){\n                return true;\n        }\n    }\n    return false;\n}\n\n$datetime = new DateTime(\'now\');\n$datetime_string = $datetime->format(\'c\');\n$sql = \"    SELECT school_year.start_date,school_year.end_date\n            FROM school\n            INNER JOIN school_year ON school.school_year_id = school_year.id\n            WHERE school.id=1\";\n$retval = nuRunQuery($sql);\n\n$row = db_fetch_row($retval);\n\n$start_year = date(\'Y\', strtotime($row[0]));\n$end_year = date(\'Y\', strtotime($row[1]));\n\n$start_date = $start_year.\"-09-01\";\n$end_date = $end_year.\"-07-01\";\n\n$datetime_current = $datetime->format(\'Y-m-d\');\n$datetime_current = ($datetime_current>$end_date ? $end_date : ($datetime_current<$start_date ? $start_date : $datetime_current));\n\n$sql = \" SELECT distinct holiday,description FROM holiday ORDER BY holiday\";\n$rv = nuRunQuery($sql);\n\n$holiday_array = array();\n\nwhile ($r = db_fetch_row($rv)){\n    $holiday_array[]= array($r[0],$r[1]);    \n}\n\n//--------------------------------------------Εύρσεση συμβάντων του συγκεκριμένου μαθητή--------------------------------------------\n\n$event_array = array();\n\n//--------------------------------------------- Όσά αναφέρονται στο group του μαθητή (Μαθητής/Γονέας)-----------------------------------------------\n$sql = \"    SELECT \n                calendar_event.id,\n                calendar_event.title,\n                ifNULL(calendar_event.description,\'\'),\n                calendar_event.allDay,\n                calendar_event.start_date,\n                calendar_event.end_date,\n                calendar_event.start_time, \n                calendar_event.end_time,\n                ifNULL(calendar_event.color,\'\'),\n                ifNULL(calendar_event.backgroundColor,\'\'),\n                ifNULL(calendar_event.borderColor,\'\'),\n                ifNULL(calendar_event.textColor,\'\'),\n                calendar_event.is_exam,\n                calendar_event.is_test,\n                ifNULL(calendar_event.location,\'\'),\n                is_appointment,\n                was_held\n            FROM calendar_event\n            INNER JOIN calendar_event_access ON calendar_event.id = calendar_event_access.calendar_event_id\n            WHERE \n                calendar_event_access.teacher_id is NULL AND\n                calendar_event_access.student_id is NULL AND\n                calendar_event_access.grade_id is NULL AND\n                calendar_event_access.class_id is NULL AND\n                calendar_event_access.user_group_id IN (SELECT zzzsys_user_group_id FROM zzzsys_user_group WHERE sug_code=\'#nu_user_group#\')\n        \";\n$rv1 = nuRunQuery($sql);\n\nwhile ($r1 = db_fetch_row($rv1)){\n    if(!search_event($event_array,$r1[0])){\n        $event_array[]= $r1;    \n    }\n        \n}\n\n\n//-------------------------------------------- Όσά αναφέρονται σε όλη την τάξη του μαθητή ------------------------------------------------\n$sql = \"    SELECT \n                calendar_event.id,\n                calendar_event.title,\n                ifNULL(calendar_event.description,\'\'),\n                calendar_event.allDay,\n                calendar_event.start_date,\n                calendar_event.end_date,\n                calendar_event.start_time, \n                calendar_event.end_time,\n                ifNULL(calendar_event.color,\'\'),\n                ifNULL(calendar_event.backgroundColor,\'\'),\n                ifNULL(calendar_event.borderColor,\'\'),\n                ifNULL(calendar_event.textColor,\'\'),\n                calendar_event.is_exam,\n                calendar_event.is_test,\n                ifNULL(calendar_event.location,\'\'),\n                is_appointment,\n                was_held\n            FROM calendar_event\n            INNER JOIN calendar_event_access ON calendar_event.id = calendar_event_access.calendar_event_id\n            WHERE \n                calendar_event_access.grade_id=\'#grade_id#\' AND\n                calendar_event_access.user_group_id IN (SELECT zzzsys_user_group_id FROM zzzsys_user_group WHERE sug_code=\'#nu_user_group#\')\n                    \n        \";\n$rv1 = nuRunQuery($sql);\n\nwhile ($r1 = db_fetch_row($rv1)){\n    if(!search_event($event_array,$r1[0])){\n        $event_array[]= $r1;    \n    }\n        \n}\n//-------------------------------------------- Όσά αναφέρονται σε όλους τους μαθητές των τμημάτων που ανήκει ο μαθητής ------------------------------------------------\n$sql = \"    SELECT \n                calendar_event.id,\n                calendar_event.title,\n                ifNULL(calendar_event.description,\'\'),\n                calendar_event.allDay,\n                calendar_event.start_date,\n                calendar_event.end_date,\n                calendar_event.start_time, \n                calendar_event.end_time,\n                ifNULL(calendar_event.color,\'\'),\n                ifNULL(calendar_event.backgroundColor,\'\'),\n                ifNULL(calendar_event.borderColor,\'\'),\n                ifNULL(calendar_event.textColor,\'\'),\n                calendar_event.is_exam,\n                calendar_event.is_test,\n                ifNULL(calendar_event.location,\'\'),\n                is_appointment,\n                was_held\n            FROM calendar_event\n            INNER JOIN calendar_event_access ON calendar_event.id = calendar_event_access.calendar_event_id\n            WHERE \n                calendar_event_access.class_id IN (SELECT DISTINCT class_id FROM student_class WHERE student_id=\'#RECORD_ID#\') AND\n                calendar_event_access.user_group_id IN (SELECT zzzsys_user_group_id FROM zzzsys_user_group WHERE sug_code=\'#nu_user_group#\')\n                    \n        \";\n$rv1 = nuRunQuery($sql);\n\nwhile ($r1 = db_fetch_row($rv1)){\n    if(!search_event($event_array,$r1[0])){\n        $event_array[]= $r1;    \n    }\n        \n}\n\n//--------------------------------------------- Όσά αναφέρονται στο συγκεκριμένο μαθητή -----------------------------------------------\n$sql = \"    SELECT \n                calendar_event.id,\n                calendar_event.title,\n                ifNULL(calendar_event.description,\'\'),\n                calendar_event.allDay,\n                calendar_event.start_date,\n                calendar_event.end_date,\n                calendar_event.start_time, \n                calendar_event.end_time,\n                ifNULL(calendar_event.color,\'\'),\n                ifNULL(calendar_event.backgroundColor,\'\'),\n                ifNULL(calendar_event.borderColor,\'\'),\n                ifNULL(calendar_event.textColor,\'\'),\n                calendar_event.is_exam,\n                calendar_event.is_test,\n                ifNULL(calendar_event.location,\'\'),\n                is_appointment,\n                was_held\n            FROM calendar_event\n            INNER JOIN calendar_event_access ON calendar_event.id = calendar_event_access.calendar_event_id\n            LEFT JOIN ballot ON ballot.calendar_event_id = calendar_event.id\n            WHERE \n                calendar_event_access.student_id=\'#RECORD_ID#\'AND\n                calendar_event_access.user_group_id IN (SELECT zzzsys_user_group_id FROM zzzsys_user_group WHERE sug_code=\'#nu_user_group#\') AND\n                (ballot.id IS NULL OR ballot.is_active=1)\n                    \n        \";\n$rv1 = nuRunQuery($sql);\n\nwhile ($r1 = db_fetch_row($rv1)){\n    if(!search_event($event_array,$r1[0])){\n        $event_array[]= $r1;    \n    }\n        \n}\n//------------------------------------------------------------------------------------------------------------------------------------\n\nprint\"\n<!DOCTYPE html>\n<html>\n<head>\n    <meta charset=\'utf-8\' />\n    <link href=\'calendar/fullcalendar.min.css\' rel=\'stylesheet\' />\n    <link href=\'calendar/fullcalendar.print.min.css\' rel=\'stylesheet\' media=\'print\' />\n    \n    <script src=\'calendar/lib/moment.min.js\'></script>\n    <script src=\'calendar/lib/jquery.min.js\'></script>\n    <script src=\'calendar/fullcalendar.min.js\'></script>\n    <script src=\'calendar/locale/el.js\'></script>\n    <script>\n        var holiday_array = [];\n\";\n    \nforeach ($holiday_array as $holiday) {\n    print \"     holiday_array.push([\\\"\".$holiday[0].\"\\\", \\\"\".$holiday[1].\"\\\"]);\n\";\n} \n\nprint\"    \n	$(document).ready(function() {\n		$(\'#calendar\').fullCalendar({\n			defaultDate: \'$datetime_current\',\n			editable: false,\n			aspectRatio: 2,\n			fixedWeekCount: false,\n			eventLimit: true,\n			minTime: \'07:00:00\',\n			maxTime: \'22:00:00\',\n			nowIndicator: true,\n		    visibleRange: \n		        {\n                start: \'\".$start_date.\"\',\n                end: \'\".$end_date.\"\'\n                },\n            validRange: \n		        {\n                start: \'\".$start_date.\"\',\n                end: \'\".$end_date.\"\'\n                },\n			now: \".json_encode($datetime_string).\",\n			header: \n			    {\n		            left:   \'prev,next today\',\n                    center: \'title\',\n                    right:  \'month,agendaWeek,agendaDay,listMonth\'\n			    },\n\n            dayRender: function (date, cell) \n                {\n                    var d=date.format(\'YYYY-MM-DD\');\n                    for (var i = 0; i < holiday_array.length; i++) {\n                        if (d==holiday_array[i][0]) {\n                            cell.css(\\\"background-color\\\", \\\"#ffdb99\\\");\n                            break;\n                        }\n                    }\n                },\n                \n            dayClick: function(date, jsEvent, view) {\n                if(view.name == \'month\' || view.name == \'agendaWeek\') {\n                    //$(\'#calendar\').fullCalendar(\'changeView\', \'agendaDay\');\n                    $(\'#calendar\').fullCalendar(\'gotoDate\', date);      \n                }\n            },\n\n            eventClick: function(calEvent, jsEvent, view) {\n            \n                if(calEvent.id>0 && calEvent.is_appointment==1){\n                    if(\n                        ((moment().add(15, \'minutes\').format(\'YYYY-MM-DD HH:mm:ss\')) >= (moment(calEvent.start).format(\'YYYY-MM-DD HH:mm:ss\'))) &&\n                        ((moment().format(\'YYYY-MM-DD HH:mm:ss\')) <= (moment(calEvent.end).format(\'YYYY-MM-DD HH:mm:ss\'))) &&\n                        isValidHttpUrl(calEvent.location)\n                        ){                    \n                        window.open(calEvent.location);     \n                    } else if((moment().format(\'YYYY-MM-DD\')+\'23:59:59\') < moment(calEvent.start).format(\'YYYY-MM-DD HH:mm:ss\')){\n                        if(confirm(\'Θέλετε να ακυρώσετε το ραντεβού;\')){\n                            parent.nuSetHash(\'calendar_event_id\', calEvent.id);\n                            parent.nuAjax(\'delete_appointment\',\'delete_appointment_result\')                        \n                        }    \n                    } \n                } else {\n                \n                    if (!($(\'#eventContent\').is(\':visible\'))){\n		            \n		                var position = $(this).offset();\n		                var overlap = false;\n		            \n		                var new_top = position.top;\n		                var new_left = position.left-410;\n		            \n		                if (new_left < 10){\n                            new_left = position.left+$(this).width()+10;\n		                }\n		            \n		                if (new_left > $(document).width()-410){\n                            new_left = $(document).width()-445;\n                            overlap = true;\n                            new_top += $(this).height()+5;\n		                }\n\n		                if (($(document).height()-position.top) < 250){\n                            if(overlap){\n                                new_top = position.top-250;    \n                            } else {\n                                new_top = position.top+$(this).height()-245;    \n                            }\n		                }\n			    \n		                $(\'#eventContent\').css({ top: new_top+\'px\' });\n		                $(\'#eventContent\').css({ left: new_left+\'px\' });\n		            \n		                $(\'#eventTitle\').html(calEvent.title);\n		                $(\'#eventTitle\').css({ color: calEvent.color });\n		            \n		                $(\'#startTime\').html(moment(calEvent.start).format(\'MMM Do h:mm A\'));\n		                if(moment(calEvent.end).format(\'MMM Do h:mm A\')==\'Invalid date\'){\n		                    $(\'#endTime\').html(\'\');    \n		                } else {\n		                    $(\'#endTime\').html(moment(calEvent.end).format(\'MMM Do h:mm A\'));    \n		                }\n                        $(\'#allDay\').html(calEvent.allDay ? \'Ναί\' : \'Όχι\');\n                        $(\'#eventDescription\').html(calEvent.description);\n                        $(\'#eventLocation\').html(calEvent.location);\n\n		                $(\'#eventContent\').show();\n		        \n		                $(this).bind(\'wheel\', function(e){\n                            var scrollTo = $(\'#eventContent\').scrollTop() - (e.originalEvent.deltaY*-1);\n                            $(\'#eventContent\').scrollTop(scrollTo);\n                        });\n                    } else {\n                        $(\'#eventContent\').hide();    \n                    }\n                }\n            },\n            eventMouseover: function(calEvent, jsEvent, view) {\n            \n                if(calEvent.id>0 && calEvent.is_appointment==1){\n                \n                    if(\n                        ((moment().add(15, \'minutes\').format(\'YYYY-MM-DD HH:mm:ss\')) >= (moment(calEvent.start).format(\'YYYY-MM-DD HH:mm:ss\'))) &&\n                        ((moment().format(\'YYYY-MM-DD HH:mm:ss\')) <= (moment(calEvent.end).format(\'YYYY-MM-DD HH:mm:ss\'))) &&\n                        isValidHttpUrl(calEvent.location)\n                        ){                    \n                        this.style.cursor=\\\"pointer\\\";    \n                    } else if((moment().format(\'YYYY-MM-DD\')+\' 23:59:59\') < moment(calEvent.start).format(\'YYYY-MM-DD HH:mm:ss\')){\n                        this.style.cursor=\\\"url(\'images/x.png\'), pointer\\\";    \n                    } else {\n                        this.style.cursor=\\\"auto\\\";    \n                    }\n                } else{\n                    this.style.cursor=\\\"auto\\\";    \n                }\n                \n                if (!($(\'#eventContent\').is(\':visible\'))){\n		            \n		            var position = $(this).offset()\n		            var overlap = false;\n		            \n		            var new_top = position.top;\n		            var new_left = position.left-410;\n		            \n		            if (new_left < 10){\n                        new_left = position.left+$(this).width()+10;\n		            }\n		            \n		            if (new_left > $(document).width()-410){\n                        new_left = $(document).width()-445;\n                        overlap = true;\n                        new_top += $(this).height()+5;\n		            }\n\n		            if (($(document).height()-position.top) < 250){\n                        if(overlap){\n                            new_top = position.top-250;    \n                        } else {\n                            new_top = position.top+$(this).height()-245;    \n                        }\n		            }\n			    \n		            $(\'#eventContent\').css({ top: new_top+\'px\' });\n		            $(\'#eventContent\').css({ left: new_left+\'px\' });\n		            \n		            $(\'#eventTitle\').html(calEvent.title);\n		            $(\'#eventTitle\').css({ color: calEvent.color });\n		            \n		            $(\'#startTime\').html(moment(calEvent.start).format(\'MMM Do h:mm A\'));\n		            if(moment(calEvent.end).format(\'MMM Do h:mm A\')==\'Invalid date\'){\n		                $(\'#endTime\').html(\'\');    \n		            } else {\n		                $(\'#endTime\').html(moment(calEvent.end).format(\'MMM Do h:mm A\'));    \n		            }\n                    $(\'#allDay\').html(calEvent.allDay ? \'Ναί\' : \'Όχι\');\n                    $(\'#eventDescription\').html(calEvent.description);\n                    $(\'#eventLocation\').html(calEvent.location);\n\n		            $(\'#eventContent\').show();\n		        \n		        }\n		        \n		        $(this).bind(\'wheel\', function(e){\n                    var scrollTo = $(\'#eventContent\').scrollTop() - (e.originalEvent.deltaY*-1);\n                    $(\'#eventContent\').scrollTop(scrollTo);\n                });\n            },\n            eventMouseout: function(calEvent, jsEvent, view) {\n                $(\'#eventContent\').hide();\n                this.style.cursor=\\\"auto\\\";\n            },           \n            \n            eventSources: [\n\n                {\n                    events: [\";\n                    \n$last_holiday = end(array_keys($holiday_array));\nforeach ($holiday_array as $holiday) {\n    print\"\n                        {\n					        title: \'\".$holiday[1].\"\',\n					        start: \'\".$holiday[0].\"\',\n					        color: \'green\',\n					        allDay: true,\n					        description: \'Αργία\',\n					        location: \'\'\n				        },\n				        {\n                            start: \'\".$holiday[0].\"T00:00:00\',\n                            end: \'\".$holiday[0].\"T23:59:59\',\n                            rendering: \'background\'\n                        }\".($holiday[0]!=$last_holiday[0] ? \',\' : \'\');\n}                     \n\nprint\"\n                    ]\n                },\n                \n                {\n                    events: [\";\n                    \n$last_event = end(array_keys($event_array));\nforeach ($event_array as $event) {\n    $c = ($event[8]!=\'\' ? $event[8] : \'#3a87ad\');\n    $c = ($event[15]==1 ? ($event[16]==1 ? \'#5daa6a\' : ($event[16]===\'0\' ? \'#97799e\' : $c))  : $c );\n    print\"\n                        {\n                            id: \'\".$event[0].\"\',\n                            title: \".json_encode($event[1],JSON_HEX_APOS).\",\n                            allDay: \".($event[3]==\'1\' ? \'true\' : \'false\').\",\n                            start: \'\".$event[4].($event[3]==\'0\' ? \'T\'.$event[6] : \'\'  ).\"\',\n                            end: \'\".$event[5].($event[3]==\'0\' ? \'T\'.$event[7] : \'\'  ).\"\',\n                            color: \'$c\',\n                            \".($event[9]!=\'\' ? \"backgroundColor: \'\".$event[9].\"\',\n                            \" : \'\').($event[10]!=\'\' ? \"borderColor: \'\".$event[10].\"\',\n                            \" : \'\').($event[11]!=\'\' ? \"textColor: \'\".$event[11].\"\',\n                            \" : \'\').\n                            \"description: \'\".json_encode(preg_replace(\"/\\r\\n|\\r|\\n/\",\'<br/>\',$event[2]),JSON_HEX_APOS).\"\',\n                            is_exam: \'\".$event[12].\"\',\n					        is_test: \'\".$event[13].\"\',\n					        location: \'\".$event[14].\"\',\n					        is_appointment: \'\".$event[15].\"\',\n					        was_held: \'\".$event[16].\"\'\n				        }\".($event!=$last_event ? \',\' :\'\');\n}                     \n\nprint\"\n                    ]\n                }\n            ]\n        });\n	});\n	\nfunction add_event(id,title,allDay,start,end,color,is_exam,is_test,description,location,is_appointment=0,was_held=0){\n        var new_event = \n                        {\n                            id: id,\n                            title: title,\n                            allDay: (allDay==\'1\' ? true : false),\n                            start: start,\n                            end: end,\n                            color: color,\n                            description: description,\n                            is_exam: is_exam,\n					        is_test: is_test,\n					        location: location,\n					        is_appointment: is_appointment,\n					        was_held: was_held\n				        };\n		$(\'#calendar\').fullCalendar(\'gotoDate\', start);\n        $(\\\"#calendar\\\").fullCalendar( \'renderEvent\', new_event);\n}\n\nfunction remove_event(id){\n    $(\\\"#calendar\\\").fullCalendar(\'removeEvents\', id);\n}\n\n\nfunction isValidHttpUrl(string) {\n    let url;\n\n    try {\n        url = new URL(string);\n    } catch (_) {\n        return false;  \n    }\n    return url.protocol === \\\"http:\\\" || url.protocol === \\\"https:\\\";\n}\n\n</script>\n<style>\n	body {\n		margin: 0px 10px;\n		padding: 0;\n		font-family: \\\"Lucida Grande\\\",Helvetica,Arial,Verdana,sans-serif;\n		font-size: 14px;\n	}\n	\n	.eventContents{\n			    display: none;\n			    position: absolute;\n			    z-index: 5000;\n			    padding-top: 1px;\n                padding-right: 20px;\n                padding-left: 20px;\n			    overflow-x:none;\n			    padding-bottom: 0 !important;\n			    width: 360px;\n			    height: 240px;\n			    border-radius: 15px;\n			    border: 1px solid #C8C8C8;\n			    background-color:#fff;\n			    box-shadow: 0 4px 3px #8C8C8C;\n			    overflow-y: auto;\n	}\n\n	#calendar {\n		max-width: 1050px;\n		margin: 0 auto;\n	}\n	\n	.fc-mon { background-color:#ffffe6; }\n	.fc-tue { background-color:#ffffe6; }\n	.fc-wed { background-color:#ffffe6; }\n	.fc-thu { background-color:#ffffe6; }\n	.fc-fri { background-color:#ffffe6; }\n	.fc-sat { background-color:#ffdb99; }\n    .fc-sun { background-color:#ffdb99; }\n    .fc-today { background-color:#ffff80 !important; color:#ff0000 !important;}\n    .fc-bgevent { background-color:#ffa600 !important; }\n\n</style>\n</head>\n<body>\n    <div id=\\\"eventContent\\\" class=\\\"eventContents\\\" title=\\\"Λεπτομέρειες Συμβάντος\\\" onclick=\\\"$(this).hide();\\\">\n        \n        <p><font size=+1><b><span id=\\\"eventTitle\\\"></span></b></font></p>\n        \n        <table border=0>\n            <tr>\n                <td width=70><b>Έναρξη</b></td>\n                <td> : </td>\n                <td><span id=\\\"startTime\\\"></span></td>\n            </tr>\n            <tr>\n                <td width=70><b>Λήξη</b></td>\n                <td> : </td>\n                <td><span id=\\\"endTime\\\"></span></td>           \n            </tr>\n            <tr>\n                <td width=70><b>Ολοήμερο</b></td>\n                <td> : </td>\n                <td><span id=\\\"allDay\\\"></span></td>\n            </tr>\n            <tr>\n                <td width=70><b>Τοποθεσία</b></td>\n                <td> : </td>\n                <td><span id=\\\"eventLocation\\\"></span></td>\n            </tr>\n            <tr>\n                <td width=70><b>Περιγραφή</b></td>\n                <td> : </td>\n                <td></td>\n            </tr>\n            <tr>\n                <td colspan=3><span id=\\\"eventDescription\\\" style=\\\"font-size: 12px;\\\"></span></td>\n            </tr>\n        </table>\n    </div>\n	<div id=\'calendar\'></div>\n</body>\n</html>\";','','0','2017-09-03 16:50:08','globeadmin','2022-01-10 21:39:18','globeadmin','2022-01-10 21:39:18','globeadmin','0'),('59b447a587c9f81','send_email_calendar_event','Στέλνει email ενημέρωσης σε καθηγητές που τους κοινοποιήθηκε ένα συμβάν ημερολογίου','Teachers','//require_once(\"phpmailer/class.phpmailer.php\");\nuse PHPMailer\\PHPMailer\\PHPMailer;\nuse PHPMailer\\PHPMailer\\Exception;\n\nrequire \'PHPMailer/src/Exception.php\';\nrequire \'PHPMailer/src/PHPMailer.php\';\nrequire \'PHPMailer/src/SMTP.php\';\n\nnuRunPHP(\"sisyphos_lib\");\n\nfunction my_esc($str){\n    $db_params = nuRunQuery();\n    $link = mysqli_connect($db_params[0], $db_params[2], $db_params[3], $db_params[1]);\n\n    if (mysqli_connect_errno()) {\n        nuDebug(\"Connect failed: %s\\n\", mysqli_connect_error());\n        return \'\';\n    }\n    return(mysqli_real_escape_string($link,$str));\n}\n\nfunction find_address($email_to_send,$emails){\n    foreach ($emails as $email) {\n        if($email[0]==$email_to_send){\n                return true;\n        }\n    }\n    return false;\n}\n\nfunction calendar_event_email(          $calendar_event_access_id,\n                                        $event_type=7,\n                                        $new_title=\'\',\n                                        $new_location=\'\',\n                                        $new_start_date=\'\',\n                                        $new_start_time=\'\',\n                                        $new_end_date=\'\',\n                                        $new_end_time=\'\',\n                                        $new_allDay=\'\',\n                                        $new_description=\'\'){\n    $setup                      = $GLOBALS[\'nuSetup\'];                                      //-- Read SMTP AUTH Settings from zzsys_setup table	\n    if (!empty($setup->set_smtp_username))          { $setup->set_smtp_username = trim($setup->set_smtp_username);}                       else{$errorText .= \"SMTP Username not set.<br>\";}\n    if (!empty($setup->set_smtp_password)) 	        { $setup->set_smtp_password = trim($setup->set_smtp_password);}                       else{$errorText .= \"SMTP Password not set.<br>\";}\n    if (!empty($setup->set_smtp_host))              { $setup->set_smtp_host = trim($setup->set_smtp_host);}                               else{$errorText .= \"SMTP Host not set.<br>\";}\n    if (!empty($setup->set_smtp_from_address))      { $setup->set_smtp_from_address = trim($setup->set_smtp_from_address);}               else{$errorText .= \"SMTP From Address not set.<br>\";}\n    if (!empty($setup->set_smtp_port))              { $setup->set_smtp_port = intval($setup->set_smtp_port);}                             else{$errorText .= \"SMTP PORT not set.<br>\";}\n    if (!empty($setup->set_smtp_use_ssl))           { $setup->set_smtp_use_ssl = trim($setup->set_smtp_use_ssl);}                         else{$setup->set_smtp_use_ssl = \'\';}\n    if (!empty($setup->set_smtp_from_name))         { $SMTPname = trim($setup->set_smtp_from_name);}	                                  else{$SMTPname = \"Sisyphos\";}\n\n    if ($errorText == \'\'){\n\n        $sql = \"\n            SELECT \n                calendar_event_access.id,\n                ifNULL(calendar_event_access.teacher_id,\'-1\'),\n                ifNULL(calendar_event_access.user_group_id,\'\'),\n                \n                calendar_event.id,\n                calendar_event.title,\n                calendar_event.description,\n                calendar_event.location,\n                CONCAT(DATE_FORMAT(calendar_event.start_date,\'%d-%m-%Y\'),\' \' ,calendar_event.start_time),\n                CONCAT(DATE_FORMAT(calendar_event.end_date,\'%d-%m-%Y\'),\' \' ,calendar_event.end_time),\n                IF(calendar_event.allDay=\'1\',\'ΝΑΙ\',\'ΌΧΙ\'),\n                \n                concat(ifNULL(t1.surname,\'\'),if(t1.surname is NULL OR t1.name is NULL,\'\',\' \'),ifNULL(t1.name,\'\')),\n                concat(ifNULL(t2.surname,\'\'),if(t2.surname is NULL OR t2.name is NULL,\'\',\' \'),ifNULL(t2.name,\'\')),\n                t2.id,\n                if(calendar_event.color is NULL OR calendar_event.color=\'\',\'#3a87ad\',calendar_event.color),\n                if(t1.id<>t2.id,\'1\',\'0\'),\n                t1.id\n            FROM calendar_event_access\n            INNER JOIN session_variables    ON  session_variables.session_id = \'#session_id#\'\n            INNER JOIN calendar_event       ON  calendar_event.id       = calendar_event_access.calendar_event_id\n            INNER JOIN teacher as t1        ON  t1.id                   = calendar_event.teacher_id\n            INNER JOIN teacher as t2        ON  t2.id                   = session_variables.teacher_id\n            WHERE \n                calendar_event_access.id = \'$calendar_event_access_id\' AND\n                (calendar_event_access.user_group_id is NULL OR  calendar_event_access.user_group_id NOT IN (\'547de4c65675a29\',\'5717ba3eb32c252\',\'999999999999999\'))\";\n    \n        $retval     = nuRunQuery($sql);\n        \n        $ns=\'\';\n        $ne=\'\';\n        \n        if($retval && db_num_rows($retval)==1){\n            $row        = db_fetch_row($retval);\n            $email_content    = \"\n<div style=\\\"margin: 10px 10px; font-family:Sans-serif; font-size: 16px; color: #525c66;\\\">\n\";\n            if($event_type==7){            \n                $email_subject    = \'Σίσυφος - Κοινοποίηση Συμβάντος Ημερολογίου\';        \n                $email_content    .=\"<p>Σας ενημερώνουμε ότι ο Καθηγητής \".$row[11].\" σας κοινοποίησε ένα συμβάν από το Ημερολόγιο του Σχολείου με τα παρακάτω στοιχεία :</p>\";\n            } else if($event_type==8){            \n                $email_subject    = \'Σίσυφος - Τροποποίηση Συμβάντος Ημερολογίου\';        \n                $email_content    .=\"<p>Σας ενημερώνουμε ότι ο Καθηγητής \".$row[11].\" τροποποίησε στο Ημερολόγιο του Σχολείου το συμβάν με τα παρακάτω στοιχεία :</p>\";\n                \n                $ns = date(\'d-m-Y\', strtotime($new_start_date));\n                $ns .= \' \'.$new_start_time;\n            \n                $ne = date(\'d-m-Y\', strtotime($new_end_date));\n                $ne .= \' \'.$new_end_time;\n            } else if($event_type==9){            \n                $email_subject    = \'Σίσυφος - Διαγραφή Συμβάντος Ημερολογίου\';        \n                $email_content    .=\"<p>Σας ενημερώνουμε ότι ο Καθηγητής \".$row[11].\" <b><u>διέγραψε</u></b> από το Ημερολόγιο του Σχολείου το συμβάν με τα παρακάτω στοιχεία :</p>\";\n            }  else if($event_type==10){            \n                $email_subject    = \'Σίσυφος - Διαγραφή Συμμετεχόντων Συμβάντος Ημερολογίου\';        \n                $email_content    .=\"<p>Σας ενημερώνουμε ότι ο Καθηγητής \".$row[11].\" <b><u>αφαίρεσε συμμετέχοντες</u></b> από το συμβάν, του Ημερολογίου Σχολείου, με τα παρακάτω στοιχεία :</p>\";\n            }\n            \n$email_content    .=\"\n    <div title=\\\"Λεπτομέρειες Συμβάντος\\\" style=\\\"padding-top: 10px; padding-right: 20px; padding-left: 20px; padding-bottom: 20px; margin-top: 20px; margin-right: 20px; margin-bottom: 20px; margin-left: 50px; width: 500px; border-radius: 15px; border: 2px solid \".$row[13].\"; background-color:#fff; font-family: \\\"Sans-serif\\\"; font-size: 16px;\\\">\n        <p><font size=+2 color=\\\"\".$row[13].\"\\\"><b>\".$row[4].($new_title != \'\' && $new_title != $row[4] ? \" &#x25B6; \".$new_title : \'\').\"</b></font></p>\n        <table border=0 style=\\\"font-family:Sans-serif; color: #525c66; font-size: \".($event_type==8 ? \"14\" : \"16\").\"px;\\\">\n            <tr>\n                <td width=70><b>Έναρξη</b></td>\n                <td> : </td>\n                <td>\".$row[7].($ns != \'\' && $ns != $row[7] ? \" &#x25B6; \".$ns : \'\').\"</td>\n            </tr>\n            <tr>\n                <td width=70><b>Λήξη</b></td>\n                <td> : </td>\n                <td>\".$row[8].($ne != \'\' && $ne != $row[8] ? \" &#x25B6; \".$ne : \'\').\"</td>           \n            </tr>\n            <tr>\n                <td width=70><b>Ολοήμερο</b></td>\n                <td> : </td>\n                <td>\".$row[9].($new_allDay != \'\' && $new_allDay != $row[9] ? \" &#x25B6; \".$new_allDay : \'\').\"</td>\n            </tr>\n            <tr>\n                <td width=70><b>Τοποθεσία</b></td>\n                <td> : </td>\n                <td>\".$row[6].($new_location != \'\' && $new_location != $row[6] ? \" &#x25B6; \".$new_location : \'\').\"</td>\n            </tr>\n            <tr>\n                <td width=70><b>Περιγραφή</b></td>\n                <td> : </td>\n                <td></td>\n            </tr>\n            <tr>\n                <td colspan=3>\".($new_description==\'\' ? $row[5] : $new_description).\"</td>\n            </tr>\n        </table>\n    </div>\n</div>\n            \";\n            \n            $emails_array = array();\n            \n            $sql=\"  SELECT TRIM(teacher.email),TRIM(zzzsys_user.sus_email),teacher.id\n                FROM teacher\n                LEFT JOIN zzzsys_user ON teacher.user_id=zzzsys_user.zzzsys_user_id\n                LEFT JOIN zzzsys_user_group ON zzzsys_user.sus_zzzsys_user_group_id = zzzsys_user_group.zzzsys_user_group_id\n                WHERE\n                    ((teacher.email IS NOT NULL AND TRIM(teacher.email)<>\'\') OR\n                    (zzzsys_user.sus_email IS NOT NULL AND TRIM(zzzsys_user.sus_email)<>\'\'))\n                \";\n    \n            if($row[1]!=\'-1\'){\n                $sql .=\"AND teacher.id = \'\".$row[1].\"\'\";        \n            } else {\n                if($row[2]!=\'\'){\n                    $sql .=\"AND zzzsys_user_group.zzzsys_user_group_id = \'\".$row[2].\"\'\";       \n                }\n            }\n\n            $rv     = nuRunQuery($sql);\n            while($r = db_fetch_row($rv)){\n                if(!is_null($r[0]) && $r[0]!=\'\' && !find_address($r[0],$emails_array)){\n                    $emails_array[]= array($r[0],$email_subject,$email_content,$r[2]);\n                }\n                    \n                if(!is_null($r[1]) && $r[1]!=\'\' && !find_address($r[1],$emails_array)){\n                    $emails_array[]= array($r[1],$email_subject,$email_content,$r[2]);\n                }            \n            }\n        \n            $mail                    = new PHPMailer(true);\n        \n            $mail->SMTPDebug         = 0;\n	        $mail->IsSMTP();\n	        $mail->setLanguage(\'el\');\n            $mail->Host              = $setup->set_smtp_host;\n            $mail->Port              = $setup->set_smtp_port;\n            $mail->SMTPAuth          = true;\n            $mail->SMTPSecure        = $setup->set_smtp_use_ssl ? $setup->set_smtp_use_ssl : \'\';\n            $mail->CharSet           = \'iso-8859-7\';\n\n            $mail->Username          = $setup->set_smtp_username;\n            $mail->Password          = $setup->set_smtp_password;\n\n            $mail->From              = $setup->set_smtp_from_address;\n            $mail->FromName          = iconv(\'UTF-8\',\'ISO-8859-7//IGNORE\',$setup->set_smtp_from_name);\n            $mail->AddReplyTo($setup->set_smtp_from_address,iconv(\'UTF-8\',\'ISO-8859-7//IGNORE\',$setup->set_smtp_from_name));\n            $mail->AddReplyTo        = $setup->set_smtp_from_address;\n            $mail->WordWrap          = 80;\n            $mail->IsHTML(true);\n            \n            $system_url = get_system_url();\n            $school_name = get_school_name();\n    \n            $footer = \"<br>                    \n<hr style=\\\"width: 100%; height: 0px; background-color:#b04b00; color:#b04b00;border: 1px solid;\\\">	\n<span style=\\\"color: #525c66;line-height: 150%;font-size: 14px;font-family: Sans-serif;\\\">\nΤο μήνυμα αυτό στάλθηκε μέσω του Σίσυφου. Αν θέλετε να απαντήσετε, παρακαλώ \".( $system_url==\'\' ? \"συνδεθείτε\": \"<a href=\\\"$system_url\\\">συνδεθείτε</a>\").\" και στείλτε και εσείς την απάντηση σας μέσω του Σίσυφου. Για λόγους ασφάλειας δεν κοινοποιείται η ηλεκτρονική διεύθυνση του αποστολέα.<br>\n<b>Παρακαλώ, μην απαντάτε σ’αυτό το email.</b>\n</span>\n<p></p>\n<hr style=\\\"width: 50%; margin-left:0; height: 0px; border-style: dotted; border-width: 1px 0px 0px; border-color: #525c66;\\\">\n<span style=\\\"color: #525c66;line-height: 150%;font-size: 10px;font-family: Sans-serif;\\\">\n<b>Διευκρίνιση ηλεκτρονικού ταχυδρομείου : </b>\n<br>\nΑυτό το ηλεκτρονικό μήνυμα (e-mail) είναι εμπιστευτικό και προορίζεται μόνο για χρήση από τα άτομα στα οποία απευθύνεται. Εάν δεν είστε ο προοριζόμενος παραλήπτης ή αρμόδιος για την παράδοση του μηνύματος στον προοριζόμενο παραλήπτη, παρακαλώ επιστρέψτε το στον αποστολέα και σας γνωρίζουμε ότι η αποθήκευση, ανάγνωση, μετάδοση, αναγραφή, αποκάλυψη, ανακοίνωση ή οποιασδήποτε άλλης μορφής χρήση οποιωνδήποτε πληροφοριών περιέχονται στο παρόν μήνυμα, δεν είναι σύννομη. \n<br>\nΤο $school_name δεν αποδέχεται ουδεμία ευθύνη για το περιεχόμενο του παρόντος μηνύματος και σε καμία περίπτωση, δεν ευθύνεται για οιαδήποτε τυχόν ζημία λόγω αποθήκευσης ή ανάγνωσης του παρόντος, καθυστερημένης διαβίβασης, υποκλοπής ή αλλοίωσης. Οι απόψεις που τυχόν διατυπώνονται στο παρόν μήνυμα ανήκουν αποκλειστικά στον αποστολέα αυτού.\n</span>\n\";                    \n                    \n                    \n                    \n            $footer = iconv(\'UTF-8\',\'ISO-8859-7//IGNORE\',$footer);        \n            \n            $sent=0;\n            $fail=0;\n            $wrong_address = 0;\n        \n            foreach ($emails_array as $recipient){\n            \n                $fail_code=0;\n                $fail_comments=\'\';\n            \n                $email_address = $recipient[0];\n            \n                if(!filter_var($email_address, FILTER_VALIDATE_EMAIL)){\n                    $wrong_address++;\n                    $fail_code=1;\n                    $fail_comments=\'Μη έγκυρη email διεύθυνση\';\n                } else {\n            \n                    $subject = $recipient[1];\n                    $subject =iconv(\'UTF-8\',\'ISO-8859-7//IGNORE\',$subject);\n        \n                    $content = $recipient[2];\n                    $content = iconv(\'UTF-8\',\'ISO-8859-7//IGNORE\',$content);\n                    \n                    if($content && trim($content) != \'\'){\n                        $content = $content.$footer;\n	                    $mail->Subject  = $subject;\n	                    $mail->Body     = $content;\n	                    $mail->ClearAllRecipients();\n                        $mail->AddAddress($email_address);\n            \n                        try {\n                            $mail->Send();\n                            $sent++;\n                        } catch (phpmailerException $e) {\n                            $fail++;\n                            $fail_code = 2;\n                            $fail_comments = $e->errorMessage();;\n                        } catch (Exception $e) {\n                            $fail++;\n                            $fail_code = 3;\n                            $fail_comments = $e->getMessage();;\n                        }\n                    } else {\n                            $fail++;\n                            $fail_code = 2;\n                            $fail_comments = \'Αποτυχία στη μετατροπή της κωδικοποίησης του περιεχομένου του μηνύματος.\'; \n                    }\n                }\n                $sql=\"  INSERT INTO email (\n                            id,\n                            sender_id,\n                            sent_at,\n                            email_address,\n                            email_subject,\n                            email_text,\n                            fail_code,\n                            fail_comments,\n                            teacher_id,\n                            student_id\n                            )\n                        VALUES (\n                            NULL,\n                            \'\".$row[12].\"\',\n                            NOW(),\n                            \'\".$recipient[0].\"\',\n                            \'\".my_esc($recipient[1]).\"\',\n                            \'\".my_esc($recipient[2]).\"\',\n                            \'\".$fail_code.\"\',\n                            \'\".(is_null($fail_comments) || $fail_comments==\'\' ? \'\' : $fail_comments).\"\',\n                            \".(is_null($recipient[3]) || $recipient[3]<=0 ? \'NULL\' : $recipient[3]).\",\n                            -1\n                        )\";\n                nuRunQuery($sql);\n            }\n          \n            $r_text = \"\";\n            if($sent>0) {           $r_text .= ($r_text!=\"\" ? \"\\n\" : \"\").\"Στάλθηκαν \".$sent.\" Emails!\";}\n            if($fail>0) {           $r_text .= ($r_text!=\"\" ? \"\\n\" : \"\").\"Απέτυχαν \".$fail.\" Emails!\";}\n            if($wrong_address>0) {  $r_text .= ($r_text!=\"\" ? \"\\n\" : \"\").\"Λάθος σε \".$wrong_address.\" διευθύνσεις!\";}\n            return $r_text;\n        }\n    } else{\n	    return \"-1\";\n    }\n}\n\n\n\nfunction calendar_event_owner_email(    $calendar_event_id,\n                                        $event_type=7,\n                                        $new_title=\'\',\n                                        $new_location=\'\',\n                                        $new_start_date=\'\',\n                                        $new_start_time=\'\',\n                                        $new_end_date=\'\',\n                                        $new_end_time=\'\',\n                                        $new_allDay=\'\',\n                                        $new_description=\'\'){\n    $setup = $GLOBALS[\'nuSetup\'];                                      //-- Read SMTP AUTH Settings from zzsys_setup table	\n    if (!empty($setup->set_smtp_username))          { $setup->set_smtp_username = trim($setup->set_smtp_username);}                       else{$errorText .= \"SMTP Username not set.<br>\";}\n    if (!empty($setup->set_smtp_password)) 	        { $setup->set_smtp_password = trim($setup->set_smtp_password);}                       else{$errorText .= \"SMTP Password not set.<br>\";}\n    if (!empty($setup->set_smtp_host))              { $setup->set_smtp_host = trim($setup->set_smtp_host);}                               else{$errorText .= \"SMTP Host not set.<br>\";}\n    if (!empty($setup->set_smtp_from_address))      { $setup->set_smtp_from_address = trim($setup->set_smtp_from_address);}               else{$errorText .= \"SMTP From Address not set.<br>\";}\n    if (!empty($setup->set_smtp_port))              { $setup->set_smtp_port = intval($setup->set_smtp_port);}                             else{$errorText .= \"SMTP PORT not set.<br>\";}\n    if (!empty($setup->set_smtp_use_ssl))           { $setup->set_smtp_use_ssl = trim($setup->set_smtp_use_ssl);}                         else{$setup->set_smtp_use_ssl = \'\';}\n    if (!empty($setup->set_smtp_from_name))         { $SMTPname = trim($setup->set_smtp_from_name);}	                                  else{$SMTPname = \"Sisyphos\";}\n\n    if ($errorText == \'\'){\n\n        $sql = \"\n            SELECT \n                -1,\n                -1,\n                \'\',\n                calendar_event.id,\n                calendar_event.title,\n                calendar_event.description,\n                calendar_event.location,\n                CONCAT(DATE_FORMAT(calendar_event.start_date,\'%d-%m-%Y\'),\' \' ,calendar_event.start_time),\n                CONCAT(DATE_FORMAT(calendar_event.end_date,\'%d-%m-%Y\'),\' \' ,calendar_event.end_time),\n                IF(calendar_event.allDay=\'1\',\'ΝΑΙ\',\'ΌΧΙ\'),\n                \n                concat(ifNULL(t1.surname,\'\'),if(t1.surname is NULL OR t1.name is NULL,\'\',\' \'),ifNULL(t1.name,\'\')),\n                concat(ifNULL(t2.surname,\'\'),if(t2.surname is NULL OR t2.name is NULL,\'\',\' \'),ifNULL(t2.name,\'\')),\n                t2.id,\n                if(calendar_event.color is NULL OR calendar_event.color=\'\',\'#3a87ad\',calendar_event.color),\n                if(t1.id<>t2.id,\'1\',\'0\'),\n                t1.id,\n                concat(ifNULL(s.surname,\'\'),if(s.surname is NULL OR s.name is NULL,\'\',\' \'),ifNULL(s.name,\'\'),\' (\',s.registration_number,\')\')\n            FROM calendar_event\n            INNER JOIN session_variables    ON  session_variables.session_id = \'#session_id#\'\n            INNER JOIN teacher as t1        ON  t1.id                   = calendar_event.teacher_id\n            LEFT JOIN teacher as t2         ON  t2.id                   = session_variables.teacher_id\n            LEFT JOIN student as s          ON  s.id                    = session_variables.student_id\n            WHERE \n                calendar_event.id = \'$calendar_event_id\'\";\n\n        $retval     = nuRunQuery($sql);\n        \n        $ns=\'\';\n        $ne=\'\';\n        $sender_title = \'#nu_user_group#\' == \'Parents\' ? \'γονέας του μαθητή\' : (\'#nu_user_group#\'== \'Students\' ? \'μαθητής\' : \'καθηγητής\');\n        \n        if($retval && db_num_rows($retval)==1){\n            $row        = db_fetch_row($retval);\n            $sender_name = \'#nu_user_group#\' == \'Parents\' || \'#nu_user_group#\'== \'Students\' ? $row[16] : $row[11];\n            $sender_id = \'#nu_user_group#\' == \'Parents\' || \'#nu_user_group#\'== \'Students\' ? $row[15] : $row[12];\n            $email_content    = \"\n<div style=\\\"margin: 10px 10px; font-family:Sans-serif; font-size: 16px; color: #525c66;\\\">\n\";\n            if($event_type==7){            \n                $email_subject    = \'Σίσυφος - Τροποποίηση Συμμετεχόντων Συμβάντος Ημερολογίου\';        \n                $email_content    .=\"<p>Σας ενημερώνουμε ότι ο $sender_title $sender_name τροποποίησε τους συμμετέχοντες στο συμβάν από το Ημερολόγιο του Σχολείου με τα παρακάτω στοιχεία :</p>\";\n            } else if($event_type==8){            \n                $email_subject    = \'Σίσυφος - Τροποποίηση Συμβάντος Ημερολογίου\';        \n                $email_content    .=\"<p>Σας ενημερώνουμε ότι ο $sender_title $sender_name τροποποίησε στο Ημερολόγιο του Σχολείου το συμβάν με τα παρακάτω στοιχεία :</p>\";\n                \n                $ns = date(\'d-m-Y\', strtotime($new_start_date));\n                $ns .= \' \'.$new_start_time;\n            \n                $ne = date(\'d-m-Y\', strtotime($new_end_date));\n                $ne .= \' \'.$new_end_time;\n            } else if($event_type==9){            \n                $email_subject    = \'Σίσυφος - Διαγραφή Συμβάντος Ημερολογίου\';        \n                $email_content    .=\"<p>Σας ενημερώνουμε ότι ο $sender_title $sender_name <b><u>διέγραψε</u></b> από το Ημερολόγιο του Σχολείου το συμβάν σας με τα παρακάτω στοιχεία :</p>\";\n            }  else if($event_type==10){            \n                $email_subject    = \'Σίσυφος - Προσθήκη Συμβάντος Ημερολογίου\';        \n                $email_content    .=\"<p>Σας ενημερώνουμε ότι ο $sender_title $sender_name <b><u>εισήγαγε</u></b> στο Ημερολόγιο του Σχολείου ένα συμβάν που σας αφορά με τα παρακάτω στοιχεία :</p>\";\n            }\n            \n$email_content    .=\"\n    <div title=\\\"Λεπτομέρειες Συμβάντος\\\" style=\\\"padding-top: 10px; padding-right: 20px; padding-left: 20px; padding-bottom: 20px; margin-top: 20px; margin-right: 20px; margin-bottom: 20px; margin-left: 50px; width: 500px; border-radius: 15px; border: 2px solid \".$row[13].\"; background-color:#fff; font-family: \\\"Sans-serif\\\"; font-size: 16px;\\\">\n        <p><font size=+2 color=\\\"\".$row[13].\"\\\"><b>\".$row[4].($new_title != \'\' && $new_title != $row[4] ? \" &#x25B6; \".$new_title : \'\').\"</b></font></p>\n        <table border=0 style=\\\"font-family:Sans-serif; color: #525c66; font-size: \".($event_type==8 ? \"14\" : \"16\").\"px;\\\">\n            <tr>\n                <td width=70><b>Έναρξη</b></td>\n                <td> : </td>\n                <td>\".$row[7].($ns != \'\' && $ns != $row[7] ? \" &#x25B6; \".$ns : \'\').\"</td>\n            </tr>\n            <tr>\n                <td width=70><b>Λήξη</b></td>\n                <td> : </td>\n                <td>\".$row[8].($ne != \'\' && $ne != $row[8] ? \" &#x25B6; \".$ne : \'\').\"</td>           \n            </tr>\n            <tr>\n                <td width=70><b>Ολοήμερο</b></td>\n                <td> : </td>\n                <td>\".$row[9].($new_allDay != \'\' && $new_allDay != $row[9] ? \" &#x25B6; \".$new_allDay : \'\').\"</td>\n            </tr>\n            <tr>\n                <td width=70><b>Τοποθεσία</b></td>\n                <td> : </td>\n                <td>\".$row[6].($new_location != \'\' && $new_location != $row[6] ? \" &#x25B6; \".$new_location : \'\').\"</td>\n            </tr>\n            <tr>\n                <td width=70><b>Περιγραφή</b></td>\n                <td> : </td>\n                <td></td>\n            </tr>\n            <tr>\n                <td colspan=3>\".($new_description==\'\' ? $row[5] : $new_description).\"</td>\n            </tr>\n        </table>\n    </div>\n</div>\n            \";\n            \n            $emails_array = array();\n            \n            $sql=\"  SELECT TRIM(ifNULL(teacher.email,\'\')),TRIM(ifNULL(zzzsys_user.sus_email,\'\'))\n                    FROM teacher\n                    LEFT JOIN zzzsys_user ON teacher.user_id=zzzsys_user.zzzsys_user_id\n                    WHERE\n                        teacher.id = \'\".$row[15].\"\' AND\n                        ((teacher.email IS NOT NULL AND TRIM(teacher.email)<>\'\') OR\n                        (zzzsys_user.sus_email IS NOT NULL AND TRIM(zzzsys_user.sus_email)<>\'\'))\n                \";\n            $rv     = nuRunQuery($sql);\n            \n            if($r = db_fetch_row($rv)){\n                if($r[0]!=\'\'){\n                    $emails_array[] = array($r[0]);\n                }\n                if($r[1]!=\'\' && $r[1]!=$r[0]){\n                    $emails_array[] = array($r[1]);\n                }            \n            }\n        \n            $mail                    = new PHPMailer(true);\n        \n            $mail->SMTPDebug         = 0;\n	        $mail->IsSMTP();\n	        $mail->setLanguage(\'el\');\n            $mail->Host              = $setup->set_smtp_host;\n            $mail->Port              = $setup->set_smtp_port;\n            $mail->SMTPAuth          = true;\n            $mail->SMTPSecure        = $setup->set_smtp_use_ssl ? $setup->set_smtp_use_ssl : \'\';\n            $mail->CharSet           = \'iso-8859-7\';\n\n            $mail->Username          = $setup->set_smtp_username;\n            $mail->Password          = $setup->set_smtp_password;\n\n            $mail->From              = $setup->set_smtp_from_address;\n            $mail->FromName          = iconv(\'UTF-8\',\'ISO-8859-7//IGNORE\',$setup->set_smtp_from_name);\n            $mail->AddReplyTo($setup->set_smtp_from_address,iconv(\'UTF-8\',\'ISO-8859-7//IGNORE\',$setup->set_smtp_from_name));\n            $mail->AddReplyTo        = $setup->set_smtp_from_address;\n            $mail->WordWrap          = 80;\n            $mail->IsHTML(true);\n            \n            $system_url = get_system_url();\n    \n            $footer = \"                    \n<hr style=\\\"width: 100%; height: 0px; background-color:#b04b00; color:#b04b00;border: 1px solid;\\\">	\n<span style=\\\"color: #525c66;line-height: 150%;font-size: 14px;font-family: Sans-serif;\\\">\nΤο μήνυμα αυτό το στάλθηκε μέσω του Σίσυφου. Αν θέλετε να απαντήσετε, παρακαλώ \".( $system_url==\'\' ? \"συνδεθείτε\": \"<a href=\\\"$system_url\\\">συνδεθείτε</a>\").\" και στείλτε και εσείς την απάντηση σας μέσω του Σίσυφου.<br>\nΓια λόγους ασφάλειας δεν κοινοποιείται η ηλεκτρονική διεύθυνση του αποστολέα.<br>\n<b>Παρακαλώ, μην απαντάτε σ’αυτό το email.</b>\n</span>\n                    \";\n            $footer = iconv(\'UTF-8\',\'ISO-8859-7//IGNORE\',$footer);        \n            \n            $sent=0;\n            $fail=0;\n            $wrong_address = 0;\n        \n            foreach ($emails_array as $recipient){\n            \n                $fail_code=0;\n                $fail_comments=\'\';\n            \n                $email_address = $recipient[0];\n            \n                if(!filter_var($email_address, FILTER_VALIDATE_EMAIL)){\n                    $wrong_address++;\n                    $fail_code=1;\n                    $fail_comments=\'Μη έγκυρη email διεύθυνση\';\n                } else {\n            \n                    $subject = $email_subject;\n                    $subject =iconv(\'UTF-8\',\'ISO-8859-7//IGNORE\',$subject);\n        \n                    $content = $email_content;\n                    $content = iconv(\'UTF-8\',\'ISO-8859-7//IGNORE\',$content);\n                    \n                    if($content && trim($content) != \'\'){\n                        $content = $content.$footer;\n	                    $mail->Subject  = $subject;\n	                    $mail->Body     = $content;\n	                    $mail->ClearAllRecipients();\n                        $mail->AddAddress($email_address);\n            \n                        try {\n                            $mail->Send();\n                            $sent++;\n                        } catch (phpmailerException $e) {\n                            $fail++;\n                            $fail_code = 2;\n                            $fail_comments = $e->errorMessage();;\n                        } catch (Exception $e) {\n                            $fail++;\n                            $fail_code = 3;\n                            $fail_comments = $e->getMessage();;\n                        }\n                    } else {\n                            $fail++;\n                            $fail_code = 2;\n                            $fail_comments = \'Αποτυχία στη μετατροπή της κωδικοποίησης του περιεχομένου του μηνύματος.\'; \n                    }\n                }\n                $sql=\"  INSERT INTO email (\n                            id,\n                            sender_id,\n                            sent_at,\n                            email_address,\n                            email_subject,\n                            email_text,\n                            fail_code,\n                            fail_comments,\n                            teacher_id,\n                            student_id\n                            )\n                        VALUES (\n                            NULL,\n                            \'$sender_id\',\n                            NOW(),\n                            \'\".$recipient[0].\"\',\n                            \'\".my_esc($email_subject).\"\',\n                            \'\".my_esc($email_content).\"\',\n                            \'\".$fail_code.\"\',\n                            \'\".(is_null($fail_comments) || $fail_comments==\'\' ? \'\' : $fail_comments).\"\',\n                            \'\".$row[15].\"\',\n                            -1\n                        )\";\n                nuRunQuery($sql);\n            }\n          \n            $r_text = \"\";\n            if($sent>0) {           $r_text .= ($r_text!=\"\" ? \"\\n\" : \"\").\"Στάλθηκαν \".$sent.\" Emails!\";}\n            if($fail>0) {           $r_text .= ($r_text!=\"\" ? \"\\n\" : \"\").\"Απέτυχαν \".$fail.\" Emails!\";}\n            if($wrong_address>0) {  $r_text .= ($r_text!=\"\" ? \"\\n\" : \"\").\"Λάθος σε \".$wrong_address.\" διευθύνσεις!\";}\n            return $r_text;\n        }\n    } else{\n	    return \"-1\";\n    }\n}\n\n','','0','2017-09-09 22:57:25','globeadmin','2020-09-23 23:55:57','globeadmin','2020-09-23 23:55:57','globeadmin','0'),('59b96a9340a4bcc','public_calendar','Δημόσιο Ημερολόγιο Σχολείου','All','function search_event($ea, $event_id){\n    foreach ($ea as $event) {\n        if($event[0]==$event_id){\n                return true;\n        }\n    }\n    return false;\n}\n\n$datetime = new DateTime(\'now\');\n$datetime_string = $datetime->format(\'c\');\n\n$sql = \"    SELECT school_year.start_date,school_year.end_date\n            FROM school\n            INNER JOIN school_year ON school.school_year_id = school_year.id\n            WHERE school.id=1\";\n$retval = nuRunQuery($sql);\n$row = db_fetch_row($retval);\n\n$start_year = date(\'Y\', strtotime($row[0]));\n$end_year = date(\'Y\', strtotime($row[1]));\n\n$start_date = $start_year.\"-09-01\";\n$end_date = $end_year.\"-07-01\";\n\n$datetime_current = $datetime->format(\'Y-m-d\');\n$datetime_current = ($datetime_current>$end_date ? $end_date : ($datetime_current<$start_date ? $start_date : $datetime_current));\n\n$sql = \" SELECT distinct holiday,description FROM holiday ORDER BY holiday\";\n$rv = nuRunQuery($sql);\n$holiday_array = array();\nwhile ($r = db_fetch_row($rv)){\n    $holiday_array[]= array($r[0],$r[1]);    \n}\n\n//--------------------------------------------Εύρσεση συμβάντων--------------------------------------------\n\n$event_array = array();\n\n//--------------------------------------------- Όσά αναφέρονται στο group του μαθητή (Μαθητής/Γονέας)-----------------------------------------------\n$sql = \"    SELECT \n                calendar_event.id,\n                calendar_event.title,\n                ifNULL(calendar_event.description,\'\'),\n                calendar_event.allDay,\n                calendar_event.start_date,\n                calendar_event.end_date,\n                calendar_event.start_time, \n                calendar_event.end_time,\n                ifNULL(calendar_event.color,\'\'),\n                ifNULL(calendar_event.backgroundColor,\'\'),\n                ifNULL(calendar_event.borderColor,\'\'),\n                ifNULL(calendar_event.textColor,\'\'),\n                calendar_event.is_exam,\n                calendar_event.is_test,\n                ifNULL(calendar_event.location,\'\')\n            FROM calendar_event\n            INNER JOIN calendar_event_access ON calendar_event.id = calendar_event_access.calendar_event_id\n            WHERE \n                calendar_event_access.teacher_id is NULL AND\n                calendar_event_access.student_id is NULL AND\n                calendar_event_access.grade_id is NULL AND\n                calendar_event_access.class_id is NULL AND\n                calendar_event_access.user_group_id=\'999999999999999\'\n        \";\n$rv1 = nuRunQuery($sql);\n\nwhile ($r1 = db_fetch_row($rv1)){\n    if(!search_event($event_array,$r1[0])){\n        $event_array[]= $r1;    \n    }\n        \n}\n\n//------------------------------------------------------------------------------------------------------------------------------------\n\nprint\"\n<!DOCTYPE html>\n<html>\n<head>\n    <meta charset=\'utf-8\' />\n    <link href=\'calendar/fullcalendar.min.css\' rel=\'stylesheet\' />\n    <link href=\'calendar/fullcalendar.print.min.css\' rel=\'stylesheet\' media=\'print\' />\n    \n    <script src=\'calendar/lib/moment.min.js\'></script>\n    <script src=\'calendar/lib/jquery.min.js\'></script>\n    <script src=\'calendar/fullcalendar.min.js\'></script>\n    <script src=\'calendar/locale/el.js\'></script>\n    <script>\n        var holiday_array = [];\n\";\n    \nforeach ($holiday_array as $holiday) {\n    print \"     holiday_array.push([\\\"\".$holiday[0].\"\\\", \\\"\".$holiday[1].\"\\\"]);\n\";\n} \n\nprint\"    \n	$(document).ready(function() {\n		$(\'#calendar\').fullCalendar({\n			defaultDate: \'$datetime_current\',\n			editable: false,\n			aspectRatio: 2,\n			fixedWeekCount: false,\n			eventLimit: true,\n			minTime: \'07:00:00\',\n			maxTime: \'22:00:00\',\n			nowIndicator: true,\n		    visibleRange: \n		        {\n                start: \'\".$start_date.\"\',\n                end: \'\".$end_date.\"\'\n                },\n            validRange: \n		        {\n                start: \'\".$start_date.\"\',\n                end: \'\".$end_date.\"\'\n                },\n			now: \".json_encode($datetime_string).\",\n			header: \n			    {\n		            left:   \'prev,next today\',\n                    center: \'title\',\n                    right:  \'month,agendaWeek,agendaDay,listMonth\'\n			    },\n\n            dayRender: function (date, cell) \n                {\n                    var d=date.format(\'YYYY-MM-DD\');\n                    for (var i = 0; i < holiday_array.length; i++) {\n                        if (d==holiday_array[i][0]) {\n                            cell.css(\\\"background-color\\\", \\\"#ffdb99\\\");\n                            break;\n                        }\n                    }\n                },\n                \n            dayClick: function(date, jsEvent, view) {\n                if(view.name == \'month\' || view.name == \'agendaWeek\') {\n                    //$(\'#calendar\').fullCalendar(\'changeView\', \'agendaDay\');\n                    $(\'#calendar\').fullCalendar(\'gotoDate\', date);      \n                }\n            },\n\n            eventClick: function(calEvent, jsEvent, view) {\n                if (!($(\'#eventContent\').is(\':visible\'))){\n		            \n		            var position = $(this).offset();\n		            var overlap = false;\n		            \n		            var new_top = position.top;\n		            var new_left = position.left-410;\n		            \n		            if (new_left < 10){\n                        new_left = position.left+$(this).width()+10;\n		            }\n		            \n		            if (new_left > $(document).width()-410){\n                        new_left = $(document).width()-445;\n                        overlap = true;\n                        new_top += $(this).height()+5;\n		            }\n\n		            if (($(document).height()-position.top) < 250){\n                        if(overlap){\n                            new_top = position.top-250;    \n                        } else {\n                            new_top = position.top+$(this).height()-245;    \n                        }\n		            }\n			    \n		            $(\'#eventContent\').css({ top: new_top+\'px\' });\n		            $(\'#eventContent\').css({ left: new_left+\'px\' });\n		            \n		            $(\'#eventTitle\').html(calEvent.title);\n		            $(\'#eventTitle\').css({ color: calEvent.color });\n		            \n		            $(\'#startTime\').html(moment(calEvent.start).format(\'MMM Do h:mm A\'));\n		            if(moment(calEvent.end).format(\'MMM Do h:mm A\')==\'Invalid date\'){\n		                $(\'#endTime\').html(\'\');    \n		            } else {\n		                $(\'#endTime\').html(moment(calEvent.end).format(\'MMM Do h:mm A\'));    \n		            }\n                    $(\'#allDay\').html(calEvent.allDay ? \'Ναί\' : \'Όχι\');\n                    $(\'#eventDescription\').html(calEvent.description);\n                    $(\'#eventLocation\').html(calEvent.location);\n\n		            $(\'#eventContent\').show();\n		        \n		            $(this).bind(\'wheel\', function(e){\n                        var scrollTo = $(\'#eventContent\').scrollTop() - (e.originalEvent.deltaY*-1);\n                        $(\'#eventContent\').scrollTop(scrollTo);\n                    });\n                } else {\n                    $(\'#eventContent\').hide();    \n                }\n            },            \n            eventMouseover: function(calEvent, jsEvent, view) {\n                if (!($(\'#eventContent\').is(\':visible\'))){\n		            \n		            var position = $(this).offset()\n		            var overlap = false;\n		            \n		            var new_top = position.top;\n		            var new_left = position.left-410;\n		            \n		            if (new_left < 10){\n                        new_left = position.left+$(this).width()+10;\n		            }\n		            \n		            if (new_left > $(document).width()-410){\n                        new_left = $(document).width()-445;\n                        overlap = true;\n                        new_top += $(this).height()+5;\n		            }\n\n		            if (($(document).height()-position.top) < 250){\n                        if(overlap){\n                            new_top = position.top-250;    \n                        } else {\n                            new_top = position.top+$(this).height()-245;    \n                        }\n		            }\n			    \n		            $(\'#eventContent\').css({ top: new_top+\'px\' });\n		            $(\'#eventContent\').css({ left: new_left+\'px\' });\n		            \n		            $(\'#eventTitle\').html(calEvent.title);\n		            $(\'#eventTitle\').css({ color: calEvent.color });\n		            \n		            $(\'#startTime\').html(moment(calEvent.start).format(\'MMM Do h:mm A\'));\n		            if(moment(calEvent.end).format(\'MMM Do h:mm A\')==\'Invalid date\'){\n		                $(\'#endTime\').html(\'\');    \n		            } else {\n		                $(\'#endTime\').html(moment(calEvent.end).format(\'MMM Do h:mm A\'));    \n		            }\n                    $(\'#allDay\').html(calEvent.allDay ? \'Ναί\' : \'Όχι\');\n                    $(\'#eventDescription\').html(calEvent.description);\n                    $(\'#eventLocation\').html(calEvent.location);\n\n		            $(\'#eventContent\').show();\n			\n		        }\n	            \n	            $(this).bind(\'wheel\', function(e){\n                    var scrollTo = $(\'#eventContent\').scrollTop() - (e.originalEvent.deltaY*-1);\n                    $(\'#eventContent\').scrollTop(scrollTo);\n                });\n            },\n            eventMouseout: function(calEvent, jsEvent, view) {\n                $(\'#eventContent\').hide();\n            },           \n            \n            eventSources: [\n\n                {\n                    events: [\";\n                    \n$last_holiday = end(array_keys($holiday_array));\nforeach ($holiday_array as $holiday) {\n    print\"\n                        {\n					        title: \'\".$holiday[1].\"\',\n					        start: \'\".$holiday[0].\"\',\n					        color: \'green\',\n					        allDay: true,\n					        description: \'Αργία\',\n					        location: \'\'\n				        },\n				        {\n                            start: \'\".$holiday[0].\"T00:00:00\',\n                            end: \'\".$holiday[0].\"T23:59:59\',\n                            rendering: \'background\'\n                        }\".($holiday[0]!=$last_holiday[0] ? \',\' : \'\');\n}                     \n\nprint\"\n                    ]\n                },\n                \n                {\n                    events: [\";\n                    \n$last_event = end(array_keys($event_array));\nforeach ($event_array as $event) {\n    print\"\n                        {\n                            id: \'\".$event[0].\"\',\n                            title: \'\".$event[1].\"\',\n                            allDay: \".($event[3]==\'1\' ? \'true\' : \'false\').\",\n                            start: \'\".$event[4].($event[3]==\'0\' ? \'T\'.$event[6] : \'\'  ).\"\',\n                            end: \'\".$event[5].($event[3]==\'0\' ? \'T\'.$event[7] : \'\'  ).\"\',\n                            color: \'\".($event[8]!=\'\' ? $event[8] : \'#3a87ad\').\"\',\n                            \".($event[9]!=\'\' ? \"backgroundColor: \'\".$event[9].\"\',\n                            \" : \'\').($event[10]!=\'\' ? \"borderColor: \'\".$event[10].\"\',\n                            \" : \'\').($event[11]!=\'\' ? \"textColor: \'\".$event[11].\"\',\n                            \" : \'\').\n                            \"description: \'\".json_encode(preg_replace(\"/\\r\\n|\\r|\\n/\",\'<br/>\',$event[2]),JSON_HEX_APOS).\"\',\n                            is_exam: \'\".$event[12].\"\',\n					        is_test: \'\".$event[13].\"\',\n					        location: \'\".$event[14].\"\'\n				        }\".($event!=$last_event ? \',\' :\'\');\n}                     \n\nprint\"\n                    ]\n                }\n            ]\n        });\n	});\n	\n</script>\n<style>\n	body {\n		margin: 10px 10px 10px 10px;\n		padding: 0;\n		font-family: \\\"Lucida Grande\\\",Helvetica,Arial,Verdana,sans-serif;\n		font-size: 14px;\n	}\n	\n	.eventContents{\n			    display: none;\n			    position: absolute;\n			    z-index: 5000;\n			    padding-top: 1px;\n                padding-right: 20px;\n                padding-left: 20px;\n			    overflow-x:none;\n			    padding-bottom: 0 !important;\n			    width: 360px;\n			    height: 240px;\n			    border-radius: 15px;\n			    border: 1px solid #C8C8C8;\n			    background-color:#fff;\n			    box-shadow: 0 4px 3px #8C8C8C;\n			    overflow-y: auto;\n	}\n\n	#calendar {\n		max-width: 1050px;\n		min-width: 800px;\n		margin: 0 auto;\n	}\n	\n	.fc-mon { background-color:#ffffe6; }\n	.fc-tue { background-color:#ffffe6; }\n	.fc-wed { background-color:#ffffe6; }\n	.fc-thu { background-color:#ffffe6; }\n	.fc-fri { background-color:#ffffe6; }\n	.fc-sat { background-color:#ffdb99; }\n    .fc-sun { background-color:#ffdb99; }\n    .fc-today { background-color:#ffff80 !important; color:#ff0000 !important;}\n    .fc-bgevent { background-color:#ffa600 !important; }\n\n</style>\n</head>\n<body>\n    <div id=\\\"eventContent\\\" class=\\\"eventContents\\\" title=\\\"Λεπτομέρειες Συμβάντος\\\" onclick=\\\"$(this).hide();\\\">\n        \n        <p><font size=+1><b><span id=\\\"eventTitle\\\"></span></b></font></p>\n        \n        <table border=0>\n            <tr>\n                <td width=70><b>Έναρξη</b></td>\n                <td> : </td>\n                <td><span id=\\\"startTime\\\"></span></td>\n            </tr>\n            <tr>\n                <td width=70><b>Λήξη</b></td>\n                <td> : </td>\n                <td><span id=\\\"endTime\\\"></span></td>           \n            </tr>\n            <tr>\n                <td width=70><b>Ολοήμερο</b></td>\n                <td> : </td>\n                <td><span id=\\\"allDay\\\"></span></td>\n            </tr>\n            <tr>\n                <td width=70><b>Τοποθεσία</b></td>\n                <td> : </td>\n                <td><span id=\\\"eventLocation\\\"></span></td>\n            </tr>\n            <tr>\n                <td width=70><b>Περιγραφή</b></td>\n                <td> : </td>\n                <td></td>\n            </tr>\n            <tr>\n                <td colspan=3><span id=\\\"eventDescription\\\" style=\\\"font-size: 12px;\\\"></span></td>\n            </tr>\n        </table>\n    </div>\n	<div id=\'calendar\'></div>\n</body>\n</html>\";','','1','2017-09-13 20:27:47','globeadmin','2018-07-18 09:27:33','globeadmin','2018-07-18 09:27:33','globeadmin','1'),('59c268951ca99d5','student_class_delete_all','Διαγράφει όλες τις κατανομές σε τμήματα που έχουν επιλεγεί','manager','$nuParameters =\'\';\nif(\'#class_id_sumo#\'!=\'#\'.\'class_id_sumo#\' && \'#class_id_sumo#\'!=\'\'){\n    $sql=\"DELETE FROM student_class WHERE class_id IN (#class_id_sumo#)\";\n    nuRunQuery($sql); \n    $nuParameters =\'OK\';\n} else {\n    $nuError = \"Προσοχή: Επιλέξτε πρώτα τα τμήματα!\";\n}\n\n\n\n','','0','2017-09-20 16:09:41','globeadmin','2017-09-20 21:24:32','globeadmin','2017-10-03 00:35:35','globeadmin','0'),('59cf5a3a12fe151','student_programs','Πρόγραμμα Μαθητή','student','$sql = \"SELECT max(timetable.start_date) \n		FROM timetable\";\n$rv1 = nuRunQuery($sql);\n$r1 = db_fetch_row($rv1);\n$current_timetable_date = $r1[0];\n\n\n$sql = \" CREATE TEMPORARY TABLE IF NOT EXISTS #TABLE_ID# AS \n            SELECT distinct\n            	subject.name 				AS subject_name,\n            	subject_type.name 			AS subject_type_name,\n            	classroom.short_name		AS classroom_short,\n            	class.short_name 			AS class_short,\n            	CAST(\'\' as CHAR(1000))		AS teacher_name,\n            	class.id					AS class_id,\n            	subject.id					AS subject_id,\n            	card.day_id					AS day_id,\n            	card.period_id				As period_id\n            FROM card\n            INNER JOIN subject 			on card.subject_id = subject.id \n            INNER JOIN class 			on card.class_id = class.id\n            LEFT  JOIN subject_type 	on subject.subject_type_id = subject_type.id\n            LEFT  JOIN classroom		ON classroom.id = card.classroom_id 	\n            WHERE \n            	card.valid_from = \'$current_timetable_date\' AND\n            	class.id in (select distinct class_id from student_class where student_id=\'#RECORD_ID#\') 	\n            ORDER BY \n            	class_short,\n            	subject_name,\n            	subject_type_name DESC\n\";\nnuRunQuery($sql);\n\n$sql = \"SELECT DISTINCT class_id,subject_id FROM #TABLE_ID#\";\n$rv2 = nuRunQuery($sql);\nwhile($r2 = db_fetch_row($rv2)){\n        $sql=\"  SELECT distinct\n                        concat(IF(teacher.surname IS NULL,\'\',teacher.surname),IF(teacher.surname IS NULL,\'\',\' \'),IF(teacher.name IS NULL,\'\',teacher.name))\n                FROM card\n                INNER JOIN teacher on card.teacher_id = teacher.id \n                WHERE \n                    card.valid_from = \'\".$current_timetable_date.\"\' AND\n                    card.class_id   = \'\".$r2[0].\"\' AND\n                    card.subject_id = \'\".$r2[1].\"\'\n                \";\n        $rv3 = nuRunQuery($sql);\n        $teacher_names = \"\";\n        while($r3 = db_fetch_row($rv3)){\n            $teacher_names = ($teacher_names == \"\" ? $r3[0] : $teacher_names.\", \".$r3[0]);\n        }\n        \n        if($teacher_names != \"\"){\n            $sql = \"UPDATE #TABLE_ID# SET teacher_name=\'$teacher_names\' WHERE class_id= \'\".$r2[0].\"\' AND subject_id = \'\".$r2[1].\"\'\";\n            nuRunQuery($sql);\n        }\n        \n}\n\n$sql = \"SELECT  \n	        dp.day_name,\n	        dp.period_short_name,\n	        ifNULL(c.subject_name,\'\'),\n	        ifNULL(c.subject_type_name,\'\'),\n            ifNULL(c.classroom_short,\'\'),\n            ifNULL(c.class_short,\'\'),\n            ifNULL(c.teacher_name,\'\'),\n            dp.day_id\n	    FROM \n	        (SELECT \n	            day.id as day_id,\n	            day.name as day_name,\n	            day.short_name as day_short_name,\n	            period.id as period_id,\n	            period.name as period_name,\n	            period.short_name as period_short_name\n			FROM day,period\n			ORDER BY day.id,period.id) AS dp\n	    LEFT JOIN #TABLE_ID# AS c ON (c.day_id=dp.day_id AND c.period_id=dp.period_id)\n        ORDER BY dp.day_id,dp.period_id\";\n\n$retval = nuRunQuery($sql);\n\nprint \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n        \n        <STYLE TYPE=\\\"text/css\\\">\n            .sisTableLine TH{\n                font-size:1.1em;\n            }\n        </STYLE>\n    </head>\n\n    <body onload=\\\"adjustIframeHeight()\\\">\";\n\nif(!$retval ){\n    print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν τα δεδομένα!</span>\");\n} else{\n    print (\"\n        <table CLASS=\\\"sisTableLine\\\" cellspacing=0 width=100%>\n            <tr height=30> \n                <th width=80 align=center>Ημέρα</th> \n                <th width=60 align=center>Ώρα</th> \n                <th width=70 align=center>Τμήμα</th> \n                <th width=350 align=center>Μάθημα</th> \n                <th width=100 align=center>Κατηγορία</th> \n                <th width=80 align=center>Αίθουσα</th>\n                <th width=250 align=center>Καθηγητής</th>\n            </tr>\");\n                \n    $color1 = \'LightBlue\';\n    $color2 = \'LightSteelBlue\';\n    \n    $color = $color2;\n    $cur_day=-1;\n    \n    while($row = db_fetch_row($retval)){\n        if ($cur_day!=$row[7]){$color = ($color==$color1 ? $color2 : $color1);$cur_day=$row[7];}\n        print \"\n            <tr style=\\\"background-color:$color;\\\" height=28>\n                <td align=center valign=center>\".$row[0].\"</td>\n                <td align=center valign=center>\".$row[1].\"</td>\n                <td align=center valign=center>\".$row[5].\"</td>\n                <td align=left valign=center>\".$row[2].\"</td>\n                <td align=center valign=center>\".$row[3].\"</td>\n                <td align=center valign=center>\".$row[4].\"</td>\n                <td align=left valign=center>\".$row[6].\"</td>\n            </tr>\";\n    }\n    print (\"\n        </table>\");\n}\n    \nprint \"\n    </body>\n</html>\";\n','','0','2017-09-30 11:47:54','globeadmin','2018-07-16 23:19:24','globeadmin','2018-07-16 23:19:24','globeadmin','0'),('59cfe983ac3c809','show_email_content','Εμφανίζει περιεχόμενο ενός email σε iframe','teacher','print \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n    </head>\n    <body>\";\n$sql=\"SELECT email_text FROM email WHERE id=\'#RECORD_ID#\'\";\n$retval=nuRunQuery($sql);\nif($retval) {\n    if($row=db_fetch_row($retval)) {\n        print (\"\n        <table border=0 cellspacing=0 width=100% style=\\\"padding: 10px 10px 10px 10px;\\\">\n            <tr width=100%>\n                <td  bgcolor=\\\"#fffff0\\\">\n\".$row[0].\"\n                </td>\n            </tr>\n        </table>\n        \");\n    } else {\n        print (\"<span CLASS=\\\"msg\\\">Δε βρέθηκε το Email...</span>\");\n    }   \n} else {\n    print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν δεδομένα...</span>\");    \n}\nprint \"\n    </body>\n</html>\";','','0','2017-09-30 21:59:15','globeadmin','2018-07-16 10:32:04','globeadmin','2018-07-16 10:32:04','globeadmin','0'),('59d28f945fe6eab','student_class_delete_row','Διαγράφει ένα μαθητή από ένα τμήμα','manager','if(\'#student_class_id#\'!=\'#\'.\'student_class_id#\' && \'#student_class_id#\'!=\'\'){\n    $sql=\"delete from student_class where new_id=\'#student_class_id#\'\";\n    nuRunQuery($sql);\n}\n\n','','0','2017-10-02 22:12:20','globeadmin','2017-10-02 22:15:01','globeadmin','2017-10-02 22:26:54','globeadmin','0'),('59d29693d0e9c14','student_class_add','Προσθέτει ένα μαθητή στα επιλεγμένα τμήμτα','manager','$nuParameters =\'\';\nif(\'#class_id_sumo#\'!=\'#\'.\'class_id_sumo#\' && \'#class_id_sumo#\'!=\'\'){\n    $sql=\"  INSERT INTO student_class \n                (new_id,class_id,student_id)\n            SELECT\n                NULL,\n                class.id,\n                \'#RECORD_ID#\'\n            FROM class\n            WHERE id IN (#class_id_sumo#)\";\n    nuRunQuery($sql); \n    $nuParameters =\'OK\';\n} else {\n    $nuError = \"Προσοχή: Επιλέξτε πρώτα τα τμήματα!\";\n}\n','','0','2017-10-02 22:42:11','globeadmin','2017-10-02 22:50:29','globeadmin','2017-10-02 22:50:29','globeadmin','0'),('59e6312e9944cb9','show_participants_ballot','Εμφανίζει τους συμμετέχοντες ψηφοφόρους σε μία ψηφοφορία','Manager','print \"<html>\n    <head>\n\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n        \n        <STYLE TYPE=\\\"text/css\\\">\n			.sisTableLine TD{\n                font-weight: normal;    \n            }\n			.sisTableLine TH{\n                font-size:9pt;    \n            }\n        </STYLE>\n\n    </head>\n    <body onload=\\\"adjustIframeHeight()\\\">\";\n\n$sql=\"  SELECT\n                ballot_voter.id,\n                grade.short_name,\n                registration_number,\n                concat(student.surname,\' \',student.name,if(student.fathers_name is NULL,\'\',concat(\' πατ. \',student.fathers_name))),\n                if(is_parent=1,\'Γονέας\',\'Μαθητής\'),\n                if(voted=1,DATE_FORMAT(voted_at,\'%d-%m-%Y %T\'),\'Όχι\'),\n                voted\n        FROM ballot_voter\n        INNER JOIN student           ON ballot_voter.student_id = student.id\n        INNER JOIN grade             ON grade.id = student.grade_id\n        WHERE\n            ballot_voter.ballot_id=\'#RECORD_ID#\'\n        ORDER BY    \n                    grade.short_name,\n                    student.surname,\n                    student.name,\n                    student.fathers_name,\n                    is_parent\n\";\n\n$retval = nuRunQuery($sql);\n\nif($retval) {\n    if(db_num_rows($retval)>0) {\n        print (\"\n        <table cellspacing=0 CLASS=\\\"sisTableLine\\\" align=center width=900>\n            <tr height=30>\n                <th width=50 align=center>Τάξη</th>\n                <th width=50 align=center>Α.Μ.</th>\n                <th width=400 align=center>Όνομα</th>\n                <th width=100 align=center>Ιδιότητα</th>\n                <th width=150 align=center>Ψήφισε</th>\n                <th width=80 align=center>\n                    Επιλογή Όλων<input type=\\\"checkbox\\\" id=\\\"all_chk_1\\\" title=\\\"Επιλογή Όλων\\\" onclick=\\\"toggle(this,\'chk_1\')\\\">\n                </th>\n            </tr>\");\n        $i=0;\n        while($row = db_fetch_row($retval)) {\n            $i++;    \n            print (\"\n            <tr\".($row[6]==\'1\' ? \" style=\\\"background-color:LightGreen;\\\"\" : \"\").\" height=27>\n                <td align=center>\".$row[1].\"</td>\n                <td align=center>\".$row[2].\"</td>\n                <td align=left>\".$row[3].\"</td>\n                <td align=center>\".$row[4].\"</td>\n                <td align=center>\".$row[5].\"</td>\n                <td align=center>\n                    \".($row[6]==\'1\' ? \'\' : \"<input type=\\\"checkbox\\\" CLASS=\\\"chk_1\\\" id=\\\"\".$row[0].\"\\\" title=\\\"Επιλογή\\\" onclick=\\\"make_indeterminate(\'all_chk_1\')\\\">\").\"\n                </td>\n            </tr>\");\n        }\n        print (\"\n            <tr height=27>\n                <th align=right colspan=4>Αριθμός Ψηφοφόρων : </th>\n                <th align=left colspan=2>$i</th>\n            </tr>\n        </table>\");        \n    } else{\n        print (\"<span CLASS=\\\"msg\\\">Δε βρέθηκαν ψηφοφόροι για την ψηφοφορία!</span>\");\n    }\n} else{\n    print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν δεδομένα...</span>\");\n}\nprint \"\n    </body>\n</html>\";','','0','2017-10-17 19:34:54','globeadmin','2018-07-16 10:56:37','globeadmin','2018-07-16 10:56:37','globeadmin','0'),('59ea53ae2bbc384','show_student_ballot_choices','Εμφανίζει στους μαθητές τις επιλογές μίας ψηφοφορίας','Student','print \"<html>\n    <head>\n\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\"> \n        \n        <style>\n	        .sisTableLine TH{\n                font-size:10pt;    \n            }        \n        </style>\n\n        <script type=\\\"text/javascript\\\">\n\n            function show_choice_info(choice_id) {\n                parent.nuOpenFormInFrame(\'59ea67cf8d2d9b3\', choice_id);\n            }\n\n            function edit_choice_info(choice_id) {\n                parent.nuOpenFormInFrame(\'59eaf663b08f216\', choice_id);\n            }\n\n        </script>\n    </head>\n    <body onload=\\\"adjustIframeHeight()\\\">\";\n\n$sql=\"  SELECT\n            ballot_choice.id,\n            ballot_choice.name,\n            if(ballot_choice.description is NULL OR trim(ballot_choice.description)=\'\',\'0\',\'1\'),\n            if(session_variables.student_id=ballot_choice.student_id,\'1\',\'0\'),\n            if(concat(ballot.start_date,\' \',ballot.start_time)>NOW(),\'1\',\'0\')\n        FROM ballot_choice\n        INNER JOIN ballot ON ballot.id = ballot_choice.ballot_id\n        INNER JOIN session_variables ON session_id=\'#session_id#\'\n        WHERE\n            ballot_choice.ballot_id=\'#RECORD_ID#\'\n        ORDER BY    \n            ballot_choice.hierarchy,ballot_choice.name\n            \n\";\n\n$retval = nuRunQuery($sql);\n\nif($retval) {\n    if(db_num_rows($retval)>0) {\n        print (\"\n        <table cellspacing=0 CLASS=\\\"sisTableLine\\\" align=center width=850>\n            <tr height=30>\n                <th width=750 align=center>Επιλογή/Υποψηφιότητα</th>\n                <th width=100 align=center>Περιγραφή</th>\n            </tr>\");\n        \n        while($row = db_fetch_row($retval)) {\n                \n            print (\"\n            <tr height=30>\n                <td align=left>\".$row[1].\"</td>\n                \".($row[3]==\'1\' && $row[4]==\'1\' ? \n                    \"<td align=center title=\\\"Επεξεργασία της περιγραφής μου\\\" onclick=\\\"edit_choice_info(\".$row[0].\")\\\" onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\"><img id=\\\"img_\".$row[0].\"\\\" width=18 height=18 src=\\\"images/\".($row[2]==\'1\' ? \'edit_red\' : \'edit\').\".png\\\"></td>\" : \n                    ($row[2]==\'1\' ? \n                        \"<td align=center title=\\\"Περιγραφή για αυτήν την επιλογή/υποψήφιο\\\" onclick=\\\"show_choice_info(\".$row[0].\")\\\" onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\"><img id=\\\"img_\".$row[0].\"\\\" width=16 height=16 src=\\\"images/info.png\\\"></td>\" : \n                        \"<td></td>\")).\"\n            </tr>\");\n        }\n        print (\"\n        </table>\");\n    } else{\n        print (\"<span CLASS=\\\"msg\\\">Δεν έχουν οριστεί επιλογές για την ψηφοφορία!</span>\");\n    }\n} else{\n    print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν δεδομένα...</span>\");\n}\nprint \"\n    </body>\n</html>\";','','0','2017-10-20 22:51:10','globeadmin','2018-07-16 10:55:00','globeadmin','2018-07-16 10:55:00','globeadmin','0'),('59ea6f7db44655c','student_ballot_paper','Ψηφοδέλτιο ψηφοφορίας Μαθητή','Student','print \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n\n        <STYLE TYPE=\\\"text/css\\\">\n            .sisTableLine TD,.sisTableLine TH{\n                font-size:11pt;\n                border-bottom: 3px solid lightyellow;\n            }\n        </STYLE>\n\n        <script type=\\\"text/javascript\\\">\n\n            function change_state(cell) {\n                var img = document.getElementById(cell.id+\\\"_check\\\");\n                if(cell.vote==\\\"1\\\"){\n                    cell.vote=\\\"0\\\";\n                    cell.parentNode.style.backgroundColor = \\\"LightBlue\\\";\n                    cell.title=\\\"Επιλέξτε\\\";\n                    img.style.visibility = \'hidden\';\n                } else {\n                    var s = count_selected();\n                    if(s < parseInt(\'#max_numb_of_choices#\')){\n                        cell.vote=\\\"1\\\";\n                        cell.parentNode.style.backgroundColor = \\\"LightGreen\\\";\n                        cell.title=\\\"Αποεπιλέξτε\\\";\n                        img.style.visibility = \'visible\';\n                    } else {\n                        alert(\'Δεν μπορείτε να επιλέξετε περισσότερα από #max_numb_of_choices#\');\n                    }\n                }\n    \n                parent.set_num_of_choices(count_selected());\n            }\n\n            function get_selected(){\n\n                var c = document.getElementsByClassName(\\\"choices\\\");\n                var id_array = [];\n                var i;\n    \n                for (i = 0; i < c.length; i++) {\n                    if(c[i].vote==\\\"1\\\"){\n                        id_array.push(c[i].id);    \n                    }\n                }\n    \n                ids = id_array.join();\n    \n                if(typeof id_array != \'undefined\' && id_array != null && id_array.length > 0){\n                    return ids;\n                } else {\n                    return \'-1\';\n                }\n            }\n\n            function count_selected(){\n\n                var c = document.getElementsByClassName(\\\"choices\\\");\n                var id_array = [];\n                var i;\n    \n                var t=0;\n    \n                for (i = 0; i < c.length; i++) {\n                    if(c[i].vote==\\\"1\\\"){\n                        t++;        \n                    }\n                }\n    \n                return t;  \n            }\n\n        </script>\n    </head>\n    <body onload=\\\"adjustIframeHeight()\\\">\";\n\n$cur_datetime = date(\'Y-m-d H:i:s\');\n$is_parent = (\'#nu_user_group#\'==\'Parents\' ? \'1\' : \'0\');\n\nif(\'#is_active#\'==\'1\'){\n\n    $sql=\"  SELECT voted,if(voted_at IS NOT NULL,DATE_FORMAT(voted_at,\'%d-%m-%Y %T\'),\'\')\n            FROM ballot_voter\n            INNER JOIN session_variables ON (session_id=\'#session_id#\' AND session_variables.student_id = ballot_voter.student_id)\n            WHERE\n                ballot_voter.ballot_id=\'#RECORD_ID#\' and\n                ballot_voter.is_parent=\'$is_parent\'\";\n    $rv = nuRunQuery($sql);\n\n    if(db_num_rows($rv)==1) {\n        \n        $r=db_fetch_row($rv);\n        if($r[0]==\'0\'){\n            if($cur_datetime>=\'#start_date# #start_time#\'){\n            \n                if($cur_datetime<=\'#end_date# #end_time#\'){\n      \n//********************************************************* Δημιουργία ψηφοδελτίου ***********************************************************\n    $sql=\"  SELECT\n            ballot_choice.id,\n            ballot_choice.name,\n            if(description is NULL OR trim(description)=\'\',\'\',description)\n        FROM ballot_choice\n        WHERE\n            ballot_choice.ballot_id=\'#RECORD_ID#\'\n        ORDER BY    \n            hierarchy,name\";\n\n    $retval = nuRunQuery($sql);\n\n\n    if(db_num_rows($retval)>0) {\n        print (\"\n        <table cellspacing=0 CLASS=\\\"sisTableLine\\\" align=center width=850>\");\n        \n        while($row = db_fetch_row($retval)) {\n                \n            print (\"\n            <tr height=36>\n                <td align=center valign=center width=30><img style=\\\"visibility: hidden;\\\" id=\\\"\".$row[0].\"_check\\\" src=\\\"images/check.png\\\"></td>\n                <td class=\\\"choices\\\" align=left valign=center id=\\\"\".$row[0].\"\\\" vote=\\\"0\\\" title=\\\"Επιλέξτε\\\" onmousedown=\\\"change_state(this);\\\" onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\">\".$row[1].\"</td>\n            </tr>\");\n        }\n        print (\"\n        </table>\");\n    } else{\n        print \"<span CLASS=\\\"msgError\\\">Δεν έχουν οριστεί επιλογές για τη ψηφοφορία!</span>\";\n    }      \n//*************************************************************************************************************************************************\n                } else {\n                    print \"<span CLASS=\\\"msgError\\\">Δυστυχώς η κάλπη έκλεισε και δεν μπορέσατε να ψηφίσετε!!</span>\";\n                }\n            } else {\n                print \"<span CLASS=\\\"msg\\\" style=\\\"color:orange;\\\">Η κάλπη δεν έχει ανοίξει ακόμη!</span>\";\n            }          \n         \n        } else {\n            print \"<span CLASS=\\\"msg\\\">Ψηφίσατε στην ψηφοφορία αυτή στις \".$r[1].\"</span>\";\n        }\n    } else {\n        print \"<span CLASS=\\\"msgError\\\">Δεν έχετε δικαίωμα ψήφου σε αυτήν τη ψηφοφορία!</span>\";\n    }\n} else {\n    print \"<span CLASS=\\\"msgError\\\" style=\\\"color:orange;\\\">Η ψηφοφορία αυτή δεν είναι ενεργή!</span>\";\n}\nprint \"\n    </body>\n</html>\";','','0','2017-10-21 00:49:49','globeadmin','2018-07-16 11:03:22','globeadmin','2018-07-16 11:03:22','globeadmin','0'),('59eb2c8c6a0bf72','student_ballot_vote','Καταχώριση ψηφοφορίας Μαθητή','Student','$nuParameters = \'\';\n$cur_datetime = date(\'Y-m-d H:i:s\');\n$is_parent = (\'#nu_user_group#\'==\'Parents\' ? \'1\' : \'0\');\n\nif(\'#is_active#\'==\'1\'){\n\n    $sql=\"  SELECT \n                    ballot_voter.id,\n                    ballot_voter.voted,\n                    if(ballot_voter.voted_at IS NOT NULL,DATE_FORMAT(ballot_voter.voted_at,\'%d-%m-%Y %T\'),\'\'),\n                    ballot_voter.student_id,\n                    ballot.max_numb_of_choices,\n                    NOW()\n            FROM ballot_voter\n            INNER JOIN session_variables ON (session_id=\'#session_id#\' AND session_variables.student_id = ballot_voter.student_id)\n            INNER JOIN ballot ON ballot.id = ballot_voter.ballot_id\n            WHERE\n                ballot_voter.ballot_id=\'#RECORD_ID#\' and\n                ballot_voter.is_parent=\'$is_parent\'\";\n    $rv = nuRunQuery($sql);\n\n    if(db_num_rows($rv)==1) {\n        \n        $r=db_fetch_row($rv);\n        if($r[1]==\'0\'){\n            if($cur_datetime>=\'#start_date# #start_time#\'){\n            \n                if($cur_datetime<=\'#end_date# #end_time#\'){\n                \n                    if(\'#choices_id_list#\' != \'#\'.\'choices_id_list#\' && \'#choices_id_list#\'!=\'\') {\n                    \n                        $ids = explode(\',\',\'#choices_id_list#\');\n                        \n                        if(count($ids) == count(array_unique($ids))){\n                        \n                            $sql=\"select count(*) from ballot_choice where ballot_id=\'#RECORD_ID#\' AND id in(#choices_id_list#)\";\n                            $rv2 = nuRunQuery($sql);\n                            $r2 =  db_fetch_row($rv2);\n                            \n                            if(\'#choices_id_list#\'==\'-1\' || count($ids)==$r2[0]){\n                                if(count($ids)<=$r[4]){\n//**************************************************************** Καταχώρηση ψηφοφορίας *****************************************                         \n                                    $sql=\"UPDATE ballot_voter SET voted=1,voted_at=\'\".$r[5].\"\' WHERE id=\'\".$r[0].\"\'\";\n                                    nuRunQuery($sql);\n                                    \n                                    $old_timestamp = strtotime($r[5]);\n                                    $new_timestamp = date(\'Y-m-d H:00:00\', $old_timestamp); // αφαιρούνται τα λεπτά και τα δευτερόλεπτα για την εξασφάλιση της μυστικότητας   \n                        \n                                    $sql=\"  INSERT INTO ballot_paper (\n                                                            id,\n                                                            ballot_id,\n                                                            student_id,\n                                                            is_parent,\n                                                            added_at)\n                                            VALUES (\n                                                            NULL,\n                                                            \'#RECORD_ID#\',\n                                                            \".(\"#is_anonymous#\"==\'1\' ? \'NULL\' : \"\'\".$r[3].\"\'\").\",\n                                                            \".(\"#is_anonymous#\"==\'1\' ? \'0\' : \"\'$is_parent\'\").\",\n                                                            \'\".$new_timestamp.\"\')\n                                            \";\n                                    $t = nuRunQuery($sql,null,true);\n                        \n                                    if(\'#choices_id_list#\'!=\'-1\'){\n     \n                                        foreach ($ids as $id){\n\n                                            $sql=\"  INSERT INTO ballot_vote (id,ballot_choice_id,ballot_paper_id)\n                                                    VALUES (NULL,\'$id\',\'$t\')\n                                                \";\n                                            nuRunQuery($sql);\n                                        }\n                                    }\n                                    $nuParameters = \'OK\';\n//*************************************************************************************************************************** \n                                } else {\n                                    $nuError = \"Προσοχή! Προσπαθείτε να καταχωρίσετε περισσότερες επιλογές από το επιτρεπόμενο! Παρακαλώ επικοινωνήστε με τον διαχειριστή του συστήματος!\";    \n                                }\n                            } else {\n                                $nuError = \"Προσοχή! Προσπαθείτε να καταχωρίσετε μια μη έγκυρη επιλογή! Παρακαλώ επικοινωνήστε με τον διαχειριστή του συστήματος!\";    \n                            }\n                        } else {\n                            $nuError = \"Προσοχή! Παρουσιάστηκε σφάλμα (διπλότυπα) κατά την επεξεργασία των επιλογών σας! Παρακαλώ επικοινωνήστε με τον διαχειριστή του συστήματος!\";    \n                        }\n                    } else {\n                        $nuError = \"Προσοχή! Παρουσιάστηκε σφάλμα κατά την αποστολή των επιλογών σας! Παρακαλώ επικοινωνήστε με τον διαχειριστή του συστήματος!\";    \n                    }\n                } else {\n                    $nuError = \"Δυστυχώς η κάλπη έκλεισε και δεν μπορέσατε να ψηφίσετε!!\";\n                }\n            } else {\n                $nuError = \"Η κάλπη δεν έχει ανοίξει ακόμη!\";\n            }          \n        } else {\n            $nuError = \"Ψηφίσατε ήδη στη ψηφοφορία αυτή στις \".$r[2];    \n        }\n    } else {\n        $nuError = \"Δεν έχετε δικαίωμα ψήφου σε αυτήν τη ψηφοφορία!\";    \n    }\n} else {\n    $nuError = \"Η ψηφοφορία αυτή δεν είναι ενεργή!\";    \n}','','0','2017-10-21 14:16:28','globeadmin','2017-11-12 13:45:25','globeadmin','2017-11-12 13:47:20','globeadmin','0'),('59eb9e1160272cc','ballot_results','Εμφανίζει τα αποτελέσματα μια ψηφοφορίας','sisyphos','function format_precent($n){\nreturn (str_pad(number_format(round($n*100,2),2,\',\',\'.\'), 5, \'0\', STR_PAD_LEFT));\n}\n\nprint \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n\n        <STYLE TYPE=\\\"text/css\\\">\n            .sisTable, .sisTable TD{\n                font-size:9pt;\n                font-weight: bold;\n                text-align: center;\n                border-color:#595959;\n            }\n            .sisTable TH{\n                font-size:10pt;\n                background-color:#93aed2;\n                border-color:#595959;\n            }\n    \n            .blank_row{\n                height: 20px !important; /* overwrites any other rules */\n                background-color: #FFFFFF;\n                border-style: 0px solid !important;\n                border-left: 0px solid !important;\n                border-right: 0px solid !important;\n            }\n    \n            .small_font{\n                font-size:6pt;\n            }\n            .small_font2{\n                font-size:7pt;\n            }    \n            .big_font{\n                font-size:12pt;\n            }\n\n            .big_font2{\n                font-size:11pt;\n            }\n            .align_left{\n                text-align: left !important;\n            }\n        </STYLE>\n    <head>\n    <body onload=\\\"adjustIframeHeight()\\\">\";\n    \n$sql = \"SELECT \n    ballot.name,\n    ballot.display_results,\n    school.short_name,\n    school_year.short_name,\n    DATE_FORMAT(NOW(),\'%d-%m-%Y %T\'), \n    if(concat(ballot.end_date,\' \',ballot.end_time)<DATE_FORMAT(NOW(),\'%Y-%m-%d %T\'),\'Οριστικά\',\'Προσωρινά\'),\n    ballot.is_anonymous\nFROM ballot\nINNER JOIN school ON school.id = 1\nINNER JOIN school_year ON school_year.id = school.school_year_id\nWHERE ballot.id=\'#RECORD_ID#\'\";\n$retval = nuRunQuery($sql);\n\nif($row=db_fetch_row($retval)){\n$ballot_name        = $row[0];\n$display_results    = $row[1];\n$school_name        = $row[2];\n$school_year_name   = $row[3];\n$cur_datetime       = $row[4];\n$result_state       = $row[5];\n$is_anonymous       = $row[6];\n\n$total_voters               = 0;\n$total_voters_parent        = 0;\n$total_voters_student       = 0;\n$total_voted                = 0;\n$total_voted_parent         = 0;\n$total_voted_student        = 0;\n$total_not_voted            = 0;\n$total_not_voted_parent     = 0;\n$total_not_voted_student    = 0;\n$total_voted2               = 0;\n$white_papers               = 0;\n    \n$sql = \"SELECT \n    count(*),\n    ifNULL(sum(if(is_parent=\'0\',1,0)),0),\n    ifNULL(sum(if(is_parent=\'0\',0,1)),0)\nFROM ballot_voter \nWHERE ballot_id=\'#RECORD_ID#\'\";\n$retval = nuRunQuery($sql);\nif($row=db_fetch_row($retval)){\n    $total_voters           = $row[0];\n    $total_voters_parent    = $row[2];\n    $total_voters_student   = $row[1];\n}\n\n$sql = \"SELECT \n    count(*),\n    ifNULL(sum(if(is_parent=\'0\',1,0)),0),\n    ifNULL(sum(if(is_parent=\'0\',0,1)),0)\nFROM ballot_voter \nWHERE \n	ballot_id=\'#RECORD_ID#\'\n    and `voted`=1\";\n$retval = nuRunQuery($sql);\nif($row=db_fetch_row($retval)){\n    $total_voted            = $row[0];\n    $total_voted_parent     = $row[2];\n    $total_voted_student    = $row[1];\n}\n\n$sql = \"SELECT \n    count(*),\n    ifNULL(sum(if(is_parent=\'0\',1,0)),0),\n    ifNULL(sum(if(is_parent=\'0\',0,1)),0)\nFROM ballot_voter \nWHERE \n	ballot_id=\'#RECORD_ID#\'\n    and `voted`=0\";\n$retval = nuRunQuery($sql);\nif($row=db_fetch_row($retval)){\n    $total_not_voted            = $row[0];\n    $total_not_voted_parent     = $row[2];\n    $total_not_voted_student    = $row[1];\n}\n\n$sql = \"SELECT count(*) \nFROM `ballot_paper` \nWHERE `ballot_id`=\'#RECORD_ID#\'\";\n$retval = nuRunQuery($sql);\nif($row=db_fetch_row($retval)){\n    $total_voted2 = $row[0];\n}\n\n$sql = \"SELECT count(*) \nFROM ballot_paper \nWHERE \n	ballot_paper.ballot_id=\'#RECORD_ID#\' AND\n	ballot_paper.id NOT IN \n		(select distinct ballot_vote.ballot_paper_id  from ballot_vote WHERE ballot_id=\'#RECORD_ID#\')\";\n$retval = nuRunQuery($sql);\nif($row=db_fetch_row($retval)){\n    $white_papers = $row[0];\n}\n\nif($total_voters!=0){\n\n$color1=\'#7bea7b\';\n$color2=\'#a7f1a7\';\n$color=$color2;\n\nprint (\"\n    <table cellspacing=0 CLASS=\\\"sisTable\\\" align=center width=920>\n    \n        <tr height=40>\n            <th align=center colspan=7><span class=\\\"big_font\\\">$result_state Αποτελέσματα Ψηφοφορίας</span></th>\n        </tr>\n        <tr height=40>\n            <th align=center colspan=7><span class=\\\"big_font2\\\">$school_name, $school_year_name, $cur_datetime</span></th>\n        </tr>\n        \n        <tr height=40>\n            <th align=center colspan=7><span class=\\\"big_font2\\\">$ballot_name</span></th>\n        </tr>\n\n        <tr>\n            <td class=\\\"blank_row\\\" colspan=7></td>\n        </tr> \n        \n        <tr height=35>\n            <th rowspan=2 width=220></th>\n            <th colspan=2 width=220>Σύνολο</th>\n            <th colspan=2 width=220>Μαθητές</th>\n            <th colspan=2 width=220>Γονείς</th>\n        </tr>\n        \n        <tr height=35>\n            <th width=110>Αριθμός</th>\n            <th width=110>Ποσοστό %</th>\n            <th width=110>Αριθμός</th>\n            <th width=110>Ποσοστό %</th>\n            <th width=110>Αριθμός</th>\n            <th width=110>Ποσοστό %</th>\n        </tr>\n        \n        <tr height=40 style=\\\"background-color:lightgreen;\\\">\n            <td>Ψήφισαν</td>\n            <td>$total_voted</td>\n            <td>\".format_precent($total_voted/$total_voters).\"</td>\n            <td>\".($total_voters_student==\'0\' ? \'-\' :  $total_voted_student).\"</td>\n            <td>\".($total_voters_student==\'0\' ? \'-\' :  format_precent($total_voted_student/$total_voters_student)).\"</td>\n            <td>\".($total_voters_parent==\'0\' ? \'-\' :  $total_voted_parent).\"</td>\n            <td>\".($total_voters_parent==\'0\' ? \'-\' :  format_precent($total_voted_parent/$total_voters_parent)).\"</td>\n        </tr>\n\n        <tr height=40 style=\\\"background-color:#ffc14d;\\\">\n            <td>Απείχαν</td>\n            <td>$total_not_voted</td>\n            <td>\".format_precent($total_not_voted/$total_voters).\"</td>\n            <td>\".($total_voters_student==\'0\' ? \'-\' :  $total_not_voted_student).\"</td>\n            <td>\".($total_voters_student==\'0\' ? \'-\' :  format_precent($total_not_voted_student/$total_voters_student)).\"</td>\n            <td>\".($total_voters_parent==\'0\' ? \'-\' :  $total_not_voted_parent).\"</td>\n            <td>\".($total_voters_parent==\'0\' ? \'-\' :  format_precent($total_not_voted_parent/$total_voters_parent)).\"</td>\n        </tr>\n        \n        <tr height=40 style=\\\"background-color:LightBlue;\\\">\n            <td>Σύνολο Ψηφοφόρων</td>\n            <td>$total_voters</td>\n            <td>\".format_precent($total_voters/$total_voters).\"</td>\n            <td>\".($total_voters_student==\'0\' ? \'-\' :  $total_voters_student).\"</td>\n            <td>\".($total_voters_student==\'0\' ? \'-\' :  format_precent($total_voters_student/$total_voters_student)).\"</td>\n            <td>\".($total_voters_parent==\'0\' ? \'-\' :  $total_voters_parent).\"</td>\n            <td>\".($total_voters_parent==\'0\' ? \'-\' :  format_precent($total_voters_parent/$total_voters_parent)).\"</td>\n        </tr> \n        \n        <tr>\n            <td class=\\\"blank_row\\\" colspan=7></td>\n        </tr> \n        \n        <tr height=40 style=\\\"background-color:LightYellow;\\\">\n            <td>Λευκά</td>\n            <td align=left>$white_papers</th>\n            <td align=left>\".format_precent($white_papers/$total_voted).\"<br><span class=\\\"small_font\\\">(στους Ψηφίσαντες)</span></td>\n            <td colspan=4 style=\\\"background-color:LightGray;\\\"></td>\n        </tr>\n\");\n\nif($is_anonymous==\'0\' && $white_papers>0){\n    $sql =\" SELECT concat(student.surname,\' \',student.name,if(student.fathers_name IS NULL,\'\',CONCAT(\' πατ.\',student.fathers_name)),if(ballot_paper.is_parent=1,\' (Γονέας)\',\' (Μαθητής)\'))\n                    FROM ballot_paper\n                    INNER JOIN student ON student.id = ballot_paper.student_id\n                    WHERE \n	                    ballot_paper.ballot_id=\'#RECORD_ID#\' AND\n	                    ballot_paper.id NOT IN \n		                    (select distinct ballot_vote.ballot_paper_id  from ballot_vote WHERE ballot_id=\'#RECORD_ID#\')\n                    ORDER BY student.surname,student.name,student.fathers_name\n    \";\n    $rv = nuRunQuery($sql);\n    $nr = db_num_rows($rv);\n    if($nr>0){\n        print(\"\n         <tr height=30 style=\\\"background-color:LightYellow;\\\">\n            <td colspan=7 class=\\\"align_left\\\" style=\\\"padding-left: 30px;\\\">\"); \n                while($r=db_fetch_row($rv)){\n                    print(\"<span class=\\\"small_font2\\\">\".$r[0].\"</span><br>\");             \n                }            \n                print(\"\n            </td>\n        </tr> \");     \n    }\n}\n\nprint (\"       \n        <tr>\n            <td class=\\\"blank_row\\\" colspan=7></td>\n        </tr>\n\");\n\n\n$sql = \"SELECT ballot_choice.id,ballot_choice.name,count(ballot_vote.id)\nFROM ballot_choice\nLEFT JOIN ballot_vote ON ballot_choice.id = ballot_vote.ballot_choice_id\nWHERE\n    ballot_choice.ballot_id=\'#RECORD_ID#\'\nGROUP BY ballot_choice.id,ballot_choice.name\nORDER by count(ballot_vote.id) desc,ballot_choice.hierarchy,ballot_choice.name\";\n$retval = nuRunQuery($sql);\n\nif(db_num_rows($retval)>=0){\n    print \"\n        <tr height=40>\n            <th align=center colspan=7><span class=\\\"big_font\\\">Έλαβαν</span></th>\n        </tr>\";\n    $j=0;\n    while($row=db_fetch_row($retval)){\n        $color = ($color==$color1 ? $color2 : $color1);\n        $j++;\n        print(\"\n         <tr height=40 style=\\\"background-color:$color;\\\">\n            <td colspan=5 class=\\\"align_left\\\">\".$j.\'. \'.$row[1].\"</td>\n            <td colspan=2><span class=\\\"big_font\\\">\".$row[2].\"</span></td>\n        </tr>   \n        \"); \n    \n        if($is_anonymous==\'0\' && $row[2]>0){\n            $sql =\" SELECT concat(student.surname,\' \',student.name,if(student.fathers_name IS NULL,\'\',CONCAT(\' πατ.\',student.fathers_name)))\n                    FROM ballot_vote\n                    INNER JOIN ballot_paper ON ballot_paper.id = ballot_vote.ballot_paper_id\n                    INNER JOIN student      ON student.id = ballot_paper.student_id\n                    WHERE \n                        ballot_vote.ballot_choice_id=\'\".$row[0].\"\' AND\n                        ballot_paper.ballot_id = \'#RECORD_ID#\'\n                    ORDER BY student.surname,student.name,student.fathers_name\n            \";\n            $rv = nuRunQuery($sql);\n            $nr = db_num_rows($rv);\n            if($nr>0){\n                print(\"\n         <tr height=30 style=\\\"background-color:$color;\\\">\n            <td colspan=7 class=\\\"align_left\\\" style=\\\"padding-left: 30px;\\\">\"); \n                while($r=db_fetch_row($rv)){\n                    print(\"<span class=\\\"small_font2\\\">\".$r[0].\"</span><br>\");             \n                }            \n                print(\"\n            </td>\n        </tr> \");     \n            }\n            \n        }\n    }\n} else {\n    print (\"\n        <tr height=40>\n            <th align=center colspan=7>Δεν έχουν καταχωρηθεί προτιμήσεις!</th>\n        </tr>\");    \n}\n\nprint \"\n    </table>\";\n\n} else {\n    print (\"<span CLASS=\\\"msg\\\">Δε βρέθηκαν ψηφοφόροι για την ψηφοφορία!</span>\");    \n}\n} else {\n    print (\"<span CLASS=\\\"msgError\\\">Προσοχή: Δε βρέθηκε η ψηφοφορία!</span>\");    \n}\nprint \"\n    </body>\n</html>\";\n','','0','2017-10-21 22:20:49','globeadmin','2018-07-16 11:10:33','globeadmin','2019-11-07 13:35:39','globeadmin','0'),('59eb9f11d245bfd','add_students_to_ballot_choices','Προσθέτει τους επιλεγμένους μαθητές ως υποψήφιους σε μία ψηφοφορία','Teacher','nuRunPHP(\'notification_add_lib\');\n\n$nuParameters = \'\';\n$publish_id = nuID();\n\n$sql = \"    SELECT COUNT(*)\n            FROM ballot_paper\n            WHERE ballot_id = \'#RECORD_ID#\'\n        \";\n$retval = nuRunQuery($sql);\n$row    = db_fetch_row($retval);\n$papers = $row[0];\n\nif($papers==0){\nif(\'#choice_student_id_select_sumo#\'!=\'#\'.\'choice_student_id_select_sumo#\' && \'#choice_student_id_select_sumo#\'!=\'\'){\n\n    $sql = \"    SELECT count(*) \n                FROM ballot_choice \n                WHERE \n                    student_id IN (#choice_student_id_select_sumo#) and ballot_id=\'#RECORD_ID#\'\n            \";\n    $retval = nuRunQuery($sql);\n    $row=db_fetch_row($retval);\n    $exists = $row[0];\n    \n    $i = 0;\n    \n    $sql = \"    SELECT  student.id,\n                        concat(student.surname,\' \',student.name,if(student.fathers_name is NULL,\'\',concat(\' πατ. \',student.fathers_name)),\' (Τάξη \',grade.short_name,\')\')\n                FROM student\n                INNER JOIN grade ON grade.id = student.grade_id\n                WHERE \n                    student.id IN (#choice_student_id_select_sumo#) AND\n                    student.id NOT IN (select student_id FROM ballot_choice WHERE ballot_id=\'#RECORD_ID#\' and student_id is not null)\n            \";\n \n    $retval = nuRunQuery($sql);\n    if($retval){\n        while($row=db_fetch_row($retval)){\n            $i++;\n            $sql = \"INSERT INTO ballot_choice (\n                        id,\n                        ballot_id,\n                        name,\n                        description,\n                        student_id,\n                        hierarchy) VALUES (\n                        NULL,\n                        \'#RECORD_ID#\',\n                        \'\".$row[1].\"\',\n                        NULL,\n                        \'\".$row[0].\"\',\n                        0\n                        )\";\n            nuRunQuery($sql);\n            \n            if(\'#calendar_event_id#\'!=\'\' && \'#calendar_event_id#\' != \'#\'.\'calendar_event_id#\'){\n            \n                $sql = \"INSERT INTO calendar_event_access (\n                            id,\n                            calendar_event_id,\n                            teacher_id,\n                            student_id,\n                            grade_id,\n                            class_id,\n                            user_group_id,\n                            publish_id\n                            )\n                        SELECT\n                            NULL,\n                            \'#calendar_event_id#\',\n                            NULL,\n                            \'\".$row[0].\"\',\n                            NULL,\n                            NULL,\n                            zzzsys_user_group_id,\n                            \'$publish_id\'\n                    FROM student \n                    inner join zzzsys_user_group ON zzzsys_user_group_id in (\'547de4c65675a29\',\'5717ba3eb32c252\')\n                    WHERE student.id =\'\".$row[0].\"\'\n                \";\n                nuRunQuery($sql);\n            }\n        }\n        \n        if($i>0) {$nuParameters=\"Εισήχθησαν ως υποψήφιοι $i Μαθητές!\";}\n        if($exists>0) {$nuParameters=$nuParameters.\"\\n\".$exists.\" Μαθητές δεν εισήχθησαν γιατί υπάρχουν ήδη ως υποψήφιοι!\";}\n        \n                // Clean up dublicates if any. Δεν είναι και ο καλύτερος τρόπος αλλά για να γίνει σωστά χρειάζονται πάρα πολοί έλεγχοι. \n        $sql = \"DELETE a\n                FROM calendar_event_access as a, calendar_event_access as b\n                WHERE\n                    (a.calendar_event_id = b.calendar_event_id) AND\n                    (a.teacher_id = b.teacher_id OR (a.teacher_id IS NULL AND b.teacher_id IS NULL)) AND\n                    (a.student_id = b.student_id OR (a.student_id IS NULL AND b.student_id IS NULL)) AND    \n                    (a.grade_id = b.grade_id OR (a.grade_id IS NULL AND b.grade_id IS NULL)) AND\n                    (a.class_id = b.class_id OR (a.class_id IS NULL AND b.class_id IS NULL)) AND\n                    (a.user_group_id = b.user_group_id OR (a.user_group_id IS NULL AND b.user_group_id IS NULL)) AND\n                    a.id > b.id\";\n        nuRunQuery($sql);\n        \n        if(\'#create_notification#\'==\'1\'){\n            $sql =\"SELECT id FROM calendar_event_access WHERE publish_id=\'$publish_id\' AND user_group_id IN (\'547de4c65675a29\',\'5717ba3eb32c252\')\";\n            $rv = nuRunQuery($sql);\n            while($r = db_fetch_row($rv)){\n                calendar_event_notification($r[0],7);\n            }\n        }\n        \n    } else{\n        $nuError = \"Προσοχή : Παρουσιάστηκε σφάλμα κατά την εισαγωγή!\";    \n    }\n} else {\n    $nuError = \"Παρακαλώ επιλέξτε πρώτα τους Μαθητές!\";    \n}\n} else {\n    $nuError = \'Προσοχή! Έχουν ήδη καταχωρηθεί ψήφοι! Δεν μπορείτε να προσθέσετε νέους υποψήφιους!\';    \n}','','0','2017-10-21 22:25:05','globeadmin','2017-11-03 22:16:27','globeadmin','2018-02-25 10:33:14','globeadmin','0'),('59ecb4b6b724284','ballot_results_student','Εμφανίζει τα αποτελέσματα μια ψηφοφορίας στους Μαθητές - Γονείς','sisyphos','$sql = \"SELECT name,display_results,is_active,is_anonymous,end_date,end_time\nFROM ballot\nWHERE id=\'#RECORD_ID#\'\";\n$retval = nuRunQuery($sql);\n$row    = db_fetch_row($retval);\n\n$ballot_name        = $row[0];\n$display_results    = $row[1];\n$is_active          = $row[2];\n$is_anonymous       = $row[3];\n$end_datetime       = $row[4].\" \".$row[5];\n\n$msg_class = \'\';\n$msg = \'msg\';\n\nif($is_active==\'1\'){\n    if($display_results==\'1\'){\n        if($is_anonymous ==\'1\' && $end_datetime > date(\"Y-m-d H:i:s\")){\n            $msg_class = \"msg\";\n            $msg = \"Η κάλπη είναι ακόμη ανοιχτή!\";                \n        } else {\n            nuRunPHP(\"ballot_results\");    \n        }\n    } else {\n        $msg_class = \"msg\";\n        $msg = \"Τα αποτελέσματα δεν έχουν ακόμη εκδοθεί!\";    \n    }\n} else{\n    $msg_class = \"msgError\";\n    $msg = \"Η ψηφοφορία δεν είναι ενεργή!\";\n}\n\nprint \"\n<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n    </head>\n    <body>\n        <span CLASS=\\\"$msg_class\\\">$msg</span>\n    </body>\n</html>\";  \n','','0','2017-10-22 18:09:42','globeadmin','2019-11-07 13:31:37','globeadmin','2019-11-07 13:31:37','globeadmin','0'),('59ee65967ccd61f','delete_ballot_voters','Διαγράφει επιλεγμένους ψηφοφόρους σε μια ψηφοφορία','Teachers','nuRunPHP(\'notification_add_lib\');\n\n$nuParameters = \'\';\n\nif(\'#id_list#\'!=\'#\'.\'id_list#\' && \'#id_list#\'!=\'\'){\n\n    if(\'#create_notification#\'==\'1\'){\n        $sql = \"SELECT calendar_event_access.id \n            FROM calendar_event_access \n            WHERE \n                calendar_event_id = \'#calendar_event_id#\' AND\n                student_id IN (SELECT student_id FROM ballot_voter WHERE id IN (#id_list#) AND ballot_id=\'#RECORD_ID#\' AND is_parent=0 AND student_id IS NOT NULL) AND\n                student_id NOT IN (SELECT student_id FROM ballot_choice WHERE ballot_id=\'#RECORD_ID#\' AND student_id IS NOT NULL) AND\n                user_group_id = \'547de4c65675a29\'\n            \";\n        nuDebug($sql);\n        $retval = nuRunQuery($sql);\n        while($row=db_fetch_row($retval)){\n            calendar_event_notification($row[0],9);\n        }\n    }\n    $sql = \"DELETE \n            FROM calendar_event_access \n            WHERE \n                calendar_event_id = \'#calendar_event_id#\' AND\n                student_id IN (SELECT student_id FROM ballot_voter WHERE id IN (#id_list#) AND ballot_id=\'#RECORD_ID#\' AND is_parent=0 AND student_id IS NOT NULL) AND\n                student_id NOT IN (SELECT student_id FROM ballot_choice WHERE ballot_id=\'#RECORD_ID#\' AND student_id IS NOT NULL) AND\n                user_group_id = \'547de4c65675a29\'\n            \";\n    nuRunQuery($sql);\n    \n    \n    if(\'#create_notification#\'==\'1\'){\n        $sql = \"SELECT calendar_event_access.id \n            FROM calendar_event_access \n            WHERE \n                calendar_event_id = \'#calendar_event_id#\' AND\n                student_id IN (SELECT student_id FROM ballot_voter WHERE id IN (#id_list#) AND ballot_id=\'#RECORD_ID#\' AND is_parent=1 AND student_id IS NOT NULL) AND\n                student_id NOT IN (SELECT student_id FROM ballot_choice WHERE ballot_id=\'#RECORD_ID#\' AND student_id IS NOT NULL) AND\n                user_group_id = \'5717ba3eb32c252\'\n            \";\n        nuDebug($sql);\n        $retval = nuRunQuery($sql);\n        while($row=db_fetch_row($retval)){\n            calendar_event_notification($row[0],9);\n        }\n    }    \n    $sql = \"DELETE \n            FROM calendar_event_access \n            WHERE \n                calendar_event_id = \'#calendar_event_id#\' AND\n                student_id IN (SELECT student_id FROM ballot_voter WHERE id IN (#id_list#) AND ballot_id=\'#RECORD_ID#\' AND is_parent=1 AND student_id IS NOT NULL) AND\n                student_id NOT IN (SELECT student_id FROM ballot_choice WHERE ballot_id=\'#RECORD_ID#\' AND student_id IS NOT NULL) AND\n                user_group_id = \'5717ba3eb32c252\'\n            \";\n    nuRunQuery($sql);\n\n    \n    $sql=\"DELETE FROM ballot_voter WHERE id IN (#id_list#) AND ballot_id=\'#RECORD_ID#\'\";\n    nuRunQuery($sql);\n} else {\n    $nuParameters = \'-1\';    \n}\n','','0','2017-10-24 00:56:38','globeadmin','2017-11-04 13:49:53','globeadmin','2017-11-04 13:49:53','globeadmin','0'),('59ee6a061d547b1','add_ballot_voters','Προσθέτει τους επιλεγμένους ψηφοφόρους σε μια ψηφοφορία','Teachers','nuRunPHP(\'notification_add_lib\');\n\nfunction calendar_publish($selection,$is_parent,$p_id){\n    if(\'#calendar_event_id#\'!=\'\' && \'#calendar_event_id#\' != \'#\'.\'calendar_event_id#\'){\n            \n        if ($selection == \'1\'){\n    \n            $sql = \"INSERT INTO calendar_event_access (\n                            id,\n                            calendar_event_id,\n                            teacher_id,\n                            student_id,\n                            grade_id,\n                            class_id,\n                            user_group_id,\n                            publish_id\n                            )\n                        SELECT\n                            NULL,\n                            \'#calendar_event_id#\',\n                            NULL,\n                            student.id,\n                            NULL,\n                            NULL,\n                            \'\".($is_parent==\'0\' ? \'547de4c65675a29\' : \'5717ba3eb32c252\').\"\',\n                            \'$p_id\'\n                    FROM student \n                    WHERE student.grade_id IN (#grade_id_select_sumo#)\n            \";\n            nuRunQuery($sql);    \n                \n        } elseif ($selection == \'2\'){\n    \n            $sql = \"INSERT INTO calendar_event_access (\n                            id,\n                            calendar_event_id,\n                            teacher_id,\n                            student_id,\n                            grade_id,\n                            class_id,\n                            user_group_id,\n                            publish_id\n                            )\n                        SELECT\n                            NULL,\n                            \'#calendar_event_id#\',\n                            NULL,\n                            student_class.student_id,\n                            NULL,\n                            NULL,\n                            \'\".($is_parent==\'0\' ? \'547de4c65675a29\' : \'5717ba3eb32c252\').\"\',\n                            \'$p_id\'\n                    FROM student_class \n                    WHERE student_class.class_id IN (#class_id_select_sumo#)\n            \";\n            nuRunQuery($sql);     \n    \n        } if ($selection == \'3\'){\n            $sql = \"INSERT INTO calendar_event_access (\n                            id,\n                            calendar_event_id,\n                            teacher_id,\n                            student_id,\n                            grade_id,\n                            class_id,\n                            user_group_id,\n                            publish_id\n                            )\n                        SELECT\n                            NULL,\n                            \'#calendar_event_id#\',\n                            NULL,\n                            student.id,\n                            NULL,\n                            NULL,\n                            \'\".($is_parent==\'0\' ? \'547de4c65675a29\' : \'5717ba3eb32c252\').\"\',\n                            \'$p_id\'\n                    FROM student \n                    WHERE student.id IN (#student_id_select_sumo#)\n            \";\n            nuRunQuery($sql);   \n        }\n    \n    }\n}\n\n$nuParameters = \'-1\';\n$publish_id = nuID();\n$t1=0;\n$t2=0;\n            \nif (\'#selection1#\' == \'#\'.\'selection1\'.\'#\' || \'#selection1#\' == \'\') {\n\n    $nuError = \"Προσοχή: Επιλέξτε πρώτα ποιοι ψηφοφόροι θα προστεθούν!\"; \n    \n} elseif (\'#selection1#\' == \'1\' || \'#selection1#\' == \'2\' || \'#selection1#\' == \'3\') {\n    \n    if( \'#students_check_hash#\'==\'#\'.\'students_check_hash#\' || \'#students_check_hash#\'==\'\' || \n        \'#parents_check_hash#\'==\'#\'.\'parents_check_hash#\' || \'#parents_check_hash#\'==\'\' || \n        (\'#students_check_hash#\'==\'0\' && \'#parents_check_hash#\'==\'0\')){\n        \n        $nuError = \"Προσοχή: Επιλέξτε πρώτα αν θα προστεθούν «Μαθητές» ή και «Γονείς»!!\"; \n    \n            \n    } elseif (\'#selection1#\' == \'1\') {\n        if(\'#grade_id_select_sumo#\'!=\'#\'.\'grade_id_select_sumo#\' && \'#grade_id_select_sumo#\'!=\'\'){\n        \n            if(\'#students_check_hash#\'==\'1\'){\n            \n                $sql = \" INSERT INTO ballot_voter (\n                            id,\n                            ballot_id,\n                            student_id,\n                            voted,\n                            voted_at,\n                            is_parent\n                            )\n                        SELECT\n                            NULL,\n                            \'#RECORD_ID#\',\n                            student.id,\n                            0,\n                            NULL,\n                            0\n                        FROM student\n                        WHERE \n                            grade_id IN (#grade_id_select_sumo#) AND\n                            student.id NOT IN (SELECT bv1.student_id FROM ballot_voter AS bv1 WHERE bv1.ballot_id=\'#RECORD_ID#\' AND is_parent=0)\n                \";\n                $t1 = nuRunQuery($sql,NULL,true);\n                \n                calendar_publish(\'1\',\'0\',$publish_id);\n            }\n            if(\'#parents_check_hash#\'==\'1\'){\n                $sql = \" INSERT INTO ballot_voter (\n                            id,\n                            ballot_id,\n                            student_id,\n                            voted,\n                            voted_at,\n                            is_parent\n                            )\n                        SELECT\n                            NULL,\n                            \'#RECORD_ID#\',\n                            student.id,\n                            0,\n                            NULL,\n                            1\n                        FROM student\n                         WHERE \n                            grade_id IN (#grade_id_select_sumo#) AND\n                            student.id NOT IN (SELECT bv1.student_id FROM ballot_voter AS bv1 WHERE bv1.ballot_id=\'#RECORD_ID#\' AND is_parent=1)\n                \";\n                $t2 = nuRunQuery($sql,NULL,true);\n                calendar_publish(\'1\',\'1\',$publish_id);\n            }\n            if($t1<>-1 && $t2<>-1){$nuParameters = \'\';} else {$nuError = \"Προσοχή: Παρουσιάστηκε σφάλμα κατά την προσθήκη!\";}\n            \n        } else {\n            $nuError = \"Προσοχή: Επιλέξτε πρώτα τάξεις!\";     \n        }    \n    } elseif (\'#selection1#\' == \'2\') {\n        if(\'#class_id_select_sumo#\'!=\'#\'.\'class_id_select_sumo#\' && \'#class_id_select_sumo#\'!=\'\'){\n            if(\'#students_check_hash#\'==\'1\'){\n                $sql = \" INSERT INTO ballot_voter (\n                            id,\n                            ballot_id,\n                            student_id,\n                            voted,\n                            voted_at,\n                            is_parent\n                            )\n                        SELECT DISTINCT\n                            NULL,\n                            \'#RECORD_ID#\',\n                            student_class.student_id,\n                            0,\n                            NULL,\n                            0\n                        FROM student_class\n                        WHERE \n                            student_class.class_id IN (#class_id_select_sumo#) AND\n                            student_class.student_id NOT IN (SELECT bv1.student_id FROM ballot_voter AS bv1 WHERE bv1.ballot_id=\'#RECORD_ID#\' AND is_parent=0)\n                \";\n                $t1 = nuRunQuery($sql,NULL,true);\n                calendar_publish(\'2\',\'0\',$publish_id);\n            }\n            if(\'#parents_check_hash#\'==\'1\'){\n                $sql = \" INSERT INTO ballot_voter (\n                            id,\n                            ballot_id,\n                            student_id,\n                            voted,\n                            voted_at,\n                            is_parent\n                            )\n                        SELECT DISTINCT\n                            NULL,\n                            \'#RECORD_ID#\',\n                            student_class.student_id,\n                            0,\n                            NULL,\n                            1\n                        FROM student_class\n                        WHERE \n                            student_class.class_id IN (#class_id_select_sumo#) AND\n                            student_class.student_id NOT IN (SELECT bv1.student_id FROM ballot_voter AS bv1 WHERE bv1.ballot_id=\'#RECORD_ID#\' AND is_parent=1)\n                \";\n                $t2 = nuRunQuery($sql,NULL,true);\n                calendar_publish(\'2\',\'1\',$publish_id);\n            }\n            if($t1<>-1 && $t2<>-1){$nuParameters = \'\';} else {$nuError = \"Προσοχή: Παρουσιάστηκε σφάλμα κατά την προσθήκη!\";}            \n            \n        } else {\n            $nuError = \"Προσοχή: Επιλέξτε πρώτα τμήματα!\";     \n        }     \n    } elseif (\'#selection1#\' == \'3\') {\n        if(\'#student_id_select_sumo#\'!=\'#\'.\'student_id_select_sumo#\' && \'#student_id_select_sumo#\'!=\'\'){\n            if(\'#students_check_hash#\'==\'1\'){\n            \n                $sql = \" INSERT INTO ballot_voter (\n                            id,\n                            ballot_id,\n                            student_id,\n                            voted,\n                            voted_at,\n                            is_parent\n                            )\n                        SELECT\n                            NULL,\n                            \'#RECORD_ID#\',\n                            student.id,\n                            0,\n                            NULL,\n                            0\n                        FROM student\n                        WHERE \n                            student.id IN (#student_id_select_sumo#) AND\n                            student.id NOT IN (SELECT bv1.student_id FROM ballot_voter AS bv1 WHERE bv1.ballot_id=\'#RECORD_ID#\' AND is_parent=0)\n                \";\n                $t1 = nuRunQuery($sql,NULL,true);\n                calendar_publish(\'3\',\'0\',$publish_id);\n            }\n            if(\'#parents_check_hash#\'==\'1\'){\n                $sql = \" INSERT INTO ballot_voter (\n                            id,\n                            ballot_id,\n                            student_id,\n                            voted,\n                            voted_at,\n                            is_parent\n                            )\n                        SELECT\n                            NULL,\n                            \'#RECORD_ID#\',\n                            student.id,\n                            0,\n                            NULL,\n                            1\n                        FROM student\n                         WHERE \n                            student.id IN (#student_id_select_sumo#) AND\n                            student.id NOT IN (SELECT bv1.student_id FROM ballot_voter AS bv1 WHERE bv1.ballot_id=\'#RECORD_ID#\' AND is_parent=1)\n                \";\n                $t2 = nuRunQuery($sql,NULL,true);\n                calendar_publish(\'3\',\'1\',$publish_id);\n            }\n            if($t1<>-1 && $t2<>-1){$nuParameters = \'\';} else {$nuError = \"Προσοχή: Παρουσιάστηκε σφάλμα κατά την προσθήκη!\";}\n        } else {\n            $nuError = \"Προσοχή: Επιλέξτε πρώτα μαθητές!\";     \n        }\n    }\n    \n                    // Clean up dublicates if any. Δεν είναι και ο καλύτερος τρόπος αλλά για να γίνει σωστά χρειάζονται πάρα πολοί έλεγχοι. \n    $sql = \"DELETE a\n                FROM calendar_event_access as a, calendar_event_access as b\n                WHERE\n                    (a.calendar_event_id = b.calendar_event_id) AND\n                    (a.teacher_id = b.teacher_id OR (a.teacher_id IS NULL AND b.teacher_id IS NULL)) AND\n                    (a.student_id = b.student_id OR (a.student_id IS NULL AND b.student_id IS NULL)) AND    \n                    (a.grade_id = b.grade_id OR (a.grade_id IS NULL AND b.grade_id IS NULL)) AND\n                    (a.class_id = b.class_id OR (a.class_id IS NULL AND b.class_id IS NULL)) AND\n                    (a.user_group_id = b.user_group_id OR (a.user_group_id IS NULL AND b.user_group_id IS NULL)) AND\n                    a.id > b.id\";\n    nuRunQuery($sql);\n    \n    if(\'#create_notification#\'==\'1\'){\n        $sql =\"SELECT id FROM calendar_event_access WHERE publish_id=\'$publish_id\' AND user_group_id IN (\'547de4c65675a29\',\'5717ba3eb32c252\')\";\n        $rv = nuRunQuery($sql);\n        while($r = db_fetch_row($rv)){\n            calendar_event_notification($r[0],7);\n        }\n    }\n    \n} else {\n    $nuError = \"Προσοχή: Αυτή δεν είναι μια έγκυρη επιλογή!\";    \n}\n','','0','2017-10-24 01:15:34','globeadmin','2017-11-03 22:17:01','globeadmin','2017-11-25 13:16:39','globeadmin','0'),('59f2469383bbd98','ballot_google_chart','Δημιουργεί γράφημα με την προσέλευση σε μια ψηφοφορία','Teacher','//ob_start();\n//print \'hi\';\n\n$cur_datetime = date(\'Y-m-d H:i:s\');\n$start_datetime = \'#start_date# #start_time#\';\n$end_datetime = \'#end_date# #end_time#\';\n\n$start = strtotime($start_datetime);\n$end1 = strtotime($end_datetime);\n$numb_of_samples = 100;\n\n$interval = ceil(($end1-$start)/$numb_of_samples); \n$chunks = array();\n\nfor($time=$start; $time<=$end1; $time+=$interval){\n    $chunks[] = date(\'Y-m-d H:i:s\', $time);\n}\nif($time>$end1){\n    $chunks[] = date(\'Y-m-d H:i:s\', $end1);    \n}\n\nif($cur_datetime>=$start_datetime){\n\n    $total_voters               = 0;\n    $total_voters_parent        = 0;\n    $total_voters_student       = 0;\n\n    $sql = \"SELECT \n        count(*),\n        ifNULL(sum(if(is_parent=\'0\',1,0)),0),\n        ifNULL(sum(if(is_parent=\'0\',0,1)),0)\n    FROM ballot_voter \n    WHERE ballot_id=\'#RECORD_ID#\'\";\n    $retval = nuRunQuery($sql);\n    if($row=db_fetch_row($retval)){\n        $total_voters           = $row[0];\n        $total_voters_parent    = $row[2];\n        $total_voters_student   = $row[1];\n    }\n\n    if($total_voters>0){\n    \n        $numb_of_rows = ($total_voters_parent==0 || $total_voters_student==0 ? 2 : 4 );\n        \n        $chart_data   = array();\n\n        foreach ($chunks as $chunk) {\n        //find data\n            if($chunk<=$cur_datetime){\n                $d = date(\'d/m H:i:s\',strtotime($chunk));\n                $total_voted                = 0;\n                $total_voted_parent         = 0;\n                $total_voted_student        = 0;\n        \n                $sql = \"SELECT \n                    count(*),\n                    ifNULL(sum(if(is_parent=\'0\',1,0)),0),\n                    ifNULL(sum(if(is_parent=\'0\',0,1)),0)\n                FROM ballot_voter \n                WHERE \n	                ballot_id=\'#RECORD_ID#\' and \n	                voted=1 and\n	                voted_at <=\'$chunk\'\n	                \";\n                $retval = nuRunQuery($sql);\n                if($row=db_fetch_row($retval)){\n                    $total_voted            = $row[0];\n                    $total_voted_parent     = $row[2];\n                    $total_voted_student    = $row[1];\n                }\n        \n                $chart_data[] = ($numb_of_rows==2 ?\n                    \"[\\\"$d\\\",$total_voted,$total_voters]\" : \n                    \"[\\\"$d\\\",$total_voted,$total_voted_student,$total_voted_parent,$total_voters,$total_voters_student,$total_voters_parent]\");\n            }\n        }\n    \n        $js_string = implode(\',\', $chart_data);\n\n        $gg = \"\n<html>\n  <head>\n    <script type=\'text/javascript\' src=\'https://www.google.com/jsapi\'></script>\n    <script type=\'text/javascript\'>\n	\n	google.load(\'visualization\', \'1\', {packages: [\'corechart\', \'line\']});\n	google.setOnLoadCallback(drawAxisTickColors);\n	\n	function drawAxisTickColors() {\n        \n      \n	  var data = new google.visualization.DataTable();\n      data.addColumn(\'string\', \'X\');\n      \".\n      ($numb_of_rows==4 ?\n      \"data.addColumn(\'number\', \'\\u03A8\\u03AE\\u03C6\\u03B7\\u03C3\\u03B1\\u03BD\');\n      data.addColumn(\'number\', \'\\u039C\\u03B1\\u03B8\\u03B7\\u03C4\\u03AD\\u03C2\');\n	  data.addColumn(\'number\', \'\\u0393\\u03BF\\u03BD\\u03B5\\u03AF\\u03C2\');\n	  data.addColumn(\'number\', \'\\u03A3\\u03CD\\u03BD\\u03BF\\u03BB\\u03BF \\u03A8\\u03B7\\u03C6\\u03BF\\u03C6\\u03CC\\u03C1\\u03C9\\u03BD\');\n	  data.addColumn(\'number\', \'\\u03A3\\u03CD\\u03BD\\u03BF\\u03BB\\u03BF \\u039C\\u03B1\\u03B8\\u03B7\\u03C4\\u03CE\\u03BD\');\n      data.addColumn(\'number\', \'\\u03A3\\u03CD\\u03BD\\u03BF\\u03BB\\u03BF \\u0393\\u03BF\\u03BD\\u03AD\\u03C9\\u03BD\');\" :\n      \"data.addColumn(\'number\', \'\\u03A8\\u03AE\\u03C6\\u03B7\\u03C3\\u03B1\\u03BD\');\n	  data.addColumn(\'number\', \'\\u03A3\\u03CD\\u03BD\\u03BF\\u03BB\\u03BF \\u03A8\\u03B7\\u03C6\\u03BF\\u03C6\\u03CC\\u03C1\\u03C9\\u03BD\');\").\n      \"\n      data.addRows([\n      \n        \".$js_string.\" \n        \n      ]);\n\n      var options = {\n        hAxis: {\n          title: \'\',\n          textStyle: {\n            color: \'#01579b\',\n            fontSize: 14,\n            bold: true,\n            italic: true\n          },\n          titleTextStyle: {\n            color: \'#01579b\',\n            fontSize: 14,\n            bold: true,\n            italic: true\n          }\n        },\n        vAxis: {\n          title: \'\',\n          textStyle: {\n            color: \'#1a237e\',\n            fontSize: 14,\n            bold: true\n          },\n          titleTextStyle: {\n            color: \'#1a237e\',\n            fontSize: 14,\n            bold: true \n          }\n        },\n        \".($numb_of_rows==4 ? \"colors: [\'00FF00\', \'ffb833\',\'#FF00FF\',\'#009900\',\'#e69500\',\'#990099\'],\" : \"colors: [\'00FF00\',\'#009900\'],\").\"\n        backgroundColor: \'#FAF0E6\',\n        lineWidth: 2,\n        \".($numb_of_rows==4 ? \n        \"series: {\n            3: { lineDashStyle: [4, 4] },\n            4: { lineDashStyle: [4, 4] },\n            5: { lineDashStyle: [4, 4] }\n          }\" : \n        \"series: {\n            1: { lineDashStyle: [4, 4] }\n          }\").\"\n      };\n      var chart = new google.visualization.LineChart(document.getElementById(\'chart_div\'));\n      chart.draw(data, options);\n      }\n    </script>\n  </head>\n  <body>\n    <div id=\'chart_div\' style=\'width: 940px; height: 450px;\'></div>\n  </body>\n</html>\n\";\n        echo $gg;\n    } else{\n        print \"\n<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n    </head>\n    <body>\n        <span CLASS=\\\"msg\\\">Δεν υπάρχουν ψηφοφόροι για την ψηφοφορία αυτή!</span>\n    </body>\n</html>\";          \n    }       \n} else{\n        print \"\n<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n    </head>\n    <body>\n        <span CLASS=\\\"msg\\\" style=\\\"color:orange;\\\">Η κάλπη δεν έχει ανοίξει ακόμη!</span>\n    </body>\n</html>\"; \n}\n\n//ob_end_clean();\n','','0','2017-10-26 23:33:23','globeadmin','2021-03-24 11:36:00','globeadmin','2021-03-24 11:36:00','globeadmin','0'),('59f4d865bbf74c4','show_ballot_choices','Εμφανίζει τους υποψήφιους/επιλογές μιας ψηφοφορίας','Teacher','print \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n        \n        <script src=\\\"jquery/jquery-1.8.3.js\\\" type=\'text/javascript\'></script>\n        <script src=\\\"jquery/jquery-ui.js\\\" type=\'text/javascript\'></script>\n        <style>\n            .sisTableLine TR{\n	            background-color: LightSkyBlue;\n            }        \n        </style>\n\n        <script type=\\\"text/javascript\\\">\n\n            function ol(){\n                $(\'#stable tbody\').sortable();\n                $(\'#stable img.move\').click(function() {\n                    var row = $(this).closest(\'tr\');\n                    if ($(this).hasClass(\'up\'))\n                        row.prev().before(row);\n                    else\n                        row.next().after(row);\n                });\n    \n                adjustIframeHeight();\n            }\n\n            function reorder_choices(){\n                if(confirm(\'Οι υποψηφιότητες θα ταξινομηθούν αλφαβητικά!\\\\n Είστε σίγουρος;\')){\n                    parent.nuAjax(\'reorder_ballot_choices\',\'reorder_choices_result\');\n                }\n            }\n\n            function remove_selected(){\n                var c1 = document.getElementsByClassName(\'chk_1\');\n                var id_array = [];\n    \n                for(var i=0, n=c1.length;i<n;i++) {\n                    if(c1[i].checked){\n                        id_array.push(c1[i].id.substr(2));\n                    }\n                }\n    \n                var id_list = id_array.join(\',\');\n    \n                if(id_list !=\'\'){\n                    if(confirm(\'Θα αφαιρέσετε τις επιλεγμένες υποψηφιότητες!\\\\n Είστε σίγουρος;\')){\n                        parent.nuSetHash(\'id_list\', id_list);\n                        parent.nuAjax(\'delete_ballot_choices\',\'delete_choices_result\');\n                    }\n                } else {\n                    alert(\'Παρακαλώ επιλέξτε πρώτα τις υποψηφιότητες που θέλετε να αφαιρέσετε!\');    \n                }  \n            }\n\n            function show_ballot_choice_info(ballot_choice_id){\n                parent.nuOpenFormInFrame(\'59f607fc7a2c0b2\',ballot_choice_id);\n            }\n        </script>\n    </head>\n\n    <body onload=\\\"ol();\\\">\";\n\n$sql = \"    SELECT COUNT(*)\n            FROM ballot_paper\n            WHERE ballot_id = \'#RECORD_ID#\'\n        \";\n$retval = nuRunQuery($sql);\nif(db_num_rows($retval)>0){\n    $row    = db_fetch_row($retval);\n    $papers = $row[0];   \n} else {\n    $papers = 0;\n}\n\n$sql=\"  SELECT\n            ifNULL(ballot_choice.id,\'\'),\n            ballot_choice.name,\n            if(ballot_choice.description is NULL OR trim(ballot_choice.description)=\'\',\'0\',\'1\'),\n            if(ballot_choice.student_id is NULL,\'0\',\'1\'),\n            if(student.id IS NULL,\'\',CONCAT(student.registration_number,\'-\',student.surname,\' \',student.name,\' \',IF(student.fathers_name IS NULL,\'\',CONCAT(\' πατ. \',student.fathers_name)))),\n            if(student.id IS NULL,\'\',student.gender),\n            if(((\'#nu_user_group#\' IN (\'globeadmin\',\'Managers\',\'AssistManagers\',\'Administrators\')) OR \'#teacher_id#\'=session_variables.teacher_id) AND \'#nu_new_record#\'=\'0\' AND \'$papers\'=\'0\',\'1\',\'0\')\n        FROM session_variables\n        LEFT JOIN ballot_choice ON ballot_choice.ballot_id=\'#RECORD_ID#\'\n        LEFT JOIN student ON student.id = ballot_choice.student_id\n        WHERE\n            session_variables.session_id=\'#session_id#\'    \n        ORDER BY    \n            ballot_choice.hierarchy,ballot_choice.name\n            \n\";\n$retval=nuRunQuery($sql);\n\nif($retval) {\n    if(db_num_rows($retval)>0) {\n        $row = db_fetch_row($retval);\n        \n        if($row[6]==\'1\'){\n            print (\"\n        <table width=900 CLASS=\\\"sisTableLine\\\" cellspacing=0 align=center>\n            <tr height=40 style=\\\"background-color: transparent;\\\">\n                <td style=\\\"padding-right:28px\\\" align=right><img width=20 height=20 title=\\\"Προσθήκη Νέας Επιλογής\\\" src=\\\"images/add.png\\\" onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\" onclick=\\\"show_ballot_choice_info(-1)\\\"></td>\n                <td width=80 align=center><img width=20 height=20 title=\\\"Διαγραφή Επιλεγμένων\\\" src=\\\"images/d.png\\\" onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\" onclick=\\\"remove_selected()\\\"></td>\n            </tr>\n        </table>\");\n        }\n        if($row[0]!=\'\'){\n            print (\"\n        <table width=900 cellspacing=0 CLASS=\\\"sisTableLine\\\" align=center>\n            <tr height=30>\n                <th align=center>Υποψηφιότητες/Επιλογές</th>\n        \");\n            if($row[6]==\'1\'){\n                print (\"\n                <th align=center width=40><img title=\\\"Αλφαβητική Ταξινόμιση\\\" src=\\\"images/down.png\\\" width=18 height=18 onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\" onclick=\\\"reorder_choices()\\\"></th>\n                <th width=80 align=center>\n                    <b>Επιλογή</b><br>\n                    Όλα<input type=\\\"checkbox\\\" id=\\\"all_chk_1\\\" title=\\\"Όλα\\\" onclick=\\\"toggle(this,\'chk_1\')\\\">\n                </th>\n            \");\n        }\n            print (\"\n            </tr>\n        </table>\n        \n        <table id=\\\"stable\\\" width=900 cellspacing=0 CLASS=\\\"sisTableLine\\\" align=center>\");\n            $i=0;\n            while($row) {\n                $i++;\n                print (\"\n            <tr height=30>\n                <td id=\\\"\".$row[0].\"\\\" hierarchy=\\\"$i\\\" class=\\\"choices\\\" align=left title=\\\"Πληροφορίες/Επεξεργασία\\\" onclick=\\\"show_ballot_choice_info(\".$row[0].\")\\\" onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\">\".\n                ( $row[3]==\'1\'? \"<img src=\\\"images/\".($row[5]==\'Α\' ? \"boy\" : \"girl\").\".png\\\" width=20 height=20 title=\\\"\".$row[4].\"\\\">&nbsp;\" : \"\").\n                (is_null($row[1]) || $row[1]==\'\'? \'&nbsp;\' : $row[1]).\n                ($row[2]==\'1\'? \"&nbsp;<img src=\\\"images/note2.png\\\" title=\\\"Υπάρχει περιγραφή για την υποψηφιότητα\\\" width=18 height=18>\" : \"\").\n                \"</td>\n                \");\n                if($row[6]==\'1\'){\n                    print (\"                \n                <td width=40 align=center><img title=\\\"Μετακίνηση Επάνω\\\" class=\\\"move up\\\" src=\\\"images/up.png\\\" width=18 height=18 onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\"></td>\n                <td width=80 align=center><input type=\\\"checkbox\\\" CLASS=\\\"chk_1\\\" id=\\\"c_\".$row[0].\"\\\" title=\\\"Επιλογή Μαθητή\\\" onclick=\\\"make_indeterminate(\'all_chk_1\')\\\"></td>\n            </tr>\");\n                }\n                $row = db_fetch_row($retval);\n            }\n            print (\"\n        </table>\");\n        }\n    } else {\n        print (\"<span CLASS=\\\"msg\\\">Δε βρέθηκαν υποψήφιοι για την ψηφοφορία!</span>\");\n    }\n} else{\n    print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν δεδομένα...</span>\");\n}\nprint \"\n    </body>\n</html>\";\n','','0','2017-10-28 22:20:05','globeadmin','2018-07-16 10:53:30','globeadmin','2018-07-16 10:53:30','globeadmin','0'),('59f5e72d606d247','delete_ballot_choices','Διαγράφει επιλεγμένους υποψηφίους σε μια ψηφοφορία','Teachers','nuRunPHP(\'notification_add_lib\');\n\n$nuParameters = \'\';\n$sql = \"    SELECT COUNT(*)\n            FROM ballot_paper\n            WHERE ballot_id = \'#RECORD_ID#\'\n        \";\n$retval = nuRunQuery($sql);\n$row    = db_fetch_row($retval);\n$papers = $row[0];\n\nif($papers==0){\n\n    if(\'#id_list#\'!=\'#\'.\'id_list#\' && \'#id_list#\'!=\'\'){\n    \n        if(\'#create_notification#\'==\'1\'){\n            $sql = \"SELECT calendar_event_access.id \n            FROM calendar_event_access \n            WHERE \n                calendar_event_id = \'#calendar_event_id#\' AND\n                student_id IN (SELECT student_id FROM ballot_choice WHERE id IN (#id_list#) AND ballot_id=\'#RECORD_ID#\' AND student_id IS NOT NULL) AND\n                student_id NOT IN (SELECT student_id FROM ballot_voter WHERE ballot_id=\'#RECORD_ID#\' AND is_parent=0 AND student_id IS NOT NULL) AND\n                user_group_id = \'547de4c65675a29\'\n            \";\n            $retval = nuRunQuery($sql);\n            while($row=db_fetch_row($retval)){\n                calendar_event_notification($row[0],9);\n            }\n        }\n        \n        $sql = \"DELETE \n            FROM calendar_event_access \n            WHERE \n                calendar_event_id = \'#calendar_event_id#\' AND\n                student_id IN (SELECT student_id FROM ballot_choice WHERE id IN (#id_list#) AND ballot_id=\'#RECORD_ID#\' AND student_id IS NOT NULL) AND\n                student_id NOT IN (SELECT student_id FROM ballot_voter WHERE ballot_id=\'#RECORD_ID#\' AND is_parent=0  AND student_id IS NOT NULL) AND\n                user_group_id = \'547de4c65675a29\'\n            \";\n        nuRunQuery($sql);\n    \n    \n    \n        if(\'#create_notification#\'==\'1\'){\n            $sql = \"SELECT calendar_event_access.id \n            FROM calendar_event_access \n            WHERE \n                calendar_event_id = \'#calendar_event_id#\' AND\n                student_id IN (SELECT student_id FROM ballot_choice WHERE id IN (#id_list#) AND ballot_id=\'#RECORD_ID#\' AND student_id IS NOT NULL) AND\n                student_id NOT IN (SELECT student_id FROM ballot_voter WHERE ballot_id=\'#RECORD_ID#\' AND is_parent=1 AND student_id IS NOT NULL) AND\n                user_group_id = \'5717ba3eb32c252\'\n            \";\n            $retval = nuRunQuery($sql);\n            while($row=db_fetch_row($retval)){\n                calendar_event_notification($row[0],9);\n            }\n        }\n        \n        $sql = \"DELETE \n            FROM calendar_event_access \n            WHERE \n                calendar_event_id = \'#calendar_event_id#\' AND\n                student_id IN (SELECT student_id FROM ballot_choice WHERE id IN (#id_list#) AND ballot_id=\'#RECORD_ID#\' AND student_id IS NOT NULL) AND\n                student_id NOT IN (SELECT student_id FROM ballot_voter WHERE ballot_id=\'#RECORD_ID#\' AND is_parent=1 AND student_id IS NOT NULL) AND\n                user_group_id = \'5717ba3eb32c252\'\n            \";\n        nuRunQuery($sql);\n    \n    \n        $sql=\"DELETE FROM ballot_choice WHERE id IN (#id_list#) AND ballot_id=\'#RECORD_ID#\'\";\n        nuRunQuery($sql);\n        $nuParameters = \'OK\';\n    }\n} else {\n    $nuError = \'Προσοχή! Έχουν ήδη καταχωρηθεί ψήφοι! Δεν μπορείτε να αφαιρέσετε υποψήφιους\';    \n}','','0','2017-10-29 16:35:25','globeadmin','2017-11-04 13:47:18','globeadmin','2017-11-04 13:48:46','globeadmin','0'),('59f5e965a0dd38c','reorder_ballot_choices','Ταξινομεί τους υποψηφίους σε μια ψηφοφορία αλφαβητικά','Teachers','$nuParameters = \'\';\n$sql = \"    SELECT COUNT(*)\n            FROM ballot_paper\n            WHERE ballot_id = \'#RECORD_ID#\'\n        \";\n$retval = nuRunQuery($sql);\n$row    = db_fetch_row($retval);\n$papers = $row[0];\n\nif($papers==0){\n    $sql=\"UPDATE ballot_choice SET hierarchy=0 WHERE ballot_id=\'#RECORD_ID#\'\";\n    nuRunQuery($sql);\n} else {\n    $nuError = \'Προσοχή! Έχουν ήδη καταχωρηθεί ψήφοι! Δεν μπορείτε να αλλάξετε τη σειρά των υποψηφίων\';\n}\n','','0','2017-10-29 16:44:53','globeadmin','2017-11-02 08:34:40','globeadmin','2017-11-04 13:49:58','globeadmin','0'),('59f840c19a6f621','delete_card','Διαγράφει μια Διδασκαλία από το πρόγραμμα','Manager','if(date(\"Y-m-d\")<\'#valid_from#\'){\n    $sql=\"DELETE FROM card WHERE id=\'#RECORD_ID#\'\";\n    nuRunQuery($sql);\n} else {\n    $nuError = \"Προσοχή : Δεν μπορείτε να σβήσετε διδασκαλίες από πρόγραμμα που έχει τεθεί σε ισχύ!\";  \n}\n','','0','2017-10-31 11:22:09','globeadmin','2017-10-31 11:27:40','globeadmin','2017-10-31 11:30:27','globeadmin','0'),('59f84dae26c5aa0','create_student_class_list','Δημιουργεί τη λίστα των μαθητών ενός τμήματος','manager','print \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n    \n        <STYLE TYPE=\\\"text/css\\\">\n            .sisTable TH{\n                font-size:110%;\n            }\n        </STYLE>\n\n    </head>\n<body onload=\\\"adjustIframeHeight()\\\">\";\n\n\n$sql=\"  SELECT \n            student_class.new_id,\n            grade.short_name,\n            student.registration_number,\n            student.surname,\n            student.name,\n            student.fathers_name,\n            student.has_left_school\n        FROM student\n        INNER JOIN grade on grade.id=student.grade_id\n        INNER JOIN student_class on student_class.student_id=student.id\n        WHERE student_class.class_id=\'#RECORD_ID#\'\n        ORDER BY student.grade_id,student.surname,student.name,student.fathers_name\n        \";\n\n$retval = nuRunQuery($sql);\n\nif($retval) {\n    if(db_num_rows($retval)>0) {\n    \n        print (\"\n        <table cellspacing=0 CLASS=\\\"sisTable\\\" align=center width=860>\n            <tr height=40>\n                <th width=50 align=center>Τάξη</th>\n                <th width=60 align=center>Α.Μ.</th>\n                <th width=270 align=center>Επώνυμο</th>\n                <th width=180 align=center>Όνομα</th>\n                <th width=180 align=center>Πατρώνυμο</th>\n                <th width=110 align=center>\n                    Επιλογή<br>\n                    Όλοι<input type=\\\"checkbox\\\" id=\\\"all_chk_1\\\" title=\\\"Επιλογή Όλων\\\" onclick=\\\"toggle(this,\'chk_1\')\\\">\n                </th>\n            </tr>\");\n        $i=0;\n        $j=0;\n        while($row = db_fetch_row($retval)) {\n            $i++;\n            $j = ($row[6]==1 ? $j+1 : $j);\n            print (\"\n            <tr \".($row[6]==1 ? \" style=\\\"background-color:#ff6666;\\\"\" : \"\").\" height=28>\n                <td align=center>\".(is_null($row[1]) || $row[1]==\'\'? \'&nbsp;\' : $row[1]).\"</td>\n                <td align=center>\".(is_null($row[2]) || $row[2]==\'\'? \'&nbsp;\' : $row[2]).\"</td>\n                <td align=left>\".(is_null($row[3]) || $row[3]==\'\'? \'&nbsp;\' : $row[3]).\"</td>\n                <td align=left>\".(is_null($row[4]) || $row[4]==\'\'? \'&nbsp;\' : $row[4]).\"</td>\n                <td align=left>\".(is_null($row[5]) || $row[5]==\'\'? \'&nbsp;\' : $row[5]).\"</td>\n                <td align=center><input type=\\\"checkbox\\\" CLASS=\\\"chk_1\\\" id=\\\"\".$row[0].\"\\\" title=\\\"Επιλογή Μαθητή\\\" onclick=\\\"make_indeterminate(\'all_chk_1\')\\\"></td>\n            </tr>\");\n        }\n        \n        print (\"\n            <tr height=30>\n                <th width=50 align=right colspan=5>Μαθητές που φοιτούν :&nbsp;</th>\n                <th>\".($i-$j).\"</th>\n            </tr>\n            <tr height=30>\n                <th width=50 align=right colspan=5>Μαθητές που έχουν εγκαταλείψει το Σχολείο :&nbsp;</th>\n                <th>$j</th>\n            </tr>\n            <tr height=30>\n                <th width=50 align=right colspan=5>Συνολικός αριθμός μαθητών :&nbsp;</th>\n                <th>$i</th>\n            </tr>\n            \n            \");\n        print (\"\n        </table>\");\n    } else{\n        print (\"<span CLASS=\\\"msg\\\">Δε βρέθηκαν Μαθητές...</span>\");\n    }\n} else{\n    print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν δεδομένα...</span>\");\n}\nprint \"\n    </body>\n</html>\";\n','','0','2017-10-31 12:17:18','globeadmin','2018-07-15 00:38:00','globeadmin','2018-07-15 00:38:00','globeadmin','0'),('59f878b4b35c111','add_students_to_class','Προσθέτει τους επιλεγμένους μαθητές σε ένα τμήμα','Manager','$nuParameters = \'\';\nif(\'#student_id_select_sumo#\'!=\'#\'.\'student_id_select_sumo#\' && \'#student_id_select_sumo#\'!=\'\'){\n\n    $sql = \"    SELECT count(*) \n                FROM student_class \n                WHERE \n                    student_id IN (#student_id_select_sumo#) and\n                    class_id = \'#RECORD_ID#\'\n            \";\n    $retval = nuRunQuery($sql);\n    $row=db_fetch_row($retval);\n    $exists = $row[0];\n\n    $sql = \"    SELECT count(*) \n                FROM student \n                WHERE \n                    student.id IN (#student_id_select_sumo#) AND\n                    student.id NOT IN (SELECT student_id from student_class WHERE class_id = \'#RECORD_ID#\')\n            \";\n    $retval = nuRunQuery($sql);\n    $row=db_fetch_row($retval);\n    $not_exists = $row[0];\n    \n    $sql = \"    INSERT INTO student_class (\n                    new_id,\n                    class_id,\n                    student_id) \n                SELECT \n                    NULL,\n                    \'#RECORD_ID#\',\n                    student.id \n                FROM student \n                WHERE \n                    student.id IN (#student_id_select_sumo#) AND\n                    student.id NOT IN (SELECT student_class.student_id from student_class WHERE student_class.class_id = \'#RECORD_ID#\')\";\n    nuRunQuery($sql);\n        \n    if($not_exists>0) {$nuParameters=\"Εισήχθησαν $not_exists μαθητές στο τμήμα!\";}\n    if($exists>0) {$nuParameters=$nuParameters.\"\\nΔεν εισήχθησαν $exists μαθητές γιατί υπάρχουν ήδη στο τμήμα!\";}\n\n} else {\n    $nuError = \"Παρακαλώ επιλέξτε πρώτα τους Μαθητές!\";    \n}','','0','2017-10-31 15:20:52','globeadmin','2017-10-31 16:36:42','globeadmin','2017-10-31 16:36:42','globeadmin','0'),('59f88affdd8e424','remove_students_from_class','Διαγράφει επιλεγμένους μαθητές από ένα τμήμα','Manager','$nuParameters = \'\';\n\nif(\'#id_list#\'!=\'#\'.\'id_list#\' && \'#id_list#\'!=\'\'){\n    $sql=\"DELETE FROM student_class WHERE new_id IN (#id_list#) AND class_id=\'#RECORD_ID#\'\";\n    nuRunQuery($sql);\n    $nuParameters = \'OK\';\n}','','0','2017-10-31 16:38:55','globeadmin','2017-10-31 16:43:30','globeadmin','2017-10-31 16:43:30','globeadmin','0'),('59fe057de3b97b4','create_ballot_email_list','Δημιουργεί τη λίστα των μαθητών που συμμετέχουν σε ψηφοφορία με τα email τους','teacher','print \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n\n        <script type=\\\"text/javascript\\\">\n\n            function make_indeterminate(chk_name1,chk_name2) {\n                var all_chk1 = document.getElementById(chk_name1);\n                all_chk1.indeterminate = true;\n    \n                var all_chk2 = document.getElementById(chk_name2);\n                all_chk2.indeterminate = true;\n            }\n\n        </script>\n    </head>\n    <body onload=\\\"adjustIframeHeight()\\\">\";\n\n$sql=\"  (SELECT distinct\n            student.id,\n            grade.short_name,\n            concat(\n                student.registration_number,\n                \' -\',\n                if(student.surname is NULL,\'\',concat (\' \',student.surname)),\n                if(student.name is NULL,\'\',concat (\' \',student.name)),\n                if(student.fathers_name is NULL,\'\',concat (\'<br>πατ. \',student.fathers_name))\n            ),\n            TRIM(student.email),\n            TRIM(student.parent_email),\n            student.has_left_school,\n            0\n        FROM student\n        INNER JOIN grade on grade.id=student.grade_id\n        INNER JOIN session_variables ON session_id=\'#session_id#\'\n        INNER JOIN ballot_choice ON student.id = ballot_choice.student_id\n        WHERE \n            ballot_choice.ballot_id = session_variables.ballot_id\n        ORDER BY ballot_choice.hierarchy,student.surname,student.name,student.fathers_name)\n        UNION\n        (SELECT distinct\n            student.id,\n            grade.short_name,\n            concat(\n                student.registration_number,\n                \' -\',\n                if(student.surname is NULL,\'\',concat (\' \',student.surname)),\n                if(student.name is NULL,\'\',concat (\' \',student.name)),\n                if(student.fathers_name is NULL,\'\',concat (\'<br>πατ. \',student.fathers_name))\n            ),\n            TRIM(student.email),\n            TRIM(student.parent_email),\n            student.has_left_school,\n            1\n        FROM student\n        INNER JOIN grade on grade.id=student.grade_id\n        INNER JOIN session_variables ON session_id=\'#session_id#\'\n        INNER JOIN ballot_voter ON student.id = ballot_voter.student_id\n        WHERE \n            ballot_voter.ballot_id = session_variables.ballot_id\n        ORDER BY student.grade_id,student.surname,student.name,student.fathers_name)\n\";\n$retval = nuRunQuery($sql);\n\nif($retval) {\n    if(db_num_rows($retval)>0) {\n    \n        print (\"\n        <table cellspacing=0 CLASS=\\\"sisTable\\\">\n            <tr height=50>\n            \n                <th width=50 align=center><b>Τάξη</b></th>\n                <th width=300 align=center><b>Μαθητής</b></th>\n                \n                <th width=300 align=center>\n                    <table cellspacing=\\\"0\\\" cellpadding=\\\"0\\\" style=\\\"border: none;\\\" width=100%>\n                        <tr>\n                            <th style=\\\"border: none;\\\" align=center rowspan=3>\n                                <b>Email Μαθητή</b>\n                            </th>\n                            <th align=right style=\\\"border: none;\\\">\n                                Όλα<input type=\\\"checkbox\\\" id=\\\"all_chk_1\\\" title=\\\"Επιλογή Όλων\\\" onclick=\\\"toggle(this,\'chk_1\')\\\">\n                            </th>\n                        </tr>\n                        <tr>\n                            <th colspan=2 align=right style=\\\"border: none;\\\">\n                                Υποψήφιοι<input type=\\\"checkbox\\\" id=\\\"all_choice1\\\" title=\\\"Επιλογή Όλων των Υποψηφίων\\\" onclick=\\\"toggle(this,\'choice1\')\\\">\n                            </th>\n                        </tr>\n                        <tr>\n                            <th colspan=2 align=right style=\\\"border: none;\\\">\n                                Ψηφοφόροι<input type=\\\"checkbox\\\" id=\\\"all_voter1\\\" title=\\\"Επιλογή Όλων των Ψηφοφόρων\\\" onclick=\\\"toggle(this,\'voter1\')\\\">\n                            </th>\n                        </tr>                        \n                    </table>                \n                </th>\n                <th width=300 align=center>\n                    <table cellspacing=\\\"0\\\" cellpadding=\\\"0\\\" style=\\\"border: none;\\\" width=100%>\n                        <tr>\n                            <th style=\\\"border: none;\\\" align=center rowspan=3>\n                                <b>Email Γονέα</b>\n                            </th>\n                            <th align=right style=\\\"border: none;\\\">\n                                Όλα<input type=\\\"checkbox\\\" id=\\\"all_chk_2\\\" title=\\\"Επιλογή Όλων\\\" onclick=\\\"toggle(this,\'chk_2\')\\\">\n                            </th>\n                        </tr>\n                        <tr>\n                            <th colspan=2 align=right style=\\\"border: none;\\\">\n                                Υποψήφιοι<input type=\\\"checkbox\\\" id=\\\"all_choice2\\\" title=\\\"Επιλογή Όλων των Υποψηφίων\\\" onclick=\\\"toggle(this,\'choice2\')\\\">\n                            </th>\n                        </tr>\n                        <tr>\n                            <th colspan=2 align=right style=\\\"border: none;\\\">\n                                Ψηφοφόροι<input type=\\\"checkbox\\\" id=\\\"all_voter2\\\" title=\\\"Επιλογή Όλων των Ψηφοφόρων\\\" onclick=\\\"toggle(this,\'voter2\')\\\">\n                            </th>\n                        </tr>                        \n                    </table>                  \n                </th>\n            </tr>\");\n            \n        while($row = db_fetch_row($retval)) {\n                \n            print (\"            <tr bgcolor=\".($row[6]==1 ? \"LightBlue\" : \"LightSkyBlue\").\" height=35>\n                <td align=center>\".(is_null($row[1]) || $row[1]==\'\'? \'&nbsp;\' : $row[1]).\"</td>\n                <td align=left>\".(is_null($row[2]) || $row[2]==\'\'? \'&nbsp;\' : $row[2]).\"</td>\");\n                \n                if(!is_null($row[3]) && $row[3]!=\'\'){\n                    if(filter_var($row[3], FILTER_VALIDATE_EMAIL)){\n                        print(\"<td align=right>\".$row[3].\"<input type=\\\"checkbox\\\" CLASS=\\\"chk_1 \".($row[6]==\'1\' ? \'voter1\' : \'choice1\').\"\\\" id=\\\"1,\".$row[0].\",\".$row[3].\"\\\" title=\\\"Επιλογή Email\\\" onclick=\\\"make_indeterminate(\'all_chk_1\',\'\".($row[6]==\'1\' ? \'all_voter1\' : \'all_choice1\').\"\');\\\"></td>\");\n                    } else {\n                        print(\"<td bgcolor=Red align=right>\".$row[3].\"</td>\");\n                    }   \n                } else{\n                    print(\"<td>&nbsp;</td>\");    \n                }\n\n                if(!is_null($row[4]) && $row[4]!=\'\'){\n                    if(filter_var($row[4], FILTER_VALIDATE_EMAIL)){\n                        print(\"<td align=right>\".$row[4].\"<input type=\\\"checkbox\\\" CLASS=\\\"chk_2 \".($row[6]==\'1\' ? \'voter2\' : \'choice2\').\"\\\" id=\\\"2,\".$row[0].\",\".$row[4].\"\\\" title=\\\"Επιλογή Email\\\" onclick=\\\"make_indeterminate(\'all_chk_2\',\'\".($row[6]==\'1\' ? \'all_voter2\' : \'all_choice2\').\"\')\\\"></td>\");\n                    } else {\n                        print(\"<td bgcolor=Red align=right>\".$row[4].\"</td>\");\n                    }   \n                } else{\n                    print(\"<td>&nbsp;</td>\");    \n                }\n                \n            print (\"            </tr>\");\n        }\n        \n        print (\"</table>\");\n    } else{\n        print (\"<span CLASS=\\\"msg\\\">Δε βρέθηκαν Μαθητές...</span>\");\n    }\n} else{\n    print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν δεδομένα...</span>\");\n}\nprint \"\n    </body>\n</html>\";\n','','0','2017-11-04 20:22:53','globeadmin','2018-07-16 12:33:24','globeadmin','2021-09-07 20:56:53','globeadmin','0'),('5a084a0d4a2a6e6','check_permission_lib','Ελέγχει αν έχει την άδεια ένας καθηγητής ή μαθητής να δει μια συγκεκριμένη εγγραφή','sisyphos','function check_permission($is_teacher=\'0\'){\n    \n    if(\'#nu_user_group#\'==\'globeadmin\'){return true;}\n    \n    \n    if($is_teacher==\'1\'){\n        $sql=\"SELECT id FROM teacher WHERE user_id=\'#nu_user_id#\'\";    \n    } else {\n        $sql=\"SELECT id FROM student WHERE user_id=\'#nu_user_id#\' OR parent_user_id=\'#nu_user_id#\'\";    \n    }\n    \n    $retval = nuRunQuery($sql);\n    \n    if($retval){\n        if($row = db_fetch_row($retval)){\n            if($row[0]==\'#RECORD_ID#\'){\n                    return true;    \n            }\n        }\n    }\n    \n    return false;    \n}','','0','2017-11-12 15:18:05','globeadmin','2017-11-12 15:40:00','globeadmin','2018-07-28 00:32:40','globeadmin','0'),('5a109cd88f731e7','merge_class','Συγχωνεύει δύο τμήματα σε ένα','Manager','$nuParameters = \'-1\';\n\nif(\'#class_id_1#\'!=\'\' && \'#class_id_1#\'!=\'#\'.\'class_id_1#\' && \'#class_id_2#\'!=\'\' && \'#class_id_2#\'!=\'#\'.\'class_id_2#\'){\n    if(\'#class_id_1#\'!=\'#class_id_2#\'){\n        \n        $sql=\"UPDATE calendar_event SET exam_class_id=\'#class_id_1#\' WHERE exam_class_id=\'#class_id_2#\'\";\n        nuRunQuery($sql);        \n\n        $sql=\"UPDATE calendar_event_access SET class_id=\'#class_id_1#\' WHERE class_id=\'#class_id_2#\'\";\n        nuRunQuery($sql);\n        \n        $sql=\"UPDATE card SET class_id=\'#class_id_1#\' WHERE class_id=\'#class_id_2#\'\";\n        nuRunQuery($sql);\n        \n        $sql=\"UPDATE mark SET class_id=\'#class_id_1#\' WHERE class_id=\'#class_id_2#\'\";\n        nuRunQuery($sql);\n        \n        //*******************************************************\n        \n        $sql = \"DELETE a\n                FROM student_class as a, student_class as b\n                WHERE\n                    a.class_id=\'#class_id_2#\' and\n                    b.class_id=\'#class_id_1#\' and\n                    a.student_id = b.student_id\";\n        nuRunQuery($sql);\n        \n        $sql=\"UPDATE student_class SET class_id=\'#class_id_1#\' WHERE class_id=\'#class_id_2#\'\";\n        nuRunQuery($sql); \n        \n        //*******************************************************\n        \n        $sql=\"DELETE FROM class WHERE id=\'#class_id_2#\'\";\n        nuRunQuery($sql); \n        \n        //*******************************************************\n        $nuParameters = \'\';\n        \n    } else {\n        $nuError = \"Προσοχή: Δεν μπορείτε να συγχωνεύσετε ένα τμήμα με τον εαυτό του!\";    \n    }   \n} else {\n    $nuError = \"Προσοχή: Επιλέξτε πρώτα τα τμήματα!\";    \n}\n\n','','0','2017-11-18 22:49:28','globeadmin','2017-11-26 10:41:16','globeadmin','2017-11-26 10:41:16','globeadmin','0'),('5a109cea54d2823','merge_teacher','Συγχωνεύει δύο καθηγητές σε ένα','Manager','$nuParameters = \'-1\';\n\nif(\'#teacher_id_1#\'!=\'\' && \'#teacher_id_1#\'!=\'#\'.\'teacher_id_1#\' && \'#teacher_id_2#\'!=\'\' && \'#teacher_id_2#\'!=\'#\'.\'teacher_id_2#\'){\n    if(\'#teacher_id_1#\'!=\'#teacher_id_2#\'){\n\n        $sql=\"UPDATE absence SET post_teacher_id=\'#teacher_id_1#\' WHERE post_teacher_id=\'#teacher_id_2#\'\";\n        nuRunQuery($sql);\n        \n        $sql=\"UPDATE absence SET justified_teacher_id=\'#teacher_id_1#\' WHERE justified_teacher_id=\'#teacher_id_2#\'\";\n        nuRunQuery($sql);\n        \n        $sql=\"UPDATE ballot SET teacher_id=\'#teacher_id_1#\' WHERE teacher_id=\'#teacher_id_2#\'\";\n        nuRunQuery($sql);\n        \n        $sql=\"UPDATE calendar_event SET teacher_id=\'#teacher_id_1#\' WHERE teacher_id=\'#teacher_id_2#\'\";\n        nuRunQuery($sql);\n        \n        $sql=\"UPDATE calendar_event_access SET teacher_id=\'#teacher_id_1#\' WHERE teacher_id=\'#teacher_id_2#\'\";\n        nuRunQuery($sql);\n        \n        $sql=\"UPDATE card SET teacher_id=\'#teacher_id_1#\' WHERE teacher_id=\'#teacher_id_2#\'\";\n        nuRunQuery($sql);\n        \n        $sql=\"UPDATE class SET post_teacher_id=\'#teacher_id_1#\' WHERE post_teacher_id=\'#teacher_id_2#\'\";\n        nuRunQuery($sql);\n        \n        $sql=\"UPDATE comment SET post_teacher_id=\'#teacher_id_1#\' WHERE post_teacher_id=\'#teacher_id_2#\'\";\n        nuRunQuery($sql);\n        \n        $sql=\"UPDATE critirion_general SET teacher_id=\'#teacher_id_1#\' WHERE teacher_id=\'#teacher_id_2#\'\";\n        nuRunQuery($sql);\n        \n        $sql=\"UPDATE email SET teacher_id=\'#teacher_id_1#\' WHERE teacher_id=\'#teacher_id_2#\'\";\n        nuRunQuery($sql);\n        \n        $sql=\"UPDATE justification_request SET post_teacher_id=\'#teacher_id_1#\' WHERE post_teacher_id=\'#teacher_id_2#\'\";\n        nuRunQuery($sql);\n        \n        $sql=\"UPDATE justification_request SET proceeded_teacher_id=\'#teacher_id_1#\' WHERE proceeded_teacher_id=\'#teacher_id_2#\'\";\n        nuRunQuery($sql);\n        \n        $sql=\"UPDATE mark SET post_teacher_id=\'#teacher_id_1#\' WHERE post_teacher_id=\'#teacher_id_2#\'\";\n        nuRunQuery($sql);\n        \n        $sql=\"UPDATE penalty SET teacher_id=\'#teacher_id_1#\' WHERE teacher_id=\'#teacher_id_2#\'\";\n        nuRunQuery($sql);\n        \n        $sql=\"UPDATE penalty SET post_teacher_id=\'#teacher_id_1#\' WHERE post_teacher_id=\'#teacher_id_2#\'\";\n        nuRunQuery($sql);\n        \n        $sql=\"UPDATE registered_card SET teacher_id=\'#teacher_id_1#\' WHERE teacher_id=\'#teacher_id_2#\'\";\n        nuRunQuery($sql);\n        \n        $sql=\"UPDATE sms SET teacher_id=\'#teacher_id_1#\' WHERE teacher_id=\'#teacher_id_2#\'\";\n        nuRunQuery($sql);\n        \n        $sql=\"UPDATE student SET teacher_id=\'#teacher_id_1#\' WHERE teacher_id=\'#teacher_id_2#\'\";\n        nuRunQuery($sql);\n        \n        $sql=\"UPDATE student SET advisor_id=\'#teacher_id_1#\' WHERE advisor_id=\'#teacher_id_2#\'\";\n        nuRunQuery($sql);\n        \n        $sql=\"UPDATE teacher_student SET teacher_id=\'#teacher_id_1#\' WHERE teacher_id=\'#teacher_id_2#\'\";\n        nuRunQuery($sql);\n        \n        //*******************************************************\n        $sql=\"  DELETE zzzsys_user\n                FROM zzzsys_user\n                INNER JOIN teacher ON teacher.user_id = zzzsys_user.zzzsys_user_id\n                WHERE teacher.id = \'#teacher_id_2#\'\";\n                \n        nuRunQuery($sql);\n        \n        $sql=\"DELETE FROM teacher WHERE id=\'#teacher_id_2#\'\";\n        nuRunQuery($sql); \n        \n        //*******************************************************\n        $nuParameters = \'\';\n        \n    } else {\n        $nuError = \"Προσοχή: Δεν μπορείτε να συγχωνεύσετε ένα καθηγητή με τον εαυτό του!\";    \n    }   \n} else {\n    $nuError = \"Προσοχή: Επιλέξτε πρώτα τους καθηγητές!\";    \n}\n\n','','0','2017-11-18 22:49:46','globeadmin','2017-11-26 12:08:27','globeadmin','2017-11-26 12:08:27','globeadmin','0'),('5a109cfa4fed6f9','merge_subject','Συγχωνεύει δύο μαθήματα σε ένα','Manager','$nuParameters = \'-1\';\n\nif(\'#subject_id_1#\'!=\'\' && \'#subject_id_1#\'!=\'#\'.\'subject_id_1#\' && \'#subject_id_2#\'!=\'\' && \'#subject_id_2#\'!=\'#\'.\'subject_id_2#\'){\n    if(\'#subject_id_1#\'!=\'#subject_id_2#\'){\n        \n        $sql = \"    SELECT student_id,grading_period_id\n                    FROM mark\n                    WHERE subject_id=\'#subject_id_1#\' OR subject_id=\'#subject_id_2#\'\n                    GROUP BY student_id,grading_period_id\n                    HAVING COUNT(student_id)>1\n                    \";\n        $retval = nuRunQuery($sql);\n        \n        if(db_num_rows($retval)==0){\n            $sql=\"UPDATE card SET subject_id=\'#subject_id_1#\' WHERE subject_id=\'#subject_id_2#\'\";\n            nuRunQuery($sql); \n        \n            //Ίσως υπάρξει πρόβλημα με τις ιδιότητες του συμβάντος\n            $sql=\"UPDATE calendar_event SET exam_subject_id=\'#subject_id_1#\' WHERE exam_subject_id=\'#subject_id_2#\'\";\n            nuRunQuery($sql);        \n        \n            $sql=\"UPDATE mark SET subject_id=\'#subject_id_1#\' WHERE subject_id=\'#subject_id_2#\'\";\n            nuRunQuery($sql);\n        \n        \n            //*******************************************************\n            \n            $sql=\"DELETE FROM subject_critirion_general WHERE subject_id=\'#subject_id_2#\'\";\n            nuRunQuery($sql);\n            \n            $sql=\"DELETE FROM comment WHERE subject_id=\'#subject_id_2#\'\";\n            nuRunQuery($sql);\n            \n            $sql=\"DELETE FROM subject WHERE id=\'#subject_id_2#\'\";\n            nuRunQuery($sql); \n        \n            //*******************************************************\n            $nuParameters = \'\';    \n        } else {\n            $nuError = \"Προσοχή: Υπάρχουν μαθητές με βαθμούς και στα δύο μαθήματα την ίδια βαθμολογική περίοδο! Η συγχώνευση δεν μπορεί να πραγματοποιηθεί!\";    \n        }\n    } else {\n        $nuError = \"Προσοχή: Δεν μπορείτε να συγχωνεύσετε ένα μάθημα με τον εαυτό του!\";    \n    }   \n} else {\n    $nuError = \"Προσοχή: Επιλέξτε πρώτα τα μαθήματα!\";    \n}\n\n','','0','2017-11-18 22:50:02','globeadmin','2017-11-26 12:00:43','globeadmin','2020-09-27 18:27:23','globeadmin','0'),('5a12e752e9655e6','find_calendar_test_dates','Βρίσκει τις ελεύθερες ημερομηνίες για τον προγραμματισμό ενός διαγωνίσματος σε ένα τμήμα','Teacher','function translateMonthName($month) { \nreturn strtr($month, array(\n    \'Jan\' => \'Ιανουαρίου\',\n    \'Feb\' => \'Φεβρουαρίου\',\n    \'Mar\' => \'Μαρτίου\',\n    \'Apr\' => \'Απριλίου\', \n    \'May\' => \'Μαΐου\', \n    \'Jun\' => \'Ιουνίου\', \n    \'Jul\' => \'Ιουλίου\',\n    \'Aug\' => \'Αυγούστου\',\n    \'Sep\' => \'Σεπτεμβρίου\',\n    \'Oct\' => \'Οκτωβρίου\',\n    \'Nov\' => \'Νοεμβρίου\',\n    \'Dec\' => \'Δεκεμβρίου\'\n    )); \n}\n\nfunction translateDayName($day) { \nreturn strtr($day, array(\n    \'Mon\' => \'Δευτέρα\',\n    \'Tue\' => \'Τρίτη\',\n    \'Wed\' => \'Τετάρτη\',\n    \'Thu\' => \'Πέμπτη\', \n    \'Fri\' => \'Παρασκευή\', \n    \'Sat\' => \'Σάββατο\', \n    \'Sun\' => \'Κυριακή\'\n    )); \n}\n\nfunction translateDate($date) {\n    $day_name = translateDayName(date(\'D\', strtotime($date)));\n    $d = date(\'d\', strtotime($date));\n    $m = translateMonthName(date(\'M\', strtotime($date)));\n    $y = date(\'Y\', strtotime($date));\n    return($day_name.\' \'.$d.\' \'.$m.\' \'.$y);\n}\n\nfunction createDateRangeArray($strDateFrom,$strDateTo)\n{\n    $sql=\"  select holiday.holiday \n            from holiday\n            inner join school_year on holiday.school_year_id=school_year.id\n            inner join school on school.school_year_id = school_year.id\";\n    $retval=nuRunQuery($sql);\n    \n    $holiday_array = array();\n    while($row=db_fetch_row($retval)){\n        array_push($holiday_array,$row[0]);\n    }\n    \n    $sql=\"select id from day\";\n    $retval=nuRunQuery($sql);\n    \n    $day_array = array();\n    while($row=db_fetch_row($retval)){\n        array_push($day_array,$row[0]);\n    }\n    \n    $aryRange=array();\n\n    $iDateFrom=mktime(1,0,0,substr($strDateFrom,5,2),     substr($strDateFrom,8,2),substr($strDateFrom,0,4));\n    $iDateTo=mktime(1,0,0,substr($strDateTo,5,2),     substr($strDateTo,8,2),substr($strDateTo,0,4));\n\n    if ($iDateTo>=$iDateFrom)\n    {\n    \n        $day_of_week = idate(\'w\', strtotime(date(\'Y-m-d\',$iDateFrom)))-1;\n        if(in_array($day_of_week,$day_array)){\n                array_push($aryRange,date(\'Y-m-d\',$iDateFrom)); // first entry\n            }\n    \n        while ($iDateFrom<$iDateTo)\n        {\n            $iDateFrom+=86400; // add 24 hours\n            \n            $day_of_week = idate(\'w\', strtotime(date(\'Y-m-d\',$iDateFrom)))-1;\n            if(in_array($day_of_week,$day_array)){\n                array_push($aryRange,date(\'Y-m-d\',$iDateFrom));\n            }\n        }\n    }\n\n    return array_diff($aryRange, $holiday_array);\n}\n\nfunction check_exam_limits($exam_date,$class_id,$exam_day_limit,$exam_week_limit){\n\n    $first_date = new DateTime($exam_date);\n    $last_date = new DateTime($exam_date);\n    \n    $week_number = $first_date->format(\"W\");\n    $year_number = $first_date->format(\"Y\");\n\n    $first_date->setISODate($year_number, $week_number);\n    $last_date->setISODate($year_number, $week_number, 7);\n    \n    $sql = \"SELECT student_id FROM student_class WHERE class_id=\'$class_id\'\";\n    $rv = nuRunQuery($sql);\n    while($r = db_fetch_row($rv)){\n        $sql = \"\n                SELECT count(*)\n                FROM calendar_event\n                WHERE \n                    start_date = \'$exam_date\' AND\n                    is_exam = \'1\' AND\n                    exam_class_id IN (SELECT DISTINCT class_id FROM student_class WHERE student_id=\'\".$r[0].\"\')\"\n            ; \n        $rv1 = nuRunQuery($sql);\n        $r1 = db_fetch_row($rv1);\n        \n        if($r1[0]>=$exam_day_limit){\n            return false;    \n        }\n        \n        $sql = \"\n                SELECT count(*)\n                FROM calendar_event\n                WHERE \n                    start_date BETWEEN \'\".$first_date->format(\"Y-m-d\").\"\' AND \'\".$last_date->format(\"Y-m-d\").\"\' AND\n                    is_exam = \'1\' AND\n                    exam_class_id IN (SELECT DISTINCT class_id FROM student_class WHERE student_id=\'\".$r[0].\"\')\"\n            ;\n        $rv2 = nuRunQuery($sql);\n        $r2 = db_fetch_row($rv2);\n        \n        if($r2[0]>=$exam_week_limit){\n            return false;    \n        }\n    }\n    return true;\n}\n\nprint \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n    </head>\n\n    <body>\";// onload=\\\"adjustIframeHeight()\\\">\";\n\n$cur_date = date(\"Y-m-d\");\n\n$sql=\"  select school_year.end_date  \n        from school\n        inner join school_year on school.school_year_id = school_year.id\n        where school.id=1\";\n$retval=nuRunQuery($sql);\n$row = db_fetch_row($retval);\n$end_year = $row[0];\n\nif(\'#search_date#\'!=\'#\'.\'search_date#\' && \'#search_date#\'!=\'\'){\n    \n    $search_date = (\'#search_date#\'>$end_year ? $end_year : \'#search_date#\');\n    \n    if($search_date>=$cur_date){\n        if(\'#search_class_subject_id#\'!=\'#\'.\'search_class_subject_id#\' && \'#search_class_subject_id#\'!=\'\'){\n            \n                    $ids = explode(\",\",\'#search_class_subject_id#\');\n                    if(sizeof($ids) == 2){\n                    \n                        $sql=\"SELECT exam_day_limit, exam_week_limit FROM school WHERE school.id=1\";\n                        $retval = nuRunQuery($sql);\n                        $row = db_fetch_row($retval);\n                        $exam_day_limit = $row[0];\n                        $exam_week_limit = $row[1];\n                        \n                        $dates = createDateRangeArray($cur_date,$search_date);\n                        \n                        $valid_dates = array();\n                        \n                        foreach($dates as $date){\n                            $sql = \"    SELECT COUNT(*) \n                                        FROM card \n                                        WHERE \n                                            card.valid_from = (select max(start_date) from timetable where start_date <= \'$date\') AND\n                                            card.teacher_id = \'#RECORD_ID#\' AND\n                                            card.day_id = DAYOFWEEK(\'$date\')-2 AND\n                                            card.class_id = \'\".$ids[0].\"\' AND\n                                            card.subject_id = \'\".$ids[1].\"\'\n                                    \";\n                            $retval = nuRunQuery($sql);\n                            $row = db_fetch_row($retval);\n                            \n                            if($row[0]>0){ // έχει μάθημα\n                                if(check_exam_limits($date,$ids[0],$exam_day_limit,$exam_week_limit)){ //μπορεί να βάλει διαγώνισμα\n                                    array_push($valid_dates,$date);    \n                                }    \n                            }\n                        }\n                        if(sizeof($valid_dates)>0){\n                            print (\"\n        <table cellspacing=0 CLASS=\\\"sisTable\\\" width=300>\n            <tr height=35 width=300>\n                <th align=center>\n                    Διαθέσιμες Ημερομηνίες\n                </th>\n            </tr>\");    \n                            foreach($valid_dates as $date){\n                            print (\"\n            <tr>\n                <td height=28>\n                    \".translateDate($date).\"\n                </td>\n            </tr>\n                    \");\n                            }\n                            print (\"\n         </table>\");\n                        } else {\n                            print (\"<span CLASS=\\\"msg\\\">Δε βρέθηκαν ελεύθερες ημερομηνίες!</span>\");    \n                        }\n                    } else {\n                        print (\"<span CLASS=\\\"msgError\\\">Παρακαλώ να ορίσετε πρώτα σωστά το τμήμα-μάθημα!</span>\");    \n                    }\n        } else{\n            print (\"<span CLASS=\\\"msg\\\">Παρακαλώ να ορίσετε πρώτα το τμήμα-μάθημα!</span>\");\n        }\n    } else {\n        print (\"<span CLASS=\\\"msgError\\\">Προσοχή: Η ημερομηνία δεν μπορεί να έχει παρέλθει!</span>\");\n    }\n} else {\n    print (\"<span CLASS=\\\"msg\\\">Παρακαλώ να ορίσετε πρώτα την ημερομηνία!</span>\");\n}\n\nprint \"\n    </body>\n</html>\";','','0','2017-11-20 16:31:46','globeadmin','2018-07-15 12:02:59','globeadmin','2018-07-15 12:02:59','globeadmin','0'),('5a131626cf1b235','show_loader','Εμφανίζει ένα loader στο iframe','sisyphos','/*print(\"<table width=100% height=100%>\n    <tr width=100% height=100%>\n        <td width=100% height=100% align=center valign=center>\n            <img src=\\\"ajax-loader.gif\\\">\n        </td>\n    </tr>\n</table>\");*/\nprint \"\n<html>\n<head>\n<title>Loader</title>\n<script>\n\nfunction showFrameLoader(){\n    \n	var e = document.createElement(\'div\');\n    e.setAttribute(\'id\', \'sisFrameLoaderAreaHolder\');\n    document.body.appendChild(e);\n	e.classList.add(\\\"loaderAreaHolder\\\");\n	\n	var e1 = document.createElement(\'div\');\n	e1.setAttribute(\'id\', \'sisFrameLoader1\');\n	e.appendChild(e1);\n	e1.classList.add(\\\"loader1\\\");\n	\n	var e2 = document.createElement(\'div\');\n	e2.setAttribute(\'id\', \'sisFrameLoader2\');\n	e.appendChild(e2);\n	e2.classList.add(\\\"loader2\\\");\n	e2.innerHTML = \'Σ\'\n	\n	e1.style.display = \\\"block\\\";\n	e2.style.display = \\\"block\\\";\n}    \n\nfunction hideFrameLoader() {\n	var e = document.getElementById(\\\"sisFrameLoaderAreaHolder\\\");\n	var e1 = document.getElementById(\\\"sisFrameLoader1\\\");\n	var e1 = document.getElementById(\\\"sisFrameLoader2\\\");\n	\n	e1.parentNode.removeChild(e1);\n	e2.parentNode.removeChild(e2);\n	e.parentNode.removeChild(e);\n}\n\n</script>\n\n<style>\n.loaderAreaHolder{\n    position: absolute;\n    top: 0px;\n    right: 0px;\n    width: 100%;\n    height: 100%;\n    background-color: rgba(255,255,230,0.8);\n    \n    background-size: 50px;\n    background-repeat: no-repeat;\n    background-position: center;\n    z-index: 10000000;\n}\n\n.loader1 {\n    border: 7px solid #f2c8aa;\n    border-top: 7px solid #e76200;\n    border-bottom: 7px solid #e76200;\n    border-radius: 50%;\n    width: 50px;\n    height: 50px;\n	margin: 0px;\n\n    position: absolute;;\n    top: 100px;\n    left: 50%;    \n    margin-left: -25px;\n    margin-top: -25px;\n    opacity: 0.6;\n    animation: spin_left 1s linear infinite;\n}\n\n.loader2 {\n    border: 0px solid #e76200;\n    border-radius: 50%;\n    width: 36px;\n    height: 36px;\n	\n	text-align: center;\n	vertical-align: middle;\n	line-height: 34px;\n	\n	color: lightYellow;\n	font-family: verdana;\n	font-size:18px;\n	font-weight: 600;\n	\n	background-color: #e76200;;\n \n    position: absolute;;\n    top: 100px;\n    left: 50%;    \n    margin-left: -11px;\n    margin-top: -11px;\n    opacity: 0.35;\n}\n\n@-moz-keyframes spin_left {\n    0% { -moz-transform: rotate(0deg); }\n    100% { -moz-transform: rotate(360deg); }\n}\n@-webkit-keyframes spin_left {\n    0% { -webkit-transform: rotate(0deg); }\n    100% { -webkit-transform: rotate(360deg); }\n}\n@keyframes spin_left {\n    0% {transform:rotate(0deg);}\n    100% {transform:rotate(360deg);}\n}\n</style>\n\n</head>\n<body style=\'background-color:#eeeeee\' onload=\\\"showFrameLoader()\\\">\n</body>\n</html>\";','','1','2017-11-20 19:51:34','globeadmin','2021-02-08 14:45:36','globeadmin','2021-04-01 10:22:54','globeadmin','1'),('5a1951049c4b544','search_card','Βρίσκει λεπτομέρειες για μια πραγματοποιηθείσα διδασκαλία','globeadmin','print \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n        \n        <STYLE TYPE=\\\"text/css\\\">\n            .sisTable TD{\n                font-size:1.1em;\n            }\n            .sisTable TH{\n                font-size:1.1em;\n            }\n        </STYLE>\n    </head>\n\n    <body>\";\n\nif(\'#card_date#\'!=\'\' && \'#card_date#\' != \'#\'.\'card_date#\'){\n    if(\'#class_id#\'!=\'\' && \'#class_id#\' != \'#\'.\'class_id#\'){\n        if(\'#period_id#\'!=\'\' && \'#period_id#\' != \'#\'.\'period_id#\'){\n\n            $sql=\"  SELECT\n                            card.id,\n                            concat(subject.name,if(subject_type.short_name is NULL,\'\',concat(\' (\',subject_type.short_name,\')\')),if(classroom.short_name is NULL,\'\',concat(\', Αιθ. \',classroom.short_name))),\n                            concat(if(teacher.surname is null,\'\',concat(teacher.surname,\' \')), IFNULL(teacher.name,\'\')),\n                            IFNULL(registered_card.id,\'-1\'),\n                            IFNULL(registered_card.no_lesson,\'-1\')\n                    FROM card\n                    INNER JOIN subject      ON card.subject_id          = subject.id\n                    LEFT JOIN subject_type  ON subject.subject_type_id  = subject_type.id\n                    INNER JOIN teacher      ON card.teacher_id          = teacher.id\n                    LEFT JOIN classroom     ON card.classroom_id        = classroom.id\n                    LEFT JOIN registered_card ON (card.id = registered_card.card_id AND registered_card.card_date=\'#card_date#\')\n                    WHERE\n                        valid_from = (select max(start_date) from timetable where start_date <= \'#card_date#\') AND\n                        class_id=\'#class_id#\' AND\n                        period_id=\'#period_id#\' AND\n                        card.day_id = DAYOFWEEK(\'#card_date#\')-2\n                    \";\n            $retval = nuRunQuery($sql);\n            \n            if(db_num_rows($retval)>0){\n                print (\"\n        <table cellspacing=0 CLASS=\\\"sisTable\\\" width=880>\n            <tr height=30 width=880>\n                <th align=center colspan=3>\n                    Διδασκαλίες\n                </th>\n            </tr>\n            \n            <tr height=30 width=880>\n                <th align=center width=480>\n                    Μάθημα    \n                </th>\n                <th align=center width=280 >\n                    Καθηγητής   \n                </th>\n                <th align=center width=120>\n                    Καταχωρίστηκε   \n                </th>\n            </tr>\");\n                \n                $cards = array();\n                $registered_cards = array();\n                \n                while($row=db_fetch_row($retval)){\n                    $color = ($row[3]==\'-1\' ? \'lightBlue\' : ($row[4]==\'1\' ? \'yellow\' : \'lightGreen\'));\n                    print (\"\n            <tr height=35 style=\\\"background-color:$color;\\\">\n                <td>\n                    \".(\'#nu_user_group#\'==\'globeadmin\' ? $row[0].\"-\" : \"\").$row[1].\"\n                </td>\n                <td>\n                    \".$row[2].\"\n                </td>\n                <td align=center>\n                    \".($row[3]==\'-1\' ? \'Όχι\' : (\'#nu_user_group#\'==\'globeadmin\' ? $row[3].\"-\" : \"\").\'Ναι\'.($row[4]==\'1\' ? \"-Κενό\" : \"\")).\"\n                </td>\n            </tr>\");\n                \n                    $cards[] = $row[0];\n                    if($row[3]!=\'-1\'){$registered_cards[] = $row[3];}\n                }\n                            print (\"\n         </table>\n         <br>\");\n         \n                $sql=\"  SELECT\n                            absence.id,\n                            concat(student.surname,\' \',student.name,\' \',if(student.fathers_name IS NULL,\'\', CONCAT(\' πατ. \',student.fathers_name))),\n                            ifNULL(absence_reason.name,\'\'),\n                            ifNULL(justified_reason.short_name,\'-1\')\n                        FROM absence\n                        INNER JOIN absence_reason ON absence.absence_reason_id = absence_reason.id\n                        INNER JOIN student ON absence.student_id = student.id\n                        LEFT JOIN justified_reason ON absence.justified_reason_id = justified_reason.id\n                        WHERE \n                            absence_date = \'#card_date#\' AND\n                            card_id IN (\".implode(\",\", $cards).\")\";\n                $rv = nuRunQuery($sql);\n                \n                $absences = array();\n                \n                if(db_num_rows($rv)){\n                    print (\"\n        <table cellspacing=0 CLASS=\\\"sisTable\\\" width=880>\n            <tr height=30 width=880>\n                <th align=center colspan=4>\n                    Απουσίες\n                </th>\n            </tr>\n            \n            <tr height=30 width=880>\n                <th align=center width=350>\n                    Μαθητής    \n                </th>\n                <th align=center width=140 >\n                    Λόγος   \n                </th>\n                <th align=center width=190>\n                    Δικαιολόγηση   \n                </th>\n                <th align=center width=150>\n                    Αιτήματα Διαγραφής   \n                </th>\n            </tr>            \n            \");\n                    while($r=db_fetch_row($rv)){\n                        \n                        $justification_requests = array();\n                        \n                        $sql = \"SELECT id FROM justification_request WHERE absence_id=\'\".$r[0].\"\'\";\n                        $rv1 = nuRunQuery($sql);\n                        while($r1=db_fetch_row($rv1)){$justification_requests[]=$r1[0];}\n                        \n                        $color = ($r[3]==\'-1\' ? \'lightBlue\' : \'lightGreen\');\n                        print (\"\n            <tr height=35 style=\\\"background-color:$color;\\\">\n                <td>\n                    \".(\'#nu_user_group#\'==\'globeadmin\' ? $r[0].\"-\" : \"\").$r[1].\"\n                </td>\n                <td>\n                    \".$r[2].\"\n                </td>\n                <td align=center>\n                    \".($r[3]==\"-1\" ? \"Όχι\" :$r[3]).\"\n                </td>\n                \n                <td align=center>\n                    \".(sizeof($justification_requests)>0 ? (\'#nu_user_group#\'==\'globeadmin\' ? implode(\",\", $justification_requests).\"-Ναι\" : \"Ναι\") : \"Όχι\").\"    \n                </td>\n            </tr>\");\n                    }\n                    print (\"\n         </table>\");\n                } else if(sizeof($registered_cards)>0){\n                    print \"<span CLASS=\\\"msgSuccess\\\">Δε βρέθηκαν Απουσίες!</span>\";\n                }\n            } else {\n                print \"<span CLASS=\\\"msg\\\">Δε βρέθηκαν διδασκαλίες!</span>\";\n            }\n        } else {\n            print \"<span CLASS=\\\"msg\\\">Παρακαλώ να ορίσετε πρώτα την Ώρα!</span>\";\n        }\n    } else {\n        print \"<span CLASS=\\\"msg\\\">Παρακαλώ να ορίσετε πρώτα το Τμήμα!</span>\";\n    }\n} else {\n    print \"<span CLASS=\\\"msg\\\">Παρακαλώ να ορίσετε πρώτα την Ημερομηνία!</span>\";\n}\nprint \"\n    </body>\n</html>\";','','0','2017-11-25 13:16:20','globeadmin','2018-07-16 10:43:12','globeadmin','2020-09-16 00:19:19','globeadmin','0'),('5a19bfa808547e7','clear_card','Διαγράφει όλες τις καταχωρίσεις και απουσίες που αφορούν μια διδασκαλία','globeadmin','$msg=\"\";\n\nif(\'#card_date#\'!=\'\' && \'#card_date#\' != \'#\'.\'card_date#\'){\n    if(\'#class_id#\'!=\'\' && \'#class_id#\' != \'#\'.\'class_id#\'){\n        if(\'#period_id#\'!=\'\' && \'#period_id#\' != \'#\'.\'period_id#\'){\n\n            $sql=\"  SELECT\n                            card.id,\n                            concat(subject.name,if(subject_type.short_name is NULL,\'\',concat(\' (\',subject_type.short_name,\')\')),if(classroom.short_name is NULL,\'\',concat(\', Αιθ. \',classroom.short_name))),\n                            concat(if(teacher.surname is null,\'\',concat(teacher.surname,\' \')), IFNULL(teacher.name,\'\')),\n                            IFNULL(registered_card.id,\'-1\'),\n                            IFNULL(registered_card.no_lesson,\'-1\')\n                    FROM card\n                    INNER JOIN subject      ON card.subject_id          = subject.id\n                    LEFT JOIN subject_type  ON subject.subject_type_id  = subject_type.id\n                    INNER JOIN teacher      ON card.teacher_id          = teacher.id\n                    LEFT JOIN classroom     ON card.classroom_id        = classroom.id\n                    LEFT JOIN registered_card ON (card.id = registered_card.card_id AND registered_card.card_date=\'#card_date#\')\n                    WHERE\n                        valid_from = (select max(start_date) from timetable where start_date <= \'#card_date#\') AND\n                        class_id=\'#class_id#\' AND\n                        period_id=\'#period_id#\' AND\n                        card.day_id = DAYOFWEEK(\'#card_date#\')-2\n                    \";\n            $retval = nuRunQuery($sql);\n            \n            if(db_num_rows($retval)>0){\n                \n                $cards = array();\n                $registered_cards = array();\n                \n                while($row=db_fetch_row($retval)){\n                    $cards[] = $row[0];\n                    if($row[3]!=\'-1\'){$registered_cards[] = $row[3];}\n                }\n                \n                $sql=\"  SELECT\n                            absence.id,\n                            concat(student.surname,\' \',student.name,\' \',if(student.fathers_name IS NULL,\'\', CONCAT(\' πατ. \',student.fathers_name))),\n                            ifNULL(absence_reason.name,\'\'),\n                            ifNULL(justified_reason.short_name,\'-1\')\n                        FROM absence\n                        INNER JOIN absence_reason ON absence.absence_reason_id = absence_reason.id\n                        INNER JOIN student ON absence.student_id = student.id\n                        LEFT JOIN justified_reason ON absence.justified_reason_id = justified_reason.id\n                        WHERE \n                            absence_date = \'#card_date#\' AND\n                            card_id IN (\".implode(\",\", $cards).\")\";\n                $rv = nuRunQuery($sql);\n                \n                $absences = array();\n                $justification_requests = array();\n                \n                while($r=db_fetch_row($rv)){\n                \n                    $absences[] = $r[0];    \n                    \n                    $sql = \"SELECT id FROM justification_request WHERE absence_id=\'\".$r[0].\"\'\";\n                    $rv1 = nuRunQuery($sql);\n                    while($r1=db_fetch_row($rv1)){$justification_requests[]=$r1[0];}\n                }\n                \n                if(sizeof($justification_requests)>0){\n                    $sql=\"DELETE FROM justification_request WHERE id in (\".implode(\",\", $justification_requests).\")\";\n                    nuRunQuery($sql);\n                }\n                \n                if(sizeof($absences)>0){\n                    $sql=\"DELETE FROM absence WHERE id in (\".implode(\",\", $absences).\")\";\n                    nuRunQuery($sql);\n                }                \n\n                if(sizeof($registered_cards)>0){\n                    $sql=\"DELETE FROM registered_card WHERE id in (\".implode(\",\", $registered_cards).\")\";\n                    nuRunQuery($sql);\n                }\n                \n                nuRunPHP(\'search_card\');\n                \n            } else {\n                $msg=\"Δε βρέθηκαν διδασκαλίες!\";\n            }\n        } else {\n            $msg=\"Παρακαλώ να ορίσετε πρώτα την Ώρα...\";\n        }\n    } else {\n        $msg=\"Παρακαλώ να ορίσετε πρώτα το Τμήμα...\";\n    }\n} else {\n    $msg=\"Παρακαλώ να ορίσετε πρώτα την Ημερομηνία...\";\n}\n\nif($msg!=\"\"){\n    print \"\n<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n    </head>\n    <body>\n        <span CLASS=\\\"msg\\\">$msg</span>\n    </body>\n</html>\";     \n}','','0','2017-11-25 21:08:24','globeadmin','2018-07-16 12:16:54','globeadmin','2018-07-17 15:02:02','globeadmin','0'),('5a28162b9f2ddc4','check_teacher_calendar_exams','Βρίσκει ποια μελλοντικά διαγωνίσματα του καθηγητή δεν ταιριάζουν με το ΩΠ','teacher','function translateMonthName($month) { \nreturn strtr($month, array(\n    \'Jan\' => \'Ιανουαρίου\',\n    \'Feb\' => \'Φεβρουαρίου\',\n    \'Mar\' => \'Μαρτίου\',\n    \'Apr\' => \'Απριλίου\', \n    \'May\' => \'Μαΐου\', \n    \'Jun\' => \'Ιουνίου\', \n    \'Jul\' => \'Ιουλίου\',\n    \'Aug\' => \'Αυγούστου\',\n    \'Sep\' => \'Σεπτεμβρίου\',\n    \'Oct\' => \'Οκτωβρίου\',\n    \'Nov\' => \'Νοεμβρίου\',\n    \'Dec\' => \'Δεκεμβρίου\'\n    )); \n}\n\nfunction translateDayName($day) { \nreturn strtr($day, array(\n    \'Mon\' => \'Δευτέρα\',\n    \'Tue\' => \'Τρίτη\',\n    \'Wed\' => \'Τετάρτη\',\n    \'Thu\' => \'Πέμπτη\', \n    \'Fri\' => \'Παρασκευή\', \n    \'Sat\' => \'Σάββατο\', \n    \'Sun\' => \'Κυριακή\'\n    )); \n}\n\nfunction translateDate($date) {\n    $day_name = translateDayName(date(\'D\', strtotime($date)));\n    $d = date(\'d\', strtotime($date));\n    $m = translateMonthName(date(\'M\', strtotime($date)));\n    $y = date(\'Y\', strtotime($date));\n    return($day_name.\' \'.$d.\' \'.$m.\' \'.$y);\n}\n\nprint \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n    </head>\n\n    <body>\";\n\n$sql = \"    SELECT \n                calendar_event.id,\n                calendar_event.exam_class_id,\n                calendar_event.exam_subject_id,\n                calendar_event.start_date,\n                calendar_event.end_date,\n                calendar_event.start_time, \n                calendar_event.end_time,\n                calendar_event.title,\n                ifNULL(calendar_event.description,\'\'),\n                ifNULL(calendar_event.location,\'\'),\n                class.short_name,\n                subject.short_name,\n                calendar_event.teacher_id\n            FROM calendar_event\n            INNER JOIN class ON class.id = calendar_event.exam_class_id\n            INNER JOIN subject ON subject.id = calendar_event.exam_subject_id\n            WHERE \n                calendar_event.is_exam=\'1\' AND\";\n                \nif(\'#show_all_exams#\'!=\'1\'){\n$sql .= \"                \n                calendar_event.teacher_id=\'#RECORD_ID#\' AND\";\n    \n}\n                \n$sql .= \"                \n                calendar_event.start_date>=CURDATE()\n            ORDER BY calendar_event.start_date,calendar_event.start_time,class.short_name,subject.short_name\n        \";\n$retval = nuRunQuery($sql);\n\nif(db_num_rows($retval)>0){\n\n    print (\"\n        <table border=1  cellspacing=0 CLASS=\\\"sisTable\\\" width=640>\n            <tr height=35 width=640>\n                <th align=center colspan=5>\n                    Προγραμματισμένα Διαγωνίσματα σε Λάθος Ημερομηνίες\n                </th>\n            </tr>\n            <tr height=35>\n                <th align=center width=200>\n                    Ημερομηνία\n                </th>\n                <th align=center width=120>\n                    Ώρα\n                </th>\n                <th align=center width=70>\n                    Τμήμα\n                </th>\n                <th align=center width=180>\n                    Μάθημα\n                </th>\n                <th width=70 align=center>\n                    <b>Επιλογή</b><br>\n                    Όλα<input type=\\\"checkbox\\\" id=\\\"all_chk_1\\\" title=\\\"Επιλογή Όλων\\\" onclick=\\\"toggle(this,\'chk_1\')\\\">\n                </th>\n            </tr>            \n            \n            \");\n            \n    while ($row = db_fetch_row($retval)){\n    \n        $date = $row[3];\n        \n        $sql = \"SELECT \n                    card.id,\n                    if(period.start_time=\'\".$row[5].\"\' AND period.end_time=\'\".$row[6].\"\',\'1\',\'0\')\n                FROM card\n                INNER JOIN period ON period.id=card.period_id\n                WHERE\n                    card.valid_from = (select max(start_date) from timetable where start_date <= \'$date\') AND\";\n                    \n        if(\'#show_all_exams#\'!=\'1\'){\n        $sql .= \"                \n                card.teacher_id = \'#RECORD_ID#\' AND\";\n    \n        }\n  \n        $sql .= \"            \n                    card.day_id = DAYOFWEEK(\'$date\')-2 AND\n                    card.class_id = \'\".$row[1].\"\' AND\n                    card.subject_id = \'\".$row[2].\"\'\n        \";\n    \n        $rv = nuRunQuery($sql);\n    \n        $status = 0;\n        \n        if(db_num_rows($rv)==0){\n            $status = 1;\n        } else {\n            $wrong_period = true;\n            while ($r = db_fetch_row($rv)){\n                if($r[1]==\'1\'){$wrong_period = false;}\n            }\n            if($wrong_period){\n                $status = 2;                  \n            }\n        }\n        \n        $color = ($status == 0 ? \'lightGreen\' : ($status == 1 ? \'#ff8080\' : \'lightBlue\'));\n        \n        print (\"\n            <tr style=\\\"background-color:$color;\\\" height=28>\n                <td>\n                    \".translateDate($date).\"\n                </td>\n                <td align=center\".($status == 2 ? \" style=\\\"background-color:#ff8080;\\\"\" : \"\").\">\n                    \".$row[5].\"-\".$row[6].\"\n                </td>\n                <td align=center>\n                    \".$row[10].\"\n                </td>\n                <td>\n                    \".$row[11].\"\n                </td>\n                <td align=center>\n                    \".($status !=0 && ($row[12]==\'#RECORD_ID#\' || \'#nu_user_group#\'==\'globeadmin\' || \'#nu_user_group#\'==\'Managers\' || \'#nu_user_group#\'==\'AssistManagers\' || \'#nu_user_group#\'==\'Administrators\' || \'#nu_user_group#\'==\'Secretaries\') ? \n                    \"<input type=\\\"checkbox\\\" CLASS=\\\"chk_1\\\" id=\\\"\".$row[0].\"\\\" title=\\\"Επιλογή Διαγωνίσματος\\\" onclick=\\\"make_indeterminate(\'all_chk_1\')\\\">\" : \"&nbsp;\").\"\n                </td>\n            </tr>\n            \");  \n    }\n    \n    print (\"\n         </table>\");\n} else {\n    print (\"<span CLASS=\\\"msg\\\">Δε βρέθηκαν προγραμματισμένα διαγωνίσματα!</span>\");    \n}\nprint \"\n    </body>\n</html>\";\n','','0','2017-12-06 18:09:15','globeadmin','2018-07-14 22:10:21','globeadmin','2018-07-14 22:10:21','globeadmin','0'),('5a2becd4c30f6d1','delete_calendar_exams','Διαγράφει μια λίστα διαγωνισμάτων από το ημερολόγιο','Teachers','nuRunPHP(\'notification_add_lib\');\nnuRunPHP(\'send_email_calendar_event\');\n\n$nuParameters = \'\';\n\nif(\'#exams_id_list#\'!=\'\' && \'#exams_id_list#\'!=\'#\'.\'exams_id_list#\'){\n\n    $ids = explode(\",\", \'#exams_id_list#\');\n    \n    foreach($ids as $id){\n    \n        if(\'#inform_check_hash#\'==\'1\'){\n        \n            $sql = \"SELECT id,user_group_id FROM calendar_event_access WHERE calendar_event_id=\'$id\'\";\n            $retval = nuRunQuery($sql);\n\n            while($row=db_fetch_row($retval)){\n                if($row[1]==\'547de4c65675a29\' || $row[1]==\'5717ba3eb32c252\'){\n                    calendar_event_notification($row[0],9);\n                } else if($row[1]!=\'999999999999999\'){\n                    $m = calendar_event_email($row[0],9);\n                    if($m!=\'-1\' && $m !=\'\'){\n                        $nuParameters .= ($nuParameters != \"\" ? \"\\n\" : \"\").$m;    \n                    }\n                }\n            }\n        }\n        \n        $sql=\"  SELECT \n                        calendar_event.teacher_id,\n                        session_variables.teacher_id\n                FROM calendar_event\n                INNER JOIN session_variables    ON  session_variables.session_id = \'#session_id#\'\n                WHERE \n                    calendar_event.id=\'$id\'\";\n        $retval = nuRunQuery($sql);        \n        \n        if($row = db_fetch_row($retval)){\n            if($row[0]!=$row[1]){\n                $m = calendar_event_owner_email($id,9);\n                $nuParameters .= ($nuParameters != \"\" ? \"\\n\" : \"\").$m;\n            }    \n        }\n        \n        $sql=\"DELETE FROM calendar_event_access WHERE calendar_event_id=\'$id\'\";\n        nuRunQuery($sql);\n    \n        $sql=\"DELETE FROM calendar_event WHERE id=\'$id\'\";\n        nuRunQuery($sql);    \n        \n    }\n} else {\n    $nuParameters = \'-1\';\n}','','0','2017-12-09 16:01:56','globeadmin','2017-12-09 21:36:55','globeadmin','2017-12-14 21:40:44','globeadmin','0'),('5a36908c39d6562','find_next_student_mark','Βρίσκει το βαθμό για τον επόμενο μαθητή στο ίδιο μάθημα','teacher','$sql = \"    SELECT\n                mark.id\n            FROM mark\n            INNER JOIN student ON student.id = mark.student_id\n            WHERE \n	            mark.grading_period_id = \'#grading_period_id#\' AND\n	            class_id = \'#class_id#\' AND\n	            subject_id = \'#subject_id#\'\n            ORDER BY student.surname,student.name,student.fathers_name\";\n$retval=nuRunQuery($sql);\n\n$found = false;\n$nuParameters = \'-1\';\n\nif($retval){\n    while($row=db_fetch_row($retval)){\n        if($found){\n            $nuParameters = $row[0];\n            break;\n        }\n        \n        if($row[0]==\'#RECORD_ID#\'){\n            $found = true;    \n        }  \n    }\n} else {\n    $nuError = \"Προσοχή! Παρουσιάστηκε πρόβλημα κατά την ανάκτηση των δεδομένων!\";    \n}\n  \n','','0','2017-12-17 17:43:08','globeadmin','2017-12-17 17:58:14','globeadmin','2017-12-17 17:58:14','globeadmin','0'),('5a3690cc1299b0a','find_prev_student_mark','Βρίσκει τo βαθμό για τον προηγούμενο μαθητή στο ίδιο μάθημα','teacher','$sql = \"    SELECT\n                mark.id\n            FROM mark\n            INNER JOIN student ON student.id = mark.student_id\n            WHERE \n	            mark.grading_period_id = \'#grading_period_id#\' AND\n	            class_id = \'#class_id#\' AND\n	            subject_id = \'#subject_id#\'\n            ORDER BY student.surname,student.name,student.fathers_name\";\n            \n$retval=nuRunQuery($sql);\n\n$prev_id = \'-1\';\n$nuParameters = \'-1\';\n\nif($retval){\n    while($row=db_fetch_row($retval)){\n        \n        if($row[0]==\'#RECORD_ID#\'){\n            $nuParameters = $prev_id;\n            break;\n        } else {\n            $prev_id = $row[0];    \n        }\n    }\n} else {\n    $nuError = \"Προσοχή! Παρουσιάστηκε πρόβλημα κατά την ανάκτηση των δεδομένων!\";    \n}','','0','2017-12-17 17:44:12','globeadmin','2017-12-17 17:59:42','globeadmin','2017-12-17 17:59:42','globeadmin','0'),('5a36b672b84479b','download_check_version','01. Βρίσκει την τελευταία έκδοση του Σίσυφου στο GitHub και τη συγκρίνει με την τρέχουσα','Manager','$key = nuID();\nnuDebug($key);\n\nprint \"<html>\n<head>\n\n<meta charset=\\\"UTF-8\\\">\n\n<STYLE TYPE=\\\"text/css\\\">\n    .mytable TH{\n        font-family:Verdana;\n        font-size:9pt;\n        border: 2px solid Gray;\n        padding: 12px 12px 12px 12px;\n    }\n</STYLE>\n\n<script type=\\\"text/javascript\\\">\n\nfunction ChangeCursor(cell) {\n    cell.style.cursor=\\\"pointer\\\";\n}\n\nfunction RestoreCursor(cell) {\n    cell.style.cursor=\\\"auto\\\";\n}\n\n\nfunction star_download() {\n        var xmlhttp;\n        xmlhttp = new XMLHttpRequest();\n        xmlhttp.onreadystatechange=function() {\n            if (xmlhttp.readyState==4 && xmlhttp.status==200)  {\n                var s=xmlhttp.responseText;                  \n            } \n        }\n        xmlhttp.open(\\\"GET\\\",\\\"sisDownload.php?key=$key\\\",true);\n        xmlhttp.send();\n}\n\nfunction download_new_version(){\n    star_download();\n    parent.display_msg(\'<b>Βήμα 1 από 6 : Λήψη νέας έκδοσης...</b>\',\'loader\');\n    parent.nuRunPHP(\'download_progress_version\',\'progress_iframe\');\n}\n\n</script>\n</head>\n<body>\";\n\n$sql = \"SELECT version FROM school WHERE id=1\";\n$retval = nuRunQuery($sql);\n$row = db_fetch_row($retval);\n$cur_version = $row[0];\n\n$url=\"https://raw.githubusercontent.com/nekpap/sisyphos/master/package.json\";\n$result = file_get_contents($url);\nif($result===false){\n    print (\"\n    \n     <table border=1  cellspacing=0 CLASS=\\\"mytable\\\" align=left>\n        <tr>\n            <th bgcolor=red>\n                Προσοχή : Η τελευταία έκδοση δε βρέθηκε!\n            </th>\n        </tr>\n    </table>\");    \n} else {\n    $package = json_decode($result, true);\n    $last_version = $package[\'version\'];\n\n    print (\"\n    <table border=0 cellspacing=0>\n        <tr>\n            <td>\n                <table cellspacing=0 CLASS=\\\"mytable\\\" align=left>\n                    <tr>\n                        <th bgcolor=\".($cur_version>=$last_version ? \'LightGreen\' : \'LightBlue\').\" width=450 align=left>\n                        \".($cur_version>=$last_version ? \"Τέλεια! Το σύστημα σας είναι ενημέρωμενο στην τελευταία έκδοση!\" : \"H νεότερη έκδοση <u>$last_version</u>, είναι διαθέσιμη για λήψη!\").\"\n                        </th>\n                    </tr>\n                </table>\n            </td>\");\n    \n    if($last_version>$cur_version){\n        if(is_writable(DIRECTORY_SEPARATOR.\'tmp\')){\n            print (\"\n            <td width=20>\n            </td>\n            <td>\n                <table cellspacing=0 CLASS=\\\"mytable\\\" align=left>\n                    <tr>\n                        <th width=150 bgcolor=#00cc00 style=\\\"color:lightyellow\\\" onclick=\\\"download_new_version()\\\" onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\">\n                            <u>Λήψη Τώρα</u>\n                        </th>    \n                    </tr>\n                </table>\n            </td>\");\n        } else {\n            print (\"\n            <td width=20>\n            </td>\n            <td>\n                <table cellspacing=0 CLASS=\\\"mytable\\\" align=left>\n                    <tr>\n                        <th bgcolor=#cc0000 style=\\\"color:lightyellow\\\">\n                            Άρνηση εγγραφής στο φάκελο tmp!\n                        </th>    \n                    </tr>\n                </table>\n            </td>\");            \n        }\n    }\n    print (\"\n        </tr>\n    </table>\n    \");\n}\nprint (\"    \n</body>\n</html>\");','','0','2017-12-17 20:24:50','globeadmin','2018-01-12 08:39:48','globeadmin','2018-06-28 23:58:56','globeadmin','0'),('5a37c77e5107316','download_progress_version','02. Εμφανίζει μπάρα προόδου κατά τη λήψη της τελευταίας έκδοσης από το GitHub','manager','$url=\"https://raw.githubusercontent.com/nekpap/sisyphos/master/package.json\";\n$result = file_get_contents($url);\nif($result===false){\n    print (\"\n     <table cellspacing=0 CLASS=\\\"sisTable\\\" align=left>\n        <tr>\n            <th style=\\\"background-color:red;\\\">\n                Προσοχή : Η τελευταία έκδοση δε βρέθηκε!\n            </th>\n        </tr>\n    </table>\");    \n} else {\n    $package = json_decode($result, true);\n    $last_version = $package[\'version\'];\n\n    print \"\n<html>\n<head>\n<script src=\\\"sisIframe.js\\\"></script>\n<link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n<style>\nbody {\n    margin: 5px 0px 0px 10px\n}\n.demo-wrapper {\n	width: 700px;\n	margin: 0px 0px 0px 0px;\n}\n.html5-progress-bar {\n	padding: 15px 15px;\n	border-radius: 3px;\n	background-color: #fff;\n	box-shadow:  0px 1px 2px 0px rgba(0, 0, 0, .2);\n}\n.html5-progress-bar progress {\n	background-color: #f3f3f3;\n	border: 0;\n	width: 45%;\n	height: 18px;\n	border-radius: 9px;\n}\n.html5-progress-bar progress::-webkit-progress-bar {\n	background-color: #f3f3f3;\n	border-radius: 9px;\n}\n.html5-progress-bar progress::-webkit-progress-value {\n	background: #cdeb8e;\n	background: -moz-linear-gradient(top,  #cdeb8e 0%, #a5c956 100%);\n	background: -webkit-gradient(linear, left top, left bottom, color-stop(0%,#cdeb8e), color-stop(100%,#a5c956));\n	background: -webkit-linear-gradient(top,  #cdeb8e 0%,#a5c956 100%);\n	background: -o-linear-gradient(top,  #cdeb8e 0%,#a5c956 100%);\n	background: -ms-linear-gradient(top,  #cdeb8e 0%,#a5c956 100%);\n	background: linear-gradient(to bottom,  #cdeb8e 0%,#a5c956 100%);\n	filter: progid:DXImageTransform.Microsoft.gradient( startColorstr=\'#cdeb8e\', endColorstr=\'#a5c956\',GradientType=0 );\n	border-radius: 9px;\n}\n.html5-progress-bar progress::-moz-progress-bar {\n	background: #cdeb8e;\n	background: -moz-linear-gradient(top,  #cdeb8e 0%, #a5c956 100%);\n	background: -webkit-gradient(linear, left top, left bottom, color-stop(0%,#cdeb8e), color-stop(100%,#a5c956));\n	background: -webkit-linear-gradient(top,  #cdeb8e 0%,#a5c956 100%);\n	background: -o-linear-gradient(top,  #cdeb8e 0%,#a5c956 100%);\n	background: -ms-linear-gradient(top,  #cdeb8e 0%,#a5c956 100%);\n	background: linear-gradient(to bottom,  #cdeb8e 0%,#a5c956 100%);\n	filter: progid:DXImageTransform.Microsoft.gradient( startColorstr=\'#cdeb8e\', endColorstr=\'#a5c956\',GradientType=0 );\n	border-radius: 9px;\n}\n.html5-progress-bar .progress-value{\n	padding: 0px 5px;\n	line-height: 20px;\n	margin-left: 5px;\n	font-family:Verdana;\n    font-size:8pt;\n    font-weight: bold;\n	color: #555;\n	height: 18px;\n	float: right;\n}\n\n.pl{\n	padding: 0px 5px;\n	line-height: 20px;\n	margin-left: 0px;\n	margin-rigth: 5px;\n	font-family:Verdana;\n    font-size:8pt;\n    font-weight: bold;\n	color: #555;\n	height: 18px;\n	float: left;\n}\n.sisTable TH{\n        font-size:9pt;\n        padding: 12px 12px 12px 12px;\n}\n</style>\n\n<script src=\\\"jquery/jquery-1.8.3.js\\\" type=\'text/javascript\'></script>\n<script src=\\\"jquery/jquery-ui.js\\\" type=\'text/javascript\'></script>\n\n<script type=\\\"text/javascript\\\">\n\n    function unzip_version(){\n        parent.display_msg(\'<hr>\');\n        parent.display_msg(\'<b>Βήμα 2 από 6: Αποσυμπίεση ληφθέντος αρχείου...</b>\',\'loader\');\n        parent.nuRunPHP(\'unzip_progress_version\',\'progress_iframe\');\n    }\n	\n    function loadProgress() {\n        var p=\'0\';\n        var xmlhttp;\n        xmlhttp = new XMLHttpRequest();\n        xmlhttp.onreadystatechange=function() {\n            if (xmlhttp.readyState==4 && xmlhttp.status==200)  {\n                p=xmlhttp.responseText;                  \n            } \n        }\n        xmlhttp.open(\\\"GET\\\",\\\"tmp/progress.txt\\\",false);\n        xmlhttp.send();\n        return p;\n    }	\n		$(document).ready(function() {\n				var progressbar = $(\'#progressbar\'),\n					max = progressbar.attr(\'max\'),\n					time = (1000/max)*20,	\n			        value = progressbar.val(),\n			        download_size=0,\n			        downloaded_size=0,\n			        max_download_size=0,\n			        max_downloaded_size=0			        \n			        ;\n\n			    var loading = function() {\n			        \n			        //value = parseInt(loadProgress());\n			        \n			        var v = loadProgress();\n			        \n			        if(v){\n                        try {\n                            var d = JSON.parse(v);\n                            \n                            if(d[0]>-1){\n                                \n                                downloaded_size = d[0];\n                                download_size = d[1];\n                                \n                                if(downloaded_size>max_downloaded_size) {max_downloaded_size=downloaded_size;}\n                                if(download_size>max_download_size) {max_download_size=download_size;}\n                            \n                                var d0=max_downloaded_size;\n                                var d1=max_download_size;\n                            \n                                d0 = d0.toString().replace(/\\B(?=(\\d{3})+(?!\\d))/g, \\\".\\\");\n                                \n                                d1 = (d1==0 ? \'NA\' : d1.toString().replace(/\\B(?=(\\d{3})+(?!\\d))/g, \\\".\\\"));\n			        \n			                    value = (max_download_size == 0 ? \'0\' : Math.round( max_downloaded_size * 100 / max_download_size ));\n			        \n			                    progressbar.val(value);\n			        \n			                    $(\'.progress-value\').html(value + \'%\'+ \' (\'+d0+\'/\'+d1+\')\');\n\n			                    if (max_downloaded_size == max_download_size && max_downloaded_size!=0) {\n			                        clearInterval(animate);	\n                                    var x = document.getElementById(\\\"install_table\\\");\n                                    x.style.display = \\\"block\\\";\n                                    parent.display_msg(\'Η Λήψη του αρχείου zip ολοκληρώθηκε με επιτυχία! \'+d0+\' Bytes ελήφθησαν!\',\'check\');\n			                    }    \n                            } else {\n                                clearInterval(animate);\n                                $(\'.progress-value\').html(\'-% ERROR-Download Faild!\');\n                                parent.display_msg(\'Η Λήψη του αρχείου zip απέτυχε!\',\'error\',\'red\');\n                            }\n                        } catch(e) {\n                            console.log(v);\n                            console.log(e);\n                        }\n			        }\n			    };\n\n			    var animate = setInterval(function() {\n			        loading();\n			    }, time);\n		});\n</script>\n</head>\n<body>\n<table border=0>\n    <tr>\n        <td>\n	        <div class=\\\"demo-wrapper html5-progress-bar\\\">\n		        <div class=\\\"progress-bar-wrapper\\\">\n		            <span class=\\\"pl\\\">Λήψη Έκδοσης $last_version : </span>\n			        <progress id=\\\"progressbar\\\" value=\\\"0\\\" max=\\\"100\\\"></progress>\n			        <span class=\\\"progress-value\\\">0%</span>\n		        </div>\n	        </div>\n	    </td>\n	    <td width=30>\n        </td>\n	    <td>\n            <table cellspacing=0 CLASS=\\\"sisTable\\\" align=left id=\\\"install_table\\\" style=\\\"display:none;\\\">\n                <tr>\n                    <th style=\\\"color:lightyellow;background-color:#00cc00;\\\" onclick=\\\"unzip_version()\\\" onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\">\n                        <u>Αποσυμπίεση</u>\n                    </th>    \n                </tr>\n            </table>\n	    </td>\n	</tr>\n</table>\n</body>\n</html>\n    \";\n}','','0','2017-12-18 15:49:50','globeadmin','2018-06-29 00:08:41','globeadmin','2018-07-15 23:04:24','globeadmin','0'),('5a3c17afa650e8f','install_version_messages','00. Εμφανίζει μηνύματα προόδου κατά την εγκατάσταση της νέας έκδοσης','Manager','print \"\n<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        \n        <STYLE TYPE=\\\"text/css\\\">\n            .mytable, .mytable TD{\n                font-family:Verdana;\n                font-size:8pt;\n            }\n            .mytable TH{\n                font-family:Verdana;\n                font-size:9pt;\n            }\n        </STYLE>\n        \n        <script>\n        \n            function stop_loader(){\n                var paras = document.getElementsByClassName(\'loader_img\');\n                for(var i = 0; i < paras.length; i++) {\n                    paras[i].parentNode.removeChild(paras[i]);\n                }\n            }\n        \n            function add_msg(msg,img=null,color=null,stop_ldr=true){\n                if(stop_ldr){\n                    stop_loader();\n                }\n                var table = document.getElementById(\'msg_table\');\n                var row = table.insertRow(-1);\n                \n                if(img){\n                    var cell1 = row.insertCell(0);\n                    var cell2 = row.insertCell(1);\n                    var extension=\'.png\';\n                    var w=24;\n                    var h=24;\n                    var img_class=\'\';\n                    \n                    if(img==\'loader\'){\n                        extension=\'.gif\';\n                        w=16;\n                        h=11;\n                        img_class = \' CLASS=\\\"loader_img\\\"\'\n                    }\n                    \n                    cell1.style.width = \\\"35px\\\";\n                    cell1.style.textAlign = \\\"left\\\";\n                    cell1.style.verticalAlign = \\\"bottom\\\";\n                    cell1.innerHTML = \'<img width=\'+w+\' height=\'+h+img_class+\' src=\\\"images/\'+img+extension+\'\\\">\';\n                    \n                    cell2.style.verticalAlign = \\\"bottom\\\";\n                    if(color){\n                        cell2.innerHTML = \'<font color=\\\"\'+color+\'\\\">\'+msg+\'</font>\';   \n                    } else {\n                        cell2.innerHTML = msg;\n                    }\n                } else {\n                    var cell1 = row.insertCell(0); \n                    cell1.colSpan = \\\"2\\\";\n                    if(color){\n                        cell1.innerHTML = \'<font color=\\\"\'+color+\'\\\">\'+msg+\'</font>\';   \n                    } else {\n                        cell1.innerHTML = msg;\n                    }\n                }\n            }\n        </script>\n    </head>\n\n    <body>\n        <table CLASS=\\\"mytable\\\" border=0  bgcolor=white cellspacing=5 width=100% height=100%>\n            <tr width=100% height=100%>\n                <td valign=top>\n                    <table id =\\\"msg_table\\\" CLASS=\\\"mytable\\\" border=0  bgcolor=white cellspacing=0 width=100%>\n                    </table>\n                </td>\n            </tr>    \n        </table>\n    </body>\n</html>\";\n','','0','2017-12-21 22:21:03','globeadmin','2018-01-01 11:29:20','globeadmin','2018-06-29 00:34:22','globeadmin','0'),('5a585e7b93e7cfa','check_for_new_version','Ελέγχει αν υπάρχει νέα έκδοση διαθέσιμη για ενημέρωση (με κλήση ajax)','Manager','$nuParameters = \'0\';\n\n$sql = \"SELECT version FROM school WHERE id=1\";\n$retval = nuRunQuery($sql);\n$row = db_fetch_row($retval);\n$cur_version = $row[0];\n\n$url=\"https://raw.githubusercontent.com/nekpap/sisyphos/master/package.json\";\n$result = file_get_contents($url);\n\nif(!$result===false){\n    \n    $package = json_decode($result, true);\n    $last_version = $package[\'version\'];\n\n    if($last_version>$cur_version){\n        $nuParameters = \'1\';    \n    }        \n}\n','','0','2018-01-12 09:06:35','globeadmin','2018-01-12 22:11:46','globeadmin','2020-08-23 13:49:48','globeadmin','0'),('5a60719e03a40ca','create_mass_comments_book','Δημιουργεί λίστα για την μαζική εισαγωγή σχολίων στους μαθητές ενός τμήματος για ένα μάθημα','teacher','print \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n        \n        <STYLE TYPE=\\\"text/css\\\">\n            .sisTable TH{\n                font-size:9pt;\n            }\n            .sisTable tr:nth-child(even){\n	            background-color: LightSteelBlue;\n            }\n            input { \n                text-align: left; \n            }\n        </STYLE>\n    <script>\n        function chk_click(chk) {\n            var std = chk.id.substring(4);\n            if(!chk.checked){\n                document.getElementById(std).setAttribute(\'data-hiden-value\', document.getElementById(std).value);\n                document.getElementById(std).value=\'\';\n            } else {\n                document.getElementById(std).value = document.getElementById(std).getAttribute(\'data-hiden-value\');\n                document.getElementById(std).setAttribute(\'data-hiden-value\',\'\');                \n            }\n            document.getElementById(std).disabled = !chk.checked;\n            make_indeterminate(\'all_chk_1\')    \n        } \n        \n        function toggle_all(source,class_name) {\n            checkboxes = document.getElementsByClassName(class_name);\n            for(var i=0, n=checkboxes.length;i<n;i++) {\n                checkboxes[i].indeterminate = false;\n                checkboxes[i].checked = source.checked;\n                var std = checkboxes[i].id.substring(4);\n                \n                if(!source.checked){\n                    document.getElementById(std).setAttribute(\'data-hiden-value\', document.getElementById(std).value);\n                    document.getElementById(std).value=\'\';\n                } else {\n                    document.getElementById(std).value = document.getElementById(std).getAttribute(\'data-hiden-value\');\n                    document.getElementById(std).setAttribute(\'data-hiden-value\',\'\');                \n                }\n            \n                document.getElementById(std).disabled = !source.checked;\n            }\n        }\n    </script>\n    </head>\n\n    <body onload=\\\"adjustIframeHeight()\\\">\";\n    \n// Δημιουργία εγγραφών για τους μαθητές του τμήματος αν δεν υπάρχουν ήδη\n\n$sql = \"CREATE TEMPORARY TABLE IF NOT EXISTS #TABLE_ID# AS \n        (   SELECT\n                student_class.student_id AS s_id\n            FROM student_class\n            INNER JOIN session_variables   ON (student_class.class_id = session_variables.class_id)\n            WHERE \n                session_variables.session_id=\'#session_id#\' AND\n                student_class.student_id not in \n                    (   SELECT comment.student_id \n                        FROM comment\n                        INNER JOIN session_variables as sv   ON (sv.subject_id = comment.subject_id)\n                        WHERE\n                            sv.session_id=\'#session_id#\'\n                    )\n        )\n        \";  \nnuRunQuery($sql);\n\n$sql = \" INSERT INTO comment (\n                id,	\n                student_id,\n                subject_id,\n                post_teacher_id,\n                changed_at,\n                student_viewed_at,\n                parent_viewed_at,\n                student_comments_changed_at)\n            SELECT\n                NULL,\n                s_id,\n                session_variables.subject_id,\n                #RECORD_ID#,\n                NOW(),\n                NOW(),\n                NOW(),\n                NOW()\n            FROM #TABLE_ID#,session_variables\n            WHERE session_variables.session_id=\'#session_id#\'\n        \";\nnuRunQuery($sql);    \n\n// ----------------------\n\n$sql=\"  SELECT \n                concat(class.short_name, \' - \', subject.name, IF(subject_type.short_name IS NULL,\'\',CONCAT(\' (\',subject_type.name,\')\')))\n        FROM session_variables\n		INNER JOIN  class               on class.id         = session_variables.class_id\n        INNER JOIN  subject             on subject.id       = session_variables.subject_id\n        LEFT  JOIN  subject_type        on subject_type.id  = subject.subject_type_id\n        WHERE\n            session_variables.session_id=\'#session_id#\'\n        \";\n$rv = nuRunQuery($sql);\n$r = db_fetch_row($rv);\n$class_subject_name = $r[0];\n\n\n$sql = \"    SELECT\n                comment.id,\n                student.registration_number,\n                student.surname,\n                student.name,\n                student.fathers_name,\n                ifNULL(comment.teacher_comments,\'\'),\n                ifNULL(comment.student_comments,\'\'),\n                student.has_left_school\n            FROM comment\n            INNER JOIN session_variables    ON (session_variables.subject_id = comment.subject_id)\n            INNER JOIN student_class        ON (student_class.class_id = session_variables.class_id AND student_class.student_id = comment.student_id)\n            INNER JOIN student 	            ON student.id   = comment.student_id\n            WHERE \n	            session_variables.session_id=\'#session_id#\'\n            ORDER BY student.surname,student.name,student.fathers_name\";\n$retval = nuRunQuery($sql);\n\nif($retval){\n    if(db_num_rows($retval)>0){\n\n        print (\"\n            <table CLASS=\\\"sisTable\\\" cellspacing=0>\n                <tr height=35>\n                    <th colspan=6>\".$class_subject_name.\"</th>\n                </tr>\n                <tr height=35> \n                    <th width=60 align=center><b>Α.Μ.</b></th> \n                    <th width=200><b>Επώνυμο</b></th> \n                    <th width=140><b>Όνομα</b></th>\n                    <th width=140><b>Όνομα Πατρός</b></th>\n                    <th width=120 align=center>\n                    Συμπερίληψη<br>\n                    Όλοι<input type=\\\"checkbox\\\" id=\\\"all_chk_1\\\" title=\\\"Επιλογή Όλων\\\" onclick=\\\"toggle_all(this,\'chk_1\')\\\" checked>\n                </th>\n                    <th align=center><b>Σχόλια</b></th>\n                </tr>\");\n        \n        while($row = db_fetch_row($retval)) {\n        \n            print(\"     \n            <tr\".($row[7]==1 ? \" style=\\\"background-color:#FCBBFC;\\\"\" : \"\").\">            \n                 \n                <td align=center>\n                    \".$row[1].\"\n                </td>\n                \n                <td>\n                    \".$row[2].\"\n                </td>\n                 \n                <td>\n                    \".$row[3].\"\n                </td>\n                \n                <td>\n                    \".$row[4].\"\n                </td>\n                <td align=center>\n                <input type=\\\"checkbox\\\" CLASS=\\\"chk_1\\\" id=\\\"chk_\".$row[0].\"\\\" title=\\\"Επιλογή Μαθητή\\\" onclick=\\\"chk_click(this)\\\" checked></td>\n                <td>\n                <input CLASS=\\\"input_fields\\\" type=\\\"text\\\" id=\\\"\".$row[0].\"\\\" size=\\\"40\\\" data-hiden-value=\'\'><br>\n                </td>\n            </tr>\");    \n        }\n        \n        print (\"\n            </table>\");\n        \n    } else {\n        print \"<span CLASS=\\\"msg\\\">Δε βρέθηκαν μαθητές. Παρακαλώ επιλέξτε Τμήμα-Μάθημα!</span>\";\n    }\n} else {\n    print \"<span CLASS=\\\"msgError\\\">Παρουσιάστηκε σφάλμα κατά την ανάκτηση των δεδομένων...</span>\";    \n}                        \nprint \"\n    </body>\n</html>\";','','0','2018-01-18 12:06:22','globeadmin','2019-07-08 13:08:25','globeadmin','2019-07-08 13:08:25','globeadmin','0'),('5a4a001d391cfa4','cleanup_progress_version','10. Εμφανίζει μήνυμα για την εκκαθάριση των προσωρινών αρχείων','Manager','print \"<html>\n<head>\n\n<meta charset=\\\"UTF-8\\\">\n\n<STYLE TYPE=\\\"text/css\\\">\n body {\n        margin: 5px 0px 0px 10px;\n    }\n    \n    .demo-wrapper {\n	    vertical-align: middle;\n	    width: 500px;\n	    height: 30px;\n	    margin: 6px 0px 0px 0px;\n	    border-radius: 3px;\n	    background-color: #fff;\n	    box-shadow:  0px 1px 2px 0px rgba(0, 0, 0, .2);\n    }\n\n\n    .pl{\n	    padding: 9px 10px 9px 10px;\n	    vertical-align: middle;\n	    margin-left: 0px;\n	    margin-rigth: 5px;\n	    font-family:Verdana;\n        font-size:8pt;\n        font-weight: bold;\n	    color: #555;\n	    height: 18px;\n	    float: left;\n    }\n    \n    .mytable TH{\n        font-family:Verdana;\n        font-size:9pt;\n        border: 2px solid Gray;\n        padding: 8px 12px 8px 12px;\n    }\n</STYLE>\n\n<script type=\\\"text/javascript\\\">\n\nfunction ChangeCursor(cell) {\n    cell.style.cursor=\\\"pointer\\\";\n}\n\nfunction RestoreCursor(cell) {\n    cell.style.cursor=\\\"auto\\\";\n}\n\nfunction show_button() {\n    var x = document.getElementById(\\\"button_table\\\");\n    x.style.display = \\\"block\\\";    \n}\n\nfunction set_message(msg) {\n    var x = document.getElementById(\\\"message_cell\\\");\n    x.innerHTML  = msg;    \n}\n\nfunction button_action(){\n\n}\n\n</script>\n</head>\n<body>\n    <table border=0 cellspacing=0>\n        <tr height=60>\n            <td>\n	            <div class=\\\"demo-wrapper\\\">\n		                <span id=\\\"message_cell\\\" class=\\\"pl\\\">Τα προσωρινά αρχεία διαγράφονται. Παρακαλώ περιμένετε...</span>\n	            </div>                        \n            </td>\n            <td width=20>\n            </td>\n            <td>\n                <table cellspacing=0 CLASS=\\\"mytable\\\" align=left id=\\\"button_table\\\" style=\\\"display:none;\\\">\n                    <tr>\n                        <th width=250 bgcolor=#00cc00 style=\\\"color:lightyellow\\\" onclick=\\\"button_action()\\\" onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\">\n                            <u>Επαναφόρτωση</u>\n                        </th>    \n                    </tr>\n                </table>\n            </td>\n        </tr>\n    </table>\n    <script>\n        //parent.nuAjax(\'clear_tmp\',\'cleanup_results\',{async:true});\n    </script>\n</body>\n</html>\";','','0','2018-01-01 11:32:13','globeadmin','2018-01-01 11:36:10','globeadmin','2018-06-26 22:22:14','globeadmin','0'),('5a41416ba57ab7e','copy_progress_version','05. Εμφανίζει μήνυμα για την αντιγραφή των αρχείων της νέας έκδοσης','Manager','print \"<html>\n<head>\n\n<meta charset=\\\"UTF-8\\\">\n\n<STYLE TYPE=\\\"text/css\\\">\n body {\n        margin: 5px 0px 0px 10px;\n    }\n    \n    .demo-wrapper {\n	    vertical-align: middle;\n	    width: 500px;\n	    height: 30px;\n	    margin: 6px 0px 0px 0px;\n	    border-radius: 3px;\n	    background-color: #fff;\n	    box-shadow:  0px 1px 2px 0px rgba(0, 0, 0, .2);\n    }\n\n\n    .pl{\n	    padding: 9px 10px 9px 10px;\n	    vertical-align: middle;\n	    margin-left: 0px;\n	    margin-rigth: 5px;\n	    font-family:Verdana;\n        font-size:8pt;\n        font-weight: bold;\n	    color: #555;\n	    height: 18px;\n	    float: left;\n    }\n    \n    .mytable TH{\n        font-family:Verdana;\n        font-size:9pt;\n        border: 2px solid Gray;\n        padding: 8px 12px 8px 12px;\n    }\n</STYLE>\n\n<script type=\\\"text/javascript\\\">\n\nfunction ChangeCursor(cell) {\n    cell.style.cursor=\\\"pointer\\\";\n}\n\nfunction RestoreCursor(cell) {\n    cell.style.cursor=\\\"auto\\\";\n}\n\nfunction show_button() {\n    var x = document.getElementById(\\\"button_table\\\");\n    x.style.display = \\\"block\\\";    \n}\n\nfunction set_message(msg) {\n    var x = document.getElementById(\\\"message_cell\\\");\n    x.innerHTML  = msg;    \n}\n\nfunction button_action(){\n    parent.display_msg(\'<hr>\');\n    parent.display_msg(\'<b>Βήμα 4 από 6: Δημιουργία αντίγραφου ασφαλείας της βάσης δεδομένων...</b>\',\'loader\');\n    parent.nuRunPHP(\'backup_progress_version\',\'progress_iframe\');\n}\n\n</script>\n</head>\n<body>\n    <table border=0 cellspacing=0>\n        <tr height=60>\n            <td>\n	            <div class=\\\"demo-wrapper\\\">\n		                <span id=\\\"message_cell\\\" class=\\\"pl\\\">Τα αρχεία αντιγράφονται. Παρακαλώ περιμένετε...</span>\n	            </div>                        \n            </td>\n            <td width=20>\n            </td>\n            <td>\n                <table cellspacing=0 CLASS=\\\"mytable\\\" align=left id=\\\"button_table\\\" style=\\\"display:none;\\\">\n                    <tr>\n                        <th width=250 bgcolor=#00cc00 style=\\\"color:lightyellow\\\" onclick=\\\"button_action()\\\" onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\">\n                            <u>Λήψη Backup Βάσης Δεδομένων</u>\n                        </th>    \n                    </tr>\n                </table>\n            </td>\n        </tr>\n    </table>\n    <script>\n        parent.nuAjax(\'copy_new_version_files\',\'copy_results\',{async:true});\n    </script>\n</body>\n</html>\";','','0','2017-12-25 20:20:27','globeadmin','2018-01-01 11:30:28','globeadmin','2018-06-26 22:22:56','globeadmin','0'),('5a413f9ddeeef6a','copy_new_version_files','06. Αντιγράφει τα νέα αρχεία από την ληφθείσα έκδοση','manager','function setError($msg) {\n  global $errors;\n  array_push($errors, $msg);\n}\n\nfunction errorCount() {\n  global $errors;\n  return count($errors);\n}\n\nfunction compare_files($a, $b){\n  // Check if filesize is different\n  if(filesize($a) !== filesize($b))\n      return false;\n\n  // Check if content is different\n  $ah = fopen($a, \'rb\');\n  $bh = fopen($b, \'rb\');\n\n  $result = true;\n  \n  while(!feof($ah)){\n    if(fread($ah, 8192) != fread($bh, 8192)){\n      $result = false;\n      break;\n    }\n  }\n\n  fclose($ah);\n  fclose($bh);\n\n  return $result;\n}\n\nfunction getDirContents($dir, &$results = array(),$exclude_dir){\n    $files = scandir($dir);\n\n    foreach($files as $key => $value){\n        $path = realpath($dir.DIRECTORY_SEPARATOR.$value);\n        if(!is_dir($path)) {\n            $results[] = $path.\'-f\';\n        } else if($value != \".\" && $value != \"..\" && $value !=$exclude_dir) {\n            getDirContents($path, $results);\n            $results[] = $path.\'-d\';\n        }\n    }\n    return $results;\n}\n\n\n$nuParameters = \'\';\n\n$base_path = realpath(__DIR__);\n$tmp_path = $base_path.DIRECTORY_SEPARATOR.\'tmp\';\n$backup_path = $tmp_path.DIRECTORY_SEPARATOR.\'update-backup\';\n$download_path = $tmp_path.DIRECTORY_SEPARATOR.\'sisyphos-master\';\n\n$lock_file = $tmp_path.DIRECTORY_SEPARATOR.\"lock\";\n\n//*******************************************************************************\n$exclude_files 	= array(\'config.php\');\n\n$errors		= array();\n\n$dir_created   = array();\n$file_created  = array();\n$file_replaced = array();\n\n$finalResult 	= array(\'message\'=>\'\', \'errors\'=>array(), \'dir_created\'=>array(),\'file_created\'=>array(),\'file_replaced\'=>array());\n\n$fp = fopen($lock_file, \"w\");\n\nif (flock($fp, LOCK_EX)) {\n\n//*******************************************************************************\n\n    $s = strlen($base_path)+1;\n\n    $current = getDirContents($base_path,$r1,\'tmp\');\n\n    $current_files = array();\n    $current_dirs = array();\n\n    foreach ($current as &$file) {\n	\n	    $file = substr($file,$s);\n	\n	    $file_type = substr($file,strlen($file)-1);\n	    $file_name = substr($file,0,strlen($file)-2);\n	\n	    if($file_type==\'d\') {\n		    $current_dirs[] = $file_name;\n	    } else if($file_type==\'f\') {\n		    $current_files[] = $file_name;\n	    }\n    }\n//*******************************************************************************\n\n    $s = strlen($download_path)+1;\n\n    $downloaded = getDirContents($download_path,$r2,\'tmp\');\n\n    $downloaded_files = array();\n    $downloaded_dirs = array();\n\n    foreach ($downloaded as &$file) {\n	\n	    $file = substr($file,$s);\n	\n	    $file_type = substr($file,strlen($file)-1);\n	    $file_name = substr($file,0,strlen($file)-2);\n	\n	    if($file_type==\'d\') {\n		    $downloaded_dirs[] = $file_name;\n	    } else if($file_type==\'f\') {\n		    $downloaded_files[] = $file_name;\n	    }\n    }\n//*******************************************************************************\n\n    $new_dirs = array_diff($downloaded_dirs,$current_dirs);\n\n    asort($new_dirs);\n\n    foreach ($new_dirs as $dir) {\n        if(!file_exists($dir)){\n            if(mkdir($base_path.DIRECTORY_SEPARATOR.$dir, 0777, true)){\n                array_push($dir_created, \'Ό κατάλογος \'.$dir.\' δημιουργήθηκε επιτυχώς!\');\n            } else {\n                setError(\'Η δημιουργία του καταλόγου \'.$dir.\' απέτυχε!\');\n            }\n        }\n    }\n\n//*******************************************************************************\n    if ( 0 == errorCount() ) {\n\n        $new_files = array_diff($downloaded_files,$current_files);\n\n        foreach ($new_files as $file) {\n            if(copy($download_path.DIRECTORY_SEPARATOR.$file,$base_path.DIRECTORY_SEPARATOR.$file)){\n                array_push($file_created, \'Το αρχείο \'.$file.\' δημιουργήθηκε επιτυχώς!\');\n            } else {\n                setError(\'Η δημιουργία του αρχείου \'.$file.\' απέτυχε!\');\n            }\n        }\n    }\n//*******************************************************************************\n    if ( 0 == errorCount() ) {\n        $existing_files = array_diff($downloaded_files,$new_files);\n        $existing_files = array_diff($existing_files,$exclude_files);\n\n        $files_to_replace = array();\n\n        foreach ($existing_files as $file) {\n            if(!compare_files($base_path.DIRECTORY_SEPARATOR.$file,$download_path.DIRECTORY_SEPARATOR.$file)){\n                array_push($files_to_replace,$file);\n            }\n        }\n\n        foreach ($files_to_replace as $file) {\n            $path = dirname($file);\n            $path = $backup_path.DIRECTORY_SEPARATOR.$path;\n\n            if (!file_exists($path)) {\n                $dir_ok = mkdir($path, 0777, true);\n            } else {\n                $dir_ok = true;    \n            }\n\n            if(!$dir_ok || !copy($base_path.DIRECTORY_SEPARATOR.$file,$backup_path.DIRECTORY_SEPARATOR.$file)){\n                setError(\'Η δημιουργία εφεδρικού αντιγράφου για το αρχείο \'.$file.\' απέτυχε!\');\n            }\n        }\n\n        if ( 0 == errorCount() ) {\n            foreach ($files_to_replace as $file) {\n                if(copy($download_path.DIRECTORY_SEPARATOR.$file,$base_path.DIRECTORY_SEPARATOR.$file)){\n                    array_push($file_replaced, \'Το αρχείο \'.$file.\' αντικαταστάθηκε επιτυχώς!\');\n                } else {\n                    setError(\'Η αντικατάσταση του αρχείου \'.$file.\' απέτυχε!\');\n                }\n            }\n        }\n    }\n\n    flock($fp, LOCK_UN);\n} else {\n    setError(\'Προσοχή! Υπάρχει άλλη διαδικασία ενημέρωσης σε εξέλιξη αυτή τη στιγμή!\');    \n}\n\nfclose($fp);\nunlink($lock_file);\n\nif ( errorCount() > 0 ) {\n  $finalResult[\'message\'] = \'ERRORS\';\n} else {\n  $finalResult[\'message\'] = \'SUCCESS\';\n}\n\n$finalResult[\'errors\']          = $errors;\n$finalResult[\'dir_created\']     = $dir_created;\n$finalResult[\'file_created\']    = $file_created;\n$finalResult[\'file_replaced\']   = $file_replaced;\n\n$nuParameters = json_encode($finalResult);\n','','0','2017-12-25 20:12:45','globeadmin','2018-01-01 12:34:10','globeadmin','2018-01-05 23:05:42','globeadmin','0'),('5a43e2feb23700e','backup_db_lib','Συνάρτηση για τη δημιουργία αντιγράφου ασφαλείας της βάσης δεδομένων','Manager','/**\n * Abstract dump file: provides common interface for writing\n * data to dump files. \n */\nabstract class Shuttle_Dump_File {\n	/**\n	 * File Handle\n	 */\n	protected $fh;\n\n	/**\n	 * Location of the dump file on the disk\n	 */\n	protected $file_location;\n\n	abstract function write($string);\n	abstract function end();\n\n	static function create($filename) {\n		if (self::is_gzip($filename)) {\n			return new Shuttle_Dump_File_Gzip($filename);\n		}\n		return new Shuttle_Dump_File_Plaintext($filename);\n	}\n	function __construct($file) {\n		$this->file_location = $file;\n		$this->fh = $this->open();\n\n		if (!$this->fh) {\n			throw new Shuttle_Exception(\"Couldn\'t create gz file\");\n		}\n	}\n\n	public static function is_gzip($filename) {\n		return preg_match(\'~gz$~i\', $filename);\n	}	\n}\n\n/**\n * Plain text implementation. Uses standard file functions in PHP. \n */\nclass Shuttle_Dump_File_Plaintext extends Shuttle_Dump_File {\n	function open() {\n		return fopen($this->file_location, \'w\');\n	}\n	function write($string) {\n		return fwrite($this->fh, $string);\n	}\n	function end() {\n		return fclose($this->fh);\n	}\n}\n\n/**\n * Gzip implementation. Uses gz* functions. \n */\nclass Shuttle_Dump_File_Gzip extends Shuttle_Dump_File {\n	function open() {\n		return gzopen($this->file_location, \'wb9\');\n	}\n	function write($string) {\n		return gzwrite($this->fh, $string);\n	}\n	function end() {\n		return gzclose($this->fh);\n	}\n}\n\n/**\n * MySQL insert statement builder. \n */\nclass Shuttle_Insert_Statement {\n	private $rows = array();\n	private $length = 0;\n	private $table;\n\n	function __construct($table) {\n		$this->table = $table;\n	}\n\n	function reset() {\n		$this->rows = array();\n		$this->length = 0;\n	}\n\n	function add_row($row) {\n		$row = \'(\' . implode(\",\", $row) . \')\';\n		$this->rows[] = $row;\n		$this->length += strlen($row);\n	}\n\n	function get_sql() {\n		if (empty($this->rows)) {\n			return false;\n		}\n\n		return \'INSERT INTO `\' . $this->table . \'` VALUES \' . \n			implode(\",\\n\", $this->rows) . \'; \';\n	}\n\n	function get_length() {\n		return $this->length;\n	}\n}\n\n/**\n * Main facade\n */\nabstract class Shuttle_Dumper {\n	/**\n	 * Maximum length of single insert statement\n	 */\n	const INSERT_THRESHOLD = 838860;\n	\n	/**\n	 * @var Shuttle_DBConn\n	 */	\n	public $db;\n\n	/**\n	 * @var Shuttle_Dump_File\n	 */\n	public $dump_file;\n\n	/**\n	 * End of line style used in the dump\n	 */\n	public $eol = \"\\r\\n\";\n\n	/**\n	 * Specificed tables to include\n	 */\n	public $include_tables;\n\n	/**\n	 * Specified tables to exclude\n	 */\n	public $exclude_tables = array();\n\n	/**\n	 * Factory method for dumper on current hosts\'s configuration. \n	 */\n	static function create($db_options) {\n		$db = Shuttle_DBConn::create($db_options);\n\n		$db->connect();\n\n		if (self::has_shell_access() \n				&& self::is_shell_command_available(\'mysqldump\')\n				&& self::is_shell_command_available(\'gzip\')\n			) {\n			$dumper = new Shuttle_Dumper_ShellCommand($db);\n		} else {\n			$dumper = new Shuttle_Dumper_Native($db);\n		}\n\n		if (isset($db_options[\'include_tables\'])) {\n			$dumper->include_tables = $db_options[\'include_tables\'];\n		}\n		if (isset($db_options[\'exclude_tables\'])) {\n			$dumper->exclude_tables = $db_options[\'exclude_tables\'];\n		}\n\n		return $dumper;\n	}\n\n	function __construct(Shuttle_DBConn $db) {\n		$this->db = $db;\n	}\n\n	public static function has_shell_access() {\n		if (!is_callable(\'shell_exec\')) {\n			return false;\n		}\n		$disabled_functions = ini_get(\'disable_functions\');\n		return stripos($disabled_functions, \'shell_exec\') === false;\n	}\n\n	public static function is_shell_command_available($command) {\n		if (preg_match(\'~win~i\', PHP_OS)) {\n			/*\n			On Windows, the `where` command checks for availabilty in PATH. According\n			to the manual(`where /?`), there is quiet mode: \n			....\n			    /Q       Returns only the exit code, without displaying the list\n			             of matched files. (Quiet mode)\n			....\n			*/\n			$output = array();\n			exec(\'where /Q \' . $command, $output, $return_val);\n\n			if (intval($return_val) === 1) {\n				return false;\n			} else {\n				return true;\n			}\n\n		} else {\n			$last_line = exec(\'which \' . $command);\n			$last_line = trim($last_line);\n\n			// Whenever there is at least one line in the output, \n			// it should be the path to the executable\n			if (empty($last_line)) {\n				return false;\n			} else {\n				return true;\n			}\n		}\n		\n	}\n\n	/**\n	 * Create an export file from the tables with that prefix.\n	 * @param string $export_file_location the file to put the dump to.\n	 *		Note that whenever the file has .gz extension the dump will be comporessed with gzip\n	 * @param string $table_prefix Allow to export only tables with particular prefix\n	 * @return void\n	 */\n	abstract public function dump($export_file_location, $table_prefix=\'\');\n\n	protected function get_tables($table_prefix) {\n		if (!empty($this->include_tables)) {\n			return $this->include_tables;\n		}\n		\n		// $tables will only include the tables and not views.\n		// TODO - Handle views also, edits to be made in function \'get_create_table_sql\' line 336\n		$tables = $this->db->fetch_numeric(\'\n			SHOW FULL TABLES WHERE Table_Type = \"BASE TABLE\" AND Tables_in_\'.$this->db->name.\' LIKE \"\' . $this->db->escape_like($table_prefix) . \'%\"\n		\');\n\n		$tables_list = array();\n		foreach ($tables as $table_row) {\n			$table_name = $table_row[0];\n			if (!in_array($table_name, $this->exclude_tables)) {\n				$tables_list[] = $table_name;\n			}\n		}\n		return $tables_list;\n	}\n}\n\nclass Shuttle_Dumper_ShellCommand extends Shuttle_Dumper {\n	function dump($export_file_location, $table_prefix=\'\') {\n		$command = \'mysqldump -h \' . escapeshellarg($this->db->host) .\n			\' -u \' . escapeshellarg($this->db->username) . \n			\' --password=\' . escapeshellarg($this->db->password) . \n			\' \' . escapeshellarg($this->db->name);\n\n		$include_all_tables = empty($table_prefix) &&\n			empty($this->include_tables) &&\n			empty($this->exclude_tables);\n\n		if (!$include_all_tables) {\n			$tables = $this->get_tables($table_prefix);\n			$command .= \' \' . implode(\' \', array_map(\'escapeshellarg\', $tables));\n		}\n\n		$error_file = tempnam(sys_get_temp_dir(), \'err\');\n\n		$command .= \' 2> \' . escapeshellarg($error_file);\n\n		if (Shuttle_Dump_File::is_gzip($export_file_location)) {\n			$command .= \' | gzip\';\n		}\n\n		$command .= \' > \' . escapeshellarg($export_file_location);\n\n		exec($command, $output, $return_val);\n\n		if ($return_val !== 0) {\n			$error_text = file_get_contents($error_file);\n			unlink($error_file);\n			throw new Shuttle_Exception(\'Couldn\\\'t export database: \' . $error_text);\n		}\n\n		unlink($error_file);\n	}\n}\n\nclass Shuttle_Dumper_Native extends Shuttle_Dumper {\n	public function dump($export_file_location, $table_prefix=\'\') {\n		$eol = $this->eol;\n\n		$this->dump_file = Shuttle_Dump_File::create($export_file_location);\n\n		$this->dump_file->write(\"-- Generation time: \" . date(\'r\') . $eol);\n		$this->dump_file->write(\"-- Host: \" . $this->db->host . $eol);\n		$this->dump_file->write(\"-- DB name: \" . $this->db->name . $eol);\n		$this->dump_file->write(\"/*!40030 SET NAMES UTF8 */;$eol\");\n		\n		$this->dump_file->write(\"/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;$eol\");\n		$this->dump_file->write(\"/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;$eol\");\n		$this->dump_file->write(\"/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;$eol\");\n		$this->dump_file->write(\"/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;$eol\");\n		$this->dump_file->write(\"/*!40103 SET TIME_ZONE=\'+00:00\' */;$eol\");\n		$this->dump_file->write(\"/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;$eol\");\n		$this->dump_file->write(\"/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;$eol\");\n		$this->dump_file->write(\"/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE=\'NO_AUTO_VALUE_ON_ZERO\' */;$eol\");\n		$this->dump_file->write(\"/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;$eol$eol\");\n\n\n		$tables = $this->get_tables($table_prefix);\n		foreach ($tables as $table) {\n			$this->dump_table($table);\n		}\n		\n		$this->dump_file->write(\"$eol$eol\");\n		$this->dump_file->write(\"/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;$eol\");\n		$this->dump_file->write(\"/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;$eol\");\n		$this->dump_file->write(\"/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;$eol\");\n		$this->dump_file->write(\"/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;$eol\");\n		$this->dump_file->write(\"/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;$eol\");\n		$this->dump_file->write(\"/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;$eol\");\n		$this->dump_file->write(\"/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;$eol$eol\");\n\n		unset($this->dump_file);\n	}\n\n	protected function dump_table($table) {\n		$eol = $this->eol;\n\n		$this->dump_file->write(\"DROP TABLE IF EXISTS `$table`;$eol\");\n\n		$create_table_sql = $this->get_create_table_sql($table);\n		$this->dump_file->write($create_table_sql . $eol . $eol);\n\n		$data = $this->db->query(\"SELECT * FROM `$table`\");\n\n		$insert = new Shuttle_Insert_Statement($table);\n\n		while ($row = $this->db->fetch_row($data)) {\n			$row_values = array();\n			foreach ($row as $value) {\n				$row_values[] = $this->db->escape($value);\n			}\n			$insert->add_row( $row_values );\n\n			if ($insert->get_length() > self::INSERT_THRESHOLD) {\n				// The insert got too big: write the SQL and create\n				// new insert statement\n				$this->dump_file->write($insert->get_sql() . $eol);\n				$insert->reset();\n			}\n		}\n\n		$sql = $insert->get_sql();\n		if ($sql) {\n			$this->dump_file->write($insert->get_sql() . $eol);\n		}\n		$this->dump_file->write($eol . $eol);\n	}\n	\n	public function get_create_table_sql($table) {\n		$create_table_sql = $this->db->fetch(\'SHOW CREATE TABLE `\' . $table . \'`\');\n		return $create_table_sql[0][\'Create Table\'] . \';\';\n	}\n}\n\nclass Shuttle_DBConn {\n	public $host;\n	public $username;\n	public $password;\n	public $name;\n\n	protected $connection;\n\n	function __construct($options) {\n		$this->host = $options[\'host\'];\n		if (empty($this->host)) {\n			$this->host = \'127.0.0.1\';\n		}\n		$this->username = $options[\'username\'];\n		$this->password = $options[\'password\'];\n		$this->name = $options[\'db_name\'];\n	}\n\n	static function create($options) {\n		if (class_exists(\'mysqli\')) {\n			$class_name = \"Shuttle_DBConn_Mysqli\";\n		} else {\n			$class_name = \"Shuttle_DBConn_Mysql\";\n		}\n\n		return new $class_name($options);\n	}\n}\n\nclass Shuttle_DBConn_Mysql extends Shuttle_DBConn {\n	function connect() {\n		$this->connection = @mysql_connect($this->host, $this->username, $this->password);\n		if (!$this->connection) {\n			throw new Shuttle_Exception(\"Couldn\'t connect to the database: \" . mysql_error());\n		}\n\n		$select_db_res = mysql_select_db($this->name, $this->connection);\n		if (!$select_db_res) {\n			throw new Shuttle_Exception(\"Couldn\'t select database: \" . mysql_error($this->connection));\n		}\n\n		return true;\n	}\n\n	function query($q) {\n		if (!$this->connection) {\n			$this->connect();\n		}\n		$res = mysql_query($q);\n		if (!$res) {\n			throw new Shuttle_Exception(\"SQL error: \" . mysql_error($this->connection));\n		}\n		return $res;\n	}\n\n	function fetch_numeric($query) {\n		return $this->fetch($query, MYSQL_NUM);\n	}\n\n	function fetch($query, $result_type=MYSQL_ASSOC) {\n		$result = $this->query($query, $this->connection);\n		$return = array();\n		while ( $row = mysql_fetch_array($result, $result_type) ) {\n			$return[] = $row;\n		}\n		return $return;\n	}\n\n	function escape($value) {\n		if (is_null($value)) {\n			return \"NULL\";\n		}\n		return \"\'\" . mysql_real_escape_string($value) . \"\'\";\n	}\n\n	function escape_like($search) {\n		return str_replace(array(\'_\', \'%\'), array(\'\\_\', \'\\%\'), $search);\n	}\n\n	function get_var($sql) {\n		$result = $this->query($sql);\n		$row = mysql_fetch_array($result);\n		return $row[0];\n	}\n\n	function fetch_row($data) {\n		return mysql_fetch_assoc($data);\n	}\n}\n\n\nclass Shuttle_DBConn_Mysqli extends Shuttle_DBConn {\n	function connect() {\n		$this->connection = @new MySQLi($this->host, $this->username, $this->password, $this->name);\n\n		if ($this->connection->connect_error) {\n			throw new Shuttle_Exception(\"Couldn\'t connect to the database: \" . $this->connection->connect_error);\n		}\n\n		return true;\n	}\n\n	function query($q) {\n		if (!$this->connection) {\n			$this->connect();\n		}\n		$res = $this->connection->query($q);\n		\n		if (!$res) {\n			throw new Shuttle_Exception(\"SQL error: \" . $this->connection->error);\n		}\n		\n		return $res;\n	}\n\n	function fetch_numeric($query) {\n		return $this->fetch($query, MYSQLI_NUM);\n	}\n\n	function fetch($query, $result_type=MYSQLI_ASSOC) {\n		$result = $this->query($query, $this->connection);\n		$return = array();\n		while ( $row = $result->fetch_array($result_type) ) {\n			$return[] = $row;\n		}\n		return $return;\n	}\n\n	function escape($value) {\n		if (is_null($value)) {\n			return \"NULL\";\n		}\n		return \"\'\" . $this->connection->real_escape_string($value) . \"\'\";\n	}\n\n	function escape_like($search) {\n		return str_replace(array(\'_\', \'%\'), array(\'\\_\', \'\\%\'), $search);\n	}\n\n	function get_var($sql) {\n		$result = $this->query($sql);\n		$row = $result->fetch_array($result, MYSQLI_NUM);\n		return $row[0];\n	}\n\n	function fetch_row($data) {\n		return $data->fetch_array(MYSQLI_ASSOC);\n	}\n}\n\nclass Shuttle_Exception extends Exception {};\n\n','','0','2017-12-27 20:14:22','globeadmin','2017-12-31 09:58:05','globeadmin','2017-12-31 09:58:05','globeadmin','0'),('5a47ce353542e1e','backup_db_get_file','Λήψη του αντιγράφου ασφαλείας της βάσης δεδομένων που έχει ήδη δημιουργηθεί','manager','if(\'#backup_file_name#\'!=\'\' && \'#backup_file_name#\'!=\'#\'.\'backup_file_name#\'){\n    \n    $backup_name = \'#backup_file_name#\';\n    \n    if(file_exists ($backup_name)){\n    \n        if(\'#send_file_name#\'!=\'\' && \'#send_file_name#\'!=\'#\'.\'send_file_name#\'){\n            $fname = \'#send_file_name#\';\n        } else{\n            $rpath  = realpath($backup_name);\n            $dir    = dirname($rpath);\n        \n            $s      = strlen($dir)+1;\n            $fname  = substr($rpath,$s);             \n        }\n        \n        $valid_extensions = array(\".sql\",\".xls\",\".zip\",\".xml\");\n        \n        if(in_array(substr($backup_name, -4),$valid_extensions)){\n            header(\'Content-Type: application/octet-stream\');   \n            header(\"Content-Transfer-Encoding: Binary\"); \n            header(\"Content-disposition: attachment; filename=\\\"\".$fname.\"\\\"\");\n\n            if (    isset($_SERVER[\'HTTP_ACCEPT_ENCODING\']) && \n                    strpos( $_SERVER[\'HTTP_ACCEPT_ENCODING\'], \'gzip\' ) !== false &&\n                    function_exists(\'ob_gzhandler\') &&\n                    ini_get(\'zlib.output_compression\')) {\n                header(\'Content-Encoding: gzip\');\n            } \n            ob_clean();\n            $handle = @fopen($backup_name, \"rb\");\n            if ($handle) {\n                while (!feof($handle)) {\n	                $buffer = @fread($handle, 1024*8);\n	                print($buffer);\n	                ob_flush();\n	                flush();                    \n                }\n                fclose($handle);\n            }\n            unlink($backup_name);\n        }\n    }\n}\n\n','','0','2017-12-30 19:34:45','globeadmin','2021-01-30 11:41:33','globeadmin','2021-04-01 20:26:38','globeadmin','0'),('5a5273258ad81dd','print_penalty_book','Δημιουργεί τον προσωρινό πίνακα για την εκτύπωση πολλών ποινών μαζί','teacher','$sql=\"DROP TEMPORARY TABLE IF EXISTS #TABLE_ID#\";\nnuRunQuery($sql);\n\n$sql=\"CREATE TEMPORARY TABLE #TABLE_ID# DEFAULT CHARACTER SET=utf8\nSELECT\n	student.id as student_id,\n	concat(student.surname,\' \',student.name,if(student.fathers_name is NULL,\'\',concat(\' πατ. \',student.fathers_name)),\' (ΑΜ:\',student.registration_number,\')\') as student_full_name,\n	date_format(penalty.date_enforced,\'%d-%m-%Y\') as penalty_date_enforced,\n	penalty.type as penalty_type,\n	penalty.reason as penalty_reason,\n	concat(if(penalty.carrier is NULL,\'\',penalty.carrier),if(penalty.carrier IS NOT NULL AND after_referral=1,\' - \',\'\'),if(after_referral=1,\'Μετά από παραπομπή\',\'\')) as penalty_carrier,\n	school.name as school_name,\n	school_year.name as school_year_name,\n	date_format(curdate(),\'%d-%m-%Y\') as cur_date,\n	if(teacher.id IS NULL,\'\',CONCAT(if(teacher.surname is null,\'\',concat(trim(teacher.surname),\' \')), IFNULL(teacher.name,\'\'))) as teacher_name,\n	if(period.id IS NULL,\'\',period.name) as period_short_name,\n	penalty.apology as penalty_apology,\n	if(teacher.id IS NULL,\'\',\'Ο Καθηγητής\') teacher_label\nFROM penalty\nINNER JOIN student ON  student.id = penalty.student_id\nINNER JOIN school on school.id = 1\nINNER JOIN school_year on school_year.id = school.school_year_id\nLEFT JOIN teacher ON teacher.id=penalty.teacher_id\nLEFT JOIN period ON period.id = penalty.period_id\";\n\nif(\'#class_id#\'!=\'#\'.\'class_id#\' && \'#class_id#\'!=\'\'){\n    $sql=$sql.\" \n            INNER JOIN student_class on (student_class.student_id=student.id AND student_class.class_id=#class_id#)\";\n} \n\n$sql=$sql.\"            \n        WHERE\n\";\nif(\'#from_date#\'!=\'#\'.\'from_date#\' && \'#from_date#\'!=\'\'){\n    $sql=$sql.\" penalty.date_enforced >= \'#from_date#\' and \n    \";\n}\nif(\'#to_date#\'!=\'#\'.\'to_date#\' && \'#to_date#\'!=\'\'){\n    $sql=$sql.\" penalty.date_enforced <= \'#to_date#\' and \n    \";\n}\n\nif(\'#student_id#\'!=\'#\'.\'student_id#\' && \'#student_id#\'!=\'\'){\n    $sql=$sql.\" student.id = \'#student_id#\' and \n    \";\n    $is_student=1;\n}\n\nif(\'#teacher_id#\'!=\'#\'.\'teacher_id#\' && \'#teacher_id#\'!=\'\'){\n    $sql=$sql.\" penalty.teacher_id = \'#teacher_id#\' and \n    \";\n}\n\nif(\'#type_sumo#\'!=\'#\'.\'type_sumo#\' && \'#type_sumo#\'!=\'\'){\n    \n    $pieces = explode(\",\", \'#type_sumo#\');\n    foreach($pieces as &$piece){\n        $piece = \"\'\".$piece.\"\'\";\n    }\n    $types = implode(\",\",$pieces);\n    \n    $sql=$sql.\" penalty.type IN ($types) and \n    \";\n}\n\nif(\'#carrier#\'!=\'#\'.\'carrier#\' && \'#carrier#\'!=\'\'){\n    if(\'#carrier#\'==\'-\'){\n        $sql=$sql.\" penalty.carrier IS NULL and \n    \";        \n    } else {\n        $sql=$sql.\" penalty.carrier = \'#carrier#\' and \n    \";        \n    }\n}\n$sql=$sql.\"\n    1=1\n    order by student.surname,student.name,student.fathers_name,penalty.date_enforced,penalty.period_id\n\";\nnuRunQuery($sql);','','0','2018-01-07 21:21:09','globeadmin','2018-02-09 13:47:33','globeadmin','2018-02-09 13:47:33','globeadmin','0'),('5a453233d2245ec','backup_db_download','Λήψη αντιγράφου ασφαλείας της βάσης δεδομένων και αποστολή του','manager','nuRunPHP(\'backup_db_lib\');\n\ntry {\n	\n    $db = nuRunQuery();\n\n    $db_dumper = Shuttle_Dumper::create(array(\n        \'host\' => $db[0],\n        \'username\' => $db[2],\n        \'password\' => $db[3],\n        \'db_name\' => $db[1],\n    ));\n\n    $backup_name = sys_get_temp_dir().DIRECTORY_SEPARATOR.$db[1].\".sql\";\n    \n    $db_dumper->dump($backup_name );\n    \n    header(\'Content-Type: application/octet-stream\');   \n    header(\"Content-Transfer-Encoding: Binary\"); \n    header(\"Content-disposition: attachment; filename=\\\"\".$db[1].\".sql\".\"\\\"\");\n    \n    $handle = @fopen($backup_name, \"r\");\n    if ($handle) {\n        while (($buffer = fgets($handle, 4096)) !== false) {\n            echo $buffer;\n        }\n        fclose($handle);\n    }\n    \n    unlink($backup_name);\n\n} catch(Shuttle_Exception $e) {\n    nuDebug(\"Couldn\'t dump database: \" . $e->getMessage());\n    $nuError = \"Παρουσιάστηκε σφάλμα κατά την εξαγωγή της βάσης δεδομένων!\";\n}\n','','0','2017-12-28 20:04:35','globeadmin','2018-01-09 18:53:12','globeadmin','2018-01-09 18:57:12','globeadmin','0'),('5a464a6044084ff','backup_progress_version','07. Εμφανίζει μήνυμα για την λήψη backup της βάσης δεδομένων','Manager','print \"<html>\n<head>\n\n<meta charset=\\\"UTF-8\\\">\n\n<STYLE TYPE=\\\"text/css\\\">\n body {\n        margin: 5px 0px 0px 10px;\n    }\n    \n    .demo-wrapper {\n	    vertical-align: middle;\n	    width: 500px;\n	    height: 30px;\n	    margin: 6px 0px 0px 0px;\n	    border-radius: 3px;\n	    background-color: #fff;\n	    box-shadow:  0px 1px 2px 0px rgba(0, 0, 0, .2);\n    }\n\n\n    .pl{\n	    padding: 9px 10px 9px 10px;\n	    vertical-align: middle;\n	    margin-left: 0px;\n	    margin-rigth: 5px;\n	    font-family:Verdana;\n        font-size:8pt;\n        font-weight: bold;\n	    color: #555;\n	    height: 18px;\n	    float: left;\n    }\n    \n    .mytable TH{\n        font-family:Verdana;\n        font-size:9pt;\n        border: 2px solid Gray;\n        padding: 8px 12px 8px 12px;\n    }\n</STYLE>\n\n<script type=\\\"text/javascript\\\">\n\nfunction ChangeCursor(cell) {\n    cell.style.cursor=\\\"pointer\\\";\n}\n\nfunction RestoreCursor(cell) {\n    cell.style.cursor=\\\"auto\\\";\n}\n\nfunction show_button() {\n    var x = document.getElementById(\\\"button_table\\\");\n    x.style.display = \\\"block\\\";    \n}\n\nfunction set_message(msg) {\n    var x = document.getElementById(\\\"message_cell\\\");\n    x.innerHTML  = msg;    \n}\n\nfunction button_action(){\n    parent.display_msg(\'<hr>\');\n    parent.display_msg(\'<b>Βήμα 5 από 6: Ενημέρωση βάσης δεδομένων...</b>\',\'loader\');\n    parent.nuRunPHP(\'update_progress_version\',\'progress_iframe\');\n}\n\n</script>\n</head>\n<body>\n    <table border=0 cellspacing=0>\n        <tr height=60>\n            <td>\n	            <div class=\\\"demo-wrapper\\\">\n		                <span id=\\\"message_cell\\\" class=\\\"pl\\\">Το αντίγραφό ασφαλείας δημιουργείται. Παρακαλώ περιμένετε...</span>\n	            </div>                        \n            </td>\n            <td width=20>\n            </td>\n            <td>\n                <table cellspacing=0 CLASS=\\\"mytable\\\" align=left id=\\\"button_table\\\" style=\\\"display:none;\\\">\n                    <tr>\n                        <th width=250 bgcolor=#00cc00 style=\\\"color:lightyellow\\\" onclick=\\\"button_action()\\\" onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\">\n                            <u>Ενημέρωση Βάσης Δεδομένων</u>\n                        </th>    \n                    </tr>\n                </table>\n            </td>\n        </tr>\n    </table>\n    <script>\n        parent.nuAjax(\'backup_db_file\',\'get_backup_file\',{async:true});\n    </script>\n</body>\n</html>\";','','0','2017-12-29 16:00:00','globeadmin','2018-01-01 11:30:51','globeadmin','2018-06-23 09:34:59','globeadmin','0'),('5a48f38d2e8d6bd','update_db_version','09. Ενημερώνει τη βάση δεδομένων στη νέα έκδοση','manager','$download_dest = \'tmp\';\n$lock_file = $download_dest.DIRECTORY_SEPARATOR.\"lock\";\n\n$fp = fopen($lock_file, \"w\");\n\n$nuParameters = \'-1\';\n\nif (flock($fp, LOCK_EX)) {\n    \n    \n    flock($fp, LOCK_UN);\n}\n\nfclose($fp);\nunlink($lock_file);','','0','2017-12-31 16:26:21','globeadmin','2018-01-01 12:34:42','globeadmin','2018-01-01 12:34:42','globeadmin','0'),('5a4f4833bacfc5c','penalty_export','Εξαγωγή Ποινών στο Excel','Teacher','require_once(\'Classes/PHPExcel.php\');\n\n$nuParameters = \'-1\';\n$filefordown = sys_get_temp_dir().DIRECTORY_SEPARATOR.\"penalty_#RECORD_ID#.xls\";\n\n$sql=\"  SELECT \n            student.registration_number,\n            grade.short_name,\n            student.surname,\n            student.name,\n            ifNULL(student.fathers_name,\'\'),\n            DATE_FORMAT(penalty.date_enforced,\'%d-%m-%Y\'),\n            ifNULL(period.short_name,\'\'),\n            penalty.type,\n            ifNULL(penalty.reason,\'\'),\n            ifNULL(penalty.carrier,\'\'),\n            concat(if(teacher.surname is null,\'\',concat(teacher.surname,\' \')), IFNULL(teacher.name,\'\'))\n        FROM penalty\n            INNER JOIN student          ON  penalty.student_id              = student.id\n            INNER JOIN grade            ON  grade.id                        = student.grade_id\n            LEFT JOIN teacher           ON  penalty.teacher_id              = teacher.id\n            LEFT JOIN period            ON  penalty.period_id               = period.id\n        WHERE\n\";\n\nif(\'#from_date#\'!=\'#\'.\'from_date#\' && \'#from_date#\'!=\'\'){\n    $sql=$sql.\" penalty.date_enforced >= \'#from_date#\' and \n    \";\n}\nif(\'#to_date#\'!=\'#\'.\'to_date#\' && \'#to_date#\'!=\'\'){\n    $sql=$sql.\" penalty.date_enforced <= \'#to_date#\' and \n    \";\n}\n\nif(\'#student_id#\'!=\'#\'.\'student_id#\' && \'#student_id#\'!=\'\'){\n    $sql=$sql.\" student.id = \'#student_id#\' and \n    \";\n    $is_student=1;\n}\n\nif(\'#teacher_id#\'!=\'#\'.\'teacher_id#\' && \'#teacher_id#\'!=\'\'){\n    $sql=$sql.\" penalty.teacher_id = \'#teacher_id#\' and \n    \";\n}\n\nif(\'#type_sumo#\'!=\'#\'.\'type_sumo#\' && \'#type_sumo#\'!=\'\'){\n    \n    $pieces = explode(\",\", \'#type_sumo#\');\n    foreach($pieces as &$piece){\n        $piece = \"\'\".$piece.\"\'\";\n    }\n    $types = implode(\",\",$pieces);\n    \n    $sql=$sql.\" penalty.type IN ($types) and \n    \";\n}\n\nif(\'#carrier#\'!=\'#\'.\'carrier#\' && \'#carrier#\'!=\'\'){\n    if(\'#carrier#\'==\'-\'){\n        $sql=$sql.\" penalty.carrier IS NULL and \n    \";        \n    } else {\n        $sql=$sql.\" penalty.carrier = \'#carrier#\' and \n    \";        \n    }\n}\n\n\n\n$sql=$sql.\"\n    1=1\n    order by grade.short_name,student.surname,student.name,student.fathers_name,penalty.date_enforced,penalty.period_id\n\";\n\n$retval=nuRunQuery($sql);\n\nif($retval) {\n    if(db_num_rows($retval)>0) {\n            \n        $objPHPExcel = new PHPExcel();\n            \n        $objPHPExcel->getProperties()->setCreator(\'Papadakakis Nektarios\')\n							 ->setLastModifiedBy(\'Papadakakis Nektarios\')\n							 ->setTitle(\'sisyphos Export for mySchool\')\n							 ->setSubject(\'sisyphos\')\n							 ->setDescription(\'Marks file for myschool information system\')\n							 ->setKeywords(\'Excel sisyphos myschool\')\n							 ->setCategory(\'sisyphos\');\n			\n        $objPHPExcel->getActiveSheet()->setTitle(\'Ποινές\');\n            \n        $objPHPExcel->getDefaultStyle()->getFont()->setName(\'Arial\')\n                                        ->setSize(10);\n        \n        $objPHPExcel->getActiveSheet()->getStyle(\'I1:I999\')->getAlignment()->setWrapText(true);\n        \n        $objPHPExcel->getActiveSheet()->getStyle(\'A2:B999\')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);\n        $objPHPExcel->getActiveSheet()->getStyle(\'A1:K1\')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);\n        \n        $objPHPExcel->getActiveSheet() ->getColumnDimension(\'A\') ->setWidth(8);\n        $objPHPExcel->getActiveSheet() ->getColumnDimension(\'B\') ->setWidth(8);\n        $objPHPExcel->getActiveSheet() ->getColumnDimension(\'C\') ->setWidth(25);\n        $objPHPExcel->getActiveSheet() ->getColumnDimension(\'D\') ->setWidth(20);\n        $objPHPExcel->getActiveSheet() ->getColumnDimension(\'E\') ->setWidth(20);\n        $objPHPExcel->getActiveSheet() ->getColumnDimension(\'F\') ->setWidth(15);\n        $objPHPExcel->getActiveSheet() ->getColumnDimension(\'G\') ->setWidth(8);\n        $objPHPExcel->getActiveSheet() ->getColumnDimension(\'H\') ->setWidth(30);\n        $objPHPExcel->getActiveSheet() ->getColumnDimension(\'I\') ->setWidth(60);\n        $objPHPExcel->getActiveSheet() ->getColumnDimension(\'J\') ->setWidth(30);\n        $objPHPExcel->getActiveSheet() ->getColumnDimension(\'K\') ->setWidth(30);\n            \n        $data = array(  \"ΑΜ\",\n                        \"Τάξη\",\n                        \"Επώνυμο Μαθητή\",\n                        \"Όνομα Μαθητή\",\n                        \"Πατρώνυμο Μαθητή\",\n                        \"Ημερομηνία\",\n                        \"Ώρα\",\n                        \"Τύπος Ποινής\",\n                        \"Αιτία Ποινής\",\n                        \"Φορέας Επιβολής\",\n                        \"Καθηγητής\");\n        $objPHPExcel->setActiveSheetIndex(0);\n        $objPHPExcel->getActiveSheet()->fromArray($data,NULL,\'A1\');       \n        $objPHPExcel->getActiveSheet()->getStyle(\'A1:J1\')->getFont()->setBold(true);\n        \n        $i=2;\n        while($data = db_fetch_row($retval)) {\n            $objPHPExcel->setActiveSheetIndex(0);\n            $objPHPExcel->getActiveSheet()->fromArray($data,NULL,\'A\'.$i);\n            $i++;            \n        }\n        \n        $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, \'Excel5\');\n        $objWriter->save($filefordown);\n        \n        $nuParameters = $filefordown;\n    }\n    else{\n        $nuError = \"Δε βρέθηκαν ποινές για εξαγωγή!\";    \n    }\n}\nelse{\n    $nuError = \"Προσοχή! Παρουσιάστηκε σφάλμα κατά την εξαγωγή των ποινών!\";    \n}\n','','0','2018-01-05 11:41:07','globeadmin','2018-01-05 13:05:50','globeadmin','2018-02-05 19:05:23','globeadmin','0'),('5a3d4ce3031112d','unzip_new_version','04. Αποσυμπιέζει το αρχείο zip της νέας έκδοσης που έχει ληφθεί','manager','$download_dest = \'tmp\';\n$zip_file = $download_dest.DIRECTORY_SEPARATOR.\"sisyphos.zip\";\n$lock_file = $download_dest.DIRECTORY_SEPARATOR.\"lock\";\n\n$fp = fopen($lock_file, \"w\");\n\n$nuParameters = \'-1\';\n\nif (flock($fp, LOCK_EX)) {\n    $zip = new ZipArchive;\n    \n    if ($zip->open($zip_file) === TRUE) {\n        $zip->extractTo($download_dest);\n        $nuParameters = $zip->numFiles;\n        $zip->close();\n    }\n    \n    flock($fp, LOCK_UN);\n}\n\nfclose($fp);\nunlink($lock_file);\n\n\n','','0','2017-12-22 20:20:19','globeadmin','2018-01-01 11:30:14','globeadmin','2018-01-01 12:33:38','globeadmin','0'),('5a48d4e8ce664c8','unzip_progress_version','03. Εμφανίζει μήνυμα κατά τηv αποσυμπίεση του αρχείου zip της τελευταίας έκδοσης','Manager','$zip_file = \"tmp\".DIRECTORY_SEPARATOR.\"sisyphos.zip\";\n\nprint \"<html>\n<head>\n\n<meta charset=\\\"UTF-8\\\">\n\n<STYLE TYPE=\\\"text/css\\\">\n body {\n        margin: 5px 0px 0px 10px;\n    }\n    \n    .demo-wrapper {\n	    vertical-align: middle;\n	    width: 500px;\n	    height: 30px;\n	    margin: 6px 0px 0px 0px;\n	    border-radius: 3px;\n	    background-color: #fff;\n	    box-shadow:  0px 1px 2px 0px rgba(0, 0, 0, .2);\n    }\n\n\n    .pl{\n	    padding: 9px 10px 9px 10px;\n	    vertical-align: middle;\n	    margin-left: 0px;\n	    margin-rigth: 5px;\n	    font-family:Verdana;\n        font-size:8pt;\n        font-weight: bold;\n	    color: #555;\n	    height: 18px;\n	    float: left;\n    }\n    \n    .mytable TH{\n        font-family:Verdana;\n        font-size:9pt;\n        border: 2px solid Gray;\n        padding: 8px 12px 8px 12px;\n    }\n</STYLE>\n\n<script type=\\\"text/javascript\\\">\n\nfunction ChangeCursor(cell) {\n    cell.style.cursor=\\\"pointer\\\";\n}\n\nfunction RestoreCursor(cell) {\n    cell.style.cursor=\\\"auto\\\";\n}\n\nfunction show_button() {\n    var x = document.getElementById(\\\"button_table\\\");\n    x.style.display = \\\"block\\\";\n}\n\nfunction set_message(msg) {\n    var x = document.getElementById(\\\"message_cell\\\");\n    x.innerHTML  = msg;    \n}\n\nfunction button_action(){\n    parent.display_msg(\'<hr>\');\n    parent.display_msg(\'<b>Βήμα 3 από 6: Σύγκριση και αντιγραφή αρχείων...</b>\',\'loader\');\n    parent.nuRunPHP(\'copy_progress_version\',\'progress_iframe\');\n}\n\n</script>\n</head>\n<body>\n    <table border=0 cellspacing=0>\n        <tr height=60>\n            <td>\n	            <div class=\\\"demo-wrapper\\\">\n		                <span id=\\\"message_cell\\\" class=\\\"pl\\\">Αποσυμπίεση του $zip_file. Παρακαλώ περιμένετε...</span>\n	            </div>                        \n            </td>\n            <td width=20>\n            </td>\n            <td>\n                <table cellspacing=0 CLASS=\\\"mytable\\\" align=left id=\\\"button_table\\\" style=\\\"display:none;\\\">\n                    <tr>\n                        <th width=200 bgcolor=#00cc00 style=\\\"color:lightyellow\\\" onclick=\\\"button_action()\\\" onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\">\n                            <u>Αντιγραφή Αρχείων</u>\n                        </th>    \n                    </tr>\n                </table>\n            </td>\n        </tr>\n    </table>\n    <script>\n        parent.nuAjax(\'unzip_new_version\',\'unzip_results\',{async:true});\n    </script>\n</body>\n</html>\";','','0','2017-12-31 14:15:36','globeadmin','2018-01-01 11:30:01','globeadmin','2018-06-29 00:16:54','globeadmin','0'),('5a48f33613f2b2b','update_progress_version','08. Εμφανίζει μήνυμα για την ενημέρωση της βάσης δεδομένων','Manager','print \"<html>\n<head>\n\n<meta charset=\\\"UTF-8\\\">\n\n<STYLE TYPE=\\\"text/css\\\">\n body {\n        margin: 5px 0px 0px 10px;\n    }\n    \n    .demo-wrapper {\n	    vertical-align: middle;\n	    width: 500px;\n	    height: 30px;\n	    margin: 6px 0px 0px 0px;\n	    border-radius: 3px;\n	    background-color: #fff;\n	    box-shadow:  0px 1px 2px 0px rgba(0, 0, 0, .2);\n    }\n\n\n    .pl{\n	    padding: 9px 10px 9px 10px;\n	    vertical-align: middle;\n	    margin-left: 0px;\n	    margin-rigth: 5px;\n	    font-family:Verdana;\n        font-size:8pt;\n        font-weight: bold;\n	    color: #555;\n	    height: 18px;\n	    float: left;\n    }\n    \n    .mytable TH{\n        font-family:Verdana;\n        font-size:9pt;\n        border: 2px solid Gray;\n        padding: 8px 12px 8px 12px;\n    }\n</STYLE>\n\n<script type=\\\"text/javascript\\\">\n\nfunction ChangeCursor(cell) {\n    cell.style.cursor=\\\"pointer\\\";\n}\n\nfunction RestoreCursor(cell) {\n    cell.style.cursor=\\\"auto\\\";\n}\n\nfunction show_button() {\n    var x = document.getElementById(\\\"button_table\\\");\n    x.style.display = \\\"block\\\";    \n}\n\nfunction set_message(msg) {\n    var x = document.getElementById(\\\"message_cell\\\");\n    x.innerHTML  = msg;    \n}\n\nfunction button_action(){\n    parent.display_msg(\'<hr>\');\n    parent.display_msg(\'<b>Βήμα 6 από 6: Εκκαθάριση προσωρινών αρχείων...</b>\',\'loader\');\n    //parent.nuRunPHP(\'cleanup_progress_version\',\'progress_iframe\');\n}\n\n</script>\n</head>\n<body>\n    <table border=0 cellspacing=0>\n        <tr height=60>\n            <td>\n	            <div class=\\\"demo-wrapper\\\">\n		                <span id=\\\"message_cell\\\" class=\\\"pl\\\">Η βάση δεδομένων ενημερώνεται. Παρακαλώ περιμένετε...</span>\n	            </div>                        \n            </td>\n            <td width=20>\n            </td>\n            <td>\n                <table cellspacing=0 CLASS=\\\"mytable\\\" align=left id=\\\"button_table\\\" style=\\\"display:none;\\\">\n                    <tr>\n                        <th width=250 bgcolor=#00cc00 style=\\\"color:lightyellow\\\" onclick=\\\"button_action()\\\" onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\">\n                            <u>Εκκαθάριση Προσωρινών Αρχείων</u>\n                        </th>    \n                    </tr>\n                </table>\n            </td>\n        </tr>\n    </table>\n    <script>\n        //parent.nuAjax(\'update_db_version\',\'update_db_results\',{async:true});\n    </script>\n</body>\n</html>\";','','0','2017-12-31 16:24:54','globeadmin','2018-01-01 11:31:02','globeadmin','2018-06-29 00:17:33','globeadmin','0'),('5a60ab1d143a8e7','add_mass_comments','Εισαγάγει μαζικά σχόλια στους μαθητές ενός τμήματος για ένα μάθημα','teacher','nuRunPHP(\'notification_add_lib\');\n\n$nuParameters = \"\";\n\n$json_str = stripslashes(\'#comments_JSON#\'); \n$json = json_decode($json_str,true);\n\n$i=0;\n\nif (json_last_error() === JSON_ERROR_NONE) {\n\n    foreach ($json as $comment){\n        \n        if(\'#teacher_chk_hash#\'==\'1\' || \'#student_chk_hash#\'==\'1\'){\n            $sql=\" UPDATE comment SET \n                        post_teacher_id = \'#RECORD_ID#\',\n                        changed_at = now()\n                    WHERE id=\'\".$comment[0].\"\'\";  \n            nuRunQuery($sql);\n            $i++;\n        }\n        \n        if(\'#teacher_chk_hash#\'==\'1\'){\n            $sql=\"  UPDATE comment SET \n                        teacher_comments = CONCAT(if(teacher_comments IS NULL OR TRIM(teacher_comments)=\'\',\'\',CONCAT(teacher_comments,\'<BR>\')),\'\".esc($comment[1]).\"\')\n                    WHERE id=\'\".$comment[0].\"\'\"; \n            nuRunQuery($sql);\n        }\n        \n        if(\'#student_chk_hash#\'==\'1\'){\n            $sql=\" UPDATE comment SET \n                        student_comments = CONCAT(if(student_comments IS NULL OR TRIM(student_comments)=\'\',\'\',CONCAT(student_comments,\'<BR>\')),\'\".esc($comment[1]).\"\'),\n                        student_comments_changed_at = now()\n                    WHERE id=\'\".$comment[0].\"\'\";\n            nuRunQuery($sql);\n    \n            update_comment_notification($comment[0]);\n        }\n    }\n    \n    $nuParameters = \"Ενημερώθηκαν $i σχόλια μαθητών!\";\n\n} else {\n    nuDebug(\'Append mass comments : JSON ERROR -> #comments_JSON#\');\n    $nuError = \"Παρουσιάστηκε σφάλμα κατά την προσθήκη των σχολίων!\\nΤα σχόλια δεν προστέθηκαν!\";\n}\n\n','','0','2018-01-18 16:11:41','globeadmin','2019-03-09 10:45:41','globeadmin','2019-03-09 16:08:14','globeadmin','0'),('5a788f06d54e1a2','class_excel_export','Εξαγωγή Μαθητών τμήματος στο Excel','Teacher','require_once(\'Classes/PHPExcel.php\');\n\n$nuParameters = \'-1\';\n\n$sql=\"  SELECT \n            class.id,\n            subject.id,\n            school.name,\n            school_year.name,\n            ifNULL(grade.short_name,\'\'),\n            class.short_name,\n            ifNULL(class.name,\'\'),\n            subject.name,\n            ifNULL(subject_type.name,\'\')\n        FROM class\n        INNER JOIN session_variables    ON  session_variables.session_id    = \'#session_id#\'\n        INNER JOIN subject              ON  subject.id                      = session_variables.subject_id\n        INNER JOIN school               ON  school.id                       = 1\n        INNER JOIN school_year          ON  school_year.id                  = school.school_year_id\n        LEFT JOIN grade                ON  grade.id                        = class.grade_id\n        LEFT JOIN subject_type          ON  subject_type.id                 = subject.subject_type_id\n        WHERE\n            class.id = session_variables.class_id\n\";\n$rv=nuRunQuery($sql);\nif($rv) {\n    if(db_num_rows($rv)>0) {\n    \n        $r = db_fetch_row($rv);\n\n        $filefordown = sys_get_temp_dir().DIRECTORY_SEPARATOR.$r[0].\"-\".$r[1].\"-#RECORD_ID#.xls\";\n\n        $objPHPExcel = new PHPExcel();\n            \n        $objPHPExcel->getProperties()->setCreator(\'Papadakakis Nektarios\')\n							 ->setLastModifiedBy(\'Papadakakis Nektarios\')\n							 ->setTitle(\'sisyphos Export\')\n							 ->setSubject(\'sisyphos\')\n							 ->setDescription(\'Students at Class\')\n							 ->setKeywords(\'Excel sisyphos\')\n							 ->setCategory(\'sisyphos\');\n			\n        $objPHPExcel->getActiveSheet()->setTitle(\'Μαθητές\');\n            \n        $objPHPExcel->getDefaultStyle()->getFont()->setName(\'Arial\')->setSize(10);\n        \n        $objPHPExcel->getActiveSheet()->mergeCells(\'A1:E1\');\n        $objPHPExcel->getActiveSheet()->mergeCells(\'A2:E2\');\n        \n        $objPHPExcel->getActiveSheet()->mergeCells(\'A3:B3\');\n        $objPHPExcel->getActiveSheet()->mergeCells(\'A4:B4\');\n        $objPHPExcel->getActiveSheet()->mergeCells(\'A5:B5\');\n\n        $objPHPExcel->getActiveSheet()->mergeCells(\'C3:E3\');\n        $objPHPExcel->getActiveSheet()->mergeCells(\'C4:E4\');\n        $objPHPExcel->getActiveSheet()->mergeCells(\'C5:E5\');\n        \n        $objPHPExcel->getActiveSheet()->mergeCells(\'A6:E6\');\n        $objPHPExcel->getActiveSheet()->mergeCells(\'A7:E7\');\n        \n        $objPHPExcel->getActiveSheet()->setCellValue(\'A1\',$r[2]);\n        $objPHPExcel->getActiveSheet()->setCellValue(\'A2\',$r[3]);\n        $objPHPExcel->getActiveSheet()->setCellValue(\'A3\',\'Τάξη : \');\n        $objPHPExcel->getActiveSheet()->setCellValue(\'A4\',\'Τμήμα : \');\n        $objPHPExcel->getActiveSheet()->setCellValue(\'A5\',\'Μάθημα : \');\n        $objPHPExcel->getActiveSheet()->setCellValue(\'A7\',\'Μαθητές\');\n        \n        $objPHPExcel->getActiveSheet()->setCellValue(\'C3\',$r[4]);\n        $objPHPExcel->getActiveSheet()->setCellValue(\'C4\',$r[5].\' (\'.$r[6].\')\');\n        $objPHPExcel->getActiveSheet()->setCellValue(\'C5\',$r[7].\'-\'.$r[8]);\n        \n        $objPHPExcel->getActiveSheet() ->getColumnDimension(\'A\') ->setWidth(5);\n        $objPHPExcel->getActiveSheet() ->getColumnDimension(\'B\') ->setWidth(7);\n        $objPHPExcel->getActiveSheet() ->getColumnDimension(\'C\') ->setWidth(30);\n        $objPHPExcel->getActiveSheet() ->getColumnDimension(\'D\') ->setWidth(25);\n        $objPHPExcel->getActiveSheet() ->getColumnDimension(\'E\') ->setWidth(25);\n        \n        $objPHPExcel->getActiveSheet() ->getDefaultRowDimension()->setRowHeight(17);\n    \n        $data = array(  \"ΑΑ\",\n                        \"ΑΜ\",\n                        \"Επώνυμο Μαθητή\",\n                        \"Όνομα Μαθητή\",\n                        \"Πατρώνυμο Μαθητή\"\n                        );\n        $objPHPExcel->setActiveSheetIndex(0);\n        $objPHPExcel->getActiveSheet()->fromArray($data,NULL,\'A8\');\n        $objPHPExcel->getActiveSheet()->getStyle(\'A6:E7\')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);\n        \n        $objPHPExcel->getActiveSheet()->getStyle(\'A4:E8\')->getFont()->setBold(true);\n        \n        $objPHPExcel->getActiveSheet()->getStyle(\'A8:A999\')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);\n\n        $sql=\"  SELECT \n                    student.registration_number,\n                    student.surname,\n                    student.name,\n                    ifNULL(student.fathers_name,\'\')\n                FROM student_class\n                INNER JOIN student              ON  student.id                      = student_class.student_id\n                INNER JOIN class                ON  class.id                        = student_class.class_id\n                INNER JOIN session_variables    ON  session_variables.session_id    = \'#session_id#\'\n                WHERE\n                    class.id = session_variables.class_id\n                ORDER BY student.surname,student.name,student.fathers_name\n            \";\n\n        $retval=nuRunQuery($sql);\n        \n        $i=9;\n        while($data = db_fetch_row($retval)) {\n            $objPHPExcel->setActiveSheetIndex(0);\n            $objPHPExcel->getActiveSheet()->setCellValue(\'A\'.$i,($i-8));\n            $objPHPExcel->getActiveSheet()->fromArray($data,NULL,\'B\'.$i);\n            $i++;\n        }\n    \n        $styleArray = array(\n            \'borders\' => array(\n                \'allborders\' => array(\n                    \'style\' => PHPExcel_Style_Border::BORDER_THIN\n                )\n            )\n        );\n        \n        $objPHPExcel->getActiveSheet()->getStyle(\'A7:E\'.($i-1))->applyFromArray($styleArray);\n        \n        $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, \'Excel5\');\n        $objWriter->save($filefordown);\n        \n        $nuParameters = $filefordown;\n    }\n    else{\n        $nuError = \"Δε βρέθηκαν στοιχεία για εξαγωγή!\";    \n    }\n}\nelse{\n    $nuError = \"Προσοχή! Παρουσιάστηκε σφάλμα κατά την εξαγωγή!\";    \n}\n','','0','2018-02-05 19:06:14','globeadmin','2018-02-06 00:05:38','globeadmin','2021-01-30 11:11:46','globeadmin','0'),('5a8c6664a38d180','absence_totals','Σύνολα απουσιών ανά λόγο διακιολόγησης ','teacher','if (\'#to_date#\'==\'#\'.\'to_date\'.\'#\' || \'#to_date#\'==\'\' || \'#to_date#\'>date(\'Y-m-d\')){\n    $to_date = date(\'Y-m-d\');\n} else {\n    $to_date = \'#to_date#\';\n}\n\n$sql=\"DROP TEMPORARY TABLE IF EXISTS #TABLE_ID#\";\nnuRunQuery($sql);\n\n$sql=\"CREATE TEMPORARY TABLE #TABLE_ID# DEFAULT CHARACTER SET=utf8\nSELECT \n                student.id as student_id,\n                \n                ifNULL(grade.short_name,\'\') as grade_short_name,\n                \n                concat(if(school.city is null,\'Ημερομηνία : \',concat(school.city,\', \')),DATE_FORMAT(curdate(),\'%d-%m-%Y\')) as cur_date,\n                school.name as school_name,\n                school_year.name as school_year_name,\n                concat(\'Απουσίες μαθητών από την έναρξη της σχολικής χρονιάς έως και τις \',DATE_FORMAT(\'\".$to_date.\"\',\'%d-%m-%Y\')) as text2,\n                \n                concat(ifNull(student.surname,\'\'),\' \',ifNull(student.name,\'\'),\' πατ. \',ifNull(student.fathers_name,\'\')) as student_full_name,\n                student.has_left_school as student_has_left_school,\n                \n                ifnull(prev_justified_absences,0) as prev_justified,\n                \n                sum(if(ab.counts is null,0,ab.counts))+ifnull(prev_an_justified_absences,0)+ifnull(prev_justified_absences,0) as synolo,\n                sum(if(ab.counts is null,0,if(ab.justified,ab.counts,0)))+ifnull(prev_justified_absences,0) as dikaiologimenes,\n                sum(if(ab.counts is null,0,if(ab.justified,0,ab.counts)))+ifnull(prev_an_justified_absences,0) as adikaiologites,\n                sum(if(ab.counts=0,1,0)) as diegramenes\n                \n            FROM student\n            LEFT JOIN grade ON grade.id = student.grade_id\n            \";\n\nif(\'#class_id#\'!=\'#\'.\'class_id#\' && \'#class_id#\'!=\'\' ){\n$sql=$sql.\"\n                INNER JOIN  (select distinct student_id from student_class where class_id in (#class_id#)) as sc ON  student.id = sc.student_id\";\n}\n\n$sql=$sql.\"\n                INNER JOIN school on school.id=1\n                INNER JOIN school_year on school.school_year_id = school_year.id\n                LEFT JOIN ( select \n								    absence.student_id,\n									absence.counts,\n									absence.justified\n							from absence\n							where DATE_FORMAT(absence.absence_date, \'%Y-%m-%d\') <= \'\".$to_date.\"\') \n						as ab ON student.id    =   ab.student_id\n            WHERE\n\";\n\nif(\'#class_id#\'==\'#\'.\'class_id#\' || \'#class_id#\'==\'\'){\n$sql=$sql.\" student.teacher_id = \'#RECORD_ID#\' and \n\";\n}\n\nif(\'#export_student_id#\'!=\'#\'.\'export_student_id#\' && \'#export_student_id#\'!=\'\' ){\n    $sql=$sql.\" student.id = \'#export_student_id#\' and \n\";\n}\n\nif(\'#has_left_school#\'!=\'#\'.\'has_left_school#\' && \'#has_left_school#\'!=\'\' && \'#has_left_school#\'==\'1\'){\n    $sql=$sql.\" student.has_left_school = 0 and \n    \";\n}\n\nif(\'#absence_limit#\'!=\'#\'.\'absence_limit#\' && \'#absence_limit#\'!=\'\'){\n    $limit=\'#absence_limit#\';\n} else {\n    $limit=0;\n}\n\n$sql=$sql.\"\n            1=1\n            GROUP BY student.id\n            HAVING synolo>=\".$limit.\"\n            ORDER BY student.grade_id,student.surname,student.name,student.fathers_name\n\";\n\nnuRunQuery($sql);\n\n$sql = \"SELECT DISTINCT\n            justified_reason.id,\n            justified_reason.name,\n            justified_reason.short_name,\n            justified_reason.counts\n		FROM absence\n		INNER JOIN #TABLE_ID# ON #TABLE_ID#.student_id = absence.student_id\n		INNER JOIN justified_reason ON justified_reason.id = absence.justified_reason_id\n		WHERE \n		    absence.justified = 1 AND\n		    DATE_FORMAT(absence.absence_date, \'%Y-%m-%d\') <= \'\".$to_date.\"\'\n        ORDER BY justified_reason.counts desc,justified_reason.id\";\n$retval = nuRunQuery($sql);\n\n$justified_reason_array = array();\n\nif($retval){\n    while($row = db_fetch_row($retval)){\n        \n        $justified_reason_array[] = array($row[0],$row[1],$row[2],$row[3]);\n        \n        $col_name1 = \"js_\".$row[0];\n        $col_name2 = \"jd_\".$row[0];\n        \n        $sql=\"ALTER TABLE #TABLE_ID# \n                ADD COLUMN $col_name1 INT NOT NULL DEFAULT 0,\n                ADD COLUMN $col_name2 INT NOT NULL DEFAULT 0\n        \";\n        nuRunQuery($sql);\n    }\n}\n\n$sql = \"SELECT student_id FROM #TABLE_ID# WHERE 1\";\n$retval = nuRunQuery($sql);\nif($retval){\n    while($row = db_fetch_row($retval)){\n    \n        $sql = \"SELECT justified_reason_id, count(*), count(DISTINCT absence_date)\n		        FROM absence\n		        WHERE \n		            absence.student_id = \'\".$row[0].\"\' AND\n		            absence.justified = 1 AND\n		            DATE_FORMAT(absence.absence_date, \'%Y-%m-%d\') <= \'\".$to_date.\"\'\n		        GROUP BY justified_reason_id\n		    \";\n        $rv = nuRunQuery($sql);\n        \n        while($r=db_fetch_row($rv)){\n        \n            $col_name1 = \"js_\".$r[0];\n            $col_name2 = \"jd_\".$r[0];\n            \n            $col_val1 = $r[1]; \n            $col_val2 = $r[2];\n            \n            $sql = \"UPDATE #TABLE_ID# SET $col_name1=$col_val1,$col_name2=$col_val2  WHERE student_id=\'\".$row[0].\"\'\";\n            nuRunQuery($sql);\n        }\n    }\n}\n\n\nprint \"<html>\n<head>\n\n<meta charset=\\\"UTF-8\\\">\n<script src=\\\"sisIframe.js\\\"></script>\n<link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n    \n<STYLE TYPE=\\\"text/css\\\">\n    .print-only{\n        display: none;\n    }\n    \n    @media print{\n        @page {size: landscape},\n        #pager,\n        form,\n        .no-print{\n            display: none !important;\n            height: 0;\n        }\n            \n        .no-print, \n        .no-print *{\n            display: none !important;\n            height: 0;\n        }\n        \n        .print-only{\n            display: block;\n        }\n    }\n</STYLE>\n\n<script type=\\\"text/javascript\\\">\n\n    function inIframe () {\n        try {\n            return window.self !== window.top;\n        } catch (e) {\n            return true;\n        }\n    }\n\n    function print_this() {\n        if(inIframe()){\n            var iframe = parent.document.getElementById(\'search_iframe\');\n            iframe.contentWindow.focus();\n            iframe.contentWindow.print();    \n        } else {\n            window.print();       \n        }\n    }\n\n</script>\n</head>\n<body onload=\\\"adjustIframeHeight()\\\">\";\n\n$sql = \"SELECT * FROM #TABLE_ID# WHERE 1\";\n$retval = nuRunQuery($sql);\nif($retval){\n    if(db_num_rows($retval)>0) {\n    \n        $sql = \"SELECT SUM(dikaiologimenes) FROM #TABLE_ID# WHERE 1\";\n        $rv = nuRunQuery($sql);\n        $r = db_fetch_row($rv);\n        $show_dik = ($r[0]==0 ? false : true);\n        \n        $sql = \"SELECT SUM(diegramenes) FROM #TABLE_ID# WHERE 1\";\n        $rv = nuRunQuery($sql);\n        $r = db_fetch_row($rv);\n        $show_diegr = ($r[0]==0 ? false : true);\n        \n        \n        $sql = \"SELECT SUM(prev_justified) FROM #TABLE_ID# WHERE 1\";\n        $rv = nuRunQuery($sql);\n        $r = db_fetch_row($rv);\n        $show_prev = ($r[0]==0 ? false : true);\n        \n        $row = db_fetch_object($retval);\n        \n        print (\"\n        \n        <div class=\\\"print-only\\\" style=\\\"font-family:Verdana;font-size:8pt\\\">\n        \".$row->school_name.\"<br>\n        \".$row->school_year_name.\"<br>\n        \".$row->cur_date.\"<br><br>\n        <b>\".$row->text2.\"</b><br>\n        </div>\n        <span class=\\\"no-print\\\" style=\\\"font-family:Verdana;font-size:9pt;font-weight: bold;\\\"><a href=\\\"javascript:void(0);\\\" onclick=\\\"print_this();\\\">Εκτύπωση</a></span>\n        <br>\n        <table border=1 cellspacing=0 CLASS=\\\"sisTable\\\">\n            <tr height=35>\n                <th width=40 align=center rowspan=3><b>Τάξη</b></th>\n                <th width=220 align=center rowspan=3><b>Μαθητής</b></th>\n                <th width=60 align=center rowspan=3><b>Σύνολο Μετρήσιμων Απουσιών</b></th>\");\n                \n        if($show_dik){\n            $n = 0;\n            foreach($justified_reason_array as $reason){\n                if($reason[3]==1){\n                    $n++;\n                }\n            }\n            $n=($n*2)+1+($show_prev ? 1 : 0);\n            print (\"\n                <th width=120 align=center colspan=$n style=\\\"border-left-width:thick;\\\"><b>Δικαιολογημένες Μετρήσιμες</b></th>\");\n        }\n        \n        if($show_diegr){\n            $n = 0;\n            foreach($justified_reason_array as $reason){if($reason[3]==0){$n++;}}\n            $n = $n*2+1;\n             print (\"\n                <th width=120 align=center colspan=$n style=\\\"border-left-width:thick;\\\"><b>Δικαιολογημένες Μη Μετρήσιμες (Διαγραμμένες)</b></th>\");\n        }\n        \n        print (\"\n            </tr>\n            <tr height=30>\");\n            \n        if($show_dik){\n            print (\"\n                <th width=60 align=center rowspan=2 style=\\\"border-left-width:thick;\\\"><b>Σύνολο</b></th>\");\n            \n            foreach($justified_reason_array as $reason){\n                if($reason[3]==1){\n                    print (\"\n                <th width=60 align=center colspan=2 style=\\\"border-left-width:medium;\\\"><b>\".$reason[2].\"</b></th>\");    \n                }\n            }    \n            if($show_prev){    \n                print (\"\n                <th width=60 align=center rowspan=2 style=\\\"border-left-width:medium;\\\"><b>Εκτός Συστήματος</b></th>\");\n            }\n        }\n        \n        if($show_diegr){\n            print (\"\n                <th width=60 align=center rowspan=2 style=\\\"border-left-width:thick;\\\"><b>Σύνολο</b></th>\");\n            \n            foreach($justified_reason_array as $reason){\n                if($reason[3]==0){\n                    print (\"\n                <th width=60 align=center colspan=2 style=\\\"border-left-width:medium;\\\"><b>\".$reason[2].\"</b></th>\");    \n                }\n            }\n        } \n        \n        print (\"\n            </tr>\n            <tr height=30>\");        \n\n        foreach($justified_reason_array as $reason){\n            print (\"\n                <th width=60 align=center style=\\\"border-left-width:medium;\\\"><b>Σύνολο</b></th>\n                <th width=60 align=center><b>Ημέρες</b></th>\");\n        }    \n        \n        print (\"\n            </tr>\");\n            \n        while($row){\n            print (\"\n            <tr\".($row->student_has_left_school==1 ? \" style=\\\"background-color:#EE82EE;\\\"\": \"\").\" height=30>\n                <td align=center style=\\\"font-size:7pt;\\\">\".$row->grade_short_name.\"</td>\n                <td align=left style=\\\"font-size:7pt;\\\">\".$row->student_full_name.\"</td>\n                <td align=center style=\\\"font-size:9pt;\\\"><b>\".($row->synolo==0 ? \'-\' : $row->synolo).\"</b></td>\");\n                \n            if($show_dik){\n                print (\"\n                <td align=center style=\\\"border-left-width:thick;\\\"><b>\".($row->dikaiologimenes==0 ? \'-\' : $row->dikaiologimenes).\"</b></td>\");\n                foreach($justified_reason_array as $reason){\n                    if($reason[3]==1){\n                        $col_name1 = \"js_\".$reason[0];\n                        $col_name2 = \"jd_\".$reason[0];\n                        print (\"\n                <td align=center style=\\\"border-left-width:medium;\\\">\".($row->{$col_name1}==0 ? \'-\' : $row->{$col_name1}).\"</td>\n                <td align=center>\".($row->{$col_name2}==0 ? \'-\' : $row->{$col_name2}).\"</td>\n                \");    \n                    }\n                }\n                if($show_prev){    \n                    print (\"\n                <td align=center style=\\\"border-left-width:medium;\\\">\".($row->prev_justified==0 ? \'-\' : $row->prev_justified).\"</td>\");\n                }\n            }\n            \n            if($show_diegr){\n                print (\"\n                <td align=center style=\\\"border-left-width:thick;\\\"><b>\".($row->diegramenes==0 ? \'-\' : $row->diegramenes).\"</b></td>\");\n                foreach($justified_reason_array as $reason){\n                    if($reason[3]==0){\n                        $col_name1 = \"js_\".$reason[0];\n                        $col_name2 = \"jd_\".$reason[0];\n                        print (\"\n                <td align=center style=\\\"border-left-width:medium;\\\">\".($row->{$col_name1}==0 ? \'-\' : $row->{$col_name1}).\"</td>\n                <td align=center>\".($row->{$col_name2}==0 ? \'-\' : $row->{$col_name2}).\"</td>\n                \");    \n                    }\n                }\n            } \n            \n            print (\"\n            </tr>\");\n            \n            $row = db_fetch_object($retval);\n        }\n        print (\"\n        </table>\");        \n    } else {\n        print (\"<<span CLASS=\\\"msg\\\">Δε βρέθηκαν Μαθητές...</span>\");\n    }\n} else {\n    print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν δεδομένα...</span>\");    \n}\n\n\nprint \"\n    </body>\n</html>\";\n','','0','2018-02-20 20:18:12','globeadmin','2018-07-14 12:21:36','globeadmin','2022-02-12 14:34:06','globeadmin','0'),('5a92dae6a2be54b','students_excel_export','Εξαγωγή Μαθητών στο Excel','Teacher','require_once(\'Classes/PHPExcel.php\');\n\n$nuParameters = \'-1\';\n\n$sql=\"  SELECT \n            grade.short_name,\n            \n            ifNULL(student.registration_number,\'\'),\n        \n            ifNULL(student.surname,\'\'),\n            ifNULL(student.name,\'\'),\n            ifNULL(student.fathers_name,\'\'),\n            ifNULL(student.mothers_name,\'\'),\n            ifNULL(student.mothers_surname,\'\'),\n\n            ifNULL(student.gender,\'\'),\n            if(student.birth_date IS NULL,\'\',DATE_FORMAT(student.birth_date,\'%d/%m/%Y\')),\n            \n            ifNULL(student.phone1,\'\'),\n            ifNULL(student.phone2,\'\'),\n            ifNULL(student.mobile,\'\'),\n            \n            ifNULL(student.email,\'\'),\n            \n            ifNULL(student.street,\'\'),\n            ifNULL(student.area,\'\'),\n            ifNULL(student.zipcode,\'\'),\n            ifNULL(student.city,\'\'),\n            \n            ifNULL(student.parent_name,\'\'),\n            ifNULL(student.parent_surname,\'\'),\n\n            ifNULL(student.parent_phone1,\'\'),\n            ifNULL(student.parent_phone2,\'\'),\n            ifNULL(student.parent_phone3,\'\'),\n            \n            ifNULL(student.parent_email,\'\'),\n            ifNULL(student.parent_email2,\'\'),\n            \n            ifNULL(student.parent_street,\'\'),\n            ifNULL(student.parent_area,\'\'),\n            ifNULL(student.parent_zipcode,\'\')\n        FROM student\n        INNER JOIN grade on grade.id=student.grade_id\n        WHERE\n        \";\nif(\'#nu_user_group#\'==\'globeadmin\' || \'#nu_user_group#\'==\'Managers\' || \'#nu_user_group#\'==\'AssistManagers\' || \'#nu_user_group#\'==\'Administrators\' ||\'#nu_user_group#\'==\'Secretaries\'){\n\n    if(\'#grade_id_sumo#\'!=\'#\'.\'grade_id_sumo#\' && \'#grade_id_sumo#\'!=\'\'){\n        $sql=$sql.\" student.grade_id IN (#grade_id_sumo#) AND \n        \";\n    }\n\n    if(\'#class_id_sumo#\'!=\'#\'.\'class_id_sumo#\' && \'#class_id_sumo#\'!=\'\'){\n        $sql=$sql.\" student.id IN (select distinct student_id from student_class where class_id IN (#class_id_sumo#)) AND \n        \";\n    }\n\n    if(\'#student_id_sumo#\'!=\'#\'.\'student_id_sumo#\' && \'#student_id_sumo#\'!=\'\'){\n        $sql=$sql.\" student.id IN (#student_id_sumo#) AND \n        \";\n        $is_student=1;\n    }\n} else {\n    $sql.= \"student.teacher_id=\'#RECORD_ID#\' AND\";    \n}\n \n$sql.=\"\n        1=1\n        ORDER BY grade.short_name,student.surname,student.name,student.fathers_name\";\n        \n$rv=nuRunQuery($sql);\n\nif($rv) {\n    if(db_num_rows($rv)>0) {\n\n        $filefordown = sys_get_temp_dir().DIRECTORY_SEPARATOR.\"students-#RECORD_ID#.xls\";\n\n        $objPHPExcel = new PHPExcel();\n            \n        $objPHPExcel->getProperties()->setCreator(\'Papadakakis Nektarios\')\n							 ->setLastModifiedBy(\'Papadakakis Nektarios\')\n							 ->setTitle(\'sisyphos Students Export\')\n							 ->setSubject(\'sisyphos\')\n							 ->setDescription(\'Students\')\n							 ->setKeywords(\'Excel sisyphos student\')\n							 ->setCategory(\'sisyphos\');\n			\n        $objPHPExcel->getActiveSheet()->setTitle(\'Στοιχεία Μαθητών\');\n        \n        $objPHPExcel->getDefaultStyle()->getFont()->setName(\'Arial\')->setSize(9);\n        \n        $objPHPExcel->getActiveSheet() ->getColumnDimension(\'A\') ->setWidth(6);\n        $objPHPExcel->getActiveSheet() ->getColumnDimension(\'B\') ->setWidth(6);\n        $objPHPExcel->getActiveSheet() ->getColumnDimension(\'C\') ->setWidth(6);\n        $objPHPExcel->getActiveSheet() ->getColumnDimension(\'D\') ->setWidth(30);\n        $objPHPExcel->getActiveSheet() ->getColumnDimension(\'E\') ->setWidth(15);\n        $objPHPExcel->getActiveSheet() ->getColumnDimension(\'F\') ->setWidth(15);\n        $objPHPExcel->getActiveSheet() ->getColumnDimension(\'G\') ->setWidth(15);\n        $objPHPExcel->getActiveSheet() ->getColumnDimension(\'H\') ->setWidth(30);\n        $objPHPExcel->getActiveSheet() ->getColumnDimension(\'I\') ->setWidth(6);\n        $objPHPExcel->getActiveSheet() ->getColumnDimension(\'J\') ->setWidth(15);\n        $objPHPExcel->getActiveSheet() ->getColumnDimension(\'K\') ->setWidth(20);\n        $objPHPExcel->getActiveSheet() ->getColumnDimension(\'L\') ->setWidth(20);\n        $objPHPExcel->getActiveSheet() ->getColumnDimension(\'M\') ->setWidth(20);\n        $objPHPExcel->getActiveSheet() ->getColumnDimension(\'N\') ->setWidth(25);\n        \n        $objPHPExcel->getActiveSheet() ->getColumnDimension(\'O\') ->setWidth(25);\n        \n        $objPHPExcel->getActiveSheet() ->getColumnDimension(\'P\') ->setWidth(25);\n        $objPHPExcel->getActiveSheet() ->getColumnDimension(\'Q\') ->setWidth(20);\n        $objPHPExcel->getActiveSheet() ->getColumnDimension(\'R\') ->setWidth(10);\n        $objPHPExcel->getActiveSheet() ->getColumnDimension(\'S\') ->setWidth(20);\n        $objPHPExcel->getActiveSheet() ->getColumnDimension(\'T\') ->setWidth(15);\n        $objPHPExcel->getActiveSheet() ->getColumnDimension(\'U\') ->setWidth(30);\n        $objPHPExcel->getActiveSheet() ->getColumnDimension(\'V\') ->setWidth(20);\n        $objPHPExcel->getActiveSheet() ->getColumnDimension(\'W\') ->setWidth(20);\n        $objPHPExcel->getActiveSheet() ->getColumnDimension(\'X\') ->setWidth(20);\n        $objPHPExcel->getActiveSheet() ->getColumnDimension(\'Y\') ->setWidth(25);\n        $objPHPExcel->getActiveSheet() ->getColumnDimension(\'Z\') ->setWidth(25);\n        $objPHPExcel->getActiveSheet() ->getColumnDimension(\'AA\') ->setWidth(20);\n        $objPHPExcel->getActiveSheet() ->getColumnDimension(\'AB\') ->setWidth(10);\n        \n        $data = array(\n            \'ΑΑ\',\n            \'Τάξη\',\n            \'Α.Μ.\',\n            \'Επώνυμο\', \n            \'Όνομα\',\n            \'Όνομα πατέρα\',	\n            \'Όνομα μητέρας\',\n            \'Γένος μητέρας\',		\n            \'Φύλο\', 	\n            \'Ημερομηνία γέννησης\',	\n            \'Τηλέφωνο 1 Μαθητή\',	\n            \'Τηλέφωνο 2 Μαθητή\',	\n            \'Κινητό Τηλέφωνο Μαθητή\',	\n            \'eMail μαθητή\',	\n            \'Οδός, Αριθμός\',	\n            \'Περιοχή\',	\n            \'Τ.Κ.\',	\n            \'Πόλη\',	\n            \'Όνομα Κηδεμόνα\',	\n            \'Επώνυμο Κηδεμόνα\',	\n            \'Τηλέφωνο Κηδεμόνα 1\',	\n            \'Τηλέφωνο Κηδεμόνα 2\',	\n            \'Τηλέφωνο Κηδεμόνα 3\',	\n            \'email κηδεμόνα\',\n            \'email κηδεμόνα 2\',	\n            \'Διεύθυνση Κηδεμόνα\',	\n            \'Περιοχή Κηδεμόνα\',	\n            \'Τ.Κ. Κηδεμόνα\');\n            \n        $objPHPExcel->setActiveSheetIndex(0);\n        $objPHPExcel->getActiveSheet()->fromArray($data,NULL,\'A1\');\n        $objPHPExcel->getActiveSheet()->getStyle(\'A1:AB1\')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);\n        \n        $objPHPExcel->getActiveSheet()->getStyle(\'A1:AB1\')->getFont()->setBold(true);\n        \n        $objPHPExcel->getActiveSheet()->getStyle(\'A2:B999\')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);\n        $objPHPExcel->getActiveSheet()->getStyle(\'I2:I999\')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);\n        $i=2;\n        while($data = db_fetch_row($rv)) {\n            $objPHPExcel->setActiveSheetIndex(0);\n            $objPHPExcel->getActiveSheet()->setCellValue(\'A\'.$i,($i-1));\n            $objPHPExcel->getActiveSheet()->fromArray($data,NULL,\'B\'.$i);\n            $i++;\n        }\n        \n        $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, \'Excel5\');\n        $objWriter->save($filefordown);\n        \n        $nuParameters = $filefordown;\n    }\n    else{\n        $nuError = \"Δε βρέθηκαν στοιχεία για εξαγωγή!\";    \n    }\n}\nelse{\n    $nuError = \"Προσοχή! Παρουσιάστηκε σφάλμα κατά την εξαγωγή!\";    \n}\n','','0','2018-02-25 17:48:54','globeadmin','2021-09-07 20:31:30','globeadmin','2021-09-07 20:31:30','globeadmin','0'),('5a9d96938c5959e','student_programs_new','Νέο με Ημερομηνίες Πρόγραμμα Μαθητή','student','function createDateRangeArray($strDateFrom,$strDateTo){\n    $sql=\"  select holiday.holiday \n            from holiday\n            inner join school_year on holiday.school_year_id=school_year.id\n            inner join school on school.school_year_id = school_year.id\";\n    $retval=nuRunQuery($sql);\n    \n    $holiday_array = array();\n    while($row=db_fetch_row($retval)){\n        array_push($holiday_array,$row[0]);\n    }\n    \n    $sql=\"select id from day\";\n    $retval=nuRunQuery($sql);\n    \n    $day_array = array();\n    while($row=db_fetch_row($retval)){\n        array_push($day_array,$row[0]);\n    }\n    \n    $aryRange=array();\n\n    $iDateFrom=mktime(1,0,0,substr($strDateFrom,5,2),     substr($strDateFrom,8,2),substr($strDateFrom,0,4));\n    $iDateTo=mktime(1,0,0,substr($strDateTo,5,2),     substr($strDateTo,8,2),substr($strDateTo,0,4));\n\n    if ($iDateTo>=$iDateFrom)\n    {\n    \n        $day_of_week = idate(\'w\', strtotime(date(\'Y-m-d\',$iDateFrom)))-1;\n        if(in_array($day_of_week,$day_array)){\n                array_push($aryRange,date(\'Y-m-d\',$iDateFrom)); // first entry\n            }\n    \n        while ($iDateFrom<$iDateTo)\n        {\n            $iDateFrom+=86400; // add 24 hours\n            \n            $day_of_week = idate(\'w\', strtotime(date(\'Y-m-d\',$iDateFrom)))-1;\n            if(in_array($day_of_week,$day_array)){\n                array_push($aryRange,date(\'Y-m-d\',$iDateFrom));\n            }\n        }\n    }\n\n    return array_diff($aryRange, $holiday_array);\n}\n\n$sql = \"SELECT CURDATE(),GREATEST(DATE_ADD(CURDATE(), INTERVAL 6 DAY), DATE_ADD(IFNULL(max(timetable.start_date), CURDATE()),INTERVAL 6 DAY))\n		FROM timetable\";\n$rv = nuRunQuery($sql);\n$r = db_fetch_row($rv);\n$curdate = $r[0];\n$dates = createDateRangeArray( $r[0], $r[1]);\n\n$sql = \"SELECT MIN(start_time), MAX(end_time)\n		FROM period\";\n$rv = nuRunQuery($sql);\n$r = db_fetch_row($rv);\n$min_period_time = $r[0];\n$max_period_time = $r[1];\n$curtime = date(\'H:i:s\');\n\nprint \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n        \n        <STYLE TYPE=\\\"text/css\\\">\n            .sisTableLine TD{\n                font-weight: normal;\n            }\n            .sisTable TD{\n                font-size:7pt;\n            }            \n            .sisTable TH{\n                font-size:7pt;\n            }\n        </STYLE>\n    </head>\n      \n    <body>\n        <table border=0 cellspacing=0 cellpadding=4 CLASS=\\\"sisTable\\\" align=center>\n            <tr height=20>\n                <th align=center rowspan=2>Διδακτικές<br>Ώρες</th>\";\n               \n$sql = \"SELECT \n            short_name,\n            DATE_FORMAT(start_time, \'%H:%i\'),\n            DATE_FORMAT(end_time, \'%H:%i\'),\n            IF((CURTIME() BETWEEN start_time AND end_time) AND (DAYOFWEEK(CURDATE())-2 IN (SELECT id FROM day)),1,0)\n        FROM period ORDER BY start_time\";\n$rv = nuRunQuery($sql); \n$periods = array();\nwhile($r = db_fetch_row($rv)) $periods[]= $r;\n\nforeach($periods as $period){\n    print(\n                \"<td align=center \".($period[3]==1 ? \"style=\\\"background-color:LightGreen;\\\"\" : \"style=\\\"background-color:LightSteelBlue;\\\"\").\"><b>{$period[0]}</b></td>\");\n}\n\nprint(\"\n            </tr>\n            <tr height=20>\");\n            \nforeach($periods as $period){\n    print(\n                \"<td align=center \".($period[3]==1 ? \"style=\\\"background-color:LightGreen;\\\"\" : \"style=\\\"background-color:LighBlue;\\\"\").\">{$period[1]} - {$period[2]}</td>\");\n}  \n\nprint \"\n            </tr>\n        </table>    \n        <br>\n        <table CLASS=\\\"sisTableLine\\\" cellspacing=0 width=100%>\n            <tr height=30> \n                <th width=160 align=center>Ημέρομηνία</th> \n                <th width=60 align=center>Ώρα</th> \n                <th width=70 align=center>Τμήμα</th> \n                <th width=310 align=center>Μάθημα</th> \n                <th width=100 align=center>Κατηγορία</th> \n                <th width=80 align=center>Αίθουσα</th>\n                <th width=180 align=center>Καθηγητής</th>\n                <th width=30 align=right><img src=\\\"images/expand.png\\\" onclick=\\\"adjustIframeHeight()\\\" title=\\\"Επέκταση\\\" onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\"></th></th>\n            </tr>\";\n\n$color1 = \'LightBlue\';\n$color2 = \'LightSteelBlue\';\n$curcolor = \'#b2e6d5\';\n$activecolor = \'LightGreen\';\n\nforeach($dates as $date){\n\n    $color = ($date==$curdate  && ($curtime>=$min_period_time && $curtime<=$max_period_time)? $curcolor : ($color==$color1 ? $color2 : $color1));\n\n    $sql = \"SELECT max(timetable.start_date)\n		    FROM timetable\n		    WHERE timetable.start_date<=\'$date\'\";\n    $rv = nuRunQuery($sql);\n    $r = db_fetch_row($rv); \n    \n    $timetable_date = $r[0];\n    \n    $day_of_week = idate(\'w\', strtotime($date))-1;\n    \n    $sql = \"DROP TEMPORARY TABLE IF EXISTS #TABLE_ID#\";\n    nuRunQuery($sql);\n\n    $sql = \" CREATE TEMPORARY TABLE IF NOT EXISTS #TABLE_ID# AS \n            SELECT distinct\n            	subject.name 				AS subject_name,\n            	subject_type.name 			AS subject_type_name,\n            	classroom.short_name		AS classroom_short,\n            	class.short_name 			AS class_short,\n            	CAST(\'\' as CHAR(1000))		AS teacher_name,\n            	class.id					AS class_id,\n            	subject.id					AS subject_id,\n            	card.day_id					AS day_id,\n            	card.period_id				As period_id\n            FROM card\n            INNER JOIN subject 			on card.subject_id = subject.id \n            INNER JOIN class 			on card.class_id = class.id\n            LEFT  JOIN subject_type 	on subject.subject_type_id = subject_type.id\n            LEFT  JOIN classroom		ON classroom.id = card.classroom_id 	\n            WHERE \n            	card.valid_from = \'$timetable_date\' AND\n            	card.day_id = \'$day_of_week\' AND\n            	class.id in (select distinct class_id from student_class where student_id=\'#RECORD_ID#\') \n            ORDER BY \n            	class_short,\n            	subject_name,\n            	subject_type_name DESC\n    \";\n    nuRunQuery($sql);\n\n    $sql = \"SELECT DISTINCT class_id,subject_id,day_id,period_id  FROM #TABLE_ID#\";\n    $rv2 = nuRunQuery($sql);\n    while($r2 = db_fetch_row($rv2)){\n        $sql=\"  SELECT distinct\n                        concat(IF(teacher.surname IS NULL,\'\',teacher.surname),IF(teacher.surname IS NULL,\'\',\' \'),IF(teacher.name IS NULL,\'\',teacher.name)),\n                        IFNull(teacher.web_page,\'\')\n                FROM card\n                INNER JOIN teacher on card.teacher_id = teacher.id \n                WHERE \n                    card.valid_from = \'\".$timetable_date.\"\' AND\n                    card.class_id   = \'\".$r2[0].\"\' AND\n                    card.subject_id = \'\".$r2[1].\"\' AND\n                    card.day_id = \'\".$r2[2].\"\' AND\n                    card.period_id   = \'\".$r2[3].\"\'  \n                \";\n        $rv3 = nuRunQuery($sql);\n        $teacher_names = \"\";\n        while($r3 = db_fetch_row($rv3)){\n        \n            $nm = ($r3[1]==\'\' ? $r3[0] : \"<a href=\\\"\".$r3[1].\"\\\" target=\\\"_blank\\\">\".$r3[0].\"</a>\");\n            \n            $teacher_names = ($teacher_names == \"\" ? $nm : $teacher_names.\", \".$nm);        \n        }\n        \n        if($teacher_names != \"\"){\n            $sql = \"UPDATE #TABLE_ID# \n                    SET teacher_name=\'$teacher_names\' \n                    WHERE \n                        class_id= \'\".$r2[0].\"\' AND \n                        subject_id = \'\".$r2[1].\"\' AND\n                        day_id = \'\".$r2[2].\"\' AND\n                        period_id = \'\".$r2[3].\"\'\n                        \";\n            nuRunQuery($sql);\n        }\n        \n    }\n\n    $sql = \"SELECT  \n	        dp.day_name,\n	        dp.period_short_name,\n	        ifNULL(c.subject_name,\'\'),\n	        ifNULL(c.subject_type_name,\'\'),\n            ifNULL(c.classroom_short,\'\'),\n            ifNULL(c.class_short,\'\'),\n            ifNULL(c.teacher_name,\'\'),\n            dp.day_id,\n            IF((CURTIME() BETWEEN period_start_time AND period_end_time) AND (DAYOFWEEK(CURDATE())-2 = dp.day_id),1,0)\n	    FROM \n	        (SELECT \n	            day.id as day_id,\n	            day.name as day_name,\n	            day.short_name as day_short_name,\n	            period.id as period_id,\n	            period.name as period_name,\n	            period.short_name as period_short_name,\n	            period.start_time as period_start_time,\n	            period.end_time as period_end_time\n			FROM day,period\n			WHERE day.id = \'$day_of_week\'\n			ORDER BY day.id,period.id) AS dp\n	    LEFT JOIN #TABLE_ID# AS c ON (c.day_id=dp.day_id AND c.period_id=dp.period_id)\n        ORDER BY dp.day_id,dp.period_id\";\n\n    $retval = nuRunQuery($sql);\n    \n    while($row = db_fetch_row($retval)){\n        print \"\n            <tr style=\\\"background-color:\".($row[8]==0 ? $color : $activecolor).\";\\\" height=30>\n                <td align=center valign=center>\".$row[0].\", \".date_format(date_create($date),\'d-m-Y\').\"</td>\n                <td align=center valign=center>\".$row[1].\"</td>\n                <td align=center valign=center>\".$row[5].\"</td>\n                <td align=left valign=center>\".$row[2].\"</td>\n                <td align=center valign=center>\".$row[3].\"</td>\n                <td align=center valign=center>\".$row[4].\"</td>\n                <td align=left valign=center colspan=2>\".$row[6].\"</td>\n            </tr>\";\n    }\n}\nprint \"\n        </table>\n    </body>\n</html>\";\n','','0','2018-03-05 21:12:19','globeadmin','2022-01-10 21:26:04','globeadmin','2022-01-10 21:26:04','globeadmin','0'),('5a9e7622e307049','teacher_programs_new','Νέο με Ημερομηνίες Πρόγραμμα Καθηγητή','teacher','function createDateRangeArray($strDateFrom,$strDateTo){\n    $sql=\"  select holiday.holiday \n            from holiday\n            inner join school_year on holiday.school_year_id=school_year.id\n            inner join school on school.school_year_id = school_year.id\";\n    $retval=nuRunQuery($sql);\n    \n    $holiday_array = array();\n    while($row=db_fetch_row($retval)){\n        array_push($holiday_array,$row[0]);\n    }\n    \n    $sql=\"select id from day\";\n    $retval=nuRunQuery($sql);\n    \n    $day_array = array();\n    while($row=db_fetch_row($retval)){\n        array_push($day_array,$row[0]);\n    }\n    \n    $aryRange=array();\n\n    $iDateFrom=mktime(1,0,0,substr($strDateFrom,5,2),     substr($strDateFrom,8,2),substr($strDateFrom,0,4));\n    $iDateTo=mktime(1,0,0,substr($strDateTo,5,2),     substr($strDateTo,8,2),substr($strDateTo,0,4));\n\n    if ($iDateTo>=$iDateFrom)\n    {\n    \n        $day_of_week = idate(\'w\', strtotime(date(\'Y-m-d\',$iDateFrom)))-1;\n        if(in_array($day_of_week,$day_array)){\n                array_push($aryRange,date(\'Y-m-d\',$iDateFrom)); // first entry\n            }\n    \n        while ($iDateFrom<$iDateTo)\n        {\n            $iDateFrom+=86400; // add 24 hours\n            \n            $day_of_week = idate(\'w\', strtotime(date(\'Y-m-d\',$iDateFrom)))-1;\n            if(in_array($day_of_week,$day_array)){\n                array_push($aryRange,date(\'Y-m-d\',$iDateFrom));\n            }\n        }\n    }\n\n    return array_diff($aryRange, $holiday_array);\n}\n\n$sql = \"SELECT CURDATE(),GREATEST(DATE_ADD(CURDATE(), INTERVAL 6 DAY), DATE_ADD(IFNULL(max(timetable.start_date), CURDATE()),INTERVAL 6 DAY))\n		FROM timetable\";\n$rv = nuRunQuery($sql);\n$r = db_fetch_row($rv);\n$curdate = $r[0];\n$dates = createDateRangeArray( $r[0], $r[1]);\n\n$sql = \"SELECT MIN(start_time), MAX(end_time)\n		FROM period\";\n$rv = nuRunQuery($sql);\n$r = db_fetch_row($rv);\n$min_period_time = $r[0];\n$max_period_time = $r[1];\n$curtime = date(\'H:i:s\');\n\nprint \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n        \n        <STYLE TYPE=\\\"text/css\\\">\n            .sisTableLine TD{\n                font-weight: normal;\n            }\n        </STYLE>\n    </head>\n\n    <body>\n        <table border=0 cellspacing=0 cellpadding=4 CLASS=\\\"sisTable\\\" align=center>\n            <tr height=20>\n                <th align=center rowspan=2>Διδακτικές<br>Ώρες</th>\";\n               \n$sql = \"SELECT \n            short_name,\n            DATE_FORMAT(start_time, \'%H:%i\'),\n            DATE_FORMAT(end_time, \'%H:%i\'),\n            IF((CURTIME() BETWEEN start_time AND end_time) AND (DAYOFWEEK(CURDATE())-2 IN (SELECT id FROM day)),1,0)\n        FROM period ORDER BY start_time\";\n$rv = nuRunQuery($sql); \n$periods = array();\nwhile($r = db_fetch_row($rv)) $periods[]= $r;\n\nforeach($periods as $period){\n    print(\n                \"<td align=center \".($period[3]==1 ? \"style=\\\"background-color:LightGreen;\\\"\" : \"style=\\\"background-color:LightSteelBlue;\\\"\").\"><b>{$period[0]}</b></td>\");\n}\n\nprint(\"\n            </tr>\n            <tr height=20>\");\n            \nforeach($periods as $period){\n    print(\n                \"<td align=center \".($period[3]==1 ? \"style=\\\"background-color:LightGreen;\\\"\" : \"style=\\\"background-color:LighBlue;\\\"\").\">{$period[1]} - {$period[2]}</td>\");\n}  \n\nprint \"\n            </tr>\n        </table>    \n        <br>\n        <table CLASS=\\\"sisTableLine\\\" cellspacing=0 width=100%>\n            <tr height=30> \n                <th width=150 align=center>Ημέρομηνία</th> \n                <th width=80 align=center>Ώρα</th> \n                <th width=100 align=center>Τμήμα</th> \n                <th width=340 align=center>Μάθημα</th> \n                <th width=120 align=center>Κατηγορία</th> \n                <th width=80 align=center>Αίθουσα</th>\n                <th width=30 align=right>\n                    <img src=\\\"images/expand.png\\\" onclick=\\\"adjustIframeHeight()\\\" title=\\\"Επέκταση\\\" onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\">\n                </th>\n            </tr>\";\n            \n$color1 = \'LightBlue\';\n$color2 = \'LightSteelBlue\';\n$curcolor = \'#b2e6d5\';\n$activecolor = \'LightGreen\';\n\nforeach($dates as $date){\n\n    $color = ($date==$curdate  && ($curtime>=$min_period_time && $curtime<=$max_period_time)? $curcolor : ($color==$color1 ? $color2 : $color1));\n\n    $sql = \"SELECT max(timetable.start_date)\n		    FROM timetable\n		    WHERE timetable.start_date<=\'$date\'\";\n    $rv = nuRunQuery($sql);\n    $r = db_fetch_row($rv); \n    \n    $timetable_date = $r[0];\n    \n    $day_of_week = idate(\'w\', strtotime($date))-1;\n    \n    $sql = \"DROP TEMPORARY TABLE IF EXISTS #TABLE_ID#\";\n    nuRunQuery($sql);\n    \n    $sql = \"select  \n	    dp.day_name,\n	    dp.period_short_name,\n	    c.subject_name,\n	    c.subject_type_name,\n        c.classroom_short,\n        c.class_short,\n        dp.day_id,\n        IF((CURTIME() BETWEEN period_start_time AND period_end_time) AND (DAYOFWEEK(CURDATE())-2 = dp.day_id),1,0)\n	from (	select day.id as day_id,day.name as day_name,day.short_name as day_short_name, period.id as period_id,period.name as period_name,period.short_name as period_short_name,period.start_time AS period_start_time,period.end_time AS period_end_time\n			from day,period\n			where day.id = \'$day_of_week\'\n			order by day.id,period.id) as dp\n	left join (\n	\n                SELECT\n	                active_card.day_id 			AS day_id,\n	                active_card.period_id 		AS period_id,\n	                day.name 					AS day_name,\n	                period.short_name 			AS period_short,\n	                subject.name 				AS subject_name,\n	                subject_type.name 			AS subject_type_name,\n	                classroom.short_name 		AS classroom_short,\n	                class.short_name 			AS class_short\n                FROM \n	                (SELECT \n		                card.id 			AS id,\n		                card.valid_from 	AS valid_from,\n		                card.subject_id 	AS subject_id,\n		                card.teacher_id 	AS teacher_id,\n		                card.class_id 		AS class_id,\n		                card.classroom_id 	AS classroom_id,\n		                card.day_id 		AS day_id,\n		                card.period_id 		AS period_id\n	                FROM card \n	                WHERE card.valid_from =\n		                (	SELECT max(timetable.start_date) \n			                FROM timetable \n			                WHERE (timetable.start_date <= \'$timetable_date\'))) as active_card \n	                inner join subject 			on active_card.subject_id = subject.id \n	                inner join teacher 			on active_card.teacher_id = teacher.id  \n	                inner join day 				on active_card.day_id = day.id  \n	                inner join period 			on active_card.period_id = period.id\n	                inner join class 			on active_card.class_id = class.id	\n	                left  join subject_type 	on subject.subject_type_id = subject_type.id  \n	                left  join classroom 		on active_card.classroom_id = classroom.id  \n                WHERE active_card.teacher_id is NULL OR active_card.teacher_id=\'#RECORD_ID#\' \n				) as c ON (c.day_id=dp.day_id AND c.period_id=dp.period_id)\n	\n    order by dp.day_id,dp.period_id\";\n\n    $retval = nuRunQuery($sql);\n                \n    while($row = db_fetch_row($retval)){\n        print \"\n            <tr style=\\\"background-color:\".($row[7]==0 ? $color : $activecolor).\";\\\" height=25>\n                <td align=center valign=center>\".$row[0].\", \".date_format(date_create($date),\'d-m-Y\').\"</td>\n                <td align=center valign=center>\".$row[1].\"</td>\n                <td align=center valign=center>\".$row[5].\"</td>\n                <td align=left valign=center>\".$row[2].\"</td>\n                <td align=center valign=center>\".$row[3].\"</td>\n                <td align=center valign=center colspan=2>\".$row[4].\"</td>\n            </tr>\";\n            \n    }\n}\nprint \"\n        </table>\n    </body>\n</html>\";','','0','2018-03-06 13:06:10','globeadmin','2020-11-10 14:52:12','globeadmin','2021-02-03 20:46:55','globeadmin','0'),('5aa18dc089a2268','old_absence_student_google_chart','Παλαιό - Δημιουργεί γράφημα με τις απουσίες του μαθητή ανά μήνα','student','ob_start();\nprint \'hi\';\n\n$sql=\"  select prev_an_justified_absences,prev_justified_absences\n        from student\n        where id=#RECORD_ID#\";\n$rv = nuRunQuery($sql);\n$row = db_fetch_row($rv);\n$prev_an_justified_absences = $row[0];\n$prev_justified_absences = $row[1];\n\n\n$sql=\"  select \n            school_year.start_date,\n            school_year.end_date,\n            school.absence_anjustified_limit,\n            school.absence_total_limit\n        from school_year\n        inner join school on school_year.id=school.school_year_id\n    \";\n$rv = nuRunQuery($sql);\n$row = db_fetch_row($rv);\n$starting_date = $row[0];\n$ending_date = $row[1];\n$curdate = date(\"Y-m-d\");\n$absence_anjustified_limit = $row[2];\n$absence_total_limit = $row[3];\n\n\n$start    = new DateTime($starting_date);\n$start->modify(\'first day of this month\');\n$end      = new DateTime(($curdate>$ending_date ? $ending_date : $curdate));\n$end->modify(\'first day of next month\');\n$interval = DateInterval::createFromDateString(\'1 month\');\n$period   = new DatePeriod($start, $interval, $end);\n\n$months = array();\n\nforeach ($period as $dt) {\n    $start_month_date = $dt->format(\"Y-m-d\");\n    \n    $dt->modify(\'last day of this month\');\n    $end_month_date = $dt->format(\"Y-m-d\");\n    \n    $month_name = $dt->format(\"M\");\n    \n    $months[] = array($start_month_date,$end_month_date,$month_name);\n}\n\n$chart_data   = array();\n\nforeach ($months as $month) {\n\n    $sql = \"    \n            select count(*) \n            from absence \n            where \n                student_id=#RECORD_ID# \n                and counts=1 \n                and justified=0 and\n                absence_date between \'\".$starting_date.\"\' and \'\".$month[1].\"\'\";\n                \n    $rv = nuRunQuery($sql);\n    $row = db_fetch_row($rv);\n    $an_justified_absences=$row[0];\n    $an_justified_absences += $prev_an_justified_absences;\n    \n    $sql = \"    \n            select count(*) \n            from absence \n            where \n                student_id=#RECORD_ID# \n                and counts=1 \n                and justified=1 and\n                absence_date between \'\".$starting_date.\"\' and \'\".$month[1].\"\'\";\n    $rv = nuRunQuery($sql);\n    $row = db_fetch_row($rv);\n    $justified_absences=$row[0];\n    $justified_absences += $prev_justified_absences;\n    \n    $chart_data[] = \"[\\\"\".$month[2].\"\\\",\".$an_justified_absences.\",\".$justified_absences.\",\".($an_justified_absences+$justified_absences).\",$absence_anjustified_limit,$absence_total_limit]\";\n\n}\n\n$js_string = implode(\',\', $chart_data);\n \n$gg = \"\n \n<html>\n  <head>\n    <script type=\'text/javascript\' src=\'https://www.google.com/jsapi\'></script>\n    <script type=\'text/javascript\'>\n	\n	google.load(\'visualization\', \'1\', {packages: [\'corechart\', \'line\']});\n	google.setOnLoadCallback(drawAxisTickColors);\n	\n	function drawAxisTickColors() {\n        \n      \n	  var data = new google.visualization.DataTable();\n      data.addColumn(\'string\', \'X\');\n      data.addColumn(\'number\', \'\\u0391\\u03B4\\u03B9\\u03BA\\u03B1\\u03B9\\u03BF\\u03BB\\u03CC\\u03B3\\u03B7\\u03C4\\u03B5\\u03DB\');\n      data.addColumn(\'number\', \'\\u0394\\u03B9\\u03BA\\u03B1\\u03B9\\u03BF\\u03BB\\u03BF\\u03B3\\u03B7\\u03BC\\u03AD\\u03BD\\u03B5\\u03DB\');\n	  data.addColumn(\'number\', \'\\u03A3\\u03CD\\u03BD\\u03BF\\u03BB\\u03BF\');\n	  data.addColumn(\'number\', \'\\u038C\\u03C1\\u03B9\\u03BF \\u0391\\u03B4\\u03B9\\u03BA\\u03B1\\u03B9\\u03BF\\u03BB\\u03CC\\u03B3\\u03B7\\u03C4\\u03C9\\u03BD\');\n	  data.addColumn(\'number\', \'\\u038C\\u03C1\\u03B9\\u03BF \\u03A3\\u03C5\\u03BD\\u03CC\\u03BB\\u03BF\\u03C5\');\n\n      data.addRows([\n      \n        \".$js_string.\" \n        \n      ]);\n\n      var options = {\n        hAxis: {\n          title: \'\',\n          textStyle: {\n            color: \'#01579b\',\n            fontSize: 14,\n            bold: true,\n            italic: true\n          },\n          titleTextStyle: {\n            color: \'#01579b\',\n            fontSize: 14,\n            bold: true,\n            italic: true\n          }\n        },\n        vAxis: {\n          title: \'\',\n          textStyle: {\n            color: \'#1a237e\',\n            fontSize: 14,\n            bold: true\n          },\n          titleTextStyle: {\n            color: \'#1a237e\',\n            fontSize: 14,\n            bold: true\n          }\n        },\n        colors: [\'#ff0000\', \'#00ff00\',\'#0000ff\',\'#990000\',\'#000088\'],\n        backgroundColor: \'#FAF0E6\',\n        lineWidth: 2,\n        series: {\n            3: { lineDashStyle: [4, 4] },\n            4: { lineDashStyle: [4, 4] }\n          }\n      };\n      var chart = new google.visualization.LineChart(document.getElementById(\'chart_div\'));\n      chart.draw(data, options);\n      }\n    </script>\n  </head>\n  <body>\n    <div id=\'chart_div\' style=\'width: 950px; height: 280px;\'></div>\n  </body>\n</html>\n \n\";\n \nob_end_clean();\necho $gg; \n','','0','2018-03-08 21:23:44','globeadmin','2021-03-24 11:35:21','globeadmin','2021-03-24 11:35:21','globeadmin','0'),('5b0f02fc45e374e','extract_absence_student_excel','Εξάγει τις απουσίες σε αρχείο excel ανά μαθητή και ημερομηνία','teacher','require_once(\'Classes/PHPExcel.php\');\n\n$nuParameters = \'-1\';\n\nfunction createDateRangeArray($strDateFrom,$strDateTo)\n{\n\n    $sql=\"  select holiday.holiday \n            from holiday\n            inner join school_year on holiday.school_year_id=school_year.id\n            inner join school on school.school_year_id = school_year.id\";\n    $retval=nuRunQuery($sql);\n    \n    $holiday_array = array();\n    while($row=db_fetch_row($retval)){\n        array_push($holiday_array,$row[0]);\n    }\n    \n    $sql=\"select id from day\";\n    $retval=nuRunQuery($sql);\n    \n    $day_array = array();\n    while($row=db_fetch_row($retval)){\n        array_push($day_array,$row[0]);\n    }\n    \n    $aryRange=array();\n\n    $iDateFrom=mktime(1,0,0,substr($strDateFrom,5,2),     substr($strDateFrom,8,2),substr($strDateFrom,0,4));\n    $iDateTo=mktime(1,0,0,substr($strDateTo,5,2),     substr($strDateTo,8,2),substr($strDateTo,0,4));\n\n    if ($iDateTo>=$iDateFrom)\n    {\n    \n        $day_of_week = idate(\'w\', strtotime(date(\'Y-m-d\',$iDateFrom)))-1;\n        if(in_array($day_of_week,$day_array)){\n                array_push($aryRange,date(\'Y-m-d\',$iDateFrom)); // first entry\n            }\n    \n        while ($iDateFrom<$iDateTo)\n        {\n            $iDateFrom+=86400; // add 24 hours\n            \n            $day_of_week = idate(\'w\', strtotime(date(\'Y-m-d\',$iDateFrom)))-1;\n            if(in_array($day_of_week,$day_array)){\n                array_push($aryRange,date(\'Y-m-d\',$iDateFrom));\n            }\n        }\n    }\n\n    return array_diff($aryRange, $holiday_array);\n}\n\nfunction createSheet($objPHPExcel,$idx){\n\n    if($idx!=0){\n        $objWorkSheet = $objPHPExcel->createSheet($idx);    \n    } else {\n        $objPHPExcel->setActiveSheetIndex(0);\n        $objWorkSheet = $objPHPExcel->getActiveSheet();    \n    }\n    \n    $objWorkSheet->setTitle(\'Απουσίες_\'.($idx+1));\n                \n    $objWorkSheet->getColumnDimension(\'A\') ->setWidth(8);\n    $objWorkSheet->getColumnDimension(\'B\') ->setWidth(10);\n    $objWorkSheet->getColumnDimension(\'C\') ->setWidth(35);\n    $objWorkSheet->getColumnDimension(\'D\') ->setWidth(25);\n    $objWorkSheet->getColumnDimension(\'E\') ->setWidth(25);\n    $objWorkSheet->getColumnDimension(\'F\') ->setWidth(5);\n    $objWorkSheet->getColumnDimension(\'G\') ->setWidth(5);\n    $objWorkSheet->getColumnDimension(\'H\') ->setWidth(5);\n    $objWorkSheet->getColumnDimension(\'I\') ->setWidth(10);\n    $objWorkSheet->getColumnDimension(\'J\') ->setWidth(16);\n                \n    $data_title = array(  \"ΑΑ\",\n                        \"ΑΜ\",\n                        \"Επώνυμο Μαθητή\",\n                        \"Όνομα Μαθητή\",\n                        \"Πατρώνυμο Μαθητή\",\n                        \"Σ\",\n                        \"ΑΑΑ\",\n                        \"Δ\",\n                        \"Τύπος Δικ.\",\n                        \"Ημερομηνία\"\n                        );\n    $objWorkSheet->fromArray($data_title,NULL,\'A1\');\n    $objWorkSheet->getStyle(\'A1:J1\')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);\n    $objWorkSheet->getStyle(\'A1:J1\')->getFont()->setBold(true);\n}\n\nif(\'#student_id_sumo#\'!=\'#\'.\'student_id_sumo#\' && \'#student_id_sumo#\'!=\'\'){ \n\n    if (\'#from_date#\'!=\'#\'.\'from_date\'.\'#\' && \'#from_date#\'!=\'\'){\n        if (\'#to_date#\'!=\'#\'.\'to_date\'.\'#\' && \'#to_date#\'!=\'\'){\n\n            $days = createDateRangeArray(\'#from_date#\',\'#to_date#\');\n        \n            if(count($days)>0){\n                \n                $filefordown = sys_get_temp_dir().DIRECTORY_SEPARATOR.\'students_absence_#from_date#\'.(\'#from_date#\'==\'#to_date#\' ? \'\' : \'_to_#to_date#\').\"-#RECORD_ID#.xls\";\n                \n                $objPHPExcel = new PHPExcel();\n            \n                $objPHPExcel->getProperties()->setCreator(\'Papadakakis Nektarios\')\n					 ->setLastModifiedBy(\'Papadakakis Nektarios\')\n					 ->setTitle(\'Sisyphos Export for mySchool\')\n					 ->setSubject(\'Absence\')\n					 ->setDescription(\'Absence file for myschool information system\')\n					 ->setKeywords(\'Excel Sisyphos myschool\')\n					 ->setCategory(\'Sisyphos\');\n					 \n			    $objPHPExcel->getDefaultStyle()->getFont()->setName(\'Arial\')\n                                          ->setSize(10);\n				if (\'#max_rows#\'!=\'#\'.\'max_rows\'.\'#\' && \'#max_rows#\'!=\'\'){\n				    $max_rows = \'#max_rows#\';    \n				} else {\n				    $max_rows = 999;    \n				}\n				\n				$sheet_index = 0;\n				$format = \'dd/mm/yyyy\';\n	\n                createSheet($objPHPExcel,$sheet_index);	\n                $i=2;\n                \n                foreach($days as $day){\n                    $date = new DateTime($day);\n                    $sql=\"  SELECT \n                                student.id,\n                                student.registration_number,\n                                student.surname,\n                                student.name,\n                                student.fathers_name,\n                                sum(if(ab.counts is null,0,ab.counts)) as s,\n                                0,\n                                sum(if(ab.counts is null,0,if(ab.justified,ab.counts,0))) as d,\n                                count(distinct ab.justified_reason_id)\n                            FROM student\n                            LEFT JOIN ( SELECT absence.student_id, absence.counts, absence.justified, absence.justified_reason_id\n                                        FROM absence\n                                        WHERE absence.counts=1 and absence.absence_date=\'$day\') AS ab ON student.id = ab.student_id\n                            WHERE \n		                        student.id IN (#student_id_sumo#)\n                            GROUP BY student.id,student.registration_number,student.surname,student.name,student.fathers_name\";\n                    \n                    if(\'#show_zero#\'!=\'1\'){\n                        $sql.=\"\n                            HAVING s>0\n                        \";\n                    }\n                    \n                    $retval = nuRunQuery($sql);\n                    while($data = db_fetch_row($retval)){\n                        $objPHPExcel->setActiveSheetIndex($sheet_index);\n                        $objPHPExcel->getActiveSheet()->fromArray($data,NULL,\'A\'.$i);\n                        \n                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0, $i,$i-1);   \n                        \n                        /*if($data[7]!=0){\n                            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(6, $i,$data[5]-$data[7]);       \n                        } else {\n                            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(6, $i,$data[5]);       \n                        }*/\n                        \n                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(6, $i,\'\');\n                        \n                        if($data[8]==1){    \n                            $sql=\"  SELECT DISTINCT justified_reason_id,ifNULL(myschool_code,\'\')\n                                    FROM absence\n                                    INNER JOIN justified_reason ON absence.justified_reason_id = justified_reason.id\n                                    WHERE \n                                        student_id=\'\".$data[0].\"\' and\n                                        absence_date=\'$day\'\";\n                            $rv = nuRunQuery($sql);\n                           \n                            if($r=db_fetch_row($rv)){\n                                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(8, $i,$r[1]);    \n                            }\n                        } else{\n                            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(8, $i,\"\");\n                        }\n                        \n                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(9, $i, \n                                       PHPExcel_Shared_Date::PHPToExcel($date));\n                        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(9, $i)\n                                            ->getNumberFormat()->setFormatCode($format);\n                        if($i>$max_rows){\n                            $sheet_index++;\n                            createSheet($objPHPExcel,$sheet_index);	\n                            $i=2;    \n                        } else {\n                            $i++;    \n                        }\n                        \n                    }    \n                }\n                \n                $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, \'Excel5\');\n            \n                $objWriter->save($filefordown);\n    \n                $nuParameters = $filefordown;;\n            \n            } else {\n                $nuError = \"Δε βρέθηκαν ημερομηνίες λειτουργίας του σχολείου στο μεσοδιάστημα από και έως...\";    \n            }\n        } else {\n            $nuError = \"Παρακαλώ ορίσετε την ημερομηνία έως...\";\n        }\n    } else {\n        $nuError = \"Παρακαλώ ορίσετε την ημερομηνία από...\";    \n    }\n} else {\n    $nuError = \"Παρακαλώ επιλέξτε μαθητές!\";    \n}','','0','2018-05-30 23:01:00','globeadmin','2020-09-24 22:51:25','globeadmin','2022-02-11 22:15:30','globeadmin','0'),('5b116f44be18d06','absence_class_book','Δημιουργεί όλα τα απουσιολόγια ενός τμήματος σε ένα εύρος ημερομηνιών','Teacher','function greek_to_greeklish($string) { \nreturn strtr($string, array( \n    \'Α\' => \'A\',\n    \'Ά\' => \'A\',\n    \'Β\' => \'B\', \n    \'Γ\' => \'G\', \n    \'Δ\' => \'D\', \n    \'Ε\' => \'E\',\n    \'Έ\' => \'E\',\n    \'Ζ\' => \'Z\', \n    \'Η\' => \'H\',\n    \'Ή\' => \'H\',\n    \'Θ\' => \'Th\', \n    \'Ι\' => \'I\', \n    \'Ί\' => \'I\',\n    \'Κ\' => \'K\', \n    \'Λ\' => \'L\', \n    \'Μ\' => \'M\', \n    \'Ν\' => \'N\', \n    \'Ξ\' => \'Ks\', \n    \'Ο\' => \'O\',\n    \'Ό\' => \'O\',\n    \'Π\' => \'P\', \n    \'Ρ\' => \'R\', \n    \'Σ\' => \'S\', \n    \'Τ\' => \'T\', \n    \'Υ\' => \'Y\',\n    \'Ύ\' => \'Y\',\n    \'Φ\' => \'F\', \n    \'Χ\' => \'X\', \n    \'Ψ\' => \'Ps\', \n    \'Ω\' => \'O\',\n    \'Ώ\' => \'O\',\n    \'α\' => \'a\', \n    \'β\' => \'v\', \n    \'γ\' => \'g\', \n    \'δ\' => \'d\', \n    \'ε\' => \'e\', \n    \'ζ\' => \'z\', \n    \'η\' => \'h\', \n    \'θ\' => \'th\', \n    \'ι\' => \'i\', \n    \'κ\' => \'k\', \n    \'λ\' => \'l\', \n    \'μ\' => \'m\', \n    \'ν\' => \'n\', \n    \'ξ\' => \'ks\', \n    \'ο\' => \'o\', \n    \'π\' => \'p\', \n    \'ρ\' => \'r\', \n    \'σ\' => \'s\', \n    \'τ\' => \'t\', \n    \'υ\' => \'y\', \n    \'φ\' => \'f\', \n    \'χ\' => \'x\', \n    \'ψ\' => \'ps\', \n    \'ω\' => \'o\', \n    \'ς\' => \'s\', \n    \'ά\' => \'a\', \n    \'έ\' => \'e\', \n    \'ή\' => \'h\', \n    \'ί\' => \'i\', \n    \'ό\' => \'o\', \n    \'ύ\' => \'y\', \n    \'ώ\' => \'o\', \n    \'ϊ\' => \'i\', \n    \'ϋ\' => \'y\', \n    \'ΐ\' => \'i\', \n    \'ΰ\' => \'y\' \n    )); \n}\n\nfunction repair_file_name($string) { \nreturn strtr($string, array(\n    \' \' => \'_\',\n    \'\\\\\' => \'_\',\n    \'/\' => \'_\',\n    \':\' => \'_\', \n    \'*\' => \'_\', \n    \'?\' => \'_\', \n    \'\"\' => \'_\',\n    \'<\' => \'_\',\n    \'>\' => \'_\', \n    \'|\' => \'_\'\n    )); \n}\n\nfunction createDateRangeArray($strDateFrom,$strDateTo)\n{\n\n    $sql=\"  select holiday.holiday \n            from holiday\n            inner join school_year on holiday.school_year_id=school_year.id\n            inner join school on school.school_year_id = school_year.id\";\n    $retval=nuRunQuery($sql);\n    \n    $holiday_array = array();\n    while($row=db_fetch_row($retval)){\n        array_push($holiday_array,$row[0]);\n    }\n    \n    $sql=\"select id from day\";\n    $retval=nuRunQuery($sql);\n    \n    $day_array = array();\n    while($row=db_fetch_row($retval)){\n        array_push($day_array,$row[0]);\n    }\n    \n    $aryRange=array();\n\n    $iDateFrom=mktime(1,0,0,substr($strDateFrom,5,2),     substr($strDateFrom,8,2),substr($strDateFrom,0,4));\n    $iDateTo=mktime(1,0,0,substr($strDateTo,5,2),     substr($strDateTo,8,2),substr($strDateTo,0,4));\n\n    if ($iDateTo>=$iDateFrom)\n    {\n    \n        $day_of_week = idate(\'w\', strtotime(date(\'Y-m-d\',$iDateFrom)))-1;\n        if(in_array($day_of_week,$day_array)){\n                array_push($aryRange,date(\'Y-m-d\',$iDateFrom)); // first entry\n            }\n    \n        while ($iDateFrom<$iDateTo)\n        {\n            $iDateFrom+=86400; // add 24 hours\n            \n            $day_of_week = idate(\'w\', strtotime(date(\'Y-m-d\',$iDateFrom)))-1;\n            if(in_array($day_of_week,$day_array)){\n                array_push($aryRange,date(\'Y-m-d\',$iDateFrom));\n            }\n        }\n    }\n\n    return array_diff($aryRange, $holiday_array);\n}\n\n$nuParameters = \'-1\';\n\nif(\'#absence_class_id#\'!=\'#\'.\'absence_class_id#\' && \'#absence_class_id#\'!=\'\'){ \n    if (\'#from_date#\'!=\'#\'.\'from_date\'.\'#\' && \'#from_date#\'!=\'\'){\n        if (\'#to_date#\'!=\'#\'.\'to_date\'.\'#\' && \'#to_date#\'!=\'\'){\n            \n            $class_id = \'#absence_class_id#\';\n            $days = createDateRangeArray(\'#from_date#\',\'#to_date#\');\n            $files = array();\n        \n            if(count($days)>0){\n            \n                $sql=\"  select short_name \n                        from class\n                        where id=\'#absence_class_id#\'\";\n                $rv=nuRunQuery($sql);\n                $r=db_fetch_row($rv);\n                $class_name = $r[0];\n                \n                $dir_name = greek_to_greeklish(repair_file_name($class_name.\"_\".date(\"YmdHis\")));\n                $dir = \"tmp\".DIRECTORY_SEPARATOR.$dir_name;\n                \n                if(mkdir($dir)){\n                    \n                    $zip = new ZipArchive();\n                    $zip->open($dir.\'.zip\', ZipArchive::CREATE);\n                    \n                    $hashData = nuHashData();\n                    $hashData[\'absence_class_id\'] = \'#absence_class_id#\';\n                    nuV(\'code\', \'absence_class_day_table\');\n                    nuV(\'call_type\', \'printpdf\');\n                    \n                    foreach($days as $day){\n                        \n                        $day_of_week = idate(\'w\', strtotime($day))-1;\n                        \n                        $sql = \"    SELECT COUNT(*) \n                                    FROM card \n                                    WHERE \n                                        class_id=\'#absence_class_id#\' AND\n                                        day_id = \'$day_of_week\' AND\n                                        valid_from = (  SELECT max(timetable.start_date) \n                                			            FROM timetable \n                                			            WHERE (timetable.start_date <= \'$day\'))\n                                        \";\n                        $retval = nuRunQuery($sql);\n                        $row = db_fetch_row($retval);\n                        if($row[0]>0){\n                            $file_name = $day.\".pdf\";\n                        \n                            nuV(\'filename\', $file_name);\n                            $hashData[\'absence_date\'] = $day;\n                            $hashData[\'parent_record_id\'] = \'absence_class_day_table\';\n                            $tmp_nu_file = nuPDForPHPParameters($hashData);\n                        \n                            rename($tmp_nu_file, $dir.\'/\'.$file_name);\n                            $files[] =  $dir.\'/\'.$file_name;\n                        }\n                    }\n                    \n                    foreach($files as $file){\n                        $zip->addFile($file, basename($file));\n                    }\n                    \n                    $zip->close();\n                    \n                    $nuParameters = $dir.\'.zip\';\n                } else{\n                    $nuError = \"Προσοχή : Δεν μπορούν να αποθηκευτουν τα εξαγόμενα αρχεία στον εξυπηρετητή!\";    \n                }    \n            } else {\n                $nuError = \"Δε βρέθηκαν ημερομηνίες λειτουργίας του σχολείου στο μεσοδιάστημα από και έως...\";    \n            }        \n        } else {\n            $nuError = \"Παρακαλώ ορίσετε την ημερομηνία έως...\";\n        }\n    } else {\n        $nuError = \"Παρακαλώ ορίσετε την ημερομηνία από...\";    \n    }\n} else {\n    $nuError = \"Παρακαλώ επιλέξτε τμήμα!\";    \n}\n','','0','2018-06-01 19:07:32','globeadmin','2018-06-03 10:21:10','globeadmin','2018-07-16 15:52:54','globeadmin','0'),('5b1f96ff515d327','user_login_log','Ιστορικό σύνδεσης χρήστη','Teacher','$sql = \"SELECT \n	DATE_FORMAT(sul_start,\'%d-%m-%Y %T\'),\n    IF(sul_end IS NULL OR sul_end=sul_start,\'Ν/Α\',DATE_FORMAT(sul_end,\'%d-%m-%Y %T\')),\n    IF(sul_end IS NULL OR sul_end=sul_start,\'Ν/Α\',SEC_TO_TIME(TIMESTAMPDIFF(SECOND,sul_start,sul_end))),\n    sul_ip,\n    DATE_FORMAT(sul_start,\'%d-%m-%Y\')\nFROM zzzsys_user_log \nINNER JOIN zzzsys_user ON zzzsys_user_log.sul_zzzsys_user_id=zzzsys_user.zzzsys_user_id\nWHERE zzzsys_user.zzzsys_user_id=\'#RECORD_ID#\'\nORDER BY sul_start DESC\";\n\n$retval = nuRunQuery($sql);\n\nprint \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n    </head>\n    <body>\";\n\nif($retval ){\n    if(db_num_rows($retval)>0){\n        print (\"\n            <table cellspacing=0 align=center CLASS=\\\"sisTable\\\">\n                <tr height=30> \n                    <th width=40 align=center>Α/Α</th>\n                    <th width=180 align=center>Σύνδεση</th>\n                    <th width=180 align=center>Τελευταία Δραστηριότητα</th>\n                    <th width=150 align=center>Χρόνος Παραμονής</th>\n                    <th width=150 align=center>Διεύθυνση IP</th>\n                </tr>\");\n\n        $i=1;\n        $d = \"1970-01-01\";\n    \n        $color1 = \"LightBlue\";\n        $color2 = \"LightSteelBlue\";\n        $color = $color;\n    \n        while($row = db_fetch_row($retval)){\n            if($d!=$row[4]){\n                $d=$row[4];\n                $color = ($color==$color1 ? $color2 : $color1);\n            }\n            print \"\n                <tr style=\\\"background-color:$color;\\\">\n                    <td align=center>$i</td>\n                    <td align=center>\".$row[0].\"</td>\n                    <td align=center>\".$row[1].\"</td>\n                    <td align=center>\".$row[2].\"</td>\n                    <td align=center>\".$row[3].\"</td>\n                </tr>\";\n            $i++;\n        }\n        print (\"\n            </table>\");\n    } else {\n        print (\"<span CLASS=\\\"msg\\\">Δε βρέθηκαν συνδέσεις!</span>\");    \n    }\n} else{\n    print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν τα δεδομένα!</span>\");\n}\nprint \"\n    </body>\n</html>\";','','0','2018-06-12 12:48:47','globeadmin','2018-07-15 21:38:05','globeadmin','2018-07-15 21:38:06','globeadmin','0'),('5b5dc66f6d3bbfa','first_record','Βρίσκει την πρώτη εγγραφή σε μία φόρμα','sisyphos','$sql = \"    SELECT sfo_sql\n            FROM zzzsys_form\n            WHERE zzzsys_form_id = \'#FORM_ID#\'\";\n$retval=nuRunQuery($sql);\n\nif($retval){\n    if($row=db_fetch_row($retval)){\n        $hashData = nuHashData();\n        $sql = nuReplaceHashes($row[0],$hashData);\n        $rv=nuRunQuery($sql);\n        if($rv){\n            $nuParameters = \'-1\';\n            if($r=db_fetch_array($rv)){\n                $nuParameters = $r[\'id\'];    \n            }\n        } else{\n            $nuError = \"Προσοχή! Παρουσιάστηκε πρόβλημα κατά την ανάκτηση των δεδομένων!\";    \n        } \n    } else {\n        $nuError = \"Προσοχή! Παρουσιάστηκε πρόβλημα κατά την ανάκτηση των δεδομένων!\";    \n    }\n} else {\n    $nuError = \"Προσοχή! Παρουσιάστηκε πρόβλημα κατά την ανάκτηση των δεδομένων!\";    \n}\n','','0','2018-07-29 16:51:43','globeadmin','2018-07-30 19:53:57','globeadmin','2018-07-30 19:53:57','globeadmin','0'),('5b5dc7d35686687','last_record','Βρίσκει την τελευταία εγγραφή σε μία φόρμα','sisyphos','$sql = \"    SELECT sfo_sql\n            FROM zzzsys_form\n            WHERE zzzsys_form_id = \'#FORM_ID#\'\";\n$retval=nuRunQuery($sql);\n\nif($retval){\n    if($row=db_fetch_row($retval)){\n        $hashData = nuHashData();\n        $sql = nuReplaceHashes($row[0],$hashData);\n        $rv=nuRunQuery($sql);\n        if($rv){\n            $nuParameters = \'-1\';\n            while($r=db_fetch_array($rv)){\n                $nuParameters = $r[\'id\'];    \n            }\n        } else{\n            $nuError = \"Προσοχή! Παρουσιάστηκε πρόβλημα κατά την ανάκτηση των δεδομένων!\";    \n        } \n    } else {\n        $nuError = \"Προσοχή! Παρουσιάστηκε πρόβλημα κατά την ανάκτηση των δεδομένων!\";    \n    }\n} else {\n    $nuError = \"Προσοχή! Παρουσιάστηκε πρόβλημα κατά την ανάκτηση των δεδομένων!\";    \n}\n','','0','2018-07-29 16:57:39','globeadmin','2018-07-30 19:54:14','globeadmin','2018-07-30 19:54:15','globeadmin','0'),('5c1e7af53187bff','sisyphos_lib','Βιβλιοθήκη συναρτήσεων','Sisyphos','function get_system_url($create=false){\n\n    $sql=\"select ifNULL(system_url,\'\') from school where id=1\";\n    $retval = nuRunQuery($sql);\n    if($row = db_fetch_row($retval)){//&& filter_var($r1[0], FILTER_VALIDATE_URL) === true\n        if(trim($row[0]) !=\"\") return  $row[0];\n    }\n\n    $sql=\"select ifNULL(system_url,\'\') from session_variables where session_id=\'#session_id#\'\";\n    $retval = nuRunQuery($sql);\n    if($row = db_fetch_row($retval)){\n        if(trim($row[0]) !=\"\") return  $row[0];\n    }\n\n    if($create){\n        $ssl = (!empty($_SERVER[\'HTTPS\']) && $_SERVER[\'HTTPS\'] == \'on\') ? true:false;\n        $sp = strtolower($_SERVER[\'SERVER_PROTOCOL\']);\n        $protocol = substr($sp, 0, strpos($sp, \'/\')) . (($ssl) ? \'s\' : \'\');\n        $port = $_SERVER[\'SERVER_PORT\'];\n        $port = ((!$ssl && $port==\'80\') || ($ssl && $port==\'443\')) ? \'\' : \':\'.$port;\n        $host = isset($_SERVER[\'HTTP_HOST\']) ? $_SERVER[\'HTTP_HOST\'] : $_SERVER[\'SERVER_NAME\'];\n    \n        $folder=\'\';\n        $url = $_SERVER[\'REQUEST_URI\']; //returns the current URL\n        $parts = explode(\'/\',$url);\n        for ($i = 0; $i < count($parts) - 1; $i++) {\n            $folder .= $parts[$i] . \"/\";\n        }\n        return $protocol . \'://\' . $host . $port . $folder;        \n    } \n    \n    return \"\";\n}\n\nfunction get_school_name($short=false){\n    $sql=\"select ifNULL(\".($short ? \"short_name\" : \"name\").\",\'Σχολείο\') from school where id=1\";\n    $retval = nuRunQuery($sql);\n    $row = db_fetch_row($retval);\n    return  $row[0];\n}','','0','2018-12-22 19:57:09','globeadmin','2019-07-24 19:46:46','globeadmin','2019-07-24 19:46:46','globeadmin','0'),('5c83c9358b77ad3','add_student_subject_comment','Προσθέτει ένα σχόλιο για ένα μαθητή σε ένα μάθημα','teacher','nuRunPHP(\'notification_add_lib\');\n\n$nuParameters = \"\";\n\nif( \'#student_id#\' !=\'\' && \'#student_id#\' != \'#\'.\'student_id#\' && \'#student_id#\' !=\'-1\' &&\n    \'#subject_id#\' !=\'\' && \'#subject_id#\' != \'#\'.\'subject_id#\' && \'#subject_id#\' !=\'-1\' &&\n    \'#new_comment#\' !=\'\' && \'#new_comment#\' != \'#\'.\'new_comment#\'\n    ){\n    \n    $sql=\"  SELECT id\n            FROM comment\n            WHERE \n                student_id=\'#student_id#\' AND\n                subject_id=\'#subject_id#\'\"; \n    $retval = nuRunQuery($sql);\n    if($retval){\n        if(db_num_rows($retval)==0){\n           // insert new comment\n           $sql = \" INSERT INTO comment (\n                id,	\n                student_id,\n                subject_id,\n                post_teacher_id,\n                changed_at,\n                student_viewed_at,\n                parent_viewed_at,\n                student_comments_changed_at)\n            VALUES(\n                NULL,\n                \'#student_id#\',\n                \'#subject_id#\',\n                #RECORD_ID#,\n                NOW(),\n                \'2000-01-01\',\n                \'2000-01-01\',\n                NOW())\";\n            $comment_id = nuRunQuery($sql,null,true);\n        } else {\n            $row = db_fetch_row($retval);\n            $comment_id = $row[0];\n        }\n    }\n    \n    if(\'#teacher_chk_hash#\'==\'1\' || \'#student_chk_hash#\'==\'1\'){\n        $sql=\" UPDATE comment SET \n                    post_teacher_id = \'#RECORD_ID#\',\n                    changed_at = now()\n                WHERE id=\'$comment_id\'\";  \n        nuRunQuery($sql);\n    } \n    \n    \n    if(\'#teacher_chk_hash#\'==\'1\'){\n        $sql=\"  UPDATE comment SET \n                        teacher_comments = CONCAT(if(teacher_comments IS NULL,\'\',teacher_comments),\'\".esc(\'#new_comment#\').\"\')\n                    WHERE id=\'$comment_id\'\"; \n        nuRunQuery($sql);\n    }\n        \n    if(\'#student_chk_hash#\'==\'1\'){\n        $sql=\"  UPDATE comment SET \n                        student_comments = CONCAT(if(student_comments IS NULL ,\'\',student_comments),\'\".esc(\'#new_comment#\').\"\'),\n                        student_comments_changed_at = now()\n                    WHERE id=\'$comment_id\'\";\n        nuRunQuery($sql);\n    \n        update_comment_notification($comment_id);\n    }\n        \n} else{\n    $nuError = \"Παρουσιάστηκε σφάλμα κατά την προσθήκη του σχόλιου!\\nΤο σχόλιο δεν προστέθηκε!\";    \n}    \n\n$nuParameters = \"Το σχόλιο προστέθηκε επιτυχώς!\";\n    ','','0','2019-03-09 16:09:57','globeadmin','2019-03-09 21:18:27','globeadmin','2019-03-09 21:18:27','globeadmin','0'),('5c84df1571ef247','register_no_lesson_mass','Καταχωρεί ότι δεν έγινε μάθημα σε ένα σύνολο διδασκαλιών','teacher','function esc($str){\n    $db_params = nuRunQuery();\n    $link = mysqli_connect($db_params[0], $db_params[2], $db_params[3], $db_params[1]);\n\n    if (mysqli_connect_errno()) {\n        nuDebug(\"Connect failed: %s\\n\", mysqli_connect_error());\n        return \'\';\n    }\n    return(mysqli_real_escape_string($link,$str));\n}\n\nif(\'#card_list#\' != \'#\'.\'card_list\'.\'#\' && \'#card_list#\' != \'\'){\n    \n    $comments=\'\';\n    if(\'#no_lesson_comments#\' != \'#\'.\'no_lesson_comments\'.\'#\' && \'#no_lesson_comments#\' != \'\'){\n        $comments=\'#no_lesson_comments#\';\n    }\n    \n    $lessons = explode(\",\", \"#card_list#\");\n    \n    foreach($lessons as $lesson) {\n        $l = explode(\"/\", $lesson);\n        $card_id = $l[0];\n        $absence_date = $l[1];\n        \n        /*$sql=\"  SELECT COUNT(*)\n                FROM registered_card \n                WHERE \n                    card_id = \'$card_id\'\n                    card_date = \'$absence_date\'\";\n        $retval=nuRunQuery($sql);\n        $row = db_fetch_row($retval);\n        if($row[0]==0){*/\n        \n        $sql=\"  SELECT c1.id\n                FROM card as c1\n                INNER JOIN card AS c2 ON c2.id=\'$card_id\'\n                WHERE\n                    c1.valid_from   = c2.valid_from AND\n                    c1.day_id       = c2.day_id AND\n                    c1.period_id    = c2.period_id AND\n                    c1.class_id     = c2.class_id AND\n                    c1.id not in (  SELECT registered_card.card_id \n                                    FROM registered_card \n                                    WHERE registered_card.card_date = \'$absence_date\')\";\n        $retval=nuRunQuery($sql);\n        \n        $is_primary=1;\n                \n        while($row=db_fetch_row($retval)){\n            $sql=\"  INSERT INTO registered_card (\n                                id,\n                                card_date,\n                                posted_when,\n                                card_id,\n                                comments,\n                                teacher_id,\n                                no_lesson,\n                                prime\n                            ) VALUES (\n                                NULL,\n                                \'$absence_date\',\n                                NOW(),\n                                \".$row[0].\",\n                                \'\".esc($comments).\"\',\n                                #RECORD_ID#,\n                                1,\n                                $is_primary)\";\n            nuRunQuery($sql); \n            $is_primary=0;\n        }\n        //}\n    }\n\n    nuRunPHP(\'absence_card_not_registered\');\n    \n} else {\n    $message = \'Παρακαλώ επιλέξτε πρώτα τις διδασκαλίες!\';\n    nuDisplayError($message);   \n}','','0','2019-03-10 11:55:33','globeadmin','2019-03-10 16:43:03','globeadmin','2021-02-25 23:13:05','globeadmin','0'),('5d0dda2ac6ea17d','get_student_absence_state','Επιστρέφει αν ο μαθητής βρίσκεται στην τάξη','sisyphos','function get_student_state($student_id){\n\n    // Έλεγχος λήξης μαθημάτων    \n    $sql    = \" SELECT IF(CURDATE()>school_year.end_date,\'1\',\'0\') \n                FROM school\n                INNER JOIN school_year ON school.school_year_id = school_year.id\n                WHERE\n                    school.id = 1\";\n    $retval = nuRunQuery($sql);\n\n    if(db_num_rows($retval) == 1){\n        $row = db_fetch_row($retval);\n        if($row[0] == \'1\'){\n            return \'Το διδακτικό έτος έχει λήξει\';\n        }\n    }\n\n    // Έλεγχος αν σήμερα είναι ημέρα λειτουργίας του σχολείου\n\n    $curdate    = date(\'Y-m-d\');\n    $day_of_week = idate(\'w\', strtotime($curdate))-1;\n\n    $sql    = \" SELECT id\n                FROM day\n                WHERE id = $day_of_week\";\n    $retval = nuRunQuery($sql);\n    \n    if(db_num_rows($retval) == 0){\n        return \'Σήμερα το σχολείο δεν λειτουργεί\';\n    }\n\n    //  Έλεγχος αν σήμερα είναι αργία\n    \n    $sql    = \" SELECT id\n                FROM holiday where holiday.holiday=\'$curdate\'\";\n    $retval = nuRunQuery($sql);\n    \n    if(db_num_rows($retval) > 0){\n            return \'Σήμερα για το σχολείο είναι ημέρα αργίας\';\n    }\n\n    \n    // Έλεγχος αν έχει λήξει το ημερήσιο ωράριο\n\n    $sql    = \" SELECT IF(CURTIME() < MIN(start_time) OR CURTIME() > MAX(end_time),\'1\',\'0\') \n                FROM period\";\n    $retval = nuRunQuery($sql);\n    \n    if(db_num_rows($retval) == 1){\n        $row = db_fetch_row($retval);\n        if($row[0] == \'1\'){\n            return \'Αυτήν την ώρα δεν πραγματοποιούνται μαθήματα\';\n        }\n    }\n\n    // Έυρεση ώρας\n    \n    $sql    = \" SELECT if(gender=\'Θ\',\'H μαθήτρια\',\'O μαθητής\')\n                FROM student\n                WHERE id=\'$student_id\'\";\n    $retval =nuRunQuery($sql);\n    if($row = db_fetch_row($retval))\n        $g = $row[0];\n    else \n        $g = \'O μαθητής\';\n    \n    $sql    = \" SELECT id,name,LEFT(end_time,5)\n                FROM period\n                WHERE CURTIME() BETWEEN period.start_time AND period.end_time\";\n    $retval =nuRunQuery($sql);\n    \n    \n    if(db_num_rows($retval) == 0){    // Δίαλειμα\n        return \"$g έχει διάλειμμα\";    \n    } else if(db_num_rows($retval) == 1){\n        $row = db_fetch_row($retval); // Εν μέσω ώρας διδασκαλίας\n        $curperiod = $row[0];\n        $curperiod_name = $row[1];\n        $end_period = $row[2];\n    } else return \'\'; // Λαθος στις ώρες των μαθημάτων\n\n    $sql = \"    SELECT max(timetable.start_date)\n	            FROM timetable\n                WHERE timetable.start_date<=\'$curdate\'\";\n    $retval = nuRunQuery($sql);\n    $row    = db_fetch_row($retval); \n    \n    $timetable_date = $row[0];\n\n    $sql = \"SELECT  card.id,\n                    IF(subject.name IS NULL , subject.short_name, CONCAT(subject.name,\' (\', ifNull(subject_type.short_name,\'\'),\')\')),\n                    CONCAT(IFNULL(teacher.surname,\'\'),\' \',IFNULL(teacher.name,\'\')),\n                    class.short_name,\n                    IFNULL(classroom.short_name,\'\')\n            FROM card\n            INNER JOIN subject      ON card.subject_id          = subject.id\n            INNER JOIN teacher      ON card.teacher_id          = teacher.id\n            INNER JOIN class        ON card.class_id            = class.id\n            LEFT JOIN classroom     ON card.classroom_id        = classroom.id\n            LEFT JOIN subject_type  ON subject.subject_type_id  = subject_type.id\n            WHERE \n            	card.valid_from = \'$timetable_date\' AND\n            	card.day_id = \'$day_of_week\' AND\n            	card.period_id = \'$curperiod\' AND\n            	class.id in (   SELECT distinct student_class.class_id \n            	                FROM student_class \n            	                WHERE student_class.student_id=\'$student_id\')\";\n\n    $retval = nuRunQuery($sql);\n\n    if(db_num_rows($retval) == 0){    // Δεν υπάρχει διδασκαλία\n        return \"$g δεν έχει προγραμματισμένη διδασκαλία\";    \n    }\n    \n    $card_ids        = array();\n    $subject_names   = array();\n    $teacher_names   = array();\n    $class_names     = array();\n    $classroom_names = array();\n    \n    while($row = db_fetch_row($retval)){\n        $card_ids[]        = $row[0];\n        $subject_names[]   = $row[1];\n        $teacher_names[]   = $row[2];\n        $class_names[]     = $row[3];\n        $classroom_names[] = $row[4];        \n    }\n    \n    $cards          = implode(\",\", array_unique($card_ids));\n    $subject_name   = implode(\",\", array_unique($subject_names));\n    $teacher_name   = implode(\",\", array_unique($teacher_names));\n    $class_name     = implode(\",\", array_unique($class_names));\n    $classroom_name = implode(\",\", array_unique($classroom_names));\n    \n    $lesson = $subject_name.\", \".$class_name.\", \".$teacher_name.($classroom_name==\"\" ? \"\" : \", Αίθ. \".$classroom_name);\n    \n    $sql = \"SELECT card_id, no_lesson\n            FROM registered_card\n            WHERE \n                card_date = \'$curdate\' AND\n                card_id IN  ($cards)\";\n    $rv = nuRunQuery($sql);\n    \n    if(db_num_rows($rv) == 0){    // Δεν έχει γίνει καταχώρηση ακόμη\n        return \"$g έχει μάθημα \\\"$lesson\\\" μεχρι τις $end_period\";    \n    }\n    \n    $r = db_fetch_row($rv);\n    $card_id = $r[0];\n    \n    if($r[1]==\'1\'){ // Κενό\n        return \"$g έχει <font color=\\\"#FF8C00\\\"><u>κενό</u></font> μέχρι τις $end_period, το μάθημα \\\"$lesson\\\" δεν πραγματοποιείται\";     \n    }    \n    \n// Έλεγχος για απουσία\n\n    $sql=\"SELECT  \n            absence.id,\n            absence_reason.short_name,\n            absence_reason.name\n        FROM absence\n        INNER JOIN absence_reason       ON absence_reason.id = absence.absence_reason_id\n        WHERE \n            absence.student_id = \'$student_id\' AND\n            absence.absence_date = \'$curdate\' AND\n            absence.card_id = \'$card_id\'\";\n\n    $retval = nuRunQuery($sql);\n\n    if(db_num_rows($retval) == 0){    // Δεν υπάρχει απουσία\n        return \"$g είναι <font color=\\\"green\\\"><u>παρών</u></font> στο μάθημα \\\"$lesson\\\" (λήξη ώρας $end_period)\";    \n    }\n\n    // Ο μαθητής έχει απουσία\n\n    $row = db_fetch_row($retval);\n\n    return \"$g <font color=\\\"red\\\"><u>απουσιάζει (\".$row[2].\")</u></font> στο μάθημα \\\"$lesson\\\" (λήξη ώρας $end_period)\";\n}\n\nif(\'#nu_user_group#\'==\'Students\' || \'#nu_user_group#\'==\'Parents\'){\n    $sql    = \" SELECT student_id FROM session_variables WHERE session_id = \'#session_id#\'\";\n    $retval = nuRunQuery($sql);\n    $row    = db_fetch_row($retval); \n    $student_id = $row[0];\n} else {\n    $student_id = \'#RECORD_ID#\';    \n}\n\n$nuParameters = get_student_state($student_id);\n','','0','2019-06-22 10:35:07','globeadmin','2019-07-25 12:32:51','globeadmin','2019-07-25 12:32:51','globeadmin','0'),('5e64b003a223bfc','create_notifications_email_queue','Δημιουργεί τις ειδοποιήσεις μιας λίστας απο id ή όσες είναι σε εκκρεμότητα βαζοντας τα email σε ουρά για μετέπειτα αποστολή','manager','nuRunPHP(\"sisyphos_lib\");\n\nfunction my_esc($str){\n    $db_params = nuRunQuery();\n    $link = mysqli_connect($db_params[0], $db_params[2], $db_params[3], $db_params[1]);\n\n    if (mysqli_connect_errno()) {\n        nuDebug(\"Connect failed: %s\\n\", mysqli_connect_error());\n        return \'\';\n    }\n    return(mysqli_real_escape_string($link,$str));\n}\n\nfunction nextID($table_name,$temp_key){\n\n    $temp_id    = nuID();\n	\n    $sql        = \"INSERT IGNORE $table_name SET $temp_key =  \'$temp_id\'\";        //-- insert to create next number\n    nuRunQuery($sql);\n    \n    $sql        = \"SELECT id FROM $table_name WHERE $temp_key = \'$temp_id\'\";    //-- get next number\n    $retval     = nuRunQuery($sql);\n    $row        = db_fetch_row($retval);\n	\n	$sql        = \"UPDATE $table_name SET $temp_key = NULL WHERE id = \'\".$row[0].\"\'\"; \n	nuRunQuery($sql);\n	\n    return $row[0];                                                        	    //-- return next number\n}\n\n$system_url = get_system_url();\n$school_name = get_school_name();\n\n// Ομαδοποίηση ειδοποιήσεων για νέες απουσίες όπου αυτό απαιτείται \nnuRunPHP(\'group_new_absence_notification\');\n\n//------------------------------------------------------------------------------------------------------------------------------------    \n            // Δημιουργία προσωρινού πίνακα                        \nif(\'#TABLE_ID#\' != \'#\'.\'TABLE_ID\'.\'#\' && \'#TABLE_ID#\' != \'\'){\n    $tmp_table=\'#TABLE_ID#\';\n} else {\n    $tmp_table=\'__\'.nuID().\'__\';\n}\n    \n$sql=\"DROP TEMPORARY TABLE IF EXISTS \".$tmp_table;\nnuRunQuery($sql);\n   \nif(\'#notification_id_list#\' != \'#\'.\'notification_id_list\'.\'#\' && \'#notification_id_list#\' != \'\'){\n    $sql=\"CREATE TEMPORARY TABLE \".$tmp_table.\" DEFAULT CHARACTER SET=utf8 SELECT *, CAST(\'\' AS CHAR(255)) AS email_address FROM notification where id in (#notification_id_list#)\";\n} else {\n    $sql=\"CREATE TEMPORARY TABLE \".$tmp_table.\" DEFAULT CHARACTER SET=utf8 SELECT *, CAST(\'\' AS CHAR(255)) AS email_address  FROM notification where pending=1\";\n}\nnuRunQuery($sql);\n\n//--------------------------------------------------------------------------------------------------------------------------------------- \n            // αγνόηση συμβάντων στα οποία είναι λάθος η διευθυνση email\n$absence_deleted = 0;\n\n$sql=\"  UPDATE $tmp_table as a\n        INNER JOIN student as b ON  $tmp_table.student_id = student.id\n        SET a.email_address = ΤΡΙΜ(if(a.is_parent=\'1\',ifNUll(b.parent_email,\'\'),ifNULL(b.email,\'\')))\";\nnuRunQuery($sql);\n\n$sql=\"  DELETE FROM \".$tmp_table.\" \n        WHERE email_address IS NULL OR email_address=\'\'\";\nnuRunQuery($sql);\n\n$sql=\"  SELECT DISTINCT email_address FROM $tmp_table\";\n$retval = nuRunQuery($sql);\n    \nif($retval) {\n    while($row = db_fetch_row($retval)) {\n        if(!filter_var($row[0], FILTER_VALIDATE_EMAIL)){\n            $sql=\"  DELETE FROM \".$tmp_table.\" \n                    WHERE email_address=\'\".$row[0].\"\'\";\n            nuRunQuery($sql);        \n        }    \n    }\n}\n//------------------------------------------------------------------------------------------------------------------------------------\n            // αγνόηση συμβάντων εισαγωγής απουσιών για τα οποία δεν έχει ολοκληρωθεί η καταχώρηση των απουσιών του μαθητή την ημέρα αυτή \n$absence_deleted = 0;\n    \n$sql=\"  SELECT DISTINCT \n            student_id,\n            DATE_FORMAT(occurred_at, \'%Y-%m-%d\') \n        FROM \".$tmp_table.\" \n        WHERE \n            type_id=1 AND \n            occurred_at IS NOT NULL\";\n$retval = nuRunQuery($sql);\n    \nif($retval) {\n    while($row = db_fetch_row($retval)) {\n        \n        $sql=\"      SELECT count(distinct period_id)\n                    FROM card\n                    WHERE\n                        valid_from=(select max(c.valid_from) from card as c where c.valid_from<=\'\".$row[1].\"\') and\n                        day_id=\".(idate(\'w\', strtotime($row[1]))-1).\" and\n                        card.id not in (    select card_id \n                                            from registered_card\n                                            where DATE_FORMAT(registered_card.card_date, \'%Y-%m-%d\')=\'\".$row[1].\"\') and\n                    \'\".$row[1].\"\' not in (    select holiday.holiday \n                                                    from holiday \n                                                    inner join school_year on holiday.school_year_id=school_year.id\n                                                    inner join school on school.school_year_id=school_year.id) and\n                    card.class_id in (select distinct class_id from student_class where student_id=\'\".$row[0].\"\')\";\n            \n        $rv = nuRunQuery($sql);\n        $r = db_fetch_row($rv);\n            \n        if($r[0]>0){\n                \n            $sql=\"  SELECT count(*) \n                    FROM \".$tmp_table.\" \n                    WHERE \n                            student_id=\'\".$row[0].\"\' AND \n                            type_id=1 AND \n                            DATE_FORMAT(occurred_at, \'%Y-%m-%d\')=\'\".$row[1].\"\'\n                            \";                \n            $rv1 = nuRunQuery($sql);\n            $r1 = db_fetch_row($rv1);\n            $absence_deleted += $r1[0];\n                \n            $sql=\"  DELETE FROM \".$tmp_table.\" \n                    WHERE \n                        student_id=\'\".$row[0].\"\' AND \n                        type_id=1 AND \n                        DATE_FORMAT(occurred_at, \'%Y-%m-%d\')=\'\".$row[1].\"\'\n                        \";\n            nuRunQuery($sql);\n            }\n        }\n    }\n\n//--------------------------------------------------------------------------------------------------------------------------------------- \n$sql=\"  SELECT DISTINCT student_id,is_parent,email_address FROM \".$tmp_table;\n$retval = nuRunQuery($sql);\n\nif($retval) {\n    if(db_num_rows($retval)>0) {\n        \n        $subject = \"Σίσυφος - Ενημερωτικό Δελτίο\";\n            \n        while($row = db_fetch_row($retval)) {\n                \n            $sql=\"  SELECT\n                        \".$tmp_table.\".id,\n                        DATE_FORMAT(\".$tmp_table.\".occurred_at,\'%d-%m-%Y %T\'),\n                        \".$tmp_table.\".content,\n            \n                        notification_category.id,\n                        notification_category.header,\n                        \n                        notification_type.id,\n                        notification_type.name,\n                        notification_type.header,\n                        \n                        student.registration_number,\n                        concat(if(student.surname is NULL,\'\',student.surname),if(student.name is NULL,\'\',concat(\' \',student.name)),if(student.fathers_name is NULL,\'\',concat(\' πατ. \',student.fathers_name))) as student_name,\n                        \n                        \".$tmp_table.\".email_address\n                        \n                    FROM \".$tmp_table.\"\n                    INNER JOIN notification_type        ON \".$tmp_table.\".type_id             = notification_type.id\n                    INNER JOIN notification_category    ON notification_type.category_id    = notification_category.id\n                    INNER JOIN student                  ON student.id = \'\".$row[0].\"\'\n                    WHERE \".$tmp_table.\".student_id=\'\".$row[0].\"\' AND \".$tmp_table.\".is_parent=\'\".$row[1].\"\'\n                    ORDER BY\n                        notification_category.hierarchy,\n                        notification_category.id,\n                        notification_type.hierarchy,\n                        \".$tmp_table.\".type_id,\n                        \".$tmp_table.\".occurred_at,\n                        \".$tmp_table.\".id\n                \";\n            $rv = nuRunQuery($sql);\n            if(db_num_rows($rv)>0){\n                    \n                $r = db_fetch_row($rv);\n    \n                $email_address = $r[10];\n\n$content=\"\n		<table align=center style=\\\"width: 960px!important;border-spacing: 5px 5px;\\\">\n			<tr>\n				<td align=center style=\\\"color: #525c66;line-height: 150%;font-size: 16px;font-family: Sans-serif;\\\">\n					<h2>Σίσυφος - Ενημερωτικό Δελτίο</h2>\n				</td>\n			</tr>\n			<tr>\n				<td align=center>\n					<hr style=\\\"width: 100%; height: 0px; background-color:#b04b00; color:#b04b00;border: 1px solid;\\\">\n				</td>\n			</tr>\n			<tr>\n				<th align=left style=\\\"color: #525c66;line-height: 150%;font-size: 16px;font-family: Sans-serif;\\\">\n					Μαθητής : \".$r[9].\" (ΑΜ:\".$r[8].\")\n				</th>\n			</tr>\n			<tr>\n				<td align=center>\n					<hr style=\\\"width: 100%; height: 0px; background-color:#b04b00; color:#b04b00;border: 1px solid;\\\">\n				</td>\n			</tr>			\n			<tr>\n				<td align=left style=\\\"width: 960px;color: #525c66;line-height: 150%;font-size: 16px;font-family: Sans-serif;\\\">\n					<table style=\\\"width: 960px!important;margin-top: 0px;margin-bottom: 0px;margin-right: 0px;margin-left: 0px;border:0px;border-spacing: 0px 0px;\\\">                    \n                    \";\n                    \n                    $category_id = $r[3];\n                    $category_header = $r[4];\n                    \n                    $type_id = $r[5];\n                    $type_header = $r[7];\n                    \n                    $content.=\"\n						<tr>\n							<td width=100%>\n								\".$category_header.\"\n							</td>\n						</tr>                    \n                    \";\n                    \n                    $content.=\"\n						<tr>\n							<td >\n								\".$type_header.\"\n							</td>\n						</tr>                    \n                    \";\n                    do {\n                        \n                        \n                        if($category_id != $r[3]){\n                            $category_id = $r[3];\n                            $category_header = $r[4];\n                            $content.=\"\n						<tr>\n							<td >\n								\".$category_header.\"\n							</td>\n						</tr>                    \n                            \";                        \n                                \n                        }\n                        \n                        if($type_id != $r[5]){\n                            $type_id = $r[5];\n                            $type_header = $r[7];\n                            $content.=\"\n						<tr>\n							<td >\n								\".$type_header.\"\n							</td>\n						</tr>                    \n                            \";\n                        }\n \n                        $content.=\"\n						<tr>\n							<td >\n								\".$r[2].\"\n							</td>\n						</tr>                    \n                        \";\n                        \n                    } while($r = db_fetch_row($rv));\n                    \n                    $content .=\"\n                    					</table>\n				</td>\n			</tr>\n			<tr>\n				<td align=center>\n					<hr style=\\\"width: 100%; height: 0px; background-color:#b04b00; color:#b04b00;border: 1px solid;\\\">\n				</td>\n			</tr>			\n			<tr>\n				<td align=left style=\\\"color: #525c66;line-height: 150%;font-size: 14px;font-family: Sans-serif;\\\">\n					Το δελτίο αυτό δημιουργήθηκε στις \".date(\'d-m-Y H:i:s\').\" και στάλθηκε αυτόματα από το Σίσυφο. Για πληρέστερη ενημέρωση \".( $system_url==\'\' ? \"συνδεθείτε\": \"<a href=\\\"$system_url\\\">συνδεθείτε</a>\").\" στο σύστημα.<br><b>Παρακαλώ, μην απαντάτε σ’αυτό το email.</b>\n				</td>\n			</tr>\n			<tr>\n				<td align=center>\n					<hr style=\\\"width: 50%; margin-left:0; height: 0px; border-style: dotted; border-width: 1px 0px 0px; border-color: #525c66;\\\">\n				</td>\n			</tr>\n			<tr>\n				<td align=left style=\\\"color: #525c66;line-height: 150%;font-size: 10px;font-family: Sans-serif;\\\">\n					<b>Διευκρίνιση ηλεκτρονικού ταχυδρομείου : </b>\n                    <br>\n                    Αυτό το ηλεκτρονικό μήνυμα (e-mail) μαζί με τα τυχόν επισυναπτόμενά του, είναι εμπιστευτικό και προορίζεται μόνο για χρήση από τα άτομα στα οποία απευθύνεται. Εάν δεν είστε ο προοριζόμενος παραλήπτης ή αρμόδιος για την παράδοση του μηνύματος στον προοριζόμενο παραλήπτη, παρακαλώ επιστρέψτε το στον αποστολέα και σας γνωρίζουμε ότι η αποθήκευση, ανάγνωση, μετάδοση, αναγραφή, αποκάλυψη, ανακοίνωση ή οποιασδήποτε άλλης μορφής χρήση οποιωνδήποτε πληροφοριών περιέχονται στο παρόν μήνυμα, δεν είναι σύννομη. \n                    <br>\n                    Το $school_name σε καμία περίπτωση δεν ευθύνεται για οιαδήποτε τυχόν ζημία λόγω αποθήκευσης ή ανάγνωσης του παρόντος, καθυστερημένης διαβίβασης, υποκλοπής ή αλλοίωσης.\n				</td>\n			</tr>\n		</table>\n		            \";\n                       \n                    //$mail->Send();\n                           \n                   \n                    $e_id = nextID(\'email\',\'email_address\');\n                    \n                    $sql=\"  UPDATE email SET\n                                sender_id       =-1,\n                                sent_at         =NOW(),\n                                email_address   =\'\".$email_address.\"\',\n                                email_subject   =\'\".$subject.\"\',\n                                email_text      =\'\".(my_esc($content)).\"\',\n                                fail_code       =\'\".$fail_code.\"\',\n                                fail_comments   =\'\".(is_null($fail_comments) || $fail_comments==\'\' ? \'\' : $fail_comments).\"\',\n                                teacher_id      =-1,\n                                student_id      =\'\".$row[0].\"\'\n                            WHERE id=\'\".$e_id.\"\'\";\n                    \n                    nuRunQuery($sql);\n                    \n                    $sql = \"UPDATE notification SET\n                            email_id=\'\".$e_id.\"\'\n                            \".($fail_code==0 ? \",pending=0\" : \"\").\"\n                            WHERE id IN (SELECT DISTINCT id from \".$tmp_table.\" where \".$tmp_table.\".student_id=\'\".$row[0].\"\' AND \".$tmp_table.\".is_parent=\'\".$row[1].\"\')\n                            \";\n                    nuRunQuery($sql);\n            }\n        }\n    } \n}\n\n\n\n\n','','1','2020-03-08 10:42:43','globeadmin','2020-03-08 10:42:43','globeadmin','2020-03-08 10:42:51','globeadmin','0'),('5e860fe9679ea49','eclass_db_check','Έλεγχος σύνδεσης με τη βάση δεδομένων του eclass','LMS','$nuParameters = \'\';\nif(\'#server_address#\'!=\'\' && \'#server_address#\'!=\'#\'.\'server_address#\'){\n    if(\'#server_port#\'!=\'\' && \'#server_port#\'!=\'#\'.\'server_port#\'){\n        if(\'#db_name#\'!=\'\' && \'#db_name#\'!=\'#\'.\'db_name#\'){\n            if(\'#user_name#\'!=\'\' && \'#user_name#\'!=\'#\'.\'user_name#\'){\n                if(\'#user_password#\'!=\'\' && \'#user_password#\'!=\'#\'.\'user_password#\'){\n\n                    $mysqli = new mysqli(\'#server_address#\', \'#user_name#\', \'#user_password#\', \'#db_name#\', \'#server_port#\');\n\n                        /* check connection */\n\n                    if ($mysqli->connect_errno) {\n                        $nuParameters = \'Η σύνδεση απέτυχε : \'.$mysqli->connect_error;\n                    } else {\n                            // MUST check for tables too\n                            //course, course_department, hierarchy,course_user\n                        $mysqli -> set_charset(\"utf8\");    \n                        $val = $mysqli->query(\'select 1 from user LIMIT 1\');\n\n                        if($val !== FALSE){\n                            $nuParameters = \'1\';\n                        } else {\n                            $nuParameters = \'Η σύνδεση επιτεύχθηκε όμως δεν βρέθηκε εγκατάσταση του Open eClass σε αυτήν τη Βάση Δεδομένων!\';\n                        }                            \n                    }\n\n                    $mysqli->close();\n\n                } else {\n                    $nuError = \"Παρακαλώ συμπληρώστε τον κωδικό της βάσης δεδομένων!\";\n                } \n            } else {\n                $nuError = \"Παρακαλώ συμπληρώστε το όνομα του χρήστη της βάσης δεδομένων!\";\n            } \n        } else {\n            $nuError = \"Παρακαλώ συμπληρώστε το όνομα της βάσης δεδομένων!\";\n        } \n    }else {\n            $nuError = \"Παρακαλώ συμπληρώστε τη θύρα επικοινωνίας με τη βάση δεδομένων!\";\n    } \n} else {\n    $nuError = \"Παρακαλώ συμπληρώστε το όνομα ή τη διεύθυνση του εξυπηρετητή βάσης δεδομένων!\";    \n}\n\n\n','','0','2020-04-02 19:16:41','globeadmin','2020-08-30 14:28:10','globeadmin','2020-08-30 14:28:11','globeadmin','0'),('5e8774909b74cee','eclass_get_hierarchy','Λήψη του δέντρου κατηγοριών του eclass','LMS','function unserializeLangField($value) {\n        $language=\'el\';\n\n        $values = @unserialize($value);\n\n        if ($values !== false) {\n            if (isset($values[$language]) && !empty($values[$language])) {\n                return $values[$language];\n            } else if (isset($values[\'en\']) && !empty($values[\'en\'])) {\n                return $values[\'en\'];\n            } else {\n                return array_shift($values);\n            }\n        } else {\n            return $value;\n        }\n}\n    \nfunction getParent($con,$lft, $rgt) {\n        $sql = \"SELECT * FROM hierarchy WHERE lft < $lft AND rgt > $rgt ORDER BY lft DESC LIMIT 1\";\n        $res = $con->query($sql);\n        if($res !== FALSE){\n            if ($r = $res->fetch_assoc()){\n                return($r[\"id\"]);\n            }\n        }\n        return null;\n    }\n    \nprint \"<html>\n    <head>\n\n        <meta charset=\\\"UTF-8\\\">\n        <script>\n        \n            function uncheck_all(source){\n                checkboxes = document.getElementsByTagName(\\\"input\\\");\n                for(var i=0, n=checkboxes.length;i<n;i++) {\n                    if(checkboxes[i]!=source)\n                    checkboxes[i].checked = false;\n                }\n            }\n                \n            function get_selection(){\n                checkboxes = document.getElementsByTagName(\\\"input\\\");\n                for(var i=0, n=checkboxes.length;i<n;i++) {\n                    if(checkboxes[i].checked == true) return (checkboxes[i].id);\n                }\n                return -1;\n            }\n        </script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n        \n        <STYLE TYPE=\\\"text/css\\\">\n            .sisTable TR{\n	            background-color: #FFFFE0;\n            }\n        </STYLE>\n    </head>\n    \n    <body>\";\n\nif(\'#server_address#\'!=\'\' && \'#server_address#\'!=\'#\'.\'server_address#\'){\n    if(\'#server_port#\'!=\'\' && \'#server_port#\'!=\'#\'.\'server_port#\'){\n        if(\'#db_name#\'!=\'\' && \'#db_name#\'!=\'#\'.\'db_name#\'){\n            if(\'#user_name#\'!=\'\' && \'#user_name#\'!=\'#\'.\'user_name#\'){\n                if(\'#user_password#\'!=\'\' && \'#user_password#\'!=\'#\'.\'user_password#\'){\n\n                    $mysqli = new mysqli(\'#server_address#\', \'#user_name#\', \'#user_password#\', \'#db_name#\', \'#server_port#\');\n                    \n                    if ($mysqli->connect_errno) {\n                        echo \'Η σύνδεση απέτυχε : \'.$mysqli->connect_error;\n                    } else {\n                        $mysqli -> set_charset(\"utf8\");\n                        $result = $mysqli->query(\'select * from hierarchy order by lft\');\n\n                        if($result !== FALSE){\n                            print (\"<table cellspacing=0 CLASS=\\\"sisTable\\\" align=left><tr><td>\");\n                            $parents = [];\n                            \n                            while($row = $result->fetch_assoc()) {\n                            \n                                if($parent = getParent($mysqli,$row[\"lft\"],$row[\"rgt\"])){\n                                    \n                                    do{\n                                        $current_parent = array_pop($parents);    \n                                    } while(!is_null($current_parent) && ($current_parent != $parent));\n                                    \n                                    array_push($parents, $parent);\n                                    array_push($parents, $row[\"id\"]);\n                                    \n                                    echo \"<span style=\\\"display:inline-block; width:\".(30*(count($parents)-1)).\";\\\"></span>\";\n                                    \n                                } else if(count($parents) == 0){\n                                    array_push($parents, $row[\"id\"]);    \n                                }\n                                \n                                $color = ($row[\'allow_course\']==\'1\' && $row[\'allow_user\']==\'1\' ? \'green\' : ($row[\'allow_course\']==\'1\' ? \'blue\' : ($row[\'allow_user\']==\'1\' ? \'gold\' : \'black\')));\n                                print (($color!=\'black\'? \"<input type=\\\"checkbox\\\" id=\\\"\".$row[\'id\'].\"\\\" title=\\\"Επιλογή Κατηγορίας\\\" onclick=\\\"uncheck_all(this)\\\">\" : \'\').\"<span CLASS=\\\"msg\\\" style=\\\"color: $color\\\">\".unserializeLangField($row[\'name\']).(is_null($row[\'code\']) || $row[\'code\']==\'\' ? \'\' : \" (\".$row[\'code\'].\")\").\"</span>\".\"<br>\");\n                             }\n                             print (\"</td></tr></table>\");\n                            \n                        } else {\n                            print (\'<span CLASS=\\\"msgError\\\">Η σύνδεση επιτεύχθηκε όμως δεν βρέθηκε ο κατάλογος κατηγοριών του Open eClass!</span>\');\n                        }                            \n                    }\n\n                    $mysqli->close();\n\n                } else {\n                    print (\"<span CLASS=\\\"msgError\\\">Παρακαλώ συμπληρώστε τον κωδικό της βάσης δεδομένων!</span>\");\n                } \n            } else {\n                print (\"<span CLASS=\\\"msgError\\\">Παρακαλώ συμπληρώστε το όνομα του χρήστη της βάσης δεδομένων</span>\");\n            } \n        } else {\n            print (\"<span CLASS=\\\"msgError\\\">Παρακαλώ συμπληρώστε το όνομα της βάσης δεδομένων!</span>\");\n        } \n    }else {\n         print (\"<span CLASS=\\\"msgError\\\">Παρακαλώ συμπληρώστε τη θύρα επικοινωνίας με τη βάση δεδομένων!</span>\");\n    } \n} else {\n    print (\"<span CLASS=\\\"msgError\\\">Παρακαλώ συμπληρώστε το όνομα ή τη διεύθυνση του εξυπηρετητή βάσης δεδομένων!</span>\");\n}\nprint \"\n    </body>\n</html>\";\n\n','','0','2020-04-03 20:38:24','globeadmin','2020-08-30 14:28:31','globeadmin','2020-08-30 21:58:11','globeadmin','0'),('5e89aa30b163504','eclass_send_users','Αποστολή χρηστών στο eclass','LMS','nuRunPHP(\"eclass_lib\");\n\n$nuParameters = \'\';\n\nif(\'#server_address#\'!=\'\' && \'#server_address#\'!=\'#\'.\'server_address#\'){\n    if(\'#server_port#\'!=\'\' && \'#server_port#\'!=\'#\'.\'server_port#\'){\n        if(\'#db_name#\'!=\'\' && \'#db_name#\'!=\'#\'.\'db_name#\'){\n            if(\'#user_name#\'!=\'\' && \'#user_name#\'!=\'#\'.\'user_name#\'){\n                if(\'#user_password#\'!=\'\' && \'#user_password#\'!=\'#\'.\'user_password#\'){\n                    if(\'#hierarchy_id#\'!=\'\' && \'#hierarchy_id#\'!=\'#\'.\'hierarchy_id#\'&& \'#hierarchy_id#\'!=\'-1\'){\n                        if((\'#is_teacher#\'==\'1\' && \'#teacher_id_sumo#\'!=\'\' && \'#teacher_id_sumo#\'!=\'#\'.\'teacher_id_sumo#\') ||\n                        (\'#is_teacher#\'==\'0\' && \'#student_id_sumo#\'!=\'\' && \'#student_id_sumo#\'!=\'#\'.\'student_id_sumo#\')){\n                                $mysqli = new mysqli(\'#server_address#\', \'#user_name#\', \'#user_password#\', \'#db_name#\', \'#server_port#\');\n                                if ($mysqli->connect_errno) {\n                                    $nuParameters = \'Η σύνδεση απέτυχε : \'.$mysqli->connect_error;\n                                } else {\n                                    $mysqli -> set_charset(\"utf8\");\n                                    $hierarchy_id = intval(\'#hierarchy_id#\');\n                                    $inserted = 0;\n                                    $failed = 0;\n                                    $users_exists = [];\n                                    $ids = \'#is_teacher#\'==\'1\' ? explode(\",\",\'#teacher_id_sumo#\') : explode(\",\",\'#student_id_sumo#\');\n                                    foreach($ids as $id){\n                                        list($created,$cid,$username) = create_user($id,\'#is_teacher#\',$hierarchy_id,$mysqli);\n                                        if($created)\n                                            $inserted++;\n                                        else if($cid==-1)\n                                            $failed++;\n                                        else\n                                             array_push($users_exists,$username);\n                                    }\n                                        \n                                    $nuParameters = ($inserted==0 ? \"Δεν μεταφέρθηκαν χρήστες!\" : \"Μεταφέρθηκαν -<b>$inserted</b>- χρήστες!\").\n                                                    (count($users_exists) > 0 ? \"<br>Οι -<b>\".count($users_exists).\"</b>- χρήστες :<br><span style=\\\"display:inline-block; width:30px;\\\"></span>\".implode(\",<br><span style=\\\"display:inline-block; width:30px;\\\"></span>\", $users_exists).\"<br>Υπάρχουν ήδη στο Open eClass και δεν μεταφέρθηκαν!\" : \'\').\n                                                    ($failed>0 ? \"<br>Απέτυχε η εισαγωγή -<b>$failed</b>- χρηστών!\" : \'\' );\n                                }\n\n                                $mysqli->close();\n                        } else {\n                            $nuError = \"Παρακαλώ επιλέξτε πρώτα τους \".(\'#is_teacher#\'==\'1\' ? \'Καθηγητές\' : \'Μαθητές\').\"!\";\n                        }                          \n                    } else {\n                        $nuError = \"Παρακαλώ επιλέξτε πρώτα την κατηγορία στην οποία θα ενταχθούν οι νέοι χρήστες!\";\n                    }             \n                } else {\n                    $nuError = \"Παρακαλώ συμπληρώστε τον κωδικό της βάσης δεδομένων!\";\n                } \n            } else {\n                $nuError = \"Παρακαλώ συμπληρώστε το όνομα του χρήστη της βάσης δεδομένων!\";\n            } \n        } else {\n            $nuError = \"Παρακαλώ συμπληρώστε το όνομα της βάσης δεδομένων!\";\n        } \n    }else {\n            $nuError = \"Παρακαλώ συμπληρώστε τη θύρα επικοινωνίας με τη βάση δεδομένων!\";\n    } \n} else {\n    $nuError = \"Παρακαλώ συμπληρώστε το όνομα ή τη διεύθυνση του εξυπηρετητή βάσης δεδομένων!\";    \n}\n\n\n','','0','2020-04-05 12:51:44','globeadmin','2020-08-30 14:29:39','globeadmin','2020-12-15 16:37:32','globeadmin','0'),('5f5e03747627db2','teacher_appointments','Προγραμματισμένα ραντεβού καθηγητή','teacher','if(\'#appointment_from#\'!=\'\' && \'#appointment_from#\' != \'#\'.\'appointment_from#\'){\n    $from_date = \'#appointment_from#\';    \n} else {\n    $sql = \"    SELECT IF((DATE_ADD(CURDATE(), INTERVAL -2 WEEK))>school_year.start_date, (DATE_ADD(CURDATE(), INTERVAL -2 WEEK)), school_year.start_date)\n                FROM school\n                INNER JOIN school_year ON school.school_year_id = school_year.id\n                WHERE school.id=1\";\n    $retval = nuRunQuery($sql);\n    $row = db_fetch_row($retval);\n    $from_date = $row[0];\n}\n\nif(\'#appointment_to#\'!=\'\' && \'#appointment_to#\' != \'#\'.\'appointment_to#\'){\n    $to_date = \'#appointment_to#\';    \n} else {\n    $sql = \"    SELECT IF((DATE_ADD(CURDATE(), INTERVAL 2 WEEK))<school_year.end_date, (DATE_ADD(CURDATE(), INTERVAL 2 WEEK)), school_year.end_date)\n                FROM school\n                INNER JOIN school_year ON school.school_year_id = school_year.id\n                WHERE school.id=1\";\n    $retval = nuRunQuery($sql);\n    $row = db_fetch_row($retval);\n    $to_date = $row[0];\n}\n\nif(\'#nu_user_group#\'==\'Managers\' || \'#nu_user_group#\'==\'AssistManagers\' || \'#nu_user_group#\'==\'Administrators\' || \'#nu_user_group#\'==\'Secretaries\' || \'#nu_user_group#\'==\'globeadmin\'){\n    if(\'#teacher_id_sumo#\'!=\'\' && \'#teacher_id_sumo#\' != \'#\'.\'teacher_id_sumo#\'){\n        $ids = \'#teacher_id_sumo#\';\n    } else {\n        $ids = \'#RECORD_ID#\';    \n    }\n} else {\n    $ids = \'#RECORD_ID#\';\n}\n\n$sql = \"    SELECT \n                calendar_event.id,\n                calendar_event.start_date,\n                calendar_event.start_time, \n                calendar_event.end_time,\n                ifNULL(calendar_event.location,\'\'),\n                ifNULL(calendar_event.description,\'\'),\n                IF(NOW() < CONCAT(calendar_event.start_date,\' \',calendar_event.start_time),1,0) AS planed,\n                IF(NOW() >= CONCAT(calendar_event.start_date,\' \',calendar_event.start_time) AND NOW() <= CONCAT(calendar_event.start_date,\' \',calendar_event.end_time),1,0) AS in_progress,\n                IF(NOW() > CONCAT(calendar_event.start_date,\' \',calendar_event.end_time),1,0)   AS passed,\n                IFNULL(calendar_event.was_held,\'-1\'),\n                IFNULL(calendar_event.comments,\'\'),\n                IF(session_variables.teacher_id = calendar_event.teacher_id,1,0)\n            FROM calendar_event\n            INNER JOIN session_variables ON session_id = \'#session_id#\'\n            INNER JOIN teacher ON teacher.id=calendar_event.teacher_id\n            WHERE \n                calendar_event.teacher_id IN ($ids) AND \n                calendar_event.is_appointment=1 AND\n                calendar_event.start_date BETWEEN \'$from_date\' AND \'$to_date\' AND\";\nif(\'#appointment_student_id_sumo#\'!=\'\' && \'#appointment_student_id_sumo#\' != \'#\'.\'appointment_student_id_sumo#\'){\n    $sql .=\"\n                calendar_event.id IN (SELECT calendar_event_id FROM calendar_event_access WHERE student_id IN (#appointment_student_id_sumo#) AND user_group_id=\'5717ba3eb32c252\')\";    \n} else {\n    $sql .=\"\n                1\";     \n}\n                \n$sql .= \"\n            ORDER BY calendar_event.start_date,calendar_event.start_time\";\n$retval = nuRunQuery($sql);\n\nprint \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n        \n        <STYLE TYPE=\\\"text/css\\\">\n            .sisTableLine TH{\n                font-size:8pt;\n            }\n            \n            .sisTableLine TD{\n                font-size:8pt;\n                font-weight: normal;\n            }            \n\n        </STYLE>\n        <script>\n            function delete_appointment(event_id){\n                if(confirm(\'Το ραντεβού θα διαγραφεί!\\\\nΕίστε Σίγουρος;\')){\n                    parent.nuSetHash(\'calendar_event_id\', event_id);\n                    parent.nuAjax(\'delete_appointment\',\'delete_appointment_result\')\n                }\n            }\n            \n            function comment_appointment(event_id){\n                parent.nuOpenFormInFrame(\'5f68d148d9f3222\', event_id.toString());\n            }\n            \n            function set_appointment_washeld(event_id,washeld){\n                parent.nuSetHash(\'calendar_event_id\', event_id);\n                parent.nuSetHash(\'was_held\', washeld);\n                parent.nuAjax(\'set_appointment_washeld\',\'set_appointment_washeld_result\')    \n            }\n        </script>\n    </head>\n\n    <body>\";\n\nif(!$retval){\n    print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν δεδομένα!</span>\");\n} else{\n    print \"\n        <table cellspacing=0 CLASS=\\\"sisTableLine\\\">\n            <tr height=28> \n                <th width=80>Ημερομηνία</th>\n                <th width=60>Από</th>\n                <th width=60>Έως</th>\n                <th width=300>Γονέας Μαθητή</th>\n                <th width=300>Σημείο Συνάντησης</th>\n                <th width=50 colspan=2>Ενέργειες</th>\n                <th width=25><img width=20 height=20 src=\\\"images/expand.png\\\" onclick=\\\"adjustIframeHeight()\\\" title=\\\"Επέκταση\\\" onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\"></th>\n            </tr>\";\n        \n    while($row = db_fetch_row($retval)){\n            $sql = \"    SELECT \n                            concat(IFNULL(student.surname,\'\'),\' \',IFNULL(student.name,\'\'),\' πατ. \',IFNULL(student.fathers_name,\'\'),\' (\',student.registration_number,\')\') \n                        FROM calendar_event_access\n                        INNER JOIN student ON student.id=calendar_event_access.student_id\n                        WHERE calendar_event_access.calendar_event_id={$row[0]}\n                        LIMIT 1\";\n            $rv = nuRunQuery($sql);\n            $student_name = \"\";\n            if($r = db_fetch_row($rv)) $student_name = $r[0];\n            \n            $bgcolor = ($row[9]==1 ? \'LightGreen\' : ($row[9]==0 ? \'#ffeb99\' : \'LightBlue\'));\n    \n            print \"\n            <tr height=26 id=\\\"{$row[0]}\\\" style=\\\"background-color:$bgcolor\\\">\n                <td>\".$row[1]. \"</td>\n                <td>\".$row[2]. \"</td>\n                <td>\".$row[3]. \"</td>\n                <td>$student_name</td>\n                <td>\".(filter_var($row[4], FILTER_VALIDATE_URL) ? \"<a href=\\\"{$row[4]}\\\" target=\\\"_blank\\\">{$row[4]}</a>\": $row[4]).\"</td>\"\n                .($row[11]==1 ?\n                \"\n                <td align=right width=25>\".($row[7]==1 || $row[8]==1 ? \'<img id=\"edit_img_\'.$row[0].\'\" src=\"images/edit\'.($row[10]!=\'\' ? \'_red\' :\'\').\'.png\" width=16 height=16 onclick=\"comment_appointment(\'.$row[0].\')\" onmouseover=\"ChangeCursor(this)\" onmouseout=\"RestoreCursor(this)\" title=\"Σχολιασμός ραντεβού\">\' : \'\').\"</td>\n                <td align=right width=25>\".($row[7]==1 || $row[8]==1 ? \'<img src=\"images/check.png\" width=16 height=16 onclick=\"set_appointment_washeld(\'.$row[0].\',1)\" onmouseover=\"ChangeCursor(this)\" onmouseout=\"RestoreCursor(this)\" title=\"Το ραντεβού πραγματοποιήθηκε\">\' : \'\').\"</td>\n                <td align=right width=25>\".($row[6]==1 ? \'<img src=\"images/x.png\" width=16 height=16 onclick=\"delete_appointment(\'.$row[0].\')\" onmouseover=\"ChangeCursor(this)\" onmouseout=\"RestoreCursor(this)\" title=\"Διαγραφή ραντεβού\">\' : ($row[8]==1 ? \'<img src=\"images/warning.png\" width=16 height=16 onclick=\"set_appointment_washeld(\'.$row[0].\',0)\" onmouseover=\"ChangeCursor(this)\" onmouseout=\"RestoreCursor(this)\" title=\"Ο Γονέας ΔΕΝ προσήλθε στο ραντεβού\">\' : \'\')).\"</td>\n                \" :\n                \"\n                <td align=right width=25>&nbsp;</td>\n                <td align=right width=25>&nbsp;</td>\n                <td align=right width=25>&nbsp;</td>\n                \").\n            \"</tr>\";\n    }\n    \n    print (\"\n        </table>\");\n}\nprint \"\n    </body>\n</html>\";','','0','2020-09-13 14:33:08','globeadmin','2020-10-03 12:19:03','globeadmin','2020-10-07 00:38:38','globeadmin','0'),('5f424a2f68b37ac','eclass_get_tmpdir','Επιστρέφει το path για τον κατάλογο tmp σε μια κλήση Ajax','LMS','$nuParameters = __DIR__.DIRECTORY_SEPARATOR.\'tmp\';','','0','2020-08-23 13:51:27','globeadmin','2020-08-23 14:19:43','globeadmin','2020-08-30 14:28:38','globeadmin','0'),('5f611d27111dcc8','search_appointment','Αναζήτηση διαθέσιμων ραντεβού καθηγητή','parents','function date_short_name($d){\n    $day_of_week = date(\"N\", strtotime($d))-1;\n    return ($day_of_week == 0 ? \'Δευ\' : ($day_of_week==1 ? \'Τρι\' : ($day_of_week==2 ? \'Τετ\' : ($day_of_week==3 ? \'Πεμ\' : ($day_of_week==4 ? \'Παρ\' : ($day_of_week==5 ? \'Σαβ\' : \'Κυρ\'))))));\n}\nfunction find_dates($strDateFrom,$strDateTo,$day_array){\n    $sql=\"  select holiday.holiday \n            from holiday\n            inner join school_year on holiday.school_year_id=school_year.id\n            inner join school on school.school_year_id = school_year.id\";\n    $retval=nuRunQuery($sql);\n    \n    $holiday_array = array();\n    while($row=db_fetch_row($retval)){\n        array_push($holiday_array,$row[0]);\n    }\n    \n    $aryRange=array();\n\n    $iDateFrom=mktime(1,0,0,substr($strDateFrom,5,2),     substr($strDateFrom,8,2),substr($strDateFrom,0,4));\n    $iDateTo=mktime(1,0,0,substr($strDateTo,5,2),     substr($strDateTo,8,2),substr($strDateTo,0,4));\n\n    if ($iDateTo>=$iDateFrom)\n    {\n    \n        $day_of_week = idate(\'w\', strtotime(date(\'Y-m-d\',$iDateFrom)))-1;\n        if(in_array($day_of_week,$day_array)){\n                array_push($aryRange,date(\'Y-m-d\',$iDateFrom)); // first entry\n            }\n    \n        while ($iDateFrom<$iDateTo)\n        {\n            $iDateFrom+=86400; // add 24 hours\n            \n            $day_of_week = idate(\'w\', strtotime(date(\'Y-m-d\',$iDateFrom)))-1;\n            if(in_array($day_of_week,$day_array)){\n                array_push($aryRange,date(\'Y-m-d\',$iDateFrom));\n            }\n        }\n    }\n    return array_diff($aryRange, $holiday_array);\n}\n\nfunction time_to_seconds($time){\n    $arr = explode(\":\", $time);\n    return (intval($arr[0]) * 3600 + intval($arr[1]) * 60 + intval ($arr[2]));\n}\n\nfunction seconds_to_time($seconds){\n    return gmdate(\"H:i:s\", $seconds);\n}\n\nfunction split_appointments($appointments,$duration){\n    \n    $res=array();\n    \n    foreach($appointments as $appointment){ \n        $start = time_to_seconds($appointment[\'start\']);\n        $end = time_to_seconds($appointment[\'end\']);\n        \n        for($i=$start+$duration;$i<=$end; $i+=$duration){\n            $a = $appointment;\n            $a[\'start\'] = seconds_to_time($i-$duration);\n            $a[\'end\'] = seconds_to_time($i);\n            array_push($res,$a);       \n        }\n    }\n    return $res;\n}\n\nprint \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n        \n        <STYLE TYPE=\\\"text/css\\\">\n            .sisTableLine TH{\n                font-size:8pt;\n            }\n            \n            .sisTableLine TD{\n                font-size:8pt;\n                font-weight: normal;\n            }            \n            \n        </STYLE>\n        <script type=\\\"text/javascript\\\">\n        \n            var TableBackgroundMouseoverColor = \\\"Gold\\\";\n\n            function ChangeBackgroundColor(cell) {\n                cell.style.cursor=\\\"pointer\\\";\n                cell.parentNode.style.setProperty(\'data-originalBgColor\',cell.parentNode.style.backgroundColor);\n                cell.parentNode.style.backgroundColor = TableBackgroundMouseoverColor;\n            }\n\n            function RestoreBackgroundColor(cell) {\n                cell.style.cursor=\\\"auto\\\";\n                cell.parentNode.style.backgroundColor = cell.parentNode.style.getPropertyValue(\'data-originalBgColor\'); \n            }\n            \n            function reserve(cell){\n                var obj = { row_id:cell.parentNode.dataset.row_id, date: cell.parentNode.dataset.date, start: cell.parentNode.dataset.start, end: cell.parentNode.dataset.end,availability_id: cell.parentNode.dataset.availability_id };\n                var JObj = JSON.stringify(obj);\n                parent.showLoader();\n                parent.nuSetHash(\'appointment_JSON\', JObj);\n                parent.nuAjax(\'add_appointment\',\'add_appointment_result\',{async:true});\n            }\n            \n            function disable_row(row_id){\n            \n            }\n         </script>\n    </head>\n\n    <body>\n        <table cellspacing=0 CLASS=\\\"sisTableLine\\\">\n            <tr height=28>\n                <th width=80>Δέσμευση</th>\n                <th width=100>Ημερομηνία</th>\n                <th width=60>Από</th>\n                <th width=60>Έως</th>\n                <th width=220>Καθηγητής</th>\n                <th width=300>Σημείο Συνάντησης</th>\n            </tr>   \n    \";\n\nif(\'#teacher_id_sumo#\'!=\'\' && \'#teacher_id_sumo#\' != \'#\'.\'teacher_id_sumo#\'){\n    if(\'#from_date#\'!=\'\' && \'#from_date#\' != \'#\'.\'from_date#\'){\n        if(\'#to_date#\'!=\'\' && \'#to_date#\' != \'#\'.\'to_date#\'){\n            \n            $sql = \"    SELECT school_year.start_date,school_year.end_date\n            FROM school\n            INNER JOIN school_year ON school.school_year_id = school_year.id\n            WHERE school.id=1\";\n            $retval = nuRunQuery($sql);\n            $row = db_fetch_row($retval);\n            $start_date =  max(\'#from_date#\', date(\"Y-m-d\"), $row[0]);\n            $end_date = min(\'#to_date#\',date(\'Y\', strtotime($row[1])).\"-06-30\",date(\'Y-m-d\', strtotime(\'+3 months\')));\n            \n            $appointments = array();\n            $teacher_ids = explode(\',\',\'#teacher_id_sumo#\');\n            // teacher\n            foreach($teacher_ids as $teacher_id){\n                                                            // Βρίσκει αν υπάρχουν άλλλα ενεργά ραντεβού με τον καθηγητή\n                $sql = \"SELECT count(DISTINCT calendar_event.id) \n                            FROM calendar_event\n                            INNER JOIN calendar_event_access ON calendar_event.id = calendar_event_access.calendar_event_id\n                            WHERE \n                                calendar_event.teacher_id=\'$teacher_id\' AND \n                                CONCAT(calendar_event.end_date,\' \', calendar_event.end_time) > NOW() AND\n                                calendar_event.is_appointment = 1 AND\n                                calendar_event_access.student_id = \'#RECORD_ID#\'\";\n                $retval=nuRunQuery($sql);\n                $row = db_fetch_row($retval);\n\n                $open_appointment_exists = $row[0]>0 ? true : false;\n                                                            // / Βρίσκει σε πόσα ραντεβού με τον καθηγητή o συγκεκριμένος γονέας δεν προσηλθε κατά τον τελευταίο μήνα  \n                $sql = \"SELECT count(DISTINCT calendar_event.id) \n                            FROM calendar_event\n                            INNER JOIN calendar_event_access ON calendar_event.id = calendar_event_access.calendar_event_id\n                            WHERE \n                                calendar_event.teacher_id=\'$teacher_id\' AND \n                                CONCAT(calendar_event.end_date,\' \', calendar_event.end_time )< NOW() AND\n                                CONCAT(calendar_event.start_date,\' \', calendar_event.start_time > DATE_ADD(NOW(), INTERVAL -1 MONTH)) AND\n                                calendar_event.is_appointment = 1 AND\n                                calendar_event.was_held = 0 AND\n                                calendar_event_access.student_id = \'#RECORD_ID#\'\";\n                $retval=nuRunQuery($sql);\n                $row = db_fetch_row($retval);\n\n                $penalty = $row[0]>2 ? true : false;\n                \n                $disable = $open_appointment_exists || $penalty;\n            \n                $sql = \"SELECT CONCAT(IFNULL(surname,\'\'),\' \',IFNULL(name,\'\')),IFNULL(appointment_duration,15) FROM teacher WHERE id=\'$teacher_id\'\";\n                $retval=nuRunQuery($sql);\n                $row = db_fetch_row($retval);\n                $teacher_name = $row[0];\n                $duration = $row[1];\n            \n                $sql=\"SELECT DISTINCT day_id from appointment_teacher_availability WHERE teacher_id=\'$teacher_id\'\";\n                $retval=nuRunQuery($sql);\n                $day_array = array();\n                while($row=db_fetch_row($retval)){\n                    array_push($day_array,$row[0]);\n                }\n            \n                $available_dates = find_dates($start_date,$end_date,$day_array);\n                foreach($available_dates as $available_date){\n            \n                                                            // Διαθεσιμότητες καθηγητή\n                    $day_of_week = date(\"N\", strtotime($available_date))-1;\n                    $sql = \"SELECT start_time,end_time,location,id \n                            FROM appointment_teacher_availability \n                            WHERE teacher_id=\'$teacher_id\' AND day_id=$day_of_week\n                            ORDER BY start_time\";\n\n                    $retval=nuRunQuery($sql);\n                    $time_periods = array();\n                    while($row=db_fetch_row($retval)){\n                        array_push($time_periods,array(\'date\'=>$available_date,\'start\'=>$row[0],\'end\'=>$row[1],\'teacher\'=>$teacher_name,\'location\'=>$row[2],\'availability_id\'=>$row[3],\'disable\'=>$disable,\'open_appointment_exists\'=>$open_appointment_exists,\'teacher_id\'=>$teacher_id));\n                    }\n                \n                                                            // Ήδη καταχωρισμένα ραντεβού\n                    $sql = \"SELECT start_time,end_time \n                            FROM calendar_event \n                            WHERE \n                                teacher_id=\'$teacher_id\' AND \n                                start_date = \'$available_date\' AND\n                                end_date = \'$available_date\' AND\n                                is_appointment = 1\n                            ORDER BY start_time\";\n                    $retval=nuRunQuery($sql);\n                    $events = array();\n                    while($row=db_fetch_row($retval)){\n                        array_push($events,array(\'start\'=>$row[0],\'end\'=>$row[1]));\n                    }\n                \n                    foreach($events as $event){\n                        $new_periods = array();\n                        $to_delete = array();\n                    \n                        foreach($time_periods as $period){\n                            if($event[\'start\']<$period[\'end\'] && $event[\'end\']>$period[\'start\']){\n                                if($period[\'start\']<=$event[\'start\']){\n                                    if($period[\'end\']<=$event[\'end\']){    //trancate\n                                        $period[\'end\'] = $event[\'start\'];        \n                                    } else {                    // split\n                                        array_push($new_periods,array(\'date\'=>$period[\'date\'],\'start\'=>$period[\'start\'],\'end\'=>$event[\'start\'],\'teacher\'=>$period[\'teacher\'],\'location\'=>$period[\'location\'],\'availability_id\'=>$period[\'availability_id\'],\'disable\'=>$disable,\'open_appointment_exists\'=>$open_appointment_exists,\'teacher_id\'=>$teacher_id));\n                                        array_push($new_periods,array(\'date\'=>$period[\'date\'],\'start\'=>$event[\'end\'],\'end\'=>$period[\'end\'],\'teacher\'=>$period[\'teacher\'],\'location\'=>$period[\'location\'],\'availability_id\'=>$period[\'availability_id\'],\'disable\'=>$disable,\'open_appointment_exists\'=>$open_appointment_exists,\'teacher_id\'=>$teacher_id));\n                                        array_push($to_delete, $period);\n                                    }   \n                                } else {\n                                    if($event[\'end\']<$period[\'end\']){    //trancate\n                                        $period[\'start\'] = $event[\'end\'];    \n                                    } else {                    //remove\n                                        array_push($to_delete, $period);    \n                                    }       \n                                }\n                            }\n                        }\n                        $time_periods = array_udiff($time_periods, $to_delete,function($a, $b) {\n                                        if($a[\'date\']==$b[\'date\']){\n                                            if($a[\'start\']==$b[\'start\']){\n                                                if($a[\'end\']==$b[\'end\']){\n                                                    if($a[\'teacher\']==$b[\'teacher\']){\n                                                        if($a[\'location\']==$b[\'location\']){\n                                                            if($a[\'availability_id\']==$b[\'availability_id\']){\n                                                                return 0;\n                                                            }\n                                                            return $a[\'availability_id\'] > $b[\'availability_id\'] ? 1 : -1;\n                                                        }\n                                                        return $a[\'location\'] > $b[\'location\'] ? 1 : -1;\n                                                    }\n                                                    return $a[\'teacher\'] > $b[\'teacher\'] ? 1 : -1;\n                                                } \n                                                return $a[\'end\'] > $b[\'end\'] ? 1 : -1;\n                                            }\n                                            return $a[\'start\'] > $b[\'start\'] ? 1 : -1;\n                                        }\n                                        return $a[\'date\'] > $b[\'date\'] ? 1 : -1;\n                                    }); \n                \n                        $time_periods = array_merge($time_periods, $new_periods);                    \n                    }\n\n                \n                    $appointments = array_merge($appointments, split_appointments($time_periods,$duration*60));\n                }\n            }\n            \n            uasort($appointments,    function($a, $b) {\n                                        if($a[\'date\']==$b[\'date\']){\n                                            if($a[\'start\']==$b[\'start\']){\n                                                if($a[\'teacher\']==$b[\'teacher\']){\n                                                    return 0;    \n                                                } \n                                                return $a[\'teacher\'] > $b[\'teacher\'] ? 1 : -1;\n                                            }\n                                            return $a[\'start\'] > $b[\'start\'] ? 1 : -1;\n                                        }\n                                        return $a[\'date\'] > $b[\'date\'] ? 1 : -1;\n                                    });\n            $i=1;\n            $now = date(\"Y-m-d H:i:s\");\n            foreach($appointments as $appointment){\n            \n                if($appointment[\'date\'].\" \".$appointment[\'start\']<=$now) continue; \n                \n                print \"\n            <tr \".($appointment[\'disable\'] ? \"style=\\\"background-color:lightgray;\\\" title=\\\"\".($appointment[\'open_appointment_exists\'] ? \"Υπάρχει ήδη προγραμματισμένο μελλοντικό ραντεβού με τον καθηγητή!\" : \"Έχετε κλείσει αλλά δεν έχετε προσέλθει σε πολλά ραντεβού με αυτόν τον καθηγητή κατά τη διάρκεια του τελευταίου μήνα!\").\"\\\"\" : \"\").\" height=30 data-row_id=\\\"$i\\\" data-originalBgColor=\\\"\\\" data-date=\\\"{$appointment[\'date\']}\\\" data-start=\\\"{$appointment[\'start\']}\\\" data-end=\\\"{$appointment[\'end\']}\\\" data-availability_id=\\\"{$appointment[\'availability_id\']}\\\">\".\n                ($appointment[\'disable\'] ?\n                \"\n                <td CLASS=\\\"{$appointment[\'teacher_id\']}\\\"  id=\\\"$i\\\" align=center><img src=\\\"images/\".($appointment[\'open_appointment_exists\'] ? \"stop\" : \"delete\").\".png\\\" width=20 height=20></td>\"\n                :\n                \"\n                <td CLASS=\\\"{$appointment[\'teacher_id\']}\\\"  id=\\\"$i\\\" title=\\\"Δέσμευση ραντεβού\\\" align=center onclick=\\\"reserve(this)\\\" onmouseover=\\\"ChangeBackgroundColor(this)\\\" onmouseout=\\\"RestoreBackgroundColor(this)\\\"><img id=\\\"handshake_$i\\\" src=\\\"images/handshake.png\\\" width=24 height=24></td>\")\n                .\"\n                <td>\".date_short_name($appointment[\'date\']).\', \'.date(\'d-m-Y\', strtotime($appointment[\'date\'])).\"</td>\n                <td>{$appointment[\'start\']}</td>\n                <td>{$appointment[\'end\']}</td>\n                <td>{$appointment[\'teacher\']}</td>\n                <td>{$appointment[\'location\']}</td>\n            </tr>\";\n            $i++;\n            }\n            print (\"\n        </table>\");\n            \n        } else{\n            print \"<span CLASS=\\\"msg\\\">Παρακαλώ να ορίσετε πρώτα την Ημερομηνία Έως!</span>\";    \n        }\n    } else {\n        print \"<span CLASS=\\\"msg\\\">Παρακαλώ να ορίσετε πρώτα την Ημερομηνία Από!</span>\";    \n    }\n} else {\n    print \"<span CLASS=\\\"msg\\\">Παρακαλώ να ορίσετε πρώτα τον Καθηγητή!</span>\";    \n}\nprint \"\n    </body>\n</html>\";\n\n','','0','2020-09-15 22:59:35','globeadmin','2020-11-24 10:52:27','globeadmin','2020-12-21 21:12:41','globeadmin','0'),('5f5e56bb6d78a38','teacher_appointment_availability','Διαθεσιμότητα καθηγητή για ραντεβού','teacher','$sql = \"SELECT\n            ata.id,\n            day.name,\n            ata.start_time,\n            ata.end_time,\n            ata.location\n        FROM appointment_teacher_availability AS ata\n        INNER JOIN day ON day.id = ata.day_id\n        WHERE ata.teacher_id=\'#RECORD_ID#\'\n        ORDER BY day.id,ata.start_time,ata.end_time\";\n\n$retval = nuRunQuery($sql);\n\nprint \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n        \n        <STYLE TYPE=\\\"text/css\\\">\n            .sisTableLine TH{\n                font-size:9pt;\n            }\n            \n            .sisTableLine TD{\n                font-size:9pt;\n                font-weight: normal;\n            }            \n            \n            \n            .sisTableLine tr:nth-child(even){\n	            background-color: LightSteelBlue;\n            }\n        </STYLE>\n\n\n        <script>\n            function remove_row(row_id){\n                if(confirm(\'Η διαθεσιμότητα θα διαγραφεί!\\\\nΕίστε Σίγουρος;\')){\n                    parent.nuSetHash(\'appointment_availability_id\', row_id);\n                    parent.nuAjax(\'delete_appointment_availability\',\'delete_appointment_availability_result\')\n                }\n            }\n            \n            function add_row(){\n                parent.nuOpenFormInFrame(\'5f5fc06e94c4759\', \'-1\');\n            }\n            \n            function edit_row(row_id){\n                parent.nuOpenFormInFrame(\'5f5fc06e94c4759\', row_id.toString());\n            }            \n        </script>\n    </head>\n\n    <body>\";\n\nif(!$retval){\n    print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν δεδομένα!</span>\");\n} else{\n    print \"\n        <table cellspacing=0 CLASS=\\\"sisTableLine\\\">\n            <tr height=28> \n                <th width=80>Ημέρα</th>\n                <th width=80>Από</th>\n                <th width=80>Έως</th>\n                <th width=500>Σημείο Συναντήσεων</th>\n                <th colspan=2 width=50 align=right><img src=\\\"images/add.png\\\" width=16 height=16 onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\" onclick=\\\"add_row()\\\" title=\\\"Εσαγωγή νέας διαθεσιμότητας\\\"></th>\n            </tr>\";\n        \n    while($row = db_fetch_row($retval)){\n            print \"\n            <tr height=26>\n                <td>{$row[1]}</td>\n                <td>{$row[2]}</td>\n                <td>{$row[3]}</td>\n                <td>\".(filter_var($row[4], FILTER_VALIDATE_URL) ? \"<a href=\\\"{$row[4]}\\\" target=\\\"_blank\\\">{$row[4]}</a>\": $row[4]).\"</td>\n                <td width=25 align=left><img src=\\\"images/modify.png\\\" width=16 height=16 onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\" onclick=\\\"edit_row(\".$row[0].\")\\\" title=\\\"Επεξεργασία\\\"></td>\n                <td width=25 align=right><img src=\\\"images/x.png\\\" width=16 height=16 onmouseover=\\\"ChangeCursor(this)\\\" onmouseout=\\\"RestoreCursor(this)\\\" onclick=\\\"remove_row(\".$row[0].\")\\\" title=\\\"Διαγραφή\\\"></td>\n            </tr>\";\n    }\n    print (\"\n        </table>\");\n}\nprint \"\n    </body>\n</html>\";','','0','2020-09-13 20:28:27','globeadmin','2020-09-21 09:02:13','globeadmin','2020-09-26 13:49:15','globeadmin','0'),('5f6087c5486319a','delete_appointment_availability','Διαγράφει μια διαθεσιμότητα καθηγητή για ραντεβού','teacher','if (\'#appointment_availability_id#\'!=\'#\'.\'appointment_availability_id\'.\'#\' && \'#appointment_availability_id#\'!=\'\'){\n    $sql=\"delete from appointment_teacher_availability where id=#appointment_availability_id#\";\n    nuRunQuery($sql);\n}','','0','2020-09-15 12:22:13','globeadmin','2020-09-15 12:26:14','globeadmin','2020-09-26 13:48:58','globeadmin','0'),('5ed8b8f6a033db0','encoding','Encoding Class','sisyphos','/*\nCopyright (c) 2008 Sebastián Grignoli\nAll rights reserved.\n\nRedistribution and use in source and binary forms, with or without\nmodification, are permitted provided that the following conditions\nare met:\n1. Redistributions of source code must retain the above copyright\n   notice, this list of conditions and the following disclaimer.\n2. Redistributions in binary form must reproduce the above copyright\n   notice, this list of conditions and the following disclaimer in the\n   documentation and/or other materials provided with the distribution.\n3. Neither the name of copyright holders nor the names of its\n   contributors may be used to endorse or promote products derived\n   from this software without specific prior written permission.\n\nTHIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS\n``AS IS\'\' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED\nTO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR\nPURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL COPYRIGHT HOLDERS OR CONTRIBUTORS\nBE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR\nCONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF\nSUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS\nINTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN\nCONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)\nARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE\nPOSSIBILITY OF SUCH DAMAGE.\n*/\n\n/**\n * @author   \"Sebastián Grignoli\" <grignoli@gmail.com>\n * @package  Encoding\n * @version  2.0\n * @link     https://github.com/neitanod/forceutf8\n * @example  https://github.com/neitanod/forceutf8\n * @license  Revised BSD\n  */\n\nclass Encoding {\n\n  const ICONV_TRANSLIT = \"TRANSLIT\";\n  const ICONV_IGNORE = \"IGNORE\";\n  const WITHOUT_ICONV = \"\";\n\n  protected static $win1252ToUtf8 = array(\n        128 => \"\\xe2\\x82\\xac\",\n\n        130 => \"\\xe2\\x80\\x9a\",\n        131 => \"\\xc6\\x92\",\n        132 => \"\\xe2\\x80\\x9e\",\n        133 => \"\\xe2\\x80\\xa6\",\n        134 => \"\\xe2\\x80\\xa0\",\n        135 => \"\\xe2\\x80\\xa1\",\n        136 => \"\\xcb\\x86\",\n        137 => \"\\xe2\\x80\\xb0\",\n        138 => \"\\xc5\\xa0\",\n        139 => \"\\xe2\\x80\\xb9\",\n        140 => \"\\xc5\\x92\",\n\n        142 => \"\\xc5\\xbd\",\n\n\n        145 => \"\\xe2\\x80\\x98\",\n        146 => \"\\xe2\\x80\\x99\",\n        147 => \"\\xe2\\x80\\x9c\",\n        148 => \"\\xe2\\x80\\x9d\",\n        149 => \"\\xe2\\x80\\xa2\",\n        150 => \"\\xe2\\x80\\x93\",\n        151 => \"\\xe2\\x80\\x94\",\n        152 => \"\\xcb\\x9c\",\n        153 => \"\\xe2\\x84\\xa2\",\n        154 => \"\\xc5\\xa1\",\n        155 => \"\\xe2\\x80\\xba\",\n        156 => \"\\xc5\\x93\",\n\n        158 => \"\\xc5\\xbe\",\n        159 => \"\\xc5\\xb8\"\n  );\n\n    protected static $brokenUtf8ToUtf8 = array(\n        \"\\xc2\\x80\" => \"\\xe2\\x82\\xac\",\n\n        \"\\xc2\\x82\" => \"\\xe2\\x80\\x9a\",\n        \"\\xc2\\x83\" => \"\\xc6\\x92\",\n        \"\\xc2\\x84\" => \"\\xe2\\x80\\x9e\",\n        \"\\xc2\\x85\" => \"\\xe2\\x80\\xa6\",\n        \"\\xc2\\x86\" => \"\\xe2\\x80\\xa0\",\n        \"\\xc2\\x87\" => \"\\xe2\\x80\\xa1\",\n        \"\\xc2\\x88\" => \"\\xcb\\x86\",\n        \"\\xc2\\x89\" => \"\\xe2\\x80\\xb0\",\n        \"\\xc2\\x8a\" => \"\\xc5\\xa0\",\n        \"\\xc2\\x8b\" => \"\\xe2\\x80\\xb9\",\n        \"\\xc2\\x8c\" => \"\\xc5\\x92\",\n\n        \"\\xc2\\x8e\" => \"\\xc5\\xbd\",\n\n\n        \"\\xc2\\x91\" => \"\\xe2\\x80\\x98\",\n        \"\\xc2\\x92\" => \"\\xe2\\x80\\x99\",\n        \"\\xc2\\x93\" => \"\\xe2\\x80\\x9c\",\n        \"\\xc2\\x94\" => \"\\xe2\\x80\\x9d\",\n        \"\\xc2\\x95\" => \"\\xe2\\x80\\xa2\",\n        \"\\xc2\\x96\" => \"\\xe2\\x80\\x93\",\n        \"\\xc2\\x97\" => \"\\xe2\\x80\\x94\",\n        \"\\xc2\\x98\" => \"\\xcb\\x9c\",\n        \"\\xc2\\x99\" => \"\\xe2\\x84\\xa2\",\n        \"\\xc2\\x9a\" => \"\\xc5\\xa1\",\n        \"\\xc2\\x9b\" => \"\\xe2\\x80\\xba\",\n        \"\\xc2\\x9c\" => \"\\xc5\\x93\",\n\n        \"\\xc2\\x9e\" => \"\\xc5\\xbe\",\n        \"\\xc2\\x9f\" => \"\\xc5\\xb8\"\n  );\n\n  protected static $utf8ToWin1252 = array(\n       \"\\xe2\\x82\\xac\" => \"\\x80\",\n\n       \"\\xe2\\x80\\x9a\" => \"\\x82\",\n       \"\\xc6\\x92\"     => \"\\x83\",\n       \"\\xe2\\x80\\x9e\" => \"\\x84\",\n       \"\\xe2\\x80\\xa6\" => \"\\x85\",\n       \"\\xe2\\x80\\xa0\" => \"\\x86\",\n       \"\\xe2\\x80\\xa1\" => \"\\x87\",\n       \"\\xcb\\x86\"     => \"\\x88\",\n       \"\\xe2\\x80\\xb0\" => \"\\x89\",\n       \"\\xc5\\xa0\"     => \"\\x8a\",\n       \"\\xe2\\x80\\xb9\" => \"\\x8b\",\n       \"\\xc5\\x92\"     => \"\\x8c\",\n\n       \"\\xc5\\xbd\"     => \"\\x8e\",\n\n\n       \"\\xe2\\x80\\x98\" => \"\\x91\",\n       \"\\xe2\\x80\\x99\" => \"\\x92\",\n       \"\\xe2\\x80\\x9c\" => \"\\x93\",\n       \"\\xe2\\x80\\x9d\" => \"\\x94\",\n       \"\\xe2\\x80\\xa2\" => \"\\x95\",\n       \"\\xe2\\x80\\x93\" => \"\\x96\",\n       \"\\xe2\\x80\\x94\" => \"\\x97\",\n       \"\\xcb\\x9c\"     => \"\\x98\",\n       \"\\xe2\\x84\\xa2\" => \"\\x99\",\n       \"\\xc5\\xa1\"     => \"\\x9a\",\n       \"\\xe2\\x80\\xba\" => \"\\x9b\",\n       \"\\xc5\\x93\"     => \"\\x9c\",\n\n       \"\\xc5\\xbe\"     => \"\\x9e\",\n       \"\\xc5\\xb8\"     => \"\\x9f\"\n    );\n\n  static function toUTF8($text){\n  /**\n   * Function \\ForceUTF8\\Encoding::toUTF8\n   *\n   * This function leaves UTF8 characters alone, while converting almost all non-UTF8 to UTF8.\n   *\n   * It assumes that the encoding of the original string is either Windows-1252 or ISO 8859-1.\n   *\n   * It may fail to convert characters to UTF-8 if they fall into one of these scenarios:\n   *\n   * 1) when any of these characters:   ÀÁÂÃÄÅÆÇÈÉÊËÌÍÎÏÐÑÒÓÔÕÖ×ØÙÚÛÜÝÞß\n   *    are followed by any of these:  (\"group B\")\n   *                                    ¡¢£¤¥¦§¨©ª«¬­®¯°±²³´µ¶•¸¹º»¼½¾¿\n   * For example:   %ABREPRESENT%C9%BB. «REPRESENTÉ»\n   * The \"«\" (%AB) character will be converted, but the \"É\" followed by \"»\" (%C9%BB)\n   * is also a valid unicode character, and will be left unchanged.\n   *\n   * 2) when any of these: àáâãäåæçèéêëìíîï  are followed by TWO chars from group B,\n   * 3) when any of these: ðñòó  are followed by THREE chars from group B.\n   *\n   * @name toUTF8\n   * @param string $text  Any string.\n   * @return string  The same string, UTF8 encoded\n   *\n   */\n\n    if(is_array($text))\n    {\n      foreach($text as $k => $v)\n      {\n        $text[$k] = self::toUTF8($v);\n      }\n      return $text;\n    }\n\n    if(!is_string($text)) {\n      return $text;\n    }\n\n    $max = self::strlen($text);\n\n    $buf = \"\";\n    for($i = 0; $i < $max; $i++){\n        $c1 = $text[$i];\n        if($c1>=\"\\xc0\"){ //Should be converted to UTF8, if it\'s not UTF8 already\n          $c2 = $i+1 >= $max? \"\\x00\" : $text[$i+1];\n          $c3 = $i+2 >= $max? \"\\x00\" : $text[$i+2];\n          $c4 = $i+3 >= $max? \"\\x00\" : $text[$i+3];\n            if($c1 >= \"\\xc0\" & $c1 <= \"\\xdf\"){ //looks like 2 bytes UTF8\n                if($c2 >= \"\\x80\" && $c2 <= \"\\xbf\"){ //yeah, almost sure it\'s UTF8 already\n                    $buf .= $c1 . $c2;\n                    $i++;\n                } else { //not valid UTF8.  Convert it.\n                    $cc1 = (chr(ord($c1) / 64) | \"\\xc0\");\n                    $cc2 = ($c1 & \"\\x3f\") | \"\\x80\";\n                    $buf .= $cc1 . $cc2;\n                }\n            } elseif($c1 >= \"\\xe0\" & $c1 <= \"\\xef\"){ //looks like 3 bytes UTF8\n                if($c2 >= \"\\x80\" && $c2 <= \"\\xbf\" && $c3 >= \"\\x80\" && $c3 <= \"\\xbf\"){ //yeah, almost sure it\'s UTF8 already\n                    $buf .= $c1 . $c2 . $c3;\n                    $i = $i + 2;\n                } else { //not valid UTF8.  Convert it.\n                    $cc1 = (chr(ord($c1) / 64) | \"\\xc0\");\n                    $cc2 = ($c1 & \"\\x3f\") | \"\\x80\";\n                    $buf .= $cc1 . $cc2;\n                }\n            } elseif($c1 >= \"\\xf0\" & $c1 <= \"\\xf7\"){ //looks like 4 bytes UTF8\n                if($c2 >= \"\\x80\" && $c2 <= \"\\xbf\" && $c3 >= \"\\x80\" && $c3 <= \"\\xbf\" && $c4 >= \"\\x80\" && $c4 <= \"\\xbf\"){ //yeah, almost sure it\'s UTF8 already\n                    $buf .= $c1 . $c2 . $c3 . $c4;\n                    $i = $i + 3;\n                } else { //not valid UTF8.  Convert it.\n                    $cc1 = (chr(ord($c1) / 64) | \"\\xc0\");\n                    $cc2 = ($c1 & \"\\x3f\") | \"\\x80\";\n                    $buf .= $cc1 . $cc2;\n                }\n            } else { //doesn\'t look like UTF8, but should be converted\n                    $cc1 = (chr(ord($c1) / 64) | \"\\xc0\");\n                    $cc2 = (($c1 & \"\\x3f\") | \"\\x80\");\n                    $buf .= $cc1 . $cc2;\n            }\n        } elseif(($c1 & \"\\xc0\") === \"\\x80\"){ // needs conversion\n              if(isset(self::$win1252ToUtf8[ord($c1)])) { //found in Windows-1252 special cases\n                  $buf .= self::$win1252ToUtf8[ord($c1)];\n              } else {\n                $cc1 = (chr(ord($c1) / 64) | \"\\xc0\");\n                $cc2 = (($c1 & \"\\x3f\") | \"\\x80\");\n                $buf .= $cc1 . $cc2;\n              }\n        } else { // it doesn\'t need conversion\n            $buf .= $c1;\n        }\n    }\n    return $buf;\n  }\n\n  static function toWin1252($text, $option = self::WITHOUT_ICONV) {\n    if(is_array($text)) {\n      foreach($text as $k => $v) {\n        $text[$k] = self::toWin1252($v, $option);\n      }\n      return $text;\n    } elseif(is_string($text)) {\n      return static::utf8_decode($text, $option);\n    } else {\n      return $text;\n    }\n  }\n\n  static function toISO8859($text, $option = self::WITHOUT_ICONV) {\n    return self::toWin1252($text, $option);\n  }\n\n  static function toLatin1($text, $option = self::WITHOUT_ICONV) {\n    return self::toWin1252($text, $option);\n  }\n\n  static function fixUTF8($text, $option = self::WITHOUT_ICONV){\n    if(is_array($text)) {\n      foreach($text as $k => $v) {\n        $text[$k] = self::fixUTF8($v, $option);\n      }\n      return $text;\n    }\n\n    if(!is_string($text)) {\n      return $text;\n    }\n\n    $last = \"\";\n    while($last <> $text){\n      $last = $text;\n      $text = self::toUTF8(static::utf8_decode($text, $option));\n    }\n    $text = self::toUTF8(static::utf8_decode($text, $option));\n    return $text;\n  }\n\n  static function UTF8FixWin1252Chars($text){\n    // If you received an UTF-8 string that was converted from Windows-1252 as it was ISO8859-1\n    // (ignoring Windows-1252 chars from 80 to 9F) use this function to fix it.\n    // See: http://en.wikipedia.org/wiki/Windows-1252\n\n    return str_replace(array_keys(self::$brokenUtf8ToUtf8), array_values(self::$brokenUtf8ToUtf8), $text);\n  }\n\n  static function removeBOM($str=\"\"){\n    if(substr($str, 0,3) === pack(\"CCC\",0xef,0xbb,0xbf)) {\n      $str=substr($str, 3);\n    }\n    return $str;\n  }\n\n  protected static function strlen($text){\n    return (function_exists(\'mb_strlen\') && ((int) ini_get(\'mbstring.func_overload\')) & 2) ?\n           mb_strlen($text,\'8bit\') : strlen($text);\n  }\n\n  public static function normalizeEncoding($encodingLabel)\n  {\n    $encoding = strtoupper($encodingLabel);\n    $encoding = preg_replace(\'/[^a-zA-Z0-9\\s]/\', \'\', $encoding);\n    $equivalences = array(\n        \'ISO88591\' => \'ISO-8859-1\',\n        \'ISO8859\'  => \'ISO-8859-1\',\n        \'ISO\'      => \'ISO-8859-1\',\n        \'LATIN1\'   => \'ISO-8859-1\',\n        \'LATIN\'    => \'ISO-8859-1\',\n        \'UTF8\'     => \'UTF-8\',\n        \'UTF\'      => \'UTF-8\',\n        \'WIN1252\'  => \'ISO-8859-1\',\n        \'WINDOWS1252\' => \'ISO-8859-1\'\n    );\n\n    if(empty($equivalences[$encoding])){\n      return \'UTF-8\';\n    }\n\n    return $equivalences[$encoding];\n  }\n\n  public static function encode($encodingLabel, $text)\n  {\n    $encodingLabel = self::normalizeEncoding($encodingLabel);\n    if($encodingLabel === \'ISO-8859-1\') return self::toLatin1($text);\n    return self::toUTF8($text);\n  }\n\n  protected static function utf8_decode($text, $option = self::WITHOUT_ICONV)\n  {\n    if ($option == self::WITHOUT_ICONV || !function_exists(\'iconv\')) {\n       $o = utf8_decode(\n         str_replace(array_keys(self::$utf8ToWin1252), array_values(self::$utf8ToWin1252), self::toUTF8($text))\n       );\n    } else {\n       $o = iconv(\"UTF-8\", \"Windows-1252\" . ($option === self::ICONV_TRANSLIT ? \'//TRANSLIT\' : ($option === self::ICONV_IGNORE ? \'//IGNORE\' : \'\')), $text);\n    }\n    return $o;\n  }\n}\n','','1','2020-06-04 12:03:50','globeadmin','2020-06-04 12:05:42','globeadmin','2020-06-04 13:59:33','globeadmin','0'),('5f3a5eff6565e0c','eclass_send_lessons','Αποστολή διδασκαλιών στο eclass','LMS','nuRunPHP(\"eclass_lib\");\n$nuParameters = \'\';\nif(\'#server_address#\'!=\'\' && \'#server_address#\'!=\'#\'.\'server_address#\'){\n    if(\'#server_port#\'!=\'\' && \'#server_port#\'!=\'#\'.\'server_port#\'){\n        if(\'#db_name#\'!=\'\' && \'#db_name#\'!=\'#\'.\'db_name#\'){\n            if(\'#user_name#\'!=\'\' && \'#user_name#\'!=\'#\'.\'user_name#\'){\n                if(\'#user_password#\'!=\'\' && \'#user_password#\'!=\'#\'.\'user_password#\'){\n                    if(\'#hierarchy_id#\'!=\'\' && \'#hierarchy_id#\'!=\'#\'.\'hierarchy_id#\'&& \'#hierarchy_id#\'!=\'-1\'){\n                        if(\'#lesson_id_sumo#\'!=\'\' && \'#lesson_id_sumo#\'!=\'#\'.\'lesson_id_sumo#\'){\n                        \n                                $mysqli = new mysqli(\'#server_address#\', \'#user_name#\', \'#user_password#\', \'#db_name#\', \'#server_port#\');\n                                \n                                if ($mysqli->connect_errno) {\n                                    $nuParameters = \'Η σύνδεση απέτυχε : \'.$mysqli->connect_error;\n                                } else {\n                                    $mysqli -> set_charset(\"utf8\");\n                                    $result = $mysqli->query(\'SELECT public_code FROM course WHERE public_code LIKE \"sisyphos-%\"\');\n\n                                    if($result !== FALSE){\n                                        \n                                        $eclass_courses = array();\n                                        \n                                        while($row = $result->fetch_array()) {\n                                            $lesson = explode(\"-\", $row[0]);            // public_code format : sisyphos-subject_id-class_id,class_id,...\n                                            $subject_id = $lesson[1];\n                                            $class_ids = explode(\",\",$lesson[2]);\n                                            foreach($class_ids as $class_id) array_push($eclass_courses,$subject_id.\"-\".$class_id);\n                                        }\n                                        \n                                        $lessons = explode(\",\",\'#lesson_id_sumo#\');\n                                        $lessons_str = \"\'\" . implode ( \"\', \'\", $lessons ) . \"\'\";\n                                        \n                                        $sql=\"DROP TEMPORARY TABLE IF EXISTS #TABLE_ID#\";\n                                        nuRunQuery($sql);\n\n                                        $sql = \"    CREATE TEMPORARY TABLE #TABLE_ID#\n                                                    SELECT \n                                                        subject.id AS subject_id,\n                                                        class.id AS class_id,\n                                                        GROUP_CONCAT(DISTINCT teacher.id SEPARATOR \',\') AS teacher_ids\n                                                    FROM card\n                                                    INNER JOIN subject 			on card.subject_id = subject.id \n                                                    INNER JOIN teacher 			on card.teacher_id = teacher.id  \n                                                    INNER JOIN class 			on card.class_id = class.id	\n                                                    LEFT  JOIN subject_type 	on subject.subject_type_id = subject_type.id \n                                                    WHERE \n                                                        card.valid_from = (SELECT max(timetable.start_date) FROM timetable) AND \n                                                        CONCAT(subject.id,\'-\',class.id) in ($lessons_str)\n                                                    GROUP BY subject.id,class.id\n                                                    ORDER BY subject.id,class.id\";\n                                        nuRunQuery($sql);\n                                        \n                                        $sql = \'#merge_chk#\' == \'1\' ?\n                                            \n                                            \"   SELECT subject_id,teacher_ids, GROUP_CONCAT(DISTINCT class_id SEPARATOR \',\') as class_ids\n                                                FROM #TABLE_ID#\n                                                GROUP BY subject_id,teacher_ids\n                                                ORDER BY subject_id,teacher_ids\" :\n                                        \n                                            \"   SELECT DISTINCT subject_id,teacher_ids, class_id as class_ids\n                                                FROM #TABLE_ID#\n                                                ORDER BY subject_id,teacher_ids\";\n                                        $retval = nuRunQuery($sql);\n                                       \n                                        if($retval && db_num_rows($retval)>0){\n                                            \n                                            $hierarchy_id = intval(\'#hierarchy_id#\');\n                                            $courses_exists             = array();\n                                            $courses_created_names      = array();\n                                            $courses_faild_names        = array();\n                                                \n                                            while($row = db_fetch_array($retval)){\n                                            \n                                                $subject_id = $row[0];\n                                                $teacher_ids = explode(\",\",$row[1]);\n                                                $class_ids = explode(\",\",$row[2]);\n                                            \n                                                $include_class_ids = array();\n                                                \n                                                foreach($class_ids as $class_id)\n                                                    if(in_array($subject_id.\"-\".$class_id,$eclass_courses))\n                                                        array_push($courses_exists,$subject_id.\"-\".$class_id);    \n                                                    else\n                                                        array_push($include_class_ids,$class_id);\n                                                        \n                                                $sql = \"SELECT \n                                                            subject.short_name,\n                                                            if(subject.name IS NULL OR subject.name=\'\',subject.short_name,CONCAT(subject.name,if(subject_type.short_name IS NULL,\'\',CONCAT(\'-\',subject_type.name))))\n                                                        FROM subject \n                                                        LEFT  JOIN subject_type 	on subject.subject_type_id = subject_type.id \n                                                        WHERE subject.id=$subject_id\";\n                                                \n                                                $rv = nuRunQuery($sql);\n                                                $r = db_fetch_row($rv);\n                                                $subject_short_name = $r[0];\n                                                $subject_name = $r[1];\n                                                \n                                                if(count($include_class_ids) > 0){\n                                                            // create course\n                                                    \n                                                    $sql = \"SELECT GROUP_CONCAT(short_name SEPARATOR \',\') from class WHERE id IN (\".implode ( \",\", $include_class_ids ).\") ORDER BY short_name\";\n                                                    $rv = nuRunQuery($sql);\n                                                    $r = db_fetch_row($rv);\n                                                    $class_names = $r[0];\n                                                    \n                                                    $sql = \"SELECT \n                    	                                        short_name,\n                    	                                        CONCAT(IF(name IS NULL,\'\',name),\n                    	                                        IF(name IS NULL OR surname IS NULL OR name=\'\' OR  surname=\'\',\'\',\' \'),\n                    	                                        IF(surname IS NULL,\'\',surname))\n                                                            FROM teacher\n                                                            WHERE id=\".$teacher_ids[0];\n                                                    $rv = nuRunQuery($sql);\n                                                    $r = db_fetch_row($rv);\n                                                    $teacher_name = $r[1]==\"\" ?  $r[0] :  $r[1]; \n                                                    \n                                                    if(list($new_course_id,$code) = create_course(\"sisyphos-$subject_id-\".implode ( \",\", $include_class_ids ), $class_names.\" - \".$subject_short_name, $class_names.\" - \".$subject_name, $hierarchy_id, $teacher_name,$mysqli)){\n                                                        $teacher_results = array(\'created\'=>0,\'added\'=>0,\'failed\'=>0,\'not_found\'=>0);\n                                                        foreach($teacher_ids as $teacher_id){\n                                                            if(\"#create_user_chk#\"==\'1\'){\n                                                                list($created,$user_id,$username) = create_user($teacher_id,\'1\',$hierarchy_id,$mysqli);\n                                                                if($created){\n                                                                    $teacher_results[\'created\'] +=1;    \n                                                                }\n                                                                \n                                                                if($user_id != -1){\n                                                                    if(add_user_to_cource($user_id, $new_course_id,\'1\',$mysqli)){\n                                                                        $teacher_results[\'added\'] +=1;    \n                                                                    }else {     // add user to cource failed\n                                                                        $teacher_results[\'failed\'] +=1;    \n                                                                    }\n                                                                } else {\n                                                                    $teacher_results[\'not_found\'] +=1;    \n                                                                }\n                                                            } else {    // do not create users\n                                                                $sql = \"    SELECT \n                                                                                zzzsys_user.sus_login_name AS username\n                                                                            FROM teacher\n                                                                            INNER JOIN zzzsys_user ON teacher.user_id=zzzsys_user.zzzsys_user_id\n                                                                            WHERE id=$teacher_id\";\n                                                                $rv = nuRunQuery($sql);\n                                                                if($rv && db_num_rows($rv)>0){\n                                                                    $r = db_fetch_row($rv);\n                                                                    $user_id = check_user_exists($r[0],$mysqli);\n                                                                    if($user_id>0){\n                                                                       if(add_user_to_cource($user_id, $new_course_id,\'1\',$mysqli)){\n                                                                            $teacher_results[\'added\'] +=1;\n                                                                        } else {     // add user to cource failed     \n                                                                            $teacher_results[\'failed\'] +=1;\n                                                                        }                                                                           \n                                                                    } else {        // eclass user not found\n                                                                        $teacher_results[\'not_found\'] +=1;\n                                                                    }\n                                                                } else {        // sisyphos user not found\n                                                                    $teacher_results[\'not_found\'] +=1; \n                                                                }\n                                                            }    \n                                                        }\n                                                        \n                                                        $sql = \"SELECT DISTINCT student_id FROM student_class WHERE class_id IN (\".implode ( \",\", $include_class_ids ).\")\";\n                                                        $rv = nuRunQuery($sql);\n                                                        $student_results = array(\'created\'=>0,\'added\'=>0,\'failed\'=>0,\'not_found\'=>0);\n                                                        while($r = db_fetch_row($rv)){\n                                                            if(\"#create_user_chk#\"==\'1\'){\n                                                                list($created,$user_id,$username) = create_user($r[0],\'0\',$hierarchy_id,$mysqli);\n                                                                if($created){\n                                                                    $student_results[\'created\'] +=1;     \n                                                                }\n                                                                if($user_id != -1){\n                                                                    if(add_user_to_cource($user_id, $new_course_id,\'0\',$mysqli)){\n                                                                        $student_results[\'added\'] +=1;    \n                                                                    } else {        // add user to cource failed\n                                                                        $student_results[\'failed\'] +=1;    \n                                                                    }\n                                                                } else {\n                                                                    $student_results[\'not_found\'] +=1;    \n                                                                }\n                                                            } else {        // do not create users\n                                                                $sql = \"    SELECT \n                                                                                zzzsys_user.sus_login_name AS username\n                                                                            FROM student\n                                                                            INNER JOIN zzzsys_user ON student.user_id=zzzsys_user.zzzsys_user_id\n                                                                            WHERE id=\".$r[0];\n                                                                $rv2 = nuRunQuery($sql);\n                                                                if($rv && db_num_rows($rv2)>0){\n                                                                    $r2 = db_fetch_row($rv2);\n                                                                    $user_id = check_user_exists($r2[0],$mysqli);\n                                                                    if($user_id>0){\n                                                                        if(add_user_to_cource($user_id, $new_course_id,\'0\',$mysqli)){\n                                                                            $student_results[\'added\'] +=1;\n                                                                        }else{      // add user to cource failed\n                                                                            $student_results[\'failed\'] +=1;\n                                                                        }                                                                        \n                                                                    } else {    // eclass user not found\n                                                                        $student_results[\'not_found\'] +=1;\n                                                                    }\n                                                                } else {    // sisyphos user not found   \n                                                                    $student_results[\'not_found\'] +=1;    \n                                                                }\n                                                            }     \n                                                        }\n                                                        array_push($courses_created_names,\n                                                            $subject_short_name.\"-\".$class_names.\n                                                            ($teacher_results[\'created\'] > 0 ?   \"<br><span style=\\\"display:inline-block; width:30px;\\\"></span><b>\".$teacher_results[\'created\'].\"</b> νέοι λογαριασμοί καθηγητών δημιουργήθηκαν\" : \'\').\n                                                            ($teacher_results[\'added\'] > 0 ?     \"<br><span style=\\\"display:inline-block; width:30px;\\\"></span><b>\".$teacher_results[\'added\'].\"</b> καθηγητές <b>προστέθηκαν</b> ως εκπαιδευτές\" : \'\').\n                                                            ($teacher_results[\'failed\'] > 0 ?    \"<br><span style=\\\"display:inline-block; width:30px;\\\"></span> η προσθήκη <b>\".$teacher_results[\'failed\'].\"</b> καθηγητών ως εκπαιδευτές <b>απέτυχε</b>\" : \'\').\n                                                            ($teacher_results[\'not_found\'] > 0 ? \"<br><span style=\\\"display:inline-block; width:30px;\\\"></span>οι λογαριασμοί <b>\".$teacher_results[\'not_found\'].\"</b> καθηγητών <b>δε βρέθηκαν</b> και δεν προσετέθησαν\" : \'\').\n                                                            ($student_results[\'created\'] > 0 ?   \"<br><span style=\\\"display:inline-block; width:30px;\\\"></span><b>\".$student_results[\'created\'].\"</b> νέοι λογαριασμοί μαθητών δημιουργήθηκαν\" : \'\').\n                                                            ($student_results[\'added\'] > 0 ?     \"<br><span style=\\\"display:inline-block; width:30px;\\\"></span><b>\".$student_results[\'added\'].\"</b> μαθητές <b>προστέθηκαν</b> ως εκπαιδευόμενοι\" : \'\').\n                                                            ($student_results[\'failed\'] > 0 ?    \"<br><span style=\\\"display:inline-block; width:30px;\\\"></span> η προσθήκη <b>\".$student_results[\'failed\'].\"</b> μαθητών ως εκπαιδευόμενοι <b>απέτυχε</b>\" : \'\').\n                                                            ($student_results[\'not_found\'] > 0 ? \"<br><span style=\\\"display:inline-block; width:30px;\\\"></span>οι λογαριασμοί <b>\".$student_results[\'not_found\'].\"</b> μαθητών <b>δε βρέθηκαν</b> και δεν προσετέθησαν\" : \'\')\n                                                            );\n                                                    } else {    // course creation failed\n                                                        array_push($courses_faild_names,$subject_short_name.\"-\".$class_names);    \n                                                    }\n                                                } else {    // course already exists for all classes\n                                                    \n                                                }\n                                            } // while lesson\n                                            \n                                            $courses_exists_names = array();\n                                            foreach($courses_exists as $course_exists){\n                                                list($subject_id,$class_id) = explode(\'-\',$course_exists);\n                                                $sql = \"SELECT \n                                                            subject.short_name,\n                                                            class.short_name\n                                                        FROM subject\n                                                        INNER JOIN class ON class.id=$class_id\n                                                        LEFT  JOIN subject_type 	on subject.subject_type_id = subject_type.id \n                                                        WHERE subject.id=$subject_id\";\n                                                $rv = nuRunQuery($sql);\n                                                $r = db_fetch_row($rv);\n                                                array_push($courses_exists_names,$r[0].\"-\".$r[1]);\n                                            }\n\n                                            $nuParameters = (count($courses_created_names) > 0 ? \"<u><b>\".count($courses_created_names).\"</b> νέες διδασκαλίες δημιουργήθηκαν : </u><br><span style=\\\"display:inline-block; width:15px;\\\"></span>\".implode(\"<br><span style=\\\"display:inline-block; width:15px;\\\"></span>\", $courses_created_names).\"<br><br>\" : \'\').\n                                                            (count($courses_faild_names) > 0 ? \"<u>Η δημιουργία <b>\".count($courses_faild_names).\"</b> διδασκαλιών απέτυχε : </u><br><span style=\\\"display:inline-block; width:15px;\\\"></span>\".implode(\"<br><span style=\\\"display:inline-block; width:15px;\\\"></span>\", $courses_faild_names).\"<br><br>\" : \'\').\n                                                            (count($courses_exists_names) > 0 ? \"<u><b>\".count($courses_exists_names).\"</b> διδασκαλίες υπάρχουν ήδη και αγνοήθηκαν : </u><br><span style=\\\"display:inline-block; width:15px;\\\"></span>\".implode(\"<br><span style=\\\"display:inline-block; width:15px;\\\"></span>\", $courses_exists_names) : \'\');\n                                        }\n                                        \n                                        \n                                    } else {\n                                        $nuParameters = \'Προσοχή: Δε βρέθηκε ο πίνακας διδασκαλιών του Open eClass σε αυτήν τη Βάση Δεδομένων!\';\n                                    }                            \n                                }\n                                $mysqli->close();\n                        } else {\n                            $nuError = \"Παρακαλώ επιλέξτε πρώτα τις διδασκαλίες!\";\n                        }                          \n                    } else {\n                        $nuError = \"Παρακαλώ επιλέξτε πρώτα την κατηγορία στην οποία θα ενταχθούν οι νέες διδασκαλίες!\";\n                    }             \n                } else {\n                    $nuError = \"Παρακαλώ συμπληρώστε τον κωδικό της βάσης δεδομένων!\";\n                } \n            } else {\n                $nuError = \"Παρακαλώ συμπληρώστε το όνομα του χρήστη της βάσης δεδομένων!\";\n            } \n        } else {\n            $nuError = \"Παρακαλώ συμπληρώστε το όνομα της βάσης δεδομένων!\";\n        } \n    }else {\n            $nuError = \"Παρακαλώ συμπληρώστε τη θύρα επικοινωνίας με τη βάση δεδομένων!\";\n    } \n} else {\n    $nuError = \"Παρακαλώ συμπληρώστε το όνομα ή τη διεύθυνση του εξυπηρετητή βάσης δεδομένων!\";    \n}\n\n\n','','0','2020-08-17 13:42:07','globeadmin','2020-08-30 14:29:13','globeadmin','2020-08-30 14:29:13','globeadmin','0'),('5f3f7a399f33641','eclass_lib','Βιβλιοθήκη συναρτήσεων για την διασύνδεση με το eclass','LMS','function check_user_exists($username,$conn){\n    $result = $conn->query(\"SELECT id FROM user WHERE username=\'$username\'\");\n    if($result !== FALSE)\n        if($result->num_rows === 0)\n            return 0;\n        else {\n            $row = $result->fetch_row();\n            return $row[0];\n        }\n    else \n        return -1;\n}\n\nfunction create_user($id,$is_teacher,$hierarchy_id,$conn){\n    if($is_teacher==\'1\'){\n        $sql = \"    SELECT \n                    	id                                              AS am,\n                    	IF(name IS NULL OR name=\'\',\'-\',name)            AS givenname,\n                    	IF(surname IS NULL OR surname=\'\',\'-\',surname)   AS surname,\n                    	IF(email IS NOT NULL AND email<>\'\',email,\n                            IF(zzzsys_user.sus_email  IS NOT NULL AND zzzsys_user.sus_email <>\'\',zzzsys_user.sus_email ,\'-\'))       AS email,\n                        \'-\'                                             AS parent_email,\n                        IF(mobile IS NOT NULL AND mobile<>\'\',mobile,\n                            IF(phone1 IS NOT NULL AND phone1<>\'\',phone1,\n                                IF(phone2 IS NOT NULL AND phone2<>\'\',phone2,\' \')))  AS phone,\n                        zzzsys_user.sus_login_name                      AS username\n                                                        \n                    FROM teacher\n                    INNER JOIN zzzsys_user ON teacher.user_id=zzzsys_user.zzzsys_user_id\n                    WHERE id=$id\";  \n        $status = 1;\n    } else {\n        $sql = \"    SELECT \n                    	registration_number                             AS am,\n                    	IF(name IS NULL OR name=\'\',\'-\',name)            AS givenname,\n                    	IF(surname IS NULL OR surname=\'\',\'-\',surname)   AS surname,\n                    	IF(email IS NOT NULL AND email<>\'\',email,\'-\')  AS email,\n                    	IF(parent_email IS NOT NULL AND parent_email<>\'\',parent_email,\'-\')  AS parent_email,\n                        IF(mobile IS NOT NULL AND mobile<>\'\',mobile,\n                            IF(phone1 IS NOT NULL AND phone1<>\'\',phone1,\n                                IF(phone2 IS NOT NULL AND phone2<>\'\',phone2,\' \')))  AS phone,\n                        zzzsys_user.sus_login_name                      AS username\n                    FROM student\n                    INNER JOIN zzzsys_user ON student.user_id=zzzsys_user.zzzsys_user_id\n                    WHERE id=$id\";    \n        $status = 5;\n    }\n    \n    $retval=nuRunQuery($sql);\n    \n    if($retval && db_num_rows($retval)>0 && $row = db_fetch_array($retval)){\n        \n        $cid = check_user_exists($row[\'username\'],$conn);\n        \n        if($cid == 0){\n            $sql = \"    INSERT INTO user(\n                            surname, \n                            givenname, \n                            username, \n                            password, \n                            email,\n                            parent_email,\n                            status, \n                            phone,\n                            am,\n                            registered_at, \n                            expires_at, \n                            lang,\n                            description,\n                            verified_mail,\n                            email_public, \n                            phone_public, \n                            am_public,\n                            whitelist)\n				        VALUES \n	                        (\n	                         \'{$row[\'surname\']}\',\n	                         \'{$row[\'givenname\']}\',\n	                         \'{$row[\'username\']}\',\n	                         \'db\',\n	                         \'{$row[\'email\']}\',\n	                         \'{$row[\'parent_email\']}\',\n	                         $status,\n	                         \'{$row[\'phone\']}\',\n	                         \'{$row[\'am\']}\',\n	                         NOW(),\n	                         DATE_ADD(NOW(), INTERVAL 4 YEAR),\n	                         \'el\',\n	                         \'\',\n	                         1,\n	                         0,\n	                         0,\n	                         0,\n	                         \'\')\";\n	                                                                \n            $insusr = $conn->query($sql);\n\n            if($insusr !== FALSE){  \n                $new_user_id = $conn->insert_id;\n                                                                        \n                $sql = \"INSERT IGNORE INTO personal_calendar_settings(user_id) VALUES ($new_user_id)\";\n                $conn->query($sql);\n                                                                        \n                $sql = \"DELETE FROM user_department WHERE user =  $new_user_id\";\n                $conn->query($sql);\n                                                                        \n                $sql = \"INSERT INTO user_department (user, department) VALUES ($new_user_id, $hierarchy_id)\";\n                $conn->query($sql);\n                \n                return array(true,$new_user_id,$row[\'username\']);\n            } else{\n                return array(false,-1,\"\");\n            }\n        } else if($cid>0){\n            return array(false,$cid,$row[\'username\']);\n        } else {\n            return array(false,-1,\"\");    \n        }\n    } else {\n        return array(false,-1,\"\");\n    }\n}\n\nfunction create_course($public_code, $title, $description, $hierarchy_id, $prof,$conn) {\n\n    $sql = \"    SELECT code, MAX(generator) AS generator\n                FROM hierarchy \n                WHERE code = (SELECT code FROM hierarchy WHERE id = $hierarchy_id) \n                GROUP BY code\";\n    $result = $conn->query($sql);\n    \n    if($result !== FALSE && $row = $result->fetch_array()){\n        $row[1] +=1;\n        $code = strtoupper($row[0].$row[1]);\n        $sql = \"UPDATE hierarchy SET generator = {$row[1]} WHERE id = $hierarchy_id\";\n        $conn->query($sql);\n        \n        $dir = \'#server_folder#\'!=\'\' && \'#server_folder#\'!=\'#\'.\'server_folder#\' ? \'#server_folder#\' : __DIR__.DIRECTORY_SEPARATOR.\'tmp\';\n        \n        if (!create_course_dirs($code,$dir)) return false;\n        \n        $sql = \"    INSERT INTO course(\n                            code,\n                            lang,\n                            title,\n                            keywords,\n                            description,\n                            visible,\n                            prof_names,\n                            public_code,\n                            created,\n                            password,\n                            glossary_expand,\n                            glossary_index,\n                            view_type\n                            )\n				    VALUES \n	                        (\n	                         \'$code\',\n	                         \'el\',\n	                         \'$title\',\n	                         \'\',\n	                         \'$description\',\n	                         0,\n	                         \'$prof\',\n	                         \'$public_code\',\n	                         NOW(),\n	                         \'\',\n	                         0,\n	                         1,\n	                         \'simple\')\";\n        $insusr = $conn->query($sql);\n\n        if($insusr !== FALSE){  \n            $new_course_id = $conn->insert_id;\n            $sql = \"DELETE FROM course_department WHERE course = $new_course_id\";\n            $conn->query($sql);\n            $sql = \"INSERT INTO course_department (course, department) VALUES ($new_course_id,$hierarchy_id)\";\n            $conn->query($sql);\n                    \n            $sql = \"INSERT INTO idx_queue_async (user_id, request_type, resource_type, resource_id) VALUES (1, \'store\', \'course\', $new_course_id)\";\n            $conn->query($sql);\n            //require_once \'modules/course_metadata/CourseXML.php\';                 ********* IGNORED *********\n            //CourseXMLElement::refreshCourse($id, course_id_to_code($id));         ********* IGNORED *********\n                    \n            create_modules($new_course_id,$conn);\n            if(!course_index($code,$dir)) return false;\n            return array($new_course_id,$code);\n        }        \n    }\n    return false;\n}\n\nfunction create_modules($cid,$conn) {\n    $modules = array(1,2,3,4,5,7,9,10,15,16,17,18,19,21,23,26,37,46,32,30,34,48,47);\n\n    $module_ids[1] = default_modules($conn);\n    $module_ids[0] = array_diff($modules, $module_ids[1]);\n\n    $args = array();\n    foreach (array(0, 1) as $vis) {\n        foreach ($module_ids[$vis] as $mid) {\n            $args[] = \"(\".$mid.\",\".$vis.\",\".$cid.\")\";\n        }\n    }\n    $sql = \"INSERT IGNORE INTO course_module(module_id, visible, course_id) VALUES \".implode(\',\', $args);\n    $conn->query($sql);\n}\n\nfunction default_modules($conn) {\n    // Modules enabled by default in new courses\n    $default_module_defaults = array(1,2,3,7,20,16);\n\n    if ($def = get_config(\'default_modules\',$conn)) {\n        return unserialize($def);\n    } else {\n        return $default_module_defaults;\n    }\n}\n\nfunction get_config($key, $conn) {\n    $sql = \"SELECT `value` FROM config WHERE `key` = \'$key\'\";\n    $result = $conn->query($sql);\n    \n    if($result !== FALSE && $row = $result->fetch_array()){\n        return $row[0];\n    } \n    return;\n}\n\n\nfunction create_course_dirs($code,$webDir) {\n\n    $base = $webDir.DIRECTORY_SEPARATOR.\"courses\".DIRECTORY_SEPARATOR.$code;\n    foreach (array($base, \"$base/image\", \"$base/document\", \"$base/dropbox\",\n                   \"$base/page\", \"$base/work\", \"$base/group\", \"$base/temp\",\n                   \"$base/scormPackages\", \"video/$code\") as $newdir) {\n        if (!mkdir($newdir,0755,true)) {\n            return false;\n        }\n    }\n    return true;\n}\n\n\nfunction course_index($code,$webDir) {\n    \n    $fd = fopen($webDir.DIRECTORY_SEPARATOR.\"courses\".DIRECTORY_SEPARATOR.$code.DIRECTORY_SEPARATOR.\"index.php\", \"w\");\n    chmod($webDir.DIRECTORY_SEPARATOR.\"courses\".DIRECTORY_SEPARATOR.$code.DIRECTORY_SEPARATOR.\"index.php\", 0644);\n    if (!$fd) {\n        return false;\n    }\n    fwrite($fd, \"<?php\\nsession_start();\\n\" .\n            \"\\$_SESSION[\'dbname\']=\'$code\';\\n\" .\n            \"include \'../../modules/course_home/course_home.php\';\\n\");\n    fclose($fd);\n    return true;\n}\n\nfunction add_user_to_cource($user_id, $cource_id,$is_teacher,$conn){\n\n    $sql = \"SELECT * FROM course_user WHERE user_id = $user_id AND course_id = $cource_id\";\n    $result = $conn->query($sql);\n    \n    if($result === FALSE || $result->num_rows >0)\n        return false;\n    else {\n        $sql = \"INSERT INTO course_user \n                    (user_id, course_id, status, tutor, reg_date, document_timestamp)\n                VALUES \n                    ($user_id, $cource_id,\".($is_teacher==\'1\'? 1 : 5).\",$is_teacher,NOW(),NOW())\";\n        $res = $conn->query($sql);\n        if($res !== FALSE)\n            return true;\n        else return false;\n    }	\n}\n','','0','2020-08-21 10:39:37','globeadmin','2020-08-25 10:33:54','globeadmin','2021-09-07 20:45:22','globeadmin','0'),('5f63e26289741cf','add_appointment','Προσθέτει στο ημερολόγιο ένα ραντεβού καθηγητή','Parents','nuRunPHP(\'send_email_calendar_event\');\n$nuParameters = \'\';\n\nfunction time_to_seconds($time){\n    $arr = explode(\":\", $time);\n    return (intval($arr[0]) * 3600 + intval($arr[1]) * 60 + intval ($arr[2]));\n}\n\nif(\'#appointment_JSON#\'!=\'\' && \'#appointment_JSON#\'!=\'#\'.\'appointment_JSON#\'){\n    $json_str = stripslashes(\'#appointment_JSON#\');\n    $json = json_decode($json_str,true);\n    \n    if (json_last_error() === JSON_ERROR_NONE) {\n    \n        $sql=\"  SELECT day_id,start_time,end_time,location,teacher_id,appointment_duration,concat(if(teacher.surname is null,\'\',concat(teacher.surname,\' \')), IFNULL(teacher.name,\'\')) as teacher_name\n                FROM appointment_teacher_availability AS ata\n                INNER JOIN teacher ON teacher.id = ata.teacher_id\n                WHERE ata.id={$json[\'availability_id\']}\";\n        $retval = nuRunQuery($sql);\n        \n        if($retval && $row=db_fetch_array($retval)){\n        \n            $sql = \"    SELECT count(DISTINCT calendar_event.id) \n                        FROM calendar_event\n                        INNER JOIN calendar_event_access ON calendar_event.id = calendar_event_access.calendar_event_id\n                        WHERE \n                            calendar_event.teacher_id=\'{$row[\'teacher_id\']}\' AND \n                            CONCAT(calendar_event.end_date,\' \', calendar_event.end_time) > NOW() AND\n                            calendar_event.is_appointment = 1 AND\n                            calendar_event_access.student_id = \'#RECORD_ID#\'\";\n            $rv=nuRunQuery($sql);\n            $r = db_fetch_row($rv);\n\n            $open_appointment_exists = $r[0]>0 ? true : false;\n                                                            // / Βρίσκει σε πόσα ραντεβού με τον καθηγητή o συγκεκριμένος γονέας δεν προσηλθε κατά τον τελευταίο μήνα  \n            $sql = \"    SELECT count(DISTINCT calendar_event.id) \n                        FROM calendar_event\n                        INNER JOIN calendar_event_access ON calendar_event.id = calendar_event_access.calendar_event_id\n                        WHERE \n                            calendar_event.teacher_id=\'{$row[\'teacher_id\']}\' AND \n                            CONCAT(calendar_event.end_date,\' \', calendar_event.end_time )< NOW() AND\n                            CONCAT(calendar_event.start_date,\' \', calendar_event.start_time > DATE_ADD(NOW(), INTERVAL -1 MONTH)) AND\n                            calendar_event.is_appointment = 1 AND\n                            calendar_event.was_held = 0 AND\n                            calendar_event_access.student_id = \'#RECORD_ID#\'\";\n            $rv=nuRunQuery($sql);\n            $r = db_fetch_row($rv);\n\n            $penalty = $r[0]>2 ? true : false;\n//---------------------------------------------------------------------------------------------------------------------------------    \n            \n            if($row[\'day_id\'] == (date(\"N\", strtotime($json[\'date\']))-1) && \n                $row[\'start_time\']<=$json[\'start\'] && \n                $json[\'end\']<=$row[\'end_time\'] && \n                ((time_to_seconds($json[\'end\']) - time_to_seconds($json[\'start\'])) >= ($row[\'appointment_duration\']) * 60) &&\n                $open_appointment_exists==false &&\n                $penalty==false){\n                $sql = \"SELECT DISTINCT start_time AS start,end_time AS end \n                        FROM calendar_event \n                        WHERE \n                            (teacher_id=\'{$row[\'teacher_id\']}\' OR\n                            EXISTS (SELECT id FROM calendar_event_access WHERE calendar_event.id=calendar_event_access.calendar_event_id AND calendar_event_access.student_id=\'#RECORD_ID#\')) AND\n                            start_date = \'{$json[\'date\']}\' AND\n                            end_date = \'{$json[\'date\']}\' AND\n                            is_appointment = 1\n                        ORDER BY start_time\";\n                $rv=nuRunQuery($sql);\n                $events = array();\n                $overlap = false;\n                while($event=db_fetch_array($rv)){\n                    if(\n                        ($event[\'start\'] >= $json[\'start\'] && $event[\'start\'] < $json[\'end\']) || \n                        ($event[\'start\'] <= $json[\'start\'] && $json[\'start\']  < $event[\'end\']) ||\n                        ($event[\'start\'] == $json[\'start\'] && $event[\'end\'] == $json[\'end\'])\n                        ){\n                        $overlap = true;\n                        break;\n                    }\n                }\n                \n                \n                if(!$overlap){\n\n                    $sql = \"    INSERT INTO calendar_event (\n                                    id,\n                                    title,\n                                    description,\n                                    allDay,\n                                    start_date,\n                                    end_date,\n                                    start_time,\n                                    end_time,\n                                    color,\n                                    backgroundColor,\n                                    borderColor,\n                                    textColor,\n                                    is_appointment,\n                                    teacher_id ,\n                                    location)\n                                VALUES(\n                                    NULL,\n                                    \'Ραντεβού γονέα με καθηγητή\',\n                                    \'Ραντεβού του καθηγητή {$row[\'teacher_name\']} με το γονέα του μαθητή #surname# #name#\".(\'#fathers_name#\'==\'\' ? \'\' :\' πατ. #fathers_name#\').\" (#registration_number#)\',\n                                    \'0\',\n                                    \'{$json[\'date\']}\',\n                                    \'{$json[\'date\']}\',\n                                    \'{$json[\'start\']}\',\n                                    \'{$json[\'end\']}\',\n                                    \'#BA55D3\',\n                                    NULL,\n                                    NULL,\n                                    NULL,\n                                    1,\n                                    \'{$row[\'teacher_id\']}\',\n                                    \'{$row[\'location\']}\'\n                                )\";\n                            \n                    $t = nuRunQuery($sql,NULL,true);                \n                \n                    $sql = \"    INSERT INTO calendar_event_access (\n                                        id,\n                                        calendar_event_id,\n                                        teacher_id,\n                                        student_id,\n                                        grade_id,\n                                        class_id,\n                                        user_group_id,\n                                        publish_id\n                                        )\n                                    VALUES(\n                                        NULL,\n                                        \'$t\',\n                                        NULL,\n                                        \'#RECORD_ID#\',\n                                        NULL,\n                                        NULL,\n                                        \'5717ba3eb32c252\',\n                                        NULL\n                                        )\";\n                    nuRunQuery($sql);\n                        \n                    calendar_event_owner_email($t,10);\n\n                    $data_array =  array(\n                                    $t,\n                                    \'Ραντεβού γονέα με καθηγητή\',\n                                    \'0\',\n                                    $json[\'date\'].\'T\'.$json[\'start\'],\n                                    $json[\'date\'].\'T\'.$json[\'end\'],\n                                    \'#BA55D3\',\n                                    \'0\',\n                                    \'0\',\n                                    \'Ραντεβού του καθηγητή \'.$row[\'teacher_name\'].\' με το γονέα του μαθητή #surname# #name#\'.(\'#fathers_name#\'==\'\' ? \'\' :\' πατ. #fathers_name#\').\' (#registration_number#)\',\n                                    $row[\'location\'],\n                                    $json[\'row_id\'],\n                                    $row[\'teacher_id\']\n                                    );\n                            $json_string = json_encode($data_array);\n                            $nuParameters = $json_string;\n              \n                } else {\n                    $nuError = \'Προσοχή! Βρέθηκε επικάλυψη με άλλο ραντεβού δικό σας ή του καθηγητή σε αυτό το χρονικό διάστημα! Η δέσμευση δεν πραγματοποιήθηκε!\';    \n                }\n            } else {\n                $nuError = \'Προσοχή! Τα χρονικά όρια του ραντεβού είναι λανθασμένα ή υπάρχουν περιορισμοί που δεν πληρούνται! Η δέσμευση δεν πραγματοποιήθηκε!\';        \n            }\n        } else {\n            $nuError = \'Προσοχή! Παρουσιάστηκε σφάλμα κατά την επεξεργασία του αιτήματος! Η δέσμευση δεν πραγματοποιήθηκε!\';    \n        }\n    } else {\n        $nuError = \'Προσοχή! Παρουσιάστηκε σφάλμα κατά την αποστολή των δεδομένων! Η δέσμευση δεν πραγματοποιήθηκε!\';\n    }\n} else {\n    $nuError= \'Προσοχή! Παρουσιάστηκε σφάλμα κατά την αποστολή των δεδομένων! Η δέσμευση δεν πραγματοποιήθηκε!\';    \n}\n','','0','2020-09-18 01:25:38','globeadmin','2020-09-24 13:24:10','globeadmin','2021-04-05 21:46:37','globeadmin','0'),('5f68734969ddcf1','delete_appointment','Διαγράφει ένα ραντεβού ημερολογίου','Teachers, Parents','nuRunPHP(\'notification_add_lib\');\nnuRunPHP(\'send_email_calendar_event\');\n\n$nuParameters = \'\';\n\nif(\'#calendar_event_id#\'!=\'\' && \'#calendar_event_id#\'!=\'#\'.\'calendar_event_id#\'){\n    \n    $id = \'#calendar_event_id#\';\n    \n//if((moment().format(\'YYYY-MM-DD\')+\' 23:59:59\') < moment(calEvent.start).format(\'YYYY-MM-DD HH:mm:ss\')){  \n\n    $sql=\"  SELECT \n                    calendar_event.teacher_id,\n                    session_variables.teacher_id,\n                    CONCAT(calendar_event.start_date,\' \',calendar_event.start_time),\n                    NOW(),\n                    CONCAT(CURDATE(),\' 23:59:59\')\n                FROM calendar_event\n                INNER JOIN session_variables ON  session_variables.session_id = \'#session_id#\'\n                WHERE \n                    calendar_event.id=\'$id\'\";\n    $retval = nuRunQuery($sql);\n    $row = db_fetch_row($retval);\n    \n    if((\'#nu_user_group#\'==\'Parents\' && $row[4]<$row[2]) || (\'#nu_user_group#\'!=\'Parents\' && $row[3]<$row[2])){\n    \n        if(\'#nu_user_group#\'==\'Parents\' || $row[0]!=$row[1]){\n            $m = calendar_event_owner_email($id,9);\n        }\n    \n        $sql = \"SELECT id,user_group_id FROM calendar_event_access WHERE calendar_event_id=\'$id\'\";\n        $retval = nuRunQuery($sql);\n        if(\'#nu_user_group#\'!=\'Parents\' && ($row[1]==\'547de4c65675a29\' || $row[1]==\'5717ba3eb32c252\')){\n            calendar_event_notification($row[0],9);\n        } else if($row[1]!=\'999999999999999\'){\n            $m = calendar_event_email($row[0],9);\n        }\n        \n        $sql=\"DELETE FROM calendar_event WHERE id=\'$id\'\";\n        nuRunQuery($sql);\n\n        $sql=\"DELETE FROM calendar_event_access WHERE calendar_event_id=\'$id\'\";\n        nuRunQuery($sql);\n    \n        $nuParameters = \'#calendar_event_id#\';        \n    }\n} ','','0','2020-09-21 12:32:57','globeadmin','2020-09-25 23:33:06','globeadmin','2020-09-26 13:48:44','globeadmin','0'),('5f6888aa4c7548f','set_appointment_washeld','Ορίζει εάν ένα ραντεβού πραγματοποιήθηκε ή όχι','Teachers','$nuParameters = \'\';\nif(     \'#calendar_event_id#\'!=\'\' && \'#calendar_event_id#\' != \'#\'.\'calendar_event_id#\' &&\n        \'#was_held#\'!=\'\' && \'#was_held#\' != \'#\'.\'was_held#\'){\n    $sql = \"SELECT was_held FROM calendar_event WHERE id=\'#calendar_event_id#\'\";\n    $retval = nuRunQuery($sql);\n    $row = db_fetch_row($retval);\n    $res = -1;\n    \n    if($row[0] == \'#was_held#\'){\n        $sql = \"UPDATE calendar_event SET was_held=NULL WHERE id=\'#calendar_event_id#\'\";    \n    } else {\n        $sql = \"UPDATE calendar_event SET was_held=\'#was_held#\' WHERE id=\'#calendar_event_id#\'\"; \n        $res = \'#was_held#\';\n    }\n    nuRunQuery($sql);\n    \n    $data_array =  array(\'#calendar_event_id#\',$res);\n    $json_string = json_encode($data_array);\n    $nuParameters = $json_string;\n }\n','','0','2020-09-21 14:04:10','globeadmin','2020-09-21 14:21:32','globeadmin','2020-09-23 23:52:44','globeadmin','0'),('5f6cc2b342ea2e8','parent_account_delete','Μαζική Διαγραφή Λογαριασμών Γονέων','manager','$nuParameters = \'\';\nif(\'#student_id_sumo#\'!=\'\' && \'#student_id_sumo#\'!=\'#\'.\'student_id_sumo#\'){\n    $sql=\"DELETE FROM zzzsys_user WHERE zzzsys_user_id IN (SELECT parent_user_id FROM student WHERE id IN (#student_id_sumo#))\";\n    nuRunQuery($sql);\nnuDebug($sql);\n    \n    $sql=\"UPDATE student SET parent_user_id=NULL WHERE id IN (#student_id_sumo#)\";\n    nuRunQuery($sql);\n nuDebug($sql);   \n    $nuParameters = \'OK\';\n}','','0','2020-09-24 19:00:51','globeadmin','2020-09-24 22:04:23','globeadmin','2020-09-24 22:11:48','globeadmin','0'),('5f6cef854c9e4b1','student_account_delete','Μαζική Διαγραφή Λογαριασμών Μαθητών','manager','$nuParameters = \'\';\nif(\'#student_id_sumo#\'!=\'\' && \'#student_id_sumo#\'!=\'#\'.\'student_id_sumo#\'){\n    $sql=\"DELETE FROM zzzsys_user WHERE zzzsys_user_id IN (SELECT user_id FROM student WHERE id IN (#student_id_sumo#))\";\n    nuRunQuery($sql);\nnuDebug($sql);\n    \n    $sql=\"UPDATE student SET user_id=NULL WHERE id IN (#student_id_sumo#)\";\n    nuRunQuery($sql);\n nuDebug($sql);   \n    $nuParameters = \'OK\';\n}','','0','2020-09-24 22:12:05','globeadmin','2020-09-24 22:13:01','globeadmin','2020-09-24 22:13:01','globeadmin','0'),('5f7c42a7aa3146f','allday_absence_students','Βρίσκει τους μαθητές που απουσίαζαν όλη τη μέρα από το σχολείο σε μιά συγκεκριμένη ημερομηνία','manager','print \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n        \n        <script type=\\\"text/javascript\\\">\n\n            function show_penalty_info(penalty_id){\n                parent.nuOpenForm(\'\',\'\', \'554517bdc18334d\', penalty_id,\'Εισαγωγή Ποινής\');\n                //parent.nuOpenFormInFrame(\'554517bdc18334d\',penalty_id)    \n            }\n\n        </script>\n\n    </head>\n\n    <body onload=\\\"adjustIframeHeight();parent.hideLoader();\\\">\";\n    \n    \nif(\'#absence_date#\'!=\'\' && \'#absence_date#\'!=\'#\'.\'absence_date#\'){\n    if(\'#absence_date#\'<=date(\'Y-m-d\')){\n\n        if(\'#TABLE_ID#\' != \'#\'.\'TABLE_ID\'.\'#\' && \'#TABLE_ID#\' != \'\'){\n                $tmp_table=\'#TABLE_ID#\';\n        } else {\n                $tmp_table=\'__\'.nuID().\'__\';\n        }\n\n        $sql=\"DROP TEMPORARY TABLE IF EXISTS \".$tmp_table;\n        nuRunQuery($sql);\n        \n        $sql=\" CREATE TEMPORARY TABLE $tmp_table DEFAULT CHARACTER SET=utf8 \n                SELECT \n                    student.id                  AS student_id,\n                    grade.short_name            AS grade_short_name,\n                    student.registration_number AS registration_number,\n                    student.surname             AS student_surname,\n                    student.name                AS student_name,\n                    student.fathers_name        AS fathers_name,\n                    0           AS absences,\n                    0           AS absences_total,\n                    0           AS pending_cards,\n                    CAST(\'\' as CHAR(50))        AS absences_desc\n                FROM student\n                INNER JOIN grade ON grade.id = student.grade_id\";\n       \n        if(\'#class_id_sumo#\'!=\'#\'.\'class_id_sumo#\' && \'#class_id_sumo#\'!=\'\'){\n            $sql.= \"\n                INNER JOIN student_class on (student_class.student_id=student.id AND student_class.class_id  IN (#class_id_sumo#))\n                \";\n        }       \n\n        $sql.=\"\n                WHERE has_left_school=0\";\n        \n        if(\'#grade_id_sumo#\'!=\'#\'.\'grade_id_sumo#\' && \'#grade_id_sumo#\'!=\'\'){\n            $sql.= \" AND student.grade_id IN (#grade_id_sumo#)\";\n        }                \n        nuRunQuery($sql);\n\n        $sql=\"SELECT student_id FROM $tmp_table\";\n        $retval= nuRunQuery($sql);\n\n        while($row=db_fetch_row($retval)){\n    \n            $student_id = $row[0];\n\n            $sql=\"  SELECT absence.absence_reason_id,absence_reason.short_name, COUNT(absence.absence_reason_id)    \n                    FROM absence\n                    INNER JOIN absence_reason ON absence_reason.id = absence.absence_reason_id\n                    WHERE \n                        absence_date = \'#absence_date#\' AND\n                        student_id = \'$student_id\' AND\n                        NOT EXISTS (SELECT id FROM justification_request WHERE justification_request.absence_id=absence.id)\n                    GROUP BY absence.absence_reason_id,absence_reason.short_name\n                    \";\n            $rv = nuRunQuery($sql);\n            $absences = 0;\n            $absences_desc = \'\';\n            while($r = db_fetch_row($rv)){\n                $absences_desc .= ($absences_desc==\'\' ? $r[2].$r[1] : \', \'.$r[2].$r[1]);\n                $absences += $r[2];    \n            }\n\n            $sql=\"  SELECT count(distinct period_id)\n                    FROM card\n                    INNER JOIN period ON period.id = card.period_id\n                    WHERE\n                        valid_from=(SELECT MAX(start_date) FROM timetable WHERE start_date<=\'#absence_date#\') AND\n                        day_id=\".(idate(\'w\', strtotime(\'#absence_date#\'))-1).\" AND\n                        CONCAT(\'#absence_date# \',period.start_time)<= NOW() AND\n                        card.id NOT IN (SELECT card_id FROM registered_card WHERE card_date=\'#absence_date#\') AND\n                        \'#absence_date#\' NOT IN (   SELECT holiday.holiday \n                                                    FROM holiday \n                                                    INNER JOIN school_year ON holiday.school_year_id=school_year.id\n                                                    INNER JOIN school ON school.school_year_id=school_year.id) AND\n                        card.class_id in (SELECT DISTINCT class_id FROM student_class WHERE student_id=\'$student_id\')\";\n        \n            $rv = nuRunQuery($sql);\n            $r = db_fetch_row($rv);\n            $pending_cards = $r[0];\n        \n            $sql = \"    SELECT count(distinct card.period_id) \n                        FROM registered_card\n                        INNER JOIN card ON card.id = registered_card.card_id\n                        WHERE \n                            registered_card.card_date=\'#absence_date#\' AND\n                            registered_card.no_lesson = 0 AND\n                            card.class_id in (select distinct class_id from student_class where student_id=\'$student_id\')\";    \n            $rv = nuRunQuery($sql);\n            $r = db_fetch_row($rv);\n            $absences_total = $r[0];\n        \n            $sql = \"UPDATE $tmp_table SET\n                        absences = $absences,\n                        pending_cards=$pending_cards,\n                        absences_total=$absences_total,\n                        absences_desc=\'$absences_desc\'\n                    WHERE student_id=\'$student_id\'\";\n            nuRunQuery($sql);\n        }\n\n\n        $sql = \"DELETE FROM $tmp_table \n                WHERE\n                    (pending_cards=0 AND absences_total=0) OR\n                    (absences<absences_total)\";\n        nuRunQuery($sql);\n    \n        $sql=\"SELECT * FROM $tmp_table ORDER BY grade_short_name,student_surname,student_name,fathers_name\";\n        $retval=nuRunQuery($sql);\n\n        if(db_num_rows($retval)>0) {\n    \n            print (\"\n        <table cellspacing=0 CLASS=\\\"sisTable\\\">\n            <tr height=40>\n                <th width=40 align=center>Τάξη</th>\n                <th width=60 align=center>ΑΜ</th>\n                <th width=180 align=center>Επώνυμο</th>\n                <th width=140 align=center>Όνομα</th>\n                <th width=140 align=center>Πατρώνυμο</th>\n                <th width=80 align=center>Απουσίες Μαθητή</th>\n                <th width=120 align=center>Καταχωρισμένες Διδασκαλίες</th>\n                <th width=120 align=center>Διδασκαλίες σε Εκκρεμότητα</th>\n            </tr>\");\n        \n            $color1 =\'#ffb3b3\';\n            $color2 =\'#ffffcc\';\n            $s1=0;\n            $s2=0;\n        \n            while($row = db_fetch_row($retval)) {\n        \n                if($row[8]!=0){\n                    $color = $color2;\n                    $s2++;\n                    \n                } else {\n                    $color = $color1;\n                    $s1++;\n                }\n            \n                print (\"\n            <tr style=\\\"background-color:$color;\\\" height=27>\n                <td align=center>\".(is_null($row[1]) || $row[1]==\'\'? \'&nbsp;\' : $row[1]).\"</td>\n                <td align=center>\".(is_null($row[2]) || $row[2]==\'\'? \'&nbsp;\' : $row[2]).\"</td>\n                <td align=left>\".(is_null($row[3]) || $row[3]==\'\'? \'&nbsp;\' : $row[3]).\"</td>\n                <td align=left>\".(is_null($row[4]) || $row[4]==\'\'? \'&nbsp;\' : $row[4]).\"</td>\n                <td align=left>\".(is_null($row[5]) || $row[5]==\'\'? \'&nbsp;\' : $row[5]).\"</td>\n                <td align=center>\".($row[6]!=0 ? \"<b>\".$row[6].\"</b>\" : $row[6]).($row[9]==\'\' ? \'\' :\' (\'.$row[9].\')\').\"</td>\n                <td align=center>\".($row[7]!=0 ? \"<b>\".$row[7].\"</b>\" : $row[7]).\"</td>\n                <td align=center>\".($row[8]!=0 ? \"<b>\".$row[8].\"</b>\" : $row[8]).\"</td>\n             </tr>\");\n            }\n            \n            print(\"\n            <tr height=25>\n                <th align=right colspan=5>Αριθμός μαθητών που απουσίαζαν από όλες τις προγραμματισμένες διδασκαλίες : </th>\n                <th align=center colspan=3>$s1</th>\n            </tr>\");\n            \n            if($s2>0){\n                print(\"\n            <tr height=25>\n                <th align=right colspan=5>Αριθμός μαθητών που ενδέχεται (με την ολοκλήρωση της καταχώρισης) να απουσιάζουν από όλες τις προγραμματισμένες διδασκαλίες : </th>\n                <th align=center colspan=3>$s2</th>\n            </tr>\");\n            }\n        \n            print (\"\n        </table>\");\n        \n            if($s2>0){\n                print (\"\n        <br>\n        <table border=0 cellspacing=0 cellpadding=6 CLASS=\\\"sisTable\\\" align=center>\n            <tr>\n                <td bgcolor=\\\"$color1\\\" align=center>Έχει ολοκληρωθεί η καταχώριση των απουσιών</td>\n                <td bgcolor=\\\"$color2\\\" align=center>Υπάρχουν εκκρεμότητες στην καταχώριση των απουσιών</td>\n            </tr>\n        </table>\");\n            }\n        }\n        else{\n            print (\"<span CLASS=\\\"msg\\\">Δε βρέθηκαν μαθητές...</span>\");\n        }\n    } else {\n        print (\"<span CLASS=\\\"msgError\\\">Δεν μπορείτε να κάνετε αναζήτηση σε μελλοντικές ημερομηνίες...</span>\");    \n    }\n} else{\n    print (\"<span CLASS=\\\"msgError\\\">Παρακαλώ ορίσετε πρώτα την ημερομηνία...</span>\");    \n}\n\nprint \"\n    </body>\n</html>\";\n\n','','0','2020-10-06 13:10:47','globeadmin','2020-10-08 23:46:49','globeadmin','2022-02-11 21:39:39','globeadmin','0'),('5f8b61c073af846','create_teacher_list_sms','Δημιουργεί λίστα των καθηγητών με τα τηλέφωνα τους για μαζική αποστολή sms','manager','function validate_phone_number($phone_text){\n    \n    //eliminate every char except 0-9\n    $justNums = preg_replace(\"/[^0-9]/\", \'\', $phone_text);\n\n    if (strlen($justNums) == 12){ // it\'s probably a valid phone number with country code in front\n        return(\"+\".$justNums);    \n    } elseif (strlen($justNums) == 10){ // it\'s probably a valid greek phone number\n        return(\"+30\".$justNums);\n    } else {\n        return;\n    }\n}\n\nprint \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n        \n        <STYLE TYPE=\\\"text/css\\\">\n            .sisTable TH{\n                font-size:1.1em;\n            }\n        </STYLE>\n\n        <script>\n            function toggle69(source,class_name) {\n                checkboxes = document.getElementsByClassName(class_name);\n                for(var i=0, n=checkboxes.length;i<n;i++) {\n                    id_name = checkboxes[i].id;\n                    if (id_name.indexOf(\\\"+3069\\\") >= 0){\n                        checkboxes[i].checked = source.checked;\n                    }\n                }\n            }\n\n            function make_indeterminate(chk_name,phone_number) {\n                var all_chk = document.getElementById(chk_name);\n                all_chk.indeterminate = true;\n                if (phone_number.indexOf(\\\"+3069\\\") >= 0){\n                    var all_chk69 = document.getElementById(chk_name+\\\"69\\\");\n                    all_chk69.indeterminate = true;\n                }\n            }\n        </script>\n    </head>\n    <body onload=\\\"adjustIframeHeight()\\\">\";\n\n$sql=\"select email_recipients from session_variables WHERE session_id=\'#session_id#\'\";\n$retval = nuRunQuery($sql);\n$row = db_fetch_row($retval);\n$teachers = $row[0];\n$sql=\"  SELECT \n            teacher.id,\n            concat(\n                if(teacher.surname is NULL,\'\',concat (teacher.surname,\' \')),\n                ifNULL(teacher.name,\'\')\n            ),\n            \'\',\n            teacher.mobile,\n            teacher.phone1,\n            teacher.phone2\n        FROM teacher\n        WHERE teacher.id IN ($teachers)\n        ORDER BY teacher.surname,teacher.name\n        \";\n        \n$retval = nuRunQuery($sql);\n\nif($retval) {\n    if(db_num_rows($retval)>0) {\n    \n        print (\"\n        <table cellspacing=0 CLASS=\\\"sisTable\\\" align=center>\n            <tr height=35>\n                <th width=350 align=center>Καθηγητής</th>\n                \n                <th width=180 align=center>Κινητό<br>\n                    Όλα<input type=\\\"checkbox\\\" id=\\\"all_chk_1\\\" title=\\\"Επιλογή Όλων\\\" onclick=\\\"toggle(this,\'chk_1\')\\\">\n                    69...<input CLASS=\\\"chk_1\\\" type=\\\"checkbox\\\" id=\\\"all_chk_169\\\" title=\\\"Επιλογή Όλων των 69...\\\" onclick=\\\"toggle69(this,\'chk_1\')\\\">\n                </th>\n                \n                <th width=180 align=center>Τηλέφωνο 1<br>\n                    Όλα<input type=\\\"checkbox\\\" id=\\\"all_chk_2\\\" title=\\\"Επιλογή Όλων\\\" onclick=\\\"toggle(this,\'chk_2\')\\\">\n                    69...<input CLASS=\\\"chk_2\\\" type=\\\"checkbox\\\" id=\\\"all_chk_269\\\" title=\\\"Επιλογή Όλων των 69...\\\" onclick=\\\"toggle69(this,\'chk_2\')\\\">\n                </th>\n                \n                <th width=180 align=center>Τηλέφωνο 2<br>\n                    Όλα<input type=\\\"checkbox\\\" id=\\\"all_chk_3\\\" title=\\\"Επιλογή Όλων\\\" onclick=\\\"toggle(this,\'chk_3\')\\\">\n                    69...<input CLASS=\\\"chk_3\\\" type=\\\"checkbox\\\" id=\\\"all_chk_369\\\" title=\\\"Επιλογή Όλων των 69...\\\" onclick=\\\"toggle69(this,\'chk_3\')\\\">\n                </th>\n            </tr>\");\n        \n        while($row = db_fetch_row($retval)) {\n                \n            print (\"\n            <tr height=29>\n                <td align=left>\".(is_null($row[1]) || $row[1]==\'\'? \'&nbsp;\' : $row[1]).\"</td>\");\n                \n                if(!is_null($row[3]) && $row[3]!=\'\'){\n                    if($nb=validate_phone_number($row[3])){\n                        print(\"\n                <td align=right title=\\\"\".$nb.\"\\\">\".$row[3].\"<input type=\\\"checkbox\\\" CLASS=\\\"chk_1\\\" id=\\\"1_\".$row[0].\"_\".$nb.\"\\\" title=\\\"Επιλογή Τηλεφώνου\\\" onclick=\\\"make_indeterminate(\'all_chk_1\',\'\".$nb.\"\')\\\"></td>\");\n                    } else {\n                        print(\"\n                <td style=\\\"background-color:red;\\\" align=right>\".$row[3].\"</td>\");\n                    }   \n                } else{\n                    print(\"\n                <td>&nbsp;</td>\");    \n                }\n\n                if(!is_null($row[4]) && $row[4]!=\'\'){\n                    if($nb=validate_phone_number($row[4])){\n                        print(\"\n                <td align=right title=\\\"\".$nb.\"\\\">\".$row[4].\"<input type=\\\"checkbox\\\" CLASS=\\\"chk_2\\\" id=\\\"1_\".$row[0].\"_\".$nb.\"\\\" title=\\\"Επιλογή Τηλεφώνου\\\" onclick=\\\"make_indeterminate(\'all_chk_2\',\'\".$nb.\"\')\\\"></td>\");\n                    } else {\n                        print(\"\n                <td style=\\\"background-color:red;\\\" align=right>\".$row[4].\"</td>\");\n                    }   \n                } else{\n                    print(\"\n                <td>&nbsp;</td>\");    \n                }\n                \n                if(!is_null($row[5]) && $row[5]!=\'\'){\n                    if($nb=validate_phone_number($row[5])){\n                        print(\"\n                <td align=right title=\\\"\".$nb.\"\\\">\".$row[5].\"<input type=\\\"checkbox\\\" CLASS=\\\"chk_3\\\" id=\\\"1_\".$row[0].\"_\".$nb.\"\\\" title=\\\"Επιλογή Τηλεφώνου\\\" onclick=\\\"make_indeterminate(\'all_chk_3\',\'\".$nb.\"\')\\\"></td>\");\n                    } else {\n                        print(\"\n                <td style=\\\"background-color:red;\\\" align=right>\".$row[5].\"</td>\");\n                    }   \n                } else{\n                    print(\"\n                <td>&nbsp;</td>\");    \n                }\n                \n            print (\"\n            </tr>\");\n        }\n        \n        print (\"\n        </table>\");\n    } else{\n        print (\"<span CLASS=\\\"msg\\\">Δε βρέθηκαν Καθηγητές...</span>\");\n    }\n} else{\n    print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν δεδομένα...</span>\");\n}\nprint \"\n    </body>\n</html>\";\n','','0','2020-10-18 00:27:28','globeadmin','2020-10-18 00:36:26','globeadmin','2020-10-18 01:12:14','globeadmin','0'),('5f8b6c6f9011cfc','create_teacher_list_email','Δημιουργεί λίστα καθηγητών με τα email τους για μαζική αποστολή email','manager','print \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n        \n        <STYLE TYPE=\\\"text/css\\\">\n            .sisTable TH{\n                font-size:1.1em;\n            }\n        </STYLE>\n    </head>\n    <body onload=\\\"adjustIframeHeight()\\\">\";\n\n$sql=\"select email_recipients from session_variables WHERE session_id=\'#session_id#\'\";\n$retval = nuRunQuery($sql);\n$row = db_fetch_row($retval);\n$teachers = $row[0];\n\n$sql=\"  SELECT \n            teacher.id,\n            concat(\n                if(teacher.surname is NULL,\'\',concat (teacher.surname,\' \')),\n                ifNULL(teacher.name,\'\')\n            ),\n            \'\',\n            TRIM(teacher.email),\n            TRIM(zzzsys_user.sus_email)\n        FROM teacher\n        LEFT JOIN zzzsys_user ON teacher.user_id=zzzsys_user.zzzsys_user_id\n        WHERE teacher.id in ($teachers)\n        ORDER BY teacher.surname,teacher.name\n        \";\n\n\n$retval = nuRunQuery($sql);\n\nif($retval) {\n    if(db_num_rows($retval)>0) {\n    \n        print (\"\n        <table cellspacing=0 CLASS=\\\"sisTable\\\" align=center>\n            <tr height=50>\n                <th width=350 align=center>Καθηγητής</th>\n                <th width=300 align=center>Email Καθηγητή<br>\n                    Όλα<input type=\\\"checkbox\\\" id=\\\"all_chk_1\\\" title=\\\"Επιλογή Όλων\\\" onclick=\\\"toggle(this,\'chk_1\')\\\">\n                </th>\n                <th width=300 align=center>Email Λογαριασμού<br>\n                    Όλα<input type=\\\"checkbox\\\" id=\\\"all_chk_2\\\" title=\\\"Επιλογή Όλων\\\" onclick=\\\"toggle(this,\'chk_2\')\\\">\n                </th>\n            </tr>\");\n        \n        while($row = db_fetch_row($retval)) {\n                \n            print (\"  \n            <tr bgcolor=LightBlue height=30>\n                <td align=left>\".(is_null($row[1]) || $row[1]==\'\'? \'&nbsp;\' : $row[1]).\"</td>\");\n                \n                if(!is_null($row[3]) && $row[3]!=\'\'){\n                    if(filter_var($row[3], FILTER_VALIDATE_EMAIL)){\n                        print(\"\n                <td align=right>\".$row[3].\"<input type=\\\"checkbox\\\" CLASS=\\\"chk_1\\\" id=\\\"1,\".$row[0].\",\".$row[3].\"\\\" title=\\\"Επιλογή Email\\\" onclick=\\\"make_indeterminate(\'all_chk_1\')\\\"></td>\");\n                    } else {\n                        print(\"\n                <td style=\\\"background-color:red;\\\" align=right>\".$row[3].\"</td>\");\n                    }   \n                } else{\n                    print(\"\n                <td>&nbsp;</td>\");    \n                }\n\n                if(!is_null($row[4]) && $row[4]!=\'\'){\n                    if(filter_var($row[4], FILTER_VALIDATE_EMAIL)){\n                        print(\"\n                <td align=right>\".$row[4].\"<input type=\\\"checkbox\\\" CLASS=\\\"chk_2\\\" id=\\\"2,\".$row[0].\",\".$row[4].\"\\\" title=\\\"Επιλογή Email\\\" onclick=\\\"make_indeterminate(\'all_chk_2\')\\\"></td>\");\n                    } else {\n                        print(\"\n                <td style=\\\"background-color:red;\\\" align=right>\".$row[4].\"</td>\");\n                    }   \n                } else{\n                    print(\"\n                <td>&nbsp;</td>\");    \n                }\n            print (\"\n            </tr>\");\n        }\n        print (\"\n        </table>\");\n    } else{\n        print (\"<span CLASS=\\\"msg\\\">Δε βρέθηκαν Καθηγητές...</span>\");\n    }\n} else{\n    print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν δεδομένα...</span>\");\n}\nprint \"\n    </body>\n</html>\";\n','','0','2020-10-18 01:13:03','globeadmin','2020-10-18 01:14:21','globeadmin','2022-09-17 21:41:42','globeadmin','0'),('603804125b80c1b','absence_my_card_not_registered','Βρίσκει τις διδασκαλίες του καθηγητή για τις οποίες δεν έχουν καταχωρηθεί απουσίες','teacher','function createDateRangeArray($strDateFrom,$strDateTo) {\n    $sql=\"  select holiday.holiday \n            from holiday\n            inner join school_year on holiday.school_year_id=school_year.id\n            inner join school on school.school_year_id = school_year.id\";\n    $retval=nuRunQuery($sql);\n    \n    $holiday_array = array();\n    while($row=db_fetch_row($retval)){\n        array_push($holiday_array,$row[0]);\n    }\n    \n    $sql=\"select id from day\";\n    $retval=nuRunQuery($sql);\n    \n    $day_array = array();\n    while($row=db_fetch_row($retval)){\n        array_push($day_array,$row[0]);\n    }\n    \n    $aryRange=array();\n\n    $iDateFrom=mktime(1,0,0,substr($strDateFrom,5,2),     substr($strDateFrom,8,2),substr($strDateFrom,0,4));\n    $iDateTo=mktime(1,0,0,substr($strDateTo,5,2),     substr($strDateTo,8,2),substr($strDateTo,0,4));\n\n    if ($iDateTo>=$iDateFrom)\n    {\n    \n        $day_of_week = idate(\'w\', strtotime(date(\'Y-m-d\',$iDateTo)))-1;\n        if(in_array($day_of_week,$day_array)){\n                array_push($aryRange,date(\'Y-m-d\',$iDateTo)); // first entry\n            }\n    \n        while ($iDateFrom<$iDateTo)\n        {\n            $iDateTo-=86400; // add 24 hours\n            \n            $day_of_week = idate(\'w\', strtotime(date(\'Y-m-d\',$iDateTo)))-1;\n            if(in_array($day_of_week,$day_array)){\n                array_push($aryRange,date(\'Y-m-d\',$iDateTo));\n            }\n        }\n    }\n    return array_diff($aryRange, $holiday_array);\n}\n\nprint \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">                \n                \n        <STYLE TYPE=\\\"text/css\\\">\n        .sisTable, .sisTable TD{\n                    font-size:7pt;\n                }\n        .sisTable TH{\n                    font-size:8pt;\n                }\n        </STYLE>\n\n    </head>\n\n    <body>\";\n\n$sql =\" SELECT CURDATE(),start_date\n        FROM school\n        INNER JOIN school_year ON school_year.id = school.school_year_id\n        WHERE school.id=1\";\n$retval=nuRunQuery($sql);\n$row = db_fetch_row($retval);\n\n$to_date = $row[0];\n$from_date = $row[1];\n$today = date(\'Y-m-d\');\n$time = date(\"H:i:s\");\n\n$days = createDateRangeArray($from_date,$to_date);\n        \nprint (\"\n        <table border=1  cellspacing=0 CLASS=\\\"sisTable\\\" align=center>\n            <tr height=45>\n                <th width=80 align=center>Ημερομηνία</th>\n                <th width=80 align=center>Ημέρα</th>\n                <th width=50 align=center>Ώρα</th>\n                <th width=50 align=center>Τμήμα</th>\n                <th width=180 align=center>Μάθημα</th>\n                <th width=130 align=center>Καθηγητής</th>\n                <th width=50 align=center>Αίθουσα</td>\n                <th width=130 align=center>Καταχωρητής</th>\n            </tr>\");\n        \n       \n    foreach ($days as $absence_date) {\n            \n        $day_of_week = idate(\'w\', strtotime($absence_date))-1;\n                                \n        $sql=\"select max(valid_from) from card where valid_from<=\'\".$absence_date.\"\'\"; \n        $retval=nuRunQuery($sql);\n        $row = db_fetch_row($retval);\n        $card_date=$row[0];\n\n        $sql=\"  SELECT \n                        card.id,\n                        day.name,\n                        period.short_name,\n                        class.short_name,\n                        subject.name,\n                        t1.short_name,\n                        classroom.short_name,\n                        t2.short_name\n                FROM card\n                        INNER JOIN      teacher as t1   on      card.teacher_id=t1.id\n                        INNER JOIN      subject         on      card.subject_id=subject.id\n                        INNER JOIN      class           on      card.class_id=class.id\n                        INNER JOIN      period          on      card.period_id=period.id\n                        INNER JOIN      day             on      card.day_id=day.id\n                        LEFT JOIN       classroom       on      card.classroom_id=classroom.id\n                        LEFT JOIN       teacher as t2   on      class.post_teacher_id=t2.id\n                WHERE\n                        valid_from=\'\".$card_date.\"\' and\n                        day_id=\".(idate(\'w\', strtotime($absence_date))-1).\" and\n                        card.id not in (SELECT card_id FROM registered_card WHERE card_date=\'$absence_date\')\n                        AND  t1.id = \'#RECORD_ID#\'\";\n           $sql .= ($absence_date==$today ? \"\n                        AND period.end_time <= \'$time\'\" : \'\');\n            $sql .=\"            \n                ORDER BY \n                        period.id DESC,class.short_name,t1.short_name\";\n                               \n        $retval=nuRunQuery($sql);\n            \n        if($retval){\n            if(db_num_rows($retval)>0){\n                while($row = db_fetch_row($retval)) {\n                    print (\"\n            <tr height=35>\n                <td align=center>\".date(\"d-m-Y\",strtotime($absence_date)).\"</td>\n                <td align=center>\".(is_null($row[1]) || $row[1]==\'\'? \'&nbsp;\' : $row[1]).\"</td>\n                <td align=center>\".(is_null($row[2]) || $row[2]==\'\'? \'&nbsp;\' : $row[2]).\"</td>\n                <td align=center>\".(is_null($row[3]) || $row[3]==\'\'? \'&nbsp;\' : $row[3]).\"</td>\n                <td align=left>\".(is_null($row[4]) || $row[4]==\'\'? \'&nbsp;\' : $row[4]).\"</td>\n                <td align=left>\".(is_null($row[5]) || $row[5]==\'\'? \'&nbsp;\' : $row[5]).\"</td>\n                <td align=center>\".(is_null($row[6]) || $row[6]==\'\'? \'&nbsp;\' : $row[6]).\"</td>\n                <td align=left>\".(is_null($row[7]) || $row[7]==\'\'? \'&nbsp;\' : $row[7]).\"</td>\n            </tr>\");                    \n                }\n            } \n        } else{\n            $message=\"Παρουσιάστηκε σφάλμα κατά την ανάκτηση των δεδομένων...\";\n            nudebug($message);\n        }    \n    }\n\nprint \"\n    </body>\n</html>\";','','0','2021-02-25 22:09:54','globeadmin','2021-02-27 10:00:11','globeadmin','2021-03-08 08:18:49','globeadmin','0'),('6039488575f57d2','absence_has_card_not_registered','Βρίσκει αν ο καθηγητής έχει διδασκαλίες που δεν έχουν καταχωριστεί','teacher','function createDateRangeArray($strDateFrom,$strDateTo) {\n    $sql=\"  select holiday.holiday \n            from holiday\n            inner join school_year on holiday.school_year_id=school_year.id\n            inner join school on school.school_year_id = school_year.id\";\n    $retval=nuRunQuery($sql);\n    \n    $holiday_array = array();\n    while($row=db_fetch_row($retval)){\n        array_push($holiday_array,$row[0]);\n    }\n    \n    $sql=\"select id from day\";\n    $retval=nuRunQuery($sql);\n    \n    $day_array = array();\n    while($row=db_fetch_row($retval)){\n        array_push($day_array,$row[0]);\n    }\n    \n    $aryRange=array();\n\n    $iDateFrom=mktime(1,0,0,substr($strDateFrom,5,2),     substr($strDateFrom,8,2),substr($strDateFrom,0,4));\n    $iDateTo=mktime(1,0,0,substr($strDateTo,5,2),     substr($strDateTo,8,2),substr($strDateTo,0,4));\n\n    if ($iDateTo>=$iDateFrom)\n    {\n    \n        $day_of_week = idate(\'w\', strtotime(date(\'Y-m-d\',$iDateTo)))-1;\n        if(in_array($day_of_week,$day_array)){\n                array_push($aryRange,date(\'Y-m-d\',$iDateTo)); // first entry\n            }\n    \n        while ($iDateFrom<$iDateTo)\n        {\n            $iDateTo-=86400; // add 24 hours\n            \n            $day_of_week = idate(\'w\', strtotime(date(\'Y-m-d\',$iDateTo)))-1;\n            if(in_array($day_of_week,$day_array)){\n                array_push($aryRange,date(\'Y-m-d\',$iDateTo));\n            }\n        }\n    }\n    return array_diff($aryRange, $holiday_array);\n}\n\n$sql =\" SELECT CURDATE(),start_date\n        FROM school\n        INNER JOIN school_year ON school_year.id = school.school_year_id\n        WHERE school.id=1\";\n$retval=nuRunQuery($sql);\n$row = db_fetch_row($retval);\n\n$to_date = $row[0];\n$from_date = $row[1];\n$today = date(\'Y-m-d\');\n$now = date(\"H:i:s\");\n\n$days = createDateRangeArray($from_date,$to_date);\n$total = 0; \n\nforeach ($days as $absence_date) {\n            \n        $day_of_week = idate(\'w\', strtotime($absence_date))-1;\n                                \n        $sql=\"select max(valid_from) from card where valid_from<=\'\".$absence_date.\"\'\"; \n        $retval=nuRunQuery($sql);\n        $row = db_fetch_row($retval);\n        $card_date=$row[0];\n\n        $sql=\"  SELECT \n                        COUNT(card.id)\n                FROM card\n                INNER JOIN period ON card.period_id=period.id\n                INNER JOIN session_variables ON session_variables.session_id = \'#session_id#\'\n                WHERE\n                    card.valid_from=\'$card_date\' AND\n                    card.day_id=\".(idate(\'w\', strtotime($absence_date))-1).\" AND\n                    card.id not in (SELECT card_id FROM registered_card WHERE card_date=\'$absence_date\')  AND \n                    card.teacher_id = session_variables.teacher_id AND\n                    card.class_id IS NOT NULL\";\n           $sql .= ($absence_date==$today ? \"\n                    AND period.end_time <= \'$now\'\" : \'\');                               \n        $retval=nuRunQuery($sql);\n            \n        if($retval && $row = db_fetch_row($retval)) $total+=$row[0];\n}\n\n$nuParameters = $total;','','0','2021-02-26 21:14:13','globeadmin','2021-03-08 08:20:22','globeadmin','2021-03-08 08:20:22','globeadmin','0'),('6176a844969aad4','search_reward','Αναζήτηση Επιβραβεύσεων','Teacher','print \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n        \n        <script type=\\\"text/javascript\\\">\n            function show_reward_info(reward_id){\n                parent.nuOpenFormInFrame(\'\', reward_id)    \n            }\n        </script>\n    </head>\n\n    <body onload=\\\"adjustIframeHeight()\\\">\";\n    \n$sql=\"DROP TEMPORARY TABLE IF EXISTS #TABLE_ID#\";\nnuRunQuery($sql);\n\n$sql=\"CREATE TEMPORARY TABLE #TABLE_ID# DEFAULT CHARACTER SET=utf8\n        SELECT \n            reward.id AS reward_id,\n            reward.date_enforced AS reward_date_enforced,\n            period.short_name AS period_short_name,\n            concat(grade.short_name,\'-\',student.surname,\' \',student.name,\' πατ. \',student.fathers_name) AS student_full_name,\n            reward_type.name AS reward_type_name,\n            comments,\n            concat(if(teacher.surname is null,\'\',concat(teacher.surname,\' \')), IFNULL(teacher.name,\'\')) AS teacher_full_name,\n            student.id AS student_id,\n            grade.short_name AS grade_short_name,\n            reward.number_of_medals AS reward_number_of_medals,\n            subject.short_name AS subject_short_name\n        FROM reward\n            INNER JOIN student          ON  reward.student_id               = student.id\n            INNER JOIN grade            ON  grade.id                        = student.grade_id\n            INNER JOIN reward_type      ON  reward_type.id                  = reward.reward_type_id\n            INNER JOIN teacher          ON  reward.teacher_id               = teacher.id\n            LEFT JOIN period            ON  reward.period_id                = period.id\n            LEFT JOIN subject           ON  reward.subject_id               = subject.id\";\n            \n$sql=$sql.\"            \n        WHERE\n\";\n\nif(\'#class_id_sumo#\'!=\'#\'.\'class_id_sumo#\' && \'#class_id_sumo#\'!=\'\'){\n    $sql=$sql.\" \n            student.id IN (SELECT DISTINCT student_id FROM student_class WHERE class_id IN (#class_id_sumo#)) AND\";\n} \n\n\nif(\'#from_date#\'!=\'#\'.\'from_date#\' && \'#from_date#\'!=\'\'){\n    $sql=$sql.\" reward.date_enforced >= \'#from_date#\' and \n    \";\n}\nif(\'#to_date#\'!=\'#\'.\'to_date#\' && \'#to_date#\'!=\'\'){\n    $sql=$sql.\" reward.date_enforced <= \'#to_date#\' and \n    \";\n}\n\nif(\'#student_id_sumo#\'!=\'#\'.\'student_id_sumo#\' && \'#student_id_sumo#\'!=\'\'){\n    $sql=$sql.\" student.id IN (#student_id_sumo#) and \n    \";\n    $is_student=1;\n}\n\nif(\'#teacher_id_sumo#\'!=\'#\'.\'teacher_id_sumo#\' && \'#teacher_id_sumo#\'!=\'\'){\n    $sql=$sql.\" reward.teacher_id IN (#teacher_id_sumo#) and \n    \";\n}\n\nif(\'#reward_type_id_sumo#\'!=\'#\'.\'reward_type_id_sumo#\' && \'#reward_type_id_sumo#\'!=\'\'){\n    $sql=$sql.\" reward.reward_type_id IN (#reward_type_id_sumo#) and \n    \";\n}\n\nif(\'#subject_id_sumo#\'!=\'#\'.\'subject_id_sumo#\' && \'#subject_id_sumo#\'!=\'\'){\n    $sql=$sql.\" reward.subject_id IN (#subject_id_sumo#) and \n    \";\n}\n\n$sql=$sql.\"\n    1=1\n    order by grade.short_name,student.surname,student.name,student.fathers_name,reward.date_enforced,reward.period_id\n\";\n\nnuRunQuery($sql);\n\n$sql=\"DROP TEMPORARY TABLE IF EXISTS #TABLE_ID#total\";\nnuRunQuery($sql);\n\n$sql=\"CREATE TEMPORARY TABLE #TABLE_ID#total DEFAULT CHARACTER SET=utf8\n        SELECT student_id, COUNT(*) AS cnt, SUM(reward_number_of_medals) AS total_medals\n        FROM #TABLE_ID#\n        GROUP BY student_id\n    \";\nnuRunQuery($sql);\n\n$sql = \"SELECT * FROM #TABLE_ID#total ORDER BY total_medals DESC\";\n\n\n/*$sql=\"  SELECT #TABLE_ID#.*, #TABLE_ID#total.cnt, #TABLE_ID#total.total_medals\n        FROM #TABLE_ID# \n        INNER JOIN #TABLE_ID#total ON #TABLE_ID#.student_id = #TABLE_ID#total.student_id\n        WHERE 1\";*/\n        \n$retval=nuRunQuery($sql);\n\nif($retval) {\n    if(db_num_rows($retval)>0) {\n    \n        print (\"\n        <table cellspacing=0 CLASS=\\\"sisTable\\\">\n            <tr height=45>\n                <th width=80 align=center>Ημ/νία</th>\n                <th width=50 align=center>Διδ. Ώρα</th>\n                <th width=100 align=center>Μάθημα</th>\n                <th width=220 align=center>Λόγος Επιβράβευσης</th>\n                <th width=200 align=center>Σχόλια</th>\n                <th width=150 align=center>Καθηγητής /<br> Πλήθος Επιβραβεύσεων</th>\n                <th width=100 align=center>Αριθμός Μεταλλίων</th>\n            </tr>\n        </table><br>\");\n        \n        \n        $color1 =\'LightSkyBlue\';\n        $color2 =\'#48D1CC\';\n        \n        $color = $color2;\n        \n        while($row = db_fetch_row($retval)) {\n        \n            $sql = \"SELECT * FROM #TABLE_ID# WHERE student_id = \".$row[0].\" ORDER BY reward_date_enforced\";\n            $rv = nuRunQuery($sql);\n\n\n            if(db_num_rows($rv) > 0) {\n                \n                $color = ($color == $color1 ? $color2 : $color1);\n            \n                $r = db_fetch_row($rv);\n                \n                print (\"\n        <table cellspacing=0 CLASS=\\\"sisTable\\\">\n            <tr style=\\\"background-color:$color;\\\" height=35>\n                <td width=650 colspan=5 align=left><b>\".(is_null($r[3]) || $r[3]==\'\'? \'&nbsp;\' : $r[3]).\"</b></td>\n                <td width=150 align=center><b>{$row[1]}</b></td>\n                <td width=100 align=center><b>{$row[2]}</b></td>\n            </tr>\"); \n            \n            \n        \n                do {\n                    print (\"\n            <tr style=\\\"background-color:$color;\\\" height=35>\n                <td width=80 align=center>\".    (is_null($r[1])  || $r[1]==\'\' ? \'&nbsp;\' : $r[1]).\"</td>\n                <td width=50 align=center>\".    (is_null($r[2])  || $r[2]==\'\' ? \'&nbsp;\' : $r[2]).\"</td>\n                <td width=100 align=left>\".     (is_null($r[10]) || $r[10]==\'\'? \'&nbsp;\' : $r[10]).\"</td>\n                <td width=220 align=left>\".     (is_null($r[4])  || $r[4]==\'\' ? \'&nbsp;\' : $r[4]).\"</td>\n                <td width=200 align=left>\".     (is_null($r[5])  || $r[5]==\'\' ? \'&nbsp;\' : $r[5]).\"</td>\n                <td width=150 align=left>\".     (is_null($r[6])  || $r[6]==\'\' ? \'&nbsp;\' : $r[6]).\"</td>\n                <td width=100 align=center>\".   (is_null($r[9])  || $r[9]==\'\' ? \'&nbsp;\' : $r[9]).\"</td>\n             </tr>\");                \n                } while($r = db_fetch_row($rv));\n                \n                print(\"\n        </table><br>\");\n            }\n        }\n        \n        print (\"\n        </table>\");\n    }\n    else{\n        print (\"<span CLASS=\\\"msg\\\">Δε βρέθηκαν επιβραβεύσεις...</span>\");\n    }\n}\nelse{\n    print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν δεδομένα...</span>\");\n}\nprint \"\n    </body>\n</html>\";\n','','0','2021-10-25 15:51:16','globeadmin','2022-01-07 20:23:19','globeadmin','2022-02-11 22:48:06','globeadmin','0'),('61d954057af2530','reward_student_show','Εμφανίζει τις επιβραβεύσεις του μαθητή','student','print \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n        \n        <STYLE TYPE=\\\"text/css\\\">\n            .sisTableLine TH{\n                font-size:8pt;\n            }\n             .sisTableLine TD{\n                font-weight: normal;\n                font-size:8pt;\n            }           \n\n            .sisTableLine tr:nth-child(even){\n	            background-color: LightSteelBlue;\n            }\n        </STYLE>\n    \n    </head>\n\n    <body onload=\\\"adjustIframeHeight()\\\">\";\n\n$sql=\"  SELECT \n            reward.date_enforced,\n            \n            ifNULL(period.name,\'\'),\n            ifNULL(subject.name,subject.short_name),\n            \n            reward_type.name,\n            reward.comments,\n            reward.number_of_medals,\n            \n            if(reward.teacher_id IS NULL,\'\',concat(ifNULL(teacher.surname,\'\'),if(teacher.surname IS NOT NULL AND teacher.name IS NOT NULL,\' \',\'\'),ifNULL(teacher.name,\'\')))\n        FROM reward\n        INNER JOIN reward_type ON reward_type.id = reward.reward_type_id\n        LEFT JOIN period ON reward.period_id=period.id\n        LEFT JOIN teacher ON teacher.id = reward.teacher_id\n        LEFT JOIN subject ON reward.subject_id = subject.id \n        WHERE student_id=#RECORD_ID# \n        ORDER BY date_enforced\";\n        \n$retval=nuRunQuery($sql);\n\nif($retval) {\n    if(db_num_rows($retval)>0) {\n    \n        print (\"\n        <table CLASS=\\\"sisTableLine\\\" cellspacing=0 width=100%>\n            <tr height=35>\n                <th width=40 align=center>A/A</th>\n                <th width=70 align=center>Ημερομηνία</th>\n                <th width=60 align=center>Ώρα</th>\n                <th width=160 align=center>Μάθημα</th>\n                <th width=180 align=center>Τύπος</th>\n                <th width=270 align=center>Σχόλια</td>\n                <th width=70 align=center>Μετάλλια</td>\n                <th width=150 align=center>Καθηγητής</th>\n            </tr>\");\n            \n        $j=1;\n        $m=0;\n    \n        while($row = db_fetch_row($retval)) {\n        \n            print (\"\n            <tr  height=25>\n                <td align=center>\".$j.\"</td>\n                <td align=center>\".date_format(date_create_from_format(\"Y-m-d\",$row[0]),\"d-m-Y\").\"</td>\n                <td align=center>\".(is_null($row[1]) || $row[1]==\'\'? \'&nbsp;\' : $row[1]).\"</td>\n                <td align=center>\".(is_null($row[2]) || $row[2]==\'\'? \'&nbsp;\' : $row[2]).\"</td>\n                <td align=left>\".(is_null($row[3]) || $row[3]==\'\'? \'&nbsp;\' : $row[3]).\"</td>\n                <td align=center>\".(is_null($row[4]) || $row[4]==\'\'? \'&nbsp;\' : $row[4]).\"</td>\n                <td align=center><b>\".(is_null($row[5]) || $row[5]==\'\'? \'&nbsp;\' : $row[5]).\"</b></td>\n                <td align=center>\".(is_null($row[6]) || $row[6]==\'\'? \'&nbsp;\' : $row[6]).\"</td>\n            </tr>\");\n            $j++;\n            $m +=$row[5];\n        }\n        \n        print (\"\n            <tr  height=25>\n                <th align=right colspan=6>Πλήθος Μεταλλίων :</th>\n                <th align=center><span style=\\\"font-size:10pt;\\\">$m</span></th>\n                <th align=left><img src=\\\"images/medal.png\\\" width=24 height=24></th>\n            </tr>\");\n        print (\"\n        </table>\");\n    }\n    else{\n        print (\"<span CLASS=\\\"msgSuccess\\\">Δεν έχουν απονεμηθεί επιβραβεύσεις!</span>\");\n    }\n}\nelse{\n    print (\"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν δεδομένα...</span>\");\n}\nprint \"\n    </body>\n</html>\";\n','','0','2022-01-08 11:06:13','globeadmin','2022-01-09 12:29:54','globeadmin','2022-01-09 12:29:54','globeadmin','0'),('6206b6bc29d3be4','absences_compare','Συγκρίνει τις απουσίες που περιέχονται στο αρχείο excel με τις απουσίες στο σύστημα','Manager','require_once(\'Classes/PHPExcel.php\');\n\nfunction getCellDate($data){\n    \n    if (is_null($data) || $data == \"\") return \"\";\n    \n    if(strtotime($data)){\n        $st = strtotime($data);\n        return date(\'Y-m-d\',$st);    \n    } else if(PHPExcel_Shared_Date::isDateTime($data)) {\n        $cellValue = $data->getValue();\n        $dateValue = PHPExcel_Shared_Date::ExcelToPHP($cellValue);                       \n        return date(\'Y-m-d\',$dateValue);                          \n    } else {                        \n        return \"\";                                                   \n    } \n}\n\nprint \"<html>\n    <head>\n        <meta charset=\\\"UTF-8\\\">\n        <script src=\\\"sisIframe.js\\\"></script>\n        <link rel=\\\"stylesheet\\\" type=\\\"text/css\\\" href=\\\"sisIframe.css\\\">\n\n        <STYLE TYPE=\\\"text/css\\\">\n            .sisTable, .sisTable TD {\n                font-size:7pt;\n            }\n            .sisTable TH {\n                font-size:7pt;\n            }\n        </STYLE>\n    </head>\n    <body onload=\\\"adjustIframeHeight()\\\">\";\n\nif(\'#FILES#\'!=\'\') {    \n//fetch the uploaded file information\n    $S = stripslashes(\'#FILES#\');\n    $J = json_decode($S);\n\n    if (json_last_error() === JSON_ERROR_NONE) {\n        $name = $J[0]->{\'name\'};\n        $type = $J[0]->{\'type\'};\n        $error = $J[0]->{\'error\'};\n        $size  = $J[0]->{\'size\'};\n\n        $uploaddir= sys_get_temp_dir();\n        $uploadfile = $uploaddir .\'/\'.$name;\n\n        $inputFileName = $uploadfile;\n\n        $objPHPExcel = PHPExcel_IOFactory::load($inputFileName);\n        $objWorksheet = $objPHPExcel->getActiveSheet();\n        $highestRow = $objWorksheet->getHighestRow(); \n      \n        $sql=\"CREATE TEMPORARY TABLE IF NOT EXISTS #TABLE_ID# (\n                registration_number VARCHAR(100) NULL,\n                absence_date DATE NULL,\n                read_an_justified_absences INT NULL,\n                read_justified_absences INT NULL\n                ) ENGINE=MEMORY  DEFAULT CHARSET=utf8\";\n        $retval = nuRunQuery($sql);\n\n        $sql=\"DELETE FROM #TABLE_ID# WHERE 1\";\n        $retval = nuRunQuery($sql);\n\n        $lines_ignored = 0;\n        $curValueA = \'\';\n        \n        for ($row = 1; $row <= $highestRow; ++$row) {\n\n            $cellValueA = $objWorksheet->getCell(\'A\'.$row)->getFormattedValue();\n            $cellValueB = getCellDate($objWorksheet->getCell(\'B\'.$row));\n            $cellValueC = $objWorksheet->getCell(\'C\'.$row)->getFormattedValue();\n            $cellValueD = $objWorksheet->getCell(\'D\'.$row)->getFormattedValue();\n            \n            $curValueA = (is_null($cellValueA) || $cellValueA == \'\' ? $curValueA : $cellValueA);\n\n            if(is_numeric($curValueA) && $cellValueB != \"\" && is_numeric($cellValueC) && is_numeric($cellValueD)){\n                $sql=\"INSERT INTO #TABLE_ID# VALUES ($curValueA,\'\".$cellValueB.\"\', $cellValueC,$cellValueD)\"; \n                nuRunQuery($sql);\n            } else {\n                $lines_ignored++; \n            }\n        }\n        \n        $sql=\"SELECT * FROM #TABLE_ID#\";\n        $retval = nuRunQuery($sql);\n        \n        if( $retval && db_num_rows($retval) > 0) {\n            print (\"\n        <table cellspacing=0 CLASS=\\\"sisTable\\\">\n            <tr height=40>\n                <th width=35 align=center>A/A</th>\n                <th width=40 align=center>Τάξη</th>\n                <th width=50 align=center>A.M.</th> \n                <th width=150 align=center>Επώνυμο</th>\n                <th width=120 align=center>Όνομα</th>\n                <th width=120 align=center>Πατρώνυμο</th>\n                <th width=80 align=center>Ημερομηνία Απουσιών</th>\n                <th width=70 align=center style=\\\"border-left-width:medium;\\\">Σίσυφος Αδικ/γητες</th>\n                <th width=70 align=center>Σίσυφος Δικ/μένες</th>\n                <th width=70 align=center style=\\\"border-left-width:medium;\\\">Αρχείο Αδικ/γητες</th>\n                <th width=70 align=center>Αρχείο Δικ/μένες</th>\n            </tr>\"); \n            \n            $color_not_found = \'#FCBBFC\';\n            $color_diff = \'#ff9a9a\';\n            $color_diff_dark = \'#ff7070\';\n            $color_diff_just = \'#c2d1e6\';\n            $color_diff_just_dark = \'#9eb6d7\';\n            $color_ok = \'LightGreen\';\n            \n            \n            $i = 1;\n            \n            while($row = db_fetch_row($retval)) {\n            \n                $registration_number        = $row[0];\n                $absence_date               = $row[1];\n                $read_an_justified_absences = $row[2];\n                $read_justified_absences    = $row[3];\n                \n                $student_id             = \'\';\n                $student_surname        = \'\';\n                $student_name           = \'\';\n                $student_fathers_name   = \'\';\n                $stdent_grade           = \'\';\n                $an_justified_absences  = \'\';\n                $justified_absences     = \'\';\n            \n                $sql = \"SELECT \n                            student.id,\n                            student.surname,\n                            student.name,\n                            ifNULL(fathers_name,\'\'),\n                            grade.short_name\n                        FROM student\n                        INNER JOIN grade ON grade.id = student.grade_id\n                        WHERE student.registration_number = {$row[0]}\";\n                $rv1 = nuRunQuery($sql);\n                \n                if( $rv1 && db_num_rows($rv1) == 1) {\n                    \n                    $student_row = db_fetch_row($rv1);\n                    \n                    $student_id             = $student_row[0];\n                    $student_surname        = $student_row[1];\n                    $student_name           = $student_row[2];\n                    $student_fathers_name   = $student_row[3];\n                    $stdent_grade           = $student_row[4];\n                    \n                    $sql=\"  SELECT \n                                ifNULL(sum(if(counts is null,0,counts)),0) as a,\n                                ifNULL(sum(if((justified = 1 and justified_reason_id <> 3), 1, 0)), 0) as d\n                            FROM absence\n                            WHERE\n                                absence_date=\'{$row[1]}\' AND\n                                student_id = \'$student_id\'\";\n                                \n                    $rv2 = nuRunQuery($sql);\n                    \n                    if( $rv2 && db_num_rows($rv2) == 1) {\n                        $absence_row = db_fetch_row($rv2);\n                        $an_justified_absences  = $absence_row[0];\n                        $justified_absences     = $absence_row[1];\n                    }\n                }\n            \n                // print row\n                $color = ($student_id == \'\' ? $color_not_found : ($an_justified_absences != $read_an_justified_absences ? $color_diff : ($justified_absences != $read_justified_absences ? $color_diff_just : $color_ok)));\n                $color_dark = ($student_id == \'\' ? $color_not_found : ($an_justified_absences != $read_an_justified_absences ? $color_diff_dark : ($justified_absences != $read_justified_absences ? $color_diff_just_dark : $color_ok)));\n                print (\"\n            <tr style=\\\"background-color:$color;\\\" height=27>\n                <td align=center>$i</td>\n                <td align=center>$stdent_grade</td>\n                <td align=center>$registration_number</td>\n                <td align=left>$student_surname</td>\n                <td align=left>$student_name</td>\n                <td align=left>$student_fathers_name</td>\n                <td align=center>\".date(\'d-m-Y\',strtotime($absence_date)).\"</td>\n                <td align=center  style=\\\"border-left-width:medium;\".($an_justified_absences != $read_an_justified_absences ? \"background-color:$color_dark;font-weight: bold;text-decoration: underline;\\\"\": \"\\\"\").\">$an_justified_absences</td>\n                <td align=center\".($justified_absences != $read_justified_absences ? \" style=\\\"background-color:$color_dark;text-decoration: underline;\\\"\": \"\").\">$justified_absences</td>\n                <td align=center style=\\\"border-left-width:medium;\".($an_justified_absences != $read_an_justified_absences ? \"background-color:$color_dark;font-weight: bold;text-decoration: underline;\\\"\": \"\\\"\").\">$read_an_justified_absences</td>\n                <td align=center\".($justified_absences != $read_justified_absences ? \" style=\\\"background-color:$color_dark;text-decoration: underline;\\\"\": \"\").\">$read_justified_absences</td>\n             </tr>\");\n             // ($color == $an_justified_absences ? \" style=\\\"background-color:$color_diff_dark;\\\"\": \"\")\n             $i++;\n            }\n            \n            print (\"\n        </table>\"); \n        \n        if($lines_ignored > 0) \n            print \"<br><span CLASS=\\\"msg\\\"><u>$lines_ignored</u> εγγραφές στο αρχείο excel αγνοήθηκαν!</span>\"; \n        \n        } else {\n            print \"><span CLASS=\\\"msgError\\\">Δεν βρέθηκαν εγγραφές στο αρχείο...</span>\";    \n        }\n    \n    } else {\n        nuDebug(\'Read Absence from Excel : JSON ERROR -> #FILES# -> \'.$S);\n        $nuError = \"Παρουσιάστηκε σφάλμα κατά την εισαγωγή του αρχείου!\\nΤα Σύνολα των απουσιών δεν εισήχθησαν από το αρχείο Excel!\";\n    }    \n} else {\n    print \"<span CLASS=\\\"msgError\\\">Δεν ανακτήθηκαν δεδομένα...</span>\";\n}\n\nprint \"\n    </body>\n</html>\";\n    ','','0','2022-02-11 21:19:24','globeadmin','2022-02-13 11:50:19','globeadmin','2022-02-13 11:50:20','globeadmin','0'),('632616c802a9663','teacher_mail_not_registered_cards','Στέλνει μαιλ στους καθηγητές που δεν έχουν καταχωρίσει όλες τις απουσίες τους σήμερα','manager','use PHPMailer\\PHPMailer\\PHPMailer;\nuse PHPMailer\\PHPMailer\\Exception;\n\nrequire \'PHPMailer/src/Exception.php\';\nrequire \'PHPMailer/src/PHPMailer.php\';\nrequire \'PHPMailer/src/SMTP.php\';\n\nnuRunPHP(\"sisyphos_lib\");\n\nfunction my_esc($str){\n    $db_params = nuRunQuery();\n    $link = mysqli_connect($db_params[0], $db_params[2], $db_params[3], $db_params[1]);\n\n    if (mysqli_connect_errno()) {\n        nuDebug(\"Connect failed: %s\\n\", mysqli_connect_error());\n        return \'\';\n    }\n    return(mysqli_real_escape_string($link,$str));\n}\n\nfunction nextID($table_name,$temp_key){\n\n    $temp_id    = nuID();\n	\n    $sql        = \"INSERT IGNORE $table_name SET $temp_key =  \'$temp_id\'\";        //-- insert to create next number\n    nuRunQuery($sql);\n    \n    $sql        = \"SELECT id FROM $table_name WHERE $temp_key = \'$temp_id\'\";    //-- get next number\n    $retval     = nuRunQuery($sql);\n    $row        = db_fetch_row($retval);\n	\n	$sql        = \"UPDATE $table_name SET $temp_key = NULL WHERE id = \'\".$row[0].\"\'\"; \n	nuRunQuery($sql);\n	\n    return $row[0];                                                        	    //-- return next number\n}\n\n$system_url = get_system_url();\n$school_name = get_school_name();\n\n$setup                      = $GLOBALS[\'nuSetup\'];                                      //-- Read SMTP AUTH Settings from zzsys_setup table	\n\nif (!empty($setup->set_smtp_username))          { $setup->set_smtp_username = trim($setup->set_smtp_username);}                       else{$errorText .= \"SMTP Username not set.<br>\";}\nif (!empty($setup->set_smtp_password)) 	        { $setup->set_smtp_password = trim($setup->set_smtp_password);}                       else{$errorText .= \"SMTP Password not set.<br>\";}\nif (!empty($setup->set_smtp_host))              { $setup->set_smtp_host = trim($setup->set_smtp_host);}                               else{$errorText .= \"SMTP Host not set.<br>\";}\nif (!empty($setup->set_smtp_from_address))      { $setup->set_smtp_from_address = trim($setup->set_smtp_from_address);}               else{$errorText .= \"SMTP From Address not set.<br>\";}\nif (!empty($setup->set_smtp_port))              { $setup->set_smtp_port = intval($setup->set_smtp_port);}                             else{$errorText .= \"SMTP PORT not set.<br>\";}\nif (!empty($setup->set_smtp_use_ssl))           { $setup->set_smtp_use_ssl = trim($setup->set_smtp_use_ssl);}                         else{$setup->set_smtp_use_ssl = \'\';}\nif (!empty($setup->set_smtp_from_name))         { $SMTPname = trim($setup->set_smtp_from_name);}	                              else{$SMTPname = \"nuBuilder\";}\n\nif ($errorText == \'\'){// Όλα καλά! Οι ρυθμίσεις είναι ΟΚ, να σταλουν οι ειδοποιήσεις\n\n    $absence_date = date(\"Y-m-d\");\n    $day_of_week = idate(\'w\', strtotime($absence_date))-1;\n                                \n    $sql=\"select max(valid_from) from card where valid_from<=\'\".$absence_date.\"\'\"; \n    $retval=nuRunQuery($sql);\n    $row = db_fetch_row($retval);\n    $card_date=$row[0];\n\n    if(\'#TABLE_ID#\' != \'#\'.\'TABLE_ID\'.\'#\' && \'#TABLE_ID#\' != \'\'){\n        $tmp_table=\'#TABLE_ID#\';\n    } else {\n        $tmp_table=\'__\'.nuID().\'__\';\n    }\n\n    $sql=\"DROP TEMPORARY TABLE IF EXISTS $tmp_table\";\n    nuRunQuery($sql);\n\n    $sql=\"  CREATE TEMPORARY TABLE $tmp_table DEFAULT CHARACTER SET=utf8\n        SELECT\n            teacher.id              AS teacher_id,\n            teacher.short_name      AS teacher_short_name,\n            teacher.name            AS teacher_name,\n            teacher.surname         AS teacher_surname,\n            teacher.email           AS teacher_email,\n            ifNULL(zzzsys_user.sus_email ,\'\') AS teacher_account_email,\n            card.id                 AS card_id,\n            day.name                AS day_name,\n            period.short_name       AS period_short_name,\n            class.short_name        AS class_short_name,\n            subject.name            AS subject_name,\n            classroom.short_name    AS classroom_short_name \n        FROM card\n        INNER JOIN      teacher         ON      card.teacher_id=teacher.id\n        INNER JOIN      subject         ON      card.subject_id=subject.id\n        INNER JOIN      class           ON      card.class_id=class.id\n        INNER JOIN      period          ON      card.period_id=period.id\n        INNER JOIN      day             ON      card.day_id=day.id\n        LEFT JOIN       classroom       ON      card.classroom_id=classroom.id\n        LEFT JOIN       zzzsys_user     ON      zzzsys_user.zzzsys_user_id=teacher.user_id\n        WHERE\n            valid_from=\'\".$card_date.\"\' AND\n            day_id=\".(idate(\'w\', strtotime($absence_date))-1).\" AND\n            period.end_time <  CURTIME() AND\n            card.id not in (    SELECT card_id \n                                FROM registered_card \n                                WHERE DATE_FORMAT(registered_card.card_date, \'%Y-%m-%d\')=\'\".$absence_date.\"\') AND\n            \'\".$absence_date.\"\' NOT IN (    SELECT holiday.holiday \n                                            FROM holiday \n                                            INNER JOIN school_year ON holiday.school_year_id=school_year.id\n                                            INNER JOIN school ON school.school_year_id=school_year.id)\n        ORDER BY \n            teacher.id,period.id,class.short_name\";\n                                                        \n    nuRunQuery($sql);\n\n    $sql=\"SELECT DISTINCT teacher_id FROM $tmp_table\";\n    $retval = nuRunQuery($sql);        \n\n    if($retval){\n        $mail                    = new PHPMailer(true);\n        $mail->SMTPDebug         = 0;\n	    $mail->IsSMTP();\n	    $mail->setLanguage(\'el\');\n        $mail->Host              = $setup->set_smtp_host;\n        $mail->Port              = $setup->set_smtp_port;\n        $mail->SMTPAuth          = true;\n        $mail->SMTPSecure        = $setup->set_smtp_use_ssl ? $setup->set_smtp_use_ssl : \'\';\n            \n        $mail->CharSet           = \'UTF-8\';\n        $mail->Encoding          = \'base64\';\n\n        $mail->Username          = $setup->set_smtp_username;\n        $mail->Password          = $setup->set_smtp_password;\n\n        $mail->From              = $setup->set_smtp_from_address;\n        $mail->FromName          = $setup->set_smtp_from_name;//iconv(\'UTF-8\',\'ISO-8859-7//IGNORE\',$setup->set_smtp_from_name);\n        $mail->AddReplyTo($setup->set_smtp_from_address,$setup->set_smtp_from_name);//iconv(\'UTF-8\',\'ISO-8859-7//IGNORE\',$setup->set_smtp_from_name));\n        $mail->AddReplyTo        = $setup->set_smtp_from_address;\n        $mail->WordWrap          = 80;\n        $mail->IsHTML(true);\n\n        $subject = \"Ειδοποίηση για εκκρεμότητες στην καταχώριση των απουσιών στις \".date(\'d-m-Y\',strtotime($absence_date));\n        $mail->Subject  = $subject;\n        \n        $msg = \'\';\n        $sent = 0;\n        $fail = 0;\n        $wrong_address = 0; \n        \n        while($row = db_fetch_row($retval)) {\n            $sql=\"SELECT * FROM $tmp_table WHERE teacher_id = \".$row[0];\n            $rv = nuRunQuery($sql);\n                \n            $r = db_fetch_object($rv);\n                \n            $teacher_name       = $r->teacher_name;\n            $teacher_surname    = $r->teacher_surname;\n            $email_address      = $r->teacher_email;\n            $secondary_email_address = $r->teacher_account_email;\n            $day_name           = $r->day_name;\n            $fail_code          = 0;\n            $fail_comments      =\'\';\n                \n            $content=\"\n		<table align=center style=\\\"width: 960px!important;border-spacing: 5px 5px;\\\">\n			<tr>\n				<td align=center style=\\\"color: #525c66;line-height: 150%;font-size: 16px;font-family: Sans-serif;\\\">\n					<h2>Σίσυφος - Ειδοποίηση</h2>\n				</td>\n			</tr>\n			<tr>\n				<td align=center>\n					<hr style=\\\"width: 100%; height: 0px; background-color:#b04b00; color:#b04b00;border: 1px solid;\\\">\n				</td>\n			</tr>\n			<tr>\n				<th align=left style=\\\"color: #525c66;line-height: 150%;font-size: 16px;font-family: Sans-serif;\\\">\n					Καθηγητής : $teacher_surname $teacher_name\n				</th>\n			</tr>\n			<tr>\n				<td align=center>\n					<hr style=\\\"width: 100%; height: 0px; background-color:#b04b00; color:#b04b00;border: 1px solid;\\\">\n				</td>\n			</tr>			\n			<tr>\n				<td align=left style=\\\"width: 960px;color: #525c66;line-height: 150%;font-size: 16px;font-family: Sans-serif;\\\">\n					<table style=\\\"width: 960px!important;margin-top: 0px;margin-bottom: 0px;margin-right: 0px;margin-left: 0px;border:0px;border-spacing: 0px 0px;\\\">                    \n                    \n  						<tr>\n							<td colspan=3 style=\\\"line-height: 150%;font-size: 15px;font-family: Sans-serif;padding-bottom: 10px;\\\">\n							Σας ενημερώνουμε ότι στις <b>\".date(\'d-m-Y\',strtotime($absence_date)).\"</b> ημέρα <b>$day_name</b> βρέθηκαν οι παρακάτω διδασκαλίες σας για τις οποίες δεν έχετε καταχωρίσει τις απουσίες των μαθητών:	\n							</td>\n						</tr>\n  						<tr>\n							<th align=left>\n							    Ώρα\n							</th>\n							<th align=left>\n							    Τμήμα\n							</th>\n							<th align=left>\n							    Μάθημα\n							</th>\n						</tr>\n				\";\n                \n            do {\n                $content.=\"\n						<tr>\n							<td>\n								\".$r->period_short_name.\"\n							</td>\n							<td >\n								\".$r->class_short_name.\"\n							</td>\n							<td >\n								\".$r->subject_name.\"\n							</td>\n						</tr>                    \n                        \";\n            } while($r = db_fetch_object($rv));\n                \n                \n            $content .=\"\n                    </table>\n				</td>\n			</tr>\n			<tr>\n				<td align=center>\n					<hr style=\\\"width: 100%; height: 0px; background-color:#b04b00; color:#b04b00;border: 1px solid;\\\">\n				</td>\n			</tr>			\n			<tr>\n				<td align=left style=\\\"color: #525c66;line-height: 150%;font-size: 14px;font-family: Sans-serif;\\\">\n					Η ειδοποίηση αυτή δημιουργήθηκε στις \".date(\'d-m-Y H:i:s\').\" και στάλθηκε αυτόματα από το Σίσυφο. Για πληρέστερη ενημέρωση \".( $system_url==\'\' ? \"συνδεθείτε\": \"<a href=\\\"$system_url\\\">συνδεθείτε</a>\").\" στο σύστημα.<br><b>Παρακαλώ, μην απαντάτε σ’αυτό το email.</b>\n				</td>\n			</tr>\n			<tr>\n				<td align=center>\n					<hr style=\\\"width: 50%; margin-left:0; height: 0px; border-style: dotted; border-width: 1px 0px 0px; border-color: #525c66;\\\">\n				</td>\n			</tr>\n			<tr>\n				<td align=left style=\\\"color: #525c66;line-height: 150%;font-size: 10px;font-family: Sans-serif;\\\">\n					<b>Διευκρίνιση ηλεκτρονικού ταχυδρομείου : </b>\n                    <br>\n                    Αυτό το ηλεκτρονικό μήνυμα (e-mail) μαζί με τα τυχόν επισυναπτόμενά του, είναι εμπιστευτικό και προορίζεται μόνο για χρήση από τα άτομα στα οποία απευθύνεται. Εάν δεν είστε ο προοριζόμενος παραλήπτης ή αρμόδιος για την παράδοση του μηνύματος στον προοριζόμενο παραλήπτη, παρακαλώ επιστρέψτε το στον αποστολέα και σας γνωρίζουμε ότι η αποθήκευση, ανάγνωση, μετάδοση, αναγραφή, αποκάλυψη, ανακοίνωση ή οποιασδήποτε άλλης μορφής χρήση οποιωνδήποτε πληροφοριών περιέχονται στο παρόν μήνυμα, δεν είναι σύννομη. \n                    <br>\n                    Το $school_name σε καμία περίπτωση δεν ευθύνεται για οιαδήποτε τυχόν ζημία λόγω αποθήκευσης ή ανάγνωσης του παρόντος, καθυστερημένης διαβίβασης, υποκλοπής ή αλλοίωσης.\n				</td>\n			</tr>\n		</table>\n		            \";\n                \n            if(!filter_var($email_address, FILTER_VALIDATE_EMAIL) && !filter_var($secondary_email_address, FILTER_VALIDATE_EMAIL)) {\n                $wrong_address++;\n                $fail_code=1;\n                $fail_comments=\'Μη έγκυρη email διεύθυνση\';\n            } else {\n	            $mail->Body     = $content;\n	            $mail->ClearAllRecipients();\n                $mail->AddAddress($email_address);\n                        \n                if(filter_var($secondary_email_address, FILTER_VALIDATE_EMAIL) && $email_address != $secondary_email_address)\n                    $mail->AddCC($secondary_email_address);\n                try {\n                    $mail->Send();\n                    $sent++;\n                } catch (phpmailerException $e) {\n                    $fail++;\n                    $fail_code = 2;\n                    $fail_comments = $e->errorMessage();;\n                } catch (Exception $e) {\n                    $fail++;\n                    $fail_code = 3;\n                    $fail_comments = $e->getMessage();;\n                }\n            }\n                    \n            $e_id = nextID(\'email\',\'email_address\');\n                   \n            $sql=\"  UPDATE email SET\n                        sender_id       =-1,\n                        sent_at         =NOW(),\n                        email_address   =\'\".$email_address.\"\',\n                        email_subject   =\'\".$subject.\"\',\n                        email_text      =\'\".(my_esc($content)).\"\',\n                        fail_code       =\'\".$fail_code.\"\',\n                        fail_comments   =\'\".(is_null($fail_comments) || $fail_comments==\'\' ? \'\' : $fail_comments).\"\',\n                        teacher_id      =\'\".$row[0].\"\',\n                        student_id      = -1\n                    WHERE id=\'\".$e_id.\"\'\";\n\n            nuRunQuery($sql);                \n        }\n        \n        if($sent>0) {$msg.=\"\\nΣτάλθηκαν \".$sent.\" Emails!\";}\n        if($fail>0) {$msg.=\"\\nΑπέτυχαν \".$fail.\" Emails!\";}\n        if($wrong_address>0) {$msg.=\"\\nΛάθος σε \".$wrong_address.\" διευθύνσεις email!\";}\n            \n        $msg=trim($msg);\n    \n        $txt=date(\'d-m-Y H:i:s\').\" Ειδοποιήσεις καθηγητών για εκκρεμείς καταχωρίσεις απουσιών\\n---------------------------------------->\\n\";\n    \n        if($msg!=\'\'){\n            $txt .= $msg.\"\\n\";\n        } else {\n            $txt .= \"\\nΔε βρέθηκαν εκκρεμότητες  στην καταχώριση των απουσιών!\\n\";\n        }\n        $txt.=\"<----------------------------------------\\n\";\n        \n        file_put_contents(\'tmp/send_notification_log.txt\', $txt.PHP_EOL , FILE_APPEND | LOCK_EX);\n        \n    } else {\n        $message=\"Παρουσιάστηκε σφάλμα κατά την ανάκτηση των δεδομένων...\";\n        nudebug($message);\n    }\n    \n    $sql=\"DROP TABLE IF EXISTS $tmp_table\";\n    nuRunQuery($sql);\n}  \n','','1','2022-09-17 21:49:44','globeadmin','2022-10-04 23:23:29','globeadmin','2023-05-18 19:40:52','globeadmin','0');
/*!40000 ALTER TABLE `zzzsys_php` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `zzzsys_report`
--

DROP TABLE IF EXISTS `zzzsys_report`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `zzzsys_report` (
  `zzzsys_report_id` varchar(25) NOT NULL,
  `sre_code` varchar(250) NOT NULL,
  `sre_description` varchar(250) NOT NULL,
  `sre_group` varchar(250) NOT NULL,
  `sre_zzzsys_sql` text NOT NULL,
  `sre_zzzsys_php_id` varchar(25) NOT NULL,
  `sre_zzzsys_form_id` varchar(25) NOT NULL,
  `sre_layout` longtext NOT NULL,
  `zzzsys_report_log_added_at` datetime NOT NULL,
  `zzzsys_report_log_added_by` varchar(25) NOT NULL,
  `zzzsys_report_log_changed_at` datetime NOT NULL,
  `zzzsys_report_log_changed_by` varchar(25) NOT NULL,
  `zzzsys_report_log_viewed_at` datetime NOT NULL,
  `zzzsys_report_log_viewed_by` varchar(25) NOT NULL,
  PRIMARY KEY (`zzzsys_report_id`),
  KEY `sre_zzzsys_php_id` (`sre_zzzsys_php_id`),
  KEY `sre_zzzsys_form_id` (`sre_zzzsys_form_id`),
  KEY `sre_code` (`sre_code`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `zzzsys_report`
--

LOCK TABLES `zzzsys_report` WRITE;
/*!40000 ALTER TABLE `zzzsys_report` DISABLE KEYS */;
INSERT INTO `zzzsys_report` VALUES ('54984128358902b','marks_print','Εκτυπώνει τους βαθμούς Περιόδου-Τμήματος-Μαθήματος','teacher','','5498454b86171f6','','{\"top\":30,\"left\":30,\"bottom\":462,\"right\":30,\"width\":\"210\",\"height\":\"297\",\"paper\":\"A4\",\"orientation\":\"P\",\"groups\":[{\"sortField\":\"Detail\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":344,\"height\":19,\"label\":\"Detail Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1031\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":80,\"top\":-1,\"height\":\"18\",\"width\":\"100\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"student_registration_number\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":211,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1031\"},{\"id\":\"object1032\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":150,\"top\":-1,\"height\":\"18\",\"width\":\"300\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"student_surname\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":212,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1032\"},{\"id\":\"object1033\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":350,\"top\":-1,\"height\":\"18\",\"width\":\"327\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"student_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":213,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1033\"},{\"id\":\"object1034\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":490,\"top\":-1,\"height\":\"18\",\"width\":\"250\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"student_fathers_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":214,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1034\"},{\"id\":\"object1035\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":660,\"top\":-1,\"height\":18,\"width\":110,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"value_p\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"21\",\"textAlign\":\"right\",\"image\":\"\",\"zIndex\":215,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1035\"}]}]},{\"sortField\":\"Report\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":30,\"height\":292,\"label\":\"Report Header\",\"page_break\":\"0\",\"margins\":2,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1007\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":80,\"top\":46,\"height\":15,\"width\":600,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":101,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1007\"},{\"id\":\"object1008\",\"group\":1,\"section\":0,\"objectType\":\"label\",\"left\":28,\"top\":236,\"height\":\"30\",\"width\":\"785\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Βαθμολογική Κατάσταση \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"14\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":102,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1008\"},{\"id\":\"object1011\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":80,\"top\":65,\"height\":\"15\",\"width\":\"600\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_year_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":104,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1011\"},{\"id\":\"object1014\",\"group\":1,\"section\":0,\"objectType\":\"label\",\"left\":80,\"top\":192,\"height\":\"18\",\"width\":\"200\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Μάθημα : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":105,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1014\"},{\"id\":\"object1018\",\"group\":1,\"section\":0,\"objectType\":\"label\",\"left\":80,\"top\":96,\"height\":15,\"width\":500,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Ημερομηνία Εκτύπωσης : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"7\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":\"200\",\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1018\"},{\"id\":\"object1037\",\"group\":1,\"section\":0,\"objectType\":\"label\",\"left\":81,\"top\":170,\"height\":\"18\",\"width\":\"150\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Τμήμα : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":216,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1037\"},{\"id\":\"object1038\",\"group\":1,\"section\":0,\"objectType\":\"label\",\"left\":80,\"top\":147,\"height\":\"18\",\"width\":\"500\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Βαθμολογική Περίοδος : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":217,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1038\"},{\"id\":\"object1039\",\"group\":1,\"section\":0,\"objectType\":\"label\",\"left\":81,\"top\":116,\"height\":15,\"width\":\"500\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Κατάσταση Βαθμολογίας : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":218,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1039\"},{\"id\":\"object1042\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":156,\"top\":192,\"height\":\"18\",\"width\":\"1000\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"subject_full_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":221,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1042\"},{\"id\":\"object1044\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":226,\"top\":96,\"height\":\"15\",\"width\":\"200\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"cur_date\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":222,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1044\"},{\"id\":\"object1045\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":148,\"top\":170,\"height\":\"18\",\"width\":\"200\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"class_short\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":223,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1045\"},{\"id\":\"object1046\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":266,\"top\":147,\"height\":18,\"width\":\"300\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"grading_period_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":224,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1046\"},{\"id\":\"object1048\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":239,\"top\":116,\"height\":\"15\",\"width\":\"200\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"cond\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":225,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1048\"}]},{\"id\":\"\",\"top\":363,\"height\":69,\"label\":\"Report Footer\",\"page_break\":\"0\",\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1063\",\"group\":1,\"section\":1,\"objectType\":\"field\",\"left\":172,\"top\":24,\"height\":\"45\",\"width\":\"600\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"teacher_names\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"right\",\"image\":\"\",\"zIndex\":236,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1063\"},{\"id\":\"object1064\",\"group\":1,\"section\":1,\"objectType\":\"label\",\"left\":172,\"top\":6,\"height\":15,\"width\":600,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Οι Διδάσκοντες Καθηγητές\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"right\",\"image\":\"\",\"zIndex\":237,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1064\"}]}]},{\"sortField\":\"Page\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":322,\"height\":22,\"label\":\"Page Header\",\"page_break\":\"0\",\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1057\",\"group\":2,\"section\":0,\"objectType\":\"label\",\"left\":80,\"top\":2,\"height\":18,\"width\":100,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Α.Μ.\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":231,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1057\"},{\"id\":\"object1058\",\"group\":2,\"section\":0,\"objectType\":\"label\",\"left\":150,\"top\":2,\"height\":18,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Επώνυμο\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":232,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1058\"},{\"id\":\"object1059\",\"group\":2,\"section\":0,\"objectType\":\"label\",\"left\":350,\"top\":2,\"height\":18,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Όνομα\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":233,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1059\"},{\"id\":\"object1060\",\"group\":2,\"section\":0,\"objectType\":\"label\",\"left\":490,\"top\":2,\"height\":18,\"width\":250,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Πατρώνυμο\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":234,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1060\"},{\"id\":\"object1061\",\"group\":2,\"section\":0,\"objectType\":\"label\",\"left\":660,\"top\":2,\"height\":18,\"width\":\"110\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Βαθμός\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"21\",\"textAlign\":\"right\",\"image\":\"\",\"zIndex\":235,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1061\"}]},{\"id\":\"\",\"top\":363,\"height\":0,\"label\":\"Page Footer\",\"page_break\":\"0\",\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":344,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":363,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":344,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":363,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":344,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":363,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":344,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":363,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":344,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":363,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":344,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":363,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":344,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":363,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":344,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":363,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]}],\"currentGroup\":0}','2014-12-22 18:04:56','globeadmin','2018-02-04 11:39:29','globeadmin','2018-02-04 11:39:29','globeadmin'),('54a3e993669f5ae','marks_print_full','Εκτυπώνει όλους τους βαθμούς της τρέχουσας περιόδου','manager','','54a3e7ba6b7fc63','','{\"top\":30,\"left\":30,\"bottom\":465,\"right\":30,\"width\":\"210\",\"height\":\"297\",\"paper\":\"A4\",\"orientation\":\"P\",\"groups\":[{\"sortField\":\"Detail\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":322,\"height\":19,\"label\":\"Detail Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1031\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":80,\"top\":-1,\"height\":\"18\",\"width\":\"100\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"student_registration_number\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":211,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1031\"},{\"id\":\"object1032\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":150,\"top\":-1,\"height\":\"18\",\"width\":\"300\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"student_surname\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":212,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1032\"},{\"id\":\"object1033\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":330,\"top\":-1,\"height\":\"18\",\"width\":\"300\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"student_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":213,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1033\"},{\"id\":\"object1034\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":490,\"top\":-1,\"height\":\"18\",\"width\":\"250\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"student_fathers_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":214,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1034\"},{\"id\":\"object1035\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":660,\"top\":-1,\"height\":18,\"width\":110,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"value_p\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"21\",\"textAlign\":\"right\",\"image\":\"\",\"zIndex\":215,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1035\"}]}]},{\"sortField\":\"Report\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":30,\"height\":0,\"label\":\"Report Header\",\"page_break\":\"0\",\"margins\":0,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":435,\"height\":0,\"label\":\"Report Footer\",\"page_break\":\"0\",\"margins\":10,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"Page\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":30,\"height\":40,\"label\":\"Page Header\",\"page_break\":\"0\",\"margins\":2,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1091\",\"group\":2,\"section\":0,\"objectType\":\"label\",\"left\":107,\"top\":12,\"height\":\"15\",\"width\":600,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\" \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"right\",\"image\":\"\",\"zIndex\":256,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1091\"}]},{\"id\":\"\",\"top\":435,\"height\":0,\"label\":\"Page Footer\",\"page_break\":\"0\",\"margins\":10,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"grading_period_id\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":70,\"height\":0,\"label\":\" Header\",\"page_break\":\"0\",\"margins\":2,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":435,\"height\":0,\"label\":\" Footer\",\"page_break\":\"0\",\"margins\":10,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"class_id\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":70,\"height\":0,\"label\":\" Header\",\"page_break\":\"0\",\"margins\":2,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":435,\"height\":0,\"label\":\" Footer\",\"page_break\":\"0\",\"margins\":10,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"subject_id2\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":70,\"height\":0,\"label\":\" Header\",\"page_break\":\"0\",\"margins\":2,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":419,\"height\":16,\"label\":\" Footer\",\"page_break\":\"1\",\"margins\":10,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1089\",\"group\":5,\"section\":1,\"objectType\":\"label\",\"left\":169,\"top\":0,\"height\":\"15\",\"width\":600,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\" \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"right\",\"image\":\"\",\"zIndex\":255,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1089\"}]}]},{\"sortField\":\"subject_id\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":70,\"height\":252,\"label\":\" Header\",\"page_break\":\"0\",\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1070\",\"group\":6,\"section\":0,\"objectType\":\"label\",\"left\":80,\"top\":57,\"height\":15,\"width\":\"500\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Κατάσταση Βαθμολογίας : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":242,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1070\"},{\"id\":\"object1074\",\"group\":6,\"section\":0,\"objectType\":\"field\",\"left\":240,\"top\":57,\"height\":\"15\",\"width\":\"200\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"cond\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":244,\"minRows\":0,\"maxRows\":\"0\",\"selected\":1,\"name\":\"object1074\"},{\"id\":\"object1076\",\"group\":6,\"section\":0,\"objectType\":\"label\",\"left\":80,\"top\":131,\"height\":\"18\",\"width\":\"200\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Μάθημα : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":245,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1076\"},{\"id\":\"object1077\",\"group\":6,\"section\":0,\"objectType\":\"field\",\"left\":153,\"top\":131,\"height\":\"18\",\"width\":\"680\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"subject_full_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":246,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1077\"},{\"id\":\"object1078\",\"group\":6,\"section\":0,\"objectType\":\"label\",\"left\":80,\"top\":232,\"height\":18,\"width\":100,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Α.Μ.\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":247,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1078\"},{\"id\":\"object1079\",\"group\":6,\"section\":0,\"objectType\":\"label\",\"left\":150,\"top\":232,\"height\":18,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Επώνυμο\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":248,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1079\"},{\"id\":\"object1080\",\"group\":6,\"section\":0,\"objectType\":\"label\",\"left\":330,\"top\":232,\"height\":18,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Όνομα\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":249,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1080\"},{\"id\":\"object1081\",\"group\":6,\"section\":0,\"objectType\":\"label\",\"left\":490,\"top\":232,\"height\":18,\"width\":250,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Πατρώνυμο\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":250,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1081\"},{\"id\":\"object1082\",\"group\":6,\"section\":0,\"objectType\":\"label\",\"left\":660,\"top\":232,\"height\":18,\"width\":\"110\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Βαθμός\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"21\",\"textAlign\":\"right\",\"image\":\"\",\"zIndex\":251,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1082\"},{\"id\":\"object1066\",\"group\":6,\"section\":0,\"objectType\":\"label\",\"left\":80,\"top\":108,\"height\":\"18\",\"width\":\"150\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Τμήμα : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":238,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1066\"},{\"id\":\"object1067\",\"group\":6,\"section\":0,\"objectType\":\"field\",\"left\":153,\"top\":108,\"height\":\"18\",\"width\":\"200\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"class_short\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":239,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1067\"},{\"id\":\"object1068\",\"group\":6,\"section\":0,\"objectType\":\"label\",\"left\":80,\"top\":85,\"height\":\"18\",\"width\":\"500\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Βαθμολογική Περίοδος : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":240,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1068\"},{\"id\":\"object1069\",\"group\":6,\"section\":0,\"objectType\":\"field\",\"left\":259,\"top\":85,\"height\":18,\"width\":\"300\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"grading_period_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":241,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1069\"},{\"id\":\"object1008\",\"group\":6,\"section\":0,\"objectType\":\"label\",\"left\":27,\"top\":176,\"height\":\"30\",\"width\":\"785\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Βαθμολογική Κατάσταση \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"14\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":102,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1008\"},{\"id\":\"object1007\",\"group\":6,\"section\":0,\"objectType\":\"field\",\"left\":80,\"top\":1,\"height\":15,\"width\":600,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":101,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1007\"},{\"id\":\"object1011\",\"group\":6,\"section\":0,\"objectType\":\"field\",\"left\":80,\"top\":17,\"height\":\"15\",\"width\":\"600\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_year_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":104,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1011\"},{\"id\":\"object1093\",\"group\":6,\"section\":0,\"objectType\":\"label\",\"left\":80,\"top\":40,\"height\":15,\"width\":500,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Ημερομηνία Εκτύπωσης : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"7\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":257,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1093\"},{\"id\":\"object1094\",\"group\":6,\"section\":0,\"objectType\":\"field\",\"left\":240,\"top\":40,\"height\":\"15\",\"width\":\"200\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"cur_date\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":258,\"minRows\":0,\"maxRows\":\"0\",\"selected\":1,\"name\":\"object1094\"}]},{\"id\":\"\",\"top\":341,\"height\":78,\"label\":\" Footer\",\"page_break\":\"0\",\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1087\",\"group\":6,\"section\":1,\"objectType\":\"label\",\"left\":169,\"top\":13,\"height\":\"15\",\"width\":600,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Οι Διδάσκοντες Καθηγητές\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"right\",\"image\":\"\",\"zIndex\":254,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1087\"},{\"id\":\"object1096\",\"group\":6,\"section\":1,\"objectType\":\"field\",\"left\":169,\"top\":30,\"height\":45,\"width\":600,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"teacher_names\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"right\",\"image\":\"\",\"zIndex\":259,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1096\"}]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":322,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":341,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":322,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":341,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":322,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":341,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":322,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":341,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]}],\"currentGroup\":0}','2014-12-31 14:18:27','globeadmin','2014-12-31 14:18:27','globeadmin','2016-07-27 20:08:14','globeadmin'),('549ef5f9e44b43a','marks_print_teacher_full','Εκτυπώνει όλους τους βαθμούς του καθηγητή','teacher','','549ef456718c2ed','','{\"top\":30,\"left\":30,\"bottom\":466,\"right\":30,\"width\":\"210\",\"height\":\"297\",\"paper\":\"A4\",\"orientation\":\"P\",\"groups\":[{\"sortField\":\"Detail\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":322,\"height\":20,\"label\":\"Detail Header\",\"page_break\":\"0\",\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1031\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":80,\"top\":-1,\"height\":\"19\",\"width\":\"100\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"student_registration_number\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":211,\"minRows\":0,\"maxRows\":\"0\",\"selected\":1,\"name\":\"object1031\"},{\"id\":\"object1032\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":150,\"top\":-1,\"height\":\"19\",\"width\":\"300\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"student_surname\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":212,\"minRows\":0,\"maxRows\":\"0\",\"selected\":1,\"name\":\"object1032\"},{\"id\":\"object1033\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":330,\"top\":-1,\"height\":\"19\",\"width\":\"329\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"student_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":213,\"minRows\":\"0\",\"maxRows\":0,\"selected\":1,\"name\":\"object1033\"},{\"id\":\"object1034\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":490,\"top\":-1,\"height\":\"19\",\"width\":\"250\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"student_fathers_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":214,\"minRows\":\"0\",\"maxRows\":0,\"selected\":1,\"name\":\"object1034\"},{\"id\":\"object1035\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":660,\"top\":-1,\"height\":\"19\",\"width\":110,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"value_p\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"21\",\"textAlign\":\"right\",\"image\":\"\",\"zIndex\":215,\"minRows\":\"0\",\"maxRows\":0,\"selected\":1,\"name\":\"object1035\"}]}]},{\"sortField\":\"Report\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":30,\"height\":0,\"label\":\"Report Header\",\"page_break\":\"0\",\"margins\":0,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":436,\"height\":0,\"label\":\"Report Footer\",\"page_break\":\"0\",\"margins\":10,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"Page\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":30,\"height\":40,\"label\":\"Page Header\",\"page_break\":\"0\",\"margins\":2,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1091\",\"group\":2,\"section\":0,\"objectType\":\"label\",\"left\":107,\"top\":12,\"height\":\"15\",\"width\":600,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\" \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"right\",\"image\":\"\",\"zIndex\":256,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1091\"}]},{\"id\":\"\",\"top\":436,\"height\":0,\"label\":\"Page Footer\",\"page_break\":\"0\",\"margins\":10,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"grading_period_id\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":70,\"height\":0,\"label\":\" Header\",\"page_break\":\"0\",\"margins\":2,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":436,\"height\":0,\"label\":\" Footer\",\"page_break\":\"0\",\"margins\":10,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"class_id\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":70,\"height\":0,\"label\":\" Header\",\"page_break\":\"0\",\"margins\":2,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":436,\"height\":0,\"label\":\" Footer\",\"page_break\":\"0\",\"margins\":10,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"subject_id2\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":70,\"height\":0,\"label\":\" Header\",\"page_break\":\"0\",\"margins\":2,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":420,\"height\":16,\"label\":\" Footer\",\"page_break\":\"1\",\"margins\":10,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1089\",\"group\":5,\"section\":1,\"objectType\":\"label\",\"left\":169,\"top\":0,\"height\":\"15\",\"width\":600,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\" \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"right\",\"image\":\"\",\"zIndex\":255,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1089\"}]}]},{\"sortField\":\"subject_id\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":70,\"height\":252,\"label\":\" Header\",\"page_break\":\"0\",\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1070\",\"group\":6,\"section\":0,\"objectType\":\"label\",\"left\":80,\"top\":57,\"height\":15,\"width\":\"500\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Κατάσταση Βαθμολογίας : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":242,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1070\"},{\"id\":\"object1074\",\"group\":6,\"section\":0,\"objectType\":\"field\",\"left\":240,\"top\":57,\"height\":\"15\",\"width\":\"200\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"cond\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":244,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1074\"},{\"id\":\"object1076\",\"group\":6,\"section\":0,\"objectType\":\"label\",\"left\":80,\"top\":131,\"height\":\"18\",\"width\":\"200\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Μάθημα : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":245,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1076\"},{\"id\":\"object1077\",\"group\":6,\"section\":0,\"objectType\":\"field\",\"left\":153,\"top\":131,\"height\":\"18\",\"width\":\"1000\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"subject_full_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":246,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1077\"},{\"id\":\"object1078\",\"group\":6,\"section\":0,\"objectType\":\"label\",\"left\":80,\"top\":232,\"height\":18,\"width\":100,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Α.Μ.\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":247,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1078\"},{\"id\":\"object1079\",\"group\":6,\"section\":0,\"objectType\":\"label\",\"left\":150,\"top\":232,\"height\":18,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Επώνυμο\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":248,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1079\"},{\"id\":\"object1080\",\"group\":6,\"section\":0,\"objectType\":\"label\",\"left\":330,\"top\":232,\"height\":18,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Όνομα\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":249,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1080\"},{\"id\":\"object1081\",\"group\":6,\"section\":0,\"objectType\":\"label\",\"left\":490,\"top\":232,\"height\":18,\"width\":250,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Πατρώνυμο\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":250,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1081\"},{\"id\":\"object1082\",\"group\":6,\"section\":0,\"objectType\":\"label\",\"left\":660,\"top\":232,\"height\":18,\"width\":\"110\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Βαθμός\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"21\",\"textAlign\":\"right\",\"image\":\"\",\"zIndex\":251,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1082\"},{\"id\":\"object1066\",\"group\":6,\"section\":0,\"objectType\":\"label\",\"left\":80,\"top\":108,\"height\":\"18\",\"width\":\"150\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Τμήμα : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":238,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1066\"},{\"id\":\"object1067\",\"group\":6,\"section\":0,\"objectType\":\"field\",\"left\":153,\"top\":108,\"height\":\"18\",\"width\":\"200\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"class_short\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":239,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1067\"},{\"id\":\"object1068\",\"group\":6,\"section\":0,\"objectType\":\"label\",\"left\":80,\"top\":85,\"height\":\"18\",\"width\":\"500\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Βαθμολογική Περίοδος : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":240,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1068\"},{\"id\":\"object1069\",\"group\":6,\"section\":0,\"objectType\":\"field\",\"left\":259,\"top\":85,\"height\":18,\"width\":\"300\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"grading_period_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":241,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1069\"},{\"id\":\"object1008\",\"group\":6,\"section\":0,\"objectType\":\"label\",\"left\":27,\"top\":176,\"height\":\"30\",\"width\":\"785\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Βαθμολογική Κατάσταση \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"14\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":102,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1008\"},{\"id\":\"object1007\",\"group\":6,\"section\":0,\"objectType\":\"field\",\"left\":80,\"top\":1,\"height\":15,\"width\":600,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":101,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1007\"},{\"id\":\"object1011\",\"group\":6,\"section\":0,\"objectType\":\"field\",\"left\":80,\"top\":17,\"height\":\"15\",\"width\":\"600\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_year_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":104,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1011\"},{\"id\":\"object1093\",\"group\":6,\"section\":0,\"objectType\":\"label\",\"left\":80,\"top\":40,\"height\":15,\"width\":500,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Ημερομηνία Εκτύπωσης : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"7\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":257,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1093\"},{\"id\":\"object1094\",\"group\":6,\"section\":0,\"objectType\":\"field\",\"left\":240,\"top\":40,\"height\":\"15\",\"width\":\"200\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"cur_date\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":258,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1094\"}]},{\"id\":\"\",\"top\":342,\"height\":78,\"label\":\" Footer\",\"page_break\":\"0\",\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1087\",\"group\":6,\"section\":1,\"objectType\":\"label\",\"left\":169,\"top\":13,\"height\":\"15\",\"width\":600,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Οι Διδάσκοντες Καθηγητές\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"right\",\"image\":\"\",\"zIndex\":254,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1087\"},{\"id\":\"object1096\",\"group\":6,\"section\":1,\"objectType\":\"field\",\"left\":169,\"top\":30,\"height\":45,\"width\":600,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"teacher_names\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"right\",\"image\":\"\",\"zIndex\":259,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1096\"}]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":322,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":342,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":322,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":342,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":322,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":342,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":322,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":342,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]}],\"currentGroup\":0}','2014-12-27 20:10:01','globeadmin','2017-05-29 09:06:14','globeadmin','2017-05-29 09:06:14','globeadmin'),('54f1a5592b47fb0','teacher_students','Τυπώνει τα στοιχεία των μαθητών για τον υπευθυνο καθηγητή','teacher','SELECT  concat(student.surname,\' \',student.name, \' πατ. \',student.fathers_name) as full_name,\n        DATE_FORMAT(student.birth_date,\'%d-%m-%Y\') as b_date,        \n        concat(student.phone1,\',\',student.phone2,\',\',student.mobile) as student_phones,\n        student.*,\n        school.name as school_name,\n        school_year.name as school_year_name,\n        DATE_FORMAT(curdate(),\'%d-%m-%Y\') as cur_date \nFROM student,school,school_year\nWHERE \nschool_year.id=school.school_year_id and\nteacher_id=#RECORD_ID# \nORDER BY surname,name,fathers_name','','','{\"top\":30,\"left\":30,\"bottom\":261,\"right\":30,\"width\":\"297\",\"height\":\"210\",\"paper\":\"A4\",\"orientation\":\"L\",\"groups\":[{\"sortField\":\"Detail\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":191,\"height\":23,\"label\":\"Detail Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1032\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":80,\"top\":-1,\"height\":\"22\",\"width\":\"650\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"full_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":212,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1032\"},{\"id\":\"object1033\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":440,\"top\":-1,\"height\":22,\"width\":\"300\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"b_date\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":213,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1033\"},{\"id\":\"object1034\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":550,\"top\":-1,\"height\":\"22\",\"width\":\"250\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"student_phones\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":214,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1034\"}]}]},{\"sortField\":\"Report\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":30,\"height\":135,\"label\":\"Report Header\",\"page_break\":\"0\",\"margins\":2,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1007\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":80,\"top\":37,\"height\":15,\"width\":600,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":101,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1007\"},{\"id\":\"object1008\",\"group\":1,\"section\":0,\"objectType\":\"label\",\"left\":36,\"top\":99,\"height\":30,\"width\":1100,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Αναλυτική Κατάσταση Μαθητών\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"14\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":102,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1008\"},{\"id\":\"object1011\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":80,\"top\":56,\"height\":\"15\",\"width\":\"600\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_year_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":104,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1011\"},{\"id\":\"object1018\",\"group\":1,\"section\":0,\"objectType\":\"label\",\"left\":80,\"top\":76,\"height\":15,\"width\":500,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Ημερομηνία Εκτύπωσης : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"7\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":\"200\",\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1018\"},{\"id\":\"object1044\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":226,\"top\":76,\"height\":\"15\",\"width\":\"200\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"cur_date\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":222,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1044\"}]},{\"id\":\"\",\"top\":214,\"height\":17,\"label\":\"Report Footer\",\"page_break\":\"0\",\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"Page\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":165,\"height\":26,\"label\":\"Page Header\",\"page_break\":\"0\",\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1058\",\"group\":2,\"section\":0,\"objectType\":\"label\",\"left\":80,\"top\":2,\"height\":\"22\",\"width\":\"650\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Ονοματεπώνυμο\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":232,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1058\"},{\"id\":\"object1059\",\"group\":2,\"section\":0,\"objectType\":\"label\",\"left\":440,\"top\":2,\"height\":\"22\",\"width\":\"300\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Ημερομηνία Γέν.\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":233,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1059\"},{\"id\":\"object1060\",\"group\":2,\"section\":0,\"objectType\":\"label\",\"left\":550,\"top\":2,\"height\":22,\"width\":250,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Τηλέφωνα\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":234,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1060\"}]},{\"id\":\"\",\"top\":214,\"height\":0,\"label\":\"Page Footer\",\"page_break\":\"0\",\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":191,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":214,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":191,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":214,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":191,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":214,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":191,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":214,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":191,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":214,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":191,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":214,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":191,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":214,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":191,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":214,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]}],\"currentGroup\":0}','2015-02-28 13:24:09','globeadmin','2015-02-28 15:13:15','globeadmin','2017-11-22 22:19:28','globeadmin'),('54f1bf4c1f13912','teacher_students_full','Τυπωνει αναλυτικά τα στοιχεία των μαθητών του υπεύθυνου καθηγητή','teacher','SELECT  concat(student.surname,\' \',student.name, \' πατ. \',student.fathers_name) as full_name,\n        DATE_FORMAT(student.birth_date,\'%d-%m-%Y\') as b_date,        \n        concat(student.parent_surname,\' \',student.parent_name) as parent_full_name,\n        if(has_left_school=1,\'ΝΑΙ\',\'ΟΧΙ\') as hls,\n        student.*,\n        school.name as school_name,\n        school_year.name as school_year_name,\n        DATE_FORMAT(curdate(),\'%d-%m-%Y\') as cur_date \nFROM student,school,school_year\nWHERE \nschool_year.id=school.school_year_id and\nteacher_id=#RECORD_ID# \nORDER BY surname,name,fathers_name','','','{\"top\":30,\"left\":30,\"bottom\":428,\"right\":30,\"width\":\"297\",\"height\":\"210\",\"paper\":\"A4\",\"orientation\":\"L\",\"groups\":[{\"sortField\":\"Detail\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":140,\"height\":241,\"label\":\"Detail Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1059\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":76,\"top\":30,\"height\":\"22\",\"width\":\"300\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Ημερομηνία Γέννησης\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":233,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1059\"},{\"id\":\"object1060\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":76,\"top\":138,\"height\":22,\"width\":\"300\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Τηλέφωνο 1\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":234,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1060\"},{\"id\":\"object1062\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":257,\"top\":30,\"height\":\"22\",\"width\":\"300\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"b_date\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":235,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1062\"},{\"id\":\"object1063\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":257,\"top\":138,\"height\":22,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"phone1\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":236,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1063\"},{\"id\":\"object1065\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":76,\"top\":160,\"height\":22,\"width\":\"300\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Τηλέφωνο 2\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":237,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1065\"},{\"id\":\"object1066\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":257,\"top\":160,\"height\":22,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"phone2\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":238,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1066\"},{\"id\":\"object1067\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":76,\"top\":182,\"height\":22,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Κινητό\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":239,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1067\"},{\"id\":\"object1068\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":257,\"top\":182,\"height\":22,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"mobile\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":240,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1068\"},{\"id\":\"object1069\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":76,\"top\":201,\"height\":22,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Email\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":241,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1069\"},{\"id\":\"object1070\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":257,\"top\":201,\"height\":22,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"email\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":242,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1070\"},{\"id\":\"object1074\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":76,\"top\":52,\"height\":22,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Διεύθυνση\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":244,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1074\"},{\"id\":\"object1075\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":257,\"top\":52,\"height\":22,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"street\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":245,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1075\"},{\"id\":\"object1076\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":76,\"top\":73,\"height\":22,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Περιοχή\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":246,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1076\"},{\"id\":\"object1077\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":257,\"top\":73,\"height\":22,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"area\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":247,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1077\"},{\"id\":\"object1078\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":76,\"top\":117,\"height\":22,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Τ.Κ.\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":248,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1078\"},{\"id\":\"object1079\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":257,\"top\":117,\"height\":22,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"zipcode\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":249,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1079\"},{\"id\":\"object1080\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":76,\"top\":95,\"height\":22,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Πόλη\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":250,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1080\"},{\"id\":\"object1081\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":257,\"top\":95,\"height\":22,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"city\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":251,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1081\"},{\"id\":\"object1058\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":51,\"top\":3,\"height\":\"1\",\"width\":\"1100\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":232,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1058\"},{\"id\":\"object1032\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":76,\"top\":7,\"height\":22,\"width\":1000,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"full_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":212,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1032\"},{\"id\":\"object1083\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":616,\"top\":32,\"height\":\"22\",\"width\":\"300\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Ονοματεπώνυμο\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":252,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1083\"},{\"id\":\"object1084\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":616,\"top\":117,\"height\":22,\"width\":\"300\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Τηλέφωνο 1\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":253,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1084\"},{\"id\":\"object1085\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":797,\"top\":32,\"height\":\"22\",\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"parent_full_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":254,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1085\"},{\"id\":\"object1086\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":797,\"top\":117,\"height\":22,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"parent_phone1\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":255,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1086\"},{\"id\":\"object1087\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":616,\"top\":138,\"height\":22,\"width\":\"300\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Τηλέφωνο 2\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":256,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1087\"},{\"id\":\"object1088\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":797,\"top\":138,\"height\":22,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"parent_phone2\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":257,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1088\"},{\"id\":\"object1089\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":616,\"top\":160,\"height\":22,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Τηλέφωνο 3\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":258,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1089\"},{\"id\":\"object1090\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":797,\"top\":160,\"height\":22,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"parent_phone3\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":259,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1090\"},{\"id\":\"object1091\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":616,\"top\":182,\"height\":22,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Email\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":260,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1091\"},{\"id\":\"object1092\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":797,\"top\":182,\"height\":22,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"parent_email\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":261,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1092\"},{\"id\":\"object1093\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":616,\"top\":52,\"height\":22,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Διεύθυνση\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":262,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1093\"},{\"id\":\"object1094\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":797,\"top\":52,\"height\":22,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"paranet_street\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":263,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1094\"},{\"id\":\"object1095\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":616,\"top\":73,\"height\":22,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Περιοχή\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":264,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1095\"},{\"id\":\"object1096\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":797,\"top\":73,\"height\":22,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"paranet_area\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":265,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1096\"},{\"id\":\"object1097\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":616,\"top\":95,\"height\":22,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Τ.Κ.\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":266,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1097\"},{\"id\":\"object1098\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":797,\"top\":95,\"height\":22,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"paranet_zipcode\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":267,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1098\"},{\"id\":\"object1099\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":616,\"top\":201,\"height\":22,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Έχει Εγκαταλείψει\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":268,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1099\"},{\"id\":\"object1100\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":797,\"top\":201,\"height\":22,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"hls\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":269,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1100\"},{\"id\":\"object1101\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":616,\"top\":7,\"height\":22,\"width\":500,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Κηδεμόνας\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":270,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1101\"}]}]},{\"sortField\":\"Report\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":30,\"height\":24,\"label\":\"Report Header\",\"page_break\":\"0\",\"margins\":2,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":381,\"height\":17,\"label\":\"Report Footer\",\"page_break\":\"0\",\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"Page\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":54,\"height\":86,\"label\":\"Page Header\",\"page_break\":\"0\",\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1018\",\"group\":2,\"section\":0,\"objectType\":\"label\",\"left\":76,\"top\":53,\"height\":15,\"width\":500,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Ημερομηνία Εκτύπωσης : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"7\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":\"200\",\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1018\"},{\"id\":\"object1011\",\"group\":2,\"section\":0,\"objectType\":\"field\",\"left\":76,\"top\":35,\"height\":\"15\",\"width\":\"600\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_year_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":104,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1011\"},{\"id\":\"object1008\",\"group\":2,\"section\":0,\"objectType\":\"label\",\"left\":481,\"top\":55,\"height\":30,\"width\":\"700\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Αναλυτική Κατάσταση Μαθητών\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"14\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":\"244\",\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1008\"},{\"id\":\"object1007\",\"group\":2,\"section\":0,\"objectType\":\"field\",\"left\":76,\"top\":18,\"height\":15,\"width\":600,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":101,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1007\"},{\"id\":\"object1072\",\"group\":2,\"section\":0,\"objectType\":\"field\",\"left\":227,\"top\":53,\"height\":\"15\",\"width\":\"200\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"cur_date\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":243,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1072\"}]},{\"id\":\"\",\"top\":381,\"height\":0,\"label\":\"Page Footer\",\"page_break\":\"0\",\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":140,\"height\":0,\"label\":\" Header\",\"page_break\":\"0\",\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":381,\"height\":0,\"label\":\" Footer\",\"page_break\":\"0\",\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":140,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":381,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":140,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":381,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":140,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":381,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":140,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":381,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":140,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":381,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":140,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":381,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":140,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":381,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]}],\"currentGroup\":0}','2015-02-28 15:14:52','globeadmin','2015-04-26 11:57:54','globeadmin','2015-12-26 23:19:57','globeadmin'),('55216527cffb240','absence_class_day_table','Απουσιολόγιο τμήματος όλης της ημέρας','teacher','','552124aeebd01bf','','{\"top\":30,\"left\":30,\"bottom\":622,\"right\":30,\"width\":\"210\",\"height\":\"297\",\"paper\":\"A4\",\"orientation\":\"P\",\"groups\":[{\"sortField\":\"Detail\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":234,\"height\":20,\"label\":\"Detail Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1032\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":46,\"top\":-1,\"height\":\"18\",\"width\":\"740\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"student_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":212,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1032\"},{\"id\":\"object1049\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":426,\"top\":-1,\"height\":\"18\",\"width\":\"100\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"absence_name1\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":224,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1049\"},{\"id\":\"object1051\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":478,\"top\":-1,\"height\":\"18\",\"width\":\"100\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"absence_name2\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":225,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1051\"},{\"id\":\"object1052\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":530,\"top\":-1,\"height\":\"18\",\"width\":\"100\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"absence_name3\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":226,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1052\"},{\"id\":\"object1053\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":582,\"top\":-1,\"height\":\"18\",\"width\":\"100\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"absence_name4\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":227,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1053\"},{\"id\":\"object1054\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":635,\"top\":-1,\"height\":\"18\",\"width\":\"100\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"absence_name5\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":228,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1054\"},{\"id\":\"object1055\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":688,\"top\":-1,\"height\":\"18\",\"width\":\"100\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"absence_name6\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":229,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1055\"},{\"id\":\"object1056\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":740,\"top\":-1,\"height\":\"18\",\"width\":\"50\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"absence_name7\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":230,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1056\"}]}]},{\"sortField\":\"Report\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":30,\"height\":202,\"label\":\"Report Header\",\"page_break\":\"0\",\"margins\":2,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1007\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":80,\"top\":34,\"height\":15,\"width\":600,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":101,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1007\"},{\"id\":\"object1008\",\"group\":1,\"section\":0,\"objectType\":\"label\",\"left\":28,\"top\":158,\"height\":30,\"width\":785,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Ημερήσιο Δελτίο Φοίτησης\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"14\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":102,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1008\"},{\"id\":\"object1011\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":80,\"top\":53,\"height\":\"15\",\"width\":\"600\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_year_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":104,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1011\"},{\"id\":\"object1014\",\"group\":1,\"section\":0,\"objectType\":\"label\",\"left\":80,\"top\":131,\"height\":18,\"width\":\"250\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Ημερομηνία : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":105,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1014\"},{\"id\":\"object1018\",\"group\":1,\"section\":0,\"objectType\":\"label\",\"left\":80,\"top\":72,\"height\":15,\"width\":500,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Ημερομηνία Εκτύπωσης : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"7\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":\"200\",\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1018\"},{\"id\":\"object1037\",\"group\":1,\"section\":0,\"objectType\":\"label\",\"left\":81,\"top\":107,\"height\":\"18\",\"width\":\"150\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Τμήμα : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":216,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1037\"},{\"id\":\"object1042\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":207,\"top\":131,\"height\":\"18\",\"width\":\"200\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"abs_date\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":221,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1042\"},{\"id\":\"object1044\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":226,\"top\":72,\"height\":\"15\",\"width\":\"200\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"cur_date\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":222,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1044\"},{\"id\":\"object1045\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":207,\"top\":107,\"height\":18,\"width\":200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"class_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":223,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1045\"}]},{\"id\":\"\",\"top\":254,\"height\":338,\"label\":\"Report Footer\",\"page_break\":\"0\",\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1058\",\"group\":1,\"section\":1,\"objectType\":\"label\",\"left\":46,\"top\":16,\"height\":18,\"width\":\"250\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Διδασκαλίες\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":231,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1058\"},{\"id\":\"object1059\",\"group\":1,\"section\":1,\"objectType\":\"field\",\"left\":62,\"top\":42,\"height\":\"18\",\"width\":\"100\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"period_name1\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":232,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1059\"},{\"id\":\"object1060\",\"group\":1,\"section\":1,\"objectType\":\"field\",\"left\":62,\"top\":83,\"height\":\"18\",\"width\":\"100\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"period_name2\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":233,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1060\"},{\"id\":\"object1061\",\"group\":1,\"section\":1,\"objectType\":\"field\",\"left\":62,\"top\":124,\"height\":\"18\",\"width\":\"100\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"period_name3\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":234,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1061\"},{\"id\":\"object1062\",\"group\":1,\"section\":1,\"objectType\":\"field\",\"left\":62,\"top\":166,\"height\":\"18\",\"width\":\"100\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"period_name4\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":235,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1062\"},{\"id\":\"object1063\",\"group\":1,\"section\":1,\"objectType\":\"field\",\"left\":62,\"top\":207,\"height\":\"18\",\"width\":\"100\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"period_name5\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":236,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1063\"},{\"id\":\"object1064\",\"group\":1,\"section\":1,\"objectType\":\"field\",\"left\":62,\"top\":248,\"height\":\"18\",\"width\":\"100\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"period_name6\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":237,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1064\"},{\"id\":\"object1065\",\"group\":1,\"section\":1,\"objectType\":\"field\",\"left\":62,\"top\":290,\"height\":\"18\",\"width\":\"100\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"period_name7\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":238,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1065\"},{\"id\":\"object1067\",\"group\":1,\"section\":1,\"objectType\":\"field\",\"left\":123,\"top\":42,\"height\":\"18\",\"width\":\"1200\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"subject_name1\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":239,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1067\"},{\"id\":\"object1068\",\"group\":1,\"section\":1,\"objectType\":\"field\",\"left\":123,\"top\":83,\"height\":\"18\",\"width\":\"1200\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"subject_name2\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":240,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1068\"},{\"id\":\"object1069\",\"group\":1,\"section\":1,\"objectType\":\"field\",\"left\":123,\"top\":124,\"height\":\"18\",\"width\":\"1200\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"subject_name3\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":241,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1069\"},{\"id\":\"object1070\",\"group\":1,\"section\":1,\"objectType\":\"field\",\"left\":123,\"top\":166,\"height\":\"18\",\"width\":\"1200\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"subject_name4\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":242,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1070\"},{\"id\":\"object1071\",\"group\":1,\"section\":1,\"objectType\":\"field\",\"left\":123,\"top\":207,\"height\":\"18\",\"width\":\"1200\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"subject_name5\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":243,\"minRows\":\"0\",\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1071\"},{\"id\":\"object1072\",\"group\":1,\"section\":1,\"objectType\":\"field\",\"left\":123,\"top\":248,\"height\":\"18\",\"width\":\"1200\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"subject_name6\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":244,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1072\"},{\"id\":\"object1073\",\"group\":1,\"section\":1,\"objectType\":\"field\",\"left\":123,\"top\":290,\"height\":\"18\",\"width\":\"1200\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"subject_name7\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":245,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1073\"},{\"id\":\"object1075\",\"group\":1,\"section\":1,\"objectType\":\"label\",\"left\":46,\"top\":37,\"height\":\"0\",\"width\":\"250\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":246,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1075\"},{\"id\":\"object1076\",\"group\":1,\"section\":1,\"objectType\":\"label\",\"left\":62,\"top\":81,\"height\":\"0\",\"width\":\"760\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":247,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1077\",\"group\":1,\"section\":1,\"objectType\":\"label\",\"left\":62,\"top\":121,\"height\":\"0\",\"width\":\"760\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":248,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1078\",\"group\":1,\"section\":1,\"objectType\":\"label\",\"left\":62,\"top\":165,\"height\":\"0\",\"width\":\"760\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":249,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1079\",\"group\":1,\"section\":1,\"objectType\":\"label\",\"left\":62,\"top\":205,\"height\":\"0\",\"width\":\"760\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":250,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1080\",\"group\":1,\"section\":1,\"objectType\":\"label\",\"left\":62,\"top\":245,\"height\":\"0\",\"width\":\"760\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":251,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1081\",\"group\":1,\"section\":1,\"objectType\":\"label\",\"left\":62,\"top\":288,\"height\":\"0\",\"width\":\"760\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":252,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1082\",\"group\":1,\"section\":1,\"objectType\":\"label\",\"left\":62,\"top\":333,\"height\":\"0\",\"width\":\"760\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":253,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"}]}]},{\"sortField\":\"Page\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":232,\"height\":2,\"label\":\"Page Header\",\"page_break\":\"0\",\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":254,\"height\":0,\"label\":\"Page Footer\",\"page_break\":\"0\",\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":234,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":254,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":234,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":254,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":234,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":254,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":234,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":254,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":234,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":254,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":234,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":254,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":234,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":254,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":234,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":254,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]}],\"currentGroup\":0}','2015-04-05 19:39:03','globeadmin','2018-06-02 15:53:54','globeadmin','2021-01-20 09:14:30','globeadmin'),('552fc50a0145cb2','absence_notes_short','Σύντομο δελτίο επικοινωνίας σχολείου γονέων','teacher','','552ea7c73b78c04','','{\"top\":30,\"left\":30,\"bottom\":1129,\"right\":30,\"width\":\"210\",\"height\":\"297\",\"paper\":\"A4\",\"orientation\":\"P\",\"groups\":[{\"sortField\":\"Detail\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":427,\"height\":651,\"label\":\"Detail Header\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1017\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":5,\"top\":290,\"height\":20,\"width\":\"300\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"manager_label\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":\"112\",\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1017\"},{\"id\":\"object1018\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":273,\"top\":290,\"height\":20,\"width\":\"300\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"assistmanager_label\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":\"111\",\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1018\"},{\"id\":\"object1019\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":532,\"top\":290,\"height\":20,\"width\":\"300\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"teacher_label\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":113,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1019\"},{\"id\":\"object1045\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":37,\"top\":180,\"height\":20,\"width\":\"800\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"text1\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":128,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1045\"},{\"id\":\"object1046\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":0,\"top\":126,\"height\":20,\"width\":\"840\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Δελτίο Επικοινωνίας Σχολείου - Γονέα\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"12\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":129,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1046\"},{\"id\":\"object1051\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":295,\"top\":180,\"height\":20,\"width\":\"870\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"student_full_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":\"131\",\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1048\"},{\"id\":\"object1053\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":37,\"top\":230,\"height\":20,\"width\":\"500\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"text4\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":134,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1053\"},{\"id\":\"object1055\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":270,\"top\":230,\"height\":20,\"width\":\"500\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"text5\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":135,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1055\"},{\"id\":\"object1056\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":500,\"top\":230,\"height\":20,\"width\":\"500\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"text6\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":136,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1056\"},{\"id\":\"object1058\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":40,\"top\":499,\"height\":20,\"width\":800,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"text10\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":137,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1058\"},{\"id\":\"object1059\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":40,\"top\":563,\"height\":20,\"width\":800,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Ημερομηνία : ________________\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":138,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1059\"},{\"id\":\"object1060\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":40,\"top\":531,\"height\":20,\"width\":1000,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Ονοματεπώνυμο : ______________________________________\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":139,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1060\"},{\"id\":\"object1061\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":500,\"top\":3,\"height\":20,\"width\":200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Πρός κ. \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":140,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1061\"},{\"id\":\"object1063\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":273,\"top\":372,\"height\":20,\"width\":\"300\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"assistmanager_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":141,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1063\"},{\"id\":\"object1064\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":5,\"top\":372,\"height\":20,\"width\":\"300\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"manager_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":142,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1064\"},{\"id\":\"object1065\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":532,\"top\":372,\"height\":20,\"width\":\"300\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"teacher_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":143,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1065\"},{\"id\":\"object1067\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":560,\"top\":3,\"height\":20,\"width\":\"620\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"student_parent_full_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":144,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1067\"},{\"id\":\"object1069\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":500,\"top\":30,\"height\":20,\"width\":\"680\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"address1\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":145,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1069\"},{\"id\":\"object1070\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":500,\"top\":61,\"height\":\"20\",\"width\":\"680\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"address2\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":146,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1070\"},{\"id\":\"object1073\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":137,\"top\":594,\"height\":20,\"width\":\"400\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Υπογραφή\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":148,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1073\"},{\"id\":\"object1074\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":37,\"top\":412,\"height\":20,\"width\":1100,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Μπορείτε να ενημερώνεστε αναλυτικά για τις απουσίες του παιδιού σας στην ιστοσελίδα του σχολείου μας\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"6\",\"fontWeight\":\"I\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":149,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1074\"},{\"id\":\"object1076\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":10,\"top\":438,\"height\":\"20\",\"width\":\"1175\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":150,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1076\"},{\"id\":\"object1078\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":295,\"top\":499,\"height\":20,\"width\":\"870\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"student_full_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":151,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1078\"},{\"id\":\"object1080\",\"group\":0,\"section\":0,\"objectType\":\"image\",\"left\":12,\"top\":440,\"height\":\"15\",\"width\":\"15\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":14,\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"images/cut1.jpg\",\"zIndex\":152,\"minRows\":0,\"maxRows\":0,\"selected\":1,\"name\":\"object1080\"},{\"id\":\"object1084\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":37,\"top\":205,\"height\":20,\"width\":\"1140\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"text2\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":154,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1084\"},{\"id\":\"object1085\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":519,\"top\":205,\"height\":20,\"width\":\"400\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"text3\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":155,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1085\"}]}]},{\"sortField\":\"Report\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":30,\"height\":1,\"label\":\"Report Header\",\"page_break\":\"0\",\"margins\":2,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":1098,\"height\":1,\"label\":\"Report Footer\",\"page_break\":\"0\",\"margins\":14,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"Page\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":31,\"height\":21,\"label\":\"Page Header\",\"page_break\":\"0\",\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":1088,\"height\":10,\"label\":\"Page Footer\",\"page_break\":\"0\",\"margins\":12,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"student_id\",\"sortBy\":\"\",\"sections\":[{\"id\":\"\",\"top\":52,\"height\":375,\"label\":\" Header\",\"page_break\":\"0\",\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1001\",\"group\":3,\"section\":0,\"objectType\":\"image\",\"left\":109,\"top\":10,\"height\":\"75\",\"width\":\"75\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":14,\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"images/coat_of_ar.png\",\"zIndex\":100,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1001\"},{\"id\":\"object1002\",\"group\":3,\"section\":0,\"objectType\":\"label\",\"left\":40,\"top\":88,\"height\":20,\"width\":\"800\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"ΕΛΛΗΝΙΚΗ ΔΗΜΟΚΡΑΤΙΑ\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":101,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1002\"},{\"id\":\"object1007\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":40,\"top\":110,\"height\":20,\"width\":\"800\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_ministry\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":104,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1007\"},{\"id\":\"object1009\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":40,\"top\":132,\"height\":20,\"width\":\"800\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_region\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":105,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1009\"},{\"id\":\"object1010\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":40,\"top\":153,\"height\":20,\"width\":\"800\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_intendancy\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":106,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1010\"},{\"id\":\"object1012\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":40,\"top\":182,\"height\":20,\"width\":800,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":107,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1012\"},{\"id\":\"object1013\",\"group\":3,\"section\":0,\"objectType\":\"label\",\"left\":555,\"top\":153,\"height\":20,\"width\":250,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Αρ. Πρωτ. __________\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"right\",\"image\":\"\",\"zIndex\":108,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1013\"},{\"id\":\"object1015\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":455,\"top\":110,\"height\":20,\"width\":\"350\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"cur_date\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"right\",\"image\":\"\",\"zIndex\":110,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1015\"},{\"id\":\"object1022\",\"group\":3,\"section\":0,\"objectType\":\"label\",\"left\":40,\"top\":270,\"height\":20,\"width\":200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Τηλ. :\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":\"114\",\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1022\"},{\"id\":\"object1024\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":88,\"top\":270,\"height\":20,\"width\":\"600\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_phone\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":115,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1024\"},{\"id\":\"object1026\",\"group\":3,\"section\":0,\"objectType\":\"label\",\"left\":40,\"top\":291,\"height\":20,\"width\":200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Fax :\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":116,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1026\"},{\"id\":\"object1027\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":88,\"top\":291,\"height\":20,\"width\":\"600\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_fax\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":117,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1027\"},{\"id\":\"object1031\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":40,\"top\":204,\"height\":20,\"width\":800,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"school_street_area\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":118,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1031\"},{\"id\":\"object1032\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":40,\"top\":226,\"height\":20,\"width\":800,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"school_zipcode_city\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":119,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1032\"},{\"id\":\"object1034\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":40,\"top\":248,\"height\":20,\"width\":800,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"school_state_country\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":120,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1034\"},{\"id\":\"object1036\",\"group\":3,\"section\":0,\"objectType\":\"label\",\"left\":40,\"top\":313,\"height\":20,\"width\":200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Email :\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":121,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1036\"},{\"id\":\"object1038\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":97,\"top\":313,\"height\":20,\"width\":\"600\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_email\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":123,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1038\"},{\"id\":\"object1039\",\"group\":3,\"section\":0,\"objectType\":\"label\",\"left\":40,\"top\":335,\"height\":20,\"width\":\"250\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Ιστοσελίδα :\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":124,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1039\"},{\"id\":\"object1041\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":133,\"top\":335,\"height\":20,\"width\":600,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"school_web_page\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":126,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1041\"}]},{\"id\":\"\",\"top\":1078,\"height\":10,\"label\":\" Footer\",\"page_break\":\"1\",\"margins\":10,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1005\",\"group\":3,\"section\":1,\"objectType\":\"label\",\"left\":151,\"top\":0,\"height\":\"10\",\"width\":\"500\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":103,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1005\"}]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":427,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":1078,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":427,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":1078,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":427,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":1078,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":427,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":1078,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":427,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":1078,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":427,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":1078,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":427,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":1078,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]}],\"currentGroup\":0}','2015-04-16 17:19:54','globeadmin','2015-12-26 23:25:42','globeadmin','2016-01-24 12:35:46','globeadmin'),('553917b8d7b07cc','absence_all_class_day_table','Όλα τα απουσιολόγια των τμημάτων ενός καθηγητή','teacher','','5539081d564cca6','','{\"top\":30,\"left\":30,\"bottom\":658,\"right\":30,\"width\":\"210\",\"height\":\"297\",\"paper\":\"A4\",\"orientation\":\"P\",\"groups\":[{\"sortField\":\"Detail\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":231,\"height\":19,\"label\":\"Detail Header\",\"page_break\":\"0\",\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1032\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":46,\"top\":-1,\"height\":\"18\",\"width\":\"740\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"student_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":212,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1032\"},{\"id\":\"object1049\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":422,\"top\":-1,\"height\":\"18\",\"width\":\"100\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"absence_name1\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":224,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1049\"},{\"id\":\"object1051\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":474,\"top\":-1,\"height\":\"18\",\"width\":\"100\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"absence_name2\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":225,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1051\"},{\"id\":\"object1052\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":528,\"top\":-1,\"height\":\"18\",\"width\":\"100\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"absence_name3\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":226,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1052\"},{\"id\":\"object1053\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":578,\"top\":-1,\"height\":\"18\",\"width\":\"100\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"absence_name4\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":227,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1053\"},{\"id\":\"object1054\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":631,\"top\":-1,\"height\":\"18\",\"width\":\"100\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"absence_name5\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":228,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1054\"},{\"id\":\"object1055\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":684,\"top\":-1,\"height\":\"18\",\"width\":\"100\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"absence_name6\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":229,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1055\"},{\"id\":\"object1056\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":736,\"top\":-1,\"height\":\"18\",\"width\":\"50\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"absence_name7\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":230,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1056\"}]}]},{\"sortField\":\"Report\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":30,\"height\":10,\"label\":\"Report Header\",\"page_break\":\"0\",\"margins\":2,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":618,\"height\":10,\"label\":\"Report Footer\",\"page_break\":\"0\",\"margins\":14,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"Page\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":40,\"height\":2,\"label\":\"Page Header\",\"page_break\":\"0\",\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":618,\"height\":0,\"label\":\"Page Footer\",\"page_break\":\"0\",\"margins\":12,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"class_name\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":42,\"height\":0,\"label\":\" Header\",\"page_break\":\"0\",\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":600,\"height\":18,\"label\":\" Footer\",\"page_break\":\"1\",\"margins\":12,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1095\",\"group\":3,\"section\":1,\"objectType\":\"label\",\"left\":58,\"top\":0,\"height\":\"18\",\"width\":\"150\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":264,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1095\"}]}]},{\"sortField\":\"class_id\",\"sortBy\":\"\",\"sections\":[{\"id\":\"\",\"top\":42,\"height\":189,\"label\":\" Header\",\"page_break\":\"0\",\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1037\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":46,\"top\":99,\"height\":18,\"width\":150,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Τμήμα : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":216,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1037\"},{\"id\":\"object1018\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":46,\"top\":64,\"height\":15,\"width\":500,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Ημερομηνία Εκτύπωσης : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"7\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":\"200\",\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1018\"},{\"id\":\"object1014\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":46,\"top\":123,\"height\":18,\"width\":250,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Ημερομηνία : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":105,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1014\"},{\"id\":\"object1011\",\"group\":4,\"section\":0,\"objectType\":\"field\",\"left\":46,\"top\":45,\"height\":15,\"width\":600,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_year_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":104,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1011\"},{\"id\":\"object1008\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":27,\"top\":148,\"height\":30,\"width\":785,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Ημερήσιο Δελτίο Φοίτησης\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"14\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":102,\"minRows\":0,\"maxRows\":0,\"selected\":1,\"name\":\"object1008\"},{\"id\":\"object1007\",\"group\":4,\"section\":0,\"objectType\":\"field\",\"left\":46,\"top\":25,\"height\":15,\"width\":600,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":101,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1007\"},{\"id\":\"object1084\",\"group\":4,\"section\":0,\"objectType\":\"field\",\"left\":193,\"top\":64,\"height\":15,\"width\":200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"cur_date\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":254,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1084\"},{\"id\":\"object1085\",\"group\":4,\"section\":0,\"objectType\":\"field\",\"left\":174,\"top\":99,\"height\":18,\"width\":200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"class_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":255,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1085\"},{\"id\":\"object1086\",\"group\":4,\"section\":0,\"objectType\":\"field\",\"left\":174,\"top\":123,\"height\":18,\"width\":200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"abs_date\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":256,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1086\"}]},{\"id\":\"\",\"top\":250,\"height\":350,\"label\":\" Footer\",\"page_break\":\"0\",\"margins\":10,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1081\",\"group\":4,\"section\":1,\"objectType\":\"label\",\"left\":69,\"top\":285,\"height\":0,\"width\":760,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":252,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1080\",\"group\":4,\"section\":1,\"objectType\":\"label\",\"left\":69,\"top\":240,\"height\":0,\"width\":760,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":251,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1079\",\"group\":4,\"section\":1,\"objectType\":\"label\",\"left\":69,\"top\":200,\"height\":0,\"width\":760,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":250,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1078\",\"group\":4,\"section\":1,\"objectType\":\"label\",\"left\":69,\"top\":160,\"height\":0,\"width\":760,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":249,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1077\",\"group\":4,\"section\":1,\"objectType\":\"label\",\"left\":69,\"top\":116,\"height\":0,\"width\":760,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":248,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1076\",\"group\":4,\"section\":1,\"objectType\":\"label\",\"left\":69,\"top\":76,\"height\":0,\"width\":760,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":247,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1075\",\"group\":4,\"section\":1,\"objectType\":\"label\",\"left\":46,\"top\":32,\"height\":0,\"width\":250,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":246,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1075\"},{\"id\":\"object1065\",\"group\":4,\"section\":1,\"objectType\":\"field\",\"left\":69,\"top\":287,\"height\":18,\"width\":100,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"period_name7\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":238,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1065\"},{\"id\":\"object1064\",\"group\":4,\"section\":1,\"objectType\":\"field\",\"left\":69,\"top\":242,\"height\":18,\"width\":100,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"period_name6\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":237,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1064\"},{\"id\":\"object1063\",\"group\":4,\"section\":1,\"objectType\":\"field\",\"left\":69,\"top\":202,\"height\":18,\"width\":100,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"period_name5\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":236,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1063\"},{\"id\":\"object1062\",\"group\":4,\"section\":1,\"objectType\":\"field\",\"left\":69,\"top\":163,\"height\":18,\"width\":100,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"period_name4\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":235,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1062\"},{\"id\":\"object1061\",\"group\":4,\"section\":1,\"objectType\":\"field\",\"left\":69,\"top\":119,\"height\":18,\"width\":100,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"period_name3\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":234,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1061\"},{\"id\":\"object1060\",\"group\":4,\"section\":1,\"objectType\":\"field\",\"left\":69,\"top\":78,\"height\":18,\"width\":100,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"period_name2\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":233,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1060\"},{\"id\":\"object1059\",\"group\":4,\"section\":1,\"objectType\":\"field\",\"left\":69,\"top\":37,\"height\":18,\"width\":100,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"period_name1\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":232,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1059\"},{\"id\":\"object1058\",\"group\":4,\"section\":1,\"objectType\":\"label\",\"left\":46,\"top\":10,\"height\":18,\"width\":250,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Διδασκαλίες\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":231,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1058\"},{\"id\":\"object1087\",\"group\":4,\"section\":1,\"objectType\":\"field\",\"left\":130,\"top\":37,\"height\":18,\"width\":1200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"subject_name1\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":257,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1087\"},{\"id\":\"object1088\",\"group\":4,\"section\":1,\"objectType\":\"field\",\"left\":130,\"top\":78,\"height\":18,\"width\":1200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"subject_name2\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":258,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1088\"},{\"id\":\"object1089\",\"group\":4,\"section\":1,\"objectType\":\"field\",\"left\":130,\"top\":119,\"height\":18,\"width\":1200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"subject_name3\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":259,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1089\"},{\"id\":\"object1090\",\"group\":4,\"section\":1,\"objectType\":\"field\",\"left\":130,\"top\":163,\"height\":18,\"width\":1200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"subject_name4\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":260,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1090\"},{\"id\":\"object1091\",\"group\":4,\"section\":1,\"objectType\":\"field\",\"left\":130,\"top\":202,\"height\":18,\"width\":1200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"subject_name5\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":261,\"minRows\":\"0\",\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1091\"},{\"id\":\"object1092\",\"group\":4,\"section\":1,\"objectType\":\"field\",\"left\":130,\"top\":242,\"height\":18,\"width\":1200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"subject_name6\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":262,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1092\"},{\"id\":\"object1093\",\"group\":4,\"section\":1,\"objectType\":\"field\",\"left\":130,\"top\":287,\"height\":18,\"width\":1200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"subject_name7\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":263,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1093\"},{\"id\":\"object1100\",\"group\":4,\"section\":1,\"objectType\":\"label\",\"left\":69,\"top\":330,\"height\":0,\"width\":760,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":265,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1100\"}]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":231,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":250,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":231,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":250,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":231,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":250,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":231,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":250,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":231,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":250,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":231,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":250,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]}],\"currentGroup\":0}','2015-04-23 19:03:04','globeadmin','2018-02-18 17:39:26','globeadmin','2018-11-19 23:09:07','globeadmin'),('553cfc2bbc79d34','absence_totals','Κατάσταση με σύνολα απουσιών','teacher','','561c0a55ec1ed91','','{\"top\":30,\"left\":30,\"bottom\":410,\"right\":30,\"width\":\"210\",\"height\":\"297\",\"paper\":\"A4\",\"orientation\":\"P\",\"groups\":[{\"sortField\":\"Detail\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":250,\"height\":23,\"label\":\"Detail Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1051\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":25,\"top\":-1,\"height\":\"22\",\"width\":\"780\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"student_full_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"7.5\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":\"131\",\"minRows\":0,\"maxRows\":0,\"selected\":1,\"name\":\"object1048\"},{\"id\":\"object1053\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":685,\"top\":-1,\"height\":\"22\",\"width\":\"120\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"synolo\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"right\",\"image\":\"\",\"zIndex\":134,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1055\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":611,\"top\":-1,\"height\":\"22\",\"width\":\"120\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"dikaiologimenes\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"right\",\"image\":\"\",\"zIndex\":135,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1056\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":551,\"top\":-1,\"height\":\"22\",\"width\":\"100\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"adikaiologites\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"right\",\"image\":\"\",\"zIndex\":136,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"}]}]},{\"sortField\":\"Report\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":30,\"height\":24,\"label\":\"Report Header\",\"page_break\":\"0\",\"margins\":2,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":353,\"height\":27,\"label\":\"Report Footer\",\"page_break\":\"0\",\"margins\":10,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"Page\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":54,\"height\":196,\"label\":\"Page Header\",\"page_break\":\"0\",\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1087\",\"group\":2,\"section\":0,\"objectType\":\"field\",\"left\":25,\"top\":48,\"height\":20,\"width\":\"500\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"cur_date\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":144,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1087\"},{\"id\":\"object1046\",\"group\":2,\"section\":0,\"objectType\":\"label\",\"left\":27,\"top\":92,\"height\":20,\"width\":\"800\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Συνοπτική Κατάσταση Απουσιών\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"12\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":129,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1046\"},{\"id\":\"object1012\",\"group\":2,\"section\":0,\"objectType\":\"field\",\"left\":25,\"top\":23,\"height\":20,\"width\":800,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":107,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1012\"},{\"id\":\"object1090\",\"group\":2,\"section\":0,\"objectType\":\"label\",\"left\":25,\"top\":172,\"height\":\"22\",\"width\":780,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Μαθητής\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":146,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1091\",\"group\":2,\"section\":0,\"objectType\":\"label\",\"left\":555,\"top\":172,\"height\":\"22\",\"width\":\"250\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Σύνολο\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"right\",\"image\":\"\",\"zIndex\":147,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1091\"},{\"id\":\"object1092\",\"group\":2,\"section\":0,\"objectType\":\"label\",\"left\":551,\"top\":172,\"height\":\"22\",\"width\":\"180\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Δικαιολ.\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"right\",\"image\":\"\",\"zIndex\":148,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1092\"},{\"id\":\"object1093\",\"group\":2,\"section\":0,\"objectType\":\"label\",\"left\":551,\"top\":172,\"height\":\"22\",\"width\":\"100\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Αδικ.\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"right\",\"image\":\"\",\"zIndex\":149,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1093\"},{\"id\":\"object1097\",\"group\":2,\"section\":0,\"objectType\":\"field\",\"left\":27,\"top\":114,\"height\":20,\"width\":\"800\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"text2\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"9\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":151,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1097\"}]},{\"id\":\"\",\"top\":273,\"height\":80,\"label\":\"Page Footer\",\"page_break\":\"0\",\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1095\",\"group\":2,\"section\":1,\"objectType\":\"label\",\"left\":25,\"top\":12,\"height\":20,\"width\":\"780\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Σελίδα #page# από #pages#\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"9\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":150,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"}]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":250,\"height\":0,\"label\":\" Header\",\"page_break\":\"0\",\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":273,\"height\":0,\"label\":\" Footer\",\"page_break\":\"1\",\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":250,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":273,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":250,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":273,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":250,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":273,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":250,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":273,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":250,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":273,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":250,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":273,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":250,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":273,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]}],\"currentGroup\":0}','2015-04-26 17:54:35','globeadmin','2015-10-12 22:35:03','globeadmin','2018-02-20 20:13:01','globeadmin'),('555e385e069287c','attendance_book','Βιβλίο φοίτησης','teacher','','555d8a344f6f95a','','{\"top\":30,\"left\":30,\"bottom\":459,\"right\":30,\"width\":\"297\",\"height\":\"210\",\"paper\":\"A4\",\"orientation\":\"L\",\"groups\":[{\"sortField\":\"Detail\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":198,\"height\":56,\"label\":\"Detail Header\",\"page_break\":\"0\",\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1046\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":25,\"top\":0,\"height\":\"54\",\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"month_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":223,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1046\"},{\"id\":\"object1047\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":136,\"top\":0,\"height\":\"18\",\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Σύνολο Απουσιών\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":224,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1048\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":136,\"top\":18,\"height\":\"18\",\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Δεν Προσμετρώνται\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":225,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1049\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":136,\"top\":36,\"height\":18,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Μετρήσιμες\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":226,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1050\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":256,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss1\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":227,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1051\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":284,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss2\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":228,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1052\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":312,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss3\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":229,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1053\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":340,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss4\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":230,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1054\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":368,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss5\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":231,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1055\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":395,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss6\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":232,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1056\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":423,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss7\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":233,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1057\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":451,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss8\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":234,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1058\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":479,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss9\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":235,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1059\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":507,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss10\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":236,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1060\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":535,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss11\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":237,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1061\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":562,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss12\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":238,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1062\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":590,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss13\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":239,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1063\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":618,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss14\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":240,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1064\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":646,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss15\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":241,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1065\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":674,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss16\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":242,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1066\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":702,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss17\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":243,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1067\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":730,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss18\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":244,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1068\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":758,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss19\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":245,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1069\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":785,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss20\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":246,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1070\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":813,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss21\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":247,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1071\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":841,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss22\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":248,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1072\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":869,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss23\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":249,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1073\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":897,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss24\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":250,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1074\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":925,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss25\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":251,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1075\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":953,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss26\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":252,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1076\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":980,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss27\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":253,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1077\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":1008,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss28\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":254,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1078\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":1036,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss29\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":255,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1079\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":1064,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss30\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":256,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1080\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":1092,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss31\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":257,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1082\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":256,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g1\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":258,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1083\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":284,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g2\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":259,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1084\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":312,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g3\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":260,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1085\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":340,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g4\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":261,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1086\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":368,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g5\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":262,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1087\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":395,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g6\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":263,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1088\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":423,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g7\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":264,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1089\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":451,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g8\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":265,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1090\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":479,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g9\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":266,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1091\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":507,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g10\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":267,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1092\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":535,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g11\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":268,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1093\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":562,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g12\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":269,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1094\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":590,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g13\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":270,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1095\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":618,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g14\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":271,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1096\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":646,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g15\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":272,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1097\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":674,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g16\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":273,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1098\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":702,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g17\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":274,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1099\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":730,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g18\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":275,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1100\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":758,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g19\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":276,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1101\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":785,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g20\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":277,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1102\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":813,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g21\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":278,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1103\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":841,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g22\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":279,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1104\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":869,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g23\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":280,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1105\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":897,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g24\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":281,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1106\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":925,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g25\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":282,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1107\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":953,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g26\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":283,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1108\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":980,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g27\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":284,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1109\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":1008,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g28\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":285,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1110\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":1036,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g29\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":286,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1111\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":1064,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g30\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":287,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1112\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":1092,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g31\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":288,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1113\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":256,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s1\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":289,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1114\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":284,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s2\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":290,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1115\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":312,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s3\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":291,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1116\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":340,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s4\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":292,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1117\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":368,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s5\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":293,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1118\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":395,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s6\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":294,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1119\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":423,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s7\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":295,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1120\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":451,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s8\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":296,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1121\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":479,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s9\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":297,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1122\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":507,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s10\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":298,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1123\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":535,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s11\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":299,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1124\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":562,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s12\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":300,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1125\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":590,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s13\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":301,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1126\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":618,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s14\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":302,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1127\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":646,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s15\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":303,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1128\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":674,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s16\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":304,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1129\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":702,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s17\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":305,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1130\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":730,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s18\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":306,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1131\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":758,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s19\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":307,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1132\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":785,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s20\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":308,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1133\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":813,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s21\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":309,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1134\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":841,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s22\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":310,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1135\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":869,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s23\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":311,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1136\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":897,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s24\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":312,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1137\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":925,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s25\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":313,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1138\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":953,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s26\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":314,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1139\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":980,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s27\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":315,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1140\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":1008,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s28\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":316,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1141\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":1036,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s29\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":317,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1142\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":1064,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s30\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":318,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1143\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":1092,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s31\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":319,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1182\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":1122,\"top\":0,\"height\":18,\"width\":\"35\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ssm\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":355,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1183\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":1122,\"top\":18,\"height\":18,\"width\":\"35\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"gm\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":356,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1184\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":1122,\"top\":36,\"height\":18,\"width\":\"35\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"sm\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":357,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"}]}]},{\"sortField\":\"Report\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":30,\"height\":10,\"label\":\"Report Header\",\"page_break\":\"0\",\"margins\":2,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":360,\"height\":69,\"label\":\"Report Footer\",\"page_break\":\"0\",\"margins\":14,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"Page\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":40,\"height\":10,\"label\":\"Page Header\",\"page_break\":\"0\",\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":360,\"height\":0,\"label\":\"Page Footer\",\"page_break\":\"0\",\"margins\":12,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"s_id\",\"sortBy\":\"\",\"sections\":[{\"id\":\"\",\"top\":50,\"height\":0,\"label\":\" Header\",\"page_break\":\"0\",\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":344,\"height\":16,\"label\":\" Footer\",\"page_break\":\"1\",\"margins\":12,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1188\",\"group\":3,\"section\":1,\"objectType\":\"label\",\"left\":150,\"top\":0,\"height\":\"10\",\"width\":\"30\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":359,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1188\"}]}]},{\"sortField\":\"student_id\",\"sortBy\":\"\",\"sections\":[{\"id\":\"\",\"top\":50,\"height\":148,\"label\":\" Header\",\"page_break\":\"0\",\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1014\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":25,\"top\":53,\"height\":18,\"width\":200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Μαθητής : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":105,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1014\"},{\"id\":\"object1018\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":26,\"top\":32,\"height\":15,\"width\":500,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Ημερομηνία : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"7\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":\"200\",\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1018\"},{\"id\":\"object1011\",\"group\":4,\"section\":0,\"objectType\":\"field\",\"left\":561,\"top\":10,\"height\":15,\"width\":600,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_year_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"right\",\"image\":\"\",\"zIndex\":104,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1011\"},{\"id\":\"object1007\",\"group\":4,\"section\":0,\"objectType\":\"field\",\"left\":25,\"top\":10,\"height\":15,\"width\":600,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":101,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1007\"},{\"id\":\"object1008\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":49,\"top\":86,\"height\":25,\"width\":1050,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Βιβλίο Φοίτησης Μαθητή\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"14\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":102,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1008\"},{\"id\":\"object1146\",\"group\":4,\"section\":0,\"objectType\":\"field\",\"left\":147,\"top\":32,\"height\":15,\"width\":200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"cur_date\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":321,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1146\"},{\"id\":\"object1147\",\"group\":4,\"section\":0,\"objectType\":\"field\",\"left\":103,\"top\":53,\"height\":18,\"width\":1075,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"student_full_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":322,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1147\"},{\"id\":\"object1179\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":1092,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"31\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":353,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1178\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":1064,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"30\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":352,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1177\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":1036,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"29\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":351,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1176\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":1008,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"28\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":350,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1175\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":980,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"27\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":349,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1174\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":953,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"26\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":348,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1173\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":925,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"25\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":347,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1172\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":897,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"24\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":346,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1171\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":869,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"23\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":345,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1170\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":841,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"22\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":344,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1169\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":813,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"21\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":343,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1168\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":785,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"20\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":342,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1167\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":758,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"19\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":341,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1166\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":730,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"18\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":340,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1165\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":702,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"17\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":339,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1164\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":674,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"16\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":338,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1163\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":646,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"15\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":337,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1162\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":618,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"14\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":336,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1161\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":590,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"13\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":335,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1160\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":562,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"12\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":334,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1159\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":535,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"11\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":333,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1158\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":507,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"10\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":332,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1157\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":479,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"9\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":331,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1156\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":451,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"8\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":330,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1155\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":423,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"7\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":329,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1154\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":395,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"6\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":328,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1153\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":368,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"5\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":327,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1152\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":340,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"4\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":326,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1151\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":312,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"3\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":325,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1150\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":284,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"2\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":324,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1149\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":256,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"1\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":323,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1181\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":1122,\"top\":128,\"height\":18,\"width\":\"35\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Σ\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":354,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"}]},{\"id\":\"\",\"top\":254,\"height\":90,\"label\":\" Footer\",\"page_break\":\"0\",\"margins\":10,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1190\",\"group\":4,\"section\":1,\"objectType\":\"label\",\"left\":736,\"top\":38,\"height\":18,\"width\":450,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Δεν Προσμετρώνται : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":360,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1190\"},{\"id\":\"object1191\",\"group\":4,\"section\":1,\"objectType\":\"label\",\"left\":736,\"top\":60,\"height\":18,\"width\":450,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Σύνολο Μετρήσιμων : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":361,\"minRows\":0,\"maxRows\":0,\"selected\":1,\"name\":\"object1191\"},{\"id\":\"object1192\",\"group\":4,\"section\":1,\"objectType\":\"label\",\"left\":736,\"top\":17,\"height\":18,\"width\":450,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Σύνολο Απουσιών : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":362,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1192\"},{\"id\":\"object1194\",\"group\":4,\"section\":1,\"objectType\":\"field\",\"left\":953,\"top\":38,\"height\":18,\"width\":40,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"SUM(gm)\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"right\",\"image\":\"\",\"zIndex\":364,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1195\",\"group\":4,\"section\":1,\"objectType\":\"field\",\"left\":953,\"top\":59,\"height\":18,\"width\":40,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"SUM(sm)\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"right\",\"image\":\"\",\"zIndex\":365,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1196\",\"group\":4,\"section\":1,\"objectType\":\"field\",\"left\":953,\"top\":17,\"height\":18,\"width\":40,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"SUM(ssm)\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"right\",\"image\":\"\",\"zIndex\":366,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1198\",\"group\":4,\"section\":1,\"objectType\":\"label\",\"left\":736,\"top\":37,\"height\":0,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":367,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1198\"},{\"id\":\"object1200\",\"group\":4,\"section\":1,\"objectType\":\"label\",\"left\":736,\"top\":56,\"height\":0,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":368,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1200\"},{\"id\":\"object1201\",\"group\":4,\"section\":1,\"objectType\":\"label\",\"left\":736,\"top\":80,\"height\":0,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":369,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1201\"}]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":198,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":254,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":198,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":254,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":198,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":254,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":198,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":254,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":198,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":254,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":198,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":254,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]}],\"currentGroup\":0}','2015-05-21 22:56:14','globeadmin','2018-08-06 23:19:08','globeadmin','2021-02-03 20:08:38','globeadmin'),('556460424caeb6a','attendance_student_book','Βιβλίο φοίτησης ενός μαθητή','teacher','','555d8a344f6f95a','','{\"top\":30,\"left\":30,\"bottom\":459,\"right\":30,\"width\":\"297\",\"height\":\"210\",\"paper\":\"A4\",\"orientation\":\"L\",\"groups\":[{\"sortField\":\"Detail\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":198,\"height\":56,\"label\":\"Detail Header\",\"page_break\":\"0\",\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1046\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":25,\"top\":0,\"height\":\"54\",\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"month_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":223,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1046\"},{\"id\":\"object1047\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":136,\"top\":0,\"height\":\"18\",\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Σύνολο Απουσιών\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":224,\"minRows\":0,\"maxRows\":0,\"selected\":1,\"name\":\"\"},{\"id\":\"object1048\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":136,\"top\":18,\"height\":18,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Δεν Προσμετρώνται\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":225,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1049\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":136,\"top\":36,\"height\":18,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Μετρήσιμες\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":226,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1050\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":256,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss1\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":227,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1051\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":284,\"top\":0,\"height\":18,\"width\":\"27\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss2\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":228,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1052\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":312,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss3\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":229,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1053\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":340,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss4\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":230,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1054\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":368,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss5\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":231,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1055\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":395,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss6\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":232,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1056\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":423,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss7\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":233,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1057\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":451,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss8\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":234,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1058\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":479,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss9\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":235,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1059\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":507,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss10\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":236,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1060\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":535,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss11\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":237,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1061\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":562,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss12\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":238,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1062\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":590,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss13\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":239,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1063\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":618,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss14\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":240,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1064\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":646,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss15\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":241,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1065\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":674,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss16\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":242,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1066\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":702,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss17\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":243,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1067\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":730,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss18\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":244,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1068\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":758,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss19\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":245,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1069\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":785,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss20\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":246,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1070\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":813,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss21\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":247,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1071\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":841,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss22\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":248,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1072\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":869,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss23\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":249,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1073\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":897,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss24\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":250,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1074\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":925,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss25\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":251,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1075\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":953,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss26\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":252,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1076\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":980,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss27\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":253,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1077\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":1008,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss28\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":254,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1078\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":1036,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss29\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":255,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1079\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":1064,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss30\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":256,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1080\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":1092,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ss31\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":257,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1082\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":256,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g1\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":258,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1083\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":284,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g2\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":259,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1084\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":312,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g3\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":260,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1085\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":340,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g4\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":261,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1086\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":368,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g5\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":262,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1087\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":395,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g6\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":263,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1088\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":423,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g7\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":264,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1089\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":451,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g8\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":265,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1090\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":479,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g9\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":266,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1091\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":507,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g10\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":267,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1092\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":535,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g11\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":268,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1093\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":562,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g12\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":269,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1094\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":590,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g13\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":270,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1095\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":618,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g14\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":271,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1096\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":646,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g15\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":272,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1097\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":674,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g16\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":273,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1098\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":702,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g17\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":274,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1099\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":730,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g18\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":275,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1100\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":758,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g19\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":276,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1101\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":785,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g20\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":277,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1102\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":813,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g21\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":278,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1103\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":841,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g22\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":279,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1104\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":869,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g23\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":280,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1105\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":897,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g24\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":281,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1106\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":925,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g25\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":282,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1107\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":953,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g26\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":283,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1108\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":980,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g27\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":284,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1109\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":1008,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g28\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":285,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1110\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":1036,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g29\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":286,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1111\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":1064,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g30\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":287,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1112\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":1092,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"g31\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":288,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1113\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":256,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s1\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":289,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1114\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":284,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s2\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":290,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1115\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":312,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s3\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":291,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1116\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":340,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s4\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":292,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1117\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":368,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s5\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":293,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1118\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":395,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s6\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":294,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1119\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":423,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s7\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":295,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1120\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":451,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s8\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":296,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1121\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":479,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s9\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":297,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1122\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":507,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s10\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":298,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1123\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":535,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s11\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":299,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1124\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":562,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s12\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":300,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1125\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":590,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s13\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":301,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1126\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":618,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s14\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":302,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1127\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":646,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s15\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":303,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1128\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":674,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s16\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":304,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1129\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":702,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s17\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":305,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1130\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":730,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s18\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":306,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1131\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":758,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s19\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":307,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1132\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":785,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s20\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":308,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1133\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":813,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s21\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":309,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1134\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":841,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s22\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":310,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1135\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":869,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s23\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":311,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1136\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":897,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s24\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":312,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1137\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":925,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s25\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":313,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1138\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":953,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s26\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":314,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1139\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":980,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s27\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":315,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1140\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":1008,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s28\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":316,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1141\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":1036,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s29\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":317,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1142\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":1064,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s30\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":318,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1143\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":1092,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s31\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":319,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1182\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":1122,\"top\":0,\"height\":18,\"width\":\"35\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"ssm\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":355,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1183\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":1122,\"top\":18,\"height\":18,\"width\":\"35\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"gm\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":356,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1184\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":1122,\"top\":36,\"height\":18,\"width\":\"35\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"sm\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":357,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"}]}]},{\"sortField\":\"Report\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":30,\"height\":10,\"label\":\"Report Header\",\"page_break\":\"0\",\"margins\":2,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":360,\"height\":69,\"label\":\"Report Footer\",\"page_break\":\"0\",\"margins\":14,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"Page\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":40,\"height\":10,\"label\":\"Page Header\",\"page_break\":\"0\",\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":360,\"height\":0,\"label\":\"Page Footer\",\"page_break\":\"0\",\"margins\":12,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"s_id\",\"sortBy\":\"\",\"sections\":[{\"id\":\"\",\"top\":50,\"height\":0,\"label\":\" Header\",\"page_break\":\"0\",\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":344,\"height\":16,\"label\":\" Footer\",\"page_break\":\"0\",\"margins\":12,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1188\",\"group\":3,\"section\":1,\"objectType\":\"label\",\"left\":150,\"top\":0,\"height\":\"10\",\"width\":\"30\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":359,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1188\"}]}]},{\"sortField\":\"student_id\",\"sortBy\":\"\",\"sections\":[{\"id\":\"\",\"top\":50,\"height\":148,\"label\":\" Header\",\"page_break\":\"0\",\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1014\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":25,\"top\":53,\"height\":18,\"width\":200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Μαθητής : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":105,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1014\"},{\"id\":\"object1018\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":26,\"top\":32,\"height\":15,\"width\":500,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Ημερομηνία : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"7\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":\"200\",\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1018\"},{\"id\":\"object1011\",\"group\":4,\"section\":0,\"objectType\":\"field\",\"left\":561,\"top\":10,\"height\":15,\"width\":600,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_year_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"right\",\"image\":\"\",\"zIndex\":104,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1011\"},{\"id\":\"object1007\",\"group\":4,\"section\":0,\"objectType\":\"field\",\"left\":25,\"top\":10,\"height\":15,\"width\":600,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":101,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1007\"},{\"id\":\"object1008\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":49,\"top\":86,\"height\":25,\"width\":1050,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Βιβλίο Φοίτησης Μαθητή\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"14\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":102,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1008\"},{\"id\":\"object1146\",\"group\":4,\"section\":0,\"objectType\":\"field\",\"left\":147,\"top\":32,\"height\":15,\"width\":200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"cur_date\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":321,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1146\"},{\"id\":\"object1147\",\"group\":4,\"section\":0,\"objectType\":\"field\",\"left\":103,\"top\":53,\"height\":18,\"width\":1075,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"student_full_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":322,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1147\"},{\"id\":\"object1179\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":1092,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"31\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":353,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1178\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":1064,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"30\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":352,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1177\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":1036,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"29\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":351,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1176\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":1008,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"28\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":350,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1175\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":980,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"27\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":349,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1174\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":953,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"26\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":348,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1173\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":925,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"25\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":347,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1172\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":897,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"24\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":346,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1171\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":869,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"23\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":345,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1170\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":841,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"22\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":344,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1169\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":813,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"21\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":343,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1168\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":785,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"20\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":342,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1167\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":758,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"19\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":341,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1166\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":730,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"18\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":340,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1165\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":702,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"17\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":339,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1164\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":674,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"16\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":338,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1163\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":646,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"15\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":337,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1162\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":618,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"14\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":336,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1161\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":590,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"13\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":335,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1160\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":562,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"12\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":334,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1159\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":535,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"11\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":333,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1158\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":507,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"10\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":332,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1157\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":479,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"9\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":331,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1156\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":451,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"8\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":330,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1155\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":423,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"7\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":329,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1154\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":395,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"6\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":328,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1153\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":368,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"5\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":327,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1152\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":340,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"4\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":326,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1151\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":312,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"3\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":325,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1150\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":284,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"2\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":324,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1149\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":256,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"1\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":323,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1181\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":1122,\"top\":128,\"height\":18,\"width\":\"35\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Σ\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":354,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"}]},{\"id\":\"\",\"top\":254,\"height\":90,\"label\":\" Footer\",\"page_break\":\"0\",\"margins\":10,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1190\",\"group\":4,\"section\":1,\"objectType\":\"label\",\"left\":736,\"top\":38,\"height\":18,\"width\":450,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Δεν Προσμετρώνται : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":360,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1190\"},{\"id\":\"object1191\",\"group\":4,\"section\":1,\"objectType\":\"label\",\"left\":736,\"top\":60,\"height\":18,\"width\":450,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Σύνολο Μετρήσιμων : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":361,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1191\"},{\"id\":\"object1192\",\"group\":4,\"section\":1,\"objectType\":\"label\",\"left\":736,\"top\":17,\"height\":18,\"width\":450,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Σύνολο Απουσιών : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":362,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1192\"},{\"id\":\"object1194\",\"group\":4,\"section\":1,\"objectType\":\"field\",\"left\":953,\"top\":38,\"height\":18,\"width\":40,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"SUM(gm)\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"right\",\"image\":\"\",\"zIndex\":364,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1195\",\"group\":4,\"section\":1,\"objectType\":\"field\",\"left\":953,\"top\":59,\"height\":18,\"width\":40,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"SUM(sm)\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"right\",\"image\":\"\",\"zIndex\":365,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1196\",\"group\":4,\"section\":1,\"objectType\":\"field\",\"left\":953,\"top\":17,\"height\":18,\"width\":40,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"SUM(ssm)\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"right\",\"image\":\"\",\"zIndex\":366,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1198\",\"group\":4,\"section\":1,\"objectType\":\"label\",\"left\":736,\"top\":37,\"height\":0,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":367,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1198\"},{\"id\":\"object1200\",\"group\":4,\"section\":1,\"objectType\":\"label\",\"left\":736,\"top\":56,\"height\":0,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":368,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1200\"},{\"id\":\"object1201\",\"group\":4,\"section\":1,\"objectType\":\"label\",\"left\":736,\"top\":80,\"height\":0,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":369,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1201\"}]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":198,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":254,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":198,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":254,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":198,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":254,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":198,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":254,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":198,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":254,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":198,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":254,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]}],\"currentGroup\":0}','2015-05-26 15:00:02','globeadmin','2018-08-06 19:00:38','globeadmin','2021-02-03 20:08:44','globeadmin'),('556dfec63aa0e9d','students_conpare_full','Τυπώνει συγκριτικό των στοιχείων των μαθητών με τα προς εισαγωγή στοιχεία (από το myschool)','manager','SELECT  \n        if(has_left_school=1,\'ΝΑΙ\',\'ΟΧΙ\') as hls,\n        \n        if(student.name=student_in.name, student.name, concat(\'#B#FF6060|\',ifnull(student.name,\'\')))                                                                as student_name,\n        if(student.surname=student_in.surname, student.surname, concat(\'#B#FF6060|\',ifnull(student.surname,\'\')))                                                    as student_surname,\n        if(student.fathers_name=student_in.fathers_name, student.fathers_name, concat(\'#B#FF6060|\',ifnull(student.fathers_name,\'\')))                                as student_fathers_name,\n        if(student.mothers_name=student_in.mothers_name, student.mothers_name, concat(\'#B#FF6060|\',ifnull(student.mothers_name,\'\')))                                as student_mothers_name,\n        if(student.registration_number=student_in.registration_number, student.registration_number, concat(\'#B#FF6060|\',ifnull(student.registration_number,\'\')))    as student_registration_number,\n        if(student.gender=student_in.gender, student.gender, concat(\'#B#FF6060|\',ifnull(student.gender,\'\')))                                                        as student_gender,\n        if(student.birth_date=student_in.birth_date, DATE_FORMAT(student.birth_date,\'%d-%m-%Y\'), concat(\'#B#FF6060|\',DATE_FORMAT(student.birth_date,\'%d-%m-%Y\')))   as student_birth_date,\n        \n        if(student.phone1=student_in.phone1, student.phone1, concat(\'#B#FF6060|\',ifnull(student.phone1,\'\')))                                                        as student_phone1,\n        if(student.phone2=student_in.phone2, student.phone2, concat(\'#B#FF6060|\',ifnull(student.phone2,\'\')))                                                        as student_phone2,\n        if(student.mobile=student_in.mobile, student.mobile, concat(\'#B#FF6060|\',ifnull(student.mobile,\'\')))                                                        as student_mobile,\n        if(student.email=student_in.email, student.email, concat(\'#B#FF6060|\',ifnull(student.email,\'\')))                                                            as student_email,\n        if(student.street=student_in.street, student.street, concat(\'#B#FF6060|\',ifnull(student.street,\'\')))                                                        as student_street,\n        if(student.area=student_in.area, student.area, concat(\'#B#FF6060|\',ifnull(student.area,\'\')))                                                                as student_area,\n        if(student.zipcode=student_in.zipcode, student.zipcode, concat(\'#B#FF6060|\',ifnull(student.zipcode,\'\')))                                                    as student_zipcode,\n        if(student.city=student_in.city, student.city, concat(\'#B#FF6060|\',ifnull(student.city,\'\')))                                                                as student_city,\n        \n        if(student.parent_name=student_in.parent_name, student.parent_name, concat(\'#B#FF6060|\',ifnull(student.parent_name,\'\')))                                    as student_parent_name,\n        if(student.parent_surname=student_in.parent_surname, student.parent_surname, concat(\'#B#FF6060|\',ifnull(student.parent_surname,\'\')))                        as student_parent_surname,\n        \n        if(student.parent_phone1=student_in.parent_phone1, student.parent_phone1, concat(\'#B#FF6060|\',ifnull(student.parent_phone1,\'\')))                            as student_parent_phone1,\n        if(student.parent_phone2=student_in.parent_phone2, student.parent_phone2, concat(\'#B#FF6060|\',ifnull(student.parent_phone2,\'\')))                            as student_parent_phone2,\n        if(student.parent_phone3=student_in.parent_phone3, student.parent_phone3, concat(\'#B#FF6060|\',ifnull(student.parent_phone3,\'\')))                            as student_parent_phone3,\n        if(student.parent_email=student_in.parent_email, student.parent_email, concat(\'#B#FF6060|\',ifnull(student.parent_email,\'\')))                                as student_parent_email,\n        if(student.parent_street=student_in.parent_street, student.parent_street, concat(\'#B#FF6060|\',ifnull(student.parent_street,\'\')))                            as student_parent_street,\n        if(student.parent_area=student_in.parent_area, student.parent_area, concat(\'#B#FF6060|\',ifnull(student.parent_area,\'\')))                                    as student_parent_area,\n        if(student.parent_zipcode=student_in.parent_zipcode, student.parent_zipcode, concat(\'#B#FF6060|\',ifnull(student.parent_zipcode,\'\')))                        as student_parent_zipcode,\n        \n        grade.short_name as student_grade_short_name,\n        school.name as school_name,\n        school_year.name as school_year_name,\n        DATE_FORMAT(curdate(),\'%d-%m-%Y\') as cur_date \nFROM student,school,school_year,student_in,grade\n    WHERE\n        \n        school_year.id=school.school_year_id and\n        student.grade_id=grade.id and\n        student.id=student_in.student_id and \n        (student.name               !=  student_in.name                 OR\n        student.surname             !=  student_in.surname              OR\n        student.fathers_name        !=  student_in.fathers_name         OR\n        student.mothers_name        !=  student_in.mothers_name         OR\n        student.registration_number !=  student_in.registration_number  OR\n        student.gender              !=  student_in.gender               OR\n        student.birth_date          !=  student_in.birth_date           OR\n        \n        student.phone1              !=  student_in.phone1               OR\n        student.phone2              !=  student_in.phone2               OR\n        student.mobile              !=  student_in.mobile               OR\n        student.email               !=  student_in.email                OR\n        student.street              !=  student_in.street               OR\n        student.area                !=  student_in.area                 OR\n        student.zipcode             !=  student_in.zipcode              OR\n        student.city                !=  student_in.city                 OR\n        \n        student.parent_name         !=  student_in.parent_name          OR\n        student.parent_surname      !=  student_in.parent_surname       OR\n        \n        student.parent_phone1       !=  student_in.parent_phone1        OR\n        student.parent_phone2       !=  student_in.parent_phone2        OR\n        student.parent_phone3       !=  student_in.parent_phone3        OR\n        student.parent_email        !=  student_in.parent_email         OR\n        student.parent_street       !=  student_in.parent_street        OR\n        student.parent_area         !=  student_in.parent_area          OR\n        student.parent_zipcode      !=  student_in.parent_zipcode\n            )\n\nORDER BY student.grade_id,student.surname,student.name,student.fathers_name\n','','','{\"top\":30,\"left\":30,\"bottom\":428,\"right\":30,\"width\":\"297\",\"height\":\"210\",\"paper\":\"A4\",\"orientation\":\"L\",\"groups\":[{\"sortField\":\"Detail\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":140,\"height\":241,\"label\":\"Detail Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1059\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":77,\"top\":10,\"height\":15,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Επώνυμο\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":233,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1060\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":76,\"top\":170,\"height\":15,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Τηλέφωνο 1\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":234,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1060\"},{\"id\":\"object1062\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":257,\"top\":10,\"height\":15,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"student_surname\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":235,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1063\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":257,\"top\":170,\"height\":15,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"student_phone1\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":236,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1063\"},{\"id\":\"object1065\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":76,\"top\":185,\"height\":15,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Τηλέφωνο 2\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":237,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1065\"},{\"id\":\"object1066\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":257,\"top\":185,\"height\":15,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"student_phone2\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":238,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1066\"},{\"id\":\"object1067\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":76,\"top\":200,\"height\":15,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Κινητό\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":239,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1067\"},{\"id\":\"object1068\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":257,\"top\":200,\"height\":15,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"student_mobile\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":240,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1068\"},{\"id\":\"object1069\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":76,\"top\":215,\"height\":15,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Email\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":241,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1069\"},{\"id\":\"object1070\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":257,\"top\":215,\"height\":15,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"student_email\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":242,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1070\"},{\"id\":\"object1074\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":76,\"top\":110,\"height\":15,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Διεύθυνση\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":244,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1074\"},{\"id\":\"object1075\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":257,\"top\":110,\"height\":15,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"student_street\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":245,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1075\"},{\"id\":\"object1076\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":76,\"top\":125,\"height\":15,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Περιοχή\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":246,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1076\"},{\"id\":\"object1077\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":257,\"top\":125,\"height\":15,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"student_area\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":247,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1077\"},{\"id\":\"object1078\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":76,\"top\":155,\"height\":15,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Τ.Κ.\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":248,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1078\"},{\"id\":\"object1079\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":257,\"top\":155,\"height\":15,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"student_zipcode\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":249,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1079\"},{\"id\":\"object1080\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":76,\"top\":140,\"height\":15,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Πόλη\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":250,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1080\"},{\"id\":\"object1081\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":257,\"top\":140,\"height\":15,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"student_city\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":251,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1081\"},{\"id\":\"object1058\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":51,\"top\":3,\"height\":\"1\",\"width\":\"1100\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":232,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1058\"},{\"id\":\"object1083\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":616,\"top\":70,\"height\":15,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Επώνυμο\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":252,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1083\"},{\"id\":\"object1084\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":616,\"top\":155,\"height\":15,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Τηλέφωνο 1\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":253,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1084\"},{\"id\":\"object1085\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":797,\"top\":70,\"height\":15,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"student_parent_surname\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":254,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1085\"},{\"id\":\"object1086\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":797,\"top\":155,\"height\":15,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"student_parent_phone1\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":255,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1086\"},{\"id\":\"object1087\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":616,\"top\":170,\"height\":15,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Τηλέφωνο 2\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":256,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1087\"},{\"id\":\"object1088\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":797,\"top\":170,\"height\":15,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"student_parent_phone2\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":257,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1088\"},{\"id\":\"object1089\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":616,\"top\":185,\"height\":15,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Τηλέφωνο 3\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":258,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1089\"},{\"id\":\"object1090\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":797,\"top\":185,\"height\":15,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"student_parent_phone3\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":259,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1090\"},{\"id\":\"object1091\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":616,\"top\":200,\"height\":15,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Email\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":260,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1091\"},{\"id\":\"object1092\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":797,\"top\":200,\"height\":15,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"student_parent_email\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":261,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1092\"},{\"id\":\"object1093\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":616,\"top\":110,\"height\":15,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Διεύθυνση\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":262,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1093\"},{\"id\":\"object1094\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":797,\"top\":110,\"height\":15,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"student_paranet_street\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":263,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1094\"},{\"id\":\"object1095\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":616,\"top\":125,\"height\":15,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Περιοχή\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":264,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1095\"},{\"id\":\"object1096\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":797,\"top\":125,\"height\":15,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"student_paranet_area\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":265,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1096\"},{\"id\":\"object1097\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":616,\"top\":140,\"height\":15,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Τ.Κ.\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":266,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1097\"},{\"id\":\"object1098\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":797,\"top\":140,\"height\":15,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"student_paranet_zipcode\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":267,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1098\"},{\"id\":\"object1099\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":616,\"top\":215,\"height\":15,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Έχει Εγκαταλείψει\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":268,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1099\"},{\"id\":\"object1100\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":797,\"top\":215,\"height\":15,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"hls\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":269,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1100\"},{\"id\":\"object1103\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":76,\"top\":25,\"height\":15,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Όνομα\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":270,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1104\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":257,\"top\":25,\"height\":15,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"student_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":271,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1105\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":76,\"top\":40,\"height\":15,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Όνομα Πατρός\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":272,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1105\"},{\"id\":\"object1106\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":257,\"top\":40,\"height\":15,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"student_fathers_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":273,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1106\"},{\"id\":\"object1107\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":76,\"top\":55,\"height\":15,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Όνομα Μητρός\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":274,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1107\"},{\"id\":\"object1108\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":257,\"top\":55,\"height\":15,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"student_mothers_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":275,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1108\"},{\"id\":\"object1109\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":76,\"top\":70,\"height\":15,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Φύλο\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":276,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1109\"},{\"id\":\"object1110\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":257,\"top\":70,\"height\":15,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"student_gender\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":277,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1110\"},{\"id\":\"object1111\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":76,\"top\":84,\"height\":15,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Ημερομηνία Γέννησης\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":278,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1111\"},{\"id\":\"object1112\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":257,\"top\":84,\"height\":15,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"student_birth_date\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":279,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1112\"},{\"id\":\"object1114\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":616,\"top\":85,\"height\":15,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Όνομα\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":280,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1114\"},{\"id\":\"object1115\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":797,\"top\":85,\"height\":15,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"student_parent_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":281,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1115\"},{\"id\":\"object1116\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":616,\"top\":50,\"height\":15,\"width\":500,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Στοιχεία Κηδεμόνα\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"7\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":282,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1116\"},{\"id\":\"object1118\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":616,\"top\":10,\"height\":15,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Α.Μ.\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":283,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"toselect\":0,\"name\":\"object1118\"},{\"id\":\"object1119\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":797,\"top\":10,\"height\":15,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"student_registration_number\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":284,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"toselect\":0,\"name\":\"object1119\"},{\"id\":\"object1120\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":616,\"top\":25,\"height\":15,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Τάξη\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":285,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"toselect\":0,\"name\":\"object1120\"},{\"id\":\"object1121\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":797,\"top\":25,\"height\":15,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"student_grade_short_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":286,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"toselect\":0,\"name\":\"object1121\"}]}]},{\"sortField\":\"Report\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":30,\"height\":24,\"label\":\"Report Header\",\"page_break\":\"0\",\"margins\":2,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":381,\"height\":17,\"label\":\"Report Footer\",\"page_break\":\"0\",\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"Page\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":54,\"height\":86,\"label\":\"Page Header\",\"page_break\":\"0\",\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1018\",\"group\":2,\"section\":0,\"objectType\":\"label\",\"left\":76,\"top\":53,\"height\":15,\"width\":500,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Ημερομηνία Εκτύπωσης : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"7\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":\"200\",\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1018\"},{\"id\":\"object1011\",\"group\":2,\"section\":0,\"objectType\":\"field\",\"left\":76,\"top\":35,\"height\":\"15\",\"width\":\"600\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_year_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":104,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1011\"},{\"id\":\"object1008\",\"group\":2,\"section\":0,\"objectType\":\"label\",\"left\":481,\"top\":55,\"height\":30,\"width\":\"700\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Αναλυτική Κατάσταση Μαθητών\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"14\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":\"244\",\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1008\"},{\"id\":\"object1007\",\"group\":2,\"section\":0,\"objectType\":\"field\",\"left\":76,\"top\":18,\"height\":15,\"width\":600,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":101,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1007\"},{\"id\":\"object1072\",\"group\":2,\"section\":0,\"objectType\":\"field\",\"left\":227,\"top\":53,\"height\":\"15\",\"width\":\"200\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"cur_date\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":243,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1072\"}]},{\"id\":\"\",\"top\":381,\"height\":0,\"label\":\"Page Footer\",\"page_break\":\"0\",\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":140,\"height\":0,\"label\":\" Header\",\"page_break\":\"0\",\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":381,\"height\":0,\"label\":\" Footer\",\"page_break\":\"0\",\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":140,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":381,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":140,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":381,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":140,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":381,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":140,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":381,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":140,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":381,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":140,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":381,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":140,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":381,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]}],\"currentGroup\":0}','2015-06-02 22:06:46','globeadmin','2015-06-04 09:18:47','globeadmin','2015-06-04 09:18:47','globeadmin'),('565b04ea7d96cc4','marks_print_manager','Εκτυπώνει τους βαθμούς βάση κριτηρίων που επιλέγει ο διευθυντής','manager','','565ac873e409ddc','','{\"top\":30,\"left\":30,\"bottom\":465,\"right\":30,\"width\":\"210\",\"height\":\"297\",\"paper\":\"A4\",\"orientation\":\"P\",\"groups\":[{\"sortField\":\"Detail\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":322,\"height\":19,\"label\":\"Detail Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1031\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":80,\"top\":-1,\"height\":\"18\",\"width\":\"100\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"student_registration_number\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":211,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1031\"},{\"id\":\"object1032\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":150,\"top\":-1,\"height\":\"18\",\"width\":\"300\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"student_surname\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":212,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1032\"},{\"id\":\"object1033\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":330,\"top\":-1,\"height\":\"18\",\"width\":\"300\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"student_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":213,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1033\"},{\"id\":\"object1034\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":490,\"top\":-1,\"height\":\"18\",\"width\":\"250\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"student_fathers_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":214,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1034\"},{\"id\":\"object1035\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":660,\"top\":-1,\"height\":18,\"width\":110,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"value_p\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"21\",\"textAlign\":\"right\",\"image\":\"\",\"zIndex\":215,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1035\"}]}]},{\"sortField\":\"Report\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":30,\"height\":0,\"label\":\"Report Header\",\"page_break\":\"0\",\"margins\":0,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":435,\"height\":0,\"label\":\"Report Footer\",\"page_break\":\"0\",\"margins\":10,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"Page\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":30,\"height\":40,\"label\":\"Page Header\",\"page_break\":\"0\",\"margins\":2,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1091\",\"group\":2,\"section\":0,\"objectType\":\"label\",\"left\":107,\"top\":12,\"height\":\"15\",\"width\":600,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\" \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"right\",\"image\":\"\",\"zIndex\":256,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1091\"}]},{\"id\":\"\",\"top\":435,\"height\":0,\"label\":\"Page Footer\",\"page_break\":\"0\",\"margins\":10,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"grading_period_id\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":70,\"height\":0,\"label\":\" Header\",\"page_break\":\"0\",\"margins\":2,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":435,\"height\":0,\"label\":\" Footer\",\"page_break\":\"0\",\"margins\":10,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"class_id\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":70,\"height\":0,\"label\":\" Header\",\"page_break\":\"0\",\"margins\":2,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":435,\"height\":0,\"label\":\" Footer\",\"page_break\":\"0\",\"margins\":10,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"subject_id2\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":70,\"height\":0,\"label\":\" Header\",\"page_break\":\"0\",\"margins\":2,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":419,\"height\":16,\"label\":\" Footer\",\"page_break\":\"1\",\"margins\":10,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1089\",\"group\":5,\"section\":1,\"objectType\":\"label\",\"left\":169,\"top\":0,\"height\":\"15\",\"width\":600,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\" \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"right\",\"image\":\"\",\"zIndex\":255,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1089\"}]}]},{\"sortField\":\"subject_id\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":70,\"height\":252,\"label\":\" Header\",\"page_break\":\"0\",\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1070\",\"group\":6,\"section\":0,\"objectType\":\"label\",\"left\":80,\"top\":57,\"height\":15,\"width\":\"500\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Κατάσταση Βαθμολογίας : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":242,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1070\"},{\"id\":\"object1074\",\"group\":6,\"section\":0,\"objectType\":\"field\",\"left\":240,\"top\":57,\"height\":\"15\",\"width\":\"200\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"cond\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":244,\"minRows\":0,\"maxRows\":\"0\",\"selected\":1,\"name\":\"object1074\"},{\"id\":\"object1076\",\"group\":6,\"section\":0,\"objectType\":\"label\",\"left\":80,\"top\":131,\"height\":\"18\",\"width\":\"200\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Μάθημα : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":245,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1076\"},{\"id\":\"object1077\",\"group\":6,\"section\":0,\"objectType\":\"field\",\"left\":153,\"top\":131,\"height\":\"18\",\"width\":\"680\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"subject_full_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":246,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1077\"},{\"id\":\"object1078\",\"group\":6,\"section\":0,\"objectType\":\"label\",\"left\":80,\"top\":232,\"height\":18,\"width\":100,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Α.Μ.\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":247,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1078\"},{\"id\":\"object1079\",\"group\":6,\"section\":0,\"objectType\":\"label\",\"left\":150,\"top\":232,\"height\":18,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Επώνυμο\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":248,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1079\"},{\"id\":\"object1080\",\"group\":6,\"section\":0,\"objectType\":\"label\",\"left\":330,\"top\":232,\"height\":18,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Όνομα\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":249,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1080\"},{\"id\":\"object1081\",\"group\":6,\"section\":0,\"objectType\":\"label\",\"left\":490,\"top\":232,\"height\":18,\"width\":250,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Πατρώνυμο\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":250,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1081\"},{\"id\":\"object1082\",\"group\":6,\"section\":0,\"objectType\":\"label\",\"left\":660,\"top\":232,\"height\":18,\"width\":\"110\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Βαθμός\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"21\",\"textAlign\":\"right\",\"image\":\"\",\"zIndex\":251,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1082\"},{\"id\":\"object1066\",\"group\":6,\"section\":0,\"objectType\":\"label\",\"left\":80,\"top\":108,\"height\":\"18\",\"width\":\"150\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Τμήμα : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":238,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1066\"},{\"id\":\"object1067\",\"group\":6,\"section\":0,\"objectType\":\"field\",\"left\":153,\"top\":108,\"height\":\"18\",\"width\":\"200\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"class_short\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":239,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1067\"},{\"id\":\"object1068\",\"group\":6,\"section\":0,\"objectType\":\"label\",\"left\":80,\"top\":85,\"height\":\"18\",\"width\":\"500\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Βαθμολογική Περίοδος : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":240,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1068\"},{\"id\":\"object1069\",\"group\":6,\"section\":0,\"objectType\":\"field\",\"left\":259,\"top\":85,\"height\":18,\"width\":\"300\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"grading_period_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":241,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1069\"},{\"id\":\"object1008\",\"group\":6,\"section\":0,\"objectType\":\"label\",\"left\":27,\"top\":176,\"height\":\"30\",\"width\":\"785\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Βαθμολογική Κατάσταση \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"14\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":102,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1008\"},{\"id\":\"object1007\",\"group\":6,\"section\":0,\"objectType\":\"field\",\"left\":80,\"top\":1,\"height\":15,\"width\":600,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":101,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1007\"},{\"id\":\"object1011\",\"group\":6,\"section\":0,\"objectType\":\"field\",\"left\":80,\"top\":17,\"height\":\"15\",\"width\":\"600\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_year_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":104,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1011\"},{\"id\":\"object1093\",\"group\":6,\"section\":0,\"objectType\":\"label\",\"left\":80,\"top\":40,\"height\":15,\"width\":500,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Ημερομηνία Εκτύπωσης : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"7\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":257,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1093\"},{\"id\":\"object1094\",\"group\":6,\"section\":0,\"objectType\":\"field\",\"left\":240,\"top\":40,\"height\":\"15\",\"width\":\"200\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"cur_date\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":258,\"minRows\":0,\"maxRows\":\"0\",\"selected\":1,\"name\":\"object1094\"}]},{\"id\":\"\",\"top\":341,\"height\":78,\"label\":\" Footer\",\"page_break\":\"0\",\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1087\",\"group\":6,\"section\":1,\"objectType\":\"label\",\"left\":169,\"top\":13,\"height\":\"15\",\"width\":600,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Οι Διδάσκοντες Καθηγητές\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"right\",\"image\":\"\",\"zIndex\":254,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1087\"},{\"id\":\"object1096\",\"group\":6,\"section\":1,\"objectType\":\"field\",\"left\":169,\"top\":30,\"height\":45,\"width\":600,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"teacher_names\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"right\",\"image\":\"\",\"zIndex\":259,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1096\"}]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":322,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":341,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":322,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":341,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":322,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":341,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":322,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":341,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]}],\"currentGroup\":0}','2015-11-29 16:00:10','globeadmin','2015-11-29 16:00:10','globeadmin','2015-12-26 23:21:10','globeadmin'),('56a48e641bec142','absence_notes_short_student','Σύντομο δελτίο επικοινωνίας σχολείου γονέων με αποδεικτικό ότι το παράλαβε ο μαθητής','teacher','','552ea7c73b78c04','','{\"top\":30,\"left\":30,\"bottom\":1162,\"right\":30,\"width\":\"210\",\"height\":\"297\",\"paper\":\"A4\",\"orientation\":\"P\",\"groups\":[{\"sortField\":\"Detail\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":411,\"height\":700,\"label\":\"Detail Header\",\"page_break\":\"0\",\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1017\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":5,\"top\":205,\"height\":20,\"width\":\"300\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"manager_label\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":\"112\",\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1017\"},{\"id\":\"object1018\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":273,\"top\":205,\"height\":20,\"width\":\"300\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"assistmanager_label\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":\"111\",\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1018\"},{\"id\":\"object1019\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":532,\"top\":205,\"height\":20,\"width\":\"300\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"teacher_label\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":113,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1019\"},{\"id\":\"object1045\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":37,\"top\":126,\"height\":20,\"width\":\"800\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"text1\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":128,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1045\"},{\"id\":\"object1046\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":0,\"top\":88,\"height\":20,\"width\":\"840\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Δελτίο Επικοινωνίας Σχολείου - Γονέα\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"12\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":129,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1046\"},{\"id\":\"object1051\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":295,\"top\":126,\"height\":20,\"width\":\"870\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"student_full_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":\"131\",\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1048\"},{\"id\":\"object1053\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":37,\"top\":176,\"height\":20,\"width\":\"500\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"text4\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":134,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1053\"},{\"id\":\"object1055\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":270,\"top\":176,\"height\":20,\"width\":\"500\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"text5\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":135,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1055\"},{\"id\":\"object1056\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":500,\"top\":176,\"height\":20,\"width\":\"500\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"text6\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":136,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1056\"},{\"id\":\"object1058\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":40,\"top\":360,\"height\":20,\"width\":800,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"text10\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":137,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1058\"},{\"id\":\"object1059\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":40,\"top\":430,\"height\":20,\"width\":800,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Ημερομηνία : ________________\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":138,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1059\"},{\"id\":\"object1060\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":40,\"top\":398,\"height\":20,\"width\":1000,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Ονοματεπώνυμο : ______________________________________\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":139,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1060\"},{\"id\":\"object1061\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":500,\"top\":3,\"height\":20,\"width\":200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Πρός κ. \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":140,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1061\"},{\"id\":\"object1063\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":273,\"top\":269,\"height\":20,\"width\":\"300\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"assistmanager_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":141,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1063\"},{\"id\":\"object1064\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":5,\"top\":269,\"height\":20,\"width\":\"300\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"manager_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":142,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1064\"},{\"id\":\"object1065\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":532,\"top\":269,\"height\":20,\"width\":\"300\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"teacher_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":143,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1065\"},{\"id\":\"object1067\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":560,\"top\":3,\"height\":20,\"width\":\"620\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"student_parent_full_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":144,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1067\"},{\"id\":\"object1069\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":500,\"top\":26,\"height\":20,\"width\":\"680\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"address1\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":145,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1069\"},{\"id\":\"object1070\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":500,\"top\":49,\"height\":\"20\",\"width\":\"680\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"address2\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":146,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1070\"},{\"id\":\"object1074\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":37,\"top\":313,\"height\":20,\"width\":1100,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Μπορείτε να ενημερώνεστε αναλυτικά για τις απουσίες του παιδιού σας στην ιστοσελίδα του σχολείου μας\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"6\",\"fontWeight\":\"I\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":149,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1074\"},{\"id\":\"object1076\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":10,\"top\":339,\"height\":\"20\",\"width\":\"1175\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":150,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1076\"},{\"id\":\"object1078\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":295,\"top\":360,\"height\":20,\"width\":\"870\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"student_full_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":151,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1078\"},{\"id\":\"object1080\",\"group\":0,\"section\":0,\"objectType\":\"image\",\"left\":15,\"top\":341,\"height\":15,\"width\":15,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":14,\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"images/cut1.jpg\",\"zIndex\":152,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1080\"},{\"id\":\"object1084\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":37,\"top\":151,\"height\":20,\"width\":\"1140\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"text2\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":154,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1084\"},{\"id\":\"object1085\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":519,\"top\":151,\"height\":20,\"width\":\"400\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"text3\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":155,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1085\"},{\"id\":\"object1087\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":13,\"top\":564,\"height\":\"20\",\"width\":\"1175\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":156,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1087\"},{\"id\":\"object1088\",\"group\":0,\"section\":0,\"objectType\":\"image\",\"left\":18,\"top\":566,\"height\":15,\"width\":15,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":14,\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"images/cut1.jpg\",\"zIndex\":157,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1088\"},{\"id\":\"object1090\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":43,\"top\":646,\"height\":20,\"width\":800,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Ημερομηνία : ________________\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":158,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1090\"},{\"id\":\"object1094\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":43,\"top\":588,\"height\":20,\"width\":800,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"text100\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":160,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1094\"},{\"id\":\"object1095\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":136,\"top\":588,\"height\":20,\"width\":\"870\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"student_full_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":161,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1095\"},{\"id\":\"object1096\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":43,\"top\":611,\"height\":20,\"width\":\"1135\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Δηλώνω ότι παρέλαβα το «Δελτίο Επικοινωνίας Σχολείου-Γονέα».\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":162,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1096\"},{\"id\":\"object1098\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":55,\"top\":456,\"height\":20,\"width\":\"750\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"issue_date\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"7\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"right\",\"image\":\"\",\"zIndex\":\"148\",\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1098\"},{\"id\":\"object1100\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":137,\"top\":456,\"height\":20,\"width\":\"400\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Υπογραφή\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":164,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"toselect\":0,\"name\":\"object1100\"},{\"id\":\"object1101\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":55,\"top\":672,\"height\":20,\"width\":\"750\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"issue_date\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"7\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"right\",\"image\":\"\",\"zIndex\":165,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"toselect\":0,\"name\":\"object1101\"},{\"id\":\"object1102\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":140,\"top\":672,\"height\":20,\"width\":\"400\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Υπογραφή\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":166,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"toselect\":0,\"name\":\"object1102\"}]}]},{\"sortField\":\"Report\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":30,\"height\":1,\"label\":\"Report Header\",\"page_break\":\"0\",\"margins\":2,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":1131,\"height\":1,\"label\":\"Report Footer\",\"page_break\":\"0\",\"margins\":14,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"Page\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":31,\"height\":21,\"label\":\"Page Header\",\"page_break\":\"0\",\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":1121,\"height\":10,\"label\":\"Page Footer\",\"page_break\":\"0\",\"margins\":12,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"student_id\",\"sortBy\":\"\",\"sections\":[{\"id\":\"\",\"top\":52,\"height\":359,\"label\":\" Header\",\"page_break\":\"0\",\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1001\",\"group\":3,\"section\":0,\"objectType\":\"image\",\"left\":109,\"top\":10,\"height\":\"75\",\"width\":\"75\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":14,\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"images/coat_of_ar.png\",\"zIndex\":100,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1001\"},{\"id\":\"object1002\",\"group\":3,\"section\":0,\"objectType\":\"label\",\"left\":40,\"top\":88,\"height\":20,\"width\":\"800\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"ΕΛΛΗΝΙΚΗ ΔΗΜΟΚΡΑΤΙΑ\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":101,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1002\"},{\"id\":\"object1007\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":40,\"top\":110,\"height\":20,\"width\":\"800\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_ministry\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":104,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1007\"},{\"id\":\"object1009\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":40,\"top\":132,\"height\":20,\"width\":\"800\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_region\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":105,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1009\"},{\"id\":\"object1010\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":40,\"top\":153,\"height\":20,\"width\":\"800\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_intendancy\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":106,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1010\"},{\"id\":\"object1012\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":40,\"top\":182,\"height\":20,\"width\":800,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":107,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1012\"},{\"id\":\"object1013\",\"group\":3,\"section\":0,\"objectType\":\"label\",\"left\":555,\"top\":153,\"height\":20,\"width\":250,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Αρ. Πρωτ. __________\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"right\",\"image\":\"\",\"zIndex\":108,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1013\"},{\"id\":\"object1015\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":455,\"top\":110,\"height\":20,\"width\":\"350\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"cur_date\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"right\",\"image\":\"\",\"zIndex\":110,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1015\"},{\"id\":\"object1022\",\"group\":3,\"section\":0,\"objectType\":\"label\",\"left\":40,\"top\":270,\"height\":20,\"width\":200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Τηλ. :\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":\"114\",\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1022\"},{\"id\":\"object1024\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":88,\"top\":270,\"height\":20,\"width\":\"600\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_phone\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":115,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1024\"},{\"id\":\"object1026\",\"group\":3,\"section\":0,\"objectType\":\"label\",\"left\":40,\"top\":291,\"height\":20,\"width\":200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Fax :\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":116,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1026\"},{\"id\":\"object1027\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":88,\"top\":291,\"height\":20,\"width\":\"600\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_fax\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":117,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1027\"},{\"id\":\"object1031\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":40,\"top\":204,\"height\":20,\"width\":800,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"school_street_area\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":118,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1031\"},{\"id\":\"object1032\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":40,\"top\":226,\"height\":20,\"width\":800,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"school_zipcode_city\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":119,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1032\"},{\"id\":\"object1034\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":40,\"top\":248,\"height\":20,\"width\":800,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"school_state_country\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":120,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1034\"},{\"id\":\"object1036\",\"group\":3,\"section\":0,\"objectType\":\"label\",\"left\":40,\"top\":313,\"height\":20,\"width\":200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Email :\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":121,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1036\"},{\"id\":\"object1038\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":97,\"top\":313,\"height\":20,\"width\":\"600\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_email\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":123,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1038\"},{\"id\":\"object1039\",\"group\":3,\"section\":0,\"objectType\":\"label\",\"left\":40,\"top\":335,\"height\":20,\"width\":\"250\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Ιστοσελίδα :\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":124,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1039\"},{\"id\":\"object1041\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":133,\"top\":335,\"height\":20,\"width\":600,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"school_web_page\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":126,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1041\"}]},{\"id\":\"\",\"top\":1111,\"height\":10,\"label\":\" Footer\",\"page_break\":\"1\",\"margins\":10,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1005\",\"group\":3,\"section\":1,\"objectType\":\"label\",\"left\":151,\"top\":0,\"height\":\"10\",\"width\":\"500\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":103,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1005\"}]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":411,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":1111,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":411,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":1111,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":411,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":1111,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":411,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":1111,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":411,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":1111,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":411,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":1111,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":411,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":1111,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]}],\"currentGroup\":0}','2016-01-24 10:42:12','globeadmin','2016-01-28 21:51:03','globeadmin','2018-02-19 16:20:56','globeadmin'),('56a4a92f31e4ef8','absence_notes_short_new','Σύντομο δελτίο επικοινωνίας σχολείου γονέων - Νέο','teacher','','552ea7c73b78c04','','{\"top\":30,\"left\":30,\"bottom\":1114,\"right\":30,\"width\":\"210\",\"height\":\"297\",\"paper\":\"A4\",\"orientation\":\"P\",\"groups\":[{\"sortField\":\"Detail\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":412,\"height\":651,\"label\":\"Detail Header\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1017\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":5,\"top\":194,\"height\":20,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"manager_label\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":\"112\",\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1017\"},{\"id\":\"object1018\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":273,\"top\":194,\"height\":20,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"assistmanager_label\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":\"111\",\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1018\"},{\"id\":\"object1019\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":532,\"top\":194,\"height\":20,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"teacher_label\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":113,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1019\"},{\"id\":\"object1045\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":37,\"top\":84,\"height\":20,\"width\":800,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"text1\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":128,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1045\"},{\"id\":\"object1046\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":0,\"top\":34,\"height\":20,\"width\":840,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Δελτίο Επικοινωνίας Σχολείου - Γονέα\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"12\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":129,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1046\"},{\"id\":\"object1051\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":295,\"top\":84,\"height\":20,\"width\":870,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"student_full_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":\"131\",\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1048\"},{\"id\":\"object1053\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":37,\"top\":134,\"height\":20,\"width\":500,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"text4\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":134,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1053\"},{\"id\":\"object1055\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":270,\"top\":134,\"height\":20,\"width\":500,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"text5\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":135,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1055\"},{\"id\":\"object1056\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":500,\"top\":134,\"height\":20,\"width\":500,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"text6\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":136,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1056\"},{\"id\":\"object1058\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":40,\"top\":512,\"height\":20,\"width\":800,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"text10\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":137,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1058\"},{\"id\":\"object1059\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":40,\"top\":577,\"height\":20,\"width\":800,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Ημερομηνία : ________________\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":138,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1059\"},{\"id\":\"object1060\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":40,\"top\":545,\"height\":20,\"width\":1000,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Ονοματεπώνυμο : ______________________________________\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":139,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1060\"},{\"id\":\"object1063\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":273,\"top\":296,\"height\":20,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"assistmanager_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":141,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1063\"},{\"id\":\"object1064\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":5,\"top\":296,\"height\":20,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"manager_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":142,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1064\"},{\"id\":\"object1065\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":532,\"top\":296,\"height\":20,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"teacher_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":143,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1065\"},{\"id\":\"object1074\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":37,\"top\":350,\"height\":20,\"width\":1100,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Μπορείτε να ενημερώνεστε αναλυτικά για τις απουσίες του παιδιού σας στην ιστοσελίδα του σχολείου μας\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"6\",\"fontWeight\":\"I\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":149,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1074\"},{\"id\":\"object1076\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":10,\"top\":451,\"height\":20,\"width\":1175,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":150,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1076\"},{\"id\":\"object1078\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":295,\"top\":513,\"height\":20,\"width\":870,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"student_full_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":151,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1078\"},{\"id\":\"object1080\",\"group\":0,\"section\":0,\"objectType\":\"image\",\"left\":12,\"top\":453,\"height\":15,\"width\":15,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":14,\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"images/cut1.jpg\",\"zIndex\":152,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1080\"},{\"id\":\"object1084\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":37,\"top\":109,\"height\":20,\"width\":1140,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"text2\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":154,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1084\"},{\"id\":\"object1085\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":519,\"top\":109,\"height\":20,\"width\":400,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"text3\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":155,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1085\"},{\"id\":\"object1098\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":10,\"top\":419,\"height\":20,\"width\":40,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"__\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":165,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1098\"},{\"id\":\"object1099\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":10,\"top\":1,\"height\":20,\"width\":40,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"__\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":166,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1099\"},{\"id\":\"object1101\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":40,\"top\":608,\"height\":20,\"width\":\"750\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"issue_date\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"7\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"right\",\"image\":\"\",\"zIndex\":167,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"toselect\":0,\"name\":\"object1101\"},{\"id\":\"object1102\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":137,\"top\":608,\"height\":20,\"width\":400,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Υπογραφή\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":168,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"toselect\":0,\"name\":\"object1102\"}]}]},{\"sortField\":\"Report\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":30,\"height\":1,\"label\":\"Report Header\",\"page_break\":\"0\",\"margins\":2,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":1083,\"height\":1,\"label\":\"Report Footer\",\"page_break\":\"0\",\"margins\":14,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"Page\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":31,\"height\":10,\"label\":\"Page Header\",\"page_break\":\"0\",\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":1073,\"height\":10,\"label\":\"Page Footer\",\"page_break\":\"0\",\"margins\":12,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"student_id\",\"sortBy\":\"\",\"sections\":[{\"id\":\"\",\"top\":41,\"height\":371,\"label\":\" Header\",\"page_break\":\"0\",\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1001\",\"group\":3,\"section\":0,\"objectType\":\"image\",\"left\":109,\"top\":10,\"height\":\"75\",\"width\":\"75\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":14,\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"images/coat_of_ar.png\",\"zIndex\":100,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1001\"},{\"id\":\"object1002\",\"group\":3,\"section\":0,\"objectType\":\"label\",\"left\":40,\"top\":88,\"height\":20,\"width\":\"800\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"ΕΛΛΗΝΙΚΗ ΔΗΜΟΚΡΑΤΙΑ\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":101,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1002\"},{\"id\":\"object1007\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":40,\"top\":110,\"height\":20,\"width\":\"800\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_ministry\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":104,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1007\"},{\"id\":\"object1009\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":40,\"top\":132,\"height\":20,\"width\":\"800\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_region\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":105,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1009\"},{\"id\":\"object1010\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":40,\"top\":153,\"height\":20,\"width\":\"800\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_intendancy\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":106,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1010\"},{\"id\":\"object1012\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":40,\"top\":182,\"height\":20,\"width\":800,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":107,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1012\"},{\"id\":\"object1013\",\"group\":3,\"section\":0,\"objectType\":\"label\",\"left\":555,\"top\":132,\"height\":20,\"width\":250,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Αρ. Πρωτ. __________\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"right\",\"image\":\"\",\"zIndex\":108,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1013\"},{\"id\":\"object1015\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":455,\"top\":88,\"height\":20,\"width\":\"350\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"cur_date\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"right\",\"image\":\"\",\"zIndex\":110,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1015\"},{\"id\":\"object1022\",\"group\":3,\"section\":0,\"objectType\":\"label\",\"left\":40,\"top\":270,\"height\":20,\"width\":200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Τηλ. :\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":\"114\",\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1022\"},{\"id\":\"object1024\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":88,\"top\":270,\"height\":20,\"width\":\"600\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_phone\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":115,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1024\"},{\"id\":\"object1026\",\"group\":3,\"section\":0,\"objectType\":\"label\",\"left\":40,\"top\":291,\"height\":20,\"width\":200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Fax :\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":116,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1026\"},{\"id\":\"object1027\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":88,\"top\":291,\"height\":20,\"width\":\"600\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_fax\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":117,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1027\"},{\"id\":\"object1031\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":40,\"top\":204,\"height\":20,\"width\":800,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"school_street_area\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":118,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1031\"},{\"id\":\"object1032\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":40,\"top\":226,\"height\":20,\"width\":800,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"school_zipcode_city\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":119,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1032\"},{\"id\":\"object1034\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":40,\"top\":248,\"height\":20,\"width\":800,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"school_state_country\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":120,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1034\"},{\"id\":\"object1036\",\"group\":3,\"section\":0,\"objectType\":\"label\",\"left\":40,\"top\":313,\"height\":20,\"width\":200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Email :\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":121,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1036\"},{\"id\":\"object1038\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":97,\"top\":313,\"height\":20,\"width\":\"600\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_email\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":123,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1038\"},{\"id\":\"object1039\",\"group\":3,\"section\":0,\"objectType\":\"label\",\"left\":40,\"top\":335,\"height\":20,\"width\":\"250\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Ιστοσελίδα :\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":124,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1039\"},{\"id\":\"object1041\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":133,\"top\":335,\"height\":20,\"width\":600,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"school_web_page\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":126,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1041\"},{\"id\":\"object1092\",\"group\":3,\"section\":0,\"objectType\":\"label\",\"left\":468,\"top\":204,\"height\":20,\"width\":200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Πρός κ. \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":161,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1092\"},{\"id\":\"object1093\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":468,\"top\":226,\"height\":20,\"width\":\"680\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"address1\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":162,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1093\"},{\"id\":\"object1094\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":468,\"top\":248,\"height\":\"20\",\"width\":\"680\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"address2\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":163,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1094\"},{\"id\":\"object1096\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":528,\"top\":204,\"height\":20,\"width\":\"620\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"student_parent_full_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":164,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1096\"}]},{\"id\":\"\",\"top\":1063,\"height\":10,\"label\":\" Footer\",\"page_break\":\"1\",\"margins\":10,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1005\",\"group\":3,\"section\":1,\"objectType\":\"label\",\"left\":151,\"top\":0,\"height\":\"10\",\"width\":\"500\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":103,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1005\"}]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":412,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":1063,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":412,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":1063,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":412,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":1063,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":412,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":1063,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":412,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":1063,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":412,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":1063,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":412,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":1063,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]}],\"currentGroup\":0}','2016-01-24 12:36:31','globeadmin','2016-01-28 21:55:11','globeadmin','2018-02-19 16:11:11','globeadmin'),('56eefe2e7a0f4b7','penalty','Εκτυπώνει τις ποινές ενός μαθητή','teacher','SELECT\n	concat(student.surname,\' \',student.name,if(student.fathers_name is NULL,\'\',concat(\' πατ. \',student.fathers_name)),\' (ΑΜ:\',student.registration_number,\')\') as student_full_name,\n	date_format(penalty.date_enforced,\'%d-%m-%Y\') as penalty_date_enforced,\n	penalty.type as penalty_type,\n	penalty.reason as penalty_reason,\n	penalty.carrier as penalty_carrier,\n	school.name as school_name,\n	school_year.name as school_year_name,\n	date_format(curdate(),\'%d-%m-%Y\') as cur_date,\n    if(penalty.carrier = if(penalty.teacher_id IS NULL,\'\',concat(ifNULL(teacher.surname,\'\'),if(teacher.surname IS NOT NULL AND teacher.name IS NOT NULL,\' \',\'\'),ifNULL(teacher.name,\'\'))),\n    penalty.carrier,\n    concat (ifNULL(penalty.carrier,\'\'),if(penalty.carrier IS NOT NULL AND penalty.teacher_id IS NOT NULL, \' / \', \'\'),if(penalty.teacher_id IS NULL,\'\',concat(ifNULL(teacher.surname,\'\'),if(teacher.surname IS NOT NULL AND teacher.name IS NOT NULL,\' \',\'\'),ifNULL(teacher.name,\'\'))))) \n        as names\nFROM penalty\nINNER JOIN student ON  student.id = penalty.student_id\nINNER JOIN school on school.id = 1\nINNER JOIN school_year on school_year.id = school.school_year_id\nLEFT JOIN teacher ON teacher.id = penalty.teacher_id\nWHERE penalty.student_id=\'#RECORD_ID#\' \nORDER BY penalty.date_enforced','','','{\"top\":30,\"left\":30,\"bottom\":400,\"right\":30,\"width\":\"210\",\"height\":\"297\",\"paper\":\"A4\",\"orientation\":\"P\",\"groups\":[{\"sortField\":\"Detail\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":271,\"height\":30,\"label\":\"Detail Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1032\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":59,\"top\":8,\"height\":\"18\",\"width\":\"300\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"penalty_date_enforced\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":212,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1032\"},{\"id\":\"object1033\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":147,\"top\":8,\"height\":\"18\",\"width\":\"300\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"penalty_type\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":213,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1033\"},{\"id\":\"object1034\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":266,\"top\":8,\"height\":\"18\",\"width\":\"250\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"names\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":214,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1034\"},{\"id\":\"object1035\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":406,\"top\":8,\"height\":\"18\",\"width\":\"700\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"penalty_reason\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":215,\"minRows\":\"0\",\"maxRows\":0,\"selected\":1,\"name\":\"object1035\"},{\"id\":\"object1066\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":44,\"top\":1,\"height\":\"0\",\"width\":\"750\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"14\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":238,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1066\"}]}]},{\"sortField\":\"Report\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":30,\"height\":218,\"label\":\"Report Header\",\"page_break\":\"0\",\"margins\":2,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1007\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":80,\"top\":46,\"height\":15,\"width\":600,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":101,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1007\"},{\"id\":\"object1008\",\"group\":1,\"section\":0,\"objectType\":\"label\",\"left\":28,\"top\":160,\"height\":\"30\",\"width\":\"785\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Επιβληθείσες Ποινές\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"14\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":102,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1008\"},{\"id\":\"object1011\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":80,\"top\":65,\"height\":\"15\",\"width\":\"600\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_year_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":104,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1011\"},{\"id\":\"object1014\",\"group\":1,\"section\":0,\"objectType\":\"label\",\"left\":80,\"top\":119,\"height\":18,\"width\":200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Μαθητής : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":105,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1014\"},{\"id\":\"object1018\",\"group\":1,\"section\":0,\"objectType\":\"label\",\"left\":80,\"top\":88,\"height\":15,\"width\":500,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Ημερομηνία Εκτύπωσης : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"7\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":\"200\",\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1018\"},{\"id\":\"object1042\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":156,\"top\":119,\"height\":\"18\",\"width\":\"950\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"student_full_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":221,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1042\"},{\"id\":\"object1044\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":226,\"top\":88,\"height\":\"15\",\"width\":\"200\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"cur_date\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":222,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1044\"}]},{\"id\":\"\",\"top\":301,\"height\":69,\"label\":\"Report Footer\",\"page_break\":\"0\",\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1063\",\"group\":1,\"section\":1,\"objectType\":\"label\",\"left\":44,\"top\":1,\"height\":\"0\",\"width\":\"750\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"14\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":236,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1063\"}]}]},{\"sortField\":\"Page\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":248,\"height\":23,\"label\":\"Page Header\",\"page_break\":\"0\",\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1058\",\"group\":2,\"section\":0,\"objectType\":\"label\",\"left\":59,\"top\":1,\"height\":18,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Ημερομηνία\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":232,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1058\"},{\"id\":\"object1059\",\"group\":2,\"section\":0,\"objectType\":\"label\",\"left\":147,\"top\":1,\"height\":18,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Τύπος Ποινής\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":233,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1059\"},{\"id\":\"object1060\",\"group\":2,\"section\":0,\"objectType\":\"label\",\"left\":266,\"top\":1,\"height\":18,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Φορέας Επιβολής / Καθηγητής\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":234,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1060\"},{\"id\":\"object1061\",\"group\":2,\"section\":0,\"objectType\":\"label\",\"left\":409,\"top\":1,\"height\":18,\"width\":\"250\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Αιτία\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"21\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":235,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1061\"}]},{\"id\":\"\",\"top\":301,\"height\":0,\"label\":\"Page Footer\",\"page_break\":\"0\",\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":271,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":301,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":271,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":301,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":271,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":301,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":271,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":301,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":271,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":301,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":271,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":301,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":271,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":301,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":271,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":301,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]}],\"currentGroup\":0}','2016-03-20 21:46:54','globeadmin','2019-02-06 00:08:59','globeadmin','2019-02-06 00:09:00','globeadmin'),('5745eed0d13a1e0','critirion_general','Εκτυπώνει ένα Γενικό Κριτήριο Περιγραφικής Αξιολόγησης','teacher','SELECT\n	critirion_general.name                  as critirion_general_name,\n	critirion_general.description           as critirion_general_description,\n	ifNULL(grade.short_name,\'\')             as grade_short_name,\n	ifNULL(speciality.short_name,\'\')        as speciality_short_name,\n	concat(ifNULL(teacher.surname,\'\'),if(teacher.surname is not NULL and teacher.name is not NULL,\' \',\'\'),ifNULL(teacher.name,\'\')) as teacher_full_name,\n	ifNULL(critirion_special.id,\'\')         as critirion_special_id,\n	ifNULL(critirion_special.description,\'\')           as critirion_special_description,\n	if(critirion_special_level.description is NULL,\'\',concat(\'- \',critirion_special_level.description))     as critirion_special_level_description,\n	school.name                             as school_name,\n	school_year.name                        as school_year_name,\n	date_format(curdate(),\'%d-%m-%Y\')       as cur_date\n	\nFROM critirion_general\nLEFT JOIN grade                     ON critirion_general.grade_id = grade.id\nLEFT JOIN speciality                ON critirion_general.speciality_id = speciality.id\nLEFT JOIN teacher                   ON critirion_general.teacher_id = teacher.id\nLEFT JOIN critirion_special         ON critirion_special.critirion_general_id = critirion_general.id\nLEFT JOIN critirion_special_level   ON  critirion_special_level.critirion_special_id = critirion_special.id\nINNER JOIN school on school.id = 1\nINNER JOIN school_year on school_year.id = school.school_year_id\nWHERE critirion_general.id=\'#RECORD_ID#\' \nORDER BY critirion_general.name,critirion_special.hierarchy,critirion_special_level.hierarchy','','','{\"top\":30,\"left\":30,\"bottom\":414,\"right\":30,\"width\":\"210\",\"height\":\"297\",\"paper\":\"A4\",\"orientation\":\"P\",\"groups\":[{\"sortField\":\"Detail\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":333,\"height\":24,\"label\":\"Detail Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1035\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":86,\"top\":3,\"height\":\"15\",\"width\":\"1500\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"critirion_special_level_description\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"7\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":215,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1035\"}]}]},{\"sortField\":\"Report\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":30,\"height\":259,\"label\":\"Report Header\",\"page_break\":\"0\",\"margins\":2,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1007\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":80,\"top\":34,\"height\":15,\"width\":600,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":101,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1007\"},{\"id\":\"object1008\",\"group\":1,\"section\":0,\"objectType\":\"label\",\"left\":27,\"top\":107,\"height\":30,\"width\":785,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Γενικό Κριτηρίο Αξιολόγησης\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"14\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":102,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1008\"},{\"id\":\"object1011\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":80,\"top\":53,\"height\":\"15\",\"width\":\"600\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_year_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":104,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1011\"},{\"id\":\"object1014\",\"group\":1,\"section\":0,\"objectType\":\"label\",\"left\":80,\"top\":150,\"height\":18,\"width\":200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Όνομα : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":105,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1014\"},{\"id\":\"object1018\",\"group\":1,\"section\":0,\"objectType\":\"label\",\"left\":80,\"top\":76,\"height\":15,\"width\":500,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Ημερομηνία Εκτύπωσης : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"7\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":\"200\",\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1018\"},{\"id\":\"object1042\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":186,\"top\":150,\"height\":\"18\",\"width\":\"1000\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"critirion_general_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":221,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1042\"},{\"id\":\"object1044\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":226,\"top\":76,\"height\":\"15\",\"width\":\"200\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"cur_date\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":222,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1044\"},{\"id\":\"object1068\",\"group\":1,\"section\":0,\"objectType\":\"label\",\"left\":80,\"top\":213,\"height\":18,\"width\":200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Ειδικότητα : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":239,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1068\"},{\"id\":\"object1069\",\"group\":1,\"section\":0,\"objectType\":\"label\",\"left\":80,\"top\":235,\"height\":18,\"width\":200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Δημιουργός : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":240,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1069\"},{\"id\":\"object1070\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":186,\"top\":213,\"height\":\"18\",\"width\":\"1000\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"speciality_short_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":241,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1070\"},{\"id\":\"object1071\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":186,\"top\":235,\"height\":\"18\",\"width\":\"1000\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"teacher_full_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":242,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1071\"},{\"id\":\"object1075\",\"group\":1,\"section\":0,\"objectType\":\"label\",\"left\":80,\"top\":171,\"height\":18,\"width\":200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Περιγραφή : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":245,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1075\"},{\"id\":\"object1076\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":186,\"top\":171,\"height\":18,\"width\":\"1000\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"critirion_general_description\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":246,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1076\"},{\"id\":\"object1084\",\"group\":1,\"section\":0,\"objectType\":\"label\",\"left\":80,\"top\":192,\"height\":18,\"width\":200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Τάξη : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":250,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"toselect\":0,\"name\":\"object1084\"},{\"id\":\"object1085\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":186,\"top\":192,\"height\":18,\"width\":1000,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"grade_short_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":251,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"toselect\":0,\"name\":\"object1085\"}]},{\"id\":\"\",\"top\":367,\"height\":17,\"label\":\"Report Footer\",\"page_break\":\"0\",\"margins\":10,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1080\",\"group\":1,\"section\":1,\"objectType\":\"label\",\"left\":41,\"top\":5,\"height\":\"0\",\"width\":\"750\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"14\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":248,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1080\"}]}]},{\"sortField\":\"Page\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":289,\"height\":0,\"label\":\"Page Header\",\"page_break\":\"0\",\"margins\":2,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":367,\"height\":0,\"label\":\"Page Footer\",\"page_break\":\"0\",\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"critirion_special_id\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":289,\"height\":44,\"label\":\" Header\",\"page_break\":\"0\",\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1066\",\"group\":3,\"section\":0,\"objectType\":\"label\",\"left\":41,\"top\":1,\"height\":\"0\",\"width\":\"750\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"14\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":238,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1066\"},{\"id\":\"object1073\",\"group\":3,\"section\":0,\"objectType\":\"label\",\"left\":71,\"top\":12,\"height\":18,\"width\":\"300\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Ειδικό Κριτήριο : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":\"243\",\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1073\"},{\"id\":\"object1078\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":186,\"top\":12,\"height\":\"18\",\"width\":\"1000\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"critirion_special_description\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":247,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1078\"},{\"id\":\"object1082\",\"group\":3,\"section\":0,\"objectType\":\"label\",\"left\":71,\"top\":35,\"height\":\"0\",\"width\":\"650\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"14\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":249,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1082\"}]},{\"id\":\"\",\"top\":357,\"height\":10,\"label\":\" Footer\",\"page_break\":\"0\",\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":333,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":357,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":333,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":357,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":333,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":357,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":333,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":357,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":333,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":357,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":333,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":357,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":333,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":357,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]}],\"currentGroup\":0}','2016-05-25 21:28:32','globeadmin','2016-05-27 22:46:09','globeadmin','2016-08-03 22:34:05','globeadmin'),('57965aa71a7c002','marks_print_student','Εκτυπώνει τους βαθμούς ενός μαθητή μιας περιόδου','student','','57965e409e50885','','{\"top\":30,\"left\":30,\"bottom\":424,\"right\":30,\"width\":\"210\",\"height\":\"297\",\"paper\":\"A4\",\"orientation\":\"P\",\"groups\":[{\"sortField\":\"Detail\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":294,\"height\":31,\"label\":\"Detail Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1031\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":62,\"top\":7,\"height\":18,\"width\":\"800\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"subject_full_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":211,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"\"},{\"id\":\"object1032\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":439,\"top\":7,\"height\":18,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"value_formated\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"9\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":212,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"\"},{\"id\":\"object1033\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":509,\"top\":7,\"height\":18,\"width\":500,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"teacher_names\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":213,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1061\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":48,\"top\":1,\"height\":0,\"width\":750,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":14,\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":234,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1061\"}]}]},{\"sortField\":\"Report\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":30,\"height\":237,\"label\":\"Report Header\",\"page_break\":\"0\",\"margins\":2,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1007\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":62,\"top\":46,\"height\":15,\"width\":600,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":101,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1007\"},{\"id\":\"object1008\",\"group\":1,\"section\":0,\"objectType\":\"label\",\"left\":10,\"top\":196,\"height\":30,\"width\":785,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Βαθμολογία\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"14\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":102,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1008\"},{\"id\":\"object1011\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":62,\"top\":65,\"height\":15,\"width\":600,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_year_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":104,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1011\"},{\"id\":\"object1014\",\"group\":1,\"section\":0,\"objectType\":\"label\",\"left\":62,\"top\":155,\"height\":18,\"width\":200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Μάθητής : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":105,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1014\"},{\"id\":\"object1018\",\"group\":1,\"section\":0,\"objectType\":\"label\",\"left\":62,\"top\":96,\"height\":15,\"width\":500,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Ημερομηνία Εκτύπωσης : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"7\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":\"200\",\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1018\"},{\"id\":\"object1038\",\"group\":1,\"section\":0,\"objectType\":\"label\",\"left\":62,\"top\":125,\"height\":18,\"width\":500,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Βαθμολογική Περίοδος : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":217,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1038\"},{\"id\":\"object1042\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":139,\"top\":155,\"height\":18,\"width\":1000,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"student_full_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":221,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1042\"},{\"id\":\"object1044\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":208,\"top\":96,\"height\":15,\"width\":200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"cur_date\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":222,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1044\"},{\"id\":\"object1046\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":248,\"top\":125,\"height\":18,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"grading_period_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":224,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1046\"}]},{\"id\":\"\",\"top\":325,\"height\":69,\"label\":\"Report Footer\",\"page_break\":\"0\",\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1063\",\"group\":1,\"section\":1,\"objectType\":\"label\",\"left\":48,\"top\":2,\"height\":0,\"width\":750,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":14,\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":235,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1063\"}]}]},{\"sortField\":\"Page\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":267,\"height\":27,\"label\":\"Page Header\",\"page_break\":\"0\",\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1057\",\"group\":2,\"section\":0,\"objectType\":\"label\",\"left\":62,\"top\":2,\"height\":18,\"width\":100,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Μάθημα\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":231,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"\"},{\"id\":\"object1058\",\"group\":2,\"section\":0,\"objectType\":\"label\",\"left\":433,\"top\":2,\"height\":18,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Βαθμός\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":232,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"\"},{\"id\":\"object1059\",\"group\":2,\"section\":0,\"objectType\":\"label\",\"left\":509,\"top\":2,\"height\":18,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Καθηγητές\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":233,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"\"}]},{\"id\":\"\",\"top\":325,\"height\":0,\"label\":\"Page Footer\",\"page_break\":\"0\",\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":294,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":325,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":294,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":325,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":294,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":325,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":294,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":325,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":294,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":325,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":294,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":325,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":294,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":325,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":294,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":325,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]}],\"currentGroup\":0}','2016-07-25 21:29:59','globeadmin','2016-07-29 00:28:33','globeadmin','2017-11-22 22:21:20','globeadmin'),('57991b2b036e45b','marks_print_student_evaluation','Εκτυπώνει τη περιγραφική αξιολόγηση ενός μαθητή για μια περίοδο','student','','579785a44a87d70','','{\"top\":30,\"left\":30,\"bottom\":792,\"right\":30,\"width\":\"210\",\"height\":\"297\",\"paper\":\"A4\",\"orientation\":\"P\",\"groups\":[{\"sortField\":\"Detail\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":653,\"height\":53,\"label\":\"Detail Header\",\"page_break\":\"0\",\"margins\":10,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1063\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":64,\"top\":1,\"height\":0,\"width\":730,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":14,\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":235,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1063\"},{\"id\":\"object1080\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":65,\"top\":8,\"height\":18,\"width\":\"1120\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"critirion_special_description\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"9\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":245,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1080\"},{\"id\":\"object1081\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":85,\"top\":30,\"height\":18,\"width\":\"1500\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"critirion_special_level_description\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"9\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":246,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1081\"}]}]},{\"sortField\":\"Report\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":30,\"height\":335,\"label\":\"Report Header\",\"page_break\":\"0\",\"margins\":2,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1007\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":46,\"top\":35,\"height\":30,\"width\":1140,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"14\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":101,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1007\"},{\"id\":\"object1011\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":46,\"top\":75,\"height\":30,\"width\":1140,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_year_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"14\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":104,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1011\"},{\"id\":\"object1018\",\"group\":1,\"section\":0,\"objectType\":\"label\",\"left\":48,\"top\":310,\"height\":15,\"width\":500,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Ημερομηνία Εκτύπωσης : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"7\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":\"200\",\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1018\"},{\"id\":\"object1044\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":191,\"top\":310,\"height\":15,\"width\":200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"cur_date\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":222,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1044\"},{\"id\":\"object1046\",\"group\":1,\"section\":0,\"objectType\":\"label\",\"left\":46,\"top\":247,\"height\":18,\"width\":\"800\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Περίοδος Αξιολόγησης : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"12\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":224,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"\"},{\"id\":\"object1042\",\"group\":1,\"section\":0,\"objectType\":\"label\",\"left\":46,\"top\":208,\"height\":18,\"width\":200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Μάθητής : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"12\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":221,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"\"},{\"id\":\"object1008\",\"group\":1,\"section\":0,\"objectType\":\"label\",\"left\":46,\"top\":138,\"height\":30,\"width\":\"750\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Περιγραφική Αξιολόγηση\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"18\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":102,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1008\"},{\"id\":\"object1072\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":270,\"top\":247,\"height\":18,\"width\":\"900\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"grading_period_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"12\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":240,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"\"},{\"id\":\"object1073\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":150,\"top\":208,\"height\":18,\"width\":\"1035\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"student_full_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"12\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":241,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"\"}]},{\"id\":\"\",\"top\":749,\"height\":13,\"label\":\"Report Footer\",\"page_break\":\"0\",\"margins\":16,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"Page\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":365,\"height\":33,\"label\":\"Page Header\",\"page_break\":\"0\",\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":719,\"height\":30,\"label\":\"Page Footer\",\"page_break\":\"0\",\"margins\":14,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1086\",\"group\":2,\"section\":1,\"objectType\":\"label\",\"left\":46,\"top\":3,\"height\":\"18\",\"width\":\"750\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"#page# / #pages# \",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":249,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1086\"}]}]},{\"sortField\":\"subject_id\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":398,\"height\":219,\"label\":\" Header\",\"page_break\":\"1\",\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1031\",\"group\":3,\"section\":0,\"objectType\":\"label\",\"left\":46,\"top\":131,\"height\":18,\"width\":200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Μάθημα :\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"9\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":211,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"\"},{\"id\":\"object1033\",\"group\":3,\"section\":0,\"objectType\":\"label\",\"left\":46,\"top\":110,\"height\":18,\"width\":200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Καθηγητές :\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"9\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":\"233\",\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1066\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":46,\"top\":174,\"height\":18,\"width\":785,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"comments_label\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":236,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1066\"},{\"id\":\"object1067\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":65,\"top\":194,\"height\":18,\"width\":\"1500\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"mark_comments\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":237,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1067\"},{\"id\":\"object1070\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":130,\"top\":131,\"height\":\"18\",\"width\":\"1055\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"subject_full_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"9\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":238,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1070\"},{\"id\":\"object1071\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":135,\"top\":110,\"height\":18,\"width\":\"1045\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"teacher_names\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"9\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":239,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1071\"},{\"id\":\"object1094\",\"group\":3,\"section\":0,\"objectType\":\"label\",\"left\":45,\"top\":81,\"height\":18,\"width\":\"300\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Μάθητής : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":255,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1094\"},{\"id\":\"object1093\",\"group\":3,\"section\":0,\"objectType\":\"label\",\"left\":45,\"top\":51,\"height\":18,\"width\":\"700\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Περίοδος Αξιολόγησης :\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":254,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1093\"},{\"id\":\"object1092\",\"group\":3,\"section\":0,\"objectType\":\"label\",\"left\":43,\"top\":13,\"height\":30,\"width\":\"750\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Περιγραφική Αξιολόγηση\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"14\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":253,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1092\"},{\"id\":\"object1096\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":237,\"top\":51,\"height\":18,\"width\":\"700\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"grading_period_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":256,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1096\"},{\"id\":\"object1097\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":130,\"top\":81,\"height\":18,\"width\":\"1055\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"student_full_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":257,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1097\"}]},{\"id\":\"\",\"top\":706,\"height\":13,\"label\":\" Footer\",\"page_break\":\"0\",\"margins\":12,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1088\",\"group\":3,\"section\":1,\"objectType\":\"label\",\"left\":44,\"top\":3,\"height\":0,\"width\":750,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":14,\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":250,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1088\"}]}]},{\"sortField\":\"critirion_general_id\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":617,\"height\":36,\"label\":\" Header\",\"page_break\":\"0\",\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1079\",\"group\":4,\"section\":0,\"objectType\":\"field\",\"left\":46,\"top\":8,\"height\":18,\"width\":\"1140\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"critirion_general_description\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":244,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1079\"},{\"id\":\"object1082\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":44,\"top\":1,\"height\":0,\"width\":750,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":14,\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":247,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1082\"},{\"id\":\"object1099\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":44,\"top\":31,\"height\":0,\"width\":750,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":14,\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":258,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1099\"}]},{\"id\":\"\",\"top\":706,\"height\":0,\"label\":\" Footer\",\"page_break\":\"0\",\"margins\":10,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":653,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":706,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":10,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":653,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":706,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":10,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":653,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":706,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":10,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":653,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":706,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":10,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":653,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":706,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":10,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":653,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":706,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":10,\"color\":\"#FFFFFF\",\"objects\":[]}]}],\"currentGroup\":0}','2016-07-27 23:35:55','globeadmin','2016-07-28 15:41:07','globeadmin','2017-08-26 23:01:19','globeadmin'),('584596d4e28b331','search_absence_list','Λίστα απουσιών βάση κριτιρίων','sisyphos','','58458875d6799f3','','{\"top\":30,\"left\":30,\"bottom\":550,\"right\":30,\"width\":\"210\",\"height\":\"297\",\"paper\":\"A4\",\"orientation\":\"P\",\"groups\":[{\"sortField\":\"Detail\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":229,\"height\":30,\"label\":\"Detail Header\",\"page_break\":\"0\",\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1032\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":45,\"top\":7,\"height\":18,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"absence_absence_date\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"7\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":212,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"\"},{\"id\":\"object1033\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":115,\"top\":7,\"height\":18,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"period_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":213,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1033\"},{\"id\":\"object1034\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":142,\"top\":7,\"height\":18,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"student_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"7\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":214,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1035\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":296,\"top\":7,\"height\":18,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"absence_reason_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"7\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":215,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1066\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":44,\"top\":1,\"height\":\"0\",\"width\":\"750\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"14\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":238,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1066\"},{\"id\":\"object1075\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":323,\"top\":7,\"height\":18,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"class_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"7\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":245,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1076\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":363,\"top\":7,\"height\":18,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"subject_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"7\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":246,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1077\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":494,\"top\":7,\"height\":18,\"width\":250,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"teacher_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"7\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":247,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1078\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":606,\"top\":7,\"height\":18,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"absence_justified\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"7\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":248,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1079\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":645,\"top\":7,\"height\":18,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"justified_reason_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"7\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":249,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1080\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":755,\"top\":7,\"height\":18,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"absence_counts\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"7\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":250,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"\"}]}]},{\"sortField\":\"Report\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":30,\"height\":144,\"label\":\"Report Header\",\"page_break\":\"0\",\"margins\":2,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1007\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":80,\"top\":26,\"height\":15,\"width\":600,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":101,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1007\"},{\"id\":\"object1008\",\"group\":1,\"section\":0,\"objectType\":\"label\",\"left\":28,\"top\":110,\"height\":30,\"width\":785,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Λίστα Απουσιών\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"14\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":102,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1008\"},{\"id\":\"object1011\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":80,\"top\":45,\"height\":\"15\",\"width\":\"600\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_year_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":104,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1011\"},{\"id\":\"object1018\",\"group\":1,\"section\":0,\"objectType\":\"label\",\"left\":80,\"top\":68,\"height\":15,\"width\":500,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Ημερομηνία Εκτύπωσης : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"7\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":\"200\",\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1018\"},{\"id\":\"object1044\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":226,\"top\":68,\"height\":\"15\",\"width\":\"200\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"cur_date\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":222,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1044\"}]},{\"id\":\"\",\"top\":452,\"height\":68,\"label\":\"Report Footer\",\"page_break\":\"0\",\"margins\":12,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1063\",\"group\":1,\"section\":1,\"objectType\":\"label\",\"left\":44,\"top\":1,\"height\":\"0\",\"width\":\"750\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"14\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":236,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1063\"}]}]},{\"sortField\":\"Page\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":174,\"height\":55,\"label\":\"Page Header\",\"page_break\":\"0\",\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1058\",\"group\":2,\"section\":0,\"objectType\":\"label\",\"left\":42,\"top\":37,\"height\":18,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Ημερομηνία\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":232,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1058\"},{\"id\":\"object1059\",\"group\":2,\"section\":0,\"objectType\":\"label\",\"left\":115,\"top\":37,\"height\":18,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Ώρα\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":233,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1059\"},{\"id\":\"object1060\",\"group\":2,\"section\":0,\"objectType\":\"label\",\"left\":149,\"top\":37,\"height\":18,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Μαθητής\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":234,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1060\"},{\"id\":\"object1061\",\"group\":2,\"section\":0,\"objectType\":\"label\",\"left\":283,\"top\":37,\"height\":18,\"width\":250,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Λόγος\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"21\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":235,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1061\"},{\"id\":\"object1068\",\"group\":2,\"section\":0,\"objectType\":\"label\",\"left\":323,\"top\":37,\"height\":18,\"width\":250,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Τμήμα\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"21\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":239,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1068\"},{\"id\":\"object1069\",\"group\":2,\"section\":0,\"objectType\":\"label\",\"left\":363,\"top\":37,\"height\":18,\"width\":250,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Μάθημα\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"21\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":240,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1069\"},{\"id\":\"object1070\",\"group\":2,\"section\":0,\"objectType\":\"label\",\"left\":488,\"top\":37,\"height\":18,\"width\":250,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Καταχωρητής\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"21\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":241,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1070\"},{\"id\":\"object1071\",\"group\":2,\"section\":0,\"objectType\":\"label\",\"left\":589,\"top\":37,\"height\":18,\"width\":250,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Δικ/μενη\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"21\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":242,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1071\"},{\"id\":\"object1072\",\"group\":2,\"section\":0,\"objectType\":\"label\",\"left\":644,\"top\":37,\"height\":18,\"width\":250,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Δικαιολόγηση\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"21\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":243,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1072\"},{\"id\":\"object1073\",\"group\":2,\"section\":0,\"objectType\":\"label\",\"left\":739,\"top\":37,\"height\":18,\"width\":250,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Μετράει\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"21\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":244,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1073\"}]},{\"id\":\"\",\"top\":392,\"height\":60,\"label\":\"Page Footer\",\"page_break\":\"0\",\"margins\":10,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1082\",\"group\":2,\"section\":1,\"objectType\":\"label\",\"left\":28,\"top\":3,\"height\":20,\"width\":785,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"#page# / #pages# \",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":251,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1082\"}]}]},{\"sortField\":\"cur_date\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":229,\"height\":0,\"label\":\" Header\",\"page_break\":\"0\",\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":259,\"height\":133,\"label\":\" Footer\",\"page_break\":\"0\",\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1084\",\"group\":3,\"section\":1,\"objectType\":\"label\",\"left\":436,\"top\":10,\"height\":\"15\",\"width\":500,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Αριθμός Απουσιών : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"9\",\"fontWeight\":\"B\",\"format\":\"7\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":252,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1085\",\"group\":3,\"section\":1,\"objectType\":\"field\",\"left\":669,\"top\":10,\"height\":\"15\",\"width\":200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"SUM(total_n)\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"9\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":253,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"\"},{\"id\":\"object1086\",\"group\":3,\"section\":1,\"objectType\":\"label\",\"left\":436,\"top\":64,\"height\":\"15\",\"width\":500,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Αδικαιολόγητες : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"9\",\"fontWeight\":\"B\",\"format\":\"7\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":254,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1087\",\"group\":3,\"section\":1,\"objectType\":\"field\",\"left\":669,\"top\":64,\"height\":\"15\",\"width\":\"200\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"SUM(not_justified_n)\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"9\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":255,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"\"},{\"id\":\"object1088\",\"group\":3,\"section\":1,\"objectType\":\"label\",\"left\":436,\"top\":86,\"height\":\"15\",\"width\":500,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Δικαιολογημένες Μετρήσιμες : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"9\",\"fontWeight\":\"B\",\"format\":\"7\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":256,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1089\",\"group\":3,\"section\":1,\"objectType\":\"field\",\"left\":669,\"top\":86,\"height\":15,\"width\":199,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"SUM(justified_counts_n)\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"9\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":257,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"\"},{\"id\":\"object1090\",\"group\":3,\"section\":1,\"objectType\":\"label\",\"left\":436,\"top\":37,\"height\":\"15\",\"width\":500,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Δικαιολογημένες Όχι Μετρήσιμες : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"9\",\"fontWeight\":\"B\",\"format\":\"7\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":258,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1091\",\"group\":3,\"section\":1,\"objectType\":\"field\",\"left\":669,\"top\":37,\"height\":15,\"width\":200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"SUM(not_counts_n)\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"9\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":259,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"\"},{\"id\":\"object1092\",\"group\":3,\"section\":1,\"objectType\":\"label\",\"left\":436,\"top\":109,\"height\":\"15\",\"width\":500,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Σύνολο Μετρήσιμων : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"9\",\"fontWeight\":\"B\",\"format\":\"7\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":260,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1093\",\"group\":3,\"section\":1,\"objectType\":\"field\",\"left\":669,\"top\":109,\"height\":15,\"width\":200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"SUM(counts_n)\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"9\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":261,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"\"},{\"id\":\"object1095\",\"group\":3,\"section\":1,\"objectType\":\"label\",\"left\":44,\"top\":2,\"height\":\"0\",\"width\":\"750\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"14\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":262,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1095\"}]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":229,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":259,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":229,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":259,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":229,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":259,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":229,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":259,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":229,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":259,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":229,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":259,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":229,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":259,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]}],\"currentGroup\":0}','2016-12-05 18:33:24','globeadmin','2017-11-28 08:18:56','globeadmin','2017-11-28 08:18:57','globeadmin'),('5a15dd9989051f3','class_print','Εκτυπώνει τα στοιχεία-μαθητές ενός τμήματος','teacher','SELECT \n	class.short_name				    AS class_short_name,\n	class.name						    AS class_name,\n	grade.short_name 				    AS grade_short_name,\n	student.registration_number		    AS student_registration_number,\n	student.surname					    AS student_surname,\n	student.name					    AS student_name,\n	student.fathers_name			    AS student_fathers_name,\n	student.has_left_school			    AS student_has_left_school,\n	school.name 					    AS school_name,\n	school_year.name 				    AS school_year_name,\n	DATE_FORMAT(curdate(),\'%d-%m-%Y\')   AS cur_date,\n	if(teacher.id is NULL,\'\',concat(if(teacher.surname is null,\'\',concat(teacher.surname,\' \')), IFNULL(teacher.name,\'\')))  AS post_teacher_name,\n	1                                   AS cnt\nFROM student\nINNER JOIN class			ON class.id						= \'#RECORD_ID#\'\nINNER JOIN grade 			ON grade.id						= class.grade_id\nINNER JOIN student_class 	ON student_class.student_id		= student.id\nINNER JOIN school 			ON school.id					= 1\nINNER JOIN school_year 		ON school_year.id				= school.school_year_id\nLEFT JOIN teacher           ON teacher.id                   = class.post_teacher_id\nWHERE student_class.class_id=\'#RECORD_ID#\'\nORDER BY student.surname,student.name,student.fathers_name','','','{\"top\":30,\"left\":30,\"bottom\":467,\"right\":30,\"width\":\"210\",\"height\":\"297\",\"paper\":\"A4\",\"orientation\":\"P\",\"groups\":[{\"sortField\":\"Detail\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":344,\"height\":19,\"label\":\"Detail Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1031\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":80,\"top\":-1,\"height\":\"18\",\"width\":\"100\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"student_registration_number\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":211,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1031\"},{\"id\":\"object1032\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":150,\"top\":-1,\"height\":\"18\",\"width\":\"350\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"student_surname\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":212,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1032\"},{\"id\":\"object1033\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":387,\"top\":-1,\"height\":\"18\",\"width\":\"350\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"student_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":213,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1033\"},{\"id\":\"object1034\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":602,\"top\":-1,\"height\":\"18\",\"width\":\"200\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"student_fathers_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":214,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1034\"}]}]},{\"sortField\":\"Report\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":30,\"height\":292,\"label\":\"Report Header\",\"page_break\":\"0\",\"margins\":2,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1007\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":80,\"top\":46,\"height\":15,\"width\":600,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":101,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1007\"},{\"id\":\"object1008\",\"group\":1,\"section\":0,\"objectType\":\"label\",\"left\":35,\"top\":236,\"height\":30,\"width\":786,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Κατάσταση Μαθητών\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"14\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":102,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1008\"},{\"id\":\"object1011\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":80,\"top\":65,\"height\":\"15\",\"width\":\"600\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_year_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":104,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1011\"},{\"id\":\"object1018\",\"group\":1,\"section\":0,\"objectType\":\"label\",\"left\":80,\"top\":96,\"height\":15,\"width\":500,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Ημερομηνία Εκτύπωσης : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"7\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":\"200\",\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1018\"},{\"id\":\"object1037\",\"group\":1,\"section\":0,\"objectType\":\"label\",\"left\":80,\"top\":129,\"height\":18,\"width\":\"500\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Συντομογραφία Τμήματος : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":216,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1037\"},{\"id\":\"object1044\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":226,\"top\":96,\"height\":\"15\",\"width\":\"200\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"cur_date\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":222,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1044\"},{\"id\":\"object1045\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":284,\"top\":129,\"height\":\"18\",\"width\":\"500\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"class_short_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":223,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1045\"},{\"id\":\"object1062\",\"group\":1,\"section\":0,\"objectType\":\"label\",\"left\":80,\"top\":155,\"height\":18,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Όνομα Τμήματος : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":235,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1062\"},{\"id\":\"object1063\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":229,\"top\":155,\"height\":\"18\",\"width\":\"500\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"class_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":236,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1063\"},{\"id\":\"object1065\",\"group\":1,\"section\":0,\"objectType\":\"label\",\"left\":80,\"top\":190,\"height\":14,\"width\":500,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Καταχωριστής Απουσιών : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"7\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":237,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1065\"},{\"id\":\"object1066\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":247,\"top\":190,\"height\":\"14\",\"width\":\"570\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"post_teacher_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":238,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1066\"}]},{\"id\":\"\",\"top\":413,\"height\":24,\"label\":\"Report Footer\",\"page_break\":\"0\",\"margins\":10,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"Page\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":322,\"height\":22,\"label\":\"Page Header\",\"page_break\":\"0\",\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1057\",\"group\":2,\"section\":0,\"objectType\":\"label\",\"left\":80,\"top\":2,\"height\":18,\"width\":100,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Α.Μ.\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":231,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1057\"},{\"id\":\"object1058\",\"group\":2,\"section\":0,\"objectType\":\"label\",\"left\":150,\"top\":2,\"height\":18,\"width\":\"350\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Επώνυμο\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":232,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1058\"},{\"id\":\"object1059\",\"group\":2,\"section\":0,\"objectType\":\"label\",\"left\":387,\"top\":2,\"height\":18,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Όνομα\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":233,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1059\"},{\"id\":\"object1060\",\"group\":2,\"section\":0,\"objectType\":\"label\",\"left\":602,\"top\":2,\"height\":18,\"width\":\"200\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Πατρώνυμο\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":234,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1060\"}]},{\"id\":\"\",\"top\":413,\"height\":0,\"label\":\"Page Footer\",\"page_break\":\"0\",\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"class_short_name\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":344,\"height\":0,\"label\":\" Header\",\"page_break\":\"0\",\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":363,\"height\":50,\"label\":\" Footer\",\"page_break\":\"0\",\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1068\",\"group\":3,\"section\":1,\"objectType\":\"label\",\"left\":81,\"top\":21,\"height\":18,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Αριθμός Μαθητών : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":239,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1068\"},{\"id\":\"object1071\",\"group\":3,\"section\":1,\"objectType\":\"field\",\"left\":232,\"top\":21,\"height\":\"18\",\"width\":\"200\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"SUM(cnt)\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":242,\"minRows\":0,\"maxRows\":\"0\",\"selected\":1,\"name\":\"object1071\"}]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":344,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":363,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":344,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":363,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":344,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":363,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":344,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":363,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":344,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":363,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":344,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":363,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":344,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":363,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]}],\"currentGroup\":0}','2017-11-22 22:27:05','globeadmin','2017-11-23 09:00:27','globeadmin','2017-11-23 09:00:27','globeadmin'),('5a4b96939f5f56f','penalty_report','Τυπώνει τα στοιχεία μιας συγκεκριμένης ποινής','teacher','SELECT\n	concat(student.surname,\' \',student.name,if(student.fathers_name is NULL,\'\',concat(\' πατ. \',student.fathers_name)),\' (ΑΜ:\',student.registration_number,\')\') as student_full_name,\n	date_format(penalty.date_enforced,\'%d-%m-%Y\') as penalty_date_enforced,\n	penalty.type as penalty_type,\n	penalty.reason as penalty_reason,\n	concat(if(penalty.carrier is NULL,\'\',penalty.carrier),if(penalty.carrier IS NOT NULL AND after_referral=1,\' - \',\'\'),if(after_referral=1,\'Μετά από παραπομπή\',\'\')) as penalty_carrier,\n	school.name as school_name,\n	school_year.name as school_year_name,\n	date_format(curdate(),\'%d-%m-%Y\') as cur_date,\n	if(teacher.id IS NULL,\'\',CONCAT(if(teacher.surname is null,\'\',concat(trim(teacher.surname),\' \')), IFNULL(teacher.name,\'\'))) as teacher_name,\n	if(period.id IS NULL,\'\',period.name) as period_short_name,\n	penalty.apology as penalty_apology,\n	if(teacher.id IS NULL,\'\',\'Ο Καθηγητής\') teacher_label\nFROM penalty\nINNER JOIN student ON  student.id = penalty.student_id\nINNER JOIN school on school.id = 1\nINNER JOIN school_year on school_year.id = school.school_year_id\nLEFT JOIN teacher ON teacher.id=penalty.teacher_id\nLEFT JOIN period ON period.id = penalty.period_id\nWHERE penalty.id=\'#RECORD_ID#\'','','','{\"top\":30,\"left\":30,\"bottom\":726,\"right\":30,\"width\":\"210\",\"height\":\"297\",\"paper\":\"A4\",\"orientation\":\"P\",\"groups\":[{\"sortField\":\"Detail\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":395,\"height\":76,\"label\":\"Detail Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1061\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":52,\"top\":18,\"height\":18,\"width\":250,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Αιτία :\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"21\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":235,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1071\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":52,\"top\":43,\"height\":18,\"width\":\"1301\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"penalty_reason\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":242,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1077\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":51,\"top\":8,\"height\":0,\"width\":750,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"14\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":247,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1077\"}]}]},{\"sortField\":\"Report\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":30,\"height\":365,\"label\":\"Report Header\",\"page_break\":\"0\",\"margins\":2,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1007\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":53,\"top\":46,\"height\":15,\"width\":600,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":101,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1007\"},{\"id\":\"object1008\",\"group\":1,\"section\":0,\"objectType\":\"label\",\"left\":53,\"top\":135,\"height\":\"30\",\"width\":\"750\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Επιβληθείσα Ποινή\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"14\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":102,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1008\"},{\"id\":\"object1011\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":53,\"top\":65,\"height\":\"15\",\"width\":\"600\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_year_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":104,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1011\"},{\"id\":\"object1014\",\"group\":1,\"section\":0,\"objectType\":\"label\",\"left\":53,\"top\":192,\"height\":18,\"width\":200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Μαθητής : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":105,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1014\"},{\"id\":\"object1018\",\"group\":1,\"section\":0,\"objectType\":\"label\",\"left\":53,\"top\":88,\"height\":15,\"width\":500,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Ημερομηνία Εκτύπωσης : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"7\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":\"200\",\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1018\"},{\"id\":\"object1042\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":197,\"top\":192,\"height\":\"18\",\"width\":\"950\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"student_full_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":221,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"\"},{\"id\":\"object1044\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":200,\"top\":88,\"height\":\"15\",\"width\":\"200\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"cur_date\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":222,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1044\"},{\"id\":\"object1072\",\"group\":1,\"section\":0,\"objectType\":\"label\",\"left\":53,\"top\":267,\"height\":19,\"width\":200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Καθηγητής : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":243,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1072\"},{\"id\":\"object1073\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":197,\"top\":267,\"height\":19,\"width\":950,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"teacher_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":244,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"\"},{\"id\":\"object1074\",\"group\":1,\"section\":0,\"objectType\":\"label\",\"left\":53,\"top\":290,\"height\":18,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Φορέας Επιβολής : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":245,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1074\"},{\"id\":\"object1075\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":197,\"top\":290,\"height\":18,\"width\":950,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"penalty_carrier\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":246,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"\"},{\"id\":\"object1079\",\"group\":1,\"section\":0,\"objectType\":\"label\",\"left\":51,\"top\":259,\"height\":0,\"width\":750,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"14\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":249,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1079\"},{\"id\":\"object1092\",\"group\":1,\"section\":0,\"objectType\":\"label\",\"left\":53,\"top\":344,\"height\":18,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Διδακτική Ώρα :\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":257,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1092\"},{\"id\":\"object1081\",\"group\":1,\"section\":0,\"objectType\":\"label\",\"left\":51,\"top\":313,\"height\":0,\"width\":750,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"14\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":250,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1081\"},{\"id\":\"object1059\",\"group\":1,\"section\":0,\"objectType\":\"label\",\"left\":53,\"top\":232,\"height\":19,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Τύπος Ποινής :\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":233,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1058\",\"group\":1,\"section\":0,\"objectType\":\"label\",\"left\":53,\"top\":321,\"height\":18,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Ημερομηνία :\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":232,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"\"},{\"id\":\"object1066\",\"group\":1,\"section\":0,\"objectType\":\"label\",\"left\":51,\"top\":220,\"height\":\"0\",\"width\":\"750\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"14\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":238,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1066\"},{\"id\":\"object1100\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":197,\"top\":232,\"height\":19,\"width\":950,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"penalty_type\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":262,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1100\"},{\"id\":\"object1101\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":197,\"top\":321,\"height\":\"18\",\"width\":\"400\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"penalty_date_enforced\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":263,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1101\"},{\"id\":\"object1102\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":197,\"top\":344,\"height\":\"18\",\"width\":\"400\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"period_short_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":264,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1102\"}]},{\"id\":\"\",\"top\":629,\"height\":67,\"label\":\"Report Footer\",\"page_break\":\"0\",\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1095\",\"group\":1,\"section\":1,\"objectType\":\"label\",\"left\":52,\"top\":16,\"height\":18,\"width\":\"300\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Απολογία Μαθητή :\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"21\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":259,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1095\"},{\"id\":\"object1096\",\"group\":1,\"section\":1,\"objectType\":\"label\",\"left\":51,\"top\":6,\"height\":\"0\",\"width\":\"750\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"14\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":260,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1096\"},{\"id\":\"object1098\",\"group\":1,\"section\":1,\"objectType\":\"field\",\"left\":52,\"top\":40,\"height\":19,\"width\":\"1301\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"penalty_apology\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":261,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1098\"}]}]},{\"sortField\":\"Page\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":395,\"height\":0,\"label\":\"Page Header\",\"page_break\":\"0\",\"margins\":2,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":629,\"height\":0,\"label\":\"Page Footer\",\"page_break\":\"0\",\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"student_full_name\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":395,\"height\":0,\"label\":\" Header\",\"page_break\":\"0\",\"margins\":2,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":471,\"height\":158,\"label\":\" Footer\",\"page_break\":\"0\",\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1088\",\"group\":3,\"section\":1,\"objectType\":\"label\",\"left\":51,\"top\":8,\"height\":\"0\",\"width\":\"750\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"14\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":254,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1088\"},{\"id\":\"object1084\",\"group\":3,\"section\":1,\"objectType\":\"label\",\"left\":51,\"top\":16,\"height\":18,\"width\":250,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Ο Διευθυντής\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"21\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":252,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1084\"},{\"id\":\"object1083\",\"group\":3,\"section\":1,\"objectType\":\"field\",\"left\":553,\"top\":18,\"height\":18,\"width\":250,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"teacher_label\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":251,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1083\"}]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":395,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":2,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":471,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":395,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":2,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":471,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":395,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":2,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":471,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":395,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":2,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":471,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":395,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":2,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":471,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":395,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":2,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":471,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":395,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":2,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":471,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]}]}],\"currentGroup\":0}','2018-01-02 16:26:27','globeadmin','2018-01-03 21:33:55','globeadmin','2019-07-29 23:54:17','globeadmin'),('5a521da19c2dba4','penalty_book','Τυπώνει πολλές ποινές σε διαφορετικές σελίδες','teacher','','5a5273258ad81dd','','{\"top\":30,\"left\":30,\"bottom\":773,\"right\":30,\"width\":\"210\",\"height\":\"297\",\"paper\":\"A4\",\"orientation\":\"P\",\"groups\":[{\"sortField\":\"Detail\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":75,\"height\":400,\"label\":\"Detail Header\",\"page_break\":\"0\",\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1061\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":52,\"top\":352,\"height\":18,\"width\":250,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Αιτία :\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"21\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":235,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1071\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":52,\"top\":376,\"height\":18,\"width\":1301,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"penalty_reason\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":242,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1077\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":50,\"top\":334,\"height\":0,\"width\":750,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"14\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":247,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1077\"},{\"id\":\"object1058\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":52,\"top\":282,\"height\":18,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Ημερομηνία :\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":232,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"\"},{\"id\":\"object1092\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":52,\"top\":306,\"height\":18,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Διδακτική Ώρα :\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":257,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"\"},{\"id\":\"object1081\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":50,\"top\":272,\"height\":0,\"width\":750,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"14\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":250,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1081\"},{\"id\":\"object1074\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":52,\"top\":244,\"height\":18,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Φορέας Επιβολής : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":245,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1072\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":52,\"top\":220,\"height\":19,\"width\":200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Καθηγητής : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":243,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1079\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":50,\"top\":210,\"height\":0,\"width\":750,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"14\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":249,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1079\"},{\"id\":\"object1059\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":52,\"top\":182,\"height\":19,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Τύπος Ποινής :\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":233,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1066\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":50,\"top\":172,\"height\":0,\"width\":750,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"14\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":238,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1066\"},{\"id\":\"object1014\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":52,\"top\":144,\"height\":18,\"width\":200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Μαθητής : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":105,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1106\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":194,\"top\":144,\"height\":18,\"width\":950,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"student_full_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":266,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1106\"},{\"id\":\"object1107\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":194,\"top\":182,\"height\":19,\"width\":950,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"penalty_type\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":267,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1107\"},{\"id\":\"object1108\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":194,\"top\":220,\"height\":19,\"width\":950,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"teacher_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":268,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1108\"},{\"id\":\"object1109\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":194,\"top\":244,\"height\":18,\"width\":950,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"penalty_carrier\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":269,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1109\"},{\"id\":\"object1110\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":194,\"top\":282,\"height\":18,\"width\":400,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"penalty_date_enforced\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":270,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1110\"},{\"id\":\"object1111\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":194,\"top\":306,\"height\":18,\"width\":400,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"period_short_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":271,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1111\"},{\"id\":\"object1008\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":52,\"top\":87,\"height\":30,\"width\":750,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Επιβληθείσα Ποινή\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"14\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":102,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1018\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":52,\"top\":53,\"height\":15,\"width\":500,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Ημερομηνία Εκτύπωσης : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"7\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":\"200\",\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1011\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":52,\"top\":29.5,\"height\":15,\"width\":600,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_year_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":104,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1007\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":52,\"top\":6,\"height\":15,\"width\":600,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":101,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1115\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":170,\"top\":53,\"height\":15,\"width\":200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"cur_date\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":273,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1115\"}]}]},{\"sortField\":\"Report\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":30,\"height\":0,\"label\":\"Report Header\",\"page_break\":\"0\",\"margins\":0,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":743,\"height\":0,\"label\":\"Report Footer\",\"page_break\":\"0\",\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"Page\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":30,\"height\":45,\"label\":\"Page Header\",\"page_break\":\"0\",\"margins\":2,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1117\",\"group\":2,\"section\":0,\"objectType\":\"label\",\"left\":67,\"top\":14,\"height\":\"18\",\"width\":\"300\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\" \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"21\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":274,\"minRows\":\"0\",\"maxRows\":0,\"selected\":1,\"name\":\"object1117\"}]},{\"id\":\"\",\"top\":743,\"height\":0,\"label\":\"Page Footer\",\"page_break\":\"0\",\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"student_id\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":75,\"height\":0,\"label\":\" Header\",\"page_break\":\"0\",\"margins\":2,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":736,\"height\":7,\"label\":\" Footer\",\"page_break\":\"1\",\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1113\",\"group\":3,\"section\":1,\"objectType\":\"label\",\"left\":59,\"top\":1,\"height\":\"5\",\"width\":\"300\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\" \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"2\",\"fontWeight\":\"B\",\"format\":\"21\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":272,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1113\"}]}]},{\"sortField\":\"student_full_name\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":75,\"height\":0,\"label\":\" Header\",\"page_break\":\"0\",\"margins\":2,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":475,\"height\":261,\"label\":\" Footer\",\"page_break\":\"0\",\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1088\",\"group\":4,\"section\":1,\"objectType\":\"label\",\"left\":50,\"top\":18,\"height\":\"0\",\"width\":\"750\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"14\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":254,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1088\"},{\"id\":\"object1084\",\"group\":4,\"section\":1,\"objectType\":\"label\",\"left\":50,\"top\":28,\"height\":18,\"width\":250,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Ο Διευθυντής\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"21\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":252,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1084\"},{\"id\":\"object1083\",\"group\":4,\"section\":1,\"objectType\":\"field\",\"left\":552,\"top\":28,\"height\":18,\"width\":250,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"teacher_label\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":251,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1083\"},{\"id\":\"object1095\",\"group\":4,\"section\":1,\"objectType\":\"label\",\"left\":52,\"top\":207,\"height\":18,\"width\":\"300\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Απολογία Μαθητή :\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"21\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":259,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1095\"},{\"id\":\"object1096\",\"group\":4,\"section\":1,\"objectType\":\"label\",\"left\":50,\"top\":187,\"height\":\"0\",\"width\":\"750\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"14\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":260,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1096\"},{\"id\":\"object1098\",\"group\":4,\"section\":1,\"objectType\":\"field\",\"left\":52,\"top\":231,\"height\":19,\"width\":\"1301\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"penalty_apology\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":261,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1098\"}]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":75,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":2,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":475,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":75,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":2,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":475,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":75,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":2,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":475,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":75,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":2,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":475,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":75,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":2,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":475,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":75,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":2,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":475,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]}]}],\"currentGroup\":2}','2018-01-07 15:16:17','globeadmin','2018-01-07 21:23:33','globeadmin','2019-07-30 00:01:27','globeadmin'),('5a8adb1f1beccd3','absence_notes_short_new_ya','Σύντομο δελτίο επικοινωνίας σχολείου γονέων - Νέο ΥΑ','teacher','','552ea7c73b78c04','','{\"top\":30,\"left\":30,\"bottom\":1102,\"right\":30,\"width\":\"210\",\"height\":\"297\",\"paper\":\"A4\",\"orientation\":\"P\",\"groups\":[{\"sortField\":\"Detail\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":407,\"height\":647,\"label\":\"Detail Header\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1017\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":5,\"top\":193,\"height\":20,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"manager_label\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":\"112\",\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1017\"},{\"id\":\"object1018\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":273,\"top\":194,\"height\":20,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"assistmanager_label\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":\"111\",\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1018\"},{\"id\":\"object1019\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":532,\"top\":194,\"height\":20,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"teacher_label\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":113,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1019\"},{\"id\":\"object1045\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":37,\"top\":84,\"height\":20,\"width\":800,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"text1\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":128,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1045\"},{\"id\":\"object1046\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":0,\"top\":34,\"height\":20,\"width\":840,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Δελτίο Επικοινωνίας Σχολείου - Γονέα\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"12\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":129,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1046\"},{\"id\":\"object1051\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":295,\"top\":84,\"height\":20,\"width\":870,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"student_full_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":\"131\",\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1048\"},{\"id\":\"object1058\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":40,\"top\":512,\"height\":20,\"width\":800,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"text10\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":137,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1058\"},{\"id\":\"object1059\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":40,\"top\":577,\"height\":20,\"width\":800,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Ημερομηνία : ________________\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":138,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1059\"},{\"id\":\"object1060\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":40,\"top\":545,\"height\":20,\"width\":1000,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Ονοματεπώνυμο : ______________________________________\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":139,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1060\"},{\"id\":\"object1063\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":273,\"top\":296,\"height\":20,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"assistmanager_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":141,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1063\"},{\"id\":\"object1064\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":5,\"top\":296,\"height\":20,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"manager_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":142,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1064\"},{\"id\":\"object1065\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":532,\"top\":296,\"height\":20,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"teacher_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":143,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1065\"},{\"id\":\"object1074\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":37,\"top\":350,\"height\":20,\"width\":1100,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Μπορείτε να ενημερώνεστε αναλυτικά για τις απουσίες του παιδιού σας στην ιστοσελίδα του σχολείου μας\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"6\",\"fontWeight\":\"I\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":149,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1074\"},{\"id\":\"object1076\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":10,\"top\":451,\"height\":20,\"width\":1175,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":150,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1076\"},{\"id\":\"object1078\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":295,\"top\":513,\"height\":20,\"width\":870,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"student_full_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":151,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1078\"},{\"id\":\"object1080\",\"group\":0,\"section\":0,\"objectType\":\"image\",\"left\":12,\"top\":453,\"height\":15,\"width\":15,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":14,\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"images/cut1.jpg\",\"zIndex\":152,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1080\"},{\"id\":\"object1084\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":37,\"top\":109,\"height\":20,\"width\":1140,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"text2\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":154,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1084\"},{\"id\":\"object1085\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":37,\"top\":134,\"height\":20,\"width\":400,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"text3\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":155,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1085\"},{\"id\":\"object1098\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":10,\"top\":419,\"height\":20,\"width\":40,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"__\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":165,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1098\"},{\"id\":\"object1099\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":10,\"top\":1,\"height\":20,\"width\":40,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"__\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":166,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1099\"},{\"id\":\"object1101\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":40,\"top\":608,\"height\":20,\"width\":\"750\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"issue_date\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"7\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"right\",\"image\":\"\",\"zIndex\":167,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1101\"},{\"id\":\"object1102\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":137,\"top\":608,\"height\":20,\"width\":400,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Υπογραφή\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":168,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1102\"},{\"id\":\"object1104\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":165,\"top\":134,\"height\":20,\"width\":\"800\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"text6\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":169,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1104\"}]}]},{\"sortField\":\"Report\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":30,\"height\":1,\"label\":\"Report Header\",\"page_break\":\"0\",\"margins\":2,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":1072,\"height\":0,\"label\":\"Report Footer\",\"page_break\":\"0\",\"margins\":12,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"Page\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":31,\"height\":8,\"label\":\"Page Header\",\"page_break\":\"0\",\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":1063,\"height\":9,\"label\":\"Page Footer\",\"page_break\":\"0\",\"margins\":12,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"student_id\",\"sortBy\":\"\",\"sections\":[{\"id\":\"\",\"top\":39,\"height\":368,\"label\":\" Header\",\"page_break\":\"0\",\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1001\",\"group\":3,\"section\":0,\"objectType\":\"image\",\"left\":109,\"top\":10,\"height\":\"75\",\"width\":\"75\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":14,\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"images/coat_of_ar.png\",\"zIndex\":100,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1001\"},{\"id\":\"object1002\",\"group\":3,\"section\":0,\"objectType\":\"label\",\"left\":40,\"top\":88,\"height\":20,\"width\":\"800\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"ΕΛΛΗΝΙΚΗ ΔΗΜΟΚΡΑΤΙΑ\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":101,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1002\"},{\"id\":\"object1007\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":40,\"top\":110,\"height\":20,\"width\":\"800\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_ministry\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":104,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1007\"},{\"id\":\"object1009\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":40,\"top\":132,\"height\":20,\"width\":\"800\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_region\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":105,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1009\"},{\"id\":\"object1010\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":40,\"top\":153,\"height\":20,\"width\":\"800\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_intendancy\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":106,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1010\"},{\"id\":\"object1012\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":40,\"top\":182,\"height\":20,\"width\":800,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":107,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1012\"},{\"id\":\"object1013\",\"group\":3,\"section\":0,\"objectType\":\"label\",\"left\":555,\"top\":132,\"height\":20,\"width\":250,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Αρ. Πρωτ. __________\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"right\",\"image\":\"\",\"zIndex\":108,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1013\"},{\"id\":\"object1015\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":455,\"top\":88,\"height\":20,\"width\":\"350\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"cur_date\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"right\",\"image\":\"\",\"zIndex\":110,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1015\"},{\"id\":\"object1022\",\"group\":3,\"section\":0,\"objectType\":\"label\",\"left\":40,\"top\":270,\"height\":20,\"width\":200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Τηλ. :\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":\"114\",\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1022\"},{\"id\":\"object1024\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":88,\"top\":270,\"height\":20,\"width\":\"600\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_phone\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":115,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1024\"},{\"id\":\"object1026\",\"group\":3,\"section\":0,\"objectType\":\"label\",\"left\":40,\"top\":291,\"height\":20,\"width\":200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Fax :\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":116,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1026\"},{\"id\":\"object1027\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":88,\"top\":291,\"height\":20,\"width\":\"600\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_fax\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":117,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1027\"},{\"id\":\"object1031\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":40,\"top\":204,\"height\":20,\"width\":800,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"school_street_area\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":118,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1031\"},{\"id\":\"object1032\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":40,\"top\":226,\"height\":20,\"width\":800,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"school_zipcode_city\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":119,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1032\"},{\"id\":\"object1034\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":40,\"top\":248,\"height\":20,\"width\":800,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"school_state_country\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":120,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1034\"},{\"id\":\"object1036\",\"group\":3,\"section\":0,\"objectType\":\"label\",\"left\":40,\"top\":313,\"height\":20,\"width\":200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Email :\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":121,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1036\"},{\"id\":\"object1038\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":97,\"top\":313,\"height\":20,\"width\":\"600\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_email\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":123,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1038\"},{\"id\":\"object1039\",\"group\":3,\"section\":0,\"objectType\":\"label\",\"left\":40,\"top\":335,\"height\":20,\"width\":\"250\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Ιστοσελίδα :\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":124,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1039\"},{\"id\":\"object1041\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":133,\"top\":335,\"height\":20,\"width\":600,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"school_web_page\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":126,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1041\"},{\"id\":\"object1092\",\"group\":3,\"section\":0,\"objectType\":\"label\",\"left\":468,\"top\":204,\"height\":20,\"width\":200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Πρός κ. \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":161,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1092\"},{\"id\":\"object1093\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":468,\"top\":226,\"height\":20,\"width\":\"680\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"address1\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":162,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1093\"},{\"id\":\"object1094\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":468,\"top\":248,\"height\":\"20\",\"width\":\"680\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"address2\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":163,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1094\"},{\"id\":\"object1096\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":528,\"top\":204,\"height\":20,\"width\":\"620\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"student_parent_full_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":164,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1096\"}]},{\"id\":\"\",\"top\":1054,\"height\":9,\"label\":\" Footer\",\"page_break\":\"1\",\"margins\":10,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1005\",\"group\":3,\"section\":1,\"objectType\":\"label\",\"left\":151,\"top\":0,\"height\":\"10\",\"width\":\"500\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":103,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1005\"}]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":407,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":1054,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":407,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":1054,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":407,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":1054,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":407,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":1054,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":407,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":1054,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":407,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":1054,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":407,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":1054,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]}],\"currentGroup\":0}','2018-02-19 16:11:43','globeadmin','2018-02-19 16:23:43','globeadmin','2018-02-25 10:37:52','globeadmin'),('5a8add5aeea826d','absence_notes_short_student_ya','Σύντομο δελτίο επικοινωνίας σχολείου γονέων με αποδεικτικό ότι το παράλαβε ο μαθητής ΥΑ','teacher','','552ea7c73b78c04','','{\"top\":30,\"left\":30,\"bottom\":1152,\"right\":30,\"width\":\"210\",\"height\":\"297\",\"paper\":\"A4\",\"orientation\":\"P\",\"groups\":[{\"sortField\":\"Detail\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":407,\"height\":697,\"label\":\"Detail Header\",\"page_break\":\"0\",\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1017\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":5,\"top\":205,\"height\":20,\"width\":\"300\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"manager_label\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":\"112\",\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1017\"},{\"id\":\"object1018\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":273,\"top\":205,\"height\":20,\"width\":\"300\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"assistmanager_label\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":\"111\",\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1018\"},{\"id\":\"object1019\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":532,\"top\":205,\"height\":20,\"width\":\"300\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"teacher_label\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":113,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1019\"},{\"id\":\"object1045\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":37,\"top\":126,\"height\":20,\"width\":\"800\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"text1\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":128,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1045\"},{\"id\":\"object1046\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":0,\"top\":88,\"height\":20,\"width\":\"840\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Δελτίο Επικοινωνίας Σχολείου - Γονέα\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"12\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":129,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1046\"},{\"id\":\"object1051\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":295,\"top\":126,\"height\":20,\"width\":\"870\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"student_full_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":\"131\",\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1048\"},{\"id\":\"object1058\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":40,\"top\":360,\"height\":20,\"width\":800,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"text10\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":137,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1058\"},{\"id\":\"object1059\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":40,\"top\":430,\"height\":20,\"width\":800,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Ημερομηνία : ________________\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":138,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1059\"},{\"id\":\"object1060\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":40,\"top\":398,\"height\":20,\"width\":1000,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Ονοματεπώνυμο : ______________________________________\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":139,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1060\"},{\"id\":\"object1061\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":500,\"top\":3,\"height\":20,\"width\":200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Πρός κ. \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":140,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1061\"},{\"id\":\"object1063\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":273,\"top\":269,\"height\":20,\"width\":\"300\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"assistmanager_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":141,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1063\"},{\"id\":\"object1064\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":5,\"top\":269,\"height\":20,\"width\":\"300\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"manager_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":142,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1064\"},{\"id\":\"object1065\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":532,\"top\":269,\"height\":20,\"width\":\"300\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"teacher_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":143,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1065\"},{\"id\":\"object1067\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":560,\"top\":3,\"height\":20,\"width\":\"620\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"student_parent_full_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":144,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1067\"},{\"id\":\"object1069\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":500,\"top\":26,\"height\":20,\"width\":\"680\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"address1\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":145,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1069\"},{\"id\":\"object1070\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":500,\"top\":49,\"height\":\"20\",\"width\":\"680\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"address2\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":146,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1070\"},{\"id\":\"object1074\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":37,\"top\":313,\"height\":20,\"width\":1100,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Μπορείτε να ενημερώνεστε αναλυτικά για τις απουσίες του παιδιού σας στην ιστοσελίδα του σχολείου μας\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"6\",\"fontWeight\":\"I\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":149,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1074\"},{\"id\":\"object1076\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":10,\"top\":339,\"height\":\"20\",\"width\":\"1175\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":150,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1076\"},{\"id\":\"object1078\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":295,\"top\":360,\"height\":20,\"width\":\"870\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"student_full_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":151,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1078\"},{\"id\":\"object1080\",\"group\":0,\"section\":0,\"objectType\":\"image\",\"left\":15,\"top\":341,\"height\":15,\"width\":15,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":14,\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"images/cut1.jpg\",\"zIndex\":152,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1080\"},{\"id\":\"object1084\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":37,\"top\":151,\"height\":20,\"width\":\"1140\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"text2\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":154,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1084\"},{\"id\":\"object1085\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":37,\"top\":176,\"height\":20,\"width\":\"400\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"text3\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":155,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1085\"},{\"id\":\"object1087\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":13,\"top\":564,\"height\":\"20\",\"width\":\"1175\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":156,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1087\"},{\"id\":\"object1088\",\"group\":0,\"section\":0,\"objectType\":\"image\",\"left\":18,\"top\":566,\"height\":15,\"width\":15,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":14,\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"images/cut1.jpg\",\"zIndex\":157,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1088\"},{\"id\":\"object1090\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":43,\"top\":646,\"height\":20,\"width\":800,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Ημερομηνία : ________________\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":158,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1090\"},{\"id\":\"object1094\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":43,\"top\":588,\"height\":20,\"width\":800,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"text100\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":160,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1094\"},{\"id\":\"object1095\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":136,\"top\":588,\"height\":20,\"width\":\"870\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"student_full_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":161,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1095\"},{\"id\":\"object1096\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":43,\"top\":611,\"height\":20,\"width\":\"1135\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Δηλώνω ότι παρέλαβα το «Δελτίο Επικοινωνίας Σχολείου-Γονέα».\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":162,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1096\"},{\"id\":\"object1098\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":55,\"top\":456,\"height\":20,\"width\":\"750\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"issue_date\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"7\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"right\",\"image\":\"\",\"zIndex\":\"148\",\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1098\"},{\"id\":\"object1100\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":137,\"top\":456,\"height\":20,\"width\":\"400\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Υπογραφή\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":164,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1100\"},{\"id\":\"object1101\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":55,\"top\":672,\"height\":20,\"width\":\"750\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"issue_date\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"7\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"right\",\"image\":\"\",\"zIndex\":165,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1101\"},{\"id\":\"object1102\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":140,\"top\":672,\"height\":20,\"width\":\"400\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Υπογραφή\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":166,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1102\"},{\"id\":\"object1104\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":165,\"top\":176,\"height\":20,\"width\":\"800\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"text6\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":167,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1104\"}]}]},{\"sortField\":\"Report\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":30,\"height\":1,\"label\":\"Report Header\",\"page_break\":\"0\",\"margins\":2,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":1122,\"height\":0,\"label\":\"Report Footer\",\"page_break\":\"0\",\"margins\":12,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"Page\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":31,\"height\":18,\"label\":\"Page Header\",\"page_break\":\"0\",\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":1113,\"height\":9,\"label\":\"Page Footer\",\"page_break\":\"0\",\"margins\":12,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"student_id\",\"sortBy\":\"\",\"sections\":[{\"id\":\"\",\"top\":49,\"height\":358,\"label\":\" Header\",\"page_break\":\"0\",\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1001\",\"group\":3,\"section\":0,\"objectType\":\"image\",\"left\":109,\"top\":10,\"height\":\"75\",\"width\":\"75\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":14,\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"images/coat_of_ar.png\",\"zIndex\":100,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1001\"},{\"id\":\"object1002\",\"group\":3,\"section\":0,\"objectType\":\"label\",\"left\":40,\"top\":88,\"height\":20,\"width\":\"800\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"ΕΛΛΗΝΙΚΗ ΔΗΜΟΚΡΑΤΙΑ\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":101,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1002\"},{\"id\":\"object1007\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":40,\"top\":110,\"height\":20,\"width\":\"800\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_ministry\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":104,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1007\"},{\"id\":\"object1009\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":40,\"top\":132,\"height\":20,\"width\":\"800\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_region\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":105,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1009\"},{\"id\":\"object1010\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":40,\"top\":153,\"height\":20,\"width\":\"800\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_intendancy\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":106,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1010\"},{\"id\":\"object1012\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":40,\"top\":182,\"height\":20,\"width\":800,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":107,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1012\"},{\"id\":\"object1013\",\"group\":3,\"section\":0,\"objectType\":\"label\",\"left\":555,\"top\":153,\"height\":20,\"width\":250,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Αρ. Πρωτ. __________\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"right\",\"image\":\"\",\"zIndex\":108,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1013\"},{\"id\":\"object1015\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":455,\"top\":110,\"height\":20,\"width\":\"350\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"cur_date\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"right\",\"image\":\"\",\"zIndex\":110,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1015\"},{\"id\":\"object1022\",\"group\":3,\"section\":0,\"objectType\":\"label\",\"left\":40,\"top\":270,\"height\":20,\"width\":200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Τηλ. :\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":\"114\",\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1022\"},{\"id\":\"object1024\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":88,\"top\":270,\"height\":20,\"width\":\"600\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_phone\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":115,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1024\"},{\"id\":\"object1026\",\"group\":3,\"section\":0,\"objectType\":\"label\",\"left\":40,\"top\":291,\"height\":20,\"width\":200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Fax :\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":116,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1026\"},{\"id\":\"object1027\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":88,\"top\":291,\"height\":20,\"width\":\"600\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_fax\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":117,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1027\"},{\"id\":\"object1031\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":40,\"top\":204,\"height\":20,\"width\":800,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"school_street_area\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":118,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1031\"},{\"id\":\"object1032\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":40,\"top\":226,\"height\":20,\"width\":800,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"school_zipcode_city\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":119,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1032\"},{\"id\":\"object1034\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":40,\"top\":248,\"height\":20,\"width\":800,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"school_state_country\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":120,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1034\"},{\"id\":\"object1036\",\"group\":3,\"section\":0,\"objectType\":\"label\",\"left\":40,\"top\":313,\"height\":20,\"width\":200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Email :\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":121,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1036\"},{\"id\":\"object1038\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":97,\"top\":313,\"height\":20,\"width\":\"600\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_email\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":123,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1038\"},{\"id\":\"object1039\",\"group\":3,\"section\":0,\"objectType\":\"label\",\"left\":40,\"top\":335,\"height\":20,\"width\":\"250\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Ιστοσελίδα :\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":124,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1039\"},{\"id\":\"object1041\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":133,\"top\":335,\"height\":20,\"width\":600,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"school_web_page\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":126,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1041\"}]},{\"id\":\"\",\"top\":1104,\"height\":9,\"label\":\" Footer\",\"page_break\":\"1\",\"margins\":10,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1005\",\"group\":3,\"section\":1,\"objectType\":\"label\",\"left\":151,\"top\":0,\"height\":\"10\",\"width\":\"500\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":103,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1005\"}]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":407,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":1104,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":407,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":1104,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":407,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":1104,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":407,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":1104,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":407,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":1104,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":407,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":1104,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":407,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":1104,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]}],\"currentGroup\":0}','2018-02-19 16:21:15','globeadmin','2018-02-19 16:24:32','globeadmin','2018-02-19 16:24:33','globeadmin'),('5b67ff45182fe35','old_attendance_student_book','Παλαιό - Βιβλίο φοίτησης ενός μαθητή','teacher','','555d8a344f6f95a','','{\"top\":30,\"left\":30,\"bottom\":459,\"right\":30,\"width\":\"297\",\"height\":\"210\",\"paper\":\"A4\",\"orientation\":\"L\",\"groups\":[{\"sortField\":\"Detail\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":198,\"height\":56,\"label\":\"Detail Header\",\"page_break\":\"0\",\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1046\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":25,\"top\":0,\"height\":\"54\",\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"month_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":223,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1046\"},{\"id\":\"object1047\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":142,\"top\":0,\"height\":\"18\",\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Σύνολο\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":224,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1048\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":142,\"top\":18,\"height\":\"18\",\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Δικαιολογημένες\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":225,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1049\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":142,\"top\":36,\"height\":18,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Αδικαιολόγητες\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":226,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1050\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":256,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s1\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":227,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1051\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":284,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s2\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":228,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1052\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":312,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s3\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":229,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1053\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":340,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s4\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":230,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1054\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":368,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s5\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":231,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1055\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":395,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s6\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":232,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1056\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":423,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s7\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":233,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1057\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":451,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s8\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":234,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1058\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":479,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s9\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":235,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1059\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":507,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s10\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":236,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1060\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":535,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s11\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":237,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1061\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":562,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s12\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":238,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1062\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":590,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s13\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":239,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1063\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":618,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s14\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":240,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1064\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":646,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s15\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":241,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1065\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":674,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s16\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":242,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1066\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":702,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s17\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":243,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1067\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":730,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s18\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":244,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1068\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":758,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s19\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":245,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1069\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":785,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s20\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":246,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1070\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":813,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s21\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":247,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1071\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":841,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s22\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":248,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1072\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":869,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s23\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":249,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1073\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":897,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s24\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":250,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1074\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":925,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s25\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":251,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1075\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":953,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s26\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":252,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1076\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":980,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s27\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":253,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1077\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":1008,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s28\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":254,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1078\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":1036,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s29\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":255,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1079\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":1064,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s30\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":256,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1080\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":1092,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s31\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":257,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1082\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":256,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d1\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":258,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1083\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":284,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d2\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":259,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1084\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":312,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d3\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":260,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1085\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":340,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d4\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":261,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1086\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":368,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d5\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":262,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1087\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":395,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d6\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":263,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1088\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":423,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d7\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":264,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1089\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":451,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d8\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":265,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1090\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":479,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d9\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":266,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1091\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":507,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d10\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":267,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1092\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":535,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d11\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":268,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1093\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":562,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d12\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":269,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1094\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":590,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d13\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":270,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1095\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":618,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d14\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":271,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1096\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":646,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d15\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":272,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1097\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":674,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d16\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":273,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1098\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":702,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d17\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":274,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1099\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":730,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d18\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":275,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1100\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":758,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d19\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":276,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1101\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":785,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d20\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":277,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1102\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":813,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d21\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":278,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1103\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":841,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d22\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":279,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1104\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":869,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d23\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":280,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1105\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":897,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d24\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":281,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1106\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":925,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d25\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":282,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1107\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":953,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d26\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":283,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1108\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":980,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d27\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":284,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1109\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":1008,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d28\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":285,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1110\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":1036,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d29\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":286,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1111\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":1064,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d30\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":287,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1112\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":1092,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d31\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":288,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1113\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":256,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a1\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":289,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1114\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":284,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a2\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":290,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1115\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":312,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a3\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":291,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1116\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":340,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a4\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":292,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1117\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":368,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a5\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":293,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1118\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":395,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a6\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":294,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1119\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":423,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a7\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":295,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1120\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":451,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a8\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":296,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1121\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":479,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a9\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":297,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1122\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":507,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a10\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":298,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1123\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":535,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a11\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":299,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1124\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":562,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a12\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":300,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1125\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":590,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a13\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":301,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1126\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":618,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a14\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":302,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1127\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":646,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a15\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":303,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1128\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":674,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a16\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":304,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1129\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":702,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a17\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":305,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1130\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":730,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a18\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":306,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1131\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":758,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a19\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":307,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1132\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":785,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a20\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":308,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1133\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":813,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a21\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":309,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1134\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":841,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a22\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":310,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1135\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":869,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a23\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":311,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1136\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":897,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a24\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":312,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1137\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":925,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a25\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":313,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1138\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":953,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a26\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":314,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1139\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":980,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a27\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":315,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1140\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":1008,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a28\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":316,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1141\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":1036,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a29\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":317,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1142\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":1064,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a30\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":318,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1143\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":1092,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a31\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":319,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1182\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":1122,\"top\":0,\"height\":18,\"width\":\"35\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"sm\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":355,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1183\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":1122,\"top\":18,\"height\":18,\"width\":\"35\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"dm\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":356,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1184\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":1122,\"top\":36,\"height\":18,\"width\":\"35\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"am\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":357,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"}]}]},{\"sortField\":\"Report\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":30,\"height\":10,\"label\":\"Report Header\",\"page_break\":\"0\",\"margins\":2,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":360,\"height\":69,\"label\":\"Report Footer\",\"page_break\":\"0\",\"margins\":14,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"Page\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":40,\"height\":10,\"label\":\"Page Header\",\"page_break\":\"0\",\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":360,\"height\":0,\"label\":\"Page Footer\",\"page_break\":\"0\",\"margins\":12,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"s_id\",\"sortBy\":\"\",\"sections\":[{\"id\":\"\",\"top\":50,\"height\":0,\"label\":\"s_id Header\",\"page_break\":\"0\",\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":344,\"height\":16,\"label\":\"s_id Footer\",\"page_break\":\"0\",\"margins\":12,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1188\",\"group\":3,\"section\":1,\"objectType\":\"label\",\"left\":150,\"top\":0,\"height\":\"10\",\"width\":\"30\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":359,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1188\"}]}]},{\"sortField\":\"student_id\",\"sortBy\":\"\",\"sections\":[{\"id\":\"\",\"top\":50,\"height\":148,\"label\":\" Header\",\"page_break\":\"0\",\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1014\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":25,\"top\":53,\"height\":18,\"width\":200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Μαθητής : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":105,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1014\"},{\"id\":\"object1018\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":26,\"top\":32,\"height\":15,\"width\":500,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Ημερομηνία : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"7\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":\"200\",\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1018\"},{\"id\":\"object1011\",\"group\":4,\"section\":0,\"objectType\":\"field\",\"left\":561,\"top\":10,\"height\":15,\"width\":600,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_year_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"right\",\"image\":\"\",\"zIndex\":104,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1011\"},{\"id\":\"object1007\",\"group\":4,\"section\":0,\"objectType\":\"field\",\"left\":25,\"top\":10,\"height\":15,\"width\":600,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":101,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1007\"},{\"id\":\"object1008\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":49,\"top\":86,\"height\":25,\"width\":1050,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Βιβλίο Φοίτησης Μαθητή\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"14\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":102,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1008\"},{\"id\":\"object1146\",\"group\":4,\"section\":0,\"objectType\":\"field\",\"left\":147,\"top\":32,\"height\":15,\"width\":200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"cur_date\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":321,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1146\"},{\"id\":\"object1147\",\"group\":4,\"section\":0,\"objectType\":\"field\",\"left\":103,\"top\":53,\"height\":18,\"width\":1075,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"student_full_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":322,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1147\"},{\"id\":\"object1179\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":1092,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"31\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":353,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1178\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":1064,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"30\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":352,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1177\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":1036,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"29\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":351,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1176\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":1008,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"28\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":350,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1175\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":980,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"27\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":349,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1174\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":953,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"26\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":348,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1173\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":925,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"25\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":347,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1172\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":897,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"24\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":346,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1171\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":869,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"23\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":345,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1170\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":841,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"22\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":344,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1169\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":813,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"21\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":343,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1168\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":785,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"20\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":342,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1167\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":758,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"19\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":341,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1166\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":730,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"18\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":340,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1165\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":702,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"17\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":339,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1164\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":674,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"16\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":338,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1163\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":646,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"15\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":337,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1162\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":618,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"14\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":336,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1161\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":590,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"13\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":335,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1160\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":562,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"12\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":334,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1159\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":535,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"11\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":333,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1158\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":507,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"10\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":332,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1157\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":479,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"9\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":331,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1156\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":451,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"8\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":330,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1155\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":423,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"7\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":329,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1154\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":395,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"6\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":328,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1153\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":368,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"5\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":327,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1152\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":340,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"4\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":326,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1151\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":312,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"3\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":325,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1150\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":284,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"2\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":324,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1149\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":256,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"1\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":323,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1181\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":1122,\"top\":128,\"height\":18,\"width\":\"35\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Σ\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":354,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"}]},{\"id\":\"\",\"top\":254,\"height\":90,\"label\":\" Footer\",\"page_break\":\"0\",\"margins\":10,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1190\",\"group\":4,\"section\":1,\"objectType\":\"label\",\"left\":736,\"top\":38,\"height\":18,\"width\":450,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Σύνολο Δικαιολογημένων : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":360,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1190\"},{\"id\":\"object1191\",\"group\":4,\"section\":1,\"objectType\":\"label\",\"left\":736,\"top\":60,\"height\":18,\"width\":450,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Σύνολο Αδικαιολόγητων : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":361,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1191\"},{\"id\":\"object1192\",\"group\":4,\"section\":1,\"objectType\":\"label\",\"left\":736,\"top\":17,\"height\":18,\"width\":450,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Σύνολο Απουσιών : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":362,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1192\"},{\"id\":\"object1194\",\"group\":4,\"section\":1,\"objectType\":\"field\",\"left\":953,\"top\":38,\"height\":18,\"width\":40,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"SUM(dm)\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"right\",\"image\":\"\",\"zIndex\":364,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1195\",\"group\":4,\"section\":1,\"objectType\":\"field\",\"left\":953,\"top\":59,\"height\":18,\"width\":40,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"SUM(am)\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"right\",\"image\":\"\",\"zIndex\":365,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1196\",\"group\":4,\"section\":1,\"objectType\":\"field\",\"left\":953,\"top\":17,\"height\":18,\"width\":40,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"SUM(sm)\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"right\",\"image\":\"\",\"zIndex\":366,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1198\",\"group\":4,\"section\":1,\"objectType\":\"label\",\"left\":736,\"top\":37,\"height\":0,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":367,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1198\"},{\"id\":\"object1200\",\"group\":4,\"section\":1,\"objectType\":\"label\",\"left\":736,\"top\":56,\"height\":0,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":368,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1200\"},{\"id\":\"object1201\",\"group\":4,\"section\":1,\"objectType\":\"label\",\"left\":736,\"top\":80,\"height\":0,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":369,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1201\"}]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":198,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":254,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":198,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":254,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":198,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":254,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":198,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":254,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":198,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":254,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":198,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":254,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]}],\"currentGroup\":3}','2018-08-06 10:56:53','globeadmin','2018-08-06 10:56:53','globeadmin','2018-08-06 10:56:53','globeadmin'),('5b67ff6dad11ea9','old_attendance_book','Παλαιό - Βιβλίο φοίτησης','teacher','','555d8a344f6f95a','','{\"top\":30,\"left\":30,\"bottom\":459,\"right\":30,\"width\":\"297\",\"height\":\"210\",\"paper\":\"A4\",\"orientation\":\"L\",\"groups\":[{\"sortField\":\"Detail\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":198,\"height\":56,\"label\":\"Detail Header\",\"page_break\":\"0\",\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1046\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":25,\"top\":0,\"height\":\"54\",\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"month_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":223,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1046\"},{\"id\":\"object1047\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":142,\"top\":0,\"height\":\"18\",\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Σύνολο\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":224,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1048\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":142,\"top\":18,\"height\":\"18\",\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Δικαιολογημένες\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":225,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1049\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":142,\"top\":36,\"height\":18,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Αδικαιολόγητες\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":226,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1050\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":256,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s1\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":227,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1051\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":284,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s2\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":228,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1052\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":312,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s3\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":229,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1053\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":340,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s4\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":230,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1054\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":368,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s5\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":231,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1055\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":395,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s6\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":232,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1056\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":423,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s7\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":233,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1057\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":451,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s8\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":234,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1058\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":479,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s9\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":235,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1059\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":507,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s10\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":236,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1060\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":535,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s11\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":237,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1061\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":562,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s12\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":238,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1062\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":590,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s13\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":239,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1063\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":618,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s14\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":240,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1064\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":646,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s15\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":241,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1065\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":674,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s16\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":242,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1066\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":702,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s17\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":243,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1067\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":730,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s18\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":244,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1068\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":758,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s19\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":245,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1069\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":785,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s20\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":246,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1070\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":813,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s21\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":247,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1071\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":841,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s22\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":248,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1072\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":869,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s23\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":249,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1073\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":897,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s24\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":250,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1074\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":925,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s25\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":251,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1075\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":953,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s26\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":252,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1076\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":980,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s27\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":253,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1077\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":1008,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s28\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":254,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1078\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":1036,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s29\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":255,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1079\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":1064,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s30\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":256,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1080\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":1092,\"top\":0,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"s31\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":257,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1082\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":256,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d1\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":258,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1083\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":284,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d2\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":259,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1084\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":312,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d3\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":260,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1085\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":340,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d4\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":261,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1086\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":368,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d5\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":262,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1087\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":395,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d6\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":263,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1088\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":423,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d7\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":264,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1089\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":451,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d8\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":265,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1090\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":479,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d9\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":266,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1091\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":507,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d10\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":267,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1092\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":535,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d11\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":268,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1093\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":562,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d12\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":269,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1094\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":590,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d13\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":270,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1095\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":618,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d14\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":271,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1096\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":646,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d15\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":272,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1097\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":674,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d16\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":273,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1098\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":702,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d17\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":274,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1099\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":730,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d18\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":275,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1100\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":758,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d19\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":276,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1101\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":785,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d20\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":277,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1102\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":813,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d21\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":278,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1103\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":841,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d22\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":279,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1104\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":869,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d23\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":280,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1105\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":897,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d24\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":281,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1106\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":925,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d25\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":282,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1107\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":953,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d26\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":283,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1108\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":980,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d27\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":284,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1109\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":1008,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d28\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":285,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1110\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":1036,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d29\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":286,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1111\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":1064,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d30\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":287,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1112\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":1092,\"top\":18,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"d31\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":288,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1113\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":256,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a1\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":289,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1114\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":284,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a2\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":290,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1115\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":312,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a3\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":291,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1116\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":340,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a4\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":292,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1117\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":368,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a5\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":293,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1118\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":395,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a6\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":294,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1119\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":423,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a7\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":295,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1120\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":451,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a8\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":296,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1121\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":479,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a9\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":297,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1122\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":507,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a10\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":298,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1123\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":535,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a11\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":299,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1124\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":562,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a12\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":300,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1125\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":590,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a13\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":301,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1126\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":618,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a14\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":302,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1127\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":646,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a15\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":303,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1128\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":674,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a16\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":304,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1129\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":702,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a17\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":305,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1130\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":730,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a18\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":306,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1131\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":758,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a19\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":307,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1132\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":785,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a20\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":308,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1133\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":813,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a21\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":309,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1134\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":841,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a22\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":310,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1135\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":869,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a23\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":311,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1136\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":897,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a24\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":312,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1137\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":925,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a25\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":313,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1138\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":953,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a26\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":314,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1139\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":980,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a27\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":315,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1140\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":1008,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a28\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":316,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1141\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":1036,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a29\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":317,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1142\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":1064,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a30\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":318,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1143\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":1092,\"top\":36,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"a31\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":319,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1182\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":1122,\"top\":0,\"height\":18,\"width\":\"35\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"sm\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":355,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1183\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":1122,\"top\":18,\"height\":18,\"width\":\"35\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"dm\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":356,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1184\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":1122,\"top\":36,\"height\":18,\"width\":\"35\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"am\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":357,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"}]}]},{\"sortField\":\"Report\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":30,\"height\":10,\"label\":\"Report Header\",\"page_break\":\"0\",\"margins\":2,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":360,\"height\":69,\"label\":\"Report Footer\",\"page_break\":\"0\",\"margins\":14,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"Page\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":40,\"height\":10,\"label\":\"Page Header\",\"page_break\":\"0\",\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":360,\"height\":0,\"label\":\"Page Footer\",\"page_break\":\"0\",\"margins\":12,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"s_id\",\"sortBy\":\"\",\"sections\":[{\"id\":\"\",\"top\":50,\"height\":0,\"label\":\" Header\",\"page_break\":\"0\",\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":344,\"height\":16,\"label\":\" Footer\",\"page_break\":\"1\",\"margins\":12,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1188\",\"group\":3,\"section\":1,\"objectType\":\"label\",\"left\":150,\"top\":0,\"height\":\"10\",\"width\":\"30\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":359,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1188\"}]}]},{\"sortField\":\"student_id\",\"sortBy\":\"\",\"sections\":[{\"id\":\"\",\"top\":50,\"height\":148,\"label\":\" Header\",\"page_break\":\"0\",\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1014\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":25,\"top\":53,\"height\":18,\"width\":200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Μαθητής : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":105,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1014\"},{\"id\":\"object1018\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":26,\"top\":32,\"height\":15,\"width\":500,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Ημερομηνία : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"7\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":\"200\",\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1018\"},{\"id\":\"object1011\",\"group\":4,\"section\":0,\"objectType\":\"field\",\"left\":561,\"top\":10,\"height\":15,\"width\":600,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_year_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"right\",\"image\":\"\",\"zIndex\":104,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1011\"},{\"id\":\"object1007\",\"group\":4,\"section\":0,\"objectType\":\"field\",\"left\":25,\"top\":10,\"height\":15,\"width\":600,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":101,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1007\"},{\"id\":\"object1008\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":49,\"top\":86,\"height\":25,\"width\":1050,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Βιβλίο Φοίτησης Μαθητή\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"14\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":102,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1008\"},{\"id\":\"object1146\",\"group\":4,\"section\":0,\"objectType\":\"field\",\"left\":147,\"top\":32,\"height\":15,\"width\":200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"cur_date\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":321,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1146\"},{\"id\":\"object1147\",\"group\":4,\"section\":0,\"objectType\":\"field\",\"left\":103,\"top\":53,\"height\":18,\"width\":1075,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"student_full_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":322,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1147\"},{\"id\":\"object1179\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":1092,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"31\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":353,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1178\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":1064,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"30\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":352,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1177\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":1036,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"29\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":351,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1176\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":1008,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"28\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":350,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1175\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":980,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"27\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":349,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1174\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":953,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"26\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":348,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1173\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":925,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"25\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":347,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1172\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":897,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"24\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":346,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1171\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":869,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"23\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":345,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1170\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":841,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"22\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":344,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1169\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":813,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"21\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":343,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1168\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":785,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"20\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":342,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1167\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":758,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"19\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":341,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1166\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":730,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"18\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":340,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1165\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":702,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"17\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":339,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1164\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":674,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"16\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":338,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1163\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":646,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"15\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":337,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1162\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":618,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"14\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":336,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1161\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":590,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"13\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":335,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1160\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":562,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"12\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":334,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1159\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":535,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"11\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":333,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1158\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":507,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"10\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":332,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1157\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":479,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"9\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":331,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1156\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":451,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"8\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":330,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1155\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":423,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"7\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":329,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1154\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":395,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"6\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":328,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1153\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":368,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"5\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":327,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1152\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":340,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"4\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":326,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1151\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":312,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"3\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":325,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1150\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":284,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"2\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":324,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1149\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":256,\"top\":128,\"height\":18,\"width\":27,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"1\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":323,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1181\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":1122,\"top\":128,\"height\":18,\"width\":\"35\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"Σ\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":354,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"}]},{\"id\":\"\",\"top\":254,\"height\":90,\"label\":\" Footer\",\"page_break\":\"0\",\"margins\":10,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1190\",\"group\":4,\"section\":1,\"objectType\":\"label\",\"left\":736,\"top\":38,\"height\":18,\"width\":450,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Σύνολο Δικαιολογημένων : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":360,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1190\"},{\"id\":\"object1191\",\"group\":4,\"section\":1,\"objectType\":\"label\",\"left\":736,\"top\":60,\"height\":18,\"width\":450,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Σύνολο Αδικαιολόγητων : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":361,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1191\"},{\"id\":\"object1192\",\"group\":4,\"section\":1,\"objectType\":\"label\",\"left\":736,\"top\":17,\"height\":18,\"width\":450,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Σύνολο Απουσιών : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":362,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1192\"},{\"id\":\"object1194\",\"group\":4,\"section\":1,\"objectType\":\"field\",\"left\":953,\"top\":38,\"height\":18,\"width\":40,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"SUM(dm)\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"right\",\"image\":\"\",\"zIndex\":364,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1195\",\"group\":4,\"section\":1,\"objectType\":\"field\",\"left\":953,\"top\":59,\"height\":18,\"width\":40,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"SUM(am)\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"right\",\"image\":\"\",\"zIndex\":365,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1196\",\"group\":4,\"section\":1,\"objectType\":\"field\",\"left\":953,\"top\":17,\"height\":18,\"width\":40,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"SUM(sm)\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"right\",\"image\":\"\",\"zIndex\":366,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1198\",\"group\":4,\"section\":1,\"objectType\":\"label\",\"left\":736,\"top\":37,\"height\":0,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":367,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1198\"},{\"id\":\"object1200\",\"group\":4,\"section\":1,\"objectType\":\"label\",\"left\":736,\"top\":56,\"height\":0,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":368,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1200\"},{\"id\":\"object1201\",\"group\":4,\"section\":1,\"objectType\":\"label\",\"left\":736,\"top\":80,\"height\":0,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":369,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1201\"}]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":198,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":254,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":198,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":254,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":198,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":254,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":198,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":254,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":198,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":254,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":198,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":254,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]}],\"currentGroup\":0}','2018-08-06 10:57:33','globeadmin','2018-08-06 10:57:33','globeadmin','2018-08-06 10:57:33','globeadmin'),('5bf3263959be988','absence_class_day_table8','Απουσιολόγιο τμήματος όλης της ημέρας 8ωρο','teacher','','552124aeebd01bf','','{\"top\":30,\"left\":30,\"bottom\":661,\"right\":30,\"width\":\"210\",\"height\":\"297\",\"paper\":\"A4\",\"orientation\":\"P\",\"groups\":[{\"sortField\":\"Detail\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":234,\"height\":20,\"label\":\"Detail Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1032\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":46,\"top\":-1,\"height\":\"18\",\"width\":\"760\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"student_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":212,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1032\"},{\"id\":\"object1049\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":392,\"top\":-1,\"height\":\"18\",\"width\":\"100\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"absence_name1\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":224,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1049\"},{\"id\":\"object1051\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":444,\"top\":-1,\"height\":\"18\",\"width\":\"100\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"absence_name2\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":225,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1051\"},{\"id\":\"object1052\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":496,\"top\":-1,\"height\":\"18\",\"width\":\"100\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"absence_name3\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":226,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1052\"},{\"id\":\"object1053\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":548,\"top\":-1,\"height\":\"18\",\"width\":\"100\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"absence_name4\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":227,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1053\"},{\"id\":\"object1054\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":601,\"top\":-1,\"height\":\"18\",\"width\":\"100\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"absence_name5\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":228,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1054\"},{\"id\":\"object1055\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":654,\"top\":-1,\"height\":\"18\",\"width\":\"100\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"absence_name6\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":229,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1055\"},{\"id\":\"object1056\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":706,\"top\":-1,\"height\":\"18\",\"width\":\"50\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"absence_name7\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":230,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1056\"},{\"id\":\"object1084\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":756,\"top\":-1,\"height\":\"18\",\"width\":\"50\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"absence_name8\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":254,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1084\"}]}]},{\"sortField\":\"Report\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":30,\"height\":202,\"label\":\"Report Header\",\"page_break\":\"0\",\"margins\":2,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1007\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":80,\"top\":34,\"height\":15,\"width\":600,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":101,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1007\"},{\"id\":\"object1008\",\"group\":1,\"section\":0,\"objectType\":\"label\",\"left\":28,\"top\":158,\"height\":30,\"width\":785,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Ημερήσιο Δελτίο Φοίτησης\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"14\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":102,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1008\"},{\"id\":\"object1011\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":80,\"top\":53,\"height\":\"15\",\"width\":\"600\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_year_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":104,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1011\"},{\"id\":\"object1014\",\"group\":1,\"section\":0,\"objectType\":\"label\",\"left\":80,\"top\":131,\"height\":18,\"width\":\"250\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Ημερομηνία : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":105,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1014\"},{\"id\":\"object1018\",\"group\":1,\"section\":0,\"objectType\":\"label\",\"left\":80,\"top\":72,\"height\":15,\"width\":500,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Ημερομηνία Εκτύπωσης : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"7\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":\"200\",\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1018\"},{\"id\":\"object1037\",\"group\":1,\"section\":0,\"objectType\":\"label\",\"left\":81,\"top\":107,\"height\":\"18\",\"width\":\"150\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Τμήμα : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":216,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1037\"},{\"id\":\"object1042\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":207,\"top\":131,\"height\":\"18\",\"width\":\"200\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"abs_date\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":221,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1042\"},{\"id\":\"object1044\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":226,\"top\":72,\"height\":\"15\",\"width\":\"200\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"cur_date\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":222,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1044\"},{\"id\":\"object1045\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":207,\"top\":107,\"height\":18,\"width\":200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"class_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":223,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1045\"}]},{\"id\":\"\",\"top\":254,\"height\":377,\"label\":\"Report Footer\",\"page_break\":\"0\",\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1058\",\"group\":1,\"section\":1,\"objectType\":\"label\",\"left\":46,\"top\":16,\"height\":18,\"width\":\"250\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Διδασκαλίες\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":231,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1058\"},{\"id\":\"object1059\",\"group\":1,\"section\":1,\"objectType\":\"field\",\"left\":62,\"top\":42,\"height\":\"18\",\"width\":\"100\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"period_name1\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":232,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1059\"},{\"id\":\"object1060\",\"group\":1,\"section\":1,\"objectType\":\"field\",\"left\":62,\"top\":83,\"height\":\"18\",\"width\":\"100\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"period_name2\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":233,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1060\"},{\"id\":\"object1061\",\"group\":1,\"section\":1,\"objectType\":\"field\",\"left\":62,\"top\":124,\"height\":\"18\",\"width\":\"100\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"period_name3\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":234,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1061\"},{\"id\":\"object1062\",\"group\":1,\"section\":1,\"objectType\":\"field\",\"left\":62,\"top\":166,\"height\":\"18\",\"width\":\"100\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"period_name4\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":235,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1062\"},{\"id\":\"object1063\",\"group\":1,\"section\":1,\"objectType\":\"field\",\"left\":62,\"top\":207,\"height\":\"18\",\"width\":\"100\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"period_name5\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":236,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1063\"},{\"id\":\"object1064\",\"group\":1,\"section\":1,\"objectType\":\"field\",\"left\":62,\"top\":248,\"height\":\"18\",\"width\":\"100\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"period_name6\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":237,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1064\"},{\"id\":\"object1065\",\"group\":1,\"section\":1,\"objectType\":\"field\",\"left\":62,\"top\":290,\"height\":\"18\",\"width\":\"100\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"period_name7\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":238,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1065\"},{\"id\":\"object1067\",\"group\":1,\"section\":1,\"objectType\":\"field\",\"left\":123,\"top\":42,\"height\":\"18\",\"width\":\"1200\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"subject_name1\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":239,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1067\"},{\"id\":\"object1068\",\"group\":1,\"section\":1,\"objectType\":\"field\",\"left\":123,\"top\":83,\"height\":\"18\",\"width\":\"1200\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"subject_name2\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":240,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1068\"},{\"id\":\"object1069\",\"group\":1,\"section\":1,\"objectType\":\"field\",\"left\":123,\"top\":124,\"height\":\"18\",\"width\":\"1200\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"subject_name3\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":241,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1069\"},{\"id\":\"object1070\",\"group\":1,\"section\":1,\"objectType\":\"field\",\"left\":123,\"top\":166,\"height\":\"18\",\"width\":\"1200\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"subject_name4\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":242,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1070\"},{\"id\":\"object1071\",\"group\":1,\"section\":1,\"objectType\":\"field\",\"left\":123,\"top\":207,\"height\":\"18\",\"width\":\"1200\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"subject_name5\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":243,\"minRows\":\"0\",\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1071\"},{\"id\":\"object1072\",\"group\":1,\"section\":1,\"objectType\":\"field\",\"left\":123,\"top\":248,\"height\":\"18\",\"width\":\"1200\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"subject_name6\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":244,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1072\"},{\"id\":\"object1073\",\"group\":1,\"section\":1,\"objectType\":\"field\",\"left\":123,\"top\":290,\"height\":\"18\",\"width\":\"1200\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"subject_name7\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":245,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1073\"},{\"id\":\"object1075\",\"group\":1,\"section\":1,\"objectType\":\"label\",\"left\":46,\"top\":37,\"height\":\"0\",\"width\":\"250\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":246,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1075\"},{\"id\":\"object1076\",\"group\":1,\"section\":1,\"objectType\":\"label\",\"left\":62,\"top\":81,\"height\":\"0\",\"width\":\"760\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":247,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1077\",\"group\":1,\"section\":1,\"objectType\":\"label\",\"left\":62,\"top\":121,\"height\":\"0\",\"width\":\"760\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":248,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1078\",\"group\":1,\"section\":1,\"objectType\":\"label\",\"left\":62,\"top\":165,\"height\":\"0\",\"width\":\"760\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":249,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1079\",\"group\":1,\"section\":1,\"objectType\":\"label\",\"left\":62,\"top\":205,\"height\":\"0\",\"width\":\"760\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":250,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1080\",\"group\":1,\"section\":1,\"objectType\":\"label\",\"left\":62,\"top\":245,\"height\":\"0\",\"width\":\"760\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":251,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1081\",\"group\":1,\"section\":1,\"objectType\":\"label\",\"left\":62,\"top\":288,\"height\":\"0\",\"width\":\"760\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":252,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1082\",\"group\":1,\"section\":1,\"objectType\":\"label\",\"left\":62,\"top\":329,\"height\":\"0\",\"width\":\"760\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":253,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1085\",\"group\":1,\"section\":1,\"objectType\":\"field\",\"left\":62,\"top\":332,\"height\":\"18\",\"width\":\"100\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"period_name8\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":255,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1085\"},{\"id\":\"object1087\",\"group\":1,\"section\":1,\"objectType\":\"field\",\"left\":123,\"top\":332,\"height\":\"18\",\"width\":\"1200\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"subject_name8\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":256,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1087\"}]}]},{\"sortField\":\"Page\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":232,\"height\":2,\"label\":\"Page Header\",\"page_break\":\"0\",\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":254,\"height\":0,\"label\":\"Page Footer\",\"page_break\":\"0\",\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":234,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":254,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":234,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":254,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":234,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":254,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":234,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":254,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":234,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":254,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":234,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":254,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":234,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":254,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":234,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":254,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]}]}],\"currentGroup\":0}','2018-11-19 23:08:09','globeadmin','2018-11-20 19:43:07','globeadmin','2018-11-20 19:43:08','globeadmin'),('5bf3268b46322c6','absence_all_class_day_table8','Όλα τα απουσιολόγια των τμημάτων ενός καθηγητή 8ωρο','teacher','','5539081d564cca6','','{\"top\":30,\"left\":30,\"bottom\":682,\"right\":30,\"width\":\"210\",\"height\":\"297\",\"paper\":\"A4\",\"orientation\":\"P\",\"groups\":[{\"sortField\":\"Detail\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":231,\"height\":19,\"label\":\"Detail Header\",\"page_break\":\"0\",\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1032\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":46,\"top\":-1,\"height\":\"18\",\"width\":\"740\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"student_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":212,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1032\"},{\"id\":\"object1049\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":399,\"top\":-1,\"height\":\"18\",\"width\":\"100\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"absence_name1\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":224,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1049\"},{\"id\":\"object1051\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":451,\"top\":-1,\"height\":\"18\",\"width\":\"100\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"absence_name2\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":225,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1051\"},{\"id\":\"object1052\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":505,\"top\":-1,\"height\":\"18\",\"width\":\"100\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"absence_name3\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":226,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1052\"},{\"id\":\"object1053\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":555,\"top\":-1,\"height\":\"18\",\"width\":\"100\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"absence_name4\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":227,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1053\"},{\"id\":\"object1054\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":608,\"top\":-1,\"height\":\"18\",\"width\":\"100\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"absence_name5\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":228,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1054\"},{\"id\":\"object1055\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":661,\"top\":-1,\"height\":\"18\",\"width\":\"100\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"absence_name6\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":229,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1055\"},{\"id\":\"object1056\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":713,\"top\":-1,\"height\":\"18\",\"width\":\"50\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"absence_name7\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":230,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1056\"},{\"id\":\"object1102\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":763,\"top\":-1,\"height\":\"18\",\"width\":\"50\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"absence_name8\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":266,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1102\"}]}]},{\"sortField\":\"Report\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":30,\"height\":10,\"label\":\"Report Header\",\"page_break\":\"0\",\"margins\":2,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":642,\"height\":10,\"label\":\"Report Footer\",\"page_break\":\"0\",\"margins\":14,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"Page\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":40,\"height\":2,\"label\":\"Page Header\",\"page_break\":\"0\",\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":642,\"height\":0,\"label\":\"Page Footer\",\"page_break\":\"0\",\"margins\":12,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"class_name\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":42,\"height\":0,\"label\":\" Header\",\"page_break\":\"0\",\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":624,\"height\":18,\"label\":\" Footer\",\"page_break\":\"1\",\"margins\":12,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1095\",\"group\":3,\"section\":1,\"objectType\":\"label\",\"left\":58,\"top\":0,\"height\":\"18\",\"width\":\"150\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":264,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1095\"}]}]},{\"sortField\":\"class_id\",\"sortBy\":\"\",\"sections\":[{\"id\":\"\",\"top\":42,\"height\":189,\"label\":\" Header\",\"page_break\":\"0\",\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1037\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":46,\"top\":99,\"height\":18,\"width\":150,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Τμήμα : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":216,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1037\"},{\"id\":\"object1018\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":46,\"top\":64,\"height\":15,\"width\":500,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Ημερομηνία Εκτύπωσης : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"7\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":\"200\",\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1018\"},{\"id\":\"object1014\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":46,\"top\":123,\"height\":18,\"width\":250,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Ημερομηνία : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":105,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1014\"},{\"id\":\"object1011\",\"group\":4,\"section\":0,\"objectType\":\"field\",\"left\":46,\"top\":45,\"height\":15,\"width\":600,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_year_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":104,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1011\"},{\"id\":\"object1008\",\"group\":4,\"section\":0,\"objectType\":\"label\",\"left\":27,\"top\":148,\"height\":30,\"width\":785,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Ημερήσιο Δελτίο Φοίτησης\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"14\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":102,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1008\"},{\"id\":\"object1007\",\"group\":4,\"section\":0,\"objectType\":\"field\",\"left\":46,\"top\":25,\"height\":15,\"width\":600,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":101,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1007\"},{\"id\":\"object1084\",\"group\":4,\"section\":0,\"objectType\":\"field\",\"left\":193,\"top\":64,\"height\":15,\"width\":200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"cur_date\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":254,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1084\"},{\"id\":\"object1085\",\"group\":4,\"section\":0,\"objectType\":\"field\",\"left\":174,\"top\":99,\"height\":18,\"width\":200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"class_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":255,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1085\"},{\"id\":\"object1086\",\"group\":4,\"section\":0,\"objectType\":\"field\",\"left\":174,\"top\":123,\"height\":18,\"width\":200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"abs_date\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":256,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1086\"}]},{\"id\":\"\",\"top\":250,\"height\":374,\"label\":\" Footer\",\"page_break\":\"0\",\"margins\":10,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1081\",\"group\":4,\"section\":1,\"objectType\":\"label\",\"left\":69,\"top\":285,\"height\":0,\"width\":760,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":252,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1080\",\"group\":4,\"section\":1,\"objectType\":\"label\",\"left\":69,\"top\":240,\"height\":0,\"width\":760,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":251,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1079\",\"group\":4,\"section\":1,\"objectType\":\"label\",\"left\":69,\"top\":200,\"height\":0,\"width\":760,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":250,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1078\",\"group\":4,\"section\":1,\"objectType\":\"label\",\"left\":69,\"top\":160,\"height\":0,\"width\":760,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":249,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1077\",\"group\":4,\"section\":1,\"objectType\":\"label\",\"left\":69,\"top\":116,\"height\":0,\"width\":760,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":248,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1076\",\"group\":4,\"section\":1,\"objectType\":\"label\",\"left\":69,\"top\":76,\"height\":0,\"width\":760,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":247,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"\"},{\"id\":\"object1075\",\"group\":4,\"section\":1,\"objectType\":\"label\",\"left\":46,\"top\":32,\"height\":0,\"width\":250,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":246,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1075\"},{\"id\":\"object1065\",\"group\":4,\"section\":1,\"objectType\":\"field\",\"left\":69,\"top\":287,\"height\":18,\"width\":100,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"period_name7\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":238,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1065\"},{\"id\":\"object1064\",\"group\":4,\"section\":1,\"objectType\":\"field\",\"left\":69,\"top\":242,\"height\":18,\"width\":100,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"period_name6\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":237,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1064\"},{\"id\":\"object1063\",\"group\":4,\"section\":1,\"objectType\":\"field\",\"left\":69,\"top\":202,\"height\":18,\"width\":100,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"period_name5\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":236,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1063\"},{\"id\":\"object1062\",\"group\":4,\"section\":1,\"objectType\":\"field\",\"left\":69,\"top\":163,\"height\":18,\"width\":100,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"period_name4\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":235,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1062\"},{\"id\":\"object1061\",\"group\":4,\"section\":1,\"objectType\":\"field\",\"left\":69,\"top\":119,\"height\":18,\"width\":100,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"period_name3\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":234,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1061\"},{\"id\":\"object1060\",\"group\":4,\"section\":1,\"objectType\":\"field\",\"left\":69,\"top\":78,\"height\":18,\"width\":100,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"period_name2\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":233,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1060\"},{\"id\":\"object1059\",\"group\":4,\"section\":1,\"objectType\":\"field\",\"left\":69,\"top\":37,\"height\":18,\"width\":100,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"period_name1\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":232,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1059\"},{\"id\":\"object1058\",\"group\":4,\"section\":1,\"objectType\":\"label\",\"left\":46,\"top\":10,\"height\":18,\"width\":250,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Διδασκαλίες\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":231,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1058\"},{\"id\":\"object1087\",\"group\":4,\"section\":1,\"objectType\":\"field\",\"left\":130,\"top\":37,\"height\":18,\"width\":1200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"subject_name1\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":257,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1087\"},{\"id\":\"object1088\",\"group\":4,\"section\":1,\"objectType\":\"field\",\"left\":130,\"top\":78,\"height\":18,\"width\":1200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"subject_name2\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":258,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1088\"},{\"id\":\"object1089\",\"group\":4,\"section\":1,\"objectType\":\"field\",\"left\":130,\"top\":119,\"height\":18,\"width\":1200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"subject_name3\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":259,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1089\"},{\"id\":\"object1090\",\"group\":4,\"section\":1,\"objectType\":\"field\",\"left\":130,\"top\":163,\"height\":18,\"width\":1200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"subject_name4\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":260,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1090\"},{\"id\":\"object1091\",\"group\":4,\"section\":1,\"objectType\":\"field\",\"left\":130,\"top\":202,\"height\":18,\"width\":1200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"subject_name5\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":261,\"minRows\":\"0\",\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1091\"},{\"id\":\"object1092\",\"group\":4,\"section\":1,\"objectType\":\"field\",\"left\":130,\"top\":242,\"height\":18,\"width\":1200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"subject_name6\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":262,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1092\"},{\"id\":\"object1093\",\"group\":4,\"section\":1,\"objectType\":\"field\",\"left\":130,\"top\":287,\"height\":18,\"width\":1200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"subject_name7\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":263,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1093\"},{\"id\":\"object1100\",\"group\":4,\"section\":1,\"objectType\":\"label\",\"left\":69,\"top\":325,\"height\":0,\"width\":760,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":265,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1100\"},{\"id\":\"object1103\",\"group\":4,\"section\":1,\"objectType\":\"field\",\"left\":69,\"top\":327,\"height\":18,\"width\":100,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"period_name8\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":267,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1103\"},{\"id\":\"object1104\",\"group\":4,\"section\":1,\"objectType\":\"field\",\"left\":130,\"top\":327,\"height\":18,\"width\":\"1200\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"subject_name8\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":268,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1104\"}]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":231,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":250,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":231,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":250,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":231,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":250,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":231,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":250,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":231,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":250,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":231,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":250,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]}],\"currentGroup\":0}','2018-11-19 23:09:31','globeadmin','2018-11-20 16:04:07','globeadmin','2018-11-20 16:04:07','globeadmin'),('5c08d35cb0aa3ac','advisor','Εκτυπώνει τους μαθητές ανά ατομικό σύμβουλο','manager','SELECT\n    school.name as school_name,\n	school_year.name as school_year_name,\n	date_format(curdate(),\'%d-%m-%Y\') as cur_date,\n	concat(grade.short_name,\' - \',student.surname,\' \',student.name,if(student.fathers_name is NULL,\'\',concat(\' πατ. \',student.fathers_name)),\' (ΑΜ:\',student.registration_number,\')\') as student_full_name,\n	concat(ifNULL(teacher.surname,\'\'),if(teacher.surname IS NOT NULL AND teacher.name IS NOT NULL,\' \',\'\'),ifNULL(teacher.name,\'\')) as teacher_full_name,\n	1 as cnt\nFROM student\nINNER JOIN school       ON school.id = 1\nINNER JOIN school_year  ON school_year.id = school.school_year_id\nINNER JOIN teacher      ON teacher.id = student.advisor_id\nINNER JOIN grade        ON grade.id = student.grade_id\nORDER BY teacher_full_name, student_full_name','','','{\"top\":30,\"left\":30,\"bottom\":408,\"right\":30,\"width\":\"210\",\"height\":\"297\",\"paper\":\"A4\",\"orientation\":\"P\",\"groups\":[{\"sortField\":\"Detail\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":289,\"height\":31,\"label\":\"Detail Header\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1042\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":70,\"top\":4,\"height\":\"16\",\"width\":\"1000\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"student_full_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":221,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1042\"},{\"id\":\"object1066\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":65,\"top\":23,\"height\":\"0\",\"width\":\"730\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"14\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":238,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1066\"}]}]},{\"sortField\":\"Report\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":30,\"height\":184,\"label\":\"Report Header\",\"page_break\":\"0\",\"margins\":2,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1007\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":80,\"top\":47,\"height\":15,\"width\":600,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":101,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1007\"},{\"id\":\"object1008\",\"group\":1,\"section\":0,\"objectType\":\"label\",\"left\":28,\"top\":141,\"height\":30,\"width\":785,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Μαθητές ανά Ατομικό Σύμβουλο Καθηγητή\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"12\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":102,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1008\"},{\"id\":\"object1011\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":80,\"top\":65,\"height\":\"15\",\"width\":\"600\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_year_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":104,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1011\"},{\"id\":\"object1018\",\"group\":1,\"section\":0,\"objectType\":\"label\",\"left\":80,\"top\":88,\"height\":15,\"width\":500,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Ημερομηνία Εκτύπωσης : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"7\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":\"200\",\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1018\"},{\"id\":\"object1044\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":226,\"top\":88,\"height\":\"15\",\"width\":\"200\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"cur_date\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":222,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1044\"}]},{\"id\":\"\",\"top\":365,\"height\":13,\"label\":\"Report Footer\",\"page_break\":\"0\",\"margins\":12,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"Page\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":214,\"height\":23,\"label\":\"Page Header\",\"page_break\":\"0\",\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":365,\"height\":0,\"label\":\"Page Footer\",\"page_break\":\"0\",\"margins\":10,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"teacher_full_name\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":237,\"height\":52,\"label\":\" Header\",\"page_break\":\"0\",\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1068\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":50,\"top\":23,\"height\":\"18\",\"width\":\"1000\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"teacher_full_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":239,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1068\"},{\"id\":\"object1063\",\"group\":3,\"section\":0,\"objectType\":\"label\",\"left\":45,\"top\":45,\"height\":\"0\",\"width\":\"750\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"14\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":236,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1063\"}]},{\"id\":\"\",\"top\":320,\"height\":45,\"label\":\" Footer\",\"page_break\":\"0\",\"margins\":10,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1072\",\"group\":3,\"section\":1,\"objectType\":\"label\",\"left\":50,\"top\":6,\"height\":15,\"width\":500,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Αριθμός Μαθητών : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"9\",\"fontWeight\":\"B\",\"format\":\"7\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":242,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1072\"},{\"id\":\"object1071\",\"group\":3,\"section\":1,\"objectType\":\"label\",\"left\":47,\"top\":25,\"height\":\"0\",\"width\":\"750\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"14\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":241,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1071\"},{\"id\":\"object1074\",\"group\":3,\"section\":1,\"objectType\":\"field\",\"left\":204,\"top\":6,\"height\":15,\"width\":200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"SUM(cnt)\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"9\",\"fontWeight\":\"B\",\"format\":\"0\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":243,\"minRows\":0,\"maxRows\":0,\"selected\":1,\"name\":\"object1074\"}]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":289,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":320,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":289,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":320,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":289,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":320,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":289,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":320,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":289,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":320,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":289,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":320,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":289,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":320,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]}],\"currentGroup\":0}','2018-12-06 09:44:28','globeadmin','2018-12-06 17:29:38','globeadmin','2018-12-06 17:29:38','globeadmin'),('5c59f72120ec304','penalty_all','Εκτυπώνει τις ποινές πολλών μαθητή','teacher','SELECT\n	concat(student.surname,\' \',student.name,if(student.fathers_name is NULL,\'\',concat(\' πατ. \',student.fathers_name)),\' (ΑΜ:\',student.registration_number,\')\') as student_full_name,\n	date_format(penalty.date_enforced,\'%d-%m-%Y\') as penalty_date_enforced,\n	penalty.type as penalty_type,\n	penalty.reason as penalty_reason,\n	penalty.carrier as penalty_carrier,\n	school.name as school_name,\n	school_year.name as school_year_name,\n	date_format(curdate(),\'%d-%m-%Y\') as cur_date,\n    if(penalty.carrier = if(penalty.teacher_id IS NULL,\'\',concat(ifNULL(teacher.surname,\'\'),if(teacher.surname IS NOT NULL AND teacher.name IS NOT NULL,\' \',\'\'),ifNULL(teacher.name,\'\'))),\n    penalty.carrier,\n    concat (ifNULL(penalty.carrier,\'\'),if(penalty.carrier IS NOT NULL AND penalty.teacher_id IS NOT NULL, \' / \', \'\'),if(penalty.teacher_id IS NULL,\'\',concat(ifNULL(teacher.surname,\'\'),if(teacher.surname IS NOT NULL AND teacher.name IS NOT NULL,\' \',\'\'),ifNULL(teacher.name,\'\'))))) \n        as names,\n    penalty.student_id as student_id\nFROM penalty\nINNER JOIN student ON  student.id = penalty.student_id\nINNER JOIN school on school.id = 1\nINNER JOIN school_year on school_year.id = school.school_year_id\nLEFT JOIN teacher ON teacher.id = penalty.teacher_id\nWHERE penalty.date_enforced BETWEEN \'2018-09-12\' AND \'2019-01-20\'\nORDER BY student_full_name,penalty.date_enforced','','','{\"top\":30,\"left\":30,\"bottom\":561,\"right\":30,\"width\":\"210\",\"height\":\"297\",\"paper\":\"A4\",\"orientation\":\"P\",\"groups\":[{\"sortField\":\"Detail\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":310,\"height\":55,\"label\":\"Detail Header\",\"page_break\":\"0\",\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1032\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":59,\"top\":24,\"height\":\"18\",\"width\":\"300\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"penalty_date_enforced\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":212,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1032\"},{\"id\":\"object1033\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":147,\"top\":24,\"height\":\"18\",\"width\":\"300\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"penalty_type\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":213,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1033\"},{\"id\":\"object1034\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":266,\"top\":24,\"height\":\"18\",\"width\":\"250\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"names\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":214,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1034\"},{\"id\":\"object1035\",\"group\":0,\"section\":0,\"objectType\":\"field\",\"left\":407,\"top\":24,\"height\":\"18\",\"width\":\"700\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"penalty_reason\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":215,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1035\"},{\"id\":\"object1066\",\"group\":0,\"section\":0,\"objectType\":\"label\",\"left\":44,\"top\":15,\"height\":\"0\",\"width\":\"750\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"14\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":238,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1066\"}]}]},{\"sortField\":\"Report\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":30,\"height\":50,\"label\":\"Report Header\",\"page_break\":\"0\",\"margins\":2,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1076\",\"group\":1,\"section\":0,\"objectType\":\"field\",\"left\":91,\"top\":10,\"height\":\"1\",\"width\":100,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":14,\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":245,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1076\"}]},{\"id\":\"\",\"top\":500,\"height\":31,\"label\":\"Report Footer\",\"page_break\":\"0\",\"margins\":16,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"Page\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":80,\"height\":30,\"label\":\"Page Header\",\"page_break\":\"0\",\"margins\":4,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":455,\"height\":45,\"label\":\"Page Footer\",\"page_break\":\"0\",\"margins\":14,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1078\",\"group\":2,\"section\":1,\"objectType\":\"field\",\"left\":60,\"top\":40,\"height\":\"1\",\"width\":100,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":14,\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":246,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1078\"}]}]},{\"sortField\":\"student_full_name\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":110,\"height\":200,\"label\":\" Header\",\"page_break\":\"0\",\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1058\",\"group\":3,\"section\":0,\"objectType\":\"label\",\"left\":59,\"top\":177,\"height\":18,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Ημερομηνία\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":232,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1058\"},{\"id\":\"object1008\",\"group\":3,\"section\":0,\"objectType\":\"label\",\"left\":28,\"top\":126,\"height\":\"30\",\"width\":\"785\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Επιβληθείσες Ποινές\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"14\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":102,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1008\"},{\"id\":\"object1018\",\"group\":3,\"section\":0,\"objectType\":\"label\",\"left\":80,\"top\":53,\"height\":15,\"width\":500,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Ημερομηνία Εκτύπωσης : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"7\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":\"200\",\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1018\"},{\"id\":\"object1014\",\"group\":3,\"section\":0,\"objectType\":\"label\",\"left\":80,\"top\":84,\"height\":18,\"width\":200,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"Μαθητής : \",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":105,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1014\"},{\"id\":\"object1011\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":80,\"top\":30,\"height\":\"15\",\"width\":\"600\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_year_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":104,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1011\"},{\"id\":\"object1007\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":80,\"top\":11,\"height\":15,\"width\":600,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"school_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":101,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1007\"},{\"id\":\"object1068\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":158,\"top\":84,\"height\":\"18\",\"width\":\"950\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"student_full_name\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"10\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":239,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1068\"},{\"id\":\"object1069\",\"group\":3,\"section\":0,\"objectType\":\"field\",\"left\":221,\"top\":53,\"height\":\"15\",\"width\":\"200\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"cur_date\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":240,\"minRows\":0,\"maxRows\":\"0\",\"selected\":0,\"name\":\"object1069\"},{\"id\":\"object1070\",\"group\":3,\"section\":0,\"objectType\":\"label\",\"left\":149,\"top\":177,\"height\":18,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Τύπος Ποινής\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":241,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1070\"},{\"id\":\"object1071\",\"group\":3,\"section\":0,\"objectType\":\"label\",\"left\":269,\"top\":177,\"height\":18,\"width\":300,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Φορέας Επιβολής / Καθηγητής\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":242,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1071\"},{\"id\":\"object1072\",\"group\":3,\"section\":0,\"objectType\":\"label\",\"left\":416,\"top\":177,\"height\":18,\"width\":\"250\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"0\",\"fieldName\":\"Αιτία\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"8\",\"fontWeight\":\"B\",\"format\":\"21\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":243,\"minRows\":\"0\",\"maxRows\":0,\"selected\":0,\"name\":\"object1072\"}]},{\"id\":\"\",\"top\":410,\"height\":45,\"label\":\" Footer\",\"page_break\":\"1\",\"margins\":12,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1074\",\"group\":3,\"section\":1,\"objectType\":\"field\",\"left\":59,\"top\":20,\"height\":\"1\",\"width\":100,\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":0,\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"Arial\",\"fontSize\":14,\"fontWeight\":\"\",\"format\":\"\",\"textAlign\":\"left\",\"image\":\"\",\"zIndex\":244,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1074\"}]}]},{\"sortField\":\"student_id\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":310,\"height\":0,\"label\":\" Header\",\"page_break\":\"0\",\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":365,\"height\":45,\"label\":\" Footer\",\"page_break\":\"0\",\"margins\":10,\"color\":\"#FFFFFF\",\"objects\":[{\"id\":\"object1063\",\"group\":4,\"section\":1,\"objectType\":\"label\",\"left\":44,\"top\":20,\"height\":\"0\",\"width\":\"750\",\"backgroundColor\":\"white\",\"borderColor\":\"black\",\"borderWidth\":\"1\",\"fieldName\":\"\",\"fontColor\":\"black\",\"fontFamily\":\"DejaVuSans\",\"fontSize\":\"14\",\"fontWeight\":\"B\",\"format\":\"\",\"textAlign\":\"center\",\"image\":\"\",\"zIndex\":236,\"minRows\":0,\"maxRows\":0,\"selected\":0,\"name\":\"object1063\"}]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":310,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":365,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":310,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":365,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":310,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":365,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":310,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":365,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":310,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":365,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]},{\"sortField\":\"\",\"sortBy\":\"a\",\"sections\":[{\"id\":\"\",\"top\":310,\"height\":0,\"label\":\" Header\",\"page_break\":0,\"margins\":6,\"color\":\"#FFFFFF\",\"objects\":[]},{\"id\":\"\",\"top\":365,\"height\":0,\"label\":\" Footer\",\"page_break\":0,\"margins\":8,\"color\":\"#FFFFFF\",\"objects\":[]}]}],\"currentGroup\":0}','2019-02-05 22:50:41','globeadmin','2019-02-06 09:24:59','globeadmin','2019-07-29 23:44:46','globeadmin');
/*!40000 ALTER TABLE `zzzsys_report` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `zzzsys_session`
--

DROP TABLE IF EXISTS `zzzsys_session`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `zzzsys_session` (
  `zzzsys_session_id` varchar(25) NOT NULL DEFAULT '',
  `sss_zzzsys_user_id` varchar(25) DEFAULT NULL,
  `sss_timeout` bigint(20) NOT NULL,
  `zzzsys_session_log_added_at` datetime NOT NULL,
  `zzzsys_session_log_added_by` varchar(25) NOT NULL,
  `zzzsys_session_log_changed_at` datetime NOT NULL,
  `zzzsys_session_log_changed_by` varchar(25) NOT NULL,
  `zzzsys_session_log_viewed_at` datetime NOT NULL,
  `zzzsys_session_log_viewed_by` varchar(25) NOT NULL,
  PRIMARY KEY (`zzzsys_session_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `zzzsys_session`
--

LOCK TABLES `zzzsys_session` WRITE;
/*!40000 ALTER TABLE `zzzsys_session` DISABLE KEYS */;
/*!40000 ALTER TABLE `zzzsys_session` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `zzzsys_setup`
--

DROP TABLE IF EXISTS `zzzsys_setup`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `zzzsys_setup` (
  `zzzsys_setup_id` varchar(25) NOT NULL DEFAULT '',
  `set_title` varchar(100) DEFAULT NULL,
  `set_time_out_minutes` int(11) DEFAULT NULL,
  `set_timezone` varchar(255) DEFAULT NULL,
  `set_smtp_username` varchar(255) DEFAULT NULL,
  `set_smtp_password` varchar(255) DEFAULT NULL,
  `set_smtp_host` varchar(255) DEFAULT NULL,
  `set_smtp_from_address` varchar(255) DEFAULT NULL,
  `set_smtp_from_name` varchar(255) DEFAULT NULL,
  `set_smtp_port` int(4) DEFAULT NULL,
  `set_smtp_use_ssl` char(3) DEFAULT NULL,
  `set_fonts` text NOT NULL,
  `set_language` varchar(20) NOT NULL,
  `set_css` longtext NOT NULL,
  `set_denied` varchar(255) NOT NULL,
  `set_inkfilepicker_key` varchar(500) NOT NULL,
  `zzzsys_setup_log_added_at` datetime NOT NULL,
  `zzzsys_setup_log_added_by` varchar(25) NOT NULL,
  `zzzsys_setup_log_changed_at` datetime NOT NULL,
  `zzzsys_setup_log_changed_by` varchar(25) NOT NULL,
  `zzzsys_setup_log_viewed_at` datetime NOT NULL,
  `zzzsys_setup_log_viewed_by` varchar(25) NOT NULL,
  `set_splash` varchar(1) NOT NULL,
  `set_numb_of_login_attempts` int(11) DEFAULT '8',
  `set_lock_login_minutes` int(11) DEFAULT '30',
  PRIMARY KEY (`zzzsys_setup_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `zzzsys_setup`
--

LOCK TABLES `zzzsys_setup` WRITE;
/*!40000 ALTER TABLE `zzzsys_setup` DISABLE KEYS */;
INSERT INTO `zzzsys_setup` VALUES ('1','NOT USED DELETED THIS FIELD',120,'Europe/Athens','username',NULL,'mail.sch.gr',NULL,NULL,465,'ssl','DejaVuSans\narialGreek','gr','<script>\nfunction nuLoadEditGlobal(){\n	nuOnLoad();\n}\nfunction nuLoadBrowseGlobal(){\n	nuOnLoad();\n}\nfunction nuOnLoad() {                  //-- display a logo\n    if (window.top === window.self) {\n        var logoWidth = 167;\n        var logoLeft  = parseInt($(\'#nuActionButtonHolder\').css(\'width\')) - logoWidth - 5;\n        if (logoLeft > 500) {\n            var im        = document.createElement(\'img\');\n            im.setAttribute(\'id\', \'thislogo\');\n            im.setAttribute(\'src\', \'sisyphos_logo.png\');\n            im.setAttribute(\'onclick\', \'window.open(\\\'http://www.sisyphos.gr\\\', \\\'_blank\\\');\');\n            im.setAttribute(\'onmouseover\', \'this.style.cursor=\"pointer\";\');\n            im.setAttribute(\'onmouseout\', \'this.style.cursor=\"auto\";\');\n            im.setAttribute(\'title\', \'www.sisyphos.gr\');\n            $(\'#nuActionButtonHolder\').append(im);\n            $(\'#\' + im.id).css( \'width\', logoWidth + \'px\');\n            $(\'#\' + im.id).css( \'height\', \'33px\');\n            $(\'#\' + im.id).css( \'left\',  logoLeft  + \'px\');\n            $(\'#\' + im.id).css( \'position\', \'absolute\');\n            $(\'#\' + im.id).css( \'border-style\', \'none\');\n            $(\'#\' + im.id).css( \'z-index\', \'0\');\n            $(\'#\' + im.id).css( \'top\', \'0px\');\n        }\n    } else {\n           if ( !window.parent.document.getElementById(\'nuDrag\') ) {\n               document.body.style.backgroundColor = \'#EDEDED\';\n           }      \n    }\n}\n</script>\n<style>\nb                            {color: #666666;}\na:focus, \na:visited, \na:hover, \na:active                     {outline: thin dotted #333;outline: 5px auto -webkit-focus-ring-color;outline-offset: -2px;color: #666666;text-shadow: 0 1px 1px rgba(255, 255, 255, 0.75);text-decoration: none;}\ntable                        {padding:0px;margin:0px;text-align:center;vertical-align:top;margin-left:auto;margin-right:auto;width:100%;cellspacing:0px;cellpadding:0px}\ntr                           {padding:0px;margin:0px;text-align:top;vertical-align:top;}\ntd                           {padding:0px;margin:0px}\ndiv                          {padding:0px;margin:0px}\nimg                          {padding:0px;margin:0px;}\nselect                       {padding:0px;margin:0px; font-family:\"Helvetica Neue\", Helvetica, Arial, sans-serif;}\ntextarea                     {padding:0px;margin:0px;font-family:\"Helvetica Neue\", Helvetica, Arial, sans-serif;}\niframe                       {border: 0px;margin: 0px;padding: 0px;}\nbody                         {margin: 0;font-family: \"Helvetica Neue\", Helvetica, Arial, sans-serif;font-size: 13px;line-height: 18px;color: #202020;background-color: ##f4f4f4;}\nhtml { \n  background: url(images/bg.png) no-repeat center center fixed; \n  -webkit-background-size: cover;\n  -moz-background-size: cover;\n  -o-background-size: cover;\n  background-size: cover;\n}\n\n.ui-widget                   {font-size: 0.8em;}\n.ui-autocomplete             {max-height: 200px; overflow-y: auto; overflow-x: hidden; }\ninput {\n	padding:0px;\n	margin:0px; \n	font-family:\"Helvetica Neue\", Helvetica, Arial, sans-serif;\n	border: 1px solid #e1e8ea;\n  	outline: none;\n	box-shadow: none;\n	padding: 0px;\n	height:25px;\n}\nselect {\n	padding:0px;\n	margin:0px; \n	font-family:\"Helvetica Neue\", Helvetica, Arial, sans-serif;\n	border: 1px solid #e1e8ea;\n  	outline: none;\n	box-shadow: none;\n	padding: 0px;\n	height: 25px;\n}\ntextarea {\n	padding:0px;\n	margin:0px; \n	font-family:\"Helvetica Neue\", Helvetica, Arial, sans-serif;\n	border: 1px solid #e1e8ea;\n  	outline: none;\n	box-shadow: none;\n	padding: 0px;\n}\n.nuLookup    {\n	background-color: #93C8F9;\n	padding:0px;\n	margin:0px; \n	font-family:\"Helvetica Neue\", Helvetica, Arial, sans-serif;\n	border: 1px solid #e1e8ea;\n  	outline: none;\n	box-shadow: none;\n	padding: 0px;\n}\n.nuReadOnly  {\n	background-color: #ccc2b8;\n	padding:0px;\n	margin:0px; \n	font-family:\"Helvetica Neue\", Helvetica, Arial, sans-serif;\n	border: 1px solid #e1e8ea;\n  	outline: none;\n	box-shadow: none;\n	padding: 0px;\n}\n.nu_browse                   {background-color : #8de2e2}\n.nu_button                   {background-color : #98AFC7}\n.nu_checkbox                 {background-color : #FF6633}\n.nu_display                  {background-color : #C7B097}\n.nu_dropdown                 {background-color : #7bce98}\n.nu_html                     {background-color : #c497a6}\n.nu_iframe                   {background-color : #89C35C}\n.nu_listbox                  {background-color : #caa5f6}\n.nu_lookup                   {background-color : #EDDA74}\n.nu_subform                  {background-color : #fa9b96}\n.nu_text                     {background-color : #cbc287}\n.nu_textarea                 {background-color : #a0a7d6}\n.nu_words                    {background-color : #ffc082}   \n.nuError                     {background-color: #FF8080;}\n.nuHolder                    {position:relative;margin:auto;width:1100px;height:800px}\n.nuFileShadow                {border-bottom-left-radius:0px;border-bottom-right-radius:0px;border-top-right-radius:0px;border-top-left-radius:0px;box-shadow: 1px 1px 1px #888888;position:relative;top:170px;left:100px;margin:auto;width:280px;height:200px;font-size:16px;font-family:\"Helvetica Neue\", Helvetica, Arial, sans-serif;background-color:white}\n.nuShadeHolder               {border-bottom-left-radius:0px;border-bottom-right-radius:0px;border-top-right-radius:0px;border-top-left-radius:0px;box-shadow: 0px 0px 0px #888888;position:absolute;top:70px;left:0px;margin:auto;width:1002px;height:542px}\n.nuDialogHolder              {position:absolute;left:0px;width:1020px;height:700px;border-style:solid;border-width:0px 0px 0px 0px;border-color:grey;-moz-border-radius: 0px;border-radius: 0px;}\n.nuActionButtonHolder        {position:absolute;top:15px;left:0px;width:1100px;text-align:center}\n.nuTabAreaHolder             {position:absolute;top:23px;left:0px;}\n.nuBrowseTabAreaHolder       {position:absolute;top:60px;left:0px;}\n.nuBrowseSearch              {color:red}\n.nuBreadCrumbHolder {\n	position:absolute;\n	left:0px;\n	top:45px;\n	font-family:\"Helvetica Neue\", Helvetica, Arial, sans-serif;\n	color:#f7961c;\n	*zoom: 1;\n	margin-bottom: 0;\n	font-size: 15px;\n	line-height: 18px;\n	text-shadow: 0 1px 1px rgba(255, 255, 255, 0.75);\n	vertical-align: middle;\n	width:100%;\n}\n.nuBreadCrumbSection {\n	font-family:\"Helvetica Neue\", Helvetica, Arial, sans-serif;\n	*zoom: 1;\n	margin-bottom: 2px;\n	font-size: 15px;\n	line-height: 23px;\n	text-shadow: 0 1px 1px rgba(255, 255, 255, 0.75);\n	text-decoration: underline;\n	vertical-align: middle; \n	cursor: pointer;\n}\n.nuBreadCrumbPointer {\n	color: #F7961C;\n	font-family:\"Helvetica Neue\", Helvetica, Arial, sans-serif;\n	*zoom: 1;\n	margin-bottom: 2px;\n	font-size: 15px;\n    line-height: 23px;\n    text-shadow: 0 1px 1px rgba(255, 255, 255, 0.75);\n    vertical-align: middle; \n}\n.nuBreadCrumbSectionEnd {\n    font-family:\"Helvetica Neue\", Helvetica, Arial, sans-serif;\n    color: #F7961C;\n    *zoom: 1;\n    margin-bottom: 2px;\n    font-size: 15px;\n    line-height: 23px;\n    text-shadow: 0 1px 1px rgba(255, 255, 255, 0.75);\n    vertical-align: middle; \n}\n.nuTabTitleHolder {\n	font-family:\"Helvetica Neue\", Helvetica, Arial, sans-serif;\n	font-size:16px;\n	position:absolute;\n	left:0px;\n	top:0px;\n	width:1100px;\n	min-height:18px;\n	-moz-border-top-left-radius:0px;\n	-moz-border-top-right-radius:0px;\n	border-top-left-radius:0px;\n	border-top-right-radius:0px;\n	border-style:solid;\n	border-width:0px;border-color:grey;\n	width:1100px;\n	border-width:0px 0px 0px 0px \n}\n.nuTabTitleHolderL {\n	font-family:\"Helvetica Neue\", \n	Helvetica, Arial, sans-serif;\n	font-size:16px;\n    position:absolute;\n	left:0px;\n	top:0px;\n	width:1100px;\n	min-height:18px;\n	-moz-border-top-left-radius:0px;\n	border-style:solid;\n	border-width:0px; \n	border-color:grey;\n	width:1100px;\n	border-width:0px 0px 0px 0px \n}\n.nuTabTitleHolderR {\n	font-family:\"Helvetica Neue\", Helvetica, Arial, sans-serif;\n	font-size:16px;\n	position:absolute;\n	left:0px;\n	top:0px;\n	width:1100px;\n	min-height:18px;\n	-moz-border-top-right-radius:0px;\n	border-top-right-radius:0px;\n	border-style:solid;\n	border-width:0px; \n	border-color:grey;\n	width:1100px;\n	border-width:0px 0px 0px 0px \n}\n.nuTabTitleHolderC {\n	font-family:\"Helvetica Neue\", Helvetica, Arial, sans-serif;\n	font-size:16px;\n	position:absolute;\n	left:0px;\n	top:0px;\n	width:1100px;\n	border-style:solid;\n	border-width:0px;\n	border-color:grey;\n	width:1100px;\n	border-width:0px 0px 0px 0px\n}\n.nuStatusHolder {\n	position:absolute;\n	top:520px;\n	left:0px;\n	width:1100px;\n	height:20px;\n	font-family:\"Helvetica Neue\", Helvetica, Arial, sans-serif;\n	-moz-border-bottom-left-radius:0px;\n	-moz-border-bottom-right-radius:0px;\n	border-bottom-left-radius:0px;\n	border-bottom-right-radius:0px;\n	font-size:16px;\n	border-style:solid;\n	border-width:0px;\n	border-color:grey;\n}\n.nuTabTitle {\n	*zoom: 1;\n	padding: 4px 10px 4px;\n	margin-bottom: 0;\n	font-size: 13px;\n	line-height: 18px;\n	color: #202020;\n	text-align: center;\n	text-shadow: 0 1px 1px rgba(255, 255, 255, 0.75);\n	vertical-align: middle;\n}\n.nuSearchColumn {\n	*zoom: 1;\n	font-size: 13px;\n	line-height: 18px;\n	text-shadow: 0 1px 1px rgba(255, 255, 255, 0.75);\n	vertical-align: middle;\n\n}\n.nuBrowseCell {\n	*zoom: 1;\n	font-size: 13px;\n	line-height: 18px;\n	color: #202020;\n	text-shadow: 0 1px 1px rgba(255, 255, 255, 0.75);\n	vertical-align: middle;\n	border-style:solid;\n	border-width: 0.082em 0.082em 0.082em 0.082em; \n	border-color: #D3D3D3; \n}\n.nuGradient {\n         background: #ccc2b8;\n/*\n	background: #e0f3fa; \n	background: -moz-linear-gradient(top,  #e0f3fa 0%, #a6daea 23%, #01A6F5 100%); \n	background: -webkit-gradient(linear, left top, left bottom, color-stop(0%,#e0f3fa), color-stop(23%,#a6daea), color-stop(100%,#01A6F5)); \n	background: -webkit-linear-gradient(top,  #e0f3fa 0%,#a6daea 23%,#01A6F5 100%); \n	background: -o-linear-gradient(top,  #e0f3fa 0%,#a6daea 23%,#01A6F5 100%); \n	background: -ms-linear-gradient(top,  #e0f3fa 0%,#a6daea 23%,#01A6F5 100%); \n	background: linear-gradient(to bottom,  #e0f3fa 0%,#a6daea 23%,#01A6F5 100%); \n	filter: progid:DXImageTransform.Microsoft.gradient( startColorstr=\'#e0f3fa\', endColorstr=\'#01A6F5\',GradientType=0 ); \n*/\n}\n.nuTabArea {\n	font-family:\"Helvetica Neue\", Helvetica, Arial, sans-serif;\n	position:absolute;\n	top:0px;\n	left:0px;\n	width:1100px;\n	height:605px;\n	border-style:solid;\n	border-width:0px 0px 0px 0px; \n	border-color:grey;\n	overflow:hidden;\n}\n.nuLoginBox {\n	font-family:\"Helvetica Neue\", Helvetica, Arial, sans-serif;\n	position:absolute;\n	top:0px;\n	left:0px;\n	width:310px;\n	height:300px;\n	/* border-style:solid;\n	border-width: 1px 1px 1px 1px; \n	border-color:grey; */\n	overflow:hidden;\n	background-color:#EDEDED;\n}\n.nuSelectedTab {\n	font-family:\"Helvetica Neue\", Helvetica, Arial, sans-serif;\n	/* background-color:#EDEDED; */\n	background-color: #faf0e6;\n	color: #666666;\n	text-align:center;\n	vertical-align:top;\n	margin-left:auto;\n	margin-right:auto;\n\n}\n.nuUnselectedTab {\n	font-family:\"Helvetica Neue\", Helvetica, Arial, sans-serif;\n	color: #666666;\n	text-shadow: 0 1px 1px rgba(255, 255, 255, 0.75); \n	cursor: pointer;\n}\n.nuGreenUnselectedTab {\n	font-family:\"Helvetica Neue\", Helvetica, Arial, sans-serif;\n	background-color: #4FFF4F;\n	text-shadow: 0 1px 1px rgba(255, 255, 255, 0.75); \n	cursor: pointer;\n}\n.nuYellowUnselectedTab {\n	font-family:\"Helvetica Neue\", Helvetica, Arial, sans-serif;\n	background-color: #FFFE28;\n	text-shadow: 0 1px 1px rgba(255, 255, 255, 0.75); \n	cursor: pointer;\n}\n.nuSearch {\n	font-family:\"Helvetica Neue\", Helvetica, Arial, sans-serif;\n	background-color: #ffd886;\n	padding: 6px 12px;\n    margin-bottom: 0;\n    font-size: 13px;\n    font-weight: normal;\n    line-height: 1.42857143;\n    text-align: left;\n    white-space: nowrap;\n    vertical-align: middle;	\n	color: #666666;\n	border: 1px solid transparent;\n	height:16px;\n}\n.nuSelectedTabTitle {\n	height:22px;\n	-moz-border-top-left-radius:0px;\n	-moz-border-top-right-radius:0px;\n	border-top-left-radius:0px;\n	border-top-right-radius:0px;\n	/* border-style:solid;\n	border-width:1px 1px 0px 1px; */\n	border-color: #01A6F5; \n}\n.nuButtonSent {\n	display: inline-block;\n	*display: inline;\n	/* IE7 inline-block hack */\n	*zoom: 1;\n	/* padding: 4px 10px 4px; */\n	margin-bottom: 0;\n	font-size: 13px;\n	line-height: 18px;\n	text-align: center;\n	text-shadow: 0 1px 1px rgba(255, 255, 255, 0.75);\n	vertical-align: middle;\n	color: #202020;\n	background-color: #ccc2b8;\n	background-image: -moz-linear-gradient(top, #FF4A4A, #FD0000);\n	background-image: -ms-linear-gradient(top, #FF4A4A, #FD0000);\n	background-image: -webkit-gradient(linear, 0 0, 0 100%, from(#FF4A4A), to(#FD0000));\n	background-image: -webkit-linear-gradient(top, #FF4A4A, #FD0000);\n	background-image: -o-linear-gradient(top, #FF4A4A, #FD0000);\n	background-image: linear-gradient(top, #FF4A4A, #FD0000);\n	background-repeat: repeat-x;\n	filter: progid:DXImageTransform.Microsoft.gradient(startColorstr=\'#FF4A4A\', endColorstr=\'#FD0000\', GradientType=0);\n	border-color: #e7e7e7 #e7e7e7 #bfbfbf;\n	border-color: rgba(0, 0, 0, 0.1) rgba(0, 0, 0, 0.1) rgba(0, 0, 0, 0.25);\n	filter: progid:dximagetransform.microsoft.gradient(enabled=false);\n	border: 1px solid #A8A8A8;\n	border-bottom-color: #999999;\n	-webkit-border-radius: 0px;\n	-moz-border-radius: 0px;\n	border-radius: 0px;\n	-webkit-box-shadow: inset 0 1px 0 rgba(255, 255, 255, 0.2), 0 1px 2px rgba(0, 0, 0, 0.05);\n	-moz-box-shadow: inset 0 1px 0 rgba(255, 255, 255, 0.2), 0 1px 2px rgba(0, 0, 0, 0.05);\n	box-shadow: inset 0 1px 0 rgba(255, 255, 255, 0.2), 0 1px 2px rgba(0, 0, 0, 0.05);\n	cursor: pointer;\n	*margin-left: .3em;\n	height: 30px;\n	min-width: 110px;\n}\n.nuClose {\n	display: inline-block;\n	*display: inline;\n	/* IE7 inline-block hack */\n	*zoom: 1;\n	padding: 0px;\n	margin-bottom: 0;\n	font-size: 13px;\n	font-weight: bold;\n	line-height: 18px;\n	text-align: center;\n	vertical-align: middle;\n	color: #f7961c;\n    background-color: transparent;\n	border: 0px solid #f7961c;\n	border-radius: 0px;\n	cursor: pointer;\n}\n.nuClose:hover {\n	background-color: #fde8ce;\n}\n.nuSaveMessageProgress {\n	font-family: \"Helvetica Neue\", Helvetica, Arial, sans-serif;\n	width:100px;\n	height:22px;\n	top:10px;\n	left:0px;\n	color: #202020;\n	position:absolute;\n	font-size: 14px;\n	line-height: 20px;\n	text-align: left;\n	text-shadow: 0 1px 1px rgba(255, 255, 255, 0.75);\n	vertical-align: middle;\n}\n.nuBrowseRowSelected         {background-color: #ffd886;}\n.nuSaveMessage {\n	top:10px;\n	left:0px;\n	position:absolute;\n	/*\n	width:110px;\n	height:20px; \n	opacity:0.7\n	*/\n	display: inline-block;\n    padding: 6px 12px;\n    margin-bottom: 0;\n	font-size: 13px;\n	font-weight: normal;\n	line-height: 1.42857143;\n	text-align: center;\n	white-space: nowrap;\n	vertical-align: middle;\n	cursor: pointer;\n	-webkit-user-select: none;\n     -moz-user-select: none;\n      -ms-user-select: none;\n          user-select: none;\n	background-image: none;\n	border: 1px solid transparent;\n	border-radius: 0px;\n	color: #ffffff;\n	background-color: #abd886;\n	border-color: #abd886;\n}\n.nuNotSaved {\n  display: inline-block;\n  padding: 6px 12px;\n  margin-bottom: 0;\n  font-size: 13px;\n  font-weight: normal;\n  line-height: 1.42857143;\n  text-align: center;\n  white-space: nowrap;\n  vertical-align: middle;\n  cursor: pointer;\n  -webkit-user-select: none;\n     -moz-user-select: none;\n      -ms-user-select: none;\n          user-select: none;\n  background-image: none;\n  border: 1px solid transparent;\n  border-radius: 3px;\n  color: #ffffff;\n  background-color: #ff6969;\n  border-color: #ff6969;\n  height: 30px;\n  min-width: 110px;\n}\n.nuButton {\n  display: inline-block;\n  padding: 6px 12px;\n  margin-bottom: 0;\n  font-size: 13px;\n  font-weight: normal;\n  line-height: 1.42857143;\n  text-align: center;\n  white-space: nowrap;\n  vertical-align: middle;\n  cursor: pointer;\n  -webkit-user-select: none;\n     -moz-user-select: none;\n      -ms-user-select: none;\n          user-select: none;\n  background-image: none;\n  border: 1px solid transparent;\n  border-radius: 3px;\n  \n  color: #ffffff;\n  background-color: #d99b00;\n  border-color: #d99b00;\n  height: 30px;\n  min-width: 110px;\n}\n.nuButton:focus,\n.nuButton:active:focus,\n.nuButton.active:focus {\n  outline: thin dotted;\n  outline: 5px auto -webkit-focus-ring-color;\n  outline-offset: -2px;\n  color: #ffffff;\n  background-color: #d99b00;\n  border-color: #d99b00;\n}\n.nuButton:hover,\n.nuButton:focus {\n    text-decoration: none;\ncolor: #ffffff;\nbackground-color: #bd8700;\nborder-color: #bd8700;\n  \n}\n.nuButton:active,\n.nuButton.active {\n  background-image: none;\n  outline: 0;\n  -webkit-box-shadow: inset 0 3px 5px rgba(0, 0, 0, .125);\n          box-shadow: inset 0 3px 5px rgba(0, 0, 0, .125);\n		  \n  color: #ffffff;\nbackground-color: #bd8700;\nborder-color: #bd8700;\n		  \n}\n.nuButton.disabled {\n  pointer-events: none;\n  cursor: not-allowed;\n  filter: alpha(opacity=65);\n  -webkit-box-shadow: none;\n          box-shadow: none;\n  opacity: .65;\n  \ncolor: #ffffff;\nbackground-color: #bd8700;\nborder-color: #bd8700;\n    \n}\n/*********************** Sisyphos **********************************/\n.mainMenu{\n    display: none;\n    position: absolute;\n	top: 0px;\n	left: 0px;\n    z-index: 4000;\n    padding-top: 10px;\n	padding-bottom: 10px;\n    padding-right: 10px;\n    padding-left: 10px;\n    overflow-x:none;\n	overflow-y: none;\n    font-weight: bold;\n    width: 200px;\n    height: 300px;\n    border-radius: 5px;\n    border: 1px solid #4e687e;\n    background-color:#fdf5e6;\n    box-shadow: 0 2px 2px #3a4e5f; \n	opacity: 0.99;\n}\n.mainMenuItemImage{\n	text-align:center;\n	vertical-align:middle;\n	opacity: 1;\n}\n			\n.mainMenuItemText{\n	text-align:center;\n	line-height: normal;\n	vertical-align:top;\n	font-family: Arial, Helvetica, sans-serif;\n	font-size: 6px;\n	font-weight: bold;\n	color: #666666;\n	opacity: 1;\n}			\n			\n.mainMenuButton {\n	display: inline-block;\n	padding: 0px 0px 0px 0px;\n	margin: 0px 0px 0px 0px;\n	font-size: 14px;\n	text-align: center;\n	vertical-align: middle;\n	cursor: pointer;\n	-webkit-user-select: none;\n	-moz-user-select: none;\n	-ms-user-select: none;\n		user-select: none;\n	background-image: none;\n	border: 1px solid;\n	border-radius: 3px;\n	background-color: transparent;\n	border-color: #F7961C;\n	height: 20px;\n	width: 21px;\n}\n\n.mainMenuButtonText {\n    position: absolute;\n    top: 0;\n    left: 0;\n    right: 0;\n    margin-top: 2px;\n}\n\n\n.mainMenuButton:focus,\n.mainMenuButton:hover{\n	background-color: #fde8ce;\n}\n.mainMenuButton:active,\n.mainMenuButton:active:focus {\n	background-color: #fbd19d;\n}\n			\n.iconHolder {\n	position: absolute;\n    top: 0px;\n    right: 0px;\n	padding: 0px 0px 0px 00px;\n	margin: 5px 0px 0px 0px;\n	font-size: 15px;\n	z-index: 4000;\n	font-weight: bold; \n	text-align: right;\n	vertical-align: middle;\n	line-height: 22px; \n	border: none;\n	-webkit-user-select: none;\n	-moz-user-select: none;\n	-ms-user-select: none;\n		user-select: none;\n	background-image: none;\n	width: 167px;\n}\n			\n.iconItem {\n	cursor: pointer;\n	color : #999999;\n	padding-right: 15px;\n	float: none;\n}\n.iconItem:focus,\n.iconItem:hover{\n	color : #e76200;\n}\n.iconItem:active,\n.iconItem:active:focus {\n	color : red;\n}\n			\n.iconBadgeHolder {\n    display: inline-block; \n    position: relative; \n    float: none;\n    cursor: pointer;\n}\n	\n.iconBadge {\n    background-color: #fa3e3e;\n    border-radius: 50%;\n    color: white;\n    line-height: 7px;\n        \n    padding: 3px 3px;\n    font-size: 9px;\n                \n    position: absolute;\n    top: 0px;\n    right: 11px;\n    text-align: center;\n	vertical-align: middle;\n}\n			\n.playButtonHolder {\n	position: absolute;\n    top: 11px;\n    right: 2px;\n	padding: 0px 0px 0px 00px;\n	margin: 0px 0px 0px 0px;\n	font-size: 12px;\n	z-index: 4000;\n	font-weight: bold; \n	text-align: right;\n	vertical-align: middle;\n	border: none;\n	-webkit-user-select: none;\n	-moz-user-select: none;\n	-ms-user-select: none;\n		user-select: none;\n	background-image: none;\n	height: 18px;\n	width: 70px;\n}\n\n.playButton {\n	cursor: pointer;\n	color : #888888;\n	padding-right: 2px;\n	float: none;\n}\n\n.playButton:focus,\n.playButton:hover{\n	color : #e76200;\n}\n.playButton:active,\n.playButton:active:focus {\n	color : red;\n}\n\n.loaderAreaHolder{\n    position: fixed;\n    top: 0px;\n    left: 0px;\n    \n    padding:0;\n    margin:0;\n    \n    width: 100%;\n    height: 100%;\n    background-color: rgba(235,230,225,0.4);\n    \n    z-index: 10000000;\n}\n\n.loader1 {\n    border: 7px solid #f2c8aa;\n    border-top: 7px solid #e76200;\n    border-bottom: 7px solid #e76200;\n    border-radius: 50%;\n    width: 50px;\n    height: 50px;\n	margin: 0px;\n\n    position: absolute;;\n    top: 250px;\n    left: 50%;    \n    margin-left: -25px;\n    margin-top: -25px;\n    opacity: 0.6;\n    animation: spin_left 1s linear infinite;\n}\n\n.loader2 {\n    border: 0px solid #e76200;\n    border-radius: 50%;\n    width: 36px;\n    height: 36px;\n	\n	text-align: center;\n	vertical-align: middle;\n	line-height: 34px;\n	\n	color: lightYellow;\n	font-family: verdana;\n	font-size:18px;\n	font-weight: 600;\n	\n	background-color: #e76200;;\n \n    position: absolute;;\n    top: 250px;\n    left: 50%;    \n    margin-left: -11px;\n    margin-top: -11px;\n    opacity: 0.30;\n}\n\n@-moz-keyframes spin_left {\n    0% { -moz-transform: rotate(0deg); }\n    100% { -moz-transform: rotate(360deg); }\n}\n@-webkit-keyframes spin_left {\n    0% { -webkit-transform: rotate(0deg); }\n    100% { -webkit-transform: rotate(360deg); }\n}\n@keyframes spin_left {\n    0% {transform:rotate(0deg);}\n    100% {transform:rotate(360deg);}\n}\n\n@-moz-keyframes spin_right {\n    0% { -moz-transform: rotate(3600deg); }\n    100% { -moz-transform: rotate(0deg); }\n}\n@-webkit-keyframes spin_right {\n    0% { -webkit-transform: rotate(360deg); }\n    100% { -webkit-transform: rotate(0deg); }\n}\n@keyframes spin_right {\n    0% {transform:rotate(360deg);}\n    100% {transform:rotate(0deg);}\n}\n\n</style>\n<link rel=\"stylesheet\" href=\"bootstrap/css/bootstrap.css\">\n<link rel=\"shortcut icon\" type=\"image/ico\" href=\"favicon.ico\">\n','nu%','','0000-00-00 00:00:00','','2018-02-11 19:29:40','54737fc85981449','2018-08-29 14:21:20','54737fc85981449','1',8,30),('default','NOT USED DELETED THIS FIELD',120,'Australia/Adelaide','','','','','',0,'','','','<script>\r\nfunction nuLoadEditGlobal(){\r\n	nuOnLoad();\r\n}\r\nfunction nuLoadBrowseGlobal(){\r\n	nuOnLoad();\r\n}\r\nfunction nuOnLoad() {                 //-- display a logo\r\n    if (window.top === window.self) {\r\n        var logoWidth = 167;\r\n        var logoLeft  = parseInt($(\'#nuActionButtonHolder\').css(\'width\')) - logoWidth - 10;\r\n        if (logoLeft > 500) {\r\n            var im        = document.createElement(\'img\');\r\n            im.setAttribute(\'id\', \'thislogo\');\r\n            im.setAttribute(\'src\', \'nuBuilder-Logo-medium.png\');\r\n            $(\'#nuActionButtonHolder\').append(im);\r\n            $(\'#\' + im.id).css( \'width\', logoWidth + \'px\');\r\n            $(\'#\' + im.id).css( \'height\', \'33px\');\r\n            $(\'#\' + im.id).css( \'left\',  logoLeft  + \'px\');\r\n            $(\'#\' + im.id).css( \'position\', \'absolute\');\r\n            $(\'#\' + im.id).css( \'border-style\', \'none\');\r\n            $(\'#\' + im.id).css( \'z-index\', \'0\');\r\n            $(\'#\' + im.id).css( \'top\', \'0px\');\r\n        }\r\n    } else {\r\n           if ( !window.parent.document.getElementById(\'nuDrag\') ) {\r\n               document.body.style.backgroundColor = \'#EDEDED\';\r\n           }      \r\n    }\r\n}\r\n</script>\r\n<style>\r\nb                            {color: #666666;}\r\na:focus, \r\na:visited, \r\na:hover, \r\na:active                     {outline: thin dotted #333;outline: 5px auto -webkit-focus-ring-color;outline-offset: -2px;color: #666666;text-shadow: 0 1px 1px rgba(255, 255, 255, 0.75);text-decoration: none;}\r\ntable                        {padding:0px;margin:0px;text-align:center;vertical-align:top;margin-left:auto;margin-right:auto;width:100%;cellspacing:0px;cellpadding:0px}\r\ntr                           {padding:0px;margin:0px;text-align:top;vertical-align:top;}\r\ntd                           {padding:0px;margin:0px}\r\ndiv                          {padding:0px;margin:0px}\r\nimg                          {padding:0px;margin:0px;}\r\nselect                       {padding:0px;margin:0px; font-family:\"Helvetica Neue\", Helvetica, Arial, sans-serif;}\r\ntextarea                     {padding:0px;margin:0px;font-family:\"Helvetica Neue\", Helvetica, Arial, sans-serif;}\r\niframe                       {border: 0px;margin: 0px;padding: 0px;}\r\nbody                         {margin: 0;font-family: \"Helvetica Neue\", Helvetica, Arial, sans-serif;font-size: 13px;line-height: 18px;color: #202020;background-color: ##f4f4f4;}\r\n.ui-widget                   {font-size: 0.8em;}\r\n.ui-autocomplete             {max-height: 200px; overflow-y: auto; overflow-x: hidden; }\r\ninput {\r\n	padding:0px;\r\n	margin:0px; \r\n	font-family:\"Helvetica Neue\", Helvetica, Arial, sans-serif;\r\n	border: 1px solid #e1e8ea;\r\n  	outline: none;\r\n	box-shadow: none;\r\n	padding: 0px;\r\n}\r\nselect {\r\n	padding:0px;\r\n	margin:0px; \r\n	font-family:\"Helvetica Neue\", Helvetica, Arial, sans-serif;\r\n	border: 1px solid #e1e8ea;\r\n  	outline: none;\r\n	box-shadow: none;\r\n	padding: 0px;\r\n}\r\ntextarea {\r\n	padding:0px;\r\n	margin:0px; \r\n	font-family:\"Helvetica Neue\", Helvetica, Arial, sans-serif;\r\n	border: 1px solid #e1e8ea;\r\n  	outline: none;\r\n	box-shadow: none;\r\n	padding: 0px;\r\n}\r\n.nuLookup    {\r\n	background-color: #93C8F9;\r\n	padding:0px;\r\n	margin:0px; \r\n	font-family:\"Helvetica Neue\", Helvetica, Arial, sans-serif;\r\n	border: 1px solid #e1e8ea;\r\n  	outline: none;\r\n	box-shadow: none;\r\n	padding: 0px;\r\n}\r\n.nuReadOnly  {\r\n	background-color: #CCCCCC;\r\n	padding:0px;\r\n	margin:0px; \r\n	font-family:\"Helvetica Neue\", Helvetica, Arial, sans-serif;\r\n	border: 1px solid #e1e8ea;\r\n  	outline: none;\r\n	box-shadow: none;\r\n	padding: 0px;\r\n}\r\n.nu_browse                   {background-color : #8de2e2}\r\n.nu_button                   {background-color : #98AFC7}\r\n.nu_checkbox                 {background-color : #FF6633}\r\n.nu_display                  {background-color : #C7B097}\r\n.nu_dropdown                 {background-color : #7bce98}\r\n.nu_html                     {background-color : #c497a6}\r\n.nu_iframe                   {background-color : #89C35C}\r\n.nu_listbox                  {background-color : #caa5f6}\r\n.nu_lookup                   {background-color : #EDDA74}\r\n.nu_subform                  {background-color : #fa9b96}\r\n.nu_text                     {background-color : #cbc287}\r\n.nu_textarea                 {background-color : #a0a7d6}\r\n.nu_words                    {background-color : #ffc082}   \r\n.nuError                     {background-color: #FF8080;}\r\n.nuHolder                    {position:relative;margin:auto;width:1100px;height:800px}\r\n.nuFileShadow                {border-bottom-left-radius:0px;border-bottom-right-radius:0px;border-top-right-radius:0px;border-top-left-radius:0px;box-shadow: 1px 1px 1px #888888;position:relative;top:170px;left:100px;margin:auto;width:280px;height:200px;font-size:16px;font-family:\"Helvetica Neue\", Helvetica, Arial, sans-serif;background-color:white}\r\n.nuShadeHolder               {border-bottom-left-radius:0px;border-bottom-right-radius:0px;border-top-right-radius:0px;border-top-left-radius:0px;box-shadow: 0px 0px 0px #888888;position:absolute;top:70px;left:0px;margin:auto;width:1002px;height:542px}\r\n.nuDialogHolder              {position:absolute;left:0px;width:1020px;height:700px;border-style:solid;border-width:0px 0px 0px 0px;border-color:grey;-moz-border-radius: 0px;border-radius: 0px;}\r\n.nuActionButtonHolder        {position:absolute;top:15px;left:0px;width:1100px;text-align:center}\r\n.nuTabAreaHolder             {position:absolute;top:23px;left:0px;}\r\n.nuBrowseTabAreaHolder       {position:absolute;top:60px;left:0px;}\r\n.nuBrowseSearch              {color:red}\r\n.nuBreadCrumbHolder {\r\n	position:absolute;\r\n	left:0px;\r\n	top:45px;\r\n	font-family:\"Helvetica Neue\", Helvetica, Arial, sans-serif;\r\n	color:#f7961c;\r\n	*zoom: 1;\r\n	margin-bottom: 0;\r\n	font-size: 15px;\r\n	line-height: 18px;\r\n	text-shadow: 0 1px 1px rgba(255, 255, 255, 0.75);\r\n	vertical-align: middle \r\n}\r\n.nuBreadCrumbSection {\r\n	font-family:\"Helvetica Neue\", Helvetica, Arial, sans-serif;\r\n	*zoom: 1;\r\n	margin-bottom: 2px;\r\n	font-size: 15px;\r\n	line-height: 23px;\r\n	text-shadow: 0 1px 1px rgba(255, 255, 255, 0.75);\r\n	text-decoration: underline;\r\n	vertical-align: middle; \r\n	cursor: pointer;\r\n}\r\n.nuBreadCrumbPointer {\r\n	color: #F7961C;\r\n	font-family:\"Helvetica Neue\", Helvetica, Arial, sans-serif;\r\n	*zoom: 1;\r\n	margin-bottom: 2px;\r\n	font-size: 15px;\r\n    line-height: 23px;\r\n    text-shadow: 0 1px 1px rgba(255, 255, 255, 0.75);\r\n    vertical-align: middle; \r\n}\r\n.nuBreadCrumbSectionEnd {\r\n    font-family:\"Helvetica Neue\", Helvetica, Arial, sans-serif;\r\n    color: #F7961C;\r\n    *zoom: 1;\r\n    margin-bottom: 2px;\r\n    font-size: 15px;\r\n    line-height: 23px;\r\n    text-shadow: 0 1px 1px rgba(255, 255, 255, 0.75);\r\n    vertical-align: middle; \r\n}\r\n.nuTabTitleHolder {\r\n	font-family:\"Helvetica Neue\", Helvetica, Arial, sans-serif;\r\n	font-size:16px;\r\n	position:absolute;\r\n	left:0px;\r\n	top:0px;\r\n	width:1100px;\r\n	min-height:18px;\r\n	-moz-border-top-left-radius:0px;\r\n	-moz-border-top-right-radius:0px;\r\n	border-top-left-radius:0px;\r\n	border-top-right-radius:0px;\r\n	border-style:solid;\r\n	border-width:0px;border-color:grey;\r\n	width:1100px;\r\n	border-width:0px 0px 0px 0px \r\n}\r\n.nuTabTitleHolderL {\r\n	font-family:\"Helvetica Neue\", \r\n	Helvetica, Arial, sans-serif;\r\n	font-size:16px;\r\n    position:absolute;\r\n	left:0px;\r\n	top:0px;\r\n	width:1100px;\r\n	min-height:18px;\r\n	-moz-border-top-left-radius:0px;\r\n	border-style:solid;\r\n	border-width:0px; \r\n	border-color:grey;\r\n	width:1100px;\r\n	border-width:0px 0px 0px 0px \r\n}\r\n.nuTabTitleHolderR {\r\n	font-family:\"Helvetica Neue\", Helvetica, Arial, sans-serif;\r\n	font-size:16px;\r\n	position:absolute;\r\n	left:0px;\r\n	top:0px;\r\n	width:1100px;\r\n	min-height:18px;\r\n	-moz-border-top-right-radius:0px;\r\n	border-top-right-radius:0px;\r\n	border-style:solid;\r\n	border-width:0px; \r\n	border-color:grey;\r\n	width:1100px;\r\n	border-width:0px 0px 0px 0px \r\n}\r\n.nuTabTitleHolderC {\r\n	font-family:\"Helvetica Neue\", Helvetica, Arial, sans-serif;\r\n	font-size:16px;\r\n	position:absolute;\r\n	left:0px;\r\n	top:0px;\r\n	width:1100px;\r\n	border-style:solid;\r\n	border-width:0px;\r\n	border-color:grey;\r\n	width:1100px;\r\n	border-width:0px 0px 0px 0px\r\n}\r\n.nuStatusHolder {\r\n	position:absolute;\r\n	top:520px;\r\n	left:0px;\r\n	width:1100px;\r\n	height:20px;\r\n	font-family:\"Helvetica Neue\", Helvetica, Arial, sans-serif;\r\n	-moz-border-bottom-left-radius:0px;\r\n	-moz-border-bottom-right-radius:0px;\r\n	border-bottom-left-radius:0px;\r\n	border-bottom-right-radius:0px;\r\n	font-size:16px;\r\n	border-style:solid;\r\n	border-width:0px;\r\n	border-color:grey;\r\n}\r\n.nuTabTitle {\r\n	*zoom: 1;\r\n	padding: 4px 10px 4px;\r\n	margin-bottom: 0;\r\n	font-size: 13px;\r\n	line-height: 18px;\r\n	color: #202020;\r\n	text-align: center;\r\n	text-shadow: 0 1px 1px rgba(255, 255, 255, 0.75);\r\n	vertical-align: middle;\r\n}\r\n.nuSearchColumn {\r\n	*zoom: 1;\r\n	font-size: 13px;\r\n	line-height: 18px;\r\n	text-shadow: 0 1px 1px rgba(255, 255, 255, 0.75);\r\n	vertical-align: middle;\r\n\r\n}\r\n.nuBrowseCell {\r\n	*zoom: 1;\r\n	font-size: 13px;\r\n	line-height: 18px;\r\n	color: #202020;\r\n	text-shadow: 0 1px 1px rgba(255, 255, 255, 0.75);\r\n	vertical-align: middle;\r\n	border-style:solid;\r\n	border-width: 0.082em 0.082em 0.082em 0.082em; \r\n	border-color: #D3D3D3; \r\n}\r\n.nuGradient {\r\n         background: #CCCCCC;\r\n/*\r\n	background: #e0f3fa; \r\n	background: -moz-linear-gradient(top,  #e0f3fa 0%, #a6daea 23%, #01A6F5 100%); \r\n	background: -webkit-gradient(linear, left top, left bottom, color-stop(0%,#e0f3fa), color-stop(23%,#a6daea), color-stop(100%,#01A6F5)); \r\n	background: -webkit-linear-gradient(top,  #e0f3fa 0%,#a6daea 23%,#01A6F5 100%); \r\n	background: -o-linear-gradient(top,  #e0f3fa 0%,#a6daea 23%,#01A6F5 100%); \r\n	background: -ms-linear-gradient(top,  #e0f3fa 0%,#a6daea 23%,#01A6F5 100%); \r\n	background: linear-gradient(to bottom,  #e0f3fa 0%,#a6daea 23%,#01A6F5 100%); \r\n	filter: progid:DXImageTransform.Microsoft.gradient( startColorstr=\'#e0f3fa\', endColorstr=\'#01A6F5\',GradientType=0 ); \r\n*/\r\n}\r\n.nuTabArea {\r\n	font-family:\"Helvetica Neue\", Helvetica, Arial, sans-serif;\r\n	position:absolute;\r\n	top:0px;\r\n	left:0px;\r\n	width:1100px;\r\n	height:605px;\r\n	border-style:solid;\r\n	border-width:0px 0px 0px 0px; \r\n	border-color:grey;\r\n	overflow:hidden;\r\n}\r\n.nuLoginBox {\r\n	font-family:\"Helvetica Neue\", Helvetica, Arial, sans-serif;\r\n	position:absolute;\r\n	top:0px;\r\n	left:0px;\r\n	width:310px;\r\n	height:300px;\r\n	/* border-style:solid;\r\n	border-width: 1px 1px 1px 1px; \r\n	border-color:grey; */\r\n	overflow:hidden;\r\n	background-color:#EDEDED;\r\n}\r\n.nuSelectedTab {\r\n	font-family:\"Helvetica Neue\", Helvetica, Arial, sans-serif;\r\n	/* background-color:#EDEDED; */\r\n	background-color: #f0f0f0;\r\n	color: #666666;\r\n	text-align:center;\r\n	vertical-align:top;\r\n	margin-left:auto;\r\n	margin-right:auto;\r\n\r\n}\r\n.nuUnselectedTab {\r\n	font-family:\"Helvetica Neue\", Helvetica, Arial, sans-serif;\r\n	color: #666666;\r\n	text-shadow: 0 1px 1px rgba(255, 255, 255, 0.75); \r\n	cursor: pointer;\r\n}\r\n.nuGreenUnselectedTab {\r\n	font-family:\"Helvetica Neue\", Helvetica, Arial, sans-serif;\r\n	background-color: #4FFF4F;\r\n	text-shadow: 0 1px 1px rgba(255, 255, 255, 0.75); \r\n	cursor: pointer;\r\n}\r\n.nuYellowUnselectedTab {\r\n	font-family:\"Helvetica Neue\", Helvetica, Arial, sans-serif;\r\n	background-color: #FFFE28;\r\n	text-shadow: 0 1px 1px rgba(255, 255, 255, 0.75); \r\n	cursor: pointer;\r\n}\r\n.nuSearch {\r\n	font-family:\"Helvetica Neue\", Helvetica, Arial, sans-serif;\r\n	background-color: #abd886;\r\n	padding: 6px 12px;\r\n    margin-bottom: 0;\r\n    font-size: 13px;\r\n    font-weight: normal;\r\n    line-height: 1.42857143;\r\n    text-align: left;\r\n    white-space: nowrap;\r\n    vertical-align: middle;	\r\n	color: #666666;\r\n	border: 1px solid transparent;\r\n}\r\n.nuSelectedTabTitle {\r\n	height:22px;\r\n	-moz-border-top-left-radius:0px;\r\n	-moz-border-top-right-radius:0px;\r\n	border-top-left-radius:0px;\r\n	border-top-right-radius:0px;\r\n	/* border-style:solid;\r\n	border-width:1px 1px 0px 1px; */\r\n	border-color: #01A6F5; \r\n}\r\n.nuButtonSent {\r\n	display: inline-block;\r\n	*display: inline;\r\n	/* IE7 inline-block hack */\r\n	*zoom: 1;\r\n	/* padding: 4px 10px 4px; */\r\n	margin-bottom: 0;\r\n	font-size: 13px;\r\n	line-height: 18px;\r\n	text-align: center;\r\n	text-shadow: 0 1px 1px rgba(255, 255, 255, 0.75);\r\n	vertical-align: middle;\r\n	color: #202020;\r\n	background-color: #CCCCCC;\r\n	background-image: -moz-linear-gradient(top, #FF4A4A, #FD0000);\r\n	background-image: -ms-linear-gradient(top, #FF4A4A, #FD0000);\r\n	background-image: -webkit-gradient(linear, 0 0, 0 100%, from(#FF4A4A), to(#FD0000));\r\n	background-image: -webkit-linear-gradient(top, #FF4A4A, #FD0000);\r\n	background-image: -o-linear-gradient(top, #FF4A4A, #FD0000);\r\n	background-image: linear-gradient(top, #FF4A4A, #FD0000);\r\n	background-repeat: repeat-x;\r\n	filter: progid:DXImageTransform.Microsoft.gradient(startColorstr=\'#FF4A4A\', endColorstr=\'#FD0000\', GradientType=0);\r\n	border-color: #e7e7e7 #e7e7e7 #bfbfbf;\r\n	border-color: rgba(0, 0, 0, 0.1) rgba(0, 0, 0, 0.1) rgba(0, 0, 0, 0.25);\r\n	filter: progid:dximagetransform.microsoft.gradient(enabled=false);\r\n	border: 1px solid #A8A8A8;\r\n	border-bottom-color: #999999;\r\n	-webkit-border-radius: 0px;\r\n	-moz-border-radius: 0px;\r\n	border-radius: 0px;\r\n	-webkit-box-shadow: inset 0 1px 0 rgba(255, 255, 255, 0.2), 0 1px 2px rgba(0, 0, 0, 0.05);\r\n	-moz-box-shadow: inset 0 1px 0 rgba(255, 255, 255, 0.2), 0 1px 2px rgba(0, 0, 0, 0.05);\r\n	box-shadow: inset 0 1px 0 rgba(255, 255, 255, 0.2), 0 1px 2px rgba(0, 0, 0, 0.05);\r\n	cursor: pointer;\r\n	*margin-left: .3em;\r\n}\r\n.nuClose {\r\n	display: inline-block;\r\n	*display: inline;\r\n	/* IE7 inline-block hack */\r\n	*zoom: 1;\r\n	padding: 0px;\r\n	margin-bottom: 0;\r\n	font-size: 13px;\r\n	font-weight: bold;\r\n	line-height: 18px;\r\n	text-align: center;\r\n	text-shadow: 0 2px 2px rgba(255, 255, 255, 0.75);\r\n	vertical-align: middle;\r\n	color: #01A6F5;\r\n	background-color: #B9CACE;\r\n	background-image: -moz-linear-gradient(top, #E7E7E7, #B9CACE);\r\n	background-image: -ms-linear-gradient(top, #E7E7E7, #B9CACE);\r\n	background-image: -webkit-gradient(linear, 0 0, 0 100%, from(#E7E7E7), to(#B9CACE));\r\n	background-image: -webkit-linear-gradient(top, #E7E7E7, #B9CACE);\r\n	background-image: -o-linear-gradient(top, #E7E7E7, #B9CACE);\r\n	background-image: linear-gradient(top, #E7E7E7, #B9CACE);\r\n	background-repeat: repeat-x;\r\n	filter: progid:DXImageTransform.Microsoft.gradient(startColorstr=\'#E7E7E7\', endColorstr=\'#B9CACE\', GradientType=0);\r\n	border-color: #e7e7e7 #e7e7e7 #bfbfbf;\r\n	border-color: rgba(0, 0, 0, 0.1) rgba(0, 0, 0, 0.1) rgba(0, 0, 0, 0.25);\r\n	filter: progid:dximagetransform.microsoft.gradient(enabled=false);\r\n	border: 1px solid #A8A8A8;\r\n	border-bottom-color: #999999;\r\n	-webkit-border-radius: 0px;\r\n	-moz-border-radius: 0px;\r\n	border-radius: 0px;\r\n	-webkit-box-shadow: inset 0 1px 0 rgba(255, 255, 255, 0.2), 0 1px 2px rgba(0, 0, 0, 0.05);\r\n	-moz-box-shadow: inset 0 1px 0 rgba(255, 255, 255, 0.2), 0 1px 2px rgba(0, 0, 0, 0.05);\r\n	box-shadow: inset 0 1px 0 rgba(255, 255, 255, 0.2), 0 1px 2px rgba(0, 0, 0, 0.05);\r\n	cursor: pointer;\r\n}\r\n.nuClose:hover {\r\n	font-weight: normal;\r\n	color: #202020;\r\n	background-color: #e9f3fa;\r\n	background-image: -moz-linear-gradient(top, #a6daea, #01A6F5);\r\n	background-image: -ms-linear-gradient(top, #a6daea, #01A6F5);\r\n	background-image: -webkit-gradient(linear, 0 0, 0 100%, from(#a6daea), to(#01A6F5));\r\n	background-image: -webkit-linear-gradient(top, #a6daea, #01A6F5);\r\n	background-image: -o-linear-gradient(top, #a6daea, #01A6F5);\r\n	background-image: linear-gradient(top, #a6daea, #01A6F5);\r\n	background-repeat: repeat-x;\r\n	filter: progid:dximagetransform.microsoft.gradient(enabled=false);\r\n	border: 1px solid #A8A8A8;\r\n	border-bottom-color: #999999;\r\n}\r\n.nuSaveMessageProgress {\r\n	font-family: \"Helvetica Neue\", Helvetica, Arial, sans-serif;\r\n	width:100px;\r\n	height:22px;\r\n	top:10px;\r\n	left:0px;\r\n	color: #202020;\r\n	position:absolute;\r\n	font-size: 14px;\r\n	line-height: 20px;\r\n	text-align: left;\r\n	text-shadow: 0 1px 1px rgba(255, 255, 255, 0.75);\r\n	vertical-align: middle;\r\n}\r\n.nuBrowseRowSelected         {background-color: #93C8F9;}\r\n.nuSaveMessage {\r\n	top:10px;\r\n	left:0px;\r\n	position:absolute;\r\n	/*\r\n	width:110px;\r\n	height:20px; \r\n	opacity:0.7\r\n	*/\r\n	display: inline-block;\r\n    padding: 6px 12px;\r\n    margin-bottom: 0;\r\n	font-size: 13px;\r\n	font-weight: normal;\r\n	line-height: 1.42857143;\r\n	text-align: center;\r\n	white-space: nowrap;\r\n	vertical-align: middle;\r\n	cursor: pointer;\r\n	-webkit-user-select: none;\r\n     -moz-user-select: none;\r\n      -ms-user-select: none;\r\n          user-select: none;\r\n	background-image: none;\r\n	border: 1px solid transparent;\r\n	border-radius: 0px;\r\n	color: #ffffff;\r\n	background-color: #abd886;\r\n	border-color: #abd886;\r\n}\r\n.nuNotSaved {\r\n  display: inline-block;\r\n  padding: 6px 12px;\r\n  margin-bottom: 0;\r\n  font-size: 13px;\r\n  font-weight: normal;\r\n  line-height: 1.42857143;\r\n  text-align: center;\r\n  white-space: nowrap;\r\n  vertical-align: middle;\r\n  cursor: pointer;\r\n  -webkit-user-select: none;\r\n     -moz-user-select: none;\r\n      -ms-user-select: none;\r\n          user-select: none;\r\n  background-image: none;\r\n  border: 1px solid transparent;\r\n  border-radius: 0px;\r\n  color: #ffffff;\r\n  background-color: #ff6969;\r\n  border-color: #ff6969;\r\n}\r\n.nuButton {\r\n  display: inline-block;\r\n  padding: 6px 12px;\r\n  margin-bottom: 0;\r\n  font-size: 13px;\r\n  font-weight: normal;\r\n  line-height: 1.42857143;\r\n  text-align: center;\r\n  white-space: nowrap;\r\n  vertical-align: middle;\r\n  cursor: pointer;\r\n  -webkit-user-select: none;\r\n     -moz-user-select: none;\r\n      -ms-user-select: none;\r\n          user-select: none;\r\n  background-image: none;\r\n  border: 1px solid transparent;\r\n  border-radius: 0px;\r\n  \r\n  color: #ffffff;\r\n  background-color: #5bcaf5;\r\n  border-color: #5bcaf5;\r\n  \r\n}\r\n.nuButton:focus,\r\n.nuButton:active:focus,\r\n.nuButton.active:focus {\r\n  outline: thin dotted;\r\n  outline: 5px auto -webkit-focus-ring-color;\r\n  outline-offset: -2px;\r\n  color: #ffffff;\r\n  background-color: #00adef;\r\n  border-color: #00adef;\r\n}\r\n.nuButton:hover,\r\n.nuButton:focus {\r\n    text-decoration: none;\r\ncolor: #ffffff;\r\nbackground-color: #00adef;\r\nborder-color: #00adef;\r\n  \r\n}\r\n.nuButton:active,\r\n.nuButton.active {\r\n  background-image: none;\r\n  outline: 0;\r\n  -webkit-box-shadow: inset 0 3px 5px rgba(0, 0, 0, .125);\r\n          box-shadow: inset 0 3px 5px rgba(0, 0, 0, .125);\r\n		  \r\n  color: #ffffff;\r\nbackground-color: #00adef;\r\nborder-color: #00adef;\r\n		  \r\n}\r\n.nuButton.disabled {\r\n  pointer-events: none;\r\n  cursor: not-allowed;\r\n  filter: alpha(opacity=65);\r\n  -webkit-box-shadow: none;\r\n          box-shadow: none;\r\n  opacity: .65;\r\n  \r\ncolor: #ffffff;\r\nbackground-color: #00adef;\r\nborder-color: #00adef;\r\n    \r\n}\r\n</style>','nu%','','0000-00-00 00:00:00','','2013-09-24 10:21:59','globeadmin','2013-09-24 10:21:59','globeadmin','1',8,30);
/*!40000 ALTER TABLE `zzzsys_setup` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `zzzsys_timezone`
--

DROP TABLE IF EXISTS `zzzsys_timezone`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `zzzsys_timezone` (
  `zzzsys_timezone_id` varchar(25) NOT NULL,
  `stz_timezone` mediumtext NOT NULL,
  PRIMARY KEY (`zzzsys_timezone_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `zzzsys_timezone`
--

LOCK TABLES `zzzsys_timezone` WRITE;
/*!40000 ALTER TABLE `zzzsys_timezone` DISABLE KEYS */;
INSERT INTO `zzzsys_timezone` VALUES ('52819fd26198388','Africa/Ouagadougou'),('52819fcb5e82cb2','Africa/Mbabane'),('52819fd0608eabc','Africa/Niamey'),('52819fd36cef7d3','Africa/Porto-Novo'),('52819fd160f38e7','Africa/Nouakchott'),('52819fce5fbef7c','Africa/Nairobi'),('52819fd56e465c5','Africa/Timbuktu'),('52819fd76f1d1cf','Africa/Tunis'),('52819fcf6025798','Africa/Ndjamena'),('52819fd66eb1b1d','Africa/Tripoli'),('52819fd86f894da','Africa/Windhoek'),('52819fd46d5db96','Africa/Sao_Tome'),('52819fda705d5db','America/Anchorage'),('52819fdf727d3b7','America/Argentina/Catamarca'),('52819fdc713665a','America/Antigua'),('52819fd96ff36de','America/Adak'),('52819fdb70ca47b','America/Anguilla'),('52819fe072e958b','America/Argentina/ComodRivadavia'),('52819fde7211b94','America/Argentina/Buenos_Aires'),('52819fdd71a44c6','America/Araguaina'),('52819fe274021b6','America/Argentina/Jujuy'),('52819fe474f1b3c','America/Argentina/Mendoza'),('52819fe17352bc1','America/Argentina/Cordoba'),('52819fe37477a3e','America/Argentina/La_Rioja'),('52819fe97747d84','America/Argentina/Tucuman'),('52819fe675e3a45','America/Argentina/Salta'),('52819fe5756aca9','America/Argentina/Rio_Gallegos'),('52819fe7765b813','America/Argentina/San_Juan'),('52819fe876d4888','America/Argentina/San_Luis'),('52819fea77c0dbe','America/Argentina/Ushuaia'),('52819fed7926984','America/Atikokan'),('52819feb783abf9','America/Aruba'),('52819fec78b6d98','America/Asuncion'),('52819ff2890b040','America/Belem'),('52819fee799c9bd','America/Atka'),('52819ff087e6620','America/Bahia_Banderas'),('52819fef7a0e5c7','America/Bahia'),('52819ff18856b00','America/Barbados'),('52819ff58a5b604','America/Boa_Vista'),('52819ff68acf15d','America/Bogota'),('52819ff3897c302','America/Belize'),('52819ff489eb768','America/Blanc-Sablon'),('52819ff98c31a7c','America/Cambridge_Bay'),('52819ff88bbf287','America/Buenos_Aires'),('52819ff78b49038','America/Boise'),('52819ffd8e40c54','America/Catamarca'),('52819ffe8ebf7a8','America/Cayenne'),('52819ffa8c9fd3d','America/Campo_Grande'),('52819ffc8d8294c','America/Caracas'),('52819ffb8d0e9f3','America/Cancun'),('52819fff8f3deef','America/Cayman'),('5281a001902eacc','America/Chihuahua'),('5281a0008fb91da','America/Chicago'),('5281a0039121eb5','America/Cordoba'),('5281a007935bea0','America/Curacao'),('5281a00491d04fe','America/Costa_Rica'),('5281a00592545ff','America/Creston'),('5281a00692d3646','America/Cuiaba'),('5281a00893dac77','America/Danmarkshavn'),('5281a00290a5cdf','America/Coral_Harbour'),('5281a00994592a4','America/Dawson'),('5281a00a94e4d56','America/Dawson_Creek'),('5281a00d9672fc4','America/Dominica'),('5281a00b956da59','America/Denver'),('5281a00e96f1a71','America/Edmonton'),('5281a00f976ef28','America/Eirunepe'),('5281a01298eb04c','America/Fort_Wayne'),('5281a011986a4c9','America/Ensenada'),('5281a00c95f4f78','America/Detroit'),('5281a01097ec36c','America/El_Salvador'),('5281a013996e3cc','America/Fortaleza'),('5281a01499ee0d7','America/Glace_Bay'),('5281a0159a6738f','America/Godthab'),('5281a0169ae60fb','America/Goose_Bay'),('5281a01b9d64472','America/Guayaquil'),('5281a021a68ad1b','America/Indiana/Knox'),('5281a01c9de431f','America/Guyana'),('5281a0189be3e29','America/Grenada'),('5281a0199c6344a','America/Guadeloupe'),('5281a0179b64421','America/Grand_Turk'),('5281a01a9ce3844','America/Guatemala'),('5281a01e9ee5729','America/Havana'),('5281a022a70ab7e','America/Indiana/Marengo'),('5281a01d9e64a89','America/Halifax'),('5281a01fa582b0b','America/Hermosillo'),('5281a020a60c1cb','America/Indiana/Indianapolis'),('5281a026b7bd32b','America/Indiana/Vincennes'),('5281a024b6c65d2','America/Indiana/Tell_City'),('5281a02ab9a5642','America/Iqaluit'),('5281a025b743617','America/Indiana/Vevay'),('5281a029b92b8a4','America/Inuvik'),('5281a023a78a9f8','America/Indiana/Petersburg'),('5281a02bba2319a','America/Jamaica'),('5281a027b83c7b7','America/Indiana/Winamac'),('5281a02dc3d9b4a','America/Juneau'),('5281a02ec4b4b08','America/Kentucky/Louisville'),('5281a028b8b5382','America/Indianapolis'),('5281a02cc3580ca','America/Jujuy'),('5281a030c5f7f87','America/Knox_IN'),('5281a037c95acd2','America/Maceio'),('5281a035c860612','America/Louisville'),('5281a033c7667a3','America/Lima'),('5281a02fc57ddcd','America/Kentucky/Monticello'),('5281a034c7e4ccf','America/Los_Angeles'),('5281a031c67163d','America/Kralendijk'),('5281a039ca5fd3d','America/Manaus'),('5281a032c6ecabc','America/La_Paz'),('5281a038c9dae4d','America/Managua'),('5281a036c8dfceb','America/Lower_Princes'),('5281a03ad4029d7','America/Marigot'),('5281a03bd4800a8','America/Martinique'),('5281a03dd56f298','America/Mazatlan'),('5281a03cd4f8d9d','America/Matamoros'),('5281a03ed5eb8a2','America/Mendoza'),('5281a03fd6686ad','America/Menominee'),('5281a043d874e50','America/Miquelon'),('5281a040d6e2a6f','America/Merida'),('5281a044d8f40df','America/Moncton'),('5281a041d776ec4','America/Metlakatla'),('5281a046d9eebc9','America/Montevideo'),('5281a04adbebf83','America/New_York'),('5281a048daec32f','America/Montserrat'),('5281a045d96f56b','America/Monterrey'),('5281a047da6f51b','America/Montreal'),('5281a042d7f6261','America/Mexico_City'),('5281a049db6c822','America/Nassau'),('5281a050e5ec3bf','America/North_Dakota/New_Salem'),('5281a04ce3791ab','America/Nome'),('5281a04fe56a837','America/North_Dakota/Center'),('5281a04ee4e9d8a','America/North_Dakota/Beulah'),('5281a04be29de22','America/Nipigon'),('5281a051e66c226','America/Ojinaga'),('5281a04de4621e6','America/Noronha'),('5281a059011444a','America/Porto_Acre'),('5281a058008a8ad','America/Port_of_Spain'),('5281a052e6eb6b1','America/Panama'),('5281a055e87432b','America/Phoenix'),('5281a056f3e39a9','America/Port-au-Prince'),('5281a054e7f5d06','America/Paramaribo'),('5281a053e771ebf','America/Pangnirtung'),('5281a05a019da2e','America/Porto_Velho'),('5281a05b02270ec','America/Puerto_Rico'),('5281a05d0abd421','America/Rankin_Inlet'),('5281a05c02b2d2e','America/Rainy_River'),('5281a05f0ba9fac','America/Regina'),('5281a05e0b23bbb','America/Recife'),('5281a0610cf1e16','America/Rio_Branco'),('5281a0600c2a582','America/Resolute'),('5281a0630df269f','America/Santa_Isabel'),('5281a06c18cefca','America/St_Johns'),('5281a0660f81e90','America/Santo_Domingo'),('5281a0650f00b2b','America/Santiago'),('5281a0620d6e73e','America/Rosario'),('5281a0640e7c243','America/Santarem'),('5281a0671001fe9','America/Sao_Paulo'),('5281a06a17c07af','America/Sitka'),('5281a06b184793e','America/St_Barthelemy'),('5281a0711bdc9cb','America/Swift_Current'),('5281a0691738a17','America/Shiprock'),('5281a06816b015a','America/Scoresbysund'),('5281a06e19dcad8','America/St_Lucia'),('5281a0731cfe848','America/Thule'),('5281a06d195ad37','America/St_Kitts'),('5281a06f1ab84cc','America/St_Thomas'),('5281a0761efa34f','America/Toronto'),('5281a0721c6d284','America/Tegucigalpa'),('5281a0751e22f0d','America/Tijuana'),('5281a0701b4895b','America/St_Vincent'),('5281a0771f90738','America/Tortola'),('5281a0782119266','America/Vancouver'),('5281a07c2387969','America/Yakutat'),('5281a07b22f5dc0','America/Winnipeg'),('5281a07f253cc33','Antarctica/Davis'),('5281a07921a60bc','America/Virgin'),('5281a0741d90667','America/Thunder_Bay'),('5281a07a2262248','America/Whitehorse'),('5281a07d24138e6','America/Yellowknife'),('5281a08126af775','Antarctica/Macquarie'),('5281a07e24a3926','Antarctica/Casey'),('5281a082274083d','Antarctica/Mawson'),('5281a0832b865db','Antarctica/McMurdo'),('5281a080261a293','Antarctica/DumontDUrville'),('5281a0892ef8f3e','Arctic/Longyearbyen'),('5281a08b392c116','Asia/Almaty'),('5281a0862d3c98a','Antarctica/South_Pole'),('5281a0842c1a6a4','Antarctica/Palmer'),('5281a0852cac95d','Antarctica/Rothera'),('5281a0882e5a3db','Antarctica/Vostok'),('5281a08a2f8c58e','Asia/Aden'),('5281a08e3afe663','Asia/Aqtau'),('5281a0903c1eb18','Asia/Ashgabat'),('5281a0872dca2fd','Antarctica/Syowa'),('5281a0923d493e0','Asia/Baghdad'),('5281a08f3b8ffbf','Asia/Aqtobe'),('5281a0913cad956','Asia/Ashkhabad'),('5281a09a421c122','Asia/Choibalsan'),('5281a0933db361c','Asia/Bahrain'),('5281a09840eba22','Asia/Brunei'),('5281a08c39bfc99','Asia/Amman'),('5281a08d3a9af97','Asia/Anadyr'),('5281a0953ee5155','Asia/Bangkok'),('5281a0943e4d693','Asia/Baku'),('5281a09740551ac','Asia/Bishkek'),('5281a0994183708','Asia/Calcutta'),('5281a09b42b4a59','Asia/Chongqing'),('5281a09d5004cfc','Asia/Colombo'),('5281a09f5139227','Asia/Damascus'),('5281a0a15264929','Asia/Dili'),('5281a09c434d7a2','Asia/Chungking'),('5281a0963f77c2f','Asia/Beirut'),('5281a0a25931d48','Asia/Dubai'),('5281a0a051ccb15','Asia/Dhaka'),('5281a09e50a0bc7','Asia/Dacca'),('5281a0a359c69e6','Asia/Dushanbe'),('5281a0a45a5d9dd','Asia/Gaza'),('5281a0a768ccd66','Asia/Ho_Chi_Minh'),('5281a0a6683a809','Asia/Hebron'),('5281a0a55af5fb5','Asia/Harbin'),('5281a0a87491a25','Asia/Hong_Kong'),('5281a0ab763ee82','Asia/Istanbul'),('5281a0ac76d0bba','Asia/Jakarta'),('5281a0aa75b1122','Asia/Irkutsk'),('5281a0a975249f9','Asia/Hovd'),('5281a0af7888b2a','Asia/Kabul'),('5281a0ad7762040','Asia/Jayapura'),('5281a0ae77f9979','Asia/Jerusalem'),('5281a0b38121eec','Asia/Kathmandu'),('5281a0b17ff7b93','Asia/Karachi'),('5281a0b07f60fbd','Asia/Kamchatka'),('5281a0b2808875b','Asia/Kashgar'),('5281a0b582467de','Asia/Khandyga'),('5281a0ba9625309','Asia/Kuwait'),('5281a0b7836a737','Asia/Krasnoyarsk'),('5281a0b481b3f82','Asia/Katmandu'),('5281a0bfa3e3403','Asia/Manila'),('5281a0bda2c3f39','Asia/Magadan'),('5281a0bea353642','Asia/Makassar'),('5281a0b682d7c6b','Asia/Kolkata'),('5281a0b984900e1','Asia/Kuching'),('5281a0b883fc097','Asia/Kuala_Lumpur'),('5281a0bc9b6658f','Asia/Macau'),('5281a0c0a47b670','Asia/Muscat'),('5281a0c2a5a914a','Asia/Novokuznetsk'),('5281a0c5ac5370d','Asia/Oral'),('5281a0c9af084a7','Asia/Qatar'),('5281a0c3a63e893','Asia/Novosibirsk'),('5281a0bb9995a61','Asia/Macao'),('5281a0c4a6cfff2','Asia/Omsk'),('5281a0c1a513266','Asia/Nicosia'),('5281a0c6ad3a016','Asia/Phnom_Penh'),('5281a0c8ae6fc1d','Asia/Pyongyang'),('5281a0caaf9a3f7','Asia/Qyzylorda'),('5281a0ceb1e6900','Asia/Sakhalin'),('5281a0cbb029a0f','Asia/Rangoon'),('5281a0ccb0b8ed7','Asia/Riyadh'),('5281a0cfb27e770','Asia/Samarkand'),('5281a0c7add4a83','Asia/Pontianak'),('5281a0d5b6195f2','Asia/Tbilisi'),('5281a0cdb14f26f','Asia/Saigon'),('5281a0d1b3a71fe','Asia/Shanghai'),('5281a0d9c3af580','Asia/Thimphu'),('5281a0d3b4ce508','Asia/Taipei'),('5281a0d2b43caed','Asia/Singapore'),('5281a0d6b6a9048','Asia/Tehran'),('5281a0d0b310ab9','Asia/Seoul'),('5281a0d7b738dfa','Asia/Tel_Aviv'),('5281a0d4b5675f0','Asia/Tashkent'),('5281a0dcc5452d8','Asia/Ulaanbaatar'),('5281a0d8b7ca13e','Asia/Thimbu'),('5281a0e1c97ee98','Asia/Vladivostok'),('5281a0dac410be3','Asia/Tokyo'),('5281a0ddc5cffcb','Asia/Ulan_Bator'),('5281a0dbc498d19','Asia/Ujung_Pandang'),('5281a0e5cbd2ab3','Atlantic/Azores'),('5281a0dfc802643','Asia/Ust-Nera'),('5281a0e3ca96355','Asia/Yekaterinburg'),('5281a0dec72d2c8','Asia/Urumqi'),('5281a0e2c9f8bff','Asia/Yakutsk'),('5281a0e0c8a8864','Asia/Vientiane'),('5281a0e6cc39d74','Atlantic/Bermuda'),('5281a0e4cb41fb8','Asia/Yerevan'),('5281a0eed19481b','Atlantic/South_Georgia'),('5281a0e7cd08d1f','Atlantic/Canary'),('5281a0eacf865b6','Atlantic/Faroe'),('5281a0e8cdf71cd','Atlantic/Cape_Verde'),('5281a0ecd083a61','Atlantic/Madeira'),('5281a0f0d28596b','Atlantic/Stanley'),('5281a0e9cee78d7','Atlantic/Faeroe'),('5281a0edd11319e','Atlantic/Reykjavik'),('5281a0efd1f32fb','Atlantic/St_Helena'),('5281a0ebd023d83','Atlantic/Jan_Mayen'),('5281a0f5d6511b5','Australia/Canberra'),('5281a0f4d5ad53b','Australia/Broken_Hill'),('5281a0f2d414c2c','Australia/Adelaide'),('5281a0f3d50b948','Australia/Brisbane'),('5281a0f1d34022d','Australia/ACT'),('5281a0f6d6f2fcb','Australia/Currie'),('5281a0f8d837181','Australia/Eucla'),('5281a0f9d8d96a3','Australia/Hobart'),('5281a0fddb58517','Australia/Melbourne'),('5281a0fad975081','Australia/LHI'),('5281a0fcdab0d34','Australia/Lord_Howe'),('5281a0fbda115d9','Australia/Lindeman'),('5281a0f7d793413','Australia/Darwin'),('5281a101ddd8257','Australia/Queensland'),('5281a0ffdc99118','Australia/NSW'),('5281a0fedbfa7e6','Australia/North'),('5281a102de7b7a9','Australia/South'),('5281a100dd385a2','Australia/Perth'),('5281a104dfc5885','Australia/Tasmania'),('5281a103df20a58','Australia/Sydney'),('5281a105e06a9b6','Australia/Victoria'),('5281a107e1b7664','Australia/Yancowinna'),('5281a108e25bc93','Brazil/Acre'),('5281a10de622257','Canada/Central'),('5281a109e3d5d6e','Brazil/DeNoronha'),('5281a10ce57f01e','Canada/Atlantic'),('5281a106e10f94a','Australia/West'),('5281a10be4de708','Brazil/West'),('5281a10ae43d03b','Brazil/East'),('5281a10ee6bf449','Canada/East-Saskatchewan'),('5281a114f0b9085','Canada/Yukon'),('5281a117f296fd5','Chile/EasterIsland'),('5281a10fe75f2c4','Canada/Eastern'),('5281a111e8ab026','Canada/Newfoundland'),('5281a110e80412c','Canada/Mountain'),('5281a116f1f4f2e','Chile/Continental'),('5281a118f33df3d','CST6CDT'),('5281a113e9f0daa','Canada/Saskatchewan'),('5281a112e94ed84','Canada/Pacific'),('5281a11e027c729','EST'),('5281a11c00fa005','Egypt'),('5281a115f1557e0','CET'),('5281a11d01970ad','Eire'),('5281a11f031f564','EST5EDT'),('5281a121045accb','Etc/GMT+0'),('5281a119f3e04e9','Cuba'),('5281a1d6c8ec435','Universal'),('5281a11b005e55d','EET'),('5281a1d3c69078e','Singapore'),('5281a1d7c9af2ed','US/Alaska'),('5281a1dbccf3617','US/East-Indiana'),('5281a1d8cabf7f1','US/Aleutian'),('5281a1dacc37651','US/Central'),('5281a1d9cb7bad5','US/Arizona'),('5281a1dcce1ad1c','US/Eastern'),('5281a1d5c82280a','UCT'),('5281a1ddcee9e3c','US/Hawaii'),('5281a1dfd0d95b2','US/Michigan'),('5281a1e0d1a0e86','US/Mountain'),('5281a1decfb3884','US/Indiana-Starke'),('5281a1e1d267cf9','US/Pacific'),('5281a1e2d332a62','US/Pacific-New'),('5281a1e3d3f844f','US/Samoa'),('5281a1c6b0be317','Pacific/Tahiti'),('5281a1c8b88aa9e','Pacific/Tongatapu'),('5281a1c7b7d1d5a','Pacific/Tarawa'),('5281a1675297098','Europe/Prague'),('5281a1e4d4c2232','UTC'),('5281a16953c1632','Europe/Rome'),('5281a16a546eb1c','Europe/Samara'),('5281a16f58a0561','Europe/Sofia'),('5281a16e578c5ca','Europe/Skopje'),('5281a16d567a909','Europe/Simferopol'),('5281a16c55c3e49','Europe/Sarajevo'),('5281a16b55183d6','Europe/San_Marino'),('5281a1735c520ab','Europe/Tiraspol'),('5281a17059b7e00','Europe/Stockholm'),('5281a1715ada39c','Europe/Tallinn'),('5281a1775f33528','Europe/Vienna'),('5281a1725b981dd','Europe/Tirane'),('5281a1755dc75a3','Europe/Vaduz'),('5281a1745d0c5ff','Europe/Uzhgorod'),('5281a1785fee51e','Europe/Vilnius'),('5281a1765e7ec77','Europe/Vatican'),('5281a17960a75a5','Europe/Volgograd'),('5281a17a61653f3','Europe/Warsaw'),('5281a17c62d8149','Europe/Zaporozhye'),('5281a17b621c391','Europe/Zagreb'),('5281a17d6394bdc','Europe/Zurich'),('5281a17e64b04e6','Factory'),('5281a17f6566ce7','GB'),('5281a183690a029','GMT-0'),('5281a1856a822c1','Greenwich'),('5281a1d2c5cc7f0','ROK'),('5281a1866b3a73f','Hongkong'),('5281a18267f39f3','GMT+0'),('5281a180667b0ff','GB-Eire'),('5281a1886cbc018','Iceland'),('5281a1876bf5f3f','HST'),('5281a1896d7af41','Indian/Antananarivo'),('5281a18167364aa','GMT'),('5281a18a6e38d94','Indian/Chagos'),('5281a18e727f96b','Indian/Kerguelen'),('5281a18b6ef1055','Indian/Christmas'),('5281a1917e7a840','Indian/Mauritius'),('5281a18c6fa914a','Indian/Cocos'),('5281a18d716cac2','Indian/Comoro'),('5281a18469c9b45','GMT0'),('5281a1907dbe28e','Indian/Maldives'),('5281a1927f358dc','Indian/Mayotte'),('5281a1937ffce01','Indian/Reunion'),('5281a1bda973ea9','Pacific/Pago_Pago'),('5281a1beaa37ad1','Pacific/Palau'),('5281a1bfaaf8959','Pacific/Pitcairn'),('5281a19480b8eb3','Iran'),('5281a1958174e03','Israel'),('5281a1968236672','Jamaica'),('5281a18f7335833','Indian/Mahe'),('5281a1c0abb94a6','Pacific/Pohnpei'),('5281a1c2adaeefc','Pacific/Port_Moresby'),('5281a1978349c3b','Japan'),('5281a1c1ac7d9a4','Pacific/Ponape'),('5281a1e7d719d77','Zulu'),('5281a1c3ae74c55','Pacific/Rarotonga'),('5281a1c4af3715e','Pacific/Saipan'),('5281a1d1c5090a1','ROC'),('5281a1e5d5896c1','W-SU'),('5281a1e6d64f54c','WET'),('52819fcc5eebbe0','Africa/Mogadishu'),('52819fca5e1862c','Africa/Maseru'),('52819fcd5f56d2d','Africa/Monrovia'),('52819fc85b5ca8c','Africa/Malabo'),('52819fc95bd505d','Africa/Maputo'),('52819fc559d1824','Africa/Luanda'),('52819fc2584bf74','Africa/Lagos     '),('52819fc75ae5c44','Africa/Lusaka'),('52819fc358f7f66','Africa/Libreville'),('52819fc156a0bb9','Africa/Kinshasa'),('52819fc65a72a20','Africa/Lubumbashi'),('52819fbf550c406','Africa/Khartoum'),('52819fc055a94f7','Africa/Kigali'),('52819fbe54a483a','Africa/Kampala'),('52819fb9527a466','Africa/Freetown'),('52819fbd543bb3d','Africa/Juba'),('52819fba52e8bfe','Africa/Gaborone'),('52819fc45965c0d','Africa/Lome'),('52819fbc53cc7cb','Africa/Johannesburg'),('52819fb4505727a','Africa/Dakar'),('52819fb7519de97','Africa/Douala'),('52819fb6512b354','Africa/Djibouti'),('52819fbb535a8db','Africa/Harare'),('52819fb34feb2b9','Africa/Conakry'),('52819fb550bf3bd','Africa/Dar_es_Salaam'),('52819fb04ea2165','Africa/Cairo'),('52819fb8520ef05','Africa/El_Aaiun'),('52819fb14f0c347','Africa/Casablanca'),('52819fad4d6d2ab','Africa/Blantyre'),('52819fb24f7a1a9','Africa/Ceuta'),('52819fae4dd596d','Africa/Brazzaville'),('52819faf4e3ea69','Africa/Bujumbura'),('52819fab4c9ff3f','Africa/Banjul'),('52819fa94bc9a93','Africa/Bamako'),('52819fac4d0b2f3','Africa/Bissau'),('52819fa84b5bed6','Africa/Asmera'),('52819faa4c334ed','Africa/Bangui'),('52819fa54a1c5c4','Africa/Addis_Ababa'),('52819fa44106fdd','Africa/Accra'),('5281a14328d7e27','Europe/Amsterdam'),('52819fa74aef179','Africa/Asmara'),('52819fa64a81c45','Africa/Algiers'),('52819fa3409d46f','Africa/Abidjan'),('5281a144293e781','Europe/Andorra'),('5281a1462a2183d','Europe/Belfast'),('5281a14529a6597','Europe/Athens'),('5281a1472b27ab5','Europe/Belgrade'),('5281a14d2ef47a3','Europe/Busingen'),('5281a1482b95f9d','Europe/Berlin'),('5281a14b2de356d','Europe/Bucharest'),('5281a14c2e8003e','Europe/Budapest'),('5281a14a2d40451','Europe/Brussels'),('5281a1492c3f8d0','Europe/Bratislava'),('5281a15030f2b55','Europe/Dublin'),('5281a1513ce8a90','Europe/Gibraltar'),('5281a14e2f9d4cf','Europe/Chisinau'),('5281a14f3048453','Europe/Copenhagen'),('5281a1543ee5f5a','Europe/Isle_of_Man'),('5281a1533e3ecc9','Europe/Helsinki'),('5281a1523d9455c','Europe/Guernsey'),('5281a1553fb3f61','Europe/Istanbul'),('5281a158421be40','Europe/Kiev'),('5281a15b443824d','Europe/London'),('5281a1574109a27','Europe/Kaliningrad'),('5281a15640623f7','Europe/Jersey'),('5281a15a4387b4d','Europe/Ljubljana'),('5281a15942d2df1','Europe/Lisbon'),('5281a15f4756ead','Europe/Mariehamn'),('5281a16148b02d8','Europe/Monaco'),('5281a15d459a699','Europe/Madrid'),('5281a15c44ee825','Europe/Luxembourg'),('5281a15e46aa01e','Europe/Malta'),('5281a162495ae00','Europe/Moscow'),('5281a1634a06938','Europe/Nicosia'),('5281a16048033d3','Europe/Minsk'),('5281a1664c0a464','Europe/Podgorica'),('5281a1654b607a0','Europe/Paris'),('5281a168534cbef','Europe/Riga'),('5281a1644ab2537','Europe/Oslo'),('5281a12003bd2d8','Etc/GMT'),('5281a12406b3d0a','Etc/GMT+11'),('5281a125075e837','Etc/GMT+12'),('5281a1220508372','Etc/GMT+1'),('5281a12305b7170','Etc/GMT+10'),('5281a1290a6ffbc','Etc/GMT+5'),('5281a12a0b21a7c','Etc/GMT+6'),('5281a12e0dd3691','Etc/GMT-0'),('5281a126080e0f2','Etc/GMT+2'),('5281a12c0c747f2','Etc/GMT+8'),('5281a12708c2a64','Etc/GMT+3'),('5281a12b0bcc422','Etc/GMT+7'),('5281a128097255f','Etc/GMT+4'),('5281a131165c9a8','Etc/GMT-11'),('5281a12f14f8806','Etc/GMT-1'),('5281a12d0d21e28','Etc/GMT+9'),('5281a13015ad04a','Etc/GMT-10'),('5281a1341865467','Etc/GMT-14'),('5281a1391bd512c','Etc/GMT-6'),('5281a132170a862','Etc/GMT-12'),('5281a13317ba384','Etc/GMT-13'),('5281a13619c9d77','Etc/GMT-3'),('5281a13b1dde432','Etc/GMT-8'),('5281a13c1e901f3','Etc/GMT-9'),('5281a1351915ab2','Etc/GMT-2'),('5281a1381b291ad','Etc/GMT-5'),('5281a13d1f4118d','Etc/GMT0'),('5281a1371a7a768','Etc/GMT-4'),('5281a13e1fecf31','Etc/Greenwich'),('5281a13a1cdc706','Etc/GMT-7'),('5281a14021ecc1a','Etc/Universal'),('5281a1422870f52','Etc/Zulu'),('5281a13f20ea1f3','Etc/UCT'),('5281a19884666fe','Kwajalein'),('5281a19b869ac55','Mexico/BajaNorte'),('5281a19985161dc','Libya'),('5281a141276c8dd','Etc/UTC'),('5281a19a85d936f','MET'),('5281a19c8755b50','Mexico/BajaSur'),('5281a19d8805651','Mexico/General'),('5281a1a08b568c9','Navajo'),('5281a1a48edbfe0','Pacific/Auckland'),('5281a19e88c6791','MST'),('5281a1a28cc076a','NZ-CHAT'),('5281a1a38db68d2','Pacific/Apia'),('5281a19f8a9df7c','MST7MDT'),('5281a1a58f97f6b','Pacific/Chatham'),('5281a1a992be08a','Pacific/Enderbury'),('5281a1a690adea0','Pacific/Chuuk'),('5281a1aa9376832','Pacific/Fakaofo'),('5281a1a89202f8f','Pacific/Efate'),('5281a1ab969470b','Pacific/Fiji'),('5281a1a18c10637','NZ'),('5281a1ac9755655','Pacific/Funafuti'),('5281a1af9991f3e','Pacific/Guadalcanal'),('5281a1ad9816446','Pacific/Galapagos'),('5281a1a7914900c','Pacific/Easter'),('5281a1b09a4fddd','Pacific/Guam'),('5281a1b29faa3dd','Pacific/Johnston'),('5281a1ae98d3fae','Pacific/Gambier'),('5281a1b19b0cfd2','Pacific/Honolulu'),('5281a1b4a18cdc0','Pacific/Kosrae'),('5281a1b3a0d3019','Pacific/Kiritimati'),('5281a1b5a2a9fe4','Pacific/Kwajalein'),('5281a1b7a41e352','Pacific/Marquesas'),('5281a1b6a366199','Pacific/Majuro'),('5281a1b8a543c50','Pacific/Midway'),('5281a1bca8aff1f','Pacific/Noumea'),('5281a1baa7229e2','Pacific/Niue'),('5281a1c9b9b4eb9','Pacific/Truk'),('5281a1cec2b8c7b','Portugal'),('5281a1ccc0a2ed7','Pacific/Yap'),('5281a1cbbb03788','Pacific/Wallis'),('5281a1bba7e9f84','Pacific/Norfolk'),('5281a1b9a65d08d','Pacific/Nauru'),('5281a1cfc380ffd','PRC'),('5281a1caba3a73f','Pacific/Wake'),('5281a1cdc1ce40f','Poland'),('5281a1d4c757c4b','Turkey'),('5281a1d0c44a02a','PST8PDT'),('5281a1c5aff8b7a','Pacific/Samoa');
/*!40000 ALTER TABLE `zzzsys_timezone` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `zzzsys_translate`
--

DROP TABLE IF EXISTS `zzzsys_translate`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `zzzsys_translate` (
  `zzzsys_translate_id` varchar(25) NOT NULL DEFAULT '',
  `trl_language` varchar(20) NOT NULL,
  `trl_english` varchar(300) NOT NULL,
  `trl_translation` varchar(300) NOT NULL,
  `zzzsys_translate_log_added_at` datetime NOT NULL,
  `zzzsys_translate_log_added_by` varchar(25) NOT NULL,
  `zzzsys_translate_log_changed_at` datetime NOT NULL,
  `zzzsys_translate_log_changed_by` varchar(25) NOT NULL,
  `zzzsys_translate_log_viewed_at` datetime NOT NULL,
  `zzzsys_translate_log_viewed_by` varchar(25) NOT NULL,
  PRIMARY KEY (`zzzsys_translate_id`),
  KEY `trl_language` (`trl_language`),
  KEY `trl_english` (`trl_english`(255))
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `zzzsys_translate`
--

LOCK TABLES `zzzsys_translate` WRITE;
/*!40000 ALTER TABLE `zzzsys_translate` DISABLE KEYS */;
INSERT INTO `zzzsys_translate` VALUES ('536f20cd04b27','fr','Filetype','Type de fichier','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('536f20cd04b0a','fr','Report ID','ID Rapport','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('536f20cd04ba7','fr','Message','Message','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('536f20cd04b67','fr','Attached Report','Rapport attachÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Â ÃƒÂ¢Ã¢â€šÂ¬Ã¢â€žÂ¢ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â©','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('536f20cd04be7','fr','Subject','Sujet','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('536f20cd04aca','fr','Send Read Receipt','Envoyer accusÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Â ÃƒÂ¢Ã¢â€šÂ¬Ã¢â€žÂ¢ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â© rÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Â ÃƒÂ¢Ã¢â€šÂ¬Ã¢â€žÂ¢ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â©ception','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('536f20cd04a89','fr','Please Wait...','Veuillez patienter...','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('536f20cd04a49','fr','The Email Is Sending','Le courriel est en cours d\'envoi','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('536f20cd04a09','fr','Email Successfully Sent','Courriel envoyÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Â ÃƒÂ¢Ã¢â€šÂ¬Ã¢â€žÂ¢ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â© avec succÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Â ÃƒÂ¢Ã¢â€šÂ¬Ã¢â€žÂ¢ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â¨s','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('536f20cd049c9','fr','Send Email','Envoyer courriel','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('536f20cd04989','fr','Error!','ErreurÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã‚Â¢ÃƒÂ¢Ã¢â‚¬Å¡Ã‚Â¬Ãƒâ€¦Ã‚Â¡ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â !','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('536f20cd04948','fr','Cancel','Annuler','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('536f20cd04908','fr','You are here..','Vous ÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Â ÃƒÂ¢Ã¢â€šÂ¬Ã¢â€žÂ¢ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Âªtes ici..','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('536f20cd04846','fr','Logout','DÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Â ÃƒÂ¢Ã¢â€šÂ¬Ã¢â€žÂ¢ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â©connexion','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('536f20cd04742','fr','Print','Imprimer','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('536f20cd04806','fr','Clone','Dupliquer','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('536f20cd04887','fr','Page','Page','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('536f20cd048c8','fr','Search','Chercher','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('536f20cd046c0','fr','Close','Fermer','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('536f20cd04783','fr','Save','Sauver','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('536f20cd047c4','fr','Add Record','Ajouter enregistrement','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('536f20cd0471f','fr','Are You Sure?','ÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Â ÃƒÂ¢Ã¢â€šÂ¬Ã¢â€žÂ¢ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã‚Â¦ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â tes-vous sÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Â ÃƒÂ¢Ã¢â€šÂ¬Ã¢â€žÂ¢ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â»rÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã‚Â¢ÃƒÂ¢Ã¢â‚¬Å¡Ã‚Â¬Ãƒâ€¦Ã‚Â¡ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â ?','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('52241927d04f1f0','Spanish','New Record','Nuevo Registro','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150299ff3507ed','it','No Such Report','Report inesistente...','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('2c38dec47','ro','Close','Inchide','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('5224182a7c09135','spanish','Home','INICIO','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('522413ca87a3d62','spanish','Powered By','DiseÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Â ÃƒÂ¢Ã¢â€šÂ¬Ã¢â€žÂ¢ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â±ado Por','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242bz8c0112','it','No','No','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('15029972f2bac7','it','You do not have access','Non sei autorizzato ad accedere...','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150299f3d1c36f','it','Report has Expired','Il report ÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Â ÃƒÂ¢Ã¢â€šÂ¬Ã¢â€žÂ¢ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â¨ scaduto...','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242bz8c0101','it','Ok','Ok','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242bz8c0107','it','Please input valid email address(es) to send to','Inserire un indirizzo email destinatario valido','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242bz8c010d','it','Please input a valid email address to send from','Inserire un valido indirizzo email mittente','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242bz8c010a','it','Please input an email address to send from','Inserire indirizzo email mittente','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242bz8c011d','it','Delete','Elimina','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242bz8c010f','it','Please input a filename','Inserire il nome di un file','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('15029941c9cc41','it','you have been logged out','Sei stato disconnesso...','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242bz8c0104','it','Please input an email address to send to','Inserire indirizzo email destinatario','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242bz8c00fb','it','Please see your<BR>System Administrator','Contatta il tuo amministratore di sistema','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242bz8c00f9','it','Yes','Si','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242bz8c00ff','it','SMTP Email Information Not Setup','Informazioni Email SMTP non configurate','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242bz8c00f6','it','HOME','HOME','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242bz8c00f3','it','To','A','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242bz8c00eb','it','From','Da','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242bz8c00dd','it','Filetype','Filetype','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242bz8c00d5','it','Please Wait...','Attendere prego...','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242bz8c00da','it','Report ID','Report ID','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242bz8c00d8','it','Send Read Receipt','Inviare confema di lettura','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242bz8c00e6','it','Subject','Soggetto','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242bz8c00e0','it','Attached Report','Report allegato','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242bz8c00e3','it','Message','Messaggio','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242bz8c00e8','it','ReplyTo','Rispondi','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242bz8c00c7','it','Cancel','Cancella','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242bz8c00c9','it','Error!','Errore!','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242bz8c00cf','it','Email Successfully Sent','Email inviata correttamente','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242bz8c00ab','it','Save','Salva','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242bz8c00b0','it','Add Record','Nuovo','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242bz8c00b3','it','Clone','Duplica','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242bz8c00bc','it','Logout','Esci','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242bz8c00bf','it','Page','Pagina','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242bz8c00c4','it','You are here','Ti trovi qui','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242bz8c00c1','it','Search','Cerca','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242bz8c00d2','it','The Email Is Sending','Invio Email in corso...','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242bz8c00cc','it','Send Email','Invia Email','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be8c00f9','lang','Yes','Yes','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be8c0107','lang','Please input valid email address(es) to send to','Please input valid email address(es) to send to','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be8c010f','lang','Please input a filename','Please input a filename','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be8c010d','lang','Please input a valid email address to send from','Please input a valid email address to send from','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242bz8c00a1','it','Close','Chiudi','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be8c010a','lang','Please input an email address to send from','Please input an email address to send from','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be8c011d','lang','Delete','Delete','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be8c0112','lang','No','No','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242bz8c00a5','it','Are You Sure?','Confermi?','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242bz8c00a8','it','Print','Stampa','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be8c00e8','lang','ReplyTo','Reply To','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be8c0104','lang','Please input an email address to send to','Please input an email address to send to','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be8c00dd','lang','Filetype','Filetype','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be8c00eb','lang','From','From','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be8c00f6','lang','HOME','HOME','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be8c00e3','lang','Message','Message','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be8c00e6','lang','Subject','Subject','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be8c00ff','lang','SMTP Email Information Not Setup','SMTP Email Information Not Setup','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be8c00f3','lang','To','To','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be8c0101','lang','Ok','Ok','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be8c00fb','lang','Please see your<BR>System Administrator','Please see your System Administrator','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be8c00d8','lang','Send Read Receipt','Send Read Receipt','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be8c00d2','lang','The Email Is Sending','The Email Is Sending','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be8c00d5','lang','Please Wait...','Please Wait','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be8c00da','lang','Report ID','Report ID','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be8c00e0','lang','Attached Report','Attached Report','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be8c00bc','lang','Logout','Logout','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be8c00bf','lang','Page','Page','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be8c00b0','lang','Add Record','Add Record','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be8c00b3','lang','Clone','Clone','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be8c00cc','lang','Send Email','Send Email','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be8c00c4','lang','You are here','You are here','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be8c00c1','lang','Search','Search','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be8c00c9','lang','Error!','Error','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be8c00c7','lang','Cancel','Cancel','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be8c00cf','lang','Email Successfully Sent','Email Successfully Sent','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be8c00a5','lang','Are You Sure?','Are You Sure?','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be8c00a1','lang','Close','Close','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be8c00ab','lang','Save','Save','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be8c00a8','lang','Print','Print','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('grgrg111111112','gr','Password :','Κωδικός :','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be543112','gr','No','Όχι','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be54311d','gr','Delete','Διαγραφή','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('522418171c52f33','gr','Home','Αρχική','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('grgrg111111111','gr','Username :','Όνομα Χρήστη :','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be54310f','gr','Please input a filename','Παρακαλώ εισάγετε ένα όνομα αρχείου','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be54310a','gr','Please input an email address to send from','Παρακαλώ εισάγετε μια διεύθυνση email για τον αποστολέα','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be54310d','gr','Please input a valid email address to send from','Παρακαλώ εισάγετε μια έγκυρη διεύθυνση email για τον αποστολέα','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be543104','gr','Please input an email address to send to','Παρακαλώ εισάγετε μια διεύθυνση email για τον παραλήπτη','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be543107','gr','Please input valid email address(es) to send to','Παρακαλώ εισάγετε μία ή περισσότερες έγκυρες διευθύνσεις email για τους παραλήπτες','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be543101','gr','Ok','Εντάξει','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be5430ff','gr','SMTP Email Information Not Setup','Τα στοιχεία για το SMTP της διεύθυνσης email δεν έχουν εισαχθεί','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be5430e6','gr','Subject','Θέμα','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be5430e0','gr','Attached Report','Συνημμένη αναφορά','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be5430f9','gr','Yes','Ναι','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be5430f6','gr','HOME','ΑΡΧΙΚΗ','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be5430fb','gr','Please see your System Administrator','Παρακαλώ επικοινωνήστε με το Διαχειριστή Συστήματος','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be5430e3','gr','Message','Μήνυμα','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be5430e8','gr','ReplyTo','Απάντηση Προς','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be5430eb','gr','From','Από','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be5430da','gr','Report ID','ID αναφοράς','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be5430f3','gr','To','Προς','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be5430d8','gr','Send Read Receipt','Αποστολή απόδειξης ανάγνωσης','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be5430dd','gr','Filetype','Τύπος αρχείου','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be5430cf','gr','Email Successfully Sent','Το email στάλθηκε με επιτυχία','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be5430d5','gr','Please Wait...','Παρακαλώ περιμένετε...','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be5430d2','gr','The Email Is Sending','Το email αποστέλλεται','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be5430c9','gr','Error!','Σφάλμα!','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be5430cc','gr','Send Email','Αποστολή email','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be5430c4','gr','You are here','Είστε εδώ','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be5430c7','gr','Cancel','Ακύρωση','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be5430c1','gr','Search','Αναζήτηση','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be5430b3','gr','Clone','Κλωνοποίηση','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be5430bf','gr','Page','Σελίδα','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be5430bc','gr','Logout','Αποσύνδεση','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be5430b0','gr','Add Record','Νέα εγγραφή','0000-00-00 00:00:00','','0000-00-00 00:00:00','','2013-09-24 09:22:01','globeadmin'),('150242be5430ab','gr','Save','Αποθήκευση','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be5430a8','gr','Print','Εκτύπωση','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be5430a5','gr','Are You Sure?','Σίγουρα;','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150242be5430a1','gr','Close','Κλείσιμο','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('15011945e3651f','spanish','Please input valid email address(es) to send to','Introduce la(s) direccione(s) valida(s) de destino(s) del correo','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('1501190c753e67','spanish','You are here','Estas aquÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Â ÃƒÂ¢Ã¢â€šÂ¬Ã¢â€žÂ¢ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â­','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('15011909ecdf87','spanish','Yes','Si','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('15011905990ef7','spanish','Subject','Asunto','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('15011908081ad3','spanish','The Email Is Sending','El correo se esta enviando','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('15011909339328','spanish','To','a','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('15011940ccee87','spanish','Please input an email address to send to','Introduce la direcciÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Â ÃƒÂ¢Ã¢â€šÂ¬Ã¢â€žÂ¢ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â³n de destino del correo','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150118fef130ce','spanish','Send Read Receipt','Enviar Acuse Lectura','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150118fcf4874c','spanish','Send Email','Enviar Email','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('15011904931916','spanish','SMTP Email Information Not Setup','No esta configurado el SMTP del correo','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150118fb84874c','spanish','Search','Buscar','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150118fa253e67','spanish','Save','Guardar','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150118f60ec7cf','spanish','Print','Imprimir','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150118f4f29f04','spanish','Please Wait...','Por favor espere ...','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150118f77f41e1','spanish','ReplyTo','Respoder a ','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150118f8f66f94','spanish','Report ID','ID del Informe','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150118ed66ac9c','spanish','Please input an email address to send from','Introduce la direcciÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Â ÃƒÂ¢Ã¢â€šÂ¬Ã¢â€žÂ¢ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â³n de origen del correo','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150118e43a7d2c','spanish','Please input a filename','Introduce el nombrel del Fichero','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150118f37ca27e','spanish','Please see your<BR>System Administrator','Ponte en contacto <BR>con el Administrador del Sistema','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150118e90894e5','spanish','Please input a valid email address to send from','Introduce una direcciÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Â ÃƒÂ¢Ã¢â€šÂ¬Ã¢â€žÂ¢ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â³n valida de origen del correo','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150118e1d16dd7','spanish','Page','PÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Â ÃƒÂ¢Ã¢â€šÂ¬Ã¢â€žÂ¢ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â¡gina','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150118e0cec7cf','spanish','Ok','OK','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150118de11e7ea','spanish','Message','Mensaje','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150118de898909','spanish','No','No','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150118d8ed96a2','spanish','Filetype','Tipo de fichero','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150118dcdc286c','spanish','Logout','Cerrar SesiÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Â ÃƒÂ¢Ã¢â€šÂ¬Ã¢â€žÂ¢ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â³n','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150118cfb29f04','spanish','Delete','Borrar','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150118d71e8ac6','spanish','Error!','ÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã‚Â¢ÃƒÂ¢Ã¢â‚¬Å¡Ã‚Â¬Ãƒâ€¦Ã‚Â¡ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â¡ Error !','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150118d9f9c612','spanish','From','Desde','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150118db640d3a','spanish','HOME','INICIO','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150118caf98909','spanish','Attached Report','Informe Adjunto','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150118d56aba36','spanish','Email Successfully Sent','Correo enviado correctamente','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150118ce7a4024','spanish','Close','Cerrar','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150118c97726af','spanish','Cancel','Cancelar','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150118cd14c455','spanish','Clone','Duplicar','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150118c4b6e9a5','spanish','Are You Sure?','ÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã‚Â¢ÃƒÂ¢Ã¢â‚¬Å¡Ã‚Â¬Ãƒâ€¦Ã‚Â¡ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â¿ Esta Seguro ?','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('536f20cd04ea8','fr','Please input an email address to send from','Indiquez une adresse d\'envoi','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('536f20cd04ee8','fr','Please input a valid email address to send from','Indiquez une adresse d\'envoi valide','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('150118c271e7e9','spanish','Add Record','AÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Â ÃƒÂ¢Ã¢â€šÂ¬Ã¢â€žÂ¢ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â±adir Registro','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('536f20cd04f14','fr','Please input a filename','Indiquez un nom de fichier','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('536f20cd04c27','fr','ReplyTo','RÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Â ÃƒÂ¢Ã¢â€šÂ¬Ã¢â€žÂ¢ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â©pondre ÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Â ÃƒÂ¢Ã¢â€šÂ¬Ã¢â€žÂ¢ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â ','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('536f20cd04ce7','fr','Home','Racine','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('536f20cd04d27','fr','Yes','Oui','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('536f20cd04c67','fr','From','De','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('536f20cd04ca7','fr','To','ÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Â ÃƒÂ¢Ã¢â€šÂ¬Ã¢â€žÂ¢ÃƒÆ’Ã†â€™Ãƒâ€šÃ‚Â¢ÃƒÆ’Ã‚Â¢ÃƒÂ¢Ã¢â‚¬Å¡Ã‚Â¬Ãƒâ€¦Ã‚Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â¬','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('536f20cd04d67','fr','Please see your<BR>System Administrator','Veuillez contacter votre <BR>Administrateur SystÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Â ÃƒÂ¢Ã¢â€šÂ¬Ã¢â€žÂ¢ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â¨me','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('536f20cd04f56','fr','No','Non','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('536f20cd04f97','fr','Delete','Effacer','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('536f20cd04fd7','fr','you have been logged out','Vous ÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Â ÃƒÂ¢Ã¢â€šÂ¬Ã¢â€žÂ¢ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Âªtes dÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Â ÃƒÂ¢Ã¢â€šÂ¬Ã¢â€žÂ¢ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â©connectÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Â ÃƒÂ¢Ã¢â€šÂ¬Ã¢â€žÂ¢ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('536f20cd05017','fr','You do not have access','Vous n\'avez pas accÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Â ÃƒÂ¢Ã¢â€šÂ¬Ã¢â€žÂ¢ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â¨s','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('536f20cd05097','fr','No Such Report','Rapport inexistant','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('536f20cd050d7','fr','Powered By','PropulsÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Â ÃƒÂ¢Ã¢â€šÂ¬Ã¢â€žÂ¢ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â© par','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('536f20cd05057','fr','Report has Expired','Le rapport a expirÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Â ÃƒÂ¢Ã¢â€šÂ¬Ã¢â€žÂ¢ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â©','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('536f20cd05158','fr','Record Saved','Enregistrement SauvÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Â ÃƒÂ¢Ã¢â€šÂ¬Ã¢â€žÂ¢ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â©','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('536f20cd05118','fr','Language','Langue','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('536f20cd05198','fr','nuBuilder Objects','Objets nuBuilder','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('536f20cd051e6','fr','Desktop','Bureau','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('536f20cd0525b','fr','Translation','Traduction','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('536f20cd052a1','fr','New Record','Nouvel Enregistrement','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('536f20cd05363','fr','TAB','Onglet','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('536f20cd052e6','fr','cannot be left blank','ne doit pas ÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Â ÃƒÂ¢Ã¢â€šÂ¬Ã¢â€žÂ¢ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Âªtre vide','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('536f20cd053ed','fr','in subform','dans le sous-formulaire','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('536f20cd053aa','fr','has an invalid date','a une date invalide','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('536f20cd0542f','fr','on row','ÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Â ÃƒÂ¢Ã¢â€šÂ¬Ã¢â€žÂ¢ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â  la ligne','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('536f20cd05472','fr','There is already a record with a','Il y a dÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Â ÃƒÂ¢Ã¢â€šÂ¬Ã¢â€žÂ¢ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â©jÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Â ÃƒÂ¢Ã¢â€šÂ¬Ã¢â€žÂ¢ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â  un enregistrement avec un(e)','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('536f20cd054b4','fr','with a value of','qui a une valeur de','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('536f20cd054f7','fr','has an invalid number','a un nombre invalide','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('536f20cd055be','fr','Your username or password was incorrect','Utilisateur ou mot de passe incorrect','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('536f20cd0557c','fr','Password :','Mot de passe :','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('536f20cd05539','fr','Username :','Utilisateur :','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('536f20cd05601','fr','Leave This Form Without Saving?','Quitter ce formulaire sans sauver ?','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('536f20cd05644','fr','Doing this will return you to the login screen.','Faire cela vous ramÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Â ÃƒÂ¢Ã¢â€šÂ¬Ã¢â€žÂ¢ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â¨nera ÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Â ÃƒÂ¢Ã¢â€šÂ¬Ã¢â€žÂ¢ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â  l\'ÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Â ÃƒÂ¢Ã¢â€šÂ¬Ã¢â€žÂ¢ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡ÃƒÆ’Ã¢â‚','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('hhhhheaf52807c','NDL','Are You Sure?','Ben je zeker','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('hhhhheae52fdf9','NDL','Close','Sluiten','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('hhhhheb8aef6f7','NDL','Add Record','Item toevoegen','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('hhhhheb02c5ca7','NDL','Delete','Verwijder','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('hhhhheb55896f8','NDL','Print','Print','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('hhhhheb79d9c9d','NDL','Save','Bewaar','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('hhhhheb9d2ed63','NDL','Clone','Kopieer','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('hhhhhebafa8a1c','NDL','Logout','Uitloggen','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('hhhhhebbb43186','NDL','Page','Pagina','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('hhhhhebf3e645a','NDL','Cancel','Annuleer','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('hhhhhebd7f4111','NDL','You are here','Jij bent hier','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('hhhhhebc92237d','NDL','Search','Zoeken','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('536f20cd04de8','fr','Ok','Ok','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('536f20cd04da7','fr','SMTP Email Information Not Setup','Serveur SMTP non configurÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Â ÃƒÂ¢Ã¢â€šÂ¬Ã¢â€žÂ¢ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â©','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('536f20cd04e28','fr','Please input an email address to send to','Indiquez une adresse de destination','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('536f20cd04e68','fr','Please input valid email address(es) to send to','Indiquez une(des) adresse(s) valide(s) de destination','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('hhhhhec03dcf60','NDL','Error!','Fout!','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('hhhhhec12169bf','NDL','Send Email','E-mail verzenden','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('hhhhhec2256b7e','NDL','Email Successfully Sent','E-mail succesvol verzonden','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('hhhhhec2e61b38','NDL','The Email Is Sending','E-mail aan het verzenden','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('hhhhhec3a828b6','NDL','Please Wait...','Wachten aub ÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â¢ÃƒÆ’Ã†â€™Ãƒâ€šÃ‚Â¢ÃƒÆ’Ã‚Â¢ÃƒÂ¢Ã¢â‚¬Å¡Ã‚Â¬Ãƒâ€¦Ã‚Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â¬ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â¦ ','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('hhhhhec4a2c82a','NDL','Send Read Receipt','Leesbevestiging verzenden','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('hhhhhec55ae5bb','NDL','Report ID','Rapport ID','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('hhhhhec616a61f','NDL','Filetype','Bestandstype','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('hhhhhec71c67ac','NDL','Attached Report','Ingesloten rapport','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('hhhhhec7f13c9e','NDL','Message','Bericht','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('hhhhhec8c0701c','NDL','Subject','Onderwerp','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('hhhhhec9be7a6c','NDL','From','Van','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('hhhhhecb1737ee','NDL','No','Nee','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('hhhhhecbb9a6cd','NDL','To','Aan','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('hhhhhecd0110c4','NDL','HOME','HOME','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('hhhhhecdb17312','NDL','Yes','Ja','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('hhhhhecea976b8','NDL','Please see your<BR>System Administrator','Contacteer uw systeembeheerder','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('hhhhhecf8e3585','NDL','SMTP Email Information Not Setup','De SMTP e-mail instellingen zijn niet ingegeven.','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('hhhhhed04058e2','NDL','Ok','OK','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('hhhhhed12a97b8','NDL','Please input an email address to send to','Gelieve een mailadres van de geadresseerde in te vullen.','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('hhhhhed23d7e33','NDL','Please input valid email address(es) to send to','Gelieve een geldig mailadres van de geadresseerde in te vullen.','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('hhhhhed34e639b','NDL','Please input an email address to send from','Gelieve een mailadres van de afzender in te vullen.','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('hhhhhed45a72b7','NDL','Please input a valid email address to send from','Gelieve een geldig mailadres van de afzender in te vullen.','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('hhhhhed5403ce0','NDL','Please input a filename','Gelieve een bestandsnaam in te geven.','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('hhhhhee30c1425','NDL','ReplyTo','Antwoorden aan','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('roror2c61c4e30','ro','Are You Sure?','Esti sigur?','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('roror2c9c823c7','ro','Print','Afisare','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('roror2cb8aac3e','ro','Save','Salvare','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('roror2cd09a688','ro','Delete','Sterge','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('roror2cea74133','ro','Add Record','Adauga','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('roror2d03da20c','ro','Clone','Cloneaza','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('roror2d1b0868f','ro','Logout','Iesire','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('roror2d30b5819','ro','Page','Pagina','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('roror2d4e56895','ro','Search','Cautare','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('roror2d680f006','ro','You are here','Esti aici','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('roror2d847607a','ro','Cancel','Anulare','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('roror2e691902f','ro','Error!','Eroare!','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('roror2ece56c7a','ro','Send Email','Trimite Email','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('roror2f09abfc2','ro','Email Successfully Sent','Email-ul a fost trimis cu succes!','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('roror2f2084ade','ro','Please Wait...','Va rugam asteptati.....','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('roror2f5d77bd1','ro','Send Read Receipt','Trimite confirmare de citire','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('roror353c1a7a3','ro','Report ID','Raport ID','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('roror3559d8a9b','ro','Filetype','Tip de fisier','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('roror35789835d','ro','Attached Report','Ataseaza raport','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('roror359b9e11d','ro','Message','Mesaj','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('roror35b264f0c','ro','Subject','Subiect','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('roror35c733ddf','ro','ReplyTo','Raspunde la','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('roror35db51a6e','ro','From','De la','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('roror35efca806','ro','No','Nu','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('roror36062dc37','ro','To','Catre','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('roror363d96034','ro','HOME','Home','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('roror369065eae','ro','Yes','Da','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('roror3755d82cd','ro','Please see your<BR>System Administrator','Contacteaza<BR>Administratorul de Sistem','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('roror377e6b885','ro','SMTP Email Information Not Setup','SMTP Informatii Email (fara setare)','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('roror3810d5bbd','ro','Ok','Acceptare','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('roror3832ac3ac','ro','Please input an email address to send to','Va rugam introduceti o adresa de email pentru a trimite catre','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('roror385e9f0b9','ro','Please input valid email address(es) to send to','Introduceti adresa /adresele valide de email pentru a trimite catre','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('roror387abd904','ro','Please input an email address to send from','Va rugam introduceti o adresa de email pentru a trimite de la','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('roror389590a47','ro','Please input a valid email address to send from','Va rugam sa introduceti o adresa valida de email pentru a trimite de la','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('roror38afacb7d','ro','Please input a filename','Va rugam sa introduceti un nume de fisier','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('roror38c7db97d','ro','Language','Limba','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('roror38dce0f69','ro','Translation','Traducere','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('roror38f3eb377','ro','Access Level','Nivel de Acces','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('roror390b27a91','ro','Users','Utilizatori','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('roror3922c0fb3','ro','Report','Raport','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00',''),('5a7574cb0e5342c','gr','Your username or password was incorrect','Τα στοιχεία σας είναι λανθασμένα ή έχετε υπερβεί το μέγιστο επιτρεπόμενο αριθμό προσπαθειών','0000-00-00 00:00:00','','0000-00-00 00:00:00','','0000-00-00 00:00:00','');
/*!40000 ALTER TABLE `zzzsys_translate` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `zzzsys_user`
--

DROP TABLE IF EXISTS `zzzsys_user`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `zzzsys_user` (
  `zzzsys_user_id` varchar(25) NOT NULL DEFAULT '',
  `sus_zzzsys_user_group_id` varchar(25) DEFAULT NULL,
  `sus_name` varchar(50) DEFAULT NULL,
  `sus_email` varchar(255) DEFAULT NULL,
  `sus_login_name` varchar(100) DEFAULT NULL,
  `sus_login_password` varchar(40) DEFAULT NULL,
  `zzzsys_user_log_added_at` datetime NOT NULL,
  `zzzsys_user_log_added_by` varchar(25) NOT NULL,
  `zzzsys_user_log_changed_at` datetime NOT NULL,
  `zzzsys_user_log_changed_by` varchar(25) NOT NULL,
  `zzzsys_user_log_viewed_at` datetime NOT NULL,
  `zzzsys_user_log_viewed_by` varchar(25) NOT NULL,
  `login_with_email_account` tinyint(1) DEFAULT '0',
  PRIMARY KEY (`zzzsys_user_id`),
  KEY `sus_zzzsys_user_group_id` (`sus_zzzsys_user_group_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `zzzsys_user`
--

LOCK TABLES `zzzsys_user` WRITE;
/*!40000 ALTER TABLE `zzzsys_user` DISABLE KEYS */;
INSERT INTO `zzzsys_user` VALUES ('54737fc85981449','547de466910d843','ΔΙΕΥΘΥΝΤΗΣ',NULL,'manager','9f31fbecda9829775b5fb03cb3afc4b8','2014-11-24 20:58:16','globeadmin','2017-05-11 11:11:51','globeadmin','2020-08-25 20:16:10','54737fc85981449',0);
/*!40000 ALTER TABLE `zzzsys_user` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `zzzsys_user_group`
--

DROP TABLE IF EXISTS `zzzsys_user_group`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `zzzsys_user_group` (
  `zzzsys_user_group_id` varchar(25) NOT NULL DEFAULT '',
  `sug_code` varchar(50) DEFAULT NULL,
  `sug_description` varchar(255) DEFAULT NULL,
  `sug_zzzsys_access_level_id` varchar(25) DEFAULT NULL,
  `zzzsys_user_group_log_added_at` datetime NOT NULL,
  `zzzsys_user_group_log_added_by` varchar(25) NOT NULL,
  `zzzsys_user_group_log_changed_at` datetime NOT NULL,
  `zzzsys_user_group_log_changed_by` varchar(25) NOT NULL,
  `zzzsys_user_group_log_viewed_at` datetime NOT NULL,
  `zzzsys_user_group_log_viewed_by` varchar(25) NOT NULL,
  PRIMARY KEY (`zzzsys_user_group_id`),
  KEY `sug_zzzsys_access_level_id` (`sug_zzzsys_access_level_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `zzzsys_user_group`
--

LOCK TABLES `zzzsys_user_group` WRITE;
/*!40000 ALTER TABLE `zzzsys_user_group` DISABLE KEYS */;
INSERT INTO `zzzsys_user_group` VALUES ('547de466910d843','Managers','Διευθυντές','5501dbedc785fe4','2014-12-02 18:10:14','globeadmin','2015-03-12 20:34:48','globeadmin','2021-03-09 13:21:50','globeadmin'),('547de49454047c6','AssistManagers','Υποδιευθυντές','547de3bee410196','2014-12-02 18:11:00','globeadmin','2014-12-02 18:11:00','globeadmin','2022-01-31 16:19:08','globeadmin'),('547de4b10fa7616','Teachers','Καθηγητές','547de3e001028e8','2014-12-02 18:11:29','globeadmin','2014-12-02 18:11:29','globeadmin','2021-03-09 13:38:48','globeadmin'),('547de4c65675a29','Students','Μαθητές','547de3fe0d36089','2014-12-02 18:11:50','globeadmin','2014-12-02 18:11:50','globeadmin','2016-12-15 19:54:46','globeadmin'),('5601b00712ca90c','Administrators','Διαχειριστές του Σίσυφου','5601afbc23dfb00','2015-09-22 22:46:15','globeadmin','2015-09-22 22:46:54','globeadmin','2016-05-29 13:31:36','globeadmin'),('568946b83ec3baa','Secretaries','Γραμματείς','5689468794353da','2016-01-03 18:05:12','globeadmin','2016-02-04 21:28:20','globeadmin','2016-07-19 21:45:21','globeadmin'),('5717ba3eb32c252','Parents','Γονείς','5717b9c74a31169','2016-04-20 20:19:58','globeadmin','2016-04-20 20:19:58','globeadmin','2016-04-25 22:23:34','globeadmin'),('60475b01603a277','Psychologists','Ψυχολόγοι','60475aa35186b93','2021-03-09 13:24:49','globeadmin','2021-03-09 13:25:59','globeadmin','2021-03-09 14:48:53','globeadmin');
/*!40000 ALTER TABLE `zzzsys_user_group` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `zzzsys_user_log`
--

DROP TABLE IF EXISTS `zzzsys_user_log`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `zzzsys_user_log` (
  `zzzsys_user_log_id` varchar(25) NOT NULL DEFAULT '',
  `sul_zzzsys_user_id` varchar(25) DEFAULT NULL,
  `sul_ip` varchar(25) DEFAULT NULL,
  `sul_start` datetime DEFAULT NULL,
  `sul_end` datetime DEFAULT NULL,
  `zzzsys_user_log_log_added_at` datetime NOT NULL,
  `zzzsys_user_log_log_added_by` varchar(25) NOT NULL,
  `zzzsys_user_log_log_changed_at` datetime NOT NULL,
  `zzzsys_user_log_log_changed_by` varchar(25) NOT NULL,
  `zzzsys_user_log_log_viewed_at` datetime NOT NULL,
  `zzzsys_user_log_log_viewed_by` varchar(25) NOT NULL,
  PRIMARY KEY (`zzzsys_user_log_id`),
  KEY `sul_zzzsys_user_id` (`sul_zzzsys_user_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `zzzsys_user_log`
--

LOCK TABLES `zzzsys_user_log` WRITE;
/*!40000 ALTER TABLE `zzzsys_user_log` DISABLE KEYS */;
/*!40000 ALTER TABLE `zzzsys_user_log` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `zzzsys_user_login_failure`
--

DROP TABLE IF EXISTS `zzzsys_user_login_failure`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `zzzsys_user_login_failure` (
  `zzzsys_user_login_failure_id` varchar(25) NOT NULL DEFAULT '',
  `sul_ip` varchar(25) DEFAULT NULL,
  `sul_datetime` datetime DEFAULT NULL,
  `sul_username` varchar(50) DEFAULT NULL,
  PRIMARY KEY (`zzzsys_user_login_failure_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `zzzsys_user_login_failure`
--

LOCK TABLES `zzzsys_user_login_failure` WRITE;
/*!40000 ALTER TABLE `zzzsys_user_login_failure` DISABLE KEYS */;
/*!40000 ALTER TABLE `zzzsys_user_login_failure` ENABLE KEYS */;
UNLOCK TABLES;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2023-09-30 14:41:14
